/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/map","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ae=function(W){for(var t=[],n=0,F=W.length;n<F;n++)t[n]=se[W[n]];return t};const je=this,$e=typeof global=="object"?global:{};var de;(function(W){W.global=je;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof W.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}W.Environment=t})(de||(de={}));var de;(function(W){class t{constructor(f,E,h){this.type=f,this.detail=E,this.timestamp=h}}W.LoaderEvent=t;class n{constructor(f){this._events=[new t(1,"",f)]}record(f,E){this._events.push(new t(f,E,W.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}W.LoaderEventRecorder=n;class F{record(f,E){}getEvents(){return[]}}F.INSTANCE=new F,W.NullLoaderEventRecorder=F})(de||(de={}));var de;(function(W){class t{static fileUriToFilePath(F,D){if(D=decodeURI(D).replace(/%23/g,"#"),F){if(/^file:\/\/\//.test(D))return D.substr(8);if(/^file:\/\//.test(D))return D.substr(5)}else if(/^file:\/\//.test(D))return D.substr(7);return D}static startsWith(F,D){return F.length>=D.length&&F.substr(0,D.length)===D}static endsWith(F,D){return F.length>=D.length&&F.substr(F.length-D.length)===D}static containsQueryString(F){return/^[^\#]*\?/gi.test(F)}static isAbsolutePath(F){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(F)}static forEachProperty(F,D){if(F){let f;for(f in F)F.hasOwnProperty(f)&&D(f,F[f])}}static isEmpty(F){let D=!0;return t.forEachProperty(F,()=>{D=!1}),D}static recursiveClone(F){if(!F||typeof F!="object"||F instanceof RegExp||!Array.isArray(F)&&Object.getPrototypeOf(F)!==Object.prototype)return F;let D=Array.isArray(F)?[]:{};return t.forEachProperty(F,(f,E)=>{E&&typeof E=="object"?D[f]=t.recursiveClone(E):D[f]=E}),D}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(F){return t.startsWith(F,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=W.global.performance&&typeof W.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?W.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,W.Utilities=t})(de||(de={}));var de;(function(W){function t(D){if(D instanceof Error)return D;const f=new Error(D.message||String(D)||"Unknown Error");return D.stack&&(f.stack=D.stack),f}W.ensureError=t;class n{static validateConfigurationOptions(f){function E(h){if(h.phase==="loading"){console.error('Loading "'+h.moduleId+'" failed'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}if(h.phase==="factory"){console.error('The factory function of "'+h.moduleId+'" has thrown an exception'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}}if(f=f||{},typeof f.baseUrl!="string"&&(f.baseUrl=""),typeof f.isBuild!="boolean"&&(f.isBuild=!1),typeof f.paths!="object"&&(f.paths={}),typeof f.config!="object"&&(f.config={}),typeof f.catchError>"u"&&(f.catchError=!1),typeof f.recordStats>"u"&&(f.recordStats=!1),typeof f.urlArgs!="string"&&(f.urlArgs=""),typeof f.onError!="function"&&(f.onError=E),Array.isArray(f.ignoreDuplicateModules)||(f.ignoreDuplicateModules=[]),f.baseUrl.length>0&&(W.Utilities.endsWith(f.baseUrl,"/")||(f.baseUrl+="/")),typeof f.cspNonce!="string"&&(f.cspNonce=""),typeof f.preferScriptTags>"u"&&(f.preferScriptTags=!1),f.nodeCachedData&&typeof f.nodeCachedData=="object"&&(typeof f.nodeCachedData.seed!="string"&&(f.nodeCachedData.seed="seed"),(typeof f.nodeCachedData.writeDelay!="number"||f.nodeCachedData.writeDelay<0)&&(f.nodeCachedData.writeDelay=1e3*7),!f.nodeCachedData.path||typeof f.nodeCachedData.path!="string")){const h=t(new Error("INVALID cached data configuration, 'path' MUST be set"));h.phase="configuration",f.onError(h),f.nodeCachedData=void 0}return f}static mergeConfigurationOptions(f=null,E=null){let h=W.Utilities.recursiveClone(E||{});return W.Utilities.forEachProperty(f,(l,s)=>{l==="ignoreDuplicateModules"&&typeof h.ignoreDuplicateModules<"u"?h.ignoreDuplicateModules=h.ignoreDuplicateModules.concat(s):l==="paths"&&typeof h.paths<"u"?W.Utilities.forEachProperty(s,(c,N)=>h.paths[c]=N):l==="config"&&typeof h.config<"u"?W.Utilities.forEachProperty(s,(c,N)=>h.config[c]=N):h[l]=W.Utilities.recursiveClone(s)}),n.validateConfigurationOptions(h)}}W.ConfigurationOptionsUtil=n;class F{constructor(f,E){if(this._env=f,this.options=n.mergeConfigurationOptions(E),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let h=this.options.nodeRequire.main.filename,l=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let f=0;f<this.options.ignoreDuplicateModules.length;f++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[f]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],W.Utilities.forEachProperty(this.options.paths,(f,E)=>{Array.isArray(E)?this.sortedPathsRules.push({from:f,to:E}):this.sortedPathsRules.push({from:f,to:[E]})}),this.sortedPathsRules.sort((f,E)=>E.from.length-f.from.length)}cloneAndMerge(f){return new F(this._env,n.mergeConfigurationOptions(f,this.options))}getOptionsLiteral(){return this.options}_applyPaths(f){let E;for(let h=0,l=this.sortedPathsRules.length;h<l;h++)if(E=this.sortedPathsRules[h],W.Utilities.startsWith(f,E.from)){let s=[];for(let c=0,N=E.to.length;c<N;c++)s.push(E.to[c]+f.substr(E.from.length));return s}return[f]}_addUrlArgsToUrl(f){return W.Utilities.containsQueryString(f)?f+"&"+this.options.urlArgs:f+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(f){return this.options.urlArgs?this._addUrlArgsToUrl(f):f}_addUrlArgsIfNecessaryToUrls(f){if(this.options.urlArgs)for(let E=0,h=f.length;E<h;E++)f[E]=this._addUrlArgsToUrl(f[E]);return f}moduleIdToPaths(f){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(f))return this.isBuild()?["empty:"]:["node|"+f];let E=f,h;if(!W.Utilities.endsWith(E,".js")&&!W.Utilities.isAbsolutePath(E)){h=this._applyPaths(E);for(let l=0,s=h.length;l<s;l++)this.isBuild()&&h[l]==="empty:"||(W.Utilities.isAbsolutePath(h[l])||(h[l]=this.options.baseUrl+h[l]),!W.Utilities.endsWith(h[l],".js")&&!W.Utilities.containsQueryString(h[l])&&(h[l]=h[l]+".js"))}else!W.Utilities.endsWith(E,".js")&&!W.Utilities.containsQueryString(E)&&(E=E+".js"),h=[E];return this._addUrlArgsIfNecessaryToUrls(h)}requireToUrl(f){let E=f;return W.Utilities.isAbsolutePath(E)||(E=this._applyPaths(E)[0],W.Utilities.isAbsolutePath(E)||(E=this.options.baseUrl+E)),this._addUrlArgsIfNecessaryToUrl(E)}isBuild(){return this.options.isBuild}shouldInvokeFactory(f){return!!(!this.options.isBuild||W.Utilities.isAnonymousModule(f)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[f])}isDuplicateMessageIgnoredFor(f){return this.ignoreDuplicateModulesMap.hasOwnProperty(f)}getConfigForModule(f){if(this.options.config)return this.options.config[f]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(f){this.options.onError(f)}}W.Configuration=F})(de||(de={}));var de;(function(W){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,c,N,g){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new D;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new n:this._scriptLoader=new f(this._env)}else this._env.isNode?this._scriptLoader=new f(this._env):this._scriptLoader=new n;let m={callback:N,errorback:g};if(this._callbackMap.hasOwnProperty(c)){this._callbackMap[c].push(m);return}this._callbackMap[c]=[m],this._scriptLoader.load(s,c,()=>this.triggerCallback(c),e=>this.triggerErrorback(c,e))}triggerCallback(s){let c=this._callbackMap[s];delete this._callbackMap[s];for(let N=0;N<c.length;N++)c[N].callback()}triggerErrorback(s,c){let N=this._callbackMap[s];delete this._callbackMap[s];for(let g=0;g<N.length;g++)N[g].errorback(c)}}class n{attachListeners(s,c,N){let g=()=>{s.removeEventListener("load",m),s.removeEventListener("error",e)},m=w=>{g(),c()},e=w=>{g(),N(w)};s.addEventListener("load",m),s.addEventListener("error",e)}load(s,c,N,g){if(/^node\|/.test(c)){let m=s.getConfig().getOptionsLiteral(),e=E(s.getRecorder(),m.nodeRequire||W.global.nodeRequire),w=c.split("|"),A=null;try{A=e(w[1])}catch(_){g(_);return}s.enqueueDefineAnonymousModule([],()=>A),N()}else{let m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript"),this.attachListeners(m,N,g);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(c=e.createScriptURL(c)),m.setAttribute("src",c);const{cspNonce:w}=s.getConfig().getOptionsLiteral();w&&m.setAttribute("nonce",w),document.getElementsByTagName("head")[0].appendChild(m)}}}function F(l){const{trustedTypesPolicy:s}=l.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class D{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=F(s)),this._cachedCanUseEval}load(s,c,N,g){if(/^node\|/.test(c)){const m=s.getConfig().getOptionsLiteral(),e=E(s.getRecorder(),m.nodeRequire||W.global.nodeRequire),w=c.split("|");let A=null;try{A=e(w[1])}catch(_){g(_);return}s.enqueueDefineAnonymousModule([],function(){return A}),N()}else{const{trustedTypesPolicy:m}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(c).then(w=>{if(w.status!==200)throw new Error(w.statusText);return w.text()}).then(w=>{w=`${w}
//# sourceURL=${c}`,(m?self.eval(m.createScript("",w)):new Function(w)).call(self),N()}).then(void 0,g);return}try{m&&(c=m.createScriptURL(c)),importScripts(c),N()}catch(w){g(w)}}}}class f{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,c){const{nodeCachedData:N}=c.getConfig().getOptionsLiteral();if(!N||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const g=this,m=s("module");function e(w){const A=w.constructor;let _=function(p){try{return w.require(p)}finally{}};return _.resolve=function(p,o){return A._resolveFilename(p,w,!1,o)},_.resolve.paths=function(p){return A._resolveLookupPaths(p,w)},_.main=process.mainModule,_.extensions=A._extensions,_.cache=A._cache,_}m.prototype._compile=function(w,A){const _=m.wrap(w.replace(/^#!.*/,"")),L=c.getRecorder(),p=g._getCachedDataPath(N,A),o={filename:A};let a;try{const R=g._fs.readFileSync(p);a=R.slice(0,16),o.cachedData=R.slice(16),L.record(60,p)}catch{L.record(61,p)}const i=new g._vm.Script(_,o),u=i.runInThisContext(o),b=g._path.dirname(A),d=e(this),v=[this.exports,d,this,A,b,process,$e,Buffer],M=u.apply(this.exports,v);return g._handleCachedData(i,_,p,!o.cachedData,c),g._verifyCachedData(i,_,p,a,c),M}}load(s,c,N,g){const m=s.getConfig().getOptionsLiteral(),e=E(s.getRecorder(),m.nodeRequire||W.global.nodeRequire),w=m.nodeInstrumenter||function(_){return _};this._init(e),this._initNodeRequire(e,s);let A=s.getRecorder();if(/^node\|/.test(c)){let _=c.split("|"),L=null;try{L=e(_[1])}catch(p){g(p);return}s.enqueueDefineAnonymousModule([],()=>L),N()}else{c=W.Utilities.fileUriToFilePath(this._env.isWindows,c);const _=this._path.normalize(c),L=this._getElectronRendererScriptPathOrUri(_),p=!!m.nodeCachedData,o=p?this._getCachedDataPath(m.nodeCachedData,c):void 0;this._readSourceAndCachedData(_,o,A,(a,i,u,b)=>{if(a){g(a);return}let d;i.charCodeAt(0)===f._BOM?d=f._PREFIX+i.substring(1)+f._SUFFIX:d=f._PREFIX+i+f._SUFFIX,d=w(d,_);const v={filename:L,cachedData:u},M=this._createAndEvalScript(s,d,v,N,g);this._handleCachedData(M,d,o,p&&!u,s),this._verifyCachedData(M,d,o,b,s)})}}_createAndEvalScript(s,c,N,g,m){const e=s.getRecorder();e.record(31,N.filename);const w=new this._vm.Script(c,N),A=w.runInThisContext(N),_=s.getGlobalAMDDefineFunc();let L=!1;const p=function(){return L=!0,_.apply(null,arguments)};return p.amd=_.amd,A.call(W.global,s.getGlobalAMDRequireFunc(),p,N.filename,this._path.dirname(N.filename)),e.record(32,N.filename),L?g():m(new Error(`Didn't receive define call in ${N.filename}!`)),w}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let c=s.match(/^([a-z])\:(.*)/i);return c?`file:///${(c[1].toUpperCase()+":"+c[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,c){const N=this._crypto.createHash("md5").update(c,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),g=this._path.basename(c).replace(/\.js$/,"");return this._path.join(s.path,`${g}-${N}.code`)}_handleCachedData(s,c,N,g,m){s.cachedDataRejected?this._fs.unlink(N,e=>{m.getRecorder().record(62,N),this._createAndWriteCachedData(s,c,N,m),e&&m.getConfig().onError(e)}):g&&this._createAndWriteCachedData(s,c,N,m)}_createAndWriteCachedData(s,c,N,g){let m=Math.ceil(g.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,w=0,A;const _=()=>{setTimeout(()=>{A||(A=this._crypto.createHash("md5").update(c,"utf8").digest());const L=s.createCachedData();if(!(L.length===0||L.length===e||w>=5)){if(L.length<e){_();return}e=L.length,this._fs.writeFile(N,Buffer.concat([A,L]),p=>{p&&g.getConfig().onError(p),g.getRecorder().record(63,N),_()})}},m*Math.pow(4,w++))};_()}_readSourceAndCachedData(s,c,N,g){if(!c)this._fs.readFile(s,{encoding:"utf8"},g);else{let m,e,w,A=2;const _=L=>{L?g(L):--A===0&&g(void 0,m,e,w)};this._fs.readFile(s,{encoding:"utf8"},(L,p)=>{m=p,_(L)}),this._fs.readFile(c,(L,p)=>{!L&&p&&p.length>0?(w=p.slice(0,16),e=p.slice(16),N.record(60,c)):N.record(61,c),_()})}}_verifyCachedData(s,c,N,g,m){g&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(c,"utf8").digest();g.equals(e)||(m.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${N}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(N,w=>{w&&m.getConfig().onError(w)}))},Math.ceil(5e3*(1+Math.random()))))}}f._BOM=65279,f._PREFIX="(function (require, define, __filename, __dirname) { ",f._SUFFIX=`
});`;function E(l,s){if(s.__$__isRecorded)return s;const c=function(g){l.record(33,g);try{return s(g)}finally{l.record(34,g)}};return c.__$__isRecorded=!0,c}W.ensureRecordedNodeRequire=E;function h(l){return new t(l)}W.createScriptLoader=h})(de||(de={}));var de;(function(W){class t{constructor(l){let s=l.lastIndexOf("/");s!==-1?this.fromModulePath=l.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(l){let s=l,c;for(c=/\/\.\//;c.test(s);)s=s.replace(c,"/");for(s=s.replace(/^\.\//g,""),c=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;c.test(s);)s=s.replace(c,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(l){let s=l;return W.Utilities.isAbsolutePath(s)||(W.Utilities.startsWith(s,"./")||W.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),W.ModuleIdResolver=t;class n{constructor(l,s,c,N,g,m){this.id=l,this.strId=s,this.dependencies=c,this._callback=N,this._errorback=g,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,s){try{return{returnedValue:l.apply(W.global,s),producedError:null}}catch(c){return{returnedValue:null,producedError:c}}}static _invokeFactory(l,s,c,N){return l.shouldInvokeFactory(s)?l.shouldCatchError()?this._safeInvokeFunction(c,N):{returnedValue:c.apply(W.global,N),producedError:null}:{returnedValue:null,producedError:null}}complete(l,s,c,N){this._isComplete=!0;let g=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let m=n._invokeFactory(s,this.strId,this._callback,c);g=m.producedError,l.record(22,this.strId),!g&&typeof m.returnedValue<"u"&&(!this.exportsPassedIn||W.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(g){let m=W.ensureError(g);m.phase="factory",m.moduleId=this.strId,m.neededBy=N(this.id),this.error=m,s.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}W.Module=n;class F{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let s=this._strModuleIdToIntModuleId.get(l);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(l,s),this._intModuleIdToStrModuleId[s]=l),s}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class D{constructor(l){this.id=l}}D.EXPORTS=new D(0),D.MODULE=new D(1),D.REQUIRE=new D(2),W.RegularDependency=D;class f{constructor(l,s,c){this.id=l,this.pluginId=s,this.pluginParam=c}}W.PluginDependency=f;class E{constructor(l,s,c,N,g=0){this._env=l,this._scriptLoader=s,this._loaderAvailableTimestamp=g,this._defineFunc=c,this._requireFunc=N,this._moduleIdProvider=new F,this._config=new W.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new E(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,s){let c=m=>m.replace(/\\/g,"/"),N=c(l),g=s.split(/\n/);for(let m=0;m<g.length;m++){let e=g[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){let w=e[1],A=e[2],_=e[3],L=Math.max(w.lastIndexOf(" ")+1,w.lastIndexOf("(")+1);if(w=w.substr(L),w=c(w),w===N){let p={line:parseInt(A,10),col:parseInt(_,10)};return p.line===1&&(p.col-=53),p}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],s=0;for(let c=0,N=this._modules2.length;c<N;c++){let g=this._modules2[c];if(!g)continue;let m=this._buildInfoPath[g.id]||null,e=this._buildInfoDefineStack[g.id]||null,w=this._buildInfoDependencies[g.id];l[s++]={id:g.strId,path:m,defineLocation:m&&e?E._findRelevantLocationInStack(m,e):null,dependencies:w,shim:null,exports:g.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new W.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=W.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let c=null;this._config.isBuild()&&(c=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:c,dependencies:l,callback:s}}defineModule(l,s,c,N,g,m=new t(l)){let e=this._moduleIdProvider.getModuleId(l);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let w=new n(e,l,this._normalizeDependencies(s,m),c,N,m);this._modules2[e]=w,this._config.isBuild()&&(this._buildInfoDefineStack[e]=g,this._buildInfoDependencies[e]=(w.dependencies||[]).map(A=>this._moduleIdProvider.getStrModuleId(A.id))),this._resolve(w)}_normalizeDependency(l,s){if(l==="exports")return D.EXPORTS;if(l==="module")return D.MODULE;if(l==="require")return D.REQUIRE;let c=l.indexOf("!");if(c>=0){let N=s.resolveModule(l.substr(0,c)),g=s.resolveModule(l.substr(c+1)),m=this._moduleIdProvider.getModuleId(N+"!"+g),e=this._moduleIdProvider.getModuleId(N);return new f(m,e,g)}return new D(this._moduleIdProvider.getModuleId(s.resolveModule(l)))}_normalizeDependencies(l,s){let c=[],N=0;for(let g=0,m=l.length;g<m;g++)c[N++]=this._normalizeDependency(l[g],s);return c}_relativeRequire(l,s,c,N){if(typeof s=="string")return this.synchronousRequire(s,l);this.defineModule(W.Utilities.generateAnonymousModule(),s,c,N,null,l)}synchronousRequire(l,s=new t(l)){let c=this._normalizeDependency(l,s),N=this._modules2[c.id];if(!N)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!N.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(N.error)throw N.error;return N.exports}configure(l,s){let c=this._config.shouldRecordStats();s?this._config=new W.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!c&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),s.dependencies,s.callback,null,s.stack)}}_createLoadError(l,s){let c=this._moduleIdProvider.getStrModuleId(l),N=(this._inverseDependencies2[l]||[]).map(m=>this._moduleIdProvider.getStrModuleId(m));const g=W.ensureError(s);return g.phase="loading",g.moduleId=c,g.neededBy=N,g}_onLoadError(l,s){const c=this._createLoadError(l,s);this._modules2[l]||(this._modules2[l]=new n(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let N=[];for(let e=0,w=this._moduleIdProvider.getMaxModuleId();e<w;e++)N[e]=!1;let g=!1,m=[];for(m.push(l),N[l]=!0;m.length>0;){let e=m.shift(),w=this._modules2[e];w&&(g=w.onDependencyError(c)||g);let A=this._inverseDependencies2[e];if(A)for(let _=0,L=A.length;_<L;_++){let p=A[_];N[p]||(m.push(p),N[p]=!0)}}g||this._config.onError(c)}_hasDependencyPath(l,s){let c=this._modules2[l];if(!c)return!1;let N=[];for(let m=0,e=this._moduleIdProvider.getMaxModuleId();m<e;m++)N[m]=!1;let g=[];for(g.push(c),N[l]=!0;g.length>0;){let e=g.shift().dependencies;if(e)for(let w=0,A=e.length;w<A;w++){let _=e[w];if(_.id===s)return!0;let L=this._modules2[_.id];L&&!N[_.id]&&(N[_.id]=!0,g.push(L))}}return!1}_findCyclePath(l,s,c){if(l===s||c===50)return[l];let N=this._modules2[l];if(!N)return null;let g=N.dependencies;if(g)for(let m=0,e=g.length;m<e;m++){let w=this._findCyclePath(g[m].id,s,c+1);if(w!==null)return w.push(l),w}return null}_createRequire(l){let s=(c,N,g)=>this._relativeRequire(l,c,N,g);return s.toUrl=c=>this._config.requireToUrl(l.resolveModule(c)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(c,N=!1)=>{this.configure(c,N)},s.__$__nodeRequire=W.global.nodeRequire,s}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let s=this._moduleIdProvider.getStrModuleId(l),c=this._config.moduleIdToPaths(s),N=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||N.test(s))&&c.push("node|"+s);let g=-1,m=e=>{if(g++,g>=c.length)this._onLoadError(l,e);else{let w=c[g],A=this.getRecorder();if(this._config.isBuild()&&w==="empty:"){this._buildInfoPath[l]=w,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}A.record(10,w),this._scriptLoader.load(this,w,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=w),A.record(11,w),this._onLoad(l)},_=>{A.record(12,w),m(_)})}};m(null)}_loadPluginDependency(l,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let c=N=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],N,null,null)};c.error=N=>{this._config.onError(this._createLoadError(s.id,N))},l.load(s.pluginParam,this._createRequire(t.ROOT),c,this._config.getOptionsLiteral())}_resolve(l){let s=l.dependencies;if(s)for(let c=0,N=s.length;c<N;c++){let g=s[c];if(g===D.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(g===D.MODULE){l.unresolvedDependenciesCount--;continue}if(g===D.REQUIRE){l.unresolvedDependenciesCount--;continue}let m=this._modules2[g.id];if(m&&m.isComplete()){if(m.error){l.onDependencyError(m.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(g.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(g.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let e=this._findCyclePath(g.id,l.id,0)||[];e.reverse(),e.push(g.id),console.warn(e.map(w=>this._moduleIdProvider.getStrModuleId(w)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[g.id]=this._inverseDependencies2[g.id]||[],this._inverseDependencies2[g.id].push(l.id),g instanceof f){let e=this._modules2[g.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,g);continue}let w=this._inversePluginDependencies2.get(g.pluginId);w||(w=[],this._inversePluginDependencies2.set(g.pluginId,w)),w.push(g),this._loadModule(g.pluginId);continue}this._loadModule(g.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let s=this.getRecorder();if(l.isComplete())return;let c=l.dependencies,N=[];if(c)for(let w=0,A=c.length;w<A;w++){let _=c[w];if(_===D.EXPORTS){N[w]=l.exports;continue}if(_===D.MODULE){N[w]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(_===D.REQUIRE){N[w]=this._createRequire(l.moduleIdResolver);continue}let L=this._modules2[_.id];if(L){N[w]=L.exports;continue}N[w]=null}const g=w=>(this._inverseDependencies2[w]||[]).map(A=>this._moduleIdProvider.getStrModuleId(A));l.complete(s,this._config,N,g);let m=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,m)for(let w=0,A=m.length;w<A;w++){let _=m[w],L=this._modules2[_];L.unresolvedDependenciesCount--,L.unresolvedDependenciesCount===0&&this._onModuleComplete(L)}let e=this._inversePluginDependencies2.get(l.id);if(e){this._inversePluginDependencies2.delete(l.id);for(let w=0,A=e.length;w<A;w++)this._loadPluginDependency(l.exports,e[w])}}}W.ModuleManager=E})(de||(de={}));var ne,de;(function(W){const t=new W.Environment;let n=null;const F=function(h,l,s){typeof h!="string"&&(s=l,l=h,h=null),(typeof l!="object"||!Array.isArray(l))&&(s=l,l=null),l||(l=["require","exports","module"]),h?n.defineModule(h,l,s,null,null):n.enqueueDefineAnonymousModule(l,s)};F.amd={jQuery:!0};const D=function(h,l=!1){n.configure(h,l)},f=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){D(arguments[0]);return}if(typeof arguments[0]=="string")return n.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){n.defineModule(W.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};f.config=D,f.getConfig=function(){return n.getConfig().getOptionsLiteral()},f.reset=function(){n=n.reset()},f.getBuildInfo=function(){return n.getBuildInfo()},f.getStats=function(){return n.getLoaderEvents()},f.define=F;function E(){if(typeof W.global.require<"u"||typeof require<"u"){const h=W.global.require||require;if(typeof h=="function"&&typeof h.resolve=="function"){const l=W.ensureRecordedNodeRequire(n.getRecorder(),h);W.global.nodeRequire=l,f.nodeRequire=l,f.__$__nodeRequire=l}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=f:(t.isElectronRenderer||(W.global.define=F),W.global.require=f)}W.init=E,(typeof W.global.define!="function"||!W.global.define.amd)&&(n=new W.ModuleManager(t,W.createScriptLoader(t),F,f,W.Utilities.getHighPerformanceTimestamp()),typeof W.global.require<"u"&&typeof W.global.require!="function"&&f.config(W.global.require),ne=function(){return F.apply(null,arguments)},ne.amd=F.amd,typeof doNotInitLoader>"u"&&E())})(de||(de={})),ne(se[72],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=n;function n(h,l,s,c){if(c=c||{},(c["vs/css"]||{}).disabled){s({});return}const g=l.toUrl(h+".css");F(h,g,()=>{s({})},m=>{typeof s.error=="function"&&s.error("Could not find "+g+".")})}function F(h,l,s,c){if(D(h,l)){s();return}f(h,l,s,c)}function D(h,l){const s=window.document.getElementsByTagName("link");for(let c=0,N=s.length;c<N;c++){const g=s[c].getAttribute("data-name"),m=s[c].getAttribute("href");if(g===h||m===l)return!0}return!1}function f(h,l,s,c){const N=document.createElement("link");N.setAttribute("rel","stylesheet"),N.setAttribute("type","text/css"),N.setAttribute("data-name",h),E(h,N,s,c),N.setAttribute("href",l),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(N)}function E(h,l,s,c){const N=()=>{l.removeEventListener("load",g),l.removeEventListener("error",m)},g=e=>{N(),s()},m=e=>{N(),c(e)};l.addEventListener("load",g),l.addEventListener("error",m)}}),ne("vs/nls",["require","exports"],function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localize=c,t.localize2=N,t.getConfiguredDefaultLocale=g,t.setPseudoTranslation=m,t.create=e,t.load=w;let n=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const F="i-default";function D(A,_){let L;return _.length===0?L=A:L=A.replace(/\{(\d+)\}/g,(p,o)=>{const a=o[0],i=_[a];let u=p;return typeof i=="string"?u=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(u=String(i)),u}),n&&(L="\uFF3B"+L.replace(/[aouei]/g,"$&$&")+"\uFF3D"),L}function f(A,_){let L=A[_];return L||(L=A["*"],L)?L:null}function E(A){return A.charAt(A.length-1)==="/"?A:A+"/"}async function h(A,_,L){const p=E(A)+E(_)+"vscode/"+E(L),o=await fetch(p);if(o.ok)return await o.json();throw new Error(`${o.status} - ${o.statusText}`)}function l(A){return function(_,L){const p=Array.prototype.slice.call(arguments,2);return D(A[_],p)}}function s(A){return(_,L,...p)=>({value:D(A[_],p),original:D(L,p)})}function c(A,_,...L){return D(_,L)}function N(A,_,...L){const p=D(_,L);return{value:p,original:p}}function g(A){}function m(A){n=A}function e(A,_){return{localize:l(_[A]),localize2:s(_[A]),getConfiguredDefaultLocale:_.getConfiguredDefaultLocale??(L=>{})}}function w(A,_,L,p){const o=p["vs/nls"]??{};if(!A||A.length===0)return L({localize:c,localize2:N,getConfiguredDefaultLocale:()=>o.availableLanguages?.["*"]});const a=o.availableLanguages?f(o.availableLanguages,A):null,i=a===null||a===F;let u=".nls";i||(u=u+"."+a);const b=d=>{Array.isArray(d)?(d.localize=l(d),d.localize2=s(d)):(d.localize=l(d[A]),d.localize2=s(d[A])),d.getConfiguredDefaultLocale=()=>o.availableLanguages?.["*"],L(d)};typeof o.loadBundle=="function"?o.loadBundle(A,a,(d,v)=>{d?_([A+".nls"],b):b(v)}):o.translationServiceUrl&&!i?(async()=>{try{const d=await h(o.translationServiceUrl,a,A);return b(d)}catch(d){if(!a.includes("-"))return console.error(d),_([A+".nls"],b);try{const v=a.split("-")[0],M=await h(o.translationServiceUrl,v,A);return o.availableLanguages??={},o.availableLanguages["*"]=v,b(M)}catch(v){return console.error(v),_([A+".nls"],b)}}})():_([A+u],b,d=>{if(u===".nls"){console.error("Failed trying to load default language strings",d);return}console.error(`Failed to load message bundle for language ${a}. Falling back to the default language:`,d),_([A+".nls"],b)})}}),function(){const W=globalThis.MonacoEnvironment,t=W&&W.baseUrl?W.baseUrl:"../../../";function n(c,N){if(W?.createTrustedTypesPolicy)try{return W.createTrustedTypesPolicy(c,N)}catch(g){console.warn(g);return}try{return self.trustedTypes?.createPolicy(c,N)}catch(g){console.warn(g);return}}const F=n("amdLoader",{createScriptURL:c=>c,createScript:(c,...N)=>{const g=N.slice(0,-1).join(","),m=N.pop().toString();return`(function anonymous(${g}) { ${m}
})`}});function D(){try{return(F?globalThis.eval(F.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function f(){return new Promise((c,N)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return c();const g=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,globalThis.origin.length)!==globalThis.origin)&&D()){fetch(g).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${g}`,(F?globalThis.eval(F.createScript("",e)):new Function(e)).call(globalThis),c()}).then(void 0,N);return}F?importScripts(F.createScriptURL(g)):importScripts(g),c()})}function E(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:F,amdModulesPattern:/^vs\//})}function h(c){f().then(()=>{E(),require([c],function(N){setTimeout(function(){const g=N.create((m,e)=>{globalThis.postMessage(m,e)},null);for(globalThis.onmessage=m=>g.onmessage(m.data,m.ports);s.length>0;){const m=s.shift();g.onmessage(m.data,m.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&E();let l=!0;const s=[];globalThis.onmessage=c=>{if(!l){s.push(c);return}l=!1,h(c.data)}}(),ne(se[9],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MonotonousArray=void 0,t.findLast=n,t.findLastIdx=F,t.findLastMonotonous=D,t.findLastIdxMonotonous=f,t.findFirstMonotonous=E,t.findFirstIdxMonotonousOrArrLen=h,t.findFirstIdxMonotonous=l,t.findFirstMaxBy=c,t.findLastMaxBy=N,t.findFirstMinBy=g,t.findMaxIdxBy=m,t.mapFindFirst=e;function n(w,A,_){const L=F(w,A);if(L!==-1)return w[L]}function F(w,A,_=w.length-1){for(let L=_;L>=0;L--){const p=w[L];if(A(p))return L}return-1}function D(w,A){const _=f(w,A);return _===-1?void 0:w[_]}function f(w,A,_=0,L=w.length){let p=_,o=L;for(;p<o;){const a=Math.floor((p+o)/2);A(w[a])?p=a+1:o=a}return p-1}function E(w,A){const _=h(w,A);return _===w.length?void 0:w[_]}function h(w,A,_=0,L=w.length){let p=_,o=L;for(;p<o;){const a=Math.floor((p+o)/2);A(w[a])?o=a:p=a+1}return p}function l(w,A,_=0,L=w.length){const p=h(w,A,_,L);return p===w.length?-1:p}class s{static{this.assertInvariants=!1}constructor(A){this._array=A,this._findLastMonotonousLastIdx=0}findLastMonotonous(A){if(s.assertInvariants){if(this._prevFindLastPredicate){for(const L of this._array)if(this._prevFindLastPredicate(L)&&!A(L))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=A}const _=f(this._array,A,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=_+1,_===-1?void 0:this._array[_]}}t.MonotonousArray=s;function c(w,A){if(w.length===0)return;let _=w[0];for(let L=1;L<w.length;L++){const p=w[L];A(p,_)>0&&(_=p)}return _}function N(w,A){if(w.length===0)return;let _=w[0];for(let L=1;L<w.length;L++){const p=w[L];A(p,_)>=0&&(_=p)}return _}function g(w,A){return c(w,(_,L)=>-A(_,L))}function m(w,A){if(w.length===0)return-1;let _=0;for(let L=1;L<w.length;L++){const p=w[L];A(p,w[_])>0&&(_=L)}return _}function e(w,A){for(const _ of w){const L=A(_);if(L!==void 0)return L}}}),ne(se[35],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.groupBy=n,t.diffSets=F,t.diffMaps=D,t.intersection=f;function n(E,h){const l=Object.create(null);for(const s of E){const c=h(s);let N=l[c];N||(N=l[c]=[]),N.push(s)}return l}function F(E,h){const l=[],s=[];for(const c of E)h.has(c)||l.push(c);for(const c of h)E.has(c)||s.push(c);return{removed:l,added:s}}function D(E,h){const l=[],s=[];for(const[c,N]of E)h.has(c)||l.push(N);for(const[c,N]of h)E.has(c)||s.push(N);return{removed:l,added:s}}function f(E,h){const l=new Set;for(const s of h)E.has(s)&&l.add(s);return l}}),ne(se[36],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function n(h,l){const s=Math.pow(10,l);return Math.round(h*s)/s}class F{constructor(l,s,c,N=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,c))|0,this.a=n(Math.max(Math.min(1,N),0),3)}static equals(l,s){return l.r===s.r&&l.g===s.g&&l.b===s.b&&l.a===s.a}}t.RGBA=F;class D{constructor(l,s,c,N){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=n(Math.max(Math.min(1,s),0),3),this.l=n(Math.max(Math.min(1,c),0),3),this.a=n(Math.max(Math.min(1,N),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.l===s.l&&l.a===s.a}static fromRGBA(l){const s=l.r/255,c=l.g/255,N=l.b/255,g=l.a,m=Math.max(s,c,N),e=Math.min(s,c,N);let w=0,A=0;const _=(e+m)/2,L=m-e;if(L>0){switch(A=Math.min(_<=.5?L/(2*_):L/(2-2*_),1),m){case s:w=(c-N)/L+(c<N?6:0);break;case c:w=(N-s)/L+2;break;case N:w=(s-c)/L+4;break}w*=60,w=Math.round(w)}return new D(w,A,_,g)}static _hue2rgb(l,s,c){return c<0&&(c+=1),c>1&&(c-=1),c<1/6?l+(s-l)*6*c:c<1/2?s:c<2/3?l+(s-l)*(2/3-c)*6:l}static toRGBA(l){const s=l.h/360,{s:c,l:N,a:g}=l;let m,e,w;if(c===0)m=e=w=N;else{const A=N<.5?N*(1+c):N+c-N*c,_=2*N-A;m=D._hue2rgb(_,A,s+1/3),e=D._hue2rgb(_,A,s),w=D._hue2rgb(_,A,s-1/3)}return new F(Math.round(m*255),Math.round(e*255),Math.round(w*255),g)}}t.HSLA=D;class f{constructor(l,s,c,N){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=n(Math.max(Math.min(1,s),0),3),this.v=n(Math.max(Math.min(1,c),0),3),this.a=n(Math.max(Math.min(1,N),0),3)}static equals(l,s){return l.h===s.h&&l.s===s.s&&l.v===s.v&&l.a===s.a}static fromRGBA(l){const s=l.r/255,c=l.g/255,N=l.b/255,g=Math.max(s,c,N),m=Math.min(s,c,N),e=g-m,w=g===0?0:e/g;let A;return e===0?A=0:g===s?A=((c-N)/e%6+6)%6:g===c?A=(N-s)/e+2:A=(s-c)/e+4,new f(Math.round(A*60),w,g,l.a)}static toRGBA(l){const{h:s,s:c,v:N,a:g}=l,m=N*c,e=m*(1-Math.abs(s/60%2-1)),w=N-m;let[A,_,L]=[0,0,0];return s<60?(A=m,_=e):s<120?(A=e,_=m):s<180?(_=m,L=e):s<240?(_=e,L=m):s<300?(A=e,L=m):s<=360&&(A=m,L=e),A=Math.round((A+w)*255),_=Math.round((_+w)*255),L=Math.round((L+w)*255),new F(A,_,L,g)}}t.HSVA=f;class E{static fromHex(l){return E.Format.CSS.parseHex(l)||E.red}static equals(l,s){return!l&&!s?!0:!l||!s?!1:l.equals(s)}get hsla(){return this._hsla?this._hsla:D.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:f.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof F)this.rgba=l;else if(l instanceof D)this._hsla=l,this.rgba=D.toRGBA(l);else if(l instanceof f)this._hsva=l,this.rgba=f.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&F.equals(this.rgba,l.rgba)&&D.equals(this.hsla,l.hsla)&&f.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=E._relativeLuminanceForComponent(this.rgba.r),s=E._relativeLuminanceForComponent(this.rgba.g),c=E._relativeLuminanceForComponent(this.rgba.b),N=.2126*l+.7152*s+.0722*c;return n(N,4)}static _relativeLuminanceForComponent(l){const s=l/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(l){const s=this.getRelativeLuminance(),c=l.getRelativeLuminance();return s>c?(s+.05)/(c+.05):(c+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const s=this.getRelativeLuminance(),c=l.getRelativeLuminance();return s>c}isDarkerThan(l){const s=this.getRelativeLuminance(),c=l.getRelativeLuminance();return s<c}lighten(l){return new E(new D(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new E(new D(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:s,g:c,b:N,a:g}=this.rgba;return new E(new F(s,c,N,g*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new E(new F(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const s=l.rgba,c=this.rgba.a,N=s.a,g=c+N*(1-c);if(g<1e-6)return E.transparent;const m=this.rgba.r*c/g+s.r*N*(1-c)/g,e=this.rgba.g*c/g+s.g*N*(1-c)/g,w=this.rgba.b*c/g+s.b*N*(1-c)/g;return new E(new F(m,e,w,g))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:s,g:c,b:N,a:g}=this.rgba;return new E(new F(l.rgba.r-g*(l.rgba.r-s),l.rgba.g-g*(l.rgba.g-c),l.rgba.b-g*(l.rgba.b-N),1))}flatten(...l){const s=l.reduceRight((c,N)=>E._flatten(N,c));return E._flatten(this,s)}static _flatten(l,s){const c=1-l.rgba.a;return new E(new F(c*s.rgba.r+l.rgba.a*l.rgba.r,c*s.rgba.g+l.rgba.a*l.rgba.g,c*s.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this._toString||(this._toString=E.Format.CSS.format(this)),this._toString}static getLighterColor(l,s,c){if(l.isLighterThan(s))return l;c=c||.5;const N=l.getRelativeLuminance(),g=s.getRelativeLuminance();return c=c*(g-N)/g,l.lighten(c)}static getDarkerColor(l,s,c){if(l.isDarkerThan(s))return l;c=c||.5;const N=l.getRelativeLuminance(),g=s.getRelativeLuminance();return c=c*(N-g)/N,l.darken(c)}static{this.white=new E(new F(255,255,255,1))}static{this.black=new E(new F(0,0,0,1))}static{this.red=new E(new F(255,0,0,1))}static{this.blue=new E(new F(0,0,255,1))}static{this.green=new E(new F(0,255,0,1))}static{this.cyan=new E(new F(0,255,255,1))}static{this.lightgrey=new E(new F(211,211,211,1))}static{this.transparent=new E(new F(0,0,0,0))}}t.Color=E,function(h){let l;(function(s){let c;(function(N){function g(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:h.Format.CSS.formatRGBA(i)}N.formatRGB=g;function m(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}N.formatRGBA=m;function e(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:h.Format.CSS.formatHSLA(i)}N.formatHSL=e;function w(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}N.formatHSLA=w;function A(i){const u=i.toString(16);return u.length!==2?"0"+u:u}function _(i){return`#${A(i.rgba.r)}${A(i.rgba.g)}${A(i.rgba.b)}`}N.formatHex=_;function L(i,u=!1){return u&&i.rgba.a===1?h.Format.CSS.formatHex(i):`#${A(i.rgba.r)}${A(i.rgba.g)}${A(i.rgba.b)}${A(Math.round(i.rgba.a*255))}`}N.formatHexA=L;function p(i){return i.isOpaque()?h.Format.CSS.formatHex(i):h.Format.CSS.formatRGBA(i)}N.format=p;function o(i){const u=i.length;if(u===0||i.charCodeAt(0)!==35)return null;if(u===7){const b=16*a(i.charCodeAt(1))+a(i.charCodeAt(2)),d=16*a(i.charCodeAt(3))+a(i.charCodeAt(4)),v=16*a(i.charCodeAt(5))+a(i.charCodeAt(6));return new h(new F(b,d,v,1))}if(u===9){const b=16*a(i.charCodeAt(1))+a(i.charCodeAt(2)),d=16*a(i.charCodeAt(3))+a(i.charCodeAt(4)),v=16*a(i.charCodeAt(5))+a(i.charCodeAt(6)),M=16*a(i.charCodeAt(7))+a(i.charCodeAt(8));return new h(new F(b,d,v,M/255))}if(u===4){const b=a(i.charCodeAt(1)),d=a(i.charCodeAt(2)),v=a(i.charCodeAt(3));return new h(new F(16*b+b,16*d+d,16*v+v))}if(u===5){const b=a(i.charCodeAt(1)),d=a(i.charCodeAt(2)),v=a(i.charCodeAt(3)),M=a(i.charCodeAt(4));return new h(new F(16*b+b,16*d+d,16*v+v,(16*M+M)/255))}return null}N.parseHex=o;function a(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(c=s.CSS||(s.CSS={}))})(l=h.Format||(h.Format={}))}(E||(t.Color=E={}))}),ne(se[37],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class n{constructor(D,f,E,h){this.originalStart=D,this.originalLength=f,this.modifiedStart=E,this.modifiedLength=h}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=n}),ne(se[3],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.ReadonlyError=t.CancellationError=t.errorHandler=t.ErrorHandler=void 0,t.setUnexpectedErrorHandler=F,t.isSigPipeError=D,t.onUnexpectedError=f,t.onUnexpectedExternalError=E,t.transformErrorForSerialization=h,t.isCancellationError=s,t.canceled=N,t.illegalArgument=g,t.illegalState=m,t.getErrorMessage=w;class n{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?p.isErrorNoTelemetry(i)?new p(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(u=>{u(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}t.ErrorHandler=n,t.errorHandler=new n;function F(a){t.errorHandler.setUnexpectedErrorHandler(a)}function D(a){if(!a||typeof a!="object")return!1;const i=a;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function f(a){s(a)||t.errorHandler.onUnexpectedError(a)}function E(a){s(a)||t.errorHandler.onUnexpectedExternalError(a)}function h(a){if(a instanceof Error){const{name:i,message:u}=a,b=a.stacktrace||a.stack;return{$isError:!0,name:i,message:u,stack:b,noTelemetry:p.isErrorNoTelemetry(a)}}return a}const l="Canceled";function s(a){return a instanceof c?!0:a instanceof Error&&a.name===l&&a.message===l}class c extends Error{constructor(){super(l),this.name=this.message}}t.CancellationError=c;function N(){const a=new Error(l);return a.name=a.message,a}function g(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function m(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class e extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}t.ReadonlyError=e;function w(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class A extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}t.NotImplementedError=A;class _ extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}t.NotSupportedError=_;class L extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=L;class p extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof p)return i;const u=new p;return u.message=i.message,u.stack=i.stack,u}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}t.ErrorNoTelemetry=p;class o extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}t.BugIndicatingError=o}),ne(se[6],ae([0,1,3,9]),function(W,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Permutation=t.CallbackIterable=t.ArrayQueue=t.booleanComparator=t.numberComparator=t.CompareResult=void 0,t.tail=D,t.tail2=f,t.equals=E,t.removeFastWithoutKeepingOrder=h,t.binarySearch=l,t.binarySearch2=s,t.quickSelect=c,t.groupBy=N,t.groupAdjacentBy=g,t.forEachAdjacent=m,t.forEachWithNeighbors=e,t.sortedDiff=w,t.delta=A,t.top=_,t.topAsync=L,t.coalesce=o,t.coalesceInPlace=a,t.move=i,t.isFalsyOrEmpty=u,t.isNonEmptyArray=b,t.distinct=d,t.uniqueFilter=v,t.firstOrDefault=M,t.lastOrDefault=R,t.commonPrefixLength=S,t.flatten=x,t.range=I,t.index=k,t.insert=y,t.remove=C,t.arrayInsert=O,t.shuffle=j,t.pushToStart=K,t.pushToEnd=U,t.pushMany=X,t.mapArrayOrNot=G,t.asArray=P,t.getRandomElement=H,t.insertInto=ie,t.splice=oe,t.compareBy=Le,t.tieBreakComparators=we,t.reverseOrder=Ce;function D(B,z=0){return B[B.length-(1+z)]}function f(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}function E(B,z,V=(Y,ee)=>Y===ee){if(B===z)return!0;if(!B||!z||B.length!==z.length)return!1;for(let Y=0,ee=B.length;Y<ee;Y++)if(!V(B[Y],z[Y]))return!1;return!0}function h(B,z){const V=B.length-1;z<V&&(B[z]=B[V]),B.pop()}function l(B,z,V){return s(B.length,Y=>V(B[Y],z))}function s(B,z){let V=0,Y=B-1;for(;V<=Y;){const ee=(V+Y)/2|0,J=z(ee);if(J<0)V=ee+1;else if(J>0)Y=ee-1;else return ee}return-(V+1)}function c(B,z,V){if(B=B|0,B>=z.length)throw new TypeError("invalid index");const Y=z[Math.floor(z.length*Math.random())],ee=[],J=[],Q=[];for(const re of z){const te=V(re,Y);te<0?ee.push(re):te>0?J.push(re):Q.push(re)}return B<ee.length?c(B,ee,V):B<ee.length+Q.length?Q[0]:c(B-(ee.length+Q.length),J,V)}function N(B,z){const V=[];let Y;for(const ee of B.slice(0).sort(z))!Y||z(Y[0],ee)!==0?(Y=[ee],V.push(Y)):Y.push(ee);return V}function*g(B,z){let V,Y;for(const ee of B)Y!==void 0&&z(Y,ee)?V.push(ee):(V&&(yield V),V=[ee]),Y=ee;V&&(yield V)}function m(B,z){for(let V=0;V<=B.length;V++)z(V===0?void 0:B[V-1],V===B.length?void 0:B[V])}function e(B,z){for(let V=0;V<B.length;V++)z(V===0?void 0:B[V-1],B[V],V+1===B.length?void 0:B[V+1])}function w(B,z,V){const Y=[];function ee(re,te,le){if(te===0&&le.length===0)return;const fe=Y[Y.length-1];fe&&fe.start+fe.deleteCount===re?(fe.deleteCount+=te,fe.toInsert.push(...le)):Y.push({start:re,deleteCount:te,toInsert:le})}let J=0,Q=0;for(;;){if(J===B.length){ee(J,0,z.slice(Q));break}if(Q===z.length){ee(J,B.length-J,[]);break}const re=B[J],te=z[Q],le=V(re,te);le===0?(J+=1,Q+=1):le<0?(ee(J,1,[]),J+=1):le>0&&(ee(J,0,[te]),Q+=1)}return Y}function A(B,z,V){const Y=w(B,z,V),ee=[],J=[];for(const Q of Y)ee.push(...B.slice(Q.start,Q.start+Q.deleteCount)),J.push(...Q.toInsert);return{removed:ee,added:J}}function _(B,z,V){if(V===0)return[];const Y=B.slice(0,V).sort(z);return p(B,z,Y,V,B.length),Y}function L(B,z,V,Y,ee){return V===0?Promise.resolve([]):new Promise((J,Q)=>{(async()=>{const re=B.length,te=B.slice(0,V).sort(z);for(let le=V,fe=Math.min(V+Y,re);le<re;le=fe,fe=Math.min(fe+Y,re)){if(le>V&&await new Promise(ce=>setTimeout(ce)),ee&&ee.isCancellationRequested)throw new n.CancellationError;p(B,z,te,le,fe)}return te})().then(J,Q)})}function p(B,z,V,Y,ee){for(const J=V.length;Y<ee;Y++){const Q=B[Y];if(z(Q,V[J-1])<0){V.pop();const re=(0,F.findFirstIdxMonotonousOrArrLen)(V,te=>z(Q,te)<0);V.splice(re,0,Q)}}}function o(B){return B.filter(z=>!!z)}function a(B){let z=0;for(let V=0;V<B.length;V++)B[V]&&(B[z]=B[V],z+=1);B.length=z}function i(B,z,V){B.splice(V,0,B.splice(z,1)[0])}function u(B){return!Array.isArray(B)||B.length===0}function b(B){return Array.isArray(B)&&B.length>0}function d(B,z=V=>V){const V=new Set;return B.filter(Y=>{const ee=z(Y);return V.has(ee)?!1:(V.add(ee),!0)})}function v(B){const z=new Set;return V=>{const Y=B(V);return z.has(Y)?!1:(z.add(Y),!0)}}function M(B,z){return B.length>0?B[0]:z}function R(B,z){return B.length>0?B[B.length-1]:z}function S(B,z,V=(Y,ee)=>Y===ee){let Y=0;for(let ee=0,J=Math.min(B.length,z.length);ee<J&&V(B[ee],z[ee]);ee++)Y++;return Y}function x(B){return[].concat(...B)}function I(B,z){let V=typeof z=="number"?B:0;typeof z=="number"?V=B:(V=0,z=B);const Y=[];if(V<=z)for(let ee=V;ee<z;ee++)Y.push(ee);else for(let ee=V;ee>z;ee--)Y.push(ee);return Y}function k(B,z,V){return B.reduce((Y,ee)=>(Y[z(ee)]=V?V(ee):ee,Y),Object.create(null))}function y(B,z){return B.push(z),()=>C(B,z)}function C(B,z){const V=B.indexOf(z);if(V>-1)return B.splice(V,1),z}function O(B,z,V){const Y=B.slice(0,z),ee=B.slice(z);return Y.concat(V,ee)}function j(B,z){let V;if(typeof z=="number"){let Y=z;V=()=>{const ee=Math.sin(Y++)*179426549;return ee-Math.floor(ee)}}else V=Math.random;for(let Y=B.length-1;Y>0;Y-=1){const ee=Math.floor(V()*(Y+1)),J=B[Y];B[Y]=B[ee],B[ee]=J}}function K(B,z){const V=B.indexOf(z);V>-1&&(B.splice(V,1),B.unshift(z))}function U(B,z){const V=B.indexOf(z);V>-1&&(B.splice(V,1),B.push(z))}function X(B,z){for(const V of z)B.push(V)}function G(B,z){return Array.isArray(B)?B.map(z):z(B)}function P(B){return Array.isArray(B)?B:[B]}function H(B){return B[Math.floor(Math.random()*B.length)]}function ie(B,z,V){const Y=ge(B,z),ee=B.length,J=V.length;B.length=ee+J;for(let Q=ee-1;Q>=Y;Q--)B[Q+J]=B[Q];for(let Q=0;Q<J;Q++)B[Q+Y]=V[Q]}function oe(B,z,V,Y){const ee=ge(B,z);let J=B.splice(ee,V);return J===void 0&&(J=[]),ie(B,ee,Y),J}function ge(B,z){return z<0?Math.max(z+B.length,0):Math.min(z,B.length)}var r;(function(B){function z(J){return J<0}B.isLessThan=z;function V(J){return J<=0}B.isLessThanOrEqual=V;function Y(J){return J>0}B.isGreaterThan=Y;function ee(J){return J===0}B.isNeitherLessOrGreaterThan=ee,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(r||(t.CompareResult=r={}));function Le(B,z){return(V,Y)=>z(B(V),B(Y))}function we(...B){return(z,V)=>{for(const Y of B){const ee=Y(z,V);if(!r.isNeitherLessOrGreaterThan(ee))return ee}return r.neitherLessOrGreaterThan}}const ke=(B,z)=>B-z;t.numberComparator=ke;const _e=(B,z)=>(0,t.numberComparator)(B?1:0,z?1:0);t.booleanComparator=_e;function Ce(B){return(z,V)=>-B(z,V)}class Oe{constructor(z){this.items=z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(z){let V=this.firstIdx;for(;V<this.items.length&&z(this.items[V]);)V++;const Y=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,Y}takeFromEndWhile(z){let V=this.lastIdx;for(;V>=0&&z(this.items[V]);)V--;const Y=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,Y}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const z=this.items[this.firstIdx];return this.firstIdx++,z}removeLast(){const z=this.items[this.lastIdx];return this.lastIdx--,z}takeCount(z){const V=this.items.slice(this.firstIdx,this.firstIdx+z);return this.firstIdx+=z,V}}t.ArrayQueue=Oe;class Re{static{this.empty=new Re(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(V=>(z(V),!0))}toArray(){const z=[];return this.iterate(V=>(z.push(V),!0)),z}filter(z){return new Re(V=>this.iterate(Y=>z(Y)?V(Y):!0))}map(z){return new Re(V=>this.iterate(Y=>V(z(Y))))}some(z){let V=!1;return this.iterate(Y=>(V=z(Y),!V)),V}findFirst(z){let V;return this.iterate(Y=>z(Y)?(V=Y,!1):!0),V}findLast(z){let V;return this.iterate(Y=>(z(Y)&&(V=Y),!0)),V}findLastMaxBy(z){let V,Y=!0;return this.iterate(ee=>((Y||r.isGreaterThan(z(ee,V)))&&(Y=!1,V=ee),!0)),V}}t.CallbackIterable=Re;class Se{constructor(z){this._indexMap=z}static createSortPermutation(z,V){const Y=Array.from(z.keys()).sort((ee,J)=>V(z[ee],z[J]));return new Se(Y)}apply(z){return z.map((V,Y)=>z[this._indexMap[Y]])}inverse(){const z=this._indexMap.slice();for(let V=0;V<this._indexMap.length;V++)z[this._indexMap[V]]=V;return new Se(z)}}t.Permutation=Se}),ne(se[13],ae([0,1,3]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=F,t.assertNever=D,t.assert=f,t.softAssert=E,t.assertFn=h,t.checkAdjacentItems=l;function F(s,c){if(!s)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}function D(s,c="Unreachable"){throw new Error(c)}function f(s){if(!s)throw new n.BugIndicatingError("Assertion Failed")}function E(s){s||(0,n.onUnexpectedError)(new n.BugIndicatingError("Soft Assertion Failed"))}function h(s){if(!s()){debugger;s(),(0,n.onUnexpectedError)(new n.BugIndicatingError("Assertion Failed"))}}function l(s,c){let N=0;for(;N<s.length-1;){const g=s[N],m=s[N+1];if(!c(g,m))return!1;N++}return!0}}),ne(se[20],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSingleCallFunction=n;function n(F,D){const f=this;let E=!1,h;return function(){if(E)return h;if(E=!0,D)try{h=F.apply(f,arguments)}finally{D()}else h=F.apply(f,arguments);return h}}}),ne(se[21],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var n;(function(F){function D(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}F.is=D;const f=Object.freeze([]);function E(){return f}F.empty=E;function*h(i){yield i}F.single=h;function l(i){return D(i)?i:h(i)}F.wrap=l;function s(i){return i||f}F.from=s;function*c(i){for(let u=i.length-1;u>=0;u--)yield i[u]}F.reverse=c;function N(i){return!i||i[Symbol.iterator]().next().done===!0}F.isEmpty=N;function g(i){return i[Symbol.iterator]().next().value}F.first=g;function m(i,u){for(const b of i)if(u(b))return!0;return!1}F.some=m;function e(i,u){for(const b of i)if(u(b))return b}F.find=e;function*w(i,u){for(const b of i)u(b)&&(yield b)}F.filter=w;function*A(i,u){let b=0;for(const d of i)yield u(d,b++)}F.map=A;function*_(...i){for(const u of i)yield*u}F.concat=_;function L(i,u,b){let d=b;for(const v of i)d=u(d,v);return d}F.reduce=L;function*p(i,u,b=i.length){for(u<0&&(u+=i.length),b<0?b+=i.length:b>i.length&&(b=i.length);u<b;u++)yield i[u]}F.slice=p;function o(i,u=Number.POSITIVE_INFINITY){const b=[];if(u===0)return[b,i];const d=i[Symbol.iterator]();for(let v=0;v<u;v++){const M=d.next();if(M.done)return[b,F.empty()];b.push(M.value)}return[b,{[Symbol.iterator](){return d}}]}F.consume=o;async function a(i){const u=[];for await(const b of i)u.push(b);return Promise.resolve(u)}F.asyncToArray=a})(n||(t.Iterable=n={}))}),ne(se[38],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0,t.KeyChord=m;var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(n||(t.KeyCode=n={}));var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(F||(t.ScanCode=F={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(w,A){this._keyCodeToStr[w]=A,this._strToKeyCode[A.toLowerCase()]=w}keyCodeToStr(w){return this._keyCodeToStr[w]}strToKeyCode(w){return this._strToKeyCode[w.toLowerCase()]||0}}const f=new D,E=new D,h=new D;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const l=[],s=Object.create(null),c=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>c[e]||0,toEnum:e=>s[e]||0,toString:e=>l[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",w=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],A=[],_=[];for(const L of w){const[p,o,a,i,u,b,d,v,M]=L;if(_[o]||(_[o]=!0,l[o]=a,s[a]=o,c[a.toLowerCase()]=o,p&&(t.IMMUTABLE_CODE_TO_KEY_CODE[o]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[i]=o))),!A[i]){if(A[i]=!0,!u)throw new Error(`String representation missing for key code ${i} around scan code ${a}`);f.define(i,u),E.define(i,v||u),h.define(i,M||v||u)}b&&(t.EVENT_KEY_CODE_MAP[b]=i),d&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[d]=i)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var N;(function(e){function w(a){return f.keyCodeToStr(a)}e.toString=w;function A(a){return f.strToKeyCode(a)}e.fromString=A;function _(a){return E.keyCodeToStr(a)}e.toUserSettingsUS=_;function L(a){return h.keyCodeToStr(a)}e.toUserSettingsGeneral=L;function p(a){return E.strToKeyCode(a)||h.strToKeyCode(a)}e.fromUserSettings=p;function o(a){if(a>=98&&a<=113)return null;switch(a){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return f.keyCodeToStr(a)}e.toElectronAccelerator=o})(N||(t.KeyCodeUtils=N={}));var g;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(g||(t.KeyMod=g={}));function m(e,w){const A=(w&65535)<<16>>>0;return(e|A)>>>0}}),ne(se[39],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class n{constructor(D){this.executor=D,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=n}),ne(se[22],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class n{static{this.Undefined=new n(void 0)}constructor(f){this.element=f,this.next=n.Undefined,this.prev=n.Undefined}}class F{constructor(){this._first=n.Undefined,this._last=n.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===n.Undefined}clear(){let f=this._first;for(;f!==n.Undefined;){const E=f.next;f.prev=n.Undefined,f.next=n.Undefined,f=E}this._first=n.Undefined,this._last=n.Undefined,this._size=0}unshift(f){return this._insert(f,!1)}push(f){return this._insert(f,!0)}_insert(f,E){const h=new n(f);if(this._first===n.Undefined)this._first=h,this._last=h;else if(E){const s=this._last;this._last=h,h.prev=s,s.next=h}else{const s=this._first;this._first=h,h.next=s,s.prev=h}this._size+=1;let l=!1;return()=>{l||(l=!0,this._remove(h))}}shift(){if(this._first!==n.Undefined){const f=this._first.element;return this._remove(this._first),f}}pop(){if(this._last!==n.Undefined){const f=this._last.element;return this._remove(this._last),f}}_remove(f){if(f.prev!==n.Undefined&&f.next!==n.Undefined){const E=f.prev;E.next=f.next,f.next.prev=E}else f.prev===n.Undefined&&f.next===n.Undefined?(this._first=n.Undefined,this._last=n.Undefined):f.next===n.Undefined?(this._last=this._last.prev,this._last.next=n.Undefined):f.prev===n.Undefined&&(this._first=this._first.next,this._first.prev=n.Undefined);this._size-=1}*[Symbol.iterator](){let f=this._first;for(;f!==n.Undefined;)yield f.element,f=f.next}}t.LinkedList=F}),ne(se[14],ae([0,1]),function(W,t){"use strict";var n,F,D;Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.BidirectionalMap=t.CounterSet=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=void 0,t.getOrSet=f,t.mapToString=E,t.setToString=h,t.mapsStrictEqualIgnoreOrder=L;function f(p,o,a){let i=p.get(o);return i===void 0&&(i=a,p.set(o,i)),i}function E(p){const o=[];return p.forEach((a,i)=>{o.push(`${i} => ${a}`)}),`Map(${p.size}) {${o.join(", ")}}`}function h(p){const o=[];return p.forEach(a=>{o.push(a)}),`Set(${p.size}) {${o.join(", ")}}`}class l{constructor(o,a){this.uri=o,this.value=a}}function s(p){return Array.isArray(p)}class c{static{this.defaultToKey=o=>o.toString()}constructor(o,a){if(this[n]="ResourceMap",o instanceof c)this.map=new Map(o.map),this.toKey=a??c.defaultToKey;else if(s(o)){this.map=new Map,this.toKey=a??c.defaultToKey;for(const[i,u]of o)this.set(i,u)}else this.map=new Map,this.toKey=o??c.defaultToKey}set(o,a){return this.map.set(this.toKey(o),new l(o,a)),this}get(o){return this.map.get(this.toKey(o))?.value}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,a){typeof a<"u"&&(o=o.bind(a));for(const[i,u]of this.map)o(u.value,u.uri,this)}*values(){for(const o of this.map.values())yield o.value}*keys(){for(const o of this.map.values())yield o.uri}*entries(){for(const o of this.map.values())yield[o.uri,o.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.map)yield[o.uri,o.value]}}t.ResourceMap=c;class N{constructor(o,a){this[F]="ResourceSet",!o||typeof o=="function"?this._map=new c(o):(this._map=new c(a),o.forEach(this.add,this))}get size(){return this._map.size}add(o){return this._map.set(o,o),this}clear(){this._map.clear()}delete(o){return this._map.delete(o)}forEach(o,a){this._map.forEach((i,u)=>o.call(a,u,u,this))}has(o){return this._map.has(o)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=N;var g;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(g||(t.Touch=g={}));class m{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(o){return this._map.has(o)}get(o,a=0){const i=this._map.get(o);if(i)return a!==0&&this.touch(i,a),i.value}set(o,a,i=0){let u=this._map.get(o);if(u)u.value=a,i!==0&&this.touch(u,i);else{switch(u={key:o,value:a,next:void 0,previous:void 0},i){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(o,u),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const a=this._map.get(o);if(a)return this._map.delete(o),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}forEach(o,a){const i=this._state;let u=this._head;for(;u;){if(a?o.bind(a)(u.value,u.key,this):o(u.value,u.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const o=this,a=this._state;let i=this._head;const u={[Symbol.iterator](){return u},next(){if(o._state!==a)throw new Error("LinkedMap got modified during iteration.");if(i){const b={value:i.key,done:!1};return i=i.next,b}else return{value:void 0,done:!0}}};return u}values(){const o=this,a=this._state;let i=this._head;const u={[Symbol.iterator](){return u},next(){if(o._state!==a)throw new Error("LinkedMap got modified during iteration.");if(i){const b={value:i.value,done:!1};return i=i.next,b}else return{value:void 0,done:!0}}};return u}entries(){const o=this,a=this._state;let i=this._head;const u={[Symbol.iterator](){return u},next(){if(o._state!==a)throw new Error("LinkedMap got modified during iteration.");if(i){const b={value:[i.key,i.value],done:!1};return i=i.next,b}else return{value:void 0,done:!0}}};return u}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(o>=this.size)return;if(o===0){this.clear();return}let a=this._head,i=this.size;for(;a&&i>o;)this._map.delete(a.key),a=a.next,i--;this._head=a,this._size=i,a&&(a.previous=void 0),this._state++}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const a=o.next,i=o.previous;if(!a||!i)throw new Error("Invalid list");a.previous=i,i.next=a}o.next=void 0,o.previous=void 0,this._state++}touch(o,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(o===this._head)return;const i=o.next,u=o.previous;o===this._tail?(u.next=void 0,this._tail=u):(i.previous=u,u.next=i),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(a===2){if(o===this._tail)return;const i=o.next,u=o.previous;o===this._head?(i.previous=void 0,this._head=i):(i.previous=u,u.next=i),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((a,i)=>{o.push([i,a])}),o}fromJSON(o){this.clear();for(const[a,i]of o)this.set(a,i)}}t.LinkedMap=m;class e extends m{constructor(o,a=1){super(),this._limit=o,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,a=2){return super.get(o,a)}peek(o){return super.get(o,0)}set(o,a){return super.set(o,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=e;class w{constructor(){this.map=new Map}add(o){return this.map.set(o,(this.map.get(o)||0)+1),this}delete(o){let a=this.map.get(o)||0;return a===0?!1:(a--,a===0?this.map.delete(o):this.map.set(o,a),!0)}has(o){return this.map.has(o)}}t.CounterSet=w;class A{constructor(o){if(this._m1=new Map,this._m2=new Map,o)for(const[a,i]of o)this.set(a,i)}clear(){this._m1.clear(),this._m2.clear()}set(o,a){this._m1.set(o,a),this._m2.set(a,o)}get(o){return this._m1.get(o)}getKey(o){return this._m2.get(o)}delete(o){const a=this._m1.get(o);return a===void 0?!1:(this._m1.delete(o),this._m2.delete(a),!0)}forEach(o,a){this._m1.forEach((i,u)=>{o.call(a,i,u,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}t.BidirectionalMap=A;class _{constructor(){this.map=new Map}add(o,a){let i=this.map.get(o);i||(i=new Set,this.map.set(o,i)),i.add(a)}delete(o,a){const i=this.map.get(o);i&&(i.delete(a),i.size===0&&this.map.delete(o))}forEach(o,a){const i=this.map.get(o);i&&i.forEach(a)}get(o){const a=this.map.get(o);return a||new Set}}t.SetMap=_;function L(p,o){if(p===o)return!0;if(p.size!==o.size)return!1;for(const[a,i]of p)if(!o.has(a)||o.get(a)!==i)return!1;for(const[a]of o)if(!p.has(a))return!1;return!0}}),ne(se[10],ae([0,1,6,35,14,20,21]),function(W,t,n,F,D,f,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MandatoryMutableDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.DisposableTracker=void 0,t.setDisposableTracker=c,t.trackDisposable=N,t.markAsDisposed=g,t.markAsSingleton=w,t.isDisposable=A,t.dispose=_,t.disposeIfDisposable=L,t.combinedDisposable=p,t.toDisposable=o,t.disposeOnReturn=x;const h=!1;let l=null;class s{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(y){let C=this.livingDisposables.get(y);return C||(C={parent:null,source:null,isSingleton:!1,value:y,idx:s.idx++},this.livingDisposables.set(y,C)),C}trackDisposable(y){const C=this.getDisposableData(y);C.source||(C.source=new Error().stack)}setParent(y,C){const O=this.getDisposableData(y);O.parent=C}markAsDisposed(y){this.livingDisposables.delete(y)}markAsSingleton(y){this.getDisposableData(y).isSingleton=!0}getRootParent(y,C){const O=C.get(y);if(O)return O;const j=y.parent?this.getRootParent(this.getDisposableData(y.parent),C):y;return C.set(y,j),j}getTrackedDisposables(){const y=new Map;return[...this.livingDisposables.entries()].filter(([,O])=>O.source!==null&&!this.getRootParent(O,y).isSingleton).flatMap(([O])=>O)}computeLeakingDisposables(y=10,C){let O;if(C)O=C;else{const G=new Map,P=[...this.livingDisposables.values()].filter(ie=>ie.source!==null&&!this.getRootParent(ie,G).isSingleton);if(P.length===0)return;const H=new Set(P.map(ie=>ie.value));if(O=P.filter(ie=>!(ie.parent&&H.has(ie.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function j(G){function P(ie,oe){for(;ie.length>0&&oe.some(ge=>typeof ge=="string"?ge===ie[0]:ie[0].match(ge));)ie.shift()}const H=G.source.split(`
`).map(ie=>ie.trim().replace("at ","")).filter(ie=>ie!=="");return P(H,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),H.reverse()}const K=new D.SetMap;for(const G of O){const P=j(G);for(let H=0;H<=P.length;H++)K.add(P.slice(0,H).join(`
`),G)}O.sort((0,n.compareBy)(G=>G.idx,n.numberComparator));let U="",X=0;for(const G of O.slice(0,y)){X++;const P=j(G),H=[];for(let ie=0;ie<P.length;ie++){let oe=P[ie];oe=`(shared with ${K.get(P.slice(0,ie+1).join(`
`)).size}/${O.length} leaks) at ${oe}`;const r=K.get(P.slice(0,ie).join(`
`)),Le=(0,F.groupBy)([...r].map(we=>j(we)[ie]),we=>we);delete Le[P[ie]];for(const[we,ke]of Object.entries(Le))H.unshift(`    - stacktraces of ${ke.length} other leaks continue with ${we}`);H.unshift(oe)}U+=`


==================== Leaking disposable ${X}/${O.length}: ${G.value.constructor.name} ====================
${H.join(`
`)}
============================================================

`}return O.length>y&&(U+=`


... and ${O.length-y} more leaking disposables

`),{leaks:O,details:U}}}t.DisposableTracker=s;function c(k){l=k}if(h){const k="__is_disposable_tracked__";c(new class{trackDisposable(y){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{y[k]||console.log(C)},3e3)}setParent(y,C){if(y&&y!==i.None)try{y[k]=!0}catch{}}markAsDisposed(y){if(y&&y!==i.None)try{y[k]=!0}catch{}}markAsSingleton(y){}})}function N(k){return l?.trackDisposable(k),k}function g(k){l?.markAsDisposed(k)}function m(k,y){l?.setParent(k,y)}function e(k,y){if(l)for(const C of k)l.setParent(C,y)}function w(k){return l?.markAsSingleton(k),k}function A(k){return typeof k.dispose=="function"&&k.dispose.length===0}function _(k){if(E.Iterable.is(k)){const y=[];for(const C of k)if(C)try{C.dispose()}catch(O){y.push(O)}if(y.length===1)throw y[0];if(y.length>1)throw new AggregateError(y,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}function L(k){for(const y of k)A(y)&&y.dispose();return[]}function p(...k){const y=o(()=>_(k));return e(k,y),y}function o(k){const y=N({dispose:(0,f.createSingleCallFunction)(()=>{g(y),k()})});return y}class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,N(this)}dispose(){this._isDisposed||(g(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{_(this._toDispose)}finally{this._toDispose.clear()}}add(y){if(!y)return y;if(y===this)throw new Error("Cannot register a disposable on itself!");return m(y,this),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(y),y}delete(y){if(y){if(y===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(y),y.dispose()}}deleteAndLeak(y){y&&this._toDispose.has(y)&&(this._toDispose.delete(y),m(y,null))}}t.DisposableStore=a;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new a,N(this),m(this._store,this)}dispose(){g(this),this._store.dispose()}_register(y){if(y===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(y)}}t.Disposable=i;class u{constructor(){this._isDisposed=!1,N(this)}get value(){return this._isDisposed?void 0:this._value}set value(y){this._isDisposed||y===this._value||(this._value?.dispose(),y&&m(y,this),this._value=y)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,g(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const y=this._value;return this._value=void 0,y&&m(y,null),y}}t.MutableDisposable=u;class b{constructor(y){this._disposable=new u,this._isDisposed=!1,this._disposable.value=y}get value(){return this._disposable.value}set value(y){this._isDisposed||y===this._disposable.value||(this._disposable.value=y)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}t.MandatoryMutableDisposable=b;class d{constructor(y){this._disposable=y,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=d;class v{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,N(this)}set(y){let C=y;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,g(this))},this}}t.SafeDisposable=v;class M{constructor(){this.references=new Map}acquire(y,...C){let O=this.references.get(y);O||(O={counter:0,object:this.createReferencedObject(y,...C)},this.references.set(y,O));const{object:j}=O,K=(0,f.createSingleCallFunction)(()=>{--O.counter===0&&(this.destroyReferencedObject(y,O.object),this.references.delete(y))});return O.counter++,{object:j,dispose:K}}}t.ReferenceCollection=M;class R{constructor(y){this.referenceCollection=y}async acquire(y,...C){const O=this.referenceCollection.acquire(y,...C);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(j){throw O.dispose(),j}}}t.AsyncReferenceCollection=R;class S{constructor(y){this.object=y}dispose(){}}t.ImmortalReference=S;function x(k){const y=new a;try{k(y)}finally{y.dispose()}}class I{constructor(){this._store=new Map,this._isDisposed=!1,N(this)}dispose(){g(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{_(this._store.values())}finally{this._store.clear()}}has(y){return this._store.has(y)}get size(){return this._store.size}get(y){return this._store.get(y)}set(y,C,O=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this._store.get(y)?.dispose(),this._store.set(y,C)}deleteAndDispose(y){this._store.get(y)?.dispose(),this._store.delete(y)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=I}),ne(se[23],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(f){return new F(f)}constructor(f){this._now=n&&f===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=F}),ne(se[11],ae([0,1,3,20,10,22,23]),function(W,t,n,F,D,f,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.DynamicListEventMultiplexer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.EventProfiling=t.Event=void 0,t.setGlobalLeakWarningThreshold=m;const h=!1,l=!1,s=!1;var c;(function(k){k.None=()=>D.Disposable.None;function y(J){if(s){const{onDidAddListener:Q}=J,re=w.create();let te=0;J.onDidAddListener=()=>{++te===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),re.print()),Q?.()}}}function C(J,Q){return oe(J,()=>{},0,void 0,!0,void 0,Q)}k.defer=C;function O(J){return(Q,re=null,te)=>{let le=!1,fe;return fe=J(ce=>{if(!le)return fe?fe.dispose():le=!0,Q.call(re,ce)},null,te),le&&fe.dispose(),fe}}k.once=O;function j(J,Q,re){return H((te,le=null,fe)=>J(ce=>te.call(le,Q(ce)),null,fe),re)}k.map=j;function K(J,Q,re){return H((te,le=null,fe)=>J(ce=>{Q(ce),te.call(le,ce)},null,fe),re)}k.forEach=K;function U(J,Q,re){return H((te,le=null,fe)=>J(ce=>Q(ce)&&te.call(le,ce),null,fe),re)}k.filter=U;function X(J){return J}k.signal=X;function G(...J){return(Q,re=null,te)=>{const le=(0,D.combinedDisposable)(...J.map(fe=>fe(ce=>Q.call(re,ce))));return ie(le,te)}}k.any=G;function P(J,Q,re,te){let le=re;return j(J,fe=>(le=Q(le,fe),le),te)}k.reduce=P;function H(J,Q){let re;const te={onWillAddFirstListener(){re=J(le.fire,le)},onDidRemoveLastListener(){re?.dispose()}};Q||y(te);const le=new a(te);return Q?.add(le),le.event}function ie(J,Q){return Q instanceof Array?Q.push(J):Q&&Q.add(J),J}function oe(J,Q,re=100,te=!1,le=!1,fe,ce){let me,be,Fe,xe=0,Pe;const Ne={leakWarningThreshold:fe,onWillAddFirstListener(){me=J(We=>{xe++,be=Q(be,We),te&&!Fe&&(Te.fire(be),be=void 0),Pe=()=>{const Ve=be;be=void 0,Fe=void 0,(!te||xe>1)&&Te.fire(Ve),xe=0},typeof re=="number"?(clearTimeout(Fe),Fe=setTimeout(Pe,re)):Fe===void 0&&(Fe=0,queueMicrotask(Pe))})},onWillRemoveListener(){le&&xe>0&&Pe?.()},onDidRemoveLastListener(){Pe=void 0,me.dispose()}};ce||y(Ne);const Te=new a(Ne);return ce?.add(Te),Te.event}k.debounce=oe;function ge(J,Q=0,re){return k.debounce(J,(te,le)=>te?(te.push(le),te):[le],Q,void 0,!0,void 0,re)}k.accumulate=ge;function r(J,Q=(te,le)=>te===le,re){let te=!0,le;return U(J,fe=>{const ce=te||!Q(fe,le);return te=!1,le=fe,ce},re)}k.latch=r;function Le(J,Q,re){return[k.filter(J,Q,re),k.filter(J,te=>!Q(te),re)]}k.split=Le;function we(J,Q=!1,re=[],te){let le=re.slice(),fe=J(be=>{le?le.push(be):me.fire(be)});te&&te.add(fe);const ce=()=>{le?.forEach(be=>me.fire(be)),le=null},me=new a({onWillAddFirstListener(){fe||(fe=J(be=>me.fire(be)),te&&te.add(fe))},onDidAddFirstListener(){le&&(Q?setTimeout(ce):ce())},onDidRemoveLastListener(){fe&&fe.dispose(),fe=null}});return te&&te.add(me),me.event}k.buffer=we;function ke(J,Q){return(te,le,fe)=>{const ce=Q(new Ce);return J(function(me){const be=ce.evaluate(me);be!==_e&&te.call(le,be)},void 0,fe)}}k.chain=ke;const _e=Symbol("HaltChainable");class Ce{constructor(){this.steps=[]}map(Q){return this.steps.push(Q),this}forEach(Q){return this.steps.push(re=>(Q(re),re)),this}filter(Q){return this.steps.push(re=>Q(re)?re:_e),this}reduce(Q,re){let te=re;return this.steps.push(le=>(te=Q(te,le),te)),this}latch(Q=(re,te)=>re===te){let re=!0,te;return this.steps.push(le=>{const fe=re||!Q(le,te);return re=!1,te=le,fe?le:_e}),this}evaluate(Q){for(const re of this.steps)if(Q=re(Q),Q===_e)break;return Q}}function Oe(J,Q,re=te=>te){const te=(...me)=>ce.fire(re(...me)),le=()=>J.on(Q,te),fe=()=>J.removeListener(Q,te),ce=new a({onWillAddFirstListener:le,onDidRemoveLastListener:fe});return ce.event}k.fromNodeEventEmitter=Oe;function Re(J,Q,re=te=>te){const te=(...me)=>ce.fire(re(...me)),le=()=>J.addEventListener(Q,te),fe=()=>J.removeEventListener(Q,te),ce=new a({onWillAddFirstListener:le,onDidRemoveLastListener:fe});return ce.event}k.fromDOMEventEmitter=Re;function Se(J){return new Promise(Q=>O(J)(Q))}k.toPromise=Se;function B(J){const Q=new a;return J.then(re=>{Q.fire(re)},()=>{Q.fire(void 0)}).finally(()=>{Q.dispose()}),Q.event}k.fromPromise=B;function z(J,Q,re){return Q(re),J(te=>Q(te))}k.runAndSubscribe=z;class V{constructor(Q,re){this._observable=Q,this._counter=0,this._hasChanged=!1;const te={onWillAddFirstListener:()=>{Q.addObserver(this)},onDidRemoveLastListener:()=>{Q.removeObserver(this)}};re||y(te),this.emitter=new a(te),re&&re.add(this.emitter)}beginUpdate(Q){this._counter++}handlePossibleChange(Q){}handleChange(Q,re){this._hasChanged=!0}endUpdate(Q){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Y(J,Q){return new V(J,Q).emitter.event}k.fromObservable=Y;function ee(J){return(Q,re,te)=>{let le=0,fe=!1;const ce={beginUpdate(){le++},endUpdate(){le--,le===0&&(J.reportChanges(),fe&&(fe=!1,Q.call(re)))},handlePossibleChange(){},handleChange(){fe=!0}};J.addObserver(ce),J.reportChanges();const me={dispose(){J.removeObserver(ce)}};return te instanceof D.DisposableStore?te.add(me):Array.isArray(te)&&te.push(me),me}}k.fromObservableLight=ee})(c||(t.Event=c={}));class N{static{this.all=new Set}static{this._idPool=0}constructor(y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${y}_${N._idPool++}`,N.all.add(this)}start(y){this._stopWatch=new E.StopWatch,this.listenerCount=y}stop(){if(this._stopWatch){const y=this._stopWatch.elapsed();this.durations.push(y),this.elapsedOverall+=y,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=N;let g=-1;function m(k){const y=g;return g=k,{dispose(){g=y}}}class e{constructor(y,C=Math.random().toString(18).slice(2,5)){this.threshold=y,this.name=C,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(y,C){const O=this.threshold;if(O<=0||C<O)return;this._stacks||(this._stacks=new Map);const j=this._stacks.get(y.value)||0;if(this._stacks.set(y.value,j+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=O*.5;let K,U=0;for(const[X,G]of this._stacks)(!K||U<G)&&(K=X,U=G);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${U}):`),console.warn(K)}return()=>{const K=this._stacks.get(y.value)||0;this._stacks.set(y.value,K-1)}}}class w{static create(){return new w(new Error().stack??"")}constructor(y){this.value=y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let A=0;class _{constructor(y){this.value=y,this.id=A++}}const L=2,p=(k,y)=>{if(k instanceof _)y(k);else for(let C=0;C<k.length;C++){const O=k[C];O&&y(O)}},o=h?new FinalizationRegistry(k=>{typeof k=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(k))}):void 0;class a{constructor(y){this._size=0,this._options=y,this._leakageMon=g>0||this._options?.leakWarningThreshold?new e(this._options?.leakWarningThreshold??g):void 0,this._perfMon=this._options?._profName?new N(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(l){const y=this._listeners;queueMicrotask(()=>{p(y,C=>C.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(y,C,O)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),D.Disposable.None;if(this._disposed)return D.Disposable.None;C&&(y=y.bind(C));const j=new _(y);let K,U;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(j.stack=w.create(),K=this._leakageMon.check(j.stack,this._size+1)),l&&(j.stack=U??w.create()),this._listeners?this._listeners instanceof _?(this._deliveryQueue??=new u,this._listeners=[this._listeners,j]):this._listeners.push(j):(this._options?.onWillAddFirstListener?.(this),this._listeners=j,this._options?.onDidAddFirstListener?.(this)),this._size++;const X=(0,D.toDisposable)(()=>{o?.unregister(X),K?.(),this._removeListener(j)});if(O instanceof D.DisposableStore?O.add(X):Array.isArray(O)&&O.push(X),o){const G=new Error().stack.split(`
`).slice(2).join(`
`).trim();o.register(X,G,X)}return X},this._event}_removeListener(y){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const C=this._listeners,O=C.indexOf(y);if(O===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,C[O]=void 0;const j=this._deliveryQueue.current===this;if(this._size*L<=C.length){let K=0;for(let U=0;U<C.length;U++)C[U]?C[K++]=C[U]:j&&(this._deliveryQueue.end--,K<this._deliveryQueue.i&&this._deliveryQueue.i--);C.length=K}}_deliver(y,C){if(!y)return;const O=this._options?.onListenerError||n.onUnexpectedError;if(!O){y.value(C);return}try{y.value(C)}catch(j){O(j)}}_deliverQueue(y){const C=y.current._listeners;for(;y.i<y.end;)this._deliver(C[y.i++],y.value);y.reset()}fire(y){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof _)this._deliver(this._listeners,y);else{const C=this._deliveryQueue;C.enqueue(this,y,this._listeners.length),this._deliverQueue(C)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=a;const i=()=>new u;t.createEventDeliveryQueue=i;class u{constructor(){this.i=-1,this.end=0}enqueue(y,C,O){this.i=0,this.end=O,this.current=y,this.value=C}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class b extends a{async fireAsync(y,C,O){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new f.LinkedList),p(this._listeners,j=>this._asyncDeliveryQueue.push([j.value,y]));this._asyncDeliveryQueue.size>0&&!C.isCancellationRequested;){const[j,K]=this._asyncDeliveryQueue.shift(),U=[],X={...K,token:C,waitUntil:G=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");O&&(G=O(G,j)),U.push(G)}};try{j(X)}catch(G){(0,n.onUnexpectedError)(G);continue}Object.freeze(U),await Promise.allSettled(U).then(G=>{for(const P of G)P.status==="rejected"&&(0,n.onUnexpectedError)(P.reason)})}}}t.AsyncEmitter=b;class d extends a{get isPaused(){return this._isPaused!==0}constructor(y){super(y),this._isPaused=0,this._eventQueue=new f.LinkedList,this._mergeFn=y?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const y=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(y))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(y){this._size&&(this._isPaused!==0?this._eventQueue.push(y):super.fire(y))}}t.PauseableEmitter=d;class v extends d{constructor(y){super(y),this._delay=y.delay??100}fire(y){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(y)}}t.DebounceEmitter=v;class M extends a{constructor(y){super(y),this._queuedEvents=[],this._mergeFn=y?.merge}fire(y){this.hasListeners()&&(this._queuedEvents.push(y),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(C=>super.fire(C)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=M;class R{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new a({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(y){const C={event:y,listener:null};this.events.push(C),this.hasListeners&&this.hook(C);const O=()=>{this.hasListeners&&this.unhook(C);const j=this.events.indexOf(C);this.events.splice(j,1)};return(0,D.toDisposable)((0,F.createSingleCallFunction)(O))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(y=>this.hook(y))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(y=>this.unhook(y))}hook(y){y.listener=y.event(C=>this.emitter.fire(C))}unhook(y){y.listener?.dispose(),y.listener=null}dispose(){this.emitter.dispose();for(const y of this.events)y.listener?.dispose();this.events=[]}}t.EventMultiplexer=R;class S{constructor(y,C,O,j){this._store=new D.DisposableStore;const K=this._store.add(new R),U=this._store.add(new D.DisposableMap);function X(G){U.set(G,K.add(j(G)))}for(const G of y)X(G);this._store.add(C(G=>{X(G)})),this._store.add(O(G=>{U.deleteAndDispose(G)})),this.event=K.event}dispose(){this._store.dispose()}}t.DynamicListEventMultiplexer=S;class x{constructor(){this.buffers=[]}wrapEvent(y){return(C,O,j)=>y(K=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>C.call(O,K)):C.call(O,K)},void 0,j)}bufferEvents(y){const C=[];this.buffers.push(C);const O=y();return this.buffers.pop(),C.forEach(j=>j()),O}}t.EventBufferer=x;class I{constructor(){this.listening=!1,this.inputEvent=c.None,this.inputEventListener=D.Disposable.None,this.emitter=new a({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(y){this.inputEvent=y,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=y(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=I}),ne(se[24],ae([0,1,11]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const F=Object.freeze(function(h,l){const s=setTimeout(h.bind(l),0);return{dispose(){clearTimeout(s)}}});var D;(function(h){function l(s){return s===h.None||s===h.Cancelled||s instanceof f?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}h.isCancellationToken=l,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(D||(t.CancellationToken=D={}));class f{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?F:(this._emitter||(this._emitter=new n.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new f),this._token}cancel(){this._token?this._token instanceof f&&this._token.cancel():this._token=D.Cancelled}dispose(l=!1){l&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof f&&this._token.dispose():this._token=D.None}}t.CancellationTokenSource=E}),ne(se[40],ae([0,1,24]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class F{constructor(h){this.task=h,this.result=null}get(){if(this.result)return this.result;const h=new n.CancellationTokenSource,l=this.task(h.token);return this.result={promise:l,dispose:()=>{this.result=null,h.cancel(),h.dispose()}},this.result}}t.Cache=F;class D{constructor(h,l=JSON.stringify){this.fn=h,this._computeKey=l,this.lastCache=void 0,this.lastArgKey=void 0}get(h){const l=this._computeKey(h);return this.lastArgKey!==l&&(this.lastArgKey=l,this.lastCache=this.fn(h)),this.lastCache}}t.LRUCachedFunction=D;class f{get cachedValues(){return this._map}constructor(h){this.fn=h,this._map=new Map}get(h){if(this._map.has(h))return this._map.get(h);const l=this.fn(h);return this._map.set(h,l),l}}t.CachedFunction=f}),ne(se[7],ae([0,1,40,39]),function(W,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.GraphemeBreakType=t.UTF8_BOM_CHARACTER=t.UNUSUAL_LINE_TERMINATORS=t.GraphemeIterator=t.CodePointIterator=void 0,t.isFalsyOrWhitespace=D,t.format=E,t.format2=l,t.htmlAttributeEncodeValue=s,t.escape=c,t.escapeRegExpCharacters=N,t.count=g,t.truncate=m,t.truncateMiddle=e,t.trim=w,t.ltrim=A,t.rtrim=_,t.convertSimple2RegExpPattern=L,t.stripWildcards=p,t.createRegExp=o,t.regExpLeadsToEndlessLoop=a,t.splitLines=i,t.splitLinesIncludeSeparators=u,t.firstNonWhitespaceIndex=b,t.getLeadingWhitespace=d,t.lastNonWhitespaceIndex=v,t.replaceAsync=M,t.compare=R,t.compareSubstring=S,t.compareIgnoreCase=x,t.compareSubstringIgnoreCase=I,t.isAsciiDigit=k,t.isLowerAsciiLetter=y,t.isUpperAsciiLetter=C,t.equalsIgnoreCase=O,t.startsWithIgnoreCase=j,t.commonPrefixLength=K,t.commonSuffixLength=U,t.isHighSurrogate=X,t.isLowSurrogate=G,t.computeCodePoint=P,t.getNextCodePoint=H,t.nextCharLength=r,t.prevCharLength=Le,t.getCharContainingOffset=we,t.charCount=ke,t.containsRTL=Oe,t.isBasicASCII=Se,t.containsUnusualLineTerminators=B,t.isFullWidthCharacter=z,t.isEmojiImprecise=V,t.lcut=Y,t.forAnsiStringParts=J,t.removeAnsiEscapeCodes=Q,t.startsWithUTF8BOM=re,t.stripUTF8BOM=te,t.fuzzyContains=le,t.containsUppercaseCharacter=fe,t.uppercaseFirstLetter=ce,t.getNLines=me,t.singleLetterHash=be,t.getGraphemeBreakType=Fe,t.getLeftDeleteOffset=We;function D(T){return!T||typeof T!="string"?!0:T.trim().length===0}const f=/{(\d+)}/g;function E(T,...q){return q.length===0?T:T.replace(f,function($,Z){const ue=parseInt(Z,10);return isNaN(ue)||ue<0||ue>=q.length?$:q[ue]})}const h=/{([^}]+)}/g;function l(T,q){return Object.keys(q).length===0?T:T.replace(h,($,Z)=>q[Z]??$)}function s(T){return T.replace(/[<>"'&]/g,q=>{switch(q){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return q})}function c(T){return T.replace(/[<>&]/g,function(q){switch(q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return q}})}function N(T){return T.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function g(T,q){let $=0;const Z=q.charCodeAt(0);for(let ue=T.length-1;ue>=0;ue--)T.charCodeAt(ue)===Z&&$++;return $}function m(T,q,$="\u2026"){return T.length<=q?T:`${T.substr(0,q)}${$}`}function e(T,q,$="\u2026"){if(T.length<=q)return T;const Z=Math.ceil(q/2)-$.length/2,ue=Math.floor(q/2)-$.length/2;return`${T.substr(0,Z)}${$}${T.substr(T.length-ue)}`}function w(T,q=" "){const $=A(T,q);return _($,q)}function A(T,q){if(!T||!q)return T;const $=q.length;if($===0||T.length===0)return T;let Z=0;for(;T.indexOf(q,Z)===Z;)Z=Z+$;return T.substring(Z)}function _(T,q){if(!T||!q)return T;const $=q.length,Z=T.length;if($===0||Z===0)return T;let ue=Z,he=-1;for(;he=T.lastIndexOf(q,ue-1),!(he===-1||he+$!==ue);){if(he===0)return"";ue=he}return T.substring(0,ue)}function L(T){return T.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function p(T){return T.replace(/\*/g,"")}function o(T,q,$={}){if(!T)throw new Error("Cannot create regex from empty string");q||(T=N(T)),$.wholeWord&&(/\B/.test(T.charAt(0))||(T="\\b"+T),/\B/.test(T.charAt(T.length-1))||(T=T+"\\b"));let Z="";return $.global&&(Z+="g"),$.matchCase||(Z+="i"),$.multiline&&(Z+="m"),$.unicode&&(Z+="u"),new RegExp(T,Z)}function a(T){return T.source==="^"||T.source==="^$"||T.source==="$"||T.source==="^\\s*$"?!1:!!(T.exec("")&&T.lastIndex===0)}function i(T){return T.split(/\r\n|\r|\n/)}function u(T){const q=[],$=T.split(/(\r\n|\r|\n)/);for(let Z=0;Z<Math.ceil($.length/2);Z++)q.push($[2*Z]+($[2*Z+1]??""));return q}function b(T){for(let q=0,$=T.length;q<$;q++){const Z=T.charCodeAt(q);if(Z!==32&&Z!==9)return q}return-1}function d(T,q=0,$=T.length){for(let Z=q;Z<$;Z++){const ue=T.charCodeAt(Z);if(ue!==32&&ue!==9)return T.substring(q,Z)}return T.substring(q,$)}function v(T,q=T.length-1){for(let $=q;$>=0;$--){const Z=T.charCodeAt($);if(Z!==32&&Z!==9)return $}return-1}function M(T,q,$){const Z=[];let ue=0;for(const he of T.matchAll(q)){if(Z.push(T.slice(ue,he.index)),he.index===void 0)throw new Error("match.index should be defined");ue=he.index+he[0].length,Z.push($(he[0],...he.slice(1),he.index,T,he.groups))}return Z.push(T.slice(ue)),Promise.all(Z).then(he=>he.join(""))}function R(T,q){return T<q?-1:T>q?1:0}function S(T,q,$=0,Z=T.length,ue=0,he=q.length){for(;$<Z&&ue<he;$++,ue++){const Ee=T.charCodeAt($),Ae=q.charCodeAt(ue);if(Ee<Ae)return-1;if(Ee>Ae)return 1}const pe=Z-$,ye=he-ue;return pe<ye?-1:pe>ye?1:0}function x(T,q){return I(T,q,0,T.length,0,q.length)}function I(T,q,$=0,Z=T.length,ue=0,he=q.length){for(;$<Z&&ue<he;$++,ue++){let Ee=T.charCodeAt($),Ae=q.charCodeAt(ue);if(Ee===Ae)continue;if(Ee>=128||Ae>=128)return S(T.toLowerCase(),q.toLowerCase(),$,Z,ue,he);y(Ee)&&(Ee-=32),y(Ae)&&(Ae-=32);const ve=Ee-Ae;if(ve!==0)return ve}const pe=Z-$,ye=he-ue;return pe<ye?-1:pe>ye?1:0}function k(T){return T>=48&&T<=57}function y(T){return T>=97&&T<=122}function C(T){return T>=65&&T<=90}function O(T,q){return T.length===q.length&&I(T,q)===0}function j(T,q){const $=q.length;return q.length>T.length?!1:I(T,q,0,$)===0}function K(T,q){const $=Math.min(T.length,q.length);let Z;for(Z=0;Z<$;Z++)if(T.charCodeAt(Z)!==q.charCodeAt(Z))return Z;return $}function U(T,q){const $=Math.min(T.length,q.length);let Z;const ue=T.length-1,he=q.length-1;for(Z=0;Z<$;Z++)if(T.charCodeAt(ue-Z)!==q.charCodeAt(he-Z))return Z;return $}function X(T){return 55296<=T&&T<=56319}function G(T){return 56320<=T&&T<=57343}function P(T,q){return(T-55296<<10)+(q-56320)+65536}function H(T,q,$){const Z=T.charCodeAt($);if(X(Z)&&$+1<q){const ue=T.charCodeAt($+1);if(G(ue))return P(Z,ue)}return Z}function ie(T,q){const $=T.charCodeAt(q-1);if(G($)&&q>1){const Z=T.charCodeAt(q-2);if(X(Z))return P(Z,$)}return $}class oe{get offset(){return this._offset}constructor(q,$=0){this._str=q,this._len=q.length,this._offset=$}setOffset(q){this._offset=q}prevCodePoint(){const q=ie(this._str,this._offset);return this._offset-=q>=65536?2:1,q}nextCodePoint(){const q=H(this._str,this._len,this._offset);return this._offset+=q>=65536?2:1,q}eol(){return this._offset>=this._len}}t.CodePointIterator=oe;class ge{get offset(){return this._iterator.offset}constructor(q,$=0){this._iterator=new oe(q,$)}nextGraphemeLength(){const q=Ne.getInstance(),$=this._iterator,Z=$.offset;let ue=q.getGraphemeBreakType($.nextCodePoint());for(;!$.eol();){const he=$.offset,pe=q.getGraphemeBreakType($.nextCodePoint());if(xe(ue,pe)){$.setOffset(he);break}ue=pe}return $.offset-Z}prevGraphemeLength(){const q=Ne.getInstance(),$=this._iterator,Z=$.offset;let ue=q.getGraphemeBreakType($.prevCodePoint());for(;$.offset>0;){const he=$.offset,pe=q.getGraphemeBreakType($.prevCodePoint());if(xe(pe,ue)){$.setOffset(he);break}ue=pe}return Z-$.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=ge;function r(T,q){return new ge(T,q).nextGraphemeLength()}function Le(T,q){return new ge(T,q).prevGraphemeLength()}function we(T,q){q>0&&G(T.charCodeAt(q))&&q--;const $=q+r(T,q);return[$-Le(T,$),$]}function ke(T){const q=new ge(T);let $=0;for(;!q.eol();)$++,q.nextGraphemeLength();return $}let _e;function Ce(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Oe(T){return _e||(_e=Ce()),_e.test(T)}const Re=/^[\t\n\r\x20-\x7E]*$/;function Se(T){return Re.test(T)}t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(T){return t.UNUSUAL_LINE_TERMINATORS.test(T)}function z(T){return T>=11904&&T<=55215||T>=63744&&T<=64255||T>=65281&&T<=65374}function V(T){return T>=127462&&T<=127487||T===8986||T===8987||T===9200||T===9203||T>=9728&&T<=10175||T===11088||T===11093||T>=127744&&T<=128591||T>=128640&&T<=128764||T>=128992&&T<=129008||T>=129280&&T<=129535||T>=129648&&T<=129782}function Y(T,q,$=""){const Z=T.trimStart();if(Z.length<q)return Z;const ue=/\b/g;let he=0;for(;ue.test(Z)&&!(Z.length-ue.lastIndex<q);)he=ue.lastIndex,ue.lastIndex+=1;return he===0?Z:$+Z.substring(he).trimStart()}const ee=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*J(T){let q=0;for(const $ of T.matchAll(ee))q!==$.index&&(yield{isCode:!1,str:T.substring(q,$.index)}),yield{isCode:!0,str:$[0]},q=$.index+$[0].length;q!==T.length&&(yield{isCode:!1,str:T.substring(q)})}function Q(T){return T&&(T=T.replace(ee,"")),T}t.UTF8_BOM_CHARACTER="\uFEFF";function re(T){return!!(T&&T.length>0&&T.charCodeAt(0)===65279)}function te(T){return re(T)?T.substr(1):T}function le(T,q){if(!T||!q||T.length<q.length)return!1;const $=q.length,Z=T.toLowerCase();let ue=0,he=-1;for(;ue<$;){const pe=Z.indexOf(q[ue],he+1);if(pe<0)return!1;he=pe,ue++}return!0}function fe(T,q=!1){return T?(q&&(T=T.replace(/\\./g,"")),T.toLowerCase()!==T):!1}function ce(T){return T.charAt(0).toUpperCase()+T.slice(1)}function me(T,q=1){if(q===0)return"";let $=-1;do $=T.indexOf(`
`,$+1),q--;while(q>0&&$>=0);return $===-1?T:(T[$-1]==="\r"&&$--,T.substr(0,$))}function be(T){return T=T%(2*26),T<26?String.fromCharCode(97+T):String.fromCharCode(65+T-26)}function Fe(T){return Ne.getInstance().getGraphemeBreakType(T)}function xe(T,q){return T===0?q!==5&&q!==7:T===2&&q===3?!1:T===4||T===2||T===3||q===4||q===2||q===3?!0:!(T===8&&(q===8||q===9||q===11||q===12)||(T===11||T===9)&&(q===9||q===10)||(T===12||T===10)&&q===10||q===5||q===13||q===7||T===1||T===13&&q===14||T===6&&q===6)}var Pe;(function(T){T[T.Other=0]="Other",T[T.Prepend=1]="Prepend",T[T.CR=2]="CR",T[T.LF=3]="LF",T[T.Control=4]="Control",T[T.Extend=5]="Extend",T[T.Regional_Indicator=6]="Regional_Indicator",T[T.SpacingMark=7]="SpacingMark",T[T.L=8]="L",T[T.V=9]="V",T[T.T=10]="T",T[T.LV=11]="LV",T[T.LVT=12]="LVT",T[T.ZWJ=13]="ZWJ",T[T.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(t.GraphemeBreakType=Pe={}));class Ne{static{this._INSTANCE=null}static getInstance(){return Ne._INSTANCE||(Ne._INSTANCE=new Ne),Ne._INSTANCE}constructor(){this._data=Te()}getGraphemeBreakType(q){if(q<32)return q===10?3:q===13?2:4;if(q<127)return 0;const $=this._data,Z=$.length/3;let ue=1;for(;ue<=Z;)if(q<$[3*ue])ue=2*ue;else if(q>$[3*ue+1])ue=2*ue+1;else return $[3*ue+2];return 0}}function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(T,q){if(T===0)return 0;const $=Ve(T,q);if($!==void 0)return $;const Z=new oe(q,T);return Z.prevCodePoint(),Z.offset}function Ve(T,q){const $=new oe(q,T);let Z=$.prevCodePoint();for(;Ge(Z)||Z===65039||Z===8419;){if($.offset===0)return;Z=$.prevCodePoint()}if(!V(Z))return;let ue=$.offset;return ue>0&&$.prevCodePoint()===8205&&(ue=$.offset),ue}function Ge(T){return 127995<=T&&T<=127999}var He;(function(T){T[T.zwj=8205]="zwj",T[T.emojiVariantSelector=65039]="emojiVariantSelector",T[T.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),t.noBreakWhitespace="\xA0";class Ie{static{this.ambiguousCharacterData=new F.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new n.LRUCachedFunction(q=>{function $(ve){const De=new Map;for(let Me=0;Me<ve.length;Me+=2)De.set(ve[Me],ve[Me+1]);return De}function Z(ve,De){const Me=new Map(ve);for(const[Be,ze]of De)Me.set(Be,ze);return Me}function ue(ve,De){if(!ve)return De;const Me=new Map;for(const[Be,ze]of ve)De.has(Be)&&Me.set(Be,ze);return Me}const he=this.ambiguousCharacterData.value;let pe=q.filter(ve=>!ve.startsWith("_")&&ve in he);pe.length===0&&(pe=["_default"]);let ye;for(const ve of pe){const De=$(he[ve]);ye=ue(ye,De)}const Ee=$(he._common),Ae=Z(Ee,ye);return new Ie(Ae)})}static getInstance(q){return Ie.cache.get(Array.from(q))}static{this._locales=new F.Lazy(()=>Object.keys(Ie.ambiguousCharacterData.value).filter(q=>!q.startsWith("_")))}static getLocales(){return Ie._locales.value}constructor(q){this.confusableDictionary=q}isAmbiguous(q){return this.confusableDictionary.has(q)}getPrimaryConfusable(q){return this.confusableDictionary.get(q)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=Ie;class qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(qe.getRawData())),this._data}static isInvisibleCharacter(q){return qe.getData().has(q)}static get codePoints(){return qe.getData()}}t.InvisibleCharacters=qe}),ne(se[41],ae([0,1,7]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.Hasher=void 0,t.hash=F,t.doHash=D,t.numberHash=f,t.stringHash=h,t.toHexString=w;function F(_){return D(_,0)}function D(_,L){switch(typeof _){case"object":return _===null?f(349,L):Array.isArray(_)?l(_,L):s(_,L);case"string":return h(_,L);case"boolean":return E(_,L);case"number":return f(_,L);case"undefined":return f(937,L);default:return f(617,L)}}function f(_,L){return(L<<5)-L+_|0}function E(_,L){return f(_?433:863,L)}function h(_,L){L=f(149417,L);for(let p=0,o=_.length;p<o;p++)L=f(_.charCodeAt(p),L);return L}function l(_,L){return L=f(104579,L),_.reduce((p,o)=>D(o,p),L)}function s(_,L){return L=f(181387,L),Object.keys(_).sort().reduce((p,o)=>(p=h(o,p),D(_[o],p)),L)}class c{constructor(){this._value=0}get value(){return this._value}hash(L){return this._value=D(L,this._value),this._value}}t.Hasher=c;var N;(function(_){_[_.BLOCK_SIZE=64]="BLOCK_SIZE",_[_.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(N||(N={}));function g(_,L,p=32){const o=p-L,a=~((1<<o)-1);return(_<<L|(a&_)>>>o)>>>0}function m(_,L=0,p=_.byteLength,o=0){for(let a=0;a<p;a++)_[L+a]=o}function e(_,L,p="0"){for(;_.length<L;)_=p+_;return _}function w(_,L=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(p=>p.toString(16).padStart(2,"0")).join(""):e((_>>>0).toString(16),L/4)}class A{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(L){const p=L.length;if(p===0)return;const o=this._buff;let a=this._buffLen,i=this._leftoverHighSurrogate,u,b;for(i!==0?(u=i,b=-1,i=0):(u=L.charCodeAt(0),b=0);;){let d=u;if(n.isHighSurrogate(u))if(b+1<p){const v=L.charCodeAt(b+1);n.isLowSurrogate(v)?(b++,d=n.computeCodePoint(u,v)):d=65533}else{i=u;break}else n.isLowSurrogate(u)&&(d=65533);if(a=this._push(o,a,d),b++,b<p)u=L.charCodeAt(b);else break}this._buffLen=a,this._leftoverHighSurrogate=i}_push(L,p,o){return o<128?L[p++]=o:o<2048?(L[p++]=192|(o&1984)>>>6,L[p++]=128|(o&63)>>>0):o<65536?(L[p++]=224|(o&61440)>>>12,L[p++]=128|(o&4032)>>>6,L[p++]=128|(o&63)>>>0):(L[p++]=240|(o&1835008)>>>18,L[p++]=128|(o&258048)>>>12,L[p++]=128|(o&4032)>>>6,L[p++]=128|(o&63)>>>0),p>=64&&(this._step(),p-=64,this._totalLen+=64,L[0]=L[64],L[1]=L[65],L[2]=L[66]),p}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const L=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(L/4294967296),!1),this._buffDV.setUint32(60,L%4294967296,!1),this._step()}_step(){const L=A._bigBlock32,p=this._buffDV;for(let R=0;R<64;R+=4)L.setUint32(R,p.getUint32(R,!1),!1);for(let R=64;R<320;R+=4)L.setUint32(R,g(L.getUint32(R-12,!1)^L.getUint32(R-32,!1)^L.getUint32(R-56,!1)^L.getUint32(R-64,!1),1),!1);let o=this._h0,a=this._h1,i=this._h2,u=this._h3,b=this._h4,d,v,M;for(let R=0;R<80;R++)R<20?(d=a&i|~a&u,v=1518500249):R<40?(d=a^i^u,v=1859775393):R<60?(d=a&i|a&u|i&u,v=2400959708):(d=a^i^u,v=3395469782),M=g(o,5)+d+b+v+L.getUint32(R*4,!1)&4294967295,b=u,u=i,i=g(a,30),a=o,o=M;this._h0=this._h0+o&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+b&4294967295}}t.StringSHA1=A}),ne(se[25],ae([0,1,37,41]),function(W,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.StringDiffSequence=void 0,t.stringDiff=f;class D{constructor(g){this.source=g}getElements(){const g=this.source,m=new Int32Array(g.length);for(let e=0,w=g.length;e<w;e++)m[e]=g.charCodeAt(e);return m}}t.StringDiffSequence=D;function f(N,g,m){return new c(new D(N),new D(g)).ComputeDiff(m).changes}class E{static Assert(g,m){if(!g)throw new Error(m)}}class h{static Copy(g,m,e,w,A){for(let _=0;_<A;_++)e[w+_]=g[m+_]}static Copy2(g,m,e,w,A){for(let _=0;_<A;_++)e[w+_]=g[m+_]}}var l;(function(N){N[N.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class s{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new n.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(g,m){this.m_originalStart=Math.min(this.m_originalStart,g),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_originalCount++}AddModifiedElement(g,m){this.m_originalStart=Math.min(this.m_originalStart,g),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class c{constructor(g,m,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=g,this._modifiedSequence=m;const[w,A,_]=c._getElements(g),[L,p,o]=c._getElements(m);this._hasStrings=_&&o,this._originalStringElements=w,this._originalElementsOrHash=A,this._modifiedStringElements=L,this._modifiedElementsOrHash=p,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(g){return g.length>0&&typeof g[0]=="string"}static _getElements(g){const m=g.getElements();if(c._isStringArray(m)){const e=new Int32Array(m.length);for(let w=0,A=m.length;w<A;w++)e[w]=(0,F.stringHash)(m[w],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}ElementsAreEqual(g,m){return this._originalElementsOrHash[g]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[g]===this._modifiedStringElements[m]:!0}ElementsAreStrictEqual(g,m){if(!this.ElementsAreEqual(g,m))return!1;const e=c._getStrictElement(this._originalSequence,g),w=c._getStrictElement(this._modifiedSequence,m);return e===w}static _getStrictElement(g,m){return typeof g.getStrictElement=="function"?g.getStrictElement(m):null}OriginalElementsAreEqual(g,m){return this._originalElementsOrHash[g]!==this._originalElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[g]===this._originalStringElements[m]:!0}ModifiedElementsAreEqual(g,m){return this._modifiedElementsOrHash[g]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._modifiedStringElements[g]===this._modifiedStringElements[m]:!0}ComputeDiff(g){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,g)}_ComputeDiff(g,m,e,w,A){const _=[!1];let L=this.ComputeDiffRecursive(g,m,e,w,_);return A&&(L=this.PrettifyChanges(L)),{quitEarly:_[0],changes:L}}ComputeDiffRecursive(g,m,e,w,A){for(A[0]=!1;g<=m&&e<=w&&this.ElementsAreEqual(g,e);)g++,e++;for(;m>=g&&w>=e&&this.ElementsAreEqual(m,w);)m--,w--;if(g>m||e>w){let i;return e<=w?(E.Assert(g===m+1,"originalStart should only be one more than originalEnd"),i=[new n.DiffChange(g,0,e,w-e+1)]):g<=m?(E.Assert(e===w+1,"modifiedStart should only be one more than modifiedEnd"),i=[new n.DiffChange(g,m-g+1,e,0)]):(E.Assert(g===m+1,"originalStart should only be one more than originalEnd"),E.Assert(e===w+1,"modifiedStart should only be one more than modifiedEnd"),i=[]),i}const _=[0],L=[0],p=this.ComputeRecursionPoint(g,m,e,w,_,L,A),o=_[0],a=L[0];if(p!==null)return p;if(!A[0]){const i=this.ComputeDiffRecursive(g,o,e,a,A);let u=[];return A[0]?u=[new n.DiffChange(o+1,m-(o+1)+1,a+1,w-(a+1)+1)]:u=this.ComputeDiffRecursive(o+1,m,a+1,w,A),this.ConcatenateChanges(i,u)}return[new n.DiffChange(g,m-g+1,e,w-e+1)]}WALKTRACE(g,m,e,w,A,_,L,p,o,a,i,u,b,d,v,M,R,S){let x=null,I=null,k=new s,y=m,C=e,O=b[0]-M[0]-w,j=-1073741824,K=this.m_forwardHistory.length-1;do{const U=O+g;U===y||U<C&&o[U-1]<o[U+1]?(i=o[U+1],d=i-O-w,i<j&&k.MarkNextChange(),j=i,k.AddModifiedElement(i+1,d),O=U+1-g):(i=o[U-1]+1,d=i-O-w,i<j&&k.MarkNextChange(),j=i-1,k.AddOriginalElement(i,d+1),O=U-1-g),K>=0&&(o=this.m_forwardHistory[K],g=o[0],y=1,C=o.length-1)}while(--K>=-1);if(x=k.getReverseChanges(),S[0]){let U=b[0]+1,X=M[0]+1;if(x!==null&&x.length>0){const G=x[x.length-1];U=Math.max(U,G.getOriginalEnd()),X=Math.max(X,G.getModifiedEnd())}I=[new n.DiffChange(U,u-U+1,X,v-X+1)]}else{k=new s,y=_,C=L,O=b[0]-M[0]-p,j=1073741824,K=R?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const U=O+A;U===y||U<C&&a[U-1]>=a[U+1]?(i=a[U+1]-1,d=i-O-p,i>j&&k.MarkNextChange(),j=i+1,k.AddOriginalElement(i+1,d+1),O=U+1-A):(i=a[U-1],d=i-O-p,i>j&&k.MarkNextChange(),j=i,k.AddModifiedElement(i+1,d+1),O=U-1-A),K>=0&&(a=this.m_reverseHistory[K],A=a[0],y=1,C=a.length-1)}while(--K>=-1);I=k.getChanges()}return this.ConcatenateChanges(x,I)}ComputeRecursionPoint(g,m,e,w,A,_,L){let p=0,o=0,a=0,i=0,u=0,b=0;g--,e--,A[0]=0,_[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const d=m-g+(w-e),v=d+1,M=new Int32Array(v),R=new Int32Array(v),S=w-e,x=m-g,I=g-e,k=m-w,C=(x-S)%2===0;M[S]=g,R[x]=m,L[0]=!1;for(let O=1;O<=d/2+1;O++){let j=0,K=0;a=this.ClipDiagonalBound(S-O,O,S,v),i=this.ClipDiagonalBound(S+O,O,S,v);for(let X=a;X<=i;X+=2){X===a||X<i&&M[X-1]<M[X+1]?p=M[X+1]:p=M[X-1]+1,o=p-(X-S)-I;const G=p;for(;p<m&&o<w&&this.ElementsAreEqual(p+1,o+1);)p++,o++;if(M[X]=p,p+o>j+K&&(j=p,K=o),!C&&Math.abs(X-x)<=O-1&&p>=R[X])return A[0]=p,_[0]=o,G<=R[X]&&1447>0&&O<=1448?this.WALKTRACE(S,a,i,I,x,u,b,k,M,R,p,m,A,o,w,_,C,L):null}const U=(j-g+(K-e)-O)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(j,U))return L[0]=!0,A[0]=j,_[0]=K,U>0&&1447>0&&O<=1448?this.WALKTRACE(S,a,i,I,x,u,b,k,M,R,p,m,A,o,w,_,C,L):(g++,e++,[new n.DiffChange(g,m-g+1,e,w-e+1)]);u=this.ClipDiagonalBound(x-O,O,x,v),b=this.ClipDiagonalBound(x+O,O,x,v);for(let X=u;X<=b;X+=2){X===u||X<b&&R[X-1]>=R[X+1]?p=R[X+1]-1:p=R[X-1],o=p-(X-x)-k;const G=p;for(;p>g&&o>e&&this.ElementsAreEqual(p,o);)p--,o--;if(R[X]=p,C&&Math.abs(X-S)<=O&&p<=M[X])return A[0]=p,_[0]=o,G>=M[X]&&1447>0&&O<=1448?this.WALKTRACE(S,a,i,I,x,u,b,k,M,R,p,m,A,o,w,_,C,L):null}if(O<=1447){let X=new Int32Array(i-a+2);X[0]=S-a+1,h.Copy2(M,a,X,1,i-a+1),this.m_forwardHistory.push(X),X=new Int32Array(b-u+2),X[0]=x-u+1,h.Copy2(R,u,X,1,b-u+1),this.m_reverseHistory.push(X)}}return this.WALKTRACE(S,a,i,I,x,u,b,k,M,R,p,m,A,o,w,_,C,L)}PrettifyChanges(g){for(let m=0;m<g.length;m++){const e=g[m],w=m<g.length-1?g[m+1].originalStart:this._originalElementsOrHash.length,A=m<g.length-1?g[m+1].modifiedStart:this._modifiedElementsOrHash.length,_=e.originalLength>0,L=e.modifiedLength>0;for(;e.originalStart+e.originalLength<w&&e.modifiedStart+e.modifiedLength<A&&(!_||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!L||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const o=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!o)break;e.originalStart++,e.modifiedStart++}const p=[null];if(m<g.length-1&&this.ChangesOverlap(g[m],g[m+1],p)){g[m]=p[0],g.splice(m+1,1),m--;continue}}for(let m=g.length-1;m>=0;m--){const e=g[m];let w=0,A=0;if(m>0){const i=g[m-1];w=i.originalStart+i.originalLength,A=i.modifiedStart+i.modifiedLength}const _=e.originalLength>0,L=e.modifiedLength>0;let p=0,o=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let i=1;;i++){const u=e.originalStart-i,b=e.modifiedStart-i;if(u<w||b<A||_&&!this.OriginalElementsAreEqual(u,u+e.originalLength)||L&&!this.ModifiedElementsAreEqual(b,b+e.modifiedLength))break;const v=(u===w&&b===A?5:0)+this._boundaryScore(u,e.originalLength,b,e.modifiedLength);v>o&&(o=v,p=i)}e.originalStart-=p,e.modifiedStart-=p;const a=[null];if(m>0&&this.ChangesOverlap(g[m-1],g[m],a)){g[m-1]=a[0],g.splice(m,1),m++;continue}}if(this._hasStrings)for(let m=1,e=g.length;m<e;m++){const w=g[m-1],A=g[m],_=A.originalStart-w.originalStart-w.originalLength,L=w.originalStart,p=A.originalStart+A.originalLength,o=p-L,a=w.modifiedStart,i=A.modifiedStart+A.modifiedLength,u=i-a;if(_<5&&o<20&&u<20){const b=this._findBetterContiguousSequence(L,o,a,u,_);if(b){const[d,v]=b;(d!==w.originalStart+w.originalLength||v!==w.modifiedStart+w.modifiedLength)&&(w.originalLength=d-w.originalStart,w.modifiedLength=v-w.modifiedStart,A.originalStart=d+_,A.modifiedStart=v+_,A.originalLength=p-A.originalStart,A.modifiedLength=i-A.modifiedStart)}}}return g}_findBetterContiguousSequence(g,m,e,w,A){if(m<A||w<A)return null;const _=g+m-A+1,L=e+w-A+1;let p=0,o=0,a=0;for(let i=g;i<_;i++)for(let u=e;u<L;u++){const b=this._contiguousSequenceScore(i,u,A);b>0&&b>p&&(p=b,o=i,a=u)}return p>0?[o,a]:null}_contiguousSequenceScore(g,m,e){let w=0;for(let A=0;A<e;A++){if(!this.ElementsAreEqual(g+A,m+A))return 0;w+=this._originalStringElements[g+A].length}return w}_OriginalIsBoundary(g){return g<=0||g>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[g])}_OriginalRegionIsBoundary(g,m){if(this._OriginalIsBoundary(g)||this._OriginalIsBoundary(g-1))return!0;if(m>0){const e=g+m;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(g){return g<=0||g>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[g])}_ModifiedRegionIsBoundary(g,m){if(this._ModifiedIsBoundary(g)||this._ModifiedIsBoundary(g-1))return!0;if(m>0){const e=g+m;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(g,m,e,w){const A=this._OriginalRegionIsBoundary(g,m)?1:0,_=this._ModifiedRegionIsBoundary(e,w)?1:0;return A+_}ConcatenateChanges(g,m){const e=[];if(g.length===0||m.length===0)return m.length>0?m:g;if(this.ChangesOverlap(g[g.length-1],m[0],e)){const w=new Array(g.length+m.length-1);return h.Copy(g,0,w,0,g.length-1),w[g.length-1]=e[0],h.Copy(m,1,w,g.length,m.length-1),w}else{const w=new Array(g.length+m.length);return h.Copy(g,0,w,0,g.length),h.Copy(m,0,w,g.length,m.length),w}}ChangesOverlap(g,m,e){if(E.Assert(g.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),E.Assert(g.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),g.originalStart+g.originalLength>=m.originalStart||g.modifiedStart+g.modifiedLength>=m.modifiedStart){const w=g.originalStart;let A=g.originalLength;const _=g.modifiedStart;let L=g.modifiedLength;return g.originalStart+g.originalLength>=m.originalStart&&(A=m.originalStart+m.originalLength-g.originalStart),g.modifiedStart+g.modifiedLength>=m.modifiedStart&&(L=m.modifiedStart+m.modifiedLength-g.modifiedStart),e[0]=new n.DiffChange(w,A,_,L),!0}else return e[0]=null,!1}ClipDiagonalBound(g,m,e,w){if(g>=0&&g<w)return g;const A=e,_=w-e-1,L=m%2===0;if(g<0){const p=A%2===0;return L===p?0:1}else{const p=_%2===0;return L===p?w-1:w-2}}}t.LcsDiff=c}),ne(se[26],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isString=n,t.isStringArray=F,t.isObject=D,t.isTypedArray=f,t.isNumber=E,t.isIterable=h,t.isBoolean=l,t.isUndefined=s,t.isDefined=c,t.isUndefinedOrNull=N,t.assertType=g,t.assertIsDefined=m,t.assertAllDefined=e,t.isEmptyObject=A,t.isFunction=_,t.areFunctions=L,t.validateConstraints=p,t.validateConstraint=o;function n(a){return typeof a=="string"}function F(a){return Array.isArray(a)&&a.every(i=>n(i))}function D(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function f(a){const i=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof i}function E(a){return typeof a=="number"&&!isNaN(a)}function h(a){return!!a&&typeof a[Symbol.iterator]=="function"}function l(a){return a===!0||a===!1}function s(a){return typeof a>"u"}function c(a){return!N(a)}function N(a){return s(a)||a===null}function g(a,i){if(!a)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function m(a){if(N(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function e(...a){const i=[];for(let u=0;u<a.length;u++){const b=a[u];if(N(b))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);i.push(b)}return i}const w=Object.prototype.hasOwnProperty;function A(a){if(!D(a))return!1;for(const i in a)if(w.call(a,i))return!1;return!0}function _(a){return typeof a=="function"}function L(...a){return a.length>0&&a.every(_)}function p(a,i){const u=Math.min(a.length,i.length);for(let b=0;b<u;b++)o(a[b],i[b])}function o(a,i){if(n(i)){if(typeof a!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(_(i)){try{if(a instanceof i)return}catch{}if(!N(a)&&a.constructor===i||i.length===1&&i.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),ne(se[27],ae([0,1,26]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.register=D,t.getCodiconFontCharacters=f;const F=Object.create(null);function D(E,h){if((0,n.isString)(h)){const l=F[h];if(l===void 0)throw new Error(`${E} references an unknown codicon: ${h}`);h=l}return F[E]=h,{id:E}}function f(){return F}}),ne(se[42],ae([0,1,27]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.codiconsLibrary=void 0,t.codiconsLibrary={add:(0,n.register)("add",6e4),plus:(0,n.register)("plus",6e4),gistNew:(0,n.register)("gist-new",6e4),repoCreate:(0,n.register)("repo-create",6e4),lightbulb:(0,n.register)("lightbulb",60001),lightBulb:(0,n.register)("light-bulb",60001),repo:(0,n.register)("repo",60002),repoDelete:(0,n.register)("repo-delete",60002),gistFork:(0,n.register)("gist-fork",60003),repoForked:(0,n.register)("repo-forked",60003),gitPullRequest:(0,n.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.register)("git-pull-request-abandoned",60004),recordKeys:(0,n.register)("record-keys",60005),keyboard:(0,n.register)("keyboard",60005),tag:(0,n.register)("tag",60006),gitPullRequestLabel:(0,n.register)("git-pull-request-label",60006),tagAdd:(0,n.register)("tag-add",60006),tagRemove:(0,n.register)("tag-remove",60006),person:(0,n.register)("person",60007),personFollow:(0,n.register)("person-follow",60007),personOutline:(0,n.register)("person-outline",60007),personFilled:(0,n.register)("person-filled",60007),gitBranch:(0,n.register)("git-branch",60008),gitBranchCreate:(0,n.register)("git-branch-create",60008),gitBranchDelete:(0,n.register)("git-branch-delete",60008),sourceControl:(0,n.register)("source-control",60008),mirror:(0,n.register)("mirror",60009),mirrorPublic:(0,n.register)("mirror-public",60009),star:(0,n.register)("star",60010),starAdd:(0,n.register)("star-add",60010),starDelete:(0,n.register)("star-delete",60010),starEmpty:(0,n.register)("star-empty",60010),comment:(0,n.register)("comment",60011),commentAdd:(0,n.register)("comment-add",60011),alert:(0,n.register)("alert",60012),warning:(0,n.register)("warning",60012),search:(0,n.register)("search",60013),searchSave:(0,n.register)("search-save",60013),logOut:(0,n.register)("log-out",60014),signOut:(0,n.register)("sign-out",60014),logIn:(0,n.register)("log-in",60015),signIn:(0,n.register)("sign-in",60015),eye:(0,n.register)("eye",60016),eyeUnwatch:(0,n.register)("eye-unwatch",60016),eyeWatch:(0,n.register)("eye-watch",60016),circleFilled:(0,n.register)("circle-filled",60017),primitiveDot:(0,n.register)("primitive-dot",60017),closeDirty:(0,n.register)("close-dirty",60017),debugBreakpoint:(0,n.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.register)("debug-breakpoint-disabled",60017),debugHint:(0,n.register)("debug-hint",60017),terminalDecorationSuccess:(0,n.register)("terminal-decoration-success",60017),primitiveSquare:(0,n.register)("primitive-square",60018),edit:(0,n.register)("edit",60019),pencil:(0,n.register)("pencil",60019),info:(0,n.register)("info",60020),issueOpened:(0,n.register)("issue-opened",60020),gistPrivate:(0,n.register)("gist-private",60021),gitForkPrivate:(0,n.register)("git-fork-private",60021),lock:(0,n.register)("lock",60021),mirrorPrivate:(0,n.register)("mirror-private",60021),close:(0,n.register)("close",60022),removeClose:(0,n.register)("remove-close",60022),x:(0,n.register)("x",60022),repoSync:(0,n.register)("repo-sync",60023),sync:(0,n.register)("sync",60023),clone:(0,n.register)("clone",60024),desktopDownload:(0,n.register)("desktop-download",60024),beaker:(0,n.register)("beaker",60025),microscope:(0,n.register)("microscope",60025),vm:(0,n.register)("vm",60026),deviceDesktop:(0,n.register)("device-desktop",60026),file:(0,n.register)("file",60027),fileText:(0,n.register)("file-text",60027),more:(0,n.register)("more",60028),ellipsis:(0,n.register)("ellipsis",60028),kebabHorizontal:(0,n.register)("kebab-horizontal",60028),mailReply:(0,n.register)("mail-reply",60029),reply:(0,n.register)("reply",60029),organization:(0,n.register)("organization",60030),organizationFilled:(0,n.register)("organization-filled",60030),organizationOutline:(0,n.register)("organization-outline",60030),newFile:(0,n.register)("new-file",60031),fileAdd:(0,n.register)("file-add",60031),newFolder:(0,n.register)("new-folder",60032),fileDirectoryCreate:(0,n.register)("file-directory-create",60032),trash:(0,n.register)("trash",60033),trashcan:(0,n.register)("trashcan",60033),history:(0,n.register)("history",60034),clock:(0,n.register)("clock",60034),folder:(0,n.register)("folder",60035),fileDirectory:(0,n.register)("file-directory",60035),symbolFolder:(0,n.register)("symbol-folder",60035),logoGithub:(0,n.register)("logo-github",60036),markGithub:(0,n.register)("mark-github",60036),github:(0,n.register)("github",60036),terminal:(0,n.register)("terminal",60037),console:(0,n.register)("console",60037),repl:(0,n.register)("repl",60037),zap:(0,n.register)("zap",60038),symbolEvent:(0,n.register)("symbol-event",60038),error:(0,n.register)("error",60039),stop:(0,n.register)("stop",60039),variable:(0,n.register)("variable",60040),symbolVariable:(0,n.register)("symbol-variable",60040),array:(0,n.register)("array",60042),symbolArray:(0,n.register)("symbol-array",60042),symbolModule:(0,n.register)("symbol-module",60043),symbolPackage:(0,n.register)("symbol-package",60043),symbolNamespace:(0,n.register)("symbol-namespace",60043),symbolObject:(0,n.register)("symbol-object",60043),symbolMethod:(0,n.register)("symbol-method",60044),symbolFunction:(0,n.register)("symbol-function",60044),symbolConstructor:(0,n.register)("symbol-constructor",60044),symbolBoolean:(0,n.register)("symbol-boolean",60047),symbolNull:(0,n.register)("symbol-null",60047),symbolNumeric:(0,n.register)("symbol-numeric",60048),symbolNumber:(0,n.register)("symbol-number",60048),symbolStructure:(0,n.register)("symbol-structure",60049),symbolStruct:(0,n.register)("symbol-struct",60049),symbolParameter:(0,n.register)("symbol-parameter",60050),symbolTypeParameter:(0,n.register)("symbol-type-parameter",60050),symbolKey:(0,n.register)("symbol-key",60051),symbolText:(0,n.register)("symbol-text",60051),symbolReference:(0,n.register)("symbol-reference",60052),goToFile:(0,n.register)("go-to-file",60052),symbolEnum:(0,n.register)("symbol-enum",60053),symbolValue:(0,n.register)("symbol-value",60053),symbolRuler:(0,n.register)("symbol-ruler",60054),symbolUnit:(0,n.register)("symbol-unit",60054),activateBreakpoints:(0,n.register)("activate-breakpoints",60055),archive:(0,n.register)("archive",60056),arrowBoth:(0,n.register)("arrow-both",60057),arrowDown:(0,n.register)("arrow-down",60058),arrowLeft:(0,n.register)("arrow-left",60059),arrowRight:(0,n.register)("arrow-right",60060),arrowSmallDown:(0,n.register)("arrow-small-down",60061),arrowSmallLeft:(0,n.register)("arrow-small-left",60062),arrowSmallRight:(0,n.register)("arrow-small-right",60063),arrowSmallUp:(0,n.register)("arrow-small-up",60064),arrowUp:(0,n.register)("arrow-up",60065),bell:(0,n.register)("bell",60066),bold:(0,n.register)("bold",60067),book:(0,n.register)("book",60068),bookmark:(0,n.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.register)("briefcase",60076),broadcast:(0,n.register)("broadcast",60077),browser:(0,n.register)("browser",60078),bug:(0,n.register)("bug",60079),calendar:(0,n.register)("calendar",60080),caseSensitive:(0,n.register)("case-sensitive",60081),check:(0,n.register)("check",60082),checklist:(0,n.register)("checklist",60083),chevronDown:(0,n.register)("chevron-down",60084),chevronLeft:(0,n.register)("chevron-left",60085),chevronRight:(0,n.register)("chevron-right",60086),chevronUp:(0,n.register)("chevron-up",60087),chromeClose:(0,n.register)("chrome-close",60088),chromeMaximize:(0,n.register)("chrome-maximize",60089),chromeMinimize:(0,n.register)("chrome-minimize",60090),chromeRestore:(0,n.register)("chrome-restore",60091),circleOutline:(0,n.register)("circle-outline",60092),circle:(0,n.register)("circle",60092),debugBreakpointUnverified:(0,n.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.register)("terminal-decoration-incomplete",60092),circleSlash:(0,n.register)("circle-slash",60093),circuitBoard:(0,n.register)("circuit-board",60094),clearAll:(0,n.register)("clear-all",60095),clippy:(0,n.register)("clippy",60096),closeAll:(0,n.register)("close-all",60097),cloudDownload:(0,n.register)("cloud-download",60098),cloudUpload:(0,n.register)("cloud-upload",60099),code:(0,n.register)("code",60100),collapseAll:(0,n.register)("collapse-all",60101),colorMode:(0,n.register)("color-mode",60102),commentDiscussion:(0,n.register)("comment-discussion",60103),creditCard:(0,n.register)("credit-card",60105),dash:(0,n.register)("dash",60108),dashboard:(0,n.register)("dashboard",60109),database:(0,n.register)("database",60110),debugContinue:(0,n.register)("debug-continue",60111),debugDisconnect:(0,n.register)("debug-disconnect",60112),debugPause:(0,n.register)("debug-pause",60113),debugRestart:(0,n.register)("debug-restart",60114),debugStart:(0,n.register)("debug-start",60115),debugStepInto:(0,n.register)("debug-step-into",60116),debugStepOut:(0,n.register)("debug-step-out",60117),debugStepOver:(0,n.register)("debug-step-over",60118),debugStop:(0,n.register)("debug-stop",60119),debug:(0,n.register)("debug",60120),deviceCameraVideo:(0,n.register)("device-camera-video",60121),deviceCamera:(0,n.register)("device-camera",60122),deviceMobile:(0,n.register)("device-mobile",60123),diffAdded:(0,n.register)("diff-added",60124),diffIgnored:(0,n.register)("diff-ignored",60125),diffModified:(0,n.register)("diff-modified",60126),diffRemoved:(0,n.register)("diff-removed",60127),diffRenamed:(0,n.register)("diff-renamed",60128),diff:(0,n.register)("diff",60129),diffSidebyside:(0,n.register)("diff-sidebyside",60129),discard:(0,n.register)("discard",60130),editorLayout:(0,n.register)("editor-layout",60131),emptyWindow:(0,n.register)("empty-window",60132),exclude:(0,n.register)("exclude",60133),extensions:(0,n.register)("extensions",60134),eyeClosed:(0,n.register)("eye-closed",60135),fileBinary:(0,n.register)("file-binary",60136),fileCode:(0,n.register)("file-code",60137),fileMedia:(0,n.register)("file-media",60138),filePdf:(0,n.register)("file-pdf",60139),fileSubmodule:(0,n.register)("file-submodule",60140),fileSymlinkDirectory:(0,n.register)("file-symlink-directory",60141),fileSymlinkFile:(0,n.register)("file-symlink-file",60142),fileZip:(0,n.register)("file-zip",60143),files:(0,n.register)("files",60144),filter:(0,n.register)("filter",60145),flame:(0,n.register)("flame",60146),foldDown:(0,n.register)("fold-down",60147),foldUp:(0,n.register)("fold-up",60148),fold:(0,n.register)("fold",60149),folderActive:(0,n.register)("folder-active",60150),folderOpened:(0,n.register)("folder-opened",60151),gear:(0,n.register)("gear",60152),gift:(0,n.register)("gift",60153),gistSecret:(0,n.register)("gist-secret",60154),gist:(0,n.register)("gist",60155),gitCommit:(0,n.register)("git-commit",60156),gitCompare:(0,n.register)("git-compare",60157),compareChanges:(0,n.register)("compare-changes",60157),gitMerge:(0,n.register)("git-merge",60158),githubAction:(0,n.register)("github-action",60159),githubAlt:(0,n.register)("github-alt",60160),globe:(0,n.register)("globe",60161),grabber:(0,n.register)("grabber",60162),graph:(0,n.register)("graph",60163),gripper:(0,n.register)("gripper",60164),heart:(0,n.register)("heart",60165),home:(0,n.register)("home",60166),horizontalRule:(0,n.register)("horizontal-rule",60167),hubot:(0,n.register)("hubot",60168),inbox:(0,n.register)("inbox",60169),issueReopened:(0,n.register)("issue-reopened",60171),issues:(0,n.register)("issues",60172),italic:(0,n.register)("italic",60173),jersey:(0,n.register)("jersey",60174),json:(0,n.register)("json",60175),kebabVertical:(0,n.register)("kebab-vertical",60176),key:(0,n.register)("key",60177),law:(0,n.register)("law",60178),lightbulbAutofix:(0,n.register)("lightbulb-autofix",60179),linkExternal:(0,n.register)("link-external",60180),link:(0,n.register)("link",60181),listOrdered:(0,n.register)("list-ordered",60182),listUnordered:(0,n.register)("list-unordered",60183),liveShare:(0,n.register)("live-share",60184),loading:(0,n.register)("loading",60185),location:(0,n.register)("location",60186),mailRead:(0,n.register)("mail-read",60187),mail:(0,n.register)("mail",60188),markdown:(0,n.register)("markdown",60189),megaphone:(0,n.register)("megaphone",60190),mention:(0,n.register)("mention",60191),milestone:(0,n.register)("milestone",60192),gitPullRequestMilestone:(0,n.register)("git-pull-request-milestone",60192),mortarBoard:(0,n.register)("mortar-board",60193),move:(0,n.register)("move",60194),multipleWindows:(0,n.register)("multiple-windows",60195),mute:(0,n.register)("mute",60196),noNewline:(0,n.register)("no-newline",60197),note:(0,n.register)("note",60198),octoface:(0,n.register)("octoface",60199),openPreview:(0,n.register)("open-preview",60200),package:(0,n.register)("package",60201),paintcan:(0,n.register)("paintcan",60202),pin:(0,n.register)("pin",60203),play:(0,n.register)("play",60204),run:(0,n.register)("run",60204),plug:(0,n.register)("plug",60205),preserveCase:(0,n.register)("preserve-case",60206),preview:(0,n.register)("preview",60207),project:(0,n.register)("project",60208),pulse:(0,n.register)("pulse",60209),question:(0,n.register)("question",60210),quote:(0,n.register)("quote",60211),radioTower:(0,n.register)("radio-tower",60212),reactions:(0,n.register)("reactions",60213),references:(0,n.register)("references",60214),refresh:(0,n.register)("refresh",60215),regex:(0,n.register)("regex",60216),remoteExplorer:(0,n.register)("remote-explorer",60217),remote:(0,n.register)("remote",60218),remove:(0,n.register)("remove",60219),replaceAll:(0,n.register)("replace-all",60220),replace:(0,n.register)("replace",60221),repoClone:(0,n.register)("repo-clone",60222),repoForcePush:(0,n.register)("repo-force-push",60223),repoPull:(0,n.register)("repo-pull",60224),repoPush:(0,n.register)("repo-push",60225),report:(0,n.register)("report",60226),requestChanges:(0,n.register)("request-changes",60227),rocket:(0,n.register)("rocket",60228),rootFolderOpened:(0,n.register)("root-folder-opened",60229),rootFolder:(0,n.register)("root-folder",60230),rss:(0,n.register)("rss",60231),ruby:(0,n.register)("ruby",60232),saveAll:(0,n.register)("save-all",60233),saveAs:(0,n.register)("save-as",60234),save:(0,n.register)("save",60235),screenFull:(0,n.register)("screen-full",60236),screenNormal:(0,n.register)("screen-normal",60237),searchStop:(0,n.register)("search-stop",60238),server:(0,n.register)("server",60240),settingsGear:(0,n.register)("settings-gear",60241),settings:(0,n.register)("settings",60242),shield:(0,n.register)("shield",60243),smiley:(0,n.register)("smiley",60244),sortPrecedence:(0,n.register)("sort-precedence",60245),splitHorizontal:(0,n.register)("split-horizontal",60246),splitVertical:(0,n.register)("split-vertical",60247),squirrel:(0,n.register)("squirrel",60248),starFull:(0,n.register)("star-full",60249),starHalf:(0,n.register)("star-half",60250),symbolClass:(0,n.register)("symbol-class",60251),symbolColor:(0,n.register)("symbol-color",60252),symbolConstant:(0,n.register)("symbol-constant",60253),symbolEnumMember:(0,n.register)("symbol-enum-member",60254),symbolField:(0,n.register)("symbol-field",60255),symbolFile:(0,n.register)("symbol-file",60256),symbolInterface:(0,n.register)("symbol-interface",60257),symbolKeyword:(0,n.register)("symbol-keyword",60258),symbolMisc:(0,n.register)("symbol-misc",60259),symbolOperator:(0,n.register)("symbol-operator",60260),symbolProperty:(0,n.register)("symbol-property",60261),wrench:(0,n.register)("wrench",60261),wrenchSubaction:(0,n.register)("wrench-subaction",60261),symbolSnippet:(0,n.register)("symbol-snippet",60262),tasklist:(0,n.register)("tasklist",60263),telescope:(0,n.register)("telescope",60264),textSize:(0,n.register)("text-size",60265),threeBars:(0,n.register)("three-bars",60266),thumbsdown:(0,n.register)("thumbsdown",60267),thumbsup:(0,n.register)("thumbsup",60268),tools:(0,n.register)("tools",60269),triangleDown:(0,n.register)("triangle-down",60270),triangleLeft:(0,n.register)("triangle-left",60271),triangleRight:(0,n.register)("triangle-right",60272),triangleUp:(0,n.register)("triangle-up",60273),twitter:(0,n.register)("twitter",60274),unfold:(0,n.register)("unfold",60275),unlock:(0,n.register)("unlock",60276),unmute:(0,n.register)("unmute",60277),unverified:(0,n.register)("unverified",60278),verified:(0,n.register)("verified",60279),versions:(0,n.register)("versions",60280),vmActive:(0,n.register)("vm-active",60281),vmOutline:(0,n.register)("vm-outline",60282),vmRunning:(0,n.register)("vm-running",60283),watch:(0,n.register)("watch",60284),whitespace:(0,n.register)("whitespace",60285),wholeWord:(0,n.register)("whole-word",60286),window:(0,n.register)("window",60287),wordWrap:(0,n.register)("word-wrap",60288),zoomIn:(0,n.register)("zoom-in",60289),zoomOut:(0,n.register)("zoom-out",60290),listFilter:(0,n.register)("list-filter",60291),listFlat:(0,n.register)("list-flat",60292),listSelection:(0,n.register)("list-selection",60293),selection:(0,n.register)("selection",60293),listTree:(0,n.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.register)("debug-stackframe-active",60297),circleSmallFilled:(0,n.register)("circle-small-filled",60298),debugStackframeDot:(0,n.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.register)("terminal-decoration-mark",60298),debugStackframe:(0,n.register)("debug-stackframe",60299),debugStackframeFocused:(0,n.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.register)("debug-breakpoint-unsupported",60300),symbolString:(0,n.register)("symbol-string",60301),debugReverseContinue:(0,n.register)("debug-reverse-continue",60302),debugStepBack:(0,n.register)("debug-step-back",60303),debugRestartFrame:(0,n.register)("debug-restart-frame",60304),debugAlt:(0,n.register)("debug-alt",60305),callIncoming:(0,n.register)("call-incoming",60306),callOutgoing:(0,n.register)("call-outgoing",60307),menu:(0,n.register)("menu",60308),expandAll:(0,n.register)("expand-all",60309),feedback:(0,n.register)("feedback",60310),gitPullRequestReviewer:(0,n.register)("git-pull-request-reviewer",60310),groupByRefType:(0,n.register)("group-by-ref-type",60311),ungroupByRefType:(0,n.register)("ungroup-by-ref-type",60312),account:(0,n.register)("account",60313),gitPullRequestAssignee:(0,n.register)("git-pull-request-assignee",60313),bellDot:(0,n.register)("bell-dot",60314),debugConsole:(0,n.register)("debug-console",60315),library:(0,n.register)("library",60316),output:(0,n.register)("output",60317),runAll:(0,n.register)("run-all",60318),syncIgnored:(0,n.register)("sync-ignored",60319),pinned:(0,n.register)("pinned",60320),githubInverted:(0,n.register)("github-inverted",60321),serverProcess:(0,n.register)("server-process",60322),serverEnvironment:(0,n.register)("server-environment",60323),pass:(0,n.register)("pass",60324),issueClosed:(0,n.register)("issue-closed",60324),stopCircle:(0,n.register)("stop-circle",60325),playCircle:(0,n.register)("play-circle",60326),record:(0,n.register)("record",60327),debugAltSmall:(0,n.register)("debug-alt-small",60328),vmConnect:(0,n.register)("vm-connect",60329),cloud:(0,n.register)("cloud",60330),merge:(0,n.register)("merge",60331),export:(0,n.register)("export",60332),graphLeft:(0,n.register)("graph-left",60333),magnet:(0,n.register)("magnet",60334),notebook:(0,n.register)("notebook",60335),redo:(0,n.register)("redo",60336),checkAll:(0,n.register)("check-all",60337),pinnedDirty:(0,n.register)("pinned-dirty",60338),passFilled:(0,n.register)("pass-filled",60339),circleLargeFilled:(0,n.register)("circle-large-filled",60340),circleLarge:(0,n.register)("circle-large",60341),circleLargeOutline:(0,n.register)("circle-large-outline",60341),combine:(0,n.register)("combine",60342),gather:(0,n.register)("gather",60342),table:(0,n.register)("table",60343),variableGroup:(0,n.register)("variable-group",60344),typeHierarchy:(0,n.register)("type-hierarchy",60345),typeHierarchySub:(0,n.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.register)("git-pull-request-create",60348),runAbove:(0,n.register)("run-above",60349),runBelow:(0,n.register)("run-below",60350),notebookTemplate:(0,n.register)("notebook-template",60351),debugRerun:(0,n.register)("debug-rerun",60352),workspaceTrusted:(0,n.register)("workspace-trusted",60353),workspaceUntrusted:(0,n.register)("workspace-untrusted",60354),workspaceUnknown:(0,n.register)("workspace-unknown",60355),terminalCmd:(0,n.register)("terminal-cmd",60356),terminalDebian:(0,n.register)("terminal-debian",60357),terminalLinux:(0,n.register)("terminal-linux",60358),terminalPowershell:(0,n.register)("terminal-powershell",60359),terminalTmux:(0,n.register)("terminal-tmux",60360),terminalUbuntu:(0,n.register)("terminal-ubuntu",60361),terminalBash:(0,n.register)("terminal-bash",60362),arrowSwap:(0,n.register)("arrow-swap",60363),copy:(0,n.register)("copy",60364),personAdd:(0,n.register)("person-add",60365),filterFilled:(0,n.register)("filter-filled",60366),wand:(0,n.register)("wand",60367),debugLineByLine:(0,n.register)("debug-line-by-line",60368),inspect:(0,n.register)("inspect",60369),layers:(0,n.register)("layers",60370),layersDot:(0,n.register)("layers-dot",60371),layersActive:(0,n.register)("layers-active",60372),compass:(0,n.register)("compass",60373),compassDot:(0,n.register)("compass-dot",60374),compassActive:(0,n.register)("compass-active",60375),azure:(0,n.register)("azure",60376),issueDraft:(0,n.register)("issue-draft",60377),gitPullRequestClosed:(0,n.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.register)("git-pull-request-draft",60379),debugAll:(0,n.register)("debug-all",60380),debugCoverage:(0,n.register)("debug-coverage",60381),runErrors:(0,n.register)("run-errors",60382),folderLibrary:(0,n.register)("folder-library",60383),debugContinueSmall:(0,n.register)("debug-continue-small",60384),beakerStop:(0,n.register)("beaker-stop",60385),graphLine:(0,n.register)("graph-line",60386),graphScatter:(0,n.register)("graph-scatter",60387),pieChart:(0,n.register)("pie-chart",60388),bracket:(0,n.register)("bracket",60175),bracketDot:(0,n.register)("bracket-dot",60389),bracketError:(0,n.register)("bracket-error",60390),lockSmall:(0,n.register)("lock-small",60391),azureDevops:(0,n.register)("azure-devops",60392),verifiedFilled:(0,n.register)("verified-filled",60393),newline:(0,n.register)("newline",60394),layout:(0,n.register)("layout",60395),layoutActivitybarLeft:(0,n.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.register)("layout-panel-left",60398),layoutPanelCenter:(0,n.register)("layout-panel-center",60399),layoutPanelJustify:(0,n.register)("layout-panel-justify",60400),layoutPanelRight:(0,n.register)("layout-panel-right",60401),layoutPanel:(0,n.register)("layout-panel",60402),layoutSidebarLeft:(0,n.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.register)("layout-sidebar-right",60404),layoutStatusbar:(0,n.register)("layout-statusbar",60405),layoutMenubar:(0,n.register)("layout-menubar",60406),layoutCentered:(0,n.register)("layout-centered",60407),target:(0,n.register)("target",60408),indent:(0,n.register)("indent",60409),recordSmall:(0,n.register)("record-small",60410),errorSmall:(0,n.register)("error-small",60411),terminalDecorationError:(0,n.register)("terminal-decoration-error",60411),arrowCircleDown:(0,n.register)("arrow-circle-down",60412),arrowCircleLeft:(0,n.register)("arrow-circle-left",60413),arrowCircleRight:(0,n.register)("arrow-circle-right",60414),arrowCircleUp:(0,n.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.register)("layout-sidebar-left-off",60418),blank:(0,n.register)("blank",60419),heartFilled:(0,n.register)("heart-filled",60420),map:(0,n.register)("map",60421),mapHorizontal:(0,n.register)("map-horizontal",60421),foldHorizontal:(0,n.register)("fold-horizontal",60421),mapFilled:(0,n.register)("map-filled",60422),mapHorizontalFilled:(0,n.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.register)("fold-horizontal-filled",60422),circleSmall:(0,n.register)("circle-small",60423),bellSlash:(0,n.register)("bell-slash",60424),bellSlashDot:(0,n.register)("bell-slash-dot",60425),commentUnresolved:(0,n.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.register)("search-fuzzy",60429),commentDraft:(0,n.register)("comment-draft",60430),send:(0,n.register)("send",60431),sparkle:(0,n.register)("sparkle",60432),insert:(0,n.register)("insert",60433),mic:(0,n.register)("mic",60434),thumbsdownFilled:(0,n.register)("thumbsdown-filled",60435),thumbsupFilled:(0,n.register)("thumbsup-filled",60436),coffee:(0,n.register)("coffee",60437),snake:(0,n.register)("snake",60438),game:(0,n.register)("game",60439),vr:(0,n.register)("vr",60440),chip:(0,n.register)("chip",60441),piano:(0,n.register)("piano",60442),music:(0,n.register)("music",60443),micFilled:(0,n.register)("mic-filled",60444),repoFetch:(0,n.register)("repo-fetch",60445),copilot:(0,n.register)("copilot",60446),lightbulbSparkle:(0,n.register)("lightbulb-sparkle",60447),robot:(0,n.register)("robot",60448),sparkleFilled:(0,n.register)("sparkle-filled",60449),diffSingle:(0,n.register)("diff-single",60450),diffMultiple:(0,n.register)("diff-multiple",60451),surroundWith:(0,n.register)("surround-with",60452),share:(0,n.register)("share",60453),gitStash:(0,n.register)("git-stash",60454),gitStashApply:(0,n.register)("git-stash-apply",60455),gitStashPop:(0,n.register)("git-stash-pop",60456),vscode:(0,n.register)("vscode",60457),vscodeInsiders:(0,n.register)("vscode-insiders",60458),codeOss:(0,n.register)("code-oss",60459),runCoverage:(0,n.register)("run-coverage",60460),runAllCoverage:(0,n.register)("run-all-coverage",60461),coverage:(0,n.register)("coverage",60462),githubProject:(0,n.register)("github-project",60463),mapVertical:(0,n.register)("map-vertical",60464),foldVertical:(0,n.register)("fold-vertical",60464),mapVerticalFilled:(0,n.register)("map-vertical-filled",60465),foldVerticalFilled:(0,n.register)("fold-vertical-filled",60465)}}),ne(se[43],ae([0,1,27,42]),function(W,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.codiconsDerived=void 0,t.getAllCodicons=D;function D(){return Object.values(t.Codicon)}t.codiconsDerived={dialogError:(0,n.register)("dialog-error","error"),dialogWarning:(0,n.register)("dialog-warning","warning"),dialogInfo:(0,n.register)("dialog-info","info"),dialogClose:(0,n.register)("dialog-close","close"),treeItemExpanded:(0,n.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.register)("tree-filter-clear","close"),treeItemLoading:(0,n.register)("tree-item-loading","loading"),menuSelection:(0,n.register)("menu-selection","check"),menuSubmenu:(0,n.register)("menu-submenu","chevron-right"),menuBarMore:(0,n.register)("menubar-more","more"),scrollbarButtonLeft:(0,n.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.register)("toolbar-more","more"),quickInputBack:(0,n.register)("quick-input-back","arrow-left"),dropDownButton:(0,n.register)("drop-down-button",60084),symbolCustomColor:(0,n.register)("symbol-customcolor",60252),exportIcon:(0,n.register)("export",60332),workspaceUnspecified:(0,n.register)("workspace-unspecified",60355),newLine:(0,n.register)("newline",60394),thumbsDownFilled:(0,n.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.register)("thumbsup-filled",60436),gitFetch:(0,n.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.register)("debug-breakpoint-pending",60377)},t.Codicon={...F.codiconsLibrary,...t.codiconsDerived}}),ne(se[15],ae([0,1,26]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.deepClone=F,t.deepFreeze=D,t.cloneAndChange=E,t.mixin=l,t.equals=s,t.safeStringify=c,t.distinct=N,t.getCaseInsensitive=g,t.filter=m,t.getAllPropertyNames=e,t.getAllMethodNames=w,t.createProxyObject=A;function F(_){if(!_||typeof _!="object"||_ instanceof RegExp)return _;const L=Array.isArray(_)?[]:{};return Object.entries(_).forEach(([p,o])=>{L[p]=o&&typeof o=="object"?F(o):o}),L}function D(_){if(!_||typeof _!="object")return _;const L=[_];for(;L.length>0;){const p=L.shift();Object.freeze(p);for(const o in p)if(f.call(p,o)){const a=p[o];typeof a=="object"&&!Object.isFrozen(a)&&!(0,n.isTypedArray)(a)&&L.push(a)}}return _}const f=Object.prototype.hasOwnProperty;function E(_,L){return h(_,L,new Set)}function h(_,L,p){if((0,n.isUndefinedOrNull)(_))return _;const o=L(_);if(typeof o<"u")return o;if(Array.isArray(_)){const a=[];for(const i of _)a.push(h(i,L,p));return a}if((0,n.isObject)(_)){if(p.has(_))throw new Error("Cannot clone recursive data-structure");p.add(_);const a={};for(const i in _)f.call(_,i)&&(a[i]=h(_[i],L,p));return p.delete(_),a}return _}function l(_,L,p=!0){return(0,n.isObject)(_)?((0,n.isObject)(L)&&Object.keys(L).forEach(o=>{o in _?p&&((0,n.isObject)(_[o])&&(0,n.isObject)(L[o])?l(_[o],L[o],p):_[o]=L[o]):_[o]=L[o]}),_):L}function s(_,L){if(_===L)return!0;if(_==null||L===null||L===void 0||typeof _!=typeof L||typeof _!="object"||Array.isArray(_)!==Array.isArray(L))return!1;let p,o;if(Array.isArray(_)){if(_.length!==L.length)return!1;for(p=0;p<_.length;p++)if(!s(_[p],L[p]))return!1}else{const a=[];for(o in _)a.push(o);a.sort();const i=[];for(o in L)i.push(o);if(i.sort(),!s(a,i))return!1;for(p=0;p<a.length;p++)if(!s(_[a[p]],L[a[p]]))return!1}return!0}function c(_){const L=new Set;return JSON.stringify(_,(p,o)=>{if((0,n.isObject)(o)||Array.isArray(o)){if(L.has(o))return"[Circular]";L.add(o)}return o})}function N(_,L){const p=Object.create(null);return!_||!L||Object.keys(L).forEach(a=>{const i=_[a],u=L[a];s(i,u)||(p[a]=u)}),p}function g(_,L){const p=L.toLowerCase(),o=Object.keys(_).find(a=>a.toLowerCase()===p);return o?_[o]:_[L]}function m(_,L){const p=Object.create(null);for(const[o,a]of Object.entries(_))L(o,a)&&(p[o]=a);return p}function e(_){let L=[];for(;Object.prototype!==_;)L=L.concat(Object.getOwnPropertyNames(_)),_=Object.getPrototypeOf(_);return L}function w(_){const L=[];for(const p of e(_))typeof _[p]=="function"&&L.push(p);return L}function A(_,L){const p=a=>function(){const i=Array.prototype.slice.call(arguments,0);return L(a,i)},o={};for(const a of _)o[a]=p(a);return o}}),ne(se[28],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.toUint8=F,t.toUint32=D;var n;(function(f){f[f.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",f[f.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",f[f.MAX_UINT_8=255]="MAX_UINT_8",f[f.MAX_UINT_16=65535]="MAX_UINT_16",f[f.MAX_UINT_32=4294967295]="MAX_UINT_32",f[f.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(t.Constants=n={}));function F(f){return f<0?0:f>255?255:f|0}function D(f){return f<0?0:f>4294967295?4294967295:f|0}}),ne(se[29],ae([0,1,28]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class F{constructor(h){const l=(0,n.toUint8)(h);this._defaultValue=l,this._asciiMap=F._createAsciiMap(l),this._map=new Map}static _createAsciiMap(h){const l=new Uint8Array(256);return l.fill(h),l}set(h,l){const s=(0,n.toUint8)(l);h>=0&&h<256?this._asciiMap[h]=s:this._map.set(h,s)}get(h){return h>=0&&h<256?this._asciiMap[h]:this._map.get(h)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}t.CharacterClassifier=F;var D;(function(E){E[E.False=0]="False",E[E.True=1]="True"})(D||(D={}));class f{constructor(){this._actual=new F(0)}add(h){this._actual.set(h,1)}has(h){return this._actual.get(h)===1}clear(){return this._actual.clear()}}t.CharacterSet=f}),ne(se[4],ae([0,1,3]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRangeSet=t.OffsetRange=void 0;class F{static addRange(E,h){let l=0;for(;l<h.length&&h[l].endExclusive<E.start;)l++;let s=l;for(;s<h.length&&h[s].start<=E.endExclusive;)s++;if(l===s)h.splice(l,0,E);else{const c=Math.min(E.start,h[l].start),N=Math.max(E.endExclusive,h[s-1].endExclusive);h.splice(l,s-l,new F(c,N))}}static tryCreate(E,h){if(!(E>h))return new F(E,h)}static ofLength(E){return new F(0,E)}static ofStartAndLength(E,h){return new F(E,E+h)}constructor(E,h){if(this.start=E,this.endExclusive=h,E>h)throw new n.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(E){return new F(this.start+E,this.endExclusive+E)}deltaStart(E){return new F(this.start+E,this.endExclusive)}deltaEnd(E){return new F(this.start,this.endExclusive+E)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(E){return this.start===E.start&&this.endExclusive===E.endExclusive}containsRange(E){return this.start<=E.start&&E.endExclusive<=this.endExclusive}contains(E){return this.start<=E&&E<this.endExclusive}join(E){return new F(Math.min(this.start,E.start),Math.max(this.endExclusive,E.endExclusive))}intersect(E){const h=Math.max(this.start,E.start),l=Math.min(this.endExclusive,E.endExclusive);if(h<=l)return new F(h,l)}intersects(E){const h=Math.max(this.start,E.start),l=Math.min(this.endExclusive,E.endExclusive);return h<l}intersectsOrTouches(E){const h=Math.max(this.start,E.start),l=Math.min(this.endExclusive,E.endExclusive);return h<=l}isBefore(E){return this.endExclusive<=E.start}isAfter(E){return this.start>=E.endExclusive}slice(E){return E.slice(this.start,this.endExclusive)}substring(E){return E.substring(this.start,this.endExclusive)}clip(E){if(this.isEmpty)throw new n.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,E))}clipCyclic(E){if(this.isEmpty)throw new n.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return E<this.start?this.endExclusive-(this.start-E)%this.length:E>=this.endExclusive?this.start+(E-this.start)%this.length:E}map(E){const h=[];for(let l=this.start;l<this.endExclusive;l++)h.push(E(l));return h}forEach(E){for(let h=this.start;h<this.endExclusive;h++)E(h)}}t.OffsetRange=F;class D{constructor(){this._sortedRanges=[]}addRange(E){let h=0;for(;h<this._sortedRanges.length&&this._sortedRanges[h].endExclusive<E.start;)h++;let l=h;for(;l<this._sortedRanges.length&&this._sortedRanges[l].start<=E.endExclusive;)l++;if(h===l)this._sortedRanges.splice(h,0,E);else{const s=Math.min(E.start,this._sortedRanges[h].start),c=Math.max(E.endExclusive,this._sortedRanges[l-1].endExclusive);this._sortedRanges.splice(h,l-h,new F(s,c))}}toString(){return this._sortedRanges.map(E=>E.toString()).join(", ")}intersectsStrict(E){let h=0;for(;h<this._sortedRanges.length&&this._sortedRanges[h].endExclusive<=E.start;)h++;return h<this._sortedRanges.length&&this._sortedRanges[h].start<E.endExclusive}intersectWithRange(E){const h=new D;for(const l of this._sortedRanges){const s=l.intersect(E);s&&h.addRange(s)}return h}intersectWithRangeLength(E){return this.intersectWithRange(E).length}get length(){return this._sortedRanges.reduce((E,h)=>E+h.length,0)}}t.OffsetRangeSet=D}),ne(se[5],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class n{constructor(D,f){this.lineNumber=D,this.column=f}with(D=this.lineNumber,f=this.column){return D===this.lineNumber&&f===this.column?this:new n(D,f)}delta(D=0,f=0){return this.with(this.lineNumber+D,this.column+f)}equals(D){return n.equals(this,D)}static equals(D,f){return!D&&!f?!0:!!D&&!!f&&D.lineNumber===f.lineNumber&&D.column===f.column}isBefore(D){return n.isBefore(this,D)}static isBefore(D,f){return D.lineNumber<f.lineNumber?!0:f.lineNumber<D.lineNumber?!1:D.column<f.column}isBeforeOrEqual(D){return n.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,f){return D.lineNumber<f.lineNumber?!0:f.lineNumber<D.lineNumber?!1:D.column<=f.column}static compare(D,f){const E=D.lineNumber|0,h=f.lineNumber|0;if(E===h){const l=D.column|0,s=f.column|0;return l-s}return E-h}clone(){return new n(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new n(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.Position=n}),ne(se[2],ae([0,1,5]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class F{constructor(f,E,h,l){f>h||f===h&&E>l?(this.startLineNumber=h,this.startColumn=l,this.endLineNumber=f,this.endColumn=E):(this.startLineNumber=f,this.startColumn=E,this.endLineNumber=h,this.endColumn=l)}isEmpty(){return F.isEmpty(this)}static isEmpty(f){return f.startLineNumber===f.endLineNumber&&f.startColumn===f.endColumn}containsPosition(f){return F.containsPosition(this,f)}static containsPosition(f,E){return!(E.lineNumber<f.startLineNumber||E.lineNumber>f.endLineNumber||E.lineNumber===f.startLineNumber&&E.column<f.startColumn||E.lineNumber===f.endLineNumber&&E.column>f.endColumn)}static strictContainsPosition(f,E){return!(E.lineNumber<f.startLineNumber||E.lineNumber>f.endLineNumber||E.lineNumber===f.startLineNumber&&E.column<=f.startColumn||E.lineNumber===f.endLineNumber&&E.column>=f.endColumn)}containsRange(f){return F.containsRange(this,f)}static containsRange(f,E){return!(E.startLineNumber<f.startLineNumber||E.endLineNumber<f.startLineNumber||E.startLineNumber>f.endLineNumber||E.endLineNumber>f.endLineNumber||E.startLineNumber===f.startLineNumber&&E.startColumn<f.startColumn||E.endLineNumber===f.endLineNumber&&E.endColumn>f.endColumn)}strictContainsRange(f){return F.strictContainsRange(this,f)}static strictContainsRange(f,E){return!(E.startLineNumber<f.startLineNumber||E.endLineNumber<f.startLineNumber||E.startLineNumber>f.endLineNumber||E.endLineNumber>f.endLineNumber||E.startLineNumber===f.startLineNumber&&E.startColumn<=f.startColumn||E.endLineNumber===f.endLineNumber&&E.endColumn>=f.endColumn)}plusRange(f){return F.plusRange(this,f)}static plusRange(f,E){let h,l,s,c;return E.startLineNumber<f.startLineNumber?(h=E.startLineNumber,l=E.startColumn):E.startLineNumber===f.startLineNumber?(h=E.startLineNumber,l=Math.min(E.startColumn,f.startColumn)):(h=f.startLineNumber,l=f.startColumn),E.endLineNumber>f.endLineNumber?(s=E.endLineNumber,c=E.endColumn):E.endLineNumber===f.endLineNumber?(s=E.endLineNumber,c=Math.max(E.endColumn,f.endColumn)):(s=f.endLineNumber,c=f.endColumn),new F(h,l,s,c)}intersectRanges(f){return F.intersectRanges(this,f)}static intersectRanges(f,E){let h=f.startLineNumber,l=f.startColumn,s=f.endLineNumber,c=f.endColumn;const N=E.startLineNumber,g=E.startColumn,m=E.endLineNumber,e=E.endColumn;return h<N?(h=N,l=g):h===N&&(l=Math.max(l,g)),s>m?(s=m,c=e):s===m&&(c=Math.min(c,e)),h>s||h===s&&l>c?null:new F(h,l,s,c)}equalsRange(f){return F.equalsRange(this,f)}static equalsRange(f,E){return!f&&!E?!0:!!f&&!!E&&f.startLineNumber===E.startLineNumber&&f.startColumn===E.startColumn&&f.endLineNumber===E.endLineNumber&&f.endColumn===E.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(f){return new n.Position(f.endLineNumber,f.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(f){return new n.Position(f.startLineNumber,f.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(f,E){return new F(this.startLineNumber,this.startColumn,f,E)}setStartPosition(f,E){return new F(f,E,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(f){return new F(f.startLineNumber,f.startColumn,f.startLineNumber,f.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(f){return new F(f.endLineNumber,f.endColumn,f.endLineNumber,f.endColumn)}delta(f){return new F(this.startLineNumber+f,this.startColumn,this.endLineNumber+f,this.endColumn)}static fromPositions(f,E=f){return new F(f.lineNumber,f.column,E.lineNumber,E.column)}static lift(f){return f?new F(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):null}static isIRange(f){return f&&typeof f.startLineNumber=="number"&&typeof f.startColumn=="number"&&typeof f.endLineNumber=="number"&&typeof f.endColumn=="number"}static areIntersectingOrTouching(f,E){return!(f.endLineNumber<E.startLineNumber||f.endLineNumber===E.startLineNumber&&f.endColumn<E.startColumn||E.endLineNumber<f.startLineNumber||E.endLineNumber===f.startLineNumber&&E.endColumn<f.startColumn)}static areIntersecting(f,E){return!(f.endLineNumber<E.startLineNumber||f.endLineNumber===E.startLineNumber&&f.endColumn<=E.startColumn||E.endLineNumber<f.startLineNumber||E.endLineNumber===f.startLineNumber&&E.endColumn<=f.startColumn)}static compareRangesUsingStarts(f,E){if(f&&E){const s=f.startLineNumber|0,c=E.startLineNumber|0;if(s===c){const N=f.startColumn|0,g=E.startColumn|0;if(N===g){const m=f.endLineNumber|0,e=E.endLineNumber|0;if(m===e){const w=f.endColumn|0,A=E.endColumn|0;return w-A}return m-e}return N-g}return s-c}return(f?1:0)-(E?1:0)}static compareRangesUsingEnds(f,E){return f.endLineNumber===E.endLineNumber?f.endColumn===E.endColumn?f.startLineNumber===E.startLineNumber?f.startColumn-E.startColumn:f.startLineNumber-E.startLineNumber:f.endColumn-E.endColumn:f.endLineNumber-E.endLineNumber}static spansMultipleLines(f){return f.endLineNumber>f.startLineNumber}toJSON(){return this}}t.Range=F}),ne(se[44],ae([0,1,2]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditOperation=void 0;class F{static insert(f,E){return{range:new n.Range(f.lineNumber,f.column,f.lineNumber,f.column),text:E,forceMoveMarkers:!0}}static delete(f){return{range:f,text:null}}static replace(f,E){return{range:f,text:E}}static replaceMove(f,E){return{range:f,text:E,forceMoveMarkers:!0}}}t.EditOperation=F}),ne(se[12],ae([0,1,3,4,2,9]),function(W,t,n,F,D,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRangeSet=t.LineRange=void 0;class E{static fromRange(s){return new E(s.startLineNumber,s.endLineNumber)}static fromRangeInclusive(s){return new E(s.startLineNumber,s.endLineNumber+1)}static subtract(s,c){return c?s.startLineNumber<c.startLineNumber&&c.endLineNumberExclusive<s.endLineNumberExclusive?[new E(s.startLineNumber,c.startLineNumber),new E(c.endLineNumberExclusive,s.endLineNumberExclusive)]:c.startLineNumber<=s.startLineNumber&&s.endLineNumberExclusive<=c.endLineNumberExclusive?[]:c.endLineNumberExclusive<s.endLineNumberExclusive?[new E(Math.max(c.endLineNumberExclusive,s.startLineNumber),s.endLineNumberExclusive)]:[new E(s.startLineNumber,Math.min(c.startLineNumber,s.endLineNumberExclusive))]:[s]}static joinMany(s){if(s.length===0)return[];let c=new h(s[0].slice());for(let N=1;N<s.length;N++)c=c.getUnion(new h(s[N].slice()));return c.ranges}static join(s){if(s.length===0)throw new n.BugIndicatingError("lineRanges cannot be empty");let c=s[0].startLineNumber,N=s[0].endLineNumberExclusive;for(let g=1;g<s.length;g++)c=Math.min(c,s[g].startLineNumber),N=Math.max(N,s[g].endLineNumberExclusive);return new E(c,N)}static ofLength(s,c){return new E(s,s+c)}static deserialize(s){return new E(s[0],s[1])}constructor(s,c){if(s>c)throw new n.BugIndicatingError(`startLineNumber ${s} cannot be after endLineNumberExclusive ${c}`);this.startLineNumber=s,this.endLineNumberExclusive=c}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new E(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new E(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new E(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const c=Math.max(this.startLineNumber,s.startLineNumber),N=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(c<=N)return new E(c,N)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new D.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new D.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const c=[];for(let N=this.startLineNumber;N<this.endLineNumberExclusive;N++)c.push(s(N));return c}forEach(s){for(let c=this.startLineNumber;c<this.endLineNumberExclusive;c++)s(c)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new F.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.LineRange=E;class h{constructor(s=[]){this._normalizedRanges=s}get ranges(){return this._normalizedRanges}addRange(s){if(s.length===0)return;const c=(0,f.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,g=>g.endLineNumberExclusive>=s.startLineNumber),N=(0,f.findLastIdxMonotonous)(this._normalizedRanges,g=>g.startLineNumber<=s.endLineNumberExclusive)+1;if(c===N)this._normalizedRanges.splice(c,0,s);else if(c===N-1){const g=this._normalizedRanges[c];this._normalizedRanges[c]=g.join(s)}else{const g=this._normalizedRanges[c].join(this._normalizedRanges[N-1]).join(s);this._normalizedRanges.splice(c,N-c,g)}}contains(s){const c=(0,f.findLastMonotonous)(this._normalizedRanges,N=>N.startLineNumber<=s);return!!c&&c.endLineNumberExclusive>s}intersects(s){const c=(0,f.findLastMonotonous)(this._normalizedRanges,N=>N.startLineNumber<s.endLineNumberExclusive);return!!c&&c.endLineNumberExclusive>s.startLineNumber}getUnion(s){if(this._normalizedRanges.length===0)return s;if(s._normalizedRanges.length===0)return this;const c=[];let N=0,g=0,m=null;for(;N<this._normalizedRanges.length||g<s._normalizedRanges.length;){let e=null;if(N<this._normalizedRanges.length&&g<s._normalizedRanges.length){const w=this._normalizedRanges[N],A=s._normalizedRanges[g];w.startLineNumber<A.startLineNumber?(e=w,N++):(e=A,g++)}else N<this._normalizedRanges.length?(e=this._normalizedRanges[N],N++):(e=s._normalizedRanges[g],g++);m===null?m=e:m.endLineNumberExclusive>=e.startLineNumber?m=new E(m.startLineNumber,Math.max(m.endLineNumberExclusive,e.endLineNumberExclusive)):(c.push(m),m=e)}return m!==null&&c.push(m),new h(c)}subtractFrom(s){const c=(0,f.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,e=>e.endLineNumberExclusive>=s.startLineNumber),N=(0,f.findLastIdxMonotonous)(this._normalizedRanges,e=>e.startLineNumber<=s.endLineNumberExclusive)+1;if(c===N)return new h([s]);const g=[];let m=s.startLineNumber;for(let e=c;e<N;e++){const w=this._normalizedRanges[e];w.startLineNumber>m&&g.push(new E(m,w.startLineNumber)),m=w.endLineNumberExclusive}return m<s.endLineNumberExclusive&&g.push(new E(m,s.endLineNumberExclusive)),new h(g)}toString(){return this._normalizedRanges.map(s=>s.toString()).join(", ")}getIntersection(s){const c=[];let N=0,g=0;for(;N<this._normalizedRanges.length&&g<s._normalizedRanges.length;){const m=this._normalizedRanges[N],e=s._normalizedRanges[g],w=m.intersect(e);w&&!w.isEmpty&&c.push(w),m.endLineNumberExclusive<e.endLineNumberExclusive?N++:g++}return new h(c)}getWithDelta(s){return new h(this._normalizedRanges.map(c=>c.delta(s)))}}t.LineRangeSet=h}),ne(se[45],ae([0,1,5,2]),function(W,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var D;(function(E){E[E.LTR=0]="LTR",E[E.RTL=1]="RTL"})(D||(t.SelectionDirection=D={}));class f extends F.Range{constructor(h,l,s,c){super(h,l,s,c),this.selectionStartLineNumber=h,this.selectionStartColumn=l,this.positionLineNumber=s,this.positionColumn=c}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return f.selectionsEqual(this,h)}static selectionsEqual(h,l){return h.selectionStartLineNumber===l.selectionStartLineNumber&&h.selectionStartColumn===l.selectionStartColumn&&h.positionLineNumber===l.positionLineNumber&&h.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,l){return this.getDirection()===0?new f(this.startLineNumber,this.startColumn,h,l):new f(h,l,this.startLineNumber,this.startColumn)}getPosition(){return new n.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new n.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(h,l){return this.getDirection()===0?new f(h,l,this.endLineNumber,this.endColumn):new f(this.endLineNumber,this.endColumn,h,l)}static fromPositions(h,l=h){return new f(h.lineNumber,h.column,l.lineNumber,l.column)}static fromRange(h,l){return l===0?new f(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):new f(h.endLineNumber,h.endColumn,h.startLineNumber,h.startColumn)}static liftSelection(h){return new f(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,l){if(h&&!l||!h&&l)return!1;if(!h&&!l)return!0;if(h.length!==l.length)return!1;for(let s=0,c=h.length;s<c;s++)if(!this.selectionsEqual(h[s],l[s]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,l,s,c,N){return N===0?new f(h,l,s,c):new f(s,c,h,l)}}t.Selection=f}),ne(se[46],ae([0,1,14,29]),function(W,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WordCharacterClassifier=t.WordCharacterClass=void 0,t.getMapForWordSeparators=h;var D;(function(l){l[l.Regular=0]="Regular",l[l.Whitespace=1]="Whitespace",l[l.WordSeparator=2]="WordSeparator"})(D||(t.WordCharacterClass=D={}));class f extends F.CharacterClassifier{constructor(s,c){super(0),this._segmenter=null,this._cachedLine=null,this._cachedSegments=[],this.intlSegmenterLocales=c,this.intlSegmenterLocales.length>0?this._segmenter=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this._segmenter=null;for(let N=0,g=s.length;N<g;N++)this.set(s.charCodeAt(N),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(s,c){let N=null;for(const g of this._getIntlSegmenterWordsOnLine(s)){if(g.index>c)break;N=g}return N}findNextIntlWordAtOrAfterOffset(s,c){for(const N of this._getIntlSegmenterWordsOnLine(s))if(!(N.index<c))return N;return null}_getIntlSegmenterWordsOnLine(s){return this._segmenter?this._cachedLine===s?this._cachedSegments:(this._cachedLine=s,this._cachedSegments=this._filterWordSegments(this._segmenter.segment(s)),this._cachedSegments):[]}_filterWordSegments(s){const c=[];for(const N of s)this._isWordLike(N)&&c.push(N);return c}_isWordLike(s){return!!s.isWordLike}}t.WordCharacterClassifier=f;const E=new n.LRUCache(10);function h(l,s){const c=`${l}/${s.join(",")}`;let N=E.get(c);return N||(N=new f(l,s),E.set(c,N)),N}}),ne(se[30],ae([0,1,21,10,22]),function(W,t,n,F,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.ensureValidWordDefinition=E,t.setDefaultGetWordAtTextConfig=l,t.getWordAtText=s,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(N=""){let g="(-?\\d*\\.\\d\\w*)|([^";for(const m of t.USUAL_WORD_SEPARATORS)N.indexOf(m)>=0||(g+="\\"+m);return g+="\\s]+)",new RegExp(g,"g")}t.DEFAULT_WORD_REGEXP=f();function E(N){let g=t.DEFAULT_WORD_REGEXP;if(N&&N instanceof RegExp)if(N.global)g=N;else{let m="g";N.ignoreCase&&(m+="i"),N.multiline&&(m+="m"),N.unicode&&(m+="u"),g=new RegExp(N.source,m)}return g.lastIndex=0,g}const h=new D.LinkedList;h.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function l(N){const g=h.unshift(N);return(0,F.toDisposable)(g)}function s(N,g,m,e,w){if(g=E(g),w||(w=n.Iterable.first(h)),m.length>w.maxLen){let o=N-w.maxLen/2;return o<0?o=0:e+=o,m=m.substring(o,N+w.maxLen/2),s(N,g,m,e,w)}const A=Date.now(),_=N-1-e;let L=-1,p=null;for(let o=1;!(Date.now()-A>=w.timeBudget);o++){const a=_-w.windowSize*o;g.lastIndex=Math.max(0,a);const i=c(g,m,_,L);if(!i&&p||(p=i,a<=0))break;L=a}if(p){const o={word:p[0],startColumn:e+1+p.index,endColumn:e+1+p.index+p[0].length};return g.lastIndex=0,o}return null}function c(N,g,m,e){let w;for(;w=N.exec(g);){const A=w.index||0;if(A<=m&&N.lastIndex>=m)return w;if(e>0&&A>e)return null}return null}}),ne(se[8],ae([0,1,6,3,4]),function(W,t,n,F,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DateTimeout=t.InfiniteTimeout=t.OffsetPair=t.SequenceDiff=t.DiffAlgorithmResult=void 0;class f{static trivial(N,g){return new f([new E(D.OffsetRange.ofLength(N.length),D.OffsetRange.ofLength(g.length))],!1)}static trivialTimedOut(N,g){return new f([new E(D.OffsetRange.ofLength(N.length),D.OffsetRange.ofLength(g.length))],!0)}constructor(N,g){this.diffs=N,this.hitTimeout=g}}t.DiffAlgorithmResult=f;class E{static invert(N,g){const m=[];return(0,n.forEachAdjacent)(N,(e,w)=>{m.push(E.fromOffsetPairs(e?e.getEndExclusives():h.zero,w?w.getStarts():new h(g,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+g)))}),m}static fromOffsetPairs(N,g){return new E(new D.OffsetRange(N.offset1,g.offset1),new D.OffsetRange(N.offset2,g.offset2))}constructor(N,g){this.seq1Range=N,this.seq2Range=g}swap(){return new E(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(N){return new E(this.seq1Range.join(N.seq1Range),this.seq2Range.join(N.seq2Range))}delta(N){return N===0?this:new E(this.seq1Range.delta(N),this.seq2Range.delta(N))}deltaStart(N){return N===0?this:new E(this.seq1Range.deltaStart(N),this.seq2Range.deltaStart(N))}deltaEnd(N){return N===0?this:new E(this.seq1Range.deltaEnd(N),this.seq2Range.deltaEnd(N))}intersectsOrTouches(N){return this.seq1Range.intersectsOrTouches(N.seq1Range)||this.seq2Range.intersectsOrTouches(N.seq2Range)}intersect(N){const g=this.seq1Range.intersect(N.seq1Range),m=this.seq2Range.intersect(N.seq2Range);if(!(!g||!m))return new E(g,m)}getStarts(){return new h(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new h(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.SequenceDiff=E;class h{static{this.zero=new h(0,0)}static{this.max=new h(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(N,g){this.offset1=N,this.offset2=g}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(N){return N===0?this:new h(this.offset1+N,this.offset2+N)}equals(N){return this.offset1===N.offset1&&this.offset2===N.offset2}}t.OffsetPair=h;class l{static{this.instance=new l}isValid(){return!0}}t.InfiniteTimeout=l;class s{constructor(N){if(this.timeout=N,this.startTime=Date.now(),this.valid=!0,N<=0)throw new F.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}disable(){this.timeout=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.valid=!0}}t.DateTimeout=s}),ne(se[31],ae([0,1,4,8]),function(W,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class D{compute(s,c,N=F.InfiniteTimeout.instance){if(s.length===0||c.length===0)return F.DiffAlgorithmResult.trivial(s,c);const g=s,m=c;function e(u,b){for(;u<g.length&&b<m.length&&g.getElement(u)===m.getElement(b);)u++,b++;return u}let w=0;const A=new E;A.set(0,e(0,0));const _=new h;_.set(0,A.get(0)===0?null:new f(null,0,0,A.get(0)));let L=0;e:for(;;){if(w++,!N.isValid())return F.DiffAlgorithmResult.trivialTimedOut(g,m);const u=-Math.min(w,m.length+w%2),b=Math.min(w,g.length+w%2);for(L=u;L<=b;L+=2){let d=0;const v=L===b?-1:A.get(L+1),M=L===u?-1:A.get(L-1)+1;d++;const R=Math.min(Math.max(v,M),g.length),S=R-L;if(d++,R>g.length||S>m.length)continue;const x=e(R,S);A.set(L,x);const I=R===v?_.get(L+1):_.get(L-1);if(_.set(L,x!==R?new f(I,R,S,x-R):I),A.get(L)===g.length&&A.get(L)-L===m.length)break e}}let p=_.get(L);const o=[];let a=g.length,i=m.length;for(;;){const u=p?p.x+p.length:0,b=p?p.y+p.length:0;if((u!==a||b!==i)&&o.push(new F.SequenceDiff(new n.OffsetRange(u,a),new n.OffsetRange(b,i))),!p)break;a=p.x,i=p.y,p=p.prev}return o.reverse(),new F.DiffAlgorithmResult(o,!1)}}t.MyersDiffAlgorithm=D;class f{constructor(s,c,N,g){this.prev=s,this.x=c,this.y=N,this.length=g}}class E{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,c){if(s<0){if(s=-s-1,s>=this.negativeArr.length){const N=this.negativeArr;this.negativeArr=new Int32Array(N.length*2),this.negativeArr.set(N)}this.negativeArr[s]=c}else{if(s>=this.positiveArr.length){const N=this.positiveArr;this.positiveArr=new Int32Array(N.length*2),this.positiveArr.set(N)}this.positiveArr[s]=c}}}class h{constructor(){this.positiveArr=[],this.negativeArr=[]}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,c){s<0?(s=-s-1,this.negativeArr[s]=c):this.positiveArr[s]=c}}}),ne(se[47],ae([0,1,6,4,8]),function(W,t,n,F,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.optimizeSequenceDiffs=f,t.removeShortMatches=s,t.extendDiffsToEntireWordIfAppropriate=c,t.removeVeryShortMatchingLinesBetweenDiffs=g,t.removeVeryShortMatchingTextBetweenLongDiffs=m;function f(e,w,A){let _=A;return _=E(e,w,_),_=E(e,w,_),_=h(e,w,_),_}function E(e,w,A){if(A.length===0)return A;const _=[];_.push(A[0]);for(let p=1;p<A.length;p++){const o=_[_.length-1];let a=A[p];if(a.seq1Range.isEmpty||a.seq2Range.isEmpty){const i=a.seq1Range.start-o.seq1Range.endExclusive;let u;for(u=1;u<=i&&!(e.getElement(a.seq1Range.start-u)!==e.getElement(a.seq1Range.endExclusive-u)||w.getElement(a.seq2Range.start-u)!==w.getElement(a.seq2Range.endExclusive-u));u++);if(u--,u===i){_[_.length-1]=new D.SequenceDiff(new F.OffsetRange(o.seq1Range.start,a.seq1Range.endExclusive-i),new F.OffsetRange(o.seq2Range.start,a.seq2Range.endExclusive-i));continue}a=a.delta(-u)}_.push(a)}const L=[];for(let p=0;p<_.length-1;p++){const o=_[p+1];let a=_[p];if(a.seq1Range.isEmpty||a.seq2Range.isEmpty){const i=o.seq1Range.start-a.seq1Range.endExclusive;let u;for(u=0;u<i&&!(!e.isStronglyEqual(a.seq1Range.start+u,a.seq1Range.endExclusive+u)||!w.isStronglyEqual(a.seq2Range.start+u,a.seq2Range.endExclusive+u));u++);if(u===i){_[p+1]=new D.SequenceDiff(new F.OffsetRange(a.seq1Range.start+i,o.seq1Range.endExclusive),new F.OffsetRange(a.seq2Range.start+i,o.seq2Range.endExclusive));continue}u>0&&(a=a.delta(u))}L.push(a)}return _.length>0&&L.push(_[_.length-1]),L}function h(e,w,A){if(!e.getBoundaryScore||!w.getBoundaryScore)return A;for(let _=0;_<A.length;_++){const L=_>0?A[_-1]:void 0,p=A[_],o=_+1<A.length?A[_+1]:void 0,a=new F.OffsetRange(L?L.seq1Range.endExclusive+1:0,o?o.seq1Range.start-1:e.length),i=new F.OffsetRange(L?L.seq2Range.endExclusive+1:0,o?o.seq2Range.start-1:w.length);p.seq1Range.isEmpty?A[_]=l(p,e,w,a,i):p.seq2Range.isEmpty&&(A[_]=l(p.swap(),w,e,i,a).swap())}return A}function l(e,w,A,_,L){let o=1;for(;e.seq1Range.start-o>=_.start&&e.seq2Range.start-o>=L.start&&A.isStronglyEqual(e.seq2Range.start-o,e.seq2Range.endExclusive-o)&&o<100;)o++;o--;let a=0;for(;e.seq1Range.start+a<_.endExclusive&&e.seq2Range.endExclusive+a<L.endExclusive&&A.isStronglyEqual(e.seq2Range.start+a,e.seq2Range.endExclusive+a)&&a<100;)a++;if(o===0&&a===0)return e;let i=0,u=-1;for(let b=-o;b<=a;b++){const d=e.seq2Range.start+b,v=e.seq2Range.endExclusive+b,M=e.seq1Range.start+b,R=w.getBoundaryScore(M)+A.getBoundaryScore(d)+A.getBoundaryScore(v);R>u&&(u=R,i=b)}return e.delta(i)}function s(e,w,A){const _=[];for(const L of A){const p=_[_.length-1];if(!p){_.push(L);continue}L.seq1Range.start-p.seq1Range.endExclusive<=2||L.seq2Range.start-p.seq2Range.endExclusive<=2?_[_.length-1]=new D.SequenceDiff(p.seq1Range.join(L.seq1Range),p.seq2Range.join(L.seq2Range)):_.push(L)}return _}function c(e,w,A){const _=D.SequenceDiff.invert(A,e.length),L=[];let p=new D.OffsetPair(0,0);function o(i,u){if(i.offset1<p.offset1||i.offset2<p.offset2)return;const b=e.findWordContaining(i.offset1),d=w.findWordContaining(i.offset2);if(!b||!d)return;let v=new D.SequenceDiff(b,d);const M=v.intersect(u);let R=M.seq1Range.length,S=M.seq2Range.length;for(;_.length>0;){const x=_[0];if(!(x.seq1Range.intersects(v.seq1Range)||x.seq2Range.intersects(v.seq2Range)))break;const k=e.findWordContaining(x.seq1Range.start),y=w.findWordContaining(x.seq2Range.start),C=new D.SequenceDiff(k,y),O=C.intersect(x);if(R+=O.seq1Range.length,S+=O.seq2Range.length,v=v.join(C),v.seq1Range.endExclusive>=x.seq1Range.endExclusive)_.shift();else break}R+S<(v.seq1Range.length+v.seq2Range.length)*2/3&&L.push(v),p=v.getEndExclusives()}for(;_.length>0;){const i=_.shift();i.seq1Range.isEmpty||(o(i.getStarts(),i),o(i.getEndExclusives().delta(-1),i))}return N(A,L)}function N(e,w){const A=[];for(;e.length>0||w.length>0;){const _=e[0],L=w[0];let p;_&&(!L||_.seq1Range.start<L.seq1Range.start)?p=e.shift():p=w.shift(),A.length>0&&A[A.length-1].seq1Range.endExclusive>=p.seq1Range.start?A[A.length-1]=A[A.length-1].join(p):A.push(p)}return A}function g(e,w,A){let _=A;if(_.length===0)return _;let L=0,p;do{p=!1;const o=[_[0]];for(let a=1;a<_.length;a++){let b=function(v,M){const R=new F.OffsetRange(u.seq1Range.endExclusive,i.seq1Range.start);return e.getText(R).replace(/\s/g,"").length<=4&&(v.seq1Range.length+v.seq2Range.length>5||M.seq1Range.length+M.seq2Range.length>5)};const i=_[a],u=o[o.length-1];b(u,i)?(p=!0,o[o.length-1]=o[o.length-1].join(i)):o.push(i)}_=o}while(L++<10&&p);return _}function m(e,w,A){let _=A;if(_.length===0)return _;let L=0,p;do{p=!1;const a=[_[0]];for(let i=1;i<_.length;i++){let d=function(M,R){const S=new F.OffsetRange(b.seq1Range.endExclusive,u.seq1Range.start);if(e.countLinesIn(S)>5||S.length>500)return!1;const I=e.getText(S).trim();if(I.length>20||I.split(/\r\n|\r|\n/).length>1)return!1;const k=e.countLinesIn(M.seq1Range),y=M.seq1Range.length,C=w.countLinesIn(M.seq2Range),O=M.seq2Range.length,j=e.countLinesIn(R.seq1Range),K=R.seq1Range.length,U=w.countLinesIn(R.seq2Range),X=R.seq2Range.length,G=2*40+50;function P(H){return Math.min(H,G)}return Math.pow(Math.pow(P(k*40+y),1.5)+Math.pow(P(C*40+O),1.5),1.5)+Math.pow(Math.pow(P(j*40+K),1.5)+Math.pow(P(U*40+X),1.5),1.5)>(G**1.5)**1.5*1.3};const u=_[i],b=a[a.length-1];d(b,u)?(p=!0,a[a.length-1]=a[a.length-1].join(u)):a.push(u)}_=a}while(L++<10&&p);const o=[];return(0,n.forEachWithNeighbors)(_,(a,i,u)=>{let b=i;function d(I){return I.length>0&&I.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const v=e.extendToFullLines(i.seq1Range),M=e.getText(new F.OffsetRange(v.start,i.seq1Range.start));d(M)&&(b=b.deltaStart(-M.length));const R=e.getText(new F.OffsetRange(i.seq1Range.endExclusive,v.endExclusive));d(R)&&(b=b.deltaEnd(R.length));const S=D.SequenceDiff.fromOffsetPairs(a?a.getEndExclusives():D.OffsetPair.zero,u?u.getStarts():D.OffsetPair.max),x=b.intersect(S);o.length>0&&x.getStarts().equals(o[o.length-1].getEndExclusives())?o[o.length-1]=o[o.length-1].join(x):o.push(x)}),o}}),ne(se[48],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineSequence=void 0;class n{constructor(f,E){this.trimmedHash=f,this.lines=E}getElement(f){return this.trimmedHash[f]}get length(){return this.trimmedHash.length}getBoundaryScore(f){const E=f===0?0:F(this.lines[f-1]),h=f===this.lines.length?0:F(this.lines[f]);return 1e3-(E+h)}getText(f){return this.lines.slice(f.start,f.endExclusive).join(`
`)}isStronglyEqual(f,E){return this.lines[f]===this.lines[E]}}t.LineSequence=n;function F(D){let f=0;for(;f<D.length&&(D.charCodeAt(f)===32||D.charCodeAt(f)===9);)f++;return f}}),ne(se[16],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRangeFragment=t.Array2D=void 0,t.isSpace=F;class n{constructor(E,h){this.width=E,this.height=h,this.array=[],this.array=new Array(E*h)}get(E,h){return this.array[E+h*this.width]}set(E,h,l){this.array[E+h*this.width]=l}}t.Array2D=n;function F(f){return f===32||f===9}class D{static{this.chrKeys=new Map}static getKey(E){let h=this.chrKeys.get(E);return h===void 0&&(h=this.chrKeys.size,this.chrKeys.set(E,h)),h}constructor(E,h,l){this.range=E,this.lines=h,this.source=l,this.histogram=[];let s=0;for(let c=E.startLineNumber-1;c<E.endLineNumberExclusive-1;c++){const N=h[c];for(let m=0;m<N.length;m++){s++;const e=N[m],w=D.getKey(e);this.histogram[w]=(this.histogram[w]||0)+1}s++;const g=D.getKey(`
`);this.histogram[g]=(this.histogram[g]||0)+1}this.totalCount=s}computeSimilarity(E){let h=0;const l=Math.max(this.histogram.length,E.histogram.length);for(let s=0;s<l;s++)h+=Math.abs((this.histogram[s]??0)-(E.histogram[s]??0));return 1-h/(this.totalCount+E.totalCount)}}t.LineRangeFragment=D}),ne(se[49],ae([0,1,4,8,16]),function(W,t,n,F,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class f{compute(h,l,s=F.InfiniteTimeout.instance,c){if(h.length===0||l.length===0)return F.DiffAlgorithmResult.trivial(h,l);const N=new D.Array2D(h.length,l.length),g=new D.Array2D(h.length,l.length),m=new D.Array2D(h.length,l.length);for(let o=0;o<h.length;o++)for(let a=0;a<l.length;a++){if(!s.isValid())return F.DiffAlgorithmResult.trivialTimedOut(h,l);const i=o===0?0:N.get(o-1,a),u=a===0?0:N.get(o,a-1);let b;h.getElement(o)===l.getElement(a)?(o===0||a===0?b=0:b=N.get(o-1,a-1),o>0&&a>0&&g.get(o-1,a-1)===3&&(b+=m.get(o-1,a-1)),b+=c?c(o,a):1):b=-1;const d=Math.max(i,u,b);if(d===b){const v=o>0&&a>0?m.get(o-1,a-1):0;m.set(o,a,v+1),g.set(o,a,3)}else d===i?(m.set(o,a,0),g.set(o,a,1)):d===u&&(m.set(o,a,0),g.set(o,a,2));N.set(o,a,d)}const e=[];let w=h.length,A=l.length;function _(o,a){(o+1!==w||a+1!==A)&&e.push(new F.SequenceDiff(new n.OffsetRange(o+1,w),new n.OffsetRange(a+1,A))),w=o,A=a}let L=h.length-1,p=l.length-1;for(;L>=0&&p>=0;)g.get(L,p)===3?(_(L,p),L--,p--):g.get(L,p)===1?L--:p--;return _(-1,-1),e.reverse(),new F.DiffAlgorithmResult(e,!1)}}t.DynamicProgrammingDiffing=f}),ne(se[32],ae([0,1,9,4,5,2,16]),function(W,t,n,F,D,f,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinesSliceCharSequence=void 0;class h{constructor(e,w,A){this.lines=e,this.considerWhitespaceChanges=A,this.elements=[],this.firstCharOffsetByLine=[],this.additionalOffsetByLine=[];let _=!1;w.start>0&&w.endExclusive>=e.length&&(w=new F.OffsetRange(w.start-1,w.endExclusive),_=!0),this.lineRange=w,this.firstCharOffsetByLine[0]=0;for(let L=this.lineRange.start;L<this.lineRange.endExclusive;L++){let p=e[L],o=0;if(_)o=p.length,p="",_=!1;else if(!A){const a=p.trimStart();o=p.length-a.length,p=a.trimEnd()}this.additionalOffsetByLine.push(o);for(let a=0;a<p.length;a++)this.elements.push(p.charCodeAt(a));L<e.length-1&&(this.elements.push(10),this.firstCharOffsetByLine[L-this.lineRange.start+1]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new F.OffsetRange(0,this.length))}getText(e){return this.elements.slice(e.start,e.endExclusive).map(w=>String.fromCharCode(w)).join("")}getElement(e){return this.elements[e]}get length(){return this.elements.length}getBoundaryScore(e){const w=g(e>0?this.elements[e-1]:-1),A=g(e<this.elements.length?this.elements[e]:-1);if(w===7&&A===8)return 0;if(w===8)return 150;let _=0;return w!==A&&(_+=10,w===0&&A===1&&(_+=1)),_+=N(w),_+=N(A),_}translateOffset(e){if(this.lineRange.isEmpty)return new D.Position(this.lineRange.start+1,1);const w=(0,n.findLastIdxMonotonous)(this.firstCharOffsetByLine,A=>A<=e);return new D.Position(this.lineRange.start+w+1,e-this.firstCharOffsetByLine[w]+this.additionalOffsetByLine[w]+1)}translateRange(e){return f.Range.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.elements.length||!l(this.elements[e]))return;let w=e;for(;w>0&&l(this.elements[w-1]);)w--;let A=e;for(;A<this.elements.length&&l(this.elements[A]);)A++;return new F.OffsetRange(w,A)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,w){return this.elements[e]===this.elements[w]}extendToFullLines(e){const w=(0,n.findLastMonotonous)(this.firstCharOffsetByLine,_=>_<=e.start)??0,A=(0,n.findFirstMonotonous)(this.firstCharOffsetByLine,_=>e.endExclusive<=_)??this.elements.length;return new F.OffsetRange(w,A)}}t.LinesSliceCharSequence=h;function l(m){return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57}var s;(function(m){m[m.WordLower=0]="WordLower",m[m.WordUpper=1]="WordUpper",m[m.WordNumber=2]="WordNumber",m[m.End=3]="End",m[m.Other=4]="Other",m[m.Separator=5]="Separator",m[m.Space=6]="Space",m[m.LineBreakCR=7]="LineBreakCR",m[m.LineBreakLF=8]="LineBreakLF"})(s||(s={}));const c={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function N(m){return c[m]}function g(m){return m===10?8:m===13?7:(0,E.isSpace)(m)?6:m>=97&&m<=122?0:m>=65&&m<=90?1:m>=48&&m<=57?2:m===-1?3:m===44||m===59?5:4}}),ne(se[33],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MovedText=t.LinesDiff=void 0;class n{constructor(f,E,h){this.changes=f,this.moves=E,this.hitTimeout=h}}t.LinesDiff=n;class F{constructor(f,E){this.lineRangeMapping=f,this.changes=E}flip(){return new F(this.lineRangeMapping.flip(),this.changes.map(f=>f.flip()))}}t.MovedText=F}),ne(se[17],ae([0,1,12]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMapping=t.DetailedLineRangeMapping=t.LineRangeMapping=void 0;class F{static inverse(h,l,s){const c=[];let N=1,g=1;for(const e of h){const w=new F(new n.LineRange(N,e.original.startLineNumber),new n.LineRange(g,e.modified.startLineNumber));w.modified.isEmpty||c.push(w),N=e.original.endLineNumberExclusive,g=e.modified.endLineNumberExclusive}const m=new F(new n.LineRange(N,l+1),new n.LineRange(g,s+1));return m.modified.isEmpty||c.push(m),c}static clip(h,l,s){const c=[];for(const N of h){const g=N.original.intersect(l),m=N.modified.intersect(s);g&&!g.isEmpty&&m&&!m.isEmpty&&c.push(new F(g,m))}return c}constructor(h,l){this.original=h,this.modified=l}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new F(this.modified,this.original)}join(h){return new F(this.original.join(h.original),this.modified.join(h.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.LineRangeMapping=F;class D extends F{static fromRangeMappings(h){const l=n.LineRange.join(h.map(c=>n.LineRange.fromRangeInclusive(c.originalRange))),s=n.LineRange.join(h.map(c=>n.LineRange.fromRangeInclusive(c.modifiedRange)));return new D(l,s,h)}constructor(h,l,s){super(h,l),this.innerChanges=s}flip(){return new D(this.modified,this.original,this.innerChanges?.map(h=>h.flip()))}withInnerChangesFromLineRanges(){return new D(this.original,this.modified,[new f(this.original.toExclusiveRange(),this.modified.toExclusiveRange())])}}t.DetailedLineRangeMapping=D;class f{constructor(h,l){this.originalRange=h,this.modifiedRange=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new f(this.modifiedRange,this.originalRange)}}t.RangeMapping=f}),ne(se[50],ae([0,1,8,17,6,9,14,12,4,32,16,31]),function(W,t,n,F,D,f,E,h,l,s,c,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeMovedLines=g;function g(p,o,a,i,u,b){let{moves:d,excludedChanges:v}=e(p,o,a,b);if(!b.isValid())return[];const M=p.filter(S=>!v.has(S)),R=w(M,i,u,o,a,b);return(0,D.pushMany)(d,R),d=_(d),d=d.filter(S=>{const x=S.original.toOffsetRange().slice(o).map(k=>k.trim());return x.join(`
`).length>=15&&m(x,k=>k.length>=2)>=2}),d=L(p,d),d}function m(p,o){let a=0;for(const i of p)o(i)&&a++;return a}function e(p,o,a,i){const u=[],b=p.filter(M=>M.modified.isEmpty&&M.original.length>=3).map(M=>new c.LineRangeFragment(M.original,o,M)),d=new Set(p.filter(M=>M.original.isEmpty&&M.modified.length>=3).map(M=>new c.LineRangeFragment(M.modified,a,M))),v=new Set;for(const M of b){let R=-1,S;for(const x of d){const I=M.computeSimilarity(x);I>R&&(R=I,S=x)}if(R>.9&&S&&(d.delete(S),u.push(new F.LineRangeMapping(M.range,S.range)),v.add(M.source),v.add(S.source)),!i.isValid())return{moves:u,excludedChanges:v}}return{moves:u,excludedChanges:v}}function w(p,o,a,i,u,b){const d=[],v=new E.SetMap;for(const I of p)for(let k=I.original.startLineNumber;k<I.original.endLineNumberExclusive-2;k++){const y=`${o[k-1]}:${o[k+1-1]}:${o[k+2-1]}`;v.add(y,{range:new h.LineRange(k,k+3)})}const M=[];p.sort((0,D.compareBy)(I=>I.modified.startLineNumber,D.numberComparator));for(const I of p){let k=[];for(let y=I.modified.startLineNumber;y<I.modified.endLineNumberExclusive-2;y++){const C=`${a[y-1]}:${a[y+1-1]}:${a[y+2-1]}`,O=new h.LineRange(y,y+3),j=[];v.forEach(C,({range:K})=>{for(const X of k)if(X.originalLineRange.endLineNumberExclusive+1===K.endLineNumberExclusive&&X.modifiedLineRange.endLineNumberExclusive+1===O.endLineNumberExclusive){X.originalLineRange=new h.LineRange(X.originalLineRange.startLineNumber,K.endLineNumberExclusive),X.modifiedLineRange=new h.LineRange(X.modifiedLineRange.startLineNumber,O.endLineNumberExclusive),j.push(X);return}const U={modifiedLineRange:O,originalLineRange:K};M.push(U),j.push(U)}),k=j}if(!b.isValid())return[]}M.sort((0,D.reverseOrder)((0,D.compareBy)(I=>I.modifiedLineRange.length,D.numberComparator)));const R=new h.LineRangeSet,S=new h.LineRangeSet;for(const I of M){const k=I.modifiedLineRange.startLineNumber-I.originalLineRange.startLineNumber,y=R.subtractFrom(I.modifiedLineRange),C=S.subtractFrom(I.originalLineRange).getWithDelta(k),O=y.getIntersection(C);for(const j of O.ranges){if(j.length<3)continue;const K=j,U=j.delta(-k);d.push(new F.LineRangeMapping(U,K)),R.addRange(K),S.addRange(U)}}d.sort((0,D.compareBy)(I=>I.original.startLineNumber,D.numberComparator));const x=new f.MonotonousArray(p);for(let I=0;I<d.length;I++){const k=d[I],y=x.findLastMonotonous(P=>P.original.startLineNumber<=k.original.startLineNumber),C=(0,f.findLastMonotonous)(p,P=>P.modified.startLineNumber<=k.modified.startLineNumber),O=Math.max(k.original.startLineNumber-y.original.startLineNumber,k.modified.startLineNumber-C.modified.startLineNumber),j=x.findLastMonotonous(P=>P.original.startLineNumber<k.original.endLineNumberExclusive),K=(0,f.findLastMonotonous)(p,P=>P.modified.startLineNumber<k.modified.endLineNumberExclusive),U=Math.max(j.original.endLineNumberExclusive-k.original.endLineNumberExclusive,K.modified.endLineNumberExclusive-k.modified.endLineNumberExclusive);let X;for(X=0;X<O;X++){const P=k.original.startLineNumber-X-1,H=k.modified.startLineNumber-X-1;if(P>i.length||H>u.length||R.contains(H)||S.contains(P)||!A(i[P-1],u[H-1],b))break}X>0&&(S.addRange(new h.LineRange(k.original.startLineNumber-X,k.original.startLineNumber)),R.addRange(new h.LineRange(k.modified.startLineNumber-X,k.modified.startLineNumber)));let G;for(G=0;G<U;G++){const P=k.original.endLineNumberExclusive+G,H=k.modified.endLineNumberExclusive+G;if(P>i.length||H>u.length||R.contains(H)||S.contains(P)||!A(i[P-1],u[H-1],b))break}G>0&&(S.addRange(new h.LineRange(k.original.endLineNumberExclusive,k.original.endLineNumberExclusive+G)),R.addRange(new h.LineRange(k.modified.endLineNumberExclusive,k.modified.endLineNumberExclusive+G))),(X>0||G>0)&&(d[I]=new F.LineRangeMapping(new h.LineRange(k.original.startLineNumber-X,k.original.endLineNumberExclusive+G),new h.LineRange(k.modified.startLineNumber-X,k.modified.endLineNumberExclusive+G)))}return d}function A(p,o,a){if(p.trim()===o.trim())return!0;if(p.length>300&&o.length>300)return!1;const u=new N.MyersDiffAlgorithm().compute(new s.LinesSliceCharSequence([p],new l.OffsetRange(0,1),!1),new s.LinesSliceCharSequence([o],new l.OffsetRange(0,1),!1),a);let b=0;const d=n.SequenceDiff.invert(u.diffs,p.length);for(const S of d)S.seq1Range.forEach(x=>{(0,c.isSpace)(p.charCodeAt(x))||b++});function v(S){let x=0;for(let I=0;I<p.length;I++)(0,c.isSpace)(S.charCodeAt(I))||x++;return x}const M=v(p.length>o.length?p:o);return b/M>.6&&M>10}function _(p){if(p.length===0)return p;p.sort((0,D.compareBy)(a=>a.original.startLineNumber,D.numberComparator));const o=[p[0]];for(let a=1;a<p.length;a++){const i=o[o.length-1],u=p[a],b=u.original.startLineNumber-i.original.endLineNumberExclusive,d=u.modified.startLineNumber-i.modified.endLineNumberExclusive;if(b>=0&&d>=0&&b+d<=2){o[o.length-1]=i.join(u);continue}o.push(u)}return o}function L(p,o){const a=new f.MonotonousArray(p);return o=o.filter(i=>{const u=a.findLastMonotonous(v=>v.original.startLineNumber<i.original.endLineNumberExclusive)||new F.LineRangeMapping(new h.LineRange(1,1),new h.LineRange(1,1)),b=(0,f.findLastMonotonous)(p,v=>v.modified.startLineNumber<i.modified.endLineNumberExclusive);return u!==b}),o}}),ne(se[51],ae([0,1,6,13,12,4,2,8,49,31,50,47,48,32,33,17]),function(W,t,n,F,D,f,E,h,l,s,c,N,g,m,e,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DefaultLinesDiffComputer=void 0,t.lineRangeMappingFromRangeMappings=_,t.getLineRangeMapping=L;class A{constructor(){this.dynamicProgrammingDiffing=new l.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new s.MyersDiffAlgorithm}computeDiff(o,a,i){if(o.length<=1&&(0,n.equals)(o,a,(G,P)=>G===P))return new e.LinesDiff([],[],!1);if(o.length===1&&o[0].length===0||a.length===1&&a[0].length===0)return new e.LinesDiff([new w.DetailedLineRangeMapping(new D.LineRange(1,o.length+1),new D.LineRange(1,a.length+1),[new w.RangeMapping(new E.Range(1,1,o.length,o[0].length+1),new E.Range(1,1,a.length,a[0].length+1))])],[],!1);const u=i.maxComputationTimeMs===0?h.InfiniteTimeout.instance:new h.DateTimeout(i.maxComputationTimeMs),b=!i.ignoreTrimWhitespace,d=new Map;function v(G){let P=d.get(G);return P===void 0&&(P=d.size,d.set(G,P)),P}const M=o.map(G=>v(G.trim())),R=a.map(G=>v(G.trim())),S=new g.LineSequence(M,o),x=new g.LineSequence(R,a),I=S.length+x.length<1700?this.dynamicProgrammingDiffing.compute(S,x,u,(G,P)=>o[G]===a[P]?a[P].length===0?.1:1+Math.log(1+a[P].length):.99):this.myersDiffingAlgorithm.compute(S,x);let k=I.diffs,y=I.hitTimeout;k=(0,N.optimizeSequenceDiffs)(S,x,k),k=(0,N.removeVeryShortMatchingLinesBetweenDiffs)(S,x,k);const C=[],O=G=>{if(b)for(let P=0;P<G;P++){const H=j+P,ie=K+P;if(o[H]!==a[ie]){const oe=this.refineDiff(o,a,new h.SequenceDiff(new f.OffsetRange(H,H+1),new f.OffsetRange(ie,ie+1)),u,b);for(const ge of oe.mappings)C.push(ge);oe.hitTimeout&&(y=!0)}}};let j=0,K=0;for(const G of k){(0,F.assertFn)(()=>G.seq1Range.start-j===G.seq2Range.start-K);const P=G.seq1Range.start-j;O(P),j=G.seq1Range.endExclusive,K=G.seq2Range.endExclusive;const H=this.refineDiff(o,a,G,u,b);H.hitTimeout&&(y=!0);for(const ie of H.mappings)C.push(ie)}O(o.length-j);const U=_(C,o,a);let X=[];return i.computeMoves&&(X=this.computeMoves(U,o,a,M,R,u,b)),(0,F.assertFn)(()=>{function G(H,ie){if(H.lineNumber<1||H.lineNumber>ie.length)return!1;const oe=ie[H.lineNumber-1];return!(H.column<1||H.column>oe.length+1)}function P(H,ie){return!(H.startLineNumber<1||H.startLineNumber>ie.length+1||H.endLineNumberExclusive<1||H.endLineNumberExclusive>ie.length+1)}for(const H of U){if(!H.innerChanges)return!1;for(const ie of H.innerChanges)if(!(G(ie.modifiedRange.getStartPosition(),a)&&G(ie.modifiedRange.getEndPosition(),a)&&G(ie.originalRange.getStartPosition(),o)&&G(ie.originalRange.getEndPosition(),o)))return!1;if(!P(H.modified,a)||!P(H.original,o))return!1}return!0}),new e.LinesDiff(U,X,y)}computeMoves(o,a,i,u,b,d,v){return(0,c.computeMovedLines)(o,a,i,u,b,d).map(S=>{const x=this.refineDiff(a,i,new h.SequenceDiff(S.original.toOffsetRange(),S.modified.toOffsetRange()),d,v),I=_(x.mappings,a,i,!0);return new e.MovedText(S,I)})}refineDiff(o,a,i,u,b){const d=new m.LinesSliceCharSequence(o,i.seq1Range,b),v=new m.LinesSliceCharSequence(a,i.seq2Range,b),M=d.length+v.length<500?this.dynamicProgrammingDiffing.compute(d,v,u):this.myersDiffingAlgorithm.compute(d,v,u);let R=M.diffs;return R=(0,N.optimizeSequenceDiffs)(d,v,R),R=(0,N.extendDiffsToEntireWordIfAppropriate)(d,v,R),R=(0,N.removeShortMatches)(d,v,R),R=(0,N.removeVeryShortMatchingTextBetweenLongDiffs)(d,v,R),{mappings:R.map(x=>new w.RangeMapping(d.translateRange(x.seq1Range),v.translateRange(x.seq2Range))),hitTimeout:M.hitTimeout}}}t.DefaultLinesDiffComputer=A;function _(p,o,a,i=!1){const u=[];for(const b of(0,n.groupAdjacentBy)(p.map(d=>L(d,o,a)),(d,v)=>d.original.overlapOrTouch(v.original)||d.modified.overlapOrTouch(v.modified))){const d=b[0],v=b[b.length-1];u.push(new w.DetailedLineRangeMapping(d.original.join(v.original),d.modified.join(v.modified),b.map(M=>M.innerChanges[0])))}return(0,F.assertFn)(()=>!i&&u.length>0&&(u[0].modified.startLineNumber!==u[0].original.startLineNumber||a.length-u[u.length-1].modified.endLineNumberExclusive!==o.length-u[u.length-1].original.endLineNumberExclusive)?!1:(0,F.checkAdjacentItems)(u,(b,d)=>d.original.startLineNumber-b.original.endLineNumberExclusive===d.modified.startLineNumber-b.modified.endLineNumberExclusive&&b.original.endLineNumberExclusive<d.original.startLineNumber&&b.modified.endLineNumberExclusive<d.modified.startLineNumber)),u}function L(p,o,a){let i=0,u=0;p.modifiedRange.endColumn===1&&p.originalRange.endColumn===1&&p.originalRange.startLineNumber+i<=p.originalRange.endLineNumber&&p.modifiedRange.startLineNumber+i<=p.modifiedRange.endLineNumber&&(u=-1),p.modifiedRange.startColumn-1>=a[p.modifiedRange.startLineNumber-1].length&&p.originalRange.startColumn-1>=o[p.originalRange.startLineNumber-1].length&&p.originalRange.startLineNumber<=p.originalRange.endLineNumber+u&&p.modifiedRange.startLineNumber<=p.modifiedRange.endLineNumber+u&&(i=1);const b=new D.LineRange(p.originalRange.startLineNumber+i,p.originalRange.endLineNumber+1+u),d=new D.LineRange(p.modifiedRange.startLineNumber+i,p.modifiedRange.endLineNumber+1+u);return new w.DetailedLineRangeMapping(b,d,[p])}}),ne(se[34],ae([0,1,25,33,17,7,2,13,12]),function(W,t,n,F,D,f,E,h,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.LegacyLinesDiffComputer=void 0;const s=3;class c{computeDiff(i,u,b){const v=new _(i,u,{maxComputationTime:b.maxComputationTimeMs,shouldIgnoreTrimWhitespace:b.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),M=[];let R=null;for(const S of v.changes){let x;S.originalEndLineNumber===0?x=new l.LineRange(S.originalStartLineNumber+1,S.originalStartLineNumber+1):x=new l.LineRange(S.originalStartLineNumber,S.originalEndLineNumber+1);let I;S.modifiedEndLineNumber===0?I=new l.LineRange(S.modifiedStartLineNumber+1,S.modifiedStartLineNumber+1):I=new l.LineRange(S.modifiedStartLineNumber,S.modifiedEndLineNumber+1);let k=new D.DetailedLineRangeMapping(x,I,S.charChanges?.map(y=>new D.RangeMapping(new E.Range(y.originalStartLineNumber,y.originalStartColumn,y.originalEndLineNumber,y.originalEndColumn),new E.Range(y.modifiedStartLineNumber,y.modifiedStartColumn,y.modifiedEndLineNumber,y.modifiedEndColumn))));R&&(R.modified.endLineNumberExclusive===k.modified.startLineNumber||R.original.endLineNumberExclusive===k.original.startLineNumber)&&(k=new D.DetailedLineRangeMapping(R.original.join(k.original),R.modified.join(k.modified),R.innerChanges&&k.innerChanges?R.innerChanges.concat(k.innerChanges):void 0),M.pop()),M.push(k),R=k}return(0,h.assertFn)(()=>(0,h.checkAdjacentItems)(M,(S,x)=>x.original.startLineNumber-S.original.endLineNumberExclusive===x.modified.startLineNumber-S.modified.endLineNumberExclusive&&S.original.endLineNumberExclusive<x.original.startLineNumber&&S.modified.endLineNumberExclusive<x.modified.startLineNumber)),new F.LinesDiff(M,[],v.quitEarly)}}t.LegacyLinesDiffComputer=c;function N(a,i,u,b){return new n.LcsDiff(a,i,u).ComputeDiff(b)}class g{constructor(i){const u=[],b=[];for(let d=0,v=i.length;d<v;d++)u[d]=L(i[d],1),b[d]=p(i[d],1);this.lines=i,this._startColumns=u,this._endColumns=b}getElements(){const i=[];for(let u=0,b=this.lines.length;u<b;u++)i[u]=this.lines[u].substring(this._startColumns[u]-1,this._endColumns[u]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,u,b){const d=[],v=[],M=[];let R=0;for(let S=u;S<=b;S++){const x=this.lines[S],I=i?this._startColumns[S]:1,k=i?this._endColumns[S]:x.length+1;for(let y=I;y<k;y++)d[R]=x.charCodeAt(y-1),v[R]=S+1,M[R]=y,R++;!i&&S<b&&(d[R]=10,v[R]=S+1,M[R]=x.length+1,R++)}return new m(d,v,M)}}class m{constructor(i,u,b){this._charCodes=i,this._lineNumbers=u,this._columns=b}toString(){return"["+this._charCodes.map((i,u)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this._lineNumbers[u]},${this._columns[u]})`).join(", ")+"]"}_assertIndex(i,u){if(i<0||i>=u.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(i){return i>0&&i===this._lineNumbers.length?this.getEndLineNumber(i-1):(this._assertIndex(i,this._lineNumbers),this._lineNumbers[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this._assertIndex(i,this._lineNumbers),this._charCodes[i]===10?this._lineNumbers[i]+1:this._lineNumbers[i])}getStartColumn(i){return i>0&&i===this._columns.length?this.getEndColumn(i-1):(this._assertIndex(i,this._columns),this._columns[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this._assertIndex(i,this._columns),this._charCodes[i]===10?1:this._columns[i]+1)}}class e{constructor(i,u,b,d,v,M,R,S){this.originalStartLineNumber=i,this.originalStartColumn=u,this.originalEndLineNumber=b,this.originalEndColumn=d,this.modifiedStartLineNumber=v,this.modifiedStartColumn=M,this.modifiedEndLineNumber=R,this.modifiedEndColumn=S}static createFromDiffChange(i,u,b){const d=u.getStartLineNumber(i.originalStart),v=u.getStartColumn(i.originalStart),M=u.getEndLineNumber(i.originalStart+i.originalLength-1),R=u.getEndColumn(i.originalStart+i.originalLength-1),S=b.getStartLineNumber(i.modifiedStart),x=b.getStartColumn(i.modifiedStart),I=b.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),k=b.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new e(d,v,M,R,S,x,I,k)}}function w(a){if(a.length<=1)return a;const i=[a[0]];let u=i[0];for(let b=1,d=a.length;b<d;b++){const v=a[b],M=v.originalStart-(u.originalStart+u.originalLength),R=v.modifiedStart-(u.modifiedStart+u.modifiedLength);Math.min(M,R)<s?(u.originalLength=v.originalStart+v.originalLength-u.originalStart,u.modifiedLength=v.modifiedStart+v.modifiedLength-u.modifiedStart):(i.push(v),u=v)}return i}class A{constructor(i,u,b,d,v){this.originalStartLineNumber=i,this.originalEndLineNumber=u,this.modifiedStartLineNumber=b,this.modifiedEndLineNumber=d,this.charChanges=v}static createFromDiffResult(i,u,b,d,v,M,R){let S,x,I,k,y;if(u.originalLength===0?(S=b.getStartLineNumber(u.originalStart)-1,x=0):(S=b.getStartLineNumber(u.originalStart),x=b.getEndLineNumber(u.originalStart+u.originalLength-1)),u.modifiedLength===0?(I=d.getStartLineNumber(u.modifiedStart)-1,k=0):(I=d.getStartLineNumber(u.modifiedStart),k=d.getEndLineNumber(u.modifiedStart+u.modifiedLength-1)),M&&u.originalLength>0&&u.originalLength<20&&u.modifiedLength>0&&u.modifiedLength<20&&v()){const C=b.createCharSequence(i,u.originalStart,u.originalStart+u.originalLength-1),O=d.createCharSequence(i,u.modifiedStart,u.modifiedStart+u.modifiedLength-1);if(C.getElements().length>0&&O.getElements().length>0){let j=N(C,O,v,!0).changes;R&&(j=w(j)),y=[];for(let K=0,U=j.length;K<U;K++)y.push(e.createFromDiffChange(j[K],C,O))}}return new A(S,x,I,k,y)}}class _{constructor(i,u,b){this.shouldComputeCharChanges=b.shouldComputeCharChanges,this.shouldPostProcessCharChanges=b.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=b.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=b.shouldMakePrettyDiff,this.originalLines=i,this.modifiedLines=u,this.original=new g(i),this.modified=new g(u),this.continueLineDiff=o(b.maxComputationTime),this.continueCharDiff=o(b.maxComputationTime===0?0:Math.min(b.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=N(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),u=i.changes,b=i.quitEarly;if(this.shouldIgnoreTrimWhitespace){const R=[];for(let S=0,x=u.length;S<x;S++)R.push(A.createFromDiffResult(this.shouldIgnoreTrimWhitespace,u[S],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:b,changes:R}}const d=[];let v=0,M=0;for(let R=-1,S=u.length;R<S;R++){const x=R+1<S?u[R+1]:null,I=x?x.originalStart:this.originalLines.length,k=x?x.modifiedStart:this.modifiedLines.length;for(;v<I&&M<k;){const y=this.originalLines[v],C=this.modifiedLines[M];if(y!==C){{let O=L(y,1),j=L(C,1);for(;O>1&&j>1;){const K=y.charCodeAt(O-2),U=C.charCodeAt(j-2);if(K!==U)break;O--,j--}(O>1||j>1)&&this._pushTrimWhitespaceCharChange(d,v+1,1,O,M+1,1,j)}{let O=p(y,1),j=p(C,1);const K=y.length+1,U=C.length+1;for(;O<K&&j<U;){const X=y.charCodeAt(O-1),G=y.charCodeAt(j-1);if(X!==G)break;O++,j++}(O<K||j<U)&&this._pushTrimWhitespaceCharChange(d,v+1,O,K,M+1,j,U)}}v++,M++}x&&(d.push(A.createFromDiffResult(this.shouldIgnoreTrimWhitespace,x,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),v+=x.originalLength,M+=x.modifiedLength)}return{quitEarly:b,changes:d}}_pushTrimWhitespaceCharChange(i,u,b,d,v,M,R){if(this._mergeTrimWhitespaceCharChange(i,u,b,d,v,M,R))return;let S;this.shouldComputeCharChanges&&(S=[new e(u,b,u,d,v,M,v,R)]),i.push(new A(u,u,v,v,S))}_mergeTrimWhitespaceCharChange(i,u,b,d,v,M,R){const S=i.length;if(S===0)return!1;const x=i[S-1];return x.originalEndLineNumber===0||x.modifiedEndLineNumber===0?!1:x.originalEndLineNumber===u&&x.modifiedEndLineNumber===v?(this.shouldComputeCharChanges&&x.charChanges&&x.charChanges.push(new e(u,b,u,d,v,M,v,R)),!0):x.originalEndLineNumber+1===u&&x.modifiedEndLineNumber+1===v?(x.originalEndLineNumber=u,x.modifiedEndLineNumber=v,this.shouldComputeCharChanges&&x.charChanges&&x.charChanges.push(new e(u,b,u,d,v,M,v,R)),!0):!1}}t.DiffComputer=_;function L(a,i){const u=f.firstNonWhitespaceIndex(a);return u===-1?i:u+1}function p(a,i){const u=f.lastNonWhitespaceIndex(a);return u===-1?i:u+2}function o(a){if(a===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<a}}),ne(se[52],ae([0,1,34,51]),function(W,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={getLegacy:()=>new n.LegacyLinesDiffComputer,getDefault:()=>new F.DefaultLinesDiffComputer}}),ne(se[53],ae([0,1,36]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeDefaultDocumentColors=N;function F(g){const m=[];for(const e of g){const w=Number(e);(w||w===0&&e.replace(/\s/g,"")!=="")&&m.push(w)}return m}function D(g,m,e,w){return{red:g/255,blue:e/255,green:m/255,alpha:w}}function f(g,m){const e=m.index,w=m[0].length;if(!e)return;const A=g.positionAt(e);return{startLineNumber:A.lineNumber,startColumn:A.column,endLineNumber:A.lineNumber,endColumn:A.column+w}}function E(g,m){if(!g)return;const e=n.Color.Format.CSS.parseHex(m);if(e)return{range:g,color:D(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function h(g,m,e){if(!g||m.length!==1)return;const A=m[0].values(),_=F(A);return{range:g,color:D(_[0],_[1],_[2],e?_[3]:1)}}function l(g,m,e){if(!g||m.length!==1)return;const A=m[0].values(),_=F(A),L=new n.Color(new n.HSLA(_[0],_[1]/100,_[2]/100,e?_[3]:1));return{range:g,color:D(L.rgba.r,L.rgba.g,L.rgba.b,L.rgba.a)}}function s(g,m){return typeof g=="string"?[...g.matchAll(m)]:g.findMatches(m)}function c(g){const m=[],w=s(g,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(w.length>0)for(const A of w){const _=A.filter(a=>a!==void 0),L=_[1],p=_[2];if(!p)continue;let o;if(L==="rgb"){const a=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;o=h(f(g,A),s(p,a),!1)}else if(L==="rgba"){const a=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;o=h(f(g,A),s(p,a),!0)}else if(L==="hsl"){const a=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;o=l(f(g,A),s(p,a),!1)}else if(L==="hsla"){const a=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;o=l(f(g,A),s(p,a),!0)}else L==="#"&&(o=E(f(g,A),L+p));o&&m.push(o)}return m}function N(g){return!g||typeof g.getValue!="function"||typeof g.positionAt!="function"?[]:c(g)}}),ne(se[54],ae([0,1,29]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkComputer=t.StateMachine=t.State=void 0,t.computeLinks=g;var F;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(F||(t.State=F={}));class D{constructor(e,w,A){const _=new Uint8Array(e*w);for(let L=0,p=e*w;L<p;L++)_[L]=A;this._data=_,this.rows=e,this.cols=w}get(e,w){return this._data[e*this.cols+w]}set(e,w,A){this._data[e*this.cols+w]=A}}class f{constructor(e){let w=0,A=0;for(let L=0,p=e.length;L<p;L++){const[o,a,i]=e[L];a>w&&(w=a),o>A&&(A=o),i>A&&(A=i)}w++,A++;const _=new D(A,w,0);for(let L=0,p=e.length;L<p;L++){const[o,a,i]=e[L];_.set(o,a,i)}this._states=_,this._maxCharCode=w}nextState(e,w){return w<0||w>=this._maxCharCode?0:this._states.get(e,w)}}t.StateMachine=f;let E=null;function h(){return E===null&&(E=new f([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),E}var l;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let s=null;function c(){if(s===null){s=new n.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<m.length;w++)s.set(m.charCodeAt(w),1);const e=".,;:";for(let w=0;w<e.length;w++)s.set(e.charCodeAt(w),2)}return s}class N{static _createLink(e,w,A,_,L){let p=L-1;do{const o=w.charCodeAt(p);if(e.get(o)!==2)break;p--}while(p>_);if(_>0){const o=w.charCodeAt(_-1),a=w.charCodeAt(p);(o===40&&a===41||o===91&&a===93||o===123&&a===125)&&p--}return{range:{startLineNumber:A,startColumn:_+1,endLineNumber:A,endColumn:p+2},url:w.substring(_,p+1)}}static computeLinks(e,w=h()){const A=c(),_=[];for(let L=1,p=e.getLineCount();L<=p;L++){const o=e.getLineContent(L),a=o.length;let i=0,u=0,b=0,d=1,v=!1,M=!1,R=!1,S=!1;for(;i<a;){let x=!1;const I=o.charCodeAt(i);if(d===13){let k;switch(I){case 40:v=!0,k=0;break;case 41:k=v?0:1;break;case 91:R=!0,M=!0,k=0;break;case 93:R=!1,k=M?0:1;break;case 123:S=!0,k=0;break;case 125:k=S?0:1;break;case 39:case 34:case 96:b===I?k=1:b===39||b===34||b===96?k=0:k=1;break;case 42:k=b===42?1:0;break;case 124:k=b===124?1:0;break;case 32:k=R?0:1;break;default:k=A.get(I)}k===1&&(_.push(N._createLink(A,o,L,u,i)),x=!0)}else if(d===12){let k;I===91?(M=!0,k=0):k=A.get(I),k===1?x=!0:d=13}else d=w.nextState(d,I),d===0&&(x=!0);x&&(d=1,v=!1,M=!1,S=!1,u=i+1,b=I),i++}d===13&&_.push(N._createLink(A,o,L,u,a))}return _}}t.LinkComputer=N;function g(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:N.computeLinks(m)}}),ne(se[55],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class n{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new n}navigateValueSet(D,f,E,h,l){if(D&&f){const s=this.doNavigateValueSet(f,l);if(s)return{range:D,value:s}}if(E&&h){const s=this.doNavigateValueSet(h,l);if(s)return{range:E,value:s}}return null}doNavigateValueSet(D,f){const E=this.numberReplace(D,f);return E!==null?E:this.textReplace(D,f)}numberReplace(D,f){const E=Math.pow(10,D.length-(D.lastIndexOf(".")+1));let h=Number(D);const l=parseFloat(D);return!isNaN(h)&&!isNaN(l)&&h===l?h===0&&!f?null:(h=Math.floor(h*E),h+=f?E:-E,String(h/E)):null}textReplace(D,f){return this.valueSetsReplace(this._defaultValueSet,D,f)}valueSetsReplace(D,f,E){let h=null;for(let l=0,s=D.length;h===null&&l<s;l++)h=this.valueSetReplace(D[l],f,E);return h}valueSetReplace(D,f,E){let h=D.indexOf(f);return h>=0?(h+=E?1:-1,h<0?h=D.length-1:h%=D.length,D[h]):null}}t.BasicInplaceReplace=n}),ne(se[56],ae([0,1,15]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0,t.isITextSnapshot=e,t.shouldSynchronizeModel=o;var F;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=4]="Right",a[a.Full=7]="Full"})(F||(t.OverviewRulerLane=F={}));var D;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=3]="Right"})(D||(t.GlyphMarginLane=D={}));var f;(function(a){a[a.Inline=1]="Inline",a[a.Gutter=2]="Gutter"})(f||(t.MinimapPosition=f={}));var E;(function(a){a[a.Normal=1]="Normal",a[a.Underlined=2]="Underlined"})(E||(t.MinimapSectionHeaderStyle=E={}));var h;(function(a){a[a.Both=0]="Both",a[a.Right=1]="Right",a[a.Left=2]="Left",a[a.None=3]="None"})(h||(t.InjectedTextCursorStops=h={}));var l;(function(a){a[a.TextDefined=0]="TextDefined",a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(l||(t.EndOfLinePreference=l={}));var s;(function(a){a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(s||(t.DefaultEndOfLine=s={}));var c;(function(a){a[a.LF=0]="LF",a[a.CRLF=1]="CRLF"})(c||(t.EndOfLineSequence=c={}));class N{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(i){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,i.tabSize|0),i.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,i.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!i.insertSpaces,this.defaultEOL=i.defaultEOL|0,this.trimAutoWhitespace=!!i.trimAutoWhitespace,this.bracketPairColorizationOptions=i.bracketPairColorizationOptions}equals(i){return this.tabSize===i.tabSize&&this._indentSizeIsTabSize===i._indentSizeIsTabSize&&this.indentSize===i.indentSize&&this.insertSpaces===i.insertSpaces&&this.defaultEOL===i.defaultEOL&&this.trimAutoWhitespace===i.trimAutoWhitespace&&(0,n.equals)(this.bracketPairColorizationOptions,i.bracketPairColorizationOptions)}createChangeEvent(i){return{tabSize:this.tabSize!==i.tabSize,indentSize:this.indentSize!==i.indentSize,insertSpaces:this.insertSpaces!==i.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==i.trimAutoWhitespace}}}t.TextModelResolvedOptions=N;class g{constructor(i,u){this._findMatchBrand=void 0,this.range=i,this.matches=u}}t.FindMatch=g;var m;(function(a){a[a.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",a[a.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",a[a.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",a[a.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(t.TrackedRangeStickiness=m={}));function e(a){return a&&typeof a.read=="function"}var w;(function(a){a[a.Left=0]="Left",a[a.Right=1]="Right",a[a.None=2]="None",a[a.LeftOfInjectedText=3]="LeftOfInjectedText",a[a.RightOfInjectedText=4]="RightOfInjectedText"})(w||(t.PositionAffinity=w={}));var A;(function(a){a[a.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(A||(t.ModelConstants=A={}));class _{constructor(i,u,b,d,v,M){this.identifier=i,this.range=u,this.text=b,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=v,this._isTracked=M}}t.ValidAnnotatedEditOperation=_;class L{constructor(i,u,b){this.regex=i,this.wordSeparators=u,this.simpleSearch=b}}t.SearchData=L;class p{constructor(i,u,b){this.reverseEdits=i,this.changes=u,this.trimAutoWhitespaceLineNumbers=b}}t.ApplyEditsResult=p;function o(a){return!a.isTooLargeForSyncing()&&!a.isForSimpleWidget}}),ne(se[57],ae([0,1,6,28]),function(W,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class D{constructor(l){this.values=l,this.prefixSum=new Uint32Array(l.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(l,s){l=(0,F.toUint32)(l);const c=this.values,N=this.prefixSum,g=s.length;return g===0?!1:(this.values=new Uint32Array(c.length+g),this.values.set(c.subarray(0,l),0),this.values.set(c.subarray(l),l+g),this.values.set(s,l),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(N.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(l,s){return l=(0,F.toUint32)(l),s=(0,F.toUint32)(s),this.values[l]===s?!1:(this.values[l]=s,l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),!0)}removeValues(l,s){l=(0,F.toUint32)(l),s=(0,F.toUint32)(s);const c=this.values,N=this.prefixSum;if(l>=c.length)return!1;const g=c.length-l;return s>=g&&(s=g),s===0?!1:(this.values=new Uint32Array(c.length-s),this.values.set(c.subarray(0,l),0),this.values.set(c.subarray(l+s),l),this.prefixSum=new Uint32Array(this.values.length),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(N.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(l){return l<0?0:(l=(0,F.toUint32)(l),this._getPrefixSum(l))}_getPrefixSum(l){if(l<=this.prefixSumValidIndex[0])return this.prefixSum[l];let s=this.prefixSumValidIndex[0]+1;s===0&&(this.prefixSum[0]=this.values[0],s++),l>=this.values.length&&(l=this.values.length-1);for(let c=s;c<=l;c++)this.prefixSum[c]=this.prefixSum[c-1]+this.values[c];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],l),this.prefixSum[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let s=0,c=this.values.length-1,N=0,g=0,m=0;for(;s<=c;)if(N=s+(c-s)/2|0,g=this.prefixSum[N],m=g-this.values[N],l<m)c=N-1;else if(l>=g)s=N+1;else break;return new E(N,l-m)}}t.PrefixSumComputer=D;class f{constructor(l){this._values=l,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(l){return this._ensureValid(),l===0?0:this._prefixSum[l-1]}getIndexOf(l){this._ensureValid();const s=this._indexBySum[l],c=s>0?this._prefixSum[s-1]:0;return new E(s,l-c)}removeValues(l,s){this._values.splice(l,s),this._invalidate(l)}insertValues(l,s){this._values=(0,n.arrayInsert)(this._values,l,s),this._invalidate(l)}_invalidate(l){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,l-1)}_ensureValid(){if(!this._isValid){for(let l=this._validEndIndex+1,s=this._values.length;l<s;l++){const c=this._values[l],N=l>0?this._prefixSum[l-1]:0;this._prefixSum[l]=N+c;for(let g=0;g<c;g++)this._indexBySum[N+g]=l}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(l,s){this._values[l]!==s&&(this._values[l]=s,this._invalidate(l))}}t.ConstantTimePrefixSumComputer=f;class E{constructor(l,s){this.index=l,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=s}}t.PrefixSumIndexOfResult=E}),ne(se[58],ae([0,1,7,5,57]),function(W,t,n,F,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class f{constructor(h,l,s,c){this._uri=h,this._lines=l,this._eol=s,this._versionId=c,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(h){h.eol&&h.eol!==this._eol&&(this._eol=h.eol,this._lineStarts=null);const l=h.changes;for(const s of l)this._acceptDeleteRange(s.range),this._acceptInsertText(new F.Position(s.range.startLineNumber,s.range.startColumn),s.text);this._versionId=h.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const h=this._eol.length,l=this._lines.length,s=new Uint32Array(l);for(let c=0;c<l;c++)s[c]=this._lines[c].length+h;this._lineStarts=new D.PrefixSumComputer(s)}}_setLineText(h,l){this._lines[h]=l,this._lineStarts&&this._lineStarts.setValue(h,this._lines[h].length+this._eol.length)}_acceptDeleteRange(h){if(h.startLineNumber===h.endLineNumber){if(h.startColumn===h.endColumn)return;this._setLineText(h.startLineNumber-1,this._lines[h.startLineNumber-1].substring(0,h.startColumn-1)+this._lines[h.startLineNumber-1].substring(h.endColumn-1));return}this._setLineText(h.startLineNumber-1,this._lines[h.startLineNumber-1].substring(0,h.startColumn-1)+this._lines[h.endLineNumber-1].substring(h.endColumn-1)),this._lines.splice(h.startLineNumber,h.endLineNumber-h.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(h.startLineNumber,h.endLineNumber-h.startLineNumber)}_acceptInsertText(h,l){if(l.length===0)return;const s=(0,n.splitLines)(l);if(s.length===1){this._setLineText(h.lineNumber-1,this._lines[h.lineNumber-1].substring(0,h.column-1)+s[0]+this._lines[h.lineNumber-1].substring(h.column-1));return}s[s.length-1]+=this._lines[h.lineNumber-1].substring(h.column-1),this._setLineText(h.lineNumber-1,this._lines[h.lineNumber-1].substring(0,h.column-1)+s[0]);const c=new Uint32Array(s.length-1);for(let N=1;N<s.length;N++)this._lines.splice(h.lineNumber+N-1,0,s[N]),c[N-1]=s[N].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(h.lineNumber,c)}}t.MirrorTextModel=f}),ne(se[59],ae([0,1,7,46,5,2,56]),function(W,t,n,F,D,f,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.TextModelSearch=t.SearchParams=void 0,t.isMultilineRegexSource=s,t.createFindMatch=c,t.isValidMatch=w;const h=999;class l{constructor(L,p,o,a){this.searchString=L,this.isRegex=p,this.matchCase=o,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let L;this.isRegex?L=s(this.searchString):L=this.searchString.indexOf(`
`)>=0;let p=null;try{p=n.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:L,global:!0,unicode:!0})}catch{return null}if(!p)return null;let o=!this.isRegex&&!L;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new E.SearchData(p,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators,[]):null,o?this.searchString:null)}}t.SearchParams=l;function s(_){if(!_||_.length===0)return!1;for(let L=0,p=_.length;L<p;L++){const o=_.charCodeAt(L);if(o===10)return!0;if(o===92){if(L++,L>=p)break;const a=_.charCodeAt(L);if(a===110||a===114||a===87)return!0}}return!1}function c(_,L,p){if(!p)return new E.FindMatch(_,null);const o=[];for(let a=0,i=L.length;a<i;a++)o[a]=L[a];return new E.FindMatch(_,o)}class N{constructor(L){const p=[];let o=0;for(let a=0,i=L.length;a<i;a++)L.charCodeAt(a)===10&&(p[o++]=a);this._lineFeedsOffsets=p}findLineFeedCountBeforeOffset(L){const p=this._lineFeedsOffsets;let o=0,a=p.length-1;if(a===-1||L<=p[0])return 0;for(;o<a;){const i=o+((a-o)/2>>0);p[i]>=L?a=i-1:p[i+1]>=L?(o=i,a=i):o=i+1}return o+1}}class g{static findMatches(L,p,o,a,i){const u=p.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(L,o,new A(u.wordSeparators,u.regex),a,i):this._doFindMatchesLineByLine(L,o,u,a,i):[]}static _getMultilineMatchRange(L,p,o,a,i,u){let b,d=0;a?(d=a.findLineFeedCountBeforeOffset(i),b=p+i+d):b=p+i;let v;if(a){const x=a.findLineFeedCountBeforeOffset(i+u.length)-d;v=b+u.length+x}else v=b+u.length;const M=L.getPositionAt(b),R=L.getPositionAt(v);return new f.Range(M.lineNumber,M.column,R.lineNumber,R.column)}static _doFindMatchesMultiline(L,p,o,a,i){const u=L.getOffsetAt(p.getStartPosition()),b=L.getValueInRange(p,1),d=L.getEOL()===`\r
`?new N(b):null,v=[];let M=0,R;for(o.reset(0);R=o.next(b);)if(v[M++]=c(this._getMultilineMatchRange(L,u,b,d,R.index,R[0]),R,a),M>=i)return v;return v}static _doFindMatchesLineByLine(L,p,o,a,i){const u=[];let b=0;if(p.startLineNumber===p.endLineNumber){const v=L.getLineContent(p.startLineNumber).substring(p.startColumn-1,p.endColumn-1);return b=this._findMatchesInLine(o,v,p.startLineNumber,p.startColumn-1,b,u,a,i),u}const d=L.getLineContent(p.startLineNumber).substring(p.startColumn-1);b=this._findMatchesInLine(o,d,p.startLineNumber,p.startColumn-1,b,u,a,i);for(let v=p.startLineNumber+1;v<p.endLineNumber&&b<i;v++)b=this._findMatchesInLine(o,L.getLineContent(v),v,0,b,u,a,i);if(b<i){const v=L.getLineContent(p.endLineNumber).substring(0,p.endColumn-1);b=this._findMatchesInLine(o,v,p.endLineNumber,0,b,u,a,i)}return u}static _findMatchesInLine(L,p,o,a,i,u,b,d){const v=L.wordSeparators;if(!b&&L.simpleSearch){const S=L.simpleSearch,x=S.length,I=p.length;let k=-x;for(;(k=p.indexOf(S,k+x))!==-1;)if((!v||w(v,p,I,k,x))&&(u[i++]=new E.FindMatch(new f.Range(o,k+1+a,o,k+1+x+a),null),i>=d))return i;return i}const M=new A(L.wordSeparators,L.regex);let R;M.reset(0);do if(R=M.next(p),R&&(u[i++]=c(new f.Range(o,R.index+1+a,o,R.index+1+R[0].length+a),R,b),i>=d))return i;while(R);return i}static findNextMatch(L,p,o,a){const i=p.parseSearchRequest();if(!i)return null;const u=new A(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(L,o,u,a):this._doFindNextMatchLineByLine(L,o,u,a)}static _doFindNextMatchMultiline(L,p,o,a){const i=new D.Position(p.lineNumber,1),u=L.getOffsetAt(i),b=L.getLineCount(),d=L.getValueInRange(new f.Range(i.lineNumber,i.column,b,L.getLineMaxColumn(b)),1),v=L.getEOL()===`\r
`?new N(d):null;o.reset(p.column-1);const M=o.next(d);return M?c(this._getMultilineMatchRange(L,u,d,v,M.index,M[0]),M,a):p.lineNumber!==1||p.column!==1?this._doFindNextMatchMultiline(L,new D.Position(1,1),o,a):null}static _doFindNextMatchLineByLine(L,p,o,a){const i=L.getLineCount(),u=p.lineNumber,b=L.getLineContent(u),d=this._findFirstMatchInLine(o,b,u,p.column,a);if(d)return d;for(let v=1;v<=i;v++){const M=(u+v-1)%i,R=L.getLineContent(M+1),S=this._findFirstMatchInLine(o,R,M+1,1,a);if(S)return S}return null}static _findFirstMatchInLine(L,p,o,a,i){L.reset(a-1);const u=L.next(p);return u?c(new f.Range(o,u.index+1,o,u.index+1+u[0].length),u,i):null}static findPreviousMatch(L,p,o,a){const i=p.parseSearchRequest();if(!i)return null;const u=new A(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(L,o,u,a):this._doFindPreviousMatchLineByLine(L,o,u,a)}static _doFindPreviousMatchMultiline(L,p,o,a){const i=this._doFindMatchesMultiline(L,new f.Range(1,1,p.lineNumber,p.column),o,a,10*h);if(i.length>0)return i[i.length-1];const u=L.getLineCount();return p.lineNumber!==u||p.column!==L.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(L,new D.Position(u,L.getLineMaxColumn(u)),o,a):null}static _doFindPreviousMatchLineByLine(L,p,o,a){const i=L.getLineCount(),u=p.lineNumber,b=L.getLineContent(u).substring(0,p.column-1),d=this._findLastMatchInLine(o,b,u,a);if(d)return d;for(let v=1;v<=i;v++){const M=(i+u-v-1)%i,R=L.getLineContent(M+1),S=this._findLastMatchInLine(o,R,M+1,a);if(S)return S}return null}static _findLastMatchInLine(L,p,o,a){let i=null,u;for(L.reset(0);u=L.next(p);)i=c(new f.Range(o,u.index+1,o,u.index+1+u[0].length),u,a);return i}}t.TextModelSearch=g;function m(_,L,p,o,a){if(o===0)return!0;const i=L.charCodeAt(o-1);if(_.get(i)!==0||i===13||i===10)return!0;if(a>0){const u=L.charCodeAt(o);if(_.get(u)!==0)return!0}return!1}function e(_,L,p,o,a){if(o+a===p)return!0;const i=L.charCodeAt(o+a);if(_.get(i)!==0||i===13||i===10)return!0;if(a>0){const u=L.charCodeAt(o+a-1);if(_.get(u)!==0)return!0}return!1}function w(_,L,p,o,a){return m(_,L,p,o,a)&&e(_,L,p,o,a)}class A{constructor(L,p){this._wordSeparators=L,this._searchRegex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(L){this._searchRegex.lastIndex=L,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(L){const p=L.length;let o;do{if(this._prevMatchStartIndex+this._prevMatchLength===p||(o=this._searchRegex.exec(L),!o))return null;const a=o.index,i=o[0].length;if(a===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){n.getNextCodePoint(L,p,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=i,!this._wordSeparators||w(this._wordSeparators,L,p,a,i))return o}while(o);return null}}t.Searcher=A}),ne(se[60],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.findSectionHeaders=D;const n=/\bMARK:\s*(.*)$/d,F=/^-+|-+$/g;function D(s,c){let N=[];if(c.findRegionSectionHeaders&&c.foldingRules?.markers){const g=f(s,c);N=N.concat(g)}if(c.findMarkSectionHeaders){const g=E(s);N=N.concat(g)}return N}function f(s,c){const N=[],g=s.getLineCount();for(let m=1;m<=g;m++){const e=s.getLineContent(m),w=e.match(c.foldingRules.markers.start);if(w){const A={startLineNumber:m,startColumn:w[0].length+1,endLineNumber:m,endColumn:e.length+1};if(A.endColumn>A.startColumn){const _={range:A,...l(e.substring(w[0].length)),shouldBeInComments:!1};(_.text||_.hasSeparatorLine)&&N.push(_)}}}return N}function E(s){const c=[],N=s.getLineCount();for(let g=1;g<=N;g++){const m=s.getLineContent(g);h(m,g,c)}return c}function h(s,c,N){n.lastIndex=0;const g=n.exec(s);if(g){const m=g.indices[1][0]+1,e=g.indices[1][1]+1,w={startLineNumber:c,startColumn:m,endLineNumber:c,endColumn:e};if(w.endColumn>w.startColumn){const A={range:w,...l(g[1]),shouldBeInComments:!0};(A.text||A.hasSeparatorLine)&&N.push(A)}}}function l(s){s=s.trim();const c=s.startsWith("-");return s=s.replace(F,""),{text:s,hasSeparatorLine:c}}}),ne(se[61],ae([0,1,2,59,7,13,30]),function(W,t,n,F,D,f,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class h{static computeUnicodeHighlights(e,w,A){const _=A?A.startLineNumber:1,L=A?A.endLineNumber:e.getLineCount(),p=new c(w),o=p.getCandidateCodePoints();let a;o==="allNonBasicAscii"?a=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):a=new RegExp(`${l(Array.from(o))}`,"g");const i=new F.Searcher(null,a),u=[];let b=!1,d,v=0,M=0,R=0;e:for(let S=_,x=L;S<=x;S++){const I=e.getLineContent(S),k=I.length;i.reset(0);do if(d=i.next(I),d){let y=d.index,C=d.index+d[0].length;if(y>0){const U=I.charCodeAt(y-1);D.isHighSurrogate(U)&&y--}if(C+1<k){const U=I.charCodeAt(C-1);D.isHighSurrogate(U)&&C++}const O=I.substring(y,C);let j=(0,E.getWordAtText)(y+1,E.DEFAULT_WORD_REGEXP,I,0);j&&j.endColumn<=y+1&&(j=null);const K=p.shouldHighlightNonBasicASCII(O,j?j.word:null);if(K!==0){if(K===3?v++:K===2?M++:K===1?R++:(0,f.assertNever)(K),u.length>=1e3){b=!0;break e}u.push(new n.Range(S,y+1,S,C+1))}}while(d)}return{ranges:u,hasMore:b,ambiguousCharacterCount:v,invisibleCharacterCount:M,nonBasicAsciiCharacterCount:R}}static computeUnicodeHighlightReason(e,w){const A=new c(w);switch(A.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const L=e.codePointAt(0),p=A.ambiguousCharacters.getPrimaryConfusable(L),o=D.AmbiguousCharacters.getLocales().filter(a=>!D.AmbiguousCharacters.getInstance(new Set([...w.allowedLocales,a])).isAmbiguous(L));return{kind:0,confusableWith:String.fromCodePoint(p),notAmbiguousInLocales:o}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=h;function l(m,e){return`[${D.escapeRegExpCharacters(m.map(A=>String.fromCodePoint(A)).join(""))}]`}var s;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class c{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=D.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const w of D.InvisibleCharacters.codePoints)N(String.fromCodePoint(w))||e.add(w);if(this.options.ambiguousCharacters)for(const w of this.ambiguousCharacters.getConfusableCodePoints())e.add(w);for(const w of this.allowedCodePoints)e.delete(w);return e}shouldHighlightNonBasicASCII(e,w){const A=e.codePointAt(0);if(this.allowedCodePoints.has(A))return 0;if(this.options.nonBasicASCII)return 1;let _=!1,L=!1;if(w)for(const p of w){const o=p.codePointAt(0),a=D.isBasicASCII(p);_=_||a,!a&&!this.ambiguousCharacters.isAmbiguous(o)&&!D.InvisibleCharacters.isInvisibleCharacter(o)&&(L=!0)}return!_&&L?0:this.options.invisibleCharacters&&!N(e)&&D.InvisibleCharacters.isInvisibleCharacter(A)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(A)?3:0}}function N(m){return m===" "||m===`
`||m==="	"}var g;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(g||(g={}))}),ne(se[62],ae([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.PartialAcceptTriggerKind=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var n;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(n||(t.AccessibilitySupport=n={}));var F;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(F||(t.CodeActionTriggerType=F={}));var D;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(D||(t.CompletionItemInsertTextRule=D={}));var f;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(f||(t.CompletionItemKind=f={}));var E;(function(r){r[r.Deprecated=1]="Deprecated"})(E||(t.CompletionItemTag=E={}));var h;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(t.CompletionTriggerKind=h={}));var l;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(l||(t.ContentWidgetPositionPreference=l={}));var s;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var c;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(c||(t.DefaultEndOfLine=c={}));var N;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(N||(t.DocumentHighlightKind=N={}));var g;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(g||(t.EditorAutoIndentStrategy=g={}));var m;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.ariaRequired=5]="ariaRequired",r[r.autoClosingBrackets=6]="autoClosingBrackets",r[r.autoClosingComments=7]="autoClosingComments",r[r.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",r[r.autoClosingDelete=9]="autoClosingDelete",r[r.autoClosingOvertype=10]="autoClosingOvertype",r[r.autoClosingQuotes=11]="autoClosingQuotes",r[r.autoIndent=12]="autoIndent",r[r.automaticLayout=13]="automaticLayout",r[r.autoSurround=14]="autoSurround",r[r.bracketPairColorization=15]="bracketPairColorization",r[r.guides=16]="guides",r[r.codeLens=17]="codeLens",r[r.codeLensFontFamily=18]="codeLensFontFamily",r[r.codeLensFontSize=19]="codeLensFontSize",r[r.colorDecorators=20]="colorDecorators",r[r.colorDecoratorsLimit=21]="colorDecoratorsLimit",r[r.columnSelection=22]="columnSelection",r[r.comments=23]="comments",r[r.contextmenu=24]="contextmenu",r[r.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",r[r.cursorBlinking=26]="cursorBlinking",r[r.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",r[r.cursorStyle=28]="cursorStyle",r[r.cursorSurroundingLines=29]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",r[r.cursorWidth=31]="cursorWidth",r[r.disableLayerHinting=32]="disableLayerHinting",r[r.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",r[r.domReadOnly=34]="domReadOnly",r[r.dragAndDrop=35]="dragAndDrop",r[r.dropIntoEditor=36]="dropIntoEditor",r[r.emptySelectionClipboard=37]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",r[r.extraEditorClassName=39]="extraEditorClassName",r[r.fastScrollSensitivity=40]="fastScrollSensitivity",r[r.find=41]="find",r[r.fixedOverflowWidgets=42]="fixedOverflowWidgets",r[r.folding=43]="folding",r[r.foldingStrategy=44]="foldingStrategy",r[r.foldingHighlight=45]="foldingHighlight",r[r.foldingImportsByDefault=46]="foldingImportsByDefault",r[r.foldingMaximumRegions=47]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=49]="fontFamily",r[r.fontInfo=50]="fontInfo",r[r.fontLigatures=51]="fontLigatures",r[r.fontSize=52]="fontSize",r[r.fontWeight=53]="fontWeight",r[r.fontVariations=54]="fontVariations",r[r.formatOnPaste=55]="formatOnPaste",r[r.formatOnType=56]="formatOnType",r[r.glyphMargin=57]="glyphMargin",r[r.gotoLocation=58]="gotoLocation",r[r.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",r[r.hover=60]="hover",r[r.inDiffEditor=61]="inDiffEditor",r[r.inlineSuggest=62]="inlineSuggest",r[r.inlineEdit=63]="inlineEdit",r[r.letterSpacing=64]="letterSpacing",r[r.lightbulb=65]="lightbulb",r[r.lineDecorationsWidth=66]="lineDecorationsWidth",r[r.lineHeight=67]="lineHeight",r[r.lineNumbers=68]="lineNumbers",r[r.lineNumbersMinChars=69]="lineNumbersMinChars",r[r.linkedEditing=70]="linkedEditing",r[r.links=71]="links",r[r.matchBrackets=72]="matchBrackets",r[r.minimap=73]="minimap",r[r.mouseStyle=74]="mouseStyle",r[r.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=76]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",r[r.multiCursorModifier=78]="multiCursorModifier",r[r.multiCursorPaste=79]="multiCursorPaste",r[r.multiCursorLimit=80]="multiCursorLimit",r[r.occurrencesHighlight=81]="occurrencesHighlight",r[r.overviewRulerBorder=82]="overviewRulerBorder",r[r.overviewRulerLanes=83]="overviewRulerLanes",r[r.padding=84]="padding",r[r.pasteAs=85]="pasteAs",r[r.parameterHints=86]="parameterHints",r[r.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",r[r.quickSuggestions=89]="quickSuggestions",r[r.quickSuggestionsDelay=90]="quickSuggestionsDelay",r[r.readOnly=91]="readOnly",r[r.readOnlyMessage=92]="readOnlyMessage",r[r.renameOnType=93]="renameOnType",r[r.renderControlCharacters=94]="renderControlCharacters",r[r.renderFinalNewline=95]="renderFinalNewline",r[r.renderLineHighlight=96]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=98]="renderValidationDecorations",r[r.renderWhitespace=99]="renderWhitespace",r[r.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",r[r.roundedSelection=101]="roundedSelection",r[r.rulers=102]="rulers",r[r.scrollbar=103]="scrollbar",r[r.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=105]="scrollBeyondLastLine",r[r.scrollPredominantAxis=106]="scrollPredominantAxis",r[r.selectionClipboard=107]="selectionClipboard",r[r.selectionHighlight=108]="selectionHighlight",r[r.selectOnLineNumbers=109]="selectOnLineNumbers",r[r.showFoldingControls=110]="showFoldingControls",r[r.showUnused=111]="showUnused",r[r.snippetSuggestions=112]="snippetSuggestions",r[r.smartSelect=113]="smartSelect",r[r.smoothScrolling=114]="smoothScrolling",r[r.stickyScroll=115]="stickyScroll",r[r.stickyTabStops=116]="stickyTabStops",r[r.stopRenderingLineAfter=117]="stopRenderingLineAfter",r[r.suggest=118]="suggest",r[r.suggestFontSize=119]="suggestFontSize",r[r.suggestLineHeight=120]="suggestLineHeight",r[r.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",r[r.suggestSelection=122]="suggestSelection",r[r.tabCompletion=123]="tabCompletion",r[r.tabIndex=124]="tabIndex",r[r.unicodeHighlighting=125]="unicodeHighlighting",r[r.unusualLineTerminators=126]="unusualLineTerminators",r[r.useShadowDOM=127]="useShadowDOM",r[r.useTabStops=128]="useTabStops",r[r.wordBreak=129]="wordBreak",r[r.wordSegmenterLocales=130]="wordSegmenterLocales",r[r.wordSeparators=131]="wordSeparators",r[r.wordWrap=132]="wordWrap",r[r.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=135]="wordWrapColumn",r[r.wordWrapOverride1=136]="wordWrapOverride1",r[r.wordWrapOverride2=137]="wordWrapOverride2",r[r.wrappingIndent=138]="wrappingIndent",r[r.wrappingStrategy=139]="wrappingStrategy",r[r.showDeprecated=140]="showDeprecated",r[r.inlayHints=141]="inlayHints",r[r.editorClassName=142]="editorClassName",r[r.pixelRatio=143]="pixelRatio",r[r.tabFocusMode=144]="tabFocusMode",r[r.layoutInfo=145]="layoutInfo",r[r.wrappingInfo=146]="wrappingInfo",r[r.defaultColorDecorators=147]="defaultColorDecorators",r[r.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",r[r.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(m||(t.EditorOption=m={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var w;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(w||(t.EndOfLineSequence=w={}));var A;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(A||(t.GlyphMarginLane=A={}));var _;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(_||(t.IndentAction=_={}));var L;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(L||(t.InjectedTextCursorStops=L={}));var p;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(p||(t.InlayHintKind=p={}));var o;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(o||(t.InlineCompletionTriggerKind=o={}));var a;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(a||(t.InlineEditTriggerKind=a={}));var i;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.F20=78]="F20",r[r.F21=79]="F21",r[r.F22=80]="F22",r[r.F23=81]="F23",r[r.F24=82]="F24",r[r.NumLock=83]="NumLock",r[r.ScrollLock=84]="ScrollLock",r[r.Semicolon=85]="Semicolon",r[r.Equal=86]="Equal",r[r.Comma=87]="Comma",r[r.Minus=88]="Minus",r[r.Period=89]="Period",r[r.Slash=90]="Slash",r[r.Backquote=91]="Backquote",r[r.BracketLeft=92]="BracketLeft",r[r.Backslash=93]="Backslash",r[r.BracketRight=94]="BracketRight",r[r.Quote=95]="Quote",r[r.OEM_8=96]="OEM_8",r[r.IntlBackslash=97]="IntlBackslash",r[r.Numpad0=98]="Numpad0",r[r.Numpad1=99]="Numpad1",r[r.Numpad2=100]="Numpad2",r[r.Numpad3=101]="Numpad3",r[r.Numpad4=102]="Numpad4",r[r.Numpad5=103]="Numpad5",r[r.Numpad6=104]="Numpad6",r[r.Numpad7=105]="Numpad7",r[r.Numpad8=106]="Numpad8",r[r.Numpad9=107]="Numpad9",r[r.NumpadMultiply=108]="NumpadMultiply",r[r.NumpadAdd=109]="NumpadAdd",r[r.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=111]="NumpadSubtract",r[r.NumpadDecimal=112]="NumpadDecimal",r[r.NumpadDivide=113]="NumpadDivide",r[r.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",r[r.ABNT_C1=115]="ABNT_C1",r[r.ABNT_C2=116]="ABNT_C2",r[r.AudioVolumeMute=117]="AudioVolumeMute",r[r.AudioVolumeUp=118]="AudioVolumeUp",r[r.AudioVolumeDown=119]="AudioVolumeDown",r[r.BrowserSearch=120]="BrowserSearch",r[r.BrowserHome=121]="BrowserHome",r[r.BrowserBack=122]="BrowserBack",r[r.BrowserForward=123]="BrowserForward",r[r.MediaTrackNext=124]="MediaTrackNext",r[r.MediaTrackPrevious=125]="MediaTrackPrevious",r[r.MediaStop=126]="MediaStop",r[r.MediaPlayPause=127]="MediaPlayPause",r[r.LaunchMediaPlayer=128]="LaunchMediaPlayer",r[r.LaunchMail=129]="LaunchMail",r[r.LaunchApp2=130]="LaunchApp2",r[r.Clear=131]="Clear",r[r.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var u;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(u||(t.MarkerSeverity=u={}));var b;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(b||(t.MarkerTag=b={}));var d;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(d||(t.MinimapPosition=d={}));var v;(function(r){r[r.Normal=1]="Normal",r[r.Underlined=2]="Underlined"})(v||(t.MinimapSectionHeaderStyle=v={}));var M;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(M||(t.MouseTargetType=M={}));var R;(function(r){r[r.AIGenerated=1]="AIGenerated"})(R||(t.NewSymbolNameTag=R={}));var S;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(S||(t.OverlayWidgetPositionPreference=S={}));var x;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(x||(t.OverviewRulerLane=x={}));var I;(function(r){r[r.Word=0]="Word",r[r.Line=1]="Line",r[r.Suggest=2]="Suggest"})(I||(t.PartialAcceptTriggerKind=I={}));var k;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(k||(t.PositionAffinity=k={}));var y;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(y||(t.RenderLineNumbersType=y={}));var C;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(C||(t.RenderMinimap=C={}));var O;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(O||(t.ScrollType=O={}));var j;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(j||(t.ScrollbarVisibility=j={}));var K;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(K||(t.SelectionDirection=K={}));var U;(function(r){r.Off="off",r.OnCode="onCode",r.On="on"})(U||(t.ShowLightbulbIconMode=U={}));var X;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(X||(t.SignatureHelpTriggerKind=X={}));var G;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(G||(t.SymbolKind=G={}));var P;(function(r){r[r.Deprecated=1]="Deprecated"})(P||(t.SymbolTag=P={}));var H;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(H||(t.TextEditorCursorBlinkingStyle=H={}));var ie;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(ie||(t.TextEditorCursorStyle=ie={}));var oe;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(oe||(t.TrackedRangeStickiness=oe={}));var ge;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(ge||(t.WrappingIndent=ge={}))}),ne(se[63],ae([0,1,11,10]),function(W,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class D{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new n.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(h){this._onDidChange.fire({changedLanguages:h,changedColorMap:!1})}register(h,l){return this._tokenizationSupports.set(h,l),this.handleChange([h]),(0,F.toDisposable)(()=>{this._tokenizationSupports.get(h)===l&&(this._tokenizationSupports.delete(h),this.handleChange([h]))})}get(h){return this._tokenizationSupports.get(h)||null}registerFactory(h,l){this._factories.get(h)?.dispose();const s=new f(this,h,l);return this._factories.set(h,s),(0,F.toDisposable)(()=>{const c=this._factories.get(h);!c||c!==s||(this._factories.delete(h),c.dispose())})}async getOrCreate(h){const l=this.get(h);if(l)return l;const s=this._factories.get(h);return!s||s.isResolved?null:(await s.resolve(),this.get(h))}isResolved(h){if(this.get(h))return!0;const s=this._factories.get(h);return!!(!s||s.isResolved)}setColorMap(h){this._colorMap=h,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}t.TokenizationRegistry=D;class f extends F.Disposable{get isResolved(){return this._isResolved}constructor(h,l,s){super(),this._registry=h,this._languageId=l,this._factory=s,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const h=await this._factory.tokenizationSupport;this._isResolved=!0,h&&!this._isDisposed&&this._register(this._registry.register(this._languageId,h))}}}),ne(se[64],ae([65,66]),function(W,t){return W.create("vs/base/common/platform",t)}),ne(se[18],ae([0,1,64]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.webWorkerOrigin=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.Platform=t.LANGUAGE_DEFAULT=void 0,t.PlatformToString=u,t.isLittleEndian=S,t.isBigSurOrNewer=x,t.LANGUAGE_DEFAULT="en";let F=!1,D=!1,f=!1,E=!1,h=!1,l=!1,s=!1,c=!1,N=!1,g=!1,m,e=t.LANGUAGE_DEFAULT,w=t.LANGUAGE_DEFAULT,A,_;const L=globalThis;let p;typeof L.vscode<"u"&&typeof L.vscode.process<"u"?p=L.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(p=process);const o=typeof p?.versions?.electron=="string",a=o&&p?.type==="renderer";if(typeof p=="object"){F=p.platform==="win32",D=p.platform==="darwin",f=p.platform==="linux",E=f&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,s=o,N=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const I=p.env.VSCODE_NLS_CONFIG;if(I)try{const k=JSON.parse(I),y=k.availableLanguages["*"];m=k.locale,w=k.osLocale,e=y||t.LANGUAGE_DEFAULT,A=k._translationsConfigFile}catch{}h=!0}else typeof navigator=="object"&&!a?(_=navigator.userAgent,F=_.indexOf("Windows")>=0,D=_.indexOf("Macintosh")>=0,c=(_.indexOf("Macintosh")>=0||_.indexOf("iPad")>=0||_.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,f=_.indexOf("Linux")>=0,g=_?.indexOf("Mobi")>=0,l=!0,m=n.getConfiguredDefaultLocale(n.localize(0,null))||t.LANGUAGE_DEFAULT,e=m,w=navigator.language):console.error("Unable to resolve platform.");var i;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(i||(t.Platform=i={}));function u(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let b=0;D?b=1:F?b=3:f&&(b=2),t.isWindows=F,t.isMacintosh=D,t.isLinux=f,t.isLinuxSnap=E,t.isNative=h,t.isElectron=s,t.isWeb=l,t.isWebWorker=l&&typeof L.importScripts=="function",t.webWorkerOrigin=t.isWebWorker?L.origin:void 0,t.isIOS=c,t.isMobile=g,t.isCI=N,t.platform=b,t.userAgent=_,t.language=e;var d;(function(I){function k(){return t.language}I.value=k;function y(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}I.isDefaultVariant=y;function C(){return t.language==="en"}I.isDefault=C})(d||(t.Language=d={})),t.locale=m,t.platformLocale=w,t.translationsConfigFile=A,t.setTimeout0IsFaster=typeof L.postMessage=="function"&&!L.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const I=[];L.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let C=0,O=I.length;C<O;C++){const j=I[C];if(j.id===y.data.vscodeScheduleAsyncWork){I.splice(C,1),j.callback();return}}});let k=0;return y=>{const C=++k;I.push({id:C,callback:y}),L.postMessage({vscodeScheduleAsyncWork:C},"*")}}return I=>setTimeout(I)})();var v;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(v||(t.OperatingSystem=v={})),t.OS=D||c?2:F?1:3;let M=!0,R=!1;function S(){if(!R){R=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,M=new Uint16Array(I.buffer)[0]===513}return M}t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0);function x(I){return parseFloat(I)>=20}}),ne(se[67],ae([0,1,18]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let F;const D=globalThis.vscode;if(typeof D<"u"&&typeof D.process<"u"){const f=D.process;F={get platform(){return f.platform},get arch(){return f.arch},get env(){return f.env},cwd(){return f.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return n.isWindows?"win32":n.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=F.cwd,t.env=F.env,t.platform=F.platform,t.arch=F.arch}),ne(se[68],ae([0,1,67]),function(W,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const F=65,D=97,f=90,E=122,h=46,l=47,s=92,c=58,N=63;class g extends Error{constructor(u,b,d){let v;typeof b=="string"&&b.indexOf("not ")===0?(v="must not be",b=b.replace(/^not /,"")):v="must be";const M=u.indexOf(".")!==-1?"property":"argument";let R=`The "${u}" ${M} ${v} of type ${b}`;R+=`. Received type ${typeof d}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function m(i,u){if(i===null||typeof i!="object")throw new g(u,"Object",i)}function e(i,u){if(typeof i!="string")throw new g(u,"string",i)}const w=n.platform==="win32";function A(i){return i===l||i===s}function _(i){return i===l}function L(i){return i>=F&&i<=f||i>=D&&i<=E}function p(i,u,b,d){let v="",M=0,R=-1,S=0,x=0;for(let I=0;I<=i.length;++I){if(I<i.length)x=i.charCodeAt(I);else{if(d(x))break;x=l}if(d(x)){if(!(R===I-1||S===1))if(S===2){if(v.length<2||M!==2||v.charCodeAt(v.length-1)!==h||v.charCodeAt(v.length-2)!==h){if(v.length>2){const k=v.lastIndexOf(b);k===-1?(v="",M=0):(v=v.slice(0,k),M=v.length-1-v.lastIndexOf(b)),R=I,S=0;continue}else if(v.length!==0){v="",M=0,R=I,S=0;continue}}u&&(v+=v.length>0?`${b}..`:"..",M=2)}else v.length>0?v+=`${b}${i.slice(R+1,I)}`:v=i.slice(R+1,I),M=I-R-1;R=I,S=0}else x===h&&S!==-1?++S:S=-1}return v}function o(i,u){m(u,"pathObject");const b=u.dir||u.root,d=u.base||`${u.name||""}${u.ext||""}`;return b?b===u.root?`${b}${d}`:`${b}${i}${d}`:d}t.win32={resolve(...i){let u="",b="",d=!1;for(let v=i.length-1;v>=-1;v--){let M;if(v>=0){if(M=i[v],e(M,"path"),M.length===0)continue}else u.length===0?M=n.cwd():(M=n.env[`=${u}`]||n.cwd(),(M===void 0||M.slice(0,2).toLowerCase()!==u.toLowerCase()&&M.charCodeAt(2)===s)&&(M=`${u}\\`));const R=M.length;let S=0,x="",I=!1;const k=M.charCodeAt(0);if(R===1)A(k)&&(S=1,I=!0);else if(A(k))if(I=!0,A(M.charCodeAt(1))){let y=2,C=y;for(;y<R&&!A(M.charCodeAt(y));)y++;if(y<R&&y!==C){const O=M.slice(C,y);for(C=y;y<R&&A(M.charCodeAt(y));)y++;if(y<R&&y!==C){for(C=y;y<R&&!A(M.charCodeAt(y));)y++;(y===R||y!==C)&&(x=`\\\\${O}\\${M.slice(C,y)}`,S=y)}}}else S=1;else L(k)&&M.charCodeAt(1)===c&&(x=M.slice(0,2),S=2,R>2&&A(M.charCodeAt(2))&&(I=!0,S=3));if(x.length>0)if(u.length>0){if(x.toLowerCase()!==u.toLowerCase())continue}else u=x;if(d){if(u.length>0)break}else if(b=`${M.slice(S)}\\${b}`,d=I,I&&u.length>0)break}return b=p(b,!d,"\\",A),d?`${u}\\${b}`:`${u}${b}`||"."},normalize(i){e(i,"path");const u=i.length;if(u===0)return".";let b=0,d,v=!1;const M=i.charCodeAt(0);if(u===1)return _(M)?"\\":i;if(A(M))if(v=!0,A(i.charCodeAt(1))){let S=2,x=S;for(;S<u&&!A(i.charCodeAt(S));)S++;if(S<u&&S!==x){const I=i.slice(x,S);for(x=S;S<u&&A(i.charCodeAt(S));)S++;if(S<u&&S!==x){for(x=S;S<u&&!A(i.charCodeAt(S));)S++;if(S===u)return`\\\\${I}\\${i.slice(x)}\\`;S!==x&&(d=`\\\\${I}\\${i.slice(x,S)}`,b=S)}}}else b=1;else L(M)&&i.charCodeAt(1)===c&&(d=i.slice(0,2),b=2,u>2&&A(i.charCodeAt(2))&&(v=!0,b=3));let R=b<u?p(i.slice(b),!v,"\\",A):"";return R.length===0&&!v&&(R="."),R.length>0&&A(i.charCodeAt(u-1))&&(R+="\\"),d===void 0?v?`\\${R}`:R:v?`${d}\\${R}`:`${d}${R}`},isAbsolute(i){e(i,"path");const u=i.length;if(u===0)return!1;const b=i.charCodeAt(0);return A(b)||u>2&&L(b)&&i.charCodeAt(1)===c&&A(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let u,b;for(let M=0;M<i.length;++M){const R=i[M];e(R,"path"),R.length>0&&(u===void 0?u=b=R:u+=`\\${R}`)}if(u===void 0)return".";let d=!0,v=0;if(typeof b=="string"&&A(b.charCodeAt(0))){++v;const M=b.length;M>1&&A(b.charCodeAt(1))&&(++v,M>2&&(A(b.charCodeAt(2))?++v:d=!1))}if(d){for(;v<u.length&&A(u.charCodeAt(v));)v++;v>=2&&(u=`\\${u.slice(v)}`)}return t.win32.normalize(u)},relative(i,u){if(e(i,"from"),e(u,"to"),i===u)return"";const b=t.win32.resolve(i),d=t.win32.resolve(u);if(b===d||(i=b.toLowerCase(),u=d.toLowerCase(),i===u))return"";let v=0;for(;v<i.length&&i.charCodeAt(v)===s;)v++;let M=i.length;for(;M-1>v&&i.charCodeAt(M-1)===s;)M--;const R=M-v;let S=0;for(;S<u.length&&u.charCodeAt(S)===s;)S++;let x=u.length;for(;x-1>S&&u.charCodeAt(x-1)===s;)x--;const I=x-S,k=R<I?R:I;let y=-1,C=0;for(;C<k;C++){const j=i.charCodeAt(v+C);if(j!==u.charCodeAt(S+C))break;j===s&&(y=C)}if(C!==k){if(y===-1)return d}else{if(I>k){if(u.charCodeAt(S+C)===s)return d.slice(S+C+1);if(C===2)return d.slice(S+C)}R>k&&(i.charCodeAt(v+C)===s?y=C:C===2&&(y=3)),y===-1&&(y=0)}let O="";for(C=v+y+1;C<=M;++C)(C===M||i.charCodeAt(C)===s)&&(O+=O.length===0?"..":"\\..");return S+=y,O.length>0?`${O}${d.slice(S,x)}`:(d.charCodeAt(S)===s&&++S,d.slice(S,x))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const u=t.win32.resolve(i);if(u.length<=2)return i;if(u.charCodeAt(0)===s){if(u.charCodeAt(1)===s){const b=u.charCodeAt(2);if(b!==N&&b!==h)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(L(u.charCodeAt(0))&&u.charCodeAt(1)===c&&u.charCodeAt(2)===s)return`\\\\?\\${u}`;return i},dirname(i){e(i,"path");const u=i.length;if(u===0)return".";let b=-1,d=0;const v=i.charCodeAt(0);if(u===1)return A(v)?i:".";if(A(v)){if(b=d=1,A(i.charCodeAt(1))){let S=2,x=S;for(;S<u&&!A(i.charCodeAt(S));)S++;if(S<u&&S!==x){for(x=S;S<u&&A(i.charCodeAt(S));)S++;if(S<u&&S!==x){for(x=S;S<u&&!A(i.charCodeAt(S));)S++;if(S===u)return i;S!==x&&(b=d=S+1)}}}}else L(v)&&i.charCodeAt(1)===c&&(b=u>2&&A(i.charCodeAt(2))?3:2,d=b);let M=-1,R=!0;for(let S=u-1;S>=d;--S)if(A(i.charCodeAt(S))){if(!R){M=S;break}}else R=!1;if(M===-1){if(b===-1)return".";M=b}return i.slice(0,M)},basename(i,u){u!==void 0&&e(u,"ext"),e(i,"path");let b=0,d=-1,v=!0,M;if(i.length>=2&&L(i.charCodeAt(0))&&i.charCodeAt(1)===c&&(b=2),u!==void 0&&u.length>0&&u.length<=i.length){if(u===i)return"";let R=u.length-1,S=-1;for(M=i.length-1;M>=b;--M){const x=i.charCodeAt(M);if(A(x)){if(!v){b=M+1;break}}else S===-1&&(v=!1,S=M+1),R>=0&&(x===u.charCodeAt(R)?--R===-1&&(d=M):(R=-1,d=S))}return b===d?d=S:d===-1&&(d=i.length),i.slice(b,d)}for(M=i.length-1;M>=b;--M)if(A(i.charCodeAt(M))){if(!v){b=M+1;break}}else d===-1&&(v=!1,d=M+1);return d===-1?"":i.slice(b,d)},extname(i){e(i,"path");let u=0,b=-1,d=0,v=-1,M=!0,R=0;i.length>=2&&i.charCodeAt(1)===c&&L(i.charCodeAt(0))&&(u=d=2);for(let S=i.length-1;S>=u;--S){const x=i.charCodeAt(S);if(A(x)){if(!M){d=S+1;break}continue}v===-1&&(M=!1,v=S+1),x===h?b===-1?b=S:R!==1&&(R=1):b!==-1&&(R=-1)}return b===-1||v===-1||R===0||R===1&&b===v-1&&b===d+1?"":i.slice(b,v)},format:o.bind(null,"\\"),parse(i){e(i,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return u;const b=i.length;let d=0,v=i.charCodeAt(0);if(b===1)return A(v)?(u.root=u.dir=i,u):(u.base=u.name=i,u);if(A(v)){if(d=1,A(i.charCodeAt(1))){let y=2,C=y;for(;y<b&&!A(i.charCodeAt(y));)y++;if(y<b&&y!==C){for(C=y;y<b&&A(i.charCodeAt(y));)y++;if(y<b&&y!==C){for(C=y;y<b&&!A(i.charCodeAt(y));)y++;y===b?d=y:y!==C&&(d=y+1)}}}}else if(L(v)&&i.charCodeAt(1)===c){if(b<=2)return u.root=u.dir=i,u;if(d=2,A(i.charCodeAt(2))){if(b===3)return u.root=u.dir=i,u;d=3}}d>0&&(u.root=i.slice(0,d));let M=-1,R=d,S=-1,x=!0,I=i.length-1,k=0;for(;I>=d;--I){if(v=i.charCodeAt(I),A(v)){if(!x){R=I+1;break}continue}S===-1&&(x=!1,S=I+1),v===h?M===-1?M=I:k!==1&&(k=1):M!==-1&&(k=-1)}return S!==-1&&(M===-1||k===0||k===1&&M===S-1&&M===R+1?u.base=u.name=i.slice(R,S):(u.name=i.slice(R,M),u.base=i.slice(R,S),u.ext=i.slice(M,S))),R>0&&R!==d?u.dir=i.slice(0,R-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(w){const i=/\\/g;return()=>{const u=n.cwd().replace(i,"/");return u.slice(u.indexOf("/"))}}return()=>n.cwd()})();t.posix={resolve(...i){let u="",b=!1;for(let d=i.length-1;d>=-1&&!b;d--){const v=d>=0?i[d]:a();e(v,"path"),v.length!==0&&(u=`${v}/${u}`,b=v.charCodeAt(0)===l)}return u=p(u,!b,"/",_),b?`/${u}`:u.length>0?u:"."},normalize(i){if(e(i,"path"),i.length===0)return".";const u=i.charCodeAt(0)===l,b=i.charCodeAt(i.length-1)===l;return i=p(i,!u,"/",_),i.length===0?u?"/":b?"./":".":(b&&(i+="/"),u?`/${i}`:i)},isAbsolute(i){return e(i,"path"),i.length>0&&i.charCodeAt(0)===l},join(...i){if(i.length===0)return".";let u;for(let b=0;b<i.length;++b){const d=i[b];e(d,"path"),d.length>0&&(u===void 0?u=d:u+=`/${d}`)}return u===void 0?".":t.posix.normalize(u)},relative(i,u){if(e(i,"from"),e(u,"to"),i===u||(i=t.posix.resolve(i),u=t.posix.resolve(u),i===u))return"";const b=1,d=i.length,v=d-b,M=1,R=u.length-M,S=v<R?v:R;let x=-1,I=0;for(;I<S;I++){const y=i.charCodeAt(b+I);if(y!==u.charCodeAt(M+I))break;y===l&&(x=I)}if(I===S)if(R>S){if(u.charCodeAt(M+I)===l)return u.slice(M+I+1);if(I===0)return u.slice(M+I)}else v>S&&(i.charCodeAt(b+I)===l?x=I:I===0&&(x=0));let k="";for(I=b+x+1;I<=d;++I)(I===d||i.charCodeAt(I)===l)&&(k+=k.length===0?"..":"/..");return`${k}${u.slice(M+x)}`},toNamespacedPath(i){return i},dirname(i){if(e(i,"path"),i.length===0)return".";const u=i.charCodeAt(0)===l;let b=-1,d=!0;for(let v=i.length-1;v>=1;--v)if(i.charCodeAt(v)===l){if(!d){b=v;break}}else d=!1;return b===-1?u?"/":".":u&&b===1?"//":i.slice(0,b)},basename(i,u){u!==void 0&&e(u,"ext"),e(i,"path");let b=0,d=-1,v=!0,M;if(u!==void 0&&u.length>0&&u.length<=i.length){if(u===i)return"";let R=u.length-1,S=-1;for(M=i.length-1;M>=0;--M){const x=i.charCodeAt(M);if(x===l){if(!v){b=M+1;break}}else S===-1&&(v=!1,S=M+1),R>=0&&(x===u.charCodeAt(R)?--R===-1&&(d=M):(R=-1,d=S))}return b===d?d=S:d===-1&&(d=i.length),i.slice(b,d)}for(M=i.length-1;M>=0;--M)if(i.charCodeAt(M)===l){if(!v){b=M+1;break}}else d===-1&&(v=!1,d=M+1);return d===-1?"":i.slice(b,d)},extname(i){e(i,"path");let u=-1,b=0,d=-1,v=!0,M=0;for(let R=i.length-1;R>=0;--R){const S=i.charCodeAt(R);if(S===l){if(!v){b=R+1;break}continue}d===-1&&(v=!1,d=R+1),S===h?u===-1?u=R:M!==1&&(M=1):u!==-1&&(M=-1)}return u===-1||d===-1||M===0||M===1&&u===d-1&&u===b+1?"":i.slice(u,d)},format:o.bind(null,"/"),parse(i){e(i,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return u;const b=i.charCodeAt(0)===l;let d;b?(u.root="/",d=1):d=0;let v=-1,M=0,R=-1,S=!0,x=i.length-1,I=0;for(;x>=d;--x){const k=i.charCodeAt(x);if(k===l){if(!S){M=x+1;break}continue}R===-1&&(S=!1,R=x+1),k===h?v===-1?v=x:I!==1&&(I=1):v!==-1&&(I=-1)}if(R!==-1){const k=M===0&&b?1:M;v===-1||I===0||I===1&&v===R-1&&v===M+1?u.base=u.name=i.slice(k,R):(u.name=i.slice(k,v),u.base=i.slice(k,R),u.ext=i.slice(v,R))}return M>0?u.dir=i.slice(0,M-1):b&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=w?t.win32.normalize:t.posix.normalize,t.isAbsolute=w?t.win32.isAbsolute:t.posix.isAbsolute,t.join=w?t.win32.join:t.posix.join,t.resolve=w?t.win32.resolve:t.posix.resolve,t.relative=w?t.win32.relative:t.posix.relative,t.dirname=w?t.win32.dirname:t.posix.dirname,t.basename=w?t.win32.basename:t.posix.basename,t.extname=w?t.win32.extname:t.posix.extname,t.format=w?t.win32.format:t.posix.format,t.parse=w?t.win32.parse:t.posix.parse,t.toNamespacedPath=w?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=w?t.win32.sep:t.posix.sep,t.delimiter=w?t.win32.delimiter:t.posix.delimiter}),ne(se[19],ae([0,1,68,18]),function(W,t,n,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.isUriComponents=e,t.uriToFsPath=o;const D=/^\w[\w\d+.-]*$/,f=/^\//,E=/^\/\//;function h(d,v){if(!d.scheme&&v)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!D.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!f.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(d,v){return!d&&!v?"file":d}function s(d,v){switch(d){case"https":case"http":case"file":v?v[0]!==N&&(v=N+v):v=N;break}return v}const c="",N="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(v){return v instanceof m?!0:v?typeof v.authority=="string"&&typeof v.fragment=="string"&&typeof v.path=="string"&&typeof v.query=="string"&&typeof v.scheme=="string"&&typeof v.fsPath=="string"&&typeof v.with=="function"&&typeof v.toString=="function":!1}constructor(v,M,R,S,x,I=!1){typeof v=="object"?(this.scheme=v.scheme||c,this.authority=v.authority||c,this.path=v.path||c,this.query=v.query||c,this.fragment=v.fragment||c):(this.scheme=l(v,I),this.authority=M||c,this.path=s(this.scheme,R||c),this.query=S||c,this.fragment=x||c,h(this,I))}get fsPath(){return o(this,!1)}with(v){if(!v)return this;let{scheme:M,authority:R,path:S,query:x,fragment:I}=v;return M===void 0?M=this.scheme:M===null&&(M=c),R===void 0?R=this.authority:R===null&&(R=c),S===void 0?S=this.path:S===null&&(S=c),x===void 0?x=this.query:x===null&&(x=c),I===void 0?I=this.fragment:I===null&&(I=c),M===this.scheme&&R===this.authority&&S===this.path&&x===this.query&&I===this.fragment?this:new A(M,R,S,x,I)}static parse(v,M=!1){const R=g.exec(v);return R?new A(R[2]||c,b(R[4]||c),b(R[5]||c),b(R[7]||c),b(R[9]||c),M):new A(c,c,c,c,c)}static file(v){let M=c;if(F.isWindows&&(v=v.replace(/\\/g,N)),v[0]===N&&v[1]===N){const R=v.indexOf(N,2);R===-1?(M=v.substring(2),v=N):(M=v.substring(2,R),v=v.substring(R)||N)}return new A("file",M,v,c,c)}static from(v,M){return new A(v.scheme,v.authority,v.path,v.query,v.fragment,M)}static joinPath(v,...M){if(!v.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return F.isWindows&&v.scheme==="file"?R=m.file(n.win32.join(o(v,!0),...M)).path:R=n.posix.join(v.path,...M),v.with({path:R})}toString(v=!1){return a(this,v)}toJSON(){return this}static revive(v){if(v){if(v instanceof m)return v;{const M=new A(v);return M._formatted=v.external??null,M._fsPath=v._sep===w?v.fsPath??null:null,M}}else return v}}t.URI=m;function e(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}const w=F.isWindows?1:void 0;class A extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(v=!1){return v?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const v={$mid:1};return this._fsPath&&(v.fsPath=this._fsPath,v._sep=w),this._formatted&&(v.external=this._formatted),this.path&&(v.path=this.path),this.scheme&&(v.scheme=this.scheme),this.authority&&(v.authority=this.authority),this.query&&(v.query=this.query),this.fragment&&(v.fragment=this.fragment),v}}const _={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function L(d,v,M){let R,S=-1;for(let x=0;x<d.length;x++){const I=d.charCodeAt(x);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||v&&I===47||M&&I===91||M&&I===93||M&&I===58)S!==-1&&(R+=encodeURIComponent(d.substring(S,x)),S=-1),R!==void 0&&(R+=d.charAt(x));else{R===void 0&&(R=d.substr(0,x));const k=_[I];k!==void 0?(S!==-1&&(R+=encodeURIComponent(d.substring(S,x)),S=-1),R+=k):S===-1&&(S=x)}}return S!==-1&&(R+=encodeURIComponent(d.substring(S))),R!==void 0?R:d}function p(d){let v;for(let M=0;M<d.length;M++){const R=d.charCodeAt(M);R===35||R===63?(v===void 0&&(v=d.substr(0,M)),v+=_[R]):v!==void 0&&(v+=d[M])}return v!==void 0?v:d}function o(d,v){let M;return d.authority&&d.path.length>1&&d.scheme==="file"?M=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?v?M=d.path.substr(1):M=d.path[1].toLowerCase()+d.path.substr(2):M=d.path,F.isWindows&&(M=M.replace(/\//g,"\\")),M}function a(d,v){const M=v?p:L;let R="",{scheme:S,authority:x,path:I,query:k,fragment:y}=d;if(S&&(R+=S,R+=":"),(x||S==="file")&&(R+=N,R+=N),x){let C=x.indexOf("@");if(C!==-1){const O=x.substr(0,C);x=x.substr(C+1),C=O.lastIndexOf(":"),C===-1?R+=M(O,!1,!1):(R+=M(O.substr(0,C),!1,!1),R+=":",R+=M(O.substr(C+1),!1,!0)),R+="@"}x=x.toLowerCase(),C=x.lastIndexOf(":"),C===-1?R+=M(x,!1,!0):(R+=M(x.substr(0,C),!1,!0),R+=x.substr(C))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const C=I.charCodeAt(1);C>=65&&C<=90&&(I=`/${String.fromCharCode(C+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const C=I.charCodeAt(0);C>=65&&C<=90&&(I=`${String.fromCharCode(C+32)}:${I.substr(2)}`)}R+=M(I,!0,!1)}return k&&(R+="?",R+=M(k,!1,!1)),y&&(R+="#",R+=v?y:L(y,!1,!1)),R}function i(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+i(d.substr(3)):d}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function b(d){return d.match(u)?d.replace(u,v=>i(v)):d}}),ne(se[73],ae([0,1,3,11,10,15,18,7]),function(W,t,n,F,D,f,E,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=c,t.create=u;const l="$initialize";let s=!1;function c(b){E.isWeb&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(b.message))}var N;(function(b){b[b.Request=0]="Request",b[b.Reply=1]="Reply",b[b.SubscribeEvent=2]="SubscribeEvent",b[b.Event=3]="Event",b[b.UnsubscribeEvent=4]="UnsubscribeEvent"})(N||(N={}));class g{constructor(d,v,M,R){this.vsWorker=d,this.req=v,this.method=M,this.args=R,this.type=0}}class m{constructor(d,v,M,R){this.vsWorker=d,this.seq=v,this.res=M,this.err=R,this.type=1}}class e{constructor(d,v,M,R){this.vsWorker=d,this.req=v,this.eventName=M,this.arg=R,this.type=2}}class w{constructor(d,v,M){this.vsWorker=d,this.req=v,this.event=M,this.type=3}}class A{constructor(d,v){this.vsWorker=d,this.req=v,this.type=4}}class _{constructor(d){this._workerId=-1,this._handler=d,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(d){this._workerId=d}sendMessage(d,v){const M=String(++this._lastSentReq);return new Promise((R,S)=>{this._pendingReplies[M]={resolve:R,reject:S},this._send(new g(this._workerId,M,d,v))})}listen(d,v){let M=null;const R=new F.Emitter({onWillAddFirstListener:()=>{M=String(++this._lastSentReq),this._pendingEmitters.set(M,R),this._send(new e(this._workerId,M,d,v))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(M),this._send(new A(this._workerId,M)),M=null}});return R.event}handleMessage(d){!d||!d.vsWorker||this._workerId!==-1&&d.vsWorker!==this._workerId||this._handleMessage(d)}_handleMessage(d){switch(d.type){case 1:return this._handleReplyMessage(d);case 0:return this._handleRequestMessage(d);case 2:return this._handleSubscribeEventMessage(d);case 3:return this._handleEventMessage(d);case 4:return this._handleUnsubscribeEventMessage(d)}}_handleReplyMessage(d){if(!this._pendingReplies[d.seq]){console.warn("Got reply to unknown seq");return}const v=this._pendingReplies[d.seq];if(delete this._pendingReplies[d.seq],d.err){let M=d.err;d.err.$isError&&(M=new Error,M.name=d.err.name,M.message=d.err.message,M.stack=d.err.stack),v.reject(M);return}v.resolve(d.res)}_handleRequestMessage(d){const v=d.req;this._handler.handleMessage(d.method,d.args).then(R=>{this._send(new m(this._workerId,v,R,void 0))},R=>{R.detail instanceof Error&&(R.detail=(0,n.transformErrorForSerialization)(R.detail)),this._send(new m(this._workerId,v,void 0,(0,n.transformErrorForSerialization)(R)))})}_handleSubscribeEventMessage(d){const v=d.req,M=this._handler.handleEvent(d.eventName,d.arg)(R=>{this._send(new w(this._workerId,v,R))});this._pendingEvents.set(v,M)}_handleEventMessage(d){if(!this._pendingEmitters.has(d.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(d.req).fire(d.event)}_handleUnsubscribeEventMessage(d){if(!this._pendingEvents.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(d.req).dispose(),this._pendingEvents.delete(d.req)}_send(d){const v=[];if(d.type===0)for(let M=0;M<d.args.length;M++)d.args[M]instanceof ArrayBuffer&&v.push(d.args[M]);else d.type===1&&d.res instanceof ArrayBuffer&&v.push(d.res);this._handler.sendMessage(d,v)}}class L extends D.Disposable{constructor(d,v,M){super();let R=null;this._worker=this._register(d.create("vs/base/common/worker/simpleWorker",C=>{this._protocol.handleMessage(C)},C=>{R?.(C)})),this._protocol=new _({sendMessage:(C,O)=>{this._worker.postMessage(C,O)},handleMessage:(C,O)=>{if(typeof M[C]!="function")return Promise.reject(new Error("Missing method "+C+" on main thread host."));try{return Promise.resolve(M[C].apply(M,O))}catch(j){return Promise.reject(j)}},handleEvent:(C,O)=>{if(o(C)){const j=M[C].call(M,O);if(typeof j!="function")throw new Error(`Missing dynamic event ${C} on main thread host.`);return j}if(p(C)){const j=M[C];if(typeof j!="function")throw new Error(`Missing event ${C} on main thread host.`);return j}throw new Error(`Malformed event name ${C}`)}}),this._protocol.setWorkerId(this._worker.getId());let S=null;const x=globalThis.require;typeof x<"u"&&typeof x.getConfig=="function"?S=x.getConfig():typeof globalThis.requirejs<"u"&&(S=globalThis.requirejs.s.contexts._.config);const I=(0,f.getAllMethodNames)(M);this._onModuleLoaded=this._protocol.sendMessage(l,[this._worker.getId(),JSON.parse(JSON.stringify(S)),v,I]);const k=(C,O)=>this._request(C,O),y=(C,O)=>this._protocol.listen(C,O);this._lazyProxy=new Promise((C,O)=>{R=O,this._onModuleLoaded.then(j=>{C(a(j,k,y))},j=>{O(j),this._onError("Worker failed to load "+v,j)})})}getProxyObject(){return this._lazyProxy}_request(d,v){return new Promise((M,R)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(d,v).then(M,R)},R)})}_onError(d,v){console.error(d),console.info(v)}}t.SimpleWorkerClient=L;function p(b){return b[0]==="o"&&b[1]==="n"&&h.isUpperAsciiLetter(b.charCodeAt(2))}function o(b){return/^onDynamic/.test(b)&&h.isUpperAsciiLetter(b.charCodeAt(9))}function a(b,d,v){const M=x=>function(){const I=Array.prototype.slice.call(arguments,0);return d(x,I)},R=x=>function(I){return v(x,I)},S={};for(const x of b){if(o(x)){S[x]=R(x);continue}if(p(x)){S[x]=v(x,void 0);continue}S[x]=M(x)}return S}class i{constructor(d,v){this._requestHandlerFactory=v,this._requestHandler=null,this._protocol=new _({sendMessage:(M,R)=>{d(M,R)},handleMessage:(M,R)=>this._handleMessage(M,R),handleEvent:(M,R)=>this._handleEvent(M,R)})}onmessage(d){this._protocol.handleMessage(d)}_handleMessage(d,v){if(d===l)return this.initialize(v[0],v[1],v[2],v[3]);if(!this._requestHandler||typeof this._requestHandler[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this._requestHandler[d].apply(this._requestHandler,v))}catch(M){return Promise.reject(M)}}_handleEvent(d,v){if(!this._requestHandler)throw new Error("Missing requestHandler");if(o(d)){const M=this._requestHandler[d].call(this._requestHandler,v);if(typeof M!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return M}if(p(d)){const M=this._requestHandler[d];if(typeof M!="function")throw new Error(`Missing event ${d} on request handler.`);return M}throw new Error(`Malformed event name ${d}`)}initialize(d,v,M,R){this._protocol.setWorkerId(d);const I=a(R,(k,y)=>this._protocol.sendMessage(k,y),(k,y)=>this._protocol.listen(k,y));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(I),Promise.resolve((0,f.getAllMethodNames)(this._requestHandler))):(v&&(typeof v.baseUrl<"u"&&delete v.baseUrl,typeof v.paths<"u"&&typeof v.paths.vs<"u"&&delete v.paths.vs,typeof v.trustedTypesPolicy<"u"&&delete v.trustedTypesPolicy,v.catchError=!0,globalThis.require.config(v)),new Promise((k,y)=>{(globalThis.require||W)([M],O=>{if(this._requestHandler=O.create(I),!this._requestHandler){y(new Error("No RequestHandler!"));return}k((0,f.getAllMethodNames)(this._requestHandler))},y)}))}}t.SimpleWorkerServer=i;function u(b){return new i(b,null)}}),ne(se[69],ae([65,66]),function(W,t){return W.create("vs/editor/common/languages",t)}),ne(se[70],ae([0,1,43,19,44,2,63,69]),function(W,t,n,F,D,f,E,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.ExternalUriOpenerPriority=t.TokenizationRegistry=t.LazyTokenizationSupport=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadApplicability=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTag=t.FoldingRangeKind=t.TextEdit=t.SymbolKinds=t.SymbolTag=t.symbolKindNames=t.SymbolKind=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.DocumentPasteTriggerKind=t.CodeActionTriggerType=t.SelectedSuggestionInfo=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.PartialAcceptTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0,t.isLocationLink=u,t.getAriaLabelForSymbol=d;class l{constructor(H,ie,oe){this.offset=H,this.type=ie,this.language=oe,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=l;class s{constructor(H,ie){this.tokens=H,this.endState=ie,this._tokenizationResultBrand=void 0}}t.TokenizationResult=s;class c{constructor(H,ie){this.tokens=H,this.endState=ie,this._encodedTokenizationResultBrand=void 0}}t.EncodedTokenizationResult=c;var N;(function(P){P[P.Method=0]="Method",P[P.Function=1]="Function",P[P.Constructor=2]="Constructor",P[P.Field=3]="Field",P[P.Variable=4]="Variable",P[P.Class=5]="Class",P[P.Struct=6]="Struct",P[P.Interface=7]="Interface",P[P.Module=8]="Module",P[P.Property=9]="Property",P[P.Event=10]="Event",P[P.Operator=11]="Operator",P[P.Unit=12]="Unit",P[P.Value=13]="Value",P[P.Constant=14]="Constant",P[P.Enum=15]="Enum",P[P.EnumMember=16]="EnumMember",P[P.Keyword=17]="Keyword",P[P.Text=18]="Text",P[P.Color=19]="Color",P[P.File=20]="File",P[P.Reference=21]="Reference",P[P.Customcolor=22]="Customcolor",P[P.Folder=23]="Folder",P[P.TypeParameter=24]="TypeParameter",P[P.User=25]="User",P[P.Issue=26]="Issue",P[P.Snippet=27]="Snippet"})(N||(t.CompletionItemKind=N={}));var g;(function(P){const H=new Map;H.set(0,n.Codicon.symbolMethod),H.set(1,n.Codicon.symbolFunction),H.set(2,n.Codicon.symbolConstructor),H.set(3,n.Codicon.symbolField),H.set(4,n.Codicon.symbolVariable),H.set(5,n.Codicon.symbolClass),H.set(6,n.Codicon.symbolStruct),H.set(7,n.Codicon.symbolInterface),H.set(8,n.Codicon.symbolModule),H.set(9,n.Codicon.symbolProperty),H.set(10,n.Codicon.symbolEvent),H.set(11,n.Codicon.symbolOperator),H.set(12,n.Codicon.symbolUnit),H.set(13,n.Codicon.symbolValue),H.set(15,n.Codicon.symbolEnum),H.set(14,n.Codicon.symbolConstant),H.set(15,n.Codicon.symbolEnum),H.set(16,n.Codicon.symbolEnumMember),H.set(17,n.Codicon.symbolKeyword),H.set(27,n.Codicon.symbolSnippet),H.set(18,n.Codicon.symbolText),H.set(19,n.Codicon.symbolColor),H.set(20,n.Codicon.symbolFile),H.set(21,n.Codicon.symbolReference),H.set(22,n.Codicon.symbolCustomColor),H.set(23,n.Codicon.symbolFolder),H.set(24,n.Codicon.symbolTypeParameter),H.set(25,n.Codicon.account),H.set(26,n.Codicon.issues);function ie(r){let Le=H.get(r);return Le||(console.info("No codicon found for CompletionItemKind "+r),Le=n.Codicon.symbolProperty),Le}P.toIcon=ie;const oe=new Map;oe.set("method",0),oe.set("function",1),oe.set("constructor",2),oe.set("field",3),oe.set("variable",4),oe.set("class",5),oe.set("struct",6),oe.set("interface",7),oe.set("module",8),oe.set("property",9),oe.set("event",10),oe.set("operator",11),oe.set("unit",12),oe.set("value",13),oe.set("constant",14),oe.set("enum",15),oe.set("enum-member",16),oe.set("enumMember",16),oe.set("keyword",17),oe.set("snippet",27),oe.set("text",18),oe.set("color",19),oe.set("file",20),oe.set("reference",21),oe.set("customcolor",22),oe.set("folder",23),oe.set("type-parameter",24),oe.set("typeParameter",24),oe.set("account",25),oe.set("issue",26);function ge(r,Le){let we=oe.get(r);return typeof we>"u"&&!Le&&(we=9),we}P.fromString=ge})(g||(t.CompletionItemKinds=g={}));var m;(function(P){P[P.Deprecated=1]="Deprecated"})(m||(t.CompletionItemTag=m={}));var e;(function(P){P[P.None=0]="None",P[P.KeepWhitespace=1]="KeepWhitespace",P[P.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var w;(function(P){P[P.Word=0]="Word",P[P.Line=1]="Line",P[P.Suggest=2]="Suggest"})(w||(t.PartialAcceptTriggerKind=w={}));var A;(function(P){P[P.Invoke=0]="Invoke",P[P.TriggerCharacter=1]="TriggerCharacter",P[P.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(A||(t.CompletionTriggerKind=A={}));var _;(function(P){P[P.Automatic=0]="Automatic",P[P.Explicit=1]="Explicit"})(_||(t.InlineCompletionTriggerKind=_={}));class L{constructor(H,ie,oe,ge){this.range=H,this.text=ie,this.completionKind=oe,this.isSnippetText=ge}equals(H){return f.Range.lift(this.range).equalsRange(H.range)&&this.text===H.text&&this.completionKind===H.completionKind&&this.isSnippetText===H.isSnippetText}}t.SelectedSuggestionInfo=L;var p;(function(P){P[P.Invoke=1]="Invoke",P[P.Auto=2]="Auto"})(p||(t.CodeActionTriggerType=p={}));var o;(function(P){P[P.Automatic=0]="Automatic",P[P.PasteAs=1]="PasteAs"})(o||(t.DocumentPasteTriggerKind=o={}));var a;(function(P){P[P.Invoke=1]="Invoke",P[P.TriggerCharacter=2]="TriggerCharacter",P[P.ContentChange=3]="ContentChange"})(a||(t.SignatureHelpTriggerKind=a={}));var i;(function(P){P[P.Text=0]="Text",P[P.Read=1]="Read",P[P.Write=2]="Write"})(i||(t.DocumentHighlightKind=i={}));function u(P){return P&&F.URI.isUri(P.uri)&&f.Range.isIRange(P.range)&&(f.Range.isIRange(P.originSelectionRange)||f.Range.isIRange(P.targetSelectionRange))}var b;(function(P){P[P.File=0]="File",P[P.Module=1]="Module",P[P.Namespace=2]="Namespace",P[P.Package=3]="Package",P[P.Class=4]="Class",P[P.Method=5]="Method",P[P.Property=6]="Property",P[P.Field=7]="Field",P[P.Constructor=8]="Constructor",P[P.Enum=9]="Enum",P[P.Interface=10]="Interface",P[P.Function=11]="Function",P[P.Variable=12]="Variable",P[P.Constant=13]="Constant",P[P.String=14]="String",P[P.Number=15]="Number",P[P.Boolean=16]="Boolean",P[P.Array=17]="Array",P[P.Object=18]="Object",P[P.Key=19]="Key",P[P.Null=20]="Null",P[P.EnumMember=21]="EnumMember",P[P.Struct=22]="Struct",P[P.Event=23]="Event",P[P.Operator=24]="Operator",P[P.TypeParameter=25]="TypeParameter"})(b||(t.SymbolKind=b={})),t.symbolKindNames={17:(0,h.localize)(0,null),16:(0,h.localize)(1,null),4:(0,h.localize)(2,null),13:(0,h.localize)(3,null),8:(0,h.localize)(4,null),9:(0,h.localize)(5,null),21:(0,h.localize)(6,null),23:(0,h.localize)(7,null),7:(0,h.localize)(8,null),0:(0,h.localize)(9,null),11:(0,h.localize)(10,null),10:(0,h.localize)(11,null),19:(0,h.localize)(12,null),5:(0,h.localize)(13,null),1:(0,h.localize)(14,null),2:(0,h.localize)(15,null),20:(0,h.localize)(16,null),15:(0,h.localize)(17,null),18:(0,h.localize)(18,null),24:(0,h.localize)(19,null),3:(0,h.localize)(20,null),6:(0,h.localize)(21,null),14:(0,h.localize)(22,null),22:(0,h.localize)(23,null),25:(0,h.localize)(24,null),12:(0,h.localize)(25,null)};function d(P,H){return(0,h.localize)(26,null,P,t.symbolKindNames[H])}var v;(function(P){P[P.Deprecated=1]="Deprecated"})(v||(t.SymbolTag=v={}));var M;(function(P){const H=new Map;H.set(0,n.Codicon.symbolFile),H.set(1,n.Codicon.symbolModule),H.set(2,n.Codicon.symbolNamespace),H.set(3,n.Codicon.symbolPackage),H.set(4,n.Codicon.symbolClass),H.set(5,n.Codicon.symbolMethod),H.set(6,n.Codicon.symbolProperty),H.set(7,n.Codicon.symbolField),H.set(8,n.Codicon.symbolConstructor),H.set(9,n.Codicon.symbolEnum),H.set(10,n.Codicon.symbolInterface),H.set(11,n.Codicon.symbolFunction),H.set(12,n.Codicon.symbolVariable),H.set(13,n.Codicon.symbolConstant),H.set(14,n.Codicon.symbolString),H.set(15,n.Codicon.symbolNumber),H.set(16,n.Codicon.symbolBoolean),H.set(17,n.Codicon.symbolArray),H.set(18,n.Codicon.symbolObject),H.set(19,n.Codicon.symbolKey),H.set(20,n.Codicon.symbolNull),H.set(21,n.Codicon.symbolEnumMember),H.set(22,n.Codicon.symbolStruct),H.set(23,n.Codicon.symbolEvent),H.set(24,n.Codicon.symbolOperator),H.set(25,n.Codicon.symbolTypeParameter);function ie(oe){let ge=H.get(oe);return ge||(console.info("No codicon found for SymbolKind "+oe),ge=n.Codicon.symbolProperty),ge}P.toIcon=ie})(M||(t.SymbolKinds=M={}));class R{static asEditOperation(H){return D.EditOperation.replace(f.Range.lift(H.range),H.text)}}t.TextEdit=R;class S{static{this.Comment=new S("comment")}static{this.Imports=new S("imports")}static{this.Region=new S("region")}static fromValue(H){switch(H){case"comment":return S.Comment;case"imports":return S.Imports;case"region":return S.Region}return new S(H)}constructor(H){this.value=H}}t.FoldingRangeKind=S;var x;(function(P){P[P.AIGenerated=1]="AIGenerated"})(x||(t.NewSymbolNameTag=x={}));var I;(function(P){function H(ie){return!ie||typeof ie!="object"?!1:typeof ie.id=="string"&&typeof ie.title=="string"}P.is=H})(I||(t.Command=I={}));var k;(function(P){P[P.Collapsed=0]="Collapsed",P[P.Expanded=1]="Expanded"})(k||(t.CommentThreadCollapsibleState=k={}));var y;(function(P){P[P.Unresolved=0]="Unresolved",P[P.Resolved=1]="Resolved"})(y||(t.CommentThreadState=y={}));var C;(function(P){P[P.Current=0]="Current",P[P.Outdated=1]="Outdated"})(C||(t.CommentThreadApplicability=C={}));var O;(function(P){P[P.Editing=0]="Editing",P[P.Preview=1]="Preview"})(O||(t.CommentMode=O={}));var j;(function(P){P[P.Published=0]="Published",P[P.Draft=1]="Draft"})(j||(t.CommentState=j={}));var K;(function(P){P[P.Type=1]="Type",P[P.Parameter=2]="Parameter"})(K||(t.InlayHintKind=K={}));class U{constructor(H){this.createSupport=H,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(H=>{H&&H.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}t.LazyTokenizationSupport=U,t.TokenizationRegistry=new E.TokenizationRegistry;var X;(function(P){P[P.None=0]="None",P[P.Option=1]="Option",P[P.Default=2]="Default",P[P.Preferred=3]="Preferred"})(X||(t.ExternalUriOpenerPriority=X={}));var G;(function(P){P[P.Invoke=0]="Invoke",P[P.Automatic=1]="Automatic"})(G||(t.InlineEditTriggerKind=G={}))}),ne(se[71],ae([0,1,24,11,38,19,5,2,45,70,62]),function(W,t,n,F,D,f,E,h,l,s,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=void 0,t.createMonacoBaseAPI=g;class N{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,w){return(0,D.KeyChord)(e,w)}}t.KeyMod=N;function g(){return{editor:void 0,languages:void 0,CancellationTokenSource:n.CancellationTokenSource,Emitter:F.Emitter,KeyCode:c.KeyCode,KeyMod:N,Position:E.Position,Range:h.Range,Selection:l.Selection,SelectionDirection:c.SelectionDirection,MarkerSeverity:c.MarkerSeverity,MarkerTag:c.MarkerTag,Uri:f.URI,Token:s.Token}}}),ne(se[74],ae([0,1,25,19,5,2,58,30,54,55,71,23,61,34,52,15,3,53,60]),function(W,t,n,F,D,f,E,h,l,s,c,N,g,m,e,w,A,_,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorSimpleWorker=void 0,t.create=a;class p extends E.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(u){const b=[];for(let d=0;d<this._lines.length;d++){const v=this._lines[d],M=this.offsetAt(new D.Position(d+1,1)),R=v.matchAll(u);for(const S of R)(S.index||S.index===0)&&(S.index=S.index+M),b.push(S)}return b}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(u){return this._lines[u-1]}getWordAtPosition(u,b){const d=(0,h.getWordAtText)(u.column,(0,h.ensureValidWordDefinition)(b),this._lines[u.lineNumber-1],0);return d?new f.Range(u.lineNumber,d.startColumn,u.lineNumber,d.endColumn):null}getWordUntilPosition(u,b){const d=this.getWordAtPosition(u,b);return d?{word:this._lines[u.lineNumber-1].substring(d.startColumn-1,u.column-1),startColumn:d.startColumn,endColumn:u.column}:{word:"",startColumn:u.column,endColumn:u.column}}words(u){const b=this._lines,d=this._wordenize.bind(this);let v=0,M="",R=0,S=[];return{*[Symbol.iterator](){for(;;)if(R<S.length){const x=M.substring(S[R].start,S[R].end);R+=1,yield x}else if(v<b.length)M=b[v],S=d(M,u),R=0,v+=1;else break}}}getLineWords(u,b){const d=this._lines[u-1],v=this._wordenize(d,b),M=[];for(const R of v)M.push({word:d.substring(R.start,R.end),startColumn:R.start+1,endColumn:R.end+1});return M}_wordenize(u,b){const d=[];let v;for(b.lastIndex=0;(v=b.exec(u))&&v[0].length!==0;)d.push({start:v.index,end:v.index+v[0].length});return d}getValueInRange(u){if(u=this._validateRange(u),u.startLineNumber===u.endLineNumber)return this._lines[u.startLineNumber-1].substring(u.startColumn-1,u.endColumn-1);const b=this._eol,d=u.startLineNumber-1,v=u.endLineNumber-1,M=[];M.push(this._lines[d].substring(u.startColumn-1));for(let R=d+1;R<v;R++)M.push(this._lines[R]);return M.push(this._lines[v].substring(0,u.endColumn-1)),M.join(b)}offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.lineNumber-2)+(u.column-1)}positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const b=this._lineStarts.getIndexOf(u),d=this._lines[b.index].length;return{lineNumber:1+b.index,column:1+Math.min(b.remainder,d)}}_validateRange(u){const b=this._validatePosition({lineNumber:u.startLineNumber,column:u.startColumn}),d=this._validatePosition({lineNumber:u.endLineNumber,column:u.endColumn});return b.lineNumber!==u.startLineNumber||b.column!==u.startColumn||d.lineNumber!==u.endLineNumber||d.column!==u.endColumn?{startLineNumber:b.lineNumber,startColumn:b.column,endLineNumber:d.lineNumber,endColumn:d.column}:u}_validatePosition(u){if(!D.Position.isIPosition(u))throw new Error("bad position");let{lineNumber:b,column:d}=u,v=!1;if(b<1)b=1,d=1,v=!0;else if(b>this._lines.length)b=this._lines.length,d=this._lines[b-1].length+1,v=!0;else{const M=this._lines[b-1].length+1;d<1?(d=1,v=!0):d>M&&(d=M,v=!0)}return v?{lineNumber:b,column:d}:u}}class o{constructor(u,b){this._host=u,this._models=Object.create(null),this._foreignModuleFactory=b,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(u){return this._models[u]}_getModels(){const u=[];return Object.keys(this._models).forEach(b=>u.push(this._models[b])),u}acceptNewModel(u){this._models[u.url]=new p(F.URI.parse(u.url),u.lines,u.EOL,u.versionId)}acceptModelChanged(u,b){if(!this._models[u])return;this._models[u].onEvents(b)}acceptRemovedModel(u){this._models[u]&&delete this._models[u]}async computeUnicodeHighlights(u,b,d){const v=this._getModel(u);return v?g.UnicodeTextModelHighlighter.computeUnicodeHighlights(v,b,d):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(u,b){const d=this._getModel(u);return d?(0,L.findSectionHeaders)(d,b):[]}async computeDiff(u,b,d,v){const M=this._getModel(u),R=this._getModel(b);return!M||!R?null:o.computeDiff(M,R,d,v)}static computeDiff(u,b,d,v){const M=v==="advanced"?e.linesDiffComputers.getDefault():e.linesDiffComputers.getLegacy(),R=u.getLinesContent(),S=b.getLinesContent(),x=M.computeDiff(R,S,d),I=x.changes.length>0?!1:this._modelsAreIdentical(u,b);function k(y){return y.map(C=>[C.original.startLineNumber,C.original.endLineNumberExclusive,C.modified.startLineNumber,C.modified.endLineNumberExclusive,C.innerChanges?.map(O=>[O.originalRange.startLineNumber,O.originalRange.startColumn,O.originalRange.endLineNumber,O.originalRange.endColumn,O.modifiedRange.startLineNumber,O.modifiedRange.startColumn,O.modifiedRange.endLineNumber,O.modifiedRange.endColumn])])}return{identical:I,quitEarly:x.hitTimeout,changes:k(x.changes),moves:x.moves.map(y=>[y.lineRangeMapping.original.startLineNumber,y.lineRangeMapping.original.endLineNumberExclusive,y.lineRangeMapping.modified.startLineNumber,y.lineRangeMapping.modified.endLineNumberExclusive,k(y.changes)])}}static _modelsAreIdentical(u,b){const d=u.getLineCount(),v=b.getLineCount();if(d!==v)return!1;for(let M=1;M<=d;M++){const R=u.getLineContent(M),S=b.getLineContent(M);if(R!==S)return!1}return!0}async computeDirtyDiff(u,b,d){const v=this._getModel(u),M=this._getModel(b);if(!v||!M)return null;const R=v.getLinesContent(),S=M.getLinesContent();return new m.DiffComputer(R,S,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:d,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this._diffLimit=1e5}async computeMoreMinimalEdits(u,b,d){const v=this._getModel(u);if(!v)return b;const M=[];let R;b=b.slice(0).sort((x,I)=>{if(x.range&&I.range)return f.Range.compareRangesUsingStarts(x.range,I.range);const k=x.range?0:1,y=I.range?0:1;return k-y});let S=0;for(let x=1;x<b.length;x++)f.Range.getEndPosition(b[S].range).equals(f.Range.getStartPosition(b[x].range))?(b[S].range=f.Range.fromPositions(f.Range.getStartPosition(b[S].range),f.Range.getEndPosition(b[x].range)),b[S].text+=b[x].text):(S++,b[S]=b[x]);b.length=S+1;for(let{range:x,text:I,eol:k}of b){if(typeof k=="number"&&(R=k),f.Range.isEmpty(x)&&!I)continue;const y=v.getValueInRange(x);if(I=I.replace(/\r\n|\n|\r/g,v.eol),y===I)continue;if(Math.max(I.length,y.length)>o._diffLimit){M.push({range:x,text:I});continue}const C=(0,n.stringDiff)(y,I,d),O=v.offsetAt(f.Range.lift(x).getStartPosition());for(const j of C){const K=v.positionAt(O+j.originalStart),U=v.positionAt(O+j.originalStart+j.originalLength),X={text:I.substr(j.modifiedStart,j.modifiedLength),range:{startLineNumber:K.lineNumber,startColumn:K.column,endLineNumber:U.lineNumber,endColumn:U.column}};v.getValueInRange(X.range)!==X.text&&M.push(X)}}return typeof R=="number"&&M.push({eol:R,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),M}computeHumanReadableDiff(u,b,d){const v=this._getModel(u);if(!v)return b;const M=[];let R;b=b.slice(0).sort((S,x)=>{if(S.range&&x.range)return f.Range.compareRangesUsingStarts(S.range,x.range);const I=S.range?0:1,k=x.range?0:1;return I-k});for(let{range:S,text:x,eol:I}of b){let K=function(X,G){return new D.Position(X.lineNumber+G.lineNumber-1,G.lineNumber===1?X.column+G.column-1:G.column)},U=function(X,G){const P=[];for(let H=G.startLineNumber;H<=G.endLineNumber;H++){const ie=X[H-1];H===G.startLineNumber&&H===G.endLineNumber?P.push(ie.substring(G.startColumn-1,G.endColumn-1)):H===G.startLineNumber?P.push(ie.substring(G.startColumn-1)):H===G.endLineNumber?P.push(ie.substring(0,G.endColumn-1)):P.push(ie)}return P};if(typeof I=="number"&&(R=I),f.Range.isEmpty(S)&&!x)continue;const k=v.getValueInRange(S);if(x=x.replace(/\r\n|\n|\r/g,v.eol),k===x)continue;if(Math.max(x.length,k.length)>o._diffLimit){M.push({range:S,text:x});continue}const y=k.split(/\r\n|\n|\r/),C=x.split(/\r\n|\n|\r/),O=e.linesDiffComputers.getDefault().computeDiff(y,C,d),j=f.Range.lift(S).getStartPosition();for(const X of O.changes)if(X.innerChanges)for(const G of X.innerChanges)M.push({range:f.Range.fromPositions(K(j,G.originalRange.getStartPosition()),K(j,G.originalRange.getEndPosition())),text:U(C,G.modifiedRange).join(v.eol)});else throw new A.BugIndicatingError("The experimental diff algorithm always produces inner changes")}return typeof R=="number"&&M.push({eol:R,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),M}async computeLinks(u){const b=this._getModel(u);return b?(0,l.computeLinks)(b):null}async computeDefaultDocumentColors(u){const b=this._getModel(u);return b?(0,_.computeDefaultDocumentColors)(b):null}static{this._suggestionsLimit=1e4}async textualSuggest(u,b,d,v){const M=new N.StopWatch,R=new RegExp(d,v),S=new Set;e:for(const x of u){const I=this._getModel(x);if(I){for(const k of I.words(R))if(!(k===b||!isNaN(Number(k)))&&(S.add(k),S.size>o._suggestionsLimit))break e}}return{words:Array.from(S),duration:M.elapsed()}}async computeWordRanges(u,b,d,v){const M=this._getModel(u);if(!M)return Object.create(null);const R=new RegExp(d,v),S=Object.create(null);for(let x=b.startLineNumber;x<b.endLineNumber;x++){const I=M.getLineWords(x,R);for(const k of I){if(!isNaN(Number(k.word)))continue;let y=S[k.word];y||(y=[],S[k.word]=y),y.push({startLineNumber:x,startColumn:k.startColumn,endLineNumber:x,endColumn:k.endColumn})}}return S}async navigateValueSet(u,b,d,v,M){const R=this._getModel(u);if(!R)return null;const S=new RegExp(v,M);b.startColumn===b.endColumn&&(b={startLineNumber:b.startLineNumber,startColumn:b.startColumn,endLineNumber:b.endLineNumber,endColumn:b.endColumn+1});const x=R.getValueInRange(b),I=R.getWordAtPosition({lineNumber:b.startLineNumber,column:b.startColumn},S);if(!I)return null;const k=R.getValueInRange(I);return s.BasicInplaceReplace.INSTANCE.navigateValueSet(b,x,I,k,d)}loadForeignModule(u,b,d){const v=(S,x)=>this._host.fhr(S,x),R={host:(0,w.createProxyObject)(d,v),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(R,b),Promise.resolve((0,w.getAllMethodNames)(this._foreignModule))):new Promise((S,x)=>{W([u],I=>{this._foreignModule=I.create(R,b),S((0,w.getAllMethodNames)(this._foreignModule))},x)})}fmr(u,b){if(!this._foreignModule||typeof this._foreignModule[u]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+u));try{return Promise.resolve(this._foreignModule[u].apply(this._foreignModule,b))}catch(d){return Promise.reject(d)}}}t.EditorSimpleWorker=o;function a(i){return new o(i,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,c.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0d01a72525276e5e3771fe5851b9c83de0de1e2b/core/vs/base/worker/workerMain.js.map
