/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/cancellation","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/observableInternal/base","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/browser/ui/hover/updatableHoverWidget","vs/base/common/assert","vs/base/common/map","vs/base/common/numbers","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/buffer","vs/base/common/filters","vs/base/common/codiconsUtil","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/observable","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/common/observableInternal/utils","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/common/codiconsLibrary","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/hover/updatableHoverWidget","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(ie){for(var t=[],s=0,N=ie.length;s<N;s++)t[s]=ge[ie[s]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:xt,setPrototypeOf:Wt,isFrozen:ii,getPrototypeOf:si,getOwnPropertyDescriptor:ni}=Object;let{freeze:ot,seal:dt,create:ri}=Object,{apply:Ft,construct:Lt}=typeof Reflect<"u"&&Reflect;Ft||(Ft=function(t,s,N){return t.apply(s,N)}),ot||(ot=function(t){return t}),dt||(dt=function(t){return t}),Lt||(Lt=function(t,s){return new t(...s)});const oi=ct(Array.prototype.forEach),Ht=ct(Array.prototype.pop),Dt=ct(Array.prototype.push),Et=ct(String.prototype.toLowerCase),kt=ct(String.prototype.toString),ai=ct(String.prototype.match),ft=ct(String.prototype.replace),li=ct(String.prototype.indexOf),ui=ct(String.prototype.trim),ut=ct(RegExp.prototype.test),wt=hi(TypeError);function ct(ie){return function(t){for(var s=arguments.length,N=new Array(s>1?s-1:0),x=1;x<s;x++)N[x-1]=arguments[x];return Ft(ie,t,N)}}function hi(ie){return function(){for(var t=arguments.length,s=new Array(t),N=0;N<t;N++)s[N]=arguments[N];return Lt(ie,s)}}function ze(ie,t,s){var N;s=(N=s)!==null&&N!==void 0?N:Et,Wt&&Wt(ie,null);let x=t.length;for(;x--;){let V=t[x];if(typeof V=="string"){const _=s(V);_!==V&&(ii(t)||(t[x]=_),V=_)}ie[V]=!0}return ie}function pt(ie){const t=ri(null);for(const[s,N]of xt(ie))t[s]=N;return t}function St(ie,t){for(;ie!==null;){const N=ni(ie,t);if(N){if(N.get)return ct(N.get);if(typeof N.value=="function")return ct(N.value)}ie=si(ie)}function s(N){return console.warn("fallback value for",N),null}return s}const zt=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Pt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ot=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Mt=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),di=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Vt=ot(["#text"]),$t=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Rt=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Kt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Ct=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),fi=dt(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=dt(/<%[\w\W]*|[\w\W]*%>/gm),mi=dt(/\${[\w\W]*}/gm),pi=dt(/^data-[\-\w.\u00B7-\uFFFF]/),bi=dt(/^aria-[\-\w]+$/),qt=dt(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),vi=dt(/^(?:\w+script|data):/i),Di=dt(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),jt=dt(/^html$/i);var Gt=Object.freeze({__proto__:null,MUSTACHE_EXPR:fi,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:pi,ARIA_ATTR:bi,IS_ALLOWED_URI:qt,IS_SCRIPT_OR_DATA:vi,ATTR_WHITESPACE:Di,DOCTYPE_NAME:jt});const wi=()=>typeof window>"u"?null:window,yi=function(t,s){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let N=null;const x="data-tt-policy-suffix";s&&s.hasAttribute(x)&&(N=s.getAttribute(x));const V="dompurify"+(N?"#"+N:"");try{return t.createPolicy(V,{createHTML(_){return _},createScriptURL(_){return _}})}catch{return console.warn("TrustedTypes policy "+V+" could not be created."),null}};function Ut(){let ie=arguments.length>0&&arguments[0]!==void 0?arguments[0]:wi();const t=xe=>Ut(xe);if(t.version="3.0.5",t.removed=[],!ie||!ie.document||ie.document.nodeType!==9)return t.isSupported=!1,t;const s=ie.document,N=s.currentScript;let{document:x}=ie;const{DocumentFragment:V,HTMLTemplateElement:_,Node:A,Element:m,NodeFilter:p,NamedNodeMap:w=ie.NamedNodeMap||ie.MozNamedAttrMap,HTMLFormElement:W,DOMParser:h,trustedTypes:d}=ie,e=m.prototype,i=St(e,"cloneNode"),r=St(e,"nextSibling"),u=St(e,"childNodes"),g=St(e,"parentNode");if(typeof _=="function"){const xe=x.createElement("template");xe.content&&xe.content.ownerDocument&&(x=xe.content.ownerDocument)}let D,a="";const{implementation:f,createNodeIterator:o,createDocumentFragment:C,getElementsByTagName:F}=x,{importNode:R}=s;let B={};t.isSupported=typeof xt=="function"&&typeof g=="function"&&f&&f.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:P,ERB_EXPR:b,TMPLIT_EXPR:O,DATA_ATTR:$,ARIA_ATTR:k,IS_SCRIPT_OR_DATA:M,ATTR_WHITESPACE:I}=Gt;let{IS_ALLOWED_URI:q}=Gt,X=null;const ce=ze({},[...zt,...Pt,...Ot,...Mt,...Vt]);let re=null;const te=ze({},[...$t,...Rt,...Kt,...Ct]);let be=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Ee=null,Ie=null,Be=!0,ue=!0,J=!1,le=!0,ae=!1,Z=!1,G=!1,ne=!1,de=!1,we=!1,Fe=!1,_e=!0,Pe=!1;const H="user-content-";let c=!0,E=!1,l={},v=null;const T=ze({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let n=null;const S=ze({},["audio","video","img","source","image","track"]);let y=null;const L=ze({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),z="http://www.w3.org/1998/Math/MathML",Y="http://www.w3.org/2000/svg",Q="http://www.w3.org/1999/xhtml";let oe=Q,De=!1,me=null;const ke=ze({},[z,Y,Q],kt);let Ae;const Me=["application/xhtml+xml","text/html"],Se="text/html";let Te,Ve=null;const Qe=x.createElement("form"),Ue=function(he){return he instanceof RegExp||he instanceof Function},Je=function(he){if(!(Ve&&Ve===he)){if((!he||typeof he!="object")&&(he={}),he=pt(he),Ae=Me.indexOf(he.PARSER_MEDIA_TYPE)===-1?Ae=Se:Ae=he.PARSER_MEDIA_TYPE,Te=Ae==="application/xhtml+xml"?kt:Et,X="ALLOWED_TAGS"in he?ze({},he.ALLOWED_TAGS,Te):ce,re="ALLOWED_ATTR"in he?ze({},he.ALLOWED_ATTR,Te):te,me="ALLOWED_NAMESPACES"in he?ze({},he.ALLOWED_NAMESPACES,kt):ke,y="ADD_URI_SAFE_ATTR"in he?ze(pt(L),he.ADD_URI_SAFE_ATTR,Te):L,n="ADD_DATA_URI_TAGS"in he?ze(pt(S),he.ADD_DATA_URI_TAGS,Te):S,v="FORBID_CONTENTS"in he?ze({},he.FORBID_CONTENTS,Te):T,Ee="FORBID_TAGS"in he?ze({},he.FORBID_TAGS,Te):{},Ie="FORBID_ATTR"in he?ze({},he.FORBID_ATTR,Te):{},l="USE_PROFILES"in he?he.USE_PROFILES:!1,Be=he.ALLOW_ARIA_ATTR!==!1,ue=he.ALLOW_DATA_ATTR!==!1,J=he.ALLOW_UNKNOWN_PROTOCOLS||!1,le=he.ALLOW_SELF_CLOSE_IN_ATTR!==!1,ae=he.SAFE_FOR_TEMPLATES||!1,Z=he.WHOLE_DOCUMENT||!1,de=he.RETURN_DOM||!1,we=he.RETURN_DOM_FRAGMENT||!1,Fe=he.RETURN_TRUSTED_TYPE||!1,ne=he.FORCE_BODY||!1,_e=he.SANITIZE_DOM!==!1,Pe=he.SANITIZE_NAMED_PROPS||!1,c=he.KEEP_CONTENT!==!1,E=he.IN_PLACE||!1,q=he.ALLOWED_URI_REGEXP||qt,oe=he.NAMESPACE||Q,be=he.CUSTOM_ELEMENT_HANDLING||{},he.CUSTOM_ELEMENT_HANDLING&&Ue(he.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(be.tagNameCheck=he.CUSTOM_ELEMENT_HANDLING.tagNameCheck),he.CUSTOM_ELEMENT_HANDLING&&Ue(he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(be.attributeNameCheck=he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),he.CUSTOM_ELEMENT_HANDLING&&typeof he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(be.allowCustomizedBuiltInElements=he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),ae&&(ue=!1),we&&(de=!0),l&&(X=ze({},[...Vt]),re=[],l.html===!0&&(ze(X,zt),ze(re,$t)),l.svg===!0&&(ze(X,Pt),ze(re,Rt),ze(re,Ct)),l.svgFilters===!0&&(ze(X,Ot),ze(re,Rt),ze(re,Ct)),l.mathMl===!0&&(ze(X,Mt),ze(re,Kt),ze(re,Ct))),he.ADD_TAGS&&(X===ce&&(X=pt(X)),ze(X,he.ADD_TAGS,Te)),he.ADD_ATTR&&(re===te&&(re=pt(re)),ze(re,he.ADD_ATTR,Te)),he.ADD_URI_SAFE_ATTR&&ze(y,he.ADD_URI_SAFE_ATTR,Te),he.FORBID_CONTENTS&&(v===T&&(v=pt(v)),ze(v,he.FORBID_CONTENTS,Te)),c&&(X["#text"]=!0),Z&&ze(X,["html","head","body"]),X.table&&(ze(X,["tbody"]),delete Ee.tbody),he.TRUSTED_TYPES_POLICY){if(typeof he.TRUSTED_TYPES_POLICY.createHTML!="function")throw wt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof he.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw wt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');D=he.TRUSTED_TYPES_POLICY,a=D.createHTML("")}else D===void 0&&(D=yi(d,N)),D!==null&&typeof a=="string"&&(a=D.createHTML(""));ot&&ot(he),Ve=he}},U=ze({},["mi","mo","mn","ms","mtext"]),se=ze({},["foreignobject","desc","title","annotation-xml"]),ve=ze({},["title","style","font","a","script"]),ye=ze({},Pt);ze(ye,Ot),ze(ye,ci);const Le=ze({},Mt);ze(Le,di);const He=function(he){let Ne=g(he);(!Ne||!Ne.tagName)&&(Ne={namespaceURI:oe,tagName:"template"});const Oe=Et(he.tagName),je=Et(Ne.tagName);return me[he.namespaceURI]?he.namespaceURI===Y?Ne.namespaceURI===Q?Oe==="svg":Ne.namespaceURI===z?Oe==="svg"&&(je==="annotation-xml"||U[je]):!!ye[Oe]:he.namespaceURI===z?Ne.namespaceURI===Q?Oe==="math":Ne.namespaceURI===Y?Oe==="math"&&se[je]:!!Le[Oe]:he.namespaceURI===Q?Ne.namespaceURI===Y&&!se[je]||Ne.namespaceURI===z&&!U[je]?!1:!Le[Oe]&&(ve[Oe]||!ye[Oe]):!!(Ae==="application/xhtml+xml"&&me[he.namespaceURI]):!1},$e=function(he){Dt(t.removed,{element:he});try{he.parentNode.removeChild(he)}catch{he.remove()}},et=function(he,Ne){try{Dt(t.removed,{attribute:Ne.getAttributeNode(he),from:Ne})}catch{Dt(t.removed,{attribute:null,from:Ne})}if(Ne.removeAttribute(he),he==="is"&&!re[he])if(de||we)try{$e(Ne)}catch{}else try{Ne.setAttribute(he,"")}catch{}},it=function(he){let Ne,Oe;if(ne)he="<remove></remove>"+he;else{const lt=ai(he,/^[\r\n\t ]+/);Oe=lt&&lt[0]}Ae==="application/xhtml+xml"&&oe===Q&&(he='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+he+"</body></html>");const je=D?D.createHTML(he):he;if(oe===Q)try{Ne=new h().parseFromString(je,Ae)}catch{}if(!Ne||!Ne.documentElement){Ne=f.createDocument(oe,"template",null);try{Ne.documentElement.innerHTML=De?a:je}catch{}}const st=Ne.body||Ne.documentElement;return he&&Oe&&st.insertBefore(x.createTextNode(Oe),st.childNodes[0]||null),oe===Q?F.call(Ne,Z?"html":"body")[0]:Z?Ne.documentElement:st},nt=function(he){return o.call(he.ownerDocument||he,he,p.SHOW_ELEMENT|p.SHOW_COMMENT|p.SHOW_TEXT,null,!1)},Ze=function(he){return he instanceof W&&(typeof he.nodeName!="string"||typeof he.textContent!="string"||typeof he.removeChild!="function"||!(he.attributes instanceof w)||typeof he.removeAttribute!="function"||typeof he.setAttribute!="function"||typeof he.namespaceURI!="string"||typeof he.insertBefore!="function"||typeof he.hasChildNodes!="function")},rt=function(he){return typeof A=="object"?he instanceof A:he&&typeof he=="object"&&typeof he.nodeType=="number"&&typeof he.nodeName=="string"},tt=function(he,Ne,Oe){B[he]&&oi(B[he],je=>{je.call(t,Ne,Oe,Ve)})},mt=function(he){let Ne;if(tt("beforeSanitizeElements",he,null),Ze(he))return $e(he),!0;const Oe=Te(he.nodeName);if(tt("uponSanitizeElement",he,{tagName:Oe,allowedTags:X}),he.hasChildNodes()&&!rt(he.firstElementChild)&&(!rt(he.content)||!rt(he.content.firstElementChild))&&ut(/<[/\w]/g,he.innerHTML)&&ut(/<[/\w]/g,he.textContent))return $e(he),!0;if(!X[Oe]||Ee[Oe]){if(!Ee[Oe]&&_t(Oe)&&(be.tagNameCheck instanceof RegExp&&ut(be.tagNameCheck,Oe)||be.tagNameCheck instanceof Function&&be.tagNameCheck(Oe)))return!1;if(c&&!v[Oe]){const je=g(he)||he.parentNode,st=u(he)||he.childNodes;if(st&&je){const lt=st.length;for(let Ye=lt-1;Ye>=0;--Ye)je.insertBefore(i(st[Ye],!0),r(he))}}return $e(he),!0}return he instanceof m&&!He(he)||(Oe==="noscript"||Oe==="noembed"||Oe==="noframes")&&ut(/<\/no(script|embed|frames)/i,he.innerHTML)?($e(he),!0):(ae&&he.nodeType===3&&(Ne=he.textContent,Ne=ft(Ne,P," "),Ne=ft(Ne,b," "),Ne=ft(Ne,O," "),he.textContent!==Ne&&(Dt(t.removed,{element:he.cloneNode()}),he.textContent=Ne)),tt("afterSanitizeElements",he,null),!1)},gt=function(he,Ne,Oe){if(_e&&(Ne==="id"||Ne==="name")&&(Oe in x||Oe in Qe))return!1;if(!(ue&&!Ie[Ne]&&ut($,Ne))){if(!(Be&&ut(k,Ne))){if(!re[Ne]||Ie[Ne]){if(!(_t(he)&&(be.tagNameCheck instanceof RegExp&&ut(be.tagNameCheck,he)||be.tagNameCheck instanceof Function&&be.tagNameCheck(he))&&(be.attributeNameCheck instanceof RegExp&&ut(be.attributeNameCheck,Ne)||be.attributeNameCheck instanceof Function&&be.attributeNameCheck(Ne))||Ne==="is"&&be.allowCustomizedBuiltInElements&&(be.tagNameCheck instanceof RegExp&&ut(be.tagNameCheck,Oe)||be.tagNameCheck instanceof Function&&be.tagNameCheck(Oe))))return!1}else if(!y[Ne]){if(!ut(q,ft(Oe,I,""))){if(!((Ne==="src"||Ne==="xlink:href"||Ne==="href")&&he!=="script"&&li(Oe,"data:")===0&&n[he])){if(!(J&&!ut(M,ft(Oe,I,"")))){if(Oe)return!1}}}}}}return!0},_t=function(he){return he.indexOf("-")>0},At=function(he){let Ne,Oe,je,st;tt("beforeSanitizeAttributes",he,null);const{attributes:lt}=he;if(!lt)return;const Ye={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:re};for(st=lt.length;st--;){Ne=lt[st];const{name:ht,namespaceURI:bt}=Ne;if(Oe=ht==="value"?Ne.value:ui(Ne.value),je=Te(ht),Ye.attrName=je,Ye.attrValue=Oe,Ye.keepAttr=!0,Ye.forceKeepAttr=void 0,tt("uponSanitizeAttribute",he,Ye),Oe=Ye.attrValue,Ye.forceKeepAttr||(et(ht,he),!Ye.keepAttr))continue;if(!le&&ut(/\/>/i,Oe)){et(ht,he);continue}ae&&(Oe=ft(Oe,P," "),Oe=ft(Oe,b," "),Oe=ft(Oe,O," "));const It=Te(he.nodeName);if(gt(It,je,Oe)){if(Pe&&(je==="id"||je==="name")&&(et(ht,he),Oe=H+Oe),D&&typeof d=="object"&&typeof d.getAttributeType=="function"&&!bt)switch(d.getAttributeType(It,je)){case"TrustedHTML":{Oe=D.createHTML(Oe);break}case"TrustedScriptURL":{Oe=D.createScriptURL(Oe);break}}try{bt?he.setAttributeNS(bt,ht,Oe):he.setAttribute(ht,Oe),Ht(t.removed)}catch{}}}tt("afterSanitizeAttributes",he,null)},Tt=function xe(he){let Ne;const Oe=nt(he);for(tt("beforeSanitizeShadowDOM",he,null);Ne=Oe.nextNode();)tt("uponSanitizeShadowNode",Ne,null),!mt(Ne)&&(Ne.content instanceof V&&xe(Ne.content),At(Ne));tt("afterSanitizeShadowDOM",he,null)};return t.sanitize=function(xe){let he=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Ne,Oe,je,st;if(De=!xe,De&&(xe="<!-->"),typeof xe!="string"&&!rt(xe))if(typeof xe.toString=="function"){if(xe=xe.toString(),typeof xe!="string")throw wt("dirty is not a string, aborting")}else throw wt("toString is not a function");if(!t.isSupported)return xe;if(G||Je(he),t.removed=[],typeof xe=="string"&&(E=!1),E){if(xe.nodeName){const ht=Te(xe.nodeName);if(!X[ht]||Ee[ht])throw wt("root node is forbidden and cannot be sanitized in-place")}}else if(xe instanceof A)Ne=it("<!---->"),Oe=Ne.ownerDocument.importNode(xe,!0),Oe.nodeType===1&&Oe.nodeName==="BODY"||Oe.nodeName==="HTML"?Ne=Oe:Ne.appendChild(Oe);else{if(!de&&!ae&&!Z&&xe.indexOf("<")===-1)return D&&Fe?D.createHTML(xe):xe;if(Ne=it(xe),!Ne)return de?null:Fe?a:""}Ne&&ne&&$e(Ne.firstChild);const lt=nt(E?xe:Ne);for(;je=lt.nextNode();)mt(je)||(je.content instanceof V&&Tt(je.content),At(je));if(E)return xe;if(de){if(we)for(st=C.call(Ne.ownerDocument);Ne.firstChild;)st.appendChild(Ne.firstChild);else st=Ne;return(re.shadowroot||re.shadowrootmode)&&(st=R.call(s,st,!0)),st}let Ye=Z?Ne.outerHTML:Ne.innerHTML;return Z&&X["!doctype"]&&Ne.ownerDocument&&Ne.ownerDocument.doctype&&Ne.ownerDocument.doctype.name&&ut(jt,Ne.ownerDocument.doctype.name)&&(Ye="<!DOCTYPE "+Ne.ownerDocument.doctype.name+`>
`+Ye),ae&&(Ye=ft(Ye,P," "),Ye=ft(Ye,b," "),Ye=ft(Ye,O," ")),D&&Fe?D.createHTML(Ye):Ye},t.setConfig=function(xe){Je(xe),G=!0},t.clearConfig=function(){Ve=null,G=!1},t.isValidAttribute=function(xe,he,Ne){Ve||Je({});const Oe=Te(xe),je=Te(he);return gt(Oe,je,Ne)},t.addHook=function(xe,he){typeof he=="function"&&(B[xe]=B[xe]||[],Dt(B[xe],he))},t.removeHook=function(xe){if(B[xe])return Ht(B[xe])},t.removeHooks=function(xe){B[xe]&&(B[xe]=[])},t.removeAllHooks=function(){B={}},t}var Ei=Ut();define("vs/base/browser/dompurify/dompurify",function(){return Ei}),define(ge[51],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FastDomNode=void 0,t.createFastDomNode=x;class s{constructor(_){this.domNode=_,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._paddingTop="",this._paddingLeft="",this._paddingBottom="",this._paddingRight="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._fontVariationSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(_){const A=N(_);this._maxWidth!==A&&(this._maxWidth=A,this.domNode.style.maxWidth=this._maxWidth)}setWidth(_){const A=N(_);this._width!==A&&(this._width=A,this.domNode.style.width=this._width)}setHeight(_){const A=N(_);this._height!==A&&(this._height=A,this.domNode.style.height=this._height)}setTop(_){const A=N(_);this._top!==A&&(this._top=A,this.domNode.style.top=this._top)}setLeft(_){const A=N(_);this._left!==A&&(this._left=A,this.domNode.style.left=this._left)}setBottom(_){const A=N(_);this._bottom!==A&&(this._bottom=A,this.domNode.style.bottom=this._bottom)}setRight(_){const A=N(_);this._right!==A&&(this._right=A,this.domNode.style.right=this._right)}setPaddingTop(_){const A=N(_);this._paddingTop!==A&&(this._paddingTop=A,this.domNode.style.paddingTop=this._paddingTop)}setPaddingLeft(_){const A=N(_);this._paddingLeft!==A&&(this._paddingLeft=A,this.domNode.style.paddingLeft=this._paddingLeft)}setPaddingBottom(_){const A=N(_);this._paddingBottom!==A&&(this._paddingBottom=A,this.domNode.style.paddingBottom=this._paddingBottom)}setPaddingRight(_){const A=N(_);this._paddingRight!==A&&(this._paddingRight=A,this.domNode.style.paddingRight=this._paddingRight)}setFontFamily(_){this._fontFamily!==_&&(this._fontFamily=_,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(_){this._fontWeight!==_&&(this._fontWeight=_,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(_){const A=N(_);this._fontSize!==A&&(this._fontSize=A,this.domNode.style.fontSize=this._fontSize)}setFontStyle(_){this._fontStyle!==_&&(this._fontStyle=_,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(_){this._fontFeatureSettings!==_&&(this._fontFeatureSettings=_,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setFontVariationSettings(_){this._fontVariationSettings!==_&&(this._fontVariationSettings=_,this.domNode.style.fontVariationSettings=this._fontVariationSettings)}setTextDecoration(_){this._textDecoration!==_&&(this._textDecoration=_,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(_){const A=N(_);this._lineHeight!==A&&(this._lineHeight=A,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(_){const A=N(_);this._letterSpacing!==A&&(this._letterSpacing=A,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(_){this._className!==_&&(this._className=_,this.domNode.className=this._className)}toggleClassName(_,A){this.domNode.classList.toggle(_,A),this._className=this.domNode.className}setDisplay(_){this._display!==_&&(this._display=_,this.domNode.style.display=this._display)}setPosition(_){this._position!==_&&(this._position=_,this.domNode.style.position=this._position)}setVisibility(_){this._visibility!==_&&(this._visibility=_,this.domNode.style.visibility=this._visibility)}setColor(_){this._color!==_&&(this._color=_,this.domNode.style.color=this._color)}setBackgroundColor(_){this._backgroundColor!==_&&(this._backgroundColor=_,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(_){this._layerHint!==_&&(this._layerHint=_,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(_){this._boxShadow!==_&&(this._boxShadow=_,this.domNode.style.boxShadow=_)}setContain(_){this._contain!==_&&(this._contain=_,this.domNode.style.contain=this._contain)}setAttribute(_,A){this.domNode.setAttribute(_,A)}removeAttribute(_){this.domNode.removeAttribute(_)}appendChild(_){this.domNode.appendChild(_.domNode)}removeChild(_){this.domNode.removeChild(_.domNode)}}t.FastDomNode=s;function N(V){return typeof V=="number"?`${V}px`:V}function x(V){return new s(V)}}),define(ge[79],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0,t.parentOriginHash=V;const s=new WeakMap;function N(A){if(!A.parent||A.parent===A)return null;try{const m=A.location,p=A.parent.location;if(m.origin!=="null"&&p.origin!=="null"&&m.origin!==p.origin)return null}catch{return null}return A.parent}class x{static getSameOriginWindowChain(m){let p=s.get(m);if(!p){p=[],s.set(m,p);let w=m,W;do W=N(w),W?p.push({window:new WeakRef(w),iframeElement:w.frameElement||null}):p.push({window:new WeakRef(w),iframeElement:null}),w=W;while(w)}return p.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(m,p){if(!p||m===p)return{top:0,left:0};let w=0,W=0;const h=this.getSameOriginWindowChain(m);for(const d of h){const e=d.window.deref();if(w+=e?.scrollY??0,W+=e?.scrollX??0,e===p||!d.iframeElement)break;const i=d.iframeElement.getBoundingClientRect();w+=i.top,W+=i.left}return{top:w,left:W}}}t.IframeUtils=x;async function V(A,m){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const p=JSON.stringify({parentOrigin:A,salt:m}),W=new TextEncoder().encode(p),h=await crypto.subtle.digest("sha-256",W);return _(h)}function _(A){const p=Array.from(new Uint8Array(A)).map(w=>w.toString(16).padStart(2,"0")).join("");return BigInt(`0x${p}`).toString(32).padStart(52,"0")}}),define(ge[80],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var s;(function(_){_[_.Copy=0]="Copy",_[_.Move=1]="Move"})(s||(t.ListDragOverEffectType=s={}));var N;(function(_){_.Over="drop-target",_.Before="drop-target-before",_.After="drop-target-after"})(N||(t.ListDragOverEffectPosition=N={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class x extends Error{constructor(A,m){super(`ListError [${A}] ${m}`)}}t.ListError=x;class V{constructor(){this.cache=new WeakMap}getHeight(A){return this.cache.get(A)??this.estimateHeight(A)}setDynamicHeight(A,m){m>0&&this.cache.set(A,m)}}t.CachedListVirtualDelegate=V}),define(ge[81],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class s{constructor(x){this.spliceables=x}splice(x,V,_){this.spliceables.forEach(A=>A.splice(x,V,_))}}t.CombinedSpliceable=s}),define(ge[52],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const s=20;class N{constructor(V,_,A,m,p,w){this._scrollbarSize=Math.round(_),this._oppositeScrollbarSize=Math.round(A),this._arrowSize=Math.round(V),this._visibleSize=m,this._scrollSize=p,this._scrollPosition=w,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new N(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(V){const _=Math.round(V);return this._visibleSize!==_?(this._visibleSize=_,this._refreshComputedValues(),!0):!1}setScrollSize(V){const _=Math.round(V);return this._scrollSize!==_?(this._scrollSize=_,this._refreshComputedValues(),!0):!1}setScrollPosition(V){const _=Math.round(V);return this._scrollPosition!==_?(this._scrollPosition=_,this._refreshComputedValues(),!0):!1}setScrollbarSize(V){this._scrollbarSize=Math.round(V)}setOppositeScrollbarSize(V){this._oppositeScrollbarSize=Math.round(V)}static _computeValues(V,_,A,m,p){const w=Math.max(0,A-V),W=Math.max(0,w-2*_),h=m>0&&m>A;if(!h)return{computedAvailableSize:Math.round(w),computedIsNeeded:h,computedSliderSize:Math.round(W),computedSliderRatio:0,computedSliderPosition:0};const d=Math.round(Math.max(s,Math.floor(A*W/m))),e=(W-d)/(m-A),i=p*e;return{computedAvailableSize:Math.round(w),computedIsNeeded:h,computedSliderSize:Math.round(d),computedSliderRatio:e,computedSliderPosition:Math.round(i)}}_refreshComputedValues(){const V=N._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=V.computedAvailableSize,this._computedIsNeeded=V.computedIsNeeded,this._computedSliderSize=V.computedSliderSize,this._computedSliderRatio=V.computedSliderRatio,this._computedSliderPosition=V.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(V){if(!this._computedIsNeeded)return 0;const _=V-this._arrowSize-this._computedSliderSize/2;return Math.round(_/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(V){if(!this._computedIsNeeded)return 0;const _=V-this._arrowSize;let A=this._scrollPosition;return _<this._computedSliderPosition?A-=this._visibleSize:A+=this._visibleSize,A}getDesiredScrollPositionFromDelta(V){if(!this._computedIsNeeded)return 0;const _=this._computedSliderPosition+V;return Math.round(_/this._computedSliderRatio)}}t.ScrollbarState=N}),define(ge[30],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var s;(function(m){m[m.Hidden=0]="Hidden",m[m.Visible=1]="Visible",m[m.Recurse=2]="Recurse"})(s||(t.TreeVisibility=s={}));var N;(function(m){m[m.Expanded=0]="Expanded",m[m.Collapsed=1]="Collapsed",m[m.PreserveOrExpanded=2]="PreserveOrExpanded",m[m.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(N||(t.ObjectTreeElementCollapseState=N={}));var x;(function(m){m[m.Unknown=0]="Unknown",m[m.Twistie=1]="Twistie",m[m.Element=2]="Element",m[m.Filter=3]="Filter"})(x||(t.TreeMouseEventTarget=x={}));var V;(function(m){m[m.Down=0]="Down",m[m.Up=1]="Up"})(V||(t.TreeDragOverBubble=V={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(m=!1){return{accept:!0,bubble:0,autoExpand:m}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(m=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:m}}};class _ extends Error{constructor(p,w){super(`TreeError [${p}] ${w}`)}}t.TreeError=_;class A{constructor(p){this.fn=p,this._map=new WeakMap}map(p){let w=this._map.get(p);return w||(w=this.fn(p),this._map.set(p,w)),w}}t.WeakMapper=A}),define(ge[22],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mainWindow=void 0,t.ensureCodeWindow=s,t.isAuxiliaryWindow=N;function s(x,V){const _=x;typeof _.vscodeWindowId!="number"&&Object.defineProperty(_,"vscodeWindowId",{get:()=>V})}t.mainWindow=window;function N(x){return x===t.mainWindow?!1:typeof x?.vscodeWindowId=="number"}}),define(ge[82],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MonotonousArray=void 0,t.findLast=s,t.findLastIdx=N,t.findLastMonotonous=x,t.findLastIdxMonotonous=V,t.findFirstMonotonous=_,t.findFirstIdxMonotonousOrArrLen=A,t.findFirstIdxMonotonous=m,t.findFirstMaxBy=w,t.findLastMaxBy=W,t.findFirstMinBy=h,t.findMaxIdxBy=d,t.mapFindFirst=e;function s(i,r,u){const g=N(i,r);if(g!==-1)return i[g]}function N(i,r,u=i.length-1){for(let g=u;g>=0;g--){const D=i[g];if(r(D))return g}return-1}function x(i,r){const u=V(i,r);return u===-1?void 0:i[u]}function V(i,r,u=0,g=i.length){let D=u,a=g;for(;D<a;){const f=Math.floor((D+a)/2);r(i[f])?D=f+1:a=f}return D-1}function _(i,r){const u=A(i,r);return u===i.length?void 0:i[u]}function A(i,r,u=0,g=i.length){let D=u,a=g;for(;D<a;){const f=Math.floor((D+a)/2);r(i[f])?a=f:D=f+1}return D}function m(i,r,u=0,g=i.length){const D=A(i,r,u,g);return D===i.length?-1:D}class p{static{this.assertInvariants=!1}constructor(r){this._array=r,this._findLastMonotonousLastIdx=0}findLastMonotonous(r){if(p.assertInvariants){if(this._prevFindLastPredicate){for(const g of this._array)if(this._prevFindLastPredicate(g)&&!r(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=r}const u=V(this._array,r,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=u+1,u===-1?void 0:this._array[u]}}t.MonotonousArray=p;function w(i,r){if(i.length===0)return;let u=i[0];for(let g=1;g<i.length;g++){const D=i[g];r(D,u)>0&&(u=D)}return u}function W(i,r){if(i.length===0)return;let u=i[0];for(let g=1;g<i.length;g++){const D=i[g];r(D,u)>=0&&(u=D)}return u}function h(i,r){return w(i,(u,g)=>-r(u,g))}function d(i,r){if(i.length===0)return-1;let u=0;for(let g=1;g<i.length;g++){const D=i[g];r(D,i[u])>0&&(u=g)}return u}function e(i,r){for(const u of i){const g=r(u);if(g!==void 0)return g}}}),define(ge[83],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.groupBy=s,t.diffSets=N,t.diffMaps=x,t.intersection=V;function s(_,A){const m=Object.create(null);for(const p of _){const w=A(p);let W=m[w];W||(W=m[w]=[]),W.push(p)}return m}function N(_,A){const m=[],p=[];for(const w of _)A.has(w)||m.push(w);for(const w of A)_.has(w)||p.push(w);return{removed:m,added:p}}function x(_,A){const m=[],p=[];for(const[w,W]of _)A.has(w)||m.push(W);for(const[w,W]of A)_.has(w)||p.push(W);return{removed:m,added:p}}function V(_,A){const m=new Set;for(const p of A)_.has(p)&&m.add(p);return m}}),define(ge[84],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function s(A,m){const p=Math.pow(10,m);return Math.round(A*p)/p}class N{constructor(m,p,w,W=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,m))|0,this.g=Math.min(255,Math.max(0,p))|0,this.b=Math.min(255,Math.max(0,w))|0,this.a=s(Math.max(Math.min(1,W),0),3)}static equals(m,p){return m.r===p.r&&m.g===p.g&&m.b===p.b&&m.a===p.a}}t.RGBA=N;class x{constructor(m,p,w,W){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=s(Math.max(Math.min(1,p),0),3),this.l=s(Math.max(Math.min(1,w),0),3),this.a=s(Math.max(Math.min(1,W),0),3)}static equals(m,p){return m.h===p.h&&m.s===p.s&&m.l===p.l&&m.a===p.a}static fromRGBA(m){const p=m.r/255,w=m.g/255,W=m.b/255,h=m.a,d=Math.max(p,w,W),e=Math.min(p,w,W);let i=0,r=0;const u=(e+d)/2,g=d-e;if(g>0){switch(r=Math.min(u<=.5?g/(2*u):g/(2-2*u),1),d){case p:i=(w-W)/g+(w<W?6:0);break;case w:i=(W-p)/g+2;break;case W:i=(p-w)/g+4;break}i*=60,i=Math.round(i)}return new x(i,r,u,h)}static _hue2rgb(m,p,w){return w<0&&(w+=1),w>1&&(w-=1),w<1/6?m+(p-m)*6*w:w<1/2?p:w<2/3?m+(p-m)*(2/3-w)*6:m}static toRGBA(m){const p=m.h/360,{s:w,l:W,a:h}=m;let d,e,i;if(w===0)d=e=i=W;else{const r=W<.5?W*(1+w):W+w-W*w,u=2*W-r;d=x._hue2rgb(u,r,p+1/3),e=x._hue2rgb(u,r,p),i=x._hue2rgb(u,r,p-1/3)}return new N(Math.round(d*255),Math.round(e*255),Math.round(i*255),h)}}t.HSLA=x;class V{constructor(m,p,w,W){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=s(Math.max(Math.min(1,p),0),3),this.v=s(Math.max(Math.min(1,w),0),3),this.a=s(Math.max(Math.min(1,W),0),3)}static equals(m,p){return m.h===p.h&&m.s===p.s&&m.v===p.v&&m.a===p.a}static fromRGBA(m){const p=m.r/255,w=m.g/255,W=m.b/255,h=Math.max(p,w,W),d=Math.min(p,w,W),e=h-d,i=h===0?0:e/h;let r;return e===0?r=0:h===p?r=((w-W)/e%6+6)%6:h===w?r=(W-p)/e+2:r=(p-w)/e+4,new V(Math.round(r*60),i,h,m.a)}static toRGBA(m){const{h:p,s:w,v:W,a:h}=m,d=W*w,e=d*(1-Math.abs(p/60%2-1)),i=W-d;let[r,u,g]=[0,0,0];return p<60?(r=d,u=e):p<120?(r=e,u=d):p<180?(u=d,g=e):p<240?(u=e,g=d):p<300?(r=e,g=d):p<=360&&(r=d,g=e),r=Math.round((r+i)*255),u=Math.round((u+i)*255),g=Math.round((g+i)*255),new N(r,u,g,h)}}t.HSVA=V;class _{static fromHex(m){return _.Format.CSS.parseHex(m)||_.red}static equals(m,p){return!m&&!p?!0:!m||!p?!1:m.equals(p)}get hsla(){return this._hsla?this._hsla:x.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:V.fromRGBA(this.rgba)}constructor(m){if(m)if(m instanceof N)this.rgba=m;else if(m instanceof x)this._hsla=m,this.rgba=x.toRGBA(m);else if(m instanceof V)this._hsva=m,this.rgba=V.toRGBA(m);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(m){return!!m&&N.equals(this.rgba,m.rgba)&&x.equals(this.hsla,m.hsla)&&V.equals(this.hsva,m.hsva)}getRelativeLuminance(){const m=_._relativeLuminanceForComponent(this.rgba.r),p=_._relativeLuminanceForComponent(this.rgba.g),w=_._relativeLuminanceForComponent(this.rgba.b),W=.2126*m+.7152*p+.0722*w;return s(W,4)}static _relativeLuminanceForComponent(m){const p=m/255;return p<=.03928?p/12.92:Math.pow((p+.055)/1.055,2.4)}getContrastRatio(m){const p=this.getRelativeLuminance(),w=m.getRelativeLuminance();return p>w?(p+.05)/(w+.05):(w+.05)/(p+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(m){const p=this.getRelativeLuminance(),w=m.getRelativeLuminance();return p>w}isDarkerThan(m){const p=this.getRelativeLuminance(),w=m.getRelativeLuminance();return p<w}lighten(m){return new _(new x(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*m,this.hsla.a))}darken(m){return new _(new x(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*m,this.hsla.a))}transparent(m){const{r:p,g:w,b:W,a:h}=this.rgba;return new _(new N(p,w,W,h*m))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new _(new N(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(m){const p=m.rgba,w=this.rgba.a,W=p.a,h=w+W*(1-w);if(h<1e-6)return _.transparent;const d=this.rgba.r*w/h+p.r*W*(1-w)/h,e=this.rgba.g*w/h+p.g*W*(1-w)/h,i=this.rgba.b*w/h+p.b*W*(1-w)/h;return new _(new N(d,e,i,h))}makeOpaque(m){if(this.isOpaque()||m.rgba.a!==1)return this;const{r:p,g:w,b:W,a:h}=this.rgba;return new _(new N(m.rgba.r-h*(m.rgba.r-p),m.rgba.g-h*(m.rgba.g-w),m.rgba.b-h*(m.rgba.b-W),1))}flatten(...m){const p=m.reduceRight((w,W)=>_._flatten(W,w));return _._flatten(this,p)}static _flatten(m,p){const w=1-m.rgba.a;return new _(new N(w*p.rgba.r+m.rgba.a*m.rgba.r,w*p.rgba.g+m.rgba.a*m.rgba.g,w*p.rgba.b+m.rgba.a*m.rgba.b))}toString(){return this._toString||(this._toString=_.Format.CSS.format(this)),this._toString}static getLighterColor(m,p,w){if(m.isLighterThan(p))return m;w=w||.5;const W=m.getRelativeLuminance(),h=p.getRelativeLuminance();return w=w*(h-W)/h,m.lighten(w)}static getDarkerColor(m,p,w){if(m.isDarkerThan(p))return m;w=w||.5;const W=m.getRelativeLuminance(),h=p.getRelativeLuminance();return w=w*(W-h)/W,m.darken(w)}static{this.white=new _(new N(255,255,255,1))}static{this.black=new _(new N(0,0,0,1))}static{this.red=new _(new N(255,0,0,1))}static{this.blue=new _(new N(0,0,255,1))}static{this.green=new _(new N(0,255,0,1))}static{this.cyan=new _(new N(0,255,255,1))}static{this.lightgrey=new _(new N(211,211,211,1))}static{this.transparent=new _(new N(0,0,0,0))}}t.Color=_,function(A){let m;(function(p){let w;(function(W){function h(o){return o.rgba.a===1?`rgb(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b})`:A.Format.CSS.formatRGBA(o)}W.formatRGB=h;function d(o){return`rgba(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b}, ${+o.rgba.a.toFixed(2)})`}W.formatRGBA=d;function e(o){return o.hsla.a===1?`hsl(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%)`:A.Format.CSS.formatHSLA(o)}W.formatHSL=e;function i(o){return`hsla(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%, ${o.hsla.a.toFixed(2)})`}W.formatHSLA=i;function r(o){const C=o.toString(16);return C.length!==2?"0"+C:C}function u(o){return`#${r(o.rgba.r)}${r(o.rgba.g)}${r(o.rgba.b)}`}W.formatHex=u;function g(o,C=!1){return C&&o.rgba.a===1?A.Format.CSS.formatHex(o):`#${r(o.rgba.r)}${r(o.rgba.g)}${r(o.rgba.b)}${r(Math.round(o.rgba.a*255))}`}W.formatHexA=g;function D(o){return o.isOpaque()?A.Format.CSS.formatHex(o):A.Format.CSS.formatRGBA(o)}W.format=D;function a(o){const C=o.length;if(C===0||o.charCodeAt(0)!==35)return null;if(C===7){const F=16*f(o.charCodeAt(1))+f(o.charCodeAt(2)),R=16*f(o.charCodeAt(3))+f(o.charCodeAt(4)),B=16*f(o.charCodeAt(5))+f(o.charCodeAt(6));return new A(new N(F,R,B,1))}if(C===9){const F=16*f(o.charCodeAt(1))+f(o.charCodeAt(2)),R=16*f(o.charCodeAt(3))+f(o.charCodeAt(4)),B=16*f(o.charCodeAt(5))+f(o.charCodeAt(6)),P=16*f(o.charCodeAt(7))+f(o.charCodeAt(8));return new A(new N(F,R,B,P/255))}if(C===4){const F=f(o.charCodeAt(1)),R=f(o.charCodeAt(2)),B=f(o.charCodeAt(3));return new A(new N(16*F+F,16*R+R,16*B+B))}if(C===5){const F=f(o.charCodeAt(1)),R=f(o.charCodeAt(2)),B=f(o.charCodeAt(3)),P=f(o.charCodeAt(4));return new A(new N(16*F+F,16*R+R,16*B+B,(16*P+P)/255))}return null}W.parseHex=a;function f(o){switch(o){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(w=p.CSS||(p.CSS={}))})(m=A.Format||(A.Format={}))}(_||(t.Color=_={}))}),define(ge[31],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.memoize=N,t.debounce=x,t.throttle=V;function s(_){return(A,m,p)=>{let w=null,W=null;if(typeof p.value=="function"?(w="value",W=p.value):typeof p.get=="function"&&(w="get",W=p.get),!W)throw new Error("not supported");p[w]=_(W,m)}}function N(_,A,m){let p=null,w=null;if(typeof m.value=="function"?(p="value",w=m.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(p="get",w=m.get),!w)throw new Error("not supported");const W=`$memoize$${A}`;m[p]=function(...h){return this.hasOwnProperty(W)||Object.defineProperty(this,W,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,h)}),this[W]}}function x(_,A,m){return s((p,w)=>{const W=`$debounce$${w}`,h=`$debounce$result$${w}`;return function(...d){this[h]||(this[h]=m?m():void 0),clearTimeout(this[W]),A&&(this[h]=A(this[h],...d),d=[this[h]]),this[W]=setTimeout(()=>{p.apply(this,d),this[h]=m?m():void 0},_)}})}function V(_,A,m){return s((p,w)=>{const W=`$throttle$timer$${w}`,h=`$throttle$result$${w}`,d=`$throttle$lastRun$${w}`,e=`$throttle$pending$${w}`;return function(...i){if(this[h]||(this[h]=m?m():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),A&&(this[h]=A(this[h],...i)),this[e])return;const r=this[d]+_;r<=Date.now()?(this[d]=Date.now(),p.apply(this,[this[h]]),this[h]=m?m():void 0):(this[e]=!0,this[W]=setTimeout(()=>{this[e]=!1,this[d]=Date.now(),p.apply(this,[this[h]]),this[h]=m?m():void 0},r-Date.now()))}})}}),define(ge[85],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class s{constructor(x,V,_,A){this.originalStart=x,this.originalLength=V,this.modifiedStart=_,this.modifiedLength=A}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=s}),define(ge[6],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.ReadonlyError=t.CancellationError=t.errorHandler=t.ErrorHandler=void 0,t.setUnexpectedErrorHandler=N,t.isSigPipeError=x,t.onUnexpectedError=V,t.onUnexpectedExternalError=_,t.transformErrorForSerialization=A,t.isCancellationError=p,t.canceled=W,t.illegalArgument=h,t.illegalState=d,t.getErrorMessage=i;class s{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?D.isErrorNoTelemetry(o)?new D(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(C=>{C(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}t.ErrorHandler=s,t.errorHandler=new s;function N(f){t.errorHandler.setUnexpectedErrorHandler(f)}function x(f){if(!f||typeof f!="object")return!1;const o=f;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}function V(f){p(f)||t.errorHandler.onUnexpectedError(f)}function _(f){p(f)||t.errorHandler.onUnexpectedExternalError(f)}function A(f){if(f instanceof Error){const{name:o,message:C}=f,F=f.stacktrace||f.stack;return{$isError:!0,name:o,message:C,stack:F,noTelemetry:D.isErrorNoTelemetry(f)}}return f}const m="Canceled";function p(f){return f instanceof w?!0:f instanceof Error&&f.name===m&&f.message===m}class w extends Error{constructor(){super(m),this.name=this.message}}t.CancellationError=w;function W(){const f=new Error(m);return f.name=f.message,f}function h(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}function d(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}class e extends TypeError{constructor(o){super(o?`${o} is read-only and cannot be changed`:"Cannot change read-only property")}}t.ReadonlyError=e;function i(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}class r extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}t.NotImplementedError=r;class u extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}t.NotSupportedError=u;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=g;class D extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof D)return o;const C=new D;return C.message=o.message,C.stack=o.stack,C}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}t.ErrorNoTelemetry=D;class a extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,a.prototype)}}t.BugIndicatingError=a}),define(ge[12],pe([1,0,6,82]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Permutation=t.CallbackIterable=t.ArrayQueue=t.booleanComparator=t.numberComparator=t.CompareResult=void 0,t.tail=x,t.tail2=V,t.equals=_,t.removeFastWithoutKeepingOrder=A,t.binarySearch=m,t.binarySearch2=p,t.quickSelect=w,t.groupBy=W,t.groupAdjacentBy=h,t.forEachAdjacent=d,t.forEachWithNeighbors=e,t.sortedDiff=i,t.delta=r,t.top=u,t.topAsync=g,t.coalesce=a,t.coalesceInPlace=f,t.move=o,t.isFalsyOrEmpty=C,t.isNonEmptyArray=F,t.distinct=R,t.uniqueFilter=B,t.firstOrDefault=P,t.lastOrDefault=b,t.commonPrefixLength=O,t.flatten=$,t.range=k,t.index=M,t.insert=I,t.remove=q,t.arrayInsert=X,t.shuffle=ce,t.pushToStart=re,t.pushToEnd=te,t.pushMany=be,t.mapArrayOrNot=Ee,t.asArray=Ie,t.getRandomElement=Be,t.insertInto=ue,t.splice=J,t.compareBy=Z,t.tieBreakComparators=G,t.reverseOrder=we;function x(H,c=0){return H[H.length-(1+c)]}function V(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}function _(H,c,E=(l,v)=>l===v){if(H===c)return!0;if(!H||!c||H.length!==c.length)return!1;for(let l=0,v=H.length;l<v;l++)if(!E(H[l],c[l]))return!1;return!0}function A(H,c){const E=H.length-1;c<E&&(H[c]=H[E]),H.pop()}function m(H,c,E){return p(H.length,l=>E(H[l],c))}function p(H,c){let E=0,l=H-1;for(;E<=l;){const v=(E+l)/2|0,T=c(v);if(T<0)E=v+1;else if(T>0)l=v-1;else return v}return-(E+1)}function w(H,c,E){if(H=H|0,H>=c.length)throw new TypeError("invalid index");const l=c[Math.floor(c.length*Math.random())],v=[],T=[],n=[];for(const S of c){const y=E(S,l);y<0?v.push(S):y>0?T.push(S):n.push(S)}return H<v.length?w(H,v,E):H<v.length+n.length?n[0]:w(H-(v.length+n.length),T,E)}function W(H,c){const E=[];let l;for(const v of H.slice(0).sort(c))!l||c(l[0],v)!==0?(l=[v],E.push(l)):l.push(v);return E}function*h(H,c){let E,l;for(const v of H)l!==void 0&&c(l,v)?E.push(v):(E&&(yield E),E=[v]),l=v;E&&(yield E)}function d(H,c){for(let E=0;E<=H.length;E++)c(E===0?void 0:H[E-1],E===H.length?void 0:H[E])}function e(H,c){for(let E=0;E<H.length;E++)c(E===0?void 0:H[E-1],H[E],E+1===H.length?void 0:H[E+1])}function i(H,c,E){const l=[];function v(S,y,L){if(y===0&&L.length===0)return;const z=l[l.length-1];z&&z.start+z.deleteCount===S?(z.deleteCount+=y,z.toInsert.push(...L)):l.push({start:S,deleteCount:y,toInsert:L})}let T=0,n=0;for(;;){if(T===H.length){v(T,0,c.slice(n));break}if(n===c.length){v(T,H.length-T,[]);break}const S=H[T],y=c[n],L=E(S,y);L===0?(T+=1,n+=1):L<0?(v(T,1,[]),T+=1):L>0&&(v(T,0,[y]),n+=1)}return l}function r(H,c,E){const l=i(H,c,E),v=[],T=[];for(const n of l)v.push(...H.slice(n.start,n.start+n.deleteCount)),T.push(...n.toInsert);return{removed:v,added:T}}function u(H,c,E){if(E===0)return[];const l=H.slice(0,E).sort(c);return D(H,c,l,E,H.length),l}function g(H,c,E,l,v){return E===0?Promise.resolve([]):new Promise((T,n)=>{(async()=>{const S=H.length,y=H.slice(0,E).sort(c);for(let L=E,z=Math.min(E+l,S);L<S;L=z,z=Math.min(z+l,S)){if(L>E&&await new Promise(Y=>setTimeout(Y)),v&&v.isCancellationRequested)throw new s.CancellationError;D(H,c,y,L,z)}return y})().then(T,n)})}function D(H,c,E,l,v){for(const T=E.length;l<v;l++){const n=H[l];if(c(n,E[T-1])<0){E.pop();const S=(0,N.findFirstIdxMonotonousOrArrLen)(E,y=>c(n,y)<0);E.splice(S,0,n)}}}function a(H){return H.filter(c=>!!c)}function f(H){let c=0;for(let E=0;E<H.length;E++)H[E]&&(H[c]=H[E],c+=1);H.length=c}function o(H,c,E){H.splice(E,0,H.splice(c,1)[0])}function C(H){return!Array.isArray(H)||H.length===0}function F(H){return Array.isArray(H)&&H.length>0}function R(H,c=E=>E){const E=new Set;return H.filter(l=>{const v=c(l);return E.has(v)?!1:(E.add(v),!0)})}function B(H){const c=new Set;return E=>{const l=H(E);return c.has(l)?!1:(c.add(l),!0)}}function P(H,c){return H.length>0?H[0]:c}function b(H,c){return H.length>0?H[H.length-1]:c}function O(H,c,E=(l,v)=>l===v){let l=0;for(let v=0,T=Math.min(H.length,c.length);v<T&&E(H[v],c[v]);v++)l++;return l}function $(H){return[].concat(...H)}function k(H,c){let E=typeof c=="number"?H:0;typeof c=="number"?E=H:(E=0,c=H);const l=[];if(E<=c)for(let v=E;v<c;v++)l.push(v);else for(let v=E;v>c;v--)l.push(v);return l}function M(H,c,E){return H.reduce((l,v)=>(l[c(v)]=E?E(v):v,l),Object.create(null))}function I(H,c){return H.push(c),()=>q(H,c)}function q(H,c){const E=H.indexOf(c);if(E>-1)return H.splice(E,1),c}function X(H,c,E){const l=H.slice(0,c),v=H.slice(c);return l.concat(E,v)}function ce(H,c){let E;if(typeof c=="number"){let l=c;E=()=>{const v=Math.sin(l++)*179426549;return v-Math.floor(v)}}else E=Math.random;for(let l=H.length-1;l>0;l-=1){const v=Math.floor(E()*(l+1)),T=H[l];H[l]=H[v],H[v]=T}}function re(H,c){const E=H.indexOf(c);E>-1&&(H.splice(E,1),H.unshift(c))}function te(H,c){const E=H.indexOf(c);E>-1&&(H.splice(E,1),H.push(c))}function be(H,c){for(const E of c)H.push(E)}function Ee(H,c){return Array.isArray(H)?H.map(c):c(H)}function Ie(H){return Array.isArray(H)?H:[H]}function Be(H){return H[Math.floor(Math.random()*H.length)]}function ue(H,c,E){const l=le(H,c),v=H.length,T=E.length;H.length=v+T;for(let n=v-1;n>=l;n--)H[n+T]=H[n];for(let n=0;n<T;n++)H[n+l]=E[n]}function J(H,c,E,l){const v=le(H,c);let T=H.splice(v,E);return T===void 0&&(T=[]),ue(H,v,l),T}function le(H,c){return c<0?Math.max(c+H.length,0):Math.min(c,H.length)}var ae;(function(H){function c(T){return T<0}H.isLessThan=c;function E(T){return T<=0}H.isLessThanOrEqual=E;function l(T){return T>0}H.isGreaterThan=l;function v(T){return T===0}H.isNeitherLessOrGreaterThan=v,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(ae||(t.CompareResult=ae={}));function Z(H,c){return(E,l)=>c(H(E),H(l))}function G(...H){return(c,E)=>{for(const l of H){const v=l(c,E);if(!ae.isNeitherLessOrGreaterThan(v))return v}return ae.neitherLessOrGreaterThan}}const ne=(H,c)=>H-c;t.numberComparator=ne;const de=(H,c)=>(0,t.numberComparator)(H?1:0,c?1:0);t.booleanComparator=de;function we(H){return(c,E)=>-H(c,E)}class Fe{constructor(c){this.items=c,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(c){let E=this.firstIdx;for(;E<this.items.length&&c(this.items[E]);)E++;const l=E===this.firstIdx?null:this.items.slice(this.firstIdx,E);return this.firstIdx=E,l}takeFromEndWhile(c){let E=this.lastIdx;for(;E>=0&&c(this.items[E]);)E--;const l=E===this.lastIdx?null:this.items.slice(E+1,this.lastIdx+1);return this.lastIdx=E,l}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const c=this.items[this.firstIdx];return this.firstIdx++,c}removeLast(){const c=this.items[this.lastIdx];return this.lastIdx--,c}takeCount(c){const E=this.items.slice(this.firstIdx,this.firstIdx+c);return this.firstIdx+=c,E}}t.ArrayQueue=Fe;class _e{static{this.empty=new _e(c=>{})}constructor(c){this.iterate=c}forEach(c){this.iterate(E=>(c(E),!0))}toArray(){const c=[];return this.iterate(E=>(c.push(E),!0)),c}filter(c){return new _e(E=>this.iterate(l=>c(l)?E(l):!0))}map(c){return new _e(E=>this.iterate(l=>E(c(l))))}some(c){let E=!1;return this.iterate(l=>(E=c(l),!E)),E}findFirst(c){let E;return this.iterate(l=>c(l)?(E=l,!1):!0),E}findLast(c){let E;return this.iterate(l=>(c(l)&&(E=l),!0)),E}findLastMaxBy(c){let E,l=!0;return this.iterate(v=>((l||ae.isGreaterThan(c(v,E)))&&(l=!1,E=v),!0)),E}}t.CallbackIterable=_e;class Pe{constructor(c){this._indexMap=c}static createSortPermutation(c,E){const l=Array.from(c.keys()).sort((v,T)=>E(c[v],c[T]));return new Pe(l)}apply(c){return c.map((E,l)=>c[this._indexMap[l]])}inverse(){const c=this._indexMap.slice();for(let E=0;E<this._indexMap.length;E++)c[this._indexMap[E]]=E;return new Pe(c)}}t.Permutation=Pe}),define(ge[37],pe([1,0,6]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=N,t.assertNever=x,t.assert=V,t.softAssert=_,t.assertFn=A,t.checkAdjacentItems=m;function N(p,w){if(!p)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}function x(p,w="Unreachable"){throw new Error(w)}function V(p){if(!p)throw new s.BugIndicatingError("Assertion Failed")}function _(p){p||(0,s.onUnexpectedError)(new s.BugIndicatingError("Soft Assertion Failed"))}function A(p){if(!p()){debugger;p(),(0,s.onUnexpectedError)(new s.BugIndicatingError("Assertion Failed"))}}function m(p,w){let W=0;for(;W<p.length-1;){const h=p[W],d=p[W+1];if(!w(h,d))return!1;W++}return!0}}),define(ge[53],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSingleCallFunction=s;function s(N,x){const V=this;let _=!1,A;return function(){if(_)return A;if(_=!0,x)try{A=N.apply(V,arguments)}finally{x()}else A=N.apply(V,arguments);return A}}}),define(ge[86],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class s{constructor(x){this._prefix=x,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=s,t.defaultGenerator=new s("id#")}),define(ge[32],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var s;(function(N){function x(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}N.is=x;const V=Object.freeze([]);function _(){return V}N.empty=_;function*A(o){yield o}N.single=A;function m(o){return x(o)?o:A(o)}N.wrap=m;function p(o){return o||V}N.from=p;function*w(o){for(let C=o.length-1;C>=0;C--)yield o[C]}N.reverse=w;function W(o){return!o||o[Symbol.iterator]().next().done===!0}N.isEmpty=W;function h(o){return o[Symbol.iterator]().next().value}N.first=h;function d(o,C){for(const F of o)if(C(F))return!0;return!1}N.some=d;function e(o,C){for(const F of o)if(C(F))return F}N.find=e;function*i(o,C){for(const F of o)C(F)&&(yield F)}N.filter=i;function*r(o,C){let F=0;for(const R of o)yield C(R,F++)}N.map=r;function*u(...o){for(const C of o)yield*C}N.concat=u;function g(o,C,F){let R=F;for(const B of o)R=C(R,B);return R}N.reduce=g;function*D(o,C,F=o.length){for(C<0&&(C+=o.length),F<0?F+=o.length:F>o.length&&(F=o.length);C<F;C++)yield o[C]}N.slice=D;function a(o,C=Number.POSITIVE_INFINITY){const F=[];if(C===0)return[F,o];const R=o[Symbol.iterator]();for(let B=0;B<C;B++){const P=R.next();if(P.done)return[F,N.empty()];F.push(P.value)}return[F,{[Symbol.iterator](){return R}}]}N.consume=a;async function f(o){const C=[];for await(const F of o)C.push(F);return Promise.resolve(C)}N.asyncToArray=f})(s||(t.Iterable=s={}))}),define(ge[54],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0,t.KeyChord=d;var s;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(s||(t.KeyCode=s={}));var N;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(N||(t.ScanCode=N={}));class x{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(i,r){this._keyCodeToStr[i]=r,this._strToKeyCode[r.toLowerCase()]=i}keyCodeToStr(i){return this._keyCodeToStr[i]}strToKeyCode(i){return this._strToKeyCode[i.toLowerCase()]||0}}const V=new x,_=new x,A=new x;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const m=[],p=Object.create(null),w=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>w[e]||0,toEnum:e=>p[e]||0,toString:e=>m[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",i=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],r=[],u=[];for(const g of i){const[D,a,f,o,C,F,R,B,P]=g;if(u[a]||(u[a]=!0,m[a]=f,p[f]=a,w[f.toLowerCase()]=a,D&&(t.IMMUTABLE_CODE_TO_KEY_CODE[a]=o,o!==0&&o!==3&&o!==5&&o!==4&&o!==6&&o!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[o]=a))),!r[o]){if(r[o]=!0,!C)throw new Error(`String representation missing for key code ${o} around scan code ${f}`);V.define(o,C),_.define(o,B||C),A.define(o,P||B||C)}F&&(t.EVENT_KEY_CODE_MAP[F]=o),R&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[R]=o)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var W;(function(e){function i(f){return V.keyCodeToStr(f)}e.toString=i;function r(f){return V.strToKeyCode(f)}e.fromString=r;function u(f){return _.keyCodeToStr(f)}e.toUserSettingsUS=u;function g(f){return A.keyCodeToStr(f)}e.toUserSettingsGeneral=g;function D(f){return _.strToKeyCode(f)||A.strToKeyCode(f)}e.fromUserSettings=D;function a(f){if(f>=98&&f<=113)return null;switch(f){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return V.keyCodeToStr(f)}e.toElectronAccelerator=a})(W||(t.KeyCodeUtils=W={}));var h;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(h||(t.KeyMod=h={}));function d(e,i){const r=(i&65535)<<16>>>0;return(e|r)>>>0}}),define(ge[87],pe([1,0,6]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedChord=t.Keybinding=t.ScanCodeChord=t.KeyCodeChord=void 0,t.decodeKeybinding=x,t.createSimpleKeybinding=V;var N;(function(W){W[W.CtrlCmd=2048]="CtrlCmd",W[W.Shift=1024]="Shift",W[W.Alt=512]="Alt",W[W.WinCtrl=256]="WinCtrl",W[W.KeyCode=255]="KeyCode"})(N||(N={}));function x(W,h){if(typeof W=="number"){if(W===0)return null;const d=(W&65535)>>>0,e=(W&4294901760)>>>16;return e!==0?new m([V(d,h),V(e,h)]):new m([V(d,h)])}else{const d=[];for(let e=0;e<W.length;e++)d.push(V(W[e],h));return new m(d)}}function V(W,h){const d=!!(W&2048),e=!!(W&256),i=h===2?e:d,r=!!(W&1024),u=!!(W&512),g=h===2?d:e,D=W&255;return new _(i,r,u,g,D)}class _{constructor(h,d,e,i,r){this.ctrlKey=h,this.shiftKey=d,this.altKey=e,this.metaKey=i,this.keyCode=r}equals(h){return h instanceof _&&this.ctrlKey===h.ctrlKey&&this.shiftKey===h.shiftKey&&this.altKey===h.altKey&&this.metaKey===h.metaKey&&this.keyCode===h.keyCode}getHashCode(){const h=this.ctrlKey?"1":"0",d=this.shiftKey?"1":"0",e=this.altKey?"1":"0",i=this.metaKey?"1":"0";return`K${h}${d}${e}${i}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.KeyCodeChord=_;class A{constructor(h,d,e,i,r){this.ctrlKey=h,this.shiftKey=d,this.altKey=e,this.metaKey=i,this.scanCode=r}equals(h){return h instanceof A&&this.ctrlKey===h.ctrlKey&&this.shiftKey===h.shiftKey&&this.altKey===h.altKey&&this.metaKey===h.metaKey&&this.scanCode===h.scanCode}getHashCode(){const h=this.ctrlKey?"1":"0",d=this.shiftKey?"1":"0",e=this.altKey?"1":"0",i=this.metaKey?"1":"0";return`S${h}${d}${e}${i}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeChord=A;class m{constructor(h){if(h.length===0)throw(0,s.illegalArgument)("chords");this.chords=h}getHashCode(){let h="";for(let d=0,e=this.chords.length;d<e;d++)d!==0&&(h+=";"),h+=this.chords[d].getHashCode();return h}equals(h){if(h===null||this.chords.length!==h.chords.length)return!1;for(let d=0;d<this.chords.length;d++)if(!this.chords[d].equals(h.chords[d]))return!1;return!0}}t.Keybinding=m;class p{constructor(h,d,e,i,r,u){this.ctrlKey=h,this.shiftKey=d,this.altKey=e,this.metaKey=i,this.keyLabel=r,this.keyAriaLabel=u}}t.ResolvedChord=p;class w{}t.ResolvedKeybinding=w}),define(ge[23],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class s{constructor(x){this.executor=x,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(x){this._error=x}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=s}),define(ge[14],pe([1,0,23]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setHoverDelegateFactory=A,t.getDefaultHoverDelegate=m,t.createInstantHoverDelegate=p;let x=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const V=new s.Lazy(()=>x("mouse",!1)),_=new s.Lazy(()=>x("element",!1));function A(w){x=w}function m(w){return w==="element"?_.value:V.value}function p(){return x("element",!0)}}),define(ge[55],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class s{static{this.Undefined=new s(void 0)}constructor(V){this.element=V,this.next=s.Undefined,this.prev=s.Undefined}}class N{constructor(){this._first=s.Undefined,this._last=s.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===s.Undefined}clear(){let V=this._first;for(;V!==s.Undefined;){const _=V.next;V.prev=s.Undefined,V.next=s.Undefined,V=_}this._first=s.Undefined,this._last=s.Undefined,this._size=0}unshift(V){return this._insert(V,!1)}push(V){return this._insert(V,!0)}_insert(V,_){const A=new s(V);if(this._first===s.Undefined)this._first=A,this._last=A;else if(_){const p=this._last;this._last=A,A.prev=p,p.next=A}else{const p=this._first;this._first=A,A.next=p,p.prev=A}this._size+=1;let m=!1;return()=>{m||(m=!0,this._remove(A))}}shift(){if(this._first!==s.Undefined){const V=this._first.element;return this._remove(this._first),V}}pop(){if(this._last!==s.Undefined){const V=this._last.element;return this._remove(this._last),V}}_remove(V){if(V.prev!==s.Undefined&&V.next!==s.Undefined){const _=V.prev;_.next=V.next,V.next.prev=_}else V.prev===s.Undefined&&V.next===s.Undefined?(this._first=s.Undefined,this._last=s.Undefined):V.next===s.Undefined?(this._last=this._last.prev,this._last.next=s.Undefined):V.prev===s.Undefined&&(this._first=this._first.next,this._first.prev=s.Undefined);this._size-=1}*[Symbol.iterator](){let V=this._first;for(;V!==s.Undefined;)yield V.element,V=V.next}}t.LinkedList=N}),define(ge[38],pe([1,0]),function(ie,t){"use strict";var s,N,x;Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.BidirectionalMap=t.CounterSet=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=void 0,t.getOrSet=V,t.mapToString=_,t.setToString=A,t.mapsStrictEqualIgnoreOrder=g;function V(D,a,f){let o=D.get(a);return o===void 0&&(o=f,D.set(a,o)),o}function _(D){const a=[];return D.forEach((f,o)=>{a.push(`${o} => ${f}`)}),`Map(${D.size}) {${a.join(", ")}}`}function A(D){const a=[];return D.forEach(f=>{a.push(f)}),`Set(${D.size}) {${a.join(", ")}}`}class m{constructor(a,f){this.uri=a,this.value=f}}function p(D){return Array.isArray(D)}class w{static{this.defaultToKey=a=>a.toString()}constructor(a,f){if(this[s]="ResourceMap",a instanceof w)this.map=new Map(a.map),this.toKey=f??w.defaultToKey;else if(p(a)){this.map=new Map,this.toKey=f??w.defaultToKey;for(const[o,C]of a)this.set(o,C)}else this.map=new Map,this.toKey=a??w.defaultToKey}set(a,f){return this.map.set(this.toKey(a),new m(a,f)),this}get(a){return this.map.get(this.toKey(a))?.value}has(a){return this.map.has(this.toKey(a))}get size(){return this.map.size}clear(){this.map.clear()}delete(a){return this.map.delete(this.toKey(a))}forEach(a,f){typeof f<"u"&&(a=a.bind(f));for(const[o,C]of this.map)a(C.value,C.uri,this)}*values(){for(const a of this.map.values())yield a.value}*keys(){for(const a of this.map.values())yield a.uri}*entries(){for(const a of this.map.values())yield[a.uri,a.value]}*[(s=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.map)yield[a.uri,a.value]}}t.ResourceMap=w;class W{constructor(a,f){this[N]="ResourceSet",!a||typeof a=="function"?this._map=new w(a):(this._map=new w(f),a.forEach(this.add,this))}get size(){return this._map.size}add(a){return this._map.set(a,a),this}clear(){this._map.clear()}delete(a){return this._map.delete(a)}forEach(a,f){this._map.forEach((o,C)=>a.call(f,C,C,this))}has(a){return this._map.has(a)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=W;var h;(function(D){D[D.None=0]="None",D[D.AsOld=1]="AsOld",D[D.AsNew=2]="AsNew"})(h||(t.Touch=h={}));class d{constructor(){this[x]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(a){return this._map.has(a)}get(a,f=0){const o=this._map.get(a);if(o)return f!==0&&this.touch(o,f),o.value}set(a,f,o=0){let C=this._map.get(a);if(C)C.value=f,o!==0&&this.touch(C,o);else{switch(C={key:a,value:f,next:void 0,previous:void 0},o){case 0:this.addItemLast(C);break;case 1:this.addItemFirst(C);break;case 2:this.addItemLast(C);break;default:this.addItemLast(C);break}this._map.set(a,C),this._size++}return this}delete(a){return!!this.remove(a)}remove(a){const f=this._map.get(a);if(f)return this._map.delete(a),this.removeItem(f),this._size--,f.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const a=this._head;return this._map.delete(a.key),this.removeItem(a),this._size--,a.value}forEach(a,f){const o=this._state;let C=this._head;for(;C;){if(f?a.bind(f)(C.value,C.key,this):a(C.value,C.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");C=C.next}}keys(){const a=this,f=this._state;let o=this._head;const C={[Symbol.iterator](){return C},next(){if(a._state!==f)throw new Error("LinkedMap got modified during iteration.");if(o){const F={value:o.key,done:!1};return o=o.next,F}else return{value:void 0,done:!0}}};return C}values(){const a=this,f=this._state;let o=this._head;const C={[Symbol.iterator](){return C},next(){if(a._state!==f)throw new Error("LinkedMap got modified during iteration.");if(o){const F={value:o.value,done:!1};return o=o.next,F}else return{value:void 0,done:!0}}};return C}entries(){const a=this,f=this._state;let o=this._head;const C={[Symbol.iterator](){return C},next(){if(a._state!==f)throw new Error("LinkedMap got modified during iteration.");if(o){const F={value:[o.key,o.value],done:!1};return o=o.next,F}else return{value:void 0,done:!0}}};return C}[(x=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(a){if(a>=this.size)return;if(a===0){this.clear();return}let f=this._head,o=this.size;for(;f&&o>a;)this._map.delete(f.key),f=f.next,o--;this._head=f,this._size=o,f&&(f.previous=void 0),this._state++}addItemFirst(a){if(!this._head&&!this._tail)this._tail=a;else if(this._head)a.next=this._head,this._head.previous=a;else throw new Error("Invalid list");this._head=a,this._state++}addItemLast(a){if(!this._head&&!this._tail)this._head=a;else if(this._tail)a.previous=this._tail,this._tail.next=a;else throw new Error("Invalid list");this._tail=a,this._state++}removeItem(a){if(a===this._head&&a===this._tail)this._head=void 0,this._tail=void 0;else if(a===this._head){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this._head=a.next}else if(a===this._tail){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this._tail=a.previous}else{const f=a.next,o=a.previous;if(!f||!o)throw new Error("Invalid list");f.previous=o,o.next=f}a.next=void 0,a.previous=void 0,this._state++}touch(a,f){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(a===this._head)return;const o=a.next,C=a.previous;a===this._tail?(C.next=void 0,this._tail=C):(o.previous=C,C.next=o),a.previous=void 0,a.next=this._head,this._head.previous=a,this._head=a,this._state++}else if(f===2){if(a===this._tail)return;const o=a.next,C=a.previous;a===this._head?(o.previous=void 0,this._head=o):(o.previous=C,C.next=o),a.next=void 0,a.previous=this._tail,this._tail.next=a,this._tail=a,this._state++}}}toJSON(){const a=[];return this.forEach((f,o)=>{a.push([o,f])}),a}fromJSON(a){this.clear();for(const[f,o]of a)this.set(f,o)}}t.LinkedMap=d;class e extends d{constructor(a,f=1){super(),this._limit=a,this._ratio=Math.min(Math.max(0,f),1)}get limit(){return this._limit}set limit(a){this._limit=a,this.checkTrim()}get ratio(){return this._ratio}set ratio(a){this._ratio=Math.min(Math.max(0,a),1),this.checkTrim()}get(a,f=2){return super.get(a,f)}peek(a){return super.get(a,0)}set(a,f){return super.set(a,f,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=e;class i{constructor(){this.map=new Map}add(a){return this.map.set(a,(this.map.get(a)||0)+1),this}delete(a){let f=this.map.get(a)||0;return f===0?!1:(f--,f===0?this.map.delete(a):this.map.set(a,f),!0)}has(a){return this.map.has(a)}}t.CounterSet=i;class r{constructor(a){if(this._m1=new Map,this._m2=new Map,a)for(const[f,o]of a)this.set(f,o)}clear(){this._m1.clear(),this._m2.clear()}set(a,f){this._m1.set(a,f),this._m2.set(f,a)}get(a){return this._m1.get(a)}getKey(a){return this._m2.get(a)}delete(a){const f=this._m1.get(a);return f===void 0?!1:(this._m1.delete(a),this._m2.delete(f),!0)}forEach(a,f){this._m1.forEach((o,C)=>{a.call(f,o,C,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}t.BidirectionalMap=r;class u{constructor(){this.map=new Map}add(a,f){let o=this.map.get(a);o||(o=new Set,this.map.set(a,o)),o.add(f)}delete(a,f){const o=this.map.get(a);o&&(o.delete(f),o.size===0&&this.map.delete(a))}forEach(a,f){const o=this.map.get(a);o&&o.forEach(f)}get(a){const f=this.map.get(a);return f||new Set}}t.SetMap=u;function g(D,a){if(D===a)return!0;if(D.size!==a.size)return!1;for(const[f,o]of D)if(!a.has(f)||a.get(f)!==o)return!1;for(const[f]of a)if(!D.has(f))return!1;return!0}}),define(ge[2],pe([1,0,12,83,38,53,32]),function(ie,t,s,N,x,V,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MandatoryMutableDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.DisposableTracker=void 0,t.setDisposableTracker=w,t.trackDisposable=W,t.markAsDisposed=h,t.markAsSingleton=i,t.isDisposable=r,t.dispose=u,t.disposeIfDisposable=g,t.combinedDisposable=D,t.toDisposable=a,t.disposeOnReturn=$;const A=!1;let m=null;class p{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(I){let q=this.livingDisposables.get(I);return q||(q={parent:null,source:null,isSingleton:!1,value:I,idx:p.idx++},this.livingDisposables.set(I,q)),q}trackDisposable(I){const q=this.getDisposableData(I);q.source||(q.source=new Error().stack)}setParent(I,q){const X=this.getDisposableData(I);X.parent=q}markAsDisposed(I){this.livingDisposables.delete(I)}markAsSingleton(I){this.getDisposableData(I).isSingleton=!0}getRootParent(I,q){const X=q.get(I);if(X)return X;const ce=I.parent?this.getRootParent(this.getDisposableData(I.parent),q):I;return q.set(I,ce),ce}getTrackedDisposables(){const I=new Map;return[...this.livingDisposables.entries()].filter(([,X])=>X.source!==null&&!this.getRootParent(X,I).isSingleton).flatMap(([X])=>X)}computeLeakingDisposables(I=10,q){let X;if(q)X=q;else{const Ee=new Map,Ie=[...this.livingDisposables.values()].filter(ue=>ue.source!==null&&!this.getRootParent(ue,Ee).isSingleton);if(Ie.length===0)return;const Be=new Set(Ie.map(ue=>ue.value));if(X=Ie.filter(ue=>!(ue.parent&&Be.has(ue.parent))),X.length===0)throw new Error("There are cyclic diposable chains!")}if(!X)return;function ce(Ee){function Ie(ue,J){for(;ue.length>0&&J.some(le=>typeof le=="string"?le===ue[0]:ue[0].match(le));)ue.shift()}const Be=Ee.source.split(`
`).map(ue=>ue.trim().replace("at ","")).filter(ue=>ue!=="");return Ie(Be,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Be.reverse()}const re=new x.SetMap;for(const Ee of X){const Ie=ce(Ee);for(let Be=0;Be<=Ie.length;Be++)re.add(Ie.slice(0,Be).join(`
`),Ee)}X.sort((0,s.compareBy)(Ee=>Ee.idx,s.numberComparator));let te="",be=0;for(const Ee of X.slice(0,I)){be++;const Ie=ce(Ee),Be=[];for(let ue=0;ue<Ie.length;ue++){let J=Ie[ue];J=`(shared with ${re.get(Ie.slice(0,ue+1).join(`
`)).size}/${X.length} leaks) at ${J}`;const ae=re.get(Ie.slice(0,ue).join(`
`)),Z=(0,N.groupBy)([...ae].map(G=>ce(G)[ue]),G=>G);delete Z[Ie[ue]];for(const[G,ne]of Object.entries(Z))Be.unshift(`    - stacktraces of ${ne.length} other leaks continue with ${G}`);Be.unshift(J)}te+=`


==================== Leaking disposable ${be}/${X.length}: ${Ee.value.constructor.name} ====================
${Be.join(`
`)}
============================================================

`}return X.length>I&&(te+=`


... and ${X.length-I} more leaking disposables

`),{leaks:X,details:te}}}t.DisposableTracker=p;function w(M){m=M}if(A){const M="__is_disposable_tracked__";w(new class{trackDisposable(I){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[M]||console.log(q)},3e3)}setParent(I,q){if(I&&I!==o.None)try{I[M]=!0}catch{}}markAsDisposed(I){if(I&&I!==o.None)try{I[M]=!0}catch{}}markAsSingleton(I){}})}function W(M){return m?.trackDisposable(M),M}function h(M){m?.markAsDisposed(M)}function d(M,I){m?.setParent(M,I)}function e(M,I){if(m)for(const q of M)m.setParent(q,I)}function i(M){return m?.markAsSingleton(M),M}function r(M){return typeof M.dispose=="function"&&M.dispose.length===0}function u(M){if(_.Iterable.is(M)){const I=[];for(const q of M)if(q)try{q.dispose()}catch(X){I.push(X)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(M)?[]:M}else if(M)return M.dispose(),M}function g(M){for(const I of M)r(I)&&I.dispose();return[]}function D(...M){const I=a(()=>u(M));return e(M,I),I}function a(M){const I=W({dispose:(0,V.createSingleCallFunction)(()=>{h(I),M()})});return I}class f{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,W(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{u(this._toDispose)}finally{this._toDispose.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return d(I,this),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(I),I.dispose()}}deleteAndLeak(I){I&&this._toDispose.has(I)&&(this._toDispose.delete(I),d(I,null))}}t.DisposableStore=f;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new f,W(this),d(this._store,this)}dispose(){h(this),this._store.dispose()}_register(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(I)}}t.Disposable=o;class C{constructor(){this._isDisposed=!1,W(this)}get value(){return this._isDisposed?void 0:this._value}set value(I){this._isDisposed||I===this._value||(this._value?.dispose(),I&&d(I,this),this._value=I)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const I=this._value;return this._value=void 0,I&&d(I,null),I}}t.MutableDisposable=C;class F{constructor(I){this._disposable=new C,this._isDisposed=!1,this._disposable.value=I}get value(){return this._disposable.value}set value(I){this._isDisposed||I===this._disposable.value||(this._disposable.value=I)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}t.MandatoryMutableDisposable=F;class R{constructor(I){this._disposable=I,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=R;class B{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,W(this)}set(I){let q=I;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,h(this))},this}}t.SafeDisposable=B;class P{constructor(){this.references=new Map}acquire(I,...q){let X=this.references.get(I);X||(X={counter:0,object:this.createReferencedObject(I,...q)},this.references.set(I,X));const{object:ce}=X,re=(0,V.createSingleCallFunction)(()=>{--X.counter===0&&(this.destroyReferencedObject(I,X.object),this.references.delete(I))});return X.counter++,{object:ce,dispose:re}}}t.ReferenceCollection=P;class b{constructor(I){this.referenceCollection=I}async acquire(I,...q){const X=this.referenceCollection.acquire(I,...q);try{return{object:await X.object,dispose:()=>X.dispose()}}catch(ce){throw X.dispose(),ce}}}t.AsyncReferenceCollection=b;class O{constructor(I){this.object=I}dispose(){}}t.ImmortalReference=O;function $(M){const I=new f;try{M(I)}finally{I.dispose()}}class k{constructor(){this._store=new Map,this._isDisposed=!1,W(this)}dispose(){h(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{u(this._store.values())}finally{this._store.clear()}}has(I){return this._store.has(I)}get size(){return this._store.size}get(I){return this._store.get(I)}set(I,q,X=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),X||this._store.get(I)?.dispose(),this._store.set(I,q)}deleteAndDispose(I){this._store.get(I)?.dispose(),this._store.delete(I)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=k}),function(ie,t){typeof define=="function"&&define.amd?define(ge[88],pe([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ie=typeof globalThis<"u"?globalThis:ie||self,t(ie.marked={}))}(this,function(ie){"use strict";function t(H,c){for(var E=0;E<c.length;E++){var l=c[E];l.enumerable=l.enumerable||!1,l.configurable=!0,"value"in l&&(l.writable=!0),Object.defineProperty(H,l.key,l)}}function s(H,c,E){return c&&t(H.prototype,c),E&&t(H,E),Object.defineProperty(H,"prototype",{writable:!1}),H}function N(H,c){if(H){if(typeof H=="string")return x(H,c);var E=Object.prototype.toString.call(H).slice(8,-1);if(E==="Object"&&H.constructor&&(E=H.constructor.name),E==="Map"||E==="Set")return Array.from(H);if(E==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(E))return x(H,c)}}function x(H,c){(c==null||c>H.length)&&(c=H.length);for(var E=0,l=new Array(c);E<c;E++)l[E]=H[E];return l}function V(H,c){var E=typeof Symbol<"u"&&H[Symbol.iterator]||H["@@iterator"];if(E)return(E=E.call(H)).next.bind(E);if(Array.isArray(H)||(E=N(H))||c&&H&&typeof H.length=="number"){E&&(H=E);var l=0;return function(){return l>=H.length?{done:!0}:{done:!1,value:H[l++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function _(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=_();function A(H){ie.defaults=H}var m=/[&<>"']/,p=/[&<>"']/g,w=/[<>"']|&(?!#?\w+;)/,W=/[<>"']|&(?!#?\w+;)/g,h={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(c){return h[c]};function e(H,c){if(c){if(m.test(H))return H.replace(p,d)}else if(w.test(H))return H.replace(W,d);return H}var i=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(H){return H.replace(i,function(c,E){return E=E.toLowerCase(),E==="colon"?":":E.charAt(0)==="#"?E.charAt(1)==="x"?String.fromCharCode(parseInt(E.substring(2),16)):String.fromCharCode(+E.substring(1)):""})}var u=/(^|[^\[])\^/g;function g(H,c){H=typeof H=="string"?H:H.source,c=c||"";var E={replace:function(v,T){return T=T.source||T,T=T.replace(u,"$1"),H=H.replace(v,T),E},getRegex:function(){return new RegExp(H,c)}};return E}var D=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(H,c,E){if(H){var l;try{l=decodeURIComponent(r(E)).replace(D,"").toLowerCase()}catch{return null}if(l.indexOf("javascript:")===0||l.indexOf("vbscript:")===0||l.indexOf("data:")===0)return null}c&&!a.test(E)&&(E=B(c,E));try{E=encodeURI(E).replace(/%25/g,"%")}catch{return null}return E}var o={},C=/^[^:]+:\/*[^/]*$/,F=/^([^:]+:)[\s\S]*$/,R=/^([^:]+:\/*[^/]*)[\s\S]*$/;function B(H,c){o[" "+H]||(C.test(H)?o[" "+H]=H+"/":o[" "+H]=$(H,"/",!0)),H=o[" "+H];var E=H.indexOf(":")===-1;return c.substring(0,2)==="//"?E?c:H.replace(F,"$1")+c:c.charAt(0)==="/"?E?c:H.replace(R,"$1")+c:H+c}var P={exec:function(){}};function b(H){for(var c=1,E,l;c<arguments.length;c++){E=arguments[c];for(l in E)Object.prototype.hasOwnProperty.call(E,l)&&(H[l]=E[l])}return H}function O(H,c){var E=H.replace(/\|/g,function(T,n,S){for(var y=!1,L=n;--L>=0&&S[L]==="\\";)y=!y;return y?"|":" |"}),l=E.split(/ \|/),v=0;if(l[0].trim()||l.shift(),l.length>0&&!l[l.length-1].trim()&&l.pop(),l.length>c)l.splice(c);else for(;l.length<c;)l.push("");for(;v<l.length;v++)l[v]=l[v].trim().replace(/\\\|/g,"|");return l}function $(H,c,E){var l=H.length;if(l===0)return"";for(var v=0;v<l;){var T=H.charAt(l-v-1);if(T===c&&!E)v++;else if(T!==c&&E)v++;else break}return H.slice(0,l-v)}function k(H,c){if(H.indexOf(c[1])===-1)return-1;for(var E=H.length,l=0,v=0;v<E;v++)if(H[v]==="\\")v++;else if(H[v]===c[0])l++;else if(H[v]===c[1]&&(l--,l<0))return v;return-1}function M(H){H&&H.sanitize&&!H.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(H,c){if(c<1)return"";for(var E="";c>1;)c&1&&(E+=H),c>>=1,H+=H;return E+H}function q(H,c,E,l){var v=c.href,T=c.title?e(c.title):null,n=H[1].replace(/\\([\[\]])/g,"$1");if(H[0].charAt(0)!=="!"){l.state.inLink=!0;var S={type:"link",raw:E,href:v,title:T,text:n,tokens:l.inlineTokens(n)};return l.state.inLink=!1,S}return{type:"image",raw:E,href:v,title:T,text:e(n)}}function X(H,c){var E=H.match(/^(\s+)(?:```)/);if(E===null)return c;var l=E[1];return c.split(`
`).map(function(v){var T=v.match(/^\s+/);if(T===null)return v;var n=T[0];return n.length>=l.length?v.slice(l.length):v}).join(`
`)}var ce=function(){function H(E){this.options=E||ie.defaults}var c=H.prototype;return c.space=function(l){var v=this.rules.block.newline.exec(l);if(v&&v[0].length>0)return{type:"space",raw:v[0]}},c.code=function(l){var v=this.rules.block.code.exec(l);if(v){var T=v[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:v[0],codeBlockStyle:"indented",text:this.options.pedantic?T:$(T,`
`)}}},c.fences=function(l){var v=this.rules.block.fences.exec(l);if(v){var T=v[0],n=X(T,v[3]||"");return{type:"code",raw:T,lang:v[2]?v[2].trim():v[2],text:n}}},c.heading=function(l){var v=this.rules.block.heading.exec(l);if(v){var T=v[2].trim();if(/#$/.test(T)){var n=$(T,"#");(this.options.pedantic||!n||/ $/.test(n))&&(T=n.trim())}return{type:"heading",raw:v[0],depth:v[1].length,text:T,tokens:this.lexer.inline(T)}}},c.hr=function(l){var v=this.rules.block.hr.exec(l);if(v)return{type:"hr",raw:v[0]}},c.blockquote=function(l){var v=this.rules.block.blockquote.exec(l);if(v){var T=v[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:v[0],tokens:this.lexer.blockTokens(T,[]),text:T}}},c.list=function(l){var v=this.rules.block.list.exec(l);if(v){var T,n,S,y,L,z,Y,Q,oe,De,me,ke,Ae=v[1].trim(),Me=Ae.length>1,Se={type:"list",raw:"",ordered:Me,start:Me?+Ae.slice(0,-1):"",loose:!1,items:[]};Ae=Me?"\\d{1,9}\\"+Ae.slice(-1):"\\"+Ae,this.options.pedantic&&(Ae=Me?Ae:"[*+-]");for(var Te=new RegExp("^( {0,3}"+Ae+")((?:[	 ][^\\n]*)?(?:\\n|$))");l&&(ke=!1,!(!(v=Te.exec(l))||this.rules.block.hr.test(l)));){if(T=v[0],l=l.substring(T.length),Q=v[2].split(`
`,1)[0],oe=l.split(`
`,1)[0],this.options.pedantic?(y=2,me=Q.trimLeft()):(y=v[2].search(/[^ ]/),y=y>4?1:y,me=Q.slice(y),y+=v[1].length),z=!1,!Q&&/^ *$/.test(oe)&&(T+=oe+`
`,l=l.substring(oe.length+1),ke=!0),!ke)for(var Ve=new RegExp("^ {0,"+Math.min(3,y-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Qe=new RegExp("^ {0,"+Math.min(3,y-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ue=new RegExp("^ {0,"+Math.min(3,y-1)+"}(?:```|~~~)"),Je=new RegExp("^ {0,"+Math.min(3,y-1)+"}#");l&&(De=l.split(`
`,1)[0],Q=De,this.options.pedantic&&(Q=Q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ue.test(Q)||Je.test(Q)||Ve.test(Q)||Qe.test(l)));){if(Q.search(/[^ ]/)>=y||!Q.trim())me+=`
`+Q.slice(y);else if(!z)me+=`
`+Q;else break;!z&&!Q.trim()&&(z=!0),T+=De+`
`,l=l.substring(De.length+1)}Se.loose||(Y?Se.loose=!0:/\n *\n *$/.test(T)&&(Y=!0)),this.options.gfm&&(n=/^\[[ xX]\] /.exec(me),n&&(S=n[0]!=="[ ] ",me=me.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:T,task:!!n,checked:S,loose:!1,text:me}),Se.raw+=T}Se.items[Se.items.length-1].raw=T.trimRight(),Se.items[Se.items.length-1].text=me.trimRight(),Se.raw=Se.raw.trimRight();var U=Se.items.length;for(L=0;L<U;L++){this.lexer.state.top=!1,Se.items[L].tokens=this.lexer.blockTokens(Se.items[L].text,[]);var se=Se.items[L].tokens.filter(function(ye){return ye.type==="space"}),ve=se.every(function(ye){for(var Le=ye.raw.split(""),He=0,$e=V(Le),et;!(et=$e()).done;){var it=et.value;if(it===`
`&&(He+=1),He>1)return!0}return!1});!Se.loose&&se.length&&ve&&(Se.loose=!0,Se.items[L].loose=!0)}return Se}},c.html=function(l){var v=this.rules.block.html.exec(l);if(v){var T={type:"html",raw:v[0],pre:!this.options.sanitizer&&(v[1]==="pre"||v[1]==="script"||v[1]==="style"),text:v[0]};if(this.options.sanitize){var n=this.options.sanitizer?this.options.sanitizer(v[0]):e(v[0]);T.type="paragraph",T.text=n,T.tokens=this.lexer.inline(n)}return T}},c.def=function(l){var v=this.rules.block.def.exec(l);if(v){v[3]&&(v[3]=v[3].substring(1,v[3].length-1));var T=v[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:T,raw:v[0],href:v[2],title:v[3]}}},c.table=function(l){var v=this.rules.block.table.exec(l);if(v){var T={type:"table",header:O(v[1]).map(function(Y){return{text:Y}}),align:v[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:v[3]&&v[3].trim()?v[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(T.header.length===T.align.length){T.raw=v[0];var n=T.align.length,S,y,L,z;for(S=0;S<n;S++)/^ *-+: *$/.test(T.align[S])?T.align[S]="right":/^ *:-+: *$/.test(T.align[S])?T.align[S]="center":/^ *:-+ *$/.test(T.align[S])?T.align[S]="left":T.align[S]=null;for(n=T.rows.length,S=0;S<n;S++)T.rows[S]=O(T.rows[S],T.header.length).map(function(Y){return{text:Y}});for(n=T.header.length,y=0;y<n;y++)T.header[y].tokens=this.lexer.inline(T.header[y].text);for(n=T.rows.length,y=0;y<n;y++)for(z=T.rows[y],L=0;L<z.length;L++)z[L].tokens=this.lexer.inline(z[L].text);return T}}},c.lheading=function(l){var v=this.rules.block.lheading.exec(l);if(v)return{type:"heading",raw:v[0],depth:v[2].charAt(0)==="="?1:2,text:v[1],tokens:this.lexer.inline(v[1])}},c.paragraph=function(l){var v=this.rules.block.paragraph.exec(l);if(v){var T=v[1].charAt(v[1].length-1)===`
`?v[1].slice(0,-1):v[1];return{type:"paragraph",raw:v[0],text:T,tokens:this.lexer.inline(T)}}},c.text=function(l){var v=this.rules.block.text.exec(l);if(v)return{type:"text",raw:v[0],text:v[0],tokens:this.lexer.inline(v[0])}},c.escape=function(l){var v=this.rules.inline.escape.exec(l);if(v)return{type:"escape",raw:v[0],text:e(v[1])}},c.tag=function(l){var v=this.rules.inline.tag.exec(l);if(v)return!this.lexer.state.inLink&&/^<a /i.test(v[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(v[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(v[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(v[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:v[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(v[0]):e(v[0]):v[0]}},c.link=function(l){var v=this.rules.inline.link.exec(l);if(v){var T=v[2].trim();if(!this.options.pedantic&&/^</.test(T)){if(!/>$/.test(T))return;var n=$(T.slice(0,-1),"\\");if((T.length-n.length)%2===0)return}else{var S=k(v[2],"()");if(S>-1){var y=v[0].indexOf("!")===0?5:4,L=y+v[1].length+S;v[2]=v[2].substring(0,S),v[0]=v[0].substring(0,L).trim(),v[3]=""}}var z=v[2],Y="";if(this.options.pedantic){var Q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(z);Q&&(z=Q[1],Y=Q[3])}else Y=v[3]?v[3].slice(1,-1):"";return z=z.trim(),/^</.test(z)&&(this.options.pedantic&&!/>$/.test(T)?z=z.slice(1):z=z.slice(1,-1)),q(v,{href:z&&z.replace(this.rules.inline._escapes,"$1"),title:Y&&Y.replace(this.rules.inline._escapes,"$1")},v[0],this.lexer)}},c.reflink=function(l,v){var T;if((T=this.rules.inline.reflink.exec(l))||(T=this.rules.inline.nolink.exec(l))){var n=(T[2]||T[1]).replace(/\s+/g," ");if(n=v[n.toLowerCase()],!n||!n.href){var S=T[0].charAt(0);return{type:"text",raw:S,text:S}}return q(T,n,T[0],this.lexer)}},c.emStrong=function(l,v,T){T===void 0&&(T="");var n=this.rules.inline.emStrong.lDelim.exec(l);if(n&&!(n[3]&&T.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var S=n[1]||n[2]||"";if(!S||S&&(T===""||this.rules.inline.punctuation.exec(T))){var y=n[0].length-1,L,z,Y=y,Q=0,oe=n[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(oe.lastIndex=0,v=v.slice(-1*l.length+y);(n=oe.exec(v))!=null;)if(L=n[1]||n[2]||n[3]||n[4]||n[5]||n[6],!!L){if(z=L.length,n[3]||n[4]){Y+=z;continue}else if((n[5]||n[6])&&y%3&&!((y+z)%3)){Q+=z;continue}if(Y-=z,!(Y>0)){if(z=Math.min(z,z+Y+Q),Math.min(y,z)%2){var De=l.slice(1,y+n.index+z);return{type:"em",raw:l.slice(0,y+n.index+z+1),text:De,tokens:this.lexer.inlineTokens(De)}}var me=l.slice(2,y+n.index+z-1);return{type:"strong",raw:l.slice(0,y+n.index+z+1),text:me,tokens:this.lexer.inlineTokens(me)}}}}}},c.codespan=function(l){var v=this.rules.inline.code.exec(l);if(v){var T=v[2].replace(/\n/g," "),n=/[^ ]/.test(T),S=/^ /.test(T)&&/ $/.test(T);return n&&S&&(T=T.substring(1,T.length-1)),T=e(T,!0),{type:"codespan",raw:v[0],text:T}}},c.br=function(l){var v=this.rules.inline.br.exec(l);if(v)return{type:"br",raw:v[0]}},c.del=function(l){var v=this.rules.inline.del.exec(l);if(v)return{type:"del",raw:v[0],text:v[2],tokens:this.lexer.inlineTokens(v[2])}},c.autolink=function(l,v){var T=this.rules.inline.autolink.exec(l);if(T){var n,S;return T[2]==="@"?(n=e(this.options.mangle?v(T[1]):T[1]),S="mailto:"+n):(n=e(T[1]),S=n),{type:"link",raw:T[0],text:n,href:S,tokens:[{type:"text",raw:n,text:n}]}}},c.url=function(l,v){var T;if(T=this.rules.inline.url.exec(l)){var n,S;if(T[2]==="@")n=e(this.options.mangle?v(T[0]):T[0]),S="mailto:"+n;else{var y;do y=T[0],T[0]=this.rules.inline._backpedal.exec(T[0])[0];while(y!==T[0]);n=e(T[0]),T[1]==="www."?S="http://"+n:S=n}return{type:"link",raw:T[0],text:n,href:S,tokens:[{type:"text",raw:n,text:n}]}}},c.inlineText=function(l,v){var T=this.rules.inline.text.exec(l);if(T){var n;return this.lexer.state.inRawBlock?n=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(T[0]):e(T[0]):T[0]:n=e(this.options.smartypants?v(T[0]):T[0]),{type:"text",raw:T[0],text:n}}},H}(),re={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:P,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};re._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,re._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,re.def=g(re.def).replace("label",re._label).replace("title",re._title).getRegex(),re.bullet=/(?:[*+-]|\d{1,9}[.)])/,re.listItemStart=g(/^( *)(bull) */).replace("bull",re.bullet).getRegex(),re.list=g(re.list).replace(/bull/g,re.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+re.def.source+")").getRegex(),re._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",re._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,re.html=g(re.html,"i").replace("comment",re._comment).replace("tag",re._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),re.paragraph=g(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.blockquote=g(re.blockquote).replace("paragraph",re.paragraph).getRegex(),re.normal=b({},re),re.gfm=b({},re.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),re.gfm.table=g(re.gfm.table).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.gfm.paragraph=g(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",re.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.pedantic=b({},re.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",re._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:P,paragraph:g(re.normal._paragraph).replace("hr",re.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",re.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:P,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:P,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=g(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=g(re._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=g(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=g(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=g(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=g(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=g(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=g(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=g(te.reflink).replace("label",te._label).replace("ref",re._label).getRegex(),te.nolink=g(te.nolink).replace("ref",re._label).getRegex(),te.reflinkSearch=g(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=b({},te),te.pedantic=b({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=b({},te.normal,{escape:g(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),te.gfm.url=g(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=b({},te.gfm,{br:g(te.br).replace("{2,}","*").getRegex(),text:g(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function be(H){return H.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ee(H){var c="",E,l,v=H.length;for(E=0;E<v;E++)l=H.charCodeAt(E),Math.random()>.5&&(l="x"+l.toString(16)),c+="&#"+l+";";return c}var Ie=function(){function H(E){this.tokens=[],this.tokens.links=Object.create(null),this.options=E||ie.defaults,this.options.tokenizer=this.options.tokenizer||new ce,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var l={block:re.normal,inline:te.normal};this.options.pedantic?(l.block=re.pedantic,l.inline=te.pedantic):this.options.gfm&&(l.block=re.gfm,this.options.breaks?l.inline=te.breaks:l.inline=te.gfm),this.tokenizer.rules=l}H.lex=function(l,v){var T=new H(v);return T.lex(l)},H.lexInline=function(l,v){var T=new H(v);return T.inlineTokens(l)};var c=H.prototype;return c.lex=function(l){l=l.replace(/\r\n|\r/g,`
`),this.blockTokens(l,this.tokens);for(var v;v=this.inlineQueue.shift();)this.inlineTokens(v.src,v.tokens);return this.tokens},c.blockTokens=function(l,v){var T=this;v===void 0&&(v=[]),this.options.pedantic?l=l.replace(/\t/g,"    ").replace(/^ +$/gm,""):l=l.replace(/^( *)(\t+)/gm,function(Y,Q,oe){return Q+"    ".repeat(oe.length)});for(var n,S,y,L;l;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Y){return(n=Y.call({lexer:T},l,v))?(l=l.substring(n.raw.length),v.push(n),!0):!1}))){if(n=this.tokenizer.space(l)){l=l.substring(n.raw.length),n.raw.length===1&&v.length>0?v[v.length-1].raw+=`
`:v.push(n);continue}if(n=this.tokenizer.code(l)){l=l.substring(n.raw.length),S=v[v.length-1],S&&(S.type==="paragraph"||S.type==="text")?(S.raw+=`
`+n.raw,S.text+=`
`+n.text,this.inlineQueue[this.inlineQueue.length-1].src=S.text):v.push(n);continue}if(n=this.tokenizer.fences(l)){l=l.substring(n.raw.length),v.push(n);continue}if(n=this.tokenizer.heading(l)){l=l.substring(n.raw.length),v.push(n);continue}if(n=this.tokenizer.hr(l)){l=l.substring(n.raw.length),v.push(n);continue}if(n=this.tokenizer.blockquote(l)){l=l.substring(n.raw.length),v.push(n);continue}if(n=this.tokenizer.list(l)){l=l.substring(n.raw.length),v.push(n);continue}if(n=this.tokenizer.html(l)){l=l.substring(n.raw.length),v.push(n);continue}if(n=this.tokenizer.def(l)){l=l.substring(n.raw.length),S=v[v.length-1],S&&(S.type==="paragraph"||S.type==="text")?(S.raw+=`
`+n.raw,S.text+=`
`+n.raw,this.inlineQueue[this.inlineQueue.length-1].src=S.text):this.tokens.links[n.tag]||(this.tokens.links[n.tag]={href:n.href,title:n.title});continue}if(n=this.tokenizer.table(l)){l=l.substring(n.raw.length),v.push(n);continue}if(n=this.tokenizer.lheading(l)){l=l.substring(n.raw.length),v.push(n);continue}if(y=l,this.options.extensions&&this.options.extensions.startBlock&&function(){var Y=1/0,Q=l.slice(1),oe=void 0;T.options.extensions.startBlock.forEach(function(De){oe=De.call({lexer:this},Q),typeof oe=="number"&&oe>=0&&(Y=Math.min(Y,oe))}),Y<1/0&&Y>=0&&(y=l.substring(0,Y+1))}(),this.state.top&&(n=this.tokenizer.paragraph(y))){S=v[v.length-1],L&&S.type==="paragraph"?(S.raw+=`
`+n.raw,S.text+=`
`+n.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=S.text):v.push(n),L=y.length!==l.length,l=l.substring(n.raw.length);continue}if(n=this.tokenizer.text(l)){l=l.substring(n.raw.length),S=v[v.length-1],S&&S.type==="text"?(S.raw+=`
`+n.raw,S.text+=`
`+n.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=S.text):v.push(n);continue}if(l){var z="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(z);break}else throw new Error(z)}}return this.state.top=!0,v},c.inline=function(l,v){return v===void 0&&(v=[]),this.inlineQueue.push({src:l,tokens:v}),v},c.inlineTokens=function(l,v){var T=this;v===void 0&&(v=[]);var n,S,y,L=l,z,Y,Q;if(this.tokens.links){var oe=Object.keys(this.tokens.links);if(oe.length>0)for(;(z=this.tokenizer.rules.inline.reflinkSearch.exec(L))!=null;)oe.includes(z[0].slice(z[0].lastIndexOf("[")+1,-1))&&(L=L.slice(0,z.index)+"["+I("a",z[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(z=this.tokenizer.rules.inline.blockSkip.exec(L))!=null;)L=L.slice(0,z.index)+"["+I("a",z[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(z=this.tokenizer.rules.inline.escapedEmSt.exec(L))!=null;)L=L.slice(0,z.index)+"++"+L.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;l;)if(Y||(Q=""),Y=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(me){return(n=me.call({lexer:T},l,v))?(l=l.substring(n.raw.length),v.push(n),!0):!1}))){if(n=this.tokenizer.escape(l)){l=l.substring(n.raw.length),v.push(n);continue}if(n=this.tokenizer.tag(l)){l=l.substring(n.raw.length),S=v[v.length-1],S&&n.type==="text"&&S.type==="text"?(S.raw+=n.raw,S.text+=n.text):v.push(n);continue}if(n=this.tokenizer.link(l)){l=l.substring(n.raw.length),v.push(n);continue}if(n=this.tokenizer.reflink(l,this.tokens.links)){l=l.substring(n.raw.length),S=v[v.length-1],S&&n.type==="text"&&S.type==="text"?(S.raw+=n.raw,S.text+=n.text):v.push(n);continue}if(n=this.tokenizer.emStrong(l,L,Q)){l=l.substring(n.raw.length),v.push(n);continue}if(n=this.tokenizer.codespan(l)){l=l.substring(n.raw.length),v.push(n);continue}if(n=this.tokenizer.br(l)){l=l.substring(n.raw.length),v.push(n);continue}if(n=this.tokenizer.del(l)){l=l.substring(n.raw.length),v.push(n);continue}if(n=this.tokenizer.autolink(l,Ee)){l=l.substring(n.raw.length),v.push(n);continue}if(!this.state.inLink&&(n=this.tokenizer.url(l,Ee))){l=l.substring(n.raw.length),v.push(n);continue}if(y=l,this.options.extensions&&this.options.extensions.startInline&&function(){var me=1/0,ke=l.slice(1),Ae=void 0;T.options.extensions.startInline.forEach(function(Me){Ae=Me.call({lexer:this},ke),typeof Ae=="number"&&Ae>=0&&(me=Math.min(me,Ae))}),me<1/0&&me>=0&&(y=l.substring(0,me+1))}(),n=this.tokenizer.inlineText(y,be)){l=l.substring(n.raw.length),n.raw.slice(-1)!=="_"&&(Q=n.raw.slice(-1)),Y=!0,S=v[v.length-1],S&&S.type==="text"?(S.raw+=n.raw,S.text+=n.text):v.push(n);continue}if(l){var De="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return v},s(H,null,[{key:"rules",get:function(){return{block:re,inline:te}}}]),H}(),Be=function(){function H(E){this.options=E||ie.defaults}var c=H.prototype;return c.code=function(l,v,T){var n=(v||"").match(/\S*/)[0];if(this.options.highlight){var S=this.options.highlight(l,n);S!=null&&S!==l&&(T=!0,l=S)}return l=l.replace(/\n$/,"")+`
`,n?'<pre><code class="'+this.options.langPrefix+e(n,!0)+'">'+(T?l:e(l,!0))+`</code></pre>
`:"<pre><code>"+(T?l:e(l,!0))+`</code></pre>
`},c.blockquote=function(l){return`<blockquote>
`+l+`</blockquote>
`},c.html=function(l){return l},c.heading=function(l,v,T,n){if(this.options.headerIds){var S=this.options.headerPrefix+n.slug(T);return"<h"+v+' id="'+S+'">'+l+"</h"+v+`>
`}return"<h"+v+">"+l+"</h"+v+`>
`},c.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},c.list=function(l,v,T){var n=v?"ol":"ul",S=v&&T!==1?' start="'+T+'"':"";return"<"+n+S+`>
`+l+"</"+n+`>
`},c.listitem=function(l){return"<li>"+l+`</li>
`},c.checkbox=function(l){return"<input "+(l?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},c.paragraph=function(l){return"<p>"+l+`</p>
`},c.table=function(l,v){return v&&(v="<tbody>"+v+"</tbody>"),`<table>
<thead>
`+l+`</thead>
`+v+`</table>
`},c.tablerow=function(l){return`<tr>
`+l+`</tr>
`},c.tablecell=function(l,v){var T=v.header?"th":"td",n=v.align?"<"+T+' align="'+v.align+'">':"<"+T+">";return n+l+("</"+T+`>
`)},c.strong=function(l){return"<strong>"+l+"</strong>"},c.em=function(l){return"<em>"+l+"</em>"},c.codespan=function(l){return"<code>"+l+"</code>"},c.br=function(){return this.options.xhtml?"<br/>":"<br>"},c.del=function(l){return"<del>"+l+"</del>"},c.link=function(l,v,T){if(l=f(this.options.sanitize,this.options.baseUrl,l),l===null)return T;var n='<a href="'+e(l)+'"';return v&&(n+=' title="'+v+'"'),n+=">"+T+"</a>",n},c.image=function(l,v,T){if(l=f(this.options.sanitize,this.options.baseUrl,l),l===null)return T;var n='<img src="'+l+'" alt="'+T+'"';return v&&(n+=' title="'+v+'"'),n+=this.options.xhtml?"/>":">",n},c.text=function(l){return l},H}(),ue=function(){function H(){}var c=H.prototype;return c.strong=function(l){return l},c.em=function(l){return l},c.codespan=function(l){return l},c.del=function(l){return l},c.html=function(l){return l},c.text=function(l){return l},c.link=function(l,v,T){return""+T},c.image=function(l,v,T){return""+T},c.br=function(){return""},H}(),J=function(){function H(){this.seen={}}var c=H.prototype;return c.serialize=function(l){return l.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},c.getNextSafeSlug=function(l,v){var T=l,n=0;if(this.seen.hasOwnProperty(T)){n=this.seen[l];do n++,T=l+"-"+n;while(this.seen.hasOwnProperty(T))}return v||(this.seen[l]=n,this.seen[T]=0),T},c.slug=function(l,v){v===void 0&&(v={});var T=this.serialize(l);return this.getNextSafeSlug(T,v.dryrun)},H}(),le=function(){function H(E){this.options=E||ie.defaults,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ue,this.slugger=new J}H.parse=function(l,v){var T=new H(v);return T.parse(l)},H.parseInline=function(l,v){var T=new H(v);return T.parseInline(l)};var c=H.prototype;return c.parse=function(l,v){v===void 0&&(v=!0);var T="",n,S,y,L,z,Y,Q,oe,De,me,ke,Ae,Me,Se,Te,Ve,Qe,Ue,Je,U=l.length;for(n=0;n<U;n++){if(me=l[n],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[me.type]&&(Je=this.options.extensions.renderers[me.type].call({parser:this},me),Je!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(me.type))){T+=Je||"";continue}switch(me.type){case"space":continue;case"hr":{T+=this.renderer.hr();continue}case"heading":{T+=this.renderer.heading(this.parseInline(me.tokens),me.depth,r(this.parseInline(me.tokens,this.textRenderer)),this.slugger);continue}case"code":{T+=this.renderer.code(me.text,me.lang,me.escaped);continue}case"table":{for(oe="",Q="",L=me.header.length,S=0;S<L;S++)Q+=this.renderer.tablecell(this.parseInline(me.header[S].tokens),{header:!0,align:me.align[S]});for(oe+=this.renderer.tablerow(Q),De="",L=me.rows.length,S=0;S<L;S++){for(Y=me.rows[S],Q="",z=Y.length,y=0;y<z;y++)Q+=this.renderer.tablecell(this.parseInline(Y[y].tokens),{header:!1,align:me.align[y]});De+=this.renderer.tablerow(Q)}T+=this.renderer.table(oe,De);continue}case"blockquote":{De=this.parse(me.tokens),T+=this.renderer.blockquote(De);continue}case"list":{for(ke=me.ordered,Ae=me.start,Me=me.loose,L=me.items.length,De="",S=0;S<L;S++)Te=me.items[S],Ve=Te.checked,Qe=Te.task,Se="",Te.task&&(Ue=this.renderer.checkbox(Ve),Me?Te.tokens.length>0&&Te.tokens[0].type==="paragraph"?(Te.tokens[0].text=Ue+" "+Te.tokens[0].text,Te.tokens[0].tokens&&Te.tokens[0].tokens.length>0&&Te.tokens[0].tokens[0].type==="text"&&(Te.tokens[0].tokens[0].text=Ue+" "+Te.tokens[0].tokens[0].text)):Te.tokens.unshift({type:"text",text:Ue}):Se+=Ue),Se+=this.parse(Te.tokens,Me),De+=this.renderer.listitem(Se,Qe,Ve);T+=this.renderer.list(De,ke,Ae);continue}case"html":{T+=this.renderer.html(me.text);continue}case"paragraph":{T+=this.renderer.paragraph(this.parseInline(me.tokens));continue}case"text":{for(De=me.tokens?this.parseInline(me.tokens):me.text;n+1<U&&l[n+1].type==="text";)me=l[++n],De+=`
`+(me.tokens?this.parseInline(me.tokens):me.text);T+=v?this.renderer.paragraph(De):De;continue}default:{var se='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}}return T},c.parseInline=function(l,v){v=v||this.renderer;var T="",n,S,y,L=l.length;for(n=0;n<L;n++){if(S=l[n],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[S.type]&&(y=this.options.extensions.renderers[S.type].call({parser:this},S),y!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(S.type))){T+=y||"";continue}switch(S.type){case"escape":{T+=v.text(S.text);break}case"html":{T+=v.html(S.text);break}case"link":{T+=v.link(S.href,S.title,this.parseInline(S.tokens,v));break}case"image":{T+=v.image(S.href,S.title,S.text);break}case"strong":{T+=v.strong(this.parseInline(S.tokens,v));break}case"em":{T+=v.em(this.parseInline(S.tokens,v));break}case"codespan":{T+=v.codespan(S.text);break}case"br":{T+=v.br();break}case"del":{T+=v.del(this.parseInline(S.tokens,v));break}case"text":{T+=v.text(S.text);break}default:{var z='Token with "'+S.type+'" type was not found.';if(this.options.silent){console.error(z);return}else throw new Error(z)}}}return T},H}();function ae(H,c,E){if(typeof H>"u"||H===null)throw new Error("marked(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");if(typeof c=="function"&&(E=c,c=null),c=b({},ae.defaults,c||{}),M(c),E){var l=c.highlight,v;try{v=Ie.lex(H,c)}catch(L){return E(L)}var T=function(z){var Y;if(!z)try{c.walkTokens&&ae.walkTokens(v,c.walkTokens),Y=le.parse(v,c)}catch(Q){z=Q}return c.highlight=l,z?E(z):E(null,Y)};if(!l||l.length<3||(delete c.highlight,!v.length))return T();var n=0;ae.walkTokens(v,function(L){L.type==="code"&&(n++,setTimeout(function(){l(L.text,L.lang,function(z,Y){if(z)return T(z);Y!=null&&Y!==L.text&&(L.text=Y,L.escaped=!0),n--,n===0&&T()})},0))}),n===0&&T();return}function S(L){if(L.message+=`
Please report this to https://github.com/markedjs/marked.`,c.silent)return"<p>An error occurred:</p><pre>"+e(L.message+"",!0)+"</pre>";throw L}try{var y=Ie.lex(H,c);if(c.walkTokens){if(c.async)return Promise.all(ae.walkTokens(y,c.walkTokens)).then(function(){return le.parse(y,c)}).catch(S);ae.walkTokens(y,c.walkTokens)}return le.parse(y,c)}catch(L){S(L)}}ae.options=ae.setOptions=function(H){return b(ae.defaults,H),A(ae.defaults),ae},ae.getDefaults=_,ae.defaults=ie.defaults,ae.use=function(){for(var H=arguments.length,c=new Array(H),E=0;E<H;E++)c[E]=arguments[E];var l=b.apply(void 0,[{}].concat(c)),v=ae.defaults.extensions||{renderers:{},childTokens:{}},T;c.forEach(function(n){if(n.extensions&&(T=!0,n.extensions.forEach(function(y){if(!y.name)throw new Error("extension name required");if(y.renderer){var L=v.renderers?v.renderers[y.name]:null;L?v.renderers[y.name]=function(){for(var z=arguments.length,Y=new Array(z),Q=0;Q<z;Q++)Y[Q]=arguments[Q];var oe=y.renderer.apply(this,Y);return oe===!1&&(oe=L.apply(this,Y)),oe}:v.renderers[y.name]=y.renderer}if(y.tokenizer){if(!y.level||y.level!=="block"&&y.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");v[y.level]?v[y.level].unshift(y.tokenizer):v[y.level]=[y.tokenizer],y.start&&(y.level==="block"?v.startBlock?v.startBlock.push(y.start):v.startBlock=[y.start]:y.level==="inline"&&(v.startInline?v.startInline.push(y.start):v.startInline=[y.start]))}y.childTokens&&(v.childTokens[y.name]=y.childTokens)})),n.renderer&&function(){var y=ae.defaults.renderer||new Be,L=function(Q){var oe=y[Q];y[Q]=function(){for(var De=arguments.length,me=new Array(De),ke=0;ke<De;ke++)me[ke]=arguments[ke];var Ae=n.renderer[Q].apply(y,me);return Ae===!1&&(Ae=oe.apply(y,me)),Ae}};for(var z in n.renderer)L(z);l.renderer=y}(),n.tokenizer&&function(){var y=ae.defaults.tokenizer||new ce,L=function(Q){var oe=y[Q];y[Q]=function(){for(var De=arguments.length,me=new Array(De),ke=0;ke<De;ke++)me[ke]=arguments[ke];var Ae=n.tokenizer[Q].apply(y,me);return Ae===!1&&(Ae=oe.apply(y,me)),Ae}};for(var z in n.tokenizer)L(z);l.tokenizer=y}(),n.walkTokens){var S=ae.defaults.walkTokens;l.walkTokens=function(y){var L=[];return L.push(n.walkTokens.call(this,y)),S&&(L=L.concat(S.call(this,y))),L}}T&&(l.extensions=v),ae.setOptions(l)})},ae.walkTokens=function(H,c){for(var E=[],l=function(){var S=T.value;switch(E=E.concat(c.call(ae,S)),S.type){case"table":{for(var y=V(S.header),L;!(L=y()).done;){var z=L.value;E=E.concat(ae.walkTokens(z.tokens,c))}for(var Y=V(S.rows),Q;!(Q=Y()).done;)for(var oe=Q.value,De=V(oe),me;!(me=De()).done;){var ke=me.value;E=E.concat(ae.walkTokens(ke.tokens,c))}break}case"list":{E=E.concat(ae.walkTokens(S.items,c));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[S.type]?ae.defaults.extensions.childTokens[S.type].forEach(function(Ae){E=E.concat(ae.walkTokens(S[Ae],c))}):S.tokens&&(E=E.concat(ae.walkTokens(S.tokens,c)))}},v=V(H),T;!(T=v()).done;)l();return E},ae.parseInline=function(H,c){if(typeof H>"u"||H===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof H!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(H)+", string expected");c=b({},ae.defaults,c||{}),M(c);try{var E=Ie.lexInline(H,c);return c.walkTokens&&ae.walkTokens(E,c.walkTokens),le.parseInline(E,c)}catch(l){if(l.message+=`
Please report this to https://github.com/markedjs/marked.`,c.silent)return"<p>An error occurred:</p><pre>"+e(l.message+"",!0)+"</pre>";throw l}},ae.Parser=le,ae.parser=le.parse,ae.Renderer=Be,ae.TextRenderer=ue,ae.Lexer=Ie,ae.lexer=Ie.lex,ae.Tokenizer=ce,ae.Slugger=J,ae.parse=ae;var Z=ae.options,G=ae.setOptions,ne=ae.use,de=ae.walkTokens,we=ae.parseInline,Fe=ae,_e=le.parse,Pe=Ie.lex;ie.Lexer=Ie,ie.Parser=le,ie.Renderer=Be,ie.Slugger=J,ie.TextRenderer=ue,ie.Tokenizer=ce,ie.getDefaults=_,ie.lexer=Pe,ie.marked=ae,ie.options=Z,ie.parse=Fe,ie.parseInline=we,ie.parser=_e,ie.setOptions=G,ie.use=ne,ie.walkTokens=de,Object.defineProperty(ie,"__esModule",{value:!0})}),define(ge[89],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getKoreanAltChars=s;function s(i){const r=V(i);if(r&&r.length>0)return new Uint32Array(r)}let N=0;const x=new Uint32Array(10);function V(i){if(N=0,_(i,W,4352),N>0||(_(i,h,4449),N>0)||(_(i,d,4520),N>0)||(_(i,e,12593),N))return x.subarray(0,N);if(i>=44032&&i<=55203){const r=i-44032,u=r%588,g=Math.floor(r/588),D=Math.floor(u/28),a=u%28-1;if(g<W.length?_(g,W,0):4352+g-12593<e.length&&_(4352+g,e,12593),D<h.length?_(D,h,0):4449+D-12593<e.length&&_(4449+D-12593,e,12593),a>=0&&(a<d.length?_(a,d,0):4520+a-12593<e.length&&_(4520+a-12593,e,12593)),N>0)return x.subarray(0,N)}}function _(i,r,u){i>=u&&i<u+r.length&&A(r[i-u])}function A(i){i!==0&&(x[N++]=i&255,i>>8&&(x[N++]=i>>8&255),i>>16&&(x[N++]=i>>16&255))}var m;(function(i){i[i.InitialConsonant=4352]="InitialConsonant",i[i.Vowel=4449]="Vowel",i[i.FinalConsonant=4520]="FinalConsonant",i[i.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var p;(function(i){i[i.NUL=0]="NUL",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z"})(p||(p={}));var w;(function(i){i[i.fa=24934]="fa",i[i.fg=26470]="fg",i[i.fq=29030]="fq",i[i.fr=29286]="fr",i[i.ft=29798]="ft",i[i.fv=30310]="fv",i[i.fx=30822]="fx",i[i.hk=27496]="hk",i[i.hl=27752]="hl",i[i.ho=28520]="ho",i[i.ml=27757]="ml",i[i.nj=27246]="nj",i[i.nl=27758]="nl",i[i.np=28782]="np",i[i.qt=29809]="qt",i[i.rt=29810]="rt",i[i.sg=26483]="sg",i[i.sw=30579]="sw"})(w||(w={}));const W=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),h=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),d=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ge[90],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class s{constructor(x,V=0,_=x.length,A=V-1){this.items=x,this.start=V,this.end=_,this.index=A}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=s}),define(ge[91],pe([1,0,90]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class N{constructor(_=[],A=10){this._initialize(_),this._limit=A,this._onChange()}getHistory(){return this._elements}add(_){this._history.delete(_),this._history.add(_),this._onChange()}next(){return this._navigator.next()}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}isFirst(){return this._currentPosition()===0}isLast(){return this._currentPosition()>=this._elements.length-1}isNowhere(){return this._navigator.current()===null}has(_){return this._history.has(_)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const _=this._elements;this._navigator=new s.ArrayNavigator(_,0,_.length,_.length)}_reduceToLimit(){const _=this._elements;_.length>this._limit&&this._initialize(_.slice(_.length-this._limit))}_currentPosition(){const _=this._navigator.current();return _?this._elements.indexOf(_):-1}_initialize(_){this._history=new Set;for(const A of _)this._history.add(A)}get _elements(){const _=[];return this._history.forEach(A=>_.push(A)),_}}t.HistoryNavigator=N;class x{get size(){return this._size}constructor(_,A=10){if(this.capacity=A,_.length<1)throw new Error("not supported");this._size=1,this.head=this.tail=this.cursor={value:_[0],previous:void 0,next:void 0},this.valueSet=new Set([_[0]]);for(let m=1;m<_.length;m++)this.add(_[m])}add(_){const A={value:_,previous:this.tail,next:void 0};for(this.tail.next=A,this.tail=A,this.cursor=this.tail,this._size++,this.valueSet.has(_)?this._deleteFromList(_):this.valueSet.add(_);this._size>this.capacity;)this.valueSet.delete(this.head.value),this.head=this.head.next,this.head.previous=void 0,this._size--}replaceLast(_){if(this.tail.value===_)return _;const A=this.tail.value;return this.valueSet.delete(A),this.tail.value=_,this.valueSet.has(_)?this._deleteFromList(_):this.valueSet.add(_),A}prepend(_){if(this._size===this.capacity||this.valueSet.has(_))return;const A={value:_,previous:void 0,next:this.head};this.head.previous=A,this.head=A,this._size++,this.valueSet.add(_)}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(_){return this.valueSet.has(_)}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let _=this.head;for(;_;)yield _.value,_=_.next}_deleteFromList(_){let A=this.head;for(;A!==this.tail;)A.value===_&&(A===this.head?(this.head=this.head.next,this.head.previous=void 0):(A.previous.next=A.next,A.next.previous=A.previous),this._size--),A=A.next}}t.HistoryNavigator2=x}),define(ge[39],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=void 0,t.clamp=s,t.rot=N;function s(A,m,p){return Math.min(Math.max(A,m),p)}function N(A,m){return(m+A%m)%m}class x{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=x;class V{constructor(){this._n=1,this._val=0}update(m){return this._val=this._val+(m-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=V;class _{constructor(m){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(m),this._values.fill(0,0,m)}update(m){const p=this._values[this._index];return this._values[this._index]=m,this._index=(this._index+1)%this._values.length,this._sum-=p,this._sum+=m,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=_}),define(ge[26],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DebugNameData=void 0,t.getDebugName=V,t.getFunctionName=h;class s{constructor(e,i,r){this.owner=e,this.debugNameSource=i,this.referenceFn=r}getDebugName(e){return V(e,this)}}t.DebugNameData=s;const N=new Map,x=new WeakMap;function V(d,e){const i=x.get(d);if(i)return i;const r=_(d,e);if(r){let u=N.get(r)??0;u++,N.set(r,u);const g=u===1?r:`${r}#${u}`;return x.set(d,g),g}}function _(d,e){const i=x.get(d);if(i)return i;const r=e.owner?w(e.owner)+".":"";let u;const g=e.debugNameSource;if(g!==void 0)if(typeof g=="function"){if(u=g(),u!==void 0)return r+u}else return r+g;const D=e.referenceFn;if(D!==void 0&&(u=h(D),u!==void 0))return r+u;if(e.owner!==void 0){const a=A(e.owner,d);if(a!==void 0)return r+a}}function A(d,e){for(const i in d)if(d[i]===e)return i}const m=new Map,p=new WeakMap;function w(d){const e=p.get(d);if(e)return e;const i=W(d);let r=m.get(i)??0;r++,m.set(i,r);const u=r===1?i:`${i}#${r}`;return p.set(d,u),u}function W(d){const e=d.constructor;return e?e.name:"Object"}function h(d){const e=d.toString(),r=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(r?r[1]:void 0)?.trim()}}),define(ge[27],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConsoleObservableLogger=void 0,t.setLogger=N,t.getLogger=x;let s;function N(i){s=i}function x(){return s}class V{constructor(){this.indentation=0,this.changedObservablesSets=new WeakMap}textToConsoleArgs(r){return _([A(d("|  ",this.indentation)),r])}formatInfo(r){return r.hadValue?r.didChange?[A(" "),p(w(r.oldValue,70),{color:"red",strikeThrough:!0}),A(" "),p(w(r.newValue,60),{color:"green"})]:[A(" (unchanged)")]:[A(" "),p(w(r.newValue,60),{color:"green"}),A(" (initial)")]}handleObservableChanged(r,u){console.log(...this.textToConsoleArgs([m("observable value changed"),p(r.debugName,{color:"BlueViolet"}),...this.formatInfo(u)]))}formatChanges(r){if(r.size!==0)return p(" (changed deps: "+[...r].map(u=>u.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const u=r.handleChange;this.changedObservablesSets.set(r,new Set),r.handleChange=(g,D)=>(this.changedObservablesSets.get(r).add(g),u.apply(r,[g,D]))}handleDerivedRecomputed(r,u){const g=this.changedObservablesSets.get(r);console.log(...this.textToConsoleArgs([m("derived recomputed"),p(r.debugName,{color:"BlueViolet"}),...this.formatInfo(u),this.formatChanges(g),{data:[{fn:r._computeFn}]}])),g.clear()}handleFromEventObservableTriggered(r,u){console.log(...this.textToConsoleArgs([m("observable from event triggered"),p(r.debugName,{color:"BlueViolet"}),...this.formatInfo(u),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const u=r.handleChange;this.changedObservablesSets.set(r,new Set),r.handleChange=(g,D)=>(this.changedObservablesSets.get(r).add(g),u.apply(r,[g,D]))}handleAutorunTriggered(r){const u=this.changedObservablesSets.get(r);console.log(...this.textToConsoleArgs([m("autorun"),p(r.debugName,{color:"BlueViolet"}),this.formatChanges(u),{data:[{fn:r._runFn}]}])),u.clear(),this.indentation++}handleAutorunFinished(r){this.indentation--}handleBeginTransaction(r){let u=r.getDebugName();u===void 0&&(u=""),console.log(...this.textToConsoleArgs([m("transaction"),p(u,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.indentation++}handleEndTransaction(){this.indentation--}}t.ConsoleObservableLogger=V;function _(i){const r=new Array,u=[];let g="";function D(f){if("length"in f)for(const o of f)o&&D(o);else"text"in f?(g+=`%c${f.text}`,r.push(f.style),f.data&&u.push(...f.data)):"data"in f&&u.push(...f.data)}D(i);const a=[g,...r];return a.push(...u),a}function A(i){return p(i,{color:"black"})}function m(i){return p(e(`${i}: `,10),{color:"black",bold:!0})}function p(i,r={color:"black"}){function u(D){return Object.entries(D).reduce((a,[f,o])=>`${a}${f}:${o};`,"")}const g={color:r.color};return r.strikeThrough&&(g["text-decoration"]="line-through"),r.bold&&(g["font-weight"]="bold"),{text:i,style:u(g)}}function w(i,r){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=r?`"${i}"`:`"${i.substr(0,r-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?W(i,r):h(i,r);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function W(i,r){let u="[ ",g=!0;for(const D of i){if(g||(u+=", "),u.length-5>r){u+="...";break}g=!1,u+=`${w(D,r-u.length)}`}return u+=" ]",u}function h(i,r){let u="{ ",g=!0;for(const[D,a]of Object.entries(i)){if(g||(u+=", "),u.length-5>r){u+="...";break}g=!1,u+=`${D}: ${w(a,r-u.length)}`}return u+=" }",u}function d(i,r){let u="";for(let g=1;g<=r;g++)u+=i;return u}function e(i,r){for(;i.length<r;)i+=" ";return i}}),define(ge[40],pe([1,0,37,2,26,27]),function(ie,t,s,N,x,V){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AutorunObserver=void 0,t.autorun=_,t.autorunOpts=A,t.autorunHandleChanges=m,t.autorunWithStoreHandleChanges=p,t.autorunWithStore=w,t.autorunDelta=W;function _(e){return new d(new x.DebugNameData(void 0,void 0,e),e,void 0,void 0)}function A(e,i){return new d(new x.DebugNameData(e.owner,e.debugName,e.debugReferenceFn??i),i,void 0,void 0)}function m(e,i){return new d(new x.DebugNameData(e.owner,e.debugName,e.debugReferenceFn??i),i,e.createEmptyChangeSummary,e.handleChange)}function p(e,i){const r=new N.DisposableStore,u=m({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(g,D)=>{r.clear(),i(g,D,r)});return(0,N.toDisposable)(()=>{u.dispose(),r.dispose()})}function w(e){const i=new N.DisposableStore,r=A({owner:void 0,debugName:void 0,debugReferenceFn:e},u=>{i.clear(),e(u,i)});return(0,N.toDisposable)(()=>{r.dispose(),i.dispose()})}function W(e,i){let r;return A({debugReferenceFn:i},u=>{const g=e.read(u),D=r;r=g,i({lastValue:D,newValue:g})})}var h;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})(h||(h={}));class d{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(i,r,u,g){this._debugNameData=i,this._runFn=r,this.createChangeSummary=u,this._handleChange=g,this.state=2,this.updateCount=0,this.disposed=!1,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=this.createChangeSummary?.(),(0,V.getLogger)()?.handleAutorunCreated(this),this._runIfNeeded(),(0,N.trackDisposable)(this)}dispose(){this.disposed=!0;for(const i of this.dependencies)i.removeObserver(this);this.dependencies.clear(),(0,N.markAsDisposed)(this)}_runIfNeeded(){if(this.state===3)return;const i=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=i,this.state=3;const r=this.disposed;try{if(!r){(0,V.getLogger)()?.handleAutorunTriggered(this);const u=this.changeSummary;this.changeSummary=this.createChangeSummary?.(),this._runFn(this,u)}}finally{r||(0,V.getLogger)()?.handleAutorunFinished(this);for(const u of this.dependenciesToBeRemoved)u.removeObserver(this);this.dependenciesToBeRemoved.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.state===3&&(this.state=1),this.updateCount++}endUpdate(){if(this.updateCount===1)do{if(this.state===1){this.state=3;for(const i of this.dependencies)if(i.reportChanges(),this.state===2)break}this._runIfNeeded()}while(this.state!==3);this.updateCount--,(0,s.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(i){this.state===3&&this.dependencies.has(i)&&!this.dependenciesToBeRemoved.has(i)&&(this.state=1)}handleChange(i,r){this.dependencies.has(i)&&!this.dependenciesToBeRemoved.has(i)&&(!this._handleChange||this._handleChange({changedObservable:i,change:r,didChange:g=>g===i},this.changeSummary))&&(this.state=2)}readObservable(i){if(this.disposed)return i.get();i.addObserver(this);const r=i.get();return this.dependencies.add(i),this.dependenciesToBeRemoved.delete(i),r}}t.AutorunObserver=d,function(e){e.Observer=d}(_||(t.autorun=_={}))}),define(ge[33],pe([1,0,26,27]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableObservableValue=t.ObservableValue=t.TransactionImpl=t.BaseObservable=t.ConvenientObservable=void 0,t._setRecomputeInitiallyAndOnChange=V,t._setKeepObserved=A,t._setDerivedOpts=p,t.transaction=h,t.globalTransaction=e,t.asyncTransaction=i,t.subtransaction=r,t.observableValue=g,t.disposableObservableValue=a;let x;function V(o){x=o}let _;function A(o){_=o}let m;function p(o){m=o}class w{get TChange(){return null}reportChanges(){this.get()}read(C){return C?C.readObservable(this):this.get()}map(C,F){const R=F===void 0?void 0:C,B=F===void 0?C:F;return m({owner:R,debugName:()=>{const P=(0,s.getFunctionName)(B);if(P!==void 0)return P;const O=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(B.toString());if(O)return`${this.debugName}.${O[2]}`;if(!R)return`${this.debugName} (mapped)`}},P=>B(this.read(P),P))}recomputeInitiallyAndOnChange(C,F){return C.add(x(this,F)),this}keepObserved(C){return C.add(_(this)),this}}t.ConvenientObservable=w;class W extends w{constructor(){super(...arguments),this.observers=new Set}addObserver(C){const F=this.observers.size;this.observers.add(C),F===0&&this.onFirstObserverAdded()}removeObserver(C){this.observers.delete(C)&&this.observers.size===0&&this.onLastObserverRemoved()}onFirstObserverAdded(){}onLastObserverRemoved(){}}t.BaseObservable=W;function h(o,C){const F=new u(o,C);try{o(F)}finally{F.finish()}}let d;function e(o){if(d)o(d);else{const C=new u(o,void 0);d=C;try{o(C)}finally{C.finish(),d=void 0}}}async function i(o,C){const F=new u(o,C);try{await o(F)}finally{F.finish()}}function r(o,C,F){o?C(o):h(C,F)}class u{constructor(C,F){this._fn=C,this._getDebugName=F,this.updatingObservers=[],(0,N.getLogger)()?.handleBeginTransaction(this)}getDebugName(){return this._getDebugName?this._getDebugName():(0,s.getFunctionName)(this._fn)}updateObserver(C,F){this.updatingObservers.push({observer:C,observable:F}),C.beginUpdate(F)}finish(){const C=this.updatingObservers;for(let F=0;F<C.length;F++){const{observer:R,observable:B}=C[F];R.endUpdate(B)}this.updatingObservers=null,(0,N.getLogger)()?.handleEndTransaction()}}t.TransactionImpl=u;function g(o,C){return typeof o=="string"?new D(void 0,o,C):new D(o,void 0,C)}class D extends W{get debugName(){return new s.DebugNameData(this._owner,this._debugName,void 0).getDebugName(this)??"ObservableValue"}constructor(C,F,R){super(),this._owner=C,this._debugName=F,this._value=R}get(){return this._value}set(C,F,R){if(this._value===C)return;let B;F||(F=B=new u(()=>{},()=>`Setting ${this.debugName}`));try{const P=this._value;this._setValue(C),(0,N.getLogger)()?.handleObservableChanged(this,{oldValue:P,newValue:C,change:R,didChange:!0,hadValue:!0});for(const b of this.observers)F.updateObserver(b,this),b.handleChange(this,R)}finally{B&&B.finish()}}toString(){return`${this.debugName}: ${this._value}`}_setValue(C){this._value=C}}t.ObservableValue=D;function a(o,C){return typeof o=="string"?new f(void 0,o,C):new f(o,void 0,C)}class f extends D{_setValue(C){this._value!==C&&(this._value&&this._value.dispose(),this._value=C)}dispose(){this._value?.dispose()}}t.DisposableObservableValue=f}),define(ge[41],pe([1,0,37,2,33,26,27]),function(ie,t,s,N,x,V,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Derived=t.defaultEqualityComparer=void 0,t.derived=m,t.derivedOpts=p,t.derivedHandleChanges=w,t.derivedWithStore=W,t.derivedDisposable=h;const A=(i,r)=>i===r;t.defaultEqualityComparer=A;function m(i,r){return r!==void 0?new e(new V.DebugNameData(i,void 0,r),r,void 0,void 0,void 0,t.defaultEqualityComparer):new e(new V.DebugNameData(void 0,void 0,i),i,void 0,void 0,void 0,t.defaultEqualityComparer)}function p(i,r){return new e(new V.DebugNameData(i.owner,i.debugName,i.debugReferenceFn),r,void 0,void 0,i.onLastObserverRemoved,i.equalityComparer??t.defaultEqualityComparer)}(0,x._setDerivedOpts)(p);function w(i,r){return new e(new V.DebugNameData(i.owner,i.debugName,void 0),r,i.createEmptyChangeSummary,i.handleChange,void 0,i.equalityComparer??t.defaultEqualityComparer)}function W(i,r){let u,g;r===void 0?(u=i,g=void 0):(g=i,u=r);const D=new N.DisposableStore;return new e(new V.DebugNameData(g,void 0,u),a=>(D.clear(),u(a,D)),void 0,void 0,()=>D.dispose(),t.defaultEqualityComparer)}function h(i,r){let u,g;r===void 0?(u=i,g=void 0):(g=i,u=r);const D=new N.DisposableStore;return new e(new V.DebugNameData(g,void 0,u),a=>{D.clear();const f=u(a);return f&&D.add(f),f},void 0,void 0,()=>D.dispose(),t.defaultEqualityComparer)}var d;(function(i){i[i.initial=0]="initial",i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(d||(d={}));class e extends x.BaseObservable{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(r,u,g,D,a=void 0,f){super(),this._debugNameData=r,this._computeFn=u,this.createChangeSummary=g,this._handleChange=D,this._handleLastObserverRemoved=a,this._equalityComparator=f,this.state=0,this.value=void 0,this.updateCount=0,this.dependencies=new Set,this.dependenciesToBeRemoved=new Set,this.changeSummary=void 0,this.changeSummary=this.createChangeSummary?.(),(0,_.getLogger)()?.handleDerivedCreated(this)}onLastObserverRemoved(){this.state=0,this.value=void 0;for(const r of this.dependencies)r.removeObserver(this);this.dependencies.clear(),this._handleLastObserverRemoved?.()}get(){if(this.observers.size===0){const r=this._computeFn(this,this.createChangeSummary?.());return this.onLastObserverRemoved(),r}else{do{if(this.state===1){for(const r of this.dependencies)if(r.reportChanges(),this.state===2)break}this.state===1&&(this.state=3),this._recomputeIfNeeded()}while(this.state!==3);return this.value}}_recomputeIfNeeded(){if(this.state===3)return;const r=this.dependenciesToBeRemoved;this.dependenciesToBeRemoved=this.dependencies,this.dependencies=r;const u=this.state!==0,g=this.value;this.state=3;const D=this.changeSummary;this.changeSummary=this.createChangeSummary?.();try{this.value=this._computeFn(this,D)}finally{for(const f of this.dependenciesToBeRemoved)f.removeObserver(this);this.dependenciesToBeRemoved.clear()}const a=u&&!this._equalityComparator(g,this.value);if((0,_.getLogger)()?.handleDerivedRecomputed(this,{oldValue:g,newValue:this.value,change:void 0,didChange:a,hadValue:u}),a)for(const f of this.observers)f.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(r){this.updateCount++;const u=this.updateCount===1;if(this.state===3&&(this.state=1,!u))for(const g of this.observers)g.handlePossibleChange(this);if(u)for(const g of this.observers)g.beginUpdate(this)}endUpdate(r){if(this.updateCount--,this.updateCount===0){const u=[...this.observers];for(const g of u)g.endUpdate(this)}(0,s.assertFn)(()=>this.updateCount>=0)}handlePossibleChange(r){if(this.state===3&&this.dependencies.has(r)&&!this.dependenciesToBeRemoved.has(r)){this.state=1;for(const u of this.observers)u.handlePossibleChange(this)}}handleChange(r,u){if(this.dependencies.has(r)&&!this.dependenciesToBeRemoved.has(r)){const g=this._handleChange?this._handleChange({changedObservable:r,change:u,didChange:a=>a===r},this.changeSummary):!0,D=this.state===3;if(g&&(this.state===1||D)&&(this.state=2,D))for(const a of this.observers)a.handlePossibleChange(this)}}readObservable(r){r.addObserver(this);const u=r.get();return this.dependencies.add(r),this.dependenciesToBeRemoved.delete(r),u}addObserver(r){const u=!this.observers.has(r)&&this.updateCount>0;super.addObserver(r),u&&r.beginUpdate(this)}removeObserver(r){const u=this.observers.has(r)&&this.updateCount>0;super.removeObserver(r),u&&r.endUpdate(this)}}t.Derived=e}),define(ge[92],pe([1,0,2,40,33,26,41,27]),function(ie,t,s,N,x,V,_,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeepAliveObserver=t.FromEventObservable=void 0,t.constObservable=m,t.observableFromPromise=w,t.observableFromEvent=W,t.observableSignalFromEvent=d,t.observableSignal=i,t.debouncedObservable=u,t.debouncedObservable2=g,t.wasEventTriggeredRecently=D,t.keepObserved=a,t.recomputeInitiallyAndOnChange=f,t.derivedObservableWithCache=C,t.derivedObservableWithWritableCache=F,t.mapObservableArrayCached=R;function m(P){return new p(P)}class p extends x.ConvenientObservable{constructor(b){super(),this.value=b}get debugName(){return this.toString()}get(){return this.value}addObserver(b){}removeObserver(b){}toString(){return`Const: ${this.value}`}}function w(P){const b=(0,x.observableValue)("promiseValue",{});return P.then(O=>{b.set({value:O},void 0)}),b}function W(P,b){return new h(P,b)}class h extends x.BaseObservable{constructor(b,O){super(),this.event=b,this._getValue=O,this.hasValue=!1,this.handleEvent=$=>{const k=this._getValue($),M=this.value,I=!this.hasValue||M!==k;let q=!1;I&&(this.value=k,this.hasValue&&(q=!0,(0,x.subtransaction)(h.globalTransaction,X=>{(0,A.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:M,newValue:k,change:void 0,didChange:I,hadValue:this.hasValue});for(const ce of this.observers)X.updateObserver(ce,this),ce.handleChange(this,void 0)},()=>{const X=this.getDebugName();return"Event fired"+(X?`: ${X}`:"")})),this.hasValue=!0),q||(0,A.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:M,newValue:k,change:void 0,didChange:I,hadValue:this.hasValue})}}getDebugName(){return(0,V.getFunctionName)(this._getValue)}get debugName(){const b=this.getDebugName();return"From Event"+(b?`: ${b}`:"")}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0,this.hasValue=!1,this.value=void 0}get(){return this.subscription?(this.hasValue||this.handleEvent(void 0),this.value):this._getValue(void 0)}}t.FromEventObservable=h,function(P){P.Observer=h;function b(O,$){let k=!1;h.globalTransaction===void 0&&(h.globalTransaction=O,k=!0);try{$()}finally{k&&(h.globalTransaction=void 0)}}P.batchEventsGlobally=b}(W||(t.observableFromEvent=W={}));function d(P,b){return new e(P,b)}class e extends x.BaseObservable{constructor(b,O){super(),this.debugName=b,this.event=O,this.handleEvent=()=>{(0,x.transaction)($=>{for(const k of this.observers)$.updateObserver(k,this),k.handleChange(this,void 0)},()=>this.debugName)}}onFirstObserverAdded(){this.subscription=this.event(this.handleEvent)}onLastObserverRemoved(){this.subscription.dispose(),this.subscription=void 0}get(){}}function i(P){return typeof P=="string"?new r(P):new r(void 0,P)}class r extends x.BaseObservable{get debugName(){return new V.DebugNameData(this._owner,this._debugName,void 0).getDebugName(this)??"Observable Signal"}constructor(b,O){super(),this._debugName=b,this._owner=O}trigger(b,O){if(!b){(0,x.transaction)($=>{this.trigger($,O)},()=>`Trigger signal ${this.debugName}`);return}for(const $ of this.observers)b.updateObserver($,this),$.handleChange(this,O)}get(){}}function u(P,b,O){const $=(0,x.observableValue)("debounced",void 0);let k;return O.add((0,N.autorun)(M=>{const I=P.read(M);k&&clearTimeout(k),k=setTimeout(()=>{(0,x.transaction)(q=>{$.set(I,q)})},b)})),$}function g(P,b){let O=!1,$,k;return W(M=>{const I=(0,N.autorun)(q=>{const X=P.read(q);O?(k&&clearTimeout(k),k=setTimeout(()=>{$=X,M()},b)):(O=!0,$=X)});return{dispose(){I.dispose(),O=!1,$=void 0}}},()=>O?$:P.get())}function D(P,b,O){const $=(0,x.observableValue)("triggeredRecently",!1);let k;return O.add(P(()=>{$.set(!0,void 0),k&&clearTimeout(k),k=setTimeout(()=>{$.set(!1,void 0)},b)})),$}function a(P){const b=new o(!1,void 0);return P.addObserver(b),(0,s.toDisposable)(()=>{P.removeObserver(b)})}(0,x._setKeepObserved)(a);function f(P,b){const O=new o(!0,b);return P.addObserver(O),b?b(P.get()):P.reportChanges(),(0,s.toDisposable)(()=>{P.removeObserver(O)})}(0,x._setRecomputeInitiallyAndOnChange)(f);class o{constructor(b,O){this._forceRecompute=b,this._handleValue=O,this._counter=0}beginUpdate(b){this._counter++}endUpdate(b){this._counter--,this._counter===0&&this._forceRecompute&&(this._handleValue?this._handleValue(b.get()):b.reportChanges())}handlePossibleChange(b){}handleChange(b,O){}}t.KeepAliveObserver=o;function C(P){let b;return(0,_.derived)($=>(b=P($,b),b))}function F(P,b){let O;const $=(0,x.observableValue)("derivedObservableWithWritableCache.counter",0),k=(0,_.derived)(P,M=>($.read(M),O=b(M,O),O));return Object.assign(k,{clearCache:M=>{O=void 0,$.set($.get()+1,M)}})}function R(P,b,O,$){let k=new B(O,$);return(0,_.derivedOpts)({debugReferenceFn:O,owner:P,onLastObserverRemoved:()=>{k.dispose(),k=new B(O)}},I=>(k.setItems(b.read(I)),k.getItems()))}class B{constructor(b,O){this._map=b,this._keySelector=O,this._cache=new Map,this._items=[]}dispose(){this._cache.forEach(b=>b.store.dispose()),this._cache.clear()}setItems(b){const O=[],$=new Set(this._cache.keys());for(const k of b){const M=this._keySelector?this._keySelector(k):k;let I=this._cache.get(M);if(I)$.delete(M);else{const q=new s.DisposableStore;I={out:this._map(k,q),store:q},this._cache.set(M,I)}O.push(I.out)}for(const k of $)this._cache.get(k).store.dispose(),this._cache.delete(k);this._items=O}getItems(){return this._items}}}),define(ge[56],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var s;(function(N){function x(m,p){if(m.start>=p.end||p.start>=m.end)return{start:0,end:0};const w=Math.max(m.start,p.start),W=Math.min(m.end,p.end);return W-w<=0?{start:0,end:0}:{start:w,end:W}}N.intersect=x;function V(m){return m.end-m.start<=0}N.isEmpty=V;function _(m,p){return!V(x(m,p))}N.intersects=_;function A(m,p){const w=[],W={start:m.start,end:Math.min(p.start,m.end)},h={start:Math.max(p.end,m.start),end:m.end};return V(W)||w.push(W),V(h)||w.push(h),w}N.relativeComplement=A})(s||(t.Range=s={}))}),define(ge[93],pe([1,0,56]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=void 0,t.groupIntersect=N,t.shift=x,t.consolidate=V;function N(m,p){const w=[];for(const W of p){if(m.start>=W.range.end)continue;if(m.end<W.range.start)break;const h=s.Range.intersect(m,W.range);s.Range.isEmpty(h)||w.push({range:h,size:W.size})}return w}function x({start:m,end:p},w){return{start:m+w,end:p+w}}function V(m){const p=[];let w=null;for(const W of m){const h=W.range.start,d=W.range.end,e=W.size;if(w&&e===w.size){w.range.end=d;continue}w={range:{start:h,end:d},size:e},p.push(w)}return p}function _(...m){return V(m.reduce((p,w)=>p.concat(w),[]))}class A{get paddingTop(){return this._paddingTop}set paddingTop(p){this._size=this._size+p-this._paddingTop,this._paddingTop=p}constructor(p){this.groups=[],this._size=0,this._paddingTop=0,this._paddingTop=p??0,this._size=this._paddingTop}splice(p,w,W=[]){const h=W.length-w,d=N({start:0,end:p},this.groups),e=N({start:p+w,end:Number.POSITIVE_INFINITY},this.groups).map(r=>({range:x(r.range,h),size:r.size})),i=W.map((r,u)=>({range:{start:p+u,end:p+u+1},size:r.size}));this.groups=_(d,i,e),this._size=this._paddingTop+this.groups.reduce((r,u)=>r+u.size*(u.range.end-u.range.start),0)}get count(){const p=this.groups.length;return p?this.groups[p-1].range.end:0}get size(){return this._size}indexAt(p){if(p<0)return-1;if(p<this._paddingTop)return 0;let w=0,W=this._paddingTop;for(const h of this.groups){const d=h.range.end-h.range.start,e=W+d*h.size;if(p<e)return w+Math.floor((p-W)/h.size);w+=d,W=e}return w}indexAfter(p){return Math.min(this.indexAt(p)+1,this.count)}positionAt(p){if(p<0)return-1;let w=0,W=0;for(const h of this.groups){const d=h.range.end-h.range.start,e=W+d;if(p<e)return this._paddingTop+w+(p-W)*h.size;w+=d*h.size,W=e}return-1}}t.RangeMap=A}),define(ge[94],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const s=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(V){return new N(V)}constructor(V){this._now=s&&V===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=N}),define(ge[4],pe([1,0,6,53,2,55,94]),function(ie,t,s,N,x,V,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.DynamicListEventMultiplexer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.EventProfiling=t.Event=void 0,t.setGlobalLeakWarningThreshold=d;const A=!1,m=!1,p=!1;var w;(function(M){M.None=()=>x.Disposable.None;function I(T){if(p){const{onDidAddListener:n}=T,S=i.create();let y=0;T.onDidAddListener=()=>{++y===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),S.print()),n?.()}}}function q(T,n){return J(T,()=>{},0,void 0,!0,void 0,n)}M.defer=q;function X(T){return(n,S=null,y)=>{let L=!1,z;return z=T(Y=>{if(!L)return z?z.dispose():L=!0,n.call(S,Y)},null,y),L&&z.dispose(),z}}M.once=X;function ce(T,n,S){return Be((y,L=null,z)=>T(Y=>y.call(L,n(Y)),null,z),S)}M.map=ce;function re(T,n,S){return Be((y,L=null,z)=>T(Y=>{n(Y),y.call(L,Y)},null,z),S)}M.forEach=re;function te(T,n,S){return Be((y,L=null,z)=>T(Y=>n(Y)&&y.call(L,Y),null,z),S)}M.filter=te;function be(T){return T}M.signal=be;function Ee(...T){return(n,S=null,y)=>{const L=(0,x.combinedDisposable)(...T.map(z=>z(Y=>n.call(S,Y))));return ue(L,y)}}M.any=Ee;function Ie(T,n,S,y){let L=S;return ce(T,z=>(L=n(L,z),L),y)}M.reduce=Ie;function Be(T,n){let S;const y={onWillAddFirstListener(){S=T(L.fire,L)},onDidRemoveLastListener(){S?.dispose()}};n||I(y);const L=new f(y);return n?.add(L),L.event}function ue(T,n){return n instanceof Array?n.push(T):n&&n.add(T),T}function J(T,n,S=100,y=!1,L=!1,z,Y){let Q,oe,De,me=0,ke;const Ae={leakWarningThreshold:z,onWillAddFirstListener(){Q=T(Se=>{me++,oe=n(oe,Se),y&&!De&&(Me.fire(oe),oe=void 0),ke=()=>{const Te=oe;oe=void 0,De=void 0,(!y||me>1)&&Me.fire(Te),me=0},typeof S=="number"?(clearTimeout(De),De=setTimeout(ke,S)):De===void 0&&(De=0,queueMicrotask(ke))})},onWillRemoveListener(){L&&me>0&&ke?.()},onDidRemoveLastListener(){ke=void 0,Q.dispose()}};Y||I(Ae);const Me=new f(Ae);return Y?.add(Me),Me.event}M.debounce=J;function le(T,n=0,S){return M.debounce(T,(y,L)=>y?(y.push(L),y):[L],n,void 0,!0,void 0,S)}M.accumulate=le;function ae(T,n=(y,L)=>y===L,S){let y=!0,L;return te(T,z=>{const Y=y||!n(z,L);return y=!1,L=z,Y},S)}M.latch=ae;function Z(T,n,S){return[M.filter(T,n,S),M.filter(T,y=>!n(y),S)]}M.split=Z;function G(T,n=!1,S=[],y){let L=S.slice(),z=T(oe=>{L?L.push(oe):Q.fire(oe)});y&&y.add(z);const Y=()=>{L?.forEach(oe=>Q.fire(oe)),L=null},Q=new f({onWillAddFirstListener(){z||(z=T(oe=>Q.fire(oe)),y&&y.add(z))},onDidAddFirstListener(){L&&(n?setTimeout(Y):Y())},onDidRemoveLastListener(){z&&z.dispose(),z=null}});return y&&y.add(Q),Q.event}M.buffer=G;function ne(T,n){return(y,L,z)=>{const Y=n(new we);return T(function(Q){const oe=Y.evaluate(Q);oe!==de&&y.call(L,oe)},void 0,z)}}M.chain=ne;const de=Symbol("HaltChainable");class we{constructor(){this.steps=[]}map(n){return this.steps.push(n),this}forEach(n){return this.steps.push(S=>(n(S),S)),this}filter(n){return this.steps.push(S=>n(S)?S:de),this}reduce(n,S){let y=S;return this.steps.push(L=>(y=n(y,L),y)),this}latch(n=(S,y)=>S===y){let S=!0,y;return this.steps.push(L=>{const z=S||!n(L,y);return S=!1,y=L,z?L:de}),this}evaluate(n){for(const S of this.steps)if(n=S(n),n===de)break;return n}}function Fe(T,n,S=y=>y){const y=(...Q)=>Y.fire(S(...Q)),L=()=>T.on(n,y),z=()=>T.removeListener(n,y),Y=new f({onWillAddFirstListener:L,onDidRemoveLastListener:z});return Y.event}M.fromNodeEventEmitter=Fe;function _e(T,n,S=y=>y){const y=(...Q)=>Y.fire(S(...Q)),L=()=>T.addEventListener(n,y),z=()=>T.removeEventListener(n,y),Y=new f({onWillAddFirstListener:L,onDidRemoveLastListener:z});return Y.event}M.fromDOMEventEmitter=_e;function Pe(T){return new Promise(n=>X(T)(n))}M.toPromise=Pe;function H(T){const n=new f;return T.then(S=>{n.fire(S)},()=>{n.fire(void 0)}).finally(()=>{n.dispose()}),n.event}M.fromPromise=H;function c(T,n,S){return n(S),T(y=>n(y))}M.runAndSubscribe=c;class E{constructor(n,S){this._observable=n,this._counter=0,this._hasChanged=!1;const y={onWillAddFirstListener:()=>{n.addObserver(this)},onDidRemoveLastListener:()=>{n.removeObserver(this)}};S||I(y),this.emitter=new f(y),S&&S.add(this.emitter)}beginUpdate(n){this._counter++}handlePossibleChange(n){}handleChange(n,S){this._hasChanged=!0}endUpdate(n){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function l(T,n){return new E(T,n).emitter.event}M.fromObservable=l;function v(T){return(n,S,y)=>{let L=0,z=!1;const Y={beginUpdate(){L++},endUpdate(){L--,L===0&&(T.reportChanges(),z&&(z=!1,n.call(S)))},handlePossibleChange(){},handleChange(){z=!0}};T.addObserver(Y),T.reportChanges();const Q={dispose(){T.removeObserver(Y)}};return y instanceof x.DisposableStore?y.add(Q):Array.isArray(y)&&y.push(Q),Q}}M.fromObservableLight=v})(w||(t.Event=w={}));class W{static{this.all=new Set}static{this._idPool=0}constructor(I){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${I}_${W._idPool++}`,W.all.add(this)}start(I){this._stopWatch=new _.StopWatch,this.listenerCount=I}stop(){if(this._stopWatch){const I=this._stopWatch.elapsed();this.durations.push(I),this.elapsedOverall+=I,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=W;let h=-1;function d(M){const I=h;return h=M,{dispose(){h=I}}}class e{constructor(I,q=Math.random().toString(18).slice(2,5)){this.threshold=I,this.name=q,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(I,q){const X=this.threshold;if(X<=0||q<X)return;this._stacks||(this._stacks=new Map);const ce=this._stacks.get(I.value)||0;if(this._stacks.set(I.value,ce+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=X*.5;let re,te=0;for(const[be,Ee]of this._stacks)(!re||te<Ee)&&(re=be,te=Ee);console.warn(`[${this.name}] potential listener LEAK detected, having ${q} listeners already. MOST frequent listener (${te}):`),console.warn(re)}return()=>{const re=this._stacks.get(I.value)||0;this._stacks.set(I.value,re-1)}}}class i{static create(){return new i(new Error().stack??"")}constructor(I){this.value=I}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let r=0;class u{constructor(I){this.value=I,this.id=r++}}const g=2,D=(M,I)=>{if(M instanceof u)I(M);else for(let q=0;q<M.length;q++){const X=M[q];X&&I(X)}},a=A?new FinalizationRegistry(M=>{typeof M=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(M))}):void 0;class f{constructor(I){this._size=0,this._options=I,this._leakageMon=h>0||this._options?.leakWarningThreshold?new e(this._options?.leakWarningThreshold??h):void 0,this._perfMon=this._options?._profName?new W(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(m){const I=this._listeners;queueMicrotask(()=>{D(I,q=>q.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(I,q,X)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),x.Disposable.None;if(this._disposed)return x.Disposable.None;q&&(I=I.bind(q));const ce=new u(I);let re,te;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(ce.stack=i.create(),re=this._leakageMon.check(ce.stack,this._size+1)),m&&(ce.stack=te??i.create()),this._listeners?this._listeners instanceof u?(this._deliveryQueue??=new C,this._listeners=[this._listeners,ce]):this._listeners.push(ce):(this._options?.onWillAddFirstListener?.(this),this._listeners=ce,this._options?.onDidAddFirstListener?.(this)),this._size++;const be=(0,x.toDisposable)(()=>{a?.unregister(be),re?.(),this._removeListener(ce)});if(X instanceof x.DisposableStore?X.add(be):Array.isArray(X)&&X.push(be),a){const Ee=new Error().stack.split(`
`).slice(2).join(`
`).trim();a.register(be,Ee,be)}return be},this._event}_removeListener(I){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const q=this._listeners,X=q.indexOf(I);if(X===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,q[X]=void 0;const ce=this._deliveryQueue.current===this;if(this._size*g<=q.length){let re=0;for(let te=0;te<q.length;te++)q[te]?q[re++]=q[te]:ce&&(this._deliveryQueue.end--,re<this._deliveryQueue.i&&this._deliveryQueue.i--);q.length=re}}_deliver(I,q){if(!I)return;const X=this._options?.onListenerError||s.onUnexpectedError;if(!X){I.value(q);return}try{I.value(q)}catch(ce){X(ce)}}_deliverQueue(I){const q=I.current._listeners;for(;I.i<I.end;)this._deliver(q[I.i++],I.value);I.reset()}fire(I){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof u)this._deliver(this._listeners,I);else{const q=this._deliveryQueue;q.enqueue(this,I,this._listeners.length),this._deliverQueue(q)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=f;const o=()=>new C;t.createEventDeliveryQueue=o;class C{constructor(){this.i=-1,this.end=0}enqueue(I,q,X){this.i=0,this.end=X,this.current=I,this.value=q}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class F extends f{async fireAsync(I,q,X){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new V.LinkedList),D(this._listeners,ce=>this._asyncDeliveryQueue.push([ce.value,I]));this._asyncDeliveryQueue.size>0&&!q.isCancellationRequested;){const[ce,re]=this._asyncDeliveryQueue.shift(),te=[],be={...re,token:q,waitUntil:Ee=>{if(Object.isFrozen(te))throw new Error("waitUntil can NOT be called asynchronous");X&&(Ee=X(Ee,ce)),te.push(Ee)}};try{ce(be)}catch(Ee){(0,s.onUnexpectedError)(Ee);continue}Object.freeze(te),await Promise.allSettled(te).then(Ee=>{for(const Ie of Ee)Ie.status==="rejected"&&(0,s.onUnexpectedError)(Ie.reason)})}}}t.AsyncEmitter=F;class R extends f{get isPaused(){return this._isPaused!==0}constructor(I){super(I),this._isPaused=0,this._eventQueue=new V.LinkedList,this._mergeFn=I?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const I=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(I))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(I){this._size&&(this._isPaused!==0?this._eventQueue.push(I):super.fire(I))}}t.PauseableEmitter=R;class B extends R{constructor(I){super(I),this._delay=I.delay??100}fire(I){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(I)}}t.DebounceEmitter=B;class P extends f{constructor(I){super(I),this._queuedEvents=[],this._mergeFn=I?.merge}fire(I){this.hasListeners()&&(this._queuedEvents.push(I),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(q=>super.fire(q)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=P;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(I){const q={event:I,listener:null};this.events.push(q),this.hasListeners&&this.hook(q);const X=()=>{this.hasListeners&&this.unhook(q);const ce=this.events.indexOf(q);this.events.splice(ce,1)};return(0,x.toDisposable)((0,N.createSingleCallFunction)(X))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(I=>this.hook(I))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(I=>this.unhook(I))}hook(I){I.listener=I.event(q=>this.emitter.fire(q))}unhook(I){I.listener?.dispose(),I.listener=null}dispose(){this.emitter.dispose();for(const I of this.events)I.listener?.dispose();this.events=[]}}t.EventMultiplexer=b;class O{constructor(I,q,X,ce){this._store=new x.DisposableStore;const re=this._store.add(new b),te=this._store.add(new x.DisposableMap);function be(Ee){te.set(Ee,re.add(ce(Ee)))}for(const Ee of I)be(Ee);this._store.add(q(Ee=>{be(Ee)})),this._store.add(X(Ee=>{te.deleteAndDispose(Ee)})),this.event=re.event}dispose(){this._store.dispose()}}t.DynamicListEventMultiplexer=O;class ${constructor(){this.buffers=[]}wrapEvent(I){return(q,X,ce)=>I(re=>{const te=this.buffers[this.buffers.length-1];te?te.push(()=>q.call(X,re)):q.call(X,re)},void 0,ce)}bufferEvents(I){const q=[];this.buffers.push(q);const X=I();return this.buffers.pop(),q.forEach(ce=>ce()),X}}t.EventBufferer=$;class k{constructor(){this.listening=!1,this.inputEvent=w.None,this.inputEventListener=x.Disposable.None,this.emitter=new f({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(I){this.inputEvent=I,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=I(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=k}),define(ge[17],pe([1,0,22,4]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.onDidChangeZoomLevel=void 0,t.addMatchMediaChangeListener=V,t.setZoomLevel=_,t.getZoomLevel=A,t.getZoomFactor=m,t.setZoomFactor=p,t.setFullscreen=w,t.isFullscreen=W,t.isStandalone=e,t.isWCOEnabled=i;class x{constructor(){this.mapWindowIdToZoomLevel=new Map,this._onDidChangeZoomLevel=new N.Emitter,this.onDidChangeZoomLevel=this._onDidChangeZoomLevel.event,this.mapWindowIdToZoomFactor=new Map,this._onDidChangeFullscreen=new N.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event,this.mapWindowIdToFullScreen=new Map}static{this.INSTANCE=new x}getZoomLevel(u){return this.mapWindowIdToZoomLevel.get(this.getWindowId(u))??0}setZoomLevel(u,g){if(this.getZoomLevel(g)===u)return;const D=this.getWindowId(g);this.mapWindowIdToZoomLevel.set(D,u),this._onDidChangeZoomLevel.fire(D)}getZoomFactor(u){return this.mapWindowIdToZoomFactor.get(this.getWindowId(u))??1}setZoomFactor(u,g){this.mapWindowIdToZoomFactor.set(this.getWindowId(g),u)}setFullscreen(u,g){if(this.isFullscreen(g)===u)return;const D=this.getWindowId(g);this.mapWindowIdToFullScreen.set(D,u),this._onDidChangeFullscreen.fire(D)}isFullscreen(u){return!!this.mapWindowIdToFullScreen.get(this.getWindowId(u))}getWindowId(u){return u.vscodeWindowId}}function V(r,u,g){typeof u=="string"&&(u=r.matchMedia(u)),u.addEventListener("change",g)}function _(r,u){x.INSTANCE.setZoomLevel(r,u)}function A(r){return x.INSTANCE.getZoomLevel(r)}t.onDidChangeZoomLevel=x.INSTANCE.onDidChangeZoomLevel;function m(r){return x.INSTANCE.getZoomFactor(r)}function p(r,u){x.INSTANCE.setZoomFactor(r,u)}function w(r,u){x.INSTANCE.setFullscreen(r,u)}function W(r){return x.INSTANCE.isFullscreen(r)}t.onDidChangeFullscreen=x.INSTANCE.onDidChangeFullscreen;const h=navigator.userAgent;t.isFirefox=h.indexOf("Firefox")>=0,t.isWebKit=h.indexOf("AppleWebKit")>=0,t.isChrome=h.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&h.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=h.indexOf("Electron/")>=0,t.isAndroid=h.indexOf("Android")>=0;let d=!1;if(typeof s.mainWindow.matchMedia=="function"){const r=s.mainWindow.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),u=s.mainWindow.matchMedia("(display-mode: fullscreen)");d=r.matches,V(s.mainWindow,r,({matches:g})=>{d&&u.matches||(d=g)})}function e(){return d}function i(){return navigator?.windowControlsOverlay?.visible}}),define(ge[24],pe([1,0,4]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class N{get event(){return this.emitter.event}constructor(V,_,A){const m=p=>this.emitter.fire(p);this.emitter=new s.Emitter({onWillAddFirstListener:()=>V.addEventListener(_,m,A),onDidRemoveLastListener:()=>V.removeEventListener(_,m,A)})}dispose(){this.emitter.dispose()}}t.DomEmitter=N}),define(ge[28],pe([1,0,4]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const N=Object.freeze(function(A,m){const p=setTimeout(A.bind(m),0);return{dispose(){clearTimeout(p)}}});var x;(function(A){function m(p){return p===A.None||p===A.Cancelled||p instanceof V?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}A.isCancellationToken=m,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:s.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(x||(t.CancellationToken=x={}));class V{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?N:(this._emitter||(this._emitter=new s.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(m){this._token=void 0,this._parentListener=void 0,this._parentListener=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new V),this._token}cancel(){this._token?this._token instanceof V&&this._token.cancel():this._token=x.Cancelled}dispose(m=!1){m&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof V&&this._token.dispose():this._token=x.None}}t.CancellationTokenSource=_}),define(ge[95],pe([1,0,28]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class N{constructor(A){this.task=A,this.result=null}get(){if(this.result)return this.result;const A=new s.CancellationTokenSource,m=this.task(A.token);return this.result={promise:m,dispose:()=>{this.result=null,A.cancel(),A.dispose()}},this.result}}t.Cache=N;class x{constructor(A,m=JSON.stringify){this.fn=A,this._computeKey=m,this.lastCache=void 0,this.lastArgKey=void 0}get(A){const m=this._computeKey(A);return this.lastArgKey!==m&&(this.lastArgKey=m,this.lastCache=this.fn(A)),this.lastCache}}t.LRUCachedFunction=x;class V{get cachedValues(){return this._map}constructor(A){this.fn=A,this._map=new Map}get(A){if(this._map.has(A))return this._map.get(A);const m=this.fn(A);return this._map.set(A,m),m}}t.CachedFunction=V}),define(ge[96],pe([1,0,40,33,41,28,26]),function(ie,t,s,N,x,V,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObservableLazyPromise=t.PromiseResult=t.ObservablePromise=t.ObservableLazy=void 0,t.waitForState=W,t.derivedWithCancellationToken=h;class A{get cachedValue(){return this._value}constructor(e){this._computeValue=e,this._value=(0,N.observableValue)(this,void 0)}getValue(){let e=this._value.get();return e||(e=this._computeValue(),this._value.set(e,void 0)),e}}t.ObservableLazy=A;class m{constructor(e){this._value=(0,N.observableValue)(this,void 0),this.promiseResult=this._value,this.promise=e.then(i=>((0,N.transaction)(r=>{this._value.set(new p(i,void 0),r)}),i),i=>{throw(0,N.transaction)(r=>{this._value.set(new p(void 0,i),r)}),i})}}t.ObservablePromise=m;class p{constructor(e,i){this.data=e,this.error=i}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.PromiseResult=p;class w{constructor(e){this._computePromise=e,this._lazyValue=new A(()=>new m(this._computePromise())),this.cachedPromiseResult=(0,x.derived)(this,i=>this._lazyValue.cachedValue.read(i)?.promiseResult.read(i))}getPromise(){return this._lazyValue.getValue().promise}}t.ObservableLazyPromise=w;function W(d,e,i){return new Promise((r,u)=>{let g=!0,D=!1;const a=d.map(o=>({isFinished:e(o),error:i?i(o):!1,state:o})),f=(0,s.autorun)(o=>{const{isFinished:C,error:F,state:R}=a.read(o);(C||F)&&(g?D=!0:f.dispose(),F?u(F===!0?R:F):r(R))});g=!1,D&&f.dispose()})}function h(d,e){let i,r;e===void 0?(i=d,r=void 0):(r=d,i=e);let u;return new x.Derived(new _.DebugNameData(r,void 0,i),g=>(u&&u.dispose(!0),u=new V.CancellationTokenSource,i(g,u.token)),void 0,void 0,()=>u?.dispose(),x.defaultEqualityComparer)}}),define(ge[57],pe([1,0,33,41,40,92,96,27]),function(ie,t,s,N,x,V,_,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return s.observableValue}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return s.disposableObservableValue}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return s.transaction}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return s.subtransaction}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return N.derived}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return N.derivedOpts}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return N.derivedHandleChanges}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return N.derivedWithStore}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return x.autorun}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return x.autorunDelta}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return x.autorunHandleChanges}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return x.autorunWithStore}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return x.autorunOpts}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return x.autorunWithStoreHandleChanges}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return V.constObservable}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return V.debouncedObservable}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return V.derivedObservableWithCache}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return V.derivedObservableWithWritableCache}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return V.keepObserved}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return V.recomputeInitiallyAndOnChange}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return V.observableFromEvent}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return V.observableFromPromise}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return V.observableSignal}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return V.observableSignalFromEvent}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return V.wasEventTriggeredRecently}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return _.ObservableLazy}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return _.ObservableLazyPromise}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return _.ObservablePromise}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return _.PromiseResult}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return _.waitForState}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return _.derivedWithCancellationToken}}),!1&&(0,A.setLogger)(new A.ConsoleObservableLogger)}),define(ge[58],pe([1,0,4,2]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var x;(function(d){d[d.Auto=1]="Auto",d[d.Hidden=2]="Hidden",d[d.Visible=3]="Visible"})(x||(t.ScrollbarVisibility=x={}));class V{constructor(e,i,r,u,g,D,a){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(i=i|0,r=r|0,u=u|0,g=g|0,D=D|0,a=a|0),this.rawScrollLeft=u,this.rawScrollTop=a,i<0&&(i=0),u+i>r&&(u=r-i),u<0&&(u=0),g<0&&(g=0),a+g>D&&(a=D-g),a<0&&(a=0),this.width=i,this.scrollWidth=r,this.scrollLeft=u,this.height=g,this.scrollHeight=D,this.scrollTop=a}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,i){return new V(this._forceIntegerValues,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,i?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,i?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new V(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,i){const r=this.width!==e.width,u=this.scrollWidth!==e.scrollWidth,g=this.scrollLeft!==e.scrollLeft,D=this.height!==e.height,a=this.scrollHeight!==e.scrollHeight,f=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:i,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:r,scrollWidthChanged:u,scrollLeftChanged:g,heightChanged:D,scrollHeightChanged:a,scrollTopChanged:f}}}t.ScrollState=V;class _ extends N.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new s.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new V(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,i){const r=this._state.withScrollDimensions(e,i);this._setState(r,!!this._smoothScrolling),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const i=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(i,!1)}setScrollPositionSmooth(e,i){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this._smoothScrolling.to.scrollTop:e.scrollTop};const r=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===r.scrollLeft&&this._smoothScrolling.to.scrollTop===r.scrollTop)return;let u;i?u=new w(this._smoothScrolling.from,r,this._smoothScrolling.startTime,this._smoothScrolling.duration):u=this._smoothScrolling.combine(this._state,r,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=u}else{const r=this._state.withScrollPosition(e);this._smoothScrolling=w.start(this._state,r,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}hasPendingScrollAnimation(){return!!this._smoothScrolling}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),i=this._state.withScrollPosition(e);if(this._setState(i,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{this._smoothScrolling&&(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,i){const r=this._state;r.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(r,i)))}}t.Scrollable=_;class A{constructor(e,i,r){this.scrollLeft=e,this.scrollTop=i,this.isDone=r}}t.SmoothScrollingUpdate=A;function m(d,e){const i=e-d;return function(r){return d+i*h(r)}}function p(d,e,i){return function(r){return r<i?d(r/i):e((r-i)/(1-i))}}class w{constructor(e,i,r,u){this.from=e,this.to=i,this.duration=u,this.startTime=r,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,i,r){if(Math.abs(e-i)>2.5*r){let g,D;return e<i?(g=e+.75*r,D=i-.75*r):(g=e-.75*r,D=i+.75*r),p(m(e,g),m(D,i),.33)}return m(e,i)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const i=(e-this.startTime)/this.duration;if(i<1){const r=this.scrollLeft(i),u=this.scrollTop(i);return new A(r,u,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,i,r){return w.start(e,i,r)}static start(e,i,r){r=r+10;const u=Date.now()-10;return new w(e,i,u,r)}}t.SmoothScrollingOperation=w;function W(d){return Math.pow(d,3)}function h(d){return 1-W(1-d)}}),define(ge[97],pe([1,0,6,2]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isReadable=x,t.isReadableStream=V,t.isReadableBufferedStream=_,t.newWriteableStream=A,t.consumeReadable=p,t.peekReadable=w,t.consumeStream=W,t.listenStream=h,t.peekStream=d,t.toStream=e,t.emptyStream=i,t.toReadable=r,t.transform=u,t.prefixedReadable=g,t.prefixedStream=D;function x(a){const f=a;return f?typeof f.read=="function":!1}function V(a){const f=a;return f?[f.on,f.pause,f.resume,f.destroy].every(o=>typeof o=="function"):!1}function _(a){const f=a;return f?V(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}function A(a,f){return new m(a,f)}class m{constructor(f,o){this.reducer=f,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f<"u"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(o=>o(f))}emitError(f){this.listeners.error.length===0?(0,s.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(o=>o(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,o){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(f,o){if(this.state.destroyed)return;let C;switch(f){case"data":C=this.listeners.data;break;case"end":C=this.listeners.end;break;case"error":C=this.listeners.error;break}if(C){const F=C.indexOf(o);F>=0&&C.splice(F,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(C=>C())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(a,f){const o=[];let C;for(;(C=a.read())!==null;)o.push(C);return f(o)}function w(a,f,o){const C=[];let F;for(;(F=a.read())!==null&&C.length<o;)C.push(F);return F===null&&C.length>0?f(C):{read:()=>{if(C.length>0)return C.shift();if(typeof F<"u"){const R=F;return F=void 0,R}return a.read()}}}function W(a,f){return new Promise((o,C)=>{const F=[];h(a,{onData:R=>{f&&F.push(R)},onError:R=>{f?C(R):o(void 0)},onEnd:()=>{o(f?f(F):void 0)}})})}function h(a,f,o){a.on("error",C=>{o?.isCancellationRequested||f.onError(C)}),a.on("end",()=>{o?.isCancellationRequested||f.onEnd()}),a.on("data",C=>{o?.isCancellationRequested||f.onData(C)})}function d(a,f){return new Promise((o,C)=>{const F=new N.DisposableStore,R=[],B=O=>{if(R.push(O),R.length>f)return F.dispose(),a.pause(),o({stream:a,buffer:R,ended:!1})},P=O=>(F.dispose(),C(O)),b=()=>(F.dispose(),o({stream:a,buffer:R,ended:!0}));F.add((0,N.toDisposable)(()=>a.removeListener("error",P))),a.on("error",P),F.add((0,N.toDisposable)(()=>a.removeListener("end",b))),a.on("end",b),F.add((0,N.toDisposable)(()=>a.removeListener("data",B))),a.on("data",B)})}function e(a,f){const o=A(f);return o.end(a),o}function i(){const a=A(()=>{throw new Error("not supported")});return a.end(),a}function r(a){let f=!1;return{read:()=>f?null:(f=!0,a)}}function u(a,f,o){const C=A(o);return h(a,{onData:F=>C.write(f.data(F)),onError:F=>C.error(f.error?f.error(F):F),onEnd:()=>C.end()}),C}function g(a,f,o){let C=!1;return{read:()=>{const F=f.read();return C?F:(C=!0,F!==null?o([a,F]):a)}}}function D(a,f,o){let C=!1;const F=A(o);return h(f,{onData:R=>C?F.write(R):(C=!0,F.write(o([a,R]))),onError:R=>F.error(R),onEnd:()=>{C||(C=!0,F.write(a)),F.end()}}),F}}),define(ge[42],pe([1,0,23,97]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VSBuffer=void 0,t.binaryIndexOf=p,t.readUInt16LE=w,t.writeUInt16LE=W,t.readUInt32BE=h,t.writeUInt32BE=d,t.readUInt32LE=e,t.writeUInt32LE=i,t.readUInt8=r,t.writeUInt8=u,t.readableToBuffer=g,t.bufferToReadable=D,t.streamToBuffer=a,t.bufferedStreamToBuffer=f,t.bufferToStream=o,t.streamToBufferReadableStream=C,t.newWriteableBufferStream=F,t.prefixedBufferReadable=R,t.prefixedBufferStream=B,t.decodeBase64=P,t.encodeBase64=$;const x=typeof Buffer<"u",V=new s.Lazy(()=>new Uint8Array(256));let _,A;class m{static alloc(M){return x?new m(Buffer.allocUnsafe(M)):new m(new Uint8Array(M))}static wrap(M){return x&&!Buffer.isBuffer(M)&&(M=Buffer.from(M.buffer,M.byteOffset,M.byteLength)),new m(M)}static fromString(M,I){return!(I?.dontUseNodeBuffer||!1)&&x?new m(Buffer.from(M)):(_||(_=new TextEncoder),new m(_.encode(M)))}static fromByteArray(M){const I=m.alloc(M.length);for(let q=0,X=M.length;q<X;q++)I.buffer[q]=M[q];return I}static concat(M,I){if(typeof I>"u"){I=0;for(let ce=0,re=M.length;ce<re;ce++)I+=M[ce].byteLength}const q=m.alloc(I);let X=0;for(let ce=0,re=M.length;ce<re;ce++){const te=M[ce];q.set(te,X),X+=te.byteLength}return q}constructor(M){this.buffer=M,this.byteLength=this.buffer.byteLength}clone(){const M=m.alloc(this.byteLength);return M.set(this),M}toString(){return x?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(M,I){return new m(this.buffer.subarray(M,I))}set(M,I){if(M instanceof m)this.buffer.set(M.buffer,I);else if(M instanceof Uint8Array)this.buffer.set(M,I);else if(M instanceof ArrayBuffer)this.buffer.set(new Uint8Array(M),I);else if(ArrayBuffer.isView(M))this.buffer.set(new Uint8Array(M.buffer,M.byteOffset,M.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(M){return h(this.buffer,M)}writeUInt32BE(M,I){d(this.buffer,M,I)}readUInt32LE(M){return e(this.buffer,M)}writeUInt32LE(M,I){i(this.buffer,M,I)}readUInt8(M){return r(this.buffer,M)}writeUInt8(M,I){u(this.buffer,M,I)}indexOf(M,I=0){return p(this.buffer,M instanceof m?M.buffer:M,I)}}t.VSBuffer=m;function p(k,M,I=0){const q=M.byteLength,X=k.byteLength;if(q===0)return 0;if(q===1)return k.indexOf(M[0]);if(q>X-I)return-1;const ce=V.value;ce.fill(M.length);for(let Ee=0;Ee<M.length;Ee++)ce[M[Ee]]=M.length-Ee-1;let re=I+M.length-1,te=re,be=-1;for(;re<X;)if(k[re]===M[te]){if(te===0){be=re;break}re--,te--}else re+=Math.max(M.length-te,ce[k[re]]),te=M.length-1;return be}function w(k,M){return k[M+0]<<0>>>0|k[M+1]<<8>>>0}function W(k,M,I){k[I+0]=M&255,M=M>>>8,k[I+1]=M&255}function h(k,M){return k[M]*2**24+k[M+1]*2**16+k[M+2]*2**8+k[M+3]}function d(k,M,I){k[I+3]=M,M=M>>>8,k[I+2]=M,M=M>>>8,k[I+1]=M,M=M>>>8,k[I]=M}function e(k,M){return k[M+0]<<0>>>0|k[M+1]<<8>>>0|k[M+2]<<16>>>0|k[M+3]<<24>>>0}function i(k,M,I){k[I+0]=M&255,M=M>>>8,k[I+1]=M&255,M=M>>>8,k[I+2]=M&255,M=M>>>8,k[I+3]=M&255}function r(k,M){return k[M]}function u(k,M,I){k[I]=M}function g(k){return N.consumeReadable(k,M=>m.concat(M))}function D(k){return N.toReadable(k)}function a(k){return N.consumeStream(k,M=>m.concat(M))}async function f(k){return k.ended?m.concat(k.buffer):m.concat([...k.buffer,await a(k.stream)])}function o(k){return N.toStream(k,M=>m.concat(M))}function C(k){return N.transform(k,{data:M=>typeof M=="string"?m.fromString(M):m.wrap(M)},M=>m.concat(M))}function F(k){return N.newWriteableStream(M=>m.concat(M),k)}function R(k,M){return N.prefixedReadable(k,M,I=>m.concat(I))}function B(k,M){return N.prefixedStream(k,M,I=>m.concat(I))}function P(k){let M=0,I=0,q=0;const X=new Uint8Array(Math.floor(k.length/4*3)),ce=te=>{switch(I){case 3:X[q++]=M|te,I=0;break;case 2:X[q++]=M|te>>>2,M=te<<6,I=3;break;case 1:X[q++]=M|te>>>4,M=te<<4,I=2;break;default:M=te<<2,I=1}};for(let te=0;te<k.length;te++){const be=k.charCodeAt(te);if(be>=65&&be<=90)ce(be-65);else if(be>=97&&be<=122)ce(be-97+26);else if(be>=48&&be<=57)ce(be-48+52);else if(be===43||be===45)ce(62);else if(be===47||be===95)ce(63);else{if(be===61)break;throw new SyntaxError(`Unexpected base64 character ${k[te]}`)}}const re=q;for(;I>0;)ce(0);return m.wrap(X).slice(0,re)}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function $({buffer:k},M=!0,I=!1){const q=I?O:b;let X="";const ce=k.byteLength%3;let re=0;for(;re<k.byteLength-ce;re+=3){const te=k[re+0],be=k[re+1],Ee=k[re+2];X+=q[te>>>2],X+=q[(te<<4|be>>>4)&63],X+=q[(be<<2|Ee>>>6)&63],X+=q[Ee&63]}if(ce===1){const te=k[re+0];X+=q[te>>>2],X+=q[te<<4&63],M&&(X+="==")}else if(ce===2){const te=k[re+0],be=k[re+1];X+=q[te>>>2],X+=q[(te<<4|be>>>4)&63],X+=q[be<<2&63],M&&(X+="=")}return X}}),define(ge[10],pe([1,0,95,23]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.GraphemeBreakType=t.UTF8_BOM_CHARACTER=t.UNUSUAL_LINE_TERMINATORS=t.GraphemeIterator=t.CodePointIterator=void 0,t.isFalsyOrWhitespace=x,t.format=_,t.format2=m,t.htmlAttributeEncodeValue=p,t.escape=w,t.escapeRegExpCharacters=W,t.count=h,t.truncate=d,t.truncateMiddle=e,t.trim=i,t.ltrim=r,t.rtrim=u,t.convertSimple2RegExpPattern=g,t.stripWildcards=D,t.createRegExp=a,t.regExpLeadsToEndlessLoop=f,t.splitLines=o,t.splitLinesIncludeSeparators=C,t.firstNonWhitespaceIndex=F,t.getLeadingWhitespace=R,t.lastNonWhitespaceIndex=B,t.replaceAsync=P,t.compare=b,t.compareSubstring=O,t.compareIgnoreCase=$,t.compareSubstringIgnoreCase=k,t.isAsciiDigit=M,t.isLowerAsciiLetter=I,t.isUpperAsciiLetter=q,t.equalsIgnoreCase=X,t.startsWithIgnoreCase=ce,t.commonPrefixLength=re,t.commonSuffixLength=te,t.isHighSurrogate=be,t.isLowSurrogate=Ee,t.computeCodePoint=Ie,t.getNextCodePoint=Be,t.nextCharLength=ae,t.prevCharLength=Z,t.getCharContainingOffset=G,t.charCount=ne,t.containsRTL=Fe,t.isBasicASCII=Pe,t.containsUnusualLineTerminators=H,t.isFullWidthCharacter=c,t.isEmojiImprecise=E,t.lcut=l,t.forAnsiStringParts=T,t.removeAnsiEscapeCodes=n,t.startsWithUTF8BOM=S,t.stripUTF8BOM=y,t.fuzzyContains=L,t.containsUppercaseCharacter=z,t.uppercaseFirstLetter=Y,t.getNLines=Q,t.singleLetterHash=oe,t.getGraphemeBreakType=De,t.getLeftDeleteOffset=Se;function x(U){return!U||typeof U!="string"?!0:U.trim().length===0}const V=/{(\d+)}/g;function _(U,...se){return se.length===0?U:U.replace(V,function(ve,ye){const Le=parseInt(ye,10);return isNaN(Le)||Le<0||Le>=se.length?ve:se[Le]})}const A=/{([^}]+)}/g;function m(U,se){return Object.keys(se).length===0?U:U.replace(A,(ve,ye)=>se[ye]??ve)}function p(U){return U.replace(/[<>"'&]/g,se=>{switch(se){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return se})}function w(U){return U.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}function W(U){return U.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function h(U,se){let ve=0;const ye=se.charCodeAt(0);for(let Le=U.length-1;Le>=0;Le--)U.charCodeAt(Le)===ye&&ve++;return ve}function d(U,se,ve="\u2026"){return U.length<=se?U:`${U.substr(0,se)}${ve}`}function e(U,se,ve="\u2026"){if(U.length<=se)return U;const ye=Math.ceil(se/2)-ve.length/2,Le=Math.floor(se/2)-ve.length/2;return`${U.substr(0,ye)}${ve}${U.substr(U.length-Le)}`}function i(U,se=" "){const ve=r(U,se);return u(ve,se)}function r(U,se){if(!U||!se)return U;const ve=se.length;if(ve===0||U.length===0)return U;let ye=0;for(;U.indexOf(se,ye)===ye;)ye=ye+ve;return U.substring(ye)}function u(U,se){if(!U||!se)return U;const ve=se.length,ye=U.length;if(ve===0||ye===0)return U;let Le=ye,He=-1;for(;He=U.lastIndexOf(se,Le-1),!(He===-1||He+ve!==Le);){if(He===0)return"";Le=He}return U.substring(0,Le)}function g(U){return U.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function D(U){return U.replace(/\*/g,"")}function a(U,se,ve={}){if(!U)throw new Error("Cannot create regex from empty string");se||(U=W(U)),ve.wholeWord&&(/\B/.test(U.charAt(0))||(U="\\b"+U),/\B/.test(U.charAt(U.length-1))||(U=U+"\\b"));let ye="";return ve.global&&(ye+="g"),ve.matchCase||(ye+="i"),ve.multiline&&(ye+="m"),ve.unicode&&(ye+="u"),new RegExp(U,ye)}function f(U){return U.source==="^"||U.source==="^$"||U.source==="$"||U.source==="^\\s*$"?!1:!!(U.exec("")&&U.lastIndex===0)}function o(U){return U.split(/\r\n|\r|\n/)}function C(U){const se=[],ve=U.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(ve.length/2);ye++)se.push(ve[2*ye]+(ve[2*ye+1]??""));return se}function F(U){for(let se=0,ve=U.length;se<ve;se++){const ye=U.charCodeAt(se);if(ye!==32&&ye!==9)return se}return-1}function R(U,se=0,ve=U.length){for(let ye=se;ye<ve;ye++){const Le=U.charCodeAt(ye);if(Le!==32&&Le!==9)return U.substring(se,ye)}return U.substring(se,ve)}function B(U,se=U.length-1){for(let ve=se;ve>=0;ve--){const ye=U.charCodeAt(ve);if(ye!==32&&ye!==9)return ve}return-1}function P(U,se,ve){const ye=[];let Le=0;for(const He of U.matchAll(se)){if(ye.push(U.slice(Le,He.index)),He.index===void 0)throw new Error("match.index should be defined");Le=He.index+He[0].length,ye.push(ve(He[0],...He.slice(1),He.index,U,He.groups))}return ye.push(U.slice(Le)),Promise.all(ye).then(He=>He.join(""))}function b(U,se){return U<se?-1:U>se?1:0}function O(U,se,ve=0,ye=U.length,Le=0,He=se.length){for(;ve<ye&&Le<He;ve++,Le++){const it=U.charCodeAt(ve),nt=se.charCodeAt(Le);if(it<nt)return-1;if(it>nt)return 1}const $e=ye-ve,et=He-Le;return $e<et?-1:$e>et?1:0}function $(U,se){return k(U,se,0,U.length,0,se.length)}function k(U,se,ve=0,ye=U.length,Le=0,He=se.length){for(;ve<ye&&Le<He;ve++,Le++){let it=U.charCodeAt(ve),nt=se.charCodeAt(Le);if(it===nt)continue;if(it>=128||nt>=128)return O(U.toLowerCase(),se.toLowerCase(),ve,ye,Le,He);I(it)&&(it-=32),I(nt)&&(nt-=32);const Ze=it-nt;if(Ze!==0)return Ze}const $e=ye-ve,et=He-Le;return $e<et?-1:$e>et?1:0}function M(U){return U>=48&&U<=57}function I(U){return U>=97&&U<=122}function q(U){return U>=65&&U<=90}function X(U,se){return U.length===se.length&&k(U,se)===0}function ce(U,se){const ve=se.length;return se.length>U.length?!1:k(U,se,0,ve)===0}function re(U,se){const ve=Math.min(U.length,se.length);let ye;for(ye=0;ye<ve;ye++)if(U.charCodeAt(ye)!==se.charCodeAt(ye))return ye;return ve}function te(U,se){const ve=Math.min(U.length,se.length);let ye;const Le=U.length-1,He=se.length-1;for(ye=0;ye<ve;ye++)if(U.charCodeAt(Le-ye)!==se.charCodeAt(He-ye))return ye;return ve}function be(U){return 55296<=U&&U<=56319}function Ee(U){return 56320<=U&&U<=57343}function Ie(U,se){return(U-55296<<10)+(se-56320)+65536}function Be(U,se,ve){const ye=U.charCodeAt(ve);if(be(ye)&&ve+1<se){const Le=U.charCodeAt(ve+1);if(Ee(Le))return Ie(ye,Le)}return ye}function ue(U,se){const ve=U.charCodeAt(se-1);if(Ee(ve)&&se>1){const ye=U.charCodeAt(se-2);if(be(ye))return Ie(ye,ve)}return ve}class J{get offset(){return this._offset}constructor(se,ve=0){this._str=se,this._len=se.length,this._offset=ve}setOffset(se){this._offset=se}prevCodePoint(){const se=ue(this._str,this._offset);return this._offset-=se>=65536?2:1,se}nextCodePoint(){const se=Be(this._str,this._len,this._offset);return this._offset+=se>=65536?2:1,se}eol(){return this._offset>=this._len}}t.CodePointIterator=J;class le{get offset(){return this._iterator.offset}constructor(se,ve=0){this._iterator=new J(se,ve)}nextGraphemeLength(){const se=Ae.getInstance(),ve=this._iterator,ye=ve.offset;let Le=se.getGraphemeBreakType(ve.nextCodePoint());for(;!ve.eol();){const He=ve.offset,$e=se.getGraphemeBreakType(ve.nextCodePoint());if(me(Le,$e)){ve.setOffset(He);break}Le=$e}return ve.offset-ye}prevGraphemeLength(){const se=Ae.getInstance(),ve=this._iterator,ye=ve.offset;let Le=se.getGraphemeBreakType(ve.prevCodePoint());for(;ve.offset>0;){const He=ve.offset,$e=se.getGraphemeBreakType(ve.prevCodePoint());if(me($e,Le)){ve.setOffset(He);break}Le=$e}return ye-ve.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=le;function ae(U,se){return new le(U,se).nextGraphemeLength()}function Z(U,se){return new le(U,se).prevGraphemeLength()}function G(U,se){se>0&&Ee(U.charCodeAt(se))&&se--;const ve=se+ae(U,se);return[ve-Z(U,ve),ve]}function ne(U){const se=new le(U);let ve=0;for(;!se.eol();)ve++,se.nextGraphemeLength();return ve}let de;function we(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Fe(U){return de||(de=we()),de.test(U)}const _e=/^[\t\n\r\x20-\x7E]*$/;function Pe(U){return _e.test(U)}t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function H(U){return t.UNUSUAL_LINE_TERMINATORS.test(U)}function c(U){return U>=11904&&U<=55215||U>=63744&&U<=64255||U>=65281&&U<=65374}function E(U){return U>=127462&&U<=127487||U===8986||U===8987||U===9200||U===9203||U>=9728&&U<=10175||U===11088||U===11093||U>=127744&&U<=128591||U>=128640&&U<=128764||U>=128992&&U<=129008||U>=129280&&U<=129535||U>=129648&&U<=129782}function l(U,se,ve=""){const ye=U.trimStart();if(ye.length<se)return ye;const Le=/\b/g;let He=0;for(;Le.test(ye)&&!(ye.length-Le.lastIndex<se);)He=Le.lastIndex,Le.lastIndex+=1;return He===0?ye:ve+ye.substring(He).trimStart()}const v=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*T(U){let se=0;for(const ve of U.matchAll(v))se!==ve.index&&(yield{isCode:!1,str:U.substring(se,ve.index)}),yield{isCode:!0,str:ve[0]},se=ve.index+ve[0].length;se!==U.length&&(yield{isCode:!1,str:U.substring(se)})}function n(U){return U&&(U=U.replace(v,"")),U}t.UTF8_BOM_CHARACTER="\uFEFF";function S(U){return!!(U&&U.length>0&&U.charCodeAt(0)===65279)}function y(U){return S(U)?U.substr(1):U}function L(U,se){if(!U||!se||U.length<se.length)return!1;const ve=se.length,ye=U.toLowerCase();let Le=0,He=-1;for(;Le<ve;){const $e=ye.indexOf(se[Le],He+1);if($e<0)return!1;He=$e,Le++}return!0}function z(U,se=!1){return U?(se&&(U=U.replace(/\\./g,"")),U.toLowerCase()!==U):!1}function Y(U){return U.charAt(0).toUpperCase()+U.slice(1)}function Q(U,se=1){if(se===0)return"";let ve=-1;do ve=U.indexOf(`
`,ve+1),se--;while(se>0&&ve>=0);return ve===-1?U:(U[ve-1]==="\r"&&ve--,U.substr(0,ve))}function oe(U){return U=U%(2*26),U<26?String.fromCharCode(97+U):String.fromCharCode(65+U-26)}function De(U){return Ae.getInstance().getGraphemeBreakType(U)}function me(U,se){return U===0?se!==5&&se!==7:U===2&&se===3?!1:U===4||U===2||U===3||se===4||se===2||se===3?!0:!(U===8&&(se===8||se===9||se===11||se===12)||(U===11||U===9)&&(se===9||se===10)||(U===12||U===10)&&se===10||se===5||se===13||se===7||U===1||U===13&&se===14||U===6&&se===6)}var ke;(function(U){U[U.Other=0]="Other",U[U.Prepend=1]="Prepend",U[U.CR=2]="CR",U[U.LF=3]="LF",U[U.Control=4]="Control",U[U.Extend=5]="Extend",U[U.Regional_Indicator=6]="Regional_Indicator",U[U.SpacingMark=7]="SpacingMark",U[U.L=8]="L",U[U.V=9]="V",U[U.T=10]="T",U[U.LV=11]="LV",U[U.LVT=12]="LVT",U[U.ZWJ=13]="ZWJ",U[U.Extended_Pictographic=14]="Extended_Pictographic"})(ke||(t.GraphemeBreakType=ke={}));class Ae{static{this._INSTANCE=null}static getInstance(){return Ae._INSTANCE||(Ae._INSTANCE=new Ae),Ae._INSTANCE}constructor(){this._data=Me()}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ve=this._data,ye=ve.length/3;let Le=1;for(;Le<=ye;)if(se<ve[3*Le])Le=2*Le;else if(se>ve[3*Le+1])Le=2*Le+1;else return ve[3*Le+2];return 0}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Se(U,se){if(U===0)return 0;const ve=Te(U,se);if(ve!==void 0)return ve;const ye=new J(se,U);return ye.prevCodePoint(),ye.offset}function Te(U,se){const ve=new J(se,U);let ye=ve.prevCodePoint();for(;Ve(ye)||ye===65039||ye===8419;){if(ve.offset===0)return;ye=ve.prevCodePoint()}if(!E(ye))return;let Le=ve.offset;return Le>0&&ve.prevCodePoint()===8205&&(Le=ve.offset),Le}function Ve(U){return 127995<=U&&U<=127999}var Qe;(function(U){U[U.zwj=8205]="zwj",U[U.emojiVariantSelector=65039]="emojiVariantSelector",U[U.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),t.noBreakWhitespace="\xA0";class Ue{static{this.ambiguousCharacterData=new N.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new s.LRUCachedFunction(se=>{function ve(Ze){const rt=new Map;for(let tt=0;tt<Ze.length;tt+=2)rt.set(Ze[tt],Ze[tt+1]);return rt}function ye(Ze,rt){const tt=new Map(Ze);for(const[mt,gt]of rt)tt.set(mt,gt);return tt}function Le(Ze,rt){if(!Ze)return rt;const tt=new Map;for(const[mt,gt]of Ze)rt.has(mt)&&tt.set(mt,gt);return tt}const He=this.ambiguousCharacterData.value;let $e=se.filter(Ze=>!Ze.startsWith("_")&&Ze in He);$e.length===0&&($e=["_default"]);let et;for(const Ze of $e){const rt=ve(He[Ze]);et=Le(et,rt)}const it=ve(He._common),nt=ye(it,et);return new Ue(nt)})}static getInstance(se){return Ue.cache.get(Array.from(se))}static{this._locales=new N.Lazy(()=>Object.keys(Ue.ambiguousCharacterData.value).filter(se=>!se.startsWith("_")))}static getLocales(){return Ue._locales.value}constructor(se){this.confusableDictionary=se}isAmbiguous(se){return this.confusableDictionary.has(se)}getPrimaryConfusable(se){return this.confusableDictionary.get(se)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=Ue;class Je{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Je.getRawData())),this._data}static isInvisibleCharacter(se){return Je.getData().has(se)}static get codePoints(){return Je.getData()}}t.InvisibleCharacters=Je}),define(ge[43],pe([1,0,38,89,10]),function(ie,t,s,N,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FuzzyScoreOptions=t.FuzzyScore=t.matchesPrefix=t.matchesStrictPrefix=void 0,t.or=V,t.matchesContiguousSubString=A,t.matchesSubString=m,t.isUpper=W,t.matchesCamelCase=P,t.matchesWords=b,t.matchesFuzzy=q,t.matchesFuzzy2=X,t.anyScore=ce,t.createMatches=re,t.isPatternInWord=Fe,t.fuzzyScore=c,t.fuzzyScoreGracefulAggressive=v,t.fuzzyScoreGraceful=T;function V(...y){return function(L,z){for(let Y=0,Q=y.length;Y<Q;Y++){const oe=y[Y](L,z);if(oe)return oe}return null}}t.matchesStrictPrefix=_.bind(void 0,!1),t.matchesPrefix=_.bind(void 0,!0);function _(y,L,z){if(!z||z.length<L.length)return null;let Y;return y?Y=x.startsWithIgnoreCase(z,L):Y=z.indexOf(L)===0,Y?L.length>0?[{start:0,end:L.length}]:[]:null}function A(y,L){const z=L.toLowerCase().indexOf(y.toLowerCase());return z===-1?null:[{start:z,end:z+y.length}]}function m(y,L){return p(y.toLowerCase(),L.toLowerCase(),0,0)}function p(y,L,z,Y){if(z===y.length)return[];if(Y===L.length)return null;if(y[z]===L[Y]){let Q=null;return(Q=p(y,L,z+1,Y+1))?a({start:Y,end:Y+1},Q):null}return p(y,L,z,Y+1)}function w(y){return 97<=y&&y<=122}function W(y){return 65<=y&&y<=90}function h(y){return 48<=y&&y<=57}function d(y){return y===32||y===9||y===10||y===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(y=>e.add(y.charCodeAt(0)));function i(y){return d(y)||e.has(y)}function r(y,L){return y===L||i(y)&&i(L)}const u=new Map;function g(y){if(u.has(y))return u.get(y);let L;const z=(0,N.getKoreanAltChars)(y);return z&&(L=z),u.set(y,L),L}function D(y){return w(y)||W(y)||h(y)}function a(y,L){return L.length===0?L=[y]:y.end===L[0].start?L[0].start=y.start:L.unshift(y),L}function f(y,L){for(let z=L;z<y.length;z++){const Y=y.charCodeAt(z);if(W(Y)||h(Y)||z>0&&!D(y.charCodeAt(z-1)))return z}return y.length}function o(y,L,z,Y){if(z===y.length)return[];if(Y===L.length)return null;if(y[z]!==L[Y].toLowerCase())return null;{let Q=null,oe=Y+1;for(Q=o(y,L,z+1,Y+1);!Q&&(oe=f(L,oe))<L.length;)Q=o(y,L,z+1,oe),oe++;return Q===null?null:a({start:Y,end:Y+1},Q)}}function C(y){let L=0,z=0,Y=0,Q=0,oe=0;for(let Me=0;Me<y.length;Me++)oe=y.charCodeAt(Me),W(oe)&&L++,w(oe)&&z++,D(oe)&&Y++,h(oe)&&Q++;const De=L/y.length,me=z/y.length,ke=Y/y.length,Ae=Q/y.length;return{upperPercent:De,lowerPercent:me,alphaPercent:ke,numericPercent:Ae}}function F(y){const{upperPercent:L,lowerPercent:z}=y;return z===0&&L>.6}function R(y){const{upperPercent:L,lowerPercent:z,alphaPercent:Y,numericPercent:Q}=y;return z>.2&&L<.8&&Y>.6&&Q<.2}function B(y){let L=0,z=0,Y=0,Q=0;for(let oe=0;oe<y.length;oe++)Y=y.charCodeAt(oe),W(Y)&&L++,w(Y)&&z++,d(Y)&&Q++;return(L===0||z===0)&&Q===0?y.length<=30:L<=5}function P(y,L){if(!L||(L=L.trim(),L.length===0)||!B(y))return null;L.length>60&&(L=L.substring(0,60));const z=C(L);if(!R(z)){if(!F(z))return null;L=L.toLowerCase()}let Y=null,Q=0;for(y=y.toLowerCase();Q<L.length&&(Y=o(y,L,0,Q))===null;)Q=f(L,Q+1);return Y}function b(y,L,z=!1){if(!L||L.length===0)return null;let Y=null,Q=0;for(y=y.toLowerCase(),L=L.toLowerCase();Q<L.length&&(Y=O(y,L,0,Q,z),Y===null);)Q=$(L,Q+1);return Y}function O(y,L,z,Y,Q){let oe=0;if(z===y.length)return[];if(Y===L.length)return null;if(!r(y.charCodeAt(z),L.charCodeAt(Y))){const ke=g(y.charCodeAt(z));if(!ke)return null;for(let Ae=0;Ae<ke.length;Ae++)if(!r(ke[Ae],L.charCodeAt(Y+Ae)))return null;oe+=ke.length-1}let De=null,me=Y+oe+1;if(De=O(y,L,z+1,me,Q),!Q)for(;!De&&(me=$(L,me))<L.length;)De=O(y,L,z+1,me,Q),me++;if(!De)return null;if(y.charCodeAt(z)!==L.charCodeAt(Y)){const ke=g(y.charCodeAt(z));if(!ke)return De;for(let Ae=0;Ae<ke.length;Ae++)if(ke[Ae]!==L.charCodeAt(Y+Ae))return De}return a({start:Y,end:Y+oe+1},De)}function $(y,L){for(let z=L;z<y.length;z++)if(i(y.charCodeAt(z))||z>0&&i(y.charCodeAt(z-1)))return z;return y.length}const k=V(t.matchesPrefix,P,A),M=V(t.matchesPrefix,P,m),I=new s.LRUCache(1e4);function q(y,L,z=!1){if(typeof y!="string"||typeof L!="string")return null;let Y=I.get(y);Y||(Y=new RegExp(x.convertSimple2RegExpPattern(y),"i"),I.set(y,Y));const Q=Y.exec(L);return Q?[{start:Q.index,end:Q.index+Q[0].length}]:z?M(y,L):k(y,L)}function X(y,L){const z=c(y,y.toLowerCase(),0,L,L.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?re(z):null}function ce(y,L,z,Y,Q,oe){const De=Math.min(13,y.length);for(;z<De;z++){const me=c(y,L,z,Y,Q,oe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(me)return me}return[0,oe]}function re(y){if(typeof y>"u")return[];const L=[],z=y[1];for(let Y=y.length-1;Y>1;Y--){const Q=y[Y]+z,oe=L[L.length-1];oe&&oe.end===Q?oe.end=Q+1:L.push({start:Q,end:Q+1})}return L}const te=128;function be(){const y=[],L=[];for(let z=0;z<=te;z++)L[z]=0;for(let z=0;z<=te;z++)y.push(L.slice(0));return y}function Ee(y){const L=[];for(let z=0;z<=y;z++)L[z]=0;return L}const Ie=Ee(2*te),Be=Ee(2*te),ue=be(),J=be(),le=be(),ae=!1;function Z(y,L,z,Y,Q){function oe(me,ke,Ae=" "){for(;me.length<ke;)me=Ae+me;return me}let De=` |   |${Y.split("").map(me=>oe(me,3)).join("|")}
`;for(let me=0;me<=z;me++)me===0?De+=" |":De+=`${L[me-1]}|`,De+=y[me].slice(0,Q+1).map(ke=>oe(ke.toString(),3)).join("|")+`
`;return De}function G(y,L,z,Y){y=y.substr(L),z=z.substr(Y),console.log(Z(J,y,y.length,z,z.length)),console.log(Z(le,y,y.length,z,z.length)),console.log(Z(ue,y,y.length,z,z.length))}function ne(y,L){if(L<0||L>=y.length)return!1;const z=y.codePointAt(L);switch(z){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!x.isEmojiImprecise(z)}}function de(y,L){if(L<0||L>=y.length)return!1;switch(y.charCodeAt(L)){case 32:case 9:return!0;default:return!1}}function we(y,L,z){return L[y]!==z[y]}function Fe(y,L,z,Y,Q,oe,De=!1){for(;L<z&&Q<oe;)y[L]===Y[Q]&&(De&&(Ie[L]=Q),L+=1),Q+=1;return L===z}var _e;(function(y){y[y.Diag=1]="Diag",y[y.Left=2]="Left",y[y.LeftLeft=3]="LeftLeft"})(_e||(_e={}));var Pe;(function(y){y.Default=[-100,0];function L(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}y.isDefault=L})(Pe||(t.FuzzyScore=Pe={}));class H{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(L,z){this.firstMatchCanBeWeak=L,this.boostFullMatch=z}}t.FuzzyScoreOptions=H;function c(y,L,z,Y,Q,oe,De=H.default){const me=y.length>te?te:y.length,ke=Y.length>te?te:Y.length;if(z>=me||oe>=ke||me-z>ke-oe||!Fe(L,z,me,Q,oe,ke,!0))return;E(me,ke,z,oe,L,Q);let Ae=1,Me=1,Se=z,Te=oe;const Ve=[!1];for(Ae=1,Se=z;Se<me;Ae++,Se++){const se=Ie[Se],ve=Be[Se],ye=Se+1<me?Be[Se+1]:ke;for(Me=se-oe+1,Te=se;Te<ye;Me++,Te++){let Le=Number.MIN_SAFE_INTEGER,He=!1;Te<=ve&&(Le=l(y,L,Se,z,Y,Q,Te,ke,oe,ue[Ae-1][Me-1]===0,Ve));let $e=0;Le!==Number.MAX_SAFE_INTEGER&&(He=!0,$e=Le+J[Ae-1][Me-1]);const et=Te>se,it=et?J[Ae][Me-1]+(ue[Ae][Me-1]>0?-5:0):0,nt=Te>se+1&&ue[Ae][Me-1]>0,Ze=nt?J[Ae][Me-2]+(ue[Ae][Me-2]>0?-5:0):0;if(nt&&(!et||Ze>=it)&&(!He||Ze>=$e))J[Ae][Me]=Ze,le[Ae][Me]=3,ue[Ae][Me]=0;else if(et&&(!He||it>=$e))J[Ae][Me]=it,le[Ae][Me]=2,ue[Ae][Me]=0;else if(He)J[Ae][Me]=$e,le[Ae][Me]=1,ue[Ae][Me]=ue[Ae-1][Me-1]+1;else throw new Error("not possible")}}if(ae&&G(y,z,Y,oe),!Ve[0]&&!De.firstMatchCanBeWeak)return;Ae--,Me--;const Qe=[J[Ae][Me],oe];let Ue=0,Je=0;for(;Ae>=1;){let se=Me;do{const ve=le[Ae][se];if(ve===3)se=se-2;else if(ve===2)se=se-1;else break}while(se>=1);Ue>1&&L[z+Ae-1]===Q[oe+Me-1]&&!we(se+oe-1,Y,Q)&&Ue+1>ue[Ae][se]&&(se=Me),se===Me?Ue++:Ue=1,Je||(Je=se),Ae--,Me=se-1,Qe.push(Me)}ke===me&&De.boostFullMatch&&(Qe[0]+=2);const U=Je-me;return Qe[0]-=U,Qe}function E(y,L,z,Y,Q,oe){let De=y-1,me=L-1;for(;De>=z&&me>=Y;)Q[De]===oe[me]&&(Be[De]=me,De--),me--}function l(y,L,z,Y,Q,oe,De,me,ke,Ae,Me){if(L[z]!==oe[De])return Number.MIN_SAFE_INTEGER;let Se=1,Te=!1;return De===z-Y?Se=y[z]===Q[De]?7:5:we(De,Q,oe)&&(De===0||!we(De-1,Q,oe))?(Se=y[z]===Q[De]?7:5,Te=!0):ne(oe,De)&&(De===0||!ne(oe,De-1))?Se=5:(ne(oe,De-1)||de(oe,De-1))&&(Se=5,Te=!0),Se>1&&z===Y&&(Me[0]=!0),Te||(Te=we(De,Q,oe)||ne(oe,De-1)||de(oe,De-1)),z===Y?De>ke&&(Se-=Te?3:5):Ae?Se+=Te?2:0:Se+=Te?0:1,De+1===me&&(Se-=Te?3:5),Se}function v(y,L,z,Y,Q,oe,De){return n(y,L,z,Y,Q,oe,!0,De)}function T(y,L,z,Y,Q,oe,De){return n(y,L,z,Y,Q,oe,!1,De)}function n(y,L,z,Y,Q,oe,De,me){let ke=c(y,L,z,Y,Q,oe,me);if(ke&&!De)return ke;if(y.length>=3){const Ae=Math.min(7,y.length-1);for(let Me=z+1;Me<Ae;Me++){const Se=S(y,Me);if(Se){const Te=c(Se,Se.toLowerCase(),z,Y,Q,oe,me);Te&&(Te[0]-=3,(!ke||Te[0]>ke[0])&&(ke=Te))}}}return ke}function S(y,L){if(L+1>=y.length)return;const z=y[L],Y=y[L+1];if(z!==Y)return y.slice(0,L)+Y+z+y.slice(L+2)}}),define(ge[59],pe([1,0,10]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.Hasher=void 0,t.hash=N,t.doHash=x,t.numberHash=V,t.stringHash=A,t.toHexString=i;function N(u){return x(u,0)}function x(u,g){switch(typeof u){case"object":return u===null?V(349,g):Array.isArray(u)?m(u,g):p(u,g);case"string":return A(u,g);case"boolean":return _(u,g);case"number":return V(u,g);case"undefined":return V(937,g);default:return V(617,g)}}function V(u,g){return(g<<5)-g+u|0}function _(u,g){return V(u?433:863,g)}function A(u,g){g=V(149417,g);for(let D=0,a=u.length;D<a;D++)g=V(u.charCodeAt(D),g);return g}function m(u,g){return g=V(104579,g),u.reduce((D,a)=>x(a,D),g)}function p(u,g){return g=V(181387,g),Object.keys(u).sort().reduce((D,a)=>(D=A(a,D),x(u[a],D)),g)}class w{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=x(g,this._value),this._value}}t.Hasher=w;var W;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(W||(W={}));function h(u,g,D=32){const a=D-g,f=~((1<<a)-1);return(u<<g|(f&u)>>>a)>>>0}function d(u,g=0,D=u.byteLength,a=0){for(let f=0;f<D;f++)u[g+f]=a}function e(u,g,D="0"){for(;u.length<g;)u=D+u;return u}function i(u,g=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(D=>D.toString(16).padStart(2,"0")).join(""):e((u>>>0).toString(16),g/4)}class r{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const D=g.length;if(D===0)return;const a=this._buff;let f=this._buffLen,o=this._leftoverHighSurrogate,C,F;for(o!==0?(C=o,F=-1,o=0):(C=g.charCodeAt(0),F=0);;){let R=C;if(s.isHighSurrogate(C))if(F+1<D){const B=g.charCodeAt(F+1);s.isLowSurrogate(B)?(F++,R=s.computeCodePoint(C,B)):R=65533}else{o=C;break}else s.isLowSurrogate(C)&&(R=65533);if(f=this._push(a,f,R),F++,F<D)C=g.charCodeAt(F);else break}this._buffLen=f,this._leftoverHighSurrogate=o}_push(g,D,a){return a<128?g[D++]=a:a<2048?(g[D++]=192|(a&1984)>>>6,g[D++]=128|(a&63)>>>0):a<65536?(g[D++]=224|(a&61440)>>>12,g[D++]=128|(a&4032)>>>6,g[D++]=128|(a&63)>>>0):(g[D++]=240|(a&1835008)>>>18,g[D++]=128|(a&258048)>>>12,g[D++]=128|(a&4032)>>>6,g[D++]=128|(a&63)>>>0),D>=64&&(this._step(),D-=64,this._totalLen+=64,g[0]=g[64],g[1]=g[65],g[2]=g[66]),D}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),i(this._h0)+i(this._h1)+i(this._h2)+i(this._h3)+i(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=r._bigBlock32,D=this._buffDV;for(let b=0;b<64;b+=4)g.setUint32(b,D.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)g.setUint32(b,h(g.getUint32(b-12,!1)^g.getUint32(b-32,!1)^g.getUint32(b-56,!1)^g.getUint32(b-64,!1),1),!1);let a=this._h0,f=this._h1,o=this._h2,C=this._h3,F=this._h4,R,B,P;for(let b=0;b<80;b++)b<20?(R=f&o|~f&C,B=1518500249):b<40?(R=f^o^C,B=1859775393):b<60?(R=f&o|f&C|o&C,B=2400959708):(R=f^o^C,B=3395469782),P=h(a,5)+R+F+B+g.getUint32(b*4,!1)&4294967295,F=C,C=o,o=h(f,30),f=a,a=P;this._h0=this._h0+a&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+C&4294967295,this._h4=this._h4+F&4294967295}}t.StringSHA1=r}),define(ge[98],pe([1,0,85,59]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.StringDiffSequence=void 0,t.stringDiff=V;class x{constructor(h){this.source=h}getElements(){const h=this.source,d=new Int32Array(h.length);for(let e=0,i=h.length;e<i;e++)d[e]=h.charCodeAt(e);return d}}t.StringDiffSequence=x;function V(W,h,d){return new w(new x(W),new x(h)).ComputeDiff(d).changes}class _{static Assert(h,d){if(!h)throw new Error(d)}}class A{static Copy(h,d,e,i,r){for(let u=0;u<r;u++)e[i+u]=h[d+u]}static Copy2(h,d,e,i,r){for(let u=0;u<r;u++)e[i+u]=h[d+u]}}var m;(function(W){W[W.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(m||(m={}));class p{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new s.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(h,d){this.m_originalStart=Math.min(this.m_originalStart,h),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_originalCount++}AddModifiedElement(h,d){this.m_originalStart=Math.min(this.m_originalStart,h),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class w{constructor(h,d,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=h,this._modifiedSequence=d;const[i,r,u]=w._getElements(h),[g,D,a]=w._getElements(d);this._hasStrings=u&&a,this._originalStringElements=i,this._originalElementsOrHash=r,this._modifiedStringElements=g,this._modifiedElementsOrHash=D,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(h){return h.length>0&&typeof h[0]=="string"}static _getElements(h){const d=h.getElements();if(w._isStringArray(d)){const e=new Int32Array(d.length);for(let i=0,r=d.length;i<r;i++)e[i]=(0,N.stringHash)(d[i],0);return[d,e,!0]}return d instanceof Int32Array?[[],d,!1]:[[],new Int32Array(d),!1]}ElementsAreEqual(h,d){return this._originalElementsOrHash[h]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[h]===this._modifiedStringElements[d]:!0}ElementsAreStrictEqual(h,d){if(!this.ElementsAreEqual(h,d))return!1;const e=w._getStrictElement(this._originalSequence,h),i=w._getStrictElement(this._modifiedSequence,d);return e===i}static _getStrictElement(h,d){return typeof h.getStrictElement=="function"?h.getStrictElement(d):null}OriginalElementsAreEqual(h,d){return this._originalElementsOrHash[h]!==this._originalElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[h]===this._originalStringElements[d]:!0}ModifiedElementsAreEqual(h,d){return this._modifiedElementsOrHash[h]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._modifiedStringElements[h]===this._modifiedStringElements[d]:!0}ComputeDiff(h){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,h)}_ComputeDiff(h,d,e,i,r){const u=[!1];let g=this.ComputeDiffRecursive(h,d,e,i,u);return r&&(g=this.PrettifyChanges(g)),{quitEarly:u[0],changes:g}}ComputeDiffRecursive(h,d,e,i,r){for(r[0]=!1;h<=d&&e<=i&&this.ElementsAreEqual(h,e);)h++,e++;for(;d>=h&&i>=e&&this.ElementsAreEqual(d,i);)d--,i--;if(h>d||e>i){let o;return e<=i?(_.Assert(h===d+1,"originalStart should only be one more than originalEnd"),o=[new s.DiffChange(h,0,e,i-e+1)]):h<=d?(_.Assert(e===i+1,"modifiedStart should only be one more than modifiedEnd"),o=[new s.DiffChange(h,d-h+1,e,0)]):(_.Assert(h===d+1,"originalStart should only be one more than originalEnd"),_.Assert(e===i+1,"modifiedStart should only be one more than modifiedEnd"),o=[]),o}const u=[0],g=[0],D=this.ComputeRecursionPoint(h,d,e,i,u,g,r),a=u[0],f=g[0];if(D!==null)return D;if(!r[0]){const o=this.ComputeDiffRecursive(h,a,e,f,r);let C=[];return r[0]?C=[new s.DiffChange(a+1,d-(a+1)+1,f+1,i-(f+1)+1)]:C=this.ComputeDiffRecursive(a+1,d,f+1,i,r),this.ConcatenateChanges(o,C)}return[new s.DiffChange(h,d-h+1,e,i-e+1)]}WALKTRACE(h,d,e,i,r,u,g,D,a,f,o,C,F,R,B,P,b,O){let $=null,k=null,M=new p,I=d,q=e,X=F[0]-P[0]-i,ce=-1073741824,re=this.m_forwardHistory.length-1;do{const te=X+h;te===I||te<q&&a[te-1]<a[te+1]?(o=a[te+1],R=o-X-i,o<ce&&M.MarkNextChange(),ce=o,M.AddModifiedElement(o+1,R),X=te+1-h):(o=a[te-1]+1,R=o-X-i,o<ce&&M.MarkNextChange(),ce=o-1,M.AddOriginalElement(o,R+1),X=te-1-h),re>=0&&(a=this.m_forwardHistory[re],h=a[0],I=1,q=a.length-1)}while(--re>=-1);if($=M.getReverseChanges(),O[0]){let te=F[0]+1,be=P[0]+1;if($!==null&&$.length>0){const Ee=$[$.length-1];te=Math.max(te,Ee.getOriginalEnd()),be=Math.max(be,Ee.getModifiedEnd())}k=[new s.DiffChange(te,C-te+1,be,B-be+1)]}else{M=new p,I=u,q=g,X=F[0]-P[0]-D,ce=1073741824,re=b?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const te=X+r;te===I||te<q&&f[te-1]>=f[te+1]?(o=f[te+1]-1,R=o-X-D,o>ce&&M.MarkNextChange(),ce=o+1,M.AddOriginalElement(o+1,R+1),X=te+1-r):(o=f[te-1],R=o-X-D,o>ce&&M.MarkNextChange(),ce=o,M.AddModifiedElement(o+1,R+1),X=te-1-r),re>=0&&(f=this.m_reverseHistory[re],r=f[0],I=1,q=f.length-1)}while(--re>=-1);k=M.getChanges()}return this.ConcatenateChanges($,k)}ComputeRecursionPoint(h,d,e,i,r,u,g){let D=0,a=0,f=0,o=0,C=0,F=0;h--,e--,r[0]=0,u[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const R=d-h+(i-e),B=R+1,P=new Int32Array(B),b=new Int32Array(B),O=i-e,$=d-h,k=h-e,M=d-i,q=($-O)%2===0;P[O]=h,b[$]=d,g[0]=!1;for(let X=1;X<=R/2+1;X++){let ce=0,re=0;f=this.ClipDiagonalBound(O-X,X,O,B),o=this.ClipDiagonalBound(O+X,X,O,B);for(let be=f;be<=o;be+=2){be===f||be<o&&P[be-1]<P[be+1]?D=P[be+1]:D=P[be-1]+1,a=D-(be-O)-k;const Ee=D;for(;D<d&&a<i&&this.ElementsAreEqual(D+1,a+1);)D++,a++;if(P[be]=D,D+a>ce+re&&(ce=D,re=a),!q&&Math.abs(be-$)<=X-1&&D>=b[be])return r[0]=D,u[0]=a,Ee<=b[be]&&1447>0&&X<=1448?this.WALKTRACE(O,f,o,k,$,C,F,M,P,b,D,d,r,a,i,u,q,g):null}const te=(ce-h+(re-e)-X)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(ce,te))return g[0]=!0,r[0]=ce,u[0]=re,te>0&&1447>0&&X<=1448?this.WALKTRACE(O,f,o,k,$,C,F,M,P,b,D,d,r,a,i,u,q,g):(h++,e++,[new s.DiffChange(h,d-h+1,e,i-e+1)]);C=this.ClipDiagonalBound($-X,X,$,B),F=this.ClipDiagonalBound($+X,X,$,B);for(let be=C;be<=F;be+=2){be===C||be<F&&b[be-1]>=b[be+1]?D=b[be+1]-1:D=b[be-1],a=D-(be-$)-M;const Ee=D;for(;D>h&&a>e&&this.ElementsAreEqual(D,a);)D--,a--;if(b[be]=D,q&&Math.abs(be-O)<=X&&D<=P[be])return r[0]=D,u[0]=a,Ee>=P[be]&&1447>0&&X<=1448?this.WALKTRACE(O,f,o,k,$,C,F,M,P,b,D,d,r,a,i,u,q,g):null}if(X<=1447){let be=new Int32Array(o-f+2);be[0]=O-f+1,A.Copy2(P,f,be,1,o-f+1),this.m_forwardHistory.push(be),be=new Int32Array(F-C+2),be[0]=$-C+1,A.Copy2(b,C,be,1,F-C+1),this.m_reverseHistory.push(be)}}return this.WALKTRACE(O,f,o,k,$,C,F,M,P,b,D,d,r,a,i,u,q,g)}PrettifyChanges(h){for(let d=0;d<h.length;d++){const e=h[d],i=d<h.length-1?h[d+1].originalStart:this._originalElementsOrHash.length,r=d<h.length-1?h[d+1].modifiedStart:this._modifiedElementsOrHash.length,u=e.originalLength>0,g=e.modifiedLength>0;for(;e.originalStart+e.originalLength<i&&e.modifiedStart+e.modifiedLength<r&&(!u||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!g||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const a=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!a)break;e.originalStart++,e.modifiedStart++}const D=[null];if(d<h.length-1&&this.ChangesOverlap(h[d],h[d+1],D)){h[d]=D[0],h.splice(d+1,1),d--;continue}}for(let d=h.length-1;d>=0;d--){const e=h[d];let i=0,r=0;if(d>0){const o=h[d-1];i=o.originalStart+o.originalLength,r=o.modifiedStart+o.modifiedLength}const u=e.originalLength>0,g=e.modifiedLength>0;let D=0,a=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let o=1;;o++){const C=e.originalStart-o,F=e.modifiedStart-o;if(C<i||F<r||u&&!this.OriginalElementsAreEqual(C,C+e.originalLength)||g&&!this.ModifiedElementsAreEqual(F,F+e.modifiedLength))break;const B=(C===i&&F===r?5:0)+this._boundaryScore(C,e.originalLength,F,e.modifiedLength);B>a&&(a=B,D=o)}e.originalStart-=D,e.modifiedStart-=D;const f=[null];if(d>0&&this.ChangesOverlap(h[d-1],h[d],f)){h[d-1]=f[0],h.splice(d,1),d++;continue}}if(this._hasStrings)for(let d=1,e=h.length;d<e;d++){const i=h[d-1],r=h[d],u=r.originalStart-i.originalStart-i.originalLength,g=i.originalStart,D=r.originalStart+r.originalLength,a=D-g,f=i.modifiedStart,o=r.modifiedStart+r.modifiedLength,C=o-f;if(u<5&&a<20&&C<20){const F=this._findBetterContiguousSequence(g,a,f,C,u);if(F){const[R,B]=F;(R!==i.originalStart+i.originalLength||B!==i.modifiedStart+i.modifiedLength)&&(i.originalLength=R-i.originalStart,i.modifiedLength=B-i.modifiedStart,r.originalStart=R+u,r.modifiedStart=B+u,r.originalLength=D-r.originalStart,r.modifiedLength=o-r.modifiedStart)}}}return h}_findBetterContiguousSequence(h,d,e,i,r){if(d<r||i<r)return null;const u=h+d-r+1,g=e+i-r+1;let D=0,a=0,f=0;for(let o=h;o<u;o++)for(let C=e;C<g;C++){const F=this._contiguousSequenceScore(o,C,r);F>0&&F>D&&(D=F,a=o,f=C)}return D>0?[a,f]:null}_contiguousSequenceScore(h,d,e){let i=0;for(let r=0;r<e;r++){if(!this.ElementsAreEqual(h+r,d+r))return 0;i+=this._originalStringElements[h+r].length}return i}_OriginalIsBoundary(h){return h<=0||h>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[h])}_OriginalRegionIsBoundary(h,d){if(this._OriginalIsBoundary(h)||this._OriginalIsBoundary(h-1))return!0;if(d>0){const e=h+d;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(h){return h<=0||h>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[h])}_ModifiedRegionIsBoundary(h,d){if(this._ModifiedIsBoundary(h)||this._ModifiedIsBoundary(h-1))return!0;if(d>0){const e=h+d;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(h,d,e,i){const r=this._OriginalRegionIsBoundary(h,d)?1:0,u=this._ModifiedRegionIsBoundary(e,i)?1:0;return r+u}ConcatenateChanges(h,d){const e=[];if(h.length===0||d.length===0)return d.length>0?d:h;if(this.ChangesOverlap(h[h.length-1],d[0],e)){const i=new Array(h.length+d.length-1);return A.Copy(h,0,i,0,h.length-1),i[h.length-1]=e[0],A.Copy(d,1,i,h.length,d.length-1),i}else{const i=new Array(h.length+d.length);return A.Copy(h,0,i,0,h.length),A.Copy(d,0,i,h.length,d.length),i}}ChangesOverlap(h,d,e){if(_.Assert(h.originalStart<=d.originalStart,"Left change is not less than or equal to right change"),_.Assert(h.modifiedStart<=d.modifiedStart,"Left change is not less than or equal to right change"),h.originalStart+h.originalLength>=d.originalStart||h.modifiedStart+h.modifiedLength>=d.modifiedStart){const i=h.originalStart;let r=h.originalLength;const u=h.modifiedStart;let g=h.modifiedLength;return h.originalStart+h.originalLength>=d.originalStart&&(r=d.originalStart+d.originalLength-h.originalStart),h.modifiedStart+h.modifiedLength>=d.modifiedStart&&(g=d.modifiedStart+d.modifiedLength-h.modifiedStart),e[0]=new s.DiffChange(i,r,u,g),!0}else return e[0]=null,!1}ClipDiagonalBound(h,d,e,i){if(h>=0&&h<i)return h;const r=e,u=i-e-1,g=d%2===0;if(h<0){const D=r%2===0;return g===D?0:1}else{const D=u%2===0;return g===D?i-1:i-2}}}t.LcsDiff=w}),define(ge[60],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MicrotaskDelay=void 0,t.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ge[99],pe([1,0,12,10]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class x{constructor(){this._value="",this._pos=0}reset(d){return this._value=d,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(d){const e=d.charCodeAt(0),i=this._value.charCodeAt(this._pos);return e-i}value(){return this._value[this._pos]}}t.StringIterator=x;class V{constructor(d=!0){this._caseSensitive=d}reset(d){return this._value=d,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let d=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(d)this._from++;else break;else d=!1;return this}cmp(d){return this._caseSensitive?(0,N.compareSubstring)(d,this._value,0,d.length,this._from,this._to):(0,N.compareSubstringIgnoreCase)(d,this._value,0,d.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=V;class _{constructor(d=!0,e=!0){this._splitOnBackslash=d,this._caseSensitive=e}reset(d){this._from=0,this._to=0,this._value=d,this._valueLen=d.length;for(let e=d.length-1;e>=0;e--,this._valueLen--){const i=this._value.charCodeAt(e);if(!(i===47||this._splitOnBackslash&&i===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let d=!0;for(;this._to<this._valueLen;this._to++){const e=this._value.charCodeAt(this._to);if(e===47||this._splitOnBackslash&&e===92)if(d)this._from++;else break;else d=!1}return this}cmp(d){return this._caseSensitive?(0,N.compareSubstring)(d,this._value,0,d.length,this._from,this._to):(0,N.compareSubstringIgnoreCase)(d,this._value,0,d.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=_;var A;(function(h){h[h.Scheme=1]="Scheme",h[h.Authority=2]="Authority",h[h.Path=3]="Path",h[h.Query=4]="Query",h[h.Fragment=5]="Fragment"})(A||(A={}));class m{constructor(d,e){this._ignorePathCasing=d,this._ignoreQueryAndFragment=e,this._states=[],this._stateIdx=0}reset(d){return this._value=d,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new _(!1,!this._ignorePathCasing(d)),this._pathIterator.reset(d.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(d)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(d){if(this._states[this._stateIdx]===1)return(0,N.compareIgnoreCase)(d,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,N.compareIgnoreCase)(d,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(d);if(this._states[this._stateIdx]===4)return(0,N.compare)(d,this._value.query);if(this._states[this._stateIdx]===5)return(0,N.compare)(d,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}t.UriIterator=m;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(h){h[h.Left=-1]="Left",h[h.Mid=0]="Mid",h[h.Right=1]="Right"})(w||(w={}));class W{static forUris(d=()=>!1,e=()=>!1){return new W(new m(d,e))}static forPaths(d=!1){return new W(new _(void 0,!d))}static forStrings(){return new W(new x)}static forConfigKeys(){return new W(new V)}constructor(d){this._iter=d}clear(){this._root=void 0}fill(d,e){if(e){const i=e.slice(0);(0,s.shuffle)(i);for(const r of i)this.set(r,d)}else{const i=d.slice(0);(0,s.shuffle)(i);for(const r of i)this.set(r[0],r[1])}}set(d,e){const i=this._iter.reset(d);let r;this._root||(this._root=new p,this._root.segment=i.value());const u=[];for(r=this._root;;){const D=i.cmp(r.segment);if(D>0)r.left||(r.left=new p,r.left.segment=i.value()),u.push([-1,r]),r=r.left;else if(D<0)r.right||(r.right=new p,r.right.segment=i.value()),u.push([1,r]),r=r.right;else if(i.hasNext())i.next(),r.mid||(r.mid=new p,r.mid.segment=i.value()),u.push([0,r]),r=r.mid;else break}const g=r.value;r.value=e,r.key=d;for(let D=u.length-1;D>=0;D--){const a=u[D][1];a.updateHeight();const f=a.balanceFactor();if(f<-1||f>1){const o=u[D][0],C=u[D+1][0];if(o===1&&C===1)u[D][1]=a.rotateLeft();else if(o===-1&&C===-1)u[D][1]=a.rotateRight();else if(o===1&&C===-1)a.right=u[D+1][1]=u[D+1][1].rotateRight(),u[D][1]=a.rotateLeft();else if(o===-1&&C===1)a.left=u[D+1][1]=u[D+1][1].rotateLeft(),u[D][1]=a.rotateRight();else throw new Error;if(D>0)switch(u[D-1][0]){case-1:u[D-1][1].left=u[D][1];break;case 1:u[D-1][1].right=u[D][1];break;case 0:u[D-1][1].mid=u[D][1];break}else this._root=u[0][1]}}return g}get(d){return this._getNode(d)?.value}_getNode(d){const e=this._iter.reset(d);let i=this._root;for(;i;){const r=e.cmp(i.segment);if(r>0)i=i.left;else if(r<0)i=i.right;else if(e.hasNext())e.next(),i=i.mid;else break}return i}has(d){const e=this._getNode(d);return!(e?.value===void 0&&e?.mid===void 0)}delete(d){return this._delete(d,!1)}deleteSuperstr(d){return this._delete(d,!0)}_delete(d,e){const i=this._iter.reset(d),r=[];let u=this._root;for(;u;){const g=i.cmp(u.segment);if(g>0)r.push([-1,u]),u=u.left;else if(g<0)r.push([1,u]),u=u.right;else if(i.hasNext())i.next(),r.push([0,u]),u=u.mid;else break}if(u){if(e?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const g=this._min(u.right);if(g.key){const{key:D,value:a,segment:f}=g;this._delete(g.key,!1),u.key=D,u.value=a,u.segment=f}}else{const g=u.left??u.right;if(r.length>0){const[D,a]=r[r.length-1];switch(D){case-1:a.left=g;break;case 0:a.mid=g;break;case 1:a.right=g;break}}else this._root=g}for(let g=r.length-1;g>=0;g--){const D=r[g][1];D.updateHeight();const a=D.balanceFactor();if(a>1?(D.right.balanceFactor()>=0||(D.right=D.right.rotateRight()),r[g][1]=D.rotateLeft()):a<-1&&(D.left.balanceFactor()<=0||(D.left=D.left.rotateLeft()),r[g][1]=D.rotateRight()),g>0)switch(r[g-1][0]){case-1:r[g-1][1].left=r[g][1];break;case 1:r[g-1][1].right=r[g][1];break;case 0:r[g-1][1].mid=r[g][1];break}else this._root=r[0][1]}}}_min(d){for(;d.left;)d=d.left;return d}findSubstr(d){const e=this._iter.reset(d);let i=this._root,r;for(;i;){const u=e.cmp(i.segment);if(u>0)i=i.left;else if(u<0)i=i.right;else if(e.hasNext())e.next(),r=i.value||r,i=i.mid;else break}return i&&i.value||r}findSuperstr(d){return this._findSuperstrOrElement(d,!1)}_findSuperstrOrElement(d,e){const i=this._iter.reset(d);let r=this._root;for(;r;){const u=i.cmp(r.segment);if(u>0)r=r.left;else if(u<0)r=r.right;else if(i.hasNext())i.next(),r=r.mid;else return r.mid?this._entries(r.mid):e?r.value:void 0}}hasElementOrSubtree(d){return this._findSuperstrOrElement(d,!0)!==void 0}forEach(d){for(const[e,i]of this)d(i,e)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(d){const e=[];return this._dfsEntries(d,e),e[Symbol.iterator]()}_dfsEntries(d,e){d&&(d.left&&this._dfsEntries(d.left,e),d.value&&e.push([d.key,d.value]),d.mid&&this._dfsEntries(d.mid,e),d.right&&this._dfsEntries(d.right,e))}_isBalanced(){const d=e=>{if(!e)return!0;const i=e.balanceFactor();return i<-1||i>1?!1:d(e.left)&&d(e.right)};return d(this._root)}}t.TernarySearchTree=W}),define(ge[7],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isString=s,t.isStringArray=N,t.isObject=x,t.isTypedArray=V,t.isNumber=_,t.isIterable=A,t.isBoolean=m,t.isUndefined=p,t.isDefined=w,t.isUndefinedOrNull=W,t.assertType=h,t.assertIsDefined=d,t.assertAllDefined=e,t.isEmptyObject=r,t.isFunction=u,t.areFunctions=g,t.validateConstraints=D,t.validateConstraint=a;function s(f){return typeof f=="string"}function N(f){return Array.isArray(f)&&f.every(o=>s(o))}function x(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}function V(f){const o=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof o}function _(f){return typeof f=="number"&&!isNaN(f)}function A(f){return!!f&&typeof f[Symbol.iterator]=="function"}function m(f){return f===!0||f===!1}function p(f){return typeof f>"u"}function w(f){return!W(f)}function W(f){return p(f)||f===null}function h(f,o){if(!f)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}function d(f){if(W(f))throw new Error("Assertion Failed: argument is undefined or null");return f}function e(...f){const o=[];for(let C=0;C<f.length;C++){const F=f[C];if(W(F))throw new Error(`Assertion Failed: argument at index ${C} is undefined or null`);o.push(F)}return o}const i=Object.prototype.hasOwnProperty;function r(f){if(!x(f))return!1;for(const o in f)if(i.call(f,o))return!1;return!0}function u(f){return typeof f=="function"}function g(...f){return f.length>0&&f.every(u)}function D(f,o){const C=Math.min(f.length,o.length);for(let F=0;F<C;F++)a(f[F],o[F])}function a(f,o){if(s(o)){if(typeof f!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(u(o)){try{if(f instanceof o)return}catch{}if(!W(f)&&f.constructor===o||o.length===1&&o.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ge[44],pe([1,0,7]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.register=x,t.getCodiconFontCharacters=V;const N=Object.create(null);function x(_,A){if((0,s.isString)(A)){const m=N[A];if(m===void 0)throw new Error(`${_} references an unknown codicon: ${A}`);A=m}return N[_]=A,{id:_}}function V(){return N}}),define(ge[100],pe([1,0,44]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.codiconsLibrary=void 0,t.codiconsLibrary={add:(0,s.register)("add",6e4),plus:(0,s.register)("plus",6e4),gistNew:(0,s.register)("gist-new",6e4),repoCreate:(0,s.register)("repo-create",6e4),lightbulb:(0,s.register)("lightbulb",60001),lightBulb:(0,s.register)("light-bulb",60001),repo:(0,s.register)("repo",60002),repoDelete:(0,s.register)("repo-delete",60002),gistFork:(0,s.register)("gist-fork",60003),repoForked:(0,s.register)("repo-forked",60003),gitPullRequest:(0,s.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,s.register)("git-pull-request-abandoned",60004),recordKeys:(0,s.register)("record-keys",60005),keyboard:(0,s.register)("keyboard",60005),tag:(0,s.register)("tag",60006),gitPullRequestLabel:(0,s.register)("git-pull-request-label",60006),tagAdd:(0,s.register)("tag-add",60006),tagRemove:(0,s.register)("tag-remove",60006),person:(0,s.register)("person",60007),personFollow:(0,s.register)("person-follow",60007),personOutline:(0,s.register)("person-outline",60007),personFilled:(0,s.register)("person-filled",60007),gitBranch:(0,s.register)("git-branch",60008),gitBranchCreate:(0,s.register)("git-branch-create",60008),gitBranchDelete:(0,s.register)("git-branch-delete",60008),sourceControl:(0,s.register)("source-control",60008),mirror:(0,s.register)("mirror",60009),mirrorPublic:(0,s.register)("mirror-public",60009),star:(0,s.register)("star",60010),starAdd:(0,s.register)("star-add",60010),starDelete:(0,s.register)("star-delete",60010),starEmpty:(0,s.register)("star-empty",60010),comment:(0,s.register)("comment",60011),commentAdd:(0,s.register)("comment-add",60011),alert:(0,s.register)("alert",60012),warning:(0,s.register)("warning",60012),search:(0,s.register)("search",60013),searchSave:(0,s.register)("search-save",60013),logOut:(0,s.register)("log-out",60014),signOut:(0,s.register)("sign-out",60014),logIn:(0,s.register)("log-in",60015),signIn:(0,s.register)("sign-in",60015),eye:(0,s.register)("eye",60016),eyeUnwatch:(0,s.register)("eye-unwatch",60016),eyeWatch:(0,s.register)("eye-watch",60016),circleFilled:(0,s.register)("circle-filled",60017),primitiveDot:(0,s.register)("primitive-dot",60017),closeDirty:(0,s.register)("close-dirty",60017),debugBreakpoint:(0,s.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,s.register)("debug-breakpoint-disabled",60017),debugHint:(0,s.register)("debug-hint",60017),terminalDecorationSuccess:(0,s.register)("terminal-decoration-success",60017),primitiveSquare:(0,s.register)("primitive-square",60018),edit:(0,s.register)("edit",60019),pencil:(0,s.register)("pencil",60019),info:(0,s.register)("info",60020),issueOpened:(0,s.register)("issue-opened",60020),gistPrivate:(0,s.register)("gist-private",60021),gitForkPrivate:(0,s.register)("git-fork-private",60021),lock:(0,s.register)("lock",60021),mirrorPrivate:(0,s.register)("mirror-private",60021),close:(0,s.register)("close",60022),removeClose:(0,s.register)("remove-close",60022),x:(0,s.register)("x",60022),repoSync:(0,s.register)("repo-sync",60023),sync:(0,s.register)("sync",60023),clone:(0,s.register)("clone",60024),desktopDownload:(0,s.register)("desktop-download",60024),beaker:(0,s.register)("beaker",60025),microscope:(0,s.register)("microscope",60025),vm:(0,s.register)("vm",60026),deviceDesktop:(0,s.register)("device-desktop",60026),file:(0,s.register)("file",60027),fileText:(0,s.register)("file-text",60027),more:(0,s.register)("more",60028),ellipsis:(0,s.register)("ellipsis",60028),kebabHorizontal:(0,s.register)("kebab-horizontal",60028),mailReply:(0,s.register)("mail-reply",60029),reply:(0,s.register)("reply",60029),organization:(0,s.register)("organization",60030),organizationFilled:(0,s.register)("organization-filled",60030),organizationOutline:(0,s.register)("organization-outline",60030),newFile:(0,s.register)("new-file",60031),fileAdd:(0,s.register)("file-add",60031),newFolder:(0,s.register)("new-folder",60032),fileDirectoryCreate:(0,s.register)("file-directory-create",60032),trash:(0,s.register)("trash",60033),trashcan:(0,s.register)("trashcan",60033),history:(0,s.register)("history",60034),clock:(0,s.register)("clock",60034),folder:(0,s.register)("folder",60035),fileDirectory:(0,s.register)("file-directory",60035),symbolFolder:(0,s.register)("symbol-folder",60035),logoGithub:(0,s.register)("logo-github",60036),markGithub:(0,s.register)("mark-github",60036),github:(0,s.register)("github",60036),terminal:(0,s.register)("terminal",60037),console:(0,s.register)("console",60037),repl:(0,s.register)("repl",60037),zap:(0,s.register)("zap",60038),symbolEvent:(0,s.register)("symbol-event",60038),error:(0,s.register)("error",60039),stop:(0,s.register)("stop",60039),variable:(0,s.register)("variable",60040),symbolVariable:(0,s.register)("symbol-variable",60040),array:(0,s.register)("array",60042),symbolArray:(0,s.register)("symbol-array",60042),symbolModule:(0,s.register)("symbol-module",60043),symbolPackage:(0,s.register)("symbol-package",60043),symbolNamespace:(0,s.register)("symbol-namespace",60043),symbolObject:(0,s.register)("symbol-object",60043),symbolMethod:(0,s.register)("symbol-method",60044),symbolFunction:(0,s.register)("symbol-function",60044),symbolConstructor:(0,s.register)("symbol-constructor",60044),symbolBoolean:(0,s.register)("symbol-boolean",60047),symbolNull:(0,s.register)("symbol-null",60047),symbolNumeric:(0,s.register)("symbol-numeric",60048),symbolNumber:(0,s.register)("symbol-number",60048),symbolStructure:(0,s.register)("symbol-structure",60049),symbolStruct:(0,s.register)("symbol-struct",60049),symbolParameter:(0,s.register)("symbol-parameter",60050),symbolTypeParameter:(0,s.register)("symbol-type-parameter",60050),symbolKey:(0,s.register)("symbol-key",60051),symbolText:(0,s.register)("symbol-text",60051),symbolReference:(0,s.register)("symbol-reference",60052),goToFile:(0,s.register)("go-to-file",60052),symbolEnum:(0,s.register)("symbol-enum",60053),symbolValue:(0,s.register)("symbol-value",60053),symbolRuler:(0,s.register)("symbol-ruler",60054),symbolUnit:(0,s.register)("symbol-unit",60054),activateBreakpoints:(0,s.register)("activate-breakpoints",60055),archive:(0,s.register)("archive",60056),arrowBoth:(0,s.register)("arrow-both",60057),arrowDown:(0,s.register)("arrow-down",60058),arrowLeft:(0,s.register)("arrow-left",60059),arrowRight:(0,s.register)("arrow-right",60060),arrowSmallDown:(0,s.register)("arrow-small-down",60061),arrowSmallLeft:(0,s.register)("arrow-small-left",60062),arrowSmallRight:(0,s.register)("arrow-small-right",60063),arrowSmallUp:(0,s.register)("arrow-small-up",60064),arrowUp:(0,s.register)("arrow-up",60065),bell:(0,s.register)("bell",60066),bold:(0,s.register)("bold",60067),book:(0,s.register)("book",60068),bookmark:(0,s.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,s.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,s.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,s.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,s.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,s.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,s.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,s.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,s.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,s.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,s.register)("briefcase",60076),broadcast:(0,s.register)("broadcast",60077),browser:(0,s.register)("browser",60078),bug:(0,s.register)("bug",60079),calendar:(0,s.register)("calendar",60080),caseSensitive:(0,s.register)("case-sensitive",60081),check:(0,s.register)("check",60082),checklist:(0,s.register)("checklist",60083),chevronDown:(0,s.register)("chevron-down",60084),chevronLeft:(0,s.register)("chevron-left",60085),chevronRight:(0,s.register)("chevron-right",60086),chevronUp:(0,s.register)("chevron-up",60087),chromeClose:(0,s.register)("chrome-close",60088),chromeMaximize:(0,s.register)("chrome-maximize",60089),chromeMinimize:(0,s.register)("chrome-minimize",60090),chromeRestore:(0,s.register)("chrome-restore",60091),circleOutline:(0,s.register)("circle-outline",60092),circle:(0,s.register)("circle",60092),debugBreakpointUnverified:(0,s.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,s.register)("terminal-decoration-incomplete",60092),circleSlash:(0,s.register)("circle-slash",60093),circuitBoard:(0,s.register)("circuit-board",60094),clearAll:(0,s.register)("clear-all",60095),clippy:(0,s.register)("clippy",60096),closeAll:(0,s.register)("close-all",60097),cloudDownload:(0,s.register)("cloud-download",60098),cloudUpload:(0,s.register)("cloud-upload",60099),code:(0,s.register)("code",60100),collapseAll:(0,s.register)("collapse-all",60101),colorMode:(0,s.register)("color-mode",60102),commentDiscussion:(0,s.register)("comment-discussion",60103),creditCard:(0,s.register)("credit-card",60105),dash:(0,s.register)("dash",60108),dashboard:(0,s.register)("dashboard",60109),database:(0,s.register)("database",60110),debugContinue:(0,s.register)("debug-continue",60111),debugDisconnect:(0,s.register)("debug-disconnect",60112),debugPause:(0,s.register)("debug-pause",60113),debugRestart:(0,s.register)("debug-restart",60114),debugStart:(0,s.register)("debug-start",60115),debugStepInto:(0,s.register)("debug-step-into",60116),debugStepOut:(0,s.register)("debug-step-out",60117),debugStepOver:(0,s.register)("debug-step-over",60118),debugStop:(0,s.register)("debug-stop",60119),debug:(0,s.register)("debug",60120),deviceCameraVideo:(0,s.register)("device-camera-video",60121),deviceCamera:(0,s.register)("device-camera",60122),deviceMobile:(0,s.register)("device-mobile",60123),diffAdded:(0,s.register)("diff-added",60124),diffIgnored:(0,s.register)("diff-ignored",60125),diffModified:(0,s.register)("diff-modified",60126),diffRemoved:(0,s.register)("diff-removed",60127),diffRenamed:(0,s.register)("diff-renamed",60128),diff:(0,s.register)("diff",60129),diffSidebyside:(0,s.register)("diff-sidebyside",60129),discard:(0,s.register)("discard",60130),editorLayout:(0,s.register)("editor-layout",60131),emptyWindow:(0,s.register)("empty-window",60132),exclude:(0,s.register)("exclude",60133),extensions:(0,s.register)("extensions",60134),eyeClosed:(0,s.register)("eye-closed",60135),fileBinary:(0,s.register)("file-binary",60136),fileCode:(0,s.register)("file-code",60137),fileMedia:(0,s.register)("file-media",60138),filePdf:(0,s.register)("file-pdf",60139),fileSubmodule:(0,s.register)("file-submodule",60140),fileSymlinkDirectory:(0,s.register)("file-symlink-directory",60141),fileSymlinkFile:(0,s.register)("file-symlink-file",60142),fileZip:(0,s.register)("file-zip",60143),files:(0,s.register)("files",60144),filter:(0,s.register)("filter",60145),flame:(0,s.register)("flame",60146),foldDown:(0,s.register)("fold-down",60147),foldUp:(0,s.register)("fold-up",60148),fold:(0,s.register)("fold",60149),folderActive:(0,s.register)("folder-active",60150),folderOpened:(0,s.register)("folder-opened",60151),gear:(0,s.register)("gear",60152),gift:(0,s.register)("gift",60153),gistSecret:(0,s.register)("gist-secret",60154),gist:(0,s.register)("gist",60155),gitCommit:(0,s.register)("git-commit",60156),gitCompare:(0,s.register)("git-compare",60157),compareChanges:(0,s.register)("compare-changes",60157),gitMerge:(0,s.register)("git-merge",60158),githubAction:(0,s.register)("github-action",60159),githubAlt:(0,s.register)("github-alt",60160),globe:(0,s.register)("globe",60161),grabber:(0,s.register)("grabber",60162),graph:(0,s.register)("graph",60163),gripper:(0,s.register)("gripper",60164),heart:(0,s.register)("heart",60165),home:(0,s.register)("home",60166),horizontalRule:(0,s.register)("horizontal-rule",60167),hubot:(0,s.register)("hubot",60168),inbox:(0,s.register)("inbox",60169),issueReopened:(0,s.register)("issue-reopened",60171),issues:(0,s.register)("issues",60172),italic:(0,s.register)("italic",60173),jersey:(0,s.register)("jersey",60174),json:(0,s.register)("json",60175),kebabVertical:(0,s.register)("kebab-vertical",60176),key:(0,s.register)("key",60177),law:(0,s.register)("law",60178),lightbulbAutofix:(0,s.register)("lightbulb-autofix",60179),linkExternal:(0,s.register)("link-external",60180),link:(0,s.register)("link",60181),listOrdered:(0,s.register)("list-ordered",60182),listUnordered:(0,s.register)("list-unordered",60183),liveShare:(0,s.register)("live-share",60184),loading:(0,s.register)("loading",60185),location:(0,s.register)("location",60186),mailRead:(0,s.register)("mail-read",60187),mail:(0,s.register)("mail",60188),markdown:(0,s.register)("markdown",60189),megaphone:(0,s.register)("megaphone",60190),mention:(0,s.register)("mention",60191),milestone:(0,s.register)("milestone",60192),gitPullRequestMilestone:(0,s.register)("git-pull-request-milestone",60192),mortarBoard:(0,s.register)("mortar-board",60193),move:(0,s.register)("move",60194),multipleWindows:(0,s.register)("multiple-windows",60195),mute:(0,s.register)("mute",60196),noNewline:(0,s.register)("no-newline",60197),note:(0,s.register)("note",60198),octoface:(0,s.register)("octoface",60199),openPreview:(0,s.register)("open-preview",60200),package:(0,s.register)("package",60201),paintcan:(0,s.register)("paintcan",60202),pin:(0,s.register)("pin",60203),play:(0,s.register)("play",60204),run:(0,s.register)("run",60204),plug:(0,s.register)("plug",60205),preserveCase:(0,s.register)("preserve-case",60206),preview:(0,s.register)("preview",60207),project:(0,s.register)("project",60208),pulse:(0,s.register)("pulse",60209),question:(0,s.register)("question",60210),quote:(0,s.register)("quote",60211),radioTower:(0,s.register)("radio-tower",60212),reactions:(0,s.register)("reactions",60213),references:(0,s.register)("references",60214),refresh:(0,s.register)("refresh",60215),regex:(0,s.register)("regex",60216),remoteExplorer:(0,s.register)("remote-explorer",60217),remote:(0,s.register)("remote",60218),remove:(0,s.register)("remove",60219),replaceAll:(0,s.register)("replace-all",60220),replace:(0,s.register)("replace",60221),repoClone:(0,s.register)("repo-clone",60222),repoForcePush:(0,s.register)("repo-force-push",60223),repoPull:(0,s.register)("repo-pull",60224),repoPush:(0,s.register)("repo-push",60225),report:(0,s.register)("report",60226),requestChanges:(0,s.register)("request-changes",60227),rocket:(0,s.register)("rocket",60228),rootFolderOpened:(0,s.register)("root-folder-opened",60229),rootFolder:(0,s.register)("root-folder",60230),rss:(0,s.register)("rss",60231),ruby:(0,s.register)("ruby",60232),saveAll:(0,s.register)("save-all",60233),saveAs:(0,s.register)("save-as",60234),save:(0,s.register)("save",60235),screenFull:(0,s.register)("screen-full",60236),screenNormal:(0,s.register)("screen-normal",60237),searchStop:(0,s.register)("search-stop",60238),server:(0,s.register)("server",60240),settingsGear:(0,s.register)("settings-gear",60241),settings:(0,s.register)("settings",60242),shield:(0,s.register)("shield",60243),smiley:(0,s.register)("smiley",60244),sortPrecedence:(0,s.register)("sort-precedence",60245),splitHorizontal:(0,s.register)("split-horizontal",60246),splitVertical:(0,s.register)("split-vertical",60247),squirrel:(0,s.register)("squirrel",60248),starFull:(0,s.register)("star-full",60249),starHalf:(0,s.register)("star-half",60250),symbolClass:(0,s.register)("symbol-class",60251),symbolColor:(0,s.register)("symbol-color",60252),symbolConstant:(0,s.register)("symbol-constant",60253),symbolEnumMember:(0,s.register)("symbol-enum-member",60254),symbolField:(0,s.register)("symbol-field",60255),symbolFile:(0,s.register)("symbol-file",60256),symbolInterface:(0,s.register)("symbol-interface",60257),symbolKeyword:(0,s.register)("symbol-keyword",60258),symbolMisc:(0,s.register)("symbol-misc",60259),symbolOperator:(0,s.register)("symbol-operator",60260),symbolProperty:(0,s.register)("symbol-property",60261),wrench:(0,s.register)("wrench",60261),wrenchSubaction:(0,s.register)("wrench-subaction",60261),symbolSnippet:(0,s.register)("symbol-snippet",60262),tasklist:(0,s.register)("tasklist",60263),telescope:(0,s.register)("telescope",60264),textSize:(0,s.register)("text-size",60265),threeBars:(0,s.register)("three-bars",60266),thumbsdown:(0,s.register)("thumbsdown",60267),thumbsup:(0,s.register)("thumbsup",60268),tools:(0,s.register)("tools",60269),triangleDown:(0,s.register)("triangle-down",60270),triangleLeft:(0,s.register)("triangle-left",60271),triangleRight:(0,s.register)("triangle-right",60272),triangleUp:(0,s.register)("triangle-up",60273),twitter:(0,s.register)("twitter",60274),unfold:(0,s.register)("unfold",60275),unlock:(0,s.register)("unlock",60276),unmute:(0,s.register)("unmute",60277),unverified:(0,s.register)("unverified",60278),verified:(0,s.register)("verified",60279),versions:(0,s.register)("versions",60280),vmActive:(0,s.register)("vm-active",60281),vmOutline:(0,s.register)("vm-outline",60282),vmRunning:(0,s.register)("vm-running",60283),watch:(0,s.register)("watch",60284),whitespace:(0,s.register)("whitespace",60285),wholeWord:(0,s.register)("whole-word",60286),window:(0,s.register)("window",60287),wordWrap:(0,s.register)("word-wrap",60288),zoomIn:(0,s.register)("zoom-in",60289),zoomOut:(0,s.register)("zoom-out",60290),listFilter:(0,s.register)("list-filter",60291),listFlat:(0,s.register)("list-flat",60292),listSelection:(0,s.register)("list-selection",60293),selection:(0,s.register)("selection",60293),listTree:(0,s.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,s.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,s.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,s.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,s.register)("debug-stackframe-active",60297),circleSmallFilled:(0,s.register)("circle-small-filled",60298),debugStackframeDot:(0,s.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,s.register)("terminal-decoration-mark",60298),debugStackframe:(0,s.register)("debug-stackframe",60299),debugStackframeFocused:(0,s.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,s.register)("debug-breakpoint-unsupported",60300),symbolString:(0,s.register)("symbol-string",60301),debugReverseContinue:(0,s.register)("debug-reverse-continue",60302),debugStepBack:(0,s.register)("debug-step-back",60303),debugRestartFrame:(0,s.register)("debug-restart-frame",60304),debugAlt:(0,s.register)("debug-alt",60305),callIncoming:(0,s.register)("call-incoming",60306),callOutgoing:(0,s.register)("call-outgoing",60307),menu:(0,s.register)("menu",60308),expandAll:(0,s.register)("expand-all",60309),feedback:(0,s.register)("feedback",60310),gitPullRequestReviewer:(0,s.register)("git-pull-request-reviewer",60310),groupByRefType:(0,s.register)("group-by-ref-type",60311),ungroupByRefType:(0,s.register)("ungroup-by-ref-type",60312),account:(0,s.register)("account",60313),gitPullRequestAssignee:(0,s.register)("git-pull-request-assignee",60313),bellDot:(0,s.register)("bell-dot",60314),debugConsole:(0,s.register)("debug-console",60315),library:(0,s.register)("library",60316),output:(0,s.register)("output",60317),runAll:(0,s.register)("run-all",60318),syncIgnored:(0,s.register)("sync-ignored",60319),pinned:(0,s.register)("pinned",60320),githubInverted:(0,s.register)("github-inverted",60321),serverProcess:(0,s.register)("server-process",60322),serverEnvironment:(0,s.register)("server-environment",60323),pass:(0,s.register)("pass",60324),issueClosed:(0,s.register)("issue-closed",60324),stopCircle:(0,s.register)("stop-circle",60325),playCircle:(0,s.register)("play-circle",60326),record:(0,s.register)("record",60327),debugAltSmall:(0,s.register)("debug-alt-small",60328),vmConnect:(0,s.register)("vm-connect",60329),cloud:(0,s.register)("cloud",60330),merge:(0,s.register)("merge",60331),export:(0,s.register)("export",60332),graphLeft:(0,s.register)("graph-left",60333),magnet:(0,s.register)("magnet",60334),notebook:(0,s.register)("notebook",60335),redo:(0,s.register)("redo",60336),checkAll:(0,s.register)("check-all",60337),pinnedDirty:(0,s.register)("pinned-dirty",60338),passFilled:(0,s.register)("pass-filled",60339),circleLargeFilled:(0,s.register)("circle-large-filled",60340),circleLarge:(0,s.register)("circle-large",60341),circleLargeOutline:(0,s.register)("circle-large-outline",60341),combine:(0,s.register)("combine",60342),gather:(0,s.register)("gather",60342),table:(0,s.register)("table",60343),variableGroup:(0,s.register)("variable-group",60344),typeHierarchy:(0,s.register)("type-hierarchy",60345),typeHierarchySub:(0,s.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,s.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,s.register)("git-pull-request-create",60348),runAbove:(0,s.register)("run-above",60349),runBelow:(0,s.register)("run-below",60350),notebookTemplate:(0,s.register)("notebook-template",60351),debugRerun:(0,s.register)("debug-rerun",60352),workspaceTrusted:(0,s.register)("workspace-trusted",60353),workspaceUntrusted:(0,s.register)("workspace-untrusted",60354),workspaceUnknown:(0,s.register)("workspace-unknown",60355),terminalCmd:(0,s.register)("terminal-cmd",60356),terminalDebian:(0,s.register)("terminal-debian",60357),terminalLinux:(0,s.register)("terminal-linux",60358),terminalPowershell:(0,s.register)("terminal-powershell",60359),terminalTmux:(0,s.register)("terminal-tmux",60360),terminalUbuntu:(0,s.register)("terminal-ubuntu",60361),terminalBash:(0,s.register)("terminal-bash",60362),arrowSwap:(0,s.register)("arrow-swap",60363),copy:(0,s.register)("copy",60364),personAdd:(0,s.register)("person-add",60365),filterFilled:(0,s.register)("filter-filled",60366),wand:(0,s.register)("wand",60367),debugLineByLine:(0,s.register)("debug-line-by-line",60368),inspect:(0,s.register)("inspect",60369),layers:(0,s.register)("layers",60370),layersDot:(0,s.register)("layers-dot",60371),layersActive:(0,s.register)("layers-active",60372),compass:(0,s.register)("compass",60373),compassDot:(0,s.register)("compass-dot",60374),compassActive:(0,s.register)("compass-active",60375),azure:(0,s.register)("azure",60376),issueDraft:(0,s.register)("issue-draft",60377),gitPullRequestClosed:(0,s.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,s.register)("git-pull-request-draft",60379),debugAll:(0,s.register)("debug-all",60380),debugCoverage:(0,s.register)("debug-coverage",60381),runErrors:(0,s.register)("run-errors",60382),folderLibrary:(0,s.register)("folder-library",60383),debugContinueSmall:(0,s.register)("debug-continue-small",60384),beakerStop:(0,s.register)("beaker-stop",60385),graphLine:(0,s.register)("graph-line",60386),graphScatter:(0,s.register)("graph-scatter",60387),pieChart:(0,s.register)("pie-chart",60388),bracket:(0,s.register)("bracket",60175),bracketDot:(0,s.register)("bracket-dot",60389),bracketError:(0,s.register)("bracket-error",60390),lockSmall:(0,s.register)("lock-small",60391),azureDevops:(0,s.register)("azure-devops",60392),verifiedFilled:(0,s.register)("verified-filled",60393),newline:(0,s.register)("newline",60394),layout:(0,s.register)("layout",60395),layoutActivitybarLeft:(0,s.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,s.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,s.register)("layout-panel-left",60398),layoutPanelCenter:(0,s.register)("layout-panel-center",60399),layoutPanelJustify:(0,s.register)("layout-panel-justify",60400),layoutPanelRight:(0,s.register)("layout-panel-right",60401),layoutPanel:(0,s.register)("layout-panel",60402),layoutSidebarLeft:(0,s.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,s.register)("layout-sidebar-right",60404),layoutStatusbar:(0,s.register)("layout-statusbar",60405),layoutMenubar:(0,s.register)("layout-menubar",60406),layoutCentered:(0,s.register)("layout-centered",60407),target:(0,s.register)("target",60408),indent:(0,s.register)("indent",60409),recordSmall:(0,s.register)("record-small",60410),errorSmall:(0,s.register)("error-small",60411),terminalDecorationError:(0,s.register)("terminal-decoration-error",60411),arrowCircleDown:(0,s.register)("arrow-circle-down",60412),arrowCircleLeft:(0,s.register)("arrow-circle-left",60413),arrowCircleRight:(0,s.register)("arrow-circle-right",60414),arrowCircleUp:(0,s.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,s.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,s.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,s.register)("layout-sidebar-left-off",60418),blank:(0,s.register)("blank",60419),heartFilled:(0,s.register)("heart-filled",60420),map:(0,s.register)("map",60421),mapHorizontal:(0,s.register)("map-horizontal",60421),foldHorizontal:(0,s.register)("fold-horizontal",60421),mapFilled:(0,s.register)("map-filled",60422),mapHorizontalFilled:(0,s.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,s.register)("fold-horizontal-filled",60422),circleSmall:(0,s.register)("circle-small",60423),bellSlash:(0,s.register)("bell-slash",60424),bellSlashDot:(0,s.register)("bell-slash-dot",60425),commentUnresolved:(0,s.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,s.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,s.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,s.register)("search-fuzzy",60429),commentDraft:(0,s.register)("comment-draft",60430),send:(0,s.register)("send",60431),sparkle:(0,s.register)("sparkle",60432),insert:(0,s.register)("insert",60433),mic:(0,s.register)("mic",60434),thumbsdownFilled:(0,s.register)("thumbsdown-filled",60435),thumbsupFilled:(0,s.register)("thumbsup-filled",60436),coffee:(0,s.register)("coffee",60437),snake:(0,s.register)("snake",60438),game:(0,s.register)("game",60439),vr:(0,s.register)("vr",60440),chip:(0,s.register)("chip",60441),piano:(0,s.register)("piano",60442),music:(0,s.register)("music",60443),micFilled:(0,s.register)("mic-filled",60444),repoFetch:(0,s.register)("repo-fetch",60445),copilot:(0,s.register)("copilot",60446),lightbulbSparkle:(0,s.register)("lightbulb-sparkle",60447),robot:(0,s.register)("robot",60448),sparkleFilled:(0,s.register)("sparkle-filled",60449),diffSingle:(0,s.register)("diff-single",60450),diffMultiple:(0,s.register)("diff-multiple",60451),surroundWith:(0,s.register)("surround-with",60452),share:(0,s.register)("share",60453),gitStash:(0,s.register)("git-stash",60454),gitStashApply:(0,s.register)("git-stash-apply",60455),gitStashPop:(0,s.register)("git-stash-pop",60456),vscode:(0,s.register)("vscode",60457),vscodeInsiders:(0,s.register)("vscode-insiders",60458),codeOss:(0,s.register)("code-oss",60459),runCoverage:(0,s.register)("run-coverage",60460),runAllCoverage:(0,s.register)("run-all-coverage",60461),coverage:(0,s.register)("coverage",60462),githubProject:(0,s.register)("github-project",60463),mapVertical:(0,s.register)("map-vertical",60464),foldVertical:(0,s.register)("fold-vertical",60464),mapVerticalFilled:(0,s.register)("map-vertical-filled",60465),foldVerticalFilled:(0,s.register)("fold-vertical-filled",60465)}}),define(ge[18],pe([1,0,44,100]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.codiconsDerived=void 0,t.getAllCodicons=x;function x(){return Object.values(t.Codicon)}t.codiconsDerived={dialogError:(0,s.register)("dialog-error","error"),dialogWarning:(0,s.register)("dialog-warning","warning"),dialogInfo:(0,s.register)("dialog-info","info"),dialogClose:(0,s.register)("dialog-close","close"),treeItemExpanded:(0,s.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,s.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,s.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,s.register)("tree-filter-clear","close"),treeItemLoading:(0,s.register)("tree-item-loading","loading"),menuSelection:(0,s.register)("menu-selection","check"),menuSubmenu:(0,s.register)("menu-submenu","chevron-right"),menuBarMore:(0,s.register)("menubar-more","more"),scrollbarButtonLeft:(0,s.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,s.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,s.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,s.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,s.register)("toolbar-more","more"),quickInputBack:(0,s.register)("quick-input-back","arrow-left"),dropDownButton:(0,s.register)("drop-down-button",60084),symbolCustomColor:(0,s.register)("symbol-customcolor",60252),exportIcon:(0,s.register)("export",60332),workspaceUnspecified:(0,s.register)("workspace-unspecified",60355),newLine:(0,s.register)("newline",60394),thumbsDownFilled:(0,s.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,s.register)("thumbsup-filled",60436),gitFetch:(0,s.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,s.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,s.register)("debug-breakpoint-pending",60377)},t.Codicon={...N.codiconsLibrary,...t.codiconsDerived}}),define(ge[61],pe([1,0,7]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.deepClone=N,t.deepFreeze=x,t.cloneAndChange=_,t.mixin=m,t.equals=p,t.safeStringify=w,t.distinct=W,t.getCaseInsensitive=h,t.filter=d,t.getAllPropertyNames=e,t.getAllMethodNames=i,t.createProxyObject=r;function N(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const g=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([D,a])=>{g[D]=a&&typeof a=="object"?N(a):a}),g}function x(u){if(!u||typeof u!="object")return u;const g=[u];for(;g.length>0;){const D=g.shift();Object.freeze(D);for(const a in D)if(V.call(D,a)){const f=D[a];typeof f=="object"&&!Object.isFrozen(f)&&!(0,s.isTypedArray)(f)&&g.push(f)}}return u}const V=Object.prototype.hasOwnProperty;function _(u,g){return A(u,g,new Set)}function A(u,g,D){if((0,s.isUndefinedOrNull)(u))return u;const a=g(u);if(typeof a<"u")return a;if(Array.isArray(u)){const f=[];for(const o of u)f.push(A(o,g,D));return f}if((0,s.isObject)(u)){if(D.has(u))throw new Error("Cannot clone recursive data-structure");D.add(u);const f={};for(const o in u)V.call(u,o)&&(f[o]=A(u[o],g,D));return D.delete(u),f}return u}function m(u,g,D=!0){return(0,s.isObject)(u)?((0,s.isObject)(g)&&Object.keys(g).forEach(a=>{a in u?D&&((0,s.isObject)(u[a])&&(0,s.isObject)(g[a])?m(u[a],g[a],D):u[a]=g[a]):u[a]=g[a]}),u):g}function p(u,g){if(u===g)return!0;if(u==null||g===null||g===void 0||typeof u!=typeof g||typeof u!="object"||Array.isArray(u)!==Array.isArray(g))return!1;let D,a;if(Array.isArray(u)){if(u.length!==g.length)return!1;for(D=0;D<u.length;D++)if(!p(u[D],g[D]))return!1}else{const f=[];for(a in u)f.push(a);f.sort();const o=[];for(a in g)o.push(a);if(o.sort(),!p(f,o))return!1;for(D=0;D<f.length;D++)if(!p(u[f[D]],g[f[D]]))return!1}return!0}function w(u){const g=new Set;return JSON.stringify(u,(D,a)=>{if((0,s.isObject)(a)||Array.isArray(a)){if(g.has(a))return"[Circular]";g.add(a)}return a})}function W(u,g){const D=Object.create(null);return!u||!g||Object.keys(g).forEach(f=>{const o=u[f],C=g[f];p(o,C)||(D[f]=C)}),D}function h(u,g){const D=g.toLowerCase(),a=Object.keys(u).find(f=>f.toLowerCase()===D);return a?u[a]:u[g]}function d(u,g){const D=Object.create(null);for(const[a,f]of Object.entries(u))g(a,f)&&(D[a]=f);return D}function e(u){let g=[];for(;Object.prototype!==u;)g=g.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return g}function i(u){const g=[];for(const D of e(u))typeof u[D]=="function"&&g.push(D);return g}function r(u,g){const D=f=>function(){const o=Array.prototype.slice.call(arguments,0);return g(f,o)},a={};for(const f of u)a[f]=D(f);return a}}),define(ge[19],pe([1,0,18]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.themeColorFromId=x;var N;(function(_){function A(m){return m&&typeof m=="object"&&typeof m.id=="string"}_.isThemeColor=A})(N||(t.ThemeColor=N={}));function x(_){return{id:_}}var V;(function(_){_.iconNameSegment="[A-Za-z0-9]+",_.iconNameExpression="[A-Za-z0-9-]+",_.iconModifierExpression="~[A-Za-z]+",_.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${_.iconNameExpression})(${_.iconModifierExpression})?$`);function m(g){const D=A.exec(g.id);if(!D)return m(s.Codicon.error);const[,a,f]=D,o=["codicon","codicon-"+a];return f&&o.push("codicon-modifier-"+f.substring(1)),o}_.asClassNameArray=m;function p(g){return m(g).join(" ")}_.asClassName=p;function w(g){return"."+m(g).join(".")}_.asCSSSelector=w;function W(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||N.isThemeColor(g.color))}_.isThemeIcon=W;const h=new RegExp(`^\\$\\((${_.iconNameExpression}(?:${_.iconModifierExpression})?)\\)$`);function d(g){const D=h.exec(g);if(!D)return;const[,a]=D;return{id:a}}_.fromString=d;function e(g){return{id:g}}_.fromId=e;function i(g,D){let a=g.id;const f=a.lastIndexOf("~");return f!==-1&&(a=a.substring(0,f)),D&&(a=`${a}~${D}`),{id:a}}_.modify=i;function r(g){const D=g.id.lastIndexOf("~");if(D!==-1)return g.id.substring(D+1)}_.getModifier=r;function u(g,D){return g.id===D.id&&g.color?.id===D.color?.id}_.isEqual=u})(V||(t.ThemeIcon=V={}))}),define(ge[45],pe([1,0,43,10,19]),function(ie,t,s,N,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.escapeIcons=m,t.markdownEscapeEscapedIcons=w,t.stripIcons=h,t.getCodiconAriaLabel=d,t.parseLabelWithIcons=i,t.matchesFuzzyIconAware=r;const V="$(",_=new RegExp(`\\$\\(${x.ThemeIcon.iconNameExpression}(?:${x.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${_.source}`,"g");function m(u){return u.replace(A,(g,D)=>D?g:`\\${g}`)}const p=new RegExp(`\\\\${_.source}`,"g");function w(u){return u.replace(p,g=>`\\${g}`)}const W=new RegExp(`(\\s)?(\\\\)?${_.source}(\\s)?`,"g");function h(u){return u.indexOf(V)===-1?u:u.replace(W,(g,D,a,f)=>a?g:D||f||"")}function d(u){return u?u.replace(/\$\((.*?)\)/g,(g,D)=>` ${D} `).trim():""}const e=new RegExp(`\\$\\(${x.ThemeIcon.iconNameCharacter}+\\)`,"g");function i(u){e.lastIndex=0;let g="";const D=[];let a=0;for(;;){const f=e.lastIndex,o=e.exec(u),C=u.substring(f,o?.index);if(C.length>0){g+=C;for(let F=0;F<C.length;F++)D.push(a)}if(!o)break;a+=o[0].length}return{text:g,iconOffsets:D}}function r(u,g,D=!1){const{text:a,iconOffsets:f}=g;if(!f||f.length===0)return(0,s.matchesFuzzy)(u,a,D);const o=(0,N.ltrim)(a," "),C=a.length-o.length,F=(0,s.matchesFuzzy)(u,o,D);if(F)for(const R of F){const B=f[R.start+C]+C;R.start+=B,R.end+=B}return F}}),define(ge[101],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ge[102],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class s{constructor(x,V){this.sender=x,this.onMessage=V}send(x){try{this.sender.send("vscode:message",x.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=s}),define(ge[34],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0;const s=globalThis.vscode;t.ipcRenderer=s.ipcRenderer,t.ipcMessagePort=s.ipcMessagePort,t.webFrame=s.webFrame,t.process=s.process,t.context=s.context}),define(ge[103],pe([1,0,101,34]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=V;let x=0;function V(A,m,p){const w=[],W=x++,h=`vscode:onContextMenu${W}`,d=(e,i,r)=>{w[i].click?.(r)};N.ipcRenderer.once(h,d),N.ipcRenderer.once(s.CONTEXT_MENU_CLOSE_CHANNEL,(e,i)=>{i===W&&(N.ipcRenderer.removeListener(h,d),p?.())}),N.ipcRenderer.send(s.CONTEXT_MENU_CHANNEL,W,A.map(e=>_(e,w)),h,m)}function _(A,m){const p={id:m.length,label:A.label,type:A.type,accelerator:A.accelerator,checked:A.checked,enabled:typeof A.enabled=="boolean"?A.enabled:!0,visible:typeof A.visible=="boolean"?A.visible:!0};return m.push(A),Array.isArray(A.submenu)&&(p.submenu=A.submenu.map(w=>_(w,m))),p}}),define(ge[62],pe([8]),{}),define(ge[104],pe([8]),{}),define(ge[105],pe([8]),{}),define(ge[106],pe([8]),{}),define(ge[107],pe([1,0,105,106]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(ge[108],pe([8]),{}),define(ge[109],pe([8]),{}),define(ge[110],pe([8]),{}),define(ge[111],pe([8]),{}),define(ge[112],pe([8]),{}),define(ge[113],pe([8]),{}),define(ge[114],pe([8]),{}),define(ge[115],pe([8]),{}),define(ge[116],pe([8]),{}),define(ge[117],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(ge[118],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/findinput/findInput",t)}),define(ge[119],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(ge[120],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/hover/updatableHoverWidget",t)}),define(ge[121],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(ge[122],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(ge[123],pe([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/tree/abstractTree",t)}),define(ge[124],pe([13,11]),function(ie,t){return ie.create("vs/base/common/actions",t)}),define(ge[46],pe([1,0,4,2,124]),function(ie,t,s,N,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0,t.toAction=w;class V extends N.Disposable{constructor(h,d="",e="",i=!0,r){super(),this._onDidChange=this._register(new s.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=h,this._label=d,this._cssClass=e,this._enabled=i,this._actionCallback=r}get id(){return this._id}get label(){return this._label}set label(h){this._setLabel(h)}_setLabel(h){this._label!==h&&(this._label=h,this._onDidChange.fire({label:h}))}get tooltip(){return this._tooltip||""}set tooltip(h){this._setTooltip(h)}_setTooltip(h){this._tooltip!==h&&(this._tooltip=h,this._onDidChange.fire({tooltip:h}))}get class(){return this._cssClass}set class(h){this._setClass(h)}_setClass(h){this._cssClass!==h&&(this._cssClass=h,this._onDidChange.fire({class:h}))}get enabled(){return this._enabled}set enabled(h){this._setEnabled(h)}_setEnabled(h){this._enabled!==h&&(this._enabled=h,this._onDidChange.fire({enabled:h}))}get checked(){return this._checked}set checked(h){this._setChecked(h)}_setChecked(h){this._checked!==h&&(this._checked=h,this._onDidChange.fire({checked:h}))}async run(h,d){this._actionCallback&&await this._actionCallback(h)}}t.Action=V;class _ extends N.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new s.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new s.Emitter),this.onDidRun=this._onDidRun.event}async run(h,d){if(!h.enabled)return;this._onWillRun.fire({action:h});let e;try{await this.runAction(h,d)}catch(i){e=i}this._onDidRun.fire({action:h,error:e})}async runAction(h,d){await h.run(d)}}t.ActionRunner=_;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...h){let d=[];for(const e of h)e.length&&(d.length?d=[...d,new A,...e]:d=e);return d}static{this.ID="vs.actions.separator"}async run(){}}t.Separator=A;class m{get actions(){return this._actions}constructor(h,d,e,i){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=h,this.label=d,this.class=i,this._actions=e}async run(){}}t.SubmenuAction=m;class p extends V{static{this.ID="vs.actions.empty"}constructor(){super(p.ID,x.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=p;function w(W){return{id:W.id,label:W.label,class:W.class,enabled:W.enabled??!0,checked:W.checked,run:async(...h)=>W.run(...h),tooltip:W.label}}}),define(ge[125],pe([13,11]),function(ie,t){return ie.create("vs/base/common/platform",t)}),define(ge[5],pe([1,0,125]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.webWorkerOrigin=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.Platform=t.LANGUAGE_DEFAULT=void 0,t.PlatformToString=C,t.isLittleEndian=O,t.isBigSurOrNewer=$,t.LANGUAGE_DEFAULT="en";let N=!1,x=!1,V=!1,_=!1,A=!1,m=!1,p=!1,w=!1,W=!1,h=!1,d,e=t.LANGUAGE_DEFAULT,i=t.LANGUAGE_DEFAULT,r,u;const g=globalThis;let D;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?D=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(D=process);const a=typeof D?.versions?.electron=="string",f=a&&D?.type==="renderer";if(typeof D=="object"){N=D.platform==="win32",x=D.platform==="darwin",V=D.platform==="linux",_=V&&!!D.env.SNAP&&!!D.env.SNAP_REVISION,p=a,W=!!D.env.CI||!!D.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const k=D.env.VSCODE_NLS_CONFIG;if(k)try{const M=JSON.parse(k),I=M.availableLanguages["*"];d=M.locale,i=M.osLocale,e=I||t.LANGUAGE_DEFAULT,r=M._translationsConfigFile}catch{}A=!0}else typeof navigator=="object"&&!f?(u=navigator.userAgent,N=u.indexOf("Windows")>=0,x=u.indexOf("Macintosh")>=0,w=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,V=u.indexOf("Linux")>=0,h=u?.indexOf("Mobi")>=0,m=!0,d=s.getConfiguredDefaultLocale(s.localize(0,null))||t.LANGUAGE_DEFAULT,e=d,i=navigator.language):console.error("Unable to resolve platform.");var o;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(o||(t.Platform=o={}));function C(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let F=0;x?F=1:N?F=3:V&&(F=2),t.isWindows=N,t.isMacintosh=x,t.isLinux=V,t.isLinuxSnap=_,t.isNative=A,t.isElectron=p,t.isWeb=m,t.isWebWorker=m&&typeof g.importScripts=="function",t.webWorkerOrigin=t.isWebWorker?g.origin:void 0,t.isIOS=w,t.isMobile=h,t.isCI=W,t.platform=F,t.userAgent=u,t.language=e;var R;(function(k){function M(){return t.language}k.value=M;function I(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}k.isDefaultVariant=I;function q(){return t.language==="en"}k.isDefault=q})(R||(t.Language=R={})),t.locale=d,t.platformLocale=i,t.translationsConfigFile=r,t.setTimeout0IsFaster=typeof g.postMessage=="function"&&!g.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const k=[];g.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let q=0,X=k.length;q<X;q++){const ce=k[q];if(ce.id===I.data.vscodeScheduleAsyncWork){k.splice(q,1),ce.callback();return}}});let M=0;return I=>{const q=++M;k.push({id:q,callback:I}),g.postMessage({vscodeScheduleAsyncWork:q},"*")}}return k=>setTimeout(k)})();var B;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(B||(t.OperatingSystem=B={})),t.OS=x||w?2:N?1:3;let P=!0,b=!1;function O(){if(!b){b=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,P=new Uint16Array(k.buffer)[0]===513}return P}t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0);function $(k){return parseFloat(k)>=20}}),define(ge[126],pe([1,0,17,22,5]),function(ie,t,s,N,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var V;(function(_){_[_.Always=0]="Always",_[_.FullScreen=1]="FullScreen",_[_.None=2]="None"})(V||(t.KeyboardSupport=V={})),t.BrowserFeatures={clipboard:{writeText:x.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:x.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:x.isNative||s.isStandalone()?0:navigator.keyboard||s.isSafari?1:2,touch:"ontouchstart"in N.mainWindow||navigator.maxTouchPoints>0,pointerEvents:N.mainWindow.PointerEvent&&("ontouchstart"in N.mainWindow||navigator.maxTouchPoints>0)}}),define(ge[15],pe([1,0,17,54,87,5]),function(ie,t,s,N,x,V){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=void 0,t.printKeyboardEvent=W,t.printStandardKeyboardEvent=h;function _(e){if(e.charCode){const r=String.fromCharCode(e.charCode).toUpperCase();return N.KeyCodeUtils.fromString(r)}const i=e.keyCode;if(i===3)return 7;if(s.isFirefox)switch(i){case 59:return 85;case 60:if(V.isLinux)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(V.isMacintosh)return 57;break}else if(s.isWebKit){if(V.isMacintosh&&i===93)return 57;if(!V.isMacintosh&&i===92)return 57}return N.EVENT_KEY_CODE_MAP[i]||0}const A=V.isMacintosh?256:2048,m=512,p=1024,w=V.isMacintosh?2048:256;function W(e){const i=[];return e.ctrlKey&&i.push("ctrl"),e.shiftKey&&i.push("shift"),e.altKey&&i.push("alt"),e.metaKey&&i.push("meta"),`modifiers: [${i.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function h(e){const i=[];return e.ctrlKey&&i.push("ctrl"),e.shiftKey&&i.push("shift"),e.altKey&&i.push("alt"),e.metaKey&&i.push("meta"),`modifiers: [${i.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${N.KeyCodeUtils.toString(e.keyCode)}')`}class d{constructor(i){this._standardKeyboardEventBrand=!0;const r=i;this.browserEvent=r,this.target=r.target,this.ctrlKey=r.ctrlKey,this.shiftKey=r.shiftKey,this.altKey=r.altKey,this.metaKey=r.metaKey,this.altGraphKey=r.getModifierState?.("AltGraph"),this.keyCode=_(r),this.code=r.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this._asKeybinding=this._computeKeybinding(),this._asKeyCodeChord=this._computeKeyCodeChord()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this._asKeyCodeChord}equals(i){return this._asKeybinding===i}_computeKeybinding(){let i=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(i=this.keyCode);let r=0;return this.ctrlKey&&(r|=A),this.altKey&&(r|=m),this.shiftKey&&(r|=p),this.metaKey&&(r|=w),r|=i,r}_computeKeyCodeChord(){let i=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(i=this.keyCode),new x.KeyCodeChord(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,i)}}t.StandardKeyboardEvent=d}),define(ge[20],pe([1,0,17,79,5]),function(ie,t,s,N,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class V{constructor(p,w){this.timestamp=Date.now(),this.browserEvent=w,this.leftButton=w.button===0,this.middleButton=w.button===1,this.rightButton=w.button===2,this.buttons=w.buttons,this.target=w.target,this.detail=w.detail||1,w.type==="dblclick"&&(this.detail=2),this.ctrlKey=w.ctrlKey,this.shiftKey=w.shiftKey,this.altKey=w.altKey,this.metaKey=w.metaKey,typeof w.pageX=="number"?(this.posx=w.pageX,this.posy=w.pageY):(this.posx=w.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=w.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const W=N.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(p,w.view);this.posx-=W.left,this.posy-=W.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=V;class _ extends V{constructor(p,w){super(p,w),this.dataTransfer=w.dataTransfer}}t.DragMouseEvent=_;class A{constructor(p,w=0,W=0){this.browserEvent=p||null,this.target=p?p.target||p.targetNode||p.srcElement:null,this.deltaY=W,this.deltaX=w;let h=!1;if(s.isChrome){const d=navigator.userAgent.match(/Chrome\/(\d+)/);h=(d?parseInt(d[1]):123)<=122}if(p){const d=p,e=p,i=p.view?.devicePixelRatio||1;if(typeof d.wheelDeltaY<"u")h?this.deltaY=d.wheelDeltaY/(120*i):this.deltaY=d.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(p.type==="wheel"){const r=p;r.deltaMode===r.DOM_DELTA_LINE?s.isFirefox&&!x.isMacintosh?this.deltaY=-p.deltaY/3:this.deltaY=-p.deltaY:this.deltaY=-p.deltaY/40}if(typeof d.wheelDeltaX<"u")s.isSafari&&x.isWindows?this.deltaX=-(d.wheelDeltaX/120):h?this.deltaX=d.wheelDeltaX/(120*i):this.deltaX=d.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-p.detail/3;else if(p.type==="wheel"){const r=p;r.deltaMode===r.DOM_DELTA_LINE?s.isFirefox&&!x.isMacintosh?this.deltaX=-p.deltaX/3:this.deltaX=-p.deltaX:this.deltaX=-p.deltaX/40}this.deltaY===0&&this.deltaX===0&&p.wheelDelta&&(h?this.deltaY=p.wheelDelta/(120*i):this.deltaY=p.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=A}),define(ge[127],pe([1,0,5]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let N;const x=globalThis.vscode;if(typeof x<"u"&&typeof x.process<"u"){const V=x.process;N={get platform(){return V.platform},get arch(){return V.arch},get env(){return V.env},cwd(){return V.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return s.isWindows?"win32":s.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=N.cwd,t.env=N.env,t.platform=N.platform,t.arch=N.arch}),define(ge[25],pe([1,0,127]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const N=65,x=97,V=90,_=122,A=46,m=47,p=92,w=58,W=63;class h extends Error{constructor(C,F,R){let B;typeof F=="string"&&F.indexOf("not ")===0?(B="must not be",F=F.replace(/^not /,"")):B="must be";const P=C.indexOf(".")!==-1?"property":"argument";let b=`The "${C}" ${P} ${B} of type ${F}`;b+=`. Received type ${typeof R}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function d(o,C){if(o===null||typeof o!="object")throw new h(C,"Object",o)}function e(o,C){if(typeof o!="string")throw new h(C,"string",o)}const i=s.platform==="win32";function r(o){return o===m||o===p}function u(o){return o===m}function g(o){return o>=N&&o<=V||o>=x&&o<=_}function D(o,C,F,R){let B="",P=0,b=-1,O=0,$=0;for(let k=0;k<=o.length;++k){if(k<o.length)$=o.charCodeAt(k);else{if(R($))break;$=m}if(R($)){if(!(b===k-1||O===1))if(O===2){if(B.length<2||P!==2||B.charCodeAt(B.length-1)!==A||B.charCodeAt(B.length-2)!==A){if(B.length>2){const M=B.lastIndexOf(F);M===-1?(B="",P=0):(B=B.slice(0,M),P=B.length-1-B.lastIndexOf(F)),b=k,O=0;continue}else if(B.length!==0){B="",P=0,b=k,O=0;continue}}C&&(B+=B.length>0?`${F}..`:"..",P=2)}else B.length>0?B+=`${F}${o.slice(b+1,k)}`:B=o.slice(b+1,k),P=k-b-1;b=k,O=0}else $===A&&O!==-1?++O:O=-1}return B}function a(o,C){d(C,"pathObject");const F=C.dir||C.root,R=C.base||`${C.name||""}${C.ext||""}`;return F?F===C.root?`${F}${R}`:`${F}${o}${R}`:R}t.win32={resolve(...o){let C="",F="",R=!1;for(let B=o.length-1;B>=-1;B--){let P;if(B>=0){if(P=o[B],e(P,"path"),P.length===0)continue}else C.length===0?P=s.cwd():(P=s.env[`=${C}`]||s.cwd(),(P===void 0||P.slice(0,2).toLowerCase()!==C.toLowerCase()&&P.charCodeAt(2)===p)&&(P=`${C}\\`));const b=P.length;let O=0,$="",k=!1;const M=P.charCodeAt(0);if(b===1)r(M)&&(O=1,k=!0);else if(r(M))if(k=!0,r(P.charCodeAt(1))){let I=2,q=I;for(;I<b&&!r(P.charCodeAt(I));)I++;if(I<b&&I!==q){const X=P.slice(q,I);for(q=I;I<b&&r(P.charCodeAt(I));)I++;if(I<b&&I!==q){for(q=I;I<b&&!r(P.charCodeAt(I));)I++;(I===b||I!==q)&&($=`\\\\${X}\\${P.slice(q,I)}`,O=I)}}}else O=1;else g(M)&&P.charCodeAt(1)===w&&($=P.slice(0,2),O=2,b>2&&r(P.charCodeAt(2))&&(k=!0,O=3));if($.length>0)if(C.length>0){if($.toLowerCase()!==C.toLowerCase())continue}else C=$;if(R){if(C.length>0)break}else if(F=`${P.slice(O)}\\${F}`,R=k,k&&C.length>0)break}return F=D(F,!R,"\\",r),R?`${C}\\${F}`:`${C}${F}`||"."},normalize(o){e(o,"path");const C=o.length;if(C===0)return".";let F=0,R,B=!1;const P=o.charCodeAt(0);if(C===1)return u(P)?"\\":o;if(r(P))if(B=!0,r(o.charCodeAt(1))){let O=2,$=O;for(;O<C&&!r(o.charCodeAt(O));)O++;if(O<C&&O!==$){const k=o.slice($,O);for($=O;O<C&&r(o.charCodeAt(O));)O++;if(O<C&&O!==$){for($=O;O<C&&!r(o.charCodeAt(O));)O++;if(O===C)return`\\\\${k}\\${o.slice($)}\\`;O!==$&&(R=`\\\\${k}\\${o.slice($,O)}`,F=O)}}}else F=1;else g(P)&&o.charCodeAt(1)===w&&(R=o.slice(0,2),F=2,C>2&&r(o.charCodeAt(2))&&(B=!0,F=3));let b=F<C?D(o.slice(F),!B,"\\",r):"";return b.length===0&&!B&&(b="."),b.length>0&&r(o.charCodeAt(C-1))&&(b+="\\"),R===void 0?B?`\\${b}`:b:B?`${R}\\${b}`:`${R}${b}`},isAbsolute(o){e(o,"path");const C=o.length;if(C===0)return!1;const F=o.charCodeAt(0);return r(F)||C>2&&g(F)&&o.charCodeAt(1)===w&&r(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let C,F;for(let P=0;P<o.length;++P){const b=o[P];e(b,"path"),b.length>0&&(C===void 0?C=F=b:C+=`\\${b}`)}if(C===void 0)return".";let R=!0,B=0;if(typeof F=="string"&&r(F.charCodeAt(0))){++B;const P=F.length;P>1&&r(F.charCodeAt(1))&&(++B,P>2&&(r(F.charCodeAt(2))?++B:R=!1))}if(R){for(;B<C.length&&r(C.charCodeAt(B));)B++;B>=2&&(C=`\\${C.slice(B)}`)}return t.win32.normalize(C)},relative(o,C){if(e(o,"from"),e(C,"to"),o===C)return"";const F=t.win32.resolve(o),R=t.win32.resolve(C);if(F===R||(o=F.toLowerCase(),C=R.toLowerCase(),o===C))return"";let B=0;for(;B<o.length&&o.charCodeAt(B)===p;)B++;let P=o.length;for(;P-1>B&&o.charCodeAt(P-1)===p;)P--;const b=P-B;let O=0;for(;O<C.length&&C.charCodeAt(O)===p;)O++;let $=C.length;for(;$-1>O&&C.charCodeAt($-1)===p;)$--;const k=$-O,M=b<k?b:k;let I=-1,q=0;for(;q<M;q++){const ce=o.charCodeAt(B+q);if(ce!==C.charCodeAt(O+q))break;ce===p&&(I=q)}if(q!==M){if(I===-1)return R}else{if(k>M){if(C.charCodeAt(O+q)===p)return R.slice(O+q+1);if(q===2)return R.slice(O+q)}b>M&&(o.charCodeAt(B+q)===p?I=q:q===2&&(I=3)),I===-1&&(I=0)}let X="";for(q=B+I+1;q<=P;++q)(q===P||o.charCodeAt(q)===p)&&(X+=X.length===0?"..":"\\..");return O+=I,X.length>0?`${X}${R.slice(O,$)}`:(R.charCodeAt(O)===p&&++O,R.slice(O,$))},toNamespacedPath(o){if(typeof o!="string"||o.length===0)return o;const C=t.win32.resolve(o);if(C.length<=2)return o;if(C.charCodeAt(0)===p){if(C.charCodeAt(1)===p){const F=C.charCodeAt(2);if(F!==W&&F!==A)return`\\\\?\\UNC\\${C.slice(2)}`}}else if(g(C.charCodeAt(0))&&C.charCodeAt(1)===w&&C.charCodeAt(2)===p)return`\\\\?\\${C}`;return o},dirname(o){e(o,"path");const C=o.length;if(C===0)return".";let F=-1,R=0;const B=o.charCodeAt(0);if(C===1)return r(B)?o:".";if(r(B)){if(F=R=1,r(o.charCodeAt(1))){let O=2,$=O;for(;O<C&&!r(o.charCodeAt(O));)O++;if(O<C&&O!==$){for($=O;O<C&&r(o.charCodeAt(O));)O++;if(O<C&&O!==$){for($=O;O<C&&!r(o.charCodeAt(O));)O++;if(O===C)return o;O!==$&&(F=R=O+1)}}}}else g(B)&&o.charCodeAt(1)===w&&(F=C>2&&r(o.charCodeAt(2))?3:2,R=F);let P=-1,b=!0;for(let O=C-1;O>=R;--O)if(r(o.charCodeAt(O))){if(!b){P=O;break}}else b=!1;if(P===-1){if(F===-1)return".";P=F}return o.slice(0,P)},basename(o,C){C!==void 0&&e(C,"ext"),e(o,"path");let F=0,R=-1,B=!0,P;if(o.length>=2&&g(o.charCodeAt(0))&&o.charCodeAt(1)===w&&(F=2),C!==void 0&&C.length>0&&C.length<=o.length){if(C===o)return"";let b=C.length-1,O=-1;for(P=o.length-1;P>=F;--P){const $=o.charCodeAt(P);if(r($)){if(!B){F=P+1;break}}else O===-1&&(B=!1,O=P+1),b>=0&&($===C.charCodeAt(b)?--b===-1&&(R=P):(b=-1,R=O))}return F===R?R=O:R===-1&&(R=o.length),o.slice(F,R)}for(P=o.length-1;P>=F;--P)if(r(o.charCodeAt(P))){if(!B){F=P+1;break}}else R===-1&&(B=!1,R=P+1);return R===-1?"":o.slice(F,R)},extname(o){e(o,"path");let C=0,F=-1,R=0,B=-1,P=!0,b=0;o.length>=2&&o.charCodeAt(1)===w&&g(o.charCodeAt(0))&&(C=R=2);for(let O=o.length-1;O>=C;--O){const $=o.charCodeAt(O);if(r($)){if(!P){R=O+1;break}continue}B===-1&&(P=!1,B=O+1),$===A?F===-1?F=O:b!==1&&(b=1):F!==-1&&(b=-1)}return F===-1||B===-1||b===0||b===1&&F===B-1&&F===R+1?"":o.slice(F,B)},format:a.bind(null,"\\"),parse(o){e(o,"path");const C={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return C;const F=o.length;let R=0,B=o.charCodeAt(0);if(F===1)return r(B)?(C.root=C.dir=o,C):(C.base=C.name=o,C);if(r(B)){if(R=1,r(o.charCodeAt(1))){let I=2,q=I;for(;I<F&&!r(o.charCodeAt(I));)I++;if(I<F&&I!==q){for(q=I;I<F&&r(o.charCodeAt(I));)I++;if(I<F&&I!==q){for(q=I;I<F&&!r(o.charCodeAt(I));)I++;I===F?R=I:I!==q&&(R=I+1)}}}}else if(g(B)&&o.charCodeAt(1)===w){if(F<=2)return C.root=C.dir=o,C;if(R=2,r(o.charCodeAt(2))){if(F===3)return C.root=C.dir=o,C;R=3}}R>0&&(C.root=o.slice(0,R));let P=-1,b=R,O=-1,$=!0,k=o.length-1,M=0;for(;k>=R;--k){if(B=o.charCodeAt(k),r(B)){if(!$){b=k+1;break}continue}O===-1&&($=!1,O=k+1),B===A?P===-1?P=k:M!==1&&(M=1):P!==-1&&(M=-1)}return O!==-1&&(P===-1||M===0||M===1&&P===O-1&&P===b+1?C.base=C.name=o.slice(b,O):(C.name=o.slice(b,P),C.base=o.slice(b,O),C.ext=o.slice(P,O))),b>0&&b!==R?C.dir=o.slice(0,b-1):C.dir=C.root,C},sep:"\\",delimiter:";",win32:null,posix:null};const f=(()=>{if(i){const o=/\\/g;return()=>{const C=s.cwd().replace(o,"/");return C.slice(C.indexOf("/"))}}return()=>s.cwd()})();t.posix={resolve(...o){let C="",F=!1;for(let R=o.length-1;R>=-1&&!F;R--){const B=R>=0?o[R]:f();e(B,"path"),B.length!==0&&(C=`${B}/${C}`,F=B.charCodeAt(0)===m)}return C=D(C,!F,"/",u),F?`/${C}`:C.length>0?C:"."},normalize(o){if(e(o,"path"),o.length===0)return".";const C=o.charCodeAt(0)===m,F=o.charCodeAt(o.length-1)===m;return o=D(o,!C,"/",u),o.length===0?C?"/":F?"./":".":(F&&(o+="/"),C?`/${o}`:o)},isAbsolute(o){return e(o,"path"),o.length>0&&o.charCodeAt(0)===m},join(...o){if(o.length===0)return".";let C;for(let F=0;F<o.length;++F){const R=o[F];e(R,"path"),R.length>0&&(C===void 0?C=R:C+=`/${R}`)}return C===void 0?".":t.posix.normalize(C)},relative(o,C){if(e(o,"from"),e(C,"to"),o===C||(o=t.posix.resolve(o),C=t.posix.resolve(C),o===C))return"";const F=1,R=o.length,B=R-F,P=1,b=C.length-P,O=B<b?B:b;let $=-1,k=0;for(;k<O;k++){const I=o.charCodeAt(F+k);if(I!==C.charCodeAt(P+k))break;I===m&&($=k)}if(k===O)if(b>O){if(C.charCodeAt(P+k)===m)return C.slice(P+k+1);if(k===0)return C.slice(P+k)}else B>O&&(o.charCodeAt(F+k)===m?$=k:k===0&&($=0));let M="";for(k=F+$+1;k<=R;++k)(k===R||o.charCodeAt(k)===m)&&(M+=M.length===0?"..":"/..");return`${M}${C.slice(P+$)}`},toNamespacedPath(o){return o},dirname(o){if(e(o,"path"),o.length===0)return".";const C=o.charCodeAt(0)===m;let F=-1,R=!0;for(let B=o.length-1;B>=1;--B)if(o.charCodeAt(B)===m){if(!R){F=B;break}}else R=!1;return F===-1?C?"/":".":C&&F===1?"//":o.slice(0,F)},basename(o,C){C!==void 0&&e(C,"ext"),e(o,"path");let F=0,R=-1,B=!0,P;if(C!==void 0&&C.length>0&&C.length<=o.length){if(C===o)return"";let b=C.length-1,O=-1;for(P=o.length-1;P>=0;--P){const $=o.charCodeAt(P);if($===m){if(!B){F=P+1;break}}else O===-1&&(B=!1,O=P+1),b>=0&&($===C.charCodeAt(b)?--b===-1&&(R=P):(b=-1,R=O))}return F===R?R=O:R===-1&&(R=o.length),o.slice(F,R)}for(P=o.length-1;P>=0;--P)if(o.charCodeAt(P)===m){if(!B){F=P+1;break}}else R===-1&&(B=!1,R=P+1);return R===-1?"":o.slice(F,R)},extname(o){e(o,"path");let C=-1,F=0,R=-1,B=!0,P=0;for(let b=o.length-1;b>=0;--b){const O=o.charCodeAt(b);if(O===m){if(!B){F=b+1;break}continue}R===-1&&(B=!1,R=b+1),O===A?C===-1?C=b:P!==1&&(P=1):C!==-1&&(P=-1)}return C===-1||R===-1||P===0||P===1&&C===R-1&&C===F+1?"":o.slice(C,R)},format:a.bind(null,"/"),parse(o){e(o,"path");const C={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return C;const F=o.charCodeAt(0)===m;let R;F?(C.root="/",R=1):R=0;let B=-1,P=0,b=-1,O=!0,$=o.length-1,k=0;for(;$>=R;--$){const M=o.charCodeAt($);if(M===m){if(!O){P=$+1;break}continue}b===-1&&(O=!1,b=$+1),M===A?B===-1?B=$:k!==1&&(k=1):B!==-1&&(k=-1)}if(b!==-1){const M=P===0&&F?1:P;B===-1||k===0||k===1&&B===b-1&&B===P+1?C.base=C.name=o.slice(M,b):(C.name=o.slice(M,B),C.base=o.slice(M,b),C.ext=o.slice(B,b))}return P>0?C.dir=o.slice(0,P-1):F&&(C.dir="/"),C},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=i?t.win32.normalize:t.posix.normalize,t.isAbsolute=i?t.win32.isAbsolute:t.posix.isAbsolute,t.join=i?t.win32.join:t.posix.join,t.resolve=i?t.win32.resolve:t.posix.resolve,t.relative=i?t.win32.relative:t.posix.relative,t.dirname=i?t.win32.dirname:t.posix.dirname,t.basename=i?t.win32.basename:t.posix.basename,t.extname=i?t.win32.extname:t.posix.extname,t.format=i?t.win32.format:t.posix.format,t.parse=i?t.win32.parse:t.posix.parse,t.toNamespacedPath=i?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=i?t.win32.sep:t.posix.sep,t.delimiter=i?t.win32.delimiter:t.posix.delimiter}),define(ge[128],pe([1,0,25,5,10,7]),function(ie,t,s,N,x,V){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isPathSeparator=_,t.toSlashes=A,t.toPosixPath=m,t.getRoot=p,t.isUNC=w,t.isValidBasename=e,t.isEqual=i,t.isEqualOrParent=r,t.isWindowsDriveLetter=u,t.sanitizeFilePath=g,t.isRootOrDriveLetter=D,t.hasDriveLetter=a,t.getDriveLetter=f,t.indexOfPath=o,t.parseLineAndColumnAware=C,t.randomPath=B;function _(P){return P===47||P===92}function A(P){return P.replace(/[\\/]/g,s.posix.sep)}function m(P){return P.indexOf("/")===-1&&(P=A(P)),/^[a-zA-Z]:(\/|$)/.test(P)&&(P="/"+P),P}function p(P,b=s.posix.sep){if(!P)return"";const O=P.length,$=P.charCodeAt(0);if(_($)){if(_(P.charCodeAt(1))&&!_(P.charCodeAt(2))){let M=3;const I=M;for(;M<O&&!_(P.charCodeAt(M));M++);if(I!==M&&!_(P.charCodeAt(M+1))){for(M+=1;M<O;M++)if(_(P.charCodeAt(M)))return P.slice(0,M+1).replace(/[\\/]/g,b)}}return b}else if(u($)&&P.charCodeAt(1)===58)return _(P.charCodeAt(2))?P.slice(0,2)+b:P.slice(0,2);let k=P.indexOf("://");if(k!==-1){for(k+=3;k<O;k++)if(_(P.charCodeAt(k)))return P.slice(0,k+1)}return""}function w(P){if(!N.isWindows||!P||P.length<5)return!1;let b=P.charCodeAt(0);if(b!==92||(b=P.charCodeAt(1),b!==92))return!1;let O=2;const $=O;for(;O<P.length&&(b=P.charCodeAt(O),b!==92);O++);return!($===O||(b=P.charCodeAt(O+1),isNaN(b)||b===92))}const W=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(P,b=N.isWindows){const O=b?W:h;return!(!P||P.length===0||/^\s+$/.test(P)||(O.lastIndex=0,O.test(P))||b&&d.test(P)||P==="."||P===".."||b&&P[P.length-1]==="."||b&&P.length!==P.trim().length||P.length>255)}function i(P,b,O){const $=P===b;return!O||$?$:!P||!b?!1:(0,x.equalsIgnoreCase)(P,b)}function r(P,b,O,$=s.sep){if(P===b)return!0;if(!P||!b||b.length>P.length)return!1;if(O){if(!(0,x.startsWithIgnoreCase)(P,b))return!1;if(b.length===P.length)return!0;let M=b.length;return b.charAt(b.length-1)===$&&M--,P.charAt(M)===$}return b.charAt(b.length-1)!==$&&(b+=$),P.indexOf(b)===0}function u(P){return P>=65&&P<=90||P>=97&&P<=122}function g(P,b){return N.isWindows&&P.endsWith(":")&&(P+=s.sep),(0,s.isAbsolute)(P)||(P=(0,s.join)(b,P)),P=(0,s.normalize)(P),N.isWindows?(P=(0,x.rtrim)(P,s.sep),P.endsWith(":")&&(P+=s.sep)):(P=(0,x.rtrim)(P,s.sep),P||(P=s.sep)),P}function D(P){const b=(0,s.normalize)(P);return N.isWindows?P.length>3?!1:a(b)&&(P.length===2||b.charCodeAt(2)===92):b===s.posix.sep}function a(P,b=N.isWindows){return b?u(P.charCodeAt(0))&&P.charCodeAt(1)===58:!1}function f(P,b=N.isWindows){return a(P,b)?P[0]:void 0}function o(P,b,O){return b.length>P.length?-1:P===b?0:(O&&(P=P.toLowerCase(),b=b.toLowerCase()),P.indexOf(b))}function C(P){const b=P.split(":");let O,$,k;for(const M of b){const I=Number(M);(0,V.isNumber)(I)?$===void 0?$=I:k===void 0&&(k=I):O=O?[O,M].join(":"):M}if(!O)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:O,line:$!==void 0?$:void 0,column:k!==void 0?k:$!==void 0?1:void 0}}const F="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",R="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function B(P,b,O=8){let $="";for(let M=0;M<O;M++){let I;M===0&&N.isWindows&&!b&&(O===3||O===4)?I=R:I=F,$+=I.charAt(Math.floor(Math.random()*I.length))}let k;return b?k=`${b}-${$}`:k=$,P?(0,s.join)(P,k):k}}),define(ge[129],pe([1,0,25]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Mimes=void 0,t.getMediaOrTextMime=V,t.getMediaMime=_,t.getExtensionForMimeType=A,t.normalizeMimeType=p,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},x={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function V(w){const W=(0,s.extname)(w),h=N[W.toLowerCase()];return h!==void 0?h:_(w)}function _(w){const W=(0,s.extname)(w);return x[W.toLowerCase()]}function A(w){for(const W in x)if(x[W]===w)return W}const m=/^(.+)\/(.+?)(;.+)?$/;function p(w,W){const h=m.exec(w);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:W?void 0:w}}),define(ge[16],pe([1,0,25,5]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.isUriComponents=e,t.uriToFsPath=a;const x=/^\w[\w\d+.-]*$/,V=/^\//,_=/^\/\//;function A(R,B){if(!R.scheme&&B)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!x.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!V.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(R,B){return!R&&!B?"file":R}function p(R,B){switch(R){case"https":case"http":case"file":B?B[0]!==W&&(B=W+B):B=W;break}return B}const w="",W="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(B){return B instanceof d?!0:B?typeof B.authority=="string"&&typeof B.fragment=="string"&&typeof B.path=="string"&&typeof B.query=="string"&&typeof B.scheme=="string"&&typeof B.fsPath=="string"&&typeof B.with=="function"&&typeof B.toString=="function":!1}constructor(B,P,b,O,$,k=!1){typeof B=="object"?(this.scheme=B.scheme||w,this.authority=B.authority||w,this.path=B.path||w,this.query=B.query||w,this.fragment=B.fragment||w):(this.scheme=m(B,k),this.authority=P||w,this.path=p(this.scheme,b||w),this.query=O||w,this.fragment=$||w,A(this,k))}get fsPath(){return a(this,!1)}with(B){if(!B)return this;let{scheme:P,authority:b,path:O,query:$,fragment:k}=B;return P===void 0?P=this.scheme:P===null&&(P=w),b===void 0?b=this.authority:b===null&&(b=w),O===void 0?O=this.path:O===null&&(O=w),$===void 0?$=this.query:$===null&&($=w),k===void 0?k=this.fragment:k===null&&(k=w),P===this.scheme&&b===this.authority&&O===this.path&&$===this.query&&k===this.fragment?this:new r(P,b,O,$,k)}static parse(B,P=!1){const b=h.exec(B);return b?new r(b[2]||w,F(b[4]||w),F(b[5]||w),F(b[7]||w),F(b[9]||w),P):new r(w,w,w,w,w)}static file(B){let P=w;if(N.isWindows&&(B=B.replace(/\\/g,W)),B[0]===W&&B[1]===W){const b=B.indexOf(W,2);b===-1?(P=B.substring(2),B=W):(P=B.substring(2,b),B=B.substring(b)||W)}return new r("file",P,B,w,w)}static from(B,P){return new r(B.scheme,B.authority,B.path,B.query,B.fragment,P)}static joinPath(B,...P){if(!B.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return N.isWindows&&B.scheme==="file"?b=d.file(s.win32.join(a(B,!0),...P)).path:b=s.posix.join(B.path,...P),B.with({path:b})}toString(B=!1){return f(this,B)}toJSON(){return this}static revive(B){if(B){if(B instanceof d)return B;{const P=new r(B);return P._formatted=B.external??null,P._fsPath=B._sep===i?B.fsPath??null:null,P}}else return B}}t.URI=d;function e(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}const i=N.isWindows?1:void 0;class r extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(B=!1){return B?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const B={$mid:1};return this._fsPath&&(B.fsPath=this._fsPath,B._sep=i),this._formatted&&(B.external=this._formatted),this.path&&(B.path=this.path),this.scheme&&(B.scheme=this.scheme),this.authority&&(B.authority=this.authority),this.query&&(B.query=this.query),this.fragment&&(B.fragment=this.fragment),B}}const u={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function g(R,B,P){let b,O=-1;for(let $=0;$<R.length;$++){const k=R.charCodeAt($);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||B&&k===47||P&&k===91||P&&k===93||P&&k===58)O!==-1&&(b+=encodeURIComponent(R.substring(O,$)),O=-1),b!==void 0&&(b+=R.charAt($));else{b===void 0&&(b=R.substr(0,$));const M=u[k];M!==void 0?(O!==-1&&(b+=encodeURIComponent(R.substring(O,$)),O=-1),b+=M):O===-1&&(O=$)}}return O!==-1&&(b+=encodeURIComponent(R.substring(O))),b!==void 0?b:R}function D(R){let B;for(let P=0;P<R.length;P++){const b=R.charCodeAt(P);b===35||b===63?(B===void 0&&(B=R.substr(0,P)),B+=u[b]):B!==void 0&&(B+=R[P])}return B!==void 0?B:R}function a(R,B){let P;return R.authority&&R.path.length>1&&R.scheme==="file"?P=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===47&&(R.path.charCodeAt(1)>=65&&R.path.charCodeAt(1)<=90||R.path.charCodeAt(1)>=97&&R.path.charCodeAt(1)<=122)&&R.path.charCodeAt(2)===58?B?P=R.path.substr(1):P=R.path[1].toLowerCase()+R.path.substr(2):P=R.path,N.isWindows&&(P=P.replace(/\//g,"\\")),P}function f(R,B){const P=B?D:g;let b="",{scheme:O,authority:$,path:k,query:M,fragment:I}=R;if(O&&(b+=O,b+=":"),($||O==="file")&&(b+=W,b+=W),$){let q=$.indexOf("@");if(q!==-1){const X=$.substr(0,q);$=$.substr(q+1),q=X.lastIndexOf(":"),q===-1?b+=P(X,!1,!1):(b+=P(X.substr(0,q),!1,!1),b+=":",b+=P(X.substr(q+1),!1,!0)),b+="@"}$=$.toLowerCase(),q=$.lastIndexOf(":"),q===-1?b+=P($,!1,!0):(b+=P($.substr(0,q),!1,!0),b+=$.substr(q))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const q=k.charCodeAt(1);q>=65&&q<=90&&(k=`/${String.fromCharCode(q+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const q=k.charCodeAt(0);q>=65&&q<=90&&(k=`${String.fromCharCode(q+32)}:${k.substr(2)}`)}b+=P(k,!0,!1)}return M&&(b+="?",b+=P(M,!1,!1)),I&&(b+="#",b+=B?I:g(I,!1,!1)),b}function o(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+o(R.substr(3)):R}}const C=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function F(R){return R.match(C)?R.replace(C,B=>o(B)):R}}),define(ge[63],pe([1,0,42,16]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.stringify=x,t.parse=V,t.revive=A;function x(m){return JSON.stringify(m,_)}function V(m){let p=JSON.parse(m);return p=A(p),p}function _(m,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:p.flags}:p}function A(m,p=0){if(!m||p>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return N.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof s.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let w=0;w<m.length;++w)m[w]=A(m[w],p+1);else for(const w in m)Object.hasOwnProperty.call(m,w)&&(m[w]=A(m[w],p+1))}return m}}),define(ge[35],pe([1,0,6,5,10,16,25]),function(ie,t,s,N,x,V,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.VSCODE_AUTHORITY=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0,t.matchesScheme=m,t.matchesSomeScheme=p,t.getServerRootPath=W;var A;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.codeSetting="code-setting"})(A||(t.Schemas=A={}));function m(e,i){return V.URI.isUri(e)?(0,x.equalsIgnoreCase)(e.scheme,i):(0,x.startsWithIgnoreCase)(e,i+":")}function p(e,...i){return i.some(r=>m(e,r))}t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class w{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(i){this._preferredWebSchema=i}setDelegate(i){this._delegate=i}setServerRootPath(i,r){this._serverRootPath=W(i,r)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return _.posix.join(this._serverRootPath,A.vscodeRemoteResource)}set(i,r,u){this._hosts[i]=r,this._ports[i]=u}setConnectionToken(i,r){this._connectionTokens[i]=r}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(i){if(this._delegate)try{return this._delegate(i)}catch(f){return s.onUnexpectedError(f),i}const r=i.authority;let u=this._hosts[r];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const g=this._ports[r],D=this._connectionTokens[r];let a=`path=${encodeURIComponent(i.path)}`;return typeof D=="string"&&(a+=`&${t.connectionTokenQueryName}=${encodeURIComponent(D)}`),V.URI.from({scheme:N.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${u}:${g}`,path:this._remoteResourcesPath,query:a})}}t.RemoteAuthorities=new w;function W(e,i){return _.posix.join(i??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",t.VSCODE_AUTHORITY="vscode-app";class h{static{this.FALLBACK_AUTHORITY=t.VSCODE_AUTHORITY}asBrowserUri(i){const r=this.toUri(i,ie);return this.uriToBrowserUri(r)}uriToBrowserUri(i){return i.scheme===A.vscodeRemote?t.RemoteAuthorities.rewrite(i):i.scheme===A.file&&(N.isNative||N.webWorkerOrigin===`${A.vscodeFileResource}://${h.FALLBACK_AUTHORITY}`)?i.with({scheme:A.vscodeFileResource,authority:i.authority||h.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(i){const r=this.toUri(i,ie);return this.uriToFileUri(r)}uriToFileUri(i){return i.scheme===A.vscodeFileResource?i.with({scheme:A.file,authority:i.authority!==h.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(i,r){return V.URI.isUri(i)?i:V.URI.parse(r.toUrl(i))}}t.FileAccess=new h;var d;(function(e){const i=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(i.get("3"));const r="vscode-coi";function u(D){let a;typeof D=="string"?a=new URL(D).searchParams:D instanceof URL?a=D.searchParams:V.URI.isUri(D)&&(a=new URL(D.toString(!0)).searchParams);const f=a?.get(r);if(f)return i.get(f)}e.getHeadersFromQuery=u;function g(D,a,f){if(!globalThis.crossOriginIsolated)return;const o=a&&f?"3":f?"2":"1";D instanceof URLSearchParams?D.set(r,o):D[r]=o}e.addSearchParam=g})(d||(t.COI=d={}))}),define(ge[47],pe([1,0,128,35,25,5,10,16]),function(ie,t,s,N,x,V,_,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=void 0,t.originalFSPath=m,t.distinctParents=w,t.toLocalResource=h;function m(d){return(0,A.uriToFsPath)(d,!0)}class p{constructor(e){this._ignorePathCasing=e}compare(e,i,r=!1){return e===i?0:(0,_.compare)(this.getComparisonKey(e,r),this.getComparisonKey(i,r))}isEqual(e,i,r=!1){return e===i?!0:!e||!i?!1:this.getComparisonKey(e,r)===this.getComparisonKey(i,r)}getComparisonKey(e,i=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(e){return this._ignorePathCasing(e)}isEqualOrParent(e,i,r=!1){if(e.scheme===i.scheme){if(e.scheme===N.Schemas.file)return s.isEqualOrParent(m(e),m(i),this._ignorePathCasing(e))&&e.query===i.query&&(r||e.fragment===i.fragment);if((0,t.isEqualAuthority)(e.authority,i.authority))return s.isEqualOrParent(e.path,i.path,this._ignorePathCasing(e),"/")&&e.query===i.query&&(r||e.fragment===i.fragment)}return!1}joinPath(e,...i){return A.URI.joinPath(e,...i)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return x.posix.basename(e.path)}extname(e){return x.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let i;return e.scheme===N.Schemas.file?i=A.URI.file(x.dirname(m(e))).path:(i=x.posix.dirname(e.path),e.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),i="/")),e.with({path:i})}normalizePath(e){if(!e.path.length)return e;let i;return e.scheme===N.Schemas.file?i=A.URI.file(x.normalize(m(e))).path:i=x.posix.normalize(e.path),e.with({path:i})}relativePath(e,i){if(e.scheme!==i.scheme||!(0,t.isEqualAuthority)(e.authority,i.authority))return;if(e.scheme===N.Schemas.file){const g=x.relative(m(e),m(i));return V.isWindows?s.toSlashes(g):g}let r=e.path||"/";const u=i.path||"/";if(this._ignorePathCasing(e)){let g=0;for(const D=Math.min(r.length,u.length);g<D&&!(r.charCodeAt(g)!==u.charCodeAt(g)&&r.charAt(g).toLowerCase()!==u.charAt(g).toLowerCase());g++);r=u.substr(0,g)+r.substr(g)}return x.posix.relative(r,u)}resolvePath(e,i){if(e.scheme===N.Schemas.file){const r=A.URI.file(x.resolve(m(e),i));return e.with({authority:r.authority,path:r.path})}return i=s.toPosixPath(i),e.with({path:x.posix.resolve(e.path,i)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,i){return e===i||e!==void 0&&i!==void 0&&(0,_.equalsIgnoreCase)(e,i)}hasTrailingPathSeparator(e,i=x.sep){if(e.scheme===N.Schemas.file){const r=m(e);return r.length>s.getRoot(r).length&&r[r.length-1]===i}else{const r=e.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,i=x.sep){return(0,t.hasTrailingPathSeparator)(e,i)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,i=x.sep){let r=!1;if(e.scheme===N.Schemas.file){const u=m(e);r=u!==void 0&&u.length===s.getRoot(u).length&&u[u.length-1]===i}else{i="/";const u=e.path;r=u.length===1&&u.charCodeAt(u.length-1)===47}return!r&&!(0,t.hasTrailingPathSeparator)(e,i)?e.with({path:e.path+"/"}):e}}t.ExtUri=p,t.extUri=new p(()=>!1),t.extUriBiasedIgnorePathCase=new p(d=>d.scheme===N.Schemas.file?!V.isLinux:!0),t.extUriIgnorePathCase=new p(d=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function w(d,e){const i=[];for(let r=0;r<d.length;r++){const u=e(d[r]);d.some((g,D)=>D===r?!1:(0,t.isEqualOrParent)(u,e(g)))||i.push(d[r])}return i}var W;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function e(i){const r=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(D=>{const[a,f]=D.split(":");a&&f&&r.set(a,f)});const g=i.path.substring(0,i.path.indexOf(";"));return g&&r.set(d.META_DATA_MIME,g),r}d.parseMetaData=e})(W||(t.DataUri=W={}));function h(d,e,i){if(e){let r=d.path;return r&&r[0]!==x.posix.sep&&(r=x.posix.sep+r),d.with({scheme:i,authority:e,path:r})}return d.with({scheme:i})}}),define(ge[9],pe([1,0,28,6,4,2,47,5,60,23]),function(ie,t,s,N,x,V,_,A,m,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AsyncIterableSource=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.LazyStatefulPromise=t.StatefulPromise=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.GlobalIdleValue=t.AbstractIdleValue=t._runWhenIdle=t.runWhenGlobalIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.LimitedQueue=t.Queue=t.Limiter=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=void 0,t.isThenable=w,t.createCancelablePromise=W,t.raceCancellation=h,t.raceCancellationError=d,t.raceCancellablePromises=e,t.raceTimeout=i,t.asPromise=r,t.promiseWithResolvers=u,t.timeout=P,t.disposableTimeout=b,t.sequence=O,t.first=$,t.firstParallel=k,t.retry=J,t.createCancelableAsyncIterable=H;function w(E){return!!E&&typeof E.then=="function"}function W(E){const l=new s.CancellationTokenSource,v=E(l.token),T=new Promise((n,S)=>{const y=l.token.onCancellationRequested(()=>{y.dispose(),S(new N.CancellationError)});Promise.resolve(v).then(L=>{y.dispose(),l.dispose(),n(L)},L=>{y.dispose(),l.dispose(),S(L)})});return new class{cancel(){l.cancel(),l.dispose()}then(n,S){return T.then(n,S)}catch(n){return this.then(void 0,n)}finally(n){return T.finally(n)}}}function h(E,l,v){return new Promise((T,n)=>{const S=l.onCancellationRequested(()=>{S.dispose(),T(v)});E.then(T,n).finally(()=>S.dispose())})}function d(E,l){return new Promise((v,T)=>{const n=l.onCancellationRequested(()=>{n.dispose(),T(new N.CancellationError)});E.then(v,T).finally(()=>n.dispose())})}async function e(E){let l=-1;const v=E.map((T,n)=>T.then(S=>(l=n,S)));try{return await Promise.race(v)}finally{E.forEach((T,n)=>{n!==l&&T.cancel()})}}function i(E,l,v){let T;const n=setTimeout(()=>{T?.(void 0),v?.()},l);return Promise.race([E.finally(()=>clearTimeout(n)),new Promise(S=>T=S)])}function r(E){return new Promise((l,v)=>{const T=E();w(T)?T.then(l,v):l(T)})}function u(){let E,l;return{promise:new Promise((T,n)=>{E=T,l=n}),resolve:E,reject:l}}class g{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(l){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=l,!this.queuedPromise){const v=()=>{if(this.queuedPromise=null,this.isDisposed)return;const T=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,T};this.queuedPromise=new Promise(T=>{this.activePromise.then(v,v).then(T)})}return new Promise((v,T)=>{this.queuedPromise.then(v,T)})}return this.activePromise=l(),new Promise((v,T)=>{this.activePromise.then(n=>{this.activePromise=null,v(n)},n=>{this.activePromise=null,T(n)})})}dispose(){this.isDisposed=!0}}t.Throttler=g;class D{constructor(){this.current=Promise.resolve(null)}queue(l){return this.current=this.current.then(()=>l(),()=>l())}}t.Sequencer=D;class a{constructor(){this.promiseMap=new Map}queue(l,v){const n=(this.promiseMap.get(l)??Promise.resolve()).catch(()=>{}).then(v).finally(()=>{this.promiseMap.get(l)===n&&this.promiseMap.delete(l)});return this.promiseMap.set(l,n),n}}t.SequencerByKey=a;const f=(E,l)=>{let v=!0;const T=setTimeout(()=>{v=!1,l()},E);return{isTriggered:()=>v,dispose:()=>{clearTimeout(T),v=!1}}},o=E=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,E())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class C{constructor(l){this.defaultDelay=l,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(l,v=this.defaultDelay){this.task=l,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((n,S)=>{this.doResolve=n,this.doReject=S}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const n=this.task;return this.task=null,n()}}));const T=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=v===m.MicrotaskDelay?o(T):f(v,T),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new N.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=C;class F{constructor(l){this.delayer=new C(l),this.throttler=new g}trigger(l,v){return this.delayer.trigger(()=>this.throttler.queue(l),v)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}t.ThrottledDelayer=F;class R{constructor(){this._isOpen=!1,this._promise=new Promise((l,v)=>{this._completePromise=l})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=R;class B extends R{constructor(l){super(),this._timeout=setTimeout(()=>this.open(),l)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=B;function P(E,l){return l?new Promise((v,T)=>{const n=setTimeout(()=>{S.dispose(),v()},E),S=l.onCancellationRequested(()=>{clearTimeout(n),S.dispose(),T(new N.CancellationError)})}):W(v=>P(E,v))}function b(E,l=0,v){const T=setTimeout(()=>{E(),v&&n.dispose()},l),n=(0,V.toDisposable)(()=>{clearTimeout(T),v?.deleteAndLeak(n)});return v?.add(n),n}function O(E){const l=[];let v=0;const T=E.length;function n(){return v<T?E[v++]():null}function S(y){y!=null&&l.push(y);const L=n();return L?L.then(S):Promise.resolve(l)}return Promise.resolve(null).then(S)}function $(E,l=T=>!!T,v=null){let T=0;const n=E.length,S=()=>{if(T>=n)return Promise.resolve(v);const y=E[T++];return Promise.resolve(y()).then(z=>l(z)?Promise.resolve(z):S())};return S()}function k(E,l=T=>!!T,v=null){if(E.length===0)return Promise.resolve(v);let T=E.length;const n=()=>{T=-1;for(const S of E)S.cancel?.()};return new Promise((S,y)=>{for(const L of E)L.then(z=>{--T>=0&&l(z)?(n(),S(z)):T===0&&S(v)}).catch(z=>{--T>=0&&(n(),y(z))})})}class M{constructor(l){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=l,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new x.Emitter}whenIdle(){return this.size>0?x.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(l){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((v,T)=>{this.outstandingPromises.push({factory:l,c:v,e:T}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const l=this.outstandingPromises.shift();this.runningPromises++;const v=l.factory();v.then(l.c,l.e),v.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}t.Limiter=M;class I extends M{constructor(){super(1)}}t.Queue=I;class q{constructor(){this.sequentializer=new le,this.tasks=0}queue(l){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,l())):this.sequentializer.run(this.tasks++,l())}}t.LimitedQueue=q;class X{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const l=new G;return this.drainers.add(l),l.p}isDrained(){for(const[,l]of this.queues)if(l.size>0)return!1;return!0}queueSize(l,v=_.extUri){const T=v.getComparisonKey(l);return this.queues.get(T)?.size??0}queueFor(l,v,T=_.extUri){const n=T.getComparisonKey(l);let S=this.queues.get(n);if(!S){S=new I;const y=this.drainListenerCount++,L=x.Event.once(S.onDrained)(()=>{S?.dispose(),this.queues.delete(n),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(y),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new V.DisposableMap),this.drainListeners.set(y,L),this.queues.set(n,S)}return S.queue(v)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const l of this.drainers)l.complete();this.drainers.clear()}dispose(){for(const[,l]of this.queues)l.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}t.ResourceQueue=X;class ce{constructor(l,v){this._token=-1,typeof l=="function"&&typeof v=="number"&&this.setIfNotSet(l,v)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(l,v){this.cancel(),this._token=setTimeout(()=>{this._token=-1,l()},v)}setIfNotSet(l,v){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,l()},v))}}t.TimeoutTimer=ce;class re{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(l,v,T=globalThis){this.cancel();const n=T.setInterval(()=>{l()},v);this.disposable=(0,V.toDisposable)(()=>{T.clearInterval(n),this.disposable=void 0})}dispose(){this.cancel()}}t.IntervalTimer=re;class te{constructor(l,v){this.timeoutToken=-1,this.runner=l,this.timeout=v,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(l=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,l)}get delay(){return this.timeout}set delay(l){this.timeout=l}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=te;class be{constructor(l,v){v%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${v}ms is not a multiple of 1000ms.`),this.runner=l,this.timeout=v,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(l=this.timeout){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(l/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=be;class Ee extends te{constructor(l,v){super(l,v),this.units=[]}work(l){this.units.push(l),this.isScheduled()||this.schedule()}doRun(){const l=this.units;this.units=[],this.runner?.(l)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=Ee;class Ie extends V.Disposable{constructor(l,v){super(),this.options=l,this.handler=v,this.pendingWork=[],this.throttler=this._register(new V.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(l){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+l.length>this.options.maxBufferedWork)return!1}else if(this.pending+l.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const v of l)this.pendingWork.push(v);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new te(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=Ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t._runWhenIdle=(E,l)=>{(0,A.setTimeout0)(()=>{if(v)return;const T=Date.now()+15;l(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,T-Date.now())}}))});let v=!1;return{dispose(){v||(v=!0)}}}:t._runWhenIdle=(E,l,v)=>{const T=E.requestIdleCallback(l,typeof v=="number"?{timeout:v}:void 0);let n=!1;return{dispose(){n||(n=!0,E.cancelIdleCallback(T))}}},t.runWhenGlobalIdle=E=>(0,t._runWhenIdle)(globalThis,E)}();class Be{constructor(l,v){this._didRun=!1,this._executor=()=>{try{this._value=v()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=(0,t._runWhenIdle)(l,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.AbstractIdleValue=Be;class ue extends Be{constructor(l){super(globalThis,l)}}t.GlobalIdleValue=ue;async function J(E,l,v){let T;for(let n=0;n<v;n++)try{return await E()}catch(S){T=S,await P(l)}throw T}class le{isRunning(l){return typeof l=="number"?this._running?.taskId===l:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(l,v,T){return this._running={taskId:l,cancel:()=>T?.(),promise:v},v.then(()=>this.doneRunning(l),()=>this.doneRunning(l)),v}doneRunning(l){this._running&&l===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const l=this._queued;this._queued=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}queue(l){if(this._queued)this._queued.run=l;else{const{promise:v,resolve:T,reject:n}=u();this._queued={run:l,promise:v,promiseResolve:T,promiseReject:n}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}t.TaskSequentializer=le;class ae{constructor(l,v=()=>Date.now()){this.interval=l,this.nowFn=v,this.lastIncrementTime=0,this.value=0}increment(){const l=this.nowFn();return l-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=l,this.value=0),this.value++,this.value}}t.IntervalCounter=ae;var Z;(function(E){E[E.Resolved=0]="Resolved",E[E.Rejected=1]="Rejected"})(Z||(Z={}));class G{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((l,v)=>{this.completeCallback=l,this.errorCallback=v})}complete(l){return new Promise(v=>{this.completeCallback(l),this.outcome={outcome:0,value:l},v()})}error(l){return new Promise(v=>{this.errorCallback(l),this.outcome={outcome:1,value:l},v()})}cancel(){return this.error(new N.CancellationError)}}t.DeferredPromise=G;var ne;(function(E){async function l(T){let n;const S=await Promise.all(T.map(y=>y.then(L=>L,L=>{n||(n=L)})));if(typeof n<"u")throw n;return S}E.settled=l;function v(T){return new Promise(async(n,S)=>{try{await T(n,S)}catch(y){S(y)}})}E.withAsyncBody=v})(ne||(t.Promises=ne={}));class de{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(l){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=l.then(v=>(this._value=v,this._isResolved=!0,v),v=>{throw this._error=v,this._isResolved=!0,v})}requireValue(){if(!this._isResolved)throw new N.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}t.StatefulPromise=de;class we{constructor(l){this._compute=l,this._promise=new p.Lazy(()=>new de(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}t.LazyStatefulPromise=we;var Fe;(function(E){E[E.Initial=0]="Initial",E[E.DoneOK=1]="DoneOK",E[E.DoneError=2]="DoneError"})(Fe||(Fe={}));class _e{static fromArray(l){return new _e(v=>{v.emitMany(l)})}static fromPromise(l){return new _e(async v=>{v.emitMany(await l)})}static fromPromises(l){return new _e(async v=>{await Promise.all(l.map(async T=>v.emitOne(await T)))})}static merge(l){return new _e(async v=>{await Promise.all(l.map(async T=>{for await(const n of T)v.emitOne(n)}))})}static{this.EMPTY=_e.fromArray([])}constructor(l){this._state=0,this._results=[],this._error=null,this._onStateChanged=new x.Emitter,queueMicrotask(async()=>{const v={emitOne:T=>this.emitOne(T),emitMany:T=>this.emitMany(T),reject:T=>this.reject(T)};try{await Promise.resolve(l(v)),this.resolve()}catch(T){this.reject(T)}finally{v.emitOne=void 0,v.emitMany=void 0,v.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(l<this._results.length)return{done:!1,value:this._results[l++]};if(this._state===1)return{done:!0,value:void 0};await x.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(l,v){return new _e(async T=>{for await(const n of l)T.emitOne(v(n))})}map(l){return _e.map(this,l)}static filter(l,v){return new _e(async T=>{for await(const n of l)v(n)&&T.emitOne(n)})}filter(l){return _e.filter(this,l)}static coalesce(l){return _e.filter(l,v=>!!v)}coalesce(){return _e.coalesce(this)}static async toPromise(l){const v=[];for await(const T of l)v.push(T);return v}toPromise(){return _e.toPromise(this)}emitOne(l){this._state===0&&(this._results.push(l),this._onStateChanged.fire())}emitMany(l){this._state===0&&(this._results=this._results.concat(l),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(l){this._state===0&&(this._state=2,this._error=l,this._onStateChanged.fire())}}t.AsyncIterableObject=_e;class Pe extends _e{constructor(l,v){super(v),this._source=l}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=Pe;function H(E){const l=new s.CancellationTokenSource,v=E(l.token);return new Pe(l,async T=>{const n=l.token.onCancellationRequested(()=>{n.dispose(),l.dispose(),T.reject(new N.CancellationError)});try{for await(const S of v){if(l.token.isCancellationRequested)return;T.emitOne(S)}n.dispose(),l.dispose()}catch(S){n.dispose(),l.dispose(),T.reject(S)}})}class c{constructor(){this._deferred=new G,this._asyncIterable=new _e(T=>{if(l){T.reject(l);return}return v&&T.emitMany(v),this._errorFn=n=>T.reject(n),this._emitFn=n=>T.emitOne(n),this._deferred.p});let l,v;this._emitFn=T=>{v||(v=[]),v.push(T)},this._errorFn=T=>{l||(l=T)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(l){this._errorFn(l),this._deferred.complete()}emitOne(l){this._emitFn(l)}}t.AsyncIterableSource=c}),define(ge[3],pe([1,0,17,126,15,20,9,6,4,130,2,35,5,16,59,22]),function(ie,t,s,N,x,V,_,A,m,p,w,W,h,d,e,i){"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.DragAndDropObserver=t.ModifierKeyEmitter=t.basicMarkupHtmlTags=t.DetectedFullscreenMode=t.Namespace=t.EventHelper=t.EventType=t.sharedMutationObserver=t.Dimension=t.WindowIntervalTimer=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.WindowIdleValue=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.clearNode=u,t.addDisposableListener=D,t.addDisposableGenericMouseDownListener=R,t.addDisposableGenericMouseMoveListener=B,t.addDisposableGenericMouseUpListener=P,t.runWhenWindowIdle=b,t.disposableWindowInterval=$,t.measure=I,t.modify=q,t.addDisposableThrottledListener=te,t.getComputedStyle=be,t.getClientArea=Ee,t.getTopLeftOffset=ue,t.size=J,t.position=le,t.getDomNodePagePosition=ae,t.getDomNodeZoomLevel=Z,t.getTotalWidth=G,t.getContentWidth=ne,t.getTotalScrollWidth=de,t.getContentHeight=we,t.getTotalHeight=Fe,t.getLargestChildWidth=Pe,t.isAncestor=H,t.setParentFlowTo=E,t.isAncestorUsingFlowTo=v,t.findParentWithClass=T,t.hasParentWithClass=n,t.isShadowRoot=S,t.isInShadowDOM=y,t.getShadowRoot=L,t.getActiveElement=z,t.isActiveElement=Y,t.isAncestorOfActiveElement=Q,t.isActiveDocument=oe,t.getActiveDocument=De,t.getActiveWindow=me,t.isGlobalStylesheet=Ae,t.createStyleSheet2=Me,t.createStyleSheet=Te,t.cloneGlobalStylesheets=Ve,t.createMetaElement=Ue,t.createLinkElement=Je,t.createCSSRule=Le,t.removeCSSRulesContainingSelector=He,t.isMouseEvent=et,t.isKeyboardEvent=it,t.isPointerEvent=nt,t.isDragEvent=Ze,t.isEventLike=rt,t.saveParentsScrollTop=tt,t.restoreParentsScrollTop=mt,t.trackFocus=_t,t.after=At,t.append=Tt,t.prepend=xe,t.reset=he,t.$=st,t.join=lt,t.setVisibility=Ye,t.show=ht,t.hide=bt,t.removeTabIndexAndUpdateFocus=Yt,t.finalHandler=Ci,t.domContentLoaded=_i,t.computeScreenAwareSize=Ai,t.windowOpenNoOpener=Ti,t.windowOpenPopup=Ii,t.windowOpenWithSuccess=Ni,t.animate=Fi,t.asCSSUrl=Li,t.asCSSPropertyValue=ki,t.asCssValueWithDefault=Qt,t.triggerDownload=Pi,t.triggerUpload=Oi,t.detectFullscreen=Mi,t.hookDomPurifyHrefAndSrcSanitizer=Jt,t.safeInnerHtml=xi,t.multibyteAwareBtoa=Hi,t.getCookieValue=zi,t.h=Ki,t.copyAttributes=ti,t.trackAttributes=ji,r=function(){const K=new Map;(0,i.ensureCodeWindow)(i.mainWindow,1);const j={window:i.mainWindow,disposables:new w.DisposableStore};K.set(i.mainWindow.vscodeWindowId,j);const ee=new m.Emitter,fe=new m.Emitter,Ce=new m.Emitter;function We(Re,Ke){return(typeof Re=="number"?K.get(Re):void 0)??(Ke?j:void 0)}return{onDidRegisterWindow:ee.event,onWillUnregisterWindow:Ce.event,onDidUnregisterWindow:fe.event,registerWindow(Re){if(K.has(Re.vscodeWindowId))return w.Disposable.None;const Ke=new w.DisposableStore,qe={window:Re,disposables:Ke.add(new w.DisposableStore)};return K.set(Re.vscodeWindowId,qe),Ke.add((0,w.toDisposable)(()=>{K.delete(Re.vscodeWindowId),fe.fire(Re)})),Ke.add(D(Re,t.EventType.BEFORE_UNLOAD,()=>{Ce.fire(Re)})),ee.fire(qe),Ke},getWindows(){return K.values()},getWindowsCount(){return K.size},getWindowId(Re){return Re.vscodeWindowId},hasWindow(Re){return K.has(Re)},getWindowById:We,getWindow(Re){const Ke=Re;if(Ke?.ownerDocument?.defaultView)return Ke.ownerDocument.defaultView.window;const qe=Re;return qe?.view?qe.view.window:i.mainWindow},getDocument(Re){const Ke=Re;return(0,t.getWindow)(Ke).document}}}(),t.registerWindow=r.registerWindow,t.getWindow=r.getWindow,t.getDocument=r.getDocument,t.getWindows=r.getWindows,t.getWindowsCount=r.getWindowsCount,t.getWindowId=r.getWindowId,t.getWindowById=r.getWindowById,t.hasWindow=r.hasWindow,t.onDidRegisterWindow=r.onDidRegisterWindow,t.onWillUnregisterWindow=r.onWillUnregisterWindow,t.onDidUnregisterWindow=r.onDidUnregisterWindow;function u(K){for(;K.firstChild;)K.firstChild.remove()}class g{constructor(j,ee,fe,Ce){this._node=j,this._type=ee,this._handler=fe,this._options=Ce||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){this._handler&&(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function D(K,j,ee,fe){return new g(K,j,ee,fe)}function a(K,j){return function(ee){return j(new V.StandardMouseEvent(K,ee))}}function f(K){return function(j){return K(new x.StandardKeyboardEvent(j))}}const o=function(j,ee,fe,Ce){let We=fe;return ee==="click"||ee==="mousedown"?We=a((0,t.getWindow)(j),fe):(ee==="keydown"||ee==="keypress"||ee==="keyup")&&(We=f(fe)),D(j,ee,We,Ce)};t.addStandardDisposableListener=o;const C=function(j,ee,fe){const Ce=a((0,t.getWindow)(j),ee);return R(j,Ce,fe)};t.addStandardDisposableGenericMouseDownListener=C;const F=function(j,ee,fe){const Ce=a((0,t.getWindow)(j),ee);return P(j,Ce,fe)};t.addStandardDisposableGenericMouseUpListener=F;function R(K,j,ee){return D(K,h.isIOS&&N.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,j,ee)}function B(K,j,ee){return D(K,h.isIOS&&N.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,j,ee)}function P(K,j,ee){return D(K,h.isIOS&&N.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,j,ee)}function b(K,j,ee){return(0,_._runWhenIdle)(K,j,ee)}class O extends _.AbstractIdleValue{constructor(j,ee){super(j,ee)}}t.WindowIdleValue=O;function $(K,j,ee,fe){let Ce=0;const We=K.setInterval(()=>{Ce++,(typeof fe=="number"&&Ce>=fe||j()===!0)&&Re.dispose()},ee),Re=(0,w.toDisposable)(()=>{K.clearInterval(We)});return Re}class k extends _.IntervalTimer{constructor(j){super(),this.defaultTarget=j&&(0,t.getWindow)(j)}cancelAndSet(j,ee,fe){return super.cancelAndSet(j,ee,fe??this.defaultTarget)}}t.WindowIntervalTimer=k;class M{constructor(j,ee=0){this._runner=j,this.priority=ee,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(j){(0,A.onUnexpectedError)(j)}}static sort(j,ee){return ee.priority-j.priority}}(function(){const K=new Map,j=new Map,ee=new Map,fe=new Map,Ce=We=>{ee.set(We,!1);const Re=K.get(We)??[];for(j.set(We,Re),K.set(We,[]),fe.set(We,!0);Re.length>0;)Re.sort(M.sort),Re.shift().execute();fe.set(We,!1)};t.scheduleAtNextAnimationFrame=(We,Re,Ke=0)=>{const qe=(0,t.getWindowId)(We),Ge=new M(Re,Ke);let at=K.get(qe);return at||(at=[],K.set(qe,at)),at.push(Ge),ee.get(qe)||(ee.set(qe,!0),We.requestAnimationFrame(()=>Ce(qe))),Ge},t.runAtThisOrScheduleAtNextAnimationFrame=(We,Re,Ke)=>{const qe=(0,t.getWindowId)(We);if(fe.get(qe)){const Ge=new M(Re,Ke);let at=j.get(qe);return at||(at=[],j.set(qe,at)),at.push(Ge),Ge}else return(0,t.scheduleAtNextAnimationFrame)(We,Re,Ke)}})();function I(K,j){return(0,t.scheduleAtNextAnimationFrame)(K,j,1e4)}function q(K,j){return(0,t.scheduleAtNextAnimationFrame)(K,j,-1e4)}const X=8,ce=function(K,j){return j};class re extends w.Disposable{constructor(j,ee,fe,Ce=ce,We=X){super();let Re=null,Ke=0;const qe=this._register(new _.TimeoutTimer),Ge=()=>{Ke=new Date().getTime(),fe(Re),Re=null};this._register(D(j,ee,at=>{Re=Ce(Re,at);const Nt=new Date().getTime()-Ke;Nt>=We?(qe.cancel(),Ge()):qe.setIfNotSet(Ge,We-Nt)}))}}function te(K,j,ee,fe,Ce){return new re(K,j,ee,fe,Ce)}function be(K){return(0,t.getWindow)(K).getComputedStyle(K,null)}function Ee(K,j){const ee=(0,t.getWindow)(K),fe=ee.document;if(K!==fe.body)return new Be(K.clientWidth,K.clientHeight);if(h.isIOS&&ee?.visualViewport)return new Be(ee.visualViewport.width,ee.visualViewport.height);if(ee?.innerWidth&&ee.innerHeight)return new Be(ee.innerWidth,ee.innerHeight);if(fe.body&&fe.body.clientWidth&&fe.body.clientHeight)return new Be(fe.body.clientWidth,fe.body.clientHeight);if(fe.documentElement&&fe.documentElement.clientWidth&&fe.documentElement.clientHeight)return new Be(fe.documentElement.clientWidth,fe.documentElement.clientHeight);if(j)return Ee(j);throw new Error("Unable to figure out browser width and height")}class Ie{static convertToPixels(j,ee){return parseFloat(ee)||0}static getDimension(j,ee,fe){const Ce=be(j),We=Ce?Ce.getPropertyValue(ee):"0";return Ie.convertToPixels(j,We)}static getBorderLeftWidth(j){return Ie.getDimension(j,"border-left-width","borderLeftWidth")}static getBorderRightWidth(j){return Ie.getDimension(j,"border-right-width","borderRightWidth")}static getBorderTopWidth(j){return Ie.getDimension(j,"border-top-width","borderTopWidth")}static getBorderBottomWidth(j){return Ie.getDimension(j,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(j){return Ie.getDimension(j,"padding-left","paddingLeft")}static getPaddingRight(j){return Ie.getDimension(j,"padding-right","paddingRight")}static getPaddingTop(j){return Ie.getDimension(j,"padding-top","paddingTop")}static getPaddingBottom(j){return Ie.getDimension(j,"padding-bottom","paddingBottom")}static getMarginLeft(j){return Ie.getDimension(j,"margin-left","marginLeft")}static getMarginTop(j){return Ie.getDimension(j,"margin-top","marginTop")}static getMarginRight(j){return Ie.getDimension(j,"margin-right","marginRight")}static getMarginBottom(j){return Ie.getDimension(j,"margin-bottom","marginBottom")}}class Be{static{this.None=new Be(0,0)}constructor(j,ee){this.width=j,this.height=ee}with(j=this.width,ee=this.height){return j!==this.width||ee!==this.height?new Be(j,ee):this}static is(j){return typeof j=="object"&&typeof j.height=="number"&&typeof j.width=="number"}static lift(j){return j instanceof Be?j:new Be(j.width,j.height)}static equals(j,ee){return j===ee?!0:!j||!ee?!1:j.width===ee.width&&j.height===ee.height}}t.Dimension=Be;function ue(K){let j=K.offsetParent,ee=K.offsetTop,fe=K.offsetLeft;for(;(K=K.parentNode)!==null&&K!==K.ownerDocument.body&&K!==K.ownerDocument.documentElement;){ee-=K.scrollTop;const Ce=S(K)?null:be(K);Ce&&(fe-=Ce.direction!=="rtl"?K.scrollLeft:-K.scrollLeft),K===j&&(fe+=Ie.getBorderLeftWidth(K),ee+=Ie.getBorderTopWidth(K),ee+=K.offsetTop,fe+=K.offsetLeft,j=K.offsetParent)}return{left:fe,top:ee}}function J(K,j,ee){typeof j=="number"&&(K.style.width=`${j}px`),typeof ee=="number"&&(K.style.height=`${ee}px`)}function le(K,j,ee,fe,Ce,We="absolute"){typeof j=="number"&&(K.style.top=`${j}px`),typeof ee=="number"&&(K.style.right=`${ee}px`),typeof fe=="number"&&(K.style.bottom=`${fe}px`),typeof Ce=="number"&&(K.style.left=`${Ce}px`),K.style.position=We}function ae(K){const j=K.getBoundingClientRect(),ee=(0,t.getWindow)(K);return{left:j.left+ee.scrollX,top:j.top+ee.scrollY,width:j.width,height:j.height}}function Z(K){let j=K,ee=1;do{const fe=be(j).zoom;fe!=null&&fe!=="1"&&(ee*=fe),j=j.parentElement}while(j!==null&&j!==j.ownerDocument.documentElement);return ee}function G(K){const j=Ie.getMarginLeft(K)+Ie.getMarginRight(K);return K.offsetWidth+j}function ne(K){const j=Ie.getBorderLeftWidth(K)+Ie.getBorderRightWidth(K),ee=Ie.getPaddingLeft(K)+Ie.getPaddingRight(K);return K.offsetWidth-j-ee}function de(K){const j=Ie.getMarginLeft(K)+Ie.getMarginRight(K);return K.scrollWidth+j}function we(K){const j=Ie.getBorderTopWidth(K)+Ie.getBorderBottomWidth(K),ee=Ie.getPaddingTop(K)+Ie.getPaddingBottom(K);return K.offsetHeight-j-ee}function Fe(K){const j=Ie.getMarginTop(K)+Ie.getMarginBottom(K);return K.offsetHeight+j}function _e(K,j){if(K===null)return 0;const ee=ue(K),fe=ue(j);return ee.left-fe.left}function Pe(K,j){const ee=j.map(Ce=>Math.max(de(Ce),G(Ce))+_e(Ce,K)||0);return Math.max(...ee)}function H(K,j){return!!j?.contains(K)}const c="parentFlowToElementId";function E(K,j){K.dataset[c]=j.id}function l(K){const j=K.dataset[c];return typeof j=="string"?K.ownerDocument.getElementById(j):null}function v(K,j){let ee=K;for(;ee;){if(ee===j)return!0;if(ee instanceof HTMLElement){const fe=l(ee);if(fe){ee=fe;continue}}ee=ee.parentNode}return!1}function T(K,j,ee){for(;K&&K.nodeType===K.ELEMENT_NODE;){if(K.classList.contains(j))return K;if(ee){if(typeof ee=="string"){if(K.classList.contains(ee))return null}else if(K===ee)return null}K=K.parentNode}return null}function n(K,j,ee){return!!T(K,j,ee)}function S(K){return K&&!!K.host&&!!K.mode}function y(K){return!!L(K)}function L(K){for(;K.parentNode;){if(K===K.ownerDocument?.body)return null;K=K.parentNode}return S(K)?K:null}function z(){let K=De().activeElement;for(;K?.shadowRoot;)K=K.shadowRoot.activeElement;return K}function Y(K){return z()===K}function Q(K){return H(z(),K)}function oe(K){return K.ownerDocument===De()}function De(){return(0,t.getWindowsCount)()<=1?i.mainWindow.document:Array.from((0,t.getWindows)()).map(({window:j})=>j.document).find(j=>j.hasFocus())??i.mainWindow.document}function me(){return De().defaultView?.window??i.mainWindow}const ke=new Map;function Ae(K){return ke.has(K)}function Me(){return new Se}class Se{constructor(){this._currentCssStyle="",this._styleSheet=void 0}setStyle(j){j!==this._currentCssStyle&&(this._currentCssStyle=j,this._styleSheet?this._styleSheet.innerText=j:this._styleSheet=Te(i.mainWindow.document.head,ee=>ee.innerText=j))}dispose(){this._styleSheet&&(this._styleSheet.remove(),this._styleSheet=void 0)}}function Te(K=i.mainWindow.document.head,j,ee){const fe=document.createElement("style");if(fe.type="text/css",fe.media="screen",j?.(fe),K.appendChild(fe),ee&&ee.add((0,w.toDisposable)(()=>K.removeChild(fe))),K===i.mainWindow.document.head){const Ce=new Set;ke.set(fe,Ce);for(const{window:We,disposables:Re}of(0,t.getWindows)()){if(We===i.mainWindow)continue;const Ke=Re.add(Qe(fe,Ce,We));ee?.add(Ke)}}return fe}function Ve(K){const j=new w.DisposableStore;for(const[ee,fe]of ke)j.add(Qe(ee,fe,K));return j}function Qe(K,j,ee){const fe=new w.DisposableStore,Ce=K.cloneNode(!0);ee.document.head.appendChild(Ce),fe.add((0,w.toDisposable)(()=>ee.document.head.removeChild(Ce)));for(const We of ye(K))Ce.sheet?.insertRule(We.cssText,Ce.sheet?.cssRules.length);return fe.add(t.sharedMutationObserver.observe(K,fe,{childList:!0})(()=>{Ce.textContent=K.textContent})),j.add(Ce),fe.add((0,w.toDisposable)(()=>j.delete(Ce))),fe}t.sharedMutationObserver=new class{constructor(){this.mutationObservers=new Map}observe(K,j,ee){let fe=this.mutationObservers.get(K);fe||(fe=new Map,this.mutationObservers.set(K,fe));const Ce=(0,e.hash)(ee);let We=fe.get(Ce);if(We)We.users+=1;else{const Re=new m.Emitter,Ke=new MutationObserver(Ge=>Re.fire(Ge));Ke.observe(K,ee);const qe=We={users:1,observer:Ke,onDidMutate:Re.event};j.add((0,w.toDisposable)(()=>{qe.users-=1,qe.users===0&&(Re.dispose(),Ke.disconnect(),fe?.delete(Ce),fe?.size===0&&this.mutationObservers.delete(K))})),fe.set(Ce,We)}return We.onDidMutate}};function Ue(K=i.mainWindow.document.head){return U("meta",K)}function Je(K=i.mainWindow.document.head){return U("link",K)}function U(K,j=i.mainWindow.document.head){const ee=document.createElement(K);return j.appendChild(ee),ee}let se=null;function ve(){return se||(se=Te()),se}function ye(K){return K?.sheet?.rules?K.sheet.rules:K?.sheet?.cssRules?K.sheet.cssRules:[]}function Le(K,j,ee=ve()){if(!(!ee||!j)){ee.sheet?.insertRule(`${K} {${j}}`,0);for(const fe of ke.get(ee)??[])Le(K,j,fe)}}function He(K,j=ve()){if(!j)return;const ee=ye(j),fe=[];for(let Ce=0;Ce<ee.length;Ce++){const We=ee[Ce];$e(We)&&We.selectorText.indexOf(K)!==-1&&fe.push(Ce)}for(let Ce=fe.length-1;Ce>=0;Ce--)j.sheet?.deleteRule(fe[Ce]);for(const Ce of ke.get(j)??[])He(K,Ce)}function $e(K){return typeof K.selectorText=="string"}function et(K){return K instanceof MouseEvent||K instanceof(0,t.getWindow)(K).MouseEvent}function it(K){return K instanceof KeyboardEvent||K instanceof(0,t.getWindow)(K).KeyboardEvent}function nt(K){return K instanceof PointerEvent||K instanceof(0,t.getWindow)(K).PointerEvent}function Ze(K){return K instanceof DragEvent||K instanceof(0,t.getWindow)(K).DragEvent}t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:s.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:s.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:s.isWebKit?"webkitAnimationIteration":"animationiteration"};function rt(K){const j=K;return!!(j&&typeof j.preventDefault=="function"&&typeof j.stopPropagation=="function")}t.EventHelper={stop:(K,j)=>(K.preventDefault(),j&&K.stopPropagation(),K)};function tt(K){const j=[];for(let ee=0;K&&K.nodeType===K.ELEMENT_NODE;ee++)j[ee]=K.scrollTop,K=K.parentNode;return j}function mt(K,j){for(let ee=0;K&&K.nodeType===K.ELEMENT_NODE;ee++)K.scrollTop!==j[ee]&&(K.scrollTop=j[ee]),K=K.parentNode}class gt extends w.Disposable{static hasFocusWithin(j){if(j instanceof HTMLElement){const ee=L(j),fe=ee?ee.activeElement:j.ownerDocument.activeElement;return H(fe,j)}else{const ee=j;return H(ee.document.activeElement,ee.document)}}constructor(j){super(),this._onDidFocus=this._register(new m.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new m.Emitter),this.onDidBlur=this._onDidBlur.event;let ee=gt.hasFocusWithin(j),fe=!1;const Ce=()=>{fe=!1,ee||(ee=!0,this._onDidFocus.fire())},We=()=>{ee&&(fe=!0,(j instanceof HTMLElement?(0,t.getWindow)(j):j).setTimeout(()=>{fe&&(fe=!1,ee=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{gt.hasFocusWithin(j)!==ee&&(ee?We():Ce())},this._register(D(j,t.EventType.FOCUS,Ce,!0)),this._register(D(j,t.EventType.BLUR,We,!0)),j instanceof HTMLElement&&(this._register(D(j,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(D(j,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler())))}refreshState(){this._refreshStateHandler()}}function _t(K){return new gt(K)}function At(K,j){return K.after(j),j}function Tt(K,...j){if(K.append(...j),j.length===1&&typeof j[0]!="string")return j[0]}function xe(K,j){return K.insertBefore(j,K.firstChild),j}function he(K,...j){K.innerText="",Tt(K,...j)}const Ne=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Oe;(function(K){K.HTML="http://www.w3.org/1999/xhtml",K.SVG="http://www.w3.org/2000/svg"})(Oe||(t.Namespace=Oe={}));function je(K,j,ee,...fe){const Ce=Ne.exec(j);if(!Ce)throw new Error("Bad use of emmet");const We=Ce[1]||"div";let Re;return K!==Oe.HTML?Re=document.createElementNS(K,We):Re=document.createElement(We),Ce[3]&&(Re.id=Ce[3]),Ce[4]&&(Re.className=Ce[4].replace(/\./g," ").trim()),ee&&Object.entries(ee).forEach(([Ke,qe])=>{typeof qe>"u"||(/^on\w+$/.test(Ke)?Re[Ke]=qe:Ke==="selected"?qe&&Re.setAttribute(Ke,"true"):Re.setAttribute(Ke,qe))}),Re.append(...fe),Re}function st(K,j,...ee){return je(Oe.HTML,K,j,...ee)}st.SVG=function(K,j,...ee){return je(Oe.SVG,K,j,...ee)};function lt(K,j){const ee=[];return K.forEach((fe,Ce)=>{Ce>0&&(j instanceof Node?ee.push(j.cloneNode()):ee.push(document.createTextNode(j))),ee.push(fe)}),ee}function Ye(K,...j){K?ht(...j):bt(...j)}function ht(...K){for(const j of K)j.style.display="",j.removeAttribute("aria-hidden")}function bt(...K){for(const j of K)j.style.display="none",j.setAttribute("aria-hidden","true")}function It(K,j){for(;K&&K.nodeType===K.ELEMENT_NODE;){if(K instanceof HTMLElement&&K.hasAttribute(j))return K;K=K.parentNode}return null}function Yt(K){!K||!K.hasAttribute("tabIndex")||(K.ownerDocument.activeElement===K&&It(K.parentElement,"tabIndex")?.focus(),K.removeAttribute("tabindex"))}function Ci(K){return j=>{j.preventDefault(),j.stopPropagation(),K(j)}}function _i(K){return new Promise(j=>{if(K.document.readyState==="complete"||K.document&&K.document.body!==null)j(void 0);else{const fe=()=>{K.window.removeEventListener("DOMContentLoaded",fe,!1),j()};K.window.addEventListener("DOMContentLoaded",fe,!1)}})}function Ai(K,j){const ee=K.devicePixelRatio*j;return Math.max(1,Math.floor(ee))/K.devicePixelRatio}function Ti(K){i.mainWindow.open(K,"_blank","noopener")}const Xt=780,Zt=640;function Ii(K){const j=Math.floor(i.mainWindow.screenLeft+i.mainWindow.innerWidth/2-Xt/2),ee=Math.floor(i.mainWindow.screenTop+i.mainWindow.innerHeight/2-Zt/2);i.mainWindow.open(K,"_blank",`width=${Xt},height=${Zt},top=${ee},left=${j}`)}function Ni(K,j=!0){const ee=i.mainWindow.open();return ee?(j&&(ee.opener=null),ee.location.href=K,!0):!1}function Fi(K,j){const ee=()=>{j(),fe=(0,t.scheduleAtNextAnimationFrame)(K,ee)};let fe=(0,t.scheduleAtNextAnimationFrame)(K,ee);return(0,w.toDisposable)(()=>fe.dispose())}W.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(i.mainWindow.location.href)?"https":"http");function Li(K){return K?`url('${W.FileAccess.uriToBrowserUri(K).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function ki(K){return`'${K.replace(/'/g,"%27")}'`}function Qt(K,j){if(K!==void 0){const ee=K.match(/^\s*var\((.+)\)$/);if(ee){const fe=ee[1].split(",",2);return fe.length===2&&(j=Qt(fe[1].trim(),j)),`var(${fe[0]}, ${j})`}return K}return j}function Pi(K,j){let ee;if(d.URI.isUri(K))ee=K.toString(!0);else{const We=new Blob([K]);ee=URL.createObjectURL(We),setTimeout(()=>URL.revokeObjectURL(ee))}const fe=me(),Ce=document.createElement("a");fe.document.body.appendChild(Ce),Ce.download=j,Ce.href=ee,Ce.click(),setTimeout(()=>fe.document.body.removeChild(Ce))}function Oi(){return new Promise(K=>{const j=me(),ee=document.createElement("input");j.document.body.appendChild(ee),ee.type="file",ee.multiple=!0,m.Event.once(m.Event.fromDOMEventEmitter(ee,"input"))(()=>{K(ee.files??void 0)}),ee.click(),setTimeout(()=>j.document.body.removeChild(ee))})}var yt;(function(K){K[K.DOCUMENT=1]="DOCUMENT",K[K.BROWSER=2]="BROWSER"})(yt||(t.DetectedFullscreenMode=yt={}));function Mi(K){return K.document.fullscreenElement||K.document.webkitFullscreenElement||K.document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:K.innerHeight===K.screen.height?{mode:yt.BROWSER,guess:!1}:(h.isMacintosh||h.isLinux)&&K.outerHeight===K.screen.height&&K.outerWidth===K.screen.width?{mode:yt.BROWSER,guess:!0}:null}function Jt(K,j=!1){const ee=document.createElement("a");return p.addHook("afterSanitizeAttributes",fe=>{for(const Ce of["href","src"])if(fe.hasAttribute(Ce)){const We=fe.getAttribute(Ce);if(Ce==="href"&&We.startsWith("#"))continue;if(ee.href=We,!K.includes(ee.protocol.replace(/:$/,""))){if(j&&Ce==="src"&&ee.href.startsWith("data:"))continue;fe.removeAttribute(Ce)}}}),(0,w.toDisposable)(()=>{p.removeHook("afterSanitizeAttributes")})}const Ri=[W.Schemas.http,W.Schemas.https,W.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Bi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function xi(K,j){const ee=Jt(Ri);try{const fe=p.sanitize(j,Bi);K.innerHTML=fe}finally{ee.dispose()}}function Wi(K){const j=new Uint16Array(K.length);for(let Ce=0;Ce<j.length;Ce++)j[Ce]=K.charCodeAt(Ce);let ee="";const fe=new Uint8Array(j.buffer);for(let Ce=0;Ce<fe.length;Ce++)ee+=String.fromCharCode(fe[Ce]);return ee}function Hi(K){return btoa(Wi(K))}class vt extends m.Emitter{constructor(){super(),this._subscriptions=new w.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(m.Event.runAndSubscribe(t.onDidRegisterWindow,({window:j,disposables:ee})=>this.registerListeners(j,ee),{window:i.mainWindow,disposables:this._subscriptions}))}registerListeners(j,ee){ee.add(D(j,"keydown",fe=>{if(fe.defaultPrevented)return;const Ce=new x.StandardKeyboardEvent(fe);if(!(Ce.keyCode===6&&fe.repeat)){if(fe.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(fe.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(fe.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(fe.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(Ce.keyCode!==6)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=fe.altKey,this._keyStatus.ctrlKey=fe.ctrlKey,this._keyStatus.metaKey=fe.metaKey,this._keyStatus.shiftKey=fe.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=fe,this.fire(this._keyStatus))}},!0)),ee.add(D(j,"keyup",fe=>{fe.defaultPrevented||(!fe.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!fe.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!fe.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!fe.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=fe.altKey,this._keyStatus.ctrlKey=fe.ctrlKey,this._keyStatus.metaKey=fe.metaKey,this._keyStatus.shiftKey=fe.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=fe,this.fire(this._keyStatus)))},!0)),ee.add(D(j.document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),ee.add(D(j.document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),ee.add(D(j.document.body,"mousemove",fe=>{fe.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),ee.add(D(j,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return vt.instance||(vt.instance=new vt),vt.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=vt;function zi(K){const j=document.cookie.match("(^|[^;]+)\\s*"+K+"\\s*=\\s*([^;]+)");return j?j.pop():void 0}class Vi extends w.Disposable{constructor(j,ee){super(),this.element=j,this.callbacks=ee,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this.callbacks.onDragStart&&this._register(D(this.element,t.EventType.DRAG_START,j=>{this.callbacks.onDragStart?.(j)})),this.callbacks.onDrag&&this._register(D(this.element,t.EventType.DRAG,j=>{this.callbacks.onDrag?.(j)})),this._register(D(this.element,t.EventType.DRAG_ENTER,j=>{this.counter++,this.dragStartTime=j.timeStamp,this.callbacks.onDragEnter?.(j)})),this._register(D(this.element,t.EventType.DRAG_OVER,j=>{j.preventDefault(),this.callbacks.onDragOver?.(j,j.timeStamp-this.dragStartTime)})),this._register(D(this.element,t.EventType.DRAG_LEAVE,j=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave?.(j))})),this._register(D(this.element,t.EventType.DRAG_END,j=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd?.(j)})),this._register(D(this.element,t.EventType.DROP,j=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop?.(j)}))}}t.DragAndDropObserver=Vi;const $i=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Ki(K,...j){let ee,fe;Array.isArray(j[0])?(ee={},fe=j[0]):(ee=j[0]||{},fe=j[1]);const Ce=$i.exec(K);if(!Ce||!Ce.groups)throw new Error("Bad use of h");const We=Ce.groups.tag||"div",Re=document.createElement(We);Ce.groups.id&&(Re.id=Ce.groups.id);const Ke=[];if(Ce.groups.class)for(const Ge of Ce.groups.class.split("."))Ge!==""&&Ke.push(Ge);if(ee.className!==void 0)for(const Ge of ee.className.split("."))Ge!==""&&Ke.push(Ge);Ke.length>0&&(Re.className=Ke.join(" "));const qe={};if(Ce.groups.name&&(qe[Ce.groups.name]=Re),fe)for(const Ge of fe)Ge instanceof HTMLElement?Re.appendChild(Ge):typeof Ge=="string"?Re.append(Ge):"root"in Ge&&(Object.assign(qe,Ge),Re.appendChild(Ge.root));for(const[Ge,at]of Object.entries(ee))if(Ge!=="className")if(Ge==="style")for(const[Nt,Bt]of Object.entries(at))Re.style.setProperty(ei(Nt),typeof Bt=="number"?Bt+"px":""+Bt);else Ge==="tabIndex"?Re.tabIndex=at:Re.setAttribute(ei(Ge),at.toString());return qe.root=Re,qe}function ei(K){return K.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(K,j,ee){for(const{name:fe,value:Ce}of K.attributes)(!ee||ee.includes(fe))&&j.setAttribute(fe,Ce)}function qi(K,j,ee){const fe=K.getAttribute(ee);fe?j.setAttribute(ee,fe):j.removeAttribute(ee)}function ji(K,j,ee){ti(K,j,ee);const fe=new w.DisposableStore;return fe.add(t.sharedMutationObserver.observe(K,fe,{attributes:!0,attributeFilter:ee})(Ce=>{for(const We of Ce)We.type==="attributes"&&We.attributeName&&qi(K,j,We.attributeName)})),fe}}),define(ge[64],pe([1,0,3,2,129]),function(ie,t,s,N,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTransfers=t.DelayedDragHandler=void 0,t.applyDragImage=_;class V extends N.Disposable{constructor(m,p){super(),this._register((0,s.addDisposableListener)(m,"dragover",w=>{w.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{p(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(w=>{this._register((0,s.addDisposableListener)(m,w,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=V,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:x.Mimes.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function _(A,m,p,w,W){const h=document.createElement("div");if(h.className=p,h.textContent=m,W&&(h.style.color=W),w&&(h.style.background=w),A.dataTransfer){const d=(0,s.getWindow)(A).document;d.body.appendChild(h),A.dataTransfer.setDragImage(h,-10,-10),setTimeout(()=>d.body.removeChild(h),0)}}}),define(ge[65],pe([1,0,3]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderText=N,t.renderFormattedText=x,t.createElement=V;function N(h,d={}){const e=V(d);return e.textContent=h,e}function x(h,d={}){const e=V(d);return m(e,p(h,!!d.renderCodeSegments),d.actionHandler,d.renderCodeSegments),e}function V(h){const d=h.inline?"span":"div",e=document.createElement(d);return h.className&&(e.className=h.className),e}class _{constructor(d){this.source=d,this.index=0}eos(){return this.index>=this.source.length}next(){const d=this.peek();return this.advance(),d}peek(){return this.source[this.index]}advance(){this.index++}}var A;(function(h){h[h.Invalid=0]="Invalid",h[h.Root=1]="Root",h[h.Text=2]="Text",h[h.Bold=3]="Bold",h[h.Italics=4]="Italics",h[h.Action=5]="Action",h[h.ActionClose=6]="ActionClose",h[h.Code=7]="Code",h[h.NewLine=8]="NewLine"})(A||(A={}));function m(h,d,e,i){let r;if(d.type===2)r=document.createTextNode(d.content||"");else if(d.type===3)r=document.createElement("b");else if(d.type===4)r=document.createElement("i");else if(d.type===7&&i)r=document.createElement("code");else if(d.type===5&&e){const u=document.createElement("a");e.disposables.add(s.addStandardDisposableListener(u,"click",g=>{e.callback(String(d.index),g)})),r=u}else d.type===8?r=document.createElement("br"):d.type===1&&(r=h);r&&h!==r&&h.appendChild(r),r&&Array.isArray(d.children)&&d.children.forEach(u=>{m(r,u,e,i)})}function p(h,d){const e={type:1,children:[]};let i=0,r=e;const u=[],g=new _(h);for(;!g.eos();){let D=g.next();const a=D==="\\"&&W(g.peek(),d)!==0;if(a&&(D=g.next()),!a&&w(D,d)&&D===g.peek()){g.advance(),r.type===2&&(r=u.pop());const f=W(D,d);if(r.type===f||r.type===5&&f===6)r=u.pop();else{const o={type:f,children:[]};f===5&&(o.index=i,i++),r.children.push(o),u.push(r),r=o}}else if(D===`
`)r.type===2&&(r=u.pop()),r.children.push({type:8});else if(r.type!==2){const f={type:2,content:D};r.children.push(f),u.push(r),r=f}else r.content+=D}return r.type===2&&(r=u.pop()),u.length,e}function w(h,d){return W(h,d)!==0}function W(h,d){switch(h){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return d?7:0;default:return 0}}}),define(ge[66],pe([1,0,3,2]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class x{constructor(){this._hooks=new N.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(_,A){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const m=this._onStopCallback;this._onStopCallback=null,_&&m&&m(A)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(_,A,m,p,w){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=p,this._onStopCallback=w;let W=_;try{_.setPointerCapture(A),this._hooks.add((0,N.toDisposable)(()=>{try{_.releasePointerCapture(A)}catch{}}))}catch{W=s.getWindow(_)}this._hooks.add(s.addDisposableListener(W,s.EventType.POINTER_MOVE,h=>{if(h.buttons!==m){this.stopMonitoring(!0);return}h.preventDefault(),this._pointerMoveCallback(h)})),this._hooks.add(s.addDisposableListener(W,s.EventType.POINTER_UP,h=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=x});var Xe=this&&this.__decorate||function(ie,t,s,N){var x=arguments.length,V=x<3?t:N===null?N=Object.getOwnPropertyDescriptor(t,s):N,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")V=Reflect.decorate(ie,t,s,N);else for(var A=ie.length-1;A>=0;A--)(_=ie[A])&&(V=(x<3?_(V):x>3?_(t,s,V):_(t,s))||V);return x>3&&V&&Object.defineProperty(t,s,V),V};define(ge[29],pe([1,0,3,22,12,31,4,2,55]),function(ie,t,s,N,x,V,_,A,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var p;(function(W){W.Tap="-monaco-gesturetap",W.Change="-monaco-gesturechange",W.Start="-monaco-gesturestart",W.End="-monaco-gesturesend",W.Contextmenu="-monaco-gesturecontextmenu"})(p||(t.EventType=p={}));class w extends A.Disposable{static{this.SCROLL_FRICTION=-.005}static{this.HOLD_DELAY=700}static{this.CLEAR_TAP_COUNT_TIME=400}constructor(){super(),this.dispatched=!1,this.targets=new m.LinkedList,this.ignoreTargets=new m.LinkedList,this.activeTouches={},this.handle=null,this._lastSetTapCountTime=0,this._register(_.Event.runAndSubscribe(s.onDidRegisterWindow,({window:h,disposables:d})=>{d.add(s.addDisposableListener(h.document,"touchstart",e=>this.onTouchStart(e),{passive:!1})),d.add(s.addDisposableListener(h.document,"touchend",e=>this.onTouchEnd(h,e))),d.add(s.addDisposableListener(h.document,"touchmove",e=>this.onTouchMove(e),{passive:!1}))},{window:N.mainWindow,disposables:this._store}))}static addTarget(h){if(!w.isTouchDevice())return A.Disposable.None;w.INSTANCE||(w.INSTANCE=(0,A.markAsSingleton)(new w));const d=w.INSTANCE.targets.push(h);return(0,A.toDisposable)(d)}static ignoreTarget(h){if(!w.isTouchDevice())return A.Disposable.None;w.INSTANCE||(w.INSTANCE=(0,A.markAsSingleton)(new w));const d=w.INSTANCE.ignoreTargets.push(h);return(0,A.toDisposable)(d)}static isTouchDevice(){return"ontouchstart"in N.mainWindow||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(h){const d=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let e=0,i=h.targetTouches.length;e<i;e++){const r=h.targetTouches.item(e);this.activeTouches[r.identifier]={id:r.identifier,initialTarget:r.target,initialTimeStamp:d,initialPageX:r.pageX,initialPageY:r.pageY,rollingTimestamps:[d],rollingPageX:[r.pageX],rollingPageY:[r.pageY]};const u=this.newGestureEvent(p.Start,r.target);u.pageX=r.pageX,u.pageY=r.pageY,this.dispatchEvent(u)}this.dispatched&&(h.preventDefault(),h.stopPropagation(),this.dispatched=!1)}onTouchEnd(h,d){const e=Date.now(),i=Object.keys(this.activeTouches).length;for(let r=0,u=d.changedTouches.length;r<u;r++){const g=d.changedTouches.item(r);if(!this.activeTouches.hasOwnProperty(String(g.identifier))){console.warn("move of an UNKNOWN touch",g);continue}const D=this.activeTouches[g.identifier],a=Date.now()-D.initialTimeStamp;if(a<w.HOLD_DELAY&&Math.abs(D.initialPageX-x.tail(D.rollingPageX))<30&&Math.abs(D.initialPageY-x.tail(D.rollingPageY))<30){const f=this.newGestureEvent(p.Tap,D.initialTarget);f.pageX=x.tail(D.rollingPageX),f.pageY=x.tail(D.rollingPageY),this.dispatchEvent(f)}else if(a>=w.HOLD_DELAY&&Math.abs(D.initialPageX-x.tail(D.rollingPageX))<30&&Math.abs(D.initialPageY-x.tail(D.rollingPageY))<30){const f=this.newGestureEvent(p.Contextmenu,D.initialTarget);f.pageX=x.tail(D.rollingPageX),f.pageY=x.tail(D.rollingPageY),this.dispatchEvent(f)}else if(i===1){const f=x.tail(D.rollingPageX),o=x.tail(D.rollingPageY),C=x.tail(D.rollingTimestamps)-D.rollingTimestamps[0],F=f-D.rollingPageX[0],R=o-D.rollingPageY[0],B=[...this.targets].filter(P=>D.initialTarget instanceof Node&&P.contains(D.initialTarget));this.inertia(h,B,e,Math.abs(F)/C,F>0?1:-1,f,Math.abs(R)/C,R>0?1:-1,o)}this.dispatchEvent(this.newGestureEvent(p.End,D.initialTarget)),delete this.activeTouches[g.identifier]}this.dispatched&&(d.preventDefault(),d.stopPropagation(),this.dispatched=!1)}newGestureEvent(h,d){const e=document.createEvent("CustomEvent");return e.initEvent(h,!1,!0),e.initialTarget=d,e.tapCount=0,e}dispatchEvent(h){if(h.type===p.Tap){const d=new Date().getTime();let e=0;d-this._lastSetTapCountTime>w.CLEAR_TAP_COUNT_TIME?e=1:e=2,this._lastSetTapCountTime=d,h.tapCount=e}else(h.type===p.Change||h.type===p.Contextmenu)&&(this._lastSetTapCountTime=0);if(h.initialTarget instanceof Node){for(const e of this.ignoreTargets)if(e.contains(h.initialTarget))return;const d=[];for(const e of this.targets)if(e.contains(h.initialTarget)){let i=0,r=h.initialTarget;for(;r&&r!==e;)i++,r=r.parentElement;d.push([i,e])}d.sort((e,i)=>e[0]-i[0]);for(const[e,i]of d)i.dispatchEvent(h),this.dispatched=!0}}inertia(h,d,e,i,r,u,g,D,a){this.handle=s.scheduleAtNextAnimationFrame(h,()=>{const f=Date.now(),o=f-e;let C=0,F=0,R=!0;i+=w.SCROLL_FRICTION*o,g+=w.SCROLL_FRICTION*o,i>0&&(R=!1,C=r*i*o),g>0&&(R=!1,F=D*g*o);const B=this.newGestureEvent(p.Change);B.translationX=C,B.translationY=F,d.forEach(P=>P.dispatchEvent(B)),R||this.inertia(h,d,f,i,r,u+C,g,D,a+F)})}onTouchMove(h){const d=Date.now();for(let e=0,i=h.changedTouches.length;e<i;e++){const r=h.changedTouches.item(e);if(!this.activeTouches.hasOwnProperty(String(r.identifier))){console.warn("end of an UNKNOWN touch",r);continue}const u=this.activeTouches[r.identifier],g=this.newGestureEvent(p.Change,u.initialTarget);g.translationX=r.pageX-x.tail(u.rollingPageX),g.translationY=r.pageY-x.tail(u.rollingPageY),g.pageX=r.pageX,g.pageY=r.pageY,this.dispatchEvent(g),u.rollingPageX.length>3&&(u.rollingPageX.shift(),u.rollingPageY.shift(),u.rollingTimestamps.shift()),u.rollingPageX.push(r.pageX),u.rollingPageY.push(r.pageY),u.rollingTimestamps.push(d)}this.dispatched&&(h.preventDefault(),h.stopPropagation(),this.dispatched=!1)}}t.Gesture=w,Xe([V.memoize],w,"isTouchDevice",null)}),define(ge[67],pe([1,0,3,104]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setARIAContainer=p,t.alert=w,t.status=W;const N=2e4;let x,V,_,A,m;function p(d){x=document.createElement("div"),x.className="monaco-aria-container";const e=()=>{const r=document.createElement("div");return r.className="monaco-alert",r.setAttribute("role","alert"),r.setAttribute("aria-atomic","true"),x.appendChild(r),r};V=e(),_=e();const i=()=>{const r=document.createElement("div");return r.className="monaco-status",r.setAttribute("aria-live","polite"),r.setAttribute("aria-atomic","true"),x.appendChild(r),r};A=i(),m=i(),d.appendChild(x)}function w(d){x&&(V.textContent!==d?(s.clearNode(_),h(V,d)):(s.clearNode(V),h(_,d)))}function W(d){x&&(A.textContent!==d?(s.clearNode(m),h(A,d)):(s.clearNode(A),h(m,d)))}function h(d,e){s.clearNode(d),e.length>N&&(e=e.substr(0,N)),d.textContent=e,d.style.visibility="hidden",d.style.visibility="visible"}}),define(ge[131],pe([1,0,3,19]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderLabelWithIcons=V,t.renderIcon=_;const x=new RegExp(`(\\\\)?\\$\\((${N.ThemeIcon.iconNameExpression}(?:${N.ThemeIcon.iconModifierExpression})?)\\)`,"g");function V(A){const m=new Array;let p,w=0,W=0;for(;(p=x.exec(A))!==null;){W=p.index||0,w<W&&m.push(A.substring(w,W)),w=(p.index||0)+p[0].length;const[,h,d]=p;m.push(h?`$(${d})`:_({id:d}))}return w<A.length&&m.push(A.substring(w)),m}function _(A){const m=s.$("span");return m.classList.add(...N.ThemeIcon.asClassNameArray(A)),m}}),define(ge[132],pe([1,0,3]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function N(V){try{V.parentElement?.removeChild(V)}catch{}}class x{constructor(_){this.renderers=_,this.cache=new Map,this.transactionNodesPendingRemoval=new Set,this.inTransaction=!1}alloc(_){let A=this.getTemplateCache(_).pop(),m=!1;if(A)m=this.transactionNodesPendingRemoval.has(A.domNode),m&&this.transactionNodesPendingRemoval.delete(A.domNode);else{const p=(0,s.$)(".monaco-list-row"),W=this.getRenderer(_).renderTemplate(p);A={domNode:p,templateId:_,templateData:W}}return{row:A,isReusingConnectedDomNode:m}}release(_){_&&this.releaseRow(_)}transact(_){if(this.inTransaction)throw new Error("Already in transaction");this.inTransaction=!0;try{_()}finally{for(const A of this.transactionNodesPendingRemoval)this.doRemoveNode(A);this.transactionNodesPendingRemoval.clear(),this.inTransaction=!1}}releaseRow(_){const{domNode:A,templateId:m}=_;A&&(this.inTransaction?this.transactionNodesPendingRemoval.add(A):this.doRemoveNode(A)),this.getTemplateCache(m).push(_)}doRemoveNode(_){_.classList.remove("scrolling"),N(_)}getTemplateCache(_){let A=this.cache.get(_);return A||(A=[],this.cache.set(_,A)),A}dispose(){this.cache.forEach((_,A)=>{for(const m of _)this.getRenderer(A).disposeTemplate(m.templateData),m.templateData=null}),this.cache.clear(),this.transactionNodesPendingRemoval.clear()}getRenderer(_){const A=this.renderers.get(_);if(!A)throw new Error(`No renderer found for ${_}`);return A}}t.RowCache=x}),define(ge[133],pe([1,0,9,2]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class x extends N.Disposable{constructor(_,A,m){super(),this._visibility=_,this._visibleClassName=A,this._invisibleClassName=m,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new s.TimeoutTimer)}setVisibility(_){this._visibility!==_&&(this._visibility=_,this._updateShouldBeVisible())}setShouldBeVisible(_){this._rawShouldBeVisible=_,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===2?!1:this._visibility===3?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const _=this._applyVisibilitySetting();this._shouldBeVisible!==_&&(this._shouldBeVisible=_,this.ensureVisibility())}setIsNeeded(_){this._isNeeded!==_&&(this._isNeeded=_,this.ensureVisibility())}setDomNode(_){this._domNode=_,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(_){this._revealTimer.cancel(),this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(_?" fade":"")))}}t.ScrollbarVisibilityController=x}),define(ge[134],pe([1,0,3,29,12,4,2,5]),function(ie,t,s,N,x,V,_,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class m extends _.Disposable{constructor(w,W,h,d){super(),this.selected=0,this.selectBoxOptions=d||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new V.Emitter),this.styles=h,this.registerListeners(),this.setOptions(w,W)}registerListeners(){this._register(N.Gesture.addTarget(this.selectElement)),[N.EventType.Tap].forEach(w=>{this._register(s.addDisposableListener(this.selectElement,w,W=>{this.selectElement.focus()}))}),this._register(s.addStandardDisposableListener(this.selectElement,"click",w=>{s.EventHelper.stop(w,!0)})),this._register(s.addStandardDisposableListener(this.selectElement,"change",w=>{this.selectElement.title=w.target.value,this._onDidSelect.fire({index:w.target.selectedIndex,selected:w.target.value})})),this._register(s.addStandardDisposableListener(this.selectElement,"keydown",w=>{let W=!1;A.isMacintosh?(w.keyCode===18||w.keyCode===16||w.keyCode===10)&&(W=!0):(w.keyCode===18&&w.altKey||w.keyCode===10||w.keyCode===3)&&(W=!0),W&&w.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(w,W){(!this.options||!x.equals(this.options,w))&&(this.options=w,this.selectElement.options.length=0,this.options.forEach((h,d)=>{this.selectElement.add(this.createOption(h.text,d,h.isDisabled))})),W!==void 0&&this.select(W)}select(w){this.options.length===0?this.selected=0:w>=0&&w<this.options.length?this.selected=w:w>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(w){this.selectBoxOptions.ariaLabel=w,this.selectElement.setAttribute("aria-label",w)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(w){this.selectElement.tabIndex=w?0:-1}render(w){w.classList.add("select-container"),w.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(w){this.styles=w,this.applyStyles()}applyStyles(){this.selectElement&&(this.selectElement.style.backgroundColor=this.styles.selectBackground??"",this.selectElement.style.color=this.styles.selectForeground??"",this.selectElement.style.borderColor=this.styles.selectBorder??"")}createOption(w,W,h){const d=document.createElement("option");return d.value=w,d.text=w,d.disabled=!!h,d}}t.SelectBoxNative=m}),define(ge[68],pe([1,0,30,12,9,60,98,4,32]),function(ie,t,s,N,x,V,_,A,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=void 0,t.isFilterResult=p,t.getVisibleState=w;function p(d){return typeof d=="object"&&"visibility"in d&&"data"in d}function w(d){switch(d){case!0:return 1;case!1:return 0;default:return d}}function W(d){return typeof d.collapsible=="boolean"}class h{constructor(e,i,r,u={}){this.user=e,this.list=i,this.rootRef=[],this.eventBufferer=new A.EventBufferer,this._onDidChangeCollapseState=new A.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new A.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new A.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new x.Delayer(V.MicrotaskDelay),this.collapseByDefault=typeof u.collapseByDefault>"u"?!1:u.collapseByDefault,this.allowNonCollapsibleParents=u.allowNonCollapsibleParents??!1,this.filter=u.filter,this.autoExpandSingleChildren=typeof u.autoExpandSingleChildren>"u"?!1:u.autoExpandSingleChildren,this.root={parent:void 0,element:r,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,i,r=m.Iterable.empty(),u={}){if(e.length===0)throw new s.TreeError(this.user,"Invalid tree location");u.diffIdentityProvider?this.spliceSmart(u.diffIdentityProvider,e,i,r,u):this.spliceSimple(e,i,r,u)}spliceSmart(e,i,r,u=m.Iterable.empty(),g,D=g.diffDepth??0){const{parentNode:a}=this.getParentNodeWithListIndex(i);if(!a.lastDiffIds)return this.spliceSimple(i,r,u,g);const f=[...u],o=i[i.length-1],C=new _.LcsDiff({getElements:()=>a.lastDiffIds},{getElements:()=>[...a.children.slice(0,o),...f,...a.children.slice(o+r)].map(b=>e.getId(b.element).toString())}).ComputeDiff(!1);if(C.quitEarly)return a.lastDiffIds=void 0,this.spliceSimple(i,r,f,g);const F=i.slice(0,-1),R=(b,O,$)=>{if(D>0)for(let k=0;k<$;k++)b--,O--,this.spliceSmart(e,[...F,b,0],Number.MAX_SAFE_INTEGER,f[O].children,g,D-1)};let B=Math.min(a.children.length,o+r),P=f.length;for(const b of C.changes.sort((O,$)=>$.originalStart-O.originalStart))R(B,P,B-(b.originalStart+b.originalLength)),B=b.originalStart,P=b.modifiedStart-o,this.spliceSimple([...F,B],b.originalLength,m.Iterable.slice(f,P,P+b.modifiedLength),g);R(B,P,B)}spliceSimple(e,i,r=m.Iterable.empty(),{onDidCreateNode:u,onDidDeleteNode:g,diffIdentityProvider:D}){const{parentNode:a,listIndex:f,revealed:o,visible:C}=this.getParentNodeWithListIndex(e),F=[],R=m.Iterable.map(r,q=>this.createTreeNode(q,a,a.visible?1:0,o,F,u)),B=e[e.length-1];let P=0;for(let q=B;q>=0&&q<a.children.length;q--){const X=a.children[q];if(X.visible){P=X.visibleChildIndex;break}}const b=[];let O=0,$=0;for(const q of R)b.push(q),$+=q.renderNodeCount,q.visible&&(q.visibleChildIndex=P+O++);const k=(0,N.splice)(a.children,B,i,b);D?a.lastDiffIds?(0,N.splice)(a.lastDiffIds,B,i,b.map(q=>D.getId(q.element).toString())):a.lastDiffIds=a.children.map(q=>D.getId(q.element).toString()):a.lastDiffIds=void 0;let M=0;for(const q of k)q.visible&&M++;if(M!==0)for(let q=B+b.length;q<a.children.length;q++){const X=a.children[q];X.visible&&(X.visibleChildIndex-=M)}if(a.visibleChildrenCount+=O-M,o&&C){const q=k.reduce((X,ce)=>X+(ce.visible?ce.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(a,$-q),this.list.splice(f,q,F)}if(k.length>0&&g){const q=X=>{g(X),X.children.forEach(q)};k.forEach(q)}this._onDidSplice.fire({insertedNodes:b,deletedNodes:k});let I=a;for(;I;){if(I.visibility===2){this.refilterDelayer.trigger(()=>this.refilter());break}I=I.parent}}rerender(e){if(e.length===0)throw new s.TreeError(this.user,"Invalid tree location");const{node:i,listIndex:r,revealed:u}=this.getTreeNodeWithListIndex(e);i.visible&&u&&this.list.splice(r,1,[i])}updateElementHeight(e,i){if(e.length===0)throw new s.TreeError(this.user,"Invalid tree location");const{listIndex:r}=this.getTreeNodeWithListIndex(e);this.list.updateElementHeight(r,i)}has(e){return this.hasTreeNode(e)}getListIndex(e){const{listIndex:i,visible:r,revealed:u}=this.getTreeNodeWithListIndex(e);return r&&u?i:-1}getListRenderCount(e){return this.getTreeNode(e).renderNodeCount}isCollapsible(e){return this.getTreeNode(e).collapsible}setCollapsible(e,i){const r=this.getTreeNode(e);typeof i>"u"&&(i=!r.collapsible);const u={collapsible:i};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,u))}isCollapsed(e){return this.getTreeNode(e).collapsed}setCollapsed(e,i,r){const u=this.getTreeNode(e);typeof i>"u"&&(i=!u.collapsed);const g={collapsed:i,recursive:r||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(e,g))}_setCollapseState(e,i){const{node:r,listIndex:u,revealed:g}=this.getTreeNodeWithListIndex(e),D=this._setListNodeCollapseState(r,u,g,i);if(r!==this.root&&this.autoExpandSingleChildren&&D&&!W(i)&&r.collapsible&&!r.collapsed&&!i.recursive){let a=-1;for(let f=0;f<r.children.length;f++)if(r.children[f].visible)if(a>-1){a=-1;break}else a=f;a>-1&&this._setCollapseState([...e,a],i)}return D}_setListNodeCollapseState(e,i,r,u){const g=this._setNodeCollapseState(e,u,!1);if(!r||!e.visible||!g)return g;const D=e.renderNodeCount,a=this.updateNodeAfterCollapseChange(e),f=D-(i===-1?0:1);return this.list.splice(i+1,f,a.slice(1)),g}_setNodeCollapseState(e,i,r){let u;if(e===this.root?u=!1:(W(i)?(u=e.collapsible!==i.collapsible,e.collapsible=i.collapsible):e.collapsible?(u=e.collapsed!==i.collapsed,e.collapsed=i.collapsed):u=!1,u&&this._onDidChangeCollapseState.fire({node:e,deep:r})),!W(i)&&i.recursive)for(const g of e.children)u=this._setNodeCollapseState(g,i,!0)||u;return u}expandTo(e){this.eventBufferer.bufferEvents(()=>{let i=this.getTreeNode(e);for(;i.parent;)i=i.parent,e=e.slice(0,e.length-1),i.collapsed&&this._setCollapseState(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.root.renderNodeCount,i=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,e,i),this.refilterDelayer.cancel()}createTreeNode(e,i,r,u,g,D){const a={parent:i,element:e.element,children:[],depth:i.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.collapseByDefault:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},f=this._filterNode(a,r);a.visibility=f,u&&g.push(a);const o=e.children||m.Iterable.empty(),C=u&&f!==0&&!a.collapsed;let F=0,R=1;for(const B of o){const P=this.createTreeNode(B,a,f,C,g,D);a.children.push(P),R+=P.renderNodeCount,P.visible&&(P.visibleChildIndex=F++)}return this.allowNonCollapsibleParents||(a.collapsible=a.collapsible||a.children.length>0),a.visibleChildrenCount=F,a.visible=f===2?F>0:f===1,a.visible?a.collapsed||(a.renderNodeCount=R):(a.renderNodeCount=0,u&&g.pop()),D?.(a),a}updateNodeAfterCollapseChange(e){const i=e.renderNodeCount,r=[];return this._updateNodeAfterCollapseChange(e,r),this._updateAncestorsRenderNodeCount(e.parent,r.length-i),r}_updateNodeAfterCollapseChange(e,i){if(e.visible===!1)return 0;if(i.push(e),e.renderNodeCount=1,!e.collapsed)for(const r of e.children)e.renderNodeCount+=this._updateNodeAfterCollapseChange(r,i);return this._onDidChangeRenderNodeCount.fire(e),e.renderNodeCount}updateNodeAfterFilterChange(e){const i=e.renderNodeCount,r=[];return this._updateNodeAfterFilterChange(e,e.visible?1:0,r),this._updateAncestorsRenderNodeCount(e.parent,r.length-i),r}_updateNodeAfterFilterChange(e,i,r,u=!0){let g;if(e!==this.root){if(g=this._filterNode(e,i),g===0)return e.visible=!1,e.renderNodeCount=0,!1;u&&r.push(e)}const D=r.length;e.renderNodeCount=e===this.root?0:1;let a=!1;if(!e.collapsed||g!==0){let f=0;for(const o of e.children)a=this._updateNodeAfterFilterChange(o,g,r,u&&!e.collapsed)||a,o.visible&&(o.visibleChildIndex=f++);e.visibleChildrenCount=f}else e.visibleChildrenCount=0;return e!==this.root&&(e.visible=g===2?a:g===1,e.visibility=g),e.visible?e.collapsed||(e.renderNodeCount+=r.length-D):(e.renderNodeCount=0,u&&r.pop()),this._onDidChangeRenderNodeCount.fire(e),e.visible}_updateAncestorsRenderNodeCount(e,i){if(i!==0)for(;e;)e.renderNodeCount+=i,this._onDidChangeRenderNodeCount.fire(e),e=e.parent}_filterNode(e,i){const r=this.filter?this.filter.filter(e.element,i):1;return typeof r=="boolean"?(e.filterData=void 0,r?1:0):p(r)?(e.filterData=r.data,w(r.visibility)):(e.filterData=void 0,w(r))}hasTreeNode(e,i=this.root){if(!e||e.length===0)return!0;const[r,...u]=e;return r<0||r>i.children.length?!1:this.hasTreeNode(u,i.children[r])}getTreeNode(e,i=this.root){if(!e||e.length===0)return i;const[r,...u]=e;if(r<0||r>i.children.length)throw new s.TreeError(this.user,"Invalid tree location");return this.getTreeNode(u,i.children[r])}getTreeNodeWithListIndex(e){if(e.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:i,listIndex:r,revealed:u,visible:g}=this.getParentNodeWithListIndex(e),D=e[e.length-1];if(D<0||D>i.children.length)throw new s.TreeError(this.user,"Invalid tree location");const a=i.children[D];return{node:a,listIndex:r,revealed:u,visible:g&&a.visible}}getParentNodeWithListIndex(e,i=this.root,r=0,u=!0,g=!0){const[D,...a]=e;if(D<0||D>i.children.length)throw new s.TreeError(this.user,"Invalid tree location");for(let f=0;f<D;f++)r+=i.children[f].renderNodeCount;return u=u&&!i.collapsed,g=g&&i.visible,a.length===0?{parentNode:i,listIndex:r,revealed:u,visible:g}:this.getParentNodeWithListIndex(a,i.children[D],r+1,u,g)}getNode(e=[]){return this.getTreeNode(e)}getNodeLocation(e){const i=[];let r=e;for(;r.parent;)i.push(r.parent.children.indexOf(r)),r=r.parent;return i.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,N.tail2)(e)[0]}getFirstElementChild(e){const i=this.getTreeNode(e);if(i.children.length!==0)return i.children[0].element}getLastElementAncestor(e=[]){const i=this.getTreeNode(e);if(i.children.length!==0)return this._getLastElementAncestor(i)}_getLastElementAncestor(e){return e.children.length===0?e.element:this._getLastElementAncestor(e.children[e.children.length-1])}}t.IndexTreeModel=h}),define(ge[135],pe([1,0,68,30,32]),function(ie,t,s,N,x){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class V{get size(){return this.nodes.size}constructor(A,m,p={}){this.user=A,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new s.IndexTreeModel(A,m,null,p),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,p.sorter&&(this.sorter={compare(w,W){return p.sorter.compare(w.element,W.element)}}),this.identityProvider=p.identityProvider}setChildren(A,m=x.Iterable.empty(),p={}){const w=this.getElementLocation(A);this._setChildren(w,this.preserveCollapseState(m),p)}_setChildren(A,m=x.Iterable.empty(),p){const w=new Set,W=new Set,h=e=>{if(e.element===null)return;const i=e;if(w.add(i.element),this.nodes.set(i.element,i),this.identityProvider){const r=this.identityProvider.getId(i.element).toString();W.add(r),this.nodesByIdentity.set(r,i)}p.onDidCreateNode?.(i)},d=e=>{if(e.element===null)return;const i=e;if(w.has(i.element)||this.nodes.delete(i.element),this.identityProvider){const r=this.identityProvider.getId(i.element).toString();W.has(r)||this.nodesByIdentity.delete(r)}p.onDidDeleteNode?.(i)};this.model.splice([...A,0],Number.MAX_VALUE,m,{...p,onDidCreateNode:h,onDidDeleteNode:d})}preserveCollapseState(A=x.Iterable.empty()){return this.sorter&&(A=[...A].sort(this.sorter.compare.bind(this.sorter))),x.Iterable.map(A,m=>{let p=this.nodes.get(m.element);if(!p&&this.identityProvider){const h=this.identityProvider.getId(m.element).toString();p=this.nodesByIdentity.get(h)}if(!p){let h;return typeof m.collapsed>"u"?h=void 0:m.collapsed===N.ObjectTreeElementCollapseState.Collapsed||m.collapsed===N.ObjectTreeElementCollapseState.PreserveOrCollapsed?h=!0:m.collapsed===N.ObjectTreeElementCollapseState.Expanded||m.collapsed===N.ObjectTreeElementCollapseState.PreserveOrExpanded?h=!1:h=!!m.collapsed,{...m,children:this.preserveCollapseState(m.children),collapsed:h}}const w=typeof m.collapsible=="boolean"?m.collapsible:p.collapsible;let W;return typeof m.collapsed>"u"||m.collapsed===N.ObjectTreeElementCollapseState.PreserveOrCollapsed||m.collapsed===N.ObjectTreeElementCollapseState.PreserveOrExpanded?W=p.collapsed:m.collapsed===N.ObjectTreeElementCollapseState.Collapsed?W=!0:m.collapsed===N.ObjectTreeElementCollapseState.Expanded?W=!1:W=!!m.collapsed,{...m,collapsible:w,collapsed:W,children:this.preserveCollapseState(m.children)}})}rerender(A){const m=this.getElementLocation(A);this.model.rerender(m)}updateElementHeight(A,m){const p=this.getElementLocation(A);this.model.updateElementHeight(p,m)}resort(A=null,m=!0){if(!this.sorter)return;const p=this.getElementLocation(A),w=this.model.getNode(p);this._setChildren(p,this.resortChildren(w,m),{})}resortChildren(A,m,p=!0){let w=[...A.children];return(m||p)&&(w=w.sort(this.sorter.compare.bind(this.sorter))),x.Iterable.map(w,W=>({element:W.element,collapsible:W.collapsible,collapsed:W.collapsed,children:this.resortChildren(W,m,!1)}))}getFirstElementChild(A=null){const m=this.getElementLocation(A);return this.model.getFirstElementChild(m)}getLastElementAncestor(A=null){const m=this.getElementLocation(A);return this.model.getLastElementAncestor(m)}has(A){return this.nodes.has(A)}getListIndex(A){const m=this.getElementLocation(A);return this.model.getListIndex(m)}getListRenderCount(A){const m=this.getElementLocation(A);return this.model.getListRenderCount(m)}isCollapsible(A){const m=this.getElementLocation(A);return this.model.isCollapsible(m)}setCollapsible(A,m){const p=this.getElementLocation(A);return this.model.setCollapsible(p,m)}isCollapsed(A){const m=this.getElementLocation(A);return this.model.isCollapsed(m)}setCollapsed(A,m,p){const w=this.getElementLocation(A);return this.model.setCollapsed(w,m,p)}expandTo(A){const m=this.getElementLocation(A);this.model.expandTo(m)}refilter(){this.model.refilter()}getNode(A=null){if(A===null)return this.model.getNode(this.model.rootRef);const m=this.nodes.get(A);if(!m)throw new N.TreeError(this.user,`Tree element not found: ${A}`);return m}getNodeLocation(A){return A.element}getParentNodeLocation(A){if(A===null)throw new N.TreeError(this.user,"Invalid getParentNodeLocation call");const m=this.nodes.get(A);if(!m)throw new N.TreeError(this.user,`Tree element not found: ${A}`);const p=this.model.getNodeLocation(m),w=this.model.getParentNodeLocation(p);return this.model.getNode(w).element}getElementLocation(A){if(A===null)return[];const m=this.nodes.get(A);if(!m)throw new N.TreeError(this.user,`Tree element not found: ${A}`);return this.model.getNodeLocation(m)}}t.ObjectTreeModel=V}),define(ge[21],pe([1,0,3,15,20,29,2]),function(ie,t,s,N,x,V,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class A extends _.Disposable{onclick(p,w){this._register(s.addDisposableListener(p,s.EventType.CLICK,W=>w(new x.StandardMouseEvent(s.getWindow(p),W))))}onmousedown(p,w){this._register(s.addDisposableListener(p,s.EventType.MOUSE_DOWN,W=>w(new x.StandardMouseEvent(s.getWindow(p),W))))}onmouseover(p,w){this._register(s.addDisposableListener(p,s.EventType.MOUSE_OVER,W=>w(new x.StandardMouseEvent(s.getWindow(p),W))))}onmouseleave(p,w){this._register(s.addDisposableListener(p,s.EventType.MOUSE_LEAVE,W=>w(new x.StandardMouseEvent(s.getWindow(p),W))))}onkeydown(p,w){this._register(s.addDisposableListener(p,s.EventType.KEY_DOWN,W=>w(new N.StandardKeyboardEvent(W))))}onkeyup(p,w){this._register(s.addDisposableListener(p,s.EventType.KEY_UP,W=>w(new N.StandardKeyboardEvent(W))))}oninput(p,w){this._register(s.addDisposableListener(p,s.EventType.INPUT,w))}onblur(p,w){this._register(s.addDisposableListener(p,s.EventType.BLUR,w))}onfocus(p,w){this._register(s.addDisposableListener(p,s.EventType.FOCUS,w))}onchange(p,w){this._register(s.addDisposableListener(p,s.EventType.CHANGE,w))}ignoreGesture(p){return V.Gesture.ignoreTarget(p)}}t.Widget=A}),define(ge[48],pe([1,0,66,21,9,19,3]),function(ie,t,s,N,x,V,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class A extends N.Widget{constructor(p){super(),this._onActivate=p.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=p.bgWidth+"px",this.bgDomNode.style.height=p.bgHeight+"px",typeof p.top<"u"&&(this.bgDomNode.style.top="0px"),typeof p.left<"u"&&(this.bgDomNode.style.left="0px"),typeof p.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof p.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=p.className,this.domNode.classList.add(...V.ThemeIcon.asClassNameArray(p.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof p.top<"u"&&(this.domNode.style.top=p.top+"px"),typeof p.left<"u"&&(this.domNode.style.left=p.left+"px"),typeof p.bottom<"u"&&(this.domNode.style.bottom=p.bottom+"px"),typeof p.right<"u"&&(this.domNode.style.right=p.right+"px"),this._pointerMoveMonitor=this._register(new s.GlobalPointerMoveMonitor),this._register(_.addStandardDisposableListener(this.bgDomNode,_.EventType.POINTER_DOWN,w=>this._arrowPointerDown(w))),this._register(_.addStandardDisposableListener(this.domNode,_.EventType.POINTER_DOWN,w=>this._arrowPointerDown(w))),this._pointerdownRepeatTimer=this._register(new _.WindowIntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new x.TimeoutTimer)}_arrowPointerDown(p){if(!p.target||!(p.target instanceof Element))return;const w=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24,_.getWindow(p))};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(w,200),this._pointerMoveMonitor.startMonitoring(p.target,p.pointerId,p.buttons,W=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),p.preventDefault()}}t.ScrollbarArrow=A}),define(ge[69],pe([1,0,3,51,66,48,133,21,5]),function(ie,t,s,N,x,V,_,A,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const p=140;class w extends A.Widget{constructor(h){super(),this._lazyRender=h.lazyRender,this._host=h.host,this._scrollable=h.scrollable,this._scrollByPage=h.scrollByPage,this._scrollbarState=h.scrollbarState,this._visibilityController=this._register(new _.ScrollbarVisibilityController(h.visibility,"visible scrollbar "+h.extraScrollbarClassName,"invisible scrollbar "+h.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new x.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,N.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(s.addDisposableListener(this.domNode.domNode,s.EventType.POINTER_DOWN,d=>this._domNodePointerDown(d)))}_createArrow(h){const d=this._register(new V.ScrollbarArrow(h));this.domNode.domNode.appendChild(d.bgDomNode),this.domNode.domNode.appendChild(d.domNode)}_createSlider(h,d,e,i){this.slider=(0,N.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(h),this.slider.setLeft(d),typeof e=="number"&&this.slider.setWidth(e),typeof i=="number"&&this.slider.setHeight(i),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(s.addDisposableListener(this.slider.domNode,s.EventType.POINTER_DOWN,r=>{r.button===0&&(r.preventDefault(),this._sliderPointerDown(r))})),this.onclick(this.slider.domNode,r=>{r.leftButton&&r.stopPropagation()})}_onElementSize(h){return this._scrollbarState.setVisibleSize(h)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(h){return this._scrollbarState.setScrollSize(h)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(h){return this._scrollbarState.setScrollPosition(h)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){this._shouldRender&&(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(h){h.target===this.domNode.domNode&&this._onPointerDown(h)}delegatePointerDown(h){const d=this.domNode.domNode.getClientRects()[0].top,e=d+this._scrollbarState.getSliderPosition(),i=d+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),r=this._sliderPointerPosition(h);e<=r&&r<=i?h.button===0&&(h.preventDefault(),this._sliderPointerDown(h)):this._onPointerDown(h)}_onPointerDown(h){let d,e;if(h.target===this.domNode.domNode&&typeof h.offsetX=="number"&&typeof h.offsetY=="number")d=h.offsetX,e=h.offsetY;else{const r=s.getDomNodePagePosition(this.domNode.domNode);d=h.pageX-r.left,e=h.pageY-r.top}const i=this._pointerDownRelativePosition(d,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(i):this._scrollbarState.getDesiredScrollPositionFromOffset(i)),h.button===0&&(h.preventDefault(),this._sliderPointerDown(h))}_sliderPointerDown(h){if(!h.target||!(h.target instanceof Element))return;const d=this._sliderPointerPosition(h),e=this._sliderOrthogonalPointerPosition(h),i=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(h.target,h.pointerId,h.buttons,r=>{const u=this._sliderOrthogonalPointerPosition(r),g=Math.abs(u-e);if(m.isWindows&&g>p){this._setDesiredScrollPositionNow(i.getScrollPosition());return}const a=this._sliderPointerPosition(r)-d;this._setDesiredScrollPositionNow(i.getDesiredScrollPositionFromDelta(a))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(h){const d={};this.writeScrollPosition(d,h),this._scrollable.setScrollPositionNow(d)}updateScrollbarSize(h){this._updateScrollbarSize(h),this._scrollbarState.setScrollbarSize(h),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=w}),define(ge[136],pe([1,0,20,69,48,52,18]),function(ie,t,s,N,x,V,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class A extends N.AbstractScrollbar{constructor(p,w,W){const h=p.getScrollDimensions(),d=p.getCurrentScrollPosition();if(super({lazyRender:w.lazyRender,host:W,scrollbarState:new V.ScrollbarState(w.horizontalHasArrows?w.arrowSize:0,w.horizontal===2?0:w.horizontalScrollbarSize,w.vertical===2?0:w.verticalScrollbarSize,h.width,h.scrollWidth,d.scrollLeft),visibility:w.horizontal,extraScrollbarClassName:"horizontal",scrollable:p,scrollByPage:w.scrollByPage}),w.horizontalHasArrows){const e=(w.arrowSize-x.ARROW_IMG_SIZE)/2,i=(w.horizontalScrollbarSize-x.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:_.Codicon.scrollbarButtonLeft,top:i,left:e,bottom:void 0,right:void 0,bgWidth:w.arrowSize,bgHeight:w.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new s.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:_.Codicon.scrollbarButtonRight,top:i,left:void 0,bottom:void 0,right:e,bgWidth:w.arrowSize,bgHeight:w.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new s.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((w.horizontalScrollbarSize-w.horizontalSliderSize)/2),0,void 0,w.horizontalSliderSize)}_updateSlider(p,w){this.slider.setWidth(p),this.slider.setLeft(w)}_renderDomNode(p,w){this.domNode.setWidth(p),this.domNode.setHeight(w),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(p){return this._shouldRender=this._onElementScrollSize(p.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(p.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(p.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(p,w){return p}_sliderPointerPosition(p){return p.pageX}_sliderOrthogonalPointerPosition(p){return p.pageY}_updateScrollbarSize(p){this.slider.setHeight(p)}writeScrollPosition(p,w){p.scrollLeft=w}updateOptions(p){this.updateScrollbarSize(p.horizontal===2?0:p.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(p.vertical===2?0:p.verticalScrollbarSize),this._visibilityController.setVisibility(p.horizontal),this._scrollByPage=p.scrollByPage}}t.HorizontalScrollbar=A}),define(ge[137],pe([1,0,20,69,48,52,18]),function(ie,t,s,N,x,V,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class A extends N.AbstractScrollbar{constructor(p,w,W){const h=p.getScrollDimensions(),d=p.getCurrentScrollPosition();if(super({lazyRender:w.lazyRender,host:W,scrollbarState:new V.ScrollbarState(w.verticalHasArrows?w.arrowSize:0,w.vertical===2?0:w.verticalScrollbarSize,0,h.height,h.scrollHeight,d.scrollTop),visibility:w.vertical,extraScrollbarClassName:"vertical",scrollable:p,scrollByPage:w.scrollByPage}),w.verticalHasArrows){const e=(w.arrowSize-x.ARROW_IMG_SIZE)/2,i=(w.verticalScrollbarSize-x.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:_.Codicon.scrollbarButtonUp,top:e,left:i,bottom:void 0,right:void 0,bgWidth:w.verticalScrollbarSize,bgHeight:w.arrowSize,onActivate:()=>this._host.onMouseWheel(new s.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:_.Codicon.scrollbarButtonDown,top:void 0,left:i,bottom:e,right:void 0,bgWidth:w.verticalScrollbarSize,bgHeight:w.arrowSize,onActivate:()=>this._host.onMouseWheel(new s.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((w.verticalScrollbarSize-w.verticalSliderSize)/2),w.verticalSliderSize,void 0)}_updateSlider(p,w){this.slider.setHeight(p),this.slider.setTop(w)}_renderDomNode(p,w){this.domNode.setWidth(w),this.domNode.setHeight(p),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(p){return this._shouldRender=this._onElementScrollSize(p.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(p.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(p.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(p,w){return w}_sliderPointerPosition(p){return p.pageY}_sliderOrthogonalPointerPosition(p){return p.pageX}_updateScrollbarSize(p){this.slider.setWidth(p)}writeScrollPosition(p,w){p.scrollTop=w}updateOptions(p){this.updateScrollbarSize(p.vertical===2?0:p.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(p.vertical),this._scrollByPage=p.scrollByPage}}t.VerticalScrollbar=A}),define(ge[70],pe([1,0,17,3,51,20,136,137,21,9,4,2,5,58,111]),function(ie,t,s,N,x,V,_,A,m,p,w,W,h,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,i=50,r=!0;class u{constructor(R,B,P){this.timestamp=R,this.deltaX=B,this.deltaY=P,this.score=0}}class g{static{this.INSTANCE=new g}constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let R=1,B=0,P=1,b=this._rear;do{const O=b===this._front?R:Math.pow(2,-P);if(R-=O,B+=this._memory[b].score*O,b===this._front)break;b=(this._capacity+b-1)%this._capacity,P++}while(!0);return B<=.5}acceptStandardWheelEvent(R){if(s.isChrome){const B=N.getWindow(R.browserEvent),P=(0,s.getZoomFactor)(B);this.accept(Date.now(),R.deltaX*P,R.deltaY*P)}else this.accept(Date.now(),R.deltaX,R.deltaY)}accept(R,B,P){let b=null;const O=new u(R,B,P);this._front===-1&&this._rear===-1?(this._memory[0]=O,this._front=0,this._rear=0):(b=this._memory[this._rear],this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=O),O.score=this._computeScore(O,b)}_computeScore(R,B){if(Math.abs(R.deltaX)>0&&Math.abs(R.deltaY)>0)return 1;let P=.5;if((!this._isAlmostInt(R.deltaX)||!this._isAlmostInt(R.deltaY))&&(P+=.25),B){const b=Math.abs(R.deltaX),O=Math.abs(R.deltaY),$=Math.abs(B.deltaX),k=Math.abs(B.deltaY),M=Math.max(Math.min(b,$),1),I=Math.max(Math.min(O,k),1),q=Math.max(b,$),X=Math.max(O,k);q%M===0&&X%I===0&&(P-=.5)}return Math.min(Math.max(P,0),1)}_isAlmostInt(R){return Math.abs(Math.round(R)-R)<.01}}t.MouseWheelClassifier=g;class D extends m.Widget{get options(){return this._options}constructor(R,B,P){super(),this._onScroll=this._register(new w.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new w.Emitter),this.onWillScroll=this._onWillScroll.event,R.style.overflow="hidden",this._options=C(B),this._scrollable=P,this._register(this._scrollable.onScroll(O=>{this._onWillScroll.fire(O),this._onDidScroll(O),this._onScroll.fire(O)}));const b={onMouseWheel:O=>this._onMouseWheel(O),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new A.VerticalScrollbar(this._scrollable,this._options,b)),this._horizontalScrollbar=this._register(new _.HorizontalScrollbar(this._scrollable,this._options,b)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(R),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,x.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,x.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,x.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,O=>this._onMouseOver(O)),this.onmouseleave(this._listenOnDomNode,O=>this._onMouseLeave(O)),this._hideTimeout=this._register(new p.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}dispose(){this._mouseWheelToDispose=(0,W.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(R){this._verticalScrollbar.delegatePointerDown(R)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(R){this._scrollable.setScrollDimensions(R,!1)}updateClassName(R){this._options.className=R,h.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(R){typeof R.handleMouseWheel<"u"&&(this._options.handleMouseWheel=R.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof R.mouseWheelScrollSensitivity<"u"&&(this._options.mouseWheelScrollSensitivity=R.mouseWheelScrollSensitivity),typeof R.fastScrollSensitivity<"u"&&(this._options.fastScrollSensitivity=R.fastScrollSensitivity),typeof R.scrollPredominantAxis<"u"&&(this._options.scrollPredominantAxis=R.scrollPredominantAxis),typeof R.horizontal<"u"&&(this._options.horizontal=R.horizontal),typeof R.vertical<"u"&&(this._options.vertical=R.vertical),typeof R.horizontalScrollbarSize<"u"&&(this._options.horizontalScrollbarSize=R.horizontalScrollbarSize),typeof R.verticalScrollbarSize<"u"&&(this._options.verticalScrollbarSize=R.verticalScrollbarSize),typeof R.scrollByPage<"u"&&(this._options.scrollByPage=R.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(R){this._revealOnScroll=R}delegateScrollFromMouseWheelEvent(R){this._onMouseWheel(new V.StandardWheelEvent(R))}_setListeningToMouseWheel(R){if(this._mouseWheelToDispose.length>0!==R&&(this._mouseWheelToDispose=(0,W.dispose)(this._mouseWheelToDispose),R)){const P=b=>{this._onMouseWheel(new V.StandardWheelEvent(b))};this._mouseWheelToDispose.push(N.addDisposableListener(this._listenOnDomNode,N.EventType.MOUSE_WHEEL,P,{passive:!1}))}}_onMouseWheel(R){if(R.browserEvent?.defaultPrevented)return;const B=g.INSTANCE;r&&B.acceptStandardWheelEvent(R);let P=!1;if(R.deltaY||R.deltaX){let O=R.deltaY*this._options.mouseWheelScrollSensitivity,$=R.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(this._options.scrollYToX&&$+O===0?$=O=0:Math.abs(O)>=Math.abs($)?$=0:O=0),this._options.flipAxes&&([O,$]=[$,O]);const k=!h.isMacintosh&&R.browserEvent&&R.browserEvent.shiftKey;(this._options.scrollYToX||k)&&!$&&($=O,O=0),R.browserEvent&&R.browserEvent.altKey&&($=$*this._options.fastScrollSensitivity,O=O*this._options.fastScrollSensitivity);const M=this._scrollable.getFutureScrollPosition();let I={};if(O){const q=i*O,X=M.scrollTop-(q<0?Math.floor(q):Math.ceil(q));this._verticalScrollbar.writeScrollPosition(I,X)}if($){const q=i*$,X=M.scrollLeft-(q<0?Math.floor(q):Math.ceil(q));this._horizontalScrollbar.writeScrollPosition(I,X)}I=this._scrollable.validateScrollPosition(I),(M.scrollLeft!==I.scrollLeft||M.scrollTop!==I.scrollTop)&&(r&&this._options.mouseWheelSmoothScroll&&B.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(I):this._scrollable.setScrollPositionNow(I),P=!0)}let b=P;!b&&this._options.alwaysConsumeMouseWheel&&(b=!0),!b&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(b=!0),b&&(R.preventDefault(),R.stopPropagation())}_onDidScroll(R){this._shouldRender=this._horizontalScrollbar.onDidScroll(R)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(R)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const R=this._scrollable.getCurrentScrollPosition(),B=R.scrollTop>0,P=R.scrollLeft>0,b=P?" left":"",O=B?" top":"",$=P||B?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${b}`),this._topShadowDomNode.setClassName(`shadow${O}`),this._topLeftShadowDomNode.setClassName(`shadow${$}${O}${b}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(R){this._mouseIsOver=!1,this._hide()}_onMouseOver(R){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=D;class a extends D{constructor(R,B){B=B||{},B.mouseWheelSmoothScroll=!1;const P=new d.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:b=>N.scheduleAtNextAnimationFrame(N.getWindow(R),b)});super(R,B,P),this._register(P)}setScrollPosition(R){this._scrollable.setScrollPositionNow(R)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=a;class f extends D{constructor(R,B,P){super(R,B,P)}setScrollPosition(R){R.reuseAnimation?this._scrollable.setScrollPositionSmooth(R,R.reuseAnimation):this._scrollable.setScrollPositionNow(R)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=f;class o extends D{constructor(R,B){B=B||{},B.mouseWheelSmoothScroll=!1;const P=new d.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:b=>N.scheduleAtNextAnimationFrame(N.getWindow(R),b)});super(R,B,P),this._register(P),this._element=R,this._register(this.onScroll(b=>{b.scrollTopChanged&&(this._element.scrollTop=b.scrollTop),b.scrollLeftChanged&&(this._element.scrollLeft=b.scrollLeft)})),this.scanDomNode()}setScrollPosition(R){this._scrollable.setScrollPositionNow(R)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=o;function C(F){const R={lazyRender:typeof F.lazyRender<"u"?F.lazyRender:!1,className:typeof F.className<"u"?F.className:"",useShadows:typeof F.useShadows<"u"?F.useShadows:!0,handleMouseWheel:typeof F.handleMouseWheel<"u"?F.handleMouseWheel:!0,flipAxes:typeof F.flipAxes<"u"?F.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof F.consumeMouseWheelIfScrollbarIsNeeded<"u"?F.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof F.alwaysConsumeMouseWheel<"u"?F.alwaysConsumeMouseWheel:!1,scrollYToX:typeof F.scrollYToX<"u"?F.scrollYToX:!1,mouseWheelScrollSensitivity:typeof F.mouseWheelScrollSensitivity<"u"?F.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof F.fastScrollSensitivity<"u"?F.fastScrollSensitivity:5,scrollPredominantAxis:typeof F.scrollPredominantAxis<"u"?F.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof F.mouseWheelSmoothScroll<"u"?F.mouseWheelSmoothScroll:!0,arrowSize:typeof F.arrowSize<"u"?F.arrowSize:11,listenOnDomNode:typeof F.listenOnDomNode<"u"?F.listenOnDomNode:null,horizontal:typeof F.horizontal<"u"?F.horizontal:1,horizontalScrollbarSize:typeof F.horizontalScrollbarSize<"u"?F.horizontalScrollbarSize:10,horizontalSliderSize:typeof F.horizontalSliderSize<"u"?F.horizontalSliderSize:0,horizontalHasArrows:typeof F.horizontalHasArrows<"u"?F.horizontalHasArrows:!1,vertical:typeof F.vertical<"u"?F.vertical:1,verticalScrollbarSize:typeof F.verticalScrollbarSize<"u"?F.verticalScrollbarSize:10,verticalHasArrows:typeof F.verticalHasArrows<"u"?F.verticalHasArrows:!1,verticalSliderSize:typeof F.verticalSliderSize<"u"?F.verticalSliderSize:0,scrollByPage:typeof F.scrollByPage<"u"?F.scrollByPage:!1};return R.horizontalSliderSize=typeof F.horizontalSliderSize<"u"?F.horizontalSliderSize:R.horizontalScrollbarSize,R.verticalSliderSize=typeof F.verticalSliderSize<"u"?F.verticalSliderSize:R.verticalScrollbarSize,h.isMacintosh&&(R.className+=" mac"),R}}),define(ge[71],pe([1,0,64,3,24,29,70,12,9,31,4,2,56,58,93,132,6,39]),function(ie,t,s,N,x,V,_,A,m,p,w,W,h,d,e,i,r,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=t.ListViewTargetSector=void 0;const g={CurrentDragAndDropData:void 0};var D;(function(P){P[P.TOP=0]="TOP",P[P.CENTER_TOP=1]="CENTER_TOP",P[P.CENTER_BOTTOM=2]="CENTER_BOTTOM",P[P.BOTTOM=3]="BOTTOM"})(D||(t.ListViewTargetSector=D={}));const a={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(P){return[P]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class f{get context(){return this._context}set context(b){this._context=b}constructor(b){this.elements=b}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=f;class o{constructor(b){this.elements=b}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=o;class C{constructor(){this.types=[],this.files=[]}update(b){if(b.types&&this.types.splice(0,this.types.length,...b.types),b.files){this.files.splice(0,this.files.length);for(let O=0;O<b.files.length;O++){const $=b.files.item(O);$&&($.size||$.type)&&this.files.push($)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=C;function F(P,b){return Array.isArray(P)&&Array.isArray(b)?(0,A.equals)(P,b):P===b}class R{constructor(b){b?.getSetSize?this.getSetSize=b.getSetSize.bind(b):this.getSetSize=(O,$,k)=>k,b?.getPosInSet?this.getPosInSet=b.getPosInSet.bind(b):this.getPosInSet=(O,$)=>$+1,b?.getRole?this.getRole=b.getRole.bind(b):this.getRole=O=>"listitem",b?.isChecked?this.isChecked=b.isChecked.bind(b):this.isChecked=O=>{}}}class B{static{this.InstanceCount=0}get contentHeight(){return this.rangeMap.size}get contentWidth(){return this.scrollWidth??0}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(b){if(b!==this._horizontalScrolling){if(b&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=b,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const O of this.items)this.measureItemWidth(O);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,N.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}constructor(b,O,$,k=a){if(this.virtualDelegate=O,this.domId=`list_id_${++B.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new m.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=W.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=W.Disposable.None,this.onDragLeaveTimeout=W.Disposable.None,this.disposables=new W.DisposableStore,this._onDidChangeContentHeight=new w.Emitter,this._onDidChangeContentWidth=new w.Emitter,this.onDidChangeContentHeight=w.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this.onDidChangeContentWidth=w.Event.latch(this._onDidChangeContentWidth.event,void 0,this.disposables),this._horizontalScrolling=!1,k.horizontalScrolling&&k.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=this.createRangeMap(k.paddingTop??0);for(const I of $)this.renderers.set(I.templateId,I);this.cache=this.disposables.add(new i.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof k.mouseSupport=="boolean"?k.mouseSupport:!0),this._horizontalScrolling=k.horizontalScrolling??a.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.paddingBottom=typeof k.paddingBottom>"u"?0:k.paddingBottom,this.accessibilityProvider=new R(k.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(k.transformOptimization??a.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)",this.rowsContainer.style.overflow="hidden",this.rowsContainer.style.contain="strict"),this.disposables.add(V.Gesture.addTarget(this.rowsContainer)),this.scrollable=this.disposables.add(new d.Scrollable({forceIntegerValues:!0,smoothScrollDuration:k.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:I=>(0,N.scheduleAtNextAnimationFrame)((0,N.getWindow)(this.domNode),I)})),this.scrollableElement=this.disposables.add(new _.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:k.alwaysConsumeMouseWheel??a.alwaysConsumeMouseWheel,horizontal:1,vertical:k.verticalScrollMode??a.verticalScrollMode,useShadows:k.useShadows??a.useShadows,mouseWheelScrollSensitivity:k.mouseWheelScrollSensitivity,fastScrollSensitivity:k.fastScrollSensitivity,scrollByPage:k.scrollByPage},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),b.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,N.addDisposableListener)(this.rowsContainer,V.EventType.Change,I=>this.onTouchChange(I))),this.disposables.add((0,N.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",I=>I.target.scrollTop=0)),this.disposables.add((0,N.addDisposableListener)(this.domNode,"dragover",I=>this.onDragOver(this.toDragEvent(I)))),this.disposables.add((0,N.addDisposableListener)(this.domNode,"drop",I=>this.onDrop(this.toDragEvent(I)))),this.disposables.add((0,N.addDisposableListener)(this.domNode,"dragleave",I=>this.onDragLeave(this.toDragEvent(I)))),this.disposables.add((0,N.addDisposableListener)(this.domNode,"dragend",I=>this.onDragEnd(I))),this.setRowLineHeight=k.setRowLineHeight??a.setRowLineHeight,this.setRowHeight=k.setRowHeight??a.setRowHeight,this.supportDynamicHeights=k.supportDynamicHeights??a.supportDynamicHeights,this.dnd=k.dnd??this.disposables.add(a.dnd),this.layout(k.initialSize?.height,k.initialSize?.width)}updateOptions(b){b.paddingBottom!==void 0&&(this.paddingBottom=b.paddingBottom,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),b.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(b.smoothScrolling?125:0),b.horizontalScrolling!==void 0&&(this.horizontalScrolling=b.horizontalScrolling);let O;if(b.scrollByPage!==void 0&&(O={...O??{},scrollByPage:b.scrollByPage}),b.mouseWheelScrollSensitivity!==void 0&&(O={...O??{},mouseWheelScrollSensitivity:b.mouseWheelScrollSensitivity}),b.fastScrollSensitivity!==void 0&&(O={...O??{},fastScrollSensitivity:b.fastScrollSensitivity}),O&&this.scrollableElement.updateOptions(O),b.paddingTop!==void 0&&b.paddingTop!==this.rangeMap.paddingTop){const $=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),k=b.paddingTop-this.rangeMap.paddingTop;this.rangeMap.paddingTop=b.paddingTop,this.render($,Math.max(0,this.lastRenderTop+k),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}}delegateScrollFromMouseWheelEvent(b){this.scrollableElement.delegateScrollFromMouseWheelEvent(b)}delegateVerticalScrollbarPointerDown(b){this.scrollableElement.delegateVerticalScrollbarPointerDown(b)}updateElementHeight(b,O,$){if(b<0||b>=this.items.length)return;const k=this.items[b].size;if(typeof O>"u"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[b].lastDynamicHeightWidth=void 0,O=k+this.probeDynamicHeight(b)}if(k===O)return;const M=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let I=0;b<M.start||$!==null&&$>b&&$<M.end?I=O-k:I=0,this.rangeMap.splice(b,1,[{size:O}]),this.items[b].size=O,this.render(M,Math.max(0,this.lastRenderTop+I),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}createRangeMap(b){return new e.RangeMap(b)}splice(b,O,$=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(b,O,$)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(b,O,$=[]){const k=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),M={start:b,end:b+O},I=h.Range.intersect(k,M),q=new Map;for(let G=I.end-1;G>=I.start;G--){const ne=this.items[G];if(ne.dragStartDisposable.dispose(),ne.checkedDisposable.dispose(),ne.row){let de=q.get(ne.templateId);de||(de=[],q.set(ne.templateId,de));const we=this.renderers.get(ne.templateId);we&&we.disposeElement&&we.disposeElement(ne.element,G,ne.row.templateData,ne.size),de.push(ne.row)}ne.row=null,ne.stale=!0}const X={start:b+O,end:this.items.length},ce=h.Range.intersect(X,k),re=h.Range.relativeComplement(X,k),te=$.map(G=>({id:String(this.itemId++),element:G,templateId:this.virtualDelegate.getTemplateId(G),size:this.virtualDelegate.getHeight(G),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight(G),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:W.Disposable.None,checkedDisposable:W.Disposable.None,stale:!1}));let be;b===0&&O>=this.items.length?(this.rangeMap=this.createRangeMap(this.rangeMap.paddingTop),this.rangeMap.splice(0,0,te),be=this.items,this.items=te):(this.rangeMap.splice(b,O,te),be=this.items.splice(b,O,...te));const Ee=$.length-O,Ie=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),Be=(0,e.shift)(ce,Ee),ue=h.Range.intersect(Ie,Be);for(let G=ue.start;G<ue.end;G++)this.updateItemInDOM(this.items[G],G);const J=h.Range.relativeComplement(Be,Ie);for(const G of J)for(let ne=G.start;ne<G.end;ne++)this.removeItemFromDOM(ne);const le=re.map(G=>(0,e.shift)(G,Ee)),Z=[{start:b,end:b+$.length},...le].map(G=>h.Range.intersect(Ie,G)).reverse();for(const G of Z)for(let ne=G.end-1;ne>=G.start;ne--){const de=this.items[ne],Fe=q.get(de.templateId)?.pop();this.insertItemInDOM(ne,Fe)}for(const G of q.values())for(const ne of G)this.cache.release(ne);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),be.map(G=>G.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,N.scheduleAtNextAnimationFrame)((0,N.getWindow)(this.domNode),()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let b=0;for(const O of this.items)typeof O.width<"u"&&(b=Math.max(b,O.width));this.scrollWidth=b,this.scrollableElement.setScrollDimensions({scrollWidth:b===0?0:b+10}),this._onDidChangeContentWidth.fire(this.scrollWidth)}updateWidth(b){if(!this.horizontalScrolling||typeof this.scrollWidth>"u")return;const O=this.items[b];this.measureItemWidth(O),typeof O.width<"u"&&O.width>this.scrollWidth&&(this.scrollWidth=O.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}),this._onDidChangeContentWidth.fire(this.scrollWidth))}rerender(){if(this.supportDynamicHeights){for(const b of this.items)b.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).start}get firstMostlyVisibleIndex(){const b=this.firstVisibleIndex,O=this.rangeMap.positionAt(b),$=this.rangeMap.positionAt(b+1);return $!==-1&&($-O)/2+O<this.scrollTop?b+1:b}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(b){return this.items[b].element}indexOf(b){return this.items.findIndex(O=>O.element===b)}domElement(b){const O=this.items[b].row;return O&&O.domNode}elementHeight(b){return this.items[b].size}elementTop(b){return this.rangeMap.positionAt(b)}indexAt(b){return this.rangeMap.indexAt(b)}indexAfter(b){return this.rangeMap.indexAfter(b)}layout(b,O){const $={height:typeof b=="number"?b:(0,N.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,$.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions($),typeof O<"u"&&(this.renderWidth=O,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof O=="number"?O:(0,N.getContentWidth)(this.domNode)})}render(b,O,$,k,M,I=!1){const q=this.getRenderRange(O,$),X=h.Range.relativeComplement(q,b).reverse(),ce=h.Range.relativeComplement(b,q);if(I){const re=h.Range.intersect(b,q);for(let te=re.start;te<re.end;te++)this.updateItemInDOM(this.items[te],te)}this.cache.transact(()=>{for(const re of ce)for(let te=re.start;te<re.end;te++)this.removeItemFromDOM(te);for(const re of X)for(let te=re.end-1;te>=re.start;te--)this.insertItemInDOM(te)}),k!==void 0&&(this.rowsContainer.style.left=`-${k}px`),this.rowsContainer.style.top=`-${O}px`,this.horizontalScrolling&&M!==void 0&&(this.rowsContainer.style.width=`${Math.max(M,this.renderWidth)}px`),this.lastRenderTop=O,this.lastRenderHeight=$}insertItemInDOM(b,O){const $=this.items[b];if(!$.row)if(O)$.row=O,$.stale=!0;else{const X=this.cache.alloc($.templateId);$.row=X.row,$.stale||=X.isReusingConnectedDomNode}const k=this.accessibilityProvider.getRole($.element)||"listitem";$.row.domNode.setAttribute("role",k);const M=this.accessibilityProvider.isChecked($.element);if(typeof M=="boolean")$.row.domNode.setAttribute("aria-checked",String(!!M));else if(M){const X=ce=>$.row.domNode.setAttribute("aria-checked",String(!!ce));X(M.value),$.checkedDisposable=M.onDidChange(X)}if($.stale||!$.row.domNode.parentElement){const X=this.items.at(b+1)?.row?.domNode??null;this.rowsContainer.insertBefore($.row.domNode,X),$.stale=!1}this.updateItemInDOM($,b);const I=this.renderers.get($.templateId);if(!I)throw new Error(`No renderer found for template id ${$.templateId}`);I?.renderElement($.element,b,$.row.templateData,$.size);const q=this.dnd.getDragURI($.element);$.dragStartDisposable.dispose(),$.row.domNode.draggable=!!q,q&&($.dragStartDisposable=(0,N.addDisposableListener)($.row.domNode,"dragstart",X=>this.onDragStart($.element,q,X))),this.horizontalScrolling&&(this.measureItemWidth($),this.eventuallyUpdateScrollWidth())}measureItemWidth(b){if(!b.row||!b.row.domNode)return;b.row.domNode.style.width="fit-content",b.width=(0,N.getContentWidth)(b.row.domNode);const O=(0,N.getWindow)(b.row.domNode).getComputedStyle(b.row.domNode);O.paddingLeft&&(b.width+=parseFloat(O.paddingLeft)),O.paddingRight&&(b.width+=parseFloat(O.paddingRight)),b.row.domNode.style.width=""}updateItemInDOM(b,O){b.row.domNode.style.top=`${this.elementTop(O)}px`,this.setRowHeight&&(b.row.domNode.style.height=`${b.size}px`),this.setRowLineHeight&&(b.row.domNode.style.lineHeight=`${b.size}px`),b.row.domNode.setAttribute("data-index",`${O}`),b.row.domNode.setAttribute("data-last-element",O===this.length-1?"true":"false"),b.row.domNode.setAttribute("data-parity",O%2===0?"even":"odd"),b.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(b.element,O,this.length))),b.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(b.element,O))),b.row.domNode.setAttribute("id",this.getElementDomId(O)),b.row.domNode.classList.toggle("drop-target",b.dropTarget)}removeItemFromDOM(b){const O=this.items[b];if(O.dragStartDisposable.dispose(),O.checkedDisposable.dispose(),O.row){const $=this.renderers.get(O.templateId);$&&$.disposeElement&&$.disposeElement(O.element,b,O.row.templateData,O.size),this.cache.release(O.row),O.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(b,O){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:b,reuseAnimation:O})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(b){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:b})}get scrollTop(){return this.getScrollTop()}set scrollTop(b){this.setScrollTop(b)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.paddingBottom}get onMouseClick(){return w.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"click")).event,b=>this.toMouseEvent(b),this.disposables)}get onMouseDblClick(){return w.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"dblclick")).event,b=>this.toMouseEvent(b),this.disposables)}get onMouseMiddleClick(){return w.Event.filter(w.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"auxclick")).event,b=>this.toMouseEvent(b),this.disposables),b=>b.browserEvent.button===1,this.disposables)}get onMouseUp(){return w.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"mouseup")).event,b=>this.toMouseEvent(b),this.disposables)}get onMouseDown(){return w.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"mousedown")).event,b=>this.toMouseEvent(b),this.disposables)}get onMouseOver(){return w.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"mouseover")).event,b=>this.toMouseEvent(b),this.disposables)}get onMouseMove(){return w.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"mousemove")).event,b=>this.toMouseEvent(b),this.disposables)}get onMouseOut(){return w.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"mouseout")).event,b=>this.toMouseEvent(b),this.disposables)}get onContextMenu(){return w.Event.any(w.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"contextmenu")).event,b=>this.toMouseEvent(b),this.disposables),w.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,V.EventType.Contextmenu)).event,b=>this.toGestureEvent(b),this.disposables))}get onTouchStart(){return w.Event.map(this.disposables.add(new x.DomEmitter(this.domNode,"touchstart")).event,b=>this.toTouchEvent(b),this.disposables)}get onTap(){return w.Event.map(this.disposables.add(new x.DomEmitter(this.rowsContainer,V.EventType.Tap)).event,b=>this.toGestureEvent(b),this.disposables)}toMouseEvent(b){const O=this.getItemIndexFromEventTarget(b.target||null),$=typeof O>"u"?void 0:this.items[O],k=$&&$.element;return{browserEvent:b,index:O,element:k}}toTouchEvent(b){const O=this.getItemIndexFromEventTarget(b.target||null),$=typeof O>"u"?void 0:this.items[O],k=$&&$.element;return{browserEvent:b,index:O,element:k}}toGestureEvent(b){const O=this.getItemIndexFromEventTarget(b.initialTarget||null),$=typeof O>"u"?void 0:this.items[O],k=$&&$.element;return{browserEvent:b,index:O,element:k}}toDragEvent(b){const O=this.getItemIndexFromEventTarget(b.target||null),$=typeof O>"u"?void 0:this.items[O],k=$&&$.element,M=this.getTargetSector(b,O);return{browserEvent:b,index:O,element:k,sector:M}}onScroll(b){try{const O=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(O,b.scrollTop,b.height,b.scrollLeft,b.scrollWidth),this.supportDynamicHeights&&this._rerender(b.scrollTop,b.height,b.inSmoothScrolling)}catch(O){throw console.error("Got bad scroll event:",b),O}}onTouchChange(b){b.preventDefault(),b.stopPropagation(),this.scrollTop-=b.translationY}onDragStart(b,O,$){if(!$.dataTransfer)return;const k=this.dnd.getDragElements(b);if($.dataTransfer.effectAllowed="copyMove",$.dataTransfer.setData(s.DataTransfers.TEXT,O),$.dataTransfer.setDragImage){let M;this.dnd.getDragLabel&&(M=this.dnd.getDragLabel(k,$)),typeof M>"u"&&(M=String(k.length));const I=(0,N.$)(".monaco-drag-image");I.textContent=M;const X=(ce=>{for(;ce&&!ce.classList.contains("monaco-workbench");)ce=ce.parentElement;return ce||this.domNode.ownerDocument})(this.domNode);X.appendChild(I),$.dataTransfer.setDragImage(I,-10,-10),setTimeout(()=>X.removeChild(I),0)}this.domNode.classList.add("dragging"),this.currentDragData=new f(k),g.CurrentDragAndDropData=new o(k),this.dnd.onDragStart?.(this.currentDragData,$)}onDragOver(b){if(b.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),g.CurrentDragAndDropData&&g.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(b.browserEvent),!b.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(g.CurrentDragAndDropData)this.currentDragData=g.CurrentDragAndDropData;else{if(!b.browserEvent.dataTransfer.types)return!1;this.currentDragData=new C}const O=this.dnd.onDragOver(this.currentDragData,b.element,b.index,b.sector,b.browserEvent);if(this.canDrop=typeof O=="boolean"?O:O.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;b.browserEvent.dataTransfer.dropEffect=typeof O!="boolean"&&O.effect?.type===0?"copy":"move";let $;typeof O!="boolean"&&O.feedback?$=O.feedback:typeof b.index>"u"?$=[-1]:$=[b.index],$=(0,A.distinct)($).filter(M=>M>=-1&&M<this.length).sort((M,I)=>M-I),$=$[0]===-1?[-1]:$;let k=typeof O!="boolean"&&O.effect&&O.effect.position?O.effect.position:"drop-target";if(F(this.currentDragFeedback,$)&&this.currentDragFeedbackPosition===k)return!0;if(this.currentDragFeedback=$,this.currentDragFeedbackPosition=k,this.currentDragFeedbackDisposable.dispose(),$[0]===-1)this.domNode.classList.add(k),this.rowsContainer.classList.add(k),this.currentDragFeedbackDisposable=(0,W.toDisposable)(()=>{this.domNode.classList.remove(k),this.rowsContainer.classList.remove(k)});else{if($.length>1&&k!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");k==="drop-target-after"&&$[0]<this.length-1&&($[0]+=1,k="drop-target-before");for(const M of $){const I=this.items[M];I.dropTarget=!0,I.row?.domNode.classList.add(k)}this.currentDragFeedbackDisposable=(0,W.toDisposable)(()=>{for(const M of $){const I=this.items[M];I.dropTarget=!1,I.row?.domNode.classList.remove(k)}})}return!0}onDragLeave(b){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,m.disposableTimeout)(()=>this.clearDragOverFeedback(),100,this.disposables),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,b.element,b.index,b.browserEvent)}onDrop(b){if(!this.canDrop)return;const O=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,g.CurrentDragAndDropData=void 0,!(!O||!b.browserEvent.dataTransfer)&&(b.browserEvent.preventDefault(),O.update(b.browserEvent.dataTransfer),this.dnd.drop(O,b.element,b.index,b.sector,b.browserEvent))}onDragEnd(b){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.domNode.classList.remove("dragging"),this.currentDragData=void 0,g.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(b)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackPosition=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=W.Disposable.None}setupDragAndDropScrollTopAnimation(b){if(!this.dragOverAnimationDisposable){const O=(0,N.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,N.animate)((0,N.getWindow)(this.domNode),this.animateDragAndDropScrollTop.bind(this,O))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,m.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3,this.disposables),this.dragOverMouseY=b.pageY}animateDragAndDropScrollTop(b){if(this.dragOverMouseY===void 0)return;const O=this.dragOverMouseY-b,$=this.renderHeight-35;O<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(O-35))):O>$&&(this.scrollTop+=Math.min(14,Math.floor(.3*(O-$))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getTargetSector(b,O){if(O===void 0)return;const $=b.offsetY/this.items[O].size,k=Math.floor($/.25);return(0,u.clamp)(k,0,3)}getItemIndexFromEventTarget(b){const O=this.scrollableElement.getDomNode();let $=b;for(;$ instanceof HTMLElement&&$!==this.rowsContainer&&O.contains($);){const k=$.getAttribute("data-index");if(k){const M=Number(k);if(!isNaN(M))return M}$=$.parentElement}}getRenderRange(b,O){return{start:this.rangeMap.indexAt(b),end:this.rangeMap.indexAfter(b+O-1)}}_rerender(b,O,$){const k=this.getRenderRange(b,O);let M,I;b===this.elementTop(k.start)?(M=k.start,I=0):k.end-k.start>1&&(M=k.start+1,I=this.elementTop(M)-b);let q=0;for(;;){const X=this.getRenderRange(b,O);let ce=!1;for(let re=X.start;re<X.end;re++){const te=this.probeDynamicHeight(re);te!==0&&this.rangeMap.splice(re,1,[this.items[re]]),q+=te,ce=ce||te!==0}if(!ce){q!==0&&this.eventuallyUpdateScrollDimensions();const re=h.Range.relativeComplement(k,X);for(const be of re)for(let Ee=be.start;Ee<be.end;Ee++)this.items[Ee].row&&this.removeItemFromDOM(Ee);const te=h.Range.relativeComplement(X,k).reverse();for(const be of te)for(let Ee=be.end-1;Ee>=be.start;Ee--)this.insertItemInDOM(Ee);for(let be=X.start;be<X.end;be++)this.items[be].row&&this.updateItemInDOM(this.items[be],be);if(typeof M=="number"){const be=this.scrollable.getFutureScrollPosition().scrollTop-b,Ee=this.elementTop(M)-I+be;this.setScrollTop(Ee,$)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(b){const O=this.items[b];if(this.virtualDelegate.getDynamicHeight){const I=this.virtualDelegate.getDynamicHeight(O.element);if(I!==null){const q=O.size;return O.size=I,O.lastDynamicHeightWidth=this.renderWidth,I-q}}if(!O.hasDynamicHeight||O.lastDynamicHeightWidth===this.renderWidth||this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(O.element))return 0;const $=O.size;if(O.row)return O.row.domNode.style.height="",O.size=O.row.domNode.offsetHeight,O.size===0&&!(0,N.isAncestor)(O.row.domNode,(0,N.getWindow)(O.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!"),O.lastDynamicHeightWidth=this.renderWidth,O.size-$;const{row:k}=this.cache.alloc(O.templateId);k.domNode.style.height="",this.rowsContainer.appendChild(k.domNode);const M=this.renderers.get(O.templateId);if(!M)throw new r.BugIndicatingError("Missing renderer for templateId: "+O.templateId);return M.renderElement(O.element,b,k.templateData,void 0),O.size=k.domNode.offsetHeight,M.disposeElement?.(O.element,b,k.templateData,void 0),this.virtualDelegate.setDynamicHeight?.(O.element,O.size),O.lastDynamicHeightWidth=this.renderWidth,this.rowsContainer.removeChild(k.domNode),this.cache.release(k),O.size-$}getElementDomId(b){return`${this.domId}_${b}`}dispose(){for(const b of this.items)if(b.dragStartDisposable.dispose(),b.checkedDisposable.dispose(),b.row){const O=this.renderers.get(b.row.templateId);O&&(O.disposeElement?.(b.element,-1,b.row.templateData,void 0),O.disposeTemplate(b.row.templateData))}this.items=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.dragOverAnimationDisposable?.dispose(),this.disposables.dispose()}}t.ListView=B,Xe([p.memoize],B.prototype,"onMouseClick",null),Xe([p.memoize],B.prototype,"onMouseDblClick",null),Xe([p.memoize],B.prototype,"onMouseMiddleClick",null),Xe([p.memoize],B.prototype,"onMouseUp",null),Xe([p.memoize],B.prototype,"onMouseDown",null),Xe([p.memoize],B.prototype,"onMouseOver",null),Xe([p.memoize],B.prototype,"onMouseMove",null),Xe([p.memoize],B.prototype,"onMouseOut",null),Xe([p.memoize],B.prototype,"onContextMenu",null),Xe([p.memoize],B.prototype,"onTouchStart",null),Xe([p.memoize],B.prototype,"onTap",null)}),define(ge[49],pe([1,0,3,24,15,29,67,81,12,9,84,31,4,43,2,39,5,7,80,71,20,57,110]),function(ie,t,s,N,x,V,_,A,m,p,w,W,h,d,e,i,r,u,g,D,a,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.unthemedListStyles=t.DefaultStyleController=t.MouseController=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=void 0,t.isInputElement=B,t.isMonacoEditor=b,t.isMonacoCustomToggle=O,t.isActionItem=$,t.isMonacoTwistie=k,t.isStickyScrollElement=M,t.isStickyScrollContainer=I,t.isButton=q,t.isSelectionSingleChangeEvent=Ee,t.isSelectionRangeChangeEvent=Ie;class o{constructor(c){this.trait=c,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(c){return c}renderElement(c,E,l){const v=this.renderedElements.findIndex(T=>T.templateData===l);if(v>=0){const T=this.renderedElements[v];this.trait.unrender(l),T.index=E}else{const T={index:E,templateData:l};this.renderedElements.push(T)}this.trait.renderIndex(E,l)}splice(c,E,l){const v=[];for(const T of this.renderedElements)T.index<c?v.push(T):T.index>=c+E&&v.push({index:T.index+l-E,templateData:T.templateData});this.renderedElements=v}renderIndexes(c){for(const{index:E,templateData:l}of this.renderedElements)c.indexOf(E)>-1&&this.trait.renderIndex(E,l)}disposeTemplate(c){const E=this.renderedElements.findIndex(l=>l.templateData===c);E<0||this.renderedElements.splice(E,1)}}class C{get name(){return this._trait}get renderer(){return new o(this)}constructor(c){this._trait=c,this.indexes=[],this.sortedIndexes=[],this._onChange=new h.Emitter,this.onChange=this._onChange.event}splice(c,E,l){const v=l.length-E,T=c+E,n=[];let S=0;for(;S<this.sortedIndexes.length&&this.sortedIndexes[S]<c;)n.push(this.sortedIndexes[S++]);for(let y=0;y<l.length;y++)l[y]&&n.push(y+c);for(;S<this.sortedIndexes.length&&this.sortedIndexes[S]>=T;)n.push(this.sortedIndexes[S++]+v);this.renderer.splice(c,E,l.length),this._set(n,n)}renderIndex(c,E){E.classList.toggle(this._trait,this.contains(c))}unrender(c){c.classList.remove(this._trait)}set(c,E){return this._set(c,[...c].sort(de),E)}_set(c,E,l){const v=this.indexes,T=this.sortedIndexes;this.indexes=c,this.sortedIndexes=E;const n=G(T,c);return this.renderer.renderIndexes(n),this._onChange.fire({indexes:c,browserEvent:l}),v}get(){return this.indexes}contains(c){return(0,m.binarySearch)(this.sortedIndexes,c,de)>=0}dispose(){(0,e.dispose)(this._onChange)}}Xe([W.memoize],C.prototype,"renderer",null);class F extends C{constructor(c){super("selected"),this.setAriaSelected=c}renderIndex(c,E){super.renderIndex(c,E),this.setAriaSelected&&(this.contains(c)?E.setAttribute("aria-selected","true"):E.setAttribute("aria-selected","false"))}}class R{constructor(c,E,l){this.trait=c,this.view=E,this.identityProvider=l}splice(c,E,l){if(!this.identityProvider)return this.trait.splice(c,E,new Array(l.length).fill(!1));const v=this.trait.get().map(S=>this.identityProvider.getId(this.view.element(S)).toString());if(v.length===0)return this.trait.splice(c,E,new Array(l.length).fill(!1));const T=new Set(v),n=l.map(S=>T.has(this.identityProvider.getId(S).toString()));this.trait.splice(c,E,n)}}function B(H){return H.tagName==="INPUT"||H.tagName==="TEXTAREA"}function P(H,c){return H.classList.contains(c)?!0:H.classList.contains("monaco-list")||!H.parentElement?!1:P(H.parentElement,c)}function b(H){return P(H,"monaco-editor")}function O(H){return P(H,"monaco-custom-toggle")}function $(H){return P(H,"action-item")}function k(H){return P(H,"monaco-tl-twistie")}function M(H){return P(H,"monaco-tree-sticky-row")}function I(H){return H.classList.contains("monaco-tree-sticky-container")}function q(H){return H.tagName==="A"&&H.classList.contains("monaco-button")||H.tagName==="DIV"&&H.classList.contains("monaco-button-dropdown")?!0:H.classList.contains("monaco-list")||!H.parentElement?!1:q(H.parentElement)}class X{get onKeyDown(){return h.Event.chain(this.disposables.add(new N.DomEmitter(this.view.domNode,"keydown")).event,c=>c.filter(E=>!B(E.target)).map(E=>new x.StandardKeyboardEvent(E)))}constructor(c,E,l){this.list=c,this.view=E,this.disposables=new e.DisposableStore,this.multipleSelectionDisposables=new e.DisposableStore,this.multipleSelectionSupport=l.multipleSelectionSupport,this.disposables.add(this.onKeyDown(v=>{switch(v.keyCode){case 3:return this.onEnter(v);case 16:return this.onUpArrow(v);case 18:return this.onDownArrow(v);case 11:return this.onPageUpArrow(v);case 12:return this.onPageDownArrow(v);case 9:return this.onEscape(v);case 31:this.multipleSelectionSupport&&(r.isMacintosh?v.metaKey:v.ctrlKey)&&this.onCtrlA(v)}}))}updateOptions(c){c.multipleSelectionSupport!==void 0&&(this.multipleSelectionSupport=c.multipleSelectionSupport)}onEnter(c){c.preventDefault(),c.stopPropagation(),this.list.setSelection(this.list.getFocus(),c.browserEvent)}onUpArrow(c){c.preventDefault(),c.stopPropagation(),this.list.focusPrevious(1,!1,c.browserEvent);const E=this.list.getFocus()[0];this.list.setAnchor(E),this.list.reveal(E),this.view.domNode.focus()}onDownArrow(c){c.preventDefault(),c.stopPropagation(),this.list.focusNext(1,!1,c.browserEvent);const E=this.list.getFocus()[0];this.list.setAnchor(E),this.list.reveal(E),this.view.domNode.focus()}onPageUpArrow(c){c.preventDefault(),c.stopPropagation(),this.list.focusPreviousPage(c.browserEvent);const E=this.list.getFocus()[0];this.list.setAnchor(E),this.list.reveal(E),this.view.domNode.focus()}onPageDownArrow(c){c.preventDefault(),c.stopPropagation(),this.list.focusNextPage(c.browserEvent);const E=this.list.getFocus()[0];this.list.setAnchor(E),this.list.reveal(E),this.view.domNode.focus()}onCtrlA(c){c.preventDefault(),c.stopPropagation(),this.list.setSelection((0,m.range)(this.list.length),c.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(c){this.list.getSelection().length&&(c.preventDefault(),c.stopPropagation(),this.list.setSelection([],c.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}Xe([W.memoize],X.prototype,"onKeyDown",null);var ce;(function(H){H[H.Automatic=0]="Automatic",H[H.Trigger=1]="Trigger"})(ce||(t.TypeNavigationMode=ce={}));var re;(function(H){H[H.Idle=0]="Idle",H[H.Typing=1]="Typing"})(re||(re={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(H){return H.ctrlKey||H.metaKey||H.altKey?!1:H.keyCode>=31&&H.keyCode<=56||H.keyCode>=21&&H.keyCode<=30||H.keyCode>=98&&H.keyCode<=107||H.keyCode>=85&&H.keyCode<=95}};class te{constructor(c,E,l,v,T){this.list=c,this.view=E,this.keyboardNavigationLabelProvider=l,this.keyboardNavigationEventFilter=v,this.delegate=T,this.enabled=!1,this.state=re.Idle,this.mode=ce.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new e.DisposableStore,this.disposables=new e.DisposableStore,this.updateOptions(c.options)}updateOptions(c){c.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=c.typeNavigationMode??ce.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let c=!1;const E=h.Event.chain(this.enabledDisposables.add(new N.DomEmitter(this.view.domNode,"keydown")).event,T=>T.filter(n=>!B(n.target)).filter(()=>this.mode===ce.Automatic||this.triggered).map(n=>new x.StandardKeyboardEvent(n)).filter(n=>c||this.keyboardNavigationEventFilter(n)).filter(n=>this.delegate.mightProducePrintableCharacter(n)).forEach(n=>s.EventHelper.stop(n,!0)).map(n=>n.browserEvent.key)),l=h.Event.debounce(E,()=>null,800,void 0,void 0,void 0,this.enabledDisposables);h.Event.reduce(h.Event.any(E,l),(T,n)=>n===null?null:(T||"")+n,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),l(this.onClear,this,this.enabledDisposables),E(()=>c=!0,void 0,this.enabledDisposables),l(()=>c=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){this.enabled&&(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const c=this.list.getFocus();if(c.length>0&&c[0]===this.previouslyFocused){const E=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(c[0]));typeof E=="string"?(0,_.alert)(E):E&&(0,_.alert)(E.get())}this.previouslyFocused=-1}onInput(c){if(!c){this.state=re.Idle,this.triggered=!1;return}const E=this.list.getFocus(),l=E.length>0?E[0]:0,v=this.state===re.Idle?1:0;this.state=re.Typing;for(let T=0;T<this.list.length;T++){const n=(l+T+v)%this.list.length,S=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(n)),y=S&&S.toString();if(this.list.options.typeNavigationEnabled){if(typeof y<"u"){if((0,d.matchesPrefix)(c,y)){this.previouslyFocused=l,this.list.setFocus([n]),this.list.reveal(n);return}const L=(0,d.matchesFuzzy2)(c,y);if(L&&L[0].end-L[0].start>1&&L.length===1){this.previouslyFocused=l,this.list.setFocus([n]),this.list.reveal(n);return}}}else if(typeof y>"u"||(0,d.matchesPrefix)(c,y)){this.previouslyFocused=l,this.list.setFocus([n]),this.list.reveal(n);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class be{constructor(c,E){this.list=c,this.view=E,this.disposables=new e.DisposableStore;const l=h.Event.chain(this.disposables.add(new N.DomEmitter(E.domNode,"keydown")).event,T=>T.filter(n=>!B(n.target)).map(n=>new x.StandardKeyboardEvent(n)));h.Event.chain(l,T=>T.filter(n=>n.keyCode===2&&!n.ctrlKey&&!n.metaKey&&!n.shiftKey&&!n.altKey))(this.onTab,this,this.disposables)}onTab(c){if(c.target!==this.view.domNode)return;const E=this.list.getFocus();if(E.length===0)return;const l=this.view.domElement(E[0]);if(!l)return;const v=l.querySelector("[tabIndex]");if(!v||!(v instanceof HTMLElement)||v.tabIndex===-1)return;const T=(0,s.getWindow)(v).getComputedStyle(v);T.visibility==="hidden"||T.display==="none"||(c.preventDefault(),c.stopPropagation(),v.focus())}dispose(){this.disposables.dispose()}}function Ee(H){return r.isMacintosh?H.browserEvent.metaKey:H.browserEvent.ctrlKey}function Ie(H){return H.browserEvent.shiftKey}function Be(H){return(0,s.isMouseEvent)(H)&&H.button===2}const ue={isSelectionSingleChangeEvent:Ee,isSelectionRangeChangeEvent:Ie};class J{constructor(c){this.list=c,this.disposables=new e.DisposableStore,this._onPointer=new h.Emitter,this.onPointer=this._onPointer.event,c.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||ue),this.mouseSupport=typeof c.options.mouseSupport>"u"||!!c.options.mouseSupport,this.mouseSupport&&(c.onMouseDown(this.onMouseDown,this,this.disposables),c.onContextMenu(this.onContextMenu,this,this.disposables),c.onMouseDblClick(this.onDoubleClick,this,this.disposables),c.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(V.Gesture.addTarget(c.getHTMLElement()))),h.Event.any(c.onMouseClick,c.onMouseMiddleClick,c.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(c){c.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,c.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||ue))}isSelectionSingleChangeEvent(c){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(c):!1}isSelectionRangeChangeEvent(c){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(c):!1}isSelectionChangeEvent(c){return this.isSelectionSingleChangeEvent(c)||this.isSelectionRangeChangeEvent(c)}onMouseDown(c){b(c.browserEvent.target)||(0,s.getActiveElement)()!==c.browserEvent.target&&this.list.domFocus()}onContextMenu(c){if(B(c.browserEvent.target)||b(c.browserEvent.target))return;const E=typeof c.index>"u"?[]:[c.index];this.list.setFocus(E,c.browserEvent)}onViewPointer(c){if(!this.mouseSupport||B(c.browserEvent.target)||b(c.browserEvent.target)||c.browserEvent.isHandledByList)return;c.browserEvent.isHandledByList=!0;const E=c.index;if(typeof E>"u"){this.list.setFocus([],c.browserEvent),this.list.setSelection([],c.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionChangeEvent(c))return this.changeSelection(c);this.list.setFocus([E],c.browserEvent),this.list.setAnchor(E),Be(c.browserEvent)||this.list.setSelection([E],c.browserEvent),this._onPointer.fire(c)}onDoubleClick(c){if(B(c.browserEvent.target)||b(c.browserEvent.target)||this.isSelectionChangeEvent(c)||c.browserEvent.isHandledByList)return;c.browserEvent.isHandledByList=!0;const E=this.list.getFocus();this.list.setSelection(E,c.browserEvent)}changeSelection(c){const E=c.index;let l=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(c)){typeof l>"u"&&(l=this.list.getFocus()[0]??E,this.list.setAnchor(l));const v=Math.min(l,E),T=Math.max(l,E),n=(0,m.range)(v,T+1),S=this.list.getSelection(),y=Z(G(S,[l]),l);if(y.length===0)return;const L=G(n,ne(S,y));this.list.setSelection(L,c.browserEvent),this.list.setFocus([E],c.browserEvent)}else if(this.isSelectionSingleChangeEvent(c)){const v=this.list.getSelection(),T=v.filter(n=>n!==E);this.list.setFocus([E]),this.list.setAnchor(E),v.length===T.length?this.list.setSelection([...T,E],c.browserEvent):this.list.setSelection(T,c.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=J;class le{constructor(c,E){this.styleElement=c,this.selectorSuffix=E}style(c){const E=this.selectorSuffix&&`.${this.selectorSuffix}`,l=[];c.listBackground&&l.push(`.monaco-list${E} .monaco-list-rows { background: ${c.listBackground}; }`),c.listFocusBackground&&(l.push(`.monaco-list${E}:focus .monaco-list-row.focused { background-color: ${c.listFocusBackground}; }`),l.push(`.monaco-list${E}:focus .monaco-list-row.focused:hover { background-color: ${c.listFocusBackground}; }`)),c.listFocusForeground&&l.push(`.monaco-list${E}:focus .monaco-list-row.focused { color: ${c.listFocusForeground}; }`),c.listActiveSelectionBackground&&(l.push(`.monaco-list${E}:focus .monaco-list-row.selected { background-color: ${c.listActiveSelectionBackground}; }`),l.push(`.monaco-list${E}:focus .monaco-list-row.selected:hover { background-color: ${c.listActiveSelectionBackground}; }`)),c.listActiveSelectionForeground&&l.push(`.monaco-list${E}:focus .monaco-list-row.selected { color: ${c.listActiveSelectionForeground}; }`),c.listActiveSelectionIconForeground&&l.push(`.monaco-list${E}:focus .monaco-list-row.selected .codicon { color: ${c.listActiveSelectionIconForeground}; }`),c.listFocusAndSelectionBackground&&l.push(`
				.monaco-drag-image,
				.monaco-list${E}:focus .monaco-list-row.selected.focused { background-color: ${c.listFocusAndSelectionBackground}; }
			`),c.listFocusAndSelectionForeground&&l.push(`
				.monaco-drag-image,
				.monaco-list${E}:focus .monaco-list-row.selected.focused { color: ${c.listFocusAndSelectionForeground}; }
			`),c.listInactiveFocusForeground&&(l.push(`.monaco-list${E} .monaco-list-row.focused { color:  ${c.listInactiveFocusForeground}; }`),l.push(`.monaco-list${E} .monaco-list-row.focused:hover { color:  ${c.listInactiveFocusForeground}; }`)),c.listInactiveSelectionIconForeground&&l.push(`.monaco-list${E} .monaco-list-row.focused .codicon { color:  ${c.listInactiveSelectionIconForeground}; }`),c.listInactiveFocusBackground&&(l.push(`.monaco-list${E} .monaco-list-row.focused { background-color:  ${c.listInactiveFocusBackground}; }`),l.push(`.monaco-list${E} .monaco-list-row.focused:hover { background-color:  ${c.listInactiveFocusBackground}; }`)),c.listInactiveSelectionBackground&&(l.push(`.monaco-list${E} .monaco-list-row.selected { background-color:  ${c.listInactiveSelectionBackground}; }`),l.push(`.monaco-list${E} .monaco-list-row.selected:hover { background-color:  ${c.listInactiveSelectionBackground}; }`)),c.listInactiveSelectionForeground&&l.push(`.monaco-list${E} .monaco-list-row.selected { color: ${c.listInactiveSelectionForeground}; }`),c.listHoverBackground&&l.push(`.monaco-list${E}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${c.listHoverBackground}; }`),c.listHoverForeground&&l.push(`.monaco-list${E}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${c.listHoverForeground}; }`);const v=(0,s.asCssValueWithDefault)(c.listFocusAndSelectionOutline,(0,s.asCssValueWithDefault)(c.listSelectionOutline,c.listFocusOutline??""));v&&l.push(`.monaco-list${E}:focus .monaco-list-row.focused.selected { outline: 1px solid ${v}; outline-offset: -1px;}`),c.listFocusOutline&&l.push(`
				.monaco-drag-image,
				.monaco-list${E}:focus .monaco-list-row.focused { outline: 1px solid ${c.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${E}.last-focused .monaco-list-row.focused { outline: 1px solid ${c.listFocusOutline}; outline-offset: -1px; }
			`);const T=(0,s.asCssValueWithDefault)(c.listSelectionOutline,c.listInactiveFocusOutline??"");T&&l.push(`.monaco-list${E} .monaco-list-row.focused.selected { outline: 1px dotted ${T}; outline-offset: -1px; }`),c.listSelectionOutline&&l.push(`.monaco-list${E} .monaco-list-row.selected { outline: 1px dotted ${c.listSelectionOutline}; outline-offset: -1px; }`),c.listInactiveFocusOutline&&l.push(`.monaco-list${E} .monaco-list-row.focused { outline: 1px dotted ${c.listInactiveFocusOutline}; outline-offset: -1px; }`),c.listHoverOutline&&l.push(`.monaco-list${E} .monaco-list-row:hover { outline: 1px dashed ${c.listHoverOutline}; outline-offset: -1px; }`),c.listDropOverBackground&&l.push(`
				.monaco-list${E}.drop-target,
				.monaco-list${E} .monaco-list-rows.drop-target,
				.monaco-list${E} .monaco-list-row.drop-target { background-color: ${c.listDropOverBackground} !important; color: inherit !important; }
			`),c.listDropBetweenBackground&&(l.push(`
			.monaco-list${E} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${E} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${c.listDropBetweenBackground};
			}`),l.push(`
			.monaco-list${E} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${E} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${c.listDropBetweenBackground};
			}`)),c.tableColumnsBorder&&l.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${c.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),c.tableOddRowsBackgroundColor&&l.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${c.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=l.join(`
`)}}t.DefaultStyleController=le,t.unthemedListStyles={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:w.Color.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:w.Color.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:w.Color.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const ae={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function Z(H,c){const E=H.indexOf(c);if(E===-1)return[];const l=[];let v=E-1;for(;v>=0&&H[v]===c-(E-v);)l.push(H[v--]);for(l.reverse(),v=E;v<H.length&&H[v]===c+(v-E);)l.push(H[v++]);return l}function G(H,c){const E=[];let l=0,v=0;for(;l<H.length||v<c.length;)if(l>=H.length)E.push(c[v++]);else if(v>=c.length)E.push(H[l++]);else if(H[l]===c[v]){E.push(H[l]),l++,v++;continue}else H[l]<c[v]?E.push(H[l++]):E.push(c[v++]);return E}function ne(H,c){const E=[];let l=0,v=0;for(;l<H.length||v<c.length;)if(l>=H.length)E.push(c[v++]);else if(v>=c.length)E.push(H[l++]);else if(H[l]===c[v]){l++,v++;continue}else H[l]<c[v]?E.push(H[l++]):v++;return E}const de=(H,c)=>H-c;class we{constructor(c,E){this._templateId=c,this.renderers=E}get templateId(){return this._templateId}renderTemplate(c){return this.renderers.map(E=>E.renderTemplate(c))}renderElement(c,E,l,v){let T=0;for(const n of this.renderers)n.renderElement(c,E,l[T++],v)}disposeElement(c,E,l,v){let T=0;for(const n of this.renderers)n.disposeElement?.(c,E,l[T],v),T+=1}disposeTemplate(c){let E=0;for(const l of this.renderers)l.disposeTemplate(c[E++])}}class Fe{constructor(c){this.accessibilityProvider=c,this.templateId="a18n"}renderTemplate(c){return{container:c,disposables:new e.DisposableStore}}renderElement(c,E,l){const v=this.accessibilityProvider.getAriaLabel(c),T=v&&typeof v!="string"?v:(0,f.constObservable)(v);l.disposables.add((0,f.autorun)(S=>{this.setAriaLabel(S.readObservable(T),l.container)}));const n=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(c);typeof n=="number"?l.container.setAttribute("aria-level",`${n}`):l.container.removeAttribute("aria-level")}setAriaLabel(c,E){c?E.setAttribute("aria-label",c):E.removeAttribute("aria-label")}disposeElement(c,E,l,v){l.disposables.clear()}disposeTemplate(c){c.disposables.dispose()}}class _e{constructor(c,E){this.list=c,this.dnd=E}getDragElements(c){const E=this.list.getSelectedElements();return E.indexOf(c)>-1?E:[c]}getDragURI(c){return this.dnd.getDragURI(c)}getDragLabel(c,E){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(c,E)}onDragStart(c,E){this.dnd.onDragStart?.(c,E)}onDragOver(c,E,l,v,T){return this.dnd.onDragOver(c,E,l,v,T)}onDragLeave(c,E,l,v){this.dnd.onDragLeave?.(c,E,l,v)}onDragEnd(c){this.dnd.onDragEnd?.(c)}drop(c,E,l,v,T){this.dnd.drop(c,E,l,v,T)}dispose(){this.dnd.dispose()}}class Pe{get onDidChangeFocus(){return h.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),c=>this.toListEvent(c),this.disposables)}get onDidChangeSelection(){return h.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),c=>this.toListEvent(c),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let c=!1;const E=h.Event.chain(this.disposables.add(new N.DomEmitter(this.view.domNode,"keydown")).event,T=>T.map(n=>new x.StandardKeyboardEvent(n)).filter(n=>c=n.keyCode===58||n.shiftKey&&n.keyCode===68).map(n=>s.EventHelper.stop(n,!0)).filter(()=>!1)),l=h.Event.chain(this.disposables.add(new N.DomEmitter(this.view.domNode,"keyup")).event,T=>T.forEach(()=>c=!1).map(n=>new x.StandardKeyboardEvent(n)).filter(n=>n.keyCode===58||n.shiftKey&&n.keyCode===68).map(n=>s.EventHelper.stop(n,!0)).map(({browserEvent:n})=>{const S=this.getFocus(),y=S.length?S[0]:void 0,L=typeof y<"u"?this.view.element(y):void 0,z=typeof y<"u"?this.view.domElement(y):this.view.domNode;return{index:y,element:L,anchor:z,browserEvent:n}})),v=h.Event.chain(this.view.onContextMenu,T=>T.filter(n=>!c).map(({element:n,index:S,browserEvent:y})=>({element:n,index:S,anchor:new a.StandardMouseEvent((0,s.getWindow)(this.view.domNode),y),browserEvent:y})));return h.Event.any(E,l,v)}get onKeyDown(){return this.disposables.add(new N.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new N.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new N.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return h.Event.signal(this.disposables.add(new N.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return h.Event.signal(this.disposables.add(new N.DomEmitter(this.view.domNode,"blur",!0)).event)}constructor(c,E,l,v,T=ae){this.user=c,this._options=T,this.focus=new C("focused"),this.anchor=new C("anchor"),this.eventBufferer=new h.EventBufferer,this._ariaLabel="",this.disposables=new e.DisposableStore,this._onDidDispose=new h.Emitter,this.onDidDispose=this._onDidDispose.event;const n=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new F(n!=="listbox");const S=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=T.accessibilityProvider,this.accessibilityProvider&&(S.push(new Fe(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),v=v.map(L=>new we(L.templateId,[...S,L]));const y={...T,dnd:T.dnd&&new _e(this,T.dnd)};if(this.view=this.createListView(E,l,v,y),this.view.domNode.setAttribute("role",n),T.styleController)this.styleController=T.styleController(this.view.domId);else{const L=(0,s.createStyleSheet)(this.view.domNode);this.styleController=new le(L,this.view.domId)}if(this.spliceable=new A.CombinedSpliceable([new R(this.focus,this.view,T.identityProvider),new R(this.selection,this.view,T.identityProvider),new R(this.anchor,this.view,T.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new be(this,this.view)),(typeof T.keyboardSupport!="boolean"||T.keyboardSupport)&&(this.keyboardController=new X(this,this.view,T),this.disposables.add(this.keyboardController)),T.keyboardNavigationLabelProvider){const L=T.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new te(this,this.view,T.keyboardNavigationLabelProvider,T.keyboardNavigationEventFilter??(()=>!0),L),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(T),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}createListView(c,E,l,v){return new D.ListView(c,E,l,v)}createMouseController(c){return new J(this)}updateOptions(c={}){this._options={...this._options,...c},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(c),this.keyboardController?.updateOptions(c),this.view.updateOptions(c)}get options(){return this._options}splice(c,E,l=[]){if(c<0||c>this.view.length)throw new g.ListError(this.user,`Invalid start index: ${c}`);if(E<0)throw new g.ListError(this.user,`Invalid delete count: ${E}`);E===0&&l.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(c,E,l))}updateWidth(c){this.view.updateWidth(c)}updateElementHeight(c,E){this.view.updateElementHeight(c,E,null)}rerender(){this.view.rerender()}element(c){return this.view.element(c)}indexOf(c){return this.view.indexOf(c)}indexAt(c){return this.view.indexAt(c)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get contentWidth(){return this.view.contentWidth}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.view.onDidChangeContentWidth}get scrollTop(){return this.view.getScrollTop()}set scrollTop(c){this.view.setScrollTop(c)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(c){this.view.setScrollLeft(c)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.view.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(c){this._ariaLabel=c,this.view.domNode.setAttribute("aria-label",c)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(c,E){this.view.layout(c,E)}triggerTypeNavigation(){this.typeNavigationController?.trigger()}setSelection(c,E){for(const l of c)if(l<0||l>=this.length)throw new g.ListError(this.user,`Invalid index ${l}`);this.selection.set(c,E)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(c=>this.view.element(c))}setAnchor(c){if(typeof c>"u"){this.anchor.set([]);return}if(c<0||c>=this.length)throw new g.ListError(this.user,`Invalid index ${c}`);this.anchor.set([c])}getAnchor(){return(0,m.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const c=this.getAnchor();return typeof c>"u"?void 0:this.element(c)}setFocus(c,E){for(const l of c)if(l<0||l>=this.length)throw new g.ListError(this.user,`Invalid index ${l}`);this.focus.set(c,E)}focusNext(c=1,E=!1,l,v){if(this.length===0)return;const T=this.focus.get(),n=this.findNextIndex(T.length>0?T[0]+c:0,E,v);n>-1&&this.setFocus([n],l)}focusPrevious(c=1,E=!1,l,v){if(this.length===0)return;const T=this.focus.get(),n=this.findPreviousIndex(T.length>0?T[0]-c:0,E,v);n>-1&&this.setFocus([n],l)}async focusNextPage(c,E){let l=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);l=l===0?0:l-1;const v=this.getFocus()[0];if(v!==l&&(v===void 0||l>v)){const T=this.findPreviousIndex(l,!1,E);T>-1&&v!==T?this.setFocus([T],c):this.setFocus([l],c)}else{const T=this.view.getScrollTop();let n=T+this.view.renderHeight;l>v&&(n-=this.view.elementHeight(l)),this.view.setScrollTop(n),this.view.getScrollTop()!==T&&(this.setFocus([]),await(0,p.timeout)(0),await this.focusNextPage(c,E))}}async focusPreviousPage(c,E,l=()=>0){let v;const T=l(),n=this.view.getScrollTop()+T;n===0?v=this.view.indexAt(n):v=this.view.indexAfter(n-1);const S=this.getFocus()[0];if(S!==v&&(S===void 0||S>=v)){const y=this.findNextIndex(v,!1,E);y>-1&&S!==y?this.setFocus([y],c):this.setFocus([v],c)}else{const y=n;this.view.setScrollTop(n-this.view.renderHeight-T),this.view.getScrollTop()+l()!==y&&(this.setFocus([]),await(0,p.timeout)(0),await this.focusPreviousPage(c,E,l))}}focusLast(c,E){if(this.length===0)return;const l=this.findPreviousIndex(this.length-1,!1,E);l>-1&&this.setFocus([l],c)}focusFirst(c,E){this.focusNth(0,c,E)}focusNth(c,E,l){if(this.length===0)return;const v=this.findNextIndex(c,!1,l);v>-1&&this.setFocus([v],E)}findNextIndex(c,E=!1,l){for(let v=0;v<this.length;v++){if(c>=this.length&&!E)return-1;if(c=c%this.length,!l||l(this.element(c)))return c;c++}return-1}findPreviousIndex(c,E=!1,l){for(let v=0;v<this.length;v++){if(c<0&&!E)return-1;if(c=(this.length+c%this.length)%this.length,!l||l(this.element(c)))return c;c--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(c=>this.view.element(c))}reveal(c,E,l=0){if(c<0||c>=this.length)throw new g.ListError(this.user,`Invalid index ${c}`);const v=this.view.getScrollTop(),T=this.view.elementTop(c),n=this.view.elementHeight(c);if((0,u.isNumber)(E)){const S=n-this.view.renderHeight+l;this.view.setScrollTop(S*(0,i.clamp)(E,0,1)+T-l)}else{const S=T+n,y=v+this.view.renderHeight;T<v+l&&S>=y||(T<v+l||S>=y&&n>=this.view.renderHeight?this.view.setScrollTop(T-l):S>=y&&this.view.setScrollTop(S-this.view.renderHeight))}}getRelativeTop(c,E=0){if(c<0||c>=this.length)throw new g.ListError(this.user,`Invalid index ${c}`);const l=this.view.getScrollTop(),v=this.view.elementTop(c),T=this.view.elementHeight(c);if(v<l+E||v+T>l+this.view.renderHeight)return null;const n=T-this.view.renderHeight+E;return Math.abs((l+E-v)/n)}isDOMFocused(){return(0,s.isActiveElement)(this.view.domNode)}getHTMLElement(){return this.view.domNode}getScrollableElement(){return this.view.scrollableElementDomNode}getElementID(c){return this.view.getElementDomId(c)}getElementTop(c){return this.view.elementTop(c)}style(c){this.styleController.style(c)}toListEvent({indexes:c,browserEvent:E}){return{indexes:c,elements:c.map(l=>this.view.element(l)),browserEvent:E}}_onFocusChange(){const c=this.focus.get();this.view.domNode.classList.toggle("element-focused",c.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const c=this.focus.get();if(c.length>0){let E;this.accessibilityProvider?.getActiveDescendantId&&(E=this.accessibilityProvider.getActiveDescendantId(this.view.element(c[0]))),this.view.domNode.setAttribute("aria-activedescendant",E||this.view.getElementDomId(c[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const c=this.selection.get();this.view.domNode.classList.toggle("selection-none",c.length===0),this.view.domNode.classList.toggle("selection-single",c.length===1),this.view.domNode.classList.toggle("selection-multiple",c.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}t.List=Pe,Xe([W.memoize],Pe.prototype,"onDidChangeFocus",null),Xe([W.memoize],Pe.prototype,"onDidChangeSelection",null),Xe([W.memoize],Pe.prototype,"onContextMenu",null),Xe([W.memoize],Pe.prototype,"onKeyDown",null),Xe([W.memoize],Pe.prototype,"onKeyUp",null),Xe([W.memoize],Pe.prototype,"onKeyPress",null),Xe([W.memoize],Pe.prototype,"onDidFocus",null),Xe([W.memoize],Pe.prototype,"onDidBlur",null)}),define(ge[72],pe([1,0,6,45,47,10,16]),function(ie,t,s,N,x,V,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0,t.isEmptyMarkdownString=p,t.isMarkdownString=w,t.markdownStringEqual=W,t.escapeMarkdownSyntaxTokens=h,t.appendEscapedMarkdownCodeBlockFence=d,t.escapeDoubleQuotes=e,t.removeMarkdownEscapes=i,t.parseHrefAndDimensions=r;var A;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(A||(t.MarkdownStringTextNewlineStyle=A={}));class m{constructor(g="",D=!1){if(this.value=g,typeof this.value!="string")throw(0,s.illegalArgument)("value");typeof D=="boolean"?(this.isTrusted=D,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=D.isTrusted??void 0,this.supportThemeIcons=D.supportThemeIcons??!1,this.supportHtml=D.supportHtml??!1)}appendText(g,D=0){return this.value+=h(this.supportThemeIcons?(0,N.escapeIcons)(g):g).replace(/([ \t]+)/g,(a,f)=>"&nbsp;".repeat(f.length)).replace(/\>/gm,"\\>").replace(/\n/g,D===1?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,D){return this.value+=`
${d(D,g)}
`,this}appendLink(g,D,a){return this.value+="[",this.value+=this._escape(D,"]"),this.value+="](",this.value+=this._escape(String(g),")"),a&&(this.value+=` "${this._escape(this._escape(a,'"'),")")}"`),this.value+=")",this}_escape(g,D){const a=new RegExp((0,V.escapeRegExpCharacters)(D),"g");return g.replace(a,(f,o)=>g.charAt(o-1)!=="\\"?`\\${f}`:f)}}t.MarkdownString=m;function p(u){return w(u)?!u.value:Array.isArray(u)?u.every(p):!0}function w(u){return u instanceof m?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||typeof u.isTrusted=="object"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}function W(u,g){return u===g?!0:!u||!g?!1:u.value===g.value&&u.isTrusted===g.isTrusted&&u.supportThemeIcons===g.supportThemeIcons&&u.supportHtml===g.supportHtml&&(u.baseUri===g.baseUri||!!u.baseUri&&!!g.baseUri&&(0,x.isEqual)(_.URI.from(u.baseUri),_.URI.from(g.baseUri)))}function h(u){return u.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function d(u,g){const D=u.match(/^`+/gm)?.reduce((f,o)=>f.length>o.length?f:o).length??0,a=D>=3?D+1:3;return[`${"`".repeat(a)}${g}`,u,`${"`".repeat(a)}`].join(`
`)}function e(u){return u.replace(/"/g,"&quot;")}function i(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function r(u){const g=[],D=u.split("|").map(f=>f.trim());u=D[0];const a=D[1];if(a){const f=/height=(\d+)/.exec(a),o=/width=(\d+)/.exec(a),C=f?f[1]:"",F=o?o[1]:"",R=isFinite(parseInt(F)),B=isFinite(parseInt(C));R&&g.push(`width="${F}"`),B&&g.push(`height="${C}"`)}return{href:u,dimensions:g}}}),define(ge[138],pe([1,0,3,130,24,65,15,20,131,6,4,72,45,86,23,2,88,63,35,61,47,10,16]),function(ie,t,s,N,x,V,_,A,m,p,w,W,h,d,e,i,r,u,g,D,a,f,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.allowedMarkdownAttr=void 0,t.renderMarkdown=F,t.renderStringAsPlaintext=O,t.renderMarkdownAsPlaintext=$,t.fillInIncompleteTokens=ce;const C=Object.freeze({image:(G,ne,de)=>{let we=[],Fe=[];return G&&({href:G,dimensions:we}=(0,W.parseHrefAndDimensions)(G),Fe.push(`src="${(0,W.escapeDoubleQuotes)(G)}"`)),de&&Fe.push(`alt="${(0,W.escapeDoubleQuotes)(de)}"`),ne&&Fe.push(`title="${(0,W.escapeDoubleQuotes)(ne)}"`),we.length&&(Fe=Fe.concat(we)),"<img "+Fe.join(" ")+">"},paragraph:G=>`<p>${G}</p>`,link:(G,ne,de)=>typeof G!="string"?"":(G===de&&(de=(0,W.removeMarkdownEscapes)(de)),ne=typeof ne=="string"?(0,W.escapeDoubleQuotes)((0,W.removeMarkdownEscapes)(ne)):"",G=(0,W.removeMarkdownEscapes)(G),G=G.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${G}" title="${ne||G}" draggable="false">${de}</a>`)});function F(G,ne={},de={}){const we=new i.DisposableStore;let Fe=!1;const _e=(0,V.createElement)(ne),Pe=function(y){let L;try{L=(0,u.parse)(decodeURIComponent(y))}catch{}return L?(L=(0,D.cloneAndChange)(L,z=>{if(G.uris&&G.uris[z])return o.URI.revive(G.uris[z])}),encodeURIComponent(JSON.stringify(L))):y},H=function(y,L){const z=G.uris&&G.uris[y];let Y=o.URI.revive(z);return L?y.startsWith(g.Schemas.data+":")?y:(Y||(Y=o.URI.parse(y)),g.FileAccess.uriToBrowserUri(Y).toString(!0)):!Y||o.URI.parse(y).toString()===Y.toString()?y:(Y.query&&(Y=Y.with({query:Pe(Y.query)})),Y.toString())},c=new r.marked.Renderer;c.image=C.image,c.link=C.link,c.paragraph=C.paragraph;const E=[],l=[];if(ne.codeBlockRendererSync?c.code=(y,L)=>{const z=d.defaultGenerator.nextId(),Y=ne.codeBlockRendererSync(R(L),y);return l.push([z,Y]),`<div class="code" data-code="${z}">${(0,f.escape)(y)}</div>`}:ne.codeBlockRenderer&&(c.code=(y,L)=>{const z=d.defaultGenerator.nextId(),Y=ne.codeBlockRenderer(R(L),y);return E.push(Y.then(Q=>[z,Q])),`<div class="code" data-code="${z}">${(0,f.escape)(y)}</div>`}),ne.actionHandler){const y=function(Y){let Q=Y.target;if(!(Q.tagName!=="A"&&(Q=Q.parentElement,!Q||Q.tagName!=="A")))try{let oe=Q.dataset.href;oe&&(G.baseUri&&(oe=B(o.URI.from(G.baseUri),oe)),ne.actionHandler.callback(oe,Y))}catch(oe){(0,p.onUnexpectedError)(oe)}finally{Y.preventDefault()}},L=ne.actionHandler.disposables.add(new x.DomEmitter(_e,"click")),z=ne.actionHandler.disposables.add(new x.DomEmitter(_e,"auxclick"));ne.actionHandler.disposables.add(w.Event.any(L.event,z.event)(Y=>{const Q=new A.StandardMouseEvent(s.getWindow(_e),Y);!Q.leftButton&&!Q.middleButton||y(Q)})),ne.actionHandler.disposables.add(s.addDisposableListener(_e,"keydown",Y=>{const Q=new _.StandardKeyboardEvent(Y);!Q.equals(10)&&!Q.equals(3)||y(Q)}))}G.supportHtml||(de.sanitizer=y=>(G.isTrusted?y.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?y:"",de.sanitize=!0,de.silent=!0),de.renderer=c;let v=G.value??"";v.length>1e5&&(v=`${v.substr(0,1e5)}\u2026`),G.supportThemeIcons&&(v=(0,h.markdownEscapeEscapedIcons)(v));let T;if(ne.fillInIncompleteTokens){const y={...r.marked.defaults,...de},L=r.marked.lexer(v,y),z=ce(L);T=r.marked.parser(z,y)}else T=r.marked.parse(v,de);G.supportThemeIcons&&(T=(0,m.renderLabelWithIcons)(T).map(L=>typeof L=="string"?L:L.outerHTML).join(""));const S=new DOMParser().parseFromString(P(G,T),"text/html");if(S.body.querySelectorAll("img").forEach(y=>{const L=y.getAttribute("src");if(L){let z=L;try{G.baseUri&&(z=B(o.URI.from(G.baseUri),z))}catch{}y.src=H(z,!0)}}),S.body.querySelectorAll("a").forEach(y=>{const L=y.getAttribute("href");if(y.setAttribute("href",""),!L||/^data:|javascript:/i.test(L)||/^command:/i.test(L)&&!G.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(L))y.replaceWith(...y.childNodes);else{let z=H(L,!1);G.baseUri&&(z=B(o.URI.from(G.baseUri),L)),y.dataset.href=z}}),_e.innerHTML=P(G,S.body.innerHTML),E.length>0)Promise.all(E).then(y=>{if(Fe)return;const L=new Map(y),z=_e.querySelectorAll("div[data-code]");for(const Y of z){const Q=L.get(Y.dataset.code??"");Q&&s.reset(Y,Q)}ne.asyncRenderCallback?.()});else if(l.length>0){const y=new Map(l),L=_e.querySelectorAll("div[data-code]");for(const z of L){const Y=y.get(z.dataset.code??"");Y&&s.reset(z,Y)}}if(ne.asyncRenderCallback)for(const y of _e.getElementsByTagName("img")){const L=we.add(s.addDisposableListener(y,"load",()=>{L.dispose(),ne.asyncRenderCallback()}))}return{element:_e,dispose:()=>{Fe=!0,we.dispose()}}}function R(G){if(!G)return"";const ne=G.split(/[\s+|:|,|\{|\?]/,1);return ne.length?ne[0]:G}function B(G,ne){return/^\w[\w\d+.-]*:/.test(ne)?ne:G.path.endsWith("/")?(0,a.resolvePath)(G,ne).toString():(0,a.resolvePath)((0,a.dirname)(G),ne).toString()}function P(G,ne){const{config:de,allowedSchemes:we}=b(G);N.addHook("uponSanitizeAttribute",(_e,Pe)=>{if(Pe.attrName==="style"||Pe.attrName==="class"){if(_e.tagName==="SPAN"){if(Pe.attrName==="style"){Pe.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(Pe.attrValue);return}else if(Pe.attrName==="class"){Pe.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Pe.attrValue);return}}Pe.keepAttr=!1;return}else if(_e.tagName==="INPUT"&&_e.attributes.getNamedItem("type")?.value==="checkbox"){if(Pe.attrName==="type"&&Pe.attrValue==="checkbox"||Pe.attrName==="disabled"||Pe.attrName==="checked"){Pe.keepAttr=!0;return}Pe.keepAttr=!1}}),N.addHook("uponSanitizeElement",(_e,Pe)=>{Pe.tagName==="input"&&(_e.attributes.getNamedItem("type")?.value==="checkbox"?_e.setAttribute("disabled",""):_e.parentElement?.removeChild(_e))});const Fe=s.hookDomPurifyHrefAndSrcSanitizer(we);try{return N.sanitize(ne,{...de,RETURN_TRUSTED_TYPE:!0})}finally{N.removeHook("uponSanitizeAttribute"),Fe.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function b(G){const ne=[g.Schemas.http,g.Schemas.https,g.Schemas.mailto,g.Schemas.data,g.Schemas.file,g.Schemas.vscodeFileResource,g.Schemas.vscodeRemote,g.Schemas.vscodeRemoteResource];return G.isTrusted&&ne.push(g.Schemas.command),{config:{ALLOWED_TAGS:[...s.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:ne}}function O(G){return typeof G=="string"?G:$(G)}function $(G){let ne=G.value??"";ne.length>1e5&&(ne=`${ne.substr(0,1e5)}\u2026`);const de=r.marked.parse(ne,{renderer:M.value}).replace(/&(#\d+|[a-zA-Z]+);/g,we=>k.get(we)??we);return P({isTrusted:!1},de).toString()}const k=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),M=new e.Lazy(()=>{const G=new r.marked.Renderer;return G.code=ne=>ne,G.blockquote=ne=>ne,G.html=ne=>"",G.heading=(ne,de,we)=>ne+`
`,G.hr=()=>"",G.list=(ne,de)=>ne,G.listitem=ne=>ne+`
`,G.paragraph=ne=>ne+`
`,G.table=(ne,de)=>ne+de+`
`,G.tablerow=ne=>ne,G.tablecell=(ne,de)=>ne+" ",G.strong=ne=>ne,G.em=ne=>ne,G.codespan=ne=>ne,G.br=()=>`
`,G.del=ne=>ne,G.image=(ne,de,we)=>"",G.text=ne=>ne,G.link=(ne,de,we)=>we,G});function I(G){let ne="";return G.forEach(de=>{ne+=de.raw}),ne}function q(G){for(let ne=0;ne<G.tokens.length;ne++){const de=G.tokens[ne];if(de.type==="text"){const we=de.raw.split(`
`),Fe=we[we.length-1];if(Fe.includes("`"))return te(G);if(Fe.includes("**"))return J(G);if(Fe.match(/\*\w/))return be(G);if(Fe.match(/(^|\s)__\w/))return le(G);if(Fe.match(/(^|\s)_\w/))return Ee(G);if(Fe.match(/(^|\s)\[.*\]\(\w*/)){const _e=G.tokens.slice(ne+1);return _e[0]?.type==="link"&&_e[1]?.type==="text"&&_e[1].raw.match(/^ *"[^"]*$/)?Be(G):Ie(G)}else{if(X(Fe))return Ie(G);if(Fe.match(/(^|\s)\[\w/)&&!G.tokens.slice(ne+1).some(_e=>X(_e.raw)))return ue(G)}}}}function X(G){return!!G.match(/^[^\[]*\]\([^\)]*$/)}function ce(G){let ne,de;for(ne=0;ne<G.length;ne++){const we=G[ne];let Fe;if(we.type==="paragraph"&&(Fe=we.raw.match(/(\n|^)(````*)/))){const _e=Fe[2];de=re(G.slice(ne),_e);break}if(we.type==="paragraph"&&we.raw.match(/(\n|^)\|/)){de=Z(G.slice(ne));break}if(ne===G.length-1&&we.type==="paragraph"){const _e=q(we);if(_e){de=[_e];break}}}if(de){const we=[...G.slice(0,ne),...de];return we.links=G.links,we}return G}function re(G,ne){const de=I(G);return r.marked.lexer(de+`
${ne}`)}function te(G){return ae(G,"`")}function be(G){return ae(G,"*")}function Ee(G){return ae(G,"_")}function Ie(G){return ae(G,")")}function Be(G){return ae(G,'")')}function ue(G){return ae(G,"](about:blank)")}function J(G){return ae(G,"**")}function le(G){return ae(G,"__")}function ae(G,ne){const de=I(Array.isArray(G)?G:[G]);return r.marked.lexer(de+ne)[0]}function Z(G){const ne=I(G),de=ne.split(`
`);let we,Fe=!1;for(let _e=0;_e<de.length;_e++){const Pe=de[_e].trim();if(typeof we>"u"&&Pe.match(/^\s*\|/)){const H=Pe.match(/(\|[^\|]+)(?=\||$)/g);H&&(we=H.length)}else if(typeof we=="number")if(Pe.match(/^\s*\|/)){if(_e!==de.length-1)return;Fe=!0}else return}if(typeof we=="number"&&we>0){const _e=Fe?de.slice(0,-1).join(`
`):ne,Pe=!!_e.match(/\|\s*$/),H=_e+(Pe?"":"|")+`
|${" --- |".repeat(we)}`;return r.marked.lexer(H)}}}),define(ge[36],pe([1,0,3,9,28,72,45,2,7,120]),function(ie,t,s,N,x,V,_,A,m,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupNativeHover=w,t.setupCustomHover=d;function w(e,i){(0,m.isString)(i)?e.title=(0,_.stripIcons)(i):i?.markdownNotSupportedFallback?e.title=i.markdownNotSupportedFallback:e.removeAttribute("title")}class W{constructor(i,r,u){this.hoverDelegate=i,this.target=r,this.fadeInAnimation=u}async update(i,r,u){if(this._cancellationTokenSource&&(this._cancellationTokenSource.dispose(!0),this._cancellationTokenSource=void 0),this.isDisposed)return;let g;if(i===void 0||(0,m.isString)(i)||i instanceof HTMLElement)g=i;else if(!(0,m.isFunction)(i.markdown))g=i.markdown??i.markdownNotSupportedFallback;else{this._hoverWidget||this.show((0,p.localize)(0,null),r),this._cancellationTokenSource=new x.CancellationTokenSource;const D=this._cancellationTokenSource.token;if(g=await i.markdown(D),g===void 0&&(g=i.markdownNotSupportedFallback),this.isDisposed||D.isCancellationRequested)return}this.show(g,r,u)}show(i,r,u){const g=this._hoverWidget;if(this.hasContent(i)){const D={content:i,target:this.target,appearance:{showPointer:this.hoverDelegate.placement==="element",skipFadeInAnimation:!this.fadeInAnimation||!!g},position:{hoverPosition:2},...u};this._hoverWidget=this.hoverDelegate.showHover(D,r)}g?.dispose()}hasContent(i){return i?(0,V.isMarkdownString)(i)?!!i.value:!0:!1}get isDisposed(){return this._hoverWidget?.isDisposed}dispose(){this._hoverWidget?.dispose(),this._cancellationTokenSource?.dispose(!0),this._cancellationTokenSource=void 0}}function h(e,i){for(i=i??s.getWindow(e).document.body;!e.hasAttribute("custom-hover")&&e!==i;)e=e.parentElement;return e}function d(e,i,r,u){i.setAttribute("custom-hover","true"),i.title!==""&&(console.warn("HTML element already has a title attribute, which will conflict with the custom hover. Please remove the title attribute."),console.trace("Stack trace:",i.title),i.title="");let g,D;const a=(M,I)=>{const q=D!==void 0;M&&(D?.dispose(),D=void 0),I&&(g?.dispose(),g=void 0),q&&(e.onDidHideHover?.(),D=void 0)},f=(M,I,q)=>new N.TimeoutTimer(async()=>{(!D||D.isDisposed)&&(D=new W(e,q||i,M>0),await D.update(typeof r=="function"?r():r,I,u))},M);let o=!1;const C=s.addDisposableListener(i,s.EventType.MOUSE_DOWN,()=>{o=!0,a(!0,!0)},!0),F=s.addDisposableListener(i,s.EventType.MOUSE_UP,()=>{o=!1},!0),R=s.addDisposableListener(i,s.EventType.MOUSE_LEAVE,M=>{o=!1,a(!1,M.fromElement===i)},!0),B=M=>{if(g)return;const I=new A.DisposableStore,q={targetElements:[i],dispose:()=>{}};if(e.placement===void 0||e.placement==="mouse"){const X=ce=>{q.x=ce.x+10,ce.target instanceof HTMLElement&&h(ce.target,i)!==i&&a(!0,!0)};I.add(s.addDisposableListener(i,s.EventType.MOUSE_MOVE,X,!0))}g=I,!(M.target instanceof HTMLElement&&h(M.target,i)!==i)&&I.add(f(e.delay,!1,q))},P=s.addDisposableListener(i,s.EventType.MOUSE_OVER,B,!0),b=()=>{if(o||g)return;const M={targetElements:[i],dispose:()=>{}},I=new A.DisposableStore,q=()=>a(!0,!0);I.add(s.addDisposableListener(i,s.EventType.BLUR,q,!0)),I.add(f(e.delay,!1,M)),g=I};let O;const $=i.tagName.toLowerCase();return $!=="input"&&$!=="textarea"&&(O=s.addDisposableListener(i,s.EventType.FOCUS,b,!0)),{show:M=>{a(!1,!0),f(0,M)},hide:()=>{a(!0,!0)},update:async(M,I)=>{r=M,await D?.update(r,void 0,I)},dispose:()=>{P.dispose(),R.dispose(),C.dispose(),F.dispose(),O?.dispose(),a(!0,!0)}}}}),define(ge[139],pe([1,0,3,24,15,138,14,36,49,12,4,54,2,5,122,113]),function(ie,t,s,N,x,V,_,A,m,p,w,W,h,d,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const i=s.$,r="selectOption.entry.template";class u{get templateId(){return r}renderTemplate(a){const f=Object.create(null);return f.root=a,f.text=s.append(a,i(".option-text")),f.detail=s.append(a,i(".option-detail")),f.decoratorRight=s.append(a,i(".option-decorator-right")),f}renderElement(a,f,o){const C=o,F=a.text,R=a.detail,B=a.decoratorRight,P=a.isDisabled;C.text.textContent=F,C.detail.textContent=R||"",C.decoratorRight.innerText=B||"",P?C.root.classList.add("option-disabled"):C.root.classList.remove("option-disabled")}disposeTemplate(a){}}class g extends h.Disposable{static{this.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32}static{this.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2}static{this.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}constructor(a,f,o,C,F){super(),this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.styles=C,this.selectBoxOptions=F||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=g.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new w.Emitter,this._register(this._onDidSelect),this.registerListeners(),this.constructSelectDropDown(o),this.selected=f||0,a&&this.setOptions(a,f),this.initStyleSheet()}setTitle(a){!this._hover&&a?this._hover=this._register((0,A.setupCustomHover)((0,_.getDefaultHoverDelegate)("mouse"),this.selectElement,a)):this._hover&&this._hover.update(a)}getHeight(){return 22}getTemplateId(){return r}constructSelectDropDown(a){this.contextViewProvider=a,this.selectDropDownContainer=s.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=s.append(this.selectDropDownContainer,i(".select-box-details-pane"));const f=s.append(this.selectDropDownContainer,i(".select-box-dropdown-container-width-control")),o=s.append(f,i(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",s.append(o,this.widthControlElement),this._dropDownPosition=0,this.styleElement=s.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(s.addDisposableListener(this.selectDropDownContainer,s.EventType.DRAG_START,C=>{s.EventHelper.stop(C,!0)}))}registerListeners(){this._register(s.addStandardDisposableListener(this.selectElement,"change",f=>{this.selected=f.target.selectedIndex,this._onDidSelect.fire({index:f.target.selectedIndex,selected:f.target.value}),this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)})),this._register(s.addDisposableListener(this.selectElement,s.EventType.CLICK,f=>{s.EventHelper.stop(f),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(s.addDisposableListener(this.selectElement,s.EventType.MOUSE_DOWN,f=>{s.EventHelper.stop(f)}));let a;this._register(s.addDisposableListener(this.selectElement,"touchstart",f=>{a=this._isVisible})),this._register(s.addDisposableListener(this.selectElement,"touchend",f=>{s.EventHelper.stop(f),a?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(s.addDisposableListener(this.selectElement,s.EventType.KEY_DOWN,f=>{const o=new x.StandardKeyboardEvent(f);let C=!1;d.isMacintosh?(o.keyCode===18||o.keyCode===16||o.keyCode===10||o.keyCode===3)&&(C=!0):(o.keyCode===18&&o.altKey||o.keyCode===16&&o.altKey||o.keyCode===10||o.keyCode===3)&&(C=!0),C&&(this.showSelectDropDown(),s.EventHelper.stop(f,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(a,f){p.equals(this.options,a)||(this.options=a,this.selectElement.options.length=0,this._hasDetails=!1,this._cachedMaxDetailsHeight=void 0,this.options.forEach((o,C)=>{this.selectElement.add(this.createOption(o.text,C,o.isDisabled)),typeof o.description=="string"&&(this._hasDetails=!0)})),f!==void 0&&(this.select(f),this._currentSelection=this.selected)}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(a){a>=0&&a<this.options.length?this.selected=a:a>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)}setAriaLabel(a){this.selectBoxOptions.ariaLabel=a,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(a){this.selectElement.tabIndex=a?0:-1}render(a){this.container=a,a.classList.add("select-container"),a.appendChild(this.selectElement),this.styleSelectElement()}initStyleSheet(){const a=[];this.styles.listFocusBackground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&this.styles.selectBorder!==this.styles.selectBackground?(a.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),a.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),a.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=a.join(`
`)}styleSelectElement(){const a=this.styles.selectBackground??"",f=this.styles.selectForeground??"",o=this.styles.selectBorder??"";this.selectElement.style.backgroundColor=a,this.selectElement.style.color=f,this.selectElement.style.borderColor=o}styleList(){const a=this.styles.selectBackground??"",f=s.asCssValueWithDefault(this.styles.selectListBackground,a);this.selectDropDownListContainer.style.backgroundColor=f,this.selectionDetailsPane.style.backgroundColor=f;const o=this.styles.focusBorder??"";this.selectDropDownContainer.style.outlineColor=o,this.selectDropDownContainer.style.outlineOffset="-1px",this.selectList.style(this.styles)}createOption(a,f,o){const C=document.createElement("option");return C.value=a,C.text=a,C.disabled=!!o,C}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:a=>this.renderSelectDropDown(a,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:a=>this.renderSelectDropDown(a),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(a){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),a&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(a,f){return a.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(f),{dispose:()=>{try{a.removeChild(this.selectDropDownContainer)}catch{}}}}measureMaxDetailsHeight(){let a=0;return this.options.forEach((f,o)=>{this.updateDetail(o),this.selectionDetailsPane.offsetHeight>a&&(a=this.selectionDetailsPane.offsetHeight)}),a}layoutSelectDropDown(a){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const f=s.getWindow(this.selectElement),o=s.getDomNodePagePosition(this.selectElement),C=s.getWindow(this.selectElement).getComputedStyle(this.selectElement),F=parseFloat(C.getPropertyValue("--dropdown-padding-top"))+parseFloat(C.getPropertyValue("--dropdown-padding-bottom")),R=f.innerHeight-o.top-o.height-(this.selectBoxOptions.minBottomMargin||0),B=o.top-g.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,P=this.selectElement.offsetWidth,b=this.setWidthControlElement(this.widthControlElement),O=Math.max(b,Math.round(P)).toString()+"px";this.selectDropDownContainer.style.width=O,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let $=this.selectList.contentHeight;this._hasDetails&&this._cachedMaxDetailsHeight===void 0&&(this._cachedMaxDetailsHeight=this.measureMaxDetailsHeight());const k=this._hasDetails?this._cachedMaxDetailsHeight:0,M=$+F+k,I=Math.floor((R-F-k)/this.getHeight()),q=Math.floor((B-F-k)/this.getHeight());if(a)return o.top+o.height>f.innerHeight-22||o.top<g.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||I<1&&q<1?!1:(I<g.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&q>I&&this.options.length>I?(this._dropDownPosition=1,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=0,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(o.top+o.height>f.innerHeight-22||o.top<g.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===0&&I<1||this._dropDownPosition===1&&q<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===0){if(this._isVisible&&I+q<1)return this.hideSelectDropDown(!0),!1;M>R&&($=I*this.getHeight())}else M>B&&($=q*this.getHeight());return this.selectList.layout($),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=$+F+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=$+F+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=O,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(a){let f=0;if(a){let o=0,C=0;this.options.forEach((F,R)=>{const B=F.detail?F.detail.length:0,P=F.decoratorRight?F.decoratorRight.length:0,b=F.text.length+B+P;b>C&&(o=R,C=b)}),a.textContent=this.options[o].text+(this.options[o].decoratorRight?this.options[o].decoratorRight+" ":""),f=s.getTotalWidth(a)}return f}createSelectList(a){if(this.selectList)return;this.selectDropDownListContainer=s.append(a,i(".select-box-dropdown-list-container")),this.listRenderer=new u,this.selectList=new m.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:C=>{let F=C.text;return C.detail&&(F+=`. ${C.detail}`),C.decoratorRight&&(F+=`. ${C.decoratorRight}`),C.description&&(F+=`. ${C.description}`),F},getWidgetAriaLabel:()=>(0,e.localize)(0,null),getRole:()=>d.isMacintosh?"":"option",getWidgetRole:()=>"listbox"}}),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const f=this._register(new N.DomEmitter(this.selectDropDownListContainer,"keydown")),o=w.Event.chain(f.event,C=>C.filter(()=>this.selectList.length>0).map(F=>new x.StandardKeyboardEvent(F)));this._register(w.Event.chain(o,C=>C.filter(F=>F.keyCode===3))(this.onEnter,this)),this._register(w.Event.chain(o,C=>C.filter(F=>F.keyCode===2))(this.onEnter,this)),this._register(w.Event.chain(o,C=>C.filter(F=>F.keyCode===9))(this.onEscape,this)),this._register(w.Event.chain(o,C=>C.filter(F=>F.keyCode===16))(this.onUpArrow,this)),this._register(w.Event.chain(o,C=>C.filter(F=>F.keyCode===18))(this.onDownArrow,this)),this._register(w.Event.chain(o,C=>C.filter(F=>F.keyCode===12))(this.onPageDown,this)),this._register(w.Event.chain(o,C=>C.filter(F=>F.keyCode===11))(this.onPageUp,this)),this._register(w.Event.chain(o,C=>C.filter(F=>F.keyCode===14))(this.onHome,this)),this._register(w.Event.chain(o,C=>C.filter(F=>F.keyCode===13))(this.onEnd,this)),this._register(w.Event.chain(o,C=>C.filter(F=>F.keyCode>=21&&F.keyCode<=56||F.keyCode>=85&&F.keyCode<=113))(this.onCharacter,this)),this._register(s.addDisposableListener(this.selectList.getHTMLElement(),s.EventType.POINTER_UP,C=>this.onPointerUp(C))),this._register(this.selectList.onMouseOver(C=>typeof C.index<"u"&&this.selectList.setFocus([C.index]))),this._register(this.selectList.onDidChangeFocus(C=>this.onListFocus(C))),this._register(s.addDisposableListener(this.selectDropDownContainer,s.EventType.FOCUS_OUT,C=>{!this._isVisible||s.isAncestor(C.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(a){if(!this.selectList.length)return;s.EventHelper.stop(a);const f=a.target;if(!f||f.classList.contains("slider"))return;const o=f.closest(".monaco-list-row");if(!o)return;const C=Number(o.getAttribute("data-index")),F=o.classList.contains("option-disabled");C>=0&&C<this.options.length&&!F&&(this.selected=C,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(a,f){const o=F=>{for(let R=0;R<F.childNodes.length;R++){const B=F.childNodes.item(R);(B.tagName&&B.tagName.toLowerCase())==="img"?F.removeChild(B):o(B)}},C=(0,V.renderMarkdown)({value:a,supportThemeIcons:!0},{actionHandler:f});return C.element.classList.add("select-box-description-markdown"),o(C.element),C.element}onListFocus(a){!this._isVisible||!this._hasDetails||this.updateDetail(a.indexes[0])}updateDetail(a){this.selectionDetailsPane.innerText="";const f=this.options[a],o=f?.description??"",C=f?.descriptionIsMarkdown??!1;if(o){if(C){const F=f.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(o,F))}else this.selectionDetailsPane.innerText=o;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(a){s.EventHelper.stop(a),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(a){s.EventHelper.stop(a),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),this.options[this.selected]&&this.options[this.selected].text&&this.setTitle(this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(a){if(this.selected<this.options.length-1){s.EventHelper.stop(a,!0);const f=this.options[this.selected+1].isDisabled;if(f&&this.options.length>this.selected+2)this.selected+=2;else{if(f)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(a){this.selected>0&&(s.EventHelper.stop(a,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(a){s.EventHelper.stop(a),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(a){s.EventHelper.stop(a),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(a){s.EventHelper.stop(a),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(a){s.EventHelper.stop(a),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(a){const f=W.KeyCodeUtils.toString(a.keyCode);let o=-1;for(let C=0;C<this.options.length-1;C++)if(o=(C+this.selected+1)%this.options.length,this.options[o].text.charAt(0).toUpperCase()===f&&!this.options[o].isDisabled){this.select(o),this.selectList.setFocus([o]),this.selectList.reveal(this.selectList.getFocus()[0]),s.EventHelper.stop(a);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}t.SelectBoxList=g}),define(ge[140],pe([1,0,49,139,134,21,5,112]),function(ie,t,s,N,x,V,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.unthemedSelectBoxStyles=void 0,t.unthemedSelectBoxStyles={...s.unthemedListStyles,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class A extends V.Widget{constructor(p,w,W,h,d){super(),_.isMacintosh&&!d?.useCustomDrawn?this.selectBoxDelegate=new x.SelectBoxNative(p,w,h,d):this.selectBoxDelegate=new N.SelectBoxList(p,w,W,h,d),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(p,w){this.selectBoxDelegate.setOptions(p,w)}select(p){this.selectBoxDelegate.select(p)}setAriaLabel(p){this.selectBoxDelegate.setAriaLabel(p)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(p){this.selectBoxDelegate.setFocusable(p)}render(p){this.selectBoxDelegate.render(p)}}t.SelectBox=A}),define(ge[73],pe([1,0,17,64,3,29,14,36,140,46,2,5,7,117,62]),function(ie,t,s,N,x,V,_,A,m,p,w,W,h,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class e extends w.Disposable{get action(){return this._action}constructor(g,D,a={}){super(),this.options=a,this._context=g||this,this._action=D,D instanceof p.Action&&this._register(D.onDidChange(f=>{this.element&&this.handleActionChangeEvent(f)}))}handleActionChangeEvent(g){g.enabled!==void 0&&this.updateEnabled(),g.checked!==void 0&&this.updateChecked(),g.class!==void 0&&this.updateClass(),g.label!==void 0&&(this.updateLabel(),this.updateTooltip()),g.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new p.ActionRunner)),this._actionRunner}set actionRunner(g){this._actionRunner=g}isEnabled(){return this._action.enabled}setActionContext(g){this._context=g}render(g){const D=this.element=g;this._register(V.Gesture.addTarget(g));const a=this.options&&this.options.draggable;a&&(g.draggable=!0,s.isFirefox&&this._register((0,x.addDisposableListener)(g,x.EventType.DRAG_START,f=>f.dataTransfer?.setData(N.DataTransfers.TEXT,this._action.label)))),this._register((0,x.addDisposableListener)(D,V.EventType.Tap,f=>this.onClick(f,!0))),this._register((0,x.addDisposableListener)(D,x.EventType.MOUSE_DOWN,f=>{a||x.EventHelper.stop(f,!0),this._action.enabled&&f.button===0&&D.classList.add("active")})),W.isMacintosh&&this._register((0,x.addDisposableListener)(D,x.EventType.CONTEXT_MENU,f=>{f.button===0&&f.ctrlKey===!0&&this.onClick(f)})),this._register((0,x.addDisposableListener)(D,x.EventType.CLICK,f=>{x.EventHelper.stop(f,!0),this.options&&this.options.isMenu||this.onClick(f)})),this._register((0,x.addDisposableListener)(D,x.EventType.DBLCLICK,f=>{x.EventHelper.stop(f,!0)})),[x.EventType.MOUSE_UP,x.EventType.MOUSE_OUT].forEach(f=>{this._register((0,x.addDisposableListener)(D,f,o=>{x.EventHelper.stop(o),D.classList.remove("active")}))})}onClick(g,D=!1){x.EventHelper.stop(g,!0);const a=h.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?g:{preserveFocus:D}:this._context;this.actionRunner.run(this._action,a)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(g){this.element&&(this.element.tabIndex=g?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getClass(){return this.action.class}getTooltip(){return this.action.tooltip}updateTooltip(){if(!this.element)return;const g=this.getTooltip()??"";if(this.updateAriaLabel(),this.options.hoverDelegate?.showNativeHover)this.element.title=g;else if(!this.customHover&&g!==""){const D=this.options.hoverDelegate??(0,_.getDefaultHoverDelegate)("element");this.customHover=this._store.add((0,A.setupCustomHover)(D,this.element,g))}else this.customHover&&this.customHover.update(g)}updateAriaLabel(){if(this.element){const g=this.getTooltip()??"";this.element.setAttribute("aria-label",g)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=e;class i extends e{constructor(g,D,a){super(g,D,a),this.options=a,this.options.icon=a.icon!==void 0?a.icon:!1,this.options.label=a.label!==void 0?a.label:!0,this.cssClass=""}render(g){super.render(g),h.assertType(this.element);const D=document.createElement("a");if(D.classList.add("action-label"),D.setAttribute("role",this.getDefaultAriaRole()),this.label=D,this.element.appendChild(D),this.options.label&&this.options.keybinding){const a=document.createElement("span");a.classList.add("keybinding"),a.textContent=this.options.keybinding,this.element.appendChild(a)}this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}getDefaultAriaRole(){return this._action.id===p.Separator.ID?"presentation":this.options.isMenu?"menuitem":"button"}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(g){this.label&&(this.label.tabIndex=g?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.action.label)}getTooltip(){let g=null;return this.action.tooltip?g=this.action.tooltip:!this.options.label&&this.action.label&&this.options.icon&&(g=this.action.label,this.options.keybinding&&(g=d.localize(0,null,g,this.options.keybinding))),g??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.getClass(),this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.action.enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateAriaLabel(){if(this.label){const g=this.getTooltip()??"";this.label.setAttribute("aria-label",g)}}updateChecked(){this.label&&(this.action.checked!==void 0?(this.label.classList.toggle("checked",this.action.checked),this.label.setAttribute("aria-checked",this.action.checked?"true":"false"),this.label.setAttribute("role","checkbox")):(this.label.classList.remove("checked"),this.label.removeAttribute("aria-checked"),this.label.setAttribute("role",this.getDefaultAriaRole())))}}t.ActionViewItem=i;class r extends e{constructor(g,D,a,f,o,C,F){super(g,D),this.selectBox=new m.SelectBox(a,f,o,C,F),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(g,D){this.selectBox.setOptions(g,D)}select(g){this.selectBox.select(g)}registerListeners(){this._register(this.selectBox.onDidSelect(g=>this.runAction(g.selected,g.index)))}runAction(g,D){this.actionRunner.run(this._action,this.getActionContext(g,D))}getActionContext(g,D){return g}setFocusable(g){this.selectBox.setFocusable(g)}focus(){this.selectBox?.focus()}blur(){this.selectBox?.blur()}render(g){this.selectBox.render(g)}}t.SelectActionViewItem=r}),define(ge[74],pe([1,0,3,15,73,14,46,4,2,7,62]),function(ie,t,s,N,x,V,_,A,m,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ActionBar=t.ActionsOrientation=void 0,t.prepareActions=h;var w;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(w||(t.ActionsOrientation=w={}));class W extends m.Disposable{constructor(e,i={}){super(),this._actionRunnerDisposables=this._register(new m.DisposableStore),this.viewItemDisposables=this._register(new m.DisposableMap),this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new A.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new A.Emitter({onWillAddFirstListener:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new A.Emitter),this.onDidRun=this._onDidRun.event,this._onWillRun=this._register(new A.Emitter),this.onWillRun=this._onWillRun.event,this.options=i,this._context=i.context??null,this._orientation=this.options.orientation??0,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[3,10]},this._hoverDelegate=i.hoverDelegate??this._register((0,V.createInstantHoverDelegate)()),this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new _.ActionRunner,this._actionRunnerDisposables.add(this._actionRunner)),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(g=>this._onDidRun.fire(g))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(g=>this._onWillRun.fire(g))),this.viewItems=[],this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let r,u;switch(this._orientation){case 0:r=[15],u=[17];break;case 1:r=[16],u=[18],this.domNode.className+=" vertical";break}this._register(s.addDisposableListener(this.domNode,s.EventType.KEY_DOWN,g=>{const D=new N.StandardKeyboardEvent(g);let a=!0;const f=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;r&&(D.equals(r[0])||D.equals(r[1]))?a=this.focusPrevious():u&&(D.equals(u[0])||D.equals(u[1]))?a=this.focusNext():D.equals(9)&&this.cancelHasListener?this._onDidCancel.fire():D.equals(14)?a=this.focusFirst():D.equals(13)?a=this.focusLast():D.equals(2)&&f instanceof x.BaseActionViewItem&&f.trapsArrowNavigation?a=this.focusNext():this.isTriggerKeyEvent(D)?this._triggerKeys.keyDown?this.doTrigger(D):this.triggerKeyDown=!0:a=!1,a&&(D.preventDefault(),D.stopPropagation())})),this._register(s.addDisposableListener(this.domNode,s.EventType.KEY_UP,g=>{const D=new N.StandardKeyboardEvent(g);this.isTriggerKeyEvent(D)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(D)),D.preventDefault(),D.stopPropagation()):(D.equals(2)||D.equals(1026)||D.equals(16)||D.equals(18)||D.equals(15)||D.equals(17))&&this.updateFocusedItem()})),this.focusTracker=this._register(s.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(s.getActiveElement()===this.domNode||!s.isAncestor(s.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.previouslyFocusedItem=this.focusedItem,this.focusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.options.highlightToggledItems&&this.actionsList.classList.add("highlight-toggled"),this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),e.appendChild(this.domNode)}refreshRole(){this.length()>=1?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(e){e?this.actionsList.setAttribute("aria-label",e):this.actionsList.removeAttribute("aria-label")}setFocusable(e){if(this.focusable=e,this.focusable){const i=this.viewItems.find(r=>r instanceof x.BaseActionViewItem&&r.isEnabled());i instanceof x.BaseActionViewItem&&i.setFocusable(!0)}else this.viewItems.forEach(i=>{i instanceof x.BaseActionViewItem&&i.setFocusable(!1)})}isTriggerKeyEvent(e){let i=!1;return this._triggerKeys.keys.forEach(r=>{i=i||e.equals(r)}),i}updateFocusedItem(){for(let e=0;e<this.actionsList.children.length;e++){const i=this.actionsList.children[e];if(s.isAncestor(s.getActiveElement(),i)){this.focusedItem=e,this.viewItems[this.focusedItem]?.showHover?.();break}}}get context(){return this._context}set context(e){this._context=e,this.viewItems.forEach(i=>i.setActionContext(e))}get actionRunner(){return this._actionRunner}set actionRunner(e){this._actionRunner=e,this._actionRunnerDisposables.clear(),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(i=>this._onDidRun.fire(i))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(i=>this._onWillRun.fire(i))),this.viewItems.forEach(i=>i.actionRunner=e)}getContainer(){return this.domNode}hasAction(e){return this.viewItems.findIndex(i=>i.action.id===e.id)!==-1}getAction(e){if(typeof e=="number")return this.viewItems[e]?.action;if(e instanceof HTMLElement){for(;e.parentElement!==this.actionsList;){if(!e.parentElement)return;e=e.parentElement}for(let i=0;i<this.actionsList.childNodes.length;i++)if(this.actionsList.childNodes[i]===e)return this.viewItems[i].action}}push(e,i={}){const r=Array.isArray(e)?e:[e];let u=p.isNumber(i.index)?i.index:null;r.forEach(g=>{const D=document.createElement("li");D.className="action-item",D.setAttribute("role","presentation");let a;const f={hoverDelegate:this._hoverDelegate,...i};this.options.actionViewItemProvider&&(a=this.options.actionViewItemProvider(g,f)),a||(a=new x.ActionViewItem(this.context,g,f)),this.options.allowContextMenu||this.viewItemDisposables.set(a,s.addDisposableListener(D,s.EventType.CONTEXT_MENU,o=>{s.EventHelper.stop(o,!0)})),a.actionRunner=this._actionRunner,a.setActionContext(this.context),a.render(D),this.focusable&&a instanceof x.BaseActionViewItem&&this.viewItems.length===0&&a.setFocusable(!0),u===null||u<0||u>=this.actionsList.children.length?(this.actionsList.appendChild(D),this.viewItems.push(a)):(this.actionsList.insertBefore(D,this.actionsList.children[u]),this.viewItems.splice(u,0,a),u++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(e){if(e>=0&&e<this.actionsList.children.length){const i=this.actionsList.children.item(e);if(i)return i.clientWidth}return 0}getHeight(e){if(e>=0&&e<this.actionsList.children.length){const i=this.actionsList.children.item(e);if(i)return i.clientHeight}return 0}pull(e){e>=0&&e<this.viewItems.length&&(this.actionsList.removeChild(this.actionsList.childNodes[e]),this.viewItemDisposables.deleteAndDispose(this.viewItems[e]),(0,m.dispose)(this.viewItems.splice(e,1)),this.refreshRole())}clear(){this.isEmpty()||(this.viewItems=(0,m.dispose)(this.viewItems),this.viewItemDisposables.clearAndDisposeAll(),s.clearNode(this.actionsList),this.refreshRole())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(e){let i=!1,r;if(e===void 0?i=!0:typeof e=="number"?r=e:typeof e=="boolean"&&(i=e),i&&typeof this.focusedItem>"u"){const u=this.viewItems.findIndex(g=>g.isEnabled());this.focusedItem=u===-1?void 0:u,this.updateFocus(void 0,void 0,!0)}else r!==void 0&&(this.focusedItem=r),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(e){if(typeof this.focusedItem>"u")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const i=this.focusedItem;let r;do{if(!e&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=i,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,r=this.viewItems[this.focusedItem]}while(this.focusedItem!==i&&(this.options.focusOnlyEnabledItems&&!r.isEnabled()||r.action.id===_.Separator.ID));return this.updateFocus(),!0}focusPrevious(e){if(typeof this.focusedItem>"u")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const i=this.focusedItem;let r;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!e&&this.options.preventLoopNavigation)return this.focusedItem=i,!1;this.focusedItem=this.viewItems.length-1}r=this.viewItems[this.focusedItem]}while(this.focusedItem!==i&&(this.options.focusOnlyEnabledItems&&!r.isEnabled()||r.action.id===_.Separator.ID));return this.updateFocus(!0),!0}updateFocus(e,i,r=!1){typeof this.focusedItem>"u"&&this.actionsList.focus({preventScroll:i}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const u=this.focusedItem!==void 0?this.viewItems[this.focusedItem]:void 0;if(u){let g=!0;p.isFunction(u.focus)||(g=!1),this.options.focusOnlyEnabledItems&&p.isFunction(u.isEnabled)&&!u.isEnabled()&&(g=!1),u.action.id===_.Separator.ID&&(g=!1),g?(r||this.previouslyFocusedItem!==this.focusedItem)&&(u.focus(e),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:i}),this.previouslyFocusedItem=void 0),g&&u.showHover?.()}}doTrigger(e){if(typeof this.focusedItem>"u")return;const i=this.viewItems[this.focusedItem];if(i instanceof x.BaseActionViewItem){const r=i._context===null||i._context===void 0?e:i._context;this.run(i._action,r)}}async run(e,i){await this._actionRunner.run(e,i)}dispose(){this._context=void 0,this.viewItems=(0,m.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=W;function h(d){if(!d.length)return d;let e=-1;for(let r=0;r<d.length;r++)if(d[r].id!==_.Separator.ID){e=r;break}if(e===-1)return[];d=d.slice(e);for(let r=d.length-1;r>=0&&d[r].id===_.Separator.ID;r--)d.splice(r,1);let i=!1;for(let r=d.length-1;r>=0;r--){const u=d[r].id===_.Separator.ID;u&&!i?d.splice(r,1):u?u&&(i=!1):i=!0}return d}}),define(ge[75],pe([1,0,3,24,65,74,67,14,36,70,21,4,91,61,121,109]),function(ie,t,s,N,x,V,_,A,m,p,w,W,h,d,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0;const i=s.$;var r;(function(D){D[D.INFO=1]="INFO",D[D.WARNING=2]="WARNING",D[D.ERROR=3]="ERROR"})(r||(t.MessageType=r={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class u extends w.Widget{constructor(a,f,o){super(),this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new W.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new W.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=f,this.options=o,this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=s.append(a,i(".monaco-inputbox.idle"));const C=this.options.flexibleHeight?"textarea":"input",F=s.append(this.element,i(".ibwrapper"));if(this.input=s.append(F,i(C+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=s.append(F,i("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new p.ScrollableElement(this.element,{vertical:1}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),s.append(a,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(P=>this.input.scrollTop=P.scrollTop));const R=this._register(new N.DomEmitter(a.ownerDocument,"selectionchange")),B=W.Event.filter(R.event,()=>a.ownerDocument.getSelection()?.anchorNode===F);this._register(B(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this._register(this.ignoreGesture(this.input)),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new V.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(a){this.placeholder=a,this.input.setAttribute("placeholder",a)}setTooltip(a){this.tooltip=a,this.hover?this.hover.update(a):this.hover=this._register((0,m.setupCustomHover)((0,A.getDefaultHoverDelegate)("mouse"),this.input,a))}setAriaLabel(a){this.ariaLabel=a,a?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(a){this.input.value!==a&&(this.input.value=a,this.onValueChange())}get step(){return this.input.step}set step(a){this.input.step=a}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:s.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return s.isActiveElement(this.input)}select(a=null){this.input.select(),a&&(this.input.setSelectionRange(a.start,a.end),a.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}getSelection(){const a=this.input.selectionStart;if(a===null)return null;const f=this.input.selectionEnd??a;return{start:a,end:f}}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(a){a?this.enable():this.disable()}get width(){return s.getTotalWidth(this.input)}set width(a){if(this.options.flexibleHeight&&this.options.flexibleWidth){let f=0;if(this.mirror){const o=parseFloat(this.mirror.style.paddingLeft||"")||0,C=parseFloat(this.mirror.style.paddingRight||"")||0;f=o+C}this.input.style.width=a-f+"px"}else this.input.style.width=a+"px";this.mirror&&(this.mirror.style.width=a+"px")}set paddingRight(a){this.input.style.width=`calc(100% - ${a}px)`,this.mirror&&(this.mirror.style.paddingRight=a+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const a=this.cachedContentHeight,f=this.cachedHeight,o=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:a,height:f}),this.scrollableElement.setScrollPosition({scrollTop:o})}showMessage(a,f){if(this.state==="open"&&(0,d.equals)(this.message,a))return;this.message=a,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(a.type));const o=this.stylesForType(this.message.type);this.element.style.border=`1px solid ${s.asCssValueWithDefault(o.border,"transparent")}`,this.message.content&&(this.hasFocus()||f)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let a=null;return this.validation&&(a=this.validation(this.value),a?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(a)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),a?.type}stylesForType(a){const f=this.options.inputBoxStyles;switch(a){case 1:return{border:f.inputValidationInfoBorder,background:f.inputValidationInfoBackground,foreground:f.inputValidationInfoForeground};case 2:return{border:f.inputValidationWarningBorder,background:f.inputValidationWarningBackground,foreground:f.inputValidationWarningForeground};default:return{border:f.inputValidationErrorBorder,background:f.inputValidationErrorBackground,foreground:f.inputValidationErrorForeground}}}classForType(a){switch(a){case 1:return"info";case 2:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let a;const f=()=>a.style.width=s.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:C=>{if(!this.message)return null;a=s.append(C,i(".monaco-inputbox-container")),f();const F={inline:!0,className:"monaco-inputbox-message"},R=this.message.formatContent?(0,x.renderFormattedText)(this.message.content,F):(0,x.renderText)(this.message.content,F);R.classList.add(this.classForType(this.message.type));const B=this.stylesForType(this.message.type);return R.style.backgroundColor=B.background??"",R.style.color=B.foreground??"",R.style.border=B.border?`1px solid ${B.border}`:"",s.append(a,R),null},onHide:()=>{this.state="closed"},layout:f});let o;this.message.type===3?o=e.localize(0,null,this.message.content):this.message.type===2?o=e.localize(1,null,this.message.content):o=e.localize(2,null,this.message.content),_.alert(o),this.state="open"}_hideMessage(){this.contextViewProvider&&(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const a=this.value,o=a.charCodeAt(a.length-1)===10?" ":"";(a+o).replace(/\u000c/g,"")?this.mirror.textContent=a+o:this.mirror.innerText="\xA0",this.layout()}applyStyles(){const a=this.options.inputBoxStyles,f=a.inputBackground??"",o=a.inputForeground??"",C=a.inputBorder??"";this.element.style.backgroundColor=f,this.element.style.color=o,this.input.style.backgroundColor="inherit",this.input.style.color=o,this.element.style.border=`1px solid ${s.asCssValueWithDefault(C,"transparent")}`}layout(){if(!this.mirror)return;const a=this.cachedContentHeight;this.cachedContentHeight=s.getTotalHeight(this.mirror),a!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(a){const f=this.inputElement,o=f.selectionStart,C=f.selectionEnd,F=f.value;o!==null&&C!==null&&(this.value=F.substr(0,o)+a+F.substr(C),f.setSelectionRange(o+1,o+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar?.dispose(),super.dispose()}}t.InputBox=u;class g extends u{constructor(a,f,o){const C=e.localize(3,null,"\u21C5"),F=e.localize(4,null,"\u21C5");super(a,f,o),this._onDidFocus=this._register(new W.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new W.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new h.HistoryNavigator(o.history,100);const R=()=>{if(o.showHistoryHint&&o.showHistoryHint()&&!this.placeholder.endsWith(C)&&!this.placeholder.endsWith(F)&&this.history.getHistory().length){const B=this.placeholder.endsWith(")")?C:F,P=this.placeholder+B;o.showPlaceholderOnFocus&&!s.isActiveElement(this.input)?this.placeholder=P:this.setPlaceHolder(P)}};this.observer=new MutationObserver((B,P)=>{B.forEach(b=>{b.target.textContent||R()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>R()),this.onblur(this.input,()=>{const B=P=>{if(this.placeholder.endsWith(P)){const b=this.placeholder.slice(0,this.placeholder.length-P.length);return o.showPlaceholderOnFocus?this.placeholder=b:this.setPlaceHolder(b),!0}else return!1};B(F)||B(C)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(a){this.value&&(a||this.value!==this.getCurrentValue())&&this.history.add(this.value)}prependHistory(a){const f=this.getHistory();this.clearHistory(),a.forEach(o=>{this.history.add(o)}),f.forEach(o=>{this.history.add(o)})}getHistory(){return this.history.getHistory()}isAtFirstInHistory(){return this.history.isFirst()}isAtLastInHistory(){return this.history.isLast()}isNowhereInHistory(){return this.history.isNowhere()}showNextValue(){this.history.has(this.value)||this.addToHistory();let a=this.getNextValue();a&&(a=a===this.value?this.getNextValue():a),this.value=a??"",_.status(this.value?this.value:e.localize(5,null))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let a=this.getPreviousValue();a&&(a=a===this.value?this.getPreviousValue():a),a&&(this.value=a,_.status(this.value))}clearHistory(){this.history.clear()}setPlaceHolder(a){super.setPlaceHolder(a),this.setTooltip(a)}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let a=this.history.current();return a||(a=this.history.last(),this.history.next()),a}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()}}t.HistoryInputBox=g}),define(ge[76],pe([1,0,73,21,18,19,4,3,36,14,114]),function(ie,t,s,N,x,V,_,A,m,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CheckboxActionViewItem=t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class w extends s.BaseActionViewItem{constructor(i,r,u){super(i,r,u),this.toggle=this._register(new W({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:u.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:u.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:u.toggleStyles?.inputActiveOptionForeground,hoverDelegate:u.hoverDelegate})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(i){this.element=i,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(i){this.toggle.domNode.tabIndex=i?0:-1}}t.ToggleActionViewItem=w;class W extends N.Widget{constructor(i){super(),this._onChange=this._register(new _.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new _.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts=i,this._checked=this._opts.isChecked;const r=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,r.push(...V.ThemeIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&r.push(...this._opts.actionClassName.split(" ")),this._checked&&r.push("checked"),this.domNode=document.createElement("div"),this._hover=this._register((0,m.setupCustomHover)(i.hoverDelegate??(0,p.getDefaultHoverDelegate)("mouse"),this.domNode,this._opts.title)),this.domNode.classList.add(...r),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,u=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),u.preventDefault())}),this._register(this.ignoreGesture(this.domNode)),this.onkeydown(this.domNode,u=>{if(u.keyCode===10||u.keyCode===3){this.checked=!this._checked,this._onChange.fire(!0),u.preventDefault(),u.stopPropagation();return}this._onKeyDown.fire(u)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(i){this._checked=i,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(i){this._icon&&this.domNode.classList.remove(...V.ThemeIcon.asClassNameArray(this._icon)),this._icon=i,this._icon&&this.domNode.classList.add(...V.ThemeIcon.asClassNameArray(this._icon))}width(){return 22}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder||"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(i){this._hover.update(i),this.domNode.setAttribute("aria-label",i)}}t.Toggle=W;class h extends N.Widget{constructor(i,r,u){super(),this.title=i,this.isChecked=r,this._onChange=this._register(new _.Emitter),this.onChange=this._onChange.event,this.checkbox=this._register(new W({title:this.title,isChecked:this.isChecked,icon:x.Codicon.check,actionClassName:"monaco-checkbox",...t.unthemedToggleStyles})),this.domNode=this.checkbox.domNode,this.styles=u,this.applyStyles(),this._register(this.checkbox.onChange(g=>{this.applyStyles(),this._onChange.fire(g)}))}get checked(){return this.checkbox.checked}set checked(i){this.checkbox.checked=i,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return(0,A.isActiveElement)(this.domNode)}enable(){this.checkbox.enable()}disable(){this.checkbox.disable()}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground||"",this.domNode.style.backgroundColor=this.styles.checkboxBackground||"",this.domNode.style.borderColor=this.styles.checkboxBorder||""}}t.Checkbox=h;class d extends s.BaseActionViewItem{constructor(i,r,u){super(i,r,u),this.toggle=this._register(new h(this._action.label,!!this._action.checked,u.checkboxStyles)),this._register(this.toggle.onChange(()=>this.onChange()))}render(i){if(this.element=i,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.toggle.domNode),this.options.label&&this._action.label){const r=this.element.appendChild((0,A.$)("span.checkbox-label",void 0,this._action.label));this._register((0,A.addDisposableListener)(r,A.EventType.CLICK,u=>{this.toggle.checked=!this.toggle.checked,u.stopPropagation(),u.preventDefault(),this.onChange()}))}this.updateEnabled(),this.updateClass(),this.updateChecked()}onChange(){this._action.checked=!!this.toggle&&this.toggle.checked,this.actionRunner.run(this._action,this._context)}updateEnabled(){this.isEnabled()?this.toggle.enable():this.toggle.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}updateChecked(){this.toggle.checked=!!this._action.checked}updateClass(){this.cssClass&&this.toggle.domNode.classList.remove(...this.cssClass.split(" ")),this.cssClass=this.getClass(),this.cssClass&&this.toggle.domNode.classList.add(...this.cssClass.split(" "))}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(i){this.toggle.domNode.tabIndex=i?0:-1}}t.CheckboxActionViewItem=d}),define(ge[141],pe([1,0,14,76,18,119]),function(ie,t,s,N,x,V){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const _=V.localize(0,null),A=V.localize(1,null),m=V.localize(2,null);class p extends N.Toggle{constructor(d){super({icon:x.Codicon.caseSensitive,title:_+d.appendTitle,isChecked:d.isChecked,hoverDelegate:d.hoverDelegate??(0,s.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.CaseSensitiveToggle=p;class w extends N.Toggle{constructor(d){super({icon:x.Codicon.wholeWord,title:A+d.appendTitle,isChecked:d.isChecked,hoverDelegate:d.hoverDelegate??(0,s.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.WholeWordsToggle=w;class W extends N.Toggle{constructor(d){super({icon:x.Codicon.regex,title:m+d.appendTitle,isChecked:d.isChecked,hoverDelegate:d.hoverDelegate??(0,s.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.RegexToggle=W}),define(ge[142],pe([1,0,3,141,75,21,4,118,2,14,108]),function(ie,t,s,N,x,V,_,A,m,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const w=A.localize(0,null);class W extends V.Widget{static{this.OPTION_CHANGE="optionChange"}constructor(d,e,i){super(),this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalTogglesDisposables=this._register(new m.MutableDisposable),this.additionalToggles=[],this._onDidOptionChange=this._register(new _.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new _.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new _.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new _.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new _.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new _.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new _.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.placeholder=i.placeholder||"",this.validation=i.validation,this.label=i.label||w,this.showCommonFindToggles=!!i.showCommonFindToggles;const r=i.appendCaseSensitiveLabel||"",u=i.appendWholeWordsLabel||"",g=i.appendRegexLabel||"",D=i.history||[],a=!!i.flexibleHeight,f=!!i.flexibleWidth,o=i.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new x.HistoryInputBox(this.domNode,e,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},history:D,showHistoryHint:i.showHistoryHint,flexibleHeight:a,flexibleWidth:f,flexibleMaxHeight:o,inputBoxStyles:i.inputBoxStyles}));const C=this._register((0,p.createInstantHoverDelegate)());if(this.showCommonFindToggles){this.regex=this._register(new N.RegexToggle({appendTitle:g,isChecked:!1,hoverDelegate:C,...i.toggleStyles})),this._register(this.regex.onChange(R=>{this._onDidOptionChange.fire(R),!R&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(R=>{this._onRegexKeyDown.fire(R)})),this.wholeWords=this._register(new N.WholeWordsToggle({appendTitle:u,isChecked:!1,hoverDelegate:C,...i.toggleStyles})),this._register(this.wholeWords.onChange(R=>{this._onDidOptionChange.fire(R),!R&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new N.CaseSensitiveToggle({appendTitle:r,isChecked:!1,hoverDelegate:C,...i.toggleStyles})),this._register(this.caseSensitive.onChange(R=>{this._onDidOptionChange.fire(R),!R&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(R=>{this._onCaseSensitiveKeyDown.fire(R)}));const F=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,R=>{if(R.equals(15)||R.equals(17)||R.equals(9)){const B=F.indexOf(this.domNode.ownerDocument.activeElement);if(B>=0){let P=-1;R.equals(17)?P=(B+1)%F.length:R.equals(15)&&(B===0?P=F.length-1:P=B-1),R.equals(9)?(F[B].blur(),this.inputBox.focus()):P>=0&&F[P].focus(),s.EventHelper.stop(R,!0)}}})}this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this.showCommonFindToggles?"":"none",this.caseSensitive&&this.controls.append(this.caseSensitive.domNode),this.wholeWords&&this.controls.appendChild(this.wholeWords.domNode),this.regex&&this.controls.appendChild(this.regex.domNode),this.setAdditionalToggles(i?.additionalToggles),this.controls&&this.domNode.appendChild(this.controls),d?.appendChild(this.domNode),this._register(s.addDisposableListener(this.inputBox.inputElement,"compositionstart",F=>{this.imeSessionInProgress=!0})),this._register(s.addDisposableListener(this.inputBox.inputElement,"compositionend",F=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,F=>this._onKeyDown.fire(F)),this.onkeyup(this.inputBox.inputElement,F=>this._onKeyUp.fire(F)),this.oninput(this.inputBox.inputElement,F=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,F=>this._onMouseDown.fire(F))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}layout(d){this.inputBox.layout(),this.updateInputBoxPadding(d.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex?.enable(),this.wholeWords?.enable(),this.caseSensitive?.enable();for(const d of this.additionalToggles)d.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex?.disable(),this.wholeWords?.disable(),this.caseSensitive?.disable();for(const d of this.additionalToggles)d.disable()}setFocusInputOnOptionClick(d){this.fixFocusOnOptionClickEnabled=d}setEnabled(d){d?this.enable():this.disable()}setAdditionalToggles(d){for(const e of this.additionalToggles)e.domNode.remove();this.additionalToggles=[],this.additionalTogglesDisposables.value=new m.DisposableStore;for(const e of d??[])this.additionalTogglesDisposables.value.add(e),this.controls.appendChild(e.domNode),this.additionalTogglesDisposables.value.add(e.onChange(i=>{this._onDidOptionChange.fire(i),!i&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(e);this.additionalToggles.length>0&&(this.controls.style.display=""),this.updateInputBoxPadding()}updateInputBoxPadding(d=!1){d?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.caseSensitive?.width()??0)+(this.wholeWords?.width()??0)+(this.regex?.width()??0)+this.additionalToggles.reduce((e,i)=>e+i.width(),0)}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(d){this.inputBox.value!==d&&(this.inputBox.value=d)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive?.checked??!1}setCaseSensitive(d){this.caseSensitive&&(this.caseSensitive.checked=d)}getWholeWords(){return this.wholeWords?.checked??!1}setWholeWords(d){this.wholeWords&&(this.wholeWords.checked=d)}getRegex(){return this.regex?.checked??!1}setRegex(d){this.regex&&(this.regex.checked=d,this.validate())}focusOnCaseSensitive(){this.caseSensitive?.focus()}focusOnRegex(){this.regex?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(d){this.inputBox.showMessage(d)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}t.FindInput=W}),define(ge[143],pe([1,0,3,24,15,74,142,75,71,49,76,68,30,46,12,9,18,19,38,4,43,2,39,7,123,14,57,115]),function(ie,t,s,N,x,V,_,A,m,p,w,W,h,d,e,i,r,u,g,D,a,f,o,C,F,R,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.FuzzyToggle=t.ModeToggle=t.TreeRenderer=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class P extends m.ElementsDragAndDropData{set context(n){this.data.context=n}get context(){return this.data.context}constructor(n){super(n.elements.map(S=>S.element)),this.data=n}}function b(T){return T instanceof m.ElementsDragAndDropData?new P(T):T}class O{constructor(n,S){this.modelProvider=n,this.dnd=S,this.autoExpandDisposable=f.Disposable.None,this.disposables=new f.DisposableStore}getDragURI(n){return this.dnd.getDragURI(n.element)}getDragLabel(n,S){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(n.map(y=>y.element),S)}onDragStart(n,S){this.dnd.onDragStart?.(b(n),S)}onDragOver(n,S,y,L,z,Y=!0){const Q=this.dnd.onDragOver(b(n),S&&S.element,y,L,z),oe=this.autoExpandNode!==S;if(oe&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=S),typeof S>"u")return Q;if(oe&&typeof Q!="boolean"&&Q.autoExpand&&(this.autoExpandDisposable=(0,i.disposableTimeout)(()=>{const Me=this.modelProvider(),Se=Me.getNodeLocation(S);Me.isCollapsed(Se)&&Me.setCollapsed(Se,!1),this.autoExpandNode=void 0},500,this.disposables)),typeof Q=="boolean"||!Q.accept||typeof Q.bubble>"u"||Q.feedback){if(!Y){const Me=typeof Q=="boolean"?Q:Q.accept,Se=typeof Q=="boolean"?void 0:Q.effect;return{accept:Me,effect:Se,feedback:[y]}}return Q}if(Q.bubble===1){const Me=this.modelProvider(),Se=Me.getNodeLocation(S),Te=Me.getParentNodeLocation(Se),Ve=Me.getNode(Te),Qe=Te&&Me.getListIndex(Te);return this.onDragOver(n,Ve,Qe,L,z,!1)}const De=this.modelProvider(),me=De.getNodeLocation(S),ke=De.getListIndex(me),Ae=De.getListRenderCount(me);return{...Q,feedback:(0,e.range)(ke,ke+Ae)}}drop(n,S,y,L,z){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(b(n),S&&S.element,y,L,z)}onDragEnd(n){this.dnd.onDragEnd?.(n)}dispose(){this.disposables.dispose(),this.dnd.dispose()}}function $(T,n){return n&&{...n,identityProvider:n.identityProvider&&{getId(S){return n.identityProvider.getId(S.element)}},dnd:n.dnd&&new O(T,n.dnd),multipleSelectionController:n.multipleSelectionController&&{isSelectionSingleChangeEvent(S){return n.multipleSelectionController.isSelectionSingleChangeEvent({...S,element:S.element})},isSelectionRangeChangeEvent(S){return n.multipleSelectionController.isSelectionRangeChangeEvent({...S,element:S.element})}},accessibilityProvider:n.accessibilityProvider&&{...n.accessibilityProvider,getSetSize(S){const y=T(),L=y.getNodeLocation(S),z=y.getParentNodeLocation(L);return y.getNode(z).visibleChildrenCount},getPosInSet(S){return S.visibleChildIndex+1},isChecked:n.accessibilityProvider&&n.accessibilityProvider.isChecked?S=>n.accessibilityProvider.isChecked(S.element):void 0,getRole:n.accessibilityProvider&&n.accessibilityProvider.getRole?S=>n.accessibilityProvider.getRole(S.element):()=>"treeitem",getAriaLabel(S){return n.accessibilityProvider.getAriaLabel(S.element)},getWidgetAriaLabel(){return n.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:n.accessibilityProvider&&n.accessibilityProvider.getWidgetRole?()=>n.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:n.accessibilityProvider&&n.accessibilityProvider.getAriaLevel?S=>n.accessibilityProvider.getAriaLevel(S.element):S=>S.depth,getActiveDescendantId:n.accessibilityProvider.getActiveDescendantId&&(S=>n.accessibilityProvider.getActiveDescendantId(S.element))},keyboardNavigationLabelProvider:n.keyboardNavigationLabelProvider&&{...n.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(S){return n.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(S.element)}}}}class k{constructor(n){this.delegate=n}getHeight(n){return this.delegate.getHeight(n.element)}getTemplateId(n){return this.delegate.getTemplateId(n.element)}hasDynamicHeight(n){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(n.element)}setDynamicHeight(n,S){this.delegate.setDynamicHeight?.(n.element,S)}}t.ComposedTreeDelegate=k;class M{static lift(n){return n instanceof M?n:new M(n)}static empty(n=0){return new M({focus:[],selection:[],expanded:Object.create(null),scrollTop:n})}constructor(n){if(this.focus=new Set(n.focus),this.selection=new Set(n.selection),n.expanded instanceof Array){this.expanded=Object.create(null);for(const S of n.expanded)this.expanded[S]=1}else this.expanded=n.expanded;this.expanded=n.expanded,this.scrollTop=n.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=M;var I;(function(T){T.None="none",T.OnHover="onHover",T.Always="always"})(I||(t.RenderIndentGuides=I={}));class q{get elements(){return this._elements}constructor(n,S=[]){this._elements=S,this.disposables=new f.DisposableStore,this.onDidChange=D.Event.forEach(n,y=>this._elements=y,this.disposables)}dispose(){this.disposables.dispose()}}class X{static{this.DefaultIndent=8}constructor(n,S,y,L,z,Y={}){this.renderer=n,this.modelProvider=S,this.activeNodes=L,this.renderedIndentGuides=z,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=X.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.activeIndentNodes=new Set,this.indentGuidesDisposable=f.Disposable.None,this.disposables=new f.DisposableStore,this.templateId=n.templateId,this.updateOptions(Y),D.Event.map(y,Q=>Q.node)(this.onDidChangeNodeTwistieState,this,this.disposables),n.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(n={}){if(typeof n.indent<"u"){const S=(0,o.clamp)(n.indent,0,40);if(S!==this.indent){this.indent=S;for(const[y,L]of this.renderedNodes)this.renderTreeElement(y,L)}}if(typeof n.renderIndentGuides<"u"){const S=n.renderIndentGuides!==I.None;if(S!==this.shouldRenderIndentGuides){this.shouldRenderIndentGuides=S;for(const[y,L]of this.renderedNodes)this._renderIndentGuides(y,L);if(this.indentGuidesDisposable.dispose(),S){const y=new f.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,y),this.indentGuidesDisposable=y,this._onDidChangeActiveNodes(this.activeNodes.elements)}}}typeof n.hideTwistiesOfChildlessElements<"u"&&(this.hideTwistiesOfChildlessElements=n.hideTwistiesOfChildlessElements)}renderTemplate(n){const S=(0,s.append)(n,(0,s.$)(".monaco-tl-row")),y=(0,s.append)(S,(0,s.$)(".monaco-tl-indent")),L=(0,s.append)(S,(0,s.$)(".monaco-tl-twistie")),z=(0,s.append)(S,(0,s.$)(".monaco-tl-contents")),Y=this.renderer.renderTemplate(z);return{container:n,indent:y,twistie:L,indentGuidesDisposable:f.Disposable.None,templateData:Y}}renderElement(n,S,y,L){this.renderedNodes.set(n,y),this.renderedElements.set(n.element,n),this.renderTreeElement(n,y),this.renderer.renderElement(n,S,y.templateData,L)}disposeElement(n,S,y,L){y.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(n,S,y.templateData,L),typeof L=="number"&&(this.renderedNodes.delete(n),this.renderedElements.delete(n.element))}disposeTemplate(n){this.renderer.disposeTemplate(n.templateData)}onDidChangeTwistieState(n){const S=this.renderedElements.get(n);S&&this.onDidChangeNodeTwistieState(S)}onDidChangeNodeTwistieState(n){const S=this.renderedNodes.get(n);S&&(this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderTreeElement(n,S))}renderTreeElement(n,S){const y=X.DefaultIndent+(n.depth-1)*this.indent;S.twistie.style.paddingLeft=`${y}px`,S.indent.style.width=`${y+this.indent-16}px`,n.collapsible?S.container.setAttribute("aria-expanded",String(!n.collapsed)):S.container.removeAttribute("aria-expanded"),S.twistie.classList.remove(...u.ThemeIcon.asClassNameArray(r.Codicon.treeItemExpanded));let L=!1;this.renderer.renderTwistie&&(L=this.renderer.renderTwistie(n.element,S.twistie)),n.collapsible&&(!this.hideTwistiesOfChildlessElements||n.visibleChildrenCount>0)?(L||S.twistie.classList.add(...u.ThemeIcon.asClassNameArray(r.Codicon.treeItemExpanded)),S.twistie.classList.add("collapsible"),S.twistie.classList.toggle("collapsed",n.collapsed)):S.twistie.classList.remove("collapsible","collapsed"),this._renderIndentGuides(n,S)}_renderIndentGuides(n,S){if((0,s.clearNode)(S.indent),S.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const y=new f.DisposableStore,L=this.modelProvider();for(;;){const z=L.getNodeLocation(n),Y=L.getParentNodeLocation(z);if(!Y)break;const Q=L.getNode(Y),oe=(0,s.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(Q)&&oe.classList.add("active"),S.indent.childElementCount===0?S.indent.appendChild(oe):S.indent.insertBefore(oe,S.indent.firstElementChild),this.renderedIndentGuides.add(Q,oe),y.add((0,f.toDisposable)(()=>this.renderedIndentGuides.delete(Q,oe))),n=Q}S.indentGuidesDisposable=y}_onDidChangeActiveNodes(n){if(!this.shouldRenderIndentGuides)return;const S=new Set,y=this.modelProvider();n.forEach(L=>{const z=y.getNodeLocation(L);try{const Y=y.getParentNodeLocation(z);L.collapsible&&L.children.length>0&&!L.collapsed?S.add(L):Y&&S.add(y.getNode(Y))}catch{}}),this.activeIndentNodes.forEach(L=>{S.has(L)||this.renderedIndentGuides.forEach(L,z=>z.classList.remove("active"))}),S.forEach(L=>{this.activeIndentNodes.has(L)||this.renderedIndentGuides.forEach(L,z=>z.classList.add("active"))}),this.activeIndentNodes=S}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,f.dispose)(this.disposables)}}t.TreeRenderer=X;class ce{get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(n){this._pattern=n,this._lowercasePattern=n.toLowerCase()}constructor(n,S,y){this.tree=n,this.keyboardNavigationLabelProvider=S,this._filter=y,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new f.DisposableStore,n.onWillRefilter(this.reset,this,this.disposables)}filter(n,S){let y=1;if(this._filter){const Y=this._filter.filter(n,S);if(typeof Y=="boolean"?y=Y?1:0:(0,W.isFilterResult)(Y)?y=(0,W.getVisibleState)(Y.visibility):y=Y,y===0)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:a.FuzzyScore.Default,visibility:y};const L=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(n),z=Array.isArray(L)?L:[L];for(const Y of z){const Q=Y&&Y.toString();if(typeof Q>"u")return{data:a.FuzzyScore.Default,visibility:y};let oe;if(this.tree.findMatchType===Ie.Contiguous){const De=Q.toLowerCase().indexOf(this._lowercasePattern);if(De>-1){oe=[Number.MAX_SAFE_INTEGER,0];for(let me=this._lowercasePattern.length;me>0;me--)oe.push(De+me-1)}}else oe=(0,a.fuzzyScore)(this._pattern,this._lowercasePattern,0,Q,Q.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return this._matchCount++,z.length===1?{data:oe,visibility:y}:{data:{label:Q,score:oe},visibility:y}}return this.tree.findMode===Ee.Filter?typeof this.tree.options.defaultFindVisibility=="number"?this.tree.options.defaultFindVisibility:this.tree.options.defaultFindVisibility?this.tree.options.defaultFindVisibility(n):2:{data:a.FuzzyScore.Default,visibility:y}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,f.dispose)(this.disposables)}}class re extends w.Toggle{constructor(n){super({icon:r.Codicon.listFilter,title:(0,F.localize)(0,null),isChecked:n.isChecked??!1,hoverDelegate:n.hoverDelegate??(0,R.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}t.ModeToggle=re;class te extends w.Toggle{constructor(n){super({icon:r.Codicon.searchFuzzy,title:(0,F.localize)(1,null),isChecked:n.isChecked??!1,hoverDelegate:n.hoverDelegate??(0,R.getDefaultHoverDelegate)("element"),inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}t.FuzzyToggle=te;const be={inputBoxStyles:A.unthemedInboxStyles,toggleStyles:w.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var Ee;(function(T){T[T.Highlight=0]="Highlight",T[T.Filter=1]="Filter"})(Ee||(t.TreeFindMode=Ee={}));var Ie;(function(T){T[T.Fuzzy=0]="Fuzzy",T[T.Contiguous=1]="Contiguous"})(Ie||(t.TreeFindMatchType=Ie={}));class Be extends f.Disposable{set mode(n){this.modeToggle.checked=n===Ee.Filter,this.findInput.inputBox.setPlaceHolder(n===Ee.Filter?(0,F.localize)(2,null):(0,F.localize)(3,null))}set matchType(n){this.matchTypeToggle.checked=n===Ie.Fuzzy}get value(){return this.findInput.inputBox.value}set value(n){this.findInput.inputBox.value=n}constructor(n,S,y,L,z,Y){super(),this.tree=S,this.elements=(0,s.h)(".monaco-tree-type-filter",[(0,s.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,s.h)(".monaco-tree-type-filter-input@findInput"),(0,s.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=0,this.top=0,this._onDidDisable=new D.Emitter,this.onDidDisable=this._onDidDisable.event,n.appendChild(this.elements.root),this._register((0,f.toDisposable)(()=>n.removeChild(this.elements.root)));const Q=Y?.styles??be;Q.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=Q.listFilterWidgetBackground),Q.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${Q.listFilterWidgetShadow}`);const oe=this._register((0,R.createInstantHoverDelegate)());this.modeToggle=this._register(new re({...Q.toggleStyles,isChecked:L===Ee.Filter,hoverDelegate:oe})),this.matchTypeToggle=this._register(new te({...Q.toggleStyles,isChecked:z===Ie.Fuzzy,hoverDelegate:oe})),this.onDidChangeMode=D.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?Ee.Filter:Ee.Highlight,this._store),this.onDidChangeMatchType=D.Event.map(this.matchTypeToggle.onChange,()=>this.matchTypeToggle.checked?Ie.Fuzzy:Ie.Contiguous,this._store),this.findInput=this._register(new _.FindInput(this.elements.findInput,y,{label:(0,F.localize)(4,null),additionalToggles:[this.modeToggle,this.matchTypeToggle],showCommonFindToggles:!1,inputBoxStyles:Q.inputBoxStyles,toggleStyles:Q.toggleStyles,history:Y?.history})),this.actionbar=this._register(new V.ActionBar(this.elements.actionbar)),this.mode=L;const De=this._register(new N.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),me=D.Event.chain(De.event,Se=>Se.map(Te=>new x.StandardKeyboardEvent(Te)));this._register(me(Se=>{if(Se.equals(3)){Se.preventDefault(),Se.stopPropagation(),this.findInput.inputBox.addToHistory(),this.tree.domFocus();return}if(Se.equals(18)){Se.preventDefault(),Se.stopPropagation(),this.findInput.inputBox.isAtLastInHistory()||this.findInput.inputBox.isNowhereInHistory()?(this.findInput.inputBox.addToHistory(),this.tree.domFocus()):this.findInput.inputBox.showNextValue();return}if(Se.equals(16)){Se.preventDefault(),Se.stopPropagation(),this.findInput.inputBox.showPreviousValue();return}}));const ke=this._register(new d.Action("close",(0,F.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(ke,{icon:!0,label:!1});const Ae=this._register(new N.DomEmitter(this.elements.grab,"mousedown"));this._register(Ae.event(Se=>{const Te=new f.DisposableStore,Ve=Te.add(new N.DomEmitter((0,s.getWindow)(Se),"mousemove")),Qe=Te.add(new N.DomEmitter((0,s.getWindow)(Se),"mouseup")),Ue=this.right,Je=Se.pageX,U=this.top,se=Se.pageY;this.elements.grab.classList.add("grabbing");const ve=this.elements.root.style.transition;this.elements.root.style.transition="unset";const ye=Le=>{const He=Le.pageX-Je;this.right=Ue-He;const $e=Le.pageY-se;this.top=U+$e,this.layout()};Te.add(Ve.event(ye)),Te.add(Qe.event(Le=>{ye(Le),this.elements.grab.classList.remove("grabbing"),this.elements.root.style.transition=ve,Te.dispose()}))}));const Me=D.Event.chain(this._register(new N.DomEmitter(this.elements.grab,"keydown")).event,Se=>Se.map(Te=>new x.StandardKeyboardEvent(Te)));this._register(Me(Se=>{let Te,Ve;if(Se.keyCode===15?Te=Number.POSITIVE_INFINITY:Se.keyCode===17?Te=0:Se.keyCode===10&&(Te=this.right===0?Number.POSITIVE_INFINITY:0),Se.keyCode===16?Ve=0:Se.keyCode===18&&(Ve=Number.POSITIVE_INFINITY),Te!==void 0&&(Se.preventDefault(),Se.stopPropagation(),this.right=Te,this.layout()),Ve!==void 0){Se.preventDefault(),Se.stopPropagation(),this.top=Ve;const Qe=this.elements.root.style.transition;this.elements.root.style.transition="unset",this.layout(),setTimeout(()=>{this.elements.root.style.transition=Qe},0)}})),this.onDidChangeValue=this.findInput.onDidChange}getHistory(){return this.findInput.inputBox.getHistory()}focus(){this.findInput.focus()}select(){this.findInput.select(),this.findInput.inputBox.addToHistory(!0)}layout(n=this.width){this.width=n,this.right=(0,o.clamp)(this.right,0,Math.max(0,n-212)),this.elements.root.style.right=`${this.right}px`,this.top=(0,o.clamp)(this.top,0,24),this.elements.root.style.top=`${this.top}px`}showMessage(n){this.findInput.showMessage(n)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,i.timeout)(300),super.dispose()}}class ue{get pattern(){return this._pattern}get mode(){return this._mode}set mode(n){n!==this._mode&&(this._mode=n,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(n))}get matchType(){return this._matchType}set matchType(n){n!==this._matchType&&(this._matchType=n,this.widget&&(this.widget.matchType=this._matchType),this.tree.refilter(),this.render(),this._onDidChangeMatchType.fire(n))}constructor(n,S,y,L,z,Y={}){this.tree=n,this.view=y,this.filter=L,this.contextViewProvider=z,this.options=Y,this._pattern="",this.previousPattern="",this.width=0,this._onDidChangeMode=new D.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangeMatchType=new D.Emitter,this.onDidChangeMatchType=this._onDidChangeMatchType.event,this._onDidChangePattern=new D.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new D.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new f.DisposableStore,this.disposables=new f.DisposableStore,this._mode=n.options.defaultFindMode??Ee.Highlight,this._matchType=n.options.defaultFindMatchType??Ie.Fuzzy,S.onDidSplice(this.onDidSpliceModel,this,this.disposables)}updateOptions(n={}){n.defaultFindMode!==void 0&&(this.mode=n.defaultFindMode),n.defaultFindMatchType!==void 0&&(this.matchType=n.defaultFindMatchType)}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.widget=new Be(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this.mode,this.matchType,{...this.options,history:this._history}),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(n=>this.mode=n,void 0,this.enabledDisposables),this.widget.onDidChangeMatchType(n=>this.matchType=n,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this.widget.value=this.previousPattern,this.widget.select(),this._onDidChangeOpenState.fire(!0)}close(){this.widget&&(this._history=this.widget.getHistory(),this.widget=void 0,this.enabledDisposables.clear(),this.previousPattern=this.pattern,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(n){this._pattern=n,this._onDidChangePattern.fire(n),this.filter.pattern=n,this.tree.refilter(),n&&this.tree.focusNext(0,!0,void 0,y=>!a.FuzzyScore.isDefault(y.filterData));const S=this.tree.getFocus();if(S.length>0){const y=S[0];this.tree.getRelativeTop(y)===null&&this.tree.reveal(y,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const n=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&n?this.tree.options.showNotFoundMessage??!0?this.widget?.showMessage({type:2,content:(0,F.localize)(6,null)}):this.widget?.showMessage({type:2}):this.widget?.clearMessage()}shouldAllowFocus(n){return!this.widget||!this.pattern||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!a.FuzzyScore.isDefault(n.filterData)}layout(n){this.width=n,this.widget?.layout(n)}dispose(){this._history=void 0,this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function J(T,n){return T.position===n.position&&le(T,n)}function le(T,n){return T.node.element===n.node.element&&T.startIndex===n.startIndex&&T.height===n.height&&T.endIndex===n.endIndex}class ae{constructor(n=[]){this.stickyNodes=n}get count(){return this.stickyNodes.length}equal(n){return(0,e.equals)(this.stickyNodes,n.stickyNodes,J)}lastNodePartiallyVisible(){if(this.count===0)return!1;const n=this.stickyNodes[this.count-1];if(this.count===1)return n.position!==0;const S=this.stickyNodes[this.count-2];return S.position+S.height!==n.position}animationStateChanged(n){if(!(0,e.equals)(this.stickyNodes,n.stickyNodes,le)||this.count===0)return!1;const S=this.stickyNodes[this.count-1],y=n.stickyNodes[n.count-1];return S.position!==y.position}}class Z{constrainStickyScrollNodes(n,S,y){for(let L=0;L<n.length;L++){const z=n[L];if(z.position+z.height>y||L>=S)return n.slice(0,L)}return n}}class G extends f.Disposable{constructor(n,S,y,L,z,Y={}){super(),this.tree=n,this.model=S,this.view=y,this.treeDelegate=z,this.maxWidgetViewRatio=.4;const Q=this.validateStickySettings(Y);this.stickyScrollMaxItemCount=Q.stickyScrollMaxItemCount,this.stickyScrollDelegate=Y.stickyScrollDelegate??new Z,this._widget=this._register(new ne(y.getScrollableElement(),y,n,L,z,Y.accessibilityProvider)),this.onDidChangeHasFocus=this._widget.onDidChangeHasFocus,this.onContextMenu=this._widget.onContextMenu,this._register(y.onDidScroll(()=>this.update())),this._register(y.onDidChangeContentHeight(()=>this.update())),this._register(n.onDidChangeCollapseState(()=>this.update())),this.update()}get height(){return this._widget.height}get count(){return this._widget.count}getNode(n){return this._widget.getNode(n)}getNodeAtHeight(n){let S;if(n===0?S=this.view.firstVisibleIndex:S=this.view.indexAt(n+this.view.scrollTop),!(S<0||S>=this.view.length))return this.view.element(S)}update(){const n=this.getNodeAtHeight(0);if(!n||this.tree.scrollTop===0){this._widget.setState(void 0);return}const S=this.findStickyState(n);this._widget.setState(S)}findStickyState(n){const S=[];let y=n,L=0,z=this.getNextStickyNode(y,void 0,L);for(;z&&(S.push(z),L+=z.height,!(S.length<=this.stickyScrollMaxItemCount&&(y=this.getNextVisibleNode(z),!y)));)z=this.getNextStickyNode(y,z.node,L);const Y=this.constrainStickyNodes(S);return Y.length?new ae(Y):void 0}getNextVisibleNode(n){return this.getNodeAtHeight(n.position+n.height)}getNextStickyNode(n,S,y){const L=this.getAncestorUnderPrevious(n,S);if(L&&!(L===n&&(!this.nodeIsUncollapsedParent(n)||this.nodeTopAlignsWithStickyNodesBottom(n,y))))return this.createStickyScrollNode(L,y)}nodeTopAlignsWithStickyNodesBottom(n,S){const y=this.getNodeIndex(n),L=this.view.getElementTop(y),z=S;return this.view.scrollTop===L-z}createStickyScrollNode(n,S){const y=this.treeDelegate.getHeight(n),{startIndex:L,endIndex:z}=this.getNodeRange(n),Y=this.calculateStickyNodePosition(z,S,y);return{node:n,position:Y,height:y,startIndex:L,endIndex:z}}getAncestorUnderPrevious(n,S=void 0){let y=n,L=this.getParentNode(y);for(;L;){if(L===S)return y;y=L,L=this.getParentNode(y)}if(S===void 0)return y}calculateStickyNodePosition(n,S,y){let L=this.view.getRelativeTop(n);if(L===null&&this.view.firstVisibleIndex===n&&n+1<this.view.length){const De=this.treeDelegate.getHeight(this.view.element(n)),me=this.view.getRelativeTop(n+1);L=me?me-De/this.view.renderHeight:null}if(L===null)return S;const z=this.view.element(n),Y=this.treeDelegate.getHeight(z),oe=L*this.view.renderHeight+Y;return S+y>oe&&S<=oe?oe-y:S}constrainStickyNodes(n){if(n.length===0)return[];const S=this.view.renderHeight*this.maxWidgetViewRatio,y=n[n.length-1];if(n.length<=this.stickyScrollMaxItemCount&&y.position+y.height<=S)return n;const L=this.stickyScrollDelegate.constrainStickyScrollNodes(n,this.stickyScrollMaxItemCount,S);if(!L.length)return[];const z=L[L.length-1];if(L.length>this.stickyScrollMaxItemCount||z.position+z.height>S)throw new Error("stickyScrollDelegate violates constraints");return L}getParentNode(n){const S=this.model.getNodeLocation(n),y=this.model.getParentNodeLocation(S);return y?this.model.getNode(y):void 0}nodeIsUncollapsedParent(n){const S=this.model.getNodeLocation(n);return this.model.getListRenderCount(S)>1}getNodeIndex(n){const S=this.model.getNodeLocation(n);return this.model.getListIndex(S)}getNodeRange(n){const S=this.model.getNodeLocation(n),y=this.model.getListIndex(S);if(y<0)throw new Error("Node not found in tree");const L=this.model.getListRenderCount(S),z=y+L-1;return{startIndex:y,endIndex:z}}nodePositionTopBelowWidget(n){const S=[];let y=this.getParentNode(n);for(;y;)S.push(y),y=this.getParentNode(y);let L=0;for(let z=0;z<S.length&&z<this.stickyScrollMaxItemCount;z++)L+=this.treeDelegate.getHeight(S[z]);return L}getFocus(){return this._widget.getFocus()}domFocus(){this._widget.domFocus()}focusedLast(){return this._widget.focusedLast()}updateOptions(n={}){if(!n.stickyScrollMaxItemCount)return;const S=this.validateStickySettings(n);this.stickyScrollMaxItemCount!==S.stickyScrollMaxItemCount&&(this.stickyScrollMaxItemCount=S.stickyScrollMaxItemCount,this.update())}validateStickySettings(n){let S=7;return typeof n.stickyScrollMaxItemCount=="number"&&(S=Math.max(n.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:S}}}class ne{constructor(n,S,y,L,z,Y){this.view=S,this.tree=y,this.treeRenderers=L,this.treeDelegate=z,this.accessibilityProvider=Y,this._previousElements=[],this._previousStateDisposables=new f.DisposableStore,this._rootDomNode=(0,s.$)(".monaco-tree-sticky-container.empty"),n.appendChild(this._rootDomNode);const Q=(0,s.$)(".monaco-tree-sticky-container-shadow");this._rootDomNode.appendChild(Q),this.stickyScrollFocus=new de(this._rootDomNode,S),this.onDidChangeHasFocus=this.stickyScrollFocus.onDidChangeHasFocus,this.onContextMenu=this.stickyScrollFocus.onContextMenu}get height(){if(!this._previousState)return 0;const n=this._previousState.stickyNodes[this._previousState.count-1];return n.position+n.height}get count(){return this._previousState?.count??0}getNode(n){return this._previousState?.stickyNodes.find(S=>S.node===n)}setState(n){const S=!!this._previousState&&this._previousState.count>0,y=!!n&&n.count>0;if(!S&&!y||S&&y&&this._previousState.equal(n))return;if(S!==y&&this.setVisible(y),!y){this._previousState=void 0,this._previousElements=[],this._previousStateDisposables.clear();return}const L=n.stickyNodes[n.count-1];if(this._previousState&&n.animationStateChanged(this._previousState))this._previousElements[this._previousState.count-1].style.top=`${L.position}px`;else{this._previousStateDisposables.clear();const z=Array(n.count);for(let Y=n.count-1;Y>=0;Y--){const Q=n.stickyNodes[Y],{element:oe,disposable:De}=this.createElement(Q,Y,n.count);z[Y]=oe,this._rootDomNode.appendChild(oe),this._previousStateDisposables.add(De)}this.stickyScrollFocus.updateElements(z,n),this._previousElements=z}this._previousState=n,this._rootDomNode.style.height=`${L.position+L.height}px`}createElement(n,S,y){const L=n.startIndex,z=document.createElement("div");z.style.top=`${n.position}px`,this.tree.options.setRowHeight!==!1&&(z.style.height=`${n.height}px`),this.tree.options.setRowLineHeight!==!1&&(z.style.lineHeight=`${n.height}px`),z.classList.add("monaco-tree-sticky-row"),z.classList.add("monaco-list-row"),z.setAttribute("data-index",`${L}`),z.setAttribute("data-parity",L%2===0?"even":"odd"),z.setAttribute("id",this.view.getElementID(L));const Y=this.setAccessibilityAttributes(z,n.node.element,S,y),Q=this.treeDelegate.getTemplateId(n.node),oe=this.treeRenderers.find(Ae=>Ae.templateId===Q);if(!oe)throw new Error(`No renderer found for template id ${Q}`);let De=n.node;De===this.tree.getNode(this.tree.getNodeLocation(n.node))&&(De=new Proxy(n.node,{}));const me=oe.renderTemplate(z);oe.renderElement(De,n.startIndex,me,n.height);const ke=(0,f.toDisposable)(()=>{Y.dispose(),oe.disposeElement(De,n.startIndex,me,n.height),oe.disposeTemplate(me),z.remove()});return{element:z,disposable:ke}}setAccessibilityAttributes(n,S,y,L){if(!this.accessibilityProvider)return f.Disposable.None;this.accessibilityProvider.getSetSize&&n.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(S,y,L))),this.accessibilityProvider.getPosInSet&&n.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(S,y))),this.accessibilityProvider.getRole&&n.setAttribute("role",this.accessibilityProvider.getRole(S)??"treeitem");const z=this.accessibilityProvider.getAriaLabel(S),Y=z&&typeof z!="string"?z:(0,B.constObservable)(z),Q=(0,B.autorun)(De=>{const me=De.readObservable(Y);me?n.setAttribute("aria-label",me):n.removeAttribute("aria-label")});typeof z=="string"||z&&n.setAttribute("aria-label",z.get());const oe=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(S);return typeof oe=="number"&&n.setAttribute("aria-level",`${oe}`),n.setAttribute("aria-selected",String(!1)),Q}setVisible(n){this._rootDomNode.classList.toggle("empty",!n),n||this.stickyScrollFocus.updateElements([],void 0)}getFocus(){return this.stickyScrollFocus.getFocus()}domFocus(){this.stickyScrollFocus.domFocus()}focusedLast(){return this.stickyScrollFocus.focusedLast()}dispose(){this.stickyScrollFocus.dispose(),this._previousStateDisposables.dispose(),this._rootDomNode.remove()}}class de extends f.Disposable{get domHasFocus(){return this._domHasFocus}set domHasFocus(n){n!==this._domHasFocus&&(this._onDidChangeHasFocus.fire(n),this._domHasFocus=n)}constructor(n,S){super(),this.container=n,this.view=S,this.focusedIndex=-1,this.elements=[],this._onDidChangeHasFocus=new D.Emitter,this.onDidChangeHasFocus=this._onDidChangeHasFocus.event,this._onContextMenu=new D.Emitter,this.onContextMenu=this._onContextMenu.event,this._domHasFocus=!1,this.container.addEventListener("focus",()=>this.onFocus()),this.container.addEventListener("blur",()=>this.onBlur()),this._register(this.view.onDidFocus(()=>this.toggleStickyScrollFocused(!1))),this._register(this.view.onKeyDown(y=>this.onKeyDown(y))),this._register(this.view.onMouseDown(y=>this.onMouseDown(y))),this._register(this.view.onContextMenu(y=>this.handleContextMenu(y)))}handleContextMenu(n){const S=n.browserEvent.target;if(!(0,p.isStickyScrollContainer)(S)&&!(0,p.isStickyScrollElement)(S)){this.focusedLast()&&this.view.domFocus();return}if(!(0,s.isKeyboardEvent)(n.browserEvent)){if(!this.state)throw new Error("Context menu should not be triggered when state is undefined");const Y=this.state.stickyNodes.findIndex(Q=>Q.node.element===n.element?.element);if(Y===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.container.focus(),this.setFocus(Y);return}if(!this.state||this.focusedIndex<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const L=this.state.stickyNodes[this.focusedIndex].node.element,z=this.elements[this.focusedIndex];this._onContextMenu.fire({element:L,anchor:z,browserEvent:n.browserEvent,isStickyScroll:!0})}onKeyDown(n){if(this.domHasFocus&&this.state){if(n.key==="ArrowUp")this.setFocusedElement(Math.max(0,this.focusedIndex-1)),n.preventDefault(),n.stopPropagation();else if(n.key==="ArrowDown"||n.key==="ArrowRight"){if(this.focusedIndex>=this.state.count-1){const S=this.state.stickyNodes[this.state.count-1].startIndex+1;this.view.domFocus(),this.view.setFocus([S]),this.scrollNodeUnderWidget(S,this.state)}else this.setFocusedElement(this.focusedIndex+1);n.preventDefault(),n.stopPropagation()}}}onMouseDown(n){const S=n.browserEvent.target;!(0,p.isStickyScrollContainer)(S)&&!(0,p.isStickyScrollElement)(S)||(n.browserEvent.preventDefault(),n.browserEvent.stopPropagation())}updateElements(n,S){if(S&&S.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(S&&S.count!==n.length)throw new Error("Sticky scroll focus received illigel state");const y=this.focusedIndex;if(this.removeFocus(),this.elements=n,this.state=S,S){const L=(0,o.clamp)(y,0,S.count-1);this.setFocus(L)}else this.domHasFocus&&this.view.domFocus();this.container.tabIndex=S?0:-1}setFocusedElement(n){const S=this.state;if(!S)throw new Error("Cannot set focus when state is undefined");if(this.setFocus(n),!(n<S.count-1)&&S.lastNodePartiallyVisible()){const y=S.stickyNodes[n];this.scrollNodeUnderWidget(y.endIndex+1,S)}}scrollNodeUnderWidget(n,S){const y=S.stickyNodes[S.count-1],L=S.count>1?S.stickyNodes[S.count-2]:void 0,z=this.view.getElementTop(n),Y=L?L.position+L.height+y.height:y.height;this.view.scrollTop=z-Y}getFocus(){if(!(!this.state||this.focusedIndex===-1))return this.state.stickyNodes[this.focusedIndex].node.element}domFocus(){if(!this.state)throw new Error("Cannot focus when state is undefined");this.container.focus()}focusedLast(){return this.state?this.view.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}removeFocus(){this.focusedIndex!==-1&&(this.toggleElementFocus(this.elements[this.focusedIndex],!1),this.focusedIndex=-1)}setFocus(n){if(0>n)throw new Error("addFocus() can not remove focus");if(!this.state&&n>=0)throw new Error("Cannot set focus index when state is undefined");if(this.state&&n>=this.state.count)throw new Error("Cannot set focus index to an index that does not exist");const S=this.focusedIndex;S>=0&&this.toggleElementFocus(this.elements[S],!1),n>=0&&this.toggleElementFocus(this.elements[n],!0),this.focusedIndex=n}toggleElementFocus(n,S){this.toggleElementActiveFocus(n,S&&this.domHasFocus),this.toggleElementPassiveFocus(n,S)}toggleCurrentElementActiveFocus(n){this.focusedIndex!==-1&&this.toggleElementActiveFocus(this.elements[this.focusedIndex],n)}toggleElementActiveFocus(n,S){n.classList.toggle("focused",S)}toggleElementPassiveFocus(n,S){n.classList.toggle("passive-focused",S)}toggleStickyScrollFocused(n){this.view.getHTMLElement().classList.toggle("sticky-scroll-focused",n)}onFocus(){if(!this.state||this.elements.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.domHasFocus=!0,this.toggleStickyScrollFocused(!0),this.toggleCurrentElementActiveFocus(!0),this.focusedIndex===-1&&this.setFocus(0)}onBlur(){this.domHasFocus=!1,this.toggleCurrentElementActiveFocus(!1)}dispose(){this.toggleStickyScrollFocused(!1),this._onDidChangeHasFocus.fire(!1),super.dispose()}}function we(T){let n=h.TreeMouseEventTarget.Unknown;return(0,s.hasParentWithClass)(T.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?n=h.TreeMouseEventTarget.Twistie:(0,s.hasParentWithClass)(T.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?n=h.TreeMouseEventTarget.Element:(0,s.hasParentWithClass)(T.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(n=h.TreeMouseEventTarget.Filter),{browserEvent:T.browserEvent,element:T.element?T.element.element:null,target:n}}function Fe(T){const n=(0,p.isStickyScrollContainer)(T.browserEvent.target);return{element:T.element?T.element.element:null,browserEvent:T.browserEvent,anchor:T.anchor,isStickyScroll:n}}function _e(T,n){n(T),T.children.forEach(S=>_e(S,n))}class Pe{get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}constructor(n,S){this.getFirstViewElementWithTrait=n,this.identityProvider=S,this.nodes=[],this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event}set(n,S){!S?.__forceEvent&&(0,e.equals)(this.nodes,n)||this._set(n,!1,S)}_set(n,S,y){if(this.nodes=[...n],this.elements=void 0,this._nodeSet=void 0,!S){const L=this;this._onDidChange.fire({get elements(){return L.get()},browserEvent:y})}}get(){return this.elements||(this.elements=this.nodes.map(n=>n.element)),[...this.elements]}getNodes(){return this.nodes}has(n){return this.nodeSet.has(n)}onDidModelSplice({insertedNodes:n,deletedNodes:S}){if(!this.identityProvider){const oe=this.createNodeSet(),De=me=>oe.delete(me);S.forEach(me=>_e(me,De)),this.set([...oe.values()]);return}const y=new Set,L=oe=>y.add(this.identityProvider.getId(oe.element).toString());S.forEach(oe=>_e(oe,L));const z=new Map,Y=oe=>z.set(this.identityProvider.getId(oe.element).toString(),oe);n.forEach(oe=>_e(oe,Y));const Q=[];for(const oe of this.nodes){const De=this.identityProvider.getId(oe.element).toString();if(!y.has(De))Q.push(oe);else{const ke=z.get(De);ke&&ke.visible&&Q.push(ke)}}if(this.nodes.length>0&&Q.length===0){const oe=this.getFirstViewElementWithTrait();oe&&Q.push(oe)}this._set(Q,!0)}createNodeSet(){const n=new Set;for(const S of this.nodes)n.add(S);return n}}class H extends p.MouseController{constructor(n,S,y){super(n),this.tree=S,this.stickyScrollProvider=y}onViewPointer(n){if((0,p.isButton)(n.browserEvent.target)||(0,p.isInputElement)(n.browserEvent.target)||(0,p.isMonacoEditor)(n.browserEvent.target)||n.browserEvent.isHandledByList)return;const S=n.element;if(!S)return super.onViewPointer(n);if(this.isSelectionRangeChangeEvent(n)||this.isSelectionSingleChangeEvent(n))return super.onViewPointer(n);const y=n.browserEvent.target,L=y.classList.contains("monaco-tl-twistie")||y.classList.contains("monaco-icon-label")&&y.classList.contains("folder-icon")&&n.browserEvent.offsetX<16,z=(0,p.isStickyScrollElement)(n.browserEvent.target);let Y=!1;if(z?Y=!0:typeof this.tree.expandOnlyOnTwistieClick=="function"?Y=this.tree.expandOnlyOnTwistieClick(S.element):Y=!!this.tree.expandOnlyOnTwistieClick,z)this.handleStickyScrollMouseEvent(n,S);else{if(Y&&!L&&n.browserEvent.detail!==2)return super.onViewPointer(n);if(!this.tree.expandOnDoubleClick&&n.browserEvent.detail===2)return super.onViewPointer(n)}if(S.collapsible&&(!z||L)){const Q=this.tree.getNodeLocation(S),oe=n.browserEvent.altKey;if(this.tree.setFocus([Q]),this.tree.toggleCollapsed(Q,oe),Y&&L){n.browserEvent.isHandledByList=!0;return}}z||super.onViewPointer(n)}handleStickyScrollMouseEvent(n,S){if((0,p.isMonacoCustomToggle)(n.browserEvent.target)||(0,p.isActionItem)(n.browserEvent.target))return;const y=this.stickyScrollProvider();if(!y)throw new Error("Sticky scroll controller not found");const L=this.list.indexOf(S),z=this.list.getElementTop(L),Y=y.nodePositionTopBelowWidget(S);this.tree.scrollTop=z-Y,this.list.domFocus(),this.list.setFocus([L]),this.list.setSelection([L])}onDoubleClick(n){n.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||n.browserEvent.isHandledByList||super.onDoubleClick(n)}onMouseDown(n){const S=n.browserEvent.target;if(!(0,p.isStickyScrollContainer)(S)&&!(0,p.isStickyScrollElement)(S)){super.onMouseDown(n);return}}onContextMenu(n){const S=n.browserEvent.target;if(!(0,p.isStickyScrollContainer)(S)&&!(0,p.isStickyScrollElement)(S)){super.onContextMenu(n);return}}}class c extends p.List{constructor(n,S,y,L,z,Y,Q,oe){super(n,S,y,L,oe),this.focusTrait=z,this.selectionTrait=Y,this.anchorTrait=Q}createMouseController(n){return new H(this,n.tree,n.stickyScrollProvider)}splice(n,S,y=[]){if(super.splice(n,S,y),y.length===0)return;const L=[],z=[];let Y;y.forEach((Q,oe)=>{this.focusTrait.has(Q)&&L.push(n+oe),this.selectionTrait.has(Q)&&z.push(n+oe),this.anchorTrait.has(Q)&&(Y=n+oe)}),L.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...L])),z.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...z])),typeof Y=="number"&&super.setAnchor(Y)}setFocus(n,S,y=!1){super.setFocus(n,S),y||this.focusTrait.set(n.map(L=>this.element(L)),S)}setSelection(n,S,y=!1){super.setSelection(n,S),y||this.selectionTrait.set(n.map(L=>this.element(L)),S)}setAnchor(n,S=!1){super.setAnchor(n),S||(typeof n>"u"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(n)]))}}var E;(function(T){T[T.Tree=0]="Tree",T[T.StickyScroll=1]="StickyScroll"})(E||(t.AbstractTreePart=E={}));class l{get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return D.Event.map(this.view.onMouseClick,we)}get onMouseDblClick(){return D.Event.filter(D.Event.map(this.view.onMouseDblClick,we),n=>n.target!==h.TreeMouseEventTarget.Filter)}get onMouseOver(){return D.Event.map(this.view.onMouseOver,we)}get onMouseOut(){return D.Event.map(this.view.onMouseOut,we)}get onContextMenu(){return D.Event.any(D.Event.filter(D.Event.map(this.view.onContextMenu,Fe),n=>!n.isStickyScroll),this.stickyScrollController?.onContextMenu??D.Event.None)}get onTap(){return D.Event.map(this.view.onTap,we)}get onPointer(){return D.Event.map(this.view.onPointer,we)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return D.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??Ee.Highlight}set findMode(n){this.findController&&(this.findController.mode=n)}get findMatchType(){return this.findController?.matchType??Ie.Fuzzy}set findMatchType(n){this.findController&&(this.findController.matchType=n)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:D.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick>"u"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick>"u"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}constructor(n,S,y,L,z={}){this._user=n,this._options=z,this.eventBufferer=new D.EventBufferer,this.onDidChangeFindOpenState=D.Event.None,this.onDidChangeStickyScrollFocused=D.Event.None,this.disposables=new f.DisposableStore,this._onWillRefilter=new D.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new D.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event,this.treeDelegate=new k(y);const Y=new D.Relay,Q=new D.Relay,oe=this.disposables.add(new q(Q.event)),De=new g.SetMap;this.renderers=L.map(Se=>new X(Se,()=>this.model,Y.event,oe,De,z));for(const Se of this.renderers)this.disposables.add(Se);let me;z.keyboardNavigationLabelProvider&&(me=new ce(this,z.keyboardNavigationLabelProvider,z.filter),z={...z,filter:me},this.disposables.add(me)),this.focus=new Pe(()=>this.view.getFocusedElements()[0],z.identityProvider),this.selection=new Pe(()=>this.view.getSelectedElements()[0],z.identityProvider),this.anchor=new Pe(()=>this.view.getAnchorElement(),z.identityProvider),this.view=new c(n,S,this.treeDelegate,this.renderers,this.focus,this.selection,this.anchor,{...$(()=>this.model,z),tree:this,stickyScrollProvider:()=>this.stickyScrollController}),this.model=this.createModel(n,this.view,z),Y.input=this.model.onDidChangeCollapseState;const ke=D.Event.forEach(this.model.onDidSplice,Se=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(Se),this.selection.onDidModelSplice(Se)})},this.disposables);ke(()=>null,null,this.disposables);const Ae=this.disposables.add(new D.Emitter),Me=this.disposables.add(new i.Delayer(0));if(this.disposables.add(D.Event.any(ke,this.focus.onDidChange,this.selection.onDidChange)(()=>{Me.trigger(()=>{const Se=new Set;for(const Te of this.focus.getNodes())Se.add(Te);for(const Te of this.selection.getNodes())Se.add(Te);Ae.fire([...Se.values()])})})),Q.input=Ae.event,z.keyboardSupport!==!1){const Se=D.Event.chain(this.view.onKeyDown,Te=>Te.filter(Ve=>!(0,p.isInputElement)(Ve.target)).map(Ve=>new x.StandardKeyboardEvent(Ve)));D.Event.chain(Se,Te=>Te.filter(Ve=>Ve.keyCode===15))(this.onLeftArrow,this,this.disposables),D.Event.chain(Se,Te=>Te.filter(Ve=>Ve.keyCode===17))(this.onRightArrow,this,this.disposables),D.Event.chain(Se,Te=>Te.filter(Ve=>Ve.keyCode===10))(this.onSpace,this,this.disposables)}if((z.findWidgetEnabled??!0)&&z.keyboardNavigationLabelProvider&&z.contextViewProvider){const Se=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.findController=new ue(this,this.model,this.view,me,z.contextViewProvider,Se),this.focusNavigationFilter=Te=>this.findController.shouldAllowFocus(Te),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode,this.onDidChangeFindMatchType=this.findController.onDidChangeMatchType}else this.onDidChangeFindMode=D.Event.None,this.onDidChangeFindMatchType=D.Event.None;z.enableStickyScroll&&(this.stickyScrollController=new G(this,this.model,this.view,this.renderers,this.treeDelegate,z),this.onDidChangeStickyScrollFocused=this.stickyScrollController.onDidChangeHasFocus),this.styleElement=(0,s.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===I.Always)}updateOptions(n={}){this._options={...this._options,...n};for(const S of this.renderers)S.updateOptions(n);this.view.updateOptions(this._options),this.findController?.updateOptions(n),this.updateStickyScroll(n),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===I.Always)}get options(){return this._options}updateStickyScroll(n){!this.stickyScrollController&&this._options.enableStickyScroll?(this.stickyScrollController=new G(this,this.model,this.view,this.renderers,this.treeDelegate,this._options),this.onDidChangeStickyScrollFocused=this.stickyScrollController.onDidChangeHasFocus):this.stickyScrollController&&!this._options.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=D.Event.None,this.stickyScrollController.dispose(),this.stickyScrollController=void 0),this.stickyScrollController?.updateOptions(n)}updateWidth(n){const S=this.model.getListIndex(n);S!==-1&&this.view.updateWidth(S)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get contentWidth(){return this.view.contentWidth}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.view.onDidChangeContentWidth}get scrollTop(){return this.view.scrollTop}set scrollTop(n){this.view.scrollTop=n}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(n){this.view.scrollLeft=n}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){let n=this.view.firstVisibleIndex;return this.stickyScrollController&&(n+=this.stickyScrollController.count),n<0||n>=this.view.length?void 0:this.view.element(n).element}get lastVisibleElement(){const n=this.view.lastVisibleIndex;return this.view.element(n).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(n){this.view.ariaLabel=n}get selectionSize(){return this.selection.getNodes().length}domFocus(){this.stickyScrollController?.focusedLast()?this.stickyScrollController.domFocus():this.view.domFocus()}isDOMFocused(){return(0,s.isActiveElement)(this.getHTMLElement())}layout(n,S){this.view.layout(n,S),(0,C.isNumber)(S)&&this.findController?.layout(S)}style(n){const S=`.${this.view.domId}`,y=[];n.treeIndentGuidesStroke&&(y.push(`.monaco-list${S}:hover .monaco-tl-indent > .indent-guide, .monaco-list${S}.always .monaco-tl-indent > .indent-guide  { border-color: ${n.treeInactiveIndentGuidesStroke}; }`),y.push(`.monaco-list${S} .monaco-tl-indent > .indent-guide.active { border-color: ${n.treeIndentGuidesStroke}; }`)),n.listBackground&&(y.push(`.monaco-list${S} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${n.listBackground}; }`),y.push(`.monaco-list${S} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${n.listBackground}; }`)),n.listFocusForeground&&(y.push(`.monaco-list${S}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${n.listFocusForeground}; }`),y.push(`.monaco-list${S}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const L=(0,s.asCssValueWithDefault)(n.listFocusAndSelectionOutline,(0,s.asCssValueWithDefault)(n.listSelectionOutline,n.listFocusOutline??""));L&&(y.push(`.monaco-list${S}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${L}; outline-offset: -1px;}`),y.push(`.monaco-list${S}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),n.listFocusOutline&&(y.push(`.monaco-list${S}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${n.listFocusOutline}; outline-offset: -1px; }`),y.push(`.monaco-list${S}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),y.push(`.monaco-workbench.context-menu-visible .monaco-list${S}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${n.listFocusOutline}; outline-offset: -1px; }`),y.push(`.monaco-workbench.context-menu-visible .monaco-list${S}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),y.push(`.monaco-workbench.context-menu-visible .monaco-list${S}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.styleElement.textContent=y.join(`
`),this.view.style(n)}getParentElement(n){const S=this.model.getParentNodeLocation(n);return this.model.getNode(S).element}getFirstElementChild(n){return this.model.getFirstElementChild(n)}getNode(n){return this.model.getNode(n)}getNodeLocation(n){return this.model.getNodeLocation(n)}collapse(n,S=!1){return this.model.setCollapsed(n,!0,S)}expand(n,S=!1){return this.model.setCollapsed(n,!1,S)}toggleCollapsed(n,S=!1){return this.model.setCollapsed(n,void 0,S)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(n){return this.model.isCollapsible(n)}setCollapsible(n,S){return this.model.setCollapsible(n,S)}isCollapsed(n){return this.model.isCollapsed(n)}expandTo(n){this.model.expandTo(n)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(n){if(typeof n>"u")return this.view.setAnchor(void 0);this.eventBufferer.bufferEvents(()=>{const S=this.model.getNode(n);this.anchor.set([S]);const y=this.model.getListIndex(n);y>-1&&this.view.setAnchor(y,!0)})}getAnchor(){return(0,e.firstOrDefault)(this.anchor.get(),void 0)}setSelection(n,S){this.eventBufferer.bufferEvents(()=>{const y=n.map(z=>this.model.getNode(z));this.selection.set(y,S);const L=n.map(z=>this.model.getListIndex(z)).filter(z=>z>-1);this.view.setSelection(L,S,!0)})}getSelection(){return this.selection.get()}setFocus(n,S){this.eventBufferer.bufferEvents(()=>{const y=n.map(z=>this.model.getNode(z));this.focus.set(y,S);const L=n.map(z=>this.model.getListIndex(z)).filter(z=>z>-1);this.view.setFocus(L,S,!0)})}focusNext(n=1,S=!1,y,L=(0,s.isKeyboardEvent)(y)&&y.altKey?void 0:this.focusNavigationFilter){this.view.focusNext(n,S,y,L)}focusPrevious(n=1,S=!1,y,L=(0,s.isKeyboardEvent)(y)&&y.altKey?void 0:this.focusNavigationFilter){this.view.focusPrevious(n,S,y,L)}focusNextPage(n,S=(0,s.isKeyboardEvent)(n)&&n.altKey?void 0:this.focusNavigationFilter){return this.view.focusNextPage(n,S)}focusPreviousPage(n,S=(0,s.isKeyboardEvent)(n)&&n.altKey?void 0:this.focusNavigationFilter){return this.view.focusPreviousPage(n,S,()=>this.stickyScrollController?.height??0)}focusLast(n,S=(0,s.isKeyboardEvent)(n)&&n.altKey?void 0:this.focusNavigationFilter){this.view.focusLast(n,S)}focusFirst(n,S=(0,s.isKeyboardEvent)(n)&&n.altKey?void 0:this.focusNavigationFilter){this.view.focusFirst(n,S)}getFocus(){return this.focus.get()}getStickyScrollFocus(){const n=this.stickyScrollController?.getFocus();return n!==void 0?[n]:[]}getFocusedPart(){return this.stickyScrollController?.focusedLast()?1:0}reveal(n,S){this.model.expandTo(n);const y=this.model.getListIndex(n);if(y!==-1)if(!this.stickyScrollController)this.view.reveal(y,S);else{const L=this.stickyScrollController.nodePositionTopBelowWidget(this.getNode(n));this.view.reveal(y,S,L)}}getRelativeTop(n){const S=this.model.getListIndex(n);if(S===-1)return null;const y=this.stickyScrollController?.getNode(this.getNode(n));return this.view.getRelativeTop(S,y?.position??this.stickyScrollController?.height)}getViewState(n=this.options.identityProvider){if(!n)throw new h.TreeError(this._user,"Can't get tree view state without an identity provider");const S=Y=>n.getId(Y).toString(),y=M.empty(this.scrollTop);for(const Y of this.getFocus())y.focus.add(S(Y));for(const Y of this.getSelection())y.selection.add(S(Y));const L=this.model.getNode(),z=[L];for(;z.length>0;){const Y=z.shift();Y!==L&&Y.collapsible&&(y.expanded[S(Y.element)]=Y.collapsed?0:1),z.push(...Y.children)}return y}onLeftArrow(n){n.preventDefault(),n.stopPropagation();const S=this.view.getFocusedElements();if(S.length===0)return;const y=S[0],L=this.model.getNodeLocation(y);if(!this.model.setCollapsed(L,!0)){const Y=this.model.getParentNodeLocation(L);if(!Y)return;const Q=this.model.getListIndex(Y);this.view.reveal(Q),this.view.setFocus([Q])}}onRightArrow(n){n.preventDefault(),n.stopPropagation();const S=this.view.getFocusedElements();if(S.length===0)return;const y=S[0],L=this.model.getNodeLocation(y);if(!this.model.setCollapsed(L,!1)){if(!y.children.some(oe=>oe.visible))return;const[Y]=this.view.getFocus(),Q=Y+1;this.view.reveal(Q),this.view.setFocus([Q])}}onSpace(n){n.preventDefault(),n.stopPropagation();const S=this.view.getFocusedElements();if(S.length===0)return;const y=S[0],L=this.model.getNodeLocation(y),z=n.browserEvent.altKey;this.model.setCollapsed(L,void 0,z)}navigate(n){return new v(this.view,this.model,n)}dispose(){(0,f.dispose)(this.disposables),this.stickyScrollController?.dispose(),this.view.dispose()}}t.AbstractTree=l;class v{constructor(n,S,y){this.view=n,this.model=S,y?this.index=this.model.getListIndex(y):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(ge[144],pe([1,0,143,135,30,32]),function(ie,t,s,N,x,V){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class _ extends s.AbstractTree{constructor(m,p,w,W,h,d={}){super(m,p,w,W,d),this.user=m,this.dataSource=h,this.nodesByIdentity=new Map,this.identityProvider=d.identityProvider}getInput(){return this.input}setInput(m,p){if(p&&!this.identityProvider)throw new x.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=m,!m){this.nodesByIdentity.clear(),this.model.setChildren(null,V.Iterable.empty());return}if(!p){this._refresh(m);return}const w=[],W=[],h=e=>{const i=this.identityProvider.getId(e).toString();return!p.expanded[i]},d=e=>{const i=this.identityProvider.getId(e.element).toString();p.focus.has(i)&&w.push(e.element),p.selection.has(i)&&W.push(e.element)};this._refresh(m,h,d),this.setFocus(w),this.setSelection(W),p&&typeof p.scrollTop=="number"&&(this.scrollTop=p.scrollTop)}updateChildren(m=this.input){if(typeof this.input>"u")throw new x.TreeError(this.user,"Tree input not set");let p;this.identityProvider&&(p=w=>{const W=this.identityProvider.getId(w).toString(),h=this.nodesByIdentity.get(W);if(h)return h.collapsed}),this._refresh(m,p)}resort(m=this.input,p=!0){this.model.resort(m===this.input?null:m,p)}refresh(m){if(m===void 0){this.view.rerender();return}this.model.rerender(m)}_refresh(m,p,w){let W;if(this.identityProvider){const h=new Set,d=w;w=e=>{const i=this.identityProvider.getId(e.element).toString();h.add(i),this.nodesByIdentity.set(i,e),d?.(e)},W=e=>{const i=this.identityProvider.getId(e.element).toString();h.has(i)||this.nodesByIdentity.delete(i)}}this.model.setChildren(m===this.input?null:m,this.iterate(m,p).elements,{onDidCreateNode:w,onDidDeleteNode:W})}iterate(m,p){const w=[...this.dataSource.getChildren(m)];return{elements:V.Iterable.map(w,h=>{const{elements:d,size:e}=this.iterate(h,p),i=this.dataSource.hasChildren?this.dataSource.hasChildren(h):void 0,r=e===0?void 0:p&&p(h);return{element:h,children:d,collapsible:i,collapsed:r}}),size:w.length}}createModel(m,p,w){return new N.ObjectTreeModel(m,p,w)}}t.DataTree=_}),define(ge[77],pe([1,0,12,9,42,28,31,6,4,2,63,10,7]),function(ie,t,s,N,x,V,_,A,m,p,w,W,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.BufferWriter=t.BufferReader=void 0,t.serialize=P,t.deserialize=b,t.getDelayedChannel=q,t.getNextTickChannel=X;var d;(function(ue){ue[ue.Promise=100]="Promise",ue[ue.PromiseCancel=101]="PromiseCancel",ue[ue.EventListen=102]="EventListen",ue[ue.EventDispose=103]="EventDispose"})(d||(d={}));function e(ue){switch(ue){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var i;(function(ue){ue[ue.Initialize=200]="Initialize",ue[ue.PromiseSuccess=201]="PromiseSuccess",ue[ue.PromiseError=202]="PromiseError",ue[ue.PromiseErrorObj=203]="PromiseErrorObj",ue[ue.EventFire=204]="EventFire"})(i||(i={}));function r(ue){switch(ue){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(ue){ue[ue.Uninitialized=0]="Uninitialized",ue[ue.Idle=1]="Idle"})(u||(u={}));function g(ue){let J=0;for(let le=0;;le+=7){const ae=ue.read(1);if(J|=(ae.buffer[0]&127)<<le,!(ae.buffer[0]&128))return J}}const D=F(0);function a(ue,J){if(J===0){ue.write(D);return}let le=0;for(let Z=J;Z!==0;Z=Z>>>7)le++;const ae=x.VSBuffer.alloc(le);for(let Z=0;J!==0;Z++)ae.buffer[Z]=J&127,J=J>>>7,J>0&&(ae.buffer[Z]|=128);ue.write(ae)}class f{constructor(J){this.buffer=J,this.pos=0}read(J){const le=this.buffer.slice(this.pos,this.pos+J);return this.pos+=le.byteLength,le}}t.BufferReader=f;class o{constructor(){this.buffers=[]}get buffer(){return x.VSBuffer.concat(this.buffers)}write(J){this.buffers.push(J)}}t.BufferWriter=o;var C;(function(ue){ue[ue.Undefined=0]="Undefined",ue[ue.String=1]="String",ue[ue.Buffer=2]="Buffer",ue[ue.VSBuffer=3]="VSBuffer",ue[ue.Array=4]="Array",ue[ue.Object=5]="Object",ue[ue.Int=6]="Int"})(C||(C={}));function F(ue){const J=x.VSBuffer.alloc(1);return J.writeUInt8(ue,0),J}const R={Undefined:F(C.Undefined),String:F(C.String),Buffer:F(C.Buffer),VSBuffer:F(C.VSBuffer),Array:F(C.Array),Object:F(C.Object),Uint:F(C.Int)},B=typeof Buffer<"u";function P(ue,J){if(typeof J>"u")ue.write(R.Undefined);else if(typeof J=="string"){const le=x.VSBuffer.fromString(J);ue.write(R.String),a(ue,le.byteLength),ue.write(le)}else if(B&&Buffer.isBuffer(J)){const le=x.VSBuffer.wrap(J);ue.write(R.Buffer),a(ue,le.byteLength),ue.write(le)}else if(J instanceof x.VSBuffer)ue.write(R.VSBuffer),a(ue,J.byteLength),ue.write(J);else if(Array.isArray(J)){ue.write(R.Array),a(ue,J.length);for(const le of J)P(ue,le)}else if(typeof J=="number"&&(J|0)===J)ue.write(R.Uint),a(ue,J);else{const le=x.VSBuffer.fromString(JSON.stringify(J));ue.write(R.Object),a(ue,le.byteLength),ue.write(le)}}function b(ue){switch(ue.read(1).readUInt8(0)){case C.Undefined:return;case C.String:return ue.read(g(ue)).toString();case C.Buffer:return ue.read(g(ue)).buffer;case C.VSBuffer:return ue.read(g(ue));case C.Array:{const le=g(ue),ae=[];for(let Z=0;Z<le;Z++)ae.push(b(ue));return ae}case C.Object:return JSON.parse(ue.read(g(ue)).toString());case C.Int:return g(ue)}}class O{constructor(J,le,ae=null,Z=1e3){this.protocol=J,this.ctx=le,this.logger=ae,this.timeoutDelay=Z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(G=>this.onRawMessage(G)),this.sendResponse({type:200})}registerChannel(J,le){this.channels.set(J,le),setTimeout(()=>this.flushPendingRequests(J),0)}sendResponse(J){switch(J.type){case 200:{const le=this.send([J.type]);this.logger?.logOutgoing(le,0,1,r(J.type));return}case 201:case 202:case 204:case 203:{const le=this.send([J.type,J.id],J.data);this.logger?.logOutgoing(le,J.id,1,r(J.type),J.data);return}}}send(J,le=void 0){const ae=new o;return P(ae,J),P(ae,le),this.sendBuffer(ae.buffer)}sendBuffer(J){try{return this.protocol.send(J),J.byteLength}catch{return 0}}onRawMessage(J){const le=new f(J),ae=b(le),Z=b(le),G=ae[0];switch(G){case 100:return this.logger?.logIncoming(J.byteLength,ae[1],1,`${e(G)}: ${ae[2]}.${ae[3]}`,Z),this.onPromise({type:G,id:ae[1],channelName:ae[2],name:ae[3],arg:Z});case 102:return this.logger?.logIncoming(J.byteLength,ae[1],1,`${e(G)}: ${ae[2]}.${ae[3]}`,Z),this.onEventListen({type:G,id:ae[1],channelName:ae[2],name:ae[3],arg:Z});case 101:return this.logger?.logIncoming(J.byteLength,ae[1],1,`${e(G)}`),this.disposeActiveRequest({type:G,id:ae[1]});case 103:return this.logger?.logIncoming(J.byteLength,ae[1],1,`${e(G)}`),this.disposeActiveRequest({type:G,id:ae[1]})}}onPromise(J){const le=this.channels.get(J.channelName);if(!le){this.collectPendingRequest(J);return}const ae=new V.CancellationTokenSource;let Z;try{Z=le.call(this.ctx,J.name,J.arg,ae.token)}catch(de){Z=Promise.reject(de)}const G=J.id;Z.then(de=>{this.sendResponse({id:G,data:de,type:201})},de=>{de instanceof Error?this.sendResponse({id:G,data:{message:de.message,name:de.name,stack:de.stack?de.stack.split?de.stack.split(`
`):de.stack:void 0},type:202}):this.sendResponse({id:G,data:de,type:203})}).finally(()=>{ne.dispose(),this.activeRequests.delete(J.id)});const ne=(0,p.toDisposable)(()=>ae.cancel());this.activeRequests.set(J.id,ne)}onEventListen(J){const le=this.channels.get(J.channelName);if(!le){this.collectPendingRequest(J);return}const ae=J.id,G=le.listen(this.ctx,J.name,J.arg)(ne=>this.sendResponse({id:ae,data:ne,type:204}));this.activeRequests.set(J.id,G)}disposeActiveRequest(J){const le=this.activeRequests.get(J.id);le&&(le.dispose(),this.activeRequests.delete(J.id))}collectPendingRequest(J){let le=this.pendingRequests.get(J.channelName);le||(le=[],this.pendingRequests.set(J.channelName,le));const ae=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.sendResponse({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);le.push({request:J,timeoutTimer:ae})}flushPendingRequests(J){const le=this.pendingRequests.get(J);if(le){for(const ae of le)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.onPromise(ae.request);break;case 102:this.onEventListen(ae.request);break}this.pendingRequests.delete(J)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,p.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=O;var $;(function(ue){ue[ue.LocalSide=0]="LocalSide",ue[ue.OtherSide=1]="OtherSide"})($||(t.RequestInitiator=$={}));class k{constructor(J,le=null){this.protocol=J,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ae=>this.onBuffer(ae)),this.logger=le}getChannel(J){const le=this;return{call(ae,Z,G){return le.isDisposed?Promise.reject(new A.CancellationError):le.requestPromise(J,ae,Z,G)},listen(ae,Z){return le.isDisposed?m.Event.None:le.requestEvent(J,ae,Z)}}}requestPromise(J,le,ae,Z=V.CancellationToken.None){const G=this.lastRequestId++,de={id:G,type:100,channelName:J,name:le,arg:ae};if(Z.isCancellationRequested)return Promise.reject(new A.CancellationError);let we;return new Promise((_e,Pe)=>{if(Z.isCancellationRequested)return Pe(new A.CancellationError);const H=()=>{const v=T=>{switch(T.type){case 201:this.handlers.delete(G),_e(T.data);break;case 202:{this.handlers.delete(G);const n=new Error(T.data.message);n.stack=Array.isArray(T.data.stack)?T.data.stack.join(`
`):T.data.stack,n.name=T.data.name,Pe(n);break}case 203:this.handlers.delete(G),Pe(T.data);break}};this.handlers.set(G,v),this.sendRequest(de)};let c=null;this.state===u.Idle?H():(c=(0,N.createCancelablePromise)(v=>this.whenInitialized()),c.then(()=>{c=null,H()}));const E=()=>{c?(c.cancel(),c=null):this.sendRequest({id:G,type:101}),Pe(new A.CancellationError)},l=Z.onCancellationRequested(E);we=(0,p.combinedDisposable)((0,p.toDisposable)(E),l),this.activeRequests.add(we)}).finally(()=>{we.dispose(),this.activeRequests.delete(we)})}requestEvent(J,le,ae){const Z=this.lastRequestId++,ne={id:Z,type:102,channelName:J,name:le,arg:ae};let de=null;const we=new m.Emitter({onWillAddFirstListener:()=>{de=(0,N.createCancelablePromise)(_e=>this.whenInitialized()),de.then(()=>{de=null,this.activeRequests.add(we),this.sendRequest(ne)})},onDidRemoveLastListener:()=>{de?(de.cancel(),de=null):(this.activeRequests.delete(we),this.sendRequest({id:Z,type:103}))}}),Fe=_e=>we.fire(_e.data);return this.handlers.set(Z,Fe),we.event}sendRequest(J){switch(J.type){case 100:case 102:{const le=this.send([J.type,J.id,J.channelName,J.name],J.arg);this.logger?.logOutgoing(le,J.id,0,`${e(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const le=this.send([J.type,J.id]);this.logger?.logOutgoing(le,J.id,0,e(J.type));return}}}send(J,le=void 0){const ae=new o;return P(ae,J),P(ae,le),this.sendBuffer(ae.buffer)}sendBuffer(J){try{return this.protocol.send(J),J.byteLength}catch{return 0}}onBuffer(J){const le=new f(J),ae=b(le),Z=b(le),G=ae[0];switch(G){case 200:return this.logger?.logIncoming(J.byteLength,0,0,r(G)),this.onResponse({type:ae[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(J.byteLength,ae[1],0,r(G),Z),this.onResponse({type:ae[0],id:ae[1],data:Z})}}onResponse(J){if(J.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(J.id)?.(J)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,p.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelClient=k,Xe([_.memoize],k.prototype,"onDidInitializePromise",null);class M{get connections(){const J=[];return this._connections.forEach(le=>J.push(le)),J}constructor(J,le,ae){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new p.DisposableStore,this.disposables.add(J(({protocol:Z,onDidClientDisconnect:G})=>{const ne=m.Event.once(Z.onMessage);this.disposables.add(ne(de=>{const we=new f(de),Fe=b(we),_e=new O(Z,Fe,le,ae),Pe=new k(Z,le);this.channels.forEach((c,E)=>_e.registerChannel(E,c));const H={channelServer:_e,channelClient:Pe,ctx:Fe};this._connections.add(H),this._onDidAddConnection.fire(H),this.disposables.add(G(()=>{_e.dispose(),Pe.dispose(),this._connections.delete(H),this._onDidRemoveConnection.fire(H)}))}))}))}getChannel(J,le){const ae=this;return{call(Z,G,ne){let de;if((0,h.isFunction)(le)){const Fe=(0,s.getRandomElement)(ae.connections.filter(le));de=Fe?Promise.resolve(Fe):m.Event.toPromise(m.Event.filter(ae.onDidAddConnection,le))}else de=le.routeCall(ae,Z,G);const we=de.then(Fe=>Fe.channelClient.getChannel(J));return q(we).call(Z,G,ne)},listen(Z,G){if((0,h.isFunction)(le))return ae.getMulticastEvent(J,le,Z,G);const ne=le.routeEvent(ae,Z,G).then(de=>de.channelClient.getChannel(J));return q(ne).listen(Z,G)}}}getMulticastEvent(J,le,ae,Z){const G=this;let ne;const de=new m.Emitter({onWillAddFirstListener:()=>{ne=new p.DisposableStore;const we=new m.EventMultiplexer,Fe=new Map,_e=H=>{const E=H.channelClient.getChannel(J).listen(ae,Z),l=we.add(E);Fe.set(H,l)},Pe=H=>{const c=Fe.get(H);c&&(c.dispose(),Fe.delete(H))};G.connections.filter(le).forEach(_e),m.Event.filter(G.onDidAddConnection,le)(_e,void 0,ne),G.onDidRemoveConnection(Pe,void 0,ne),we.event(de.fire,de,ne),ne.add(we)},onDidRemoveLastListener:()=>{ne?.dispose(),ne=void 0}});return de.event}registerChannel(J,le){this.channels.set(J,le);for(const ae of this._connections)ae.channelServer.registerChannel(J,le)}dispose(){this.disposables.dispose();for(const J of this._connections)J.channelClient.dispose(),J.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=M;class I{constructor(J,le,ae=null){const Z=new o;P(Z,le),J.send(Z.buffer),this.channelClient=new k(J,ae),this.channelServer=new O(J,le,ae)}getChannel(J){return this.channelClient.getChannel(J)}registerChannel(J,le){this.channelServer.registerChannel(J,le)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=I;function q(ue){return{call(J,le,ae){return ue.then(Z=>Z.call(J,le,ae))},listen(J,le){const ae=new m.Relay;return ue.then(Z=>ae.input=Z.listen(J,le)),ae.event}}}function X(ue){let J=!1;return{call(le,ae,Z){return J?ue.call(le,ae,Z):(0,N.timeout)(0).then(()=>J=!0).then(()=>ue.call(le,ae,Z))},listen(le,ae){if(J)return ue.listen(le,ae);const Z=new m.Relay;return(0,N.timeout)(0).then(()=>J=!0).then(()=>Z.input=ue.listen(le,ae)),Z.event}}}class ce{constructor(J){this.fn=J}routeCall(J){return this.route(J)}routeEvent(J){return this.route(J)}async route(J){for(const le of J.connections)if(await Promise.resolve(this.fn(le.ctx)))return Promise.resolve(le);return await m.Event.toPromise(J.onDidAddConnection),await this.route(J)}}t.StaticRouter=ce;var re;(function(ue){function J(G,ne,de){const we=G,Fe=de&&de.disableMarshalling,_e=new Map;for(const Pe in we)ae(Pe)&&_e.set(Pe,m.Event.buffer(we[Pe],!0,void 0,ne));return new class{listen(Pe,H,c){const E=_e.get(H);if(E)return E;const l=we[H];if(typeof l=="function"){if(Z(H))return l.call(we,c);if(ae(H))return _e.set(H,m.Event.buffer(we[H],!0,void 0,ne)),_e.get(H)}throw new A.ErrorNoTelemetry(`Event not found: ${H}`)}call(Pe,H,c){const E=we[H];if(typeof E=="function"){if(!Fe&&Array.isArray(c))for(let v=0;v<c.length;v++)c[v]=(0,w.revive)(c[v]);let l=E.apply(we,c);return l instanceof Promise||(l=Promise.resolve(l)),l}throw new A.ErrorNoTelemetry(`Method not found: ${H}`)}}}ue.fromService=J;function le(G,ne){const de=ne&&ne.disableMarshalling;return new Proxy({},{get(we,Fe){if(typeof Fe=="string")return ne?.properties?.has(Fe)?ne.properties.get(Fe):Z(Fe)?function(_e){return G.listen(Fe,_e)}:ae(Fe)?G.listen(Fe):async function(..._e){let Pe;ne&&!(0,h.isUndefinedOrNull)(ne.context)?Pe=[ne.context,..._e]:Pe=_e;const H=await G.call(Fe,Pe);return de?H:(0,w.revive)(H)};throw new A.ErrorNoTelemetry(`Property not found: ${String(Fe)}`)}})}ue.toService=le;function ae(G){return G[0]==="o"&&G[1]==="n"&&W.isUpperAsciiLetter(G.charCodeAt(2))}function Z(G){return/^onDynamic/.test(G)&&W.isUpperAsciiLetter(G.charCodeAt(9))}})(re||(t.ProxyChannel=re={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function be(ue){if(Array.isArray(ue))return ue;if(ue&&typeof ue=="object"&&typeof ue.toString=="function"){const J=ue.toString();if(J!=="[object Object]")return J}return ue}function Ee(ue){return Array.isArray(ue)?ue.map(be):be(ue)}function Ie(ue,J,le,ae,Z,G,ne){ne=Ee(ne);const de=te[Z],we=de[ae%de.length];let Fe=[`%c[${ue}]%c[${String(J).padStart(7," ")}]%c[len: ${String(le).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${we}`];/\($/.test(G)?(Fe=Fe.concat(ne),Fe.push(")")):Fe.push(ne),console.log.apply(console,Fe)}class Be{constructor(J,le){this._outgoingPrefix=J,this._incomingPrefix=le,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(J,le,ae,Z,G){this._totalOutgoing+=J,Ie(this._outgoingPrefix,this._totalOutgoing,J,le,ae,Z,G)}logIncoming(J,le,ae,Z,G){this._totalIncoming+=J,Ie(this._incomingPrefix,this._totalIncoming,J,le,ae,Z,G)}}t.IPCLogger=Be}),define(ge[145],pe([1,0,42,4,77,102,34]),function(ie,t,s,N,x,V,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class A extends x.IPCClient{static createProtocol(){const p=N.Event.fromNodeEventEmitter(_.ipcRenderer,"vscode:message",(w,W)=>s.VSBuffer.wrap(W));return _.ipcRenderer.send("vscode:hello"),new V.Protocol(_.ipcRenderer,p)}constructor(p){const w=A.createProtocol();super(w,p),this.protocol=w}dispose(){this.protocol.disconnect(),super.dispose()}}t.Client=A}),define(ge[146],pe([13,11]),function(ie,t){return ie.create("vs/platform/files/common/files",t)}),define(ge[147],pe([13,11]),function(ie,t){return ie.create("vs/platform/theme/common/iconRegistry",t)}),define(ge[50],pe([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IInstantiationService=t._util=void 0,t.createDecorator=x,t.refineServiceDecorator=V;var s;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function A(m){return m[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=A})(s||(t._util=s={})),t.IInstantiationService=x("instantiationService");function N(_,A,m){A[s.DI_TARGET]===A?A[s.DI_DEPENDENCIES].push({id:_,index:m}):(A[s.DI_DEPENDENCIES]=[{id:_,index:m}],A[s.DI_TARGET]=A)}function x(_){if(s.serviceIds.has(_))return s.serviceIds.get(_);const A=function(m,p,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(A,m,w)};return A.toString=()=>_,s.serviceIds.set(_,A),A}function V(_){return _}}),define(ge[148],pe([1,0,50]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.IDiagnosticsService=t.ID=void 0,t.isRemoteDiagnosticError=N,t.ID="diagnosticsService",t.IDiagnosticsService=(0,s.createDecorator)(t.ID);function N(V){return!!V.hostName&&!!V.errorMessage}class x{async getPerformanceInfo(_,A){return{}}async getSystemInfo(_,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(_,A){return""}async getWorkspaceFileExtensions(_){return{extensions:[]}}async reportWorkspaceStats(_){}}t.NullDiagnosticsService=x}),define(ge[149],pe([1,0,99,25,10,7,16,146,50,5,35,23]),function(ie,t,s,N,x,V,_,A,m,p,w,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ByteSize=t.ETAG_DISABLED=t.FileKind=t.FILES_READONLY_FROM_PERMISSIONS_CONFIG=t.FILES_READONLY_EXCLUDE_CONFIG=t.FILES_READONLY_INCLUDE_CONFIG=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.TooLargeFileOperationError=t.FileOperationError=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.IFileService=void 0,t.isFileOpenForWriteOptions=h,t.isFileSystemWatcher=i,t.hasReadWriteCapability=u,t.hasFileFolderCopyCapability=g,t.hasFileCloneCapability=D,t.hasOpenReadWriteCloseCapability=a,t.hasFileReadStreamCapability=f,t.hasFileAtomicReadCapability=o,t.hasFileAtomicWriteCapability=C,t.hasFileAtomicDeleteCapability=F,t.hasReadonlyCapability=R,t.createFileSystemProviderError=b,t.ensureFileSystemProviderError=O,t.markAsFileSystemProviderError=$,t.toFileSystemProviderErrorCode=k,t.toFileOperationResult=M,t.isParent=re,t.etag=ue,t.whenProviderRegistered=J,t.getLargeFileConfirmationLimit=ae,t.IFileService=(0,m.createDecorator)("fileService");function h(Z){return Z.create===!0}var d;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.File=1]="File",Z[Z.Directory=2]="Directory",Z[Z.SymbolicLink=64]="SymbolicLink"})(d||(t.FileType=d={}));var e;(function(Z){Z[Z.Readonly=1]="Readonly",Z[Z.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function i(Z){const G=Z;return!!G&&typeof G.onDidChange=="function"}var r;(function(Z){Z[Z.None=0]="None",Z[Z.FileReadWrite=2]="FileReadWrite",Z[Z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Z[Z.FileReadStream=16]="FileReadStream",Z[Z.FileFolderCopy=8]="FileFolderCopy",Z[Z.PathCaseSensitive=1024]="PathCaseSensitive",Z[Z.Readonly=2048]="Readonly",Z[Z.Trash=4096]="Trash",Z[Z.FileWriteUnlock=8192]="FileWriteUnlock",Z[Z.FileAtomicRead=16384]="FileAtomicRead",Z[Z.FileAtomicWrite=32768]="FileAtomicWrite",Z[Z.FileAtomicDelete=65536]="FileAtomicDelete",Z[Z.FileClone=131072]="FileClone"})(r||(t.FileSystemProviderCapabilities=r={}));function u(Z){return!!(Z.capabilities&2)}function g(Z){return!!(Z.capabilities&8)}function D(Z){return!!(Z.capabilities&131072)}function a(Z){return!!(Z.capabilities&4)}function f(Z){return!!(Z.capabilities&16)}function o(Z){return u(Z)?!!(Z.capabilities&16384):!1}function C(Z){return u(Z)?!!(Z.capabilities&32768):!1}function F(Z){return!!(Z.capabilities&65536)}function R(Z){return!!(Z.capabilities&2048)}var B;(function(Z){Z.FileExists="EntryExists",Z.FileNotFound="EntryNotFound",Z.FileNotADirectory="EntryNotADirectory",Z.FileIsADirectory="EntryIsADirectory",Z.FileExceedsStorageQuota="EntryExceedsStorageQuota",Z.FileTooLarge="EntryTooLarge",Z.FileWriteLocked="EntryWriteLocked",Z.NoPermissions="NoPermissions",Z.Unavailable="Unavailable",Z.Unknown="Unknown"})(B||(t.FileSystemProviderErrorCode=B={}));class P extends Error{static create(G,ne){const de=new P(G.toString(),ne);return $(de,ne),de}constructor(G,ne){super(G),this.code=ne}}t.FileSystemProviderError=P;function b(Z,G){return P.create(Z,G)}function O(Z){return Z||b((0,A.localize)(0,null),B.Unknown)}function $(Z,G){return Z.name=G?`${G} (FileSystemError)`:"FileSystemError",Z}function k(Z){if(!Z)return B.Unknown;if(Z instanceof P)return Z.code;const G=/^(.+) \(FileSystemError\)$/.exec(Z.name);if(!G)return B.Unknown;switch(G[1]){case B.FileExists:return B.FileExists;case B.FileIsADirectory:return B.FileIsADirectory;case B.FileNotADirectory:return B.FileNotADirectory;case B.FileNotFound:return B.FileNotFound;case B.FileTooLarge:return B.FileTooLarge;case B.FileWriteLocked:return B.FileWriteLocked;case B.NoPermissions:return B.NoPermissions;case B.Unavailable:return B.Unavailable}return B.Unknown}function M(Z){if(Z instanceof te)return Z.fileOperationResult;switch(k(Z)){case B.FileNotFound:return 1;case B.FileIsADirectory:return 0;case B.FileNotADirectory:return 9;case B.FileWriteLocked:return 5;case B.NoPermissions:return 6;case B.FileExists:return 4;case B.FileTooLarge:return 7;default:return 10}}var I;(function(Z){Z[Z.CREATE=0]="CREATE",Z[Z.DELETE=1]="DELETE",Z[Z.MOVE=2]="MOVE",Z[Z.COPY=3]="COPY",Z[Z.WRITE=4]="WRITE"})(I||(t.FileOperation=I={}));class q{constructor(G,ne,de){this.resource=G,this.operation=ne,this.target=de}isOperation(G){return this.operation===G}}t.FileOperationEvent=q;var X;(function(Z){Z[Z.UPDATED=0]="UPDATED",Z[Z.ADDED=1]="ADDED",Z[Z.DELETED=2]="DELETED"})(X||(t.FileChangeType=X={}));class ce{static{this.MIXED_CORRELATION=null}constructor(G,ne){this.ignorePathCasing=ne,this.correlationId=void 0,this.added=new W.Lazy(()=>{const de=s.TernarySearchTree.forUris(()=>this.ignorePathCasing);return de.fill(this.rawAdded.map(we=>[we,!0])),de}),this.updated=new W.Lazy(()=>{const de=s.TernarySearchTree.forUris(()=>this.ignorePathCasing);return de.fill(this.rawUpdated.map(we=>[we,!0])),de}),this.deleted=new W.Lazy(()=>{const de=s.TernarySearchTree.forUris(()=>this.ignorePathCasing);return de.fill(this.rawDeleted.map(we=>[we,!0])),de}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const de of G){switch(de.type){case 1:this.rawAdded.push(de.resource);break;case 0:this.rawUpdated.push(de.resource);break;case 2:this.rawDeleted.push(de.resource);break}this.correlationId!==ce.MIXED_CORRELATION&&(typeof de.cId=="number"?this.correlationId===void 0?this.correlationId=de.cId:this.correlationId!==de.cId&&(this.correlationId=ce.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=ce.MIXED_CORRELATION))}}contains(G,...ne){return this.doContains(G,{includeChildren:!1},...ne)}affects(G,...ne){return this.doContains(G,{includeChildren:!0},...ne)}doContains(G,ne,...de){if(!G)return!1;const we=de.length>0;return!!((!we||de.includes(1))&&(this.added.value.get(G)||ne.includeChildren&&this.added.value.findSuperstr(G))||(!we||de.includes(0))&&(this.updated.value.get(G)||ne.includeChildren&&this.updated.value.findSuperstr(G))||(!we||de.includes(2))&&(this.deleted.value.findSubstr(G)||ne.includeChildren&&this.deleted.value.findSuperstr(G)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(G){return this.correlationId===G}hasCorrelation(){return typeof this.correlationId=="number"}}t.FileChangesEvent=ce;function re(Z,G,ne){return!Z||!G||Z===G||G.length>Z.length?!1:(G.charAt(G.length-1)!==N.sep&&(G+=N.sep),ne?(0,x.startsWithIgnoreCase)(Z,G):Z.indexOf(G)===0)}class te extends Error{constructor(G,ne,de){super(G),this.fileOperationResult=ne,this.options=de}}t.FileOperationError=te;class be extends te{constructor(G,ne,de,we){super(G,ne,we),this.fileOperationResult=ne,this.size=de}}t.TooLargeFileOperationError=be;class Ee extends te{constructor(G,ne,de){super(G,2,de),this.stat=ne}}t.NotModifiedSinceFileOperationError=Ee;var Ie;(function(Z){Z[Z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Z[Z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Z[Z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Z[Z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Z[Z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Z[Z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Z[Z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Z[Z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Z[Z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Z[Z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Z[Z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Ie||(t.FileOperationResult=Ie={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude",t.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",t.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",t.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var Be;(function(Z){Z[Z.FILE=0]="FILE",Z[Z.FOLDER=1]="FOLDER",Z[Z.ROOT_FOLDER=2]="ROOT_FOLDER"})(Be||(t.FileKind=Be={})),t.ETAG_DISABLED="";function ue(Z){if(!(typeof Z.size!="number"||typeof Z.mtime!="number"))return Z.mtime.toString(29)+Z.size.toString(31)}async function J(Z,G){if(!G.hasProvider(_.URI.from({scheme:Z.scheme})))return new Promise(ne=>{const de=G.onDidChangeFileSystemProviderRegistrations(we=>{we.scheme===Z.scheme&&we.added&&(de.dispose(),ne())})})}class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(G){return(0,V.isNumber)(G)||(G=0),G<le.KB?(0,A.localize)(1,null,G.toFixed(0)):G<le.MB?(0,A.localize)(2,null,(G/le.KB).toFixed(2)):G<le.GB?(0,A.localize)(3,null,(G/le.MB).toFixed(2)):G<le.TB?(0,A.localize)(4,null,(G/le.GB).toFixed(2)):(0,A.localize)(5,null,(G/le.TB).toFixed(2))}}t.ByteSize=le;function ae(Z){const G=typeof Z=="string"||Z?.scheme===w.Schemas.vscodeRemote;return typeof Z!="string"&&Z?.scheme===w.Schemas.file?1024*le.MB:G?10*le.MB:p.isWeb?50*le.MB:1024*le.MB}}),define(ge[150],pe([1,0,50]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MainProcessService=t.IMainProcessService=void 0,t.IMainProcessService=(0,s.createDecorator)("mainProcessService");class N{constructor(V,_){this.server=V,this.router=_}getChannel(V){return this.server.getChannel(V,this.router)}registerChannel(V,_){this.server.registerChannel(V,_)}}t.MainProcessService=N}),define(ge[151],pe([1,0,2,145]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class x extends s.Disposable{constructor(_){super(),this.mainProcessConnection=this._register(new N.Client(`window:${_}`))}getChannel(_){return this.mainProcessConnection.getChannel(_)}registerChannel(_,A){this.mainProcessConnection.registerChannel(_,A)}}t.ElectronIPCMainProcessService=x});var Si=this&&this.__param||function(ie,t){return function(s,N){t(s,N,ie)}};define(ge[152],pe([1,0,77,150]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let x=class{constructor(_,A){return this.windowId=_,s.ProxyChannel.toService(A.getChannel("nativeHost"),{context:_,properties:(()=>{const m=new Map;return m.set("windowId",_),m})()})}};t.NativeHostService=x,t.NativeHostService=x=Xe([Si(1,N.IMainProcessService)],x)}),define(ge[78],pe([1,0,37,7]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class x{constructor(){this.data=new Map}add(_,A){s.ok(N.isString(_)),s.ok(N.isObject(A)),s.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,A)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}t.Registry=new x}),define(ge[153],pe([1,0,4,78]),function(ie,t,s,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function x(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class V{constructor(){this._onDidChangeSchema=new s.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,p){this.schemasById[x(m)]=p,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new V;N.Registry.add(t.Extensions.JSONContribution,_)}),define(ge[154],pe([1,0,9,18,44,19,4,7,16,147,153,78]),function(ie,t,s,N,x,V,_,A,m,p,w,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.registerIcon=r,t.getIconRegistry=u,t.Extensions={IconContribution:"base.contributions.icons"};var h;(function(f){function o(C,F){let R=C.defaults;for(;V.ThemeIcon.isThemeIcon(R);){const B=i.getIcon(R.id);if(!B)return;R=B.defaults}return R}f.getDefinition=o})(h||(t.IconContribution=h={}));var d;(function(f){function o(F){return{weight:F.weight,style:F.style,src:F.src.map(R=>({format:R.format,location:R.location.toString()}))}}f.toJSONObject=o;function C(F){const R=B=>(0,A.isString)(B)?B:void 0;if(F&&Array.isArray(F.src)&&F.src.every(B=>(0,A.isString)(B.format)&&(0,A.isString)(B.location)))return{weight:R(F.weight),style:R(F.style),src:F.src.map(B=>({format:B.format,location:m.URI.parse(B.location)}))}}f.fromJSONObject=C})(d||(t.IconFontDefinition=d={}));class e{constructor(){this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,p.localize)(0,null)},fontCharacter:{type:"string",description:(0,p.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${V.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(o,C,F,R){const B=this.iconsById[o];if(B){if(F&&!B.description){B.description=F,this.iconSchema.properties[o].markdownDescription=`${F} $(${o})`;const O=this.iconReferenceSchema.enum.indexOf(o);O!==-1&&(this.iconReferenceSchema.enumDescriptions[O]=F),this._onDidChange.fire()}return B}const P={id:o,description:F,defaults:C,deprecationMessage:R};this.iconsById[o]=P;const b={$ref:"#/definitions/icons"};return R&&(b.deprecationMessage=R),F&&(b.markdownDescription=`${F}: $(${o})`),this.iconSchema.properties[o]=b,this.iconReferenceSchema.enum.push(o),this.iconReferenceSchema.enumDescriptions.push(F||""),this._onDidChange.fire(),{id:o}}deregisterIcon(o){delete this.iconsById[o],delete this.iconSchema.properties[o];const C=this.iconReferenceSchema.enum.indexOf(o);C!==-1&&(this.iconReferenceSchema.enum.splice(C,1),this.iconReferenceSchema.enumDescriptions.splice(C,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(o=>this.iconsById[o])}getIcon(o){return this.iconsById[o]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(o,C){const F=this.iconFontsById[o];return F||(this.iconFontsById[o]=C,this._onDidChange.fire(),C)}deregisterIconFont(o){delete this.iconFontsById[o]}getIconFont(o){return this.iconFontsById[o]}toString(){const o=(B,P)=>B.id.localeCompare(P.id),C=B=>{for(;V.ThemeIcon.isThemeIcon(B.defaults);)B=this.iconsById[B.defaults.id];return`codicon codicon-${B?B.id:""}`},F=[];F.push("| preview     | identifier                        | default codicon ID                | description"),F.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const R=Object.keys(this.iconsById).map(B=>this.iconsById[B]);for(const B of R.filter(P=>!!P.description).sort(o))F.push(`|<i class="${C(B)}"></i>|${B.id}|${V.ThemeIcon.isThemeIcon(B.defaults)?B.defaults.id:B.id}|${B.description||""}|`);F.push("| preview     | identifier                        "),F.push("| ----------- | --------------------------------- |");for(const B of R.filter(P=>!V.ThemeIcon.isThemeIcon(P.defaults)).sort(o))F.push(`|<i class="${C(B)}"></i>|${B.id}|`);return F.join(`
`)}}const i=new e;W.Registry.add(t.Extensions.IconContribution,i);function r(f,o,C,F){return i.registerIcon(f,o,C,F)}function u(){return i}function g(){const f=(0,x.getCodiconFontCharacters)();for(const o in f){const C="\\"+f[o].toString(16);i.registerIcon(o,{fontCharacter:C})}}g(),t.iconsSchemaId="vscode://schemas/icons";const D=W.Registry.as(w.Extensions.JSONContribution);D.registerSchema(t.iconsSchemaId,i.getIconSchema());const a=new s.RunOnceScheduler(()=>D.notifySchemaChanged(t.iconsSchemaId),200);i.onDidChange(()=>{a.isScheduled()||a.schedule()}),t.widgetClose=r("widget-close",N.Codicon.close,(0,p.localize)(2,null)),t.gotoPreviousLocation=r("goto-previous-location",N.Codicon.arrowUp,(0,p.localize)(3,null)),t.gotoNextLocation=r("goto-next-location",N.Codicon.arrowDown,(0,p.localize)(4,null)),t.syncing=V.ThemeIcon.modify(N.Codicon.sync,"spin"),t.spinningLoading=V.ThemeIcon.modify(N.Codicon.loading,"spin")}),define(ge[155],pe([1,0,3,4,2,19,154]),function(ie,t,s,N,x,V,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=void 0,t.getIconsStyleSheet=A;function A(p){const w=new x.DisposableStore,W=w.add(new N.Emitter),h=(0,_.getIconRegistry)();return w.add(h.onDidChange(()=>W.fire())),p&&w.add(p.onDidProductIconThemeChange(()=>W.fire())),{dispose:()=>w.dispose(),onDidChange:W.event,getCSS(){const d=p?p.getProductIconTheme():new m,e={},i=u=>{const g=d.getIcon(u);if(!g)return;const D=g.font;return D?(e[D.id]=D.definition,`.codicon-${u.id}:before { content: '${g.fontCharacter}'; font-family: ${(0,s.asCSSPropertyValue)(D.id)}; }`):`.codicon-${u.id}:before { content: '${g.fontCharacter}'; }`},r=[];for(const u of h.getIcons()){const g=i(u);g&&r.push(g)}for(const u in e){const g=e[u],D=g.weight?`font-weight: ${g.weight};`:"",a=g.style?`font-style: ${g.style};`:"",f=g.src.map(o=>`${(0,s.asCSSUrl)(o.location)} format('${o.format}')`).join(", ");r.push(`@font-face { src: ${f}; font-family: ${(0,s.asCSSPropertyValue)(u)};${D}${a} font-display: block; }`)}return r.join(`
`)}}}class m{getIcon(w){const W=(0,_.getIconRegistry)();let h=w.defaults;for(;V.ThemeIcon.isThemeIcon(h);){const d=W.getIcon(h.id);if(!d)return;h=d.defaults}return h}}t.UnthemedProductIconTheme=m}),define(ge[156],pe([1,0,5]),function(ie,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.WindowMinimumSize=void 0,t.isOpenedAuxiliaryWindow=N,t.isWorkspaceToOpen=x,t.isFolderToOpen=V,t.isFileToOpen=_,t.getMenuBarVisibility=A,t.hasCustomTitlebar=W,t.hasNativeTitlebar=h,t.getTitleBarStyle=d,t.useWindowControlsOverlay=e,t.useNativeFullScreen=i,t.zoomLevelToZoomFactor=r,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function N(u){return typeof u.parentId=="number"}function x(u){return!!u.workspaceUri}function V(u){return!!u.folderUri}function _(u){return!!u.fileUri}function A(u){const g=h(u),D=u.getValue("window.menuBarVisibility");return D==="default"||g&&D==="compact"||s.isMacintosh&&s.isNative?"classic":D}var m;(function(u){u.TITLE_BAR_STYLE="window.titleBarStyle",u.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(m||(t.TitleBarSetting=m={}));var p;(function(u){u.NATIVE="native",u.CUSTOM="custom"})(p||(t.TitlebarStyle=p={}));var w;(function(u){u.AUTO="auto",u.WINDOWED="windowed",u.NEVER="never"})(w||(t.CustomTitleBarVisibility=w={}));function W(u,g){return!0}function h(u,g){return g||(g=d(u)),g==="native"}function d(u){if(s.isWeb)return"custom";const g=u.getValue("window");if(g){if(s.isMacintosh&&g.nativeTabs===!0||s.isMacintosh&&g.nativeFullScreen===!1)return"native";const f=g.titleBarStyle;if(f==="native"||f==="custom")return f}return s.isLinux?"native":"custom"}function e(u){return!(!s.isWindows||s.isWeb||h(u))}function i(u){const g=u.getValue("window");return!g||typeof g.nativeFullScreen!="boolean"||g.nativeTabs?!0:g.nativeFullScreen!==!1}function r(u=0){return Math.pow(1.2,u)}}),define(ge[157],pe([1,0,17,3,22,34,156]),function(ie,t,s,N,x,V,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MIN_ZOOM_LEVEL=t.MAX_ZOOM_LEVEL=t.ApplyZoomTarget=void 0,t.applyZoom=m,t.zoomIn=w,t.zoomOut=W;var A;(function(h){h[h.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",h[h.ALL_WINDOWS=2]="ALL_WINDOWS"})(A||(t.ApplyZoomTarget=A={})),t.MAX_ZOOM_LEVEL=8,t.MIN_ZOOM_LEVEL=-8;function m(h,d){h=Math.min(Math.max(h,t.MIN_ZOOM_LEVEL),t.MAX_ZOOM_LEVEL);const e=[];d===A.ACTIVE_WINDOW?e.push((0,N.getActiveWindow)()):d===A.ALL_WINDOWS?e.push(...Array.from((0,N.getWindows)()).map(({window:i})=>i)):e.push(d);for(const i of e)p(i)?.webFrame?.setZoomLevel(h),(0,s.setZoomFactor)((0,_.zoomLevelToZoomFactor)(h),i),(0,s.setZoomLevel)(h,i)}function p(h){if(h===x.mainWindow)return{ipcRenderer:V.ipcRenderer,webFrame:V.webFrame};{const d=h;if(d?.vscode?.ipcRenderer&&d?.vscode?.webFrame)return d.vscode}}function w(h){m((0,s.getZoomLevel)(typeof h=="number"?(0,N.getActiveWindow)():h)+1,h)}function W(h){m((0,s.getZoomLevel)(typeof h=="number"?(0,N.getActiveWindow)():h)-1,h)}}),define(ge[158],pe([1,0,11,3,144,9,103,34,148,149,151,152,155,157,15,22,116,107]),function(ie,t,s,N,x,V,_,A,m,p,w,W,h,d,e,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=O;const r=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,u=/\s--inspect-port=(?<port>\d+)/;class g{getHeight(k){return 22}getTemplateId(k){return B(k)?"process":F(k)?"machine":(0,m.isRemoteDiagnosticError)(k)?"error":R(k)?"header":""}}class D{hasChildren(k){return(0,m.isRemoteDiagnosticError)(k)?!1:B(k)?!!k.children?.length:!0}getChildren(k){return B(k)?k.children?k.children:[]:(0,m.isRemoteDiagnosticError)(k)?[]:R(k)?k.processRoots.length>1?k.processRoots:[k.processRoots[0].rootProcess]:F(k)?[k.rootProcess]:[k.processes]}}class a{constructor(){this.templateId="header"}renderTemplate(k){const M=(0,N.append)(k,(0,N.$)(".row")),I=(0,N.append)(M,(0,N.$)(".nameLabel")),q=(0,N.append)(M,(0,N.$)(".cpu")),X=(0,N.append)(M,(0,N.$)(".memory")),ce=(0,N.append)(M,(0,N.$)(".pid"));return{name:I,CPU:q,memory:X,PID:ce}}renderElement(k,M,I,q){I.name.textContent=(0,s.localize)(0,null),I.CPU.textContent=(0,s.localize)(1,null),I.PID.textContent=(0,s.localize)(2,null),I.memory.textContent=(0,s.localize)(3,null)}disposeTemplate(k){}}class f{constructor(){this.templateId="machine"}renderTemplate(k){const M=Object.create(null),I=(0,N.append)(k,(0,N.$)(".row"));return M.name=(0,N.append)(I,(0,N.$)(".nameLabel")),M}renderElement(k,M,I,q){I.name.textContent=k.element.name}disposeTemplate(k){}}class o{constructor(){this.templateId="error"}renderTemplate(k){const M=Object.create(null),I=(0,N.append)(k,(0,N.$)(".row"));return M.name=(0,N.append)(I,(0,N.$)(".nameLabel")),M}renderElement(k,M,I,q){I.name.textContent=k.element.errorMessage}disposeTemplate(k){}}class C{constructor(k,M,I){this.platform=k,this.totalMem=M,this.mapPidToName=I,this.templateId="process"}renderTemplate(k){const M=(0,N.append)(k,(0,N.$)(".row")),I=(0,N.append)(M,(0,N.$)(".nameLabel")),q=(0,N.append)(M,(0,N.$)(".cpu")),X=(0,N.append)(M,(0,N.$)(".memory")),ce=(0,N.append)(M,(0,N.$)(".pid"));return{name:I,CPU:q,PID:ce,memory:X}}renderElement(k,M,I,q){const{element:X}=k,ce=X.pid.toFixed(0);let re=X.name;this.mapPidToName.has(X.pid)&&(re=this.mapPidToName.get(X.pid)),I.name.textContent=re,I.name.title=X.cmd,I.CPU.textContent=X.load.toFixed(0),I.PID.textContent=ce,I.PID.parentElement.id=`pid-${ce}`;const te=this.platform==="win32"?X.mem:this.totalMem*(X.mem/100);I.memory.textContent=(te/p.ByteSize.MB).toFixed(0)}disposeTemplate(k){}}function F($){return!!$.name&&!!$.rootProcess}function R($){return!!$.processRoots}function B($){return!!$.pid}class P{constructor(k,M){this.data=M,this.mapPidToName=new Map;const I=new w.ElectronIPCMainProcessService(k);this.nativeHostService=new W.NativeHostService(k,I),this.applyStyles(M.styles),this.setEventHandlers(M),A.ipcRenderer.on("vscode:pidToNameResponse",(q,X)=>{this.mapPidToName.clear();for(const[ce,re]of X)this.mapPidToName.set(ce,re)}),A.ipcRenderer.on("vscode:listProcessesResponse",async(q,X)=>{X.forEach((ce,re)=>{B(ce.rootProcess)&&(ce.rootProcess.name=re===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?(this.tree.setInput({processes:{processRoots:X}}),this.tree.layout(i.mainWindow.innerHeight,i.mainWindow.innerWidth)):await this.createProcessTree(X),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),A.ipcRenderer.send("vscode:pidToNameRequest"),A.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(k){i.mainWindow.document.onkeydown=M=>{const I=k.platform==="darwin"?M.metaKey:M.ctrlKey;I&&M.keyCode===87&&(M.stopPropagation(),M.preventDefault(),A.ipcRenderer.send("vscode:closeProcessExplorer")),I&&M.keyCode===187&&(0,d.zoomIn)(i.mainWindow),I&&M.keyCode===189&&(0,d.zoomOut)(i.mainWindow)}}async createProcessTree(k){const M=i.mainWindow.document.getElementById("process-list");if(!M)return;const{totalmem:I}=await this.nativeHostService.getOSStatistics(),q=[new C(this.data.platform,I,this.mapPidToName),new a,new f,new o];this.tree=new x.DataTree("processExplorer",M,new g,q,new D,{identityProvider:{getId:X=>B(X)?X.pid.toString():(0,m.isRemoteDiagnosticError)(X)?X.hostName:R(X)?"processes":F(X)?X.name:"header"}}),this.tree.setInput({processes:{processRoots:k}}),this.tree.layout(i.mainWindow.innerHeight,i.mainWindow.innerWidth),this.tree.onKeyDown(X=>{const ce=new e.StandardKeyboardEvent(X);if(ce.keyCode===35&&ce.altKey){const re=this.getSelectedPids();Promise.all(re.map(te=>this.nativeHostService.killProcess(te,"SIGTERM"))).then(()=>this.tree?.refresh())}}),this.tree.onContextMenu(X=>{B(X.element)&&this.showContextMenu(X.element,!0)}),M.style.height=`${i.mainWindow.innerHeight}px`,i.mainWindow.addEventListener("resize",()=>{M.style.height=`${i.mainWindow.innerHeight}px`,this.tree?.layout(i.mainWindow.innerHeight,i.mainWindow.innerWidth)})}isDebuggable(k){const M=r.exec(k);return M&&M.groups.port!=="0"||k.indexOf("node ")>=0||k.indexOf("node.exe")>=0}attachTo(k){const M={type:"node",request:"attach",name:`process ${k.pid}`};let I=r.exec(k.cmd);I?M.port=Number(I.groups.port):M.processId=String(k.pid),I=u.exec(k.cmd),I&&(M.port=Number(I.groups.port)),A.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[M]})}applyStyles(k){const M=(0,N.createStyleSheet)(),I=[];k.listFocusBackground&&(I.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${k.listFocusBackground}; }`),I.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${k.listFocusBackground}; }`)),k.listFocusForeground&&I.push(`.monaco-list:focus .monaco-list-row.focused { color: ${k.listFocusForeground}; }`),k.listActiveSelectionBackground&&(I.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${k.listActiveSelectionBackground}; }`),I.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${k.listActiveSelectionBackground}; }`)),k.listActiveSelectionForeground&&I.push(`.monaco-list:focus .monaco-list-row.selected { color: ${k.listActiveSelectionForeground}; }`),k.listHoverBackground&&I.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${k.listHoverBackground}; }`),k.listHoverForeground&&I.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${k.listHoverForeground}; }`),k.listFocusOutline&&I.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${k.listFocusOutline}; outline-offset: -1px; }`),k.listHoverOutline&&I.push(`.monaco-list-row:hover { outline: 1px dashed ${k.listHoverOutline}; outline-offset: -1px; }`),k.scrollbarShadowColor&&I.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${k.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${k.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${k.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),k.scrollbarSliderBackgroundColor&&I.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${k.scrollbarSliderBackgroundColor};
				}
			`),k.scrollbarSliderHoverBackgroundColor&&I.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${k.scrollbarSliderHoverBackgroundColor};
				}
			`),k.scrollbarSliderActiveBackgroundColor&&I.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${k.scrollbarSliderActiveBackgroundColor};
				}
			`),M.textContent=I.join(`
`),k.color&&(i.mainWindow.document.body.style.color=k.color)}showContextMenu(k,M){const I=[],q=Number(k.pid);M&&(I.push({accelerator:"Alt+E",label:(0,s.localize)(4,null),click:()=>{this.nativeHostService.killProcess(q,"SIGTERM")}}),I.push({label:(0,s.localize)(5,null),click:()=>{this.nativeHostService.killProcess(q,"SIGKILL")}}),I.push({type:"separator"})),I.push({label:(0,s.localize)(6,null),click:()=>{const X=this.getSelectedPids();X?.includes(q)||(X.length=0,X.push(q));const ce=X?.map(re=>i.mainWindow.document.getElementById(`pid-${re}`)).filter(re=>!!re);if(ce){const re=ce.map(te=>te.innerText).filter(te=>!!te);this.nativeHostService.writeClipboardText(re.join(`
`))}}}),I.push({label:(0,s.localize)(7,null),click:()=>{const X=i.mainWindow.document.getElementById("process-list");X&&this.nativeHostService.writeClipboardText(X.innerText)}}),k&&M&&this.isDebuggable(k.cmd)&&(I.push({type:"separator"}),I.push({label:(0,s.localize)(8,null),click:()=>{this.attachTo(k)}})),(0,_.popup)(I)}requestProcessList(k){setTimeout(()=>{const M=Date.now(),I=k+M-this.lastRequestTime;this.lastRequestTime=M,I>1e3?(A.ipcRenderer.send("vscode:pidToNameRequest"),A.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList(I)},200)}getSelectedPids(){return this.tree?.getSelection()?.map(k=>{if(!(!k||!("pid"in k)))return k.pid}).filter(k=>!!k)}}function b(){const $=(0,N.createStyleSheet)();$.id="codiconStyles";const k=(0,h.getIconsStyleSheet)(void 0);function M(){$.textContent=k.getCSS()}const I=new V.RunOnceScheduler(M,0);k.onDidChange(()=>I.schedule()),I.schedule()}function O($){const k=$.data.platform==="win32"?"windows":$.data.platform==="linux"?"linux":"mac";i.mainWindow.document.body.classList.add(k),b(),(0,d.applyZoom)($.data.zoomLevel,i.mainWindow),new P($.windowId,$.data)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0d01a72525276e5e3771fe5851b9c83de0de1e2b/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
