/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/contextkey/common/contextkey","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],_e=function(de){for(var e=[],c=0,O=de.length;c<O;c++)e[c]=ye[de[c]];return e};define(ye[162],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class c{static get(){const L=new Map,T=new Map,R=new Map,b=new Map;function p(C,S){C.has(S.detail)||C.set(S.detail,-S.timestamp)}function w(C,S){const a=C.get(S.detail);a&&(a>=0||C.set(S.detail,a+S.timestamp))}let A=[];typeof de=="function"&&typeof de.getStats=="function"&&(A=de.getStats().slice(0).sort((C,S)=>C.timestamp-S.timestamp));for(const C of A)switch(C.type){case 10:p(L,C);break;case 11:case 12:w(L,C);break;case 21:p(T,C);break;case 22:w(T,C);break;case 33:p(R,C);break;case 34:w(R,C);break;case 31:p(b,C);break;case 32:w(b,C);break}let I=0;R.forEach(C=>I+=C);function v(C){const S=[];return C.forEach((a,m)=>S.push([m,a])),S}return{amdLoad:v(L),amdInvoke:v(T),nodeRequire:v(R),nodeEval:v(b),nodeRequireTotal:I}}static toMarkdownTable(L,T){let R="";const b=[];return L.forEach((p,w)=>{b[w]=p.length}),T.forEach(p=>{p.forEach((w,A)=>{typeof w>"u"&&(w=p[A]="-");const I=w.toString().length;b[A]=Math.max(I,b[A])})}),L.forEach((p,w)=>{R+=`| ${p+" ".repeat(b[w]-p.toString().length)} `}),R+=`|
`,L.forEach((p,w)=>{R+=`| ${"-".repeat(b[w])} `}),R+=`|
`,T.forEach(p=>{p.forEach((w,A)=>{typeof w<"u"&&(R+=`| ${w+" ".repeat(b[A]-w.toString().length)} `)}),R+=`|
`}),R}}e.LoaderStats=c}),define(ye[163],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=c,e.findLastIdx=O,e.findLastMonotonous=L,e.findLastIdxMonotonous=T,e.findFirstMonotonous=R,e.findFirstIdxMonotonousOrArrLen=b,e.findFirstIdxMonotonous=p,e.findFirstMaxBy=A,e.findLastMaxBy=I,e.findFirstMinBy=v,e.findMaxIdxBy=C,e.mapFindFirst=S;function c(a,m,o){const n=O(a,m);if(n!==-1)return a[n]}function O(a,m,o=a.length-1){for(let n=o;n>=0;n--){const i=a[n];if(m(i))return n}return-1}function L(a,m){const o=T(a,m);return o===-1?void 0:a[o]}function T(a,m,o=0,n=a.length){let i=o,r=n;for(;i<r;){const s=Math.floor((i+r)/2);m(a[s])?i=s+1:r=s}return i-1}function R(a,m){const o=b(a,m);return o===a.length?void 0:a[o]}function b(a,m,o=0,n=a.length){let i=o,r=n;for(;i<r;){const s=Math.floor((i+r)/2);m(a[s])?r=s:i=s+1}return i}function p(a,m,o=0,n=a.length){const i=b(a,m,o,n);return i===a.length?-1:i}class w{static{this.assertInvariants=!1}constructor(m){this._array=m,this._findLastMonotonousLastIdx=0}findLastMonotonous(m){if(w.assertInvariants){if(this._prevFindLastPredicate){for(const n of this._array)if(this._prevFindLastPredicate(n)&&!m(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=m}const o=T(this._array,m,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=o+1,o===-1?void 0:this._array[o]}}e.MonotonousArray=w;function A(a,m){if(a.length===0)return;let o=a[0];for(let n=1;n<a.length;n++){const i=a[n];m(i,o)>0&&(o=i)}return o}function I(a,m){if(a.length===0)return;let o=a[0];for(let n=1;n<a.length;n++){const i=a[n];m(i,o)>=0&&(o=i)}return o}function v(a,m){return A(a,(o,n)=>-m(o,n))}function C(a,m){if(a.length===0)return-1;let o=0;for(let n=1;n<a.length;n++){const i=a[n];m(i,a[o])>0&&(o=n)}return o}function S(a,m){for(const o of a){const n=m(o);if(n!==void 0)return n}}}),define(ye[73],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.groupBy=c,e.diffSets=O,e.diffMaps=L,e.intersection=T;function c(R,b){const p=Object.create(null);for(const w of R){const A=b(w);let I=p[A];I||(I=p[A]=[]),I.push(w)}return p}function O(R,b){const p=[],w=[];for(const A of R)b.has(A)||p.push(A);for(const A of b)R.has(A)||w.push(A);return{removed:p,added:w}}function L(R,b){const p=[],w=[];for(const[A,I]of R)b.has(A)||p.push(I);for(const[A,I]of b)R.has(A)||w.push(I);return{removed:p,added:w}}function T(R,b){const p=new Set;for(const w of b)R.has(w)&&p.add(w);return p}}),define(ye[54],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=O,e.debounce=L,e.throttle=T;function c(R){return(b,p,w)=>{let A=null,I=null;if(typeof w.value=="function"?(A="value",I=w.value):typeof w.get=="function"&&(A="get",I=w.get),!I)throw new Error("not supported");w[A]=R(I,p)}}function O(R,b,p){let w=null,A=null;if(typeof p.value=="function"?(w="value",A=p.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(w="get",A=p.get),!A)throw new Error("not supported");const I=`$memoize$${b}`;p[w]=function(...v){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,v)}),this[I]}}function L(R,b,p){return c((w,A)=>{const I=`$debounce$${A}`,v=`$debounce$result$${A}`;return function(...C){this[v]||(this[v]=p?p():void 0),clearTimeout(this[I]),b&&(this[v]=b(this[v],...C),C=[this[v]]),this[I]=setTimeout(()=>{w.apply(this,C),this[v]=p?p():void 0},R)}})}function T(R,b,p){return c((w,A)=>{const I=`$throttle$timer$${A}`,v=`$throttle$result$${A}`,C=`$throttle$lastRun$${A}`,S=`$throttle$pending$${A}`;return function(...a){if(this[v]||(this[v]=p?p():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),b&&(this[v]=b(this[v],...a)),this[S])return;const m=this[C]+R;m<=Date.now()?(this[C]=Date.now(),w.apply(this,[this[v]]),this[v]=p?p():void 0):(this[S]=!0,this[I]=setTimeout(()=>{this[S]=!1,this[C]=Date.now(),w.apply(this,[this[v]]),this[v]=p?p():void 0},m-Date.now()))}})}}),define(ye[13],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=O,e.isSigPipeError=L,e.onUnexpectedError=T,e.onUnexpectedExternalError=R,e.transformErrorForSerialization=b,e.isCancellationError=w,e.canceled=I,e.illegalArgument=v,e.illegalState=C,e.getErrorMessage=a;class c{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(f=>{f(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=c,e.errorHandler=new c;function O(s){e.errorHandler.setUnexpectedErrorHandler(s)}function L(s){if(!s||typeof s!="object")return!1;const t=s;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function T(s){w(s)||e.errorHandler.onUnexpectedError(s)}function R(s){w(s)||e.errorHandler.onUnexpectedExternalError(s)}function b(s){if(s instanceof Error){const{name:t,message:f}=s,h=s.stacktrace||s.stack;return{$isError:!0,name:t,message:f,stack:h,noTelemetry:i.isErrorNoTelemetry(s)}}return s}const p="Canceled";function w(s){return s instanceof A?!0:s instanceof Error&&s.name===p&&s.message===p}class A extends Error{constructor(){super(p),this.name=this.message}}e.CancellationError=A;function I(){const s=new Error(p);return s.name=s.message,s}function v(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function C(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=S;function a(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=m;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=o;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const f=new i;return f.message=t.message,f.stack=t.stack,f}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=i;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.BugIndicatingError=r}),define(ye[19],_e([1,0,13,163]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=L,e.tail2=T,e.equals=R,e.removeFastWithoutKeepingOrder=b,e.binarySearch=p,e.binarySearch2=w,e.quickSelect=A,e.groupBy=I,e.groupAdjacentBy=v,e.forEachAdjacent=C,e.forEachWithNeighbors=S,e.sortedDiff=a,e.delta=m,e.top=o,e.topAsync=n,e.coalesce=r,e.coalesceInPlace=s,e.move=t,e.isFalsyOrEmpty=f,e.isNonEmptyArray=h,e.distinct=l,e.uniqueFilter=u,e.firstOrDefault=d,e.lastOrDefault=g,e.commonPrefixLength=D,e.flatten=E,e.range=_,e.index=y,e.insert=P,e.remove=k,e.arrayInsert=z,e.shuffle=x,e.pushToStart=F,e.pushToEnd=N,e.pushMany=M,e.mapArrayOrNot=B,e.asArray=W,e.getRandomElement=Y,e.insertInto=Z,e.splice=G,e.compareBy=te,e.tieBreakComparators=ve,e.reverseOrder=$;function L(ae,ce=0){return ae[ae.length-(1+ce)]}function T(ae){if(ae.length===0)throw new Error("Invalid tail call");return[ae.slice(0,ae.length-1),ae[ae.length-1]]}function R(ae,ce,se=(j,ie)=>j===ie){if(ae===ce)return!0;if(!ae||!ce||ae.length!==ce.length)return!1;for(let j=0,ie=ae.length;j<ie;j++)if(!se(ae[j],ce[j]))return!1;return!0}function b(ae,ce){const se=ae.length-1;ce<se&&(ae[ce]=ae[se]),ae.pop()}function p(ae,ce,se){return w(ae.length,j=>se(ae[j],ce))}function w(ae,ce){let se=0,j=ae-1;for(;se<=j;){const ie=(se+j)/2|0,ue=ce(ie);if(ue<0)se=ie+1;else if(ue>0)j=ie-1;else return ie}return-(se+1)}function A(ae,ce,se){if(ae=ae|0,ae>=ce.length)throw new TypeError("invalid index");const j=ce[Math.floor(ce.length*Math.random())],ie=[],ue=[],he=[];for(const Te of ce){const me=se(Te,j);me<0?ie.push(Te):me>0?ue.push(Te):he.push(Te)}return ae<ie.length?A(ae,ie,se):ae<ie.length+he.length?he[0]:A(ae-(ie.length+he.length),ue,se)}function I(ae,ce){const se=[];let j;for(const ie of ae.slice(0).sort(ce))!j||ce(j[0],ie)!==0?(j=[ie],se.push(j)):j.push(ie);return se}function*v(ae,ce){let se,j;for(const ie of ae)j!==void 0&&ce(j,ie)?se.push(ie):(se&&(yield se),se=[ie]),j=ie;se&&(yield se)}function C(ae,ce){for(let se=0;se<=ae.length;se++)ce(se===0?void 0:ae[se-1],se===ae.length?void 0:ae[se])}function S(ae,ce){for(let se=0;se<ae.length;se++)ce(se===0?void 0:ae[se-1],ae[se],se+1===ae.length?void 0:ae[se+1])}function a(ae,ce,se){const j=[];function ie(Te,me,Pe){if(me===0&&Pe.length===0)return;const Ae=j[j.length-1];Ae&&Ae.start+Ae.deleteCount===Te?(Ae.deleteCount+=me,Ae.toInsert.push(...Pe)):j.push({start:Te,deleteCount:me,toInsert:Pe})}let ue=0,he=0;for(;;){if(ue===ae.length){ie(ue,0,ce.slice(he));break}if(he===ce.length){ie(ue,ae.length-ue,[]);break}const Te=ae[ue],me=ce[he],Pe=se(Te,me);Pe===0?(ue+=1,he+=1):Pe<0?(ie(ue,1,[]),ue+=1):Pe>0&&(ie(ue,0,[me]),he+=1)}return j}function m(ae,ce,se){const j=a(ae,ce,se),ie=[],ue=[];for(const he of j)ie.push(...ae.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:ie,added:ue}}function o(ae,ce,se){if(se===0)return[];const j=ae.slice(0,se).sort(ce);return i(ae,ce,j,se,ae.length),j}function n(ae,ce,se,j,ie){return se===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const Te=ae.length,me=ae.slice(0,se).sort(ce);for(let Pe=se,Ae=Math.min(se+j,Te);Pe<Te;Pe=Ae,Ae=Math.min(Ae+j,Te)){if(Pe>se&&await new Promise(xe=>setTimeout(xe)),ie&&ie.isCancellationRequested)throw new c.CancellationError;i(ae,ce,me,Pe,Ae)}return me})().then(ue,he)})}function i(ae,ce,se,j,ie){for(const ue=se.length;j<ie;j++){const he=ae[j];if(ce(he,se[ue-1])<0){se.pop();const Te=(0,O.findFirstIdxMonotonousOrArrLen)(se,me=>ce(he,me)<0);se.splice(Te,0,he)}}}function r(ae){return ae.filter(ce=>!!ce)}function s(ae){let ce=0;for(let se=0;se<ae.length;se++)ae[se]&&(ae[ce]=ae[se],ce+=1);ae.length=ce}function t(ae,ce,se){ae.splice(se,0,ae.splice(ce,1)[0])}function f(ae){return!Array.isArray(ae)||ae.length===0}function h(ae){return Array.isArray(ae)&&ae.length>0}function l(ae,ce=se=>se){const se=new Set;return ae.filter(j=>{const ie=ce(j);return se.has(ie)?!1:(se.add(ie),!0)})}function u(ae){const ce=new Set;return se=>{const j=ae(se);return ce.has(j)?!1:(ce.add(j),!0)}}function d(ae,ce){return ae.length>0?ae[0]:ce}function g(ae,ce){return ae.length>0?ae[ae.length-1]:ce}function D(ae,ce,se=(j,ie)=>j===ie){let j=0;for(let ie=0,ue=Math.min(ae.length,ce.length);ie<ue&&se(ae[ie],ce[ie]);ie++)j++;return j}function E(ae){return[].concat(...ae)}function _(ae,ce){let se=typeof ce=="number"?ae:0;typeof ce=="number"?se=ae:(se=0,ce=ae);const j=[];if(se<=ce)for(let ie=se;ie<ce;ie++)j.push(ie);else for(let ie=se;ie>ce;ie--)j.push(ie);return j}function y(ae,ce,se){return ae.reduce((j,ie)=>(j[ce(ie)]=se?se(ie):ie,j),Object.create(null))}function P(ae,ce){return ae.push(ce),()=>k(ae,ce)}function k(ae,ce){const se=ae.indexOf(ce);if(se>-1)return ae.splice(se,1),ce}function z(ae,ce,se){const j=ae.slice(0,ce),ie=ae.slice(ce);return j.concat(se,ie)}function x(ae,ce){let se;if(typeof ce=="number"){let j=ce;se=()=>{const ie=Math.sin(j++)*179426549;return ie-Math.floor(ie)}}else se=Math.random;for(let j=ae.length-1;j>0;j-=1){const ie=Math.floor(se()*(j+1)),ue=ae[j];ae[j]=ae[ie],ae[ie]=ue}}function F(ae,ce){const se=ae.indexOf(ce);se>-1&&(ae.splice(se,1),ae.unshift(ce))}function N(ae,ce){const se=ae.indexOf(ce);se>-1&&(ae.splice(se,1),ae.push(ce))}function M(ae,ce){for(const se of ce)ae.push(se)}function B(ae,ce){return Array.isArray(ae)?ae.map(ce):ce(ae)}function W(ae){return Array.isArray(ae)?ae:[ae]}function Y(ae){return ae[Math.floor(Math.random()*ae.length)]}function Z(ae,ce,se){const j=Q(ae,ce),ie=ae.length,ue=se.length;ae.length=ie+ue;for(let he=ie-1;he>=j;he--)ae[he+ue]=ae[he];for(let he=0;he<ue;he++)ae[he+j]=se[he]}function G(ae,ce,se,j){const ie=Q(ae,ce);let ue=ae.splice(ie,se);return ue===void 0&&(ue=[]),Z(ae,ie,j),ue}function Q(ae,ce){return ce<0?Math.max(ce+ae.length,0):Math.min(ce,ae.length)}var re;(function(ae){function ce(ue){return ue<0}ae.isLessThan=ce;function se(ue){return ue<=0}ae.isLessThanOrEqual=se;function j(ue){return ue>0}ae.isGreaterThan=j;function ie(ue){return ue===0}ae.isNeitherLessOrGreaterThan=ie,ae.greaterThan=1,ae.lessThan=-1,ae.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function te(ae,ce){return(se,j)=>ce(ae(se),ae(j))}function ve(...ae){return(ce,se)=>{for(const j of ae){const ie=j(ce,se);if(!re.isNeitherLessOrGreaterThan(ie))return ie}return re.neitherLessOrGreaterThan}}const Ie=(ae,ce)=>ae-ce;e.numberComparator=Ie;const J=(ae,ce)=>(0,e.numberComparator)(ae?1:0,ce?1:0);e.booleanComparator=J;function $(ae){return(ce,se)=>-ae(ce,se)}class ne{constructor(ce){this.items=ce,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ce){let se=this.firstIdx;for(;se<this.items.length&&ce(this.items[se]);)se++;const j=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,j}takeFromEndWhile(ce){let se=this.lastIdx;for(;se>=0&&ce(this.items[se]);)se--;const j=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,j}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ce=this.items[this.firstIdx];return this.firstIdx++,ce}removeLast(){const ce=this.items[this.lastIdx];return this.lastIdx--,ce}takeCount(ce){const se=this.items.slice(this.firstIdx,this.firstIdx+ce);return this.firstIdx+=ce,se}}e.ArrayQueue=ne;class be{static{this.empty=new be(ce=>{})}constructor(ce){this.iterate=ce}forEach(ce){this.iterate(se=>(ce(se),!0))}toArray(){const ce=[];return this.iterate(se=>(ce.push(se),!0)),ce}filter(ce){return new be(se=>this.iterate(j=>ce(j)?se(j):!0))}map(ce){return new be(se=>this.iterate(j=>se(ce(j))))}some(ce){let se=!1;return this.iterate(j=>(se=ce(j),!se)),se}findFirst(ce){let se;return this.iterate(j=>ce(j)?(se=j,!1):!0),se}findLast(ce){let se;return this.iterate(j=>(ce(j)&&(se=j),!0)),se}findLastMaxBy(ce){let se,j=!0;return this.iterate(ie=>((j||re.isGreaterThan(ce(ie,se)))&&(j=!1,se=ie),!0)),se}}e.CallbackIterable=be;class Ce{constructor(ce){this._indexMap=ce}static createSortPermutation(ce,se){const j=Array.from(ce.keys()).sort((ie,ue)=>se(ce[ie],ce[ue]));return new Ce(j)}apply(ce){return ce.map((se,j)=>ce[this._indexMap[j]])}inverse(){const ce=this._indexMap.slice();for(let se=0;se<this._indexMap.length;se++)ce[this._indexMap[se]]=se;return new Ce(ce)}}e.Permutation=Ce}),define(ye[61],_e([1,0,13]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=O,e.assertNever=L,e.assert=T,e.softAssert=R,e.assertFn=b,e.checkAdjacentItems=p;function O(w,A){if(!w)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}function L(w,A="Unreachable"){throw new Error(A)}function T(w){if(!w)throw new c.BugIndicatingError("Assertion Failed")}function R(w){w||(0,c.onUnexpectedError)(new c.BugIndicatingError("Soft Assertion Failed"))}function b(w){if(!w()){debugger;w(),(0,c.onUnexpectedError)(new c.BugIndicatingError("Assertion Failed"))}}function p(w,A){let I=0;for(;I<w.length-1;){const v=w[I],C=w[I+1];if(!A(v,C))return!1;I++}return!0}}),define(ye[74],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=c;function c(O,L){const T=this;let R=!1,b;return function(){if(R)return b;if(R=!0,L)try{b=O.apply(T,arguments)}finally{L()}else b=O.apply(T,arguments);return b}}}),define(ye[124],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(L){this._prefix=L,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(ye[38],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var c;(function(O){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}O.is=L;const T=Object.freeze([]);function R(){return T}O.empty=R;function*b(t){yield t}O.single=b;function p(t){return L(t)?t:b(t)}O.wrap=p;function w(t){return t||T}O.from=w;function*A(t){for(let f=t.length-1;f>=0;f--)yield t[f]}O.reverse=A;function I(t){return!t||t[Symbol.iterator]().next().done===!0}O.isEmpty=I;function v(t){return t[Symbol.iterator]().next().value}O.first=v;function C(t,f){for(const h of t)if(f(h))return!0;return!1}O.some=C;function S(t,f){for(const h of t)if(f(h))return h}O.find=S;function*a(t,f){for(const h of t)f(h)&&(yield h)}O.filter=a;function*m(t,f){let h=0;for(const l of t)yield f(l,h++)}O.map=m;function*o(...t){for(const f of t)yield*f}O.concat=o;function n(t,f,h){let l=h;for(const u of t)l=f(l,u);return l}O.reduce=n;function*i(t,f,h=t.length){for(f<0&&(f+=t.length),h<0?h+=t.length:h>t.length&&(h=t.length);f<h;f++)yield t[f]}O.slice=i;function r(t,f=Number.POSITIVE_INFINITY){const h=[];if(f===0)return[h,t];const l=t[Symbol.iterator]();for(let u=0;u<f;u++){const d=l.next();if(d.done)return[h,O.empty()];h.push(d.value)}return[h,{[Symbol.iterator](){return l}}]}O.consume=r;async function s(t){const f=[];for await(const h of t)f.push(h);return Promise.resolve(f)}O.asyncToArray=s})(c||(e.Iterable=c={}))}),define(ye[164],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=R,e.getLocation=I,e.parse=v,e.parseTree=C,e.findNodeAtLocation=S,e.getNodePath=a,e.getNodeValue=m,e.contains=o,e.findNodeAtOffset=n,e.visit=i,e.stripComments=r,e.getNodeType=s;var c;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(c||(e.ScanError=c={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function R(t,f=!1){let h=0;const l=t.length;let u="",d=0,g=16,D=0;function E(F){let N=0,M=0;for(;N<F;){const B=t.charCodeAt(h);if(B>=48&&B<=57)M=M*16+B-48;else if(B>=65&&B<=70)M=M*16+B-65+10;else if(B>=97&&B<=102)M=M*16+B-97+10;else break;h++,N++}return N<F&&(M=-1),M}function _(F){h=F,u="",d=0,g=16,D=0}function y(){const F=h;if(t.charCodeAt(h)===48)h++;else for(h++;h<t.length&&w(t.charCodeAt(h));)h++;if(h<t.length&&t.charCodeAt(h)===46)if(h++,h<t.length&&w(t.charCodeAt(h)))for(h++;h<t.length&&w(t.charCodeAt(h));)h++;else return D=3,t.substring(F,h);let N=h;if(h<t.length&&(t.charCodeAt(h)===69||t.charCodeAt(h)===101))if(h++,(h<t.length&&t.charCodeAt(h)===43||t.charCodeAt(h)===45)&&h++,h<t.length&&w(t.charCodeAt(h))){for(h++;h<t.length&&w(t.charCodeAt(h));)h++;N=h}else D=3;return t.substring(F,N)}function P(){let F="",N=h;for(;;){if(h>=l){F+=t.substring(N,h),D=2;break}const M=t.charCodeAt(h);if(M===34){F+=t.substring(N,h),h++;break}if(M===92){if(F+=t.substring(N,h),h++,h>=l){D=2;break}switch(t.charCodeAt(h++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const W=E(4);W>=0?F+=String.fromCharCode(W):D=4;break}default:D=5}N=h;continue}if(M>=0&&M<=31)if(p(M)){F+=t.substring(N,h),D=2;break}else D=6;h++}return F}function k(){if(u="",D=0,d=h,h>=l)return d=l,g=17;let F=t.charCodeAt(h);if(b(F)){do h++,u+=String.fromCharCode(F),F=t.charCodeAt(h);while(b(F));return g=15}if(p(F))return h++,u+=String.fromCharCode(F),F===13&&t.charCodeAt(h)===10&&(h++,u+=`
`),g=14;switch(F){case 123:return h++,g=1;case 125:return h++,g=2;case 91:return h++,g=3;case 93:return h++,g=4;case 58:return h++,g=6;case 44:return h++,g=5;case 34:return h++,u=P(),g=10;case 47:{const N=h-1;if(t.charCodeAt(h+1)===47){for(h+=2;h<l&&!p(t.charCodeAt(h));)h++;return u=t.substring(N,h),g=12}if(t.charCodeAt(h+1)===42){h+=2;const M=l-1;let B=!1;for(;h<M;){if(t.charCodeAt(h)===42&&t.charCodeAt(h+1)===47){h+=2,B=!0;break}h++}return B||(h++,D=1),u=t.substring(N,h),g=13}return u+=String.fromCharCode(F),h++,g=16}case 45:if(u+=String.fromCharCode(F),h++,h===l||!w(t.charCodeAt(h)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=y(),g=11;default:for(;h<l&&z(F);)h++,F=t.charCodeAt(h);if(d!==h){switch(u=t.substring(d,h),u){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return u+=String.fromCharCode(F),h++,g=16}}function z(F){if(b(F)||p(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let F;do F=k();while(F>=12&&F<=15);return F}return{setPosition:_,getPosition:()=>h,scan:f?x:k,getToken:()=>g,getTokenValue:()=>u,getTokenOffset:()=>d,getTokenLength:()=>h-d,getTokenError:()=>D}}function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function I(t,f){const h=[],l=new Object;let u;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function D(E,_,y,P){d.value=E,d.offset=_,d.length=y,d.type=P,d.colonOffset=void 0,u=d}try{i(t,{onObjectBegin:(E,_)=>{if(f<=E)throw l;u=void 0,g=f>E,h.push("")},onObjectProperty:(E,_,y)=>{if(f<_||(D(E,_,y,"property"),h[h.length-1]=E,f<=_+y))throw l},onObjectEnd:(E,_)=>{if(f<=E)throw l;u=void 0,h.pop()},onArrayBegin:(E,_)=>{if(f<=E)throw l;u=void 0,h.push(0)},onArrayEnd:(E,_)=>{if(f<=E)throw l;u=void 0,h.pop()},onLiteralValue:(E,_,y)=>{if(f<_||(D(E,_,y,s(E)),f<=_+y))throw l},onSeparator:(E,_,y)=>{if(f<=_)throw l;if(E===":"&&u&&u.type==="property")u.colonOffset=_,g=!1,u=void 0;else if(E===","){const P=h[h.length-1];typeof P=="number"?h[h.length-1]=P+1:(g=!0,h[h.length-1]=""),u=void 0}}})}catch(E){if(E!==l)throw E}return{path:h,previousNode:u,isAtPropertyKey:g,matches:E=>{let _=0;for(let y=0;_<E.length&&y<h.length;y++)if(E[_]===h[y]||E[_]==="*")_++;else if(E[_]!=="**")return!1;return _===E.length}}}function v(t,f=[],h=T.DEFAULT){let l=null,u=[];const d=[];function g(E){Array.isArray(u)?u.push(E):l!==null&&(u[l]=E)}return i(t,{onObjectBegin:()=>{const E={};g(E),d.push(u),u=E,l=null},onObjectProperty:E=>{l=E},onObjectEnd:()=>{u=d.pop()},onArrayBegin:()=>{const E=[];g(E),d.push(u),u=E,l=null},onArrayEnd:()=>{u=d.pop()},onLiteralValue:g,onError:(E,_,y)=>{f.push({error:E,offset:_,length:y})}},h),u[0]}function C(t,f=[],h=T.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(E){l.type==="property"&&(l.length=E-l.offset,l=l.parent)}function d(E){return l.children.push(E),E}i(t,{onObjectBegin:E=>{l=d({type:"object",offset:E,length:-1,parent:l,children:[]})},onObjectProperty:(E,_,y)=>{l=d({type:"property",offset:_,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:E,offset:_,length:y,parent:l})},onObjectEnd:(E,_)=>{l.length=E+_-l.offset,l=l.parent,u(E+_)},onArrayBegin:(E,_)=>{l=d({type:"array",offset:E,length:-1,parent:l,children:[]})},onArrayEnd:(E,_)=>{l.length=E+_-l.offset,l=l.parent,u(E+_)},onLiteralValue:(E,_,y)=>{d({type:s(E),offset:_,length:y,parent:l,value:E}),u(_+y)},onSeparator:(E,_,y)=>{l.type==="property"&&(E===":"?l.colonOffset=_:E===","&&u(_))},onError:(E,_,y)=>{f.push({error:E,offset:_,length:y})}},h);const D=l.children[0];return D&&delete D.parent,D}function S(t,f){if(!t)return;let h=t;for(const l of f)if(typeof l=="string"){if(h.type!=="object"||!Array.isArray(h.children))return;let u=!1;for(const d of h.children)if(Array.isArray(d.children)&&d.children[0].value===l){h=d.children[1],u=!0;break}if(!u)return}else{const u=l;if(h.type!=="array"||u<0||!Array.isArray(h.children)||u>=h.children.length)return;h=h.children[u]}return h}function a(t){if(!t.parent||!t.parent.children)return[];const f=a(t.parent);if(t.parent.type==="property"){const h=t.parent.children[0].value;f.push(h)}else if(t.parent.type==="array"){const h=t.parent.children.indexOf(t);h!==-1&&f.push(h)}return f}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const f=Object.create(null);for(const h of t.children){const l=h.children[1];l&&(f[h.children[0].value]=m(l))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,f,h=!1){return f>=t.offset&&f<t.offset+t.length||h&&f===t.offset+t.length}function n(t,f,h=!1){if(o(t,f,h)){const l=t.children;if(Array.isArray(l))for(let u=0;u<l.length&&l[u].offset<=f;u++){const d=n(l[u],f,h);if(d)return d}return t}}function i(t,f,h=T.DEFAULT){const l=R(t,!1);function u(te){return te?()=>te(l.getTokenOffset(),l.getTokenLength()):()=>!0}function d(te){return te?ve=>te(ve,l.getTokenOffset(),l.getTokenLength()):()=>!0}const g=u(f.onObjectBegin),D=d(f.onObjectProperty),E=u(f.onObjectEnd),_=u(f.onArrayBegin),y=u(f.onArrayEnd),P=d(f.onLiteralValue),k=d(f.onSeparator),z=u(f.onComment),x=d(f.onError),F=h&&h.disallowComments,N=h&&h.allowTrailingComma;function M(){for(;;){const te=l.scan();switch(l.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:F||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(te){case 12:case 13:F?B(10):z();break;case 16:B(1);break;case 15:case 14:break;default:return te}}}function B(te,ve=[],Ie=[]){if(x(te),ve.length+Ie.length>0){let J=l.getToken();for(;J!==17;){if(ve.indexOf(J)!==-1){M();break}else if(Ie.indexOf(J)!==-1)break;J=M()}}}function W(te){const ve=l.getTokenValue();return te?P(ve):D(ve),M(),!0}function Y(){switch(l.getToken()){case 11:{let te=0;try{te=JSON.parse(l.getTokenValue()),typeof te!="number"&&(B(2),te=0)}catch{B(2)}P(te);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return M(),!0}function Z(){return l.getToken()!==10?(B(3,[],[2,5]),!1):(W(!1),l.getToken()===6?(k(":"),M(),re()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function G(){g(),M();let te=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(te||B(4,[],[]),k(","),M(),l.getToken()===2&&N)break}else te&&B(6,[],[]);Z()||B(4,[],[2,5]),te=!0}return E(),l.getToken()!==2?B(7,[2],[]):M(),!0}function Q(){_(),M();let te=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(te||B(4,[],[]),k(","),M(),l.getToken()===4&&N)break}else te&&B(6,[],[]);re()||B(4,[],[4,5]),te=!0}return y(),l.getToken()!==4?B(8,[4],[]):M(),!0}function re(){switch(l.getToken()){case 3:return Q();case 1:return G();case 10:return W(!0);default:return Y()}}return M(),l.getToken()===17?h.allowEmptyContent?!0:(B(4,[],[]),!1):re()?(l.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}function r(t,f){const h=R(t),l=[];let u,d=0,g;do switch(g=h.getPosition(),u=h.scan(),u){case 12:case 13:case 17:d!==g&&l.push(t.substring(d,g)),f!==void 0&&l.push(h.getTokenValue().replace(/[^\r\n]/g,f)),d=h.getPosition();break}while(u!==17);return l.join("")}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ye[46],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(L){this.executor=L,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=c}),define(ye[75],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class c{static{this.Undefined=new c(void 0)}constructor(T){this.element=T,this.next=c.Undefined,this.prev=c.Undefined}}class O{constructor(){this._first=c.Undefined,this._last=c.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===c.Undefined}clear(){let T=this._first;for(;T!==c.Undefined;){const R=T.next;T.prev=c.Undefined,T.next=c.Undefined,T=R}this._first=c.Undefined,this._last=c.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,R){const b=new c(T);if(this._first===c.Undefined)this._first=b,this._last=b;else if(R){const w=this._last;this._last=b,b.prev=w,w.next=b}else{const w=this._first;this._first=b,b.next=w,w.prev=b}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(b))}}shift(){if(this._first!==c.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==c.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==c.Undefined&&T.next!==c.Undefined){const R=T.prev;R.next=T.next,T.next.prev=R}else T.prev===c.Undefined&&T.next===c.Undefined?(this._first=c.Undefined,this._last=c.Undefined):T.next===c.Undefined?(this._last=this._last.prev,this._last.next=c.Undefined):T.prev===c.Undefined&&(this._first=this._first.next,this._first.prev=c.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==c.Undefined;)yield T.element,T=T.next}}e.LinkedList=O}),define(ye[27],_e([1,0]),function(de,e){"use strict";var c,O,L;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=T,e.mapToString=R,e.setToString=b,e.mapsStrictEqualIgnoreOrder=n;function T(i,r,s){let t=i.get(r);return t===void 0&&(t=s,i.set(r,t)),t}function R(i){const r=[];return i.forEach((s,t)=>{r.push(`${t} => ${s}`)}),`Map(${i.size}) {${r.join(", ")}}`}function b(i){const r=[];return i.forEach(s=>{r.push(s)}),`Set(${i.size}) {${r.join(", ")}}`}class p{constructor(r,s){this.uri=r,this.value=s}}function w(i){return Array.isArray(i)}class A{static{this.defaultToKey=r=>r.toString()}constructor(r,s){if(this[c]="ResourceMap",r instanceof A)this.map=new Map(r.map),this.toKey=s??A.defaultToKey;else if(w(r)){this.map=new Map,this.toKey=s??A.defaultToKey;for(const[t,f]of r)this.set(t,f)}else this.map=new Map,this.toKey=r??A.defaultToKey}set(r,s){return this.map.set(this.toKey(r),new p(r,s)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[t,f]of this.map)r(f.value,f.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(c=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=A;class I{constructor(r,s){this[O]="ResourceSet",!r||typeof r=="function"?this._map=new A(r):(this._map=new A(s),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,s){this._map.forEach((t,f)=>r.call(s,f,f,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=I;var v;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class C{constructor(){this[L]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const t=this._map.get(r);if(t)return s!==0&&this.touch(t,s),t.value}set(r,s,t=0){let f=this._map.get(r);if(f)f.value=s,t!==0&&this.touch(f,t);else{switch(f={key:r,value:s,next:void 0,previous:void 0},t){case 0:this.addItemLast(f);break;case 1:this.addItemFirst(f);break;case 2:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(r,f),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const t=this._state;let f=this._head;for(;f;){if(s?r.bind(s)(f.value,f.key,this):r(f.value,f.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const r=this,s=this._state;let t=this._head;const f={[Symbol.iterator](){return f},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const h={value:t.key,done:!1};return t=t.next,h}else return{value:void 0,done:!0}}};return f}values(){const r=this,s=this._state;let t=this._head;const f={[Symbol.iterator](){return f},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const h={value:t.value,done:!1};return t=t.next,h}else return{value:void 0,done:!0}}};return f}entries(){const r=this,s=this._state;let t=this._head;const f={[Symbol.iterator](){return f},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const h={value:[t.key,t.value],done:!1};return t=t.next,h}else return{value:void 0,done:!0}}};return f}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,t=this.size;for(;s&&t>r;)this._map.delete(s.key),s=s.next,t--;this._head=s,this._size=t,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,t=r.previous;if(!s||!t)throw new Error("Invalid list");s.previous=t,t.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const t=r.next,f=r.previous;r===this._tail?(f.next=void 0,this._tail=f):(t.previous=f,f.next=t),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const t=r.next,f=r.previous;r===this._head?(t.previous=void 0,this._head=t):(t.previous=f,f.next=t),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,t)=>{r.push([t,s])}),r}fromJSON(r){this.clear();for(const[s,t]of r)this.set(s,t)}}e.LinkedMap=C;class S extends C{constructor(r,s=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=S;class a{constructor(){this.map=new Map}add(r){return this.map.set(r,(this.map.get(r)||0)+1),this}delete(r){let s=this.map.get(r)||0;return s===0?!1:(s--,s===0?this.map.delete(r):this.map.set(r,s),!0)}has(r){return this.map.has(r)}}e.CounterSet=a;class m{constructor(r){if(this._m1=new Map,this._m2=new Map,r)for(const[s,t]of r)this.set(s,t)}clear(){this._m1.clear(),this._m2.clear()}set(r,s){this._m1.set(r,s),this._m2.set(s,r)}get(r){return this._m1.get(r)}getKey(r){return this._m2.get(r)}delete(r){const s=this._m1.get(r);return s===void 0?!1:(this._m1.delete(r),this._m2.delete(s),!0)}forEach(r,s){this._m1.forEach((t,f)=>{r.call(s,t,f,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=m;class o{constructor(){this.map=new Map}add(r,s){let t=this.map.get(r);t||(t=new Set,this.map.set(r,t)),t.add(s)}delete(r,s){const t=this.map.get(r);t&&(t.delete(s),t.size===0&&this.map.delete(r))}forEach(r,s){const t=this.map.get(r);t&&t.forEach(s)}get(r){const s=this.map.get(r);return s||new Set}}e.SetMap=o;function n(i,r){if(i===r)return!0;if(i.size!==r.size)return!1;for(const[s,t]of i)if(!r.has(s)||r.get(s)!==t)return!1;for(const[s]of r)if(!i.has(s))return!1;return!0}}),define(ye[3],_e([1,0,19,73,27,74,38]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=A,e.trackDisposable=I,e.markAsDisposed=v,e.markAsSingleton=a,e.isDisposable=m,e.dispose=o,e.disposeIfDisposable=n,e.combinedDisposable=i,e.toDisposable=r,e.disposeOnReturn=E;const b=!1;let p=null;class w{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(P){let k=this.livingDisposables.get(P);return k||(k={parent:null,source:null,isSingleton:!1,value:P,idx:w.idx++},this.livingDisposables.set(P,k)),k}trackDisposable(P){const k=this.getDisposableData(P);k.source||(k.source=new Error().stack)}setParent(P,k){const z=this.getDisposableData(P);z.parent=k}markAsDisposed(P){this.livingDisposables.delete(P)}markAsSingleton(P){this.getDisposableData(P).isSingleton=!0}getRootParent(P,k){const z=k.get(P);if(z)return z;const x=P.parent?this.getRootParent(this.getDisposableData(P.parent),k):P;return k.set(P,x),x}getTrackedDisposables(){const P=new Map;return[...this.livingDisposables.entries()].filter(([,z])=>z.source!==null&&!this.getRootParent(z,P).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(P=10,k){let z;if(k)z=k;else{const B=new Map,W=[...this.livingDisposables.values()].filter(Z=>Z.source!==null&&!this.getRootParent(Z,B).isSingleton);if(W.length===0)return;const Y=new Set(W.map(Z=>Z.value));if(z=W.filter(Z=>!(Z.parent&&Y.has(Z.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function x(B){function W(Z,G){for(;Z.length>0&&G.some(Q=>typeof Q=="string"?Q===Z[0]:Z[0].match(Q));)Z.shift()}const Y=B.source.split(`
`).map(Z=>Z.trim().replace("at ","")).filter(Z=>Z!=="");return W(Y,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Y.reverse()}const F=new L.SetMap;for(const B of z){const W=x(B);for(let Y=0;Y<=W.length;Y++)F.add(W.slice(0,Y).join(`
`),B)}z.sort((0,c.compareBy)(B=>B.idx,c.numberComparator));let N="",M=0;for(const B of z.slice(0,P)){M++;const W=x(B),Y=[];for(let Z=0;Z<W.length;Z++){let G=W[Z];G=`(shared with ${F.get(W.slice(0,Z+1).join(`
`)).size}/${z.length} leaks) at ${G}`;const re=F.get(W.slice(0,Z).join(`
`)),te=(0,O.groupBy)([...re].map(ve=>x(ve)[Z]),ve=>ve);delete te[W[Z]];for(const[ve,Ie]of Object.entries(te))Y.unshift(`    - stacktraces of ${Ie.length} other leaks continue with ${ve}`);Y.unshift(G)}N+=`


==================== Leaking disposable ${M}/${z.length}: ${B.value.constructor.name} ====================
${Y.join(`
`)}
============================================================

`}return z.length>P&&(N+=`


... and ${z.length-P} more leaking disposables

`),{leaks:z,details:N}}}e.DisposableTracker=w;function A(y){p=y}if(b){const y="__is_disposable_tracked__";A(new class{trackDisposable(P){const k=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[y]||console.log(k)},3e3)}setParent(P,k){if(P&&P!==t.None)try{P[y]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[y]=!0}catch{}}markAsSingleton(P){}})}function I(y){return p?.trackDisposable(y),y}function v(y){p?.markAsDisposed(y)}function C(y,P){p?.setParent(y,P)}function S(y,P){if(p)for(const k of y)p.setParent(k,P)}function a(y){return p?.markAsSingleton(y),y}function m(y){return typeof y.dispose=="function"&&y.dispose.length===0}function o(y){if(R.Iterable.is(y)){const P=[];for(const k of y)if(k)try{k.dispose()}catch(z){P.push(z)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}function n(y){for(const P of y)m(P)&&P.dispose();return[]}function i(...y){const P=r(()=>o(y));return S(y,P),P}function r(y){const P=I({dispose:(0,T.createSingleCallFunction)(()=>{v(P),y()})});return P}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(v(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{o(this._toDispose)}finally{this._toDispose.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return C(P,this),this._isDisposed?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(P),P.dispose()}}deleteAndLeak(P){P&&this._toDispose.has(P)&&(this._toDispose.delete(P),C(P,null))}}e.DisposableStore=s;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new s,I(this),C(this._store,this)}dispose(){v(this),this._store.dispose()}_register(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(P)}}e.Disposable=t;class f{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(P){this._isDisposed||P===this._value||(this._value?.dispose(),P&&C(P,this),this._value=P)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,v(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const P=this._value;return this._value=void 0,P&&C(P,null),P}}e.MutableDisposable=f;class h{constructor(P){this._disposable=new f,this._isDisposed=!1,this._disposable.value=P}get value(){return this._disposable.value}set value(P){this._isDisposed||P===this._disposable.value||(this._disposable.value=P)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=h;class l{constructor(P){this._disposable=P,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(P){let k=P;return this.unset=()=>k=void 0,this.isset=()=>k!==void 0,this.dispose=()=>{k&&(k(),k=void 0,v(this))},this}}e.SafeDisposable=u;class d{constructor(){this.references=new Map}acquire(P,...k){let z=this.references.get(P);z||(z={counter:0,object:this.createReferencedObject(P,...k)},this.references.set(P,z));const{object:x}=z,F=(0,T.createSingleCallFunction)(()=>{--z.counter===0&&(this.destroyReferencedObject(P,z.object),this.references.delete(P))});return z.counter++,{object:x,dispose:F}}}e.ReferenceCollection=d;class g{constructor(P){this.referenceCollection=P}async acquire(P,...k){const z=this.referenceCollection.acquire(P,...k);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(x){throw z.dispose(),x}}}e.AsyncReferenceCollection=g;class D{constructor(P){this.object=P}dispose(){}}e.ImmortalReference=D;function E(y){const P=new s;try{y(P)}finally{P.dispose()}}class _{constructor(){this._store=new Map,this._isDisposed=!1,I(this)}dispose(){v(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{o(this._store.values())}finally{this._store.clear()}}has(P){return this._store.has(P)}get size(){return this._store.size}get(P){return this._store.get(P)}set(P,k,z=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this._store.get(P)?.dispose(),this._store.set(P,k)}deleteAndDispose(P){this._store.get(P)?.dispose(),this._store.delete(P)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=_}),function(de,e){typeof define=="function"&&define.amd?define(ye[165],_e([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(de=typeof globalThis<"u"?globalThis:de||self,e(de.marked={}))}(this,function(de){"use strict";function e(ae,ce){for(var se=0;se<ce.length;se++){var j=ce[se];j.enumerable=j.enumerable||!1,j.configurable=!0,"value"in j&&(j.writable=!0),Object.defineProperty(ae,j.key,j)}}function c(ae,ce,se){return ce&&e(ae.prototype,ce),se&&e(ae,se),Object.defineProperty(ae,"prototype",{writable:!1}),ae}function O(ae,ce){if(ae){if(typeof ae=="string")return L(ae,ce);var se=Object.prototype.toString.call(ae).slice(8,-1);if(se==="Object"&&ae.constructor&&(se=ae.constructor.name),se==="Map"||se==="Set")return Array.from(ae);if(se==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(se))return L(ae,ce)}}function L(ae,ce){(ce==null||ce>ae.length)&&(ce=ae.length);for(var se=0,j=new Array(ce);se<ce;se++)j[se]=ae[se];return j}function T(ae,ce){var se=typeof Symbol<"u"&&ae[Symbol.iterator]||ae["@@iterator"];if(se)return(se=se.call(ae)).next.bind(se);if(Array.isArray(ae)||(se=O(ae))||ce&&ae&&typeof ae.length=="number"){se&&(ae=se);var j=0;return function(){return j>=ae.length?{done:!0}:{done:!1,value:ae[j++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}de.defaults=R();function b(ae){de.defaults=ae}var p=/[&<>"']/,w=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},C=function(ce){return v[ce]};function S(ae,ce){if(ce){if(p.test(ae))return ae.replace(w,C)}else if(A.test(ae))return ae.replace(I,C);return ae}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(ae){return ae.replace(a,function(ce,se){return se=se.toLowerCase(),se==="colon"?":":se.charAt(0)==="#"?se.charAt(1)==="x"?String.fromCharCode(parseInt(se.substring(2),16)):String.fromCharCode(+se.substring(1)):""})}var o=/(^|[^\[])\^/g;function n(ae,ce){ae=typeof ae=="string"?ae:ae.source,ce=ce||"";var se={replace:function(ie,ue){return ue=ue.source||ue,ue=ue.replace(o,"$1"),ae=ae.replace(ie,ue),se},getRegex:function(){return new RegExp(ae,ce)}};return se}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function s(ae,ce,se){if(ae){var j;try{j=decodeURIComponent(m(se)).replace(i,"").toLowerCase()}catch{return null}if(j.indexOf("javascript:")===0||j.indexOf("vbscript:")===0||j.indexOf("data:")===0)return null}ce&&!r.test(se)&&(se=u(ce,se));try{se=encodeURI(se).replace(/%25/g,"%")}catch{return null}return se}var t={},f=/^[^:]+:\/*[^/]*$/,h=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(ae,ce){t[" "+ae]||(f.test(ae)?t[" "+ae]=ae+"/":t[" "+ae]=E(ae,"/",!0)),ae=t[" "+ae];var se=ae.indexOf(":")===-1;return ce.substring(0,2)==="//"?se?ce:ae.replace(h,"$1")+ce:ce.charAt(0)==="/"?se?ce:ae.replace(l,"$1")+ce:ae+ce}var d={exec:function(){}};function g(ae){for(var ce=1,se,j;ce<arguments.length;ce++){se=arguments[ce];for(j in se)Object.prototype.hasOwnProperty.call(se,j)&&(ae[j]=se[j])}return ae}function D(ae,ce){var se=ae.replace(/\|/g,function(ue,he,Te){for(var me=!1,Pe=he;--Pe>=0&&Te[Pe]==="\\";)me=!me;return me?"|":" |"}),j=se.split(/ \|/),ie=0;if(j[0].trim()||j.shift(),j.length>0&&!j[j.length-1].trim()&&j.pop(),j.length>ce)j.splice(ce);else for(;j.length<ce;)j.push("");for(;ie<j.length;ie++)j[ie]=j[ie].trim().replace(/\\\|/g,"|");return j}function E(ae,ce,se){var j=ae.length;if(j===0)return"";for(var ie=0;ie<j;){var ue=ae.charAt(j-ie-1);if(ue===ce&&!se)ie++;else if(ue!==ce&&se)ie++;else break}return ae.slice(0,j-ie)}function _(ae,ce){if(ae.indexOf(ce[1])===-1)return-1;for(var se=ae.length,j=0,ie=0;ie<se;ie++)if(ae[ie]==="\\")ie++;else if(ae[ie]===ce[0])j++;else if(ae[ie]===ce[1]&&(j--,j<0))return ie;return-1}function y(ae){ae&&ae.sanitize&&!ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ae,ce){if(ce<1)return"";for(var se="";ce>1;)ce&1&&(se+=ae),ce>>=1,ae+=ae;return se+ae}function k(ae,ce,se,j){var ie=ce.href,ue=ce.title?S(ce.title):null,he=ae[1].replace(/\\([\[\]])/g,"$1");if(ae[0].charAt(0)!=="!"){j.state.inLink=!0;var Te={type:"link",raw:se,href:ie,title:ue,text:he,tokens:j.inlineTokens(he)};return j.state.inLink=!1,Te}return{type:"image",raw:se,href:ie,title:ue,text:S(he)}}function z(ae,ce){var se=ae.match(/^(\s+)(?:```)/);if(se===null)return ce;var j=se[1];return ce.split(`
`).map(function(ie){var ue=ie.match(/^\s+/);if(ue===null)return ie;var he=ue[0];return he.length>=j.length?ie.slice(j.length):ie}).join(`
`)}var x=function(){function ae(se){this.options=se||de.defaults}var ce=ae.prototype;return ce.space=function(j){var ie=this.rules.block.newline.exec(j);if(ie&&ie[0].length>0)return{type:"space",raw:ie[0]}},ce.code=function(j){var ie=this.rules.block.code.exec(j);if(ie){var ue=ie[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ie[0],codeBlockStyle:"indented",text:this.options.pedantic?ue:E(ue,`
`)}}},ce.fences=function(j){var ie=this.rules.block.fences.exec(j);if(ie){var ue=ie[0],he=z(ue,ie[3]||"");return{type:"code",raw:ue,lang:ie[2]?ie[2].trim():ie[2],text:he}}},ce.heading=function(j){var ie=this.rules.block.heading.exec(j);if(ie){var ue=ie[2].trim();if(/#$/.test(ue)){var he=E(ue,"#");(this.options.pedantic||!he||/ $/.test(he))&&(ue=he.trim())}return{type:"heading",raw:ie[0],depth:ie[1].length,text:ue,tokens:this.lexer.inline(ue)}}},ce.hr=function(j){var ie=this.rules.block.hr.exec(j);if(ie)return{type:"hr",raw:ie[0]}},ce.blockquote=function(j){var ie=this.rules.block.blockquote.exec(j);if(ie){var ue=ie[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ie[0],tokens:this.lexer.blockTokens(ue,[]),text:ue}}},ce.list=function(j){var ie=this.rules.block.list.exec(j);if(ie){var ue,he,Te,me,Pe,Ae,xe,H,U,X,K,ge,Ee=ie[1].trim(),ze=Ee.length>1,He={type:"list",raw:"",ordered:ze,start:ze?+Ee.slice(0,-1):"",loose:!1,items:[]};Ee=ze?"\\d{1,9}\\"+Ee.slice(-1):"\\"+Ee,this.options.pedantic&&(Ee=ze?Ee:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+Ee+")((?:[	 ][^\\n]*)?(?:\\n|$))");j&&(ge=!1,!(!(ie=Ye.exec(j))||this.rules.block.hr.test(j)));){if(ue=ie[0],j=j.substring(ue.length),H=ie[2].split(`
`,1)[0],U=j.split(`
`,1)[0],this.options.pedantic?(me=2,K=H.trimLeft()):(me=ie[2].search(/[^ ]/),me=me>4?1:me,K=H.slice(me),me+=ie[1].length),Ae=!1,!H&&/^ *$/.test(U)&&(ue+=U+`
`,j=j.substring(U.length+1),ge=!0),!ge)for(var it=new RegExp("^ {0,"+Math.min(3,me-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),rt=new RegExp("^ {0,"+Math.min(3,me-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),at=new RegExp("^ {0,"+Math.min(3,me-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,me-1)+"}#");j&&(X=j.split(`
`,1)[0],H=X,this.options.pedantic&&(H=H.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(at.test(H)||st.test(H)||it.test(H)||rt.test(j)));){if(H.search(/[^ ]/)>=me||!H.trim())K+=`
`+H.slice(me);else if(!Ae)K+=`
`+H;else break;!Ae&&!H.trim()&&(Ae=!0),ue+=X+`
`,j=j.substring(X.length+1)}He.loose||(xe?He.loose=!0:/\n *\n *$/.test(ue)&&(xe=!0)),this.options.gfm&&(he=/^\[[ xX]\] /.exec(K),he&&(Te=he[0]!=="[ ] ",K=K.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:ue,task:!!he,checked:Te,loose:!1,text:K}),He.raw+=ue}He.items[He.items.length-1].raw=ue.trimRight(),He.items[He.items.length-1].text=K.trimRight(),He.raw=He.raw.trimRight();var De=He.items.length;for(Pe=0;Pe<De;Pe++){this.lexer.state.top=!1,He.items[Pe].tokens=this.lexer.blockTokens(He.items[Pe].text,[]);var Be=He.items[Pe].tokens.filter(function(Le){return Le.type==="space"}),qe=Be.every(function(Le){for(var Qe=Le.raw.split(""),oe=0,le=T(Qe),ke;!(ke=le()).done;){var je=ke.value;if(je===`
`&&(oe+=1),oe>1)return!0}return!1});!He.loose&&Be.length&&qe&&(He.loose=!0,He.items[Pe].loose=!0)}return He}},ce.html=function(j){var ie=this.rules.block.html.exec(j);if(ie){var ue={type:"html",raw:ie[0],pre:!this.options.sanitizer&&(ie[1]==="pre"||ie[1]==="script"||ie[1]==="style"),text:ie[0]};if(this.options.sanitize){var he=this.options.sanitizer?this.options.sanitizer(ie[0]):S(ie[0]);ue.type="paragraph",ue.text=he,ue.tokens=this.lexer.inline(he)}return ue}},ce.def=function(j){var ie=this.rules.block.def.exec(j);if(ie){ie[3]&&(ie[3]=ie[3].substring(1,ie[3].length-1));var ue=ie[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ue,raw:ie[0],href:ie[2],title:ie[3]}}},ce.table=function(j){var ie=this.rules.block.table.exec(j);if(ie){var ue={type:"table",header:D(ie[1]).map(function(xe){return{text:xe}}),align:ie[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ie[3]&&ie[3].trim()?ie[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ue.header.length===ue.align.length){ue.raw=ie[0];var he=ue.align.length,Te,me,Pe,Ae;for(Te=0;Te<he;Te++)/^ *-+: *$/.test(ue.align[Te])?ue.align[Te]="right":/^ *:-+: *$/.test(ue.align[Te])?ue.align[Te]="center":/^ *:-+ *$/.test(ue.align[Te])?ue.align[Te]="left":ue.align[Te]=null;for(he=ue.rows.length,Te=0;Te<he;Te++)ue.rows[Te]=D(ue.rows[Te],ue.header.length).map(function(xe){return{text:xe}});for(he=ue.header.length,me=0;me<he;me++)ue.header[me].tokens=this.lexer.inline(ue.header[me].text);for(he=ue.rows.length,me=0;me<he;me++)for(Ae=ue.rows[me],Pe=0;Pe<Ae.length;Pe++)Ae[Pe].tokens=this.lexer.inline(Ae[Pe].text);return ue}}},ce.lheading=function(j){var ie=this.rules.block.lheading.exec(j);if(ie)return{type:"heading",raw:ie[0],depth:ie[2].charAt(0)==="="?1:2,text:ie[1],tokens:this.lexer.inline(ie[1])}},ce.paragraph=function(j){var ie=this.rules.block.paragraph.exec(j);if(ie){var ue=ie[1].charAt(ie[1].length-1)===`
`?ie[1].slice(0,-1):ie[1];return{type:"paragraph",raw:ie[0],text:ue,tokens:this.lexer.inline(ue)}}},ce.text=function(j){var ie=this.rules.block.text.exec(j);if(ie)return{type:"text",raw:ie[0],text:ie[0],tokens:this.lexer.inline(ie[0])}},ce.escape=function(j){var ie=this.rules.inline.escape.exec(j);if(ie)return{type:"escape",raw:ie[0],text:S(ie[1])}},ce.tag=function(j){var ie=this.rules.inline.tag.exec(j);if(ie)return!this.lexer.state.inLink&&/^<a /i.test(ie[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ie[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ie[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ie[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ie[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):S(ie[0]):ie[0]}},ce.link=function(j){var ie=this.rules.inline.link.exec(j);if(ie){var ue=ie[2].trim();if(!this.options.pedantic&&/^</.test(ue)){if(!/>$/.test(ue))return;var he=E(ue.slice(0,-1),"\\");if((ue.length-he.length)%2===0)return}else{var Te=_(ie[2],"()");if(Te>-1){var me=ie[0].indexOf("!")===0?5:4,Pe=me+ie[1].length+Te;ie[2]=ie[2].substring(0,Te),ie[0]=ie[0].substring(0,Pe).trim(),ie[3]=""}}var Ae=ie[2],xe="";if(this.options.pedantic){var H=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);H&&(Ae=H[1],xe=H[3])}else xe=ie[3]?ie[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(ue)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),k(ie,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:xe&&xe.replace(this.rules.inline._escapes,"$1")},ie[0],this.lexer)}},ce.reflink=function(j,ie){var ue;if((ue=this.rules.inline.reflink.exec(j))||(ue=this.rules.inline.nolink.exec(j))){var he=(ue[2]||ue[1]).replace(/\s+/g," ");if(he=ie[he.toLowerCase()],!he||!he.href){var Te=ue[0].charAt(0);return{type:"text",raw:Te,text:Te}}return k(ue,he,ue[0],this.lexer)}},ce.emStrong=function(j,ie,ue){ue===void 0&&(ue="");var he=this.rules.inline.emStrong.lDelim.exec(j);if(he&&!(he[3]&&ue.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=he[1]||he[2]||"";if(!Te||Te&&(ue===""||this.rules.inline.punctuation.exec(ue))){var me=he[0].length-1,Pe,Ae,xe=me,H=0,U=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(U.lastIndex=0,ie=ie.slice(-1*j.length+me);(he=U.exec(ie))!=null;)if(Pe=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!Pe){if(Ae=Pe.length,he[3]||he[4]){xe+=Ae;continue}else if((he[5]||he[6])&&me%3&&!((me+Ae)%3)){H+=Ae;continue}if(xe-=Ae,!(xe>0)){if(Ae=Math.min(Ae,Ae+xe+H),Math.min(me,Ae)%2){var X=j.slice(1,me+he.index+Ae);return{type:"em",raw:j.slice(0,me+he.index+Ae+1),text:X,tokens:this.lexer.inlineTokens(X)}}var K=j.slice(2,me+he.index+Ae-1);return{type:"strong",raw:j.slice(0,me+he.index+Ae+1),text:K,tokens:this.lexer.inlineTokens(K)}}}}}},ce.codespan=function(j){var ie=this.rules.inline.code.exec(j);if(ie){var ue=ie[2].replace(/\n/g," "),he=/[^ ]/.test(ue),Te=/^ /.test(ue)&&/ $/.test(ue);return he&&Te&&(ue=ue.substring(1,ue.length-1)),ue=S(ue,!0),{type:"codespan",raw:ie[0],text:ue}}},ce.br=function(j){var ie=this.rules.inline.br.exec(j);if(ie)return{type:"br",raw:ie[0]}},ce.del=function(j){var ie=this.rules.inline.del.exec(j);if(ie)return{type:"del",raw:ie[0],text:ie[2],tokens:this.lexer.inlineTokens(ie[2])}},ce.autolink=function(j,ie){var ue=this.rules.inline.autolink.exec(j);if(ue){var he,Te;return ue[2]==="@"?(he=S(this.options.mangle?ie(ue[1]):ue[1]),Te="mailto:"+he):(he=S(ue[1]),Te=he),{type:"link",raw:ue[0],text:he,href:Te,tokens:[{type:"text",raw:he,text:he}]}}},ce.url=function(j,ie){var ue;if(ue=this.rules.inline.url.exec(j)){var he,Te;if(ue[2]==="@")he=S(this.options.mangle?ie(ue[0]):ue[0]),Te="mailto:"+he;else{var me;do me=ue[0],ue[0]=this.rules.inline._backpedal.exec(ue[0])[0];while(me!==ue[0]);he=S(ue[0]),ue[1]==="www."?Te="http://"+he:Te=he}return{type:"link",raw:ue[0],text:he,href:Te,tokens:[{type:"text",raw:he,text:he}]}}},ce.inlineText=function(j,ie){var ue=this.rules.inline.text.exec(j);if(ue){var he;return this.lexer.state.inRawBlock?he=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):S(ue[0]):ue[0]:he=S(this.options.smartypants?ie(ue[0]):ue[0]),{type:"text",raw:ue[0],text:he}}},ae}(),F={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};F._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,F._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,F.def=n(F.def).replace("label",F._label).replace("title",F._title).getRegex(),F.bullet=/(?:[*+-]|\d{1,9}[.)])/,F.listItemStart=n(/^( *)(bull) */).replace("bull",F.bullet).getRegex(),F.list=n(F.list).replace(/bull/g,F.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+F.def.source+")").getRegex(),F._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",F._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,F.html=n(F.html,"i").replace("comment",F._comment).replace("tag",F._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),F.paragraph=n(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.blockquote=n(F.blockquote).replace("paragraph",F.paragraph).getRegex(),F.normal=g({},F),F.gfm=g({},F.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),F.gfm.table=n(F.gfm.table).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.gfm.paragraph=n(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",F.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.pedantic=g({},F.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",F._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:n(F.normal._paragraph).replace("hr",F.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",F.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=n(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=n(F._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=n(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=n(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=n(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=n(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=n(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=n(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=n(N.reflink).replace("label",N._label).replace("ref",F._label).getRegex(),N.nolink=n(N.nolink).replace("ref",F._label).getRegex(),N.reflinkSearch=n(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=g({},N),N.pedantic=g({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=g({},N.normal,{escape:n(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=n(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=g({},N.gfm,{br:n(N.br).replace("{2,}","*").getRegex(),text:n(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(ae){return ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(ae){var ce="",se,j,ie=ae.length;for(se=0;se<ie;se++)j=ae.charCodeAt(se),Math.random()>.5&&(j="x"+j.toString(16)),ce+="&#"+j+";";return ce}var W=function(){function ae(se){this.tokens=[],this.tokens.links=Object.create(null),this.options=se||de.defaults,this.options.tokenizer=this.options.tokenizer||new x,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var j={block:F.normal,inline:N.normal};this.options.pedantic?(j.block=F.pedantic,j.inline=N.pedantic):this.options.gfm&&(j.block=F.gfm,this.options.breaks?j.inline=N.breaks:j.inline=N.gfm),this.tokenizer.rules=j}ae.lex=function(j,ie){var ue=new ae(ie);return ue.lex(j)},ae.lexInline=function(j,ie){var ue=new ae(ie);return ue.inlineTokens(j)};var ce=ae.prototype;return ce.lex=function(j){j=j.replace(/\r\n|\r/g,`
`),this.blockTokens(j,this.tokens);for(var ie;ie=this.inlineQueue.shift();)this.inlineTokens(ie.src,ie.tokens);return this.tokens},ce.blockTokens=function(j,ie){var ue=this;ie===void 0&&(ie=[]),this.options.pedantic?j=j.replace(/\t/g,"    ").replace(/^ +$/gm,""):j=j.replace(/^( *)(\t+)/gm,function(xe,H,U){return H+"    ".repeat(U.length)});for(var he,Te,me,Pe;j;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(xe){return(he=xe.call({lexer:ue},j,ie))?(j=j.substring(he.raw.length),ie.push(he),!0):!1}))){if(he=this.tokenizer.space(j)){j=j.substring(he.raw.length),he.raw.length===1&&ie.length>0?ie[ie.length-1].raw+=`
`:ie.push(he);continue}if(he=this.tokenizer.code(j)){j=j.substring(he.raw.length),Te=ie[ie.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+he.raw,Te.text+=`
`+he.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):ie.push(he);continue}if(he=this.tokenizer.fences(j)){j=j.substring(he.raw.length),ie.push(he);continue}if(he=this.tokenizer.heading(j)){j=j.substring(he.raw.length),ie.push(he);continue}if(he=this.tokenizer.hr(j)){j=j.substring(he.raw.length),ie.push(he);continue}if(he=this.tokenizer.blockquote(j)){j=j.substring(he.raw.length),ie.push(he);continue}if(he=this.tokenizer.list(j)){j=j.substring(he.raw.length),ie.push(he);continue}if(he=this.tokenizer.html(j)){j=j.substring(he.raw.length),ie.push(he);continue}if(he=this.tokenizer.def(j)){j=j.substring(he.raw.length),Te=ie[ie.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+he.raw,Te.text+=`
`+he.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(j)){j=j.substring(he.raw.length),ie.push(he);continue}if(he=this.tokenizer.lheading(j)){j=j.substring(he.raw.length),ie.push(he);continue}if(me=j,this.options.extensions&&this.options.extensions.startBlock&&function(){var xe=1/0,H=j.slice(1),U=void 0;ue.options.extensions.startBlock.forEach(function(X){U=X.call({lexer:this},H),typeof U=="number"&&U>=0&&(xe=Math.min(xe,U))}),xe<1/0&&xe>=0&&(me=j.substring(0,xe+1))}(),this.state.top&&(he=this.tokenizer.paragraph(me))){Te=ie[ie.length-1],Pe&&Te.type==="paragraph"?(Te.raw+=`
`+he.raw,Te.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):ie.push(he),Pe=me.length!==j.length,j=j.substring(he.raw.length);continue}if(he=this.tokenizer.text(j)){j=j.substring(he.raw.length),Te=ie[ie.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+he.raw,Te.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):ie.push(he);continue}if(j){var Ae="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,ie},ce.inline=function(j,ie){return ie===void 0&&(ie=[]),this.inlineQueue.push({src:j,tokens:ie}),ie},ce.inlineTokens=function(j,ie){var ue=this;ie===void 0&&(ie=[]);var he,Te,me,Pe=j,Ae,xe,H;if(this.tokens.links){var U=Object.keys(this.tokens.links);if(U.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)U.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Ae.index)+"["+P("a",Ae[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Ae.index)+"["+P("a",Ae[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Ae.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;j;)if(xe||(H=""),xe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(K){return(he=K.call({lexer:ue},j,ie))?(j=j.substring(he.raw.length),ie.push(he),!0):!1}))){if(he=this.tokenizer.escape(j)){j=j.substring(he.raw.length),ie.push(he);continue}if(he=this.tokenizer.tag(j)){j=j.substring(he.raw.length),Te=ie[ie.length-1],Te&&he.type==="text"&&Te.type==="text"?(Te.raw+=he.raw,Te.text+=he.text):ie.push(he);continue}if(he=this.tokenizer.link(j)){j=j.substring(he.raw.length),ie.push(he);continue}if(he=this.tokenizer.reflink(j,this.tokens.links)){j=j.substring(he.raw.length),Te=ie[ie.length-1],Te&&he.type==="text"&&Te.type==="text"?(Te.raw+=he.raw,Te.text+=he.text):ie.push(he);continue}if(he=this.tokenizer.emStrong(j,Pe,H)){j=j.substring(he.raw.length),ie.push(he);continue}if(he=this.tokenizer.codespan(j)){j=j.substring(he.raw.length),ie.push(he);continue}if(he=this.tokenizer.br(j)){j=j.substring(he.raw.length),ie.push(he);continue}if(he=this.tokenizer.del(j)){j=j.substring(he.raw.length),ie.push(he);continue}if(he=this.tokenizer.autolink(j,B)){j=j.substring(he.raw.length),ie.push(he);continue}if(!this.state.inLink&&(he=this.tokenizer.url(j,B))){j=j.substring(he.raw.length),ie.push(he);continue}if(me=j,this.options.extensions&&this.options.extensions.startInline&&function(){var K=1/0,ge=j.slice(1),Ee=void 0;ue.options.extensions.startInline.forEach(function(ze){Ee=ze.call({lexer:this},ge),typeof Ee=="number"&&Ee>=0&&(K=Math.min(K,Ee))}),K<1/0&&K>=0&&(me=j.substring(0,K+1))}(),he=this.tokenizer.inlineText(me,M)){j=j.substring(he.raw.length),he.raw.slice(-1)!=="_"&&(H=he.raw.slice(-1)),xe=!0,Te=ie[ie.length-1],Te&&Te.type==="text"?(Te.raw+=he.raw,Te.text+=he.text):ie.push(he);continue}if(j){var X="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return ie},c(ae,null,[{key:"rules",get:function(){return{block:F,inline:N}}}]),ae}(),Y=function(){function ae(se){this.options=se||de.defaults}var ce=ae.prototype;return ce.code=function(j,ie,ue){var he=(ie||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(j,he);Te!=null&&Te!==j&&(ue=!0,j=Te)}return j=j.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+S(he,!0)+'">'+(ue?j:S(j,!0))+`</code></pre>
`:"<pre><code>"+(ue?j:S(j,!0))+`</code></pre>
`},ce.blockquote=function(j){return`<blockquote>
`+j+`</blockquote>
`},ce.html=function(j){return j},ce.heading=function(j,ie,ue,he){if(this.options.headerIds){var Te=this.options.headerPrefix+he.slug(ue);return"<h"+ie+' id="'+Te+'">'+j+"</h"+ie+`>
`}return"<h"+ie+">"+j+"</h"+ie+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(j,ie,ue){var he=ie?"ol":"ul",Te=ie&&ue!==1?' start="'+ue+'"':"";return"<"+he+Te+`>
`+j+"</"+he+`>
`},ce.listitem=function(j){return"<li>"+j+`</li>
`},ce.checkbox=function(j){return"<input "+(j?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(j){return"<p>"+j+`</p>
`},ce.table=function(j,ie){return ie&&(ie="<tbody>"+ie+"</tbody>"),`<table>
<thead>
`+j+`</thead>
`+ie+`</table>
`},ce.tablerow=function(j){return`<tr>
`+j+`</tr>
`},ce.tablecell=function(j,ie){var ue=ie.header?"th":"td",he=ie.align?"<"+ue+' align="'+ie.align+'">':"<"+ue+">";return he+j+("</"+ue+`>
`)},ce.strong=function(j){return"<strong>"+j+"</strong>"},ce.em=function(j){return"<em>"+j+"</em>"},ce.codespan=function(j){return"<code>"+j+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(j){return"<del>"+j+"</del>"},ce.link=function(j,ie,ue){if(j=s(this.options.sanitize,this.options.baseUrl,j),j===null)return ue;var he='<a href="'+S(j)+'"';return ie&&(he+=' title="'+ie+'"'),he+=">"+ue+"</a>",he},ce.image=function(j,ie,ue){if(j=s(this.options.sanitize,this.options.baseUrl,j),j===null)return ue;var he='<img src="'+j+'" alt="'+ue+'"';return ie&&(he+=' title="'+ie+'"'),he+=this.options.xhtml?"/>":">",he},ce.text=function(j){return j},ae}(),Z=function(){function ae(){}var ce=ae.prototype;return ce.strong=function(j){return j},ce.em=function(j){return j},ce.codespan=function(j){return j},ce.del=function(j){return j},ce.html=function(j){return j},ce.text=function(j){return j},ce.link=function(j,ie,ue){return""+ue},ce.image=function(j,ie,ue){return""+ue},ce.br=function(){return""},ae}(),G=function(){function ae(){this.seen={}}var ce=ae.prototype;return ce.serialize=function(j){return j.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(j,ie){var ue=j,he=0;if(this.seen.hasOwnProperty(ue)){he=this.seen[j];do he++,ue=j+"-"+he;while(this.seen.hasOwnProperty(ue))}return ie||(this.seen[j]=he,this.seen[ue]=0),ue},ce.slug=function(j,ie){ie===void 0&&(ie={});var ue=this.serialize(j);return this.getNextSafeSlug(ue,ie.dryrun)},ae}(),Q=function(){function ae(se){this.options=se||de.defaults,this.options.renderer=this.options.renderer||new Y,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new G}ae.parse=function(j,ie){var ue=new ae(ie);return ue.parse(j)},ae.parseInline=function(j,ie){var ue=new ae(ie);return ue.parseInline(j)};var ce=ae.prototype;return ce.parse=function(j,ie){ie===void 0&&(ie=!0);var ue="",he,Te,me,Pe,Ae,xe,H,U,X,K,ge,Ee,ze,He,Ye,it,rt,at,st,De=j.length;for(he=0;he<De;he++){if(K=j[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[K.type]&&(st=this.options.extensions.renderers[K.type].call({parser:this},K),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(K.type))){ue+=st||"";continue}switch(K.type){case"space":continue;case"hr":{ue+=this.renderer.hr();continue}case"heading":{ue+=this.renderer.heading(this.parseInline(K.tokens),K.depth,m(this.parseInline(K.tokens,this.textRenderer)),this.slugger);continue}case"code":{ue+=this.renderer.code(K.text,K.lang,K.escaped);continue}case"table":{for(U="",H="",Pe=K.header.length,Te=0;Te<Pe;Te++)H+=this.renderer.tablecell(this.parseInline(K.header[Te].tokens),{header:!0,align:K.align[Te]});for(U+=this.renderer.tablerow(H),X="",Pe=K.rows.length,Te=0;Te<Pe;Te++){for(xe=K.rows[Te],H="",Ae=xe.length,me=0;me<Ae;me++)H+=this.renderer.tablecell(this.parseInline(xe[me].tokens),{header:!1,align:K.align[me]});X+=this.renderer.tablerow(H)}ue+=this.renderer.table(U,X);continue}case"blockquote":{X=this.parse(K.tokens),ue+=this.renderer.blockquote(X);continue}case"list":{for(ge=K.ordered,Ee=K.start,ze=K.loose,Pe=K.items.length,X="",Te=0;Te<Pe;Te++)Ye=K.items[Te],it=Ye.checked,rt=Ye.task,He="",Ye.task&&(at=this.renderer.checkbox(it),ze?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=at+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=at+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:at}):He+=at),He+=this.parse(Ye.tokens,ze),X+=this.renderer.listitem(He,rt,it);ue+=this.renderer.list(X,ge,Ee);continue}case"html":{ue+=this.renderer.html(K.text);continue}case"paragraph":{ue+=this.renderer.paragraph(this.parseInline(K.tokens));continue}case"text":{for(X=K.tokens?this.parseInline(K.tokens):K.text;he+1<De&&j[he+1].type==="text";)K=j[++he],X+=`
`+(K.tokens?this.parseInline(K.tokens):K.text);ue+=ie?this.renderer.paragraph(X):X;continue}default:{var Be='Token with "'+K.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return ue},ce.parseInline=function(j,ie){ie=ie||this.renderer;var ue="",he,Te,me,Pe=j.length;for(he=0;he<Pe;he++){if(Te=j[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(me=this.options.extensions.renderers[Te.type].call({parser:this},Te),me!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){ue+=me||"";continue}switch(Te.type){case"escape":{ue+=ie.text(Te.text);break}case"html":{ue+=ie.html(Te.text);break}case"link":{ue+=ie.link(Te.href,Te.title,this.parseInline(Te.tokens,ie));break}case"image":{ue+=ie.image(Te.href,Te.title,Te.text);break}case"strong":{ue+=ie.strong(this.parseInline(Te.tokens,ie));break}case"em":{ue+=ie.em(this.parseInline(Te.tokens,ie));break}case"codespan":{ue+=ie.codespan(Te.text);break}case"br":{ue+=ie.br();break}case"del":{ue+=ie.del(this.parseInline(Te.tokens,ie));break}case"text":{ue+=ie.text(Te.text);break}default:{var Ae='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return ue},ae}();function re(ae,ce,se){if(typeof ae>"u"||ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");if(typeof ce=="function"&&(se=ce,ce=null),ce=g({},re.defaults,ce||{}),y(ce),se){var j=ce.highlight,ie;try{ie=W.lex(ae,ce)}catch(Pe){return se(Pe)}var ue=function(Ae){var xe;if(!Ae)try{ce.walkTokens&&re.walkTokens(ie,ce.walkTokens),xe=Q.parse(ie,ce)}catch(H){Ae=H}return ce.highlight=j,Ae?se(Ae):se(null,xe)};if(!j||j.length<3||(delete ce.highlight,!ie.length))return ue();var he=0;re.walkTokens(ie,function(Pe){Pe.type==="code"&&(he++,setTimeout(function(){j(Pe.text,Pe.lang,function(Ae,xe){if(Ae)return ue(Ae);xe!=null&&xe!==Pe.text&&(Pe.text=xe,Pe.escaped=!0),he--,he===0&&ue()})},0))}),he===0&&ue();return}function Te(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+S(Pe.message+"",!0)+"</pre>";throw Pe}try{var me=W.lex(ae,ce);if(ce.walkTokens){if(ce.async)return Promise.all(re.walkTokens(me,ce.walkTokens)).then(function(){return Q.parse(me,ce)}).catch(Te);re.walkTokens(me,ce.walkTokens)}return Q.parse(me,ce)}catch(Pe){Te(Pe)}}re.options=re.setOptions=function(ae){return g(re.defaults,ae),b(re.defaults),re},re.getDefaults=R,re.defaults=de.defaults,re.use=function(){for(var ae=arguments.length,ce=new Array(ae),se=0;se<ae;se++)ce[se]=arguments[se];var j=g.apply(void 0,[{}].concat(ce)),ie=re.defaults.extensions||{renderers:{},childTokens:{}},ue;ce.forEach(function(he){if(he.extensions&&(ue=!0,he.extensions.forEach(function(me){if(!me.name)throw new Error("extension name required");if(me.renderer){var Pe=ie.renderers?ie.renderers[me.name]:null;Pe?ie.renderers[me.name]=function(){for(var Ae=arguments.length,xe=new Array(Ae),H=0;H<Ae;H++)xe[H]=arguments[H];var U=me.renderer.apply(this,xe);return U===!1&&(U=Pe.apply(this,xe)),U}:ie.renderers[me.name]=me.renderer}if(me.tokenizer){if(!me.level||me.level!=="block"&&me.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ie[me.level]?ie[me.level].unshift(me.tokenizer):ie[me.level]=[me.tokenizer],me.start&&(me.level==="block"?ie.startBlock?ie.startBlock.push(me.start):ie.startBlock=[me.start]:me.level==="inline"&&(ie.startInline?ie.startInline.push(me.start):ie.startInline=[me.start]))}me.childTokens&&(ie.childTokens[me.name]=me.childTokens)})),he.renderer&&function(){var me=re.defaults.renderer||new Y,Pe=function(H){var U=me[H];me[H]=function(){for(var X=arguments.length,K=new Array(X),ge=0;ge<X;ge++)K[ge]=arguments[ge];var Ee=he.renderer[H].apply(me,K);return Ee===!1&&(Ee=U.apply(me,K)),Ee}};for(var Ae in he.renderer)Pe(Ae);j.renderer=me}(),he.tokenizer&&function(){var me=re.defaults.tokenizer||new x,Pe=function(H){var U=me[H];me[H]=function(){for(var X=arguments.length,K=new Array(X),ge=0;ge<X;ge++)K[ge]=arguments[ge];var Ee=he.tokenizer[H].apply(me,K);return Ee===!1&&(Ee=U.apply(me,K)),Ee}};for(var Ae in he.tokenizer)Pe(Ae);j.tokenizer=me}(),he.walkTokens){var Te=re.defaults.walkTokens;j.walkTokens=function(me){var Pe=[];return Pe.push(he.walkTokens.call(this,me)),Te&&(Pe=Pe.concat(Te.call(this,me))),Pe}}ue&&(j.extensions=ie),re.setOptions(j)})},re.walkTokens=function(ae,ce){for(var se=[],j=function(){var Te=ue.value;switch(se=se.concat(ce.call(re,Te)),Te.type){case"table":{for(var me=T(Te.header),Pe;!(Pe=me()).done;){var Ae=Pe.value;se=se.concat(re.walkTokens(Ae.tokens,ce))}for(var xe=T(Te.rows),H;!(H=xe()).done;)for(var U=H.value,X=T(U),K;!(K=X()).done;){var ge=K.value;se=se.concat(re.walkTokens(ge.tokens,ce))}break}case"list":{se=se.concat(re.walkTokens(Te.items,ce));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[Te.type]?re.defaults.extensions.childTokens[Te.type].forEach(function(Ee){se=se.concat(re.walkTokens(Te[Ee],ce))}):Te.tokens&&(se=se.concat(re.walkTokens(Te.tokens,ce)))}},ie=T(ae),ue;!(ue=ie()).done;)j();return se},re.parseInline=function(ae,ce){if(typeof ae>"u"||ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");ce=g({},re.defaults,ce||{}),y(ce);try{var se=W.lexInline(ae,ce);return ce.walkTokens&&re.walkTokens(se,ce.walkTokens),Q.parseInline(se,ce)}catch(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+S(j.message+"",!0)+"</pre>";throw j}},re.Parser=Q,re.parser=Q.parse,re.Renderer=Y,re.TextRenderer=Z,re.Lexer=W,re.lexer=W.lex,re.Tokenizer=x,re.Slugger=G,re.parse=re;var te=re.options,ve=re.setOptions,Ie=re.use,J=re.walkTokens,$=re.parseInline,ne=re,be=Q.parse,Ce=W.lex;de.Lexer=W,de.Parser=Q,de.Renderer=Y,de.Slugger=G,de.TextRenderer=Z,de.Tokenizer=x,de.getDefaults=R,de.lexer=Ce,de.marked=re,de.options=te,de.parse=ne,de.parseInline=$,de.parser=be,de.setOptions=ve,de.use=Ie,de.walkTokens=J,Object.defineProperty(de,"__esModule",{value:!0})}),define(ye[166],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=c;function c(a){const m=T(a);if(m&&m.length>0)return new Uint32Array(m)}let O=0;const L=new Uint32Array(10);function T(a){if(O=0,R(a,I,4352),O>0||(R(a,v,4449),O>0)||(R(a,C,4520),O>0)||(R(a,S,12593),O))return L.subarray(0,O);if(a>=44032&&a<=55203){const m=a-44032,o=m%588,n=Math.floor(m/588),i=Math.floor(o/28),r=o%28-1;if(n<I.length?R(n,I,0):4352+n-12593<S.length&&R(4352+n,S,12593),i<v.length?R(i,v,0):4449+i-12593<S.length&&R(4449+i-12593,S,12593),r>=0&&(r<C.length?R(r,C,0):4520+r-12593<S.length&&R(4520+r-12593,S,12593)),O>0)return L.subarray(0,O)}}function R(a,m,o){a>=o&&a<o+m.length&&b(m[a-o])}function b(a){a!==0&&(L[O++]=a&255,a>>8&&(L[O++]=a>>8&255),a>>16&&(L[O++]=a>>16&255))}var p;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var w;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(w||(w={}));var A;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(A||(A={}));const I=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),v=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),C=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),S=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ye[76],_e([1,0,27]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=L,e.normalizeNFD=R;const O=new c.LRUCache(1e4);function L(w){return p(w,"NFC",O)}const T=new c.LRUCache(1e4);function R(w){return p(w,"NFD",T)}const b=/[^\u0000-\u0080]/;function p(w,A,I){if(!w)return w;const v=I.get(w);if(v)return v;let C;return b.test(w)?C=w.normalize(A):C=w,I.set(w,C),C}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(A){return R(A).replace(w,"")}}()}),define(ye[125],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=c,e.rot=O;function c(b,p,w){return Math.min(Math.max(b,p),w)}function O(b,p){return(p+b%p)%p}class L{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=L;class T{constructor(){this._n=1,this._val=0}update(p){return this._val=this._val+(p-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=T;class R{constructor(p){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(p),this._values.fill(0,0,p)}update(p){const w=this._values[this._index];return this._values[this._index]=p,this._index=(this._index+1)%this._values.length,this._sum-=w,this._sum+=p,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=R}),function(){function de(L){const T=[];typeof L=="number"&&T.push("code/timeOrigin",L);function R(p){T.push(p,Date.now())}function b(){const p=[];for(let w=0;w<T.length;w+=2)p.push({name:T[w],startTime:T[w+1]});return p}return{mark:R,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?de():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const R of performance.getEntriesByType("mark"))T.push({name:R.name,startTime:Math.round(L+R.startTime)});return T}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return de(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),de()}function c(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=c(O))}(),define(ye[167],_e([1,0,38]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WellDefinedPrefixTree=void 0;const O=Symbol("unset");class L{constructor(){this.root=new R,this._size=0}get size(){return this._size}get nodes(){return this.root.children?.values()||c.Iterable.empty()}insert(p,w,A){this.opNode(p,I=>I._value=w,A)}mutate(p,w){this.opNode(p,A=>A._value=w(A._value===O?void 0:A._value))}delete(p){const w=this.getPathToKey(p);if(!w)return;let A=w.length-1;const I=w[A].node._value;if(I!==O){for(this._size--,w[A].node._value=O;A>0;A--){const{node:v,part:C}=w[A];if(v.children?.size||v._value!==O)break;w[A-1].node.children.delete(C)}return I}}*deleteRecursive(p){const w=this.getPathToKey(p);if(!w)return;const A=w[w.length-1].node;for(let I=w.length-1;I>0;I--){const v=w[I-1];if(v.node.children.delete(w[I].part),v.node.children.size>0||v.node._value!==O)break}for(const I of T(A))I._value!==O&&(this._size--,yield I._value)}find(p){let w=this.root;for(const A of p){const I=w.children?.get(A);if(!I)return;w=I}return w._value===O?void 0:w._value}hasKeyOrParent(p){let w=this.root;for(const A of p){const I=w.children?.get(A);if(!I)return!1;if(I._value!==O)return!0;w=I}return!1}hasKeyOrChildren(p){let w=this.root;for(const A of p){const I=w.children?.get(A);if(!I)return!1;w=I}return!0}hasKey(p){let w=this.root;for(const A of p){const I=w.children?.get(A);if(!I)return!1;w=I}return w._value!==O}getPathToKey(p){const w=[{part:"",node:this.root}];let A=0;for(const I of p){const v=w[A].node.children?.get(I);if(!v)return;w.push({part:I,node:v}),A++}return w}opNode(p,w,A){let I=this.root;for(const S of p){if(I.children)if(I.children.has(S))I=I.children.get(S);else{const a=new R;I.children.set(S,a),I=a}else{const a=new R;I.children=new Map([[S,a]]),I=a}A?.(I)}const v=I._value===O?0:1;w(I);const C=I._value===O?0:1;this._size+=C-v}*values(){for(const{_value:p}of T(this.root))p!==O&&(yield p)}}e.WellDefinedPrefixTree=L;function*T(b){const p=[b];for(;p.length>0;){const w=p.pop();if(yield w,w.children)for(const A of w.children.values())p.push(A)}}class R{constructor(){this._value=O}get value(){return this._value===O?void 0:this._value}set value(p){this._value=p===void 0?O:p}}}),function(de,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var c=e();for(var O in c)(typeof exports=="object"?exports:de)[O]=c[O]}}(typeof self<"u"?self:this,function(){return function(de){var e={};function c(O){if(e[O])return e[O].exports;var L=e[O]={i:O,l:!1,exports:{}};return de[O].call(L.exports,L,L.exports,c),L.l=!0,L.exports}return c.m=de,c.c=e,c.d=function(O,L,T){c.o(O,L)||Object.defineProperty(O,L,{enumerable:!0,get:T})},c.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},c.t=function(O,L){if(1&L&&(O=c(O)),8&L||4&L&&typeof O=="object"&&O&&O.__esModule)return O;var T=Object.create(null);if(c.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:O}),2&L&&typeof O!="string")for(var R in O)c.d(T,R,function(b){return O[b]}.bind(null,R));return T},c.n=function(O){var L=O&&O.__esModule?function(){return O.default}:function(){return O};return c.d(L,"a",L),L},c.o=function(O,L){return Object.prototype.hasOwnProperty.call(O,L)},c.p="",c(c.s=0)}([function(de,e,c){(function(O){var L;e=de.exports=Ie,L=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],p=e.src=[],w=0,A=w++;p[A]="0|[1-9]\\d*";var I=w++;p[I]="[0-9]+";var v=w++;p[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=w++;p[C]="("+p[A]+")\\.("+p[A]+")\\.("+p[A]+")";var S=w++;p[S]="("+p[I]+")\\.("+p[I]+")\\.("+p[I]+")";var a=w++;p[a]="(?:"+p[A]+"|"+p[v]+")";var m=w++;p[m]="(?:"+p[I]+"|"+p[v]+")";var o=w++;p[o]="(?:-("+p[a]+"(?:\\."+p[a]+")*))";var n=w++;p[n]="(?:-?("+p[m]+"(?:\\."+p[m]+")*))";var i=w++;p[i]="[0-9A-Za-z-]+";var r=w++;p[r]="(?:\\+("+p[i]+"(?:\\."+p[i]+")*))";var s=w++,t="v?"+p[C]+p[o]+"?"+p[r]+"?";p[s]="^"+t+"$";var f="[v=\\s]*"+p[S]+p[n]+"?"+p[r]+"?",h=w++;p[h]="^"+f+"$";var l=w++;p[l]="((?:<|>)?=?)";var u=w++;p[u]=p[I]+"|x|X|\\*";var d=w++;p[d]=p[A]+"|x|X|\\*";var g=w++;p[g]="[v=\\s]*("+p[d]+")(?:\\.("+p[d]+")(?:\\.("+p[d]+")(?:"+p[o]+")?"+p[r]+"?)?)?";var D=w++;p[D]="[v=\\s]*("+p[u]+")(?:\\.("+p[u]+")(?:\\.("+p[u]+")(?:"+p[n]+")?"+p[r]+"?)?)?";var E=w++;p[E]="^"+p[l]+"\\s*"+p[g]+"$";var _=w++;p[_]="^"+p[l]+"\\s*"+p[D]+"$";var y=w++;p[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=w++;p[P]="(?:~>?)";var k=w++;p[k]="(\\s*)"+p[P]+"\\s+",b[k]=new RegExp(p[k],"g");var z=w++;p[z]="^"+p[P]+p[g]+"$";var x=w++;p[x]="^"+p[P]+p[D]+"$";var F=w++;p[F]="(?:\\^)";var N=w++;p[N]="(\\s*)"+p[F]+"\\s+",b[N]=new RegExp(p[N],"g");var M=w++;p[M]="^"+p[F]+p[g]+"$";var B=w++;p[B]="^"+p[F]+p[D]+"$";var W=w++;p[W]="^"+p[l]+"\\s*("+f+")$|^$";var Y=w++;p[Y]="^"+p[l]+"\\s*("+t+")$|^$";var Z=w++;p[Z]="(\\s*)"+p[l]+"\\s*("+f+"|"+p[g]+")",b[Z]=new RegExp(p[Z],"g");var G=w++;p[G]="^\\s*("+p[g]+")\\s+-\\s+("+p[g]+")\\s*$";var Q=w++;p[Q]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var re=w++;p[re]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)L(te,p[te]),b[te]||(b[te]=new RegExp(p[te]));function ve(U,X){if(U instanceof Ie)return U;if(typeof U!="string"||U.length>T||!(X?b[h]:b[s]).test(U))return null;try{return new Ie(U,X)}catch{return null}}function Ie(U,X){if(U instanceof Ie){if(U.loose===X)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof Ie))return new Ie(U,X);L("SemVer",U,X),this.loose=X;var K=U.trim().match(X?b[h]:b[s]);if(!K)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var Ee=+ge;if(Ee>=0&&Ee<R)return Ee}return ge}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}e.parse=ve,e.valid=function(U,X){var K=ve(U,X);return K?K.version:null},e.clean=function(U,X){var K=ve(U.trim().replace(/^[=v]+/,""),X);return K?K.version:null},e.SemVer=Ie,Ie.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ie.prototype.toString=function(){return this.version},Ie.prototype.compare=function(U){return L("SemVer.compare",this.version,this.loose,U),U instanceof Ie||(U=new Ie(U,this.loose)),this.compareMain(U)||this.comparePre(U)},Ie.prototype.compareMain=function(U){return U instanceof Ie||(U=new Ie(U,this.loose)),$(this.major,U.major)||$(this.minor,U.minor)||$(this.patch,U.patch)},Ie.prototype.comparePre=function(U){if(U instanceof Ie||(U=new Ie(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var X=0;do{var K=this.prerelease[X],ge=U.prerelease[X];if(L("prerelease compare",X,K,ge),K===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(K===void 0)return-1;if(K!==ge)return $(K,ge)}while(++X)},Ie.prototype.inc=function(U,X){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},e.inc=function(U,X,K,ge){typeof K=="string"&&(ge=K,K=void 0);try{return new Ie(U,K).inc(X,ge).version}catch{return null}},e.diff=function(U,X){if(ae(U,X))return null;var K=ve(U),ge=ve(X);if(K.prerelease.length||ge.prerelease.length){for(var Ee in K)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&K[Ee]!==ge[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in K)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&K[Ee]!==ge[Ee])return Ee},e.compareIdentifiers=$;var J=/^[0-9]+$/;function $(U,X){var K=J.test(U),ge=J.test(X);return K&&ge&&(U=+U,X=+X),K&&!ge?-1:ge&&!K?1:U<X?-1:U>X?1:0}function ne(U,X,K){return new Ie(U,K).compare(new Ie(X,K))}function be(U,X,K){return ne(U,X,K)>0}function Ce(U,X,K){return ne(U,X,K)<0}function ae(U,X,K){return ne(U,X,K)===0}function ce(U,X,K){return ne(U,X,K)!==0}function se(U,X,K){return ne(U,X,K)>=0}function j(U,X,K){return ne(U,X,K)<=0}function ie(U,X,K,ge){var Ee;switch(X){case"===":typeof U=="object"&&(U=U.version),typeof K=="object"&&(K=K.version),Ee=U===K;break;case"!==":typeof U=="object"&&(U=U.version),typeof K=="object"&&(K=K.version),Ee=U!==K;break;case"":case"=":case"==":Ee=ae(U,K,ge);break;case"!=":Ee=ce(U,K,ge);break;case">":Ee=be(U,K,ge);break;case">=":Ee=se(U,K,ge);break;case"<":Ee=Ce(U,K,ge);break;case"<=":Ee=j(U,K,ge);break;default:throw new TypeError("Invalid operator: "+X)}return Ee}function ue(U,X){if(U instanceof ue){if(U.loose===X)return U;U=U.value}if(!(this instanceof ue))return new ue(U,X);L("comparator",U,X),this.loose=X,this.parse(U),this.semver===he?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(U,X){return $(X,U)},e.major=function(U,X){return new Ie(U,X).major},e.minor=function(U,X){return new Ie(U,X).minor},e.patch=function(U,X){return new Ie(U,X).patch},e.compare=ne,e.compareLoose=function(U,X){return ne(U,X,!0)},e.rcompare=function(U,X,K){return ne(X,U,K)},e.sort=function(U,X){return U.sort(function(K,ge){return e.compare(K,ge,X)})},e.rsort=function(U,X){return U.sort(function(K,ge){return e.rcompare(K,ge,X)})},e.gt=be,e.lt=Ce,e.eq=ae,e.neq=ce,e.gte=se,e.lte=j,e.cmp=ie,e.Comparator=ue;var he={};function Te(U,X){if(U instanceof Te)return U.loose===X?U:new Te(U.raw,X);if(U instanceof ue)return new Te(U.value,X);if(!(this instanceof Te))return new Te(U,X);if(this.loose=X,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function me(U){return!U||U.toLowerCase()==="x"||U==="*"}function Pe(U,X,K,ge,Ee,ze,He,Ye,it,rt,at,st,De){return((X=me(K)?"":me(ge)?">="+K+".0.0":me(Ee)?">="+K+"."+ge+".0":">="+X)+" "+(Ye=me(it)?"":me(rt)?"<"+(+it+1)+".0.0":me(at)?"<"+it+"."+(+rt+1)+".0":st?"<="+it+"."+rt+"."+at+"-"+st:"<="+Ye)).trim()}function Ae(U,X){for(var K=0;K<U.length;K++)if(!U[K].test(X))return!1;if(X.prerelease.length){for(K=0;K<U.length;K++)if(L(U[K].semver),U[K].semver!==he&&U[K].semver.prerelease.length>0){var ge=U[K].semver;if(ge.major===X.major&&ge.minor===X.minor&&ge.patch===X.patch)return!0}return!1}return!0}function xe(U,X,K){try{X=new Te(X,K)}catch{return!1}return X.test(U)}function H(U,X,K,ge){var Ee,ze,He,Ye,it;switch(U=new Ie(U,ge),X=new Te(X,ge),K){case">":Ee=be,ze=j,He=Ce,Ye=">",it=">=";break;case"<":Ee=Ce,ze=se,He=be,Ye="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(U,X,ge))return!1;for(var rt=0;rt<X.set.length;++rt){var at=X.set[rt],st=null,De=null;if(at.forEach(function(Be){Be.semver===he&&(Be=new ue(">=0.0.0")),st=st||Be,De=De||Be,Ee(Be.semver,st.semver,ge)?st=Be:He(Be.semver,De.semver,ge)&&(De=Be)}),st.operator===Ye||st.operator===it||(!De.operator||De.operator===Ye)&&ze(U,De.semver)||De.operator===it&&He(U,De.semver))return!1}return!0}ue.prototype.parse=function(U){var X=this.loose?b[W]:b[Y],K=U.match(X);if(!K)throw new TypeError("Invalid comparator: "+U);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new Ie(K[2],this.loose):this.semver=he},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(U){return L("Comparator.test",U,this.loose),this.semver===he||(typeof U=="string"&&(U=new Ie(U,this.loose)),ie(U,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(U,X){if(!(U instanceof ue))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new Te(U.value,X),xe(this.value,K,X);if(U.operator==="")return K=new Te(this.value,X),xe(U.semver,K,X);var ge=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),ze=this.semver.version===U.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Ye=ie(this.semver,"<",U.semver,X)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),it=ie(this.semver,">",U.semver,X)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return ge||Ee||ze&&He||Ye||it},e.Range=Te,Te.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},Te.prototype.toString=function(){return this.range},Te.prototype.parseRange=function(U){var X=this.loose;U=U.trim(),L("range",U,X);var K=X?b[Q]:b[G];U=U.replace(K,Pe),L("hyphen replace",U),U=U.replace(b[Z],"$1$2$3"),L("comparator trim",U,b[Z]),U=(U=(U=U.replace(b[k],"$1~")).replace(b[N],"$1^")).split(/\s+/).join(" ");var ge=X?b[W]:b[Y],Ee=U.split(" ").map(function(ze){return function(He,Ye){return L("comp",He),He=function(it,rt){return it.trim().split(/\s+/).map(function(at){return function(st,De){L("caret",st,De);var Be=De?b[B]:b[M];return st.replace(Be,function(qe,Le,Qe,oe,le){var ke;return L("caret",st,qe,Le,Qe,oe,le),me(Le)?ke="":me(Qe)?ke=">="+Le+".0.0 <"+(+Le+1)+".0.0":me(oe)?ke=Le==="0"?">="+Le+"."+Qe+".0 <"+Le+"."+(+Qe+1)+".0":">="+Le+"."+Qe+".0 <"+(+Le+1)+".0.0":le?(L("replaceCaret pr",le),le.charAt(0)!=="-"&&(le="-"+le),ke=Le==="0"?Qe==="0"?">="+Le+"."+Qe+"."+oe+le+" <"+Le+"."+Qe+"."+(+oe+1):">="+Le+"."+Qe+"."+oe+le+" <"+Le+"."+(+Qe+1)+".0":">="+Le+"."+Qe+"."+oe+le+" <"+(+Le+1)+".0.0"):(L("no pr"),ke=Le==="0"?Qe==="0"?">="+Le+"."+Qe+"."+oe+" <"+Le+"."+Qe+"."+(+oe+1):">="+Le+"."+Qe+"."+oe+" <"+Le+"."+(+Qe+1)+".0":">="+Le+"."+Qe+"."+oe+" <"+(+Le+1)+".0.0"),L("caret return",ke),ke})}(at,rt)}).join(" ")}(He,Ye),L("caret",He),He=function(it,rt){return it.trim().split(/\s+/).map(function(at){return function(st,De){var Be=De?b[x]:b[z];return st.replace(Be,function(qe,Le,Qe,oe,le){var ke;return L("tilde",st,qe,Le,Qe,oe,le),me(Le)?ke="":me(Qe)?ke=">="+Le+".0.0 <"+(+Le+1)+".0.0":me(oe)?ke=">="+Le+"."+Qe+".0 <"+Le+"."+(+Qe+1)+".0":le?(L("replaceTilde pr",le),le.charAt(0)!=="-"&&(le="-"+le),ke=">="+Le+"."+Qe+"."+oe+le+" <"+Le+"."+(+Qe+1)+".0"):ke=">="+Le+"."+Qe+"."+oe+" <"+Le+"."+(+Qe+1)+".0",L("tilde return",ke),ke})}(at,rt)}).join(" ")}(He,Ye),L("tildes",He),He=function(it,rt){return L("replaceXRanges",it,rt),it.split(/\s+/).map(function(at){return function(st,De){st=st.trim();var Be=De?b[_]:b[E];return st.replace(Be,function(qe,Le,Qe,oe,le,ke){L("xRange",st,qe,Le,Qe,oe,le,ke);var je=me(Qe),Ze=je||me(oe),Me=Ze||me(le);return Le==="="&&Me&&(Le=""),je?qe=Le===">"||Le==="<"?"<0.0.0":"*":Le&&Me?(Ze&&(oe=0),Me&&(le=0),Le===">"?(Le=">=",Ze?(Qe=+Qe+1,oe=0,le=0):Me&&(oe=+oe+1,le=0)):Le==="<="&&(Le="<",Ze?Qe=+Qe+1:oe=+oe+1),qe=Le+Qe+"."+oe+"."+le):Ze?qe=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":Me&&(qe=">="+Qe+"."+oe+".0 <"+Qe+"."+(+oe+1)+".0"),L("xRange return",qe),qe})}(at,rt)}).join(" ")}(He,Ye),L("xrange",He),He=function(it,rt){return L("replaceStars",it,rt),it.trim().replace(b[re],"")}(He,Ye),L("stars",He),He}(ze,X)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(ze){return!!ze.match(ge)})),Ee=Ee.map(function(ze){return new ue(ze,X)})},Te.prototype.intersects=function(U,X){if(!(U instanceof Te))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(ge){return U.set.some(function(Ee){return Ee.every(function(ze){return ge.intersects(ze,X)})})})})},e.toComparators=function(U,X){return new Te(U,X).set.map(function(K){return K.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},Te.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new Ie(U,this.loose));for(var X=0;X<this.set.length;X++)if(Ae(this.set[X],U))return!0;return!1},e.satisfies=xe,e.maxSatisfying=function(U,X,K){var ge=null,Ee=null;try{var ze=new Te(X,K)}catch{return null}return U.forEach(function(He){ze.test(He)&&(ge&&Ee.compare(He)!==-1||(Ee=new Ie(ge=He,K)))}),ge},e.minSatisfying=function(U,X,K){var ge=null,Ee=null;try{var ze=new Te(X,K)}catch{return null}return U.forEach(function(He){ze.test(He)&&(ge&&Ee.compare(He)!==1||(Ee=new Ie(ge=He,K)))}),ge},e.validRange=function(U,X){try{return new Te(U,X).range||"*"}catch{return null}},e.ltr=function(U,X,K){return H(U,X,"<",K)},e.gtr=function(U,X,K){return H(U,X,">",K)},e.outside=H,e.prerelease=function(U,X){var K=ve(U,X);return K&&K.prerelease.length?K.prerelease:null},e.intersects=function(U,X,K){return U=new Te(U,K),X=new Te(X,K),U.intersects(X)},e.coerce=function(U){if(U instanceof Ie)return U;if(typeof U!="string")return null;var X=U.match(b[y]);return X==null?null:ve((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,c(1))},function(de,e){var c,O,L=de.exports={};function T(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function b(m){if(c===setTimeout)return setTimeout(m,0);if((c===T||!c)&&setTimeout)return c=setTimeout,setTimeout(m,0);try{return c(m,0)}catch{try{return c.call(null,m,0)}catch{return c.call(this,m,0)}}}(function(){try{c=typeof setTimeout=="function"?setTimeout:T}catch{c=T}try{O=typeof clearTimeout=="function"?clearTimeout:R}catch{O=R}})();var p,w=[],A=!1,I=-1;function v(){A&&p&&(A=!1,p.length?w=p.concat(w):I=-1,w.length&&C())}function C(){if(!A){var m=b(v);A=!0;for(var o=w.length;o;){for(p=w,w=[];++I<o;)p&&p[I].run();I=-1,o=w.length}p=null,A=!1,function(n){if(O===clearTimeout)return clearTimeout(n);if((O===R||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(n);try{O(n)}catch{try{return O.call(null,n)}catch{return O.call(this,n)}}}(m)}}function S(m,o){this.fun=m,this.array=o}function a(){}L.nextTick=function(m){var o=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)o[n-1]=arguments[n];w.push(new S(m,o)),w.length!==1||A||b(C)},S.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=a,L.addListener=a,L.once=a,L.off=a,L.removeListener=a,L.removeAllListeners=a,L.emit=a,L.prependListener=a,L.prependOnceListener=a,L.listeners=function(m){return[]},L.binding=function(m){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(m){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ye[39],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const c=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(T){return new O(T)}constructor(T){this._now=c&&T===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=O}),define(ye[4],_e([1,0,13,74,3,75,39]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=C;const b=!1,p=!1,w=!1;var A;(function(y){y.None=()=>L.Disposable.None;function P(ue){if(w){const{onDidAddListener:he}=ue,Te=a.create();let me=0;ue.onDidAddListener=()=>{++me===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Te.print()),he?.()}}}function k(ue,he){return G(ue,()=>{},0,void 0,!0,void 0,he)}y.defer=k;function z(ue){return(he,Te=null,me)=>{let Pe=!1,Ae;return Ae=ue(xe=>{if(!Pe)return Ae?Ae.dispose():Pe=!0,he.call(Te,xe)},null,me),Pe&&Ae.dispose(),Ae}}y.once=z;function x(ue,he,Te){return Y((me,Pe=null,Ae)=>ue(xe=>me.call(Pe,he(xe)),null,Ae),Te)}y.map=x;function F(ue,he,Te){return Y((me,Pe=null,Ae)=>ue(xe=>{he(xe),me.call(Pe,xe)},null,Ae),Te)}y.forEach=F;function N(ue,he,Te){return Y((me,Pe=null,Ae)=>ue(xe=>he(xe)&&me.call(Pe,xe),null,Ae),Te)}y.filter=N;function M(ue){return ue}y.signal=M;function B(...ue){return(he,Te=null,me)=>{const Pe=(0,L.combinedDisposable)(...ue.map(Ae=>Ae(xe=>he.call(Te,xe))));return Z(Pe,me)}}y.any=B;function W(ue,he,Te,me){let Pe=Te;return x(ue,Ae=>(Pe=he(Pe,Ae),Pe),me)}y.reduce=W;function Y(ue,he){let Te;const me={onWillAddFirstListener(){Te=ue(Pe.fire,Pe)},onDidRemoveLastListener(){Te?.dispose()}};he||P(me);const Pe=new s(me);return he?.add(Pe),Pe.event}function Z(ue,he){return he instanceof Array?he.push(ue):he&&he.add(ue),ue}function G(ue,he,Te=100,me=!1,Pe=!1,Ae,xe){let H,U,X,K=0,ge;const Ee={leakWarningThreshold:Ae,onWillAddFirstListener(){H=ue(He=>{K++,U=he(U,He),me&&!X&&(ze.fire(U),U=void 0),ge=()=>{const Ye=U;U=void 0,X=void 0,(!me||K>1)&&ze.fire(Ye),K=0},typeof Te=="number"?(clearTimeout(X),X=setTimeout(ge,Te)):X===void 0&&(X=0,queueMicrotask(ge))})},onWillRemoveListener(){Pe&&K>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,H.dispose()}};xe||P(Ee);const ze=new s(Ee);return xe?.add(ze),ze.event}y.debounce=G;function Q(ue,he=0,Te){return y.debounce(ue,(me,Pe)=>me?(me.push(Pe),me):[Pe],he,void 0,!0,void 0,Te)}y.accumulate=Q;function re(ue,he=(me,Pe)=>me===Pe,Te){let me=!0,Pe;return N(ue,Ae=>{const xe=me||!he(Ae,Pe);return me=!1,Pe=Ae,xe},Te)}y.latch=re;function te(ue,he,Te){return[y.filter(ue,he,Te),y.filter(ue,me=>!he(me),Te)]}y.split=te;function ve(ue,he=!1,Te=[],me){let Pe=Te.slice(),Ae=ue(U=>{Pe?Pe.push(U):H.fire(U)});me&&me.add(Ae);const xe=()=>{Pe?.forEach(U=>H.fire(U)),Pe=null},H=new s({onWillAddFirstListener(){Ae||(Ae=ue(U=>H.fire(U)),me&&me.add(Ae))},onDidAddFirstListener(){Pe&&(he?setTimeout(xe):xe())},onDidRemoveLastListener(){Ae&&Ae.dispose(),Ae=null}});return me&&me.add(H),H.event}y.buffer=ve;function Ie(ue,he){return(me,Pe,Ae)=>{const xe=he(new $);return ue(function(H){const U=xe.evaluate(H);U!==J&&me.call(Pe,U)},void 0,Ae)}}y.chain=Ie;const J=Symbol("HaltChainable");class ${constructor(){this.steps=[]}map(he){return this.steps.push(he),this}forEach(he){return this.steps.push(Te=>(he(Te),Te)),this}filter(he){return this.steps.push(Te=>he(Te)?Te:J),this}reduce(he,Te){let me=Te;return this.steps.push(Pe=>(me=he(me,Pe),me)),this}latch(he=(Te,me)=>Te===me){let Te=!0,me;return this.steps.push(Pe=>{const Ae=Te||!he(Pe,me);return Te=!1,me=Pe,Ae?Pe:J}),this}evaluate(he){for(const Te of this.steps)if(he=Te(he),he===J)break;return he}}function ne(ue,he,Te=me=>me){const me=(...H)=>xe.fire(Te(...H)),Pe=()=>ue.on(he,me),Ae=()=>ue.removeListener(he,me),xe=new s({onWillAddFirstListener:Pe,onDidRemoveLastListener:Ae});return xe.event}y.fromNodeEventEmitter=ne;function be(ue,he,Te=me=>me){const me=(...H)=>xe.fire(Te(...H)),Pe=()=>ue.addEventListener(he,me),Ae=()=>ue.removeEventListener(he,me),xe=new s({onWillAddFirstListener:Pe,onDidRemoveLastListener:Ae});return xe.event}y.fromDOMEventEmitter=be;function Ce(ue){return new Promise(he=>z(ue)(he))}y.toPromise=Ce;function ae(ue){const he=new s;return ue.then(Te=>{he.fire(Te)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}y.fromPromise=ae;function ce(ue,he,Te){return he(Te),ue(me=>he(me))}y.runAndSubscribe=ce;class se{constructor(he,Te){this._observable=he,this._counter=0,this._hasChanged=!1;const me={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};Te||P(me),this.emitter=new s(me),Te&&Te.add(this.emitter)}beginUpdate(he){this._counter++}handlePossibleChange(he){}handleChange(he,Te){this._hasChanged=!0}endUpdate(he){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function j(ue,he){return new se(ue,he).emitter.event}y.fromObservable=j;function ie(ue){return(he,Te,me)=>{let Pe=0,Ae=!1;const xe={beginUpdate(){Pe++},endUpdate(){Pe--,Pe===0&&(ue.reportChanges(),Ae&&(Ae=!1,he.call(Te)))},handlePossibleChange(){},handleChange(){Ae=!0}};ue.addObserver(xe),ue.reportChanges();const H={dispose(){ue.removeObserver(xe)}};return me instanceof L.DisposableStore?me.add(H):Array.isArray(me)&&me.push(H),H}}y.fromObservableLight=ie})(A||(e.Event=A={}));class I{static{this.all=new Set}static{this._idPool=0}constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${I._idPool++}`,I.all.add(this)}start(P){this._stopWatch=new R.StopWatch,this.listenerCount=P}stop(){if(this._stopWatch){const P=this._stopWatch.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=I;let v=-1;function C(y){const P=v;return v=y,{dispose(){v=P}}}class S{constructor(P,k=Math.random().toString(18).slice(2,5)){this.threshold=P,this.name=k,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(P,k){const z=this.threshold;if(z<=0||k<z)return;this._stacks||(this._stacks=new Map);const x=this._stacks.get(P.value)||0;if(this._stacks.set(P.value,x+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=z*.5;let F,N=0;for(const[M,B]of this._stacks)(!F||N<B)&&(F=M,N=B);console.warn(`[${this.name}] potential listener LEAK detected, having ${k} listeners already. MOST frequent listener (${N}):`),console.warn(F)}return()=>{const F=this._stacks.get(P.value)||0;this._stacks.set(P.value,F-1)}}}class a{static create(){return new a(new Error().stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class o{constructor(P){this.value=P,this.id=m++}}const n=2,i=(y,P)=>{if(y instanceof o)P(y);else for(let k=0;k<y.length;k++){const z=y[k];z&&P(z)}},r=b?new FinalizationRegistry(y=>{typeof y=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(y))}):void 0;class s{constructor(P){this._size=0,this._options=P,this._leakageMon=v>0||this._options?.leakWarningThreshold?new S(this._options?.leakWarningThreshold??v):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(p){const P=this._listeners;queueMicrotask(()=>{i(P,k=>k.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(P,k,z)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.Disposable.None;if(this._disposed)return L.Disposable.None;k&&(P=P.bind(k));const x=new o(P);let F,N;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(x.stack=a.create(),F=this._leakageMon.check(x.stack,this._size+1)),p&&(x.stack=N??a.create()),this._listeners?this._listeners instanceof o?(this._deliveryQueue??=new f,this._listeners=[this._listeners,x]):this._listeners.push(x):(this._options?.onWillAddFirstListener?.(this),this._listeners=x,this._options?.onDidAddFirstListener?.(this)),this._size++;const M=(0,L.toDisposable)(()=>{r?.unregister(M),F?.(),this._removeListener(x)});if(z instanceof L.DisposableStore?z.add(M):Array.isArray(z)&&z.push(M),r){const B=new Error().stack.split(`
`).slice(2).join(`
`).trim();r.register(M,B,M)}return M},this._event}_removeListener(P){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const k=this._listeners,z=k.indexOf(P);if(z===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,k[z]=void 0;const x=this._deliveryQueue.current===this;if(this._size*n<=k.length){let F=0;for(let N=0;N<k.length;N++)k[N]?k[F++]=k[N]:x&&(this._deliveryQueue.end--,F<this._deliveryQueue.i&&this._deliveryQueue.i--);k.length=F}}_deliver(P,k){if(!P)return;const z=this._options?.onListenerError||c.onUnexpectedError;if(!z){P.value(k);return}try{P.value(k)}catch(x){z(x)}}_deliverQueue(P){const k=P.current._listeners;for(;P.i<P.end;)this._deliver(k[P.i++],P.value);P.reset()}fire(P){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof o)this._deliver(this._listeners,P);else{const k=this._deliveryQueue;k.enqueue(this,P,this._listeners.length),this._deliverQueue(k)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=s;const t=()=>new f;e.createEventDeliveryQueue=t;class f{constructor(){this.i=-1,this.end=0}enqueue(P,k,z){this.i=0,this.end=z,this.current=P,this.value=k}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class h extends s{async fireAsync(P,k,z){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList),i(this._listeners,x=>this._asyncDeliveryQueue.push([x.value,P]));this._asyncDeliveryQueue.size>0&&!k.isCancellationRequested;){const[x,F]=this._asyncDeliveryQueue.shift(),N=[],M={...F,token:k,waitUntil:B=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");z&&(B=z(B,x)),N.push(B)}};try{x(M)}catch(B){(0,c.onUnexpectedError)(B);continue}Object.freeze(N),await Promise.allSettled(N).then(B=>{for(const W of B)W.status==="rejected"&&(0,c.onUnexpectedError)(W.reason)})}}}e.AsyncEmitter=h;class l extends s{get isPaused(){return this._isPaused!==0}constructor(P){super(P),this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=P?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const P=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(P))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(P){this._size&&(this._isPaused!==0?this._eventQueue.push(P):super.fire(P))}}e.PauseableEmitter=l;class u extends l{constructor(P){super(P),this._delay=P.delay??100}fire(P){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(P)}}e.DebounceEmitter=u;class d extends s{constructor(P){super(P),this._queuedEvents=[],this._mergeFn=P?.merge}fire(P){this.hasListeners()&&(this._queuedEvents.push(P),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(k=>super.fire(k)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=d;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new s({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(P){const k={event:P,listener:null};this.events.push(k),this.hasListeners&&this.hook(k);const z=()=>{this.hasListeners&&this.unhook(k);const x=this.events.indexOf(k);this.events.splice(x,1)};return(0,L.toDisposable)((0,O.createSingleCallFunction)(z))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(P=>this.hook(P))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(P=>this.unhook(P))}hook(P){P.listener=P.event(k=>this.emitter.fire(k))}unhook(P){P.listener?.dispose(),P.listener=null}dispose(){this.emitter.dispose();for(const P of this.events)P.listener?.dispose();this.events=[]}}e.EventMultiplexer=g;class D{constructor(P,k,z,x){this._store=new L.DisposableStore;const F=this._store.add(new g),N=this._store.add(new L.DisposableMap);function M(B){N.set(B,F.add(x(B)))}for(const B of P)M(B);this._store.add(k(B=>{M(B)})),this._store.add(z(B=>{N.deleteAndDispose(B)})),this.event=F.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=D;class E{constructor(){this.buffers=[]}wrapEvent(P){return(k,z,x)=>P(F=>{const N=this.buffers[this.buffers.length-1];N?N.push(()=>k.call(z,F)):k.call(z,F)},void 0,x)}bufferEvents(P){const k=[];this.buffers.push(k);const z=P();return this.buffers.pop(),k.forEach(x=>x()),z}}e.EventBufferer=E;class _{constructor(){this.listening=!1,this.inputEvent=A.None,this.inputEventListener=L.Disposable.None,this.emitter=new s({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(P){this.inputEvent=P,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=P(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=_}),define(ye[22],_e([1,0,4]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const O=Object.freeze(function(b,p){const w=setTimeout(b.bind(p),0);return{dispose(){clearTimeout(w)}}});var L;(function(b){function p(w){return w===b.None||w===b.Cancelled||w instanceof T?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}b.isCancellationToken=p,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:c.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(L||(e.CancellationToken=L={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?O:(this._emitter||(this._emitter=new c.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=L.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=R}),define(ye[168],_e([1,0,22]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class O{constructor(b){this.task=b,this.result=null}get(){if(this.result)return this.result;const b=new c.CancellationTokenSource,p=this.task(b.token);return this.result={promise:p,dispose:()=>{this.result=null,b.cancel(),b.dispose()}},this.result}}e.Cache=O;class L{constructor(b,p=JSON.stringify){this.fn=b,this._computeKey=p,this.lastCache=void 0,this.lastArgKey=void 0}get(b){const p=this._computeKey(b);return this.lastArgKey!==p&&(this.lastArgKey=p,this.lastCache=this.fn(b)),this.lastCache}}e.LRUCachedFunction=L;class T{get cachedValues(){return this._map}constructor(b){this.fn=b,this._map=new Map}get(b){if(this._map.has(b))return this._map.get(b);const p=this.fn(b);return this._map.set(b,p),p}}e.CachedFunction=T}),define(ye[98],_e([1,0,13,3]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=L,e.isReadableStream=T,e.isReadableBufferedStream=R,e.newWriteableStream=b,e.consumeReadable=w,e.peekReadable=A,e.consumeStream=I,e.listenStream=v,e.peekStream=C,e.toStream=S,e.emptyStream=a,e.toReadable=m,e.transform=o,e.prefixedReadable=n,e.prefixedStream=i;function L(r){const s=r;return s?typeof s.read=="function":!1}function T(r){const s=r;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}function R(r){const s=r;return s?T(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function b(r,s){return new p(r,s)}class p{constructor(s,t){this.reducer=s,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s<"u"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(t=>t(s))}emitError(s){this.listeners.error.length===0?(0,c.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(t=>t(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,t){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(s,t){if(this.state.destroyed)return;let f;switch(s){case"data":f=this.listeners.data;break;case"end":f=this.listeners.end;break;case"error":f=this.listeners.error;break}if(f){const h=f.indexOf(t);h>=0&&f.splice(h,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(f=>f())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(r,s){const t=[];let f;for(;(f=r.read())!==null;)t.push(f);return s(t)}function A(r,s,t){const f=[];let h;for(;(h=r.read())!==null&&f.length<t;)f.push(h);return h===null&&f.length>0?s(f):{read:()=>{if(f.length>0)return f.shift();if(typeof h<"u"){const l=h;return h=void 0,l}return r.read()}}}function I(r,s){return new Promise((t,f)=>{const h=[];v(r,{onData:l=>{s&&h.push(l)},onError:l=>{s?f(l):t(void 0)},onEnd:()=>{t(s?s(h):void 0)}})})}function v(r,s,t){r.on("error",f=>{t?.isCancellationRequested||s.onError(f)}),r.on("end",()=>{t?.isCancellationRequested||s.onEnd()}),r.on("data",f=>{t?.isCancellationRequested||s.onData(f)})}function C(r,s){return new Promise((t,f)=>{const h=new O.DisposableStore,l=[],u=D=>{if(l.push(D),l.length>s)return h.dispose(),r.pause(),t({stream:r,buffer:l,ended:!1})},d=D=>(h.dispose(),f(D)),g=()=>(h.dispose(),t({stream:r,buffer:l,ended:!0}));h.add((0,O.toDisposable)(()=>r.removeListener("error",d))),r.on("error",d),h.add((0,O.toDisposable)(()=>r.removeListener("end",g))),r.on("end",g),h.add((0,O.toDisposable)(()=>r.removeListener("data",u))),r.on("data",u)})}function S(r,s){const t=b(s);return t.end(r),t}function a(){const r=b(()=>{throw new Error("not supported")});return r.end(),r}function m(r){let s=!1;return{read:()=>s?null:(s=!0,r)}}function o(r,s,t){const f=b(t);return v(r,{onData:h=>f.write(s.data(h)),onError:h=>f.error(s.error?s.error(h):h),onEnd:()=>f.end()}),f}function n(r,s,t){let f=!1;return{read:()=>{const h=s.read();return f?h:(f=!0,h!==null?t([r,h]):r)}}}function i(r,s,t){let f=!1;const h=b(t);return v(s,{onData:l=>f?h.write(l):(f=!0,h.write(t([r,l]))),onError:l=>h.error(l),onEnd:()=>{f||(f=!0,h.write(r)),h.end()}}),h}}),define(ye[21],_e([1,0,46,98]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=w,e.readUInt16LE=A,e.writeUInt16LE=I,e.readUInt32BE=v,e.writeUInt32BE=C,e.readUInt32LE=S,e.writeUInt32LE=a,e.readUInt8=m,e.writeUInt8=o,e.readableToBuffer=n,e.bufferToReadable=i,e.streamToBuffer=r,e.bufferedStreamToBuffer=s,e.bufferToStream=t,e.streamToBufferReadableStream=f,e.newWriteableBufferStream=h,e.prefixedBufferReadable=l,e.prefixedBufferStream=u,e.decodeBase64=d,e.encodeBase64=E;const L=typeof Buffer<"u",T=new c.Lazy(()=>new Uint8Array(256));let R,b;class p{static alloc(y){return L?new p(Buffer.allocUnsafe(y)):new p(new Uint8Array(y))}static wrap(y){return L&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new p(y)}static fromString(y,P){return!(P?.dontUseNodeBuffer||!1)&&L?new p(Buffer.from(y)):(R||(R=new TextEncoder),new p(R.encode(y)))}static fromByteArray(y){const P=p.alloc(y.length);for(let k=0,z=y.length;k<z;k++)P.buffer[k]=y[k];return P}static concat(y,P){if(typeof P>"u"){P=0;for(let x=0,F=y.length;x<F;x++)P+=y[x].byteLength}const k=p.alloc(P);let z=0;for(let x=0,F=y.length;x<F;x++){const N=y[x];k.set(N,z),z+=N.byteLength}return k}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=p.alloc(this.byteLength);return y.set(this),y}toString(){return L?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(y,P){return new p(this.buffer.subarray(y,P))}set(y,P){if(y instanceof p)this.buffer.set(y.buffer,P);else if(y instanceof Uint8Array)this.buffer.set(y,P);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),P);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return v(this.buffer,y)}writeUInt32BE(y,P){C(this.buffer,y,P)}readUInt32LE(y){return S(this.buffer,y)}writeUInt32LE(y,P){a(this.buffer,y,P)}readUInt8(y){return m(this.buffer,y)}writeUInt8(y,P){o(this.buffer,y,P)}indexOf(y,P=0){return w(this.buffer,y instanceof p?y.buffer:y,P)}}e.VSBuffer=p;function w(_,y,P=0){const k=y.byteLength,z=_.byteLength;if(k===0)return 0;if(k===1)return _.indexOf(y[0]);if(k>z-P)return-1;const x=T.value;x.fill(y.length);for(let B=0;B<y.length;B++)x[y[B]]=y.length-B-1;let F=P+y.length-1,N=F,M=-1;for(;F<z;)if(_[F]===y[N]){if(N===0){M=F;break}F--,N--}else F+=Math.max(y.length-N,x[_[F]]),N=y.length-1;return M}function A(_,y){return _[y+0]<<0>>>0|_[y+1]<<8>>>0}function I(_,y,P){_[P+0]=y&255,y=y>>>8,_[P+1]=y&255}function v(_,y){return _[y]*2**24+_[y+1]*2**16+_[y+2]*2**8+_[y+3]}function C(_,y,P){_[P+3]=y,y=y>>>8,_[P+2]=y,y=y>>>8,_[P+1]=y,y=y>>>8,_[P]=y}function S(_,y){return _[y+0]<<0>>>0|_[y+1]<<8>>>0|_[y+2]<<16>>>0|_[y+3]<<24>>>0}function a(_,y,P){_[P+0]=y&255,y=y>>>8,_[P+1]=y&255,y=y>>>8,_[P+2]=y&255,y=y>>>8,_[P+3]=y&255}function m(_,y){return _[y]}function o(_,y,P){_[P]=y}function n(_){return O.consumeReadable(_,y=>p.concat(y))}function i(_){return O.toReadable(_)}function r(_){return O.consumeStream(_,y=>p.concat(y))}async function s(_){return _.ended?p.concat(_.buffer):p.concat([..._.buffer,await r(_.stream)])}function t(_){return O.toStream(_,y=>p.concat(y))}function f(_){return O.transform(_,{data:y=>typeof y=="string"?p.fromString(y):p.wrap(y)},y=>p.concat(y))}function h(_){return O.newWriteableStream(y=>p.concat(y),_)}function l(_,y){return O.prefixedReadable(_,y,P=>p.concat(P))}function u(_,y){return O.prefixedStream(_,y,P=>p.concat(P))}function d(_){let y=0,P=0,k=0;const z=new Uint8Array(Math.floor(_.length/4*3)),x=N=>{switch(P){case 3:z[k++]=y|N,P=0;break;case 2:z[k++]=y|N>>>2,y=N<<6,P=3;break;case 1:z[k++]=y|N>>>4,y=N<<4,P=2;break;default:y=N<<2,P=1}};for(let N=0;N<_.length;N++){const M=_.charCodeAt(N);if(M>=65&&M<=90)x(M-65);else if(M>=97&&M<=122)x(M-97+26);else if(M>=48&&M<=57)x(M-48+52);else if(M===43||M===45)x(62);else if(M===47||M===95)x(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${_[N]}`)}}const F=k;for(;P>0;)x(0);return p.wrap(z).slice(0,F)}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function E({buffer:_},y=!0,P=!1){const k=P?D:g;let z="";const x=_.byteLength%3;let F=0;for(;F<_.byteLength-x;F+=3){const N=_[F+0],M=_[F+1],B=_[F+2];z+=k[N>>>2],z+=k[(N<<4|M>>>4)&63],z+=k[(M<<2|B>>>6)&63],z+=k[B&63]}if(x===1){const N=_[F+0];z+=k[N>>>2],z+=k[N<<4&63],y&&(z+="==")}else if(x===2){const N=_[F+0],M=_[F+1];z+=k[N>>>2],z+=k[(N<<4|M>>>4)&63],z+=k[M<<2&63],y&&(z+="=")}return z}}),define(ye[14],_e([1,0,168,46]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=L,e.format=R,e.format2=p,e.htmlAttributeEncodeValue=w,e.escape=A,e.escapeRegExpCharacters=I,e.count=v,e.truncate=C,e.truncateMiddle=S,e.trim=a,e.ltrim=m,e.rtrim=o,e.convertSimple2RegExpPattern=n,e.stripWildcards=i,e.createRegExp=r,e.regExpLeadsToEndlessLoop=s,e.splitLines=t,e.splitLinesIncludeSeparators=f,e.firstNonWhitespaceIndex=h,e.getLeadingWhitespace=l,e.lastNonWhitespaceIndex=u,e.replaceAsync=d,e.compare=g,e.compareSubstring=D,e.compareIgnoreCase=E,e.compareSubstringIgnoreCase=_,e.isAsciiDigit=y,e.isLowerAsciiLetter=P,e.isUpperAsciiLetter=k,e.equalsIgnoreCase=z,e.startsWithIgnoreCase=x,e.commonPrefixLength=F,e.commonSuffixLength=N,e.isHighSurrogate=M,e.isLowSurrogate=B,e.computeCodePoint=W,e.getNextCodePoint=Y,e.nextCharLength=re,e.prevCharLength=te,e.getCharContainingOffset=ve,e.charCount=Ie,e.containsRTL=ne,e.isBasicASCII=Ce,e.containsUnusualLineTerminators=ae,e.isFullWidthCharacter=ce,e.isEmojiImprecise=se,e.lcut=j,e.forAnsiStringParts=ue,e.removeAnsiEscapeCodes=he,e.startsWithUTF8BOM=Te,e.stripUTF8BOM=me,e.fuzzyContains=Pe,e.containsUppercaseCharacter=Ae,e.uppercaseFirstLetter=xe,e.getNLines=H,e.singleLetterHash=U,e.getGraphemeBreakType=X,e.getLeftDeleteOffset=He;function L(De){return!De||typeof De!="string"?!0:De.trim().length===0}const T=/{(\d+)}/g;function R(De,...Be){return Be.length===0?De:De.replace(T,function(qe,Le){const Qe=parseInt(Le,10);return isNaN(Qe)||Qe<0||Qe>=Be.length?qe:Be[Qe]})}const b=/{([^}]+)}/g;function p(De,Be){return Object.keys(Be).length===0?De:De.replace(b,(qe,Le)=>Be[Le]??qe)}function w(De){return De.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function A(De){return De.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function I(De){return De.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function v(De,Be){let qe=0;const Le=Be.charCodeAt(0);for(let Qe=De.length-1;Qe>=0;Qe--)De.charCodeAt(Qe)===Le&&qe++;return qe}function C(De,Be,qe="\u2026"){return De.length<=Be?De:`${De.substr(0,Be)}${qe}`}function S(De,Be,qe="\u2026"){if(De.length<=Be)return De;const Le=Math.ceil(Be/2)-qe.length/2,Qe=Math.floor(Be/2)-qe.length/2;return`${De.substr(0,Le)}${qe}${De.substr(De.length-Qe)}`}function a(De,Be=" "){const qe=m(De,Be);return o(qe,Be)}function m(De,Be){if(!De||!Be)return De;const qe=Be.length;if(qe===0||De.length===0)return De;let Le=0;for(;De.indexOf(Be,Le)===Le;)Le=Le+qe;return De.substring(Le)}function o(De,Be){if(!De||!Be)return De;const qe=Be.length,Le=De.length;if(qe===0||Le===0)return De;let Qe=Le,oe=-1;for(;oe=De.lastIndexOf(Be,Qe-1),!(oe===-1||oe+qe!==Qe);){if(oe===0)return"";Qe=oe}return De.substring(0,Qe)}function n(De){return De.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(De){return De.replace(/\*/g,"")}function r(De,Be,qe={}){if(!De)throw new Error("Cannot create regex from empty string");Be||(De=I(De)),qe.wholeWord&&(/\B/.test(De.charAt(0))||(De="\\b"+De),/\B/.test(De.charAt(De.length-1))||(De=De+"\\b"));let Le="";return qe.global&&(Le+="g"),qe.matchCase||(Le+="i"),qe.multiline&&(Le+="m"),qe.unicode&&(Le+="u"),new RegExp(De,Le)}function s(De){return De.source==="^"||De.source==="^$"||De.source==="$"||De.source==="^\\s*$"?!1:!!(De.exec("")&&De.lastIndex===0)}function t(De){return De.split(/\r\n|\r|\n/)}function f(De){const Be=[],qe=De.split(/(\r\n|\r|\n)/);for(let Le=0;Le<Math.ceil(qe.length/2);Le++)Be.push(qe[2*Le]+(qe[2*Le+1]??""));return Be}function h(De){for(let Be=0,qe=De.length;Be<qe;Be++){const Le=De.charCodeAt(Be);if(Le!==32&&Le!==9)return Be}return-1}function l(De,Be=0,qe=De.length){for(let Le=Be;Le<qe;Le++){const Qe=De.charCodeAt(Le);if(Qe!==32&&Qe!==9)return De.substring(Be,Le)}return De.substring(Be,qe)}function u(De,Be=De.length-1){for(let qe=Be;qe>=0;qe--){const Le=De.charCodeAt(qe);if(Le!==32&&Le!==9)return qe}return-1}function d(De,Be,qe){const Le=[];let Qe=0;for(const oe of De.matchAll(Be)){if(Le.push(De.slice(Qe,oe.index)),oe.index===void 0)throw new Error("match.index should be defined");Qe=oe.index+oe[0].length,Le.push(qe(oe[0],...oe.slice(1),oe.index,De,oe.groups))}return Le.push(De.slice(Qe)),Promise.all(Le).then(oe=>oe.join(""))}function g(De,Be){return De<Be?-1:De>Be?1:0}function D(De,Be,qe=0,Le=De.length,Qe=0,oe=Be.length){for(;qe<Le&&Qe<oe;qe++,Qe++){const je=De.charCodeAt(qe),Ze=Be.charCodeAt(Qe);if(je<Ze)return-1;if(je>Ze)return 1}const le=Le-qe,ke=oe-Qe;return le<ke?-1:le>ke?1:0}function E(De,Be){return _(De,Be,0,De.length,0,Be.length)}function _(De,Be,qe=0,Le=De.length,Qe=0,oe=Be.length){for(;qe<Le&&Qe<oe;qe++,Qe++){let je=De.charCodeAt(qe),Ze=Be.charCodeAt(Qe);if(je===Ze)continue;if(je>=128||Ze>=128)return D(De.toLowerCase(),Be.toLowerCase(),qe,Le,Qe,oe);P(je)&&(je-=32),P(Ze)&&(Ze-=32);const Me=je-Ze;if(Me!==0)return Me}const le=Le-qe,ke=oe-Qe;return le<ke?-1:le>ke?1:0}function y(De){return De>=48&&De<=57}function P(De){return De>=97&&De<=122}function k(De){return De>=65&&De<=90}function z(De,Be){return De.length===Be.length&&_(De,Be)===0}function x(De,Be){const qe=Be.length;return Be.length>De.length?!1:_(De,Be,0,qe)===0}function F(De,Be){const qe=Math.min(De.length,Be.length);let Le;for(Le=0;Le<qe;Le++)if(De.charCodeAt(Le)!==Be.charCodeAt(Le))return Le;return qe}function N(De,Be){const qe=Math.min(De.length,Be.length);let Le;const Qe=De.length-1,oe=Be.length-1;for(Le=0;Le<qe;Le++)if(De.charCodeAt(Qe-Le)!==Be.charCodeAt(oe-Le))return Le;return qe}function M(De){return 55296<=De&&De<=56319}function B(De){return 56320<=De&&De<=57343}function W(De,Be){return(De-55296<<10)+(Be-56320)+65536}function Y(De,Be,qe){const Le=De.charCodeAt(qe);if(M(Le)&&qe+1<Be){const Qe=De.charCodeAt(qe+1);if(B(Qe))return W(Le,Qe)}return Le}function Z(De,Be){const qe=De.charCodeAt(Be-1);if(B(qe)&&Be>1){const Le=De.charCodeAt(Be-2);if(M(Le))return W(Le,qe)}return qe}class G{get offset(){return this._offset}constructor(Be,qe=0){this._str=Be,this._len=Be.length,this._offset=qe}setOffset(Be){this._offset=Be}prevCodePoint(){const Be=Z(this._str,this._offset);return this._offset-=Be>=65536?2:1,Be}nextCodePoint(){const Be=Y(this._str,this._len,this._offset);return this._offset+=Be>=65536?2:1,Be}eol(){return this._offset>=this._len}}e.CodePointIterator=G;class Q{get offset(){return this._iterator.offset}constructor(Be,qe=0){this._iterator=new G(Be,qe)}nextGraphemeLength(){const Be=Ee.getInstance(),qe=this._iterator,Le=qe.offset;let Qe=Be.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const oe=qe.offset,le=Be.getGraphemeBreakType(qe.nextCodePoint());if(K(Qe,le)){qe.setOffset(oe);break}Qe=le}return qe.offset-Le}prevGraphemeLength(){const Be=Ee.getInstance(),qe=this._iterator,Le=qe.offset;let Qe=Be.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const oe=qe.offset,le=Be.getGraphemeBreakType(qe.prevCodePoint());if(K(le,Qe)){qe.setOffset(oe);break}Qe=le}return Le-qe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Q;function re(De,Be){return new Q(De,Be).nextGraphemeLength()}function te(De,Be){return new Q(De,Be).prevGraphemeLength()}function ve(De,Be){Be>0&&B(De.charCodeAt(Be))&&Be--;const qe=Be+re(De,Be);return[qe-te(De,qe),qe]}function Ie(De){const Be=new Q(De);let qe=0;for(;!Be.eol();)qe++,Be.nextGraphemeLength();return qe}let J;function $(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ne(De){return J||(J=$()),J.test(De)}const be=/^[\t\n\r\x20-\x7E]*$/;function Ce(De){return be.test(De)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ae(De){return e.UNUSUAL_LINE_TERMINATORS.test(De)}function ce(De){return De>=11904&&De<=55215||De>=63744&&De<=64255||De>=65281&&De<=65374}function se(De){return De>=127462&&De<=127487||De===8986||De===8987||De===9200||De===9203||De>=9728&&De<=10175||De===11088||De===11093||De>=127744&&De<=128591||De>=128640&&De<=128764||De>=128992&&De<=129008||De>=129280&&De<=129535||De>=129648&&De<=129782}function j(De,Be,qe=""){const Le=De.trimStart();if(Le.length<Be)return Le;const Qe=/\b/g;let oe=0;for(;Qe.test(Le)&&!(Le.length-Qe.lastIndex<Be);)oe=Qe.lastIndex,Qe.lastIndex+=1;return oe===0?Le:qe+Le.substring(oe).trimStart()}const ie=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ue(De){let Be=0;for(const qe of De.matchAll(ie))Be!==qe.index&&(yield{isCode:!1,str:De.substring(Be,qe.index)}),yield{isCode:!0,str:qe[0]},Be=qe.index+qe[0].length;Be!==De.length&&(yield{isCode:!1,str:De.substring(Be)})}function he(De){return De&&(De=De.replace(ie,"")),De}e.UTF8_BOM_CHARACTER="\uFEFF";function Te(De){return!!(De&&De.length>0&&De.charCodeAt(0)===65279)}function me(De){return Te(De)?De.substr(1):De}function Pe(De,Be){if(!De||!Be||De.length<Be.length)return!1;const qe=Be.length,Le=De.toLowerCase();let Qe=0,oe=-1;for(;Qe<qe;){const le=Le.indexOf(Be[Qe],oe+1);if(le<0)return!1;oe=le,Qe++}return!0}function Ae(De,Be=!1){return De?(Be&&(De=De.replace(/\\./g,"")),De.toLowerCase()!==De):!1}function xe(De){return De.charAt(0).toUpperCase()+De.slice(1)}function H(De,Be=1){if(Be===0)return"";let qe=-1;do qe=De.indexOf(`
`,qe+1),Be--;while(Be>0&&qe>=0);return qe===-1?De:(De[qe-1]==="\r"&&qe--,De.substr(0,qe))}function U(De){return De=De%(2*26),De<26?String.fromCharCode(97+De):String.fromCharCode(65+De-26)}function X(De){return Ee.getInstance().getGraphemeBreakType(De)}function K(De,Be){return De===0?Be!==5&&Be!==7:De===2&&Be===3?!1:De===4||De===2||De===3||Be===4||Be===2||Be===3?!0:!(De===8&&(Be===8||Be===9||Be===11||Be===12)||(De===11||De===9)&&(Be===9||Be===10)||(De===12||De===10)&&Be===10||Be===5||Be===13||Be===7||De===1||De===13&&Be===14||De===6&&Be===6)}var ge;(function(De){De[De.Other=0]="Other",De[De.Prepend=1]="Prepend",De[De.CR=2]="CR",De[De.LF=3]="LF",De[De.Control=4]="Control",De[De.Extend=5]="Extend",De[De.Regional_Indicator=6]="Regional_Indicator",De[De.SpacingMark=7]="SpacingMark",De[De.L=8]="L",De[De.V=9]="V",De[De.T=10]="T",De[De.LV=11]="LV",De[De.LVT=12]="LVT",De[De.ZWJ=13]="ZWJ",De[De.Extended_Pictographic=14]="Extended_Pictographic"})(ge||(e.GraphemeBreakType=ge={}));class Ee{static{this._INSTANCE=null}static getInstance(){return Ee._INSTANCE||(Ee._INSTANCE=new Ee),Ee._INSTANCE}constructor(){this._data=ze()}getGraphemeBreakType(Be){if(Be<32)return Be===10?3:Be===13?2:4;if(Be<127)return 0;const qe=this._data,Le=qe.length/3;let Qe=1;for(;Qe<=Le;)if(Be<qe[3*Qe])Qe=2*Qe;else if(Be>qe[3*Qe+1])Qe=2*Qe+1;else return qe[3*Qe+2];return 0}}function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(De,Be){if(De===0)return 0;const qe=Ye(De,Be);if(qe!==void 0)return qe;const Le=new G(Be,De);return Le.prevCodePoint(),Le.offset}function Ye(De,Be){const qe=new G(Be,De);let Le=qe.prevCodePoint();for(;it(Le)||Le===65039||Le===8419;){if(qe.offset===0)return;Le=qe.prevCodePoint()}if(!se(Le))return;let Qe=qe.offset;return Qe>0&&qe.prevCodePoint()===8205&&(Qe=qe.offset),Qe}function it(De){return 127995<=De&&De<=127999}var rt;(function(De){De[De.zwj=8205]="zwj",De[De.emojiVariantSelector=65039]="emojiVariantSelector",De[De.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),e.noBreakWhitespace="\xA0";class at{static{this.ambiguousCharacterData=new O.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new c.LRUCachedFunction(Be=>{function qe(Me){const lt=new Map;for(let bt=0;bt<Me.length;bt+=2)lt.set(Me[bt],Me[bt+1]);return lt}function Le(Me,lt){const bt=new Map(Me);for(const[Tt,Nt]of lt)bt.set(Tt,Nt);return bt}function Qe(Me,lt){if(!Me)return lt;const bt=new Map;for(const[Tt,Nt]of Me)lt.has(Tt)&&bt.set(Tt,Nt);return bt}const oe=this.ambiguousCharacterData.value;let le=Be.filter(Me=>!Me.startsWith("_")&&Me in oe);le.length===0&&(le=["_default"]);let ke;for(const Me of le){const lt=qe(oe[Me]);ke=Qe(ke,lt)}const je=qe(oe._common),Ze=Le(je,ke);return new at(Ze)})}static getInstance(Be){return at.cache.get(Array.from(Be))}static{this._locales=new O.Lazy(()=>Object.keys(at.ambiguousCharacterData.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return at._locales.value}constructor(Be){this.confusableDictionary=Be}isAmbiguous(Be){return this.confusableDictionary.has(Be)}getPrimaryConfusable(Be){return this.confusableDictionary.get(Be)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=at;class st{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(st.getRawData())),this._data}static isInvisibleCharacter(Be){return st.getData().has(Be)}static get codePoints(){return st.getData()}}e.InvisibleCharacters=st}),define(ye[126],_e([1,0,27,166,14]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FuzzyScoreOptions=e.FuzzyScore=e.matchesPrefix=e.matchesStrictPrefix=void 0,e.or=T,e.matchesContiguousSubString=b,e.matchesSubString=p,e.isUpper=I,e.matchesCamelCase=d,e.matchesWords=g,e.matchesFuzzy=k,e.matchesFuzzy2=z,e.anyScore=x,e.createMatches=F,e.isPatternInWord=ne,e.fuzzyScore=ce,e.fuzzyScoreGracefulAggressive=ie,e.fuzzyScoreGraceful=ue;function T(...me){return function(Pe,Ae){for(let xe=0,H=me.length;xe<H;xe++){const U=me[xe](Pe,Ae);if(U)return U}return null}}e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(me,Pe,Ae){if(!Ae||Ae.length<Pe.length)return null;let xe;return me?xe=L.startsWithIgnoreCase(Ae,Pe):xe=Ae.indexOf(Pe)===0,xe?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function b(me,Pe){const Ae=Pe.toLowerCase().indexOf(me.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+me.length}]}function p(me,Pe){return w(me.toLowerCase(),Pe.toLowerCase(),0,0)}function w(me,Pe,Ae,xe){if(Ae===me.length)return[];if(xe===Pe.length)return null;if(me[Ae]===Pe[xe]){let H=null;return(H=w(me,Pe,Ae+1,xe+1))?r({start:xe,end:xe+1},H):null}return w(me,Pe,Ae,xe+1)}function A(me){return 97<=me&&me<=122}function I(me){return 65<=me&&me<=90}function v(me){return 48<=me&&me<=57}function C(me){return me===32||me===9||me===10||me===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(me=>S.add(me.charCodeAt(0)));function a(me){return C(me)||S.has(me)}function m(me,Pe){return me===Pe||a(me)&&a(Pe)}const o=new Map;function n(me){if(o.has(me))return o.get(me);let Pe;const Ae=(0,O.getKoreanAltChars)(me);return Ae&&(Pe=Ae),o.set(me,Pe),Pe}function i(me){return A(me)||I(me)||v(me)}function r(me,Pe){return Pe.length===0?Pe=[me]:me.end===Pe[0].start?Pe[0].start=me.start:Pe.unshift(me),Pe}function s(me,Pe){for(let Ae=Pe;Ae<me.length;Ae++){const xe=me.charCodeAt(Ae);if(I(xe)||v(xe)||Ae>0&&!i(me.charCodeAt(Ae-1)))return Ae}return me.length}function t(me,Pe,Ae,xe){if(Ae===me.length)return[];if(xe===Pe.length)return null;if(me[Ae]!==Pe[xe].toLowerCase())return null;{let H=null,U=xe+1;for(H=t(me,Pe,Ae+1,xe+1);!H&&(U=s(Pe,U))<Pe.length;)H=t(me,Pe,Ae+1,U),U++;return H===null?null:r({start:xe,end:xe+1},H)}}function f(me){let Pe=0,Ae=0,xe=0,H=0,U=0;for(let ze=0;ze<me.length;ze++)U=me.charCodeAt(ze),I(U)&&Pe++,A(U)&&Ae++,i(U)&&xe++,v(U)&&H++;const X=Pe/me.length,K=Ae/me.length,ge=xe/me.length,Ee=H/me.length;return{upperPercent:X,lowerPercent:K,alphaPercent:ge,numericPercent:Ee}}function h(me){const{upperPercent:Pe,lowerPercent:Ae}=me;return Ae===0&&Pe>.6}function l(me){const{upperPercent:Pe,lowerPercent:Ae,alphaPercent:xe,numericPercent:H}=me;return Ae>.2&&Pe<.8&&xe>.6&&H<.2}function u(me){let Pe=0,Ae=0,xe=0,H=0;for(let U=0;U<me.length;U++)xe=me.charCodeAt(U),I(xe)&&Pe++,A(xe)&&Ae++,C(xe)&&H++;return(Pe===0||Ae===0)&&H===0?me.length<=30:Pe<=5}function d(me,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!u(me))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Ae=f(Pe);if(!l(Ae)){if(!h(Ae))return null;Pe=Pe.toLowerCase()}let xe=null,H=0;for(me=me.toLowerCase();H<Pe.length&&(xe=t(me,Pe,0,H))===null;)H=s(Pe,H+1);return xe}function g(me,Pe,Ae=!1){if(!Pe||Pe.length===0)return null;let xe=null,H=0;for(me=me.toLowerCase(),Pe=Pe.toLowerCase();H<Pe.length&&(xe=D(me,Pe,0,H,Ae),xe===null);)H=E(Pe,H+1);return xe}function D(me,Pe,Ae,xe,H){let U=0;if(Ae===me.length)return[];if(xe===Pe.length)return null;if(!m(me.charCodeAt(Ae),Pe.charCodeAt(xe))){const ge=n(me.charCodeAt(Ae));if(!ge)return null;for(let Ee=0;Ee<ge.length;Ee++)if(!m(ge[Ee],Pe.charCodeAt(xe+Ee)))return null;U+=ge.length-1}let X=null,K=xe+U+1;if(X=D(me,Pe,Ae+1,K,H),!H)for(;!X&&(K=E(Pe,K))<Pe.length;)X=D(me,Pe,Ae+1,K,H),K++;if(!X)return null;if(me.charCodeAt(Ae)!==Pe.charCodeAt(xe)){const ge=n(me.charCodeAt(Ae));if(!ge)return X;for(let Ee=0;Ee<ge.length;Ee++)if(ge[Ee]!==Pe.charCodeAt(xe+Ee))return X}return r({start:xe,end:xe+U+1},X)}function E(me,Pe){for(let Ae=Pe;Ae<me.length;Ae++)if(a(me.charCodeAt(Ae))||Ae>0&&a(me.charCodeAt(Ae-1)))return Ae;return me.length}const _=T(e.matchesPrefix,d,b),y=T(e.matchesPrefix,d,p),P=new c.LRUCache(1e4);function k(me,Pe,Ae=!1){if(typeof me!="string"||typeof Pe!="string")return null;let xe=P.get(me);xe||(xe=new RegExp(L.convertSimple2RegExpPattern(me),"i"),P.set(me,xe));const H=xe.exec(Pe);return H?[{start:H.index,end:H.index+H[0].length}]:Ae?y(me,Pe):_(me,Pe)}function z(me,Pe){const Ae=ce(me,me.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?F(Ae):null}function x(me,Pe,Ae,xe,H,U){const X=Math.min(13,me.length);for(;Ae<X;Ae++){const K=ce(me,Pe,Ae,xe,H,U,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(K)return K}return[0,U]}function F(me){if(typeof me>"u")return[];const Pe=[],Ae=me[1];for(let xe=me.length-1;xe>1;xe--){const H=me[xe]+Ae,U=Pe[Pe.length-1];U&&U.end===H?U.end=H+1:Pe.push({start:H,end:H+1})}return Pe}const N=128;function M(){const me=[],Pe=[];for(let Ae=0;Ae<=N;Ae++)Pe[Ae]=0;for(let Ae=0;Ae<=N;Ae++)me.push(Pe.slice(0));return me}function B(me){const Pe=[];for(let Ae=0;Ae<=me;Ae++)Pe[Ae]=0;return Pe}const W=B(2*N),Y=B(2*N),Z=M(),G=M(),Q=M(),re=!1;function te(me,Pe,Ae,xe,H){function U(K,ge,Ee=" "){for(;K.length<ge;)K=Ee+K;return K}let X=` |   |${xe.split("").map(K=>U(K,3)).join("|")}
`;for(let K=0;K<=Ae;K++)K===0?X+=" |":X+=`${Pe[K-1]}|`,X+=me[K].slice(0,H+1).map(ge=>U(ge.toString(),3)).join("|")+`
`;return X}function ve(me,Pe,Ae,xe){me=me.substr(Pe),Ae=Ae.substr(xe),console.log(te(G,me,me.length,Ae,Ae.length)),console.log(te(Q,me,me.length,Ae,Ae.length)),console.log(te(Z,me,me.length,Ae,Ae.length))}function Ie(me,Pe){if(Pe<0||Pe>=me.length)return!1;const Ae=me.codePointAt(Pe);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(Ae)}}function J(me,Pe){if(Pe<0||Pe>=me.length)return!1;switch(me.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function $(me,Pe,Ae){return Pe[me]!==Ae[me]}function ne(me,Pe,Ae,xe,H,U,X=!1){for(;Pe<Ae&&H<U;)me[Pe]===xe[H]&&(X&&(W[Pe]=H),Pe+=1),H+=1;return Pe===Ae}var be;(function(me){me[me.Diag=1]="Diag",me[me.Left=2]="Left",me[me.LeftLeft=3]="LeftLeft"})(be||(be={}));var Ce;(function(me){me.Default=[-100,0];function Pe(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}me.isDefault=Pe})(Ce||(e.FuzzyScore=Ce={}));class ae{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Ae){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Ae}}e.FuzzyScoreOptions=ae;function ce(me,Pe,Ae,xe,H,U,X=ae.default){const K=me.length>N?N:me.length,ge=xe.length>N?N:xe.length;if(Ae>=K||U>=ge||K-Ae>ge-U||!ne(Pe,Ae,K,H,U,ge,!0))return;se(K,ge,Ae,U,Pe,H);let Ee=1,ze=1,He=Ae,Ye=U;const it=[!1];for(Ee=1,He=Ae;He<K;Ee++,He++){const Be=W[He],qe=Y[He],Le=He+1<K?Y[He+1]:ge;for(ze=Be-U+1,Ye=Be;Ye<Le;ze++,Ye++){let Qe=Number.MIN_SAFE_INTEGER,oe=!1;Ye<=qe&&(Qe=j(me,Pe,He,Ae,xe,H,Ye,ge,U,Z[Ee-1][ze-1]===0,it));let le=0;Qe!==Number.MAX_SAFE_INTEGER&&(oe=!0,le=Qe+G[Ee-1][ze-1]);const ke=Ye>Be,je=ke?G[Ee][ze-1]+(Z[Ee][ze-1]>0?-5:0):0,Ze=Ye>Be+1&&Z[Ee][ze-1]>0,Me=Ze?G[Ee][ze-2]+(Z[Ee][ze-2]>0?-5:0):0;if(Ze&&(!ke||Me>=je)&&(!oe||Me>=le))G[Ee][ze]=Me,Q[Ee][ze]=3,Z[Ee][ze]=0;else if(ke&&(!oe||je>=le))G[Ee][ze]=je,Q[Ee][ze]=2,Z[Ee][ze]=0;else if(oe)G[Ee][ze]=le,Q[Ee][ze]=1,Z[Ee][ze]=Z[Ee-1][ze-1]+1;else throw new Error("not possible")}}if(re&&ve(me,Ae,xe,U),!it[0]&&!X.firstMatchCanBeWeak)return;Ee--,ze--;const rt=[G[Ee][ze],U];let at=0,st=0;for(;Ee>=1;){let Be=ze;do{const qe=Q[Ee][Be];if(qe===3)Be=Be-2;else if(qe===2)Be=Be-1;else break}while(Be>=1);at>1&&Pe[Ae+Ee-1]===H[U+ze-1]&&!$(Be+U-1,xe,H)&&at+1>Z[Ee][Be]&&(Be=ze),Be===ze?at++:at=1,st||(st=Be),Ee--,ze=Be-1,rt.push(ze)}ge===K&&X.boostFullMatch&&(rt[0]+=2);const De=st-K;return rt[0]-=De,rt}function se(me,Pe,Ae,xe,H,U){let X=me-1,K=Pe-1;for(;X>=Ae&&K>=xe;)H[X]===U[K]&&(Y[X]=K,X--),K--}function j(me,Pe,Ae,xe,H,U,X,K,ge,Ee,ze){if(Pe[Ae]!==U[X])return Number.MIN_SAFE_INTEGER;let He=1,Ye=!1;return X===Ae-xe?He=me[Ae]===H[X]?7:5:$(X,H,U)&&(X===0||!$(X-1,H,U))?(He=me[Ae]===H[X]?7:5,Ye=!0):Ie(U,X)&&(X===0||!Ie(U,X-1))?He=5:(Ie(U,X-1)||J(U,X-1))&&(He=5,Ye=!0),He>1&&Ae===xe&&(ze[0]=!0),Ye||(Ye=$(X,H,U)||Ie(U,X-1)||J(U,X-1)),Ae===xe?X>ge&&(He-=Ye?3:5):Ee?He+=Ye?2:0:He+=Ye?0:1,X+1===K&&(He-=Ye?3:5),He}function ie(me,Pe,Ae,xe,H,U,X){return he(me,Pe,Ae,xe,H,U,!0,X)}function ue(me,Pe,Ae,xe,H,U,X){return he(me,Pe,Ae,xe,H,U,!1,X)}function he(me,Pe,Ae,xe,H,U,X,K){let ge=ce(me,Pe,Ae,xe,H,U,K);if(ge&&!X)return ge;if(me.length>=3){const Ee=Math.min(7,me.length-1);for(let ze=Ae+1;ze<Ee;ze++){const He=Te(me,ze);if(He){const Ye=ce(He,He.toLowerCase(),Ae,xe,H,U,K);Ye&&(Ye[0]-=3,(!ge||Ye[0]>ge[0])&&(ge=Ye))}}}return ge}function Te(me,Pe){if(Pe+1>=me.length)return;const Ae=me[Pe],xe=me[Pe+1];if(Ae!==xe)return me.slice(0,Pe)+xe+Ae+me.slice(Pe+2)}}),define(ye[55],_e([1,0,14]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=O,e.doHash=L,e.numberHash=T,e.stringHash=b,e.toHexString=a;function O(o){return L(o,0)}function L(o,n){switch(typeof o){case"object":return o===null?T(349,n):Array.isArray(o)?p(o,n):w(o,n);case"string":return b(o,n);case"boolean":return R(o,n);case"number":return T(o,n);case"undefined":return T(937,n);default:return T(617,n)}}function T(o,n){return(n<<5)-n+o|0}function R(o,n){return T(o?433:863,n)}function b(o,n){n=T(149417,n);for(let i=0,r=o.length;i<r;i++)n=T(o.charCodeAt(i),n);return n}function p(o,n){return n=T(104579,n),o.reduce((i,r)=>L(r,i),n)}function w(o,n){return n=T(181387,n),Object.keys(o).sort().reduce((i,r)=>(i=b(r,i),L(o[r],i)),n)}class A{constructor(){this._value=0}get value(){return this._value}hash(n){return this._value=L(n,this._value),this._value}}e.Hasher=A;var I;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function v(o,n,i=32){const r=i-n,s=~((1<<r)-1);return(o<<n|(s&o)>>>r)>>>0}function C(o,n=0,i=o.byteLength,r=0){for(let s=0;s<i;s++)o[n+s]=r}function S(o,n,i="0"){for(;o.length<n;)o=i+o;return o}function a(o,n=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(i=>i.toString(16).padStart(2,"0")).join(""):S((o>>>0).toString(16),n/4)}class m{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(n){const i=n.length;if(i===0)return;const r=this._buff;let s=this._buffLen,t=this._leftoverHighSurrogate,f,h;for(t!==0?(f=t,h=-1,t=0):(f=n.charCodeAt(0),h=0);;){let l=f;if(c.isHighSurrogate(f))if(h+1<i){const u=n.charCodeAt(h+1);c.isLowSurrogate(u)?(h++,l=c.computeCodePoint(f,u)):l=65533}else{t=f;break}else c.isLowSurrogate(f)&&(l=65533);if(s=this._push(r,s,l),h++,h<i)f=n.charCodeAt(h);else break}this._buffLen=s,this._leftoverHighSurrogate=t}_push(n,i,r){return r<128?n[i++]=r:r<2048?(n[i++]=192|(r&1984)>>>6,n[i++]=128|(r&63)>>>0):r<65536?(n[i++]=224|(r&61440)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0):(n[i++]=240|(r&1835008)>>>18,n[i++]=128|(r&258048)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0),i>=64&&(this._step(),i-=64,this._totalLen+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),a(this._h0)+a(this._h1)+a(this._h2)+a(this._h3)+a(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,C(this._buff,this._buffLen),this._buffLen>56&&(this._step(),C(this._buff));const n=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(n/4294967296),!1),this._buffDV.setUint32(60,n%4294967296,!1),this._step()}_step(){const n=m._bigBlock32,i=this._buffDV;for(let g=0;g<64;g+=4)n.setUint32(g,i.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)n.setUint32(g,v(n.getUint32(g-12,!1)^n.getUint32(g-32,!1)^n.getUint32(g-56,!1)^n.getUint32(g-64,!1),1),!1);let r=this._h0,s=this._h1,t=this._h2,f=this._h3,h=this._h4,l,u,d;for(let g=0;g<80;g++)g<20?(l=s&t|~s&f,u=1518500249):g<40?(l=s^t^f,u=1859775393):g<60?(l=s&t|s&f|t&f,u=2400959708):(l=s^t^f,u=3395469782),d=v(r,5)+l+h+u+n.getUint32(g*4,!1)&4294967295,h=f,f=t,t=v(s,30),s=r,r=d;this._h0=this._h0+r&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+f&4294967295,this._h4=this._h4+h&4294967295}}e.StringSHA1=m}),define(ye[40],_e([1,0,14]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(O||(O={})),function(L){const T="error",R="warning",b="warn",p="info",w="ignore";function A(v){return v?c.equalsIgnoreCase(T,v)?L.Error:c.equalsIgnoreCase(R,v)||c.equalsIgnoreCase(b,v)?L.Warning:c.equalsIgnoreCase(p,v)?L.Info:L.Ignore:L.Ignore}L.fromValue=A;function I(v){switch(v){case L.Error:return T;case L.Warning:return R;case L.Info:return p;default:return w}}L.toString=I}(O||(O={})),e.default=O}),define(ye[169],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ye[77],_e([1,0,19,14]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class L{constructor(){this._value="",this._pos=0}reset(C){return this._value=C,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(C){const S=C.charCodeAt(0),a=this._value.charCodeAt(this._pos);return S-a}value(){return this._value[this._pos]}}e.StringIterator=L;class T{constructor(C=!0){this._caseSensitive=C}reset(C){return this._value=C,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let C=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(C)this._from++;else break;else C=!1;return this}cmp(C){return this._caseSensitive?(0,O.compareSubstring)(C,this._value,0,C.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(C,this._value,0,C.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class R{constructor(C=!0,S=!0){this._splitOnBackslash=C,this._caseSensitive=S}reset(C){this._from=0,this._to=0,this._value=C,this._valueLen=C.length;for(let S=C.length-1;S>=0;S--,this._valueLen--){const a=this._value.charCodeAt(S);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let C=!0;for(;this._to<this._valueLen;this._to++){const S=this._value.charCodeAt(this._to);if(S===47||this._splitOnBackslash&&S===92)if(C)this._from++;else break;else C=!1}return this}cmp(C){return this._caseSensitive?(0,O.compareSubstring)(C,this._value,0,C.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(C,this._value,0,C.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var b;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(b||(b={}));class p{constructor(C,S){this._ignorePathCasing=C,this._ignoreQueryAndFragment=S,this._states=[],this._stateIdx=0}reset(C){return this._value=C,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(C)),this._pathIterator.reset(C.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(C)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(C){if(this._states[this._stateIdx]===1)return(0,O.compareIgnoreCase)(C,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,O.compareIgnoreCase)(C,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(C);if(this._states[this._stateIdx]===4)return(0,O.compare)(C,this._value.query);if(this._states[this._stateIdx]===5)return(0,O.compare)(C,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const C=this.right;return this.right=C.left,C.left=this,this.updateHeight(),C.updateHeight(),C}rotateRight(){const C=this.left;return this.left=C.right,C.right=this,this.updateHeight(),C.updateHeight(),C}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(A||(A={}));class I{static forUris(C=()=>!1,S=()=>!1){return new I(new p(C,S))}static forPaths(C=!1){return new I(new R(void 0,!C))}static forStrings(){return new I(new L)}static forConfigKeys(){return new I(new T)}constructor(C){this._iter=C}clear(){this._root=void 0}fill(C,S){if(S){const a=S.slice(0);(0,c.shuffle)(a);for(const m of a)this.set(m,C)}else{const a=C.slice(0);(0,c.shuffle)(a);for(const m of a)this.set(m[0],m[1])}}set(C,S){const a=this._iter.reset(C);let m;this._root||(this._root=new w,this._root.segment=a.value());const o=[];for(m=this._root;;){const i=a.cmp(m.segment);if(i>0)m.left||(m.left=new w,m.left.segment=a.value()),o.push([-1,m]),m=m.left;else if(i<0)m.right||(m.right=new w,m.right.segment=a.value()),o.push([1,m]),m=m.right;else if(a.hasNext())a.next(),m.mid||(m.mid=new w,m.mid.segment=a.value()),o.push([0,m]),m=m.mid;else break}const n=m.value;m.value=S,m.key=C;for(let i=o.length-1;i>=0;i--){const r=o[i][1];r.updateHeight();const s=r.balanceFactor();if(s<-1||s>1){const t=o[i][0],f=o[i+1][0];if(t===1&&f===1)o[i][1]=r.rotateLeft();else if(t===-1&&f===-1)o[i][1]=r.rotateRight();else if(t===1&&f===-1)r.right=o[i+1][1]=o[i+1][1].rotateRight(),o[i][1]=r.rotateLeft();else if(t===-1&&f===1)r.left=o[i+1][1]=o[i+1][1].rotateLeft(),o[i][1]=r.rotateRight();else throw new Error;if(i>0)switch(o[i-1][0]){case-1:o[i-1][1].left=o[i][1];break;case 1:o[i-1][1].right=o[i][1];break;case 0:o[i-1][1].mid=o[i][1];break}else this._root=o[0][1]}}return n}get(C){return this._getNode(C)?.value}_getNode(C){const S=this._iter.reset(C);let a=this._root;for(;a;){const m=S.cmp(a.segment);if(m>0)a=a.left;else if(m<0)a=a.right;else if(S.hasNext())S.next(),a=a.mid;else break}return a}has(C){const S=this._getNode(C);return!(S?.value===void 0&&S?.mid===void 0)}delete(C){return this._delete(C,!1)}deleteSuperstr(C){return this._delete(C,!0)}_delete(C,S){const a=this._iter.reset(C),m=[];let o=this._root;for(;o;){const n=a.cmp(o.segment);if(n>0)m.push([-1,o]),o=o.left;else if(n<0)m.push([1,o]),o=o.right;else if(a.hasNext())a.next(),m.push([0,o]),o=o.mid;else break}if(o){if(S?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const n=this._min(o.right);if(n.key){const{key:i,value:r,segment:s}=n;this._delete(n.key,!1),o.key=i,o.value=r,o.segment=s}}else{const n=o.left??o.right;if(m.length>0){const[i,r]=m[m.length-1];switch(i){case-1:r.left=n;break;case 0:r.mid=n;break;case 1:r.right=n;break}}else this._root=n}for(let n=m.length-1;n>=0;n--){const i=m[n][1];i.updateHeight();const r=i.balanceFactor();if(r>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),m[n][1]=i.rotateLeft()):r<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),m[n][1]=i.rotateRight()),n>0)switch(m[n-1][0]){case-1:m[n-1][1].left=m[n][1];break;case 1:m[n-1][1].right=m[n][1];break;case 0:m[n-1][1].mid=m[n][1];break}else this._root=m[0][1]}}}_min(C){for(;C.left;)C=C.left;return C}findSubstr(C){const S=this._iter.reset(C);let a=this._root,m;for(;a;){const o=S.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(S.hasNext())S.next(),m=a.value||m,a=a.mid;else break}return a&&a.value||m}findSuperstr(C){return this._findSuperstrOrElement(C,!1)}_findSuperstrOrElement(C,S){const a=this._iter.reset(C);let m=this._root;for(;m;){const o=a.cmp(m.segment);if(o>0)m=m.left;else if(o<0)m=m.right;else if(a.hasNext())a.next(),m=m.mid;else return m.mid?this._entries(m.mid):S?m.value:void 0}}hasElementOrSubtree(C){return this._findSuperstrOrElement(C,!0)!==void 0}forEach(C){for(const[S,a]of this)C(a,S)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(C){const S=[];return this._dfsEntries(C,S),S[Symbol.iterator]()}_dfsEntries(C,S){C&&(C.left&&this._dfsEntries(C.left,S),C.value&&S.push([C.key,C.value]),C.mid&&this._dfsEntries(C.mid,S),C.right&&this._dfsEntries(C.right,S))}_isBalanced(){const C=S=>{if(!S)return!0;const a=S.balanceFactor();return a<-1||a>1?!1:C(S.left)&&C(S.right)};return C(this._root)}}e.TernarySearchTree=I}),define(ye[18],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=c,e.isStringArray=O,e.isObject=L,e.isTypedArray=T,e.isNumber=R,e.isIterable=b,e.isBoolean=p,e.isUndefined=w,e.isDefined=A,e.isUndefinedOrNull=I,e.assertType=v,e.assertIsDefined=C,e.assertAllDefined=S,e.isEmptyObject=m,e.isFunction=o,e.areFunctions=n,e.validateConstraints=i,e.validateConstraint=r;function c(s){return typeof s=="string"}function O(s){return Array.isArray(s)&&s.every(t=>c(t))}function L(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function T(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}function R(s){return typeof s=="number"&&!isNaN(s)}function b(s){return!!s&&typeof s[Symbol.iterator]=="function"}function p(s){return s===!0||s===!1}function w(s){return typeof s>"u"}function A(s){return!I(s)}function I(s){return w(s)||s===null}function v(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function C(s){if(I(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function S(...s){const t=[];for(let f=0;f<s.length;f++){const h=s[f];if(I(h))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);t.push(h)}return t}const a=Object.prototype.hasOwnProperty;function m(s){if(!L(s))return!1;for(const t in s)if(a.call(s,t))return!1;return!0}function o(s){return typeof s=="function"}function n(...s){return s.length>0&&s.every(o)}function i(s,t){const f=Math.min(s.length,t.length);for(let h=0;h<f;h++)r(s[h],t[h])}function r(s,t){if(c(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(s instanceof t)return}catch{}if(!I(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ye[99],_e([1,0,18]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.register=L,e.getCodiconFontCharacters=T;const O=Object.create(null);function L(R,b){if((0,c.isString)(b)){const p=O[b];if(p===void 0)throw new Error(`${R} references an unknown codicon: ${b}`);b=p}return O[R]=b,{id:R}}function T(){return O}}),define(ye[170],_e([1,0,99]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.codiconsLibrary=void 0,e.codiconsLibrary={add:(0,c.register)("add",6e4),plus:(0,c.register)("plus",6e4),gistNew:(0,c.register)("gist-new",6e4),repoCreate:(0,c.register)("repo-create",6e4),lightbulb:(0,c.register)("lightbulb",60001),lightBulb:(0,c.register)("light-bulb",60001),repo:(0,c.register)("repo",60002),repoDelete:(0,c.register)("repo-delete",60002),gistFork:(0,c.register)("gist-fork",60003),repoForked:(0,c.register)("repo-forked",60003),gitPullRequest:(0,c.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,c.register)("git-pull-request-abandoned",60004),recordKeys:(0,c.register)("record-keys",60005),keyboard:(0,c.register)("keyboard",60005),tag:(0,c.register)("tag",60006),gitPullRequestLabel:(0,c.register)("git-pull-request-label",60006),tagAdd:(0,c.register)("tag-add",60006),tagRemove:(0,c.register)("tag-remove",60006),person:(0,c.register)("person",60007),personFollow:(0,c.register)("person-follow",60007),personOutline:(0,c.register)("person-outline",60007),personFilled:(0,c.register)("person-filled",60007),gitBranch:(0,c.register)("git-branch",60008),gitBranchCreate:(0,c.register)("git-branch-create",60008),gitBranchDelete:(0,c.register)("git-branch-delete",60008),sourceControl:(0,c.register)("source-control",60008),mirror:(0,c.register)("mirror",60009),mirrorPublic:(0,c.register)("mirror-public",60009),star:(0,c.register)("star",60010),starAdd:(0,c.register)("star-add",60010),starDelete:(0,c.register)("star-delete",60010),starEmpty:(0,c.register)("star-empty",60010),comment:(0,c.register)("comment",60011),commentAdd:(0,c.register)("comment-add",60011),alert:(0,c.register)("alert",60012),warning:(0,c.register)("warning",60012),search:(0,c.register)("search",60013),searchSave:(0,c.register)("search-save",60013),logOut:(0,c.register)("log-out",60014),signOut:(0,c.register)("sign-out",60014),logIn:(0,c.register)("log-in",60015),signIn:(0,c.register)("sign-in",60015),eye:(0,c.register)("eye",60016),eyeUnwatch:(0,c.register)("eye-unwatch",60016),eyeWatch:(0,c.register)("eye-watch",60016),circleFilled:(0,c.register)("circle-filled",60017),primitiveDot:(0,c.register)("primitive-dot",60017),closeDirty:(0,c.register)("close-dirty",60017),debugBreakpoint:(0,c.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,c.register)("debug-breakpoint-disabled",60017),debugHint:(0,c.register)("debug-hint",60017),terminalDecorationSuccess:(0,c.register)("terminal-decoration-success",60017),primitiveSquare:(0,c.register)("primitive-square",60018),edit:(0,c.register)("edit",60019),pencil:(0,c.register)("pencil",60019),info:(0,c.register)("info",60020),issueOpened:(0,c.register)("issue-opened",60020),gistPrivate:(0,c.register)("gist-private",60021),gitForkPrivate:(0,c.register)("git-fork-private",60021),lock:(0,c.register)("lock",60021),mirrorPrivate:(0,c.register)("mirror-private",60021),close:(0,c.register)("close",60022),removeClose:(0,c.register)("remove-close",60022),x:(0,c.register)("x",60022),repoSync:(0,c.register)("repo-sync",60023),sync:(0,c.register)("sync",60023),clone:(0,c.register)("clone",60024),desktopDownload:(0,c.register)("desktop-download",60024),beaker:(0,c.register)("beaker",60025),microscope:(0,c.register)("microscope",60025),vm:(0,c.register)("vm",60026),deviceDesktop:(0,c.register)("device-desktop",60026),file:(0,c.register)("file",60027),fileText:(0,c.register)("file-text",60027),more:(0,c.register)("more",60028),ellipsis:(0,c.register)("ellipsis",60028),kebabHorizontal:(0,c.register)("kebab-horizontal",60028),mailReply:(0,c.register)("mail-reply",60029),reply:(0,c.register)("reply",60029),organization:(0,c.register)("organization",60030),organizationFilled:(0,c.register)("organization-filled",60030),organizationOutline:(0,c.register)("organization-outline",60030),newFile:(0,c.register)("new-file",60031),fileAdd:(0,c.register)("file-add",60031),newFolder:(0,c.register)("new-folder",60032),fileDirectoryCreate:(0,c.register)("file-directory-create",60032),trash:(0,c.register)("trash",60033),trashcan:(0,c.register)("trashcan",60033),history:(0,c.register)("history",60034),clock:(0,c.register)("clock",60034),folder:(0,c.register)("folder",60035),fileDirectory:(0,c.register)("file-directory",60035),symbolFolder:(0,c.register)("symbol-folder",60035),logoGithub:(0,c.register)("logo-github",60036),markGithub:(0,c.register)("mark-github",60036),github:(0,c.register)("github",60036),terminal:(0,c.register)("terminal",60037),console:(0,c.register)("console",60037),repl:(0,c.register)("repl",60037),zap:(0,c.register)("zap",60038),symbolEvent:(0,c.register)("symbol-event",60038),error:(0,c.register)("error",60039),stop:(0,c.register)("stop",60039),variable:(0,c.register)("variable",60040),symbolVariable:(0,c.register)("symbol-variable",60040),array:(0,c.register)("array",60042),symbolArray:(0,c.register)("symbol-array",60042),symbolModule:(0,c.register)("symbol-module",60043),symbolPackage:(0,c.register)("symbol-package",60043),symbolNamespace:(0,c.register)("symbol-namespace",60043),symbolObject:(0,c.register)("symbol-object",60043),symbolMethod:(0,c.register)("symbol-method",60044),symbolFunction:(0,c.register)("symbol-function",60044),symbolConstructor:(0,c.register)("symbol-constructor",60044),symbolBoolean:(0,c.register)("symbol-boolean",60047),symbolNull:(0,c.register)("symbol-null",60047),symbolNumeric:(0,c.register)("symbol-numeric",60048),symbolNumber:(0,c.register)("symbol-number",60048),symbolStructure:(0,c.register)("symbol-structure",60049),symbolStruct:(0,c.register)("symbol-struct",60049),symbolParameter:(0,c.register)("symbol-parameter",60050),symbolTypeParameter:(0,c.register)("symbol-type-parameter",60050),symbolKey:(0,c.register)("symbol-key",60051),symbolText:(0,c.register)("symbol-text",60051),symbolReference:(0,c.register)("symbol-reference",60052),goToFile:(0,c.register)("go-to-file",60052),symbolEnum:(0,c.register)("symbol-enum",60053),symbolValue:(0,c.register)("symbol-value",60053),symbolRuler:(0,c.register)("symbol-ruler",60054),symbolUnit:(0,c.register)("symbol-unit",60054),activateBreakpoints:(0,c.register)("activate-breakpoints",60055),archive:(0,c.register)("archive",60056),arrowBoth:(0,c.register)("arrow-both",60057),arrowDown:(0,c.register)("arrow-down",60058),arrowLeft:(0,c.register)("arrow-left",60059),arrowRight:(0,c.register)("arrow-right",60060),arrowSmallDown:(0,c.register)("arrow-small-down",60061),arrowSmallLeft:(0,c.register)("arrow-small-left",60062),arrowSmallRight:(0,c.register)("arrow-small-right",60063),arrowSmallUp:(0,c.register)("arrow-small-up",60064),arrowUp:(0,c.register)("arrow-up",60065),bell:(0,c.register)("bell",60066),bold:(0,c.register)("bold",60067),book:(0,c.register)("book",60068),bookmark:(0,c.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,c.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,c.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,c.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,c.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,c.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,c.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,c.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,c.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,c.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,c.register)("briefcase",60076),broadcast:(0,c.register)("broadcast",60077),browser:(0,c.register)("browser",60078),bug:(0,c.register)("bug",60079),calendar:(0,c.register)("calendar",60080),caseSensitive:(0,c.register)("case-sensitive",60081),check:(0,c.register)("check",60082),checklist:(0,c.register)("checklist",60083),chevronDown:(0,c.register)("chevron-down",60084),chevronLeft:(0,c.register)("chevron-left",60085),chevronRight:(0,c.register)("chevron-right",60086),chevronUp:(0,c.register)("chevron-up",60087),chromeClose:(0,c.register)("chrome-close",60088),chromeMaximize:(0,c.register)("chrome-maximize",60089),chromeMinimize:(0,c.register)("chrome-minimize",60090),chromeRestore:(0,c.register)("chrome-restore",60091),circleOutline:(0,c.register)("circle-outline",60092),circle:(0,c.register)("circle",60092),debugBreakpointUnverified:(0,c.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,c.register)("terminal-decoration-incomplete",60092),circleSlash:(0,c.register)("circle-slash",60093),circuitBoard:(0,c.register)("circuit-board",60094),clearAll:(0,c.register)("clear-all",60095),clippy:(0,c.register)("clippy",60096),closeAll:(0,c.register)("close-all",60097),cloudDownload:(0,c.register)("cloud-download",60098),cloudUpload:(0,c.register)("cloud-upload",60099),code:(0,c.register)("code",60100),collapseAll:(0,c.register)("collapse-all",60101),colorMode:(0,c.register)("color-mode",60102),commentDiscussion:(0,c.register)("comment-discussion",60103),creditCard:(0,c.register)("credit-card",60105),dash:(0,c.register)("dash",60108),dashboard:(0,c.register)("dashboard",60109),database:(0,c.register)("database",60110),debugContinue:(0,c.register)("debug-continue",60111),debugDisconnect:(0,c.register)("debug-disconnect",60112),debugPause:(0,c.register)("debug-pause",60113),debugRestart:(0,c.register)("debug-restart",60114),debugStart:(0,c.register)("debug-start",60115),debugStepInto:(0,c.register)("debug-step-into",60116),debugStepOut:(0,c.register)("debug-step-out",60117),debugStepOver:(0,c.register)("debug-step-over",60118),debugStop:(0,c.register)("debug-stop",60119),debug:(0,c.register)("debug",60120),deviceCameraVideo:(0,c.register)("device-camera-video",60121),deviceCamera:(0,c.register)("device-camera",60122),deviceMobile:(0,c.register)("device-mobile",60123),diffAdded:(0,c.register)("diff-added",60124),diffIgnored:(0,c.register)("diff-ignored",60125),diffModified:(0,c.register)("diff-modified",60126),diffRemoved:(0,c.register)("diff-removed",60127),diffRenamed:(0,c.register)("diff-renamed",60128),diff:(0,c.register)("diff",60129),diffSidebyside:(0,c.register)("diff-sidebyside",60129),discard:(0,c.register)("discard",60130),editorLayout:(0,c.register)("editor-layout",60131),emptyWindow:(0,c.register)("empty-window",60132),exclude:(0,c.register)("exclude",60133),extensions:(0,c.register)("extensions",60134),eyeClosed:(0,c.register)("eye-closed",60135),fileBinary:(0,c.register)("file-binary",60136),fileCode:(0,c.register)("file-code",60137),fileMedia:(0,c.register)("file-media",60138),filePdf:(0,c.register)("file-pdf",60139),fileSubmodule:(0,c.register)("file-submodule",60140),fileSymlinkDirectory:(0,c.register)("file-symlink-directory",60141),fileSymlinkFile:(0,c.register)("file-symlink-file",60142),fileZip:(0,c.register)("file-zip",60143),files:(0,c.register)("files",60144),filter:(0,c.register)("filter",60145),flame:(0,c.register)("flame",60146),foldDown:(0,c.register)("fold-down",60147),foldUp:(0,c.register)("fold-up",60148),fold:(0,c.register)("fold",60149),folderActive:(0,c.register)("folder-active",60150),folderOpened:(0,c.register)("folder-opened",60151),gear:(0,c.register)("gear",60152),gift:(0,c.register)("gift",60153),gistSecret:(0,c.register)("gist-secret",60154),gist:(0,c.register)("gist",60155),gitCommit:(0,c.register)("git-commit",60156),gitCompare:(0,c.register)("git-compare",60157),compareChanges:(0,c.register)("compare-changes",60157),gitMerge:(0,c.register)("git-merge",60158),githubAction:(0,c.register)("github-action",60159),githubAlt:(0,c.register)("github-alt",60160),globe:(0,c.register)("globe",60161),grabber:(0,c.register)("grabber",60162),graph:(0,c.register)("graph",60163),gripper:(0,c.register)("gripper",60164),heart:(0,c.register)("heart",60165),home:(0,c.register)("home",60166),horizontalRule:(0,c.register)("horizontal-rule",60167),hubot:(0,c.register)("hubot",60168),inbox:(0,c.register)("inbox",60169),issueReopened:(0,c.register)("issue-reopened",60171),issues:(0,c.register)("issues",60172),italic:(0,c.register)("italic",60173),jersey:(0,c.register)("jersey",60174),json:(0,c.register)("json",60175),kebabVertical:(0,c.register)("kebab-vertical",60176),key:(0,c.register)("key",60177),law:(0,c.register)("law",60178),lightbulbAutofix:(0,c.register)("lightbulb-autofix",60179),linkExternal:(0,c.register)("link-external",60180),link:(0,c.register)("link",60181),listOrdered:(0,c.register)("list-ordered",60182),listUnordered:(0,c.register)("list-unordered",60183),liveShare:(0,c.register)("live-share",60184),loading:(0,c.register)("loading",60185),location:(0,c.register)("location",60186),mailRead:(0,c.register)("mail-read",60187),mail:(0,c.register)("mail",60188),markdown:(0,c.register)("markdown",60189),megaphone:(0,c.register)("megaphone",60190),mention:(0,c.register)("mention",60191),milestone:(0,c.register)("milestone",60192),gitPullRequestMilestone:(0,c.register)("git-pull-request-milestone",60192),mortarBoard:(0,c.register)("mortar-board",60193),move:(0,c.register)("move",60194),multipleWindows:(0,c.register)("multiple-windows",60195),mute:(0,c.register)("mute",60196),noNewline:(0,c.register)("no-newline",60197),note:(0,c.register)("note",60198),octoface:(0,c.register)("octoface",60199),openPreview:(0,c.register)("open-preview",60200),package:(0,c.register)("package",60201),paintcan:(0,c.register)("paintcan",60202),pin:(0,c.register)("pin",60203),play:(0,c.register)("play",60204),run:(0,c.register)("run",60204),plug:(0,c.register)("plug",60205),preserveCase:(0,c.register)("preserve-case",60206),preview:(0,c.register)("preview",60207),project:(0,c.register)("project",60208),pulse:(0,c.register)("pulse",60209),question:(0,c.register)("question",60210),quote:(0,c.register)("quote",60211),radioTower:(0,c.register)("radio-tower",60212),reactions:(0,c.register)("reactions",60213),references:(0,c.register)("references",60214),refresh:(0,c.register)("refresh",60215),regex:(0,c.register)("regex",60216),remoteExplorer:(0,c.register)("remote-explorer",60217),remote:(0,c.register)("remote",60218),remove:(0,c.register)("remove",60219),replaceAll:(0,c.register)("replace-all",60220),replace:(0,c.register)("replace",60221),repoClone:(0,c.register)("repo-clone",60222),repoForcePush:(0,c.register)("repo-force-push",60223),repoPull:(0,c.register)("repo-pull",60224),repoPush:(0,c.register)("repo-push",60225),report:(0,c.register)("report",60226),requestChanges:(0,c.register)("request-changes",60227),rocket:(0,c.register)("rocket",60228),rootFolderOpened:(0,c.register)("root-folder-opened",60229),rootFolder:(0,c.register)("root-folder",60230),rss:(0,c.register)("rss",60231),ruby:(0,c.register)("ruby",60232),saveAll:(0,c.register)("save-all",60233),saveAs:(0,c.register)("save-as",60234),save:(0,c.register)("save",60235),screenFull:(0,c.register)("screen-full",60236),screenNormal:(0,c.register)("screen-normal",60237),searchStop:(0,c.register)("search-stop",60238),server:(0,c.register)("server",60240),settingsGear:(0,c.register)("settings-gear",60241),settings:(0,c.register)("settings",60242),shield:(0,c.register)("shield",60243),smiley:(0,c.register)("smiley",60244),sortPrecedence:(0,c.register)("sort-precedence",60245),splitHorizontal:(0,c.register)("split-horizontal",60246),splitVertical:(0,c.register)("split-vertical",60247),squirrel:(0,c.register)("squirrel",60248),starFull:(0,c.register)("star-full",60249),starHalf:(0,c.register)("star-half",60250),symbolClass:(0,c.register)("symbol-class",60251),symbolColor:(0,c.register)("symbol-color",60252),symbolConstant:(0,c.register)("symbol-constant",60253),symbolEnumMember:(0,c.register)("symbol-enum-member",60254),symbolField:(0,c.register)("symbol-field",60255),symbolFile:(0,c.register)("symbol-file",60256),symbolInterface:(0,c.register)("symbol-interface",60257),symbolKeyword:(0,c.register)("symbol-keyword",60258),symbolMisc:(0,c.register)("symbol-misc",60259),symbolOperator:(0,c.register)("symbol-operator",60260),symbolProperty:(0,c.register)("symbol-property",60261),wrench:(0,c.register)("wrench",60261),wrenchSubaction:(0,c.register)("wrench-subaction",60261),symbolSnippet:(0,c.register)("symbol-snippet",60262),tasklist:(0,c.register)("tasklist",60263),telescope:(0,c.register)("telescope",60264),textSize:(0,c.register)("text-size",60265),threeBars:(0,c.register)("three-bars",60266),thumbsdown:(0,c.register)("thumbsdown",60267),thumbsup:(0,c.register)("thumbsup",60268),tools:(0,c.register)("tools",60269),triangleDown:(0,c.register)("triangle-down",60270),triangleLeft:(0,c.register)("triangle-left",60271),triangleRight:(0,c.register)("triangle-right",60272),triangleUp:(0,c.register)("triangle-up",60273),twitter:(0,c.register)("twitter",60274),unfold:(0,c.register)("unfold",60275),unlock:(0,c.register)("unlock",60276),unmute:(0,c.register)("unmute",60277),unverified:(0,c.register)("unverified",60278),verified:(0,c.register)("verified",60279),versions:(0,c.register)("versions",60280),vmActive:(0,c.register)("vm-active",60281),vmOutline:(0,c.register)("vm-outline",60282),vmRunning:(0,c.register)("vm-running",60283),watch:(0,c.register)("watch",60284),whitespace:(0,c.register)("whitespace",60285),wholeWord:(0,c.register)("whole-word",60286),window:(0,c.register)("window",60287),wordWrap:(0,c.register)("word-wrap",60288),zoomIn:(0,c.register)("zoom-in",60289),zoomOut:(0,c.register)("zoom-out",60290),listFilter:(0,c.register)("list-filter",60291),listFlat:(0,c.register)("list-flat",60292),listSelection:(0,c.register)("list-selection",60293),selection:(0,c.register)("selection",60293),listTree:(0,c.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,c.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,c.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,c.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,c.register)("debug-stackframe-active",60297),circleSmallFilled:(0,c.register)("circle-small-filled",60298),debugStackframeDot:(0,c.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,c.register)("terminal-decoration-mark",60298),debugStackframe:(0,c.register)("debug-stackframe",60299),debugStackframeFocused:(0,c.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,c.register)("debug-breakpoint-unsupported",60300),symbolString:(0,c.register)("symbol-string",60301),debugReverseContinue:(0,c.register)("debug-reverse-continue",60302),debugStepBack:(0,c.register)("debug-step-back",60303),debugRestartFrame:(0,c.register)("debug-restart-frame",60304),debugAlt:(0,c.register)("debug-alt",60305),callIncoming:(0,c.register)("call-incoming",60306),callOutgoing:(0,c.register)("call-outgoing",60307),menu:(0,c.register)("menu",60308),expandAll:(0,c.register)("expand-all",60309),feedback:(0,c.register)("feedback",60310),gitPullRequestReviewer:(0,c.register)("git-pull-request-reviewer",60310),groupByRefType:(0,c.register)("group-by-ref-type",60311),ungroupByRefType:(0,c.register)("ungroup-by-ref-type",60312),account:(0,c.register)("account",60313),gitPullRequestAssignee:(0,c.register)("git-pull-request-assignee",60313),bellDot:(0,c.register)("bell-dot",60314),debugConsole:(0,c.register)("debug-console",60315),library:(0,c.register)("library",60316),output:(0,c.register)("output",60317),runAll:(0,c.register)("run-all",60318),syncIgnored:(0,c.register)("sync-ignored",60319),pinned:(0,c.register)("pinned",60320),githubInverted:(0,c.register)("github-inverted",60321),serverProcess:(0,c.register)("server-process",60322),serverEnvironment:(0,c.register)("server-environment",60323),pass:(0,c.register)("pass",60324),issueClosed:(0,c.register)("issue-closed",60324),stopCircle:(0,c.register)("stop-circle",60325),playCircle:(0,c.register)("play-circle",60326),record:(0,c.register)("record",60327),debugAltSmall:(0,c.register)("debug-alt-small",60328),vmConnect:(0,c.register)("vm-connect",60329),cloud:(0,c.register)("cloud",60330),merge:(0,c.register)("merge",60331),export:(0,c.register)("export",60332),graphLeft:(0,c.register)("graph-left",60333),magnet:(0,c.register)("magnet",60334),notebook:(0,c.register)("notebook",60335),redo:(0,c.register)("redo",60336),checkAll:(0,c.register)("check-all",60337),pinnedDirty:(0,c.register)("pinned-dirty",60338),passFilled:(0,c.register)("pass-filled",60339),circleLargeFilled:(0,c.register)("circle-large-filled",60340),circleLarge:(0,c.register)("circle-large",60341),circleLargeOutline:(0,c.register)("circle-large-outline",60341),combine:(0,c.register)("combine",60342),gather:(0,c.register)("gather",60342),table:(0,c.register)("table",60343),variableGroup:(0,c.register)("variable-group",60344),typeHierarchy:(0,c.register)("type-hierarchy",60345),typeHierarchySub:(0,c.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,c.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,c.register)("git-pull-request-create",60348),runAbove:(0,c.register)("run-above",60349),runBelow:(0,c.register)("run-below",60350),notebookTemplate:(0,c.register)("notebook-template",60351),debugRerun:(0,c.register)("debug-rerun",60352),workspaceTrusted:(0,c.register)("workspace-trusted",60353),workspaceUntrusted:(0,c.register)("workspace-untrusted",60354),workspaceUnknown:(0,c.register)("workspace-unknown",60355),terminalCmd:(0,c.register)("terminal-cmd",60356),terminalDebian:(0,c.register)("terminal-debian",60357),terminalLinux:(0,c.register)("terminal-linux",60358),terminalPowershell:(0,c.register)("terminal-powershell",60359),terminalTmux:(0,c.register)("terminal-tmux",60360),terminalUbuntu:(0,c.register)("terminal-ubuntu",60361),terminalBash:(0,c.register)("terminal-bash",60362),arrowSwap:(0,c.register)("arrow-swap",60363),copy:(0,c.register)("copy",60364),personAdd:(0,c.register)("person-add",60365),filterFilled:(0,c.register)("filter-filled",60366),wand:(0,c.register)("wand",60367),debugLineByLine:(0,c.register)("debug-line-by-line",60368),inspect:(0,c.register)("inspect",60369),layers:(0,c.register)("layers",60370),layersDot:(0,c.register)("layers-dot",60371),layersActive:(0,c.register)("layers-active",60372),compass:(0,c.register)("compass",60373),compassDot:(0,c.register)("compass-dot",60374),compassActive:(0,c.register)("compass-active",60375),azure:(0,c.register)("azure",60376),issueDraft:(0,c.register)("issue-draft",60377),gitPullRequestClosed:(0,c.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,c.register)("git-pull-request-draft",60379),debugAll:(0,c.register)("debug-all",60380),debugCoverage:(0,c.register)("debug-coverage",60381),runErrors:(0,c.register)("run-errors",60382),folderLibrary:(0,c.register)("folder-library",60383),debugContinueSmall:(0,c.register)("debug-continue-small",60384),beakerStop:(0,c.register)("beaker-stop",60385),graphLine:(0,c.register)("graph-line",60386),graphScatter:(0,c.register)("graph-scatter",60387),pieChart:(0,c.register)("pie-chart",60388),bracket:(0,c.register)("bracket",60175),bracketDot:(0,c.register)("bracket-dot",60389),bracketError:(0,c.register)("bracket-error",60390),lockSmall:(0,c.register)("lock-small",60391),azureDevops:(0,c.register)("azure-devops",60392),verifiedFilled:(0,c.register)("verified-filled",60393),newline:(0,c.register)("newline",60394),layout:(0,c.register)("layout",60395),layoutActivitybarLeft:(0,c.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,c.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,c.register)("layout-panel-left",60398),layoutPanelCenter:(0,c.register)("layout-panel-center",60399),layoutPanelJustify:(0,c.register)("layout-panel-justify",60400),layoutPanelRight:(0,c.register)("layout-panel-right",60401),layoutPanel:(0,c.register)("layout-panel",60402),layoutSidebarLeft:(0,c.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,c.register)("layout-sidebar-right",60404),layoutStatusbar:(0,c.register)("layout-statusbar",60405),layoutMenubar:(0,c.register)("layout-menubar",60406),layoutCentered:(0,c.register)("layout-centered",60407),target:(0,c.register)("target",60408),indent:(0,c.register)("indent",60409),recordSmall:(0,c.register)("record-small",60410),errorSmall:(0,c.register)("error-small",60411),terminalDecorationError:(0,c.register)("terminal-decoration-error",60411),arrowCircleDown:(0,c.register)("arrow-circle-down",60412),arrowCircleLeft:(0,c.register)("arrow-circle-left",60413),arrowCircleRight:(0,c.register)("arrow-circle-right",60414),arrowCircleUp:(0,c.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,c.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,c.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,c.register)("layout-sidebar-left-off",60418),blank:(0,c.register)("blank",60419),heartFilled:(0,c.register)("heart-filled",60420),map:(0,c.register)("map",60421),mapHorizontal:(0,c.register)("map-horizontal",60421),foldHorizontal:(0,c.register)("fold-horizontal",60421),mapFilled:(0,c.register)("map-filled",60422),mapHorizontalFilled:(0,c.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,c.register)("fold-horizontal-filled",60422),circleSmall:(0,c.register)("circle-small",60423),bellSlash:(0,c.register)("bell-slash",60424),bellSlashDot:(0,c.register)("bell-slash-dot",60425),commentUnresolved:(0,c.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,c.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,c.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,c.register)("search-fuzzy",60429),commentDraft:(0,c.register)("comment-draft",60430),send:(0,c.register)("send",60431),sparkle:(0,c.register)("sparkle",60432),insert:(0,c.register)("insert",60433),mic:(0,c.register)("mic",60434),thumbsdownFilled:(0,c.register)("thumbsdown-filled",60435),thumbsupFilled:(0,c.register)("thumbsup-filled",60436),coffee:(0,c.register)("coffee",60437),snake:(0,c.register)("snake",60438),game:(0,c.register)("game",60439),vr:(0,c.register)("vr",60440),chip:(0,c.register)("chip",60441),piano:(0,c.register)("piano",60442),music:(0,c.register)("music",60443),micFilled:(0,c.register)("mic-filled",60444),repoFetch:(0,c.register)("repo-fetch",60445),copilot:(0,c.register)("copilot",60446),lightbulbSparkle:(0,c.register)("lightbulb-sparkle",60447),robot:(0,c.register)("robot",60448),sparkleFilled:(0,c.register)("sparkle-filled",60449),diffSingle:(0,c.register)("diff-single",60450),diffMultiple:(0,c.register)("diff-multiple",60451),surroundWith:(0,c.register)("surround-with",60452),share:(0,c.register)("share",60453),gitStash:(0,c.register)("git-stash",60454),gitStashApply:(0,c.register)("git-stash-apply",60455),gitStashPop:(0,c.register)("git-stash-pop",60456),vscode:(0,c.register)("vscode",60457),vscodeInsiders:(0,c.register)("vscode-insiders",60458),codeOss:(0,c.register)("code-oss",60459),runCoverage:(0,c.register)("run-coverage",60460),runAllCoverage:(0,c.register)("run-all-coverage",60461),coverage:(0,c.register)("coverage",60462),githubProject:(0,c.register)("github-project",60463),mapVertical:(0,c.register)("map-vertical",60464),foldVertical:(0,c.register)("fold-vertical",60464),mapVerticalFilled:(0,c.register)("map-vertical-filled",60465),foldVerticalFilled:(0,c.register)("fold-vertical-filled",60465)}}),define(ye[78],_e([1,0,99,170]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.codiconsDerived=void 0,e.getAllCodicons=L;function L(){return Object.values(e.Codicon)}e.codiconsDerived={dialogError:(0,c.register)("dialog-error","error"),dialogWarning:(0,c.register)("dialog-warning","warning"),dialogInfo:(0,c.register)("dialog-info","info"),dialogClose:(0,c.register)("dialog-close","close"),treeItemExpanded:(0,c.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,c.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,c.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,c.register)("tree-filter-clear","close"),treeItemLoading:(0,c.register)("tree-item-loading","loading"),menuSelection:(0,c.register)("menu-selection","check"),menuSubmenu:(0,c.register)("menu-submenu","chevron-right"),menuBarMore:(0,c.register)("menubar-more","more"),scrollbarButtonLeft:(0,c.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,c.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,c.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,c.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,c.register)("toolbar-more","more"),quickInputBack:(0,c.register)("quick-input-back","arrow-left"),dropDownButton:(0,c.register)("drop-down-button",60084),symbolCustomColor:(0,c.register)("symbol-customcolor",60252),exportIcon:(0,c.register)("export",60332),workspaceUnspecified:(0,c.register)("workspace-unspecified",60355),newLine:(0,c.register)("newline",60394),thumbsDownFilled:(0,c.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,c.register)("thumbsup-filled",60436),gitFetch:(0,c.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,c.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,c.register)("debug-breakpoint-pending",60377)},e.Codicon={...O.codiconsLibrary,...e.codiconsDerived}}),define(ye[24],_e([1,0,18]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=O,e.deepFreeze=L,e.cloneAndChange=R,e.mixin=p,e.equals=w,e.safeStringify=A,e.distinct=I,e.getCaseInsensitive=v,e.filter=C,e.getAllPropertyNames=S,e.getAllMethodNames=a,e.createProxyObject=m;function O(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const n=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([i,r])=>{n[i]=r&&typeof r=="object"?O(r):r}),n}function L(o){if(!o||typeof o!="object")return o;const n=[o];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const r in i)if(T.call(i,r)){const s=i[r];typeof s=="object"&&!Object.isFrozen(s)&&!(0,c.isTypedArray)(s)&&n.push(s)}}return o}const T=Object.prototype.hasOwnProperty;function R(o,n){return b(o,n,new Set)}function b(o,n,i){if((0,c.isUndefinedOrNull)(o))return o;const r=n(o);if(typeof r<"u")return r;if(Array.isArray(o)){const s=[];for(const t of o)s.push(b(t,n,i));return s}if((0,c.isObject)(o)){if(i.has(o))throw new Error("Cannot clone recursive data-structure");i.add(o);const s={};for(const t in o)T.call(o,t)&&(s[t]=b(o[t],n,i));return i.delete(o),s}return o}function p(o,n,i=!0){return(0,c.isObject)(o)?((0,c.isObject)(n)&&Object.keys(n).forEach(r=>{r in o?i&&((0,c.isObject)(o[r])&&(0,c.isObject)(n[r])?p(o[r],n[r],i):o[r]=n[r]):o[r]=n[r]}),o):n}function w(o,n){if(o===n)return!0;if(o==null||n===null||n===void 0||typeof o!=typeof n||typeof o!="object"||Array.isArray(o)!==Array.isArray(n))return!1;let i,r;if(Array.isArray(o)){if(o.length!==n.length)return!1;for(i=0;i<o.length;i++)if(!w(o[i],n[i]))return!1}else{const s=[];for(r in o)s.push(r);s.sort();const t=[];for(r in n)t.push(r);if(t.sort(),!w(s,t))return!1;for(i=0;i<s.length;i++)if(!w(o[s[i]],n[s[i]]))return!1}return!0}function A(o){const n=new Set;return JSON.stringify(o,(i,r)=>{if((0,c.isObject)(r)||Array.isArray(r)){if(n.has(r))return"[Circular]";n.add(r)}return r})}function I(o,n){const i=Object.create(null);return!o||!n||Object.keys(n).forEach(s=>{const t=o[s],f=n[s];w(t,f)||(i[s]=f)}),i}function v(o,n){const i=n.toLowerCase(),r=Object.keys(o).find(s=>s.toLowerCase()===i);return r?o[r]:o[n]}function C(o,n){const i=Object.create(null);for(const[r,s]of Object.entries(o))n(r,s)&&(i[r]=s);return i}function S(o){let n=[];for(;Object.prototype!==o;)n=n.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return n}function a(o){const n=[];for(const i of S(o))typeof o[i]=="function"&&n.push(i);return n}function m(o,n){const i=s=>function(){const t=Array.prototype.slice.call(arguments,0);return n(s,t)},r={};for(const s of o)r[s]=i(s);return r}}),define(ye[56],_e([1,0,78]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=L;var O;(function(R){function b(p){return p&&typeof p=="object"&&typeof p.id=="string"}R.isThemeColor=b})(O||(e.ThemeColor=O={}));function L(R){return{id:R}}var T;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function p(n){const i=b.exec(n.id);if(!i)return p(c.Codicon.error);const[,r,s]=i,t=["codicon","codicon-"+r];return s&&t.push("codicon-modifier-"+s.substring(1)),t}R.asClassNameArray=p;function w(n){return p(n).join(" ")}R.asClassName=w;function A(n){return"."+p(n).join(".")}R.asCSSSelector=A;function I(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||O.isThemeColor(n.color))}R.isThemeIcon=I;const v=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function C(n){const i=v.exec(n);if(!i)return;const[,r]=i;return{id:r}}R.fromString=C;function S(n){return{id:n}}R.fromId=S;function a(n,i){let r=n.id;const s=r.lastIndexOf("~");return s!==-1&&(r=r.substring(0,s)),i&&(r=`${r}~${i}`),{id:r}}R.modify=a;function m(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}R.getModifier=m;function o(n,i){return n.id===i.id&&n.color?.id===i.color?.id}R.isEqual=o})(T||(e.ThemeIcon=T={}))}),define(ye[171],_e([1,0,126,14,56]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeIcons=p,e.markdownEscapeEscapedIcons=A,e.stripIcons=v,e.getCodiconAriaLabel=C,e.parseLabelWithIcons=a,e.matchesFuzzyIconAware=m;const T="$(",R=new RegExp(`\\$\\(${L.ThemeIcon.iconNameExpression}(?:${L.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${R.source}`,"g");function p(o){return o.replace(b,(n,i)=>i?n:`\\${n}`)}const w=new RegExp(`\\\\${R.source}`,"g");function A(o){return o.replace(w,n=>`\\${n}`)}const I=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function v(o){return o.indexOf(T)===-1?o:o.replace(I,(n,i,r,s)=>r?n:i||s||"")}function C(o){return o?o.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const S=new RegExp(`\\$\\(${L.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(o){S.lastIndex=0;let n="";const i=[];let r=0;for(;;){const s=S.lastIndex,t=S.exec(o),f=o.substring(s,t?.index);if(f.length>0){n+=f;for(let h=0;h<f.length;h++)i.push(r)}if(!t)break;r+=t[0].length}return{text:n,iconOffsets:i}}function m(o,n,i=!1){const{text:r,iconOffsets:s}=n;if(!s||s.length===0)return(0,c.matchesFuzzy)(o,r,i);const t=(0,O.ltrim)(r," "),f=r.length-t.length,h=(0,c.matchesFuzzy)(o,t,i);if(h)for(const l of h){const u=s[l.start+f]+f;l.start+=u,l.end+=u}return h}}),define(ye[127],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.toUint8=O,e.toUint32=L;var c;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(c||(e.Constants=c={}));function O(T){return T<0?0:T>255?255:T|0}function L(T){return T<0?0:T>4294967295?4294967295:T|0}}),define(ye[30],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=O;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(L){return c.test(L)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(b){for(let p=0;p<b.length;p++)b[p]=Math.floor(Math.random()*256);return b};const T=new Uint8Array(16),R=[];for(let b=0;b<256;b++)R.push(b.toString(16).padStart(2,"0"));return function(){L(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let p=0,w="";return w+=R[T[p++]],w+=R[T[p++]],w+=R[T[p++]],w+=R[T[p++]],w+="-",w+=R[T[p++]],w+=R[T[p++]],w+="-",w+=R[T[p++]],w+=R[T[p++]],w+="-",w+=R[T[p++]],w+=R[T[p++]],w+="-",w+=R[T[p++]],w+=R[T[p++]],w+=R[T[p++]],w+=R[T[p++]],w+=R[T[p++]],w+=R[T[p++]],w}}()}),define(ye[172],_e([1,0,19,38,30]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=void 0,e.createStringDataTransferItem=T,e.createFileDataTransferItem=R,e.matchesMimeType=w;function T(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}function R(I,v,C){const S={id:(0,L.generateUuid)(),name:I,uri:v,data:C};return{asString:async()=>"",asFile:()=>S,value:void 0}}class b{constructor(){this._entries=new Map}get size(){let v=0;for(const C of this._entries)v++;return v}has(v){return this._entries.has(this.toKey(v))}matches(v){const C=[...this._entries.keys()];return O.Iterable.some(this,([S,a])=>a.asFile())&&C.push("files"),A(p(v),C)}get(v){return this._entries.get(this.toKey(v))?.[0]}append(v,C){const S=this._entries.get(v);S?S.push(C):this._entries.set(this.toKey(v),[C])}replace(v,C){this._entries.set(this.toKey(v),[C])}delete(v){this._entries.delete(this.toKey(v))}*[Symbol.iterator](){for(const[v,C]of this._entries)for(const S of C)yield[v,S]}toKey(v){return p(v)}}e.VSDataTransfer=b;function p(I){return I.toLowerCase()}function w(I,v){return A(p(I),v.map(p))}function A(I,v){if(I==="*/*")return v.length>0;if(v.includes(I))return!0;const C=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!C)return!1;const[S,a,m]=C;return m==="*"?v.some(o=>o.startsWith(a+"/")):!1}e.UriList=Object.freeze({create:I=>(0,c.distinct)(I.map(v=>v.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.UriList.split(I).filter(v=>!v.startsWith("#"))})}),define(ye[173],_e([1,0,62]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=O,e.findFreePortFaster=T;function O(b,p,w,A=1){let I=!1;return new Promise(v=>{const C=setTimeout(()=>{if(!I)return I=!0,v(0)},w);L(b,p,A,S=>{if(!I)return I=!0,clearTimeout(C),v(S)})})}function L(b,p,w,A){if(p===0)return A(0);const I=new c.Socket;I.once("connect",()=>(R(I),L(b+w,p-1,w,A))),I.once("data",()=>{}),I.once("error",v=>(R(I),v.code!=="ECONNREFUSED"?L(b+w,p-1,w,A):A(b))),I.connect(b,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(b,p,w,A="127.0.0.1"){let I=!1,v,C=1;const S=c.createServer({pauseOnConnect:!0});function a(m,o){I||(I=!0,S.removeAllListeners(),S.close(),v&&clearTimeout(v),o(m))}return new Promise(m=>{v=setTimeout(()=>{a(0,m)},w),S.on("listening",()=>{a(b,m)}),S.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&C<p?(b++,C++,S.listen(b,A)):a(0,m)}),S.on("close",()=>{a(0,m)}),S.listen(b,A)})}function R(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(p){console.error(p)}}}),define(ye[128],_e([1,0,127]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class O{constructor(b){const p=(0,c.toUint8)(b);this._defaultValue=p,this._asciiMap=O._createAsciiMap(p),this._map=new Map}static _createAsciiMap(b){const p=new Uint8Array(256);return p.fill(b),p}set(b,p){const w=(0,c.toUint8)(p);b>=0&&b<256?this._asciiMap[b]=w:this._map.set(b,w)}get(b){return b>=0&&b<256?this._asciiMap[b]:this._map.get(b)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}e.CharacterClassifier=O;var L;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(L||(L={}));class T{constructor(){this._actual=new O(0)}add(b){this._actual.set(b,1)}has(b){return this._actual.get(b)===1}clear(){return this._actual.clear()}}e.CharacterSet=T}),define(ye[174],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.countEOL=O;var c;(function(L){L[L.Unknown=0]="Unknown",L[L.Invalid=3]="Invalid",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(c||(e.StringEOL=c={}));function O(L){let T=0,R=0,b=0,p=0;for(let w=0,A=L.length;w<A;w++){const I=L.charCodeAt(w);I===13?(T===0&&(R=w),T++,w+1<A&&L.charCodeAt(w+1)===10?(p|=2,w++):p|=3,b=w+1):I===10&&(p|=1,T===0&&(R=w),T++,b=w+1)}return T===0&&(R=L.length),[T,R,L.length-b,p]}}),define(ye[49],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class c{constructor(L,T){this.lineNumber=L,this.column=T}with(L=this.lineNumber,T=this.column){return L===this.lineNumber&&T===this.column?this:new c(L,T)}delta(L=0,T=0){return this.with(this.lineNumber+L,this.column+T)}equals(L){return c.equals(this,L)}static equals(L,T){return!L&&!T?!0:!!L&&!!T&&L.lineNumber===T.lineNumber&&L.column===T.column}isBefore(L){return c.isBefore(this,L)}static isBefore(L,T){return L.lineNumber<T.lineNumber?!0:T.lineNumber<L.lineNumber?!1:L.column<T.column}isBeforeOrEqual(L){return c.isBeforeOrEqual(this,L)}static isBeforeOrEqual(L,T){return L.lineNumber<T.lineNumber?!0:T.lineNumber<L.lineNumber?!1:L.column<=T.column}static compare(L,T){const R=L.lineNumber|0,b=T.lineNumber|0;if(R===b){const p=L.column|0,w=T.column|0;return p-w}return R-b}clone(){return new c(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(L){return new c(L.lineNumber,L.column)}static isIPosition(L){return L&&typeof L.lineNumber=="number"&&typeof L.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.Position=c}),define(ye[29],_e([1,0,49]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class O{constructor(T,R,b,p){T>b||T===b&&R>p?(this.startLineNumber=b,this.startColumn=p,this.endLineNumber=T,this.endColumn=R):(this.startLineNumber=T,this.startColumn=R,this.endLineNumber=b,this.endColumn=p)}isEmpty(){return O.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return O.containsPosition(this,T)}static containsPosition(T,R){return!(R.lineNumber<T.startLineNumber||R.lineNumber>T.endLineNumber||R.lineNumber===T.startLineNumber&&R.column<T.startColumn||R.lineNumber===T.endLineNumber&&R.column>T.endColumn)}static strictContainsPosition(T,R){return!(R.lineNumber<T.startLineNumber||R.lineNumber>T.endLineNumber||R.lineNumber===T.startLineNumber&&R.column<=T.startColumn||R.lineNumber===T.endLineNumber&&R.column>=T.endColumn)}containsRange(T){return O.containsRange(this,T)}static containsRange(T,R){return!(R.startLineNumber<T.startLineNumber||R.endLineNumber<T.startLineNumber||R.startLineNumber>T.endLineNumber||R.endLineNumber>T.endLineNumber||R.startLineNumber===T.startLineNumber&&R.startColumn<T.startColumn||R.endLineNumber===T.endLineNumber&&R.endColumn>T.endColumn)}strictContainsRange(T){return O.strictContainsRange(this,T)}static strictContainsRange(T,R){return!(R.startLineNumber<T.startLineNumber||R.endLineNumber<T.startLineNumber||R.startLineNumber>T.endLineNumber||R.endLineNumber>T.endLineNumber||R.startLineNumber===T.startLineNumber&&R.startColumn<=T.startColumn||R.endLineNumber===T.endLineNumber&&R.endColumn>=T.endColumn)}plusRange(T){return O.plusRange(this,T)}static plusRange(T,R){let b,p,w,A;return R.startLineNumber<T.startLineNumber?(b=R.startLineNumber,p=R.startColumn):R.startLineNumber===T.startLineNumber?(b=R.startLineNumber,p=Math.min(R.startColumn,T.startColumn)):(b=T.startLineNumber,p=T.startColumn),R.endLineNumber>T.endLineNumber?(w=R.endLineNumber,A=R.endColumn):R.endLineNumber===T.endLineNumber?(w=R.endLineNumber,A=Math.max(R.endColumn,T.endColumn)):(w=T.endLineNumber,A=T.endColumn),new O(b,p,w,A)}intersectRanges(T){return O.intersectRanges(this,T)}static intersectRanges(T,R){let b=T.startLineNumber,p=T.startColumn,w=T.endLineNumber,A=T.endColumn;const I=R.startLineNumber,v=R.startColumn,C=R.endLineNumber,S=R.endColumn;return b<I?(b=I,p=v):b===I&&(p=Math.max(p,v)),w>C?(w=C,A=S):w===C&&(A=Math.min(A,S)),b>w||b===w&&p>A?null:new O(b,p,w,A)}equalsRange(T){return O.equalsRange(this,T)}static equalsRange(T,R){return!T&&!R?!0:!!T&&!!R&&T.startLineNumber===R.startLineNumber&&T.startColumn===R.startColumn&&T.endLineNumber===R.endLineNumber&&T.endColumn===R.endColumn}getEndPosition(){return O.getEndPosition(this)}static getEndPosition(T){return new c.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return O.getStartPosition(this)}static getStartPosition(T){return new c.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,R){return new O(this.startLineNumber,this.startColumn,T,R)}setStartPosition(T,R){return new O(T,R,this.endLineNumber,this.endColumn)}collapseToStart(){return O.collapseToStart(this)}static collapseToStart(T){return new O(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}collapseToEnd(){return O.collapseToEnd(this)}static collapseToEnd(T){return new O(T.endLineNumber,T.endColumn,T.endLineNumber,T.endColumn)}delta(T){return new O(this.startLineNumber+T,this.startColumn,this.endLineNumber+T,this.endColumn)}static fromPositions(T,R=T){return new O(T.lineNumber,T.column,R.lineNumber,R.column)}static lift(T){return T?new O(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,R){return!(T.endLineNumber<R.startLineNumber||T.endLineNumber===R.startLineNumber&&T.endColumn<R.startColumn||R.endLineNumber<T.startLineNumber||R.endLineNumber===T.startLineNumber&&R.endColumn<T.startColumn)}static areIntersecting(T,R){return!(T.endLineNumber<R.startLineNumber||T.endLineNumber===R.startLineNumber&&T.endColumn<=R.startColumn||R.endLineNumber<T.startLineNumber||R.endLineNumber===T.startLineNumber&&R.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,R){if(T&&R){const w=T.startLineNumber|0,A=R.startLineNumber|0;if(w===A){const I=T.startColumn|0,v=R.startColumn|0;if(I===v){const C=T.endLineNumber|0,S=R.endLineNumber|0;if(C===S){const a=T.endColumn|0,m=R.endColumn|0;return a-m}return C-S}return I-v}return w-A}return(T?1:0)-(R?1:0)}static compareRangesUsingEnds(T,R){return T.endLineNumber===R.endLineNumber?T.endColumn===R.endColumn?T.startLineNumber===R.startLineNumber?T.startColumn-R.startColumn:T.startLineNumber-R.startLineNumber:T.endColumn-R.endColumn:T.endLineNumber-R.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}toJSON(){return this}}e.Range=O}),define(ye[175],_e([1,0,29]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditOperation=void 0;class O{static insert(T,R){return{range:new c.Range(T.lineNumber,T.column,T.lineNumber,T.column),text:R,forceMoveMarkers:!0}}static delete(T){return{range:T,text:null}}static replace(T,R){return{range:T,text:R}}static replaceMove(T,R){return{range:T,text:R,forceMoveMarkers:!0}}}e.EditOperation=O}),define(ye[176],_e([1,0,49,29]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var L;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(L||(e.SelectionDirection=L={}));class T extends O.Range{constructor(b,p,w,A){super(b,p,w,A),this.selectionStartLineNumber=b,this.selectionStartColumn=p,this.positionLineNumber=w,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return T.selectionsEqual(this,b)}static selectionsEqual(b,p){return b.selectionStartLineNumber===p.selectionStartLineNumber&&b.selectionStartColumn===p.selectionStartColumn&&b.positionLineNumber===p.positionLineNumber&&b.positionColumn===p.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,p){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,b,p):new T(b,p,this.startLineNumber,this.startColumn)}getPosition(){return new c.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new c.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,p){return this.getDirection()===0?new T(b,p,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,b,p)}static fromPositions(b,p=b){return new T(b.lineNumber,b.column,p.lineNumber,p.column)}static fromRange(b,p){return p===0?new T(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new T(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new T(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,p){if(b&&!p||!b&&p)return!1;if(!b&&!p)return!0;if(b.length!==p.length)return!1;for(let w=0,A=b.length;w<A;w++)if(!this.selectionsEqual(b[w],p[w]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,p,w,A,I){return I===0?new T(b,p,w,A):new T(w,A,b,p)}}e.Selection=T}),define(ye[177],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[178],_e([1,0,27,128]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WordCharacterClassifier=e.WordCharacterClass=void 0,e.getMapForWordSeparators=b;var L;(function(p){p[p.Regular=0]="Regular",p[p.Whitespace=1]="Whitespace",p[p.WordSeparator=2]="WordSeparator"})(L||(e.WordCharacterClass=L={}));class T extends O.CharacterClassifier{constructor(w,A){super(0),this._segmenter=null,this._cachedLine=null,this._cachedSegments=[],this.intlSegmenterLocales=A,this.intlSegmenterLocales.length>0?this._segmenter=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this._segmenter=null;for(let I=0,v=w.length;I<v;I++)this.set(w.charCodeAt(I),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(w,A){let I=null;for(const v of this._getIntlSegmenterWordsOnLine(w)){if(v.index>A)break;I=v}return I}findNextIntlWordAtOrAfterOffset(w,A){for(const I of this._getIntlSegmenterWordsOnLine(w))if(!(I.index<A))return I;return null}_getIntlSegmenterWordsOnLine(w){return this._segmenter?this._cachedLine===w?this._cachedSegments:(this._cachedLine=w,this._cachedSegments=this._filterWordSegments(this._segmenter.segment(w)),this._cachedSegments):[]}_filterWordSegments(w){const A=[];for(const I of w)this._isWordLike(I)&&A.push(I);return A}_isWordLike(w){return!!w.isWordLike}}e.WordCharacterClassifier=T;const R=new c.LRUCache(10);function b(p,w){const A=`${p}/${w.join(",")}`;let I=R.get(A);return I||(I=new T(p,w),R.set(A,I)),I}}),define(ye[129],_e([1,0,38,3,75]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.ensureValidWordDefinition=R,e.setDefaultGetWordAtTextConfig=p,e.getWordAtText=w,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function T(I=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)I.indexOf(C)>=0||(v+="\\"+C);return v+="\\s]+)",new RegExp(v,"g")}e.DEFAULT_WORD_REGEXP=T();function R(I){let v=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)v=I;else{let C="g";I.ignoreCase&&(C+="i"),I.multiline&&(C+="m"),I.unicode&&(C+="u"),v=new RegExp(I.source,C)}return v.lastIndex=0,v}const b=new L.LinkedList;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function p(I){const v=b.unshift(I);return(0,O.toDisposable)(v)}function w(I,v,C,S,a){if(v=R(v),a||(a=c.Iterable.first(b)),C.length>a.maxLen){let r=I-a.maxLen/2;return r<0?r=0:S+=r,C=C.substring(r,I+a.maxLen/2),w(I,v,C,S,a)}const m=Date.now(),o=I-1-S;let n=-1,i=null;for(let r=1;!(Date.now()-m>=a.timeBudget);r++){const s=o-a.windowSize*r;v.lastIndex=Math.max(0,s);const t=A(v,C,o,n);if(!t&&i||(i=t,s<=0))break;n=s}if(i){const r={word:i[0],startColumn:S+1+i.index,endColumn:S+1+i.index+i[0].length};return v.lastIndex=0,r}return null}function A(I,v,C,S){let a;for(;a=I.exec(v);){const m=a.index||0;if(m<=C&&I.lastIndex>=C)return a;if(S>0&&m>S)return null}return null}}),define(ye[179],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(c||(e.IndentAction=c={}));class O{constructor(b){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=b.open,this.close=b.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(b.notIn))for(let p=0,w=b.notIn.length;p<w;p++)switch(b.notIn[p]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(b,p){if(b.getTokenCount()===0)return!0;const w=b.findTokenIndexAtOffset(p-2),A=b.getStandardTokenType(w);return this.isOK(A)}_findNeutralCharacterInRange(b,p){for(let w=b;w<=p;w++){const A=String.fromCharCode(w);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=O;class L{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const p of b)T(this.autoClosingPairsOpenByStart,p.open.charAt(0),p),T(this.autoClosingPairsOpenByEnd,p.open.charAt(p.open.length-1),p),T(this.autoClosingPairsCloseByStart,p.close.charAt(0),p),T(this.autoClosingPairsCloseByEnd,p.close.charAt(p.close.length-1),p),p.close.length===1&&p.open.length===1&&T(this.autoClosingPairsCloseSingleChar,p.close,p)}}e.AutoClosingPairs=L;function T(R,b,p){R.has(b)?R.get(b).push(p):R.set(b,[p])}}),define(ye[180],_e([1,0,128]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkComputer=e.StateMachine=e.State=void 0,e.computeLinks=v;var O;(function(C){C[C.Invalid=0]="Invalid",C[C.Start=1]="Start",C[C.H=2]="H",C[C.HT=3]="HT",C[C.HTT=4]="HTT",C[C.HTTP=5]="HTTP",C[C.F=6]="F",C[C.FI=7]="FI",C[C.FIL=8]="FIL",C[C.BeforeColon=9]="BeforeColon",C[C.AfterColon=10]="AfterColon",C[C.AlmostThere=11]="AlmostThere",C[C.End=12]="End",C[C.Accept=13]="Accept",C[C.LastKnownState=14]="LastKnownState"})(O||(e.State=O={}));class L{constructor(S,a,m){const o=new Uint8Array(S*a);for(let n=0,i=S*a;n<i;n++)o[n]=m;this._data=o,this.rows=S,this.cols=a}get(S,a){return this._data[S*this.cols+a]}set(S,a,m){this._data[S*this.cols+a]=m}}class T{constructor(S){let a=0,m=0;for(let n=0,i=S.length;n<i;n++){const[r,s,t]=S[n];s>a&&(a=s),r>m&&(m=r),t>m&&(m=t)}a++,m++;const o=new L(m,a,0);for(let n=0,i=S.length;n<i;n++){const[r,s,t]=S[n];o.set(r,s,t)}this._states=o,this._maxCharCode=a}nextState(S,a){return a<0||a>=this._maxCharCode?0:this._states.get(S,a)}}e.StateMachine=T;let R=null;function b(){return R===null&&(R=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var p;(function(C){C[C.None=0]="None",C[C.ForceTermination=1]="ForceTermination",C[C.CannotEndIn=2]="CannotEndIn"})(p||(p={}));let w=null;function A(){if(w===null){w=new c.CharacterClassifier(0);const C=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let a=0;a<C.length;a++)w.set(C.charCodeAt(a),1);const S=".,;:";for(let a=0;a<S.length;a++)w.set(S.charCodeAt(a),2)}return w}class I{static _createLink(S,a,m,o,n){let i=n-1;do{const r=a.charCodeAt(i);if(S.get(r)!==2)break;i--}while(i>o);if(o>0){const r=a.charCodeAt(o-1),s=a.charCodeAt(i);(r===40&&s===41||r===91&&s===93||r===123&&s===125)&&i--}return{range:{startLineNumber:m,startColumn:o+1,endLineNumber:m,endColumn:i+2},url:a.substring(o,i+1)}}static computeLinks(S,a=b()){const m=A(),o=[];for(let n=1,i=S.getLineCount();n<=i;n++){const r=S.getLineContent(n),s=r.length;let t=0,f=0,h=0,l=1,u=!1,d=!1,g=!1,D=!1;for(;t<s;){let E=!1;const _=r.charCodeAt(t);if(l===13){let y;switch(_){case 40:u=!0,y=0;break;case 41:y=u?0:1;break;case 91:g=!0,d=!0,y=0;break;case 93:g=!1,y=d?0:1;break;case 123:D=!0,y=0;break;case 125:y=D?0:1;break;case 39:case 34:case 96:h===_?y=1:h===39||h===34||h===96?y=0:y=1;break;case 42:y=h===42?1:0;break;case 124:y=h===124?1:0;break;case 32:y=g?0:1;break;default:y=m.get(_)}y===1&&(o.push(I._createLink(m,r,n,f,t)),E=!0)}else if(l===12){let y;_===91?(d=!0,y=0):y=m.get(_),y===1?E=!0:l=13}else l=a.nextState(l,_),l===0&&(E=!0);E&&(l=1,u=!1,d=!1,D=!1,f=t+1,h=_),t++}l===13&&o.push(I._createLink(m,r,n,f,s))}return o}}e.LinkComputer=I;function v(C){return!C||typeof C.getLineCount!="function"||typeof C.getLineContent!="function"?[]:I.computeLinks(C)}}),define(ye[79],_e([1,0,24]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.isITextSnapshot=S,e.shouldSynchronizeModel=r;var O;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(O||(e.OverviewRulerLane=O={}));var L;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(L||(e.GlyphMarginLane=L={}));var T;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(T||(e.MinimapPosition=T={}));var R;(function(s){s[s.Normal=1]="Normal",s[s.Underlined=2]="Underlined"})(R||(e.MinimapSectionHeaderStyle=R={}));var b;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(b||(e.InjectedTextCursorStops=b={}));var p;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(p||(e.EndOfLinePreference=p={}));var w;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(w||(e.DefaultEndOfLine=w={}));var A;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(A||(e.EndOfLineSequence=A={}));class I{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,t.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this._indentSizeIsTabSize===t._indentSizeIsTabSize&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class v{constructor(t,f){this._findMatchBrand=void 0,this.range=t,this.matches=f}}e.FindMatch=v;var C;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C||(e.TrackedRangeStickiness=C={}));function S(s){return s&&typeof s.read=="function"}var a;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var m;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class o{constructor(t,f,h,l,u,d){this.identifier=t,this.range=f,this.text=h,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=u,this._isTracked=d}}e.ValidAnnotatedEditOperation=o;class n{constructor(t,f,h){this.regex=t,this.wordSeparators=f,this.simpleSearch=h}}e.SearchData=n;class i{constructor(t,f,h){this.reverseEdits=t,this.changes=f,this.trimAutoWhitespaceLineNumbers=h}}e.ApplyEditsResult=i;function r(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}}),define(ye[181],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SENTINEL=e.NodeColor=e.TreeNode=void 0,e.leftest=L,e.righttest=T,e.leftRotate=w,e.rightRotate=A,e.rbDelete=I,e.fixInsert=v,e.updateTreeMetadata=C,e.recomputeTreeMetadata=S;class c{constructor(m,o){this.piece=m,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.SENTINEL)return L(this.right);let m=this;for(;m.parent!==e.SENTINEL&&m.parent.left!==m;)m=m.parent;return m.parent===e.SENTINEL?e.SENTINEL:m.parent}prev(){if(this.left!==e.SENTINEL)return T(this.left);let m=this;for(;m.parent!==e.SENTINEL&&m.parent.right!==m;)m=m.parent;return m.parent===e.SENTINEL?e.SENTINEL:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.TreeNode=c;var O;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(O||(e.NodeColor=O={})),e.SENTINEL=new c(null,0),e.SENTINEL.parent=e.SENTINEL,e.SENTINEL.left=e.SENTINEL,e.SENTINEL.right=e.SENTINEL,e.SENTINEL.color=0;function L(a){for(;a.left!==e.SENTINEL;)a=a.left;return a}function T(a){for(;a.right!==e.SENTINEL;)a=a.right;return a}function R(a){return a===e.SENTINEL?0:a.size_left+a.piece.length+R(a.right)}function b(a){return a===e.SENTINEL?0:a.lf_left+a.piece.lineFeedCnt+b(a.right)}function p(){e.SENTINEL.parent=e.SENTINEL}function w(a,m){const o=m.right;o.size_left+=m.size_left+(m.piece?m.piece.length:0),o.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=o.left,o.left!==e.SENTINEL&&(o.left.parent=m),o.parent=m.parent,m.parent===e.SENTINEL?a.root=o:m.parent.left===m?m.parent.left=o:m.parent.right=o,o.left=m,m.parent=o}function A(a,m){const o=m.left;m.left=o.right,o.right!==e.SENTINEL&&(o.right.parent=m),o.parent=m.parent,m.size_left-=o.size_left+(o.piece?o.piece.length:0),m.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),m.parent===e.SENTINEL?a.root=o:m===m.parent.right?m.parent.right=o:m.parent.left=o,o.right=m,m.parent=o}function I(a,m){let o,n;if(m.left===e.SENTINEL?(n=m,o=n.right):m.right===e.SENTINEL?(n=m,o=n.left):(n=L(m.right),o=n.right),n===a.root){a.root=o,o.color=0,m.detach(),p(),a.root.parent=e.SENTINEL;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=o:n.parent.right=o,n===m?(o.parent=n.parent,S(a,o)):(n.parent===m?o.parent=n:o.parent=n.parent,S(a,o),n.left=m.left,n.right=m.right,n.parent=m.parent,n.color=m.color,m===a.root?a.root=n:m===m.parent.left?m.parent.left=n:m.parent.right=n,n.left!==e.SENTINEL&&(n.left.parent=n),n.right!==e.SENTINEL&&(n.right.parent=n),n.size_left=m.size_left,n.lf_left=m.lf_left,S(a,n)),m.detach(),o.parent.left===o){const s=R(o),t=b(o);if(s!==o.parent.size_left||t!==o.parent.lf_left){const f=s-o.parent.size_left,h=t-o.parent.lf_left;o.parent.size_left=s,o.parent.lf_left=t,C(a,o.parent,f,h)}}if(S(a,o.parent),i){p();return}let r;for(;o!==a.root&&o.color===0;)o===o.parent.left?(r=o.parent.right,r.color===1&&(r.color=0,o.parent.color=1,w(a,o.parent),r=o.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.right.color===0&&(r.left.color=0,r.color=1,A(a,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=0,r.right.color=0,w(a,o.parent),o=a.root)):(r=o.parent.left,r.color===1&&(r.color=0,o.parent.color=1,A(a,o.parent),r=o.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.left.color===0&&(r.right.color=0,r.color=1,w(a,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=0,r.left.color=0,A(a,o.parent),o=a.root));o.color=0,p()}function v(a,m){for(S(a,m);m!==a.root&&m.parent.color===1;)if(m.parent===m.parent.parent.left){const o=m.parent.parent.right;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,w(a,m)),m.parent.color=0,m.parent.parent.color=1,A(a,m.parent.parent))}else{const o=m.parent.parent.left;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,A(a,m)),m.parent.color=0,m.parent.parent.color=1,w(a,m.parent.parent))}a.root.color=0}function C(a,m,o,n){for(;m!==a.root&&m!==e.SENTINEL;)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=n),m=m.parent}function S(a,m){let o=0,n=0;if(m!==a.root){for(;m!==a.root&&m===m.parent.right;)m=m.parent;if(m!==a.root)for(m=m.parent,o=R(m.left)-m.size_left,n=b(m.left)-m.lf_left,m.size_left+=o,m.lf_left+=n;m!==a.root&&(o!==0||n!==0);)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=n),m=m.parent}}}),define(ye[182],_e([1,0,19,127]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class L{constructor(p){this.values=p,this.prefixSum=new Uint32Array(p.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(p,w){p=(0,O.toUint32)(p);const A=this.values,I=this.prefixSum,v=w.length;return v===0?!1:(this.values=new Uint32Array(A.length+v),this.values.set(A.subarray(0,p),0),this.values.set(A.subarray(p),p+v),this.values.set(w,p),p-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=p-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(p,w){return p=(0,O.toUint32)(p),w=(0,O.toUint32)(w),this.values[p]===w?!1:(this.values[p]=w,p-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=p-1),!0)}removeValues(p,w){p=(0,O.toUint32)(p),w=(0,O.toUint32)(w);const A=this.values,I=this.prefixSum;if(p>=A.length)return!1;const v=A.length-p;return w>=v&&(w=v),w===0?!1:(this.values=new Uint32Array(A.length-w),this.values.set(A.subarray(0,p),0),this.values.set(A.subarray(p+w),p),this.prefixSum=new Uint32Array(this.values.length),p-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=p-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(p){return p<0?0:(p=(0,O.toUint32)(p),this._getPrefixSum(p))}_getPrefixSum(p){if(p<=this.prefixSumValidIndex[0])return this.prefixSum[p];let w=this.prefixSumValidIndex[0]+1;w===0&&(this.prefixSum[0]=this.values[0],w++),p>=this.values.length&&(p=this.values.length-1);for(let A=w;A<=p;A++)this.prefixSum[A]=this.prefixSum[A-1]+this.values[A];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],p),this.prefixSum[p]}getIndexOf(p){p=Math.floor(p),this.getTotalSum();let w=0,A=this.values.length-1,I=0,v=0,C=0;for(;w<=A;)if(I=w+(A-w)/2|0,v=this.prefixSum[I],C=v-this.values[I],p<C)A=I-1;else if(p>=v)w=I+1;else break;return new R(I,p-C)}}e.PrefixSumComputer=L;class T{constructor(p){this._values=p,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(p){return this._ensureValid(),p===0?0:this._prefixSum[p-1]}getIndexOf(p){this._ensureValid();const w=this._indexBySum[p],A=w>0?this._prefixSum[w-1]:0;return new R(w,p-A)}removeValues(p,w){this._values.splice(p,w),this._invalidate(p)}insertValues(p,w){this._values=(0,c.arrayInsert)(this._values,p,w),this._invalidate(p)}_invalidate(p){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,p-1)}_ensureValid(){if(!this._isValid){for(let p=this._validEndIndex+1,w=this._values.length;p<w;p++){const A=this._values[p],I=p>0?this._prefixSum[p-1]:0;this._prefixSum[p]=I+A;for(let v=0;v<A;v++)this._indexBySum[I+v]=p}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(p,w){this._values[p]!==w&&(this._values[p]=w,this._invalidate(p))}}e.ConstantTimePrefixSumComputer=T;class R{constructor(p,w){this.index=p,this.remainder=w,this._prefixSumIndexOfResultBrand=void 0,this.index=p,this.remainder=w}}e.PrefixSumIndexOfResult=R}),define(ye[183],_e([1,0,14,49,182]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(b,p,w,A){this._uri=b,this._lines=p,this._eol=w,this._versionId=A,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(b){b.eol&&b.eol!==this._eol&&(this._eol=b.eol,this._lineStarts=null);const p=b.changes;for(const w of p)this._acceptDeleteRange(w.range),this._acceptInsertText(new O.Position(w.range.startLineNumber,w.range.startColumn),w.text);this._versionId=b.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const b=this._eol.length,p=this._lines.length,w=new Uint32Array(p);for(let A=0;A<p;A++)w[A]=this._lines[A].length+b;this._lineStarts=new L.PrefixSumComputer(w)}}_setLineText(b,p){this._lines[b]=p,this._lineStarts&&this._lineStarts.setValue(b,this._lines[b].length+this._eol.length)}_acceptDeleteRange(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this._setLineText(b.startLineNumber-1,this._lines[b.startLineNumber-1].substring(0,b.startColumn-1)+this._lines[b.startLineNumber-1].substring(b.endColumn-1));return}this._setLineText(b.startLineNumber-1,this._lines[b.startLineNumber-1].substring(0,b.startColumn-1)+this._lines[b.endLineNumber-1].substring(b.endColumn-1)),this._lines.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}_acceptInsertText(b,p){if(p.length===0)return;const w=(0,c.splitLines)(p);if(w.length===1){this._setLineText(b.lineNumber-1,this._lines[b.lineNumber-1].substring(0,b.column-1)+w[0]+this._lines[b.lineNumber-1].substring(b.column-1));return}w[w.length-1]+=this._lines[b.lineNumber-1].substring(b.column-1),this._setLineText(b.lineNumber-1,this._lines[b.lineNumber-1].substring(0,b.column-1)+w[0]);const A=new Uint32Array(w.length-1);for(let I=1;I<w.length;I++)this._lines.splice(b.lineNumber+I-1,0,w[I]),A[I-1]=w[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(b.lineNumber,A)}}e.MirrorTextModel=T}),define(ye[100],_e([1,0,14,178,49,29,79]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.TextModelSearch=e.SearchParams=void 0,e.isMultilineRegexSource=w,e.createFindMatch=A,e.isValidMatch=a;const b=999;class p{constructor(n,i,r,s){this.searchString=n,this.isRegex=i,this.matchCase=r,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=w(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let r=!this.isRegex&&!n;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new R.SearchData(i,this.wordSeparators?(0,O.getMapForWordSeparators)(this.wordSeparators,[]):null,r?this.searchString:null)}}e.SearchParams=p;function w(o){if(!o||o.length===0)return!1;for(let n=0,i=o.length;n<i;n++){const r=o.charCodeAt(n);if(r===10)return!0;if(r===92){if(n++,n>=i)break;const s=o.charCodeAt(n);if(s===110||s===114||s===87)return!0}}return!1}function A(o,n,i){if(!i)return new R.FindMatch(o,null);const r=[];for(let s=0,t=n.length;s<t;s++)r[s]=n[s];return new R.FindMatch(o,r)}class I{constructor(n){const i=[];let r=0;for(let s=0,t=n.length;s<t;s++)n.charCodeAt(s)===10&&(i[r++]=s);this._lineFeedsOffsets=i}findLineFeedCountBeforeOffset(n){const i=this._lineFeedsOffsets;let r=0,s=i.length-1;if(s===-1||n<=i[0])return 0;for(;r<s;){const t=r+((s-r)/2>>0);i[t]>=n?s=t-1:i[t+1]>=n?(r=t,s=t):r=t+1}return r+1}}class v{static findMatches(n,i,r,s,t){const f=i.parseSearchRequest();return f?f.regex.multiline?this._doFindMatchesMultiline(n,r,new m(f.wordSeparators,f.regex),s,t):this._doFindMatchesLineByLine(n,r,f,s,t):[]}static _getMultilineMatchRange(n,i,r,s,t,f){let h,l=0;s?(l=s.findLineFeedCountBeforeOffset(t),h=i+t+l):h=i+t;let u;if(s){const E=s.findLineFeedCountBeforeOffset(t+f.length)-l;u=h+f.length+E}else u=h+f.length;const d=n.getPositionAt(h),g=n.getPositionAt(u);return new T.Range(d.lineNumber,d.column,g.lineNumber,g.column)}static _doFindMatchesMultiline(n,i,r,s,t){const f=n.getOffsetAt(i.getStartPosition()),h=n.getValueInRange(i,1),l=n.getEOL()===`\r
`?new I(h):null,u=[];let d=0,g;for(r.reset(0);g=r.next(h);)if(u[d++]=A(this._getMultilineMatchRange(n,f,h,l,g.index,g[0]),g,s),d>=t)return u;return u}static _doFindMatchesLineByLine(n,i,r,s,t){const f=[];let h=0;if(i.startLineNumber===i.endLineNumber){const u=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return h=this._findMatchesInLine(r,u,i.startLineNumber,i.startColumn-1,h,f,s,t),f}const l=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);h=this._findMatchesInLine(r,l,i.startLineNumber,i.startColumn-1,h,f,s,t);for(let u=i.startLineNumber+1;u<i.endLineNumber&&h<t;u++)h=this._findMatchesInLine(r,n.getLineContent(u),u,0,h,f,s,t);if(h<t){const u=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);h=this._findMatchesInLine(r,u,i.endLineNumber,0,h,f,s,t)}return f}static _findMatchesInLine(n,i,r,s,t,f,h,l){const u=n.wordSeparators;if(!h&&n.simpleSearch){const D=n.simpleSearch,E=D.length,_=i.length;let y=-E;for(;(y=i.indexOf(D,y+E))!==-1;)if((!u||a(u,i,_,y,E))&&(f[t++]=new R.FindMatch(new T.Range(r,y+1+s,r,y+1+E+s),null),t>=l))return t;return t}const d=new m(n.wordSeparators,n.regex);let g;d.reset(0);do if(g=d.next(i),g&&(f[t++]=A(new T.Range(r,g.index+1+s,r,g.index+1+g[0].length+s),g,h),t>=l))return t;while(g);return t}static findNextMatch(n,i,r,s){const t=i.parseSearchRequest();if(!t)return null;const f=new m(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindNextMatchMultiline(n,r,f,s):this._doFindNextMatchLineByLine(n,r,f,s)}static _doFindNextMatchMultiline(n,i,r,s){const t=new L.Position(i.lineNumber,1),f=n.getOffsetAt(t),h=n.getLineCount(),l=n.getValueInRange(new T.Range(t.lineNumber,t.column,h,n.getLineMaxColumn(h)),1),u=n.getEOL()===`\r
`?new I(l):null;r.reset(i.column-1);const d=r.next(l);return d?A(this._getMultilineMatchRange(n,f,l,u,d.index,d[0]),d,s):i.lineNumber!==1||i.column!==1?this._doFindNextMatchMultiline(n,new L.Position(1,1),r,s):null}static _doFindNextMatchLineByLine(n,i,r,s){const t=n.getLineCount(),f=i.lineNumber,h=n.getLineContent(f),l=this._findFirstMatchInLine(r,h,f,i.column,s);if(l)return l;for(let u=1;u<=t;u++){const d=(f+u-1)%t,g=n.getLineContent(d+1),D=this._findFirstMatchInLine(r,g,d+1,1,s);if(D)return D}return null}static _findFirstMatchInLine(n,i,r,s,t){n.reset(s-1);const f=n.next(i);return f?A(new T.Range(r,f.index+1,r,f.index+1+f[0].length),f,t):null}static findPreviousMatch(n,i,r,s){const t=i.parseSearchRequest();if(!t)return null;const f=new m(t.wordSeparators,t.regex);return t.regex.multiline?this._doFindPreviousMatchMultiline(n,r,f,s):this._doFindPreviousMatchLineByLine(n,r,f,s)}static _doFindPreviousMatchMultiline(n,i,r,s){const t=this._doFindMatchesMultiline(n,new T.Range(1,1,i.lineNumber,i.column),r,s,10*b);if(t.length>0)return t[t.length-1];const f=n.getLineCount();return i.lineNumber!==f||i.column!==n.getLineMaxColumn(f)?this._doFindPreviousMatchMultiline(n,new L.Position(f,n.getLineMaxColumn(f)),r,s):null}static _doFindPreviousMatchLineByLine(n,i,r,s){const t=n.getLineCount(),f=i.lineNumber,h=n.getLineContent(f).substring(0,i.column-1),l=this._findLastMatchInLine(r,h,f,s);if(l)return l;for(let u=1;u<=t;u++){const d=(t+f-u-1)%t,g=n.getLineContent(d+1),D=this._findLastMatchInLine(r,g,d+1,s);if(D)return D}return null}static _findLastMatchInLine(n,i,r,s){let t=null,f;for(n.reset(0);f=n.next(i);)t=A(new T.Range(r,f.index+1,r,f.index+1+f[0].length),f,s);return t}}e.TextModelSearch=v;function C(o,n,i,r,s){if(r===0)return!0;const t=n.charCodeAt(r-1);if(o.get(t)!==0||t===13||t===10)return!0;if(s>0){const f=n.charCodeAt(r);if(o.get(f)!==0)return!0}return!1}function S(o,n,i,r,s){if(r+s===i)return!0;const t=n.charCodeAt(r+s);if(o.get(t)!==0||t===13||t===10)return!0;if(s>0){const f=n.charCodeAt(r+s-1);if(o.get(f)!==0)return!0}return!1}function a(o,n,i,r,s){return C(o,n,i,r,s)&&S(o,n,i,r,s)}class m{constructor(n,i){this._wordSeparators=n,this._searchRegex=i,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(n){this._searchRegex.lastIndex=n,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(n){const i=n.length;let r;do{if(this._prevMatchStartIndex+this._prevMatchLength===i||(r=this._searchRegex.exec(n),!r))return null;const s=r.index,t=r[0].length;if(s===this._prevMatchStartIndex&&t===this._prevMatchLength){if(t===0){c.getNextCodePoint(n,i,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=s,this._prevMatchLength=t,!this._wordSeparators||a(this._wordSeparators,n,i,s,t))return r}while(r);return null}}e.Searcher=m}),define(ye[130],_e([1,0,49,29,79,181,100]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeBase=e.StringBuffer=e.Piece=void 0,e.createLineStartsFast=A,e.createLineStarts=I;const b=65535;function p(o){let n;return o[o.length-1]<65536?n=new Uint16Array(o.length):n=new Uint32Array(o.length),n.set(o,0),n}class w{constructor(n,i,r,s,t){this.lineStarts=n,this.cr=i,this.lf=r,this.crlf=s,this.isBasicASCII=t}}function A(o,n=!0){const i=[0];let r=1;for(let s=0,t=o.length;s<t;s++){const f=o.charCodeAt(s);f===13?s+1<t&&o.charCodeAt(s+1)===10?(i[r++]=s+2,s++):i[r++]=s+1:f===10&&(i[r++]=s+1)}return n?p(i):i}function I(o,n){o.length=0,o[0]=0;let i=1,r=0,s=0,t=0,f=!0;for(let l=0,u=n.length;l<u;l++){const d=n.charCodeAt(l);d===13?l+1<u&&n.charCodeAt(l+1)===10?(t++,o[i++]=l+2,l++):(r++,o[i++]=l+1):d===10?(s++,o[i++]=l+1):f&&d!==9&&(d<32||d>126)&&(f=!1)}const h=new w(p(o),r,s,t,f);return o.length=0,h}class v{constructor(n,i,r,s,t){this.bufferIndex=n,this.start=i,this.end=r,this.lineFeedCnt=s,this.length=t}}e.Piece=v;class C{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.StringBuffer=C;class S{constructor(n,i){this._pieces=[],this._tree=n,this._BOM=i,this._index=0,n.root!==T.SENTINEL&&n.iterate(n.root,r=>(r!==T.SENTINEL&&this._pieces.push(r.piece),!0))}read(){return this._pieces.length===0?this._index===0?(this._index++,this._BOM):null:this._index>this._pieces.length-1?null:this._index===0?this._BOM+this._tree.getPieceContent(this._pieces[this._index++]):this._tree.getPieceContent(this._pieces[this._index++])}}class a{constructor(n){this._limit=n,this._cache=[]}get(n){for(let i=this._cache.length-1;i>=0;i--){const r=this._cache[i];if(r.nodeStartOffset<=n&&r.nodeStartOffset+r.node.piece.length>=n)return r}return null}get2(n){for(let i=this._cache.length-1;i>=0;i--){const r=this._cache[i];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<n&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=n)return r}return null}set(n){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(n)}validate(n){let i=!1;const r=this._cache;for(let s=0;s<r.length;s++){const t=r[s];if(t.node.parent===null||t.nodeStartOffset>=n){r[s]=null,i=!0;continue}}if(i){const s=[];for(const t of r)t!==null&&s.push(t);this._cache=s}}}class m{constructor(n,i,r){this.create(n,i,r)}create(n,i,r){this._buffers=[new C("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=T.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=i,this._EOLLength=i.length,this._EOLNormalized=r;let s=null;for(let t=0,f=n.length;t<f;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=A(n[t].buffer));const h=new v(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this._buffers.push(n[t]),s=this.rbInsertRight(s,h)}this._searchCache=new a(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()}normalizeEOL(n){const i=b,r=i-Math.floor(i/3),s=r*2;let t="",f=0;const h=[];if(this.iterate(this.root,l=>{const u=this.getNodeContent(l),d=u.length;if(f<=r||f+d<s)return t+=u,f+=d,!0;const g=t.replace(/\r\n|\r|\n/g,n);return h.push(new C(g,A(g))),t=u,f=d,!0}),f>0){const l=t.replace(/\r\n|\r|\n/g,n);h.push(new C(l,A(l)))}this.create(h,n,!0)}getEOL(){return this._EOL}setEOL(n){this._EOL=n,this._EOLLength=this._EOL.length,this.normalizeEOL(n)}createSnapshot(n){return new S(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,s=>{if(s===T.SENTINEL)return!0;const t=this.getNodeContent(s),f=t.length,h=n.nodeAt(i),l=n.nodeAt(i+f),u=n.getValueInRange2(h,l);return i+=f,t===u})}getOffsetAt(n,i){let r=0,s=this.root;for(;s!==T.SENTINEL;)if(s.left!==T.SENTINEL&&s.lf_left+1>=n)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt+1>=n){r+=s.size_left;const t=this.getAccumulatedValue(s,n-s.lf_left-2);return r+=t+i-1}else n-=s.lf_left+s.piece.lineFeedCnt,r+=s.size_left+s.piece.length,s=s.right;return r}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,r=0;const s=n;for(;i!==T.SENTINEL;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.getIndexOf(i,n-i.size_left);if(r+=i.lf_left+t.index,t.index===0){const f=this.getOffsetAt(r+1,1),h=s-f;return new c.Position(r+1,h+1)}return new c.Position(r+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,r+=i.lf_left+i.piece.lineFeedCnt,i.right===T.SENTINEL){const t=this.getOffsetAt(r+1,1),f=s-n-t;return new c.Position(r+1,f+1)}else i=i.right;return new c.Position(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const r=this.nodeAt2(n.startLineNumber,n.startColumn),s=this.nodeAt2(n.endLineNumber,n.endColumn),t=this.getValueInRange2(r,s);return i?i!==this._EOL||!this._EOLNormalized?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this._EOLNormalized?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const h=n.node,l=this._buffers[h.piece.bufferIndex].buffer,u=this.offsetInBuffer(h.piece.bufferIndex,h.piece.start);return l.substring(u+n.remainder,u+i.remainder)}let r=n.node;const s=this._buffers[r.piece.bufferIndex].buffer,t=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start);let f=s.substring(t+n.remainder,t+r.piece.length);for(r=r.next();r!==T.SENTINEL;){const h=this._buffers[r.piece.bufferIndex].buffer,l=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start);if(r===i.node){f+=h.substring(l,l+i.remainder);break}else f+=h.substr(l,r.piece.length);r=r.next()}return f}getLinesContent(){const n=[];let i=0,r="",s=!1;return this.iterate(this.root,t=>{if(t===T.SENTINEL)return!0;const f=t.piece;let h=f.length;if(h===0)return!0;const l=this._buffers[f.bufferIndex].buffer,u=this._buffers[f.bufferIndex].lineStarts,d=f.start.line,g=f.end.line;let D=u[d]+f.start.column;if(s&&(l.charCodeAt(D)===10&&(D++,h--),n[i++]=r,r="",s=!1,h===0))return!0;if(d===g)return!this._EOLNormalized&&l.charCodeAt(D+h-1)===13?(s=!0,r+=l.substr(D,h-1)):r+=l.substr(D,h),!0;r+=this._EOLNormalized?l.substring(D,Math.max(D,u[d+1]-this._EOLLength)):l.substring(D,u[d+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;for(let E=d+1;E<g;E++)r=this._EOLNormalized?l.substring(u[E],u[E+1]-this._EOLLength):l.substring(u[E],u[E+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;return!this._EOLNormalized&&l.charCodeAt(u[g]+f.end.column-1)===13?(s=!0,f.end.column===0?i--:r=l.substr(u[g],f.end.column-1)):r=l.substr(u[g],f.end.column),!0}),s&&(n[i++]=r,r=""),n[i++]=r,n}getLength(){return this._length}getLineCount(){return this._lineCnt}getLineContent(n){return this._lastVisitedLine.lineNumber===n?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=n,n===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(n):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(n,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)}_getCharCode(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const r=this._buffers[i.piece.bufferIndex],s=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start);return r.buffer.charCodeAt(s)}else{const i=this._buffers[n.node.piece.bufferIndex],s=this.offsetInBuffer(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(s)}}getLineCharCode(n,i){const r=this.nodeAt2(n,i+1);return this._getCharCode(r)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this._EOLLength}getCharCode(n){const i=this.nodeAt(n);return this._getCharCode(i)}findMatchesInNode(n,i,r,s,t,f,h,l,u,d,g){const D=this._buffers[n.piece.bufferIndex],E=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start),_=this.offsetInBuffer(n.piece.bufferIndex,t),y=this.offsetInBuffer(n.piece.bufferIndex,f);let P;const k={line:0,column:0};let z,x;i._wordSeparators?(z=D.buffer.substring(_,y),x=F=>F+_,i.reset(0)):(z=D.buffer,x=F=>F,i.reset(_));do if(P=i.next(z),P){if(x(P.index)>=y)return d;this.positionInBuffer(n,x(P.index)-E,k);const F=this.getLineFeedCnt(n.piece.bufferIndex,t,k),N=k.line===t.line?k.column-t.column+s:k.column+1,M=N+P[0].length;if(g[d++]=(0,R.createFindMatch)(new O.Range(r+F,N,r+F,M),P,l),x(P.index)+P[0].length>=y||d>=u)return d}while(P);return d}findMatchesLineByLine(n,i,r,s){const t=[];let f=0;const h=new R.Searcher(i.wordSeparators,i.regex);let l=this.nodeAt2(n.startLineNumber,n.startColumn);if(l===null)return[];const u=this.nodeAt2(n.endLineNumber,n.endColumn);if(u===null)return[];let d=this.positionInBuffer(l.node,l.remainder);const g=this.positionInBuffer(u.node,u.remainder);if(l.node===u.node)return this.findMatchesInNode(l.node,h,n.startLineNumber,n.startColumn,d,g,i,r,s,f,t),t;let D=n.startLineNumber,E=l.node;for(;E!==u.node;){const y=this.getLineFeedCnt(E.piece.bufferIndex,d,E.piece.end);if(y>=1){const k=this._buffers[E.piece.bufferIndex].lineStarts,z=this.offsetInBuffer(E.piece.bufferIndex,E.piece.start),x=k[d.line+y],F=D===n.startLineNumber?n.startColumn:1;if(f=this.findMatchesInNode(E,h,D,F,d,this.positionInBuffer(E,x-z),i,r,s,f,t),f>=s)return t;D+=y}const P=D===n.startLineNumber?n.startColumn-1:0;if(D===n.endLineNumber){const k=this.getLineContent(D).substring(P,n.endColumn-1);return f=this._findMatchesInLine(i,h,k,n.endLineNumber,P,f,t,r,s),t}if(f=this._findMatchesInLine(i,h,this.getLineContent(D).substr(P),D,P,f,t,r,s),f>=s)return t;D++,l=this.nodeAt2(D,1),E=l.node,d=this.positionInBuffer(l.node,l.remainder)}if(D===n.endLineNumber){const y=D===n.startLineNumber?n.startColumn-1:0,P=this.getLineContent(D).substring(y,n.endColumn-1);return f=this._findMatchesInLine(i,h,P,n.endLineNumber,y,f,t,r,s),t}const _=D===n.startLineNumber?n.startColumn:1;return f=this.findMatchesInNode(u.node,h,D,_,d,g,i,r,s,f,t),t}_findMatchesInLine(n,i,r,s,t,f,h,l,u){const d=n.wordSeparators;if(!l&&n.simpleSearch){const D=n.simpleSearch,E=D.length,_=r.length;let y=-E;for(;(y=r.indexOf(D,y+E))!==-1;)if((!d||(0,R.isValidMatch)(d,r,_,y,E))&&(h[f++]=new L.FindMatch(new O.Range(s,y+1+t,s,y+1+E+t),null),f>=u))return f;return f}let g;i.reset(0);do if(g=i.next(r),g&&(h[f++]=(0,R.createFindMatch)(new O.Range(s,g.index+1+t,s,g.index+1+g[0].length+t),g,l),f>=u))return f;while(g);return f}insert(n,i,r=!1){if(this._EOLNormalized=this._EOLNormalized&&r,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==T.SENTINEL){const{node:s,remainder:t,nodeStartOffset:f}=this.nodeAt(n),h=s.piece,l=h.bufferIndex,u=this.positionInBuffer(s,t);if(s.piece.bufferIndex===0&&h.end.line===this._lastChangeBufferPos.line&&h.end.column===this._lastChangeBufferPos.column&&f+h.length===n&&i.length<b){this.appendToNode(s,i),this.computeBufferMetadata();return}if(f===n)this.insertContentToNodeLeft(i,s),this._searchCache.validate(n);else if(f+s.piece.length>n){const d=[];let g=new v(h.bufferIndex,u,h.end,this.getLineFeedCnt(h.bufferIndex,u,h.end),this.offsetInBuffer(l,h.end)-this.offsetInBuffer(l,u));if(this.shouldCheckCRLF()&&this.endWithCR(i)&&this.nodeCharCodeAt(s,t)===10){const y={line:g.start.line+1,column:0};g=new v(g.bufferIndex,y,g.end,this.getLineFeedCnt(g.bufferIndex,y,g.end),g.length-1),i+=`
`}if(this.shouldCheckCRLF()&&this.startWithLF(i))if(this.nodeCharCodeAt(s,t-1)===13){const y=this.positionInBuffer(s,t-1);this.deleteNodeTail(s,y),i="\r"+i,s.piece.length===0&&d.push(s)}else this.deleteNodeTail(s,u);else this.deleteNodeTail(s,u);const D=this.createNewPieces(i);g.length>0&&this.rbInsertRight(s,g);let E=s;for(let _=0;_<D.length;_++)E=this.rbInsertRight(E,D[_]);this.deleteNodes(d)}else this.insertContentToNodeRight(i,s)}else{const s=this.createNewPieces(i);let t=this.rbInsertLeft(null,s[0]);for(let f=1;f<s.length;f++)t=this.rbInsertRight(t,s[f])}this.computeBufferMetadata()}delete(n,i){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",i<=0||this.root===T.SENTINEL)return;const r=this.nodeAt(n),s=this.nodeAt(n+i),t=r.node,f=s.node;if(t===f){const D=this.positionInBuffer(t,r.remainder),E=this.positionInBuffer(t,s.remainder);if(r.nodeStartOffset===n){if(i===t.piece.length){const _=t.next();(0,T.rbDelete)(this,t),this.validateCRLFWithPrevNode(_),this.computeBufferMetadata();return}this.deleteNodeHead(t,E),this._searchCache.validate(n),this.validateCRLFWithPrevNode(t),this.computeBufferMetadata();return}if(r.nodeStartOffset+t.piece.length===n+i){this.deleteNodeTail(t,D),this.validateCRLFWithNextNode(t),this.computeBufferMetadata();return}this.shrinkNode(t,D,E),this.computeBufferMetadata();return}const h=[],l=this.positionInBuffer(t,r.remainder);this.deleteNodeTail(t,l),this._searchCache.validate(n),t.piece.length===0&&h.push(t);const u=this.positionInBuffer(f,s.remainder);this.deleteNodeHead(f,u),f.piece.length===0&&h.push(f);const d=t.next();for(let D=d;D!==T.SENTINEL&&D!==f;D=D.next())h.push(D);const g=t.piece.length===0?t.prev():t;this.deleteNodes(h),this.validateCRLFWithNextNode(g),this.computeBufferMetadata()}insertContentToNodeLeft(n,i){const r=[];if(this.shouldCheckCRLF()&&this.endWithCR(n)&&this.startWithLF(i)){const f=i.piece,h={line:f.start.line+1,column:0},l=new v(f.bufferIndex,h,f.end,this.getLineFeedCnt(f.bufferIndex,h,f.end),f.length-1);i.piece=l,n+=`
`,(0,T.updateTreeMetadata)(this,i,-1,-1),i.piece.length===0&&r.push(i)}const s=this.createNewPieces(n);let t=this.rbInsertLeft(i,s[s.length-1]);for(let f=s.length-2;f>=0;f--)t=this.rbInsertLeft(t,s[f]);this.validateCRLFWithPrevNode(t),this.deleteNodes(r)}insertContentToNodeRight(n,i){this.adjustCarriageReturnFromNext(n,i)&&(n+=`
`);const r=this.createNewPieces(n),s=this.rbInsertRight(i,r[0]);let t=s;for(let f=1;f<r.length;f++)t=this.rbInsertRight(t,r[f]);this.validateCRLFWithPrevNode(s)}positionInBuffer(n,i,r){const s=n.piece,t=n.piece.bufferIndex,f=this._buffers[t].lineStarts,l=f[s.start.line]+s.start.column+i;let u=s.start.line,d=s.end.line,g=0,D=0,E=0;for(;u<=d&&(g=u+(d-u)/2|0,E=f[g],g!==d);)if(D=f[g+1],l<E)d=g-1;else if(l>=D)u=g+1;else break;return r?(r.line=g,r.column=l-E,null):{line:g,column:l-E}}getLineFeedCnt(n,i,r){if(r.column===0)return r.line-i.line;const s=this._buffers[n].lineStarts;if(r.line===s.length-1)return r.line-i.line;const t=s[r.line+1],f=s[r.line]+r.column;if(t>f+1)return r.line-i.line;const h=f-1;return this._buffers[n].buffer.charCodeAt(h)===13?r.line-i.line+1:r.line-i.line}offsetInBuffer(n,i){return this._buffers[n].lineStarts[i.line]+i.column}deleteNodes(n){for(let i=0;i<n.length;i++)(0,T.rbDelete)(this,n[i])}createNewPieces(n){if(n.length>b){const d=[];for(;n.length>b;){const D=n.charCodeAt(b-1);let E;D===13||D>=55296&&D<=56319?(E=n.substring(0,b-1),n=n.substring(b-1)):(E=n.substring(0,b),n=n.substring(b));const _=A(E);d.push(new v(this._buffers.length,{line:0,column:0},{line:_.length-1,column:E.length-_[_.length-1]},_.length-1,E.length)),this._buffers.push(new C(E,_))}const g=A(n);return d.push(new v(this._buffers.length,{line:0,column:0},{line:g.length-1,column:n.length-g[g.length-1]},g.length-1,n.length)),this._buffers.push(new C(n,g)),d}let i=this._buffers[0].buffer.length;const r=A(n,!1);let s=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===i&&i!==0&&this.startWithLF(n)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},s=this._lastChangeBufferPos;for(let d=0;d<r.length;d++)r[d]+=i+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(r.slice(1)),this._buffers[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let d=0;d<r.length;d++)r[d]+=i;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(r.slice(1)),this._buffers[0].buffer+=n}const t=this._buffers[0].buffer.length,f=this._buffers[0].lineStarts.length-1,h=t-this._buffers[0].lineStarts[f],l={line:f,column:h},u=new v(0,s,l,this.getLineFeedCnt(0,s,l),t-i);return this._lastChangeBufferPos=l,[u]}getLinesRawContent(){return this.getContentOfSubTree(this.root)}getLineRawContent(n,i=0){let r=this.root,s="";const t=this._searchCache.get2(n);if(t){r=t.node;const f=this.getAccumulatedValue(r,n-t.nodeStartLineNumber-1),h=this._buffers[r.piece.bufferIndex].buffer,l=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===n)s=h.substring(l+f,l+r.piece.length);else{const u=this.getAccumulatedValue(r,n-t.nodeStartLineNumber);return h.substring(l+f,l+u-i)}}else{let f=0;const h=n;for(;r!==T.SENTINEL;)if(r.left!==T.SENTINEL&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const l=this.getAccumulatedValue(r,n-r.lf_left-2),u=this.getAccumulatedValue(r,n-r.lf_left-1),d=this._buffers[r.piece.bufferIndex].buffer,g=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start);return f+=r.size_left,this._searchCache.set({node:r,nodeStartOffset:f,nodeStartLineNumber:h-(n-1-r.lf_left)}),d.substring(g+l,g+u-i)}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const l=this.getAccumulatedValue(r,n-r.lf_left-2),u=this._buffers[r.piece.bufferIndex].buffer,d=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start);s=u.substring(d+l,d+r.piece.length);break}else n-=r.lf_left+r.piece.lineFeedCnt,f+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==T.SENTINEL;){const f=this._buffers[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const h=this.getAccumulatedValue(r,0),l=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start);return s+=f.substring(l,l+h-i),s}else{const h=this.offsetInBuffer(r.piece.bufferIndex,r.piece.start);s+=f.substr(h,r.piece.length)}r=r.next()}return s}computeBufferMetadata(){let n=this.root,i=1,r=0;for(;n!==T.SENTINEL;)i+=n.lf_left+n.piece.lineFeedCnt,r+=n.size_left+n.piece.length,n=n.right;this._lineCnt=i,this._length=r,this._searchCache.validate(this._length)}getIndexOf(n,i){const r=n.piece,s=this.positionInBuffer(n,i),t=s.line-r.start.line;if(this.offsetInBuffer(r.bufferIndex,r.end)-this.offsetInBuffer(r.bufferIndex,r.start)===i){const f=this.getLineFeedCnt(n.piece.bufferIndex,r.start,s);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:s.column}}getAccumulatedValue(n,i){if(i<0)return 0;const r=n.piece,s=this._buffers[r.bufferIndex].lineStarts,t=r.start.line+i+1;return t>r.end.line?s[r.end.line]+r.end.column-s[r.start.line]-r.start.column:s[t]-s[r.start.line]-r.start.column}deleteNodeTail(n,i){const r=n.piece,s=r.lineFeedCnt,t=this.offsetInBuffer(r.bufferIndex,r.end),f=i,h=this.offsetInBuffer(r.bufferIndex,f),l=this.getLineFeedCnt(r.bufferIndex,r.start,f),u=l-s,d=h-t,g=r.length+d;n.piece=new v(r.bufferIndex,r.start,f,l,g),(0,T.updateTreeMetadata)(this,n,d,u)}deleteNodeHead(n,i){const r=n.piece,s=r.lineFeedCnt,t=this.offsetInBuffer(r.bufferIndex,r.start),f=i,h=this.getLineFeedCnt(r.bufferIndex,f,r.end),l=this.offsetInBuffer(r.bufferIndex,f),u=h-s,d=t-l,g=r.length+d;n.piece=new v(r.bufferIndex,f,r.end,h,g),(0,T.updateTreeMetadata)(this,n,d,u)}shrinkNode(n,i,r){const s=n.piece,t=s.start,f=s.end,h=s.length,l=s.lineFeedCnt,u=i,d=this.getLineFeedCnt(s.bufferIndex,s.start,u),g=this.offsetInBuffer(s.bufferIndex,i)-this.offsetInBuffer(s.bufferIndex,t);n.piece=new v(s.bufferIndex,s.start,u,d,g),(0,T.updateTreeMetadata)(this,n,g-h,d-l);const D=new v(s.bufferIndex,r,f,this.getLineFeedCnt(s.bufferIndex,r,f),this.offsetInBuffer(s.bufferIndex,f)-this.offsetInBuffer(s.bufferIndex,r)),E=this.rbInsertRight(n,D);this.validateCRLFWithPrevNode(E)}appendToNode(n,i){this.adjustCarriageReturnFromNext(i,n)&&(i+=`
`);const r=this.shouldCheckCRLF()&&this.startWithLF(i)&&this.endWithCR(n),s=this._buffers[0].buffer.length;this._buffers[0].buffer+=i;const t=A(i,!1);for(let E=0;E<t.length;E++)t[E]+=s;if(r){const E=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:s-E}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1));const f=this._buffers[0].lineStarts.length-1,h=this._buffers[0].buffer.length-this._buffers[0].lineStarts[f],l={line:f,column:h},u=n.piece.length+i.length,d=n.piece.lineFeedCnt,g=this.getLineFeedCnt(0,n.piece.start,l),D=g-d;n.piece=new v(n.piece.bufferIndex,n.piece.start,l,g,u),this._lastChangeBufferPos=l,(0,T.updateTreeMetadata)(this,n,i.length,D)}nodeAt(n){let i=this.root;const r=this._searchCache.get(n);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:n-r.nodeStartOffset};let s=0;for(;i!==T.SENTINEL;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){s+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:s};return this._searchCache.set(t),t}else n-=i.size_left+i.piece.length,s+=i.size_left+i.piece.length,i=i.right;return null}nodeAt2(n,i){let r=this.root,s=0;for(;r!==T.SENTINEL;)if(r.left!==T.SENTINEL&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const t=this.getAccumulatedValue(r,n-r.lf_left-2),f=this.getAccumulatedValue(r,n-r.lf_left-1);return s+=r.size_left,{node:r,remainder:Math.min(t+i-1,f),nodeStartOffset:s}}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const t=this.getAccumulatedValue(r,n-r.lf_left-2);if(t+i-1<=r.piece.length)return{node:r,remainder:t+i-1,nodeStartOffset:s};i-=r.piece.length-t;break}else n-=r.lf_left+r.piece.lineFeedCnt,s+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==T.SENTINEL;){if(r.piece.lineFeedCnt>0){const t=this.getAccumulatedValue(r,0),f=this.offsetOfNode(r);return{node:r,remainder:Math.min(i-1,t),nodeStartOffset:f}}else if(r.piece.length>=i-1){const t=this.offsetOfNode(r);return{node:r,remainder:i-1,nodeStartOffset:t}}else i-=r.piece.length;r=r.next()}return null}nodeCharCodeAt(n,i){if(n.piece.lineFeedCnt<1)return-1;const r=this._buffers[n.piece.bufferIndex],s=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start)+i;return r.buffer.charCodeAt(s)}offsetOfNode(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}shouldCheckCRLF(){return!(this._EOLNormalized&&this._EOL===`
`)}startWithLF(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===T.SENTINEL||n.piece.lineFeedCnt===0)return!1;const i=n.piece,r=this._buffers[i.bufferIndex].lineStarts,s=i.start.line,t=r[s]+i.start.column;return s===r.length-1||r[s+1]>t+1?!1:this._buffers[i.bufferIndex].buffer.charCodeAt(t)===10}endWithCR(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===T.SENTINEL||n.piece.lineFeedCnt===0?!1:this.nodeCharCodeAt(n,n.piece.length-1)===13}validateCRLFWithPrevNode(n){if(this.shouldCheckCRLF()&&this.startWithLF(n)){const i=n.prev();this.endWithCR(i)&&this.fixCRLF(i,n)}}validateCRLFWithNextNode(n){if(this.shouldCheckCRLF()&&this.endWithCR(n)){const i=n.next();this.startWithLF(i)&&this.fixCRLF(n,i)}}fixCRLF(n,i){const r=[],s=this._buffers[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:s[n.piece.end.line]-s[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const f=n.piece.length-1,h=n.piece.lineFeedCnt-1;n.piece=new v(n.piece.bufferIndex,n.piece.start,t,h,f),(0,T.updateTreeMetadata)(this,n,-1,-1),n.piece.length===0&&r.push(n);const l={line:i.piece.start.line+1,column:0},u=i.piece.length-1,d=this.getLineFeedCnt(i.piece.bufferIndex,l,i.piece.end);i.piece=new v(i.piece.bufferIndex,l,i.piece.end,d,u),(0,T.updateTreeMetadata)(this,i,-1,-1),i.piece.length===0&&r.push(i);const g=this.createNewPieces(`\r
`);this.rbInsertRight(n,g[0]);for(let D=0;D<r.length;D++)(0,T.rbDelete)(this,r[D])}adjustCarriageReturnFromNext(n,i){if(this.shouldCheckCRLF()&&this.endWithCR(n)){const r=i.next();if(this.startWithLF(r)){if(n+=`
`,r.piece.length===1)(0,T.rbDelete)(this,r);else{const s=r.piece,t={line:s.start.line+1,column:0},f=s.length-1,h=this.getLineFeedCnt(s.bufferIndex,t,s.end);r.piece=new v(s.bufferIndex,t,s.end,h,f),(0,T.updateTreeMetadata)(this,r,-1,-1)}return!0}}return!1}iterate(n,i){if(n===T.SENTINEL)return i(T.SENTINEL);const r=this.iterate(n.left,i);return r&&i(n)&&this.iterate(n.right,i)}getNodeContent(n){if(n===T.SENTINEL)return"";const i=this._buffers[n.piece.bufferIndex],r=n.piece,s=this.offsetInBuffer(r.bufferIndex,r.start),t=this.offsetInBuffer(r.bufferIndex,r.end);return i.buffer.substring(s,t)}getPieceContent(n){const i=this._buffers[n.bufferIndex],r=this.offsetInBuffer(n.bufferIndex,n.start),s=this.offsetInBuffer(n.bufferIndex,n.end);return i.buffer.substring(r,s)}rbInsertRight(n,i){const r=new T.TreeNode(i,1);if(r.left=T.SENTINEL,r.right=T.SENTINEL,r.parent=T.SENTINEL,r.size_left=0,r.lf_left=0,this.root===T.SENTINEL)this.root=r,r.color=0;else if(n.right===T.SENTINEL)n.right=r,r.parent=n;else{const t=(0,T.leftest)(n.right);t.left=r,r.parent=t}return(0,T.fixInsert)(this,r),r}rbInsertLeft(n,i){const r=new T.TreeNode(i,1);if(r.left=T.SENTINEL,r.right=T.SENTINEL,r.parent=T.SENTINEL,r.size_left=0,r.lf_left=0,this.root===T.SENTINEL)this.root=r,r.color=0;else if(n.left===T.SENTINEL)n.left=r,r.parent=n;else{const s=(0,T.righttest)(n.left);s.right=r,r.parent=s}return(0,T.fixInsert)(this,r),r}getContentOfSubTree(n){let i="";return this.iterate(n,r=>(i+=this.getNodeContent(r),!0)),i}}e.PieceTreeBase=m}),define(ye[184],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class c{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(T){if(T&&this._dragOperations.has(T)){const R=this._dragOperations.get(T);return this._dragOperations.delete(T),R}}addDragOperationTransfer(T,R){this._dragOperations.set(T,R)}}e.TreeViewsDnDService=c;class O{constructor(T){this.identifier=T}}e.DraggedTreeItemsIdentifier=O}),define(ye[185],_e([1,0,4,3]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class L{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new c.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(b){this._onDidChange.fire({changedLanguages:b,changedColorMap:!1})}register(b,p){return this._tokenizationSupports.set(b,p),this.handleChange([b]),(0,O.toDisposable)(()=>{this._tokenizationSupports.get(b)===p&&(this._tokenizationSupports.delete(b),this.handleChange([b]))})}get(b){return this._tokenizationSupports.get(b)||null}registerFactory(b,p){this._factories.get(b)?.dispose();const w=new T(this,b,p);return this._factories.set(b,w),(0,O.toDisposable)(()=>{const A=this._factories.get(b);!A||A!==w||(this._factories.delete(b),A.dispose())})}async getOrCreate(b){const p=this.get(b);if(p)return p;const w=this._factories.get(b);return!w||w.isResolved?null:(await w.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const w=this._factories.get(b);return!!(!w||w.isResolved)}setColorMap(b){this._colorMap=b,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=L;class T extends O.Disposable{get isResolved(){return this._isResolved}constructor(b,p,w){super(),this._registry=b,this._languageId=p,this._factory=w,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const b=await this._factory.tokenizationSupport;this._isResolved=!0,b&&!this._isDisposed&&this._register(this._registry.register(this._languageId,b))}}}),define(ye[186],_e([9,10]),function(de,e){return de.create("vs/base/common/actions",e)}),define(ye[187],_e([1,0,4,3,186]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0,e.toAction=A;class T extends O.Disposable{constructor(v,C="",S="",a=!0,m){super(),this._onDidChange=this._register(new c.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=v,this._label=C,this._cssClass=S,this._enabled=a,this._actionCallback=m}get id(){return this._id}get label(){return this._label}set label(v){this._setLabel(v)}_setLabel(v){this._label!==v&&(this._label=v,this._onDidChange.fire({label:v}))}get tooltip(){return this._tooltip||""}set tooltip(v){this._setTooltip(v)}_setTooltip(v){this._tooltip!==v&&(this._tooltip=v,this._onDidChange.fire({tooltip:v}))}get class(){return this._cssClass}set class(v){this._setClass(v)}_setClass(v){this._cssClass!==v&&(this._cssClass=v,this._onDidChange.fire({class:v}))}get enabled(){return this._enabled}set enabled(v){this._setEnabled(v)}_setEnabled(v){this._enabled!==v&&(this._enabled=v,this._onDidChange.fire({enabled:v}))}get checked(){return this._checked}set checked(v){this._setChecked(v)}_setChecked(v){this._checked!==v&&(this._checked=v,this._onDidChange.fire({checked:v}))}async run(v,C){this._actionCallback&&await this._actionCallback(v)}}e.Action=T;class R extends O.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new c.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new c.Emitter),this.onDidRun=this._onDidRun.event}async run(v,C){if(!v.enabled)return;this._onWillRun.fire({action:v});let S;try{await this.runAction(v,C)}catch(a){S=a}this._onDidRun.fire({action:v,error:S})}async runAction(v,C){await v.run(C)}}e.ActionRunner=R;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let C=[];for(const S of v)S.length&&(C.length?C=[...C,new b,...S]:C=S);return C}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=b;class p{get actions(){return this._actions}constructor(v,C,S,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=C,this.class=a,this._actions=S}async run(){}}e.SubmenuAction=p;class w extends T{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,L.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=w;function A(I){return{id:I.id,label:I.label,class:I.class,enabled:I.enabled??!0,checked:I.checked,run:async(...v)=>I.run(...v),tooltip:I.label}}}),define(ye[188],_e([9,10]),function(de,e){return de.create("vs/base/common/date",e)}),define(ye[189],_e([1,0,188]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=w,e.getDurationString=A,e.toLocalISOString=I;const O=60,L=O*60,T=L*24,R=T*7,b=T*30,p=T*365;function w(v,C,S,a){typeof v!="number"&&(v=v.getTime());const m=Math.round((new Date().getTime()-v)/1e3);if(m<-30)return(0,c.localize)(0,null,w(new Date().getTime()+m*1e3,!1));if(!a&&m<30)return(0,c.localize)(1,null);let o;return m<O?(o=m,C?o===1?S?(0,c.localize)(2,null,o):(0,c.localize)(3,null,o):S?(0,c.localize)(4,null,o):(0,c.localize)(5,null,o):o===1?S?(0,c.localize)(6,null,o):(0,c.localize)(7,null,o):S?(0,c.localize)(8,null,o):(0,c.localize)(9,null,o)):m<L?(o=Math.floor(m/O),C?o===1?S?(0,c.localize)(10,null,o):(0,c.localize)(11,null,o):S?(0,c.localize)(12,null,o):(0,c.localize)(13,null,o):o===1?S?(0,c.localize)(14,null,o):(0,c.localize)(15,null,o):S?(0,c.localize)(16,null,o):(0,c.localize)(17,null,o)):m<T?(o=Math.floor(m/L),C?o===1?S?(0,c.localize)(18,null,o):(0,c.localize)(19,null,o):S?(0,c.localize)(20,null,o):(0,c.localize)(21,null,o):o===1?S?(0,c.localize)(22,null,o):(0,c.localize)(23,null,o):S?(0,c.localize)(24,null,o):(0,c.localize)(25,null,o)):m<R?(o=Math.floor(m/T),C?o===1?(0,c.localize)(26,null,o):(0,c.localize)(27,null,o):o===1?(0,c.localize)(28,null,o):(0,c.localize)(29,null,o)):m<b?(o=Math.floor(m/R),C?o===1?S?(0,c.localize)(30,null,o):(0,c.localize)(31,null,o):S?(0,c.localize)(32,null,o):(0,c.localize)(33,null,o):o===1?S?(0,c.localize)(34,null,o):(0,c.localize)(35,null,o):S?(0,c.localize)(36,null,o):(0,c.localize)(37,null,o)):m<p?(o=Math.floor(m/b),C?o===1?S?(0,c.localize)(38,null,o):(0,c.localize)(39,null,o):S?(0,c.localize)(40,null,o):(0,c.localize)(41,null,o):o===1?S?(0,c.localize)(42,null,o):(0,c.localize)(43,null,o):S?(0,c.localize)(44,null,o):(0,c.localize)(45,null,o)):(o=Math.floor(m/p),C?o===1?S?(0,c.localize)(46,null,o):(0,c.localize)(47,null,o):S?(0,c.localize)(48,null,o):(0,c.localize)(49,null,o):o===1?S?(0,c.localize)(50,null,o):(0,c.localize)(51,null,o):S?(0,c.localize)(52,null,o):(0,c.localize)(53,null,o))}function A(v,C){const S=Math.abs(v/1e3);return S<1?C?(0,c.localize)(54,null,v):(0,c.localize)(55,null,v):S<O?C?(0,c.localize)(56,null,Math.round(v)/1e3):(0,c.localize)(57,null,Math.round(v)/1e3):S<L?C?(0,c.localize)(58,null,Math.round(v/(1e3*O))):(0,c.localize)(59,null,Math.round(v/(1e3*O))):S<T?C?(0,c.localize)(60,null,Math.round(v/(1e3*L))):(0,c.localize)(61,null,Math.round(v/(1e3*L))):(0,c.localize)(62,null,Math.round(v/(1e3*T)))}function I(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ye[190],_e([9,10]),function(de,e){return de.create("vs/base/common/errorMessage",e)}),define(ye[47],_e([1,0,19,18,190]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=p,e.isErrorWithActions=w,e.createErrorWithActions=A;function T(I,v){return v&&(I.stack||I.stacktrace)?L.localize(0,null,b(I),R(I.stack)||R(I.stacktrace)):b(I)}function R(I){return Array.isArray(I)?I.join(`
`):I}function b(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?L.localize(1,null,I.message):I.message||L.localize(2,null)}function p(I=null,v=!1){if(!I)return L.localize(3,null);if(Array.isArray(I)){const C=c.coalesce(I),S=p(C[0],v);return C.length>1?L.localize(4,null,S,C.length):S}if(O.isString(I))return I;if(I.detail){const C=I.detail;if(C.error)return T(C.error,v);if(C.exception)return T(C.exception,v)}return I.stack?T(I,v):I.message?I.message:L.localize(5,null)}function w(I){const v=I;return v instanceof Error&&Array.isArray(v.actions)}function A(I,v){let C;return typeof I=="string"?C=new Error(I):C=I,C.actions=v,C}}),define(ye[191],_e([9,10]),function(de,e){return de.create("vs/base/common/platform",e)}),define(ye[11],_e([1,0,191]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=f,e.isLittleEndian=D,e.isBigSurOrNewer=E,e.LANGUAGE_DEFAULT="en";let O=!1,L=!1,T=!1,R=!1,b=!1,p=!1,w=!1,A=!1,I=!1,v=!1,C,S=e.LANGUAGE_DEFAULT,a=e.LANGUAGE_DEFAULT,m,o;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const r=typeof i?.versions?.electron=="string",s=r&&i?.type==="renderer";if(typeof i=="object"){O=i.platform==="win32",L=i.platform==="darwin",T=i.platform==="linux",R=T&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,w=r,I=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=e.LANGUAGE_DEFAULT,S=e.LANGUAGE_DEFAULT;const _=i.env.VSCODE_NLS_CONFIG;if(_)try{const y=JSON.parse(_),P=y.availableLanguages["*"];C=y.locale,a=y.osLocale,S=P||e.LANGUAGE_DEFAULT,m=y._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!s?(o=navigator.userAgent,O=o.indexOf("Windows")>=0,L=o.indexOf("Macintosh")>=0,A=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=o.indexOf("Linux")>=0,v=o?.indexOf("Mobi")>=0,p=!0,C=c.getConfiguredDefaultLocale(c.localize(0,null))||e.LANGUAGE_DEFAULT,S=C,a=navigator.language):console.error("Unable to resolve platform.");var t;(function(_){_[_.Web=0]="Web",_[_.Mac=1]="Mac",_[_.Linux=2]="Linux",_[_.Windows=3]="Windows"})(t||(e.Platform=t={}));function f(_){switch(_){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let h=0;L?h=1:O?h=3:T&&(h=2),e.isWindows=O,e.isMacintosh=L,e.isLinux=T,e.isLinuxSnap=R,e.isNative=b,e.isElectron=w,e.isWeb=p,e.isWebWorker=p&&typeof n.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?n.origin:void 0,e.isIOS=A,e.isMobile=v,e.isCI=I,e.platform=h,e.userAgent=o,e.language=S;var l;(function(_){function y(){return e.language}_.value=y;function P(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}_.isDefaultVariant=P;function k(){return e.language==="en"}_.isDefault=k})(l||(e.Language=l={})),e.locale=C,e.platformLocale=a,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof n.postMessage=="function"&&!n.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const _=[];n.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let k=0,z=_.length;k<z;k++){const x=_[k];if(x.id===P.data.vscodeScheduleAsyncWork){_.splice(k,1),x.callback();return}}});let y=0;return P=>{const k=++y;_.push({id:k,callback:P}),n.postMessage({vscodeScheduleAsyncWork:k},"*")}}return _=>setTimeout(_)})();var u;(function(_){_[_.Windows=1]="Windows",_[_.Macintosh=2]="Macintosh",_[_.Linux=3]="Linux"})(u||(e.OperatingSystem=u={})),e.OS=L||A?2:O?1:3;let d=!0,g=!1;function D(){if(!g){g=!0;const _=new Uint8Array(2);_[0]=1,_[1]=2,d=new Uint16Array(_.buffer)[0]===513}return d}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function E(_){return parseFloat(_)>=20}}),define(ye[50],_e([1,0,11]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let O;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const T=L.process;O={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return c.isWindows?"win32":c.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.platform=O.platform,e.arch=O.arch}),define(ye[17],_e([1,0,50]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const O=65,L=97,T=90,R=122,b=46,p=47,w=92,A=58,I=63;class v extends Error{constructor(f,h,l){let u;typeof h=="string"&&h.indexOf("not ")===0?(u="must not be",h=h.replace(/^not /,"")):u="must be";const d=f.indexOf(".")!==-1?"property":"argument";let g=`The "${f}" ${d} ${u} of type ${h}`;g+=`. Received type ${typeof l}`,super(g),this.code="ERR_INVALID_ARG_TYPE"}}function C(t,f){if(t===null||typeof t!="object")throw new v(f,"Object",t)}function S(t,f){if(typeof t!="string")throw new v(f,"string",t)}const a=c.platform==="win32";function m(t){return t===p||t===w}function o(t){return t===p}function n(t){return t>=O&&t<=T||t>=L&&t<=R}function i(t,f,h,l){let u="",d=0,g=-1,D=0,E=0;for(let _=0;_<=t.length;++_){if(_<t.length)E=t.charCodeAt(_);else{if(l(E))break;E=p}if(l(E)){if(!(g===_-1||D===1))if(D===2){if(u.length<2||d!==2||u.charCodeAt(u.length-1)!==b||u.charCodeAt(u.length-2)!==b){if(u.length>2){const y=u.lastIndexOf(h);y===-1?(u="",d=0):(u=u.slice(0,y),d=u.length-1-u.lastIndexOf(h)),g=_,D=0;continue}else if(u.length!==0){u="",d=0,g=_,D=0;continue}}f&&(u+=u.length>0?`${h}..`:"..",d=2)}else u.length>0?u+=`${h}${t.slice(g+1,_)}`:u=t.slice(g+1,_),d=_-g-1;g=_,D=0}else E===b&&D!==-1?++D:D=-1}return u}function r(t,f){C(f,"pathObject");const h=f.dir||f.root,l=f.base||`${f.name||""}${f.ext||""}`;return h?h===f.root?`${h}${l}`:`${h}${t}${l}`:l}e.win32={resolve(...t){let f="",h="",l=!1;for(let u=t.length-1;u>=-1;u--){let d;if(u>=0){if(d=t[u],S(d,"path"),d.length===0)continue}else f.length===0?d=c.cwd():(d=c.env[`=${f}`]||c.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==f.toLowerCase()&&d.charCodeAt(2)===w)&&(d=`${f}\\`));const g=d.length;let D=0,E="",_=!1;const y=d.charCodeAt(0);if(g===1)m(y)&&(D=1,_=!0);else if(m(y))if(_=!0,m(d.charCodeAt(1))){let P=2,k=P;for(;P<g&&!m(d.charCodeAt(P));)P++;if(P<g&&P!==k){const z=d.slice(k,P);for(k=P;P<g&&m(d.charCodeAt(P));)P++;if(P<g&&P!==k){for(k=P;P<g&&!m(d.charCodeAt(P));)P++;(P===g||P!==k)&&(E=`\\\\${z}\\${d.slice(k,P)}`,D=P)}}}else D=1;else n(y)&&d.charCodeAt(1)===A&&(E=d.slice(0,2),D=2,g>2&&m(d.charCodeAt(2))&&(_=!0,D=3));if(E.length>0)if(f.length>0){if(E.toLowerCase()!==f.toLowerCase())continue}else f=E;if(l){if(f.length>0)break}else if(h=`${d.slice(D)}\\${h}`,l=_,_&&f.length>0)break}return h=i(h,!l,"\\",m),l?`${f}\\${h}`:`${f}${h}`||"."},normalize(t){S(t,"path");const f=t.length;if(f===0)return".";let h=0,l,u=!1;const d=t.charCodeAt(0);if(f===1)return o(d)?"\\":t;if(m(d))if(u=!0,m(t.charCodeAt(1))){let D=2,E=D;for(;D<f&&!m(t.charCodeAt(D));)D++;if(D<f&&D!==E){const _=t.slice(E,D);for(E=D;D<f&&m(t.charCodeAt(D));)D++;if(D<f&&D!==E){for(E=D;D<f&&!m(t.charCodeAt(D));)D++;if(D===f)return`\\\\${_}\\${t.slice(E)}\\`;D!==E&&(l=`\\\\${_}\\${t.slice(E,D)}`,h=D)}}}else h=1;else n(d)&&t.charCodeAt(1)===A&&(l=t.slice(0,2),h=2,f>2&&m(t.charCodeAt(2))&&(u=!0,h=3));let g=h<f?i(t.slice(h),!u,"\\",m):"";return g.length===0&&!u&&(g="."),g.length>0&&m(t.charCodeAt(f-1))&&(g+="\\"),l===void 0?u?`\\${g}`:g:u?`${l}\\${g}`:`${l}${g}`},isAbsolute(t){S(t,"path");const f=t.length;if(f===0)return!1;const h=t.charCodeAt(0);return m(h)||f>2&&n(h)&&t.charCodeAt(1)===A&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let f,h;for(let d=0;d<t.length;++d){const g=t[d];S(g,"path"),g.length>0&&(f===void 0?f=h=g:f+=`\\${g}`)}if(f===void 0)return".";let l=!0,u=0;if(typeof h=="string"&&m(h.charCodeAt(0))){++u;const d=h.length;d>1&&m(h.charCodeAt(1))&&(++u,d>2&&(m(h.charCodeAt(2))?++u:l=!1))}if(l){for(;u<f.length&&m(f.charCodeAt(u));)u++;u>=2&&(f=`\\${f.slice(u)}`)}return e.win32.normalize(f)},relative(t,f){if(S(t,"from"),S(f,"to"),t===f)return"";const h=e.win32.resolve(t),l=e.win32.resolve(f);if(h===l||(t=h.toLowerCase(),f=l.toLowerCase(),t===f))return"";let u=0;for(;u<t.length&&t.charCodeAt(u)===w;)u++;let d=t.length;for(;d-1>u&&t.charCodeAt(d-1)===w;)d--;const g=d-u;let D=0;for(;D<f.length&&f.charCodeAt(D)===w;)D++;let E=f.length;for(;E-1>D&&f.charCodeAt(E-1)===w;)E--;const _=E-D,y=g<_?g:_;let P=-1,k=0;for(;k<y;k++){const x=t.charCodeAt(u+k);if(x!==f.charCodeAt(D+k))break;x===w&&(P=k)}if(k!==y){if(P===-1)return l}else{if(_>y){if(f.charCodeAt(D+k)===w)return l.slice(D+k+1);if(k===2)return l.slice(D+k)}g>y&&(t.charCodeAt(u+k)===w?P=k:k===2&&(P=3)),P===-1&&(P=0)}let z="";for(k=u+P+1;k<=d;++k)(k===d||t.charCodeAt(k)===w)&&(z+=z.length===0?"..":"\\..");return D+=P,z.length>0?`${z}${l.slice(D,E)}`:(l.charCodeAt(D)===w&&++D,l.slice(D,E))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const f=e.win32.resolve(t);if(f.length<=2)return t;if(f.charCodeAt(0)===w){if(f.charCodeAt(1)===w){const h=f.charCodeAt(2);if(h!==I&&h!==b)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(n(f.charCodeAt(0))&&f.charCodeAt(1)===A&&f.charCodeAt(2)===w)return`\\\\?\\${f}`;return t},dirname(t){S(t,"path");const f=t.length;if(f===0)return".";let h=-1,l=0;const u=t.charCodeAt(0);if(f===1)return m(u)?t:".";if(m(u)){if(h=l=1,m(t.charCodeAt(1))){let D=2,E=D;for(;D<f&&!m(t.charCodeAt(D));)D++;if(D<f&&D!==E){for(E=D;D<f&&m(t.charCodeAt(D));)D++;if(D<f&&D!==E){for(E=D;D<f&&!m(t.charCodeAt(D));)D++;if(D===f)return t;D!==E&&(h=l=D+1)}}}}else n(u)&&t.charCodeAt(1)===A&&(h=f>2&&m(t.charCodeAt(2))?3:2,l=h);let d=-1,g=!0;for(let D=f-1;D>=l;--D)if(m(t.charCodeAt(D))){if(!g){d=D;break}}else g=!1;if(d===-1){if(h===-1)return".";d=h}return t.slice(0,d)},basename(t,f){f!==void 0&&S(f,"ext"),S(t,"path");let h=0,l=-1,u=!0,d;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(h=2),f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let g=f.length-1,D=-1;for(d=t.length-1;d>=h;--d){const E=t.charCodeAt(d);if(m(E)){if(!u){h=d+1;break}}else D===-1&&(u=!1,D=d+1),g>=0&&(E===f.charCodeAt(g)?--g===-1&&(l=d):(g=-1,l=D))}return h===l?l=D:l===-1&&(l=t.length),t.slice(h,l)}for(d=t.length-1;d>=h;--d)if(m(t.charCodeAt(d))){if(!u){h=d+1;break}}else l===-1&&(u=!1,l=d+1);return l===-1?"":t.slice(h,l)},extname(t){S(t,"path");let f=0,h=-1,l=0,u=-1,d=!0,g=0;t.length>=2&&t.charCodeAt(1)===A&&n(t.charCodeAt(0))&&(f=l=2);for(let D=t.length-1;D>=f;--D){const E=t.charCodeAt(D);if(m(E)){if(!d){l=D+1;break}continue}u===-1&&(d=!1,u=D+1),E===b?h===-1?h=D:g!==1&&(g=1):h!==-1&&(g=-1)}return h===-1||u===-1||g===0||g===1&&h===u-1&&h===l+1?"":t.slice(h,u)},format:r.bind(null,"\\"),parse(t){S(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const h=t.length;let l=0,u=t.charCodeAt(0);if(h===1)return m(u)?(f.root=f.dir=t,f):(f.base=f.name=t,f);if(m(u)){if(l=1,m(t.charCodeAt(1))){let P=2,k=P;for(;P<h&&!m(t.charCodeAt(P));)P++;if(P<h&&P!==k){for(k=P;P<h&&m(t.charCodeAt(P));)P++;if(P<h&&P!==k){for(k=P;P<h&&!m(t.charCodeAt(P));)P++;P===h?l=P:P!==k&&(l=P+1)}}}}else if(n(u)&&t.charCodeAt(1)===A){if(h<=2)return f.root=f.dir=t,f;if(l=2,m(t.charCodeAt(2))){if(h===3)return f.root=f.dir=t,f;l=3}}l>0&&(f.root=t.slice(0,l));let d=-1,g=l,D=-1,E=!0,_=t.length-1,y=0;for(;_>=l;--_){if(u=t.charCodeAt(_),m(u)){if(!E){g=_+1;break}continue}D===-1&&(E=!1,D=_+1),u===b?d===-1?d=_:y!==1&&(y=1):d!==-1&&(y=-1)}return D!==-1&&(d===-1||y===0||y===1&&d===D-1&&d===g+1?f.base=f.name=t.slice(g,D):(f.name=t.slice(g,d),f.base=t.slice(g,D),f.ext=t.slice(d,D))),g>0&&g!==l?f.dir=t.slice(0,g-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(a){const t=/\\/g;return()=>{const f=c.cwd().replace(t,"/");return f.slice(f.indexOf("/"))}}return()=>c.cwd()})();e.posix={resolve(...t){let f="",h=!1;for(let l=t.length-1;l>=-1&&!h;l--){const u=l>=0?t[l]:s();S(u,"path"),u.length!==0&&(f=`${u}/${f}`,h=u.charCodeAt(0)===p)}return f=i(f,!h,"/",o),h?`/${f}`:f.length>0?f:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===p,h=t.charCodeAt(t.length-1)===p;return t=i(t,!f,"/",o),t.length===0?f?"/":h?"./":".":(h&&(t+="/"),f?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===p},join(...t){if(t.length===0)return".";let f;for(let h=0;h<t.length;++h){const l=t[h];S(l,"path"),l.length>0&&(f===void 0?f=l:f+=`/${l}`)}return f===void 0?".":e.posix.normalize(f)},relative(t,f){if(S(t,"from"),S(f,"to"),t===f||(t=e.posix.resolve(t),f=e.posix.resolve(f),t===f))return"";const h=1,l=t.length,u=l-h,d=1,g=f.length-d,D=u<g?u:g;let E=-1,_=0;for(;_<D;_++){const P=t.charCodeAt(h+_);if(P!==f.charCodeAt(d+_))break;P===p&&(E=_)}if(_===D)if(g>D){if(f.charCodeAt(d+_)===p)return f.slice(d+_+1);if(_===0)return f.slice(d+_)}else u>D&&(t.charCodeAt(h+_)===p?E=_:_===0&&(E=0));let y="";for(_=h+E+1;_<=l;++_)(_===l||t.charCodeAt(_)===p)&&(y+=y.length===0?"..":"/..");return`${y}${f.slice(d+E)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===p;let h=-1,l=!0;for(let u=t.length-1;u>=1;--u)if(t.charCodeAt(u)===p){if(!l){h=u;break}}else l=!1;return h===-1?f?"/":".":f&&h===1?"//":t.slice(0,h)},basename(t,f){f!==void 0&&S(f,"ext"),S(t,"path");let h=0,l=-1,u=!0,d;if(f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let g=f.length-1,D=-1;for(d=t.length-1;d>=0;--d){const E=t.charCodeAt(d);if(E===p){if(!u){h=d+1;break}}else D===-1&&(u=!1,D=d+1),g>=0&&(E===f.charCodeAt(g)?--g===-1&&(l=d):(g=-1,l=D))}return h===l?l=D:l===-1&&(l=t.length),t.slice(h,l)}for(d=t.length-1;d>=0;--d)if(t.charCodeAt(d)===p){if(!u){h=d+1;break}}else l===-1&&(u=!1,l=d+1);return l===-1?"":t.slice(h,l)},extname(t){S(t,"path");let f=-1,h=0,l=-1,u=!0,d=0;for(let g=t.length-1;g>=0;--g){const D=t.charCodeAt(g);if(D===p){if(!u){h=g+1;break}continue}l===-1&&(u=!1,l=g+1),D===b?f===-1?f=g:d!==1&&(d=1):f!==-1&&(d=-1)}return f===-1||l===-1||d===0||d===1&&f===l-1&&f===h+1?"":t.slice(f,l)},format:r.bind(null,"/"),parse(t){S(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const h=t.charCodeAt(0)===p;let l;h?(f.root="/",l=1):l=0;let u=-1,d=0,g=-1,D=!0,E=t.length-1,_=0;for(;E>=l;--E){const y=t.charCodeAt(E);if(y===p){if(!D){d=E+1;break}continue}g===-1&&(D=!1,g=E+1),y===b?u===-1?u=E:_!==1&&(_=1):u!==-1&&(_=-1)}if(g!==-1){const y=d===0&&h?1:d;u===-1||_===0||_===1&&u===g-1&&u===d+1?f.base=f.name=t.slice(y,g):(f.name=t.slice(y,u),f.base=t.slice(y,g),f.ext=t.slice(u,g))}return d>0?f.dir=t.slice(0,d-1):h&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=a?e.win32.normalize:e.posix.normalize,e.isAbsolute=a?e.win32.isAbsolute:e.posix.isAbsolute,e.join=a?e.win32.join:e.posix.join,e.resolve=a?e.win32.resolve:e.posix.resolve,e.relative=a?e.win32.relative:e.posix.relative,e.dirname=a?e.win32.dirname:e.posix.dirname,e.basename=a?e.win32.basename:e.posix.basename,e.extname=a?e.win32.extname:e.posix.extname,e.format=a?e.win32.format:e.posix.format,e.parse=a?e.win32.parse:e.posix.parse,e.toNamespacedPath=a?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=a?e.win32.sep:e.posix.sep,e.delimiter=a?e.win32.delimiter:e.posix.delimiter}),define(ye[131],_e([1,0,46,17]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareFileNames=b,e.compareFileNamesDefault=p,e.compareFileNamesUpper=w,e.compareFileNamesLower=A,e.compareFileNamesUnicode=I,e.compareFileExtensions=v,e.compareFileExtensionsDefault=C,e.compareFileExtensionsUpper=S,e.compareFileExtensionsLower=a,e.compareFileExtensionsUnicode=m,e.comparePaths=u,e.compareAnything=d,e.compareByPrefix=g;const L=new c.Lazy(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),T=new c.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new c.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(D,E,_=!1){const y=D||"",P=E||"",k=L.value.collator.compare(y,P);return L.value.collatorIsNumeric&&k===0&&y!==P?y<P?-1:1:k}function p(D,E){const _=T.value.collator;return D=D||"",E=E||"",r(_,D,E)}function w(D,E){const _=T.value.collator;return D=D||"",E=E||"",h(D,E)||r(_,D,E)}function A(D,E){const _=T.value.collator;return D=D||"",E=E||"",f(D,E)||r(_,D,E)}function I(D,E){return D=D||"",E=E||"",D===E?0:D<E?-1:1}function v(D,E){const[_,y]=n(D),[P,k]=n(E);let z=L.value.collator.compare(y,k);if(z===0){if(L.value.collatorIsNumeric&&y!==k)return y<k?-1:1;if(z=L.value.collator.compare(_,P),L.value.collatorIsNumeric&&z===0&&_!==P)return _<P?-1:1}return z}function C(D,E){D=D||"",E=E||"";const _=i(D),y=i(E),P=T.value.collator,k=R.value.collator;return r(k,_,y)||r(P,D,E)}function S(D,E){D=D||"",E=E||"";const _=i(D),y=i(E),P=T.value.collator,k=R.value.collator;return r(k,_,y)||h(D,E)||r(P,D,E)}function a(D,E){D=D||"",E=E||"";const _=i(D),y=i(E),P=T.value.collator,k=R.value.collator;return r(k,_,y)||f(D,E)||r(P,D,E)}function m(D,E){D=D||"",E=E||"";const _=i(D).toLowerCase(),y=i(E).toLowerCase();return _!==y?_<y?-1:1:D!==E?D<E?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function n(D,E=!1){const _=D?o.exec(D):[];let y=[_&&_[1]||"",_&&_[3]||""];return E&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function i(D){const E=D?o.exec(D):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function r(D,E,_){const y=D.compare(E,_);return y!==0?y:E.length!==_.length?E.length<_.length?-1:1:0}function s(D){const E=D.charAt(0);return E.toLocaleUpperCase()!==E}function t(D){const E=D.charAt(0);return E.toLocaleLowerCase()!==E}function f(D,E){return s(D)&&t(E)?-1:t(D)&&s(E)?1:0}function h(D,E){return t(D)&&s(E)?-1:s(D)&&t(E)?1:0}function l(D,E,_=!1){return _||(D=D&&D.toLowerCase(),E=E&&E.toLowerCase()),D===E?0:D<E?-1:1}function u(D,E,_=!1){const y=D.split(O.sep),P=E.split(O.sep),k=y.length-1,z=P.length-1;let x,F;for(let N=0;;N++){if(x=k===N,F=z===N,x&&F)return b(y[N],P[N],_);if(x)return-1;if(F)return 1;const M=l(y[N],P[N],_);if(M!==0)return M}}function d(D,E,_){const y=D.toLowerCase(),P=E.toLowerCase(),k=g(D,E,_);if(k)return k;const z=y.endsWith(_),x=P.endsWith(_);if(z!==x)return z?-1:1;const F=b(y,P);return F!==0?F:y.localeCompare(P)}function g(D,E,_){const y=D.toLowerCase(),P=E.toLowerCase(),k=y.startsWith(_),z=P.startsWith(_);if(k!==z)return k?-1:1;if(k&&z){if(y.length<P.length)return-1;if(y.length>P.length)return 1}return 0}}),define(ye[34],_e([1,0,17,11,14,18]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=R,e.toSlashes=b,e.toPosixPath=p,e.getRoot=w,e.isUNC=A,e.isValidBasename=S,e.isEqual=a,e.isEqualOrParent=m,e.isWindowsDriveLetter=o,e.sanitizeFilePath=n,e.isRootOrDriveLetter=i,e.hasDriveLetter=r,e.getDriveLetter=s,e.indexOfPath=t,e.parseLineAndColumnAware=f,e.randomPath=u;function R(d){return d===47||d===92}function b(d){return d.replace(/[\\/]/g,c.posix.sep)}function p(d){return d.indexOf("/")===-1&&(d=b(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}function w(d,g=c.posix.sep){if(!d)return"";const D=d.length,E=d.charCodeAt(0);if(R(E)){if(R(d.charCodeAt(1))&&!R(d.charCodeAt(2))){let y=3;const P=y;for(;y<D&&!R(d.charCodeAt(y));y++);if(P!==y&&!R(d.charCodeAt(y+1))){for(y+=1;y<D;y++)if(R(d.charCodeAt(y)))return d.slice(0,y+1).replace(/[\\/]/g,g)}}return g}else if(o(E)&&d.charCodeAt(1)===58)return R(d.charCodeAt(2))?d.slice(0,2)+g:d.slice(0,2);let _=d.indexOf("://");if(_!==-1){for(_+=3;_<D;_++)if(R(d.charCodeAt(_)))return d.slice(0,_+1)}return""}function A(d){if(!O.isWindows||!d||d.length<5)return!1;let g=d.charCodeAt(0);if(g!==92||(g=d.charCodeAt(1),g!==92))return!1;let D=2;const E=D;for(;D<d.length&&(g=d.charCodeAt(D),g!==92);D++);return!(E===D||(g=d.charCodeAt(D+1),isNaN(g)||g===92))}const I=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,C=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(d,g=O.isWindows){const D=g?I:v;return!(!d||d.length===0||/^\s+$/.test(d)||(D.lastIndex=0,D.test(d))||g&&C.test(d)||d==="."||d===".."||g&&d[d.length-1]==="."||g&&d.length!==d.trim().length||d.length>255)}function a(d,g,D){const E=d===g;return!D||E?E:!d||!g?!1:(0,L.equalsIgnoreCase)(d,g)}function m(d,g,D,E=c.sep){if(d===g)return!0;if(!d||!g||g.length>d.length)return!1;if(D){if(!(0,L.startsWithIgnoreCase)(d,g))return!1;if(g.length===d.length)return!0;let y=g.length;return g.charAt(g.length-1)===E&&y--,d.charAt(y)===E}return g.charAt(g.length-1)!==E&&(g+=E),d.indexOf(g)===0}function o(d){return d>=65&&d<=90||d>=97&&d<=122}function n(d,g){return O.isWindows&&d.endsWith(":")&&(d+=c.sep),(0,c.isAbsolute)(d)||(d=(0,c.join)(g,d)),d=(0,c.normalize)(d),O.isWindows?(d=(0,L.rtrim)(d,c.sep),d.endsWith(":")&&(d+=c.sep)):(d=(0,L.rtrim)(d,c.sep),d||(d=c.sep)),d}function i(d){const g=(0,c.normalize)(d);return O.isWindows?d.length>3?!1:r(g)&&(d.length===2||g.charCodeAt(2)===92):g===c.posix.sep}function r(d,g=O.isWindows){return g?o(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}function s(d,g=O.isWindows){return r(d,g)?d[0]:void 0}function t(d,g,D){return g.length>d.length?-1:d===g?0:(D&&(d=d.toLowerCase(),g=g.toLowerCase()),d.indexOf(g))}function f(d){const g=d.split(":");let D,E,_;for(const y of g){const P=Number(y);(0,T.isNumber)(P)?E===void 0?E=P:_===void 0&&(_=P):D=D?[D,y].join(":"):y}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:E!==void 0?E:void 0,column:_!==void 0?_:E!==void 0?1:void 0}}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function u(d,g,D=8){let E="";for(let y=0;y<D;y++){let P;y===0&&O.isWindows&&!g&&(D===3||D===4)?P=l:P=h,E+=P.charAt(Math.floor(Math.random()*P.length))}let _;return g?_=`${g}-${E}`:_=E,d?(0,c.join)(d,_):_}}),define(ye[132],_e([1,0,131,126,55,17,11,14]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.scoreFuzzy=A,e.scoreFuzzy2=m,e.scoreItemFuzzy=h,e.compareItemsByFuzzyScore=_,e.prepareQuery=F,e.pieceToQuery=M;const p=0,w=[p,[]];function A(B,W,Y,Z){if(!B||!W)return w;const G=B.length,Q=W.length;if(G<Q)return w;const re=B.toLowerCase();return I(W,Y,Q,B,re,G,Z)}function I(B,W,Y,Z,G,Q,re){const te=[],ve=[];for(let ne=0;ne<Y;ne++){const be=ne*Q,Ce=be-Q,ae=ne>0,ce=B[ne],se=W[ne];for(let j=0;j<Q;j++){const ie=j>0,ue=be+j,he=ue-1,Te=Ce+j-1,me=ie?te[he]:0,Pe=ae&&ie?te[Te]:0,Ae=ae&&ie?ve[Te]:0;let xe;!Pe&&ae?xe=0:xe=v(ce,se,Z,G,j,Ae),xe&&Pe+xe>=me&&(re||ae||G.startsWith(W,j))?(ve[ue]=Ae+1,te[ue]=Pe+xe):(ve[ue]=p,te[ue]=me)}}const Ie=[];let J=Y-1,$=Q-1;for(;J>=0&&$>=0;){const ne=J*Q+$;ve[ne]===p||(Ie.push($),J--),$--}return[te[Y*Q-1],Ie.reverse()]}function v(B,W,Y,Z,G,Q){let re=0;if(!C(W,Z[G]))return re;if(re+=1,Q>0&&(re+=Q*5),B===Y[G]&&(re+=1),G===0)re+=8;else{const te=S(Y.charCodeAt(G-1));te?re+=te:(0,O.isUpper)(Y.charCodeAt(G))&&Q===0&&(re+=2)}return re}function C(B,W){return B===W?!0:B==="/"||B==="\\"?W==="/"||W==="\\":!1}function S(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function m(B,W,Y=0,Z=0){const G=W;return G.values&&G.values.length>1?o(B,G.values,Y,Z):n(B,W,Y,Z)}function o(B,W,Y,Z){let G=0;const Q=[];for(const re of W){const[te,ve]=n(B,re,Y,Z);if(typeof te!="number")return a;G+=te,Q.push(...ve)}return[G,D(Q)]}function n(B,W,Y,Z){const G=(0,O.fuzzyScore)(W.original,W.originalLowercase,Y,B,B.toLowerCase(),Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return G?[G[0],(0,O.createMatches)(G)]:a}const i=Object.freeze({score:0}),r=1<<18,s=1<<17,t=65536;function f(B,W,Y,Z){const G=Z.values?Z.values:[Z];return(0,L.hash)({[Z.normalized]:{values:G.map(re=>({value:re.normalized,expectContiguousMatch:re.expectContiguousMatch})),label:B,description:W,allowNonContiguousMatches:Y}})}function h(B,W,Y,Z,G){if(!B||!W.normalized)return i;const Q=Z.getItemLabel(B);if(!Q)return i;const re=Z.getItemDescription(B),te=f(Q,re,Y,W),ve=G[te];if(ve)return ve;const Ie=l(Q,re,Z.getItemPath(B),W,Y);return G[te]=Ie,Ie}function l(B,W,Y,Z,G){const Q=!Y||!Z.containsPathSeparator;return Y&&(R.isLinux?Z.pathNormalized===Y:(0,b.equalsIgnoreCase)(Z.pathNormalized,Y))?{score:r,labelMatch:[{start:0,end:B.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:Z.values&&Z.values.length>1?u(B,W,Y,Z.values,Q,G):d(B,W,Y,Z,Q,G)}function u(B,W,Y,Z,G,Q){let re=0;const te=[],ve=[];for(const Ie of Z){const{score:J,labelMatch:$,descriptionMatch:ne}=d(B,W,Y,Ie,G,Q);if(J===p)return i;re+=J,$&&te.push(...$),ne&&ve.push(...ne)}return{score:re,labelMatch:D(te),descriptionMatch:D(ve)}}function d(B,W,Y,Z,G,Q){if(G||!W){const[re,te]=A(B,Z.normalized,Z.normalizedLowercase,Q&&!Z.expectContiguousMatch);if(re){const ve=(0,O.matchesPrefix)(Z.normalized,B);let Ie;if(ve){Ie=s;const J=Math.round(Z.normalized.length/B.length*100);Ie+=J}else Ie=t;return{score:Ie+re,labelMatch:ve||g(te)}}}if(W){let re=W;Y&&(re=`${W}${T.sep}`);const te=re.length,ve=`${re}${B}`,[Ie,J]=A(ve,Z.normalized,Z.normalizedLowercase,Q&&!Z.expectContiguousMatch);if(Ie){const $=g(J),ne=[],be=[];return $.forEach(Ce=>{Ce.start<te&&Ce.end>te?(ne.push({start:0,end:Ce.end-te}),be.push({start:Ce.start,end:te})):Ce.start>=te?ne.push({start:Ce.start-te,end:Ce.end-te}):be.push(Ce)}),{score:Ie,labelMatch:ne,descriptionMatch:be}}}return i}function g(B){const W=[];if(!B)return W;let Y;for(const Z of B)Y&&Y.end===Z?Y.end+=1:(Y={start:Z,end:Z+1},W.push(Y));return W}function D(B){const W=B.sort((G,Q)=>G.start-Q.start),Y=[];let Z;for(const G of W)!Z||!E(Z,G)?(Z=G,Y.push(G)):(Z.start=Math.min(Z.start,G.start),Z.end=Math.max(Z.end,G.end));return Y}function E(B,W){return!(B.end<W.start||W.end<B.start)}function _(B,W,Y,Z,G,Q){const re=h(B,Y,Z,G,Q),te=h(W,Y,Z,G,Q),ve=re.score,Ie=te.score;if((ve===r||Ie===r)&&ve!==Ie)return ve===r?-1:1;if(ve>t||Ie>t){if(ve!==Ie)return ve>Ie?-1:1;if(ve<s&&Ie<s){const ce=P(re.labelMatch,te.labelMatch);if(ce!==0)return ce}const Ce=G.getItemLabel(B)||"",ae=G.getItemLabel(W)||"";if(Ce.length!==ae.length)return Ce.length-ae.length}if(ve!==Ie)return ve>Ie?-1:1;const J=Array.isArray(re.labelMatch)&&re.labelMatch.length>0,$=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(J&&!$)return-1;if($&&!J)return 1;const ne=y(B,re,G),be=y(W,te,G);return ne&&be&&ne!==be?be>ne?-1:1:k(B,W,Y,G)}function y(B,W,Y){let Z=-1,G=-1;if(W.descriptionMatch&&W.descriptionMatch.length?Z=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(Z=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(G=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const Q=Y.getItemDescription(B);Q&&(G+=Q.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(G=W.descriptionMatch[W.descriptionMatch.length-1].end);return G-Z}function P(B,W){if(!B&&!W||(!B||!B.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!B||!B.length)return 1;const Y=B[0].start,G=B[B.length-1].end-Y,Q=W[0].start,te=W[W.length-1].end-Q;return G===te?0:te<G?1:-1}function k(B,W,Y,Z){const G=Z.getItemLabel(B)||"",Q=Z.getItemLabel(W)||"",re=Z.getItemDescription(B),te=Z.getItemDescription(W),ve=G.length+(re?re.length:0),Ie=Q.length+(te?te.length:0);if(ve!==Ie)return ve-Ie;const J=Z.getItemPath(B),$=Z.getItemPath(W);return J&&$&&J.length!==$.length?J.length-$.length:G!==Q?(0,c.compareAnything)(G,Q,Y.normalized):re&&te&&re!==te?(0,c.compareAnything)(re,te,Y.normalized):J&&$&&J!==$?(0,c.compareAnything)(J,$,Y.normalized):0}function z(B){return B.startsWith('"')&&B.endsWith('"')}const x=" ";function F(B){typeof B!="string"&&(B="");const W=B.toLowerCase(),{pathNormalized:Y,normalized:Z,normalizedLowercase:G}=N(B),Q=Y.indexOf(T.sep)>=0,re=z(B);let te;const ve=B.split(x);if(ve.length>1)for(const Ie of ve){const J=z(Ie),{pathNormalized:$,normalized:ne,normalizedLowercase:be}=N(Ie);ne&&(te||(te=[]),te.push({original:Ie,originalLowercase:Ie.toLowerCase(),pathNormalized:$,normalized:ne,normalizedLowercase:be,expectContiguousMatch:J}))}return{original:B,originalLowercase:W,pathNormalized:Y,normalized:Z,normalizedLowercase:G,values:te,containsPathSeparator:Q,expectContiguousMatch:re}}function N(B){let W;R.isWindows?W=B.replace(/\//g,T.sep):W=B.replace(/\\/g,T.sep);const Y=(0,b.stripWildcards)(W).replace(/\s|"/g,"");return{pathNormalized:W,normalized:Y,normalizedLowercase:Y.toLowerCase()}}function M(B){return Array.isArray(B)?F(B.map(W=>W.original).join(x)):F(B.original)}}),define(ye[101],_e([1,0,17]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=T,e.getMediaMime=R,e.getExtensionForMimeType=b,e.normalizeMimeType=w,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(A){const I=(0,c.extname)(A),v=O[I.toLowerCase()];return v!==void 0?v:R(A)}function R(A){const I=(0,c.extname)(A);return L[I.toLowerCase()]}function b(A){for(const I in L)if(L[I]===A)return I}const p=/^(.+)\/(.+?)(;.+)?$/;function w(A,I){const v=p.exec(A);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:I?void 0:A}}),define(ye[102],_e([1,0,11]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=T,e.removeDangerousEnvVariables=R;var O;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(O||(e.Source=O={}));var L;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function T(b,...p){const w=p.reduce((v,C)=>(v[C]=!0,v),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(v=>!w[v]).forEach(v=>{for(let C=0;C<A.length;C++)if(v.search(A[C])!==-1){delete b[v];break}})}function R(b){b&&(delete b.DEBUG,c.isMacintosh&&delete b.DYLD_LIBRARY_PATH,c.isLinux&&delete b.LD_PRELOAD)}}),define(ye[2],_e([1,0,17,11]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=S,e.uriToFsPath=r;const L=/^\w[\w\d+.-]*$/,T=/^\//,R=/^\/\//;function b(l,u){if(!l.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!L.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!T.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(l,u){return!l&&!u?"file":l}function w(l,u){switch(l){case"https":case"http":case"file":u?u[0]!==I&&(u=I+u):u=I;break}return u}const A="",I="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class C{static isUri(u){return u instanceof C?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,d,g,D,E,_=!1){typeof u=="object"?(this.scheme=u.scheme||A,this.authority=u.authority||A,this.path=u.path||A,this.query=u.query||A,this.fragment=u.fragment||A):(this.scheme=p(u,_),this.authority=d||A,this.path=w(this.scheme,g||A),this.query=D||A,this.fragment=E||A,b(this,_))}get fsPath(){return r(this,!1)}with(u){if(!u)return this;let{scheme:d,authority:g,path:D,query:E,fragment:_}=u;return d===void 0?d=this.scheme:d===null&&(d=A),g===void 0?g=this.authority:g===null&&(g=A),D===void 0?D=this.path:D===null&&(D=A),E===void 0?E=this.query:E===null&&(E=A),_===void 0?_=this.fragment:_===null&&(_=A),d===this.scheme&&g===this.authority&&D===this.path&&E===this.query&&_===this.fragment?this:new m(d,g,D,E,_)}static parse(u,d=!1){const g=v.exec(u);return g?new m(g[2]||A,h(g[4]||A),h(g[5]||A),h(g[7]||A),h(g[9]||A),d):new m(A,A,A,A,A)}static file(u){let d=A;if(O.isWindows&&(u=u.replace(/\\/g,I)),u[0]===I&&u[1]===I){const g=u.indexOf(I,2);g===-1?(d=u.substring(2),u=I):(d=u.substring(2,g),u=u.substring(g)||I)}return new m("file",d,u,A,A)}static from(u,d){return new m(u.scheme,u.authority,u.path,u.query,u.fragment,d)}static joinPath(u,...d){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return O.isWindows&&u.scheme==="file"?g=C.file(c.win32.join(r(u,!0),...d)).path:g=c.posix.join(u.path,...d),u.with({path:g})}toString(u=!1){return s(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof C)return u;{const d=new m(u);return d._formatted=u.external??null,d._fsPath=u._sep===a?u.fsPath??null:null,d}}else return u}}e.URI=C;function S(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}const a=O.isWindows?1:void 0;class m extends C{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(u=!1){return u?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=a),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const o={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(l,u,d){let g,D=-1;for(let E=0;E<l.length;E++){const _=l.charCodeAt(E);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||u&&_===47||d&&_===91||d&&_===93||d&&_===58)D!==-1&&(g+=encodeURIComponent(l.substring(D,E)),D=-1),g!==void 0&&(g+=l.charAt(E));else{g===void 0&&(g=l.substr(0,E));const y=o[_];y!==void 0?(D!==-1&&(g+=encodeURIComponent(l.substring(D,E)),D=-1),g+=y):D===-1&&(D=E)}}return D!==-1&&(g+=encodeURIComponent(l.substring(D))),g!==void 0?g:l}function i(l){let u;for(let d=0;d<l.length;d++){const g=l.charCodeAt(d);g===35||g===63?(u===void 0&&(u=l.substr(0,d)),u+=o[g]):u!==void 0&&(u+=l[d])}return u!==void 0?u:l}function r(l,u){let d;return l.authority&&l.path.length>1&&l.scheme==="file"?d=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?u?d=l.path.substr(1):d=l.path[1].toLowerCase()+l.path.substr(2):d=l.path,O.isWindows&&(d=d.replace(/\//g,"\\")),d}function s(l,u){const d=u?i:n;let g="",{scheme:D,authority:E,path:_,query:y,fragment:P}=l;if(D&&(g+=D,g+=":"),(E||D==="file")&&(g+=I,g+=I),E){let k=E.indexOf("@");if(k!==-1){const z=E.substr(0,k);E=E.substr(k+1),k=z.lastIndexOf(":"),k===-1?g+=d(z,!1,!1):(g+=d(z.substr(0,k),!1,!1),g+=":",g+=d(z.substr(k+1),!1,!0)),g+="@"}E=E.toLowerCase(),k=E.lastIndexOf(":"),k===-1?g+=d(E,!1,!0):(g+=d(E.substr(0,k),!1,!0),g+=E.substr(k))}if(_){if(_.length>=3&&_.charCodeAt(0)===47&&_.charCodeAt(2)===58){const k=_.charCodeAt(1);k>=65&&k<=90&&(_=`/${String.fromCharCode(k+32)}:${_.substr(3)}`)}else if(_.length>=2&&_.charCodeAt(1)===58){const k=_.charCodeAt(0);k>=65&&k<=90&&(_=`${String.fromCharCode(k+32)}:${_.substr(2)}`)}g+=d(_,!0,!1)}return y&&(g+="?",g+=d(y,!1,!1)),P&&(g+="#",g+=u?P:n(P,!1,!1)),g}function t(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+t(l.substr(3)):l}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(l){return l.match(f)?l.replace(f,u=>t(u)):l}}),define(ye[192],_e([1,0,2]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=O,e.parse=L,e.getFirstFrame=T,e.log=b;function O(w){const A=w;return A&&typeof A.type=="string"&&typeof A.severity=="string"}function L(w){const A=[];let I;try{const v=JSON.parse(w.arguments),C=v[v.length-1];C&&C.__$stack&&(v.pop(),I=C.__$stack),A.push(...v)}catch{A.push("Unable to log remote console arguments",w.arguments)}return{args:A,stack:I}}function T(w){if(typeof w!="string")return T(L(w).stack);const A=w;if(A){const I=R(A),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(v&&v.length===4)return{uri:c.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}function R(w){if(!w)return w;const A=w.indexOf(`
`);return A===-1?w:w.substring(0,A)}function b(w,A){const{args:I,stack:v}=L(w),C=typeof I[0]=="string"&&I.length===1;let S=R(v);S&&(S=`(${S.trim()})`);let a=[];if(typeof I[0]=="string"?S&&C?a=[`%c[${A}] %c${I[0]} %c${S}`,p("blue"),p(""),p("grey")]:a=[`%c[${A}] %c${I[0]}`,p("blue"),p(""),...I.slice(1)]:a=[`%c[${A}]%`,p("blue"),...I],S&&!C&&a.push(S),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,a)}function p(w){return`color: ${w}`}}),define(ye[57],_e([1,0,21,2]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=L,e.parse=T,e.revive=b;function L(p){return JSON.stringify(p,R)}function T(p){let w=JSON.parse(p);return w=b(w),w}function R(p,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function b(p,w=0){if(!p||w>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return O.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 17:return new Date(p.source)}if(p instanceof c.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let A=0;A<p.length;++A)p[A]=b(p[A],w+1);else for(const A in p)Object.hasOwnProperty.call(p,A)&&(p[A]=b(p[A],w+1))}return p}}),define(ye[15],_e([1,0,13,11,14,2,17]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=p,e.matchesSomeScheme=w,e.getServerRootPath=I;var b;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeManagedRemoteResource="vscode-managed-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.vscodeChatCodeBlock="vscode-chat-code-block",S.vscodeChatSesssion="vscode-chat-editor",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm",S.codeSetting="code-setting"})(b||(e.Schemas=b={}));function p(S,a){return T.URI.isUri(S)?(0,L.equalsIgnoreCase)(S.scheme,a):(0,L.startsWithIgnoreCase)(S,a+":")}function w(S,...a){return a.some(m=>p(S,m))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(a){this._preferredWebSchema=a}setDelegate(a){this._delegate=a}setServerRootPath(a,m){this._serverRootPath=I(a,m)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return R.posix.join(this._serverRootPath,b.vscodeRemoteResource)}set(a,m,o){this._hosts[a]=m,this._ports[a]=o}setConnectionToken(a,m){this._connectionTokens[a]=m}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(a){if(this._delegate)try{return this._delegate(a)}catch(s){return c.onUnexpectedError(s),a}const m=a.authority;let o=this._hosts[m];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const n=this._ports[m],i=this._connectionTokens[m];let r=`path=${encodeURIComponent(a.path)}`;return typeof i=="string"&&(r+=`&${e.connectionTokenQueryName}=${encodeURIComponent(i)}`),T.URI.from({scheme:O.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${o}:${n}`,path:this._remoteResourcesPath,query:r})}}e.RemoteAuthorities=new A;function I(S,a){return R.posix.join(a??"/",`${S.quality??"oss"}-${S.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class v{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(a){const m=this.toUri(a,de);return this.uriToBrowserUri(m)}uriToBrowserUri(a){return a.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(a):a.scheme===b.file&&(O.isNative||O.webWorkerOrigin===`${b.vscodeFileResource}://${v.FALLBACK_AUTHORITY}`)?a.with({scheme:b.vscodeFileResource,authority:a.authority||v.FALLBACK_AUTHORITY,query:null,fragment:null}):a}asFileUri(a){const m=this.toUri(a,de);return this.uriToFileUri(m)}uriToFileUri(a){return a.scheme===b.vscodeFileResource?a.with({scheme:b.file,authority:a.authority!==v.FALLBACK_AUTHORITY?a.authority:null,query:null,fragment:null}):a}toUri(a,m){return T.URI.isUri(a)?a:T.URI.parse(m.toUrl(a))}}e.FileAccess=new v;var C;(function(S){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(a.get("3"));const m="vscode-coi";function o(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:T.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const s=r?.get(m);if(s)return a.get(s)}S.getHeadersFromQuery=o;function n(i,r,s){if(!globalThis.crossOriginIsolated)return;const t=r&&s?"3":s?"2":"1";i instanceof URLSearchParams?i.set(m,t):i[m]=t}S.addSearchParam=n})(C||(e.COI=C={}))}),define(ye[193],_e([1,0,162,15,11,2]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=A;class R{constructor(v,C,S){this.id=v,this.dependencies=C,this.callback=S}}class b{static{this.INSTANCE=new b}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(v,C,S)=>{typeof v!="string"&&(S=C,C=v,v=null),(typeof C!="object"||!Array.isArray(C))&&(S=C,C=null),this._defineCalls.push(new R(v,C,S))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith("vscode-file://vscode-app"))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this._initialize();const C=await(this._isWebWorker?this._workerLoadScript(v):this._isRenderer?this._rendererLoadScript(v):this._nodeJSLoadScript(v));if(!C)throw new Error(`Did not receive a define call from script ${v}`);if(Array.isArray(C.dependencies)&&C.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${C.dependencies.join(", ")}`);return typeof C.callback=="function"?C.callback([]):C.callback}_rendererLoadScript(v){return new Promise((C,S)=>{const a=document.createElement("script");a.setAttribute("async","async"),a.setAttribute("type","text/javascript");const m=()=>{a.removeEventListener("load",o),a.removeEventListener("error",n)},o=i=>{m(),C(this._defineCalls.pop())},n=i=>{m(),S(i)};a.addEventListener("load",o),a.addEventListener("error",n),this._amdPolicy&&(v=this._amdPolicy.createScriptURL(v)),a.setAttribute("src",v),window.document.getElementsByTagName("head")[0].appendChild(a)})}_workerLoadScript(v){return new Promise((C,S)=>{try{this._amdPolicy&&(v=this._amdPolicy.createScriptURL(v)),importScripts(v),C(this._defineCalls.pop())}catch(a){S(a)}})}async _nodeJSLoadScript(v){try{const C=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,a=globalThis._VSCODE_NODE_MODULES.module,m=T.URI.parse(v).fsPath,o=C.readFileSync(m).toString(),n=a.wrap(o.replace(/^#!.*/,""));return new S.Script(n).runInThisContext().apply(),this._defineCalls.pop()}catch(C){throw C}}}const p=new Map;let w={};typeof globalThis.require=="object"&&(w=globalThis.require.paths??{});async function A(I,v,C){if(c.isESM){C===void 0&&(C=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),w[I]&&(I=w[I]);const S=`${I}/${v}`;if(p.has(S))return p.get(S);let a;if(/^\w[\w\d+.-]*:\/\//.test(S))a=S;else{const i=`${C&&!L.isWeb?O.nodeModulesAsarPath:O.nodeModulesPath}/${S}`;a=O.FileAccess.asBrowserUri(i).toString(!0)}const m=b.INSTANCE.load(a);return p.set(S,m),m}else return await new Promise((S,a)=>{de([I],S,a)})}}),define(ye[23],_e([1,0,34,15,17,11,14,2]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=p,e.distinctParents=A,e.toLocalResource=v;function p(C){return(0,b.uriToFsPath)(C,!0)}class w{constructor(S){this._ignorePathCasing=S}compare(S,a,m=!1){return S===a?0:(0,R.compare)(this.getComparisonKey(S,m),this.getComparisonKey(a,m))}isEqual(S,a,m=!1){return S===a?!0:!S||!a?!1:this.getComparisonKey(S,m)===this.getComparisonKey(a,m)}getComparisonKey(S,a=!1){return S.with({path:this._ignorePathCasing(S)?S.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(S){return this._ignorePathCasing(S)}isEqualOrParent(S,a,m=!1){if(S.scheme===a.scheme){if(S.scheme===O.Schemas.file)return c.isEqualOrParent(p(S),p(a),this._ignorePathCasing(S))&&S.query===a.query&&(m||S.fragment===a.fragment);if((0,e.isEqualAuthority)(S.authority,a.authority))return c.isEqualOrParent(S.path,a.path,this._ignorePathCasing(S),"/")&&S.query===a.query&&(m||S.fragment===a.fragment)}return!1}joinPath(S,...a){return b.URI.joinPath(S,...a)}basenameOrAuthority(S){return(0,e.basename)(S)||S.authority}basename(S){return L.posix.basename(S.path)}extname(S){return L.posix.extname(S.path)}dirname(S){if(S.path.length===0)return S;let a;return S.scheme===O.Schemas.file?a=b.URI.file(L.dirname(p(S))).path:(a=L.posix.dirname(S.path),S.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),a="/")),S.with({path:a})}normalizePath(S){if(!S.path.length)return S;let a;return S.scheme===O.Schemas.file?a=b.URI.file(L.normalize(p(S))).path:a=L.posix.normalize(S.path),S.with({path:a})}relativePath(S,a){if(S.scheme!==a.scheme||!(0,e.isEqualAuthority)(S.authority,a.authority))return;if(S.scheme===O.Schemas.file){const n=L.relative(p(S),p(a));return T.isWindows?c.toSlashes(n):n}let m=S.path||"/";const o=a.path||"/";if(this._ignorePathCasing(S)){let n=0;for(const i=Math.min(m.length,o.length);n<i&&!(m.charCodeAt(n)!==o.charCodeAt(n)&&m.charAt(n).toLowerCase()!==o.charAt(n).toLowerCase());n++);m=o.substr(0,n)+m.substr(n)}return L.posix.relative(m,o)}resolvePath(S,a){if(S.scheme===O.Schemas.file){const m=b.URI.file(L.resolve(p(S),a));return S.with({authority:m.authority,path:m.path})}return a=c.toPosixPath(a),S.with({path:L.posix.resolve(S.path,a)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,a){return S===a||S!==void 0&&a!==void 0&&(0,R.equalsIgnoreCase)(S,a)}hasTrailingPathSeparator(S,a=L.sep){if(S.scheme===O.Schemas.file){const m=p(S);return m.length>c.getRoot(m).length&&m[m.length-1]===a}else{const m=S.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,a=L.sep){return(0,e.hasTrailingPathSeparator)(S,a)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,a=L.sep){let m=!1;if(S.scheme===O.Schemas.file){const o=p(S);m=o!==void 0&&o.length===c.getRoot(o).length&&o[o.length-1]===a}else{a="/";const o=S.path;m=o.length===1&&o.charCodeAt(o.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(S,a)?S.with({path:S.path+"/"}):S}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(C=>C.scheme===O.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new w(C=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(C,S){const a=[];for(let m=0;m<C.length;m++){const o=S(C[m]);C.some((n,i)=>i===m?!1:(0,e.isEqualOrParent)(o,S(n)))||a.push(C[m])}return a}var I;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function S(a){const m=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(i=>{const[r,s]=i.split(":");r&&s&&m.set(r,s)});const n=a.path.substring(0,a.path.indexOf(";"));return n&&m.set(C.META_DATA_MIME,n),m}C.parseMetaData=S})(I||(e.DataUri=I={}));function v(C,S,a){if(S){let m=C.path;return m&&m[0]!==L.posix.sep&&(m=L.posix.sep+m),C.with({scheme:a,authority:S,path:m})}return C.with({scheme:a})}}),define(ye[8],_e([1,0,22,13,4,3,23,11,169,46]),function(de,e,c,O,L,T,R,b,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=A,e.createCancelablePromise=I,e.raceCancellation=v,e.raceCancellationError=C,e.raceCancellablePromises=S,e.raceTimeout=a,e.asPromise=m,e.promiseWithResolvers=o,e.timeout=d,e.disposableTimeout=g,e.sequence=D,e.first=E,e.firstParallel=_,e.retry=G,e.createCancelableAsyncIterable=ae;function A(se){return!!se&&typeof se.then=="function"}function I(se){const j=new c.CancellationTokenSource,ie=se(j.token),ue=new Promise((he,Te)=>{const me=j.token.onCancellationRequested(()=>{me.dispose(),Te(new O.CancellationError)});Promise.resolve(ie).then(Pe=>{me.dispose(),j.dispose(),he(Pe)},Pe=>{me.dispose(),j.dispose(),Te(Pe)})});return new class{cancel(){j.cancel(),j.dispose()}then(he,Te){return ue.then(he,Te)}catch(he){return this.then(void 0,he)}finally(he){return ue.finally(he)}}}function v(se,j,ie){return new Promise((ue,he)=>{const Te=j.onCancellationRequested(()=>{Te.dispose(),ue(ie)});se.then(ue,he).finally(()=>Te.dispose())})}function C(se,j){return new Promise((ie,ue)=>{const he=j.onCancellationRequested(()=>{he.dispose(),ue(new O.CancellationError)});se.then(ie,ue).finally(()=>he.dispose())})}async function S(se){let j=-1;const ie=se.map((ue,he)=>ue.then(Te=>(j=he,Te)));try{return await Promise.race(ie)}finally{se.forEach((ue,he)=>{he!==j&&ue.cancel()})}}function a(se,j,ie){let ue;const he=setTimeout(()=>{ue?.(void 0),ie?.()},j);return Promise.race([se.finally(()=>clearTimeout(he)),new Promise(Te=>ue=Te)])}function m(se){return new Promise((j,ie)=>{const ue=se();A(ue)?ue.then(j,ie):j(ue)})}function o(){let se,j;return{promise:new Promise((ue,he)=>{se=ue,j=he}),resolve:se,reject:j}}class n{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(j){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=j,!this.queuedPromise){const ie=()=>{if(this.queuedPromise=null,this.isDisposed)return;const ue=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ue};this.queuedPromise=new Promise(ue=>{this.activePromise.then(ie,ie).then(ue)})}return new Promise((ie,ue)=>{this.queuedPromise.then(ie,ue)})}return this.activePromise=j(),new Promise((ie,ue)=>{this.activePromise.then(he=>{this.activePromise=null,ie(he)},he=>{this.activePromise=null,ue(he)})})}dispose(){this.isDisposed=!0}}e.Throttler=n;class i{constructor(){this.current=Promise.resolve(null)}queue(j){return this.current=this.current.then(()=>j(),()=>j())}}e.Sequencer=i;class r{constructor(){this.promiseMap=new Map}queue(j,ie){const he=(this.promiseMap.get(j)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.promiseMap.get(j)===he&&this.promiseMap.delete(j)});return this.promiseMap.set(j,he),he}}e.SequencerByKey=r;const s=(se,j)=>{let ie=!0;const ue=setTimeout(()=>{ie=!1,j()},se);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(ue),ie=!1}}},t=se=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,se())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class f{constructor(j){this.defaultDelay=j,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(j,ie=this.defaultDelay){this.task=j,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((he,Te)=>{this.doResolve=he,this.doReject=Te}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const he=this.task;return this.task=null,he()}}));const ue=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ie===p.MicrotaskDelay?t(ue):s(ie,ue),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new O.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class h{constructor(j){this.delayer=new f(j),this.throttler=new n}trigger(j,ie){return this.delayer.trigger(()=>this.throttler.queue(j),ie)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=h;class l{constructor(){this._isOpen=!1,this._promise=new Promise((j,ie)=>{this._completePromise=j})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class u extends l{constructor(j){super(),this._timeout=setTimeout(()=>this.open(),j)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function d(se,j){return j?new Promise((ie,ue)=>{const he=setTimeout(()=>{Te.dispose(),ie()},se),Te=j.onCancellationRequested(()=>{clearTimeout(he),Te.dispose(),ue(new O.CancellationError)})}):I(ie=>d(se,ie))}function g(se,j=0,ie){const ue=setTimeout(()=>{se(),ie&&he.dispose()},j),he=(0,T.toDisposable)(()=>{clearTimeout(ue),ie?.deleteAndLeak(he)});return ie?.add(he),he}function D(se){const j=[];let ie=0;const ue=se.length;function he(){return ie<ue?se[ie++]():null}function Te(me){me!=null&&j.push(me);const Pe=he();return Pe?Pe.then(Te):Promise.resolve(j)}return Promise.resolve(null).then(Te)}function E(se,j=ue=>!!ue,ie=null){let ue=0;const he=se.length,Te=()=>{if(ue>=he)return Promise.resolve(ie);const me=se[ue++];return Promise.resolve(me()).then(Ae=>j(Ae)?Promise.resolve(Ae):Te())};return Te()}function _(se,j=ue=>!!ue,ie=null){if(se.length===0)return Promise.resolve(ie);let ue=se.length;const he=()=>{ue=-1;for(const Te of se)Te.cancel?.()};return new Promise((Te,me)=>{for(const Pe of se)Pe.then(Ae=>{--ue>=0&&j(Ae)?(he(),Te(Ae)):ue===0&&Te(ie)}).catch(Ae=>{--ue>=0&&(he(),me(Ae))})})}class y{constructor(j){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=j,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new L.Emitter}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(j){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((ie,ue)=>{this.outstandingPromises.push({factory:j,c:ie,e:ue}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const j=this.outstandingPromises.shift();this.runningPromises++;const ie=j.factory();ie.then(j.c,j.e),ie.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=y;class P extends y{constructor(){super(1)}}e.Queue=P;class k{constructor(){this.sequentializer=new Q,this.tasks=0}queue(j){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,j())):this.sequentializer.run(this.tasks++,j())}}e.LimitedQueue=k;class z{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const j=new ve;return this.drainers.add(j),j.p}isDrained(){for(const[,j]of this.queues)if(j.size>0)return!1;return!0}queueSize(j,ie=R.extUri){const ue=ie.getComparisonKey(j);return this.queues.get(ue)?.size??0}queueFor(j,ie,ue=R.extUri){const he=ue.getComparisonKey(j);let Te=this.queues.get(he);if(!Te){Te=new P;const me=this.drainListenerCount++,Pe=L.Event.once(Te.onDrained)(()=>{Te?.dispose(),this.queues.delete(he),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(me),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new T.DisposableMap),this.drainListeners.set(me,Pe),this.queues.set(he,Te)}return Te.queue(ie)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const j of this.drainers)j.complete();this.drainers.clear()}dispose(){for(const[,j]of this.queues)j.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=z;class x{constructor(j,ie){this._token=-1,typeof j=="function"&&typeof ie=="number"&&this.setIfNotSet(j,ie)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(j,ie){this.cancel(),this._token=setTimeout(()=>{this._token=-1,j()},ie)}setIfNotSet(j,ie){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,j()},ie))}}e.TimeoutTimer=x;class F{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(j,ie,ue=globalThis){this.cancel();const he=ue.setInterval(()=>{j()},ie);this.disposable=(0,T.toDisposable)(()=>{ue.clearInterval(he),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=F;class N{constructor(j,ie){this.timeoutToken=-1,this.runner=j,this.timeout=ie,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(j=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,j)}get delay(){return this.timeout}set delay(j){this.timeout=j}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=N;class M{constructor(j,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.runner=j,this.timeout=ie,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(j=this.timeout){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(j/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=M;class B extends N{constructor(j,ie){super(j,ie),this.units=[]}work(j){this.units.push(j),this.isScheduled()||this.schedule()}doRun(){const j=this.units;this.units=[],this.runner?.(j)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=B;class W extends T.Disposable{constructor(j,ie){super(),this.options=j,this.handler=ie,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(j){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+j.length>this.options.maxBufferedWork)return!1}else if(this.pending+j.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const ie of j)this.pendingWork.push(ie);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new N(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(se,j)=>{(0,b.setTimeout0)(()=>{if(ie)return;const ue=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e._runWhenIdle=(se,j,ie)=>{const ue=se.requestIdleCallback(j,typeof ie=="number"?{timeout:ie}:void 0);let he=!1;return{dispose(){he||(he=!0,se.cancelIdleCallback(ue))}}},e.runWhenGlobalIdle=se=>(0,e._runWhenIdle)(globalThis,se)}();class Y{constructor(j,ie){this._didRun=!1,this._executor=()=>{try{this._value=ie()}catch(ue){this._error=ue}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(j,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=Y;class Z extends Y{constructor(j){super(globalThis,j)}}e.GlobalIdleValue=Z;async function G(se,j,ie){let ue;for(let he=0;he<ie;he++)try{return await se()}catch(Te){ue=Te,await d(j)}throw ue}class Q{isRunning(j){return typeof j=="number"?this._running?.taskId===j:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(j,ie,ue){return this._running={taskId:j,cancel:()=>ue?.(),promise:ie},ie.then(()=>this.doneRunning(j),()=>this.doneRunning(j)),ie}doneRunning(j){this._running&&j===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const j=this._queued;this._queued=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}queue(j){if(this._queued)this._queued.run=j;else{const{promise:ie,resolve:ue,reject:he}=o();this._queued={run:j,promise:ie,promiseResolve:ue,promiseReject:he}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Q;class re{constructor(j,ie=()=>Date.now()){this.interval=j,this.nowFn=ie,this.lastIncrementTime=0,this.value=0}increment(){const j=this.nowFn();return j-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=j,this.value=0),this.value++,this.value}}e.IntervalCounter=re;var te;(function(se){se[se.Resolved=0]="Resolved",se[se.Rejected=1]="Rejected"})(te||(te={}));class ve{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((j,ie)=>{this.completeCallback=j,this.errorCallback=ie})}complete(j){return new Promise(ie=>{this.completeCallback(j),this.outcome={outcome:0,value:j},ie()})}error(j){return new Promise(ie=>{this.errorCallback(j),this.outcome={outcome:1,value:j},ie()})}cancel(){return this.error(new O.CancellationError)}}e.DeferredPromise=ve;var Ie;(function(se){async function j(ue){let he;const Te=await Promise.all(ue.map(me=>me.then(Pe=>Pe,Pe=>{he||(he=Pe)})));if(typeof he<"u")throw he;return Te}se.settled=j;function ie(ue){return new Promise(async(he,Te)=>{try{await ue(he,Te)}catch(me){Te(me)}})}se.withAsyncBody=ie})(Ie||(e.Promises=Ie={}));class J{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(j){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=j.then(ie=>(this._value=ie,this._isResolved=!0,ie),ie=>{throw this._error=ie,this._isResolved=!0,ie})}requireValue(){if(!this._isResolved)throw new O.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=J;class ${constructor(j){this._compute=j,this._promise=new w.Lazy(()=>new J(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=$;var ne;(function(se){se[se.Initial=0]="Initial",se[se.DoneOK=1]="DoneOK",se[se.DoneError=2]="DoneError"})(ne||(ne={}));class be{static fromArray(j){return new be(ie=>{ie.emitMany(j)})}static fromPromise(j){return new be(async ie=>{ie.emitMany(await j)})}static fromPromises(j){return new be(async ie=>{await Promise.all(j.map(async ue=>ie.emitOne(await ue)))})}static merge(j){return new be(async ie=>{await Promise.all(j.map(async ue=>{for await(const he of ue)ie.emitOne(he)}))})}static{this.EMPTY=be.fromArray([])}constructor(j){this._state=0,this._results=[],this._error=null,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const ie={emitOne:ue=>this.emitOne(ue),emitMany:ue=>this.emitMany(ue),reject:ue=>this.reject(ue)};try{await Promise.resolve(j(ie)),this.resolve()}catch(ue){this.reject(ue)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(j<this._results.length)return{done:!1,value:this._results[j++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(j,ie){return new be(async ue=>{for await(const he of j)ue.emitOne(ie(he))})}map(j){return be.map(this,j)}static filter(j,ie){return new be(async ue=>{for await(const he of j)ie(he)&&ue.emitOne(he)})}filter(j){return be.filter(this,j)}static coalesce(j){return be.filter(j,ie=>!!ie)}coalesce(){return be.coalesce(this)}static async toPromise(j){const ie=[];for await(const ue of j)ie.push(ue);return ie}toPromise(){return be.toPromise(this)}emitOne(j){this._state===0&&(this._results.push(j),this._onStateChanged.fire())}emitMany(j){this._state===0&&(this._results=this._results.concat(j),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(j){this._state===0&&(this._state=2,this._error=j,this._onStateChanged.fire())}}e.AsyncIterableObject=be;class Ce extends be{constructor(j,ie){super(ie),this._source=j}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Ce;function ae(se){const j=new c.CancellationTokenSource,ie=se(j.token);return new Ce(j,async ue=>{const he=j.token.onCancellationRequested(()=>{he.dispose(),j.dispose(),ue.reject(new O.CancellationError)});try{for await(const Te of ie){if(j.token.isCancellationRequested)return;ue.emitOne(Te)}he.dispose(),j.dispose()}catch(Te){he.dispose(),j.dispose(),ue.reject(Te)}})}class ce{constructor(){this._deferred=new ve,this._asyncIterable=new be(ue=>{if(j){ue.reject(j);return}return ie&&ue.emitMany(ie),this._errorFn=he=>ue.reject(he),this._emitFn=he=>ue.emitOne(he),this._deferred.p});let j,ie;this._emitFn=ue=>{ie||(ie=[]),ie.push(ue)},this._errorFn=ue=>{j||(j=ue)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(j){this._errorFn(j),this._deferred.complete()}emitOne(j){this._emitFn(j)}}e.AsyncIterableSource=ce}),define(ye[35],_e([1,0,19,8,34,27,17,11,14]),function(de,e,c,O,L,T,R,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=w,e.splitGlobAware=S,e.match=P,e.parse=k,e.isRelativePattern=z,e.getBasenameTerms=x,e.getPathTerms=F,e.patternsEquals=W;function w(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const A="[/\\\\]",I="[^/\\\\]",v=/\//g;function C(Y,Z){switch(Y){case 0:return"";case 1:return`${I}*?`;default:return`(?:${A}|${I}+${A}${Z?`|${A}${I}+`:""})*?`}}function S(Y,Z){if(!Y)return[];const G=[];let Q=!1,re=!1,te="";for(const ve of Y){switch(ve){case Z:if(!Q&&!re){G.push(te),te="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":re=!0;break;case"]":re=!1;break}te+=ve}return te&&G.push(te),G}function a(Y){if(!Y)return"";let Z="";const G=S(Y,e.GLOB_SPLIT);if(G.every(Q=>Q===e.GLOBSTAR))Z=".*";else{let Q=!1;G.forEach((re,te)=>{if(re===e.GLOBSTAR){if(Q)return;Z+=C(2,te===G.length-1)}else{let ve=!1,Ie="",J=!1,$="";for(const ne of re){if(ne!=="}"&&ve){Ie+=ne;continue}if(J&&(ne!=="]"||!$)){let be;ne==="-"?be=ne:(ne==="^"||ne==="!")&&!$?be="^":ne===e.GLOB_SPLIT?be="":be=(0,p.escapeRegExpCharacters)(ne),$+=be;continue}switch(ne){case"{":ve=!0;continue;case"[":J=!0;continue;case"}":{const Ce=`(?:${S(Ie,",").map(ae=>a(ae)).join("|")})`;Z+=Ce,ve=!1,Ie="";break}case"]":{Z+="["+$+"]",J=!1,$="";break}case"?":Z+=I;continue;case"*":Z+=C(1);continue;default:Z+=(0,p.escapeRegExpCharacters)(ne)}}te<G.length-1&&(G[te+1]!==e.GLOBSTAR||te+2<G.length)&&(Z+=A)}Q=re===e.GLOBSTAR})}return Z}const m=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),f=function(){return!1},h=function(){return null};function l(Y,Z){if(!Y)return h;let G;typeof Y!="string"?G=Y.pattern:G=Y,G=G.trim();const Q=`${G}_${!!Z.trimForExclusions}`;let re=t.get(Q);if(re)return u(re,Y);let te;return m.test(G)?re=g(G.substr(4),G):(te=o.exec(d(G,Z)))?re=D(te[1],G):(Z.trimForExclusions?i:n).test(G)?re=E(G,Z):(te=r.exec(d(G,Z)))?re=_(te[1].substr(1),G,!0):(te=s.exec(d(G,Z)))?re=_(te[1],G,!1):re=y(G),t.set(Q,re),u(re,Y)}function u(Y,Z){if(typeof Z=="string")return Y;const G=function(Q,re){return(0,L.isEqualOrParent)(Q,Z.base,!b.isLinux)?Y((0,p.ltrim)(Q.substr(Z.base.length),R.sep),re):null};return G.allBasenames=Y.allBasenames,G.allPaths=Y.allPaths,G.basenames=Y.basenames,G.patterns=Y.patterns,G}function d(Y,Z){return Z.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function g(Y,Z){return function(G,Q){return typeof G=="string"&&G.endsWith(Y)?Z:null}}function D(Y,Z){const G=`/${Y}`,Q=`\\${Y}`,re=function(ve,Ie){return typeof ve!="string"?null:Ie?Ie===Y?Z:null:ve===Y||ve.endsWith(G)||ve.endsWith(Q)?Z:null},te=[Y];return re.basenames=te,re.patterns=[Z],re.allBasenames=te,re}function E(Y,Z){const G=B(Y.slice(1,-1).split(",").map(Ie=>l(Ie,Z)).filter(Ie=>Ie!==h),Y),Q=G.length;if(!Q)return h;if(Q===1)return G[0];const re=function(Ie,J){for(let $=0,ne=G.length;$<ne;$++)if(G[$](Ie,J))return Y;return null},te=G.find(Ie=>!!Ie.allBasenames);te&&(re.allBasenames=te.allBasenames);const ve=G.reduce((Ie,J)=>J.allPaths?Ie.concat(J.allPaths):Ie,[]);return ve.length&&(re.allPaths=ve),re}function _(Y,Z,G){const Q=R.sep===R.posix.sep,re=Q?Y:Y.replace(v,R.sep),te=R.sep+re,ve=R.posix.sep+Y;let Ie;return G?Ie=function(J,$){return typeof J=="string"&&(J===re||J.endsWith(te)||!Q&&(J===Y||J.endsWith(ve)))?Z:null}:Ie=function(J,$){return typeof J=="string"&&(J===re||!Q&&J===Y)?Z:null},Ie.allPaths=[(G?"*/":"./")+Y],Ie}function y(Y){try{const Z=new RegExp(`^${a(Y)}$`);return function(G){return Z.lastIndex=0,typeof G=="string"&&Z.test(G)?Y:null}}catch{return h}}function P(Y,Z,G){return!Y||typeof Z!="string"?!1:k(Y)(Z,void 0,G)}function k(Y,Z={}){if(!Y)return f;if(typeof Y=="string"||z(Y)){const G=l(Y,Z);if(G===h)return f;const Q=function(re,te){return!!G(re,te)};return G.allBasenames&&(Q.allBasenames=G.allBasenames),G.allPaths&&(Q.allPaths=G.allPaths),Q}return N(Y,Z)}function z(Y){const Z=Y;return Z?typeof Z.base=="string"&&typeof Z.pattern=="string":!1}function x(Y){return Y.allBasenames||[]}function F(Y){return Y.allPaths||[]}function N(Y,Z){const G=B(Object.getOwnPropertyNames(Y).map(Ie=>M(Ie,Y[Ie],Z)).filter(Ie=>Ie!==h)),Q=G.length;if(!Q)return h;if(!G.some(Ie=>!!Ie.requiresSiblings)){if(Q===1)return G[0];const Ie=function(ne,be){let Ce;for(let ae=0,ce=G.length;ae<ce;ae++){const se=G[ae](ne,be);if(typeof se=="string")return se;(0,O.isThenable)(se)&&(Ce||(Ce=[]),Ce.push(se))}return Ce?(async()=>{for(const ae of Ce){const ce=await ae;if(typeof ce=="string")return ce}return null})():null},J=G.find(ne=>!!ne.allBasenames);J&&(Ie.allBasenames=J.allBasenames);const $=G.reduce((ne,be)=>be.allPaths?ne.concat(be.allPaths):ne,[]);return $.length&&(Ie.allPaths=$),Ie}const re=function(Ie,J,$){let ne,be;for(let Ce=0,ae=G.length;Ce<ae;Ce++){const ce=G[Ce];ce.requiresSiblings&&$&&(J||(J=(0,R.basename)(Ie)),ne||(ne=J.substr(0,J.length-(0,R.extname)(Ie).length)));const se=ce(Ie,J,ne,$);if(typeof se=="string")return se;(0,O.isThenable)(se)&&(be||(be=[]),be.push(se))}return be?(async()=>{for(const Ce of be){const ae=await Ce;if(typeof ae=="string")return ae}return null})():null},te=G.find(Ie=>!!Ie.allBasenames);te&&(re.allBasenames=te.allBasenames);const ve=G.reduce((Ie,J)=>J.allPaths?Ie.concat(J.allPaths):Ie,[]);return ve.length&&(re.allPaths=ve),re}function M(Y,Z,G){if(Z===!1)return h;const Q=l(Y,G);if(Q===h)return h;if(typeof Z=="boolean")return Q;if(Z){const re=Z.when;if(typeof re=="string"){const te=(ve,Ie,J,$)=>{if(!$||!Q(ve,Ie))return null;const ne=re.replace("$(basename)",()=>J),be=$(ne);return(0,O.isThenable)(be)?be.then(Ce=>Ce?Y:null):be?Y:null};return te.requiresSiblings=!0,te}}return Q}function B(Y,Z){const G=Y.filter(Ie=>!!Ie.basenames);if(G.length<2)return Y;const Q=G.reduce((Ie,J)=>{const $=J.basenames;return $?Ie.concat($):Ie},[]);let re;if(Z){re=[];for(let Ie=0,J=Q.length;Ie<J;Ie++)re.push(Z)}else re=G.reduce((Ie,J)=>{const $=J.patterns;return $?Ie.concat($):Ie},[]);const te=function(Ie,J){if(typeof Ie!="string")return null;if(!J){let ne;for(ne=Ie.length;ne>0;ne--){const be=Ie.charCodeAt(ne-1);if(be===47||be===92)break}J=Ie.substr(ne)}const $=Q.indexOf(J);return $!==-1?re[$]:null};te.basenames=Q,te.patterns=re,te.allBasenames=Q;const ve=Y.filter(Ie=>!Ie.basenames);return ve.push(te),ve}function W(Y,Z){return(0,c.equals)(Y,Z,(G,Q)=>typeof G=="string"&&typeof Q=="string"?G===Q:typeof G!="string"&&typeof Q!="string"?G.base===Q.base&&G.pattern===Q.pattern:!1)}}),define(ye[80],_e([1,0,13,171,23,14,2]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0,e.isEmptyMarkdownString=w,e.isMarkdownString=A,e.markdownStringEqual=I,e.escapeMarkdownSyntaxTokens=v,e.appendEscapedMarkdownCodeBlockFence=C,e.escapeDoubleQuotes=S,e.removeMarkdownEscapes=a,e.parseHrefAndDimensions=m;var b;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class p{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=v(this.supportThemeIcons?(0,O.escapeIcons)(n):n).replace(/([ \t]+)/g,(r,s)=>"&nbsp;".repeat(s.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${C(i,n)}
`,this}appendLink(n,i,r){return this.value+="[",this.value+=this._escape(i,"]"),this.value+="](",this.value+=this._escape(String(n),")"),r&&(this.value+=` "${this._escape(this._escape(r,'"'),")")}"`),this.value+=")",this}_escape(n,i){const r=new RegExp((0,T.escapeRegExpCharacters)(i),"g");return n.replace(r,(s,t)=>n.charAt(t-1)!=="\\"?`\\${s}`:s)}}e.MarkdownString=p;function w(o){return A(o)?!o.value:Array.isArray(o)?o.every(w):!0}function A(o){return o instanceof p?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function I(o,n){return o===n?!0:!o||!n?!1:o.value===n.value&&o.isTrusted===n.isTrusted&&o.supportThemeIcons===n.supportThemeIcons&&o.supportHtml===n.supportHtml&&(o.baseUri===n.baseUri||!!o.baseUri&&!!n.baseUri&&(0,L.isEqual)(R.URI.from(o.baseUri),R.URI.from(n.baseUri)))}function v(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function C(o,n){const i=o.match(/^`+/gm)?.reduce((s,t)=>s.length>t.length?s:t).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${n}`,o,`${"`".repeat(r)}`].join(`
`)}function S(o){return o.replace(/"/g,"&quot;")}function a(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(o){const n=[],i=o.split("|").map(s=>s.trim());o=i[0];const r=i[1];if(r){const s=/height=(\d+)/.exec(r),t=/width=(\d+)/.exec(r),f=s?s[1]:"",h=t?t[1]:"",l=isFinite(parseInt(h)),u=isFinite(parseInt(f));l&&n.push(`width="${h}"`),u&&n.push(`height="${f}"`)}return{href:o,dimensions:n}}}),define(ye[103],_e([1,0,19,34,17,11,23,14]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=p,e.normalizeDriveLetter=A,e.tildify=v,e.untildify=C,e.shorten=o,e.template=i,e.mnemonicMenuLabel=r,e.mnemonicButtonLabel=s,e.unmnemonicLabel=t,e.splitRecentLabel=f;function p(l,u){const{os:d,tildify:g,relative:D}=u;if(D){const y=w(l,D,d);if(typeof y=="string")return y}let E=l.fsPath;if(d===1&&!T.isWindows?E=E.replace(/\//g,"\\"):d!==1&&T.isWindows&&(E=E.replace(/\\/g,"/")),d!==1&&g?.userHome){const y=g.userHome.fsPath;let P;l.scheme!==g.userHome.scheme&&l.path[0]===L.posix.sep&&l.path[1]!==L.posix.sep?P=g.userHome.with({path:l.path}).fsPath:P=E,E=v(P,y,d)}return(d===1?L.win32:L.posix).normalize(A(E,d===1))}function w(l,u,d){const g=d===1?L.win32:L.posix,D=d===3?R.extUri:R.extUriIgnorePathCase,E=u.getWorkspace(),_=(0,c.firstOrDefault)(E.folders);if(!_)return;l.scheme!==_.uri.scheme&&l.path[0]===L.posix.sep&&l.path[1]!==L.posix.sep&&(l=_.uri.with({path:l.path}));const y=u.getWorkspaceFolder(l);if(!y)return;let P;if(D.isEqual(y.uri,l)?P="":P=D.relativePath(y.uri,l)??"",P&&(P=g.normalize(P)),E.folders.length>1&&!u.noPrefix){const k=y.name?y.name:D.basenameOrAuthority(y.uri);P=P?`${k} \u2022 ${P}`:k}return P}function A(l,u=T.isWindows){return(0,O.hasDriveLetter)(l,u)?l.charAt(0).toUpperCase()+l.slice(1):l}let I=Object.create(null);function v(l,u,d=T.OS){if(d===1||!l||!u)return l;let g=I.original===u?I.normalized:void 0;g||(g=u,T.isWindows&&(g=(0,O.toSlashes)(g)),g=`${(0,b.rtrim)(g,L.posix.sep)}${L.posix.sep}`,I={original:u,normalized:g});let D=l;return T.isWindows&&(D=(0,O.toSlashes)(D)),(d===3?D.startsWith(g):(0,b.startsWithIgnoreCase)(D,g))?`~/${D.substr(g.length)}`:l}function C(l,u){return l.replace(/^~($|\/|\\)/,`${u}$1`)}const S="\u2026",a="\\\\",m="~";function o(l,u=L.sep){const d=new Array(l.length);let g=!1;for(let D=0;D<l.length;D++){const E=l[D];if(E===""){d[D]=`.${u}`;continue}if(!E){d[D]=E;continue}g=!0;let _="",y=E;y.indexOf(a)===0?(_=y.substr(0,y.indexOf(a)+a.length),y=y.substr(y.indexOf(a)+a.length)):y.indexOf(u)===0?(_=y.substr(0,y.indexOf(u)+u.length),y=y.substr(y.indexOf(u)+u.length)):y.indexOf(m)===0&&(_=y.substr(0,y.indexOf(m)+m.length),y=y.substr(y.indexOf(m)+m.length));const P=y.split(u);for(let k=1;g&&k<=P.length;k++)for(let z=P.length-k;g&&z>=0;z--){g=!1;let x=P.slice(z,z+k).join(u);for(let F=0;!g&&F<l.length;F++)if(F!==D&&l[F]&&l[F].indexOf(x)>-1){const N=z+k===P.length,M=z>0&&l[F].indexOf(u)>-1?u+x:x,B=l[F].endsWith(M);g=!N||B}if(!g){let F="";(P[0].endsWith(":")||_!=="")&&(z===1&&(z=0,k++,x=P[0]+u+x),z>0&&(F=P[0]+u),F=_+F),z>0&&(F=F+S+u),F=F+x,z+k<P.length&&(F=F+u+S),d[D]=F}}g&&(d[D]=E)}return d}var n;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(l,u=Object.create(null)){const d=[];let g=!1,D="";for(const E of l)if(E==="$"||g&&E==="{")D&&d.push({value:D,type:n.TEXT}),D="",g=!0;else if(E==="}"&&g){const _=u[D];if(typeof _=="string")_.length&&d.push({value:_,type:n.VARIABLE});else if(_){const y=d[d.length-1];(!y||y.type!==n.SEPARATOR)&&d.push({value:_.label,type:n.SEPARATOR})}D="",g=!1}else D+=E;return D&&!g&&d.push({value:D,type:n.TEXT}),d.filter((E,_)=>{if(E.type===n.SEPARATOR){const y=d[_-1],P=d[_+1];return[y,P].every(k=>k&&(k.type===n.VARIABLE||k.type===n.TEXT)&&k.value.length>0)}return!0}).map(E=>E.value).join("")}function r(l,u){return T.isMacintosh||u?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):l.replace(/&&|&/g,d=>d==="&"?"&&":"&")}function s(l,u){return T.isMacintosh||u?l.replace(/\(&&\w\)|&&/g,""):T.isWindows?l.replace(/&&|&/g,d=>d==="&"?"&&":"&"):l.replace(/&&/g,"_")}function t(l){return l.replace(/&/g,"&&")}function f(l){if(l.endsWith("]")){const u=l.lastIndexOf(" [",l.length-2);if(u!==-1){const d=h(l.substring(0,u)),g=l.substring(u);return{name:d.name+g,parentPath:d.parentPath}}}return h(l)}function h(l){const u=l.indexOf("/")!==-1?L.posix:L.win32,d=u.basename(l),g=u.dirname(l);return d.length?{name:d,parentPath:g}:{name:g,parentPath:""}}}),define(ye[133],_e([1,0,21,2]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=b,e.transformIncomingURIs=w,e.transformAndReviveIncomingURIs=A;function L(I){return I.toJSON()}class T{constructor(v){this._uriTransformer=v}transformIncoming(v){const C=this._uriTransformer.transformIncoming(v);return C===v?v:L(O.URI.from(C))}transformOutgoing(v){const C=this._uriTransformer.transformOutgoing(v);return C===v?v:L(O.URI.from(C))}transformOutgoingURI(v){const C=this._uriTransformer.transformOutgoing(v);return C===v?v:O.URI.from(C)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,v,C){if(!I||C>200)return null;if(typeof I=="object"){if(I instanceof O.URI)return v.transformOutgoing(I);for(const S in I)if(Object.hasOwnProperty.call(I,S)){const a=R(I[S],v,C+1);a!==null&&(I[S]=a)}}return null}function b(I,v){const C=R(I,v,0);return C===null?I:C}function p(I,v,C,S){if(!I||S>200)return null;if(typeof I=="object"){if(I.$mid===1)return C?O.URI.revive(v.transformIncoming(I)):v.transformIncoming(I);if(I instanceof c.VSBuffer)return null;for(const a in I)if(Object.hasOwnProperty.call(I,a)){const m=p(I[a],v,C,S+1);m!==null&&(I[a]=m)}}return null}function w(I,v){const C=p(I,v,!1,0);return C===null?I:C}function A(I,v){const C=p(I,v,!0,0);return C===null?I:C}}),define(ye[31],_e([1,0,51,63,395,8,34,76,17,11,23,2]),function(de,e,c,O,L,T,R,b,p,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=d,e.writeFileSync=D;var v;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function C(M,B=v.UNLINK,W){if((0,R.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return B===v.UNLINK?a(M):S(M,W)}async function S(M,B=(0,R.randomPath)((0,O.tmpdir)())){try{try{await c.promises.rename(M,B)}catch(W){return W.code==="ENOENT"?void 0:a(M)}a(B).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function a(M){return(0,L.promisify)(c.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function m(M){if((0,R.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");c.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}async function o(M,B){return r(await(B?n(M):(0,L.promisify)(c.readdir)(M)))}async function n(M){try{return await(0,L.promisify)(c.readdir)(M,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const B=[],W=await o(M);for(const Y of W){let Z=!1,G=!1,Q=!1;try{const re=await e.Promises.lstat((0,p.join)(M,Y));Z=re.isFile(),G=re.isDirectory(),Q=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}B.push({name:Y,isFile:()=>Z,isDirectory:()=>G,isSymbolicLink:()=>Q})}return B}function i(M){return r(c.readdirSync(M))}function r(M){return M.map(B=>typeof B=="string"?w.isMacintosh?(0,b.normalizeNFC)(B):B:(B.name=w.isMacintosh?(0,b.normalizeNFC)(B.name):B.name,B))}async function s(M){const B=await o(M),W=[];for(const Y of B)await f.existsDirectory((0,p.join)(M,Y))&&W.push(Y);return W}function t(M,B=1e3){return new Promise(W=>{let Y=!1;const Z=setInterval(()=>{Y||(Y=!0,c.access(M,G=>{Y=!1,G&&(clearInterval(Z),W(void 0))}))},B)})}var f;(function(M){async function B(Z){let G;try{if(G=await e.Promises.lstat(Z),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(w.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw re}throw Q}}M.stat=B;async function W(Z){try{const{stat:G,symbolicLink:Q}=await M.stat(Z);return G.isFile()&&Q?.dangling!==!0}catch{}return!1}M.existsFile=W;async function Y(Z){try{const{stat:G,symbolicLink:Q}=await M.stat(Z);return G.isDirectory()&&Q?.dangling!==!0}catch{}return!1}M.existsDirectory=Y})(f||(e.SymlinkSupport=f={}));const h=new T.ResourceQueue;function l(M,B,W){return h.queueFor(I.URI.file(M),()=>{const Y=E(W);return new Promise((Z,G)=>g(M,B,Y,Q=>Q?G(Q):Z()))},A.extUriBiasedIgnorePathCase)}let u=!0;function d(M){u=M}function g(M,B,W,Y){if(!u)return c.writeFile(M,B,{mode:W.mode,flag:W.flag},Y);c.open(M,W.flag,W.mode,(Z,G)=>{if(Z)return Y(Z);c.writeFile(G,B,Q=>{if(Q)return c.close(G,()=>Y(Q));c.fdatasync(G,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),d(!1)),c.close(G,te=>Y(te))))})})}function D(M,B,W){const Y=E(W);if(!u)return c.writeFileSync(M,B,{mode:Y.mode,flag:Y.flag});const Z=c.openSync(M,Y.flag,Y.mode);try{c.writeFileSync(Z,B);try{c.fdatasyncSync(Z)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),d(!1)}}finally{c.closeSync(Z)}}function E(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function _(M,B,W=6e4){if(M!==B)try{w.isWindows&&typeof W=="number"?await y(M,B,Date.now(),W):await(0,L.promisify)(c.rename)(M,B)}catch(Y){if(M.toLowerCase()!==B.toLowerCase()&&Y.code==="EXDEV"||M.endsWith("."))await P(M,B,{preserveSymlinks:!1}),await C(M,v.MOVE);else throw Y}}async function y(M,B,W,Y,Z=0){try{return await(0,L.promisify)(c.rename)(M,B)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-W>=Y)throw console.error(`[node.js fs] rename failed after ${Z} retries with error: ${G}`),G;if(Z===0){let Q=!1;try{const{stat:re}=await f.stat(B);re.isFile()||(Q=!0)}catch{}if(Q)throw G}return await(0,T.timeout)(Math.min(100,Z*10)),y(M,B,W,Y,Z+1)}}async function P(M,B,W){return z(M,B,{root:{source:M,target:B},options:W,handledSourcePaths:new Set})}const k=511;async function z(M,B,W){if(W.handledSourcePaths.has(M))return;W.handledSourcePaths.add(M);const{stat:Y,symbolicLink:Z}=await f.stat(M);if(Z){if(W.options.preserveSymlinks)try{return await N(M,B,W)}catch{}if(Z.dangling)return}return Y.isDirectory()?x(M,B,Y.mode&k,W):F(M,B,Y.mode&k)}async function x(M,B,W,Y){await e.Promises.mkdir(B,{recursive:!0,mode:W});const Z=await o(M);for(const G of Z)await z((0,p.join)(M,G),(0,p.join)(B,G),Y)}async function F(M,B,W){await e.Promises.copyFile(M,B),await e.Promises.chmod(B,W)}async function N(M,B,W){let Y=await e.Promises.readlink(M);(0,R.isEqualOrParent)(Y,W.root.source,!w.isLinux)&&(Y=(0,p.join)(W.root.target,Y.substr(W.root.source.length+1))),await e.Promises.symlink(Y,B)}e.Promises=new class{get access(){return(0,L.promisify)(c.access)}get stat(){return(0,L.promisify)(c.stat)}get lstat(){return(0,L.promisify)(c.lstat)}get utimes(){return(0,L.promisify)(c.utimes)}get read(){return(M,B,W,Y,Z)=>new Promise((G,Q)=>{c.read(M,B,W,Y,Z,(re,te,ve)=>re?Q(re):G({bytesRead:te,buffer:ve}))})}get readFile(){return(0,L.promisify)(c.readFile)}get write(){return(M,B,W,Y,Z)=>new Promise((G,Q)=>{c.write(M,B,W,Y,Z,(re,te,ve)=>re?Q(re):G({bytesWritten:te,buffer:ve}))})}get appendFile(){return(0,L.promisify)(c.appendFile)}get fdatasync(){return(0,L.promisify)(c.fdatasync)}get truncate(){return(0,L.promisify)(c.truncate)}get copyFile(){return(0,L.promisify)(c.copyFile)}get open(){return(0,L.promisify)(c.open)}get close(){return(0,L.promisify)(c.close)}get symlink(){return(0,L.promisify)(c.symlink)}get readlink(){return(0,L.promisify)(c.readlink)}get chmod(){return(0,L.promisify)(c.chmod)}get mkdir(){return(0,L.promisify)(c.mkdir)}get unlink(){return(0,L.promisify)(c.unlink)}get rmdir(){return(0,L.promisify)(c.rmdir)}get realpath(){return(0,L.promisify)(c.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return s}get writeFile(){return l}get rm(){return C}get rename(){return _}get copy(){return P}}}),define(ye[104],_e([1,0,51,17,11,14,31]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=b,e.realcase=p,e.realpath=w,e.realpathSync=A;function b(v){if(L.isLinux)return v;const C=(0,O.dirname)(v);if(v===C)return v;const S=((0,O.basename)(v)||v).toLowerCase();try{const m=(0,R.readdirSync)(C).filter(o=>o.toLowerCase()===S);if(m.length===1){const o=b(C);if(o)return(0,O.join)(o,m[0])}else if(m.length>1){const o=m.indexOf(S);if(o>=0){const n=b(C);if(n)return(0,O.join)(n,m[o])}}}catch{}return null}async function p(v,C){if(L.isLinux)return v;const S=(0,O.dirname)(v);if(v===S)return v;const a=((0,O.basename)(v)||v).toLowerCase();try{if(C?.isCancellationRequested)return null;const o=(await R.Promises.readdir(S)).filter(n=>n.toLowerCase()===a);if(o.length===1){const n=await p(S,C);if(n)return(0,O.join)(n,o[0])}else if(o.length>1){const n=o.indexOf(a);if(n>=0){const i=await p(S,C);if(i)return(0,O.join)(i,o[n])}}}catch{}return null}async function w(v){try{return await R.Promises.realpath(v)}catch{const S=I(v);return await R.Promises.access(S,c.constants.R_OK),S}}function A(v){try{return c.realpathSync(v)}catch{const S=I(v);return c.accessSync(S,c.constants.R_OK),S}}function I(v){return(0,T.rtrim)((0,O.normalize)(v),O.sep)}}),define(ye[105],_e([1,0,17,11,50,102,18,31]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=p,e.createQueuedSender=w,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function p(I=L.env){return I.comspec||"cmd.exe"}function w(I){let v=[],C=!1;const S=function(a){if(C){v.push(a);return}(!I.send(a,o=>{if(o&&console.error(o),C=!1,v.length>0){const n=v.slice(0);v=[],n.forEach(i=>S(i))}})||O.isWindows)&&(C=!0)};return{send:S}}var A;(function(I){async function v(C,S,a){if(c.isAbsolute(C))return C;if(S===void 0&&(S=L.cwd()),c.dirname(C)!=="."||(a===void 0&&R.isString(L.env.PATH)&&(a=L.env.PATH.split(c.delimiter)),a===void 0||a.length===0))return c.join(S,C);async function o(n){if(await b.Promises.exists(n)){let i;try{i=await b.Promises.stat(n)}catch(r){r.message.startsWith("EACCES")&&(i=await b.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of a){let i;if(c.isAbsolute(n)?i=c.join(n,C):i=c.join(S,n,C),await o(i))return i;let r=i+".com";if(await o(r)||(r=i+".exe",await o(r)))return r}return c.join(S,C)}I.findExecutable=v})(A||(e.win32=A={}))});var Ge=this&&this.__decorate||function(de,e,c,O){var L=arguments.length,T=L<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,c):O,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(de,e,c,O);else for(var b=de.length-1;b>=0;b--)(R=de[b])&&(T=(L<3?R(T):L>3?R(e,c,T):R(e,c))||T);return L>3&&T&&Object.defineProperty(e,c,T),T};define(ye[81],_e([1,0,19,8,21,22,54,13,4,3,57,14,18]),function(de,e,c,O,L,T,R,b,p,w,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=d,e.deserialize=g,e.getDelayedChannel=k,e.getNextTickChannel=z;var C;(function(Z){Z[Z.Promise=100]="Promise",Z[Z.PromiseCancel=101]="PromiseCancel",Z[Z.EventListen=102]="EventListen",Z[Z.EventDispose=103]="EventDispose"})(C||(C={}));function S(Z){switch(Z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(Z){Z[Z.Initialize=200]="Initialize",Z[Z.PromiseSuccess=201]="PromiseSuccess",Z[Z.PromiseError=202]="PromiseError",Z[Z.PromiseErrorObj=203]="PromiseErrorObj",Z[Z.EventFire=204]="EventFire"})(a||(a={}));function m(Z){switch(Z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(Z){Z[Z.Uninitialized=0]="Uninitialized",Z[Z.Idle=1]="Idle"})(o||(o={}));function n(Z){let G=0;for(let Q=0;;Q+=7){const re=Z.read(1);if(G|=(re.buffer[0]&127)<<Q,!(re.buffer[0]&128))return G}}const i=h(0);function r(Z,G){if(G===0){Z.write(i);return}let Q=0;for(let te=G;te!==0;te=te>>>7)Q++;const re=L.VSBuffer.alloc(Q);for(let te=0;G!==0;te++)re.buffer[te]=G&127,G=G>>>7,G>0&&(re.buffer[te]|=128);Z.write(re)}class s{constructor(G){this.buffer=G,this.pos=0}read(G){const Q=this.buffer.slice(this.pos,this.pos+G);return this.pos+=Q.byteLength,Q}}e.BufferReader=s;class t{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(G){this.buffers.push(G)}}e.BufferWriter=t;var f;(function(Z){Z[Z.Undefined=0]="Undefined",Z[Z.String=1]="String",Z[Z.Buffer=2]="Buffer",Z[Z.VSBuffer=3]="VSBuffer",Z[Z.Array=4]="Array",Z[Z.Object=5]="Object",Z[Z.Int=6]="Int"})(f||(f={}));function h(Z){const G=L.VSBuffer.alloc(1);return G.writeUInt8(Z,0),G}const l={Undefined:h(f.Undefined),String:h(f.String),Buffer:h(f.Buffer),VSBuffer:h(f.VSBuffer),Array:h(f.Array),Object:h(f.Object),Uint:h(f.Int)},u=typeof Buffer<"u";function d(Z,G){if(typeof G>"u")Z.write(l.Undefined);else if(typeof G=="string"){const Q=L.VSBuffer.fromString(G);Z.write(l.String),r(Z,Q.byteLength),Z.write(Q)}else if(u&&Buffer.isBuffer(G)){const Q=L.VSBuffer.wrap(G);Z.write(l.Buffer),r(Z,Q.byteLength),Z.write(Q)}else if(G instanceof L.VSBuffer)Z.write(l.VSBuffer),r(Z,G.byteLength),Z.write(G);else if(Array.isArray(G)){Z.write(l.Array),r(Z,G.length);for(const Q of G)d(Z,Q)}else if(typeof G=="number"&&(G|0)===G)Z.write(l.Uint),r(Z,G);else{const Q=L.VSBuffer.fromString(JSON.stringify(G));Z.write(l.Object),r(Z,Q.byteLength),Z.write(Q)}}function g(Z){switch(Z.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return Z.read(n(Z)).toString();case f.Buffer:return Z.read(n(Z)).buffer;case f.VSBuffer:return Z.read(n(Z));case f.Array:{const Q=n(Z),re=[];for(let te=0;te<Q;te++)re.push(g(Z));return re}case f.Object:return JSON.parse(Z.read(n(Z)).toString());case f.Int:return n(Z)}}class D{constructor(G,Q,re=null,te=1e3){this.protocol=G,this.ctx=Q,this.logger=re,this.timeoutDelay=te,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ve=>this.onRawMessage(ve)),this.sendResponse({type:200})}registerChannel(G,Q){this.channels.set(G,Q),setTimeout(()=>this.flushPendingRequests(G),0)}sendResponse(G){switch(G.type){case 200:{const Q=this.send([G.type]);this.logger?.logOutgoing(Q,0,1,m(G.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([G.type,G.id],G.data);this.logger?.logOutgoing(Q,G.id,1,m(G.type),G.data);return}}}send(G,Q=void 0){const re=new t;return d(re,G),d(re,Q),this.sendBuffer(re.buffer)}sendBuffer(G){try{return this.protocol.send(G),G.byteLength}catch{return 0}}onRawMessage(G){const Q=new s(G),re=g(Q),te=g(Q),ve=re[0];switch(ve){case 100:return this.logger?.logIncoming(G.byteLength,re[1],1,`${S(ve)}: ${re[2]}.${re[3]}`,te),this.onPromise({type:ve,id:re[1],channelName:re[2],name:re[3],arg:te});case 102:return this.logger?.logIncoming(G.byteLength,re[1],1,`${S(ve)}: ${re[2]}.${re[3]}`,te),this.onEventListen({type:ve,id:re[1],channelName:re[2],name:re[3],arg:te});case 101:return this.logger?.logIncoming(G.byteLength,re[1],1,`${S(ve)}`),this.disposeActiveRequest({type:ve,id:re[1]});case 103:return this.logger?.logIncoming(G.byteLength,re[1],1,`${S(ve)}`),this.disposeActiveRequest({type:ve,id:re[1]})}}onPromise(G){const Q=this.channels.get(G.channelName);if(!Q){this.collectPendingRequest(G);return}const re=new T.CancellationTokenSource;let te;try{te=Q.call(this.ctx,G.name,G.arg,re.token)}catch(J){te=Promise.reject(J)}const ve=G.id;te.then(J=>{this.sendResponse({id:ve,data:J,type:201})},J=>{J instanceof Error?this.sendResponse({id:ve,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.sendResponse({id:ve,data:J,type:203})}).finally(()=>{Ie.dispose(),this.activeRequests.delete(G.id)});const Ie=(0,w.toDisposable)(()=>re.cancel());this.activeRequests.set(G.id,Ie)}onEventListen(G){const Q=this.channels.get(G.channelName);if(!Q){this.collectPendingRequest(G);return}const re=G.id,ve=Q.listen(this.ctx,G.name,G.arg)(Ie=>this.sendResponse({id:re,data:Ie,type:204}));this.activeRequests.set(G.id,ve)}disposeActiveRequest(G){const Q=this.activeRequests.get(G.id);Q&&(Q.dispose(),this.activeRequests.delete(G.id))}collectPendingRequest(G){let Q=this.pendingRequests.get(G.channelName);Q||(Q=[],this.pendingRequests.set(G.channelName,Q));const re=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.sendResponse({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:G,timeoutTimer:re})}flushPendingRequests(G){const Q=this.pendingRequests.get(G);if(Q){for(const re of Q)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.onPromise(re.request);break;case 102:this.onEventListen(re.request);break}this.pendingRequests.delete(G)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=D;var E;(function(Z){Z[Z.LocalSide=0]="LocalSide",Z[Z.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));class _{constructor(G,Q=null){this.protocol=G,this.isDisposed=!1,this.state=o.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(re=>this.onBuffer(re)),this.logger=Q}getChannel(G){const Q=this;return{call(re,te,ve){return Q.isDisposed?Promise.reject(new b.CancellationError):Q.requestPromise(G,re,te,ve)},listen(re,te){return Q.isDisposed?p.Event.None:Q.requestEvent(G,re,te)}}}requestPromise(G,Q,re,te=T.CancellationToken.None){const ve=this.lastRequestId++,J={id:ve,type:100,channelName:G,name:Q,arg:re};if(te.isCancellationRequested)return Promise.reject(new b.CancellationError);let $;return new Promise((be,Ce)=>{if(te.isCancellationRequested)return Ce(new b.CancellationError);const ae=()=>{const ie=ue=>{switch(ue.type){case 201:this.handlers.delete(ve),be(ue.data);break;case 202:{this.handlers.delete(ve);const he=new Error(ue.data.message);he.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,he.name=ue.data.name,Ce(he);break}case 203:this.handlers.delete(ve),Ce(ue.data);break}};this.handlers.set(ve,ie),this.sendRequest(J)};let ce=null;this.state===o.Idle?ae():(ce=(0,O.createCancelablePromise)(ie=>this.whenInitialized()),ce.then(()=>{ce=null,ae()}));const se=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:ve,type:101}),Ce(new b.CancellationError)},j=te.onCancellationRequested(se);$=(0,w.combinedDisposable)((0,w.toDisposable)(se),j),this.activeRequests.add($)}).finally(()=>{$.dispose(),this.activeRequests.delete($)})}requestEvent(G,Q,re){const te=this.lastRequestId++,Ie={id:te,type:102,channelName:G,name:Q,arg:re};let J=null;const $=new p.Emitter({onWillAddFirstListener:()=>{J=(0,O.createCancelablePromise)(be=>this.whenInitialized()),J.then(()=>{J=null,this.activeRequests.add($),this.sendRequest(Ie)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.activeRequests.delete($),this.sendRequest({id:te,type:103}))}}),ne=be=>$.fire(be.data);return this.handlers.set(te,ne),$.event}sendRequest(G){switch(G.type){case 100:case 102:{const Q=this.send([G.type,G.id,G.channelName,G.name],G.arg);this.logger?.logOutgoing(Q,G.id,0,`${S(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const Q=this.send([G.type,G.id]);this.logger?.logOutgoing(Q,G.id,0,S(G.type));return}}}send(G,Q=void 0){const re=new t;return d(re,G),d(re,Q),this.sendBuffer(re.buffer)}sendBuffer(G){try{return this.protocol.send(G),G.byteLength}catch{return 0}}onBuffer(G){const Q=new s(G),re=g(Q),te=g(Q),ve=re[0];switch(ve){case 200:return this.logger?.logIncoming(G.byteLength,0,0,m(ve)),this.onResponse({type:re[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(G.byteLength,re[1],0,m(ve),te),this.onResponse({type:re[0],id:re[1],data:te})}}onResponse(G){if(G.type===200){this.state=o.Idle,this._onDidInitialize.fire();return}this.handlers.get(G.id)?.(G)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=_,Ge([R.memoize],_.prototype,"onDidInitializePromise",null);class y{get connections(){const G=[];return this._connections.forEach(Q=>G.push(Q)),G}constructor(G,Q,re){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new w.DisposableStore,this.disposables.add(G(({protocol:te,onDidClientDisconnect:ve})=>{const Ie=p.Event.once(te.onMessage);this.disposables.add(Ie(J=>{const $=new s(J),ne=g($),be=new D(te,ne,Q,re),Ce=new _(te,Q);this.channels.forEach((ce,se)=>be.registerChannel(se,ce));const ae={channelServer:be,channelClient:Ce,ctx:ne};this._connections.add(ae),this._onDidAddConnection.fire(ae),this.disposables.add(ve(()=>{be.dispose(),Ce.dispose(),this._connections.delete(ae),this._onDidRemoveConnection.fire(ae)}))}))}))}getChannel(G,Q){const re=this;return{call(te,ve,Ie){let J;if((0,v.isFunction)(Q)){const ne=(0,c.getRandomElement)(re.connections.filter(Q));J=ne?Promise.resolve(ne):p.Event.toPromise(p.Event.filter(re.onDidAddConnection,Q))}else J=Q.routeCall(re,te,ve);const $=J.then(ne=>ne.channelClient.getChannel(G));return k($).call(te,ve,Ie)},listen(te,ve){if((0,v.isFunction)(Q))return re.getMulticastEvent(G,Q,te,ve);const Ie=Q.routeEvent(re,te,ve).then(J=>J.channelClient.getChannel(G));return k(Ie).listen(te,ve)}}}getMulticastEvent(G,Q,re,te){const ve=this;let Ie;const J=new p.Emitter({onWillAddFirstListener:()=>{Ie=new w.DisposableStore;const $=new p.EventMultiplexer,ne=new Map,be=ae=>{const se=ae.channelClient.getChannel(G).listen(re,te),j=$.add(se);ne.set(ae,j)},Ce=ae=>{const ce=ne.get(ae);ce&&(ce.dispose(),ne.delete(ae))};ve.connections.filter(Q).forEach(be),p.Event.filter(ve.onDidAddConnection,Q)(be,void 0,Ie),ve.onDidRemoveConnection(Ce,void 0,Ie),$.event(J.fire,J,Ie),Ie.add($)},onDidRemoveLastListener:()=>{Ie?.dispose(),Ie=void 0}});return J.event}registerChannel(G,Q){this.channels.set(G,Q);for(const re of this._connections)re.channelServer.registerChannel(G,Q)}dispose(){this.disposables.dispose();for(const G of this._connections)G.channelClient.dispose(),G.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=y;class P{constructor(G,Q,re=null){const te=new t;d(te,Q),G.send(te.buffer),this.channelClient=new _(G,re),this.channelServer=new D(G,Q,re)}getChannel(G){return this.channelClient.getChannel(G)}registerChannel(G,Q){this.channelServer.registerChannel(G,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=P;function k(Z){return{call(G,Q,re){return Z.then(te=>te.call(G,Q,re))},listen(G,Q){const re=new p.Relay;return Z.then(te=>re.input=te.listen(G,Q)),re.event}}}function z(Z){let G=!1;return{call(Q,re,te){return G?Z.call(Q,re,te):(0,O.timeout)(0).then(()=>G=!0).then(()=>Z.call(Q,re,te))},listen(Q,re){if(G)return Z.listen(Q,re);const te=new p.Relay;return(0,O.timeout)(0).then(()=>G=!0).then(()=>te.input=Z.listen(Q,re)),te.event}}}class x{constructor(G){this.fn=G}routeCall(G){return this.route(G)}routeEvent(G){return this.route(G)}async route(G){for(const Q of G.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await p.Event.toPromise(G.onDidAddConnection),await this.route(G)}}e.StaticRouter=x;var F;(function(Z){function G(ve,Ie,J){const $=ve,ne=J&&J.disableMarshalling,be=new Map;for(const Ce in $)re(Ce)&&be.set(Ce,p.Event.buffer($[Ce],!0,void 0,Ie));return new class{listen(Ce,ae,ce){const se=be.get(ae);if(se)return se;const j=$[ae];if(typeof j=="function"){if(te(ae))return j.call($,ce);if(re(ae))return be.set(ae,p.Event.buffer($[ae],!0,void 0,Ie)),be.get(ae)}throw new b.ErrorNoTelemetry(`Event not found: ${ae}`)}call(Ce,ae,ce){const se=$[ae];if(typeof se=="function"){if(!ne&&Array.isArray(ce))for(let ie=0;ie<ce.length;ie++)ce[ie]=(0,A.revive)(ce[ie]);let j=se.apply($,ce);return j instanceof Promise||(j=Promise.resolve(j)),j}throw new b.ErrorNoTelemetry(`Method not found: ${ae}`)}}}Z.fromService=G;function Q(ve,Ie){const J=Ie&&Ie.disableMarshalling;return new Proxy({},{get($,ne){if(typeof ne=="string")return Ie?.properties?.has(ne)?Ie.properties.get(ne):te(ne)?function(be){return ve.listen(ne,be)}:re(ne)?ve.listen(ne):async function(...be){let Ce;Ie&&!(0,v.isUndefinedOrNull)(Ie.context)?Ce=[Ie.context,...be]:Ce=be;const ae=await ve.call(ne,Ce);return J?ae:(0,A.revive)(ae)};throw new b.ErrorNoTelemetry(`Property not found: ${String(ne)}`)}})}Z.toService=Q;function re(ve){return ve[0]==="o"&&ve[1]==="n"&&I.isUpperAsciiLetter(ve.charCodeAt(2))}function te(ve){return/^onDynamic/.test(ve)&&I.isUpperAsciiLetter(ve.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(Z){if(Array.isArray(Z))return Z;if(Z&&typeof Z=="object"&&typeof Z.toString=="function"){const G=Z.toString();if(G!=="[object Object]")return G}return Z}function B(Z){return Array.isArray(Z)?Z.map(M):M(Z)}function W(Z,G,Q,re,te,ve,Ie){Ie=B(Ie);const J=N[te],$=J[re%J.length];let ne=[`%c[${Z}]%c[${String(G).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${ve}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(ve)?(ne=ne.concat(Ie),ne.push(")")):ne.push(Ie),console.log.apply(console,ne)}class Y{constructor(G,Q){this._outgoingPrefix=G,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(G,Q,re,te,ve){this._totalOutgoing+=G,W(this._outgoingPrefix,this._totalOutgoing,G,Q,re,te,ve)}logIncoming(G,Q,re,te,ve){this._totalIncoming+=G,W(this._incomingPrefix,this._totalIncoming,G,Q,re,te,ve)}}e.IPCLogger=Y}),define(ye[82],_e([1,0,21,4,3,81]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var b;(function(l){l.enableDiagnostics=!1,l.records=[];const u=new WeakMap;let d=0;function g(E,_){if(!u.has(E)){const y=String(++d);u.set(E,y)}return u.get(E)}function D(E,_,y,P){if(!l.enableDiagnostics)return;const k=g(E,_);if(P instanceof c.VSBuffer||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const z=c.VSBuffer.alloc(P.byteLength);z.set(P),l.records.push({timestamp:Date.now(),id:k,label:_,type:y,buff:z})}else l.records.push({timestamp:Date.now(),id:k,label:_,type:y,data:P})}l.traceSocketEvent=D})(b||(e.SocketDiagnostics=b={}));var p;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let w=null;function A(){return w||(w=c.VSBuffer.alloc(0)),w}class I{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(u){this._chunks.push(u),this._totalLength+=u.byteLength}read(u){return this._read(u,!0)}peek(u){return this._read(u,!1)}_read(u,d){if(u===0)return A();if(u>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===u){const _=this._chunks[0];return d&&(this._chunks.shift(),this._totalLength-=u),_}if(this._chunks[0].byteLength>u){const _=this._chunks[0].slice(0,u);return d&&(this._chunks[0]=this._chunks[0].slice(u),this._totalLength-=u),_}const g=c.VSBuffer.alloc(u);let D=0,E=0;for(;u>0;){const _=this._chunks[E];if(_.byteLength>u){const y=_.slice(0,u);g.set(y,D),D+=u,d&&(this._chunks[E]=_.slice(u),this._totalLength-=u),u-=u}else g.set(_,D),D+=_.byteLength,d?(this._chunks.shift(),this._totalLength-=_.byteLength):E++,u-=_.byteLength}return g}}e.ChunkStream=I;var v;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(v||(v={}));function C(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class a{constructor(u,d,g,D){this.type=u,this.id=d,this.ack=g,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends L.Disposable{constructor(u){super(),this._onMessage=this._register(new O.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=u,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(u){if(!(!u||u.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;){const d=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=d.readUInt32BE(9),this._state.messageType=d.readUInt8(0),this._state.id=d.readUInt32BE(1),this._state.ack=d.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:C(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const g=this._state.messageType,D=this._state.id,E=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",d),this._onMessage.fire(new a(g,D,E,d)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class o{constructor(u){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=u,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(u){if(this._isDisposed)return;u.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=c.VSBuffer.alloc(13);d.writeUInt8(u.type,0),d.writeUInt32BE(u.id,1),d.writeUInt32BE(u.ack,5),d.writeUInt32BE(u.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:C(u.type),id:u.id,ack:u.ack,messageSize:u.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",u.data),this._writeSoon(d,u.data)}_bufferAdd(u,d){const g=this._totalLength===0;return this._data.push(u,d),this._totalLength+=u.byteLength+d.byteLength,g}_bufferTake(){const u=c.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,u}_writeSoon(u,d){this._bufferAdd(u,d)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const u=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:u.byteLength}),this._socket.write(u)}}class n extends L.Disposable{constructor(u){super(),this._onMessage=new O.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new O.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=u,this._socketWriter=this._register(new o(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(d=>{d.type===1&&this._onMessage.fire(d.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(u){this._socketWriter.write(new a(1,0,0,u))}}e.Protocol=n;class i extends T.IPCClient{static fromSocket(u,d){return new i(new n(u),d)}get onDidDispose(){return this.protocol.onDidDispose}constructor(u,d,g=null){super(u,d,g),this.protocol=u}dispose(){super.dispose();const u=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),u.end()}}e.Client=i;class r{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new O.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(u){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(u):this._emitter.fire(u):this._bufferedMessages.push(u)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=r;class s{constructor(u){this.data=u,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let u=0,d=this._first;for(;d;)d=d.next,u++;return u}peek(){return this._first?this._first.data:null}toArray(){const u=[];let d=0,g=this._first;for(;g;)u[d++]=g.data,g=g.next;return u}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(u){const d=new s(u);if(!this._first){this._first=d,this._last=d;return}this._last.next=d,this._last=d}}class f{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return f._INSTANCE||(f._INSTANCE=new f),f._INSTANCE}constructor(){this.lastRuns=[];const u=Date.now();for(let d=0;d<f._HISTORY_LENGTH;d++)this.lastRuns[d]=u-1e3*d;setInterval(()=>{for(let d=f._HISTORY_LENGTH;d>=1;d--)this.lastRuns[d]=this.lastRuns[d-1];this.lastRuns[0]=Date.now()},1e3)}load(){const u=Date.now(),d=(1+f._HISTORY_LENGTH)*1e3;let g=0;for(let D=0;D<f._HISTORY_LENGTH;D++)u-this.lastRuns[D]<=d&&g++;return 1-g/f._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class h{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(u){this._onControlMessage=new r,this.onControlMessage=this._onControlMessage.event,this._onMessage=new r,this.onMessage=this._onMessage.event,this._onDidDispose=new r,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new r,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new r,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u.loadEstimator??f.getInstance(),this._shouldSendKeepAlive=u.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new L.DisposableStore,this._socket=u.socket,this._socketWriter=this._socketDisposables.add(new o(this._socket)),this._socketReader=this._socketDisposables.add(new m(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.add(this._socket.onClose(d=>this._onSocketClose.fire(d))),u.initialChunk&&this._socketReader.acceptChunk(u.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const u=new a(5,0,0,A());this._socketWriter.write(u),this._socketWriter.flush()}sendPause(){const u=new a(7,0,0,A());this._socketWriter.write(u)}sendResume(){const u=new a(8,0,0,A());this._socketWriter.write(u)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(u,d){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new L.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=u,this._socketWriter=this._socketDisposables.add(new o(this._socket)),this._socketReader=this._socketDisposables.add(new m(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(g=>this._receiveMessage(g))),this._socketDisposables.add(this._socket.onClose(g=>this._onSocketClose.fire(g))),this._socketReader.acceptChunk(d)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const u=new a(3,0,this._incomingAckId,A());this._socketWriter.write(u);const d=this._outgoingUnackMsg.toArray();for(let g=0,D=d.length;g<D;g++)this._socketWriter.write(d[g]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(u){if(u.ack>this._outgoingAckId){this._outgoingAckId=u.ack;do{const d=this._outgoingUnackMsg.peek();if(d&&d.id<=u.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(u.type){case 0:break;case 1:{if(u.id>this._incomingMsgId)if(u.id!==this._incomingMsgId+1){const d=Date.now();d-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=d,this._socketWriter.write(new a(6,0,0,A())))}else this._incomingMsgId=u.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(u.data);break}case 2:{this._onControlMessage.fire(u.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const d=this._outgoingUnackMsg.toArray();for(let g=0,D=d.length;g<D;g++)this._socketWriter.write(d[g]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(u){const d=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const g=new a(1,d,this._incomingAckId,u);this._outgoingUnackMsg.push(g),this._isReconnecting||(this._socketWriter.write(g),this._recvAckCheck())}sendControl(u){const d=new a(2,0,0,u);this._socketWriter.write(d)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const u=Date.now()-this._incomingMsgLastTime;if(u>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-u+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const u=this._outgoingUnackMsg.peek(),d=Date.now()-u.writtenTime,g=Date.now()-this._socketReader.lastReadTime,D=Date.now()-this._lastSocketTimeoutTime;if(d>=2e4&&g>=2e4&&D>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:g});return}const E=Math.max(2e4-d,2e4-g,2e4-D,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},E)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const u=new a(3,0,this._incomingAckId,A());this._socketWriter.write(u)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const u=new a(9,0,this._incomingAckId,A());this._socketWriter.write(u)}}e.PersistentProtocol=h}),define(ye[194],_e([1,0,52,8,21,22,192,13,4,3,24,105,102,81]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends C.ChannelServer{constructor(o){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",n=>L.VSBuffer.wrap(Buffer.from(n,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.Server=S;class a{constructor(o,n){this.modulePath=o,this.options=n,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new p.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const i=n&&n.timeout?n.timeout:6e4;this.disposeDelayer=new O.Delayer(i),this.child=null,this._client=null}getChannel(o){const n=this;return{call(i,r,s){return n.requestPromise(o,i,r,s)},listen(i,r){return n.requestEvent(o,i,r)}}}requestPromise(o,n,i,r=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(o),t=(0,O.createCancelablePromise)(l=>s.call(n,i,l)),f=r.onCancellationRequested(()=>t.cancel()),h=(0,w.toDisposable)(()=>t.cancel());return this.activeRequests.add(h),t.finally(()=>{f.dispose(),this.activeRequests.delete(h),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(o,n,i){if(!this.disposeDelayer)return p.Event.None;this.disposeDelayer.cancel();let r;const s=new p.Emitter({onWillAddFirstListener:()=>{r=this.getCachedChannel(o).listen(n,i)(s.fire,s),this.activeRequests.add(r)},onDidRemoveLastListener:()=>{this.activeRequests.delete(r),r.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const o=this.options&&this.options.args?this.options.args:[],n=Object.create(null);n.env={...(0,A.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(n.env={...n.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(n.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(d=>!/^--inspect(-brk)?=/.test(d)).filter(d=>!d.startsWith("--vscode-"))),(0,v.removeDangerousEnvVariables)(n.env),this.child=(0,c.fork)(this.modulePath,o,n);const i=new p.Emitter,s=p.Event.fromNodeEventEmitter(this.child,"message",d=>d)(d=>{if((0,R.isRemoteConsoleLog)(d)){(0,R.log)(d,`IPC Library: ${this.options.serverName}`);return}i.fire(L.VSBuffer.wrap(Buffer.from(d,"base64")))}),t=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,f=d=>this.child&&this.child.connected&&t.send(d.buffer.toString("base64")),h=i.event,l={send:f,onMessage:h};this._client=new C.ChannelClient(l);const u=()=>this.disposeClient();process.once("exit",u),this.child.on("error",d=>console.warn('IPC "'+this.options.serverName+'" errored with '+d)),this.child.on("exit",(d,g)=>{process.removeListener("exit",u),s.dispose(),this.activeRequests.forEach(D=>(0,w.dispose)(D)),this.activeRequests.clear(),d!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+d+" and signal "+g),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:d,signal:g})})}return this._client}getCachedChannel(o){let n=this.channels.get(o);return n||(n=this.client.getChannel(o),this.channels.set(o,n)),n}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=a}),define(ye[195],_e([1,0,8,4,3,57,18]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=p;var b;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function p(v){const C=v;return C?.changed instanceof Map||C?.deleted instanceof Set}var w;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(w||(e.StorageState=w={}));class A extends L.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(C,S=Object.create(null)){super(),this.database=C,this.options=S,this._onDidChangeStorage=this._register(new O.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=w.None,this.cache=new Map,this.flushDelayer=this._register(new c.ThrottledDelayer(A.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(C=>this.onDidChangeItemsExternal(C)))}onDidChangeItemsExternal(C){this._onDidChangeStorage.pause();try{C.changed?.forEach((S,a)=>this.acceptExternal(a,S)),C.deleted?.forEach(S=>this.acceptExternal(S,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(C,S){if(this.state===w.Closed)return;let a=!1;(0,R.isUndefinedOrNull)(S)?a=this.cache.delete(C):this.cache.get(C)!==S&&(this.cache.set(C,S),a=!0),a&&this._onDidChangeStorage.fire({key:C,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===w.None&&(this.state=w.Initialized,this.options.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(C,S){const a=this.cache.get(C);return(0,R.isUndefinedOrNull)(a)?S:a}getBoolean(C,S){const a=this.get(C);return(0,R.isUndefinedOrNull)(a)?S:a==="true"}getNumber(C,S){const a=this.get(C);return(0,R.isUndefinedOrNull)(a)?S:parseInt(a,10)}getObject(C,S){const a=this.get(C);return(0,R.isUndefinedOrNull)(a)?S:(0,T.parse)(a)}async set(C,S,a=!1){if(this.state===w.Closed)return;if((0,R.isUndefinedOrNull)(S))return this.delete(C,a);const m=(0,R.isObject)(S)||Array.isArray(S)?(0,T.stringify)(S):String(S);if(this.cache.get(C)!==m)return this.cache.set(C,m),this.pendingInserts.set(C,m),this.pendingDeletes.delete(C),this._onDidChangeStorage.fire({key:C,external:a}),this.doFlush()}async delete(C,S=!1){if(!(this.state===w.Closed||!this.cache.delete(C)))return this.pendingDeletes.has(C)||this.pendingDeletes.add(C),this.pendingInserts.delete(C),this._onDidChangeStorage.fire({key:C,external:S}),this.doFlush()}async optimize(){if(this.state!==w.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=w.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const C={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(C).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(C){if(this.hasPending)return this.doFlush(C)}async doFlush(C){return this.options.hint===b.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),C)}async whenFlushed(){if(this.hasPending)return new Promise(C=>this.whenFlushedCallbacks.push(C))}isInMemory(){return this.options.hint===b.STORAGE_IN_MEMORY}}e.Storage=A;class I{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(C){C.insert?.forEach((S,a)=>this.items.set(a,S)),C.delete?.forEach(S=>this.items.delete(S))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=I}),define(ye[196],_e([1,0,14,11,21]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringBuilder=void 0,e.getPlatformTextDecoder=A,e.decodeUTF16LE=I;let T;function R(){return T||(T=new TextDecoder("UTF-16LE")),T}let b;function p(){return b||(b=new TextDecoder("UTF-16BE")),b}let w;function A(){return w||(w=O.isLittleEndian()?R():p()),w}function I(S,a,m){const o=new Uint16Array(S.buffer,a,m);return m>0&&(o[0]===65279||o[0]===65534)?v(S,a,m):R().decode(o)}function v(S,a,m){const o=[];let n=0;for(let i=0;i<m;i++){const r=L.readUInt16LE(S,a);a+=2,o[n++]=String.fromCharCode(r)}return o.join("")}class C{constructor(a){this._capacity=a|0,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}reset(){this._completedStrings=null,this._bufferLength=0}build(){return this._completedStrings!==null?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()}_buildBuffer(){if(this._bufferLength===0)return"";const a=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return A().decode(a)}_flushBuffer(){const a=this._buildBuffer();this._bufferLength=0,this._completedStrings===null?this._completedStrings=[a]:this._completedStrings[this._completedStrings.length]=a}appendCharCode(a){const m=this._capacity-this._bufferLength;m<=1&&(m===0||c.isHighSurrogate(a))&&this._flushBuffer(),this._buffer[this._bufferLength++]=a}appendASCIICharCode(a){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=a}appendString(a){const m=a.length;if(this._bufferLength+m>=this._capacity){this._flushBuffer(),this._completedStrings[this._completedStrings.length]=a;return}for(let o=0;o<m;o++)this._buffer[this._bufferLength++]=a.charCodeAt(o)}}e.StringBuilder=C}),define(ye[197],_e([1,0,21,196]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextChange=void 0,e.compressConsecutiveTextChanges=R;function L(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class T{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(w,A,I,v){this.oldPosition=w,this.oldText=A,this.newPosition=I,this.newText=v}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${L(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${L(this.oldText)}")`:`(replace@${this.oldPosition} "${L(this.oldText)}" with "${L(this.newText)}")`}static _writeStringSize(w){return 4+2*w.length}static _writeString(w,A,I){const v=A.length;c.writeUInt32BE(w,v,I),I+=4;for(let C=0;C<v;C++)c.writeUInt16LE(w,A.charCodeAt(C),I),I+=2;return I}static _readString(w,A){const I=c.readUInt32BE(w,A);return A+=4,(0,O.decodeUTF16LE)(w,A,I)}writeSize(){return 8+T._writeStringSize(this.oldText)+T._writeStringSize(this.newText)}write(w,A){return c.writeUInt32BE(w,this.oldPosition,A),A+=4,c.writeUInt32BE(w,this.newPosition,A),A+=4,A=T._writeString(w,this.oldText,A),A=T._writeString(w,this.newText,A),A}static read(w,A,I){const v=c.readUInt32BE(w,A);A+=4;const C=c.readUInt32BE(w,A);A+=4;const S=T._readString(w,A);A+=T._writeStringSize(S);const a=T._readString(w,A);return A+=T._writeStringSize(a),I.push(new T(v,S,C,a)),A}}e.TextChange=T;function R(p,w){return p===null||p.length===0?w:new b(p,w).compress()}class b{constructor(w,A){this._prevEdits=w,this._currEdits=A,this._result=[],this._resultLen=0,this._prevLen=this._prevEdits.length,this._prevDeltaOffset=0,this._currLen=this._currEdits.length,this._currDeltaOffset=0}compress(){let w=0,A=0,I=this._getPrev(w),v=this._getCurr(A);for(;w<this._prevLen||A<this._currLen;){if(I===null){this._acceptCurr(v),v=this._getCurr(++A);continue}if(v===null){this._acceptPrev(I),I=this._getPrev(++w);continue}if(v.oldEnd<=I.newPosition){this._acceptCurr(v),v=this._getCurr(++A);continue}if(I.newEnd<=v.oldPosition){this._acceptPrev(I),I=this._getPrev(++w);continue}if(v.oldPosition<I.newPosition){const[o,n]=b._splitCurr(v,I.newPosition-v.oldPosition);this._acceptCurr(o),v=n;continue}if(I.newPosition<v.oldPosition){const[o,n]=b._splitPrev(I,v.oldPosition-I.newPosition);this._acceptPrev(o),I=n;continue}let a,m;if(v.oldEnd===I.newEnd)a=I,m=v,I=this._getPrev(++w),v=this._getCurr(++A);else if(v.oldEnd<I.newEnd){const[o,n]=b._splitPrev(I,v.oldLength);a=o,m=v,I=n,v=this._getCurr(++A)}else{const[o,n]=b._splitCurr(v,I.newLength);a=I,m=o,I=this._getPrev(++w),v=n}this._result[this._resultLen++]=new T(a.oldPosition,a.oldText,m.newPosition,m.newText),this._prevDeltaOffset+=a.newLength-a.oldLength,this._currDeltaOffset+=m.newLength-m.oldLength}const C=b._merge(this._result);return b._removeNoOps(C)}_acceptCurr(w){this._result[this._resultLen++]=b._rebaseCurr(this._prevDeltaOffset,w),this._currDeltaOffset+=w.newLength-w.oldLength}_getCurr(w){return w<this._currLen?this._currEdits[w]:null}_acceptPrev(w){this._result[this._resultLen++]=b._rebasePrev(this._currDeltaOffset,w),this._prevDeltaOffset+=w.newLength-w.oldLength}_getPrev(w){return w<this._prevLen?this._prevEdits[w]:null}static _rebaseCurr(w,A){return new T(A.oldPosition-w,A.oldText,A.newPosition,A.newText)}static _rebasePrev(w,A){return new T(A.oldPosition,A.oldText,A.newPosition+w,A.newText)}static _splitPrev(w,A){const I=w.newText.substr(0,A),v=w.newText.substr(A);return[new T(w.oldPosition,w.oldText,w.newPosition,I),new T(w.oldEnd,"",w.newPosition+A,v)]}static _splitCurr(w,A){const I=w.oldText.substr(0,A),v=w.oldText.substr(A);return[new T(w.oldPosition,I,w.newPosition,w.newText),new T(w.oldPosition+A,v,w.newEnd,"")]}static _merge(w){if(w.length===0)return w;const A=[];let I=0,v=w[0];for(let C=1;C<w.length;C++){const S=w[C];v.oldEnd===S.oldPosition?v=new T(v.oldPosition,v.oldText+S.oldText,v.newPosition,v.newText+S.newText):(A[I++]=v,v=S)}return A[I++]=v,A}static _removeNoOps(w){if(w.length===0)return w;const A=[];let I=0;for(let v=0;v<w.length;v++){const C=w[v];C.oldText!==C.newText&&(A[I++]=C)}return A}}}),define(ye[198],_e([1,0,35,17]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=L,e.targetsNotebooks=T;function L(R,b,p,w,A,I){if(Array.isArray(R)){let v=0;for(const C of R){const S=L(C,b,p,w,A,I);if(S===10)return S;S>v&&(v=S)}return v}else{if(typeof R=="string")return w?R==="*"?5:R===p?10:0:0;if(R){const{language:v,pattern:C,scheme:S,hasAccessToAllModels:a,notebookType:m}=R;if(!w&&!a)return 0;m&&A&&(b=A);let o=0;if(S)if(S===b.scheme)o=10;else if(S==="*")o=5;else return 0;if(v)if(v===p)o=10;else if(v==="*")o=Math.max(o,5);else return 0;if(m)if(m===I)o=10;else if(m==="*"&&I!==void 0)o=Math.max(o,5);else return 0;if(C){let n;if(typeof C=="string"?n=C:n={...C,base:(0,O.normalize)(C.base)},n===b.fsPath||(0,c.match)(n,b.fsPath))o=10;else return 0}return o}else return 0}}function T(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(T):!!R.notebookType}}),define(ye[199],_e([1,0,4,14,29,79,130,174,197,3]),function(de,e,c,O,L,T,R,b,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBuffer=void 0;class A extends w.Disposable{constructor(v,C,S,a,m,o,n){super(),this._onDidChangeContent=this._register(new c.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._BOM=C,this._mightContainNonBasicASCII=!o,this._mightContainRTL=a,this._mightContainUnusualLineTerminators=m,this._pieceTree=new R.PieceTreeBase(v,S,n)}equals(v){return!(v instanceof A)||this._BOM!==v._BOM||this.getEOL()!==v.getEOL()?!1:this._pieceTree.equal(v._pieceTree)}mightContainRTL(){return this._mightContainRTL}mightContainUnusualLineTerminators(){return this._mightContainUnusualLineTerminators}resetMightContainUnusualLineTerminators(){this._mightContainUnusualLineTerminators=!1}mightContainNonBasicASCII(){return this._mightContainNonBasicASCII}getBOM(){return this._BOM}getEOL(){return this._pieceTree.getEOL()}createSnapshot(v){return this._pieceTree.createSnapshot(v?this._BOM:"")}getOffsetAt(v,C){return this._pieceTree.getOffsetAt(v,C)}getPositionAt(v){return this._pieceTree.getPositionAt(v)}getRangeAt(v,C){const S=v+C,a=this.getPositionAt(v),m=this.getPositionAt(S);return new L.Range(a.lineNumber,a.column,m.lineNumber,m.column)}getValueInRange(v,C=0){if(v.isEmpty())return"";const S=this._getEndOfLine(C);return this._pieceTree.getValueInRange(v,S)}getValueLengthInRange(v,C=0){if(v.isEmpty())return 0;if(v.startLineNumber===v.endLineNumber)return v.endColumn-v.startColumn;const S=this.getOffsetAt(v.startLineNumber,v.startColumn),a=this.getOffsetAt(v.endLineNumber,v.endColumn);let m=0;const o=this._getEndOfLine(C),n=this.getEOL();if(o.length!==n.length){const i=o.length-n.length,r=v.endLineNumber-v.startLineNumber;m=i*r}return a-S+m}getCharacterCountInRange(v,C=0){if(this._mightContainNonBasicASCII){let S=0;const a=v.startLineNumber,m=v.endLineNumber;for(let o=a;o<=m;o++){const n=this.getLineContent(o),i=o===a?v.startColumn-1:0,r=o===m?v.endColumn-1:n.length;for(let s=i;s<r;s++)O.isHighSurrogate(n.charCodeAt(s))?(S=S+1,s=s+1):S=S+1}return S+=this._getEndOfLine(C).length*(m-a),S}return this.getValueLengthInRange(v,C)}getLength(){return this._pieceTree.getLength()}getLineCount(){return this._pieceTree.getLineCount()}getLinesContent(){return this._pieceTree.getLinesContent()}getLineContent(v){return this._pieceTree.getLineContent(v)}getLineCharCode(v,C){return this._pieceTree.getLineCharCode(v,C)}getCharCode(v){return this._pieceTree.getCharCode(v)}getLineLength(v){return this._pieceTree.getLineLength(v)}getLineMinColumn(v){return 1}getLineMaxColumn(v){return this.getLineLength(v)+1}getLineFirstNonWhitespaceColumn(v){const C=O.firstNonWhitespaceIndex(this.getLineContent(v));return C===-1?0:C+1}getLineLastNonWhitespaceColumn(v){const C=O.lastNonWhitespaceIndex(this.getLineContent(v));return C===-1?0:C+2}_getEndOfLine(v){switch(v){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(v){this._pieceTree.setEOL(v)}applyEdits(v,C,S){let a=this._mightContainRTL,m=this._mightContainUnusualLineTerminators,o=this._mightContainNonBasicASCII,n=!0,i=[];for(let u=0;u<v.length;u++){const d=v[u];n&&d._isTracked&&(n=!1);const g=d.range;if(d.text){let P=!0;o||(P=!O.isBasicASCII(d.text),o=P),!a&&P&&(a=O.containsRTL(d.text)),!m&&P&&(m=O.containsUnusualLineTerminators(d.text))}let D="",E=0,_=0,y=0;if(d.text){let P;[E,_,y,P]=(0,b.countEOL)(d.text);const k=this.getEOL();P===0||P===(k===`\r
`?2:1)?D=d.text:D=d.text.replace(/\r\n|\r|\n/g,k)}i[u]={sortIndex:u,identifier:d.identifier||null,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g),text:D,eolCount:E,firstLineLength:_,lastLineLength:y,forceMoveMarkers:!!d.forceMoveMarkers,isAutoWhitespaceEdit:d.isAutoWhitespaceEdit||!1}}i.sort(A._sortOpsAscending);let r=!1;for(let u=0,d=i.length-1;u<d;u++){const g=i[u].range.getEndPosition(),D=i[u+1].range.getStartPosition();if(D.isBeforeOrEqual(g)){if(D.isBefore(g))throw new Error("Overlapping ranges are not allowed!");r=!0}}n&&(i=this._reduceOperations(i));const s=S||C?A._getInverseEditRanges(i):[],t=[];if(C)for(let u=0;u<i.length;u++){const d=i[u],g=s[u];if(d.isAutoWhitespaceEdit&&d.range.isEmpty())for(let D=g.startLineNumber;D<=g.endLineNumber;D++){let E="";D===g.startLineNumber&&(E=this.getLineContent(d.range.startLineNumber),O.firstNonWhitespaceIndex(E)!==-1)||t.push({lineNumber:D,oldContent:E})}}let f=null;if(S){let u=0;f=[];for(let d=0;d<i.length;d++){const g=i[d],D=s[d],E=this.getValueInRange(g.range),_=g.rangeOffset+u;u+=g.text.length-E.length,f[d]={sortIndex:g.sortIndex,identifier:g.identifier,range:D,text:E,textChange:new p.TextChange(g.rangeOffset,E,_,g.text)}}r||f.sort((d,g)=>d.sortIndex-g.sortIndex)}this._mightContainRTL=a,this._mightContainUnusualLineTerminators=m,this._mightContainNonBasicASCII=o;const h=this._doApplyEdits(i);let l=null;if(C&&t.length>0){t.sort((u,d)=>d.lineNumber-u.lineNumber),l=[];for(let u=0,d=t.length;u<d;u++){const g=t[u].lineNumber;if(u>0&&t[u-1].lineNumber===g)continue;const D=t[u].oldContent,E=this.getLineContent(g);E.length===0||E===D||O.firstNonWhitespaceIndex(E)!==-1||l.push(g)}}return this._onDidChangeContent.fire(),new T.ApplyEditsResult(f,h,l)}_reduceOperations(v){return v.length<1e3?v:[this._toSingleEditOperation(v)]}_toSingleEditOperation(v){let C=!1;const S=v[0].range,a=v[v.length-1].range,m=new L.Range(S.startLineNumber,S.startColumn,a.endLineNumber,a.endColumn);let o=S.startLineNumber,n=S.startColumn;const i=[];for(let h=0,l=v.length;h<l;h++){const u=v[h],d=u.range;C=C||u.forceMoveMarkers,i.push(this.getValueInRange(new L.Range(o,n,d.startLineNumber,d.startColumn))),u.text.length>0&&i.push(u.text),o=d.endLineNumber,n=d.endColumn}const r=i.join(""),[s,t,f]=(0,b.countEOL)(r);return{sortIndex:0,identifier:v[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,0),text:r,eolCount:s,firstLineLength:t,lastLineLength:f,forceMoveMarkers:C,isAutoWhitespaceEdit:!1}}_doApplyEdits(v){v.sort(A._sortOpsDescending);const C=[];for(let S=0;S<v.length;S++){const a=v[S],m=a.range.startLineNumber,o=a.range.startColumn,n=a.range.endLineNumber,i=a.range.endColumn;if(m===n&&o===i&&a.text.length===0)continue;a.text?(this._pieceTree.delete(a.rangeOffset,a.rangeLength),this._pieceTree.insert(a.rangeOffset,a.text,!0)):this._pieceTree.delete(a.rangeOffset,a.rangeLength);const r=new L.Range(m,o,n,i);C.push({range:r,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return C}findMatchesLineByLine(v,C,S,a){return this._pieceTree.findMatchesLineByLine(v,C,S,a)}getPieceTree(){return this._pieceTree}static _getInverseEditRange(v,C){const S=v.startLineNumber,a=v.startColumn,[m,o,n]=(0,b.countEOL)(C);let i;if(C.length>0){const r=m+1;r===1?i=new L.Range(S,a,S,a+o):i=new L.Range(S,a,S+r-1,n+1)}else i=new L.Range(S,a,S,a);return i}static _getInverseEditRanges(v){const C=[];let S=0,a=0,m=null;for(let o=0,n=v.length;o<n;o++){const i=v[o];let r,s;m?m.range.endLineNumber===i.range.startLineNumber?(r=S,s=a+(i.range.startColumn-m.range.endColumn)):(r=S+(i.range.startLineNumber-m.range.endLineNumber),s=i.range.startColumn):(r=i.range.startLineNumber,s=i.range.startColumn);let t;if(i.text.length>0){const f=i.eolCount+1;f===1?t=new L.Range(r,s,r,s+i.firstLineLength):t=new L.Range(r,s,r+f-1,i.lastLineLength+1)}else t=new L.Range(r,s,r,s);S=t.endLineNumber,a=t.endColumn,C.push(t),m=i}return C}static _sortOpsAscending(v,C){const S=L.Range.compareRangesUsingEnds(v.range,C.range);return S===0?v.sortIndex-C.sortIndex:S}static _sortOpsDescending(v,C){const S=L.Range.compareRangesUsingEnds(v.range,C.range);return S===0?C.sortIndex-v.sortIndex:-S}}e.PieceTreeTextBuffer=A}),define(ye[200],_e([1,0,14,130,199]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBufferBuilder=void 0;class T{constructor(p,w,A,I,v,C,S,a,m){this._chunks=p,this._bom=w,this._cr=A,this._lf=I,this._crlf=v,this._containsRTL=C,this._containsUnusualLineTerminators=S,this._isBasicASCII=a,this._normalizeEOL=m}_getEOL(p){const w=this._cr+this._lf+this._crlf,A=this._cr+this._crlf;return w===0?p===1?`
`:`\r
`:A>w/2?`\r
`:`
`}create(p){const w=this._getEOL(p),A=this._chunks;if(this._normalizeEOL&&(w===`\r
`&&(this._cr>0||this._lf>0)||w===`
`&&(this._cr>0||this._crlf>0)))for(let v=0,C=A.length;v<C;v++){const S=A[v].buffer.replace(/\r\n|\r|\n/g,w),a=(0,O.createLineStartsFast)(S);A[v]=new O.StringBuffer(S,a)}const I=new L.PieceTreeTextBuffer(A,this._bom,w,this._containsRTL,this._containsUnusualLineTerminators,this._isBasicASCII,this._normalizeEOL);return{textBuffer:I,disposable:I}}getFirstLineText(p){return this._chunks[0].buffer.substr(0,p).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.containsUnusualLineTerminators=!1,this.isBasicASCII=!0}acceptChunk(p){if(p.length===0)return;this.chunks.length===0&&c.startsWithUTF8BOM(p)&&(this.BOM=c.UTF8_BOM_CHARACTER,p=p.substr(1));const w=p.charCodeAt(p.length-1);w===13||w>=55296&&w<=56319?(this._acceptChunk1(p.substr(0,p.length-1),!1),this._hasPreviousChar=!0,this._previousChar=w):(this._acceptChunk1(p,!1),this._hasPreviousChar=!1,this._previousChar=w)}_acceptChunk1(p,w){!w&&p.length===0||(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+p):this._acceptChunk2(p))}_acceptChunk2(p){const w=(0,O.createLineStarts)(this._tmpLineStarts,p);this.chunks.push(new O.StringBuffer(p,w.lineStarts)),this.cr+=w.cr,this.lf+=w.lf,this.crlf+=w.crlf,w.isBasicASCII||(this.isBasicASCII=!1,this.containsRTL||(this.containsRTL=c.containsRTL(p)),this.containsUnusualLineTerminators||(this.containsUnusualLineTerminators=c.containsUnusualLineTerminators(p)))}finish(p=!0){return this._finish(),new T(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.containsUnusualLineTerminators,this.isBasicASCII,p)}_finish(){if(this.chunks.length===0&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;const p=this.chunks[this.chunks.length-1];p.buffer+=String.fromCharCode(this._previousChar);const w=(0,O.createLineStartsFast)(p.buffer);p.lineStarts=w,this._previousChar===13&&this.cr++}}}e.PieceTreeTextBufferBuilder=R}),define(ye[134],_e([1,0,21,11]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeSemanticTokensDto=p,e.decodeSemanticTokensDto=A;var L;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(L||(L={}));function T(I){for(let v=0,C=I.length;v<C;v+=4){const S=I[v+0],a=I[v+1],m=I[v+2],o=I[v+3];I[v+0]=o,I[v+1]=m,I[v+2]=a,I[v+3]=S}}function R(I){const v=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return O.isLittleEndian()||T(v),c.VSBuffer.wrap(v)}function b(I){const v=I.buffer;if(O.isLittleEndian()||T(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const C=new Uint8Array(v.byteLength);return C.set(v),new Uint32Array(C.buffer,C.byteOffset,C.length/4)}}function p(I){const v=new Uint32Array(w(I));let C=0;if(v[C++]=I.id,I.type==="full")v[C++]=1,v[C++]=I.data.length,v.set(I.data,C),C+=I.data.length;else{v[C++]=2,v[C++]=I.deltas.length;for(const S of I.deltas)v[C++]=S.start,v[C++]=S.deleteCount,S.data?(v[C++]=S.data.length,v.set(S.data,C),C+=S.data.length):v[C++]=0}return R(v)}function w(I){let v=0;if(v+=2,I.type==="full")v+=1+I.data.length;else{v+=1,v+=3*I.deltas.length;for(const C of I.deltas)C.data&&(v+=C.data.length)}return v}function A(I){const v=b(I);let C=0;const S=v[C++];if(v[C++]===1){const n=v[C++],i=v.subarray(C,C+n);return C+=n,{id:S,type:"full",data:i}}const m=v[C++],o=[];for(let n=0;n<m;n++){const i=v[C++],r=v[C++],s=v[C++];let t;s>0&&(t=v.subarray(C,C+s),C+=s),o[n]={start:i,deleteCount:r,data:t}}return{id:S,type:"delta",deltas:o}}}),define(ye[201],_e([9,10]),function(de,e){return de.create("vs/editor/common/config/editorOptions",e)}),define(ye[135],_e([1,0,19,24,11,177,129,201]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=m,e.clampedInt=n,e.clampedFloat=r,e.stringSet=f,e.cursorStyleToString=y,e.filterValidationDecorations=he;var p;(function(oe){oe[oe.None=0]="None",oe[oe.Keep=1]="Keep",oe[oe.Brackets=2]="Brackets",oe[oe.Advanced=3]="Advanced",oe[oe.Full=4]="Full"})(p||(e.EditorAutoIndentStrategy=p={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(le){this._values=le}hasChanged(le){return this._values[le]}}e.ConfigurationChangedEvent=w;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class I{constructor(le,ke,je,Ze){this.id=le,this.name=ke,this.defaultValue=je,this.schema=Ze}applyUpdate(le,ke){return C(le,ke)}compute(le,ke,je){return je}}class v{constructor(le,ke){this.newValue=le,this.didChange=ke}}e.ApplyUpdateResult=v;function C(oe,le){if(typeof oe!="object"||typeof le!="object"||!oe||!le)return new v(le,oe!==le);if(Array.isArray(oe)||Array.isArray(le)){const je=Array.isArray(oe)&&Array.isArray(le)&&c.equals(oe,le);return new v(le,!je)}let ke=!1;for(const je in le)if(le.hasOwnProperty(je)){const Ze=C(oe[je],le[je]);Ze.didChange&&(oe[je]=Ze.newValue,ke=!0)}return new v(oe,ke)}class S{constructor(le){this.schema=void 0,this.id=le,this.name="_never_",this.defaultValue=void 0}applyUpdate(le,ke){return C(le,ke)}validate(le){return this.defaultValue}}class a{constructor(le,ke,je,Ze){this.id=le,this.name=ke,this.defaultValue=je,this.schema=Ze}applyUpdate(le,ke){return C(le,ke)}validate(le){return typeof le>"u"?this.defaultValue:le}compute(le,ke,je){return je}}function m(oe,le){return typeof oe>"u"?le:oe==="false"?!1:!!oe}class o extends a{constructor(le,ke,je,Ze=void 0){typeof Ze<"u"&&(Ze.type="boolean",Ze.default=je),super(le,ke,je,Ze)}validate(le){return m(le,this.defaultValue)}}function n(oe,le,ke,je){if(typeof oe>"u")return le;let Ze=parseInt(oe,10);return isNaN(Ze)?le:(Ze=Math.max(ke,Ze),Ze=Math.min(je,Ze),Ze|0)}class i extends a{static clampedInt(le,ke,je,Ze){return n(le,ke,je,Ze)}constructor(le,ke,je,Ze,Me,lt=void 0){typeof lt<"u"&&(lt.type="integer",lt.default=je,lt.minimum=Ze,lt.maximum=Me),super(le,ke,je,lt),this.minimum=Ze,this.maximum=Me}validate(le){return i.clampedInt(le,this.defaultValue,this.minimum,this.maximum)}}function r(oe,le,ke,je){if(typeof oe>"u")return le;const Ze=s.float(oe,le);return s.clamp(Ze,ke,je)}class s extends a{static clamp(le,ke,je){return le<ke?ke:le>je?je:le}static float(le,ke){if(typeof le=="number")return le;if(typeof le>"u")return ke;const je=parseFloat(le);return isNaN(je)?ke:je}constructor(le,ke,je,Ze,Me){typeof Me<"u"&&(Me.type="number",Me.default=je),super(le,ke,je,Me),this.validationFn=Ze}validate(le){return this.validationFn(s.float(le,this.defaultValue))}}class t extends a{static string(le,ke){return typeof le!="string"?ke:le}constructor(le,ke,je,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.default=je),super(le,ke,je,Ze)}validate(le){return t.string(le,this.defaultValue)}}function f(oe,le,ke,je){return typeof oe!="string"?le:je&&oe in je?je[oe]:ke.indexOf(oe)===-1?le:oe}class h extends a{constructor(le,ke,je,Ze,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.enum=Ze,Me.default=je),super(le,ke,je,Me),this._allowedValues=Ze}validate(le){return f(le,this.defaultValue,this._allowedValues)}}class l extends I{constructor(le,ke,je,Ze,Me,lt,bt=void 0){typeof bt<"u"&&(bt.type="string",bt.enum=Me,bt.default=Ze),super(le,ke,je,bt),this._allowedValues=Me,this._convert=lt}validate(le){return typeof le!="string"?this.defaultValue:this._allowedValues.indexOf(le)===-1?this.defaultValue:this._convert(le)}}function u(oe){switch(oe){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(le){switch(le){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(le,ke,je){return je===0?le.accessibilitySupport:je}}class g extends I{constructor(){const le={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",le,{"editor.comments.insertSpace":{type:"boolean",default:le.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:le.ignoreEmptyLines,description:b.localize(5,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{insertSpace:m(ke.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(ke.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(oe){oe[oe.Hidden=0]="Hidden",oe[oe.Blink=1]="Blink",oe[oe.Smooth=2]="Smooth",oe[oe.Phase=3]="Phase",oe[oe.Expand=4]="Expand",oe[oe.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function E(oe){switch(oe){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var _;(function(oe){oe[oe.Line=1]="Line",oe[oe.Block=2]="Block",oe[oe.Underline=3]="Underline",oe[oe.LineThin=4]="LineThin",oe[oe.BlockOutline=5]="BlockOutline",oe[oe.UnderlineThin=6]="UnderlineThin"})(_||(e.TextEditorCursorStyle=_={}));function y(oe){switch(oe){case _.Line:return"line";case _.Block:return"block";case _.Underline:return"underline";case _.LineThin:return"line-thin";case _.BlockOutline:return"block-outline";case _.UnderlineThin:return"underline-thin"}}function P(oe){switch(oe){case"line":return _.Line;case"block":return _.Block;case"underline":return _.Underline;case"line-thin":return _.LineThin;case"block-outline":return _.BlockOutline;case"underline-thin":return _.UnderlineThin}}class k extends S{constructor(){super(142)}compute(le,ke,je){const Ze=["monaco-editor"];return ke.get(39)&&Ze.push(ke.get(39)),le.extraEditorClassName&&Ze.push(le.extraEditorClassName),ke.get(74)==="default"?Ze.push("mouse-default"):ke.get(74)==="copy"&&Ze.push("mouse-copy"),ke.get(111)&&Ze.push("showUnused"),ke.get(140)&&Ze.push("showDeprecated"),Ze.join(" ")}}class z extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(le,ke,je){return je&&le.emptySelectionClipboard}}class x extends I{constructor(){const le={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",le,{"editor.find.cursorMoveOnType":{type:"boolean",default:le.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:le.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:le.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:le.globalFindClipboard,description:b.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:le.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:le.loop,description:b.localize(18,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{cursorMoveOnType:m(ke.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof le.seedSearchStringFromSelection=="boolean"?le.seedSearchStringFromSelection?"always":"never":f(ke.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof le.autoFindInSelection=="boolean"?le.autoFindInSelection?"always":"never":f(ke.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(ke.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(ke.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(ke.loop,this.defaultValue.loop)}}}class F extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(le){return typeof le>"u"?this.defaultValue:typeof le=="string"?le==="false"||le.length===0?F.OFF:le==="true"?F.ON:le:le?F.ON:F.OFF}}e.EditorFontLigatures=F;class N extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(le){return typeof le>"u"?this.defaultValue:typeof le=="string"?le==="false"?N.OFF:le==="true"?N.TRANSLATE:le:le?N.TRANSLATE:N.OFF}compute(le,ke,je){return le.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class M extends S{constructor(){super(50)}compute(le,ke,je){return le.fontInfo}}class B extends a{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(le){const ke=s.float(le,this.defaultValue);return ke===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(ke,6,100)}compute(le,ke,je){return le.fontInfo.fontSize}}class W extends I{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(le){return le==="normal"||le==="bold"?le:String(i.clampedInt(le,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}class Y extends I{constructor(){const le={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ke={type:"string",enum:["peek","gotoAndPeek","goto"],default:le.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",le,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...ke},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...ke},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...ke},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...ke},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...ke},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:le.alternativeDefinitionCommand,enum:je,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:le.alternativeTypeDefinitionCommand,enum:je,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:le.alternativeDeclarationCommand,enum:je,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:le.alternativeImplementationCommand,enum:je,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:le.alternativeReferenceCommand,enum:je,description:b.localize(41,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{multiple:f(ke.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ke.multipleDefinitions??f(ke.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ke.multipleTypeDefinitions??f(ke.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ke.multipleDeclarations??f(ke.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ke.multipleImplementations??f(ke.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ke.multipleReferences??f(ke.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(ke.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(ke.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(ke.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(ke.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(ke.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends I{constructor(){const le={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",le,{"editor.hover.enabled":{type:"boolean",default:le.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:le.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:le.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:le.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:le.above,description:b.localize(46,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{enabled:m(ke.enabled,this.defaultValue.enabled),delay:i.clampedInt(ke.delay,this.defaultValue.delay,0,1e4),sticky:m(ke.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(ke.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(ke.above,this.defaultValue.above)}}}var G;(function(oe){oe[oe.None=0]="None",oe[oe.Text=1]="Text",oe[oe.Blocks=2]="Blocks"})(G||(e.RenderMinimap=G={}));class Q extends S{constructor(){super(145)}compute(le,ke,je){return Q.computeLayout(ke,{memory:le.memory,outerWidth:le.outerWidth,outerHeight:le.outerHeight,isDominatedByLongLines:le.isDominatedByLongLines,lineHeight:le.fontInfo.lineHeight,viewLineCount:le.viewLineCount,lineNumbersDigitCount:le.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:le.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:le.fontInfo.maxDigitWidth,pixelRatio:le.pixelRatio,glyphMarginDecorationLaneCount:le.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(le){const ke=le.height/le.lineHeight,je=Math.floor(le.paddingTop/le.lineHeight);let Ze=Math.floor(le.paddingBottom/le.lineHeight);le.scrollBeyondLastLine&&(Ze=Math.max(Ze,ke-1));const Me=(je+le.viewLineCount+Ze)/(le.pixelRatio*le.height),lt=Math.floor(le.viewLineCount/Me);return{typicalViewportLineCount:ke,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:Ze,desiredRatio:Me,minimapLineCount:lt}}static _computeMinimapLayout(le,ke){const je=le.outerWidth,Ze=le.outerHeight,Me=le.pixelRatio;if(!le.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Me*Ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ze};const lt=ke.stableMinimapLayoutInput,bt=lt&&le.outerHeight===lt.outerHeight&&le.lineHeight===lt.lineHeight&&le.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&le.pixelRatio===lt.pixelRatio&&le.scrollBeyondLastLine===lt.scrollBeyondLastLine&&le.paddingTop===lt.paddingTop&&le.paddingBottom===lt.paddingBottom&&le.minimap.enabled===lt.minimap.enabled&&le.minimap.side===lt.minimap.side&&le.minimap.size===lt.minimap.size&&le.minimap.showSlider===lt.minimap.showSlider&&le.minimap.renderCharacters===lt.minimap.renderCharacters&&le.minimap.maxColumn===lt.minimap.maxColumn&&le.minimap.scale===lt.minimap.scale&&le.verticalScrollbarWidth===lt.verticalScrollbarWidth&&le.isViewportWrapping===lt.isViewportWrapping,Tt=le.lineHeight,Nt=le.typicalHalfwidthCharacterWidth,Xt=le.scrollBeyondLastLine,ei=le.minimap.renderCharacters;let It=Me>=2?Math.round(le.minimap.scale*2):le.minimap.scale;const Qt=le.minimap.maxColumn,Vt=le.minimap.size,ci=le.minimap.side,tt=le.verticalScrollbarWidth,ti=le.viewLineCount,ii=le.remainingWidth,qt=le.isViewportWrapping,ht=ei?2:3;let Et=Math.floor(Me*Ze);const ai=Et/Me;let jt=!1,Ut=!1,gt=ht*It,Pt=It/Me,li=1;if(Vt==="fill"||Vt==="fit"){const{typicalViewportLineCount:Ot,extraLinesBeforeFirstLine:At,extraLinesBeyondLastLine:Ft,desiredRatio:ui,minimapLineCount:xt}=Q.computeContainedMinimapLineCount({viewLineCount:ti,scrollBeyondLastLine:Xt,paddingTop:le.paddingTop,paddingBottom:le.paddingBottom,height:Ze,lineHeight:Tt,pixelRatio:Me});if(ti/xt>1)jt=!0,Ut=!0,It=1,gt=1,Pt=It/Me;else{let Ct=!1,Lt=It+1;if(Vt==="fit"){const ri=Math.ceil((At+ti+Ft)*gt);qt&&bt&&ii<=ke.stableFitRemainingWidth?(Ct=!0,Lt=ke.stableFitMaxMinimapScale):Ct=ri>Et}if(Vt==="fill"||Ct){jt=!0;const ri=It;gt=Math.min(Tt*Me,Math.max(1,Math.floor(1/ui))),qt&&bt&&ii<=ke.stableFitRemainingWidth&&(Lt=ke.stableFitMaxMinimapScale),It=Math.min(Lt,Math.max(1,Math.floor(gt/ht))),It>ri&&(li=Math.min(2,It/ri)),Pt=It/Me/li,Et=Math.ceil(Math.max(Ot,At+ti+Ft)*gt),qt?(ke.stableMinimapLayoutInput=le,ke.stableFitRemainingWidth=ii,ke.stableFitMaxMinimapScale=It):(ke.stableMinimapLayoutInput=null,ke.stableFitRemainingWidth=0)}}}const Yt=Math.floor(Qt*Pt),Ke=Math.min(Yt,Math.max(0,Math.floor((ii-tt-2)*Pt/(Nt+Pt)))+e.MINIMAP_GUTTER_WIDTH);let Mt=Math.floor(Me*Ke);const Ht=Mt/Me;Mt=Math.floor(Mt*li);const ni=ei?1:2,pt=ci==="left"?0:je-Ke-tt;return{renderMinimap:ni,minimapLeft:pt,minimapWidth:Ke,minimapHeightIsEditorHeight:jt,minimapIsSampling:Ut,minimapScale:It,minimapLineHeight:gt,minimapCanvasInnerWidth:Mt,minimapCanvasInnerHeight:Et,minimapCanvasOuterWidth:Ht,minimapCanvasOuterHeight:ai}}static computeLayout(le,ke){const je=ke.outerWidth|0,Ze=ke.outerHeight|0,Me=ke.lineHeight|0,lt=ke.lineNumbersDigitCount|0,bt=ke.typicalHalfwidthCharacterWidth,Tt=ke.maxDigitWidth,Nt=ke.pixelRatio,Xt=ke.viewLineCount,ei=le.get(137),It=ei==="inherit"?le.get(136):ei,Qt=It==="inherit"?le.get(132):It,Vt=le.get(135),ci=ke.isDominatedByLongLines,tt=le.get(57),ti=le.get(68).renderType!==0,ii=le.get(69),qt=le.get(105),ht=le.get(84),Et=le.get(73),ai=le.get(103),jt=ai.verticalScrollbarSize,Ut=ai.verticalHasArrows,gt=ai.arrowSize,Pt=ai.horizontalScrollbarSize,li=le.get(43),Yt=le.get(110)!=="never";let Ke=le.get(66);li&&Yt&&(Ke+=16);let Mt=0;if(ti){const St=Math.max(lt,ii);Mt=Math.round(St*Tt)}let Ht=0;tt&&(Ht=Me*ke.glyphMarginDecorationLaneCount);let ni=0,pt=ni+Ht,Ot=pt+Mt,At=Ot+Ke;const Ft=je-Ht-Mt-Ke;let ui=!1,xt=!1,zt=-1;It==="inherit"&&ci?(ui=!0,xt=!0):Qt==="on"||Qt==="bounded"?xt=!0:Qt==="wordWrapColumn"&&(zt=Vt);const Ct=Q._computeMinimapLayout({outerWidth:je,outerHeight:Ze,lineHeight:Me,typicalHalfwidthCharacterWidth:bt,pixelRatio:Nt,scrollBeyondLastLine:qt,paddingTop:ht.top,paddingBottom:ht.bottom,minimap:Et,verticalScrollbarWidth:jt,viewLineCount:Xt,remainingWidth:Ft,isViewportWrapping:xt},ke.memory||new A);Ct.renderMinimap!==0&&Ct.minimapLeft===0&&(ni+=Ct.minimapWidth,pt+=Ct.minimapWidth,Ot+=Ct.minimapWidth,At+=Ct.minimapWidth);const Lt=Ft-Ct.minimapWidth,ri=Math.max(1,Math.floor((Lt-jt-2)/bt)),Bt=Ut?gt:0;return xt&&(zt=Math.max(1,ri),Qt==="bounded"&&(zt=Math.min(zt,Vt))),{width:je,height:Ze,glyphMarginLeft:ni,glyphMarginWidth:Ht,glyphMarginDecorationLaneCount:ke.glyphMarginDecorationLaneCount,lineNumbersLeft:pt,lineNumbersWidth:Mt,decorationsLeft:Ot,decorationsWidth:Ke,contentLeft:At,contentWidth:Lt,minimap:Ct,viewportColumn:ri,isWordWrapMinified:ui,isViewportWrapping:xt,wrappingColumn:zt,verticalScrollbarWidth:jt,horizontalScrollbarHeight:Pt,overviewRuler:{top:Bt,width:jt,height:Ze-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=Q;class re extends I{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(le){return f(le,"simple",["simple","advanced"])}compute(le,ke,je){return ke.get(2)===2?"advanced":je}}var te;(function(oe){oe.Off="off",oe.OnCode="onCode",oe.On="on"})(te||(e.ShowLightbulbIconMode=te={}));class ve extends I{constructor(){const le={enabled:te.On};super(65,"lightbulb",le,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[te.Off,te.OnCode,te.On],default:le.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(le){return!le||typeof le!="object"?this.defaultValue:{enabled:f(le.enabled,this.defaultValue.enabled,[te.Off,te.OnCode,te.On])}}}class Ie extends I{constructor(){const le={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",le,{"editor.stickyScroll.enabled":{type:"boolean",default:le.enabled,description:b.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:le.maxLineCount,minimum:1,maximum:20,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:le.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:le.scrollWithEditor,description:b.localize(57,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{enabled:m(ke.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(ke.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f(ke.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(ke.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class J extends I{constructor(){const le={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",le,{"editor.inlayHints.enabled":{type:"string",default:le.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,L.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,L.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:le.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:le.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:le.padding,description:b.localize(65,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return typeof ke.enabled=="boolean"&&(ke.enabled=ke.enabled?"on":"off"),{enabled:f(ke.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(ke.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(ke.fontFamily,this.defaultValue.fontFamily),padding:m(ke.padding,this.defaultValue.padding)}}}class $ extends I{constructor(){super(66,"lineDecorationsWidth",10)}validate(le){return typeof le=="string"&&/^\d+(\.\d+)?ch$/.test(le)?-parseFloat(le.substring(0,le.length-2)):i.clampedInt(le,this.defaultValue,0,1e3)}compute(le,ke,je){return je<0?i.clampedInt(-je*le.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class ne extends s{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,le=>s.clamp(le,0,150),{markdownDescription:b.localize(66,null)})}compute(le,ke,je){return le.fontInfo.lineHeight}}class be extends I{constructor(){const le={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",le,{"editor.minimap.enabled":{type:"boolean",default:le.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:le.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:le.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:le.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:le.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:le.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:le.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:le.maxColumn,description:b.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:le.showRegionSectionHeaders,description:b.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:le.showMarkSectionHeaders,description:b.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:le.sectionHeaderFontSize,description:b.localize(80,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{enabled:m(ke.enabled,this.defaultValue.enabled),autohide:m(ke.autohide,this.defaultValue.autohide),size:f(ke.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(ke.side,this.defaultValue.side,["right","left"]),showSlider:f(ke.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(ke.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(ke.scale,1,1,3),maxColumn:i.clampedInt(ke.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:m(ke.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:m(ke.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:s.clamp(ke.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Ce(oe){return oe==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ae extends I{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(82,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{top:i.clampedInt(ke.top,0,0,1e3),bottom:i.clampedInt(ke.bottom,0,0,1e3)}}}class ce extends I{constructor(){const le={enabled:!0,cycle:!0};super(86,"parameterHints",le,{"editor.parameterHints.enabled":{type:"boolean",default:le.enabled,description:b.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:le.cycle,description:b.localize(84,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{enabled:m(ke.enabled,this.defaultValue.enabled),cycle:m(ke.cycle,this.defaultValue.cycle)}}}class se extends S{constructor(){super(143)}compute(le,ke,je){return le.pixelRatio}}class j extends I{constructor(){const le={other:"on",comments:"off",strings:"off"},ke=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(85,null),b.localize(86,null),b.localize(87,null)]}];super(89,"quickSuggestions",le,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ke,default:le.strings,description:b.localize(88,null)},comments:{anyOf:ke,default:le.comments,description:b.localize(89,null)},other:{anyOf:ke,default:le.other,description:b.localize(90,null)}},default:le,markdownDescription:b.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=le}validate(le){if(typeof le=="boolean"){const Nt=le?"on":"off";return{comments:Nt,strings:Nt,other:Nt}}if(!le||typeof le!="object")return this.defaultValue;const{other:ke,comments:je,strings:Ze}=le,Me=["on","inline","off"];let lt,bt,Tt;return typeof ke=="boolean"?lt=ke?"on":"off":lt=f(ke,this.defaultValue.other,Me),typeof je=="boolean"?bt=je?"on":"off":bt=f(je,this.defaultValue.comments,Me),typeof Ze=="boolean"?Tt=Ze?"on":"off":Tt=f(Ze,this.defaultValue.strings,Me),{other:lt,comments:bt,strings:Tt}}}var ie;(function(oe){oe[oe.Off=0]="Off",oe[oe.On=1]="On",oe[oe.Relative=2]="Relative",oe[oe.Interval=3]="Interval",oe[oe.Custom=4]="Custom"})(ie||(e.RenderLineNumbersType=ie={}));class ue extends I{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(92,null),b.localize(93,null),b.localize(94,null),b.localize(95,null)],default:"on",description:b.localize(96,null)})}validate(le){let ke=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof le<"u"&&(typeof le=="function"?(ke=4,je=le):le==="interval"?ke=3:le==="relative"?ke=2:le==="on"?ke=1:ke=0),{renderType:ke,renderFn:je}}}function he(oe){const le=oe.get(98);return le==="editable"?oe.get(91):le!=="on"}class Te extends I{constructor(){const le=[],ke={type:"number",description:b.localize(97,null)};super(102,"rulers",le,{type:"array",items:{anyOf:[ke,{type:["object"],properties:{column:ke,color:{type:"string",description:b.localize(98,null),format:"color-hex"}}}]},default:le,description:b.localize(99,null)})}validate(le){if(Array.isArray(le)){const ke=[];for(const je of le)if(typeof je=="number")ke.push({column:i.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const Ze=je;ke.push({column:i.clampedInt(Ze.column,0,0,1e4),color:Ze.color})}return ke.sort((je,Ze)=>je.column-Ze.column),ke}return this.defaultValue}}class me extends I{constructor(){super(92,"readOnlyMessage",void 0)}validate(le){return!le||typeof le!="object"?this.defaultValue:le}}function Pe(oe,le){if(typeof oe!="string")return le;switch(oe){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends I{constructor(){const le={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",le,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(100,null),b.localize(101,null),b.localize(102,null)],default:"auto",description:b.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(104,null),b.localize(105,null),b.localize(106,null)],default:"auto",description:b.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:le.verticalScrollbarSize,description:b.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:le.horizontalScrollbarSize,description:b.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:le.scrollByPage,description:b.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:le.ignoreHorizontalScrollbarInContentHeight,description:b.localize(111,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le,je=i.clampedInt(ke.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ze=i.clampedInt(ke.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(ke.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(ke.vertical,this.defaultValue.vertical),horizontal:Pe(ke.horizontal,this.defaultValue.horizontal),useShadows:m(ke.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(ke.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(ke.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(ke.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(ke.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:i.clampedInt(ke.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:Ze,verticalSliderSize:i.clampedInt(ke.verticalSliderSize,Ze,0,1e3),scrollByPage:m(ke.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(ke.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class xe extends I{constructor(){const le={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",le,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.nonBasicASCII,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:le.invisibleCharacters,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:le.ambiguousCharacters,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.includeComments,description:b.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.includeStrings,description:b.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:le.allowedCharacters,description:b.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:le.allowedLocales,description:b.localize(118,null)}})}applyUpdate(le,ke){let je=!1;ke.allowedCharacters&&le&&(O.equals(le.allowedCharacters,ke.allowedCharacters)||(le={...le,allowedCharacters:ke.allowedCharacters},je=!0)),ke.allowedLocales&&le&&(O.equals(le.allowedLocales,ke.allowedLocales)||(le={...le,allowedLocales:ke.allowedLocales},je=!0));const Ze=super.applyUpdate(le,ke);return je?new v(Ze.newValue,!0):Ze}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{nonBasicASCII:ge(ke.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(ke.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(ke.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ge(ke.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ge(ke.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(le.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(le.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(le,ke){if(typeof le!="object"||!le)return ke;const je={};for(const[Ze,Me]of Object.entries(le))Me===!0&&(je[Ze]=!0);return je}}class H extends I{constructor(){const le={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",le,{"editor.inlineSuggest.enabled":{type:"boolean",default:le.enabled,description:b.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:le.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],description:b.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:le.suppressSuggestions,description:b.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:le.fontFamily,description:b.localize(125,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{enabled:m(ke.enabled,this.defaultValue.enabled),mode:f(ke.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(ke.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(ke.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(ke.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(ke.fontFamily,this.defaultValue.fontFamily)}}}class U extends I{constructor(){const le={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",le,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:le.enabled,description:b.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:le.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(127,null),b.localize(128,null),b.localize(129,null)],description:b.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:le.fontFamily,description:b.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:le.backgroundColoring,description:b.localize(132,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{enabled:m(ke.enabled,this.defaultValue.enabled),showToolbar:f(ke.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(ke.fontFamily,this.defaultValue.fontFamily),keepOnBlur:m(ke.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:m(ke.backgroundColoring,this.defaultValue.backgroundColoring)}}}class X extends I{constructor(){const le={enabled:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",le,{"editor.bracketPairColorization.enabled":{type:"boolean",default:le.enabled,markdownDescription:b.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:le.independentColorPoolPerBracketType,description:b.localize(134,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{enabled:m(ke.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(ke.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class K extends I{constructor(){const le={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",le,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:le.bracketPairs,description:b.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null)],default:le.bracketPairsHorizontal,description:b.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:le.highlightActiveBracketPair,description:b.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:le.indentation,description:b.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:le.highlightActiveIndentation,description:b.localize(148,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{bracketPairs:ge(ke.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ge(ke.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(ke.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(ke.indentation,this.defaultValue.indentation),highlightActiveIndentation:ge(ke.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ge(oe,le,ke){const je=ke.indexOf(oe);return je===-1?le:ke[je]}class Ee extends I{constructor(){const le={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",le,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(149,null),b.localize(150,null)],default:le.insertMode,description:b.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:le.filterGraceful,description:b.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:le.localityBonus,description:b.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:le.shareSuggestSelections,markdownDescription:b.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(155,null),b.localize(156,null),b.localize(157,null),b.localize(158,null)],default:le.selectionMode,markdownDescription:b.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:le.snippetsPreventQuickSuggestions,description:b.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:le.showIcons,description:b.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:le.showStatusBar,description:b.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:le.preview,description:b.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:le.showInlineDetails,description:b.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(196,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{insertMode:f(ke.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(ke.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(ke.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(ke.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(ke.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(ke.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(ke.showIcons,this.defaultValue.showIcons),showStatusBar:m(ke.showStatusBar,this.defaultValue.showStatusBar),preview:m(ke.preview,this.defaultValue.preview),previewMode:f(ke.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(ke.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(ke.showMethods,this.defaultValue.showMethods),showFunctions:m(ke.showFunctions,this.defaultValue.showFunctions),showConstructors:m(ke.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(ke.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(ke.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(ke.showFields,this.defaultValue.showFields),showVariables:m(ke.showVariables,this.defaultValue.showVariables),showClasses:m(ke.showClasses,this.defaultValue.showClasses),showStructs:m(ke.showStructs,this.defaultValue.showStructs),showInterfaces:m(ke.showInterfaces,this.defaultValue.showInterfaces),showModules:m(ke.showModules,this.defaultValue.showModules),showProperties:m(ke.showProperties,this.defaultValue.showProperties),showEvents:m(ke.showEvents,this.defaultValue.showEvents),showOperators:m(ke.showOperators,this.defaultValue.showOperators),showUnits:m(ke.showUnits,this.defaultValue.showUnits),showValues:m(ke.showValues,this.defaultValue.showValues),showConstants:m(ke.showConstants,this.defaultValue.showConstants),showEnums:m(ke.showEnums,this.defaultValue.showEnums),showEnumMembers:m(ke.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(ke.showKeywords,this.defaultValue.showKeywords),showWords:m(ke.showWords,this.defaultValue.showWords),showColors:m(ke.showColors,this.defaultValue.showColors),showFiles:m(ke.showFiles,this.defaultValue.showFiles),showReferences:m(ke.showReferences,this.defaultValue.showReferences),showFolders:m(ke.showFolders,this.defaultValue.showFolders),showTypeParameters:m(ke.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(ke.showSnippets,this.defaultValue.showSnippets),showUsers:m(ke.showUsers,this.defaultValue.showUsers),showIssues:m(ke.showIssues,this.defaultValue.showIssues)}}}class ze extends I{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(198,null),default:!0,type:"boolean"}})}validate(le){return!le||typeof le!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(le.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(le.selectSubwords,this.defaultValue.selectSubwords)}}}class He extends I{constructor(){const le=[];super(130,"wordSegmenterLocales",le,{anyOf:[{description:b.localize(199,null),type:"string"},{description:b.localize(200,null),type:"array",items:{type:"string"}}]})}validate(le){if(typeof le=="string"&&(le=[le]),Array.isArray(le)){const ke=[];for(const je of le)if(typeof je=="string")try{Intl.Segmenter.supportedLocalesOf(je).length>0&&ke.push(je)}catch{}return ke}return this.defaultValue}}var Ye;(function(oe){oe[oe.None=0]="None",oe[oe.Same=1]="Same",oe[oe.Indent=2]="Indent",oe[oe.DeepIndent=3]="DeepIndent"})(Ye||(e.WrappingIndent=Ye={}));class it extends I{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(201,null),b.localize(202,null),b.localize(203,null),b.localize(204,null)],description:b.localize(205,null),default:"same"}})}validate(le){switch(le){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(le,ke,je){return ke.get(2)===2?0:je}}class rt extends S{constructor(){super(146)}compute(le,ke,je){const Ze=ke.get(145);return{isDominatedByLongLines:le.isDominatedByLongLines,isWordWrapMinified:Ze.isWordWrapMinified,isViewportWrapping:Ze.isViewportWrapping,wrappingColumn:Ze.wrappingColumn}}}class at extends I{constructor(){const le={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",le,{"editor.dropIntoEditor.enabled":{type:"boolean",default:le.enabled,markdownDescription:b.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(208,null),b.localize(209,null)],default:"afterDrop"}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{enabled:m(ke.enabled,this.defaultValue.enabled),showDropSelector:f(ke.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends I{constructor(){const le={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",le,{"editor.pasteAs.enabled":{type:"boolean",default:le.enabled,markdownDescription:b.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(212,null),b.localize(213,null)],default:"afterPaste"}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const ke=le;return{enabled:m(ke.enabled,this.defaultValue.enabled),showPasteSelector:f(ke.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const De="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?Be:L.isLinux?qe:De,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(oe){return e.editorOptionsRegistry[oe.id]=oe,oe}var Qe;(function(oe){oe[oe.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",oe[oe.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",oe[oe.accessibilitySupport=2]="accessibilitySupport",oe[oe.accessibilityPageSize=3]="accessibilityPageSize",oe[oe.ariaLabel=4]="ariaLabel",oe[oe.ariaRequired=5]="ariaRequired",oe[oe.autoClosingBrackets=6]="autoClosingBrackets",oe[oe.autoClosingComments=7]="autoClosingComments",oe[oe.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",oe[oe.autoClosingDelete=9]="autoClosingDelete",oe[oe.autoClosingOvertype=10]="autoClosingOvertype",oe[oe.autoClosingQuotes=11]="autoClosingQuotes",oe[oe.autoIndent=12]="autoIndent",oe[oe.automaticLayout=13]="automaticLayout",oe[oe.autoSurround=14]="autoSurround",oe[oe.bracketPairColorization=15]="bracketPairColorization",oe[oe.guides=16]="guides",oe[oe.codeLens=17]="codeLens",oe[oe.codeLensFontFamily=18]="codeLensFontFamily",oe[oe.codeLensFontSize=19]="codeLensFontSize",oe[oe.colorDecorators=20]="colorDecorators",oe[oe.colorDecoratorsLimit=21]="colorDecoratorsLimit",oe[oe.columnSelection=22]="columnSelection",oe[oe.comments=23]="comments",oe[oe.contextmenu=24]="contextmenu",oe[oe.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",oe[oe.cursorBlinking=26]="cursorBlinking",oe[oe.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",oe[oe.cursorStyle=28]="cursorStyle",oe[oe.cursorSurroundingLines=29]="cursorSurroundingLines",oe[oe.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",oe[oe.cursorWidth=31]="cursorWidth",oe[oe.disableLayerHinting=32]="disableLayerHinting",oe[oe.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",oe[oe.domReadOnly=34]="domReadOnly",oe[oe.dragAndDrop=35]="dragAndDrop",oe[oe.dropIntoEditor=36]="dropIntoEditor",oe[oe.emptySelectionClipboard=37]="emptySelectionClipboard",oe[oe.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",oe[oe.extraEditorClassName=39]="extraEditorClassName",oe[oe.fastScrollSensitivity=40]="fastScrollSensitivity",oe[oe.find=41]="find",oe[oe.fixedOverflowWidgets=42]="fixedOverflowWidgets",oe[oe.folding=43]="folding",oe[oe.foldingStrategy=44]="foldingStrategy",oe[oe.foldingHighlight=45]="foldingHighlight",oe[oe.foldingImportsByDefault=46]="foldingImportsByDefault",oe[oe.foldingMaximumRegions=47]="foldingMaximumRegions",oe[oe.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",oe[oe.fontFamily=49]="fontFamily",oe[oe.fontInfo=50]="fontInfo",oe[oe.fontLigatures=51]="fontLigatures",oe[oe.fontSize=52]="fontSize",oe[oe.fontWeight=53]="fontWeight",oe[oe.fontVariations=54]="fontVariations",oe[oe.formatOnPaste=55]="formatOnPaste",oe[oe.formatOnType=56]="formatOnType",oe[oe.glyphMargin=57]="glyphMargin",oe[oe.gotoLocation=58]="gotoLocation",oe[oe.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",oe[oe.hover=60]="hover",oe[oe.inDiffEditor=61]="inDiffEditor",oe[oe.inlineSuggest=62]="inlineSuggest",oe[oe.inlineEdit=63]="inlineEdit",oe[oe.letterSpacing=64]="letterSpacing",oe[oe.lightbulb=65]="lightbulb",oe[oe.lineDecorationsWidth=66]="lineDecorationsWidth",oe[oe.lineHeight=67]="lineHeight",oe[oe.lineNumbers=68]="lineNumbers",oe[oe.lineNumbersMinChars=69]="lineNumbersMinChars",oe[oe.linkedEditing=70]="linkedEditing",oe[oe.links=71]="links",oe[oe.matchBrackets=72]="matchBrackets",oe[oe.minimap=73]="minimap",oe[oe.mouseStyle=74]="mouseStyle",oe[oe.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",oe[oe.mouseWheelZoom=76]="mouseWheelZoom",oe[oe.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",oe[oe.multiCursorModifier=78]="multiCursorModifier",oe[oe.multiCursorPaste=79]="multiCursorPaste",oe[oe.multiCursorLimit=80]="multiCursorLimit",oe[oe.occurrencesHighlight=81]="occurrencesHighlight",oe[oe.overviewRulerBorder=82]="overviewRulerBorder",oe[oe.overviewRulerLanes=83]="overviewRulerLanes",oe[oe.padding=84]="padding",oe[oe.pasteAs=85]="pasteAs",oe[oe.parameterHints=86]="parameterHints",oe[oe.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",oe[oe.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",oe[oe.quickSuggestions=89]="quickSuggestions",oe[oe.quickSuggestionsDelay=90]="quickSuggestionsDelay",oe[oe.readOnly=91]="readOnly",oe[oe.readOnlyMessage=92]="readOnlyMessage",oe[oe.renameOnType=93]="renameOnType",oe[oe.renderControlCharacters=94]="renderControlCharacters",oe[oe.renderFinalNewline=95]="renderFinalNewline",oe[oe.renderLineHighlight=96]="renderLineHighlight",oe[oe.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",oe[oe.renderValidationDecorations=98]="renderValidationDecorations",oe[oe.renderWhitespace=99]="renderWhitespace",oe[oe.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",oe[oe.roundedSelection=101]="roundedSelection",oe[oe.rulers=102]="rulers",oe[oe.scrollbar=103]="scrollbar",oe[oe.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",oe[oe.scrollBeyondLastLine=105]="scrollBeyondLastLine",oe[oe.scrollPredominantAxis=106]="scrollPredominantAxis",oe[oe.selectionClipboard=107]="selectionClipboard",oe[oe.selectionHighlight=108]="selectionHighlight",oe[oe.selectOnLineNumbers=109]="selectOnLineNumbers",oe[oe.showFoldingControls=110]="showFoldingControls",oe[oe.showUnused=111]="showUnused",oe[oe.snippetSuggestions=112]="snippetSuggestions",oe[oe.smartSelect=113]="smartSelect",oe[oe.smoothScrolling=114]="smoothScrolling",oe[oe.stickyScroll=115]="stickyScroll",oe[oe.stickyTabStops=116]="stickyTabStops",oe[oe.stopRenderingLineAfter=117]="stopRenderingLineAfter",oe[oe.suggest=118]="suggest",oe[oe.suggestFontSize=119]="suggestFontSize",oe[oe.suggestLineHeight=120]="suggestLineHeight",oe[oe.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",oe[oe.suggestSelection=122]="suggestSelection",oe[oe.tabCompletion=123]="tabCompletion",oe[oe.tabIndex=124]="tabIndex",oe[oe.unicodeHighlighting=125]="unicodeHighlighting",oe[oe.unusualLineTerminators=126]="unusualLineTerminators",oe[oe.useShadowDOM=127]="useShadowDOM",oe[oe.useTabStops=128]="useTabStops",oe[oe.wordBreak=129]="wordBreak",oe[oe.wordSegmenterLocales=130]="wordSegmenterLocales",oe[oe.wordSeparators=131]="wordSeparators",oe[oe.wordWrap=132]="wordWrap",oe[oe.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",oe[oe.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",oe[oe.wordWrapColumn=135]="wordWrapColumn",oe[oe.wordWrapOverride1=136]="wordWrapOverride1",oe[oe.wordWrapOverride2=137]="wordWrapOverride2",oe[oe.wrappingIndent=138]="wrappingIndent",oe[oe.wrappingStrategy=139]="wrappingStrategy",oe[oe.showDeprecated=140]="showDeprecated",oe[oe.inlayHints=141]="inlayHints",oe[oe.editorClassName=142]="editorClassName",oe[oe.pixelRatio=143]="pixelRatio",oe[oe.tabFocusMode=144]="tabFocusMode",oe[oe.layoutInfo=145]="layoutInfo",oe[oe.wrappingInfo=146]="wrappingInfo",oe[oe.defaultColorDecorators=147]="defaultColorDecorators",oe[oe.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",oe[oe.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Qe||(e.EditorOption=Qe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(214,null)})),acceptSuggestionOnEnter:Le(new h(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(215,null),""],markdownDescription:b.localize(216,null)})),accessibilitySupport:Le(new d),accessibilityPageSize:Le(new i(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(217,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",b.localize(218,null))),ariaRequired:Le(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Le(new h(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(220,null),b.localize(221,null),""],description:b.localize(222,null)})),autoClosingComments:Le(new h(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),autoClosingDelete:Le(new h(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(226,null),""],description:b.localize(227,null)})),autoClosingOvertype:Le(new h(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(228,null),""],description:b.localize(229,null)})),autoClosingQuotes:Le(new h(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(230,null),b.localize(231,null),""],description:b.localize(232,null)})),autoIndent:Le(new l(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[b.localize(233,null),b.localize(234,null),b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),automaticLayout:Le(new o(13,"automaticLayout",!1)),autoSurround:Le(new h(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null),""],description:b.localize(242,null)})),bracketPairColorization:Le(new X),bracketPairGuides:Le(new K),stickyTabStops:Le(new o(116,"stickyTabStops",!1,{description:b.localize(243,null)})),codeLens:Le(new o(17,"codeLens",!0,{description:b.localize(244,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:b.localize(245,null)})),codeLensFontSize:Le(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(246,null)})),colorDecorators:Le(new o(20,"colorDecorators",!0,{description:b.localize(247,null)})),colorDecoratorActivatedOn:Le(new h(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(248,null),b.localize(249,null),b.localize(250,null)],description:b.localize(251,null)})),colorDecoratorsLimit:Le(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(252,null)})),columnSelection:Le(new o(22,"columnSelection",!1,{description:b.localize(253,null)})),comments:Le(new g),contextmenu:Le(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new o(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(254,null)})),cursorBlinking:Le(new l(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],E,{description:b.localize(255,null)})),cursorSmoothCaretAnimation:Le(new h(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(256,null),b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),cursorStyle:Le(new l(28,"cursorStyle",_.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:b.localize(260,null)})),cursorSurroundingLines:Le(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(261,null)})),cursorSurroundingLinesStyle:Le(new h(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(262,null),b.localize(263,null)],markdownDescription:b.localize(264,null)})),cursorWidth:Le(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(265,null)})),disableLayerHinting:Le(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new o(34,"domReadOnly",!1)),dragAndDrop:Le(new o(35,"dragAndDrop",!0,{description:b.localize(266,null)})),emptySelectionClipboard:Le(new z),dropIntoEditor:Le(new at),stickyScroll:Le(new Ie),experimentalWhitespaceRendering:Le(new h(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(267,null),b.localize(268,null),b.localize(269,null)],description:b.localize(270,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new s(40,"fastScrollSensitivity",5,oe=>oe<=0?5:oe,{markdownDescription:b.localize(271,null)})),find:Le(new x),fixedOverflowWidgets:Le(new o(42,"fixedOverflowWidgets",!1)),folding:Le(new o(43,"folding",!0,{description:b.localize(272,null)})),foldingStrategy:Le(new h(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(273,null),b.localize(274,null)],description:b.localize(275,null)})),foldingHighlight:Le(new o(45,"foldingHighlight",!0,{description:b.localize(276,null)})),foldingImportsByDefault:Le(new o(46,"foldingImportsByDefault",!1,{description:b.localize(277,null)})),foldingMaximumRegions:Le(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(278,null)})),unfoldOnClickAfterEndOfLine:Le(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(279,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(280,null)})),fontInfo:Le(new M),fontLigatures2:Le(new F),fontSize:Le(new B),fontWeight:Le(new W),fontVariations:Le(new N),formatOnPaste:Le(new o(55,"formatOnPaste",!1,{description:b.localize(281,null)})),formatOnType:Le(new o(56,"formatOnType",!1,{description:b.localize(282,null)})),glyphMargin:Le(new o(57,"glyphMargin",!0,{description:b.localize(283,null)})),gotoLocation:Le(new Y),hideCursorInOverviewRuler:Le(new o(59,"hideCursorInOverviewRuler",!1,{description:b.localize(284,null)})),hover:Le(new Z),inDiffEditor:Le(new o(61,"inDiffEditor",!1)),letterSpacing:Le(new s(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,oe=>s.clamp(oe,-5,20),{description:b.localize(285,null)})),lightbulb:Le(new ve),lineDecorationsWidth:Le(new $),lineHeight:Le(new ne),lineNumbers:Le(new ue),lineNumbersMinChars:Le(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new o(70,"linkedEditing",!1,{description:b.localize(286,null)})),links:Le(new o(71,"links",!0,{description:b.localize(287,null)})),matchBrackets:Le(new h(72,"matchBrackets","always",["always","near","never"],{description:b.localize(288,null)})),minimap:Le(new be),mouseStyle:Le(new h(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new s(75,"mouseWheelScrollSensitivity",1,oe=>oe===0?1:oe,{markdownDescription:b.localize(289,null)})),mouseWheelZoom:Le(new o(76,"mouseWheelZoom",!1,{markdownDescription:L.isMacintosh?b.localize(290,null):b.localize(291,null)})),multiCursorMergeOverlapping:Le(new o(77,"multiCursorMergeOverlapping",!0,{description:b.localize(292,null)})),multiCursorModifier:Le(new l(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ce,{markdownEnumDescriptions:[b.localize(293,null),b.localize(294,null)],markdownDescription:b.localize(295,null)})),multiCursorPaste:Le(new h(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(296,null),b.localize(297,null)],markdownDescription:b.localize(298,null)})),multiCursorLimit:Le(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(299,null)})),occurrencesHighlight:Le(new h(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(300,null),b.localize(301,null),b.localize(302,null)],markdownDescription:b.localize(303,null)})),overviewRulerBorder:Le(new o(82,"overviewRulerBorder",!0,{description:b.localize(304,null)})),overviewRulerLanes:Le(new i(83,"overviewRulerLanes",3,0,3)),padding:Le(new ae),pasteAs:Le(new st),parameterHints:Le(new ce),peekWidgetDefaultFocus:Le(new h(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(305,null),b.localize(306,null)],description:b.localize(307,null)})),definitionLinkOpensInPeek:Le(new o(88,"definitionLinkOpensInPeek",!1,{description:b.localize(308,null)})),quickSuggestions:Le(new j),quickSuggestionsDelay:Le(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(309,null)})),readOnly:Le(new o(91,"readOnly",!1)),readOnlyMessage:Le(new me),renameOnType:Le(new o(93,"renameOnType",!1,{description:b.localize(310,null),markdownDeprecationMessage:b.localize(311,null)})),renderControlCharacters:Le(new o(94,"renderControlCharacters",!0,{description:b.localize(312,null),restricted:!0})),renderFinalNewline:Le(new h(95,"renderFinalNewline",L.isLinux?"dimmed":"on",["off","on","dimmed"],{description:b.localize(313,null)})),renderLineHighlight:Le(new h(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(314,null)],description:b.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Le(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(316,null)})),renderValidationDecorations:Le(new h(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new h(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(317,null),b.localize(318,null),b.localize(319,null),""],description:b.localize(320,null)})),revealHorizontalRightPadding:Le(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new o(101,"roundedSelection",!0,{description:b.localize(321,null)})),rulers:Le(new Te),scrollbar:Le(new Ae),scrollBeyondLastColumn:Le(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(322,null)})),scrollBeyondLastLine:Le(new o(105,"scrollBeyondLastLine",!0,{description:b.localize(323,null)})),scrollPredominantAxis:Le(new o(106,"scrollPredominantAxis",!0,{description:b.localize(324,null)})),selectionClipboard:Le(new o(107,"selectionClipboard",!0,{description:b.localize(325,null),included:L.isLinux})),selectionHighlight:Le(new o(108,"selectionHighlight",!0,{description:b.localize(326,null)})),selectOnLineNumbers:Le(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Le(new h(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(327,null),b.localize(328,null),b.localize(329,null)],description:b.localize(330,null)})),showUnused:Le(new o(111,"showUnused",!0,{description:b.localize(331,null)})),showDeprecated:Le(new o(140,"showDeprecated",!0,{description:b.localize(332,null)})),inlayHints:Le(new J),snippetSuggestions:Le(new h(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),smartSelect:Le(new ze),smoothScrolling:Le(new o(114,"smoothScrolling",!1,{description:b.localize(338,null)})),stopRenderingLineAfter:Le(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new Ee),inlineSuggest:Le(new H),inlineEdit:Le(new U),inlineCompletionsAccessibilityVerbose:Le(new o(149,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(339,null)})),suggestFontSize:Le(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new o(121,"suggestOnTriggerCharacters",!0,{description:b.localize(342,null)})),suggestSelection:Le(new h(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),tabCompletion:Le(new h(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null)],description:b.localize(350,null)})),tabIndex:Le(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new xe),unusualLineTerminators:Le(new h(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(351,null),b.localize(352,null),b.localize(353,null)],description:b.localize(354,null)})),useShadowDOM:Le(new o(127,"useShadowDOM",!0)),useTabStops:Le(new o(128,"useTabStops",!0,{description:b.localize(355,null)})),wordBreak:Le(new h(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(356,null),b.localize(357,null)],description:b.localize(358,null)})),wordSegmenterLocales:Le(new He),wordSeparators:Le(new t(131,"wordSeparators",R.USUAL_WORD_SEPARATORS,{description:b.localize(359,null)})),wordWrap:Le(new h(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(360,null),b.localize(361,null),b.localize(362,null),b.localize(363,null)],description:b.localize(364,null)})),wordWrapBreakAfterCharacters:Le(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(365,null)})),wordWrapOverride1:Le(new h(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new h(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new k),defaultColorDecorators:Le(new o(147,"defaultColorDecorators",!1,{markdownDescription:b.localize(366,null)})),pixelRatio:Le(new se),tabFocusMode:Le(new o(144,"tabFocusMode",!1,{markdownDescription:b.localize(367,null)})),layoutInfo:Le(new Q),wrappingInfo:Le(new rt),wrappingIndent:Le(new it),wrappingStrategy:Le(new re)}}),define(ye[202],_e([9,10]),function(de,e){return de.create("vs/editor/common/languages",e)}),define(ye[83],_e([1,0,78,2,175,29,185,202]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.FoldingRangeKind=e.TextEdit=e.SymbolKinds=e.SymbolTag=e.symbolKindNames=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0,e.isLocationLink=f,e.getAriaLabelForSymbol=l;class p{constructor(Y,Z,G){this.offset=Y,this.type=Z,this.language=G,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=p;class w{constructor(Y,Z){this.tokens=Y,this.endState=Z,this._tokenizationResultBrand=void 0}}e.TokenizationResult=w;class A{constructor(Y,Z){this.tokens=Y,this.endState=Z,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=A;var I;(function(W){W[W.Method=0]="Method",W[W.Function=1]="Function",W[W.Constructor=2]="Constructor",W[W.Field=3]="Field",W[W.Variable=4]="Variable",W[W.Class=5]="Class",W[W.Struct=6]="Struct",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Event=10]="Event",W[W.Operator=11]="Operator",W[W.Unit=12]="Unit",W[W.Value=13]="Value",W[W.Constant=14]="Constant",W[W.Enum=15]="Enum",W[W.EnumMember=16]="EnumMember",W[W.Keyword=17]="Keyword",W[W.Text=18]="Text",W[W.Color=19]="Color",W[W.File=20]="File",W[W.Reference=21]="Reference",W[W.Customcolor=22]="Customcolor",W[W.Folder=23]="Folder",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue",W[W.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var v;(function(W){const Y=new Map;Y.set(0,c.Codicon.symbolMethod),Y.set(1,c.Codicon.symbolFunction),Y.set(2,c.Codicon.symbolConstructor),Y.set(3,c.Codicon.symbolField),Y.set(4,c.Codicon.symbolVariable),Y.set(5,c.Codicon.symbolClass),Y.set(6,c.Codicon.symbolStruct),Y.set(7,c.Codicon.symbolInterface),Y.set(8,c.Codicon.symbolModule),Y.set(9,c.Codicon.symbolProperty),Y.set(10,c.Codicon.symbolEvent),Y.set(11,c.Codicon.symbolOperator),Y.set(12,c.Codicon.symbolUnit),Y.set(13,c.Codicon.symbolValue),Y.set(15,c.Codicon.symbolEnum),Y.set(14,c.Codicon.symbolConstant),Y.set(15,c.Codicon.symbolEnum),Y.set(16,c.Codicon.symbolEnumMember),Y.set(17,c.Codicon.symbolKeyword),Y.set(27,c.Codicon.symbolSnippet),Y.set(18,c.Codicon.symbolText),Y.set(19,c.Codicon.symbolColor),Y.set(20,c.Codicon.symbolFile),Y.set(21,c.Codicon.symbolReference),Y.set(22,c.Codicon.symbolCustomColor),Y.set(23,c.Codicon.symbolFolder),Y.set(24,c.Codicon.symbolTypeParameter),Y.set(25,c.Codicon.account),Y.set(26,c.Codicon.issues);function Z(re){let te=Y.get(re);return te||(console.info("No codicon found for CompletionItemKind "+re),te=c.Codicon.symbolProperty),te}W.toIcon=Z;const G=new Map;G.set("method",0),G.set("function",1),G.set("constructor",2),G.set("field",3),G.set("variable",4),G.set("class",5),G.set("struct",6),G.set("interface",7),G.set("module",8),G.set("property",9),G.set("event",10),G.set("operator",11),G.set("unit",12),G.set("value",13),G.set("constant",14),G.set("enum",15),G.set("enum-member",16),G.set("enumMember",16),G.set("keyword",17),G.set("snippet",27),G.set("text",18),G.set("color",19),G.set("file",20),G.set("reference",21),G.set("customcolor",22),G.set("folder",23),G.set("type-parameter",24),G.set("typeParameter",24),G.set("account",25),G.set("issue",26);function Q(re,te){let ve=G.get(re);return typeof ve>"u"&&!te&&(ve=9),ve}W.fromString=Q})(v||(e.CompletionItemKinds=v={}));var C;(function(W){W[W.Deprecated=1]="Deprecated"})(C||(e.CompletionItemTag=C={}));var S;(function(W){W[W.None=0]="None",W[W.KeepWhitespace=1]="KeepWhitespace",W[W.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var a;(function(W){W[W.Word=0]="Word",W[W.Line=1]="Line",W[W.Suggest=2]="Suggest"})(a||(e.PartialAcceptTriggerKind=a={}));var m;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(e.CompletionTriggerKind=m={}));var o;(function(W){W[W.Automatic=0]="Automatic",W[W.Explicit=1]="Explicit"})(o||(e.InlineCompletionTriggerKind=o={}));class n{constructor(Y,Z,G,Q){this.range=Y,this.text=Z,this.completionKind=G,this.isSnippetText=Q}equals(Y){return T.Range.lift(this.range).equalsRange(Y.range)&&this.text===Y.text&&this.completionKind===Y.completionKind&&this.isSnippetText===Y.isSnippetText}}e.SelectedSuggestionInfo=n;var i;(function(W){W[W.Invoke=1]="Invoke",W[W.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(W){W[W.Automatic=0]="Automatic",W[W.PasteAs=1]="PasteAs"})(r||(e.DocumentPasteTriggerKind=r={}));var s;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(s||(e.SignatureHelpTriggerKind=s={}));var t;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(t||(e.DocumentHighlightKind=t={}));function f(W){return W&&O.URI.isUri(W.uri)&&T.Range.isIRange(W.range)&&(T.Range.isIRange(W.originSelectionRange)||T.Range.isIRange(W.targetSelectionRange))}var h;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(h||(e.SymbolKind=h={})),e.symbolKindNames={17:(0,b.localize)(0,null),16:(0,b.localize)(1,null),4:(0,b.localize)(2,null),13:(0,b.localize)(3,null),8:(0,b.localize)(4,null),9:(0,b.localize)(5,null),21:(0,b.localize)(6,null),23:(0,b.localize)(7,null),7:(0,b.localize)(8,null),0:(0,b.localize)(9,null),11:(0,b.localize)(10,null),10:(0,b.localize)(11,null),19:(0,b.localize)(12,null),5:(0,b.localize)(13,null),1:(0,b.localize)(14,null),2:(0,b.localize)(15,null),20:(0,b.localize)(16,null),15:(0,b.localize)(17,null),18:(0,b.localize)(18,null),24:(0,b.localize)(19,null),3:(0,b.localize)(20,null),6:(0,b.localize)(21,null),14:(0,b.localize)(22,null),22:(0,b.localize)(23,null),25:(0,b.localize)(24,null),12:(0,b.localize)(25,null)};function l(W,Y){return(0,b.localize)(26,null,W,e.symbolKindNames[Y])}var u;(function(W){W[W.Deprecated=1]="Deprecated"})(u||(e.SymbolTag=u={}));var d;(function(W){const Y=new Map;Y.set(0,c.Codicon.symbolFile),Y.set(1,c.Codicon.symbolModule),Y.set(2,c.Codicon.symbolNamespace),Y.set(3,c.Codicon.symbolPackage),Y.set(4,c.Codicon.symbolClass),Y.set(5,c.Codicon.symbolMethod),Y.set(6,c.Codicon.symbolProperty),Y.set(7,c.Codicon.symbolField),Y.set(8,c.Codicon.symbolConstructor),Y.set(9,c.Codicon.symbolEnum),Y.set(10,c.Codicon.symbolInterface),Y.set(11,c.Codicon.symbolFunction),Y.set(12,c.Codicon.symbolVariable),Y.set(13,c.Codicon.symbolConstant),Y.set(14,c.Codicon.symbolString),Y.set(15,c.Codicon.symbolNumber),Y.set(16,c.Codicon.symbolBoolean),Y.set(17,c.Codicon.symbolArray),Y.set(18,c.Codicon.symbolObject),Y.set(19,c.Codicon.symbolKey),Y.set(20,c.Codicon.symbolNull),Y.set(21,c.Codicon.symbolEnumMember),Y.set(22,c.Codicon.symbolStruct),Y.set(23,c.Codicon.symbolEvent),Y.set(24,c.Codicon.symbolOperator),Y.set(25,c.Codicon.symbolTypeParameter);function Z(G){let Q=Y.get(G);return Q||(console.info("No codicon found for SymbolKind "+G),Q=c.Codicon.symbolProperty),Q}W.toIcon=Z})(d||(e.SymbolKinds=d={}));class g{static asEditOperation(Y){return L.EditOperation.replace(T.Range.lift(Y.range),Y.text)}}e.TextEdit=g;class D{static{this.Comment=new D("comment")}static{this.Imports=new D("imports")}static{this.Region=new D("region")}static fromValue(Y){switch(Y){case"comment":return D.Comment;case"imports":return D.Imports;case"region":return D.Region}return new D(Y)}constructor(Y){this.value=Y}}e.FoldingRangeKind=D;var E;(function(W){W[W.AIGenerated=1]="AIGenerated"})(E||(e.NewSymbolNameTag=E={}));var _;(function(W){function Y(Z){return!Z||typeof Z!="object"?!1:typeof Z.id=="string"&&typeof Z.title=="string"}W.is=Y})(_||(e.Command=_={}));var y;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(y||(e.CommentThreadCollapsibleState=y={}));var P;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(P||(e.CommentThreadState=P={}));var k;(function(W){W[W.Current=0]="Current",W[W.Outdated=1]="Outdated"})(k||(e.CommentThreadApplicability=k={}));var z;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(z||(e.CommentMode=z={}));var x;(function(W){W[W.Published=0]="Published",W[W.Draft=1]="Draft"})(x||(e.CommentState=x={}));var F;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(F||(e.InlayHintKind=F={}));class N{constructor(Y){this.createSupport=Y,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(Y=>{Y&&Y.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}e.LazyTokenizationSupport=N,e.TokenizationRegistry=new R.TokenizationRegistry;var M;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(M||(e.ExternalUriOpenerPriority=M={}));var B;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(B||(e.InlineEditTriggerKind=B={}))}),define(ye[203],_e([9,10]),function(de,e){return de.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[204],_e([9,10]),function(de,e){return de.create("vs/platform/contextkey/common/contextkey",e)}),define(ye[205],_e([9,10]),function(de,e){return de.create("vs/platform/contextkey/common/scanner",e)}),define(ye[206],_e([9,10]),function(de,e){return de.create("vs/platform/dialogs/common/dialogs",e)}),define(ye[207],_e([9,10]),function(de,e){return de.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[208],_e([9,10]),function(de,e){return de.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[209],_e([9,10]),function(de,e){return de.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[210],_e([9,10]),function(de,e){return de.create("vs/platform/files/common/files",e)}),define(ye[211],_e([9,10]),function(de,e){return de.create("vs/platform/files/common/io",e)}),define(ye[212],_e([9,10]),function(de,e){return de.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ye[213],_e([9,10]),function(de,e){return de.create("vs/platform/log/common/log",e)}),define(ye[214],_e([9,10]),function(de,e){return de.create("vs/platform/markers/common/markers",e)}),define(ye[215],_e([9,10]),function(de,e){return de.create("vs/platform/theme/common/iconRegistry",e)}),define(ye[216],_e([9,10]),function(de,e){return de.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ye[217],_e([9,10]),function(de,e){return de.create("vs/platform/workspace/common/workspace",e)}),define(ye[218],_e([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ye[219],_e([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[220],_e([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[221],_e([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ye[222],_e([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ye[223],_e([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostLogService",e)}),define(ye[224],_e([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostNotebook",e)}),define(ye[225],_e([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[226],_e([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ye[227],_e([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[228],_e([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[229],_e([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ye[230],_e([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[231],_e([9,10]),function(de,e){return de.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[232],_e([9,10]),function(de,e){return de.create("vs/workbench/common/configuration",e)}),define(ye[233],_e([9,10]),function(de,e){return de.create("vs/workbench/common/editor",e)}),define(ye[234],_e([9,10]),function(de,e){return de.create("vs/workbench/common/views",e)}),define(ye[235],_e([9,10]),function(de,e){return de.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[236],_e([9,10]),function(de,e){return de.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[237],_e([9,10]),function(de,e){return de.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[238],_e([9,10]),function(de,e){return de.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[239],_e([9,10]),function(de,e){return de.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[240],_e([9,10]),function(de,e){return de.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[241],_e([9,10]),function(de,e){return de.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ye[242],_e([9,10]),function(de,e){return de.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[243],_e([9,10]),function(de,e){return de.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ye[244],_e([9,10]),function(de,e){return de.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[245],_e([1,0,13,205]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var L;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(L||(e.TokenType=L={}));function T(...w){switch(w.length){case 1:return(0,O.localize)(0,null,w[0]);case 2:return(0,O.localize)(1,null,w[0],w[1]);case 3:return(0,O.localize)(2,null,w[0],w[1],w[2]);default:return}}const R=(0,O.localize)(3,null),b=(0,O.localize)(4,null);class p{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,c.illegalState)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(A){return this._input=A,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const I=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:I})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const I=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:I})}else this._match(126)?this._addToken(9):this._error(T("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(T("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(T("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(A){return this._isAtEnd()||this._input.charCodeAt(this._current)!==A?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(A){this._tokens.push({type:A,offset:this._start})}_error(A){const I=this._start,v=this._input.substring(this._start,this._current),C={type:19,offset:this._start,lexeme:v};this._errors.push({offset:I,lexeme:v,additionalInfo:A}),this._tokens.push(C)}_string(){this.stringRe.lastIndex=this._start;const A=this.stringRe.exec(this._input);if(A){this._current=this._start+A[0].length;const I=this._input.substring(this._start,this._current),v=p._keywords.get(I);v?this._addToken(v):this._tokens.push({type:17,lexeme:I,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let A=this._current,I=!1,v=!1;for(;;){if(A>=this._input.length){this._current=A,this._error(b);return}const S=this._input.charCodeAt(A);if(I)I=!1;else if(S===47&&!v){A++;break}else S===91?v=!0:S===92?I=!0:S===93&&(v=!1);A++}for(;A<this._input.length&&p._regexFlags.has(this._input.charCodeAt(A));)A++;this._current=A;const C=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:C,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=p}),define(ye[246],_e([1,0,23,40,208,396]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=p,e.parseVersion=w,e.normalizeVersion=A,e.isValidVersion=I,e.validateExtensionManifest=v,e.isValidExtensionVersion=C,e.isEngineValid=S;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function p(o){return o=o.trim(),o==="*"||R.test(o)}function w(o){if(!p(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=o.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function A(o){if(!o)return null;const n=o.majorBase,i=o.majorMustEqual,r=o.minorBase;let s=o.minorMustEqual;const t=o.patchBase;let f=o.patchMustEqual;o.hasCaret&&(n===0||(s=!1),f=!1);let h=0;if(o.preRelease){const l=b.exec(o.preRelease);if(l){const[,u,d,g]=l;h=Date.UTC(Number(u),Number(d)-1,Number(g))}}return{majorBase:n,majorMustEqual:i,minorBase:r,minorMustEqual:s,patchBase:t,patchMustEqual:f,isMinimum:o.hasGreaterEquals,notBefore:h}}function I(o,n,i){let r;typeof o=="string"?r=A(w(o)):r=o;let s;n instanceof Date?s=n.getTime():typeof n=="string"&&(s=new Date(n).getTime());let t;if(typeof i=="string"?t=A(w(i)):t=i,!r||!t)return!1;const f=r.majorBase,h=r.minorBase,l=r.patchBase;let u=t.majorBase,d=t.minorBase,g=t.patchBase;const D=t.notBefore;let E=t.majorMustEqual,_=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?f>u?!0:f<u?!1:h>d?!0:h<d||s&&s<D?!1:l>=g:(f===1&&u===0&&(!E||!_||!y)&&(u=1,d=0,g=0,E=!0,_=!1,y=!1),f<u?!1:f>u?!E:h<d?!1:h>d?!_:l<g?!1:l>g?!y:!(s&&s<D))}function v(o,n,i,r,s){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([O.default.Error,L.localize(0,null)]),t;if(typeof r.name!="string")return t.push([O.default.Error,L.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([O.default.Error,L.localize(2,null,"version")]),t;if(!r.engines)return t.push([O.default.Error,L.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([O.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!m(r.extensionDependencies))return t.push([O.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!m(r.activationEvents))return t.push([O.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([O.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([O.default.Warning,L.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([O.default.Error,L.localize(9,null,"main")]),t;{const l=(0,c.joinPath)(i,r.main);(0,c.isEqualOrParent)(l,i)||t.push([O.default.Warning,L.localize(10,null,l.path,i.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([O.default.Error,L.localize(11,null,"browser")]),t;{const l=(0,c.joinPath)(i,r.browser);(0,c.isEqualOrParent)(l,i)||t.push([O.default.Warning,L.localize(12,null,l.path,i.path)])}}if(!T.valid(r.version))return t.push([O.default.Error,L.localize(13,null)]),t;const f=[];if(!C(o,n,r,s,f))for(const l of f)t.push([O.default.Error,l]);return t}function C(o,n,i,r,s){return r||typeof i.main>"u"&&typeof i.browser>"u"?!0:a(o,n,i.engines.vscode,s)}function S(o,n,i){return o==="*"||a(n,i,o)}function a(o,n,i,r=[]){const s=A(w(i));if(!s)return r.push(L.localize(14,null,i)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return r.push(L.localize(15,null,i)),!1}else if(!s.majorMustEqual)return r.push(L.localize(16,null,i)),!1;return I(o,n,s)?!0:(r.push(L.localize(17,null,o,i)),!1)}function m(o){if(!Array.isArray(o))return!1;for(let n=0,i=o.length;n<i;n++)if(typeof o[n]!="string")return!1;return!0}}),define(ye[106],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(L,T=[],R=!1){this.ctor=L,this.staticArguments=T,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=c}),define(ye[84],_e([1,0,106]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=T,e.getSingletonServiceDescriptors=R;const O=[];var L;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function T(b,p,w){p instanceof c.SyncDescriptor||(p=new c.SyncDescriptor(p,[],!!w)),O.push([b,p])}function R(){return O}}),define(ye[247],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(T,R){this.key=T,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=c;class O{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(const R of this._nodes.values())R.outgoing.size===0&&T.push(R);return T}insertEdge(T,R){const b=this.lookupOrInsertNode(T),p=this.lookupOrInsertNode(R);b.outgoing.set(p.key,p),p.incoming.set(b.key,b)}removeNode(T){const R=this._hashFn(T);this._nodes.delete(R);for(const b of this._nodes.values())b.outgoing.delete(R),b.incoming.delete(R)}lookupOrInsertNode(T){const R=this._hashFn(T);let b=this._nodes.get(R);return b||(b=new c(R,T),this._nodes.set(R,b)),b}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){const T=[];for(const[R,b]of this._nodes)T.push(`${R}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,R]of this._nodes){const b=new Set([T]),p=this._findCycle(R,b);if(p)return p}}_findCycle(T,R){for(const[b,p]of T.outgoing){if(R.has(b))return[...R,b].join(" -> ");R.add(b);const w=this._findCycle(p,R);if(w)return w;R.delete(b)}}}e.Graph=O}),define(ye[5],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=L,e.refineServiceDecorator=T;var c;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function b(p){return p[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=b})(c||(e._util=c={})),e.IInstantiationService=L("instantiationService");function O(R,b,p){b[c.DI_TARGET]===b?b[c.DI_DEPENDENCIES].push({id:R,index:p}):(b[c.DI_DEPENDENCIES]=[{id:R,index:p}],b[c.DI_TARGET]=b)}function L(R){if(c.serviceIds.has(R))return c.serviceIds.get(R);const b=function(p,w,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(b,p,A)};return b.toString=()=>R,c.serviceIds.set(R,b),b}function T(R){return R}}),define(ye[53],_e([1,0,18,2,5]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=T,e.isConfigurationUpdateOverrides=R,e.ConfigurationTargetToString=p,e.isConfigured=w,e.toValuesTree=A,e.addToValueTree=I,e.removeFromValueTree=v,e.getConfigurationValue=S,e.merge=a,e.getLanguageTagSettingPlainKey=m,e.IConfigurationService=(0,L.createDecorator)("configurationService");function T(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof O.URI)}function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof O.URI)}var b;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function p(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function w(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function A(o,n){const i=Object.create(null);for(const r in o)I(i,r,o[r],n);return i}function I(o,n,i,r){const s=n.split("."),t=s.pop();let f=o;for(let h=0;h<s.length;h++){const l=s[h];let u=f[l];switch(typeof u){case"undefined":u=f[l]=Object.create(null);break;case"object":break;default:r(`Ignoring ${n} as ${s.slice(0,h+1).join(".")} is ${JSON.stringify(u)}`);return}f=u}if(typeof f=="object"&&f!==null)try{f[t]=i}catch{r(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(f)}`)}else r(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(f)}`)}function v(o,n){const i=n.split(".");C(o,i)}function C(o,n){const i=n.shift();if(n.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const r=o[i];typeof r=="object"&&!Array.isArray(r)&&(C(r,n),Object.keys(r).length===0&&delete o[i])}}function S(o,n,i){function r(f,h){let l=f;for(const u of h){if(typeof l!="object"||l===null)return;l=l[u]}return l}const s=n.split("."),t=r(o,s);return typeof t>"u"?i:t}function a(o,n,i){Object.keys(n).forEach(r=>{r!=="__proto__"&&(r in o?c.isObject(o[r])&&c.isObject(n[r])?a(o[r],n[r],i):i&&(o[r]=n[r]):o[r]=n[r])})}function m(o){return o.replace(/[\[\]]/g,"")}}),define(ye[41],_e([1,0,11,14,245,5,204,13]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=w,e.validateWhenClauses=f,e.expressionsAreEqualWithConstantSubstitution=h,e.implies=te;const p=new Map;p.set("false",!1),p.set("true",!0),p.set("isMac",c.isMacintosh),p.set("isLinux",c.isLinux),p.set("isWindows",c.isWindows),p.set("isWeb",c.isWeb),p.set("isMacNative",c.isMacintosh&&!c.isWeb),p.set("isEdge",c.isEdge),p.set("isFirefox",c.isFirefox),p.set("isChrome",c.isChrome),p.set("isSafari",c.isSafari);function w(J,$){if(p.get(J)!==void 0)throw(0,b.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");p.set(J,$)}const A=Object.prototype.hasOwnProperty;var I;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const v={regexParsingWithErrorRecovery:!0},C=(0,R.localize)(0,null),S=(0,R.localize)(1,null),a=(0,R.localize)(2,null),m=(0,R.localize)(3,null),o=(0,R.localize)(4,null),n=(0,R.localize)(5,null),i=(0,R.localize)(6,null),r=(0,R.localize)(7,null);class s{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor($=v){this._config=$,this._scanner=new L.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse($){if($===""){this._parsingErrors.push({message:C,offset:0,lexeme:"",additionalInfo:S});return}this._tokens=this._scanner.reset($).scan(),this._current=0,this._parsingErrors=[];try{const ne=this._expr();if(!this._isAtEnd()){const be=this._peek(),Ce=be.type===17?n:void 0;throw this._parsingErrors.push({message:o,offset:be.offset,lexeme:L.Scanner.getLexeme(be),additionalInfo:Ce}),s._parseError}return ne}catch(ne){if(ne!==s._parseError)throw ne;return}}_expr(){return this._or()}_or(){const $=[this._and()];for(;this._matchOne(16);){const ne=this._and();$.push(ne)}return $.length===1?$[0]:t.or(...$)}_and(){const $=[this._term()];for(;this._matchOne(15);){const ne=this._term();$.push(ne)}return $.length===1?$[0]:t.and(...$)}_term(){if(this._matchOne(2)){const $=this._peek();switch($.type){case 11:return this._advance(),u.INSTANCE;case 12:return this._advance(),d.INSTANCE;case 0:{this._advance();const ne=this._expr();return this._consume(1,m),ne?.negate()}case 17:return this._advance(),P.create($.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",$)}}return this._primary()}_primary(){const $=this._peek();switch($.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const ne=this._expr();return this._consume(1,m),ne}case 17:{const ne=$.lexeme;if(this._advance(),this._matchOne(9)){const Ce=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Ce.type!==10)throw this._errExpectedButGot("REGEX",Ce);const ae=Ce.lexeme,ce=ae.lastIndexOf("/"),se=ce===ae.length-1?void 0:this._removeFlagsGY(ae.substring(ce+1));let j;try{j=new RegExp(ae.substring(1,ce),se)}catch{throw this._errExpectedButGot("REGEX",Ce)}return M.create(ne,j)}switch(Ce.type){case 10:case 19:{const ae=[Ce.lexeme];this._advance();let ce=this._peek(),se=0;for(let Te=0;Te<Ce.lexeme.length;Te++)Ce.lexeme.charCodeAt(Te)===40?se++:Ce.lexeme.charCodeAt(Te)===41&&se--;for(;!this._isAtEnd()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:se++;break;case 1:se--;break;case 10:case 18:for(let Te=0;Te<ce.lexeme.length;Te++)ce.lexeme.charCodeAt(Te)===40?se++:Ce.lexeme.charCodeAt(Te)===41&&se--}if(se<0)break;ae.push(L.Scanner.getLexeme(ce)),this._advance(),ce=this._peek()}const j=ae.join(""),ie=j.lastIndexOf("/"),ue=ie===j.length-1?void 0:this._removeFlagsGY(j.substring(ie+1));let he;try{he=new RegExp(j.substring(1,ie),ue)}catch{throw this._errExpectedButGot("REGEX",Ce)}return t.regex(ne,he)}case 18:{const ae=Ce.lexeme;this._advance();let ce=null;if(!(0,O.isFalsyOrWhitespace)(ae)){const se=ae.indexOf("/"),j=ae.lastIndexOf("/");if(se!==j&&se>=0){const ie=ae.slice(se+1,j),ue=ae[j+1]==="i"?"i":"";try{ce=new RegExp(ie,ue)}catch{throw this._errExpectedButGot("REGEX",Ce)}}}if(ce===null)throw this._errExpectedButGot("REGEX",Ce);return M.create(ne,ce)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,a);const Ce=this._value();return t.notIn(ne,Ce)}switch(this._peek().type){case 3:{this._advance();const Ce=this._value();if(this._previous().type===18)return t.equals(ne,Ce);switch(Ce){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,Ce)}}case 4:{this._advance();const Ce=this._value();if(this._previous().type===18)return t.notEquals(ne,Ce);switch(Ce){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,Ce)}}case 5:return this._advance(),F.create(ne,this._value());case 6:return this._advance(),N.create(ne,this._value());case 7:return this._advance(),z.create(ne,this._value());case 8:return this._advance(),x.create(ne,this._value());case 13:return this._advance(),t.in(ne,this._value());default:return t.has(ne)}}case 20:throw this._parsingErrors.push({message:i,offset:$.offset,lexeme:"",additionalInfo:r}),s._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const $=this._peek();switch($.type){case 17:case 18:return this._advance(),$.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY($){return $.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne($){return this._check($)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume($,ne){if(this._check($))return this._advance();throw this._errExpectedButGot(ne,this._peek())}_errExpectedButGot($,ne,be){const Ce=(0,R.localize)(8,null,$,L.Scanner.getLexeme(ne)),ae=ne.offset,ce=L.Scanner.getLexeme(ne);return this._parsingErrors.push({message:Ce,offset:ae,lexeme:ce,additionalInfo:be}),s._parseError}_check($){return this._peek().type===$}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=s;class t{static false(){return u.INSTANCE}static true(){return d.INSTANCE}static has($){return g.create($)}static equals($,ne){return D.create($,ne)}static notEquals($,ne){return y.create($,ne)}static regex($,ne){return M.create($,ne)}static in($,ne){return E.create($,ne)}static notIn($,ne){return _.create($,ne)}static not($){return P.create($)}static and(...$){return Y.create($,null,!0)}static or(...$){return Z.create($,null,!0)}static greater($,ne){return z.create($,ne)}static greaterEquals($,ne){return x.create($,ne)}static smaller($,ne){return F.create($,ne)}static smallerEquals($,ne){return N.create($,ne)}static{this._parser=new s({regexParsingWithErrorRecovery:!1})}static deserialize($){return $==null?void 0:this._parser.parse($)}}e.ContextKeyExpr=t;function f(J){const $=new s({regexParsingWithErrorRecovery:!1});return J.map(ne=>($.parse(ne),$.lexingErrors.length>0?$.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,R.localize)(9,null,be.additionalInfo):(0,R.localize)(10,null),offset:be.offset,length:be.lexeme.length})):$.parsingErrors.length>0?$.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function h(J,$){const ne=J?J.substituteConstants():void 0,be=$?$.substituteConstants():void 0;return!ne&&!be?!0:!ne||!be?!1:ne.equals(be)}function l(J,$){return J.cmp($)}class u{static{this.INSTANCE=new u}constructor(){this.type=0}cmp($){return this.type-$.type}equals($){return $.type===this.type}substituteConstants(){return this}evaluate($){return!1}serialize(){return"false"}keys(){return[]}map($){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=u;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp($){return this.type-$.type}equals($){return $.type===this.type}substituteConstants(){return this}evaluate($){return!0}serialize(){return"true"}keys(){return[]}map($){return this}negate(){return u.INSTANCE}}e.ContextKeyTrueExpr=d;class g{static create($,ne=null){const be=p.get($);return typeof be=="boolean"?be?d.INSTANCE:u.INSTANCE:new g($,ne)}constructor($,ne){this.key=$,this.negated=ne,this.type=2}cmp($){return $.type!==this.type?this.type-$.type:Q(this.key,$.key)}equals($){return $.type===this.type?this.key===$.key:!1}substituteConstants(){const $=p.get(this.key);return typeof $=="boolean"?$?d.INSTANCE:u.INSTANCE:this}evaluate($){return!!$.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map($){return $.mapDefined(this.key)}negate(){return this.negated||(this.negated=P.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=g;class D{static create($,ne,be=null){if(typeof ne=="boolean")return ne?g.create($,be):P.create($,be);const Ce=p.get($);return typeof Ce=="boolean"?ne===(Ce?"true":"false")?d.INSTANCE:u.INSTANCE:new D($,ne,be)}constructor($,ne,be){this.key=$,this.value=ne,this.negated=be,this.type=4}cmp($){return $.type!==this.type?this.type-$.type:re(this.key,this.value,$.key,$.value)}equals($){return $.type===this.type?this.key===$.key&&this.value===$.value:!1}substituteConstants(){const $=p.get(this.key);if(typeof $=="boolean"){const ne=$?"true":"false";return this.value===ne?d.INSTANCE:u.INSTANCE}return this}evaluate($){return $.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map($){return $.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=D;class E{static create($,ne){return new E($,ne)}constructor($,ne){this.key=$,this.valueKey=ne,this.type=10,this.negated=null}cmp($){return $.type!==this.type?this.type-$.type:re(this.key,this.valueKey,$.key,$.valueKey)}equals($){return $.type===this.type?this.key===$.key&&this.valueKey===$.valueKey:!1}substituteConstants(){return this}evaluate($){const ne=$.getValue(this.valueKey),be=$.getValue(this.key);return Array.isArray(ne)?ne.includes(be):typeof be=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,be):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map($){return $.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=_.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=E;class _{static create($,ne){return new _($,ne)}constructor($,ne){this.key=$,this.valueKey=ne,this.type=11,this._negated=E.create($,ne)}cmp($){return $.type!==this.type?this.type-$.type:this._negated.cmp($._negated)}equals($){return $.type===this.type?this._negated.equals($._negated):!1}substituteConstants(){return this}evaluate($){return!this._negated.evaluate($)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map($){return $.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=_;class y{static create($,ne,be=null){if(typeof ne=="boolean")return ne?P.create($,be):g.create($,be);const Ce=p.get($);return typeof Ce=="boolean"?ne===(Ce?"true":"false")?u.INSTANCE:d.INSTANCE:new y($,ne,be)}constructor($,ne,be){this.key=$,this.value=ne,this.negated=be,this.type=5}cmp($){return $.type!==this.type?this.type-$.type:re(this.key,this.value,$.key,$.value)}equals($){return $.type===this.type?this.key===$.key&&this.value===$.value:!1}substituteConstants(){const $=p.get(this.key);if(typeof $=="boolean"){const ne=$?"true":"false";return this.value===ne?u.INSTANCE:d.INSTANCE}return this}evaluate($){return $.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map($){return $.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=y;class P{static create($,ne=null){const be=p.get($);return typeof be=="boolean"?be?u.INSTANCE:d.INSTANCE:new P($,ne)}constructor($,ne){this.key=$,this.negated=ne,this.type=3}cmp($){return $.type!==this.type?this.type-$.type:Q(this.key,$.key)}equals($){return $.type===this.type?this.key===$.key:!1}substituteConstants(){const $=p.get(this.key);return typeof $=="boolean"?$?u.INSTANCE:d.INSTANCE:this}evaluate($){return!$.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map($){return $.mapNot(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=P;function k(J,$){if(typeof J=="string"){const ne=parseFloat(J);isNaN(ne)||(J=ne)}return typeof J=="string"||typeof J=="number"?$(J):u.INSTANCE}class z{static create($,ne,be=null){return k(ne,Ce=>new z($,Ce,be))}constructor($,ne,be){this.key=$,this.value=ne,this.negated=be,this.type=12}cmp($){return $.type!==this.type?this.type-$.type:re(this.key,this.value,$.key,$.value)}equals($){return $.type===this.type?this.key===$.key&&this.value===$.value:!1}substituteConstants(){return this}evaluate($){return typeof this.value=="string"?!1:parseFloat($.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map($){return $.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=z;class x{static create($,ne,be=null){return k(ne,Ce=>new x($,Ce,be))}constructor($,ne,be){this.key=$,this.value=ne,this.negated=be,this.type=13}cmp($){return $.type!==this.type?this.type-$.type:re(this.key,this.value,$.key,$.value)}equals($){return $.type===this.type?this.key===$.key&&this.value===$.value:!1}substituteConstants(){return this}evaluate($){return typeof this.value=="string"?!1:parseFloat($.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map($){return $.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=x;class F{static create($,ne,be=null){return k(ne,Ce=>new F($,Ce,be))}constructor($,ne,be){this.key=$,this.value=ne,this.negated=be,this.type=14}cmp($){return $.type!==this.type?this.type-$.type:re(this.key,this.value,$.key,$.value)}equals($){return $.type===this.type?this.key===$.key&&this.value===$.value:!1}substituteConstants(){return this}evaluate($){return typeof this.value=="string"?!1:parseFloat($.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map($){return $.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=F;class N{static create($,ne,be=null){return k(ne,Ce=>new N($,Ce,be))}constructor($,ne,be){this.key=$,this.value=ne,this.negated=be,this.type=15}cmp($){return $.type!==this.type?this.type-$.type:re(this.key,this.value,$.key,$.value)}equals($){return $.type===this.type?this.key===$.key&&this.value===$.value:!1}substituteConstants(){return this}evaluate($){return typeof this.value=="string"?!1:parseFloat($.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map($){return $.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=z.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=N;class M{static create($,ne){return new M($,ne)}constructor($,ne){this.key=$,this.regexp=ne,this.type=7,this.negated=null}cmp($){if($.type!==this.type)return this.type-$.type;if(this.key<$.key)return-1;if(this.key>$.key)return 1;const ne=this.regexp?this.regexp.source:"",be=$.regexp?$.regexp.source:"";return ne<be?-1:ne>be?1:0}equals($){if($.type===this.type){const ne=this.regexp?this.regexp.source:"",be=$.regexp?$.regexp.source:"";return this.key===$.key&&ne===be}return!1}substituteConstants(){return this}evaluate($){const ne=$.getValue(this.key);return this.regexp?this.regexp.test(ne):!1}serialize(){const $=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${$}`}keys(){return[this.key]}map($){return $.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=B.create(this)),this.negated}}e.ContextKeyRegexExpr=M;class B{static create($){return new B($)}constructor($){this._actual=$,this.type=8}cmp($){return $.type!==this.type?this.type-$.type:this._actual.cmp($._actual)}equals($){return $.type===this.type?this._actual.equals($._actual):!1}substituteConstants(){return this}evaluate($){return!this._actual.evaluate($)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map($){return new B(this._actual.map($))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=B;function W(J){let $=null;for(let ne=0,be=J.length;ne<be;ne++){const Ce=J[ne].substituteConstants();if(J[ne]!==Ce&&$===null){$=[];for(let ae=0;ae<ne;ae++)$[ae]=J[ae]}$!==null&&($[ne]=Ce)}return $===null?J:$}class Y{static create($,ne,be){return Y._normalizeArr($,ne,be)}constructor($,ne){this.expr=$,this.negated=ne,this.type=6}cmp($){if($.type!==this.type)return this.type-$.type;if(this.expr.length<$.expr.length)return-1;if(this.expr.length>$.expr.length)return 1;for(let ne=0,be=this.expr.length;ne<be;ne++){const Ce=l(this.expr[ne],$.expr[ne]);if(Ce!==0)return Ce}return 0}equals($){if($.type===this.type){if(this.expr.length!==$.expr.length)return!1;for(let ne=0,be=this.expr.length;ne<be;ne++)if(!this.expr[ne].equals($.expr[ne]))return!1;return!0}return!1}substituteConstants(){const $=W(this.expr);return $===this.expr?this:Y.create($,this.negated,!1)}evaluate($){for(let ne=0,be=this.expr.length;ne<be;ne++)if(!this.expr[ne].evaluate($))return!1;return!0}static _normalizeArr($,ne,be){const Ce=[];let ae=!1;for(const ce of $)if(ce){if(ce.type===1){ae=!0;continue}if(ce.type===0)return u.INSTANCE;if(ce.type===6){Ce.push(...ce.expr);continue}Ce.push(ce)}if(Ce.length===0&&ae)return d.INSTANCE;if(Ce.length!==0){if(Ce.length===1)return Ce[0];Ce.sort(l);for(let ce=1;ce<Ce.length;ce++)Ce[ce-1].equals(Ce[ce])&&(Ce.splice(ce,1),ce--);if(Ce.length===1)return Ce[0];for(;Ce.length>1;){const ce=Ce[Ce.length-1];if(ce.type!==9)break;Ce.pop();const se=Ce.pop(),j=Ce.length===0,ie=Z.create(ce.expr.map(ue=>Y.create([ue,se],null,be)),null,j);ie&&(Ce.push(ie),Ce.sort(l))}if(Ce.length===1)return Ce[0];if(be){for(let ce=0;ce<Ce.length;ce++)for(let se=ce+1;se<Ce.length;se++)if(Ce[ce].negate().equals(Ce[se]))return u.INSTANCE;if(Ce.length===1)return Ce[0]}return new Y(Ce,ne)}}serialize(){return this.expr.map($=>$.serialize()).join(" && ")}keys(){const $=[];for(const ne of this.expr)$.push(...ne.keys());return $}map($){return new Y(this.expr.map(ne=>ne.map($)),null)}negate(){if(!this.negated){const $=[];for(const ne of this.expr)$.push(ne.negate());this.negated=Z.create($,this,!0)}return this.negated}}e.ContextKeyAndExpr=Y;class Z{static create($,ne,be){return Z._normalizeArr($,ne,be)}constructor($,ne){this.expr=$,this.negated=ne,this.type=9}cmp($){if($.type!==this.type)return this.type-$.type;if(this.expr.length<$.expr.length)return-1;if(this.expr.length>$.expr.length)return 1;for(let ne=0,be=this.expr.length;ne<be;ne++){const Ce=l(this.expr[ne],$.expr[ne]);if(Ce!==0)return Ce}return 0}equals($){if($.type===this.type){if(this.expr.length!==$.expr.length)return!1;for(let ne=0,be=this.expr.length;ne<be;ne++)if(!this.expr[ne].equals($.expr[ne]))return!1;return!0}return!1}substituteConstants(){const $=W(this.expr);return $===this.expr?this:Z.create($,this.negated,!1)}evaluate($){for(let ne=0,be=this.expr.length;ne<be;ne++)if(this.expr[ne].evaluate($))return!0;return!1}static _normalizeArr($,ne,be){let Ce=[],ae=!1;if($){for(let ce=0,se=$.length;ce<se;ce++){const j=$[ce];if(j){if(j.type===0){ae=!0;continue}if(j.type===1)return d.INSTANCE;if(j.type===9){Ce=Ce.concat(j.expr);continue}Ce.push(j)}}if(Ce.length===0&&ae)return u.INSTANCE;Ce.sort(l)}if(Ce.length!==0){if(Ce.length===1)return Ce[0];for(let ce=1;ce<Ce.length;ce++)Ce[ce-1].equals(Ce[ce])&&(Ce.splice(ce,1),ce--);if(Ce.length===1)return Ce[0];if(be){for(let ce=0;ce<Ce.length;ce++)for(let se=ce+1;se<Ce.length;se++)if(Ce[ce].negate().equals(Ce[se]))return d.INSTANCE;if(Ce.length===1)return Ce[0]}return new Z(Ce,ne)}}serialize(){return this.expr.map($=>$.serialize()).join(" || ")}keys(){const $=[];for(const ne of this.expr)$.push(...ne.keys());return $}map($){return new Z(this.expr.map(ne=>ne.map($)),null)}negate(){if(!this.negated){const $=[];for(const ne of this.expr)$.push(ne.negate());for(;$.length>1;){const ne=$.shift(),be=$.shift(),Ce=[];for(const ae of Ie(ne))for(const ce of Ie(be))Ce.push(Y.create([ae,ce],null,!1));$.unshift(Z.create(Ce,null,!1))}this.negated=Z.create($,this,!0)}return this.negated}}e.ContextKeyOrExpr=Z;class G extends g{static{this._info=[]}static all(){return G._info.values()}constructor($,ne,be){super($,null),this._defaultValue=ne,typeof be=="object"?G._info.push({...be,key:$}):be!==!0&&G._info.push({key:$,description:be,type:ne!=null?typeof ne:void 0})}bindTo($){return $.createKey(this.key,this._defaultValue)}getValue($){return $.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo($){return D.create(this.key,$)}notEqualsTo($){return y.create(this.key,$)}}e.RawContextKey=G,e.IContextKeyService=(0,T.createDecorator)("contextKeyService");function Q(J,$){return J<$?-1:J>$?1:0}function re(J,$,ne,be){return J<ne?-1:J>ne?1:$<be?-1:$>be?1:0}function te(J,$){if(J.type===0||$.type===1)return!0;if(J.type===9)return $.type===9?ve(J.expr,$.expr):!1;if($.type===9){for(const ne of $.expr)if(te(J,ne))return!0;return!1}if(J.type===6){if($.type===6)return ve($.expr,J.expr);for(const ne of J.expr)if(te(ne,$))return!0;return!1}return J.equals($)}function ve(J,$){let ne=0,be=0;for(;ne<J.length&&be<$.length;){const Ce=J[ne].cmp($[be]);if(Ce<0)return!1;Ce===0&&ne++,be++}return ne===J.length}function Ie(J){return J.type===9?J.expr:[J]}}),define(ye[248],_e([1,0,23,40,206,5,103,11,24]),function(de,e,c,O,L,T,R,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.getFileNamesMessage=C,e.massageMessageBoxOptions=S,e.IDialogService=(0,T.createDecorator)("dialogService");var w;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(w||(w={}));class A{getConfirmationButtons(m){return this.getButtons(m,w.Confirmation)}getPromptButtons(m){return this.getButtons(m,w.Prompt)}getInputButtons(m){return this.getButtons(m,w.Input)}getButtons(m,o){const n=[];switch(o){case w.Confirmation:{const i=m;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(1,null));break}case w.Prompt:{const i=m;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(r=>r.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,L.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,L.localize)(3,null))),n.length===0&&n.push((0,L.localize)(4,null));break}case w.Input:{const i=m;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(6,null));break}}return n}getDialogType(m){if(typeof m=="string")return m;if(typeof m=="number")return m===O.default.Info?"info":m===O.default.Error?"error":m===O.default.Warning?"warning":"none"}getPromptResult(m,o,n){const i=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&i.push(m.cancelButton);let r=i[o]?.run({checkboxChecked:n});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:n}}}e.AbstractDialogHandler=A,e.IFileDialogService=(0,T.createDecorator)("fileDialogService");var I;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const v=10;function C(a){const m=[];return m.push(...a.slice(0,v).map(o=>typeof o=="string"?o:(0,c.basename)(o))),a.length>v&&(a.length-v===1?m.push((0,L.localize)(7,null)):m.push((0,L.localize)(8,null,a.length-v))),m.push(""),m.join(`
`)}function S(a,m){const o=(0,p.deepClone)(a);let n=(o.buttons??[]).map(t=>(0,R.mnemonicButtonLabel)(t)),i=(a.buttons||[]).map((t,f)=>f),r=0,s=o.cancelId??n.length-1;if(n.length>1){const t=typeof s=="number"?n[s]:void 0;if(b.isLinux||b.isMacintosh){if(typeof t=="string"&&n.length>1&&s!==1){n.splice(s,1),n.splice(1,0,t);const f=i[s];i.splice(s,1),i.splice(1,0,f),s=1}b.isLinux&&n.length>1&&(n=n.reverse(),i=i.reverse(),r=n.length-1,typeof t=="string"&&(s=r-1))}else if(b.isWindows&&typeof t=="string"&&n.length>1&&s!==n.length-1){n.splice(s,1),n.push(t);const f=i[s];i.splice(s,1),i.push(f),s=n.length-1}}return o.buttons=n,o.defaultId=r,o.cancelId=s,o.noLink=!0,o.title=o.title||m.nameLong,{options:o,buttonIndeces:i}}}),define(ye[136],_e([1,0,5]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[137],_e([1,0,207,5]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=L,e.toTargetPlatform=T,e.getTargetPlatform=R,e.isNotWebExtensionInWebTargetPlatform=b,e.isTargetPlatformCompatible=p,e.isIExtensionIdentifier=w,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function L(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"linux-riscv64":return"Linux RISC-V 64";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function T(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"linux-riscv64":return"linux-riscv64";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function R(i,r){switch(i){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":r==="ppc64le"?"linux-ppc64le":r==="riscv64"?"linux-riscv64":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(i,r){return r==="web"&&!i.includes("web")}function p(i,r,s){return b(r,s)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===s}function w(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var A;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var I;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var v;(function(i){i.Install="install",i.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var C;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(C||(e.InstallOperation=C={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var S;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var a;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(a||(e.ExtensionSignaturetErrorCode=a={}));class m extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.ExtensionManagementError=m;var o;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class n extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.ExtensionGalleryError=n,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,c.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,c.localize2)(1,"Preferences")}),define(ye[249],_e([1,0,5]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,c.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ye[250],_e([1,0,52,54,15,17,11,102,31,105,209,249]),function(de,e,c,O,L,T,R,b,p,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const v=A.localize(0,null);class C{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends C{static{this.CMD="cmd.exe"}openTerminal(s,t){return this.spawnTerminal(c,s,w.getWindowsShell(),t)}spawnTerminal(s,t,f,h){const l=t.windowsExec||S.getDefaultTerminalWindows();h&&h[1]===":"&&(h=h[0].toUpperCase()+h.substr(1));const u=T.basename(l,".exe").toLowerCase();if(u==="cmder")return s.spawn(l,h?[h]:void 0),Promise.resolve(void 0);const d=["/c","start","/wait"];return l.indexOf(" ")>=0&&d.push('""'),d.push(l),u==="wt"&&d.push("-d ."),new Promise((g,D)=>{const E=o(process),_=s.spawn(f,d,{cwd:h,env:E,detached:!0});_.on("error",D),_.on("exit",()=>g())})}async runInTerminal(s,t,f,h,l){const u="windowsExec"in l&&l.windowsExec?l.windowsExec:S.getDefaultTerminalWindows(),d=await S.getWtExePath();return new Promise((g,D)=>{const E=`"${t} - ${v}"`,_=`"${f.join('" "')}" & pause`,y=Object.assign({},o(process),h);Object.keys(y).filter(F=>y[F]===null).forEach(F=>delete y[F]);const P={cwd:t,env:y,windowsVerbatimArguments:!0};let k,z;T.basename(u,".exe")==="wt"?(k=u,z=["-d",".",S.CMD,"/c",_]):d?(k=d,z=["-d",".",u,"/c",_]):(k=S.CMD,z=["/c","start",E,"/wait",u,"/c",`"${_}"`]),c.spawn(k,z,P).on("error",F=>{D(n(F))}),g(void 0)})}static getDefaultTerminalWindows(){if(!S._DEFAULT_TERMINAL_WINDOWS){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return S._DEFAULT_TERMINAL_WINDOWS}static async getWtExePath(){try{const s=await w.win32.findExecutable("wt");return await p.Promises.exists(s)?s:void 0}catch{return}}}e.WindowsExternalTerminalService=S,Ge([O.memoize],S,"getWtExePath",null);class a extends C{static{this.OSASCRIPT="/usr/bin/osascript"}openTerminal(s,t){return this.spawnTerminal(c,s,t)}runInTerminal(s,t,f,h,l){const u=l.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((d,g)=>{if(u===I.DEFAULT_TERMINAL_OSX||u==="iTerm.app"){const D=u===I.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",_=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",s||v,"-w",t];for(const k of f)_.push("-a"),_.push(k);if(h){const k=Object.assign({},o(process),h);for(const z in k){const x=k[z];x===null?(_.push("-u"),_.push(z)):(_.push("-e"),_.push(`${z}=${x}`))}}let y="";const P=c.spawn(a.OSASCRIPT,_);P.on("error",k=>{g(n(k))}),P.stderr.on("data",k=>{y+=k.toString()}),P.on("exit",k=>{if(k===0)d(void 0);else if(y){const z=y.split(`
`,1);g(new Error(z[0]))}else g(new Error(A.localize(1,null,D,k)))})}else g(new Error(A.localize(2,null,u)))})}spawnTerminal(s,t,f){const h=t.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((l,u)=>{const d=["-a",h];f&&d.push(f);const g=o(process),D=s.spawn("/usr/bin/open",d,{cwd:f,env:g});D.on("error",u),D.on("exit",()=>l())})}}e.MacExternalTerminalService=a;class m extends C{static{this.WAIT_MESSAGE=A.localize(3,null)}openTerminal(s,t){return this.spawnTerminal(c,s,t)}runInTerminal(s,t,f,h,l){const u=l.linuxExec?Promise.resolve(l.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((d,g)=>{const D=[];u.then(E=>{E.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const _=`${i(f)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;D.push(`''${_}''`);const y=Object.assign({},o(process),h);Object.keys(y).filter(x=>y[x]===null).forEach(x=>delete y[x]);const P={cwd:t,env:y};let k="";const z=c.spawn(E,D,P);z.on("error",x=>{g(n(x))}),z.stderr.on("data",x=>{k+=x.toString()}),z.on("exit",x=>{if(x===0)d(void 0);else if(k){const F=k.split(`
`,1);g(new Error(F[0]))}else g(new Error(A.localize(4,null,E,x)))})})})}static async getDefaultTerminalLinuxReady(){if(!m._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)m._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const s=await p.Promises.exists("/etc/debian_version");m._DEFAULT_TERMINAL_LINUX_READY=new Promise(t=>{s?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(s,t,f){const h=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((l,u)=>{h.then(d=>{const g=o(process),D=s.spawn(d,[],{cwd:f,env:g});D.on("error",u),D.on("exit",()=>l())})})}}e.LinuxExternalTerminalService=m;function o(r){const s={...r.env};return(0,b.sanitizeProcessEnvironment)(s),s}function n(r){return"errno"in r&&r.errno==="ENOENT"&&"path"in r&&typeof r.path=="string"?new Error(A.localize(5,null,r.path)):r}function i(r){let s="";for(const t of r)t.indexOf(" ")>=0?s+='"'+t+'"':s+=t,s+=" ";return s}}),define(ye[32],_e([1,0,77,17,14,18,2,210,5,11,15,46]),function(de,e,c,O,L,T,R,b,p,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=v,e.isFileSystemWatcher=a,e.hasReadWriteCapability=o,e.hasFileFolderCopyCapability=n,e.hasFileCloneCapability=i,e.hasOpenReadWriteCloseCapability=r,e.hasFileReadStreamCapability=s,e.hasFileAtomicReadCapability=t,e.hasFileAtomicWriteCapability=f,e.hasFileAtomicDeleteCapability=h,e.hasReadonlyCapability=l,e.createFileSystemProviderError=g,e.ensureFileSystemProviderError=D,e.markAsFileSystemProviderError=E,e.toFileSystemProviderErrorCode=_,e.toFileOperationResult=y,e.isParent=F,e.etag=Z,e.whenProviderRegistered=G,e.getLargeFileConfirmationLimit=re,e.IFileService=(0,p.createDecorator)("fileService");function v(te){return te.create===!0}var C;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(C||(e.FileType=C={}));var S;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function a(te){const ve=te;return!!ve&&typeof ve.onDidChange=="function"}var m;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function o(te){return!!(te.capabilities&2)}function n(te){return!!(te.capabilities&8)}function i(te){return!!(te.capabilities&131072)}function r(te){return!!(te.capabilities&4)}function s(te){return!!(te.capabilities&16)}function t(te){return o(te)?!!(te.capabilities&16384):!1}function f(te){return o(te)?!!(te.capabilities&32768):!1}function h(te){return!!(te.capabilities&65536)}function l(te){return!!(te.capabilities&2048)}var u;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class d extends Error{static create(ve,Ie){const J=new d(ve.toString(),Ie);return E(J,Ie),J}constructor(ve,Ie){super(ve),this.code=Ie}}e.FileSystemProviderError=d;function g(te,ve){return d.create(te,ve)}function D(te){return te||g((0,b.localize)(0,null),u.Unknown)}function E(te,ve){return te.name=ve?`${ve} (FileSystemError)`:"FileSystemError",te}function _(te){if(!te)return u.Unknown;if(te instanceof d)return te.code;const ve=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!ve)return u.Unknown;switch(ve[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}function y(te){if(te instanceof N)return te.fileOperationResult;switch(_(te)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 9;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileTooLarge:return 7;default:return 10}}var P;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class k{constructor(ve,Ie,J){this.resource=ve,this.operation=Ie,this.target=J}isOperation(ve){return this.operation===ve}}e.FileOperationEvent=k;var z;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class x{static{this.MIXED_CORRELATION=null}constructor(ve,Ie){this.ignorePathCasing=Ie,this.correlationId=void 0,this.added=new I.Lazy(()=>{const J=c.TernarySearchTree.forUris(()=>this.ignorePathCasing);return J.fill(this.rawAdded.map($=>[$,!0])),J}),this.updated=new I.Lazy(()=>{const J=c.TernarySearchTree.forUris(()=>this.ignorePathCasing);return J.fill(this.rawUpdated.map($=>[$,!0])),J}),this.deleted=new I.Lazy(()=>{const J=c.TernarySearchTree.forUris(()=>this.ignorePathCasing);return J.fill(this.rawDeleted.map($=>[$,!0])),J}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const J of ve){switch(J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}this.correlationId!==x.MIXED_CORRELATION&&(typeof J.cId=="number"?this.correlationId===void 0?this.correlationId=J.cId:this.correlationId!==J.cId&&(this.correlationId=x.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=x.MIXED_CORRELATION))}}contains(ve,...Ie){return this.doContains(ve,{includeChildren:!1},...Ie)}affects(ve,...Ie){return this.doContains(ve,{includeChildren:!0},...Ie)}doContains(ve,Ie,...J){if(!ve)return!1;const $=J.length>0;return!!((!$||J.includes(1))&&(this.added.value.get(ve)||Ie.includeChildren&&this.added.value.findSuperstr(ve))||(!$||J.includes(0))&&(this.updated.value.get(ve)||Ie.includeChildren&&this.updated.value.findSuperstr(ve))||(!$||J.includes(2))&&(this.deleted.value.findSubstr(ve)||Ie.includeChildren&&this.deleted.value.findSuperstr(ve)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ve){return this.correlationId===ve}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=x;function F(te,ve,Ie){return!te||!ve||te===ve||ve.length>te.length?!1:(ve.charAt(ve.length-1)!==O.sep&&(ve+=O.sep),Ie?(0,L.startsWithIgnoreCase)(te,ve):te.indexOf(ve)===0)}class N extends Error{constructor(ve,Ie,J){super(ve),this.fileOperationResult=Ie,this.options=J}}e.FileOperationError=N;class M extends N{constructor(ve,Ie,J,$){super(ve,Ie,$),this.fileOperationResult=Ie,this.size=J}}e.TooLargeFileOperationError=M;class B extends N{constructor(ve,Ie,J){super(ve,2,J),this.stat=Ie}}e.NotModifiedSinceFileOperationError=B;var W;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(W||(e.FileOperationResult=W={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var Y;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.ETAG_DISABLED="";function Z(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function G(te,ve){if(!ve.hasProvider(R.URI.from({scheme:te.scheme})))return new Promise(Ie=>{const J=ve.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===te.scheme&&$.added&&(J.dispose(),Ie())})})}class Q{static{this.KB=1024}static{this.MB=Q.KB*Q.KB}static{this.GB=Q.MB*Q.KB}static{this.TB=Q.GB*Q.KB}static formatSize(ve){return(0,T.isNumber)(ve)||(ve=0),ve<Q.KB?(0,b.localize)(1,null,ve.toFixed(0)):ve<Q.MB?(0,b.localize)(2,null,(ve/Q.KB).toFixed(2)):ve<Q.GB?(0,b.localize)(3,null,(ve/Q.MB).toFixed(2)):ve<Q.TB?(0,b.localize)(4,null,(ve/Q.GB).toFixed(2)):(0,b.localize)(5,null,(ve/Q.TB).toFixed(2))}}e.ByteSize=Q;function re(te){const ve=typeof te=="string"||te?.scheme===A.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===A.Schemas.file?1024*Q.MB:ve?10*Q.MB:w.isWeb?50*Q.MB:1024*Q.MB}}),define(ye[251],_e([1,0,21,13,211,32]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=R;async function R(A,I,v,C,S,a){let m;try{await b(A,I,v,C,S,a)}catch(o){m=o}finally{m&&S.errorTransformer&&(m=S.errorTransformer(m)),typeof m<"u"&&v.error(m),v.end()}}async function b(A,I,v,C,S,a){p(a);const m=await A.open(I,{create:!1});try{p(a);let o=0,n=0,i=S&&typeof S.length=="number"?S.length:void 0,r=c.VSBuffer.alloc(Math.min(S.bufferSize,typeof i=="number"?i:S.bufferSize)),s=S&&typeof S.position=="number"?S.position:0,t=0;do n=await A.read(m,s,r.buffer,t,r.byteLength-t),s+=n,t+=n,o+=n,typeof i=="number"&&(i-=n),t===r.byteLength&&(await v.write(C(r)),r=c.VSBuffer.alloc(Math.min(S.bufferSize,typeof i=="number"?i:S.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&p(a)&&w(o,S));if(t>0){let f=t;typeof i=="number"&&(f=Math.min(t,i)),v.write(C(r.slice(0,f)))}}catch(o){throw(0,T.ensureFileSystemProviderError)(o)}finally{await A.close(m)}}function p(A){if(A.isCancellationRequested)throw(0,O.canceled)();return!0}function w(A,I){if(typeof I?.limits?.size=="number"&&A>I.limits.size)throw(0,T.createFileSystemProviderError)((0,L.localize)(0,null),T.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ye[64],_e([1,0,35,3,17,11,2,32]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=p,e.isRecursiveWatchRequest=w,e.reviveFileChanges=C,e.coalesceEvents=S,e.normalizeWatcherPattern=a,e.parseWatcherPatterns=m;function p(n){return typeof n.correlationId=="number"}function w(n){return n.recursive===!0}class A extends O.Disposable{static{this.MAX_RESTARTS=5}constructor(i,r,s,t){super(),this.onFileChanges=i,this.onLogMessage=r,this.verboseLogging=s,this.options=t,this.watcherDisposables=this._register(new O.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const i=new O.DisposableStore;this.watcherDisposables.value=i,this.watcher=this.createWatcher(i),this.watcher.setVerboseLogging(this.verboseLogging),i.add(this.watcher.onDidChangeFile(r=>this.onFileChanges(r))),i.add(this.watcher.onDidLogMessage(r=>this.onLogMessage(r))),i.add(this.watcher.onDidError(r=>this.onError(r)))}onError(i){this.options.restartOnError?this.restartCounter<A.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${i}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${i}`):this.error(i)}restart(i){this.restartCounter++,this.init(),this.watch(i)}async watch(i){this.requests=i,await this.watcher?.watch(i)}async setVerboseLogging(i){this.verboseLogging=i,await this.watcher?.setVerboseLogging(i)}error(i){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${i}`})}trace(i){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${i}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=A;class I extends A{constructor(i,r,s){super(i,r,s,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class v extends A{constructor(i,r,s){super(i,r,s,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=v;function C(n){return n.map(i=>({type:i.type,resource:R.URI.revive(i.resource),cId:i.cId}))}function S(n){const i=new o;for(const r of n)i.processEvent(r);return i.coalesce()}function a(n,i){return typeof i=="string"&&!i.startsWith(c.GLOBSTAR)&&!(0,L.isAbsolute)(i)?{base:n,pattern:i}:i}function m(n,i){const r=[];for(const s of i)r.push((0,c.parse)(a(n,s)));return r}class o{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(i){return T.isLinux?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const r=this.mapPathToChange.get(this.toKey(i));let s=!1;if(r){const t=r.type,f=i.type;r.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?s=!0:t===1&&f===2?(this.mapPathToChange.delete(this.toKey(i)),this.coalesced.delete(r)):t===2&&f===1?r.type=0:t===1&&f===0||(r.type=f)}else s=!0;s&&(this.coalesced.add(i),this.mapPathToChange.set(this.toKey(i),i))}coalesce(){const i=[],r=[];return Array.from(this.coalesced).filter(s=>s.type!==2?(i.push(s),!1):!0).sort((s,t)=>s.resource.fsPath.length-t.resource.fsPath.length).filter(s=>r.some(t=>(0,b.isParent)(s.resource.fsPath,t,!T.isLinux))?!1:(r.push(s.resource.fsPath),!0)).concat(i)}}}),define(ye[252],_e([1,0,51,3,64,4,2]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class b extends O.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new T.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new T.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new O.DisposableMap),this.suspendedWatchRequestPollingInterval=5007,this._register(this.onDidWatchFail(w=>this.handleDidWatchFail(w)))}handleDidWatchFail(w){this.isCorrelated(w)&&this.suspendWatchRequest(w)}isCorrelated(w){return(0,L.isWatchRequestWithCorrelation)(w)}async watch(w){this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const A of w)this.isCorrelated(A)?this.allCorrelatedWatchRequests.set(A.correlationId,A):this.allNonCorrelatedWatchRequests.add(A);for(const[A]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(A)||this.suspendedWatchRequests.deleteAndDispose(A);return this.updateWatchers()}updateWatchers(){return this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(w=>!this.suspendedWatchRequests.has(w.correlationId))])}suspendWatchRequest(w){if(this.suspendedWatchRequests.has(w.correlationId))return;const A=new O.DisposableStore;this.suspendedWatchRequests.set(w.correlationId,A),this.monitorSuspendedWatchRequest(w,A),this.updateWatchers()}resumeWatchRequest(w){this.suspendedWatchRequests.deleteAndDispose(w.correlationId),this.updateWatchers()}monitorSuspendedWatchRequest(w,A){const I=R.URI.file(w.path),v=this;let C=!1;const S=(a,m)=>{if(A.isDisposed)return;const o=this.isPathNotFound(a),n=this.isPathNotFound(m),i=C;if(C=o,!o&&(n||i)){this.trace(`fs.watchFile() detected ${w.path} exists again, resuming watcher (correlationId: ${w.correlationId})`);const r={resource:I,type:1,cId:w.correlationId};v._onDidChangeFile.fire([r]),this.traceEvent(r,w),this.resumeWatchRequest(w)}};this.trace(`starting fs.watchFile() on ${w.path} (correlationId: ${w.correlationId})`);try{(0,c.watchFile)(w.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},S)}catch(a){this.warn(`fs.watchFile() failed with error ${a} on path ${w.path} (correlationId: ${w.correlationId})`)}A.add((0,O.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${w.path} (correlationId: ${w.correlationId})`);try{(0,c.unwatchFile)(w.path,S)}catch(a){this.warn(`fs.unwatchFile() failed with error ${a} on path ${w.path} (correlationId: ${w.correlationId})`)}}))}isPathNotFound(w){return w.ctimeMs===0&&w.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll()}traceEvent(w,A){const I=` >> normalized ${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.resource.fsPath}`;this.trace(typeof A.correlationId=="number"?`${I} (correlationId: ${A.correlationId})`:I)}requestToString(w){return`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?JSON.stringify(w.includes):"<all>"}, correlationId: ${typeof w.correlationId=="number"?w.correlationId:"<none>"})`}}e.BaseWatcher=b}),define(ye[253],_e([1,0,51,8,22,34,3,76,17,11,23,2,104,31,64]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=m;class a extends R.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}constructor(n,i,r,s,t){super(),this.request=n,this.onDidFilesChange=i,this.onDidWatchFail=r,this.onLogMessage=s,this.verboseLogging=t,this.throttledFileChangesEmitter=this._register(new O.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.onDidFilesChange(f))),this.fileChangesAggregator=this._register(new O.RunOnceWorker(f=>this.handleFileChanges(f),a.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new L.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const n=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const i=await C.Promises.stat(n);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.error(n):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${n})`),this.onDidWatchFail?.()}}async normalizePath(n){let i=n.path;try{i=await C.Promises.realpath(n.path),n.path===i&&(i=await(0,v.realcase)(n.path,this.cts.token)??n.path),n.path!==i&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async doWatch(n,i){if(w.isMacintosh&&(0,T.isEqualOrParent)(n,"/Volumes/",!0))return this.error(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const r=new L.CancellationTokenSource(this.cts.token),s=new R.DisposableStore;try{const t=I.URI.file(this.request.path),f=(0,p.basename)(n),h=(0,c.watch)(n);s.add((0,R.toDisposable)(()=>{h.removeAllListeners(),h.close()})),this.trace(`Started watching: '${n}'`);const l=new Set;if(i)try{for(const d of await C.Promises.readdir(n))l.add(d)}catch(d){this.error(d)}const u=new Map;s.add((0,R.toDisposable)(()=>{for(const[,d]of u)d.dispose();u.clear()})),h.on("error",(d,g)=>{this.error(`Failed to watch ${n} for changes using fs.watch() (${d}, ${g})`),this.onDidWatchFail?.()}),h.on("change",(d,g)=>{if(r.token.isCancellationRequested)return;this.trace(`[raw] ["${d}"] ${g}`);let D="";if(g&&(D=g.toString(),w.isMacintosh&&(D=(0,b.normalizeNFC)(D))),!(!D||d!=="change"&&d!=="rename"))if(i)if(d==="rename"){u.get(D)?.dispose();const E=setTimeout(async()=>{if(u.delete(D),D===f&&!await C.Promises.exists(n)){this.onWatchedPathDeleted(t);return}const _=await this.existsChildStrictCase((0,p.join)(n,D));if(r.token.isCancellationRequested)return;let y;_?l.has(D)?y=0:(y=1,l.add(D)):(l.delete(D),y=2),this.onFileChange({resource:(0,A.joinPath)(t,D),type:y,cId:this.request.correlationId})},a.FILE_DELETE_HANDLER_DELAY);u.set(D,(0,R.toDisposable)(()=>clearTimeout(E)))}else{let E;l.has(D)?E=0:(E=1,l.add(D)),this.onFileChange({resource:(0,A.joinPath)(t,D),type:E,cId:this.request.correlationId})}else if(d==="rename"||D!==f){const E=setTimeout(async()=>{const _=await C.Promises.exists(n);r.token.isCancellationRequested||(_?(this.onFileChange({resource:t,type:0,cId:this.request.correlationId},!0),s.add(await this.doWatch(n,!1))):this.onWatchedPathDeleted(t))},a.FILE_DELETE_HANDLER_DELAY);s.clear(),s.add((0,R.toDisposable)(()=>clearTimeout(E)))}else this.onFileChange({resource:t,type:0,cId:this.request.correlationId},!0)})}catch(t){r.token.isCancellationRequested||this.error(`Failed to watch ${n} for changes using fs.watch() (${t.toString()})`),this.onDidWatchFail?.()}return(0,R.toDisposable)(()=>{r.dispose(!0),s.dispose()})}onWatchedPathDeleted(n){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:n,type:2,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.onDidWatchFail?.()}onFileChange(n,i=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.excludes.some(r=>r(n.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.includes&&this.includes.length>0&&!this.includes.some(r=>r(n.resource.fsPath))?this.verboseLogging&&this.trace(` >> ignored (not included) ${n.resource.fsPath}`):this.fileChangesAggregator.work(n))}handleFileChanges(n){const i=(0,S.coalesceEvents)(n);if(i.length>0){if(this.verboseLogging)for(const s of i)this.trace(` >> normalized ${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.throttledFileChangesEmitter.work(i)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async existsChildStrictCase(n){if(w.isLinux)return C.Promises.exists(n);try{const i=(0,p.basename)(n);return(await C.Promises.readdir((0,p.dirname)(n))).some(s=>s===i)}catch(i){return this.trace(i),!1}}setVerboseLogging(n){this.verboseLogging=n}error(n){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}warn(n){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}trace(n){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=a;async function m(o,n,i,r,s=512){const t=await C.Promises.open(o,"r"),f=Buffer.allocUnsafe(s),h=new L.CancellationTokenSource(r);let l,u=!1;const d={path:o,excludes:[],recursive:!1},g=new a(d,D=>{(async()=>{for(const{type:E}of D)if(E===0){if(u)return;u=!0;try{for(;!h.token.isCancellationRequested;){const{bytesRead:_}=await C.Promises.read(t,f,0,s,null);if(!_||h.token.isCancellationRequested)break;n(f.slice(0,_))}}catch(_){l=new Error(_),h.dispose(!0)}finally{u=!1}}})()});return await g.ready,i(),new Promise((D,E)=>{h.token.onCancellationRequested(async()=>{g.dispose();try{await C.Promises.close(t)}catch(_){l=new Error(_)}l?E(l):D()})})}}),define(ye[254],_e([1,0,4,35,252,11,253,34]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class p extends L.BaseWatcher{constructor(){super(...arguments),this.onDidError=c.Event.None,this.watchers=new Set,this.verboseLogging=!1}async doWatch(A){A=this.removeDuplicateRequests(A);const I=[],v=new Set(Array.from(this.watchers));for(const C of A){const S=this.findWatcher(C);S&&(0,O.patternsEquals)(S.request.excludes,C.excludes)&&(0,O.patternsEquals)(S.request.includes,C.includes)?v.delete(S):I.push(C)}I.length&&this.trace(`Request to start watching: ${I.map(C=>this.requestToString(C)).join(",")}`),v.size&&this.trace(`Request to stop watching: ${Array.from(v).map(C=>this.requestToString(C.request)).join(",")}`);for(const C of v)this.stopWatching(C);for(const C of I)this.startWatching(C)}findWatcher(A){for(const I of this.watchers)if(typeof A.correlationId=="number"||typeof I.request.correlationId=="number"){if(I.request.correlationId===A.correlationId)return I}else if((0,b.isEqual)(I.request.path,A.path,!T.isLinux))return I}startWatching(A){const I=new R.NodeJSFileWatcherLibrary(A,C=>this._onDidChangeFile.fire(C),()=>this._onDidWatchFail.fire(A),C=>this._onDidLogMessage.fire(C),this.verboseLogging),v={request:A,instance:I};this.watchers.add(v)}async stop(){await super.stop();for(const A of this.watchers)this.stopWatching(A)}stopWatching(A){this.trace("stopping file watcher",A),this.watchers.delete(A),A.instance.dispose()}removeDuplicateRequests(A){const I=new Map;for(const v of A){const C=T.isLinux?v.path:v.path.toLowerCase();let S=I.get(v.correlationId);S||(S=new Map,I.set(v.correlationId,S)),S.has(C)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(v)}`),S.set(C,v)}return Array.from(I.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(A){this.verboseLogging=A;for(const I of this.watchers)I.instance.setVerboseLogging(A)}trace(A,I){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(A,I)})}warn(A){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(A)})}toMessage(A,I){return I?`[File Watcher (node.js)] ${A} (${this.requestToString(I.request)})`:`[File Watcher (node.js)] ${A}`}}e.NodeJSWatcher=p}),define(ye[255],_e([1,0,64,254]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends c.AbstractNonRecursiveWatcherClient{constructor(R,b,p){super(R,b,p),this.init()}createWatcher(R){return R.add(new O.NodeJSWatcher)}}e.NodeJSWatcherClient=L}),define(ye[256],_e([1,0,15,81,194,64]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class R extends T.AbstractUniversalWatcherClient{constructor(p,w,A){super(p,w,A),this.init()}createWatcher(p){const w=p.add(new L.Client(c.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(w.onDidProcessExit(({code:A,signal:I})=>this.onError(`terminated by itself with code ${A}, signal: ${I}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(w.getChannel("watcher")))}}e.UniversalWatcherClient=R}),define(ye[107],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...L){this._entries=new Map;for(const[T,R]of L)this.set(T,R)}set(L,T){const R=this._entries.get(L);return this._entries.set(L,T),R}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=c}),define(ye[257],_e([1,0,8,13,3,106,247,5,107,75]),function(de,e,c,O,L,T,R,b,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const A=!1;class I extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class v{constructor(m=new p.ServiceCollection,o=!1,n,i=A){this._services=m,this._strict=o,this._parent=n,this._enableTracing=i,this._activeInstantiations=new Set,this._services.set(b.IInstantiationService,this),this._globalGraph=i?n?._globalGraph??new R.Graph(r=>r):void 0}createChild(m){return new v(m,this._strict,this,this._enableTracing)}invokeFunction(m,...o){const n=S.traceInvocation(this._enableTracing,m);let i=!1;try{return m({get:s=>{if(i)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(s,n);if(!t)throw new Error(`[invokeFunction] unknown service '${s}'`);return t}},...o)}finally{i=!0,n.stop()}}createInstance(m,...o){let n,i;return m instanceof T.SyncDescriptor?(n=S.traceCreation(this._enableTracing,m.ctor),i=this._createInstance(m.ctor,m.staticArguments.concat(o),n)):(n=S.traceCreation(this._enableTracing,m),i=this._createInstance(m,o,n)),n.stop(),i}_createInstance(m,o=[],n){const i=b._util.getServiceDependencies(m).sort((t,f)=>t.index-f.index),r=[];for(const t of i){const f=this._getOrCreateServiceInstance(t.id,n);f||this._throwIfStrict(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(f)}const s=i.length>0?i[0].index:o.length;if(o.length!==s){console.trace(`[createInstance] First service dependency of ${m.name} at position ${s+1} conflicts with ${o.length} static arguments`);const t=s-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,s)}return Reflect.construct(m,o.concat(r))}_setServiceInstance(m,o){if(this._services.get(m)instanceof T.SyncDescriptor)this._services.set(m,o);else if(this._parent)this._parent._setServiceInstance(m,o);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(m){const o=this._services.get(m);return!o&&this._parent?this._parent._getServiceInstanceOrDescriptor(m):o}_getOrCreateServiceInstance(m,o){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(m));const n=this._getServiceInstanceOrDescriptor(m);return n instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(m,n,o.branch(m,!0)):(o.branch(m,!1),n)}_safeCreateAndCacheServiceInstance(m,o,n){if(this._activeInstantiations.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this._activeInstantiations.add(m);try{return this._createAndCacheServiceInstance(m,o,n)}finally{this._activeInstantiations.delete(m)}}_createAndCacheServiceInstance(m,o,n){const i=new R.Graph(t=>t.id.toString());let r=0;const s=[{id:m,desc:o,_trace:n}];for(;s.length;){const t=s.pop();if(i.lookupOrInsertNode(t),r++>1e3)throw new I(i);for(const f of b._util.getServiceDependencies(t.desc.ctor)){const h=this._getServiceInstanceOrDescriptor(f.id);if(h||this._throwIfStrict(`[createInstance] ${m} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),h instanceof T.SyncDescriptor){const l={id:f.id,desc:h,_trace:t._trace.branch(f.id,!0)};i.insertEdge(t,l),s.push(l)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new I(i);break}for(const{data:f}of t){if(this._getServiceInstanceOrDescriptor(f.id)instanceof T.SyncDescriptor){const l=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,l)}i.removeNode(f)}}return this._getServiceInstanceOrDescriptor(m)}_createServiceInstanceWithOwner(m,o,n=[],i,r){if(this._services.get(m)instanceof T.SyncDescriptor)return this._createServiceInstance(m,o,n,i,r);if(this._parent)return this._parent._createServiceInstanceWithOwner(m,o,n,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}_createServiceInstance(m,o,n=[],i,r){if(i){const s=new v(void 0,this._strict,this,this._enableTracing);s._globalGraphImplicitDependency=String(m);const t=new Map,f=new c.GlobalIdleValue(()=>{const h=s._createInstance(o,n,r);for(const[l,u]of t){const d=h[l];if(typeof d=="function")for(const g of u)g.disposable=d.apply(h,g.listener)}return t.clear(),h});return new Proxy(Object.create(null),{get(h,l){if(!f.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let g=t.get(l);return g||(g=new w.LinkedList,t.set(l,g)),(E,_,y)=>{if(f.isInitialized)return f.value[l](E,_,y);{const P={listener:[E,_,y],disposable:void 0},k=g.push(P);return(0,L.toDisposable)(()=>{k(),P.disposable?.dispose()})}}}if(l in h)return h[l];const u=f.value;let d=u[l];return typeof d!="function"||(d=d.bind(u),h[l]=d),d},set(h,l,u){return f.value[l]=u,!0},getPrototypeOf(h){return o.prototype}})}else return this._createInstance(o,n,r)}_throwIfStrict(m,o){if(o&&console.warn(m),this._strict)throw new Error(m)}}e.InstantiationService=v;var C;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(C||(C={}));class S{static{this.all=new Set}static{this._None=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,o){return m?new S(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S._None}static traceCreation(m,o){return m?new S(1,o.name):S._None}static{this._totals=0}constructor(m,o){this.type=m,this.name=o,this._start=Date.now(),this._dep=[]}branch(m,o){const n=new S(3,m.toString());return this._dep.push([m,o,n]),n}stop(){const m=Date.now()-this._start;S._totals+=m;let o=!1;function n(r,s){const t=[],f=new Array(r+1).join("	");for(const[h,l,u]of s._dep)if(l&&u){o=!0,t.push(`${f}CREATES -> ${h}`);const d=n(r+1,u);d&&t.push(d)}else t.push(`${f}uses -> ${h}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(m>2||o)&&S.all.add(i.join(`
`))}}e.Trace=S}),define(ye[12],_e([1,0,213,47,4,55,3,27,11,23,18,2,41,5]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=a,e.log=o,e.getLogLevel=g,e.LogLevelToString=D,e.LogLevelToLocalizedString=E,e.parseLogLevel=_,e.ILogService=(0,C.createDecorator)("logService"),e.ILoggerService=(0,C.createDecorator)("loggerService");function S(){return new Date().toISOString()}function a(y){return(0,A.isNumber)(y)}var m;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(m||(e.LogLevel=m={})),e.DEFAULT_LOG_LEVEL=m.Info;function o(y,P,k){switch(P){case m.Trace:y.trace(k);break;case m.Debug:y.debug(k);break;case m.Info:y.info(k);break;case m.Warning:y.warn(k);break;case m.Error:y.error(k);break;case m.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function n(y,P=!1){let k="";for(let z=0;z<y.length;z++){let x=y[z];if(x instanceof Error&&(x=(0,O.toErrorMessage)(x,P)),typeof x=="object")try{x=JSON.stringify(x)}catch{}k+=(z>0?" ":"")+x}return k}class i extends R.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(P){this.level!==P&&(this.level=P,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(P){return this.level!==m.Off&&this.level<=P}}e.AbstractLogger=i;class r extends i{constructor(P){super(),this.logAlways=P}checkLogLevel(P){return this.logAlways||super.checkLogLevel(P)}trace(P,...k){this.checkLogLevel(m.Trace)&&this.log(m.Trace,n([P,...k],!0))}debug(P,...k){this.checkLogLevel(m.Debug)&&this.log(m.Debug,n([P,...k]))}info(P,...k){this.checkLogLevel(m.Info)&&this.log(m.Info,n([P,...k]))}warn(P,...k){this.checkLogLevel(m.Warning)&&this.log(m.Warning,n([P,...k]))}error(P,...k){if(this.checkLogLevel(m.Error))if(P instanceof Error){const z=Array.prototype.slice.call(arguments);z[0]=P.stack,this.log(m.Error,n(z))}else this.log(m.Error,n([P,...k]))}flush(){}}e.AbstractMessageLogger=r;class s extends i{constructor(P=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(P),this.useColors=!p.isWindows}trace(P,...k){this.checkLogLevel(m.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,P,...k):console.log(`[main ${S()}]`,P,...k))}debug(P,...k){this.checkLogLevel(m.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,P,...k):console.log(`[main ${S()}]`,P,...k))}info(P,...k){this.checkLogLevel(m.Info)&&(this.useColors?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,P,...k):console.log(`[main ${S()}]`,P,...k))}warn(P,...k){this.checkLogLevel(m.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,P,...k):console.warn(`[main ${S()}]`,P,...k))}error(P,...k){this.checkLogLevel(m.Error)&&(this.useColors?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,P,...k):console.error(`[main ${S()}]`,P,...k))}flush(){}}e.ConsoleMainLogger=s;class t extends i{constructor(P=e.DEFAULT_LOG_LEVEL,k=!0){super(),this.useColors=k,this.setLevel(P)}trace(P,...k){this.checkLogLevel(m.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",P,...k):console.log(P,...k))}debug(P,...k){this.checkLogLevel(m.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",P,...k):console.log(P,...k))}info(P,...k){this.checkLogLevel(m.Info)&&(this.useColors?console.log("%c INFO","color: #33f",P,...k):console.log(P,...k))}warn(P,...k){this.checkLogLevel(m.Warning)&&(this.useColors?console.log("%c WARN","color: #993",P,...k):console.log(P,...k))}error(P,...k){this.checkLogLevel(m.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",P,...k):console.error(P,...k))}flush(){}}e.ConsoleLogger=t;class f extends i{constructor(P,k=e.DEFAULT_LOG_LEVEL){super(),this.adapter=P,this.setLevel(k)}trace(P,...k){this.checkLogLevel(m.Trace)&&this.adapter.log(m.Trace,[this.extractMessage(P),...k])}debug(P,...k){this.checkLogLevel(m.Debug)&&this.adapter.log(m.Debug,[this.extractMessage(P),...k])}info(P,...k){this.checkLogLevel(m.Info)&&this.adapter.log(m.Info,[this.extractMessage(P),...k])}warn(P,...k){this.checkLogLevel(m.Warning)&&this.adapter.log(m.Warning,[this.extractMessage(P),...k])}error(P,...k){this.checkLogLevel(m.Error)&&this.adapter.log(m.Error,[this.extractMessage(P),...k])}extractMessage(P){return typeof P=="string"?P:(0,O.toErrorMessage)(P,this.checkLogLevel(m.Trace))}flush(){}}e.AdapterLogger=f;class h extends i{constructor(P){super(),this.loggers=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const k of this.loggers)k.setLevel(P);super.setLevel(P)}trace(P,...k){for(const z of this.loggers)z.trace(P,...k)}debug(P,...k){for(const z of this.loggers)z.debug(P,...k)}info(P,...k){for(const z of this.loggers)z.info(P,...k)}warn(P,...k){for(const z of this.loggers)z.warn(P,...k)}error(P,...k){for(const z of this.loggers)z.error(P,...k)}flush(){for(const P of this.loggers)P.flush()}dispose(){for(const P of this.loggers)P.dispose();super.dispose()}}e.MultiplexLogger=h;class l extends R.Disposable{constructor(P,k,z){if(super(),this.logLevel=P,this.logsHome=k,this._loggers=new b.ResourceMap,this._onDidChangeLoggers=this._register(new L.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new L.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,z)for(const x of z)this._loggers.set(x.resource,{logger:void 0,info:x})}getLoggerEntry(P){return(0,A.isString)(P)?[...this._loggers.values()].find(k=>k.info.id===P):this._loggers.get(P)}getLogger(P){return this.getLoggerEntry(P)?.logger}createLogger(P,k){const z=this.toResource(P),x=(0,A.isString)(P)?P:k?.id??(0,T.hash)(z.toString()).toString(16);let F=this._loggers.get(z)?.logger;const N=k?.logLevel==="always"?m.Trace:k?.logLevel;F||(F=this.doCreateLogger(z,N??this.getLogLevel(z)??this.logLevel,{...k,id:x}));const M={logger:F,info:{resource:z,id:x,logLevel:N,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(M.info),this._loggers.set(z,M),F}toResource(P){return(0,A.isString)(P)?(0,w.joinPath)(this.logsHome,`${P}.log`):P}setLogLevel(P,k){if(I.URI.isUri(P)){const z=P,x=k,F=this._loggers.get(z);F&&x!==F.info.logLevel&&(F.info.logLevel=x===this.logLevel?void 0:x,F.logger?.setLevel(x),this._loggers.set(F.info.resource,F),this._onDidChangeLogLevel.fire([z,x]))}else{this.logLevel=P;for(const[z,x]of this._loggers.entries())this._loggers.get(z)?.info.logLevel===void 0&&x.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(P,k){const z=this.getLoggerEntry(P);z&&k!==!z.info.hidden&&(z.info.hidden=!k,this._loggers.set(z.info.resource,z),this._onDidChangeVisibility.fire([z.info.resource,k]))}getLogLevel(P){let k;return P&&(k=this._loggers.get(P)?.info.logLevel),k??this.logLevel}registerLogger(P){const k=this._loggers.get(P.resource);k?k.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this._loggers.set(P.resource,{info:P,logger:void 0}),this._onDidChangeLoggers.fire({added:[P],removed:[]}))}deregisterLogger(P){const k=this._loggers.get(P);k&&(k.logger&&k.logger.dispose(),this._loggers.delete(P),this._onDidChangeLoggers.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const P of this._loggers.values())yield P.info}getRegisteredLogger(P){return this._loggers.get(P)?.info}dispose(){this._loggers.forEach(P=>P.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=l;class u{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(P){}getLevel(){return m.Info}trace(P,...k){}debug(P,...k){}info(P,...k){}warn(P,...k){}error(P,...k){}critical(P,...k){}dispose(){}flush(){}}e.NullLogger=u;class d extends u{}e.NullLogService=d;function g(y){if(y.verbose)return m.Trace;if(typeof y.logLevel=="string"){const P=_(y.logLevel.toLowerCase());if(P!==void 0)return P}return e.DEFAULT_LOG_LEVEL}function D(y){switch(y){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function E(y){switch(y){case m.Trace:return{original:"Trace",value:c.localize(0,null)};case m.Debug:return{original:"Debug",value:c.localize(1,null)};case m.Info:return{original:"Info",value:c.localize(2,null)};case m.Warning:return{original:"Warning",value:c.localize(3,null)};case m.Error:return{original:"Error",value:c.localize(4,null)};case m.Off:return{original:"Off",value:c.localize(5,null)}}}function _(y){switch(y){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.CONTEXT_LOG_LEVEL=new v.RawContextKey("logLevel",D(m.Info))}),define(ye[258],_e([1,0,19,8,13,4,3,17,64,12]),function(de,e,c,O,L,T,R,b,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class A extends R.Disposable{constructor(v,C){super(),this.logService=v,this.options=C,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new O.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new O.ThrottledDelayer(0))}watch(v,C){return C.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(v,C):this.watchNonRecursive(v,C)}watchUniversal(v,C){const S={path:this.toFilePath(v),excludes:C.excludes,includes:C.includes,recursive:C.recursive,correlationId:C.correlationId},a=(0,c.insert)(this.universalPathsToWatch,S);return this.refreshUniversalWatchers(),(0,R.toDisposable)(()=>{a(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(v=>(0,L.onUnexpectedError)(v))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(C=>this._onDidChangeFile.fire((0,p.reviveFileChanges)(C)),C=>this.onWatcherLogMessage(C),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)})));const v=this.options?.watcher?.recursive?.usePolling;if(v===!0)for(const C of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(C)&&(C.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const C of this.universalPathsToWatch)(0,p.isRecursiveWatchRequest)(C)&&v.includes(C.path)&&(C.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(v,C){const S={path:this.toFilePath(v),excludes:C.excludes,includes:C.includes,recursive:!1,correlationId:C.correlationId},a=(0,c.insert)(this.nonRecursivePathsToWatch,S);return this.refreshNonRecursiveWatchers(),(0,R.toDisposable)(()=>{a(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(v=>(0,L.onUnexpectedError)(v))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(v=>this._onDidChangeFile.fire((0,p.reviveFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(v){v.type==="error"&&this._onDidWatchError.fire(v.message),this.logService[v.type](v.message)}toFilePath(v){return(0,b.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=A}),define(ye[259],_e([1,0,51,397,8,27,21,4,34,3,17,11,23,98,31,212,32,251,258,47,256,255]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n,i,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(c)}catch(f){console.error(`Error enabling graceful-fs: ${(0,i.toErrorMessage)(f)}`)}})();class t extends n.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(h,l){super(h,l),this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new T.ResourceMap(u=>v.extUriBiasedIgnorePathCase.getComparisonKey(u)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(h){try{const{stat:l,symbolicLink:u}=await S.SymlinkSupport.stat(this.toFilePath(h));return{type:this.toType(l,u),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size,permissions:l.mode&128?void 0:m.FilePermission.Locked}}catch(l){throw this.toFileSystemProviderError(l)}}async statIgnoreError(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const l=await S.Promises.readdir(this.toFilePath(h),{withFileTypes:!0}),u=[];return await Promise.all(l.map(async d=>{try{let g;d.isSymbolicLink()?g=(await this.stat((0,v.joinPath)(h,d.name))).type:g=this.toType(d),u.push([d.name,g])}catch(g){this.logService.trace(g)}})),u}catch(l){throw this.toFileSystemProviderError(l)}}toType(h,l){let u;return l?.dangling?u=m.FileType.Unknown:h.isFile()?u=m.FileType.File:h.isDirectory()?u=m.FileType.Directory:u=m.FileType.Unknown,l&&(u|=m.FileType.SymbolicLink),u}async createResourceLock(h){const l=this.toFilePath(h);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${l})`);let u;for(;u=this.resourceLocks.get(h);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${l})`),await u.wait();const d=new L.Barrier;return this.resourceLocks.set(h,d),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${l})`),(0,w.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${l})`),this.resourceLocks.get(h)===d&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${l})`),this.resourceLocks.delete(h)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${l})`),d.open()})}async readFile(h,l){let u;try{l?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(h)})`),u=await this.createResourceLock(h));const d=this.toFilePath(h);return await S.Promises.readFile(d)}catch(d){throw this.toFileSystemProviderError(d)}finally{u?.dispose()}}traceLock(h){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(h)}readFileStream(h,l,u){const d=(0,C.newWriteableStream)(g=>R.VSBuffer.concat(g.map(D=>R.VSBuffer.wrap(D))).buffer);return(0,o.readFileIntoStream)(this,h,d,g=>g.buffer,{...l,bufferSize:256*1024},u),d}async writeFile(h,l,u){return u?.atomic!==!1&&u?.atomic?.postfix&&await this.canWriteFileAtomic(h)?this.doWriteFileAtomic(h,(0,v.joinPath)((0,v.dirname)(h),`${(0,v.basename)(h)}${u.atomic.postfix}`),l,u):this.doWriteFile(h,l,u)}async canWriteFileAtomic(h){try{const l=this.toFilePath(h),{symbolicLink:u}=await S.SymlinkSupport.stat(l);if(u)return!1}catch{}return!0}async doWriteFileAtomic(h,l,u,d){const g=new w.DisposableStore;try{g.add(await this.createResourceLock(h)),g.add(await this.createResourceLock(l)),await this.doWriteFile(l,u,d,!0);try{await this.rename(l,h,{overwrite:!0})}catch(D){try{await this.delete(l,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{g.dispose()}}async doWriteFile(h,l,u,d){let g;try{const D=this.toFilePath(h);if(!u.create||!u.overwrite){if(await S.Promises.exists(D)){if(!u.overwrite)throw(0,m.createFileSystemProviderError)((0,a.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,m.createFileSystemProviderError)((0,a.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(h,{create:!0,unlock:u.unlock},d),await this.write(g,0,l,0,l.byteLength)}catch(D){throw await this.toFileSystemProviderWriteError(h,D)}finally{typeof g=="number"&&await this.close(g)}}static{this.canFlush=!0}static configureFlushOnWrite(h){t.canFlush=h}async open(h,l,u){const d=this.toFilePath(h);let g;(0,m.isFileOpenForWriteOptions)(l)&&!u&&(g=await this.createResourceLock(h));let D;try{if((0,m.isFileOpenForWriteOptions)(l)&&l.unlock)try{const{stat:_}=await S.SymlinkSupport.stat(d);_.mode&128||await S.Promises.chmod(d,_.mode|128)}catch(_){_.code!=="ENOENT"&&this.logService.trace(_)}let E;if((0,m.isFileOpenForWriteOptions)(l)){if(I.isWindows)try{await S.Promises.truncate(d,0),E="r+"}catch(_){_.code!=="ENOENT"&&this.logService.trace(_)}E||(E="w")}else E="r";D=await S.Promises.open(d,E)}catch(E){throw g?.dispose(),(0,m.isFileOpenForWriteOptions)(l)?await this.toFileSystemProviderWriteError(h,E):this.toFileSystemProviderError(E)}if(this.mapHandleToPos.set(D,0),(0,m.isFileOpenForWriteOptions)(l)&&this.writeHandles.set(D,h),g){const E=this.mapHandleToLock.get(D);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${d})`),this.mapHandleToLock.set(D,g),E&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${d})`),E.dispose())}return D}async close(h){const l=this.mapHandleToLock.get(h);try{if(this.mapHandleToPos.delete(h),this.writeHandles.delete(h)&&t.canFlush)try{await S.Promises.fdatasync(h)}catch(u){t.configureFlushOnWrite(!1),this.logService.error(u)}return await S.Promises.close(h)}catch(u){throw this.toFileSystemProviderError(u)}finally{l&&(this.mapHandleToLock.get(h)===l&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.mapHandleToLock.delete(h)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),l.dispose())}}async read(h,l,u,d,g){const D=this.normalizePos(h,l);let E=null;try{E=(await S.Promises.read(h,u,d,g,D)).bytesRead}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(h,D,E)}return E}normalizePos(h,l){return l===this.mapHandleToPos.get(h)?null:l}updatePos(h,l,u){const d=this.mapHandleToPos.get(h);typeof d=="number"&&(typeof l=="number"||(typeof u=="number"?this.mapHandleToPos.set(h,d+u):this.mapHandleToPos.delete(h)))}async write(h,l,u,d,g){return(0,L.retry)(()=>this.doWrite(h,l,u,d,g),100,3)}async doWrite(h,l,u,d,g){const D=this.normalizePos(h,l);let E=null;try{E=(await S.Promises.write(h,u,d,g,D)).bytesWritten}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(h),_)}finally{this.updatePos(h,D,E)}return E}async mkdir(h){try{await S.Promises.mkdir(this.toFilePath(h))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(h,l){try{const u=this.toFilePath(h);if(l.recursive){let d;l?.atomic!==!1&&l.atomic.postfix&&(d=(0,A.join)((0,A.dirname)(u),`${(0,A.basename)(u)}${l.atomic.postfix}`)),await S.Promises.rm(u,S.RimRafMode.MOVE,d)}else try{await S.Promises.unlink(u)}catch(d){if(d.code==="EPERM"||d.code==="EISDIR"){let g=!1;try{const{stat:D,symbolicLink:E}=await S.SymlinkSupport.stat(u);g=D.isDirectory()&&!E}catch{}if(g)await S.Promises.rmdir(u);else throw d}else throw d}}catch(u){throw this.toFileSystemProviderError(u)}}async rename(h,l,u){const d=this.toFilePath(h),g=this.toFilePath(l);if(d!==g)try{await this.validateMoveCopy(h,l,"move",u.overwrite),await S.Promises.rename(d,g)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,a.localize)(2,null,(0,A.basename)(d),(0,A.basename)((0,A.dirname)(g)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(h,l,u){const d=this.toFilePath(h),g=this.toFilePath(l);if(d!==g)try{await this.validateMoveCopy(h,l,"copy",u.overwrite),await S.Promises.copy(d,g,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,a.localize)(3,null,(0,A.basename)(d),(0,A.basename)((0,A.dirname)(g)),D.toString()))),this.toFileSystemProviderError(D)}}async validateMoveCopy(h,l,u,d){const g=this.toFilePath(h),D=this.toFilePath(l);let E=!1;if(!!(this.capabilities&1024)||(E=(0,p.isEqual)(g,D,!0)),E){if(u==="copy")throw(0,m.createFileSystemProviderError)((0,a.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(u==="move")return}const y=await this.statIgnoreError(h);if(!y)throw(0,m.createFileSystemProviderError)((0,a.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const P=await this.statIgnoreError(l);if(P){if(!d)throw(0,m.createFileSystemProviderError)((0,a.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);y.type&m.FileType.File&&P.type&m.FileType.File||await this.delete(l,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,l){return this.doCloneFile(h,l,!1)}async doCloneFile(h,l,u){const d=this.toFilePath(h),g=this.toFilePath(l),D=!!(this.capabilities&1024);if((0,p.isEqual)(d,g,!D))return;const E=new w.DisposableStore;try{E.add(await this.createResourceLock(h)),E.add(await this.createResourceLock(l)),u&&await S.Promises.mkdir((0,A.dirname)(g),{recursive:!0}),await S.Promises.copyFile(d,g)}catch(_){if(_.code==="ENOENT"&&!u)return this.doCloneFile(h,l,!0);throw this.toFileSystemProviderError(_)}finally{E.dispose()}}createUniversalWatcher(h,l,u){return new r.UniversalWatcherClient(d=>h(d),d=>l(d),u)}createNonRecursiveWatcher(h,l,u){return new s.NodeJSWatcherClient(d=>h(d),d=>l(d),u)}toFileSystemProviderError(h){if(h instanceof m.FileSystemProviderError)return h;let l=h,u;switch(h.code){case"ENOENT":u=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":u=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":u=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":u=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":u=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":l=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,u=m.FileSystemProviderErrorCode.Unknown;break;default:u=m.FileSystemProviderErrorCode.Unknown}return(0,m.createFileSystemProviderError)(l,u)}async toFileSystemProviderWriteError(h,l){let u=this.toFileSystemProviderError(l);if(h&&u.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await S.SymlinkSupport.stat(this.toFilePath(h));d.mode&128||(u=(0,m.createFileSystemProviderError)(l,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.logService.trace(d)}return u}}e.DiskFileSystemProvider=t}),define(ye[260],_e([1,0,3,12]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class L extends c.Disposable{constructor(R,b=[]){super(),this.logger=new O.MultiplexLogger([R,...b]),this._register(R.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(R){this.logger.setLevel(R)}getLevel(){return this.logger.getLevel()}trace(R,...b){this.logger.trace(R,...b)}debug(R,...b){this.logger.debug(R,...b)}info(R,...b){this.logger.info(R,...b)}warn(R,...b){this.logger.warn(R,...b)}error(R,...b){this.logger.error(R,...b)}flush(){this.logger.flush()}}e.LogService=L}),define(ye[261],_e([1,0,32,12]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var L;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(L||(L={}));async function T(w,A,I,v,C){try{const S=await new Promise((m,o)=>{de(["@vscode/spdlog"],m,o)});S.setFlushOn(L.Trace);const a=await S.createAsyncRotatingLogger(w,A,I,v);return C?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(S){console.error(S)}return null}function R(w,A,I){switch(A){case O.LogLevel.Trace:w.trace(I);break;case O.LogLevel.Debug:w.debug(I);break;case O.LogLevel.Info:w.info(I);break;case O.LogLevel.Warning:w.warn(I);break;case O.LogLevel.Error:w.error(I);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function b(w,A){switch(A){case O.LogLevel.Trace:w.setLevel(L.Trace);break;case O.LogLevel.Debug:w.setLevel(L.Debug);break;case O.LogLevel.Info:w.setLevel(L.Info);break;case O.LogLevel.Warning:w.setLevel(L.Warning);break;case O.LogLevel.Error:w.setLevel(L.Error);break;case O.LogLevel.Off:w.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class p extends O.AbstractMessageLogger{constructor(A,I,v,C,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(A,I,v,C),this._register(this.onDidChangeLogLevel(a=>{this._logger&&b(this._logger,a)}))}async _createSpdLogLogger(A,I,v,C){const S=v?6:1,a=30/S*c.ByteSize.MB,m=await T(A,I,a,S,C);if(m){this._logger=m,b(this._logger,this.getLevel());for(const{level:o,message:n}of this.buffer)R(this._logger,o,n);this.buffer=[]}}log(A,I){this._logger?R(this._logger,A,I):this.getLevel()<=A&&this.buffer.push({level:A,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=p}),define(ye[138],_e([1,0,40,214,5]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(T||(e.MarkerTag=T={}));var R;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(p){function w(S,a){return a-S}p.compare=w;const A=Object.create(null);A[p.Error]=(0,O.localize)(0,null),A[p.Warning]=(0,O.localize)(1,null),A[p.Info]=(0,O.localize)(2,null);function I(S){return A[S]||""}p.toString=I;function v(S){switch(S){case c.default.Error:return p.Error;case c.default.Warning:return p.Warning;case c.default.Info:return p.Info;case c.default.Ignore:return p.Hint}}p.fromSeverity=v;function C(S){switch(S){case p.Error:return c.default.Error;case p.Warning:return c.default.Warning;case p.Info:return c.default.Info;case p.Hint:return c.default.Ignore}}p.toSeverity=C}(R||(e.MarkerSeverity=R={}));var b;(function(p){const w="";function A(v){return I(v,!0)}p.makeKey=A;function I(v,C){const S=[w];return v.source?S.push(v.source.replace("\xA6","\\\xA6")):S.push(w),v.code?typeof v.code=="string"?S.push(v.code.replace("\xA6","\\\xA6")):S.push(v.code.value.replace("\xA6","\\\xA6")):S.push(w),v.severity!==void 0&&v.severity!==null?S.push(R.toString(v.severity)):S.push(w),v.message&&C?S.push(v.message.replace("\xA6","\\\xA6")):S.push(w),v.startLineNumber!==void 0&&v.startLineNumber!==null?S.push(v.startLineNumber.toString()):S.push(w),v.startColumn!==void 0&&v.startColumn!==null?S.push(v.startColumn.toString()):S.push(w),v.endLineNumber!==void 0&&v.endLineNumber!==null?S.push(v.endLineNumber.toString()):S.push(w),v.endColumn!==void 0&&v.endColumn!==null?S.push(v.endColumn.toString()):S.push(w),S.push(w),S.join("\xA6")}p.makeKeyOptionalMessage=I})(b||(e.IMarkerData=b={})),e.IMarkerService=(0,L.createDecorator)("markerService")}),define(ye[262],_e([1,0,4,40,5]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.isNotificationSource=b,e.Severity=O.default,e.INotificationService=(0,L.createDecorator)("notificationService");var T;(function(I){I[I.DEFAULT=0]="DEFAULT",I[I.SILENT=1]="SILENT",I[I.URGENT=2]="URGENT"})(T||(e.NotificationPriority=T={}));var R;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function b(I){if(I){const v=I;return typeof v.id=="string"&&typeof v.label=="string"}return!1}var p;(function(I){I[I.OFF=0]="OFF",I[I.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class w{constructor(){this.progress=new A,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(v){}updateMessage(v){}updateActions(v){}close(){}}e.NoOpNotification=w;class A{infinite(){}done(){}total(v){}worked(v){}}e.NoOpProgress=A}),define(ye[263],_e([1,0,50]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const T=L.context.configuration();if(T)O=T.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){O=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:T,searchUrl:R,itemUrl:b,controlUrl:p}=O.extensionsGallery||{};Object.assign(O,{extensionsGallery:{serviceUrl:c.env.VSCODE_GALLERY_SERVICE_URL||T,searchUrl:c.env.VSCODE_GALLERY_SEARCH_URL||R,itemUrl:c.env.VSCODE_GALLERY_ITEM_URL||b,controlUrl:c.env.VSCODE_GALLERY_CONTROL_URL||p}});try{const w=(...I)=>I.reduce((v,C)=>(Object.keys(C).forEach(S=>{Array.isArray(v[S])&&Array.isArray(C[S])?v[S]=C[S]:typeof v[S]=="object"&&typeof C[S]=="object"?v[S]=w(v[S],C[S]):v[S]=C[S]}),v),{}),A=globalThis._VSCODE_USER_PRODUCT_JSON||{};O=w(O,A)}catch{}if(c.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`,serverDataFolderName:O.serverDataFolderName?`${O.serverDataFolderName}-dev`:void 0}),!O.version){const w=globalThis._VSCODE_PACKAGE_JSON;Object.assign(O,{version:w.version,release:w.release})}}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=O}),define(ye[139],_e([1,0,5]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,c.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ue=this&&this.__param||function(de,e){return function(c,O){e(c,O,de)}};define(ye[108],_e([1,0,8,22,3,5]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var R;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(v){this.callback=v}report(v){this._value=v,this.callback(this._value)}}e.Progress=b;class p{get value(){return this._value}constructor(v){this.callback=v}report(v){this._asyncQueue?this._asyncQueue.push(v):this._asyncQueue=[v],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const v=this._asyncQueue.shift();this._value=v,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const v=this._drainListener;this._drainListener=void 0,v?.()}}drain(){return this._processingAsyncQueue?new Promise(v=>{const C=this._drainListener;this._drainListener=()=>{C?.(),v()}}):Promise.resolve()}}e.AsyncProgress=p;let w=class extends L.Disposable{constructor(v,C){super(),this.deferred=new c.DeferredPromise,C.withProgress(v,S=>(this.reporter=S,this.lastStep&&S.report(this.lastStep),this.deferred.p)),this._register((0,L.toDisposable)(()=>this.deferred.complete()))}report(v){this.reporter?this.reporter.report(v):this.lastStep=v}};e.UnmanagedProgress=w,e.UnmanagedProgress=w=Ge([Ue(1,e.IProgressService)],w);class A extends L.Disposable{constructor(v){super(),this.progressIndicator=v,this.currentOperationId=0,this.currentOperationDisposables=this._register(new L.DisposableStore)}start(v){this.stop();const C=++this.currentOperationId,S=new O.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{C===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},v),this.currentOperationDisposables.add((0,L.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,L.toDisposable)(()=>S.cancel())),this.currentOperationDisposables.add((0,L.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:C,token:S.token,stop:()=>this.doStop(C),isCurrent:()=>this.currentOperationId===C}}stop(){this.doStop(this.currentOperationId)}doStop(v){this.currentOperationId===v&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(ye[37],_e([1,0,61,18]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(R,b){c.ok(O.isString(R)),c.ok(O.isObject(b)),c.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,b)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new L}),define(ye[109],_e([1,0,4,37]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class T{constructor(){this._onDidChangeSchema=new c.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,w){this.schemasById[L(p)]=w,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new T;O.Registry.add(e.Extensions.JSONContribution,R)}),define(ye[85],_e([1,0,19,4,18,203,53,109,37]),function(de,e,c,O,L,T,R,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=a,e.keyFromOverrideIdentifiers=m,e.getDefaultValue=o,e.validateProperty=i,e.getScopes=r;var w;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=p.Registry.as(b.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const h=new Set;this.doRegisterConfigurations(t,f,h),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}deregisterConfigurations(t){const f=new Set;this.doDeregisterConfigurations(t,f),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:f})}updateConfigurations({add:t,remove:f}){const h=new Set;this.doDeregisterConfigurations(f,h),this.doRegisterConfigurations(t,!1,h),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}registerDefaultConfigurations(t){const f=new Set;this.doRegisterDefaultConfigurations(t,f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:f,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,f){const h=[];for(const{overrides:l,source:u}of t)for(const d in l)if(f.add(d),e.OVERRIDE_PROPERTY_REGEX.test(d)){const g=this.configurationDefaultsOverrides.get(d),D=g?.valuesSources??new Map;if(u)for(const P of Object.keys(l[d]))D.set(P,u);const E={...g?.value||{},...l[d]};this.configurationDefaultsOverrides.set(d,{source:u,value:E,valuesSources:D});const _=(0,R.getLanguageTagSettingPlainKey)(d),y={type:"object",default:E,description:T.localize(1,null,_),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:E,source:L.isString(u)?void 0:u,defaultValueSource:u};h.push(...a(d)),this.configurationProperties[d]=y,this.defaultLanguageConfigurationOverridesNode.properties[d]=y}else{this.configurationDefaultsOverrides.set(d,{value:l[d],source:u});const g=this.configurationProperties[d];g&&(this.updatePropertyDefaultValue(d,g),this.updateSchema(d,g))}this.doRegisterOverrideIdentifiers(h)}deregisterDefaultConfigurations(t){const f=new Set;this.doDeregisterDefaultConfigurations(t,f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:f,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,f){for(const{overrides:h,source:l}of t)for(const u in h){const d=this.configurationDefaultsOverrides.get(u),g=L.isString(l)?l:l?.id,D=L.isString(d?.source)?d?.source:d?.source?.id;if(g===D)if(f.add(u),this.configurationDefaultsOverrides.delete(u),e.OVERRIDE_PROPERTY_REGEX.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const E=this.configurationProperties[u];E&&(this.updatePropertyDefaultValue(u,E),this.updateSchema(u,E))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let f=!1;const h=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,h),f=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,h),f=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,h),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const f of t)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,f,h){t.forEach(l=>{this.validateAndRegisterProperties(l,f,l.extensionInfo,l.restrictedProperties,void 0,h),this.configurationContributors.push(l),this.registerJSONConfiguration(l)})}doDeregisterConfigurations(t,f){const h=l=>{if(l.properties)for(const u in l.properties){f.add(u);const d=this.configurationProperties[u];d?.policy?.name&&this.policyConfigurations.delete(d.policy.name),delete this.configurationProperties[u],this.removeFromSchema(u,l.properties[u])}l.allOf?.forEach(u=>h(u))};for(const l of t){h(l);const u=this.configurationContributors.indexOf(l);u!==-1&&this.configurationContributors.splice(u,1)}}validateAndRegisterProperties(t,f=!0,h,l,u=3,d){u=L.isUndefinedOrNull(t.scope)?u:t.scope;const g=t.properties;if(g)for(const E in g){const _=g[E];if(f&&i(E,_)){delete g[E];continue}if(_.source=h,_.defaultDefaultValue=g[E].default,this.updatePropertyDefaultValue(E,_),e.OVERRIDE_PROPERTY_REGEX.test(E)?_.scope=void 0:(_.scope=L.isUndefinedOrNull(_.scope)?u:_.scope,_.restricted=L.isUndefinedOrNull(_.restricted)?!!l?.includes(E):_.restricted),g[E].hasOwnProperty("included")&&!g[E].included){this.excludedConfigurationProperties[E]=g[E],delete g[E];continue}else this.configurationProperties[E]=g[E],g[E].policy?.name&&this.policyConfigurations.set(g[E].policy.name,E);!g[E].deprecationMessage&&g[E].markdownDeprecationMessage&&(g[E].deprecationMessage=g[E].markdownDeprecationMessage),d.add(E)}const D=t.allOf;if(D)for(const E of D)this.validateAndRegisterProperties(E,f,h,l,u,d)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const f=h=>{const l=h.properties;if(l)for(const d in l)this.updateSchema(d,l[d]);h.allOf?.forEach(f)};f(t)}updateSchema(t,f){switch(e.allSettings.properties[t]=f,f.scope){case 1:e.applicationSettings.properties[t]=f;break;case 2:e.machineSettings.properties[t]=f;break;case 6:e.machineOverridableSettings.properties[t]=f;break;case 3:e.windowSettings.properties[t]=f;break;case 4:e.resourceSettings.properties[t]=f;break;case 5:e.resourceSettings.properties[t]=f,this.resourceLanguageSettingsSchema.properties[t]=f;break}}removeFromSchema(t,f){switch(delete e.allSettings.properties[t],f.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const f=`[${t}]`,h={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,h),e.allSettings.properties[f]=h,e.applicationSettings.properties[f]=h,e.machineSettings.properties[f]=h,e.machineOverridableSettings.properties[f]=h,e.windowSettings.properties[f]=h,e.resourceSettings.properties[f]=h}}registerOverridePropertyPatternKey(){const t={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,f){const h=this.configurationDefaultsOverrides.get(t);let l=h?.value,u=h?.source;L.isUndefined(l)&&(l=f.defaultDefaultValue,u=void 0),L.isUndefined(l)&&(l=o(f.type)),f.default=l,f.defaultValueSource=u}}const C="\\[([^\\]]+)\\]",S=new RegExp(C,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${C})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function a(s){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let f=S.exec(s);for(;f?.length;){const h=f[1].trim();h&&t.push(h),f=S.exec(s)}}return(0,c.distinct)(t)}function m(s){return s.reduce((t,f)=>`${t}[${f}]`,"")}function o(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new v;p.Registry.add(e.Extensions.Configuration,n);function i(s,t){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?T.localize(7,null,s):n.getConfigurationProperties()[s]!==void 0?T.localize(8,null,s):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?T.localize(9,null,s,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:T.localize(6,null)}function r(){const s=[],t=n.getConfigurationProperties();for(const f of Object.keys(t))s.push([f,t[f].scope]);return s.push(["launch",4]),s.push(["task",4]),s}}),define(ye[264],_e([1,0,19,4,164,3,27,24,18,2,53,85,37]),function(de,e,c,O,L,T,R,b,p,w,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=i;function C(f){return Object.isFrozen(f)?f:b.deepFreeze(f)}class S{constructor(h={},l=[],u=[],d){this._contents=h,this._keys=l,this._overrides=u,this.raw=d,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const h=this.raw.map(l=>{if(l instanceof S)return l;const u=new a("");return u.parseRaw(l),u.configurationModel});this._rawConfiguration=h.reduce((l,u)=>u===l?u:l.merge(u),h[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(h){return h?(0,A.getConfigurationValue)(this.contents,h):this.contents}inspect(h,l){const u=this;return{get value(){return C(u.rawConfiguration.getValue(h))},get override(){return l?C(u.rawConfiguration.getOverrideValue(h,l)):void 0},get merged(){return C(l?u.rawConfiguration.override(l).getValue(h):u.rawConfiguration.getValue(h))},get overrides(){const d=[];for(const{contents:g,identifiers:D,keys:E}of u.rawConfiguration.overrides){const _=new S(g,E).getValue(h);_!==void 0&&d.push({identifiers:D,value:_})}return d.length?C(d):void 0}}}getOverrideValue(h,l){const u=this.getContentsForOverrideIdentifer(l);return u?h?(0,A.getConfigurationValue)(u,h):u:void 0}getKeysForOverrideIdentifier(h){const l=[];for(const u of this.overrides)u.identifiers.includes(h)&&l.push(...u.keys);return c.distinct(l)}getAllOverrideIdentifiers(){const h=[];for(const l of this.overrides)h.push(...l.identifiers);return c.distinct(h)}override(h){let l=this.overrideConfigurations.get(h);return l||(l=this.createOverrideConfigurationModel(h),this.overrideConfigurations.set(h,l)),l}merge(...h){const l=b.deepClone(this.contents),u=b.deepClone(this.overrides),d=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const D of h)if(g.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.mergeContents(l,D.contents);for(const E of D.overrides){const[_]=u.filter(y=>c.equals(y.identifiers,E.identifiers));_?(this.mergeContents(_.contents,E.contents),_.keys.push(...E.keys),_.keys=c.distinct(_.keys)):u.push(b.deepClone(E))}for(const E of D.keys)d.indexOf(E)===-1&&d.push(E)}return new S(l,d,u,g.every(D=>D instanceof S)?void 0:g)}createOverrideConfigurationModel(h){const l=this.getContentsForOverrideIdentifer(h);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const u={};for(const d of c.distinct([...Object.keys(this.contents),...Object.keys(l)])){let g=this.contents[d];const D=l[d];D&&(typeof g=="object"&&typeof D=="object"?(g=b.deepClone(g),this.mergeContents(g,D)):g=D),u[d]=g}return new S(u,this.keys,this.overrides)}mergeContents(h,l){for(const u of Object.keys(l)){if(u in h&&p.isObject(h[u])&&p.isObject(l[u])){this.mergeContents(h[u],l[u]);continue}h[u]=b.deepClone(l[u])}}getContentsForOverrideIdentifer(h){let l=null,u=null;const d=g=>{g&&(u?this.mergeContents(u,g):u=b.deepClone(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===h?l=g.contents:g.identifiers.includes(h)&&d(g.contents);return d(l),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(h,l){this.updateValue(h,l,!0)}setValue(h,l){this.updateValue(h,l,!1)}removeValue(h){const l=this.keys.indexOf(h);l!==-1&&(this.keys.splice(l,1),(0,A.removeFromValueTree)(this.contents,h),I.OVERRIDE_PROPERTY_REGEX.test(h)&&this.overrides.splice(this.overrides.findIndex(u=>c.equals(u.identifiers,(0,I.overrideIdentifiersFromKey)(h))),1))}updateValue(h,l,u){(0,A.addToValueTree)(this.contents,h,l,d=>console.error(d)),u=u||this.keys.indexOf(h)===-1,u&&this.keys.push(h),I.OVERRIDE_PROPERTY_REGEX.test(h)&&this.overrides.push({identifiers:(0,I.overrideIdentifiersFromKey)(h),keys:Object.keys(this.contents[h]),contents:(0,A.toValuesTree)(this.contents[h],d=>console.error(d))})}}e.ConfigurationModel=S;class a{constructor(h){this._name=h,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(h,l){if(!p.isUndefinedOrNull(h)){const u=this.doParseContent(h);this.parseRaw(u,l)}}reparse(h){this._raw&&this.parseRaw(this._raw,h)}parseRaw(h,l){this._raw=h;const{contents:u,keys:d,overrides:g,restricted:D,hasExcludedProperties:E}=this.doParseRaw(h,l);this._configurationModel=new S(u,d,g,E?[h]:void 0),this._restrictedConfigurations=D||[]}doParseContent(h){let l={},u=null,d=[];const g=[],D=[];function E(y){Array.isArray(d)?d.push(y):u!==null&&(d[u]=y)}const _={onObjectBegin:()=>{const y={};E(y),g.push(d),d=y,u=null},onObjectProperty:y=>{u=y},onObjectEnd:()=>{d=g.pop()},onArrayBegin:()=>{const y=[];E(y),g.push(d),d=y,u=null},onArrayEnd:()=>{d=g.pop()},onLiteralValue:E,onError:(y,P,k)=>{D.push({error:y,offset:P,length:k})}};if(h)try{L.visit(h,_),l=d[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return l}doParseRaw(h,l){const u=v.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),d=this.filter(h,u,!0,l);h=d.raw;const g=(0,A.toValuesTree)(h,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),D=Object.keys(h),E=this.toOverrides(h,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:g,keys:D,overrides:E,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}filter(h,l,u,d){let g=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:h,restricted:[],hasExcludedProperties:g};const D={},E=[];for(const _ in h)if(I.OVERRIDE_PROPERTY_REGEX.test(_)&&u){const y=this.filter(h[_],l,!1,d);D[_]=y.raw,g=g||y.hasExcludedProperties,E.push(...y.restricted)}else{const y=l[_],P=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&E.push(_),!d.exclude?.includes(_)&&(d.include?.includes(_)||(P===void 0||d.scopes===void 0||d.scopes.includes(P))&&!(d.skipRestricted&&y?.restricted))?D[_]=h[_]:g=!0}return{raw:D,restricted:E,hasExcludedProperties:g}}toOverrides(h,l){const u=[];for(const d of Object.keys(h))if(I.OVERRIDE_PROPERTY_REGEX.test(d)){const g={};for(const D in h[d])g[D]=h[d][D];u.push({identifiers:(0,I.overrideIdentifiersFromKey)(d),keys:Object.keys(g),contents:(0,A.toValuesTree)(g,l)})}return u}}e.ConfigurationModelParser=a;class m extends T.Disposable{constructor(h,l,u,d){super(),this.userSettingsResource=h,this.parseOptions=l,this.fileService=d,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new a(this.userSettingsResource.toString()),this._register(this.fileService.watch(u.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,g=>g.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,g=>(g.isOperation(0)||g.isOperation(3)||g.isOperation(1)||g.isOperation(4))&&u.isEqual(g.resource,h)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const h=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(h.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(h){return h&&(this.parseOptions=h),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class o{constructor(h,l,u,d,g,D,E,_,y,P,k,z,x){this.key=h,this.overrides=l,this._value=u,this.overrideIdentifiers=d,this.defaultConfiguration=g,this.policyConfiguration=D,this.applicationConfiguration=E,this.userConfiguration=_,this.localUserConfiguration=y,this.remoteUserConfiguration=P,this.workspaceConfiguration=k,this.folderConfigurationModel=z,this.memoryConfigurationModel=x}get value(){return C(this._value)}toInspectValue(h){return h?.value!==void 0||h?.override!==void 0||h?.overrides!==void 0?h:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class n{constructor(h,l,u,d,g=new S,D=new S,E=new R.ResourceMap,_=new S,y=new R.ResourceMap){this._defaultConfiguration=h,this._policyConfiguration=l,this._applicationConfiguration=u,this._localUserConfiguration=d,this._remoteUserConfiguration=g,this._workspaceConfiguration=D,this._folderConfigurations=E,this._memoryConfiguration=_,this._memoryConfigurationByResource=y,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(h,l,u){return this.getConsolidatedConfigurationModel(h,l,u).getValue(h)}updateValue(h,l,u={}){let d;u.resource?(d=this._memoryConfigurationByResource.get(u.resource),d||(d=new S,this._memoryConfigurationByResource.set(u.resource,d))):d=this._memoryConfiguration,l===void 0?d.removeValue(h):d.setValue(h,l),u.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(h,l,u){const d=this.getConsolidatedConfigurationModel(h,l,u),g=this.getFolderConfigurationModelForResource(l.resource,u),D=l.resource?this._memoryConfigurationByResource.get(l.resource)||this._memoryConfiguration:this._memoryConfiguration,E=new Set;for(const _ of d.overrides)for(const y of _.identifiers)d.getOverrideValue(h,y)!==void 0&&E.add(y);return new o(h,l,d.getValue(h),E.size?[...E]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this._workspaceConfiguration:void 0,g||void 0,D)}keys(h){const l=this.getFolderConfigurationModelForResource(void 0,h);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(h){this._defaultConfiguration=h,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(h){this._policyConfiguration=h}updateApplicationConfiguration(h){this._applicationConfiguration=h,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(h){this._localUserConfiguration=h,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(h){this._remoteUserConfiguration=h,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(h){this._workspaceConfiguration=h,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(h,l){this._folderConfigurations.set(h,l),this._foldersConsolidatedConfigurations.delete(h)}deleteFolderConfiguration(h){this.folderConfigurations.delete(h),this._foldersConsolidatedConfigurations.delete(h)}compareAndUpdateDefaultConfiguration(h,l){const u=[];if(!l){const{added:d,updated:g,removed:D}=s(this._defaultConfiguration,h);l=[...d,...g,...D]}for(const d of l)for(const g of(0,I.overrideIdentifiersFromKey)(d)){const D=this._defaultConfiguration.getKeysForOverrideIdentifier(g),E=h.getKeysForOverrideIdentifier(g),_=[...E.filter(y=>D.indexOf(y)===-1),...D.filter(y=>E.indexOf(y)===-1),...D.filter(y=>!b.equals(this._defaultConfiguration.override(g).getValue(y),h.override(g).getValue(y)))];u.push([g,_])}return this.updateDefaultConfiguration(h),{keys:l,overrides:u}}compareAndUpdatePolicyConfiguration(h){const{added:l,updated:u,removed:d}=s(this._policyConfiguration,h),g=[...l,...u,...d];return g.length&&this.updatePolicyConfiguration(h),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(h){const{added:l,updated:u,removed:d,overrides:g}=s(this.applicationConfiguration,h),D=[...l,...u,...d];return D.length&&this.updateApplicationConfiguration(h),{keys:D,overrides:g}}compareAndUpdateLocalUserConfiguration(h){const{added:l,updated:u,removed:d,overrides:g}=s(this.localUserConfiguration,h),D=[...l,...u,...d];return D.length&&this.updateLocalUserConfiguration(h),{keys:D,overrides:g}}compareAndUpdateRemoteUserConfiguration(h){const{added:l,updated:u,removed:d,overrides:g}=s(this.remoteUserConfiguration,h),D=[...l,...u,...d];return D.length&&this.updateRemoteUserConfiguration(h),{keys:D,overrides:g}}compareAndUpdateWorkspaceConfiguration(h){const{added:l,updated:u,removed:d,overrides:g}=s(this.workspaceConfiguration,h),D=[...l,...u,...d];return D.length&&this.updateWorkspaceConfiguration(h),{keys:D,overrides:g}}compareAndUpdateFolderConfiguration(h,l){const u=this.folderConfigurations.get(h),{added:d,updated:g,removed:D,overrides:E}=s(u,l),_=[...d,...g,...D];return(_.length||!u)&&this.updateFolderConfiguration(h,l),{keys:_,overrides:E}}compareAndDeleteFolderConfiguration(h){const l=this.folderConfigurations.get(h);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(h);const{added:u,updated:d,removed:g,overrides:D}=s(l,void 0);return{keys:[...u,...d,...g],overrides:D}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(h,l,u){let d=this.getConsolidatedConfigurationModelForResource(l,u);return l.overrideIdentifier&&(d=d.override(l.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(h)!==void 0&&(d=d.merge(this._policyConfiguration)),d}getConsolidatedConfigurationModelForResource({resource:h},l){let u=this.getWorkspaceConsolidatedConfiguration();if(l&&h){const d=l.getFolder(h);d&&(u=this.getFolderConsolidatedConfiguration(d.uri)||u);const g=this._memoryConfigurationByResource.get(h);g&&(u=u.merge(g))}return u}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(h){let l=this._foldersConsolidatedConfigurations.get(h);if(!l){const u=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(h);d?(l=u.merge(d),this._foldersConsolidatedConfigurations.set(h,l)):l=u}return l}getFolderConfigurationModelForResource(h,l){if(l&&h){const u=l.getFolder(h);if(u)return this._folderConfigurations.get(u.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((h,l)=>{const{contents:u,overrides:d,keys:g}=this._folderConfigurations.get(l);return h.push([l,{contents:u,overrides:d,keys:g}]),h},[])}}allKeys(){const h=new Set;return this._defaultConfiguration.keys.forEach(l=>h.add(l)),this.userConfiguration.keys.forEach(l=>h.add(l)),this._workspaceConfiguration.keys.forEach(l=>h.add(l)),this._folderConfigurations.forEach(l=>l.keys.forEach(u=>h.add(u))),[...h.values()]}allOverrideIdentifiers(){const h=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(l=>h.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>h.add(l)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(l=>h.add(l)),this._folderConfigurations.forEach(l=>l.getAllOverrideIdentifiers().forEach(u=>h.add(u))),[...h.values()]}getAllKeysForOverrideIdentifier(h){const l=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(h).forEach(u=>l.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(h).forEach(u=>l.add(u)),this._workspaceConfiguration.getKeysForOverrideIdentifier(h).forEach(u=>l.add(u)),this._folderConfigurations.forEach(u=>u.getKeysForOverrideIdentifier(h).forEach(d=>l.add(d))),[...l.values()]}static parse(h){const l=this.parseConfigurationModel(h.defaults),u=this.parseConfigurationModel(h.policy),d=this.parseConfigurationModel(h.application),g=this.parseConfigurationModel(h.user),D=this.parseConfigurationModel(h.workspace),E=h.folders.reduce((_,y)=>(_.set(w.URI.revive(y[0]),this.parseConfigurationModel(y[1])),_),new R.ResourceMap);return new n(l,u,d,g,new S,D,E,new S,new R.ResourceMap)}static parseConfigurationModel(h){return new S(h.contents,h.keys,h.overrides)}}e.Configuration=n;function i(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const h=new Set,l=new Map;for(const d of f)d.keys.forEach(g=>h.add(g)),d.overrides.forEach(([g,D])=>{const E=(0,R.getOrSet)(l,g,new Set);D.forEach(_=>E.add(_))});const u=[];return l.forEach((d,g)=>u.push([g,[...d.values()]])),{keys:[...h.values()],overrides:u}}class r{constructor(h,l,u,d){this.change=h,this.previous=l,this.currentConfiguraiton=u,this.currentWorkspace=d,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const g of h.keys)this.affectedKeys.add(g);for(const[,g]of h.overrides)for(const D of g)this.affectedKeys.add(D);this._affectsConfigStr=this._marker;for(const g of this.affectedKeys)this._affectsConfigStr+=g+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=n.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(h,l){const u=this._marker+h,d=this._affectsConfigStr.indexOf(u);if(d<0)return!1;const g=d+u.length;if(g>=this._affectsConfigStr.length)return!1;const D=this._affectsConfigStr.charCodeAt(g);if(D!==this._markerCode1&&D!==this._markerCode2)return!1;if(l){const E=this.previousConfiguration?this.previousConfiguration.getValue(h,l,this.previous?.workspace):void 0,_=this.currentConfiguraiton.getValue(h,l,this.currentWorkspace);return!b.equals(E,_)}return!0}}e.ConfigurationChangeEvent=r;function s(f,h){const{added:l,removed:u,updated:d}=t(h?.rawConfiguration,f?.rawConfiguration),g=[],D=f?.getAllOverrideIdentifiers()||[],E=h?.getAllOverrideIdentifiers()||[];if(h){const _=E.filter(y=>!D.includes(y));for(const y of _)g.push([y,h.getKeysForOverrideIdentifier(y)])}if(f){const _=D.filter(y=>!E.includes(y));for(const y of _)g.push([y,f.getKeysForOverrideIdentifier(y)])}if(h&&f){for(const _ of D)if(E.includes(_)){const y=t({contents:f.getOverrideValue(void 0,_)||{},keys:f.getKeysForOverrideIdentifier(_)},{contents:h.getOverrideValue(void 0,_)||{},keys:h.getKeysForOverrideIdentifier(_)});g.push([_,[...y.added,...y.removed,...y.updated]])}}return{added:l,removed:u,updated:d,overrides:g}}function t(f,h){const l=f?h?f.keys.filter(g=>h.keys.indexOf(g)===-1):[...f.keys]:[],u=h?f?h.keys.filter(g=>f.keys.indexOf(g)===-1):[...h.keys]:[],d=[];if(f&&h){for(const g of h.keys)if(f.keys.indexOf(g)!==-1){const D=(0,A.getConfigurationValue)(h.contents,g),E=(0,A.getConfigurationValue)(f.contents,g);b.equals(D,E)||d.push(g)}}return{added:l,removed:u,updated:d}}}),define(ye[265],_e([1,0,21,4,3,82]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0,e.connectManagedSocket=b;const R=(w,A,I)=>{const v=new Uint8Array(16);for(let a=0;a<16;a++)v[a]=Math.round(Math.random()*256);const C=(0,c.encodeBase64)(c.VSBuffer.wrap(v));return[`GET ws://localhost${w}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${C}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=R,e.socketRawEndHeaderSequence=c.VSBuffer.fromString(`\r
\r
`);async function b(w,A,I,v,C){w.write(c.VSBuffer.fromString((0,e.makeRawSocketHeaders)(A,I,v)));const S=new L.DisposableStore;try{return await new Promise((a,m)=>{let o;S.add(w.onData(n=>{o?o=c.VSBuffer.concat([o,n],o.byteLength+n.byteLength):o=n;const i=o.indexOf(e.socketRawEndHeaderSequence);if(i===-1)return;a(w),w.pauseData();const r=o.slice(i+e.socketRawEndHeaderSequence.byteLength);r.byteLength&&C.onData.fire(r)})),S.add(w.onClose(n=>m(n??new Error("socket closed")))),S.add(w.onEnd(()=>m(new Error("socket ended"))))})}catch(a){throw w.dispose(),a}finally{S.dispose()}}class p extends L.Disposable{constructor(A,I){super(),this.debugLabel=A,this.pausableDataEmitter=this._register(new O.PauseableEmitter),this.onData=(...v)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...v)),this.didDisposeEmitter=this._register(new O.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(I.onData),this._register(I.onData.event(v=>this.pausableDataEmitter.fire(v))),this.onClose=this._register(I.onClose).event,this.onEnd=this._register(I.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(A,I){T.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,A,I)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=p}),define(ye[65],_e([1,0,13,5]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=w,e.IRemoteAuthorityResolverService=(0,O.createDecorator)("remoteAuthorityResolverService");var L;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class T{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=T;class R{constructor(I,v){this.host=I,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=R;var b;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class p extends c.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof p&&I._code===b.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof p&&I._code===b.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof p&&I._code===b.NoResolverFound}static isInvalidAuthority(I){return I instanceof p&&I._code===b.InvalidAuthority}static isHandled(I){return I instanceof p&&I.isHandled}constructor(I,v=b.Unknown,C){super(I),this._message=I,this._code=v,this._detail=C,this.isHandled=v===b.NotAvailable&&C===!0,Object.setPrototypeOf(this,p.prototype)}}e.RemoteAuthorityResolverError=p;function w(A){const I=A.indexOf("+");return I===-1?A:A.substring(0,I)}}),define(ye[266],_e([1,0,8,21,22,13,4,3,15,58,39,30,82,65]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=D,e.connectRemoteAgentExtensionHost=E,e.connectRemoteAgentTunnel=y;const S=30*1e3;var a;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function m(J){switch(J){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(J){const $=new L.CancellationTokenSource;return setTimeout(()=>$.cancel(),J),$.token}function n(J,$){if(J.isCancellationRequested||$.isCancellationRequested)return L.CancellationToken.Cancelled;const ne=new L.CancellationTokenSource;return J.onCancellationRequested(()=>ne.cancel()),$.onCancellationRequested(()=>ne.cancel()),ne.token}class i{get didTimeout(){return this._state==="timedout"}constructor($){this._state="pending",this._disposables=new b.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,c.promiseWithResolvers)(),$.isCancellationRequested?this._timeout():this._disposables.add($.onCancellationRequested(()=>this._timeout()))}registerDisposable($){this._state==="pending"?this._disposables.add($):$.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const $=new Error("Time limit reached");return $.code="ETIMEDOUT",$.syscall="connect",$}resolve($){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise($))}reject($){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise($))}}function r(J,$){const ne=new i($);return ne.registerDisposable(J.onControlMessage(be=>{const Ce=JSON.parse(be.toString()),ae=G(Ce);ae?ne.reject(ae):ne.resolve(Ce)})),ne.promise}function s(J,$,ne,be,Ce,ae,ce,se){const j=new i(se),ie=A.StopWatch.create(!1);return J.info(`Creating a socket (${ce})...`),w.mark(`code/willCreateSocket/${ae}`),$.connect(ne,be,Ce,ce).then(ue=>{j.didTimeout?(w.mark(`code/didCreateSocketError/${ae}`),J.info(`Creating a socket (${ce}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(w.mark(`code/didCreateSocketOK/${ae}`),J.info(`Creating a socket (${ce}) was successful after ${ie.elapsed()} ms.`),j.resolve(ue))},ue=>{w.mark(`code/didCreateSocketError/${ae}`),J.info(`Creating a socket (${ce}) returned an error after ${ie.elapsed()} ms.`),J.error(ue),j.reject(ue)}),j.promise}function t(J,$){const ne=new i($);return J.then(be=>{ne.didTimeout||ne.resolve(be)},be=>{ne.didTimeout||ne.reject(be)}),ne.promise}async function f(J,$,ne,be){const Ce=ve(J,$);J.logService.trace(`${Ce} 1/6. invoking socketFactory.connect().`);let ae;try{ae=await s(J.logService,J.remoteSocketFactoryService,J.connectTo,p.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,m($),`renderer-${m($)}-${J.reconnectionToken}`,be)}catch(ue){throw J.logService.error(`${Ce} socketFactory.connect() failed or timed out. Error:`),J.logService.error(ue),ue}J.logService.trace(`${Ce} 2/6. socketFactory.connect() was successful.`);let ce,se;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(ae,null),ce=J.reconnectionProtocol,se=!1):(ce=new v.PersistentProtocol({socket:ae}),se=!0),J.logService.trace(`${Ce} 3/6. sending AuthRequest control message.`);const j=await t(J.signService.createNewMessage((0,I.generateUuid)()),be),ie={type:"auth",auth:J.connectionToken||"00000000000000000000",data:j.data};ce.sendControl(O.VSBuffer.fromString(JSON.stringify(ie)));try{const ue=await r(ce,n(be,o(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(J.logService.trace(`${Ce} 4/6. received SignRequest control message.`),!await t(J.signService.validate(j,ue.signedData),be)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const Te=await t(J.signService.sign(ue.data),be),me={type:"connectionType",commit:J.commit,signedData:Te,desiredConnectionType:$};return ne&&(me.args=ne),J.logService.trace(`${Ce} 5/6. sending ConnectionTypeRequest control message.`),ce.sendControl(O.VSBuffer.fromString(JSON.stringify(me))),{protocol:ce,ownsProtocol:se}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(J.logService.error(`${Ce} the handshake timed out. Error:`),J.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${Ce} received error control message when negotiating connection. Error:`),J.logService.error(ue)),se&&Z(ce),ue}}async function h(J,$,ne,be){const Ce=Date.now(),ae=ve(J,$),{protocol:ce,ownsProtocol:se}=await f(J,$,ne,be),j=new i(be);return j.registerDisposable(ce.onControlMessage(ie=>{const ue=JSON.parse(ie.toString()),he=G(ue);he?(J.logService.error(`${ae} received error control message when negotiating connection. Error:`),J.logService.error(he),se&&Z(ce),j.reject(he)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${ae} 6/6. handshake finished, connection is up and running after ${Ie(Ce)}!`),j.resolve({protocol:ce,firstMessage:ue}))})),j.promise}async function l(J,$){const{protocol:ne}=await h(J,1,void 0,$);return{protocol:ne}}async function u(J,$,ne){const{protocol:be,firstMessage:Ce}=await h(J,2,$,ne),ae=Ce&&Ce.debugPort;return{protocol:be,debugPort:ae}}async function d(J,$,ne){const be=Date.now(),Ce=ve(J,3),{protocol:ae}=await f(J,3,$,ne);return J.logService.trace(`${Ce} 6/6. handshake finished, connection is up and running after ${Ie(be)}!`),ae}async function g(J,$,ne){const{connectTo:be,connectionToken:Ce}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,connectTo:be,connectionToken:Ce,reconnectionToken:$,reconnectionProtocol:ne,remoteSocketFactoryService:J.remoteSocketFactoryService,signService:J.signService,logService:J.logService}}async function D(J,$,ne){return _(J,async be=>{const{protocol:Ce}=await l(be,L.CancellationToken.None);return new W(J,$,ne,be.reconnectionToken,Ce)})}async function E(J,$){return _(J,async ne=>{const{protocol:be,debugPort:Ce}=await u(ne,$,L.CancellationToken.None);return new Y(J,$,ne.reconnectionToken,be,Ce)})}async function _(J,$){for(let be=1;;be++)try{const Ce=(0,I.generateUuid)(),ae=await g(J,Ce,null);return await $(ae)}catch(Ce){if(be<5)J.logService.error(`[remote-connection][attempt ${be}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(Ce);else throw J.logService.error(`[remote-connection][attempt ${be}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(Ce),B.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(Ce)),Ce}}async function y(J,$,ne){const be=await g(J,(0,I.generateUuid)(),null);return await d(be,{host:$,port:ne},L.CancellationToken.None)}function P(J){return(0,c.createCancelablePromise)($=>new Promise((ne,be)=>{const Ce=setTimeout(ne,J*1e3);$.onCancellationRequested(()=>{clearTimeout(Ce),ne()})}))}var k;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(k||(e.PersistentConnectionEventType=k={}));class z{constructor($,ne){this.reconnectionToken=$,this.millisSinceLastIncomingData=ne,this.type=0}}e.ConnectionLostEvent=z;class x{constructor($,ne,be,Ce){this.reconnectionToken=$,this.millisSinceLastIncomingData=ne,this.durationSeconds=be,this.cancellableTimer=Ce,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=x;class F{constructor($,ne,be){this.reconnectionToken=$,this.millisSinceLastIncomingData=ne,this.attempt=be,this.type=2}}e.ReconnectionRunningEvent=F;class N{constructor($,ne,be){this.reconnectionToken=$,this.millisSinceLastIncomingData=ne,this.attempt=be,this.type=4}}e.ConnectionGainEvent=N;class M{constructor($,ne,be,Ce){this.reconnectionToken=$,this.millisSinceLastIncomingData=ne,this.attempt=be,this.handled=Ce,this.type=3}}e.ReconnectionPermanentFailureEvent=M;class B extends b.Disposable{static triggerPermanentFailure($,ne,be){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=$,this._permanentFailureAttempt=ne,this._permanentFailureHandled=be,this._instances.forEach(Ce=>Ce._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach($=>$._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach($=>$._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||B._permanentFailure}constructor($,ne,be,Ce,ae){super(),this._connectionType=$,this._options=ne,this.reconnectionToken=be,this.protocol=Ce,this._reconnectionFailureIsFatal=ae,this._onDidStateChange=this._register(new R.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(Ce.onSocketClose(ce=>{const se=te(this._connectionType,this.reconnectionToken,!0);ce?ce.type===0?(this._options.logService.info(`${se} received socket close event (hadError: ${ce.hadError}).`),ce.error&&this._options.logService.error(ce.error)):(this._options.logService.info(`${se} received socket close event (wasClean: ${ce.wasClean}, code: ${ce.code}, reason: ${ce.reason}).`),ce.event&&this._options.logService.error(ce.event)):this._options.logService.info(`${se} received socket close event.`),this._beginReconnecting()})),this._register(Ce.onSocketTimeout(ce=>{const se=te(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${ce.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ce.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ce.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),B._instances.push(this),this._register((0,b.toDisposable)(()=>{const ce=B._instances.indexOf(this);ce>=0&&B._instances.splice(ce,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(B._permanentFailureMillisSinceLastIncomingData,B._permanentFailureAttempt,B._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const $=te(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${$} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ne=[0,5,5,10,10,10,10,10,30];let be=-1;do{be++;const Ce=be<ne.length?ne[be]:ne[ne.length-1];try{if(Ce>0){const ce=P(Ce);this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Ce,ce)),this._options.logService.info(`${$} waiting for ${Ce} seconds before reconnecting...`);try{await ce}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${$} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1)),this._options.logService.info(`${$} resolving connection...`);const ae=await g(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${$} connecting to ${ae.connectTo}...`),await this._reconnect(ae,o(S)),this._options.logService.info(`${$} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1));break}catch(ae){if(ae.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${$} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(ae),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(be>360){this._options.logService.error(`${$} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(ae),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(C.RemoteAuthorityResolverError.isTemporarilyNotAvailable(ae)){this._options.logService.info(`${$} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ae);continue}if((ae.code==="ETIMEDOUT"||ae.code==="ENETUNREACH"||ae.code==="ECONNREFUSED"||ae.code==="ECONNRESET")&&ae.syscall==="connect"){this._options.logService.info(`${$} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ae);continue}if((0,T.isCancellationError)(ae)){this._options.logService.info(`${$} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ae);continue}if(ae instanceof C.RemoteAuthorityResolverError){this._options.logService.error(`${$} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(ae),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),be+1,C.RemoteAuthorityResolverError.isHandled(ae));break}this._options.logService.error(`${$} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(ae),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure($,ne,be){this._reconnectionFailureIsFatal?B.triggerPermanentFailure($,ne,be):this._gotoPermanentFailure($,ne,be)}_gotoPermanentFailure($,ne,be){this._onDidStateChange.fire(new M(this.reconnectionToken,$,ne,be)),Z(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=B;class W extends B{constructor($,ne,be,Ce,ae){super(1,$,Ce,ae,!0),this.client=this._register(new v.Client(ae,{remoteAuthority:ne,clientId:be},$.ipcLogger))}async _reconnect($,ne){await l($,ne)}}e.ManagementPersistentConnection=W;class Y extends B{constructor($,ne,be,Ce,ae){super(2,$,be,Ce,!1),this._startArguments=ne,this.debugPort=ae}async _reconnect($,ne){await u($,this._startArguments,ne)}}e.ExtensionHostPersistentConnection=Y;function Z(J){try{J.acceptDisconnect();const $=J.getSocket();J.dispose(),$.dispose()}catch($){(0,T.onUnexpectedError)($)}}function G(J){if(J&&J.type==="error"){const $=new Error(`Connection error: ${J.reason}`);return $.code="VSCODE_CONNECTION_ERROR",$}return null}function Q(J,$){for(;J.length<$;)J+=" ";return J}function re(J,$){return`[remote-connection][${Q(m(J),13)}][${$.substr(0,5)}\u2026]`}function te(J,$,ne){return`${re(J,$)}[${ne?"reconnect":"initial"}]`}function ve(J,$){return`${te($,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.connectTo}]`}function Ie(J){return`${Date.now()-J} ms`}}),define(ye[86],_e([1,0,15]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=O,e.getRemoteName=L,e.parseAuthorityWithPort=T,e.parseAuthorityWithOptionalPort=R;function O(p){return p.scheme===c.Schemas.vscodeRemote?p.authority:void 0}function L(p){if(!p)return;const w=p.indexOf("+");return w<0?p:p.substr(0,w)}function T(p){const{host:w,port:A}=b(p);if(typeof A>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:w,port:A}}function R(p,w){let{host:A,port:I}=b(p);return typeof I>"u"&&(I=w),{host:A,port:I}}function b(p){const w=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const A=p.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const I=p.match(/(.*):(\d+)$/);return I?{host:I[1],port:parseInt(I[2],10)}:{host:p,port:void 0}}}),define(ye[25],_e([1,0,14,5,86]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=T,e.isApplicationScopedExtension=I,e.isLanguagePackExtension=v,e.isAuthenticationProviderExtension=C,e.isResolverExtension=S,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(R||(e.ExtensionType=R={}));var b;(function(a){a.WIN32_X64="win32-x64",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.LINUX_PPC64LE="linux-ppc64le",a.LINUX_RISCV64="linux-riscv64",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class p{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,o){if(typeof m>"u"||m===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof m=="string"||typeof o=="string"){const n=typeof m=="string"?m:m.value,i=typeof o=="string"?o:o.value;return c.equalsIgnoreCase(n,i)}return m._lower===o._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=p;class w{get size(){return this._set.size}constructor(m){if(this._set=new Set,m)for(const o of m)this.add(o)}add(m){this._set.add(p.toKey(m))}delete(m){return this._set.delete(p.toKey(m))}has(m){return this._set.has(p.toKey(m))}}e.ExtensionIdentifierSet=w;class A{constructor(){this._map=new Map}clear(){this._map.clear()}delete(m){this._map.delete(p.toKey(m))}get(m){return this._map.get(p.toKey(m))}has(m){return this._map.has(p.toKey(m))}set(m,o){this._map.set(p.toKey(m),o)}values(){return this._map.values()}forEach(m){this._map.forEach(m)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=A;function I(a){return v(a)}function v(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}function C(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}function S(a,m){if(m){const o=`onResolveRemoteAuthority:${(0,L.getRemoteName)(m)}`;return!!a.activationEvents?.includes(o)}return!1}e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[140],_e([1,0,13,25]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class L{constructor(){this._generators=new Map,this._cache=new WeakMap}register(R,b){this._generators.set(R,b)}readActivationEvents(R){return this._cache.has(R)||this._cache.set(R,this._readActivationEvents(R)),this._cache.get(R)}createActivationEventsMap(R){const b=Object.create(null);for(const p of R){const w=this.readActivationEvents(p);w.length>0&&(b[O.ExtensionIdentifier.toKey(p.identifier)]=w)}return b}_readActivationEvents(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const b=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let p=0;p<b.length;p++)b[p]==="onUri"&&(b[p]=`onUri:${O.ExtensionIdentifier.toKey(R.identifier)}`);if(!R.contributes)return b;for(const p in R.contributes){const w=this._generators.get(p);if(!w)continue;const A=R.contributes[p],I=Array.isArray(A)?A:[A];try{w(I,b)}catch(v){(0,c.onUnexpectedError)(v)}}return b}}e.ImplicitActivationEventsImpl=L,e.ImplicitActivationEvents=new L}),define(ye[267],_e([1,0,3,5]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,O.createDecorator)("remoteSocketFactoryService");class L{constructor(){this.factories={}}register(R,b){return this.factories[R]??=[],this.factories[R].push(b),(0,c.toDisposable)(()=>{const p=this.factories[R]?.indexOf(b);typeof p=="number"&&p>=0&&this.factories[R]?.splice(p,1)})}getSocketFactory(R){return(this.factories[R.type]||[]).find(p=>p.supports(R))}connect(R,b,p,w){const A=this.getSocketFactory(R);if(!A)throw new Error(`No socket factory found for ${R}`);return A.connect(R,b,p,w)}}e.RemoteSocketFactoryService=L}),define(ye[268],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class c{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(L){try{const T=await this.getValidator();if(T){const R=String(c._nextId++);return this.validators.set(R,T),{id:R,data:T.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,T){if(!L.id)return!0;const R=this.validators.get(L.id);if(!R)return!1;this.validators.delete(L.id);try{return R.validate(T)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(L){try{return await this.signValue(L)}catch{}return L}}e.AbstractSignService=c}),define(ye[110],_e([1,0,5]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,c.createDecorator)(e.SIGN_SERVICE_ID)}),define(ye[141],_e([1,0,268]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class O extends c.AbstractSignService{getValidator(){return this.vsda().then(T=>new T.validator)}signValue(T){return this.vsda().then(R=>new R.signer().sign(T))}vsda(){return new Promise((T,R)=>de(["vsda"],T,R))}}e.SignService=O}),define(ye[269],_e([1,0,11,50,30]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=R,e.verifyMicrosoftInternalDomain=b;function T(p){if(c.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}function R(p,w,A,I,v,C,S,a,m){const o=Object.create(null);o["common.machineId"]=C,o["common.sqmId"]=S,o.sessionID=(0,L.generateUuid)()+Date.now(),o.commitHash=I,o.version=v,o["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,c.PlatformToString)(c.platform),o["common.nodePlatform"]=O.platform,o["common.nodeArch"]=A,o["common.product"]=m||"desktop",a&&(o["common.msftInternal"]=a);let n=0;const i=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),c.isLinuxSnap&&(o["common.snap"]="true");const r=T(w);return r&&(o["common.platformDetail"]=r),o}function b(p){const w=O.env.USERDNSDOMAIN;if(!w)return!1;const A=w.toLowerCase();return p.some(I=>A===I)}}),define(ye[270],_e([1,0,5]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,c.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,c.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var L;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ye[87],_e([1,0,24,18,86,269,270]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=A,e.isLoggingOnly=I,e.getTelemetryLevel=v,e.validateTelemetryData=C,e.cleanRemoteAuthority=a,e.isInternalTelemetry=o,e.getPiiPathsFromEnvironment=n,e.cleanData=s;class b{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=b;class p{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class w{async publicLog(f,h,l){}async publicLogError(f,h,l){}}e.NullEndpointTelemetryService=w,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}function I(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function v(t){const f=t.getValue(R.TELEMETRY_SETTING_ID),h=t.getValue(R.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function C(t){const f={},h={},l={};m(t,l);for(let u in l){u=u.length>150?u.substr(u.length-149):u;const d=l[u];typeof d=="number"?h[u]=d:typeof d=="boolean"?h[u]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${d.length}`),f[u]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(f[u]=d)}return{properties:f,measurements:h}}const S=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(t){if(!t)return"none";const f=(0,L.getRemoteName)(t);return S.has(f)?f:"other"}function m(t,f,h=0,l){if(t)for(const u of Object.getOwnPropertyNames(t)){const d=t[u],g=l?l+u:u;Array.isArray(d)?f[g]=(0,c.safeStringify)(d):d instanceof Date?f[g]=d.toISOString():(0,O.isObject)(d)?h<2?m(d,f,h+1,g+"."):f[g]=(0,c.safeStringify)(d):f[g]=d}}function o(t,f){const h=t.msftInternalDomains||[],l=f.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(h)||l}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let h=t;const l=[];for(const D of f)for(;;){const E=D.exec(t);if(!E)break;l.push([E.index,D.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(h="";;){const D=d.exec(t);if(!D)break;const E=l.some(([_,y])=>D.index<y&&_<d.lastIndex);!u.test(D[0])&&!E&&(h+=t.substring(g,D.index)+"<REDACTED: user-file-path>",g=d.lastIndex)}return g<t.length&&(h+=t.substr(g)),h}function r(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of f)if(h.regex.test(t))return`<REDACTED: ${h.label}>`;return t}function s(t,f){return(0,c.cloneAndChange)(t,h=>{if(h instanceof b||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let l=h.replaceAll("%20"," ");l=i(l,f);for(const u of f)l=l.replace(u,"");return l=r(l),l}})}}),define(ye[271],_e([1,0,14,137,25,11,2,13,50,87]),function(de,e,c,O,L,T,R,b,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=A,e.getIdAndVersion=S,e.getExtensionId=a,e.adoptToGalleryExtensionId=m,e.getGalleryExtensionId=o,e.groupByExtension=n,e.getLocalExtensionTelemetryData=i,e.getGalleryExtensionTelemetryData=r,e.getExtensionDependencies=s,e.computeTargetPlatform=f;function A(h,l){return h.uuid&&l.uuid?h.uuid===l.uuid:h.id===l.id?!0:(0,c.compareIgnoreCase)(h.id,l.id)===0}const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(l){const u=l.manifest?l.manifest.version:l.version,d=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new v(l.identifier,u,d)}static parse(l){const u=I.exec(l);return u&&u[1]&&u[2]?new v({id:u[1]},u[2],u[4]||void 0):null}constructor(l,u,d="undefined"){this.version=u,this.targetPlatform=d,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof v?A(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.ExtensionKey=v;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(h){const l=C.exec(h);return l&&l[1]?[m(l[1]),l[2]]:[m(h),void 0]}function a(h,l){return`${h}.${l}`}function m(h){return h.toLowerCase()}function o(h,l){return m(a(h??L.UNDEFINED_PUBLISHER,l))}function n(h,l){const u=[],d=g=>{for(const D of u)if(D.some(E=>A(l(E),l(g))))return D;return null};for(const g of h){const D=d(g);D?D.push(g):u.push([g])}return u}function i(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}function r(h){return{id:new w.TelemetryTrustedValue(h.identifier.id),name:new w.TelemetryTrustedValue(h.name),galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),isSigned:h.isSigned,...h.telemetryData}}e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function s(h,l){const u=[],d=l.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const g=d.shift();if(g&&u.every(D=>!A(D.identifier,{id:g}))){const D=h.filter(E=>A(E.identifier,{id:g}));D.length===1&&(u.push(D[0]),d.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}async function t(h,l){if(!T.isLinux)return!1;let u;try{u=(await h.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await h.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(g){l.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(g))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(h,l){const u=await t(h,l),d=(0,O.getTargetPlatform)(u?"alpine":T.platform,p.arch);return l.debug("ComputeTargetPlatform:",d),d}}),define(ye[272],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=c,e.serializeEnvironmentDescriptionMap=O,e.deserializeEnvironmentVariableCollection=L,e.deserializeEnvironmentDescriptionMap=T,e.serializeEnvironmentVariableCollections=R,e.deserializeEnvironmentVariableCollections=b;function c(p){return[...p.entries()]}function O(p){return p?[...p.entries()]:[]}function L(p){return new Map(p)}function T(p){return new Map(p??[])}function R(p){return Array.from(p.entries()).map(w=>[w[0],c(w[1].map),O(w[1].descriptionMap)])}function b(p){return new Map(p.map(w=>[w[0],{map:L(w[1]),descriptionMap:T(w[2])}]))}}),define(ye[273],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(L){this._callback=L,this._terminalBufferMap=new Map}dispose(){for(const L of this._terminalBufferMap.values())L.dispose()}startBuffering(L,T,R=5){const b=T(p=>{const w=typeof p=="string"?p:p.data;let A=this._terminalBufferMap.get(L);if(A){A.data.push(w);return}const I=setTimeout(()=>this.flushBuffer(L),R);A={data:[w],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(L),b.dispose()}},this._terminalBufferMap.set(L,A)});return b}stopBuffering(L){this._terminalBufferMap.get(L)?.dispose()}flushBuffer(L){const T=this._terminalBufferMap.get(L);T&&(this._terminalBufferMap.delete(L),this._callback(L,T.data.join("")))}}e.TerminalDataBufferer=c}),define(ye[274],_e([1,0,8,78,99,56,4,18,2,215,109,37]),function(de,e,c,O,L,T,R,b,p,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.registerIcon=m,e.getIconRegistry=o,e.Extensions={IconContribution:"base.contributions.icons"};var v;(function(s){function t(f,h){let l=f.defaults;for(;T.ThemeIcon.isThemeIcon(l);){const u=a.getIcon(l.id);if(!u)return;l=u.defaults}return l}s.getDefinition=t})(v||(e.IconContribution=v={}));var C;(function(s){function t(h){return{weight:h.weight,style:h.style,src:h.src.map(l=>({format:l.format,location:l.location.toString()}))}}s.toJSONObject=t;function f(h){const l=u=>(0,b.isString)(u)?u:void 0;if(h&&Array.isArray(h.src)&&h.src.every(u=>(0,b.isString)(u.format)&&(0,b.isString)(u.location)))return{weight:l(h.weight),style:l(h.style),src:h.src.map(u=>({format:u.format,location:p.URI.parse(u.location)}))}}s.fromJSONObject=f})(C||(e.IconFontDefinition=C={}));class S{constructor(){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,w.localize)(0,null)},fontCharacter:{type:"string",description:(0,w.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${T.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(t,f,h,l){const u=this.iconsById[t];if(u){if(h&&!u.description){u.description=h,this.iconSchema.properties[t].markdownDescription=`${h} $(${t})`;const D=this.iconReferenceSchema.enum.indexOf(t);D!==-1&&(this.iconReferenceSchema.enumDescriptions[D]=h),this._onDidChange.fire()}return u}const d={id:t,description:h,defaults:f,deprecationMessage:l};this.iconsById[t]=d;const g={$ref:"#/definitions/icons"};return l&&(g.deprecationMessage=l),h&&(g.markdownDescription=`${h}: $(${t})`),this.iconSchema.properties[t]=g,this.iconReferenceSchema.enum.push(t),this.iconReferenceSchema.enumDescriptions.push(h||""),this._onDidChange.fire(),{id:t}}deregisterIcon(t){delete this.iconsById[t],delete this.iconSchema.properties[t];const f=this.iconReferenceSchema.enum.indexOf(t);f!==-1&&(this.iconReferenceSchema.enum.splice(f,1),this.iconReferenceSchema.enumDescriptions.splice(f,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(t=>this.iconsById[t])}getIcon(t){return this.iconsById[t]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(t,f){const h=this.iconFontsById[t];return h||(this.iconFontsById[t]=f,this._onDidChange.fire(),f)}deregisterIconFont(t){delete this.iconFontsById[t]}getIconFont(t){return this.iconFontsById[t]}toString(){const t=(u,d)=>u.id.localeCompare(d.id),f=u=>{for(;T.ThemeIcon.isThemeIcon(u.defaults);)u=this.iconsById[u.defaults.id];return`codicon codicon-${u?u.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.iconsById).map(u=>this.iconsById[u]);for(const u of l.filter(d=>!!d.description).sort(t))h.push(`|<i class="${f(u)}"></i>|${u.id}|${T.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const u of l.filter(d=>!T.ThemeIcon.isThemeIcon(d.defaults)).sort(t))h.push(`|<i class="${f(u)}"></i>|${u.id}|`);return h.join(`
`)}}const a=new S;I.Registry.add(e.Extensions.IconContribution,a);function m(s,t,f,h){return a.registerIcon(s,t,f,h)}function o(){return a}function n(){const s=(0,L.getCodiconFontCharacters)();for(const t in s){const f="\\"+s[t].toString(16);a.registerIcon(t,{fontCharacter:f})}}n(),e.iconsSchemaId="vscode://schemas/icons";const i=I.Registry.as(A.Extensions.JSONContribution);i.registerSchema(e.iconsSchemaId,a.getIconSchema());const r=new c.RunOnceScheduler(()=>i.notifySchemaChanged(e.iconsSchemaId),200);a.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.widgetClose=m("widget-close",O.Codicon.close,(0,w.localize)(2,null)),e.gotoPreviousLocation=m("goto-previous-location",O.Codicon.arrowUp,(0,w.localize)(3,null)),e.gotoNextLocation=m("goto-next-location",O.Codicon.arrowDown,(0,w.localize)(4,null)),e.syncing=T.ThemeIcon.modify(O.Codicon.sync,"spin"),e.spinningLoading=T.ThemeIcon.modify(O.Codicon.loading,"spin")}),define(ye[88],_e([1,0,4,2,53,5,12]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=w,e.extractLocalHostUriMetaDataForPortMapping=I,e.extractQueryLocalHostUriMetaDataForPortMapping=v,e.isLocalhost=C,e.isAllInterfaces=S,e.isPortPrivileged=a,e.ITunnelService=(0,T.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,T.createDecorator)("sharedTunnelsService");var b;(function(n){n.Http="http",n.Https="https"})(b||(e.TunnelProtocol=b={}));var p;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(p||(e.TunnelPrivacyId=p={}));function w(n){return!!n.forwardPort}var A;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function I(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function v(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const r of i){const s=r.split("=")[1];if(/^https?:/.exec(s)){const t=I(O.URI.parse(s));if(t)return t}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(n){return e.LOCALHOST_ADDRESSES.indexOf(n)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(n){return e.ALL_INTERFACES_ADDRESSES.indexOf(n)>=0}function a(n,i,r,s){if(r===1)return!1;if(r===2&&S(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class m{constructor(i,r,s){this.remoteAddress=i,this.localAddress=r,this._dispose=s,this._onDispose=new c.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=m;let o=class{constructor(i,r){this.logService=i,this.configurationService=r,this._onTunnelOpened=new c.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new c.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new c.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const i=this.configurationService.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this._tunnelProvider=i,i?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this._canElevate=i.elevation,this._privacyOptions=i.privacyOptions,this._canChangeProtocol=i.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const i=[],r=Array.from(this._tunnels.values());for(const s of r){const t=Array.from(s.values());for(const f of t){const h=await f.value;h&&typeof h!="string"&&i.push(h)}}return i}async dispose(){for(const i of this._tunnels.values()){for(const{value:r}of i.values())await r.then(s=>typeof s!="string"?s?.dispose():void 0);i.clear()}this._tunnels.clear()}setEnvironmentTunnel(i,r,s,t,f){this.addTunnelToMap(i,r,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:r,localAddress:s,privacy:t,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,r){(S(i)||C(i))&&(i=e.LOCALHOST_ADDRESSES[0]);const s=this.getTunnelFromMap(i,r);if(s)return++s.refcount,s.value}openTunnel(i,r,s,t,f,h=!1,l,u){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${s} on local port ${f}.`);const d=this._tunnelProvider??i;if(!d)return;if(r||(r="localhost"),t||(t=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(s)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const g=this.retainOrCreateTunnel(d,r,s,t,f,h,l,u);return g?g.then(D=>{if(D){if(typeof D=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(r,s),D}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(r,s);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.makeTunnel(D);return(D.tunnelRemoteHost!==r||D.tunnelRemotePort!==s)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&D.privacy!==l&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(E),E}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),g)}makeTunnel(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const r=this._tunnels.get(i.tunnelRemoteHost);if(r){const s=r.get(i.tunnelRemotePort);s&&(s.refcount--,await this.tryDisposeTunnel(i.tunnelRemoteHost,i.tunnelRemotePort,s))}}}}async tryDisposeTunnel(i,r,s){if(s.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${r}.`);const t=s.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(i)&&this._tunnels.get(i).delete(r),t}}async closeTunnel(i,r){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${r} `);const s=this._tunnels.get(i);if(s&&s.has(r)){const t=s.get(r);t.refcount=0,await this.tryDisposeTunnel(i,r,t)}}addTunnelToMap(i,r,s){this._tunnels.has(i)||this._tunnels.set(i,new Map),this._tunnels.get(i).set(r,{refcount:1,value:s})}async removeEmptyOrErrorTunnelFromMap(i,r){const s=this._tunnels.get(i);if(s){const t=s.get(r),f=t?await t.value:void 0;(!f||typeof f=="string")&&s.delete(r),s.size===0&&this._tunnels.delete(i)}}getTunnelFromMap(i,r){const s=[i];C(i)?(s.push(...e.LOCALHOST_ADDRESSES),s.push(...e.ALL_INTERFACES_ADDRESSES)):S(i)&&s.push(...e.ALL_INTERFACES_ADDRESSES);const t=s.map(f=>this._tunnels.get(f));for(const f of t){const h=f?.get(r);if(h)return h}}canTunnel(i){return!!I(i)}createWithProvider(i,r,s,t,f,h,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${s} on local port ${t}.`);const u=s;this._factoryInProgress.add(u);const d=t===void 0?s:t,g={elevationRequired:f?this.isPortPrivileged(d):!1},D={remoteAddress:{host:r,port:s},localAddressPort:t,privacy:h,public:h?h!==p.Private:void 0,protocol:l},E=i.forwardPort(D,g);return E?(this.addTunnelToMap(r,s,E),E.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),E}};e.AbstractTunnelService=o,e.AbstractTunnelService=o=Ge([Ue(0,R.ILogService),Ue(1,L.IConfigurationService)],o)}),define(ye[275],_e([1,0,5]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,c.createDecorator)("IUriIdentityService")}),define(ye[276],_e([1,0,5]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,c.createDecorator)("editSessionIdentityService");var O;(function(L){L[L.Complete=100]="Complete",L[L.Partial=50]="Partial",L[L.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(ye[277],_e([1,0,15]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualResource=O,e.getVirtualWorkspaceLocation=L,e.getVirtualWorkspaceScheme=T,e.getVirtualWorkspaceAuthority=R,e.isVirtualWorkspace=b;function O(p){return p.scheme!==c.Schemas.file&&p.scheme!==c.Schemas.vscodeRemote}function L(p){if(p.folders.length)return p.folders.every(w=>O(w.uri))?p.folders[0].uri:void 0;if(p.configuration&&O(p.configuration))return p.configuration}function T(p){return L(p)?.scheme}function R(p){return L(p)?.authority}function b(p){return L(p)!==void 0}}),define(ye[42],_e([1,0,217,17,77,23,2,5,15]),function(de,e,c,O,L,T,R,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=w,e.isEmptyWorkspaceIdentifier=A,e.toWorkspaceIdentifier=I,e.isWorkspaceIdentifier=v,e.reviveIdentifier=C,e.isWorkspace=a,e.isWorkspaceFolder=m,e.toWorkspaceFolder=i,e.isUntitledWorkspace=r,e.isTemporaryWorkspace=s,e.isStandaloneEditorWorkspace=t,e.isSavedWorkspace=f,e.hasWorkspaceFileExtension=h,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function w(l){const u=l;return typeof u?.id=="string"&&R.URI.isUri(u.uri)}function A(l){return typeof l?.id=="string"&&!w(l)&&!v(l)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function I(l,u){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,O.basename)(l)}:u?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const d=l;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}function v(l){const u=l;return typeof u?.id=="string"&&R.URI.isUri(u.configPath)}function C(l){const u=l;if(u?.uri)return{id:u.id,uri:R.URI.revive(u.uri)};const d=l;if(d?.configPath)return{id:d.id,configPath:R.URI.revive(d.configPath)};if(l?.id)return{id:l.id}}var S;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function a(l){const u=l;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}function m(l){const u=l;return!!(u&&typeof u=="object"&&R.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}class o{constructor(u,d,g,D,E){this._id=u,this._transient=g,this._configuration=D,this._ignorePathCasing=E,this._foldersMap=L.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=d}update(u){this._id=u.id,this._configuration=u.configuration,this._transient=u.transient,this._ignorePathCasing=u._ignorePathCasing,this.folders=u.folders}get folders(){return this._folders}set folders(u){this._folders=u,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(u){this._configuration=u}getFolder(u){return u&&this._foldersMap.findSubstr(u)||null}updateFoldersMap(){this._foldersMap=L.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const u of this.folders)this._foldersMap.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=o;class n{constructor(u,d){this.raw=d,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,T.joinPath)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function i(l){return new n({uri:l,index:0,name:(0,T.basenameOrAuthority)(l)},{uri:l.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,c.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function r(l,u){return T.extUriBiasedIgnorePathCase.isEqualOrParent(l,u.untitledWorkspacesHome)}function s(l){let u;return R.URI.isUri(l)?u=l:u=l.configuration,u?.scheme===p.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function f(l,u){return!r(l,u)&&!s(l)}function h(l){return(typeof l=="string"?(0,O.extname)(l):(0,T.extname)(l))===e.WORKSPACE_SUFFIX}}),define(ye[278],_e([1,0,55,4,3,23,2,216,136,32,5,12,42,27,275,8,30,14,18]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=r,e.reviveProfile=s,e.toUserDataProfile=t;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(l){const u=l;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&typeof u.isDefault=="boolean"&&typeof u.name=="string"&&R.URI.isUri(u.location)&&R.URI.isUri(u.globalStorageHome)&&R.URI.isUri(u.settingsResource)&&R.URI.isUri(u.keybindingsResource)&&R.URI.isUri(u.tasksResource)&&R.URI.isUri(u.snippetsHome)&&R.URI.isUri(u.extensionsResource))}e.IUserDataProfilesService=(0,A.createDecorator)("IUserDataProfilesService");function s(l,u){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:R.URI.revive(l.location).with({scheme:u}),globalStorageHome:R.URI.revive(l.globalStorageHome).with({scheme:u}),settingsResource:R.URI.revive(l.settingsResource).with({scheme:u}),keybindingsResource:R.URI.revive(l.keybindingsResource).with({scheme:u}),tasksResource:R.URI.revive(l.tasksResource).with({scheme:u}),snippetsHome:R.URI.revive(l.snippetsHome).with({scheme:u}),extensionsResource:R.URI.revive(l.extensionsResource).with({scheme:u}),cacheHome:R.URI.revive(l.cacheHome).with({scheme:u}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function t(l,u,d,g,D,E){return{id:l,name:u,location:d,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:E&&D?.useDefaultFlags?.globalState?E.globalStorageHome:(0,T.joinPath)(d,"globalStorage"),settingsResource:E&&D?.useDefaultFlags?.settings?E.settingsResource:(0,T.joinPath)(d,"settings.json"),keybindingsResource:E&&D?.useDefaultFlags?.keybindings?E.keybindingsResource:(0,T.joinPath)(d,"keybindings.json"),tasksResource:E&&D?.useDefaultFlags?.tasks?E.tasksResource:(0,T.joinPath)(d,"tasks.json"),snippetsHome:E&&D?.useDefaultFlags?.snippets?E.snippetsHome:(0,T.joinPath)(d,"snippets"),extensionsResource:E&&D?.useDefaultFlags?.extensions?E.extensionsResource:(0,T.joinPath)(d,"extensions.json"),cacheHome:(0,T.joinPath)(g,l),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let f=class extends L.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(u,d,g,D){super(),this.environmentService=u,this.fileService=d,this.uriIdentityService=g,this.logService=D,this.enabled=!0,this._onDidChangeProfiles=this._register(new O.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new O.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new O.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new O.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new C.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,T.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,T.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(u){this.enabled!==u&&(this._profilesObject=void 0,this.enabled=u)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const u=this.createDefaultProfile(),d=[u];if(this.enabled)try{for(const E of this.getStoredProfiles()){if(!E.name||!(0,n.isString)(E.name)||!E.location){this.logService.warn("Skipping the invalid stored profile",E.location||E.name);continue}d.push(t((0,T.basename)(E.location),E.name,E.location,this.profilesCacheHome,{shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags},u))}}catch(E){this.logService.error(E)}const g=new C.ResourceMap,D=new Map;if(d.length)try{const E=this.getStoredProfileAssociations();if(E.workspaces)for(const[_,y]of Object.entries(E.workspaces)){const P=R.URI.parse(_),k=d.find(z=>z.id===y);k&&g.set(P,k)}if(E.emptyWindows)for(const[_,y]of Object.entries(E.emptyWindows)){const P=d.find(k=>k.id===y);P&&D.set(_,P)}}catch(E){this.logService.error(E)}this._profilesObject={profiles:d,workspaces:g,emptyWindows:D}}return this._profilesObject}createDefaultProfile(){const u=t("__default__profile__",(0,b.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...u,extensionsResource:this.getDefaultProfileExtensionsLocation()??u.extensionsResource,isDefault:!0}}async createTransientProfile(u){const d="Temp",g=new RegExp(`${(0,o.escapeRegExpCharacters)(d)}\\s(\\d+)`);let D=0;for(const _ of this.profiles){const y=g.exec(_.name),P=y?parseInt(y[1]):0;D=P>D?P:D}const E=`${d} ${D+1}`;return this.createProfile((0,c.hash)((0,m.generateUuid)()).toString(16),E,{transient:!0},u)}async createNamedProfile(u,d,g){return this.createProfile((0,c.hash)((0,m.generateUuid)()).toString(16),u,d,g)}async createProfile(u,d,g,D){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const E=await this.doCreateProfile(u,d,g);return D&&await this.setProfileForWorkspace(D,E),E}async doCreateProfile(u,d,g){if(!(0,n.isString)(d)||!d)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.profileCreationPromises.get(d);return D||(D=(async()=>{try{const E=this.profiles.find(P=>P.name===d||P.id===u);if(E)return E;const _=t(u,d,(0,T.joinPath)(this.profilesHome,u),this.profilesCacheHome,g,this.defaultProfile);await this.fileService.createFolder(_.location);const y=[];return this._onWillCreateProfile.fire({profile:_,join(P){y.push(P)}}),await a.Promises.settled(y),this.updateProfiles([_],[],[]),_}finally{this.profileCreationPromises.delete(d)}})(),this.profileCreationPromises.set(d,D)),D}async updateProfile(u,d){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let g=this.profiles.find(D=>D.id===u.id);if(!g)throw new Error(`Profile '${u.name}' does not exist`);return g=t(g.id,d.name??g.name,g.location,this.profilesCacheHome,{shortName:d.shortName??g.shortName,icon:d.icon===null?void 0:d.icon??g.icon,transient:d.transient??g.isTransient,useDefaultFlags:d.useDefaultFlags??g.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[g]),g}async removeProfile(u){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(u.isDefault)throw new Error("Cannot remove default profile");const d=this.profiles.find(D=>D.id===u.id);if(!d)throw new Error(`Profile '${u.name}' does not exist`);const g=[];this._onWillRemoveProfile.fire({profile:d,join(D){g.push(D)}});try{await Promise.allSettled(g)}catch(D){this.logService.error(D)}for(const D of[...this.profilesObject.emptyWindows.keys()])d.id===this.profilesObject.emptyWindows.get(D)?.id&&this.profilesObject.emptyWindows.delete(D);for(const D of[...this.profilesObject.workspaces.keys()])d.id===this.profilesObject.workspaces.get(D)?.id&&this.profilesObject.workspaces.delete(D);this.updateStoredProfileAssociations(),this.updateProfiles([],[d],[]);try{await this.fileService.del(d.cacheHome,{recursive:!0})}catch(D){(0,w.toFileOperationResult)(D)!==1&&this.logService.error(D)}}async setProfileForWorkspace(u,d){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const g=this.profiles.find(D=>D.id===d.id);if(!g)throw new Error(`Profile '${d.name}' does not exist`);this.updateWorkspaceAssociation(u,g)}unsetWorkspace(u,d){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(u,void 0,d)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const u=await this.fileService.resolve(this.profilesHome);await Promise.all((u.children||[]).filter(d=>d.isDirectory&&this.profiles.every(g=>!this.uriIdentityService.extUri.isEqual(g.location,d.resource))).map(d=>this.fileService.del(d.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const u=this.transientProfilesObject.profiles.filter(d=>!this.isProfileAssociatedToWorkspace(d));await Promise.allSettled(u.map(d=>this.removeProfile(d)))}getProfileForWorkspace(u){const d=this.getWorkspace(u);return R.URI.isUri(d)?this.transientProfilesObject.workspaces.get(d)??this.profilesObject.workspaces.get(d):this.transientProfilesObject.emptyWindows.get(d)??this.profilesObject.emptyWindows.get(d)}getWorkspace(u){return(0,v.isSingleFolderWorkspaceIdentifier)(u)?u.uri:(0,v.isWorkspaceIdentifier)(u)?u.configPath:u.id}isProfileAssociatedToWorkspace(u){return!!([...this.transientProfilesObject.emptyWindows.values()].some(d=>this.uriIdentityService.extUri.isEqual(d.location,u.location))||[...this.transientProfilesObject.workspaces.values()].some(d=>this.uriIdentityService.extUri.isEqual(d.location,u.location))||[...this.profilesObject.emptyWindows.values()].some(d=>this.uriIdentityService.extUri.isEqual(d.location,u.location))||[...this.profilesObject.workspaces.values()].some(d=>this.uriIdentityService.extUri.isEqual(d.location,u.location)))}updateProfiles(u,d,g){const D=[...this.profiles,...u],E=[];this.transientProfilesObject.profiles=[];for(let _ of D)_.isDefault||d.some(y=>_.id===y.id)||(_=g.find(y=>_.id===y.id)??_,_.isTransient?this.transientProfilesObject.profiles.push(_):E.push({location:_.location,name:_.name,shortName:_.shortName,icon:_.icon,useDefaultFlags:_.useDefaultFlags}));this.saveStoredProfiles(E),this._profilesObject=void 0,this.triggerProfilesChanges(u,d,g)}triggerProfilesChanges(u,d,g){this._onDidChangeProfiles.fire({added:u,removed:d,updated:g,all:this.profiles})}updateWorkspaceAssociation(u,d,g){g=d?.isTransient?!0:g,g||this.updateWorkspaceAssociation(u,void 0,!0);const D=this.getWorkspace(u),E=g?this.transientProfilesObject:this.profilesObject;R.URI.isUri(D)?(E.workspaces.delete(D),d&&E.workspaces.set(D,d)):(E.emptyWindows.delete(D),d&&E.emptyWindows.set(D,d)),g||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const u={};for(const[g,D]of this.profilesObject.workspaces.entries())u[g.toString()]=D.id;const d={};for(const[g,D]of this.profilesObject.emptyWindows.entries())d[g.toString()]=D.id;this.saveStoredProfileAssociations({workspaces:u,emptyWindows:d}),this._profilesObject=void 0}migrateStoredProfileAssociations(u){const d={},g=this.createDefaultProfile();if(u.workspaces)for(const[E,_]of Object.entries(u.workspaces)){const y=R.URI.parse(_);d[E]=this.uriIdentityService.extUri.isEqual(y,g.location)?g.id:this.uriIdentityService.extUri.basename(y)}const D={};if(u.emptyWindows)for(const[E,_]of Object.entries(u.emptyWindows)){const y=R.URI.parse(_);D[E]=this.uriIdentityService.extUri.isEqual(y,g.location)?g.id:this.uriIdentityService.extUri.basename(y)}return{workspaces:d,emptyWindows:D}}getStoredProfiles(){return[]}saveStoredProfiles(u){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(u){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=f,e.UserDataProfilesService=f=Ge([Ue(0,p.IEnvironmentService),Ue(1,w.IFileService),Ue(2,S.IUriIdentityService),Ue(3,I.ILogService)],f);class h extends f{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(u){this.storedProfiles=u}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(u){this.storedProfileAssociations=u}}e.InMemoryUserDataProfilesService=h}),define(ye[279],_e([1,0,8,4,3,58,18,195,5,278]),function(de,e,c,O,L,T,R,b,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=C,e.isProfileUsingDefaultStorage=a,e.logStorage=o,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,p.createDecorator)("storageService");var A;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var I;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var v;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function C(n){const i=n.get(e.TARGET_KEY);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class S extends L.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(i={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super(),this.options=i,this._onDidChangeValue=this._register(new O.PauseableEmitter),this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new c.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(i,r,s){return O.Event.filter(this._onDidChangeValue.event,t=>t.scope===i&&(r===void 0||t.key===r),s)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,c.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(i,r){const{key:s,external:t}=r;if(s===e.TARGET_KEY){switch(i){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:i})}else this._onDidChangeValue.fire({scope:i,key:s,target:this.getKeyTargets(i)[s],external:t})}emitWillSaveState(i){this._onWillSaveState.fire({reason:i})}get(i,r,s){return this.getStorage(r)?.get(i,s)}getBoolean(i,r,s){return this.getStorage(r)?.getBoolean(i,s)}getNumber(i,r,s){return this.getStorage(r)?.getNumber(i,s)}getObject(i,r,s){return this.getStorage(r)?.getObject(i,s)}storeAll(i,r){this.withPausedEmitters(()=>{for(const s of i)this.store(s.key,s.value,s.scope,s.target,r)})}store(i,r,s,t,f=!1){if((0,R.isUndefinedOrNull)(r)){this.remove(i,s,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(i,s,t),this.getStorage(s)?.set(i,r,f)})}remove(i,r,s=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(i,r,void 0),this.getStorage(r)?.delete(i,s)})}withPausedEmitters(i){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{i()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(i,r){const s=[],t=this.getKeyTargets(i);for(const f of Object.keys(t))t[f]===r&&s.push(f);return s}updateKeyTarget(i,r,s,t=!1){const f=this.getKeyTargets(r);typeof s=="number"?f[i]!==s&&(f[i]=s,this.getStorage(r)?.set(e.TARGET_KEY,JSON.stringify(f),t)):typeof f[i]=="number"&&(delete f[i],this.getStorage(r)?.set(e.TARGET_KEY,JSON.stringify(f),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(i){switch(i){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(i){const r=this.getStorage(i);return r?C(r):Object.create(null)}isNew(i){return this.getBoolean(e.IS_NEW_KEY,i)===!0}async flush(i=A.NONE){this._onWillSaveState.fire({reason:i});const r=this.getStorage(-1),s=this.getStorage(0),t=this.getStorage(1);switch(i){case A.NONE:await c.Promises.settled([r?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await c.Promises.settled([r?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.getStorage(-1)?.items??new Map,r=this.getStorage(0)?.items??new Map,s=this.getStorage(1)?.items??new Map;return o(i,r,s,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(i){return await this.flush(),this.getStorage(i)?.optimize()}async switch(i,r){return this.emitWillSaveState(A.NONE),(0,w.isUserDataProfile)(i)?this.switchToProfile(i,r):this.switchToWorkspace(i,r)}canSwitchProfile(i,r){return!(i.id===r.id||a(r)&&a(i))}switchData(i,r,s){this.withPausedEmitters(()=>{const t=new Set;for(const[f,h]of i)t.add(f),r.get(f)!==h&&this.emitDidChangeValue(s,{key:f,external:!0});for(const[f]of r.items)t.has(f)||this.emitDidChangeValue(s,{key:f,external:!0})})}}e.AbstractStorageService=S;function a(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class m extends S{constructor(){super(),this.applicationStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(i=>this.emitDidChangeValue(1,i))),this._register(this.profileStorage.onDidChangeStorage(i=>this.emitDidChangeValue(0,i))),this._register(this.applicationStorage.onDidChangeStorage(i=>this.emitDidChangeValue(-1,i)))}getStorage(i){switch(i){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(i){return!1}}e.InMemoryStorageService=m;async function o(n,i,r,s,t,f){const h=P=>{try{return JSON.parse(P)}catch{return P}},l=new Map,u=new Map;n.forEach((P,k)=>{l.set(k,P),u.set(k,h(P))});const d=new Map,g=new Map;i.forEach((P,k)=>{d.set(k,P),g.set(k,h(P))});const D=new Map,E=new Map;r.forEach((P,k)=>{D.set(k,P),E.set(k,h(P))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const _=[];if(l.forEach((P,k)=>{_.push({key:k,value:P})}),console.table(_),console.groupEnd(),console.log(u),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];d.forEach((k,z)=>{P.push({key:z,value:k})}),console.table(P),console.groupEnd(),console.log(g)}console.group(`Storage: Workspace (path: ${f})`);const y=[];D.forEach((P,k)=>{y.push({key:k,value:P})}),console.table(y),console.groupEnd(),console.log(E)}}),define(ye[111],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{static{this.enableDebugLogging=!1}constructor(L){this.id=L,this._data=new Map,this._idPool=1}add(L){const T=this._idPool++;return this._data.set(T,L),this.logDebugInfo(),T}get(L,T){return this._data.has(L)?this._data.get(L)[T]:void 0}delete(L){this._data.delete(L),this.logDebugInfo()}logDebugInfo(){c.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=c}),define(ye[59],_e([1,0,15,23,5]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(c.Schemas)),this._providerInfo=new Map,this.extUri=new O.ExtUri(b=>{const p=this._providerInfo.get(b.scheme);return!(p===void 0||p&1024)})}$acceptProviderInfos(b,p){p===null?this._providerInfo.delete(b.scheme):this._providerInfo.set(b.scheme,p)}isFreeScheme(b){return!this._providerInfo.has(b)&&!this._systemSchemes.has(b)}getCapabilities(b){return this._providerInfo.get(b)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,L.createDecorator)("IExtHostFileSystemInfo")}),define(ye[28],_e([1,0,5]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(ye[280],_e([1,0,223,12,260,28]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends L.LogService{constructor(p,w,A){const I=A.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",v=A.remote.isRemote?(0,c.localize)(0,null):p?(0,c.localize)(1,null):(0,c.localize)(2,null);super(w.createLogger(I,{name:v}))}};e.ExtHostLogService=R,e.ExtHostLogService=R=Ge([Ue(1,O.ILoggerService),Ue(2,T.IExtHostInitDataService)],R)}),define(ye[281],_e([1,0,8]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class O{constructor(R,b,p){this._deferredPromises=new Map,this._id=R,this._shared=b,this._storage=p,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(w=>(this._value=w,this)),this._storageListener=this._storage.onDidChangeStorage(w=>{w.shared===this._shared&&w.key===this._id&&(this._value=w.value)}),this._scheduler=new c.RunOnceScheduler(()=>{const w=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const A of w.values())A.complete()}catch(A){for(const I of w.values())I.error(A)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,b){let p=this._value[R];return typeof p>"u"&&(p=b),p}update(R,b){this._value[R]=b;const p=this._deferredPromises.get(R);if(p!==void 0)return p.p;const w=new c.DeferredPromise;return this._deferredPromises.set(R,w),this._scheduler.isScheduled()||this._scheduler.schedule(),w.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=O;class L extends O{setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}constructor(R,b){super(R.identifier.value,!0,b),this._extension=R}}e.ExtensionGlobalMemento=L}),define(ye[282],_e([1,0,4,2]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class L{constructor(R){this._notebooksAndEditors=R,this._onDidSaveNotebookDocument=new c.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new c.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(R,b,p,w){const I=this._notebooksAndEditors.getNotebookDocument(O.URI.revive(R)).acceptModelChanged(b.value,p,w);this._onDidChangeNotebookDocument.fire(I)}$acceptDirtyStateChanged(R,b){this._notebooksAndEditors.getNotebookDocument(O.URI.revive(R)).acceptDirty(b)}$acceptModelSaved(R){const b=this._notebooksAndEditors.getNotebookDocument(O.URI.revive(R));this._onDidSaveNotebookDocument.fire(b.apiNotebook)}}e.ExtHostNotebookDocuments=L}),define(ye[20],_e([1,0,5]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class O{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.dispose=T.dispose.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=O}),define(ye[283],_e([1,0,25,4]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{#e;constructor(R,b){this._onDidChange=new O.Emitter,this.onDidChange=this._onDidChange.event,this._id=c.ExtensionIdentifier.toKey(R.identifier),this.#e=b,this.#e.onDidChangePassword(p=>{p.extensionId===this._id&&this._onDidChange.fire({key:p.key})})}get(R){return this.#e.get(this._id,R)}store(R,b){return this.#e.store(this._id,R,b)}delete(R){return this.#e.delete(this._id,R)}}e.ExtensionSecrets=L}),define(ye[66],_e([1,0,5]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class O{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=O}),define(ye[284],_e([1,0,21]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewMessage=L,e.deserializeWebviewMessage=R;class O{constructor(){this.buffers=[]}add(p){let w=this.buffers.indexOf(p);return w<0&&(w=this.buffers.length,this.buffers.push(p)),w}}function L(b,p){if(p.serializeBuffersForPostMessage){const w=new O,I=JSON.stringify(b,(C,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(S)};if(ArrayBuffer.isView(S)){const a=T(S);if(a)return{$$vscode_array_buffer_reference$$:!0,index:w.add(S.buffer),view:{type:a,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),v=w.buffers.map(C=>{const S=new Uint8Array(C);return c.VSBuffer.wrap(S)});return{message:I,buffers:v}}else return{message:JSON.stringify(b),buffers:[]}}function T(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(b,p){const w=p.map(v=>{const C=new ArrayBuffer(v.byteLength);return new Uint8Array(C).set(v.buffer),C}),A=p.length?(v,C)=>{if(C&&typeof C=="object"&&C.$$vscode_array_buffer_reference$$){const S=C,{index:a}=S,m=w[a];if(S.view)switch(S.view.type){case 1:return new Int8Array(m,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return C}:void 0;return{message:JSON.parse(b,A),arrayBuffers:w}}}),define(ye[285],_e([1,0,286,398,399,62,2,12,400]),function(de,e,c,O,L,T,R,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=A;const w=!1;function A(i,r,s,t,f,h){const l=h.environment.useHostProxy,u=typeof l=="boolean"?l:!h.remote.isRemote,d={resolveProxy:E=>i.resolveProxy(E),lookupProxyAuthorization:m.bind(void 0,t,f,r,{},h.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>v(r),addCertificatesV2:()=>C(r),log:t,getLogLevel:()=>{const E=t.getLevel();switch(E){case b.LogLevel.Trace:return p.LogLevel.Trace;case b.LogLevel.Debug:return p.LogLevel.Debug;case b.LogLevel.Info:return p.LogLevel.Info;case b.LogLevel.Warning:return p.LogLevel.Warning;case b.LogLevel.Error:return p.LogLevel.Error;case b.LogLevel.Off:return p.LogLevel.Off;default:return _(E)}function _(y){return t.error("Unknown log level",y),p.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:u,loadAdditionalCertificates:async()=>{const E=[];if(h.remote.isRemote&&E.push((0,p.loadSystemCertificates)({log:t})),u){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const _=i.loadCertificates();_.then(y=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",y.length)),E.push(_)}return(await Promise.all(E)).flat()},env:process.env},g=(0,p.createProxyResolver)(d),D=I(d,g);return a(s,D)}function I(i,r){return{http:Object.assign(c,(0,p.createHttpPatch)(i,c,r)),https:Object.assign(O,(0,p.createHttpPatch)(i,O,r)),net:Object.assign(T,(0,p.createNetPatch)(i,T)),tls:Object.assign(L,(0,p.createTlsPatch)(i,L))}}function v(i){const r=i.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",w)&&!!r.get("systemCertificates")}function C(i){const r=i.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",w)&&!!r.get("systemCertificates")}const S=new Map;function a(i,r){return i.getExtensionPathIndex().then(s=>{const t=globalThis._VSCODE_NODE_MODULES.module,f=t._load;t._load=function(l,u,d){if(l==="net")return r.net;if(l==="tls")return r.tls;if(l!=="http"&&l!=="https")return f.apply(this,arguments);const g=s.findSubstr(R.URI.file(u.filename));let D=S.get(g);if(D||S.set(g,D={}),!D[l]){const E=r[l];D[l]={...E}}return D[l]}})}async function m(i,r,s,t,f,h,l,u){const d=t[h];l&&(t[h]=l),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${h}`,`proxyAuthenticate:${l}`,`proxyAuthenticateCache:${d}`);const g=l||d,D=Array.isArray(g)?g:typeof g=="string"?[g]:[];if(n(r,D,f),D.some(E=>/^(Negotiate|Kerberos)( |$)/i.test(E))&&!u.kerberosRequested)try{u.kerberosRequested=!0;const E=await new Promise((z,x)=>{de(["kerberos"],z,x)}),_=new URL(h),y=s.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${_.hostname}`:`HTTP@${_.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${h}`,`spn:${y}`),"Negotiate "+await(await E.initializeClient(y)).step("")}catch(E){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",E)}}let o=!1;function n(i,r,s){o||!r.length||(o=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:s?"remote":"local"}))}}),define(ye[287],_e([1,0,133]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=L;function O(T){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:T,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function L(T){return new c.URITransformer(O(T))}}),define(ye[142],_e([1,0,233,18,2,3,5,37,32,15,47,187,40]),function(de,e,c,O,L,T,R,b,p,w,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.EditorResourceAccessor=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.isEditorPaneWithSelection=a,e.isEditorPaneWithScrolling=m,e.findViewStateForEditor=o,e.isResourceEditorInput=n,e.isResourceDiffEditorInput=i,e.isResourceMultiDiffEditorInput=r,e.isResourceSideBySideEditorInput=s,e.isUntitledResourceEditorInput=t,e.isResourceMergeEditorInput=f,e.isEditorInput=D,e.isSideBySideEditorInput=_,e.isDiffEditorInput=y,e.createTooLargeFileError=P,e.isEditorInputWithOptions=k,e.isEditorInputWithOptionsAndGroup=z,e.isEditorIdentifier=x,e.preventEditorClose=Y,e.pathsToEditors=Q,e.isTextEditorViewState=te,e.isEditorOpenError=ve,e.createEditorOpenError=Ie,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var C;(function(J){J[J.PROGRAMMATIC=1]="PROGRAMMATIC",J[J.USER=2]="USER",J[J.EDIT=3]="EDIT",J[J.NAVIGATION=4]="NAVIGATION",J[J.JUMP=5]="JUMP"})(C||(e.EditorPaneSelectionChangeReason=C={}));var S;(function(J){J[J.IDENTICAL=1]="IDENTICAL",J[J.SIMILAR=2]="SIMILAR",J[J.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function a(J){const $=J;return!!$&&typeof $.getSelection=="function"&&!!$.onDidChangeSelection}function m(J){const $=J;return!!$&&typeof $.getScrollPosition=="function"&&typeof $.setScrollPosition=="function"&&!!$.onDidChangeScroll}function o(J,$,ne){for(const be of ne.visibleEditorPanes)if(be.group.id===$&&J.matches(be.input))return be.getViewState()}function n(J){if(D(J))return!1;const $=J;return L.URI.isUri($?.resource)}function i(J){if(D(J))return!1;const $=J;return $?.original!==void 0&&$.modified!==void 0}function r(J){if(D(J))return!1;const $=J;return!$||$.resources&&!Array.isArray($.resources)?!1:!!$.resources||!!$.multiDiffSource}function s(J){if(D(J)||i(J))return!1;const $=J;return $?.primary!==void 0&&$.secondary!==void 0}function t(J){if(D(J))return!1;const $=J;return $?$.resource===void 0||$.resource.scheme===w.Schemas.untitled||$.forceUntitled===!0:!1}function f(J){if(D(J))return!1;const $=J;return L.URI.isUri($?.base?.resource)&&L.URI.isUri($?.input1?.resource)&&L.URI.isUri($?.input2?.resource)&&L.URI.isUri($?.result?.resource)}var h;(function(J){J[J.SHORT=0]="SHORT",J[J.MEDIUM=1]="MEDIUM",J[J.LONG=2]="LONG"})(h||(e.Verbosity=h={}));var l;(function(J){J[J.EXPLICIT=1]="EXPLICIT",J[J.AUTO=2]="AUTO",J[J.FOCUS_CHANGE=3]="FOCUS_CHANGE",J[J.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class u{constructor(){this.mapIdToSaveSource=new Map}registerSource($,ne){let be=this.mapIdToSaveSource.get($);return be||(be={source:$,label:ne},this.mapIdToSaveSource.set($,be)),be.source}getSourceLabel($){return this.mapIdToSaveSource.get($)?.label??$}}e.SaveSourceRegistry=new u;var d;(function(J){J[J.None=0]="None",J[J.Readonly=2]="Readonly",J[J.Untitled=4]="Untitled",J[J.Singleton=8]="Singleton",J[J.RequiresTrust=16]="RequiresTrust",J[J.CanSplitInGroup=32]="CanSplitInGroup",J[J.ForceDescription=64]="ForceDescription",J[J.CanDropIntoEditor=128]="CanDropIntoEditor",J[J.MultipleEditors=256]="MultipleEditors",J[J.Scratchpad=512]="Scratchpad"})(d||(e.EditorInputCapabilities=d={}));class g extends T.Disposable{}e.AbstractEditorInput=g;function D(J){return J instanceof g}function E(J){const $=J;return L.URI.isUri($?.preferredResource)}function _(J){const $=J;return D($?.primary)&&D($?.secondary)}function y(J){const $=J;return D($?.modified)&&D($?.original)}function P(J,$,ne,be,Ce){return Ie(be,[(0,I.toAction)({id:"workbench.action.openLargeFile",label:(0,c.localize)(2,null),run:()=>{const ae={...ne,limits:{size:Number.MAX_VALUE}};J.openEditor($,ae)}}),(0,I.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,c.localize)(3,null),run:()=>Ce.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}function k(J){return D(J?.editor)}function z(J){const $=J;return k(J)&&$?.group!==void 0}function x(J){const $=J;return typeof $?.groupId=="number"&&D($.editor)}var F;(function(J){J[J.UNKNOWN=0]="UNKNOWN",J[J.REPLACE=1]="REPLACE",J[J.MOVE=2]="MOVE",J[J.UNPIN=3]="UNPIN"})(F||(e.EditorCloseContext=F={}));var N;(function(J){J[J.GROUP_ACTIVE=0]="GROUP_ACTIVE",J[J.GROUP_INDEX=1]="GROUP_INDEX",J[J.GROUP_LABEL=2]="GROUP_LABEL",J[J.GROUP_LOCKED=3]="GROUP_LOCKED",J[J.EDITOR_OPEN=4]="EDITOR_OPEN",J[J.EDITOR_CLOSE=5]="EDITOR_CLOSE",J[J.EDITOR_MOVE=6]="EDITOR_MOVE",J[J.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",J[J.EDITOR_LABEL=8]="EDITOR_LABEL",J[J.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",J[J.EDITOR_PIN=10]="EDITOR_PIN",J[J.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",J[J.EDITOR_STICKY=12]="EDITOR_STICKY",J[J.EDITOR_DIRTY=13]="EDITOR_DIRTY",J[J.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var M;(function(J){J[J.PRIMARY=1]="PRIMARY",J[J.SECONDARY=2]="SECONDARY",J[J.BOTH=3]="BOTH",J[J.ANY=4]="ANY"})(M||(e.SideBySideEditor=M={}));class B{getOriginalUri($,ne){if(!$)return;if(f($))return e.EditorResourceAccessor.getOriginalUri($.result,ne);if(ne?.supportSideBySide){const{primary:Ce,secondary:ae}=this.getSideEditors($);if(Ce&&ae){if(ne?.supportSideBySide===M.BOTH)return{primary:this.getOriginalUri(Ce,{filterByScheme:ne.filterByScheme}),secondary:this.getOriginalUri(ae,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===M.ANY)return this.getOriginalUri(Ce,{filterByScheme:ne.filterByScheme})??this.getOriginalUri(ae,{filterByScheme:ne.filterByScheme});$=ne.supportSideBySide===M.PRIMARY?Ce:ae}}if(i($)||r($)||s($)||f($))return;const be=E($)?$.preferredResource:$.resource;return!be||!ne||!ne.filterByScheme?be:this.filterUri(be,ne.filterByScheme)}getSideEditors($){return _($)||s($)?{primary:$.primary,secondary:$.secondary}:y($)||i($)?{primary:$.modified,secondary:$.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($,ne){if(!$)return;if(f($))return e.EditorResourceAccessor.getCanonicalUri($.result,ne);if(ne?.supportSideBySide){const{primary:Ce,secondary:ae}=this.getSideEditors($);if(Ce&&ae){if(ne?.supportSideBySide===M.BOTH)return{primary:this.getCanonicalUri(Ce,{filterByScheme:ne.filterByScheme}),secondary:this.getCanonicalUri(ae,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===M.ANY)return this.getCanonicalUri(Ce,{filterByScheme:ne.filterByScheme})??this.getCanonicalUri(ae,{filterByScheme:ne.filterByScheme});$=ne.supportSideBySide===M.PRIMARY?Ce:ae}}if(i($)||r($)||s($)||f($))return;const be=$.resource;return!be||!ne||!ne.filterByScheme?be:this.filterUri(be,ne.filterByScheme)}filterUri($,ne){if(Array.isArray(ne)){if(ne.some(be=>$.scheme===be))return $}else if(ne===$.scheme)return $}}var W;(function(J){J[J.UNKNOWN=0]="UNKNOWN",J[J.KEYBOARD=1]="KEYBOARD",J[J.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function Y(J,$,ne,be){if(!J.isSticky($))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return ne===W.MOUSE||ne===W.KEYBOARD;case"mouse":return ne===W.MOUSE;case"keyboard":return ne===W.KEYBOARD}return!1}e.EditorResourceAccessor=new B;var Z;(function(J){J[J.LEFT=0]="LEFT",J[J.RIGHT=1]="RIGHT"})(Z||(e.CloseDirection=Z={}));class G{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start($){const ne=this.instantiationService=$.get(R.IInstantiationService);for(const[be,Ce]of this.editorSerializerConstructors)this.createEditorSerializer(be,Ce,ne);this.editorSerializerConstructors.clear()}createEditorSerializer($,ne,be){const Ce=be.createInstance(ne);this.editorSerializerInstances.set($,Ce)}registerFileEditorFactory($){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=$}getFileEditorFactory(){return(0,O.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer($,ne){if(this.editorSerializerConstructors.has($)||this.editorSerializerInstances.has($))throw new Error(`A editor serializer with type ID '${$}' was already registered.`);return this.instantiationService?this.createEditorSerializer($,ne,this.instantiationService):this.editorSerializerConstructors.set($,ne),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete($),this.editorSerializerInstances.delete($)})}getEditorSerializer($){return this.editorSerializerInstances.get(typeof $=="string"?$:$.typeId)}}b.Registry.add(e.EditorExtensions.EditorFactory,new G);async function Q(J,$,ne){return!J||!J.length?[]:await Promise.all(J.map(async be=>{const Ce=L.URI.revive(be.fileUri);if(!Ce){ne.info("Cannot resolve the path because it is not valid.",be);return}if(!await $.canHandleResource(Ce)){ne.info("Cannot resolve the path because it cannot be handled",be);return}let ce=be.exists,se=be.type;if(typeof ce!="boolean"||typeof se!="number")try{se=(await $.stat(Ce)).isDirectory?p.FileType.Directory:p.FileType.Unknown,ce=!0}catch(ie){ne.error(ie),ce=!1}if(!ce&&be.openOnlyIfExists){ne.info("Cannot resolve the path because it does not exist",be);return}if(se===p.FileType.Directory){ne.info("Cannot resolve the path because it is a directory",be);return}const j={...be.options,pinned:!0};return ce?{resource:Ce,options:j}:{resource:Ce,options:j,forceUntitled:!0}}))}var re;(function(J){J[J.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",J[J.SEQUENTIAL=1]="SEQUENTIAL"})(re||(e.EditorsOrder=re={}));function te(J){const $=J;if(!$)return!1;const ne=$;if(ne.modified)return te(ne.modified);const be=$;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function ve(J){return(0,A.isErrorWithActions)(J)}function Ie(J,$,ne){const be=(0,A.createErrorWithActions)(J,$);return be.forceMessage=ne?.forceMessage,be.forceSeverity=ne?.forceSeverity,be.allowDialog=ne?.allowDialog,be}}),define(ye[288],_e([1,0,4,234,5,3,27,37,19,24,78,274]),function(de,e,c,O,L,T,R,b,p,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.ViewContentGroups=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.ViewContainerLocationToString=S,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,O.localize)(0,null),e.defaultViewIcon=(0,I.registerIcon)("default-view-icon",A.Codicon.window,(0,O.localize)(1,null));var v;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})(v||(e.Extensions=v={}));var C;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel",f[f.AuxiliaryBar=2]="AuxiliaryBar"})(C||(e.ViewContainerLocation=C={})),e.ViewContainerLocations=[0,1,2];function S(f){switch(f){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class a extends T.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new c.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new c.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,p.flatten)([...this.viewContainers.values()])}registerViewContainer(h,l,u){const d=this.get(h.id);if(d)return d;const g=h;return g.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,R.getOrSet)(this.viewContainers,l,[]).push(g),u?.isDefault&&this.defaultViewContainers.push(g),this._onDidRegister.fire({viewContainer:g,viewContainerLocation:l}),g}deregisterViewContainer(h){for(const l of this.viewContainers.keys()){const u=this.viewContainers.get(l),d=u?.indexOf(h);if(d!==-1){u?.splice(d,1),u.length===0&&this.viewContainers.delete(l),this._onDidDeregister.fire({viewContainer:h,viewContainerLocation:l});return}}}get(h){return this.all.filter(l=>l.id===h)[0]}getViewContainers(h){return[...this.viewContainers.get(h)||[]]}getViewContainerLocation(h){return[...this.viewContainers.keys()].filter(l=>this.getViewContainers(l).filter(u=>u?.id===h.id).length>0)[0]}getDefaultViewContainer(h){return this.defaultViewContainers.find(l=>this.getViewContainerLocation(l)===h)}}b.Registry.add(v.ViewContainersRegistry,new a);var m;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(m||(e.ViewContentGroups=m={}));function o(f,h){const l=f.group??m.More,u=h.group??m.More;return l!==u?l.localeCompare(u):(f.order??5)-(h.order??5)}class n extends T.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new c.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new c.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new c.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new c.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new R.SetMap}registerViews(h,l){this.registerViews2([{views:h,viewContainer:l}])}registerViews2(h){h.forEach(({views:l,viewContainer:u})=>this.addViews(l,u)),this._onViewsRegistered.fire(h)}deregisterViews(h,l){const u=this.removeViews(h,l);u.length&&this._onViewsDeregistered.fire({views:u,viewContainer:l})}moveViews(h,l){for(const u of this._views.keys())if(u!==l){const d=this.removeViews(h,u);d.length&&(this.addViews(d,l),this._onDidChangeContainer.fire({views:d,from:u,to:l}))}}getViews(h){return this._views.get(h)||[]}getView(h){for(const l of this._viewContainers){const u=(this._views.get(l)||[]).filter(d=>d.id===h)[0];if(u)return u}return null}getViewContainer(h){for(const l of this._viewContainers)if((this._views.get(l)||[]).filter(d=>d.id===h)[0])return l;return null}registerViewWelcomeContent(h,l){return this._viewWelcomeContents.add(h,l),this._onDidChangeViewWelcomeContent.fire(h),(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(h,l),this._onDidChangeViewWelcomeContent.fire(h)})}registerViewWelcomeContent2(h,l){const u=new Map;for(const[d,g]of l)this._viewWelcomeContents.add(h,g),u.set(d,(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(h,g),this._onDidChangeViewWelcomeContent.fire(h)}));return this._onDidChangeViewWelcomeContent.fire(h),u}getViewWelcomeContent(h){const l=[];return this._viewWelcomeContents.forEach(h,u=>l.push(u)),l.sort(o)}addViews(h,l){let u=this._views.get(l);u||(u=[],this._views.set(l,u),this._viewContainers.push(l));for(const d of h){if(this.getView(d.id)!==null)throw new Error((0,O.localize)(2,null,d.id));u.push(d)}}removeViews(h,l){const u=this._views.get(l);if(!u)return[];const d=[],g=[];for(const D of u)h.includes(D)?d.push(D):g.push(D);return d.length&&(g.length?this._views.set(l,g):(this._views.delete(l),this._viewContainers.splice(this._viewContainers.indexOf(l),1))),d}}b.Registry.add(v.ViewsRegistry,new n),e.IViewDescriptorService=(0,L.createDecorator)("viewDescriptorService");var i;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var r;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class s{constructor(h,l){this.resolved=!1,this._hasResolve=!1,(0,w.mixin)(this,h),this._hasResolve=!!l,this.resolve=async u=>{if(l&&!this.resolved){const d=await l(u);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}u.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s;class t extends Error{constructor(h){super((0,O.localize)(3,null,h)),this.name="NoTreeViewError"}static is(h){return h.name==="NoTreeViewError"}}e.NoTreeViewError=t}),define(ye[289],_e([1,0,4,38,3,41,5]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedChatAgent=e.ChatAgentService=e.IChatAgentService=e.ChatAgentLocation=void 0;var b;(function(A){A.Panel="panel",A.Terminal="terminal",A.Notebook="notebook",A.Editor="editor"})(b||(e.ChatAgentLocation=b={})),function(A){function I(v){switch(v){case"panel":return A.Panel;case"terminal":return A.Terminal;case"notebook":return A.Notebook}return A.Panel}A.fromRaw=I}(b||(e.ChatAgentLocation=b={})),e.IChatAgentService=(0,R.createDecorator)("chatAgentService");let p=class{static{this.AGENT_LEADER="@"}constructor(I){this.contextKeyService=I,this._agents=[],this._onDidChangeAgents=new c.Emitter,this.onDidChangeAgents=this._onDidChangeAgents.event}registerAgent(I,v){if(this.getAgent(I))throw new Error(`Agent already registered: ${JSON.stringify(I)}`);const S=this,a=v.slashCommands;v={...v,get slashCommands(){return a.filter(o=>!o.when||S.contextKeyService.contextMatchesRules(T.ContextKeyExpr.deserialize(o.when)))}};const m={data:v};return this._agents.push(m),(0,L.toDisposable)(()=>{this._agents=this._agents.filter(o=>o!==m),this._onDidChangeAgents.fire(void 0)})}registerAgentImplementation(I,v){const C=this._getAgentEntry(I);if(!C)throw new Error(`Unknown agent: ${JSON.stringify(I)}`);if(C.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(I)}`);return C.impl=v,this._onDidChangeAgents.fire(new w(C.data,v)),(0,L.toDisposable)(()=>{C.impl=void 0,this._onDidChangeAgents.fire(void 0)})}registerDynamicAgent(I,v){const C={data:I,impl:v};return this._agents.push(C),this._onDidChangeAgents.fire(new w(I,v)),(0,L.toDisposable)(()=>{this._agents=this._agents.filter(S=>S!==C),this._onDidChangeAgents.fire(void 0)})}updateAgent(I,v){const C=this._getAgentEntry(I);if(!C?.impl)throw new Error(`No activated agent with id ${JSON.stringify(I)} registered`);C.data.metadata={...C.data.metadata,...v},this._onDidChangeAgents.fire(new w(C.data,C.impl))}getDefaultAgent(I){return this.getActivatedAgents().find(v=>!!v.isDefault&&v.locations.includes(I))}getSecondaryAgent(){return O.Iterable.find(this._agents.values(),I=>!!I.data.metadata.isSecondary)?.data}_getAgentEntry(I){return this._agents.find(v=>v.data.id===I)}getAgent(I){return this._getAgentEntry(I)?.data}getAgents(){return this._agents.map(I=>I.data)}getActivatedAgents(){return Array.from(this._agents.values()).filter(I=>!!I.impl).map(I=>new w(I.data,I.impl))}getAgentsByName(I){return this.getAgents().filter(v=>v.name===I)}async invokeAgent(I,v,C,S,a){const m=this._getAgentEntry(I);if(!m?.impl)throw new Error(`No activated agent with id ${I}`);return await m.impl.invoke(v,C,S,a)}async getFollowups(I,v,C,S,a){const m=this._getAgentEntry(I);if(!m?.impl)throw new Error(`No activated agent with id ${I}`);return m.impl?.provideFollowups?m.impl.provideFollowups(v,C,S,a):[]}};e.ChatAgentService=p,e.ChatAgentService=p=Ge([Ue(0,T.IContextKeyService)],p);class w{constructor(I,v){this.data=I,this.impl=v}get id(){return this.data.id}get name(){return this.data.name??""}get description(){return this.data.description??""}get extensionId(){return this.data.extensionId}get isDefault(){return this.data.isDefault}get metadata(){return this.data.metadata}get slashCommands(){return this.data.slashCommands}get defaultImplicitVariables(){return this.data.defaultImplicitVariables}get locations(){return this.data.locations}async invoke(I,v,C,S){return this.impl.invoke(I,v,C,S)}async provideFollowups(I,v,C,S){return this.impl.provideFollowups?this.impl.provideFollowups(I,v,C,S):[]}provideWelcomeMessage(I){if(this.impl.provideWelcomeMessage)return this.impl.provideWelcomeMessage(I)}provideSampleQuestions(I){if(this.impl.provideSampleQuestions)return this.impl.provideSampleQuestions(I)}}e.MergedChatAgent=w}),define(ye[290],_e([1,0,2,29,5]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KEYWORD_ACTIVIATION_SETTING_ID=e.IChatService=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.isIDocumentContext=T,e.isIUsedContext=R;function T(w){return!!w&&typeof w=="object"&&"uri"in w&&w.uri instanceof c.URI&&"version"in w&&typeof w.version=="number"&&"ranges"in w&&Array.isArray(w.ranges)&&w.ranges.every(O.Range.isIRange)}function R(w){return!!w&&typeof w=="object"&&"documents"in w&&Array.isArray(w.documents)&&w.documents.every(T)}var b;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var p;(function(w){w[w.Action=1]="Action",w[w.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.IChatService=(0,L.createDecorator)("IChatService"),e.KEYWORD_ACTIVIATION_SETTING_ID="accessibility.voice.keywordActivation"}),define(ye[143],_e([1,0,4,8,235]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new c.Emitter,this._onExit=new c.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(b){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=b}onEvent(b){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=b}onRequest(b){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=b}sendResponse(b){b.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.internalSend("response",b)}sendRequest(b,p,w,A){const I={command:b};if(p&&Object.keys(p).length>0&&(I.arguments=p),this.internalSend("request",I),typeof A=="number"){const v=setTimeout(()=>{clearTimeout(v);const C=this.pendingRequests.get(I.seq);if(C){this.pendingRequests.delete(I.seq);const S={type:"response",seq:0,request_seq:I.seq,success:!1,command:b,message:(0,L.localize)(0,null,A,b)};C(S)}},A)}return w&&this.pendingRequests.set(I.seq,w),I.seq}acceptMessage(b){this.messageCallback?this.messageCallback(b):(this.queue.push(b),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(b,p){return b.type!=="event"||p.type!=="event"}async processQueue(){let b;for(;this.queue.length;){if((!b||this.needsTaskBoundaryBetween(this.queue[0],b))&&await(0,O.timeout)(0),b=this.queue.shift(),!b)return;switch(b.type){case"event":this.eventCallback?.(b);break;case"request":this.requestCallback?.(b);break;case"response":{const p=b,w=this.pendingRequests.get(p.request_seq);w&&(this.pendingRequests.delete(p.request_seq),w(p));break}}}}internalSend(b,p){p.type=b,p.seq=this.sequence++,this.sendMessage(p)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const b=new Map;this.pendingRequests.forEach((p,w)=>b.set(w,p)),await(0,O.timeout)(500),b.forEach((p,w)=>{p({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(w)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(ye[291],_e([1,0,2,236,41,5]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_EXTENSIONID=e.CONTEXT_VARIABLE_LANGUAGE=e.CONTEXT_VARIABLE_NAME=e.CONTEXT_VARIABLE_INTERFACES=e.CONTEXT_VARIABLE_TYPE=e.CONTEXT_VARIABLE_VALUE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_HAS_MODES=e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.getStateLabel=p,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new L.RawContextKey("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new L.RawContextKey("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new L.RawContextKey("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new L.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:O.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new L.RawContextKey("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new L.RawContextKey("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new L.RawContextKey("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new L.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new L.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new L.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new L.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new L.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new L.RawContextKey("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new L.RawContextKey("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new L.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new L.RawContextKey("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new L.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new L.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new L.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new L.RawContextKey("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new L.RawContextKey("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new L.RawContextKey("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=new L.RawContextKey("breakpointItemBytes",void 0,{type:"boolean",description:O.localize(22,null)}),e.CONTEXT_BREAKPOINT_HAS_MODES=new L.RawContextKey("breakpointHasModes",!1,{type:"boolean",description:O.localize(23,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new L.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(24,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new L.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(25,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new L.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:O.localize(26,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new L.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(27,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new L.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(28,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new L.RawContextKey("stepBackSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new L.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:O.localize(30,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new L.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(31,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new L.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new L.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(33,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new L.RawContextKey("breakpointsExist",!1,{type:"boolean",description:O.localize(34,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new L.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:O.localize(35,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new L.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(36,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new L.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(37,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new L.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=new L.RawContextKey("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new L.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new L.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new L.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new L.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new L.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(44,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new L.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(45,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new L.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(46,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new L.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:O.localize(47,null)}),e.CONTEXT_VARIABLE_VALUE=new L.RawContextKey("variableValue",!1,{type:"string",description:O.localize(48,null)}),e.CONTEXT_VARIABLE_TYPE=new L.RawContextKey("variableType",!1,{type:"string",description:O.localize(49,null)}),e.CONTEXT_VARIABLE_INTERFACES=new L.RawContextKey("variableInterfaces",!1,{type:"array",description:O.localize(50,null)}),e.CONTEXT_VARIABLE_NAME=new L.RawContextKey("variableName",!1,{type:"string",description:O.localize(51,null)}),e.CONTEXT_VARIABLE_LANGUAGE=new L.RawContextKey("variableLanguage",!1,{type:"string",description:O.localize(52,null)}),e.CONTEXT_VARIABLE_EXTENSIONID=new L.RawContextKey("variableExtensionId",!1,{type:"string",description:O.localize(53,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new L.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(54,null)}),e.CONTEXT_MULTI_SESSION_REPL=new L.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:O.localize(55,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new L.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:O.localize(56,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new L.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(57,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new L.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(58,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new L.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(59,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new L.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(60,null)});const R=n=>O.localize(61,null,n);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(62,null)};var b;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(b||(e.State=b={}));function p(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var w;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(w||(e.MemoryRangeType=w={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var A;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(A||(e.DataBreakpointSetType=A={}));var I;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(I||(e.DebugConfigurationProviderTriggerKind=I={}));var v;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(v||(e.DebuggerString=v={})),e.IDebugService=(0,T.createDecorator)("debugService");var C;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(C||(e.BreakpointWidgetContext=C={}));var S;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(S||(e.DebugVisualizationType=S={}));var a;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(a||(e.DebugTreeItemCollapsibleState=a={}));var m;(function(n){n.deserialize=i=>i,n.serialize=i=>i})(m||(e.IDebugVisualizationTreeItem=m={}));var o;(function(n){n.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:c.URI.revive(i.iconPath.light),dark:c.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),n.serialize=i=>i})(o||(e.IDebugVisualization=o={}))}),define(ye[292],_e([1,0,14,2,17,24,15,29,22,19]),function(de,e,c,O,L,T,R,b,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=void 0,e.formatPII=I,e.filterExceptionsFromTelemetry=v,e.isSessionAttach=C,e.getExtensionHostDebugSession=S,e.isDebuggerMainContribution=a,e.getExactExpressionStartAndEnd=m,e.getEvaluatableExpressionAtPosition=o,e.isUri=i,e.convertToDAPaths=t,e.convertToVSCPaths=f,e.getVisibleAndSorted=l,e.saveAllBeforeDebugStart=d;const A=/{([^}]+)}/g;function I(D,E,_){return D.replace(A,function(y,P){return E&&P.length>0&&P[0]!=="_"?y:_&&_.hasOwnProperty(P)?_[P]:y})}function v(D){const E={};for(const _ of Object.keys(D))_.startsWith("!")||(E[_]=D[_]);return E}function C(D){return D.configuration.request==="attach"&&!S(D)&&(!D.parentSession||C(D.parentSession))}function S(D){let E=D.configuration.type;if(E)return E==="vslsShare"&&(E=D.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(E,"extensionhost")||(0,c.equalsIgnoreCase)(E,"pwa-extensionhost")?D:D.parentSession?S(D.parentSession):void 0}function a(D){return D.type&&(D.label||D.program||D.runtime)}function m(D,E,_){let y,P=0;const k=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=k.exec(D);){const x=z.index+1,F=x+z[0].length;if(x<=E&&F>=_){y=z[0],P=x;break}}if(y){const x=/\w+/g;let F=null;for(;(F=x.exec(y))&&!(F.index+1+P+F[0].length>=_););F&&(y=y.substring(0,x.lastIndex))}return y?{start:P,end:P+y.length-1}:{start:0,end:0}}async function o(D,E,_,y){if(D.evaluatableExpressionProvider.has(E)){const P=D.evaluatableExpressionProvider.ordered(E),k=(0,w.coalesce)(await Promise.all(P.map(async z=>{try{return await z.provideEvaluatableExpression(E,_,y??p.CancellationToken.None)}catch{return}})));if(k.length>0){let z=k[0].expression;const x=k[0].range;return z||(z=E.getLineContent(_.lineNumber).substring(x.startColumn-1,x.endColumn-1)),{range:x,matchingExpression:z}}}else{const P=E.getLineContent(_.lineNumber),{start:k,end:z}=m(P,_.column,_.column),x=P.substring(k-1,z);return{matchingExpression:x,range:new b.Range(_.lineNumber,k,_.lineNumber,k+x.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(n))}function r(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return O.URI.parse(D.path);if((0,L.isAbsolute)(D.path))return O.URI.file(D.path)}return D.path}function s(D){if(typeof D.path=="object"){const E=O.URI.revive(D.path);if(E)return E.scheme===R.Schemas.file?E.fsPath:E.toString()}return D.path}function t(D,E){const _=E?r:s,y=(0,T.deepClone)(D);return h(y,(P,k)=>{P&&k&&(k.path=_(k))}),y}function f(D,E){const _=E?r:s,y=(0,T.deepClone)(D);return h(y,(P,k)=>{!P&&k&&(k.path=_(k))}),y}function h(D,E){switch(D.type){case"event":{const _=D;switch(_.event){case"output":E(!1,_.body.source);break;case"loadedSource":E(!1,_.body.source);break;case"breakpoint":E(!1,_.body.breakpoint.source);break;default:break}break}case"request":{const _=D;switch(_.command){case"setBreakpoints":E(!0,_.arguments.source);break;case"breakpointLocations":E(!0,_.arguments.source);break;case"source":E(!0,_.arguments.source);break;case"gotoTargets":E(!0,_.arguments.source);break;case"launchVSCode":_.arguments.args.forEach(y=>E(!1,y));break;default:break}break}case"response":{const _=D;if(_.success&&_.body)switch(_.command){case"stackTrace":_.body.stackFrames.forEach(y=>E(!1,y.source));break;case"loadedSources":_.body.sources.forEach(y=>E(!1,y));break;case"scopes":_.body.scopes.forEach(y=>E(!1,y.source));break;case"setFunctionBreakpoints":_.body.breakpoints.forEach(y=>E(!1,y.source));break;case"setBreakpoints":_.body.breakpoints.forEach(y=>E(!1,y.source));break;case"disassemble":_.body?.instructions.forEach(P=>E(!1,P.location));break;default:break}break}}}function l(D){return D.filter(E=>!E.presentation?.hidden).sort((E,_)=>E.presentation?_.presentation?E.presentation.group?_.presentation.group?E.presentation.group!==_.presentation.group?E.presentation.group.localeCompare(_.presentation.group):u(E.presentation.order,_.presentation.order):-1:_.presentation.group?1:u(E.presentation.order,_.presentation.order):-1:_.presentation?1:0)}function u(D,E){return typeof D!="number"?typeof E!="number"?0:1:typeof E!="number"?-1:D-E}async function d(D,E){const _=D.getValue("debug.saveBeforeStart",{overrideIdentifier:E.activeTextEditorLanguageId});if(_!=="none"&&(await E.saveAll(),_==="allEditorsInActiveGroup")){const y=E.activeEditorPane;y&&y.input.resource?.scheme===R.Schemas.untitled&&await E.save({editor:y.input,groupId:y.group.id})}await D.reloadConfiguration()}const g=(D,E)=>!D||!E?D===E:D.name===E.name&&D.path===E.path&&D.sourceReference===E.sourceReference;e.sourcesEqual=g}),define(ye[293],_e([1,0,52,62,24,17,11,14,31,237,143]),function(de,e,c,O,L,T,R,b,p,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class I extends A.AbstractDebugAdapter{static{this.TWO_CRLF=`\r
\r
`}static{this.HEADER_LINESEPARATOR=/\r?\n/}static{this.HEADER_FIELDSEPARATOR=/: */}constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(o,n){this.outputStream=n,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,o.on("data",i=>this.handleData(i))}sendMessage(o){if(this.outputStream){const n=JSON.stringify(o);this.outputStream.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${I.TWO_CRLF}${n}`,"utf8")}}handleData(o){for(this.rawData=Buffer.concat([this.rawData,o]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const n=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this._onError.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.rawData.indexOf(I.TWO_CRLF);if(n!==-1){const r=this.rawData.toString("utf8",0,n).split(I.HEADER_LINESEPARATOR);for(const s of r){const t=s.split(I.HEADER_FIELDSEPARATOR);t[0]==="Content-Length"&&(this.contentLength=Number(t[1]))}this.rawData=this.rawData.slice(n+I.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=I;class v extends I{startSession(){return new Promise((o,n)=>{let i=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),o(),i=!0}),this.socket.on("close",()=>{i?this._onError.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.socket.on("error",r=>{i?this._onError.fire(r):n(r)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=v;class C extends v{constructor(o){super(),this.adapterServer=o}createConnection(o){return O.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",o)}}e.SocketDebugAdapter=C;class S extends v{constructor(o){super(),this.adapterServer=o}createConnection(o){return O.createConnection(this.adapterServer.path,o)}}e.NamedPipeDebugAdapter=S;class a extends I{constructor(o,n){super(),this.adapterExecutable=o,this.debugType=n}async startSession(){const o=this.adapterExecutable.command,n=this.adapterExecutable.args,i=this.adapterExecutable.options||{};try{if(o)if(T.isAbsolute(o)){if(!await p.Promises.exists(o))throw new Error(w.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(w.localize(1,null,this.debugType));let r=process.env;if(i.env&&Object.keys(i.env).length>0&&(r=L.mixin(L.deepClone(process.env),i.env)),o==="node")if(Array.isArray(n)&&n.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const f=c.fork(n[0],n.slice(1),t);if(!f.pid)throw new Error(w.localize(2,null,n[0]));this.serverProcess=f}else throw new Error(w.localize(3,null));else{const s={env:r};i.cwd&&(s.cwd=i.cwd),this.serverProcess=c.spawn(o,n,s)}this.serverProcess.on("error",s=>{this._onError.fire(s)}),this.serverProcess.on("exit",(s,t)=>{this._onExit.fire(s)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",s=>{this._onError.fire(s)}),this.serverProcess.stdin.on("error",s=>{this._onError.fire(s)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(r){this._onError.fire(r)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),R.isWindows?new Promise((o,n)=>{const i=c.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(r,s,t){if(r)return n(r)});i.on("exit",o),i.on("error",n)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(o,n){if(!o)return;const i=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?i.runtime=T.join(n,o.runtime):i.runtime=o.runtime),o.runtimeArgs&&(i.runtimeArgs=o.runtimeArgs),o.program&&(T.isAbsolute(o.program)?i.program=o.program:i.program=T.join(n,o.program)),o.args&&(i.args=o.args);const r=o;return r.win&&(i.win=a.extract(r.win,n)),r.winx86&&(i.winx86=a.extract(r.winx86,n)),r.windows&&(i.windows=a.extract(r.windows,n)),r.osx&&(i.osx=a.extract(r.osx,n)),r.linux&&(i.linux=a.extract(r.linux,n)),i}static platformAdapterExecutable(o,n){let i=Object.create(null);n=n.toLowerCase();for(const l of o)if(l.contributes){const u=l.contributes.debuggers;u&&u.length>0&&u.filter(d=>typeof d.type=="string"&&b.equalsIgnoreCase(d.type,n)).forEach(d=>{const g=a.extract(d,l.extensionLocation.fsPath);i=L.mixin(i,g,l.isBuiltin)})}let r;R.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=i.winx86||i.win||i.windows:R.isWindows?r=i.win||i.windows:R.isMacintosh?r=i.osx:R.isLinux&&(r=i.linux),r=r||i;const s=r.program||i.program,t=r.args||i.args,f=r.runtime||i.runtime,h=r.runtimeArgs||i.runtimeArgs;if(f)return{type:"executable",command:f,args:(h||[]).concat(typeof s=="string"?[s]:[]).concat(t||[])};if(s)return{type:"executable",command:s,args:t||[]}}}e.ExecutableDebugAdapter=a}),define(ye[294],_e([1,0,52,34,11]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasChildProcesses=R,e.prepareCommand=p;function T(w,A){return new Promise((I,v)=>{let C="";const S=c.spawn(w,A);S.pid&&S.stdout.on("data",a=>{C+=a.toString()}),S.on("error",a=>{v(a)}),S.on("close",a=>{I(C)})})}async function R(w){if(w)if(L.isWindows){const A=await new Promise((I,v)=>{de(["@vscode/windows-process-tree"],I,v)});return new Promise(I=>{A.getProcessTree(w,v=>{I(!!v&&v.children.length>0)})})}else return T("/usr/bin/pgrep",["-lP",String(w)]).then(A=>{const I=A.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}var b;(function(w){w[w.cmd=0]="cmd",w[w.powershell=1]="powershell",w[w.bash=2]="bash"})(b||(b={}));function p(w,A,I,v,C){w=w.trim().toLowerCase();let S;w.indexOf("powershell")>=0||w.indexOf("pwsh")>=0?S=1:w.indexOf("cmd.exe")>=0?S=0:w.indexOf("bash")>=0?S=2:L.isWindows?S=0:S=2;let a,m=" ";switch(S){case 1:if(a=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),v){const o=(0,O.getDriveLetter)(v);o&&(m+=`${o}:; `),m+=`cd ${a(v)}; `}if(C)for(const o in C){const n=C[o];n===null?m+=`Remove-Item env:${o}; `:m+=`\${env:${o}}='${n}'; `}if(A.length>0){const o=A.shift(),n=I?o:a(o);m+=n[0]==="'"?`& ${n} `:`${n} `;for(const i of A)m+=i==="<"||i===">"||I?i:a(i),m+=" "}break;case 0:if(a=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(n=>o.includes(n))||o.length===0?`"${o}"`:o),v){const o=(0,O.getDriveLetter)(v);o&&(m+=`${o}: && `),m+=`cd ${a(v)} && `}if(C){m+='cmd /C "';for(const o in C){let n=C[o];n===null?m+=`set "${o}=" && `:(n=n.replace(/[&^|<>]/g,i=>`^${i}`),m+=`set "${o}=${n}" && `)}}for(const o of A)m+=o==="<"||o===">"||I?o:a(o),m+=" ";C&&(m+='"');break;case 2:{a=n=>(n=n.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),n.length===0?'""':n);const o=n=>/[^\w@%\/+=,.:^-]/.test(n)?`'${n.replace(/'/g,"'\\''")}'`:n;if(v&&(m+=`cd ${a(v)} ; `),C){m+="/usr/bin/env";for(const n in C){const i=C[n];i===null?m+=` -u ${o(n)}`:m+=` ${o(`${n}=${i}`)}`}m+=" "}for(const n of A)m+=n==="<"||n===">"||I?n:a(n),m+=" ";break}}return m}}),define(ye[295],_e([1,0,5]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var O;(function(L){L[L.Output=1]="Output",L[L.OutputItems=2]="OutputItems",L[L.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(ye[296],_e([1,0,5]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookKernelHistoryService=e.INotebookKernelService=e.ProxyKernelState=e.variablePageSize=void 0,e.variablePageSize=100;var O;(function(L){L[L.Disconnected=1]="Disconnected",L[L.Connected=2]="Connected",L[L.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.INotebookKernelService=(0,c.createDecorator)("INotebookKernelService"),e.INotebookKernelHistoryService=(0,c.createDecorator)("INotebookKernelHistoryService")}),define(ye[297],_e([1,0,3,29,200,100]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellSearchModel=void 0;class R extends c.Disposable{constructor(p,w,A){super(),this._source=p,this._inputTextBuffer=w,this._outputs=A,this._outputTextBuffers=void 0}_getFullModelRange(p){const w=p.getLineCount();return new O.Range(1,1,w,this._getLineMaxColumn(p,w))}_getLineMaxColumn(p,w){if(w<1||w>p.getLineCount())throw new Error("Illegal value for lineNumber");return p.getLineLength(w)+1}get inputTextBuffer(){if(!this._inputTextBuffer){const p=new L.PieceTreeTextBufferBuilder;p.acceptChunk(this._source);const w=p.finish(!0),{textBuffer:A,disposable:I}=w.create(1);this._inputTextBuffer=A,this._register(I)}return this._inputTextBuffer}get outputTextBuffers(){return this._outputTextBuffers||(this._outputTextBuffers=this._outputs.map(p=>{const w=new L.PieceTreeTextBufferBuilder;w.acceptChunk(p);const A=w.finish(!0),{textBuffer:I,disposable:v}=A.create(1);return this._register(v),I})),this._outputTextBuffers}findInInputs(p){const A=new T.SearchParams(p,!1,!1,null).parseSearchRequest();if(!A)return[];const I=this._getFullModelRange(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(I,A,!0,5e3)}findInOutputs(p){const A=new T.SearchParams(p,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(I=>{const v=I.findMatchesLineByLine(this._getFullModelRange(I),A,!0,5e3);if(v.length!==0)return{textBuffer:I,matches:v}}).filter(I=>!!I):[]}}e.CellSearchModel=R}),define(ye[67],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(T){T.Delimiter="\0"})(c||(e.TestIdPathParts=c={}));var O;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class L{static fromExtHostTestItem(R,b,p=R.parent){if(R._isRoot)return new L([b]);const w=[R.id];for(let A=p;A&&A.id!==b;A=A.parent)w.push(A.id);return w.push(b),new L(w.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const b=R.indexOf("\0");return b===-1?R:R.slice(0,b)}static fromString(R){return new L(R.split("\0"))}static join(R,b){return new L([...R.path,b])}static joinToString(R,b){return R.toString()+"\0"+b}static parentId(R){const b=R.lastIndexOf("\0");return b===-1?void 0:R.slice(0,b)}static localId(R){const b=R.lastIndexOf("\0");return b===-1?R:R.slice(b+1)}static isChild(R,b){return b.startsWith(R)&&b[R.length]==="\0"}static compare(R,b){return R===b?0:L.isChild(R,b)?2:L.isChild(b,R)?3:1}constructor(R,b=R.length){if(this.path=R,this.viewEnd=b,R.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new L(this.path,1)}get parentId(){return this.viewEnd>1?new L(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new L(this.path,R)}*idsToRoot(){for(let R=this.viewEnd;R>0;R--)yield new L(this.path,R)}compare(R){if(typeof R=="string")return L.compare(this.toString(),R);for(let b=0;b<R.viewEnd&&b<this.viewEnd;b++)if(R.path[b]!==this.path[b])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=L}),define(ye[89],_e([1,0,2,49,29,67]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.testResultStateToContextValues=e.TestResultState=void 0;var R;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.testResultStateToContextValues={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var b;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var p;(function(N){N[N.Run=2]="Run",N[N.Debug=4]="Debug",N[N.Coverage=8]="Coverage",N[N.HasNonDefaultProfile=16]="HasNonDefaultProfile",N[N.HasConfigurable=32]="HasConfigurable",N[N.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const w=N=>"runId"in N;e.isStartControllerTests=w;var A;(function(N){N.serialize=M=>({range:M.range.toJSON(),uri:M.uri.toJSON()}),N.deserialize=(M,B)=>({range:L.Range.lift(B.range),uri:M.asCanonicalUri(c.URI.revive(B.uri))})})(A||(e.IRichLocation=A={}));var I;(function(N){N[N.Error=0]="Error",N[N.Output=1]="Output"})(I||(e.TestMessageType=I={}));var v;(function(N){N.serialize=M=>({message:M.message,type:0,expected:M.expected,actual:M.actual,contextValue:M.contextValue,location:M.location&&A.serialize(M.location)}),N.deserialize=(M,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&A.deserialize(M,B.location)})})(v||(e.ITestErrorMessage=v={}));const C=(N,M)=>`${M?"s":"e"}${N}`;e.getMarkId=C;var S;(function(N){N.serialize=M=>({message:M.message,type:1,offset:M.offset,length:M.length,location:M.location&&A.serialize(M.location)}),N.deserialize=(M,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&A.deserialize(M,B.location)})})(S||(e.ITestOutputMessage=S={}));var a;(function(N){N.serialize=M=>M.type===0?v.serialize(M):S.serialize(M),N.deserialize=(M,B)=>B.type===0?v.deserialize(M,B):S.deserialize(M,B)})(a||(e.ITestMessage=a={}));var m;(function(N){N.serializeWithoutMessages=M=>({state:M.state,duration:M.duration,messages:[]}),N.serialize=M=>({state:M.state,duration:M.duration,messages:M.messages.map(a.serialize)}),N.deserialize=(M,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(W=>a.deserialize(M,W))})})(m||(e.ITestTaskState=m={}));const o="\0",n=(N,M)=>N+o+M;e.namespaceTestTag=n;const i=N=>{const M=N.indexOf(o);return{ctrlId:N.slice(0,M),tagId:N.slice(M+1)}};e.denamespaceTestTag=i;var r;(function(N){N.serialize=M=>({extId:M.extId,label:M.label,tags:M.tags,busy:M.busy,children:void 0,uri:M.uri?.toJSON(),range:M.range?.toJSON()||null,description:M.description,error:M.error,sortText:M.sortText}),N.deserialize=(M,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?M.asCanonicalUri(c.URI.revive(B.uri)):void 0,range:B.range?L.Range.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(r||(e.ITestItem=r={}));var s;(function(N){N[N.NotExpandable=0]="NotExpandable",N[N.Expandable=1]="Expandable",N[N.BusyExpanding=2]="BusyExpanding",N[N.Expanded=3]="Expanded"})(s||(e.TestItemExpandState=s={}));var t;(function(N){N.serialize=M=>({expand:M.expand,item:r.serialize(M.item)}),N.deserialize=(M,B)=>({controllerId:T.TestId.root(B.item.extId),expand:B.expand,item:r.deserialize(M,B.item)})})(t||(e.InternalTestItem=t={}));var f;(function(N){N.serialize=M=>{let B;return M.item&&(B={},M.item.label!==void 0&&(B.label=M.item.label),M.item.tags!==void 0&&(B.tags=M.item.tags),M.item.busy!==void 0&&(B.busy=M.item.busy),M.item.uri!==void 0&&(B.uri=M.item.uri?.toJSON()),M.item.range!==void 0&&(B.range=M.item.range?.toJSON()),M.item.description!==void 0&&(B.description=M.item.description),M.item.error!==void 0&&(B.error=M.item.error),M.item.sortText!==void 0&&(B.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:B}},N.deserialize=M=>{let B;return M.item&&(B={},M.item.label!==void 0&&(B.label=M.item.label),M.item.tags!==void 0&&(B.tags=M.item.tags),M.item.busy!==void 0&&(B.busy=M.item.busy),M.item.range!==void 0&&(B.range=M.item.range?L.Range.lift(M.item.range):null),M.item.description!==void 0&&(B.description=M.item.description),M.item.error!==void 0&&(B.error=M.item.error),M.item.sortText!==void 0&&(B.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:B}}})(f||(e.ITestItemUpdate=f={}));const h=(N,M)=>{M.expand!==void 0&&(N.expand=M.expand),M.item!==void 0&&(N.item=N.item?Object.assign(N.item,M.item):M.item)};e.applyTestItemUpdate=h;var l;(function(N){N.serializeWithoutMessages=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(m.serializeWithoutMessages)}),N.serialize=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(m.serialize)}),N.deserialize=(M,B)=>({...t.deserialize(M,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(W=>m.deserialize(M,W)),retired:!0})})(l||(e.TestResultItem=l={}));var u;(function(N){N.empty=()=>({covered:0,total:0}),N.sum=(M,B)=>{M.covered+=B.covered,M.total+=B.total}})(u||(e.ICoverageCount=u={}));var d;(function(N){N.serialize=M=>({id:M.id,statement:M.statement,branch:M.branch,declaration:M.declaration,uri:M.uri.toJSON()}),N.deserialize=(M,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,uri:M.asCanonicalUri(c.URI.revive(B.uri))})})(d||(e.IFileCoverage=d={}));function g(N){return{...N,location:N.location?.toJSON()}}function D(N){return N.location=N.location?O.Position.isIPosition(N.location)?O.Position.lift(N.location):L.Range.lift(N.location):void 0,N}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var E;(function(N){N[N.Declaration=0]="Declaration",N[N.Statement=1]="Statement",N[N.Branch=2]="Branch"})(E||(e.DetailType=E={}));var _;(function(N){N.serialize=M=>M.type===0?P.serialize(M):k.serialize(M),N.deserialize=M=>M.type===0?P.deserialize(M):k.deserialize(M)})(_||(e.CoverageDetails=_={}));var y;(function(N){N.serialize=g,N.deserialize=D})(y||(e.IBranchCoverage=y={}));var P;(function(N){N.serialize=g,N.deserialize=D})(P||(e.IDeclarationCoverage=P={}));var k;(function(N){N.serialize=M=>({...g(M),branches:M.branches?.map(y.serialize)}),N.deserialize=M=>({...D(M),branches:M.branches?.map(y.deserialize)})})(k||(e.IStatementCoverage=k={}));var z;(function(N){N[N.Add=0]="Add",N[N.Update=1]="Update",N[N.DocumentSynced=2]="DocumentSynced",N[N.Remove=3]="Remove",N[N.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",N[N.Retire=5]="Retire",N[N.AddTag=6]="AddTag",N[N.RemoveTag=7]="RemoveTag"})(z||(e.TestDiffOpType=z={}));var x;(function(N){N.deserialize=(M,B)=>B.op===0?{op:B.op,item:t.deserialize(M,B.item)}:B.op===1?{op:B.op,item:f.deserialize(B.item)}:B.op===2?{op:B.op,uri:M.asCanonicalUri(c.URI.revive(B.uri)),docv:B.docv}:B,N.serialize=M=>M.op===0?{op:M.op,item:t.serialize(M.item)}:M.op===1?{op:M.op,item:f.serialize(M.item)}:M})(x||(e.TestsDiffOp=x={}));class F{constructor(M){this.uriIdentity=M,this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(M){const B=this.createChangeCollector();for(const W of M)switch(W.op){case 0:this.add(t.deserialize(this.uriIdentity,W.item),B);break;case 1:this.update(f.deserialize(W.item),B);break;case 3:this.remove(W.itemId,B);break;case 5:this.retireTest(W.itemId);break;case 4:this.updatePendingRoots(W.amount);break;case 6:this._tags.set(W.tag.id,W.tag);break;case 7:this._tags.delete(W.id);break}B.complete?.()}add(M,B){const W=T.TestId.parentId(M.item.extId)?.toString();let Y;if(!W)Y=this.createItem(M),this.roots.add(Y),this.items.set(M.item.extId,Y);else if(this.items.has(W)){const Z=this.items.get(W);Z.children.add(M.item.extId),Y=this.createItem(M,Z),this.items.set(M.item.extId,Y)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(M)}`);return}return B.add?.(Y),M.expand===2&&this.busyControllerCount++,Y}update(M,B){const W=this.items.get(M.extId);if(W)return M.expand!==void 0&&(W.expand===2&&this.busyControllerCount--,M.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(W,M),B.update?.(W),W}remove(M,B){const W=this.items.get(M);if(!W)return;const Y=T.TestId.parentId(W.item.extId)?.toString();Y?this.items.get(Y).children.delete(W.item.extId):this.roots.delete(W);const Z=[[M]];for(;Z.length;)for(const G of Z.pop()){const Q=this.items.get(G);Q&&(Z.push(Q.children),this.items.delete(G),B.remove?.(Q,Q!==W),Q.expand===2&&this.busyControllerCount--)}}retireTest(M){}updatePendingRoots(M){this.pendingRootCount+=M}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=F}),define(ye[112],_e([1,0,8,4,3,61,89,67]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var p;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const w=(n,i)=>n===i,I=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:w,label:w,description:w,error:w,sortText:w,tags:(n,i)=>!(n.length!==i.length||n.some(r=>!i.includes(r)))}),v=(n,i)=>{let r;for(const[s,t]of I)t(n[s],i[s])||(r?r[s]=i[s]:r={[s]:i[s]});return r};class C extends L.Disposable{get root(){return this.options.root}constructor(i){super(),this.options=i,this.debounceSendDiff=this._register(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new O.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(i){this._resolveHandler=i;for(const r of this.tree.values())this.updateExpandability(r)}get resolveHandler(){return this._resolveHandler}collectDiff(){const i=this.diff;return this.diff=[],i}pushDiff(i){switch(i.op){case 2:{for(const r of this.diff)if(r.op===2&&r.uri===i.uri){r.docv=i.docv;return}break}case 1:{const r=this.diff[this.diff.length-1];if(r){if(r.op===1&&r.item.extId===i.item.extId){(0,R.applyTestItemUpdate)(r.item,i.item);return}if(r.op===0&&r.item.item.extId===i.item.extId){(0,R.applyTestItemUpdate)(r.item,i.item);return}}break}}this.diff.push(i),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(i,r){const s=this.tree.get(i);if(s){if((s.expandLevels===void 0||r>s.expandLevels)&&(s.expandLevels=r),s.expand===1){const t=this.resolveChildren(s);return t.isOpen()?this.expandChildren(s,r-1):t.wait().then(()=>this.expandChildren(s,r-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.expandChildren(s,r-1)):this.expandChildren(s,r-1)}}dispose(){for(const i of this.tree.values())this.options.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(i,r){switch(r.op){case 3:this.removeItem(b.TestId.joinToString(i.fullId,r.id));break;case 0:this.upsertItem(r.item,i);break;case 5:for(const s of r.ops)this.onTestItemEvent(i,s);break;case 1:this.diffTagRefs(r.new,r.old,i.fullId.toString());break;case 2:this.updateExpandability(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:r.update}});break;case 6:this.documentSynced(i.actual.uri);break;default:(0,T.assertNever)(r)}}documentSynced(i){i&&this.pushDiff({op:2,uri:i,docv:this.options.getDocumentVersion(i)})}upsertItem(i,r){const s=b.TestId.fromExtHostTestItem(i,this.root.id,r?.actual),t=this.options.getApiFor(i);t.parent&&t.parent!==r?.actual&&this.options.getChildren(t.parent).delete(i.id);let f=this.tree.get(s.toString());if(!f){f={fullId:s,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},i.tags.forEach(this.incrementTagRefs,this),this.tree.set(f.fullId.toString(),f),this.setItemParent(i,r),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:f.expand,item:this.options.toITestItem(i)}}),this.connectItemAndChildren(i,f,r);return}if(f.actual===i){this.connectItem(i,f,r);return}if(f.actual.uri?.toString()!==i.uri?.toString())return this.removeItem(s.toString()),this.upsertItem(i,r);const h=this.options.getChildren(f.actual),l=f.actual,u=v(this.options.toITestItem(l),this.options.toITestItem(i));this.options.getApiFor(l).listener=void 0,f.actual=i,f.expand=0,u&&(u.hasOwnProperty("tags")&&(this.diffTagRefs(i.tags,l.tags,s.toString()),delete u.tags),this.onTestItemEvent(f,{op:4,update:u})),this.connectItemAndChildren(i,f,r);for(const[d,g]of h)this.options.getChildren(i).get(g.id)||this.removeItem(b.TestId.joinToString(s,g.id));this.documentSynced(f.actual.uri)}diffTagRefs(i,r,s){const t=new Set(r.map(f=>f.id));for(const f of i)t.delete(f.id)||this.incrementTagRefs(f);this.pushDiff({op:1,item:{extId:s,item:{tags:i.map(f=>(0,R.namespaceTestTag)(this.options.controllerId,f.id))}}}),t.forEach(this.decrementTagRefs,this)}incrementTagRefs(i){const r=this.tags.get(i.id);r?r.refCount++:(this.tags.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.namespaceTestTag)(this.options.controllerId,i.id)}}))}decrementTagRefs(i){const r=this.tags.get(i);r&&!--r.refCount&&(this.tags.delete(i),this.pushDiff({op:7,id:(0,R.namespaceTestTag)(this.options.controllerId,i)}))}setItemParent(i,r){this.options.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}connectItem(i,r,s){this.setItemParent(i,s);const t=this.options.getApiFor(i);t.parent=s?.actual,t.listener=f=>this.onTestItemEvent(r,f),this.updateExpandability(r)}connectItemAndChildren(i,r,s){this.connectItem(i,r,s);for(const[t,f]of this.options.getChildren(i))this.upsertItem(f,r)}updateExpandability(i){let r;this._resolveHandler?i.resolveBarrier?r=i.resolveBarrier.isOpen()?3:2:r=i.actual.canResolveChildren?1:0:r=0,r!==i.expand&&(i.expand=r,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:r}}),r===1&&i.expandLevels!==void 0&&this.resolveChildren(i))}expandChildren(i,r){if(r<0)return;const s=[];for(const[t,f]of this.options.getChildren(i.actual)){const h=this.expand(b.TestId.joinToString(i.fullId,f.id),r);(0,c.isThenable)(h)&&s.push(h)}if(s.length)return Promise.all(s).then(()=>{})}resolveChildren(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this._resolveHandler){const f=new c.Barrier;return f.open(),f}i.expand=2,this.pushExpandStateUpdate(i);const r=i.resolveBarrier=new c.Barrier,s=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,f)};let t;try{t=this._resolveHandler(i.actual===this.root?void 0:i.actual)}catch(f){s(f)}return(0,c.isThenable)(t)?t.catch(s).then(()=>{r.open(),this.updateExpandability(i)}):(r.open(),this.updateExpandability(i)),i.resolveBarrier}pushExpandStateUpdate(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}removeItem(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const s=[r];for(;s.length;){const t=s.pop();if(t){this.options.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.decrementTagRefs(f.id);this.tree.delete(t.fullId.toString());for(const[f,h]of this.options.getChildren(t.actual))s.push(this.tree.get(b.TestId.joinToString(t.fullId,h.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.diffOpEmitter.fire(i)}}e.TestItemCollection=C;class S extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.DuplicateTestItemError=S;class a extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=a;class m extends Error{constructor(i,r,s){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${s}".`)}}e.MixedTestItemController=m;const o=(n,i,r)=>{let s=new Map;return{get size(){return s.size},forEach(t,f){for(const h of s.values())t.call(f,h,this)},[Symbol.iterator](){return s.entries()},replace(t){const f=new Map,h=new Set(s.keys()),l={op:5,ops:[]};for(const u of t){if(!(u instanceof r))throw new a(u.id);const d=i(u).controllerId;if(d!==n.controllerId)throw new m(u.id,d,n.controllerId);if(f.has(u.id))throw new S(u.id);f.set(u.id,u),h.delete(u.id),l.ops.push({op:0,item:u})}for(const u of h.keys())l.ops.push({op:3,id:u});n.listener?.(l),s=f},add(t){if(!(t instanceof r))throw new a(t.id);s.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){s.delete(t)&&n.listener?.({op:3,id:t})},get(t){return s.get(t)},toJSON(){return Array.from(s.values())}}};e.createTestItemChildren=o}),define(ye[144],_e([1,0,112]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const O=new WeakMap,L=(R,b)=>{const p={controllerId:b};return O.set(R,p),p};e.createPrivateApiFor=L;const T=R=>{const b=O.get(R);if(!b)throw new c.InvalidTestItemError(R?.id||"<unknown>");return b};e.getPrivateApiFor=T}),define(ye[113],_e([1,0,15,2]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.asWebviewUri=L,e.decodeAuthority=R,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function L(b,p){return b.scheme===c.Schemas.http||b.scheme===c.Schemas.https?b:(p&&p.authority&&p.isRemote&&b.scheme===c.Schemas.file&&(b=O.URI.from({scheme:c.Schemas.vscodeRemote,authority:p.authority,path:b.path})),O.URI.from({scheme:c.Schemas.https,authority:`${b.scheme}+${T(b.authority)}.${e.webviewRootResourceAuthority}`,path:b.path,fragment:b.fragment,query:b.query}))}function T(b){return b.replace(/./g,p=>{const w=p.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?p:"-"+w.toString(16).padStart(4,"0")})}function R(b){return b.replace(/-([0-9a-f]{4})/g,(p,w)=>String.fromCharCode(parseInt(w,16)))}}),define(ye[298],_e([1,0,4,3,113]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(b,p,w){this._proxy=b,this._editors=p,this._remoteInfo=w,this._handlePool=0,this._disposables=new O.DisposableStore,this._insets=new Map,this._disposables.add(p.onDidChangeVisibleTextEditors(()=>{const A=p.getVisibleTextEditors();for(const I of this._insets.values())A.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(b=>b.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(b,p,w,A,I){let v;for(const i of this._editors.getVisibleTextEditors(!0))if(i.value===b){v=i;break}if(!v)throw new Error("not a visible editor");const C=this,S=this._handlePool++,a=new c.Emitter,m=new c.Emitter,o=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(i){return(0,L.asWebviewUri)(i,C._remoteInfo)}get cspSource(){return L.webviewGenericCspSource}set options(i){this._options=i,C._proxy.$setOptions(S,i)}get options(){return this._options}set html(i){this._html=i,C._proxy.$setHtml(S,i)}get html(){return this._html}get onDidReceiveMessage(){return a.event}postMessage(i){return C._proxy.$postMessage(S,i)}},n=new class{constructor(){this.editor=b,this.line=p,this.height=w,this.webview=o,this.onDidDispose=m.event}dispose(){C._insets.has(S)&&(C._insets.delete(S),C._proxy.$disposeEditorInset(S),m.fire(),m.dispose(),a.dispose())}};return this._proxy.$createEditorInset(S,v.id,v.value.document.uri,p+1,w,A||{},I.identifier,I.extensionLocation),this._insets.set(S,{editor:b,inset:n,onDidReceiveMessage:a}),n}$onDidDispose(b){const p=this._insets.get(b);p&&p.inset.dispose()}$onDidReceiveMessage(b,p){this._insets.get(b)?.onDidReceiveMessage.fire(p)}}e.ExtHostEditorInsets=T}),define(ye[145],_e([1,0,5]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuthenticationExtensionsService=e.IAuthenticationService=e.INTERNAL_AUTH_PROVIDER_PREFIX=void 0,e.INTERNAL_AUTH_PROVIDER_PREFIX="__",e.IAuthenticationService=(0,c.createDecorator)("IAuthenticationService"),e.IAuthenticationExtensionsService=(0,c.createDecorator)("IAuthenticationExtensionsService")}),define(ye[299],_e([1,0,5]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,c.createDecorator)("configurationResolverService");var O;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator",T.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class L extends Error{constructor(R,b){super(b),this.variable=R}}e.VariableError=L}),define(ye[300],_e([1,0,17,50,18,24,11,103,240,299,14]),function(de,e,c,O,L,T,R,b,p,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(C,S,a,m){this._contributedVariables=new Map,this._context=C,this._labelService=S,this._userHomePromise=a,m&&(this._envVariablesPromise=m.then(o=>this.prepareEnv(o)))}prepareEnv(C){if(R.isWindows){const S=Object.create(null);return Object.keys(C).forEach(a=>{S[a.toLowerCase()]=C[a]}),S}return C}resolveWithEnvironment(C,S,a){return this.recursiveResolve({env:this.prepareEnv(C),userHome:void 0},S?S.uri:void 0,a)}async resolveAsync(C,S){const a={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(a,C?C.uri:void 0,S)}async resolveAnyBase(C,S,a,m){const o=T.deepClone(S);R.isWindows&&o.windows?Object.keys(o.windows).forEach(i=>o[i]=o.windows[i]):R.isMacintosh&&o.osx?Object.keys(o.osx).forEach(i=>o[i]=o.osx[i]):R.isLinux&&o.linux&&Object.keys(o.linux).forEach(i=>o[i]=o.linux[i]),delete o.windows,delete o.osx,delete o.linux;const n={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(n,C?C.uri:void 0,o,a,m)}async resolveAnyAsync(C,S,a){return this.resolveAnyBase(C,S,a)}async resolveAnyMap(C,S,a){const m=new Map;return{newConfig:await this.resolveAnyBase(C,S,a,m),resolvedVariables:m}}resolveWithInteractionReplace(C,S,a,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,S,a,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,S){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,S)}async recursiveResolve(C,S,a,m,o){if(L.isString(a))return this.resolveString(C,S,a,m,o);if(Array.isArray(a))return Promise.all(a.map(n=>this.recursiveResolve(C,S,n,m,o)));if(L.isObject(a)){const n=Object.create(null),i=await Promise.all(Object.keys(a).map(async r=>[await this.resolveString(C,S,r,m,o),await this.recursiveResolve(C,S,a[r],m,o)]));for(const[r,s]of i)n[r]=s;return n}return a}resolveString(C,S,a,m,o){return(0,A.replaceAsync)(a,I.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(I.VARIABLE_LHS))return n;let r=await this.evaluateSingleVariable(C,n,i,S,m);return o?.set(i,r),r!==n&&L.isString(r)&&r.match(I.VARIABLE_REGEXP)&&(r=await this.resolveString(C,S,r,m,o)),r})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}async evaluateSingleVariable(C,S,a,m,o){let n;const i=a.split(":");i.length>1&&(a=i[0],n=i[1]);const r=f=>{const h=this._context.getFilePath();if(h)return(0,b.normalizeDriveLetter)(h);throw new w.VariableError(f,(0,p.localize)(0,null,S))},s=f=>{const h=r(f);if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return(0,b.normalizeDriveLetter)(l)}throw new w.VariableError(f,(0,p.localize)(1,null,S,c.basename(h)))},t=f=>{if(n){const h=this._context.getFolderUri(n);if(h)return h;throw new w.VariableError(f,(0,p.localize)(2,null,S,n))}if(m)return m;throw this._context.getWorkspaceFolderCount()>1?new w.VariableError(f,(0,p.localize)(3,null,S)):new w.VariableError(f,(0,p.localize)(4,null,S))};switch(a){case"env":if(n){if(C.env){const f=C.env[R.isWindows?n.toLowerCase():n];if(L.isString(f))return f}return""}throw new w.VariableError(w.VariableKind.Env,(0,p.localize)(5,null,S));case"config":if(n){const f=this._context.getConfigurationValue(m,n);if(L.isUndefinedOrNull(f))throw new w.VariableError(w.VariableKind.Config,(0,p.localize)(6,null,S,n));if(L.isObject(f))throw new w.VariableError(w.VariableKind.Config,(0,p.localize)(7,null,S,n));return f}throw new w.VariableError(w.VariableKind.Config,(0,p.localize)(8,null,S));case"command":return this.resolveFromMap(w.VariableKind.Command,S,n,o,"command");case"input":return this.resolveFromMap(w.VariableKind.Input,S,n,o,"input");case"extensionInstallFolder":if(n){const f=await this._context.getExtension(n);if(!f)throw new w.VariableError(w.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,S,n));return this.fsPath(f.extensionLocation)}throw new w.VariableError(w.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,S));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,b.normalizeDriveLetter)(this.fsPath(t(w.VariableKind.WorkspaceFolder)));case"cwd":return m||n?(0,b.normalizeDriveLetter)(this.fsPath(t(w.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.normalizeDriveLetter)(c.basename(this.fsPath(t(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(C.userHome)return C.userHome;throw new w.VariableError(w.VariableKind.UserHome,(0,p.localize)(11,null,S))}case"lineNumber":{const f=this._context.getLineNumber();if(f)return f;throw new w.VariableError(w.VariableKind.LineNumber,(0,p.localize)(12,null,S))}case"selectedText":{const f=this._context.getSelectedText();if(f)return f;throw new w.VariableError(w.VariableKind.SelectedText,(0,p.localize)(13,null,S))}case"file":return r(w.VariableKind.File);case"fileWorkspaceFolder":return s(w.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return c.basename(s(w.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||n?c.relative(this.fsPath(t(w.VariableKind.RelativeFile)),r(w.VariableKind.RelativeFile)):r(w.VariableKind.RelativeFile);case"relativeFileDirname":{const f=c.dirname(r(w.VariableKind.RelativeFileDirname));if(m||n){const h=c.relative(this.fsPath(t(w.VariableKind.RelativeFileDirname)),f);return h.length===0?".":h}return f}case"fileDirname":return c.dirname(r(w.VariableKind.FileDirname));case"fileExtname":return c.extname(r(w.VariableKind.FileExtname));case"fileBasename":return c.basename(r(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=c.basename(r(w.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-c.extname(f).length)}case"fileDirnameBasename":return c.basename(c.dirname(r(w.VariableKind.FileDirnameBasename)));case"execPath":{const f=this._context.getExecPath();return f||S}case"execInstallFolder":{const f=this._context.getAppRoot();return f||S}case"pathSeparator":case"/":return c.sep;default:try{const f=n?`${a}:${n}`:a;return this.resolveFromMap(w.VariableKind.Unknown,S,f,o,void 0)}catch{return S}}}}resolveFromMap(C,S,a,m,o){if(a&&m){const n=o===void 0?m[a]:m[o+":"+a];if(typeof n=="string")return n;throw new w.VariableError(C,(0,p.localize)(14,null,S))}return S}}e.AbstractVariableResolverService=I}),define(ye[146],_e([1,0,5,142]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.isEditorReplacement=w,e.isEditorGroup=v,e.preferredSideBySideGroupDirection=C,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var L;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(L||(e.GroupDirection=L={}));var T;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(T||(e.GroupOrientation=T={}));var R;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var b;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var p;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function w(S){const a=S;return(0,O.isEditorInput)(a?.editor)&&(0,O.isEditorInput)(a?.replacement)}var A;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var I;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function v(S){const a=S;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function C(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ye[301],_e([1,0,5,146]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AUX_WINDOW_GROUP=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.isPreferredGroup=L,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2,e.AUX_WINDOW_GROUP=-3;function L(T){const R=T;return typeof T=="number"||(0,O.isEditorGroup)(R)}}),define(ye[147],_e([1,0,5,136]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(O.IEnvironmentService)}),define(ye[148],_e([1,0,25,4,17,3,8]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class b{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.DeltaExtensionsResult=b;class p{static isHostExtension(n,i,r){if(i.getExtensionDescription(n))return!1;const s=r.getExtensionDescription(n);return s?!!((s.main||s.browser)&&s.api==="none"):!1}constructor(n,i){this._activationEventsReader=n,this._onDidChange=new O.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(a),this._extensionsMap=new c.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this._extensionsMap.set(n.identifier,n),this._extensionsArr.push(n);const i=this._activationEventsReader.readActivationEvents(n);for(const r of i)this._activationMap.has(r)||this._activationMap.set(r,[]),this._activationMap.get(r).push(n)}}set(n){return this._extensionDescriptions=n,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(n,i){this._extensionDescriptions=m(this._extensionDescriptions,i),this._extensionDescriptions=this._extensionDescriptions.concat(n);const r=p._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=m(this._extensionDescriptions,r.map(s=>s.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new b(this._versionId,r)}static _findLoopingExtensions(n){const i=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(h){this._nodesSet.has(h)||(this._nodesSet.add(h),this._nodesArr.push(h))}addArc(h,l){this.addNode(h),this.addNode(l),this._arcs.has(h)?this._arcs.get(h).push(l):this._arcs.set(h,[l])}getArcs(h){return this._arcs.has(h)?this._arcs.get(h):[]}hasOnlyGoodArcs(h,l){const u=i.getArcs(h);for(let d=0;d<u.length;d++)if(!l.has(u[d]))return!1;return!0}getNodes(){return this._nodesArr}},r=new c.ExtensionIdentifierMap;for(const h of n)if(r.set(h.identifier,h),h.extensionDependencies)for(const l of h.extensionDependencies)i.addArc(c.ExtensionIdentifier.toKey(h.identifier),c.ExtensionIdentifier.toKey(l));const s=new Set;i.getNodes().filter(h=>i.getArcs(h).length===0).forEach(h=>s.add(h));const t=i.getNodes().filter(h=>!s.has(h));let f;do{f=!1;for(let h=0;h<t.length;h++){const l=t[h];i.hasOnlyGoodArcs(l,s)&&(t.splice(h,1),h--,s.add(l),f=!0)}}while(f);return t.map(h=>r.get(h))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this._activationMap.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new w(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this._extensionsMap.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this._extensionsArr)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.ExtensionDescriptionRegistry=p;class w{constructor(n,i){this.versionId=n,this.extensions=i}}e.ExtensionDescriptionRegistrySnapshot=w;class A{constructor(n){this._lock=new C,this._actual=new p(n,[])}async acquireLock(n){const i=await this._lock.acquire(n);return new I(this,i)}deltaExtensions(n,i,r){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(i,r)}containsActivationEvent(n){return this._actual.containsActivationEvent(n)}containsExtension(n){return this._actual.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this._actual.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(n){return this._actual.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this._actual.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this._actual.getExtensionDescriptionByIdOrUUID(n,i)}}e.LockableExtensionDescriptionRegistry=A;class I extends T.Disposable{constructor(n,i){super(),this._registry=n,this._isDisposed=!1,this._register(i)}isAcquiredFor(n){return!this._isDisposed&&this._registry===n}}e.ExtensionDescriptionRegistryLock=I;class v{constructor(n){this.name=n;const i=(0,R.promiseWithResolvers)();this.promise=i.promise,this._resolve=i.resolve}resolve(n){this._resolve(n)}}class C{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(n){const i=new v(n);return this._pendingCustomers.push(i),this._advance(),i.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const n=this._pendingCustomers.shift();this._isLocked=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),s=()=>{i&&(clearTimeout(r),i=!1,this._isLocked=!1,this._advance())};n.resolve((0,T.toDisposable)(s))}}var S;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(S||(S={}));function a(o,n){const i=o.isBuiltin?0:o.isUnderDevelopment?2:1,r=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==r)return i-r;const s=L.posix.basename(o.extensionLocation.path),t=L.posix.basename(n.extensionLocation.path);return s<t?-1:s>t?1:0}function m(o,n){const i=new c.ExtensionIdentifierSet(n);return o.filter(r=>!i.has(r.identifier))}}),define(ye[302],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0,e.writeExtHostConnection=b,e.readExtHostConnection=p;var c;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(c||(e.ExtHostConnectionType=c={}));class O{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[O.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=O;class L{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[L.ENV_KEY]="1"}}e.SocketExtHostConnection=L;class T{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[T.ENV_KEY]="1"}}e.MessagePortExtHostConnection=T;function R(A){delete A[O.ENV_KEY],delete A[L.ENV_KEY],delete A[T.ENV_KEY]}function b(A,I){R(I),A.serialize(I)}function p(A){if(A[O.ENV_KEY])return w(A,new O(A[O.ENV_KEY]));if(A[L.ENV_KEY])return w(A,new L);if(A[T.ENV_KEY])return w(A,new T);throw new Error("No connection information defined in environment!")}function w(A,I){return R(A),I}}),define(ye[114],_e([1,0,21]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.createMessageOfType=R,e.isMessageOfType=b;var O;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(O||(e.UIKind=O={}));var L;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(L||(e.ExtensionHostExitCode=L={}));var T;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(T||(e.MessageType=T={}));function R(w){const A=c.VSBuffer.alloc(1);switch(w){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}function b(w,A){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}var p;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(ye[90],_e([1,0,5,4,12,28,114,86,87,24,2,3,226]),function(de,e,c,O,L,T,R,b,p,w,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0,e.isNewAppInstall=a;let C=class extends I.Disposable{constructor(o,n){super(),this.initData=o,this.loggerService=n,this._onDidChangeTelemetryEnabled=this._register(new O.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new O.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=A.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=n.createLogger(this.extHostTelemetryLogFile,{id:p.extensionTelemetryLogChannelId,name:(0,v.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(this._outputLogger),this._register(n.onDidChangeLogLevel(i=>{(0,L.isLogLevel)(i)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===L.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(o,n,i){const r=this.getTelemetryDetails(),s=new S(n,i,o,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(o),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this._telemetryLoggers.get(o.identifier.value)??[];return this._telemetryLoggers.set(o.identifier.value,[...t,s]),s.apiTelemetryLogger}$initializeTelemetryLevel(o,n,i){this._level=o,this._telemetryIsSupported=n,this._productConfig=i??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(o){const n=Object.create(null);switch(n["common.extname"]=`${o.publisher}.${o.name}`,n["common.extversion"]=o.version,n["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,n["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,n["common.sqmid"]=this.initData.telemetryInfo.sqmId,n["common.vscodeversion"]=this.initData.version,n["common.isnewappinstall"]=a(this.initData.telemetryInfo.firstSessionDate),n["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,b.getRemoteName)((0,p.cleanRemoteAuthority)(this.initData.remote.authority)),n}$onDidChangeTelemetryLevel(o){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=o;const n=this.getTelemetryDetails();this._telemetryLoggers.forEach((i,r)=>{const s=i.filter(t=>!t.isDisposed);s.length===0?this._telemetryLoggers.delete(r):this._telemetryLoggers.set(r,s)}),this._telemetryLoggers.forEach(i=>{for(const r of i)r.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(o,n){const r=this._telemetryLoggers.get(o.value)?.filter(t=>!t.isDisposed);if(!r)return this._telemetryLoggers.delete(o.value),!1;let s=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(n),s=!0);return s}};e.ExtHostTelemetry=C,e.ExtHostTelemetry=C=Ge([Ue(0,T.IExtHostInitDataService),Ue(1,L.ILoggerService)],C);class S{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,n,i,r,s,t,f){this._extension=i,this._logger=r,this._inLoggingOnlyMode=s,this._commonProperties=t,this._onDidChangeEnableStates=new O.Emitter,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=n?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=n?.additionalCommonProperties,this._sender=o,this._telemetryEnablements={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(o,n){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:o,isErrorsEnabled:n},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(o){let n="properties"in o?o.properties??{}:o;return n=(0,p.cleanData)(n,[]),this._additionalCommonProperties&&(n=(0,w.mixin)(n,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(n=(0,w.mixin)(n,this._commonProperties)),"properties"in o?o.properties=n:o=n,o}logEvent(o,n){this._sender&&(this._extension.publisher==="vscode"?o=this._extension.name+"/"+o:o=this._extension.identifier.value+"/"+o,n=this.mixInCommonPropsAndCleanData(n||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(o,n),this._logger.trace(o,n))}logUsage(o,n){this._telemetryEnablements.isUsageEnabled&&this.logEvent(o,n)}logError(o,n){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof o=="string")this.logEvent(o,n);else{const i={name:o.name,message:o.message,stack:o.stack,cause:o.cause},r=(0,p.cleanData)(i,[]),s=new Error(r.message,{cause:r.cause});s.stack=r.stack,s.name=r.name,n=this.mixInCommonPropsAndCleanData(n||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(s,n),this._logger.trace("exception",n)}}get apiTelemetryLogger(){if(!this._apiObject){const o=this,n={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return o._telemetryEnablements.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o._onDidChangeEnableStates.event.bind(o)};this._apiObject=Object.freeze(n)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let o=this._sender;this._sender=void 0,Promise.resolve(o.flush()).then(o=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=S;function a(m){const o=Date.now()-new Date(m).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(ye[26],_e([1,0,4,2,271,140,25,5]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.isProposedApiEnabled=v,e.checkProposedApiEnabled=C,e.toExtension=o,e.toExtensionDescription=n,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");class p{constructor(s){this.dependency=s}}e.MissingExtensionDependency=p;var w;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class A{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(s,t,f){this._versionId=s,this._allExtensions=t.slice(0),this._myExtensions=f.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:T.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(s,t,f){if(this._versionId>s)throw new Error(`ExtensionHostExtensions: invalid versionId ${s} (current: ${this._versionId})`);const h=[],l=[],u=[],d=[],g=I(this._allExtensions),D=I(t),E=(z,x)=>z.extensionLocation.toString()===x.extensionLocation.toString()||z.isBuiltin===x.isBuiltin||z.isUserBuiltin===x.isUserBuiltin||z.isUnderDevelopment===x.isUnderDevelopment;for(const z of this._allExtensions){const x=D.get(z.identifier);if(!x){h.push(z.identifier),g.delete(z.identifier);continue}if(!E(z,x)){h.push(z.identifier),g.delete(z.identifier);continue}}for(const z of t){const x=g.get(z.identifier);if(!x){l.push(z);continue}if(!E(x,z)){h.push(x.identifier),g.delete(x.identifier);continue}}const _=new R.ExtensionIdentifierSet(this._myExtensions),y=new R.ExtensionIdentifierSet(f);for(const z of this._myExtensions)y.has(z)||u.push(z);for(const z of f)_.has(z)||d.push(z);const P=T.ImplicitActivationEvents.createActivationEventsMap(l),k={versionId:s,toRemove:h,toAdd:l,addActivationEvents:P,myToRemove:u,myToAdd:d};return this.delta(k),k}delta(s){if(this._versionId>=s.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:h,myToAdd:l}=s,u=new R.ExtensionIdentifierSet(t),d=new R.ExtensionIdentifierSet(h);for(let g=0;g<this._allExtensions.length;g++)u.has(this._allExtensions[g].identifier)&&(this._allExtensions.splice(g,1),g--);for(let g=0;g<this._myExtensions.length;g++)d.has(this._myExtensions[g])&&(this._myExtensions.splice(g,1),g--);for(const g of f)this._allExtensions.push(g);for(const g of l)this._myExtensions.push(g);return this._myActivationEvents=null,s}containsExtension(s){for(const t of this._myExtensions)if(R.ExtensionIdentifier.equals(t,s))return!0;return!1}containsActivationEvent(s){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(s)}_readMyActivationEvents(){const s=new Set;for(const t of this._allExtensions){if(!this.containsExtension(t.identifier))continue;const f=T.ImplicitActivationEvents.readActivationEvents(t);for(const h of f)s.add(h)}return s}}e.ExtensionHostExtensions=A;function I(r){const s=new R.ExtensionIdentifierMap;for(const t of r)s.set(t.identifier,t);return s}function v(r,s){return r.enabledApiProposals?r.enabledApiProposals.includes(s):!1}function C(r,s){if(!v(r,s))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${s}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${s}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class S{constructor(s,t,f,h){this.codeLoadingTime=s,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=h}}e.ActivationTimes=S;class a{constructor(s,t){this.description=s,this.value=t}}e.ExtensionPointContribution=a;var m;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,L.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function n(r,s){return{identifier:new R.ExtensionIdentifier((0,L.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!s,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None,this.onWillStop=c.Event.None,this.extensions=[]}activateByEvent(s){return Promise.resolve(void 0)}activateById(s,t){return Promise.resolve(void 0)}activationEventIsDone(s){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(s){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(s,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(s){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=i}),define(ye[303],_e([1,0,13,148,25,26,12,8]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(o,n,i,r){this.startup=o,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=r}}e.ExtensionActivationTimes=p;class w{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,n){return o===-1||n===-1?-1:n-o}build(){return new p(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=w;class A{constructor(o,n,i,r,s,t){this.activationFailed=o,this.activationFailedError=n,this.activationTimes=i,this.module=r,this.exports=s,this.subscriptions=t}}e.ActivatedExtension=A;class I extends A{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class v extends A{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class C extends A{constructor(o){super(!0,o,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(o,n,i,r){this._logService=r,this._registry=o,this._globalRegistry=n,this._host=i,this._operations=new L.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[o,n]of this._operations)n.dispose()}async waitForActivatingExtensions(){const o=[];for(const[n,i]of this._operations)o.push(i.wait());await Promise.all(o)}isActivated(o){const n=this._operations.get(o);return!!(n&&n.value)}getActivatedExtension(o){const n=this._operations.get(o);if(!n||!n.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return n.value}async activateByEvent(o,n){if(this._alreadyActivatedEvents[o])return;const i=this._registry.getExtensionDescriptionsForActivationEvent(o);await this._activateExtensions(i.map(r=>({id:r.identifier,reason:{startup:n,extensionId:r.identifier,activationEvent:o}}))),this._alreadyActivatedEvents[o]=!0}activateById(o,n){const i=this._registry.getExtensionDescription(o);if(!i)throw new Error(`Extension '${o.value}' is not known`);return this._activateExtensions([{id:i.identifier,reason:n}])}async _activateExtensions(o){const n=o.filter(i=>!this.isActivated(i.id)).map(i=>this._handleActivationRequest(i));await Promise.all(n.map(i=>i.wait()))}_handleActivationRequest(o){if(this._operations.has(o.id))return this._operations.get(o.id);if(this._isHostExtension(o.id))return this._createAndSaveOperation(o,null,[],null);const n=this._registry.getExtensionDescription(o.id);if(!n){const s=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this._createAndSaveOperation(o,null,[],new C(s));return this._host.onExtensionActivationError(o.id,s,new T.MissingExtensionDependency(o.id.value)),t}const i=[],r=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const s of r){if(this._isResolvedExtension(s))continue;const t=this._operations.get(s);if(t){i.push(t);continue}if(this._isHostExtension(s)){i.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(s).identifier,reason:o.reason}));continue}const f=this._registry.getExtensionDescription(s);if(f){if(!f.main&&!f.browser)continue;i.push(this._handleActivationRequest({id:f.identifier,reason:o.reason}));continue}const h=n.displayName||n.identifier.value,l=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${s}'`),u=this._createAndSaveOperation(o,n.displayName,[],new C(l));return this._host.onExtensionActivationError(n.identifier,l,new T.MissingExtensionDependency(s)),u}return this._createAndSaveOperation(o,n.displayName,i,null)}_createAndSaveOperation(o,n,i,r){const s=new a(o.id,n,o.reason,i,r,this._host,this._logService);return this._operations.set(o.id,s),s}_isHostExtension(o){return O.ExtensionDescriptionRegistry.isHostExtension(o,this._registry,this._globalRegistry)}_isResolvedExtension(o){const n=this._globalRegistry.getExtensionDescription(o);return n?!n.main&&!n.browser:!1}};e.ExtensionsActivator=S,e.ExtensionsActivator=S=Ge([Ue(3,R.ILogService)],S);let a=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(o,n,i,r,s,t,f){this._id=o,this._displayName=n,this._reason=i,this._deps=r,this._value=s,this._host=t,this._logService=f,this._barrier=new b.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let o=0;o<this._deps.length;o++){const n=this._deps[o];if(n.value&&!n.value.activationFailed){this._deps.splice(o,1),o--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this._value=new C(i),this._host.onExtensionActivationError(this._id,i,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(o=>o.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(o){const n=new Error;if(o&&o.name&&(n.name=o.name),o&&o.message?n.message=`Activating extension '${this._id.value}' failed: ${o.message}.`:n.message=`Activating extension '${this._id.value}' failed: ${o}.`,o&&o.stack&&(n.stack=o.stack),this._value=new C(n),this._isDisposed&&c.isCancellationError(o))return;this._host.onExtensionActivationError(this._id,n,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(o)}}};a=Ge([Ue(6,R.ILogService)],a)}),define(ye[304],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[305],_e([1,0,242,13,40,137,109,37,25,304,139,140]),function(de,e,c,O,L,T,R,b,p,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const v=b.Registry.as(R.Extensions.JSONContribution);class C{constructor(s,t,f){this._messageHandler=s,this._extension=t,this._extensionPointId=f}_msg(s,t){this._messageHandler({type:s,message:t,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(s){this._msg(L.default.Error,s)}warn(s){this._msg(L.default.Warning,s)}info(s){this._msg(L.default.Info,s)}}e.ExtensionMessageCollector=C;class S{static _toSet(s){const t=new p.ExtensionIdentifierSet;for(let f=0,h=s.length;f<h;f++)t.add(s[f].description.identifier);return t}static compute(s,t){if(!s||!s.length)return new S(t,[]);if(!t||!t.length)return new S([],s);const f=this._toSet(s),h=this._toSet(t),l=t.filter(d=>!f.has(d.description.identifier)),u=s.filter(d=>!h.has(d.description.identifier));return new S(l,u)}constructor(s,t){this.added=s,this.removed=t}}e.ExtensionPointUserDelta=S;class a{constructor(s,t){this.name=s,this.defaultExtensionKind=t,this._handler=null,this._users=null,this._delta=null}setHandler(s){if(this._handler!==null)throw new Error("Handler already set!");this._handler=s,this._handle()}acceptUsers(s){this._delta=S.compute(this._users,s),this._users=s,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(s){(0,O.onUnexpectedError)(s)}}}e.ExtensionPoint=a;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[c.localize(0,null),c.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:c.localize(2,null),properties:{vscode:{type:"string",description:c.localize(3,null),default:"^1.22.0"}}},publisher:{description:c.localize(4,null),type:"string"},displayName:{description:c.localize(5,null),type:"string"},categories:{description:c.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:c.localize(7,null)}]}},galleryBanner:{type:"object",description:c.localize(8,null),properties:{color:{description:c.localize(9,null),type:"string"},theme:{description:c.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:c.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:c.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:c.localize(13,null)},enabledApiProposals:{markdownDescription:c.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:c.localize(15,null),type:"string",enum:["none"],enumDescriptions:[c.localize(16,null)]},activationEvents:{description:c.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:c.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:c.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:c.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:c.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:c.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:c.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:c.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:c.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:c.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:c.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:c.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:c.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:c.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:c.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:c.localize(32,null)},{label:"onUri",body:"onUri",description:c.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:c.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:c.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:c.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:c.localize(37,null)},{label:"onRenderer",description:c.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:c.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:c.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:c.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:c.localize(42,null)},{label:"*",description:c.localize(43,null),body:"*"}]}},badges:{type:"array",description:c.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:c.localize(45,null)},href:{type:"string",description:c.localize(46,null)},description:{type:"string",description:c.localize(47,null)}}}},markdown:{type:"string",description:c.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:c.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:c.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:c.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:c.localize(52,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:c.localize(53,null)},{body:["workspace"],description:c.localize(54,null)},{body:["ui","workspace"],description:c.localize(55,null)},{body:["workspace","ui"],description:c.localize(56,null)},{body:[],description:c.localize(57,null)}]},capabilities:{description:c.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:c.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:c.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(61,null),c.localize(62,null),c.localize(63,null)]},description:{type:"string",markdownDescription:c.localize(64,null)}}},untrustedWorkspaces:{description:c.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:c.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(67,null),c.localize(68,null),c.localize(69,null)]},restrictedConfigurations:{description:c.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:c.localize(71,null)}}}}},sponsor:{description:c.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:c.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:c.localize(74,null),type:"string"},"vscode:uninstall":{description:c.localize(75,null),type:"string"}}},icon:{type:"string",description:c.localize(76,null)},l10n:{type:"string",description:c.localize(77,null)},pricing:{type:"string",markdownDescription:c.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this._extensionPoints=new Map}registerExtensionPoint(s){if(this._extensionPoints.has(s.extensionPoint))throw new Error("Duplicate extension point: "+s.extensionPoint);const t=new a(s.extensionPoint,s.defaultExtensionKind);return this._extensionPoints.set(s.extensionPoint,t),s.activationEventsGenerator&&I.ImplicitActivationEvents.register(s.extensionPoint,s.activationEventsGenerator),e.schema.properties.contributes.properties[s.extensionPoint]=s.jsonSchema,v.registerSchema(o,e.schema),t}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};b.Registry.add(i.ExtensionsRegistry,new n),e.ExtensionsRegistry=b.Registry.as(i.ExtensionsRegistry),v.registerSchema(o,e.schema),v.registerSchema(A.productSchemaId,{properties:{extensionEnabledApiProposals:{description:c.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(ye[306],_e([1,0,238,18,24,305,41,4]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:c.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:c.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:c.localize(2,null),default:""}}};var w;(function(v){function C(S,a,m){if(!S)return;const o=O.isString(S.type)?S.type:void 0;if(!o||o.length===0){m.error(c.localize(3,null));return}const n=[];if(Array.isArray(S.required))for(const i of S.required)O.isString(i)&&n.push(i);return{extensionId:a.value,taskType:o,required:n,properties:S.properties?L.deepClone(S.properties):{},when:S.when?R.ContextKeyExpr.deserialize(S.when):void 0}}v.from=C})(w||(w={}));const A=T.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(v,C)=>{for(const S of v)S.type&&C.push(`onTaskType:${S.type}`)},jsonSchema:{description:c.localize(4,null),type:"array",items:p}});class I{constructor(){this._onDefinitionsChanged=new b.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((C,S)=>{A.setHandler((a,m)=>{this._schema=void 0;try{for(const o of m.removed){const n=o.value;for(const i of n)this.taskTypes&&i.type&&this.taskTypes[i.type]&&delete this.taskTypes[i.type]}for(const o of m.added){const n=o.value;for(const i of n){const r=w.from(i,o.description.identifier,o.collector);r&&(this.taskTypes[r.taskType]=r)}}(m.removed.length>0||m.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}C(void 0)})})}onReady(){return this.readyPromise}get(C){return this.taskTypes[C]}all(){return Object.keys(this.taskTypes).map(C=>this.taskTypes[C])}getJsonSchema(){if(this._schema===void 0){const C=[];for(const S of this.all()){const a={type:"object",additionalProperties:!1};S.required.length>0&&(a.required=S.required.slice(0)),S.properties!==void 0?a.properties=L.deepClone(S.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[S.taskType]},C.push(a)}this._schema={oneOf:C}}return this._schema}}e.TaskDefinitionRegistry=new I}),define(ye[307],_e([1,0,239,18,23,24,41,306]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new R.RawContextKey("taskRunning",!1,c.localize(0,null)),e.TASKS_CATEGORY=c.localize2(2,"Tasks");var p;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(p||(e.ShellQuoting=p={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function M(B){if(!B)return N.Strong;switch(B.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=M}(p||(e.ShellQuoting=p={}));var w;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var A;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(A||(e.RevealKind=A={})),function(N){function M(B){switch(B.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=M}(A||(e.RevealKind=A={}));var I;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(N){function M(B){switch(B.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=M}(I||(e.RevealProblemKind=I={}));var v;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(v||(e.PanelKind=v={})),function(N){function M(B){switch(B.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=M}(v||(e.PanelKind=v={}));var C;(function(N){N.defaults={echo:!0,reveal:A.Always,revealProblems:I.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(C||(e.PresentationOptions=C={}));var S;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(N){function M(W){switch(W.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=M;function B(W){switch(W){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=B}(S||(e.RuntimeType=S={}));var a;(function(N){function M(B){return O.isString(B)?B:B.value}N.value=M})(a||(e.CommandString=a={}));var m;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function M(W){return W===N.Clean._id||W===N.Build._id||W===N.Rebuild._id||W===N.Test._id}N.is=M;function B(W){if(W!==void 0)return O.isString(W)?M(W)?{_id:W,isDefault:!1}:void 0:W}N.from=B})(m||(e.TaskGroup=m={}));var o;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var n;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function M(B){switch(B){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=M})(n||(e.TaskSourceKind=n={}));var i;(function(N){N.parallel="parallel",N.sequence="sequence"})(i||(e.DependsOrder=i={}));var r;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var s;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(s||(e.RunOptions=s={}));class t{constructor(M,B,W,Y,Z,G){this._label="",this._id=M,B&&(this._label=B),W&&(this.type=W),this.runOptions=Y,this.configurationProperties=Z,this._source=G}getDefinition(M){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const M={folder:this.getFolderId(),id:this._id};return JSON.stringify(M)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(M,B=!1){if(M===void 0)return!1;if(O.isString(M))return M===this._label||M===this.configurationProperties.identifier||B&&M===this._id;const W=this.getDefinition(!0);return W!==void 0&&W._key===M._key}getQualifiedLabel(){const M=this.getWorkspaceFolder();return M?`${this._label} (${M.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(M){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),M&&(this._taskLoadMessages=this._taskLoadMessages.concat(M))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class f extends t{constructor(M,B,W,Y,Z,G,Q,re){super(M,W,void 0,Q,re,B),this.command={},this._source=B,this.hasDefinedMatchers=G,Z&&(this.command=Z)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(M=!1){if(M&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case S.Shell:B="shell";break;case S.Process:B="process";break;case S.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(M){return M instanceof f}getMapKey(){const M=this._source.config.workspaceFolder;return M?`${M.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===n.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const M=this.getFolderId();if(!M)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const W={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:B};return JSON.stringify(W)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(M){return new f(M._id,M._source,M._label,M.type,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.CustomTask=f;class h extends t{constructor(M,B,W,Y,Z,G,Q){super(M,W,Y,G,Q,B),this._source=B,this.configures=Z}static is(M){return M instanceof h}fromObject(M){return M}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===n.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getKey(){const M=this.getFolderId();if(!M)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const W={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:B};return JSON.stringify(W)}}e.ConfiguringTask=h;class l extends t{constructor(M,B,W,Y,Z,G,Q,re,te){super(M,W,Y,re,te,B),this.defines=Z,this.hasDefinedMatchers=Q,this.command=G,this.icon=te.icon,this.hide=te.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(M){return M instanceof l}getMapKey(){const M=this._source.workspaceFolder;return M?`${this._source.scope.toString()}|${M.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const M={type:"contributed",scope:this._source.scope,id:this._id};return M.folder=this.getFolderId(),JSON.stringify(M)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(M){return new l(M._id,M._source,M._label,M.type,M.defines,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.ContributedTask=l;class u extends t{constructor(M,B,W,Y,Z,G){super(M,W,Y,Z,G,B),this._source=B}clone(){return new u(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(M){return M instanceof u}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(M){return new u(M._id,M._source,M._label,M.type,M.runOptions,M.configurationProperties)}}e.InMemoryTask=u;var d;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(N){N._default=N.Terminal}(d||(e.ExecutionEngine=d={}));var g;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(g||(e.JsonSchemaVersion=g={}));class D{constructor(M){this._order=new Map;for(let B=0;B<M.length;B++)this._order.set(M[B].uri.toString(),B)}compare(M,B){const W=M.getWorkspaceFolder(),Y=B.getWorkspaceFolder();if(W&&Y){let Z=this._order.get(W.uri.toString());Z=Z===void 0?0:Z+1;let G=this._order.get(Y.uri.toString());return G=G===void 0?0:G+1,Z===G?M._label.localeCompare(B._label):Z-G}else return!W&&Y?-1:W&&!Y?1:0}}e.TaskSorter=D;var E;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(E||(e.TaskEventKind=E={}));var _;(function(N){N.SingleRun="singleRun",N.Background="background"})(_||(e.TaskRunType=_={}));var y;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var P;(function(N){function M(re){return{taskId:re._id,taskName:re.configurationProperties.name,runType:re.configurationProperties.isBackground?"background":"singleRun",group:re.configurationProperties.group,__task:re}}function B(re,te,ve){return{...M(re),kind:"start",terminalId:te,resolvedVariables:ve}}N.start=B;function W(re,te,ve){return{...M(re),kind:"processStarted",terminalId:te,processId:ve}}N.processStarted=W;function Y(re,te,ve){return{...M(re),kind:"processEnded",terminalId:te,exitCode:ve}}N.processEnded=Y;function Z(re,te,ve){return{...M(re),kind:"terminated",exitReason:ve,terminalId:te}}N.terminated=Z;function G(re,te,ve){return{...M(te),kind:re,terminalId:ve}}N.general=G;function Q(){return{kind:"changed"}}N.changed=Q})(P||(e.TaskEvent=P={}));var k;(function(N){function M(W){const Y=Object.keys(W).sort();let Z="";for(const G of Y){let Q=W[G];Q instanceof Object?Q=M(Q):typeof Q=="string"&&(Q=Q.replace(/,/g,",,")),Z+=G+","+Q+","}return Z}function B(W){const Z={_key:M(W),type:W.taskType};return Object.assign(Z,W),Z}N.create=B})(k||(e.KeyedTaskIdentifier=k={}));var z;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var x;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(x||(e.TasksSchemaProperties=x={}));var F;(function(N){function M(B,W){const Y=b.TaskDefinitionRegistry.get(B.type);if(Y===void 0){const re=T.deepClone(B);return delete re._key,k.create(re)}const Z=Object.create(null);Z.type=Y.taskType;const G=new Set;Y.required.forEach(re=>G.add(re));const Q=Y.properties;for(const re of Object.keys(Q)){const te=B[re];if(te!=null)Z[re]=te;else if(G.has(re)){const ve=Q[re];if(ve.default!==void 0)Z[re]=T.deepClone(ve.default);else switch(ve.type){case"boolean":Z[re]=!1;break;case"number":case"integer":Z[re]=0;break;case"string":Z[re]="";break;default:W.error(c.localize(1,null,JSON.stringify(B,void 0,0),re));return}}}return k.create(Z)}N.createTaskIdentifier=M})(F||(e.TaskDefinition=F={}))}),define(ye[308],_e([1,0,13]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class O{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((R,b)=>{this._actualOk=R,this._actualErr=b,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(R){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=R,this._actual&&this._actualOk(R))}resolveErr(R){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=R,this._actual?this._actualErr(R):(0,c.onUnexpectedError)(R))}then(R,b){return this._ensureActual().then(R,b)}catch(R){return this._ensureActual().then(void 0,R)}finally(R){return this._ensureActual().finally(R)}}e.LazyPromise=O;class L extends O{constructor(){super(),this._hasErr=!0,this._err=new c.CancellationError}}e.CanceledLazyPromise=L}),define(ye[68],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.ProxyIdentifier=void 0,e.createProxyIdentifier=L,e.getStringIdentifierForProxy=T;class c{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++c.count}}e.ProxyIdentifier=c;const O=[];function L(b){const p=new c(b);return O[p.nid]=p,p}function T(b){return O[b].sid}class R{constructor(p){this.value=p}}e.SerializableObjectWithBuffers=R}),define(ye[6],_e([1,0,68]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var L;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(L||(e.TabInputKind=L={}));var T;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(T||(e.TabModelOperationKind=T={}));var R;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var b;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var p;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var w;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var A;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class I{static{this._n=0}static mixin(m){return m._id=I._n++,m}}e.IdObject=I;var v;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(v||(e.ISuggestDataDtoField=v={}));var C;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(C||(e.ISuggestResultDtoField=C={}));var S;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.MainContext={MainThreadAuthentication:(0,c.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,c.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,c.createProxyIdentifier)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,c.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,c.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,c.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,c.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,c.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,c.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,c.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,c.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,c.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,c.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,c.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,c.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,c.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,c.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,c.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,c.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,c.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,c.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,c.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,c.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,c.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,c.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,c.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,c.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,c.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,c.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,c.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,c.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,c.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,c.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,c.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,c.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,c.createProxyIdentifier)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,c.createProxyIdentifier)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,c.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,c.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,c.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,c.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,c.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,c.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,c.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,c.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,c.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,c.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,c.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,c.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,c.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,c.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,c.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,c.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,c.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,c.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,c.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,c.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,c.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,c.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,c.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,c.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,c.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,c.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,c.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,c.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,c.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,c.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,c.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,c.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,c.createProxyIdentifier)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,c.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,c.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,c.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,c.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,c.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,c.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,c.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,c.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,c.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,c.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,c.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,c.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,c.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,c.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,c.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,c.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,c.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,c.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,c.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,c.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,c.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,c.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,c.createProxyIdentifier)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,c.createProxyIdentifier)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,c.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,c.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,c.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,c.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,c.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,c.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,c.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,c.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,c.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,c.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,c.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,c.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,c.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,c.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,c.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,c.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,c.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,c.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,c.createProxyIdentifier)("ExtHostOutputService"),ExtHostLabelService:(0,c.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,c.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,c.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,c.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,c.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,c.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,c.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,c.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,c.createProxyIdentifier)("ExtHostChat"),ExtHostChatAgents2:(0,c.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,c.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,c.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,c.createProxyIdentifier)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,c.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,c.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,c.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,c.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,c.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,c.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,c.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,c.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,c.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,c.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,c.createProxyIdentifier)("ExtHostIssueReporter")}}),define(ye[91],_e([1,0,5,12,6,20]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(p,w){this._extHostLogService=w,this._reportedUsages=new Set,this._telemetryShape=p.getProxy(L.MainContext.MainThreadTelemetry)}report(p,w,A){const I=this.getUsageKey(p,w);this._reportedUsages.has(I)||(this._reportedUsages.add(I),w.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${p}' is deprecated. ${A}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:p}))}getUsageKey(p,w){return`${p}-${w.identifier.value}`}};e.ExtHostApiDeprecationService=R,e.ExtHostApiDeprecationService=R=Ge([Ue(0,T.IExtHostRpcService),Ue(1,O.ILogService)],R),e.NullApiDeprecationService=Object.freeze(new class{report(b,p,w){}})}),define(ye[309],_e([1,0,38,3,6]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class T{static{this._pool=0}constructor(p,w){this.extension=p,this.provider=w,this.handle=T._pool++}}class R{static{this._nextId=0}constructor(p){this._chatProvider=new Map,this._chatSessions=new Map,this._proxy=p.getProxy(L.MainContext.MainThreadChat)}registerChatProvider(p,w,A){const I=new T(p,A);return this._chatProvider.set(I.handle,I),this._proxy.$registerChatProvider(I.handle,w),(0,O.toDisposable)(()=>{this._proxy.$unregisterChatProvider(I.handle),this._chatProvider.delete(I.handle)})}transferChatSession(p,w){const A=c.Iterable.find(this._chatSessions.keys(),I=>this._chatSessions.get(I)===p)??0;typeof A=="number"&&this._proxy.$transferChatSession(A,w)}async $prepareChat(p,w){const A=this._chatProvider.get(p);if(!A)return;const I=await A.provider.prepareSession(w);if(!I)return;const v=R._nextId++;return this._chatSessions.set(v,I),{id:v}}$releaseSession(p){this._chatSessions.delete(p)}}e.ExtHostChat=R}),define(ye[310],_e([1,0,6]),function(de,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class O{constructor(T){const R=T.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(b){return R.$writeText(b)}})}}e.ExtHostClipboard=O}),define(ye[311],_e([1,0,24,6,28,20]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let R=class{constructor(A,I){this._mainThreadConsole=A.getProxy(O.MainContext.MainThreadConsole),this._includeStack=I.consoleForward.includeStack,this._logNative=I.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("debug","debug"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(A,I){const v=this,C=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){v._handleConsoleCall(A,I,C,arguments)}})}_handleConsoleCall(A,I,v,C){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:I,arguments:p(C,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(A,v,C)}};e.AbstractExtHostConsoleForwarder=R,e.AbstractExtHostConsoleForwarder=R=Ge([Ue(0,T.IExtHostRpcService),Ue(1,L.IExtHostInitDataService)],R);const b=1e5;function p(w,A){const I=[];if(w.length)for(let v=0;v<w.length;v++){let C=w[v];if(typeof C>"u")C="undefined";else if(C instanceof Error){const S=C;S.stack?C=S.stack:C=S.toString()}I.push(C)}if(A){const v=new Error().stack;v&&I.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,c.safeStringify)(I);return v.length>b?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(ye[312],_e([1,0,2,6,26]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(b){this._proxy=b.getProxy(O.MainContext.MainThreadDialogs)}showOpenDialog(b,p){return p?.allowUIResources&&(0,L.checkProposedApiEnabled)(b,"showLocal"),this._proxy.$showOpenDialog(p).then(w=>w?w.map(A=>c.URI.revive(A)):void 0)}showSaveDialog(b){return this._proxy.$showSaveDialog(b).then(p=>p?c.URI.revive(p):void 0)}}e.ExtHostDialogs=T}),define(ye[313],_e([1,0,3,6]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class L{constructor(R){this._handlePool=0,this._proxy=R.getProxy(O.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const b=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(b,R),(0,c.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(b)})}}e.ExtHostLabelService=L}),define(ye[115],_e([1,0,11,14,2,5,12,6,28,20]),function(de,e,c,O,L,T,R,b,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let A=class{constructor(v,C,S){this.logService=S,this.bundleCache=new Map,this._proxy=C.getProxy(b.MainContext.MainThreadLocalization),this.currentLanguage=v.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===c.LANGUAGE_DEFAULT}getMessage(v,C){const{message:S,args:a,comment:m}=C;if(this.isDefaultLanguage)return(0,O.format2)(S,a??{});let o=S;m&&m.length>0&&(o+=`/${Array.isArray(m)?m.join(""):m}`);const n=this.bundleCache.get(v)?.contents[o];return n||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,O.format2)(n??S,a??{})}getBundle(v){return this.bundleCache.get(v)?.contents}getBundleUri(v){return this.bundleCache.get(v)?.uri}async initializeLocalizedMessages(v){if(this.isDefaultLanguage||!v.l10n&&!v.isBuiltin||this.bundleCache.has(v.identifier.value))return;let C;const S=await this.getBundleLocation(v);if(!S){this.logService.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const a=await this._proxy.$fetchBundleContents(S),m=JSON.parse(a);C=v.isBuiltin?m.contents?.bundle:m}catch(a){this.logService.error(`Failed to load translations for ${v.identifier.value} from ${S}: ${a.message}`);return}C&&this.bundleCache.set(v.identifier.value,{contents:C,uri:S})}async getBundleLocation(v){if(v.isBuiltin){const C=await this._proxy.$fetchBuiltInBundleUri(v.identifier.value,this.currentLanguage);return L.URI.revive(C)}return v.l10n?L.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=A,e.ExtHostLocalizationService=A=Ge([Ue(0,p.IExtHostInitDataService),Ue(1,w.IExtHostRpcService),Ue(2,R.ILogService)],A),e.IExtHostLocalizationService=(0,T.createDecorator)("IExtHostLocalizationService")}),define(ye[149],_e([1,0,12,6,28,20,2,57]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let p=class extends c.AbstractLoggerService{constructor(I,v){super(v.logLevel,v.logsLocation,v.loggers.map(C=>(0,b.revive)(C))),this._proxy=I.getProxy(O.MainContext.MainThreadLogger)}$setLogLevel(I,v){v?this.setLogLevel(R.URI.revive(v),I):this.setLogLevel(I)}setVisibility(I,v){super.setVisibility(I,v),this._proxy.$setVisibility(I,v)}doCreateLogger(I,v,C){return new w(this._proxy,I,v,C)}};e.ExtHostLoggerService=p,e.ExtHostLoggerService=p=Ge([Ue(0,T.IExtHostRpcService),Ue(1,L.IExtHostInitDataService)],p);class w extends c.AbstractMessageLogger{constructor(I,v,C,S){super(S?.logLevel==="always"),this.proxy=I,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(C),this.proxy.$createLogger(v,S).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,v){const C=[[I,v]];this.isLoggerCreated?this.doLog(C):this.buffer.push(...C)}doLog(I){this.proxy.$log(this.file,I)}flush(){this.proxy.$flush(this.file)}}}),define(ye[116],_e([1,0,6,5,3,20,21]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,O.createDecorator)("IExtHostManagedSockets");let b=class{constructor(I){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=I.getProxy(c.MainContext.MainThreadManagedSockets)}setFactory(I,v){for(const C of this._managedRemoteSockets.values())C.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new p(I,v),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(I){if(!this._factory||this._factory.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const v=++this._remoteSocketIdCounter,C=await this._factory.makeConnection(),S=new L.DisposableStore;return this._managedRemoteSockets.set(v,new w(v,C,S)),S.add((0,L.toDisposable)(()=>this._managedRemoteSockets.delete(v))),S.add(C.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(v),S.dispose()})),S.add(C.onDidClose(a=>{this._proxy.$onDidManagedSocketClose(v,a?.stack??a?.message),S.dispose()})),S.add(C.onDidReceiveMessage(a=>this._proxy.$onDidManagedSocketHaveData(v,R.VSBuffer.wrap(a)))),v}$remoteSocketWrite(I,v){this._managedRemoteSockets.get(I)?.actual.send(v.buffer)}$remoteSocketEnd(I){const v=this._managedRemoteSockets.get(I);v&&(v.actual.end(),v.dispose())}async $remoteSocketDrain(I){await this._managedRemoteSockets.get(I)?.actual.drain?.()}};e.ExtHostManagedSockets=b,e.ExtHostManagedSockets=b=Ge([Ue(0,T.IExtHostRpcService)],b);class p{constructor(I,v){this.socketFactoryId=I,this.makeConnection=v}}class w extends L.Disposable{constructor(I,v,C){super(),this.socketId=I,this.actual=v,this._register(C)}}}),define(ye[314],_e([1,0,6,12,26]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(b){return b&&b.title}let R=class{constructor(p,w){this._logService=w,this._proxy=p.getProxy(c.MainContext.MainThreadMessageService)}showMessage(p,w,A,I,v){const C={source:{identifier:p.identifier,label:p.displayName||p.name}};let S;typeof I=="string"||T(I)?S=[I,...v]:(C.modal=I?.modal,C.useCustom=I?.useCustom,C.detail=I?.detail,S=v),C.useCustom&&(0,L.checkProposedApiEnabled)(p,"resolvers");const a=[];let m=!1;for(let o=0;o<S.length;o++){const n=S[o];if(typeof n=="string")a.push({title:n,handle:o,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:r}=n;a.push({title:i,isCloseAffordance:!!r,handle:o}),r&&(m?this._logService.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,n):m=!0)}else this._logService.warn(`[${p.identifier}] Invalid message item:`,n)}return this._proxy.$showMessage(w,A,C,a).then(o=>{if(typeof o=="number")return S[o]})}};e.ExtHostMessageService=R,e.ExtHostMessageService=R=Ge([Ue(1,O.ILogService)],R)}),define(ye[315],_e([1,0,3,18,2,26,6]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class b{constructor(w){this.handlers=new Map,this.proxy=w.getProxy(R.MainContext.MainThreadProfileContentHandlers)}registerProfileContentHandler(w,A,I){if((0,T.checkProposedApiEnabled)(w,"profileContentHandlers"),this.handlers.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.handlers.set(A,I),this.proxy.$registerProfileContentHandler(A,I.name,I.description,w.identifier.value),(0,c.toDisposable)(()=>{this.handlers.delete(A),this.proxy.$unregisterProfileContentHandler(A)})}async $saveProfile(w,A,I,v){const C=this.handlers.get(w);if(!C)throw new Error(`Unknown handler with id: ${w}`);return C.saveProfile(A,I,v)}async $readProfile(w,A,I){const v=this.handlers.get(w);if(!v)throw new Error(`Unknown handler with id: ${w}`);return v.readProfile((0,O.isString)(A)?A:L.URI.revive(A),I)}}e.ExtHostProfileContentHandlers=b}),define(ye[117],_e([1,0,6,4,5]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(b){this._onDidChangePassword=new O.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=b.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(b){this._onDidChangePassword.fire(b)}get(b,p){return this._proxy.$getPassword(b,p)}store(b,p,w){return this._proxy.$setPassword(b,p,w)}delete(b,p){return this._proxy.$deletePassword(b,p)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,L.createDecorator)("IExtHostSecretState")}),define(ye[316],_e([1,0,22,3,6]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class T{static{this.ID_POOL=1}constructor(b){this.providers=new Map,this.sessions=new Map,this.proxy=b.getProxy(L.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(b,p,w){const A=this.providers.get(b);if(!A)return;const I=new O.DisposableStore,v=new c.CancellationTokenSource;this.sessions.set(p,v);const C=I.add(A.provideSpeechToTextSession(v.token,w?{language:w}:void 0));I.add(C.onDidChange(S=>{v.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(p,S)})),I.add(v.token.onCancellationRequested(()=>I.dispose()))}async $cancelSpeechToTextSession(b){this.sessions.get(b)?.dispose(!0),this.sessions.delete(b)}async $createKeywordRecognitionSession(b,p){const w=this.providers.get(b);if(!w)return;const A=new O.DisposableStore,I=new c.CancellationTokenSource;this.sessions.set(p,I);const v=A.add(w.provideKeywordRecognitionSession(I.token));A.add(v.onDidChange(C=>{I.token.isCancellationRequested||this.proxy.$emitKeywordRecognitionEvent(p,C)})),A.add(I.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(b){this.sessions.get(b)?.dispose(!0),this.sessions.delete(b)}registerProvider(b,p,w){const A=T.ID_POOL++;return this.providers.set(A,w),this.proxy.$registerProvider(A,p,{extension:b,displayName:b.value}),(0,O.toDisposable)(()=>{this.proxy.$unregisterProvider(A),this.providers.delete(A)})}}e.ExtHostSpeech=T}),define(ye[118],_e([1,0,6,4,5]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(b,p){this._logService=p,this._onDidChangeStorage=new O.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=b.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(b,p){this._proxy.$registerExtensionStorageKeysToSync(b,p)}async initializeExtensionStorage(b,p,w){const A=await this._proxy.$initializeExtensionStorage(b,p);let I;return A&&(I=this.safeParseValue(b,p,A)),I||w}setValue(b,p,w){return this._proxy.$setValue(b,p,w)}$acceptValue(b,p,w){const A=this.safeParseValue(b,p,w);A&&this._onDidChangeStorage.fire({shared:b,key:p,value:A})}safeParseValue(b,p,w){try{return JSON.parse(w)}catch(A){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${b}): ${A}`)}}}e.ExtHostStorage=T,e.IExtHostStorage=(0,L.createDecorator)("IExtHostStorage")}),define(ye[317],_e([1,0,3,15,2,6]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{static{this.supportedSchemes=new Set([O.Schemas.http,O.Schemas.https])}constructor(p){this._openers=new Map,this._proxy=p.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(p,w,A,I){if(this._openers.has(w))throw new Error(`Opener with id '${w}' already registered`);const v=I.schemes.find(C=>!R.supportedSchemes.has(C));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this._openers.set(w,A),this._proxy.$registerUriOpener(w,I.schemes,p,I.label),(0,c.toDisposable)(()=>{this._openers.delete(w),this._proxy.$unregisterUriOpener(w)})}async $canOpenUri(p,w,A){const I=this._openers.get(p);if(!I)throw new Error(`Unknown opener with id: ${p}`);const v=L.URI.revive(w);return I.canOpenExternalUri(v,A)}async $openUri(p,w,A){const I=this._openers.get(p);if(!I)throw new Error(`Unknown opener id: '${p}'`);return I.openExternalUri(L.URI.revive(w.resolvedUri),{sourceUri:L.URI.revive(w.sourceUri)},A)}}e.ExtHostUriOpeners=R}),define(ye[318],_e([1,0,6,2,3,13,25]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class b{static{this.HandlePool=0}constructor(w){this.handles=new R.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=w.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(w,A){const I=w.identifier;if(this.handles.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const v=b.HandlePool++;return this.handles.add(I),this.handlers.set(v,A),this._proxy.$registerUriHandler(v,I,w.displayName||w.name),(0,L.toDisposable)(()=>{this.handles.delete(I),this.handlers.delete(v),this._proxy.$unregisterUriHandler(v)})}$handleExternalUri(w,A){const I=this.handlers.get(w);if(!I)return Promise.resolve(void 0);try{I.handleUri(O.URI.revive(A))}catch(v){(0,T.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(w){return O.URI.revive(await this._proxy.$createAppUri(w))}}e.ExtHostUrls=b}),define(ye[92],_e([1,0,4,3,15,24,2,246,284,113,6]),function(de,e,c,O,L,T,R,b,p,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviews=e.ExtHostWebview=void 0,e.shouldSerializeBuffersForPostMessage=v,e.toExtensionData=a,e.serializeWebviewOptions=m;class I{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#h;constructor(r,s,t,f,h,l,u){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new c.Emitter,this._onDidDispose=this.#d.event,this.#e=r,this.#t=s,this.#o=t,this.#n=f,this.#s=h,this.#r=l,this.#u=v(l),this.#h=C(l),this.#i=u}#d;dispose(){this.#c=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#l=!0,(0,w.asWebviewUri)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===L.Schemas.https||r.scheme===L.Schemas.http){let s=r.toString();return s.endsWith("/")||(s+="/"),s+" "+w.webviewGenericCspSource}return w.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#a}set html(r){this.assertNotDisposed(),this.#a!==r&&(this.#a=r,this.#h&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(r)))}get options(){return this.assertNotDisposed(),this.#o}set options(r){this.assertNotDisposed(),T.equals(this.#o,r)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const s=(0,p.serializeWebviewMessage)(r,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,s.message,...s.buffers)}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(r){if(!this.#h)return r;const s=this.#r.extensionLocation?.scheme===L.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===L.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,h,l,u,d,g)=>{const D=R.URI.from({scheme:u||"file",path:decodeURIComponent(d)}),E=(0,w.asWebviewUri)(D,{isRemote:s,authority:t}).toString();return`${h}${E}${g}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,h,l,u,d,g)=>{const D=R.URI.from({scheme:u||"file",path:decodeURIComponent(d)}),E=(0,w.asWebviewUri)(D,{isRemote:s,authority:t}).toString();return`${h}${E}${g}`})}}e.ExtHostWebview=I;function v(i){try{const r=(0,b.normalizeVersion)((0,b.parseVersion)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function C(i){try{const r=(0,b.normalizeVersion)((0,b.parseVersion)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class S extends O.Disposable{constructor(r,s,t,f,h){super(),this.remoteInfo=s,this.workspace=t,this._logService=f,this._deprecationService=h,this._webviews=new Map,this._webviewProxy=r.getProxy(A.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const r of this._webviews.values())r.dispose();this._webviews.clear()}$onMessage(r,s,t){const f=this.getWebview(r);if(f){const{message:h}=(0,p.deserializeWebviewMessage)(s,t.value);f._onMessageEmitter.fire(h)}}$onMissingCsp(r,s){this._logService.warn(`${s} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,s,t){const f=new I(r,this._webviewProxy,o(s),this.remoteInfo,this.workspace,t,this._deprecationService);this._webviews.set(r,f);const h=f._onDidDispose(()=>{h.dispose(),this.deleteWebview(r)});return f}deleteWebview(r){this._webviews.delete(r)}getWebview(r){return this._webviews.get(r)}}e.ExtHostWebviews=S;function a(i){return{id:i.identifier,location:i.extensionLocation}}function m(i,r,s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots||n(i,r)}}function o(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>R.URI.from(r))}}function n(i,r){return[...(r?.getWorkspaceFolders()||[]).map(s=>s.uri),i.extensionLocation]}}),define(ye[150],_e([1,0,4,6,2,15,14,5,20,26]),function(de,e,c,O,L,T,R,b,p,w){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class{static{A=this}static{this.InitialState={focused:!0,active:!0}}getState(C){const S=this._state;return{get focused(){return S.focused},get active(){return(0,w.checkProposedApiEnabled)(C,"windowActivity"),S.active}}}constructor(C){this._onDidChangeWindowState=new c.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=A.InitialState,this._proxy=C.getProxy(O.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:S,isActive:a})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",a)})}$onDidChangeWindowFocus(C){this.onDidChangeWindowProperty("focused",C)}$onDidChangeWindowActive(C){this.onDidChangeWindowProperty("active",C)}onDidChangeWindowProperty(C,S){S!==this._state[C]&&(this._state={...this._state,[C]:S},this._onDidChangeWindowState.fire(this._state))}openUri(C,S){let a;if(typeof C=="string"){a=C;try{C=L.URI.parse(C)}catch{return Promise.reject(`Invalid uri - '${C}'`)}}return(0,R.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,a,S)}async asExternalUri(C,S){if((0,R.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");const a=await this._proxy.$asExternalUri(C,S);return L.URI.from(a)}};e.ExtHostWindow=I,e.ExtHostWindow=I=A=Ge([Ue(0,p.IExtHostRpcService)],I),e.IExtHostWindow=(0,b.createDecorator)("IExtHostWindow")}),define(ye[319],_e([1,0,311,28,20]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const T=1024*1024;let R=class extends c.AbstractExtHostConsoleForwarder{constructor(p,w){super(p,w),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(p,w,A){const I=p==="error"||p==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,I.write(`
START_NATIVE_LOG
`),w.apply(console,A),I.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(p,w){const A=process[p],I=A.write;let v="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(C,S,a)=>{if(!this._isMakingConsoleCall){v+=C.toString(S);const m=v.length>T?v.length:v.lastIndexOf(`
`);m!==-1&&(console[w](v.slice(0,m)),v=v.slice(m+1))}I.call(A,C,S,a)}})}};e.ExtHostConsoleForwarder=R,e.ExtHostConsoleForwarder=R=Ge([Ue(0,L.IExtHostRpcService),Ue(1,O.IExtHostInitDataService)],R)}),define(ye[320],_e([1,0,149,15,261,30]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class R extends c.ExtHostLoggerService{doCreateLogger(p,w,A){return p.scheme===O.Schemas.file?new L.SpdLogLogger(A?.name||(0,T.generateUuid)(),p.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,w):super.doCreateLogger(p,w,A)}registerLogger(p){super.registerLogger(p),this._proxy.$registerLogger(p)}deregisterLogger(p){super.deregisterLogger(p),this._proxy.$deregisterLogger(p)}}e.ExtHostLoggerService=R}),define(ye[321],_e([1,0,8,21,22,13,4,3,133,308,68]),function(de,e,c,O,L,T,R,b,p,w,A){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0,e.stringifyJsonWithBufferRefs=m,e.parseJsonAndRestoreBufferRefs=o;function v(y,P){try{return JSON.stringify(y,P)}catch{return"null"}}const C="$$ref$$",S={[C]:-1};class a{constructor(P,k){this.jsonString=P,this.referencedBuffers=k}}function m(y,P=null,k=!1){const z=[];return{jsonString:(k?v:JSON.stringify)(y,(F,N)=>{if(typeof N>"u")return S;if(typeof N=="object"){if(N instanceof O.VSBuffer){const M=z.push(N)-1;return{[C]:M}}if(P)return P(F,N)}return N}),referencedBuffers:z}}function o(y,P,k){return JSON.parse(y,(z,x)=>{if(x){const F=x[C];if(typeof F=="number")return P[F];if(k&&x.$mid===1)return k.transformIncoming(x)}return x})}function n(y,P){return JSON.stringify(y,P)}function i(y){return y?(P,k)=>k&&k.$mid===1?y.transformOutgoing(k):k:null}var r;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var s;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const t=()=>{},f=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class l extends b.Disposable{static{I=f}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(P,k=null,z=null){super(),this[I]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=P,this._logger=k,this._uriTransformer=z,this._uriReplacer=i(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let x=0,F=A.ProxyIdentifier.count;x<F;x++)this._locals[x]=null,this._proxies[x]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new c.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(x=>this._receiveOneMessage(x))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(P=>{const k=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P],k.resolveErr(T.canceled())}),super.dispose()}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(P){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(P){this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(P){this._responsiveState!==P&&(this._responsiveState=P,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(P){return this._uriTransformer?(0,p.transformIncomingURIs)(P,this._uriTransformer):P}getProxy(P){const{nid:k,sid:z}=P;return this._proxies[k]||(this._proxies[k]=this._createProxy(k,z)),this._proxies[k]}_createProxy(P,k){const z={get:(x,F)=>(typeof F=="string"&&!x[F]&&F.charCodeAt(0)===36&&(x[F]=(...N)=>this._remoteCall(P,F,N)),F===h?k:x[F])};return new Proxy(Object.create(null),z)}set(P,k){return this._locals[P.nid]=k,k}assertRegistered(P){for(let k=0,z=P.length;k<z;k++){const x=P[k];if(!this._locals[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}_receiveOneMessage(P){if(this._isDisposed)return;const k=P.byteLength,z=d.read(P,0),x=z.readUInt8(),F=z.readUInt32();switch(x){case 1:case 2:{let{rpcId:N,method:M,args:B}=D.deserializeRequestJSONArgs(z);this._uriTransformer&&(B=(0,p.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(k,F,N,M,B,x===2);break}case 3:case 4:{let{rpcId:N,method:M,args:B}=D.deserializeRequestMixedArgs(z);this._uriTransformer&&(B=(0,p.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(k,F,N,M,B,x===4);break}case 5:{this._logger?.logIncoming(k,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(k,F);break}case 7:{this._receiveReply(k,F,void 0);break}case 9:{let N=D.deserializeReplyOKJSON(z);this._uriTransformer&&(N=(0,p.transformIncomingURIs)(N,this._uriTransformer)),this._receiveReply(k,F,N);break}case 10:{const N=D.deserializeReplyOKJSONWithBuffers(z,this._uriTransformer);this._receiveReply(k,F,N);break}case 8:{const N=D.deserializeReplyOKVSBuffer(z);this._receiveReply(k,F,N);break}case 11:{let N=D.deserializeReplyErrError(z);this._uriTransformer&&(N=(0,p.transformIncomingURIs)(N,this._uriTransformer)),this._receiveReplyErr(k,F,N);break}case 12:{this._receiveReplyErr(k,F,void 0);break}default:console.error("received unexpected message"),console.error(P)}}_receiveRequest(P,k,z,x,F,N){this._logger?.logIncoming(P,k,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)(z)}.${x}(`,F);const M=String(k);let B,W;if(N){const Z=new L.CancellationTokenSource;F.push(Z.token),B=this._invokeHandler(z,x,F),W=()=>Z.cancel()}else B=this._invokeHandler(z,x,F),W=t;this._cancelInvokedHandlers[M]=W;const Y=D.serializeAcknowledged(k);this._logger?.logOutgoing(Y.byteLength,k,1,"ack"),this._protocol.send(Y),B.then(Z=>{delete this._cancelInvokedHandlers[M];const G=D.serializeReplyOK(k,Z,this._uriReplacer);this._logger?.logOutgoing(G.byteLength,k,1,"reply:",Z),this._protocol.send(G)},Z=>{delete this._cancelInvokedHandlers[M];const G=D.serializeReplyErr(k,Z);this._logger?.logOutgoing(G.byteLength,k,1,"replyErr:",Z),this._protocol.send(G)})}_receiveCancel(P,k){this._logger?.logIncoming(P,k,1,"receiveCancel");const z=String(k);this._cancelInvokedHandlers[z]?.()}_receiveReply(P,k,z){this._logger?.logIncoming(P,k,0,"receiveReply:",z);const x=String(k);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const F=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x],F.resolveOk(z)}_receiveReplyErr(P,k,z){this._logger?.logIncoming(P,k,0,"receiveReplyErr:",z);const x=String(k);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const F=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x];let N;z&&(z.$isError?(N=new Error,N.name=z.name,N.message=z.message,N.stack=z.stack):N=z),F.resolveErr(N)}_invokeHandler(P,k,z){try{return Promise.resolve(this._doInvokeHandler(P,k,z))}catch(x){return Promise.reject(x)}}_doInvokeHandler(P,k,z){const x=this._locals[P];if(!x)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(P));const F=x[k];if(typeof F!="function")throw new Error("Unknown method "+k+" on actor "+(0,A.getStringIdentifierForProxy)(P));return F.apply(x,z)}_remoteCall(P,k,z){if(this._isDisposed)return new w.CanceledLazyPromise;let x=null;if(z.length>0&&L.CancellationToken.isCancellationToken(z[z.length-1])&&(x=z.pop()),x&&x.isCancellationRequested)return Promise.reject(T.canceled());const F=D.serializeRequestArguments(z,this._uriReplacer),N=++this._lastMessageId,M=String(N),B=new w.LazyPromise,W=new b.DisposableStore;x&&W.add(x.onCancellationRequested(()=>{const Z=D.serializeCancel(N);this._logger?.logOutgoing(Z.byteLength,N,0,"cancel"),this._protocol.send(D.serializeCancel(N))})),this._pendingRPCReplies[M]=new u(B,W),this._onWillSendRequest(N);const Y=D.serializeRequest(N,P,k,F,!!x);return this._logger?.logOutgoing(Y.byteLength,N,0,`request: ${(0,A.getStringIdentifierForProxy)(P)}.${k}(`,z),this._protocol.send(Y),B}}e.RPCProtocol=l;class u{constructor(P,k){this._promise=P,this._disposable=k}resolveOk(P){this._promise.resolveOk(P),this._disposable.dispose()}resolveErr(P){this._promise.resolveErr(P),this._disposable.dispose()}}class d{static alloc(P,k,z){const x=new d(O.VSBuffer.alloc(z+1+4),0);return x.writeUInt8(P),x.writeUInt32(k),x}static read(P,k){return new d(P,k)}get buffer(){return this._buff}constructor(P,k){this._buff=P,this._offset=k}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this._buff.writeUInt8(P,this._offset),this._offset+=1}readUInt8(){const P=this._buff.readUInt8(this._offset);return this._offset+=1,P}writeUInt32(P){this._buff.writeUInt32BE(P,this._offset),this._offset+=4}readUInt32(){const P=this._buff.readUInt32BE(this._offset);return this._offset+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this._buff.writeUInt8(P.byteLength,this._offset),this._offset+=1,this._buff.set(P,this._offset),this._offset+=P.byteLength}readShortString(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const z=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,z}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readLongString(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const z=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,z}writeBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readVSBuffer(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const k=this._buff.slice(this._offset,this._offset+P);return this._offset+=P,k}static sizeMixedArray(P){let k=0;k+=1;for(let z=0,x=P.length;z<x;z++){const F=P[z];switch(k+=1,F.type){case 1:k+=this.sizeLongString(F.value);break;case 2:k+=this.sizeVSBuffer(F.value);break;case 3:k+=this.sizeUInt32,k+=this.sizeLongString(F.value);for(let N=0;N<F.buffers.length;++N)k+=this.sizeVSBuffer(F.buffers[N]);break;case 4:break}}return k}writeMixedArray(P){this._buff.writeUInt8(P.length,this._offset),this._offset+=1;for(let k=0,z=P.length;k<z;k++){const x=P[k];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let F=0;F<x.buffers.length;++F)this.writeBuffer(x.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const k=new Array(P);for(let z=0;z<P;z++)switch(this.readUInt8()){case 1:k[z]=this.readLongString();break;case 2:k[z]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),N=this.readLongString(),M=[];for(let B=0;B<F;++B)M.push(this.readVSBuffer());k[z]=new A.SerializableObjectWithBuffers(o(N,M,null));break}case 4:k[z]=void 0;break}return k}}var g;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(g||(g={}));class D{static _useMixedArgSerialization(P){for(let k=0,z=P.length;k<z;k++)if(P[k]instanceof O.VSBuffer||P[k]instanceof A.SerializableObjectWithBuffers||typeof P[k]>"u")return!0;return!1}static serializeRequestArguments(P,k){if(this._useMixedArgSerialization(P)){const z=[];for(let x=0,F=P.length;x<F;x++){const N=P[x];if(N instanceof O.VSBuffer)z[x]={type:2,value:N};else if(typeof N>"u")z[x]={type:4};else if(N instanceof A.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:B}=m(N.value,k);z[x]={type:3,value:O.VSBuffer.fromString(M),buffers:B}}else z[x]={type:1,value:O.VSBuffer.fromString(n(N,k))}}return{type:1,args:z}}return{type:0,args:n(P,k)}}static serializeRequest(P,k,z,x,F){switch(x.type){case 0:return this._requestJSONArgs(P,k,z,x.args,F);case 1:return this._requestMixedArgs(P,k,z,x.args,F)}}static _requestJSONArgs(P,k,z,x,F){const N=O.VSBuffer.fromString(z),M=O.VSBuffer.fromString(x);let B=0;B+=d.sizeUInt8(),B+=d.sizeShortString(N),B+=d.sizeLongString(M);const W=d.alloc(F?2:1,P,B);return W.writeUInt8(k),W.writeShortString(N),W.writeLongString(M),W.buffer}static deserializeRequestJSONArgs(P){const k=P.readUInt8(),z=P.readShortString(),x=P.readLongString();return{rpcId:k,method:z,args:JSON.parse(x)}}static _requestMixedArgs(P,k,z,x,F){const N=O.VSBuffer.fromString(z);let M=0;M+=d.sizeUInt8(),M+=d.sizeShortString(N),M+=d.sizeMixedArray(x);const B=d.alloc(F?4:3,P,M);return B.writeUInt8(k),B.writeShortString(N),B.writeMixedArray(x),B.buffer}static deserializeRequestMixedArgs(P){const k=P.readUInt8(),z=P.readShortString(),x=P.readMixedArray(),F=new Array(x.length);for(let N=0,M=x.length;N<M;N++){const B=x[N];typeof B=="string"?F[N]=JSON.parse(B):F[N]=B}return{rpcId:k,method:z,args:F}}static serializeAcknowledged(P){return d.alloc(5,P,0).buffer}static serializeCancel(P){return d.alloc(6,P,0).buffer}static serializeReplyOK(P,k,z){if(typeof k>"u")return this._serializeReplyOKEmpty(P);if(k instanceof O.VSBuffer)return this._serializeReplyOKVSBuffer(P,k);if(k instanceof A.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:F}=m(k.value,z,!0);return this._serializeReplyOKJSONWithBuffers(P,x,F)}else return this._serializeReplyOKJSON(P,v(k,z))}static _serializeReplyOKEmpty(P){return d.alloc(7,P,0).buffer}static _serializeReplyOKVSBuffer(P,k){let z=0;z+=d.sizeVSBuffer(k);const x=d.alloc(8,P,z);return x.writeVSBuffer(k),x.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static _serializeReplyOKJSON(P,k){const z=O.VSBuffer.fromString(k);let x=0;x+=d.sizeLongString(z);const F=d.alloc(9,P,x);return F.writeLongString(z),F.buffer}static _serializeReplyOKJSONWithBuffers(P,k,z){const x=O.VSBuffer.fromString(k);let F=0;F+=d.sizeUInt32,F+=d.sizeLongString(x);for(const M of z)F+=d.sizeVSBuffer(M);const N=d.alloc(10,P,F);N.writeUInt32(z.length),N.writeLongString(x);for(const M of z)N.writeBuffer(M);return N.buffer}static deserializeReplyOKJSON(P){const k=P.readLongString();return JSON.parse(k)}static deserializeReplyOKJSONWithBuffers(P,k){const z=P.readUInt32(),x=P.readLongString(),F=[];for(let N=0;N<z;++N)F.push(P.readVSBuffer());return new A.SerializableObjectWithBuffers(o(x,F,k))}static serializeReplyErr(P,k){const z=k?v(T.transformErrorForSerialization(k),null):void 0;if(typeof z!="string")return this._serializeReplyErrEmpty(P);const x=O.VSBuffer.fromString(z);let F=0;F+=d.sizeLongString(x);const N=d.alloc(11,P,F);return N.writeLongString(x),N.buffer}static deserializeReplyErrError(P){const k=P.readLongString();return JSON.parse(k)}static _serializeReplyErrEmpty(P){return d.alloc(12,P,0).buffer}}var E;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(E||(E={}));var _;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(_||(_={}))}),define(ye[322],_e([1,0,21,27,15,84,5]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookDocumentWorkbenchService=e.INotebookDocumentService=void 0,e.parse=A,e.generate=I,e.INotebookDocumentService=(0,R.createDecorator)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${b.join("")}]+`),w=7;function A(C){if(C.scheme!==L.Schemas.vscodeNotebookCell)return;const S=C.fragment.indexOf("s");if(S<0)return;const a=parseInt(C.fragment.substring(0,S).replace(p,""),w),m=(0,c.decodeBase64)(C.fragment.substring(S+1)).toString();if(!isNaN(a))return{handle:a,notebook:C.with({scheme:m,fragment:null})}}function I(C,S){const a=S.toString(w),o=`${a.length<b.length?b[a.length-1]:"z"}${a}s${(0,c.encodeBase64)(c.VSBuffer.fromString(C.scheme),!0,!0)}`;return C.with({scheme:L.Schemas.vscodeNotebookCell,fragment:o})}class v{constructor(){this._documents=new O.ResourceMap}getNotebook(S){if(S.scheme===L.Schemas.vscodeNotebookCell){const a=A(S);if(a){const m=this._documents.get(a.notebook);if(m)return m}}return this._documents.get(S)}addNotebookDocument(S){this._documents.set(S.uri,S)}removeNotebookDocument(S){this._documents.delete(S.uri)}}e.NotebookDocumentWorkbenchService=v,(0,T.registerSingleton)(e.INotebookDocumentService,v,1)}),define(ye[119],_e([1,0,21,35,38,101,15,17,11,41,322]),function(de,e,c,O,L,T,R,b,p,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.diff=f,e.isDocumentExcludePattern=l,e.notebookDocumentFilterMatch=u,e.isTextStreamMime=D,e.compressOutputItemStreams=_,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var I;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(I||(e.CellKind=I={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",T.Mimes.latex,T.Mimes.markdown,"image/png","image/jpeg",T.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[T.Mimes.latex,T.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",T.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var v;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(v||(e.NotebookRunState=v={}));var C;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(C||(e.NotebookCellExecutionState=C={}));var S;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var a;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var m;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var o;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var n;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(B){B.scheme=R.Schemas.vscodeNotebookCell;function W(te,ve){return(0,A.generate)(te,ve)}B.generate=W;function Y(te){return(0,A.parse)(te)}B.parse=Y;function Z(te,ve){return te.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${ve??""},${te.scheme!==R.Schemas.file?te.scheme:""}`})}B.generateCellOutputUri=Z;function G(te){if(te.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const ve=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(te.fragment);if(!ve)return;const Ie=ve[1]&&ve[1]!==""?ve[1]:void 0,J=ve[2];return{outputId:Ie,notebook:te.with({scheme:J||R.Schemas.file,fragment:null})}}B.parseCellOutputUri=G;function Q(te,ve,Ie){return B.generate(te,ve).with({scheme:Ie})}B.generateCellPropertyUri=Q;function re(te,ve){if(te.scheme===ve)return B.parse(te.with({scheme:B.scheme}))}B.parseCellPropertyUri=re})(r||(e.CellUri=r={}));const s=B=>p.isWindows?B.replace(/\//g,"\\"):B;class t{constructor(W=[],Y=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=Y,this.order=[...new Set(W)].map(Z=>({pattern:Z,matches:O.parse(s(Z))}))}sort(W){const Y=new Map(L.Iterable.map(W,G=>[G,s(G)]));let Z=[];for(const{matches:G}of this.order)for(const[Q,re]of Y)if(G(re)){Z.push(Q),Y.delete(Q);break}return Y.size&&(Z=Z.concat([...Y.keys()].sort((G,Q)=>this.defaultOrder.indexOf(G)-this.defaultOrder.indexOf(Q)))),Z}prioritize(W,Y){const Z=this.findIndex(W);if(Z===-1){this.order.unshift({pattern:W,matches:O.parse(s(W))});return}const G=new Set(Y.map(re=>this.findIndex(re,Z)));G.delete(-1);const Q=Array.from(G).sort();this.order.splice(Z+1,0,...Q.map(re=>this.order[re]));for(let re=Q.length-1;re>=0;re--)this.order.splice(Q[re],1)}toArray(){return this.order.map(W=>W.pattern)}findIndex(W,Y=this.order.length){const Z=s(W);for(let G=0;G<Y;G++)if(this.order[G].matches(Z))return G;return-1}}e.MimeTypeDisplayOrder=t;function f(B,W,Y,Z=(G,Q)=>G===Q){const G=[];function Q(ve,Ie,J){if(Ie===0&&J.length===0)return;const $=G[G.length-1];$&&$.start+$.deleteCount===ve?($.deleteCount+=Ie,$.toInsert.push(...J)):G.push({start:ve,deleteCount:Ie,toInsert:J})}let re=0,te=0;for(;;){if(re===B.length){Q(re,0,W.slice(te));break}if(te===W.length){Q(re,B.length-re,[]);break}const ve=B[re],Ie=W[te];if(Z(ve,Ie)){re+=1,te+=1;continue}Y(Ie)?(Q(re,1,[]),re+=1):(Q(re,0,[Ie]),te+=1)}return G}e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new w.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new w.RawContextKey("notebookEditorCursorAtLineBoundary","none");var h;(function(B){B.default="default",B.option="option"})(h||(e.NotebookEditorPriority=h={}));function l(B){const W=B;return!!((typeof W.include=="string"||O.isRelativePattern(W.include))&&(typeof W.exclude=="string"||O.isRelativePattern(W.exclude)))}function u(B,W,Y){if(Array.isArray(B.viewType)&&B.viewType.indexOf(W)>=0||B.viewType===W)return!0;if(B.filenamePattern){const Z=l(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,G=l(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(O.match(Z,(0,b.basename)(Y.fsPath).toLowerCase()))return!(G&&O.match(G,(0,b.basename)(Y.fsPath).toLowerCase()))}return!1}e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var d;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(d||(e.CellStatusbarAlignment=d={}));class g{static{this._prefix="notebook/"}static create(W){return`${g._prefix}${W}`}static parse(W){if(W.startsWith(g._prefix))return W.substring(g._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=g;function D(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const E=new TextDecoder;function _(B){const W=[];let Y=!1;for(const re of B)(W.length===0||Y)&&(W.push(re),Y=!0);let Z=k(W);const G=c.VSBuffer.concat(W.map(re=>c.VSBuffer.wrap(re))),Q=M(G);return Z=Z||Q.byteLength!==G.byteLength,{data:Q,didCompression:Z}}e.MOVE_CURSOR_1_LINE_COMMAND="\x1B[A";const y=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(B=>B.charCodeAt(0)),P=10;function k(B){let W=!1;return B.forEach((Y,Z)=>{if(Z===0||Y.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const G=B[Z-1],Q=Y.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(Q[0]===y[0]&&Q[1]===y[1]&&Q[2]===y[2]){const re=G.lastIndexOf(P);if(re===-1)return;W=!0,B[Z-1]=G.subarray(0,re),B[Z]=Y.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),W}function z(B){let W=B;do B=W,W=B.replace(/[^\n]\x08/gm,"");while(W.length<B.length);return B}function x(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const W=B.match(/^(.*)\r+/m)[1];let Y=B.match(/\r+(.*)$/m)[1];Y=Y+W.slice(Y.length,W.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return B}const F=8,N=13;function M(B){return!B.buffer.includes(F)&&!B.buffer.includes(N)?B:c.VSBuffer.fromString(x(z(E.decode(B.buffer))))}}),define(ye[7],_e([1,0,19,13,80,27,101,14,18,2,30,25,32,65,119]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S){"use strict";var a,m,o,n,i,r,s,t,f,h,l,u,d,g,D,E,_;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.InlineEdit=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.LanguageModelError=e.LanguageModelChatAssistantMessage=e.LanguageModelChatUserMessage=e.LanguageModelChatSystemMessage=e.ChatLocation=e.ChatResponseTurn=e.ChatRequestTurn=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFileTreePart=e.ChatResponseMarkdownPart=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.ChatCompletionItem=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.TextMultiDiffTabInput=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.DeclarationCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.TestCoverageCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugVisualization=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.NewSymbolName=e.NewSymbolNameTag=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.Thread=e.StackFrame=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentPasteEditKind=e.DocumentPasteTriggerKind=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.asStatusBarItemIdentifier=lt,e.setBreakpointId=ee,e.validateTestCoverageCount=fe;function y(q){return Object.assign(q,{apply:function(...pe){if(pe.length===0)return Reflect.construct(q,[]);{const Ne=pe.length===1?[]:pe[1];return Reflect.construct(q,Ne,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(q,[]);{const[Ne,...Je]=pe;return Reflect.construct(q,Je,Ne.constructor)}}})}var P;(function(q){q[q.Top=0]="Top",q[q.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var k;(function(q){q[q.TerminalCommand=0]="TerminalCommand",q[q.Opener=1]="Opener",q[q.Command=3]="Command"})(k||(e.TerminalQuickFixType=k={}));let z=a=class{static from(...V){let pe=V;return new a(function(){if(pe){for(const Ne of pe)Ne&&typeof Ne.dispose=="function"&&Ne.dispose();pe=void 0}})}#e;constructor(V){this.#e=V}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=z,e.Disposable=z=a=Ge([y],z);let x=m=class{static Min(...V){if(V.length===0)throw new TypeError;let pe=V[0];for(let Ne=1;Ne<V.length;Ne++){const Je=V[Ne];Je.isBefore(pe)&&(pe=Je)}return pe}static Max(...V){if(V.length===0)throw new TypeError;let pe=V[0];for(let Ne=1;Ne<V.length;Ne++){const Je=V[Ne];Je.isAfter(pe)&&(pe=Je)}return pe}static isPosition(V){if(!V)return!1;if(V instanceof m)return!0;const{line:pe,character:Ne}=V;return typeof pe=="number"&&typeof Ne=="number"}static of(V){if(V instanceof m)return V;if(this.isPosition(V))return new m(V.line,V.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(V,pe){if(V<0)throw(0,O.illegalArgument)("line must be non-negative");if(pe<0)throw(0,O.illegalArgument)("character must be non-negative");this._line=V,this._character=pe}isBefore(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<V._character}isBeforeOrEqual(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<=V._character}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this._line===V._line&&this._character===V._character}compareTo(V){return this._line<V._line?-1:this._line>V.line?1:this._character<V._character?-1:this._character>V._character?1:0}translate(V,pe=0){if(V===null||pe===null)throw(0,O.illegalArgument)();let Ne;return typeof V>"u"?Ne=0:typeof V=="number"?Ne=V:(Ne=typeof V.lineDelta=="number"?V.lineDelta:0,pe=typeof V.characterDelta=="number"?V.characterDelta:0),Ne===0&&pe===0?this:new m(this.line+Ne,this.character+pe)}with(V,pe=this.character){if(V===null||pe===null)throw(0,O.illegalArgument)();let Ne;return typeof V>"u"?Ne=this.line:typeof V=="number"?Ne=V:(Ne=typeof V.line=="number"?V.line:this.line,pe=typeof V.character=="number"?V.character:this.character),Ne===this.line&&pe===this.character?this:new m(Ne,pe)}toJSON(){return{line:this.line,character:this.character}}};e.Position=x,e.Position=x=m=Ge([y],x);let F=o=class{static isRange(V){return V instanceof o?!0:V?x.isPosition(V.start)&&x.isPosition(V.end):!1}static of(V){if(V instanceof o)return V;if(this.isRange(V))return new o(V.start,V.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(V,pe,Ne,Je){let nt,dt;if(typeof V=="number"&&typeof pe=="number"&&typeof Ne=="number"&&typeof Je=="number"?(nt=new x(V,pe),dt=new x(Ne,Je)):x.isPosition(V)&&x.isPosition(pe)&&(nt=x.of(V),dt=x.of(pe)),!nt||!dt)throw new Error("Invalid arguments");nt.isBefore(dt)?(this._start=nt,this._end=dt):(this._start=dt,this._end=nt)}contains(V){return o.isRange(V)?this.contains(V.start)&&this.contains(V.end):x.isPosition(V)?!(x.of(V).isBefore(this._start)||this._end.isBefore(V)):!1}isEqual(V){return this._start.isEqual(V._start)&&this._end.isEqual(V._end)}intersection(V){const pe=x.Max(V.start,this._start),Ne=x.Min(V.end,this._end);if(!pe.isAfter(Ne))return new o(pe,Ne)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const pe=x.Min(V.start,this._start),Ne=x.Max(V.end,this.end);return new o(pe,Ne)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(V,pe=this.end){if(V===null||pe===null)throw(0,O.illegalArgument)();let Ne;return V?x.isPosition(V)?Ne=V:(Ne=V.start||this.start,pe=V.end||this.end):Ne=this.start,Ne.isEqual(this._start)&&pe.isEqual(this.end)?this:new o(Ne,pe)}toJSON(){return[this.start,this.end]}};e.Range=F,e.Range=F=o=Ge([y],F);let N=n=class extends F{static isSelection(V){return V instanceof n?!0:V?F.isRange(V)&&x.isPosition(V.anchor)&&x.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(V,pe,Ne,Je){let nt,dt;if(typeof V=="number"&&typeof pe=="number"&&typeof Ne=="number"&&typeof Je=="number"?(nt=new x(V,pe),dt=new x(Ne,Je)):x.isPosition(V)&&x.isPosition(pe)&&(nt=x.of(V),dt=x.of(pe)),!nt||!dt)throw new Error("Invalid arguments");super(nt,dt),this._anchor=nt,this._active=dt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=N,e.Selection=N=n=Ge([y],N);const M=q=>{if(typeof q!="string"||q.length===0||!/^[0-9A-Za-z_\-]+$/.test(q))throw(0,O.illegalArgument)("connectionToken")};class B{static isResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.host=="string"&&typeof V.port=="number"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,pe,Ne){if(typeof V!="string"||V.length===0)throw(0,O.illegalArgument)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,O.illegalArgument)("port");typeof Ne<"u"&&M(Ne),this.host=V,this.port=Math.round(pe),this.connectionToken=Ne}}e.ResolvedAuthority=B;class W{static isManagedResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.makeConnection=="function"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,pe){this.makeConnection=V,this.connectionToken=pe,typeof pe<"u"&&M(pe)}}e.ManagedResolvedAuthority=W;class Y extends Error{static NotAvailable(V,pe){return new Y(V,C.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(V){return new Y(V,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(V,pe=C.RemoteAuthorityResolverErrorCode.Unknown,Ne){super(V),this._message=V,this._code=pe,this._detail=Ne,Object.setPrototypeOf(this,Y.prototype)}}e.RemoteAuthorityResolverError=Y;var Z;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(Z||(e.EndOfLine=Z={}));var G;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(G||(e.EnvironmentVariableMutatorType=G={}));let Q=i=class{static isTextEdit(V){return V instanceof i?!0:V?F.isRange(V)&&typeof V.newText=="string":!1}static replace(V,pe){return new i(V,pe)}static insert(V,pe){return i.replace(new F(V,V),pe)}static delete(V){return i.replace(V,"")}static setEndOfLine(V){const pe=new i(new F(new x(0,0),new x(0,0)),"");return pe.newEol=V,pe}get range(){return this._range}set range(V){if(V&&!F.isRange(V))throw(0,O.illegalArgument)("range");this._range=V}get newText(){return this._newText||""}set newText(V){if(V&&typeof V!="string")throw(0,O.illegalArgument)("newText");this._newText=V}get newEol(){return this._newEol}set newEol(V){if(V&&typeof V!="number")throw(0,O.illegalArgument)("newEol");this._newEol=V}constructor(V,pe){this._range=V,this._newText=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=Q,e.TextEdit=Q=i=Ge([y],Q);let re=r=class{static isNotebookCellEdit(V){return V instanceof r?!0:V?di.isNotebookRange(V)&&Array.isArray(V.newCells):!1}static replaceCells(V,pe){return new r(V,pe)}static insertCells(V,pe){return new r(new di(V,V),pe)}static deleteCells(V){return new r(V,[])}static updateCellMetadata(V,pe){const Ne=new r(new di(V,V),[]);return Ne.newCellMetadata=pe,Ne}static updateNotebookMetadata(V){const pe=new r(new di(0,0),[]);return pe.newNotebookMetadata=V,pe}constructor(V,pe){this.range=V,this.newCells=pe}};e.NotebookEdit=re,e.NotebookEdit=re=r=Ge([y],re);class te{static isSnippetTextEdit(V){return V instanceof te?!0:V?F.isRange(V.range)&&J.isSnippetString(V.snippet):!1}static replace(V,pe){return new te(V,pe)}static insert(V,pe){return te.replace(new F(V,V),pe)}constructor(V,pe){this.range=V,this.snippet=pe}}e.SnippetTextEdit=te;var ve;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace",q[q.Snippet=6]="Snippet"})(ve||(e.FileEditType=ve={}));let Ie=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(V,pe,Ne,Je){this._edits.push({_type:1,from:V,to:pe,options:Ne,metadata:Je})}createFile(V,pe,Ne){this._edits.push({_type:1,from:void 0,to:V,options:pe,metadata:Ne})}deleteFile(V,pe,Ne){this._edits.push({_type:1,from:V,to:void 0,options:pe,metadata:Ne})}replaceNotebookMetadata(V,pe,Ne){this._edits.push({_type:3,metadata:Ne,uri:V,edit:{editType:5,metadata:pe},notebookMetadata:pe})}replaceNotebookCells(V,pe,Ne,Je){const nt=pe.start,dt=pe.end;(nt!==dt||Ne.length>0)&&this._edits.push({_type:5,uri:V,index:nt,count:dt-nt,cells:Ne,metadata:Je})}replaceNotebookCellMetadata(V,pe,Ne,Je){this._edits.push({_type:3,metadata:Je,uri:V,edit:{editType:3,index:pe,metadata:Ne}})}replace(V,pe,Ne,Je){this._edits.push({_type:2,uri:V,edit:new Q(pe,Ne),metadata:Je})}insert(V,pe,Ne,Je){this.replace(V,new F(pe,pe),Ne,Je)}delete(V,pe,Ne){this.replace(V,pe,"",Ne)}has(V){return this._edits.some(pe=>pe._type===2&&pe.uri.toString()===V.toString())}set(V,pe){if(pe)for(const Ne of pe){if(!Ne)continue;let Je,nt;Array.isArray(Ne)?(Je=Ne[0],nt=Ne[1]):Je=Ne,re.isNotebookCellEdit(Je)?Je.newCellMetadata?this.replaceNotebookCellMetadata(V,Je.range.start,Je.newCellMetadata,nt):Je.newNotebookMetadata?this.replaceNotebookMetadata(V,Je.newNotebookMetadata,nt):this.replaceNotebookCells(V,Je.range,Je.newCells,nt):te.isSnippetTextEdit(Je)?this._edits.push({_type:6,uri:V,range:Je.range,edit:Je.snippet,metadata:nt}):this._edits.push({_type:2,uri:V,edit:Je,metadata:nt})}else{for(let Ne=0;Ne<this._edits.length;Ne++){const Je=this._edits[Ne];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===V.toString()&&(this._edits[Ne]=void 0);break}}(0,c.coalesceInPlace)(this._edits)}}get(V){const pe=[];for(const Ne of this._edits)Ne._type===2&&Ne.uri.toString()===V.toString()&&pe.push(Ne.edit);return pe}entries(){const V=new T.ResourceMap;for(const pe of this._edits)if(pe._type===2){let Ne=V.get(pe.uri);Ne||(Ne=[pe.uri,[]],V.set(pe.uri,Ne)),Ne[1].push(pe.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=Ie,e.WorkspaceEdit=Ie=Ge([y],Ie);let J=s=class{static isSnippetString(V){return V instanceof s?!0:V?typeof V.value=="string":!1}static _escape(V){return V.replace(/\$|}|\\/g,"\\$&")}constructor(V){this._tabstop=1,this.value=V||""}appendText(V){return this.value+=s._escape(V),this}appendTabstop(V=this._tabstop++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,pe=this._tabstop++){if(typeof V=="function"){const Ne=new s;Ne._tabstop=this._tabstop,V(Ne),this._tabstop=Ne._tabstop,V=Ne.value}else V=s._escape(V);return this.value+="${",this.value+=pe,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,pe=this._tabstop++){const Ne=V.map(Je=>Je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Ne,this.value+="|}",this}appendVariable(V,pe){if(typeof pe=="function"){const Ne=new s;Ne._tabstop=this._tabstop,pe(Ne),this._tabstop=Ne._tabstop,pe=Ne.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.SnippetString=J,e.SnippetString=J=s=Ge([y],J);var $;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})($||(e.DiagnosticTag=$={}));var ne;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let be=t=class{static isLocation(V){return V instanceof t?!0:V?F.isRange(V.range)&&w.URI.isUri(V.uri):!1}constructor(V,pe){if(this.uri=V,pe)if(F.isRange(pe))this.range=F.of(pe);else if(x.isPosition(pe))this.range=new F(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=be,e.Location=be=t=Ge([y],be);let Ce=class{static is(V){return V?typeof V.message=="string"&&V.location&&F.isRange(V.location.range)&&w.URI.isUri(V.location.uri):!1}constructor(V,pe){this.location=V,this.message=pe}static isEqual(V,pe){return V===pe?!0:!V||!pe?!1:V.message===pe.message&&V.location.range.isEqual(pe.location.range)&&V.location.uri.toString()===pe.location.uri.toString()}};e.DiagnosticRelatedInformation=Ce,e.DiagnosticRelatedInformation=Ce=Ge([y],Ce);let ae=class{constructor(V,pe,Ne=ne.Error){if(!F.isRange(V))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=V,this.message=pe,this.severity=Ne}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,pe){return V===pe?!0:!V||!pe?!1:V.message===pe.message&&V.severity===pe.severity&&V.code===pe.code&&V.severity===pe.severity&&V.source===pe.source&&V.range.isEqual(pe.range)&&(0,c.equals)(V.tags,pe.tags)&&(0,c.equals)(V.relatedInformation,pe.relatedInformation,Ce.isEqual)}};e.Diagnostic=ae,e.Diagnostic=ae=Ge([y],ae);let ce=class{constructor(V,pe){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=pe}};e.Hover=ce,e.Hover=ce=Ge([y],ce);var se;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(se||(e.DocumentHighlightKind=se={}));let j=class{constructor(V,pe=se.Text){this.range=V,this.kind=pe}toJSON(){return{range:this.range,kind:se[this.kind]}}};e.DocumentHighlight=j,e.DocumentHighlight=j=Ge([y],j);let ie=class{constructor(V,pe){this.uri=V,this.highlights=pe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(V=>V.toJSON())}}};e.MultiDocumentHighlight=ie,e.MultiDocumentHighlight=ie=Ge([y],ie);var ue;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(ue||(e.SymbolKind=ue={}));var he;(function(q){q[q.Deprecated=1]="Deprecated"})(he||(e.SymbolTag=he={}));let Te=f=class{static validate(V){if(!V.name)throw new Error("name must not be falsy")}constructor(V,pe,Ne,Je,nt){this.name=V,this.kind=pe,this.containerName=nt,typeof Ne=="string"&&(this.containerName=Ne),Je instanceof be?this.location=Je:Ne instanceof F&&(this.location=new be(Je,Ne)),f.validate(this)}toJSON(){return{name:this.name,kind:ue[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Te,e.SymbolInformation=Te=f=Ge([y],Te);let me=h=class{static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children?.forEach(h.validate)}constructor(V,pe,Ne,Je,nt){this.name=V,this.detail=pe,this.kind=Ne,this.range=Je,this.selectionRange=nt,this.children=[],h.validate(this)}};e.DocumentSymbol=me,e.DocumentSymbol=me=h=Ge([y],me);var Pe;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(Pe||(e.CodeActionTriggerKind=Pe={}));let Ae=class{constructor(V,pe){this.title=V,this.kind=pe}};e.CodeAction=Ae,e.CodeAction=Ae=Ge([y],Ae);let xe=class{static{l=this}static{this.sep="."}constructor(V){this.value=V}append(V){return new l(this.value?this.value+l.sep+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+l.sep)}};e.CodeActionKind=xe,e.CodeActionKind=xe=l=Ge([y],xe),xe.Empty=new xe(""),xe.QuickFix=xe.Empty.append("quickfix"),xe.Refactor=xe.Empty.append("refactor"),xe.RefactorExtract=xe.Refactor.append("extract"),xe.RefactorInline=xe.Refactor.append("inline"),xe.RefactorMove=xe.Refactor.append("move"),xe.RefactorRewrite=xe.Refactor.append("rewrite"),xe.Source=xe.Empty.append("source"),xe.SourceOrganizeImports=xe.Source.append("organizeImports"),xe.SourceFixAll=xe.Source.append("fixAll"),xe.Notebook=xe.Empty.append("notebook");let H=class{constructor(V,pe){if(this.range=V,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=H,e.SelectionRange=H=Ge([y],H);class U{constructor(V,pe,Ne,Je,nt,dt){this.kind=V,this.name=pe,this.detail=Ne,this.uri=Je,this.range=nt,this.selectionRange=dt}}e.CallHierarchyItem=U;class X{constructor(V,pe){this.fromRanges=pe,this.from=V}}e.CallHierarchyIncomingCall=X;class K{constructor(V,pe){this.fromRanges=pe,this.to=V}}e.CallHierarchyOutgoingCall=K;var ge;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(ge||(e.LanguageStatusSeverity=ge={}));let Ee=class{constructor(V,pe){this.range=V,this.command=pe}get isResolved(){return!!this.command}};e.CodeLens=Ee,e.CodeLens=Ee=Ge([y],Ee);let ze=u=class{#e;static isMarkdownString(V){return V instanceof u?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}constructor(V,pe=!1){this.#e=new L.MarkdownString(V,{supportThemeIcons:pe})}get value(){return this.#e.value}set value(V){this.#e.value=V}get isTrusted(){return this.#e.isTrusted}set isTrusted(V){this.#e.isTrusted=V}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(V){this.#e.supportThemeIcons=V}get supportHtml(){return this.#e.supportHtml}set supportHtml(V){this.#e.supportHtml=V}get baseUri(){return this.#e.baseUri}set baseUri(V){this.#e.baseUri=V}appendText(V){return this.#e.appendText(V),this}appendMarkdown(V){return this.#e.appendMarkdown(V),this}appendCodeblock(V,pe){return this.#e.appendCodeblock(pe??"",V),this}};e.MarkdownString=ze,e.MarkdownString=ze=u=Ge([y],ze);let He=class{constructor(V,pe){this.label=V,this.documentation=pe}};e.ParameterInformation=He,e.ParameterInformation=He=Ge([y],He);let Ye=class{constructor(V,pe){this.label=V,this.documentation=pe,this.parameters=[]}};e.SignatureInformation=Ye,e.SignatureInformation=Ye=Ge([y],Ye);let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=it,e.SignatureHelp=it=Ge([y],it);var rt;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(rt||(e.SignatureHelpTriggerKind=rt={}));var at;(function(q){q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(at||(e.InlayHintKind=at={}));let st=class{constructor(V){this.value=V}};e.InlayHintLabelPart=st,e.InlayHintLabelPart=st=Ge([y],st);let De=class{constructor(V,pe,Ne){this.position=V,this.label=pe,this.kind=Ne}};e.InlayHint=De,e.InlayHint=De=Ge([y],De);var Be;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var qe;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(qe||(e.CompletionItemKind=qe={}));var Le;(function(q){q[q.Deprecated=1]="Deprecated"})(Le||(e.CompletionItemTag=Le={}));let Qe=class{constructor(V,pe){this.label=V,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&qe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=Qe,e.CompletionItem=Qe=Ge([y],Qe);let oe=class{constructor(V=[],pe=!1){this.items=V,this.isIncomplete=pe}};e.CompletionList=oe,e.CompletionList=oe=Ge([y],oe);let le=class{constructor(V,pe,Ne){this.insertText=V,this.range=pe,this.command=Ne}};e.InlineSuggestion=le,e.InlineSuggestion=le=Ge([y],le);let ke=class{constructor(V){this.commands=void 0,this.suppressSuggestions=void 0,this.items=V}};e.InlineSuggestionList=ke,e.InlineSuggestionList=ke=Ge([y],ke);var je;(function(q){q[q.Unknown=0]="Unknown",q[q.Word=1]="Word",q[q.Line=2]="Line",q[q.Suggest=3]="Suggest"})(je||(e.PartialAcceptTriggerKind=je={}));var Ze;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(Ze||(e.ViewColumn=Ze={}));var Me;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(Me||(e.StatusBarAlignment=Me={}));function lt(q,V){return`${I.ExtensionIdentifier.toKey(q)}.${V}`}var bt;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative",q[q.Interval=3]="Interval"})(bt||(e.TextEditorLineNumbersStyle=bt={}));var Tt;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(Tt||(e.TextDocumentSaveReason=Tt={}));var Nt;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Nt||(e.TextEditorRevealType=Nt={}));var Xt;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(Xt||(e.TextEditorSelectionChangeKind=Xt={}));var ei;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(ei||(e.TextDocumentChangeReason=ei={}));var It;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(It||(e.DecorationRangeBehavior=It={})),function(q){function V(pe){switch(pe){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=V}(Xt||(e.TextEditorSelectionChangeKind=Xt={}));var Qt;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})(Qt||(e.SyntaxTokenType=Qt={})),function(q){function V(pe){switch(pe){case q.Other:return"other";case q.Comment:return"comment";case q.String:return"string";case q.RegEx:return"regex"}return"other"}q.toString=V}(Qt||(e.SyntaxTokenType=Qt={}));let Vt=class{constructor(V,pe){if(pe&&!w.URI.isUri(pe))throw(0,O.illegalArgument)("target");if(!F.isRange(V)||V.isEmpty)throw(0,O.illegalArgument)("range");this.range=V,this.target=pe}};e.DocumentLink=Vt,e.DocumentLink=Vt=Ge([y],Vt);let ci=class{constructor(V,pe,Ne,Je){this.red=V,this.green=pe,this.blue=Ne,this.alpha=Je}};e.Color=ci,e.Color=ci=Ge([y],ci);let tt=class{constructor(V,pe){if(pe&&!(pe instanceof ci))throw(0,O.illegalArgument)("color");if(!F.isRange(V)||V.isEmpty)throw(0,O.illegalArgument)("range");this.range=V,this.color=pe}};e.ColorInformation=tt,e.ColorInformation=tt=Ge([y],tt);let ti=class{constructor(V){if(!V||typeof V!="string")throw(0,O.illegalArgument)("label");this.label=V}};e.ColorPresentation=ti,e.ColorPresentation=ti=Ge([y],ti);var ii;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(ii||(e.ColorFormat=ii={}));var qt;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(qt||(e.SourceControlInputBoxValidationType=qt={}));var ht;(function(q){q[q.Unknown=0]="Unknown",q[q.Shutdown=1]="Shutdown",q[q.Process=2]="Process",q[q.User=3]="User",q[q.Extension=4]="Extension"})(ht||(e.TerminalExitReason=ht={}));class Et{constructor(V,pe,Ne){if(this.startIndex=V,this.length=pe,this.tooltip=Ne,typeof V!="number"||V<0)throw(0,O.illegalArgument)("startIndex");if(typeof pe!="number"||pe<1)throw(0,O.illegalArgument)("length");if(Ne!==void 0&&typeof Ne!="string")throw(0,O.illegalArgument)("tooltip")}}e.TerminalLink=Et;class ai{constructor(V){this.uri=V}}e.TerminalQuickFixOpener=ai;class jt{constructor(V){this.terminalCommand=V}}e.TerminalQuickFixCommand=jt;var Ut;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(Ut||(e.TerminalLocation=Ut={}));class gt{constructor(V){if(this.options=V,typeof V!="object")throw(0,O.illegalArgument)("options")}}e.TerminalProfile=gt;var Pt;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(Pt||(e.TaskRevealKind=Pt={}));var li;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(li||(e.TaskPanelKind=li={}));let Yt=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(V){switch(V){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(V,pe){if(this.label=pe,typeof V!="string"||typeof pe!="string")throw(0,O.illegalArgument)("name");this._id=V}get id(){return this._id}};e.TaskGroup=Yt,e.TaskGroup=Yt=d=Ge([y],Yt);function Ke(q){let V="";for(let pe=0;pe<q.length;pe++)V+=q[pe].replace(/,/g,",,")+",";return V}let Mt=class{constructor(V,pe,Ne){if(typeof V!="string")throw(0,O.illegalArgument)("process");this._args=[],this._process=V,pe!==void 0&&(Array.isArray(pe)?(this._args=pe,this._options=Ne):this._options=pe)}get process(){return this._process}set process(V){if(typeof V!="string")throw(0,O.illegalArgument)("process");this._process=V}get args(){return this._args}set args(V){Array.isArray(V)||(V=[]),this._args=V}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("process"),this._process!==void 0&&V.push(this._process),this._args&&this._args.length>0)for(const pe of this._args)V.push(pe);return Ke(V)}};e.ProcessExecution=Mt,e.ProcessExecution=Mt=Ge([y],Mt);let Ht=class{constructor(V,pe,Ne){if(this._args=[],Array.isArray(pe)){if(!V)throw(0,O.illegalArgument)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,O.illegalArgument)("command");this._command=V,this._args=pe,this._options=Ne}else{if(typeof V!="string")throw(0,O.illegalArgument)("commandLine");this._commandLine=V,this._options=pe}}get commandLine(){return this._commandLine}set commandLine(V){if(typeof V!="string")throw(0,O.illegalArgument)("commandLine");this._commandLine=V}get command(){return this._command?this._command:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,O.illegalArgument)("command");this._command=V}get args(){return this._args}set args(V){this._args=V||[]}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("shell"),this._commandLine!==void 0&&V.push(this._commandLine),this._command!==void 0&&V.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const pe of this._args)V.push(typeof pe=="string"?pe:pe.value);return Ke(V)}};e.ShellExecution=Ht,e.ShellExecution=Ht=Ge([y],Ht);var ni;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(ni||(e.ShellQuoting=ni={}));var pt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(pt||(e.TaskScope=pt={}));class Ot{constructor(V){this._callback=V}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback(V){this._callback=V}get callback(){return this._callback}}e.CustomExecution=Ot;let At=class{static{g=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(V,pe,Ne,Je,nt,dt){this.__deprecated=!1,this._definition=this.definition=V;let mt;typeof pe=="string"?(this._name=this.name=pe,this._source=this.source=Ne,this.execution=Je,mt=nt,this.__deprecated=!0):pe===pt.Global||pe===pt.Workspace?(this.target=pe,this._name=this.name=Ne,this._source=this.source=Je,this.execution=nt,mt=dt):(this.target=pe,this._name=this.name=Ne,this._source=this.source=Je,this.execution=nt,mt=dt),typeof mt=="string"?(this._problemMatchers=[mt],this._hasDefinedMatchers=!0):Array.isArray(mt)?(this._problemMatchers=mt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(V){this.__id=V}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Mt?this._definition={type:g.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ht?this._definition={type:g.ShellType,id:this._execution.computeId()}:this._execution instanceof Ot?this._definition={type:g.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:g.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition(V){if(V==null)throw(0,O.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=V}get scope(){return this._scope}set target(V){this.clear(),this._scope=V}get name(){return this._name}set name(V){if(typeof V!="string")throw(0,O.illegalArgument)("name");this.clear(),this._name=V}get execution(){return this._execution}set execution(V){V===null&&(V=void 0),this.clear(),this._execution=V;const pe=this._definition.type;(g.EmptyType===pe||g.ProcessType===pe||g.ShellType===pe||g.ExtensionCallbackType===pe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(V){if(Array.isArray(V))this.clear(),this._problemMatchers=V,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.clear(),this._isBackground=V}get source(){return this._source}set source(V){if(typeof V!="string"||V.length===0)throw(0,O.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=V}get group(){return this._group}set group(V){V===null&&(V=void 0),this.clear(),this._group=V}get detail(){return this._detail}set detail(V){V===null&&(V=void 0),this._detail=V}get presentationOptions(){return this._presentationOptions}set presentationOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._presentationOptions=V}get runOptions(){return this._runOptions}set runOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._runOptions=V}};e.Task=At,e.Task=At=g=Ge([y],At);var Ft;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(Ft||(e.ProgressLocation=Ft={}));var ui;(function(q){function V(pe){const Ne=pe;return(0,p.isNumber)(Ne.value)?Ne.tooltip&&!(0,p.isString)(Ne.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ne.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ne.value),!1)}q.isViewBadge=V})(ui||(e.ViewBadge=ui={}));let xt=D=class{static isTreeItem(V,pe){const Ne=V;if(Ne.checkboxState!==void 0){const Je=(0,p.isNumber)(Ne.checkboxState)?Ne.checkboxState:(0,p.isObject)(Ne.checkboxState)&&(0,p.isNumber)(Ne.checkboxState.state)?Ne.checkboxState.state:void 0,nt=!(0,p.isNumber)(Ne.checkboxState)&&(0,p.isObject)(Ne.checkboxState)?Ne.checkboxState.tooltip:void 0;if(Je===void 0||Je!==Ct.Checked&&Je!==Ct.Unchecked||nt!==void 0&&!(0,p.isString)(nt))return console.log("INVALID tree item, invalid checkboxState",Ne.checkboxState),!1}if(V instanceof D)return!0;if(Ne.label!==void 0&&!(0,p.isString)(Ne.label)&&!Ne.label?.label)return console.log("INVALID tree item, invalid label",Ne.label),!1;if(Ne.id!==void 0&&!(0,p.isString)(Ne.id))return console.log("INVALID tree item, invalid id",Ne.id),!1;if(Ne.iconPath!==void 0&&!(0,p.isString)(Ne.iconPath)&&!w.URI.isUri(Ne.iconPath)&&(!Ne.iconPath||!(0,p.isString)(Ne.iconPath.id))){const Je=Ne.iconPath;if(!Je||!(0,p.isString)(Je.light)&&!w.URI.isUri(Je.light)&&!(0,p.isString)(Je.dark)&&!w.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Ne.iconPath),!1}return Ne.description!==void 0&&!(0,p.isString)(Ne.description)&&typeof Ne.description!="boolean"?(console.log("INVALID tree item, invalid description",Ne.description),!1):Ne.resourceUri!==void 0&&!w.URI.isUri(Ne.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ne.resourceUri),!1):Ne.tooltip!==void 0&&!(0,p.isString)(Ne.tooltip)&&!(Ne.tooltip instanceof ze)?(console.log("INVALID tree item, invalid tooltip",Ne.tooltip),!1):Ne.command!==void 0&&!Ne.command.command?(console.log("INVALID tree item, invalid command",Ne.command),!1):Ne.collapsibleState!==void 0&&Ne.collapsibleState<zt.None&&Ne.collapsibleState>zt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ne.collapsibleState),!1):Ne.contextValue!==void 0&&!(0,p.isString)(Ne.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ne.contextValue),!1):Ne.accessibilityInformation!==void 0&&!Ne.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ne.accessibilityInformation),!1):!0}constructor(V,pe=zt.None){this.collapsibleState=pe,w.URI.isUri(V)?this.resourceUri=V:this.label=V}};e.TreeItem=xt,e.TreeItem=xt=D=Ge([y],xt);var zt;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(zt||(e.TreeItemCollapsibleState=zt={}));var Ct;(function(q){q[q.Unchecked=0]="Unchecked",q[q.Checked=1]="Checked"})(Ct||(e.TreeItemCheckboxState=Ct={}));let Lt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(V){this.value=V}};e.DataTransferItem=Lt,e.DataTransferItem=Lt=Ge([y],Lt);class ri extends Lt{}e.InternalDataTransferItem=ri;class Bt extends ri{#e;constructor(V){super(""),this.#e=V}asFile(){return this.#e}}e.InternalFileDataTransferItem=Bt;class St{constructor(V,pe,Ne,Je){this.name=V,this.uri=pe,this._itemId=Ne,this._getData=Je}data(){return this._getData()}}e.DataTransferFile=St;let kt=class{#e=new Map;constructor(V){for(const[pe,Ne]of V??[]){const Je=this.#e.get(this.#t(pe));Je?Je.push(Ne):this.#e.set(this.#t(pe),[Ne])}}get(V){return this.#e.get(this.#t(V))?.[0]}set(V,pe){this.#e.set(this.#t(V),[pe])}forEach(V,pe){for(const[Ne,Je]of this.#e)for(const nt of Je)V.call(pe,nt,Ne,this)}*[Symbol.iterator](){for(const[V,pe]of this.#e)for(const Ne of pe)yield[V,Ne]}#t(V){return V.toLowerCase()}};e.DataTransfer=kt,e.DataTransfer=kt=Ge([y],kt);let fi=class{constructor(V,pe,Ne){this.insertText=V,this.title=pe,this.kind=Ne}};e.DocumentDropEdit=fi,e.DocumentDropEdit=fi=Ge([y],fi);var Dt;(function(q){q[q.Automatic=0]="Automatic",q[q.PasteAs=1]="PasteAs"})(Dt||(e.DocumentPasteTriggerKind=Dt={}));class si{static{this.sep="."}constructor(V){this.value=V}append(...V){return new si((this.value?[this.value,...V]:V).join(si.sep))}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+si.sep)}}e.DocumentPasteEditKind=si,si.Empty=new si("");let Jt=class{constructor(V,pe,Ne){this.title=pe,this.insertText=V,this.kind=Ne}};e.DocumentPasteEdit=Jt,e.DocumentPasteEdit=Jt=Ge([y],Jt);let oi=class{constructor(V,pe){this.id=V,this.color=pe}static isThemeIcon(V){return typeof V.id!="string"?(console.log("INVALID ThemeIcon, invalid id",V.id),!1):!0}};e.ThemeIcon=oi,e.ThemeIcon=oi=Ge([y],oi),oi.File=new oi("file"),oi.Folder=new oi("folder");let gi=class{constructor(V){this.id=V}};e.ThemeColor=gi,e.ThemeColor=gi=Ge([y],gi);var Oe;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(Oe||(e.ConfigurationTarget=Oe={}));let Fe=class{get base(){return this._base}set base(V){this._base=V,this._baseUri=w.URI.file(V)}get baseUri(){return this._baseUri}set baseUri(V){this._baseUri=V,this._base=V.fsPath}constructor(V,pe){if(typeof V!="string"&&(!V||!w.URI.isUri(V)&&!w.URI.isUri(V.uri)))throw(0,O.illegalArgument)("base");if(typeof pe!="string")throw(0,O.illegalArgument)("pattern");typeof V=="string"?this.baseUri=w.URI.file(V):w.URI.isUri(V)?this.baseUri=V:this.baseUri=V.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=Fe,e.RelativePattern=Fe=Ge([y],Fe);const Se=new WeakMap;function ee(q,V){Se.set(q,V)}let Re=class{constructor(V,pe,Ne,Je,nt){this.enabled=typeof V=="boolean"?V:!0,typeof pe=="string"&&(this.condition=pe),typeof Ne=="string"&&(this.hitCondition=Ne),typeof Je=="string"&&(this.logMessage=Je),typeof nt=="string"&&(this.mode=nt)}get id(){return this._id||(this._id=Se.get(this)??(0,A.generateUuid)()),this._id}};e.Breakpoint=Re,e.Breakpoint=Re=Ge([y],Re);let Ve=class extends Re{constructor(V,pe,Ne,Je,nt,dt){if(super(pe,Ne,Je,nt,dt),V===null)throw(0,O.illegalArgument)("location");this.location=V}};e.SourceBreakpoint=Ve,e.SourceBreakpoint=Ve=Ge([y],Ve);let et=class extends Re{constructor(V,pe,Ne,Je,nt,dt){super(pe,Ne,Je,nt,dt),this.functionName=V}};e.FunctionBreakpoint=et,e.FunctionBreakpoint=et=Ge([y],et);let Xe=class extends Re{constructor(V,pe,Ne,Je,nt,dt,mt,Kt){if(super(Je,nt,dt,mt,Kt),!pe)throw(0,O.illegalArgument)("dataId");this.label=V,this.dataId=pe,this.canPersist=Ne}};e.DataBreakpoint=Xe,e.DataBreakpoint=Xe=Ge([y],Xe);let ut=class{constructor(V,pe,Ne){this.command=V,this.args=pe||[],this.options=Ne}};e.DebugAdapterExecutable=ut,e.DebugAdapterExecutable=ut=Ge([y],ut);let yt=class{constructor(V,pe){this.port=V,this.host=pe}};e.DebugAdapterServer=yt,e.DebugAdapterServer=yt=Ge([y],yt);let _t=class{constructor(V){this.path=V}};e.DebugAdapterNamedPipeServer=_t,e.DebugAdapterNamedPipeServer=_t=Ge([y],_t);let Zt=class{constructor(V){this.implementation=V}};e.DebugAdapterInlineImplementation=Zt,e.DebugAdapterInlineImplementation=Zt=Ge([y],Zt);class $t{constructor(V,pe,Ne){this.session=V,this.threadId=pe,this.frameId=Ne}}e.StackFrame=$t;class Gt{constructor(V,pe){this.session=V,this.threadId=pe}}e.Thread=Gt;let wi=class{constructor(V,pe){this.range=V,this.expression=pe}};e.EvaluatableExpression=wi,e.EvaluatableExpression=wi=Ge([y],wi);var ft;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(ft||(e.InlineCompletionTriggerKind=ft={}));let Oi=class{constructor(V,pe){this.range=V,this.text=pe}};e.InlineValueText=Oi,e.InlineValueText=Oi=Ge([y],Oi);let mi=class{constructor(V,pe,Ne=!0){this.range=V,this.variableName=pe,this.caseSensitiveLookup=Ne}};e.InlineValueVariableLookup=mi,e.InlineValueVariableLookup=mi=Ge([y],mi);let bi=class{constructor(V,pe){this.range=V,this.expression=pe}};e.InlineValueEvaluatableExpression=bi,e.InlineValueEvaluatableExpression=bi=Ge([y],bi);let Di=class{constructor(V,pe){this.frameId=V,this.stoppedLocation=pe}};e.InlineValueContext=Di,e.InlineValueContext=Di=Ge([y],Di);var Ki;(function(q){q[q.AIGenerated=1]="AIGenerated"})(Ki||(e.NewSymbolNameTag=Ki={}));class gn{constructor(V,pe){this.newSymbolName=V,this.tags=pe}}e.NewSymbolName=gn;var Xi;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Xi||(e.FileChangeType=Xi={}));let Ii=E=class extends Error{static FileExists(V){return new E(V,v.FileSystemProviderErrorCode.FileExists,E.FileExists)}static FileNotFound(V){return new E(V,v.FileSystemProviderErrorCode.FileNotFound,E.FileNotFound)}static FileNotADirectory(V){return new E(V,v.FileSystemProviderErrorCode.FileNotADirectory,E.FileNotADirectory)}static FileIsADirectory(V){return new E(V,v.FileSystemProviderErrorCode.FileIsADirectory,E.FileIsADirectory)}static NoPermissions(V){return new E(V,v.FileSystemProviderErrorCode.NoPermissions,E.NoPermissions)}static Unavailable(V){return new E(V,v.FileSystemProviderErrorCode.Unavailable,E.Unavailable)}constructor(V,pe=v.FileSystemProviderErrorCode.Unknown,Ne){super(w.URI.isUri(V)?V.toString(!0):V),this.code=Ne?.name??"Unknown",(0,v.markAsFileSystemProviderError)(this,pe),Object.setPrototypeOf(this,E.prototype),typeof Error.captureStackTrace=="function"&&typeof Ne=="function"&&Error.captureStackTrace(this,Ne)}};e.FileSystemError=Ii,e.FileSystemError=Ii=E=Ge([y],Ii);let Ni=class{constructor(V,pe,Ne){this.start=V,this.end=pe,this.kind=Ne}};e.FoldingRange=Ni,e.FoldingRange=Ni=Ge([y],Ni);var Mi;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(Mi||(e.FoldingRangeKind=Mi={}));var Qi;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(Qi||(e.CommentThreadCollapsibleState=Qi={}));var Pi;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(Pi||(e.CommentMode=Pi={}));var ki;(function(q){q[q.Published=0]="Published",q[q.Draft=1]="Draft"})(ki||(e.CommentState=ki={}));var Yi;(function(q){q[q.Unresolved=0]="Unresolved",q[q.Resolved=1]="Resolved"})(Yi||(e.CommentThreadState=Yi={}));var Ji;(function(q){q[q.Current=0]="Current",q[q.Outdated=1]="Outdated"})(Ji||(e.CommentThreadApplicability=Ji={}));class Si{constructor(V,pe=[]){this.tokenTypes=V,this.tokenModifiers=pe}}e.SemanticTokensLegend=Si;function mn(q){return typeof q>"u"||(0,p.isStringArray)(q)}class Fi{constructor(V){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,V){this._hasLegend=!0;for(let pe=0,Ne=V.tokenTypes.length;pe<Ne;pe++)this._tokenTypeStrToInt.set(V.tokenTypes[pe],pe);for(let pe=0,Ne=V.tokenModifiers.length;pe<Ne;pe++)this._tokenModifierStrToInt.set(V.tokenModifiers[pe],pe)}}push(V,pe,Ne,Je,nt){if(typeof V=="number"&&typeof pe=="number"&&typeof Ne=="number"&&typeof Je=="number"&&(typeof nt=="number"||typeof nt>"u"))return typeof nt>"u"&&(nt=0),this._pushEncoded(V,pe,Ne,Je,nt);if(F.isRange(V)&&typeof pe=="string"&&mn(Ne))return this._push(V,pe,Ne);throw(0,O.illegalArgument)()}_push(V,pe,Ne){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(pe))throw new Error("`tokenType` is not in the provided legend");const Je=V.start.line,nt=V.start.character,dt=V.end.character-V.start.character,mt=this._tokenTypeStrToInt.get(pe);let Kt=0;if(Ne)for(const hi of Ne){if(!this._tokenModifierStrToInt.has(hi))throw new Error("`tokenModifier` is not in the provided legend");const pi=this._tokenModifierStrToInt.get(hi);Kt|=1<<pi>>>0}this._pushEncoded(Je,nt,dt,mt,Kt)}_pushEncoded(V,pe,Ne,Je,nt){if(this._dataIsSortedAndDeltaEncoded&&(V<this._prevLine||V===this._prevLine&&pe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Kt=this._data.length/5|0;let hi=0,pi=0;for(let vi=0;vi<Kt;vi++){let Ei=this._data[5*vi],ji=this._data[5*vi+1];Ei===0?(Ei=hi,ji+=pi):Ei+=hi,this._data[5*vi]=Ei,this._data[5*vi+1]=ji,hi=Ei,pi=ji}}let dt=V,mt=pe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(mt-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=mt,this._data[this._dataLen++]=Ne,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=nt,this._prevLine=V,this._prevChar=pe}static _sortAndDeltaEncode(V){const pe=[],Ne=V.length/5|0;for(let mt=0;mt<Ne;mt++)pe[mt]=mt;pe.sort((mt,Kt)=>{const hi=V[5*mt],pi=V[5*Kt];if(hi===pi){const vi=V[5*mt+1],Ei=V[5*Kt+1];return vi-Ei}return hi-pi});const Je=new Uint32Array(V.length);let nt=0,dt=0;for(let mt=0;mt<Ne;mt++){const Kt=5*pe[mt],hi=V[Kt+0],pi=V[Kt+1],vi=V[Kt+2],Ei=V[Kt+3],ji=V[Kt+4],On=hi-nt,sr=On===0?pi-dt:pi,Gi=5*mt;Je[Gi+0]=On,Je[Gi+1]=sr,Je[Gi+2]=vi,Je[Gi+3]=Ei,Je[Gi+4]=ji,nt=hi,dt=pi}return Je}build(V){return this._dataIsSortedAndDeltaEncoded?new xi(new Uint32Array(this._data),V):new xi(Fi._sortAndDeltaEncode(this._data),V)}}e.SemanticTokensBuilder=Fi;class xi{constructor(V,pe){this.resultId=pe,this.data=V}}e.SemanticTokens=xi;class Zi{constructor(V,pe,Ne){this.start=V,this.deleteCount=pe,this.data=Ne}}e.SemanticTokensEdit=Zi;class pn{constructor(V,pe){this.resultId=pe,this.edits=V}}e.SemanticTokensEdits=pn;var zi;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(zi||(e.DebugConsoleMode=zi={}));class en{constructor(V){this.name=V}}e.DebugVisualization=en;let Bi=class{static{this.Back={iconPath:new oi("arrow-left")}}constructor(){}};e.QuickInputButtons=Bi,e.QuickInputButtons=Bi=Ge([y],Bi);var $i;(function(q){q[q.Separator=-1]="Separator",q[q.Default=0]="Default"})($i||(e.QuickPickItemKind=$i={}));var Wi;(function(q){q[q.Info=1]="Info",q[q.Warning=2]="Warning",q[q.Error=3]="Error"})(Wi||(e.InputBoxValidationSeverity=Wi={}));var tn;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(tn||(e.ExtensionKind=tn={}));class vn{static validate(V){if(typeof V.badge=="string"){let pe=(0,b.nextCharLength)(V.badge,0);if(pe<V.badge.length&&(pe+=(0,b.nextCharLength)(V.badge,pe)),V.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(V.badge&&!oi.isThemeIcon(V.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}constructor(V,pe,Ne){this.badge=V,this.tooltip=pe,this.color=Ne}}e.FileDecoration=vn;let Ui=class{constructor(V){this.kind=V}};e.ColorTheme=Ui,e.ColorTheme=Ui=Ge([y],Ui);var nn;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast",q[q.HighContrastLight=4]="HighContrastLight"})(nn||(e.ColorThemeKind=nn={}));class di{static isNotebookRange(V){return V instanceof di?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(V,pe){if(V<0)throw(0,O.illegalArgument)("start must be positive");if(pe<0)throw(0,O.illegalArgument)("end must be positive");V<=pe?(this._start=V,this._end=pe):(this._start=pe,this._end=V)}with(V){let pe=this._start,Ne=this._end;return V.start!==void 0&&(pe=V.start),V.end!==void 0&&(Ne=V.end),pe===this._start&&Ne===this._end?this:new di(pe,Ne)}}e.NotebookRange=di;class yi{static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(pe=>yi.isNotebookCellData(pe))}static isNotebookCellData(V){return!0}constructor(V,pe,Ne,Je,nt,dt,mt){this.kind=V,this.value=pe,this.languageId=Ne,this.mime=Je,this.outputs=nt??[],this.metadata=dt,this.executionSummary=mt,yi.validate(this)}}e.NotebookCellData=yi;class We{constructor(V){this.cells=V}}e.NotebookData=We;class Wt{static isNotebookCellOutputItem(V){return V instanceof Wt?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const pe={name:V.name,message:V.message,stack:V.stack};return Wt.json(pe,"application/vnd.code.notebook.error")}static stdout(V){return Wt.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return Wt.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,pe="application/octet-stream"){return new Wt(V,pe)}static#e=new TextEncoder;static text(V,pe=R.Mimes.text){const Ne=Wt.#e.encode(String(V));return new Wt(Ne,pe)}static json(V,pe="text/x-json"){const Ne=JSON.stringify(V,void 0,"	");return Wt.text(Ne,pe)}constructor(V,pe){this.data=V,this.mime=pe;const Ne=(0,R.normalizeMimeType)(pe,!0);if(!Ne)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ne}}e.NotebookCellOutputItem=Wt;class _i{static isNotebookCellOutput(V){return V instanceof _i?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&Array.isArray(V.items)}static ensureUniqueMimeTypes(V,pe=!1){const Ne=new Set,Je=new Set;for(let nt=0;nt<V.length;nt++){const dt=V[nt],mt=(0,R.normalizeMimeType)(dt.mime);if(!Ne.has(mt)||(0,S.isTextStreamMime)(mt)){Ne.add(mt);continue}Je.add(nt),pe&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Je.size===0?V:V.filter((nt,dt)=>!Je.has(dt))}constructor(V,pe,Ne){this.items=_i.ensureUniqueMimeTypes(V,!0),typeof pe=="string"?(this.id=pe,this.metadata=Ne):(this.id=(0,A.generateUuid)(),this.metadata=pe??Ne)}}e.NotebookCellOutput=_i;var ot;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(ot||(e.NotebookCellKind=ot={}));var vt;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(vt||(e.NotebookCellExecutionState=vt={}));var rn;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var sn;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(sn||(e.NotebookEditorRevealType=sn={}));class on{constructor(V,pe){this.text=V,this.alignment=pe}}e.NotebookCellStatusBarItem=on;var an;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(an||(e.NotebookControllerAffinity=an={}));var Ci;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred",q[q.Hidden=-1]="Hidden"})(Ci||(e.NotebookControllerAffinity2=Ci={}));class bn{constructor(V,pe=[]){this.uri=V,this.provides=(0,c.asArray)(pe)}}e.NotebookRendererScript=bn;class En{constructor(V){this.label=V}}e.NotebookKernelSourceAction=En;var cn;(function(q){q[q.Named=1]="Named",q[q.Indexed=2]="Indexed"})(cn||(e.NotebookVariablesRequestKind=cn={}));let Ti=class{constructor(V,pe){this.label=V,this.timestamp=pe}};e.TimelineItem=Ti,e.TimelineItem=Ti=Ge([y],Ti);var ln;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(ln||(e.ExtensionMode=ln={}));var un;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(un||(e.ExtensionRuntime=un={}));var dn;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})(dn||(e.StandardTokenType=dn={}));class wn{constructor(V,pe){this.ranges=V,this.wordPattern=pe}}e.LinkedEditingRanges=wn;class Sn{constructor(V){this._autoForwardAction=V}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Sn;var hn;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(hn||(e.TestResultState=hn={}));var fn;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(fn||(e.TestRunProfileKind=fn={}));let Hi=class{constructor(V=void 0,pe=void 0,Ne=void 0,Je=!1){this.include=V,this.exclude=pe,this.profile=Ne,this.continuous=Je}};e.TestRunRequest=Hi,e.TestRunRequest=Hi=Ge([y],Hi);let Vi=_=class{static diff(V,pe,Ne){const Je=new _(V);return Je.expectedOutput=pe,Je.actualOutput=Ne,Je}constructor(V){this.message=V}};e.TestMessage=Vi,e.TestMessage=Vi=_=Ge([y],Vi);let qi=class{constructor(V){this.id=V}};e.TestTag=qi,e.TestTag=qi=Ge([y],qi);class Ai{constructor(V,pe){this.covered=V,this.total=pe,fe(this)}}e.TestCoverageCount=Ai;function fe(q){if(q){if(q.covered>q.total)throw new Error(`The total number of covered items (${q.covered}) cannot be greater than the total (${q.total})`);if(q.total<0)throw new Error(`The number of covered items (${q.total}) cannot be negative`)}}class we{static fromDetails(V,pe){const Ne=new Ai(0,0),Je=new Ai(0,0),nt=new Ai(0,0);for(const mt of pe)if("branches"in mt){Ne.total+=1,Ne.covered+=mt.executed?1:0;for(const Kt of mt.branches)Je.total+=1,Je.covered+=Kt.executed?1:0}else nt.total+=1,nt.covered+=mt.executed?1:0;const dt=new we(V,Ne,Je.total>0?Je:void 0,nt.total>0?nt:void 0);return dt.detailedCoverage=pe,dt}constructor(V,pe,Ne,Je){this.uri=V,this.statementCoverage=pe,this.branchCoverage=Ne,this.declarationCoverage=Je}}e.FileCoverage=we;class $e{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,pe,Ne=[]){this.executed=V,this.location=pe,this.branches=Ne}}e.StatementCoverage=$e;class ct{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,pe,Ne){this.executed=V,this.location=pe,this.label=Ne}}e.BranchCoverage=ct;class wt{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,pe,Ne){this.name=V,this.executed=pe,this.location=Ne}}e.DeclarationCoverage=wt;var Rt;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(Rt||(e.ExternalUriOpenerPriority=Rt={}));var Ri;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(Ri||(e.WorkspaceTrustState=Ri={}));var yn;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(yn||(e.PortAutoForwardAction=yn={}));class Nn{constructor(V,pe,Ne,Je,nt,dt){this.kind=V,this.name=pe,this.detail=Ne,this.uri=Je,this.range=nt,this.selectionRange=dt}}e.TypeHierarchyItem=Nn;class Mn{constructor(V){this.uri=V}}e.TextTabInput=Mn;class Fn{constructor(V,pe){this.original=V,this.modified=pe}}e.TextDiffTabInput=Fn;class xn{constructor(V,pe,Ne,Je){this.base=V,this.input1=pe,this.input2=Ne,this.result=Je}}e.TextMergeTabInput=xn;class zn{constructor(V,pe){this.uri=V,this.viewType=pe}}e.CustomEditorTabInput=zn;class Bn{constructor(V){this.viewType=V}}e.WebviewEditorTabInput=Bn;class $n{constructor(V,pe){this.uri=V,this.notebookType=pe}}e.NotebookEditorTabInput=$n;class Wn{constructor(V,pe,Ne){this.original=V,this.modified=pe,this.notebookType=Ne}}e.NotebookDiffEditorTabInput=Wn;class Un{constructor(){}}e.TerminalEditorTabInput=Un;class Hn{constructor(V,pe){this.uri=V,this.inputBoxUri=pe}}e.InteractiveWindowInput=Hn;class Vn{constructor(V){this.providerId=V}}e.ChatEditorTabInput=Vn;class qn{constructor(V){this.textDiffs=V}}e.TextMultiDiffTabInput=qn;var _n;(function(q){q[q.Down=0]="Down",q[q.Up=1]="Up"})(_n||(e.InteractiveSessionVoteDirection=_n={}));var Cn;(function(q){q[q.Action=1]="Action",q[q.Toolbar=2]="Toolbar"})(Cn||(e.ChatCopyKind=Cn={}));var Dn;(function(q){q[q.Short=1]="Short",q[q.Medium=2]="Medium",q[q.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class jn{constructor(V,pe){this.label=V,this.values=pe}}e.ChatCompletionItem=jn;var In;(function(q){q[q.Unhelpful=0]="Unhelpful",q[q.Helpful=1]="Helpful",q[q.Undone=2]="Undone",q[q.Accepted=3]="Accepted",q[q.Bug=4]="Bug"})(In||(e.InteractiveEditorResponseFeedbackKind=In={}));var Pn;(function(q){q[q.Unhelpful=0]="Unhelpful",q[q.Helpful=1]="Helpful"})(Pn||(e.ChatResultFeedbackKind=Pn={}));class Gn{constructor(V){this.value=typeof V=="string"?new ze(V):V}}e.ChatResponseMarkdownPart=Gn;class Kn{constructor(V,pe){this.value=V,this.baseUri=pe}}e.ChatResponseFileTreePart=Kn;class Xn{constructor(V,pe){this.value=V,this.title=pe}}e.ChatResponseAnchorPart=Xn;class Qn{constructor(V){this.value=V}}e.ChatResponseProgressPart=Qn;class Yn{constructor(V){this.value=V}}e.ChatResponseCommandButtonPart=Yn;class Jn{constructor(V){this.value=V}}e.ChatResponseReferencePart=Jn;class Zn{constructor(V,pe,Ne,Je){this.prompt=V,this.command=pe,this.variables=Ne,this.participant=Je}}e.ChatRequestTurn=Zn;class er{constructor(V,pe,Ne,Je){this.response=V,this.result=pe,this.participant=Ne,this.command=Je}}e.ChatResponseTurn=er;var kn;(function(q){q[q.Panel=1]="Panel",q[q.Terminal=2]="Terminal",q[q.Notebook=3]="Notebook",q[q.Editor=4]="Editor"})(kn||(e.ChatLocation=kn={}));class tr{constructor(V){this.content=V}}e.LanguageModelChatSystemMessage=tr;class ir{constructor(V,pe){this.content=V,this.name=pe}}e.LanguageModelChatUserMessage=ir;class nr{constructor(V,pe){this.content=V,this.name=pe}}e.LanguageModelChatAssistantMessage=nr;class Li extends Error{static NotFound(V){return new Li(V,Li.NotFound.name)}static NoPermissions(V){return new Li(V,Li.NoPermissions.name)}constructor(V,pe,Ne){super(V,{cause:Ne}),this.name="LanguageModelError",this.code=pe??""}}e.LanguageModelError=Li;var Tn;(function(q){q[q.SymbolInformation=1]="SymbolInformation",q[q.CommandInformation=2]="CommandInformation",q[q.SearchInformation=3]="SearchInformation",q[q.SettingInformation=4]="SettingInformation"})(Tn||(e.RelatedInformationType=Tn={}));var An;(function(q){q[q.Started=1]="Started",q[q.Recognizing=2]="Recognizing",q[q.Recognized=3]="Recognized",q[q.Stopped=4]="Stopped"})(An||(e.SpeechToTextStatus=An={}));var Rn;(function(q){q[q.Recognized=1]="Recognized",q[q.Stopped=2]="Stopped"})(Rn||(e.KeywordRecognitionStatus=Rn={}));class rr{constructor(V,pe){this.text=V,this.range=pe}}e.InlineEdit=rr;var Ln;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(Ln||(e.InlineEditTriggerKind=Ln={}))}),define(ye[323],_e([1,0,6,7]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class L{constructor(R){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=R.getProxy(c.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,b,p){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const w=this._relatedInformationProviders.get(R);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation(b,p)??[]}getRelatedInformation(R,b,p){return this._proxy.$getAiRelatedInformation(b,p)}registerRelatedInformationProvider(R,b,p){const w=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(w,p),this._proxy.$registerAiRelatedInformationProvider(w,b),new O.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(w),this._relatedInformationProviders.delete(w)})}}e.ExtHostRelatedInformation=L}),define(ye[120],_e([1,0,4,6,7,25,145,5,20]),function(de,e,c,O,L,T,R,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=e.IExtHostAuthentication=void 0,e.IExtHostAuthentication=(0,b.createDecorator)("IExtHostAuthentication");let w=class{constructor(v){this._authenticationProviders=new Map,this._onDidChangeSessions=new c.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new A,this._getSessionsTaskSingler=new A,this._proxy=v.getProxy(O.MainContext.MainThreadAuthentication)}async getSession(v,C,S,a={}){const m=T.ExtensionIdentifier.toKey(v.identifier),o=[...S].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${m} ${C} ${o}`,async()=>{await this._proxy.$ensureProvider(C);const n=v.displayName||v.name;return this._proxy.$getSession(C,S,m,n,a)})}async getSessions(v,C,S){const a=T.ExtensionIdentifier.toKey(v.identifier),m=[...S].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${a} ${m}`,async()=>{await this._proxy.$ensureProvider(C);const o=v.displayName||v.name;return this._proxy.$getSessions(C,S,a,o)})}async removeSession(v,C){const S=this._authenticationProviders.get(v);return S?S.provider.removeSession(C):this._proxy.$removeSession(v,C)}registerAuthenticationProvider(v,C,S,a){if(this._authenticationProviders.get(v))throw new Error(`An authentication provider with id '${v}' is already registered.`);this._authenticationProviders.set(v,{label:C,provider:S,options:a??{supportsMultipleAccounts:!1}});const m=S.onDidChangeSessions(o=>this._proxy.$sendDidChangeSessions(v,o));return this._proxy.$registerAuthenticationProvider(v,C,a?.supportsMultipleAccounts??!1),new L.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(v),this._proxy.$unregisterAuthenticationProvider(v)})}$createSession(v,C,S){const a=this._authenticationProviders.get(v);if(a)return Promise.resolve(a.provider.createSession(C,S));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$removeSession(v,C){const S=this._authenticationProviders.get(v);if(S)return Promise.resolve(S.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$getSessions(v,C){const S=this._authenticationProviders.get(v);if(S)return Promise.resolve(S.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$onDidChangeAuthenticationSessions(v,C){return v.startsWith(R.INTERNAL_AUTH_PROVIDER_PREFIX)||this._onDidChangeSessions.fire({provider:{id:v,label:C}}),Promise.resolve()}};e.ExtHostAuthentication=w,e.ExtHostAuthentication=w=Ge([Ue(0,p.IExtHostRpcService)],w);class A{constructor(){this._inFlightPromises=new Map}getOrCreate(v,C){const S=this._inFlightPromises.get(v);if(S)return S;const a=C().finally(()=>this._inFlightPromises.delete(v));return this._inFlightPromises.set(v,a),a}}}),define(ye[151],_e([1,0,2,6,7,5,20,12,19,14,17,26]),function(de,e,c,O,L,T,R,b,p,w,A,I){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class{static{v=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(a,m){this._logService=m,this._provider=new Map,this._proxy=a.getProxy(O.MainContext.MainThreadDecorations)}registerFileDecorationProvider(a,m){const o=v._handlePool++;this._provider.set(o,{provider:a,extensionDescription:m}),this._proxy.$registerDecorationProvider(o,m.identifier.value);const n=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(i=>{if(!i){this._proxy.$onDidChange(o,null);return}const r=(0,p.asArray)(i);if(r.length<=v._maxEventSize){this._proxy.$onDidChange(o,r);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,r.length);const s=r.map(h=>({uri:h,rank:(0,w.count)(h.path,"/")})),t=(0,p.groupBy)(s,(h,l)=>h.rank-l.rank||(0,w.compare)(h.uri.path,l.uri.path)),f=[];e:for(const h of t){let l;for(const u of h){const d=(0,A.dirname)(u.uri.path);if(l!==d&&(l=d,f.push(u.uri)>=v._maxEventSize))break e}}this._proxy.$onDidChange(o,f)});return new L.Disposable(()=>{n?.dispose(),this._proxy.$unregisterDecorationProvider(o),this._provider.delete(o)})}async $provideDecorations(a,m,o){if(!this._provider.has(a))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:r}=this._provider.get(a);return await Promise.all(m.map(async s=>{try{const{uri:t,id:f}=s,h=await Promise.resolve(i.provideFileDecoration(c.URI.revive(t),o));if(!h)return;try{L.FileDecoration.validate(h),h.badge&&typeof h.badge!="string"&&(0,I.checkProposedApiEnabled)(r,"codiconDecoration"),n[f]=[h.propagate,h.tooltip,h.badge,h.color]}catch(l){this._logService.warn(`INVALID decoration from extension '${r.identifier.value}': ${l}`)}}catch(t){this._logService.error(t)}})),n}};e.ExtHostDecorations=C,e.ExtHostDecorations=C=v=Ge([Ue(0,R.IExtHostRpcService),Ue(1,b.ILogService)],C),e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(ye[324],_e([1,0,13,2,7,6,15,22,14]),function(de,e,c,O,L,T,R,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class w{static{this._handlePool=0}constructor(I,v,C){this._documentsAndEditors=v,this._logService=C,this._documentContentProviders=new Map,this._proxy=I.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,v){if(Object.keys(R.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const C=w._handlePool++;this._documentContentProviders.set(C,v),this._proxy.$registerTextContentProvider(C,I);let S;if(typeof v.onDidChange=="function"){let a;S=v.onDidChange(async m=>{if(m.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this._documentsAndEditors.getDocument(m))return;a&&await a;const o=this.$provideTextDocumentContent(C,m).then(async n=>{if(!n&&typeof n!="string")return;const i=this._documentsAndEditors.getDocument(m);if(!i)return;const r=(0,p.splitLines)(n);if(!i.equalLines(r))return this._proxy.$onVirtualDocumentChange(m,n)}).catch(c.onUnexpectedError).finally(()=>{a===o&&(a=void 0)});a=o})}return new L.Disposable(()=>{this._documentContentProviders.delete(C)&&this._proxy.$unregisterTextContentProvider(C),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(I,v){const C=this._documentContentProviders.get(I);return C?Promise.resolve(C.provideTextDocumentContent(O.URI.revive(v),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.ExtHostDocumentContentProvider=w}),define(ye[152],_e([1,0,61,15,14,183,129,7,19]),function(de,e,c,O,L,T,R,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=void 0,e.setWordDefinitionFor=A;const w=new Map;function A(S,a){a?w.set(S,a):w.delete(S)}function I(S){return w.get(S)}class v extends T.MirrorTextModel{constructor(a,m,o,n,i,r,s){super(m,o,n,i),this._proxy=a,this._languageId=r,this._isDirty=s,this._isDisposed=!1}dispose(){(0,c.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,p.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===O.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},save(){return a._save()},getText(m){return m?a._getTextInRange(m):a.getText()},get eol(){return a._eol===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(m){return a._lineAt(m)},offsetAt(m){return a._offsetAt(m)},positionAt(m){return a._positionAt(m)},validateRange(m){return a._validateRange(m)},validatePosition(m){return a._validatePosition(m)},getWordRangeAtPosition(m,o){return a._getWordRangeAtPosition(m,o)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,c.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,c.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const m=this._validateRange(a);if(m.isEmpty)return"";if(m.isSingleLine)return this._lines[m.start.line].substring(m.start.character,m.end.character);const o=this._eol,n=m.start.line,i=m.end.line,r=[];r.push(this._lines[n].substring(m.start.character));for(let s=n+1;s<i;s++)r.push(this._lines[s]);return r.push(this._lines[i].substring(0,m.end.character)),r.join(o)}_lineAt(a){let m;if(a instanceof b.Position?m=a.line:typeof a=="number"&&(m=a),typeof m!="number"||m<0||m>=this._lines.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new C(m,this._lines[m],m===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getPrefixSum(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const m=this._lineStarts.getIndexOf(a),o=this._lines[m.index].length;return new b.Position(m.index,Math.min(m.remainder,o))}_validateRange(a){if(!(a instanceof b.Range))throw new Error("Invalid argument");const m=this._validatePosition(a.start),o=this._validatePosition(a.end);return m===a.start&&o===a.end?a:new b.Range(m.line,m.character,o.line,o.character)}_validatePosition(a){if(!(a instanceof b.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:m,character:o}=a,n=!1;if(m<0)m=0,o=0,n=!0;else if(m>=this._lines.length)m=this._lines.length-1,o=this._lines[m].length,n=!0;else{const i=this._lines[m].length;o<0?(o=0,n=!0):o>i&&(o=i,n=!0)}return n?new b.Position(m,o):a}_getWordRangeAtPosition(a,m){const o=this._validatePosition(a);if(!m)m=I(this._languageId);else if((0,L.regExpLeadsToEndlessLoop)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const n=(0,R.getWordAtText)(o.character+1,(0,R.ensureValidWordDefinition)(m),this._lines[o.line],0);if(n)return new b.Range(o.line,n.startColumn-1,o.line,n.endColumn-1)}}e.ExtHostDocumentData=v;class C{constructor(a,m,o){this._line=a,this._text=m,this._isLastLine=o}get lineNumber(){return this._line}get text(){return this._text}get range(){return new b.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new b.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=C}),define(ye[325],_e([1,0,6,7]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class L{constructor(R){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=R.getProxy(c.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,b,p){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const w=this._AiEmbeddingVectorProviders.get(R);if(!w)throw new Error("Embedding vector provider not found");const A=await w.provideEmbeddingVector(b,p);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,b,p){const w=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(w,p),this._proxy.$registerAiEmbeddingVectorProvider(b,w),new O.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(w),this._AiEmbeddingVectorProviders.delete(w)})}}e.ExtHostAiEmbeddingVector=L}),define(ye[69],_e([1,0,6,32,7,21,5,20,59,3,8,23,15]),function(de,e,c,O,L,T,R,b,p,w,A,I,v){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let S=C=class{constructor(m,o){this._fileSystemProvider=new Map,this._writeQueue=new A.ResourceQueue,this._proxy=m.getProxy(c.MainContext.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let r;const s=n._fileSystemProvider.get(i.scheme);return s?(await n._proxy.$ensureActivation(i.scheme),r=await s.impl.stat(i)):r=await n._proxy.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===O.FilePermission.Readonly?1:void 0}}catch(r){C._handleError(r)}},async readDirectory(i){try{const r=n._fileSystemProvider.get(i.scheme);return r?(await n._proxy.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await n._proxy.$readdir(i)}catch(r){return C._handleError(r)}},async createDirectory(i){try{const r=n._fileSystemProvider.get(i.scheme);return r&&!r.isReadonly?(await n._proxy.$ensureActivation(i.scheme),await n.mkdirp(r.impl,r.extUri,i)):await n._proxy.$mkdir(i)}catch(r){return C._handleError(r)}},async readFile(i){try{const r=n._fileSystemProvider.get(i.scheme);return r?(await n._proxy.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await n._proxy.$readFile(i)).buffer}catch(r){return C._handleError(r)}},async writeFile(i,r){try{const s=n._fileSystemProvider.get(i.scheme);return s&&!s.isReadonly?(await n._proxy.$ensureActivation(i.scheme),await n.mkdirp(s.impl,s.extUri,s.extUri.dirname(i)),await n._writeQueue.queueFor(i,()=>Promise.resolve(s.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await n._proxy.$writeFile(i,T.VSBuffer.wrap(r))}catch(s){return C._handleError(s)}},async delete(i,r){try{const s=n._fileSystemProvider.get(i.scheme);return s&&!s.isReadonly&&!r?.useTrash?(await n._proxy.$ensureActivation(i.scheme),await s.impl.delete(i,{recursive:!1,...r})):await n._proxy.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(s){return C._handleError(s)}},async rename(i,r,s){try{return await n._proxy.$rename(i,r,{overwrite:!1,...s})}catch(t){return C._handleError(t)}},async copy(i,r,s){try{return await n._proxy.$copy(i,r,{overwrite:!1,...s})}catch(t){return C._handleError(t)}},isWritableFileSystem(i){const r=o.getCapabilities(i);if(typeof r=="number")return!(r&2048)}})}async mkdirp(m,o,n){const i=[];for(;!o.isEqual(n,o.dirname(n));)try{if(!((await m.stat(n)).type&O.FileType.Directory))throw L.FileSystemError.FileExists(`Unable to create folder '${n.scheme===v.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(O.toFileSystemProviderErrorCode(r)!==O.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(o.basename(n)),n=o.dirname(n)}for(let r=i.length-1;r>=0;r--){n=o.joinPath(n,i[r]);try{await m.createDirectory(n)}catch(s){if(O.toFileSystemProviderErrorCode(s)!==O.FileSystemProviderErrorCode.FileExists)throw s}}}static _handleError(m){if(m instanceof L.FileSystemError)throw m;if(m instanceof O.FileSystemProviderError)switch(m.code){case O.FileSystemProviderErrorCode.FileExists:throw L.FileSystemError.FileExists(m.message);case O.FileSystemProviderErrorCode.FileNotFound:throw L.FileSystemError.FileNotFound(m.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw L.FileSystemError.FileNotADirectory(m.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw L.FileSystemError.FileIsADirectory(m.message);case O.FileSystemProviderErrorCode.NoPermissions:throw L.FileSystemError.NoPermissions(m.message);case O.FileSystemProviderErrorCode.Unavailable:throw L.FileSystemError.Unavailable(m.message);default:throw new L.FileSystemError(m.message,m.name)}if(!(m instanceof Error))throw new L.FileSystemError(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw L.FileSystemError.Unavailable(m.message);switch(m.name){case O.FileSystemProviderErrorCode.FileExists:throw L.FileSystemError.FileExists(m.message);case O.FileSystemProviderErrorCode.FileNotFound:throw L.FileSystemError.FileNotFound(m.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw L.FileSystemError.FileNotADirectory(m.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw L.FileSystemError.FileIsADirectory(m.message);case O.FileSystemProviderErrorCode.NoPermissions:throw L.FileSystemError.NoPermissions(m.message);case O.FileSystemProviderErrorCode.Unavailable:throw L.FileSystemError.Unavailable(m.message);default:throw new L.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,o,n){return this._fileSystemProvider.set(m,{impl:o,extUri:n?.isCaseSensitive?I.extUri:I.extUriIgnorePathCase,isReadonly:!!n?.isReadonly}),(0,w.toDisposable)(()=>this._fileSystemProvider.delete(m))}getFileSystemProviderExtUri(m){return this._fileSystemProvider.get(m)?.extUri??I.extUri}};e.ExtHostConsumerFileSystem=S,e.ExtHostConsumerFileSystem=S=C=Ge([Ue(0,b.IExtHostRpcService),Ue(1,p.IExtHostFileSystemInfo)],S),e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[326],_e([1,0,6,7]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class L{constructor(R){this._IssueUriRequestHandlers=new Map,this._IssueDataProviders=new Map,this._proxy=R.getProxy(c.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(R,b){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const p=this._IssueUriRequestHandlers.get(R);if(!p)throw new Error("Issue request handler not found");const w=await p.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}async $getIssueReporterData(R,b){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const p=this._IssueDataProviders.get(R);if(!p)throw new Error("Issue data provider not found");const w=await p.provideIssueData(b);if(!w)throw new Error("Issue data provider returned no result");return w}async $getIssueReporterTemplate(R,b){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const p=this._IssueDataProviders.get(R);if(!p)throw new Error("Issue data provider not found");const w=await p.provideIssueTemplate(b);if(!w)throw new Error("Issue template provider returned no result");return w}registerIssueUriRequestHandler(R,b){const p=R.identifier.value;return this._IssueUriRequestHandlers.set(p,b),this._proxy.$registerIssueUriRequestHandler(p),new O.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(p),this._IssueUriRequestHandlers.delete(p)})}registerIssueDataProvider(R,b){const p=R.identifier.value;return this._IssueDataProviders.set(p,b),this._proxy.$registerIssueDataProvider(p),new O.Disposable(()=>{this._proxy.$unregisterIssueDataProvider(p),this._IssueDataProviders.delete(p)})}}e.ExtHostIssueReporter=L}),define(ye[93],_e([1,0,5,28,12,69,2]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let b=class{constructor(w,A,I){this._logService=A,this._extHostFileSystem=I,this._workspace=w.workspace??void 0,this._environment=w.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(v=>this._value=v)}async _getWorkspaceStorageURI(w){return R.URI.joinPath(this._environment.workspaceStorageHome,w)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const w=this._workspace.id,A=await this._getWorkspaceStorageURI(w);try{return await this._extHostFileSystem.value.stat(A),this._logService.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",A),await this._extHostFileSystem.value.createDirectory(A),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),A}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(w){if(this._value)return R.URI.joinPath(this._value,w.identifier.value)}globalValue(w){return R.URI.joinPath(this._environment.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=b,e.ExtensionStoragePaths=b=Ge([Ue(0,O.IExtHostInitDataService),Ue(1,L.ILogService),Ue(2,T.IExtHostConsumerFileSystem)],b)}),define(ye[327],_e([1,0,7,20,4]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(b){this._actual=new c.ColorTheme(c.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new L.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(b){let p;switch(b){case"light":p=c.ColorThemeKind.Light;break;case"hcDark":p=c.ColorThemeKind.HighContrast;break;case"hcLight":p=c.ColorThemeKind.HighContrastLight;break;default:p=c.ColorThemeKind.Dark}this._actual=new c.ColorTheme(p),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=T,e.ExtHostTheming=T=Ge([Ue(0,O.IExtHostRpcService)],T)}),define(ye[70],_e([1,0,22,4,3,229,5,12,88,6,28,20,7]),function(de,e,c,O,L,T,R,b,p,w,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class C extends p.DisposableTunnel{}var S;(function(m){function o(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:i.protocol}}m.fromApiTunnel=o;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==p.TunnelPrivacyId.ConstantPrivate&&i.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}m.fromServiceTunnel=n})(S||(e.TunnelDtoConverter=S={})),e.IExtHostTunnelService=(0,R.createDecorator)("IExtHostTunnelService");let a=class extends L.Disposable{constructor(o,n,i){super(),this.logService=i,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new O.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=o.getProxy(w.MainContext.MainThreadTunnelService)}async openTunnel(o,n){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this._proxy.$openTunnel(n,o.displayName);if(i){const r=new C(i.remoteAddress,i.localAddress,()=>this._proxy.$closeTunnel(i.remoteAddress));return this._register(r),r}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(o,n){o.portRange===void 0&&o.commandPattern===void 0&&this.logService.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(i,{selector:o,provider:n}),this._proxy.$registerPortsAttributesProvider(o,i),new v.Disposable(()=>{this._portAttributesProviders.delete(i),this._proxy.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(o,n,i,r,s){const t=[];for(const h of o){const l=this._portAttributesProviders.get(h);if(!l)return[];t.push(...await Promise.all(n.map(async u=>{let d;try{d=await l.provider.providePortAttributes({port:u,pid:i,commandLine:r},s)}catch{d=await l.provider.providePortAttributes(u,i,r,s)}return{providedAttributes:d,port:u}})))}const f=t.filter(h=>!!h.providedAttributes);return f.length>0?f.map(h=>({autoForwardAction:h.providedAttributes.autoForwardAction,port:h.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,n){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(r,s)=>await o.provideTunnel(r,s,c.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this._proxy.$setTunnelProvider(i),Promise.resolve((0,L.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,n){if(o){o.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this._showCandidatePort=o.showCandidatePort,this._proxy.$setCandidateFilter());const i=o.tunnelFactory??(n?this.makeManagedTunnelFactory(n):void 0);if(i){this._forwardPortProvider=i;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const s=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this._proxy.$setTunnelProvider(s)}}else this._forwardPortProvider=void 0;return(0,L.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(o){}async $closeTunnel(o,n){if(this._extensionTunnels.has(o.host)){const i=this._extensionTunnels.get(o.host);i.has(o.port)&&(n&&i.get(o.port).disposeListener.dispose(),await i.get(o.port).tunnel.dispose(),i.delete(o.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(o,n){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this._forwardPortProvider(o,n);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(o.remoteAddress.host)||this._extensionTunnels.set(o.remoteAddress.host,new Map);const s=this._register(r.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(r.remoteAddress))));return this._extensionTunnels.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:s}),S.fromApiTunnel(r)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(o){const n=await Promise.all(o.map(r=>this._showCandidatePort(r.host,r.port,r.detail??""))),i=o.filter((r,s)=>n[s]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.ExtHostTunnelService=a,e.ExtHostTunnelService=a=Ge([Ue(0,I.IExtHostRpcService),Ue(1,A.IExtHostInitDataService),Ue(2,b.ILogService)],a)}),define(ye[16],_e([1,0,19,21,172,74,80,27,165,57,101,24,167,23,18,2,29,83,138,144,142,289,119,67,89,301,26,7]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n,i,r,s,t,f,h,l,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.isDecorationOptionsArr=B,e.fromRangeOrRangeWithMessage=Y,e.pathOrURIToURI=Z;var g;(function(Oe){function Fe(ee){const{selectionStartLineNumber:Re,selectionStartColumn:Ve,positionLineNumber:et,positionColumn:Xe}=ee,ut=new d.Position(Re-1,Ve-1),yt=new d.Position(et-1,Xe-1);return new d.Selection(ut,yt)}Oe.to=Fe;function Se(ee){const{anchor:Re,active:Ve}=ee;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Oe.from=Se})(g||(e.Selection=g={}));var D;(function(Oe){function Fe(ee){if(!ee)return;const{start:Re,end:Ve}=ee;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Oe.from=Fe;function Se(ee){if(!ee)return;const{startLineNumber:Re,startColumn:Ve,endLineNumber:et,endColumn:Xe}=ee;return new d.Range(Re-1,Ve-1,et-1,Xe-1)}Oe.to=Se})(D||(e.Range=D={}));var E;(function(Oe){function Fe(ee){return{uri:ee.uri,range:D.from(ee.range)}}Oe.from=Fe;function Se(ee){return new d.Location(a.URI.revive(ee.uri),D.to(ee.range))}Oe.to=Se})(E||(e.Location=E={}));var _;(function(Oe){function Fe(Se){switch(Se){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}Oe.to=Fe})(_||(e.TokenType=_={}));var y;(function(Oe){function Fe(ee){return new d.Position(ee.lineNumber-1,ee.column-1)}Oe.to=Fe;function Se(ee){return{lineNumber:ee.line+1,column:ee.character+1}}Oe.from=Se})(y||(e.Position=y={}));var P;(function(Oe){function Fe(Re,Ve,et){return(0,c.coalesce)((0,c.asArray)(Re).map(Xe=>Se(Xe,Ve,et)))}Oe.from=Fe;function Se(Re,Ve,et){if(typeof Re=="string")return{$serialized:!0,language:Re,isBuiltin:et?.isBuiltin};if(Re)return{$serialized:!0,language:Re.language,scheme:ee(Re.scheme,Ve),pattern:ke.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType,isBuiltin:et?.isBuiltin}}function ee(Re,Ve){return Ve&&typeof Re=="string"?Ve.transformOutgoingScheme(Re):Re}})(P||(e.DocumentSelector=P={}));var k;(function(Oe){function Fe(ee){switch(ee){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}Oe.from=Fe;function Se(ee){switch(ee){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}Oe.to=Se})(k||(e.DiagnosticTag=k={}));var z;(function(Oe){function Fe(ee){let Re;return ee.code&&((0,S.isString)(ee.code)||(0,S.isNumber)(ee.code)?Re=String(ee.code):Re={value:String(ee.code.value),target:ee.code.target}),{...D.from(ee.range),message:ee.message,source:ee.source,code:Re,severity:F.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(x.from),tags:Array.isArray(ee.tags)?(0,c.coalesce)(ee.tags.map(k.from)):void 0}}Oe.from=Fe;function Se(ee){const Re=new d.Diagnostic(D.to(ee),ee.message,F.to(ee.severity));return Re.source=ee.source,Re.code=(0,S.isString)(ee.code)?ee.code:ee.code?.value,Re.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(x.to),Re.tags=ee.tags&&(0,c.coalesce)(ee.tags.map(k.to)),Re}Oe.to=Se})(z||(e.Diagnostic=z={}));var x;(function(Oe){function Fe(ee){return{...D.from(ee.location.range),message:ee.message,resource:ee.location.uri}}Oe.from=Fe;function Se(ee){return new d.DiagnosticRelatedInformation(new d.Location(ee.resource,D.to(ee)),ee.message)}Oe.to=Se})(x||(e.DiagnosticRelatedInformation=x={}));var F;(function(Oe){function Fe(ee){switch(ee){case d.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Oe.from=Fe;function Se(ee){switch(ee){case n.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}Oe.to=Se})(F||(e.DiagnosticSeverity=F={}));var N;(function(Oe){function Fe(ee){return typeof ee=="number"&&ee>=d.ViewColumn.One?ee-1:ee===d.ViewColumn.Beside?l.SIDE_GROUP:l.ACTIVE_GROUP}Oe.from=Fe;function Se(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}Oe.to=Se})(N||(e.ViewColumn=N={}));function M(Oe){return typeof Oe.range<"u"}function B(Oe){return Oe.length===0?!0:!!M(Oe[0])}var W;(function(Oe){function Fe(Xe){return Xe.map(Oe.from)}Oe.fromMany=Fe;function Se(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function ee(Xe){let ut;if(Se(Xe)){const{language:$t,value:Gt}=Xe;ut={value:"```"+$t+`
`+Gt+"\n```\n"}}else d.MarkdownString.isMarkdownString(Xe)?ut={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons,supportHtml:Xe.supportHtml,baseUri:Xe.baseUri}:typeof Xe=="string"?ut={value:Xe}:ut={value:""};const yt=Object.create(null);ut.uris=yt;const _t=$t=>{try{let Gt=a.URI.parse($t,!0);Gt=Gt.with({query:Re(Gt.query,yt)}),yt[$t]=Gt}catch{}return""},Zt=new p.marked.Renderer;return Zt.link=_t,Zt.image=$t=>typeof $t=="string"?_t(R.parseHrefAndDimensions($t).href):"",(0,p.marked)(ut.value,{renderer:Zt}),ut}Oe.from=ee;function Re(Xe,ut){if(!Xe)return Xe;let yt;try{yt=(0,w.parse)(Xe)}catch{}if(!yt)return Xe;let _t=!1;return yt=(0,I.cloneAndChange)(yt,Zt=>{if(a.URI.isUri(Zt)){const $t=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[$t]=Zt,_t=!0,$t}else return}),_t?JSON.stringify(yt):Xe}function Ve(Xe){const ut=new d.MarkdownString(Xe.value,Xe.supportThemeIcons);return ut.isTrusted=Xe.isTrusted,ut.supportHtml=Xe.supportHtml,ut.baseUri=Xe.baseUri?a.URI.from(Xe.baseUri):void 0,ut}Oe.to=Ve;function et(Xe){if(Xe)return typeof Xe=="string"?Xe:Oe.from(Xe)}Oe.fromStrict=et})(W||(e.MarkdownString=W={}));function Y(Oe){return B(Oe)?Oe.map(Fe=>({range:D.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?W.fromMany(Fe.hoverMessage):Fe.hoverMessage?W.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Oe.map(Fe=>({range:D.from(Fe)}))}function Z(Oe){return typeof Oe>"u"?Oe:typeof Oe=="string"?a.URI.file(Oe):Oe}var G;(function(Oe){function Fe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?Z(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Oe.from=Fe})(G||(e.ThemableDecorationAttachmentRenderOptions=G={}));var Q;(function(Oe){function Fe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?Z(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?G.from(Se.before):void 0,after:Se.after?G.from(Se.after):void 0}}Oe.from=Fe})(Q||(e.ThemableDecorationRenderOptions=Q={}));var re;(function(Oe){function Fe(Se){if(typeof Se>"u")return Se;switch(Se){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}Oe.from=Fe})(re||(e.DecorationRangeBehavior=re={}));var te;(function(Oe){function Fe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?re.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?Q.from(Se.light):void 0,dark:Se.dark?Q.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?Z(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?G.from(Se.before):void 0,after:Se.after?G.from(Se.after):void 0}}Oe.from=Fe})(te||(e.DecorationRenderOptions=te={}));var ve;(function(Oe){function Fe(ee){return{text:ee.newText,eol:ee.newEol&&qe.from(ee.newEol),range:D.from(ee.range)}}Oe.from=Fe;function Se(ee){const Re=new d.TextEdit(D.to(ee.range),ee.text);return Re.newEol=typeof ee.eol>"u"?void 0:qe.to(ee.eol),Re}Oe.to=Se})(ve||(e.TextEdit=ve={}));var Ie;(function(Oe){function Fe(ee,Re){const Ve={edits:[]};if(ee instanceof d.WorkspaceEdit){const et=new b.ResourceSet;for(const Xe of ee._allEntries())Xe._type===1&&a.URI.isUri(Xe.to)&&Xe.from===void 0&&et.add(Xe.to);for(const Xe of ee._allEntries())if(Xe._type===1){let ut;Xe.options?.contents&&(ArrayBuffer.isView(Xe.options.contents)?ut={type:"base64",value:(0,O.encodeBase64)(O.VSBuffer.wrap(Xe.options.contents))}:ut={type:"dataTransferItem",id:Xe.options.contents._itemId}),Ve.edits.push({oldResource:Xe.from,newResource:Xe.to,options:{...Xe.options,contents:ut},metadata:Xe.metadata})}else Xe._type===2?Ve.edits.push({resource:Xe.uri,textEdit:ve.from(Xe.edit),versionId:et.has(Xe.uri)?void 0:Re?.getTextDocumentVersion(Xe.uri),metadata:Xe.metadata}):Xe._type===6?Ve.edits.push({resource:Xe.uri,textEdit:{range:D.from(Xe.range),text:Xe.edit.value,insertAsSnippet:!0},versionId:et.has(Xe.uri)?void 0:Re?.getTextDocumentVersion(Xe.uri),metadata:Xe.metadata}):Xe._type===3?Ve.edits.push({metadata:Xe.metadata,resource:Xe.uri,cellEdit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(Xe.uri)}):Xe._type===5&&Ve.edits.push({metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Re?.getNotebookDocumentVersion(Xe.uri),cellEdit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(Xt.from)}})}return Ve}Oe.from=Fe;function Se(ee){const Re=new d.WorkspaceEdit,Ve=new b.ResourceMap;for(const et of ee.edits)if(et.textEdit){const Xe=et,ut=a.URI.revive(Xe.resource),yt=D.to(Xe.textEdit.range),_t=Xe.textEdit.text,Zt=Xe.textEdit.insertAsSnippet;let $t;Zt?$t=d.SnippetTextEdit.replace(yt,new d.SnippetString(_t)):$t=d.TextEdit.replace(yt,_t);const Gt=Ve.get(ut);Gt?Gt.push($t):Ve.set(ut,[$t])}else Re.renameFile(a.URI.revive(et.oldResource),a.URI.revive(et.newResource),et.options);for(const[et,Xe]of Ve)Re.set(et,Xe);return Re}Oe.to=Se})(Ie||(e.WorkspaceEdit=Ie={}));var J;(function(Oe){const Fe=Object.create(null);Fe[d.SymbolKind.File]=0,Fe[d.SymbolKind.Module]=1,Fe[d.SymbolKind.Namespace]=2,Fe[d.SymbolKind.Package]=3,Fe[d.SymbolKind.Class]=4,Fe[d.SymbolKind.Method]=5,Fe[d.SymbolKind.Property]=6,Fe[d.SymbolKind.Field]=7,Fe[d.SymbolKind.Constructor]=8,Fe[d.SymbolKind.Enum]=9,Fe[d.SymbolKind.Interface]=10,Fe[d.SymbolKind.Function]=11,Fe[d.SymbolKind.Variable]=12,Fe[d.SymbolKind.Constant]=13,Fe[d.SymbolKind.String]=14,Fe[d.SymbolKind.Number]=15,Fe[d.SymbolKind.Boolean]=16,Fe[d.SymbolKind.Array]=17,Fe[d.SymbolKind.Object]=18,Fe[d.SymbolKind.Key]=19,Fe[d.SymbolKind.Null]=20,Fe[d.SymbolKind.EnumMember]=21,Fe[d.SymbolKind.Struct]=22,Fe[d.SymbolKind.Event]=23,Fe[d.SymbolKind.Operator]=24,Fe[d.SymbolKind.TypeParameter]=25;function Se(Re){return typeof Fe[Re]=="number"?Fe[Re]:6}Oe.from=Se;function ee(Re){for(const Ve in Fe)if(Fe[Ve]===Re)return Number(Ve);return d.SymbolKind.Property}Oe.to=ee})(J||(e.SymbolKind=J={}));var $;(function(Oe){function Fe(ee){switch(ee){case d.SymbolTag.Deprecated:return 1}}Oe.from=Fe;function Se(ee){switch(ee){case 1:return d.SymbolTag.Deprecated}}Oe.to=Se})($||(e.SymbolTag=$={}));var ne;(function(Oe){function Fe(ee){return{name:ee.name,kind:J.from(ee.kind),tags:ee.tags&&ee.tags.map($.from),containerName:ee.containerName,location:se.from(ee.location)}}Oe.from=Fe;function Se(ee){const Re=new d.SymbolInformation(ee.name,J.to(ee.kind),ee.containerName,se.to(ee.location));return Re.tags=ee.tags&&ee.tags.map($.to),Re}Oe.to=Se})(ne||(e.WorkspaceSymbol=ne={}));var be;(function(Oe){function Fe(ee){const Re={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:D.from(ee.range),selectionRange:D.from(ee.selectionRange),kind:J.from(ee.kind),tags:ee.tags?.map($.from)??[]};return ee.children&&(Re.children=ee.children.map(Fe)),Re}Oe.from=Fe;function Se(ee){const Re=new d.DocumentSymbol(ee.name,ee.detail,J.to(ee.kind),D.to(ee.range),D.to(ee.selectionRange));return(0,c.isNonEmptyArray)(ee.tags)&&(Re.tags=ee.tags.map($.to)),ee.children&&(Re.children=ee.children.map(Se)),Re}Oe.to=Se})(be||(e.DocumentSymbol=be={}));var Ce;(function(Oe){function Fe(ee){const Re=new d.CallHierarchyItem(J.to(ee.kind),ee.name,ee.detail||"",a.URI.revive(ee.uri),D.to(ee.range),D.to(ee.selectionRange));return Re._sessionId=ee._sessionId,Re._itemId=ee._itemId,Re}Oe.to=Fe;function Se(ee,Re,Ve){if(Re=Re??ee._sessionId,Ve=Ve??ee._itemId,Re===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Ve,name:ee.name,detail:ee.detail,kind:J.from(ee.kind),uri:ee.uri,range:D.from(ee.range),selectionRange:D.from(ee.selectionRange),tags:ee.tags?.map($.from)}}Oe.from=Se})(Ce||(e.CallHierarchyItem=Ce={}));var ae;(function(Oe){function Fe(Se){return new d.CallHierarchyIncomingCall(Ce.to(Se.from),Se.fromRanges.map(ee=>D.to(ee)))}Oe.to=Fe})(ae||(e.CallHierarchyIncomingCall=ae={}));var ce;(function(Oe){function Fe(Se){return new d.CallHierarchyOutgoingCall(Ce.to(Se.to),Se.fromRanges.map(ee=>D.to(ee)))}Oe.to=Fe})(ce||(e.CallHierarchyOutgoingCall=ce={}));var se;(function(Oe){function Fe(ee){return{range:ee.range&&D.from(ee.range),uri:ee.uri}}Oe.from=Fe;function Se(ee){return new d.Location(a.URI.revive(ee.uri),D.to(ee.range))}Oe.to=Se})(se||(e.location=se={}));var j;(function(Oe){function Fe(ee){const Re=ee,Ve=ee;return{originSelectionRange:Re.originSelectionRange?D.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Ve.uri,range:D.from(Re.targetRange?Re.targetRange:Ve.range),targetSelectionRange:Re.targetSelectionRange?D.from(Re.targetSelectionRange):void 0}}Oe.from=Fe;function Se(ee){return{targetUri:a.URI.revive(ee.uri),targetRange:D.to(ee.range),targetSelectionRange:ee.targetSelectionRange?D.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?D.to(ee.originSelectionRange):void 0}}Oe.to=Se})(j||(e.DefinitionLink=j={}));var ie;(function(Oe){function Fe(ee){return{range:D.from(ee.range),contents:W.fromMany(ee.contents)}}Oe.from=Fe;function Se(ee){return new d.Hover(ee.contents.map(W.to),D.to(ee.range))}Oe.to=Se})(ie||(e.Hover=ie={}));var ue;(function(Oe){function Fe(ee){return{range:D.from(ee.range),expression:ee.expression}}Oe.from=Fe;function Se(ee){return new d.EvaluatableExpression(D.to(ee.range),ee.expression)}Oe.to=Se})(ue||(e.EvaluatableExpression=ue={}));var he;(function(Oe){function Fe(ee){if(ee instanceof d.InlineValueText)return{type:"text",range:D.from(ee.range),text:ee.text};if(ee instanceof d.InlineValueVariableLookup)return{type:"variable",range:D.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:D.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}Oe.from=Fe;function Se(ee){switch(ee.type){case"text":return{range:D.to(ee.range),text:ee.text};case"variable":return{range:D.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:D.to(ee.range),expression:ee.expression}}}Oe.to=Se})(he||(e.InlineValue=he={}));var Te;(function(Oe){function Fe(ee){return{frameId:ee.frameId,stoppedLocation:D.from(ee.stoppedLocation)}}Oe.from=Fe;function Se(ee){return new d.InlineValueContext(ee.frameId,D.to(ee.stoppedLocation))}Oe.to=Se})(Te||(e.InlineValueContext=Te={}));var me;(function(Oe){function Fe(ee){return{range:D.from(ee.range),kind:ee.kind}}Oe.from=Fe;function Se(ee){return new d.DocumentHighlight(D.to(ee.range),ee.kind)}Oe.to=Se})(me||(e.DocumentHighlight=me={}));var Pe;(function(Oe){function Fe(ee){return{uri:ee.uri,highlights:ee.highlights.map(me.from)}}Oe.from=Fe;function Se(ee){return new d.MultiDocumentHighlight(a.URI.revive(ee.uri),ee.highlights.map(me.to))}Oe.to=Se})(Pe||(e.MultiDocumentHighlight=Pe={}));var Ae;(function(Oe){function Fe(Se){switch(Se){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}Oe.to=Fe})(Ae||(e.CompletionTriggerKind=Ae={}));var xe;(function(Oe){function Fe(Se){return{triggerKind:Ae.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Oe.to=Fe})(xe||(e.CompletionContext=xe={}));var H;(function(Oe){function Fe(ee){switch(ee){case d.CompletionItemTag.Deprecated:return 1}}Oe.from=Fe;function Se(ee){switch(ee){case 1:return d.CompletionItemTag.Deprecated}}Oe.to=Se})(H||(e.CompletionItemTag=H={}));var U;(function(Oe){const Fe=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function Se(Ve){return Fe.get(Ve)??9}Oe.from=Se;const ee=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Re(Ve){return ee.get(Ve)??d.CompletionItemKind.Property}Oe.to=Re})(U||(e.CompletionItemKind=U={}));var X;(function(Oe){function Fe(Se,ee){const Re=new d.CompletionItem(Se.label);return Re.insertText=Se.insertText,Re.kind=U.to(Se.kind),Re.tags=Se.tags?.map(H.to),Re.detail=Se.detail,Re.documentation=R.isMarkdownString(Se.documentation)?W.to(Se.documentation):Se.documentation,Re.sortText=Se.sortText,Re.filterText=Se.filterText,Re.preselect=Se.preselect,Re.commitCharacters=Se.commitCharacters,m.Range.isIRange(Se.range)?Re.range=D.to(Se.range):typeof Se.range=="object"&&(Re.range={inserting:D.to(Se.range.insert),replacing:D.to(Se.range.replace)}),Re.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Re.insertText=new d.SnippetString(Se.insertText):(Re.insertText=Se.insertText,Re.textEdit=Re.range instanceof d.Range?new d.TextEdit(Re.range,Re.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Re.additionalTextEdits=Se.additionalTextEdits.map(Ve=>ve.to(Ve))),Re.command=ee&&Se.command?ee.fromInternal(Se.command):void 0,Re}Oe.to=Fe})(X||(e.CompletionItem=X={}));var K;(function(Oe){function Fe(ee){if(typeof ee.label!="string"&&!Array.isArray(ee.label))throw new TypeError("Invalid label");return{label:ee.label,documentation:W.fromStrict(ee.documentation)}}Oe.from=Fe;function Se(ee){return{label:ee.label,documentation:R.isMarkdownString(ee.documentation)?W.to(ee.documentation):ee.documentation}}Oe.to=Se})(K||(e.ParameterInformation=K={}));var ge;(function(Oe){function Fe(ee){return{label:ee.label,documentation:W.fromStrict(ee.documentation),parameters:Array.isArray(ee.parameters)?ee.parameters.map(K.from):[],activeParameter:ee.activeParameter}}Oe.from=Fe;function Se(ee){return{label:ee.label,documentation:R.isMarkdownString(ee.documentation)?W.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(K.to):[],activeParameter:ee.activeParameter}}Oe.to=Se})(ge||(e.SignatureInformation=ge={}));var Ee;(function(Oe){function Fe(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(ge.from):[]}}Oe.from=Fe;function Se(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(ge.to):[]}}Oe.to=Se})(Ee||(e.SignatureHelp=Ee={}));var ze;(function(Oe){function Fe(Se,ee){const Re=new d.InlayHint(y.to(ee.position),typeof ee.label=="string"?ee.label:ee.label.map(He.to.bind(void 0,Se)),ee.kind&&Ye.to(ee.kind));return Re.textEdits=ee.textEdits&&ee.textEdits.map(ve.to),Re.tooltip=R.isMarkdownString(ee.tooltip)?W.to(ee.tooltip):ee.tooltip,Re.paddingLeft=ee.paddingLeft,Re.paddingRight=ee.paddingRight,Re}Oe.to=Fe})(ze||(e.InlayHint=ze={}));var He;(function(Oe){function Fe(Se,ee){const Re=new d.InlayHintLabelPart(ee.label);return Re.tooltip=R.isMarkdownString(ee.tooltip)?W.to(ee.tooltip):ee.tooltip,o.Command.is(ee.command)&&(Re.command=Se.fromInternal(ee.command)),ee.location&&(Re.location=se.to(ee.location)),Re}Oe.to=Fe})(He||(e.InlayHintLabelPart=He={}));var Ye;(function(Oe){function Fe(ee){return ee}Oe.from=Fe;function Se(ee){return ee}Oe.to=Se})(Ye||(e.InlayHintKind=Ye={}));var it;(function(Oe){function Fe(ee){return{range:D.from(ee.range),url:ee.target,tooltip:ee.tooltip}}Oe.from=Fe;function Se(ee){let Re;if(ee.url)try{Re=typeof ee.url=="string"?a.URI.parse(ee.url,!0):a.URI.revive(ee.url)}catch{}return new d.DocumentLink(D.to(ee.range),Re)}Oe.to=Se})(it||(e.DocumentLink=it={}));var rt;(function(Oe){function Fe(ee){const Re=new d.ColorPresentation(ee.label);return ee.textEdit&&(Re.textEdit=ve.to(ee.textEdit)),ee.additionalTextEdits&&(Re.additionalTextEdits=ee.additionalTextEdits.map(Ve=>ve.to(Ve))),Re}Oe.to=Fe;function Se(ee){return{label:ee.label,textEdit:ee.textEdit?ve.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Re=>ve.from(Re)):void 0}}Oe.from=Se})(rt||(e.ColorPresentation=rt={}));var at;(function(Oe){function Fe(ee){return new d.Color(ee[0],ee[1],ee[2],ee[3])}Oe.to=Fe;function Se(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}Oe.from=Se})(at||(e.Color=at={}));var st;(function(Oe){function Fe(ee){return{range:D.from(ee.range)}}Oe.from=Fe;function Se(ee){return new d.SelectionRange(D.to(ee.range))}Oe.to=Se})(st||(e.SelectionRange=st={}));var De;(function(Oe){function Fe(Se){switch(Se){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}Oe.to=Fe})(De||(e.TextDocumentSaveReason=De={}));var Be;(function(Oe){function Fe(ee){switch(ee){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.Interval:return 3;case d.TextEditorLineNumbersStyle.On:default:return 1}}Oe.from=Fe;function Se(ee){switch(ee){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 3:return d.TextEditorLineNumbersStyle.Interval;case 1:default:return d.TextEditorLineNumbersStyle.On}}Oe.to=Se})(Be||(e.TextEditorLineNumbersStyle=Be={}));var qe;(function(Oe){function Fe(ee){if(ee===d.EndOfLine.CRLF)return 1;if(ee===d.EndOfLine.LF)return 0}Oe.from=Fe;function Se(ee){if(ee===1)return d.EndOfLine.CRLF;if(ee===0)return d.EndOfLine.LF}Oe.to=Se})(qe||(e.EndOfLine=qe={}));var Le;(function(Oe){function Fe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Oe.from=Fe})(Le||(e.ProgressLocation=Le={}));var Qe;(function(Oe){function Fe(ee){const Re={start:ee.start+1,end:ee.end+1};return ee.kind&&(Re.kind=oe.from(ee.kind)),Re}Oe.from=Fe;function Se(ee){const Re={start:ee.start-1,end:ee.end-1};return ee.kind&&(Re.kind=oe.to(ee.kind)),Re}Oe.to=Se})(Qe||(e.FoldingRange=Qe={}));var oe;(function(Oe){function Fe(ee){if(ee)switch(ee){case d.FoldingRangeKind.Comment:return o.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return o.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return o.FoldingRangeKind.Region}}Oe.from=Fe;function Se(ee){if(ee)switch(ee.value){case o.FoldingRangeKind.Comment.value:return d.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports.value:return d.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region.value:return d.FoldingRangeKind.Region}}Oe.to=Se})(oe||(e.FoldingRangeKind=oe={}));var le;(function(Oe){function Fe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?D.from(Se.selection):void 0,override:typeof Se.override=="boolean"?r.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Oe.from=Fe})(le||(e.TextEditorOpenOptions=le={}));var ke;(function(Oe){function Fe(Ve){return Ve instanceof d.RelativePattern?Ve.toJSON():typeof Ve=="string"?Ve:Se(Ve)||ee(Ve)?new d.RelativePattern(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Oe.from=Fe;function Se(Ve){const et=Ve;return et?a.URI.isUri(et.baseUri)&&typeof et.pattern=="string":!1}function ee(Ve){const et=Ve;return et?typeof et.base=="string"&&typeof et.pattern=="string":!1}function Re(Ve){return typeof Ve=="string"?Ve:new d.RelativePattern(a.URI.revive(Ve.baseUri),Ve.pattern)}Oe.to=Re})(ke||(e.GlobPattern=ke={}));var je;(function(Oe){function Fe(Se){if(Se){if(Array.isArray(Se))return Se.map(Fe);if(typeof Se=="string")return Se;{const ee=Se;return{language:ee.language,scheme:ee.scheme,pattern:ke.from(ee.pattern),exclusive:ee.exclusive,notebookType:ee.notebookType}}}else return}Oe.from=Fe})(je||(e.LanguageSelector=je={}));var Ze;(function(Oe){function Fe(ee){return!!ee&&typeof ee=="object"&&"documents"in ee&&Array.isArray(ee.documents)&&ee.documents.every(Re=>Array.isArray(Re)&&Re.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&a.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(et=>et instanceof d.Range)))}Oe.is=Fe;function Se(ee){return{documents:ee.documents.map(Re=>Re.map(Ve=>({uri:a.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(et=>D.from(et))})))}}Oe.from=Se})(Ze||(e.MappedEditsContext=Ze={}));var Me;(function(Oe){function Fe(ee){return{start:ee.start,end:ee.end}}Oe.from=Fe;function Se(ee){return new d.NotebookRange(ee.start,ee.end)}Oe.to=Se})(Me||(e.NotebookRange=Me={}));var lt;(function(Oe){function Fe(ee){return{timing:typeof ee.runStartTime=="number"&&typeof ee.runEndTime=="number"?{startTime:ee.runStartTime,endTime:ee.runEndTime}:void 0,executionOrder:ee.executionOrder,success:ee.lastRunSuccess}}Oe.to=Fe;function Se(ee){return{lastRunSuccess:ee.success,runStartTime:ee.timing?.startTime,runEndTime:ee.timing?.endTime,executionOrder:ee.executionOrder}}Oe.from=Se})(lt||(e.NotebookCellExecutionSummary=lt={}));var bt;(function(Oe){function Fe(Se){if(Se===t.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;if(Se===t.NotebookCellExecutionState.Pending)return;if(Se===t.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Oe.to=Fe})(bt||(e.NotebookCellExecutionState=bt={}));var Tt;(function(Oe){function Fe(ee){switch(ee){case d.NotebookCellKind.Markup:return t.CellKind.Markup;case d.NotebookCellKind.Code:default:return t.CellKind.Code}}Oe.from=Fe;function Se(ee){switch(ee){case t.CellKind.Markup:return d.NotebookCellKind.Markup;case t.CellKind.Code:default:return d.NotebookCellKind.Code}}Oe.to=Se})(Tt||(e.NotebookCellKind=Tt={}));var Nt;(function(Oe){function Fe(ee){const Re={metadata:ee.metadata??Object.create(null),cells:[]};for(const Ve of ee.cells)d.NotebookCellData.validate(Ve),Re.cells.push(Xt.from(Ve));return Re}Oe.from=Fe;function Se(ee){const Re=new d.NotebookData(ee.cells.map(Xt.to));return(0,S.isEmptyObject)(ee.metadata)||(Re.metadata=ee.metadata),Re}Oe.to=Se})(Nt||(e.NotebookData=Nt={}));var Xt;(function(Oe){function Fe(ee){return{cellKind:Tt.from(ee.kind),language:ee.languageId,mime:ee.mime,source:ee.value,metadata:ee.metadata,internalMetadata:lt.from(ee.executionSummary??{}),outputs:ee.outputs?ee.outputs.map(It.from):[]}}Oe.from=Fe;function Se(ee){return new d.NotebookCellData(Tt.to(ee.cellKind),ee.source,ee.language,ee.mime,ee.outputs?ee.outputs.map(It.to):void 0,ee.metadata,ee.internalMetadata?lt.to(ee.internalMetadata):void 0)}Oe.to=Se})(Xt||(e.NotebookCellData=Xt={}));var ei;(function(Oe){function Fe(ee){return{mime:ee.mime,valueBytes:O.VSBuffer.wrap(ee.data)}}Oe.from=Fe;function Se(ee){return new d.NotebookCellOutputItem(ee.valueBytes.buffer,ee.mime)}Oe.to=Se})(ei||(e.NotebookCellOutputItem=ei={}));var It;(function(Oe){function Fe(ee){return{outputId:ee.id,items:ee.items.map(ei.from),metadata:ee.metadata}}Oe.from=Fe;function Se(ee){const Re=ee.items.map(ei.to);return new d.NotebookCellOutput(Re,ee.outputId,ee.metadata)}Oe.to=Se})(It||(e.NotebookCellOutput=It={}));var Qt;(function(Oe){function Fe(Re){return ee(Re)?{include:ke.from(Re.include)??void 0,exclude:ke.from(Re.exclude)??void 0}:ke.from(Re)??void 0}Oe.from=Fe;function Se(Re){return ee(Re)?{include:ke.to(Re.include),exclude:ke.to(Re.exclude)}:ke.to(Re)}Oe.to=Se;function ee(Re){const Ve=Re;return Ve?!(0,S.isUndefinedOrNull)(Ve.include)&&!(0,S.isUndefinedOrNull)(Ve.exclude):!1}})(Qt||(e.NotebookExclusiveDocumentPattern=Qt={}));var Vt;(function(Oe){function Fe(Se,ee,Re){const Ve=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:ee.toInternal(Ve,Re),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Oe.from=Fe})(Vt||(e.NotebookStatusBarItem=Vt={}));var ci;(function(Oe){function Fe(Se,ee,Re){const Ve=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:ee.toInternal(Ve,Re),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Oe.from=Fe})(ci||(e.NotebookKernelSourceAction=ci={}));var tt;(function(Oe){function Fe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Oe.from=Fe})(tt||(e.NotebookDocumentContentOptions=tt={}));var ti;(function(Oe){function Fe(ee){return{uri:ee.uri,provides:ee.provides}}Oe.from=Fe;function Se(ee){return new d.NotebookRendererScript(a.URI.revive(ee.uri),ee.provides)}Oe.to=Se})(ti||(e.NotebookRendererScript=ti={}));var ii;(function(Oe){function Fe(ee){return{message:W.fromStrict(ee.message)||"",type:0,expected:ee.expectedOutput,actual:ee.actualOutput,contextValue:ee.contextValue,location:ee.location&&{range:D.from(ee.location.range),uri:ee.location.uri}}}Oe.from=Fe;function Se(ee){const Re=new d.TestMessage(typeof ee.message=="string"?ee.message:W.to(ee.message));return Re.actualOutput=ee.actual,Re.expectedOutput=ee.expected,Re.contextValue=ee.contextValue,Re.location=ee.location?se.to(ee.location):void 0,Re}Oe.to=Se})(ii||(e.TestMessage=ii={}));var qt;(function(Oe){Oe.namespace=h.namespaceTestTag,Oe.denamespace=h.denamespaceTestTag})(qt||(e.TestTag=qt={}));var ht;(function(Oe){function Fe(ee){const Re=(0,i.getPrivateApiFor)(ee).controllerId;return{extId:f.TestId.fromExtHostTestItem(ee,Re).toString(),label:ee.label,uri:a.URI.revive(ee.uri),busy:ee.busy,tags:ee.tags.map(Ve=>qt.namespace(Re,Ve.id)),range:m.Range.lift(D.from(ee.range)),description:ee.description||null,sortText:ee.sortText||null,error:ee.error&&W.fromStrict(ee.error)||null}}Oe.from=Fe;function Se(ee){return{parent:void 0,error:void 0,id:f.TestId.fromString(ee.extId).localId,label:ee.label,uri:a.URI.revive(ee.uri),tags:(ee.tags||[]).map(Re=>{const{tagId:Ve}=qt.denamespace(Re);return new d.TestTag(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:D.to(ee.range||void 0),canResolveChildren:!1,busy:ee.busy,description:ee.description||void 0,sortText:ee.sortText||void 0}}Oe.toPlain=Se})(ht||(e.TestItem=ht={})),function(Oe){function Fe(ee){return{id:ee.id}}Oe.from=Fe;function Se(ee){return new d.TestTag(ee.id)}Oe.to=Se}(qt||(e.TestTag=qt={}));var Et;(function(Oe){const Fe=(ee,Re)=>{const Ve=ee.value;if(!Ve)return;const et={...ht.toPlain(Ve.item),parent:Re,taskStates:Ve.tasks.map(Xe=>({state:Xe.state,duration:Xe.duration,messages:Xe.messages.filter(ut=>ut.type===0).map(ii.to)})),children:[]};if(ee.children)for(const Xe of ee.children.values()){const ut=Fe(Xe,et);ut&&et.children.push(ut)}return et};function Se(ee){const Re=new v.WellDefinedPrefixTree;for(const Xe of ee.items)Re.insert(f.TestId.fromString(Xe.item.extId).path,Xe);const Ve=[Re.nodes],et=[];for(;Ve.length;)for(const Xe of Ve.pop())Xe.value?et.push(Xe):Xe.children&&Ve.push(Xe.children.values());return{completedAt:ee.completedAt,results:et.map(Xe=>Fe(Xe)).filter(S.isDefined)}}Oe.to=Se})(Et||(e.TestResults=Et={}));var ai;(function(Oe){function Fe(Ve){return{covered:Ve.covered,total:Ve.total}}function Se(Ve){return"line"in Ve?y.from(Ve):D.from(Ve)}function ee(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:Se(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(et=>({count:et.executed,location:et.location&&Se(et.location),label:et.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:Se(Ve.location)}}Oe.fromDetails=ee;function Re(Ve,et){return d.validateTestCoverageCount(et.statementCoverage),d.validateTestCoverageCount(et.branchCoverage),d.validateTestCoverageCount(et.declarationCoverage),{id:Ve,uri:et.uri,statement:Fe(et.statementCoverage),branch:et.branchCoverage&&Fe(et.branchCoverage),declaration:et.declarationCoverage&&Fe(et.declarationCoverage)}}Oe.fromFile=Re})(ai||(e.TestCoverage=ai={}));var jt;(function(Oe){function Fe(Se){switch(Se){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}Oe.to=Fe})(jt||(e.CodeActionTriggerKind=jt={}));var Ut;(function(Oe){function Fe(ee){const Re=new d.TypeHierarchyItem(J.to(ee.kind),ee.name,ee.detail||"",a.URI.revive(ee.uri),D.to(ee.range),D.to(ee.selectionRange));return Re._sessionId=ee._sessionId,Re._itemId=ee._itemId,Re}Oe.to=Fe;function Se(ee,Re,Ve){if(Re=Re??ee._sessionId,Ve=Ve??ee._itemId,Re===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Ve,kind:J.from(ee.kind),name:ee.name,detail:ee.detail??"",uri:ee.uri,range:D.from(ee.range),selectionRange:D.from(ee.selectionRange),tags:ee.tags?.map($.from)}}Oe.from=Se})(Ut||(e.TypeHierarchyItem=Ut={}));var gt;(function(Oe){function Fe(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Oe.from=Fe})(gt||(e.ViewBadge=gt={}));var Pt;(function(Oe){function Fe(Ve,et,Xe){const ut=et.fileData;return ut?new d.InternalFileDataTransferItem(new d.DataTransferFile(ut.name,a.URI.revive(ut.uri),ut.id,(0,T.createSingleCallFunction)(()=>Xe(ut.id)))):Ve===A.Mimes.uriList&&et.uriListData?new d.InternalDataTransferItem(Re(et.uriListData)):new d.InternalDataTransferItem(et.asString)}Oe.to=Fe;async function Se(Ve,et){const Xe=await et.asString();if(Ve===A.Mimes.uriList)return{asString:Xe,fileData:void 0,uriListData:ee(Xe)};const ut=et.asFile();return{asString:Xe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}Oe.from=Se;function ee(Ve){return L.UriList.split(Ve).map(et=>{if(et.startsWith("#"))return et;try{return a.URI.parse(et)}catch{}return et})}function Re(Ve){return L.UriList.create(Ve.map(et=>typeof et=="string"?et:a.URI.revive(et)))}})(Pt||(e.DataTransferItem=Pt={}));var li;(function(Oe){function Fe(ee,Re){const Ve=ee.items.map(([et,Xe])=>[et,Pt.to(et,Xe,Re)]);return new d.DataTransfer(Ve)}Oe.toDataTransfer=Fe;async function Se(ee){const Re={items:[]},Ve=[];for(const[et,Xe]of ee)Ve.push((async()=>{Re.items.push([et,await Pt.from(et,Xe)])})());return await Promise.all(Ve),Re}Oe.from=Se})(li||(e.DataTransfer=li={}));var Yt;(function(Oe){function Fe(ee,Re){return{kind:"reply",agentId:ee.participant??Re?.agentId??"",subCommand:ee.command??Re?.command,message:ee.prompt,title:ee.label}}Oe.from=Fe;function Se(ee){return{prompt:ee.message,label:ee.title,participant:ee.agentId,command:ee.subCommand}}Oe.to=Se})(Yt||(e.ChatFollowup=Yt={}));var Ke;(function(Oe){function Fe(Se){return"commandId"in Se?{kind:"command",title:Se.title??"",commandId:Se.commandId??"",when:Se.when??"",args:Se.args}:{kind:"reply",message:Se.message,title:Se.title,tooltip:Se.tooltip}}Oe.from=Fe})(Ke||(e.ChatInlineFollowup=Ke={}));var Mt;(function(Oe){function Fe(ee){switch(ee.role){case 0:return new d.LanguageModelChatSystemMessage(ee.content);case 1:return new d.LanguageModelChatUserMessage(ee.content);case 2:return new d.LanguageModelChatAssistantMessage(ee.content)}}Oe.to=Fe;function Se(ee){if(ee instanceof d.LanguageModelChatSystemMessage)return{role:0,content:ee.content};if(ee instanceof d.LanguageModelChatUserMessage)return{role:1,content:ee.content};if(ee instanceof d.LanguageModelChatAssistantMessage)return{role:2,content:ee.content};throw new Error("Invalid LanguageModelMessage")}Oe.from=Se})(Mt||(e.LanguageModelMessage=Mt={}));var Ht;(function(Oe){function Fe(Re){const Ve={};for(const et of Object.keys(Re))Ve[et]=Re[et].map(Oe.to);return Ve}Oe.objectTo=Fe;function Se(Re){return{level:ni.to(Re.level),kind:Re.kind,value:(0,a.isUriComponents)(Re.value)?a.URI.revive(Re.value):Re.value,description:Re.description}}Oe.to=Se;function ee(Re){return{level:ni.from(Re.level),kind:Re.kind,value:Re.value,description:Re.description}}Oe.from=ee})(Ht||(e.ChatVariable=Ht={}));var ni;(function(Oe){function Fe(ee){switch(ee){case"short":return d.ChatVariableLevel.Short;case"medium":return d.ChatVariableLevel.Medium;case"full":default:return d.ChatVariableLevel.Full}}Oe.to=Fe;function Se(ee){switch(ee){case d.ChatVariableLevel.Short:return"short";case d.ChatVariableLevel.Medium:return"medium";case d.ChatVariableLevel.Full:default:return"full"}}Oe.from=Se})(ni||(e.ChatVariableLevel=ni={}));var pt;(function(Oe){function Fe(Se){switch(Se){case 1:return d.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return d.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return d.InteractiveEditorResponseFeedbackKind.Undone;case 3:return d.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return d.InteractiveEditorResponseFeedbackKind.Bug}}Oe.to=Fe})(pt||(e.InteractiveEditorResponseFeedbackKind=pt={}));var Ot;(function(Oe){function Fe(ee){return{kind:"markdownContent",content:W.from(ee.value)}}Oe.to=Fe;function Se(ee){return new d.ChatResponseMarkdownPart(W.to(ee.content))}Oe.from=Se})(Ot||(e.ChatResponseMarkdownPart=Ot={}));var At;(function(Oe){function Fe(ee){const{value:Re,baseUri:Ve}=ee;function et(Xe,ut){return Xe.map(yt=>{const _t=a.URI.joinPath(ut,yt.name);return{label:yt.name,uri:_t,children:yt.children&&et(yt.children,_t)}})}return{kind:"treeData",treeData:{label:(0,C.basename)(Ve),uri:Ve,children:et(Re,Ve)}}}Oe.to=Fe;function Se(ee){const Re=(0,w.revive)(ee.treeData);function Ve(ut){return ut.map(yt=>({name:yt.label,children:yt.children&&Ve(yt.children)}))}const et=Re.uri,Xe=Re.children?Ve(Re.children):[];return new d.ChatResponseFileTreePart(Xe,et)}Oe.from=Se})(At||(e.ChatResponseFilesPart=At={}));var Ft;(function(Oe){function Fe(ee){return{kind:"inlineReference",name:ee.title,inlineReference:a.URI.isUri(ee.value)?ee.value:E.from(ee.value)}}Oe.to=Fe;function Se(ee){const Re=(0,w.revive)(ee);return new d.ChatResponseAnchorPart(a.URI.isUri(Re.inlineReference)?Re.inlineReference:E.to(Re.inlineReference),ee.name)}Oe.from=Se})(Ft||(e.ChatResponseAnchorPart=Ft={}));var ui;(function(Oe){function Fe(ee){return{kind:"progressMessage",content:W.from(ee.value)}}Oe.to=Fe;function Se(ee){return new d.ChatResponseProgressPart(ee.content.value)}Oe.from=Se})(ui||(e.ChatResponseProgressPart=ui={}));var xt;(function(Oe){function Fe(ee,Re,Ve){return{kind:"command",command:Re.toInternal(ee.value,Ve)??{command:ee.value.command,title:ee.value.title}}}Oe.to=Fe;function Se(ee,Re){return new d.ChatResponseCommandButtonPart(Re.fromInternal(ee.command)??{command:ee.command.id,title:ee.command.title})}Oe.from=Se})(xt||(e.ChatResponseCommandButtonPart=xt={}));var zt;(function(Oe){function Fe(ee){return"variableName"in ee.value?{kind:"reference",reference:{variableName:ee.value.variableName,value:a.URI.isUri(ee.value.value)||!ee.value.value?ee.value.value:E.from(ee.value.value)}}:{kind:"reference",reference:a.URI.isUri(ee.value)?ee.value:E.from(ee.value)}}Oe.to=Fe;function Se(ee){const Re=(0,w.revive)(ee),Ve=et=>a.URI.isUri(et)?et:E.to(et);return new d.ChatResponseReferencePart("variableName"in Re.reference?{variableName:Re.reference.variableName,value:Re.reference.value&&Ve(Re.reference.value)}:Ve(Re.reference))}Oe.from=Se})(zt||(e.ChatResponseReferencePart=zt={}));var Ct;(function(Oe){function Fe(Re,Ve,et){return Re instanceof d.ChatResponseMarkdownPart?Ot.to(Re):Re instanceof d.ChatResponseAnchorPart?Ft.to(Re):Re instanceof d.ChatResponseReferencePart?zt.to(Re):Re instanceof d.ChatResponseProgressPart?ui.to(Re):Re instanceof d.ChatResponseFileTreePart?At.to(Re):Re instanceof d.ChatResponseCommandButtonPart?xt.to(Re,Ve,et):{kind:"content",content:""}}Oe.to=Fe;function Se(Re,Ve){switch(Re.kind){case"reference":return zt.from(Re);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ee(Re,Ve)}}Oe.from=Se;function ee(Re,Ve){switch(Re.kind){case"markdownContent":return Ot.from(Re);case"inlineReference":return Ft.from(Re);case"progressMessage":return;case"treeData":return At.from(Re);case"command":return xt.from(Re,Ve)}}Oe.fromContent=ee})(Ct||(e.ChatResponsePart=Ct={}));var Lt;(function(Oe){function Fe(ee,Re){return"markdownContent"in Re?((0,u.checkProposedApiEnabled)(ee,"chatParticipantAdditions"),{content:W.from(Re.markdownContent),kind:"markdownContent"}):"content"in Re?"vulnerabilities"in Re&&Re.vulnerabilities?((0,u.checkProposedApiEnabled)(ee,"chatParticipantAdditions"),{content:Re.content,vulnerabilities:Re.vulnerabilities,kind:"vulnerability"}):typeof Re.content=="string"?{content:Re.content,kind:"content"}:((0,u.checkProposedApiEnabled)(ee,"chatParticipantAdditions"),{content:W.from(Re.content),kind:"markdownContent"}):"documents"in Re?{documents:Re.documents.map(Ve=>({uri:Ve.uri,version:Ve.version,ranges:Ve.ranges.map(et=>D.from(et))})),kind:"usedContext"}:"reference"in Re?{reference:"uri"in Re.reference?{uri:Re.reference.uri,range:D.from(Re.reference.range)}:Re.reference,kind:"reference"}:"inlineReference"in Re?{inlineReference:"uri"in Re.inlineReference?{uri:Re.inlineReference.uri,range:D.from(Re.inlineReference.range)}:Re.inlineReference,name:Re.title,kind:"inlineReference"}:"participant"in Re?((0,u.checkProposedApiEnabled)(ee,"chatParticipantAdditions"),{agentId:Re.participant,command:Re.command,kind:"agentDetection"}):"message"in Re?{content:W.from(Re.message),kind:"progressMessage"}:void 0}Oe.from=Fe;function Se(ee,Re){switch(ee.kind){case"markdownContent":return{content:ee.content.value};case"inlineReference":return{inlineReference:(0,a.isUriComponents)(ee.inlineReference)?a.URI.revive(ee.inlineReference):E.to(ee.inlineReference),title:ee.name};case"command":return{command:Re.fromInternal(ee.command)??{command:ee.command.id,title:ee.command.title}};default:return}}Oe.toProgressContent=Se})(Lt||(e.ChatResponseProgress=Lt={}));var ri;(function(Oe){function Fe(Se){return{prompt:Se.message,command:Se.command,variables:Se.variables.variables.map(St.to),location:Bt.to(Se.location)}}Oe.to=Fe})(ri||(e.ChatAgentRequest=ri={}));var Bt;(function(Oe){function Fe(Se){switch(Se){case s.ChatAgentLocation.Notebook:return d.ChatLocation.Notebook;case s.ChatAgentLocation.Terminal:return d.ChatLocation.Terminal;case s.ChatAgentLocation.Panel:return d.ChatLocation.Panel;case s.ChatAgentLocation.Editor:return d.ChatLocation.Editor}}Oe.to=Fe})(Bt||(e.ChatLocation=Bt={}));var St;(function(Oe){function Fe(Se){return{name:Se.name,range:Se.range&&[Se.range.start,Se.range.endExclusive],values:Se.values.map(Ht.to)}}Oe.to=Fe})(St||(e.ChatAgentResolvedVariable=St={}));var kt;(function(Oe){function Fe(Se){return{label:Se.label,values:Se.values.map(Ht.from),insertText:Se.insertText,detail:Se.detail,documentation:Se.documentation}}Oe.from=Fe})(kt||(e.ChatAgentCompletionItem=kt={}));var fi;(function(Oe){function Fe(Se){return{errorDetails:Se.errorDetails,metadata:Se.metadata}}Oe.to=Fe})(fi||(e.ChatAgentResult=fi={}));var Dt;(function(Oe){function Fe(Se,ee,Re){if(ee.action.kind==="vote")return;const Ve=fi.to(Se);return ee.action.kind==="command"?{action:{kind:"command",commandButton:Lt.toProgressContent(ee.action.commandButton,Re)},result:Ve}:ee.action.kind==="followUp"?{action:{kind:"followUp",followup:Yt.to(ee.action.followup)},result:Ve}:{action:ee.action,result:Ve}}Oe.to=Fe})(Dt||(e.ChatAgentUserActionEvent=Dt={}));var si;(function(Oe){function Fe(Se,ee,Re){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand,shouldExecute:Se.shouldExecute}:"uri"in Se?{uri:Se.uri}:ee.toInternal(Se,Re)}Oe.from=Fe})(si||(e.TerminalQuickFix=si={}));var Jt;(function(Oe){function Fe(Se){return{kind:oi.to(Se.kind)}}Oe.to=Fe})(Jt||(e.PartialAcceptInfo=Jt={}));var oi;(function(Oe){function Fe(Se){switch(Se){case 0:return d.PartialAcceptTriggerKind.Word;case 1:return d.PartialAcceptTriggerKind.Line;case 2:return d.PartialAcceptTriggerKind.Suggest;default:return d.PartialAcceptTriggerKind.Unknown}}Oe.to=Fe})(oi||(e.PartialAcceptTriggerKind=oi={}));var gi;(function(Oe){function Fe(Se,ee){return{id:ee,label:Se.label,description:Se.description,canEdit:Se.canEdit,collapsibleState:Se.collapsibleState||0,contextValue:Se.contextValue}}Oe.from=Fe})(gi||(e.DebugTreeItem=gi={}))}),define(ye[328],_e([1,0,6,20,16]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(b,p){this._proxy=b.getProxy(c.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:w=>p.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,p,w){const A=L.WorkspaceEdit.from(b,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(A,void 0,w?.isRefactoring??!1)}};e.ExtHostBulkEdits=T,e.ExtHostBulkEdits=T=Ge([Ue(0,O.IExtHostRpcService)],T)}),define(ye[329],_e([1,0,19,8,47,4,38,3,39,18,2,218,25,6,16,7,290,26]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0;class n{constructor(t,f,h,l,u,d){this._extension=t,this._request=f,this._proxy=h,this._logService=l,this._commandsConverter=u,this._sessionDisposables=d,this._stopWatch=p.StopWatch.create(!1),this._isClosed=!1}close(){this._isClosed=!0}get timings(){return{firstProgress:this._firstProgress,totalElapsed:this._stopWatch.elapsed()}}get apiObject(){if(!this._apiObject){let f=function(l){if(t._isClosed){const u=new Error("Response stream has been closed");throw Error.captureStackTrace(u,l),u}};const t=this;this._stopWatch.reset();const h=l=>{typeof this._firstProgress>"u"&&"content"in l&&(this._firstProgress=this._stopWatch.elapsed()),this._proxy.$handleProgressChunk(this._request.requestId,l)};this._apiObject={markdown(l){f(this.markdown);const u=new a.ChatResponseMarkdownPart(l),d=S.ChatResponseMarkdownPart.to(u);return h(d),this},filetree(l,u){f(this.filetree);const d=new a.ChatResponseFileTreePart(l,u),g=S.ChatResponseFilesPart.to(d);return h(g),this},anchor(l,u){f(this.anchor);const d=new a.ChatResponseAnchorPart(l,u),g=S.ChatResponseAnchorPart.to(d);return h(g),this},button(l){f(this.anchor);const u=new a.ChatResponseCommandButtonPart(l),d=S.ChatResponseCommandButtonPart.to(u,t._commandsConverter,t._sessionDisposables);return h(d),this},progress(l){f(this.progress);const u=new a.ChatResponseProgressPart(l),d=S.ChatResponseProgressPart.to(u);return h(d),this},reference(l){if(f(this.reference),"variableName"in l&&!l.value){const u=t._request.variables.variables.find(d=>d.name===l.variableName);if(u){let d;if(u.references?.length)d=u.references.map(g=>({kind:"reference",reference:{variableName:l.variableName,value:g.reference}}));else{const g=new a.ChatResponseReferencePart(l);d=[S.ChatResponseReferencePart.to(g)]}return d.forEach(g=>h(g)),this}}else{const u=new a.ChatResponseReferencePart(l),d=S.ChatResponseReferencePart.to(u);h(d)}return this},push(l){if(f(this.push),l instanceof a.ChatResponseReferencePart)this.reference(l.value);else{const u=S.ChatResponsePart.to(l,t._commandsConverter,t._sessionDisposables);h(u)}return this},report(l){if(f(this.report),"placeholder"in l&&"resolvedContent"in l)return;const u=S.ChatResponseProgress.from(t._extension,l);if(!u){t._logService.error("Unknown progress type: "+JSON.stringify(l));return}return h(u),this}}}return this._apiObject}}class i{static{this._idPool=0}constructor(t,f,h){this._logService=f,this.commands=h,this._agents=new Map,this._sessionDisposables=new b.DisposableMap,this._proxy=t.getProxy(C.MainContext.MainThreadChatAgents2)}createChatAgent(t,f,h){const l=i._idPool++,u=new r(t,f,this._proxy,l,h);return this._agents.set(l,u),this._proxy.$registerAgent(l,t.identifier,f,{},void 0),u.apiAgent}createDynamicChatAgent(t,f,h,l,u){const d=i._idPool++,g=new r(t,f,this._proxy,d,u);return this._agents.set(d,g),this._proxy.$registerAgent(d,t.identifier,f,{},{name:h,description:l}),g.apiAgent}async $invokeAgent(t,f,h,l){const u=this._agents.get(t);if(!u)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let d=this._sessionDisposables.get(f.sessionId);d||(d=new b.DisposableStore,this._sessionDisposables.set(f.sessionId,d));const g=new n(u.extension,f,this._proxy,this._logService,this.commands.converter,d);try{const D=await this.prepareHistoryTurns(f.agentId,h),E=u.invoke(S.ChatAgentRequest.to(f),{history:D},g.apiObject,l);return await(0,O.raceCancellation)(Promise.resolve(E).then(_=>{if(_?.metadata)try{JSON.stringify(_.metadata)}catch(y){const P=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this._logService.error(`[${u.extension.identifier.value}] [@${u.id}] ${P}`,u.extension),{errorDetails:{message:P},timings:g.timings}}return{errorDetails:_?.errorDetails,timings:g.timings,metadata:_?.metadata}}),l)}catch(D){return this._logService.error(D,u.extension),{errorDetails:{message:(0,I.localize)(0,null,(0,L.toErrorMessage)(D)),responseIsIncomplete:!0}}}finally{g.close()}}async prepareHistoryTurns(t,f){const h=[];for(const l of f.history){const u=S.ChatAgentResult.to(l.result),d=t===l.request.agentId?u:{...u,metadata:void 0};h.push(new a.ChatRequestTurn(l.request.message,l.request.command,l.request.variables.variables.map(S.ChatAgentResolvedVariable.to),l.request.agentId));const g=(0,c.coalesce)(l.response.map(D=>S.ChatResponsePart.fromContent(D,this.commands.converter)));h.push(new a.ChatResponseTurn(g,d,l.request.agentId,l.request.command))}return h}$releaseSession(t){this._sessionDisposables.deleteAndDispose(t)}async $provideFollowups(t,f,h,l,u){const d=this._agents.get(f);if(!d)return Promise.resolve([]);const g=await this.prepareHistoryTurns(d.id,l),D=S.ChatAgentResult.to(h);return(await d.provideFollowups(D,{history:g},u)).filter(E=>{const _=!E.participant||R.Iterable.some(this._agents.values(),y=>y.id===E.participant&&v.ExtensionIdentifier.equals(y.extension.identifier,d.extension.identifier));return _||this._logService.warn(`[@${d.id}] ChatFollowup refers to an unknown participant: ${E.participant}`),_}).map(E=>S.ChatFollowup.from(E,t))}$acceptFeedback(t,f,h,l){const u=this._agents.get(t);if(!u)return;const d=S.ChatAgentResult.to(f);let g;switch(h){case m.InteractiveSessionVoteDirection.Down:g=a.ChatResultFeedbackKind.Unhelpful;break;case m.InteractiveSessionVoteDirection.Up:g=a.ChatResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(l?{result:d,kind:g,reportIssue:l}:{result:d,kind:g}))}$acceptAction(t,f,h){const l=this._agents.get(t);if(!l||h.action.kind==="vote")return;const u=S.ChatAgentUserActionEvent.to(f,h,this.commands.converter);u&&l.acceptAction(Object.freeze(u))}async $invokeCompletionProvider(t,f,h){const l=this._agents.get(t);return l?(await l.invokeCompletionProvider(f,h)).map(S.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,f){const h=this._agents.get(t);if(h)return await h.provideWelcomeMessage(f)}async $provideSampleQuestions(t,f){const h=this._agents.get(t);if(h)return(await h.provideSampleQuestions(f)).map(l=>S.ChatFollowup.from(l,void 0))}}e.ExtHostChatAgents2=i;class r{constructor(t,f,h,l,u){this.extension=t,this.id=f,this._proxy=h,this._handle=l,this._requestHandler=u,this._onDidReceiveFeedback=new T.Emitter,this._onDidPerformAction=new T.Emitter}acceptFeedback(t){this._onDidReceiveFeedback.fire(t)}acceptAction(t){this._onDidPerformAction.fire(t)}async invokeCompletionProvider(t,f){return this._agentVariableProvider?await this._agentVariableProvider.provider.provideCompletionItems(t,f)??[]:[]}async provideFollowups(t,f,h){if(!this._followupProvider)return[];const l=await this._followupProvider.provideFollowups(t,f,h);return l?l.filter(u=>!(u&&"commandId"in u)).filter(u=>!(u&&"message"in u)):[]}async provideWelcomeMessage(t){if(!this._welcomeMessageProvider)return[];const f=await this._welcomeMessageProvider.provideWelcomeMessage(t);return f?f.map(h=>typeof h=="string"?h:S.MarkdownString.from(h)):[]}async provideSampleQuestions(t){if(!this._welcomeMessageProvider||!this._welcomeMessageProvider.provideSampleQuestions)return[];const f=await this._welcomeMessageProvider.provideSampleQuestions(t);return f||[]}get apiAgent(){let t=!1,f=!1;const h=()=>{t||f||(f=!0,queueMicrotask(()=>{this._proxy.$updateAgent(this._handle,{fullName:this._fullName,icon:this._iconPath?this._iconPath instanceof A.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof a.ThemeIcon?this._iconPath:void 0,hasFollowups:this._followupProvider!==void 0,isSecondary:this._isSecondary,helpTextPrefix:!this._helpTextPrefix||typeof this._helpTextPrefix=="string"?this._helpTextPrefix:S.MarkdownString.from(this._helpTextPrefix),helpTextVariablesPrefix:!this._helpTextVariablesPrefix||typeof this._helpTextVariablesPrefix=="string"?this._helpTextVariablesPrefix:S.MarkdownString.from(this._helpTextVariablesPrefix),helpTextPostfix:!this._helpTextPostfix||typeof this._helpTextPostfix=="string"?this._helpTextPostfix:S.MarkdownString.from(this._helpTextPostfix),sampleRequest:this._sampleRequest,supportIssueReporting:this._supportIssueReporting,requester:this._requester}),f=!1}))},l=this;return{get id(){return l.id},get fullName(){return(0,o.checkProposedApiEnabled)(l.extension,"defaultChatParticipant"),l._fullName??l.extension.displayName??l.extension.name},set fullName(u){(0,o.checkProposedApiEnabled)(l.extension,"defaultChatParticipant"),l._fullName=u,h()},get iconPath(){return l._iconPath},set iconPath(u){l._iconPath=u,h()},get requestHandler(){return l._requestHandler},set requestHandler(u){(0,w.assertType)(typeof u=="function","Invalid request handler"),l._requestHandler=u},get followupProvider(){return l._followupProvider},set followupProvider(u){l._followupProvider=u,h()},get isDefault(){return(0,o.checkProposedApiEnabled)(l.extension,"defaultChatParticipant"),l._isDefault},set isDefault(u){(0,o.checkProposedApiEnabled)(l.extension,"defaultChatParticipant"),l._isDefault=u,h()},get helpTextPrefix(){return(0,o.checkProposedApiEnabled)(l.extension,"defaultChatParticipant"),l._helpTextPrefix},set helpTextPrefix(u){(0,o.checkProposedApiEnabled)(l.extension,"defaultChatParticipant"),l._helpTextPrefix=u,h()},get helpTextVariablesPrefix(){return(0,o.checkProposedApiEnabled)(l.extension,"defaultChatParticipant"),l._helpTextVariablesPrefix},set helpTextVariablesPrefix(u){(0,o.checkProposedApiEnabled)(l.extension,"defaultChatParticipant"),l._helpTextVariablesPrefix=u,h()},get helpTextPostfix(){return(0,o.checkProposedApiEnabled)(l.extension,"defaultChatParticipant"),l._helpTextPostfix},set helpTextPostfix(u){(0,o.checkProposedApiEnabled)(l.extension,"defaultChatParticipant"),l._helpTextPostfix=u,h()},get isSecondary(){return(0,o.checkProposedApiEnabled)(l.extension,"defaultChatParticipant"),l._isSecondary},set isSecondary(u){(0,o.checkProposedApiEnabled)(l.extension,"defaultChatParticipant"),l._isSecondary=u,h()},get sampleRequest(){return l._sampleRequest},set sampleRequest(u){l._sampleRequest=u,h()},get supportIssueReporting(){return(0,o.checkProposedApiEnabled)(l.extension,"chatParticipantAdditions"),l._supportIssueReporting},set supportIssueReporting(u){(0,o.checkProposedApiEnabled)(l.extension,"chatParticipantAdditions"),l._supportIssueReporting=u,h()},get onDidReceiveFeedback(){return l._onDidReceiveFeedback.event},set participantVariableProvider(u){if((0,o.checkProposedApiEnabled)(l.extension,"chatParticipantAdditions"),l._agentVariableProvider=u,u){if(!u.triggerCharacters.length)throw new Error("triggerCharacters are required");l._proxy.$registerAgentCompletionsProvider(l._handle,u.triggerCharacters)}else l._proxy.$unregisterAgentCompletionsProvider(l._handle)},get participantVariableProvider(){return(0,o.checkProposedApiEnabled)(l.extension,"chatParticipantAdditions"),l._agentVariableProvider},set welcomeMessageProvider(u){(0,o.checkProposedApiEnabled)(l.extension,"defaultChatParticipant"),l._welcomeMessageProvider=u,h()},get welcomeMessageProvider(){return(0,o.checkProposedApiEnabled)(l.extension,"defaultChatParticipant"),l._welcomeMessageProvider},onDidPerformAction:(0,o.isProposedApiEnabled)(this.extension,"chatParticipantAdditions")?this._onDidPerformAction.event:void 0,set requester(u){l._requester=u,h()},get requester(){return l._requester},dispose(){t=!0,l._followupProvider=void 0,l._onDidReceiveFeedback.dispose(),l._proxy.$unregisterAgent(l._handle)}}}invoke(t,f,h,l){return this._requestHandler(t,f,h,l)}}}),define(ye[330],_e([1,0,13,3,6,16,7,26]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class p{static{this._idPool=0}constructor(I){this._resolver=new Map,this._proxy=I.getProxy(L.MainContext.MainThreadChatVariables)}async $resolveVariable(I,v,C,S){const a=this._resolver.get(I);if(a)try{if(a.resolver.resolve2){(0,b.checkProposedApiEnabled)(a.extension,"chatParticipantAdditions");const m=new w(v,this._proxy),o=await a.resolver.resolve2(a.data.name,{prompt:C},m.apiObject,S);if(o)return o.map(T.ChatVariable.from)}else{const m=await a.resolver.resolve(a.data.name,{prompt:C},S);if(m)return m.map(T.ChatVariable.from)}}catch(m){(0,c.onUnexpectedExternalError)(m)}}registerVariableResolver(I,v,C,S){const a=p._idPool++;return this._resolver.set(a,{extension:I,data:{name:v,description:C},resolver:S}),this._proxy.$registerVariable(a,{name:v,description:C}),(0,O.toDisposable)(()=>{this._resolver.delete(a),this._proxy.$unregisterVariable(a)})}}e.ExtHostChatVariables=p;class w{constructor(I,v){this._requestId=I,this._proxy=v,this._isClosed=!1}close(){this._isClosed=!0}get apiObject(){if(!this._apiObject){let v=function(S){if(I._isClosed){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,S),a}};const I=this,C=S=>{this._proxy.$handleProgressChunk(this._requestId,S)};this._apiObject={progress(S){v(this.progress);const a=new R.ChatResponseProgressPart(S),m=T.ChatResponseProgressPart.to(a);return C(m),this},reference(S){v(this.reference);const a=new R.ChatResponseReferencePart(S),m=T.ChatResponseReferencePart.to(a);return C(m),this},push(S){return v(this.push),S instanceof R.ChatResponseReferencePart?C(T.ChatResponseReferencePart.to(S)):S instanceof R.ChatResponseProgressPart&&C(T.ChatResponseProgressPart.to(S)),this}}}return this._apiObject}}}),define(ye[331],_e([1,0,8,54,4,3,2,83,25,16,7,6,26]),function(de,e,c,O,L,T,R,b,p,w,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=C;function C(S,a,m){const o=S.getProxy(I.MainContext.MainThreadComments);class n{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new p.ExtensionIdentifierMap,a.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===6){const D=this._commentControllers.get(g.handle);return D?D.value:g}else if(g&&g.$mid===7){const D=g,E=this._commentControllers.get(D.commentControlHandle);if(!E)return D;const _=E.getCommentThread(D.commentThreadHandle);return _?_.value:D}else if(g&&(g.$mid===9||g.$mid===8)){const D=this._commentControllers.get(g.thread.commentControlHandle);if(!D)return g;const E=D.getCommentThread(g.thread.commentThreadHandle);return E?g.$mid===8?E.value:{thread:E.value,text:g.text}:g}else if(g&&g.$mid===10){const D=this._commentControllers.get(g.thread.commentControlHandle);if(!D)return g;const E=D.getCommentThread(g.thread.commentThreadHandle);if(!E)return g;const _=g.commentUniqueId,y=E.getCommentByUniqueId(_);return y||g}else if(g&&g.$mid===11){const D=this._commentControllers.get(g.thread.commentControlHandle);if(!D)return g;const E=D.getCommentThread(g.thread.commentThreadHandle);if(!E)return g;const _=g.text,y=g.commentUniqueId,P=E.getCommentByUniqueId(y);return P?(typeof P.body=="string"?P.body=_:P.body=new A.MarkdownString(_),P):g}return g}})}createCommentController(g,D,E){const _=n.handlePool++,y=new r(g,_,D,E);this._commentControllers.set(y.handle,y);const P=this._commentControllersByExtension.get(g.identifier)||[];return P.push(y),this._commentControllersByExtension.set(g.identifier,P),y.value}async $createCommentThreadTemplate(g,D,E){const _=this._commentControllers.get(g);_&&_.$createCommentThreadTemplate(D,E)}async $setActiveComment(g,D){const E=this._commentControllers.get(g);E&&E.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(g,D,E){const _=this._commentControllers.get(g);_&&_.$updateCommentThreadTemplate(D,E)}$deleteCommentThread(g,D){this._commentControllers.get(g)?.$deleteCommentThread(D)}async $provideCommentingRanges(g,D,E){const _=this._commentControllers.get(g);if(!_||!_.commentingRangeProvider)return Promise.resolve(void 0);const y=await m.ensureDocumentData(R.URI.revive(D));return(0,c.asPromise)(async()=>{const P=await _.commentingRangeProvider.provideCommentingRanges(y.document,E);let k;return Array.isArray(P)?k={ranges:P,fileComments:!1}:P?k={ranges:P.ranges||[],fileComments:P.fileComments||!1}:k=P??void 0,k}).then(P=>{let k;return P&&(k={ranges:P.ranges.map(z=>w.Range.from(z)),fileComments:P.fileComments}),k})}$toggleReaction(g,D,E,_,y){const P=this._commentControllers.get(g);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const k=P.getCommentThread(D);if(k){const z=k.getCommentByUniqueId(_.uniqueIdInThread);if(P!==void 0&&z&&P.reactionHandler)return P.reactionHandler(z,f(y))}return Promise.resolve(void 0)})}}class i{static{this._handlePool=0}set threadId(g){this._id=g}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(g){(g===void 0!=(this._range===void 0)||!g||!this._range||!g.isEqual(this._range))&&(this._range=g,this.modifications.range=g,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(g){this._canReply!==g&&(this._canReply=g,this.modifications.canReply=g,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(g){this._label=g,this.modifications.label=g,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(g){this._contextValue=g,this.modifications.contextValue=g,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(g){this._comments=g,this.modifications.comments=g,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(g){this._collapseState=g,this.modifications.collapsibleState=g,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(g){this._state=g,typeof g=="object"?((0,v.checkProposedApiEnabled)(this.extensionDescription,"commentThreadApplicability"),this.modifications.state=g.resolved,this.modifications.applicability=g.applicability):this.modifications.state=g,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(g,D,E,_,y,P,k,z){this._commentControllerHandle=D,this._id=E,this._uri=_,this._range=y,this._comments=P,this.extensionDescription=k,this._isTemplate=z,this.handle=i._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new L.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${g}.${this.handle}`),o.$createCommentThread(D,this.handle,this._id,this._uri,w.Range.from(this._range),k.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this._localDisposables.push({dispose:()=>{o.$deleteCommentThread(D,this.handle)}});const x=this;this.value={get uri(){return x.uri},get range(){return x.range},set range(F){x.range=F},get comments(){return x.comments},set comments(F){x.comments=F},get collapsibleState(){return x.collapsibleState},set collapsibleState(F){x.collapsibleState=F},get canReply(){return x.canReply},set canReply(F){x.canReply=F},get contextValue(){return x.contextValue},set contextValue(F){x.contextValue=F},get label(){return x.label},set label(F){x.label=F},get state(){return x.state},set state(F){x.state=F},dispose:()=>{x.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const g=E=>Object.prototype.hasOwnProperty.call(this.modifications,E),D={};g("range")&&(D.range=w.Range.from(this._range)),g("label")&&(D.label=this.label),g("contextValue")&&(D.contextValue=this.contextValue??null),g("comments")&&(D.comments=this._comments.map(E=>s(this,E,this._commentsMap,this.extensionDescription))),g("collapsibleState")&&(D.collapseState=h(this._collapseState)),g("canReply")&&(D.canReply=this.canReply),g("state")&&(D.state=l(this._state)),g("applicability")&&(D.applicability=u(this._state)),g("isTemplate")&&(D.isTemplate=this._isTemplate),this.modifications={},o.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,D)}getCommentByUniqueId(g){for(const D of this._commentsMap){const E=D[0],_=D[1];if(g===_)return E}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(g=>g.dispose())}}Ge([(0,O.debounce)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(g){this._commentingRangeProvider=g,g?.resourceHints&&(0,v.checkProposedApiEnabled)(this._extension,"commentingRangeHint"),o.$updateCommentingRanges(this.handle,g?.resourceHints)}get reactionHandler(){return this._reactionHandler}set reactionHandler(g){this._reactionHandler=g,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!g})}get options(){return this._options}set options(g){this._options=g,o.$updateCommentControllerFeatures(this.handle,{options:this._options})}get activeComment(){return(0,v.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeComment}get activeCommentThread(){return(0,v.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeThread}constructor(g,D,E,_){this._extension=g,this._handle=D,this._id=E,this._label=_,this._threads=new Map,o.$registerCommentController(this.handle,E,_,this._extension.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(P){y.options=P},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(P){y.commentingRangeProvider=P},get reactionHandler(){return y.reactionHandler},set reactionHandler(P){y.reactionHandler=P},get activeCommentThread(){return y.activeCommentThread},createCommentThread(P,k,z){return y.createCommentThread(P,k,z).value},dispose:()=>{y.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(g,D,E){D===void 0&&(0,v.checkProposedApiEnabled)(this._extension,"fileComments");const _=new i(this.id,this.handle,void 0,g,D,E,this._extension,!1);return this._threads.set(_.handle,_),_}$setActiveComment(g){if(!g){this._activeComment=void 0,this._activeThread=void 0;return}const D=this._threads.get(g.commentThreadHandle);D&&(this._activeComment=g.uniqueIdInThread?D.getCommentByUniqueId(g.uniqueIdInThread):void 0,this._activeThread=D)}$createCommentThreadTemplate(g,D){const E=new i(this.id,this.handle,void 0,R.URI.revive(g),w.Range.to(D),[],this._extension,!0);return E.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this._threads.set(E.handle,E),E}$updateCommentThreadTemplate(g,D){const E=this._threads.get(g);E&&(E.range=w.Range.to(D))}$deleteCommentThread(g){this._threads.get(g)?.dispose(),this._threads.delete(g)}getCommentThread(g){return this._threads.get(g)}dispose(){this._threads.forEach(g=>{g.dispose()}),this._localDisposables.forEach(g=>g.dispose())}}function s(d,g,D,E){let _=D.get(g);return _||(_=++d.commentHandle,D.set(g,_)),g.state!==void 0&&(0,v.checkProposedApiEnabled)(E,"commentsDraftState"),g.reactions?.some(y=>y.reactors!==void 0)&&(0,v.checkProposedApiEnabled)(E,"commentReactor"),{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:_,body:typeof g.body=="string"?g.body:w.MarkdownString.from(g.body),userName:g.author.name,userIconPath:g.author.iconPath,label:g.label,commentReactions:g.reactions?g.reactions.map(y=>t(y)):void 0,state:g.state,timestamp:g.timestamp?.toJSON()}}function t(d){return{label:d.label,iconPath:d.iconPath?w.pathOrURIToURI(d.iconPath):void 0,count:d.count,hasReacted:d.authorHasReacted,reactors:d.reactors&&d.reactors.length>0&&typeof d.reactors[0]!="string"?d.reactors.map(g=>g.name):d.reactors}}function f(d){return{label:d.label||"",count:d.count||0,iconPath:d.iconPath?R.URI.revive(d.iconPath):"",authorHasReacted:d.hasReacted||!1,reactors:d.reactors?.map(g=>({name:g}))}}function h(d){if(d!==void 0)switch(d){case A.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function l(d){let g;if(typeof d=="object"?g=d.resolved:g=d,g!==void 0)switch(g){case A.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function u(d){let g;if(typeof d=="object"&&(g=d.applicability),g!==void 0)switch(g){case A.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case A.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new n}}),define(ye[332],_e([1,0,22,55,3,15,23,2,16,92,111,6,7]),function(de,e,c,O,L,T,R,b,p,w,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class C{constructor(f,h){this.document=f,this._storagePath=h,this._backupCounter=1,this._edits=new A.Cache("custom documents")}addEdit(f){return this._edits.add([f])}async undo(f,h){await this.getEdit(f).undo(),h||this.disposeBackup()}async redo(f,h){await this.getEdit(f).redo(),h||this.disposeBackup()}disposeEdits(f){for(const h of f)this._edits.delete(h)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const f=s(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,f)}updateBackup(f){this._backup?.delete(),this._backup=f}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(f){const h=this._edits.get(f,0);if(!h)throw new Error("No edit found");return h}}class S{constructor(){this._documents=new Map}get(f,h){return this._documents.get(this.key(f,h))}add(f,h,l){const u=this.key(f,h.uri);if(this._documents.has(u))throw new Error(`Document already exists for viewType:${f} resource:${h.uri}`);const d=new C(h,l);return this._documents.set(u,d),d}delete(f,h){const l=this.key(f,h.uri);this._documents.delete(l)}key(f,h){return`${f}@@@${h}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class m{constructor(){this._providers=new Map}addTextProvider(f,h,l){return this.add(0,f,h,l)}addCustomProvider(f,h,l){return this.add(1,f,h,l)}get(f){return this._providers.get(f)}add(f,h,l,u){if(this._providers.has(h))throw new Error(`Provider for viewType:${h} already registered`);return this._providers.set(h,{type:f,extension:l,provider:u}),new v.Disposable(()=>this._providers.delete(h))}}class o{constructor(f,h,l,u,d){this._extHostDocuments=h,this._extensionStoragePaths=l,this._extHostWebview=u,this._extHostWebviewPanels=d,this._editorProviders=new m,this._documents=new S,this._proxy=f.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(f,h,l,u){const d=new L.DisposableStore;return i(l)?(d.add(this._editorProviders.addTextProvider(h,f,l)),this._proxy.$registerTextEditorProvider((0,w.toExtensionData)(f),h,u.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,w.shouldSerializeBuffersForPostMessage)(f))):(d.add(this._editorProviders.addCustomProvider(h,f,l)),n(l)&&d.add(l.onDidChangeCustomDocument(g=>{const D=this.getCustomDocumentEntry(h,g.document.uri);if(r(g)){const E=D.addEdit(g);this._proxy.$onDidEdit(g.document.uri,h,E,g.label)}else this._proxy.$onContentChange(g.document.uri,h)})),this._proxy.$registerCustomEditorProvider((0,w.toExtensionData)(f),h,u.webviewOptions||{},!!u.supportsMultipleEditorsPerDocument,(0,w.shouldSerializeBuffersForPostMessage)(f))),v.Disposable.from(d,new v.Disposable(()=>{this._proxy.$unregisterEditorProvider(h)}))}async $createCustomDocument(f,h,l,u,d){const g=this._editorProviders.get(h);if(!g)throw new Error(`No provider found for '${h}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${h}'`);const D=b.URI.revive(f),E=await g.provider.openCustomDocument(D,{backupId:l,untitledDocumentData:u?.buffer},d);let _;return n(g.provider)&&this._extensionStoragePaths&&(_=this._extensionStoragePaths.workspaceValue(g.extension)??this._extensionStoragePaths.globalValue(g.extension)),this._documents.add(h,E,_),{editable:n(g.provider)}}async $disposeCustomDocument(f,h){const l=this._editorProviders.get(h);if(!l)throw new Error(`No provider found for '${h}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${h}'`);const u=b.URI.revive(f),{document:d}=this.getCustomDocumentEntry(h,u);this._documents.delete(h,d),d.dispose()}async $resolveCustomEditor(f,h,l,u,d,g){const D=this._editorProviders.get(l);if(!D)throw new Error(`No provider found for '${l}'`);const E=p.ViewColumn.to(d),_=this._extHostWebview.createNewWebview(h,u.contentOptions,D.extension),y=this._extHostWebviewPanels.createNewWebviewPanel(h,l,u.title,E,u.options,_,u.active),P=b.URI.revive(f);switch(D.type){case 1:{const{document:k}=this.getCustomDocumentEntry(l,P);return D.provider.resolveCustomEditor(k,y,g)}case 0:{const k=this._extHostDocuments.getDocument(P);return D.provider.resolveCustomTextEditor(k,y,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,h,l){this.getCustomDocumentEntry(h,f).disposeEdits(l)}async $onMoveCustomEditor(f,h,l){const u=this._editorProviders.get(l);if(!u)throw new Error(`No provider found for '${l}'`);if(!u.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const d=this._extHostWebviewPanels.getWebviewPanel(f);if(!d)throw new Error("No webview found");const g=b.URI.revive(h),D=this._extHostDocuments.getDocument(g);await u.provider.moveCustomTextEditor(D,d,c.CancellationToken.None)}async $undo(f,h,l,u){return this.getCustomDocumentEntry(h,f).undo(l,u)}async $redo(f,h,l,u){return this.getCustomDocumentEntry(h,f).redo(l,u)}async $revert(f,h,l){const u=this.getCustomDocumentEntry(h,f);await this.getCustomEditorProvider(h).revertCustomDocument(u.document,l),u.disposeBackup()}async $onSave(f,h,l){const u=this.getCustomDocumentEntry(h,f);await this.getCustomEditorProvider(h).saveCustomDocument(u.document,l),u.disposeBackup()}async $onSaveAs(f,h,l,u){const d=this.getCustomDocumentEntry(h,f);return this.getCustomEditorProvider(h).saveCustomDocumentAs(d.document,b.URI.revive(l),u)}async $backup(f,h,l){const u=this.getCustomDocumentEntry(h,f),g=await this.getCustomEditorProvider(h).backupCustomDocument(u.document,{destination:u.getNewBackupUri()},l);return u.updateBackup(g),g.id}getCustomDocumentEntry(f,h){const l=this._documents.get(f,b.URI.revive(h));if(!l)throw new Error("No custom document found");return l}getCustomEditorProvider(f){const l=this._editorProviders.get(f)?.provider;if(!l||!n(l))throw new Error("Custom document is not editable");return l}}e.ExtHostCustomEditors=o;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function s(t){const f=t.scheme===T.Schemas.file||t.scheme===T.Schemas.untitled?t.fsPath:t.toString();return(0,O.hash)(f)+""}}),define(ye[333],_e([1,0,219,138,2,6,7,16,4,12,27,59]),function(de,e,c,O,L,T,R,b,p,w,A,I){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{#e;#t;#i;constructor(m,o,n,i,r,s,t,f){this._name=m,this._owner=o,this._maxDiagnosticsTotal=n,this._maxDiagnosticsPerFile=i,this._modelVersionIdProvider=r,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(i,n),this.#i=new A.ResourceMap(h=>s.getComparisonKey(h)),this.#e=t,this.#t=f}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(m,o){if(!m){this.clear();return}this._checkDisposed();let n=[];if(L.URI.isUri(m)){if(!o){this.delete(m);return}this.#i.set(m,o.slice()),n=[m]}else if(Array.isArray(m)){n=[];let s;m=[...m].sort(C._compareIndexedTuplesByUri);for(const t of m){const[f,h]=t;if((!s||f.toString()!==s.toString())&&(s&&this.#i.get(s).length===0&&this.#i.delete(s),s=f,n.push(f),this.#i.set(f,[])),h)this.#i.get(f)?.push(...h);else{const l=this.#i.get(f);l&&(l.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let r=0;for(const s of n){let t=[];const f=this.#i.get(s);if(f)if(f.length>this._maxDiagnosticsPerFile){t=[];const h=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const u of f)if(u.severity===h[l]&&t.push({...b.Diagnostic.from(u),modelVersionId:this._modelVersionIdProvider(s)})===this._maxDiagnosticsPerFile)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,c.localize)(0,null,f.length-this._maxDiagnosticsPerFile),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(h=>({...b.Diagnostic.from(h),modelVersionId:this._modelVersionIdProvider(s)}));if(i.push([s,t]),r+=t.length,r>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,i)}delete(m){this._checkDisposed(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this._owner,[[m,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(m,o){this._checkDisposed();for(const[n,i]of this)m.call(o,n,i,this)}*[Symbol.iterator](){this._checkDisposed();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this._checkDisposed();const o=this.#i.get(m);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(m){return this._checkDisposed(),Array.isArray(this.#i.get(m))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(m,o){return m[0].toString()<o[0].toString()?-1:m[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=C;let S=class{static{v=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*v._maxDiagnosticsPerFile}static _mapper(m){const o=new A.ResourceMap;for(const n of m)o.set(n,n);return{uris:Object.freeze(Array.from(o.values()))}}constructor(m,o,n,i){this._logService=o,this._fileSystemInfoService=n,this._extHostDocumentsAndEditors=i,this._collections=new Map,this._onDidChangeDiagnostics=new p.DebounceEmitter({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this._onDidChangeDiagnostics.event,v._mapper),this._proxy=m.getProxy(T.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(m,o){const{_collections:n,_proxy:i,_onDidChangeDiagnostics:r,_logService:s,_fileSystemInfoService:t,_extHostDocumentsAndEditors:f}=this,h=new class{$changeMany(d,g){i.$changeMany(d,g),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,d,g.length===0?"CLEARING":g)}$clear(d){i.$clear(d),s.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,d)}dispose(){i.dispose()}};let l;if(!o)o="_generated_diagnostic_collection_name_#"+v._idPool++,l=o;else if(!n.has(o))l=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do l=o+v._idPool++;while(n.has(l))}return new class extends C{constructor(){super(o,l,v._maxDiagnosticsTotal,v._maxDiagnosticsPerFile,d=>f.getDocument(d)?.version,t.extUri,h,r),n.set(l,this)}dispose(){super.dispose(),n.delete(l)}}}getDiagnostics(m){if(m)return this._getDiagnostics(m);{const o=new Map,n=[];for(const i of this._collections.values())i.forEach((r,s)=>{let t=o.get(r.toString());typeof t>"u"&&(t=n.length,o.set(r.toString(),t),n.push([r,[]])),n[t][1]=n[t][1].concat(...s)});return n}}_getDiagnostics(m){let o=[];for(const n of this._collections.values())n.has(m)&&(o=o.concat(n.get(m)));return o}$acceptMarkersChange(m){if(!this._mirrorCollection){const o="_generated_mirror",n=new C(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,n),this._mirrorCollection=n}for(const[o,n]of m)this._mirrorCollection.set(L.URI.revive(o),n.map(b.Diagnostic.to))}};e.ExtHostDiagnostics=S,e.ExtHostDiagnostics=S=v=Ge([Ue(1,w.ILogService),Ue(2,I.IExtHostFileSystemInfo)],S)}),define(ye[334],_e([1,0,2,13,7,16,75]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class b{constructor(w,A,I,v={timeout:1500,errors:3}){this._logService=w,this._documents=A,this._mainThreadBulkEdits=I,this._thresholds=v,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(w){return(A,I,v)=>{const S={dispose:this._callbacks.push([A,I,w])};return Array.isArray(v)&&v.push(S),S}}async $participateInSave(w,A){const I=c.URI.revive(w);let v=!1;const C=setTimeout(()=>v=!0,this._thresholds.timeout),S=[];try{for(const a of[...this._callbacks]){if(v)break;const m=this._documents.getDocument(I),o=await this._deliverEventAsyncAndBlameBadListeners(a,{document:m,reason:T.TextDocumentSaveReason.to(A)});S.push(o)}}finally{clearTimeout(C)}return S}_deliverEventAsyncAndBlameBadListeners([w,A,I],v){const C=this._badListeners.get(w);return typeof C=="number"&&C>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,w,A,v).then(()=>!0,S=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const a=this._badListeners.get(w);this._badListeners.set(w,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(w,A,I,v){const C=[],S=Date.now(),{document:a,reason:m}=v,{version:o}=a,n=Object.freeze({document:a,reason:m,waitUntil(i){if(Object.isFrozen(C))throw(0,O.illegalState)("waitUntil can not be called async");C.push(Promise.resolve(i))}});try{A.apply(I,[n])}catch(i){return Promise.reject(i)}return Object.freeze(C),new Promise((i,r)=>{const s=setTimeout(()=>r(new Error("timeout")),this._thresholds.timeout);return Promise.all(C).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(s),i(t)}).catch(t=>{clearTimeout(s),r(t)})}).then(i=>{const r={edits:[]};for(const s of i)if(Array.isArray(s)&&s.every(t=>t instanceof L.TextEdit))for(const{newText:t,newEol:f,range:h}of s)r.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:h&&T.Range.from(h),text:t,eol:f&&T.EndOfLine.from(f)}});if(r.edits.length!==0)return o===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=b}),define(ye[335],_e([1,0,4,3,2,6,152,16,18,24,7]),function(de,e,c,O,L,T,R,b,p,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(C,S){this._onDidAddDocument=new c.Emitter,this._onDidRemoveDocument=new c.Emitter,this._onDidChangeDocument=new c.Emitter,this._onDidSaveDocument=new c.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new O.DisposableStore,this._documentLoader=new Map,this._proxy=C.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=S,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const m of a)this._onDidRemoveDocument.fire(m.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const m of a)this._onDidAddDocument.fire(m.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(C){if(!C)return;const S=this._documentsAndEditors.getDocument(C);if(S)return S}getDocument(C){const S=this.getDocumentData(C);if(!S?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return S.document}ensureDocumentData(C){const S=this._documentsAndEditors.getDocument(C);if(S)return Promise.resolve(S);let a=this._documentLoader.get(C.toString());return a||(a=this._proxy.$tryOpenDocument(C).then(m=>{this._documentLoader.delete(C.toString());const o=L.URI.revive(m);return(0,p.assertIsDefined)(this._documentsAndEditors.getDocument(o))},m=>(this._documentLoader.delete(C.toString()),Promise.reject(m))),this._documentLoader.set(C.toString(),a)),a}createDocumentData(C){return this._proxy.$tryCreateDocument(C).then(S=>L.URI.revive(S))}$acceptModelLanguageChanged(C,S){const a=L.URI.revive(C),m=this._documentsAndEditors.getDocument(a);if(!m)throw new Error("unknown document");this._onDidRemoveDocument.fire(m.document),m._acceptLanguageId(S),this._onDidAddDocument.fire(m.document)}$acceptModelSaved(C){const S=L.URI.revive(C),a=this._documentsAndEditors.getDocument(S);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(C,S){const a=L.URI.revive(C),m=this._documentsAndEditors.getDocument(a);if(!m)throw new Error("unknown document");m._acceptIsDirty(S),this._onDidChangeDocument.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,S,a){const m=L.URI.revive(C),o=this._documentsAndEditors.getDocument(m);if(!o)throw new Error("unknown document");o._acceptIsDirty(a),o.onEvents(S);let n;S.isUndoing?n=A.TextDocumentChangeReason.Undo:S.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,w.deepFreeze)({document:o.document,contentChanges:S.changes.map(i=>({range:b.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(C,S){(0,R.setWordDefinitionFor)(C,S)}}e.ExtHostDocuments=I}),define(ye[71],_e([1,0,73,4,18,2,5,6,20,16,7]),function(de,e,c,O,L,T,R,b,p,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,R.createDecorator)("IExtHostEditorTabs");class I{constructor(m,o,n){this._activeTabIdGetter=n,this._parentGroup=o,this.acceptDtoUpdate(m)}get apiObject(){if(!this._apiObject){const m=this,o={get isActive(){return m._dto.id===m._activeTabIdGetter()},get label(){return m._dto.label},get input(){return m._input},get isDirty(){return m._dto.isDirty},get isPinned(){return m._dto.isPinned},get isPreview(){return m._dto.isPreview},get group(){return m._parentGroup.apiObject}};this._apiObject=Object.freeze(o)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(m){this._dto=m,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new A.TextTabInput(T.URI.revive(this._dto.input.uri));case 2:return new A.TextDiffTabInput(T.URI.revive(this._dto.input.original),T.URI.revive(this._dto.input.modified));case 3:return new A.TextMergeTabInput(T.URI.revive(this._dto.input.base),T.URI.revive(this._dto.input.input1),T.URI.revive(this._dto.input.input2),T.URI.revive(this._dto.input.result));case 6:return new A.CustomEditorTabInput(T.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new A.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new A.NotebookEditorTabInput(T.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(T.URI.revive(this._dto.input.original),T.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(T.URI.revive(this._dto.input.uri),T.URI.revive(this._dto.input.inputBoxUri));case 10:return new A.ChatEditorTabInput(this._dto.input.providerId);case 11:return new A.TextMultiDiffTabInput(this._dto.input.diffEditors.map(m=>new A.TextDiffTabInput(T.URI.revive(m.original),T.URI.revive(m.modified))));default:return}}}class v{constructor(m,o){this._tabs=[],this._activeTabId="",this._dto=m,this._activeGroupIdGetter=o;for(const n of m.tabs)n.isActive&&(this._activeTabId=n.id),this._tabs.push(new I(n,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const m=this,o={get isActive(){return m._dto.groupId===m._activeGroupIdGetter()},get viewColumn(){return w.ViewColumn.to(m._dto.viewColumn)},get activeTab(){return m._tabs.find(n=>n.tabId===m._activeTabId)?.apiObject},get tabs(){return Object.freeze(m._tabs.map(n=>n.apiObject))}};this._apiObject=Object.freeze(o)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(m){this._dto=m}acceptTabOperation(m){if(m.kind===0){const n=new I(m.tabDto,this,()=>this.activeTabId());return this._tabs.splice(m.index,0,n),m.tabDto.isActive&&(this._activeTabId=n.tabId),n}else if(m.kind===1){const n=this._tabs.splice(m.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return n.tabId===this._activeTabId&&(this._activeTabId=""),n}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this._tabs.splice(m.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this._tabs.splice(m.index,0,n),n}const o=this._tabs.find(n=>n.tabId===m.tabDto.id);if(!o)throw new Error("INVALID tab");return m.tabDto.isActive?this._activeTabId=m.tabDto.id:this._activeTabId===m.tabDto.id&&!m.tabDto.isActive&&(this._activeTabId=""),o.acceptDtoUpdate(m.tabDto),o}activeTabId(){return this._activeTabId}}let C=class{constructor(m){this._onDidChangeTabs=new O.Emitter,this._onDidChangeTabGroups=new O.Emitter,this._extHostTabGroups=[],this._proxy=m.getProxy(b.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const m=this,o={onDidChangeTabGroups:m._onDidChangeTabGroups.event,onDidChangeTabs:m._onDidChangeTabs.event,get all(){return Object.freeze(m._extHostTabGroups.map(n=>n.apiObject))},get activeTabGroup(){const n=m._activeGroupId;return(0,L.assertIsDefined)(m._extHostTabGroups.find(r=>r.groupId===n)?.apiObject)},close:async(n,i)=>{const r=Array.isArray(n)?n:[n];return r.length?S(r[0])?this._closeGroups(r,i):this._closeTabs(r,i):!0}};this._apiObject=Object.freeze(o)}return this._apiObject}$acceptEditorTabModel(m){const o=new Set(this._extHostTabGroups.map(h=>h.groupId)),n=new Set(m.map(h=>h.groupId)),i=(0,c.diffSets)(o,n),r=this._extHostTabGroups.filter(h=>i.removed.includes(h.groupId)).map(h=>h.apiObject),s=[],t=[];this._extHostTabGroups=m.map(h=>{const l=new v(h,()=>this._activeGroupId);return i.added.includes(l.groupId)?s.push(l.apiObject):t.push(l.apiObject),l});const f=(0,L.assertIsDefined)(m.find(h=>h.isActive===!0)?.groupId);f!==void 0&&this._activeGroupId!==f&&(this._activeGroupId=f),this._onDidChangeTabGroups.fire(Object.freeze({opened:s,closed:r,changed:t}))}$acceptTabGroupUpdate(m){const o=this._extHostTabGroups.find(n=>n.groupId===m.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(m),m.isActive&&(this._activeGroupId=m.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const o=this._extHostTabGroups.find(i=>i.groupId===m.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const n=o.acceptTabOperation(m);switch(m.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}_findExtHostTabFromApi(m){for(const o of this._extHostTabGroups)for(const n of o.tabs)if(n.apiObject===m)return n}_findExtHostTabGroupFromApi(m){return this._extHostTabGroups.find(o=>o.apiObject===m)}async _closeTabs(m,o){const n=[];for(const i of m){const r=this._findExtHostTabFromApi(i);if(!r)throw new Error("Tab close: Invalid tab not found!");n.push(r.tabId)}return this._proxy.$closeTab(n,o)}async _closeGroups(m,o){const n=[];for(const i of m){const r=this._findExtHostTabGroupFromApi(i);if(!r)throw new Error("Group close: Invalid group not found!");n.push(r.groupId)}return this._proxy.$closeGroup(n,o)}};e.ExtHostEditorTabs=C,e.ExtHostEditorTabs=C=Ge([Ue(0,p.IExtHostRpcService)],C);function S(a){return a.tabs!==void 0}}),define(ye[336],_e([1,0,2,6,3,7,16,180,14,21,26,80]),function(de,e,c,O,L,T,R,b,p,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class v{constructor(){this._schemes=[]}add(a){this._stateMachine=void 0,this._schemes.push(a)}delete(a){const m=this._schemes.indexOf(a);m>=0&&(this._schemes.splice(m,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const a=this._schemes.sort(),m=[];let o,n,i=14,r=14;for(const s of a){let t=o?(0,p.commonPrefixLength)(o,s):0;for(t===0?n=1:n=r;t<s.length;t++)t+1===s.length?(i=r,r=9):r+=1,m.push([n,s.toUpperCase().charCodeAt(t),r]),m.push([n,s.toLowerCase().charCodeAt(t),r]),n=r;o=s,r=i}m.push([9,58,10]),m.push([10,47,12]),this._stateMachine=new b.StateMachine(m)}}provideDocumentLinks(a){this._initStateMachine();const m=[],o=b.LinkComputer.computeLinks({getLineContent(n){return a.lineAt(n-1).text},getLineCount(){return a.lineCount}},this._stateMachine);for(const n of o){const i=R.DocumentLink.to(n);i.target&&m.push(i)}return m}}class C{constructor(a,m){this._extHostLanguageFeatures=m,this._linkProvider=new v,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=a.getProxy(O.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(a,m,o,n={}){if(C._validateFileSystemProvider(o),this._registeredSchemes.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(a,"*",this._linkProvider));const i=this._handlePool++;this._linkProvider.add(m),this._registeredSchemes.add(m),this._fsProvider.set(i,o);let r=2;n.isCaseSensitive&&(r+=1024),n.isReadonly&&(r+=2048),typeof o.copy=="function"&&(r+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,A.checkProposedApiEnabled)(a,"fsChunks"),r+=4);let s;n.isReadonly&&(0,I.isMarkdownString)(n.isReadonly)&&n.isReadonly.value!==""&&(s={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this._proxy.$registerFileSystemProvider(i,m,r,s).catch(f=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${m}`),console.error(f)});const t=o.onDidChangeFile(f=>{const h=[];for(const l of f){const{uri:u,type:d}=l;if(u.scheme!==m)continue;let g;switch(d){case T.FileChangeType.Changed:g=0;break;case T.FileChangeType.Created:g=1;break;case T.FileChangeType.Deleted:g=2;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:u,type:g})}this._proxy.$onFileSystemChange(i,h)});return(0,L.toDisposable)(()=>{t.dispose(),this._linkProvider.delete(m),this._registeredSchemes.delete(m),this._fsProvider.delete(i),this._proxy.$unregisterProvider(i)})}static _validateFileSystemProvider(a){if(!a)throw new Error("MISSING provider");if(typeof a.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof a.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof a.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof a.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof a.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof a.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof a.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof a.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(a){const{type:m,ctime:o,mtime:n,size:i,permissions:r}=a;return{type:m,ctime:o,mtime:n,size:i,permissions:r}}$stat(a,m){return Promise.resolve(this._getFsProvider(a).stat(c.URI.revive(m))).then(o=>C._asIStat(o))}$readdir(a,m){return Promise.resolve(this._getFsProvider(a).readDirectory(c.URI.revive(m)))}$readFile(a,m){return Promise.resolve(this._getFsProvider(a).readFile(c.URI.revive(m))).then(o=>w.VSBuffer.wrap(o))}$writeFile(a,m,o,n){return Promise.resolve(this._getFsProvider(a).writeFile(c.URI.revive(m),o.buffer,n))}$delete(a,m,o){return Promise.resolve(this._getFsProvider(a).delete(c.URI.revive(m),o))}$rename(a,m,o,n){return Promise.resolve(this._getFsProvider(a).rename(c.URI.revive(m),c.URI.revive(o),n))}$copy(a,m,o,n){const i=this._getFsProvider(a);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(c.URI.revive(m),c.URI.revive(o),n))}$mkdir(a,m){return Promise.resolve(this._getFsProvider(a).createDirectory(c.URI.revive(m)))}$watch(a,m,o,n){const i=this._getFsProvider(a).watch(c.URI.revive(o),n);this._watches.set(m,i)}$unwatch(a,m){const o=this._watches.get(m);o&&(o.dispose(),this._watches.delete(m))}$open(a,m,o){const n=this._getFsProvider(a);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(c.URI.revive(m),o))}$close(a,m){const o=this._getFsProvider(a);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(m))}$read(a,m,o,n){const i=this._getFsProvider(a);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const r=w.VSBuffer.alloc(n);return Promise.resolve(i.read(m,o,r.buffer,0,n)).then(s=>r.slice(0,s))}$write(a,m,o,n){const i=this._getFsProvider(a);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(m,o,n.buffer,0,n.byteLength))}_getFsProvider(a){const m=this._fsProvider.get(a);if(!m){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return m}}e.ExtHostFileSystem=C}),define(ye[337],_e([1,0,4,35,2,6,16,7,46]),function(de,e,c,O,L,T,R,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class w{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(C,S,a,m,o,n){this.session=Math.random(),this._onDidCreate=new c.Emitter,this._onDidChange=new c.Emitter,this._onDidDelete=new c.Emitter,this._config=0,n?.ignoreCreateEvents&&(this._config+=1),n?.ignoreChangeEvents&&(this._config+=2),n?.ignoreDeleteEvents&&(this._config+=4);const i=(0,O.parse)(o),r=typeof o=="string",s=n?.correlate,t=m(f=>{if(!(typeof f.session=="number"&&f.session!==this.session)&&!(s&&typeof f.session>"u")){if(!n?.ignoreCreateEvents)for(const h of f.created){const l=L.URI.revive(h);i(l.fsPath)&&(!r||S.getWorkspaceFolder(l))&&this._onDidCreate.fire(l)}if(!n?.ignoreChangeEvents)for(const h of f.changed){const l=L.URI.revive(h);i(l.fsPath)&&(!r||S.getWorkspaceFolder(l))&&this._onDidChange.fire(l)}if(!n?.ignoreDeleteEvents)for(const h of f.deleted){const l=L.URI.revive(h);i(l.fsPath)&&(!r||S.getWorkspaceFolder(l))&&this._onDidDelete.fire(l)}}});this._disposable=b.Disposable.from(this.ensureWatching(C,a,o,n,n?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(C,S,a,m,o){const n=b.Disposable.from();if(typeof a=="string")return n;const i=C.getProxy(T.MainContext.MainThreadFileSystemEventService);let r=!1;return(a.pattern.includes(O.GLOBSTAR)||a.pattern.includes(O.GLOB_SPLIT))&&(r=!0),i.$watch(S.identifier.value,this.session,a.baseUri,{recursive:r,excludes:m?.excludes??[]},!!o),b.Disposable.from({dispose:()=>i.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class A{constructor(C){this._events=C,this.session=this._events.session,this._created=new p.Lazy(()=>this._events.created.map(L.URI.revive)),this._changed=new p.Lazy(()=>this._events.changed.map(L.URI.revive)),this._deleted=new p.Lazy(()=>this._events.deleted.map(L.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class I{constructor(C,S,a){this._mainContext=C,this._logService=S,this._extHostDocumentsAndEditors=a,this._onFileSystemEvent=new c.Emitter,this._onDidRenameFile=new c.Emitter,this._onDidCreateFile=new c.Emitter,this._onDidDeleteFile=new c.Emitter,this._onWillRenameFile=new c.AsyncEmitter,this._onWillCreateFile=new c.AsyncEmitter,this._onWillDeleteFile=new c.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,S,a,m){return new w(this._mainContext,C,S,this._onFileSystemEvent.event,R.GlobPattern.from(a),m)}$onFileEvent(C){this._onFileSystemEvent.fire(new A(C))}$onDidRunFileOperation(C,S){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:S.map(a=>({oldUri:L.URI.revive(a.source),newUri:L.URI.revive(a.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:S.map(a=>L.URI.revive(a.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:S.map(a=>L.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,S){return(a,m,o)=>{const n=function(r){a.call(m,r)};return n.extension=C,S.event(n,void 0,o)}}async $onWillRunFileOperation(C,S,a,m){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:S.map(o=>({oldUri:L.URI.revive(o.source),newUri:L.URI.revive(o.target)}))},a,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:S.map(o=>L.URI.revive(o.target))},a,m);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:S.map(o=>L.URI.revive(o.target))},a,m)}}async _fireWillEvent(C,S,a,m){const o=new Set,n=[];if(await C.fireAsync(S,m,async(r,s)=>{const t=Date.now(),f=await Promise.resolve(r);f instanceof b.WorkspaceEdit&&(n.push([s.extension,f]),o.add(s.extension.displayName??s.extension.identifier.value)),Date.now()-t>a&&this._logService.warn("SLOW file-participant",s.extension.identifier)}),m.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,r]of n){const{edits:s}=R.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this._extHostDocumentsAndEditors.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(s)}return{edit:i,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=I}),define(ye[338],_e([1,0,19,8,22,13,124,3,24,39,14,18,2,29,176,83,134,221,25,16,7,26,111,6]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class h{constructor(H,U){this._documents=H,this._provider=U}async provideDocumentSymbols(H,U){const X=this._documents.getDocument(H),K=await this._provider.provideDocumentSymbols(X,U);if(!(0,c.isFalsyOrEmpty)(K))return K[0]instanceof r.DocumentSymbol?K.map(i.DocumentSymbol.from):h._asDocumentSymbolTree(K)}static _asDocumentSymbolTree(H){H=H.slice(0).sort((K,ge)=>{let Ee=K.location.range.start.compareTo(ge.location.range.start);return Ee===0&&(Ee=ge.location.range.end.compareTo(K.location.range.end)),Ee});const U=[],X=[];for(const K of H){const ge={name:K.name||"!!MISSING: name!!",kind:i.SymbolKind.from(K.kind),tags:K.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:i.Range.from(K.location.range),selectionRange:i.Range.from(K.location.range),children:[]};for(;;){if(X.length===0){X.push(ge),U.push(ge);break}const Ee=X[X.length-1];if(C.Range.containsRange(Ee.range,ge.range)&&!C.Range.equalsRange(Ee.range,ge.range)){Ee.children?.push(ge),X.push(ge);break}X.pop()}}return U}}class l{constructor(H,U,X,K,ge,Ee){this._documents=H,this._commands=U,this._provider=X,this._extension=K,this._extTelemetry=ge,this._logService=Ee,this._cache=new t.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(H,U){const X=this._documents.getDocument(H),K=await this._provider.provideCodeLenses(X,U);if(!K||U.isCancellationRequested)return;const ge=this._cache.add(K),Ee=new b.DisposableStore;this._disposables.set(ge,Ee);const ze={cacheId:ge,lenses:[]};for(let He=0;He<K.length;He++)ze.lenses.push({cacheId:[ge,He],range:i.Range.from(K[He].range),command:this._commands.toInternal(K[He].command,Ee)});return ze}async resolveCodeLens(H,U){const X=H.cacheId&&this._cache.get(...H.cacheId);if(!X)return;let K;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?K=X:K=await this._provider.resolveCodeLens(X,U),K||(K=X),U.isCancellationRequested)return;const ge=H.cacheId&&this._disposables.get(H.cacheId[0]);if(ge){if(!K.command){const Ee=new Error("INVALID code lens resolved, lacks command: "+this._extension.identifier.value);this._extTelemetry.onExtensionError(this._extension.identifier,Ee),this._logService.error(Ee);return}return H.command=this._commands.toInternal(K.command,ge),H}}releaseCodeLenses(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}}function u(xe){return Array.isArray(xe)?xe.map(i.DefinitionLink.from):xe?[i.DefinitionLink.from(xe)]:[]}class d{constructor(H,U){this._documents=H,this._provider=U}async provideDefinition(H,U,X){const K=this._documents.getDocument(H),ge=i.Position.to(U),Ee=await this._provider.provideDefinition(K,ge,X);return u(Ee)}}class g{constructor(H,U){this._documents=H,this._provider=U}async provideDeclaration(H,U,X){const K=this._documents.getDocument(H),ge=i.Position.to(U),Ee=await this._provider.provideDeclaration(K,ge,X);return u(Ee)}}class D{constructor(H,U){this._documents=H,this._provider=U}async provideImplementation(H,U,X){const K=this._documents.getDocument(H),ge=i.Position.to(U),Ee=await this._provider.provideImplementation(K,ge,X);return u(Ee)}}class E{constructor(H,U){this._documents=H,this._provider=U}async provideTypeDefinition(H,U,X){const K=this._documents.getDocument(H),ge=i.Position.to(U),Ee=await this._provider.provideTypeDefinition(K,ge,X);return u(Ee)}}class _{constructor(H,U){this._documents=H,this._provider=U}async provideHover(H,U,X){const K=this._documents.getDocument(H),ge=i.Position.to(U),Ee=await this._provider.provideHover(K,ge,X);if(!(!Ee||(0,c.isFalsyOrEmpty)(Ee.contents)))return Ee.range||(Ee.range=K.getWordRangeAtPosition(ge)),Ee.range||(Ee.range=new r.Range(ge,ge)),i.Hover.from(Ee)}}class y{constructor(H,U){this._documents=H,this._provider=U}async provideEvaluatableExpression(H,U,X){const K=this._documents.getDocument(H),ge=i.Position.to(U),Ee=await this._provider.provideEvaluatableExpression(K,ge,X);if(Ee)return i.EvaluatableExpression.from(Ee)}}class P{constructor(H,U){this._documents=H,this._provider=U}async provideInlineValues(H,U,X,K){const ge=this._documents.getDocument(H),Ee=await this._provider.provideInlineValues(ge,i.Range.to(U),i.InlineValueContext.to(X),K);if(Array.isArray(Ee))return Ee.map(ze=>i.InlineValue.from(ze))}}class k{constructor(H,U){this._documents=H,this._provider=U}async provideDocumentHighlights(H,U,X){const K=this._documents.getDocument(H),ge=i.Position.to(U),Ee=await this._provider.provideDocumentHighlights(K,ge,X);if(Array.isArray(Ee))return Ee.map(i.DocumentHighlight.from)}}class z{constructor(H,U){this._documents=H,this._provider=U}async provideMultiDocumentHighlights(H,U,X,K){const ge=this._documents.getDocument(H),Ee=X.map(Ye=>this._documents.getDocument(Ye)),ze=i.Position.to(U),He=await this._provider.provideMultiDocumentHighlights(ge,ze,Ee,K);if(Array.isArray(He))return He.map(i.MultiDocumentHighlight.from)}}class x{constructor(H,U){this._documents=H,this._provider=U}async provideLinkedEditingRanges(H,U,X){const K=this._documents.getDocument(H),ge=i.Position.to(U),Ee=await this._provider.provideLinkedEditingRanges(K,ge,X);if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,c.coalesce)(Ee.ranges.map(i.Range.from)),wordPattern:Ee.wordPattern}}}class F{constructor(H,U){this._documents=H,this._provider=U}async provideReferences(H,U,X,K){const ge=this._documents.getDocument(H),Ee=i.Position.to(U),ze=await this._provider.provideReferences(ge,Ee,X,K);if(Array.isArray(ze))return ze.map(i.location.from)}}class N{static{this._maxCodeActionsPerFile=1e3}constructor(H,U,X,K,ge,Ee,ze){this._documents=H,this._commands=U,this._diagnostics=X,this._provider=K,this._logService=ge,this._extension=Ee,this._apiDeprecation=ze,this._cache=new t.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(H,U,X,K){const ge=this._documents.getDocument(H),Ee=S.Selection.isISelection(U)?i.Selection.to(U):i.Range.to(U),ze=[];for(const st of this._diagnostics.getDiagnostics(H))if(Ee.intersection(st.range)&&ze.push(st)>N._maxCodeActionsPerFile)break;const He={diagnostics:ze,only:X.only?new r.CodeActionKind(X.only):void 0,triggerKind:i.CodeActionTriggerKind.to(X.trigger)},Ye=await this._provider.provideCodeActions(ge,Ee,He,K);if(!(0,c.isNonEmptyArray)(Ye)||K.isCancellationRequested)return;const it=this._cache.add(Ye),rt=new b.DisposableStore;this._disposables.set(it,rt);const at=[];for(let st=0;st<Ye.length;st++){const De=Ye[st];if(De)if(N._isCommand(De))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:De.title,command:this._commands.toInternal(De,rt)});else{He.only&&(De.kind?He.only.contains(De.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action is of kind '${De.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Be=De.ranges??[];at.push({cacheId:[it,st],title:De.title,command:De.command&&this._commands.toInternal(De.command,rt),diagnostics:De.diagnostics&&De.diagnostics.map(i.Diagnostic.from),edit:De.edit&&i.WorkspaceEdit.from(De.edit,void 0),kind:De.kind&&De.kind.value,isPreferred:De.isPreferred,isAI:(0,s.isProposedApiEnabled)(this._extension,"codeActionAI")?De.isAI:!1,ranges:(0,s.isProposedApiEnabled)(this._extension,"codeActionRanges")?(0,c.coalesce)(Be.map(i.Range.from)):void 0,disabled:De.disabled?.reason})}}return{cacheId:it,actions:at}}async resolveCodeAction(H,U){const[X,K]=H,ge=this._cache.get(X,K);if(!ge||N._isCommand(ge))return{};if(!this._provider.resolveCodeAction)return{};const Ee=await this._provider.resolveCodeAction(ge,U)??ge;let ze;Ee.edit&&(ze=i.WorkspaceEdit.from(Ee.edit,void 0));let He;if(Ee.command){const Ye=this._disposables.get(X);Ye&&(He=this._commands.toInternal(Ee.command,Ye))}return{edit:ze,command:He}}releaseCodeActions(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}static _isCommand(H){return typeof H.command=="string"&&typeof H.title=="string"}}class M{constructor(H,U,X,K,ge){this._proxy=H,this._documents=U,this._provider=X,this._handle=K,this._extension=ge,this._cache=new t.Cache("DocumentPasteEdit")}async prepareDocumentPaste(H,U,X,K){if(!this._provider.prepareDocumentPaste)return;const ge=this._documents.getDocument(H),Ee=U.map(Ye=>i.Range.to(Ye)),ze=i.DataTransfer.toDataTransfer(X,()=>{throw new T.NotImplementedError});if(await this._provider.prepareDocumentPaste(ge,Ee,ze,K),K.isCancellationRequested)return;const He=Array.from(ze).filter(([,Ye])=>!(Ye instanceof r.InternalDataTransferItem));return i.DataTransfer.from(He)}async providePasteEdits(H,U,X,K,ge,Ee){if(!this._provider.provideDocumentPasteEdits)return[];const ze=this._documents.getDocument(U),He=X.map(at=>i.Range.to(at)),Ye=i.DataTransfer.toDataTransfer(K,async at=>(await this._proxy.$resolvePasteFileData(this._handle,H,at)).buffer),it=await this._provider.provideDocumentPasteEdits(ze,He,Ye,{only:ge.only?new r.DocumentPasteEditKind(ge.only):void 0,triggerKind:ge.triggerKind},Ee);if(!it||Ee.isCancellationRequested)return[];const rt=this._cache.add(it);return it.map((at,st)=>({_cacheId:[rt,st],title:at.title??(0,o.localize)(0,null,this._extension.displayName||this._extension.name),kind:at.kind,yieldTo:at.yieldTo?.map(De=>De.value),insertText:typeof at.insertText=="string"?at.insertText:{snippet:at.insertText.value},additionalEdit:at.additionalEdit?i.WorkspaceEdit.from(at.additionalEdit,void 0):void 0}))}async resolvePasteEdit(H,U){const[X,K]=H,ge=this._cache.get(X,K);if(!ge||!this._provider.resolveDocumentPasteEdit)return{};const Ee=await this._provider.resolveDocumentPasteEdit(ge,U)??ge;return{additionalEdit:Ee.additionalEdit?i.WorkspaceEdit.from(Ee.additionalEdit,void 0):void 0}}releasePasteEdits(H){this._cache.delete(H)}}class B{constructor(H,U){this._documents=H,this._provider=U}async provideDocumentFormattingEdits(H,U,X){const K=this._documents.getDocument(H),ge=await this._provider.provideDocumentFormattingEdits(K,U,X);if(Array.isArray(ge))return ge.map(i.TextEdit.from)}}class W{constructor(H,U){this._documents=H,this._provider=U}async provideDocumentRangeFormattingEdits(H,U,X,K){const ge=this._documents.getDocument(H),Ee=i.Range.to(U),ze=await this._provider.provideDocumentRangeFormattingEdits(ge,Ee,X,K);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(H,U,X,K){(0,I.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ge=this._documents.getDocument(H),Ee=U.map(i.Range.to),ze=await this._provider.provideDocumentRangesFormattingEdits(ge,Ee,X,K);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}}class Y{constructor(H,U){this._documents=H,this._provider=U,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(H,U,X,K,ge){const Ee=this._documents.getDocument(H),ze=i.Position.to(U),He=await this._provider.provideOnTypeFormattingEdits(Ee,ze,X,K,ge);if(Array.isArray(He))return He.map(i.TextEdit.from)}}class Z{constructor(H,U){this._provider=H,this._logService=U,this._cache=new t.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(H,U){const X=await this._provider.provideWorkspaceSymbols(H,U);if(!(0,c.isNonEmptyArray)(X))return{symbols:[]};const K=this._cache.add(X),ge={cacheId:K,symbols:[]};for(let Ee=0;Ee<X.length;Ee++){const ze=X[Ee];if(!ze||!ze.name){this._logService.warn("INVALID SymbolInformation",ze);continue}ge.symbols.push({...i.WorkspaceSymbol.from(ze),cacheId:[K,Ee]})}return ge}async resolveWorkspaceSymbol(H,U){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!H.cacheId)return H;const X=this._cache.get(...H.cacheId);if(X){const K=await this._provider.resolveWorkspaceSymbol(X,U);return K&&(0,p.mixin)(H,i.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(H){this._cache.delete(H)}}class G{static supportsResolving(H){return typeof H.prepareRename=="function"}constructor(H,U,X){this._documents=H,this._provider=U,this._logService=X}async provideRenameEdits(H,U,X,K){const ge=this._documents.getDocument(H),Ee=i.Position.to(U);try{const ze=await this._provider.provideRenameEdits(ge,Ee,X,K);return ze?i.WorkspaceEdit.from(ze):void 0}catch(ze){const He=G._asMessage(ze);return He?{rejectReason:He,edits:void 0}:Promise.reject(ze)}}async resolveRenameLocation(H,U,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const K=this._documents.getDocument(H),ge=i.Position.to(U);try{const Ee=await this._provider.prepareRename(K,ge,X);let ze,He;if(r.Range.isRange(Ee)?(ze=Ee,He=K.getText(Ee)):(0,I.isObject)(Ee)&&(ze=Ee.range,He=Ee.placeholder),!ze||!He)return;if(ze.start.line>ge.line||ze.end.line<ge.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(ze),text:He}}catch(Ee){const ze=G._asMessage(Ee);return ze?{rejectReason:ze,range:void 0,text:void 0}:Promise.reject(Ee)}}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class Q{constructor(H,U,X){this._documents=H,this._provider=U,this._logService=X}async provideNewSymbolNames(H,U,X){const K=this._documents.getDocument(H),ge=i.Range.to(U);try{const Ee=await this._provider.provideNewSymbolNames(K,ge,X);return Ee?Ee.map(ze=>typeof ze=="string"?{newSymbolName:ze}:{newSymbolName:ze.newSymbolName,tags:ze.tags}):void 0}catch(Ee){this._logService.error(Q._asMessage(Ee)??JSON.stringify(Ee,null,"	"));return}}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class re{constructor(H,U){this.resultId=H,this.tokens=U}}class te{constructor(H,U){this._documents=H,this._provider=U,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(H,U,X){const K=this._documents.getDocument(H),ge=U!==0?this._previousResults.get(U):null;let Ee=typeof ge?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(K,ge.resultId,X):await this._provider.provideDocumentSemanticTokens(K,X);return ge&&this._previousResults.delete(U),Ee?(Ee=te._fixProvidedSemanticTokens(Ee),this._send(te._convertToEdits(ge,Ee),Ee)):null}async releaseDocumentSemanticColoring(H){this._previousResults.delete(H)}static _fixProvidedSemanticTokens(H){return te._isSemanticTokens(H)?te._isCorrectSemanticTokens(H)?H:new r.SemanticTokens(new Uint32Array(H.data),H.resultId):te._isSemanticTokensEdits(H)?te._isCorrectSemanticTokensEdits(H)?H:new r.SemanticTokensEdits(H.edits.map(U=>new r.SemanticTokensEdit(U.start,U.deleteCount,U.data?new Uint32Array(U.data):U.data)),H.resultId):H}static _isSemanticTokens(H){return H&&!!H.data}static _isCorrectSemanticTokens(H){return H.data instanceof Uint32Array}static _isSemanticTokensEdits(H){return H&&Array.isArray(H.edits)}static _isCorrectSemanticTokensEdits(H){for(const U of H.edits)if(!(U.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(H,U){if(!te._isSemanticTokens(U)||!H||!H.tokens)return U;const X=H.tokens,K=X.length,ge=U.data,Ee=ge.length;let ze=0;const He=Math.min(K,Ee);for(;ze<He&&X[ze]===ge[ze];)ze++;if(ze===K&&ze===Ee)return new r.SemanticTokensEdits([],U.resultId);let Ye=0;const it=He-ze;for(;Ye<it&&X[K-Ye-1]===ge[Ee-Ye-1];)Ye++;return new r.SemanticTokensEdits([{start:ze,deleteCount:K-ze-Ye,data:ge.subarray(ze,Ee-Ye)}],U.resultId)}_send(H,U){if(te._isSemanticTokens(H)){const X=this._nextResultId++;return this._previousResults.set(X,new re(H.resultId,H.data)),(0,m.encodeSemanticTokensDto)({id:X,type:"full",data:H.data})}if(te._isSemanticTokensEdits(H)){const X=this._nextResultId++;return te._isSemanticTokens(U)?this._previousResults.set(X,new re(U.resultId,U.data)):this._previousResults.set(X,new re(H.resultId)),(0,m.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(H.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}class ve{constructor(H,U){this._documents=H,this._provider=U}async provideDocumentRangeSemanticTokens(H,U,X){const K=this._documents.getDocument(H),ge=await this._provider.provideDocumentRangeSemanticTokens(K,i.Range.to(U),X);return ge?this._send(ge):null}_send(H){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:H.data})}}class Ie{static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}constructor(H,U,X,K,ge){this._documents=H,this._commands=U,this._provider=X,this._apiDeprecation=K,this._extension=ge,this._cache=new t.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(H,U,X,K){const ge=this._documents.getDocument(H),Ee=i.Position.to(U),ze=ge.getWordRangeAtPosition(Ee)||new r.Range(Ee,Ee),He=ze.with({end:Ee}),Ye=new w.StopWatch,it=await this._provider.provideCompletionItems(ge,Ee,K,i.CompletionContext.to(X));if(!it||K.isCancellationRequested)return;const rt=Array.isArray(it)?new r.CompletionList(it):it,at=Ie.supportsResolving(this._provider)?this._cache.add(rt.items):this._cache.add([]),st=new b.DisposableStore;this._disposables.set(at,st);const De=[],Be={x:at,b:De,a:{replace:i.Range.from(ze),insert:i.Range.from(He)},c:rt.isIncomplete||void 0,d:Ye.elapsed()};for(let qe=0;qe<rt.items.length;qe++){const Le=rt.items[qe],Qe=this._convertCompletionItem(Le,[at,qe],He,ze);De.push(Qe)}return Be}async resolveCompletionItem(H,U){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...H);if(!X)return;const K=this._convertCompletionItem(X,H),ge=await this._provider.resolveCompletionItem(X,U);if(!ge)return;const Ee=this._convertCompletionItem(ge,H);return(K.h!==Ee.h||K.i!==Ee.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(K.n!==Ee.n||K.o!==Ee.o||!(0,p.equals)(K.p,Ee.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...K,d:Ee.d,c:Ee.c,l:Ee.l,h:Ee.h,i:Ee.i,n:Ee.n,o:Ee.o,p:Ee.p}}releaseCompletionItems(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}_convertCompletionItem(H,U,X,K){const ge=this._disposables.get(U[0]);if(!ge)throw Error("DisposableStore is missing...");const Ee=this._commands.toInternal(H.command,ge),ze={x:U,a:H.label,b:H.kind!==void 0?i.CompletionItemKind.from(H.kind):void 0,m:H.tags&&H.tags.map(i.CompletionItemTag.from),c:H.detail,d:typeof H.documentation>"u"?void 0:i.MarkdownString.fromStrict(H.documentation),e:H.sortText!==H.label?H.sortText:void 0,f:H.filterText!==H.label?H.filterText:void 0,g:H.preselect||void 0,i:H.keepWhitespace?1:0,k:H.commitCharacters?.join(""),l:H.additionalTextEdits&&H.additionalTextEdits.map(i.TextEdit.from),n:Ee?.$ident,o:Ee?.id,p:Ee?.$ident?void 0:Ee?.arguments};H.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ze.h=H.textEdit.newText):typeof H.insertText=="string"?ze.h=H.insertText:H.insertText instanceof r.SnippetString&&(ze.h=H.insertText.value,ze.i|=4);let He;return H.textEdit?He=H.textEdit.range:H.range&&(He=H.range),r.Range.isRange(He)?ze.j=i.Range.from(He):He&&(!X?.isEqual(He.inserting)||!K?.isEqual(He.replacing))&&(ze.j={insert:i.Range.from(He.inserting),replace:i.Range.from(He.replacing)}),ze}}class J{async provideInlineCompletions(H,U,X,K){}disposeCompletions(H){}handleDidShowCompletionItem(H,U,X){}handlePartialAccept(H,U,X,K){}}class $ extends J{constructor(H,U,X,K){super(),this._extension=H,this._documents=U,this._provider=X,this._commands=K,this._references=new be,this._isAdditionsProposedApiEnabled=(0,s.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[a.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,s.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(H,U,X,K){const ge=this._documents.getDocument(H),Ee=i.Position.to(U),ze=await this._provider.provideInlineCompletionItems(ge,Ee,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:i.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[X.triggerKind]},K);if(!ze||K.isCancellationRequested)return;const He=Array.isArray(ze)?ze:ze.items,Ye=this._isAdditionsProposedApiEnabled?Array.isArray(ze)?[]:ze.commands||[]:[],it=this._isAdditionsProposedApiEnabled&&!Array.isArray(ze)?ze.enableForwardStability:void 0;let rt;return{pid:this._references.createReferenceId({dispose(){rt?.dispose()},items:He}),items:He.map((st,De)=>{let Be;st.command&&(rt||(rt=new b.DisposableStore),Be=this._commands.toInternal(st.command,rt));const qe=st.insertText;return{insertText:typeof qe=="string"?qe:{snippet:qe.value},filterText:st.filterText,range:st.range?i.Range.from(st.range):void 0,command:Be,idx:De,completeBracketPairs:this._isAdditionsProposedApiEnabled?st.completeBracketPairs:!1}}),commands:Ye.map(st=>(rt||(rt=new b.DisposableStore),this._commands.toInternal(st,rt))),suppressSuggestions:!1,enableForwardStability:it}}disposeCompletions(H){this._references.disposeReferenceId(H)?.dispose()}handleDidShowCompletionItem(H,U,X){const K=this._references.get(H)?.items[U];K&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(K,X)}handlePartialAccept(H,U,X,K){const ge=this._references.get(H)?.items[U];ge&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&(this._provider.handleDidPartiallyAcceptCompletionItem(ge,X),this._provider.handleDidPartiallyAcceptCompletionItem(ge,i.PartialAcceptInfo.to(K)))}}class ne{async provideInlineEdits(H,U,X){const K=this._documents.getDocument(H),ge=await this._provider.provideInlineEdit(K,{triggerKind:this.languageTriggerKindToVSCodeTriggerKind[U.triggerKind]},X);if(!ge||X.isCancellationRequested)return;let Ee;const ze=this._references.createReferenceId({dispose(){Ee?.dispose()},item:ge});let He;ge.accepted&&(Ee||(Ee=new b.DisposableStore),He=this._commands.toInternal(ge.accepted,Ee));let Ye;return ge.rejected&&(Ee||(Ee=new b.DisposableStore),Ye=this._commands.toInternal(ge.rejected,Ee)),{pid:ze,text:ge.text,range:i.Range.from(ge.range),accepted:He,rejected:Ye}}disposeEdit(H){this._references.disposeReferenceId(H)?.dispose()}constructor(H,U,X,K){this._documents=U,this._provider=X,this._commands=K,this._references=new be,this.languageTriggerKindToVSCodeTriggerKind={[a.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class be{constructor(){this._references=new Map,this._idPool=1}createReferenceId(H){const U=this._idPool++;return this._references.set(U,H),U}disposeReferenceId(H){const U=this._references.get(H);return this._references.delete(H),U}get(H){return this._references.get(H)}}class Ce{constructor(H,U){this._documents=H,this._provider=U,this._cache=new t.Cache("SignatureHelp")}async provideSignatureHelp(H,U,X,K){const ge=this._documents.getDocument(H),Ee=i.Position.to(U),ze=this.reviveContext(X),He=await this._provider.provideSignatureHelp(ge,Ee,K,ze);if(He){const Ye=this._cache.add([He]);return{...i.SignatureHelp.from(He),id:Ye}}}reviveContext(H){let U;if(H.activeSignatureHelp){const X=i.SignatureHelp.to(H.activeSignatureHelp),K=this._cache.get(H.activeSignatureHelp.id,0);K?(U=K,U.activeSignature=X.activeSignature,U.activeParameter=X.activeParameter):U=X}return{...H,activeSignatureHelp:U}}releaseSignatureHelp(H){this._cache.delete(H)}}class ae{constructor(H,U,X,K,ge){this._documents=H,this._commands=U,this._provider=X,this._logService=K,this._extension=ge,this._cache=new t.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(H,U,X){const K=this._documents.getDocument(H),ge=i.Range.to(U),Ee=await this._provider.provideInlayHints(K,ge,X);if(!Array.isArray(Ee)||Ee.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(U)}`);return}if(X.isCancellationRequested)return;const ze=this._cache.add(Ee);this._disposables.set(ze,new b.DisposableStore);const He={hints:[],cacheId:ze};for(let Ye=0;Ye<Ee.length;Ye++)this._isValidInlayHint(Ee[Ye],ge)&&He.hints.push(this._convertInlayHint(Ee[Ye],[ze,Ye]));return this._logService.trace(`[InlayHints] ${He.hints.length} inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(U)}`),He}async resolveInlayHint(H,U){if(typeof this._provider.resolveInlayHint!="function")return;const X=this._cache.get(...H);if(!X)return;const K=await this._provider.resolveInlayHint(X,U);if(K&&this._isValidInlayHint(K))return this._convertInlayHint(K,H)}releaseHints(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}_isValidInlayHint(H,U){return H.label.length===0||Array.isArray(H.label)&&H.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",H),!1):!(U&&!U.contains(H.position))}_convertInlayHint(H,U){const X=this._disposables.get(U[0]);if(!X)throw Error("DisposableStore is missing...");const K={label:"",cacheId:U,tooltip:i.MarkdownString.fromStrict(H.tooltip),position:i.Position.from(H.position),textEdits:H.textEdits&&H.textEdits.map(i.TextEdit.from),kind:H.kind&&i.InlayHintKind.from(H.kind),paddingLeft:H.paddingLeft,paddingRight:H.paddingRight};if(typeof H.label=="string")K.label=H.label;else{const ge=[];K.label=ge;for(const Ee of H.label){if(!Ee.value){console.warn("INVALID inlay hint, empty label part",this._extension.identifier.value);continue}const ze={label:Ee.value,tooltip:i.MarkdownString.fromStrict(Ee.tooltip)};r.Location.isLocation(Ee.location)&&(ze.location=i.location.from(Ee.location)),Ee.command&&(ze.command=this._commands.toInternal(Ee.command,X)),ge.push(ze)}}return K}}class ce{constructor(H,U){this._documents=H,this._provider=U,this._cache=new t.Cache("DocumentLink")}async provideLinks(H,U){const X=this._documents.getDocument(H),K=await this._provider.provideDocumentLinks(X,U);if(!(!Array.isArray(K)||K.length===0)&&!U.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:K.filter(ce._validateLink).map(i.DocumentLink.from)};{const ge=this._cache.add(K),Ee={links:[],cacheId:ge};for(let ze=0;ze<K.length;ze++){if(!ce._validateLink(K[ze]))continue;const He=i.DocumentLink.from(K[ze]);He.cacheId=[ge,ze],Ee.links.push(He)}return Ee}}}static _validateLink(H){return H.target&&H.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(H,U){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...H);if(!X)return;const K=await this._provider.resolveDocumentLink(X,U);if(!(!K||!ce._validateLink(K)))return i.DocumentLink.from(K)}releaseLinks(H){this._cache.delete(H)}}class se{constructor(H,U){this._documents=H,this._provider=U}async provideColors(H,U){const X=this._documents.getDocument(H),K=await this._provider.provideDocumentColors(X,U);return Array.isArray(K)?K.map(Ee=>({color:i.Color.from(Ee.color),range:i.Range.from(Ee.range)})):[]}async provideColorPresentations(H,U,X){const K=this._documents.getDocument(H),ge=i.Range.to(U.range),Ee=i.Color.to(U.color),ze=await this._provider.provideColorPresentations(Ee,{document:K,range:ge},X);if(Array.isArray(ze))return ze.map(i.ColorPresentation.from)}}class j{constructor(H,U){this._documents=H,this._provider=U}async provideFoldingRanges(H,U,X){const K=this._documents.getDocument(H),ge=await this._provider.provideFoldingRanges(K,U,X);if(Array.isArray(ge))return ge.map(i.FoldingRange.from)}}class ie{constructor(H,U,X){this._documents=H,this._provider=U,this._logService=X}async provideSelectionRanges(H,U,X){const K=this._documents.getDocument(H),ge=U.map(i.Position.to),Ee=await this._provider.provideSelectionRanges(K,ge,X);if(!(0,c.isNonEmptyArray)(Ee))return[];if(Ee.length!==ge.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ze=[];for(let He=0;He<ge.length;He++){const Ye=[];ze.push(Ye);let it=ge[He],rt=Ee[He];for(;;){if(!rt.range.contains(it))throw new Error("INVALID selection range, must contain the previous range");if(Ye.push(i.SelectionRange.from(rt)),!rt.parent)break;it=rt.range,rt=rt.parent}}return ze}}class ue{constructor(H,U){this._documents=H,this._provider=U,this._idPool=new R.IdGenerator(""),this._cache=new Map}async prepareSession(H,U,X){const K=this._documents.getDocument(H),ge=i.Position.to(U),Ee=await this._provider.prepareCallHierarchy(K,ge,X);if(!Ee)return;const ze=this._idPool.nextId();return this._cache.set(ze,new Map),Array.isArray(Ee)?Ee.map(He=>this._cacheAndConvertItem(ze,He)):[this._cacheAndConvertItem(ze,Ee)]}async provideCallsTo(H,U,X){const K=this._itemFromCache(H,U);if(!K)throw new Error("missing call hierarchy item");const ge=await this._provider.provideCallHierarchyIncomingCalls(K,X);if(ge)return ge.map(Ee=>({from:this._cacheAndConvertItem(H,Ee.from),fromRanges:Ee.fromRanges.map(ze=>i.Range.from(ze))}))}async provideCallsFrom(H,U,X){const K=this._itemFromCache(H,U);if(!K)throw new Error("missing call hierarchy item");const ge=await this._provider.provideCallHierarchyOutgoingCalls(K,X);if(ge)return ge.map(Ee=>({to:this._cacheAndConvertItem(H,Ee.to),fromRanges:Ee.fromRanges.map(ze=>i.Range.from(ze))}))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,U){const X=this._cache.get(H),K=i.CallHierarchyItem.from(U,H,X.size.toString(36));return X.set(K._itemId,U),K}_itemFromCache(H,U){return this._cache.get(H)?.get(U)}}class he{constructor(H,U){this._documents=H,this._provider=U,this._idPool=new R.IdGenerator(""),this._cache=new Map}async prepareSession(H,U,X){const K=this._documents.getDocument(H),ge=i.Position.to(U),Ee=await this._provider.prepareTypeHierarchy(K,ge,X);if(!Ee)return;const ze=this._idPool.nextId();return this._cache.set(ze,new Map),Array.isArray(Ee)?Ee.map(He=>this._cacheAndConvertItem(ze,He)):[this._cacheAndConvertItem(ze,Ee)]}async provideSupertypes(H,U,X){const K=this._itemFromCache(H,U);if(!K)throw new Error("missing type hierarchy item");const ge=await this._provider.provideTypeHierarchySupertypes(K,X);if(ge)return ge.map(Ee=>this._cacheAndConvertItem(H,Ee))}async provideSubtypes(H,U,X){const K=this._itemFromCache(H,U);if(!K)throw new Error("missing type hierarchy item");const ge=await this._provider.provideTypeHierarchySubtypes(K,X);if(ge)return ge.map(Ee=>this._cacheAndConvertItem(H,Ee))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,U){const X=this._cache.get(H),K=i.TypeHierarchyItem.from(U,H,X.size.toString(36));return X.set(K._itemId,U),K}_itemFromCache(H,U){return this._cache.get(H)?.get(U)}}class Te{constructor(H,U,X,K,ge){this._proxy=H,this._documents=U,this._provider=X,this._handle=K,this._extension=ge}async provideDocumentOnDropEdits(H,U,X,K,ge){const Ee=this._documents.getDocument(U),ze=i.Position.to(X),He=i.DataTransfer.toDataTransfer(K,async it=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,H,it)).buffer),Ye=await this._provider.provideDocumentDropEdits(Ee,ze,He,ge);if(Ye)return(0,c.asArray)(Ye).map(it=>({title:it.title??(0,o.localize)(1,null,this._extension.displayName||this._extension.name),kind:it.kind?.value,yieldTo:it.yieldTo?.map(rt=>rt.value),insertText:typeof it.insertText=="string"?it.insertText:{snippet:it.insertText.value},additionalEdit:it.additionalEdit?i.WorkspaceEdit.from(it.additionalEdit,void 0):void 0}))}}class me{constructor(H,U){this._documents=H,this._provider=U}async provideMappedEdits(H,U,X,K){const ge=v.URI.revive(H),Ee=this._documents.getDocument(ge),ze=X.documents.map(it=>it.map(rt=>({uri:v.URI.revive(rt.uri),version:rt.version,ranges:rt.ranges.map(at=>i.Range.to(at))}))),He={documents:ze,selections:ze[0]?.[0]?.ranges??[]},Ye=await this._provider.provideMappedEdits(Ee,U,He,K);return Ye?i.WorkspaceEdit.from(Ye):null}}class Pe{constructor(H,U){this.adapter=H,this.extension=U}}class Ae{static{this._handlePool=0}constructor(H,U,X,K,ge,Ee,ze,He){this._uriTransformer=U,this._documents=X,this._commands=K,this._diagnostics=ge,this._logService=Ee,this._apiDeprecation=ze,this._extensionTelemetry=He,this._adapter=new Map,this._proxy=H.getProxy(f.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(H,U){return i.DocumentSelector.from(H,this._uriTransformer,U)}_createDisposable(H){return new r.Disposable(()=>{this._adapter.delete(H),this._proxy.$unregister(H)})}_nextHandle(){return Ae._handlePool++}async _withAdapter(H,U,X,K,ge,Ee=!1){const ze=this._adapter.get(H);if(!ze||!(ze.adapter instanceof U))return K;const He=Date.now();Ee||this._logService.trace(`[${ze.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const Ye=X(ze.adapter,ze.extension);return Promise.resolve(Ye).catch(it=>{(0,T.isCancellationError)(it)||(this._logService.error(`[${ze.extension.identifier.value}] provider FAILED`),this._logService.error(it),this._extensionTelemetry.onExtensionError(ze.extension.identifier,it))}).finally(()=>{Ee||this._logService.trace(`[${ze.extension.identifier.value}] provider DONE after ${Date.now()-He}ms`)}),L.CancellationToken.isCancellationToken(ge)?(0,O.raceCancellationError)(Ye,ge):Ye}_addNewAdapter(H,U){const X=this._nextHandle();return this._adapter.set(X,new Pe(H,U)),X}static _extLabel(H){return H.displayName||H.name}registerDocumentSymbolProvider(H,U,X,K){const ge=this._addNewAdapter(new h(this._documents,X),H),Ee=K&&K.label||Ae._extLabel(H);return this._proxy.$registerDocumentSymbolProvider(ge,this._transformDocumentSelector(U,H),Ee),this._createDisposable(ge)}$provideDocumentSymbols(H,U,X){return this._withAdapter(H,h,K=>K.provideDocumentSymbols(v.URI.revive(U),X),void 0,X)}registerCodeLensProvider(H,U,X){const K=this._nextHandle(),ge=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(K,new Pe(new l(this._documents,this._commands.converter,X,H,this._extensionTelemetry,this._logService),H)),this._proxy.$registerCodeLensSupport(K,this._transformDocumentSelector(U,H),ge);let Ee=this._createDisposable(K);if(ge!==void 0){const ze=X.onDidChangeCodeLenses(He=>this._proxy.$emitCodeLensEvent(ge));Ee=r.Disposable.from(Ee,ze)}return Ee}$provideCodeLenses(H,U,X){return this._withAdapter(H,l,K=>K.provideCodeLenses(v.URI.revive(U),X),void 0,X)}$resolveCodeLens(H,U,X){return this._withAdapter(H,l,K=>K.resolveCodeLens(U,X),void 0,void 0)}$releaseCodeLenses(H,U){this._withAdapter(H,l,X=>Promise.resolve(X.releaseCodeLenses(U)),void 0,void 0)}registerDefinitionProvider(H,U,X){const K=this._addNewAdapter(new d(this._documents,X),H);return this._proxy.$registerDefinitionSupport(K,this._transformDocumentSelector(U,H)),this._createDisposable(K)}$provideDefinition(H,U,X,K){return this._withAdapter(H,d,ge=>ge.provideDefinition(v.URI.revive(U),X,K),[],K)}registerDeclarationProvider(H,U,X){const K=this._addNewAdapter(new g(this._documents,X),H);return this._proxy.$registerDeclarationSupport(K,this._transformDocumentSelector(U,H)),this._createDisposable(K)}$provideDeclaration(H,U,X,K){return this._withAdapter(H,g,ge=>ge.provideDeclaration(v.URI.revive(U),X,K),[],K)}registerImplementationProvider(H,U,X){const K=this._addNewAdapter(new D(this._documents,X),H);return this._proxy.$registerImplementationSupport(K,this._transformDocumentSelector(U,H)),this._createDisposable(K)}$provideImplementation(H,U,X,K){return this._withAdapter(H,D,ge=>ge.provideImplementation(v.URI.revive(U),X,K),[],K)}registerTypeDefinitionProvider(H,U,X){const K=this._addNewAdapter(new E(this._documents,X),H);return this._proxy.$registerTypeDefinitionSupport(K,this._transformDocumentSelector(U,H)),this._createDisposable(K)}$provideTypeDefinition(H,U,X,K){return this._withAdapter(H,E,ge=>ge.provideTypeDefinition(v.URI.revive(U),X,K),[],K)}registerHoverProvider(H,U,X,K){const ge=this._addNewAdapter(new _(this._documents,X),H);return this._proxy.$registerHoverProvider(ge,this._transformDocumentSelector(U,H)),this._createDisposable(ge)}$provideHover(H,U,X,K){return this._withAdapter(H,_,ge=>ge.provideHover(v.URI.revive(U),X,K),void 0,K)}registerEvaluatableExpressionProvider(H,U,X,K){const ge=this._addNewAdapter(new y(this._documents,X),H);return this._proxy.$registerEvaluatableExpressionProvider(ge,this._transformDocumentSelector(U,H)),this._createDisposable(ge)}$provideEvaluatableExpression(H,U,X,K){return this._withAdapter(H,y,ge=>ge.provideEvaluatableExpression(v.URI.revive(U),X,K),void 0,K)}registerInlineValuesProvider(H,U,X,K){const ge=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ee=this._addNewAdapter(new P(this._documents,X),H);this._proxy.$registerInlineValuesProvider(Ee,this._transformDocumentSelector(U,H),ge);let ze=this._createDisposable(Ee);if(ge!==void 0){const He=X.onDidChangeInlineValues(Ye=>this._proxy.$emitInlineValuesEvent(ge));ze=r.Disposable.from(ze,He)}return ze}$provideInlineValues(H,U,X,K,ge){return this._withAdapter(H,P,Ee=>Ee.provideInlineValues(v.URI.revive(U),X,K,ge),void 0,ge)}registerDocumentHighlightProvider(H,U,X){const K=this._addNewAdapter(new k(this._documents,X),H);return this._proxy.$registerDocumentHighlightProvider(K,this._transformDocumentSelector(U,H)),this._createDisposable(K)}registerMultiDocumentHighlightProvider(H,U,X){const K=this._addNewAdapter(new z(this._documents,X),H);return this._proxy.$registerMultiDocumentHighlightProvider(K,this._transformDocumentSelector(U,H)),this._createDisposable(K)}$provideDocumentHighlights(H,U,X,K){return this._withAdapter(H,k,ge=>ge.provideDocumentHighlights(v.URI.revive(U),X,K),void 0,K)}$provideMultiDocumentHighlights(H,U,X,K,ge){return this._withAdapter(H,z,Ee=>Ee.provideMultiDocumentHighlights(v.URI.revive(U),X,K.map(ze=>v.URI.revive(ze)),ge),void 0,ge)}registerLinkedEditingRangeProvider(H,U,X){const K=this._addNewAdapter(new x(this._documents,X),H);return this._proxy.$registerLinkedEditingRangeProvider(K,this._transformDocumentSelector(U,H)),this._createDisposable(K)}$provideLinkedEditingRanges(H,U,X,K){return this._withAdapter(H,x,async ge=>{const Ee=await ge.provideLinkedEditingRanges(v.URI.revive(U),X,K);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?Ae._serializeRegExp(Ee.wordPattern):void 0}},void 0,K)}registerReferenceProvider(H,U,X){const K=this._addNewAdapter(new F(this._documents,X),H);return this._proxy.$registerReferenceSupport(K,this._transformDocumentSelector(U,H)),this._createDisposable(K)}$provideReferences(H,U,X,K,ge){return this._withAdapter(H,F,Ee=>Ee.provideReferences(v.URI.revive(U),X,K,ge),void 0,ge)}registerCodeActionProvider(H,U,X,K){const ge=new b.DisposableStore,Ee=this._addNewAdapter(new N(this._documents,this._commands.converter,this._diagnostics,X,this._logService,H,this._apiDeprecation),H);return this._proxy.$registerQuickFixSupport(Ee,this._transformDocumentSelector(U,H),{providedKinds:K?.providedCodeActionKinds?.map(ze=>ze.value),documentation:K?.documentation?.map(ze=>({kind:ze.kind.value,command:this._commands.converter.toInternal(ze.command,ge)}))},Ae._extLabel(H),!!X.resolveCodeAction),ge.add(this._createDisposable(Ee)),ge}$provideCodeActions(H,U,X,K,ge){return this._withAdapter(H,N,Ee=>Ee.provideCodeActions(v.URI.revive(U),X,K,ge),void 0,ge)}$resolveCodeAction(H,U,X){return this._withAdapter(H,N,K=>K.resolveCodeAction(U,X),{},void 0)}$releaseCodeActions(H,U){this._withAdapter(H,N,X=>Promise.resolve(X.releaseCodeActions(U)),void 0,void 0)}registerDocumentFormattingEditProvider(H,U,X){const K=this._addNewAdapter(new B(this._documents,X),H);return this._proxy.$registerDocumentFormattingSupport(K,this._transformDocumentSelector(U,H),H.identifier,H.displayName||H.name),this._createDisposable(K)}$provideDocumentFormattingEdits(H,U,X,K){return this._withAdapter(H,B,ge=>ge.provideDocumentFormattingEdits(v.URI.revive(U),X,K),void 0,K)}registerDocumentRangeFormattingEditProvider(H,U,X){const K=typeof X.provideDocumentRangesFormattingEdits=="function",ge=this._addNewAdapter(new W(this._documents,X),H);return this._proxy.$registerRangeFormattingSupport(ge,this._transformDocumentSelector(U,H),H.identifier,H.displayName||H.name,K),this._createDisposable(ge)}$provideDocumentRangeFormattingEdits(H,U,X,K,ge){return this._withAdapter(H,W,Ee=>Ee.provideDocumentRangeFormattingEdits(v.URI.revive(U),X,K,ge),void 0,ge)}$provideDocumentRangesFormattingEdits(H,U,X,K,ge){return this._withAdapter(H,W,Ee=>Ee.provideDocumentRangesFormattingEdits(v.URI.revive(U),X,K,ge),void 0,ge)}registerOnTypeFormattingEditProvider(H,U,X,K){const ge=this._addNewAdapter(new Y(this._documents,X),H);return this._proxy.$registerOnTypeFormattingSupport(ge,this._transformDocumentSelector(U,H),K,H.identifier),this._createDisposable(ge)}$provideOnTypeFormattingEdits(H,U,X,K,ge,Ee){return this._withAdapter(H,Y,ze=>ze.provideOnTypeFormattingEdits(v.URI.revive(U),X,K,ge,Ee),void 0,Ee)}registerWorkspaceSymbolProvider(H,U){const X=this._addNewAdapter(new Z(U,this._logService),H);return this._proxy.$registerNavigateTypeSupport(X,typeof U.resolveWorkspaceSymbol=="function"),this._createDisposable(X)}$provideWorkspaceSymbols(H,U,X){return this._withAdapter(H,Z,K=>K.provideWorkspaceSymbols(U,X),{symbols:[]},X)}$resolveWorkspaceSymbol(H,U,X){return this._withAdapter(H,Z,K=>K.resolveWorkspaceSymbol(U,X),void 0,void 0)}$releaseWorkspaceSymbols(H,U){this._withAdapter(H,Z,X=>X.releaseWorkspaceSymbols(U),void 0,void 0)}registerRenameProvider(H,U,X){const K=this._addNewAdapter(new G(this._documents,X,this._logService),H);return this._proxy.$registerRenameSupport(K,this._transformDocumentSelector(U,H),G.supportsResolving(X)),this._createDisposable(K)}$provideRenameEdits(H,U,X,K,ge){return this._withAdapter(H,G,Ee=>Ee.provideRenameEdits(v.URI.revive(U),X,K,ge),void 0,ge)}$resolveRenameLocation(H,U,X,K){return this._withAdapter(H,G,ge=>ge.resolveRenameLocation(v.URI.revive(U),X,K),void 0,K)}registerNewSymbolNamesProvider(H,U,X){const K=this._addNewAdapter(new Q(this._documents,X,this._logService),H);return this._proxy.$registerNewSymbolNamesProvider(K,this._transformDocumentSelector(U,H)),this._createDisposable(K)}$provideNewSymbolNames(H,U,X,K){return this._withAdapter(H,Q,ge=>ge.provideNewSymbolNames(v.URI.revive(U),X,K),void 0,K)}registerDocumentSemanticTokensProvider(H,U,X,K){const ge=this._addNewAdapter(new te(this._documents,X),H),Ee=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ge,this._transformDocumentSelector(U,H),K,Ee);let ze=this._createDisposable(ge);if(Ee){const He=X.onDidChangeSemanticTokens(Ye=>this._proxy.$emitDocumentSemanticTokensEvent(Ee));ze=r.Disposable.from(ze,He)}return ze}$provideDocumentSemanticTokens(H,U,X,K){return this._withAdapter(H,te,ge=>ge.provideDocumentSemanticTokens(v.URI.revive(U),X,K),null,K)}$releaseDocumentSemanticTokens(H,U){this._withAdapter(H,te,X=>X.releaseDocumentSemanticColoring(U),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(H,U,X,K){const ge=this._addNewAdapter(new ve(this._documents,X),H);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ge,this._transformDocumentSelector(U,H),K),this._createDisposable(ge)}$provideDocumentRangeSemanticTokens(H,U,X,K){return this._withAdapter(H,ve,ge=>ge.provideDocumentRangeSemanticTokens(v.URI.revive(U),X,K),null,K)}registerCompletionItemProvider(H,U,X,K){const ge=this._addNewAdapter(new Ie(this._documents,this._commands.converter,X,this._apiDeprecation,H),H);return this._proxy.$registerCompletionsProvider(ge,this._transformDocumentSelector(U,H),K,Ie.supportsResolving(X),H.identifier),this._createDisposable(ge)}$provideCompletionItems(H,U,X,K,ge){return this._withAdapter(H,Ie,Ee=>Ee.provideCompletionItems(v.URI.revive(U),X,K,ge),void 0,ge)}$resolveCompletionItem(H,U,X){return this._withAdapter(H,Ie,K=>K.resolveCompletionItem(U,X),void 0,X)}$releaseCompletionItems(H,U){this._withAdapter(H,Ie,X=>X.releaseCompletionItems(U),void 0,void 0)}registerInlineCompletionsProvider(H,U,X,K){const ge=new $(H,this._documents,X,this._commands.converter),Ee=this._addNewAdapter(ge,H);return this._proxy.$registerInlineCompletionsSupport(Ee,this._transformDocumentSelector(U,H),ge.supportsHandleEvents,n.ExtensionIdentifier.toKey(H.identifier.value),K?.yieldTo?.map(ze=>n.ExtensionIdentifier.toKey(ze))||[]),this._createDisposable(Ee)}$provideInlineCompletions(H,U,X,K,ge){return this._withAdapter(H,J,Ee=>Ee.provideInlineCompletions(v.URI.revive(U),X,K,ge),void 0,ge)}$handleInlineCompletionDidShow(H,U,X,K){this._withAdapter(H,J,async ge=>{ge.handleDidShowCompletionItem(U,X,K)},void 0,void 0)}$handleInlineCompletionPartialAccept(H,U,X,K,ge){this._withAdapter(H,J,async Ee=>{Ee.handlePartialAccept(U,X,K,ge)},void 0,void 0)}$freeInlineCompletionsList(H,U){this._withAdapter(H,J,async X=>{X.disposeCompletions(U)},void 0,void 0)}registerInlineEditProvider(H,U,X){const K=new ne(H,this._documents,X,this._commands.converter),ge=this._addNewAdapter(K,H);return this._proxy.$registerInlineEditProvider(ge,this._transformDocumentSelector(U,H),H.identifier),this._createDisposable(ge)}$provideInlineEdit(H,U,X,K){return this._withAdapter(H,ne,ge=>ge.provideInlineEdits(v.URI.revive(U),X,K),void 0,K)}$freeInlineEdit(H,U){this._withAdapter(H,ne,async X=>{X.disposeEdit(U)},void 0,void 0)}registerSignatureHelpProvider(H,U,X,K){const ge=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,Ee=this._addNewAdapter(new Ce(this._documents,X),H);return this._proxy.$registerSignatureHelpProvider(Ee,this._transformDocumentSelector(U,H),ge),this._createDisposable(Ee)}$provideSignatureHelp(H,U,X,K,ge){return this._withAdapter(H,Ce,Ee=>Ee.provideSignatureHelp(v.URI.revive(U),X,K,ge),void 0,ge)}$releaseSignatureHelp(H,U){this._withAdapter(H,Ce,X=>X.releaseSignatureHelp(U),void 0,void 0)}registerInlayHintsProvider(H,U,X){const K=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ge=this._addNewAdapter(new ae(this._documents,this._commands.converter,X,this._logService,H),H);this._proxy.$registerInlayHintsProvider(ge,this._transformDocumentSelector(U,H),typeof X.resolveInlayHint=="function",K,Ae._extLabel(H));let Ee=this._createDisposable(ge);if(K!==void 0){const ze=X.onDidChangeInlayHints(He=>this._proxy.$emitInlayHintsEvent(K));Ee=r.Disposable.from(Ee,ze)}return Ee}$provideInlayHints(H,U,X,K){return this._withAdapter(H,ae,ge=>ge.provideInlayHints(v.URI.revive(U),X,K),void 0,K)}$resolveInlayHint(H,U,X){return this._withAdapter(H,ae,K=>K.resolveInlayHint(U,X),void 0,X)}$releaseInlayHints(H,U){this._withAdapter(H,ae,X=>X.releaseHints(U),void 0,void 0)}registerDocumentLinkProvider(H,U,X){const K=this._addNewAdapter(new ce(this._documents,X),H);return this._proxy.$registerDocumentLinkProvider(K,this._transformDocumentSelector(U,H),typeof X.resolveDocumentLink=="function"),this._createDisposable(K)}$provideDocumentLinks(H,U,X){return this._withAdapter(H,ce,K=>K.provideLinks(v.URI.revive(U),X),void 0,X,U.scheme==="output")}$resolveDocumentLink(H,U,X){return this._withAdapter(H,ce,K=>K.resolveLink(U,X),void 0,void 0,!0)}$releaseDocumentLinks(H,U){this._withAdapter(H,ce,X=>X.releaseLinks(U),void 0,void 0,!0)}registerColorProvider(H,U,X){const K=this._addNewAdapter(new se(this._documents,X),H);return this._proxy.$registerDocumentColorProvider(K,this._transformDocumentSelector(U,H)),this._createDisposable(K)}$provideDocumentColors(H,U,X){return this._withAdapter(H,se,K=>K.provideColors(v.URI.revive(U),X),[],X)}$provideColorPresentations(H,U,X,K){return this._withAdapter(H,se,ge=>ge.provideColorPresentations(v.URI.revive(U),X,K),void 0,K)}registerFoldingRangeProvider(H,U,X){const K=this._nextHandle(),ge=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(K,new Pe(new j(this._documents,X),H)),this._proxy.$registerFoldingRangeProvider(K,this._transformDocumentSelector(U,H),H.identifier,ge);let Ee=this._createDisposable(K);if(ge!==void 0){const ze=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ge));Ee=r.Disposable.from(Ee,ze)}return Ee}$provideFoldingRanges(H,U,X,K){return this._withAdapter(H,j,ge=>ge.provideFoldingRanges(v.URI.revive(U),X,K),void 0,K)}registerSelectionRangeProvider(H,U,X){const K=this._addNewAdapter(new ie(this._documents,X,this._logService),H);return this._proxy.$registerSelectionRangeProvider(K,this._transformDocumentSelector(U,H)),this._createDisposable(K)}$provideSelectionRanges(H,U,X,K){return this._withAdapter(H,ie,ge=>ge.provideSelectionRanges(v.URI.revive(U),X,K),[],K)}registerCallHierarchyProvider(H,U,X){const K=this._addNewAdapter(new ue(this._documents,X),H);return this._proxy.$registerCallHierarchyProvider(K,this._transformDocumentSelector(U,H)),this._createDisposable(K)}$prepareCallHierarchy(H,U,X,K){return this._withAdapter(H,ue,ge=>Promise.resolve(ge.prepareSession(v.URI.revive(U),X,K)),void 0,K)}$provideCallHierarchyIncomingCalls(H,U,X,K){return this._withAdapter(H,ue,ge=>ge.provideCallsTo(U,X,K),void 0,K)}$provideCallHierarchyOutgoingCalls(H,U,X,K){return this._withAdapter(H,ue,ge=>ge.provideCallsFrom(U,X,K),void 0,K)}$releaseCallHierarchy(H,U){this._withAdapter(H,ue,X=>Promise.resolve(X.releaseSession(U)),void 0,void 0)}registerTypeHierarchyProvider(H,U,X){const K=this._addNewAdapter(new he(this._documents,X),H);return this._proxy.$registerTypeHierarchyProvider(K,this._transformDocumentSelector(U,H)),this._createDisposable(K)}$prepareTypeHierarchy(H,U,X,K){return this._withAdapter(H,he,ge=>Promise.resolve(ge.prepareSession(v.URI.revive(U),X,K)),void 0,K)}$provideTypeHierarchySupertypes(H,U,X,K){return this._withAdapter(H,he,ge=>ge.provideSupertypes(U,X,K),void 0,K)}$provideTypeHierarchySubtypes(H,U,X,K){return this._withAdapter(H,he,ge=>ge.provideSubtypes(U,X,K),void 0,K)}$releaseTypeHierarchy(H,U){this._withAdapter(H,he,X=>Promise.resolve(X.releaseSession(U)),void 0,void 0)}registerDocumentOnDropEditProvider(H,U,X,K){const ge=this._nextHandle();return this._adapter.set(ge,new Pe(new Te(this._proxy,this._documents,X,ge,H),H)),this._proxy.$registerDocumentOnDropEditProvider(ge,this._transformDocumentSelector(U,H),(0,s.isProposedApiEnabled)(H,"dropMetadata")?K:void 0),this._createDisposable(ge)}$provideDocumentOnDropEdits(H,U,X,K,ge,Ee){return this._withAdapter(H,Te,ze=>Promise.resolve(ze.provideDocumentOnDropEdits(U,v.URI.revive(X),K,ge,Ee)),void 0,void 0)}registerMappedEditsProvider(H,U,X){const K=this._addNewAdapter(new me(this._documents,X),H);return this._proxy.$registerMappedEditsProvider(K,this._transformDocumentSelector(U,H)),this._createDisposable(K)}$provideMappedEdits(H,U,X,K,ge){return this._withAdapter(H,me,Ee=>Promise.resolve(Ee.provideMappedEdits(U,X,K,ge)),null,ge)}registerDocumentPasteEditProvider(H,U,X,K){const ge=this._nextHandle();return this._adapter.set(ge,new Pe(new M(this._proxy,this._documents,X,ge,H),H)),this._proxy.$registerPasteEditProvider(ge,this._transformDocumentSelector(U,H),{supportsCopy:!!X.prepareDocumentPaste,supportsPaste:!!X.provideDocumentPasteEdits,supportsResolve:!!X.resolveDocumentPasteEdit,providedPasteEditKinds:K.providedPasteEditKinds?.map(Ee=>Ee.value),copyMimeTypes:K.copyMimeTypes,pasteMimeTypes:K.pasteMimeTypes}),this._createDisposable(ge)}$prepareDocumentPaste(H,U,X,K,ge){return this._withAdapter(H,M,Ee=>Ee.prepareDocumentPaste(v.URI.revive(U),X,K,ge),void 0,ge)}$providePasteEdits(H,U,X,K,ge,Ee,ze){return this._withAdapter(H,M,He=>He.providePasteEdits(U,v.URI.revive(X),K,ge,Ee,ze),void 0,ze)}$resolvePasteEdit(H,U,X){return this._withAdapter(H,M,K=>K.resolvePasteEdit(U,X),{},void 0)}$releasePasteEdits(H,U){this._withAdapter(H,M,X=>Promise.resolve(X.releasePasteEdits(U)),void 0,void 0)}static _serializeRegExp(H){return{pattern:H.source,flags:H.flags}}static _serializeIndentationRule(H){return{decreaseIndentPattern:Ae._serializeRegExp(H.decreaseIndentPattern),increaseIndentPattern:Ae._serializeRegExp(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?Ae._serializeRegExp(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?Ae._serializeRegExp(H.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(H){return{beforeText:Ae._serializeRegExp(H.beforeText),afterText:H.afterText?Ae._serializeRegExp(H.afterText):void 0,previousLineText:H.previousLineText?Ae._serializeRegExp(H.previousLineText):void 0,action:H.action}}static _serializeOnEnterRules(H){return H.map(Ae._serializeOnEnterRule)}static _serializeAutoClosingPair(H){return{open:H.open,close:H.close,notIn:H.notIn?H.notIn.map(U=>r.SyntaxTokenType.toString(U)):void 0}}static _serializeAutoClosingPairs(H){return H.map(Ae._serializeAutoClosingPair)}setLanguageConfiguration(H,U,X){const{wordPattern:K}=X;if(K&&(0,A.regExpLeadsToEndlessLoop)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this._documents.setWordDefinitionFor(U,K):this._documents.setWordDefinitionFor(U,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const ge=this._nextHandle(),Ee={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Ae._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?Ae._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Ae._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport,autoClosingPairs:X.autoClosingPairs?Ae._serializeAutoClosingPairs(X.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(ge,U,Ee),this._createDisposable(ge)}$setWordDefinitions(H){for(const U of H)this._documents.setWordDefinitionFor(U.languageId,new RegExp(U.regexSource,U.regexFlags))}}e.ExtHostLanguageFeatures=Ae}),define(ye[121],_e([1,0,3,6,16,7,108,25,8,4,222,145,13,5,20,120,12]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageModels=e.IExtHostLanguageModels=void 0,e.IExtHostLanguageModels=(0,C.createDecorator)("IExtHostLanguageModels");class n{constructor(t,f){this.option=t,this.stream=new p.AsyncIterableSource,this.stream=f??new p.AsyncIterableSource}}class i{constructor(){this._responseStreams=new Map,this._defaultStream=new p.AsyncIterableSource,this._isDone=!1,this._isStreaming=!1;const t=this;this.apiObject={stream:t._defaultStream.asyncIterable}}*_streams(){if(this._responseStreams.size>0)for(const[,t]of this._responseStreams)yield t.stream;else yield this._defaultStream}handleFragment(t){if(this._isDone)return;this._isStreaming=!0;let f=this._responseStreams.get(t.index);f||(this._responseStreams.size===0?f=new n(t.index,this._defaultStream):f=new n(t.index),this._responseStreams.set(t.index,f)),f.stream.emitOne(t.part)}get isStreaming(){return this._isStreaming}reject(t){this._isDone=!0;for(const f of this._streams())f.reject(t)}resolve(){this._isDone=!0;for(const t of this._streams())t.resolve()}}let r=class{static{o=this}static{this._idPool=1}constructor(t,f,h){this._logService=f,this._extHostAuthentication=h,this._onDidChangeModelAccess=new w.Emitter,this._onDidChangeProviders=new w.Emitter,this.onDidChangeProviders=this._onDidChangeProviders.event,this._languageModels=new Map,this._allLanguageModelData=new Map,this._modelAccessList=new b.ExtensionIdentifierMap,this._pendingRequest=new Map,this._languageAccessInformationExtensions=new Set,this._proxy=t.getProxy(O.MainContext.MainThreadLanguageModels)}dispose(){this._onDidChangeModelAccess.dispose(),this._onDidChangeProviders.dispose()}registerLanguageModel(t,f,h,l){const u=o._idPool++;this._languageModels.set(u,{extension:t.identifier,provider:h,languageModelId:f});let d;return l.auth&&(d={providerLabel:t.displayName||t.name,accountLabel:typeof l.auth=="object"?l.auth.label:void 0}),this._proxy.$registerLanguageModelProvider(u,f,{extension:t.identifier,identifier:f,model:l.name??"",auth:d}),(0,c.toDisposable)(()=>{this._languageModels.delete(u),this._proxy.$unregisterProvider(u)})}async $provideLanguageModelResponse(t,f,h,l,u,d){const g=this._languageModels.get(t);if(!g)return;const D=new R.Progress(async E=>{if(d.isCancellationRequested){this._logService.warn(`[CHAT](${g.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this._proxy.$handleProgressChunk(f,{index:E.index,part:E.part})});return g.provider.provideLanguageModelResponse2(l.map(L.LanguageModelMessage.to),u,b.ExtensionIdentifier.toKey(h),D,d)}$updateLanguageModels(t){const f=[],h=[];if(t.added)for(const l of t.added)this._allLanguageModelData.set(l.identifier,l),f.push(l.model);if(t.removed)for(const l of t.removed){this._allLanguageModelData.delete(l),h.push(l);for(const[u,d]of this._pendingRequest)d.languageModelId===l&&(d.res.reject(new v.CancellationError),this._pendingRequest.delete(u))}this._onDidChangeProviders.fire(Object.freeze({added:Object.freeze(f),removed:Object.freeze(h)})),t.added?.forEach(this._fakeAuthPopulate,this)}getLanguageModelIds(){return Array.from(this._allLanguageModelData.keys())}$updateModelAccesslist(t){const f=new Array;for(const{from:h,to:l,enabled:u}of t){const d=this._modelAccessList.get(h)??new b.ExtensionIdentifierSet;if(d.has(l)!==u){u?d.add(l):d.delete(l),this._modelAccessList.set(h,d);const D={from:h,to:l};f.push(D),this._onDidChangeModelAccess.fire(D)}}}async sendChatRequest(t,f,h,l,u){const d=t.identifier,g=await this._proxy.$prepareChatAccess(d,f,l.justification);if(!g||!this._allLanguageModelData.has(f))throw T.LanguageModelError.NotFound(`Language model '${f}' is unknown.`);if(this._isUsingAuth(d,g)&&(!await this._getAuthAccess(t,{identifier:g.extension,displayName:g.auth.providerLabel},l.justification,l.silent)||!this._modelAccessList.get(d)?.has(g.extension)))throw T.LanguageModelError.NoPermissions(`Language model '${f}' cannot be used by '${d.value}'.`);const D=Math.random()*1e6|0,E=this._proxy.$fetchResponse(d,f,D,h.map(L.LanguageModelMessage.from),l.modelOptions??{},u),_=new p.Barrier,y=new i;this._pendingRequest.set(D,{languageModelId:f,res:y});let P;if(E.catch(k=>{_.isOpen()?y.reject(k):P=k}).finally(()=>{this._pendingRequest.delete(D),y.resolve(),_.open()}),await _.wait(),P)throw new T.LanguageModelError(`Language model '${f}' errored, check cause for more details`,"Unknown",P);return y.apiObject}async $handleResponseFragment(t,f){const h=this._pendingRequest.get(t);h&&h.res.handleFragment(f)}async _getAuthAccess(t,f,h,l){const u=I.INTERNAL_AUTH_PROVIDER_PREFIX+f.identifier.value;if(await this._extHostAuthentication.getSession(t,u,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0;if(l)return!1;try{const g=h?(0,A.localize)(0,null,f.displayName,h):(0,A.localize)(1,null,f.displayName);return await this._extHostAuthentication.getSession(t,u,[],{forceNewSession:{detail:g}}),this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0}catch{return!1}}_isUsingAuth(t,f){return!!f.auth&&!b.ExtensionIdentifier.equals(f.extension,t)}async _fakeAuthPopulate(t){for(const f of this._languageAccessInformationExtensions)try{await this._getAuthAccess(f,{identifier:t.extension,displayName:""},void 0,!0)}catch(h){this._logService.error("Fake Auth request failed"),this._logService.error(h)}}createLanguageModelAccessInformation(t){this._languageAccessInformationExtensions.add(t);const f=this,h=w.Event.signal(w.Event.filter(this._onDidChangeModelAccess.event,u=>b.ExtensionIdentifier.equals(u.from,t.identifier))),l=w.Event.signal(this._onDidChangeProviders.event);return{get onDidChange(){return w.Event.any(h,l)},canSendRequest(u){const d=f._allLanguageModelData.get(u);if(!d)return;if(!f._isUsingAuth(t.identifier,d))return!0;const g=f._modelAccessList.get(t.identifier);if(g)return g.has(d.extension)}}}};e.ExtHostLanguageModels=r,e.ExtHostLanguageModels=r=o=Ge([Ue(0,S.IExtHostRpcService),Ue(1,m.ILogService),Ue(2,a.IExtHostAuthentication)],r)}),define(ye[339],_e([1,0,6,16,7,40,8,3,26]),function(de,e,c,O,L,T,R,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class w{constructor(I,v,C,S){this._documents=v,this._commands=C,this._uriTransformer=S,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=I.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(I){this._languageIds=I}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(I,v){await this._proxy.$changeLanguage(I,v);const C=this._documents.getDocumentData(I);if(!C)throw new Error(`document '${I.toString()}' NOT found`);return C.document}async tokenAtPosition(I,v){const C=I.version,S=O.Position.from(v),a=await this._proxy.$tokensAtPosition(I.uri,S),m={type:L.StandardTokenType.Other,range:I.getWordRangeAtPosition(v)??new L.Range(v.line,v.character,v.line,v.character)};if(!a)return m;const o={range:O.Range.to(a.range),type:O.TokenType.to(a.type)};return!o.range.contains(v)||C!==I.version?m:o}createLanguageStatusItem(I,v,C){const S=this._handlePool++,a=this._proxy,m=this._ids,o=`${I.identifier.value}/${v}`;if(m.has(o))throw new Error(`LanguageStatusItem with id '${v}' ALREADY exists`);m.add(o);const n={selector:C,id:v,name:I.displayName??I.name,severity:L.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new b.DisposableStore,s=()=>{if(i?.dispose(),!m.has(o)){console.warn(`LanguageStatusItem (${v}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,R.disposableTimeout)(()=>{r.clear(),this._proxy.$setLanguageStatus(S,{id:o,name:n.name??I.displayName??I.name,source:I.displayName??I.name,selector:O.DocumentSelector.from(n.selector,this._uriTransformer),label:n.text,detail:n.detail??"",severity:n.severity===L.LanguageStatusSeverity.Error?T.default.Error:n.severity===L.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:n.command&&this._commands.toInternal(n.command,r),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){r.dispose(),i?.dispose(),a.$removeLanguageStatus(S),m.delete(o)},get id(){return n.id},get name(){return n.name},set name(f){n.name=f,s()},get selector(){return n.selector},set selector(f){n.selector=f,s()},get text(){return n.text},set text(f){n.text=f,s()},set text2(f){(0,p.checkProposedApiEnabled)(I,"languageStatusText"),n.text=f,s()},get text2(){return(0,p.checkProposedApiEnabled)(I,"languageStatusText"),n.text},get detail(){return n.detail},set detail(f){n.detail=f,s()},get severity(){return n.severity},set severity(f){n.severity=f,s()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(f){n.accessibilityInformation=f,s()},get command(){return n.command},set command(f){n.command=f,s()},get busy(){return n.busy},set busy(f){n.busy=f,s()}};return s(),t}}e.ExtHostLanguages=w}),define(ye[340],_e([1,0,15,2,16,7,119]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class b{constructor(I,v,C,S){this.start=I,this.deletedCount=v,this.deletedItems=C,this.items=S}asApiEvent(){return{range:new T.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(I){return{EOL:I.eol,lines:I.source,languageId:I.language,uri:I.uri,isDirty:!1,versionId:1}}constructor(I,v,C){this.notebook=I,this._extHostDocument=v,this._cellData=C,this.handle=C.handle,this.uri=O.URI.revive(C.uri),this.cellKind=C.cellKind,this._outputs=C.outputs.map(L.NotebookCellOutput.to),this._internalMetadata=C.internalMetadata??{},this._metadata=Object.freeze(C.metadata??{}),this._previousResult=Object.freeze(L.NotebookCellExecutionSummary.to(C.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const I=this,v=this._extHostDocument.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const C={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:L.NotebookCellKind.to(this._cellData.cellKind),document:v.document,get mime(){return I._mime},set mime(S){I._mime=S},get outputs(){return I._outputs.slice(0)},get metadata(){return I._metadata},get executionSummary(){return I._previousResult}};this._apiCell=Object.freeze(C)}return this._apiCell}setOutputs(I){this._outputs=I.map(L.NotebookCellOutput.to)}setOutputItems(I,v,C){const S=C.map(L.NotebookCellOutputItem.to),a=this._outputs.find(m=>m.id===I);if(a&&(v||(a.items.length=0),a.items.push(...S),a.items.length>1&&a.items.every(m=>R.isTextStreamMime(m.mime)))){const m=new Map,o=[];a.items.forEach(n=>{let i;m.has(n.mime)?i=m.get(n.mime):(i=[],m.set(n.mime,i),o.push(n.mime)),i.push(n.data)}),a.items.length=0,o.forEach(n=>{const i=R.compressOutputItemStreams(m.get(n));a.items.push({mime:n,data:i.data.buffer})})}}setMetadata(I){this._metadata=Object.freeze(I)}setInternalMetadata(I){this._internalMetadata=I,this._previousResult=Object.freeze(L.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.ExtHostCell=p;class w{static{this._handlePool=0}constructor(I,v,C,S,a){this._proxy=I,this._textDocumentsAndEditors=v,this._textDocuments=C,this.uri=S,this.handle=w._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=a.viewType,this._metadata=Object.freeze(a.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,a.cells]],!0,void 0),this._versionId=a.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const I=this,v={get uri(){return I.uri},get version(){return I._versionId},get notebookType(){return I._notebookType},get isDirty(){return I._isDirty},get isUntitled(){return I.uri.scheme===c.Schemas.untitled},get isClosed(){return I._disposed},get metadata(){return I._metadata},get cellCount(){return I._cells.length},cellAt(C){return C=I._validateIndex(C),I._cells[C].apiCell},getCells(C){return(C?I._getCells(C):I._cells).map(a=>a.apiCell)},save(){return I._save()}};this._notebook=Object.freeze(v)}return this._notebook}acceptDocumentPropertiesChanged(I){I.metadata&&(this._metadata=Object.freeze({...this._metadata,...I.metadata}))}acceptDirty(I){this._isDirty=I}acceptModelChanged(I,v,C){this._versionId=I.versionId,this._isDirty=v,this.acceptDocumentPropertiesChanged({metadata:C});const S={notebook:this.apiNotebook,metadata:C,cellChanges:[],contentChanges:[]},a=[];for(const o of I.rawEvents)o.kind===R.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1,S.contentChanges):o.kind===R.NotebookCellsChangeType.Move?this._moveCells(o.index,o.length,o.newIdx,S.contentChanges):o.kind===R.NotebookCellsChangeType.Output?(this._setCellOutputs(o.index,o.outputs),a.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems),a.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(o.index,o.language),a.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document})):o.kind===R.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document}):o.kind===R.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(o.index,o.metadata),a.push({cell:this._cells[o.index].apiCell,metadata:this._cells[o.index].apiCell.metadata})):o.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(o.index,o.internalMetadata),a.push({cell:this._cells[o.index].apiCell,executionSummary:this._cells[o.index].apiCell.executionSummary}));const m=new Map;for(let o=0;o<a.length;o++){const n=a[o],i=m.get(n.cell);if(i===void 0){const r=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});m.set(n.cell,r-1)}else S.cellChanges[i]={...S.cellChanges[i],...n}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}_validateIndex(I){return I=I|0,I<0?0:I>=this._cells.length?this._cells.length-1:I}_validateRange(I){let v=I.start|0,C=I.end|0;return v<0&&(v=0),C>this._cells.length&&(C=this._cells.length),I.with({start:v,end:C})}_getCells(I){I=this._validateRange(I);const v=[];for(let C=I.start;C<I.end;C++)v.push(this._cells[C]);return v}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(I,v,C){if(this._disposed)return;const S=[],a=[],m=[];if(I.reverse().forEach(o=>{const i=o[2].map(t=>{const f=new p(this,this._textDocumentsAndEditors,t);return v||a.push(p.asModelAddData(t)),f}),r=new b(o[0],o[1],[],i),s=this._cells.splice(o[0],o[1],...i);for(const t of s)m.push(t.uri),r.deletedItems.push(t.apiCell);S.push(r)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:m}),C)for(const o of S)C.push(o.asApiEvent())}_moveCells(I,v,C,S){const a=this._cells.splice(I,v);this._cells.splice(C,0,...a);const m=[new b(I,v,a.map(o=>o.apiCell),[]),new b(C,0,[],a)];for(const o of m)S.push(o.asApiEvent())}_setCellOutputs(I,v){this._cells[I].setOutputs(v)}_setCellOutputItems(I,v,C,S){this._cells[I].setOutputItems(v,C,S)}_changeCellLanguage(I,v){const C=this._cells[I];C.apiCell.document.languageId!==v&&this._textDocuments.$acceptModelLanguageChanged(C.uri,v)}_changeCellMime(I,v){const C=this._cells[I];C.apiCell.mime=v}_changeCellMetadata(I,v){this._cells[I].setMetadata(v)}_changeCellInternalMetadata(I,v){this._cells[I].setInternalMetadata(v)}getCellFromApiCell(I){return this._cells.find(v=>v.apiCell===I)}getCellFromIndex(I){return this._cells[I]}getCell(I){return this._cells.find(v=>v.handle===I)}getCellIndex(I){return this._cells.indexOf(I)}}e.ExtHostNotebookDocument=w}),define(ye[341],_e([1,0,4,2,16,7]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class R{constructor(p,w,A,I={timeout:1500,errors:3}){this._logService=p,this._notebooksAndEditors=w,this._mainThreadBulkEdits=A,this._thresholds=I,this._onWillSaveNotebookDocumentEvent=new c.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(p){return(w,A,I)=>{const v=function(S){w.call(A,S)};return v.extension=p,this._onWillSaveNotebookDocumentEvent.event(v,void 0,I)}}async $participateInSave(p,w,A){const I=O.URI.revive(p),v=this._notebooksAndEditors.getNotebookDocument(I);if(!v)throw new Error("Unable to resolve notebook document");const C=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:v.apiNotebook,reason:L.TextDocumentSaveReason.to(w)},A,async(a,m)=>{const o=Date.now(),n=await await Promise.resolve(a);Date.now()-o>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier),!A.isCancellationRequested&&n&&(n instanceof T.WorkspaceEdit?C.push(n):this._logService.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(C.length===0)return!0;const S={edits:[]};for(const a of C){const{edits:m}=L.WorkspaceEdit.from(a);S.edits=S.edits.concat(m)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(S)}}e.ExtHostNotebookDocumentSaveParticipant=R}),define(ye[153],_e([1,0,13,16,7]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,p,w,A,I,v){this.id=b,this._proxy=p,this.notebookData=w,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=I,this._visibleRanges=A,this._viewColumn=v}get apiEditor(){if(!this._editor){const b=this;this._editor={get notebook(){return b.notebookData.apiNotebook},get selection(){return b._selections[0]},set selection(p){this.selections=[p]},get selections(){return b._selections},set selections(p){if(!Array.isArray(p)||!p.every(L.NotebookRange.isNotebookRange))throw(0,c.illegalArgument)("selections");b._selections=p,b._trySetSelections(p)},get visibleRanges(){return b._visibleRanges},revealRange(p,w){b._proxy.$tryRevealRange(b.id,O.NotebookRange.from(p),w??L.NotebookEditorRevealType.Default)},get viewColumn(){return b._viewColumn}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(b){this._visible=b}_acceptVisibleRanges(b){this._visibleRanges=b}_acceptSelections(b){this._selections=b}_trySetSelections(b){this._proxy.$trySetSelections(this.id,b.map(O.NotebookRange.from))}_acceptViewColumn(b){this._viewColumn=b}}e.ExtHostNotebookEditor=T}),define(ye[342],_e([1,0,4,12,16]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let T=class{constructor(b,p){this._logService=b,this._notebooksAndEditors=p,this._onDidChangeNotebookEditorSelection=new c.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new c.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(b,p){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,p);const w=this._notebooksAndEditors.getEditorById(b);p.visibleRanges&&w._acceptVisibleRanges(p.visibleRanges.ranges.map(L.NotebookRange.to)),p.selections&&w._acceptSelections(p.selections.selections.map(L.NotebookRange.to)),p.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:w.apiEditor,visibleRanges:w.apiEditor.visibleRanges}),p.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:w.apiEditor,selections:w.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const p in b)this._notebooksAndEditors.getEditorById(p)._acceptViewColumn(L.ViewColumn.to(b[p]))}};e.ExtHostNotebookEditors=T,e.ExtHostNotebookEditors=T=Ge([Ue(0,O.ILogService)],T)}),define(ye[343],_e([1,0,4,6,153]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class T{constructor(b,p){this._extHostNotebook=p,this._rendererMessageEmitters=new Map,this.proxy=b.getProxy(O.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(b,p,w){const A=this._extHostNotebook.getEditorById(b);this._rendererMessageEmitters.get(p)?.fire({editor:A.apiEditor,message:w})}createRendererMessaging(b,p){if(!b.contributes?.notebookRenderer?.some(A=>A.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(A,I,v)=>this.getOrCreateEmitterFor(p).event(A,I,v),postMessage:(A,I)=>{L.ExtHostNotebookEditor.apiEditorsToExtHost.has(A)&&([A,I]=[I,A]);const v=I&&L.ExtHostNotebookEditor.apiEditorsToExtHost.get(I);return this.proxy.$postMessage(v?.id,p,A)}}}getOrCreateEmitterFor(b){let p=this._rendererMessageEmitters.get(b);return p||(p=new c.Emitter({onDidRemoveLastListener:()=>{p?.dispose(),this._rendererMessageEmitters.delete(b)}}),this._rendererMessageEmitters.set(b,p),p)}}e.ExtHostNotebookRenderers=T}),define(ye[344],_e([1,0,16,108,22,54,13]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class b{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}async withProgress(I,v,C){const S=this._handles++,{title:a,location:m,cancellable:o}=v,n={label:I.displayName||I.name,id:I.identifier.value};return this._proxy.$startProgress(S,{location:c.ProgressLocation.from(m),title:a,source:n,cancellable:o},I.isUnderDevelopment?void 0:I.identifier.value).catch(R.onUnexpectedExternalError),this._withProgress(S,C,!!o)}_withProgress(I,v,C){let S;C&&(S=new L.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,S));const a=o=>{this._proxy.$progressEnd(o),this._mapHandleToCancellationSource.delete(o),S?.dispose()};let m;try{m=v(new w(this._proxy,I),C&&S?S.token:L.CancellationToken.None)}catch(o){throw a(I),o}return m.then(o=>a(I),o=>a(I)),m}$acceptProgressCanceled(I){const v=this._mapHandleToCancellationSource.get(I);v&&(v.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=b;function p(A,I){return A.message=I.message,typeof I.increment=="number"&&(typeof A.increment=="number"?A.increment+=I.increment:A.increment=I.increment),A}class w extends O.Progress{constructor(I,v){super(C=>this.throttledReport(C)),this._proxy=I,this._handle=v}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}Ge([(0,T.throttle)(100,(A,I)=>p(A,I),()=>Object.create(null))],w.prototype,"throttledReport",null)}),define(ye[345],_e([1,0,2,6,8,16]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class R{static{this.handlePool=0}constructor(p,w){this.uriTransformer=w,this.providers=new Map,this.proxy=p.getProxy(O.MainContext.MainThreadQuickDiff)}$provideOriginalResource(p,w,A){const I=c.URI.revive(w),v=this.providers.get(p);return v?(0,L.asPromise)(()=>v.provideOriginalResource(I,A)).then(C=>C||null):Promise.resolve(null)}registerQuickDiffProvider(p,w,A,I){const v=R.handlePool++;return this.providers.set(v,w),this.proxy.$registerQuickDiffProvider(v,T.DocumentSelector.from(p,this.uriTransformer),A,I),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(v),this.providers.delete(v)}}}}e.ExtHostQuickDiff=R}),define(ye[346],_e([1,0,22,4,3,6,2,7,13,19,40,56,26,16]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=S;function S(a,m,o){const n=a.getProxy(T.MainContext.MainThreadQuickOpen);class i{constructor(g,D){this._sessions=new Map,this._instances=0,this._workspace=g,this._commands=D}showQuickPick(g,D,E,_=c.CancellationToken.None){this._onDidSelectItem=void 0;const y=Promise.resolve(D),P=++this._instances,k=n.$show(P,{title:E?.title,placeHolder:E?.placeHolder,matchOnDescription:E?.matchOnDescription,matchOnDetail:E?.matchOnDetail,ignoreFocusLost:E?.ignoreFocusOut,canPickMany:E?.canPickMany},_),z={},x=k.then(()=>z);return Promise.race([x,y]).then(F=>{if(F===z)return;const N=(0,v.isProposedApiEnabled)(g,"quickPickItemTooltip");return y.then(M=>{const B=[];for(let W=0;W<M.length;W++){const Y=M[W];if(typeof Y=="string")B.push({label:Y,handle:W});else if(Y.kind===b.QuickPickItemKind.Separator)B.push({type:"separator",label:Y.label});else{Y.tooltip&&!N&&console.warn(`Extension '${g.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${g.identifier.value}`);const Z=Y.iconPath?h(Y.iconPath):void 0;B.push({label:Y.label,iconPath:Z?.iconPath,iconClass:Z?.iconClass,description:Y.description,detail:Y.detail,picked:Y.picked,alwaysShow:Y.alwaysShow,tooltip:N?C.MarkdownString.fromStrict(Y.tooltip):void 0,handle:W})}}return E&&typeof E.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{E.onDidSelectItem(M[W])}),n.$setItems(P,B),k.then(W=>{if(typeof W=="number")return M[W];if(Array.isArray(W))return W.map(Y=>M[Y])})})}).then(void 0,F=>{if(!(0,p.isCancellationError)(F))return n.$setError(P,F),Promise.reject(F)})}$onItemSelected(g){this._onDidSelectItem?.(g)}showInput(g,D=c.CancellationToken.None){return this._validateInput=g?.validateInput,n.$input(g,typeof this._validateInput=="function",D).then(void 0,E=>{if(!(0,p.isCancellationError)(E))return Promise.reject(E)})}async $validateInput(g){if(!this._validateInput)return;const D=await this._validateInput(g);if(!D||typeof D=="string")return D;let E;switch(D.severity){case b.InputBoxValidationSeverity.Info:E=A.default.Info;break;case b.InputBoxValidationSeverity.Warning:E=A.default.Warning;break;case b.InputBoxValidationSeverity.Error:E=A.default.Error;break;default:E=D.message?A.default.Error:A.default.Ignore;break}return{content:D.message,severity:E}}async showWorkspaceFolderPick(g,D=c.CancellationToken.None){const E=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[g]);if(!E)return;const _=await this._workspace.getWorkspaceFolders2();if(_)return _.find(y=>y.uri.toString()===E.uri.toString())}createQuickPick(g){const D=new l(g,()=>this._sessions.delete(D._id));return this._sessions.set(D._id,D),D}createInputBox(g){const D=new u(g,()=>this._sessions.delete(D._id));return this._sessions.set(D._id,D),D}$onDidChangeValue(g,D){this._sessions.get(g)?._fireDidChangeValue(D)}$onDidAccept(g){this._sessions.get(g)?._fireDidAccept()}$onDidChangeActive(g,D){const E=this._sessions.get(g);E instanceof l&&E._fireDidChangeActive(D)}$onDidChangeSelection(g,D){const E=this._sessions.get(g);E instanceof l&&E._fireDidChangeSelection(D)}$onDidTriggerButton(g,D){this._sessions.get(g)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(g,D,E){const _=this._sessions.get(g);_ instanceof l&&_._fireDidTriggerItemButton(D,E)}$onDidHide(g){this._sessions.get(g)?._fireDidHide()}}class r{static{this._nextId=1}constructor(g,D){this._extensionId=g,this._onDidDispose=D,this._id=l._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new O.Emitter,this._onDidChangeValueEmitter=new O.Emitter,this._onDidTriggerButtonEmitter=new O.Emitter,this._onDidHideEmitter=new O.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(g){this._title=g,this.update({title:g})}get step(){return this._steps}set step(g){this._steps=g,this.update({step:g})}get totalSteps(){return this._totalSteps}set totalSteps(g){this._totalSteps=g,this.update({totalSteps:g})}get enabled(){return this._enabled}set enabled(g){this._enabled=g,this.update({enabled:g})}get busy(){return this._busy}set busy(g){this._busy=g,this.update({busy:g})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(g){this._ignoreFocusOut=g,this.update({ignoreFocusOut:g})}get value(){return this._value}set value(g){this._value=g,this.update({value:g})}get placeholder(){return this._placeholder}set placeholder(g){this._placeholder=g,this.update({placeholder:g})}get buttons(){return this._buttons}set buttons(g){this._buttons=g.slice(),this._handlesToButtons.clear(),g.forEach((D,E)=>{const _=D===b.QuickInputButtons.Back?-1:E;this._handlesToButtons.set(_,D)}),this.update({buttons:g.map((D,E)=>({...h(D.iconPath),tooltip:D.tooltip,handle:D===b.QuickInputButtons.Back?-1:E}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(g){this._value=g,this._onDidChangeValueEmitter.fire(g)}_fireDidTriggerButton(g){const D=this._handlesToButtons.get(g);D&&this._onDidTriggerButtonEmitter.fire(D)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,L.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),n.$dispose(this._id))}update(g){if(!this._disposed){for(const D of Object.keys(g)){const E=g[D];this._pendingUpdate[D]=E===void 0?null:E}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){n.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function s(d){if(d instanceof b.ThemeIcon)return{id:d.id};const g=f(d),D=t(d);return{dark:typeof g=="string"?R.URI.file(g):g,light:typeof D=="string"?R.URI.file(D):D}}function t(d){return typeof d=="object"&&"light"in d?d.light:d}function f(d){return typeof d=="object"&&"dark"in d?d.dark:d}function h(d){const g=s(d);let D,E;return"id"in g?E=I.ThemeIcon.asClassName(g):D=g,{iconPath:D,iconClass:E}}class l extends r{constructor(g,D){super(g.identifier,D),this.extension=g,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new O.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new O.Emitter,this._onDidTriggerItemButtonEmitter=new O.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(g){this._items=g.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),g.forEach((_,y)=>{this._handlesToItems.set(y,_),this._itemsToHandles.set(_,y)});const D=(0,v.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),E=[];for(let _=0;_<g.length;_++){const y=g[_];if(y.kind===b.QuickPickItemKind.Separator)E.push({type:"separator",label:y.label});else{y.tooltip&&!D&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const P=y.iconPath?h(y.iconPath):void 0;E.push({handle:_,label:y.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:D?C.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((k,z)=>({...h(k.iconPath),tooltip:k.tooltip,handle:z}))})}}this.update({items:E})}get canSelectMany(){return this._canSelectMany}set canSelectMany(g){this._canSelectMany=g,this.update({canSelectMany:g})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(g){this._matchOnDescription=g,this.update({matchOnDescription:g})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(g){this._matchOnDetail=g,this.update({matchOnDetail:g})}get sortByLabel(){return this._sortByLabel}set sortByLabel(g){this._sortByLabel=g,this.update({sortByLabel:g})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(g){this._keepScrollPosition=g,this.update({keepScrollPosition:g})}get activeItems(){return this._activeItems}set activeItems(g){this._activeItems=g.filter(D=>this._itemsToHandles.has(D)),this.update({activeItems:this._activeItems.map(D=>this._itemsToHandles.get(D))})}get selectedItems(){return this._selectedItems}set selectedItems(g){this._selectedItems=g.filter(D=>this._itemsToHandles.has(D)),this.update({selectedItems:this._selectedItems.map(D=>this._itemsToHandles.get(D))})}_fireDidChangeActive(g){const D=(0,w.coalesce)(g.map(E=>this._handlesToItems.get(E)));this._activeItems=D,this._onDidChangeActiveEmitter.fire(D)}_fireDidChangeSelection(g){const D=(0,w.coalesce)(g.map(E=>this._handlesToItems.get(E)));this._selectedItems=D,this._onDidChangeSelectionEmitter.fire(D)}_fireDidTriggerItemButton(g,D){const E=this._handlesToItems.get(g);if(!E||!E.buttons||!E.buttons.length)return;const _=E.buttons[D];_&&this._onDidTriggerItemButtonEmitter.fire({button:_,item:E})}}class u extends r{constructor(g,D){super(g.identifier,D),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(g){this._password=g,this.update({password:g})}get prompt(){return this._prompt}set prompt(g){this._prompt=g,this.update({prompt:g})}get valueSelection(){return this._valueSelection}set valueSelection(g){this._valueSelection=g,this.update({valueSelection:g})}get validationMessage(){return this._validationMessage}set validationMessage(g){this._validationMessage=g,g?typeof g=="string"?this.update({validationMessage:g,severity:A.default.Error}):this.update({validationMessage:g.message,severity:g.severity??A.default.Error}):this.update({validationMessage:void 0,severity:A.default.Ignore})}}return new i(m,o)}}),define(ye[347],_e([1,0,2,4,54,3,8,6,19,131,12,25,56,16,26,15,11]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function n(P){return P instanceof c.URI}function i(P,k){return P.scheme===a.Schemas.file&&k.scheme===a.Schemas.file&&m.isLinux?P.toString()===k.toString():P.toString().toLowerCase()===k.toString().toLowerCase()}function r(P){if(P)return typeof P.iconPath=="string"?c.URI.file(P.iconPath):c.URI.isUri(P.iconPath)||v.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function s(P){if(P.icon){if(c.URI.isUri(P.icon))return P.icon;if(v.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const k=P.icon;return{light:k.light,dark:k.dark}}}else return}function t(P,k){if(!P.iconPath&&!k.iconPath)return 0;if(P.iconPath){if(!k.iconPath)return 1}else return-1;const z=typeof P.iconPath=="string"?P.iconPath:c.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,x=typeof k.iconPath=="string"?k.iconPath:c.URI.isUri(k.iconPath)?k.iconPath.fsPath:k.iconPath.id;return(0,w.comparePaths)(z,x)}function f(P,k){let z=0;if(P.strikeThrough!==k.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==k.faded)return P.faded?1:-1;if(P.tooltip!==k.tooltip)return(P.tooltip||"").localeCompare(k.tooltip||"");if(z=t(P,k),z!==0)return z;if(P.light&&k.light)z=t(P.light,k.light);else{if(P.light)return 1;if(k.light)return-1}if(z!==0)return z;if(P.dark&&k.dark)z=t(P.dark,k.dark);else{if(P.dark)return 1;if(k.dark)return-1}return z}function h(P,k){if(P.command!==k.command)return P.command<k.command?-1:1;if(P.title!==k.title)return P.title<k.title?-1:1;if(P.tooltip!==k.tooltip){if(P.tooltip!==void 0&&k.tooltip!==void 0)return P.tooltip<k.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(k.tooltip!==void 0)return-1}if(P.arguments===k.arguments)return 0;if(P.arguments)if(k.arguments){if(P.arguments.length!==k.arguments.length)return P.arguments.length-k.arguments.length}else return 1;else return-1;for(let z=0;z<P.arguments.length;z++){const x=P.arguments[z],F=k.arguments[z];if(x!==F&&!(n(x)&&n(F)&&i(x,F)))return x<F?-1:1}return 0}function l(P,k){let z=(0,w.comparePaths)(P.resourceUri.fsPath,k.resourceUri.fsPath,!0);if(z!==0)return z;if(P.command&&k.command)z=h(P.command,k.command);else{if(P.command)return 1;if(k.command)return-1}if(z!==0)return z;if(P.decorations&&k.decorations)z=f(P.decorations,k.decorations);else{if(P.decorations)return 1;if(k.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&k.multiFileDiffEditorModifiedUri)z=(0,w.comparePaths)(P.multiFileDiffEditorModifiedUri.fsPath,k.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(k.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&k.multiDiffEditorOriginalUri)z=(0,w.comparePaths)(P.multiDiffEditorOriginalUri.fsPath,k.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(k.multiDiffEditorOriginalUri)return-1}return z}function u(P,k){for(let z=0;z<P.length;z++)if(P[z]!==k[z])return!1;return!0}function d(P,k){return P.command===k.command&&P.title===k.title&&P.tooltip===k.tooltip&&(P.arguments&&k.arguments?u(P.arguments,k.arguments):P.arguments===k.arguments)}function g(P,k){return(0,p.equals)(P,k,d)}class D{#e;#t;get value(){return this._value}set value(k){k=k??"",this.#e.$setInputBoxValue(this._sourceControlHandle,k),this.updateValue(k)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(k){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,k),this._placeholder=k}get validateInput(){return(0,S.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(k){if((0,S.checkProposedApiEnabled)(this._extension,"scmValidation"),k&&typeof k!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=k,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!k)}get enabled(){return this._enabled}set enabled(k){k=!!k,this._enabled!==k&&(this._enabled=k,this.#e.$setInputBoxEnablement(this._sourceControlHandle,k))}get visible(){return this._visible}set visible(k){k=!!k,this._visible!==k&&(this._visible=k,this.#e.$setInputBoxVisibility(this._sourceControlHandle,k))}get document(){return(0,S.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(k,z,x,F,N){this._extension=k,this._sourceControlHandle=F,this._documentUri=N,this._value="",this._onDidChange=new O.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=z,this.#e=x}showValidationMessage(k,z){(0,S.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,k,z)}$onInputBoxValueChange(k){this.updateValue(k)}updateValue(k){this._value=k,this._onDidChange.fire(k)}}e.ExtHostSCMInputBox=D;class E{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(k){this._label=k,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,k)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(k){this._hideWhenEmpty=k,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(k){this._resourceStates=[...k],this._onDidUpdateResourceStates.fire()}constructor(k,z,x,F,N,M,B){this._proxy=k,this._commands=z,this._sourceControlHandle=x,this._id=F,this._label=N,this.multiDiffEditorEnableViewChanges=M,this._extension=B,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new O.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new O.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=E._handlePool++}getResourceState(k){return this._resourceStatesMap.get(k)}$executeResourceCommand(k,z){const x=this._resourceStatesCommandsMap.get(k);return x?(0,R.asPromise)(()=>this._commands.executeCommand(x.command,...x.arguments||[],z)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const k=[...this._resourceStates].sort(l),x=(0,p.sortedDiff)(this._resourceSnapshot,k,l).map(M=>{const B=M.toInsert.map(W=>{const Y=this._resourceHandlePool++;this._resourceStatesMap.set(Y,W);const Z=W.resourceUri;let G;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"||W.command.command==="vscode.changes"){const se=new T.DisposableStore;G=this._commands.converter.toInternal(W.command,se),this._resourceStatesDisposablesMap.set(Y,se)}else this._resourceStatesCommandsMap.set(Y,W.command);const Q=(0,S.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor"),re=Q?W.multiDiffEditorOriginalUri:void 0,te=Q?W.multiFileDiffEditorModifiedUri:void 0,ve=r(W.decorations),Ie=W.decorations&&r(W.decorations.light)||ve,J=W.decorations&&r(W.decorations.dark)||ve,$=[Ie,J],ne=W.decorations&&W.decorations.tooltip||"",be=W.decorations&&!!W.decorations.strikeThrough,Ce=W.decorations&&!!W.decorations.faded,ae=W.contextValue||"";return{rawResource:[Y,Z,$,ne,be,Ce,ae,G,re,te],handle:Y}});return{start:M.start,deleteCount:M.deleteCount,toInsert:B}}),F=x.map(({start:M,deleteCount:B,toInsert:W})=>[M,B,W.map(Y=>Y.rawResource)]),N=x.reverse();for(const{start:M,deleteCount:B,toInsert:W}of N){const Y=W.map(G=>G.handle),Z=this._handlesSnapshot.splice(M,B,...Y);for(const G of Z)this._resourceStatesMap.delete(G),this._resourceStatesCommandsMap.delete(G),this._resourceStatesDisposablesMap.get(G)?.dispose(),this._resourceStatesDisposablesMap.delete(G)}return this._resourceSnapshot=k,F}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class _{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(k){this._count!==k&&(this._count=k,this.#e.$updateSourceControl(this.handle,{count:k}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(k){this._quickDiffProvider=k;let z;(0,S.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(z=k?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!k,quickDiffLabel:z})}get historyProvider(){return(0,S.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(k){(0,S.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=k,this._historyProviderDisposable.value=new T.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!k}),k&&this._historyProviderDisposable.value.add(k.onDidChangeCurrentHistoryItemGroup(()=>{this._historyProviderCurrentHistoryItemGroup=k?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup)}))}get commitTemplate(){return this._commitTemplate}set commitTemplate(k){k!==this._commitTemplate&&(this._commitTemplate=k,this.#e.$updateSourceControl(this.handle,{commitTemplate:k}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(k){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=k;const z=this._commands.converter.toInternal(k,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:z})}get actionButton(){return(0,S.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(k){(0,S.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new T.DisposableStore,this._actionButton=k;const z=k!==void 0?{command:this._commands.converter.toInternal(k.command,this._actionButtonDisposables.value),secondaryCommands:k.secondaryCommands?.map(x=>x.map(F=>this._commands.converter.toInternal(F,this._actionButtonDisposables.value))),description:k.description,enabled:k.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:z??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(k){if(this._statusBarCommands&&k&&g(this._statusBarCommands,k))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=k;const z=(k||[]).map(x=>this._commands.converter.toInternal(x,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:z})}get selected(){return this._selected}constructor(k,z,x,F,N,M,B){this._extension=k,this._commands=F,this._id=N,this._label=M,this._rootUri=B,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new T.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new T.MutableDisposable,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new O.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=_._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=x;const W=c.URI.from({scheme:a.Schemas.vscodeSourceControl,path:`${N}/scm${this.handle}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this._inputBox=new D(k,z,this.#e,this.handle,W),this.#e.$registerSourceControl(this.handle,N,M,B,W)}createResourceGroup(k,z,x){const F=(0,S.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor")&&x?.multiDiffEditorEnableViewChanges===!0,N=new E(this.#e,this._commands,this.handle,k,z,F,this._extension),M=O.Event.once(N.onDidDispose)(()=>this.createdResourceGroups.delete(N));return this.createdResourceGroups.set(N,M),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const k=[],z=[];for(const[x,F]of this.createdResourceGroups){F.dispose();const N=x.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(x),this.eventuallyUpdateResourceStates()});O.Event.once(x.onDidDispose)(()=>{this.updatedResourceGroups.delete(x),N.dispose(),this._groups.delete(x.handle),this.#e.$unregisterGroup(this.handle,x.handle)}),k.push([x.handle,x.id,x.label,x.features,x.multiDiffEditorEnableViewChanges]);const M=x._takeResourceStateSnapshot();M.length>0&&z.push([x.handle,M]),this._groups.set(x.handle,x)}this.#e.$registerGroups(this.handle,k,z),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const k=[];this.updatedResourceGroups.forEach(z=>{const x=z._takeResourceStateSnapshot();x.length!==0&&k.push([z.handle,x])}),k.length>0&&this.#e.$spliceResourceStates(this.handle,k),this.updatedResourceGroups.clear()}getResourceGroup(k){return this._groups.get(k)}setSelectionState(k){this._selected=k,this._onDidChangeSelection.fire(k)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(k=>k.dispose()),this.#e.$unregisterSourceControl(this.handle)}}Ge([(0,L.debounce)(100)],_.prototype,"eventuallyAddResourceGroups",null),Ge([(0,L.debounce)(100)],_.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{o=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(k,z,x,F){this._commands=z,this._extHostDocuments=x,this.logService=F,this._sourceControls=new Map,this._sourceControlsByExtension=new I.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new O.Emitter,this._proxy=k.getProxy(b.MainContext.MainThreadSCM),this._telemetry=k.getProxy(b.MainContext.MainThreadTelemetry),z.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const M=this._sourceControls.get(N.sourceControlHandle);if(!M)return N;const B=M.getResourceGroup(N.groupHandle);return B?B.getResourceState(N.handle):N}else if(N&&N.$mid===4){const M=this._sourceControls.get(N.sourceControlHandle);return M?M.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const M=this._sourceControls.get(N.handle);return M||N}return N}})}createSourceControl(k,z,x,F){this.logService.trace("ExtHostSCM#createSourceControl",k.identifier.value,z,x,F),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:k.identifier.value});const N=o._handlePool++,M=new _(k,this._extHostDocuments,this._proxy,this._commands,z,x,F);this._sourceControls.set(N,M);const B=this._sourceControlsByExtension.get(k.identifier)||[];return B.push(M),this._sourceControlsByExtension.set(k.identifier,B),M}getLastInputBox(k){this.logService.trace("ExtHostSCM#getLastInputBox",k.identifier.value);const z=this._sourceControlsByExtension.get(k.identifier),x=z&&z[z.length-1];return x&&x.inputBox}$provideOriginalResource(k,z,x){const F=c.URI.revive(z);this.logService.trace("ExtHostSCM#$provideOriginalResource",k,F.toString());const N=this._sourceControls.get(k);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>N.quickDiffProvider.provideOriginalResource(F,x)).then(M=>M||null)}$onInputBoxValueChange(k,z){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",k);const x=this._sourceControls.get(k);return x&&x.inputBox.$onInputBoxValueChange(z),Promise.resolve(void 0)}$executeResourceCommand(k,z,x,F){this.logService.trace("ExtHostSCM#$executeResourceCommand",k,z,x);const N=this._sourceControls.get(k);if(!N)return Promise.resolve(void 0);const M=N.getResourceGroup(z);return M?M.$executeResourceCommand(x,F):Promise.resolve(void 0)}$validateInput(k,z,x){this.logService.trace("ExtHostSCM#$validateInput",k);const F=this._sourceControls.get(k);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>F.inputBox.validateInput(z,x)).then(N=>{if(!N)return Promise.resolve(void 0);const M=C.MarkdownString.fromStrict(N.message);return M?Promise.resolve([M,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(k){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",k),k!==void 0&&this._sourceControls.get(k)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=k,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(k,z,x,F){return await this._sourceControls.get(k)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(z,x,F)??void 0}async $provideHistoryItems(k,z,x,F){return(await this._sourceControls.get(k)?.historyProvider?.provideHistoryItems(z,x,F))?.map(B=>({...B,icon:s(B)}))??void 0}async $provideHistoryItemSummary(k,z,x,F){const N=this._sourceControls.get(k)?.historyProvider;if(typeof N?.provideHistoryItemSummary!="function")return;const M=await N.provideHistoryItemSummary(z,x,F);return M?{...M,icon:s(M)}:void 0}async $provideHistoryItemChanges(k,z,x,F){return await this._sourceControls.get(k)?.historyProvider?.provideHistoryItemChanges(z,x,F)??void 0}};e.ExtHostSCM=y,e.ExtHostSCM=y=o=Ge([Ue(3,A.ILogService)],y)}),define(ye[348],_e([1,0,6,16,2]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class T{static{this.handlePool=0}constructor(b,p){this.uriTransformer=p,this.providers=new Map,this.proxy=b.getProxy(c.MainContext.MainThreadShare)}async $provideShare(b,p,w){return await this.providers.get(b)?.provideShare({selection:O.Range.to(p.selection),resourceUri:L.URI.revive(p.resourceUri)},w)??void 0}registerShareProvider(b,p){const w=T.handlePool++;return this.providers.set(w,p),this.proxy.$registerShareProvider(w,O.DocumentSelector.from(b,this.uriTransformer),p.id,p.label,p.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(w),this.providers.delete(w)}}}}e.ExtHostShare=T}),define(ye[349],_e([1,0,7,6,225,3,16,18]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class p{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(v,C,S,a,m,o=c.StatusBarAlignment.Left,n){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new T.DisposableStore,this.#e=v,this.#t=C,m&&a){this._entryId=(0,c.asStatusBarItemIdentifier)(a.identifier,m);const i=S.get(this._entryId);i&&(o=i.alignLeft?c.StatusBarAlignment.Left:c.StatusBarAlignment.Right,n=i.priority,this._visible=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this._entryId=String(p.ID_GEN++);this._extension=a,this._id=m,this._alignment=o,this._priority=this.validatePriority(n)}validatePriority(v){if((0,b.isNumber)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(v){this._text=v,this.update()}set name(v){this._name=v,this.update()}set tooltip(v){this._tooltip=v,this.update()}set color(v){this._color=v,this.update()}set backgroundColor(v){v&&!p.ALLOWED_BACKGROUND_COLORS.has(v.id)&&(v=void 0),this._backgroundColor=v,this.update()}set command(v){this._command?.fromApi!==v&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new T.DisposableStore,typeof v=="string"?this._command={fromApi:v,internal:this.#t.toInternal({title:"",command:v},this._latestCommandRegistration)}:v?this._command={fromApi:v,internal:this.#t.toInternal(v,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(v){this._accessibilityInformation=v,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let v;this._extension?this._id?v=`${this._extension.identifier.value}.${this._id}`:v=this._extension.identifier.value:v=this._id;let C;this._name?C=this._name:C=(0,L.localize)(0,null,this._extension.displayName||this._extension.name);let S=this._color;this._backgroundColor&&(S=p.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const a=R.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,v,this._extension?.identifier.value,C,this._text,a,this._command?.internal,S,this._backgroundColor,this._alignment===c.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=p;class w{constructor(v){this._messages=[],this._item=v.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,L.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(v){const C={message:v};return this._messages.unshift(C),this._update(),new c.Disposable(()=>{const S=this._messages.indexOf(C);S>=0&&(this._messages.splice(S,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class A{constructor(v,C){this._existingItems=new Map,this._proxy=v.getProxy(O.MainContext.MainThreadStatusBar),this._commands=C,this._statusMessage=new w(this)}$acceptStaticEntries(v){for(const C of v)this._existingItems.set(C.entryId,C)}createStatusBarEntry(v,C,S,a){return new p(this._proxy,this._commands,this._existingItems,v,C,S,a)}setStatusBarMessage(v,C){const S=this._statusMessage.setMessage(v);let a;return typeof C=="number"?a=setTimeout(()=>S.dispose(),C):typeof C<"u"&&C.then(()=>S.dispose(),()=>S.dispose()),new c.Disposable(()=>{S.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=A}),define(ye[154],_e([1,0,29,144,67,112,89,16,2]),function(de,e,c,O,L,T,R,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const w=(i,r,s,t)=>{let f=r;return{enumerable:!0,configurable:!1,get(){return f},set(h){if(!s(f,h)){const l=f;f=h,i.listener?.(t(h,l))}}}},A=(i,r)=>i===r,I={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(i,r)=>!(i.length!==r.length||i.some(s=>!r.find(t=>s.id===t.id)))},v=i=>r=>({op:4,update:i(r)}),C=(i,r)=>({range:(()=>{let s;const t=v(f=>({range:c.Range.lift(b.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return s},set(f){i.listener?.({op:6}),I.range(s,f)||(s=f,i.listener?.(t(f)))}}})(),label:w(i,r,I.label,v(s=>({label:s}))),description:w(i,void 0,I.description,v(s=>({description:s}))),sortText:w(i,void 0,I.sortText,v(s=>({sortText:s}))),canResolveChildren:w(i,!1,I.canResolveChildren,s=>({op:2,state:s})),busy:w(i,!1,I.busy,v(s=>({busy:s}))),error:w(i,void 0,I.error,v(s=>({error:b.MarkdownString.fromStrict(s)||null}))),tags:w(i,[],I.tags,(s,t)=>({op:1,new:s.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),S=i=>{const r=L.TestId.fromString(i.extId),s=new m(r.controllerId,r.localId,i.label,p.URI.revive(i.uri)||void 0);return s.range=b.Range.to(i.range||void 0),s.description=i.description||void 0,s.sortText=i.sortText||void 0,s.tags=i.tags.map(t=>b.TestTag.to({id:(0,R.denamespaceTestTag)(t).tagId})),s},a=i=>{let r;for(const s of i.tests){const t=S(s.item);(0,O.getPrivateApiFor)(t).parent=r,r=t}return r};e.toItemFromContext=a;class m{constructor(r,s,t,f){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const h=(0,O.createPrivateApiFor)(this,r);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return h.parent instanceof o?void 0:h.parent}},children:{value:(0,T.createTestItemChildren)(h,O.getPrivateApiFor,m),enumerable:!0,writable:!1},...C(h,t)})}}e.TestItemImpl=m;class o extends m{constructor(r,s){super(r,r,s,void 0),this._isRoot=!0}}e.TestItemRootImpl=o;class n extends T.TestItemCollection{constructor(r,s,t){super({controllerId:r,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:O.getPrivateApiFor,getChildren:f=>f.children,root:new o(r,s),toITestItem:b.TestItem.from})}}e.ExtHostTestItemCollection=n}),define(ye[33],_e([1,0,18,7,16,24,6,19,12,57,29,49,2,3,5,20,154,21,68,47,39,87,90,30]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let h=class{#e;#t;#i;constructor(E,_,y){this._commands=new Map,this._apiCommands=new Map,this.#e=E.getProxy(R.MainContext.MainThreadCommands),this._logService=_,this.#i=y,this.#t=E.getProxy(R.MainContext.MainThreadTelemetry),this.converter=new l(this,P=>{const k=this._apiCommands.get(P);return k?.result===d.Void?k:void 0},_),this._argumentProcessors=[{processArgument(P){return(0,w.revive)(P)}},{processArgument(P){return(0,T.cloneAndChange)(P,function(k){if(A.Range.isIRange(k))return L.Range.to(k);if(I.Position.isIPosition(k))return L.Position.to(k);if(A.Range.isIRange(k.range)&&v.URI.isUri(k.uri))return L.location.to(k);if(k instanceof o.VSBuffer)return k.buffer.buffer;if(!Array.isArray(k))return k})}}]}registerArgumentProcessor(E){this._argumentProcessors.push(E)}registerApiCommand(E){const _=this.registerCommand(!1,E.id,async(...y)=>{const P=E.args.map((z,x)=>{if(!z.validate(y[x]))throw new Error(`Invalid argument '${z.name}' when running '${E.id}', received: ${typeof y[x]=="object"?JSON.stringify(y[x],null,"	"):y[x]} `);return z.convert(y[x])}),k=await this.executeCommand(E.internalId,...P);return E.result.convert(k,y,this.converter)},void 0,{description:E.description,args:E.args,returns:E.result.description});return this._apiCommands.set(E.id,E),new O.Disposable(()=>{_.dispose(),this._apiCommands.delete(E.id)})}registerCommand(E,_,y,P,k,z){if(this._logService.trace("ExtHostCommands#registerCommand",_),!_.trim().length)throw new Error("invalid id");if(this._commands.has(_))throw new Error(`command '${_}' already exists`);return this._commands.set(_,{callback:y,thisArg:P,metadata:k,extension:z}),E&&this.#e.$registerCommand(_),new O.Disposable(()=>{this._commands.delete(_)&&E&&this.#e.$unregisterCommand(_)})}executeCommand(E,..._){return this._logService.trace("ExtHostCommands#executeCommand",E),this._doExecuteCommand(E,_,!0)}async _doExecuteCommand(E,_,y){if(this._commands.has(E))return this.#e.$fireCommandActivationEvent(E),this._executeContributedCommand(E,_,!1);{let P=!1;const k=(0,T.cloneAndChange)(_,function(z){if(z instanceof O.Position)return L.Position.from(z);if(z instanceof O.Range)return L.Range.from(z);if(z instanceof O.Location)return L.location.from(z);if(O.NotebookRange.isNotebookRange(z))return L.NotebookRange.from(z);if(z instanceof ArrayBuffer)return P=!0,o.VSBuffer.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return P=!0,o.VSBuffer.wrap(z);if(z instanceof o.VSBuffer)return P=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(E,P?new n.SerializableObjectWithBuffers(k):k,y);return(0,w.revive)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this._doExecuteCommand(E,_,!1);throw z}}}async _executeContributedCommand(E,_,y){const P=this._commands.get(E);if(!P)throw new Error("Unknown command");const{callback:k,thisArg:z,metadata:x}=P;if(x?.args)for(let N=0;N<x.args.length;N++)try{(0,c.validateConstraint)(_[N],x.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${E}' failed. Illegal argument '${x.args[N].name}' - ${x.args[N].description}`)}const F=r.StopWatch.create();try{return await k.apply(z,_)}catch(N){if(E===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(..._);M&&(E=M.command)}if(this._logService.error(N,E,P.extension?.identifier),!y)throw N;if(P.extension?.identifier){const M=this.#i.onExtensionError(P.extension.identifier,N);this._logService.trace("forwarded error to extension?",M,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.toErrorMessage)(N)),this.id=E,this.source=P.extension?.displayName??P.extension?.name}}}finally{this._reportTelemetry(P,E,F.elapsed())}}_reportTelemetry(E,_,y){E.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:E.extension.identifier.value,id:new s.TelemetryTrustedValue(_),duration:y})}$executeContributedCommand(E,..._){this._logService.trace("ExtHostCommands#$executeContributedCommand",E);const y=this._commands.get(E);return y?(_=_.map(P=>this._argumentProcessors.reduce((k,z)=>z.processArgument(k,y.extension?.identifier),P)),this._executeContributedCommand(E,_,!0)):Promise.reject(new Error(`Contributed command '${E}' does not exist.`))}getCommands(E=!1){return this._logService.trace("ExtHostCommands#getCommands",E),this.#e.$getCommands().then(_=>(E&&(_=_.filter(y=>y[0]!=="_")),_))}$getContributedCommandMetadata(){const E=Object.create(null);for(const[_,y]of this._commands){const{metadata:P}=y;P&&(E[_]=P)}return Promise.resolve(E)}};e.ExtHostCommands=h,e.ExtHostCommands=h=Ge([Ue(0,a.IExtHostRpcService),Ue(1,p.ILogService),Ue(2,t.IExtHostTelemetry)],h),e.IExtHostCommands=(0,S.createDecorator)("IExtHostCommands");class l{constructor(E,_,y){this._commands=E,this._lookupApiCommand=_,this._logService=y,this.delegatingCommandId=`__vsc${(0,f.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(E,_){if(!E)return;const y={$ident:void 0,id:E.command,title:E.title,tooltip:E.tooltip};if(!E.command)return y;const P=this._lookupApiCommand(E.command);if(P)y.id=P.internalId,y.arguments=P.args.map((k,z)=>k.convert(E.arguments&&E.arguments[z]));else if((0,b.isNonEmptyArray)(E.arguments)){const k=`${E.command} /${++this._cachIdPool}`;this._cache.set(k,E),_.add((0,C.toDisposable)(()=>{this._cache.delete(k),this._logService.trace("CommandsConverter#DISPOSE",k)})),y.$ident=k,y.id=this.delegatingCommandId,y.arguments=[k],this._logService.trace("CommandsConverter#CREATE",E.command,k)}return y}fromInternal(E){return typeof E.$ident=="string"?this._cache.get(E.$ident):{command:E.id,title:E.title,arguments:E.arguments}}getActualCommand(...E){return this._cache.get(E[0])}_executeConvertedCommand(...E){const _=this.getActualCommand(...E);return this._logService.trace("CommandsConverter#EXECUTE",E[0],_?_.command:"MISSING"),_?this._commands.executeCommand(_.command,..._.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${E[0]}`)}}e.CommandsConverter=l;class u{static{this.Uri=new u("uri","Uri of a text document",E=>v.URI.isUri(E),E=>E)}static{this.Position=new u("position","A position in a text document",E=>O.Position.isPosition(E),L.Position.from)}static{this.Range=new u("range","A range in a text document",E=>O.Range.isRange(E),L.Range.from)}static{this.Selection=new u("selection","A selection in a text document",E=>O.Selection.isSelection(E),L.Selection.from)}static{this.Number=new u("number","",E=>typeof E=="number",E=>E)}static{this.String=new u("string","",E=>typeof E=="string",E=>E)}static{this.StringArray=u.Arr(u.String)}static Arr(E){return new u(`${E.name}_array`,`Array of ${E.name}, ${E.description}`,_=>Array.isArray(_)&&_.every(y=>E.validate(y)),_=>_.map(y=>E.convert(y)))}static{this.CallHierarchyItem=new u("item","A call hierarchy item",E=>E instanceof O.CallHierarchyItem,L.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new u("item","A type hierarchy item",E=>E instanceof O.TypeHierarchyItem,L.TypeHierarchyItem.from)}static{this.TestItem=new u("testItem","A VSCodium TestItem",E=>E instanceof m.TestItemImpl,L.TestItem.from)}constructor(E,_,y,P){this.name=E,this.description=_,this.validate=y,this.convert=P}optional(){return new u(this.name,`(optional) ${this.description}`,E=>E==null||this.validate(E),E=>E===void 0?void 0:E===null?null:this.convert(E))}with(E,_){return new u(E??this.name,_??this.description,this.validate,this.convert)}}e.ApiCommandArgument=u;class d{static{this.Void=new d("no result",E=>E)}constructor(E,_){this.description=E,this.convert=_}}e.ApiCommandResult=d;class g{constructor(E,_,y,P,k){this.id=E,this.internalId=_,this.description=y,this.args=P,this.result=k}}e.ApiCommand=g}),define(ye[350],_e([1,0,19,15,2,83,134,41,33,16,7]),function(de,e,c,O,L,T,R,b,p,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const I=[new p.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",C(w.DocumentHighlight.to))),new p.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,m)=>{if((0,c.isFalsyOrEmpty)(a))return;class o extends A.SymbolInformation{static to(i){const r=new o(i.name,w.SymbolKind.to(i.kind),i.containerName||"",new A.Location(m[0],w.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=w.Range.to(i.selectionRange),r.children=i.children?i.children.map(o.to):[],r}}return a.map(o.to)})),new p.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(w.TextEdit.to))),new p.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range,new p.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(w.TextEdit.to))),new p.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,new p.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new p.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(w.TextEdit.to))),new p.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new p.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new p.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new p.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",S)),new p.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(w.location.to))),new p.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(w.Hover.to))),new p.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(m=>A.Position.isPosition(m)),a=>a.map(w.Position.from))],new p.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(m=>{let o;for(const n of m.reverse())o=new A.SelectionRange(w.Range.to(n),o);return o}))),new p.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.ApiCommandArgument.String.with("query","Search string")],new p.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(w.WorkspaceSymbol.to))),new p.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(w.CallHierarchyItem.to))),new p.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.ApiCommandArgument.CallHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(w.CallHierarchyIncomingCall.to))),new p.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.ApiCommandArgument.CallHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(w.CallHierarchyOutgoingCall.to))),new p.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:w.Range.to(a.range),placeholder:a.text}})),new p.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("newName","The new symbol name")],new p.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return w.WorkspaceEdit.to(a)}})),new p.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(w.DocumentLink.to))),new p.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new A.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new p.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,R.decodeSemanticTokensDto)(a);if(m.type==="full")return new A.SemanticTokens(m.data,void 0)})),new p.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range.optional()],new p.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new A.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new p.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,R.decodeSemanticTokensDto)(a);if(m.type==="full")return new A.SemanticTokens(m.data,void 0)})),new p.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,m,o)=>{if(!a)return new A.CompletionList([]);const n=a.suggestions.map(i=>w.CompletionItem.to(i,o));return new A.CompletionList(n,a.incomplete)})),new p.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return w.SignatureHelp.to(a)})),new p.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,m,o)=>C(n=>new A.CodeLens(w.Range.to(n.range),n.command&&o.fromInternal(n.command)))(a))),new p.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>A.Range.isRange(a),a=>A.Selection.isSelection(a)?w.Selection.from(a):w.Range.from(a)),p.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),p.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,m,o)=>C(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(n.command)}else{const i=new A.CodeAction(n.title,n.kind?new A.CodeActionKind(n.kind):void 0);return n.edit&&(i.edit=w.WorkspaceEdit.to(n.edit)),n.command&&(i.command=o.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(a))),new p.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(m=>new A.ColorInformation(w.Range.to(m.range),w.Color.to(m.color))):[])),new p.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.ApiCommandArgument("color","The color to show and insert",a=>a instanceof A.Color,w.Color.from),new p.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:w.Range.from(a.range)}))],new p.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(w.ColorPresentation.to):[])),new p.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to an array of Inlay objects",(a,m,o)=>a.map(w.InlayHint.to.bind(void 0,o)))),new p.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(a,m)=>{if(a)return a.map(w.FoldingRange.to)})),new p.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",C(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(m=>w.NotebookExclusiveDocumentPattern.to(m))})))),new p.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range,new p.ApiCommandArgument("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof A.Range,a=>w.InlineValueContext.from(a))],new p.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(w.InlineValue.to))),new p.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",a=>L.URI.isUri(a)||typeof a=="string"&&(0,O.matchesSomeScheme)(a,O.Schemas.http,O.Schemas.https),a=>a),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[w.ViewColumn.from(a),void 0]:[w.ViewColumn.from(a.viewColumn),w.TextEditorOpenOptions.from(a)])).optional(),p.ApiCommandArgument.String.with("label","").optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.ApiCommandArgument.Uri.with("resource","Resource to open"),p.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[w.ViewColumn.from(a),void 0]:[w.ViewColumn.from(a.viewColumn),w.TextEditorOpenOptions.from(a)])).optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),p.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),p.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[w.ViewColumn.from(a.viewColumn),w.TextEditorOpenOptions.from(a)]).optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.ApiCommandArgument.String.with("title","Human readable title for the changes editor"),new p.ApiCommandArgument("resourceList","List of resources to compare",a=>{for(const m of a){if(m.length!==3)return!1;const[o,n,i]=m;if(!L.URI.isUri(o)||!L.URI.isUri(n)&&n!==void 0&&n!==null||!L.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},a=>a)],p.ApiCommandResult.Void),new p.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(w.TypeHierarchyItem.to))),new p.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.ApiCommandArgument.TypeHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(w.TypeHierarchyItem.to))),new p.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.ApiCommandArgument.TypeHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(w.TypeHierarchyItem.to))),new p.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.ApiCommandArgument.TestItem],p.ApiCommandResult.Void),new p.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.ApiCommandResult.Void),new p.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.ApiCommandArgument.String.with("name","The context key name"),new p.ApiCommandArgument("value","The context key value",()=>!0,a=>a)],p.ApiCommandResult.Void),new p.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.StringArray,new p.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",a=>w.MappedEditsContext.is(a),a=>w.MappedEditsContext.from(a))],new p.ApiCommandResult("A promise that resolves to a workspace edit or null",a=>a?w.WorkspaceEdit.to(a):null))];class v{static register(m){I.forEach(m.registerApiCommand,m),this._registerValidateWhenClausesCommand(m)}static _registerValidateWhenClausesCommand(m){m.registerCommand(!1,"_validateWhenClauses",b.validateWhenClauses)}}e.ExtHostApiCommands=v;function C(a){return m=>{if(Array.isArray(m))return m.map(a)}}function S(a){if(!Array.isArray(a))return;const m=[];for(const o of a)T.isLocationLink(o)?m.push(w.DefinitionLink.to(o)):m.push(w.location.to(o));return m}}),define(ye[351],_e([1,0,8,3,2,6,33,16,7]),function(de,e,c,O,L,T,R,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class w{static{this._pool=0}constructor(C,S){this.extension=C,this.provider=S,this.handle=w._pool++}}class A{constructor(C){this.session=C,this.responses=[]}}class I{static{this._nextId=0}constructor(C,S,a,m){this._documents=a,this._logService=m,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=C.getProxy(T.MainContext.MainThreadInlineChat),S.registerApiCommand(new R.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.ApiCommandArgument("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?b.Range.from(o.initialRange):void 0,initialSelection:p.Selection.isSelection(o.initialSelection)?b.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?b.Position.from(o.position):void 0}})],R.ApiCommandResult.Void))}registerProvider(C,S,a){const m=new w(C,S);return this._inputProvider.set(m.handle,m),this._proxy.$registerInteractiveEditorProvider(m.handle,a?.label??C.displayName??C.name,C.identifier,typeof S.handleInteractiveEditorResponseFeedback=="function",typeof S.provideFollowups=="function",a?.supportReportIssue??!1),(0,O.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(m.handle),this._inputProvider.delete(m.handle)})}async $prepareSession(C,S,a,m){const o=this._inputProvider.get(C);if(!o){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this._documents.getDocument(L.URI.revive(S)),i=b.Selection.to(a),r=await o.provider.prepareInteractiveEditorSession({document:n,selection:i},m);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const s=I._nextId++;return this._inputSessions.set(s,new A(r)),{id:s,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:b.Range.from(r.wholeRange),message:r.message}}async $provideResponse(C,S,a,m){const o=this._inputProvider.get(C);if(!o)return;const n=this._inputSessions.get(S.id);if(!n)return;const i={prompt:a.prompt,selection:b.Selection.to(a.selection),wholeRange:b.Range.to(a.wholeRange),attempt:a.attempt,live:a.live,previewDocument:this._documents.getDocument(L.URI.revive(a.previewDocument)),withIntentDetection:a.withIntentDetection};let r=!1;const s={report:async D=>{if(!a.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||m.isCancellationRequested||await this._proxy.$handleProgressChunk(a.requestId,{message:D.message,edits:D.edits?.map(b.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:p.MarkdownString.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(n.session,i,s,m));let f;try{f=await(0,c.raceCancellation)(t,m)}finally{r=!0}if(!f)return;const h=n.responses.push(f)-1,l={wholeRange:b.Range.from(f.wholeRange),placeholder:f.placeholder};if(!I._isEditResponse(f))return{...l,id:h,type:"editorEdit",message:b.MarkdownString.from(f.contents),edits:[]};const{edits:u,contents:d}=f,g=d!==void 0?b.MarkdownString.from(d):void 0;return u instanceof p.WorkspaceEdit?{...l,id:h,type:"bulkEdit",edits:b.WorkspaceEdit.from(u),message:g}:{...l,id:h,type:"editorEdit",edits:u.map(b.TextEdit.from),message:g}}async $provideFollowups(C,S,a,m){const o=this._inputProvider.get(C),n=this._inputSessions.get(S),i=n?.responses[a];if(o&&i&&o.provider.provideFollowups){const r=Promise.resolve(o.provider.provideFollowups(n.session,i,m));return(await(0,c.raceCancellation)(r,m))?.map(b.ChatInlineFollowup.from)}}$handleFeedback(C,S,a,m){const o=this._inputProvider.get(C),n=this._inputSessions.get(S),i=n?.responses[a];if(o&&i){const r=b.InteractiveEditorResponseFeedbackKind.to(m);o.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,r)}}$releaseSession(C,S){}static _isEditResponse(C){return typeof C=="object"&&typeof C.edits=="object"}}e.ExtHostInteractiveEditor=I}),define(ye[352],_e([1,0,2,33]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class L{constructor(R,b,p,w,A){this._extHostNotebooks=b,this._textDocumentsAndEditors=p,this._commands=w;const I=new O.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new O.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new O.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new O.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new O.ApiCommandResult("Notebook and input URI",v=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const C=this._extHostNotebooks.getEditorById(v.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",C.id),{notebookUri:c.URI.revive(v.notebookUri),inputUri:c.URI.revive(v.inputUri),notebookEditor:C.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:c.URI.revive(v.notebookUri),inputUri:c.URI.revive(v.inputUri)}}));this._commands.registerApiCommand(I)}$willAddInteractiveDocument(R,b,p,w){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:p,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,b){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=L}),define(ye[353],_e([1,0,19,8,22,4,3,27,2,25,12,6,33,16,7,113,295,26,68,296]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0,e.createKernelId=u;let r=class{constructor(g,D,E,_,y){this._initData=D,this._extHostNotebook=E,this._commands=_,this._logService=y,this._activeExecutions=new b.ResourceMap,this._activeNotebookExecutions=new b.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this.id=0,this.variableStore={},this._proxy=g.getProxy(I.MainContext.MainThreadNotebookKernels);const P=new v.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new v.ApiCommandArgument("options","Select kernel options",z=>!0,z=>{if(z&&"notebookEditor"in z&&"id"in z){const x=this._extHostNotebook.getIdByEditor(z.notebookEditor);return{id:z.id,extension:z.extension,notebookEditorId:x}}else if(z&&"notebookEditor"in z){const x=this._extHostNotebook.getIdByEditor(z.notebookEditor);if(x===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${z.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:x}}return z})],v.ApiCommandResult.Void),k=new v.ApiCommand("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[v.ApiCommandArgument.Uri],new v.ApiCommandResult("A promise that resolves to an array of variables",(z,x)=>z.map(F=>({variable:{name:F.name,value:F.value,expression:F.expression,type:F.type,language:F.language},hasNamedChildren:F.hasNamedChildren,indexedChildrenCount:F.indexedChildrenCount}))));this._commands.registerApiCommand(P),this._commands.registerApiCommand(k)}createNotebookController(g,D,E,_,y,P){for(const ve of this._kernelData.values())if(ve.controller.id===D&&w.ExtensionIdentifier.equals(g.identifier,ve.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const k=this._handlePool++,z=this;this._logService.trace(`NotebookController[${k}], CREATED by ${g.identifier.value}, ${D}`);const x=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${g.identifier}'`);let F=!1;const N=new T.Emitter,M=new T.Emitter,B={id:u(g.identifier,D),notebookType:E,extensionId:g.identifier,extensionLocation:g.extensionLocation,label:_||g.identifier.value,preloads:P?P.map(C.NotebookRendererScript.from):[]};let W=y??x,Y,Z;this._proxy.$addKernel(k,B).catch(ve=>{console.log(ve),F=!0});let G=0;const Q=()=>{if(F)return;const ve=++G;Promise.resolve().then(()=>{ve===G&&this._proxy.$updateKernel(k,B)})},re=new b.ResourceMap,te={get id(){return D},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return B.label},set label(ve){B.label=ve??g.displayName??g.name,Q()},get detail(){return B.detail??""},set detail(ve){B.detail=ve,Q()},get description(){return B.description??""},set description(ve){B.description=ve,Q()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(ve){B.supportedLanguages=ve,Q()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(ve){B.supportsExecutionOrder=ve,Q()},get rendererScripts(){return B.preloads?B.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(ve){W=ve??x},get interruptHandler(){return Y},set interruptHandler(ve){Y=ve,B.supportsInterrupt=!!ve,Q()},set variableProvider(ve){(0,o.checkProposedApiEnabled)(g,"notebookVariableProvider"),Z=ve,B.hasVariableProvider=!!ve,ve?.onDidChangeVariables(Ie=>z._proxy.$variablesUpdated(Ie.uri)),Q()},get variableProvider(){return Z},createNotebookCellExecution(ve){if(F)throw new Error("notebook controller is DISPOSED");if(!re.has(ve.notebook.uri))throw z._logService.trace(`NotebookController[${k}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map(Ie=>Ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ve.notebook.uri.toString()}`);return z._createNotebookCellExecution(ve,u(g.identifier,this.id))},createNotebookExecution(ve){if((0,o.checkProposedApiEnabled)(g,"notebookExecution"),F)throw new Error("notebook controller is DISPOSED");if(!re.has(ve.uri))throw z._logService.trace(`NotebookController[${k}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map(Ie=>Ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${ve.uri.toString()}`);return z._createNotebookExecution(ve,u(g.identifier,this.id))},dispose:()=>{F||(this._logService.trace(`NotebookController[${k}], DISPOSED`),F=!0,this._kernelData.delete(k),N.dispose(),M.dispose(),this._proxy.$removeKernel(k))},updateNotebookAffinity(ve,Ie){Ie===S.NotebookControllerAffinity2.Hidden&&(0,o.checkProposedApiEnabled)(g,"notebookControllerAffinityHidden"),z._proxy.$updateNotebookPriority(k,ve.uri,Ie)},onDidReceiveMessage:M.event,postMessage(ve,Ie){return(0,o.checkProposedApiEnabled)(g,"notebookMessaging"),z._proxy.$postMessage(k,Ie&&z._extHostNotebook.getIdByEditor(Ie),ve)},asWebviewUri(ve){return(0,o.checkProposedApiEnabled)(g,"notebookMessaging"),(0,a.asWebviewUri)(ve,z._initData.remote)}};return this._kernelData.set(k,{extensionId:g.identifier,controller:te,onDidReceiveMessage:M,onDidChangeSelection:N,associatedNotebooks:re}),te}getIdByController(g){for(const[D,E]of this._kernelData)if(E.controller===g)return u(E.extensionId,g.id);return null}createNotebookControllerDetectionTask(g,D){const E=this._kernelDetectionTaskHandlePool++,_=this;this._logService.trace(`NotebookControllerDetectionTask[${E}], CREATED by ${g.identifier.value}`),this._proxy.$addKernelDetectionTask(E,D);const y={dispose:()=>{this._kernelDetectionTask.delete(E),_._proxy.$removeKernelDetectionTask(E)}};return this._kernelDetectionTask.set(E,y),y}registerKernelSourceActionProvider(g,D,E){const _=this._kernelSourceActionProviderHandlePool++,y=typeof E.onDidChangeNotebookKernelSourceActions=="function"?_:void 0,P=this;this._kernelSourceActionProviders.set(_,E),this._logService.trace(`NotebookKernelSourceActionProvider[${_}], CREATED by ${g.identifier.value}`),this._proxy.$addKernelSourceActionProvider(_,_,D);let k;return y!==void 0&&(k=E.onDidChangeNotebookKernelSourceActions(z=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this._kernelSourceActionProviders.delete(_),P._proxy.$removeKernelSourceActionProvider(_,_),k?.dispose()}}}async $provideKernelSourceActions(g,D){const E=this._kernelSourceActionProviders.get(g);if(E){const _=new R.DisposableStore;return(await E.provideNotebookKernelSourceActions(D)??[]).map(P=>C.NotebookKernelSourceAction.from(P,this._commands.converter,_))}return[]}$acceptNotebookAssociation(g,D,E){const _=this._kernelData.get(g);if(_){const y=this._extHostNotebook.getNotebookDocument(p.URI.revive(D));E?_.associatedNotebooks.set(y.uri,!0):_.associatedNotebooks.delete(y.uri),this._logService.trace(`NotebookController[${g}] ASSOCIATE notebook`,y.uri.toString(),E),_.onDidChangeSelection.fire({selected:E,notebook:y.apiNotebook})}}async $executeCells(g,D,E){const _=this._kernelData.get(g);if(!_)return;const y=this._extHostNotebook.getNotebookDocument(p.URI.revive(D)),P=[];for(const k of E){const z=y.getCell(k);z&&P.push(z.apiCell)}try{this._logService.trace(`NotebookController[${g}] EXECUTE cells`,y.uri.toString(),P.length),await _.controller.executeHandler.call(_.controller,P,y.apiNotebook,_.controller)}catch(k){this._logService.error(`NotebookController[${g}] execute cells FAILED`,k),console.error(k)}}async $cancelCells(g,D,E){const _=this._kernelData.get(g);if(!_)return;const y=this._extHostNotebook.getNotebookDocument(p.URI.revive(D));if(_.controller.interruptHandler)await _.controller.interruptHandler.call(_.controller,y.apiNotebook);else for(const P of E){const k=y.getCell(P);k&&this._activeExecutions.get(k.uri)?.cancel()}if(_.controller.interruptHandler){const P=this._activeNotebookExecutions.get(y.uri);E.length&&Array.isArray(P)&&P.length&&P.forEach(k=>k.dispose())}}async $provideVariables(g,D,E,_,y,P,k){const z=this._kernelData.get(g);if(!z)return;const x=this._extHostNotebook.getNotebookDocument(p.URI.revive(E)),F=z.controller.variableProvider;if(!F)return;let N;if(_!==void 0){if(N=this.variableStore[_],!N)return}else this.variableStore={};const M=y==="named"?S.NotebookVariablesRequestKind.Named:S.NotebookVariablesRequestKind.Indexed,B=F.provideVariables(x.apiNotebook,N,M,P,k);let W=0;for await(const Y of B){if(k.isCancellationRequested)return;const Z={id:this.id++,name:Y.variable.name,value:Y.variable.value,type:Y.variable.type,interfaces:Y.variable.interfaces,language:Y.variable.language,expression:Y.variable.expression,hasNamedChildren:Y.hasNamedChildren,indexedChildrenCount:Y.indexedChildrenCount,extensionId:z.extensionId.value};if(this.variableStore[Z.id]=Y.variable,this._proxy.$receiveVariable(D,Z),W++>=i.variablePageSize)return}}$acceptKernelMessageFromRenderer(g,D,E){const _=this._kernelData.get(g);if(!_)return;const y=this._extHostNotebook.getEditorById(D);_.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:E}))}$cellExecutionChanged(g,D,E){const y=this._extHostNotebook.getNotebookDocument(p.URI.revive(g)).getCell(D);if(y){const P=E?C.NotebookCellExecutionState.to(E):S.NotebookCellExecutionState.Idle;P!==void 0&&this._onDidChangeCellExecutionState.fire({cell:y.apiCell,state:P})}}_createNotebookCellExecution(g,D){if(g.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const _=this._extHostNotebook.getNotebookDocument(g.notebook.uri).getCellFromApiCell(g);if(!_)throw new Error("invalid cell");if(this._activeExecutions.has(_.uri))throw new Error(`duplicate execution for ${_.uri}`);const y=new t(D,_,this._proxy);this._activeExecutions.set(_.uri,y);const P=y.onDidChangeState(()=>{y.state===s.Resolved&&(y.dispose(),P.dispose(),this._activeExecutions.delete(_.uri))});return y.asApiObject()}_createNotebookExecution(g,D){const E=this._extHostNotebook.getNotebookDocument(g.uri),_=g.getCells().find(k=>{const z=E.getCellFromApiCell(k);return z&&this._activeExecutions.has(z.uri)});if(_)throw new Error(`duplicate cell execution for ${_.document.uri}`);if(this._activeNotebookExecutions.has(E.uri))throw new Error(`duplicate notebook execution for ${E.uri}`);const y=new h(D,E,this._proxy),P=y.onDidChangeState(()=>{y.state===f.Resolved&&(y.dispose(),P.dispose(),this._activeNotebookExecutions.delete(E.uri))});return this._activeNotebookExecutions.set(E.uri,[y,P]),y.asApiObject()}};e.ExtHostNotebookKernels=r,e.ExtHostNotebookKernels=r=Ge([Ue(4,A.ILogService)],r);var s;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(s||(s={}));class t extends R.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(g,D,E){super(),this._cell=D,this._proxy=E,this._handle=t.HANDLE++,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new L.CancellationTokenSource),this._collector=new l(10,_=>this.update(_)),this._executionOrder=D.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,g,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(g){await this._collector.addItem(g)}async update(g){const D=Array.isArray(g)?g:[g];return this._proxy.$updateExecution(this._handle,new n.SerializableObjectWithBuffers(D))}verifyStateForOutput(){if(this._state===s.Init)throw new Error("Must call start before modifying cell output");if(this._state===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(g){let D=this._cell;if(g&&(D=this._cell.notebook.getCellFromApiCell(g)),!D)throw new Error("INVALID cell");return D.handle}validateAndConvertOutputs(g){return g.map(D=>{const E=S.NotebookCellOutput.ensureUniqueMimeTypes(D.items,!0);return E===D.items?C.NotebookCellOutput.from(D):C.NotebookCellOutput.from({items:E,id:D.id,metadata:D.metadata})})}async updateOutputs(g,D,E){const _=this.cellIndexToHandle(D),y=this.validateAndConvertOutputs((0,c.asArray)(g));return this.updateSoon({editType:m.CellExecutionUpdateType.Output,cellHandle:_,append:E,outputs:y})}async updateOutputItems(g,D,E){return g=S.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(g),!0),this.updateSoon({editType:m.CellExecutionUpdateType.OutputItems,items:g.map(C.NotebookCellOutputItem.from),outputId:D.id,append:E})}asApiObject(){const g=this;return Object.freeze({get token(){return g._tokenSource.token},get cell(){return g._cell.apiCell},get executionOrder(){return g._executionOrder},set executionOrder(E){g._executionOrder=E,g.update([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:g._executionOrder}])},start(E){if(g._state===s.Resolved||g._state===s.Started)throw new Error("Cannot call start again");g._state=s.Started,g._onDidChangeState.fire(),g.update({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:E})},end(E,_,y){if(g._state===s.Resolved)throw new Error("Cannot call resolve twice");g._state=s.Resolved,g._onDidChangeState.fire(),g._collector.flush();const P=y?{message:y.message,stack:y.stack,location:y?.location?{startLineNumber:y.location.start.line,startColumn:y.location.start.character,endLineNumber:y.location.end.line,endColumn:y.location.end.character}:void 0,uri:y.uri}:void 0;g._proxy.$completeExecution(g._handle,new n.SerializableObjectWithBuffers({runEndTime:_,lastRunSuccess:E,error:P}))},clearOutput(E){return g.verifyStateForOutput(),g.updateOutputs([],E,!1)},appendOutput(E,_){return g.verifyStateForOutput(),g.updateOutputs(E,_,!0)},replaceOutput(E,_){return g.verifyStateForOutput(),g.updateOutputs(E,_,!1)},appendOutputItems(E,_){return g.verifyStateForOutput(),g.updateOutputItems(E,_,!0)},replaceOutputItems(E,_){return g.verifyStateForOutput(),g.updateOutputItems(E,_,!1)}})}}var f;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(f||(f={}));class h extends R.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(g,D,E){super(),this._notebook=D,this._proxy=E,this._handle=h.HANDLE++,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=f.Init,this._tokenSource=this._register(new L.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,g,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===f.Resolved||this._state===f.Started)throw new Error("Cannot call start again");this._state=f.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===f.Resolved)throw new Error("Cannot call resolve twice");this._state=f.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class l{constructor(g,D){this.delay=g,this.callback=D,this.batch=[],this.startedTimer=Date.now()}addItem(g){return this.batch.push(g),this.currentDeferred||(this.currentDeferred=new O.DeferredPromise,this.startedTimer=Date.now(),(0,O.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const g=this.currentDeferred;this.currentDeferred=void 0;const D=this.batch;return this.batch=[],this.callback(D).finally(()=>g.complete())}}function u(d,g){return`${d.value}/${g}`}}),define(ye[43],_e([1,0,4,6,5,2,20,3,7,227,13,272,22,30,273,56,8,16,33]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,L.createDecorator)("IExtHostTerminalService");class i extends b.Disposable{constructor(E,_,y,P){super(),this._proxy=E,this._id=_,this._creationOptions=y,this._name=P,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._onWillDispose=this._register(new c.Emitter),this.onWillDispose=this._onWillDispose.event,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(z=>this._pidPromiseComplete=z);const k=this;this.value={get name(){return k._name||""},get processId(){return k._pidPromise},get creationOptions(){return k._creationOptions},get exitStatus(){return k._exitStatus},get state(){return k._state},get selection(){return k._selection},get shellIntegration(){return k.shellIntegration},sendText(z,x=!0){k._checkDisposed(),k._proxy.$sendText(k._id,z,x)},show(z){k._checkDisposed(),k._proxy.$show(k._id,z)},hide(){k._checkDisposed(),k._proxy.$hide(k._id)},dispose(){k._disposed||(k._disposed=!0,k._proxy.$dispose(k._id))},get dimensions(){if(!(k._cols===void 0||k._rows===void 0))return{columns:k._cols,rows:k._rows}}}}dispose(){this._onWillDispose.fire(),super.dispose()}async create(E,_){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:E.name,shellPath:E.shellPath??void 0,shellArgs:E.shellArgs??void 0,cwd:E.cwd??_?.cwd??void 0,env:E.env??void 0,icon:u(E.iconPath)??void 0,color:a.ThemeColor.isThemeColor(E.color)?E.color.id:void 0,initialText:E.message??void 0,strictEnv:E.strictEnv??void 0,hideFromUser:E.hideFromUser??void 0,forceShellIntegration:_?.forceShellIntegration??void 0,isFeatureTerminal:_?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:_?.useShellEnvironment??void 0,location:_?.location||this._serializeParentTerminal(E.location,_?.resolvedExtHostIdentifier),isTransient:E.isTransient??void 0})}async createExtensionTerminal(E,_,y,P,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:P,color:a.ThemeColor.isThemeColor(k)?k.id:void 0,location:_?.location||this._serializeParentTerminal(E,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(E,_){return typeof E=="object"?"parentTerminal"in E&&E.parentTerminal&&_?{parentTerminal:_}:"viewColumn"in E?{viewColumn:o.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus}:void 0:E}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(E){this._name=E}setExitStatus(E,_){this._exitStatus=Object.freeze({code:E,reason:_})}setDimensions(E,_){return E===this._cols&&_===this._rows||E===0||_===0?!1:(this._cols=E,this._rows=_,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(E){this._selection=E}_setProcessId(E){this._pidPromiseComplete?(this._pidPromiseComplete(E),this._pidPromiseComplete=void 0):this._pidPromise.then(_=>{_!==E&&(this._pidPromise=Promise.resolve(E))})}}e.ExtHostTerminal=i;class r{get onProcessReady(){return this._onProcessReady.event}constructor(E){this._pty=E,this.id=0,this.shouldPersist=!1,this._onProcessData=new c.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new c.Emitter,this._onDidChangeProperty=new c.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new c.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(E){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${E}`)}updateProperty(E,_){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${E}, value: ${_}`)}async start(){}shutdown(){this._pty.close()}input(E){this._pty.handleInput?.(E)}resize(E,_){this._pty.setDimensions?.({columns:E,rows:_})}clearBuffer(){}async processBinary(E){}acknowledgeDataEvent(E){}async setUnicodeVersion(E){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(E){this._pty.onDidWrite(_=>this._onProcessData.fire(_)),this._pty.onDidClose?.((_=void 0)=>{this._onProcessExit.fire(_===void 0?void 0:_)}),this._pty.onDidOverrideDimensions?.(_=>{_&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:_.columns,rows:_.rows}})}),this._pty.onDidChangeName?.(_=>{this._onDidChangeProperty.fire({type:"title",value:_})}),this._pty.open(E||void 0),E&&this._pty.setDimensions?.(E),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,t=class extends b.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(E=>E.value)}constructor(E,_,y){super(),this._extHostCommands=_,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new b.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new c.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new c.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new c.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new c.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new c.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new c.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new c.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new c.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=y.getProxy(O.MainContext.MainThreadTerminalService),this._bufferer=new S.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(E),this._extHostCommands.registerArgumentProcessor({processArgument:P=>{const k=z=>{const x=z;return this.getTerminalById(x.instanceId)?.value};switch(P?.$mid){case 15:return k(P);default:{if(Array.isArray(P))for(let z=0;z<P.length&&P[z].$mid===15;z++)P[z]=k(P[z]);return P}}}}),this._register({dispose:()=>{for(const[P,k]of this._terminalProcesses)k.shutdown(!0)}})}getDefaultShell(E){return(E?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(E){return(E?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(E,_){const y=new i(this._proxy,(0,C.generateUuid)(),E,E.name),P=new r(E.pty);return y.createExtensionTerminal(E.location,_,this._serializeParentTerminal(E,_).resolvedExtHostIdentifier,u(E.iconPath),d(E.color)).then(k=>{const z=this._setupExtHostProcessListeners(k,P);this._terminalProcessDisposables[k]=z}),this._terminals.push(y),y.value}_serializeParentTerminal(E,_){if(_=_||{},E.location&&typeof E.location=="object"&&"parentTerminal"in E.location){const y=E.location.parentTerminal;if(y){const P=this._terminals.find(k=>k.value===y);P&&(_.resolvedExtHostIdentifier=P._id)}}else E.location&&typeof E.location!="object"?_.location=E.location:_.location&&typeof _.location=="object"&&"splitActiveTerminal"in _.location&&(_.location={splitActiveTerminal:!0});return _}attachPtyToTerminal(E,_){if(!this.getTerminalById(E))throw new Error(`Cannot resolve terminal with id ${E} for virtual process`);const P=new r(_),k=this._setupExtHostProcessListeners(E,P);this._terminalProcessDisposables[E]=k}async $acceptActiveTerminalChanged(E){const _=this._activeTerminal;if(E===null){this._activeTerminal=void 0,_!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const y=this.getTerminalById(E);y&&(this._activeTerminal=y,_!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(E,_){const y=this.getTerminalById(E);y&&this._onDidWriteTerminalData.fire({terminal:y.value,data:_})}async $acceptTerminalDimensions(E,_,y){const P=this.getTerminalById(E);P&&P.setDimensions(_,y)&&this._onDidChangeTerminalDimensions.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(E,_){const y=this.getTerminalById(E);y&&this._onDidExecuteCommand.fire({terminal:y.value,..._})}async $acceptTerminalMaximumDimensions(E,_,y){this._terminalProcesses.get(E)?.resize(_,y)}async $acceptTerminalTitleChange(E,_){const y=this.getTerminalById(E);y&&(y.name=_)}async $acceptTerminalClosed(E,_,y){const P=this._getTerminalObjectIndexById(this._terminals,E);if(P!==null){const k=this._terminals.splice(P,1)[0];k.setExitStatus(_,y),this._onDidCloseTerminal.fire(k.value)}}$acceptTerminalOpened(E,_,y,P){if(_){const x=this._getTerminalObjectIndexById(this._terminals,_);if(x!==null){this._terminals[x]._id=E,this._onDidOpenTerminal.fire(this.terminals[x]),this._terminals[x].isOpen=!0;return}}const k={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:T.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},z=new i(this._proxy,E,k,y);this._terminals.push(z),this._onDidOpenTerminal.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(E,_){this.getTerminalById(E)?._setProcessId(_)}async $startExtensionTerminal(E,_){const y=this.getTerminalById(E);if(!y)return{message:(0,w.localize)(0,null,E)};y.isOpen||await new Promise(k=>{const z=this.onDidOpenTerminal(async x=>{x===y.value&&(z.dispose(),k())})});const P=this._terminalProcesses.get(E);P?P.startSendingEvents(_):this._extensionTerminalAwaitingStart[E]={initialDimensions:_}}_setupExtHostProcessListeners(E,_){const y=new b.DisposableStore;y.add(_.onProcessReady(k=>this._proxy.$sendProcessReady(E,k.pid,k.cwd,k.windowsPty))),y.add(_.onDidChangeProperty(k=>this._proxy.$sendProcessProperty(E,k))),this._bufferer.startBuffering(E,_.onProcessData),y.add(_.onProcessExit(k=>this._onProcessExit(E,k))),this._terminalProcesses.set(E,_);const P=this._extensionTerminalAwaitingStart[E];return P&&_ instanceof r&&(_.startSendingEvents(P.initialDimensions),delete this._extensionTerminalAwaitingStart[E]),y}$acceptProcessAckDataEvent(E,_){this._terminalProcesses.get(E)?.acknowledgeDataEvent(_)}$acceptProcessInput(E,_){this._terminalProcesses.get(E)?.input(_)}$acceptTerminalInteraction(E){const _=this.getTerminalById(E);_?.setInteractedWith()&&this._onDidChangeTerminalState.fire(_.value)}$acceptTerminalSelection(E,_){this.getTerminalById(E)?.setSelection(_)}$acceptProcessResize(E,_,y){try{this._terminalProcesses.get(E)?.resize(_,y)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(E,_){this._terminalProcesses.get(E)?.shutdown(_)}$acceptProcessRequestInitialCwd(E){this._terminalProcesses.get(E)?.getInitialCwd().then(_=>this._proxy.$sendProcessProperty(E,{type:"initialCwd",value:_}))}$acceptProcessRequestCwd(E){this._terminalProcesses.get(E)?.getCwd().then(_=>this._proxy.$sendProcessProperty(E,{type:"cwd",value:_}))}$acceptProcessRequestLatency(E){return Promise.resolve(E)}registerLinkProvider(E){return this._linkProviders.add(E),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new p.Disposable(()=>{this._linkProviders.delete(E),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(E,_,y){if(this._profileProviders.has(_))throw new Error(`Terminal profile provider "${_}" already registered`);return this._profileProviders.set(_,y),this._proxy.$registerProfileProvider(_,E.identifier.value),new p.Disposable(()=>{this._profileProviders.delete(_),this._proxy.$unregisterProfileProvider(_)})}registerTerminalQuickFixProvider(E,_,y){if(this._quickFixProviders.has(E))throw new Error(`Terminal quick fix provider "${E}" is already registered`);return this._quickFixProviders.set(E,y),this._proxy.$registerQuickFixProvider(E,_),new p.Disposable(()=>{this._quickFixProviders.delete(E),this._proxy.$unregisterQuickFixProvider(E)})}async $provideTerminalQuickFixes(E,_){const y=new v.CancellationTokenSource().token;if(y.isCancellationRequested)return;const P=this._quickFixProviders.get(E);if(!P)return;const k=await P.provideTerminalQuickFixes(_,y);if(k===null||Array.isArray(k)&&k.length===0)return;const z=new b.DisposableStore;if(this._lastQuickFixCommands.value=z,!Array.isArray(k))return k?o.TerminalQuickFix.from(k,this._extHostCommands.converter,z):void 0;const x=[];for(const F of k){const N=o.TerminalQuickFix.from(F,this._extHostCommands.converter,z);N&&x.push(N)}return x}async $createContributedProfileTerminal(E,_){const y=new v.CancellationTokenSource().token;let P=await this._profileProviders.get(E)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${E}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,_);return}this.createTerminalFromOptions(P.options,_)}}async $provideLinks(E,_){const y=this.getTerminalById(E);if(!y)return[];this._terminalLinkCache.delete(E),this._terminalLinkCancellationSource.get(E)?.dispose(!0);const k=new v.CancellationTokenSource;this._terminalLinkCancellationSource.set(E,k);const z=[],x={terminal:y.value,line:_},F=[];for(const B of this._linkProviders)F.push(m.Promises.withAsyncBody(async W=>{k.token.onCancellationRequested(()=>W({provider:B,links:[]}));const Y=await B.provideTerminalLinks(x,k.token)||[];k.token.isCancellationRequested||W({provider:B,links:Y})}));const N=await Promise.all(F);if(k.token.isCancellationRequested)return[];const M=new Map;for(const B of N)B&&B.links.length>0&&z.push(...B.links.map(W=>{const Y={id:s++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return M.set(Y.id,{provider:B.provider,link:W}),Y}));return this._terminalLinkCache.set(E,M),z}$activateLink(E,_){const y=this._terminalLinkCache.get(E)?.get(_);y&&y.provider.handleTerminalLink(y.link)}_onProcessExit(E,_){this._bufferer.stopBuffering(E),this._terminalProcesses.delete(E),delete this._extensionTerminalAwaitingStart[E];const y=this._terminalProcessDisposables[E];y&&(y.dispose(),delete this._terminalProcessDisposables[E]),this._proxy.$sendProcessExit(E,_)}getTerminalById(E){return this._getTerminalObjectById(this._terminals,E)}getTerminalIdByApiObject(E){const _=this._terminals.findIndex(y=>y.value===E);return _>=0?_:null}_getTerminalObjectById(E,_){const y=this._getTerminalObjectIndexById(E,_);return y!==null?E[y]:null}_getTerminalObjectIndexById(E,_){const y=E.findIndex(P=>P._id===_);return y>=0?y:null}getEnvironmentVariableCollection(E){let _=this._environmentVariableCollections.get(E.identifier.value);return _||(_=new f,this._setEnvironmentVariableCollection(E.identifier.value,_)),_.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(E,_){const y=(0,I.serializeEnvironmentVariableCollection)(_.map),P=(0,I.serializeEnvironmentDescriptionMap)(_.descriptionMap);this._proxy.$setEnvironmentVariableCollection(E,_.persistent,y.length===0?void 0:y,P)}$initEnvironmentVariableCollections(E){E.forEach(_=>{const y=_[0],P=new f(_[1]);this._setEnvironmentVariableCollection(y,P)})}$acceptDefaultProfile(E,_){const y=this._defaultProfile;this._defaultProfile=E,this._defaultAutomationProfile=_,y?.path!==E.path&&this._onDidChangeShell.fire(E.path)}_setEnvironmentVariableCollection(E,_){this._environmentVariableCollections.set(E,_),_.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(E,_)})}};e.BaseExtHostTerminalService=t,e.BaseExtHostTerminalService=t=Ge([Ue(1,n.IExtHostCommands),Ue(2,R.IExtHostRpcService)],t);class f{get persistent(){return this._persistent}set persistent(E){this._persistent=E,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(E){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new c.Emitter,this.map=new Map(E)}getScopedEnvironmentVariableCollection(E){const _=this.getScopeKey(E);let y=this.scopedCollections.get(_);return y||(y=new h(this,E),this.scopedCollections.set(_,y),y.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),y}replace(E,_,y,P){this._setIfDiffers(E,{value:_,type:p.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:P})}append(E,_,y,P){this._setIfDiffers(E,{value:_,type:p.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:P})}prepend(E,_,y,P){this._setIfDiffers(E,{value:_,type:p.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:P})}_setIfDiffers(E,_){if(_.options&&_.options.applyAtProcessCreation===!1&&!_.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.getKey(E,_.scope),P=this.map.get(y),k=_.options?{applyAtProcessCreation:_.options.applyAtProcessCreation??!1,applyAtShellIntegration:_.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==_.value||P.type!==_.type||P.options?.applyAtProcessCreation!==k.applyAtProcessCreation||P.options?.applyAtShellIntegration!==k.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==_.scope?.workspaceFolder?.index){const z=this.getKey(E,_.scope),x={variable:E,..._,options:k};this.map.set(z,x),this._onDidChangeCollection.fire()}}get(E,_){const y=this.getKey(E,_),P=this.map.get(y);return P?g(P):void 0}getKey(E,_){const y=this.getScopeKey(_);return y.length?`${E}:::${y}`:E}getScopeKey(E){return this.getWorkspaceKey(E?.workspaceFolder)??""}getWorkspaceKey(E){return E?E.uri.toString():void 0}getVariableMap(E){const _=new Map;for(const[y,P]of this.map)this.getScopeKey(P.scope)===this.getScopeKey(E)&&_.set(P.variable,g(P));return _}delete(E,_){const y=this.getKey(E,_);this.map.delete(y),this._onDidChangeCollection.fire()}clear(E){if(E?.workspaceFolder){for(const[_,y]of this.map)y.scope?.workspaceFolder?.index===E.workspaceFolder.index&&this.map.delete(_);this.clearDescription(E)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(E,_){const y=this.getScopeKey(_),P=this.descriptionMap.get(y);if(!P||P.description!==E){let k;typeof E=="string"?k=E:k=E?.value.split(`

`)[0];const z={description:k,scope:_};this.descriptionMap.set(y,z),this._onDidChangeCollection.fire()}}getDescription(E){const _=this.getScopeKey(E);return this.descriptionMap.get(_)?.description}clearDescription(E){const _=this.getScopeKey(E);this.descriptionMap.delete(_)}}class h{get persistent(){return this.collection.persistent}set persistent(E){this.collection.persistent=E}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(E,_){this.collection=E,this.scope=_,this._onDidChangeCollection=new c.Emitter}getScoped(E){return this.collection.getScopedEnvironmentVariableCollection(E)}replace(E,_,y){this.collection.replace(E,_,y,this.scope)}append(E,_,y){this.collection.append(E,_,y,this.scope)}prepend(E,_,y){this.collection.prepend(E,_,y,this.scope)}get(E){return this.collection.get(E,this.scope)}forEach(E,_){this.collection.getVariableMap(this.scope).forEach((y,P)=>E.call(_,P,y,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(E){this.collection.delete(E,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(E){this.collection.setDescription(E,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let l=class extends t{constructor(E,_){super(!1,E,_)}createTerminal(E,_,y){throw new A.NotSupportedError}createTerminalFromOptions(E,_){throw new A.NotSupportedError}};e.WorkerExtHostTerminalService=l,e.WorkerExtHostTerminalService=l=Ge([Ue(0,n.IExtHostCommands),Ue(1,R.IExtHostRpcService)],l);function u(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function d(D){return a.ThemeColor.isThemeColor(D)?D:void 0}function g(D){const E={...D};return delete E.scope,E.options=E.options??void 0,delete E.variable,E}}),define(ye[155],_e([1,0,3,5,6,20,43,4,2,8]),function(de,e,c,O,L,T,R,b,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalShellIntegration=e.IExtHostTerminalShellIntegration=void 0,e.IExtHostTerminalShellIntegration=(0,O.createDecorator)("IExtHostTerminalShellIntegration");let A=class extends c.Disposable{constructor(a,m){super(),this._extHostTerminalService=m,this._activeShellIntegrations=new Map,this._onDidChangeTerminalShellIntegration=new b.Emitter,this.onDidChangeTerminalShellIntegration=this._onDidChangeTerminalShellIntegration.event,this._onDidStartTerminalShellExecution=new b.Emitter,this.onDidStartTerminalShellExecution=this._onDidStartTerminalShellExecution.event,this._onDidEndTerminalShellExecution=new b.Emitter,this.onDidEndTerminalShellExecution=this._onDidEndTerminalShellExecution.event,this._proxy=a.getProxy(L.MainContext.MainThreadTerminalShellIntegration),this._register((0,c.toDisposable)(()=>{for(const[o,n]of this._activeShellIntegrations)n.dispose();this._activeShellIntegrations.clear()}))}$shellIntegrationChange(a){const m=this._extHostTerminalService.getTerminalById(a);if(!m)return;const o=m.value;let n=this._activeShellIntegrations.get(a);n||(n=new I(m.value,this._onDidStartTerminalShellExecution),this._activeShellIntegrations.set(a,n),n.store.add(m.onWillDispose(()=>this._activeShellIntegrations.get(a)?.dispose())),n.store.add(n.onDidRequestShellExecution(i=>this._proxy.$executeCommand(a,i))),n.store.add(n.onDidRequestEndExecution(i=>this._onDidEndTerminalShellExecution.fire(i.value))),n.store.add(n.onDidRequestChangeShellIntegration(i=>this._onDidChangeTerminalShellIntegration.fire(i))),m.shellIntegration=n.value),this._onDidChangeTerminalShellIntegration.fire({terminal:o,shellIntegration:n.value})}$shellExecutionStart(a,m,o){this._activeShellIntegrations.has(a)||this.$shellIntegrationChange(a),this._activeShellIntegrations.get(a)?.startShellExecution(m,o)}$shellExecutionEnd(a,m,o){this._activeShellIntegrations.get(a)?.endShellExecution(m,o)}$shellExecutionData(a,m){this._activeShellIntegrations.get(a)?.emitData(m)}$cwdChange(a,m){this._activeShellIntegrations.get(a)?.setCwd(m)}$closeTerminal(a){this._activeShellIntegrations.get(a)?.dispose(),this._activeShellIntegrations.delete(a)}};e.ExtHostTerminalShellIntegration=A,e.ExtHostTerminalShellIntegration=A=Ge([Ue(0,T.IExtHostRpcService),Ue(1,R.IExtHostTerminalService)],A);class I extends c.Disposable{get currentExecution(){return this._currentExecution}constructor(a,m){super(),this._terminal=a,this._onDidStartTerminalShellExecution=m,this._ignoreNextExecution=!1,this.store=this._register(new c.DisposableStore),this._onDidRequestChangeShellIntegration=this._register(new b.Emitter),this.onDidRequestChangeShellIntegration=this._onDidRequestChangeShellIntegration.event,this._onDidRequestShellExecution=this._register(new b.Emitter),this.onDidRequestShellExecution=this._onDidRequestShellExecution.event,this._onDidRequestEndExecution=this._register(new b.Emitter),this.onDidRequestEndExecution=this._onDidRequestEndExecution.event;const o=this;this.value={get cwd(){return o._cwd},executeCommand(n){o._onDidRequestShellExecution.fire(n);const i=o.startShellExecution(n,o._cwd).value;return o._ignoreNextExecution=!0,i}}}startShellExecution(a,m){return this._ignoreNextExecution&&this._currentExecution?this._ignoreNextExecution=!1:(this._currentExecution&&(this._currentExecution.endExecution(void 0,void 0),this._onDidRequestEndExecution.fire(this._currentExecution)),this._currentExecution=new v(this._terminal,a,m),this._onDidStartTerminalShellExecution.fire(this._currentExecution.value)),this._currentExecution}emitData(a){this.currentExecution?.emitData(a)}endShellExecution(a,m){this._currentExecution&&(this._currentExecution.endExecution(a,m),this._onDidRequestEndExecution.fire(this._currentExecution),this._currentExecution=void 0)}setCwd(a){let m=!1;p.URI.isUri(this._cwd)?this._cwd.toString()!==a.toString()&&(m=!0):this._cwd!==a&&(m=!0),m&&(this._cwd=a,this._onDidRequestChangeShellIntegration.fire({terminal:this._terminal,shellIntegration:this.value}))}}class v{constructor(a,m,o){this.terminal=a,this._commandLine=m,this.cwd=o,this._exitCode=new Promise(i=>{this._exitCodeResolve=i});const n=this;this.value={get terminal(){return a},get commandLine(){return n._commandLine},get cwd(){return o},get exitCode(){return n._exitCode},createDataStream(){return n._createDataStream()}}}_createDataStream(){if(!this._dataStream){if(this._exitCodeResolve===void 0)return w.AsyncIterableObject.EMPTY;this._dataStream=new C}return this._dataStream.createIterable()}emitData(a){this._dataStream?.emitData(a)}endExecution(a,m){a&&(this._commandLine=a),this._dataStream?.endExecution(),this._dataStream=void 0,this._exitCodeResolve?.(m),this._exitCodeResolve=void 0}}class C extends c.Disposable{constructor(){super(...arguments),this._emitters=[]}createIterable(){const a=this._barrier=new w.Barrier;return new w.AsyncIterableObject(async o=>{this._emitters.push(o),await a.wait()})}emitData(a){for(const m of this._emitters)m.emitOne(a)}endExecution(){this._barrier?.open(),this._barrier=void 0}}}),define(ye[354],_e([1,0,8,21,22,4,74,55,3,18,30,12,6,20,154,16,7,67,112,89]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class extends p.Disposable{constructor(k,z,x,F){super(),this.editors=F,this.resultsChangedEmitter=this._register(new T.Emitter),this.controllers=new Map,this.defaultProfilesChangedEmitter=this._register(new T.Emitter),this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=k.getProxy(v.MainContext.MainThreadTesting),this.observer=new D(this.proxy),this.runTracker=new h(this.proxy,z),x.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const M=N,B=M.tests[M.tests.length-1].item.extId;return this.controllers.get(o.TestId.root(B))?.collection.tree.get(B)?.actual??(0,S.toItemFromContext)(N)}case 18:{const{test:M,message:B}=N,W=M.item.extId;return{test:this.controllers.get(o.TestId.root(W))?.collection.tree.get(W)?.actual??(0,S.toItemFromContext)({$mid:16,tests:[M]}),message:a.TestMessage.to(B)}}default:return N}}}),x.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await x.executeCommand("_testing.getExplorerSelection"),M=B=>{const W=this.controllers.get(o.TestId.root(B));if(W)return o.TestId.isRoot(B)?W.controller:W.collection.tree.get(B)?.actual};return{include:N?.include.map(M).filter(w.isDefined)||[],exclude:N?.exclude.map(M).filter(w.isDefined)||[]}})}createTestController(k,z,x,F){if(this.controllers.has(z))throw new Error(`Attempt to insert a duplicate controller with ID "${z}"`);const N=new p.DisposableStore,M=N.add(new S.ExtHostTestItemCollection(z,x,this.editors));M.root.label=x;const B=new Map,W=new Set,Y=this.proxy,Z={items:M.root.children,get label(){return x},set label(Q){x=Q,M.root.label=Q,Y.$updateController(z,{label:x})},get refreshHandler(){return F},set refreshHandler(Q){F=Q,Y.$updateController(z,{canRefresh:!!Q})},get id(){return z},createRunProfile:(Q,re,te,ve,Ie,J)=>{let $=(0,b.hash)(Q);for(;B.has($);)$++;return new _(this.proxy,B,W,this.defaultProfilesChangedEmitter.event,z,$,Q,re,te,ve,Ie,J)},createTestItem(Q,re,te){return new S.TestItemImpl(z,Q,re,te)},createTestRun:(Q,re,te=!0)=>this.runTracker.createTestRun(z,M,Q,re,te),invalidateTestResults:Q=>{if(Q===void 0)this.proxy.$markTestRetired(void 0);else{const re=Q instanceof Array?Q:[Q];this.proxy.$markTestRetired(re.map(te=>o.TestId.fromExtHostTestItem(te,z).toString()))}},set resolveHandler(Q){M.resolveHandler=Q},get resolveHandler(){return M.resolveHandler},dispose:()=>{N.dispose()}};Y.$registerTestController(z,x,!!F),N.add((0,p.toDisposable)(()=>Y.$unregisterTestController(z)));const G={controller:Z,collection:M,profiles:B,extension:k,activeProfiles:W};return this.controllers.set(z,G),N.add((0,p.toDisposable)(()=>this.controllers.delete(z))),N.add(M.onDidGenerateDiff(Q=>Y.$publishDiff(z,Q.map(i.TestsDiffOp.serialize)))),Z}createTestObserver(){return this.observer.checkout()}async runTests(k,z=L.CancellationToken.None){const x=l(k);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(x.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:k.include?.map(N=>o.TestId.fromExtHostTestItem(N,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:y[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:k.exclude?.map(N=>N.id)},z)}$syncTests(){for(const{collection:k}of this.controllers.values())k.flushDiff();return Promise.resolve()}async $getCoverageDetails(k,z){return(await this.runTracker.getCoverageDetails(k,z))?.map(a.TestCoverage.fromDetails)}async $disposeRun(k){this.runTracker.disposeTestRun(k)}$configureRunProfile(k,z){this.controllers.get(k)?.profiles.get(z)?.configureHandler?.()}$setDefaultRunProfiles(k){const z=new Map;for(const[x,F]of Object.entries(k)){const N=this.controllers.get(x);if(!N)continue;const M=new Map,B=F.filter(Y=>!N.activeProfiles.has(Y)),W=[...N.activeProfiles].filter(Y=>!F.includes(Y));for(const Y of B)M.set(Y,!0),N.activeProfiles.add(Y);for(const Y of W)M.set(Y,!1),N.activeProfiles.delete(Y);M.size&&z.set(x,M)}this.defaultProfilesChangedEmitter.fire(z)}async $refreshTests(k,z){await this.controllers.get(k)?.controller.refreshHandler?.(z)}$publishTestResults(k){this.results=Object.freeze(k.map(a.TestResults.to).concat(this.results).sort((z,x)=>x.completedAt-z.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(k,z){const x=this.controllers.get(o.TestId.fromString(k).controllerId)?.collection;x&&(await x.expand(k,z<0?1/0:z),x.flushDiff())}$acceptDiff(k){this.observer.applyDiff(k.map(z=>i.TestsDiffOp.deserialize({asCanonicalUri:x=>x},z)))}async $runControllerTests(k,z){return Promise.all(k.map(x=>this.runControllerTestRequest(x,!1,z)))}async $startContinuousRun(k,z){const x=new L.CancellationTokenSource(z),F=await Promise.all(k.map(N=>this.runControllerTestRequest(N,!0,x.token)));return!z.isCancellationRequested&&!F.some(N=>N.error)&&await new Promise(N=>z.onCancellationRequested(N)),x.dispose(!0),F}async runControllerTestRequest(k,z,x){const F=this.controllers.get(k.controllerId);if(!F)return{};const{collection:N,profiles:M}=F,B=M.get(k.profileId);if(!B)return{};const W=k.testIds.map(Q=>N.tree.get(Q)).filter(w.isDefined),Y=k.excludeExtIds.map(Q=>F.collection.tree.get(Q)).filter(w.isDefined).filter(Q=>W.some(re=>re.fullId.compare(Q.fullId)===2));if(!W.length)return{};const Z=new m.TestRunRequest(W.some(Q=>Q.actual instanceof S.TestItemRootImpl)?void 0:W.map(Q=>Q.actual),Y.map(Q=>Q.actual),B,z),G=(0,i.isStartControllerTests)(k)&&this.runTracker.prepareForMainThreadTestRun(Z,u.fromInternal(k,F.collection),B,x);try{return await B.runHandler(Z,x),{}}catch(Q){return{error:String(Q)}}finally{G&&G.hasRunningTasks&&!x.isCancellationRequested&&await T.Event.toPromise(G.onEnd)}}$cancelExtensionTestRun(k){k===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(k)}};e.ExtHostTesting=r,e.ExtHostTesting=r=Ge([Ue(0,C.IExtHostRpcService),Ue(1,I.ILogService)],r);const s=1e4;var t;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(t||(t={}));class f extends p.Disposable{get hasRunningTasks(){return this.running>0}get id(){return this.dto.id}constructor(k,z,x,F,N){super(),this.dto=k,this.proxy=z,this.logService=x,this.profile=F,this.state=0,this.running=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.publishedCoverage=new Map,this.onEnd=this.endEmitter.event,this.cts=this._register(new L.CancellationTokenSource(N));const M=this._register(new c.RunOnceScheduler(()=>this.forciblyEndTasks(),s));this._register(this.cts.token.onCancellationRequested(()=>M.schedule()));const B=new T.Emitter;this.onDidDispose=B.event,this._register((0,p.toDisposable)(()=>{B.fire(),B.dispose()}))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverageDetails(k,z){const[,x,F]=o.TestId.fromString(k).path,N=this.publishedCoverage.get(F);if(!N)return[];if(N.backCompatResolve)return N.backCompatResolve(z);const M=this.tasks.get(x);if(!M)throw new Error("unreachable: run task was not found");return this.profile?.loadDetailedCoverage?.(M.run,N.coverage,z)??[]}createRun(k){const z=this.dto.id,x=this.dto.controllerId,F=(0,A.generateUuid)(),N=G=>(Q,...re)=>{if(W){this.logService.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(Q)&&(this.ensureTestIsKnown(Q),G(Q,...re))},M=(G,Q)=>{const re=Q instanceof Array?Q.map(a.TestMessage.from):[a.TestMessage.from(Q)];if(G.uri&&G.range){const te={range:a.Range.from(G.range),uri:G.uri};for(const ve of re)ve.location=ve.location||te}this.proxy.$appendTestMessagesInRun(z,F,o.TestId.fromExtHostTestItem(G,x).toString(),re)},B=(G,Q)=>{const re=G.uri.toString(),te=new o.TestId([z,F,re]).toString();this.publishedCoverage.set(re,{coverage:G,backCompatResolve:Q}),this.proxy.$appendCoverage(z,F,a.TestCoverage.fromFile(te,G))};let W=!1,Y;const Z={isPersisted:this.dto.isPersisted,token:this.cts.token,name:k,onDidDispose:this.onDidDispose,get coverageProvider(){return Y},set coverageProvider(G){Y=G,G&&Promise.resolve(G.provideFileCoverage(L.CancellationToken.None)).then(Q=>{Q?.forEach(re=>B(re,G.resolveFileCoverage&&(async te=>(await G.resolveFileCoverage(re,te)||re).detailedCoverage)))})},addCoverage:B,enqueued:N(G=>{this.proxy.$updateTestStateInRun(z,F,o.TestId.fromExtHostTestItem(G,x).toString(),1)}),skipped:N(G=>{this.proxy.$updateTestStateInRun(z,F,o.TestId.fromExtHostTestItem(G,x).toString(),5)}),started:N(G=>{this.proxy.$updateTestStateInRun(z,F,o.TestId.fromExtHostTestItem(G,x).toString(),2)}),errored:N((G,Q,re)=>{M(G,Q),this.proxy.$updateTestStateInRun(z,F,o.TestId.fromExtHostTestItem(G,x).toString(),6,re)}),failed:N((G,Q,re)=>{M(G,Q),this.proxy.$updateTestStateInRun(z,F,o.TestId.fromExtHostTestItem(G,x).toString(),4,re)}),passed:N((G,Q)=>{this.proxy.$updateTestStateInRun(z,F,o.TestId.fromExtHostTestItem(G,this.dto.controllerId).toString(),3,Q)}),appendOutput:(G,Q,re)=>{W||(re&&(this.dto.isIncluded(re)?this.ensureTestIsKnown(re):re=void 0),this.proxy.$appendOutputToRun(z,F,O.VSBuffer.fromString(G),Q&&a.location.from(Q),re&&o.TestId.fromExtHostTestItem(re,x).toString()))},end:()=>{W||(W=!0,this.proxy.$finishedTestRunTask(z,F),--this.running||this.markEnded())}};return this.running++,this.tasks.set(F,{run:Z}),this.proxy.$startedTestRunTask(z,{id:F,name:k,running:!0}),Z}forciblyEndTasks(){for(const{run:k}of this.tasks.values())k.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(k){if(!(k instanceof S.TestItemImpl))throw new n.InvalidTestItemError(k.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(k,this.dto.controllerId).toString()))return;const z=[],x=this.dto.colllection.root;for(;;){const F=a.TestItem.from(k);if(z.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),k===x))break;k=k.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,z)}dispose(){this.markEnded(),super.dispose()}}class h{get trackers(){return this.tracked.values()}constructor(k,z){this.proxy=k,this.logService=z,this.tracked=new Map,this.trackedById=new Map}getCoverageDetails(k,z){const x=o.TestId.root(k);return this.trackedById.get(x)?.getCoverageDetails(k,z)||[]}disposeTestRun(k){this.trackedById.get(k)?.dispose(),this.trackedById.delete(k);for(const[z,{id:x}]of this.tracked)x===k&&this.tracked.delete(z)}prepareForMainThreadTestRun(k,z,x,F){return this.getTracker(k,z,x,F)}cancelRunById(k){this.trackedById.get(k)?.cancel()}cancelAllRuns(){for(const k of this.tracked.values())k.cancel()}createTestRun(k,z,x,F,N){const M=this.tracked.get(x);if(M)return M.createRun(F);const B=u.fromPublic(k,z,x,N),W=l(x);this.proxy.$startedExtensionTestRun({controllerId:k,continuous:!!x.continuous,profile:W&&{group:y[W.kind],id:W.profileId},exclude:x.exclude?.map(Z=>o.TestId.fromExtHostTestItem(Z,z.root.id).toString())??[],id:B.id,include:x.include?.map(Z=>o.TestId.fromExtHostTestItem(Z,z.root.id).toString())??[z.root.id],persist:N});const Y=this.getTracker(x,B,x.profile);return T.Event.once(Y.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(B.id)}),Y.createRun(F)}getTracker(k,z,x,F){const N=new f(z,this.proxy,this.logService,x,F);return this.tracked.set(k,N),this.trackedById.set(N.id,N),N}}e.TestRunCoordinator=h;const l=P=>{if(P.profile){if(!(P.profile instanceof _))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class u{static fromPublic(k,z,x,F){return new u(k,(0,A.generateUuid)(),x.include?.map(N=>o.TestId.fromExtHostTestItem(N,k).toString())??[k],x.exclude?.map(N=>o.TestId.fromExtHostTestItem(N,k).toString())??[],F,z)}static fromInternal(k,z){return new u(k.controllerId,k.runId,k.testIds,k.excludeExtIds,!0,z)}constructor(k,z,x,F,N,M){this.controllerId=k,this.id=z,this.isPersisted=N,this.colllection=M,this.includePrefix=x.map(B=>B+"\0"),this.excludePrefix=F.map(B=>B+"\0")}isIncluded(k){const z=o.TestId.fromExtHostTestItem(k,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(z===x||z.startsWith(x))return!1;for(const x of this.includePrefix)if(z===x||z.startsWith(x))return!0;return!1}}e.TestRunDto=u;class d{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(k){this.emitter=k,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(k){this.added.add(k)}update(k){Object.assign(k.revived,a.TestItem.toPlain(k.item)),this.added.has(k)||this.updated.add(k)}remove(k){if(this.added.has(k)){this.added.delete(k);return}this.updated.delete(k);const z=o.TestId.parentId(k.item.extId);if(z&&this.alreadyRemoved.has(z.toString())){this.alreadyRemoved.add(k.item.extId);return}this.removed.add(k)}getChangeEvent(){const{added:k,updated:z,removed:x}=this;return{get added(){return[...k].map(F=>F.revived)},get updated(){return[...z].map(F=>F.revived)},get removed(){return[...x].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class g extends i.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(k){return this.items.get(k)}getMirroredTestDataByReference(k){return this.items.get(k.id)}createItem(k,z){return{...k,revived:a.TestItem.toPlain(k.item),depth:z?z.depth+1:0,children:new Set}}createChangeCollector(){return new d(this.changeEmitter)}}class D{constructor(k){this.proxy=k}checkout(){this.current||(this.current=this.createObserverData());const k=this.current;return k.observers++,{onDidChangeTest:k.tests.onDidChangeTests,get tests(){return[...k.tests.rootTests].map(z=>z.revived)},dispose:(0,R.createSingleCallFunction)(()=>{--k.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(k){return this.current?.tests.getMirroredTestDataByReference(k)}applyDiff(k){this.current?.tests.apply(k)}createObserverData(){const k=new g({asCanonicalUri:z=>z});return this.proxy.$subscribeToDiffs(),{observers:0,tests:k}}}const E=(P,k,z,x)=>{z?Object.assign(z,x):k.$updateTestRunConfig(P.controllerId,P.profileId,x)};class _{#e;#t;#i;#n;#s;get label(){return this._label}set label(k){k!==this._label&&(this._label=k,E(this,this.#e,this.#n,{label:k}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(k){k!==this._supportsContinuousRun&&(this._supportsContinuousRun=k,E(this,this.#e,this.#n,{supportsContinuousRun:k}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(k){k!==this.isDefault&&(k?this.#t.add(this.profileId):this.#t.delete(this.profileId),E(this,this.#e,this.#n,{isDefault:k}))}get tag(){return this._tag}set tag(k){k?.id!==this._tag?.id&&(this._tag=k,E(this,this.#e,this.#n,{tag:k?a.TestTag.namespace(this.controllerId,k.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(k){k!==this._configureHandler&&(this._configureHandler=k,E(this,this.#e,this.#n,{hasConfigurationHandler:!!k}))}get onDidChangeDefault(){return T.Event.chain(this.#i,k=>k.map(z=>z.get(this.controllerId)?.get(this.profileId)).filter(w.isDefined))}constructor(k,z,x,F,N,M,B,W,Y,Z=!1,G=void 0,Q=!1){this.controllerId=N,this.profileId=M,this._label=B,this.kind=W,this.runHandler=Y,this._tag=G,this._supportsContinuousRun=Q,this.#e=k,this.#s=z,this.#t=x,this.#i=F,z.set(M,this);const re=y[W];if(typeof re!="number")throw new Error(`Unknown TestRunProfile.group ${W}`);Z&&x.add(M),this.#n={profileId:M,controllerId:N,tag:G?a.TestTag.namespace(this.controllerId,G.id):null,label:B,group:re,isDefault:Z,hasConfigurationHandler:!1,supportsContinuousRun:Q},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.TestRunProfileImpl=_;const y={[m.TestRunProfileKind.Coverage]:8,[m.TestRunProfileKind.Debug]:4,[m.TestRunProfileKind.Run]:2}}),define(ye[156],_e([1,0,61,13,124,16,7]),function(de,e,c,O,L,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class b{static{this._Keys=new L.IdGenerator("TextEditorDecorationType")}constructor(v,C,S){const a=b._Keys.nextId();v.$registerTextEditorDecorationType(C.identifier,a,T.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:a,dispose(){v.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=b;class p{constructor(v,C){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=v,this._documentVersionId=v.version,this._undoStopBefore=C.undoStopBefore,this._undoStopAfter=C.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(v,C){this._throwIfFinalized();let S=null;if(v instanceof R.Position)S=new R.Range(v,v);else if(v instanceof R.Range)S=v;else throw new Error("Unrecognized location");this._pushEdit(S,C,!1)}insert(v,C){this._throwIfFinalized(),this._pushEdit(new R.Range(v,v),C,!0)}delete(v){this._throwIfFinalized();let C=null;if(v instanceof R.Range)C=v;else throw new Error("Unrecognized location");this._pushEdit(C,null,!0)}_pushEdit(v,C,S){const a=this._document.validateRange(v);this._collectedEdits.push({range:a,text:C,forceMoveMarkers:S})}setEndOfLine(v){if(this._throwIfFinalized(),v!==R.EndOfLine.LF&&v!==R.EndOfLine.CRLF)throw(0,O.illegalArgument)("endOfLine");this._setEndOfLine=v}}class w{constructor(v,C,S,a){this._proxy=v,this._id=C,this._accept(S),this._logService=a;const m=this;this.value={get tabSize(){return m._tabSize},set tabSize(o){m._setTabSize(o)},get indentSize(){return m._indentSize},set indentSize(o){m._setIndentSize(o)},get insertSpaces(){return m._insertSpaces},set insertSpaces(o){m._setInsertSpaces(o)},get cursorStyle(){return m._cursorStyle},set cursorStyle(o){m._setCursorStyle(o)},get lineNumbers(){return m._lineNumbers},set lineNumbers(o){m._setLineNumbers(o)}}}_accept(v){this._tabSize=v.tabSize,this._indentSize=v.indentSize,this._originalIndentSize=v.originalIndentSize,this._insertSpaces=v.insertSpaces,this._cursorStyle=v.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(v.lineNumbers)}_validateTabSize(v){if(v==="auto")return"auto";if(typeof v=="number"){const C=Math.floor(v);return C>0?C:null}if(typeof v=="string"){const C=parseInt(v,10);return isNaN(C)?null:C>0?C:null}return null}_setTabSize(v){const C=this._validateTabSize(v);if(C!==null){if(typeof C=="number"){if(this._tabSize===C)return;this._tabSize=C}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:C}))}}_validateIndentSize(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const C=Math.floor(v);return C>0?C:null}if(typeof v=="string"){const C=parseInt(v,10);return isNaN(C)?null:C>0?C:null}return null}_setIndentSize(v){const C=this._validateIndentSize(v);if(C!==null){if(typeof C=="number"){if(this._originalIndentSize===C)return;this._indentSize=C,this._originalIndentSize=C}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:C}))}}_validateInsertSpaces(v){return v==="auto"?"auto":v==="false"?!1:!!v}_setInsertSpaces(v){const C=this._validateInsertSpaces(v);if(typeof C=="boolean"){if(this._insertSpaces===C)return;this._insertSpaces=C}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:C}))}_setCursorStyle(v){this._cursorStyle!==v&&(this._cursorStyle=v,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:v})))}_setLineNumbers(v){this._lineNumbers!==v&&(this._lineNumbers=v,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(v)})))}assign(v){const C={};let S=!1;if(typeof v.tabSize<"u"){const a=this._validateTabSize(v.tabSize);a==="auto"?(S=!0,C.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,S=!0,C.tabSize=a)}if(typeof v.indentSize<"u"){const a=this._validateIndentSize(v.indentSize);a==="tabSize"?(S=!0,C.indentSize=a):typeof a=="number"&&this._originalIndentSize!==a&&(this._indentSize=a,this._originalIndentSize=a,S=!0,C.indentSize=a)}if(typeof v.insertSpaces<"u"){const a=this._validateInsertSpaces(v.insertSpaces);a==="auto"?(S=!0,C.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,S=!0,C.insertSpaces=a)}typeof v.cursorStyle<"u"&&this._cursorStyle!==v.cursorStyle&&(this._cursorStyle=v.cursorStyle,S=!0,C.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this._lineNumbers!==v.lineNumbers&&(this._lineNumbers=v.lineNumbers,S=!0,C.lineNumbers=T.TextEditorLineNumbersStyle.from(v.lineNumbers)),S&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,C))}_warnOnError(v,C){C.catch(S=>{this._logService.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this._logService.warn(S)})}}e.ExtHostTextEditorOptions=w;class A{constructor(v,C,S,a,m,o,n,i){this.id=v,this._proxy=C,this._logService=S,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=m,this._options=new w(this._proxy,this.id,o,S),this._visibleRanges=n,this._viewColumn=i;const r=this;this.value=Object.freeze({get document(){return a.value},set document(s){throw new O.ReadonlyError("document")},get selection(){return r._selections&&r._selections[0]},set selection(s){if(!(s instanceof R.Selection))throw(0,O.illegalArgument)("selection");r._selections=[s],r._trySetSelection()},get selections(){return r._selections},set selections(s){if(!Array.isArray(s)||s.some(t=>!(t instanceof R.Selection)))throw(0,O.illegalArgument)("selections");r._selections=s,r._trySetSelection()},get visibleRanges(){return r._visibleRanges},set visibleRanges(s){throw new O.ReadonlyError("visibleRanges")},get options(){return r._options.value},set options(s){r._disposed||r._options.assign(s)},get viewColumn(){return r._viewColumn},set viewColumn(s){throw new O.ReadonlyError("viewColumn")},edit(s,t={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new p(a.value,t);return s(f),r._applyEdit(f)},insertSnippet(s,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let h;if(!t||Array.isArray(t)&&t.length===0)h=r._selections.map(l=>T.Range.from(l));else if(t instanceof R.Position){const{lineNumber:l,column:u}=T.Position.from(t);h=[{startLineNumber:l,startColumn:u,endLineNumber:l,endColumn:u}]}else if(t instanceof R.Range)h=[T.Range.from(t)];else{h=[];for(const l of t)if(l instanceof R.Range)h.push(T.Range.from(l));else{const{lineNumber:u,column:d}=T.Position.from(l);h.push({startLineNumber:u,startColumn:d,endLineNumber:u,endColumn:d})}}return C.$tryInsertSnippet(v,a.value.version,s.value,h,f)},setDecorations(s,t){const f=t.length===0;f&&!r._hasDecorationsForKey.has(s.key)||(f?r._hasDecorationsForKey.delete(s.key):r._hasDecorationsForKey.add(s.key),r._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return C.$trySetDecorations(v,s.key,T.fromRangeOrRangeWithMessage(t));{const h=new Array(4*t.length);for(let l=0,u=t.length;l<u;l++){const d=t[l];h[4*l]=d.start.line+1,h[4*l+1]=d.start.character+1,h[4*l+2]=d.end.line+1,h[4*l+3]=d.end.character+1}return C.$trySetDecorationsFast(v,s.key,h)}}))},revealRange(s,t){r._runOnProxy(()=>C.$tryRevealRange(v,T.Range.from(s),t||R.TextEditorRevealType.Default))},show(s){C.$tryShowEditor(v,T.ViewColumn.from(s))},hide(){C.$tryHideEditor(v)}})}dispose(){(0,c.ok)(!this._disposed),this._disposed=!0}_acceptOptions(v){(0,c.ok)(!this._disposed),this._options._accept(v)}_acceptVisibleRanges(v){(0,c.ok)(!this._disposed),this._visibleRanges=v}_acceptViewColumn(v){(0,c.ok)(!this._disposed),this._viewColumn=v}_acceptSelections(v){(0,c.ok)(!this._disposed),this._selections=v}async _trySetSelection(){const v=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,v)),this.value}_applyEdit(v){const C=v.finalize();if(C.edits.length===0&&!C.setEndOfLine)return Promise.resolve(!0);const S=C.edits.map(m=>m.range);S.sort((m,o)=>m.end.line===o.end.line?m.end.character===o.end.character?m.start.line===o.start.line?m.start.character-o.start.character:m.start.line-o.start.line:m.end.character-o.end.character:m.end.line-o.end.line);for(let m=0,o=S.length-1;m<o;m++){const n=S[m].end;if(S[m+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=C.edits.map(m=>({range:T.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,a,{setEndOfLine:typeof C.setEndOfLine=="number"?T.EndOfLine.from(C.setEndOfLine):void 0,undoStopBefore:C.undoStopBefore,undoStopAfter:C.undoStopAfter})}_runOnProxy(v){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,C=>(C instanceof Error&&C.name==="DISPOSED"||this._logService.warn(C),null))}}e.ExtHostTextEditor=A}),define(ye[72],_e([1,0,61,4,3,2,5,6,152,20,156,16,12,27,15,38,46]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class o{constructor(r){this.value=r,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let n=class{constructor(r,s){this._extHostRpc=r,this._logService=s,this._activeEditorId=null,this._editors=new Map,this._documents=new C.ResourceMap,this._onDidAddDocuments=new O.Emitter,this._onDidRemoveDocuments=new O.Emitter,this._onDidChangeVisibleTextEditors=new O.Emitter,this._onDidChangeActiveTextEditor=new O.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const s=[],t=[],f=[];if(r.removedDocuments)for(const h of r.removedDocuments){const l=T.URI.revive(h),u=this._documents.get(l);u?.unref()&&(this._documents.delete(l),s.push(u.value))}if(r.addedDocuments)for(const h of r.addedDocuments){const l=T.URI.revive(h.uri);let u=this._documents.get(l);if(u&&l.scheme!==S.Schemas.vscodeNotebookCell&&l.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);u||(u=new o(new p.ExtHostDocumentData(this._extHostRpc.getProxy(b.MainContext.MainThreadDocuments),l,h.lines,h.EOL,h.versionId,h.languageId,h.isDirty)),this._documents.set(l,u),t.push(u.value)),u.ref()}if(r.removedEditors)for(const h of r.removedEditors){const l=this._editors.get(h);this._editors.delete(h),l&&f.push(l)}if(r.addedEditors)for(const h of r.addedEditors){const l=T.URI.revive(h.documentUri);c.ok(this._documents.has(l),`document '${l}' does not exist`),c.ok(!this._editors.has(h.id),`editor '${h.id}' already exists!`);const u=this._documents.get(l).value,d=new A.ExtHostTextEditor(h.id,this._extHostRpc.getProxy(b.MainContext.MainThreadTextEditors),this._logService,new m.Lazy(()=>u.document),h.selections.map(I.Selection.to),h.options,h.visibleRanges.map(g=>I.Range.to(g)),typeof h.editorPosition=="number"?I.ViewColumn.to(h.editorPosition):void 0);this._editors.set(h.id,d)}r.newActiveEditor!==void 0&&(c.ok(r.newActiveEditor===null||this._editors.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this._activeEditorId=r.newActiveEditor),(0,L.dispose)(s),(0,L.dispose)(f),r.removedDocuments&&this._onDidRemoveDocuments.fire(s),r.addedDocuments&&this._onDidAddDocuments.fire(t),(r.removedEditors||r.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(h=>h.value)),r.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(r){return this._documents.get(r)?.value}allDocuments(){return a.Iterable.map(this._documents.values(),r=>r.value)}getEditor(r){return this._editors.get(r)}activeEditor(r){if(!this._activeEditorId)return;const s=this._editors.get(this._activeEditorId);return r?s:s?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=n,e.ExtHostDocumentsAndEditors=n=Ge([Ue(0,w.IExtHostRpcService),Ue(1,v.ILogService)],n),e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[355],_e([1,0,19,4,6,156,16,7]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class p{constructor(A,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new O.Emitter,this._onDidChangeTextEditorOptions=new O.Emitter,this._onDidChangeTextEditorVisibleRanges=new O.Emitter,this._onDidChangeTextEditorViewColumn=new O.Emitter,this._onDidChangeActiveTextEditor=new O.Emitter,this._onDidChangeVisibleTextEditors=new O.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=A.getProxy(L.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(v=>this._onDidChangeVisibleTextEditors.fire(v)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(v=>this._onDidChangeActiveTextEditor.fire(v))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(A){const I=this._extHostDocumentsAndEditors.allEditors();return A?I:I.map(v=>v.value)}async showTextDocument(A,I,v){let C;typeof I=="number"?C={position:R.ViewColumn.from(I),preserveFocus:v}:typeof I=="object"?C={position:R.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?R.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:C={preserveFocus:!1};const S=await this._proxy.$tryShowTextDocument(A.uri,C),a=S&&this._extHostDocumentsAndEditors.getEditor(S);if(a)return a.value;throw S?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,I){return new T.TextEditorDecorationType(this._proxy,A,I).value}$acceptEditorPropertiesChanged(A,I){const v=this._extHostDocumentsAndEditors.getEditor(A);if(!v)throw new Error("unknown text editor");if(I.options&&v._acceptOptions(I.options),I.selections){const C=I.selections.selections.map(R.Selection.to);v._acceptSelections(C)}if(I.visibleRanges){const C=c.coalesce(I.visibleRanges.map(R.Range.to));v._acceptVisibleRanges(C)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:v.value,options:{...I.options,lineNumbers:R.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const C=b.TextEditorSelectionChangeKind.fromValue(I.selections.source),S=I.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:v.value,selections:S,kind:C})}if(I.visibleRanges){const C=c.coalesce(I.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:v.value,visibleRanges:C})}}$acceptEditorPositionData(A){for(const I in A){const v=this._extHostDocumentsAndEditors.getEditor(I);if(!v)throw new Error("Unknown text editor");const C=R.ViewColumn.to(A[I]);v.value.viewColumn!==C&&(v._acceptViewColumn(C),this._onDidChangeTextEditorViewColumn.fire({textEditor:v.value,viewColumn:C}))}}getDiffInformation(A){return Promise.resolve(this._proxy.$getDiffInformation(A))}}e.ExtHostEditors=p}),define(ye[356],_e([1,0,2,5,6,3,7,16,25,18]),function(de,e,c,O,L,T,R,b,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,O.createDecorator)("IExtHostTimeline");class A{constructor(C,S){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=C.getProxy(L.MainContext.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(a,m)=>{if(a&&a.$mid===12)if(this._providers.get(a.source)&&p.ExtensionIdentifier.equals(m,this._providers.get(a.source)?.extension)){const o=a.uri===void 0?void 0:c.URI.revive(a.uri);return this._itemsBySourceAndUriMap.get(a.source)?.get(I(o))?.get(a.handle)}else return;return a}})}async $getTimeline(C,S,a,m){return this._providers.get(C)?.provider.provideTimeline(c.URI.revive(S),a,m)}registerTimelineProvider(C,S,a,m){const o=new T.DisposableStore,n=this.convertTimelineItem(S.id,m,o).bind(this);let i;S.onDidChange&&(i=S.onDidChange(s=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...s,id:S.id}),this));const r=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...S,scheme:C,onDidChange:void 0,async provideTimeline(s,t,f){t?.resetCache&&(o.clear(),r.get(S.id)?.clear());const h=await S.provideTimeline(s,t,f);if(h==null)return;const l=n(s,t);return{...h,source:S.id,items:h.items.map(l)}},dispose(){for(const s of r.values())s.get(S.id)?.clear();i?.dispose(),o.dispose()}},a)}convertTimelineItem(C,S,a){return(m,o)=>{let n;if(o?.cacheResults){let i=this._itemsBySourceAndUriMap.get(C);i===void 0&&(i=new Map,this._itemsBySourceAndUriMap.set(C,i));const r=I(m);n=i.get(r),n===void 0&&(n=new Map,i.set(r,n))}return i=>{const{iconPath:r,...s}=i,t=`${C}|${i.id??i.timestamp}`;n?.set(t,i);let f,h,l;i.iconPath&&(r instanceof R.ThemeIcon?l={id:r.id,color:r.color}:c.URI.isUri(r)?(f=r,h=r):{light:f,dark:h}=r);let u;return R.MarkdownString.isMarkdownString(s.tooltip)?u=b.MarkdownString.from(s.tooltip):(0,w.isString)(s.tooltip)?u=s.tooltip:R.MarkdownString.isMarkdownString(s.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=b.MarkdownString.from(s.detail)):(0,w.isString)(s.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=s.detail),{...s,id:s.id??void 0,handle:t,source:C,command:i.command?S.toInternal(i.command,a):void 0,icon:f,iconDark:h,themeIcon:l,tooltip:u,accessibilityInformation:i.accessibilityInformation}}}}registerTimelineProviderCore(C,S){if(this._providers.get(C.id))throw new Error(`Timeline Provider ${C.id} already exists.`);return this._proxy.$registerTimelineProvider({id:C.id,label:C.label,scheme:C.scheme}),this._providers.set(C.id,{provider:C,extension:S}),(0,T.toDisposable)(()=>{for(const m of this._itemsBySourceAndUriMap.values())m.get(C.id)?.clear();this._providers.delete(C.id),this._proxy.$unregisterTimelineProvider(C.id),C.dispose()})}}e.ExtHostTimeline=A;function I(v){return v?.toString()}}),define(ye[357],_e([1,0,228,23,2,4,3,288,8,7,18,19,16,80,22,184,26]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(r,s){if((0,A.isString)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class n extends R.Disposable{constructor(s,t,f){super(),this._proxy=s,this.commands=t,this.logService=f,this.treeViews=new Map,this.treeDragAndDropService=new a.TreeViewsDnDService;function h(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>h(l)?this.convertArgument(l):Array.isArray(l)&&l.length>0?l.map(u=>h(u)?this.convertArgument(u):u):l})}registerTreeDataProvider(s,t,f){const h=this.createTreeView(s,{treeDataProvider:t},f);return{dispose:()=>h.dispose()}}createTreeView(s,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],u=!!t.dragAndDropController?.handleDrag,d=!!t.dragAndDropController?.handleDrop,g=this.createExtHostTreeView(s,t,f),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:h,dragMimeTypes:l,hasHandleDrag:u,hasHandleDrop:d,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},E=this._proxy.$registerTreeViewDataProvider(s,D),_={get onDidCollapseElement(){return g.onDidCollapseElement},get onDidExpandElement(){return g.onDidExpandElement},get selection(){return g.selectedElements},get onDidChangeSelection(){return g.onDidChangeSelection},get activeItem(){return(0,m.checkProposedApiEnabled)(f,"treeViewActiveItem"),g.focusedElement},get onDidChangeActiveItem(){return(0,m.checkProposedApiEnabled)(f,"treeViewActiveItem"),g.onDidChangeActiveItem},get visible(){return g.visible},get onDidChangeVisibility(){return g.onDidChangeVisibility},get onDidChangeCheckboxState(){return g.onDidChangeCheckboxState},get message(){return g.message},set message(y){(0,C.isMarkdownString)(y)&&(0,m.checkProposedApiEnabled)(f,"treeViewMarkdownMessage"),g.message=y},get title(){return g.title},set title(y){g.title=y},get description(){return g.description},set description(y){g.description=y},get badge(){return g.badge},set badge(y){y!==void 0&&w.ViewBadge.isViewBadge(y)?g.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(g.badge=void 0)},reveal:(y,P)=>g.reveal(y,P),dispose:async()=>{await E,this.treeViews.delete(s),g.dispose()}};return this._register(_),_}$getChildren(s,t){const f=this.treeViews.get(s);return f?f.getChildren(t):Promise.reject(new b.NoTreeViewError(s))}async $handleDrop(s,t,f,h,l,u,d,g){const D=this.treeViews.get(s);if(!D)return Promise.reject(new b.NoTreeViewError(s));const E=v.DataTransfer.toDataTransfer(f,async _=>(await this._proxy.$resolveDropFileData(s,t,_)).buffer);return d===s&&g&&await this.addAdditionalTransferItems(E,D,g,l,u),D.onDrop(E,h,l)}async addAdditionalTransferItems(s,t,f,h,l){const u=this.treeDragAndDropService.removeDragOperationTransfer(l);if(u)(await u)?.forEach((d,g)=>{d&&s.set(g,d)});else if(l&&t.handleDrag){const d=t.handleDrag(f,s,h);this.treeDragAndDropService.addDragOperationTransfer(l,d),await d}return s}async $handleDrag(s,t,f,h){const l=this.treeViews.get(s);if(!l)return Promise.reject(new b.NoTreeViewError(s));const u=await this.addAdditionalTransferItems(new w.DataTransfer,l,t,h,f);if(!(!u||h.isCancellationRequested))return v.DataTransfer.from(u)}async $hasResolve(s){const t=this.treeViews.get(s);if(!t)throw new b.NoTreeViewError(s);return t.hasResolve}$resolve(s,t,f){const h=this.treeViews.get(s);if(!h)throw new b.NoTreeViewError(s);return h.resolveTreeItem(t,f)}$setExpanded(s,t,f){const h=this.treeViews.get(s);if(!h)throw new b.NoTreeViewError(s);h.setExpanded(t,f)}$setSelectionAndFocus(s,t,f){const h=this.treeViews.get(s);if(!h)throw new b.NoTreeViewError(s);h.setSelectionAndFocus(t,f)}$setVisible(s,t){const f=this.treeViews.get(s);if(!f){if(!t)return;throw new b.NoTreeViewError(s)}f.setVisible(t)}$changeCheckboxState(s,t){const f=this.treeViews.get(s);if(!f)throw new b.NoTreeViewError(s);f.setCheckboxState(t)}createExtHostTreeView(s,t,f){const h=this._register(new i(s,t,this._proxy,this.commands.converter,this.logService,f));return this.treeViews.set(s,h),h}convertArgument(s){const t=this.treeViews.get(s.$treeViewId);return t&&"$treeItemHandle"in s?t.getExtensionElement(s.$treeItemHandle):t&&"$focusedTreeItem"in s&&s.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=n;class i extends R.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(s=>this.getExtensionElement(s)).filter(s=>!(0,A.isUndefinedOrNull)(s))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(s,t,f,h,l,u){if(super(),this.viewId=s,this.proxy=f,this.commands=h,this.logService=l,this.extension=u,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new T.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new T.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new S.CancellationTokenSource,u.contributes&&u.contributes.views)for(const E in u.contributes.views)for(const _ of u.contributes.views[E])_.id===s&&(this._title=_.name);this.dataProvider=t.treeDataProvider,this.dndController=t.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(E=>this._onDidChangeData.fire({message:!1,element:E})));let d,g;const D=T.Event.debounce(this._onDidChangeData.event,(E,_)=>(E||(E={message:!1,elements:[]}),_.element!==!1&&(d||(d=new Promise(y=>g=y),this.refreshPromise=this.refreshPromise.then(()=>d)),Array.isArray(_.element)?E.elements.push(..._.element):E.elements.push(_.element)),_.message&&(E.message=!0),E),200,!0);this._register(D(({message:E,elements:_})=>{_.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const y=g;return d=null,this.refresh(_).then(()=>y())})),E&&this.proxy.$setMessage(this.viewId,v.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(s){const t=s?this.getExtensionElement(s):void 0;if(s&&!t)return this.logService.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let f=this.getChildrenNodes(s);return f||(f=await this.fetchChildrenNodes(t)),f?f.map(h=>h.item):void 0}getExtensionElement(s){return this.elements.get(s)}reveal(s,t){t=t||{select:!0,focus:!1};const f=(0,A.isUndefinedOrNull)(t.select)?!0:t.select,h=(0,A.isUndefinedOrNull)(t.focus)?!1:t.focus,l=(0,A.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.refreshPromise.then(()=>this.resolveUnknownParentChain(s)).then(u=>this.resolveTreeNode(s,u[u.length-1]).then(d=>this.proxy.$reveal(this.viewId,{item:d.item,parentChain:u.map(g=>g.item)},{select:f,focus:h,expand:l})),u=>this.logService.error(u)):this.proxy.$reveal(this.viewId,void 0,{select:f,focus:h,expand:l})}get message(){return this._message}set message(s){this._message=s,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(s){this._title=s,this.proxy.$setTitle(this.viewId,s,this._description)}get description(){return this._description}set description(s){this._description=s,this.proxy.$setTitle(this.viewId,this._title,s)}get badge(){return this._badge}set badge(s){this._badge?.value===s?.value&&this._badge?.tooltip===s?.tooltip||(this._badge=v.ViewBadge.from(s),this.proxy.$setBadge(this.viewId,s))}setExpanded(s,t){const f=this.getExtensionElement(s);f&&(t?this._onDidExpandElement.fire(Object.freeze({element:f})):this._onDidCollapseElement.fire(Object.freeze({element:f})))}setSelectionAndFocus(s,t){const f=!(0,I.equals)(this._selectedHandles,s);this._selectedHandles=s;const h=this._focusedHandle!==t;this._focusedHandle=t,f&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),h&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(s){s!==this._visible&&(this._visible=s,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(s){const t=(await Promise.all(s.map(async f=>{const h=this.getExtensionElement(f.treeItemHandle);return h?{extensionItem:h,treeItem:await this.dataProvider.getTreeItem(h),newState:f.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(s,t,f){const h=[];for(const l of s){const u=this.getExtensionElement(l);u&&h.push(u)}if(!(!this.dndController?.handleDrag||h.length===0))return await this.dndController.handleDrag(h,t,f),t}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(s,t,f){const h=t?this.getExtensionElement(t):void 0;if(!(!h&&t||!this.dndController?.handleDrop))return(0,p.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(h,s,f):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(s,t){if(!this.dataProvider.resolveTreeItem)return;const f=this.elements.get(s);if(f){const h=this.nodes.get(f);if(h){const l=await this.dataProvider.resolveTreeItem(h.extensionItem,f,t)??h.extensionItem;return this.validateTreeItem(l),h.item.tooltip=this.getTooltip(l.tooltip),h.item.command=this.getCommand(h.disposableStore,l.command),h.item}}}resolveUnknownParentChain(s){return this.resolveParent(s).then(t=>t?this.resolveUnknownParentChain(t).then(f=>this.resolveTreeNode(t,f[f.length-1]).then(h=>(f.push(h),f))):Promise.resolve([]))}resolveParent(s){const t=this.nodes.get(s);return t?Promise.resolve(t.parent?this.elements.get(t.parent.item.handle):void 0):(0,p.asPromise)(()=>this.dataProvider.getParent(s))}resolveTreeNode(s,t){const f=this.nodes.get(s);return f?Promise.resolve(f):(0,p.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(h=>this.createHandle(s,h,t,!0)).then(h=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(h);if(l){const u=this.nodes.get(l);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${h} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(s){if(s){let t;if(typeof s=="string"){const f=this.getExtensionElement(s);t=f?this.nodes.get(f):void 0}else t=s;return t&&t.children||void 0}return this.roots}async fetchChildrenNodes(s){this.clearChildren(s);const t=new S.CancellationTokenSource(this._refreshCancellationSource.token);try{const f=s?this.nodes.get(s):void 0,h=await this.dataProvider.getChildren(s);if(t.token.isCancellationRequested)return;const l=(0,I.coalesce)(h||[]),u=await Promise.all((0,I.coalesce)(l).map(g=>this.dataProvider.getTreeItem(g)));if(t.token.isCancellationRequested)return;const d=u.map((g,D)=>g?this.createAndRegisterTreeNode(l[D],g,f):null);return(0,I.coalesce)(d)}finally{t.dispose()}}refresh(s){if(s.some(f=>!f))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new S.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const f=this.getHandlesToRefresh(s);if(f.length)return this.refreshHandles(f)}return Promise.resolve(void 0)}getHandlesToRefresh(s){const t=new Set,f=s.map(l=>this.nodes.get(l));for(const l of f)if(l&&!t.has(l.item.handle)){let u=l;for(;u&&u.parent&&f.findIndex(d=>u&&u.parent&&d&&d.item.handle===u.parent.item.handle)===-1;){const d=this.elements.get(u.parent.item.handle);u=d?this.nodes.get(d):void 0}u&&!u.parent&&t.add(l.item.handle)}const h=[];return t.forEach(l=>{const u=this.elements.get(l);if(u){const d=this.nodes.get(u);d&&(!d.parent||!t.has(d.parent.item.handle))&&h.push(l)}}),h}refreshHandles(s){const t={};return Promise.all(s.map(f=>this.refreshNode(f).then(h=>{h&&(t[f]=h.item)}))).then(()=>Object.keys(t).length?this.proxy.$refresh(this.viewId,t):void 0)}refreshNode(s){const t=this.getExtensionElement(s);if(t){const f=this.nodes.get(t);if(f)return this.clearChildren(t),(0,p.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(h=>{if(h){const l=this.createTreeNode(t,h,f.parent);return this.updateNodeCache(t,l,f,f.parent),f.dispose(),l}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(s,t,f){const h=this.createTreeNode(s,t,f);if(t.id&&this.elements.has(h.item.handle))throw new Error((0,c.localize)(0,null,t.id));return this.addNodeToCache(s,h),this.addNodeToParentCache(h,f),h}getTooltip(s){return w.MarkdownString.isMarkdownString(s)?v.MarkdownString.from(s):s}getCommand(s,t){return t?{...this.commands.toInternal(t,s),originalId:t.command}:void 0}getCheckbox(s){if(s.checkboxState===void 0)return;let t,f,h;return typeof s.checkboxState=="number"?t=s.checkboxState:(t=s.checkboxState.state,f=s.checkboxState.tooltip,h=s.checkboxState.accessibilityInformation),{isChecked:t===w.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:h}}validateTreeItem(s){if(!w.TreeItem.isTreeItem(s,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(s,t,f){this.validateTreeItem(t);const h=this._register(new R.DisposableStore),l=this.createHandle(s,t,f),u=this.getLightIconPath(t);return{item:{handle:l,parentHandle:f?f.item.handle:void 0,label:o(t.label,this.extension),description:t.description,resourceUri:t.resourceUri,tooltip:this.getTooltip(t.tooltip),command:this.getCommand(h,t.command),contextValue:t.contextValue,icon:u,iconDark:this.getDarkIconPath(t)||u,themeIcon:this.getThemeIcon(t),collapsibleState:(0,A.isUndefinedOrNull)(t.collapsibleState)?w.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.getCheckbox(t)},extensionItem:t,parent:f,children:void 0,disposableStore:h,dispose(){h.dispose()}}}getThemeIcon(s){return s.iconPath instanceof w.ThemeIcon?s.iconPath:void 0}createHandle(s,{id:t,label:f,resourceUri:h},l,u){if(t)return`${i.ID_HANDLE_PREFIX}/${t}`;const d=o(f,this.extension),g=l?l.item.handle:i.LABEL_HANDLE_PREFIX;let D=d?d.label:h?(0,O.basename)(h):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const E=this.nodes.has(s)?this.nodes.get(s).item.handle:void 0,_=this.getChildrenNodes(l)||[];let y,P=0;do{if(y=`${g}/${P}:${D}`,u||!this.elements.has(y)||E===y)break;P++}while(P<=_.length);return y}getLightIconPath(s){if(s.iconPath&&!(s.iconPath instanceof w.ThemeIcon))return typeof s.iconPath=="string"||L.URI.isUri(s.iconPath)?this.getIconPath(s.iconPath):this.getIconPath(s.iconPath.light)}getDarkIconPath(s){if(s.iconPath&&!(s.iconPath instanceof w.ThemeIcon)&&s.iconPath.dark)return this.getIconPath(s.iconPath.dark)}getIconPath(s){return L.URI.isUri(s)?s:L.URI.file(s)}addNodeToCache(s,t){this.elements.set(t.item.handle,s),this.nodes.set(s,t)}updateNodeCache(s,t,f,h){this.elements.delete(t.item.handle),this.nodes.delete(s),t.item.handle!==f.item.handle&&this.elements.delete(f.item.handle),this.addNodeToCache(s,t);const l=this.getChildrenNodes(h)||[],u=l.filter(d=>d.item.handle===f.item.handle)[0];u&&l.splice(l.indexOf(u),1,t)}addNodeToParentCache(s,t){t?(t.children||(t.children=[]),t.children.push(s)):(this.roots||(this.roots=[]),this.roots.push(s))}clearChildren(s){if(s){const t=this.nodes.get(s);if(t){if(t.children)for(const f of t.children){const h=this.elements.get(f.item.handle);h&&this.clear(h)}t.children=void 0}}else this.clearAll()}clear(s){const t=this.nodes.get(s);if(t){if(t.children)for(const f of t.children){const h=this.elements.get(f.item.handle);h&&this.clear(h)}this.nodes.delete(s),this.elements.delete(t.item.handle),t.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(s=>s.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(ye[358],_e([1,0,4,3,2,30,16,92,6,7]),function(de,e,c,O,L,T,R,b,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class A extends O.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#h;#d;constructor(S,a,m,o){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#h=this._register(new c.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new c.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=S,this.#t=a,this.#n=m,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#l=o.active}dispose(){this.#u||(this.#u=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#n}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#r}set title(S){this.assertNotDisposed(),this.#r!==S&&(this.#r=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.assertNotDisposed(),this.#a}set iconPath(S){this.assertNotDisposed(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,L.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#s}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.assertNotDisposed(),this.#l}get visible(){return this.assertNotDisposed(),this.#c}_updateViewState(S){this.#u||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#l=S.active,this.#c=S.visible,this.#o=S.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(S,a){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:R.ViewColumn.from(S),preserveFocus:!!a})}assertNotDisposed(){if(this.#u)throw new Error("Webview is disposed")}}class I extends O.Disposable{static newHandle(){return(0,T.generateUuid)()}constructor(S,a,m){super(),this.webviews=a,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=S.getProxy(p.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(S=>S.dispose()),this._webviewPanels.clear()}createWebviewPanel(S,a,m,o,n={}){const i=typeof o=="object"?o.viewColumn:o,r={viewColumn:R.ViewColumn.from(i),preserveFocus:typeof o=="object"&&!!o.preserveFocus},s=(0,b.shouldSerializeBuffersForPostMessage)(S),t=I.newHandle();this._proxy.$createWebviewPanel((0,b.toExtensionData)(S),t,a,{title:m,panelOptions:v(n),webviewOptions:(0,b.serializeWebviewOptions)(S,this.workspace,n),serializeBuffersForPostMessage:s},r);const f=this.webviews.createNewWebview(t,n,S);return this.createNewWebviewPanel(t,a,m,i,n,f,!0)}$onDidChangeWebviewPanelViewStates(S){const a=Object.keys(S);a.sort((m,o)=>{const n=S[m],i=S[o];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const m of a){const o=this.getWebviewPanel(m);if(!o)continue;const n=S[m];o._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this._webviewPanels.delete(S),this.webviews.deleteWebview(S)}registerWebviewPanelSerializer(S,a,m){if(this._serializers.has(a))throw new Error(`Serializer for '${a}' already registered`);return this._serializers.set(a,{serializer:m,extension:S}),this._proxy.$registerSerializer(a,{serializeBuffersForPostMessage:(0,b.shouldSerializeBuffersForPostMessage)(S)}),new w.Disposable(()=>{this._serializers.delete(a),this._proxy.$unregisterSerializer(a)})}async $deserializeWebviewPanel(S,a,m,o){const n=this._serializers.get(a);if(!n)throw new Error(`No serializer found for '${a}'`);const{serializer:i,extension:r}=n,s=this.webviews.createNewWebview(S,m.webviewOptions,r),t=this.createNewWebviewPanel(S,a,m.title,o,m.panelOptions,s,m.active);await i.deserializeWebviewPanel(t,m.state)}createNewWebviewPanel(S,a,m,o,n,i,r){const s=new A(S,this._proxy,i,{viewType:a,title:m,viewColumn:o,panelOptions:n,active:r});return this._webviewPanels.set(S,s),s}getWebviewPanel(S){return this._webviewPanels.get(S)}}e.ExtHostWebviewPanels=I;function v(C){return{enableFindWidget:C.enableFindWidget,retainContextWhenHidden:C.retainContextWhenHidden}}}),define(ye[359],_e([1,0,4,3,92,16,6,7]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class p extends O.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(I,v,C,S,a,m){super(),this.#s=!1,this.#l=this._register(new c.Emitter),this.onDidChangeVisibility=this.#l.event,this.#u=this._register(new c.Emitter),this.onDidDispose=this.#u.event,this.#i=C,this.#a=S,this.#e=I,this.#t=v,this.#n=a,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.assertNotDisposed(),this.#a}set title(I){this.assertNotDisposed(),this.#a!==I&&(this.#a=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.assertNotDisposed(),this.#o}set description(I){this.assertNotDisposed(),this.#o!==I&&(this.#o=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(I){I===this.#r||this.#s||(this.#r=I,this.#l.fire())}get badge(){return this.assertNotDisposed(),this.#c}set badge(I){this.assertNotDisposed(),!(I?.value===this.#c?.value&&I?.tooltip===this.#c?.tooltip)&&(this.#c=T.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.assertNotDisposed(),this.#t.$show(this.#e,!!I)}assertNotDisposed(){if(this.#s)throw new Error("Webview is disposed")}}class w{constructor(I,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=I.getProxy(R.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(I,v,C,S){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:C,extension:I}),this._proxy.$registerWebviewViewProvider((0,L.toExtensionData)(I),v,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,L.shouldSerializeBuffersForPostMessage)(I)}),new b.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(I,v,C,S,a){const m=this._viewProviders.get(v);if(!m)throw new Error(`No view provider found for '${v}'`);const{provider:o,extension:n}=m,i=this._extHostWebview.createNewWebview(I,{},n),r=new p(I,this._proxy,v,C,i,!0);this._webviewViews.set(I,r),await o.resolveWebviewView(r,{state:S},a)}async $onDidChangeWebviewViewVisibility(I,v){this.getWebviewView(I)._setVisible(v)}async $disposeWebviewView(I){const v=this.getWebviewView(I);this._webviewViews.delete(I),v.dispose(),this._extHostWebview.deleteWebview(I)}getWebviewView(I){const v=this._webviewViews.get(I);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=w}),define(ye[360],_e([1,0,69,15,12,259,32,11]),function(de,e,c,O,L,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiskFileSystemProvider=void 0;let p=class{constructor(I,v){I.addFileSystemProvider(O.Schemas.file,new w(v),{isCaseSensitive:b.isLinux})}};e.ExtHostDiskFileSystemProvider=p,e.ExtHostDiskFileSystemProvider=p=Ge([Ue(0,c.IExtHostConsumerFileSystem),Ue(1,L.ILogService)],p);class w{constructor(I){this.logService=I,this.impl=new T.DiskFileSystemProvider(this.logService)}async stat(I){const v=await this.impl.stat(I);return{type:v.type,ctime:v.ctime,mtime:v.mtime,size:v.size,permissions:v.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.impl.readdir(I)}createDirectory(I){return this.impl.mkdir(I)}readFile(I){return this.impl.readFile(I)}writeFile(I,v,C){return this.impl.writeFile(I,v,{...C,unlock:!1,atomic:!1})}delete(I,v){return this.impl.delete(I,{...v,useTrash:!1,atomic:!1})}rename(I,v,C){return this.impl.rename(I,v,C)}copy(I,v,C){return this.impl.copy(I,v,C)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,v){throw new Error("Method not implemented.")}}}),define(ye[361],_e([1,0,17,63,30,33,3,6,2,20]),function(de,e,c,O,L,T,R,b,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let A=class extends R.Disposable{constructor(v,C){super();const S=v.getProxy(b.MainContext.MainThreadDownloadService);C.registerCommand(!1,"_workbench.downloadResource",async a=>{const m=p.URI.file((0,c.join)((0,O.tmpdir)(),(0,L.generateUuid)()));return await S.$download(a,m),m})}};e.ExtHostDownloadService=A,e.ExtHostDownloadService=A=Ge([Ue(0,w.IExtHostRpcService),Ue(1,T.IExtHostCommands)],A)}),define(ye[362],_e([1,0,51,17,2,93,3,15,8,31]),function(de,e,c,O,L,T,R,b,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class A extends T.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(t){const f=await super._getWorkspaceStorageURI(t);if(f.scheme!==b.Schemas.file)return f;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${f.fsPath}.`),f;const h=f.fsPath;let l=0;do{let u;l===0?u=h:u=/[/\\]$/.test(h)?`${h.substr(0,h.length-1)}-${l}`:`${h}-${l}`,await I(u);const d=O.join(u,"vscode.lock"),g=await a(this._logService,d,!1);if(g)return this._workspaceStorageLock=g,process.on("exit",()=>{g.dispose()}),L.URI.file(u);l++}while(l<10);return f}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=A;async function I(s){try{await w.Promises.stat(s);return}catch{}try{await w.Promises.mkdir(s,{recursive:!0})}catch{}}const v=1e3,C=10*60*1e3;class S extends R.Disposable{constructor(t,f){super(),this.logService=t,this.filename=f,this._timer=this._register(new p.IntervalTimer),this._timer.cancelAndSet(async()=>{const h=await m(t,f);(!h||h.pid!==process.pid)&&(t.info(`Lock '${f}': The lock was lost unexpectedly.`),this._timer.cancel());try{await w.Promises.utimes(f,new Date,new Date)}catch(l){t.error(l),t.info(`Lock '${f}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{c.unlinkSync(this.filename)}catch{}}async setWillRelease(t){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const f={pid:process.pid,willReleaseAt:Date.now()+t};await w.Promises.writeFile(this.filename,JSON.stringify(f),{flag:"w"})}catch(f){this.logService.error(f)}}}async function a(s,t,f){try{const l={pid:process.pid,willReleaseAt:0};await w.Promises.writeFile(t,JSON.stringify(l),{flag:"wx"})}catch(l){s.error(l)}const h=await m(s,t);return!h||h.pid!==process.pid?f?(s.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(s.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(s,t)):(s.info(`Lock '${t}': Lock acquired.`),new S(s,t))}async function m(s,t){let f;try{f=await w.Promises.readFile(t)}catch(h){return s.error(h),null}try{return JSON.parse(String(f))}catch(h){return s.error(h),null}}async function o(s,t){let f;try{f=await w.Promises.stat(t)}catch(h){return s.error(h),0}return f.mtime.getTime()}function n(s){try{return process.kill(s,0),!0}catch{return!1}}async function i(s,t){const f=await m(s,t);if(!f)return s.info(`Lock '${t}': Could not read pid of lock holder.`),r(s,t);if(f.willReleaseAt){let g=f.willReleaseAt-Date.now();if(g<5e3){for(g>0?s.info(`Lock '${t}': The lockfile is scheduled to be released in ${g} ms.`):s.info(`Lock '${t}': The lockfile is scheduled to have been released.`);g>0;){if(await(0,p.timeout)(Math.min(100,g)),await o(s,t)===0)return r(s,t);g=f.willReleaseAt-Date.now()}return r(s,t)}}if(!n(f.pid))return s.info(`Lock '${t}': The pid ${f.pid} appears to be gone.`),r(s,t);const h=await o(s,t),l=Date.now()-h;if(l<=C)return s.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;s.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,p.timeout)(2e3);const u=await o(s,t),d=Date.now()-u;return d<=C?(s.info(`Lock '${t}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(s.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(s,t))}async function r(s,t){s.info(`Lock '${t}': Deleting a stale lock.`);try{await w.Promises.unlink(t)}catch{}return a(s,t,!0)}}),define(ye[363],_e([1,0,30,20,43,33]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends L.BaseExtHostTerminalService{constructor(p,w){super(!0,p,w)}createTerminal(p,w,A){return this.createTerminalFromOptions({name:p,shellPath:w,shellArgs:A})}createTerminalFromOptions(p,w){const A=new L.ExtHostTerminal(this._proxy,(0,c.generateUuid)(),p,p.name);return this._terminals.push(A),A.create(p,this._serializeParentTerminal(p,w)),A.value}};e.ExtHostTerminalService=R,e.ExtHostTerminalService=R=Ge([Ue(0,T.IExtHostCommands),Ue(1,O.IExtHostRpcService)],R)}),define(ye[364],_e([1,0,4,37,41,5]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=e.CONTEXT_ACTIVE_OUTPUT_LEVEL=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=e.CONTEXT_ACTIVE_FILE_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new L.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_FILE_OUTPUT=new L.RawContextKey("activeLogOutput",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=new L.RawContextKey("activeLogOutput.levelSettable",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL=new L.RawContextKey("activeLogOutput.level",""),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=new L.RawContextKey("activeLogOutput.levelIsDefault",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new L.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,T.createDecorator)("outputService");var R;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.channels=new Map,this._onDidRegisterChannel=new c.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new c.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(w){this.channels.has(w.id)||(this.channels.set(w.id,w),this._onDidRegisterChannel.fire(w.id))}getChannels(){const w=[];return this.channels.forEach(A=>w.push(A)),w}getChannel(w){return this.channels.get(w)}removeChannel(w){this.channels.delete(w),this._onDidRemoveChannel.fire(w)}}O.Registry.add(e.Extensions.OutputChannels,new b),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new L.RawContextKey("activeOutputChannel","")}),define(ye[157],_e([1,0,6,5,20,25,12,364,69,28,59,189,21,18,32,4,3]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class o extends R.AbstractMessageLogger{get disposed(){return this._disposed}constructor(s,t,f,h,l){super(),this.id=s,this.name=t,this.logger=f,this.proxy=h,this.extension=l,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(f.getLevel()),this._register(f.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.getLevel()}appendLine(s){this.append(s+`
`)}append(s){this.info(s)}clear(){const s=this.offset;this.logger.flush(),this.proxy.$update(this.id,b.OutputChannelUpdateMode.Clear,s)}replace(s){const t=this.offset;this.info(s),this.proxy.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.logger.flush()}show(s,t){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof s=="boolean"?s:t))}hide(){this.proxy.$close(this.id)}log(s,t){this.offset+=v.VSBuffer.fromString(t).byteLength,(0,R.log)(this.logger,s,t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class n extends o{appendLine(s){this.append(s)}}let i=class{constructor(s,t,f,h,l,u){this.initData=t,this.extHostFileSystem=f,this.extHostFileSystemInfo=h,this.loggerService=l,this.logService=u,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=s.getProxy(c.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(s){this.visibleChannelId=s;for(const[t,f]of this.channels)f.visible=t===this.visibleChannelId}createOutputChannel(s,t,f){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");const h=typeof t=="object"&&t.log,l=(0,C.isString)(t)?t:void 0;if((0,C.isString)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let u;const d=this.initData.environment.extensionLogLevel?.find(([D])=>T.ExtensionIdentifier.equals(f.identifier,D))?.[1];d&&(u=(0,R.parseLogLevel)(d));const g=h?this.doCreateLogOutputChannel(s,u,f):this.doCreateOutputChannel(s,l,f);return g.then(D=>{this.channels.set(D.id,D),D.visible=D.id===this.visibleChannelId}),h?this.createExtHostLogOutputChannel(s,u??this.logService.getLevel(),g):this.createExtHostOutputChannel(s,g)}async doCreateOutputChannel(s,t,f){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const h=await this.outputDirectoryPromise,l=this.extHostFileSystemInfo.extUri.joinPath(h,`${this.namePool++}-${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.loggerService.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.proxy.$register(s,l,t,f.identifier.value);return new o(d,s,u,this.proxy,f)}async doCreateLogOutputChannel(s,t,f){const h=await this.createExtensionLogDirectory(f),l=s.replace(/[\\/:\*\?"<>\|]/g,""),u=this.extHostFileSystemInfo.extUri.joinPath(h,`${l}.log`),d=`${f.identifier.value}.${l}`,g=this.loggerService.createLogger(u,{id:d,name:s,logLevel:t,extensionId:f.identifier.value});return new n(d,s,g,this.proxy,f)}createExtensionLogDirectory(s){let t=this.extensionLogDirectoryPromise.get(s.identifier.value);if(!t){const f=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,s.identifier.value);this.extensionLogDirectoryPromise.set(s.identifier.value,t=(async()=>{try{await this.extHostFileSystem.value.createDirectory(f)}catch(h){if((0,S.toFileSystemProviderErrorCode)(h)!==S.FileSystemProviderErrorCode.FileExists)throw h}return f})())}return t}createExtHostOutputChannel(s,t){let f=!1;const h=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return s},append(l){h(),t.then(u=>u.append(l))},appendLine(l){h(),t.then(u=>u.appendLine(l))},clear(){h(),t.then(l=>l.clear())},replace(l){h(),t.then(u=>u.replace(l))},show(l,u){h(),t.then(d=>d.show(l,u))},hide(){h(),t.then(l=>l.hide())},dispose(){f=!0,t.then(l=>l.dispose())}}}createExtHostLogOutputChannel(s,t,f){const h=new m.DisposableStore,l=()=>{if(h.isDisposed)throw new Error("Channel has been closed")},u=h.add(new a.Emitter);function d(g){t=g,u.fire(g)}return f.then(g=>{h.add(g),g.logLevel!==t&&d(g.logLevel),h.add(g.onDidChangeLogLevel(D=>d(D)))}),{...this.createExtHostOutputChannel(s,f),get logLevel(){return t},onDidChangeLogLevel:u.event,trace(g,...D){l(),f.then(E=>E.trace(g,...D))},debug(g,...D){l(),f.then(E=>E.debug(g,...D))},info(g,...D){l(),f.then(E=>E.info(g,...D))},warn(g,...D){l(),f.then(E=>E.warn(g,...D))},error(g,...D){l(),f.then(E=>E.error(g,...D))},dispose(){h.dispose()}}}};e.ExtHostOutputService=i,e.ExtHostOutputService=i=Ge([Ue(0,L.IExtHostRpcService),Ue(1,w.IExtHostInitDataService),Ue(2,p.IExtHostConsumerFileSystem),Ue(3,A.IExtHostFileSystemInfo),Ue(4,R.ILoggerService),Ue(5,R.ILogService)],i),e.IExtHostOutputService=(0,O.createDecorator)("IExtHostOutputService")}),define(ye[158],_e([1,0,5,8]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(L){let T=1/0;for(let b=0;b<this.maxSampleCount;b++){const p=await L.getRoundTripTime();if(p===void 0)return;T=Math.min(T,p/2),await(0,O.timeout)(this.sampleDelay)}this.average.push(T),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(T):R=this.initial.reduce((b,p)=>b+p,0)/this.initial.length,this.lastMeasurement={initial:R,current:T,average:this.average.reduce((b,p)=>b+p,0)/this.average.length,high:typeof R>"u"?!1:T>this.highLatencyMaxThreshold||T>this.highLatencyMinThreshold&&T>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(ye[365],_e([1,0,232,85,37,42,53,3,4,158,11,24,8]),function(de,e,c,O,L,T,R,b,p,w,A,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DynamicWorkbenchSecurityConfiguration=e.ConfigurationMigrationWorkbenchContribution=e.Extensions=e.problemsConfigurationNodeBase=e.securityConfigurationNodeBase=e.workbenchConfigurationNodeBase=e.applicationConfigurationNodeBase=void 0,e.applicationConfigurationNodeBase=Object.freeze({id:"application",order:100,title:(0,c.localize)(0,null),type:"object"}),e.workbenchConfigurationNodeBase=Object.freeze({id:"workbench",order:7,title:(0,c.localize)(1,null),type:"object"}),e.securityConfigurationNodeBase=Object.freeze({id:"security",scope:1,title:(0,c.localize)(2,null),type:"object",order:7}),e.problemsConfigurationNodeBase=Object.freeze({id:"problems",title:(0,c.localize)(3,null),type:"object",order:101}),e.Extensions={ConfigurationMigration:"base.contributions.configuration.migration"};class C{constructor(){this.migrations=[],this._onDidRegisterConfigurationMigrations=new p.Emitter,this.onDidRegisterConfigurationMigration=this._onDidRegisterConfigurationMigrations.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const S=new C;L.Registry.add(e.Extensions.ConfigurationMigration,S);let a=class extends b.Disposable{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.configurationService=n,this.workspaceService=i,this._register(this.workspaceService.onDidChangeWorkspaceFolders(async r=>{for(const s of r.added)await this.migrateConfigurationsForFolder(s,S.migrations)})),this.migrateConfigurations(S.migrations),this._register(S.onDidRegisterConfigurationMigration(r=>this.migrateConfigurations(r)))}async migrateConfigurations(n){await this.migrateConfigurationsForFolder(void 0,n);for(const i of this.workspaceService.getWorkspace().folders)await this.migrateConfigurationsForFolder(i,n)}async migrateConfigurationsForFolder(n,i){await Promise.all([i.map(r=>this.migrateConfigurationsForFolderAndOverride(r,n?.uri))])}async migrateConfigurationsForFolderAndOverride(n,i){const r=this.configurationService.inspect(n.key,{resource:i}),s=this.workspaceService.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of s){const h=r[t];if(!h)continue;const l=[];if(h.value!==void 0){const u=await this.runMigration(n,t,h.value,i,void 0);for(const d of u??[])l.push([d,[]])}for(const{identifiers:u,value:d}of h.overrides??[])if(d!==void 0){const g=await this.runMigration(n,t,d,i,u);for(const D of g??[])l.push([D,u])}l.length&&await Promise.allSettled(l.map(async([[u,d],g])=>this.configurationService.updateValue(u,d.value,{resource:i,overrideIdentifiers:g},f)))}}async runMigration(n,i,r,s,t){const f=l=>{const d=this.configurationService.inspect(l,{resource:s})[i];if(d)return t?d.overrides?.find(({identifiers:g})=>(0,I.equals)(g,t))?.value:d.value},h=await n.migrateFn(r,f);return Array.isArray(h)?h:[[n.key,h]]}};e.ConfigurationMigrationWorkbenchContribution=a,e.ConfigurationMigrationWorkbenchContribution=a=Ge([Ue(0,R.IConfigurationService),Ue(1,T.IWorkspaceContextService)],a);let m=class extends b.Disposable{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.remoteAgentService=n,this._ready=new v.DeferredPromise,this.ready=this._ready.p,this.create()}async create(){try{await this.doCreate()}finally{this._ready.complete()}}async doCreate(){if(!A.isWindows&&(await this.remoteAgentService.getEnvironment())?.os!==1)return;L.Registry.as(O.Extensions.Configuration).registerConfiguration({...e.securityConfigurationNodeBase,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,c.localize)(4,null)},default:[],markdownDescription:(0,c.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,c.localize)(6,null),scope:2}}})}};e.DynamicWorkbenchSecurityConfiguration=m,e.DynamicWorkbenchSecurityConfiguration=m=Ge([Ue(0,w.IRemoteAgentService)],m)}),define(ye[366],_e([1,0,35,15,17,23,241,365,85,5,37]),function(de,e,c,O,L,T,R,b,p,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.editorsAssociationsSettingId=e.IEditorResolverService=void 0,e.priorityToRank=a,e.globMatchesResource=m,e.IEditorResolverService=(0,w.createDecorator)("editorResolverService"),e.editorsAssociationsSettingId="workbench.editorAssociations";const I=A.Registry.as(p.Extensions.Configuration),v={...b.workbenchConfigurationNodeBase,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};I.registerConfiguration(v);var C;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(C||(e.RegisteredEditorPriority=C={}));var S;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function a(o){switch(o){case C.exclusive:return 5;case C.default:return 4;case C.builtin:return 3;case C.option:default:return 1}}function m(o,n){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(n.scheme))return!1;const s=typeof o=="string"&&o.indexOf(L.posix.sep)>=0?`${n.scheme}:${n.path}`:(0,T.basename)(n);return c.match(typeof o=="string"?o.toLowerCase():o,s.toLowerCase())}}),define(ye[367],_e([1,0,34,15,17,11,23,2,5,277,42,147,158]),function(de,e,c,O,L,T,R,b,p,w,A,I,v){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,p.createDecorator)("pathService");let S=C=class{constructor(m,o,n,i){this.localUserHome=m,this.remoteAgentService=o,this.environmentService=n,this.contextService=i,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||T.OS)(),this.resolveUserHome=(async()=>{const r=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=r?.userHome??m})()}hasValidBasename(m,o,n){return typeof o=="string"||typeof o>"u"?this.resolveOS.then(i=>this.doHasValidBasename(m,i,o)):this.doHasValidBasename(m,o,n)}doHasValidBasename(m,o,n){return m.scheme===O.Schemas.file||m.scheme===O.Schemas.vscodeRemote?(0,c.isValidBasename)(n??(0,R.basename)(m),o===1):!0}get defaultUriScheme(){return C.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,o){if(m.remoteAuthority)return O.Schemas.vscodeRemote;const n=(0,w.getVirtualWorkspaceScheme)(o.getWorkspace());if(n)return n;const i=o.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:O.Schemas.file}userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?L.win32:L.posix)}async fileURI(m){let o="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const i=m.indexOf("/",2);i===-1?(o=m.substring(2),m="/"):(o=m.substring(2,i),m=m.substring(i)||"/")}return b.URI.from({scheme:O.Schemas.file,authority:o,path:m,query:"",fragment:""})}};e.AbstractPathService=S,e.AbstractPathService=S=C=Ge([Ue(1,v.IRemoteAgentService),Ue(2,I.IWorkbenchEnvironmentService),Ue(3,A.IWorkspaceContextService)],S)}),define(ye[368],_e([1,0,243,19,54,4,55,3,2,53,248,12,65,279,88,42,147,26,22,18,24,41]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n,i,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelModel=e.PortsAttributes=e.OnPortForward=e.AutoTunnelSource=e.UserTunnelSource=e.TunnelSource=e.TunnelCloseReason=e.forwardedPortsViewEnabled=e.ACTIVATION_EVENT=void 0,e.parseAddress=u,e.mapHasAddress=D,e.mapHasAddressLocalhostOrAllInterfaces=E,e.makeAddress=_,e.isCandidatePort=P;const t=10*1e3,f="remote.tunnels.toRestore",h="remote.tunnels.toRestoreExpiration",l=1e3*60*60*24*14;e.ACTIVATION_EVENT="onTunnel",e.forwardedPortsViewEnabled=new s.RawContextKey("forwardedPortsViewEnabled",!1,c.localize(0,null));function u(x){const F=x.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(F)return{host:F[1]?.substring(0,F[1].length-1)||"localhost",port:Number(F[2])}}var d;(function(x){x.Other="Other",x.User="User",x.AutoForwardEnd="AutoForwardEnd"})(d||(e.TunnelCloseReason=d={}));var g;(function(x){x[x.User=0]="User",x[x.Auto=1]="Auto",x[x.Extension=2]="Extension"})(g||(e.TunnelSource=g={})),e.UserTunnelSource={source:g.User,description:c.localize(1,null)},e.AutoTunnelSource={source:g.Auto,description:c.localize(2,null)};function D(x,F,N){const M=x.get(_(F,N));if(M)return M;if((0,S.isLocalhost)(F))for(const B of S.LOCALHOST_ADDRESSES){const W=_(B,N);if(x.has(W))return x.get(W)}else if((0,S.isAllInterfaces)(F))for(const B of S.ALL_INTERFACES_ADDRESSES){const W=_(B,N);if(x.has(W))return x.get(W)}}function E(x,F,N){const M=D(x,F,N);if(M)return M;const B=(0,S.isAllInterfaces)(F)?"localhost":(0,S.isLocalhost)(F)?"0.0.0.0":void 0;if(B)return D(x,B,N)}function _(x,F){return x+":"+F}var y;(function(x){x.Notify="notify",x.OpenBrowser="openBrowser",x.OpenBrowserOnce="openBrowserOnce",x.OpenPreview="openPreview",x.Silent="silent",x.Ignore="ignore"})(y||(e.OnPortForward=y={}));function P(x){return x&&"host"in x&&typeof x.host=="string"&&"port"in x&&typeof x.port=="number"&&(!("detail"in x)||typeof x.detail=="string")&&(!("pid"in x)||typeof x.pid=="string")}class k extends b.Disposable{static{this.SETTING="remote.portsAttributes"}static{this.DEFAULTS="remote.otherPortsAttributes"}static{this.RANGE=/^(\d+)\-(\d+)$/}static{this.HOST_AND_PORT=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(F){super(),this.configurationService=F,this.portsAttributes=[],this._onDidChangeAttributes=new T.Emitter,this.onDidChangeAttributes=this._onDidChangeAttributes.event,this._register(F.onDidChangeConfiguration(N=>{(N.affectsConfiguration(k.SETTING)||N.affectsConfiguration(k.DEFAULTS))&&this.updateAttributes()})),this.updateAttributes()}updateAttributes(){this.portsAttributes=this.readSetting(),this._onDidChangeAttributes.fire()}getAttributes(F,N,M){let B=this.findNextIndex(F,N,M,this.portsAttributes,0);const W={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;B>=0;){const Y=this.portsAttributes[B];Y.key===F?(W.onAutoForward=Y.onAutoForward??W.onAutoForward,W.elevateIfNeeded=Y.elevateIfNeeded!==void 0?Y.elevateIfNeeded:W.elevateIfNeeded,W.label=Y.label??W.label,W.requireLocalPort=Y.requireLocalPort,W.protocol=Y.protocol):(W.onAutoForward=W.onAutoForward??Y.onAutoForward,W.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:Y.elevateIfNeeded,W.label=W.label??Y.label,W.requireLocalPort=W.requireLocalPort!==void 0?W.requireLocalPort:void 0,W.protocol=W.protocol??Y.protocol),B=this.findNextIndex(F,N,M,this.portsAttributes,B+1)}return W.onAutoForward!==void 0||W.elevateIfNeeded!==void 0||W.label!==void 0||W.requireLocalPort!==void 0||W.protocol!==void 0?W:this.getOtherAttributes()}hasStartEnd(F){return F.start!==void 0&&F.end!==void 0}hasHostAndPort(F){return F.host!==void 0&&F.port!==void 0&&(0,i.isString)(F.host)&&(0,i.isNumber)(F.port)}findNextIndex(F,N,M,B,W){if(W>=B.length)return-1;const Y=!(0,S.isLocalhost)(N)&&!(0,S.isAllInterfaces)(N),G=B.slice(W).findIndex(Q=>(0,i.isNumber)(Q.key)?Y?!1:Q.key===F:this.hasStartEnd(Q.key)?Y?!1:F>=Q.key.start&&F<=Q.key.end:this.hasHostAndPort(Q.key)?F===Q.key.port&&N===Q.key.host:M?Q.key.test(M):!1);return G>=0?G+W:-1}readSetting(){const F=this.configurationService.getValue(k.SETTING);if(!F||!(0,i.isObject)(F))return[];const N=[];for(const B in F){if(B===void 0)continue;const W=F[B];let Y;if(Number(B))Y=Number(B);else if((0,i.isString)(B))if(k.RANGE.test(B)){const Z=B.match(k.RANGE);Y={start:Number(Z[1]),end:Number(Z[2])}}else if(k.HOST_AND_PORT.test(B)){const Z=B.match(k.HOST_AND_PORT);Y={host:Z[1],port:Number(Z[2])}}else{let Z;try{Z=RegExp(B)}catch{}Z&&(Y=Z)}Y&&N.push({key:Y,elevateIfNeeded:W.elevateIfNeeded,onAutoForward:W.onAutoForward,label:W.label,requireLocalPort:W.requireLocalPort,protocol:W.protocol})}const M=this.configurationService.getValue(k.DEFAULTS);return M&&(this.defaultPortAttributes={elevateIfNeeded:M.elevateIfNeeded,label:M.label,onAutoForward:M.onAutoForward,requireLocalPort:M.requireLocalPort,protocol:M.protocol}),this.sortAttributes(N)}sortAttributes(F){function N(M,B){return(0,i.isNumber)(M.key)?M.key:B.hasStartEnd(M.key)?M.key.start:B.hasHostAndPort(M.key)?M.key.port:Number.MAX_VALUE}return F.sort((M,B)=>N(M,this)-N(B,this))}getOtherAttributes(){return this.defaultPortAttributes}static providedActionToAction(F){switch(F){case S.ProvidedOnAutoForward.Notify:return y.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case S.ProvidedOnAutoForward.Silent:return y.Silent;case S.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(F,N,M){const W=this.configurationService.inspect(k.SETTING).userRemoteValue;let Y;!W||!(0,i.isObject)(W)?Y={}:Y=(0,r.deepClone)(W),Y[`${F}`]||(Y[`${F}`]={});for(const Z in N)Y[`${F}`][Z]=N[Z];return this.configurationService.updateValue(k.SETTING,Y,M)}}e.PortsAttributes=k;let z=class extends b.Disposable{constructor(F,N,M,B,W,Y,Z,G,Q,re){super(),this.tunnelService=F,this.storageService=N,this.configurationService=M,this.environmentService=B,this.remoteAuthorityResolverService=W,this.workspaceContextService=Y,this.logService=Z,this.dialogService=G,this.extensionService=Q,this.contextKeyService=re,this.inProgress=new Map,this._onForwardPort=new T.Emitter,this.onForwardPort=this._onForwardPort.event,this._onClosePort=new T.Emitter,this.onClosePort=this._onClosePort.event,this._onPortName=new T.Emitter,this.onPortName=this._onPortName.event,this._onCandidatesChanged=new T.Emitter,this.onCandidatesChanged=this._onCandidatesChanged.event,this._onEnvironmentTunnelsSet=new T.Emitter,this.onEnvironmentTunnelsSet=this._onEnvironmentTunnelsSet.event,this._environmentTunnelsSet=!1,this.restoreListener=void 0,this.restoreComplete=!1,this.onRestoreComplete=new T.Emitter,this.unrestoredExtensionTunnels=new Map,this.sessionCachedProperties=new Map,this.portAttributesProviders=[],this.mismatchCooldown=new Date,this.configPortsAttributes=new k(M),this.tunnelRestoreValue=this.getTunnelRestoreValue(),this._register(this.configPortsAttributes.onDidChangeAttributes(this.updateAttributes,this)),this.forwarded=new Map,this.remoteTunnels=new Map,this.tunnelService.tunnels.then(async te=>{const ve=await this.getAttributes(te.map(Ie=>({port:Ie.tunnelRemotePort,host:Ie.tunnelRemoteHost})));for(const Ie of te)if(Ie.localAddress){const J=_(Ie.tunnelRemoteHost,Ie.tunnelRemotePort),$=E(this._candidates??new Map,Ie.tunnelRemoteHost,Ie.tunnelRemotePort);this.forwarded.set(J,{remotePort:Ie.tunnelRemotePort,remoteHost:Ie.tunnelRemoteHost,localAddress:Ie.localAddress,protocol:ve?.get(Ie.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.makeLocalUri(Ie.localAddress,ve?.get(Ie.tunnelRemotePort)),localPort:Ie.tunnelLocalPort,runningProcess:$?.detail,hasRunningProcess:!!$,pid:$?.pid,privacy:Ie.privacy,source:e.UserTunnelSource}),this.remoteTunnels.set(J,Ie)}}),this.detected=new Map,this._register(this.tunnelService.onTunnelOpened(async te=>{const ve=_(te.tunnelRemoteHost,te.tunnelRemotePort);if(!E(this.forwarded,te.tunnelRemoteHost,te.tunnelRemotePort)&&!E(this.detected,te.tunnelRemoteHost,te.tunnelRemotePort)&&!E(this.inProgress,te.tunnelRemoteHost,te.tunnelRemotePort)&&te.localAddress){const Ie=E(this._candidates??new Map,te.tunnelRemoteHost,te.tunnelRemotePort),J=(await this.getAttributes([{port:te.tunnelRemotePort,host:te.tunnelRemoteHost}]))?.get(te.tunnelRemotePort);this.forwarded.set(ve,{remoteHost:te.tunnelRemoteHost,remotePort:te.tunnelRemotePort,localAddress:te.localAddress,protocol:J?.protocol??S.TunnelProtocol.Http,localUri:await this.makeLocalUri(te.localAddress,J),localPort:te.tunnelLocalPort,closeable:!0,runningProcess:Ie?.detail,hasRunningProcess:!!Ie,pid:Ie?.pid,privacy:te.privacy,source:e.UserTunnelSource})}await this.storeForwarded(),this.remoteTunnels.set(ve,te),this._onForwardPort.fire(this.forwarded.get(ve))})),this._register(this.tunnelService.onTunnelClosed(te=>this.onTunnelClosed(te,d.Other))),this.checkExtensionActivationEvents()}extensionHasActivationEvent(){return this.extensionService.extensions.find(F=>F.activationEvents?.includes(e.ACTIVATION_EVENT))?(this.contextKeyService.createKey(e.forwardedPortsViewEnabled.key,!0),!0):!1}checkExtensionActivationEvents(){if(this.extensionHasActivationEvent())return;const F=this._register(this.extensionService.onDidRegisterExtensions(()=>{this.extensionHasActivationEvent()&&F.dispose()}))}async onTunnelClosed(F,N){const M=_(F.host,F.port);this.forwarded.has(M)&&(this.forwarded.delete(M),await this.storeForwarded(),this._onClosePort.fire(F))}makeLocalUri(F,N){if(F.startsWith("http"))return p.URI.parse(F);const M=N?.protocol??"http";return p.URI.parse(`${M}://${F}`)}async addStorageKeyPostfix(F){const N=this.workspaceContextService.getWorkspace(),M=N.configuration?(0,R.hash)(N.configuration.path):N.folders.length>0?(0,R.hash)(N.folders[0].uri.path):void 0;if(M===void 0){this.logService.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${F}.${this.environmentService.remoteAuthority}.${M}`}async getTunnelRestoreStorageKey(){return this.addStorageKeyPostfix(f)}async getRestoreExpirationStorageKey(){return this.addStorageKeyPostfix(h)}async getTunnelRestoreValue(){const F=this.storageService.get(f,1);if(F)return this.storageService.remove(f,1),await this.storeForwarded(),F;const N=await this.getTunnelRestoreStorageKey();if(N)return this.storageService.get(N,0)}async restoreForwarded(){if(this.cleanupExpiredTunnelsForRestore(),this.configurationService.getValue("remote.restoreForwardedPorts")){const F=await this.tunnelRestoreValue;if(F&&F!==this.knownPortsRestoreValue){const N=JSON.parse(F)??[];this.logService.trace(`ForwardedPorts: (TunnelModel) restoring ports ${N.map(M=>M.remotePort).join(", ")}`);for(const M of N){const B=E(this.detected,M.remoteHost,M.remotePort);M.source.source!==g.Extension&&!B||M.source.source===g.Extension&&B?await this.doForward({remote:{host:M.remoteHost,port:M.remotePort},local:M.localPort,name:M.name,elevateIfNeeded:!0,source:M.source}):M.source.source===g.Extension&&!B&&this.unrestoredExtensionTunnels.set(_(M.remoteHost,M.remotePort),M)}}}if(this.restoreComplete=!0,this.onRestoreComplete.fire(),!this.restoreListener){const F=await this.getTunnelRestoreStorageKey();this.restoreListener=this._register(new b.DisposableStore),this.restoreListener.add(this.storageService.onDidChangeValue(0,void 0,this.restoreListener)(async N=>{N.key===F&&(this.tunnelRestoreValue=Promise.resolve(this.storageService.get(F,0)),await this.restoreForwarded())}))}}cleanupExpiredTunnelsForRestore(){const F=this.storageService.keys(0,0).filter(N=>N.startsWith(h));for(const N of F){const M=this.storageService.getNumber(N,0);if(M&&M<Date.now()){this.tunnelRestoreValue=Promise.resolve(void 0);const B=N.replace(h,f);this.storageService.remove(N,0),this.storageService.remove(B,0)}}}async storeForwarded(){if(this.configurationService.getValue("remote.restoreForwardedPorts")){const F=Array.from(this.forwarded.values()),N=F.map(Y=>({remoteHost:Y.remoteHost,remotePort:Y.remotePort,localPort:Y.localPort,name:Y.name,localAddress:Y.localAddress,localUri:Y.localUri,protocol:Y.protocol,source:Y.source}));let M;F.length>0&&(M=JSON.stringify(N));const B=await this.getTunnelRestoreStorageKey(),W=await this.getRestoreExpirationStorageKey();!M&&B&&W?(this.storageService.remove(B,0),this.storageService.remove(W,0)):M!==this.knownPortsRestoreValue&&B&&W&&(this.storageService.store(B,M,0,0),this.storageService.store(W,Date.now()+l,0,0)),this.knownPortsRestoreValue=M}}async showPortMismatchModalIfNeeded(F,N,M){if(!F.tunnelLocalPort||!M?.requireLocalPort||F.tunnelLocalPort===N)return;const B=new Date;if(this.mismatchCooldown.getTime()+t>B.getTime())return;this.mismatchCooldown=B;const W=c.localize(3,null,N,F.tunnelRemotePort,F.tunnelLocalPort);return this.dialogService.info(W)}async forward(F,N){return!this.restoreComplete&&this.environmentService.remoteAuthority&&await T.Event.toPromise(this.onRestoreComplete.event),this.doForward(F,N)}async doForward(F,N){await this.extensionService.activateByEvent(e.ACTIVATION_EVENT);const M=E(this.forwarded,F.remote.host,F.remote.port);N=N??(N!==null?(await this.getAttributes([F.remote]))?.get(F.remote.port):void 0);const B=F.local!==void 0?F.local:F.remote.port;let W;if(M)return this.mergeAttributesIntoExistingTunnel(M,F,N);{const Y=this.environmentService.remoteAuthority,Z=Y?{getAddress:async()=>(await this.remoteAuthorityResolverService.resolveAuthority(Y)).authority}:void 0,G=_(F.remote.host,F.remote.port);this.inProgress.set(G,!0),F=this.mergeCachedAndUnrestoredProperties(G,F);const Q=await this.tunnelService.openTunnel(Z,F.remote.host,F.remote.port,void 0,B,F.elevateIfNeeded?F.elevateIfNeeded:N?.elevateIfNeeded,F.privacy,N?.protocol);if(typeof Q=="string")W=Q;else if(Q&&Q.localAddress){const re=E(this._candidates??new Map,F.remote.host,F.remote.port),te=Q.protocol?Q.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:N?.protocol??S.TunnelProtocol.Http,ve={remoteHost:Q.tunnelRemoteHost,remotePort:Q.tunnelRemotePort,localPort:Q.tunnelLocalPort,name:N?.label??F.name,closeable:!0,localAddress:Q.localAddress,protocol:te,localUri:await this.makeLocalUri(Q.localAddress,N),runningProcess:re?.detail,hasRunningProcess:!!re,pid:re?.pid,source:F.source??e.UserTunnelSource,privacy:Q.privacy};return this.forwarded.set(G,ve),this.remoteTunnels.set(G,Q),this.inProgress.delete(G),await this.storeForwarded(),await this.showPortMismatchModalIfNeeded(Q,B,N),this._onForwardPort.fire(ve),Q}this.inProgress.delete(G)}return W}mergeCachedAndUnrestoredProperties(F,N){const M=this.unrestoredExtensionTunnels.has(F)?this.unrestoredExtensionTunnels:this.sessionCachedProperties.has(F)?this.sessionCachedProperties:void 0;if(M){const B=M.get(F);M.delete(F),B&&(N.name=B.name??N.name,N.local=("local"in B?B.local:"localPort"in B?B.localPort:void 0)??N.local,N.privacy=N.privacy)}return N}async mergeAttributesIntoExistingTunnel(F,N,M){const B=M?.label??N.name;let W;(function(Z){Z[Z.None=0]="None",Z[Z.Fire=1]="Fire",Z[Z.Reopen=2]="Reopen"})(W||(W={}));let Y=W.None;switch(B!==F.name&&(F.name=B,Y=W.Fire),(M?.protocol||F.protocol!==S.TunnelProtocol.Http)&&M?.protocol!==F.protocol&&(N.source=F.source,Y=W.Reopen),N.privacy&&F.privacy!==N.privacy&&(Y=W.Reopen),Y){case W.Fire:{this._onForwardPort.fire();break}case W.Reopen:await this.close(F.remoteHost,F.remotePort,d.User),await this.doForward(N,M)}return E(this.remoteTunnels,N.remote.host,N.remote.port)}async name(F,N,M){const B=E(this.forwarded,F,N),W=_(F,N);if(B){B.name=M,await this.storeForwarded(),this._onPortName.fire({host:F,port:N});return}else this.detected.has(W)&&(this.detected.get(W).name=M,this._onPortName.fire({host:F,port:N}))}async close(F,N,M){const B=_(F,N),W=this.forwarded.get(B);return M===d.AutoForwardEnd&&W&&W.source.source===g.Auto&&this.sessionCachedProperties.set(B,{local:W.localPort,name:W.name,privacy:W.privacy}),await this.tunnelService.closeTunnel(F,N),this.onTunnelClosed({host:F,port:N},M)}address(F,N){const M=_(F,N);return(this.forwarded.get(M)||this.detected.get(M))?.localAddress}get environmentTunnelsSet(){return this._environmentTunnelsSet}addEnvironmentTunnels(F){if(F)for(const N of F){const M=E(this._candidates??new Map,N.remoteAddress.host,N.remoteAddress.port),B=typeof N.localAddress=="string"?N.localAddress:_(N.localAddress.host,N.localAddress.port);this.detected.set(_(N.remoteAddress.host,N.remoteAddress.port),{remoteHost:N.remoteAddress.host,remotePort:N.remoteAddress.port,localAddress:B,protocol:S.TunnelProtocol.Http,localUri:this.makeLocalUri(B),closeable:!1,runningProcess:M?.detail,hasRunningProcess:!!M,pid:M?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:g.Extension,description:c.localize(4,null)}}),this.tunnelService.setEnvironmentTunnel(N.remoteAddress.host,N.remoteAddress.port,B,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this._environmentTunnelsSet=!0,this._onEnvironmentTunnelsSet.fire(),this._onForwardPort.fire()}setCandidateFilter(F){this._candidateFilter=F}async setCandidates(F){let N=F;this._candidateFilter&&(N=await this._candidateFilter(F));const M=this.updateInResponseToCandidates(N);this.logService.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(M.values()).map(B=>B.port).join(", ")}`),this._onCandidatesChanged.fire(M)}updateInResponseToCandidates(F){const N=this._candidates??new Map,M=new Map;return this._candidates=M,F.forEach(B=>{const W=_(B.host,B.port);M.set(W,{host:B.host,port:B.port,detail:B.detail,pid:B.pid}),N.has(W)&&N.delete(W);const Y=E(this.forwarded,B.host,B.port);Y&&(Y.runningProcess=B.detail,Y.hasRunningProcess=!0,Y.pid=B.pid)}),N.forEach((B,W)=>{const Y=u(W);if(!Y)return;const Z=E(this.forwarded,Y.host,Y.port);Z&&(Z.runningProcess=void 0,Z.hasRunningProcess=!1,Z.pid=void 0);const G=E(this.detected,Y.host,Y.port);G&&(G.runningProcess=void 0,G.hasRunningProcess=!1,G.pid=void 0)}),N}get candidates(){return this._candidates?Array.from(this._candidates.values()):[]}get candidatesOrUndefined(){return this._candidates?this.candidates:void 0}async updateAttributes(){const F=Array.from(this.forwarded.values()),N=await this.getAttributes(F.map(M=>({port:M.remotePort,host:M.remoteHost})),!1);if(N)for(const M of F){const B=N.get(M.remotePort);(B?.protocol||M.protocol!==S.TunnelProtocol.Http)&&B?.protocol!==M.protocol&&await this.doForward({remote:{host:M.remoteHost,port:M.remotePort},local:M.localPort,name:M.name,source:M.source},B),B&&B.label&&B.label!==M.name&&await this.name(M.remoteHost,M.remotePort,B.label)}}async getAttributes(F,N=!0){const M=new Map,B=new Map;F.forEach(Q=>{const re=E(this._candidates??new Map,S.LOCALHOST_ADDRESSES[0],Q.port)??Q;if(re){M.set(Q.port,re);const te=P(re)?re.pid:void 0;B.has(te)||B.set(te,[]),B.get(te)?.push(Q.port)}});const W=new Map;if(F.forEach(Q=>{const re=this.configPortsAttributes.getAttributes(Q.port,Q.host,M.get(Q.port)?.detail);re&&W.set(Q.port,re)}),this.portAttributesProviders.length===0||!N)return W.size>0?W:void 0;const Y=await Promise.all((0,O.flatten)(this.portAttributesProviders.map(Q=>Array.from(B.entries()).map(re=>{const te=re[1],ve=M.get(te[0]);return Q.providePortAttributes(te,ve?.pid,ve?.detail,n.CancellationToken.None)})))),Z=new Map;if(Y.forEach(Q=>Q.forEach(re=>{re&&Z.set(re.port,re)})),!W&&!Z)return;const G=new Map;return F.forEach(Q=>{const re=W.get(Q.port),te=Z.get(Q.port);G.set(Q.port,{elevateIfNeeded:re?.elevateIfNeeded,label:re?.label,onAutoForward:re?.onAutoForward??k.providedActionToAction(te?.autoForwardAction),requireLocalPort:re?.requireLocalPort,protocol:re?.protocol})}),G}addAttributesProvider(F){this.portAttributesProviders.push(F)}};e.TunnelModel=z,Ge([(0,L.debounce)(1e3)],z.prototype,"storeForwarded",null),e.TunnelModel=z=Ge([Ue(0,S.ITunnelService),Ue(1,C.IStorageService),Ue(2,w.IConfigurationService),Ue(3,m.IWorkbenchEnvironmentService),Ue(4,v.IRemoteAuthorityResolverService),Ue(5,a.IWorkspaceContextService),Ue(6,I.ILogService),Ue(7,A.IDialogService),Ue(8,o.IExtensionService),Ue(9,s.IContextKeyService)],z)}),define(ye[94],_e([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(R,b){this.line=R,this.character=b}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,b){return new c(0,0)}with(R){return new c(0,0)}}e.Position=c;class O{constructor(R,b,p,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(R,b),this.end=new c(p,w)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new O(0,0,0,0)}with(R){return new O(0,0,0,0)}}e.Range=O;var L;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(L||(e.TextSearchCompleteMessageType=L={}))}),define(ye[36],_e([1,0,19,35,24,34,14,5,17,13,94,8]),function(de,e,c,O,L,T,R,b,p,w,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.SerializableFileMatch=e.SearchError=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,e.resultIsMatch=o,e.isFileMatch=n,e.isProgressMessage=i,e.getExcludes=g,e.pathIncludedInQuery=D,e.deserializeSearchError=y,e.serializeSearchError=P,e.isSerializedSearchComplete=k,e.isSerializedSearchSuccess=z,e.isSerializedFileMatch=x,e.isFilePatternMatch=F,e.resolvePatternsForProvider=M,e.hasSiblingPromiseFn=Y,e.hasSiblingFn=Z,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const v="\u27EA ",C=" characters skipped \u27EB",S=(v.length+C.length+5)*2;e.ISearchService=(0,b.createDecorator)("searchService");var a;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text",Q[Q.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var m;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text",Q[Q.aiText=3]="aiText"})(m||(e.QueryType=m={}));function o(Q){return!!Q.preview}function n(Q){return!!Q.resource}function i(Q){return!!Q.message}var r;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class s{constructor(re){this.resource=re,this.results=[]}}e.FileMatch=s;class t{constructor(re,te,ve,Ie){this.ranges=te,this.webviewIndex=Ie;const J=Array.isArray(te)?te:[te];if(ve&&ve.matchLines===1&&f(J)){re=(0,R.getNLines)(re,ve.matchLines);let $="",ne=0,be=0;const Ce=Math.floor(ve.charsPerLine/5),ae=[];for(const ce of J){const se=Math.max(ce.startColumn-Ce,0),j=ce.startColumn+ve.charsPerLine;if(se>be+Ce+S){const ie=v+(se-be)+C;$+=ie+re.slice(se,j),ne+=se-(be+ie.length)}else $+=re.slice(be,j);ae.push(new l(0,ce.startColumn-ne,ce.endColumn-ne)),be=j}this.preview={text:$,matches:Array.isArray(this.ranges)?ae:ae[0]}}else{const $=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:re,matches:(0,c.mapArrayOrNot)(te,ne=>new h(ne.startLineNumber-$,ne.startColumn,ne.endLineNumber-$,ne.endColumn))}}}}e.TextSearchMatch=t;function f(Q){const re=Q[0].startLineNumber;for(const te of Q)if(te.startLineNumber!==re||te.endLineNumber!==re)return!1;return!0}class h{constructor(re,te,ve,Ie){this.startLineNumber=re,this.startColumn=te,this.endLineNumber=ve,this.endColumn=Ie}}e.SearchRange=h;class l extends h{constructor(re,te,ve){super(re,te,re,ve)}}e.OneLineRange=l;var u;(function(Q){Q.List="list",Q.Tree="tree"})(u||(e.ViewMode=u={}));var d;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function g(Q,re=!0){const te=Q&&Q.files&&Q.files.exclude,ve=re&&Q&&Q.search&&Q.search.exclude;if(!te&&!ve)return;if(!te||!ve)return te||ve;let Ie=Object.create(null);return Ie=L.mixin(Ie,L.deepClone(te)),Ie=L.mixin(Ie,L.deepClone(ve),!0),Ie}function D(Q,re){return Q.excludePattern&&O.match(Q.excludePattern,re)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&O.match(Q.includePattern,re)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(te=>{const ve=te.folder.fsPath;if(T.isEqualOrParent(re,ve)){const Ie=p.relative(ve,re);return!te.includePattern||!!O.match(te.includePattern,Ie)}else return!1}):!1:!0}var E;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(E||(e.SearchErrorCode=E={}));class _ extends Error{constructor(re,te){super(re),this.code=te}}e.SearchError=_;function y(Q){const re=Q.message;if((0,w.isCancellationError)(Q))return new _(re,E.canceled);try{const te=JSON.parse(re);return new _(te.message,te.code)}catch{return new _(re,E.other)}}function P(Q){const re={message:Q.message,code:Q.code};return new Error(JSON.stringify(re))}function k(Q){return Q.type==="error"?!0:Q.type==="success"}function z(Q){return Q.type==="success"}function x(Q){return!!Q.path}function F(Q,re,te=!0){const ve=Q.searchPath?Q.searchPath:Q.relativePath;return te?(0,R.fuzzyContains)(ve,re):O.match(re,ve)}class N{constructor(re){this.path=re,this.results=[]}addMatch(re){this.results.push(re)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function M(Q,re){const te={...Q||{},...re||{}};return Object.keys(te).filter(ve=>{const Ie=te[ve];return typeof Ie=="boolean"&&Ie})}class B{constructor(re,te){this._parsedIncludeExpression=null,this._excludeExpression={...re.excludePattern||{},...te.excludePattern||{}},this._parsedExcludeExpression=O.parse(this._excludeExpression);let ve=re.includePattern;te.includePattern&&(ve?ve={...ve,...te.includePattern}:ve=te.includePattern),ve&&(this._parsedIncludeExpression=O.parse(ve))}matchesExcludesSync(re,te,ve){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(re,te,ve))}includedInQuerySync(re,te,ve){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(re,te,ve)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(re,te,ve))}includedInQuery(re,te,ve){const Ie=this._parsedExcludeExpression(re,te,ve),J=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(re,te,ve):!0;return(0,I.isThenable)(Ie)?Ie.then($=>$?!1:J()):J()}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=B;function W(Q){for(const re in Q)if(typeof Q[re]!="boolean")return!0;return!1}function Y(Q){if(!Q)return;let re;return te=>(re||(re=(Q()||Promise.resolve([])).then(ve=>ve?G(ve):{})),re.then(ve=>!!ve[te]))}function Z(Q){if(!Q)return;let re;return te=>{if(!re){const ve=Q();re=ve?G(ve):{}}return!!re[te]}}function G(Q){const re={};for(const te of Q)re[te]=!0;return re}}),define(ye[44],_e([1,0,19,8,22,4,3,77,15,125,23,14,2,230,5,12,262,42,59,28,20,16,7,66,36,6,57]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n,i,r,s,t,f,h,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function d(z,x,F){return new A.ExtUri(N=>_(N,F)).isEqual(z,x)}function g(z,x,F){return d(z.uri,x.uri,F)?0:(0,I.compare)(z.uri.toString(),x.uri.toString())}function D(z,x,F){return z.index!==x.index?z.index<x.index?-1:1:d(z.uri,x.uri,F)?(0,I.compare)(z.name,x.name):(0,I.compare)(z.uri.toString(),x.uri.toString())}function E(z,x,F,N){const M=z.slice(0).sort((W,Y)=>F(W,Y,N)),B=x.slice(0).sort((W,Y)=>F(W,Y,N));return(0,c.delta)(M,B,(W,Y)=>F(W,Y,N))}function _(z,x){const F=x.getCapabilities(z.scheme);return!(F&&F&1024)}class y extends o.Workspace{static toExtHostWorkspace(x,F,N,M){if(!x)return{workspace:null,added:[],removed:[]};const{id:B,name:W,folders:Y,configuration:Z,transient:G,isUntitled:Q}=x,re=[],te=F;F?Y.forEach(($,ne)=>{const be=v.URI.revive($.uri),Ce=y._findFolder(N||F,be,M);Ce?(Ce.name=$.name,Ce.index=$.index,re.push(Ce)):re.push({uri:be,name:$.name,index:ne})}):re.push(...Y.map(({uri:$,name:ne,index:be})=>({uri:v.URI.revive($),name:ne,index:be}))),re.sort(($,ne)=>$.index<ne.index?-1:1);const ve=new y(B,W,re,!!G,Z?v.URI.revive(Z):null,!!Q,$=>_($,M)),{added:Ie,removed:J}=E(te?te.workspaceFolders:[],ve.workspaceFolders,g,M);return{workspace:ve,added:Ie,removed:J}}static _findFolder(x,F,N){for(let M=0;M<x.folders.length;M++){const B=x.workspaceFolders[M];if(d(B.uri,F,N))return B}}constructor(x,F,N,M,B,W,Y){super(x,N.map(Z=>new o.WorkspaceFolder(Z)),M,B,Y),this._name=F,this._isUntitled=W,this._workspaceFolders=[],this._structure=b.TernarySearchTree.forUris(Y),N.forEach(Z=>{this._workspaceFolders.push(Z),this._structure.set(Z.uri,Z)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(x,F){return F&&this._structure.get(x)&&(x=(0,A.dirname)(x)),this._structure.findSubstr(x)}resolveWorkspaceFolder(x){return this._structure.get(x)}}let P=class{constructor(x,F,N,M,B){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new T.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=M,this._extHostFileSystemInfo=N,this._uriTransformerService=B,this._requestIdProvider=new w.Counter,this._barrier=new O.Barrier,this._proxy=x.getProxy(l.MainContext.MainThreadWorkspace),this._messageService=x.getProxy(l.MainContext.MainThreadMessageService);const W=F.workspace;this._confirmedWorkspace=W?new y(W.id,W.name,[],!!W.transient,W.configuration?v.URI.revive(W.configuration):null,!!W.isUntitled,Y=>_(Y,N)):void 0}$initializeWorkspace(x,F){this._trusted=F,this.$acceptWorkspaceData(x),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?v.URI.from({scheme:p.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(x,F,N,...M){const B=[];if(Array.isArray(M)&&M.forEach(Q=>{v.URI.isUri(Q.uri)&&!B.some(re=>d(re.uri,Q.uri,this._extHostFileSystemInfo))&&B.push({uri:Q.uri,name:Q.name||(0,A.basenameOrAuthority)(Q.uri)})}),this._unconfirmedWorkspace||[F,N].some(Q=>typeof Q!="number"||Q<0)||N===0&&B.length===0)return!1;const W=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(F+N>W.length)return!1;const Y=W.slice(0);Y.splice(F,N,...B.map(Q=>({uri:Q.uri,name:Q.name||(0,A.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<Y.length;Q++){const re=Y[Q];if(Y.some((te,ve)=>ve!==Q&&d(re.uri,te.uri,this._extHostFileSystemInfo)))return!1}Y.forEach((Q,re)=>Q.index=re);const{added:Z,removed:G}=E(W,Y,D,this._extHostFileSystemInfo);if(Z.length===0&&G.length===0)return!1;if(this._proxy){const Q=x.displayName||x.name;this._proxy.$updateWorkspaceFolders(Q,F,N,B).then(void 0,re=>{this._unconfirmedWorkspace=void 0;const te={source:{identifier:x.identifier,label:x.displayName||x.name}};this._messageService.$showMessage(m.Severity.Error,(0,C.localize)(0,null,Q,re.toString()),te,[])})}return this.trySetWorkspaceFolders(Y),!0}getWorkspaceFolder(x,F){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,F)}async getWorkspaceFolder2(x,F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,F)}async resolveWorkspaceFolder(x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(x)}getPath(){if(!this._actualWorkspace)return;const{folders:x}=this._actualWorkspace;if(x.length!==0)return x[0].uri.fsPath}getRelativePath(x,F){let N,M="";if(typeof x=="string"?(N=v.URI.file(x),M=x):typeof x<"u"&&(N=x,M=x.fsPath),!N)return M;const B=this.getWorkspaceFolder(N,!0);if(!B)return M;typeof F>"u"&&this._actualWorkspace&&(F=this._actualWorkspace.folders.length>1);let W=(0,A.relativePath)(B.uri,N);return F&&B.name&&(W=`${B.name}/${W}`),W}trySetWorkspaceFolders(x){this._actualWorkspace&&(this._unconfirmedWorkspace=y.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:x,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(x){const{workspace:F,added:N,removed:M}=y.toExtHostWorkspace(x,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=F||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:M}))}findFiles(x,F,N,M,B=L.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let W="",Y=!0;return F===null?Y=!1:F!==void 0&&(typeof F=="string"?W=F:W=F.pattern),this._findFilesImpl(x,void 0,{exclude:W,maxResults:N,useDefaultExcludes:Y,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},B)}findFiles2(x,F={},N,M=L.CancellationToken.None){return this._logService.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this._findFilesImpl(void 0,x,F,M)}async _findFilesImpl(x,F,N,M=L.CancellationToken.None){if(M&&M.isCancellationRequested)return Promise.resolve([]);const B=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,W={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:B,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let Y;if(x){const{includePattern:Z,folder:G}=k(s.GlobPattern.from(x));Y=G,W.includePattern=Z}else{const{includePattern:Z,folder:G}=k(s.GlobPattern.from(F));Y=G,W.filePattern=Z}return this._proxy.$startFileSearch(Y??null,W,M).then(Z=>Array.isArray(Z)?Z.map(G=>v.URI.revive(G)):[])}async findTextInFiles(x,F,N,M,B=L.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const W=this._requestIdProvider.getNext(),Y=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:Z,folder:G}=k(s.GlobPattern.from(F.include)),Q=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,re={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:Y,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:Z,excludePattern:Q},te=!1;if(this._activeSearchCallbacks[W]=ve=>{if(te)return;const Ie=v.URI.revive(ve.resource);ve.results.forEach(J=>{const $=(0,u.revive)(J);(0,h.resultIsMatch)($)?N({uri:Ie,preview:{text:$.preview.text,matches:(0,c.mapArrayOrNot)($.preview.matches,ne=>new t.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,c.mapArrayOrNot)($.ranges,ne=>new t.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):N({uri:Ie,text:$.text,lineNumber:$.lineNumber})})},B.isCancellationRequested)return{};try{const ve=await this._proxy.$startTextSearch(x,G??null,re,W,B);return delete this._activeSearchCallbacks[W],ve||{}}catch(ve){throw delete this._activeSearchCallbacks[W],ve}}$handleTextSearchResult(x,F){this._activeSearchCallbacks[F]?.(x)}async save(x){const F=await this._proxy.$save(x,{saveAs:!1});return v.URI.revive(F)}async saveAs(x){const F=await this._proxy.$save(x,{saveAs:!0});return v.URI.revive(F)}saveAll(x){return this._proxy.$saveAll(x)}resolveProxy(x){return this._proxy.$resolveProxy(x)}loadCertificates(){return this._proxy.$loadCertificates()}get trusted(){return this._trusted}requestWorkspaceTrust(x){return this._proxy.$requestWorkspaceTrust(x)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(x,F){if(this._editSessionIdentityProviders.has(x))throw new Error(`A provider has already been registered for scheme ${x}`);this._editSessionIdentityProviders.set(x,F);const N=this._uriTransformerService.transformOutgoingScheme(x),M=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(M,N),(0,R.toDisposable)(()=>{this._editSessionIdentityProviders.delete(x),this._proxy.$unregisterEditSessionIdentityProvider(M)})}async $getEditSessionIdentifier(x,F){this._logService.info("Getting edit session identifier for workspaceFolder",x);const N=await this.resolveWorkspaceFolder(v.URI.revive(x));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const M=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!M),!M)return;const B=await M.provideEditSessionIdentity(N,F);if(this._logService.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(x,F,N,M){this._logService.info("Getting edit session identifier for workspaceFolder",x);const B=await this.resolveWorkspaceFolder(v.URI.revive(x));if(!B){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const W=this._editSessionIdentityProviders.get(B.uri.scheme);if(this._logService.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!W),!W)return;const Y=await W.provideEditSessionIdentityMatch?.(F,N,M);if(this._logService.info("Provider returned edit session identifier match result: ",Y),!!Y)return Y}getOnWillCreateEditSessionIdentityEvent(x){return(F,N,M)=>{const B=function(Y){F.call(N,Y)};return B.extension=x,this._onWillCreateEditSessionIdentityEvent.event(B,void 0,M)}}async $onWillCreateEditSessionIdentity(x,F,N){const M=await this.resolveWorkspaceFolder(v.URI.revive(x));if(M===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:M},F,async(B,W)=>{const Y=Date.now();await Promise.resolve(B),Date.now()-Y>N&&this._logService.warn("SLOW edit session create-participant",W.extension.identifier)}),F.isCancellationRequested}registerCanonicalUriProvider(x,F){if(this._canonicalUriProviders.has(x))throw new Error(`A provider has already been registered for scheme ${x}`);this._canonicalUriProviders.set(x,F);const N=this._uriTransformerService.transformOutgoingScheme(x),M=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(M,N),(0,R.toDisposable)(()=>{this._canonicalUriProviders.delete(x),this._proxy.$unregisterCanonicalUriProvider(M)})}async provideCanonicalUri(x,F,N){const M=this._canonicalUriProviders.get(x.scheme);if(!M)return;const B=await M.provideCanonicalUri?.(v.URI.revive(x),F,N);if(B)return B}async $provideCanonicalUri(x,F,N){return this.provideCanonicalUri(v.URI.revive(x),{targetScheme:F},N)}};e.ExtHostWorkspace=P,e.ExtHostWorkspace=P=Ge([Ue(0,r.IExtHostRpcService),Ue(1,i.IExtHostInitDataService),Ue(2,n.IExtHostFileSystemInfo),Ue(3,a.ILogService),Ue(4,f.IURITransformerService)],P),e.IExtHostWorkspace=(0,S.createDecorator)("IExtHostWorkspace");function k(z){let x,F;return z&&(typeof z=="string"?x=z:(x=z.pattern,F=v.URI.revive(z.baseUri))),{includePattern:x,folder:F}}}),define(ye[45],_e([1,0,24,4,44,6,7,264,85,18,8,5,20,12,2]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(f,h){if(h){const l=h.split(".");let u=f;for(let d=0;u&&d<l.length;d++)u=u[l[d]];return u}}function m(f){return f instanceof S.URI}function o(f){return f&&f.uri instanceof S.URI&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&f.uri instanceof S.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function r(f){if(m(f))return{resource:f};if(o(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(n(f))return{overrideIdentifier:f.languageId};if(i(f))return{resource:f.uri};if(f===null)return{resource:null}}let s=class{constructor(h,l,u){this._proxy=h.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=l,this._logService=u,this._barrier=new A.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(h=>this._actual)}$initializeConfiguration(h){this._actual=new t(this._proxy,this._extHostWorkspace,h,this._logService),this._barrier.open()}$acceptConfigurationChanged(h,l){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(h,l))}};e.ExtHostConfiguration=s,e.ExtHostConfiguration=s=Ge([Ue(0,v.IExtHostRpcService),Ue(1,L.IExtHostWorkspace),Ue(2,C.ILogService)],s);class t{constructor(h,l,u,d){this._onDidChangeConfiguration=new O.Emitter,this._proxy=h,this._logService=d,this._extHostWorkspace=l,this._configuration=b.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(h,l){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=b.Configuration.parse(h),this._configurationScopes=this._toMap(h.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(l,u))}getConfiguration(h,l,u){const d=r(l)||{},g=this._toReadonlyValue(h?a(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),h):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));h&&this._validateConfigurationAccess(h,d,u?.identifier);function D(_){if(_==null)return null;if(typeof _=="boolean")return _?2:5;switch(_){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const E={has(_){return typeof a(g,_)<"u"},get:(_,y)=>{this._validateConfigurationAccess(h?`${h}.${_}`:_,d,u?.identifier);let P=a(g,_);if(typeof P>"u")P=y;else{let k;const z=(x,F)=>{if((0,w.isObject)(x)){let N;const M=()=>{k=k||(0,c.deepClone)(g),N=N||a(k,F)};return new Proxy(x,{get:(B,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return M(),()=>N;if(k)return N=N||a(k,F),N[W];const Y=B[W];return typeof W=="string"?z(Y,`${F}.${W}`):Y},set:(B,W,Y)=>(M(),N&&(N[W]=Y),!0),deleteProperty:(B,W)=>(M(),N&&delete N[W],!0),defineProperty:(B,W,Y)=>(M(),N&&Object.defineProperty(N,W,Y),!0)})}return Array.isArray(x)?(0,c.deepClone)(x):x};P=z(P,_)}return P},update:(_,y,P,k)=>{_=h?`${h}.${_}`:_;const z=D(P);return y!==void 0?this._proxy.$updateConfigurationOption(z,_,y,d,k):this._proxy.$removeConfigurationOption(z,_,d,k)},inspect:_=>{_=h?`${h}.${_}`:_;const y=this._configuration.inspect(_,d,this._extHostWorkspace.workspace);if(y)return{key:_,defaultValue:(0,c.deepClone)(y.policy?.value??y.default?.value),globalValue:(0,c.deepClone)(y.user?.value??y.application?.value),workspaceValue:(0,c.deepClone)(y.workspace?.value),workspaceFolderValue:(0,c.deepClone)(y.workspaceFolder?.value),defaultLanguageValue:(0,c.deepClone)(y.default?.override),globalLanguageValue:(0,c.deepClone)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,c.deepClone)(y.workspace?.override),workspaceFolderLanguageValue:(0,c.deepClone)(y.workspaceFolder?.override),languageIds:(0,c.deepClone)(y.overrideIdentifiers)}}};return typeof g=="object"&&(0,c.mixin)(E,g,!1),Object.freeze(E)}_toReadonlyValue(h){const l=u=>(0,w.isObject)(u)?new Proxy(u,{get:(d,g)=>l(d[g]),set:(d,g,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(d,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(d,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return l(h)}_validateConfigurationAccess(h,l,u){const d=p.OVERRIDE_PROPERTY_REGEX.test(h)?4:this._configurationScopes.get(h),g=u?`[${u.value}] `:"";if(d===4){typeof l?.resource>"u"&&this._logService.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${h}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){l?.resource&&this._logService.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${h}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(h,l){const u=new b.ConfigurationChangeEvent(h,l,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,g)=>u.affectsConfiguration(d,r(g))})}_toMap(h){return h.reduce((l,u)=>(l.set(u[0],u[1]),l),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")}),define(ye[95],_e([1,0,2,8,4,6,7,44,72,45,22,43,20,28,5,15,11,12,91,307,13]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(z){function x(N){if(N!=null)return N}z.from=x;function F(N){if(N!=null)return N}z.to=F})(s||(s={}));var t;(function(z){function x(N){if(N!=null)return N}z.from=x;function F(N){if(N!=null)return N}z.to=F})(t||(t={}));var f;(function(z){function x(N){if(N!=null)return N}z.from=x;function F(N){if(N!=null)return N}z.to=F})(f||(f={}));var h;(function(z){function x(M){if(M){const B=M;return B&&!!B.process}else return!1}z.is=x;function F(M){if(M==null)return;const B={process:M.process,args:M.args};return M.options&&(B.options=f.from(M.options)),B}z.from=F;function N(M){if(M!=null)return new R.ProcessExecution(M.process,M.args,M.options)}z.to=N})(h||(h={}));var l;(function(z){function x(N){if(N!=null)return N}z.from=x;function F(N){if(N!=null)return N}z.to=F})(l||(l={}));var u;(function(z){function x(M){if(M){const B=M;return B&&(!!B.commandLine||!!B.command)}else return!1}z.is=x;function F(M){if(M==null)return;const B={};return M.commandLine!==void 0?B.commandLine=M.commandLine:(B.command=M.command,B.args=M.args),M.options&&(B.options=l.from(M.options)),B}z.from=F;function N(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new R.ShellExecution(M.commandLine,M.options):new R.ShellExecution(M.command,M.args?M.args:[],M.options)}z.to=N})(u||(u={}));var d;(function(z){function x(M){if(M){const B=M;return B&&B.customExecution==="customExecution"}else return!1}z.is=x;function F(M){return{customExecution:"customExecution"}}z.from=F;function N(M,B){return B.get(M)}z.to=N})(d||(e.CustomExecutionDTO=d={}));var g;(function(z){function x(F,N){let M;return F.scope!==void 0&&typeof F.scope!="number"?M=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===R.TaskScope.Workspace&&N&&N.workspaceFile?M=N.workspaceFile:M=i.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:M}}z.from=x})(g||(e.TaskHandleDTO=g={}));var D;(function(z){function x(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}z.from=x})(D||(D={}));var E;(function(z){function x(M,B){if(M==null)return[];const W=[];for(const Y of M){const Z=F(Y,B);Z&&W.push(Z)}return W}z.fromMany=x;function F(M,B){if(M==null)return;let W;M.execution instanceof R.ProcessExecution?W=h.from(M.execution):M.execution instanceof R.ShellExecution?W=u.from(M.execution):M.execution&&M.execution instanceof R.CustomExecution&&(W=d.from(M.execution));const Y=s.from(M.definition);let Z;return M.scope?typeof M.scope=="number"?Z=M.scope:Z=M.scope.uri:Z=R.TaskScope.Workspace,!Y||!Z?void 0:{_id:M._id,definition:Y,name:M.name,source:{extensionId:B.identifier.value,label:M.source,scope:Z},execution:W,isBackground:M.isBackground,group:D.from(M.group),presentationOptions:t.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}z.from=F;async function N(M,B,W){if(M==null)return;let Y;h.is(M.execution)?Y=h.to(M.execution):u.is(M.execution)?Y=u.to(M.execution):d.is(M.execution)&&(Y=d.to(M._id,W));const Z=s.to(M.definition);let G;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?G=M.source.scope:G=await B.resolveWorkspaceFolder(c.URI.revive(M.source.scope)):G=R.TaskScope.Workspace),!Z||!G)return;const Q=new R.Task(Z,G,M.name,M.source.label,Y,M.problemMatchers);return M.isBackground!==void 0&&(Q.isBackground=M.isBackground),M.group!==void 0&&(Q.group=R.TaskGroup.from(M.group._id),Q.group&&M.group.isDefault&&(Q.group=new R.TaskGroup(Q.group.id,Q.group.label),M.group.isDefault===!0&&(Q.group.isDefault=M.group.isDefault))),M.presentationOptions&&(Q.presentationOptions=t.to(M.presentationOptions)),M._id&&(Q._id=M._id),M.detail&&(Q.detail=M.detail),Q}z.to=N})(E||(e.TaskDTO=E={}));var _;(function(z){function x(N){return N}z.from=x;function F(N){if(N)return Object.assign(Object.create(null),N)}z.to=F})(_||(_={}));class y{#e;constructor(x,F,N){this._id=F,this._task=N,this.#e=x}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}let P=class{constructor(x,F,N,M,B,W,Y,Z){this._onDidExecuteTask=new L.Emitter,this._onDidTerminateTask=new L.Emitter,this._onDidTaskProcessStarted=new L.Emitter,this._onDidTaskProcessEnded=new L.Emitter,this._proxy=x.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=M,this._configurationService=B,this._terminalService=W,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Y,this._deprecationService=Z,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,F,N){if(!N)return new R.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:F,provider:N,extension:x}),this._proxy.$registerTaskProvider(M,F),new R.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(x,F){this._proxy.$registerTaskSystem(x,F)}fetchTasks(x){return this._proxy.$fetchTasks(_.from(x)).then(async F=>{const N=[];for(const M of F){const B=await E.to(M,this._workspaceProvider,this._providedCustomExecutions2);B&&N.push(B)}return N})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(F=>x.push(F)),x}terminateTask(x){if(!(x instanceof y))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,F,N){const M=this._providedCustomExecutions2.get(x.id);M&&(this._activeCustomExecutions2.set(x.id,M),this._terminalService.attachPtyToTerminal(F,await M.callback(N))),this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){if(!this._taskExecutionPromises.has(x.id))return;const F=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:F})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const F=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:F,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const F=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:F,exitCode:x.exitCode})}$provideTasks(x,F){const N=this._handlers.get(x);if(!N)return Promise.reject(new Error("no handler found"));const M=[],B=(0,O.asPromise)(()=>N.provider.provideTasks(A.CancellationToken.None)).then(W=>this.provideTasksInternal(F,M,N,W));return new Promise(W=>{B.then(Y=>{Promise.all(M).then(()=>{W(Y)})})})}async $resolveTask(x,F){const N=this._handlers.get(x);if(!N)return Promise.reject(new Error("no handler found"));if(F.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${N.type}].`);const M=await E.to(F,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const B=await N.provider.resolveTask(M,A.CancellationToken.None);if(!B)return;this.checkDeprecation(B,N);const W=E.from(B,N.extension);if(!W)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(W.execution)&&await this.addCustomExecution(W,B,!0),await this.resolveTaskInternal(W)}nextHandle(){return this._handleCounter++}async addCustomExecution(x,F,N){const M=await this._proxy.$createTaskId(x);!N&&!this._providedCustomExecutions2.has(M)&&(this._notProvidedCustomExecutions.add(M),this._activeCustomExecutions2.set(M,F.execution)),this._providedCustomExecutions2.set(M,F.execution)}async getTaskExecution(x,F){if(typeof x=="string"){const B=this._taskExecutionPromises.get(x);if(!B)throw new r.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return B}const N=this._taskExecutionPromises.get(x.id);if(N)return N;let M;return F?M=Promise.resolve(new y(this,x.id,F)):M=E.to(x.task,this._workspaceProvider,this._providedCustomExecutions2).then(B=>{if(!B)throw new r.ErrorNoTelemetry("Unexpected: Task does not exist.");return new y(this,x.id,B)}),this._taskExecutionPromises.set(x.id,M),M.then(B=>(this._taskExecutions.set(x.id,B),B))}checkDeprecation(x,F){x._deprecated&&this._deprecationService.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));const N=this._notProvidedCustomExecutions.values();let M=N.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=N.next()}};e.ExtHostTaskBase=P,e.ExtHostTaskBase=P=Ge([Ue(0,v.IExtHostRpcService),Ue(1,C.IExtHostInitDataService),Ue(2,b.IExtHostWorkspace),Ue(3,p.IExtHostDocumentsAndEditors),Ue(4,w.IExtHostConfiguration),Ue(5,I.IExtHostTerminalService),Ue(6,o.ILogService),Ue(7,n.IExtHostApiDeprecationService)],P);let k=class extends P{constructor(x,F,N,M,B,W,Y,Z){super(x,F,N,M,B,W,Y,Z),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:m.PlatformToString(0)})}async executeTask(x,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const N=E.from(F,x);if(N===void 0)throw new Error("Task is not valid");if(d.is(N.execution))await this.addCustomExecution(N,F,!1);else throw new r.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),F);return this._proxy.$executeTask(N).catch(B=>{throw new Error(B)}),M}provideTasksInternal(x,F,N,M){const B=[];if(M)for(const W of M){if(this.checkDeprecation(W,N),!W.definition||!x[W.definition.type]){const Z=W.source?W.source:"No task source";this._logService.warn(`The task [${Z}, ${W.name}] uses an undefined task type. The task will be ignored in the future.`)}const Y=E.from(W,N.extension);Y&&d.is(Y.execution)?(B.push(Y),F.push(this.addCustomExecution(Y,W,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:B,extension:N.extension}}async resolveTaskInternal(x){if(d.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(x,F,N){}};e.WorkerExtHostTask=k,e.WorkerExtHostTask=k=Ge([Ue(0,v.IExtHostRpcService),Ue(1,C.IExtHostInitDataService),Ue(2,b.IExtHostWorkspace),Ue(3,p.IExtHostDocumentsAndEditors),Ue(4,w.IExtHostConfiguration),Ue(5,I.IExtHostTerminalService),Ue(6,o.ILogService),Ue(7,n.IExtHostApiDeprecationService)],k),e.IExtHostTask=(0,S.createDecorator)("IExtHostTask")}),define(ye[369],_e([1,0,36,29]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rawCellPrefix=void 0,e.isINotebookFileMatchNoModel=L,e.genericCellMatchesToTextSearchMatches=T;function L(R){return"cellResults"in R}e.rawCellPrefix="rawCell#";function T(R,b){let p=-1;const w=[];let A=[];return R.forEach(v=>{v.range.startLineNumber!==p&&A.length>0&&(w.push([...A]),A=[]),A.push(v),p=v.range.endLineNumber}),A.length>0&&w.push([...A]),w.map(v=>{const C=[],S=v[0].range.startLineNumber,a=v[v.length-1].range.endLineNumber;for(let m=S;m<=a;m++)C.push(b.getLineContent(m));return new c.TextSearchMatch(C.join(`
`)+`
`,v.map(m=>new O.Range(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(ye[370],_e([1,0,224,21,4,3,27,14,18,2,32,111,6,33,16,7,68,340,153,24,15,297,369,366]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(u=>u.apiEditor)}constructor(u,d,g,D,E,_){this._textDocumentsAndEditors=g,this._textDocuments=D,this._extHostFileSystem=E,this._extHostSearch=_,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new I.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=u.getProxy(v.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=u.getProxy(v.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=u.getProxy(v.MainContext.MainThreadNotebookEditors),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const P=y.notebookEditor?.notebookUri,k=y.cell.handle,x=this._documents.get(P)?.getCell(k);if(x)return x.apiCell}if(y&&y.$mid===14){const P=y.uri,k=this._documents.get(P);if(k)return k.apiNotebook}return y}}),h._registerApiCommands(d)}getEditorById(u){const d=this._editors.get(u);if(!d)throw new Error(`unknown text editor: ${u}. known editors: ${[...this._editors.keys()]} `);return d}getIdByEditor(u){for(const[d,g]of this._editors)if(g.apiEditor===u)return d}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(u,d){const g=this._documents.get(u);if(!g&&!d)throw new Error(`NO notebook document for '${u}'`);return g}static _convertNotebookRegistrationData(u,d){if(!d)return;const g=d.filenamePattern.map(D=>S.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(d.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:u.identifier,providerDisplayName:u.displayName||u.name,displayName:d.displayName,filenamePattern:g,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(u,d,g){const D=h._notebookStatusBarItemProviderHandlePool++,E=typeof g.onDidChangeCellStatusBarItems=="function"?h._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(D,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(D,E,d);let _;return E!==void 0&&(_=g.onDidChangeCellStatusBarItems(y=>this._notebookProxy.$emitCellStatusBarEvent(E))),new a.Disposable(()=>{this._notebookStatusBarItemProviders.delete(D),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(D,E),_?.dispose()})}async createNotebookDocument(u){const d=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:u.viewType,content:u.content&&S.NotebookData.from(u.content)});return w.URI.revive(d)}async openNotebookDocument(u){const d=this._documents.get(u);if(d)return d.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(u),D=this._documents.get(w.URI.revive(g));return(0,p.assertIsDefined)(D?.apiNotebook)}async showNotebookDocument(u,d){w.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let g;typeof d=="object"?g={position:S.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(S.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:g={preserveFocus:!1};const D=await this._notebookEditorsProxy.$tryShowNotebookDocument(u.uri,u.notebookType,g),E=D&&this._editors.get(D)?.apiEditor;if(E)return E;throw D?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(u,d,g,D){const E=this._notebookStatusBarItemProviders.get(u),_=w.URI.revive(d),y=this._documents.get(_);if(!y||!E)return;const P=y.getCellFromIndex(g);if(!P)return;const k=await E.provideCellStatusBarItems(P.apiCell,D);if(!k)return;const z=new T.DisposableStore,x=this._statusBarCache.add([z]),N=(Array.isArray(k)?k:[k]).map(M=>S.NotebookStatusBarItem.from(M,this._commandsConverter,z));return{cacheId:x,items:N}}$releaseNotebookCellStatusBarItems(u){this._statusBarCache.delete(u)}registerNotebookSerializer(u,d,g,D,E){if((0,b.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");const _=this._handlePool++;return this._notebookSerializer.set(_,{viewType:d,serializer:g,options:D}),this._notebookProxy.$registerNotebookSerializer(_,{id:u.identifier,location:u.extensionLocation},d,S.NotebookDocumentContentOptions.from(D),h._convertNotebookRegistrationData(u,E)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(_)})}async $dataToNotebook(u,d,g){const D=this._notebookSerializer.get(u);if(!D)throw new Error("NO serializer found");const E=await D.serializer.deserializeNotebook(d.buffer,g);return new m.SerializableObjectWithBuffers(S.NotebookData.from(E))}async $notebookToData(u,d,g){const D=this._notebookSerializer.get(u);if(!D)throw new Error("NO serializer found");const E=await D.serializer.serializeNotebook(S.NotebookData.to(d.value),g);return O.VSBuffer.wrap(E)}async $saveNotebook(u,d,g,D,E){const _=w.URI.revive(d),y=this._notebookSerializer.get(u);if(!y)throw new Error("NO serializer found");const P=this._documents.get(_);if(!P)throw new Error("Document NOT found");if(P.versionId!==g)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(_.scheme))throw new A.FileOperationError((0,c.localize)(0,null,this._resourceForError(_)),6);await this._validateWriteFile(_,D);const k={metadata:(0,i.filter)(P.apiNotebook.metadata,M=>!(y.options?.transientDocumentMetadata??{})[M]),cells:[]};for(const M of P.apiNotebook.getCells()){const B=new a.NotebookCellData(M.kind,M.document.getText(),M.document.languageId,M.mime,y.options?.transientOutputs?[]:[...M.outputs],M.metadata,M.executionSummary);B.metadata=(0,i.filter)(M.metadata,W=>!(y.options?.transientCellMetadata??{})[W]),k.cells.push(B)}const z=await y.serializer.serializeNotebook(k,E);await this._extHostFileSystem.value.writeFile(_,z);const x=this._extHostFileSystem.getFileSystemProviderExtUri(_.scheme),F=await this._extHostFileSystem.value.stat(_);return{name:x.basename(_),isFile:(F.type&A.FileType.File)!==0,isDirectory:(F.type&A.FileType.Directory)!==0,isSymbolicLink:(F.type&A.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&A.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(_.scheme),locked:!!((F.permissions??0)&A.FilePermission.Locked),etag:A.etag({mtime:F.mtime,size:F.size}),children:void 0}}async $searchInNotebooks(u,d,g,D,E){const _=this._notebookSerializer.get(u)?.serializer;if(!_)return{limitHit:!1,results:[]};const y=new R.ResourceSet;await(async(F,N,M)=>{await Promise.all(F.map(async B=>await Promise.all(B.filenamePatterns.map(W=>{const Y={_reason:M._reason,folderQueries:M.folderQueries,includePattern:M.includePattern,excludePattern:M.excludePattern,maxResults:M.maxResults,type:1,filePattern:W};return this._extHostSearch.doInternalFileSearchWithCustomCallback(Y,N,Z=>{Z.forEach(G=>{y.has(G)||D.some(re=>B.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(te=>(0,f.globMatchesResource)(te,G)))||y.add(G)})}).catch(Z=>{if(Z.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Z})}))))})(g,E,d);const k=new R.ResourceMap;let z=!1;const x=Array.from(y).map(async F=>{const N=[];try{if(E.isCancellationRequested)return;if(d.maxResults&&[...k.values()].reduce((Y,Z)=>Y+Z.cellResults.length,0)>d.maxResults){z=!0;return}const M=[],B=this._documents.get(F);if(B)B.apiNotebook.getCells().forEach(Z=>M.push({input:Z.document.getText(),outputs:Z.outputs.flatMap(G=>G.items.map(Q=>Q.data.toString()))}));else{const Y=await this._extHostFileSystem.value.readFile(F),Z=O.VSBuffer.fromString(Y.toString()),G=await _.deserializeNotebook(Z.buffer,E);if(E.isCancellationRequested)return;S.NotebookData.from(G).cells.forEach(re=>M.push({input:re.source,outputs:re.outputs.flatMap(te=>te.items.map(ve=>ve.valueBytes.toString()))}))}if(E.isCancellationRequested)return;M.forEach((Y,Z)=>{const G=d.contentPattern.pattern,Q=new s.CellSearchModel(Y.input,void 0,Y.outputs),re=Q.findInInputs(G),te=Q.findInOutputs(G),ve=te.flatMap(Ie=>(0,t.genericCellMatchesToTextSearchMatches)(Ie.matches,Ie.textBuffer)).map((Ie,J)=>(Ie.webviewIndex=J,Ie));if(re.length>0||te.length>0){const Ie={index:Z,contentResults:(0,t.genericCellMatchesToTextSearchMatches)(re,Q.inputTextBuffer),webviewResults:ve};N.push(Ie)}});const W={resource:F,cellResults:N};k.set(F,W);return}catch{return}});return await Promise.all(x),{limitHit:z,results:[...k.values()]}}async _validateWriteFile(u,d){const g=await this._extHostFileSystem.value.stat(u);if(typeof d?.mtime=="number"&&typeof d.etag=="string"&&d.etag!==A.ETAG_DISABLED&&typeof g.mtime=="number"&&typeof g.size=="number"&&d.mtime<g.mtime&&d.etag!==A.etag({mtime:d.mtime,size:g.size}))throw new A.FileOperationError((0,c.localize)(1,null),3,d)}_resourceForError(u){return u.scheme===r.Schemas.file?u.fsPath:u.toString()}_createExtHostEditor(u,d,g){if(this._editors.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const D=new n.ExtHostNotebookEditor(d,this._notebookEditorsProxy,u,g.visibleRanges.map(S.NotebookRange.to),g.selections.map(S.NotebookRange.to),typeof g.viewColumn=="number"?S.ViewColumn.to(g.viewColumn):void 0);this._editors.set(d,D)}$acceptDocumentAndEditorsDelta(u){if(u.value.removedDocuments)for(const g of u.value.removedDocuments){const D=w.URI.revive(g),E=this._documents.get(D);E&&(E.dispose(),this._documents.delete(D),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:E.apiNotebook.getCells().map(_=>_.document.uri)}),this._onDidCloseNotebookDocument.fire(E.apiNotebook));for(const _ of this._editors.values())_.notebookData.uri.toString()===D.toString()&&this._editors.delete(_.id)}if(u.value.addedDocuments){const g=[];for(const D of u.value.addedDocuments){const E=w.URI.revive(D.uri);if(this._documents.has(E))throw new Error(`adding EXISTING notebook ${E} `);const _=new o.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,E,D);g.push(...D.cells.map(y=>o.ExtHostCell.asModelAddData(y))),this._documents.get(E)?.dispose(),this._documents.set(E,_),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(_.apiNotebook)}}if(u.value.addedEditors)for(const g of u.value.addedEditors){if(this._editors.has(g.id))return;const D=w.URI.revive(g.documentUri),E=this._documents.get(D);E&&this._createExtHostEditor(E,g.id,g)}const d=[];if(u.value.removedEditors)for(const g of u.value.removedEditors){const D=this._editors.get(g);D&&(this._editors.delete(g),this._activeNotebookEditor?.id===D.id&&(this._activeNotebookEditor=void 0),d.push(D))}if(u.value.visibleEditors){this._visibleNotebookEditors=u.value.visibleEditors.map(D=>this._editors.get(D)).filter(D=>!!D);const g=new Set;this._visibleNotebookEditors.forEach(D=>g.add(D.id));for(const D of this._editors.values()){const E=g.has(D.id);D._acceptVisibility(E)}this._visibleNotebookEditors=[...this._editors.values()].map(D=>D).filter(D=>D.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}u.value.newActiveEditor===null?this._activeNotebookEditor=void 0:u.value.newActiveEditor&&(this._editors.get(u.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${u.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(u.value.newActiveEditor)),u.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(u){const d=C.ApiCommandArgument.String.with("notebookType","A notebook type"),g=new C.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[d,new C.ApiCommandArgument("data","Bytes to convert to data",E=>E instanceof Uint8Array,E=>O.VSBuffer.wrap(E))],new C.ApiCommandResult("Notebook Data",E=>S.NotebookData.to(E.value))),D=new C.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[d,new C.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",E=>!0,E=>new m.SerializableObjectWithBuffers(S.NotebookData.from(E)))],new C.ApiCommandResult("Bytes",E=>E.buffer));u.registerApiCommand(g),u.registerApiCommand(D)}}e.ExtHostNotebookController=h}),define(ye[371],_e([1,0,17,22,47,35,23,39,36]),function(de,e,c,O,L,T,R,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class w{constructor(v,C,S){this.config=v,this.provider=C,this.sessionToken=S,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=v.filePattern,this.includePattern=v.includePattern&&T.parse(v.includePattern),this.maxResults=v.maxResults||void 0,this.exists=v.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=v.excludePattern&&T.parse(v.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(v=>v.cancel()),this.activeCancellationTokens=new Set}search(v){const C=this.config.folderQueries||[];return new Promise((S,a)=>{const m=o=>{this.resultCount++,v(o)};if(this.isCanceled)return S({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(o=>{const n=o.toString(),i=c.basename(n);this.globalExcludePattern&&this.globalExcludePattern(n,i)||this.matchFile(m,{base:o,basename:i})}),Promise.all(C.map(o=>this.searchInFolder(o,m))).then(o=>{S({limitHit:this.isLimitHit,stats:o[0]||void 0})},o=>{a(new Error((0,L.toErrorMessage)(o)))})})}async searchInFolder(v,C){const S=new O.CancellationTokenSource,a=this.getSearchOptionsForFolder(v),m=this.initDirectoryTree(),o=new p.QueryGlobTester(this.config,v),n=!o.hasSiblingExcludeClauses();let i;try{this.activeCancellationTokens.add(S),i=b.StopWatch.create();const r=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,S.token),s=i.elapsed(),t=b.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(f=>{const h=c.posix.relative(v.folder.path,f.path);if(n){const l=c.basename(f.path);this.matchFile(C,{base:v.folder,relativePath:h,basename:l});return}this.addDirectoryEntries(m,v.folder,h,C)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(m,o,C),{providerTime:s,postProcessTime:t.elapsed()})}finally{S.dispose(),this.activeCancellationTokens.delete(S)}}getSearchOptionsForFolder(v){const C=(0,p.resolvePatternsForProvider)(this.config.includePattern,v.includePattern),S=(0,p.resolvePatternsForProvider)(this.config.excludePattern,v.excludePattern);return{folder:v.folder,excludes:S,includes:C,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}addDirectoryEntries({pathToEntries:v},C,S,a){if(S===this.filePattern){const o=c.basename(this.filePattern);this.matchFile(a,{base:C,relativePath:this.filePattern,basename:o})}function m(o){const n=c.basename(o),i=c.dirname(o);let r=v[i];r||(r=v[i]=[],m(i)),r.push({base:C,relativePath:o,basename:n})}m(S)}matchDirectoryTree({rootEntries:v,pathToEntries:C},S,a){const m=this,o=this.filePattern;function n(i){const r=(0,p.hasSiblingFn)(()=>i.map(s=>s.basename));for(let s=0,t=i.length;s<t;s++){const f=i[s],{relativePath:h,basename:l}=f;if(S.matchesExcludesSync(h,l,o!==l?r:void 0))continue;const u=C[h];if(u)n(u);else{if(h===o)continue;m.matchFile(a,f)}if(m.isLimitHit)break}}n(v)}matchFile(v,C){(!this.includePattern||C.relativePath&&this.includePattern(C.relativePath,C.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||v(C))}}class A{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(v,C,S,a){const m=this.getSessionTokenSource(v.cacheKey),o=new w(v,C,m&&m.token);let n=0;const i=r=>{n+=r.length,S(r.map(s=>this.rawMatchToSearchItem(s)))};return this.doSearch(o,A.BATCH_SIZE,i,a).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:r.stats}}))}clearCache(v){this.getSessionTokenSource(v)?.cancel()}getSessionTokenSource(v){if(v)return this.sessions.has(v)||this.sessions.set(v,new O.CancellationTokenSource),this.sessions.get(v)}rawMatchToSearchItem(v){return v.relativePath?{resource:R.joinPath(v.base,v.relativePath)}:{resource:v.base}}doSearch(v,C,S,a){const m=a.onCancellationRequested(()=>{v.cancel()}),o=i=>{i&&(n.push(i),C>0&&n.length>=C&&(S(n),n=[]))};let n=[];return v.search(o).then(i=>(n.length&&S(n),m.dispose(),i),i=>(n.length&&S(n),m.dispose(),Promise.reject(i)))}}e.FileSearchManager=A}),define(ye[372],_e([1,0,19,73,35,103,27,15,17,23,14,18,2,100,244,53,12,42,146,367,36]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryBuilder=void 0,e.resolveResourcesForSearchIncludes=D;let s=class{constructor(_,y,P,k,z){this.configurationService=_,this.workspaceContextService=y,this.editorGroupsService=P,this.logService=k,this.pathService=z}text(_,y,P={}){_=this.getContentPattern(_,P);const k=this.configurationService.getValue(),z=y&&y.some(F=>!this.configurationService.getValue({resource:F}).search.useRipgrep);return{...this.commonQuery(y?.map(o.toWorkspaceFolder),P),type:2,contentPattern:_,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:k.search.usePCRE2||z||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}getContentPattern(_,y){const P=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const k={..._,wordSeparators:P.editor.wordSeparators};return this.isCaseSensitive(_,y)&&(k.isCaseSensitive=!0),this.isMultiline(_)&&(k.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(k.notebookInfo||(k.notebookInfo={}),k.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(k.notebookInfo||(k.notebookInfo={}),k.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(k.notebookInfo||(k.notebookInfo={}),k.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(k.notebookInfo||(k.notebookInfo={}),k.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),k}file(_,y={}){return{...this.commonQuery(_,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}handleIncludeExclude(_,y){return _?(_=Array.isArray(_)?_.map(u):u(_),y?this.parseSearchPaths(_):{pattern:f(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],y={}){const P=this.handleIncludeExclude(y.includePattern,y.expandPatterns),k=this.handleIncludeExclude(y.excludePattern,y.expandPatterns),z=_.length>1,x=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(M=>this.getFolderQueryForSearchPath(M,y,k)):_.map(M=>this.getFolderQueryForRoot(M,y,k,z))).filter(M=>!!M),F={_reason:y._reason,folderQueries:x,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:k.pattern,includePattern:P.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const M=c.coalesce(c.flatten(this.editorGroupsService.groups.map(Y=>Y.editors.map(Z=>Z.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const B=M.filter(Y=>(0,r.pathIncludedInQuery)(F,Y.fsPath)),W=this.commonQueryFromFileList(B);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...F,...W}}const N=y.extraFileResources&&y.extraFileResources.filter(M=>(0,r.pathIncludedInQuery)(F,M.fsPath));return F.extraFileResources=N&&N.length?N:void 0,F}commonQueryFromFileList(_){const y=[],P=new R.ResourceMap,k={};let z=!1;return _.forEach(x=>{if(x.scheme===b.Schemas.walkThrough)return;if((0,w.isAbsolutePath)(x)){const N=this.workspaceContextService.getWorkspaceFolder(x)?.uri??x.with({path:p.dirname(x.fsPath)});let M=P.get(N);M||(z=!0,M={folder:N,includePattern:{}},y.push(M),P.set(N,M));const B=p.relative(N.fsPath,x.fsPath);(0,I.assertIsDefined)(M.includePattern)[B.replace(/\\/g,"/")]=!0}else x.fsPath&&(z=!0,k[x.fsPath]=!0)}),{folderQueries:y,includePattern:k,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}isCaseSensitive(_,y){if(y.isSmartCase){if(_.isRegExp){if(A.containsUppercaseCharacter(_.pattern,!0))return!0}else if(A.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&(0,C.isMultilineRegexSource)(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const y=W=>p.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),k=(Array.isArray(_)?_:h(_)).map(W=>{const Y=this.pathService.resolvedUserHome;return Y?(0,T.untildify)(W,Y.scheme===b.Schemas.file?Y.fsPath:Y.path):W}),z=O.groupBy(k,W=>y(W)?"searchPaths":"exprSegments"),x=(z.exprSegments||[]).map(W=>A.rtrim(W,"/")).map(W=>A.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),l(W))),F={},N=this.expandSearchPathPatterns(z.searchPaths||[]);N&&N.length&&(F.searchPaths=N);const M=c.flatten(x),B=f(...M);return B&&(F.pattern=B),F}getExcludesForFolder(_,y){return y.disregardExcludeSettings?void 0:(0,r.getExcludes)(_,!y.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const y=_.flatMap(k=>{let{pathPortion:z,globPortion:x}=t(k);return x&&(x=d(x)),this.expandOneSearchPath(z).flatMap(N=>this.resolveOneSearchPathPattern(N,x))}),P=new Map;return y.forEach(k=>{const z=k.searchPath.toString(),x=P.get(z);x?k.pattern&&(x.pattern=x.pattern||{},x.pattern[k.pattern]=!0):P.set(z,{searchPath:k.searchPath,pattern:k.pattern?f(k.pattern):void 0})}),Array.from(P.values())}expandOneSearchPath(_){if(p.isAbsolute(_)){const y=this.workspaceContextService.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==b.Schemas.file?[{searchPath:y[0].uri.with({path:_})}]:[{searchPath:v.URI.file(p.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const y=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=u(_),_.startsWith("../")||_===".."){const k=p.posix.resolve(y.path,_);return[{searchPath:y.with({path:k})}]}const P=d(_);return[{searchPath:y,pattern:P}]}else{if(_==="./"||_===".\\")return[];{const y=_.replace(/^\.[\/\\]/,""),k=this.workspaceContextService.getWorkspace().folders.map(z=>{const x=y.match(new RegExp(`^${A.escapeRegExpCharacters(z.name)}(?:/(.*)|$)`));return x?{match:x,folder:z}:null}).filter(I.isDefined);if(k.length)return k.map(z=>{const x=z.match[1];return{searchPath:z.folder.uri,pattern:x&&d(x)}});{const z=_.match(/\.[\/\\](.+)[\/\\]?/),x=z?z[1]:_,F=S.localize(0,null,x);throw new Error(F)}}}}resolveOneSearchPathPattern(_,y){const P=_.pattern&&y?`${_.pattern}/${y}`:_.pattern||y,k=[{searchPath:_.searchPath,pattern:P}];return P&&!P.endsWith("**")&&k.push({searchPath:_.searchPath,pattern:P+"/**"}),k}getFolderQueryForSearchPath(_,y,P){const k=this.getFolderQueryForRoot((0,o.toWorkspaceFolder)(_.searchPath),y,P,!1);return k?{...k,includePattern:_.pattern}:null}getFolderQueryForRoot(_,y,P,k){let z;const x=v.URI.isUri(_)?_:_.uri;if(P.searchPaths){const W=P.searchPaths.filter(Y=>(0,w.isEqual)(Y.searchPath,x))[0];if(W&&!W.pattern)return null;W&&(z=W.pattern)}const F=this.configurationService.getValue({resource:x}),M={...this.getExcludesForFolder(F,y)||{},...z||{}},B=v.URI.isUri(_)?(0,w.basename)(_):_.name;return{folder:x,folderName:k?B:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!F.search.followSymlinks}}};e.QueryBuilder=s,e.QueryBuilder=s=Ge([Ue(0,a.IConfigurationService),Ue(1,o.IWorkspaceContextService),Ue(2,n.IEditorGroupsService),Ue(3,m.ILogService),Ue(4,i.IPathService)],s);function t(E){const _=E.match(/[\*\{\}\(\)\[\]\?]/);if(_){const y=_.index,P=E.substr(0,y).match(/[/|\\][^/\\]*$/);if(P){let k=E.substr(0,P.index);return k.match(/[/\\]/)||(k+="/"),{pathPortion:k,globPortion:E.substr((P.index||0)+1)}}}return{pathPortion:E}}function f(...E){return E.length?E.reduce((_,y)=>(_[y]=!0,_),Object.create(null)):void 0}function h(E){return L.splitGlobAware(E,",").map(_=>_.trim()).filter(_=>!!_.length)}function l(E){return[`**/${E}/**`,`**/${E}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function u(E){return E.replace(/\\/g,"/")}function d(E){return u(E).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(E){return E.replace(/([?*[\]])/g,"[$1]")}function D(E,_){E=c.distinct(E,k=>k.toString());const y=[],P=_.getWorkspace();return E&&E.forEach(k=>{let z;if(_.getWorkbenchState()===2)z=(0,w.relativePath)(P.folders[0].uri,k),z&&z!=="."&&(z="./"+z);else{const x=_.getWorkspaceFolder(k);if(x){const F=x.name;if(P.folders.filter(M=>M.name===F).length===1){const M=(0,w.relativePath)(x.uri,k);M===""?z=`./${x.name}`:z=`./${x.name}/${M}`}else z=k.fsPath}}z&&y.push(g(z))}),y}}),define(ye[373],_e([1,0,23,2,22,13,5,372,36,42,8]),function(de,e,c,O,L,T,R,b,p,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkActivateWorkspaceContainsExtension=v,e.checkGlobFileExists=a;const I=7e3;function v(m,o){const n=o.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],r=[];for(const u of n)if(/^workspaceContains:/.test(u)){const d=u.substr(18);d.indexOf("*")>=0||d.indexOf("?")>=0||m.forceUsingSearch?r.push(d):i.push(d)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:s,resolve:t}=(0,A.promiseWithResolvers)(),f=u=>t({activationEvent:u}),h=Promise.all(i.map(u=>C(m,u,f))).then(()=>{}),l=S(m,o.identifier,r,f);return Promise.all([h,l]).then(()=>{t(void 0)}),s}async function C(m,o,n){for(const i of m.folders)if(await m.exists(c.joinPath(O.URI.revive(i),o))){n(`workspaceContains:${o}`);return}}async function S(m,o,n,i){if(n.length===0)return Promise.resolve(void 0);const r=new L.CancellationTokenSource,s=m.checkExists(m.folders,n,r.token),t=setTimeout(async()=>{r.cancel(),m.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},I);let f=!1;try{f=await s}catch(h){T.isCancellationError(h)||T.onUnexpectedError(h)}r.dispose(),clearTimeout(t),f&&i(`workspaceContains:${n.join(",")}`)}function a(m,o,n,i){const r=m.get(R.IInstantiationService),s=m.get(p.ISearchService),f=r.createInstance(b.QueryBuilder).file(o.map(h=>(0,w.toWorkspaceFolder)(O.URI.revive(h))),{_reason:"checkExists",includePattern:n,exists:!0});return s.fileSearch(f,i).then(h=>!!h.limitHit,h=>T.isCancellationError(h)?!1:Promise.reject(h))}}),define(ye[48],_e([1,0,220,17,58,23,8,3,77,2,12,6,45,303,118,44,26,148,13,25,21,281,7,65,5,28,93,20,107,70,43,121,4,373,117,283,15,115,39,11,116]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n,i,r,s,t,f,h,l,u,d,g,D,E,_,y,P,k,z,x,F,N,M,B){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,h.createDecorator)("IHostUtils");let Y=W=class extends b.Disposable{constructor($,ne,be,Ce,ae,ce,se,j,ie,ue,he,Te,me){super(),this._extHostManagedSockets=Te,this._extHostLanguageModels=me,this._onDidChangeRemoteConnectionData=this._register(new y.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._realPathCache=new Map,this._isTerminating=!1,this._hostUtils=ne,this._extHostContext=be,this._initData=se,this._extHostWorkspace=Ce,this._extHostConfiguration=ae,this._logService=ce,this._extHostTunnelService=ie,this._extHostTerminalService=ue,this._extHostLocalizationService=he,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._activationEventsReader=new Ie(this._initData.extensions.activationEvents),this._globalRegistry=new o.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const Pe=new i.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new o.ExtensionDescriptionRegistry(this._activationEventsReader,te(this._globalRegistry,Pe)),M.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${Q(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${Q(this._myRegistry)}`)),this._storage=new S.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new k.ExtHostSecretState(this._extHostContext),this._storagePath=j,this._instaService=$.createChild(new g.ServiceCollection([S.IExtHostStorage,this._storage],[k.IExtHostSecretState,this._secretState])),this._activator=this._register(new C.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(Ae,xe,H)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ae,n.transformErrorForSerialization(xe),H)},actualActivateExtension:async(Ae,xe)=>{if(o.ExtensionDescriptionRegistry.isHostExtension(Ae,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(Ae,xe),new C.HostExtension;const H=this._myRegistry.getExtensionDescription(Ae);return this._activateExtension(H,xe)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),L.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch($){n.onUnexpectedError($)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let $=[];try{$=this._myRegistry.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this._deactivate(ae))}catch{}await Promise.all($)}terminate($,ne=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${$}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),n.setUnexpectedErrorHandler(Ce=>{this._logService.error(Ce)}),this._extHostContext.dispose();const be=this._deactivateAll();Promise.race([(0,R.timeout)(5e3),be]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${ne}`):this._logService.info(`Extension host exiting with code ${ne}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(ne)})}isActivated($){return this._readyToRunExtensions.isOpen()?this._activator.isActivated($):!1}async getExtension($){const ne=await this._mainThreadExtensionsProxy.$getExtension($);return ne&&{...ne,identifier:new i.ExtensionIdentifier(ne.identifier.value),extensionLocation:w.URI.revive(ne.extensionLocation)}}_activateByEvent($,ne){return this._activator.activateByEvent($,ne)}_activateById($,ne){return this._activator.activateById($,ne)}activateByIdWithErrors($,ne){return this._activateById($,ne).then(()=>{const be=this._activator.getActivatedExtension($);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then($=>this._myRegistry)}getExtensionExports($){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension($).exports;try{return this._activator.getActivatedExtension($).exports}catch{return null}}async _realPathExtensionUri($){if($.scheme===x.Schemas.file&&this._hostUtils.fsRealpath){const ne=$.fsPath;this._realPathCache.has(ne)||this._realPathCache.set(ne,this._hostUtils.fsRealpath(ne));const be=await this._realPathCache.get(ne);return w.URI.file(be)}return $}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then($=>new ve($))),this._extensionPathIndex}async _createExtensionPathIndex($){const ne=p.TernarySearchTree.forUris(be=>T.extUriBiasedIgnorePathCase.ignorePathCasing(be));return await Promise.all($.map(async be=>{if(this._getEntryPoint(be)){const Ce=await this._realPathExtensionUri(be.extensionLocation);ne.set(Ce,be)}})),ne}_deactivate($){let ne=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated($))return ne;const be=this._activator.getActivatedExtension($);if(!be)return ne;try{typeof be.module.deactivate=="function"&&(ne=Promise.resolve(be.module.deactivate()).then(void 0,Ce=>(this._logService.error(Ce),Promise.resolve(void 0))))}catch(Ce){this._logService.error(`An error occurred when deactivating the extension '${$.value}':`),this._logService.error(Ce)}try{(0,b.dispose)(be.subscriptions)}catch(Ce){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${$.value}':`),this._logService.error(Ce)}return ne}async _activateExtension($,ne){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension($.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension($.identifier),this._doActivateExtension($,ne).then(be=>{const Ce=be.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension($.identifier,Ce.codeLoadingTime,Ce.activateCallTime,Ce.activateResolvedTime,ne),this._logExtensionActivationTimes($,ne,"success",Ce),be},be=>{throw this._logExtensionActivationTimes($,ne,"failure"),be})}_logExtensionActivationTimes($,ne,be,Ce){const ae=G($,ne);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ae,...Ce||{},outcome:be})}_doActivateExtension($,ne){const be=G($,ne);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",be);const Ce=this._getEntryPoint($);if(!Ce)return Promise.resolve(new C.EmptyExtension(C.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${$.identifier.value}, startup: ${ne.startup}, activationEvent: '${ne.activationEvent}'${$.identifier.value!==ne.extensionId.value?`, root cause: ${ne.extensionId.value}`:""}`),this._logService.flush();const ae=new C.ExtensionActivationTimesBuilder(ne.startup);return Promise.all([this._loadCommonJSModule($,(0,T.joinPath)($.extensionLocation,Ce),ae),this._loadExtensionContext($)]).then(ce=>(L.mark(`code/extHost/willActivateExtension/${$.identifier.value}`),W._callActivate(this._logService,$.identifier,ce[0],ce[1],ae))).then(ce=>(L.mark(`code/extHost/didActivateExtension/${$.identifier.value}`),ce))}_loadExtensionContext($){const ne=this._extHostLanguageModels.createLanguageModelAccessInformation($),be=new s.ExtensionGlobalMemento($,this._storage),Ce=new s.ExtensionMemento($.identifier.value,!1,this._storage),ae=new z.ExtensionSecrets($,this._secretState),ce=$.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,se=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${$.identifier.value}`),Promise.all([be.whenReady,Ce.whenReady,this._storagePath.whenReady]).then(()=>{const j=this;let ie,ue;const he=(0,m.isProposedApiEnabled)($,"ipc")?this._initData.messagePorts?.get(i.ExtensionIdentifier.toKey($.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Ce,secrets:ae,subscriptions:[],get languageModelAccessInformation(){return ne},get extensionUri(){return $.extensionLocation},get extensionPath(){return $.extensionLocation.fsPath},asAbsolutePath(Te){return O.join($.extensionLocation.fsPath,Te)},get storagePath(){return j._storagePath.workspaceValue($)?.fsPath},get globalStoragePath(){return j._storagePath.globalValue($).fsPath},get logPath(){return O.join(j._initData.logsLocation.fsPath,$.identifier.value)},get logUri(){return w.URI.joinPath(j._initData.logsLocation,$.identifier.value)},get storageUri(){return j._storagePath.workspaceValue($)},get globalStorageUri(){return j._storagePath.globalValue($)},get extensionMode(){return ce},get extension(){return ie===void 0&&(ie=new re(j,$.identifier,$,se,!1)),ie},get extensionRuntime(){return(0,m.checkProposedApiEnabled)($,"extensionRuntime"),j.extensionRuntime},get environmentVariableCollection(){return j._extHostTerminalService.getEnvironmentVariableCollection($)},get messagePassingProtocol(){if(!ue){if(!he)return;const Te=y.Event.buffer(y.Event.fromDOMEventEmitter(he,"message",me=>me.data));he.start(),ue={onDidReceiveMessage:Te,postMessage:he.postMessage.bind(he)}}return ue}})})}static _callActivate($,ne,be,Ce,ae){return be=be||{activate:void 0,deactivate:void 0},this._callActivateOptional($,ne,be,Ce,ae).then(ce=>new C.ActivatedExtension(!1,null,ae.build(),be,ce,Ce.subscriptions))}static _callActivateOptional($,ne,be,Ce,ae){if(typeof be.activate=="function")try{ae.activateCallStart(),$.trace(`ExtensionService#_callActivateOptional ${ne.value}`);const ce=typeof global=="object"?global:self,se=be.activate.apply(ce,[Ce]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve(se).then(j=>(ae.activateResolveStop(),j))}catch(ce){return Promise.reject(ce)}else return Promise.resolve(be)}_activateOneStartupFinished($,ne){this._activateById($.identifier,{startup:!1,extensionId:$.identifier,activationEvent:ne}).then(void 0,be=>{this._logService.error(be)})}_activateAllStartupFinishedDeferred($,ne=0){const Ce=Date.now();(0,M.setTimeout0)(()=>{for(let ae=ne;ae<$.length;ae+=1){const ce=$[ae];for(const se of ce.activationEvents??[])if(se==="onStartupFinished")if(Date.now()-Ce>50){this._activateAllStartupFinishedDeferred($,ae);break}else this._activateOneStartupFinished(ce,se)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(L.getMarks()),this._extHostConfiguration.getConfigProvider().then($=>{const ne=$.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this._myRegistry.getAllExtensionDescriptions();if(ne)this._activateAllStartupFinishedDeferred(be);else for(const Ce of be)if(Ce.activationEvents)for(const ae of Ce.activationEvents)ae==="onStartupFinished"&&this._activateOneStartupFinished(Ce,ae)})}_handleEagerExtensions(){const $=this._activateByEvent("*",!0).then(void 0,ce=>{this._logService.error(ce)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ce=>this._handleWorkspaceContainsEagerExtensions(ce.added)));const ne=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],be=this._handleWorkspaceContainsEagerExtensions(ne),Ce=this._handleRemoteResolverEagerExtensions(),ae=Promise.all([Ce,$,be]).then(()=>{});return Promise.race([ae,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ae}_handleWorkspaceContainsEagerExtensions($){return $.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(ne=>this._handleWorkspaceContainsEagerExtension($,ne))).then(()=>{})}async _handleWorkspaceContainsEagerExtension($,ne){if(this.isActivated(ne.identifier))return;const be=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Ce={logService:this._logService,folders:$.map(ce=>ce.uri),forceUsingSearch:be||!this._hostUtils.fsExists,exists:ce=>this._hostUtils.fsExists(ce.fsPath),checkExists:(ce,se,j)=>this._mainThreadWorkspaceProxy.$checkExists(ce,se,j)},ae=await(0,P.checkActivateWorkspaceContainsExtension)(Ce,ne);if(ae)return this._activateById(ne.identifier,{startup:!0,extensionId:ne.identifier,activationEvent:ae.activationEvent}).then(void 0,ce=>this._logService.error(ce))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch($){throw console.error($),$}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:$,extensionTestsLocationURI:ne}=this._initData.environment;if(!$||!ne)throw new Error(c.localize(0,null));const be=await this._loadCommonJSModule(null,ne,new C.ExtensionActivationTimesBuilder(!1));if(!be||typeof be.run!="function")throw new Error(c.localize(1,null,ne.toString()));return new Promise((Ce,ae)=>{const ce=(ie,ue)=>{ie?(M.isCI&&this._logService.error("Test runner called back with error",ie),ae(ie)):(M.isCI&&(ue?this._logService.info(`Test runner called back with ${ue} failures.`):this._logService.info("Test runner called back with successful outcome.")),Ce(typeof ue=="number"&&ue>0?1:0))},se=(0,T.originalFSPath)(ne),j=be.run(se,ce);j&&j.then&&j.then(()=>{M.isCI&&this._logService.info("Test runner finished successfully."),Ce(0)}).catch(ie=>{M.isCI&&this._logService.error("Test runner finished with error",ie),ae(ie instanceof Error&&ie.stack?ie.stack:String(ie))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,R.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver($,ne){return this._resolvers[$]=ne,(0,b.toDisposable)(()=>{delete this._resolvers[$]})}async getRemoteExecServer($){const{resolver:ne}=await this._activateAndGetResolver($);return ne?.resolveExecServer?.($,{resolveAttempt:0})}async _activateAndGetResolver($){const ne=$.indexOf("+");if(ne===-1)throw new t.RemoteAuthorityResolverError("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=$.substr(0,ne);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this._resolvers[be]}}async $resolveAuthority($,ne){const be=N.StopWatch.create(!1),Ce=()=>`[resolveAuthority(${(0,f.getRemoteAuthorityPrefix)($)},${ne})][${be.elapsed()}ms] `,ae=U=>this._logService.info(`${Ce()}${U}`),ce=U=>this._logService.warn(`${Ce()}${U}`),se=(U,X=void 0)=>this._logService.error(`${Ce()}${U}`,X),j=U=>{if(U instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:U._code,message:U._message,detail:U._detail}};throw U},ie=async U=>{ae(`activating resolver for ${U}...`);const{resolver:X,authorityPrefix:K}=await this._activateAndGetResolver(U);if(!X)throw se(`no resolver for ${K}`),new t.RemoteAuthorityResolverError(`No remote extension installed to resolve ${K}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:X,authorityPrefix:K,remoteAuthority:U}},ue=$.split(/@|%40/g).reverse();ae(`activating remote resolvers ${ue.join(" -> ")}`);let he;try{he=await Promise.all(ue.map(ie)).catch(async U=>{if(!(U instanceof t.RemoteAuthorityResolverError)||U._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw U;return ce(`resolving nested authorities failed: ${U.message}`),[await ie($)]})}catch(U){return j(U)}const Te=new R.IntervalTimer;Te.cancelAndSet(()=>ae("waiting..."),1e3);let me,Pe;for(const[U,{authorityPrefix:X,resolver:K,remoteAuthority:ge}]of he.entries())try{if(U===he.length-1)ae("invoking final resolve()..."),L.mark(`code/extHost/willResolveAuthority/${X}`),me=await K.resolve(ge,{resolveAttempt:ne,execServer:Pe}),L.mark(`code/extHost/didResolveAuthorityOK/${X}`),ae("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(K,t.ManagedResolvedAuthority.isManagedResolvedAuthority(me)?me:void 0));else{if(ae(`invoking resolveExecServer() for ${ge}`),L.mark(`code/extHost/willResolveExecServer/${X}`),Pe=await K.resolveExecServer?.(ge,{resolveAttempt:ne,execServer:Pe}),!Pe)throw new t.RemoteAuthorityResolverError(`Exec server was not available for ${ge}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);L.mark(`code/extHost/didResolveExecServerOK/${X}`)}}catch(Ee){return L.mark(`code/extHost/didResolveAuthorityError/${X}`),se("returned an error",Ee),Te.dispose(),j(Ee)}Te.dispose();const Ae={environmentTunnels:me.environmentTunnels,features:me.tunnelFeatures?{elevation:me.tunnelFeatures.elevation,privacyOptions:me.tunnelFeatures.privacyOptions,protocol:me.tunnelFeatures.protocol===void 0?!0:me.tunnelFeatures.protocol}:void 0},xe={extensionHostEnv:me.extensionHostEnv,isTrusted:me.isTrusted,authenticationSession:me.authenticationSessionForInitializingExtensions?{id:me.authenticationSessionForInitializingExtensions.id,providerId:me.authenticationSessionForInitializingExtensions.providerId}:void 0};ae(`returned ${t.ManagedResolvedAuthority.isManagedResolvedAuthority(me)?"managed authority":`${me.host}:${me.port}`}`);let H;if(t.ManagedResolvedAuthority.isManagedResolvedAuthority(me)){const U=ne;this._extHostManagedSockets.setFactory(U,me.makeConnection),H={authority:$,connectTo:new f.ManagedRemoteConnection(U),connectionToken:me.connectionToken}}else H={authority:$,connectTo:new f.WebSocketRemoteConnection(me.host,me.port),connectionToken:me.connectionToken};return{type:"ok",value:{authority:H,options:xe,tunnelInformation:Ae}}}async $getCanonicalURI($,ne){this._logService.info(`$getCanonicalURI invoked for authority (${(0,f.getRemoteAuthorityPrefix)($)})`);const{resolver:be}=await this._activateAndGetResolver($);if(!be)return null;const Ce=w.URI.revive(ne);if(typeof be.getCanonicalURI>"u")return Ce;const ae=await(0,R.asPromise)(()=>be.getCanonicalURI(Ce));return ae||Ce}async $startExtensionHost($){$.toAdd.forEach(ce=>ce.extensionLocation=w.URI.revive(ce.extensionLocation));const{globalRegistry:ne,myExtensions:be}=Z(this._activationEventsReader,this._globalRegistry,this._myRegistry,$),Ce=await this._createExtensionPathIndex(be);return(await this.getExtensionPathIndex()).setSearchTree(Ce),this._globalRegistry.set(ne.getAllExtensionDescriptions()),this._myRegistry.set(be),M.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${Q(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${Q(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent($,ne){return ne===1?this._almostReadyToRunExtensions.wait().then(be=>this._activateByEvent($,!1)):this._readyToRunExtensions.wait().then(be=>this._activateByEvent($,!1))}async $activate($,ne){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription($)?(await this._activateById($,ne),!0):!1}async $deltaExtensions($){$.toAdd.forEach(ce=>ce.extensionLocation=w.URI.revive(ce.extensionLocation));const{globalRegistry:ne,myExtensions:be}=Z(this._activationEventsReader,this._globalRegistry,this._myRegistry,$),Ce=await this._createExtensionPathIndex(be);return(await this.getExtensionPathIndex()).setSearchTree(Ce),this._globalRegistry.set(ne.getAllExtensionDescriptions()),this._myRegistry.set(be),M.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${Q(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${Q(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency($){return $}async $test_up($){return $.byteLength}async $test_down($){const ne=r.VSBuffer.alloc($),be=Math.random()%256;for(let Ce=0;Ce<$;Ce++)ne.writeUInt8(be,Ce);return ne}async $updateRemoteConnectionData($){this._remoteConnectionData=$,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=Y,e.AbstractExtHostExtensionService=Y=W=Ge([Ue(0,h.IInstantiationService),Ue(1,e.IHostUtils),Ue(2,d.IExtHostRpcService),Ue(3,a.IExtHostWorkspace),Ue(4,v.IExtHostConfiguration),Ue(5,A.ILogService),Ue(6,l.IExtHostInitDataService),Ue(7,u.IExtensionStoragePaths),Ue(8,D.IExtHostTunnelService),Ue(9,E.IExtHostTerminalService),Ue(10,F.IExtHostLocalizationService),Ue(11,B.IExtHostManagedSockets),Ue(12,_.IExtHostLanguageModels)],Y);function Z(J,$,ne,be){J.addActivationEvents(be.addActivationEvents);const Ce=new o.ExtensionDescriptionRegistry(J,$.getAllExtensionDescriptions());Ce.deltaExtensions(be.toAdd,be.toRemove);const ae=new i.ExtensionIdentifierSet(ne.getAllExtensionDescriptions().map(se=>se.identifier));for(const se of be.myToRemove)ae.delete(se);for(const se of be.myToAdd)ae.add(se);const ce=te(Ce,ae);return{globalRegistry:Ce,myExtensions:ce}}function G(J,$){return{id:J.identifier.value,name:J.name,extensionVersion:J.version,publisherDisplayName:J.publisher,activationEvents:J.activationEvents?J.activationEvents.join(","):null,isBuiltin:J.isBuiltin,reason:$.activationEvent,reasonId:$.extensionId.value}}function Q(J){return J.getAllExtensionDescriptions().map($=>$.identifier.value).join(",")}e.IExtHostExtensionService=(0,h.createDecorator)("IExtHostExtensionService");class re{#e;#t;#i;constructor($,ne,be,Ce,ae){this.#e=$,this.#t=ne,this.#i=be.identifier,this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=O.normalize((0,T.originalFSPath)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=Ce,this.isFromDifferentExtensionHost=ae}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=re;function te(J,$){return J.getAllExtensionDescriptions().filter(ne=>$.has(ne.identifier))}class ve{constructor($){this._searchTree=$}setSearchTree($){this._searchTree=$}findSubstr($){return this._searchTree.findSubstr($)}forEach($){return this._searchTree.forEach($)}}e.ExtensionPaths=ve;class Ie{constructor($){this._map=new i.ExtensionIdentifierMap,this.addActivationEvents($)}readActivationEvents($){return this._map.get($.identifier)??[]}addActivationEvents($){for(const ne of Object.keys($))this._map.set(ne,$[ne])}}}),define(ye[374],_e([1,0,58,2,6,45,26,25,20,28,5,48,12,14]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(r,s,t,f,h,l,u){this._apiFactory=r,this._extensionRegistry=s,this._instaService=t,this._extHostConfiguration=f,this._extHostExtensionService=h,this._initData=l,this._logService=u,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),c.mark("code/extHost/willWaitForConfig");const r=await this._extHostConfiguration.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const s=await this._extHostExtensionService.getExtensionPathIndex();this.register(new o(this._apiFactory,s,this._extensionRegistry,r,this._logService)),this.register(this._instaService.createInstance(m)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(n,s,this._initData.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const s of r.nodeModuleName)this._factories.set(s,r);else this._factories.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this._alternatives.push(s=>r.alternativeModuleName(s))}};e.RequireInterceptor=a,e.RequireInterceptor=a=Ge([Ue(2,A.IInstantiationService),Ue(3,T.IExtHostConfiguration),Ue(4,I.IExtHostExtensionService),Ue(5,w.IExtHostInitDataService),Ue(6,v.ILogService)],a);let m=class{static{S=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&S.aliased.size){const s=(0,C.escapeRegExpCharacters)(this.forceForwardSlashes(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,h="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${s}/${h}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(r){if(!this.re)return;const s=this.re.exec(this.forceForwardSlashes(r));if(!s)return;const[,t,f,h]=s,l=S.aliased.get(f);if(l!==void 0)return console.warn(`${f} as been renamed to ${l}, please update your imports`),t+l+h}forceForwardSlashes(r){return r.replace(/\\/g,"/")}};m=S=Ge([Ue(0,w.IExtHostInitDataService)],m);class o{constructor(r,s,t,f,h){this._apiFactory=r,this._extensionPaths=s,this._extensionRegistry=t,this._configProvider=f,this._logService=h,this.nodeModuleName="vscode",this._extApiImpl=new b.ExtensionIdentifierMap}load(r,s){const t=this._extensionPaths.findSubstr(s);if(t){let f=this._extApiImpl.get(t.identifier);return f||(f=this._apiFactory(t,this._extensionRegistry,this._configProvider),this._extApiImpl.set(t.identifier,f)),f}if(!this._defaultApiImpl){let f="";this._extensionPaths.forEach((h,l)=>f+=`	${l} -> ${h.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${f}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let n=class{constructor(r,s,t){this._extensionPaths=r,this._appUriScheme=s,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=t.getProxy(L.MainContext.MainThreadTelemetry);const f=t.getProxy(L.MainContext.MainThreadWindow);this._impl=(h,l)=>{const u=O.URI.parse(h);return l?this.callOriginal(h,l):u.scheme==="http"||u.scheme==="https"?f.$openUri(u,h,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this._appUriScheme?f.$openUri(u,h,{}):this.callOriginal(h,l)}}load(r,s,t){const f=this._extensionPaths.findSubstr(s);return f&&(this._extensionId=f.identifier.value,this.sendShimmingTelemetry()),this._original=t(r),this._impl}callOriginal(r,s){return this.sendNoForwardTelemetry(),this._original(r,s)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};n=Ge([Ue(2,p.IExtHostRpcService)],n)}),define(ye[60],_e([1,0,46,3,17,50,5,72,71,48,7,44,300,45]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,R.createDecorator)("IExtHostVariableResolverProvider");class S extends v.AbstractVariableResolverService{constructor(o,n,i,r,s,t,f){function h(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const u=r.tabGroups.all.find(d=>d.isActive)?.activeTab;if(u!==void 0){if(u.input instanceof A.TextDiffTabInput||u.input instanceof A.NotebookDiffEditorTabInput)return u.input.modified;if(u.input instanceof A.TextTabInput||u.input instanceof A.NotebookEditorTabInput||u.input instanceof A.CustomEditorTabInput)return u.input.uri}}}super({getFolderUri:l=>{const u=t.folders.filter(d=>d.name===l);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,u)=>s.getConfiguration(void 0,l).get(u),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=h();if(l)return L.normalize(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const l=h();if(l){const u=n.getWorkspaceFolder(l);if(u)return L.normalize(u.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>o.getExtension(l)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(T.env))}}let a=class extends O.Disposable{constructor(o,n,i,r,s){super(),this.extensionService=o,this.workspaceService=n,this.editorService=i,this.configurationService=r,this.editorTabs=s,this._resolver=new c.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),h={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async l=>{h.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new S(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,h,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=a,e.ExtHostVariableResolverProviderService=a=Ge([Ue(0,w.IExtHostExtensionService),Ue(1,I.IExtHostWorkspace),Ue(2,b.IExtHostDocumentsAndEditors),Ue(3,C.IExtHostConfiguration),Ue(4,p.IExtHostEditorTabs)],a)}),define(ye[96],_e([1,0,8,4,2,25,5,6,71,48,20,7,44,143,292,45,60,3,56,33,16]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,R.createDecorator)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession?.api}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(g,D,E,_,y,P,k){this._workspaceService=D,this._extensionService=E,this._configurationService=_,this._editorTabs=y,this._variableResolver=P,this._commands=k,this._debugSessions=new Map,this._debugVisualizationTreeItemIdsCounter=0,this._debugVisualizationProviders=new Map,this._debugVisualizationTrees=new Map,this._debugVisualizationTreeItemIds=new WeakMap,this._debugVisualizationElements=new Map,this._visualizers=new Map,this._visualizerIdCounter=0,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new O.Emitter,this._onDidTerminateDebugSession=new O.Emitter,this._onDidChangeActiveDebugSession=new O.Emitter,this._onDidReceiveDebugSessionCustomEvent=new O.Emitter,this._debugServiceProxy=g.getProxy(b.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new O.Emitter,this._onDidChangeActiveStackItem=new O.Emitter,this._activeDebugConsole=new f(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(z=>{z.onDidChange(x=>{this.registerAllDebugTypes(z)}),this.registerAllDebugTypes(z)})}async $getVisualizerTreeItem(g,D){const E=this.hydrateVisualizationContext(D);if(!E)return;const _=await this._debugVisualizationTrees.get(g)?.getTreeItem?.(E);return _?this.convertVisualizerTreeItem(g,_):void 0}registerDebugVisualizationTree(g,D,E){const _=T.ExtensionIdentifier.toKey(g.identifier),y=this.extensionVisKey(_,D);if(this._debugVisualizationProviders.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this._debugVisualizationTrees.set(y,E),this._debugServiceProxy.$registerDebugVisualizerTree(y,!!E.editItem),(0,o.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizerTree(y),this._debugVisualizationTrees.delete(D)})}async $getVisualizerTreeItemChildren(g,D){const E=this._debugVisualizationElements.get(D)?.item;return E?(await this._debugVisualizationTrees.get(g)?.getChildren?.(E))?.map(y=>this.convertVisualizerTreeItem(g,y))||[]:[]}async $editVisualizerTreeItem(g,D){const E=this._debugVisualizationElements.get(g);if(!E)return;const _=await this._debugVisualizationTrees.get(E.provider)?.editItem?.(E.item,D);return this.convertVisualizerTreeItem(E.provider,_||E.item)}$disposeVisualizedTree(g){const D=this._debugVisualizationElements.get(g);if(!D)return;const E=[D.children];for(const _ of E)if(_)for(const y of _)E.push(this._debugVisualizationElements.get(y)?.children),this._debugVisualizationElements.delete(y)}convertVisualizerTreeItem(g,D){let E=this._debugVisualizationTreeItemIds.get(D);return E||(E=this._debugVisualizationTreeItemIdsCounter++,this._debugVisualizationTreeItemIds.set(D,E),this._debugVisualizationElements.set(E,{provider:g,item:D})),r.DebugTreeItem.from(D,E)}asDebugSourceUri(g,D){const E=g;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let _=`debug:${encodeURIComponent(E.path||"")}`,y="?";return D&&(_+=`${y}session=${encodeURIComponent(D.id)}`,y="&"),_+=`${y}ref=${E.sourceReference}`,L.URI.parse(_)}else{if(E.path)return L.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(g){const D=[];for(const E of g.getAllExtensionDescriptions())if(E.contributes){const _=E.contributes.debuggers;if(_&&_.length>0)for(const y of _)(0,S.isDebuggerMainContribution)(y)&&D.push(y.type)}this._debugServiceProxy.$registerDebugTypes(D)}get activeStackItem(){return this._activeStackItem}get onDidChangeActiveStackItem(){return this._onDidChangeActiveStackItem.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const g=[];return this._breakpoints.forEach(D=>g.push(D)),g}async $resolveDebugVisualizer(g,D){const E=this._visualizers.get(g);if(!E)throw new Error(`No debug visualizer found with id '${g}'`);let{v:_,provider:y,extensionId:P}=E;if(_.visualization||(_=await y.resolveDebugVisualization?.(_,D)||_,E.v=_),!_.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.serializeVisualization(P,_.visualization)}async $executeDebugVisualizerCommand(g){const D=this._visualizers.get(g);if(!D)throw new Error(`No debug visualizer found with id '${g}'`);const E=D.v.visualization;E&&"command"in E&&this._commands.executeCommand(E.command,...E.arguments||[])}hydrateVisualizationContext(g){const D=this._debugSessions.get(g.sessionId);return D&&{session:D.api,variable:g.variable,containerId:g.containerId,frameId:g.frameId,threadId:g.threadId}}async $provideDebugVisualizers(g,D,E,_){const y=this.hydrateVisualizationContext(E),P=this.extensionVisKey(g,D),k=this._debugVisualizationProviders.get(P);if(!y||!k)return[];const z=await k.provideDebugVisualization(y,_);return z?z.map(x=>{const F=++this._visualizerIdCounter;this._visualizers.set(F,{v:x,provider:k,extensionId:g});const N=x.iconPath?this.getIconPathOrClass(x.iconPath):void 0;return{id:F,name:x.name,iconClass:N?.iconClass,iconPath:N?.iconPath,visualization:this.serializeVisualization(g,x.visualization)}}):[]}$disposeDebugVisualizers(g){for(const D of g)this._visualizers.delete(D)}registerDebugVisualizationProvider(g,D,E){if(!g.contributes?.debugVisualizers?.some(P=>P.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const _=T.ExtensionIdentifier.toKey(g.identifier),y=this.extensionVisKey(_,D);if(this._debugVisualizationProviders.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this._debugVisualizationProviders.set(y,E),this._debugServiceProxy.$registerDebugVisualizer(_,D),(0,o.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizer(_,D),this._debugVisualizationProviders.delete(D)})}addBreakpoints(g){const D=g.filter(y=>{const P=y.id;return this._breakpoints.has(P)?!1:(this._breakpoints.set(P,y),!0)});this.fireBreakpointChanges(D,[],[]);const E=[],_=new Map;for(const y of D)if(y instanceof I.SourceBreakpoint){let P=_.get(y.location.uri.toString());P||(P={type:"sourceMulti",uri:y.location.uri,lines:[]},_.set(y.location.uri.toString(),P),E.push(P)),P.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof I.FunctionBreakpoint&&E.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this._debugServiceProxy.$registerBreakpoints(E)}removeBreakpoints(g){const D=g.filter(P=>this._breakpoints.delete(P.id));this.fireBreakpointChanges([],D,[]);const E=D.filter(P=>P instanceof I.SourceBreakpoint).map(P=>P.id),_=D.filter(P=>P instanceof I.FunctionBreakpoint).map(P=>P.id),y=D.filter(P=>P instanceof I.DataBreakpoint).map(P=>P.id);return this._debugServiceProxy.$unregisterBreakpoints(E,_,y)}startDebugging(g,D,E){return this._debugServiceProxy.$startDebugging(g?g.uri:void 0,D,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,suppressSaveBeforeStart:E.suppressSaveBeforeStart,suppressDebugStatusbar:E.suppressDebugStatusbar??E.debugUI?.simple,suppressDebugToolbar:E.suppressDebugToolbar??E.debugUI?.simple,suppressDebugView:E.suppressDebugView??E.debugUI?.simple})}stopDebugging(g){return this._debugServiceProxy.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,D,E){if(!D)return new I.Disposable(()=>{});const _=this._configProviderHandleCounter++;return this._configProviders.push({type:g,handle:_,provider:D}),this._debugServiceProxy.$registerDebugConfigurationProvider(g,E,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,_),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(y=>y.provider!==D),this._debugServiceProxy.$unregisterDebugConfigurationProvider(_)})}registerDebugAdapterDescriptorFactory(g,D,E){if(!E)return new I.Disposable(()=>{});if(!this.definesDebugType(g,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.getAdapterDescriptorFactoryByType(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const _=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:D,handle:_,factory:E}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(D,_),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(y=>y.factory!==E),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(_)})}registerDebugAdapterTrackerFactory(g,D){if(!D)return new I.Disposable(()=>{});const E=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:g,handle:E,factory:D}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(_=>_.factory!==D)})}async $runInTerminal(g,D){return Promise.resolve(void 0)}async $substituteVariables(g,D){let E;const _=await this.getFolder(g);return _&&(E={uri:_.uri,name:_.name,index:_.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(E,D)}createDebugAdapter(g,D){if(g.type==="implementation")return new l(g.implementation)}createSignService(){}async $startDASession(g,D){const E=this,_=await this.getSession(D);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(_.type),_).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}' (extension might have failed to activate)`);const P=this.convertToDto(y),k=this.createDebugAdapter(P,_);if(!k)throw new Error(`Couldn't create a debug adapter for type '${_.type}'.`);const z=k;return this._debugAdapters.set(g,z),this.getDebugAdapterTrackers(_).then(x=>(x&&this._debugAdaptersTrackers.set(g,x),z.onMessage(async F=>{if(F.type==="request"&&F.command==="handshake"){const N=F,M={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const B=await this._signService.sign(N.arguments.value);M.body={signature:B},z.sendResponse(M)}else throw new Error("no signer")}catch(B){M.success=!1,M.message=B.message,z.sendResponse(M)}}else x&&x.onDidSendMessage&&x.onDidSendMessage(F),F=(0,S.convertToVSCPaths)(F,!0),E._debugServiceProxy.$acceptDAMessage(g,F)}),z.onError(F=>{x&&x.onError&&x.onError(F),this._debugServiceProxy.$acceptDAError(g,F.name,F.message,F.stack)}),z.onExit(F=>{x&&x.onExit&&x.onExit(F??void 0,void 0),this._debugServiceProxy.$acceptDAExit(g,F??void 0,void 0)}),x&&x.onWillStartSession&&x.onWillStartSession(),z.startSession()))})}$sendDAMessage(g,D){D=(0,S.convertToDAPaths)(D,!1);const E=this._debugAdaptersTrackers.get(g);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(D),this._debugAdapters.get(g)?.sendMessage(D)}$stopDASession(g){const D=this._debugAdaptersTrackers.get(g);this._debugAdaptersTrackers.delete(g),D&&D.onWillStopSession&&D.onWillStopSession();const E=this._debugAdapters.get(g);return this._debugAdapters.delete(g),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const D=[],E=[],_=[];if(g.added)for(const y of g.added){const P=y.id;if(P&&!this._breakpoints.has(P)){let k;if(y.type==="function")k=new I.FunctionBreakpoint(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")k=new I.DataBreakpoint(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const z=L.URI.revive(y.uri);k=new I.SourceBreakpoint(new I.Location(z,new I.Position(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,I.setBreakpointId)(k,P),this._breakpoints.set(P,k),D.push(k)}}if(g.removed)for(const y of g.removed){const P=this._breakpoints.get(y);P&&(this._breakpoints.delete(y),E.push(P))}if(g.changed){for(const y of g.changed)if(y.id){const P=this._breakpoints.get(y.id);if(P){if(P instanceof I.FunctionBreakpoint&&y.type==="function"){const k=P;k.enabled=y.enabled,k.condition=y.condition,k.hitCondition=y.hitCondition,k.logMessage=y.logMessage,k.functionName=y.functionName}else if(P instanceof I.SourceBreakpoint&&y.type==="source"){const k=P;k.enabled=y.enabled,k.condition=y.condition,k.hitCondition=y.hitCondition,k.logMessage=y.logMessage,k.location=new I.Location(L.URI.revive(y.uri),new I.Position(y.line,y.character))}_.push(P)}}}this.fireBreakpointChanges(D,E,_)}async $acceptStackFrameFocus(g){let D;if(g){const E=await this.getSession(g.sessionId);g.kind==="thread"?D=new I.Thread(E.api,g.threadId):D=new I.StackFrame(E.api,g.threadId,g.frameId)}this._activeStackItem=D,this._onDidChangeActiveStackItem.fire(this._activeStackItem)}$provideDebugConfigurations(g,D,E){return(0,c.asPromise)(async()=>{const _=this.getConfigProviderByHandle(g);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.getFolder(D);return _.provideDebugConfigurations(y,E)}).then(_=>{if(!_)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return _})}$resolveDebugConfiguration(g,D,E,_){return(0,c.asPromise)(async()=>{const y=this.getConfigProviderByHandle(g);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.getFolder(D);return y.resolveDebugConfiguration(P,E,_)})}$resolveDebugConfigurationWithSubstitutedVariables(g,D,E,_){return(0,c.asPromise)(async()=>{const y=this.getConfigProviderByHandle(g);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.getFolder(D);return y.resolveDebugConfigurationWithSubstitutedVariables(P,E,_)})}async $provideDebugAdapter(g,D){const E=this.getAdapterDescriptorFactoryByHandle(g);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const _=await this.getSession(D);return this.getAdapterDescriptor(E,_).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}'`);return this.convertToDto(y)})}async $acceptDebugSessionStarted(g){const D=await this.getSession(g);this._onDidStartDebugSession.fire(D.api)}async $acceptDebugSessionTerminated(g){const D=await this.getSession(g);D&&(this._onDidTerminateDebugSession.fire(D.api),this._debugSessions.delete(D.id))}async $acceptDebugSessionActiveChanged(g){this._activeDebugSession=g?await this.getSession(g):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession?.api)}async $acceptDebugSessionNameChanged(g,D){(await this.getSession(g))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(g,D){const _={session:(await this.getSession(g)).api,event:D.event,body:D.body};this._onDidReceiveDebugSessionCustomEvent.fire(_)}convertToDto(g){if(g instanceof I.DebugAdapterExecutable)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof I.DebugAdapterServer)return{type:"server",port:g.port,host:g.host};if(g instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:g.path};if(g instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(g){const D=this._adapterFactories.filter(E=>E.type===g);if(D.length>0)return D[0].factory}getAdapterDescriptorFactoryByHandle(g){const D=this._adapterFactories.filter(E=>E.handle===g);if(D.length>0)return D[0].factory}getConfigProviderByHandle(g){const D=this._configProviders.filter(E=>E.handle===g);if(D.length>0)return D[0].provider}definesDebugType(g,D){if(g.contributes){const E=g.contributes.debuggers;if(E&&E.length>0){for(const _ of E)if(_.label&&_.type&&_.type===D)return!0}}return!1}getDebugAdapterTrackers(g){const E=g.configuration.type,_=this._trackerFactories.filter(y=>y.type===E||y.type==="*").map(y=>(0,c.asPromise)(()=>y.factory.createDebugAdapterTracker(g.api)).then(P=>P,P=>null));return Promise.race([Promise.all(_).then(y=>{const P=y.filter(k=>!!k);if(P.length>0)return new h(P)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async getAdapterDescriptor(g,D){const E=D.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new I.DebugAdapterServer(E));if(g){const y=await this._extensionService.getExtensionRegistry();return(0,c.asPromise)(()=>g.createDebugAdapterDescriptor(D.api,this.daExecutableFromPackage(D,y))).then(P=>{if(P)return P})}const _=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(D,_))}daExecutableFromPackage(g,D){}fireBreakpointChanges(g,D,E){(g.length>0||D.length>0||E.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:g,removed:D,changed:E}))}async getSession(g){if(g)if(typeof g=="string"){const D=this._debugSessions.get(g);if(D)return D}else{let D=this._debugSessions.get(g.id);if(!D){const E=await this.getFolder(g.folderUri),_=g.parent?this._debugSessions.get(g.parent):void 0;D=new t(this._debugServiceProxy,g.id,g.type,g.name,E,g.configuration,_?.api),this._debugSessions.set(D.id,D),this._debugServiceProxy.$sessionCached(D.id)}return D}throw new Error("cannot find session")}getFolder(g){if(g){const D=L.URI.revive(g);return this._workspaceService.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}extensionVisKey(g,D){return`${g}\0${D}`}serializeVisualization(g,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${g}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}getIconPathOrClass(g){const D=this.getIconUris(g);let E,_;return"id"in D?_=n.ThemeIcon.asClassName(D):E=D,{iconPath:E,iconClass:_}}getIconUris(g){if(g instanceof I.ThemeIcon)return{id:g.id};const D=typeof g=="object"&&"dark"in g?g.dark:g,E=typeof g=="object"&&"light"in g?g.light:g;return{dark:typeof D=="string"?L.URI.file(D):D,light:typeof E=="string"?L.URI.file(E):E}}};e.ExtHostDebugServiceBase=s,e.ExtHostDebugServiceBase=s=Ge([Ue(0,A.IExtHostRpcService),Ue(1,v.IExtHostWorkspace),Ue(2,w.IExtHostExtensionService),Ue(3,a.IExtHostConfiguration),Ue(4,p.IExtHostEditorTabs),Ue(5,m.IExtHostVariableResolverProvider),Ue(6,i.IExtHostCommands)],s);class t{constructor(g,D,E,_,y,P,k){this._debugServiceProxy=g,this._id=D,this._type=E,this._name=_,this._workspaceFolder=y,this._configuration=P,this._parentSession=k}get api(){const g=this;return this.apiSession??=Object.freeze({id:g._id,type:g._type,get name(){return g._name},set name(D){g._name=D,g._debugServiceProxy.$setDebugSessionName(g._id,D)},parentSession:g._parentSession,workspaceFolder:g._workspaceFolder,configuration:g._configuration,customRequest(D,E){return g._debugServiceProxy.$customDebugAdapterRequest(g._id,D,E)},getDebugProtocolBreakpoint(D){return g._debugServiceProxy.$getDebugProtocolBreakpoint(g._id,D.id)}})}get id(){return this._id}get type(){return this._type}_acceptNameChanged(g){this._name=g}get configuration(){return this._configuration}}e.ExtHostDebugSession=t;class f{constructor(g){this.value=Object.freeze({append(D){g.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.ExtHostDebugConsole=f;class h{constructor(g){this.trackers=g}onWillStartSession(){this.trackers.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.trackers.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.trackers.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(g):void 0)}onWillStopSession(){this.trackers.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.trackers.forEach(D=>D.onError?D.onError(g):void 0)}onExit(g,D){this.trackers.forEach(E=>E.onExit?E.onExit(g,D):void 0)}}class l extends C.AbstractDebugAdapter{constructor(g){super(),this.implementation=g,g.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.implementation.handleMessage(g)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends s{constructor(g,D,E,_,y,P,k){super(g,D,E,_,y,P,k)}};e.WorkerExtHostDebugService=u,e.WorkerExtHostDebugService=u=Ge([Ue(0,A.IExtHostRpcService),Ue(1,v.IExtHostWorkspace),Ue(2,w.IExtHostExtensionService),Ue(3,a.IExtHostConfiguration),Ue(4,p.IExtHostEditorTabs),Ue(5,m.IExtHostVariableResolverProvider),Ue(6,i.IExtHostCommands)],u)}),define(ye[375],_e([1,0,13,58,2,6,321,12,84,107,28,257,20,66,48,90]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class m{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(b.ILogService),t=i.get(v.IExtHostRpcService).getProxy(T.MainContext.MainThreadErrors);c.setUnexpectedErrorHandler(f=>{r.error(f);const h=c.transformErrorForSerialization(f);t.$onUnexpectedError(h)})}static async installFullHandler(i){const r=i.get(b.ILogService),s=i.get(v.IExtHostRpcService),t=i.get(S.IExtHostExtensionService),f=i.get(a.IExtHostTelemetry),h=s.getProxy(T.MainContext.MainThreadExtensionService),l=s.getProxy(T.MainContext.MainThreadErrors),u=await t.getExtensionPathIndex(),d=new WeakMap;function g(_,y){if(d.has(_))return d.get(_).stack;let P="",k,z;for(const F of y)P+=`
	at ${F.toString()}`,z=F.getFileName(),!k&&z&&(k=u.findSubstr(L.URI.file(z)));const x=`${_.name||"Error"}: ${_.message||""}${P}`;return d.set(_,{extensionIdentifier:k?.identifier,stack:x}),x}const D=Symbol("prepareStackTrace wrapped");let E=g;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return E},set(_){if(_===g||!_||_[D]){E=_||g;return}E=function(y,P){return g(y,P),_.call(Error,y,P)},Object.assign(E,{[D]:!0})}}),c.setUnexpectedErrorHandler(_=>{r.error(_);const y=c.transformErrorForSerialization(_),P=d.get(_);if(!P?.extensionIdentifier){l.$onUnexpectedError(y);return}h.$onExtensionRuntimeError(P.extensionIdentifier,y);const k=f.onExtensionError(P.extensionIdentifier,_);r.trace("forwarded error to extension?",k,P)})}}e.ErrorHandler=m;class o{constructor(i,r,s,t,f){this._hostUtils=s,this._rpcProtocol=new R.RPCProtocol(i,null,t),r=o._transform(r,this._rpcProtocol);const h=new w.ServiceCollection(...(0,p.getSingletonServiceDescriptors)());h.set(A.IExtHostInitDataService,{_serviceBrand:void 0,...r,messagePorts:f}),h.set(v.IExtHostRpcService,new v.ExtHostRpcService(this._rpcProtocol)),h.set(C.IURITransformerService,new C.URITransformerService(t)),h.set(S.IHostUtils,s);const l=new I.InstantiationService(h,!0);l.invokeFunction(m.installEarlyHandler),this._logService=l.invokeFunction(u=>u.get(b.ILogService)),O.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",r),this._extensionService=l.invokeFunction(u=>u.get(S.IExtHostExtensionService)),this._extensionService.initialize(),l.invokeFunction(m.installFullHandler)}async asBrowserUri(i){const r=this._rpcProtocol.getProxy(T.MainContext.MainThreadExtensionService);return L.URI.revive(await r.$asBrowserUri(i))}terminate(i){this._extensionService.terminate(i)}static _transform(i,r){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=L.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=L.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const s=i.environment.extensionDevelopmentLocationURI;return s&&(i.environment.extensionDevelopmentLocationURI=s.map(t=>L.URI.revive(r.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=L.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=L.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=L.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=L.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=L.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=L.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.ExtensionHostMain=o}),define(ye[376],_e([1,0,8,11,231,250,141,96,71,48,20,43,7,60,44,293,294,45,33]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let i=class extends b.ExtHostDebugServiceBase{constructor(h,l,u,d,g,D,E,_){super(h,l,u,d,D,E,_),this._terminalService=g,this._integratedTerminalInstances=new t}createDebugAdapter(h,l){switch(h.type){case"server":return new a.SocketDebugAdapter(h);case"pipeServer":return new a.NamedPipeDebugAdapter(h);case"executable":return new a.ExecutableDebugAdapter(h,l.type)}return super.createDebugAdapter(h,l)}daExecutableFromPackage(h,l){const u=a.ExecutableDebugAdapter.platformAdapterExecutable(l.getAllExtensionDescriptions(),h.type);if(u)return new v.DebugAdapterExecutable(u.command,u.args,u.options)}createSignService(){return new R.SignService}async $runInTerminal(h,l){if(h.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(F=>{this._integratedTerminalInstances.onTerminalClosed(F)}));const u=await this._configurationService.getConfigProvider(),d=this._terminalService.getDefaultShell(!0),g=this._terminalService.getDefaultShellArgs(!0),D=h.title||L.localize(0,null),E=JSON.stringify({shell:d,shellArgs:g});let _=await this._integratedTerminalInstances.checkout(E,D),y,P=!1;if(_)y=h.cwd;else{const F={shellPath:d,shellArgs:g,cwd:h.cwd,name:D,iconPath:new v.ThemeIcon("debug")};P=!0,_=this._terminalService.createTerminalFromOptions(F,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(_,E)}_.show(!0);const k=await _.processId;P?await new Promise(F=>setTimeout(F,1e3)):(_.state.isInteractedWith&&_.sendText(""),u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(d.indexOf("powershell")>=0||d.indexOf("pwsh")>=0||d.indexOf("cmd.exe")>=0?_.sendText("cls"):d.indexOf("bash")>=0?_.sendText("clear"):O.isWindows?_.sendText("cls"):_.sendText("clear")));const z=(0,m.prepareCommand)(d,h.args,!!h.argsCanBeInterpretedByShell,y,h.env);_.sendText(z);const x=this.onDidTerminateDebugSession(F=>{F.id===l&&(this._integratedTerminalInstances.free(_),x.dispose())});return k}else if(h.kind==="external")return s(h,await this._configurationService.getConfigProvider());return super.$runInTerminal(h,l)}};e.ExtHostDebugService=i,e.ExtHostDebugService=i=Ge([Ue(0,A.IExtHostRpcService),Ue(1,S.IExtHostWorkspace),Ue(2,w.IExtHostExtensionService),Ue(3,o.IExtHostConfiguration),Ue(4,I.IExtHostTerminalService),Ue(5,p.IExtHostEditorTabs),Ue(6,C.IExtHostVariableResolverProvider),Ue(7,n.IExtHostCommands)],i);let r;function s(f,h){if(!r)if(O.isWindows)r=new T.WindowsExternalTerminalService;else if(O.isMacintosh)r=new T.MacExternalTerminalService;else if(O.isLinux)r=new T.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const l=h.getConfiguration("terminal");return r.runInTerminal(f.title,f.cwd,f.args,f.env||{},l.external||{})}class t{constructor(){this._terminalInstances=new Map}static{this.minUseDelay=1e3}async checkout(h,l,u=!1){const g=[...this._terminalInstances.entries()].map(([D,E])=>(0,c.createCancelablePromise)(async _=>{if(D.name!==l||E.lastUsedAt!==-1&&await(0,m.hasChildProcesses)(await D.processId))return null;const y=Date.now();return E.lastUsedAt+t.minUseDelay>y||_.isCancellationRequested?null:E.config!==h?(u&&D.dispose(),null):(E.lastUsedAt=y,D)}));return await(0,c.firstParallel)(g,D=>!!D)}insert(h,l){this._terminalInstances.set(h,{lastUsedAt:Date.now(),config:l})}free(h){const l=this._terminalInstances.get(h);l&&(l.lastUsedAt=-1)}onTerminalClosed(h){this._terminalInstances.delete(h)}}}),define(ye[377],_e([1,0,17,2,105,44,72,45,42,43,20,28,95,15,12,91,23,63,60]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let i=class extends v.ExtHostTaskBase{constructor(s,t,f,h,l,u,d,g,D){super(s,t,f,h,l,u,d,g),this.workspaceService=f,this.variableResolver=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(C.Schemas.vscodeRemote,{scheme:C.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(C.Schemas.file,{scheme:C.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,t){const f=t;if(!t.execution&&f._id===void 0)throw new Error("Tasks to execute must include an execution");if(f._id!==void 0){const h=v.TaskHandleDTO.from(f,this.workspaceService),l=await this._proxy.$getTaskExecution(h);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const u=await this.getTaskExecution(l,t);return this._proxy.$executeTask(h).catch(()=>{}),u}else{const h=v.TaskDTO.from(t,s);if(h===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(h.execution)&&await this.addCustomExecution(h,t,!1);const l=await this.getTaskExecution(await this._proxy.$getTaskExecution(h),t);return this._proxy.$executeTask(h).catch(()=>{}),l}}provideTasksInternal(s,t,f,h){const l=[];if(h)for(const u of h){this.checkDeprecation(u,f),(!u.definition||!s[u.definition.type])&&this._logService.warn(`The task [${u.source}, ${u.name}] uses an undefined task type. The task will be ignored in the future.`);const d=v.TaskDTO.from(u,f.extension);d&&(l.push(d),v.CustomExecutionDTO.is(d.execution)&&t.push(this.addCustomExecution(d,u,!0)))}return{tasks:l,extension:f.extension}}async resolveTaskInternal(s){return s}async getAFolder(s){let t=s&&s.length>0?s[0]:void 0;if(!t){const f=O.URI.file((0,o.homedir)());t=new p.WorkspaceFolder({uri:f,name:m.basename(f),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,t){const f=O.URI.revive(s),h={process:void 0,variables:Object.create(null)},l=await this._workspaceProvider.resolveWorkspaceFolder(f),u=await this._workspaceProvider.getWorkspaceFolders2()??[],d=await this.variableResolver.getResolver(),g=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(u);for(const D of t.variables)h.variables[D]=await d.resolveAsync(g,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(c.delimiter);for(let E=0;E<D.length;E++)D[E]=await d.resolveAsync(g,D[E])}h.process=await L.win32.findExecutable(await d.resolveAsync(g,t.process.name),t.process.cwd!==void 0?await d.resolveAsync(g,t.process.cwd):void 0,D)}return h}async $jsonTasksSupported(){return!0}async $findExecutable(s,t,f){return L.win32.findExecutable(s,t,f)}};e.ExtHostTask=i,e.ExtHostTask=i=Ge([Ue(0,A.IExtHostRpcService),Ue(1,I.IExtHostInitDataService),Ue(2,T.IExtHostWorkspace),Ue(3,R.IExtHostDocumentsAndEditors),Ue(4,b.IExtHostConfiguration),Ue(5,w.IExtHostTerminalService),Ue(6,S.ILogService),Ue(7,a.IExtHostApiDeprecationService),Ue(8,n.IExtHostVariableResolverProvider)],i)}),define(ye[378],_e([1,0,63,60]),function(de,e,c,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class L extends O.ExtHostVariableResolverProviderService{homeDir(){return(0,c.homedir)()}}e.NodeExtHostVariableResolverProviderService=L}),define(ye[159],_e([1,0,19,8,22,47,15,17,23,2,36]),function(de,e,c,O,L,T,R,b,p,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.TextSearchResultsCollector=e.TextSearchManager=void 0,e.extensionResultIsMatch=a;class I{constructor(n,i,r){this.queryProviderPair=n,this.fileUtils=i,this.processType=r,this.collector=null,this.isLimitHit=!1,this.resultCount=0}get query(){return this.queryProviderPair.query}search(n,i){const r=this.query.folderQueries||[],s=new L.CancellationTokenSource(i);return new Promise((t,f)=>{this.collector=new C(n);let h=!1;const l=(u,d)=>{if(!h&&!this.isLimitHit){const g=this.resultSize(u);a(u)&&typeof this.query.maxResults=="number"&&this.resultCount+g>this.query.maxResults&&(this.isLimitHit=!0,h=!0,s.cancel(),u=this.trimResultToSize(u,this.query.maxResults-this.resultCount));const D=this.resultSize(u);this.resultCount+=D,(D>0||!a(u))&&this.collector.add(u,d)}};Promise.all(r.map((u,d)=>this.searchInFolder(u,g=>l(g,d),s.token))).then(u=>{s.dispose(),this.collector.flush();const d=u.some(g=>!!g&&!!g.limitHit);t({limitHit:this.isLimitHit||d,messages:(0,c.flatten)(u.map(g=>g?.message?Array.isArray(g.message)?g.message:[g.message]:[])),stats:{type:this.processType}})},u=>{s.dispose();const d=(0,T.toErrorMessage)(u);f(new Error(d))})})}resultSize(n){return a(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}trimResultToSize(n,i){const r=Array.isArray(n.ranges)?n.ranges:[n.ranges],s=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:r.slice(0,i),preview:{matches:s.slice(0,i),text:n.preview.text},uri:n.uri}}async searchInFolder(n,i,r){const s=new A.QueryGlobTester(this.query,n),t=[],f={report:u=>{if(!this.validateProviderResult(u))return;const d=n.folder.scheme===R.Schemas.file?(0,A.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(p.dirname(u.uri))):void 0,g=p.relativePath(n.folder,u.uri);if(g){const D=s.includedInQuery(g,b.basename(g),d);(0,O.isThenable)(D)?t.push(D.then(E=>{E&&i(u)})):D&&i(u)}}},h=this.getSearchOptionsForFolder(n);let l;return this.queryProviderPair.query.type===3?l=await this.queryProviderPair.provider.provideAITextSearchResults(this.queryProviderPair.query.contentPattern,h,f,r):l=await this.queryProviderPair.provider.provideTextSearchResults(v(this.queryProviderPair.query.contentPattern),h,f,r),t.length&&await Promise.all(t),l}validateProviderResult(n){if(a(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(n){const i=(0,A.resolvePatternsForProvider)(this.query.includePattern,n.includePattern),r=(0,A.resolvePatternsForProvider)(this.query.excludePattern,n.excludePattern),s={folder:w.URI.from(n.folder),excludes:r,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.fileUtils.toCanonicalName(n.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return"usePCRE2"in this.query&&(s.usePCRE2=this.query.usePCRE2),s}}e.TextSearchManager=I;function v(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class C{constructor(n){this._onResult=n,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new m(512,i=>this.sendItems(i))}add(n,i){this._currentFileMatch&&(this._currentFolderIdx!==i||!p.isEqual(this._currentUri,n.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=i,this._currentFileMatch={resource:n.uri,results:[]}),this._currentFileMatch.results.push(S(n))}pushToCollector(){const n=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,n)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(n){this._onResult(n)}}e.TextSearchResultsCollector=C;function S(o){return a(o)?{preview:{matches:(0,c.mapArrayOrNot)(o.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:o.preview.text},ranges:(0,c.mapArrayOrNot)(o.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function a(o){return!!o.preview}class m{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(n,i){this.maxBatchSize=n,this.cb=i,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(n,i){n&&this.addItemToBatch(n,i)}addItems(n,i){n&&this.addItemsToBatch(n,i)}addItemToBatch(n,i){this.batch.push(n),this.batchSize+=i,this.onUpdate()}addItemsToBatch(n,i){this.batch=this.batch.concat(n),this.batchSize+=i,this.onUpdate()}onUpdate(){this.totalNumberCompleted<m.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},m.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=m}),define(ye[97],_e([1,0,3,6,5,371,20,66,12,2,159]),function(de,e,c,O,L,T,R,b,p,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSearch=e.IExtHostSearch=void 0,e.reviveQuery=v,e.IExtHostSearch=(0,L.createDecorator)("IExtHostSearch");let I=class{constructor(a,m,o){this.extHostRpc=a,this._uriTransformer=m,this._logService=o,this._proxy=this.extHostRpc.getProxy(O.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._aiTextSearchProvider=new Map,this._aiTextSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,m){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const o=this._handlePool++;return this._textSearchProvider.set(o,m),this._proxy.$registerTextSearchProvider(o,this._transformScheme(a)),(0,c.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}registerAITextSearchProvider(a,m){if(this._aiTextSearchUsedSchemes.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this._aiTextSearchUsedSchemes.add(a);const o=this._handlePool++;return this._aiTextSearchProvider.set(o,m),this._proxy.$registerAITextSearchProvider(o,this._transformScheme(a)),(0,c.toDisposable)(()=>{this._aiTextSearchUsedSchemes.delete(a),this._aiTextSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}registerFileSearchProvider(a,m){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const o=this._handlePool++;return this._fileSearchProvider.set(o,m),this._proxy.$registerFileSearchProvider(o,this._transformScheme(a)),(0,c.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(a,m,o,n){const i=v(o),r=this._fileSearchProvider.get(a);if(r)return this._fileSearchManager.fileSearch(i,r,s=>{this._proxy.$handleFileMatch(a,m,s.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,m,o){return{messages:[]}}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,m,o,n){const i=this._textSearchProvider.get(a);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${a}`);const r=v(o);return this.createTextSearchManager(r,i).search(t=>this._proxy.$handleTextMatch(a,m,t),n)}$provideAITextSearchResults(a,m,o,n){const i=this._aiTextSearchProvider.get(a);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${a}`);const r=v(o);return this.createAITextSearchManager(r,i).search(t=>this._proxy.$handleTextMatch(a,m,t),n)}$enableExtensionHostSearch(){}createTextSearchManager(a,m){return new A.TextSearchManager({query:a,provider:m},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}createAITextSearchManager(a,m){return new A.TextSearchManager({query:a,provider:m},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.ExtHostSearch=I,e.ExtHostSearch=I=Ge([Ue(0,R.IExtHostRpcService),Ue(1,b.IURITransformerService),Ue(2,p.ILogService)],I);function v(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(C),extraFileResources:S.extraFileResources&&S.extraFileResources.map(a=>w.URI.revive(a))}}function C(S){return{...S,folder:w.URI.revive(S.folder)}}}),define(ye[379],_e([1,0,22,13,4,3,15,40,2,135,198,179,79,25,32,12,86,87,276,6,323,350,91,120,328,309,329,121,330,310,298,33,331,45,332,96,151,333,312,324,334,335,72,71,325,48,336,69,337,59,28,351,352,326,313,338,339,115,116,314,370,341,282,342,353,343,157,315,344,345,346,20,347,97,117,348,316,349,118,93,95,90,43,354,355,327,356,357,70,16,7,317,66,318,92,358,359,150,44,291,114,26,94,155]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n,i,r,s,t,f,h,l,u,d,g,D,E,_,y,P,k,z,x,F,N,M,B,W,Y,Z,G,Q,re,te,ve,Ie,J,$,ne,be,Ce,ae,ce,se,j,ie,ue,he,Te,me,Pe,Ae,xe,H,U,X,K,ge,Ee,ze,He,Ye,it,rt,at,st,De,Be,qe,Le,Qe,oe,le,ke,je,Ze,Me,lt,bt,Tt,Nt,Xt,ei,It,Qt,Vt,ci,tt,ti,ii){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=qt;function qt(ht){const Et=ht.get(J.IExtHostInitDataService),ai=ht.get(Ie.IExtHostFileSystemInfo),jt=ht.get(te.IExtHostConsumerFileSystem),Ut=ht.get(Q.IExtHostExtensionService),gt=ht.get(Qt.IExtHostWorkspace),Pt=ht.get(Be.IExtHostTelemetry),li=ht.get(P.IExtHostConfiguration),Yt=ht.get(bt.IURITransformerService),Ke=ht.get(ge.IExtHostRpcService),Mt=ht.get(at.IExtHostStorage),Ht=ht.get(st.IExtensionStoragePaths),ni=ht.get(a.ILoggerService),pt=ht.get(a.ILogService),Ot=ht.get(je.IExtHostTunnelService),At=ht.get(t.IExtHostApiDeprecationService),Ft=ht.get(It.IExtHostWindow),ui=ht.get(He.IExtHostSecretState),xt=ht.get(Z.IExtHostEditorTabs),zt=ht.get(j.IExtHostManagedSockets),Ct=ht.get(f.IExtHostAuthentication),Lt=ht.get(d.IExtHostLanguageModels);Ke.set(i.ExtHostContext.ExtHostFileSystemInfo,ai),Ke.set(i.ExtHostContext.ExtHostLogLevelServiceShape,ni),Ke.set(i.ExtHostContext.ExtHostWorkspace,gt),Ke.set(i.ExtHostContext.ExtHostConfiguration,li),Ke.set(i.ExtHostContext.ExtHostExtensionService,Ut),Ke.set(i.ExtHostContext.ExtHostStorage,Mt),Ke.set(i.ExtHostContext.ExtHostTunnelService,Ot),Ke.set(i.ExtHostContext.ExtHostWindow,Ft),Ke.set(i.ExtHostContext.ExtHostSecretState,ui),Ke.set(i.ExtHostContext.ExtHostTelemetry,Pt),Ke.set(i.ExtHostContext.ExtHostEditorTabs,xt),Ke.set(i.ExtHostContext.ExtHostManagedSockets,zt),Ke.set(i.ExtHostContext.ExtHostAuthentication,Ct),Ke.set(i.ExtHostContext.ExtHostChatProvider,Lt);const ri=Ke.set(i.ExtHostContext.ExtHostDecorations,ht.get(x.IExtHostDecorations)),Bt=Ke.set(i.ExtHostContext.ExtHostDocumentsAndEditors,ht.get(Y.IExtHostDocumentsAndEditors)),St=Ke.set(i.ExtHostContext.ExtHostCommands,ht.get(_.IExtHostCommands)),kt=Ke.set(i.ExtHostContext.ExtHostTerminalService,ht.get(qe.IExtHostTerminalService)),fi=Ke.set(i.ExtHostContext.ExtHostTerminalShellIntegration,ht.get(ii.IExtHostTerminalShellIntegration)),Dt=Ke.set(i.ExtHostContext.ExtHostDebugService,ht.get(z.IExtHostDebugService)),si=Ke.set(i.ExtHostContext.ExtHostSearch,ht.get(ze.IExtHostSearch)),Jt=Ke.set(i.ExtHostContext.ExtHostTask,ht.get(De.IExtHostTask)),oi=Ke.set(i.ExtHostContext.ExtHostOutputService,ht.get(xe.IExtHostOutputService)),gi=Ke.set(i.ExtHostContext.ExtHostLocalization,ht.get(se.IExtHostLocalizationService)),Oe=Ke.set(i.ExtHostContext.ExtHostUrls,new Tt.ExtHostUrls(Ke)),Fe=Ke.set(i.ExtHostContext.ExtHostDocuments,new W.ExtHostDocuments(Ke,Bt)),Se=Ke.set(i.ExtHostContext.ExtHostDocumentContentProviders,new M.ExtHostDocumentContentProvider(Ke,Bt,pt)),ee=Ke.set(i.ExtHostContext.ExtHostDocumentSaveParticipant,new B.ExtHostDocumentSaveParticipant(pt,Fe,Ke.getProxy(i.MainContext.MainThreadBulkEdits))),Re=Ke.set(i.ExtHostContext.ExtHostNotebook,new ue.ExtHostNotebookController(Ke,St,Bt,Fe,jt,si)),Ve=Ke.set(i.ExtHostContext.ExtHostNotebookDocuments,new Te.ExtHostNotebookDocuments(Re)),et=Ke.set(i.ExtHostContext.ExtHostNotebookEditors,new me.ExtHostNotebookEditors(pt,Re)),Xe=Ke.set(i.ExtHostContext.ExtHostNotebookKernels,new Pe.ExtHostNotebookKernels(Ke,Et,Re,St,pt)),ut=Ke.set(i.ExtHostContext.ExtHostNotebookRenderers,new Ae.ExtHostNotebookRenderers(Ke,Re)),yt=Ke.set(i.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new he.ExtHostNotebookDocumentSaveParticipant(pt,Re,Ke.getProxy(i.MainContext.MainThreadBulkEdits))),_t=Ke.set(i.ExtHostContext.ExtHostEditors,new Qe.ExtHostEditors(Ke,Bt)),Zt=Ke.set(i.ExtHostContext.ExtHostTreeViews,new ke.ExtHostTreeViews(Ke.getProxy(i.MainContext.MainThreadTreeViews),St,pt)),$t=Ke.set(i.ExtHostContext.ExtHostEditorInsets,new E.ExtHostEditorInsets(Ke.getProxy(i.MainContext.MainThreadEditorInsets),_t,Et.remote)),Gt=Ke.set(i.ExtHostContext.ExtHostDiagnostics,new F.ExtHostDiagnostics(Ke,pt,ai,Bt)),wi=Ke.set(i.ExtHostContext.ExtHostLanguages,new ce.ExtHostLanguages(Ke,Fe,St.converter,Yt)),ft=Ke.set(i.ExtHostContext.ExtHostLanguageFeatures,new ae.ExtHostLanguageFeatures(Ke,Yt,Fe,St,Gt,pt,At,Pt)),Oi=Ke.set(i.ExtHostContext.ExtHostFileSystem,new re.ExtHostFileSystem(Ke,ft)),mi=Ke.set(i.ExtHostContext.ExtHostFileSystemEventService,new ve.ExtHostFileSystemEventService(Ke,pt,Bt)),bi=Ke.set(i.ExtHostContext.ExtHostQuickOpen,(0,K.createExtHostQuickOpen)(Ke,gt,St)),Di=Ke.set(i.ExtHostContext.ExtHostSCM,new Ee.ExtHostSCM(Ke,St,Fe,pt)),Ki=Ke.set(i.ExtHostContext.ExtHostQuickDiff,new X.ExtHostQuickDiff(Ke,Yt)),gn=Ke.set(i.ExtHostContext.ExtHostShare,new Ye.ExtHostShare(Ke,Yt)),Xi=Ke.set(i.ExtHostContext.ExtHostComments,(0,y.createExtHostComments)(Ke,St,Fe)),Ii=Ke.set(i.ExtHostContext.ExtHostProgress,new U.ExtHostProgress(Ke.getProxy(i.MainContext.MainThreadProgress))),Ni=Ke.set(i.ExtHostContext.ExtHostLabelService,new Ce.ExtHostLabelService(Ke)),Mi=Ke.set(i.ExtHostContext.ExtHostTheming,new oe.ExtHostTheming(Ke)),Qi=Ke.set(i.ExtHostContext.ExtHostTimeline,new le.ExtHostTimeline(Ke,St)),Pi=Ke.set(i.ExtHostContext.ExtHostWebviews,new Nt.ExtHostWebviews(Ke,Et.remote,gt,pt,At)),ki=Ke.set(i.ExtHostContext.ExtHostWebviewPanels,new Xt.ExtHostWebviewPanels(Ke,Pi,gt)),Yi=Ke.set(i.ExtHostContext.ExtHostCustomEditors,new k.ExtHostCustomEditors(Ke,Fe,Ht,Pi,ki)),Ji=Ke.set(i.ExtHostContext.ExtHostWebviewViews,new ei.ExtHostWebviewViews(Ke,Pi)),Si=Ke.set(i.ExtHostContext.ExtHostTesting,new Le.ExtHostTesting(Ke,pt,St,Bt)),mn=Ke.set(i.ExtHostContext.ExtHostUriOpeners,new lt.ExtHostUriOpeners(Ke)),Fi=Ke.set(i.ExtHostContext.ExtHostProfileContentHandlers,new H.ExtHostProfileContentHandlers(Ke));Ke.set(i.ExtHostContext.ExtHostInteractive,new ne.ExtHostInteractive(Ke,Re,Bt,St,pt));const xi=Ke.set(i.ExtHostContext.ExtHostInlineChat,new $.ExtHostInteractiveEditor(Ke,St,Fe,pt)),Zi=Ke.set(i.ExtHostContext.ExtHostChatAgents2,new u.ExtHostChatAgents2(Ke,pt,St)),pn=Ke.set(i.ExtHostContext.ExtHostChatVariables,new g.ExtHostChatVariables(Ke)),zi=Ke.set(i.ExtHostContext.ExtHostChat,new l.ExtHostChat(Ke)),en=Ke.set(i.ExtHostContext.ExtHostAiRelatedInformation,new r.ExtHostRelatedInformation(Ke)),Bi=Ke.set(i.ExtHostContext.ExtHostAiEmbeddingVector,new G.ExtHostAiEmbeddingVector(Ke)),$i=Ke.set(i.ExtHostContext.ExtHostIssueReporter,new be.ExtHostIssueReporter(Ke)),Wi=Ke.set(i.ExtHostContext.ExtHostStatusBar,new rt.ExtHostStatusBar(Ke,St.converter)),tn=Ke.set(i.ExtHostContext.ExtHostSpeech,new it.ExtHostSpeech(Ke)),vn=Object.values(i.ExtHostContext);Ke.assertRegistered(vn);const Ui=new h.ExtHostBulkEdits(Ke,Bt),nn=new D.ExtHostClipboard(Ke),di=new ie.ExtHostMessageService(Ke,pt),yi=new N.ExtHostDialogs(Ke);return s.ExtHostApiCommands.register(St),function(We,Wt,_i){function ot(fe){return(we,$e,ct)=>{const wt=fe(Rt=>{try{we.call($e,Rt)}catch(Ri){O.onUnexpectedExternalError(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event: ${Ri.toString()}`,{cause:Ri})),Pt.onExtensionError(We.identifier,Ri)}});return ct?.push(wt),wt}}const vt=function(){let fe=!We.isUnderDevelopment;function we(){fe||(pt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function $e(ct){if(Array.isArray(ct))ct.forEach($e);else if(typeof ct=="string")we();else{const wt=ct;typeof wt.scheme>"u"&&we(),typeof wt.exclusive=="boolean"&&(0,tt.checkProposedApiEnabled)(We,"documentFiltersExclusive")}return ct}}(),rn={getSession(fe,we,$e){return typeof $e?.forceNewSession=="object"&&$e.forceNewSession.learnMore&&(0,tt.checkProposedApiEnabled)(We,"authLearnMore"),Ct.getSession(We,fe,we,$e)},getSessions(fe,we){return(0,tt.checkProposedApiEnabled)(We,"authGetSessions"),Ct.getSessions(We,fe,we)},async hasSession(fe,we){return(0,tt.checkProposedApiEnabled)(We,"authSession"),!!await Ct.getSession(We,fe,we,{silent:!0})},get onDidChangeSessions(){return ot(Ct.onDidChangeSessions)},registerAuthenticationProvider(fe,we,$e,ct){return Ct.registerAuthenticationProvider(fe,we,$e,ct)}},sn={registerCommand(fe,we,$e){return St.registerCommand(!0,fe,we,$e,void 0,We)},registerTextEditorCommand(fe,we,$e){return St.registerCommand(!0,fe,(...ct)=>{const wt=_t.getActiveTextEditor();if(!wt){pt.warn("Cannot execute "+fe+" because there is no active text editor.");return}return wt.edit(Rt=>{we.apply($e,[wt,Rt,...ct])}).then(Rt=>{Rt||pt.warn("Edits from command "+fe+" were not applied.")},Rt=>{pt.warn("An error occurred while running command "+fe,Rt)})},void 0,void 0,We)},registerDiffInformationCommand:(fe,we,$e)=>((0,tt.checkProposedApiEnabled)(We,"diffCommand"),St.registerCommand(!0,fe,async(...ct)=>{const wt=Bt.activeEditor(!0);if(!wt){pt.warn("Cannot execute "+fe+" because there is no active text editor.");return}const Rt=await _t.getDiffInformation(wt.id);we.apply($e,[Rt,...ct])},void 0,void 0,We)),executeCommand(fe,...we){return St.executeCommand(fe,...we)},getCommands(fe=!1){return St.getCommands(fe)}},on={get machineId(){return Et.telemetryInfo.machineId},get sessionId(){return Et.telemetryInfo.sessionId},get language(){return Et.environment.appLanguage},get appName(){return Et.environment.appName},get appRoot(){return Et.environment.appRoot?.fsPath??""},get appHost(){return Et.environment.appHost},get uriScheme(){return Et.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return kt.getDefaultShell(!1)},get onDidChangeShell(){return ot(kt.onDidChangeShell)},get isTelemetryEnabled(){return Pt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Pt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,tt.checkProposedApiEnabled)(We,"telemetry"),Pt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.checkProposedApiEnabled)(We,"telemetry"),ot(Pt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Be.isNewAppInstall)(Et.telemetryInfo.firstSessionDate)},createTelemetryLogger(fe,we){return Be.ExtHostTelemetryLogger.validateSender(fe),Pt.instantiateLogger(We,fe,we)},openExternal(fe,we){return Ft.openUri(fe,{allowTunneling:!!Et.remote.authority,allowContributedOpeners:we?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===Et.environment.appUriScheme)return Oe.createAppUri(fe);try{return await Ft.asExternalUri(fe,{allowTunneling:!!Et.remote.authority})}catch(we){if((0,R.matchesScheme)(fe,R.Schemas.http)||(0,R.matchesScheme)(fe,R.Schemas.https))return fe;throw we}},get remoteName(){return(0,m.getRemoteName)(Et.remote.authority)},get remoteAuthority(){return(0,tt.checkProposedApiEnabled)(We,"resolvers"),Et.remote.authority},get uiKind(){return Et.uiKind},get logLevel(){return pt.getLevel()},get onDidChangeLogLevel(){return ot(pt.onDidChangeLogLevel)},registerIssueUriRequestHandler(fe){return(0,tt.checkProposedApiEnabled)(We,"handleIssueUri"),$i.registerIssueUriRequestHandler(We,fe)},registerIssueDataProvider(fe){return(0,tt.checkProposedApiEnabled)(We,"handleIssueUri"),$i.registerIssueDataProvider(We,fe)},get appQuality(){return(0,tt.checkProposedApiEnabled)(We,"resolvers"),Et.quality},get appCommit(){return(0,tt.checkProposedApiEnabled)(We,"resolvers"),Et.commit}};Et.environment.extensionTestsLocationURI||Object.freeze(on);const an={createTestController(fe,we,$e){return Si.createTestController(We,fe,we,$e)},createTestObserver(){return(0,tt.checkProposedApiEnabled)(We,"testObserver"),Si.createTestObserver()},runTests(fe){return(0,tt.checkProposedApiEnabled)(We,"testObserver"),Si.runTests(fe)},get onDidChangeTestResults(){return(0,tt.checkProposedApiEnabled)(We,"testObserver"),ot(Si.onResultsChanged)},get testResults(){return(0,tt.checkProposedApiEnabled)(We,"testObserver"),Si.results}},Ci=Et.remote.isRemote?Me.ExtensionKind.Workspace:Me.ExtensionKind.UI,bn={getExtension(fe,we){(0,tt.isProposedApiEnabled)(We,"extensionsAny")||(we=!1);const $e=Wt.mine.getExtensionDescription(fe);if($e)return new Q.Extension(Ut,We.identifier,$e,Ci,!1);if(we){const ct=Wt.all.getExtensionDescription(fe);if(ct)return new Q.Extension(Ut,We.identifier,ct,Ci,!0)}},get all(){const fe=[];for(const we of Wt.mine.getAllExtensionDescriptions())fe.push(new Q.Extension(Ut,We.identifier,we,Ci,!1));return fe},get allAcrossExtensionHosts(){(0,tt.checkProposedApiEnabled)(We,"extensionsAny");const fe=new C.ExtensionIdentifierSet(Wt.mine.getAllExtensionDescriptions().map($e=>$e.identifier)),we=[];for(const $e of Wt.all.getAllExtensionDescriptions()){const ct=!fe.has($e.identifier);we.push(new Q.Extension(Ut,We.identifier,$e,Ci,ct))}return we},get onDidChange(){return(0,tt.isProposedApiEnabled)(We,"extensionsAny")?ot(L.Event.any(Wt.mine.onDidChange,Wt.all.onDidChange)):ot(Wt.mine.onDidChange)}},En={createDiagnosticCollection(fe){return Gt.createDiagnosticCollection(We.identifier,fe)},get onDidChangeDiagnostics(){return ot(Gt.onDidChangeDiagnostics)},getDiagnostics:fe=>Gt.getDiagnostics(fe),getLanguages(){return wi.getLanguages()},setTextDocumentLanguage(fe,we){return wi.changeLanguage(fe.uri,we)},match(fe,we){const $e=Ze.LanguageSelector.from(fe);let ct;return(0,A.targetsNotebooks)($e)&&(ct=Re.notebookDocuments.find(wt=>wt.apiNotebook.getCells().find(Rt=>Rt.document===we))?.apiNotebook),(0,A.score)($e,we.uri,we.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(fe,we,$e){return ft.registerCodeActionProvider(We,vt(fe),we,$e)},registerDocumentPasteEditProvider(fe,we,$e){return(0,tt.checkProposedApiEnabled)(We,"documentPaste"),ft.registerDocumentPasteEditProvider(We,vt(fe),we,$e)},registerCodeLensProvider(fe,we){return ft.registerCodeLensProvider(We,vt(fe),we)},registerDefinitionProvider(fe,we){return ft.registerDefinitionProvider(We,vt(fe),we)},registerDeclarationProvider(fe,we){return ft.registerDeclarationProvider(We,vt(fe),we)},registerImplementationProvider(fe,we){return ft.registerImplementationProvider(We,vt(fe),we)},registerTypeDefinitionProvider(fe,we){return ft.registerTypeDefinitionProvider(We,vt(fe),we)},registerHoverProvider(fe,we){return ft.registerHoverProvider(We,vt(fe),we,We.identifier)},registerEvaluatableExpressionProvider(fe,we){return ft.registerEvaluatableExpressionProvider(We,vt(fe),we,We.identifier)},registerInlineValuesProvider(fe,we){return ft.registerInlineValuesProvider(We,vt(fe),we,We.identifier)},registerDocumentHighlightProvider(fe,we){return ft.registerDocumentHighlightProvider(We,vt(fe),we)},registerMultiDocumentHighlightProvider(fe,we){return ft.registerMultiDocumentHighlightProvider(We,vt(fe),we)},registerLinkedEditingRangeProvider(fe,we){return ft.registerLinkedEditingRangeProvider(We,vt(fe),we)},registerReferenceProvider(fe,we){return ft.registerReferenceProvider(We,vt(fe),we)},registerRenameProvider(fe,we){return ft.registerRenameProvider(We,vt(fe),we)},registerNewSymbolNamesProvider(fe,we){return(0,tt.checkProposedApiEnabled)(We,"newSymbolNamesProvider"),ft.registerNewSymbolNamesProvider(We,vt(fe),we)},registerDocumentSymbolProvider(fe,we,$e){return ft.registerDocumentSymbolProvider(We,vt(fe),we,$e)},registerWorkspaceSymbolProvider(fe){return ft.registerWorkspaceSymbolProvider(We,fe)},registerDocumentFormattingEditProvider(fe,we){return ft.registerDocumentFormattingEditProvider(We,vt(fe),we)},registerDocumentRangeFormattingEditProvider(fe,we){return ft.registerDocumentRangeFormattingEditProvider(We,vt(fe),we)},registerOnTypeFormattingEditProvider(fe,we,$e,...ct){return ft.registerOnTypeFormattingEditProvider(We,vt(fe),we,[$e].concat(ct))},registerDocumentSemanticTokensProvider(fe,we,$e){return ft.registerDocumentSemanticTokensProvider(We,vt(fe),we,$e)},registerDocumentRangeSemanticTokensProvider(fe,we,$e){return ft.registerDocumentRangeSemanticTokensProvider(We,vt(fe),we,$e)},registerSignatureHelpProvider(fe,we,$e,...ct){return typeof $e=="object"?ft.registerSignatureHelpProvider(We,vt(fe),we,$e):ft.registerSignatureHelpProvider(We,vt(fe),we,typeof $e>"u"?[]:[$e,...ct])},registerCompletionItemProvider(fe,we,...$e){return ft.registerCompletionItemProvider(We,vt(fe),we,$e)},registerInlineCompletionItemProvider(fe,we,$e){return we.handleDidShowCompletionItem&&(0,tt.checkProposedApiEnabled)(We,"inlineCompletionsAdditions"),we.handleDidPartiallyAcceptCompletionItem&&(0,tt.checkProposedApiEnabled)(We,"inlineCompletionsAdditions"),$e&&(0,tt.checkProposedApiEnabled)(We,"inlineCompletionsAdditions"),ft.registerInlineCompletionsProvider(We,vt(fe),we,$e)},registerInlineEditProvider(fe,we){return(0,tt.checkProposedApiEnabled)(We,"inlineEdit"),ft.registerInlineEditProvider(We,vt(fe),we)},registerDocumentLinkProvider(fe,we){return ft.registerDocumentLinkProvider(We,vt(fe),we)},registerColorProvider(fe,we){return ft.registerColorProvider(We,vt(fe),we)},registerFoldingRangeProvider(fe,we){return ft.registerFoldingRangeProvider(We,vt(fe),we)},registerSelectionRangeProvider(fe,we){return ft.registerSelectionRangeProvider(We,fe,we)},registerCallHierarchyProvider(fe,we){return ft.registerCallHierarchyProvider(We,fe,we)},registerTypeHierarchyProvider(fe,we){return ft.registerTypeHierarchyProvider(We,fe,we)},setLanguageConfiguration:(fe,we)=>ft.setLanguageConfiguration(We,fe,we),getTokenInformationAtPosition(fe,we){return(0,tt.checkProposedApiEnabled)(We,"tokenInformation"),wi.tokenAtPosition(fe,we)},registerInlayHintsProvider(fe,we){return ft.registerInlayHintsProvider(We,fe,we)},createLanguageStatusItem(fe,we){return wi.createLanguageStatusItem(We,fe,we)},registerDocumentDropEditProvider(fe,we,$e){return ft.registerDocumentOnDropEditProvider(We,fe,we,(0,tt.isProposedApiEnabled)(We,"dropMetadata")?$e:void 0)}},cn={get activeTextEditor(){return _t.getActiveTextEditor()},get visibleTextEditors(){return _t.getVisibleTextEditors()},get activeTerminal(){return kt.activeTerminal},get terminals(){return kt.terminals},async showTextDocument(fe,we,$e){p.URI.isUri(fe)&&fe.scheme===R.Schemas.vscodeRemote&&!fe.authority&&At.report("workspace.showTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await(p.URI.isUri(fe)?Promise.resolve(Ti.openTextDocument(fe)):Promise.resolve(fe));return _t.showTextDocument(ct,we,$e)},createTextEditorDecorationType(fe){return _t.createTextEditorDecorationType(We,fe)},onDidChangeActiveTextEditor(fe,we,$e){return ot(_t.onDidChangeActiveTextEditor)(fe,we,$e)},onDidChangeVisibleTextEditors(fe,we,$e){return ot(_t.onDidChangeVisibleTextEditors)(fe,we,$e)},onDidChangeTextEditorSelection(fe,we,$e){return ot(_t.onDidChangeTextEditorSelection)(fe,we,$e)},onDidChangeTextEditorOptions(fe,we,$e){return ot(_t.onDidChangeTextEditorOptions)(fe,we,$e)},onDidChangeTextEditorVisibleRanges(fe,we,$e){return ot(_t.onDidChangeTextEditorVisibleRanges)(fe,we,$e)},onDidChangeTextEditorViewColumn(fe,we,$e){return ot(_t.onDidChangeTextEditorViewColumn)(fe,we,$e)},onDidCloseTerminal(fe,we,$e){return ot(kt.onDidCloseTerminal)(fe,we,$e)},onDidOpenTerminal(fe,we,$e){return ot(kt.onDidOpenTerminal)(fe,we,$e)},onDidChangeActiveTerminal(fe,we,$e){return ot(kt.onDidChangeActiveTerminal)(fe,we,$e)},onDidChangeTerminalDimensions(fe,we,$e){return(0,tt.checkProposedApiEnabled)(We,"terminalDimensions"),ot(kt.onDidChangeTerminalDimensions)(fe,we,$e)},onDidChangeTerminalState(fe,we,$e){return ot(kt.onDidChangeTerminalState)(fe,we,$e)},onDidWriteTerminalData(fe,we,$e){return(0,tt.checkProposedApiEnabled)(We,"terminalDataWriteEvent"),ot(kt.onDidWriteTerminalData)(fe,we,$e)},onDidExecuteTerminalCommand(fe,we,$e){return(0,tt.checkProposedApiEnabled)(We,"terminalExecuteCommandEvent"),ot(kt.onDidExecuteTerminalCommand)(fe,we,$e)},onDidChangeTerminalShellIntegration(fe,we,$e){return(0,tt.checkProposedApiEnabled)(We,"terminalShellIntegration"),ot(fi.onDidChangeTerminalShellIntegration)(fe,we,$e)},onDidStartTerminalShellExecution(fe,we,$e){return(0,tt.checkProposedApiEnabled)(We,"terminalShellIntegration"),ot(fi.onDidStartTerminalShellExecution)(fe,we,$e)},onDidEndTerminalShellExecution(fe,we,$e){return(0,tt.checkProposedApiEnabled)(We,"terminalShellIntegration"),ot(fi.onDidEndTerminalShellExecution)(fe,we,$e)},get state(){return Ft.getState(We)},onDidChangeWindowState(fe,we,$e){return ot(Ft.onDidChangeWindowState)(fe,we,$e)},showInformationMessage(fe,...we){return di.showMessage(We,b.default.Info,fe,we[0],we.slice(1))},showWarningMessage(fe,...we){return di.showMessage(We,b.default.Warning,fe,we[0],we.slice(1))},showErrorMessage(fe,...we){return di.showMessage(We,b.default.Error,fe,we[0],we.slice(1))},showQuickPick(fe,we,$e){return bi.showQuickPick(We,fe,we,$e)},showWorkspaceFolderPick(fe){return bi.showWorkspaceFolderPick(fe)},showInputBox(fe,we){return bi.showInput(fe,we)},showOpenDialog(fe){return yi.showOpenDialog(We,fe)},showSaveDialog(fe){return yi.showSaveDialog(fe)},createStatusBarItem(fe,we,$e){let ct,wt,Rt;return typeof fe=="string"?(ct=fe,wt=we,Rt=$e):(wt=fe,Rt=we),Wi.createStatusBarEntry(We,ct,wt,Rt)},setStatusBarMessage(fe,we){return Wi.setStatusBarMessage(fe,we)},withScmProgress(fe){return At.report("window.withScmProgress",We,"Use 'withProgress' instead."),Ii.withProgress(We,{location:Me.ProgressLocation.SourceControl},(we,$e)=>fe({report(ct){}}))},withProgress(fe,we){return Ii.withProgress(We,fe,we)},createOutputChannel(fe,we){return oi.createOutputChannel(fe,we,We)},createWebviewPanel(fe,we,$e,ct){return ki.createWebviewPanel(We,fe,we,$e,ct)},createWebviewTextEditorInset(fe,we,$e,ct){return(0,tt.checkProposedApiEnabled)(We,"editorInsets"),$t.createWebviewEditorInset(fe,we,$e,ct,We)},createTerminal(fe,we,$e){return typeof fe=="object"?"pty"in fe?kt.createExtensionTerminal(fe):kt.createTerminalFromOptions(fe):kt.createTerminal(fe,we,$e)},registerTerminalLinkProvider(fe){return kt.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,we){return kt.registerProfileProvider(We,fe,we)},registerTerminalQuickFixProvider(fe,we){return(0,tt.checkProposedApiEnabled)(We,"terminalQuickFixProvider"),kt.registerTerminalQuickFixProvider(fe,We.identifier.value,we)},registerTreeDataProvider(fe,we){return Zt.registerTreeDataProvider(fe,we,We)},createTreeView(fe,we){return Zt.createTreeView(fe,we,We)},registerWebviewPanelSerializer:(fe,we)=>ki.registerWebviewPanelSerializer(We,fe,we),registerCustomEditorProvider:(fe,we,$e={})=>Yi.registerCustomEditorProvider(We,fe,we,$e),registerFileDecorationProvider(fe){return ri.registerFileDecorationProvider(fe,We)},registerUriHandler(fe){return Oe.registerUriHandler(We,fe)},createQuickPick(){return bi.createQuickPick(We)},createInputBox(){return bi.createInputBox(We)},get activeColorTheme(){return Mi.activeColorTheme},onDidChangeActiveColorTheme(fe,we,$e){return ot(Mi.onDidChangeActiveColorTheme)(fe,we,$e)},registerWebviewViewProvider(fe,we,$e){return Ji.registerWebviewViewProvider(We,fe,we,$e?.webviewOptions)},get activeNotebookEditor(){return Re.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,we,$e){return ot(Re.onDidChangeActiveNotebookEditor)(fe,we,$e)},get visibleNotebookEditors(){return Re.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Re.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(fe,we,$e){return ot(et.onDidChangeNotebookEditorSelection)(fe,we,$e)},onDidChangeNotebookEditorVisibleRanges(fe,we,$e){return ot(et.onDidChangeNotebookEditorVisibleRanges)(fe,we,$e)},showNotebookDocument(fe,we){return Re.showNotebookDocument(fe,we)},registerExternalUriOpener(fe,we,$e){return(0,tt.checkProposedApiEnabled)(We,"externalUriOpener"),mn.registerExternalUriOpener(We.identifier,fe,we,$e)},registerProfileContentHandler(fe,we){return(0,tt.checkProposedApiEnabled)(We,"profileContentHandlers"),Fi.registerProfileContentHandler(We,fe,we)},registerQuickDiffProvider(fe,we,$e,ct){return(0,tt.checkProposedApiEnabled)(We,"quickDiffProvider"),Ki.registerQuickDiffProvider(vt(fe),we,$e,ct)},get tabGroups(){return xt.tabGroups},registerShareProvider(fe,we){return(0,tt.checkProposedApiEnabled)(We,"shareProvider"),gn.registerShareProvider(vt(fe),we)}},Ti={get rootPath(){return At.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(fe){throw new O.ReadonlyError("rootPath")},getWorkspaceFolder(fe){return gt.getWorkspaceFolder(fe)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(fe){throw new O.ReadonlyError("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(fe){throw new O.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(fe,we,...$e)=>gt.updateWorkspaceFolders(We,fe,we||0,...$e),onDidChangeWorkspaceFolders:function(fe,we,$e){return ot(gt.onDidChangeWorkspace)(fe,we,$e)},asRelativePath:(fe,we)=>gt.getRelativePath(fe,we),findFiles:(fe,we,$e,ct)=>gt.findFiles(fe,we,$e,We.identifier,ct),findFiles2:(fe,we,$e)=>((0,tt.checkProposedApiEnabled)(We,"findFiles2"),gt.findFiles2(fe,we,We.identifier,$e)),findTextInFiles:(fe,we,$e,ct)=>{(0,tt.checkProposedApiEnabled)(We,"findTextInFiles");let wt,Rt;return typeof we=="object"?(wt=we,Rt=$e):(wt={},Rt=we,ct=$e),gt.findTextInFiles(fe,wt||{},Rt,We.identifier,ct)},save:fe=>gt.save(fe),saveAs:fe=>gt.saveAs(fe),saveAll:fe=>gt.saveAll(fe),applyEdit(fe,we){return Ui.applyWorkspaceEdit(fe,We,we)},createFileSystemWatcher:(fe,we,$e,ct)=>{let wt;return typeof we=="boolean"?wt={ignoreCreateEvents:!!we,ignoreChangeEvents:!!$e,ignoreDeleteEvents:!!ct,correlate:!1}:we&&((0,tt.checkProposedApiEnabled)(We,"createFileSystemWatcher"),wt={...we,correlate:!0}),mi.createFileSystemWatcher(gt,We,fe,wt)},get textDocuments(){return Fe.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw new O.ReadonlyError("textDocuments")},openTextDocument(fe){let we;const $e=fe;if(typeof fe=="string")we=Promise.resolve(p.URI.file(fe));else if(p.URI.isUri(fe))we=Promise.resolve(fe);else if(!$e||typeof $e=="object")we=Fe.createDocumentData($e);else throw new Error("illegal argument - uriOrFileNameOrOptions");return we.then(ct=>(ct.scheme===R.Schemas.vscodeRemote&&!ct.authority&&At.report("workspace.openTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority."),Fe.ensureDocumentData(ct).then(wt=>wt.document)))},onDidOpenTextDocument:(fe,we,$e)=>ot(Fe.onDidAddDocument)(fe,we,$e),onDidCloseTextDocument:(fe,we,$e)=>ot(Fe.onDidRemoveDocument)(fe,we,$e),onDidChangeTextDocument:(fe,we,$e)=>ot(Fe.onDidChangeDocument)(fe,we,$e),onDidSaveTextDocument:(fe,we,$e)=>ot(Fe.onDidSaveDocument)(fe,we,$e),onWillSaveTextDocument:(fe,we,$e)=>ot(ee.getOnWillSaveTextDocumentEvent(We))(fe,we,$e),get notebookDocuments(){return Re.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,we){let $e;if(p.URI.isUri(fe))$e=fe,await Re.openNotebookDocument(fe);else if(typeof fe=="string")$e=p.URI.revive(await Re.createNotebookDocument({viewType:fe,content:we}));else throw new Error("Invalid arguments");return Re.getNotebookDocument($e).apiNotebook},onDidSaveNotebookDocument(fe,we,$e){return ot(Ve.onDidSaveNotebookDocument)(fe,we,$e)},onDidChangeNotebookDocument(fe,we,$e){return ot(Ve.onDidChangeNotebookDocument)(fe,we,$e)},onWillSaveNotebookDocument(fe,we,$e){return ot(yt.getOnWillSaveNotebookDocumentEvent(We))(fe,we,$e)},get onDidOpenNotebookDocument(){return ot(Re.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Re.onDidCloseNotebookDocument)},registerNotebookSerializer(fe,we,$e,ct){return Re.registerNotebookSerializer(We,fe,we,$e,(0,tt.isProposedApiEnabled)(We,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(fe,we,$e)=>ot(_i.onDidChangeConfiguration)(fe,we,$e),getConfiguration(fe,we){return we=arguments.length===1?void 0:we,_i.getConfiguration(fe,we,We)},registerTextDocumentContentProvider(fe,we){return Se.registerTextDocumentContentProvider(fe,we)},registerTaskProvider:(fe,we)=>(At.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),Jt.registerTaskProvider(We,fe,we)),registerFileSystemProvider(fe,we,$e){return(0,T.combinedDisposable)(Oi.registerFileSystemProvider(We,fe,we,$e),jt.addFileSystemProvider(fe,we,$e))},get fs(){return jt.value},registerFileSearchProvider:(fe,we)=>((0,tt.checkProposedApiEnabled)(We,"fileSearchProvider"),si.registerFileSearchProvider(fe,we)),registerTextSearchProvider:(fe,we)=>((0,tt.checkProposedApiEnabled)(We,"textSearchProvider"),si.registerTextSearchProvider(fe,we)),registerAITextSearchProvider:(fe,we)=>((0,tt.checkProposedApiEnabled)(We,"aiTextSearchProvider"),(0,tt.checkProposedApiEnabled)(We,"textSearchProvider"),si.registerAITextSearchProvider(fe,we)),registerRemoteAuthorityResolver:(fe,we)=>((0,tt.checkProposedApiEnabled)(We,"resolvers"),Ut.registerRemoteAuthorityResolver(fe,we)),registerResourceLabelFormatter:fe=>((0,tt.checkProposedApiEnabled)(We,"resolvers"),Ni.$registerResourceLabelFormatter(fe)),getRemoteExecServer:fe=>((0,tt.checkProposedApiEnabled)(We,"resolvers"),Ut.getRemoteExecServer(fe)),onDidCreateFiles:(fe,we,$e)=>ot(mi.onDidCreateFile)(fe,we,$e),onDidDeleteFiles:(fe,we,$e)=>ot(mi.onDidDeleteFile)(fe,we,$e),onDidRenameFiles:(fe,we,$e)=>ot(mi.onDidRenameFile)(fe,we,$e),onWillCreateFiles:(fe,we,$e)=>ot(mi.getOnWillCreateFileEvent(We))(fe,we,$e),onWillDeleteFiles:(fe,we,$e)=>ot(mi.getOnWillDeleteFileEvent(We))(fe,we,$e),onWillRenameFiles:(fe,we,$e)=>ot(mi.getOnWillRenameFileEvent(We))(fe,we,$e),openTunnel:fe=>((0,tt.checkProposedApiEnabled)(We,"tunnels"),Ot.openTunnel(We,fe).then(we=>{if(!we)throw new Error("cannot open tunnel");return we})),get tunnels(){return(0,tt.checkProposedApiEnabled)(We,"tunnels"),Ot.getTunnels()},onDidChangeTunnels:(fe,we,$e)=>((0,tt.checkProposedApiEnabled)(We,"tunnels"),ot(Ot.onDidChangeTunnels)(fe,we,$e)),registerPortAttributesProvider:(fe,we)=>((0,tt.checkProposedApiEnabled)(We,"portsAttributes"),Ot.registerPortsAttributesProvider(fe,we)),registerTunnelProvider:(fe,we)=>((0,tt.checkProposedApiEnabled)(We,"tunnelFactory"),Ot.registerTunnelProvider(fe,we)),registerTimelineProvider:(fe,we)=>((0,tt.checkProposedApiEnabled)(We,"timeline"),Qi.registerTimelineProvider(fe,we,We.identifier,St.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:fe=>((0,tt.checkProposedApiEnabled)(We,"workspaceTrust"),gt.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,we,$e)=>ot(gt.onDidGrantWorkspaceTrust)(fe,we,$e),registerEditSessionIdentityProvider:(fe,we)=>((0,tt.checkProposedApiEnabled)(We,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(fe,we)),onWillCreateEditSessionIdentity:(fe,we,$e)=>((0,tt.checkProposedApiEnabled)(We,"editSessionIdentityProvider"),ot(gt.getOnWillCreateEditSessionIdentityEvent(We))(fe,we,$e)),registerCanonicalUriProvider:(fe,we)=>((0,tt.checkProposedApiEnabled)(We,"canonicalUriProvider"),gt.registerCanonicalUriProvider(fe,we)),getCanonicalUri:(fe,we,$e)=>((0,tt.checkProposedApiEnabled)(We,"canonicalUriProvider"),gt.provideCanonicalUri(fe,we,$e))},ln={get inputBox(){return At.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),Di.getLastInputBox(We)},createSourceControl(fe,we,$e){return Di.createSourceControl(We,fe,we,$e)}},un={createCommentController(fe,we){return Xi.createCommentController(We,fe,we)}},dn={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){if((0,tt.isProposedApiEnabled)(We,"debugFocus"))return Dt.activeStackItem},registerDebugVisualizationProvider(fe,we){return(0,tt.checkProposedApiEnabled)(We,"debugVisualization"),Dt.registerDebugVisualizationProvider(We,fe,we)},registerDebugVisualizationTreeProvider(fe,we){return(0,tt.checkProposedApiEnabled)(We,"debugVisualization"),Dt.registerDebugVisualizationTree(We,fe,we)},onDidStartDebugSession(fe,we,$e){return ot(Dt.onDidStartDebugSession)(fe,we,$e)},onDidTerminateDebugSession(fe,we,$e){return ot(Dt.onDidTerminateDebugSession)(fe,we,$e)},onDidChangeActiveDebugSession(fe,we,$e){return ot(Dt.onDidChangeActiveDebugSession)(fe,we,$e)},onDidReceiveDebugSessionCustomEvent(fe,we,$e){return ot(Dt.onDidReceiveDebugSessionCustomEvent)(fe,we,$e)},onDidChangeBreakpoints(fe,we,$e){return ot(Dt.onDidChangeBreakpoints)(fe,we,$e)},onDidChangeActiveStackItem(fe,we,$e){return(0,tt.checkProposedApiEnabled)(We,"debugFocus"),ot(Dt.onDidChangeActiveStackItem)(fe,we,$e)},registerDebugConfigurationProvider(fe,we,$e){return Dt.registerDebugConfigurationProvider(fe,we,$e||Vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,we){return Dt.registerDebugAdapterDescriptorFactory(We,fe,we)},registerDebugAdapterTrackerFactory(fe,we){return Dt.registerDebugAdapterTrackerFactory(fe,we)},startDebugging(fe,we,$e){return!$e||typeof $e=="object"&&"configuration"in $e?Dt.startDebugging(fe,we,{parentSession:$e}):Dt.startDebugging(fe,we,$e||{})},stopDebugging(fe){return Dt.stopDebugging(fe)},addBreakpoints(fe){return Dt.addBreakpoints(fe)},removeBreakpoints(fe){return Dt.removeBreakpoints(fe)},asDebugSourceUri(fe,we){return Dt.asDebugSourceUri(fe,we)}},wn={registerTaskProvider:(fe,we)=>Jt.registerTaskProvider(We,fe,we),fetchTasks:fe=>Jt.fetchTasks(fe),executeTask:fe=>Jt.executeTask(We,fe),get taskExecutions(){return Jt.taskExecutions},onDidStartTask:(fe,we,$e)=>ot(Jt.onDidStartTask)(fe,we,$e),onDidEndTask:(fe,we,$e)=>ot(Jt.onDidEndTask)(fe,we,$e),onDidStartTaskProcess:(fe,we,$e)=>ot(Jt.onDidStartTaskProcess)(fe,we,$e),onDidEndTaskProcess:(fe,we,$e)=>ot(Jt.onDidEndTaskProcess)(fe,we,$e)},Sn={createNotebookController(fe,we,$e,ct,wt){return Xe.createNotebookController(We,fe,we,$e,ct,(0,tt.isProposedApiEnabled)(We,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(fe,we)=>Re.registerNotebookCellStatusBarItemProvider(We,fe,we),createRendererMessaging(fe){return ut.createRendererMessaging(We,fe)},createNotebookControllerDetectionTask(fe){return(0,tt.checkProposedApiEnabled)(We,"notebookKernelSource"),Xe.createNotebookControllerDetectionTask(We,fe)},registerKernelSourceActionProvider(fe,we){return(0,tt.checkProposedApiEnabled)(We,"notebookKernelSource"),Xe.registerKernelSourceActionProvider(We,fe,we)},onDidChangeNotebookCellExecutionState(fe,we,$e){return(0,tt.checkProposedApiEnabled)(We,"notebookCellExecutionState"),ot(Xe.onDidChangeNotebookCellExecutionState)(fe,we,$e)}},hn={t(...fe){if(typeof fe[0]=="string"){const we=fe.shift(),$e=!fe||typeof fe[0]!="object"?fe:fe[0];return gi.getMessage(We.identifier.value,{message:we,args:$e})}return gi.getMessage(We.identifier.value,fe[0])},get bundle(){return gi.getBundle(We.identifier.value)},get uri(){return gi.getBundleUri(We.identifier.value)}},fn={_version:1,registerInteractiveEditorSessionProvider(fe,we){return(0,tt.checkProposedApiEnabled)(We,"interactive"),xi.registerProvider(We,fe,we)},registerInteractiveSessionProvider(fe,we){return(0,tt.checkProposedApiEnabled)(We,"interactive"),zi.registerChatProvider(We,fe,we)},transferChatSession(fe,we){return(0,tt.checkProposedApiEnabled)(We,"interactive"),zi.transferChatSession(fe,we)}},Hi={getRelatedInformation(fe,we){return(0,tt.checkProposedApiEnabled)(We,"aiRelatedInformation"),en.getRelatedInformation(We,fe,we)},registerRelatedInformationProvider(fe,we){return(0,tt.checkProposedApiEnabled)(We,"aiRelatedInformation"),en.registerRelatedInformationProvider(We,fe,we)},registerEmbeddingVectorProvider(fe,we){return(0,tt.checkProposedApiEnabled)(We,"aiRelatedInformation"),Bi.registerEmbeddingVectorProvider(We,fe,we)}},Vi={registerChatResponseProvider(fe,we,$e){return(0,tt.checkProposedApiEnabled)(We,"chatProvider"),Lt.registerLanguageModel(We,fe,we,$e)},registerChatVariableResolver(fe,we,$e){return(0,tt.checkProposedApiEnabled)(We,"chatVariableResolver"),pn.registerVariableResolver(We,fe,we,$e)},registerMappedEditsProvider(fe,we){return(0,tt.checkProposedApiEnabled)(We,"mappedEditsProvider"),ft.registerMappedEditsProvider(We,fe,we)},createChatParticipant(fe,we){return(0,tt.checkProposedApiEnabled)(We,"chatParticipant"),Zi.createChatAgent(We,fe,we)},createDynamicChatParticipant(fe,we,$e,ct){return(0,tt.checkProposedApiEnabled)(We,"chatParticipantAdditions"),Zi.createDynamicChatAgent(We,fe,we,$e,ct)}},qi={get languageModels(){return(0,tt.checkProposedApiEnabled)(We,"languageModels"),Lt.getLanguageModelIds()},onDidChangeLanguageModels:(fe,we,$e)=>((0,tt.checkProposedApiEnabled)(We,"languageModels"),Lt.onDidChangeProviders(fe,we,$e)),sendChatRequest(fe,we,$e,ct){return(0,tt.checkProposedApiEnabled)(We,"languageModels"),Lt.sendChatRequest(We,fe,we,$e,ct)}},Ai={registerSpeechProvider(fe,we){return(0,tt.checkProposedApiEnabled)(We,"speech"),tn.registerProvider(We.identifier,fe,we)}};return{version:Et.version,ai:Hi,authentication:rn,commands:sn,comments:un,chat:Vi,debug:dn,env:on,extensions:bn,interactive:fn,l10n:hn,languages:En,lm:qi,notebooks:Sn,scm:ln,speech:Ai,tasks:wn,tests:an,window:cn,workspace:Ti,Breakpoint:Me.Breakpoint,TerminalOutputAnchor:Me.TerminalOutputAnchor,ChatResultFeedbackKind:Me.ChatResultFeedbackKind,ChatVariableLevel:Me.ChatVariableLevel,ChatCompletionItem:Me.ChatCompletionItem,CallHierarchyIncomingCall:Me.CallHierarchyIncomingCall,CallHierarchyItem:Me.CallHierarchyItem,CallHierarchyOutgoingCall:Me.CallHierarchyOutgoingCall,CancellationError:O.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:i.CandidatePortSource,CodeAction:Me.CodeAction,CodeActionKind:Me.CodeActionKind,CodeActionTriggerKind:Me.CodeActionTriggerKind,CodeLens:Me.CodeLens,Color:Me.Color,ColorInformation:Me.ColorInformation,ColorPresentation:Me.ColorPresentation,ColorThemeKind:Me.ColorThemeKind,CommentMode:Me.CommentMode,CommentState:Me.CommentState,CommentThreadCollapsibleState:Me.CommentThreadCollapsibleState,CommentThreadState:Me.CommentThreadState,CommentThreadApplicability:Me.CommentThreadApplicability,CompletionItem:Me.CompletionItem,CompletionItemKind:Me.CompletionItemKind,CompletionItemTag:Me.CompletionItemTag,CompletionList:Me.CompletionList,CompletionTriggerKind:Me.CompletionTriggerKind,ConfigurationTarget:Me.ConfigurationTarget,CustomExecution:Me.CustomExecution,DebugAdapterExecutable:Me.DebugAdapterExecutable,DebugAdapterInlineImplementation:Me.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:Me.DebugAdapterNamedPipeServer,DebugAdapterServer:Me.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Me.DebugConsoleMode,DebugVisualization:Me.DebugVisualization,DecorationRangeBehavior:Me.DecorationRangeBehavior,Diagnostic:Me.Diagnostic,DiagnosticRelatedInformation:Me.DiagnosticRelatedInformation,DiagnosticSeverity:Me.DiagnosticSeverity,DiagnosticTag:Me.DiagnosticTag,Disposable:Me.Disposable,DocumentHighlight:Me.DocumentHighlight,DocumentHighlightKind:Me.DocumentHighlightKind,MultiDocumentHighlight:Me.MultiDocumentHighlight,DocumentLink:Me.DocumentLink,DocumentSymbol:Me.DocumentSymbol,EndOfLine:Me.EndOfLine,EnvironmentVariableMutatorType:Me.EnvironmentVariableMutatorType,EvaluatableExpression:Me.EvaluatableExpression,InlineValueText:Me.InlineValueText,InlineValueVariableLookup:Me.InlineValueVariableLookup,InlineValueEvaluatableExpression:Me.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:Me.InlineCompletionTriggerKind,EventEmitter:L.Emitter,ExtensionKind:Me.ExtensionKind,ExtensionMode:Me.ExtensionMode,ExternalUriOpenerPriority:Me.ExternalUriOpenerPriority,FileChangeType:Me.FileChangeType,FileDecoration:Me.FileDecoration,FileDecoration2:Me.FileDecoration,FileSystemError:Me.FileSystemError,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:Me.FoldingRange,FoldingRangeKind:Me.FoldingRangeKind,FunctionBreakpoint:Me.FunctionBreakpoint,InlineCompletionItem:Me.InlineSuggestion,InlineCompletionList:Me.InlineSuggestionList,Hover:Me.Hover,IndentAction:I.IndentAction,Location:Me.Location,MarkdownString:Me.MarkdownString,OverviewRulerLane:v.OverviewRulerLane,ParameterInformation:Me.ParameterInformation,PortAutoForwardAction:Me.PortAutoForwardAction,Position:Me.Position,ProcessExecution:Me.ProcessExecution,ProgressLocation:Me.ProgressLocation,QuickInputButtons:Me.QuickInputButtons,Range:Me.Range,RelativePattern:Me.RelativePattern,Selection:Me.Selection,SelectionRange:Me.SelectionRange,SemanticTokens:Me.SemanticTokens,SemanticTokensBuilder:Me.SemanticTokensBuilder,SemanticTokensEdit:Me.SemanticTokensEdit,SemanticTokensEdits:Me.SemanticTokensEdits,SemanticTokensLegend:Me.SemanticTokensLegend,ShellExecution:Me.ShellExecution,ShellQuoting:Me.ShellQuoting,SignatureHelp:Me.SignatureHelp,SignatureHelpTriggerKind:Me.SignatureHelpTriggerKind,SignatureInformation:Me.SignatureInformation,SnippetString:Me.SnippetString,SourceBreakpoint:Me.SourceBreakpoint,StandardTokenType:Me.StandardTokenType,StatusBarAlignment:Me.StatusBarAlignment,SymbolInformation:Me.SymbolInformation,SymbolKind:Me.SymbolKind,SymbolTag:Me.SymbolTag,Task:Me.Task,TaskGroup:Me.TaskGroup,TaskPanelKind:Me.TaskPanelKind,TaskRevealKind:Me.TaskRevealKind,TaskScope:Me.TaskScope,TerminalLink:Me.TerminalLink,TerminalQuickFixTerminalCommand:Me.TerminalQuickFixCommand,TerminalQuickFixOpener:Me.TerminalQuickFixOpener,TerminalLocation:Me.TerminalLocation,TerminalProfile:Me.TerminalProfile,TerminalExitReason:Me.TerminalExitReason,TextDocumentSaveReason:Me.TextDocumentSaveReason,TextEdit:Me.TextEdit,SnippetTextEdit:Me.SnippetTextEdit,TextEditorCursorStyle:w.TextEditorCursorStyle,TextEditorLineNumbersStyle:Me.TextEditorLineNumbersStyle,TextEditorRevealType:Me.TextEditorRevealType,TextEditorSelectionChangeKind:Me.TextEditorSelectionChangeKind,SyntaxTokenType:Me.SyntaxTokenType,TextDocumentChangeReason:Me.TextDocumentChangeReason,ThemeColor:Me.ThemeColor,ThemeIcon:Me.ThemeIcon,TreeItem:Me.TreeItem,TreeItemCheckboxState:Me.TreeItemCheckboxState,TreeItemCollapsibleState:Me.TreeItemCollapsibleState,TypeHierarchyItem:Me.TypeHierarchyItem,UIKind:ci.UIKind,Uri:p.URI,ViewColumn:Me.ViewColumn,WorkspaceEdit:Me.WorkspaceEdit,DocumentPasteTriggerKind:Me.DocumentPasteTriggerKind,DocumentDropEdit:Me.DocumentDropEdit,DocumentPasteEditKind:Me.DocumentPasteEditKind,DocumentPasteEdit:Me.DocumentPasteEdit,InlayHint:Me.InlayHint,InlayHintLabelPart:Me.InlayHintLabelPart,InlayHintKind:Me.InlayHintKind,RemoteAuthorityResolverError:Me.RemoteAuthorityResolverError,ResolvedAuthority:Me.ResolvedAuthority,ManagedResolvedAuthority:Me.ManagedResolvedAuthority,SourceControlInputBoxValidationType:Me.SourceControlInputBoxValidationType,ExtensionRuntime:Me.ExtensionRuntime,TimelineItem:Me.TimelineItem,NotebookRange:Me.NotebookRange,NotebookCellKind:Me.NotebookCellKind,NotebookCellExecutionState:Me.NotebookCellExecutionState,NotebookCellData:Me.NotebookCellData,NotebookData:Me.NotebookData,NotebookRendererScript:Me.NotebookRendererScript,NotebookCellStatusBarAlignment:Me.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Me.NotebookEditorRevealType,NotebookCellOutput:Me.NotebookCellOutput,NotebookCellOutputItem:Me.NotebookCellOutputItem,NotebookCellStatusBarItem:Me.NotebookCellStatusBarItem,NotebookControllerAffinity:Me.NotebookControllerAffinity,NotebookControllerAffinity2:Me.NotebookControllerAffinity2,NotebookEdit:Me.NotebookEdit,NotebookKernelSourceAction:Me.NotebookKernelSourceAction,NotebookVariablesRequestKind:Me.NotebookVariablesRequestKind,PortAttributes:Me.PortAttributes,LinkedEditingRanges:Me.LinkedEditingRanges,TestResultState:Me.TestResultState,TestRunRequest:Me.TestRunRequest,TestMessage:Me.TestMessage,TestTag:Me.TestTag,TestRunProfileKind:Me.TestRunProfileKind,TextSearchCompleteMessageType:ti.TextSearchCompleteMessageType,DataTransfer:Me.DataTransfer,DataTransferItem:Me.DataTransferItem,TestCoverageCount:Me.TestCoverageCount,FileCoverage:Me.FileCoverage,StatementCoverage:Me.StatementCoverage,BranchCoverage:Me.BranchCoverage,DeclarationCoverage:Me.DeclarationCoverage,FunctionCoverage:Me.DeclarationCoverage,WorkspaceTrustState:Me.WorkspaceTrustState,LanguageStatusSeverity:Me.LanguageStatusSeverity,QuickPickItemKind:Me.QuickPickItemKind,InputBoxValidationSeverity:Me.InputBoxValidationSeverity,TabInputText:Me.TextTabInput,TabInputTextDiff:Me.TextDiffTabInput,TabInputTextMerge:Me.TextMergeTabInput,TabInputCustom:Me.CustomEditorTabInput,TabInputNotebook:Me.NotebookEditorTabInput,TabInputNotebookDiff:Me.NotebookDiffEditorTabInput,TabInputWebview:Me.WebviewEditorTabInput,TabInputTerminal:Me.TerminalEditorTabInput,TabInputInteractiveWindow:Me.InteractiveWindowInput,TabInputChat:Me.ChatEditorTabInput,TabInputTextMultiDiff:Me.TextMultiDiffTabInput,TelemetryTrustedValue:o.TelemetryTrustedValue,LogLevel:a.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Me.InteractiveSessionVoteDirection,ChatCopyKind:Me.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Me.InteractiveEditorResponseFeedbackKind,StackFrame:Me.StackFrame,Thread:Me.Thread,RelatedInformationType:Me.RelatedInformationType,SpeechToTextStatus:Me.SpeechToTextStatus,PartialAcceptTriggerKind:Me.PartialAcceptTriggerKind,KeywordRecognitionStatus:Me.KeywordRecognitionStatus,ChatResponseMarkdownPart:Me.ChatResponseMarkdownPart,ChatResponseFileTreePart:Me.ChatResponseFileTreePart,ChatResponseAnchorPart:Me.ChatResponseAnchorPart,ChatResponseProgressPart:Me.ChatResponseProgressPart,ChatResponseReferencePart:Me.ChatResponseReferencePart,ChatResponseCommandButtonPart:Me.ChatResponseCommandButtonPart,ChatRequestTurn:Me.ChatRequestTurn,ChatResponseTurn:Me.ChatResponseTurn,ChatLocation:Me.ChatLocation,LanguageModelChatSystemMessage:Me.LanguageModelChatSystemMessage,LanguageModelChatUserMessage:Me.LanguageModelChatUserMessage,LanguageModelChatAssistantMessage:Me.LanguageModelChatAssistantMessage,LanguageModelSystemMessage:Me.LanguageModelChatSystemMessage,LanguageModelUserMessage:Me.LanguageModelChatUserMessage,LanguageModelAssistantMessage:Me.LanguageModelChatAssistantMessage,LanguageModelError:Me.LanguageModelError,NewSymbolName:Me.NewSymbolName,NewSymbolNameTag:Me.NewSymbolNameTag,InlineEdit:Me.InlineEdit,InlineEditTriggerKind:Me.InlineEditTriggerKind}}}}),define(ye[380],_e([1,0,84,157,44,151,45,33,72,43,95,96,97,118,70,91,150,69,59,117,90,71,149,12,60,115,116,120,121,155]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n,i,r,s,t,f,h,l,u,d,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(l.IExtHostLocalizationService,l.ExtHostLocalizationService,1),(0,c.registerSingleton)(f.ILoggerService,t.ExtHostLoggerService,1),(0,c.registerSingleton)(a.IExtHostApiDeprecationService,a.ExtHostApiDeprecationService,1),(0,c.registerSingleton)(b.IExtHostCommands,b.ExtHostCommands,0),(0,c.registerSingleton)(d.IExtHostAuthentication,d.ExtHostAuthentication,0),(0,c.registerSingleton)(g.IExtHostLanguageModels,g.ExtHostLanguageModels,0),(0,c.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration,0),(0,c.registerSingleton)(o.IExtHostConsumerFileSystem,o.ExtHostConsumerFileSystem,0),(0,c.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService,0),(0,c.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations,0),(0,c.registerSingleton)(p.IExtHostDocumentsAndEditors,p.ExtHostDocumentsAndEditors,0),(0,c.registerSingleton)(u.IExtHostManagedSockets,u.ExtHostManagedSockets,0),(0,c.registerSingleton)(n.IExtHostFileSystemInfo,n.ExtHostFileSystemInfo,0),(0,c.registerSingleton)(O.IExtHostOutputService,O.ExtHostOutputService,1),(0,c.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch,0),(0,c.registerSingleton)(C.IExtHostStorage,C.ExtHostStorage,0),(0,c.registerSingleton)(A.IExtHostTask,A.WorkerExtHostTask,0),(0,c.registerSingleton)(w.IExtHostTerminalService,w.WorkerExtHostTerminalService,0),(0,c.registerSingleton)(D.IExtHostTerminalShellIntegration,D.ExtHostTerminalShellIntegration,0),(0,c.registerSingleton)(S.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,c.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow,0),(0,c.registerSingleton)(L.IExtHostWorkspace,L.ExtHostWorkspace,0),(0,c.registerSingleton)(i.IExtHostSecretState,i.ExtHostSecretState,0),(0,c.registerSingleton)(r.IExtHostTelemetry,r.ExtHostTelemetry,0),(0,c.registerSingleton)(s.IExtHostEditorTabs,s.ExtHostEditorTabs,0),(0,c.registerSingleton)(h.IExtHostVariableResolverProvider,h.ExtHostVariableResolverProviderService,0)}),define(ye[122],_e([1,0,19,12,36,94]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=void 0,e.anchorGlob=R,e.createTextSearchResult=b;function R(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}function b(I,v,C,S){const a=(0,c.mapArrayOrNot)(C,p),m=new L.TextSearchMatch(v,a,S),o=m.preview.matches;return{ranges:(0,c.mapArrayOrNot)(a,w),uri:I,preview:{text:m.preview.text,matches:(0,c.mapArrayOrNot)(o,w)}}}function p(I){return new L.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function w(I){return new T.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let A=class{constructor(v,C){this.prefix=v,this.logService=C}appendLine(v){this.logService.debug(`${this.prefix}#search`,v)}};e.OutputChannel=A,e.OutputChannel=A=Ge([Ue(1,O.ILogService)],A)}),define(ye[381],_e([1,0,52,17,76,34,11,14,122,382]),function(de,e,c,O,L,T,R,b,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnRipgrepCmd=I,e.getAbsoluteGlob=m,e.fixDriveC=n;const A=w.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(i,r,s,t){const f=v(i,r,s,t),h=r.folder.fsPath;return{cmd:c.spawn(A,f.args,{cwd:h}),rgDiskPath:A,siblingClauses:f.siblingClauses,rgArgs:f,cwd:h}}function v(i,r,s,t){const f=["--files","--hidden","--case-sensitive","--no-require-git"];S([r],s,!1).forEach(l=>{const u=(0,p.anchorGlob)(l);if(f.push("-g",u),R.isMacintosh){const d=(0,L.normalizeNFD)(u);d!==u&&f.push("-g",d)}});const h=C([r],t,void 0,!1);return h.globArgs.forEach(l=>{const u=`!${(0,p.anchorGlob)(l)}`;if(f.push("-g",u),R.isMacintosh){const d=(0,L.normalizeNFD)(u);d!==u&&f.push("-g",d)}}),r.disregardIgnoreFiles!==!1?f.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&f.push("--no-ignore-parent"),r.ignoreSymlinks||f.push("--follow"),i.exists&&f.push("--quiet"),f.push("--no-config"),r.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:h.siblingClauses}}function C(i,r,s,t=!0){const f=[];let h={};return i.forEach(l=>{const u=Object.assign({},l.excludePattern||{},r||{}),d=a(u,t?l.folder.fsPath:void 0,s);f.push(...d.globArgs),d.siblingClauses&&(h=Object.assign(h,d.siblingClauses))}),{globArgs:f,siblingClauses:h}}function S(i,r,s=!0){const t=[];return i.forEach(f=>{const h=Object.assign({},r||{},f.includePattern||{}),l=a(h,s?f.folder.fsPath:void 0);t.push(...l.globArgs)}),t}function a(i,r,s){const t=[],f={};return Object.keys(i).forEach(h=>{if(s&&s.has(h)||!h)return;const l=i[h];h=o(r?m(r,h):h),h.startsWith("\\\\")?h="\\\\"+h.substr(2).replace(/\\/g,"/"):h=h.replace(/\\/g,"/"),typeof l=="boolean"&&l?(h.startsWith("\\\\")&&(h+="**"),t.push(n(h))):l&&l.when&&(f[h]=l)}),{globArgs:t,siblingClauses:f}}function m(i,r){return O.isAbsolute(r)?r:O.join(i,r)}function o(i){return i=b.rtrim(i,"\\"),b.rtrim(i,"/")}function n(i){return T.getRoot(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ye[383],_e([1,0,52,51,17,384,19,47,35,76,34,11,39,14,18,31,36,381,132]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const i=new Set;process.on("exit",()=>{i.forEach(h=>h())});class r{constructor(l){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=l,this.filePattern=l.filePattern||"",this.includePattern=l.includePattern&&p.parse(l.includePattern),this.maxResults=l.maxResults||null,this.exists=!!l.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=l.shouldGlobMatchFilePattern?null:(0,n.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=l.excludePattern&&p.parse(l.excludePattern),this.folderExcludePatterns=new Map,l.folderQueries.forEach(u=>{const d=Object.assign({},u.excludePattern||{},this.config.excludePattern||{}),g=u.folder.fsPath;l.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==g).forEach(D=>{(0,A.isEqualOrParent)(D,g)&&(d[L.relative(g,D)]=!0)}),this.folderExcludePatterns.set(g,new t(d,g))})}cancel(){this.isCanceled=!0,i.forEach(l=>l())}walk(l,u,d,g,D){if(this.fileWalkSW=v.StopWatch.create(!1),this.isCanceled)return D(null,this.isLimitHit);u.forEach(E=>{const _=L.basename(E.fsPath);this.globalExcludePattern&&this.globalExcludePattern(E.fsPath,_)||this.matchFile(d,{relativePath:E.fsPath,searchPath:void 0})}),this.cmdSW=v.StopWatch.create(!1),this.parallel(l,(E,_)=>{this.call(this.cmdTraversal,this,E,d,g,y=>{if(y){const P=(0,b.toErrorMessage)(y);console.error(P),this.errors.push(P),_(y,void 0)}else _(null,void 0)})},(E,_)=>{this.fileWalkSW.stop();const y=E?R.coalesce(E)[0]:null;D(y,this.isLimitHit)})}parallel(l,u,d){const g=new Array(l.length),D=new Array(l.length);let E=!1,_=0;if(l.length===0)return d(null,[]);l.forEach((y,P)=>{u(y,(k,z)=>{if(k?(E=!0,g[P]=null,D[P]=k):(g[P]=z,D[P]=null),++_===l.length)return d(E?D:null,g)})})}call(l,u,...d){try{l.apply(u,d)}catch(g){d[d.length-1](g)}}cmdTraversal(l,u,d,g){const D=l.folder.fsPath,E=I.isMacintosh,_=()=>x&&x.kill();i.add(_);let y=B=>{i.delete(_),y=()=>{},g(B)},P="";const k=this.initDirectoryTree(),z=(0,o.spawnRipgrepCmd)(this.config,l,this.config.includePattern,this.folderExcludePatterns.get(l.folder.fsPath).expression),x=z.cmd,F=!Object.keys(z.siblingClauses).length,N=z.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let M=`${z.rgDiskPath} ${N}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(M+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),d({message:M}),this.cmdResultCount=0,this.collectStdout(x,"utf8",d,(B,W,Y)=>{if(B){y(B);return}if(this.isLimitHit){y();return}const G=(P+(E?w.normalizeNFC(W||""):W)).split(`
`);if(Y){const Q=G.length;G[Q-1]=G[Q-1].trim(),G[Q-1]||G.pop()}else P=G.pop()||"";if(G.length&&G[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=G.length,F){for(const Q of G)if(this.matchFile(u,{base:D,relativePath:Q,searchPath:this.getSearchPath(l,Q)}),this.isLimitHit){_();break}(Y||this.isLimitHit)&&y();return}this.addDirectoryEntries(l,k,D,G,u),Y&&(this.matchDirectoryTree(k,D,u),y())})}spawnFindCmd(l){const u=this.folderExcludePatterns.get(l.folder.fsPath),d=u.getBasenameTerms(),g=u.getPathTerms(),D=["-L","."];if(d.length||g.length){D.push("-not","(","(");for(const E of d)D.push("-name",E),D.push("-o");for(const E of g)D.push("-path",E),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),c.spawn("find",D,{cwd:l.folder.fsPath})}readStdout(l,u,d){let g="";this.collectStdout(l,u,()=>{},(D,E,_)=>{if(D){d(D);return}g+=E,_&&d(null,g)})}collectStdout(l,u,d,g){let D=(y,P,k)=>{(y||k)&&(D=()=>{},this.cmdSW?.stop()),g(y,P,k)},E=!1;l.stdout?(this.forwardData(l.stdout,u,D),l.stdout.once("data",()=>E=!0)):d({message:"stdout is null"});let _;l.stderr?_=this.collectData(l.stderr):d({message:"stderr is null"}),l.on("error",y=>{D(y)}),l.on("close",y=>{let P;!E&&(P=this.decodeData(_,u))&&f(P)?D(new Error(`command failed with error code ${y}: ${this.decodeData(_,u)}`)):(this.exists&&y===0&&(this.isLimitHit=!0),D(null,"",!0))})}forwardData(l,u,d){const g=new T.StringDecoder(u);return l.on("data",D=>{d(null,g.write(D))}),g}collectData(l){const u=[];return l.on("data",d=>{u.push(d)}),u}decodeData(l,u){const d=new T.StringDecoder(u);return l.map(g=>d.write(g)).join("")}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries(l,{pathToEntries:u},d,g,D){g.indexOf(this.filePattern)!==-1&&this.matchFile(D,{base:d,relativePath:this.filePattern,searchPath:this.getSearchPath(l,this.filePattern)});const E=_=>{const y=L.basename(_),P=L.dirname(_);let k=u[P];k||(k=u[P]=[],E(P)),k.push({base:d,relativePath:_,basename:y,searchPath:this.getSearchPath(l,_)})};g.forEach(E)}matchDirectoryTree({rootEntries:l,pathToEntries:u},d,g){const D=this,E=this.folderExcludePatterns.get(d),_=this.filePattern;function y(P){D.directoriesWalked++;const k=(0,m.hasSiblingFn)(()=>P.map(z=>z.basename));for(let z=0,x=P.length;z<x;z++){const F=P[z],{relativePath:N,basename:M}=F;if(E.test(N,M,_!==M?k:void 0))continue;const B=u[N];if(B)y(B);else{if(D.filesWalked++,N===_)continue;D.matchFile(g,F)}if(D.isLimitHit)break}}y(l)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(l,u,d,g,D){const E=l.folder,_=(0,m.hasSiblingFn)(()=>d);this.parallel(d,(y,P)=>{if(this.isCanceled||this.isLimitHit)return P(null);const k=u?[u,y].join(L.sep):y;if(this.folderExcludePatterns.get(l.folder.fsPath).test(k,y,this.config.filePattern!==y?_:void 0))return P(null);const z=[E.fsPath,k].join(L.sep);O.lstat(z,(x,F)=>{if(x||this.isCanceled||this.isLimitHit)return P(null);this.statLinkIfNeeded(z,F,(N,M)=>N||this.isCanceled||this.isLimitHit?P(null):M.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(z,F,(B,W)=>B||this.isCanceled||this.isLimitHit||(W=W||"",this.walkedPaths[W])?P(null):(this.walkedPaths[W]=!0,a.Promises.readdir(z).then(Y=>{if(this.isCanceled||this.isLimitHit)return P(null);this.doWalk(l,k,Y,g,Z=>P(Z||null))},Y=>{P(null)})))):(this.filesWalked++,k===this.filePattern||this.maxFilesize&&S.isNumber(M.size)&&M.size>this.maxFilesize||this.matchFile(g,{base:E.fsPath,relativePath:k,searchPath:this.getSearchPath(l,k)}),P(null,void 0)))})},y=>{const P=y&&R.coalesce(y);return D(P&&P.length>0?P[0]:void 0)})}matchFile(l,u){this.isFileMatch(u)&&(!this.includePattern||this.includePattern(u.relativePath,L.basename(u.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||l(u))}isFileMatch(l){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,m.isFilePatternMatch)(l,this.normalizedFilePatternLowercase);if(this.filePattern)return(0,m.isFilePatternMatch)(l,this.filePattern,!1)}return!0}statLinkIfNeeded(l,u,d){return u.isSymbolicLink()?O.stat(l,d):d(null,u)}realPathIfNeeded(l,u,d){return u.isSymbolicLink()?O.realpath(l,(g,D)=>g?d(g):d(null,D)):d(null,l)}getSearchPath(l,u){return l.folderName?L.join(l.folderName,u):u}}e.FileWalker=r;class s{constructor(l){this.folderQueries=l.folderQueries,this.extraFiles=l.extraFileResources||[],this.walker=new r(l)}search(l,u,d){this.walker.walk(this.folderQueries,this.extraFiles,l,u,(g,D)=>{d(g,{limitHit:D,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=s;class t{constructor(l,u){this.expression=l,this.root=u,this.init(l)}init(l){let u,d;Object.keys(l).filter(g=>l[g]).forEach(g=>{L.isAbsolute(g)?(u=u||p.getEmptyExpression(),u[g]=l[g]):(d=d||p.getEmptyExpression(),d[g]=l[g])}),this.absoluteParsedExpr=u&&p.parse(u,{trimForExclusions:!0}),this.relativeParsedExpr=d&&p.parse(d,{trimForExclusions:!0})}test(l,u,d){return this.relativeParsedExpr&&this.relativeParsedExpr(l,u,d)||this.absoluteParsedExpr&&this.absoluteParsedExpr(L.join(this.root,l),u,d)}getBasenameTerms(){const l=[];return this.absoluteParsedExpr&&l.push(...p.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&l.push(...p.getBasenameTerms(this.relativeParsedExpr)),l}getPathTerms(){const l=[];return this.absoluteParsedExpr&&l.push(...p.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&l.push(...p.getPathTerms(this.relativeParsedExpr)),l}}function f(h){const l=h.trim().split(`
`),u=l[0].trim();if(u.startsWith("Error parsing regex"))return u;if(u.startsWith("regex parse error"))return C.uppercaseFirstLetter(l[l.length-1].trim());if(u.startsWith("error parsing glob")||u.startsWith("unsupported encoding"))return u.charAt(0).toUpperCase()+u.substr(1);if(u==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(u.startsWith("Literal "))return u}}),define(ye[385],_e([1,0,98,21,193,22]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.isUTFEncoding=R,e.toDecodeStream=S,e.toEncodeReadable=a,e.encodingExists=m,e.toNodeEncoding=o,e.detectEncodingByBOMFromBuffer=n,e.toCanonicalName=h,e.detectEncodingFromBuffer=l,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function R(u){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(d=>d===u)}e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const b=512,p=512,w=512*8,A=512*128;var I;(function(u){u[u.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class v extends Error{constructor(d,g){super(d),this.decodeStreamErrorKind=g}}e.DecodeStreamError=v;class C{static async create(d){let g;if(d!==e.UTF8)g=(await(0,L.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(d));else{const D=new TextDecoder;g={write(E){return D.decode(E,{stream:!0})},end(){return D.decode()}}}return new C(g)}constructor(d){this.iconvLiteDecoder=d}write(d){return this.iconvLiteDecoder.write(d)}end(){return this.iconvLiteDecoder.end()}}function S(u,d){const g=d.minBytesRequiredForDetection??d.guessEncoding?w:p;return new Promise((D,E)=>{const _=(0,c.newWriteableStream)(F=>F.join("")),y=[];let P=0,k;const z=new T.CancellationTokenSource,x=async()=>{try{const F=await l({buffer:O.VSBuffer.concat(y),bytesRead:P},d.guessEncoding);if(F.seemsBinary&&d.acceptTextOnly)throw new v("Stream is binary but only text is accepted for decoding",1);F.encoding=await d.overwriteEncoding(F.encoding),k=await C.create(F.encoding);const N=k.write(O.VSBuffer.concat(y).buffer);_.write(N),y.length=0,P=0,D({stream:_,detected:F})}catch(F){z.cancel(),_.destroy(),E(F)}};(0,c.listenStream)(u,{onData:async F=>{k?_.write(k.write(F.buffer)):(y.push(F),P+=F.byteLength,P>=g&&(u.pause(),await x(),setTimeout(()=>u.resume())))},onError:F=>_.error(F),onEnd:async()=>{k||await x(),_.end(k?.end())}},z.token)})}async function a(u,d,g){const E=(await(0,L.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(d),g);let _=!1,y=!1;return{read(){if(y)return null;const P=u.read();if(typeof P!="string"){if(y=!0,!_&&g?.addBOM)switch(d){case e.UTF8:case e.UTF8_with_bom:return O.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return O.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return O.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const k=E.end();return k&&k.length>0?(_=!0,O.VSBuffer.wrap(k)):null}return _=!0,O.VSBuffer.wrap(E.write(P))}}}async function m(u){return(await(0,L.importAMDNodeModule)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(u))}function o(u){return u===e.UTF8_with_bom||u===null?e.UTF8:u}function n(u,d){if(!u||d<e.UTF16be_BOM.length)return null;const g=u.readUInt8(0),D=u.readUInt8(1);if(g===e.UTF16be_BOM[0]&&D===e.UTF16be_BOM[1])return e.UTF16be;if(g===e.UTF16le_BOM[0]&&D===e.UTF16le_BOM[1])return e.UTF16le;if(d<e.UTF8_BOM.length)return null;const E=u.readUInt8(2);return g===e.UTF8_BOM[0]&&D===e.UTF8_BOM[1]&&E===e.UTF8_BOM[2]?e.UTF8_with_bom:null}const i=["ascii","utf-16","utf-32"];async function r(u){const d=await(0,L.importAMDNodeModule)("jschardet","dist/jschardet.min.js"),g=u.slice(0,A),D=f(g.buffer),E=d.detect(D);if(!E||!E.encoding)return null;const _=E.encoding.toLowerCase();return 0<=i.indexOf(_)?null:t(E.encoding)}const s={ibm866:"cp866",big5:"cp950"};function t(u){const d=u.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return s[d]||d}function f(u){let d="";for(let g=0;g<u.length;g++)d+=String.fromCharCode(u[g]);return d}function h(u){switch(u){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const d=u.match(/windows(\d+)/);return d?"windows-"+d[1]:u}}}function l({buffer:u,bytesRead:d},g){let D=n(u,d),E=!1;if(D!==e.UTF16be&&D!==e.UTF16le&&u){let _=!0,y=!0,P=!1;for(let k=0;k<d&&k<b;k++){const z=k%2===1,x=u.readUInt8(k)===0;if(x&&(P=!0),_&&(z&&!x||!z&&x)&&(_=!1),y&&(z&&x||!z&&!x)&&(y=!1),x&&!_&&!y)break}P&&(_?D=e.UTF16le:y?D=e.UTF16be:E=!0)}return g&&!E&&!D&&u?r(u.slice(0,d)).then(_=>({seemsBinary:!1,encoding:_})):{seemsBinary:E,encoding:D}}e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[160],_e([1,0,385,31,159]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class T extends L.TextSearchManager{constructor(b,p,w=O,A="searchProcess"){super({query:b,provider:p},{readdir:I=>w.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,c.toCanonicalName)(I)},A)}}e.NativeTextSearchManager=T}),define(ye[161],_e([1,0,52,401,384,19,73,35,14,2,36,94,402,382,122]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepParser=e.RipgrepTextSearchEngine=void 0,e.getRgArgs=t,e.unicodeEscapesToPCRE2=h,e.fixRegexNewline=u,e.fixNewline=d,e.performBraceExpansionForRipgrep=D;const a=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(_){this.outputChannel=_}provideTextSearchResults(_,y,P,k){return this.outputChannel.appendLine(`provideTextSearchResults ${_.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((z,x)=>{k.onCancellationRequested(()=>G());const F=t(_,y),N=y.folder.fsPath,M=F.map(Ie=>Ie.match(/^-/)?Ie:`'${Ie}'`).join(" ");this.outputChannel.appendLine(`${a} ${M}
 - cwd: ${N}`);let B=c.spawn(a,F,{cwd:N});B.on("error",Ie=>{console.error(Ie),this.outputChannel.appendLine("Error: "+(Ie&&Ie.message)),x((0,A.serializeSearchError)(new A.SearchError(Ie&&Ie.message,A.SearchErrorCode.rgProcessError)))});let W=!1;const Y=new i(y.maxResults,y.folder,y.previewOptions);Y.on("result",Ie=>{W=!0,re="",P.report(Ie)});let Z=!1;const G=()=>{Z=!0,B?.kill(),Y?.cancel()};let Q=!1;Y.on("hitLimit",()=>{Q=!0,G()});let re="";B.stdout.on("data",Ie=>{Y.handleData(Ie),W||(re+=Ie)});let te=!1;B.stdout.once("data",()=>te=!0);let ve="";B.stderr.on("data",Ie=>{const J=Ie.toString();this.outputChannel.appendLine(J),ve.length+J.length<1e6&&(ve+=J)}),B.on("close",()=>{if(this.outputChannel.appendLine(te?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(W?"Got result from parser":"No result from parser"),re&&this.outputChannel.appendLine(`Got data without result: ${re}`),this.outputChannel.appendLine(""),Z)z({limitHit:Q});else{Y.flush(),B=null;let Ie;ve&&!te&&(Ie=o(ve))?x((0,A.serializeSearchError)(new A.SearchError(Ie.message,Ie.code))):z({limitHit:Q})}})})}}e.RipgrepTextSearchEngine=m;function o(E){const _=E.split(`
`),y=_[0].trim();if(_.some(k=>k.startsWith("regex parse error")))return new A.SearchError(n(_),A.SearchErrorCode.regexParseError);const P=y.match(/grep config error: unknown encoding: (.*)/);if(P)return new A.SearchError(`Unknown encoding: ${P[1]}`,A.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new A.SearchError(y.charAt(0).toUpperCase()+y.substr(1),A.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new A.SearchError(y.charAt(0).toUpperCase()+y.substr(1),A.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new A.SearchError(y,A.SearchErrorCode.regexParseError)}function n(E){const _=["Regex parse error"],y=E.filter(P=>P.startsWith("PCRE2:"));if(y.length>=1){const P=y[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const k=P.split(":")[1];_.push(":"+k)}}return _.join("")}class i extends O.EventEmitter{constructor(_,y,P){super(),this.maxResults=_,this.root=y,this.previewOptions=P,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new L.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(_,y){return super.on(_,y),this}handleData(_){if(this.isDone)return;const y=typeof _=="string"?_:this.stringDecoder.write(_);this.handleDecodedData(y)}handleDecodedData(_){let y=_.indexOf(`
`);const P=this.remainder+_;if(y>=0)y+=this.remainder.length;else{this.remainder=P;return}let k=0;for(;y>=0;)this.handleLine(P.substring(k,y).trim()),k=y+1,y=P.indexOf(`
`,k);this.remainder=P.substring(k)}handleLine(_){if(this.isDone||!_)return;let y;try{y=JSON.parse(_)}catch{throw new Error(`malformed line from rg: ${_}`)}if(y.type==="match"){const P=r(y.data.path),k=w.URI.joinPath(this.root,P),z=this.createTextSearchMatch(y.data,k);this.onResult(z),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const P=r(y.data.path),k=w.URI.joinPath(this.root,P);this.createTextSearchContext(y.data,k).forEach(x=>this.onResult(x))}}createTextSearchMatch(_,y){const P=_.line_number-1,k=r(_.lines),z=Buffer.from(k);let x=0,F=0,N=P;_.submatches.length===0&&_.submatches.push(k.length?{start:0,end:1,match:{text:k[0]}}:{start:0,end:0,match:{text:""}});const M=(0,T.coalesce)(_.submatches.map((B,W)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const Y=r(B.match),Z=z.slice(x,B.start).toString(),G=s(Z),Q=G.numLines>0?G.lastLineLength:G.lastLineLength+F,re=s(Y),te=G.numLines+N,ve=re.numLines+te,Ie=re.numLines>0?re.lastLineLength:re.lastLineLength+Q;return x=B.end,F=Ie,N=ve,new I.Range(te,Q,ve,Ie)}));return(0,S.createTextSearchResult)(y,k,M,this.previewOptions)}createTextSearchContext(_,y){const P=r(_.lines),k=_.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((z,x)=>({text:z,uri:y,lineNumber:k+x}))}onResult(_){this.emit("result",_)}}e.RipgrepParser=i;function r(E){return E.bytes?Buffer.from(E.bytes,"base64").toString():E.text}function s(E){const _=/\n/g;let y=0,P=-1,k;for(;k=_.exec(E);)y++,P=k.index;const z=P>=0?E.length-P-1:E.length;return{numLines:y,lastLineLength:z}}function t(E,_){const y=["--hidden","--no-require-git"];y.push(E.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:k}=(0,R.groupBy)(_.includes,x=>x.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(k&&k.length){const x=new Set;k.forEach(F=>{x.add(F)}),y.push("-g","!*"),x.forEach(F=>{f(F).map(S.anchorGlob).forEach(N=>{y.push("-g",N)})})}P&&P.length&&P.forEach(x=>{y.push("-g",x)}),_.excludes.map(S.anchorGlob).forEach(x=>y.push("-g",`!${x}`)),_.maxFileSize&&y.push("--max-filesize",_.maxFileSize+""),_.useIgnoreFiles?_.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),_.followSymlinks&&y.push("--follow"),_.encoding&&_.encoding!=="utf8"&&y.push("--encoding",_.encoding),E.pattern==="--"&&(E.isRegExp=!0,E.pattern="\\-\\-"),E.isMultiline&&!E.isRegExp&&(E.pattern=(0,p.escapeRegExpCharacters)(E.pattern),E.isRegExp=!0),_.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),E.isRegExp&&(E.pattern=h(E.pattern),y.push("--engine","auto"));let z;if(E.isWordMatch){const F=(0,p.createRegExp)(E.pattern,!!E.isRegExp,{wholeWord:E.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",F)}else if(E.isRegExp){let x=u(E.pattern);x=d(x),y.push("--regexp",x)}else z=E.pattern,y.push("--fixed-strings");return y.push("--no-config"),_.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),E.isMultiline&&y.push("--multiline"),_.beforeContext&&y.push("--before-context",_.beforeContext+""),_.afterContext&&y.push("--after-context",_.afterContext+""),y.push("--"),z&&y.push(z),y.push("."),y}function f(E){return D(E).flatMap(y=>{const P=(0,b.splitGlobAware)(y,"/");return P.map((k,z)=>P.slice(0,z+1).join("/"))})}function h(E){const _=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;E.match(_);)E=E.replace(_,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;E.match(y);)E=E.replace(y,"$1\\x{$2}");return E}const l=E=>E.type==="Assertion"&&E.kind==="lookbehind";function u(E){let _;try{_=new v.RegExpParser().parsePattern(E)}catch{return E}let y="",P=0;const k=(F,N,M)=>{y+=E.slice(P,F)+M,P=N},z=[];return new v.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const N=z[0];if(!N)k(F.start,F.end,"\\r?\\n");else if(!z.some(l))if(N.type==="CharacterClass")if(N.negate){const M=E.slice(N.start+2,F.start)+E.slice(F.end,N.end-1);N.parent?.type==="Quantifier"?k(N.start,N.end,M?`[^${M}]`:"."):k(N.start,N.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=E.slice(N.start+1,F.start)+E.slice(F.end,N.end-1);k(N.start,N.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else N.type==="Quantifier"&&k(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){z.unshift(F)},onQuantifierLeave(){z.shift()},onCharacterClassRangeEnter(F){z.unshift(F)},onCharacterClassRangeLeave(){z.shift()},onCharacterClassEnter(F){z.unshift(F)},onCharacterClassLeave(){z.shift()},onAssertionEnter(F){l(F)&&z.push(F)},onAssertionLeave(F){z[0]===F&&z.shift()}}).visit(_),y+=E.slice(P),y}function d(E){return E.replace(/\n/g,"\\r?\\n")}function g(E){let _=!1,y=!1,P="",k="";for(let z=0;z<E.length;z++){const x=E[z];switch(x){case"\\":y?(_?k+="\\"+x:P+="\\"+x,y=!1):y=!0;break;case"{":if(y)_?k+=x:P+=x,y=!1;else{if(_)return{strInBraces:P+"{"+k+"{"+E.substring(z+1)};_=!0}break;case"}":if(y)_?k+=x:P+=x,y=!1;else{if(_)return{fixedStart:P,strInBraces:k,fixedEnd:E.substring(z+1)};P+=x}break;default:_?k+=(y?"\\":"")+x:P+=(y?"\\":"")+x,y=!1;break}}return{strInBraces:P+(_?"{"+k:"")}}function D(E){const{fixedStart:_,strInBraces:y,fixedEnd:P}=g(E);if(_===void 0||P===void 0)return[y];let k=(0,b.splitGlobAware)(y,",");k.length||(k=[""]);const z=D(P);return k.flatMap(x=>{const F=_+x;return z.map(N=>F+N)})}}),define(ye[386],_e([1,0,22,161,108,15]),function(de,e,c,O,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class R{constructor(w){this.outputChannel=w,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(w,A,I,v){const C=new O.RipgrepTextSearchEngine(this.outputChannel);if(A.folder.scheme===T.Schemas.vscodeUserData){const S={...A,folder:A.folder.with({scheme:T.Schemas.file})},a=new L.Progress(m=>I.report({...m,uri:m.uri.with({scheme:A.folder.scheme})}));return this.withToken(v,m=>C.provideTextSearchResults(w,S,a,m))}else return this.withToken(v,S=>C.provideTextSearchResults(w,A,I,S))}async withToken(w,A){const I=b(w);this.inProgress.add(I);const v=await A(I.token);return this.inProgress.delete(I),v}dispose(){this.inProgress.forEach(w=>w.cancel())}}e.RipgrepSearchProvider=R;function b(p){const w=new c.CancellationTokenSource;return p.onCancellationRequested(()=>w.cancel()),w}}),define(ye[387],_e([1,0,31,161,160]),function(de,e,c,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class T{constructor(p){this.query=p}search(p,w,A){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(C){A({message:C})}},v=new L.NativeTextSearchManager(this.query,new O.RipgrepTextSearchEngine(I),c);return new Promise((C,S)=>v.search(a=>{w(a.map(R))},p).then(a=>C({limitHit:a.limitHit,type:"success",stats:a.stats}),S))}}e.TextSearchEngineAdapter=T;function R(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce((p,w)=>{if(w.ranges){const A=w;return p+(Array.isArray(A.ranges)?A.ranges.length:1)}else return p+1},0)}}}),define(ye[388],_e([1,0,19,8,13,4,132,17,39,2,32,36,383,387]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class S{static{this.BATCH_SIZE=512}constructor(r="searchProcess"){this.processType=r,this.caches=Object.create(null)}fileSearch(r){let s;const t=o(r),f=new T.Emitter({onDidAddFirstListener:()=>{s=(0,O.createCancelablePromise)(h=>this.doFileSearchWithEngine(v.Engine,t,l=>f.fire(l),h)),s.then(h=>f.fire(h),h=>f.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return f.event}textSearch(r){let s;const t=o(r),f=new T.Emitter({onDidAddFirstListener:()=>{s=(0,O.createCancelablePromise)(h=>this.ripgrepTextSearch(t,l=>f.fire(l),h)),s.then(h=>f.fire(h),h=>f.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return f.event}ripgrepTextSearch(r,s,t){return r.maxFileSize=this.getPlatformFileLimits().maxFileSize,new C.TextSearchEngineAdapter(r).search(t,s,s)}getPlatformFileLimits(){return{maxFileSize:16*A.ByteSize.GB}}doFileSearch(r,s,t){return this.doFileSearchWithEngine(v.Engine,r,s,t)}doFileSearchWithEngine(r,s,t,f,h=S.BATCH_SIZE){let l=0;const u=g=>{Array.isArray(g)?(l+=g.length,t(g.map(D=>this.rawMatchToSearchItem(D)))):g.relativePath?(l++,t(this.rawMatchToSearchItem(g))):t(g)};if(s.sortByScore){let g=this.trySortedSearchFromCache(s,u,f);if(!g){const D=s.maxResults?Object.assign({},s,{maxResults:null}):s,E=new r(D);g=this.doSortedSearch(E,s,t,u,f)}return new Promise((D,E)=>{g.then(([_,y])=>{const P=y.map(k=>this.rawMatchToSearchItem(k));this.sendProgress(P,t,h),D(_)},E)})}const d=new r(s);return this.doSearch(d,u,h,f).then(g=>({limitHit:g.limitHit,type:"success",stats:{detailStats:g.stats,type:this.processType,fromCache:!1,resultCount:l,sortingTime:void 0}}))}rawMatchToSearchItem(r){return{path:r.base?(0,b.join)(r.base,r.relativePath):r.relativePath}}doSortedSearch(r,s,t,f,h){const l=new T.Emitter;let u=(0,O.createCancelablePromise)(g=>{let D=[];const E=_=>{Array.isArray(_)?D=_:(f(_),l.fire(_))};return this.doSearch(r,E,-1,g).then(_=>[_,D])}),d;if(s.cacheKey){d=this.getOrCreateCache(s.cacheKey);const g={promise:u,event:l.event,resolved:!1};d.resultsToSearchCache[s.filePattern||""]=g,u.then(()=>{g.resolved=!0},D=>{delete d.resultsToSearchCache[s.filePattern||""]}),u=this.preventCancellation(u)}return u.then(([g,D])=>{const E=d?d.scorerCache:Object.create(null),_=(typeof s.maxResults!="number"||s.maxResults>0)&&p.StopWatch.create(!1);return this.sortResults(s,D,E,h).then(y=>{const P=_?_.elapsed():-1;return[{type:"success",stats:{detailStats:g.stats,sortingTime:P,fromCache:!1,type:this.processType,workspaceFolderCount:s.folderQueries.length,resultCount:y.length},messages:g.messages,limitHit:g.limitHit||typeof s.maxResults=="number"&&D.length>s.maxResults},y]})})}getOrCreateCache(r){const s=this.caches[r];return s||(this.caches[r]=new a)}trySortedSearchFromCache(r,s,t){const f=r.cacheKey&&this.caches[r.cacheKey];if(!f)return;const h=this.getResultsFromCache(f,r.filePattern||"",s,t);if(h)return h.then(([l,u,d])=>{const g=p.StopWatch.create(!1);return this.sortResults(r,u,f.scorerCache,t).then(D=>{const E=g.elapsed(),_={fromCache:!0,detailStats:d,type:this.processType,resultCount:u.length,sortingTime:E};return[{type:"success",limitHit:l.limitHit||typeof r.maxResults=="number"&&u.length>r.maxResults,stats:_},D]})})}sortResults(r,s,t,f){const h=(0,R.prepareQuery)(r.filePattern||""),l=(d,g)=>(0,R.compareItemsByFuzzyScore)(d,g,h,!0,m,t),u=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return c.topAsync(s,l,u,1e4,f)}sendProgress(r,s,t){if(t&&t>0)for(let f=0;f<r.length;f+=t)s(r.slice(f,f+t));else s(r)}getResultsFromCache(r,s,t,f){const h=p.StopWatch.create(!1),l=s.indexOf(b.sep)>=0;let u;for(const E in r.resultsToSearchCache)if(s.startsWith(E)){if(l&&E.indexOf(b.sep)<0&&E!=="")continue;const _=r.resultsToSearchCache[E];u={promise:this.preventCancellation(_.promise),event:_.event,resolved:_.resolved};break}if(!u)return null;const d=h.elapsed(),g=p.StopWatch.create(!1),D=u.event(t);return f&&f.onCancellationRequested(()=>{D.dispose()}),u.promise.then(([E,_])=>{if(f&&f.isCancellationRequested)throw(0,L.canceled)();const y=[],P=(0,R.prepareQuery)(s).normalizedLowercase;for(const k of _)(0,I.isFilePatternMatch)(k,P)&&y.push(k);return[E,y,{cacheWasResolved:u.resolved,cacheLookupTime:d,cacheFilterTime:g.elapsed(),cacheEntryCount:_.length}]})}doSearch(r,s,t,f){return new Promise((h,l)=>{let u=[];f?.onCancellationRequested(()=>r.cancel()),r.search(d=>{d&&(t?(u.push(d),t>0&&u.length>=t&&(s(u),u=[])):s(d))},d=>{s(d)},(d,g)=>{u.length&&s(u),d?(s({message:"Search finished. Error: "+d.message}),l(d)):(s({message:"Search finished. Stats: "+JSON.stringify(g.stats)}),h(g))})})}clearCache(r){return delete this.caches[r],Promise.resolve(void 0)}preventCancellation(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,t){return r.then(s,t)}catch(s){return this.then(void 0,s)}finally(s){return r.finally(s)}}}}e.SearchService=S;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(i){return(0,b.basename)(i.relativePath)}getItemDescription(i){return(0,b.dirname)(i.relativePath)}getItemPath(i){return i.relativePath}};function o(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(r=>w.URI.revive(r))}}function n(i){return{...i,folder:w.URI.revive(i.folder)}}}),define(ye[389],_e([1,0,3,15,2,31,12,28,20,97,66,36,388,386,122,160]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let m=class extends w.ExtHostSearch{constructor(n,i,r,s){super(n,r,s),this._pfs=T,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1,this._disposables=new c.DisposableStore;const t=new S.OutputChannel("RipgrepSearchUD",this._logService);this._disposables.add(this.registerTextSearchProvider(O.Schemas.vscodeUserData,new C.RipgrepSearchProvider(t))),i.remote.isRemote&&i.remote.authority&&this._registerEHSearchProviders()}dispose(){this._disposables.dispose()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const n=new S.OutputChannel("RipgrepSearchEH",this._logService);this._disposables.add(this.registerTextSearchProvider(O.Schemas.file,new C.RipgrepSearchProvider(n))),this._disposables.add(this.registerInternalFileSearchProvider(O.Schemas.file,new v.SearchService("fileSearchProvider")))}registerInternalFileSearchProvider(n,i){const r=this._handlePool++;return this._internalFileSearchProvider=i,this._internalFileSearchHandle=r,this._proxy.$registerFileSearchProvider(r,this._transformScheme(n)),(0,c.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(r)})}$provideFileSearchResults(n,i,r,s){const t=(0,w.reviveQuery)(r);if(n===this._internalFileSearchHandle){const f=Date.now();return this.doInternalFileSearch(n,i,t,s).then(h=>{const l=Date.now()-f;return this._logService.debug(`Ext host file search time: ${l}ms`),h})}return super.$provideFileSearchResults(n,i,r,s)}doInternalFileSearchWithCustomCallback(n,i,r){const s=t=>{if((0,I.isSerializedFileMatch)(t)&&(t=[t]),Array.isArray(t)){r(t.map(f=>L.URI.file(f.path)));return}t.message&&this._logService.debug("ExtHostSearch",t.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(n,s,i)}async doInternalFileSearch(n,i,r,s){return this.doInternalFileSearchWithCustomCallback(r,s,t=>{this._proxy.$handleFileMatch(n,i,t)})}$clearCache(n){return this._internalFileSearchProvider?.clearCache(n),super.$clearCache(n)}createTextSearchManager(n,i){return new a.NativeTextSearchManager(n,i,void 0,"textSearchProvider")}};e.NativeExtHostSearch=m,e.NativeExtHostSearch=m=Ge([Ue(0,p.IExtHostRpcService),Ue(1,b.IExtHostInitDataService),Ue(2,A.IURITransformerService),Ue(3,R.ILogService)],m)}),define(ye[123],_e([1,0,403,62,63,404,21,13,4,3,17,11,30,81,82]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=h,e.createStaticIPCHandle=l,e.serve=g,e.connect=D;class a{traceSocketEvent(_,y){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,_,y)}constructor(_,y=""){this._canWrite=!0,this.debugLabel=y,this.socket=_,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,b.onUnexpectedError)(P)}},this.socket.on("error",this._errorListener),this._closeListener=P=>{this.traceSocketEvent("close",{hadError:P}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(_){const y=P=>{this.traceSocketEvent("read",P),_(R.VSBuffer.wrap(P))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(_){const y=P=>{_({type:0,hadError:P,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(_){const y=()=>{_()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(_){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",_),this.socket.write(_.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,b.onUnexpectedError)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,b.onUnexpectedError)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((_,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),_();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),_()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.NodeSocket=a;var m;(function(E){E[E.MinHeaderByteSize=2]="MinHeaderByteSize",E[E.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var o;(function(E){E[E.PeekHeader=1]="PeekHeader",E[E.ReadHeader=2]="ReadHeader",E[E.ReadBody=3]="ReadBody",E[E.Fin=4]="Fin"})(o||(o={}));class n extends w.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(_,y){this.socket.traceSocketEvent(_,y)}constructor(_,y,P,k){super(),this._onData=this._register(new p.Emitter),this._onClose=this._register(new p.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=_,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:P?.byteLength||0,recordInflateBytes:k}),this._flowManager=this._register(new i(this,y,P,k,this._onData,(z,x)=>this._write(z,x))),this._register(this._flowManager.onError(z=>{console.error(z),(0,b.onUnexpectedError)(z),this._onClose.fire({type:0,hadError:!0,error:z})})),this._incomingData=new S.ChunkStream,this._register(this.socket.onData(z=>this._acceptChunk(z))),this._register(this.socket.onClose(async z=>{this._flowManager.isProcessingReadQueue()&&await p.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(z)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(_){return this._onData.event(_)}onClose(_){return this._onClose.event(_)}onEnd(_){return this.socket.onEnd(_)}write(_){let y=0;for(;y<_.byteLength;)this._flowManager.writeMessage(_.slice(y,Math.min(y+262144,_.byteLength)),{compressed:!0,opcode:2}),y+=262144}_write(_,{compressed:y,opcode:P}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",_);let k=2;_.byteLength<126?k+=0:_.byteLength<2**16?k+=2:k+=8;const z=R.VSBuffer.alloc(k),x=y?64:0,F=P&15;if(z.writeUInt8(128|x|F,0),_.byteLength<126)z.writeUInt8(_.byteLength,1);else if(_.byteLength<2**16){z.writeUInt8(126,1);let N=1;z.writeUInt8(_.byteLength>>>8&255,++N),z.writeUInt8(_.byteLength>>>0&255,++N)}else{z.writeUInt8(127,1);let N=1;z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(_.byteLength>>>24&255,++N),z.writeUInt8(_.byteLength>>>16&255,++N),z.writeUInt8(_.byteLength>>>8&255,++N),z.writeUInt8(_.byteLength>>>0&255,++N)}this.socket.write(R.VSBuffer.concat([z,_]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(_){if(_.byteLength!==0){for(this._incomingData.acceptChunk(_);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const y=this._incomingData.peek(this._state.readLen),P=y.readUInt8(0),k=(P&128)>>>7,z=(P&64)>>>6,x=P&15,F=y.readUInt8(1),N=(F&128)>>>7,M=F&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(M===126?2:0)+(M===127?8:0),this._state.fin=k,this._state.firstFrameOfMessage&&(this._state.compressed=!!z),this._state.firstFrameOfMessage=!!k,this._state.mask=0,this._state.opcode=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const y=this._incomingData.read(this._state.readLen),P=y.readUInt8(1),k=(P&128)>>>7;let z=P&127,x=1;z===126?z=y.readUInt8(++x)*2**8+y.readUInt8(++x):z===127&&(z=y.readUInt8(++x)*0+y.readUInt8(++x)*0+y.readUInt8(++x)*0+y.readUInt8(++x)*0+y.readUInt8(++x)*2**24+y.readUInt8(++x)*2**16+y.readUInt8(++x)*2**8+y.readUInt8(++x));let F=0;k&&(F=y.readUInt8(++x)*2**24+y.readUInt8(++x)*2**16+y.readUInt8(++x)*2**8+y.readUInt8(++x)),this._state.state=3,this._state.readLen=z,this._state.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const y=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),t(y,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(y,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await p.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=n;class i extends w.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:R.VSBuffer.alloc(0)}constructor(_,y,P,k,z,x){super(),this._tracer=_,this._onData=z,this._writeFn=x,this._onError=this._register(new p.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new p.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new p.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,y?(this._zlibInflateStream=this._register(new r(this._tracer,k,P,{windowBits:15})),this._zlibDeflateStream=this._register(new s(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(F=>this._onError.fire(F))),this._register(this._zlibDeflateStream.onError(F=>this._onError.fire(F)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(_,y){this._writeQueue.push({data:_,options:y}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:_,options:y}=this._writeQueue.shift();if(this._zlibDeflateStream&&y.compressed){const P=await this._deflateMessage(this._zlibDeflateStream,_);this._writeFn(P,y)}else this._writeFn(_,{...y,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(_,y){return new Promise((P,k)=>{_.write(y),_.flush(z=>P(z))})}acceptFrame(_,y,P){this._readQueue.push({data:_,isCompressed:y,isLastFrameOfMessage:P}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const _=this._readQueue.shift();if(this._zlibInflateStream&&_.isCompressed){const y=await this._inflateFrame(this._zlibInflateStream,_.data,_.isLastFrameOfMessage);this._onData.fire(y)}else this._onData.fire(_.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(_,y,P){return new Promise((k,z)=>{_.write(y),P&&_.write(R.VSBuffer.fromByteArray([0,0,255,255])),_.flush(x=>k(x))})}}class r extends w.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.concat(this._recordedInflateBytes):R.VSBuffer.alloc(0)}constructor(_,y,P,k){super(),this._tracer=_,this._recordInflateBytes=y,this._onError=this._register(new p.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,T.createInflateRaw)(k),this._zlibInflate.on("error",z=>{this._tracer.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this._onError.fire(z)}),this._zlibInflate.on("data",z=>{this._tracer.traceSocketEvent("zlibInflateData",z),this._pendingInflateData.push(R.VSBuffer.wrap(z))}),P&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this._zlibInflate.write(P.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(_){this._recordInflateBytes&&this._recordedInflateBytes.push(_.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",_),this._zlibInflate.write(_.buffer)}flush(_){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const y=R.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,_(y)})}}class s extends w.Disposable{constructor(_,y){super(),this._tracer=_,this._onError=this._register(new p.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,T.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",P=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this._onError.fire(P)}),this._zlibDeflate.on("data",P=>{this._tracer.traceSocketEvent("zlibDeflateData",P),this._pendingDeflateData.push(R.VSBuffer.wrap(P))})}write(_){this._tracer.traceSocketEvent("zlibDeflateWrite",_.buffer),this._zlibDeflate.write(_.buffer)}flush(_){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let y=R.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,y=y.slice(0,y.byteLength-4),_(y)})}}function t(E,_){if(_===0)return;const y=E.byteLength>>>2;for(let N=0;N<y;N++){const M=E.readUInt32BE(N*4);E.writeUInt32BE(M^_,N*4)}const P=y*4,k=E.byteLength-P,z=_>>>24&255,x=_>>>16&255,F=_>>>8&255;k>=1&&E.writeUInt8(E.readUInt8(P)^z,P),k>=2&&E.writeUInt8(E.readUInt8(P+1)^x,P+1),k>=3&&E.writeUInt8(E.readUInt8(P+2)^F,P+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const f={2:107,1:103};function h(){const E=(0,v.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${E}-sock`;const _=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,L.tmpdir)(),y=(0,A.join)(_,`vscode-ipc-${E}.sock`);return u(y),y}function l(E,_,y){const k=(0,c.createHash)("sha256").update(E).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${k}-${y}-${_}-sock`;const z=y.substr(0,4),x=_.substr(0,6);let F;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${k}-${z}-${x}.sock`):F=(0,A.join)(E,`${z}-${x}.sock`),u(F),F}function u(E){const _=f[I.platform];typeof _=="number"&&E.length>=_&&console.warn(`WARNING: IPC handle "${E}" is longer than ${_} chars, try a shorter --user-data-dir`)}class d extends C.IPCServer{static toClientConnectionEvent(_){const y=p.Event.fromNodeEventEmitter(_,"connection");return p.Event.map(y,P=>({protocol:new S.Protocol(new a(P,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(P,"close"))}))}constructor(_){super(d.toClientConnectionEvent(_)),this.server=_}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=d;function g(E){return new Promise((_,y)=>{const P=(0,O.createServer)();P.on("error",y),P.listen(E,()=>{P.removeListener("error",y),_(new d(P))})})}function D(E,_){return new Promise((y,P)=>{const k=(0,O.createConnection)(E,()=>{k.removeListener("error",P),y(S.Client.fromSocket(new a(k,`ipc-client${_}`),_))});k.once("error",P)})}}),define(ye[390],_e([1,0,62,63,173,123,8,3,11,53,12,139,266,267,110,88,21]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function o(t,f,h,l,u){let d;for(let g=3;g&&(d?.dispose(),d=await new n(t,f,h,l,u).waitForReady(),!(u&&L.BROWSER_RESTRICTED_PORTS[u]||!L.BROWSER_RESTRICTED_PORTS[d.tunnelLocalPort]));g--);return d}class n extends b.Disposable{constructor(f,h,l,u,d){super(),this.defaultTunnelHost=h,this.suggestedLocalPort=d,this.privacy=a.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=f,this._server=c.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=g=>this._onConnection(g),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=u,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){const f=this.suggestedLocalPort??this.tunnelRemotePort,h=(0,a.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let l=await(0,L.findFreePortFaster)(f,2,1e3,h),u=null;return this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address(),u||(l=0,this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async _onConnection(f){f.pause();const h=(0,a.isLocalhost)(this.tunnelRemoteHost)||(0,a.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,v.connectRemoteAgentTunnel)(this._options,h,this.tunnelRemotePort),u=l.getSocket(),d=l.readEntireBuffer();l.dispose(),d.byteLength>0&&f.write(d.buffer),f.on("end",()=>{f.localAddress&&this._socketsDispose.delete(f.localAddress),u.end()}),f.on("close",()=>u.end()),f.on("error",()=>{f.localAddress&&this._socketsDispose.delete(f.localAddress),u instanceof T.NodeSocket?u.socket.destroy():u.end()}),u instanceof T.NodeSocket?this._mirrorNodeSocket(f,u):this._mirrorGenericSocket(f,u),f.localAddress&&this._socketsDispose.set(f.localAddress,()=>{f.end(),u.end()})}_mirrorGenericSocket(f,h){h.onClose(()=>f.destroy()),h.onEnd(()=>f.end()),h.onData(l=>f.write(l.buffer)),f.on("data",l=>h.write(m.VSBuffer.wrap(l))),f.resume()}_mirrorNodeSocket(f,h){const l=h.socket;l.on("end",()=>f.end()),l.on("close",()=>f.end()),l.on("error",()=>{f.destroy()}),l.pipe(f),f.pipe(l)}}e.NodeRemoteTunnel=n;let i=class extends a.AbstractTunnelService{constructor(f,h,l,u,d){super(h,d),this.remoteSocketFactoryService=f,this.signService=l,this.productService=u}isPortPrivileged(f){return(0,a.isPortPrivileged)(f,this.defaultTunnelHost,p.OS,O.release())}retainOrCreateTunnel(f,h,l,u,d,g,D,E){const _=this.getTunnelFromMap(h,l);if(_)return++_.refcount,_.value;if((0,a.isTunnelProvider)(f))return this.createWithProvider(f,h,l,d,g,D,E);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${l} on local port ${d}.`);const y={commit:this.productService.commit,quality:this.productService.quality,addressProvider:f,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},P=o(y,u,h,l,d);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,l,P),P}}};e.BaseTunnelService=i,e.BaseTunnelService=i=Ge([Ue(0,C.IRemoteSocketFactoryService),Ue(1,A.ILogService),Ue(2,S.ISignService),Ue(3,I.IProductService),Ue(4,w.IConfigurationService)],i);let r=class extends i{constructor(f,h,l,u,d){super(f,h,l,u,d)}};e.TunnelService=r,e.TunnelService=r=Ge([Ue(0,C.IRemoteSocketFactoryService),Ue(1,A.ILogService),Ue(2,S.ISignService),Ue(3,I.IProductService),Ue(4,w.IConfigurationService)],r);let s=class extends b.Disposable{constructor(f,h,l,u,d){super(),this.remoteSocketFactoryService=f,this.logService=h,this.productService=l,this.signService=u,this.configurationService=d,this._tunnelServices=new Map}async openTunnel(f,h,l,u,d,g,D,E,_){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${u} on local port ${g}.`),!this._tunnelServices.has(f)){const y=new r(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(y),this._tunnelServices.set(f,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this._tunnelServices.delete(f))})}return this._tunnelServices.get(f).openTunnel(h,l,u,d,g,D,E,_)}};e.SharedTunnelsService=s,e.SharedTunnelsService=s=Ge([Ue(0,C.IRemoteSocketFactoryService),Ue(1,A.ILogService),Ue(2,I.IProductService),Ue(3,S.ISignService),Ue(4,w.IConfigurationService)],s)}),define(ye[391],_e([1,0,123,286,51,33,2,12,42]),function(de,e,c,O,L,T,R,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class w{constructor(v,C,S){this._commands=v,this.logService=C,this._ipcHandlePath=S,this._server=O.createServer((a,m)=>this.onRequest(a,m)),this.setup().catch(a=>(C.error(a),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",v=>this.logService.error(v))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(v,C){const S=(m,o)=>{C.writeHead(m,{"content-type":"application/json"}),C.end(JSON.stringify(o||null),n=>n&&this.logService.error(n))},a=[];v.setEncoding("utf8"),v.on("data",m=>a.push(m)),v.on("end",async()=>{try{const m=JSON.parse(a.join(""));let o;switch(m.type){case"open":o=await this.open(m);break;case"openExternal":o=await this.openExternal(m);break;case"status":o=await this.getStatus(m);break;case"extensionManagement":o=await this.manageExtensions(m);break;default:S(404,`Unknown message type: ${m.type}`);break}S(200,o)}catch(m){const o=m instanceof Error?m.message:JSON.stringify(m);S(500,o),this.logService.error("Error while processing pipe request",m)}})}async open(v){const{fileURIs:C,folderURIs:S,forceNewWindow:a,diffMode:m,mergeMode:o,addMode:n,forceReuseWindow:i,gotoLineMode:r,waitMarkerFilePath:s,remoteAuthority:t}=v,f=[];if(Array.isArray(S))for(const d of S)try{f.push({folderUri:R.URI.parse(d)})}catch{}if(Array.isArray(C))for(const d of C)try{(0,p.hasWorkspaceFileExtension)(d)?f.push({workspaceUri:R.URI.parse(d)}):f.push({fileUri:R.URI.parse(d)})}catch{}const h=s?R.URI.file(s):void 0,u={forceNewWindow:a,diffMode:m,mergeMode:o,addMode:n,gotoLineMode:r,forceReuseWindow:i,preferNewWindow:!i&&!h&&!n,waitMarkerFileURI:h,remoteAuthority:t};this._commands.executeCommand("_remoteCLI.windowOpen",f,u)}async openExternal(v){for(const C of v.uris){const S=R.URI.parse(C),a=S.scheme==="file"?S:C;await this._commands.executeCommand("_remoteCLI.openExternal",a)}}async manageExtensions(v){const C=a=>a?.map(m=>/\.vsix$/i.test(m)?R.URI.parse(m):m),S={list:v.list,install:C(v.install),uninstall:C(v.uninstall),force:v.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",S)}async getStatus(v){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&L.existsSync(this._ipcHandlePath)&&L.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=w;let A=class extends w{constructor(v,C){super(v,C,(0,c.createRandomIPCHandle)())}};e.CLIServer=A,e.CLIServer=A=Ge([Ue(0,T.IExtHostCommands),Ue(1,b.ILogService)],A)}),define(ye[392],_e([1,0,58,379,374,285,48,361,2,15,7,391,104,319,360]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class a extends L.RequireInterceptor{_installInterceptor(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,r=i._load;i._load=function(h,l,u){return h=t(h),n._factories.has(h)?n._factories.get(h).load(h,p.URI.file((0,v.realpathSync)(l.filename)),d=>r.apply(this,[d,l,u])):r.apply(this,arguments)};const s=i._resolveLookupPaths;i._resolveLookupPaths=(f,h)=>s.call(this,t(f),h);const t=f=>{for(const h of n._alternatives){const l=h(f);if(l){f=l;break}}return f}}}class m extends R.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(C.ExtHostConsoleForwarder);const n=this._instaService.invokeFunction(O.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(b.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const s=this._instaService.createInstance(I.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath}this._instaService.createInstance(S.ExtHostDiskFileSystemProvider),await this._instaService.createInstance(a,n,{mine:this._myRegistry,all:this._globalRegistry}).install(),c.mark("code/extHost/didInitAPI");const r=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,r,this,this._logService,this._mainThreadTelemetryProxy,this._initData),c.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(n){return n.main}async _loadCommonJSModule(n,i,r){if(i.scheme!==w.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let s=null;r.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this._logService.flush();const t=n?.identifier.value;n&&await this._extHostLocalizationService.initializeLocalizedMessages(n);try{t&&c.mark(`code/extHost/willLoadExtensionCode/${t}`),s=de.__$__nodeRequire(i.fsPath)}finally{t&&c.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return s}async $setRemoteEnvironment(n){if(this._initData.remote.isRemote)for(const i in n){const r=n[i];r===null?delete process.env[i]:process.env[i]=r}}}e.ExtHostExtensionService=m}),define(ye[393],_e([1,0,52,21,4,3,125,11,23,2,31,12,265,65,110,88,390,28,20,70,368]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostTunnelService=void 0,e.getSockets=s,e.loadListeningPorts=t,e.parseIpAddress=f,e.loadConnectionTable=h,e.getRootProcesses=u,e.findPorts=d,e.tryFindRootPorts=g;function s(_){const y=_.trim().split(`
`),P=[];return y.forEach(z=>{const x=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);x&&x.length>=3&&P.push({pid:parseInt(x[1],10),socket:parseInt(x[2],10)})}),P.reduce((z,x)=>(z[x.socket]=x,z),{})}function t(..._){const y=[].concat(..._.map(h));return[...new Map(y.filter(P=>P.st==="0A").map(P=>{const k=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:f(k[0]),port:parseInt(k[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}function f(_){let y="";if(_.length===8)for(let P=_.length-2;P>=0;P-=2)y+=parseInt(_.substr(P,2),16),P!==0&&(y+=".");else for(let P=0;P<_.length;P+=8){const k=_.substring(P,P+8);let z="";for(let x=8;x>=2;x-=2)z+=k.substring(x-2,x),(x===6||x===2)&&(z=parseInt(z,16).toString(16),y+=`${z}`,z="",P+x!==_.length-6&&(y+=":"))}return y}function h(_){const y=_.trim().split(`
`),P=y.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return y.map(z=>z.trim().split(/\s+/).reduce((x,F,N)=>(x[P[N]||N]=F,x),{}))}function l(_){return!!_.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||_.indexOf("out/server-main.js")!==-1||_.indexOf("_productName=VSCode")!==-1}function u(_){const y=_.trim().split(`
`),P=[];return y.forEach(k=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(k);z&&z.length>=4&&P.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),P}async function d(_,y,P){const k=P.reduce((x,F)=>(x[F.pid]=F,x),{}),z=[];return _.forEach(({socket:x,ip:F,port:N})=>{const M=y[x]?y[x].pid:void 0,B=M?k[M]?.cmd:void 0;M&&B&&!l(B)&&z.push({host:F,port:N,detail:B,pid:M})}),z}function g(_,y,P){const k=new Map,z=u(y);for(const x of _){const F=P.get(x.port);if(F){k.set(x.port,F);continue}const N=z.find(M=>M.cmd.includes(`${x.port}`));if(N){let M=N,B;do B=z.find(W=>W.ppid===M.pid),B&&(M=B);while(B);k.set(x.port,{host:x.ip,port:x.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else k.set(x.port,{host:x.ip,port:x.port,ppid:Number.MAX_VALUE})}return k}let D=class extends i.ExtHostTunnelService{constructor(y,P,k,z){super(y,P,k),this.initData=P,this.signService=z,this._initialCandidates=void 0,this._foundRootPorts=new Map,this._candidateFindingEnabled=!1,b.isLinux&&P.remote.isRemote&&P.remote.authority&&(this._proxy.$setRemoteTunnelService(process.pid),this.setInitialCandidates())}async $registerCandidateFinder(y){if(y&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=y;let P;this._initialCandidates&&(P=this._initialCandidates,await this._proxy.$onFoundNewCandidates(this._initialCandidates));const k=new R.MovingAverage;let z=0;for(;this._candidateFindingEnabled;){const x=new Date().getTime(),F=(await this.findCandidatePorts()).filter(B=>(0,a.isLocalhost)(B.host)||(0,a.isAllInterfaces)(B.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(B=>B.port).join(", ")}`);const N=new Date().getTime()-x;this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),z++>3&&k.update(N),(!P||JSON.stringify(P)!==JSON.stringify(F))&&(P=F,await this._proxy.$onFoundNewCandidates(P));const M=this.calculateDelay(k.value);this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${M} ms.`),await new Promise(B=>setTimeout(()=>B(),M))}}calculateDelay(y){return Math.max(y*20,2e3)}async setInitialCandidates(){this._initialCandidates=await this.findCandidatePorts(),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this._initialCandidates.map(y=>y.port).join(", ")}`)}async findCandidatePorts(){let y="",P="";try{y=await A.Promises.readFile("/proc/net/tcp","utf8"),P=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const k=t(y,P),z=await new Promise(Z=>{(0,c.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(G,Q,re)=>{Z(Q)})}),x=s(z),F=await A.Promises.readdir("/proc"),N=[];for(const Z of F)try{const G=Number(Z),Q=p.joinPath(w.URI.file("/proc"),Z);if((await A.Promises.stat(Q.fsPath)).isDirectory()&&!isNaN(G)){const te=await A.Promises.readlink(p.joinPath(Q,"cwd").fsPath),ve=await A.Promises.readFile(p.joinPath(Q,"cmdline").fsPath,"utf8");N.push({pid:G,cwd:te,cmd:ve})}}catch{}const M=[],B=k.filter(Z=>{const G=x[Z.socket];return G||M.push(Z),G}),W=d(B,x,N);let Y;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const Z=await new Promise(G=>{(0,c.exec)("ps -F -A -l | grep root",(Q,re,te)=>{G(re)})});this._foundRootPorts=g(M,Z,this._foundRootPorts),Y=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${Y.map(G=>G.port).join(", ")}`)}return W.then(Z=>Y?Z.concat(Y):Z)}makeManagedTunnelFactory(y){return async P=>{const k=new m.NodeRemoteTunnel({commit:this.initData.commit,quality:this.initData.quality,logService:this.logService,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(x,F,N,M){const B=await y.makeConnection();return E.connect(B,F,N,M)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new C.ManagedRemoteConnection(0),connectionToken:y.connectionToken})}},signService:this.signService},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await k.waitForReady();const z=new L.Emitter;return{localAddress:(0,r.parseAddress)(k.localAddress)??k.localAddress,remoteAddress:{port:k.tunnelRemotePort,host:k.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{k.dispose(),z.fire(),z.dispose()}}}}};e.NodeExtHostTunnelService=D,e.NodeExtHostTunnelService=D=Ge([Ue(0,n.IExtHostRpcService),Ue(1,o.IExtHostInitDataService),Ue(2,I.ILogService),Ue(3,S.ISignService)],D);class E extends v.ManagedSocket{static connect(y,P,k,z){const x=new T.DisposableStore,F={onClose:x.add(new L.Emitter),onData:x.add(new L.Emitter),onEnd:x.add(new L.Emitter)};x.add(y.onDidReceiveMessage(M=>F.onData.fire(O.VSBuffer.wrap(M)))),x.add(y.onDidEnd(()=>F.onEnd.fire())),x.add(y.onDidClose(M=>F.onClose.fire({type:0,error:M,hadError:!!M})));const N=new E(y,z,F);return N._register(x),(0,v.connectManagedSocket)(N,P,k,z,F)}constructor(y,P,k){super(P,k),this.passing=y}write(y){this.passing.send(y.buffer)}closeRemote(){this.passing.end()}async drain(){await this.passing.drain?.()}}}),define(ye[394],_e([1,0,84,363,377,376,389,392,393,96,48,97,95,43,70,93,362,320,12,378,60,280,106,110,141]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o,n,i,r,s,t,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(A.IExtHostExtensionService,b.ExtHostExtensionService,0),(0,c.registerSingleton)(n.ILoggerService,o.ExtHostLoggerService,1),(0,c.registerSingleton)(n.ILogService,new t.SyncDescriptor(s.ExtHostLogService,[!1],!0)),(0,c.registerSingleton)(f.ISignService,h.SignService,1),(0,c.registerSingleton)(a.IExtensionStoragePaths,m.ExtensionStoragePaths,0),(0,c.registerSingleton)(w.IExtHostDebugService,T.ExtHostDebugService,0),(0,c.registerSingleton)(I.IExtHostSearch,R.NativeExtHostSearch,0),(0,c.registerSingleton)(v.IExtHostTask,L.ExtHostTask,0),(0,c.registerSingleton)(C.IExtHostTerminalService,O.ExtHostTerminalService,0),(0,c.registerSingleton)(S.IExtHostTunnelService,p.NodeExtHostTunnelService,0),(0,c.registerSingleton)(r.IExtHostVariableResolverProvider,i.NodeExtHostVariableResolverProviderService,0)}),define(ye[405],_e([1,0,62,406,58,13,82,123,263,114,375,21,31,104,8,135,287,302,380,394]),function(de,e,c,O,L,T,R,b,p,w,A,I,v,C,S,a,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let g=0;g<process.execArgv.length;g++)process.execArgv[g]==="--inspect-port=0"&&(process.execArgv.splice(g,1),g--)}();const n=O(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const d=globalThis._VSCODE_NODE_MODULES.module,g=d._load;d._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return g.apply(this,arguments)}})();const i=process.exit.bind(process),r=process.on.bind(process);function s(d){process.exit=function(g){if(d)i(g);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const g=new Error("An extension called process.crash() and this was prevented.");console.warn(g.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(g,D){g==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),r(g,D)}}let t=function(d){i()};function f(){const d=(0,o.readExtHostConnection)(process.env);if(d.type===3)return new Promise((g,D)=>{const E=_=>{const y=_[0],P=new R.BufferedEmitter;y.on("message",k=>P.fire(I.VSBuffer.wrap(k.data))),y.on("close",()=>{t("renderer closed the MessagePort")}),y.start(),g({onMessage:P.event,send:k=>y.postMessage(k.buffer)})};process.parentPort.on("message",_=>E(_.ports))});if(d.type===2)return new Promise((g,D)=>{let E=null;const _=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,P=3e5,k=new S.ProcessTimeRunOnceScheduler(()=>t("renderer disconnected for too long (1)"),y),z=new S.ProcessTimeRunOnceScheduler(()=>t("renderer disconnected for too long (2)"),P);process.on("message",(F,N)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){N.setNoDelay(!0);const M=I.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let B;if(F.skipWebSocketFrames)B=new b.NodeSocket(N,"extHost-socket");else{const W=I.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));B=new b.WebSocketNodeSocket(new b.NodeSocket(N,"extHost-socket"),F.permessageDeflate,W,!1)}E?(k.cancel(),z.cancel(),E.beginAcceptReconnection(B,M),E.endAcceptReconnection(),E.sendResume()):(clearTimeout(_),E=new R.PersistentProtocol({socket:B,initialChunk:M}),E.sendResume(),E.onDidDispose(()=>t("renderer disconnected")),g(E),E.onSocketClose(()=>{k.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;k.isScheduled()&&z.schedule()}});const x={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(x)});{const g=d.pipeName;return new Promise((D,E)=>{const _=c.createConnection(g,()=>{_.removeListener("error",E);const y=new R.PersistentProtocol({socket:new b.NodeSocket(_,"extHost-renderer")});y.sendResume(),D(y)});_.once("error",E),_.on("close",()=>{t("renderer closed the socket")})})}}async function h(){const d=await f();return new class{constructor(){this._onMessage=new R.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,d.onMessage(g=>{(0,w.isMessageOfType)(g,2)?(this._terminating=!0,t("received terminate message from renderer")):this._onMessage.fire(g)})}send(g){this._terminating||d.send(g)}async drain(){if(d.drain)return d.drain()}}}function l(d){return new Promise(g=>{const D=d.onMessage(E=>{D.dispose();const _=JSON.parse(E.toString()),y=_.commit,P=p.default.commit;if(y&&P&&y!==P&&i(55),_.parentPid){let k=0;setInterval(function(){try{process.kill(_.parentPid,0),k=0}catch(x){x&&x.code==="EPERM"?(k++,k>=3&&t(`parent process ${_.parentPid} does not exist anymore (3 x EPERM): ${x.message} (code: ${x.code}) (errno: ${x.errno})`)):t(`parent process ${_.parentPid} does not exist anymore: ${x.message} (code: ${x.code}) (errno: ${x.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(_.parentPid)}catch(x){(0,T.onUnexpectedError)(x)}}d.send((0,w.createMessageOfType)(0)),g({protocol:d,initData:_})});d.send((0,w.createMessageOfType)(1))})}async function u(){const d=[];process.on("unhandledRejection",(k,z)=>{d.push(z),setTimeout(()=>{const x=d.indexOf(z);x>=0&&z.catch(F=>{d.splice(x,1),(0,T.isCancellationError)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),k&&(0,T.onUnexpectedError)(k))})},1e3)}),process.on("rejectionHandled",k=>{const z=d.indexOf(k);z>=0&&d.splice(z,1)}),process.on("uncaughtException",function(k){(0,T.isSigPipeError)(k)||(0,T.onUnexpectedError)(k)}),L.mark("code/extHost/willConnectToRenderer");const g=await h();L.mark("code/extHost/didConnectToRenderer");const D=await l(g);L.mark("code/extHost/didWaitForInitData");const{initData:E}=D;s(!!E.environment.extensionTestsLocationURI),E.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,E.environment.skipWorkspaceStorageLock=(0,a.boolean)(n.skipWorkspaceStorageLock,!1);const _=new class{constructor(){this.pid=process.pid}exit(z){i(z)}fsExists(z){return v.Promises.exists(z)}fsRealpath(z){return(0,C.realpath)(z)}};let y=null;E.remote.authority&&n.transformURIs&&(y=(0,m.createURITransformer)(E.remote.authority));const P=new A.ExtensionHostMain(D.protocol,E,_,y);t=k=>P.terminate(k)}u().catch(d=>console.log(d))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0d01a72525276e5e3771fe5851b9c83de0de1e2b/core/vs/workbench/api/node/extensionHostProcess.js.map
