/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/buffer","vs/base/common/resources","vs/base/common/cancellation","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/platform/contextkey/common/contextkey","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Te=function(me){for(var e=[],D=0,O=me.length;D<O;D++)e[D]=Pe[me[D]];return e};define(Pe[68],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=O,e.debounce=T,e.throttle=N;function D(R){return(m,h,y)=>{let L=null,_=null;if(typeof y.value=="function"?(L="value",_=y.value):typeof y.get=="function"&&(L="get",_=y.get),!_)throw new Error("not supported");y[L]=R(_,h)}}function O(R,m,h){let y=null,L=null;if(typeof h.value=="function"?(y="value",L=h.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(y="get",L=h.get),!L)throw new Error("not supported");const _=`$memoize$${m}`;h[y]=function(...l){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,l)}),this[_]}}function T(R,m,h){return D((y,L)=>{const _=`$debounce$${L}`,l=`$debounce$result$${L}`;return function(...w){this[l]||(this[l]=h?h():void 0),clearTimeout(this[_]),m&&(this[l]=m(this[l],...w),w=[this[l]]),this[_]=setTimeout(()=>{y.apply(this,w),this[l]=h?h():void 0},R)}})}function N(R,m,h){return D((y,L)=>{const _=`$throttle$timer$${L}`,l=`$throttle$result$${L}`,w=`$throttle$lastRun$${L}`,g=`$throttle$pending$${L}`;return function(...r){if(this[l]||(this[l]=h?h():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),m&&(this[l]=m(this[l],...r)),this[g])return;const o=this[w]+R;o<=Date.now()?(this[w]=Date.now(),y.apply(this,[this[l]]),this[l]=h?h():void 0):(this[g]=!0,this[_]=setTimeout(()=>{this[g]=!1,this[w]=Date.now(),y.apply(this,[this[l]]),this[l]=h?h():void 0},o-Date.now()))}})}}),define(Pe[90],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class D{constructor(T){this._prefix=T,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=D,e.defaultGenerator=new D("id#")}),define(Pe[123],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=R,e.getLocation=_,e.parse=l,e.parseTree=w,e.findNodeAtLocation=g,e.getNodePath=r,e.getNodeValue=o,e.contains=s,e.findNodeAtOffset=n,e.visit=i,e.stripComments=a,e.getNodeType=d;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T||(e.ParseErrorCode=T={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function R(t,E=!1){let c=0;const p=t.length;let b="",v=0,u=16,C=0;function f(V){let A=0,U=0;for(;A<V;){const j=t.charCodeAt(c);if(j>=48&&j<=57)U=U*16+j-48;else if(j>=65&&j<=70)U=U*16+j-65+10;else if(j>=97&&j<=102)U=U*16+j-97+10;else break;c++,A++}return A<V&&(U=-1),U}function I(V){c=V,b="",v=0,u=16,C=0}function S(){const V=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&y(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&y(t.charCodeAt(c)))for(c++;c<t.length&&y(t.charCodeAt(c));)c++;else return C=3,t.substring(V,c);let A=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&y(t.charCodeAt(c))){for(c++;c<t.length&&y(t.charCodeAt(c));)c++;A=c}else C=3;return t.substring(V,A)}function P(){let V="",A=c;for(;;){if(c>=p){V+=t.substring(A,c),C=2;break}const U=t.charCodeAt(c);if(U===34){V+=t.substring(A,c),c++;break}if(U===92){if(V+=t.substring(A,c),c++,c>=p){C=2;break}switch(t.charCodeAt(c++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:{const ie=f(4);ie>=0?V+=String.fromCharCode(ie):C=4;break}default:C=5}A=c;continue}if(U>=0&&U<=31)if(h(U)){V+=t.substring(A,c),C=2;break}else C=6;c++}return V}function k(){if(b="",C=0,v=c,c>=p)return v=p,u=17;let V=t.charCodeAt(c);if(m(V)){do c++,b+=String.fromCharCode(V),V=t.charCodeAt(c);while(m(V));return u=15}if(h(V))return c++,b+=String.fromCharCode(V),V===13&&t.charCodeAt(c)===10&&(c++,b+=`
`),u=14;switch(V){case 123:return c++,u=1;case 125:return c++,u=2;case 91:return c++,u=3;case 93:return c++,u=4;case 58:return c++,u=6;case 44:return c++,u=5;case 34:return c++,b=P(),u=10;case 47:{const A=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<p&&!h(t.charCodeAt(c));)c++;return b=t.substring(A,c),u=12}if(t.charCodeAt(c+1)===42){c+=2;const U=p-1;let j=!1;for(;c<U;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,j=!0;break}c++}return j||(c++,C=1),b=t.substring(A,c),u=13}return b+=String.fromCharCode(V),c++,u=16}case 45:if(b+=String.fromCharCode(V),c++,c===p||!y(t.charCodeAt(c)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b+=S(),u=11;default:for(;c<p&&H(V);)c++,V=t.charCodeAt(c);if(v!==c){switch(b=t.substring(v,c),b){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return b+=String.fromCharCode(V),c++,u=16}}function H(V){if(m(V)||h(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function $(){let V;do V=k();while(V>=12&&V<=15);return V}return{setPosition:I,getPosition:()=>c,scan:E?$:k,getToken:()=>u,getTokenValue:()=>b,getTokenOffset:()=>v,getTokenLength:()=>c-v,getTokenError:()=>C}}function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function _(t,E){const c=[],p=new Object;let b;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function C(f,I,S,P){v.value=f,v.offset=I,v.length=S,v.type=P,v.colonOffset=void 0,b=v}try{i(t,{onObjectBegin:(f,I)=>{if(E<=f)throw p;b=void 0,u=E>f,c.push("")},onObjectProperty:(f,I,S)=>{if(E<I||(C(f,I,S,"property"),c[c.length-1]=f,E<=I+S))throw p},onObjectEnd:(f,I)=>{if(E<=f)throw p;b=void 0,c.pop()},onArrayBegin:(f,I)=>{if(E<=f)throw p;b=void 0,c.push(0)},onArrayEnd:(f,I)=>{if(E<=f)throw p;b=void 0,c.pop()},onLiteralValue:(f,I,S)=>{if(E<I||(C(f,I,S,d(f)),E<=I+S))throw p},onSeparator:(f,I,S)=>{if(E<=I)throw p;if(f===":"&&b&&b.type==="property")b.colonOffset=I,u=!1,b=void 0;else if(f===","){const P=c[c.length-1];typeof P=="number"?c[c.length-1]=P+1:(u=!0,c[c.length-1]=""),b=void 0}}})}catch(f){if(f!==p)throw f}return{path:c,previousNode:b,isAtPropertyKey:u,matches:f=>{let I=0;for(let S=0;I<f.length&&S<c.length;S++)if(f[I]===c[S]||f[I]==="*")I++;else if(f[I]!=="**")return!1;return I===f.length}}}function l(t,E=[],c=N.DEFAULT){let p=null,b=[];const v=[];function u(f){Array.isArray(b)?b.push(f):p!==null&&(b[p]=f)}return i(t,{onObjectBegin:()=>{const f={};u(f),v.push(b),b=f,p=null},onObjectProperty:f=>{p=f},onObjectEnd:()=>{b=v.pop()},onArrayBegin:()=>{const f=[];u(f),v.push(b),b=f,p=null},onArrayEnd:()=>{b=v.pop()},onLiteralValue:u,onError:(f,I,S)=>{E.push({error:f,offset:I,length:S})}},c),b[0]}function w(t,E=[],c=N.DEFAULT){let p={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(f){p.type==="property"&&(p.length=f-p.offset,p=p.parent)}function v(f){return p.children.push(f),f}i(t,{onObjectBegin:f=>{p=v({type:"object",offset:f,length:-1,parent:p,children:[]})},onObjectProperty:(f,I,S)=>{p=v({type:"property",offset:I,length:-1,parent:p,children:[]}),p.children.push({type:"string",value:f,offset:I,length:S,parent:p})},onObjectEnd:(f,I)=>{p.length=f+I-p.offset,p=p.parent,b(f+I)},onArrayBegin:(f,I)=>{p=v({type:"array",offset:f,length:-1,parent:p,children:[]})},onArrayEnd:(f,I)=>{p.length=f+I-p.offset,p=p.parent,b(f+I)},onLiteralValue:(f,I,S)=>{v({type:d(f),offset:I,length:S,parent:p,value:f}),b(I+S)},onSeparator:(f,I,S)=>{p.type==="property"&&(f===":"?p.colonOffset=I:f===","&&b(I))},onError:(f,I,S)=>{E.push({error:f,offset:I,length:S})}},c);const C=p.children[0];return C&&delete C.parent,C}function g(t,E){if(!t)return;let c=t;for(const p of E)if(typeof p=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let b=!1;for(const v of c.children)if(Array.isArray(v.children)&&v.children[0].value===p){c=v.children[1],b=!0;break}if(!b)return}else{const b=p;if(c.type!=="array"||b<0||!Array.isArray(c.children)||b>=c.children.length)return;c=c.children[b]}return c}function r(t){if(!t.parent||!t.parent.children)return[];const E=r(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;E.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&E.push(c)}return E}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const E=Object.create(null);for(const c of t.children){const p=c.children[1];p&&(E[c.children[0].value]=o(p))}return E}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function s(t,E,c=!1){return E>=t.offset&&E<t.offset+t.length||c&&E===t.offset+t.length}function n(t,E,c=!1){if(s(t,E,c)){const p=t.children;if(Array.isArray(p))for(let b=0;b<p.length&&p[b].offset<=E;b++){const v=n(p[b],E,c);if(v)return v}return t}}function i(t,E,c=N.DEFAULT){const p=R(t,!1);function b(ne){return ne?()=>ne(p.getTokenOffset(),p.getTokenLength()):()=>!0}function v(ne){return ne?Ie=>ne(Ie,p.getTokenOffset(),p.getTokenLength()):()=>!0}const u=b(E.onObjectBegin),C=v(E.onObjectProperty),f=b(E.onObjectEnd),I=b(E.onArrayBegin),S=b(E.onArrayEnd),P=v(E.onLiteralValue),k=v(E.onSeparator),H=b(E.onComment),$=v(E.onError),V=c&&c.disallowComments,A=c&&c.allowTrailingComma;function U(){for(;;){const ne=p.scan();switch(p.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:V||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(ne){case 12:case 13:V?j(10):H();break;case 16:j(1);break;case 15:case 14:break;default:return ne}}}function j(ne,Ie=[],xe=[]){if($(ne),Ie.length+xe.length>0){let re=p.getToken();for(;re!==17;){if(Ie.indexOf(re)!==-1){U();break}else if(xe.indexOf(re)!==-1)break;re=U()}}}function ie(ne){const Ie=p.getTokenValue();return ne?P(Ie):C(Ie),U(),!0}function fe(){switch(p.getToken()){case 11:{let ne=0;try{ne=JSON.parse(p.getTokenValue()),typeof ne!="number"&&(j(2),ne=0)}catch{j(2)}P(ne);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return U(),!0}function Ce(){return p.getToken()!==10?(j(3,[],[2,5]),!1):(ie(!1),p.getToken()===6?(k(":"),U(),pe()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function _e(){u(),U();let ne=!1;for(;p.getToken()!==2&&p.getToken()!==17;){if(p.getToken()===5){if(ne||j(4,[],[]),k(","),U(),p.getToken()===2&&A)break}else ne&&j(6,[],[]);Ce()||j(4,[],[2,5]),ne=!0}return f(),p.getToken()!==2?j(7,[2],[]):U(),!0}function oe(){I(),U();let ne=!1;for(;p.getToken()!==4&&p.getToken()!==17;){if(p.getToken()===5){if(ne||j(4,[],[]),k(","),U(),p.getToken()===4&&A)break}else ne&&j(6,[],[]);pe()||j(4,[],[4,5]),ne=!0}return S(),p.getToken()!==4?j(8,[4],[]):U(),!0}function pe(){switch(p.getToken()){case 3:return oe();case 1:return _e();case 10:return ie(!0);default:return fe()}}return U(),p.getToken()===17?c.allowEmptyContent?!0:(j(4,[],[]),!1):pe()?(p.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}function a(t,E){const c=R(t),p=[];let b,v=0,u;do switch(u=c.getPosition(),b=c.scan(),b){case 12:case 13:case 17:v!==u&&p.push(t.substring(v,u)),E!==void 0&&p.push(c.getTokenValue().replace(/[^\r\n]/g,E)),v=c.getPosition();break}while(b!==17);return p.join("")}function d(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(me,e){typeof define=="function"&&define.amd?define(Pe[124],Te([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(Se,ve){for(var he=0;he<ve.length;he++){var K=ve[he];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(Se,K.key,K)}}function D(Se,ve,he){return ve&&e(Se.prototype,ve),he&&e(Se,he),Object.defineProperty(Se,"prototype",{writable:!1}),Se}function O(Se,ve){if(Se){if(typeof Se=="string")return T(Se,ve);var he=Object.prototype.toString.call(Se).slice(8,-1);if(he==="Object"&&Se.constructor&&(he=Se.constructor.name),he==="Map"||he==="Set")return Array.from(Se);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return T(Se,ve)}}function T(Se,ve){(ve==null||ve>Se.length)&&(ve=Se.length);for(var he=0,K=new Array(ve);he<ve;he++)K[he]=Se[he];return K}function N(Se,ve){var he=typeof Symbol<"u"&&Se[Symbol.iterator]||Se["@@iterator"];if(he)return(he=he.call(Se)).next.bind(he);if(Array.isArray(Se)||(he=O(Se))||ve&&Se&&typeof Se.length=="number"){he&&(Se=he);var K=0;return function(){return K>=Se.length?{done:!0}:{done:!1,value:Se[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=R();function m(Se){me.defaults=Se}var h=/[&<>"']/,y=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(ve){return l[ve]};function g(Se,ve){if(ve){if(h.test(Se))return Se.replace(y,w)}else if(L.test(Se))return Se.replace(_,w);return Se}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Se){return Se.replace(r,function(ve,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var s=/(^|[^\[])\^/g;function n(Se,ve){Se=typeof Se=="string"?Se:Se.source,ve=ve||"";var he={replace:function(Y,le){return le=le.source||le,le=le.replace(s,"$1"),Se=Se.replace(Y,le),he},getRegex:function(){return new RegExp(Se,ve)}};return he}var i=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(Se,ve,he){if(Se){var K;try{K=decodeURIComponent(o(he)).replace(i,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}ve&&!a.test(he)&&(he=b(ve,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var t={},E=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,p=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(Se,ve){t[" "+Se]||(E.test(Se)?t[" "+Se]=Se+"/":t[" "+Se]=f(Se,"/",!0)),Se=t[" "+Se];var he=Se.indexOf(":")===-1;return ve.substring(0,2)==="//"?he?ve:Se.replace(c,"$1")+ve:ve.charAt(0)==="/"?he?ve:Se.replace(p,"$1")+ve:Se+ve}var v={exec:function(){}};function u(Se){for(var ve=1,he,K;ve<arguments.length;ve++){he=arguments[ve];for(K in he)Object.prototype.hasOwnProperty.call(he,K)&&(Se[K]=he[K])}return Se}function C(Se,ve){var he=Se.replace(/\|/g,function(le,de,Ne){for(var ue=!1,De=de;--De>=0&&Ne[De]==="\\";)ue=!ue;return ue?"|":" |"}),K=he.split(/ \|/),Y=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>ve)K.splice(ve);else for(;K.length<ve;)K.push("");for(;Y<K.length;Y++)K[Y]=K[Y].trim().replace(/\\\|/g,"|");return K}function f(Se,ve,he){var K=Se.length;if(K===0)return"";for(var Y=0;Y<K;){var le=Se.charAt(K-Y-1);if(le===ve&&!he)Y++;else if(le!==ve&&he)Y++;else break}return Se.slice(0,K-Y)}function I(Se,ve){if(Se.indexOf(ve[1])===-1)return-1;for(var he=Se.length,K=0,Y=0;Y<he;Y++)if(Se[Y]==="\\")Y++;else if(Se[Y]===ve[0])K++;else if(Se[Y]===ve[1]&&(K--,K<0))return Y;return-1}function S(Se){Se&&Se.sanitize&&!Se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(Se,ve){if(ve<1)return"";for(var he="";ve>1;)ve&1&&(he+=Se),ve>>=1,Se+=Se;return he+Se}function k(Se,ve,he,K){var Y=ve.href,le=ve.title?g(ve.title):null,de=Se[1].replace(/\\([\[\]])/g,"$1");if(Se[0].charAt(0)!=="!"){K.state.inLink=!0;var Ne={type:"link",raw:he,href:Y,title:le,text:de,tokens:K.inlineTokens(de)};return K.state.inLink=!1,Ne}return{type:"image",raw:he,href:Y,title:le,text:g(de)}}function H(Se,ve){var he=Se.match(/^(\s+)(?:```)/);if(he===null)return ve;var K=he[1];return ve.split(`
`).map(function(Y){var le=Y.match(/^\s+/);if(le===null)return Y;var de=le[0];return de.length>=K.length?Y.slice(K.length):Y}).join(`
`)}var $=function(){function Se(he){this.options=he||me.defaults}var ve=Se.prototype;return ve.space=function(K){var Y=this.rules.block.newline.exec(K);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},ve.code=function(K){var Y=this.rules.block.code.exec(K);if(Y){var le=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?le:f(le,`
`)}}},ve.fences=function(K){var Y=this.rules.block.fences.exec(K);if(Y){var le=Y[0],de=H(le,Y[3]||"");return{type:"code",raw:le,lang:Y[2]?Y[2].trim():Y[2],text:de}}},ve.heading=function(K){var Y=this.rules.block.heading.exec(K);if(Y){var le=Y[2].trim();if(/#$/.test(le)){var de=f(le,"#");(this.options.pedantic||!de||/ $/.test(de))&&(le=de.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:le,tokens:this.lexer.inline(le)}}},ve.hr=function(K){var Y=this.rules.block.hr.exec(K);if(Y)return{type:"hr",raw:Y[0]}},ve.blockquote=function(K){var Y=this.rules.block.blockquote.exec(K);if(Y){var le=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},ve.list=function(K){var Y=this.rules.block.list.exec(K);if(Y){var le,de,Ne,ue,De,Re,Ue,B,x,q,W,ee,se=Y[1].trim(),Oe=se.length>1,ze={type:"list",raw:"",ordered:Oe,start:Oe?+se.slice(0,-1):"",loose:!1,items:[]};se=Oe?"\\d{1,9}\\"+se.slice(-1):"\\"+se,this.options.pedantic&&(se=Oe?se:"[*+-]");for(var Ge=new RegExp("^( {0,3}"+se+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(ee=!1,!(!(Y=Ge.exec(K))||this.rules.block.hr.test(K)));){if(le=Y[0],K=K.substring(le.length),B=Y[2].split(`
`,1)[0],x=K.split(`
`,1)[0],this.options.pedantic?(ue=2,W=B.trimLeft()):(ue=Y[2].search(/[^ ]/),ue=ue>4?1:ue,W=B.slice(ue),ue+=Y[1].length),Re=!1,!B&&/^ *$/.test(x)&&(le+=x+`
`,K=K.substring(x.length+1),ee=!0),!ee)for(var Je=new RegExp("^ {0,"+Math.min(3,ue-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,ue-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ot=new RegExp("^ {0,"+Math.min(3,ue-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,ue-1)+"}#");K&&(q=K.split(`
`,1)[0],B=q,this.options.pedantic&&(B=B.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ot.test(B)||it.test(B)||Je.test(B)||et.test(K)));){if(B.search(/[^ ]/)>=ue||!B.trim())W+=`
`+B.slice(ue);else if(!Re)W+=`
`+B;else break;!Re&&!B.trim()&&(Re=!0),le+=q+`
`,K=K.substring(q.length+1)}ze.loose||(Ue?ze.loose=!0:/\n *\n *$/.test(le)&&(Ue=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(W),de&&(Ne=de[0]!=="[ ] ",W=W.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:le,task:!!de,checked:Ne,loose:!1,text:W}),ze.raw+=le}ze.items[ze.items.length-1].raw=le.trimRight(),ze.items[ze.items.length-1].text=W.trimRight(),ze.raw=ze.raw.trimRight();var nt=ze.items.length;for(De=0;De<nt;De++){this.lexer.state.top=!1,ze.items[De].tokens=this.lexer.blockTokens(ze.items[De].text,[]);var at=ze.items[De].tokens.filter(function(Be){return Be.type==="space"}),ft=at.every(function(Be){for(var st=Be.raw.split(""),Q=0,X=N(st),ge;!(ge=X()).done;){var Ve=ge.value;if(Ve===`
`&&(Q+=1),Q>1)return!0}return!1});!ze.loose&&at.length&&ft&&(ze.loose=!0,ze.items[De].loose=!0)}return ze}},ve.html=function(K){var Y=this.rules.block.html.exec(K);if(Y){var le={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(Y[0]):g(Y[0]);le.type="paragraph",le.text=de,le.tokens=this.lexer.inline(de)}return le}},ve.def=function(K){var Y=this.rules.block.def.exec(K);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var le=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:Y[0],href:Y[2],title:Y[3]}}},ve.table=function(K){var Y=this.rules.block.table.exec(K);if(Y){var le={type:"table",header:C(Y[1]).map(function(Ue){return{text:Ue}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=Y[0];var de=le.align.length,Ne,ue,De,Re;for(Ne=0;Ne<de;Ne++)/^ *-+: *$/.test(le.align[Ne])?le.align[Ne]="right":/^ *:-+: *$/.test(le.align[Ne])?le.align[Ne]="center":/^ *:-+ *$/.test(le.align[Ne])?le.align[Ne]="left":le.align[Ne]=null;for(de=le.rows.length,Ne=0;Ne<de;Ne++)le.rows[Ne]=C(le.rows[Ne],le.header.length).map(function(Ue){return{text:Ue}});for(de=le.header.length,ue=0;ue<de;ue++)le.header[ue].tokens=this.lexer.inline(le.header[ue].text);for(de=le.rows.length,ue=0;ue<de;ue++)for(Re=le.rows[ue],De=0;De<Re.length;De++)Re[De].tokens=this.lexer.inline(Re[De].text);return le}}},ve.lheading=function(K){var Y=this.rules.block.lheading.exec(K);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},ve.paragraph=function(K){var Y=this.rules.block.paragraph.exec(K);if(Y){var le=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:le,tokens:this.lexer.inline(le)}}},ve.text=function(K){var Y=this.rules.block.text.exec(K);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},ve.escape=function(K){var Y=this.rules.inline.escape.exec(K);if(Y)return{type:"escape",raw:Y[0],text:g(Y[1])}},ve.tag=function(K){var Y=this.rules.inline.tag.exec(K);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):g(Y[0]):Y[0]}},ve.link=function(K){var Y=this.rules.inline.link.exec(K);if(Y){var le=Y[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var de=f(le.slice(0,-1),"\\");if((le.length-de.length)%2===0)return}else{var Ne=I(Y[2],"()");if(Ne>-1){var ue=Y[0].indexOf("!")===0?5:4,De=ue+Y[1].length+Ne;Y[2]=Y[2].substring(0,Ne),Y[0]=Y[0].substring(0,De).trim(),Y[3]=""}}var Re=Y[2],Ue="";if(this.options.pedantic){var B=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);B&&(Re=B[1],Ue=B[3])}else Ue=Y[3]?Y[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(le)?Re=Re.slice(1):Re=Re.slice(1,-1)),k(Y,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:Ue&&Ue.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},ve.reflink=function(K,Y){var le;if((le=this.rules.inline.reflink.exec(K))||(le=this.rules.inline.nolink.exec(K))){var de=(le[2]||le[1]).replace(/\s+/g," ");if(de=Y[de.toLowerCase()],!de||!de.href){var Ne=le[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return k(le,de,le[0],this.lexer)}},ve.emStrong=function(K,Y,le){le===void 0&&(le="");var de=this.rules.inline.emStrong.lDelim.exec(K);if(de&&!(de[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=de[1]||de[2]||"";if(!Ne||Ne&&(le===""||this.rules.inline.punctuation.exec(le))){var ue=de[0].length-1,De,Re,Ue=ue,B=0,x=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(x.lastIndex=0,Y=Y.slice(-1*K.length+ue);(de=x.exec(Y))!=null;)if(De=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!De){if(Re=De.length,de[3]||de[4]){Ue+=Re;continue}else if((de[5]||de[6])&&ue%3&&!((ue+Re)%3)){B+=Re;continue}if(Ue-=Re,!(Ue>0)){if(Re=Math.min(Re,Re+Ue+B),Math.min(ue,Re)%2){var q=K.slice(1,ue+de.index+Re);return{type:"em",raw:K.slice(0,ue+de.index+Re+1),text:q,tokens:this.lexer.inlineTokens(q)}}var W=K.slice(2,ue+de.index+Re-1);return{type:"strong",raw:K.slice(0,ue+de.index+Re+1),text:W,tokens:this.lexer.inlineTokens(W)}}}}}},ve.codespan=function(K){var Y=this.rules.inline.code.exec(K);if(Y){var le=Y[2].replace(/\n/g," "),de=/[^ ]/.test(le),Ne=/^ /.test(le)&&/ $/.test(le);return de&&Ne&&(le=le.substring(1,le.length-1)),le=g(le,!0),{type:"codespan",raw:Y[0],text:le}}},ve.br=function(K){var Y=this.rules.inline.br.exec(K);if(Y)return{type:"br",raw:Y[0]}},ve.del=function(K){var Y=this.rules.inline.del.exec(K);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},ve.autolink=function(K,Y){var le=this.rules.inline.autolink.exec(K);if(le){var de,Ne;return le[2]==="@"?(de=g(this.options.mangle?Y(le[1]):le[1]),Ne="mailto:"+de):(de=g(le[1]),Ne=de),{type:"link",raw:le[0],text:de,href:Ne,tokens:[{type:"text",raw:de,text:de}]}}},ve.url=function(K,Y){var le;if(le=this.rules.inline.url.exec(K)){var de,Ne;if(le[2]==="@")de=g(this.options.mangle?Y(le[0]):le[0]),Ne="mailto:"+de;else{var ue;do ue=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(ue!==le[0]);de=g(le[0]),le[1]==="www."?Ne="http://"+de:Ne=de}return{type:"link",raw:le[0],text:de,href:Ne,tokens:[{type:"text",raw:de,text:de}]}}},ve.inlineText=function(K,Y){var le=this.rules.inline.text.exec(K);if(le){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):g(le[0]):le[0]:de=g(this.options.smartypants?Y(le[0]):le[0]),{type:"text",raw:le[0],text:de}}},Se}(),V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=n(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.listItemStart=n(/^( *)(bull) */).replace("bull",V.bullet).getRegex(),V.list=n(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=n(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=n(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.blockquote=n(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=u({},V),V.gfm=u({},V.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.table=n(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.gfm.paragraph=n(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",V.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.pedantic=u({},V.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:n(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var A={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};A._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",A.punctuation=n(A.punctuation).replace(/punctuation/g,A._punctuation).getRegex(),A.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,A.escapedEmSt=/\\\*|\\_/g,A._comment=n(V._comment).replace("(?:-->|$)","-->").getRegex(),A.emStrong.lDelim=n(A.emStrong.lDelim).replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimAst=n(A.emStrong.rDelimAst,"g").replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimUnd=n(A.emStrong.rDelimUnd,"g").replace(/punct/g,A._punctuation).getRegex(),A._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,A._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,A._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,A.autolink=n(A.autolink).replace("scheme",A._scheme).replace("email",A._email).getRegex(),A._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,A.tag=n(A.tag).replace("comment",A._comment).replace("attribute",A._attribute).getRegex(),A._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,A._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,A._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,A.link=n(A.link).replace("label",A._label).replace("href",A._href).replace("title",A._title).getRegex(),A.reflink=n(A.reflink).replace("label",A._label).replace("ref",V._label).getRegex(),A.nolink=n(A.nolink).replace("ref",V._label).getRegex(),A.reflinkSearch=n(A.reflinkSearch,"g").replace("reflink",A.reflink).replace("nolink",A.nolink).getRegex(),A.normal=u({},A),A.pedantic=u({},A.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",A._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",A._label).getRegex()}),A.gfm=u({},A.normal,{escape:n(A.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),A.gfm.url=n(A.gfm.url,"i").replace("email",A.gfm._extended_email).getRegex(),A.breaks=u({},A.gfm,{br:n(A.br).replace("{2,}","*").getRegex(),text:n(A.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(Se){return Se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(Se){var ve="",he,K,Y=Se.length;for(he=0;he<Y;he++)K=Se.charCodeAt(he),Math.random()>.5&&(K="x"+K.toString(16)),ve+="&#"+K+";";return ve}var ie=function(){function Se(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||me.defaults,this.options.tokenizer=this.options.tokenizer||new $,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:V.normal,inline:A.normal};this.options.pedantic?(K.block=V.pedantic,K.inline=A.pedantic):this.options.gfm&&(K.block=V.gfm,this.options.breaks?K.inline=A.breaks:K.inline=A.gfm),this.tokenizer.rules=K}Se.lex=function(K,Y){var le=new Se(Y);return le.lex(K)},Se.lexInline=function(K,Y){var le=new Se(Y);return le.inlineTokens(K)};var ve=Se.prototype;return ve.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},ve.blockTokens=function(K,Y){var le=this;Y===void 0&&(Y=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(Ue,B,x){return B+"    ".repeat(x.length)});for(var de,Ne,ue,De;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ue){return(de=Ue.call({lexer:le},K,Y))?(K=K.substring(de.raw.length),Y.push(de),!0):!1}))){if(de=this.tokenizer.space(K)){K=K.substring(de.raw.length),de.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(de);continue}if(de=this.tokenizer.code(K)){K=K.substring(de.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+de.raw,Ne.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(de);continue}if(de=this.tokenizer.fences(K)){K=K.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.heading(K)){K=K.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.hr(K)){K=K.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.blockquote(K)){K=K.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.list(K)){K=K.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.html(K)){K=K.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.def(K)){K=K.substring(de.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+de.raw,Ne.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(K)){K=K.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.lheading(K)){K=K.substring(de.raw.length),Y.push(de);continue}if(ue=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ue=1/0,B=K.slice(1),x=void 0;le.options.extensions.startBlock.forEach(function(q){x=q.call({lexer:this},B),typeof x=="number"&&x>=0&&(Ue=Math.min(Ue,x))}),Ue<1/0&&Ue>=0&&(ue=K.substring(0,Ue+1))}(),this.state.top&&(de=this.tokenizer.paragraph(ue))){Ne=Y[Y.length-1],De&&Ne.type==="paragraph"?(Ne.raw+=`
`+de.raw,Ne.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(de),De=ue.length!==K.length,K=K.substring(de.raw.length);continue}if(de=this.tokenizer.text(K)){K=K.substring(de.raw.length),Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+de.raw,Ne.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(de);continue}if(K){var Re="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,Y},ve.inline=function(K,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:K,tokens:Y}),Y},ve.inlineTokens=function(K,Y){var le=this;Y===void 0&&(Y=[]);var de,Ne,ue,De=K,Re,Ue,B;if(this.tokens.links){var x=Object.keys(this.tokens.links);if(x.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)x.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,Re.index)+"["+P("a",Re[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,Re.index)+"["+P("a",Re[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,Re.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(Ue||(B=""),Ue=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(W){return(de=W.call({lexer:le},K,Y))?(K=K.substring(de.raw.length),Y.push(de),!0):!1}))){if(de=this.tokenizer.escape(K)){K=K.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.tag(K)){K=K.substring(de.raw.length),Ne=Y[Y.length-1],Ne&&de.type==="text"&&Ne.type==="text"?(Ne.raw+=de.raw,Ne.text+=de.text):Y.push(de);continue}if(de=this.tokenizer.link(K)){K=K.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(de.raw.length),Ne=Y[Y.length-1],Ne&&de.type==="text"&&Ne.type==="text"?(Ne.raw+=de.raw,Ne.text+=de.text):Y.push(de);continue}if(de=this.tokenizer.emStrong(K,De,B)){K=K.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.codespan(K)){K=K.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.br(K)){K=K.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.del(K)){K=K.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.autolink(K,j)){K=K.substring(de.raw.length),Y.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(K,j))){K=K.substring(de.raw.length),Y.push(de);continue}if(ue=K,this.options.extensions&&this.options.extensions.startInline&&function(){var W=1/0,ee=K.slice(1),se=void 0;le.options.extensions.startInline.forEach(function(Oe){se=Oe.call({lexer:this},ee),typeof se=="number"&&se>=0&&(W=Math.min(W,se))}),W<1/0&&W>=0&&(ue=K.substring(0,W+1))}(),de=this.tokenizer.inlineText(ue,U)){K=K.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(B=de.raw.slice(-1)),Ue=!0,Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=de.raw,Ne.text+=de.text):Y.push(de);continue}if(K){var q="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return Y},D(Se,null,[{key:"rules",get:function(){return{block:V,inline:A}}}]),Se}(),fe=function(){function Se(he){this.options=he||me.defaults}var ve=Se.prototype;return ve.code=function(K,Y,le){var de=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(K,de);Ne!=null&&Ne!==K&&(le=!0,K=Ne)}return K=K.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+g(de,!0)+'">'+(le?K:g(K,!0))+`</code></pre>
`:"<pre><code>"+(le?K:g(K,!0))+`</code></pre>
`},ve.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},ve.html=function(K){return K},ve.heading=function(K,Y,le,de){if(this.options.headerIds){var Ne=this.options.headerPrefix+de.slug(le);return"<h"+Y+' id="'+Ne+'">'+K+"</h"+Y+`>
`}return"<h"+Y+">"+K+"</h"+Y+`>
`},ve.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ve.list=function(K,Y,le){var de=Y?"ol":"ul",Ne=Y&&le!==1?' start="'+le+'"':"";return"<"+de+Ne+`>
`+K+"</"+de+`>
`},ve.listitem=function(K){return"<li>"+K+`</li>
`},ve.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ve.paragraph=function(K){return"<p>"+K+`</p>
`},ve.table=function(K,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+Y+`</table>
`},ve.tablerow=function(K){return`<tr>
`+K+`</tr>
`},ve.tablecell=function(K,Y){var le=Y.header?"th":"td",de=Y.align?"<"+le+' align="'+Y.align+'">':"<"+le+">";return de+K+("</"+le+`>
`)},ve.strong=function(K){return"<strong>"+K+"</strong>"},ve.em=function(K){return"<em>"+K+"</em>"},ve.codespan=function(K){return"<code>"+K+"</code>"},ve.br=function(){return this.options.xhtml?"<br/>":"<br>"},ve.del=function(K){return"<del>"+K+"</del>"},ve.link=function(K,Y,le){if(K=d(this.options.sanitize,this.options.baseUrl,K),K===null)return le;var de='<a href="'+g(K)+'"';return Y&&(de+=' title="'+Y+'"'),de+=">"+le+"</a>",de},ve.image=function(K,Y,le){if(K=d(this.options.sanitize,this.options.baseUrl,K),K===null)return le;var de='<img src="'+K+'" alt="'+le+'"';return Y&&(de+=' title="'+Y+'"'),de+=this.options.xhtml?"/>":">",de},ve.text=function(K){return K},Se}(),Ce=function(){function Se(){}var ve=Se.prototype;return ve.strong=function(K){return K},ve.em=function(K){return K},ve.codespan=function(K){return K},ve.del=function(K){return K},ve.html=function(K){return K},ve.text=function(K){return K},ve.link=function(K,Y,le){return""+le},ve.image=function(K,Y,le){return""+le},ve.br=function(){return""},Se}(),_e=function(){function Se(){this.seen={}}var ve=Se.prototype;return ve.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ve.getNextSafeSlug=function(K,Y){var le=K,de=0;if(this.seen.hasOwnProperty(le)){de=this.seen[K];do de++,le=K+"-"+de;while(this.seen.hasOwnProperty(le))}return Y||(this.seen[K]=de,this.seen[le]=0),le},ve.slug=function(K,Y){Y===void 0&&(Y={});var le=this.serialize(K);return this.getNextSafeSlug(le,Y.dryrun)},Se}(),oe=function(){function Se(he){this.options=he||me.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ce,this.slugger=new _e}Se.parse=function(K,Y){var le=new Se(Y);return le.parse(K)},Se.parseInline=function(K,Y){var le=new Se(Y);return le.parseInline(K)};var ve=Se.prototype;return ve.parse=function(K,Y){Y===void 0&&(Y=!0);var le="",de,Ne,ue,De,Re,Ue,B,x,q,W,ee,se,Oe,ze,Ge,Je,et,ot,it,nt=K.length;for(de=0;de<nt;de++){if(W=K[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[W.type]&&(it=this.options.extensions.renderers[W.type].call({parser:this},W),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(W.type))){le+=it||"";continue}switch(W.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(W.tokens),W.depth,o(this.parseInline(W.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(W.text,W.lang,W.escaped);continue}case"table":{for(x="",B="",De=W.header.length,Ne=0;Ne<De;Ne++)B+=this.renderer.tablecell(this.parseInline(W.header[Ne].tokens),{header:!0,align:W.align[Ne]});for(x+=this.renderer.tablerow(B),q="",De=W.rows.length,Ne=0;Ne<De;Ne++){for(Ue=W.rows[Ne],B="",Re=Ue.length,ue=0;ue<Re;ue++)B+=this.renderer.tablecell(this.parseInline(Ue[ue].tokens),{header:!1,align:W.align[ue]});q+=this.renderer.tablerow(B)}le+=this.renderer.table(x,q);continue}case"blockquote":{q=this.parse(W.tokens),le+=this.renderer.blockquote(q);continue}case"list":{for(ee=W.ordered,se=W.start,Oe=W.loose,De=W.items.length,q="",Ne=0;Ne<De;Ne++)Ge=W.items[Ne],Je=Ge.checked,et=Ge.task,ze="",Ge.task&&(ot=this.renderer.checkbox(Je),Oe?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=ot+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=ot+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:ot}):ze+=ot),ze+=this.parse(Ge.tokens,Oe),q+=this.renderer.listitem(ze,et,Je);le+=this.renderer.list(q,ee,se);continue}case"html":{le+=this.renderer.html(W.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(W.tokens));continue}case"text":{for(q=W.tokens?this.parseInline(W.tokens):W.text;de+1<nt&&K[de+1].type==="text";)W=K[++de],q+=`
`+(W.tokens?this.parseInline(W.tokens):W.text);le+=Y?this.renderer.paragraph(q):q;continue}default:{var at='Token with "'+W.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return le},ve.parseInline=function(K,Y){Y=Y||this.renderer;var le="",de,Ne,ue,De=K.length;for(de=0;de<De;de++){if(Ne=K[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(ue=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),ue!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){le+=ue||"";continue}switch(Ne.type){case"escape":{le+=Y.text(Ne.text);break}case"html":{le+=Y.html(Ne.text);break}case"link":{le+=Y.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,Y));break}case"image":{le+=Y.image(Ne.href,Ne.title,Ne.text);break}case"strong":{le+=Y.strong(this.parseInline(Ne.tokens,Y));break}case"em":{le+=Y.em(this.parseInline(Ne.tokens,Y));break}case"codespan":{le+=Y.codespan(Ne.text);break}case"br":{le+=Y.br();break}case"del":{le+=Y.del(this.parseInline(Ne.tokens,Y));break}case"text":{le+=Y.text(Ne.text);break}default:{var Re='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return le},Se}();function pe(Se,ve,he){if(typeof Se>"u"||Se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");if(typeof ve=="function"&&(he=ve,ve=null),ve=u({},pe.defaults,ve||{}),S(ve),he){var K=ve.highlight,Y;try{Y=ie.lex(Se,ve)}catch(De){return he(De)}var le=function(Re){var Ue;if(!Re)try{ve.walkTokens&&pe.walkTokens(Y,ve.walkTokens),Ue=oe.parse(Y,ve)}catch(B){Re=B}return ve.highlight=K,Re?he(Re):he(null,Ue)};if(!K||K.length<3||(delete ve.highlight,!Y.length))return le();var de=0;pe.walkTokens(Y,function(De){De.type==="code"&&(de++,setTimeout(function(){K(De.text,De.lang,function(Re,Ue){if(Re)return le(Re);Ue!=null&&Ue!==De.text&&(De.text=Ue,De.escaped=!0),de--,de===0&&le()})},0))}),de===0&&le();return}function Ne(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+g(De.message+"",!0)+"</pre>";throw De}try{var ue=ie.lex(Se,ve);if(ve.walkTokens){if(ve.async)return Promise.all(pe.walkTokens(ue,ve.walkTokens)).then(function(){return oe.parse(ue,ve)}).catch(Ne);pe.walkTokens(ue,ve.walkTokens)}return oe.parse(ue,ve)}catch(De){Ne(De)}}pe.options=pe.setOptions=function(Se){return u(pe.defaults,Se),m(pe.defaults),pe},pe.getDefaults=R,pe.defaults=me.defaults,pe.use=function(){for(var Se=arguments.length,ve=new Array(Se),he=0;he<Se;he++)ve[he]=arguments[he];var K=u.apply(void 0,[{}].concat(ve)),Y=pe.defaults.extensions||{renderers:{},childTokens:{}},le;ve.forEach(function(de){if(de.extensions&&(le=!0,de.extensions.forEach(function(ue){if(!ue.name)throw new Error("extension name required");if(ue.renderer){var De=Y.renderers?Y.renderers[ue.name]:null;De?Y.renderers[ue.name]=function(){for(var Re=arguments.length,Ue=new Array(Re),B=0;B<Re;B++)Ue[B]=arguments[B];var x=ue.renderer.apply(this,Ue);return x===!1&&(x=De.apply(this,Ue)),x}:Y.renderers[ue.name]=ue.renderer}if(ue.tokenizer){if(!ue.level||ue.level!=="block"&&ue.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[ue.level]?Y[ue.level].unshift(ue.tokenizer):Y[ue.level]=[ue.tokenizer],ue.start&&(ue.level==="block"?Y.startBlock?Y.startBlock.push(ue.start):Y.startBlock=[ue.start]:ue.level==="inline"&&(Y.startInline?Y.startInline.push(ue.start):Y.startInline=[ue.start]))}ue.childTokens&&(Y.childTokens[ue.name]=ue.childTokens)})),de.renderer&&function(){var ue=pe.defaults.renderer||new fe,De=function(B){var x=ue[B];ue[B]=function(){for(var q=arguments.length,W=new Array(q),ee=0;ee<q;ee++)W[ee]=arguments[ee];var se=de.renderer[B].apply(ue,W);return se===!1&&(se=x.apply(ue,W)),se}};for(var Re in de.renderer)De(Re);K.renderer=ue}(),de.tokenizer&&function(){var ue=pe.defaults.tokenizer||new $,De=function(B){var x=ue[B];ue[B]=function(){for(var q=arguments.length,W=new Array(q),ee=0;ee<q;ee++)W[ee]=arguments[ee];var se=de.tokenizer[B].apply(ue,W);return se===!1&&(se=x.apply(ue,W)),se}};for(var Re in de.tokenizer)De(Re);K.tokenizer=ue}(),de.walkTokens){var Ne=pe.defaults.walkTokens;K.walkTokens=function(ue){var De=[];return De.push(de.walkTokens.call(this,ue)),Ne&&(De=De.concat(Ne.call(this,ue))),De}}le&&(K.extensions=Y),pe.setOptions(K)})},pe.walkTokens=function(Se,ve){for(var he=[],K=function(){var Ne=le.value;switch(he=he.concat(ve.call(pe,Ne)),Ne.type){case"table":{for(var ue=N(Ne.header),De;!(De=ue()).done;){var Re=De.value;he=he.concat(pe.walkTokens(Re.tokens,ve))}for(var Ue=N(Ne.rows),B;!(B=Ue()).done;)for(var x=B.value,q=N(x),W;!(W=q()).done;){var ee=W.value;he=he.concat(pe.walkTokens(ee.tokens,ve))}break}case"list":{he=he.concat(pe.walkTokens(Ne.items,ve));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[Ne.type]?pe.defaults.extensions.childTokens[Ne.type].forEach(function(se){he=he.concat(pe.walkTokens(Ne[se],ve))}):Ne.tokens&&(he=he.concat(pe.walkTokens(Ne.tokens,ve)))}},Y=N(Se),le;!(le=Y()).done;)K();return he},pe.parseInline=function(Se,ve){if(typeof Se>"u"||Se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");ve=u({},pe.defaults,ve||{}),S(ve);try{var he=ie.lexInline(Se,ve);return ve.walkTokens&&pe.walkTokens(he,ve.walkTokens),oe.parseInline(he,ve)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+g(K.message+"",!0)+"</pre>";throw K}},pe.Parser=oe,pe.parser=oe.parse,pe.Renderer=fe,pe.TextRenderer=Ce,pe.Lexer=ie,pe.lexer=ie.lex,pe.Tokenizer=$,pe.Slugger=_e,pe.parse=pe;var ne=pe.options,Ie=pe.setOptions,xe=pe.use,re=pe.walkTokens,F=pe.parseInline,Z=pe,be=oe.parse,Le=ie.lex;me.Lexer=ie,me.Parser=oe,me.Renderer=fe,me.Slugger=_e,me.TextRenderer=Ce,me.Tokenizer=$,me.getDefaults=R,me.lexer=Le,me.marked=pe,me.options=ne,me.parse=Z,me.parseInline=F,me.parser=be,me.setOptions=Ie,me.use=xe,me.walkTokens=re,Object.defineProperty(me,"__esModule",{value:!0})}),define(Pe[125],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getKoreanAltChars=D;function D(r){const o=N(r);if(o&&o.length>0)return new Uint32Array(o)}let O=0;const T=new Uint32Array(10);function N(r){if(O=0,R(r,_,4352),O>0||(R(r,l,4449),O>0)||(R(r,w,4520),O>0)||(R(r,g,12593),O))return T.subarray(0,O);if(r>=44032&&r<=55203){const o=r-44032,s=o%588,n=Math.floor(o/588),i=Math.floor(s/28),a=s%28-1;if(n<_.length?R(n,_,0):4352+n-12593<g.length&&R(4352+n,g,12593),i<l.length?R(i,l,0):4449+i-12593<g.length&&R(4449+i-12593,g,12593),a>=0&&(a<w.length?R(a,w,0):4520+a-12593<g.length&&R(4520+a-12593,g,12593)),O>0)return T.subarray(0,O)}}function R(r,o,s){r>=s&&r<s+o.length&&m(o[r-s])}function m(r){r!==0&&(T[O++]=r&255,r>>8&&(T[O++]=r>>8&255),r>>16&&(T[O++]=r>>16&255))}var h;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(h||(h={}));var y;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(y||(y={}));var L;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(L||(L={}));const _=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),w=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),g=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[126],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=void 0,e.clamp=D,e.rot=O;function D(m,h,y){return Math.min(Math.max(m,h),y)}function O(m,h){return(h+m%h)%h}class T{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=T;class N{constructor(){this._n=1,this._val=0}update(h){return this._val=this._val+(h-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=N;class R{constructor(h){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(h),this._values.fill(0,0,h)}update(h){const y=this._values[this._index];return this._values[this._index]=h,this._index=(this._index+1)%this._values.length,this._sum-=y,this._sum+=h,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=R}),function(){function me(T){const N=[];typeof T=="number"&&N.push("code/timeOrigin",T);function R(h){N.push(h,Date.now())}function m(){const h=[];for(let y=0;y<N.length;y+=2)h.push({name:N[y],startTime:N[y+1]});return h}return{mark:R,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const R of performance.getEntriesByType("mark"))N.push({name:R.name,startTime:Math.round(T+R.startTime)});return N}};if(typeof process=="object"){const T=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function D(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=D(O))}(),define(Pe[127],Te([1,0,39]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WellDefinedPrefixTree=void 0;const O=Symbol("unset");class T{constructor(){this.root=new R,this._size=0}get size(){return this._size}get nodes(){return this.root.children?.values()||D.Iterable.empty()}insert(h,y,L){this.opNode(h,_=>_._value=y,L)}mutate(h,y){this.opNode(h,L=>L._value=y(L._value===O?void 0:L._value))}delete(h){const y=this.getPathToKey(h);if(!y)return;let L=y.length-1;const _=y[L].node._value;if(_!==O){for(this._size--,y[L].node._value=O;L>0;L--){const{node:l,part:w}=y[L];if(l.children?.size||l._value!==O)break;y[L-1].node.children.delete(w)}return _}}*deleteRecursive(h){const y=this.getPathToKey(h);if(!y)return;const L=y[y.length-1].node;for(let _=y.length-1;_>0;_--){const l=y[_-1];if(l.node.children.delete(y[_].part),l.node.children.size>0||l.node._value!==O)break}for(const _ of N(L))_._value!==O&&(this._size--,yield _._value)}find(h){let y=this.root;for(const L of h){const _=y.children?.get(L);if(!_)return;y=_}return y._value===O?void 0:y._value}hasKeyOrParent(h){let y=this.root;for(const L of h){const _=y.children?.get(L);if(!_)return!1;if(_._value!==O)return!0;y=_}return!1}hasKeyOrChildren(h){let y=this.root;for(const L of h){const _=y.children?.get(L);if(!_)return!1;y=_}return!0}hasKey(h){let y=this.root;for(const L of h){const _=y.children?.get(L);if(!_)return!1;y=_}return y._value!==O}getPathToKey(h){const y=[{part:"",node:this.root}];let L=0;for(const _ of h){const l=y[L].node.children?.get(_);if(!l)return;y.push({part:_,node:l}),L++}return y}opNode(h,y,L){let _=this.root;for(const g of h){if(_.children)if(_.children.has(g))_=_.children.get(g);else{const r=new R;_.children.set(g,r),_=r}else{const r=new R;_.children=new Map([[g,r]]),_=r}L?.(_)}const l=_._value===O?0:1;y(_);const w=_._value===O?0:1;this._size+=w-l}*values(){for(const{_value:h}of N(this.root))h!==O&&(yield h)}}e.WellDefinedPrefixTree=T;function*N(m){const h=[m];for(;h.length>0;){const y=h.pop();if(yield y,y.children)for(const L of y.children.values())h.push(L)}}class R{constructor(){this._value=O}get value(){return this._value===O?void 0:this._value}set value(h){this._value=h===void 0?O:h}}}),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var O in D)(typeof exports=="object"?exports:me)[O]=D[O]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function D(O){if(e[O])return e[O].exports;var T=e[O]={i:O,l:!1,exports:{}};return me[O].call(T.exports,T,T.exports,D),T.l=!0,T.exports}return D.m=me,D.c=e,D.d=function(O,T,N){D.o(O,T)||Object.defineProperty(O,T,{enumerable:!0,get:N})},D.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},D.t=function(O,T){if(1&T&&(O=D(O)),8&T||4&T&&typeof O=="object"&&O&&O.__esModule)return O;var N=Object.create(null);if(D.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:O}),2&T&&typeof O!="string")for(var R in O)D.d(N,R,function(m){return O[m]}.bind(null,R));return N},D.n=function(O){var T=O&&O.__esModule?function(){return O.default}:function(){return O};return D.d(T,"a",T),T},D.o=function(O,T){return Object.prototype.hasOwnProperty.call(O,T)},D.p="",D(D.s=0)}([function(me,e,D){(function(O){var T;e=me.exports=xe,T=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],h=e.src=[],y=0,L=y++;h[L]="0|[1-9]\\d*";var _=y++;h[_]="[0-9]+";var l=y++;h[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=y++;h[w]="("+h[L]+")\\.("+h[L]+")\\.("+h[L]+")";var g=y++;h[g]="("+h[_]+")\\.("+h[_]+")\\.("+h[_]+")";var r=y++;h[r]="(?:"+h[L]+"|"+h[l]+")";var o=y++;h[o]="(?:"+h[_]+"|"+h[l]+")";var s=y++;h[s]="(?:-("+h[r]+"(?:\\."+h[r]+")*))";var n=y++;h[n]="(?:-?("+h[o]+"(?:\\."+h[o]+")*))";var i=y++;h[i]="[0-9A-Za-z-]+";var a=y++;h[a]="(?:\\+("+h[i]+"(?:\\."+h[i]+")*))";var d=y++,t="v?"+h[w]+h[s]+"?"+h[a]+"?";h[d]="^"+t+"$";var E="[v=\\s]*"+h[g]+h[n]+"?"+h[a]+"?",c=y++;h[c]="^"+E+"$";var p=y++;h[p]="((?:<|>)?=?)";var b=y++;h[b]=h[_]+"|x|X|\\*";var v=y++;h[v]=h[L]+"|x|X|\\*";var u=y++;h[u]="[v=\\s]*("+h[v]+")(?:\\.("+h[v]+")(?:\\.("+h[v]+")(?:"+h[s]+")?"+h[a]+"?)?)?";var C=y++;h[C]="[v=\\s]*("+h[b]+")(?:\\.("+h[b]+")(?:\\.("+h[b]+")(?:"+h[n]+")?"+h[a]+"?)?)?";var f=y++;h[f]="^"+h[p]+"\\s*"+h[u]+"$";var I=y++;h[I]="^"+h[p]+"\\s*"+h[C]+"$";var S=y++;h[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=y++;h[P]="(?:~>?)";var k=y++;h[k]="(\\s*)"+h[P]+"\\s+",m[k]=new RegExp(h[k],"g");var H=y++;h[H]="^"+h[P]+h[u]+"$";var $=y++;h[$]="^"+h[P]+h[C]+"$";var V=y++;h[V]="(?:\\^)";var A=y++;h[A]="(\\s*)"+h[V]+"\\s+",m[A]=new RegExp(h[A],"g");var U=y++;h[U]="^"+h[V]+h[u]+"$";var j=y++;h[j]="^"+h[V]+h[C]+"$";var ie=y++;h[ie]="^"+h[p]+"\\s*("+E+")$|^$";var fe=y++;h[fe]="^"+h[p]+"\\s*("+t+")$|^$";var Ce=y++;h[Ce]="(\\s*)"+h[p]+"\\s*("+E+"|"+h[u]+")",m[Ce]=new RegExp(h[Ce],"g");var _e=y++;h[_e]="^\\s*("+h[u]+")\\s+-\\s+("+h[u]+")\\s*$";var oe=y++;h[oe]="^\\s*("+h[C]+")\\s+-\\s+("+h[C]+")\\s*$";var pe=y++;h[pe]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)T(ne,h[ne]),m[ne]||(m[ne]=new RegExp(h[ne]));function Ie(x,q){if(x instanceof xe)return x;if(typeof x!="string"||x.length>N||!(q?m[c]:m[d]).test(x))return null;try{return new xe(x,q)}catch{return null}}function xe(x,q){if(x instanceof xe){if(x.loose===q)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof xe))return new xe(x,q);T("SemVer",x,q),this.loose=q;var W=x.trim().match(q?m[c]:m[d]);if(!W)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+W[1],this.minor=+W[2],this.patch=+W[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");W[4]?this.prerelease=W[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var se=+ee;if(se>=0&&se<R)return se}return ee}):this.prerelease=[],this.build=W[5]?W[5].split("."):[],this.format()}e.parse=Ie,e.valid=function(x,q){var W=Ie(x,q);return W?W.version:null},e.clean=function(x,q){var W=Ie(x.trim().replace(/^[=v]+/,""),q);return W?W.version:null},e.SemVer=xe,xe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},xe.prototype.toString=function(){return this.version},xe.prototype.compare=function(x){return T("SemVer.compare",this.version,this.loose,x),x instanceof xe||(x=new xe(x,this.loose)),this.compareMain(x)||this.comparePre(x)},xe.prototype.compareMain=function(x){return x instanceof xe||(x=new xe(x,this.loose)),F(this.major,x.major)||F(this.minor,x.minor)||F(this.patch,x.patch)},xe.prototype.comparePre=function(x){if(x instanceof xe||(x=new xe(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var q=0;do{var W=this.prerelease[q],ee=x.prerelease[q];if(T("prerelease compare",q,W,ee),W===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(W===void 0)return-1;if(W!==ee)return F(W,ee)}while(++q)},xe.prototype.inc=function(x,q){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",q),this.inc("pre",q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",q),this.inc("pre",q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var W=this.prerelease.length;--W>=0;)typeof this.prerelease[W]=="number"&&(this.prerelease[W]++,W=-2);W===-1&&this.prerelease.push(0)}q&&(this.prerelease[0]===q?isNaN(this.prerelease[1])&&(this.prerelease=[q,0]):this.prerelease=[q,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,q,W,ee){typeof W=="string"&&(ee=W,W=void 0);try{return new xe(x,W).inc(q,ee).version}catch{return null}},e.diff=function(x,q){if(Se(x,q))return null;var W=Ie(x),ee=Ie(q);if(W.prerelease.length||ee.prerelease.length){for(var se in W)if((se==="major"||se==="minor"||se==="patch")&&W[se]!==ee[se])return"pre"+se;return"prerelease"}for(var se in W)if((se==="major"||se==="minor"||se==="patch")&&W[se]!==ee[se])return se},e.compareIdentifiers=F;var re=/^[0-9]+$/;function F(x,q){var W=re.test(x),ee=re.test(q);return W&&ee&&(x=+x,q=+q),W&&!ee?-1:ee&&!W?1:x<q?-1:x>q?1:0}function Z(x,q,W){return new xe(x,W).compare(new xe(q,W))}function be(x,q,W){return Z(x,q,W)>0}function Le(x,q,W){return Z(x,q,W)<0}function Se(x,q,W){return Z(x,q,W)===0}function ve(x,q,W){return Z(x,q,W)!==0}function he(x,q,W){return Z(x,q,W)>=0}function K(x,q,W){return Z(x,q,W)<=0}function Y(x,q,W,ee){var se;switch(q){case"===":typeof x=="object"&&(x=x.version),typeof W=="object"&&(W=W.version),se=x===W;break;case"!==":typeof x=="object"&&(x=x.version),typeof W=="object"&&(W=W.version),se=x!==W;break;case"":case"=":case"==":se=Se(x,W,ee);break;case"!=":se=ve(x,W,ee);break;case">":se=be(x,W,ee);break;case">=":se=he(x,W,ee);break;case"<":se=Le(x,W,ee);break;case"<=":se=K(x,W,ee);break;default:throw new TypeError("Invalid operator: "+q)}return se}function le(x,q){if(x instanceof le){if(x.loose===q)return x;x=x.value}if(!(this instanceof le))return new le(x,q);T("comparator",x,q),this.loose=q,this.parse(x),this.semver===de?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function(x,q){return F(q,x)},e.major=function(x,q){return new xe(x,q).major},e.minor=function(x,q){return new xe(x,q).minor},e.patch=function(x,q){return new xe(x,q).patch},e.compare=Z,e.compareLoose=function(x,q){return Z(x,q,!0)},e.rcompare=function(x,q,W){return Z(q,x,W)},e.sort=function(x,q){return x.sort(function(W,ee){return e.compare(W,ee,q)})},e.rsort=function(x,q){return x.sort(function(W,ee){return e.rcompare(W,ee,q)})},e.gt=be,e.lt=Le,e.eq=Se,e.neq=ve,e.gte=he,e.lte=K,e.cmp=Y,e.Comparator=le;var de={};function Ne(x,q){if(x instanceof Ne)return x.loose===q?x:new Ne(x.raw,q);if(x instanceof le)return new Ne(x.value,q);if(!(this instanceof Ne))return new Ne(x,q);if(this.loose=q,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(W){return this.parseRange(W.trim())},this).filter(function(W){return W.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function ue(x){return!x||x.toLowerCase()==="x"||x==="*"}function De(x,q,W,ee,se,Oe,ze,Ge,Je,et,ot,it,nt){return((q=ue(W)?"":ue(ee)?">="+W+".0.0":ue(se)?">="+W+"."+ee+".0":">="+q)+" "+(Ge=ue(Je)?"":ue(et)?"<"+(+Je+1)+".0.0":ue(ot)?"<"+Je+"."+(+et+1)+".0":it?"<="+Je+"."+et+"."+ot+"-"+it:"<="+Ge)).trim()}function Re(x,q){for(var W=0;W<x.length;W++)if(!x[W].test(q))return!1;if(q.prerelease.length){for(W=0;W<x.length;W++)if(T(x[W].semver),x[W].semver!==de&&x[W].semver.prerelease.length>0){var ee=x[W].semver;if(ee.major===q.major&&ee.minor===q.minor&&ee.patch===q.patch)return!0}return!1}return!0}function Ue(x,q,W){try{q=new Ne(q,W)}catch{return!1}return q.test(x)}function B(x,q,W,ee){var se,Oe,ze,Ge,Je;switch(x=new xe(x,ee),q=new Ne(q,ee),W){case">":se=be,Oe=K,ze=Le,Ge=">",Je=">=";break;case"<":se=Le,Oe=he,ze=be,Ge="<",Je="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(x,q,ee))return!1;for(var et=0;et<q.set.length;++et){var ot=q.set[et],it=null,nt=null;if(ot.forEach(function(at){at.semver===de&&(at=new le(">=0.0.0")),it=it||at,nt=nt||at,se(at.semver,it.semver,ee)?it=at:ze(at.semver,nt.semver,ee)&&(nt=at)}),it.operator===Ge||it.operator===Je||(!nt.operator||nt.operator===Ge)&&Oe(x,nt.semver)||nt.operator===Je&&ze(x,nt.semver))return!1}return!0}le.prototype.parse=function(x){var q=this.loose?m[ie]:m[fe],W=x.match(q);if(!W)throw new TypeError("Invalid comparator: "+x);this.operator=W[1],this.operator==="="&&(this.operator=""),W[2]?this.semver=new xe(W[2],this.loose):this.semver=de},le.prototype.toString=function(){return this.value},le.prototype.test=function(x){return T("Comparator.test",x,this.loose),this.semver===de||(typeof x=="string"&&(x=new xe(x,this.loose)),Y(x,this.operator,this.semver,this.loose))},le.prototype.intersects=function(x,q){if(!(x instanceof le))throw new TypeError("a Comparator is required");var W;if(this.operator==="")return W=new Ne(x.value,q),Ue(this.value,W,q);if(x.operator==="")return W=new Ne(this.value,q),Ue(x.semver,W,q);var ee=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),se=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Oe=this.semver.version===x.semver.version,ze=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Ge=Y(this.semver,"<",x.semver,q)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Je=Y(this.semver,">",x.semver,q)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ee||se||Oe&&ze||Ge||Je},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(x){var q=this.loose;x=x.trim(),T("range",x,q);var W=q?m[oe]:m[_e];x=x.replace(W,De),T("hyphen replace",x),x=x.replace(m[Ce],"$1$2$3"),T("comparator trim",x,m[Ce]),x=(x=(x=x.replace(m[k],"$1~")).replace(m[A],"$1^")).split(/\s+/).join(" ");var ee=q?m[ie]:m[fe],se=x.split(" ").map(function(Oe){return function(ze,Ge){return T("comp",ze),ze=function(Je,et){return Je.trim().split(/\s+/).map(function(ot){return function(it,nt){T("caret",it,nt);var at=nt?m[j]:m[U];return it.replace(at,function(ft,Be,st,Q,X){var ge;return T("caret",it,ft,Be,st,Q,X),ue(Be)?ge="":ue(st)?ge=">="+Be+".0.0 <"+(+Be+1)+".0.0":ue(Q)?ge=Be==="0"?">="+Be+"."+st+".0 <"+Be+"."+(+st+1)+".0":">="+Be+"."+st+".0 <"+(+Be+1)+".0.0":X?(T("replaceCaret pr",X),X.charAt(0)!=="-"&&(X="-"+X),ge=Be==="0"?st==="0"?">="+Be+"."+st+"."+Q+X+" <"+Be+"."+st+"."+(+Q+1):">="+Be+"."+st+"."+Q+X+" <"+Be+"."+(+st+1)+".0":">="+Be+"."+st+"."+Q+X+" <"+(+Be+1)+".0.0"):(T("no pr"),ge=Be==="0"?st==="0"?">="+Be+"."+st+"."+Q+" <"+Be+"."+st+"."+(+Q+1):">="+Be+"."+st+"."+Q+" <"+Be+"."+(+st+1)+".0":">="+Be+"."+st+"."+Q+" <"+(+Be+1)+".0.0"),T("caret return",ge),ge})}(ot,et)}).join(" ")}(ze,Ge),T("caret",ze),ze=function(Je,et){return Je.trim().split(/\s+/).map(function(ot){return function(it,nt){var at=nt?m[$]:m[H];return it.replace(at,function(ft,Be,st,Q,X){var ge;return T("tilde",it,ft,Be,st,Q,X),ue(Be)?ge="":ue(st)?ge=">="+Be+".0.0 <"+(+Be+1)+".0.0":ue(Q)?ge=">="+Be+"."+st+".0 <"+Be+"."+(+st+1)+".0":X?(T("replaceTilde pr",X),X.charAt(0)!=="-"&&(X="-"+X),ge=">="+Be+"."+st+"."+Q+X+" <"+Be+"."+(+st+1)+".0"):ge=">="+Be+"."+st+"."+Q+" <"+Be+"."+(+st+1)+".0",T("tilde return",ge),ge})}(ot,et)}).join(" ")}(ze,Ge),T("tildes",ze),ze=function(Je,et){return T("replaceXRanges",Je,et),Je.split(/\s+/).map(function(ot){return function(it,nt){it=it.trim();var at=nt?m[I]:m[f];return it.replace(at,function(ft,Be,st,Q,X,ge){T("xRange",it,ft,Be,st,Q,X,ge);var Ve=ue(st),Qe=Ve||ue(Q),Ae=Qe||ue(X);return Be==="="&&Ae&&(Be=""),Ve?ft=Be===">"||Be==="<"?"<0.0.0":"*":Be&&Ae?(Qe&&(Q=0),Ae&&(X=0),Be===">"?(Be=">=",Qe?(st=+st+1,Q=0,X=0):Ae&&(Q=+Q+1,X=0)):Be==="<="&&(Be="<",Qe?st=+st+1:Q=+Q+1),ft=Be+st+"."+Q+"."+X):Qe?ft=">="+st+".0.0 <"+(+st+1)+".0.0":Ae&&(ft=">="+st+"."+Q+".0 <"+st+"."+(+Q+1)+".0"),T("xRange return",ft),ft})}(ot,et)}).join(" ")}(ze,Ge),T("xrange",ze),ze=function(Je,et){return T("replaceStars",Je,et),Je.trim().replace(m[pe],"")}(ze,Ge),T("stars",ze),ze}(Oe,q)}).join(" ").split(/\s+/);return this.loose&&(se=se.filter(function(Oe){return!!Oe.match(ee)})),se=se.map(function(Oe){return new le(Oe,q)})},Ne.prototype.intersects=function(x,q){if(!(x instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(W){return W.every(function(ee){return x.set.some(function(se){return se.every(function(Oe){return ee.intersects(Oe,q)})})})})},e.toComparators=function(x,q){return new Ne(x,q).set.map(function(W){return W.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new xe(x,this.loose));for(var q=0;q<this.set.length;q++)if(Re(this.set[q],x))return!0;return!1},e.satisfies=Ue,e.maxSatisfying=function(x,q,W){var ee=null,se=null;try{var Oe=new Ne(q,W)}catch{return null}return x.forEach(function(ze){Oe.test(ze)&&(ee&&se.compare(ze)!==-1||(se=new xe(ee=ze,W)))}),ee},e.minSatisfying=function(x,q,W){var ee=null,se=null;try{var Oe=new Ne(q,W)}catch{return null}return x.forEach(function(ze){Oe.test(ze)&&(ee&&se.compare(ze)!==1||(se=new xe(ee=ze,W)))}),ee},e.validRange=function(x,q){try{return new Ne(x,q).range||"*"}catch{return null}},e.ltr=function(x,q,W){return B(x,q,"<",W)},e.gtr=function(x,q,W){return B(x,q,">",W)},e.outside=B,e.prerelease=function(x,q){var W=Ie(x,q);return W&&W.prerelease.length?W.prerelease:null},e.intersects=function(x,q,W){return x=new Ne(x,W),q=new Ne(q,W),x.intersects(q)},e.coerce=function(x){if(x instanceof xe)return x;if(typeof x!="string")return null;var q=x.match(m[S]);return q==null?null:Ie((q[1]||"0")+"."+(q[2]||"0")+"."+(q[3]||"0"))}}).call(this,D(1))},function(me,e){var D,O,T=me.exports={};function N(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function m(o){if(D===setTimeout)return setTimeout(o,0);if((D===N||!D)&&setTimeout)return D=setTimeout,setTimeout(o,0);try{return D(o,0)}catch{try{return D.call(null,o,0)}catch{return D.call(this,o,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:N}catch{D=N}try{O=typeof clearTimeout=="function"?clearTimeout:R}catch{O=R}})();var h,y=[],L=!1,_=-1;function l(){L&&h&&(L=!1,h.length?y=h.concat(y):_=-1,y.length&&w())}function w(){if(!L){var o=m(l);L=!0;for(var s=y.length;s;){for(h=y,y=[];++_<s;)h&&h[_].run();_=-1,s=y.length}h=null,L=!1,function(n){if(O===clearTimeout)return clearTimeout(n);if((O===R||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(n);try{O(n)}catch{try{return O.call(null,n)}catch{return O.call(this,n)}}}(o)}}function g(o,s){this.fun=o,this.array=s}function r(){}T.nextTick=function(o){var s=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)s[n-1]=arguments[n];y.push(new g(o,s)),y.length!==1||L||m(w)},g.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=r,T.addListener=r,T.once=r,T.off=r,T.removeListener=r,T.removeAllListeners=r,T.emit=r,T.prependListener=r,T.prependOnceListener=r,T.listeners=function(o){return[]},T.binding=function(o){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(o){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(Pe[128],Te([1,0,14,6]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=T,e.isReadableStream=N,e.isReadableBufferedStream=R,e.newWriteableStream=m,e.consumeReadable=y,e.peekReadable=L,e.consumeStream=_,e.listenStream=l,e.peekStream=w,e.toStream=g,e.emptyStream=r,e.toReadable=o,e.transform=s,e.prefixedReadable=n,e.prefixedStream=i;function T(a){const d=a;return d?typeof d.read=="function":!1}function N(a){const d=a;return d?[d.on,d.pause,d.resume,d.destroy].every(t=>typeof t=="function"):!1}function R(a){const d=a;return d?N(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}function m(a,d){return new h(a,d)}class h{constructor(d,t){this.reducer=d,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d<"u"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(t=>t(d))}emitError(d){this.listeners.error.length===0?(0,D.onUnexpectedError)(d):this.listeners.error.slice(0).forEach(t=>t(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,t){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(d,t){if(this.state.destroyed)return;let E;switch(d){case"data":E=this.listeners.data;break;case"end":E=this.listeners.end;break;case"error":E=this.listeners.error;break}if(E){const c=E.indexOf(t);c>=0&&E.splice(c,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(E=>E())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(a,d){const t=[];let E;for(;(E=a.read())!==null;)t.push(E);return d(t)}function L(a,d,t){const E=[];let c;for(;(c=a.read())!==null&&E.length<t;)E.push(c);return c===null&&E.length>0?d(E):{read:()=>{if(E.length>0)return E.shift();if(typeof c<"u"){const p=c;return c=void 0,p}return a.read()}}}function _(a,d){return new Promise((t,E)=>{const c=[];l(a,{onData:p=>{d&&c.push(p)},onError:p=>{d?E(p):t(void 0)},onEnd:()=>{t(d?d(c):void 0)}})})}function l(a,d,t){a.on("error",E=>{t?.isCancellationRequested||d.onError(E)}),a.on("end",()=>{t?.isCancellationRequested||d.onEnd()}),a.on("data",E=>{t?.isCancellationRequested||d.onData(E)})}function w(a,d){return new Promise((t,E)=>{const c=new O.DisposableStore,p=[],b=C=>{if(p.push(C),p.length>d)return c.dispose(),a.pause(),t({stream:a,buffer:p,ended:!1})},v=C=>(c.dispose(),E(C)),u=()=>(c.dispose(),t({stream:a,buffer:p,ended:!0}));c.add((0,O.toDisposable)(()=>a.removeListener("error",v))),a.on("error",v),c.add((0,O.toDisposable)(()=>a.removeListener("end",u))),a.on("end",u),c.add((0,O.toDisposable)(()=>a.removeListener("data",b))),a.on("data",b)})}function g(a,d){const t=m(d);return t.end(a),t}function r(){const a=m(()=>{throw new Error("not supported")});return a.end(),a}function o(a){let d=!1;return{read:()=>d?null:(d=!0,a)}}function s(a,d,t){const E=m(t);return l(a,{onData:c=>E.write(d.data(c)),onError:c=>E.error(d.error?d.error(c):c),onEnd:()=>E.end()}),E}function n(a,d,t){let E=!1;return{read:()=>{const c=d.read();return E?c:(E=!0,c!==null?t([a,c]):a)}}}function i(a,d,t){let E=!1;const c=m(t);return l(d,{onData:p=>E?c.write(p):(E=!0,c.write(t([a,p]))),onError:p=>c.error(p),onEnd:()=>{E||(E=!0,c.write(a)),c.end()}}),c}}),define(Pe[22],Te([1,0,40,128]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=y,e.readUInt16LE=L,e.writeUInt16LE=_,e.readUInt32BE=l,e.writeUInt32BE=w,e.readUInt32LE=g,e.writeUInt32LE=r,e.readUInt8=o,e.writeUInt8=s,e.readableToBuffer=n,e.bufferToReadable=i,e.streamToBuffer=a,e.bufferedStreamToBuffer=d,e.bufferToStream=t,e.streamToBufferReadableStream=E,e.newWriteableBufferStream=c,e.prefixedBufferReadable=p,e.prefixedBufferStream=b,e.decodeBase64=v,e.encodeBase64=f;const T=typeof Buffer<"u",N=new D.Lazy(()=>new Uint8Array(256));let R,m;class h{static alloc(S){return T?new h(Buffer.allocUnsafe(S)):new h(new Uint8Array(S))}static wrap(S){return T&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new h(S)}static fromString(S,P){return!(P?.dontUseNodeBuffer||!1)&&T?new h(Buffer.from(S)):(R||(R=new TextEncoder),new h(R.encode(S)))}static fromByteArray(S){const P=h.alloc(S.length);for(let k=0,H=S.length;k<H;k++)P.buffer[k]=S[k];return P}static concat(S,P){if(typeof P>"u"){P=0;for(let $=0,V=S.length;$<V;$++)P+=S[$].byteLength}const k=h.alloc(P);let H=0;for(let $=0,V=S.length;$<V;$++){const A=S[$];k.set(A,H),H+=A.byteLength}return k}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=h.alloc(this.byteLength);return S.set(this),S}toString(){return T?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(S,P){return new h(this.buffer.subarray(S,P))}set(S,P){if(S instanceof h)this.buffer.set(S.buffer,P);else if(S instanceof Uint8Array)this.buffer.set(S,P);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),P);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return l(this.buffer,S)}writeUInt32BE(S,P){w(this.buffer,S,P)}readUInt32LE(S){return g(this.buffer,S)}writeUInt32LE(S,P){r(this.buffer,S,P)}readUInt8(S){return o(this.buffer,S)}writeUInt8(S,P){s(this.buffer,S,P)}indexOf(S,P=0){return y(this.buffer,S instanceof h?S.buffer:S,P)}}e.VSBuffer=h;function y(I,S,P=0){const k=S.byteLength,H=I.byteLength;if(k===0)return 0;if(k===1)return I.indexOf(S[0]);if(k>H-P)return-1;const $=N.value;$.fill(S.length);for(let j=0;j<S.length;j++)$[S[j]]=S.length-j-1;let V=P+S.length-1,A=V,U=-1;for(;V<H;)if(I[V]===S[A]){if(A===0){U=V;break}V--,A--}else V+=Math.max(S.length-A,$[I[V]]),A=S.length-1;return U}function L(I,S){return I[S+0]<<0>>>0|I[S+1]<<8>>>0}function _(I,S,P){I[P+0]=S&255,S=S>>>8,I[P+1]=S&255}function l(I,S){return I[S]*2**24+I[S+1]*2**16+I[S+2]*2**8+I[S+3]}function w(I,S,P){I[P+3]=S,S=S>>>8,I[P+2]=S,S=S>>>8,I[P+1]=S,S=S>>>8,I[P]=S}function g(I,S){return I[S+0]<<0>>>0|I[S+1]<<8>>>0|I[S+2]<<16>>>0|I[S+3]<<24>>>0}function r(I,S,P){I[P+0]=S&255,S=S>>>8,I[P+1]=S&255,S=S>>>8,I[P+2]=S&255,S=S>>>8,I[P+3]=S&255}function o(I,S){return I[S]}function s(I,S,P){I[P]=S}function n(I){return O.consumeReadable(I,S=>h.concat(S))}function i(I){return O.toReadable(I)}function a(I){return O.consumeStream(I,S=>h.concat(S))}async function d(I){return I.ended?h.concat(I.buffer):h.concat([...I.buffer,await a(I.stream)])}function t(I){return O.toStream(I,S=>h.concat(S))}function E(I){return O.transform(I,{data:S=>typeof S=="string"?h.fromString(S):h.wrap(S)},S=>h.concat(S))}function c(I){return O.newWriteableStream(S=>h.concat(S),I)}function p(I,S){return O.prefixedReadable(I,S,P=>h.concat(P))}function b(I,S){return O.prefixedStream(I,S,P=>h.concat(P))}function v(I){let S=0,P=0,k=0;const H=new Uint8Array(Math.floor(I.length/4*3)),$=A=>{switch(P){case 3:H[k++]=S|A,P=0;break;case 2:H[k++]=S|A>>>2,S=A<<6,P=3;break;case 1:H[k++]=S|A>>>4,S=A<<4,P=2;break;default:S=A<<2,P=1}};for(let A=0;A<I.length;A++){const U=I.charCodeAt(A);if(U>=65&&U<=90)$(U-65);else if(U>=97&&U<=122)$(U-97+26);else if(U>=48&&U<=57)$(U-48+52);else if(U===43||U===45)$(62);else if(U===47||U===95)$(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${I[A]}`)}}const V=k;for(;P>0;)$(0);return h.wrap(H).slice(0,V)}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:I},S=!0,P=!1){const k=P?C:u;let H="";const $=I.byteLength%3;let V=0;for(;V<I.byteLength-$;V+=3){const A=I[V+0],U=I[V+1],j=I[V+2];H+=k[A>>>2],H+=k[(A<<4|U>>>4)&63],H+=k[(U<<2|j>>>6)&63],H+=k[j&63]}if($===1){const A=I[V+0];H+=k[A>>>2],H+=k[A<<4&63],S&&(H+="==")}else if($===2){const A=I[V+0],U=I[V+1];H+=k[A>>>2],H+=k[(A<<4|U>>>4)&63],H+=k[U<<2&63],S&&(H+="=")}return H}}),define(Pe[129],Te([1,0,28,125,15]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FuzzyScoreOptions=e.FuzzyScore=e.matchesPrefix=e.matchesStrictPrefix=void 0,e.or=N,e.matchesContiguousSubString=m,e.matchesSubString=h,e.isUpper=_,e.matchesCamelCase=v,e.matchesWords=u,e.matchesFuzzy=k,e.matchesFuzzy2=H,e.anyScore=$,e.createMatches=V,e.isPatternInWord=Z,e.fuzzyScore=ve,e.fuzzyScoreGracefulAggressive=Y,e.fuzzyScoreGraceful=le;function N(...ue){return function(De,Re){for(let Ue=0,B=ue.length;Ue<B;Ue++){const x=ue[Ue](De,Re);if(x)return x}return null}}e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(ue,De,Re){if(!Re||Re.length<De.length)return null;let Ue;return ue?Ue=T.startsWithIgnoreCase(Re,De):Ue=Re.indexOf(De)===0,Ue?De.length>0?[{start:0,end:De.length}]:[]:null}function m(ue,De){const Re=De.toLowerCase().indexOf(ue.toLowerCase());return Re===-1?null:[{start:Re,end:Re+ue.length}]}function h(ue,De){return y(ue.toLowerCase(),De.toLowerCase(),0,0)}function y(ue,De,Re,Ue){if(Re===ue.length)return[];if(Ue===De.length)return null;if(ue[Re]===De[Ue]){let B=null;return(B=y(ue,De,Re+1,Ue+1))?a({start:Ue,end:Ue+1},B):null}return y(ue,De,Re,Ue+1)}function L(ue){return 97<=ue&&ue<=122}function _(ue){return 65<=ue&&ue<=90}function l(ue){return 48<=ue&&ue<=57}function w(ue){return ue===32||ue===9||ue===10||ue===13}const g=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ue=>g.add(ue.charCodeAt(0)));function r(ue){return w(ue)||g.has(ue)}function o(ue,De){return ue===De||r(ue)&&r(De)}const s=new Map;function n(ue){if(s.has(ue))return s.get(ue);let De;const Re=(0,O.getKoreanAltChars)(ue);return Re&&(De=Re),s.set(ue,De),De}function i(ue){return L(ue)||_(ue)||l(ue)}function a(ue,De){return De.length===0?De=[ue]:ue.end===De[0].start?De[0].start=ue.start:De.unshift(ue),De}function d(ue,De){for(let Re=De;Re<ue.length;Re++){const Ue=ue.charCodeAt(Re);if(_(Ue)||l(Ue)||Re>0&&!i(ue.charCodeAt(Re-1)))return Re}return ue.length}function t(ue,De,Re,Ue){if(Re===ue.length)return[];if(Ue===De.length)return null;if(ue[Re]!==De[Ue].toLowerCase())return null;{let B=null,x=Ue+1;for(B=t(ue,De,Re+1,Ue+1);!B&&(x=d(De,x))<De.length;)B=t(ue,De,Re+1,x),x++;return B===null?null:a({start:Ue,end:Ue+1},B)}}function E(ue){let De=0,Re=0,Ue=0,B=0,x=0;for(let Oe=0;Oe<ue.length;Oe++)x=ue.charCodeAt(Oe),_(x)&&De++,L(x)&&Re++,i(x)&&Ue++,l(x)&&B++;const q=De/ue.length,W=Re/ue.length,ee=Ue/ue.length,se=B/ue.length;return{upperPercent:q,lowerPercent:W,alphaPercent:ee,numericPercent:se}}function c(ue){const{upperPercent:De,lowerPercent:Re}=ue;return Re===0&&De>.6}function p(ue){const{upperPercent:De,lowerPercent:Re,alphaPercent:Ue,numericPercent:B}=ue;return Re>.2&&De<.8&&Ue>.6&&B<.2}function b(ue){let De=0,Re=0,Ue=0,B=0;for(let x=0;x<ue.length;x++)Ue=ue.charCodeAt(x),_(Ue)&&De++,L(Ue)&&Re++,w(Ue)&&B++;return(De===0||Re===0)&&B===0?ue.length<=30:De<=5}function v(ue,De){if(!De||(De=De.trim(),De.length===0)||!b(ue))return null;De.length>60&&(De=De.substring(0,60));const Re=E(De);if(!p(Re)){if(!c(Re))return null;De=De.toLowerCase()}let Ue=null,B=0;for(ue=ue.toLowerCase();B<De.length&&(Ue=t(ue,De,0,B))===null;)B=d(De,B+1);return Ue}function u(ue,De,Re=!1){if(!De||De.length===0)return null;let Ue=null,B=0;for(ue=ue.toLowerCase(),De=De.toLowerCase();B<De.length&&(Ue=C(ue,De,0,B,Re),Ue===null);)B=f(De,B+1);return Ue}function C(ue,De,Re,Ue,B){let x=0;if(Re===ue.length)return[];if(Ue===De.length)return null;if(!o(ue.charCodeAt(Re),De.charCodeAt(Ue))){const ee=n(ue.charCodeAt(Re));if(!ee)return null;for(let se=0;se<ee.length;se++)if(!o(ee[se],De.charCodeAt(Ue+se)))return null;x+=ee.length-1}let q=null,W=Ue+x+1;if(q=C(ue,De,Re+1,W,B),!B)for(;!q&&(W=f(De,W))<De.length;)q=C(ue,De,Re+1,W,B),W++;if(!q)return null;if(ue.charCodeAt(Re)!==De.charCodeAt(Ue)){const ee=n(ue.charCodeAt(Re));if(!ee)return q;for(let se=0;se<ee.length;se++)if(ee[se]!==De.charCodeAt(Ue+se))return q}return a({start:Ue,end:Ue+x+1},q)}function f(ue,De){for(let Re=De;Re<ue.length;Re++)if(r(ue.charCodeAt(Re))||Re>0&&r(ue.charCodeAt(Re-1)))return Re;return ue.length}const I=N(e.matchesPrefix,v,m),S=N(e.matchesPrefix,v,h),P=new D.LRUCache(1e4);function k(ue,De,Re=!1){if(typeof ue!="string"||typeof De!="string")return null;let Ue=P.get(ue);Ue||(Ue=new RegExp(T.convertSimple2RegExpPattern(ue),"i"),P.set(ue,Ue));const B=Ue.exec(De);return B?[{start:B.index,end:B.index+B[0].length}]:Re?S(ue,De):I(ue,De)}function H(ue,De){const Re=ve(ue,ue.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Re?V(Re):null}function $(ue,De,Re,Ue,B,x){const q=Math.min(13,ue.length);for(;Re<q;Re++){const W=ve(ue,De,Re,Ue,B,x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(W)return W}return[0,x]}function V(ue){if(typeof ue>"u")return[];const De=[],Re=ue[1];for(let Ue=ue.length-1;Ue>1;Ue--){const B=ue[Ue]+Re,x=De[De.length-1];x&&x.end===B?x.end=B+1:De.push({start:B,end:B+1})}return De}const A=128;function U(){const ue=[],De=[];for(let Re=0;Re<=A;Re++)De[Re]=0;for(let Re=0;Re<=A;Re++)ue.push(De.slice(0));return ue}function j(ue){const De=[];for(let Re=0;Re<=ue;Re++)De[Re]=0;return De}const ie=j(2*A),fe=j(2*A),Ce=U(),_e=U(),oe=U(),pe=!1;function ne(ue,De,Re,Ue,B){function x(W,ee,se=" "){for(;W.length<ee;)W=se+W;return W}let q=` |   |${Ue.split("").map(W=>x(W,3)).join("|")}
`;for(let W=0;W<=Re;W++)W===0?q+=" |":q+=`${De[W-1]}|`,q+=ue[W].slice(0,B+1).map(ee=>x(ee.toString(),3)).join("|")+`
`;return q}function Ie(ue,De,Re,Ue){ue=ue.substr(De),Re=Re.substr(Ue),console.log(ne(_e,ue,ue.length,Re,Re.length)),console.log(ne(oe,ue,ue.length,Re,Re.length)),console.log(ne(Ce,ue,ue.length,Re,Re.length))}function xe(ue,De){if(De<0||De>=ue.length)return!1;const Re=ue.codePointAt(De);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(Re)}}function re(ue,De){if(De<0||De>=ue.length)return!1;switch(ue.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function F(ue,De,Re){return De[ue]!==Re[ue]}function Z(ue,De,Re,Ue,B,x,q=!1){for(;De<Re&&B<x;)ue[De]===Ue[B]&&(q&&(ie[De]=B),De+=1),B+=1;return De===Re}var be;(function(ue){ue[ue.Diag=1]="Diag",ue[ue.Left=2]="Left",ue[ue.LeftLeft=3]="LeftLeft"})(be||(be={}));var Le;(function(ue){ue.Default=[-100,0];function De(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}ue.isDefault=De})(Le||(e.FuzzyScore=Le={}));class Se{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,Re){this.firstMatchCanBeWeak=De,this.boostFullMatch=Re}}e.FuzzyScoreOptions=Se;function ve(ue,De,Re,Ue,B,x,q=Se.default){const W=ue.length>A?A:ue.length,ee=Ue.length>A?A:Ue.length;if(Re>=W||x>=ee||W-Re>ee-x||!Z(De,Re,W,B,x,ee,!0))return;he(W,ee,Re,x,De,B);let se=1,Oe=1,ze=Re,Ge=x;const Je=[!1];for(se=1,ze=Re;ze<W;se++,ze++){const at=ie[ze],ft=fe[ze],Be=ze+1<W?fe[ze+1]:ee;for(Oe=at-x+1,Ge=at;Ge<Be;Oe++,Ge++){let st=Number.MIN_SAFE_INTEGER,Q=!1;Ge<=ft&&(st=K(ue,De,ze,Re,Ue,B,Ge,ee,x,Ce[se-1][Oe-1]===0,Je));let X=0;st!==Number.MAX_SAFE_INTEGER&&(Q=!0,X=st+_e[se-1][Oe-1]);const ge=Ge>at,Ve=ge?_e[se][Oe-1]+(Ce[se][Oe-1]>0?-5:0):0,Qe=Ge>at+1&&Ce[se][Oe-1]>0,Ae=Qe?_e[se][Oe-2]+(Ce[se][Oe-2]>0?-5:0):0;if(Qe&&(!ge||Ae>=Ve)&&(!Q||Ae>=X))_e[se][Oe]=Ae,oe[se][Oe]=3,Ce[se][Oe]=0;else if(ge&&(!Q||Ve>=X))_e[se][Oe]=Ve,oe[se][Oe]=2,Ce[se][Oe]=0;else if(Q)_e[se][Oe]=X,oe[se][Oe]=1,Ce[se][Oe]=Ce[se-1][Oe-1]+1;else throw new Error("not possible")}}if(pe&&Ie(ue,Re,Ue,x),!Je[0]&&!q.firstMatchCanBeWeak)return;se--,Oe--;const et=[_e[se][Oe],x];let ot=0,it=0;for(;se>=1;){let at=Oe;do{const ft=oe[se][at];if(ft===3)at=at-2;else if(ft===2)at=at-1;else break}while(at>=1);ot>1&&De[Re+se-1]===B[x+Oe-1]&&!F(at+x-1,Ue,B)&&ot+1>Ce[se][at]&&(at=Oe),at===Oe?ot++:ot=1,it||(it=at),se--,Oe=at-1,et.push(Oe)}ee===W&&q.boostFullMatch&&(et[0]+=2);const nt=it-W;return et[0]-=nt,et}function he(ue,De,Re,Ue,B,x){let q=ue-1,W=De-1;for(;q>=Re&&W>=Ue;)B[q]===x[W]&&(fe[q]=W,q--),W--}function K(ue,De,Re,Ue,B,x,q,W,ee,se,Oe){if(De[Re]!==x[q])return Number.MIN_SAFE_INTEGER;let ze=1,Ge=!1;return q===Re-Ue?ze=ue[Re]===B[q]?7:5:F(q,B,x)&&(q===0||!F(q-1,B,x))?(ze=ue[Re]===B[q]?7:5,Ge=!0):xe(x,q)&&(q===0||!xe(x,q-1))?ze=5:(xe(x,q-1)||re(x,q-1))&&(ze=5,Ge=!0),ze>1&&Re===Ue&&(Oe[0]=!0),Ge||(Ge=F(q,B,x)||xe(x,q-1)||re(x,q-1)),Re===Ue?q>ee&&(ze-=Ge?3:5):se?ze+=Ge?2:0:ze+=Ge?0:1,q+1===W&&(ze-=Ge?3:5),ze}function Y(ue,De,Re,Ue,B,x,q){return de(ue,De,Re,Ue,B,x,!0,q)}function le(ue,De,Re,Ue,B,x,q){return de(ue,De,Re,Ue,B,x,!1,q)}function de(ue,De,Re,Ue,B,x,q,W){let ee=ve(ue,De,Re,Ue,B,x,W);if(ee&&!q)return ee;if(ue.length>=3){const se=Math.min(7,ue.length-1);for(let Oe=Re+1;Oe<se;Oe++){const ze=Ne(ue,Oe);if(ze){const Ge=ve(ze,ze.toLowerCase(),Re,Ue,B,x,W);Ge&&(Ge[0]-=3,(!ee||Ge[0]>ee[0])&&(ee=Ge))}}}return ee}function Ne(ue,De){if(De+1>=ue.length)return;const Re=ue[De],Ue=ue[De+1];if(Re!==Ue)return ue.slice(0,De)+Ue+Re+ue.slice(De+2)}}),define(Pe[32],Te([1,0,15]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(O||(O={})),function(T){const N="error",R="warning",m="warn",h="info",y="ignore";function L(l){return l?D.equalsIgnoreCase(N,l)?T.Error:D.equalsIgnoreCase(R,l)||D.equalsIgnoreCase(m,l)?T.Warning:D.equalsIgnoreCase(h,l)?T.Info:T.Ignore:T.Ignore}T.fromValue=L;function _(l){switch(l){case T.Error:return N;case T.Warning:return R;case T.Info:return h;default:return y}}T.toString=_}(O||(O={})),e.default=O}),define(Pe[130],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Pe[52],Te([1,0,18,15]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class T{constructor(){this._value="",this._pos=0}reset(w){return this._value=w,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(w){const g=w.charCodeAt(0),r=this._value.charCodeAt(this._pos);return g-r}value(){return this._value[this._pos]}}e.StringIterator=T;class N{constructor(w=!0){this._caseSensitive=w}reset(w){return this._value=w,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let w=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(w)this._from++;else break;else w=!1;return this}cmp(w){return this._caseSensitive?(0,O.compareSubstring)(w,this._value,0,w.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(w,this._value,0,w.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=N;class R{constructor(w=!0,g=!0){this._splitOnBackslash=w,this._caseSensitive=g}reset(w){this._from=0,this._to=0,this._value=w,this._valueLen=w.length;for(let g=w.length-1;g>=0;g--,this._valueLen--){const r=this._value.charCodeAt(g);if(!(r===47||this._splitOnBackslash&&r===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let w=!0;for(;this._to<this._valueLen;this._to++){const g=this._value.charCodeAt(this._to);if(g===47||this._splitOnBackslash&&g===92)if(w)this._from++;else break;else w=!1}return this}cmp(w){return this._caseSensitive?(0,O.compareSubstring)(w,this._value,0,w.length,this._from,this._to):(0,O.compareSubstringIgnoreCase)(w,this._value,0,w.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=R;var m;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(m||(m={}));class h{constructor(w,g){this._ignorePathCasing=w,this._ignoreQueryAndFragment=g,this._states=[],this._stateIdx=0}reset(w){return this._value=w,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new R(!1,!this._ignorePathCasing(w)),this._pathIterator.reset(w.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(w)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(w){if(this._states[this._stateIdx]===1)return(0,O.compareIgnoreCase)(w,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,O.compareIgnoreCase)(w,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(w);if(this._states[this._stateIdx]===4)return(0,O.compare)(w,this._value.query);if(this._states[this._stateIdx]===5)return(0,O.compare)(w,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(L||(L={}));class _{static forUris(w=()=>!1,g=()=>!1){return new _(new h(w,g))}static forPaths(w=!1){return new _(new R(void 0,!w))}static forStrings(){return new _(new T)}static forConfigKeys(){return new _(new N)}constructor(w){this._iter=w}clear(){this._root=void 0}fill(w,g){if(g){const r=g.slice(0);(0,D.shuffle)(r);for(const o of r)this.set(o,w)}else{const r=w.slice(0);(0,D.shuffle)(r);for(const o of r)this.set(o[0],o[1])}}set(w,g){const r=this._iter.reset(w);let o;this._root||(this._root=new y,this._root.segment=r.value());const s=[];for(o=this._root;;){const i=r.cmp(o.segment);if(i>0)o.left||(o.left=new y,o.left.segment=r.value()),s.push([-1,o]),o=o.left;else if(i<0)o.right||(o.right=new y,o.right.segment=r.value()),s.push([1,o]),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new y,o.mid.segment=r.value()),s.push([0,o]),o=o.mid;else break}const n=o.value;o.value=g,o.key=w;for(let i=s.length-1;i>=0;i--){const a=s[i][1];a.updateHeight();const d=a.balanceFactor();if(d<-1||d>1){const t=s[i][0],E=s[i+1][0];if(t===1&&E===1)s[i][1]=a.rotateLeft();else if(t===-1&&E===-1)s[i][1]=a.rotateRight();else if(t===1&&E===-1)a.right=s[i+1][1]=s[i+1][1].rotateRight(),s[i][1]=a.rotateLeft();else if(t===-1&&E===1)a.left=s[i+1][1]=s[i+1][1].rotateLeft(),s[i][1]=a.rotateRight();else throw new Error;if(i>0)switch(s[i-1][0]){case-1:s[i-1][1].left=s[i][1];break;case 1:s[i-1][1].right=s[i][1];break;case 0:s[i-1][1].mid=s[i][1];break}else this._root=s[0][1]}}return n}get(w){return this._getNode(w)?.value}_getNode(w){const g=this._iter.reset(w);let r=this._root;for(;r;){const o=g.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(g.hasNext())g.next(),r=r.mid;else break}return r}has(w){const g=this._getNode(w);return!(g?.value===void 0&&g?.mid===void 0)}delete(w){return this._delete(w,!1)}deleteSuperstr(w){return this._delete(w,!0)}_delete(w,g){const r=this._iter.reset(w),o=[];let s=this._root;for(;s;){const n=r.cmp(s.segment);if(n>0)o.push([-1,s]),s=s.left;else if(n<0)o.push([1,s]),s=s.right;else if(r.hasNext())r.next(),o.push([0,s]),s=s.mid;else break}if(s){if(g?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const n=this._min(s.right);if(n.key){const{key:i,value:a,segment:d}=n;this._delete(n.key,!1),s.key=i,s.value=a,s.segment=d}}else{const n=s.left??s.right;if(o.length>0){const[i,a]=o[o.length-1];switch(i){case-1:a.left=n;break;case 0:a.mid=n;break;case 1:a.right=n;break}}else this._root=n}for(let n=o.length-1;n>=0;n--){const i=o[n][1];i.updateHeight();const a=i.balanceFactor();if(a>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),o[n][1]=i.rotateLeft()):a<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),o[n][1]=i.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this._root=o[0][1]}}}_min(w){for(;w.left;)w=w.left;return w}findSubstr(w){const g=this._iter.reset(w);let r=this._root,o;for(;r;){const s=g.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(g.hasNext())g.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(w){return this._findSuperstrOrElement(w,!1)}_findSuperstrOrElement(w,g){const r=this._iter.reset(w);let o=this._root;for(;o;){const s=r.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this._entries(o.mid):g?o.value:void 0}}hasElementOrSubtree(w){return this._findSuperstrOrElement(w,!0)!==void 0}forEach(w){for(const[g,r]of this)w(r,g)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(w){const g=[];return this._dfsEntries(w,g),g[Symbol.iterator]()}_dfsEntries(w,g){w&&(w.left&&this._dfsEntries(w.left,g),w.value&&g.push([w.key,w.value]),w.mid&&this._dfsEntries(w.mid,g),w.right&&this._dfsEntries(w.right,g))}_isBalanced(){const w=g=>{if(!g)return!0;const r=g.balanceFactor();return r<-1||r>1?!1:w(g.left)&&w(g.right)};return w(this._root)}}e.TernarySearchTree=_}),define(Pe[41],Te([1,0,91]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.themeColorFromId=T;var O;(function(R){function m(h){return h&&typeof h=="object"&&typeof h.id=="string"}R.isThemeColor=m})(O||(e.ThemeColor=O={}));function T(R){return{id:R}}var N;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function h(n){const i=m.exec(n.id);if(!i)return h(D.Codicon.error);const[,a,d]=i,t=["codicon","codicon-"+a];return d&&t.push("codicon-modifier-"+d.substring(1)),t}R.asClassNameArray=h;function y(n){return h(n).join(" ")}R.asClassName=y;function L(n){return"."+h(n).join(".")}R.asCSSSelector=L;function _(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||O.isThemeColor(n.color))}R.isThemeIcon=_;const l=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function w(n){const i=l.exec(n);if(!i)return;const[,a]=i;return{id:a}}R.fromString=w;function g(n){return{id:n}}R.fromId=g;function r(n,i){let a=n.id;const d=a.lastIndexOf("~");return d!==-1&&(a=a.substring(0,d)),i&&(a=`${a}~${i}`),{id:a}}R.modify=r;function o(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}R.getModifier=o;function s(n,i){return n.id===i.id&&n.color?.id===i.color?.id}R.isEqual=s})(N||(e.ThemeIcon=N={}))}),define(Pe[131],Te([1,0,129,15,41]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeIcons=h,e.markdownEscapeEscapedIcons=L,e.stripIcons=l,e.getCodiconAriaLabel=w,e.parseLabelWithIcons=r,e.matchesFuzzyIconAware=o;const N="$(",R=new RegExp(`\\$\\(${T.ThemeIcon.iconNameExpression}(?:${T.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${R.source}`,"g");function h(s){return s.replace(m,(n,i)=>i?n:`\\${n}`)}const y=new RegExp(`\\\\${R.source}`,"g");function L(s){return s.replace(y,n=>`\\${n}`)}const _=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function l(s){return s.indexOf(N)===-1?s:s.replace(_,(n,i,a,d)=>a?n:i||d||"")}function w(s){return s?s.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const g=new RegExp(`\\$\\(${T.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(s){g.lastIndex=0;let n="";const i=[];let a=0;for(;;){const d=g.lastIndex,t=g.exec(s),E=s.substring(d,t?.index);if(E.length>0){n+=E;for(let c=0;c<E.length;c++)i.push(a)}if(!t)break;a+=t[0].length}return{text:n,iconOffsets:i}}function o(s,n,i=!1){const{text:a,iconOffsets:d}=n;if(!d||d.length===0)return(0,D.matchesFuzzy)(s,a,i);const t=(0,O.ltrim)(a," "),E=a.length-t.length,c=(0,D.matchesFuzzy)(s,t,i);if(c)for(const p of c){const b=d[p.start+E]+E;p.start+=b,p.end+=b}return c}}),define(Pe[34],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=O;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(T){return D.test(T)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(m){for(let h=0;h<m.length;h++)m[h]=Math.floor(Math.random()*256);return m};const N=new Uint8Array(16),R=[];for(let m=0;m<256;m++)R.push(m.toString(16).padStart(2,"0"));return function(){T(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let h=0,y="";return y+=R[N[h++]],y+=R[N[h++]],y+=R[N[h++]],y+=R[N[h++]],y+="-",y+=R[N[h++]],y+=R[N[h++]],y+="-",y+=R[N[h++]],y+=R[N[h++]],y+="-",y+=R[N[h++]],y+=R[N[h++]],y+="-",y+=R[N[h++]],y+=R[N[h++]],y+=R[N[h++]],y+=R[N[h++]],y+=R[N[h++]],y+=R[N[h++]],y}}()}),define(Pe[132],Te([1,0,18,39,34]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=void 0,e.createStringDataTransferItem=N,e.createFileDataTransferItem=R,e.matchesMimeType=y;function N(_){return{asString:async()=>_,asFile:()=>{},value:typeof _=="string"?_:void 0}}function R(_,l,w){const g={id:(0,T.generateUuid)(),name:_,uri:l,data:w};return{asString:async()=>"",asFile:()=>g,value:void 0}}class m{constructor(){this._entries=new Map}get size(){let l=0;for(const w of this._entries)l++;return l}has(l){return this._entries.has(this.toKey(l))}matches(l){const w=[...this._entries.keys()];return O.Iterable.some(this,([g,r])=>r.asFile())&&w.push("files"),L(h(l),w)}get(l){return this._entries.get(this.toKey(l))?.[0]}append(l,w){const g=this._entries.get(l);g?g.push(w):this._entries.set(this.toKey(l),[w])}replace(l,w){this._entries.set(this.toKey(l),[w])}delete(l){this._entries.delete(this.toKey(l))}*[Symbol.iterator](){for(const[l,w]of this._entries)for(const g of w)yield[l,g]}toKey(l){return h(l)}}e.VSDataTransfer=m;function h(_){return _.toLowerCase()}function y(_,l){return L(h(_),l.map(h))}function L(_,l){if(_==="*/*")return l.length>0;if(l.includes(_))return!0;const w=_.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[g,r,o]=w;return o==="*"?l.some(s=>s.startsWith(r+"/")):!1}e.UriList=Object.freeze({create:_=>(0,D.distinct)(_.map(l=>l.toString())).join(`\r
`),split:_=>_.split(`\r
`),parse:_=>e.UriList.split(_).filter(l=>!l.startsWith("#"))})}),define(Pe[133],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.countEOL=O;var D;(function(T){T[T.Unknown=0]="Unknown",T[T.Invalid=3]="Invalid",T[T.LF=1]="LF",T[T.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function O(T){let N=0,R=0,m=0,h=0;for(let y=0,L=T.length;y<L;y++){const _=T.charCodeAt(y);_===13?(N===0&&(R=y),N++,y+1<L&&T.charCodeAt(y+1)===10?(h|=2,y++):h|=3,m=y+1):_===10&&(h|=1,N===0&&(R=y),N++,m=y+1)}return N===0&&(R=T.length),[N,R,T.length-m,h]}}),define(Pe[134],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[135],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var D;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class O{constructor(m){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=m.open,this.close=m.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(m.notIn))for(let h=0,y=m.notIn.length;h<y;h++)switch(m.notIn[h]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(m,h){if(m.getTokenCount()===0)return!0;const y=m.findTokenIndexAtOffset(h-2),L=m.getStandardTokenType(y);return this.isOK(L)}_findNeutralCharacterInRange(m,h){for(let y=m;y<=h;y++){const L=String.fromCharCode(y);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=O;class T{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const h of m)N(this.autoClosingPairsOpenByStart,h.open.charAt(0),h),N(this.autoClosingPairsOpenByEnd,h.open.charAt(h.open.length-1),h),N(this.autoClosingPairsCloseByStart,h.close.charAt(0),h),N(this.autoClosingPairsCloseByEnd,h.close.charAt(h.close.length-1),h),h.close.length===1&&h.open.length===1&&N(this.autoClosingPairsCloseSingleChar,h.close,h)}}e.AutoClosingPairs=T;function N(R,m,h){R.has(m)?R.get(m).push(h):R.set(m,[h])}}),define(Pe[136],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SENTINEL=e.NodeColor=e.TreeNode=void 0,e.leftest=T,e.righttest=N,e.leftRotate=y,e.rightRotate=L,e.rbDelete=_,e.fixInsert=l,e.updateTreeMetadata=w,e.recomputeTreeMetadata=g;class D{constructor(o,s){this.piece=o,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.SENTINEL)return T(this.right);let o=this;for(;o.parent!==e.SENTINEL&&o.parent.left!==o;)o=o.parent;return o.parent===e.SENTINEL?e.SENTINEL:o.parent}prev(){if(this.left!==e.SENTINEL)return N(this.left);let o=this;for(;o.parent!==e.SENTINEL&&o.parent.right!==o;)o=o.parent;return o.parent===e.SENTINEL?e.SENTINEL:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.TreeNode=D;var O;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(O||(e.NodeColor=O={})),e.SENTINEL=new D(null,0),e.SENTINEL.parent=e.SENTINEL,e.SENTINEL.left=e.SENTINEL,e.SENTINEL.right=e.SENTINEL,e.SENTINEL.color=0;function T(r){for(;r.left!==e.SENTINEL;)r=r.left;return r}function N(r){for(;r.right!==e.SENTINEL;)r=r.right;return r}function R(r){return r===e.SENTINEL?0:r.size_left+r.piece.length+R(r.right)}function m(r){return r===e.SENTINEL?0:r.lf_left+r.piece.lineFeedCnt+m(r.right)}function h(){e.SENTINEL.parent=e.SENTINEL}function y(r,o){const s=o.right;s.size_left+=o.size_left+(o.piece?o.piece.length:0),s.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=s.left,s.left!==e.SENTINEL&&(s.left.parent=o),s.parent=o.parent,o.parent===e.SENTINEL?r.root=s:o.parent.left===o?o.parent.left=s:o.parent.right=s,s.left=o,o.parent=s}function L(r,o){const s=o.left;o.left=s.right,s.right!==e.SENTINEL&&(s.right.parent=o),s.parent=o.parent,o.size_left-=s.size_left+(s.piece?s.piece.length:0),o.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),o.parent===e.SENTINEL?r.root=s:o===o.parent.right?o.parent.right=s:o.parent.left=s,s.right=o,o.parent=s}function _(r,o){let s,n;if(o.left===e.SENTINEL?(n=o,s=n.right):o.right===e.SENTINEL?(n=o,s=n.left):(n=T(o.right),s=n.right),n===r.root){r.root=s,s.color=0,o.detach(),h(),r.root.parent=e.SENTINEL;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=s:n.parent.right=s,n===o?(s.parent=n.parent,g(r,s)):(n.parent===o?s.parent=n:s.parent=n.parent,g(r,s),n.left=o.left,n.right=o.right,n.parent=o.parent,n.color=o.color,o===r.root?r.root=n:o===o.parent.left?o.parent.left=n:o.parent.right=n,n.left!==e.SENTINEL&&(n.left.parent=n),n.right!==e.SENTINEL&&(n.right.parent=n),n.size_left=o.size_left,n.lf_left=o.lf_left,g(r,n)),o.detach(),s.parent.left===s){const d=R(s),t=m(s);if(d!==s.parent.size_left||t!==s.parent.lf_left){const E=d-s.parent.size_left,c=t-s.parent.lf_left;s.parent.size_left=d,s.parent.lf_left=t,w(r,s.parent,E,c)}}if(g(r,s.parent),i){h();return}let a;for(;s!==r.root&&s.color===0;)s===s.parent.left?(a=s.parent.right,a.color===1&&(a.color=0,s.parent.color=1,y(r,s.parent),a=s.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.right.color===0&&(a.left.color=0,a.color=1,L(r,a),a=s.parent.right),a.color=s.parent.color,s.parent.color=0,a.right.color=0,y(r,s.parent),s=r.root)):(a=s.parent.left,a.color===1&&(a.color=0,s.parent.color=1,L(r,s.parent),a=s.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.left.color===0&&(a.right.color=0,a.color=1,y(r,a),a=s.parent.left),a.color=s.parent.color,s.parent.color=0,a.left.color=0,L(r,s.parent),s=r.root));s.color=0,h()}function l(r,o){for(g(r,o);o!==r.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const s=o.parent.parent.right;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,y(r,o)),o.parent.color=0,o.parent.parent.color=1,L(r,o.parent.parent))}else{const s=o.parent.parent.left;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,L(r,o)),o.parent.color=0,o.parent.parent.color=1,y(r,o.parent.parent))}r.root.color=0}function w(r,o,s,n){for(;o!==r.root&&o!==e.SENTINEL;)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=n),o=o.parent}function g(r,o){let s=0,n=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,s=R(o.left)-o.size_left,n=m(o.left)-o.lf_left,o.size_left+=s,o.lf_left+=n;o!==r.root&&(s!==0||n!==0);)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=n),o=o.parent}}}),define(Pe[92],Te([1,0,93,29,94,136,95]),function(me,e,D,O,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeBase=e.StringBuffer=e.Piece=void 0,e.createLineStartsFast=L,e.createLineStarts=_;const m=65535;function h(s){let n;return s[s.length-1]<65536?n=new Uint16Array(s.length):n=new Uint32Array(s.length),n.set(s,0),n}class y{constructor(n,i,a,d,t){this.lineStarts=n,this.cr=i,this.lf=a,this.crlf=d,this.isBasicASCII=t}}function L(s,n=!0){const i=[0];let a=1;for(let d=0,t=s.length;d<t;d++){const E=s.charCodeAt(d);E===13?d+1<t&&s.charCodeAt(d+1)===10?(i[a++]=d+2,d++):i[a++]=d+1:E===10&&(i[a++]=d+1)}return n?h(i):i}function _(s,n){s.length=0,s[0]=0;let i=1,a=0,d=0,t=0,E=!0;for(let p=0,b=n.length;p<b;p++){const v=n.charCodeAt(p);v===13?p+1<b&&n.charCodeAt(p+1)===10?(t++,s[i++]=p+2,p++):(a++,s[i++]=p+1):v===10?(d++,s[i++]=p+1):E&&v!==9&&(v<32||v>126)&&(E=!1)}const c=new y(h(s),a,d,t,E);return s.length=0,c}class l{constructor(n,i,a,d,t){this.bufferIndex=n,this.start=i,this.end=a,this.lineFeedCnt=d,this.length=t}}e.Piece=l;class w{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.StringBuffer=w;class g{constructor(n,i){this._pieces=[],this._tree=n,this._BOM=i,this._index=0,n.root!==N.SENTINEL&&n.iterate(n.root,a=>(a!==N.SENTINEL&&this._pieces.push(a.piece),!0))}read(){return this._pieces.length===0?this._index===0?(this._index++,this._BOM):null:this._index>this._pieces.length-1?null:this._index===0?this._BOM+this._tree.getPieceContent(this._pieces[this._index++]):this._tree.getPieceContent(this._pieces[this._index++])}}class r{constructor(n){this._limit=n,this._cache=[]}get(n){for(let i=this._cache.length-1;i>=0;i--){const a=this._cache[i];if(a.nodeStartOffset<=n&&a.nodeStartOffset+a.node.piece.length>=n)return a}return null}get2(n){for(let i=this._cache.length-1;i>=0;i--){const a=this._cache[i];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<n&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=n)return a}return null}set(n){this._cache.length>=this._limit&&this._cache.shift(),this._cache.push(n)}validate(n){let i=!1;const a=this._cache;for(let d=0;d<a.length;d++){const t=a[d];if(t.node.parent===null||t.nodeStartOffset>=n){a[d]=null,i=!0;continue}}if(i){const d=[];for(const t of a)t!==null&&d.push(t);this._cache=d}}}class o{constructor(n,i,a){this.create(n,i,a)}create(n,i,a){this._buffers=[new w("",[0])],this._lastChangeBufferPos={line:0,column:0},this.root=N.SENTINEL,this._lineCnt=1,this._length=0,this._EOL=i,this._EOLLength=i.length,this._EOLNormalized=a;let d=null;for(let t=0,E=n.length;t<E;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=L(n[t].buffer));const c=new l(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this._buffers.push(n[t]),d=this.rbInsertRight(d,c)}this._searchCache=new r(1),this._lastVisitedLine={lineNumber:0,value:""},this.computeBufferMetadata()}normalizeEOL(n){const i=m,a=i-Math.floor(i/3),d=a*2;let t="",E=0;const c=[];if(this.iterate(this.root,p=>{const b=this.getNodeContent(p),v=b.length;if(E<=a||E+v<d)return t+=b,E+=v,!0;const u=t.replace(/\r\n|\r|\n/g,n);return c.push(new w(u,L(u))),t=b,E=v,!0}),E>0){const p=t.replace(/\r\n|\r|\n/g,n);c.push(new w(p,L(p)))}this.create(c,n,!0)}getEOL(){return this._EOL}setEOL(n){this._EOL=n,this._EOLLength=this._EOL.length,this.normalizeEOL(n)}createSnapshot(n){return new g(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,d=>{if(d===N.SENTINEL)return!0;const t=this.getNodeContent(d),E=t.length,c=n.nodeAt(i),p=n.nodeAt(i+E),b=n.getValueInRange2(c,p);return i+=E,t===b})}getOffsetAt(n,i){let a=0,d=this.root;for(;d!==N.SENTINEL;)if(d.left!==N.SENTINEL&&d.lf_left+1>=n)d=d.left;else if(d.lf_left+d.piece.lineFeedCnt+1>=n){a+=d.size_left;const t=this.getAccumulatedValue(d,n-d.lf_left-2);return a+=t+i-1}else n-=d.lf_left+d.piece.lineFeedCnt,a+=d.size_left+d.piece.length,d=d.right;return a}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,a=0;const d=n;for(;i!==N.SENTINEL;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.getIndexOf(i,n-i.size_left);if(a+=i.lf_left+t.index,t.index===0){const E=this.getOffsetAt(a+1,1),c=d-E;return new D.Position(a+1,c+1)}return new D.Position(a+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,a+=i.lf_left+i.piece.lineFeedCnt,i.right===N.SENTINEL){const t=this.getOffsetAt(a+1,1),E=d-n-t;return new D.Position(a+1,E+1)}else i=i.right;return new D.Position(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const a=this.nodeAt2(n.startLineNumber,n.startColumn),d=this.nodeAt2(n.endLineNumber,n.endColumn),t=this.getValueInRange2(a,d);return i?i!==this._EOL||!this._EOLNormalized?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this._EOLNormalized?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const c=n.node,p=this._buffers[c.piece.bufferIndex].buffer,b=this.offsetInBuffer(c.piece.bufferIndex,c.piece.start);return p.substring(b+n.remainder,b+i.remainder)}let a=n.node;const d=this._buffers[a.piece.bufferIndex].buffer,t=this.offsetInBuffer(a.piece.bufferIndex,a.piece.start);let E=d.substring(t+n.remainder,t+a.piece.length);for(a=a.next();a!==N.SENTINEL;){const c=this._buffers[a.piece.bufferIndex].buffer,p=this.offsetInBuffer(a.piece.bufferIndex,a.piece.start);if(a===i.node){E+=c.substring(p,p+i.remainder);break}else E+=c.substr(p,a.piece.length);a=a.next()}return E}getLinesContent(){const n=[];let i=0,a="",d=!1;return this.iterate(this.root,t=>{if(t===N.SENTINEL)return!0;const E=t.piece;let c=E.length;if(c===0)return!0;const p=this._buffers[E.bufferIndex].buffer,b=this._buffers[E.bufferIndex].lineStarts,v=E.start.line,u=E.end.line;let C=b[v]+E.start.column;if(d&&(p.charCodeAt(C)===10&&(C++,c--),n[i++]=a,a="",d=!1,c===0))return!0;if(v===u)return!this._EOLNormalized&&p.charCodeAt(C+c-1)===13?(d=!0,a+=p.substr(C,c-1)):a+=p.substr(C,c),!0;a+=this._EOLNormalized?p.substring(C,Math.max(C,b[v+1]-this._EOLLength)):p.substring(C,b[v+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=a;for(let f=v+1;f<u;f++)a=this._EOLNormalized?p.substring(b[f],b[f+1]-this._EOLLength):p.substring(b[f],b[f+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=a;return!this._EOLNormalized&&p.charCodeAt(b[u]+E.end.column-1)===13?(d=!0,E.end.column===0?i--:a=p.substr(b[u],E.end.column-1)):a=p.substr(b[u],E.end.column),!0}),d&&(n[i++]=a,a=""),n[i++]=a,n}getLength(){return this._length}getLineCount(){return this._lineCnt}getLineContent(n){return this._lastVisitedLine.lineNumber===n?this._lastVisitedLine.value:(this._lastVisitedLine.lineNumber=n,n===this._lineCnt?this._lastVisitedLine.value=this.getLineRawContent(n):this._EOLNormalized?this._lastVisitedLine.value=this.getLineRawContent(n,this._EOLLength):this._lastVisitedLine.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this._lastVisitedLine.value)}_getCharCode(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const a=this._buffers[i.piece.bufferIndex],d=this.offsetInBuffer(i.piece.bufferIndex,i.piece.start);return a.buffer.charCodeAt(d)}else{const i=this._buffers[n.node.piece.bufferIndex],d=this.offsetInBuffer(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(d)}}getLineCharCode(n,i){const a=this.nodeAt2(n,i+1);return this._getCharCode(a)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this._EOLLength}getCharCode(n){const i=this.nodeAt(n);return this._getCharCode(i)}findMatchesInNode(n,i,a,d,t,E,c,p,b,v,u){const C=this._buffers[n.piece.bufferIndex],f=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start),I=this.offsetInBuffer(n.piece.bufferIndex,t),S=this.offsetInBuffer(n.piece.bufferIndex,E);let P;const k={line:0,column:0};let H,$;i._wordSeparators?(H=C.buffer.substring(I,S),$=V=>V+I,i.reset(0)):(H=C.buffer,$=V=>V,i.reset(I));do if(P=i.next(H),P){if($(P.index)>=S)return v;this.positionInBuffer(n,$(P.index)-f,k);const V=this.getLineFeedCnt(n.piece.bufferIndex,t,k),A=k.line===t.line?k.column-t.column+d:k.column+1,U=A+P[0].length;if(u[v++]=(0,R.createFindMatch)(new O.Range(a+V,A,a+V,U),P,p),$(P.index)+P[0].length>=S||v>=b)return v}while(P);return v}findMatchesLineByLine(n,i,a,d){const t=[];let E=0;const c=new R.Searcher(i.wordSeparators,i.regex);let p=this.nodeAt2(n.startLineNumber,n.startColumn);if(p===null)return[];const b=this.nodeAt2(n.endLineNumber,n.endColumn);if(b===null)return[];let v=this.positionInBuffer(p.node,p.remainder);const u=this.positionInBuffer(b.node,b.remainder);if(p.node===b.node)return this.findMatchesInNode(p.node,c,n.startLineNumber,n.startColumn,v,u,i,a,d,E,t),t;let C=n.startLineNumber,f=p.node;for(;f!==b.node;){const S=this.getLineFeedCnt(f.piece.bufferIndex,v,f.piece.end);if(S>=1){const k=this._buffers[f.piece.bufferIndex].lineStarts,H=this.offsetInBuffer(f.piece.bufferIndex,f.piece.start),$=k[v.line+S],V=C===n.startLineNumber?n.startColumn:1;if(E=this.findMatchesInNode(f,c,C,V,v,this.positionInBuffer(f,$-H),i,a,d,E,t),E>=d)return t;C+=S}const P=C===n.startLineNumber?n.startColumn-1:0;if(C===n.endLineNumber){const k=this.getLineContent(C).substring(P,n.endColumn-1);return E=this._findMatchesInLine(i,c,k,n.endLineNumber,P,E,t,a,d),t}if(E=this._findMatchesInLine(i,c,this.getLineContent(C).substr(P),C,P,E,t,a,d),E>=d)return t;C++,p=this.nodeAt2(C,1),f=p.node,v=this.positionInBuffer(p.node,p.remainder)}if(C===n.endLineNumber){const S=C===n.startLineNumber?n.startColumn-1:0,P=this.getLineContent(C).substring(S,n.endColumn-1);return E=this._findMatchesInLine(i,c,P,n.endLineNumber,S,E,t,a,d),t}const I=C===n.startLineNumber?n.startColumn:1;return E=this.findMatchesInNode(b.node,c,C,I,v,u,i,a,d,E,t),t}_findMatchesInLine(n,i,a,d,t,E,c,p,b){const v=n.wordSeparators;if(!p&&n.simpleSearch){const C=n.simpleSearch,f=C.length,I=a.length;let S=-f;for(;(S=a.indexOf(C,S+f))!==-1;)if((!v||(0,R.isValidMatch)(v,a,I,S,f))&&(c[E++]=new T.FindMatch(new O.Range(d,S+1+t,d,S+1+f+t),null),E>=b))return E;return E}let u;i.reset(0);do if(u=i.next(a),u&&(c[E++]=(0,R.createFindMatch)(new O.Range(d,u.index+1+t,d,u.index+1+u[0].length+t),u,p),E>=b))return E;while(u);return E}insert(n,i,a=!1){if(this._EOLNormalized=this._EOLNormalized&&a,this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",this.root!==N.SENTINEL){const{node:d,remainder:t,nodeStartOffset:E}=this.nodeAt(n),c=d.piece,p=c.bufferIndex,b=this.positionInBuffer(d,t);if(d.piece.bufferIndex===0&&c.end.line===this._lastChangeBufferPos.line&&c.end.column===this._lastChangeBufferPos.column&&E+c.length===n&&i.length<m){this.appendToNode(d,i),this.computeBufferMetadata();return}if(E===n)this.insertContentToNodeLeft(i,d),this._searchCache.validate(n);else if(E+d.piece.length>n){const v=[];let u=new l(c.bufferIndex,b,c.end,this.getLineFeedCnt(c.bufferIndex,b,c.end),this.offsetInBuffer(p,c.end)-this.offsetInBuffer(p,b));if(this.shouldCheckCRLF()&&this.endWithCR(i)&&this.nodeCharCodeAt(d,t)===10){const S={line:u.start.line+1,column:0};u=new l(u.bufferIndex,S,u.end,this.getLineFeedCnt(u.bufferIndex,S,u.end),u.length-1),i+=`
`}if(this.shouldCheckCRLF()&&this.startWithLF(i))if(this.nodeCharCodeAt(d,t-1)===13){const S=this.positionInBuffer(d,t-1);this.deleteNodeTail(d,S),i="\r"+i,d.piece.length===0&&v.push(d)}else this.deleteNodeTail(d,b);else this.deleteNodeTail(d,b);const C=this.createNewPieces(i);u.length>0&&this.rbInsertRight(d,u);let f=d;for(let I=0;I<C.length;I++)f=this.rbInsertRight(f,C[I]);this.deleteNodes(v)}else this.insertContentToNodeRight(i,d)}else{const d=this.createNewPieces(i);let t=this.rbInsertLeft(null,d[0]);for(let E=1;E<d.length;E++)t=this.rbInsertRight(t,d[E])}this.computeBufferMetadata()}delete(n,i){if(this._lastVisitedLine.lineNumber=0,this._lastVisitedLine.value="",i<=0||this.root===N.SENTINEL)return;const a=this.nodeAt(n),d=this.nodeAt(n+i),t=a.node,E=d.node;if(t===E){const C=this.positionInBuffer(t,a.remainder),f=this.positionInBuffer(t,d.remainder);if(a.nodeStartOffset===n){if(i===t.piece.length){const I=t.next();(0,N.rbDelete)(this,t),this.validateCRLFWithPrevNode(I),this.computeBufferMetadata();return}this.deleteNodeHead(t,f),this._searchCache.validate(n),this.validateCRLFWithPrevNode(t),this.computeBufferMetadata();return}if(a.nodeStartOffset+t.piece.length===n+i){this.deleteNodeTail(t,C),this.validateCRLFWithNextNode(t),this.computeBufferMetadata();return}this.shrinkNode(t,C,f),this.computeBufferMetadata();return}const c=[],p=this.positionInBuffer(t,a.remainder);this.deleteNodeTail(t,p),this._searchCache.validate(n),t.piece.length===0&&c.push(t);const b=this.positionInBuffer(E,d.remainder);this.deleteNodeHead(E,b),E.piece.length===0&&c.push(E);const v=t.next();for(let C=v;C!==N.SENTINEL&&C!==E;C=C.next())c.push(C);const u=t.piece.length===0?t.prev():t;this.deleteNodes(c),this.validateCRLFWithNextNode(u),this.computeBufferMetadata()}insertContentToNodeLeft(n,i){const a=[];if(this.shouldCheckCRLF()&&this.endWithCR(n)&&this.startWithLF(i)){const E=i.piece,c={line:E.start.line+1,column:0},p=new l(E.bufferIndex,c,E.end,this.getLineFeedCnt(E.bufferIndex,c,E.end),E.length-1);i.piece=p,n+=`
`,(0,N.updateTreeMetadata)(this,i,-1,-1),i.piece.length===0&&a.push(i)}const d=this.createNewPieces(n);let t=this.rbInsertLeft(i,d[d.length-1]);for(let E=d.length-2;E>=0;E--)t=this.rbInsertLeft(t,d[E]);this.validateCRLFWithPrevNode(t),this.deleteNodes(a)}insertContentToNodeRight(n,i){this.adjustCarriageReturnFromNext(n,i)&&(n+=`
`);const a=this.createNewPieces(n),d=this.rbInsertRight(i,a[0]);let t=d;for(let E=1;E<a.length;E++)t=this.rbInsertRight(t,a[E]);this.validateCRLFWithPrevNode(d)}positionInBuffer(n,i,a){const d=n.piece,t=n.piece.bufferIndex,E=this._buffers[t].lineStarts,p=E[d.start.line]+d.start.column+i;let b=d.start.line,v=d.end.line,u=0,C=0,f=0;for(;b<=v&&(u=b+(v-b)/2|0,f=E[u],u!==v);)if(C=E[u+1],p<f)v=u-1;else if(p>=C)b=u+1;else break;return a?(a.line=u,a.column=p-f,null):{line:u,column:p-f}}getLineFeedCnt(n,i,a){if(a.column===0)return a.line-i.line;const d=this._buffers[n].lineStarts;if(a.line===d.length-1)return a.line-i.line;const t=d[a.line+1],E=d[a.line]+a.column;if(t>E+1)return a.line-i.line;const c=E-1;return this._buffers[n].buffer.charCodeAt(c)===13?a.line-i.line+1:a.line-i.line}offsetInBuffer(n,i){return this._buffers[n].lineStarts[i.line]+i.column}deleteNodes(n){for(let i=0;i<n.length;i++)(0,N.rbDelete)(this,n[i])}createNewPieces(n){if(n.length>m){const v=[];for(;n.length>m;){const C=n.charCodeAt(m-1);let f;C===13||C>=55296&&C<=56319?(f=n.substring(0,m-1),n=n.substring(m-1)):(f=n.substring(0,m),n=n.substring(m));const I=L(f);v.push(new l(this._buffers.length,{line:0,column:0},{line:I.length-1,column:f.length-I[I.length-1]},I.length-1,f.length)),this._buffers.push(new w(f,I))}const u=L(n);return v.push(new l(this._buffers.length,{line:0,column:0},{line:u.length-1,column:n.length-u[u.length-1]},u.length-1,n.length)),this._buffers.push(new w(n,u)),v}let i=this._buffers[0].buffer.length;const a=L(n,!1);let d=this._lastChangeBufferPos;if(this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-1]===i&&i!==0&&this.startWithLF(n)&&this.endWithCR(this._buffers[0].buffer)){this._lastChangeBufferPos={line:this._lastChangeBufferPos.line,column:this._lastChangeBufferPos.column+1},d=this._lastChangeBufferPos;for(let v=0;v<a.length;v++)a[v]+=i+1;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(a.slice(1)),this._buffers[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let v=0;v<a.length;v++)a[v]+=i;this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(a.slice(1)),this._buffers[0].buffer+=n}const t=this._buffers[0].buffer.length,E=this._buffers[0].lineStarts.length-1,c=t-this._buffers[0].lineStarts[E],p={line:E,column:c},b=new l(0,d,p,this.getLineFeedCnt(0,d,p),t-i);return this._lastChangeBufferPos=p,[b]}getLinesRawContent(){return this.getContentOfSubTree(this.root)}getLineRawContent(n,i=0){let a=this.root,d="";const t=this._searchCache.get2(n);if(t){a=t.node;const E=this.getAccumulatedValue(a,n-t.nodeStartLineNumber-1),c=this._buffers[a.piece.bufferIndex].buffer,p=this.offsetInBuffer(a.piece.bufferIndex,a.piece.start);if(t.nodeStartLineNumber+a.piece.lineFeedCnt===n)d=c.substring(p+E,p+a.piece.length);else{const b=this.getAccumulatedValue(a,n-t.nodeStartLineNumber);return c.substring(p+E,p+b-i)}}else{let E=0;const c=n;for(;a!==N.SENTINEL;)if(a.left!==N.SENTINEL&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const p=this.getAccumulatedValue(a,n-a.lf_left-2),b=this.getAccumulatedValue(a,n-a.lf_left-1),v=this._buffers[a.piece.bufferIndex].buffer,u=this.offsetInBuffer(a.piece.bufferIndex,a.piece.start);return E+=a.size_left,this._searchCache.set({node:a,nodeStartOffset:E,nodeStartLineNumber:c-(n-1-a.lf_left)}),v.substring(u+p,u+b-i)}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const p=this.getAccumulatedValue(a,n-a.lf_left-2),b=this._buffers[a.piece.bufferIndex].buffer,v=this.offsetInBuffer(a.piece.bufferIndex,a.piece.start);d=b.substring(v+p,v+a.piece.length);break}else n-=a.lf_left+a.piece.lineFeedCnt,E+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==N.SENTINEL;){const E=this._buffers[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const c=this.getAccumulatedValue(a,0),p=this.offsetInBuffer(a.piece.bufferIndex,a.piece.start);return d+=E.substring(p,p+c-i),d}else{const c=this.offsetInBuffer(a.piece.bufferIndex,a.piece.start);d+=E.substr(c,a.piece.length)}a=a.next()}return d}computeBufferMetadata(){let n=this.root,i=1,a=0;for(;n!==N.SENTINEL;)i+=n.lf_left+n.piece.lineFeedCnt,a+=n.size_left+n.piece.length,n=n.right;this._lineCnt=i,this._length=a,this._searchCache.validate(this._length)}getIndexOf(n,i){const a=n.piece,d=this.positionInBuffer(n,i),t=d.line-a.start.line;if(this.offsetInBuffer(a.bufferIndex,a.end)-this.offsetInBuffer(a.bufferIndex,a.start)===i){const E=this.getLineFeedCnt(n.piece.bufferIndex,a.start,d);if(E!==t)return{index:E,remainder:0}}return{index:t,remainder:d.column}}getAccumulatedValue(n,i){if(i<0)return 0;const a=n.piece,d=this._buffers[a.bufferIndex].lineStarts,t=a.start.line+i+1;return t>a.end.line?d[a.end.line]+a.end.column-d[a.start.line]-a.start.column:d[t]-d[a.start.line]-a.start.column}deleteNodeTail(n,i){const a=n.piece,d=a.lineFeedCnt,t=this.offsetInBuffer(a.bufferIndex,a.end),E=i,c=this.offsetInBuffer(a.bufferIndex,E),p=this.getLineFeedCnt(a.bufferIndex,a.start,E),b=p-d,v=c-t,u=a.length+v;n.piece=new l(a.bufferIndex,a.start,E,p,u),(0,N.updateTreeMetadata)(this,n,v,b)}deleteNodeHead(n,i){const a=n.piece,d=a.lineFeedCnt,t=this.offsetInBuffer(a.bufferIndex,a.start),E=i,c=this.getLineFeedCnt(a.bufferIndex,E,a.end),p=this.offsetInBuffer(a.bufferIndex,E),b=c-d,v=t-p,u=a.length+v;n.piece=new l(a.bufferIndex,E,a.end,c,u),(0,N.updateTreeMetadata)(this,n,v,b)}shrinkNode(n,i,a){const d=n.piece,t=d.start,E=d.end,c=d.length,p=d.lineFeedCnt,b=i,v=this.getLineFeedCnt(d.bufferIndex,d.start,b),u=this.offsetInBuffer(d.bufferIndex,i)-this.offsetInBuffer(d.bufferIndex,t);n.piece=new l(d.bufferIndex,d.start,b,v,u),(0,N.updateTreeMetadata)(this,n,u-c,v-p);const C=new l(d.bufferIndex,a,E,this.getLineFeedCnt(d.bufferIndex,a,E),this.offsetInBuffer(d.bufferIndex,E)-this.offsetInBuffer(d.bufferIndex,a)),f=this.rbInsertRight(n,C);this.validateCRLFWithPrevNode(f)}appendToNode(n,i){this.adjustCarriageReturnFromNext(i,n)&&(i+=`
`);const a=this.shouldCheckCRLF()&&this.startWithLF(i)&&this.endWithCR(n),d=this._buffers[0].buffer.length;this._buffers[0].buffer+=i;const t=L(i,!1);for(let f=0;f<t.length;f++)t[f]+=d;if(a){const f=this._buffers[0].lineStarts[this._buffers[0].lineStarts.length-2];this._buffers[0].lineStarts.pop(),this._lastChangeBufferPos={line:this._lastChangeBufferPos.line-1,column:d-f}}this._buffers[0].lineStarts=this._buffers[0].lineStarts.concat(t.slice(1));const E=this._buffers[0].lineStarts.length-1,c=this._buffers[0].buffer.length-this._buffers[0].lineStarts[E],p={line:E,column:c},b=n.piece.length+i.length,v=n.piece.lineFeedCnt,u=this.getLineFeedCnt(0,n.piece.start,p),C=u-v;n.piece=new l(n.piece.bufferIndex,n.piece.start,p,u,b),this._lastChangeBufferPos=p,(0,N.updateTreeMetadata)(this,n,i.length,C)}nodeAt(n){let i=this.root;const a=this._searchCache.get(n);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:n-a.nodeStartOffset};let d=0;for(;i!==N.SENTINEL;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){d+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:d};return this._searchCache.set(t),t}else n-=i.size_left+i.piece.length,d+=i.size_left+i.piece.length,i=i.right;return null}nodeAt2(n,i){let a=this.root,d=0;for(;a!==N.SENTINEL;)if(a.left!==N.SENTINEL&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const t=this.getAccumulatedValue(a,n-a.lf_left-2),E=this.getAccumulatedValue(a,n-a.lf_left-1);return d+=a.size_left,{node:a,remainder:Math.min(t+i-1,E),nodeStartOffset:d}}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const t=this.getAccumulatedValue(a,n-a.lf_left-2);if(t+i-1<=a.piece.length)return{node:a,remainder:t+i-1,nodeStartOffset:d};i-=a.piece.length-t;break}else n-=a.lf_left+a.piece.lineFeedCnt,d+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==N.SENTINEL;){if(a.piece.lineFeedCnt>0){const t=this.getAccumulatedValue(a,0),E=this.offsetOfNode(a);return{node:a,remainder:Math.min(i-1,t),nodeStartOffset:E}}else if(a.piece.length>=i-1){const t=this.offsetOfNode(a);return{node:a,remainder:i-1,nodeStartOffset:t}}else i-=a.piece.length;a=a.next()}return null}nodeCharCodeAt(n,i){if(n.piece.lineFeedCnt<1)return-1;const a=this._buffers[n.piece.bufferIndex],d=this.offsetInBuffer(n.piece.bufferIndex,n.piece.start)+i;return a.buffer.charCodeAt(d)}offsetOfNode(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}shouldCheckCRLF(){return!(this._EOLNormalized&&this._EOL===`
`)}startWithLF(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===N.SENTINEL||n.piece.lineFeedCnt===0)return!1;const i=n.piece,a=this._buffers[i.bufferIndex].lineStarts,d=i.start.line,t=a[d]+i.start.column;return d===a.length-1||a[d+1]>t+1?!1:this._buffers[i.bufferIndex].buffer.charCodeAt(t)===10}endWithCR(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===N.SENTINEL||n.piece.lineFeedCnt===0?!1:this.nodeCharCodeAt(n,n.piece.length-1)===13}validateCRLFWithPrevNode(n){if(this.shouldCheckCRLF()&&this.startWithLF(n)){const i=n.prev();this.endWithCR(i)&&this.fixCRLF(i,n)}}validateCRLFWithNextNode(n){if(this.shouldCheckCRLF()&&this.endWithCR(n)){const i=n.next();this.startWithLF(i)&&this.fixCRLF(n,i)}}fixCRLF(n,i){const a=[],d=this._buffers[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:d[n.piece.end.line]-d[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const E=n.piece.length-1,c=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,t,c,E),(0,N.updateTreeMetadata)(this,n,-1,-1),n.piece.length===0&&a.push(n);const p={line:i.piece.start.line+1,column:0},b=i.piece.length-1,v=this.getLineFeedCnt(i.piece.bufferIndex,p,i.piece.end);i.piece=new l(i.piece.bufferIndex,p,i.piece.end,v,b),(0,N.updateTreeMetadata)(this,i,-1,-1),i.piece.length===0&&a.push(i);const u=this.createNewPieces(`\r
`);this.rbInsertRight(n,u[0]);for(let C=0;C<a.length;C++)(0,N.rbDelete)(this,a[C])}adjustCarriageReturnFromNext(n,i){if(this.shouldCheckCRLF()&&this.endWithCR(n)){const a=i.next();if(this.startWithLF(a)){if(n+=`
`,a.piece.length===1)(0,N.rbDelete)(this,a);else{const d=a.piece,t={line:d.start.line+1,column:0},E=d.length-1,c=this.getLineFeedCnt(d.bufferIndex,t,d.end);a.piece=new l(d.bufferIndex,t,d.end,c,E),(0,N.updateTreeMetadata)(this,a,-1,-1)}return!0}}return!1}iterate(n,i){if(n===N.SENTINEL)return i(N.SENTINEL);const a=this.iterate(n.left,i);return a&&i(n)&&this.iterate(n.right,i)}getNodeContent(n){if(n===N.SENTINEL)return"";const i=this._buffers[n.piece.bufferIndex],a=n.piece,d=this.offsetInBuffer(a.bufferIndex,a.start),t=this.offsetInBuffer(a.bufferIndex,a.end);return i.buffer.substring(d,t)}getPieceContent(n){const i=this._buffers[n.bufferIndex],a=this.offsetInBuffer(n.bufferIndex,n.start),d=this.offsetInBuffer(n.bufferIndex,n.end);return i.buffer.substring(a,d)}rbInsertRight(n,i){const a=new N.TreeNode(i,1);if(a.left=N.SENTINEL,a.right=N.SENTINEL,a.parent=N.SENTINEL,a.size_left=0,a.lf_left=0,this.root===N.SENTINEL)this.root=a,a.color=0;else if(n.right===N.SENTINEL)n.right=a,a.parent=n;else{const t=(0,N.leftest)(n.right);t.left=a,a.parent=t}return(0,N.fixInsert)(this,a),a}rbInsertLeft(n,i){const a=new N.TreeNode(i,1);if(a.left=N.SENTINEL,a.right=N.SENTINEL,a.parent=N.SENTINEL,a.size_left=0,a.lf_left=0,this.root===N.SENTINEL)this.root=a,a.color=0;else if(n.left===N.SENTINEL)n.left=a,a.parent=n;else{const d=(0,N.righttest)(n.left);d.right=a,a.parent=d}return(0,N.fixInsert)(this,a),a}getContentOfSubTree(n){let i="";return this.iterate(n,a=>(i+=this.getNodeContent(a),!0)),i}}e.PieceTreeBase=o}),define(Pe[137],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class D{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(N){if(N&&this._dragOperations.has(N)){const R=this._dragOperations.get(N);return this._dragOperations.delete(N),R}}addDragOperationTransfer(N,R){this._dragOperations.set(N,R)}}e.TreeViewsDnDService=D;class O{constructor(N){this.identifier=N}}e.DraggedTreeItemsIdentifier=O}),define(Pe[138],Te([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Pe[139],Te([1,0,5,6,138]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0,e.toAction=L;class N extends O.Disposable{constructor(l,w="",g="",r=!0,o){super(),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=l,this._label=w,this._cssClass=g,this._enabled=r,this._actionCallback=o}get id(){return this._id}get label(){return this._label}set label(l){this._setLabel(l)}_setLabel(l){this._label!==l&&(this._label=l,this._onDidChange.fire({label:l}))}get tooltip(){return this._tooltip||""}set tooltip(l){this._setTooltip(l)}_setTooltip(l){this._tooltip!==l&&(this._tooltip=l,this._onDidChange.fire({tooltip:l}))}get class(){return this._cssClass}set class(l){this._setClass(l)}_setClass(l){this._cssClass!==l&&(this._cssClass=l,this._onDidChange.fire({class:l}))}get enabled(){return this._enabled}set enabled(l){this._setEnabled(l)}_setEnabled(l){this._enabled!==l&&(this._enabled=l,this._onDidChange.fire({enabled:l}))}get checked(){return this._checked}set checked(l){this._setChecked(l)}_setChecked(l){this._checked!==l&&(this._checked=l,this._onDidChange.fire({checked:l}))}async run(l,w){this._actionCallback&&await this._actionCallback(l)}}e.Action=N;class R extends O.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new D.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new D.Emitter),this.onDidRun=this._onDidRun.event}async run(l,w){if(!l.enabled)return;this._onWillRun.fire({action:l});let g;try{await this.runAction(l,w)}catch(r){g=r}this._onDidRun.fire({action:l,error:g})}async runAction(l,w){await l.run(w)}}e.ActionRunner=R;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let w=[];for(const g of l)g.length&&(w.length?w=[...w,new m,...g]:w=g);return w}static{this.ID="vs.actions.separator"}async run(){}}e.Separator=m;class h{get actions(){return this._actions}constructor(l,w,g,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=w,this.class=r,this._actions=g}async run(){}}e.SubmenuAction=h;class y extends N{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,T.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=y;function L(_){return{id:_.id,label:_.label,class:_.class,enabled:_.enabled??!0,checked:_.checked,run:async(...l)=>_.run(...l),tooltip:_.label}}}),define(Pe[140],Te([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(Pe[141],Te([1,0,140]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=y,e.getDurationString=L,e.toLocalISOString=_;const O=60,T=O*60,N=T*24,R=N*7,m=N*30,h=N*365;function y(l,w,g,r){typeof l!="number"&&(l=l.getTime());const o=Math.round((new Date().getTime()-l)/1e3);if(o<-30)return(0,D.localize)(0,null,y(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,D.localize)(1,null);let s;return o<O?(s=o,w?s===1?g?(0,D.localize)(2,null,s):(0,D.localize)(3,null,s):g?(0,D.localize)(4,null,s):(0,D.localize)(5,null,s):s===1?g?(0,D.localize)(6,null,s):(0,D.localize)(7,null,s):g?(0,D.localize)(8,null,s):(0,D.localize)(9,null,s)):o<T?(s=Math.floor(o/O),w?s===1?g?(0,D.localize)(10,null,s):(0,D.localize)(11,null,s):g?(0,D.localize)(12,null,s):(0,D.localize)(13,null,s):s===1?g?(0,D.localize)(14,null,s):(0,D.localize)(15,null,s):g?(0,D.localize)(16,null,s):(0,D.localize)(17,null,s)):o<N?(s=Math.floor(o/T),w?s===1?g?(0,D.localize)(18,null,s):(0,D.localize)(19,null,s):g?(0,D.localize)(20,null,s):(0,D.localize)(21,null,s):s===1?g?(0,D.localize)(22,null,s):(0,D.localize)(23,null,s):g?(0,D.localize)(24,null,s):(0,D.localize)(25,null,s)):o<R?(s=Math.floor(o/N),w?s===1?(0,D.localize)(26,null,s):(0,D.localize)(27,null,s):s===1?(0,D.localize)(28,null,s):(0,D.localize)(29,null,s)):o<m?(s=Math.floor(o/R),w?s===1?g?(0,D.localize)(30,null,s):(0,D.localize)(31,null,s):g?(0,D.localize)(32,null,s):(0,D.localize)(33,null,s):s===1?g?(0,D.localize)(34,null,s):(0,D.localize)(35,null,s):g?(0,D.localize)(36,null,s):(0,D.localize)(37,null,s)):o<h?(s=Math.floor(o/m),w?s===1?g?(0,D.localize)(38,null,s):(0,D.localize)(39,null,s):g?(0,D.localize)(40,null,s):(0,D.localize)(41,null,s):s===1?g?(0,D.localize)(42,null,s):(0,D.localize)(43,null,s):g?(0,D.localize)(44,null,s):(0,D.localize)(45,null,s)):(s=Math.floor(o/h),w?s===1?g?(0,D.localize)(46,null,s):(0,D.localize)(47,null,s):g?(0,D.localize)(48,null,s):(0,D.localize)(49,null,s):s===1?g?(0,D.localize)(50,null,s):(0,D.localize)(51,null,s):g?(0,D.localize)(52,null,s):(0,D.localize)(53,null,s))}function L(l,w){const g=Math.abs(l/1e3);return g<1?w?(0,D.localize)(54,null,l):(0,D.localize)(55,null,l):g<O?w?(0,D.localize)(56,null,Math.round(l)/1e3):(0,D.localize)(57,null,Math.round(l)/1e3):g<T?w?(0,D.localize)(58,null,Math.round(l/(1e3*O))):(0,D.localize)(59,null,Math.round(l/(1e3*O))):g<N?w?(0,D.localize)(60,null,Math.round(l/(1e3*T))):(0,D.localize)(61,null,Math.round(l/(1e3*T))):(0,D.localize)(62,null,Math.round(l/(1e3*N)))}function _(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Pe[142],Te([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Pe[42],Te([1,0,18,17,142]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=h,e.isErrorWithActions=y,e.createErrorWithActions=L;function N(_,l){return l&&(_.stack||_.stacktrace)?T.localize(0,null,m(_),R(_.stack)||R(_.stacktrace)):m(_)}function R(_){return Array.isArray(_)?_.join(`
`):_}function m(_){return _.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${_.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof _.code=="string"&&typeof _.errno=="number"&&typeof _.syscall=="string"?T.localize(1,null,_.message):_.message||T.localize(2,null)}function h(_=null,l=!1){if(!_)return T.localize(3,null);if(Array.isArray(_)){const w=D.coalesce(_),g=h(w[0],l);return w.length>1?T.localize(4,null,g,w.length):g}if(O.isString(_))return _;if(_.detail){const w=_.detail;if(w.error)return N(w.error,l);if(w.exception)return N(w.exception,l)}return _.stack?N(_,l):_.message?_.message:T.localize(5,null)}function y(_){const l=_;return l instanceof Error&&Array.isArray(l.actions)}function L(_,l){let w;return typeof _=="string"?w=new Error(_):w=_,w.actions=l,w}}),define(Pe[143],Te([1,0,40,19]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareFileNames=m,e.compareFileNamesDefault=h,e.compareFileNamesUpper=y,e.compareFileNamesLower=L,e.compareFileNamesUnicode=_,e.compareFileExtensions=l,e.compareFileExtensionsDefault=w,e.compareFileExtensionsUpper=g,e.compareFileExtensionsLower=r,e.compareFileExtensionsUnicode=o,e.comparePaths=b,e.compareAnything=v,e.compareByPrefix=u;const T=new D.Lazy(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),N=new D.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new D.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(C,f,I=!1){const S=C||"",P=f||"",k=T.value.collator.compare(S,P);return T.value.collatorIsNumeric&&k===0&&S!==P?S<P?-1:1:k}function h(C,f){const I=N.value.collator;return C=C||"",f=f||"",a(I,C,f)}function y(C,f){const I=N.value.collator;return C=C||"",f=f||"",c(C,f)||a(I,C,f)}function L(C,f){const I=N.value.collator;return C=C||"",f=f||"",E(C,f)||a(I,C,f)}function _(C,f){return C=C||"",f=f||"",C===f?0:C<f?-1:1}function l(C,f){const[I,S]=n(C),[P,k]=n(f);let H=T.value.collator.compare(S,k);if(H===0){if(T.value.collatorIsNumeric&&S!==k)return S<k?-1:1;if(H=T.value.collator.compare(I,P),T.value.collatorIsNumeric&&H===0&&I!==P)return I<P?-1:1}return H}function w(C,f){C=C||"",f=f||"";const I=i(C),S=i(f),P=N.value.collator,k=R.value.collator;return a(k,I,S)||a(P,C,f)}function g(C,f){C=C||"",f=f||"";const I=i(C),S=i(f),P=N.value.collator,k=R.value.collator;return a(k,I,S)||c(C,f)||a(P,C,f)}function r(C,f){C=C||"",f=f||"";const I=i(C),S=i(f),P=N.value.collator,k=R.value.collator;return a(k,I,S)||E(C,f)||a(P,C,f)}function o(C,f){C=C||"",f=f||"";const I=i(C).toLowerCase(),S=i(f).toLowerCase();return I!==S?I<S?-1:1:C!==f?C<f?-1:1:0}const s=/^(.*?)(\.([^.]*))?$/;function n(C,f=!1){const I=C?s.exec(C):[];let S=[I&&I[1]||"",I&&I[3]||""];return f&&(!S[0]&&S[1]||S[0]&&S[0].charAt(0)===".")&&(S=[S[0]+"."+S[1],""]),S}function i(C){const f=C?s.exec(C):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function a(C,f,I){const S=C.compare(f,I);return S!==0?S:f.length!==I.length?f.length<I.length?-1:1:0}function d(C){const f=C.charAt(0);return f.toLocaleUpperCase()!==f}function t(C){const f=C.charAt(0);return f.toLocaleLowerCase()!==f}function E(C,f){return d(C)&&t(f)?-1:t(C)&&d(f)?1:0}function c(C,f){return t(C)&&d(f)?-1:d(C)&&t(f)?1:0}function p(C,f,I=!1){return I||(C=C&&C.toLowerCase(),f=f&&f.toLowerCase()),C===f?0:C<f?-1:1}function b(C,f,I=!1){const S=C.split(O.sep),P=f.split(O.sep),k=S.length-1,H=P.length-1;let $,V;for(let A=0;;A++){if($=k===A,V=H===A,$&&V)return m(S[A],P[A],I);if($)return-1;if(V)return 1;const U=p(S[A],P[A],I);if(U!==0)return U}}function v(C,f,I){const S=C.toLowerCase(),P=f.toLowerCase(),k=u(C,f,I);if(k)return k;const H=S.endsWith(I),$=P.endsWith(I);if(H!==$)return H?-1:1;const V=m(S,P);return V!==0?V:S.localeCompare(P)}function u(C,f,I){const S=C.toLowerCase(),P=f.toLowerCase(),k=S.startsWith(I),H=P.startsWith(I);if(k!==H)return k?-1:1;if(k&&H){if(S.length<P.length)return-1;if(S.length>P.length)return 1}return 0}}),define(Pe[46],Te([1,0,19,21,15,17]),function(me,e,D,O,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=R,e.toSlashes=m,e.toPosixPath=h,e.getRoot=y,e.isUNC=L,e.isValidBasename=g,e.isEqual=r,e.isEqualOrParent=o,e.isWindowsDriveLetter=s,e.sanitizeFilePath=n,e.isRootOrDriveLetter=i,e.hasDriveLetter=a,e.getDriveLetter=d,e.indexOfPath=t,e.parseLineAndColumnAware=E,e.randomPath=b;function R(v){return v===47||v===92}function m(v){return v.replace(/[\\/]/g,D.posix.sep)}function h(v){return v.indexOf("/")===-1&&(v=m(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}function y(v,u=D.posix.sep){if(!v)return"";const C=v.length,f=v.charCodeAt(0);if(R(f)){if(R(v.charCodeAt(1))&&!R(v.charCodeAt(2))){let S=3;const P=S;for(;S<C&&!R(v.charCodeAt(S));S++);if(P!==S&&!R(v.charCodeAt(S+1))){for(S+=1;S<C;S++)if(R(v.charCodeAt(S)))return v.slice(0,S+1).replace(/[\\/]/g,u)}}return u}else if(s(f)&&v.charCodeAt(1)===58)return R(v.charCodeAt(2))?v.slice(0,2)+u:v.slice(0,2);let I=v.indexOf("://");if(I!==-1){for(I+=3;I<C;I++)if(R(v.charCodeAt(I)))return v.slice(0,I+1)}return""}function L(v){if(!O.isWindows||!v||v.length<5)return!1;let u=v.charCodeAt(0);if(u!==92||(u=v.charCodeAt(1),u!==92))return!1;let C=2;const f=C;for(;C<v.length&&(u=v.charCodeAt(C),u!==92);C++);return!(f===C||(u=v.charCodeAt(C+1),isNaN(u)||u===92))}const _=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(v,u=O.isWindows){const C=u?_:l;return!(!v||v.length===0||/^\s+$/.test(v)||(C.lastIndex=0,C.test(v))||u&&w.test(v)||v==="."||v===".."||u&&v[v.length-1]==="."||u&&v.length!==v.trim().length||v.length>255)}function r(v,u,C){const f=v===u;return!C||f?f:!v||!u?!1:(0,T.equalsIgnoreCase)(v,u)}function o(v,u,C,f=D.sep){if(v===u)return!0;if(!v||!u||u.length>v.length)return!1;if(C){if(!(0,T.startsWithIgnoreCase)(v,u))return!1;if(u.length===v.length)return!0;let S=u.length;return u.charAt(u.length-1)===f&&S--,v.charAt(S)===f}return u.charAt(u.length-1)!==f&&(u+=f),v.indexOf(u)===0}function s(v){return v>=65&&v<=90||v>=97&&v<=122}function n(v,u){return O.isWindows&&v.endsWith(":")&&(v+=D.sep),(0,D.isAbsolute)(v)||(v=(0,D.join)(u,v)),v=(0,D.normalize)(v),O.isWindows?(v=(0,T.rtrim)(v,D.sep),v.endsWith(":")&&(v+=D.sep)):(v=(0,T.rtrim)(v,D.sep),v||(v=D.sep)),v}function i(v){const u=(0,D.normalize)(v);return O.isWindows?v.length>3?!1:a(u)&&(v.length===2||u.charCodeAt(2)===92):u===D.posix.sep}function a(v,u=O.isWindows){return u?s(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}function d(v,u=O.isWindows){return a(v,u)?v[0]:void 0}function t(v,u,C){return u.length>v.length?-1:v===u?0:(C&&(v=v.toLowerCase(),u=u.toLowerCase()),v.indexOf(u))}function E(v){const u=v.split(":");let C,f,I;for(const S of u){const P=Number(S);(0,N.isNumber)(P)?f===void 0?f=P:I===void 0&&(I=P):C=C?[C,S].join(":"):S}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:f!==void 0?f:void 0,column:I!==void 0?I:f!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",p="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(v,u,C=8){let f="";for(let S=0;S<C;S++){let P;S===0&&O.isWindows&&!u&&(C===3||C===4)?P=p:P=c,f+=P.charAt(Math.floor(Math.random()*P.length))}let I;return u?I=`${u}-${f}`:I=f,v?(0,D.join)(v,I):I}}),define(Pe[69],Te([1,0,19]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=N,e.getMediaMime=R,e.getExtensionForMimeType=m,e.normalizeMimeType=y,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(L){const _=(0,D.extname)(L),l=O[_.toLowerCase()];return l!==void 0?l:R(L)}function R(L){const _=(0,D.extname)(L);return T[_.toLowerCase()]}function m(L){for(const _ in T)if(T[_]===L)return _}const h=/^(.+)\/(.+?)(;.+)?$/;function y(L,_){const l=h.exec(L);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:_?void 0:L}}),define(Pe[53],Te([1,0,22,2]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=T,e.parse=N,e.revive=m;function T(h){return JSON.stringify(h,R)}function N(h){let y=JSON.parse(h);return y=m(y),y}function R(h,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function m(h,y=0){if(!h||y>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return O.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof D.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let L=0;L<h.length;++L)h[L]=m(h[L],y+1);else for(const L in h)Object.hasOwnProperty.call(h,L)&&(h[L]=m(h[L],y+1))}return h}}),define(Pe[12],Te([1,0,14,21,15,2,19]),function(me,e,D,O,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=h,e.matchesSomeScheme=y,e.getServerRootPath=_;var m;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatCodeBlock="vscode-chat-code-block",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm",g.codeSetting="code-setting"})(m||(e.Schemas=m={}));function h(g,r){return N.URI.isUri(g)?(0,T.equalsIgnoreCase)(g.scheme,r):(0,T.startsWithIgnoreCase)(g,r+":")}function y(g,...r){return r.some(o=>h(g,o))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(r){this._preferredWebSchema=r}setDelegate(r){this._delegate=r}setServerRootPath(r,o){this._serverRootPath=_(r,o)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return R.posix.join(this._serverRootPath,m.vscodeRemoteResource)}set(r,o,s){this._hosts[r]=o,this._ports[r]=s}setConnectionToken(r,o){this._connectionTokens[r]=o}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(r){if(this._delegate)try{return this._delegate(r)}catch(d){return D.onUnexpectedError(d),r}const o=r.authority;let s=this._hosts[o];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const n=this._ports[o],i=this._connectionTokens[o];let a=`path=${encodeURIComponent(r.path)}`;return typeof i=="string"&&(a+=`&${e.connectionTokenQueryName}=${encodeURIComponent(i)}`),N.URI.from({scheme:O.isWeb?this._preferredWebSchema:m.vscodeRemoteResource,authority:`${s}:${n}`,path:this._remoteResourcesPath,query:a})}}e.RemoteAuthorities=new L;function _(g,r){return R.posix.join(r??"/",`${g.quality??"oss"}-${g.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class l{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(r){const o=this.toUri(r,me);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===m.vscodeRemote?e.RemoteAuthorities.rewrite(r):r.scheme===m.file&&(O.isNative||O.webWorkerOrigin===`${m.vscodeFileResource}://${l.FALLBACK_AUTHORITY}`)?r.with({scheme:m.vscodeFileResource,authority:r.authority||l.FALLBACK_AUTHORITY,query:null,fragment:null}):r}asFileUri(r){const o=this.toUri(r,me);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===m.vscodeFileResource?r.with({scheme:m.file,authority:r.authority!==l.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(r,o){return N.URI.isUri(r)?r:N.URI.parse(o.toUrl(r))}}e.FileAccess=new l;var w;(function(g){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function s(i){let a;typeof i=="string"?a=new URL(i).searchParams:i instanceof URL?a=i.searchParams:N.URI.isUri(i)&&(a=new URL(i.toString(!0)).searchParams);const d=a?.get(o);if(d)return r.get(d)}g.getHeadersFromQuery=s;function n(i,a,d){if(!globalThis.crossOriginIsolated)return;const t=a&&d?"3":d?"2":"1";i instanceof URLSearchParams?i.set(o,t):i[o]=t}g.addSearchParam=n})(w||(e.COI=w={}))}),define(Pe[23],Te([1,0,46,12,19,21,15,2]),function(me,e,D,O,T,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=h,e.distinctParents=L,e.toLocalResource=l;function h(w){return(0,m.uriToFsPath)(w,!0)}class y{constructor(g){this._ignorePathCasing=g}compare(g,r,o=!1){return g===r?0:(0,R.compare)(this.getComparisonKey(g,o),this.getComparisonKey(r,o))}isEqual(g,r,o=!1){return g===r?!0:!g||!r?!1:this.getComparisonKey(g,o)===this.getComparisonKey(r,o)}getComparisonKey(g,r=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,r,o=!1){if(g.scheme===r.scheme){if(g.scheme===O.Schemas.file)return D.isEqualOrParent(h(g),h(r),this._ignorePathCasing(g))&&g.query===r.query&&(o||g.fragment===r.fragment);if((0,e.isEqualAuthority)(g.authority,r.authority))return D.isEqualOrParent(g.path,r.path,this._ignorePathCasing(g),"/")&&g.query===r.query&&(o||g.fragment===r.fragment)}return!1}joinPath(g,...r){return m.URI.joinPath(g,...r)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return T.posix.basename(g.path)}extname(g){return T.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let r;return g.scheme===O.Schemas.file?r=m.URI.file(T.dirname(h(g))).path:(r=T.posix.dirname(g.path),g.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),r="/")),g.with({path:r})}normalizePath(g){if(!g.path.length)return g;let r;return g.scheme===O.Schemas.file?r=m.URI.file(T.normalize(h(g))).path:r=T.posix.normalize(g.path),g.with({path:r})}relativePath(g,r){if(g.scheme!==r.scheme||!(0,e.isEqualAuthority)(g.authority,r.authority))return;if(g.scheme===O.Schemas.file){const n=T.relative(h(g),h(r));return N.isWindows?D.toSlashes(n):n}let o=g.path||"/";const s=r.path||"/";if(this._ignorePathCasing(g)){let n=0;for(const i=Math.min(o.length,s.length);n<i&&!(o.charCodeAt(n)!==s.charCodeAt(n)&&o.charAt(n).toLowerCase()!==s.charAt(n).toLowerCase());n++);o=s.substr(0,n)+o.substr(n)}return T.posix.relative(o,s)}resolvePath(g,r){if(g.scheme===O.Schemas.file){const o=m.URI.file(T.resolve(h(g),r));return g.with({authority:o.authority,path:o.path})}return r=D.toPosixPath(r),g.with({path:T.posix.resolve(g.path,r)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,r){return g===r||g!==void 0&&r!==void 0&&(0,R.equalsIgnoreCase)(g,r)}hasTrailingPathSeparator(g,r=T.sep){if(g.scheme===O.Schemas.file){const o=h(g);return o.length>D.getRoot(o).length&&o[o.length-1]===r}else{const o=g.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,r=T.sep){return(0,e.hasTrailingPathSeparator)(g,r)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,r=T.sep){let o=!1;if(g.scheme===O.Schemas.file){const s=h(g);o=s!==void 0&&s.length===D.getRoot(s).length&&s[s.length-1]===r}else{r="/";const s=g.path;o=s.length===1&&s.charCodeAt(s.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(g,r)?g.with({path:g.path+"/"}):g}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(w=>w.scheme===O.Schemas.file?!N.isLinux:!0),e.extUriIgnorePathCase=new y(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(w,g){const r=[];for(let o=0;o<w.length;o++){const s=g(w[o]);w.some((n,i)=>i===o?!1:(0,e.isEqualOrParent)(s,g(n)))||r.push(w[o])}return r}var _;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function g(r){const o=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(i=>{const[a,d]=i.split(":");a&&d&&o.set(a,d)});const n=r.path.substring(0,r.path.indexOf(";"));return n&&o.set(w.META_DATA_MIME,n),o}w.parseMetaData=g})(_||(e.DataUri=_={}));function l(w,g,r){if(g){let o=w.path;return o&&o[0]!==T.posix.sep&&(o=T.posix.sep+o),w.with({scheme:r,authority:g,path:o})}return w.with({scheme:r})}}),define(Pe[11],Te([1,0,24,14,5,6,23,21,130,40]),function(me,e,D,O,T,N,R,m,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=L,e.createCancelablePromise=_,e.raceCancellation=l,e.raceCancellationError=w,e.raceCancellablePromises=g,e.raceTimeout=r,e.asPromise=o,e.promiseWithResolvers=s,e.timeout=v,e.disposableTimeout=u,e.sequence=C,e.first=f,e.firstParallel=I,e.retry=_e,e.createCancelableAsyncIterable=Se;function L(he){return!!he&&typeof he.then=="function"}function _(he){const K=new D.CancellationTokenSource,Y=he(K.token),le=new Promise((de,Ne)=>{const ue=K.token.onCancellationRequested(()=>{ue.dispose(),Ne(new O.CancellationError)});Promise.resolve(Y).then(De=>{ue.dispose(),K.dispose(),de(De)},De=>{ue.dispose(),K.dispose(),Ne(De)})});return new class{cancel(){K.cancel(),K.dispose()}then(de,Ne){return le.then(de,Ne)}catch(de){return this.then(void 0,de)}finally(de){return le.finally(de)}}}function l(he,K,Y){return new Promise((le,de)=>{const Ne=K.onCancellationRequested(()=>{Ne.dispose(),le(Y)});he.then(le,de).finally(()=>Ne.dispose())})}function w(he,K){return new Promise((Y,le)=>{const de=K.onCancellationRequested(()=>{de.dispose(),le(new O.CancellationError)});he.then(Y,le).finally(()=>de.dispose())})}async function g(he){let K=-1;const Y=he.map((le,de)=>le.then(Ne=>(K=de,Ne)));try{return await Promise.race(Y)}finally{he.forEach((le,de)=>{de!==K&&le.cancel()})}}function r(he,K,Y){let le;const de=setTimeout(()=>{le?.(void 0),Y?.()},K);return Promise.race([he.finally(()=>clearTimeout(de)),new Promise(Ne=>le=Ne)])}function o(he){return new Promise((K,Y)=>{const le=he();L(le)?le.then(K,Y):K(le)})}function s(){let he,K;return{promise:new Promise((le,de)=>{he=le,K=de}),resolve:he,reject:K}}class n{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(K){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=K,!this.queuedPromise){const Y=()=>{if(this.queuedPromise=null,this.isDisposed)return;const le=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,le};this.queuedPromise=new Promise(le=>{this.activePromise.then(Y,Y).then(le)})}return new Promise((Y,le)=>{this.queuedPromise.then(Y,le)})}return this.activePromise=K(),new Promise((Y,le)=>{this.activePromise.then(de=>{this.activePromise=null,Y(de)},de=>{this.activePromise=null,le(de)})})}dispose(){this.isDisposed=!0}}e.Throttler=n;class i{constructor(){this.current=Promise.resolve(null)}queue(K){return this.current=this.current.then(()=>K(),()=>K())}}e.Sequencer=i;class a{constructor(){this.promiseMap=new Map}queue(K,Y){const de=(this.promiseMap.get(K)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.promiseMap.get(K)===de&&this.promiseMap.delete(K)});return this.promiseMap.set(K,de),de}}e.SequencerByKey=a;const d=(he,K)=>{let Y=!0;const le=setTimeout(()=>{Y=!1,K()},he);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(le),Y=!1}}},t=he=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,he())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class E{constructor(K){this.defaultDelay=K,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(K,Y=this.defaultDelay){this.task=K,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((de,Ne)=>{this.doResolve=de,this.doReject=Ne}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const de=this.task;return this.task=null,de()}}));const le=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=Y===h.MicrotaskDelay?t(le):d(Y,le),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new O.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=E;class c{constructor(K){this.delayer=new E(K),this.throttler=new n}trigger(K,Y){return this.delayer.trigger(()=>this.throttler.queue(K),Y)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=c;class p{constructor(){this._isOpen=!1,this._promise=new Promise((K,Y)=>{this._completePromise=K})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=p;class b extends p{constructor(K){super(),this._timeout=setTimeout(()=>this.open(),K)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=b;function v(he,K){return K?new Promise((Y,le)=>{const de=setTimeout(()=>{Ne.dispose(),Y()},he),Ne=K.onCancellationRequested(()=>{clearTimeout(de),Ne.dispose(),le(new O.CancellationError)})}):_(Y=>v(he,Y))}function u(he,K=0,Y){const le=setTimeout(()=>{he(),Y&&de.dispose()},K),de=(0,N.toDisposable)(()=>{clearTimeout(le),Y?.deleteAndLeak(de)});return Y?.add(de),de}function C(he){const K=[];let Y=0;const le=he.length;function de(){return Y<le?he[Y++]():null}function Ne(ue){ue!=null&&K.push(ue);const De=de();return De?De.then(Ne):Promise.resolve(K)}return Promise.resolve(null).then(Ne)}function f(he,K=le=>!!le,Y=null){let le=0;const de=he.length,Ne=()=>{if(le>=de)return Promise.resolve(Y);const ue=he[le++];return Promise.resolve(ue()).then(Re=>K(Re)?Promise.resolve(Re):Ne())};return Ne()}function I(he,K=le=>!!le,Y=null){if(he.length===0)return Promise.resolve(Y);let le=he.length;const de=()=>{le=-1;for(const Ne of he)Ne.cancel?.()};return new Promise((Ne,ue)=>{for(const De of he)De.then(Re=>{--le>=0&&K(Re)?(de(),Ne(Re)):le===0&&Ne(Y)}).catch(Re=>{--le>=0&&(de(),ue(Re))})})}class S{constructor(K){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=K,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new T.Emitter}whenIdle(){return this.size>0?T.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(K){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((Y,le)=>{this.outstandingPromises.push({factory:K,c:Y,e:le}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const K=this.outstandingPromises.shift();this.runningPromises++;const Y=K.factory();Y.then(K.c,K.e),Y.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=S;class P extends S{constructor(){super(1)}}e.Queue=P;class k{constructor(){this.sequentializer=new oe,this.tasks=0}queue(K){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,K())):this.sequentializer.run(this.tasks++,K())}}e.LimitedQueue=k;class H{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const K=new Ie;return this.drainers.add(K),K.p}isDrained(){for(const[,K]of this.queues)if(K.size>0)return!1;return!0}queueSize(K,Y=R.extUri){const le=Y.getComparisonKey(K);return this.queues.get(le)?.size??0}queueFor(K,Y,le=R.extUri){const de=le.getComparisonKey(K);let Ne=this.queues.get(de);if(!Ne){Ne=new P;const ue=this.drainListenerCount++,De=T.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.queues.delete(de),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(ue),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new N.DisposableMap),this.drainListeners.set(ue,De),this.queues.set(de,Ne)}return Ne.queue(Y)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const K of this.drainers)K.complete();this.drainers.clear()}dispose(){for(const[,K]of this.queues)K.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=H;class ${constructor(K,Y){this._token=-1,typeof K=="function"&&typeof Y=="number"&&this.setIfNotSet(K,Y)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(K,Y){this.cancel(),this._token=setTimeout(()=>{this._token=-1,K()},Y)}setIfNotSet(K,Y){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,K()},Y))}}e.TimeoutTimer=$;class V{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(K,Y,le=globalThis){this.cancel();const de=le.setInterval(()=>{K()},Y);this.disposable=(0,N.toDisposable)(()=>{le.clearInterval(de),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=V;class A{constructor(K,Y){this.timeoutToken=-1,this.runner=K,this.timeout=Y,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(K=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,K)}get delay(){return this.timeout}set delay(K){this.timeout=K}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=A;class U{constructor(K,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.runner=K,this.timeout=Y,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(K=this.timeout){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(K/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=U;class j extends A{constructor(K,Y){super(K,Y),this.units=[]}work(K){this.units.push(K),this.isScheduled()||this.schedule()}doRun(){const K=this.units;this.units=[],this.runner?.(K)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=j;class ie extends N.Disposable{constructor(K,Y){super(),this.options=K,this.handler=Y,this.pendingWork=[],this.throttler=this._register(new N.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(K){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+K.length>this.options.maxBufferedWork)return!1}else if(this.pending+K.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const Y of K)this.pendingWork.push(Y);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new A(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(he,K)=>{(0,m.setTimeout0)(()=>{if(Y)return;const le=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e._runWhenIdle=(he,K,Y)=>{const le=he.requestIdleCallback(K,typeof Y=="number"?{timeout:Y}:void 0);let de=!1;return{dispose(){de||(de=!0,he.cancelIdleCallback(le))}}},e.runWhenGlobalIdle=he=>(0,e._runWhenIdle)(globalThis,he)}();class fe{constructor(K,Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(le){this._error=le}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(K,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=fe;class Ce extends fe{constructor(K){super(globalThis,K)}}e.GlobalIdleValue=Ce;async function _e(he,K,Y){let le;for(let de=0;de<Y;de++)try{return await he()}catch(Ne){le=Ne,await v(K)}throw le}class oe{isRunning(K){return typeof K=="number"?this._running?.taskId===K:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(K,Y,le){return this._running={taskId:K,cancel:()=>le?.(),promise:Y},Y.then(()=>this.doneRunning(K),()=>this.doneRunning(K)),Y}doneRunning(K){this._running&&K===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const K=this._queued;this._queued=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this._queued)this._queued.run=K;else{const{promise:Y,resolve:le,reject:de}=s();this._queued={run:K,promise:Y,promiseResolve:le,promiseReject:de}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=oe;class pe{constructor(K,Y=()=>Date.now()){this.interval=K,this.nowFn=Y,this.lastIncrementTime=0,this.value=0}increment(){const K=this.nowFn();return K-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=K,this.value=0),this.value++,this.value}}e.IntervalCounter=pe;var ne;(function(he){he[he.Resolved=0]="Resolved",he[he.Rejected=1]="Rejected"})(ne||(ne={}));class Ie{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((K,Y)=>{this.completeCallback=K,this.errorCallback=Y})}complete(K){return new Promise(Y=>{this.completeCallback(K),this.outcome={outcome:0,value:K},Y()})}error(K){return new Promise(Y=>{this.errorCallback(K),this.outcome={outcome:1,value:K},Y()})}cancel(){return this.error(new O.CancellationError)}}e.DeferredPromise=Ie;var xe;(function(he){async function K(le){let de;const Ne=await Promise.all(le.map(ue=>ue.then(De=>De,De=>{de||(de=De)})));if(typeof de<"u")throw de;return Ne}he.settled=K;function Y(le){return new Promise(async(de,Ne)=>{try{await le(de,Ne)}catch(ue){Ne(ue)}})}he.withAsyncBody=Y})(xe||(e.Promises=xe={}));class re{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(K){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=K.then(Y=>(this._value=Y,this._isResolved=!0,Y),Y=>{throw this._error=Y,this._isResolved=!0,Y})}requireValue(){if(!this._isResolved)throw new O.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=re;class F{constructor(K){this._compute=K,this._promise=new y.Lazy(()=>new re(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=F;var Z;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(Z||(Z={}));class be{static fromArray(K){return new be(Y=>{Y.emitMany(K)})}static fromPromise(K){return new be(async Y=>{Y.emitMany(await K)})}static fromPromises(K){return new be(async Y=>{await Promise.all(K.map(async le=>Y.emitOne(await le)))})}static merge(K){return new be(async Y=>{await Promise.all(K.map(async le=>{for await(const de of le)Y.emitOne(de)}))})}static{this.EMPTY=be.fromArray([])}constructor(K){this._state=0,this._results=[],this._error=null,this._onStateChanged=new T.Emitter,queueMicrotask(async()=>{const Y={emitOne:le=>this.emitOne(le),emitMany:le=>this.emitMany(le),reject:le=>this.reject(le)};try{await Promise.resolve(K(Y)),this.resolve()}catch(le){this.reject(le)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(K<this._results.length)return{done:!1,value:this._results[K++]};if(this._state===1)return{done:!0,value:void 0};await T.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(K,Y){return new be(async le=>{for await(const de of K)le.emitOne(Y(de))})}map(K){return be.map(this,K)}static filter(K,Y){return new be(async le=>{for await(const de of K)Y(de)&&le.emitOne(de)})}filter(K){return be.filter(this,K)}static coalesce(K){return be.filter(K,Y=>!!Y)}coalesce(){return be.coalesce(this)}static async toPromise(K){const Y=[];for await(const le of K)Y.push(le);return Y}toPromise(){return be.toPromise(this)}emitOne(K){this._state===0&&(this._results.push(K),this._onStateChanged.fire())}emitMany(K){this._state===0&&(this._results=this._results.concat(K),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(K){this._state===0&&(this._state=2,this._error=K,this._onStateChanged.fire())}}e.AsyncIterableObject=be;class Le extends be{constructor(K,Y){super(Y),this._source=K}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Le;function Se(he){const K=new D.CancellationTokenSource,Y=he(K.token);return new Le(K,async le=>{const de=K.token.onCancellationRequested(()=>{de.dispose(),K.dispose(),le.reject(new O.CancellationError)});try{for await(const Ne of Y){if(K.token.isCancellationRequested)return;le.emitOne(Ne)}de.dispose(),K.dispose()}catch(Ne){de.dispose(),K.dispose(),le.reject(Ne)}})}class ve{constructor(){this._deferred=new Ie,this._asyncIterable=new be(le=>{if(K){le.reject(K);return}return Y&&le.emitMany(Y),this._errorFn=de=>le.reject(de),this._emitFn=de=>le.emitOne(de),this._deferred.p});let K,Y;this._emitFn=le=>{Y||(Y=[]),Y.push(le)},this._errorFn=le=>{K||(K=le)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(K){this._errorFn(K),this._deferred.complete()}emitOne(K){this._emitFn(K)}}e.AsyncIterableSource=ve}),define(Pe[35],Te([1,0,18,11,46,28,19,21,15]),function(me,e,D,O,T,N,R,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=y,e.splitGlobAware=g,e.match=P,e.parse=k,e.isRelativePattern=H,e.getBasenameTerms=$,e.getPathTerms=V,e.patternsEquals=ie;function y(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",_="[^/\\\\]",l=/\//g;function w(fe,Ce){switch(fe){case 0:return"";case 1:return`${_}*?`;default:return`(?:${L}|${_}+${L}${Ce?`|${L}${_}+`:""})*?`}}function g(fe,Ce){if(!fe)return[];const _e=[];let oe=!1,pe=!1,ne="";for(const Ie of fe){switch(Ie){case Ce:if(!oe&&!pe){_e.push(ne),ne="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}ne+=Ie}return ne&&_e.push(ne),_e}function r(fe){if(!fe)return"";let Ce="";const _e=g(fe,e.GLOB_SPLIT);if(_e.every(oe=>oe===e.GLOBSTAR))Ce=".*";else{let oe=!1;_e.forEach((pe,ne)=>{if(pe===e.GLOBSTAR){if(oe)return;Ce+=w(2,ne===_e.length-1)}else{let Ie=!1,xe="",re=!1,F="";for(const Z of pe){if(Z!=="}"&&Ie){xe+=Z;continue}if(re&&(Z!=="]"||!F)){let be;Z==="-"?be=Z:(Z==="^"||Z==="!")&&!F?be="^":Z===e.GLOB_SPLIT?be="":be=(0,h.escapeRegExpCharacters)(Z),F+=be;continue}switch(Z){case"{":Ie=!0;continue;case"[":re=!0;continue;case"}":{const Le=`(?:${g(xe,",").map(Se=>r(Se)).join("|")})`;Ce+=Le,Ie=!1,xe="";break}case"]":{Ce+="["+F+"]",re=!1,F="";break}case"?":Ce+=_;continue;case"*":Ce+=w(1);continue;default:Ce+=(0,h.escapeRegExpCharacters)(Z)}}ne<_e.length-1&&(_e[ne+1]!==e.GLOBSTAR||ne+2<_e.length)&&(Ce+=L)}oe=pe===e.GLOBSTAR})}return Ce}const o=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new N.LRUCache(1e4),E=function(){return!1},c=function(){return null};function p(fe,Ce){if(!fe)return c;let _e;typeof fe!="string"?_e=fe.pattern:_e=fe,_e=_e.trim();const oe=`${_e}_${!!Ce.trimForExclusions}`;let pe=t.get(oe);if(pe)return b(pe,fe);let ne;return o.test(_e)?pe=u(_e.substr(4),_e):(ne=s.exec(v(_e,Ce)))?pe=C(ne[1],_e):(Ce.trimForExclusions?i:n).test(_e)?pe=f(_e,Ce):(ne=a.exec(v(_e,Ce)))?pe=I(ne[1].substr(1),_e,!0):(ne=d.exec(v(_e,Ce)))?pe=I(ne[1],_e,!1):pe=S(_e),t.set(oe,pe),b(pe,fe)}function b(fe,Ce){if(typeof Ce=="string")return fe;const _e=function(oe,pe){return(0,T.isEqualOrParent)(oe,Ce.base,!m.isLinux)?fe((0,h.ltrim)(oe.substr(Ce.base.length),R.sep),pe):null};return _e.allBasenames=fe.allBasenames,_e.allPaths=fe.allPaths,_e.basenames=fe.basenames,_e.patterns=fe.patterns,_e}function v(fe,Ce){return Ce.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function u(fe,Ce){return function(_e,oe){return typeof _e=="string"&&_e.endsWith(fe)?Ce:null}}function C(fe,Ce){const _e=`/${fe}`,oe=`\\${fe}`,pe=function(Ie,xe){return typeof Ie!="string"?null:xe?xe===fe?Ce:null:Ie===fe||Ie.endsWith(_e)||Ie.endsWith(oe)?Ce:null},ne=[fe];return pe.basenames=ne,pe.patterns=[Ce],pe.allBasenames=ne,pe}function f(fe,Ce){const _e=j(fe.slice(1,-1).split(",").map(xe=>p(xe,Ce)).filter(xe=>xe!==c),fe),oe=_e.length;if(!oe)return c;if(oe===1)return _e[0];const pe=function(xe,re){for(let F=0,Z=_e.length;F<Z;F++)if(_e[F](xe,re))return fe;return null},ne=_e.find(xe=>!!xe.allBasenames);ne&&(pe.allBasenames=ne.allBasenames);const Ie=_e.reduce((xe,re)=>re.allPaths?xe.concat(re.allPaths):xe,[]);return Ie.length&&(pe.allPaths=Ie),pe}function I(fe,Ce,_e){const oe=R.sep===R.posix.sep,pe=oe?fe:fe.replace(l,R.sep),ne=R.sep+pe,Ie=R.posix.sep+fe;let xe;return _e?xe=function(re,F){return typeof re=="string"&&(re===pe||re.endsWith(ne)||!oe&&(re===fe||re.endsWith(Ie)))?Ce:null}:xe=function(re,F){return typeof re=="string"&&(re===pe||!oe&&re===fe)?Ce:null},xe.allPaths=[(_e?"*/":"./")+fe],xe}function S(fe){try{const Ce=new RegExp(`^${r(fe)}$`);return function(_e){return Ce.lastIndex=0,typeof _e=="string"&&Ce.test(_e)?fe:null}}catch{return c}}function P(fe,Ce,_e){return!fe||typeof Ce!="string"?!1:k(fe)(Ce,void 0,_e)}function k(fe,Ce={}){if(!fe)return E;if(typeof fe=="string"||H(fe)){const _e=p(fe,Ce);if(_e===c)return E;const oe=function(pe,ne){return!!_e(pe,ne)};return _e.allBasenames&&(oe.allBasenames=_e.allBasenames),_e.allPaths&&(oe.allPaths=_e.allPaths),oe}return A(fe,Ce)}function H(fe){const Ce=fe;return Ce?typeof Ce.base=="string"&&typeof Ce.pattern=="string":!1}function $(fe){return fe.allBasenames||[]}function V(fe){return fe.allPaths||[]}function A(fe,Ce){const _e=j(Object.getOwnPropertyNames(fe).map(xe=>U(xe,fe[xe],Ce)).filter(xe=>xe!==c)),oe=_e.length;if(!oe)return c;if(!_e.some(xe=>!!xe.requiresSiblings)){if(oe===1)return _e[0];const xe=function(Z,be){let Le;for(let Se=0,ve=_e.length;Se<ve;Se++){const he=_e[Se](Z,be);if(typeof he=="string")return he;(0,O.isThenable)(he)&&(Le||(Le=[]),Le.push(he))}return Le?(async()=>{for(const Se of Le){const ve=await Se;if(typeof ve=="string")return ve}return null})():null},re=_e.find(Z=>!!Z.allBasenames);re&&(xe.allBasenames=re.allBasenames);const F=_e.reduce((Z,be)=>be.allPaths?Z.concat(be.allPaths):Z,[]);return F.length&&(xe.allPaths=F),xe}const pe=function(xe,re,F){let Z,be;for(let Le=0,Se=_e.length;Le<Se;Le++){const ve=_e[Le];ve.requiresSiblings&&F&&(re||(re=(0,R.basename)(xe)),Z||(Z=re.substr(0,re.length-(0,R.extname)(xe).length)));const he=ve(xe,re,Z,F);if(typeof he=="string")return he;(0,O.isThenable)(he)&&(be||(be=[]),be.push(he))}return be?(async()=>{for(const Le of be){const Se=await Le;if(typeof Se=="string")return Se}return null})():null},ne=_e.find(xe=>!!xe.allBasenames);ne&&(pe.allBasenames=ne.allBasenames);const Ie=_e.reduce((xe,re)=>re.allPaths?xe.concat(re.allPaths):xe,[]);return Ie.length&&(pe.allPaths=Ie),pe}function U(fe,Ce,_e){if(Ce===!1)return c;const oe=p(fe,_e);if(oe===c)return c;if(typeof Ce=="boolean")return oe;if(Ce){const pe=Ce.when;if(typeof pe=="string"){const ne=(Ie,xe,re,F)=>{if(!F||!oe(Ie,xe))return null;const Z=pe.replace("$(basename)",()=>re),be=F(Z);return(0,O.isThenable)(be)?be.then(Le=>Le?fe:null):be?fe:null};return ne.requiresSiblings=!0,ne}}return oe}function j(fe,Ce){const _e=fe.filter(xe=>!!xe.basenames);if(_e.length<2)return fe;const oe=_e.reduce((xe,re)=>{const F=re.basenames;return F?xe.concat(F):xe},[]);let pe;if(Ce){pe=[];for(let xe=0,re=oe.length;xe<re;xe++)pe.push(Ce)}else pe=_e.reduce((xe,re)=>{const F=re.patterns;return F?xe.concat(F):xe},[]);const ne=function(xe,re){if(typeof xe!="string")return null;if(!re){let Z;for(Z=xe.length;Z>0;Z--){const be=xe.charCodeAt(Z-1);if(be===47||be===92)break}re=xe.substr(Z)}const F=oe.indexOf(re);return F!==-1?pe[F]:null};ne.basenames=oe,ne.patterns=pe,ne.allBasenames=oe;const Ie=fe.filter(xe=>!xe.basenames);return Ie.push(ne),Ie}function ie(fe,Ce){return(0,D.equals)(fe,Ce,(_e,oe)=>typeof _e=="string"&&typeof oe=="string"?_e===oe:typeof _e!="string"&&typeof oe!="string"?_e.base===oe.base&&_e.pattern===oe.pattern:!1)}}),define(Pe[54],Te([1,0,14,131,23,15,2]),function(me,e,D,O,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0,e.isEmptyMarkdownString=y,e.isMarkdownString=L,e.markdownStringEqual=_,e.escapeMarkdownSyntaxTokens=l,e.appendEscapedMarkdownCodeBlockFence=w,e.escapeDoubleQuotes=g,e.removeMarkdownEscapes=r,e.parseHrefAndDimensions=o;var m;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class h{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,D.illegalArgument)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=l(this.supportThemeIcons?(0,O.escapeIcons)(n):n).replace(/([ \t]+)/g,(a,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${w(i,n)}
`,this}appendLink(n,i,a){return this.value+="[",this.value+=this._escape(i,"]"),this.value+="](",this.value+=this._escape(String(n),")"),a&&(this.value+=` "${this._escape(this._escape(a,'"'),")")}"`),this.value+=")",this}_escape(n,i){const a=new RegExp((0,N.escapeRegExpCharacters)(i),"g");return n.replace(a,(d,t)=>n.charAt(t-1)!=="\\"?`\\${d}`:d)}}e.MarkdownString=h;function y(s){return L(s)?!s.value:Array.isArray(s)?s.every(y):!0}function L(s){return s instanceof h?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}function _(s,n){return s===n?!0:!s||!n?!1:s.value===n.value&&s.isTrusted===n.isTrusted&&s.supportThemeIcons===n.supportThemeIcons&&s.supportHtml===n.supportHtml&&(s.baseUri===n.baseUri||!!s.baseUri&&!!n.baseUri&&(0,T.isEqual)(R.URI.from(s.baseUri),R.URI.from(n.baseUri)))}function l(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function w(s,n){const i=s.match(/^`+/gm)?.reduce((d,t)=>d.length>t.length?d:t).length??0,a=i>=3?i+1:3;return[`${"`".repeat(a)}${n}`,s,`${"`".repeat(a)}`].join(`
`)}function g(s){return s.replace(/"/g,"&quot;")}function r(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(s){const n=[],i=s.split("|").map(d=>d.trim());s=i[0];const a=i[1];if(a){const d=/height=(\d+)/.exec(a),t=/width=(\d+)/.exec(a),E=d?d[1]:"",c=t?t[1]:"",p=isFinite(parseInt(c)),b=isFinite(parseInt(E));p&&n.push(`width="${c}"`),b&&n.push(`height="${E}"`)}return{href:s,dimensions:n}}}),define(Pe[96],Te([1,0,18,46,19,21,23,15]),function(me,e,D,O,T,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathLabel=h,e.normalizeDriveLetter=L,e.tildify=l,e.untildify=w,e.shorten=s,e.template=i,e.mnemonicMenuLabel=a,e.mnemonicButtonLabel=d,e.unmnemonicLabel=t,e.splitRecentLabel=E;function h(p,b){const{os:v,tildify:u,relative:C}=b;if(C){const S=y(p,C,v);if(typeof S=="string")return S}let f=p.fsPath;if(v===1&&!N.isWindows?f=f.replace(/\//g,"\\"):v!==1&&N.isWindows&&(f=f.replace(/\\/g,"/")),v!==1&&u?.userHome){const S=u.userHome.fsPath;let P;p.scheme!==u.userHome.scheme&&p.path[0]===T.posix.sep&&p.path[1]!==T.posix.sep?P=u.userHome.with({path:p.path}).fsPath:P=f,f=l(P,S,v)}return(v===1?T.win32:T.posix).normalize(L(f,v===1))}function y(p,b,v){const u=v===1?T.win32:T.posix,C=v===3?R.extUri:R.extUriIgnorePathCase,f=b.getWorkspace(),I=(0,D.firstOrDefault)(f.folders);if(!I)return;p.scheme!==I.uri.scheme&&p.path[0]===T.posix.sep&&p.path[1]!==T.posix.sep&&(p=I.uri.with({path:p.path}));const S=b.getWorkspaceFolder(p);if(!S)return;let P;if(C.isEqual(S.uri,p)?P="":P=C.relativePath(S.uri,p)??"",P&&(P=u.normalize(P)),f.folders.length>1&&!b.noPrefix){const k=S.name?S.name:C.basenameOrAuthority(S.uri);P=P?`${k} \u2022 ${P}`:k}return P}function L(p,b=N.isWindows){return(0,O.hasDriveLetter)(p,b)?p.charAt(0).toUpperCase()+p.slice(1):p}let _=Object.create(null);function l(p,b,v=N.OS){if(v===1||!p||!b)return p;let u=_.original===b?_.normalized:void 0;u||(u=b,N.isWindows&&(u=(0,O.toSlashes)(u)),u=`${(0,m.rtrim)(u,T.posix.sep)}${T.posix.sep}`,_={original:b,normalized:u});let C=p;return N.isWindows&&(C=(0,O.toSlashes)(C)),(v===3?C.startsWith(u):(0,m.startsWithIgnoreCase)(C,u))?`~/${C.substr(u.length)}`:p}function w(p,b){return p.replace(/^~($|\/|\\)/,`${b}$1`)}const g="\u2026",r="\\\\",o="~";function s(p,b=T.sep){const v=new Array(p.length);let u=!1;for(let C=0;C<p.length;C++){const f=p[C];if(f===""){v[C]=`.${b}`;continue}if(!f){v[C]=f;continue}u=!0;let I="",S=f;S.indexOf(r)===0?(I=S.substr(0,S.indexOf(r)+r.length),S=S.substr(S.indexOf(r)+r.length)):S.indexOf(b)===0?(I=S.substr(0,S.indexOf(b)+b.length),S=S.substr(S.indexOf(b)+b.length)):S.indexOf(o)===0&&(I=S.substr(0,S.indexOf(o)+o.length),S=S.substr(S.indexOf(o)+o.length));const P=S.split(b);for(let k=1;u&&k<=P.length;k++)for(let H=P.length-k;u&&H>=0;H--){u=!1;let $=P.slice(H,H+k).join(b);for(let V=0;!u&&V<p.length;V++)if(V!==C&&p[V]&&p[V].indexOf($)>-1){const A=H+k===P.length,U=H>0&&p[V].indexOf(b)>-1?b+$:$,j=p[V].endsWith(U);u=!A||j}if(!u){let V="";(P[0].endsWith(":")||I!=="")&&(H===1&&(H=0,k++,$=P[0]+b+$),H>0&&(V=P[0]+b),V=I+V),H>0&&(V=V+g+b),V=V+$,H+k<P.length&&(V=V+b+g),v[C]=V}}u&&(v[C]=f)}return v}var n;(function(p){p[p.TEXT=0]="TEXT",p[p.VARIABLE=1]="VARIABLE",p[p.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(p,b=Object.create(null)){const v=[];let u=!1,C="";for(const f of p)if(f==="$"||u&&f==="{")C&&v.push({value:C,type:n.TEXT}),C="",u=!0;else if(f==="}"&&u){const I=b[C];if(typeof I=="string")I.length&&v.push({value:I,type:n.VARIABLE});else if(I){const S=v[v.length-1];(!S||S.type!==n.SEPARATOR)&&v.push({value:I.label,type:n.SEPARATOR})}C="",u=!1}else C+=f;return C&&!u&&v.push({value:C,type:n.TEXT}),v.filter((f,I)=>{if(f.type===n.SEPARATOR){const S=v[I-1],P=v[I+1];return[S,P].every(k=>k&&(k.type===n.VARIABLE||k.type===n.TEXT)&&k.value.length>0)}return!0}).map(f=>f.value).join("")}function a(p,b){return N.isMacintosh||b?p.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.isMacintosh?"&":"&&"):p.replace(/&&|&/g,v=>v==="&"?"&&":"&")}function d(p,b){return N.isMacintosh||b?p.replace(/\(&&\w\)|&&/g,""):N.isWindows?p.replace(/&&|&/g,v=>v==="&"?"&&":"&"):p.replace(/&&/g,"_")}function t(p){return p.replace(/&/g,"&&")}function E(p){if(p.endsWith("]")){const b=p.lastIndexOf(" [",p.length-2);if(b!==-1){const v=c(p.substring(0,b)),u=p.substring(b);return{name:v.name+u,parentPath:v.parentPath}}}return c(p)}function c(p){const b=p.indexOf("/")!==-1?T.posix:T.win32,v=b.basename(p),u=b.dirname(p);return v.length?{name:v,parentPath:u}:{name:u,parentPath:""}}}),define(Pe[144],Te([1,0,22,2]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=m,e.transformIncomingURIs=y,e.transformAndReviveIncomingURIs=L;function T(_){return _.toJSON()}class N{constructor(l){this._uriTransformer=l}transformIncoming(l){const w=this._uriTransformer.transformIncoming(l);return w===l?l:T(O.URI.from(w))}transformOutgoing(l){const w=this._uriTransformer.transformOutgoing(l);return w===l?l:T(O.URI.from(w))}transformOutgoingURI(l){const w=this._uriTransformer.transformOutgoing(l);return w===l?l:O.URI.from(w)}transformOutgoingScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}}e.URITransformer=N,e.DefaultURITransformer=new class{transformIncoming(_){return _}transformOutgoing(_){return _}transformOutgoingURI(_){return _}transformOutgoingScheme(_){return _}};function R(_,l,w){if(!_||w>200)return null;if(typeof _=="object"){if(_ instanceof O.URI)return l.transformOutgoing(_);for(const g in _)if(Object.hasOwnProperty.call(_,g)){const r=R(_[g],l,w+1);r!==null&&(_[g]=r)}}return null}function m(_,l){const w=R(_,l,0);return w===null?_:w}function h(_,l,w,g){if(!_||g>200)return null;if(typeof _=="object"){if(_.$mid===1)return w?O.URI.revive(l.transformIncoming(_)):l.transformIncoming(_);if(_ instanceof D.VSBuffer)return null;for(const r in _)if(Object.hasOwnProperty.call(_,r)){const o=h(_[r],l,w,g+1);o!==null&&(_[r]=o)}}return null}function y(_,l){const w=h(_,l,!1,0);return w===null?_:w}function L(_,l){const w=h(_,l,!0,0);return w===null?_:w}}),define(Pe[145],Te([1,0,15,21,22]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringBuilder=void 0,e.getPlatformTextDecoder=L,e.decodeUTF16LE=_;let N;function R(){return N||(N=new TextDecoder("UTF-16LE")),N}let m;function h(){return m||(m=new TextDecoder("UTF-16BE")),m}let y;function L(){return y||(y=O.isLittleEndian()?R():h()),y}function _(g,r,o){const s=new Uint16Array(g.buffer,r,o);return o>0&&(s[0]===65279||s[0]===65534)?l(g,r,o):R().decode(s)}function l(g,r,o){const s=[];let n=0;for(let i=0;i<o;i++){const a=T.readUInt16LE(g,r);r+=2,s[n++]=String.fromCharCode(a)}return s.join("")}class w{constructor(r){this._capacity=r|0,this._buffer=new Uint16Array(this._capacity),this._completedStrings=null,this._bufferLength=0}reset(){this._completedStrings=null,this._bufferLength=0}build(){return this._completedStrings!==null?(this._flushBuffer(),this._completedStrings.join("")):this._buildBuffer()}_buildBuffer(){if(this._bufferLength===0)return"";const r=new Uint16Array(this._buffer.buffer,0,this._bufferLength);return L().decode(r)}_flushBuffer(){const r=this._buildBuffer();this._bufferLength=0,this._completedStrings===null?this._completedStrings=[r]:this._completedStrings[this._completedStrings.length]=r}appendCharCode(r){const o=this._capacity-this._bufferLength;o<=1&&(o===0||D.isHighSurrogate(r))&&this._flushBuffer(),this._buffer[this._bufferLength++]=r}appendASCIICharCode(r){this._bufferLength===this._capacity&&this._flushBuffer(),this._buffer[this._bufferLength++]=r}appendString(r){const o=r.length;if(this._bufferLength+o>=this._capacity){this._flushBuffer(),this._completedStrings[this._completedStrings.length]=r;return}for(let s=0;s<o;s++)this._buffer[this._bufferLength++]=r.charCodeAt(s)}}e.StringBuilder=w}),define(Pe[146],Te([1,0,22,145]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextChange=void 0,e.compressConsecutiveTextChanges=R;function T(h){return h.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class N{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,L,_,l){this.oldPosition=y,this.oldText=L,this.newPosition=_,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${T(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${T(this.oldText)}")`:`(replace@${this.oldPosition} "${T(this.oldText)}" with "${T(this.newText)}")`}static _writeStringSize(y){return 4+2*y.length}static _writeString(y,L,_){const l=L.length;D.writeUInt32BE(y,l,_),_+=4;for(let w=0;w<l;w++)D.writeUInt16LE(y,L.charCodeAt(w),_),_+=2;return _}static _readString(y,L){const _=D.readUInt32BE(y,L);return L+=4,(0,O.decodeUTF16LE)(y,L,_)}writeSize(){return 8+N._writeStringSize(this.oldText)+N._writeStringSize(this.newText)}write(y,L){return D.writeUInt32BE(y,this.oldPosition,L),L+=4,D.writeUInt32BE(y,this.newPosition,L),L+=4,L=N._writeString(y,this.oldText,L),L=N._writeString(y,this.newText,L),L}static read(y,L,_){const l=D.readUInt32BE(y,L);L+=4;const w=D.readUInt32BE(y,L);L+=4;const g=N._readString(y,L);L+=N._writeStringSize(g);const r=N._readString(y,L);return L+=N._writeStringSize(r),_.push(new N(l,g,w,r)),L}}e.TextChange=N;function R(h,y){return h===null||h.length===0?y:new m(h,y).compress()}class m{constructor(y,L){this._prevEdits=y,this._currEdits=L,this._result=[],this._resultLen=0,this._prevLen=this._prevEdits.length,this._prevDeltaOffset=0,this._currLen=this._currEdits.length,this._currDeltaOffset=0}compress(){let y=0,L=0,_=this._getPrev(y),l=this._getCurr(L);for(;y<this._prevLen||L<this._currLen;){if(_===null){this._acceptCurr(l),l=this._getCurr(++L);continue}if(l===null){this._acceptPrev(_),_=this._getPrev(++y);continue}if(l.oldEnd<=_.newPosition){this._acceptCurr(l),l=this._getCurr(++L);continue}if(_.newEnd<=l.oldPosition){this._acceptPrev(_),_=this._getPrev(++y);continue}if(l.oldPosition<_.newPosition){const[s,n]=m._splitCurr(l,_.newPosition-l.oldPosition);this._acceptCurr(s),l=n;continue}if(_.newPosition<l.oldPosition){const[s,n]=m._splitPrev(_,l.oldPosition-_.newPosition);this._acceptPrev(s),_=n;continue}let r,o;if(l.oldEnd===_.newEnd)r=_,o=l,_=this._getPrev(++y),l=this._getCurr(++L);else if(l.oldEnd<_.newEnd){const[s,n]=m._splitPrev(_,l.oldLength);r=s,o=l,_=n,l=this._getCurr(++L)}else{const[s,n]=m._splitCurr(l,_.newLength);r=_,o=s,_=this._getPrev(++y),l=n}this._result[this._resultLen++]=new N(r.oldPosition,r.oldText,o.newPosition,o.newText),this._prevDeltaOffset+=r.newLength-r.oldLength,this._currDeltaOffset+=o.newLength-o.oldLength}const w=m._merge(this._result);return m._removeNoOps(w)}_acceptCurr(y){this._result[this._resultLen++]=m._rebaseCurr(this._prevDeltaOffset,y),this._currDeltaOffset+=y.newLength-y.oldLength}_getCurr(y){return y<this._currLen?this._currEdits[y]:null}_acceptPrev(y){this._result[this._resultLen++]=m._rebasePrev(this._currDeltaOffset,y),this._prevDeltaOffset+=y.newLength-y.oldLength}_getPrev(y){return y<this._prevLen?this._prevEdits[y]:null}static _rebaseCurr(y,L){return new N(L.oldPosition-y,L.oldText,L.newPosition,L.newText)}static _rebasePrev(y,L){return new N(L.oldPosition,L.oldText,L.newPosition+y,L.newText)}static _splitPrev(y,L){const _=y.newText.substr(0,L),l=y.newText.substr(L);return[new N(y.oldPosition,y.oldText,y.newPosition,_),new N(y.oldEnd,"",y.newPosition+L,l)]}static _splitCurr(y,L){const _=y.oldText.substr(0,L),l=y.oldText.substr(L);return[new N(y.oldPosition,_,y.newPosition,y.newText),new N(y.oldPosition+L,l,y.newEnd,"")]}static _merge(y){if(y.length===0)return y;const L=[];let _=0,l=y[0];for(let w=1;w<y.length;w++){const g=y[w];l.oldEnd===g.oldPosition?l=new N(l.oldPosition,l.oldText+g.oldText,l.newPosition,l.newText+g.newText):(L[_++]=l,l=g)}return L[_++]=l,L}static _removeNoOps(y){if(y.length===0)return y;const L=[];let _=0;for(let l=0;l<y.length;l++){const w=y[l];w.oldText!==w.newText&&(L[_++]=w)}return L}}}),define(Pe[147],Te([1,0,35,19]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=T,e.targetsNotebooks=N;function T(R,m,h,y,L,_){if(Array.isArray(R)){let l=0;for(const w of R){const g=T(w,m,h,y,L,_);if(g===10)return g;g>l&&(l=g)}return l}else{if(typeof R=="string")return y?R==="*"?5:R===h?10:0:0;if(R){const{language:l,pattern:w,scheme:g,hasAccessToAllModels:r,notebookType:o}=R;if(!y&&!r)return 0;o&&L&&(m=L);let s=0;if(g)if(g===m.scheme)s=10;else if(g==="*")s=5;else return 0;if(l)if(l===h)s=10;else if(l==="*")s=Math.max(s,5);else return 0;if(o)if(o===_)s=10;else if(o==="*"&&_!==void 0)s=Math.max(s,5);else return 0;if(w){let n;if(typeof w=="string"?n=w:n={...w,base:(0,O.normalize)(w.base)},n===m.fsPath||(0,D.match)(n,m.fsPath))s=10;else return 0}return s}else return 0}}function N(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(N):!!R.notebookType}}),define(Pe[148],Te([1,0,5,15,29,94,92,133,146,6]),function(me,e,D,O,T,N,R,m,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBuffer=void 0;class L extends y.Disposable{constructor(l,w,g,r,o,s,n){super(),this._onDidChangeContent=this._register(new D.Emitter),this.onDidChangeContent=this._onDidChangeContent.event,this._BOM=w,this._mightContainNonBasicASCII=!s,this._mightContainRTL=r,this._mightContainUnusualLineTerminators=o,this._pieceTree=new R.PieceTreeBase(l,g,n)}equals(l){return!(l instanceof L)||this._BOM!==l._BOM||this.getEOL()!==l.getEOL()?!1:this._pieceTree.equal(l._pieceTree)}mightContainRTL(){return this._mightContainRTL}mightContainUnusualLineTerminators(){return this._mightContainUnusualLineTerminators}resetMightContainUnusualLineTerminators(){this._mightContainUnusualLineTerminators=!1}mightContainNonBasicASCII(){return this._mightContainNonBasicASCII}getBOM(){return this._BOM}getEOL(){return this._pieceTree.getEOL()}createSnapshot(l){return this._pieceTree.createSnapshot(l?this._BOM:"")}getOffsetAt(l,w){return this._pieceTree.getOffsetAt(l,w)}getPositionAt(l){return this._pieceTree.getPositionAt(l)}getRangeAt(l,w){const g=l+w,r=this.getPositionAt(l),o=this.getPositionAt(g);return new T.Range(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(l,w=0){if(l.isEmpty())return"";const g=this._getEndOfLine(w);return this._pieceTree.getValueInRange(l,g)}getValueLengthInRange(l,w=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const g=this.getOffsetAt(l.startLineNumber,l.startColumn),r=this.getOffsetAt(l.endLineNumber,l.endColumn);let o=0;const s=this._getEndOfLine(w),n=this.getEOL();if(s.length!==n.length){const i=s.length-n.length,a=l.endLineNumber-l.startLineNumber;o=i*a}return r-g+o}getCharacterCountInRange(l,w=0){if(this._mightContainNonBasicASCII){let g=0;const r=l.startLineNumber,o=l.endLineNumber;for(let s=r;s<=o;s++){const n=this.getLineContent(s),i=s===r?l.startColumn-1:0,a=s===o?l.endColumn-1:n.length;for(let d=i;d<a;d++)O.isHighSurrogate(n.charCodeAt(d))?(g=g+1,d=d+1):g=g+1}return g+=this._getEndOfLine(w).length*(o-r),g}return this.getValueLengthInRange(l,w)}getLength(){return this._pieceTree.getLength()}getLineCount(){return this._pieceTree.getLineCount()}getLinesContent(){return this._pieceTree.getLinesContent()}getLineContent(l){return this._pieceTree.getLineContent(l)}getLineCharCode(l,w){return this._pieceTree.getLineCharCode(l,w)}getCharCode(l){return this._pieceTree.getCharCode(l)}getLineLength(l){return this._pieceTree.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const w=O.firstNonWhitespaceIndex(this.getLineContent(l));return w===-1?0:w+1}getLineLastNonWhitespaceColumn(l){const w=O.lastNonWhitespaceIndex(this.getLineContent(l));return w===-1?0:w+2}_getEndOfLine(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this._pieceTree.setEOL(l)}applyEdits(l,w,g){let r=this._mightContainRTL,o=this._mightContainUnusualLineTerminators,s=this._mightContainNonBasicASCII,n=!0,i=[];for(let b=0;b<l.length;b++){const v=l[b];n&&v._isTracked&&(n=!1);const u=v.range;if(v.text){let P=!0;s||(P=!O.isBasicASCII(v.text),s=P),!r&&P&&(r=O.containsRTL(v.text)),!o&&P&&(o=O.containsUnusualLineTerminators(v.text))}let C="",f=0,I=0,S=0;if(v.text){let P;[f,I,S,P]=(0,m.countEOL)(v.text);const k=this.getEOL();P===0||P===(k===`\r
`?2:1)?C=v.text:C=v.text.replace(/\r\n|\r|\n/g,k)}i[b]={sortIndex:b,identifier:v.identifier||null,range:u,rangeOffset:this.getOffsetAt(u.startLineNumber,u.startColumn),rangeLength:this.getValueLengthInRange(u),text:C,eolCount:f,firstLineLength:I,lastLineLength:S,forceMoveMarkers:!!v.forceMoveMarkers,isAutoWhitespaceEdit:v.isAutoWhitespaceEdit||!1}}i.sort(L._sortOpsAscending);let a=!1;for(let b=0,v=i.length-1;b<v;b++){const u=i[b].range.getEndPosition(),C=i[b+1].range.getStartPosition();if(C.isBeforeOrEqual(u)){if(C.isBefore(u))throw new Error("Overlapping ranges are not allowed!");a=!0}}n&&(i=this._reduceOperations(i));const d=g||w?L._getInverseEditRanges(i):[],t=[];if(w)for(let b=0;b<i.length;b++){const v=i[b],u=d[b];if(v.isAutoWhitespaceEdit&&v.range.isEmpty())for(let C=u.startLineNumber;C<=u.endLineNumber;C++){let f="";C===u.startLineNumber&&(f=this.getLineContent(v.range.startLineNumber),O.firstNonWhitespaceIndex(f)!==-1)||t.push({lineNumber:C,oldContent:f})}}let E=null;if(g){let b=0;E=[];for(let v=0;v<i.length;v++){const u=i[v],C=d[v],f=this.getValueInRange(u.range),I=u.rangeOffset+b;b+=u.text.length-f.length,E[v]={sortIndex:u.sortIndex,identifier:u.identifier,range:C,text:f,textChange:new h.TextChange(u.rangeOffset,f,I,u.text)}}a||E.sort((v,u)=>v.sortIndex-u.sortIndex)}this._mightContainRTL=r,this._mightContainUnusualLineTerminators=o,this._mightContainNonBasicASCII=s;const c=this._doApplyEdits(i);let p=null;if(w&&t.length>0){t.sort((b,v)=>v.lineNumber-b.lineNumber),p=[];for(let b=0,v=t.length;b<v;b++){const u=t[b].lineNumber;if(b>0&&t[b-1].lineNumber===u)continue;const C=t[b].oldContent,f=this.getLineContent(u);f.length===0||f===C||O.firstNonWhitespaceIndex(f)!==-1||p.push(u)}}return this._onDidChangeContent.fire(),new N.ApplyEditsResult(E,c,p)}_reduceOperations(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let w=!1;const g=l[0].range,r=l[l.length-1].range,o=new T.Range(g.startLineNumber,g.startColumn,r.endLineNumber,r.endColumn);let s=g.startLineNumber,n=g.startColumn;const i=[];for(let c=0,p=l.length;c<p;c++){const b=l[c],v=b.range;w=w||b.forceMoveMarkers,i.push(this.getValueInRange(new T.Range(s,n,v.startLineNumber,v.startColumn))),b.text.length>0&&i.push(b.text),s=v.endLineNumber,n=v.endColumn}const a=i.join(""),[d,t,E]=(0,m.countEOL)(a);return{sortIndex:0,identifier:l[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:a,eolCount:d,firstLineLength:t,lastLineLength:E,forceMoveMarkers:w,isAutoWhitespaceEdit:!1}}_doApplyEdits(l){l.sort(L._sortOpsDescending);const w=[];for(let g=0;g<l.length;g++){const r=l[g],o=r.range.startLineNumber,s=r.range.startColumn,n=r.range.endLineNumber,i=r.range.endColumn;if(o===n&&s===i&&r.text.length===0)continue;r.text?(this._pieceTree.delete(r.rangeOffset,r.rangeLength),this._pieceTree.insert(r.rangeOffset,r.text,!0)):this._pieceTree.delete(r.rangeOffset,r.rangeLength);const a=new T.Range(o,s,n,i);w.push({range:a,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return w}findMatchesLineByLine(l,w,g,r){return this._pieceTree.findMatchesLineByLine(l,w,g,r)}getPieceTree(){return this._pieceTree}static _getInverseEditRange(l,w){const g=l.startLineNumber,r=l.startColumn,[o,s,n]=(0,m.countEOL)(w);let i;if(w.length>0){const a=o+1;a===1?i=new T.Range(g,r,g,r+s):i=new T.Range(g,r,g+a-1,n+1)}else i=new T.Range(g,r,g,r);return i}static _getInverseEditRanges(l){const w=[];let g=0,r=0,o=null;for(let s=0,n=l.length;s<n;s++){const i=l[s];let a,d;o?o.range.endLineNumber===i.range.startLineNumber?(a=g,d=r+(i.range.startColumn-o.range.endColumn)):(a=g+(i.range.startLineNumber-o.range.endLineNumber),d=i.range.startColumn):(a=i.range.startLineNumber,d=i.range.startColumn);let t;if(i.text.length>0){const E=i.eolCount+1;E===1?t=new T.Range(a,d,a,d+i.firstLineLength):t=new T.Range(a,d,a+E-1,i.lastLineLength+1)}else t=new T.Range(a,d,a,d);g=t.endLineNumber,r=t.endColumn,w.push(t),o=i}return w}static _sortOpsAscending(l,w){const g=T.Range.compareRangesUsingEnds(l.range,w.range);return g===0?l.sortIndex-w.sortIndex:g}static _sortOpsDescending(l,w){const g=T.Range.compareRangesUsingEnds(l.range,w.range);return g===0?w.sortIndex-l.sortIndex:-g}}e.PieceTreeTextBuffer=L}),define(Pe[149],Te([1,0,15,92,148]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PieceTreeTextBufferBuilder=void 0;class N{constructor(h,y,L,_,l,w,g,r,o){this._chunks=h,this._bom=y,this._cr=L,this._lf=_,this._crlf=l,this._containsRTL=w,this._containsUnusualLineTerminators=g,this._isBasicASCII=r,this._normalizeEOL=o}_getEOL(h){const y=this._cr+this._lf+this._crlf,L=this._cr+this._crlf;return y===0?h===1?`
`:`\r
`:L>y/2?`\r
`:`
`}create(h){const y=this._getEOL(h),L=this._chunks;if(this._normalizeEOL&&(y===`\r
`&&(this._cr>0||this._lf>0)||y===`
`&&(this._cr>0||this._crlf>0)))for(let l=0,w=L.length;l<w;l++){const g=L[l].buffer.replace(/\r\n|\r|\n/g,y),r=(0,O.createLineStartsFast)(g);L[l]=new O.StringBuffer(g,r)}const _=new T.PieceTreeTextBuffer(L,this._bom,y,this._containsRTL,this._containsUnusualLineTerminators,this._isBasicASCII,this._normalizeEOL);return{textBuffer:_,disposable:_}}getFirstLineText(h){return this._chunks[0].buffer.substr(0,h).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.chunks=[],this.BOM="",this._hasPreviousChar=!1,this._previousChar=0,this._tmpLineStarts=[],this.cr=0,this.lf=0,this.crlf=0,this.containsRTL=!1,this.containsUnusualLineTerminators=!1,this.isBasicASCII=!0}acceptChunk(h){if(h.length===0)return;this.chunks.length===0&&D.startsWithUTF8BOM(h)&&(this.BOM=D.UTF8_BOM_CHARACTER,h=h.substr(1));const y=h.charCodeAt(h.length-1);y===13||y>=55296&&y<=56319?(this._acceptChunk1(h.substr(0,h.length-1),!1),this._hasPreviousChar=!0,this._previousChar=y):(this._acceptChunk1(h,!1),this._hasPreviousChar=!1,this._previousChar=y)}_acceptChunk1(h,y){!y&&h.length===0||(this._hasPreviousChar?this._acceptChunk2(String.fromCharCode(this._previousChar)+h):this._acceptChunk2(h))}_acceptChunk2(h){const y=(0,O.createLineStarts)(this._tmpLineStarts,h);this.chunks.push(new O.StringBuffer(h,y.lineStarts)),this.cr+=y.cr,this.lf+=y.lf,this.crlf+=y.crlf,y.isBasicASCII||(this.isBasicASCII=!1,this.containsRTL||(this.containsRTL=D.containsRTL(h)),this.containsUnusualLineTerminators||(this.containsUnusualLineTerminators=D.containsUnusualLineTerminators(h)))}finish(h=!0){return this._finish(),new N(this.chunks,this.BOM,this.cr,this.lf,this.crlf,this.containsRTL,this.containsUnusualLineTerminators,this.isBasicASCII,h)}_finish(){if(this.chunks.length===0&&this._acceptChunk1("",!0),this._hasPreviousChar){this._hasPreviousChar=!1;const h=this.chunks[this.chunks.length-1];h.buffer+=String.fromCharCode(this._previousChar);const y=(0,O.createLineStartsFast)(h.buffer);h.lineStarts=y,this._previousChar===13&&this.cr++}}}e.PieceTreeTextBufferBuilder=R}),define(Pe[97],Te([1,0,22,21]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeSemanticTokensDto=h,e.decodeSemanticTokensDto=L;var T;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(T||(T={}));function N(_){for(let l=0,w=_.length;l<w;l+=4){const g=_[l+0],r=_[l+1],o=_[l+2],s=_[l+3];_[l+0]=s,_[l+1]=o,_[l+2]=r,_[l+3]=g}}function R(_){const l=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return O.isLittleEndian()||N(l),D.VSBuffer.wrap(l)}function m(_){const l=_.buffer;if(O.isLittleEndian()||N(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const w=new Uint8Array(l.byteLength);return w.set(l),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function h(_){const l=new Uint32Array(y(_));let w=0;if(l[w++]=_.id,_.type==="full")l[w++]=1,l[w++]=_.data.length,l.set(_.data,w),w+=_.data.length;else{l[w++]=2,l[w++]=_.deltas.length;for(const g of _.deltas)l[w++]=g.start,l[w++]=g.deleteCount,g.data?(l[w++]=g.data.length,l.set(g.data,w),w+=g.data.length):l[w++]=0}return R(l)}function y(_){let l=0;if(l+=2,_.type==="full")l+=1+_.data.length;else{l+=1,l+=3*_.deltas.length;for(const w of _.deltas)w.data&&(l+=w.data.length)}return l}function L(_){const l=m(_);let w=0;const g=l[w++];if(l[w++]===1){const n=l[w++],i=l.subarray(w,w+n);return w+=n,{id:g,type:"full",data:i}}const o=l[w++],s=[];for(let n=0;n<o;n++){const i=l[w++],a=l[w++],d=l[w++];let t;d>0&&(t=l.subarray(w,w+d),w+=d),s[n]={start:i,deleteCount:a,data:t}}return{id:g,type:"delta",deltas:s}}}),define(Pe[150],Te([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Pe[151],Te([1,0,18,26,21,134,152,150]),function(me,e,D,O,T,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=n,e.clampedFloat=a,e.stringSet=E,e.cursorStyleToString=S,e.filterValidationDecorations=de;var h;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(h||(e.EditorAutoIndentStrategy=h={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=y;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class _{constructor(X,ge,Ve,Qe){this.id=X,this.name=ge,this.defaultValue=Ve,this.schema=Qe}applyUpdate(X,ge){return w(X,ge)}compute(X,ge,Ve){return Ve}}class l{constructor(X,ge){this.newValue=X,this.didChange=ge}}e.ApplyUpdateResult=l;function w(Q,X){if(typeof Q!="object"||typeof X!="object"||!Q||!X)return new l(X,Q!==X);if(Array.isArray(Q)||Array.isArray(X)){const Ve=Array.isArray(Q)&&Array.isArray(X)&&D.equals(Q,X);return new l(X,!Ve)}let ge=!1;for(const Ve in X)if(X.hasOwnProperty(Ve)){const Qe=w(Q[Ve],X[Ve]);Qe.didChange&&(Q[Ve]=Qe.newValue,ge=!0)}return new l(Q,ge)}class g{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,ge){return w(X,ge)}validate(X){return this.defaultValue}}class r{constructor(X,ge,Ve,Qe){this.id=X,this.name=ge,this.defaultValue=Ve,this.schema=Qe}applyUpdate(X,ge){return w(X,ge)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,ge,Ve){return Ve}}function o(Q,X){return typeof Q>"u"?X:Q==="false"?!1:!!Q}class s extends r{constructor(X,ge,Ve,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=Ve),super(X,ge,Ve,Qe)}validate(X){return o(X,this.defaultValue)}}function n(Q,X,ge,Ve){if(typeof Q>"u")return X;let Qe=parseInt(Q,10);return isNaN(Qe)?X:(Qe=Math.max(ge,Qe),Qe=Math.min(Ve,Qe),Qe|0)}class i extends r{static clampedInt(X,ge,Ve,Qe){return n(X,ge,Ve,Qe)}constructor(X,ge,Ve,Qe,Ae,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=Ve,dt.minimum=Qe,dt.maximum=Ae),super(X,ge,Ve,dt),this.minimum=Qe,this.maximum=Ae}validate(X){return i.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function a(Q,X,ge,Ve){if(typeof Q>"u")return X;const Qe=d.float(Q,X);return d.clamp(Qe,ge,Ve)}class d extends r{static clamp(X,ge,Ve){return X<ge?ge:X>Ve?Ve:X}static float(X,ge){if(typeof X=="number")return X;if(typeof X>"u")return ge;const Ve=parseFloat(X);return isNaN(Ve)?ge:Ve}constructor(X,ge,Ve,Qe,Ae){typeof Ae<"u"&&(Ae.type="number",Ae.default=Ve),super(X,ge,Ve,Ae),this.validationFn=Qe}validate(X){return this.validationFn(d.float(X,this.defaultValue))}}class t extends r{static string(X,ge){return typeof X!="string"?ge:X}constructor(X,ge,Ve,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=Ve),super(X,ge,Ve,Qe)}validate(X){return t.string(X,this.defaultValue)}}function E(Q,X,ge,Ve){return typeof Q!="string"?X:Ve&&Q in Ve?Ve[Q]:ge.indexOf(Q)===-1?X:Q}class c extends r{constructor(X,ge,Ve,Qe,Ae=void 0){typeof Ae<"u"&&(Ae.type="string",Ae.enum=Qe,Ae.default=Ve),super(X,ge,Ve,Ae),this._allowedValues=Qe}validate(X){return E(X,this.defaultValue,this._allowedValues)}}class p extends _{constructor(X,ge,Ve,Qe,Ae,dt,Pt=void 0){typeof Pt<"u"&&(Pt.type="string",Pt.enum=Ae,Pt.default=Qe),super(X,ge,Ve,Pt),this._allowedValues=Ae,this._convert=dt}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function b(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends _{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,ge,Ve){return Ve===0?X.accessibilitySupport:Ve}}class u extends _{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:m.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{insertSpace:o(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var C;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(C||(e.TextEditorCursorBlinkingStyle=C={}));function f(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var I;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(I||(e.TextEditorCursorStyle=I={}));function S(Q){switch(Q){case I.Line:return"line";case I.Block:return"block";case I.Underline:return"underline";case I.LineThin:return"line-thin";case I.BlockOutline:return"block-outline";case I.UnderlineThin:return"underline-thin"}}function P(Q){switch(Q){case"line":return I.Line;case"block":return I.Block;case"underline":return I.Underline;case"line-thin":return I.LineThin;case"block-outline":return I.BlockOutline;case"underline-thin":return I.UnderlineThin}}class k extends g{constructor(){super(142)}compute(X,ge,Ve){const Qe=["monaco-editor"];return ge.get(39)&&Qe.push(ge.get(39)),X.extraEditorClassName&&Qe.push(X.extraEditorClassName),ge.get(74)==="default"?Qe.push("mouse-default"):ge.get(74)==="copy"&&Qe.push("mouse-copy"),ge.get(111)&&Qe.push("showUnused"),ge.get(140)&&Qe.push("showDeprecated"),Qe.join(" ")}}class H extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(X,ge,Ve){return Ve&&X.emptySelectionClipboard}}class $ extends _{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:m.localize(16,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:m.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{cursorMoveOnType:o(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":E(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":E(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(ge.loop,this.defaultValue.loop)}}}class V extends _{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",V.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"||X.length===0?V.OFF:X==="true"?V.ON:X:X?V.ON:V.OFF}}e.EditorFontLigatures=V;class A extends _{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",A.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?A.OFF:X==="true"?A.TRANSLATE:X:X?A.TRANSLATE:A.OFF}compute(X,ge,Ve){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=A;class U extends g{constructor(){super(50)}compute(X,ge,Ve){return X.fontInfo}}class j extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(X){const ge=d.float(X,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(ge,6,100)}compute(X,ge,Ve){return X.fontInfo.fontSize}}class ie extends _{static{this.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.MINIMUM_VALUE=1}static{this.MAXIMUM_VALUE=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ie.MINIMUM_VALUE,maximum:ie.MAXIMUM_VALUE,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ie.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(i.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,ie.MINIMUM_VALUE,ie.MAXIMUM_VALUE))}}class fe extends _{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...ge},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...ge},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Ve,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Ve,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Ve,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Ve,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Ve,description:m.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{multiple:E(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??E(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??E(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??E(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??E(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??E(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Ce extends _{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:m.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:o(ge.enabled,this.defaultValue.enabled),delay:i.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:o(ge.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(ge.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(ge.above,this.defaultValue.above)}}}var _e;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(_e||(e.RenderMinimap=_e={}));class oe extends g{constructor(){super(145)}compute(X,ge,Ve){return oe.computeLayout(ge,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const ge=X.height/X.lineHeight,Ve=Math.floor(X.paddingTop/X.lineHeight);let Qe=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Qe=Math.max(Qe,ge-1));const Ae=(Ve+X.viewLineCount+Qe)/(X.pixelRatio*X.height),dt=Math.floor(X.viewLineCount/Ae);return{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Qe,desiredRatio:Ae,minimapLineCount:dt}}static _computeMinimapLayout(X,ge){const Ve=X.outerWidth,Qe=X.outerHeight,Ae=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ae*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const dt=ge.stableMinimapLayoutInput,Pt=dt&&X.outerHeight===dt.outerHeight&&X.lineHeight===dt.lineHeight&&X.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&X.pixelRatio===dt.pixelRatio&&X.scrollBeyondLastLine===dt.scrollBeyondLastLine&&X.paddingTop===dt.paddingTop&&X.paddingBottom===dt.paddingBottom&&X.minimap.enabled===dt.minimap.enabled&&X.minimap.side===dt.minimap.side&&X.minimap.size===dt.minimap.size&&X.minimap.showSlider===dt.minimap.showSlider&&X.minimap.renderCharacters===dt.minimap.renderCharacters&&X.minimap.maxColumn===dt.minimap.maxColumn&&X.minimap.scale===dt.minimap.scale&&X.verticalScrollbarWidth===dt.verticalScrollbarWidth&&X.isViewportWrapping===dt.isViewportWrapping,zt=X.lineHeight,Zt=X.typicalHalfwidthCharacterWidth,Gt=X.scrollBeyondLastLine,ei=X.minimap.renderCharacters;let It=Ae>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Xt=X.minimap.maxColumn,Vt=X.minimap.size,ci=X.minimap.side,Ye=X.verticalScrollbarWidth,ti=X.viewLineCount,ii=X.remainingWidth,Wt=X.isViewportWrapping,ut=ei?2:3;let Et=Math.floor(Ae*Qe);const ai=Et/Ae;let qt=!1,$t=!1,mt=ut*It,Dt=It/Ae,li=1;if(Vt==="fill"||Vt==="fit"){const{typicalViewportLineCount:Lt,extraLinesBeforeFirstLine:Tt,extraLinesBeyondLastLine:Nt,desiredRatio:ui,minimapLineCount:Mt}=oe.computeContainedMinimapLineCount({viewLineCount:ti,scrollBeyondLastLine:Gt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Qe,lineHeight:zt,pixelRatio:Ae});if(ti/Mt>1)qt=!0,$t=!0,It=1,mt=1,Dt=It/Ae;else{let yt=!1,Rt=It+1;if(Vt==="fit"){const ri=Math.ceil((Tt+ti+Nt)*mt);Wt&&Pt&&ii<=ge.stableFitRemainingWidth?(yt=!0,Rt=ge.stableFitMaxMinimapScale):yt=ri>Et}if(Vt==="fill"||yt){qt=!0;const ri=It;mt=Math.min(zt*Ae,Math.max(1,Math.floor(1/ui))),Wt&&Pt&&ii<=ge.stableFitRemainingWidth&&(Rt=ge.stableFitMaxMinimapScale),It=Math.min(Rt,Math.max(1,Math.floor(mt/ut))),It>ri&&(li=Math.min(2,It/ri)),Dt=It/Ae/li,Et=Math.ceil(Math.max(Lt,Tt+ti+Nt)*mt),Wt?(ge.stableMinimapLayoutInput=X,ge.stableFitRemainingWidth=ii,ge.stableFitMaxMinimapScale=It):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const Qt=Math.floor(Xt*Dt),We=Math.min(Qt,Math.max(0,Math.floor((ii-Ye-2)*Dt/(Zt+Dt)))+e.MINIMAP_GUTTER_WIDTH);let Ot=Math.floor(Ae*We);const Ht=Ot/Ae;Ot=Math.floor(Ot*li);const ni=ei?1:2,pt=ci==="left"?0:Ve-We-Ye;return{renderMinimap:ni,minimapLeft:pt,minimapWidth:We,minimapHeightIsEditorHeight:qt,minimapIsSampling:$t,minimapScale:It,minimapLineHeight:mt,minimapCanvasInnerWidth:Ot,minimapCanvasInnerHeight:Et,minimapCanvasOuterWidth:Ht,minimapCanvasOuterHeight:ai}}static computeLayout(X,ge){const Ve=ge.outerWidth|0,Qe=ge.outerHeight|0,Ae=ge.lineHeight|0,dt=ge.lineNumbersDigitCount|0,Pt=ge.typicalHalfwidthCharacterWidth,zt=ge.maxDigitWidth,Zt=ge.pixelRatio,Gt=ge.viewLineCount,ei=X.get(137),It=ei==="inherit"?X.get(136):ei,Xt=It==="inherit"?X.get(132):It,Vt=X.get(135),ci=ge.isDominatedByLongLines,Ye=X.get(57),ti=X.get(68).renderType!==0,ii=X.get(69),Wt=X.get(105),ut=X.get(84),Et=X.get(73),ai=X.get(103),qt=ai.verticalScrollbarSize,$t=ai.verticalHasArrows,mt=ai.arrowSize,Dt=ai.horizontalScrollbarSize,li=X.get(43),Qt=X.get(110)!=="never";let We=X.get(66);li&&Qt&&(We+=16);let Ot=0;if(ti){const wt=Math.max(dt,ii);Ot=Math.round(wt*zt)}let Ht=0;Ye&&(Ht=Ae*ge.glyphMarginDecorationLaneCount);let ni=0,pt=ni+Ht,Lt=pt+Ot,Tt=Lt+We;const Nt=Ve-Ht-Ot-We;let ui=!1,Mt=!1,Ft=-1;It==="inherit"&&ci?(ui=!0,Mt=!0):Xt==="on"||Xt==="bounded"?Mt=!0:Xt==="wordWrapColumn"&&(Ft=Vt);const yt=oe._computeMinimapLayout({outerWidth:Ve,outerHeight:Qe,lineHeight:Ae,typicalHalfwidthCharacterWidth:Pt,pixelRatio:Zt,scrollBeyondLastLine:Wt,paddingTop:ut.top,paddingBottom:ut.bottom,minimap:Et,verticalScrollbarWidth:qt,viewLineCount:Gt,remainingWidth:Nt,isViewportWrapping:Mt},ge.memory||new L);yt.renderMinimap!==0&&yt.minimapLeft===0&&(ni+=yt.minimapWidth,pt+=yt.minimapWidth,Lt+=yt.minimapWidth,Tt+=yt.minimapWidth);const Rt=Nt-yt.minimapWidth,ri=Math.max(1,Math.floor((Rt-qt-2)/Pt)),xt=$t?mt:0;return Mt&&(Ft=Math.max(1,ri),Xt==="bounded"&&(Ft=Math.min(Ft,Vt))),{width:Ve,height:Qe,glyphMarginLeft:ni,glyphMarginWidth:Ht,glyphMarginDecorationLaneCount:ge.glyphMarginDecorationLaneCount,lineNumbersLeft:pt,lineNumbersWidth:Ot,decorationsLeft:Lt,decorationsWidth:We,contentLeft:Tt,contentWidth:Rt,minimap:yt,viewportColumn:ri,isWordWrapMinified:ui,isViewportWrapping:Mt,wrappingColumn:Ft,verticalScrollbarWidth:qt,horizontalScrollbarHeight:Dt,overviewRuler:{top:xt,width:qt,height:Qe-2*xt,right:0}}}}e.EditorLayoutInfoComputer=oe;class pe extends _{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(X){return E(X,"simple",["simple","advanced"])}compute(X,ge,Ve){return ge.get(2)===2?"advanced":Ve}}var ne;(function(Q){Q.Off="off",Q.OnCode="onCode",Q.On="on"})(ne||(e.ShowLightbulbIconMode=ne={}));class Ie extends _{constructor(){const X={enabled:ne.On};super(65,"lightbulb",X,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ne.Off,ne.OnCode,ne.On],default:X.enabled,enumDescriptions:[m.localize(50,null),m.localize(51,null),m.localize(52,null)],description:m.localize(53,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:E(X.enabled,this.defaultValue.enabled,[ne.Off,ne.OnCode,ne.On])}}}class xe extends _{constructor(){const X={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:m.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:20,description:m.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:m.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:m.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:o(ge.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:E(ge.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(ge.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class re extends _{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:m.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(59,null),m.localize(60,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),m.localize(61,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:m.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:m.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:m.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:E(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(ge.fontFamily,this.defaultValue.fontFamily),padding:o(ge.padding,this.defaultValue.padding)}}}class F extends _{constructor(){super(66,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):i.clampedInt(X,this.defaultValue,0,1e3)}compute(X,ge,Ve){return Ve<0?i.clampedInt(-Ve*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class Z extends d{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>d.clamp(X,0,150),{markdownDescription:m.localize(66,null)})}compute(X,ge,Ve){return X.fontInfo.lineHeight}}class be extends _{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:m.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:m.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(69,null),m.localize(70,null),m.localize(71,null)],default:X.size,description:m.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:m.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:m.localize(74,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:m.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:m.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:X.showRegionSectionHeaders,description:m.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:X.showMarkSectionHeaders,description:m.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:X.sectionHeaderFontSize,description:m.localize(80,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:o(ge.enabled,this.defaultValue.enabled),autohide:o(ge.autohide,this.defaultValue.autohide),size:E(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:E(ge.side,this.defaultValue.side,["right","left"]),showSlider:E(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(ge.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(ge.scale,1,1,3),maxColumn:i.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:o(ge.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:o(ge.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:d.clamp(ge.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Le(Q){return Q==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Se extends _{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(82,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{top:i.clampedInt(ge.top,0,0,1e3),bottom:i.clampedInt(ge.bottom,0,0,1e3)}}}class ve extends _{constructor(){const X={enabled:!0,cycle:!0};super(86,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:m.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:m.localize(84,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:o(ge.enabled,this.defaultValue.enabled),cycle:o(ge.cycle,this.defaultValue.cycle)}}}class he extends g{constructor(){super(143)}compute(X,ge,Ve){return X.pixelRatio}}class K extends _{constructor(){const X={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(85,null),m.localize(86,null),m.localize(87,null)]}];super(89,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:X.strings,description:m.localize(88,null)},comments:{anyOf:ge,default:X.comments,description:m.localize(89,null)},other:{anyOf:ge,default:X.other,description:m.localize(90,null)}},default:X,markdownDescription:m.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Zt=X?"on":"off";return{comments:Zt,strings:Zt,other:Zt}}if(!X||typeof X!="object")return this.defaultValue;const{other:ge,comments:Ve,strings:Qe}=X,Ae=["on","inline","off"];let dt,Pt,zt;return typeof ge=="boolean"?dt=ge?"on":"off":dt=E(ge,this.defaultValue.other,Ae),typeof Ve=="boolean"?Pt=Ve?"on":"off":Pt=E(Ve,this.defaultValue.comments,Ae),typeof Qe=="boolean"?zt=Qe?"on":"off":zt=E(Qe,this.defaultValue.strings,Ae),{other:dt,comments:Pt,strings:zt}}}var Y;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class le extends _{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(92,null),m.localize(93,null),m.localize(94,null),m.localize(95,null)],default:"on",description:m.localize(96,null)})}validate(X){let ge=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(ge=4,Ve=X):X==="interval"?ge=3:X==="relative"?ge=2:X==="on"?ge=1:ge=0),{renderType:ge,renderFn:Ve}}}function de(Q){const X=Q.get(98);return X==="editable"?Q.get(91):X!=="on"}class Ne extends _{constructor(){const X=[],ge={type:"number",description:m.localize(97,null)};super(102,"rulers",X,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:m.localize(98,null),format:"color-hex"}}}]},default:X,description:m.localize(99,null)})}validate(X){if(Array.isArray(X)){const ge=[];for(const Ve of X)if(typeof Ve=="number")ge.push({column:i.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Qe=Ve;ge.push({column:i.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return ge.sort((Ve,Qe)=>Ve.column-Qe.column),ge}return this.defaultValue}}class ue extends _{constructor(){super(92,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function De(Q,X){if(typeof Q!="string")return X;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class Re extends _{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(100,null),m.localize(101,null),m.localize(102,null)],default:"auto",description:m.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(104,null),m.localize(105,null),m.localize(106,null)],default:"auto",description:m.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:m.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:m.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:m.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:m.localize(111,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X,Ve=i.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=i.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(ge.vertical,this.defaultValue.vertical),horizontal:De(ge.horizontal,this.defaultValue.horizontal),useShadows:o(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:i.clampedInt(ge.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:i.clampedInt(ge.verticalSliderSize,Qe,0,1e3),scrollByPage:o(ge.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(ge.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Ue extends _{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:m.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:m.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:m.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:m.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:m.localize(118,null)}})}applyUpdate(X,ge){let Ve=!1;ge.allowedCharacters&&X&&(O.equals(X.allowedCharacters,ge.allowedCharacters)||(X={...X,allowedCharacters:ge.allowedCharacters},Ve=!0)),ge.allowedLocales&&X&&(O.equals(X.allowedLocales,ge.allowedLocales)||(X={...X,allowedLocales:ge.allowedLocales},Ve=!0));const Qe=super.applyUpdate(X,ge);return Ve?new l(Qe.newValue,!0):Qe}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{nonBasicASCII:ee(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(X.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(X,ge){if(typeof X!="object"||!X)return ge;const Ve={};for(const[Qe,Ae]of Object.entries(X))Ae===!0&&(Ve[Qe]=!0);return Ve}}class B extends _{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:m.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(120,null),m.localize(121,null),m.localize(122,null)],description:m.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:m.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:X.fontFamily,description:m.localize(125,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:o(ge.enabled,this.defaultValue.enabled),mode:E(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:E(ge.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(ge.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(ge.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(ge.fontFamily,this.defaultValue.fontFamily)}}}class x extends _{constructor(){const X={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",X,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:X.enabled,description:m.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(127,null),m.localize(128,null),m.localize(129,null)],description:m.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:X.fontFamily,description:m.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:X.backgroundColoring,description:m.localize(132,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:o(ge.enabled,this.defaultValue.enabled),showToolbar:E(ge.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(ge.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o(ge.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o(ge.backgroundColoring,this.defaultValue.backgroundColoring)}}}class q extends _{constructor(){const X={enabled:N.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:N.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:m.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:m.localize(134,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:o(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class W extends _{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(135,null),m.localize(136,null),m.localize(137,null)],default:X.bracketPairs,description:m.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(139,null),m.localize(140,null),m.localize(141,null)],default:X.bracketPairsHorizontal,description:m.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:m.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:m.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(145,null),m.localize(146,null),m.localize(147,null)],default:X.highlightActiveIndentation,description:m.localize(148,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{bracketPairs:ee(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(Q,X,ge){const Ve=ge.indexOf(Q);return Ve===-1?X:ge[Ve]}class se extends _{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(149,null),m.localize(150,null)],default:X.insertMode,description:m.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:m.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:m.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:m.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(155,null),m.localize(156,null),m.localize(157,null),m.localize(158,null)],default:X.selectionMode,markdownDescription:m.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:m.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:m.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:m.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:m.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:m.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(196,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{insertMode:E(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:E(ge.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(ge.showIcons,this.defaultValue.showIcons),showStatusBar:o(ge.showStatusBar,this.defaultValue.showStatusBar),preview:o(ge.preview,this.defaultValue.preview),previewMode:E(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(ge.showMethods,this.defaultValue.showMethods),showFunctions:o(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:o(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(ge.showFields,this.defaultValue.showFields),showVariables:o(ge.showVariables,this.defaultValue.showVariables),showClasses:o(ge.showClasses,this.defaultValue.showClasses),showStructs:o(ge.showStructs,this.defaultValue.showStructs),showInterfaces:o(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:o(ge.showModules,this.defaultValue.showModules),showProperties:o(ge.showProperties,this.defaultValue.showProperties),showEvents:o(ge.showEvents,this.defaultValue.showEvents),showOperators:o(ge.showOperators,this.defaultValue.showOperators),showUnits:o(ge.showUnits,this.defaultValue.showUnits),showValues:o(ge.showValues,this.defaultValue.showValues),showConstants:o(ge.showConstants,this.defaultValue.showConstants),showEnums:o(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:o(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(ge.showKeywords,this.defaultValue.showKeywords),showWords:o(ge.showWords,this.defaultValue.showWords),showColors:o(ge.showColors,this.defaultValue.showColors),showFiles:o(ge.showFiles,this.defaultValue.showFiles),showReferences:o(ge.showReferences,this.defaultValue.showReferences),showFolders:o(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:o(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(ge.showSnippets,this.defaultValue.showSnippets),showUsers:o(ge.showUsers,this.defaultValue.showUsers),showIssues:o(ge.showIssues,this.defaultValue.showIssues)}}}class Oe extends _{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(198,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(X.selectSubwords,this.defaultValue.selectSubwords)}}}class ze extends _{constructor(){const X=[];super(130,"wordSegmenterLocales",X,{anyOf:[{description:m.localize(199,null),type:"string"},{description:m.localize(200,null),type:"array",items:{type:"string"}}]})}validate(X){if(typeof X=="string"&&(X=[X]),Array.isArray(X)){const ge=[];for(const Ve of X)if(typeof Ve=="string")try{Intl.Segmenter.supportedLocalesOf(Ve).length>0&&ge.push(Ve)}catch{}return ge}return this.defaultValue}}var Ge;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(Ge||(e.WrappingIndent=Ge={}));class Je extends _{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(201,null),m.localize(202,null),m.localize(203,null),m.localize(204,null)],description:m.localize(205,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,ge,Ve){return ge.get(2)===2?0:Ve}}class et extends g{constructor(){super(146)}compute(X,ge,Ve){const Qe=ge.get(145);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class ot extends _{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:m.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(208,null),m.localize(209,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:o(ge.enabled,this.defaultValue.enabled),showDropSelector:E(ge.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends _{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:m.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(212,null),m.localize(213,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:o(ge.enabled,this.defaultValue.enabled),showPasteSelector:E(ge.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",ft="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?at:T.isLinux?ft:nt,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var st;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.ariaRequired=5]="ariaRequired",Q[Q.autoClosingBrackets=6]="autoClosingBrackets",Q[Q.autoClosingComments=7]="autoClosingComments",Q[Q.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Q[Q.autoClosingDelete=9]="autoClosingDelete",Q[Q.autoClosingOvertype=10]="autoClosingOvertype",Q[Q.autoClosingQuotes=11]="autoClosingQuotes",Q[Q.autoIndent=12]="autoIndent",Q[Q.automaticLayout=13]="automaticLayout",Q[Q.autoSurround=14]="autoSurround",Q[Q.bracketPairColorization=15]="bracketPairColorization",Q[Q.guides=16]="guides",Q[Q.codeLens=17]="codeLens",Q[Q.codeLensFontFamily=18]="codeLensFontFamily",Q[Q.codeLensFontSize=19]="codeLensFontSize",Q[Q.colorDecorators=20]="colorDecorators",Q[Q.colorDecoratorsLimit=21]="colorDecoratorsLimit",Q[Q.columnSelection=22]="columnSelection",Q[Q.comments=23]="comments",Q[Q.contextmenu=24]="contextmenu",Q[Q.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=26]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=28]="cursorStyle",Q[Q.cursorSurroundingLines=29]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=31]="cursorWidth",Q[Q.disableLayerHinting=32]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Q[Q.domReadOnly=34]="domReadOnly",Q[Q.dragAndDrop=35]="dragAndDrop",Q[Q.dropIntoEditor=36]="dropIntoEditor",Q[Q.emptySelectionClipboard=37]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=39]="extraEditorClassName",Q[Q.fastScrollSensitivity=40]="fastScrollSensitivity",Q[Q.find=41]="find",Q[Q.fixedOverflowWidgets=42]="fixedOverflowWidgets",Q[Q.folding=43]="folding",Q[Q.foldingStrategy=44]="foldingStrategy",Q[Q.foldingHighlight=45]="foldingHighlight",Q[Q.foldingImportsByDefault=46]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=47]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=49]="fontFamily",Q[Q.fontInfo=50]="fontInfo",Q[Q.fontLigatures=51]="fontLigatures",Q[Q.fontSize=52]="fontSize",Q[Q.fontWeight=53]="fontWeight",Q[Q.fontVariations=54]="fontVariations",Q[Q.formatOnPaste=55]="formatOnPaste",Q[Q.formatOnType=56]="formatOnType",Q[Q.glyphMargin=57]="glyphMargin",Q[Q.gotoLocation=58]="gotoLocation",Q[Q.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Q[Q.hover=60]="hover",Q[Q.inDiffEditor=61]="inDiffEditor",Q[Q.inlineSuggest=62]="inlineSuggest",Q[Q.inlineEdit=63]="inlineEdit",Q[Q.letterSpacing=64]="letterSpacing",Q[Q.lightbulb=65]="lightbulb",Q[Q.lineDecorationsWidth=66]="lineDecorationsWidth",Q[Q.lineHeight=67]="lineHeight",Q[Q.lineNumbers=68]="lineNumbers",Q[Q.lineNumbersMinChars=69]="lineNumbersMinChars",Q[Q.linkedEditing=70]="linkedEditing",Q[Q.links=71]="links",Q[Q.matchBrackets=72]="matchBrackets",Q[Q.minimap=73]="minimap",Q[Q.mouseStyle=74]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=76]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=78]="multiCursorModifier",Q[Q.multiCursorPaste=79]="multiCursorPaste",Q[Q.multiCursorLimit=80]="multiCursorLimit",Q[Q.occurrencesHighlight=81]="occurrencesHighlight",Q[Q.overviewRulerBorder=82]="overviewRulerBorder",Q[Q.overviewRulerLanes=83]="overviewRulerLanes",Q[Q.padding=84]="padding",Q[Q.pasteAs=85]="pasteAs",Q[Q.parameterHints=86]="parameterHints",Q[Q.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=89]="quickSuggestions",Q[Q.quickSuggestionsDelay=90]="quickSuggestionsDelay",Q[Q.readOnly=91]="readOnly",Q[Q.readOnlyMessage=92]="readOnlyMessage",Q[Q.renameOnType=93]="renameOnType",Q[Q.renderControlCharacters=94]="renderControlCharacters",Q[Q.renderFinalNewline=95]="renderFinalNewline",Q[Q.renderLineHighlight=96]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=98]="renderValidationDecorations",Q[Q.renderWhitespace=99]="renderWhitespace",Q[Q.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Q[Q.roundedSelection=101]="roundedSelection",Q[Q.rulers=102]="rulers",Q[Q.scrollbar=103]="scrollbar",Q[Q.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=105]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=106]="scrollPredominantAxis",Q[Q.selectionClipboard=107]="selectionClipboard",Q[Q.selectionHighlight=108]="selectionHighlight",Q[Q.selectOnLineNumbers=109]="selectOnLineNumbers",Q[Q.showFoldingControls=110]="showFoldingControls",Q[Q.showUnused=111]="showUnused",Q[Q.snippetSuggestions=112]="snippetSuggestions",Q[Q.smartSelect=113]="smartSelect",Q[Q.smoothScrolling=114]="smoothScrolling",Q[Q.stickyScroll=115]="stickyScroll",Q[Q.stickyTabStops=116]="stickyTabStops",Q[Q.stopRenderingLineAfter=117]="stopRenderingLineAfter",Q[Q.suggest=118]="suggest",Q[Q.suggestFontSize=119]="suggestFontSize",Q[Q.suggestLineHeight=120]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Q[Q.suggestSelection=122]="suggestSelection",Q[Q.tabCompletion=123]="tabCompletion",Q[Q.tabIndex=124]="tabIndex",Q[Q.unicodeHighlighting=125]="unicodeHighlighting",Q[Q.unusualLineTerminators=126]="unusualLineTerminators",Q[Q.useShadowDOM=127]="useShadowDOM",Q[Q.useTabStops=128]="useTabStops",Q[Q.wordBreak=129]="wordBreak",Q[Q.wordSegmenterLocales=130]="wordSegmenterLocales",Q[Q.wordSeparators=131]="wordSeparators",Q[Q.wordWrap=132]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=135]="wordWrapColumn",Q[Q.wordWrapOverride1=136]="wordWrapOverride1",Q[Q.wordWrapOverride2=137]="wordWrapOverride2",Q[Q.wrappingIndent=138]="wrappingIndent",Q[Q.wrappingStrategy=139]="wrappingStrategy",Q[Q.showDeprecated=140]="showDeprecated",Q[Q.inlayHints=141]="inlayHints",Q[Q.editorClassName=142]="editorClassName",Q[Q.pixelRatio=143]="pixelRatio",Q[Q.tabFocusMode=144]="tabFocusMode",Q[Q.layoutInfo=145]="layoutInfo",Q[Q.wrappingInfo=146]="wrappingInfo",Q[Q.defaultColorDecorators=147]="defaultColorDecorators",Q[Q.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",Q[Q.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(214,null)})),acceptSuggestionOnEnter:Be(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(215,null),""],markdownDescription:m.localize(216,null)})),accessibilitySupport:Be(new v),accessibilityPageSize:Be(new i(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(217,null),tags:["accessibility"]})),ariaLabel:Be(new t(4,"ariaLabel",m.localize(218,null))),ariaRequired:Be(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Be(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(220,null),m.localize(221,null),""],description:m.localize(222,null)})),autoClosingComments:Be(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(223,null),m.localize(224,null),""],description:m.localize(225,null)})),autoClosingDelete:Be(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(226,null),""],description:m.localize(227,null)})),autoClosingOvertype:Be(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(228,null),""],description:m.localize(229,null)})),autoClosingQuotes:Be(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(230,null),m.localize(231,null),""],description:m.localize(232,null)})),autoIndent:Be(new p(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[m.localize(233,null),m.localize(234,null),m.localize(235,null),m.localize(236,null),m.localize(237,null)],description:m.localize(238,null)})),automaticLayout:Be(new s(13,"automaticLayout",!1)),autoSurround:Be(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(239,null),m.localize(240,null),m.localize(241,null),""],description:m.localize(242,null)})),bracketPairColorization:Be(new q),bracketPairGuides:Be(new W),stickyTabStops:Be(new s(116,"stickyTabStops",!1,{description:m.localize(243,null)})),codeLens:Be(new s(17,"codeLens",!0,{description:m.localize(244,null)})),codeLensFontFamily:Be(new t(18,"codeLensFontFamily","",{description:m.localize(245,null)})),codeLensFontSize:Be(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(246,null)})),colorDecorators:Be(new s(20,"colorDecorators",!0,{description:m.localize(247,null)})),colorDecoratorActivatedOn:Be(new c(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(248,null),m.localize(249,null),m.localize(250,null)],description:m.localize(251,null)})),colorDecoratorsLimit:Be(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(252,null)})),columnSelection:Be(new s(22,"columnSelection",!1,{description:m.localize(253,null)})),comments:Be(new u),contextmenu:Be(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new s(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(254,null)})),cursorBlinking:Be(new p(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:m.localize(255,null)})),cursorSmoothCaretAnimation:Be(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(256,null),m.localize(257,null),m.localize(258,null)],description:m.localize(259,null)})),cursorStyle:Be(new p(28,"cursorStyle",I.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:m.localize(260,null)})),cursorSurroundingLines:Be(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(261,null)})),cursorSurroundingLinesStyle:Be(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(262,null),m.localize(263,null)],markdownDescription:m.localize(264,null)})),cursorWidth:Be(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(265,null)})),disableLayerHinting:Be(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new s(34,"domReadOnly",!1)),dragAndDrop:Be(new s(35,"dragAndDrop",!0,{description:m.localize(266,null)})),emptySelectionClipboard:Be(new H),dropIntoEditor:Be(new ot),stickyScroll:Be(new xe),experimentalWhitespaceRendering:Be(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(267,null),m.localize(268,null),m.localize(269,null)],description:m.localize(270,null)})),extraEditorClassName:Be(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Be(new d(40,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:m.localize(271,null)})),find:Be(new $),fixedOverflowWidgets:Be(new s(42,"fixedOverflowWidgets",!1)),folding:Be(new s(43,"folding",!0,{description:m.localize(272,null)})),foldingStrategy:Be(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(273,null),m.localize(274,null)],description:m.localize(275,null)})),foldingHighlight:Be(new s(45,"foldingHighlight",!0,{description:m.localize(276,null)})),foldingImportsByDefault:Be(new s(46,"foldingImportsByDefault",!1,{description:m.localize(277,null)})),foldingMaximumRegions:Be(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(278,null)})),unfoldOnClickAfterEndOfLine:Be(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(279,null)})),fontFamily:Be(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(280,null)})),fontInfo:Be(new U),fontLigatures2:Be(new V),fontSize:Be(new j),fontWeight:Be(new ie),fontVariations:Be(new A),formatOnPaste:Be(new s(55,"formatOnPaste",!1,{description:m.localize(281,null)})),formatOnType:Be(new s(56,"formatOnType",!1,{description:m.localize(282,null)})),glyphMargin:Be(new s(57,"glyphMargin",!0,{description:m.localize(283,null)})),gotoLocation:Be(new fe),hideCursorInOverviewRuler:Be(new s(59,"hideCursorInOverviewRuler",!1,{description:m.localize(284,null)})),hover:Be(new Ce),inDiffEditor:Be(new s(61,"inDiffEditor",!1)),letterSpacing:Be(new d(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>d.clamp(Q,-5,20),{description:m.localize(285,null)})),lightbulb:Be(new Ie),lineDecorationsWidth:Be(new F),lineHeight:Be(new Z),lineNumbers:Be(new le),lineNumbersMinChars:Be(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new s(70,"linkedEditing",!1,{description:m.localize(286,null)})),links:Be(new s(71,"links",!0,{description:m.localize(287,null)})),matchBrackets:Be(new c(72,"matchBrackets","always",["always","near","never"],{description:m.localize(288,null)})),minimap:Be(new be),mouseStyle:Be(new c(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new d(75,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:m.localize(289,null)})),mouseWheelZoom:Be(new s(76,"mouseWheelZoom",!1,{markdownDescription:T.isMacintosh?m.localize(290,null):m.localize(291,null)})),multiCursorMergeOverlapping:Be(new s(77,"multiCursorMergeOverlapping",!0,{description:m.localize(292,null)})),multiCursorModifier:Be(new p(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Le,{markdownEnumDescriptions:[m.localize(293,null),m.localize(294,null)],markdownDescription:m.localize(295,null)})),multiCursorPaste:Be(new c(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(296,null),m.localize(297,null)],markdownDescription:m.localize(298,null)})),multiCursorLimit:Be(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(299,null)})),occurrencesHighlight:Be(new c(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(300,null),m.localize(301,null),m.localize(302,null)],markdownDescription:m.localize(303,null)})),overviewRulerBorder:Be(new s(82,"overviewRulerBorder",!0,{description:m.localize(304,null)})),overviewRulerLanes:Be(new i(83,"overviewRulerLanes",3,0,3)),padding:Be(new Se),pasteAs:Be(new it),parameterHints:Be(new ve),peekWidgetDefaultFocus:Be(new c(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(305,null),m.localize(306,null)],description:m.localize(307,null)})),definitionLinkOpensInPeek:Be(new s(88,"definitionLinkOpensInPeek",!1,{description:m.localize(308,null)})),quickSuggestions:Be(new K),quickSuggestionsDelay:Be(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(309,null)})),readOnly:Be(new s(91,"readOnly",!1)),readOnlyMessage:Be(new ue),renameOnType:Be(new s(93,"renameOnType",!1,{description:m.localize(310,null),markdownDeprecationMessage:m.localize(311,null)})),renderControlCharacters:Be(new s(94,"renderControlCharacters",!0,{description:m.localize(312,null),restricted:!0})),renderFinalNewline:Be(new c(95,"renderFinalNewline",T.isLinux?"dimmed":"on",["off","on","dimmed"],{description:m.localize(313,null)})),renderLineHighlight:Be(new c(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(314,null)],description:m.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Be(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(316,null)})),renderValidationDecorations:Be(new c(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new c(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(317,null),m.localize(318,null),m.localize(319,null),""],description:m.localize(320,null)})),revealHorizontalRightPadding:Be(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new s(101,"roundedSelection",!0,{description:m.localize(321,null)})),rulers:Be(new Ne),scrollbar:Be(new Re),scrollBeyondLastColumn:Be(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(322,null)})),scrollBeyondLastLine:Be(new s(105,"scrollBeyondLastLine",!0,{description:m.localize(323,null)})),scrollPredominantAxis:Be(new s(106,"scrollPredominantAxis",!0,{description:m.localize(324,null)})),selectionClipboard:Be(new s(107,"selectionClipboard",!0,{description:m.localize(325,null),included:T.isLinux})),selectionHighlight:Be(new s(108,"selectionHighlight",!0,{description:m.localize(326,null)})),selectOnLineNumbers:Be(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:Be(new c(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(327,null),m.localize(328,null),m.localize(329,null)],description:m.localize(330,null)})),showUnused:Be(new s(111,"showUnused",!0,{description:m.localize(331,null)})),showDeprecated:Be(new s(140,"showDeprecated",!0,{description:m.localize(332,null)})),inlayHints:Be(new re),snippetSuggestions:Be(new c(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(333,null),m.localize(334,null),m.localize(335,null),m.localize(336,null)],description:m.localize(337,null)})),smartSelect:Be(new Oe),smoothScrolling:Be(new s(114,"smoothScrolling",!1,{description:m.localize(338,null)})),stopRenderingLineAfter:Be(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new se),inlineSuggest:Be(new B),inlineEdit:Be(new x),inlineCompletionsAccessibilityVerbose:Be(new s(149,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(339,null)})),suggestFontSize:Be(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new s(121,"suggestOnTriggerCharacters",!0,{description:m.localize(342,null)})),suggestSelection:Be(new c(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(343,null),m.localize(344,null),m.localize(345,null)],description:m.localize(346,null)})),tabCompletion:Be(new c(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(347,null),m.localize(348,null),m.localize(349,null)],description:m.localize(350,null)})),tabIndex:Be(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new Ue),unusualLineTerminators:Be(new c(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(351,null),m.localize(352,null),m.localize(353,null)],description:m.localize(354,null)})),useShadowDOM:Be(new s(127,"useShadowDOM",!0)),useTabStops:Be(new s(128,"useTabStops",!0,{description:m.localize(355,null)})),wordBreak:Be(new c(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(356,null),m.localize(357,null)],description:m.localize(358,null)})),wordSegmenterLocales:Be(new ze),wordSeparators:Be(new t(131,"wordSeparators",R.USUAL_WORD_SEPARATORS,{description:m.localize(359,null)})),wordWrap:Be(new c(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(360,null),m.localize(361,null),m.localize(362,null),m.localize(363,null)],description:m.localize(364,null)})),wordWrapBreakAfterCharacters:Be(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(365,null)})),wordWrapOverride1:Be(new c(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new c(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new k),defaultColorDecorators:Be(new s(147,"defaultColorDecorators",!1,{markdownDescription:m.localize(366,null)})),pixelRatio:Be(new he),tabFocusMode:Be(new s(144,"tabFocusMode",!1,{markdownDescription:m.localize(367,null)})),layoutInfo:Be(new oe),wrappingInfo:Be(new et),wrappingIndent:Be(new Je),wrappingStrategy:Be(new pe)}}),define(Pe[153],Te([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[154],Te([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[155],Te([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[156],Te([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[157],Te([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[158],Te([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Pe[159],Te([9,10]),function(me,e){return me.create("vs/platform/log/common/log",e)}),define(Pe[160],Te([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Pe[161],Te([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[162],Te([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Pe[163],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[164],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[165],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[166],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[167],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Pe[168],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[169],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[170],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[171],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[172],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[173],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[174],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[175],Te([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[176],Te([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Pe[177],Te([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Pe[178],Te([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Pe[179],Te([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[180],Te([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[181],Te([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[182],Te([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[183],Te([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[184],Te([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[185],Te([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[186],Te([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[187],Te([1,0,14,155]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var T;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(T||(e.TokenType=T={}));function N(...y){switch(y.length){case 1:return(0,O.localize)(0,null,y[0]);case 2:return(0,O.localize)(1,null,y[0],y[1]);case 3:return(0,O.localize)(2,null,y[0],y[1],y[2]);default:return}}const R=(0,O.localize)(3,null),m=(0,O.localize)(4,null);class h{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,D.illegalState)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(L=>L.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(L){return this._input=L,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const _=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:_})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const _=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:_})}else this._match(126)?this._addToken(9):this._error(N("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(N("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(L){return this._isAtEnd()||this._input.charCodeAt(this._current)!==L?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(L){this._tokens.push({type:L,offset:this._start})}_error(L){const _=this._start,l=this._input.substring(this._start,this._current),w={type:19,offset:this._start,lexeme:l};this._errors.push({offset:_,lexeme:l,additionalInfo:L}),this._tokens.push(w)}_string(){this.stringRe.lastIndex=this._start;const L=this.stringRe.exec(this._input);if(L){this._current=this._start+L[0].length;const _=this._input.substring(this._start,this._current),l=h._keywords.get(_);l?this._addToken(l):this._tokens.push({type:17,lexeme:_,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(R);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let L=this._current,_=!1,l=!1;for(;;){if(L>=this._input.length){this._current=L,this._error(m);return}const g=this._input.charCodeAt(L);if(_)_=!1;else if(g===47&&!l){L++;break}else g===91?l=!0:g===92?_=!0:g===93&&(l=!1);L++}for(;L<this._input.length&&h._regexFlags.has(this._input.charCodeAt(L));)L++;this._current=L;const w=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:w,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=h}),define(Pe[188],Te([1,0,23,32,157,301]),function(me,e,D,O,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=h,e.parseVersion=y,e.normalizeVersion=L,e.isValidVersion=_,e.validateExtensionManifest=l,e.isValidExtensionVersion=w,e.isEngineValid=g;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function h(s){return s=s.trim(),s==="*"||R.test(s)}function y(s){if(!h(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=s.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function L(s){if(!s)return null;const n=s.majorBase,i=s.majorMustEqual,a=s.minorBase;let d=s.minorMustEqual;const t=s.patchBase;let E=s.patchMustEqual;s.hasCaret&&(n===0||(d=!1),E=!1);let c=0;if(s.preRelease){const p=m.exec(s.preRelease);if(p){const[,b,v,u]=p;c=Date.UTC(Number(b),Number(v)-1,Number(u))}}return{majorBase:n,majorMustEqual:i,minorBase:a,minorMustEqual:d,patchBase:t,patchMustEqual:E,isMinimum:s.hasGreaterEquals,notBefore:c}}function _(s,n,i){let a;typeof s=="string"?a=L(y(s)):a=s;let d;n instanceof Date?d=n.getTime():typeof n=="string"&&(d=new Date(n).getTime());let t;if(typeof i=="string"?t=L(y(i)):t=i,!a||!t)return!1;const E=a.majorBase,c=a.minorBase,p=a.patchBase;let b=t.majorBase,v=t.minorBase,u=t.patchBase;const C=t.notBefore;let f=t.majorMustEqual,I=t.minorMustEqual,S=t.patchMustEqual;return t.isMinimum?E>b?!0:E<b?!1:c>v?!0:c<v||d&&d<C?!1:p>=u:(E===1&&b===0&&(!f||!I||!S)&&(b=1,v=0,u=0,f=!0,I=!1,S=!1),E<b?!1:E>b?!f:c<v?!1:c>v?!I:p<u?!1:p>u?!S:!(d&&d<C))}function l(s,n,i,a,d){const t=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return t.push([O.default.Error,T.localize(0,null)]),t;if(typeof a.name!="string")return t.push([O.default.Error,T.localize(1,null,"name")]),t;if(typeof a.version!="string")return t.push([O.default.Error,T.localize(2,null,"version")]),t;if(!a.engines)return t.push([O.default.Error,T.localize(3,null,"engines")]),t;if(typeof a.engines.vscode!="string")return t.push([O.default.Error,T.localize(4,null,"engines.vscode")]),t;if(typeof a.extensionDependencies<"u"&&!o(a.extensionDependencies))return t.push([O.default.Error,T.localize(5,null,"extensionDependencies")]),t;if(typeof a.activationEvents<"u"){if(!o(a.activationEvents))return t.push([O.default.Error,T.localize(6,null,"activationEvents")]),t;if(typeof a.main>"u"&&typeof a.browser>"u")return t.push([O.default.Error,T.localize(7,null,"activationEvents","main","browser")]),t}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&t.push([O.default.Warning,T.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return t.push([O.default.Error,T.localize(9,null,"main")]),t;{const p=(0,D.joinPath)(i,a.main);(0,D.isEqualOrParent)(p,i)||t.push([O.default.Warning,T.localize(10,null,p.path,i.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return t.push([O.default.Error,T.localize(11,null,"browser")]),t;{const p=(0,D.joinPath)(i,a.browser);(0,D.isEqualOrParent)(p,i)||t.push([O.default.Warning,T.localize(12,null,p.path,i.path)])}}if(!N.valid(a.version))return t.push([O.default.Error,T.localize(13,null)]),t;const E=[];if(!w(s,n,a,d,E))for(const p of E)t.push([O.default.Error,p]);return t}function w(s,n,i,a,d){return a||typeof i.main>"u"&&typeof i.browser>"u"?!0:r(s,n,i.engines.vscode,d)}function g(s,n,i){return s==="*"||r(n,i,s)}function r(s,n,i,a=[]){const d=L(y(i));if(!d)return a.push(T.localize(14,null,i)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return a.push(T.localize(15,null,i)),!1}else if(!d.majorMustEqual)return a.push(T.localize(16,null,i)),!1;return _(s,n,d)?!0:(a.push(T.localize(17,null,s,i)),!1)}function o(s){if(!Array.isArray(s))return!1;for(let n=0,i=s.length;n<i;n++)if(typeof s[n]!="string")return!1;return!0}}),define(Pe[70],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(T,N=[],R=!1){this.ctor=T,this.staticArguments=N,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=D}),define(Pe[55],Te([1,0,70]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=N,e.getSingletonServiceDescriptors=R;const O=[];var T;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(T||(e.InstantiationType=T={}));function N(m,h,y){h instanceof D.SyncDescriptor||(h=new D.SyncDescriptor(h,[],!!y)),O.push([m,h])}function R(){return O}}),define(Pe[189],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(N,R){this.key=N,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=D;class O{constructor(N){this._hashFn=N,this._nodes=new Map}roots(){const N=[];for(const R of this._nodes.values())R.outgoing.size===0&&N.push(R);return N}insertEdge(N,R){const m=this.lookupOrInsertNode(N),h=this.lookupOrInsertNode(R);m.outgoing.set(h.key,h),h.incoming.set(m.key,m)}removeNode(N){const R=this._hashFn(N);this._nodes.delete(R);for(const m of this._nodes.values())m.outgoing.delete(R),m.incoming.delete(R)}lookupOrInsertNode(N){const R=this._hashFn(N);let m=this._nodes.get(R);return m||(m=new D(R,N),this._nodes.set(R,m)),m}lookup(N){return this._nodes.get(this._hashFn(N))}isEmpty(){return this._nodes.size===0}toString(){const N=[];for(const[R,m]of this._nodes)N.push(`${R}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,R]of this._nodes){const m=new Set([N]),h=this._findCycle(R,m);if(h)return h}}_findCycle(N,R){for(const[m,h]of N.outgoing){if(R.has(m))return[...R,m].join(" -> ");R.add(m);const y=this._findCycle(h,R);if(y)return y;R.delete(m)}}}e.Graph=O}),define(Pe[3],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=T,e.refineServiceDecorator=N;var D;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function m(h){return h[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=m})(D||(e._util=D={})),e.IInstantiationService=T("instantiationService");function O(R,m,h){m[D.DI_TARGET]===m?m[D.DI_DEPENDENCIES].push({id:R,index:h}):(m[D.DI_DEPENDENCIES]=[{id:R,index:h}],m[D.DI_TARGET]=m)}function T(R){if(D.serviceIds.has(R))return D.serviceIds.get(R);const m=function(h,y,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(m,h,L)};return m.toString=()=>R,D.serviceIds.set(R,m),m}function N(R){return R}}),define(Pe[47],Te([1,0,17,2,3]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=N,e.isConfigurationUpdateOverrides=R,e.ConfigurationTargetToString=h,e.isConfigured=y,e.toValuesTree=L,e.addToValueTree=_,e.removeFromValueTree=l,e.getConfigurationValue=g,e.merge=r,e.getLanguageTagSettingPlainKey=o,e.IConfigurationService=(0,T.createDecorator)("configurationService");function N(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof O.URI)}function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof O.URI)}var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function h(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function y(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}function L(s,n){const i=Object.create(null);for(const a in s)_(i,a,s[a],n);return i}function _(s,n,i,a){const d=n.split("."),t=d.pop();let E=s;for(let c=0;c<d.length;c++){const p=d[c];let b=E[p];switch(typeof b){case"undefined":b=E[p]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${d.slice(0,c+1).join(".")} is ${JSON.stringify(b)}`);return}E=b}if(typeof E=="object"&&E!==null)try{E[t]=i}catch{a(`Ignoring ${n} as ${d.join(".")} is ${JSON.stringify(E)}`)}else a(`Ignoring ${n} as ${d.join(".")} is ${JSON.stringify(E)}`)}function l(s,n){const i=n.split(".");w(s,i)}function w(s,n){const i=n.shift();if(n.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const a=s[i];typeof a=="object"&&!Array.isArray(a)&&(w(a,n),Object.keys(a).length===0&&delete s[i])}}function g(s,n,i){function a(E,c){let p=E;for(const b of c){if(typeof p!="object"||p===null)return;p=p[b]}return p}const d=n.split("."),t=a(s,d);return typeof t>"u"?i:t}function r(s,n,i){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in s?D.isObject(s[a])&&D.isObject(n[a])?r(s[a],n[a],i):i&&(s[a]=n[a]):s[a]=n[a])})}function o(s){return s.replace(/[\[\]]/g,"")}}),define(Pe[33],Te([1,0,21,15,187,3,154,14]),function(me,e,D,O,T,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=y,e.validateWhenClauses=E,e.expressionsAreEqualWithConstantSubstitution=c,e.implies=ne;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",D.isMacintosh),h.set("isLinux",D.isLinux),h.set("isWindows",D.isWindows),h.set("isWeb",D.isWeb),h.set("isMacNative",D.isMacintosh&&!D.isWeb),h.set("isEdge",D.isEdge),h.set("isFirefox",D.isFirefox),h.set("isChrome",D.isChrome),h.set("isSafari",D.isSafari);function y(re,F){if(h.get(re)!==void 0)throw(0,m.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(re,F)}const L=Object.prototype.hasOwnProperty;var _;(function(re){re[re.False=0]="False",re[re.True=1]="True",re[re.Defined=2]="Defined",re[re.Not=3]="Not",re[re.Equals=4]="Equals",re[re.NotEquals=5]="NotEquals",re[re.And=6]="And",re[re.Regex=7]="Regex",re[re.NotRegex=8]="NotRegex",re[re.Or=9]="Or",re[re.In=10]="In",re[re.NotIn=11]="NotIn",re[re.Greater=12]="Greater",re[re.GreaterEquals=13]="GreaterEquals",re[re.Smaller=14]="Smaller",re[re.SmallerEquals=15]="SmallerEquals"})(_||(e.ContextKeyExprType=_={}));const l={regexParsingWithErrorRecovery:!0},w=(0,R.localize)(0,null),g=(0,R.localize)(1,null),r=(0,R.localize)(2,null),o=(0,R.localize)(3,null),s=(0,R.localize)(4,null),n=(0,R.localize)(5,null),i=(0,R.localize)(6,null),a=(0,R.localize)(7,null);class d{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(F=l){this._config=F,this._scanner=new T.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(F){if(F===""){this._parsingErrors.push({message:w,offset:0,lexeme:"",additionalInfo:g});return}this._tokens=this._scanner.reset(F).scan(),this._current=0,this._parsingErrors=[];try{const Z=this._expr();if(!this._isAtEnd()){const be=this._peek(),Le=be.type===17?n:void 0;throw this._parsingErrors.push({message:s,offset:be.offset,lexeme:T.Scanner.getLexeme(be),additionalInfo:Le}),d._parseError}return Z}catch(Z){if(Z!==d._parseError)throw Z;return}}_expr(){return this._or()}_or(){const F=[this._and()];for(;this._matchOne(16);){const Z=this._and();F.push(Z)}return F.length===1?F[0]:t.or(...F)}_and(){const F=[this._term()];for(;this._matchOne(15);){const Z=this._term();F.push(Z)}return F.length===1?F[0]:t.and(...F)}_term(){if(this._matchOne(2)){const F=this._peek();switch(F.type){case 11:return this._advance(),b.INSTANCE;case 12:return this._advance(),v.INSTANCE;case 0:{this._advance();const Z=this._expr();return this._consume(1,o),Z?.negate()}case 17:return this._advance(),P.create(F.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",F)}}return this._primary()}_primary(){const F=this._peek();switch(F.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const Z=this._expr();return this._consume(1,o),Z}case 17:{const Z=F.lexeme;if(this._advance(),this._matchOne(9)){const Le=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Le.type!==10)throw this._errExpectedButGot("REGEX",Le);const Se=Le.lexeme,ve=Se.lastIndexOf("/"),he=ve===Se.length-1?void 0:this._removeFlagsGY(Se.substring(ve+1));let K;try{K=new RegExp(Se.substring(1,ve),he)}catch{throw this._errExpectedButGot("REGEX",Le)}return U.create(Z,K)}switch(Le.type){case 10:case 19:{const Se=[Le.lexeme];this._advance();let ve=this._peek(),he=0;for(let Ne=0;Ne<Le.lexeme.length;Ne++)Le.lexeme.charCodeAt(Ne)===40?he++:Le.lexeme.charCodeAt(Ne)===41&&he--;for(;!this._isAtEnd()&&ve.type!==15&&ve.type!==16;){switch(ve.type){case 0:he++;break;case 1:he--;break;case 10:case 18:for(let Ne=0;Ne<ve.lexeme.length;Ne++)ve.lexeme.charCodeAt(Ne)===40?he++:Le.lexeme.charCodeAt(Ne)===41&&he--}if(he<0)break;Se.push(T.Scanner.getLexeme(ve)),this._advance(),ve=this._peek()}const K=Se.join(""),Y=K.lastIndexOf("/"),le=Y===K.length-1?void 0:this._removeFlagsGY(K.substring(Y+1));let de;try{de=new RegExp(K.substring(1,Y),le)}catch{throw this._errExpectedButGot("REGEX",Le)}return t.regex(Z,de)}case 18:{const Se=Le.lexeme;this._advance();let ve=null;if(!(0,O.isFalsyOrWhitespace)(Se)){const he=Se.indexOf("/"),K=Se.lastIndexOf("/");if(he!==K&&he>=0){const Y=Se.slice(he+1,K),le=Se[K+1]==="i"?"i":"";try{ve=new RegExp(Y,le)}catch{throw this._errExpectedButGot("REGEX",Le)}}}if(ve===null)throw this._errExpectedButGot("REGEX",Le);return U.create(Z,ve)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,r);const Le=this._value();return t.notIn(Z,Le)}switch(this._peek().type){case 3:{this._advance();const Le=this._value();if(this._previous().type===18)return t.equals(Z,Le);switch(Le){case"true":return t.has(Z);case"false":return t.not(Z);default:return t.equals(Z,Le)}}case 4:{this._advance();const Le=this._value();if(this._previous().type===18)return t.notEquals(Z,Le);switch(Le){case"true":return t.not(Z);case"false":return t.has(Z);default:return t.notEquals(Z,Le)}}case 5:return this._advance(),V.create(Z,this._value());case 6:return this._advance(),A.create(Z,this._value());case 7:return this._advance(),H.create(Z,this._value());case 8:return this._advance(),$.create(Z,this._value());case 13:return this._advance(),t.in(Z,this._value());default:return t.has(Z)}}case 20:throw this._parsingErrors.push({message:i,offset:F.offset,lexeme:"",additionalInfo:a}),d._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const F=this._peek();switch(F.type){case 17:case 18:return this._advance(),F.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(F){return F.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(F){return this._check(F)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(F,Z){if(this._check(F))return this._advance();throw this._errExpectedButGot(Z,this._peek())}_errExpectedButGot(F,Z,be){const Le=(0,R.localize)(8,null,F,T.Scanner.getLexeme(Z)),Se=Z.offset,ve=T.Scanner.getLexeme(Z);return this._parsingErrors.push({message:Le,offset:Se,lexeme:ve,additionalInfo:be}),d._parseError}_check(F){return this._peek().type===F}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=d;class t{static false(){return b.INSTANCE}static true(){return v.INSTANCE}static has(F){return u.create(F)}static equals(F,Z){return C.create(F,Z)}static notEquals(F,Z){return S.create(F,Z)}static regex(F,Z){return U.create(F,Z)}static in(F,Z){return f.create(F,Z)}static notIn(F,Z){return I.create(F,Z)}static not(F){return P.create(F)}static and(...F){return fe.create(F,null,!0)}static or(...F){return Ce.create(F,null,!0)}static greater(F,Z){return H.create(F,Z)}static greaterEquals(F,Z){return $.create(F,Z)}static smaller(F,Z){return V.create(F,Z)}static smallerEquals(F,Z){return A.create(F,Z)}static{this._parser=new d({regexParsingWithErrorRecovery:!1})}static deserialize(F){return F==null?void 0:this._parser.parse(F)}}e.ContextKeyExpr=t;function E(re){const F=new d({regexParsingWithErrorRecovery:!1});return re.map(Z=>(F.parse(Z),F.lexingErrors.length>0?F.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,R.localize)(9,null,be.additionalInfo):(0,R.localize)(10,null),offset:be.offset,length:be.lexeme.length})):F.parsingErrors.length>0?F.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function c(re,F){const Z=re?re.substituteConstants():void 0,be=F?F.substituteConstants():void 0;return!Z&&!be?!0:!Z||!be?!1:Z.equals(be)}function p(re,F){return re.cmp(F)}class b{static{this.INSTANCE=new b}constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=b;class v{static{this.INSTANCE=new v}constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=v;class u{static create(F,Z=null){const be=h.get(F);return typeof be=="boolean"?be?v.INSTANCE:b.INSTANCE:new u(F,Z)}constructor(F,Z){this.key=F,this.negated=Z,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:oe(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=h.get(this.key);return typeof F=="boolean"?F?v.INSTANCE:b.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=P.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=u;class C{static create(F,Z,be=null){if(typeof Z=="boolean")return Z?u.create(F,be):P.create(F,be);const Le=h.get(F);return typeof Le=="boolean"?Z===(Le?"true":"false")?v.INSTANCE:b.INSTANCE:new C(F,Z,be)}constructor(F,Z,be){this.key=F,this.value=Z,this.negated=be,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:pe(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=h.get(this.key);if(typeof F=="boolean"){const Z=F?"true":"false";return this.value===Z?v.INSTANCE:b.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=C;class f{static create(F,Z){return new f(F,Z)}constructor(F,Z){this.key=F,this.valueKey=Z,this.type=10,this.negated=null}cmp(F){return F.type!==this.type?this.type-F.type:pe(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const Z=F.getValue(this.valueKey),be=F.getValue(this.key);return Array.isArray(Z)?Z.includes(be):typeof be=="string"&&typeof Z=="object"&&Z!==null?L.call(Z,be):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=I.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=f;class I{static create(F,Z){return new I(F,Z)}constructor(F,Z){this.key=F,this.valueKey=Z,this.type=11,this._negated=f.create(F,Z)}cmp(F){return F.type!==this.type?this.type-F.type:this._negated.cmp(F._negated)}equals(F){return F.type===this.type?this._negated.equals(F._negated):!1}substituteConstants(){return this}evaluate(F){return!this._negated.evaluate(F)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(F){return F.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=I;class S{static create(F,Z,be=null){if(typeof Z=="boolean")return Z?P.create(F,be):u.create(F,be);const Le=h.get(F);return typeof Le=="boolean"?Z===(Le?"true":"false")?b.INSTANCE:v.INSTANCE:new S(F,Z,be)}constructor(F,Z,be){this.key=F,this.value=Z,this.negated=be,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:pe(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=h.get(this.key);if(typeof F=="boolean"){const Z=F?"true":"false";return this.value===Z?b.INSTANCE:v.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class P{static create(F,Z=null){const be=h.get(F);return typeof be=="boolean"?be?b.INSTANCE:v.INSTANCE:new P(F,Z)}constructor(F,Z){this.key=F,this.negated=Z,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:oe(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=h.get(this.key);return typeof F=="boolean"?F?b.INSTANCE:v.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=u.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=P;function k(re,F){if(typeof re=="string"){const Z=parseFloat(re);isNaN(Z)||(re=Z)}return typeof re=="string"||typeof re=="number"?F(re):b.INSTANCE}class H{static create(F,Z,be=null){return k(Z,Le=>new H(F,Le,be))}constructor(F,Z,be){this.key=F,this.value=Z,this.negated=be,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:pe(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=A.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=H;class ${static create(F,Z,be=null){return k(Z,Le=>new $(F,Le,be))}constructor(F,Z,be){this.key=F,this.value=Z,this.negated=be,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:pe(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=V.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=$;class V{static create(F,Z,be=null){return k(Z,Le=>new V(F,Le,be))}constructor(F,Z,be){this.key=F,this.value=Z,this.negated=be,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:pe(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=$.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=V;class A{static create(F,Z,be=null){return k(Z,Le=>new A(F,Le,be))}constructor(F,Z,be){this.key=F,this.value=Z,this.negated=be,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:pe(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=H.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=A;class U{static create(F,Z){return new U(F,Z)}constructor(F,Z){this.key=F,this.regexp=Z,this.type=7,this.negated=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const Z=this.regexp?this.regexp.source:"",be=F.regexp?F.regexp.source:"";return Z<be?-1:Z>be?1:0}equals(F){if(F.type===this.type){const Z=this.regexp?this.regexp.source:"",be=F.regexp?F.regexp.source:"";return this.key===F.key&&Z===be}return!1}substituteConstants(){return this}evaluate(F){const Z=F.getValue(this.key);return this.regexp?this.regexp.test(Z):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=j.create(this)),this.negated}}e.ContextKeyRegexExpr=U;class j{static create(F){return new j(F)}constructor(F){this._actual=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(F){return new j(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=j;function ie(re){let F=null;for(let Z=0,be=re.length;Z<be;Z++){const Le=re[Z].substituteConstants();if(re[Z]!==Le&&F===null){F=[];for(let Se=0;Se<Z;Se++)F[Se]=re[Se]}F!==null&&(F[Z]=Le)}return F===null?re:F}class fe{static create(F,Z,be){return fe._normalizeArr(F,Z,be)}constructor(F,Z){this.expr=F,this.negated=Z,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let Z=0,be=this.expr.length;Z<be;Z++){const Le=p(this.expr[Z],F.expr[Z]);if(Le!==0)return Le}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let Z=0,be=this.expr.length;Z<be;Z++)if(!this.expr[Z].equals(F.expr[Z]))return!1;return!0}return!1}substituteConstants(){const F=ie(this.expr);return F===this.expr?this:fe.create(F,this.negated,!1)}evaluate(F){for(let Z=0,be=this.expr.length;Z<be;Z++)if(!this.expr[Z].evaluate(F))return!1;return!0}static _normalizeArr(F,Z,be){const Le=[];let Se=!1;for(const ve of F)if(ve){if(ve.type===1){Se=!0;continue}if(ve.type===0)return b.INSTANCE;if(ve.type===6){Le.push(...ve.expr);continue}Le.push(ve)}if(Le.length===0&&Se)return v.INSTANCE;if(Le.length!==0){if(Le.length===1)return Le[0];Le.sort(p);for(let ve=1;ve<Le.length;ve++)Le[ve-1].equals(Le[ve])&&(Le.splice(ve,1),ve--);if(Le.length===1)return Le[0];for(;Le.length>1;){const ve=Le[Le.length-1];if(ve.type!==9)break;Le.pop();const he=Le.pop(),K=Le.length===0,Y=Ce.create(ve.expr.map(le=>fe.create([le,he],null,be)),null,K);Y&&(Le.push(Y),Le.sort(p))}if(Le.length===1)return Le[0];if(be){for(let ve=0;ve<Le.length;ve++)for(let he=ve+1;he<Le.length;he++)if(Le[ve].negate().equals(Le[he]))return b.INSTANCE;if(Le.length===1)return Le[0]}return new fe(Le,Z)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const Z of this.expr)F.push(...Z.keys());return F}map(F){return new fe(this.expr.map(Z=>Z.map(F)),null)}negate(){if(!this.negated){const F=[];for(const Z of this.expr)F.push(Z.negate());this.negated=Ce.create(F,this,!0)}return this.negated}}e.ContextKeyAndExpr=fe;class Ce{static create(F,Z,be){return Ce._normalizeArr(F,Z,be)}constructor(F,Z){this.expr=F,this.negated=Z,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let Z=0,be=this.expr.length;Z<be;Z++){const Le=p(this.expr[Z],F.expr[Z]);if(Le!==0)return Le}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let Z=0,be=this.expr.length;Z<be;Z++)if(!this.expr[Z].equals(F.expr[Z]))return!1;return!0}return!1}substituteConstants(){const F=ie(this.expr);return F===this.expr?this:Ce.create(F,this.negated,!1)}evaluate(F){for(let Z=0,be=this.expr.length;Z<be;Z++)if(this.expr[Z].evaluate(F))return!0;return!1}static _normalizeArr(F,Z,be){let Le=[],Se=!1;if(F){for(let ve=0,he=F.length;ve<he;ve++){const K=F[ve];if(K){if(K.type===0){Se=!0;continue}if(K.type===1)return v.INSTANCE;if(K.type===9){Le=Le.concat(K.expr);continue}Le.push(K)}}if(Le.length===0&&Se)return b.INSTANCE;Le.sort(p)}if(Le.length!==0){if(Le.length===1)return Le[0];for(let ve=1;ve<Le.length;ve++)Le[ve-1].equals(Le[ve])&&(Le.splice(ve,1),ve--);if(Le.length===1)return Le[0];if(be){for(let ve=0;ve<Le.length;ve++)for(let he=ve+1;he<Le.length;he++)if(Le[ve].negate().equals(Le[he]))return v.INSTANCE;if(Le.length===1)return Le[0]}return new Ce(Le,Z)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const Z of this.expr)F.push(...Z.keys());return F}map(F){return new Ce(this.expr.map(Z=>Z.map(F)),null)}negate(){if(!this.negated){const F=[];for(const Z of this.expr)F.push(Z.negate());for(;F.length>1;){const Z=F.shift(),be=F.shift(),Le=[];for(const Se of xe(Z))for(const ve of xe(be))Le.push(fe.create([Se,ve],null,!1));F.unshift(Ce.create(Le,null,!1))}this.negated=Ce.create(F,this,!0)}return this.negated}}e.ContextKeyOrExpr=Ce;class _e extends u{static{this._info=[]}static all(){return _e._info.values()}constructor(F,Z,be){super(F,null),this._defaultValue=Z,typeof be=="object"?_e._info.push({...be,key:F}):be!==!0&&_e._info.push({key:F,description:be,type:Z!=null?typeof Z:void 0})}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return C.create(this.key,F)}notEqualsTo(F){return S.create(this.key,F)}}e.RawContextKey=_e,e.IContextKeyService=(0,N.createDecorator)("contextKeyService");function oe(re,F){return re<F?-1:re>F?1:0}function pe(re,F,Z,be){return re<Z?-1:re>Z?1:F<be?-1:F>be?1:0}function ne(re,F){if(re.type===0||F.type===1)return!0;if(re.type===9)return F.type===9?Ie(re.expr,F.expr):!1;if(F.type===9){for(const Z of F.expr)if(ne(re,Z))return!0;return!1}if(re.type===6){if(F.type===6)return Ie(F.expr,re.expr);for(const Z of re.expr)if(ne(Z,F))return!0;return!1}return re.equals(F)}function Ie(re,F){let Z=0,be=0;for(;Z<re.length&&be<F.length;){const Le=re[Z].cmp(F[be]);if(Le<0)return!1;Le===0&&Z++,be++}return Z===re.length}function xe(re){return re.type===9?re.expr:[re]}}),define(Pe[190],Te([1,0,3]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(Pe[98],Te([1,0,156,3]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=T,e.toTargetPlatform=N,e.getTargetPlatform=R,e.isNotWebExtensionInWebTargetPlatform=m,e.isTargetPlatformCompatible=h,e.isIExtensionIdentifier=y,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function T(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PPC64LE";case"linux-riscv64":return"Linux RISC-V 64";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function N(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"linux-riscv64":return"linux-riscv64";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function R(i,a){switch(i){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":a==="ppc64le"?"linux-ppc64le":a==="riscv64"?"linux-riscv64":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function m(i,a){return a==="web"&&!i.includes("web")}function h(i,a,d){return m(a,d)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===d}function y(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var L;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(L||(e.SortBy=L={}));var _;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(_||(e.SortOrder=_={}));var l;(function(i){i.Install="install",i.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var w;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var g;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));var r;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class o extends Error{constructor(a,d){super(a),this.code=d,this.name=d}}e.ExtensionManagementError=o;var s;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(s||(e.ExtensionGalleryErrorCode=s={}));class n extends Error{constructor(a,d){super(a),this.code=d,this.name=d}}e.ExtensionGalleryError=n,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,D.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,D.localize2)(1,"Preferences")}),define(Pe[43],Te([1,0,52,19,15,17,2,158,3,21,12,40]),function(me,e,D,O,T,N,R,m,h,y,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=l,e.isFileSystemWatcher=r,e.hasReadWriteCapability=s,e.hasFileFolderCopyCapability=n,e.hasFileCloneCapability=i,e.hasOpenReadWriteCloseCapability=a,e.hasFileReadStreamCapability=d,e.hasFileAtomicReadCapability=t,e.hasFileAtomicWriteCapability=E,e.hasFileAtomicDeleteCapability=c,e.hasReadonlyCapability=p,e.createFileSystemProviderError=u,e.ensureFileSystemProviderError=C,e.markAsFileSystemProviderError=f,e.toFileSystemProviderErrorCode=I,e.toFileOperationResult=S,e.isParent=V,e.etag=Ce,e.whenProviderRegistered=_e,e.getLargeFileConfirmationLimit=pe,e.IFileService=(0,h.createDecorator)("fileService");function l(ne){return ne.create===!0}var w;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var g;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(g||(e.FilePermission=g={}));function r(ne){const Ie=ne;return!!Ie&&typeof Ie.onDidChange=="function"}var o;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function s(ne){return!!(ne.capabilities&2)}function n(ne){return!!(ne.capabilities&8)}function i(ne){return!!(ne.capabilities&131072)}function a(ne){return!!(ne.capabilities&4)}function d(ne){return!!(ne.capabilities&16)}function t(ne){return s(ne)?!!(ne.capabilities&16384):!1}function E(ne){return s(ne)?!!(ne.capabilities&32768):!1}function c(ne){return!!(ne.capabilities&65536)}function p(ne){return!!(ne.capabilities&2048)}var b;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(b||(e.FileSystemProviderErrorCode=b={}));class v extends Error{static create(Ie,xe){const re=new v(Ie.toString(),xe);return f(re,xe),re}constructor(Ie,xe){super(Ie),this.code=xe}}e.FileSystemProviderError=v;function u(ne,Ie){return v.create(ne,Ie)}function C(ne){return ne||u((0,m.localize)(0,null),b.Unknown)}function f(ne,Ie){return ne.name=Ie?`${Ie} (FileSystemError)`:"FileSystemError",ne}function I(ne){if(!ne)return b.Unknown;if(ne instanceof v)return ne.code;const Ie=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!Ie)return b.Unknown;switch(Ie[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}function S(ne){if(ne instanceof A)return ne.fileOperationResult;switch(I(ne)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 9;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileTooLarge:return 7;default:return 10}}var P;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class k{constructor(Ie,xe,re){this.resource=Ie,this.operation=xe,this.target=re}isOperation(Ie){return this.operation===Ie}}e.FileOperationEvent=k;var H;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(H||(e.FileChangeType=H={}));class ${static{this.MIXED_CORRELATION=null}constructor(Ie,xe){this.ignorePathCasing=xe,this.correlationId=void 0,this.added=new _.Lazy(()=>{const re=D.TernarySearchTree.forUris(()=>this.ignorePathCasing);return re.fill(this.rawAdded.map(F=>[F,!0])),re}),this.updated=new _.Lazy(()=>{const re=D.TernarySearchTree.forUris(()=>this.ignorePathCasing);return re.fill(this.rawUpdated.map(F=>[F,!0])),re}),this.deleted=new _.Lazy(()=>{const re=D.TernarySearchTree.forUris(()=>this.ignorePathCasing);return re.fill(this.rawDeleted.map(F=>[F,!0])),re}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const re of Ie){switch(re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}this.correlationId!==$.MIXED_CORRELATION&&(typeof re.cId=="number"?this.correlationId===void 0?this.correlationId=re.cId:this.correlationId!==re.cId&&(this.correlationId=$.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=$.MIXED_CORRELATION))}}contains(Ie,...xe){return this.doContains(Ie,{includeChildren:!1},...xe)}affects(Ie,...xe){return this.doContains(Ie,{includeChildren:!0},...xe)}doContains(Ie,xe,...re){if(!Ie)return!1;const F=re.length>0;return!!((!F||re.includes(1))&&(this.added.value.get(Ie)||xe.includeChildren&&this.added.value.findSuperstr(Ie))||(!F||re.includes(0))&&(this.updated.value.get(Ie)||xe.includeChildren&&this.updated.value.findSuperstr(Ie))||(!F||re.includes(2))&&(this.deleted.value.findSubstr(Ie)||xe.includeChildren&&this.deleted.value.findSuperstr(Ie)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ie){return this.correlationId===Ie}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=$;function V(ne,Ie,xe){return!ne||!Ie||ne===Ie||Ie.length>ne.length?!1:(Ie.charAt(Ie.length-1)!==O.sep&&(Ie+=O.sep),xe?(0,T.startsWithIgnoreCase)(ne,Ie):ne.indexOf(Ie)===0)}class A extends Error{constructor(Ie,xe,re){super(Ie),this.fileOperationResult=xe,this.options=re}}e.FileOperationError=A;class U extends A{constructor(Ie,xe,re,F){super(Ie,xe,F),this.fileOperationResult=xe,this.size=re}}e.TooLargeFileOperationError=U;class j extends A{constructor(Ie,xe,re){super(Ie,2,re),this.stat=xe}}e.NotModifiedSinceFileOperationError=j;var ie;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var fe;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(fe||(e.FileKind=fe={})),e.ETAG_DISABLED="";function Ce(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function _e(ne,Ie){if(!Ie.hasProvider(R.URI.from({scheme:ne.scheme})))return new Promise(xe=>{const re=Ie.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===ne.scheme&&F.added&&(re.dispose(),xe())})})}class oe{static{this.KB=1024}static{this.MB=oe.KB*oe.KB}static{this.GB=oe.MB*oe.KB}static{this.TB=oe.GB*oe.KB}static formatSize(Ie){return(0,N.isNumber)(Ie)||(Ie=0),Ie<oe.KB?(0,m.localize)(1,null,Ie.toFixed(0)):Ie<oe.MB?(0,m.localize)(2,null,(Ie/oe.KB).toFixed(2)):Ie<oe.GB?(0,m.localize)(3,null,(Ie/oe.MB).toFixed(2)):Ie<oe.TB?(0,m.localize)(4,null,(Ie/oe.GB).toFixed(2)):(0,m.localize)(5,null,(Ie/oe.TB).toFixed(2))}}e.ByteSize=oe;function pe(ne){const Ie=typeof ne=="string"||ne?.scheme===L.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===L.Schemas.file?1024*oe.MB:Ie?10*oe.MB:y.isWeb?50*oe.MB:1024*oe.MB}}),define(Pe[71],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...T){this._entries=new Map;for(const[N,R]of T)this.set(N,R)}set(T,N){const R=this._entries.get(T);return this._entries.set(T,N),R}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=D}),define(Pe[191],Te([1,0,11,14,6,70,189,3,71,192]),function(me,e,D,O,T,N,R,m,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class _ extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class l{constructor(o=new h.ServiceCollection,s=!1,n,i=L){this._services=o,this._strict=s,this._parent=n,this._enableTracing=i,this._activeInstantiations=new Set,this._services.set(m.IInstantiationService,this),this._globalGraph=i?n?._globalGraph??new R.Graph(a=>a):void 0}createChild(o){return new l(o,this._strict,this,this._enableTracing)}invokeFunction(o,...s){const n=g.traceInvocation(this._enableTracing,o);let i=!1;try{return o({get:d=>{if(i)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(d,n);if(!t)throw new Error(`[invokeFunction] unknown service '${d}'`);return t}},...s)}finally{i=!0,n.stop()}}createInstance(o,...s){let n,i;return o instanceof N.SyncDescriptor?(n=g.traceCreation(this._enableTracing,o.ctor),i=this._createInstance(o.ctor,o.staticArguments.concat(s),n)):(n=g.traceCreation(this._enableTracing,o),i=this._createInstance(o,s,n)),n.stop(),i}_createInstance(o,s=[],n){const i=m._util.getServiceDependencies(o).sort((t,E)=>t.index-E.index),a=[];for(const t of i){const E=this._getOrCreateServiceInstance(t.id,n);E||this._throwIfStrict(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),a.push(E)}const d=i.length>0?i[0].index:s.length;if(s.length!==d){console.trace(`[createInstance] First service dependency of ${o.name} at position ${d+1} conflicts with ${s.length} static arguments`);const t=d-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,d)}return Reflect.construct(o,s.concat(a))}_setServiceInstance(o,s){if(this._services.get(o)instanceof N.SyncDescriptor)this._services.set(o,s);else if(this._parent)this._parent._setServiceInstance(o,s);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){const s=this._services.get(o);return!s&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):s}_getOrCreateServiceInstance(o,s){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(o));const n=this._getServiceInstanceOrDescriptor(o);return n instanceof N.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,n,s.branch(o,!0)):(s.branch(o,!1),n)}_safeCreateAndCacheServiceInstance(o,s,n){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,s,n)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,s,n){const i=new R.Graph(t=>t.id.toString());let a=0;const d=[{id:o,desc:s,_trace:n}];for(;d.length;){const t=d.pop();if(i.lookupOrInsertNode(t),a++>1e3)throw new _(i);for(const E of m._util.getServiceDependencies(t.desc.ctor)){const c=this._getServiceInstanceOrDescriptor(E.id);if(c||this._throwIfStrict(`[createInstance] ${o} depends on ${E.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(E.id)),c instanceof N.SyncDescriptor){const p={id:E.id,desc:c,_trace:t._trace.branch(E.id,!0)};i.insertEdge(t,p),d.push(p)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new _(i);break}for(const{data:E}of t){if(this._getServiceInstanceOrDescriptor(E.id)instanceof N.SyncDescriptor){const p=this._createServiceInstanceWithOwner(E.id,E.desc.ctor,E.desc.staticArguments,E.desc.supportsDelayedInstantiation,E._trace);this._setServiceInstance(E.id,p)}i.removeNode(E)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,s,n=[],i,a){if(this._services.get(o)instanceof N.SyncDescriptor)return this._createServiceInstance(o,s,n,i,a);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,s,n,i,a);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}_createServiceInstance(o,s,n=[],i,a){if(i){const d=new l(void 0,this._strict,this,this._enableTracing);d._globalGraphImplicitDependency=String(o);const t=new Map,E=new D.GlobalIdleValue(()=>{const c=d._createInstance(s,n,a);for(const[p,b]of t){const v=c[p];if(typeof v=="function")for(const u of b)u.disposable=v.apply(c,u.listener)}return t.clear(),c});return new Proxy(Object.create(null),{get(c,p){if(!E.isInitialized&&typeof p=="string"&&(p.startsWith("onDid")||p.startsWith("onWill"))){let u=t.get(p);return u||(u=new y.LinkedList,t.set(p,u)),(f,I,S)=>{if(E.isInitialized)return E.value[p](f,I,S);{const P={listener:[f,I,S],disposable:void 0},k=u.push(P);return(0,T.toDisposable)(()=>{k(),P.disposable?.dispose()})}}}if(p in c)return c[p];const b=E.value;let v=b[p];return typeof v!="function"||(v=v.bind(b),c[p]=v),v},set(c,p,b){return E.value[p]=b,!0},getPrototypeOf(c){return s.prototype}})}else return this._createInstance(s,n,a)}_throwIfStrict(o,s){if(s&&console.warn(o),this._strict)throw new Error(o)}}e.InstantiationService=l;var w;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(w||(w={}));class g{static{this.all=new Set}static{this._None=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,s){return o?new g(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g._None}static traceCreation(o,s){return o?new g(1,s.name):g._None}static{this._totals=0}constructor(o,s){this.type=o,this.name=s,this._start=Date.now(),this._dep=[]}branch(o,s){const n=new g(3,o.toString());return this._dep.push([o,s,n]),n}stop(){const o=Date.now()-this._start;g._totals+=o;let s=!1;function n(a,d){const t=[],E=new Array(a+1).join("	");for(const[c,p,b]of d._dep)if(p&&b){s=!0,t.push(`${E}CREATES -> ${c}`);const v=n(a+1,b);v&&t.push(v)}else t.push(`${E}uses -> ${c}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(o>2||s)&&g.all.add(i.join(`
`))}}e.Trace=g}),define(Pe[13],Te([1,0,159,42,5,99,6,28,21,23,17,2,33,3]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=r,e.log=s,e.getLogLevel=u,e.LogLevelToString=C,e.LogLevelToLocalizedString=f,e.parseLogLevel=I,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function g(){return new Date().toISOString()}function r(S){return(0,L.isNumber)(S)}var o;(function(S){S[S.Off=0]="Off",S[S.Trace=1]="Trace",S[S.Debug=2]="Debug",S[S.Info=3]="Info",S[S.Warning=4]="Warning",S[S.Error=5]="Error"})(o||(e.LogLevel=o={})),e.DEFAULT_LOG_LEVEL=o.Info;function s(S,P,k){switch(P){case o.Trace:S.trace(k);break;case o.Debug:S.debug(k);break;case o.Info:S.info(k);break;case o.Warning:S.warn(k);break;case o.Error:S.error(k);break;case o.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function n(S,P=!1){let k="";for(let H=0;H<S.length;H++){let $=S[H];if($ instanceof Error&&($=(0,O.toErrorMessage)($,P)),typeof $=="object")try{$=JSON.stringify($)}catch{}k+=(H>0?" ":"")+$}return k}class i extends R.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(P){this.level!==P&&(this.level=P,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(P){return this.level!==o.Off&&this.level<=P}}e.AbstractLogger=i;class a extends i{constructor(P){super(),this.logAlways=P}checkLogLevel(P){return this.logAlways||super.checkLogLevel(P)}trace(P,...k){this.checkLogLevel(o.Trace)&&this.log(o.Trace,n([P,...k],!0))}debug(P,...k){this.checkLogLevel(o.Debug)&&this.log(o.Debug,n([P,...k]))}info(P,...k){this.checkLogLevel(o.Info)&&this.log(o.Info,n([P,...k]))}warn(P,...k){this.checkLogLevel(o.Warning)&&this.log(o.Warning,n([P,...k]))}error(P,...k){if(this.checkLogLevel(o.Error))if(P instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=P.stack,this.log(o.Error,n(H))}else this.log(o.Error,n([P,...k]))}flush(){}}e.AbstractMessageLogger=a;class d extends i{constructor(P=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(P),this.useColors=!h.isWindows}trace(P,...k){this.checkLogLevel(o.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,P,...k):console.log(`[main ${g()}]`,P,...k))}debug(P,...k){this.checkLogLevel(o.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,P,...k):console.log(`[main ${g()}]`,P,...k))}info(P,...k){this.checkLogLevel(o.Info)&&(this.useColors?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,P,...k):console.log(`[main ${g()}]`,P,...k))}warn(P,...k){this.checkLogLevel(o.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,P,...k):console.warn(`[main ${g()}]`,P,...k))}error(P,...k){this.checkLogLevel(o.Error)&&(this.useColors?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,P,...k):console.error(`[main ${g()}]`,P,...k))}flush(){}}e.ConsoleMainLogger=d;class t extends i{constructor(P=e.DEFAULT_LOG_LEVEL,k=!0){super(),this.useColors=k,this.setLevel(P)}trace(P,...k){this.checkLogLevel(o.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",P,...k):console.log(P,...k))}debug(P,...k){this.checkLogLevel(o.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",P,...k):console.log(P,...k))}info(P,...k){this.checkLogLevel(o.Info)&&(this.useColors?console.log("%c INFO","color: #33f",P,...k):console.log(P,...k))}warn(P,...k){this.checkLogLevel(o.Warning)&&(this.useColors?console.log("%c WARN","color: #993",P,...k):console.log(P,...k))}error(P,...k){this.checkLogLevel(o.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",P,...k):console.error(P,...k))}flush(){}}e.ConsoleLogger=t;class E extends i{constructor(P,k=e.DEFAULT_LOG_LEVEL){super(),this.adapter=P,this.setLevel(k)}trace(P,...k){this.checkLogLevel(o.Trace)&&this.adapter.log(o.Trace,[this.extractMessage(P),...k])}debug(P,...k){this.checkLogLevel(o.Debug)&&this.adapter.log(o.Debug,[this.extractMessage(P),...k])}info(P,...k){this.checkLogLevel(o.Info)&&this.adapter.log(o.Info,[this.extractMessage(P),...k])}warn(P,...k){this.checkLogLevel(o.Warning)&&this.adapter.log(o.Warning,[this.extractMessage(P),...k])}error(P,...k){this.checkLogLevel(o.Error)&&this.adapter.log(o.Error,[this.extractMessage(P),...k])}extractMessage(P){return typeof P=="string"?P:(0,O.toErrorMessage)(P,this.checkLogLevel(o.Trace))}flush(){}}e.AdapterLogger=E;class c extends i{constructor(P){super(),this.loggers=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const k of this.loggers)k.setLevel(P);super.setLevel(P)}trace(P,...k){for(const H of this.loggers)H.trace(P,...k)}debug(P,...k){for(const H of this.loggers)H.debug(P,...k)}info(P,...k){for(const H of this.loggers)H.info(P,...k)}warn(P,...k){for(const H of this.loggers)H.warn(P,...k)}error(P,...k){for(const H of this.loggers)H.error(P,...k)}flush(){for(const P of this.loggers)P.flush()}dispose(){for(const P of this.loggers)P.dispose();super.dispose()}}e.MultiplexLogger=c;class p extends R.Disposable{constructor(P,k,H){if(super(),this.logLevel=P,this.logsHome=k,this._loggers=new m.ResourceMap,this._onDidChangeLoggers=this._register(new T.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,H)for(const $ of H)this._loggers.set($.resource,{logger:void 0,info:$})}getLoggerEntry(P){return(0,L.isString)(P)?[...this._loggers.values()].find(k=>k.info.id===P):this._loggers.get(P)}getLogger(P){return this.getLoggerEntry(P)?.logger}createLogger(P,k){const H=this.toResource(P),$=(0,L.isString)(P)?P:k?.id??(0,N.hash)(H.toString()).toString(16);let V=this._loggers.get(H)?.logger;const A=k?.logLevel==="always"?o.Trace:k?.logLevel;V||(V=this.doCreateLogger(H,A??this.getLogLevel(H)??this.logLevel,{...k,id:$}));const U={logger:V,info:{resource:H,id:$,logLevel:A,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(U.info),this._loggers.set(H,U),V}toResource(P){return(0,L.isString)(P)?(0,y.joinPath)(this.logsHome,`${P}.log`):P}setLogLevel(P,k){if(_.URI.isUri(P)){const H=P,$=k,V=this._loggers.get(H);V&&$!==V.info.logLevel&&(V.info.logLevel=$===this.logLevel?void 0:$,V.logger?.setLevel($),this._loggers.set(V.info.resource,V),this._onDidChangeLogLevel.fire([H,$]))}else{this.logLevel=P;for(const[H,$]of this._loggers.entries())this._loggers.get(H)?.info.logLevel===void 0&&$.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(P,k){const H=this.getLoggerEntry(P);H&&k!==!H.info.hidden&&(H.info.hidden=!k,this._loggers.set(H.info.resource,H),this._onDidChangeVisibility.fire([H.info.resource,k]))}getLogLevel(P){let k;return P&&(k=this._loggers.get(P)?.info.logLevel),k??this.logLevel}registerLogger(P){const k=this._loggers.get(P.resource);k?k.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this._loggers.set(P.resource,{info:P,logger:void 0}),this._onDidChangeLoggers.fire({added:[P],removed:[]}))}deregisterLogger(P){const k=this._loggers.get(P);k&&(k.logger&&k.logger.dispose(),this._loggers.delete(P),this._onDidChangeLoggers.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const P of this._loggers.values())yield P.info}getRegisteredLogger(P){return this._loggers.get(P)?.info}dispose(){this._loggers.forEach(P=>P.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class b{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(P){}getLevel(){return o.Info}trace(P,...k){}debug(P,...k){}info(P,...k){}warn(P,...k){}error(P,...k){}critical(P,...k){}dispose(){}flush(){}}e.NullLogger=b;class v extends b{}e.NullLogService=v;function u(S){if(S.verbose)return o.Trace;if(typeof S.logLevel=="string"){const P=I(S.logLevel.toLowerCase());if(P!==void 0)return P}return e.DEFAULT_LOG_LEVEL}function C(S){switch(S){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function f(S){switch(S){case o.Trace:return{original:"Trace",value:D.localize(0,null)};case o.Debug:return{original:"Debug",value:D.localize(1,null)};case o.Info:return{original:"Info",value:D.localize(2,null)};case o.Warning:return{original:"Warning",value:D.localize(3,null)};case o.Error:return{original:"Error",value:D.localize(4,null)};case o.Off:return{original:"Off",value:D.localize(5,null)}}}function I(S){switch(S){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.CONTEXT_LOG_LEVEL=new l.RawContextKey("logLevel",C(o.Info))}),define(Pe[193],Te([1,0,6,13]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class T extends D.Disposable{constructor(R,m=[]){super(),this.logger=new O.MultiplexLogger([R,...m]),this._register(R.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(R){this.logger.setLevel(R)}getLevel(){return this.logger.getLevel()}trace(R,...m){this.logger.trace(R,...m)}debug(R,...m){this.logger.debug(R,...m)}info(R,...m){this.logger.info(R,...m)}warn(R,...m){this.logger.warn(R,...m)}error(R,...m){this.logger.error(R,...m)}flush(){this.logger.flush()}}e.LogService=T}),define(Pe[100],Te([1,0,32,160,3]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(h){h[h.Unnecessary=1]="Unnecessary",h[h.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var R;(function(h){h[h.Hint=1]="Hint",h[h.Info=2]="Info",h[h.Warning=4]="Warning",h[h.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(h){function y(g,r){return r-g}h.compare=y;const L=Object.create(null);L[h.Error]=(0,O.localize)(0,null),L[h.Warning]=(0,O.localize)(1,null),L[h.Info]=(0,O.localize)(2,null);function _(g){return L[g]||""}h.toString=_;function l(g){switch(g){case D.default.Error:return h.Error;case D.default.Warning:return h.Warning;case D.default.Info:return h.Info;case D.default.Ignore:return h.Hint}}h.fromSeverity=l;function w(g){switch(g){case h.Error:return D.default.Error;case h.Warning:return D.default.Warning;case h.Info:return D.default.Info;case h.Hint:return D.default.Ignore}}h.toSeverity=w}(R||(e.MarkerSeverity=R={}));var m;(function(h){const y="";function L(l){return _(l,!0)}h.makeKey=L;function _(l,w){const g=[y];return l.source?g.push(l.source.replace("\xA6","\\\xA6")):g.push(y),l.code?typeof l.code=="string"?g.push(l.code.replace("\xA6","\\\xA6")):g.push(l.code.value.replace("\xA6","\\\xA6")):g.push(y),l.severity!==void 0&&l.severity!==null?g.push(R.toString(l.severity)):g.push(y),l.message&&w?g.push(l.message.replace("\xA6","\\\xA6")):g.push(y),l.startLineNumber!==void 0&&l.startLineNumber!==null?g.push(l.startLineNumber.toString()):g.push(y),l.startColumn!==void 0&&l.startColumn!==null?g.push(l.startColumn.toString()):g.push(y),l.endLineNumber!==void 0&&l.endLineNumber!==null?g.push(l.endLineNumber.toString()):g.push(y),l.endColumn!==void 0&&l.endColumn!==null?g.push(l.endColumn.toString()):g.push(y),g.push(y),g.join("\xA6")}h.makeKeyOptionalMessage=_})(m||(e.IMarkerData=m={})),e.IMarkerService=(0,T.createDecorator)("markerService")}),define(Pe[194],Te([1,0,5,32,3]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.isNotificationSource=m,e.Severity=O.default,e.INotificationService=(0,T.createDecorator)("notificationService");var N;(function(_){_[_.DEFAULT=0]="DEFAULT",_[_.SILENT=1]="SILENT",_[_.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var R;(function(_){_[_.WORKSPACE=0]="WORKSPACE",_[_.PROFILE=1]="PROFILE",_[_.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function m(_){if(_){const l=_;return typeof l.id=="string"&&typeof l.label=="string"}return!1}var h;(function(_){_[_.OFF=0]="OFF",_[_.ERROR=1]="ERROR"})(h||(e.NotificationsFilter=h={}));class y{constructor(){this.progress=new L,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.NoOpNotification=y;class L{infinite(){}done(){}total(l){}worked(l){}}e.NoOpProgress=L}),define(Pe[195],Te([1,0,3]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(me,e,D,O){var T=arguments.length,N=T<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,D):O,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(me,e,D,O);else for(var m=me.length-1;m>=0;m--)(R=me[m])&&(N=(T<3?R(N):T>3?R(e,D,N):R(e,D))||N);return T>3&&N&&Object.defineProperty(e,D,N),N},He=this&&this.__param||function(me,e){return function(D,O){e(D,O,me)}};define(Pe[101],Te([1,0,11,24,6,3]),function(me,e,D,O,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.AsyncProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,N.createDecorator)("progressService");var R;(function(_){_[_.Explorer=1]="Explorer",_[_.Scm=3]="Scm",_[_.Extensions=5]="Extensions",_[_.Window=10]="Window",_[_.Notification=15]="Notification",_[_.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this._value}constructor(l){this.callback=l}report(l){this._value=l,this.callback(this._value)}}e.Progress=m;class h{get value(){return this._value}constructor(l){this.callback=l}report(l){this._asyncQueue?this._asyncQueue.push(l):this._asyncQueue=[l],this._processAsyncQueue()}async _processAsyncQueue(){if(!this._processingAsyncQueue)try{for(this._processingAsyncQueue=!0;this._asyncQueue&&this._asyncQueue.length;){const l=this._asyncQueue.shift();this._value=l,await this.callback(this._value)}}finally{this._processingAsyncQueue=!1;const l=this._drainListener;this._drainListener=void 0,l?.()}}drain(){return this._processingAsyncQueue?new Promise(l=>{const w=this._drainListener;this._drainListener=()=>{w?.(),l()}}):Promise.resolve()}}e.AsyncProgress=h;let y=class extends T.Disposable{constructor(l,w){super(),this.deferred=new D.DeferredPromise,w.withProgress(l,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,T.toDisposable)(()=>this.deferred.complete()))}report(l){this.reporter?this.reporter.report(l):this.lastStep=l}};e.UnmanagedProgress=y,e.UnmanagedProgress=y=Ke([He(1,e.IProgressService)],y);class L extends T.Disposable{constructor(l){super(),this.progressIndicator=l,this.currentOperationId=0,this.currentOperationDisposables=this._register(new T.DisposableStore)}start(l){this.stop();const w=++this.currentOperationId,g=new O.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{w===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},l),this.currentOperationDisposables.add((0,T.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,T.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,T.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:w,token:g.token,stop:()=>this.doStop(w),isCurrent:()=>this.currentOperationId===w}}stop(){this.doStop(this.currentOperationId)}doStop(l){this.currentOperationId===l&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=L,e.IEditorProgressService=(0,N.createDecorator)("editorProgressService")}),define(Pe[30],Te([1,0,56,17]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(R,m){D.ok(O.isString(R)),D.ok(O.isObject(m)),D.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,m)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new T}),define(Pe[72],Te([1,0,5,30]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class N{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,y){this.schemasById[T(h)]=y,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new N;O.Registry.add(e.Extensions.JSONContribution,R)}),define(Pe[57],Te([1,0,18,5,17,153,47,72,30]),function(me,e,D,O,T,N,R,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=r,e.keyFromOverrideIdentifiers=o,e.getDefaultValue=s,e.validateProperty=i,e.getScopes=a;var y;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L||(e.ConfigurationScope=L={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const _=h.Registry.as(m.Extensions.JSONContribution);class l{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,E=!0){this.registerConfigurations([t],E)}registerConfigurations(t,E=!0){const c=new Set;this.doRegisterConfigurations(t,E,c),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}deregisterConfigurations(t){const E=new Set;this.doDeregisterConfigurations(t,E),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:E})}updateConfigurations({add:t,remove:E}){const c=new Set;this.doDeregisterConfigurations(E,c),this.doRegisterConfigurations(t,!1,c),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}registerDefaultConfigurations(t){const E=new Set;this.doRegisterDefaultConfigurations(t,E),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:E,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,E){const c=[];for(const{overrides:p,source:b}of t)for(const v in p)if(E.add(v),e.OVERRIDE_PROPERTY_REGEX.test(v)){const u=this.configurationDefaultsOverrides.get(v),C=u?.valuesSources??new Map;if(b)for(const P of Object.keys(p[v]))C.set(P,b);const f={...u?.value||{},...p[v]};this.configurationDefaultsOverrides.set(v,{source:b,value:f,valuesSources:C});const I=(0,R.getLanguageTagSettingPlainKey)(v),S={type:"object",default:f,description:N.localize(1,null,I),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:T.isString(b)?void 0:b,defaultValueSource:b};c.push(...r(v)),this.configurationProperties[v]=S,this.defaultLanguageConfigurationOverridesNode.properties[v]=S}else{this.configurationDefaultsOverrides.set(v,{value:p[v],source:b});const u=this.configurationProperties[v];u&&(this.updatePropertyDefaultValue(v,u),this.updateSchema(v,u))}this.doRegisterOverrideIdentifiers(c)}deregisterDefaultConfigurations(t){const E=new Set;this.doDeregisterDefaultConfigurations(t,E),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:E,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,E){for(const{overrides:c,source:p}of t)for(const b in c){const v=this.configurationDefaultsOverrides.get(b),u=T.isString(p)?p:p?.id,C=T.isString(v?.source)?v?.source:v?.source?.id;if(u===C)if(E.add(b),this.configurationDefaultsOverrides.delete(b),e.OVERRIDE_PROPERTY_REGEX.test(b))delete this.configurationProperties[b],delete this.defaultLanguageConfigurationOverridesNode.properties[b];else{const f=this.configurationProperties[b];f&&(this.updatePropertyDefaultValue(b,f),this.updateSchema(b,f))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let E=!1;const c=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,c),E=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,c),E=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,c),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:E})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const E of t)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,E,c){t.forEach(p=>{this.validateAndRegisterProperties(p,E,p.extensionInfo,p.restrictedProperties,void 0,c),this.configurationContributors.push(p),this.registerJSONConfiguration(p)})}doDeregisterConfigurations(t,E){const c=p=>{if(p.properties)for(const b in p.properties){E.add(b);const v=this.configurationProperties[b];v?.policy?.name&&this.policyConfigurations.delete(v.policy.name),delete this.configurationProperties[b],this.removeFromSchema(b,p.properties[b])}p.allOf?.forEach(b=>c(b))};for(const p of t){c(p);const b=this.configurationContributors.indexOf(p);b!==-1&&this.configurationContributors.splice(b,1)}}validateAndRegisterProperties(t,E=!0,c,p,b=3,v){b=T.isUndefinedOrNull(t.scope)?b:t.scope;const u=t.properties;if(u)for(const f in u){const I=u[f];if(E&&i(f,I)){delete u[f];continue}if(I.source=c,I.defaultDefaultValue=u[f].default,this.updatePropertyDefaultValue(f,I),e.OVERRIDE_PROPERTY_REGEX.test(f)?I.scope=void 0:(I.scope=T.isUndefinedOrNull(I.scope)?b:I.scope,I.restricted=T.isUndefinedOrNull(I.restricted)?!!p?.includes(f):I.restricted),u[f].hasOwnProperty("included")&&!u[f].included){this.excludedConfigurationProperties[f]=u[f],delete u[f];continue}else this.configurationProperties[f]=u[f],u[f].policy?.name&&this.policyConfigurations.set(u[f].policy.name,f);!u[f].deprecationMessage&&u[f].markdownDeprecationMessage&&(u[f].deprecationMessage=u[f].markdownDeprecationMessage),v.add(f)}const C=t.allOf;if(C)for(const f of C)this.validateAndRegisterProperties(f,E,c,p,b,v)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const E=c=>{const p=c.properties;if(p)for(const v in p)this.updateSchema(v,p[v]);c.allOf?.forEach(E)};E(t)}updateSchema(t,E){switch(e.allSettings.properties[t]=E,E.scope){case 1:e.applicationSettings.properties[t]=E;break;case 2:e.machineSettings.properties[t]=E;break;case 6:e.machineOverridableSettings.properties[t]=E;break;case 3:e.windowSettings.properties[t]=E;break;case 4:e.resourceSettings.properties[t]=E;break;case 5:e.resourceSettings.properties[t]=E,this.resourceLanguageSettingsSchema.properties[t]=E;break}}removeFromSchema(t,E){switch(delete e.allSettings.properties[t],E.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const E=`[${t}]`,c={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,c),e.allSettings.properties[E]=c,e.applicationSettings.properties[E]=c,e.machineSettings.properties[E]=c,e.machineOverridableSettings.properties[E]=c,e.windowSettings.properties[E]=c,e.resourceSettings.properties[E]=c}}registerOverridePropertyPatternKey(){const t={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,E){const c=this.configurationDefaultsOverrides.get(t);let p=c?.value,b=c?.source;T.isUndefined(p)&&(p=E.defaultDefaultValue,b=void 0),T.isUndefined(p)&&(p=s(E.type)),E.default=p,E.defaultValueSource=b}}const w="\\[([^\\]]+)\\]",g=new RegExp(w,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${w})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function r(d){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(d)){let E=g.exec(d);for(;E?.length;){const c=E[1].trim();c&&t.push(c),E=g.exec(d)}}return(0,D.distinct)(t)}function o(d){return d.reduce((t,E)=>`${t}[${E}]`,"")}function s(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new l;h.Registry.add(e.Extensions.Configuration,n);function i(d,t){return d.trim()?e.OVERRIDE_PROPERTY_REGEX.test(d)?N.localize(7,null,d):n.getConfigurationProperties()[d]!==void 0?N.localize(8,null,d):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?N.localize(9,null,d,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:N.localize(6,null)}function a(){const d=[],t=n.getConfigurationProperties();for(const E of Object.keys(t))d.push([E,t[E].scope]);return d.push(["launch",4]),d.push(["task",4]),d}}),define(Pe[196],Te([1,0,18,5,123,6,28,26,17,2,47,57,30]),function(me,e,D,O,T,N,R,m,h,y,L,_,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=i;function w(E){return Object.isFrozen(E)?E:m.deepFreeze(E)}class g{constructor(c={},p=[],b=[],v){this._contents=c,this._keys=p,this._overrides=b,this.raw=v,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const c=this.raw.map(p=>{if(p instanceof g)return p;const b=new r("");return b.parseRaw(p),b.configurationModel});this._rawConfiguration=c.reduce((p,b)=>b===p?b:p.merge(b),c[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(c){return c?(0,L.getConfigurationValue)(this.contents,c):this.contents}inspect(c,p){const b=this;return{get value(){return w(b.rawConfiguration.getValue(c))},get override(){return p?w(b.rawConfiguration.getOverrideValue(c,p)):void 0},get merged(){return w(p?b.rawConfiguration.override(p).getValue(c):b.rawConfiguration.getValue(c))},get overrides(){const v=[];for(const{contents:u,identifiers:C,keys:f}of b.rawConfiguration.overrides){const I=new g(u,f).getValue(c);I!==void 0&&v.push({identifiers:C,value:I})}return v.length?w(v):void 0}}}getOverrideValue(c,p){const b=this.getContentsForOverrideIdentifer(p);return b?c?(0,L.getConfigurationValue)(b,c):b:void 0}getKeysForOverrideIdentifier(c){const p=[];for(const b of this.overrides)b.identifiers.includes(c)&&p.push(...b.keys);return D.distinct(p)}getAllOverrideIdentifiers(){const c=[];for(const p of this.overrides)c.push(...p.identifiers);return D.distinct(c)}override(c){let p=this.overrideConfigurations.get(c);return p||(p=this.createOverrideConfigurationModel(c),this.overrideConfigurations.set(c,p)),p}merge(...c){const p=m.deepClone(this.contents),b=m.deepClone(this.overrides),v=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const C of c)if(u.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.mergeContents(p,C.contents);for(const f of C.overrides){const[I]=b.filter(S=>D.equals(S.identifiers,f.identifiers));I?(this.mergeContents(I.contents,f.contents),I.keys.push(...f.keys),I.keys=D.distinct(I.keys)):b.push(m.deepClone(f))}for(const f of C.keys)v.indexOf(f)===-1&&v.push(f)}return new g(p,v,b,u.every(C=>C instanceof g)?void 0:u)}createOverrideConfigurationModel(c){const p=this.getContentsForOverrideIdentifer(c);if(!p||typeof p!="object"||!Object.keys(p).length)return this;const b={};for(const v of D.distinct([...Object.keys(this.contents),...Object.keys(p)])){let u=this.contents[v];const C=p[v];C&&(typeof u=="object"&&typeof C=="object"?(u=m.deepClone(u),this.mergeContents(u,C)):u=C),b[v]=u}return new g(b,this.keys,this.overrides)}mergeContents(c,p){for(const b of Object.keys(p)){if(b in c&&h.isObject(c[b])&&h.isObject(p[b])){this.mergeContents(c[b],p[b]);continue}c[b]=m.deepClone(p[b])}}getContentsForOverrideIdentifer(c){let p=null,b=null;const v=u=>{u&&(b?this.mergeContents(b,u):b=m.deepClone(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===c?p=u.contents:u.identifiers.includes(c)&&v(u.contents);return v(p),b}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,p){this.updateValue(c,p,!0)}setValue(c,p){this.updateValue(c,p,!1)}removeValue(c){const p=this.keys.indexOf(c);p!==-1&&(this.keys.splice(p,1),(0,L.removeFromValueTree)(this.contents,c),_.OVERRIDE_PROPERTY_REGEX.test(c)&&this.overrides.splice(this.overrides.findIndex(b=>D.equals(b.identifiers,(0,_.overrideIdentifiersFromKey)(c))),1))}updateValue(c,p,b){(0,L.addToValueTree)(this.contents,c,p,v=>console.error(v)),b=b||this.keys.indexOf(c)===-1,b&&this.keys.push(c),_.OVERRIDE_PROPERTY_REGEX.test(c)&&this.overrides.push({identifiers:(0,_.overrideIdentifiersFromKey)(c),keys:Object.keys(this.contents[c]),contents:(0,L.toValuesTree)(this.contents[c],v=>console.error(v))})}}e.ConfigurationModel=g;class r{constructor(c){this._name=c,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(c,p){if(!h.isUndefinedOrNull(c)){const b=this.doParseContent(c);this.parseRaw(b,p)}}reparse(c){this._raw&&this.parseRaw(this._raw,c)}parseRaw(c,p){this._raw=c;const{contents:b,keys:v,overrides:u,restricted:C,hasExcludedProperties:f}=this.doParseRaw(c,p);this._configurationModel=new g(b,v,u,f?[c]:void 0),this._restrictedConfigurations=C||[]}doParseContent(c){let p={},b=null,v=[];const u=[],C=[];function f(S){Array.isArray(v)?v.push(S):b!==null&&(v[b]=S)}const I={onObjectBegin:()=>{const S={};f(S),u.push(v),v=S,b=null},onObjectProperty:S=>{b=S},onObjectEnd:()=>{v=u.pop()},onArrayBegin:()=>{const S=[];f(S),u.push(v),v=S,b=null},onArrayEnd:()=>{v=u.pop()},onLiteralValue:f,onError:(S,P,k)=>{C.push({error:S,offset:P,length:k})}};if(c)try{T.visit(c,I),p=v[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return p}doParseRaw(c,p){const b=l.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),v=this.filter(c,b,!0,p);c=v.raw;const u=(0,L.toValuesTree)(c,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),C=Object.keys(c),f=this.toOverrides(c,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:u,keys:C,overrides:f,restricted:v.restricted,hasExcludedProperties:v.hasExcludedProperties}}filter(c,p,b,v){let u=!1;if(!v?.scopes&&!v?.skipRestricted&&!v?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:u};const C={},f=[];for(const I in c)if(_.OVERRIDE_PROPERTY_REGEX.test(I)&&b){const S=this.filter(c[I],p,!1,v);C[I]=S.raw,u=u||S.hasExcludedProperties,f.push(...S.restricted)}else{const S=p[I],P=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&f.push(I),!v.exclude?.includes(I)&&(v.include?.includes(I)||(P===void 0||v.scopes===void 0||v.scopes.includes(P))&&!(v.skipRestricted&&S?.restricted))?C[I]=c[I]:u=!0}return{raw:C,restricted:f,hasExcludedProperties:u}}toOverrides(c,p){const b=[];for(const v of Object.keys(c))if(_.OVERRIDE_PROPERTY_REGEX.test(v)){const u={};for(const C in c[v])u[C]=c[v][C];b.push({identifiers:(0,_.overrideIdentifiersFromKey)(v),keys:Object.keys(u),contents:(0,L.toValuesTree)(u,p)})}return b}}e.ConfigurationModelParser=r;class o extends N.Disposable{constructor(c,p,b,v){super(),this.userSettingsResource=c,this.parseOptions=p,this.fileService=v,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new r(this.userSettingsResource.toString()),this._register(this.fileService.watch(b.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.any(O.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource)),O.Event.filter(this.fileService.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&b.isEqual(u.resource,c)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const c=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(c.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(c){return c&&(this.parseOptions=c),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=o;class s{constructor(c,p,b,v,u,C,f,I,S,P,k,H,$){this.key=c,this.overrides=p,this._value=b,this.overrideIdentifiers=v,this.defaultConfiguration=u,this.policyConfiguration=C,this.applicationConfiguration=f,this.userConfiguration=I,this.localUserConfiguration=S,this.remoteUserConfiguration=P,this.workspaceConfiguration=k,this.folderConfigurationModel=H,this.memoryConfigurationModel=$}get value(){return w(this._value)}toInspectValue(c){return c?.value!==void 0||c?.override!==void 0||c?.overrides!==void 0?c:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class n{constructor(c,p,b,v,u=new g,C=new g,f=new R.ResourceMap,I=new g,S=new R.ResourceMap){this._defaultConfiguration=c,this._policyConfiguration=p,this._applicationConfiguration=b,this._localUserConfiguration=v,this._remoteUserConfiguration=u,this._workspaceConfiguration=C,this._folderConfigurations=f,this._memoryConfiguration=I,this._memoryConfigurationByResource=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(c,p,b){return this.getConsolidatedConfigurationModel(c,p,b).getValue(c)}updateValue(c,p,b={}){let v;b.resource?(v=this._memoryConfigurationByResource.get(b.resource),v||(v=new g,this._memoryConfigurationByResource.set(b.resource,v))):v=this._memoryConfiguration,p===void 0?v.removeValue(c):v.setValue(c,p),b.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(c,p,b){const v=this.getConsolidatedConfigurationModel(c,p,b),u=this.getFolderConfigurationModelForResource(p.resource,b),C=p.resource?this._memoryConfigurationByResource.get(p.resource)||this._memoryConfiguration:this._memoryConfiguration,f=new Set;for(const I of v.overrides)for(const S of I.identifiers)v.getOverrideValue(c,S)!==void 0&&f.add(S);return new s(c,p,v.getValue(c),f.size?[...f]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,b?this._workspaceConfiguration:void 0,u||void 0,C)}keys(c){const p=this.getFolderConfigurationModelForResource(void 0,c);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:p?p.keys.slice(0):[]}}updateDefaultConfiguration(c){this._defaultConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(c){this._policyConfiguration=c}updateApplicationConfiguration(c){this._applicationConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(c){this._localUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(c){this._remoteUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(c){this._workspaceConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(c,p){this._folderConfigurations.set(c,p),this._foldersConsolidatedConfigurations.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this._foldersConsolidatedConfigurations.delete(c)}compareAndUpdateDefaultConfiguration(c,p){const b=[];if(!p){const{added:v,updated:u,removed:C}=d(this._defaultConfiguration,c);p=[...v,...u,...C]}for(const v of p)for(const u of(0,_.overrideIdentifiersFromKey)(v)){const C=this._defaultConfiguration.getKeysForOverrideIdentifier(u),f=c.getKeysForOverrideIdentifier(u),I=[...f.filter(S=>C.indexOf(S)===-1),...C.filter(S=>f.indexOf(S)===-1),...C.filter(S=>!m.equals(this._defaultConfiguration.override(u).getValue(S),c.override(u).getValue(S)))];b.push([u,I])}return this.updateDefaultConfiguration(c),{keys:p,overrides:b}}compareAndUpdatePolicyConfiguration(c){const{added:p,updated:b,removed:v}=d(this._policyConfiguration,c),u=[...p,...b,...v];return u.length&&this.updatePolicyConfiguration(c),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:p,updated:b,removed:v,overrides:u}=d(this.applicationConfiguration,c),C=[...p,...b,...v];return C.length&&this.updateApplicationConfiguration(c),{keys:C,overrides:u}}compareAndUpdateLocalUserConfiguration(c){const{added:p,updated:b,removed:v,overrides:u}=d(this.localUserConfiguration,c),C=[...p,...b,...v];return C.length&&this.updateLocalUserConfiguration(c),{keys:C,overrides:u}}compareAndUpdateRemoteUserConfiguration(c){const{added:p,updated:b,removed:v,overrides:u}=d(this.remoteUserConfiguration,c),C=[...p,...b,...v];return C.length&&this.updateRemoteUserConfiguration(c),{keys:C,overrides:u}}compareAndUpdateWorkspaceConfiguration(c){const{added:p,updated:b,removed:v,overrides:u}=d(this.workspaceConfiguration,c),C=[...p,...b,...v];return C.length&&this.updateWorkspaceConfiguration(c),{keys:C,overrides:u}}compareAndUpdateFolderConfiguration(c,p){const b=this.folderConfigurations.get(c),{added:v,updated:u,removed:C,overrides:f}=d(b,p),I=[...v,...u,...C];return(I.length||!b)&&this.updateFolderConfiguration(c,p),{keys:I,overrides:f}}compareAndDeleteFolderConfiguration(c){const p=this.folderConfigurations.get(c);if(!p)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:b,updated:v,removed:u,overrides:C}=d(p,void 0);return{keys:[...b,...v,...u],overrides:C}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(c,p,b){let v=this.getConsolidatedConfigurationModelForResource(p,b);return p.overrideIdentifier&&(v=v.override(p.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(c)!==void 0&&(v=v.merge(this._policyConfiguration)),v}getConsolidatedConfigurationModelForResource({resource:c},p){let b=this.getWorkspaceConsolidatedConfiguration();if(p&&c){const v=p.getFolder(c);v&&(b=this.getFolderConsolidatedConfiguration(v.uri)||b);const u=this._memoryConfigurationByResource.get(c);u&&(b=b.merge(u))}return b}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(c){let p=this._foldersConsolidatedConfigurations.get(c);if(!p){const b=this.getWorkspaceConsolidatedConfiguration(),v=this._folderConfigurations.get(c);v?(p=b.merge(v),this._foldersConsolidatedConfigurations.set(c,p)):p=b}return p}getFolderConfigurationModelForResource(c,p){if(p&&c){const b=p.getFolder(c);if(b)return this._folderConfigurations.get(b.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((c,p)=>{const{contents:b,overrides:v,keys:u}=this._folderConfigurations.get(p);return c.push([p,{contents:b,overrides:v,keys:u}]),c},[])}}allKeys(){const c=new Set;return this._defaultConfiguration.keys.forEach(p=>c.add(p)),this.userConfiguration.keys.forEach(p=>c.add(p)),this._workspaceConfiguration.keys.forEach(p=>c.add(p)),this._folderConfigurations.forEach(p=>p.keys.forEach(b=>c.add(b))),[...c.values()]}allOverrideIdentifiers(){const c=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(p=>c.add(p)),this.userConfiguration.getAllOverrideIdentifiers().forEach(p=>c.add(p)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(p=>c.add(p)),this._folderConfigurations.forEach(p=>p.getAllOverrideIdentifiers().forEach(b=>c.add(b))),[...c.values()]}getAllKeysForOverrideIdentifier(c){const p=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(c).forEach(b=>p.add(b)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(b=>p.add(b)),this._workspaceConfiguration.getKeysForOverrideIdentifier(c).forEach(b=>p.add(b)),this._folderConfigurations.forEach(b=>b.getKeysForOverrideIdentifier(c).forEach(v=>p.add(v))),[...p.values()]}static parse(c){const p=this.parseConfigurationModel(c.defaults),b=this.parseConfigurationModel(c.policy),v=this.parseConfigurationModel(c.application),u=this.parseConfigurationModel(c.user),C=this.parseConfigurationModel(c.workspace),f=c.folders.reduce((I,S)=>(I.set(y.URI.revive(S[0]),this.parseConfigurationModel(S[1])),I),new R.ResourceMap);return new n(p,b,v,u,new g,C,f,new g,new R.ResourceMap)}static parseConfigurationModel(c){return new g(c.contents,c.keys,c.overrides)}}e.Configuration=n;function i(...E){if(E.length===0)return{keys:[],overrides:[]};if(E.length===1)return E[0];const c=new Set,p=new Map;for(const v of E)v.keys.forEach(u=>c.add(u)),v.overrides.forEach(([u,C])=>{const f=(0,R.getOrSet)(p,u,new Set);C.forEach(I=>f.add(I))});const b=[];return p.forEach((v,u)=>b.push([u,[...v.values()]])),{keys:[...c.values()],overrides:b}}class a{constructor(c,p,b,v){this.change=c,this.previous=p,this.currentConfiguraiton=b,this.currentWorkspace=v,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const u of c.keys)this.affectedKeys.add(u);for(const[,u]of c.overrides)for(const C of u)this.affectedKeys.add(C);this._affectsConfigStr=this._marker;for(const u of this.affectedKeys)this._affectsConfigStr+=u+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=n.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(c,p){const b=this._marker+c,v=this._affectsConfigStr.indexOf(b);if(v<0)return!1;const u=v+b.length;if(u>=this._affectsConfigStr.length)return!1;const C=this._affectsConfigStr.charCodeAt(u);if(C!==this._markerCode1&&C!==this._markerCode2)return!1;if(p){const f=this.previousConfiguration?this.previousConfiguration.getValue(c,p,this.previous?.workspace):void 0,I=this.currentConfiguraiton.getValue(c,p,this.currentWorkspace);return!m.equals(f,I)}return!0}}e.ConfigurationChangeEvent=a;function d(E,c){const{added:p,removed:b,updated:v}=t(c?.rawConfiguration,E?.rawConfiguration),u=[],C=E?.getAllOverrideIdentifiers()||[],f=c?.getAllOverrideIdentifiers()||[];if(c){const I=f.filter(S=>!C.includes(S));for(const S of I)u.push([S,c.getKeysForOverrideIdentifier(S)])}if(E){const I=C.filter(S=>!f.includes(S));for(const S of I)u.push([S,E.getKeysForOverrideIdentifier(S)])}if(c&&E){for(const I of C)if(f.includes(I)){const S=t({contents:E.getOverrideValue(void 0,I)||{},keys:E.getKeysForOverrideIdentifier(I)},{contents:c.getOverrideValue(void 0,I)||{},keys:c.getKeysForOverrideIdentifier(I)});u.push([I,[...S.added,...S.removed,...S.updated]])}}return{added:p,removed:b,updated:v,overrides:u}}function t(E,c){const p=E?c?E.keys.filter(u=>c.keys.indexOf(u)===-1):[...E.keys]:[],b=c?E?c.keys.filter(u=>E.keys.indexOf(u)===-1):[...c.keys]:[],v=[];if(E&&c){for(const u of c.keys)if(E.keys.indexOf(u)!==-1){const C=(0,L.getConfigurationValue)(c.contents,u),f=(0,L.getConfigurationValue)(E.contents,u);m.equals(C,f)||v.push(u)}}return{added:p,removed:b,updated:v}}}),define(Pe[102],Te([1,0,14,3]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=y,e.IRemoteAuthorityResolverService=(0,O.createDecorator)("remoteAuthorityResolverService");var T;(function(L){L[L.WebSocket=0]="WebSocket",L[L.Managed=1]="Managed"})(T||(e.RemoteConnectionType=T={}));class N{constructor(_){this.id=_,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=N;class R{constructor(_,l){this.host=_,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=R;var m;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound",L.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class h extends D.ErrorNoTelemetry{static isNotAvailable(_){return _ instanceof h&&_._code===m.NotAvailable}static isTemporarilyNotAvailable(_){return _ instanceof h&&_._code===m.TemporarilyNotAvailable}static isNoResolverFound(_){return _ instanceof h&&_._code===m.NoResolverFound}static isInvalidAuthority(_){return _ instanceof h&&_._code===m.InvalidAuthority}static isHandled(_){return _ instanceof h&&_.isHandled}constructor(_,l=m.Unknown,w){super(_),this._message=_,this._code=l,this._detail=w,this.isHandled=l===m.NotAvailable&&w===!0,Object.setPrototypeOf(this,h.prototype)}}e.RemoteAuthorityResolverError=h;function y(L){const _=L.indexOf("+");return _===-1?L:L.substring(0,_)}}),define(Pe[58],Te([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=O,e.getRemoteName=T,e.parseAuthorityWithPort=N,e.parseAuthorityWithOptionalPort=R;function O(h){return h.scheme===D.Schemas.vscodeRemote?h.authority:void 0}function T(h){if(!h)return;const y=h.indexOf("+");return y<0?h:h.substr(0,y)}function N(h){const{host:y,port:L}=m(h);if(typeof L>"u")throw new Error(`Invalid remote authority: ${h}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:y,port:L}}function R(h,y){let{host:L,port:_}=m(h);return typeof _>"u"&&(_=y),{host:L,port:_}}function m(h){const y=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const L=h.match(/^(\[[0-9a-z:]+\])$/);if(L)return{host:L[1],port:void 0};const _=h.match(/(.*):(\d+)$/);return _?{host:_[1],port:parseInt(_[2],10)}:{host:h,port:void 0}}}),define(Pe[20],Te([1,0,15,3,58]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=N,e.isApplicationScopedExtension=_,e.isLanguagePackExtension=l,e.isAuthenticationProviderExtension=w,e.isResolverExtension=g,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function N(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(R||(e.ExtensionType=R={}));var m;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.LINUX_PPC64LE="linux-ppc64le",r.LINUX_RISCV64="linux-riscv64",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class h{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,s){if(typeof o>"u"||o===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof o=="string"||typeof s=="string"){const n=typeof o=="string"?o:o.value,i=typeof s=="string"?s:s.value;return D.equalsIgnoreCase(n,i)}return o._lower===s._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.ExtensionIdentifier=h;class y{get size(){return this._set.size}constructor(o){if(this._set=new Set,o)for(const s of o)this.add(s)}add(o){this._set.add(h.toKey(o))}delete(o){return this._set.delete(h.toKey(o))}has(o){return this._set.has(h.toKey(o))}}e.ExtensionIdentifierSet=y;class L{constructor(){this._map=new Map}clear(){this._map.clear()}delete(o){this._map.delete(h.toKey(o))}get(o){return this._map.get(h.toKey(o))}has(o){return this._map.has(h.toKey(o))}set(o,s){this._map.set(h.toKey(o),s)}values(){return this._map.values()}forEach(o){this._map.forEach(o)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=L;function _(r){return l(r)}function l(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function w(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function g(r,o){if(o){const s=`onResolveRemoteAuthority:${(0,T.getRemoteName)(o)}`;return!!r.activationEvents?.includes(s)}return!1}e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(Pe[103],Te([1,0,14,20]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class T{constructor(){this._generators=new Map,this._cache=new WeakMap}register(R,m){this._generators.set(R,m)}readActivationEvents(R){return this._cache.has(R)||this._cache.set(R,this._readActivationEvents(R)),this._cache.get(R)}createActivationEventsMap(R){const m=Object.create(null);for(const h of R){const y=this.readActivationEvents(h);y.length>0&&(m[O.ExtensionIdentifier.toKey(h.identifier)]=y)}return m}_readActivationEvents(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const m=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let h=0;h<m.length;h++)m[h]==="onUri"&&(m[h]=`onUri:${O.ExtensionIdentifier.toKey(R.identifier)}`);if(!R.contributes)return m;for(const h in R.contributes){const y=this._generators.get(h);if(!y)continue;const L=R.contributes[h],_=Array.isArray(L)?L:[L];try{y(_,m)}catch(l){(0,D.onUnexpectedError)(l)}}return m}}e.ImplicitActivationEventsImpl=T,e.ImplicitActivationEvents=new T}),define(Pe[197],Te([1,0,21,73,34]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=R,e.verifyMicrosoftInternalDomain=m;function N(h){if(D.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function R(h,y,L,_,l,w,g,r,o){const s=Object.create(null);s["common.machineId"]=w,s["common.sqmId"]=g,s.sessionID=(0,T.generateUuid)()+Date.now(),s.commitHash=_,s.version=l,s["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,D.PlatformToString)(D.platform),s["common.nodePlatform"]=O.platform,s["common.nodeArch"]=L,s["common.product"]=o||"desktop",r&&(s["common.msftInternal"]=r);let n=0;const i=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),D.isLinuxSnap&&(s["common.snap"]="true");const a=N(y);return a&&(s["common.platformDetail"]=a),s}function m(h){const y=O.env.USERDNSDOMAIN;if(!y)return!1;const L=y.toLowerCase();return h.some(_=>L===_)}}),define(Pe[198],Te([1,0,3]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var T;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(T||(e.TelemetryConfiguration=T={}))}),define(Pe[59],Te([1,0,26,17,58,197,198]),function(me,e,D,O,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=L,e.isLoggingOnly=_,e.getTelemetryLevel=l,e.validateTelemetryData=w,e.cleanRemoteAuthority=r,e.isInternalTelemetry=s,e.getPiiPathsFromEnvironment=n,e.cleanData=d;class m{constructor(E){this.value=E,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=m;class h{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=h,e.NullTelemetryService=new h;class y{async publicLog(E,c,p){}async publicLogError(E,c,p){}}e.NullEndpointTelemetryService=y,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function L(t,E){return!E.isBuilt&&!E.disableTelemetry?!0:!(E.disableTelemetry||!t.enableTelemetry)}function _(t,E){return E.extensionTestsLocationURI?!0:!(E.isBuilt||E.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function l(t){const E=t.getValue(R.TELEMETRY_SETTING_ID),c=t.getValue(R.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(E??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(t){const E={},c={},p={};o(t,p);for(let b in p){b=b.length>150?b.substr(b.length-149):b;const v=p[b];typeof v=="number"?c[b]=v:typeof v=="boolean"?c[b]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${b} has been trimmed to 8192, the original length is ${v.length}`),E[b]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(E[b]=v)}return{properties:E,measurements:c}}const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const E=(0,T.getRemoteName)(t);return g.has(E)?E:"other"}function o(t,E,c=0,p){if(t)for(const b of Object.getOwnPropertyNames(t)){const v=t[b],u=p?p+b:b;Array.isArray(v)?E[u]=(0,D.safeStringify)(v):v instanceof Date?E[u]=v.toISOString():(0,O.isObject)(v)?c<2?o(v,E,c+1,u+"."):E[u]=(0,D.safeStringify)(v):E[u]=v}}function s(t,E){const c=t.msftInternalDomains||[],p=E.getValue("telemetry.internalTesting");return(0,N.verifyMicrosoftInternalDomain)(c)||p}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,E){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let c=t;const p=[];for(const C of E)for(;;){const f=C.exec(t);if(!f)break;p.push([f.index,C.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(c="";;){const C=v.exec(t);if(!C)break;const f=p.some(([I,S])=>C.index<S&&I<v.lastIndex);!b.test(C[0])&&!f&&(c+=t.substring(u,C.index)+"<REDACTED: user-file-path>",u=v.lastIndex)}return u<t.length&&(c+=t.substr(u)),c}function a(t){if(!t)return t;const E=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of E)if(c.regex.test(t))return`<REDACTED: ${c.label}>`;return t}function d(t,E){return(0,D.cloneAndChange)(t,c=>{if(c instanceof m||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let p=c.replaceAll("%20"," ");p=i(p,E);for(const b of E)p=p.replace(b,"");return p=a(p),p}})}}),define(Pe[199],Te([1,0,15,98,20,21,2,14,73,59]),function(me,e,D,O,T,N,R,m,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=L,e.getIdAndVersion=g,e.getExtensionId=r,e.adoptToGalleryExtensionId=o,e.getGalleryExtensionId=s,e.groupByExtension=n,e.getLocalExtensionTelemetryData=i,e.getGalleryExtensionTelemetryData=a,e.getExtensionDependencies=d,e.computeTargetPlatform=E;function L(c,p){return c.uuid&&p.uuid?c.uuid===p.uuid:c.id===p.id?!0:(0,D.compareIgnoreCase)(c.id,p.id)===0}const _=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(p){const b=p.manifest?p.manifest.version:p.version,v=p.manifest?p.targetPlatform:p.properties.targetPlatform;return new l(p.identifier,b,v)}static parse(p){const b=_.exec(p);return b&&b[1]&&b[2]?new l({id:b[1]},b[2],b[4]||void 0):null}constructor(p,b,v="undefined"){this.version=b,this.targetPlatform=v,this.id=p.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(p){return p instanceof l?L(this,p)&&this.version===p.version&&this.targetPlatform===p.targetPlatform:!1}}e.ExtensionKey=l;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(c){const p=w.exec(c);return p&&p[1]?[o(p[1]),p[2]]:[o(c),void 0]}function r(c,p){return`${c}.${p}`}function o(c){return c.toLowerCase()}function s(c,p){return o(r(c??T.UNDEFINED_PUBLISHER,p))}function n(c,p){const b=[],v=u=>{for(const C of b)if(C.some(f=>L(p(f),p(u))))return C;return null};for(const u of c){const C=v(u);C?C.push(u):b.push([u])}return b}function i(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}function a(c){return{id:new y.TelemetryTrustedValue(c.identifier.id),name:new y.TelemetryTrustedValue(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function d(c,p){const b=[],v=p.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const u=v.shift();if(u&&b.every(C=>!L(C.identifier,{id:u}))){const C=c.filter(f=>L(f.identifier,{id:u}));C.length===1&&(b.push(C[0]),v.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}async function t(c,p){if(!N.isLinux)return!1;let b;try{b=(await c.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await c.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){p.debug("Error while getting the os-release file.",(0,m.getErrorMessage)(u))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function E(c,p){const b=await t(c,p),v=(0,O.getTargetPlatform)(b?"alpine":N.platform,h.arch);return p.debug("ComputeTargetPlatform:",v),v}}),define(Pe[200],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=D,e.serializeEnvironmentDescriptionMap=O,e.deserializeEnvironmentVariableCollection=T,e.deserializeEnvironmentDescriptionMap=N,e.serializeEnvironmentVariableCollections=R,e.deserializeEnvironmentVariableCollections=m;function D(h){return[...h.entries()]}function O(h){return h?[...h.entries()]:[]}function T(h){return new Map(h)}function N(h){return new Map(h??[])}function R(h){return Array.from(h.entries()).map(y=>[y[0],D(y[1].map),O(y[1].descriptionMap)])}function m(h){return new Map(h.map(y=>[y[0],{map:T(y[1]),descriptionMap:N(y[2])}]))}}),define(Pe[201],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class D{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,N,R=5){const m=N(h=>{const y=typeof h=="string"?h:h.data;let L=this._terminalBufferMap.get(T);if(L){L.data.push(y);return}const _=setTimeout(()=>this.flushBuffer(T),R);L={data:[y],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(T),m.dispose()}},this._terminalBufferMap.set(T,L)});return m}stopBuffering(T){this._terminalBufferMap.get(T)?.dispose()}flushBuffer(T){const N=this._terminalBufferMap.get(T);N&&(this._terminalBufferMap.delete(T),this._callback(T,N.data.join("")))}}e.TerminalDataBufferer=D}),define(Pe[202],Te([1,0,11,91,302,41,5,17,2,161,72,30]),function(me,e,D,O,T,N,R,m,h,y,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.registerIcon=o,e.getIconRegistry=s,e.Extensions={IconContribution:"base.contributions.icons"};var l;(function(d){function t(E,c){let p=E.defaults;for(;N.ThemeIcon.isThemeIcon(p);){const b=r.getIcon(p.id);if(!b)return;p=b.defaults}return p}d.getDefinition=t})(l||(e.IconContribution=l={}));var w;(function(d){function t(c){return{weight:c.weight,style:c.style,src:c.src.map(p=>({format:p.format,location:p.location.toString()}))}}d.toJSONObject=t;function E(c){const p=b=>(0,m.isString)(b)?b:void 0;if(c&&Array.isArray(c.src)&&c.src.every(b=>(0,m.isString)(b.format)&&(0,m.isString)(b.location)))return{weight:p(c.weight),style:p(c.style),src:c.src.map(b=>({format:b.format,location:h.URI.parse(b.location)}))}}d.fromJSONObject=E})(w||(e.IconFontDefinition=w={}));class g{constructor(){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${N.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(t,E,c,p){const b=this.iconsById[t];if(b){if(c&&!b.description){b.description=c,this.iconSchema.properties[t].markdownDescription=`${c} $(${t})`;const C=this.iconReferenceSchema.enum.indexOf(t);C!==-1&&(this.iconReferenceSchema.enumDescriptions[C]=c),this._onDidChange.fire()}return b}const v={id:t,description:c,defaults:E,deprecationMessage:p};this.iconsById[t]=v;const u={$ref:"#/definitions/icons"};return p&&(u.deprecationMessage=p),c&&(u.markdownDescription=`${c}: $(${t})`),this.iconSchema.properties[t]=u,this.iconReferenceSchema.enum.push(t),this.iconReferenceSchema.enumDescriptions.push(c||""),this._onDidChange.fire(),{id:t}}deregisterIcon(t){delete this.iconsById[t],delete this.iconSchema.properties[t];const E=this.iconReferenceSchema.enum.indexOf(t);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(t=>this.iconsById[t])}getIcon(t){return this.iconsById[t]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(t,E){const c=this.iconFontsById[t];return c||(this.iconFontsById[t]=E,this._onDidChange.fire(),E)}deregisterIconFont(t){delete this.iconFontsById[t]}getIconFont(t){return this.iconFontsById[t]}toString(){const t=(b,v)=>b.id.localeCompare(v.id),E=b=>{for(;N.ThemeIcon.isThemeIcon(b.defaults);)b=this.iconsById[b.defaults.id];return`codicon codicon-${b?b.id:""}`},c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const p=Object.keys(this.iconsById).map(b=>this.iconsById[b]);for(const b of p.filter(v=>!!v.description).sort(t))c.push(`|<i class="${E(b)}"></i>|${b.id}|${N.ThemeIcon.isThemeIcon(b.defaults)?b.defaults.id:b.id}|${b.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const b of p.filter(v=>!N.ThemeIcon.isThemeIcon(v.defaults)).sort(t))c.push(`|<i class="${E(b)}"></i>|${b.id}|`);return c.join(`
`)}}const r=new g;_.Registry.add(e.Extensions.IconContribution,r);function o(d,t,E,c){return r.registerIcon(d,t,E,c)}function s(){return r}function n(){const d=(0,T.getCodiconFontCharacters)();for(const t in d){const E="\\"+d[t].toString(16);r.registerIcon(t,{fontCharacter:E})}}n(),e.iconsSchemaId="vscode://schemas/icons";const i=_.Registry.as(L.Extensions.JSONContribution);i.registerSchema(e.iconsSchemaId,r.getIconSchema());const a=new D.RunOnceScheduler(()=>i.notifySchemaChanged(e.iconsSchemaId),200);r.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.widgetClose=o("widget-close",O.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=o("goto-previous-location",O.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=o("goto-next-location",O.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=N.ThemeIcon.modify(O.Codicon.sync,"spin"),e.spinningLoading=N.ThemeIcon.modify(O.Codicon.loading,"spin")}),define(Pe[203],Te([1,0,5,2,47,3,13]),function(me,e,D,O,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=y,e.extractLocalHostUriMetaDataForPortMapping=_,e.extractQueryLocalHostUriMetaDataForPortMapping=l,e.isLocalhost=w,e.isAllInterfaces=g,e.isPortPrivileged=r,e.ITunnelService=(0,N.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,N.createDecorator)("sharedTunnelsService");var m;(function(n){n.Http="http",n.Https="https"})(m||(e.TunnelProtocol=m={}));var h;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(h||(e.TunnelPrivacyId=h={}));function y(n){return!!n.forwardPort}var L;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(L||(e.ProvidedOnAutoForward=L={}));function _(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function l(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const a of i){const d=a.split("=")[1];if(/^https?:/.exec(d)){const t=_(O.URI.parse(d));if(t)return t}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(n){return e.LOCALHOST_ADDRESSES.indexOf(n)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(n){return e.ALL_INTERFACES_ADDRESSES.indexOf(n)>=0}function r(n,i,a,d){if(a===1)return!1;if(a===2&&g(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class o{constructor(i,a,d){this.remoteAddress=i,this.localAddress=a,this._dispose=d,this._onDispose=new D.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=o;let s=class{constructor(i,a){this.logService=i,this.configurationService=a,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const i=this.configurationService.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this._tunnelProvider=i,i?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this._canElevate=i.elevation,this._privacyOptions=i.privacyOptions,this._canChangeProtocol=i.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const i=[],a=Array.from(this._tunnels.values());for(const d of a){const t=Array.from(d.values());for(const E of t){const c=await E.value;c&&typeof c!="string"&&i.push(c)}}return i}async dispose(){for(const i of this._tunnels.values()){for(const{value:a}of i.values())await a.then(d=>typeof d!="string"?d?.dispose():void 0);i.clear()}this._tunnels.clear()}setEnvironmentTunnel(i,a,d,t,E){this.addTunnelToMap(i,a,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:a,localAddress:d,privacy:t,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,a){(g(i)||w(i))&&(i=e.LOCALHOST_ADDRESSES[0]);const d=this.getTunnelFromMap(i,a);if(d)return++d.refcount,d.value}openTunnel(i,a,d,t,E,c=!1,p,b){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${d} on local port ${E}.`);const v=this._tunnelProvider??i;if(!v)return;if(a||(a="localhost"),t||(t=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(d)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.retainOrCreateTunnel(v,a,d,t,E,c,p,b);return u?u.then(C=>{if(C){if(typeof C=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(a,d),C}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(a,d);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.makeTunnel(C);return(C.tunnelRemoteHost!==a||C.tunnelRemotePort!==d)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),p&&C.privacy!==p&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(f),f}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const a=this._tunnels.get(i.tunnelRemoteHost);if(a){const d=a.get(i.tunnelRemotePort);d&&(d.refcount--,await this.tryDisposeTunnel(i.tunnelRemoteHost,i.tunnelRemotePort,d))}}}}async tryDisposeTunnel(i,a,d){if(d.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${a}.`);const t=d.value.then(async E=>{E&&typeof E!="string"&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(i)&&this._tunnels.get(i).delete(a),t}}async closeTunnel(i,a){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${a} `);const d=this._tunnels.get(i);if(d&&d.has(a)){const t=d.get(a);t.refcount=0,await this.tryDisposeTunnel(i,a,t)}}addTunnelToMap(i,a,d){this._tunnels.has(i)||this._tunnels.set(i,new Map),this._tunnels.get(i).set(a,{refcount:1,value:d})}async removeEmptyOrErrorTunnelFromMap(i,a){const d=this._tunnels.get(i);if(d){const t=d.get(a),E=t?await t.value:void 0;(!E||typeof E=="string")&&d.delete(a),d.size===0&&this._tunnels.delete(i)}}getTunnelFromMap(i,a){const d=[i];w(i)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):g(i)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const t=d.map(E=>this._tunnels.get(E));for(const E of t){const c=E?.get(a);if(c)return c}}canTunnel(i){return!!_(i)}createWithProvider(i,a,d,t,E,c,p){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${d} on local port ${t}.`);const b=d;this._factoryInProgress.add(b);const v=t===void 0?d:t,u={elevationRequired:E?this.isPortPrivileged(v):!1},C={remoteAddress:{host:a,port:d},localAddressPort:t,privacy:c,public:c?c!==h.Private:void 0,protocol:p},f=i.forwardPort(C,u);return f?(this.addTunnelToMap(a,d,f),f.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(b)})):this._factoryInProgress.delete(b),f}};e.AbstractTunnelService=s,e.AbstractTunnelService=s=Ke([He(0,R.ILogService),He(1,T.IConfigurationService)],s)}),define(Pe[204],Te([1,0,3]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,D.createDecorator)("editSessionIdentityService");var O;(function(T){T[T.Complete=100]="Complete",T[T.Partial=50]="Partial",T[T.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(Pe[205],Te([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualResource=O,e.getVirtualWorkspaceLocation=T,e.getVirtualWorkspaceScheme=N,e.getVirtualWorkspaceAuthority=R,e.isVirtualWorkspace=m;function O(h){return h.scheme!==D.Schemas.file&&h.scheme!==D.Schemas.vscodeRemote}function T(h){if(h.folders.length)return h.folders.every(y=>O(y.uri))?h.folders[0].uri:void 0;if(h.configuration&&O(h.configuration))return h.configuration}function N(h){return T(h)?.scheme}function R(h){return T(h)?.authority}function m(h){return T(h)!==void 0}}),define(Pe[48],Te([1,0,162,19,52,23,2,3,12]),function(me,e,D,O,T,N,R,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=y,e.isEmptyWorkspaceIdentifier=L,e.toWorkspaceIdentifier=_,e.isWorkspaceIdentifier=l,e.reviveIdentifier=w,e.isWorkspace=r,e.isWorkspaceFolder=o,e.toWorkspaceFolder=i,e.isUntitledWorkspace=a,e.isTemporaryWorkspace=d,e.isStandaloneEditorWorkspace=t,e.isSavedWorkspace=E,e.hasWorkspaceFileExtension=c,e.IWorkspaceContextService=(0,m.createDecorator)("contextService");function y(p){const b=p;return typeof b?.id=="string"&&R.URI.isUri(b.uri)}function L(p){return typeof p?.id=="string"&&!y(p)&&!l(p)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function _(p,b){if(typeof p=="string"||typeof p>"u")return typeof p=="string"?{id:(0,O.basename)(p)}:b?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const v=p;return v.configuration?{id:v.id,configPath:v.configuration}:v.folders.length===1?{id:v.id,uri:v.folders[0].uri}:{id:v.id}}function l(p){const b=p;return typeof b?.id=="string"&&R.URI.isUri(b.configPath)}function w(p){const b=p;if(b?.uri)return{id:b.id,uri:R.URI.revive(b.uri)};const v=p;if(v?.configPath)return{id:v.id,configPath:R.URI.revive(v.configPath)};if(p?.id)return{id:p.id}}var g;(function(p){p[p.EMPTY=1]="EMPTY",p[p.FOLDER=2]="FOLDER",p[p.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function r(p){const b=p;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}function o(p){const b=p;return!!(b&&typeof b=="object"&&R.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}class s{constructor(b,v,u,C,f){this._id=b,this._transient=u,this._configuration=C,this._ignorePathCasing=f,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=v}update(b){this._id=b.id,this._configuration=b.configuration,this._transient=b.transient,this._ignorePathCasing=b._ignorePathCasing,this.folders=b.folders}get folders(){return this._folders}set folders(b){this._folders=b,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(b){this._configuration=b}getFolder(b){return b&&this._foldersMap.findSubstr(b)||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const b of this.folders)this._foldersMap.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=s;class n{constructor(b,v){this.raw=v,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,N.joinPath)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function i(p){return new n({uri:p,index:0,name:(0,N.basenameOrAuthority)(p)},{uri:p.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function a(p,b){return N.extUriBiasedIgnorePathCase.isEqualOrParent(p,b.untitledWorkspacesHome)}function d(p){let b;return R.URI.isUri(p)?b=p:b=p.configuration,b?.scheme===h.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(p){return p.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function E(p,b){return!a(p,b)&&!d(p)}function c(p){return(typeof p=="string"?(0,O.extname)(p):(0,N.extname)(p))===e.WORKSPACE_SUFFIX}}),define(Pe[74],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class D{static{this.enableDebugLogging=!1}constructor(T){this.id=T,this._data=new Map,this._idPool=1}add(T){const N=this._idPool++;return this._data.set(N,T),this.logDebugInfo(),N}get(T,N){return this._data.has(T)?this._data.get(T)[N]:void 0}delete(T){this._data.delete(T),this.logDebugInfo()}logDebugInfo(){D.enableDebugLogging&&console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=D}),define(Pe[44],Te([1,0,12,23,3]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class N{constructor(){this._systemSchemes=new Set(Object.keys(D.Schemas)),this._providerInfo=new Map,this.extUri=new O.ExtUri(m=>{const h=this._providerInfo.get(m.scheme);return!(h===void 0||h&1024)})}$acceptProviderInfos(m,h){h===null?this._providerInfo.delete(m.scheme):this._providerInfo.set(m.scheme,h)}isFreeScheme(m){return!this._providerInfo.has(m)&&!this._systemSchemes.has(m)}getCapabilities(m){return this._providerInfo.get(m)}}e.ExtHostFileSystemInfo=N,e.IExtHostFileSystemInfo=(0,T.createDecorator)("IExtHostFileSystemInfo")}),define(Pe[27],Te([1,0,3]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,D.createDecorator)("IExtHostInitDataService")}),define(Pe[206],Te([1,0,168,13,193,27]),function(me,e,D,O,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends T.LogService{constructor(h,y,L){const _=L.remote.isRemote?"remoteexthost":h?"workerexthost":"exthost",l=L.remote.isRemote?(0,D.localize)(0,null):h?(0,D.localize)(1,null):(0,D.localize)(2,null);super(y.createLogger(_,{name:l}))}};e.ExtHostLogService=R,e.ExtHostLogService=R=Ke([He(1,O.ILoggerService),He(2,N.IExtHostInitDataService)],R)}),define(Pe[207],Te([1,0,11]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class O{constructor(R,m,h){this._deferredPromises=new Map,this._id=R,this._shared=m,this._storage=h,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)}),this._scheduler=new D.RunOnceScheduler(()=>{const y=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of y.values())L.complete()}catch(L){for(const _ of y.values())_.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,m){let h=this._value[R];return typeof h>"u"&&(h=m),h}update(R,m){this._value[R]=m;const h=this._deferredPromises.get(R);if(h!==void 0)return h.p;const y=new D.DeferredPromise;return this._deferredPromises.set(R,y),this._scheduler.isScheduled()||this._scheduler.schedule(),y.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=O;class T extends O{setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}constructor(R,m){super(R.identifier.value,!0,m),this._extension=R}}e.ExtensionGlobalMemento=T}),define(Pe[208],Te([1,0,5,2]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class T{constructor(R){this._notebooksAndEditors=R,this._onDidSaveNotebookDocument=new D.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new D.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(R,m,h,y){const _=this._notebooksAndEditors.getNotebookDocument(O.URI.revive(R)).acceptModelChanged(m.value,h,y);this._onDidChangeNotebookDocument.fire(_)}$acceptDirtyStateChanged(R,m){this._notebooksAndEditors.getNotebookDocument(O.URI.revive(R)).acceptDirty(m)}$acceptModelSaved(R){const m=this._notebooksAndEditors.getNotebookDocument(O.URI.revive(R));this._onDidSaveNotebookDocument.fire(m.apiNotebook)}}e.ExtHostNotebookDocuments=T}),define(Pe[16],Te([1,0,3]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,D.createDecorator)("IExtHostRpcService");class O{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.ExtHostRpcService=O}),define(Pe[209],Te([1,0,20,5]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{#e;constructor(R,m){this._onDidChange=new O.Emitter,this.onDidChange=this._onDidChange.event,this._id=D.ExtensionIdentifier.toKey(R.identifier),this.#e=m,this.#e.onDidChangePassword(h=>{h.extensionId===this._id&&this._onDidChange.fire({key:h.key})})}get(R){return this.#e.get(this._id,R)}store(R,m){return this.#e.store(this._id,R,m)}delete(R){return this.#e.delete(this._id,R)}}e.ExtensionSecrets=T}),define(Pe[60],Te([1,0,3]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,D.createDecorator)("IURITransformerService");class O{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=O}),define(Pe[210],Te([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewMessage=T,e.deserializeWebviewMessage=R;class O{constructor(){this.buffers=[]}add(h){let y=this.buffers.indexOf(h);return y<0&&(y=this.buffers.length,this.buffers.push(h)),y}}function T(m,h){if(h.serializeBuffersForPostMessage){const y=new O,_=JSON.stringify(m,(w,g)=>{if(g instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(g)};if(ArrayBuffer.isView(g)){const r=N(g);if(r)return{$$vscode_array_buffer_reference$$:!0,index:y.add(g.buffer),view:{type:r,byteLength:g.byteLength,byteOffset:g.byteOffset}}}return g}),l=y.buffers.map(w=>{const g=new Uint8Array(w);return D.VSBuffer.wrap(g)});return{message:_,buffers:l}}else return{message:JSON.stringify(m),buffers:[]}}function N(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(m,h){const y=h.map(l=>{const w=new ArrayBuffer(l.byteLength);return new Uint8Array(w).set(l.buffer),w}),L=h.length?(l,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const g=w,{index:r}=g,o=y[r];if(g.view)switch(g.view.type){case 1:return new Int8Array(o,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return w}:void 0;return{message:JSON.parse(m,L),arrayBuffers:y}}}),define(Pe[104],Te([1,0,177,17,2,6,3,30,43,12,42,139,32]),function(me,e,D,O,T,N,R,m,h,y,L,_,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.EditorResourceAccessor=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.isEditorPaneWithSelection=r,e.isEditorPaneWithScrolling=o,e.findViewStateForEditor=s,e.isResourceEditorInput=n,e.isResourceDiffEditorInput=i,e.isResourceMultiDiffEditorInput=a,e.isResourceSideBySideEditorInput=d,e.isUntitledResourceEditorInput=t,e.isResourceMergeEditorInput=E,e.isEditorInput=C,e.isSideBySideEditorInput=I,e.isDiffEditorInput=S,e.createTooLargeFileError=P,e.isEditorInputWithOptions=k,e.isEditorInputWithOptionsAndGroup=H,e.isEditorIdentifier=$,e.preventEditorClose=fe,e.pathsToEditors=oe,e.isTextEditorViewState=ne,e.isEditorOpenError=Ie,e.createEditorOpenError=xe,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var w;(function(re){re[re.PROGRAMMATIC=1]="PROGRAMMATIC",re[re.USER=2]="USER",re[re.EDIT=3]="EDIT",re[re.NAVIGATION=4]="NAVIGATION",re[re.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var g;(function(re){re[re.IDENTICAL=1]="IDENTICAL",re[re.SIMILAR=2]="SIMILAR",re[re.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function r(re){const F=re;return!!F&&typeof F.getSelection=="function"&&!!F.onDidChangeSelection}function o(re){const F=re;return!!F&&typeof F.getScrollPosition=="function"&&typeof F.setScrollPosition=="function"&&!!F.onDidChangeScroll}function s(re,F,Z){for(const be of Z.visibleEditorPanes)if(be.group.id===F&&re.matches(be.input))return be.getViewState()}function n(re){if(C(re))return!1;const F=re;return T.URI.isUri(F?.resource)}function i(re){if(C(re))return!1;const F=re;return F?.original!==void 0&&F.modified!==void 0}function a(re){if(C(re))return!1;const F=re;return!F||F.resources&&!Array.isArray(F.resources)?!1:!!F.resources||!!F.multiDiffSource}function d(re){if(C(re)||i(re))return!1;const F=re;return F?.primary!==void 0&&F.secondary!==void 0}function t(re){if(C(re))return!1;const F=re;return F?F.resource===void 0||F.resource.scheme===y.Schemas.untitled||F.forceUntitled===!0:!1}function E(re){if(C(re))return!1;const F=re;return T.URI.isUri(F?.base?.resource)&&T.URI.isUri(F?.input1?.resource)&&T.URI.isUri(F?.input2?.resource)&&T.URI.isUri(F?.result?.resource)}var c;(function(re){re[re.SHORT=0]="SHORT",re[re.MEDIUM=1]="MEDIUM",re[re.LONG=2]="LONG"})(c||(e.Verbosity=c={}));var p;(function(re){re[re.EXPLICIT=1]="EXPLICIT",re[re.AUTO=2]="AUTO",re[re.FOCUS_CHANGE=3]="FOCUS_CHANGE",re[re.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(p||(e.SaveReason=p={}));class b{constructor(){this.mapIdToSaveSource=new Map}registerSource(F,Z){let be=this.mapIdToSaveSource.get(F);return be||(be={source:F,label:Z},this.mapIdToSaveSource.set(F,be)),be.source}getSourceLabel(F){return this.mapIdToSaveSource.get(F)?.label??F}}e.SaveSourceRegistry=new b;var v;(function(re){re[re.None=0]="None",re[re.Readonly=2]="Readonly",re[re.Untitled=4]="Untitled",re[re.Singleton=8]="Singleton",re[re.RequiresTrust=16]="RequiresTrust",re[re.CanSplitInGroup=32]="CanSplitInGroup",re[re.ForceDescription=64]="ForceDescription",re[re.CanDropIntoEditor=128]="CanDropIntoEditor",re[re.MultipleEditors=256]="MultipleEditors",re[re.Scratchpad=512]="Scratchpad"})(v||(e.EditorInputCapabilities=v={}));class u extends N.Disposable{}e.AbstractEditorInput=u;function C(re){return re instanceof u}function f(re){const F=re;return T.URI.isUri(F?.preferredResource)}function I(re){const F=re;return C(F?.primary)&&C(F?.secondary)}function S(re){const F=re;return C(F?.modified)&&C(F?.original)}function P(re,F,Z,be,Le){return xe(be,[(0,_.toAction)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const Se={...Z,limits:{size:Number.MAX_VALUE}};re.openEditor(F,Se)}}),(0,_.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>Le.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}function k(re){return C(re?.editor)}function H(re){const F=re;return k(re)&&F?.group!==void 0}function $(re){const F=re;return typeof F?.groupId=="number"&&C(F.editor)}var V;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.REPLACE=1]="REPLACE",re[re.MOVE=2]="MOVE",re[re.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var A;(function(re){re[re.GROUP_ACTIVE=0]="GROUP_ACTIVE",re[re.GROUP_INDEX=1]="GROUP_INDEX",re[re.GROUP_LABEL=2]="GROUP_LABEL",re[re.GROUP_LOCKED=3]="GROUP_LOCKED",re[re.EDITOR_OPEN=4]="EDITOR_OPEN",re[re.EDITOR_CLOSE=5]="EDITOR_CLOSE",re[re.EDITOR_MOVE=6]="EDITOR_MOVE",re[re.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",re[re.EDITOR_LABEL=8]="EDITOR_LABEL",re[re.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",re[re.EDITOR_PIN=10]="EDITOR_PIN",re[re.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",re[re.EDITOR_STICKY=12]="EDITOR_STICKY",re[re.EDITOR_DIRTY=13]="EDITOR_DIRTY",re[re.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(A||(e.GroupModelChangeKind=A={}));var U;(function(re){re[re.PRIMARY=1]="PRIMARY",re[re.SECONDARY=2]="SECONDARY",re[re.BOTH=3]="BOTH",re[re.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class j{getOriginalUri(F,Z){if(!F)return;if(E(F))return e.EditorResourceAccessor.getOriginalUri(F.result,Z);if(Z?.supportSideBySide){const{primary:Le,secondary:Se}=this.getSideEditors(F);if(Le&&Se){if(Z?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(Le,{filterByScheme:Z.filterByScheme}),secondary:this.getOriginalUri(Se,{filterByScheme:Z.filterByScheme})};if(Z?.supportSideBySide===U.ANY)return this.getOriginalUri(Le,{filterByScheme:Z.filterByScheme})??this.getOriginalUri(Se,{filterByScheme:Z.filterByScheme});F=Z.supportSideBySide===U.PRIMARY?Le:Se}}if(i(F)||a(F)||d(F)||E(F))return;const be=f(F)?F.preferredResource:F.resource;return!be||!Z||!Z.filterByScheme?be:this.filterUri(be,Z.filterByScheme)}getSideEditors(F){return I(F)||d(F)?{primary:F.primary,secondary:F.secondary}:S(F)||i(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,Z){if(!F)return;if(E(F))return e.EditorResourceAccessor.getCanonicalUri(F.result,Z);if(Z?.supportSideBySide){const{primary:Le,secondary:Se}=this.getSideEditors(F);if(Le&&Se){if(Z?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(Le,{filterByScheme:Z.filterByScheme}),secondary:this.getCanonicalUri(Se,{filterByScheme:Z.filterByScheme})};if(Z?.supportSideBySide===U.ANY)return this.getCanonicalUri(Le,{filterByScheme:Z.filterByScheme})??this.getCanonicalUri(Se,{filterByScheme:Z.filterByScheme});F=Z.supportSideBySide===U.PRIMARY?Le:Se}}if(i(F)||a(F)||d(F)||E(F))return;const be=F.resource;return!be||!Z||!Z.filterByScheme?be:this.filterUri(be,Z.filterByScheme)}filterUri(F,Z){if(Array.isArray(Z)){if(Z.some(be=>F.scheme===be))return F}else if(Z===F.scheme)return F}}var ie;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.KEYBOARD=1]="KEYBOARD",re[re.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function fe(re,F,Z,be){if(!re.isSticky(F))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return Z===ie.MOUSE||Z===ie.KEYBOARD;case"mouse":return Z===ie.MOUSE;case"keyboard":return Z===ie.KEYBOARD}return!1}e.EditorResourceAccessor=new j;var Ce;(function(re){re[re.LEFT=0]="LEFT",re[re.RIGHT=1]="RIGHT"})(Ce||(e.CloseDirection=Ce={}));class _e{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const Z=this.instantiationService=F.get(R.IInstantiationService);for(const[be,Le]of this.editorSerializerConstructors)this.createEditorSerializer(be,Le,Z);this.editorSerializerConstructors.clear()}createEditorSerializer(F,Z,be){const Le=be.createInstance(Z);this.editorSerializerInstances.set(F,Le)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,O.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,Z){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,Z,this.instantiationService):this.editorSerializerConstructors.set(F,Z),(0,N.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}m.Registry.add(e.EditorExtensions.EditorFactory,new _e);async function oe(re,F,Z){return!re||!re.length?[]:await Promise.all(re.map(async be=>{const Le=T.URI.revive(be.fileUri);if(!Le){Z.info("Cannot resolve the path because it is not valid.",be);return}if(!await F.canHandleResource(Le)){Z.info("Cannot resolve the path because it cannot be handled",be);return}let ve=be.exists,he=be.type;if(typeof ve!="boolean"||typeof he!="number")try{he=(await F.stat(Le)).isDirectory?h.FileType.Directory:h.FileType.Unknown,ve=!0}catch(Y){Z.error(Y),ve=!1}if(!ve&&be.openOnlyIfExists){Z.info("Cannot resolve the path because it does not exist",be);return}if(he===h.FileType.Directory){Z.info("Cannot resolve the path because it is a directory",be);return}const K={...be.options,pinned:!0};return ve?{resource:Le,options:K}:{resource:Le,options:K,forceUntitled:!0}}))}var pe;(function(re){re[re.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",re[re.SEQUENTIAL=1]="SEQUENTIAL"})(pe||(e.EditorsOrder=pe={}));function ne(re){const F=re;if(!F)return!1;const Z=F;if(Z.modified)return ne(Z.modified);const be=F;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function Ie(re){return(0,L.isErrorWithActions)(re)}function xe(re,F,Z){const be=(0,L.createErrorWithActions)(re,F);return be.forceMessage=Z?.forceMessage,be.forceSeverity=Z?.forceSeverity,be.allowDialog=Z?.allowDialog,be}}),define(Pe[211],Te([1,0,5,178,3,6,28,30,18,26,91,202]),function(me,e,D,O,T,N,R,m,h,y,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.ViewContentGroups=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=e.VIEWS_LOG_NAME=e.VIEWS_LOG_ID=void 0,e.ViewContainerLocationToString=g,e.VIEWS_LOG_ID="views",e.VIEWS_LOG_NAME=(0,O.localize)(0,null),e.defaultViewIcon=(0,_.registerIcon)("default-view-icon",L.Codicon.window,(0,O.localize)(1,null));var l;(function(E){E.ViewContainersRegistry="workbench.registry.view.containers",E.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var w;(function(E){E[E.Sidebar=0]="Sidebar",E[E.Panel=1]="Panel",E[E.AuxiliaryBar=2]="AuxiliaryBar"})(w||(e.ViewContainerLocation=w={})),e.ViewContainerLocations=[0,1,2];function g(E){switch(E){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class r extends N.Disposable{constructor(){super(...arguments),this._onDidRegister=this._register(new D.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new D.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,h.flatten)([...this.viewContainers.values()])}registerViewContainer(c,p,b){const v=this.get(c.id);if(v)return v;const u=c;return u.openCommandActionDescriptor=b?.doNotRegisterOpenCommand?void 0:u.openCommandActionDescriptor??{id:u.id},(0,R.getOrSet)(this.viewContainers,p,[]).push(u),b?.isDefault&&this.defaultViewContainers.push(u),this._onDidRegister.fire({viewContainer:u,viewContainerLocation:p}),u}deregisterViewContainer(c){for(const p of this.viewContainers.keys()){const b=this.viewContainers.get(p),v=b?.indexOf(c);if(v!==-1){b?.splice(v,1),b.length===0&&this.viewContainers.delete(p),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:p});return}}}get(c){return this.all.filter(p=>p.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(p=>this.getViewContainers(p).filter(b=>b?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(p=>this.getViewContainerLocation(p)===c)}}m.Registry.add(l.ViewContainersRegistry,new r);var o;(function(E){E.Open="2_open",E.Debug="4_debug",E.SCM="5_scm",E.More="9_more"})(o||(e.ViewContentGroups=o={}));function s(E,c){const p=E.group??o.More,b=c.group??o.More;return p!==b?p.localeCompare(b):(E.order??5)-(c.order??5)}class n extends N.Disposable{constructor(){super(...arguments),this._onViewsRegistered=this._register(new D.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new D.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new D.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new D.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new R.SetMap}registerViews(c,p){this.registerViews2([{views:c,viewContainer:p}])}registerViews2(c){c.forEach(({views:p,viewContainer:b})=>this.addViews(p,b)),this._onViewsRegistered.fire(c)}deregisterViews(c,p){const b=this.removeViews(c,p);b.length&&this._onViewsDeregistered.fire({views:b,viewContainer:p})}moveViews(c,p){for(const b of this._views.keys())if(b!==p){const v=this.removeViews(c,b);v.length&&(this.addViews(v,p),this._onDidChangeContainer.fire({views:v,from:b,to:p}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const p of this._viewContainers){const b=(this._views.get(p)||[]).filter(v=>v.id===c)[0];if(b)return b}return null}getViewContainer(c){for(const p of this._viewContainers)if((this._views.get(p)||[]).filter(v=>v.id===c)[0])return p;return null}registerViewWelcomeContent(c,p){return this._viewWelcomeContents.add(c,p),this._onDidChangeViewWelcomeContent.fire(c),(0,N.toDisposable)(()=>{this._viewWelcomeContents.delete(c,p),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,p){const b=new Map;for(const[v,u]of p)this._viewWelcomeContents.add(c,u),b.set(v,(0,N.toDisposable)(()=>{this._viewWelcomeContents.delete(c,u),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),b}getViewWelcomeContent(c){const p=[];return this._viewWelcomeContents.forEach(c,b=>p.push(b)),p.sort(s)}addViews(c,p){let b=this._views.get(p);b||(b=[],this._views.set(p,b),this._viewContainers.push(p));for(const v of c){if(this.getView(v.id)!==null)throw new Error((0,O.localize)(2,null,v.id));b.push(v)}}removeViews(c,p){const b=this._views.get(p);if(!b)return[];const v=[],u=[];for(const C of b)c.includes(C)?v.push(C):u.push(C);return v.length&&(u.length?this._views.set(p,u):(this._views.delete(p),this._viewContainers.splice(this._viewContainers.indexOf(p),1))),v}}m.Registry.add(l.ViewsRegistry,new n),e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var i;(function(E){E[E.Default=0]="Default",E[E.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var a;(function(E){E[E.None=0]="None",E[E.Collapsed=1]="Collapsed",E[E.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class d{constructor(c,p){this.resolved=!1,this._hasResolve=!1,(0,y.mixin)(this,c),this._hasResolve=!!p,this.resolve=async b=>{if(p&&!this.resolved){const v=await p(b);v&&(this.tooltip=this.tooltip??v.tooltip,this.command=this.command??v.command)}b.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=d;class t extends Error{constructor(c){super((0,O.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.NoTreeViewError=t}),define(Pe[212],Te([1,0,5,39,6,33,3]),function(me,e,D,O,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedChatAgent=e.ChatAgentService=e.IChatAgentService=e.ChatAgentLocation=void 0;var m;(function(L){L.Panel="panel",L.Terminal="terminal",L.Notebook="notebook",L.Editor="editor"})(m||(e.ChatAgentLocation=m={})),function(L){function _(l){switch(l){case"panel":return L.Panel;case"terminal":return L.Terminal;case"notebook":return L.Notebook}return L.Panel}L.fromRaw=_}(m||(e.ChatAgentLocation=m={})),e.IChatAgentService=(0,R.createDecorator)("chatAgentService");let h=class{static{this.AGENT_LEADER="@"}constructor(_){this.contextKeyService=_,this._agents=[],this._onDidChangeAgents=new D.Emitter,this.onDidChangeAgents=this._onDidChangeAgents.event}registerAgent(_,l){if(this.getAgent(_))throw new Error(`Agent already registered: ${JSON.stringify(_)}`);const g=this,r=l.slashCommands;l={...l,get slashCommands(){return r.filter(s=>!s.when||g.contextKeyService.contextMatchesRules(N.ContextKeyExpr.deserialize(s.when)))}};const o={data:l};return this._agents.push(o),(0,T.toDisposable)(()=>{this._agents=this._agents.filter(s=>s!==o),this._onDidChangeAgents.fire(void 0)})}registerAgentImplementation(_,l){const w=this._getAgentEntry(_);if(!w)throw new Error(`Unknown agent: ${JSON.stringify(_)}`);if(w.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(_)}`);return w.impl=l,this._onDidChangeAgents.fire(new y(w.data,l)),(0,T.toDisposable)(()=>{w.impl=void 0,this._onDidChangeAgents.fire(void 0)})}registerDynamicAgent(_,l){const w={data:_,impl:l};return this._agents.push(w),this._onDidChangeAgents.fire(new y(_,l)),(0,T.toDisposable)(()=>{this._agents=this._agents.filter(g=>g!==w),this._onDidChangeAgents.fire(void 0)})}updateAgent(_,l){const w=this._getAgentEntry(_);if(!w?.impl)throw new Error(`No activated agent with id ${JSON.stringify(_)} registered`);w.data.metadata={...w.data.metadata,...l},this._onDidChangeAgents.fire(new y(w.data,w.impl))}getDefaultAgent(_){return this.getActivatedAgents().find(l=>!!l.isDefault&&l.locations.includes(_))}getSecondaryAgent(){return O.Iterable.find(this._agents.values(),_=>!!_.data.metadata.isSecondary)?.data}_getAgentEntry(_){return this._agents.find(l=>l.data.id===_)}getAgent(_){return this._getAgentEntry(_)?.data}getAgents(){return this._agents.map(_=>_.data)}getActivatedAgents(){return Array.from(this._agents.values()).filter(_=>!!_.impl).map(_=>new y(_.data,_.impl))}getAgentsByName(_){return this.getAgents().filter(l=>l.name===_)}async invokeAgent(_,l,w,g,r){const o=this._getAgentEntry(_);if(!o?.impl)throw new Error(`No activated agent with id ${_}`);return await o.impl.invoke(l,w,g,r)}async getFollowups(_,l,w,g,r){const o=this._getAgentEntry(_);if(!o?.impl)throw new Error(`No activated agent with id ${_}`);return o.impl?.provideFollowups?o.impl.provideFollowups(l,w,g,r):[]}};e.ChatAgentService=h,e.ChatAgentService=h=Ke([He(0,N.IContextKeyService)],h);class y{constructor(_,l){this.data=_,this.impl=l}get id(){return this.data.id}get name(){return this.data.name??""}get description(){return this.data.description??""}get extensionId(){return this.data.extensionId}get isDefault(){return this.data.isDefault}get metadata(){return this.data.metadata}get slashCommands(){return this.data.slashCommands}get defaultImplicitVariables(){return this.data.defaultImplicitVariables}get locations(){return this.data.locations}async invoke(_,l,w,g){return this.impl.invoke(_,l,w,g)}async provideFollowups(_,l,w,g){return this.impl.provideFollowups?this.impl.provideFollowups(_,l,w,g):[]}provideWelcomeMessage(_){if(this.impl.provideWelcomeMessage)return this.impl.provideWelcomeMessage(_)}provideSampleQuestions(_){if(this.impl.provideSampleQuestions)return this.impl.provideSampleQuestions(_)}}e.MergedChatAgent=y}),define(Pe[213],Te([1,0,2,29,3]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KEYWORD_ACTIVIATION_SETTING_ID=e.IChatService=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.isIDocumentContext=N,e.isIUsedContext=R;function N(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof D.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(O.Range.isIRange)}function R(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(N)}var m;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var h;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})(h||(e.ChatCopyKind=h={})),e.IChatService=(0,T.createDecorator)("IChatService"),e.KEYWORD_ACTIVIATION_SETTING_ID="accessibility.voice.keywordActivation"}),define(Pe[214],Te([1,0,5,11,179]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class N{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new D.Emitter,this._onExit=new D.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(m){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=m}onEvent(m){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=m}onRequest(m){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=m}sendResponse(m){m.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.internalSend("response",m)}sendRequest(m,h,y,L){const _={command:m};if(h&&Object.keys(h).length>0&&(_.arguments=h),this.internalSend("request",_),typeof L=="number"){const l=setTimeout(()=>{clearTimeout(l);const w=this.pendingRequests.get(_.seq);if(w){this.pendingRequests.delete(_.seq);const g={type:"response",seq:0,request_seq:_.seq,success:!1,command:m,message:(0,T.localize)(0,null,L,m)};w(g)}},L)}return y&&this.pendingRequests.set(_.seq,y),_.seq}acceptMessage(m){this.messageCallback?this.messageCallback(m):(this.queue.push(m),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(m,h){return m.type!=="event"||h.type!=="event"}async processQueue(){let m;for(;this.queue.length;){if((!m||this.needsTaskBoundaryBetween(this.queue[0],m))&&await(0,O.timeout)(0),m=this.queue.shift(),!m)return;switch(m.type){case"event":this.eventCallback?.(m);break;case"request":this.requestCallback?.(m);break;case"response":{const h=m,y=this.pendingRequests.get(h.request_seq);y&&(this.pendingRequests.delete(h.request_seq),y(h));break}}}}internalSend(m,h){h.type=m,h.seq=this.sequence++,this.sendMessage(h)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const m=new Map;this.pendingRequests.forEach((h,y)=>m.set(y,h)),await(0,O.timeout)(500),m.forEach((h,y)=>{h({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(y)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=N}),define(Pe[215],Te([1,0,2,180,33,3]),function(me,e,D,O,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_EXTENSIONID=e.CONTEXT_VARIABLE_LANGUAGE=e.CONTEXT_VARIABLE_NAME=e.CONTEXT_VARIABLE_INTERFACES=e.CONTEXT_VARIABLE_TYPE=e.CONTEXT_VARIABLE_VALUE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_HAS_MODES=e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.getStateLabel=h,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new T.RawContextKey("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new T.RawContextKey("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new T.RawContextKey("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new T.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:O.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new T.RawContextKey("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new T.RawContextKey("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new T.RawContextKey("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new T.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new T.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new T.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new T.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new T.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new T.RawContextKey("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new T.RawContextKey("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new T.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new T.RawContextKey("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new T.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new T.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new T.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new T.RawContextKey("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new T.RawContextKey("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new T.RawContextKey("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.CONTEXT_BREAKPOINT_ITEM_IS_DATA_BYTES=new T.RawContextKey("breakpointItemBytes",void 0,{type:"boolean",description:O.localize(22,null)}),e.CONTEXT_BREAKPOINT_HAS_MODES=new T.RawContextKey("breakpointHasModes",!1,{type:"boolean",description:O.localize(23,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new T.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(24,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new T.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(25,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new T.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:O.localize(26,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new T.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(27,null)}),e.CONTEXT_FOCUSED_SESSION_IS_NO_DEBUG=new T.RawContextKey("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(28,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new T.RawContextKey("stepBackSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new T.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:O.localize(30,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new T.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(31,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new T.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new T.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(33,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new T.RawContextKey("breakpointsExist",!1,{type:"boolean",description:O.localize(34,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new T.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:O.localize(35,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new T.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(36,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new T.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(37,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new T.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.CONTEXT_SET_DATA_BREAKPOINT_BYTES_SUPPORTED=new T.RawContextKey("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new T.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new T.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new T.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new T.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new T.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(44,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new T.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(45,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new T.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(46,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new T.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:O.localize(47,null)}),e.CONTEXT_VARIABLE_VALUE=new T.RawContextKey("variableValue",!1,{type:"string",description:O.localize(48,null)}),e.CONTEXT_VARIABLE_TYPE=new T.RawContextKey("variableType",!1,{type:"string",description:O.localize(49,null)}),e.CONTEXT_VARIABLE_INTERFACES=new T.RawContextKey("variableInterfaces",!1,{type:"array",description:O.localize(50,null)}),e.CONTEXT_VARIABLE_NAME=new T.RawContextKey("variableName",!1,{type:"string",description:O.localize(51,null)}),e.CONTEXT_VARIABLE_LANGUAGE=new T.RawContextKey("variableLanguage",!1,{type:"string",description:O.localize(52,null)}),e.CONTEXT_VARIABLE_EXTENSIONID=new T.RawContextKey("variableExtensionId",!1,{type:"string",description:O.localize(53,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new T.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(54,null)}),e.CONTEXT_MULTI_SESSION_REPL=new T.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:O.localize(55,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new T.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:O.localize(56,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new T.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(57,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new T.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(58,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new T.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(59,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new T.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(60,null)});const R=n=>O.localize(61,null,n);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(62,null)};var m;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(m||(e.State=m={}));function h(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var y;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var L;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(L||(e.DataBreakpointSetType=L={}));var _;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(_||(e.DebugConfigurationProviderTriggerKind=_={}));var l;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(l||(e.DebuggerString=l={})),e.IDebugService=(0,N.createDecorator)("debugService");var w;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var g;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(g||(e.DebugVisualizationType=g={}));var r;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(r||(e.DebugTreeItemCollapsibleState=r={}));var o;(function(n){n.deserialize=i=>i,n.serialize=i=>i})(o||(e.IDebugVisualizationTreeItem=o={}));var s;(function(n){n.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:D.URI.revive(i.iconPath.light),dark:D.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),n.serialize=i=>i})(s||(e.IDebugVisualization=s={}))}),define(Pe[216],Te([1,0,15,2,19,26,12,29,24,18]),function(me,e,D,O,T,N,R,m,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sourcesEqual=void 0,e.formatPII=_,e.filterExceptionsFromTelemetry=l,e.isSessionAttach=w,e.getExtensionHostDebugSession=g,e.isDebuggerMainContribution=r,e.getExactExpressionStartAndEnd=o,e.getEvaluatableExpressionAtPosition=s,e.isUri=i,e.convertToDAPaths=t,e.convertToVSCPaths=E,e.getVisibleAndSorted=p,e.saveAllBeforeDebugStart=v;const L=/{([^}]+)}/g;function _(C,f,I){return C.replace(L,function(S,P){return f&&P.length>0&&P[0]!=="_"?S:I&&I.hasOwnProperty(P)?I[P]:S})}function l(C){const f={};for(const I of Object.keys(C))I.startsWith("!")||(f[I]=C[I]);return f}function w(C){return C.configuration.request==="attach"&&!g(C)&&(!C.parentSession||w(C.parentSession))}function g(C){let f=C.configuration.type;if(f)return f==="vslsShare"&&(f=C.configuration.adapterProxy.configuration.type),(0,D.equalsIgnoreCase)(f,"extensionhost")||(0,D.equalsIgnoreCase)(f,"pwa-extensionhost")?C:C.parentSession?g(C.parentSession):void 0}function r(C){return C.type&&(C.label||C.program||C.runtime)}function o(C,f,I){let S,P=0;const k=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let H=null;for(;H=k.exec(C);){const $=H.index+1,V=$+H[0].length;if($<=f&&V>=I){S=H[0],P=$;break}}if(S){const $=/\w+/g;let V=null;for(;(V=$.exec(S))&&!(V.index+1+P+V[0].length>=I););V&&(S=S.substring(0,$.lastIndex))}return S?{start:P,end:P+S.length-1}:{start:0,end:0}}async function s(C,f,I,S){if(C.evaluatableExpressionProvider.has(f)){const P=C.evaluatableExpressionProvider.ordered(f),k=(0,y.coalesce)(await Promise.all(P.map(async H=>{try{return await H.provideEvaluatableExpression(f,I,S??h.CancellationToken.None)}catch{return}})));if(k.length>0){let H=k[0].expression;const $=k[0].range;return H||(H=f.getLineContent(I.lineNumber).substring($.startColumn-1,$.endColumn-1)),{range:$,matchingExpression:H}}}else{const P=f.getLineContent(I.lineNumber),{start:k,end:H}=o(P,I.column,I.column),$=P.substring(k-1,H);return{matchingExpression:$,range:new m.Range(I.lineNumber,k,I.lineNumber,k+$.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(C){return!!(C&&C.match(n))}function a(C){if(typeof C.path=="string"&&!(typeof C.sourceReference=="number"&&C.sourceReference>0)){if(i(C.path))return O.URI.parse(C.path);if((0,T.isAbsolute)(C.path))return O.URI.file(C.path)}return C.path}function d(C){if(typeof C.path=="object"){const f=O.URI.revive(C.path);if(f)return f.scheme===R.Schemas.file?f.fsPath:f.toString()}return C.path}function t(C,f){const I=f?a:d,S=(0,N.deepClone)(C);return c(S,(P,k)=>{P&&k&&(k.path=I(k))}),S}function E(C,f){const I=f?a:d,S=(0,N.deepClone)(C);return c(S,(P,k)=>{!P&&k&&(k.path=I(k))}),S}function c(C,f){switch(C.type){case"event":{const I=C;switch(I.event){case"output":f(!1,I.body.source);break;case"loadedSource":f(!1,I.body.source);break;case"breakpoint":f(!1,I.body.breakpoint.source);break;default:break}break}case"request":{const I=C;switch(I.command){case"setBreakpoints":f(!0,I.arguments.source);break;case"breakpointLocations":f(!0,I.arguments.source);break;case"source":f(!0,I.arguments.source);break;case"gotoTargets":f(!0,I.arguments.source);break;case"launchVSCode":I.arguments.args.forEach(S=>f(!1,S));break;default:break}break}case"response":{const I=C;if(I.success&&I.body)switch(I.command){case"stackTrace":I.body.stackFrames.forEach(S=>f(!1,S.source));break;case"loadedSources":I.body.sources.forEach(S=>f(!1,S));break;case"scopes":I.body.scopes.forEach(S=>f(!1,S.source));break;case"setFunctionBreakpoints":I.body.breakpoints.forEach(S=>f(!1,S.source));break;case"setBreakpoints":I.body.breakpoints.forEach(S=>f(!1,S.source));break;case"disassemble":I.body?.instructions.forEach(P=>f(!1,P.location));break;default:break}break}}}function p(C){return C.filter(f=>!f.presentation?.hidden).sort((f,I)=>f.presentation?I.presentation?f.presentation.group?I.presentation.group?f.presentation.group!==I.presentation.group?f.presentation.group.localeCompare(I.presentation.group):b(f.presentation.order,I.presentation.order):-1:I.presentation.group?1:b(f.presentation.order,I.presentation.order):-1:I.presentation?1:0)}function b(C,f){return typeof C!="number"?typeof f!="number"?0:1:typeof f!="number"?-1:C-f}async function v(C,f){const I=C.getValue("debug.saveBeforeStart",{overrideIdentifier:f.activeTextEditorLanguageId});if(I!=="none"&&(await f.saveAll(),I==="allEditorsInActiveGroup")){const S=f.activeEditorPane;S&&S.input.resource?.scheme===R.Schemas.untitled&&await f.save({editor:S.input,groupId:S.group.id})}await C.reloadConfiguration()}const u=(C,f)=>!C||!f?C===f:C.name===f.name&&C.path===f.path&&C.sourceReference===f.sourceReference;e.sourcesEqual=u}),define(Pe[217],Te([1,0,3]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var O;(function(T){T[T.Output=1]="Output",T[T.OutputItems=2]="OutputItems",T[T.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.INotebookExecutionService=(0,D.createDecorator)("INotebookExecutionService")}),define(Pe[218],Te([1,0,3]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookKernelHistoryService=e.INotebookKernelService=e.ProxyKernelState=e.variablePageSize=void 0,e.variablePageSize=100;var O;(function(T){T[T.Disconnected=1]="Disconnected",T[T.Connected=2]="Connected",T[T.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.INotebookKernelService=(0,D.createDecorator)("INotebookKernelService"),e.INotebookKernelHistoryService=(0,D.createDecorator)("INotebookKernelHistoryService")}),define(Pe[219],Te([1,0,6,29,149,95]),function(me,e,D,O,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellSearchModel=void 0;class R extends D.Disposable{constructor(h,y,L){super(),this._source=h,this._inputTextBuffer=y,this._outputs=L,this._outputTextBuffers=void 0}_getFullModelRange(h){const y=h.getLineCount();return new O.Range(1,1,y,this._getLineMaxColumn(h,y))}_getLineMaxColumn(h,y){if(y<1||y>h.getLineCount())throw new Error("Illegal value for lineNumber");return h.getLineLength(y)+1}get inputTextBuffer(){if(!this._inputTextBuffer){const h=new T.PieceTreeTextBufferBuilder;h.acceptChunk(this._source);const y=h.finish(!0),{textBuffer:L,disposable:_}=y.create(1);this._inputTextBuffer=L,this._register(_)}return this._inputTextBuffer}get outputTextBuffers(){return this._outputTextBuffers||(this._outputTextBuffers=this._outputs.map(h=>{const y=new T.PieceTreeTextBufferBuilder;y.acceptChunk(h);const L=y.finish(!0),{textBuffer:_,disposable:l}=L.create(1);return this._register(l),_})),this._outputTextBuffers}findInInputs(h){const L=new N.SearchParams(h,!1,!1,null).parseSearchRequest();if(!L)return[];const _=this._getFullModelRange(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(_,L,!0,5e3)}findInOutputs(h){const L=new N.SearchParams(h,!1,!1,null).parseSearchRequest();return L?this.outputTextBuffers.map(_=>{const l=_.findMatchesLineByLine(this._getFullModelRange(_),L,!0,5e3);if(l.length!==0)return{textBuffer:_,matches:l}}).filter(_=>!!_):[]}}e.CellSearchModel=R}),define(Pe[49],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(N){N.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var O;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class T{static fromExtHostTestItem(R,m,h=R.parent){if(R._isRoot)return new T([m]);const y=[R.id];for(let L=h;L&&L.id!==m;L=L.parent)y.push(L.id);return y.push(m),new T(y.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const m=R.indexOf("\0");return m===-1?R:R.slice(0,m)}static fromString(R){return new T(R.split("\0"))}static join(R,m){return new T([...R.path,m])}static joinToString(R,m){return R.toString()+"\0"+m}static parentId(R){const m=R.lastIndexOf("\0");return m===-1?void 0:R.slice(0,m)}static localId(R){const m=R.lastIndexOf("\0");return m===-1?R:R.slice(m+1)}static isChild(R,m){return m.startsWith(R)&&m[R.length]==="\0"}static compare(R,m){return R===m?0:T.isChild(R,m)?2:T.isChild(m,R)?3:1}constructor(R,m=R.length){if(this.path=R,this.viewEnd=m,R.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new T(this.path,1)}get parentId(){return this.viewEnd>1?new T(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new T(this.path,R)}*idsToRoot(){for(let R=this.viewEnd;R>0;R--)yield new T(this.path,R)}compare(R){if(typeof R=="string")return T.compare(this.toString(),R);for(let m=0;m<R.viewEnd&&m<this.viewEnd;m++)if(R.path[m]!==this.path[m])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=T}),define(Pe[61],Te([1,0,2,93,29,49]),function(me,e,D,O,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.KEEP_N_LAST_COVERAGE_REPORTS=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.testResultStateToContextValues=e.TestResultState=void 0;var R;(function(A){A[A.Unset=0]="Unset",A[A.Queued=1]="Queued",A[A.Running=2]="Running",A[A.Passed=3]="Passed",A[A.Failed=4]="Failed",A[A.Skipped=5]="Skipped",A[A.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.testResultStateToContextValues={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var m;(function(A){A[A.Run=1]="Run",A[A.Debug=2]="Debug",A[A.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var h;(function(A){A[A.Run=2]="Run",A[A.Debug=4]="Debug",A[A.Coverage=8]="Coverage",A[A.HasNonDefaultProfile=16]="HasNonDefaultProfile",A[A.HasConfigurable=32]="HasConfigurable",A[A.SupportsContinuousRun=64]="SupportsContinuousRun"})(h||(e.TestRunProfileBitset=h={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const y=A=>"runId"in A;e.isStartControllerTests=y;var L;(function(A){A.serialize=U=>({range:U.range.toJSON(),uri:U.uri.toJSON()}),A.deserialize=(U,j)=>({range:T.Range.lift(j.range),uri:U.asCanonicalUri(D.URI.revive(j.uri))})})(L||(e.IRichLocation=L={}));var _;(function(A){A[A.Error=0]="Error",A[A.Output=1]="Output"})(_||(e.TestMessageType=_={}));var l;(function(A){A.serialize=U=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&L.serialize(U.location)}),A.deserialize=(U,j)=>({message:j.message,type:0,expected:j.expected,actual:j.actual,contextValue:j.contextValue,location:j.location&&L.deserialize(U,j.location)})})(l||(e.ITestErrorMessage=l={}));const w=(A,U)=>`${U?"s":"e"}${A}`;e.getMarkId=w;var g;(function(A){A.serialize=U=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&L.serialize(U.location)}),A.deserialize=(U,j)=>({message:j.message,type:1,offset:j.offset,length:j.length,location:j.location&&L.deserialize(U,j.location)})})(g||(e.ITestOutputMessage=g={}));var r;(function(A){A.serialize=U=>U.type===0?l.serialize(U):g.serialize(U),A.deserialize=(U,j)=>j.type===0?l.deserialize(U,j):g.deserialize(U,j)})(r||(e.ITestMessage=r={}));var o;(function(A){A.serializeWithoutMessages=U=>({state:U.state,duration:U.duration,messages:[]}),A.serialize=U=>({state:U.state,duration:U.duration,messages:U.messages.map(r.serialize)}),A.deserialize=(U,j)=>({state:j.state,duration:j.duration,messages:j.messages.map(ie=>r.deserialize(U,ie))})})(o||(e.ITestTaskState=o={}));const s="\0",n=(A,U)=>A+s+U;e.namespaceTestTag=n;const i=A=>{const U=A.indexOf(s);return{ctrlId:A.slice(0,U),tagId:A.slice(U+1)}};e.denamespaceTestTag=i;var a;(function(A){A.serialize=U=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?.toJSON(),range:U.range?.toJSON()||null,description:U.description,error:U.error,sortText:U.sortText}),A.deserialize=(U,j)=>({extId:j.extId,label:j.label,tags:j.tags,busy:j.busy,children:void 0,uri:j.uri?U.asCanonicalUri(D.URI.revive(j.uri)):void 0,range:j.range?T.Range.lift(j.range):null,description:j.description,error:j.error,sortText:j.sortText})})(a||(e.ITestItem=a={}));var d;(function(A){A[A.NotExpandable=0]="NotExpandable",A[A.Expandable=1]="Expandable",A[A.BusyExpanding=2]="BusyExpanding",A[A.Expanded=3]="Expanded"})(d||(e.TestItemExpandState=d={}));var t;(function(A){A.serialize=U=>({expand:U.expand,item:a.serialize(U.item)}),A.deserialize=(U,j)=>({controllerId:N.TestId.root(j.item.extId),expand:j.expand,item:a.deserialize(U,j.item)})})(t||(e.InternalTestItem=t={}));var E;(function(A){A.serialize=U=>{let j;return U.item&&(j={},U.item.label!==void 0&&(j.label=U.item.label),U.item.tags!==void 0&&(j.tags=U.item.tags),U.item.busy!==void 0&&(j.busy=U.item.busy),U.item.uri!==void 0&&(j.uri=U.item.uri?.toJSON()),U.item.range!==void 0&&(j.range=U.item.range?.toJSON()),U.item.description!==void 0&&(j.description=U.item.description),U.item.error!==void 0&&(j.error=U.item.error),U.item.sortText!==void 0&&(j.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:j}},A.deserialize=U=>{let j;return U.item&&(j={},U.item.label!==void 0&&(j.label=U.item.label),U.item.tags!==void 0&&(j.tags=U.item.tags),U.item.busy!==void 0&&(j.busy=U.item.busy),U.item.range!==void 0&&(j.range=U.item.range?T.Range.lift(U.item.range):null),U.item.description!==void 0&&(j.description=U.item.description),U.item.error!==void 0&&(j.error=U.item.error),U.item.sortText!==void 0&&(j.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:j}}})(E||(e.ITestItemUpdate=E={}));const c=(A,U)=>{U.expand!==void 0&&(A.expand=U.expand),U.item!==void 0&&(A.item=A.item?Object.assign(A.item,U.item):U.item)};e.applyTestItemUpdate=c;var p;(function(A){A.serializeWithoutMessages=U=>({...t.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(o.serializeWithoutMessages)}),A.serialize=U=>({...t.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(o.serialize)}),A.deserialize=(U,j)=>({...t.deserialize(U,j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(ie=>o.deserialize(U,ie)),retired:!0})})(p||(e.TestResultItem=p={}));var b;(function(A){A.empty=()=>({covered:0,total:0}),A.sum=(U,j)=>{U.covered+=j.covered,U.total+=j.total}})(b||(e.ICoverageCount=b={}));var v;(function(A){A.serialize=U=>({id:U.id,statement:U.statement,branch:U.branch,declaration:U.declaration,uri:U.uri.toJSON()}),A.deserialize=(U,j)=>({id:j.id,statement:j.statement,branch:j.branch,declaration:j.declaration,uri:U.asCanonicalUri(D.URI.revive(j.uri))})})(v||(e.IFileCoverage=v={}));function u(A){return{...A,location:A.location?.toJSON()}}function C(A){return A.location=A.location?O.Position.isIPosition(A.location)?O.Position.lift(A.location):T.Range.lift(A.location):void 0,A}e.KEEP_N_LAST_COVERAGE_REPORTS=3;var f;(function(A){A[A.Declaration=0]="Declaration",A[A.Statement=1]="Statement",A[A.Branch=2]="Branch"})(f||(e.DetailType=f={}));var I;(function(A){A.serialize=U=>U.type===0?P.serialize(U):k.serialize(U),A.deserialize=U=>U.type===0?P.deserialize(U):k.deserialize(U)})(I||(e.CoverageDetails=I={}));var S;(function(A){A.serialize=u,A.deserialize=C})(S||(e.IBranchCoverage=S={}));var P;(function(A){A.serialize=u,A.deserialize=C})(P||(e.IDeclarationCoverage=P={}));var k;(function(A){A.serialize=U=>({...u(U),branches:U.branches?.map(S.serialize)}),A.deserialize=U=>({...C(U),branches:U.branches?.map(S.deserialize)})})(k||(e.IStatementCoverage=k={}));var H;(function(A){A[A.Add=0]="Add",A[A.Update=1]="Update",A[A.DocumentSynced=2]="DocumentSynced",A[A.Remove=3]="Remove",A[A.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",A[A.Retire=5]="Retire",A[A.AddTag=6]="AddTag",A[A.RemoveTag=7]="RemoveTag"})(H||(e.TestDiffOpType=H={}));var $;(function(A){A.deserialize=(U,j)=>j.op===0?{op:j.op,item:t.deserialize(U,j.item)}:j.op===1?{op:j.op,item:E.deserialize(j.item)}:j.op===2?{op:j.op,uri:U.asCanonicalUri(D.URI.revive(j.uri)),docv:j.docv}:j,A.serialize=U=>U.op===0?{op:U.op,item:t.serialize(U.item)}:U.op===1?{op:U.op,item:E.serialize(U.item)}:U})($||(e.TestsDiffOp=$={}));class V{constructor(U){this.uriIdentity=U,this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(U){const j=this.createChangeCollector();for(const ie of U)switch(ie.op){case 0:this.add(t.deserialize(this.uriIdentity,ie.item),j);break;case 1:this.update(E.deserialize(ie.item),j);break;case 3:this.remove(ie.itemId,j);break;case 5:this.retireTest(ie.itemId);break;case 4:this.updatePendingRoots(ie.amount);break;case 6:this._tags.set(ie.tag.id,ie.tag);break;case 7:this._tags.delete(ie.id);break}j.complete?.()}add(U,j){const ie=N.TestId.parentId(U.item.extId)?.toString();let fe;if(!ie)fe=this.createItem(U),this.roots.add(fe),this.items.set(U.item.extId,fe);else if(this.items.has(ie)){const Ce=this.items.get(ie);Ce.children.add(U.item.extId),fe=this.createItem(U,Ce),this.items.set(U.item.extId,fe)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(U)}`);return}return j.add?.(fe),U.expand===2&&this.busyControllerCount++,fe}update(U,j){const ie=this.items.get(U.extId);if(ie)return U.expand!==void 0&&(ie.expand===2&&this.busyControllerCount--,U.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(ie,U),j.update?.(ie),ie}remove(U,j){const ie=this.items.get(U);if(!ie)return;const fe=N.TestId.parentId(ie.item.extId)?.toString();fe?this.items.get(fe).children.delete(ie.item.extId):this.roots.delete(ie);const Ce=[[U]];for(;Ce.length;)for(const _e of Ce.pop()){const oe=this.items.get(_e);oe&&(Ce.push(oe.children),this.items.delete(_e),j.remove?.(oe,oe!==ie),oe.expand===2&&this.busyControllerCount--)}}retireTest(U){}updatePendingRoots(U){this.pendingRootCount+=U}createChangeCollector(){return{}}}e.AbstractIncrementalTestCollection=V}),define(Pe[75],Te([1,0,11,5,6,56,61,49]),function(me,e,D,O,T,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var h;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(h||(e.TestItemEventOp=h={}));const y=(n,i)=>n===i,_=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:y,label:y,description:y,error:y,sortText:y,tags:(n,i)=>!(n.length!==i.length||n.some(a=>!i.includes(a)))}),l=(n,i)=>{let a;for(const[d,t]of _)t(n[d],i[d])||(a?a[d]=i[d]:a={[d]:i[d]});return a};class w extends T.Disposable{get root(){return this.options.root}constructor(i){super(),this.options=i,this.debounceSendDiff=this._register(new D.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new O.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(i){this._resolveHandler=i;for(const a of this.tree.values())this.updateExpandability(a)}get resolveHandler(){return this._resolveHandler}collectDiff(){const i=this.diff;return this.diff=[],i}pushDiff(i){switch(i.op){case 2:{for(const a of this.diff)if(a.op===2&&a.uri===i.uri){a.docv=i.docv;return}break}case 1:{const a=this.diff[this.diff.length-1];if(a){if(a.op===1&&a.item.extId===i.item.extId){(0,R.applyTestItemUpdate)(a.item,i.item);return}if(a.op===0&&a.item.item.extId===i.item.extId){(0,R.applyTestItemUpdate)(a.item,i.item);return}}break}}this.diff.push(i),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(i,a){const d=this.tree.get(i);if(d){if((d.expandLevels===void 0||a>d.expandLevels)&&(d.expandLevels=a),d.expand===1){const t=this.resolveChildren(d);return t.isOpen()?this.expandChildren(d,a-1):t.wait().then(()=>this.expandChildren(d,a-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.expandChildren(d,a-1)):this.expandChildren(d,a-1)}}dispose(){for(const i of this.tree.values())this.options.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(i,a){switch(a.op){case 3:this.removeItem(m.TestId.joinToString(i.fullId,a.id));break;case 0:this.upsertItem(a.item,i);break;case 5:for(const d of a.ops)this.onTestItemEvent(i,d);break;case 1:this.diffTagRefs(a.new,a.old,i.fullId.toString());break;case 2:this.updateExpandability(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:a.update}});break;case 6:this.documentSynced(i.actual.uri);break;default:(0,N.assertNever)(a)}}documentSynced(i){i&&this.pushDiff({op:2,uri:i,docv:this.options.getDocumentVersion(i)})}upsertItem(i,a){const d=m.TestId.fromExtHostTestItem(i,this.root.id,a?.actual),t=this.options.getApiFor(i);t.parent&&t.parent!==a?.actual&&this.options.getChildren(t.parent).delete(i.id);let E=this.tree.get(d.toString());if(!E){E={fullId:d,actual:i,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},i.tags.forEach(this.incrementTagRefs,this),this.tree.set(E.fullId.toString(),E),this.setItemParent(i,a),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:E.expand,item:this.options.toITestItem(i)}}),this.connectItemAndChildren(i,E,a);return}if(E.actual===i){this.connectItem(i,E,a);return}if(E.actual.uri?.toString()!==i.uri?.toString())return this.removeItem(d.toString()),this.upsertItem(i,a);const c=this.options.getChildren(E.actual),p=E.actual,b=l(this.options.toITestItem(p),this.options.toITestItem(i));this.options.getApiFor(p).listener=void 0,E.actual=i,E.expand=0,b&&(b.hasOwnProperty("tags")&&(this.diffTagRefs(i.tags,p.tags,d.toString()),delete b.tags),this.onTestItemEvent(E,{op:4,update:b})),this.connectItemAndChildren(i,E,a);for(const[v,u]of c)this.options.getChildren(i).get(u.id)||this.removeItem(m.TestId.joinToString(d,u.id));this.documentSynced(E.actual.uri)}diffTagRefs(i,a,d){const t=new Set(a.map(E=>E.id));for(const E of i)t.delete(E.id)||this.incrementTagRefs(E);this.pushDiff({op:1,item:{extId:d,item:{tags:i.map(E=>(0,R.namespaceTestTag)(this.options.controllerId,E.id))}}}),t.forEach(this.decrementTagRefs,this)}incrementTagRefs(i){const a=this.tags.get(i.id);a?a.refCount++:(this.tags.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.namespaceTestTag)(this.options.controllerId,i.id)}}))}decrementTagRefs(i){const a=this.tags.get(i);a&&!--a.refCount&&(this.tags.delete(i),this.pushDiff({op:7,id:(0,R.namespaceTestTag)(this.options.controllerId,i)}))}setItemParent(i,a){this.options.getApiFor(i).parent=a&&a.actual!==this.root?a.actual:void 0}connectItem(i,a,d){this.setItemParent(i,d);const t=this.options.getApiFor(i);t.parent=d?.actual,t.listener=E=>this.onTestItemEvent(a,E),this.updateExpandability(a)}connectItemAndChildren(i,a,d){this.connectItem(i,a,d);for(const[t,E]of this.options.getChildren(i))this.upsertItem(E,a)}updateExpandability(i){let a;this._resolveHandler?i.resolveBarrier?a=i.resolveBarrier.isOpen()?3:2:a=i.actual.canResolveChildren?1:0:a=0,a!==i.expand&&(i.expand=a,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:a}}),a===1&&i.expandLevels!==void 0&&this.resolveChildren(i))}expandChildren(i,a){if(a<0)return;const d=[];for(const[t,E]of this.options.getChildren(i.actual)){const c=this.expand(m.TestId.joinToString(i.fullId,E.id),a);(0,D.isThenable)(c)&&d.push(c)}if(d.length)return Promise.all(d).then(()=>{})}resolveChildren(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this._resolveHandler){const E=new D.Barrier;return E.open(),E}i.expand=2,this.pushExpandStateUpdate(i);const a=i.resolveBarrier=new D.Barrier,d=E=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,E)};let t;try{t=this._resolveHandler(i.actual===this.root?void 0:i.actual)}catch(E){d(E)}return(0,D.isThenable)(t)?t.catch(d).then(()=>{a.open(),this.updateExpandability(i)}):(a.open(),this.updateExpandability(i)),i.resolveBarrier}pushExpandStateUpdate(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}removeItem(i){const a=this.tree.get(i);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const d=[a];for(;d.length;){const t=d.pop();if(t){this.options.getApiFor(t.actual).listener=void 0;for(const E of t.actual.tags)this.decrementTagRefs(E.id);this.tree.delete(t.fullId.toString());for(const[E,c]of this.options.getChildren(t.actual))d.push(this.tree.get(m.TestId.joinToString(t.fullId,c.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.diffOpEmitter.fire(i)}}e.TestItemCollection=w;class g extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.DuplicateTestItemError=g;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=r;class o extends Error{constructor(i,a,d){super(`TestItem with ID "${i}" is from controller "${a}" and cannot be added as a child of an item from controller "${d}".`)}}e.MixedTestItemController=o;const s=(n,i,a)=>{let d=new Map;return{get size(){return d.size},forEach(t,E){for(const c of d.values())t.call(E,c,this)},[Symbol.iterator](){return d.entries()},replace(t){const E=new Map,c=new Set(d.keys()),p={op:5,ops:[]};for(const b of t){if(!(b instanceof a))throw new r(b.id);const v=i(b).controllerId;if(v!==n.controllerId)throw new o(b.id,v,n.controllerId);if(E.has(b.id))throw new g(b.id);E.set(b.id,b),c.delete(b.id),p.ops.push({op:0,item:b})}for(const b of c.keys())p.ops.push({op:3,id:b});n.listener?.(p),d=E},add(t){if(!(t instanceof a))throw new r(t.id);d.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){d.delete(t)&&n.listener?.({op:3,id:t})},get(t){return d.get(t)},toJSON(){return Array.from(d.values())}}};e.createTestItemChildren=s}),define(Pe[105],Te([1,0,75]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const O=new WeakMap,T=(R,m)=>{const h={controllerId:m};return O.set(R,h),h};e.createPrivateApiFor=T;const N=R=>{const m=O.get(R);if(!m)throw new D.InvalidTestItemError(R?.id||"<unknown>");return m};e.getPrivateApiFor=N}),define(Pe[76],Te([1,0,12,2]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.asWebviewUri=T,e.decodeAuthority=R,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function T(m,h){return m.scheme===D.Schemas.http||m.scheme===D.Schemas.https?m:(h&&h.authority&&h.isRemote&&m.scheme===D.Schemas.file&&(m=O.URI.from({scheme:D.Schemas.vscodeRemote,authority:h.authority,path:m.path})),O.URI.from({scheme:D.Schemas.https,authority:`${m.scheme}+${N(m.authority)}.${e.webviewRootResourceAuthority}`,path:m.path,fragment:m.fragment,query:m.query}))}function N(m){return m.replace(/./g,h=>{const y=h.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?h:"-"+y.toString(16).padStart(4,"0")})}function R(m){return m.replace(/-([0-9a-f]{4})/g,(h,y)=>String.fromCharCode(parseInt(y,16)))}}),define(Pe[220],Te([1,0,5,6,76]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class N{constructor(m,h,y){this._proxy=m,this._editors=h,this._remoteInfo=y,this._handlePool=0,this._disposables=new O.DisposableStore,this._insets=new Map,this._disposables.add(h.onDidChangeVisibleTextEditors(()=>{const L=h.getVisibleTextEditors();for(const _ of this._insets.values())L.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(m=>m.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(m,h,y,L,_){let l;for(const i of this._editors.getVisibleTextEditors(!0))if(i.value===m){l=i;break}if(!l)throw new Error("not a visible editor");const w=this,g=this._handlePool++,r=new D.Emitter,o=new D.Emitter,s=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(i){return(0,T.asWebviewUri)(i,w._remoteInfo)}get cspSource(){return T.webviewGenericCspSource}set options(i){this._options=i,w._proxy.$setOptions(g,i)}get options(){return this._options}set html(i){this._html=i,w._proxy.$setHtml(g,i)}get html(){return this._html}get onDidReceiveMessage(){return r.event}postMessage(i){return w._proxy.$postMessage(g,i)}},n=new class{constructor(){this.editor=m,this.line=h,this.height=y,this.webview=s,this.onDidDispose=o.event}dispose(){w._insets.has(g)&&(w._insets.delete(g),w._proxy.$disposeEditorInset(g),o.fire(),o.dispose(),r.dispose())}};return this._proxy.$createEditorInset(g,l.id,l.value.document.uri,h+1,y,L||{},_.identifier,_.extensionLocation),this._insets.set(g,{editor:m,inset:n,onDidReceiveMessage:r}),n}$onDidDispose(m){const h=this._insets.get(m);h&&h.inset.dispose()}$onDidReceiveMessage(m,h){this._insets.get(m)?.onDidReceiveMessage.fire(h)}}e.ExtHostEditorInsets=N}),define(Pe[106],Te([1,0,3]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IAuthenticationExtensionsService=e.IAuthenticationService=e.INTERNAL_AUTH_PROVIDER_PREFIX=void 0,e.INTERNAL_AUTH_PROVIDER_PREFIX="__",e.IAuthenticationService=(0,D.createDecorator)("IAuthenticationService"),e.IAuthenticationExtensionsService=(0,D.createDecorator)("IAuthenticationExtensionsService")}),define(Pe[221],Te([1,0,3]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,D.createDecorator)("configurationResolverService");var O;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator",N.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class T extends Error{constructor(R,m){super(m),this.variable=R}}e.VariableError=T}),define(Pe[222],Te([1,0,19,73,17,26,21,96,183,221,15]),function(me,e,D,O,T,N,R,m,h,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class _{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(w,g,r,o){this._contributedVariables=new Map,this._context=w,this._labelService=g,this._userHomePromise=r,o&&(this._envVariablesPromise=o.then(s=>this.prepareEnv(s)))}prepareEnv(w){if(R.isWindows){const g=Object.create(null);return Object.keys(w).forEach(r=>{g[r.toLowerCase()]=w[r]}),g}return w}resolveWithEnvironment(w,g,r){return this.recursiveResolve({env:this.prepareEnv(w),userHome:void 0},g?g.uri:void 0,r)}async resolveAsync(w,g){const r={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(r,w?w.uri:void 0,g)}async resolveAnyBase(w,g,r,o){const s=N.deepClone(g);R.isWindows&&s.windows?Object.keys(s.windows).forEach(i=>s[i]=s.windows[i]):R.isMacintosh&&s.osx?Object.keys(s.osx).forEach(i=>s[i]=s.osx[i]):R.isLinux&&s.linux&&Object.keys(s.linux).forEach(i=>s[i]=s.linux[i]),delete s.windows,delete s.osx,delete s.linux;const n={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(n,w?w.uri:void 0,s,r,o)}async resolveAnyAsync(w,g,r){return this.resolveAnyBase(w,g,r)}async resolveAnyMap(w,g,r){const o=new Map;return{newConfig:await this.resolveAnyBase(w,g,r,o),resolvedVariables:o}}resolveWithInteractionReplace(w,g,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,g,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,g){if(this._contributedVariables.has(w))throw new Error("Variable "+w+" is contributed twice.");this._contributedVariables.set(w,g)}async recursiveResolve(w,g,r,o,s){if(T.isString(r))return this.resolveString(w,g,r,o,s);if(Array.isArray(r))return Promise.all(r.map(n=>this.recursiveResolve(w,g,n,o,s)));if(T.isObject(r)){const n=Object.create(null),i=await Promise.all(Object.keys(r).map(async a=>[await this.resolveString(w,g,a,o,s),await this.recursiveResolve(w,g,r[a],o,s)]));for(const[a,d]of i)n[a]=d;return n}return r}resolveString(w,g,r,o,s){return(0,L.replaceAsync)(r,_.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(_.VARIABLE_LHS))return n;let a=await this.evaluateSingleVariable(w,n,i,g,o);return s?.set(i,a),a!==n&&T.isString(a)&&a.match(_.VARIABLE_REGEXP)&&(a=await this.resolveString(w,g,a,o,s)),a})}fsPath(w){return this._labelService?this._labelService.getUriLabel(w,{noPrefix:!0}):w.fsPath}async evaluateSingleVariable(w,g,r,o,s){let n;const i=r.split(":");i.length>1&&(r=i[0],n=i[1]);const a=E=>{const c=this._context.getFilePath();if(c)return(0,m.normalizeDriveLetter)(c);throw new y.VariableError(E,(0,h.localize)(0,null,g))},d=E=>{const c=a(E);if(this._context.getWorkspaceFolderPathForFile){const p=this._context.getWorkspaceFolderPathForFile();if(p)return(0,m.normalizeDriveLetter)(p)}throw new y.VariableError(E,(0,h.localize)(1,null,g,D.basename(c)))},t=E=>{if(n){const c=this._context.getFolderUri(n);if(c)return c;throw new y.VariableError(E,(0,h.localize)(2,null,g,n))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new y.VariableError(E,(0,h.localize)(3,null,g)):new y.VariableError(E,(0,h.localize)(4,null,g))};switch(r){case"env":if(n){if(w.env){const E=w.env[R.isWindows?n.toLowerCase():n];if(T.isString(E))return E}return""}throw new y.VariableError(y.VariableKind.Env,(0,h.localize)(5,null,g));case"config":if(n){const E=this._context.getConfigurationValue(o,n);if(T.isUndefinedOrNull(E))throw new y.VariableError(y.VariableKind.Config,(0,h.localize)(6,null,g,n));if(T.isObject(E))throw new y.VariableError(y.VariableKind.Config,(0,h.localize)(7,null,g,n));return E}throw new y.VariableError(y.VariableKind.Config,(0,h.localize)(8,null,g));case"command":return this.resolveFromMap(y.VariableKind.Command,g,n,s,"command");case"input":return this.resolveFromMap(y.VariableKind.Input,g,n,s,"input");case"extensionInstallFolder":if(n){const E=await this._context.getExtension(n);if(!E)throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,h.localize)(9,null,g,n));return this.fsPath(E.extensionLocation)}throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,h.localize)(10,null,g));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,m.normalizeDriveLetter)(this.fsPath(t(y.VariableKind.WorkspaceFolder)));case"cwd":return o||n?(0,m.normalizeDriveLetter)(this.fsPath(t(y.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.normalizeDriveLetter)(D.basename(this.fsPath(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new y.VariableError(y.VariableKind.UserHome,(0,h.localize)(11,null,g))}case"lineNumber":{const E=this._context.getLineNumber();if(E)return E;throw new y.VariableError(y.VariableKind.LineNumber,(0,h.localize)(12,null,g))}case"selectedText":{const E=this._context.getSelectedText();if(E)return E;throw new y.VariableError(y.VariableKind.SelectedText,(0,h.localize)(13,null,g))}case"file":return a(y.VariableKind.File);case"fileWorkspaceFolder":return d(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.basename(d(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||n?D.relative(this.fsPath(t(y.VariableKind.RelativeFile)),a(y.VariableKind.RelativeFile)):a(y.VariableKind.RelativeFile);case"relativeFileDirname":{const E=D.dirname(a(y.VariableKind.RelativeFileDirname));if(o||n){const c=D.relative(this.fsPath(t(y.VariableKind.RelativeFileDirname)),E);return c.length===0?".":c}return E}case"fileDirname":return D.dirname(a(y.VariableKind.FileDirname));case"fileExtname":return D.extname(a(y.VariableKind.FileExtname));case"fileBasename":return D.basename(a(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const E=D.basename(a(y.VariableKind.FileBasenameNoExtension));return E.slice(0,E.length-D.extname(E).length)}case"fileDirnameBasename":return D.basename(D.dirname(a(y.VariableKind.FileDirnameBasename)));case"execPath":{const E=this._context.getExecPath();return E||g}case"execInstallFolder":{const E=this._context.getAppRoot();return E||g}case"pathSeparator":case"/":return D.sep;default:try{const E=n?`${r}:${n}`:r;return this.resolveFromMap(y.VariableKind.Unknown,g,E,s,void 0)}catch{return g}}}}resolveFromMap(w,g,r,o,s){if(r&&o){const n=s===void 0?o[r]:o[s+":"+r];if(typeof n=="string")return n;throw new y.VariableError(w,(0,h.localize)(14,null,g))}return g}}e.AbstractVariableResolverService=_}),define(Pe[107],Te([1,0,3,104]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.isEditorReplacement=y,e.isEditorGroup=l,e.preferredSideBySideGroupDirection=w,e.IEditorGroupsService=(0,D.createDecorator)("editorGroupsService");var T;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(T||(e.GroupDirection=T={}));var N;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var R;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var m;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EXPAND=1]="EXPAND",g[g.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var h;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(h||(e.MergeGroupMode=h={}));function y(g){const r=g;return(0,O.isEditorInput)(r?.editor)&&(0,O.isEditorInput)(r?.replacement)}var L;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L||(e.GroupsOrder=L={}));var _;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(_||(e.OpenEditorContext=_={}));function l(g){const r=g;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function w(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Pe[223],Te([1,0,3,107]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AUX_WINDOW_GROUP=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.isPreferredGroup=T,e.IEditorService=(0,D.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2,e.AUX_WINDOW_GROUP=-3;function T(N){const R=N;return typeof N=="number"||(0,O.isEditorGroup)(R)}}),define(Pe[224],Te([1,0,3,190]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,D.refineServiceDecorator)(O.IEnvironmentService)}),define(Pe[108],Te([1,0,20,5,19,6,11]),function(me,e,D,O,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.ExtensionDescriptionRegistrySnapshot=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class m{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.DeltaExtensionsResult=m;class h{static isHostExtension(n,i,a){if(i.getExtensionDescription(n))return!1;const d=a.getExtensionDescription(n);return d?!!((d.main||d.browser)&&d.api==="none"):!1}constructor(n,i){this._activationEventsReader=n,this._onDidChange=new O.Emitter,this.onDidChange=this._onDidChange.event,this._versionId=0,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(r),this._extensionsMap=new D.ExtensionIdentifierMap,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this._extensionsMap.set(n.identifier,n),this._extensionsArr.push(n);const i=this._activationEventsReader.readActivationEvents(n);for(const a of i)this._activationMap.has(a)||this._activationMap.set(a,[]),this._activationMap.get(a).push(n)}}set(n){return this._extensionDescriptions=n,this._initialize(),this._versionId++,this._onDidChange.fire(void 0),{versionId:this._versionId}}deltaExtensions(n,i){this._extensionDescriptions=o(this._extensionDescriptions,i),this._extensionDescriptions=this._extensionDescriptions.concat(n);const a=h._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=o(this._extensionDescriptions,a.map(d=>d.identifier)),this._initialize(),this._versionId++,this._onDidChange.fire(void 0),new m(this._versionId,a)}static _findLoopingExtensions(n){const i=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(c){this._nodesSet.has(c)||(this._nodesSet.add(c),this._nodesArr.push(c))}addArc(c,p){this.addNode(c),this.addNode(p),this._arcs.has(c)?this._arcs.get(c).push(p):this._arcs.set(c,[p])}getArcs(c){return this._arcs.has(c)?this._arcs.get(c):[]}hasOnlyGoodArcs(c,p){const b=i.getArcs(c);for(let v=0;v<b.length;v++)if(!p.has(b[v]))return!1;return!0}getNodes(){return this._nodesArr}},a=new D.ExtensionIdentifierMap;for(const c of n)if(a.set(c.identifier,c),c.extensionDependencies)for(const p of c.extensionDependencies)i.addArc(D.ExtensionIdentifier.toKey(c.identifier),D.ExtensionIdentifier.toKey(p));const d=new Set;i.getNodes().filter(c=>i.getArcs(c).length===0).forEach(c=>d.add(c));const t=i.getNodes().filter(c=>!d.has(c));let E;do{E=!1;for(let c=0;c<t.length;c++){const p=t[c];i.hasOnlyGoodArcs(p,d)&&(t.splice(c,1),c--,d.add(p),E=!0)}}while(E);return t.map(c=>a.get(c))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this._activationMap.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getSnapshot(){return new y(this._versionId,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this._extensionsMap.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this._extensionsArr)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.ExtensionDescriptionRegistry=h;class y{constructor(n,i){this.versionId=n,this.extensions=i}}e.ExtensionDescriptionRegistrySnapshot=y;class L{constructor(n){this._lock=new w,this._actual=new h(n,[])}async acquireLock(n){const i=await this._lock.acquire(n);return new _(this,i)}deltaExtensions(n,i,a){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this._actual.deltaExtensions(i,a)}containsActivationEvent(n){return this._actual.containsActivationEvent(n)}containsExtension(n){return this._actual.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this._actual.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this._actual.getAllExtensionDescriptions()}getSnapshot(){return this._actual.getSnapshot()}getExtensionDescription(n){return this._actual.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this._actual.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this._actual.getExtensionDescriptionByIdOrUUID(n,i)}}e.LockableExtensionDescriptionRegistry=L;class _ extends N.Disposable{constructor(n,i){super(),this._registry=n,this._isDisposed=!1,this._register(i)}isAcquiredFor(n){return!this._isDisposed&&this._registry===n}}e.ExtensionDescriptionRegistryLock=_;class l{constructor(n){this.name=n;const i=(0,R.promiseWithResolvers)();this.promise=i.promise,this._resolve=i.resolve}resolve(n){this._resolve(n)}}class w{constructor(){this._pendingCustomers=[],this._isLocked=!1}async acquire(n){const i=new l(n);return this._pendingCustomers.push(i),this._advance(),i.promise}_advance(){if(this._isLocked||this._pendingCustomers.length===0)return;const n=this._pendingCustomers.shift();this._isLocked=!0;let i=!0;const a=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),d=()=>{i&&(clearTimeout(a),i=!1,this._isLocked=!1,this._advance())};n.resolve((0,N.toDisposable)(d))}}var g;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(g||(g={}));function r(s,n){const i=s.isBuiltin?0:s.isUnderDevelopment?2:1,a=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==a)return i-a;const d=T.posix.basename(s.extensionLocation.path),t=T.posix.basename(n.extensionLocation.path);return d<t?-1:d>t?1:0}function o(s,n){const i=new D.ExtensionIdentifierSet(n);return s.filter(a=>!i.has(a.identifier))}}),define(Pe[77],Te([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.createMessageOfType=R,e.isMessageOfType=m;var O;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(O||(e.UIKind=O={}));var T;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(T||(e.ExtensionHostExitCode=T={}));var N;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function R(y){const L=D.VSBuffer.alloc(1);switch(y){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}function m(y,L){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}var h;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})(h||(e.NativeLogMarkers=h={}))}),define(Pe[62],Te([1,0,3,5,13,27,77,58,59,26,2,6,171]),function(me,e,D,O,T,N,R,m,h,y,L,_,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0,e.isNewAppInstall=r;let w=class extends _.Disposable{constructor(s,n){super(),this.initData=s,this.loggerService=n,this._onDidChangeTelemetryEnabled=this._register(new O.Emitter),this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=this._register(new O.Emitter),this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryIsSupported=!1,this._inLoggingOnlyMode=!1,this._telemetryLoggers=new Map,this.extHostTelemetryLogFile=L.URI.revive(this.initData.environment.extensionTelemetryLogResource),this._inLoggingOnlyMode=this.initData.environment.isExtensionTelemetryLoggingOnly,this._outputLogger=n.createLogger(this.extHostTelemetryLogFile,{id:h.extensionTelemetryLogChannelId,name:(0,l.localize)(0,null,this._inLoggingOnlyMode?" (Not Sent)":""),hidden:!0}),this._register(this._outputLogger),this._register(n.onDidChangeLogLevel(i=>{(0,T.isLogLevel)(i)&&this.updateLoggerVisibility()})),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}updateLoggerVisibility(){this.loggerService.setVisibility(this.extHostTelemetryLogFile,this._telemetryIsSupported&&this.loggerService.getLogLevel()===T.LogLevel.Trace)}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(s,n,i){const a=this.getTelemetryDetails(),d=new g(n,i,s,this._outputLogger,this._inLoggingOnlyMode,this.getBuiltInCommonProperties(s),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),t=this._telemetryLoggers.get(s.identifier.value)??[];return this._telemetryLoggers.set(s.identifier.value,[...t,d]),d.apiTelemetryLogger}$initializeTelemetryLevel(s,n,i){this._level=s,this._telemetryIsSupported=n,this._productConfig=i??{usage:!0,error:!0},this.updateLoggerVisibility()}getBuiltInCommonProperties(s){const n=Object.create(null);switch(n["common.extname"]=`${s.publisher}.${s.name}`,n["common.extversion"]=s.version,n["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,n["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,n["common.sqmid"]=this.initData.telemetryInfo.sqmId,n["common.vscodeversion"]=this.initData.version,n["common.isnewappinstall"]=r(this.initData.telemetryInfo.firstSessionDate),n["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,m.getRemoteName)((0,h.cleanRemoteAuthority)(this.initData.remote.authority)),n}$onDidChangeTelemetryLevel(s){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=s;const n=this.getTelemetryDetails();this._telemetryLoggers.forEach((i,a)=>{const d=i.filter(t=>!t.isDisposed);d.length===0?this._telemetryLoggers.delete(a):this._telemetryLoggers.set(a,d)}),this._telemetryLoggers.forEach(i=>{for(const a of i)a.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails()),this.updateLoggerVisibility()}onExtensionError(s,n){const a=this._telemetryLoggers.get(s.value)?.filter(t=>!t.isDisposed);if(!a)return this._telemetryLoggers.delete(s.value),!1;let d=!1;for(const t of a)t.ignoreUnhandledExtHostErrors||(t.logError(n),d=!0);return d}};e.ExtHostTelemetry=w,e.ExtHostTelemetry=w=Ke([He(0,N.IExtHostInitDataService),He(1,T.ILoggerService)],w);class g{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,n,i,a,d,t,E){this._extension=i,this._logger=a,this._inLoggingOnlyMode=d,this._commonProperties=t,this._onDidChangeEnableStates=new O.Emitter,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this._ignoreBuiltinCommonProperties=n?.ignoreBuiltInCommonProperties??!1,this._additionalCommonProperties=n?.additionalCommonProperties,this._sender=s,this._telemetryEnablements={isUsageEnabled:E.isUsageEnabled,isErrorsEnabled:E.isErrorsEnabled}}updateTelemetryEnablements(s,n){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:s,isErrorsEnabled:n},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(s){let n="properties"in s?s.properties??{}:s;return n=(0,h.cleanData)(n,[]),this._additionalCommonProperties&&(n=(0,y.mixin)(n,this._additionalCommonProperties)),this._ignoreBuiltinCommonProperties||(n=(0,y.mixin)(n,this._commonProperties)),"properties"in s?s.properties=n:s=n,s}logEvent(s,n){this._sender&&(this._extension.publisher==="vscode"?s=this._extension.name+"/"+s:s=this._extension.identifier.value+"/"+s,n=this.mixInCommonPropsAndCleanData(n||{}),this._inLoggingOnlyMode||this._sender?.sendEventData(s,n),this._logger.trace(s,n))}logUsage(s,n){this._telemetryEnablements.isUsageEnabled&&this.logEvent(s,n)}logError(s,n){if(!(!this._telemetryEnablements.isErrorsEnabled||!this._sender))if(typeof s=="string")this.logEvent(s,n);else{const i={name:s.name,message:s.message,stack:s.stack,cause:s.cause},a=(0,h.cleanData)(i,[]),d=new Error(a.message,{cause:a.cause});d.stack=a.stack,d.name=a.name,n=this.mixInCommonPropsAndCleanData(n||{}),this._inLoggingOnlyMode||this._sender.sendErrorData(d,n),this._logger.trace("exception",n)}}get apiTelemetryLogger(){if(!this._apiObject){const s=this,n={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return s._telemetryEnablements.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s._onDidChangeEnableStates.event.bind(s)};this._apiObject=Object.freeze(n)}return this._apiObject}get isDisposed(){return!this._sender}dispose(){if(this._sender?.flush){let s=this._sender;this._sender=void 0,Promise.resolve(s.flush()).then(s=void 0),this._apiObject=void 0}else this._sender=void 0}}e.ExtHostTelemetryLogger=g;function r(o){const s=Date.now()-new Date(o).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.IExtHostTelemetry=(0,D.createDecorator)("IExtHostTelemetry")}),define(Pe[25],Te([1,0,5,2,199,103,20,3]),function(me,e,D,O,T,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.isProposedApiEnabled=l,e.checkProposedApiEnabled=w,e.toExtension=s,e.toExtensionDescription=n,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,m.createDecorator)("extensionService");class h{constructor(d){this.dependency=d}}e.MissingExtensionDependency=h;var y;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class L{get versionId(){return this._versionId}get allExtensions(){return this._allExtensions}get myExtensions(){return this._myExtensions}constructor(d,t,E){this._versionId=d,this._allExtensions=t.slice(0),this._myExtensions=E.slice(0),this._myActivationEvents=null}toSnapshot(){return{versionId:this._versionId,allExtensions:this._allExtensions,myExtensions:this._myExtensions,activationEvents:N.ImplicitActivationEvents.createActivationEventsMap(this._allExtensions)}}set(d,t,E){if(this._versionId>d)throw new Error(`ExtensionHostExtensions: invalid versionId ${d} (current: ${this._versionId})`);const c=[],p=[],b=[],v=[],u=_(this._allExtensions),C=_(t),f=(H,$)=>H.extensionLocation.toString()===$.extensionLocation.toString()||H.isBuiltin===$.isBuiltin||H.isUserBuiltin===$.isUserBuiltin||H.isUnderDevelopment===$.isUnderDevelopment;for(const H of this._allExtensions){const $=C.get(H.identifier);if(!$){c.push(H.identifier),u.delete(H.identifier);continue}if(!f(H,$)){c.push(H.identifier),u.delete(H.identifier);continue}}for(const H of t){const $=u.get(H.identifier);if(!$){p.push(H);continue}if(!f($,H)){c.push($.identifier),u.delete($.identifier);continue}}const I=new R.ExtensionIdentifierSet(this._myExtensions),S=new R.ExtensionIdentifierSet(E);for(const H of this._myExtensions)S.has(H)||b.push(H);for(const H of E)I.has(H)||v.push(H);const P=N.ImplicitActivationEvents.createActivationEventsMap(p),k={versionId:d,toRemove:c,toAdd:p,addActivationEvents:P,myToRemove:b,myToAdd:v};return this.delta(k),k}delta(d){if(this._versionId>=d.versionId)return null;const{toRemove:t,toAdd:E,myToRemove:c,myToAdd:p}=d,b=new R.ExtensionIdentifierSet(t),v=new R.ExtensionIdentifierSet(c);for(let u=0;u<this._allExtensions.length;u++)b.has(this._allExtensions[u].identifier)&&(this._allExtensions.splice(u,1),u--);for(let u=0;u<this._myExtensions.length;u++)v.has(this._myExtensions[u])&&(this._myExtensions.splice(u,1),u--);for(const u of E)this._allExtensions.push(u);for(const u of p)this._myExtensions.push(u);return this._myActivationEvents=null,d}containsExtension(d){for(const t of this._myExtensions)if(R.ExtensionIdentifier.equals(t,d))return!0;return!1}containsActivationEvent(d){return this._myActivationEvents||(this._myActivationEvents=this._readMyActivationEvents()),this._myActivationEvents.has(d)}_readMyActivationEvents(){const d=new Set;for(const t of this._allExtensions){if(!this.containsExtension(t.identifier))continue;const E=N.ImplicitActivationEvents.readActivationEvents(t);for(const c of E)d.add(c)}return d}}e.ExtensionHostExtensions=L;function _(a){const d=new R.ExtensionIdentifierMap;for(const t of a)d.set(t.identifier,t);return d}function l(a,d){return a.enabledApiProposals?a.enabledApiProposals.includes(d):!1}function w(a,d){if(!l(a,d))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}class g{constructor(d,t,E,c){this.codeLoadingTime=d,this.activateCallTime=t,this.activateResolvedTime=E,this.activationReason=c}}e.ActivationTimes=g;class r{constructor(d,t){this.description=d,this.value=t}}e.ExtensionPointContribution=r;var o;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function s(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}function n(a,d){return{identifier:new R.ExtensionIdentifier((0,T.getExtensionId)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!d,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activateById(d,t){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(d,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=i}),define(Pe[225],Te([1,0,14,108,20,25,13,11]),function(me,e,D,O,T,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class h{static{this.NONE=new h(!1,-1,-1,-1)}constructor(s,n,i,a){this.startup=s,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=a}}e.ExtensionActivationTimes=h;class y{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,n){return s===-1||n===-1?-1:n-s}build(){return new h(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class L{constructor(s,n,i,a,d,t){this.activationFailed=s,this.activationFailedError=n,this.activationTimes=i,this.module=a,this.exports=d,this.subscriptions=t}}e.ActivatedExtension=L;class _ extends L{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=_;class l extends L{constructor(){super(!1,null,h.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=l;class w extends L{constructor(s){super(!0,s,h.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let g=class{constructor(s,n,i,a){this._logService=a,this._registry=s,this._globalRegistry=n,this._host=i,this._operations=new T.ExtensionIdentifierMap,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[s,n]of this._operations)n.dispose()}async waitForActivatingExtensions(){const s=[];for(const[n,i]of this._operations)s.push(i.wait());await Promise.all(s)}isActivated(s){const n=this._operations.get(s);return!!(n&&n.value)}getActivatedExtension(s){const n=this._operations.get(s);if(!n||!n.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return n.value}async activateByEvent(s,n){if(this._alreadyActivatedEvents[s])return;const i=this._registry.getExtensionDescriptionsForActivationEvent(s);await this._activateExtensions(i.map(a=>({id:a.identifier,reason:{startup:n,extensionId:a.identifier,activationEvent:s}}))),this._alreadyActivatedEvents[s]=!0}activateById(s,n){const i=this._registry.getExtensionDescription(s);if(!i)throw new Error(`Extension '${s.value}' is not known`);return this._activateExtensions([{id:i.identifier,reason:n}])}async _activateExtensions(s){const n=s.filter(i=>!this.isActivated(i.id)).map(i=>this._handleActivationRequest(i));await Promise.all(n.map(i=>i.wait()))}_handleActivationRequest(s){if(this._operations.has(s.id))return this._operations.get(s.id);if(this._isHostExtension(s.id))return this._createAndSaveOperation(s,null,[],null);const n=this._registry.getExtensionDescription(s.id);if(!n){const d=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this._createAndSaveOperation(s,null,[],new w(d));return this._host.onExtensionActivationError(s.id,d,new N.MissingExtensionDependency(s.id.value)),t}const i=[],a=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const d of a){if(this._isResolvedExtension(d))continue;const t=this._operations.get(d);if(t){i.push(t);continue}if(this._isHostExtension(d)){i.push(this._handleActivationRequest({id:this._globalRegistry.getExtensionDescription(d).identifier,reason:s.reason}));continue}const E=this._registry.getExtensionDescription(d);if(E){if(!E.main&&!E.browser)continue;i.push(this._handleActivationRequest({id:E.identifier,reason:s.reason}));continue}const c=n.displayName||n.identifier.value,p=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${d}'`),b=this._createAndSaveOperation(s,n.displayName,[],new w(p));return this._host.onExtensionActivationError(n.identifier,p,new N.MissingExtensionDependency(d)),b}return this._createAndSaveOperation(s,n.displayName,i,null)}_createAndSaveOperation(s,n,i,a){const d=new r(s.id,n,s.reason,i,a,this._host,this._logService);return this._operations.set(s.id,d),d}_isHostExtension(s){return O.ExtensionDescriptionRegistry.isHostExtension(s,this._registry,this._globalRegistry)}_isResolvedExtension(s){const n=this._globalRegistry.getExtensionDescription(s);return n?!n.main&&!n.browser:!1}};e.ExtensionsActivator=g,e.ExtensionsActivator=g=Ke([He(3,R.ILogService)],g);let r=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(s,n,i,a,d,t,E){this._id=s,this._displayName=n,this._reason=i,this._deps=a,this._value=d,this._host=t,this._logService=E,this._barrier=new m.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let s=0;s<this._deps.length;s++){const n=this._deps[s];if(n.value&&!n.value.activationFailed){this._deps.splice(s,1),s--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this._value=new w(i),this._host.onExtensionActivationError(this._id,i,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(s=>s.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(s){const n=new Error;if(s&&s.name&&(n.name=s.name),s&&s.message?n.message=`Activating extension '${this._id.value}' failed: ${s.message}.`:n.message=`Activating extension '${this._id.value}' failed: ${s}.`,s&&s.stack&&(n.stack=s.stack),this._value=new w(n),this._isDisposed&&D.isCancellationError(s))return;this._host.onExtensionActivationError(this._id,n,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(s)}}};r=Ke([He(6,R.ILogService)],r)}),define(Pe[226],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[227],Te([1,0,185,14,32,98,72,30,20,226,195,103]),function(me,e,D,O,T,N,R,m,h,y,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const l=m.Registry.as(R.Extensions.JSONContribution);class w{constructor(d,t,E){this._messageHandler=d,this._extension=t,this._extensionPointId=E}_msg(d,t){this._messageHandler({type:d,message:t,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(d){this._msg(T.default.Error,d)}warn(d){this._msg(T.default.Warning,d)}info(d){this._msg(T.default.Info,d)}}e.ExtensionMessageCollector=w;class g{static _toSet(d){const t=new h.ExtensionIdentifierSet;for(let E=0,c=d.length;E<c;E++)t.add(d[E].description.identifier);return t}static compute(d,t){if(!d||!d.length)return new g(t,[]);if(!t||!t.length)return new g([],d);const E=this._toSet(d),c=this._toSet(t),p=t.filter(v=>!E.has(v.description.identifier)),b=d.filter(v=>!c.has(v.description.identifier));return new g(p,b)}constructor(d,t){this.added=d,this.removed=t}}e.ExtensionPointUserDelta=g;class r{constructor(d,t){this.name=d,this.defaultExtensionKind=t,this._handler=null,this._users=null,this._delta=null}setHandler(d){if(this._handler!==null)throw new Error("Handler already set!");this._handler=d,this._handle()}acceptUsers(d){this._delta=g.compute(this._users,d),this._users=d,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(d){(0,O.onUnexpectedError)(d)}}}e.ExtensionPoint=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:h.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:D.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this._extensionPoints=new Map}registerExtensionPoint(d){if(this._extensionPoints.has(d.extensionPoint))throw new Error("Duplicate extension point: "+d.extensionPoint);const t=new r(d.extensionPoint,d.defaultExtensionKind);return this._extensionPoints.set(d.extensionPoint,t),d.activationEventsGenerator&&_.ImplicitActivationEvents.register(d.extensionPoint,d.activationEventsGenerator),e.schema.properties.contributes.properties[d.extensionPoint]=d.jsonSchema,l.registerSchema(s,e.schema),t}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};m.Registry.add(i.ExtensionsRegistry,new n),e.ExtensionsRegistry=m.Registry.as(i.ExtensionsRegistry),l.registerSchema(s,e.schema),l.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(Pe[228],Te([1,0,181,17,26,227,33,5]),function(me,e,D,O,T,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const h={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var y;(function(l){function w(g,r,o){if(!g)return;const s=O.isString(g.type)?g.type:void 0;if(!s||s.length===0){o.error(D.localize(3,null));return}const n=[];if(Array.isArray(g.required))for(const i of g.required)O.isString(i)&&n.push(i);return{extensionId:r.value,taskType:s,required:n,properties:g.properties?T.deepClone(g.properties):{},when:g.when?R.ContextKeyExpr.deserialize(g.when):void 0}}l.from=w})(y||(y={}));const L=N.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,w)=>{for(const g of l)g.type&&w.push(`onTaskType:${g.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:h}});class _{constructor(){this._onDefinitionsChanged=new m.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((w,g)=>{L.setHandler((r,o)=>{this._schema=void 0;try{for(const s of o.removed){const n=s.value;for(const i of n)this.taskTypes&&i.type&&this.taskTypes[i.type]&&delete this.taskTypes[i.type]}for(const s of o.added){const n=s.value;for(const i of n){const a=y.from(i,s.description.identifier,s.collector);a&&(this.taskTypes[a.taskType]=a)}}(o.removed.length>0||o.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}w(void 0)})})}onReady(){return this.readyPromise}get(w){return this.taskTypes[w]}all(){return Object.keys(this.taskTypes).map(w=>this.taskTypes[w])}getJsonSchema(){if(this._schema===void 0){const w=[];for(const g of this.all()){const r={type:"object",additionalProperties:!1};g.required.length>0&&(r.required=g.required.slice(0)),g.properties!==void 0?r.properties=T.deepClone(g.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[g.taskType]},w.push(r)}this._schema={oneOf:w}}return this._schema}}e.TaskDefinitionRegistry=new _}),define(Pe[229],Te([1,0,182,17,23,26,33,228]),function(me,e,D,O,T,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new R.RawContextKey("taskRunning",!1,D.localize(0,null)),e.TASKS_CATEGORY=D.localize2(2,"Tasks");var h;(function(A){A[A.Escape=1]="Escape",A[A.Strong=2]="Strong",A[A.Weak=3]="Weak"})(h||(e.ShellQuoting=h={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(A){function U(j){if(!j)return A.Strong;switch(j.toLowerCase()){case"escape":return A.Escape;case"strong":return A.Strong;case"weak":return A.Weak;default:return A.Strong}}A.from=U}(h||(e.ShellQuoting=h={}));var y;(function(A){A.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var L;(function(A){A[A.Always=1]="Always",A[A.Silent=2]="Silent",A[A.Never=3]="Never"})(L||(e.RevealKind=L={})),function(A){function U(j){switch(j.toLowerCase()){case"always":return A.Always;case"silent":return A.Silent;case"never":return A.Never;default:return A.Always}}A.fromString=U}(L||(e.RevealKind=L={}));var _;(function(A){A[A.Never=1]="Never",A[A.OnProblem=2]="OnProblem",A[A.Always=3]="Always"})(_||(e.RevealProblemKind=_={})),function(A){function U(j){switch(j.toLowerCase()){case"always":return A.Always;case"never":return A.Never;case"onproblem":return A.OnProblem;default:return A.OnProblem}}A.fromString=U}(_||(e.RevealProblemKind=_={}));var l;(function(A){A[A.Shared=1]="Shared",A[A.Dedicated=2]="Dedicated",A[A.New=3]="New"})(l||(e.PanelKind=l={})),function(A){function U(j){switch(j.toLowerCase()){case"shared":return A.Shared;case"dedicated":return A.Dedicated;case"new":return A.New;default:return A.Shared}}A.fromString=U}(l||(e.PanelKind=l={}));var w;(function(A){A.defaults={echo:!0,reveal:L.Always,revealProblems:_.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var g;(function(A){A[A.Shell=1]="Shell",A[A.Process=2]="Process",A[A.CustomExecution=3]="CustomExecution"})(g||(e.RuntimeType=g={})),function(A){function U(ie){switch(ie.toLowerCase()){case"shell":return A.Shell;case"process":return A.Process;case"customExecution":return A.CustomExecution;default:return A.Process}}A.fromString=U;function j(ie){switch(ie){case A.Shell:return"shell";case A.Process:return"process";case A.CustomExecution:return"customExecution";default:return"process"}}A.toString=j}(g||(e.RuntimeType=g={}));var r;(function(A){function U(j){return O.isString(j)?j:j.value}A.value=U})(r||(e.CommandString=r={}));var o;(function(A){A.Clean={_id:"clean",isDefault:!1},A.Build={_id:"build",isDefault:!1},A.Rebuild={_id:"rebuild",isDefault:!1},A.Test={_id:"test",isDefault:!1};function U(ie){return ie===A.Clean._id||ie===A.Build._id||ie===A.Rebuild._id||ie===A.Test._id}A.is=U;function j(ie){if(ie!==void 0)return O.isString(ie)?U(ie)?{_id:ie,isDefault:!1}:void 0:ie}A.from=j})(o||(e.TaskGroup=o={}));var s;(function(A){A[A.Global=1]="Global",A[A.Workspace=2]="Workspace",A[A.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var n;(function(A){A.Workspace="workspace",A.Extension="extension",A.InMemory="inMemory",A.WorkspaceFile="workspaceFile",A.User="user";function U(j){switch(j){case A.User:return 2;case A.WorkspaceFile:return 5;default:return 6}}A.toConfigurationTarget=U})(n||(e.TaskSourceKind=n={}));var i;(function(A){A.parallel="parallel",A.sequence="sequence"})(i||(e.DependsOrder=i={}));var a;(function(A){A[A.default=1]="default",A[A.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var d;(function(A){A.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(d||(e.RunOptions=d={}));class t{constructor(U,j,ie,fe,Ce,_e){this._label="",this._id=U,j&&(this._label=j),ie&&(this.type=ie),this.runOptions=fe,this.configurationProperties=Ce,this._source=_e}getDefinition(U){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const U={folder:this.getFolderId(),id:this._id};return JSON.stringify(U)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,j=!1){if(U===void 0)return!1;if(O.isString(U))return U===this._label||U===this.configurationProperties.identifier||j&&U===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),U&&(this._taskLoadMessages=this._taskLoadMessages.concat(U))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class E extends t{constructor(U,j,ie,fe,Ce,_e,oe,pe){super(U,ie,void 0,oe,pe,j),this.command={},this._source=j,this.hasDefinedMatchers=_e,Ce&&(this.command=Ce)}clone(){return new E(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let j;switch(this.command?this.command.runtime:void 0){case g.Shell:j="shell";break;case g.Process:j="process";break;case g.CustomExecution:j="customExecution";break;case void 0:j="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:j,_key:this._id,id:this._id}}}static is(U){return U instanceof E}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===n.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const U=this.getFolderId();if(!U)return;let j=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(j+=this._source.kind);const ie={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:j};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?T.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(U){return new E(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.CustomTask=E;class c extends t{constructor(U,j,ie,fe,Ce,_e,oe){super(U,ie,fe,_e,oe,j),this._source=j,this.configures=Ce}static is(U){return U instanceof c}fromObject(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?T.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===n.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getKey(){const U=this.getFolderId();if(!U)return;let j=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(j+=this._source.kind);const ie={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:j};return JSON.stringify(ie)}}e.ConfiguringTask=c;class p extends t{constructor(U,j,ie,fe,Ce,_e,oe,pe,ne){super(U,ie,fe,pe,ne,j),this.defines=Ce,this.hasDefinedMatchers=oe,this.command=_e,this.icon=ne.icon,this.hide=ne.hide}clone(){return new p(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof p}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.getFolderId(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(U){return new p(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.ContributedTask=p;class b extends t{constructor(U,j,ie,fe,Ce,_e){super(U,ie,fe,Ce,_e,j),this._source=j}clone(){return new b(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof b}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(U){return new b(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.InMemoryTask=b;var v;(function(A){A[A.Process=1]="Process",A[A.Terminal=2]="Terminal"})(v||(e.ExecutionEngine=v={})),function(A){A._default=A.Terminal}(v||(e.ExecutionEngine=v={}));var u;(function(A){A[A.V0_1_0=1]="V0_1_0",A[A.V2_0_0=2]="V2_0_0"})(u||(e.JsonSchemaVersion=u={}));class C{constructor(U){this._order=new Map;for(let j=0;j<U.length;j++)this._order.set(U[j].uri.toString(),j)}compare(U,j){const ie=U.getWorkspaceFolder(),fe=j.getWorkspaceFolder();if(ie&&fe){let Ce=this._order.get(ie.uri.toString());Ce=Ce===void 0?0:Ce+1;let _e=this._order.get(fe.uri.toString());return _e=_e===void 0?0:_e+1,Ce===_e?U._label.localeCompare(j._label):Ce-_e}else return!ie&&fe?-1:ie&&!fe?1:0}}e.TaskSorter=C;var f;(function(A){A.DependsOnStarted="dependsOnStarted",A.AcquiredInput="acquiredInput",A.Start="start",A.ProcessStarted="processStarted",A.Active="active",A.Inactive="inactive",A.Changed="changed",A.Terminated="terminated",A.ProcessEnded="processEnded",A.End="end"})(f||(e.TaskEventKind=f={}));var I;(function(A){A.SingleRun="singleRun",A.Background="background"})(I||(e.TaskRunType=I={}));var S;(function(A){A[A.System=0]="System",A[A.User=1]="User",A[A.FolderOpen=2]="FolderOpen",A[A.ConfigurationChange=3]="ConfigurationChange",A[A.Reconnect=4]="Reconnect"})(S||(e.TaskRunSource=S={}));var P;(function(A){function U(pe){return{taskId:pe._id,taskName:pe.configurationProperties.name,runType:pe.configurationProperties.isBackground?"background":"singleRun",group:pe.configurationProperties.group,__task:pe}}function j(pe,ne,Ie){return{...U(pe),kind:"start",terminalId:ne,resolvedVariables:Ie}}A.start=j;function ie(pe,ne,Ie){return{...U(pe),kind:"processStarted",terminalId:ne,processId:Ie}}A.processStarted=ie;function fe(pe,ne,Ie){return{...U(pe),kind:"processEnded",terminalId:ne,exitCode:Ie}}A.processEnded=fe;function Ce(pe,ne,Ie){return{...U(pe),kind:"terminated",exitReason:Ie,terminalId:ne}}A.terminated=Ce;function _e(pe,ne,Ie){return{...U(ne),kind:pe,terminalId:Ie}}A.general=_e;function oe(){return{kind:"changed"}}A.changed=oe})(P||(e.TaskEvent=P={}));var k;(function(A){function U(ie){const fe=Object.keys(ie).sort();let Ce="";for(const _e of fe){let oe=ie[_e];oe instanceof Object?oe=U(oe):typeof oe=="string"&&(oe=oe.replace(/,/g,",,")),Ce+=_e+","+oe+","}return Ce}function j(ie){const Ce={_key:U(ie),type:ie.taskType};return Object.assign(Ce,ie),Ce}A.create=j})(k||(e.KeyedTaskIdentifier=k={}));var H;(function(A){A.AutoDetect="task.autoDetect",A.SaveBeforeRun="task.saveBeforeRun",A.ShowDecorations="task.showDecorations",A.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",A.SlowProviderWarning="task.slowProviderWarning",A.QuickOpenHistory="task.quickOpen.history",A.QuickOpenDetail="task.quickOpen.detail",A.QuickOpenSkip="task.quickOpen.skip",A.QuickOpenShowAll="task.quickOpen.showAll",A.AllowAutomaticTasks="task.allowAutomaticTasks",A.Reconnection="task.reconnection",A.VerboseLogging="task.verboseLogging"})(H||(e.TaskSettingId=H={}));var $;(function(A){A.Tasks="tasks",A.SuppressTaskName="tasks.suppressTaskName",A.Windows="tasks.windows",A.Osx="tasks.osx",A.Linux="tasks.linux",A.ShowOutput="tasks.showOutput",A.IsShellCommand="tasks.isShellCommand",A.ServiceTestSetting="tasks.service.testSetting"})($||(e.TasksSchemaProperties=$={}));var V;(function(A){function U(j,ie){const fe=m.TaskDefinitionRegistry.get(j.type);if(fe===void 0){const pe=N.deepClone(j);return delete pe._key,k.create(pe)}const Ce=Object.create(null);Ce.type=fe.taskType;const _e=new Set;fe.required.forEach(pe=>_e.add(pe));const oe=fe.properties;for(const pe of Object.keys(oe)){const ne=j[pe];if(ne!=null)Ce[pe]=ne;else if(_e.has(pe)){const Ie=oe[pe];if(Ie.default!==void 0)Ce[pe]=N.deepClone(Ie.default);else switch(Ie.type){case"boolean":Ce[pe]=!1;break;case"number":case"integer":Ce[pe]=0;break;case"string":Ce[pe]="";break;default:ie.error(D.localize(1,null,JSON.stringify(j,void 0,0),pe));return}}}return k.create(Ce)}A.createTaskIdentifier=U})(V||(e.TaskDefinition=V={}))}),define(Pe[230],Te([1,0,14]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class O{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((R,m)=>{this._actualOk=R,this._actualErr=m,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(R){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=R,this._actual&&this._actualOk(R))}resolveErr(R){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=R,this._actual?this._actualErr(R):(0,D.onUnexpectedError)(R))}then(R,m){return this._ensureActual().then(R,m)}catch(R){return this._ensureActual().then(void 0,R)}finally(R){return this._ensureActual().finally(R)}}e.LazyPromise=O;class T extends O{constructor(){super(),this._hasErr=!0,this._err=new D.CancellationError}}e.CanceledLazyPromise=T}),define(Pe[50],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.ProxyIdentifier=void 0,e.createProxyIdentifier=T,e.getStringIdentifierForProxy=N;class D{static{this.count=0}constructor(h){this._proxyIdentifierBrand=void 0,this.sid=h,this.nid=++D.count}}e.ProxyIdentifier=D;const O=[];function T(m){const h=new D(m);return O[h.nid]=h,h}function N(m){return O[m].sid}class R{constructor(h){this.value=h}}e.SerializableObjectWithBuffers=R}),define(Pe[4],Te([1,0,50]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var T;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(T||(e.TabInputKind=T={}));var N;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var R;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var m;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var h;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(h||(e.CellOutputKind=h={}));var y;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var L;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(L||(e.CandidatePortSource=L={}));class _{static{this._n=0}static mixin(o){return o._id=_._n++,o}}e.IdObject=_;var l;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var w;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var g;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.MainContext={MainThreadAuthentication:(0,D.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,D.createProxyIdentifier)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,D.createProxyIdentifier)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.createProxyIdentifier)("MainThreadChatVariables"),MainThreadClipboard:(0,D.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createProxyIdentifier)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,D.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,D.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,D.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createProxyIdentifier)("MainThreadStorage"),MainThreadSpeech:(0,D.createProxyIdentifier)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createProxyIdentifier)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,D.createProxyIdentifier)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,D.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createProxyIdentifier)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.createProxyIdentifier)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,D.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,D.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,D.createProxyIdentifier)("MainThreadChat"),MainThreadInlineChat:(0,D.createProxyIdentifier)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,D.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.createProxyIdentifier)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.createProxyIdentifier)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,D.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,D.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,D.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.createProxyIdentifier)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,D.createProxyIdentifier)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,D.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.createProxyIdentifier)("ExtHostOutputService"),ExtHostLabelService:(0,D.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.createProxyIdentifier)("ExtHostInteractive"),ExtHostInlineChat:(0,D.createProxyIdentifier)("ExtHostInlineChatShape"),ExtHostChat:(0,D.createProxyIdentifier)("ExtHostChat"),ExtHostChatAgents2:(0,D.createProxyIdentifier)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.createProxyIdentifier)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.createProxyIdentifier)("ExtHostChatProvider"),ExtHostSpeech:(0,D.createProxyIdentifier)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.createProxyIdentifier)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.createProxyIdentifier)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,D.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Pe[78],Te([1,0,3,13,4,16]),function(me,e,D,O,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,D.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(h,y){this._extHostLogService=y,this._reportedUsages=new Set,this._telemetryShape=h.getProxy(T.MainContext.MainThreadTelemetry)}report(h,y,L){const _=this.getUsageKey(h,y);this._reportedUsages.has(_)||(this._reportedUsages.add(_),y.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${h}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:h}))}getUsageKey(h,y){return`${h}-${y.identifier.value}`}};e.ExtHostApiDeprecationService=R,e.ExtHostApiDeprecationService=R=Ke([He(0,N.IExtHostRpcService),He(1,O.ILogService)],R),e.NullApiDeprecationService=Object.freeze(new class{report(m,h,y){}})}),define(Pe[231],Te([1,0,39,6,4]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class N{static{this._pool=0}constructor(h,y){this.extension=h,this.provider=y,this.handle=N._pool++}}class R{static{this._nextId=0}constructor(h){this._chatProvider=new Map,this._chatSessions=new Map,this._proxy=h.getProxy(T.MainContext.MainThreadChat)}registerChatProvider(h,y,L){const _=new N(h,L);return this._chatProvider.set(_.handle,_),this._proxy.$registerChatProvider(_.handle,y),(0,O.toDisposable)(()=>{this._proxy.$unregisterChatProvider(_.handle),this._chatProvider.delete(_.handle)})}transferChatSession(h,y){const L=D.Iterable.find(this._chatSessions.keys(),_=>this._chatSessions.get(_)===h)??0;typeof L=="number"&&this._proxy.$transferChatSession(L,y)}async $prepareChat(h,y){const L=this._chatProvider.get(h);if(!L)return;const _=await L.provider.prepareSession(y);if(!_)return;const l=R._nextId++;return this._chatSessions.set(l,_),{id:l}}$releaseSession(h){this._chatSessions.delete(h)}}e.ExtHostChat=R}),define(Pe[232],Te([1,0,4]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class O{constructor(N){const R=N.getProxy(D.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(m){return R.$writeText(m)}})}}e.ExtHostClipboard=O}),define(Pe[233],Te([1,0,26,4,27,16]),function(me,e,D,O,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let R=class{constructor(L,_){this._mainThreadConsole=L.getProxy(O.MainContext.MainThreadConsole),this._includeStack=_.consoleForward.includeStack,this._logNative=_.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("debug","debug"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(L,_){const l=this,w=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){l._handleConsoleCall(L,_,w,arguments)}})}_handleConsoleCall(L,_,l,w){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:_,arguments:h(w,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(L,l,w)}};e.AbstractExtHostConsoleForwarder=R,e.AbstractExtHostConsoleForwarder=R=Ke([He(0,N.IExtHostRpcService),He(1,T.IExtHostInitDataService)],R);const m=1e5;function h(y,L){const _=[];if(y.length)for(let l=0;l<y.length;l++){let w=y[l];if(typeof w>"u")w="undefined";else if(w instanceof Error){const g=w;g.stack?w=g.stack:w=g.toString()}_.push(w)}if(L){const l=new Error().stack;l&&_.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,D.safeStringify)(_);return l.length>m?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Pe[234],Te([1,0,2,4,25]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class N{constructor(m){this._proxy=m.getProxy(O.MainContext.MainThreadDialogs)}showOpenDialog(m,h){return h?.allowUIResources&&(0,T.checkProposedApiEnabled)(m,"showLocal"),this._proxy.$showOpenDialog(h).then(y=>y?y.map(L=>D.URI.revive(L)):void 0)}showSaveDialog(m){return this._proxy.$showSaveDialog(m).then(h=>h?D.URI.revive(h):void 0)}}e.ExtHostDialogs=N}),define(Pe[235],Te([1,0,6,4]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(R){this._handlePool=0,this._proxy=R.getProxy(O.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const m=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(m,R),(0,D.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(m)})}}e.ExtHostLabelService=T}),define(Pe[79],Te([1,0,21,15,2,3,13,4,27,16]),function(me,e,D,O,T,N,R,m,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(l,w,g){this.logService=g,this.bundleCache=new Map,this._proxy=w.getProxy(m.MainContext.MainThreadLocalization),this.currentLanguage=l.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===D.LANGUAGE_DEFAULT}getMessage(l,w){const{message:g,args:r,comment:o}=w;if(this.isDefaultLanguage)return(0,O.format2)(g,r??{});let s=g;o&&o.length>0&&(s+=`/${Array.isArray(o)?o.join(""):o}`);const n=this.bundleCache.get(l)?.contents[s];return n||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,O.format2)(n??g,r??{})}getBundle(l){return this.bundleCache.get(l)?.contents}getBundleUri(l){return this.bundleCache.get(l)?.uri}async initializeLocalizedMessages(l){if(this.isDefaultLanguage||!l.l10n&&!l.isBuiltin||this.bundleCache.has(l.identifier.value))return;let w;const g=await this.getBundleLocation(l);if(!g){this.logService.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const r=await this._proxy.$fetchBundleContents(g),o=JSON.parse(r);w=l.isBuiltin?o.contents?.bundle:o}catch(r){this.logService.error(`Failed to load translations for ${l.identifier.value} from ${g}: ${r.message}`);return}w&&this.bundleCache.set(l.identifier.value,{contents:w,uri:g})}async getBundleLocation(l){if(l.isBuiltin){const w=await this._proxy.$fetchBuiltInBundleUri(l.identifier.value,this.currentLanguage);return T.URI.revive(w)}return l.l10n?T.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};e.ExtHostLocalizationService=L,e.ExtHostLocalizationService=L=Ke([He(0,h.IExtHostInitDataService),He(1,y.IExtHostRpcService),He(2,R.ILogService)],L),e.IExtHostLocalizationService=(0,N.createDecorator)("IExtHostLocalizationService")}),define(Pe[236],Te([1,0,13,4,27,16,2,53]),function(me,e,D,O,T,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let h=class extends D.AbstractLoggerService{constructor(_,l){super(l.logLevel,l.logsLocation,l.loggers.map(w=>(0,m.revive)(w))),this._proxy=_.getProxy(O.MainContext.MainThreadLogger)}$setLogLevel(_,l){l?this.setLogLevel(R.URI.revive(l),_):this.setLogLevel(_)}setVisibility(_,l){super.setVisibility(_,l),this._proxy.$setVisibility(_,l)}doCreateLogger(_,l,w){return new y(this._proxy,_,l,w)}};e.ExtHostLoggerService=h,e.ExtHostLoggerService=h=Ke([He(0,N.IExtHostRpcService),He(1,T.IExtHostInitDataService)],h);class y extends D.AbstractMessageLogger{constructor(_,l,w,g){super(g?.logLevel==="always"),this.proxy=_,this.file=l,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(w),this.proxy.$createLogger(l,g).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(_,l){const w=[[_,l]];this.isLoggerCreated?this.doLog(w):this.buffer.push(...w)}doLog(_){this.proxy.$log(this.file,_)}flush(){this.proxy.$flush(this.file)}}}),define(Pe[80],Te([1,0,4,3,6,16,22]),function(me,e,D,O,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,O.createDecorator)("IExtHostManagedSockets");let m=class{constructor(_){this._remoteSocketIdCounter=0,this._factory=null,this._managedRemoteSockets=new Map,this._proxy=_.getProxy(D.MainContext.MainThreadManagedSockets)}setFactory(_,l){for(const w of this._managedRemoteSockets.values())w.dispose();this._factory&&this._proxy.$unregisterSocketFactory(this._factory.socketFactoryId),this._factory=new h(_,l),this._proxy.$registerSocketFactory(this._factory.socketFactoryId)}async $openRemoteSocket(_){if(!this._factory||this._factory.socketFactoryId!==_)throw new Error(`No socket factory with id ${_}`);const l=++this._remoteSocketIdCounter,w=await this._factory.makeConnection(),g=new T.DisposableStore;return this._managedRemoteSockets.set(l,new y(l,w,g)),g.add((0,T.toDisposable)(()=>this._managedRemoteSockets.delete(l))),g.add(w.onDidEnd(()=>{this._proxy.$onDidManagedSocketEnd(l),g.dispose()})),g.add(w.onDidClose(r=>{this._proxy.$onDidManagedSocketClose(l,r?.stack??r?.message),g.dispose()})),g.add(w.onDidReceiveMessage(r=>this._proxy.$onDidManagedSocketHaveData(l,R.VSBuffer.wrap(r)))),l}$remoteSocketWrite(_,l){this._managedRemoteSockets.get(_)?.actual.send(l.buffer)}$remoteSocketEnd(_){const l=this._managedRemoteSockets.get(_);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(_){await this._managedRemoteSockets.get(_)?.actual.drain?.()}};e.ExtHostManagedSockets=m,e.ExtHostManagedSockets=m=Ke([He(0,N.IExtHostRpcService)],m);class h{constructor(_,l){this.socketFactoryId=_,this.makeConnection=l}}class y extends T.Disposable{constructor(_,l,w){super(),this.socketId=_,this.actual=l,this._register(w)}}}),define(Pe[237],Te([1,0,4,13,25]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function N(m){return m&&m.title}let R=class{constructor(h,y){this._logService=y,this._proxy=h.getProxy(D.MainContext.MainThreadMessageService)}showMessage(h,y,L,_,l){const w={source:{identifier:h.identifier,label:h.displayName||h.name}};let g;typeof _=="string"||N(_)?g=[_,...l]:(w.modal=_?.modal,w.useCustom=_?.useCustom,w.detail=_?.detail,g=l),w.useCustom&&(0,T.checkProposedApiEnabled)(h,"resolvers");const r=[];let o=!1;for(let s=0;s<g.length;s++){const n=g[s];if(typeof n=="string")r.push({title:n,handle:s,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:a}=n;r.push({title:i,isCloseAffordance:!!a,handle:s}),a&&(o?this._logService.warn(`[${h.identifier}] Only one message item can have 'isCloseAffordance':`,n):o=!0)}else this._logService.warn(`[${h.identifier}] Invalid message item:`,n)}return this._proxy.$showMessage(y,L,w,r).then(s=>{if(typeof s=="number")return g[s]})}};e.ExtHostMessageService=R,e.ExtHostMessageService=R=Ke([He(1,O.ILogService)],R)}),define(Pe[238],Te([1,0,6,17,2,25,4]),function(me,e,D,O,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class m{constructor(y){this.handlers=new Map,this.proxy=y.getProxy(R.MainContext.MainThreadProfileContentHandlers)}registerProfileContentHandler(y,L,_){if((0,N.checkProposedApiEnabled)(y,"profileContentHandlers"),this.handlers.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.handlers.set(L,_),this.proxy.$registerProfileContentHandler(L,_.name,_.description,y.identifier.value),(0,D.toDisposable)(()=>{this.handlers.delete(L),this.proxy.$unregisterProfileContentHandler(L)})}async $saveProfile(y,L,_,l){const w=this.handlers.get(y);if(!w)throw new Error(`Unknown handler with id: ${y}`);return w.saveProfile(L,_,l)}async $readProfile(y,L,_){const l=this.handlers.get(y);if(!l)throw new Error(`Unknown handler with id: ${y}`);return l.readProfile((0,O.isString)(L)?L:T.URI.revive(L),_)}}e.ExtHostProfileContentHandlers=m}),define(Pe[81],Te([1,0,4,5,3]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class N{constructor(m){this._onDidChangePassword=new O.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=m.getProxy(D.MainContext.MainThreadSecretState)}async $onDidChangePassword(m){this._onDidChangePassword.fire(m)}get(m,h){return this._proxy.$getPassword(m,h)}store(m,h,y){return this._proxy.$setPassword(m,h,y)}delete(m,h){return this._proxy.$deletePassword(m,h)}}e.ExtHostSecretState=N,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")}),define(Pe[239],Te([1,0,24,6,4]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSpeech=void 0;class N{static{this.ID_POOL=1}constructor(m){this.providers=new Map,this.sessions=new Map,this.proxy=m.getProxy(T.MainContext.MainThreadSpeech)}async $createSpeechToTextSession(m,h,y){const L=this.providers.get(m);if(!L)return;const _=new O.DisposableStore,l=new D.CancellationTokenSource;this.sessions.set(h,l);const w=_.add(L.provideSpeechToTextSession(l.token,y?{language:y}:void 0));_.add(w.onDidChange(g=>{l.token.isCancellationRequested||this.proxy.$emitSpeechToTextEvent(h,g)})),_.add(l.token.onCancellationRequested(()=>_.dispose()))}async $cancelSpeechToTextSession(m){this.sessions.get(m)?.dispose(!0),this.sessions.delete(m)}async $createKeywordRecognitionSession(m,h){const y=this.providers.get(m);if(!y)return;const L=new O.DisposableStore,_=new D.CancellationTokenSource;this.sessions.set(h,_);const l=L.add(y.provideKeywordRecognitionSession(_.token));L.add(l.onDidChange(w=>{_.token.isCancellationRequested||this.proxy.$emitKeywordRecognitionEvent(h,w)})),L.add(_.token.onCancellationRequested(()=>L.dispose()))}async $cancelKeywordRecognitionSession(m){this.sessions.get(m)?.dispose(!0),this.sessions.delete(m)}registerProvider(m,h,y){const L=N.ID_POOL++;return this.providers.set(L,y),this.proxy.$registerProvider(L,h,{extension:m,displayName:m.value}),(0,O.toDisposable)(()=>{this.proxy.$unregisterProvider(L),this.providers.delete(L)})}}e.ExtHostSpeech=N}),define(Pe[82],Te([1,0,4,5,3]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class N{constructor(m,h){this._logService=h,this._onDidChangeStorage=new O.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=m.getProxy(D.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(m,h){this._proxy.$registerExtensionStorageKeysToSync(m,h)}async initializeExtensionStorage(m,h,y){const L=await this._proxy.$initializeExtensionStorage(m,h);let _;return L&&(_=this.safeParseValue(m,h,L)),_||y}setValue(m,h,y){return this._proxy.$setValue(m,h,y)}$acceptValue(m,h,y){const L=this.safeParseValue(m,h,y);L&&this._onDidChangeStorage.fire({shared:m,key:h,value:L})}safeParseValue(m,h,y){try{return JSON.parse(y)}catch(L){this._logService.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${m}): ${L}`)}}}e.ExtHostStorage=N,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(Pe[240],Te([1,0,6,12,2,4]),function(me,e,D,O,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{static{this.supportedSchemes=new Set([O.Schemas.http,O.Schemas.https])}constructor(h){this._openers=new Map,this._proxy=h.getProxy(N.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(h,y,L,_){if(this._openers.has(y))throw new Error(`Opener with id '${y}' already registered`);const l=_.schemes.find(w=>!R.supportedSchemes.has(w));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(y,L),this._proxy.$registerUriOpener(y,_.schemes,h,_.label),(0,D.toDisposable)(()=>{this._openers.delete(y),this._proxy.$unregisterUriOpener(y)})}async $canOpenUri(h,y,L){const _=this._openers.get(h);if(!_)throw new Error(`Unknown opener with id: ${h}`);const l=T.URI.revive(y);return _.canOpenExternalUri(l,L)}async $openUri(h,y,L){const _=this._openers.get(h);if(!_)throw new Error(`Unknown opener id: '${h}'`);return _.openExternalUri(T.URI.revive(y.resolvedUri),{sourceUri:T.URI.revive(y.sourceUri)},L)}}e.ExtHostUriOpeners=R}),define(Pe[241],Te([1,0,4,2,6,14,20]),function(me,e,D,O,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class m{static{this.HandlePool=0}constructor(y){this.handles=new R.ExtensionIdentifierSet,this.handlers=new Map,this._proxy=y.getProxy(D.MainContext.MainThreadUrls)}registerUriHandler(y,L){const _=y.identifier;if(this.handles.has(_))throw new Error(`Protocol handler already registered for extension ${_}`);const l=m.HandlePool++;return this.handles.add(_),this.handlers.set(l,L),this._proxy.$registerUriHandler(l,_,y.displayName||y.name),(0,T.toDisposable)(()=>{this.handles.delete(_),this.handlers.delete(l),this._proxy.$unregisterUriHandler(l)})}$handleExternalUri(y,L){const _=this.handlers.get(y);if(!_)return Promise.resolve(void 0);try{_.handleUri(O.URI.revive(L))}catch(l){(0,N.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(y){return O.URI.revive(await this._proxy.$createAppUri(y))}}e.ExtHostUrls=m}),define(Pe[63],Te([1,0,5,6,12,26,2,188,210,76,4]),function(me,e,D,O,T,N,R,m,h,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviews=e.ExtHostWebview=void 0,e.shouldSerializeBuffersForPostMessage=l,e.toExtensionData=r,e.serializeWebviewOptions=o;class _{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#h;constructor(a,d,t,E,c,p,b){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new D.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new D.Emitter,this._onDidDispose=this.#d.event,this.#e=a,this.#t=d,this.#o=t,this.#n=E,this.#s=c,this.#r=p,this.#u=l(p),this.#h=w(p),this.#i=b}#d;dispose(){this.#c=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#l=!0,(0,y.asWebviewUri)(a,this.#n)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===T.Schemas.https||a.scheme===T.Schemas.http){let d=a.toString();return d.endsWith("/")||(d+="/"),d+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),this.#a}set html(a){this.assertNotDisposed(),this.#a!==a&&(this.#a=a,this.#h&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.rewriteOldResourceUrlsIfNeeded(a)))}get options(){return this.assertNotDisposed(),this.#o}set options(a){this.assertNotDisposed(),N.equals(this.#o,a)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const d=(0,h.serializeWebviewMessage)(a,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,d.message,...d.buffers)}assertNotDisposed(){if(this.#c)throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(a){if(!this.#h)return a;const d=this.#r.extensionLocation?.scheme===T.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===T.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(E,c,p,b,v,u)=>{const C=R.URI.from({scheme:b||"file",path:decodeURIComponent(v)}),f=(0,y.asWebviewUri)(C,{isRemote:d,authority:t}).toString();return`${c}${f}${u}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(E,c,p,b,v,u)=>{const C=R.URI.from({scheme:b||"file",path:decodeURIComponent(v)}),f=(0,y.asWebviewUri)(C,{isRemote:d,authority:t}).toString();return`${c}${f}${u}`})}}e.ExtHostWebview=_;function l(i){try{const a=(0,m.normalizeVersion)((0,m.parseVersion)(i.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}function w(i){try{const a=(0,m.normalizeVersion)((0,m.parseVersion)(i.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class g extends O.Disposable{constructor(a,d,t,E,c){super(),this.remoteInfo=d,this.workspace=t,this._logService=E,this._deprecationService=c,this._webviews=new Map,this._webviewProxy=a.getProxy(L.MainContext.MainThreadWebviews)}dispose(){super.dispose();for(const a of this._webviews.values())a.dispose();this._webviews.clear()}$onMessage(a,d,t){const E=this.getWebview(a);if(E){const{message:c}=(0,h.deserializeWebviewMessage)(d,t.value);E._onMessageEmitter.fire(c)}}$onMissingCsp(a,d){this._logService.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,d,t){const E=new _(a,this._webviewProxy,s(d),this.remoteInfo,this.workspace,t,this._deprecationService);this._webviews.set(a,E);const c=E._onDidDispose(()=>{c.dispose(),this.deleteWebview(a)});return E}deleteWebview(a){this._webviews.delete(a)}getWebview(a){return this._webviews.get(a)}}e.ExtHostWebviews=g;function r(i){return{id:i.identifier,location:i.extensionLocation}}function o(i,a,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||n(i,a)}}function s(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(a=>R.URI.from(a))}}function n(i,a){return[...(a?.getWorkspaceFolders()||[]).map(d=>d.uri),i.extensionLocation]}}),define(Pe[109],Te([1,0,5,4,2,12,15,3,16,25]),function(me,e,D,O,T,N,R,m,h,y){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let _=class{static{L=this}static{this.InitialState={focused:!0,active:!0}}getState(w){const g=this._state;return{get focused(){return g.focused},get active(){return(0,y.checkProposedApiEnabled)(w,"windowActivity"),g.active}}}constructor(w){this._onDidChangeWindowState=new D.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=L.InitialState,this._proxy=w.getProxy(O.MainContext.MainThreadWindow),this._proxy.$getInitialState().then(({isFocused:g,isActive:r})=>{this.onDidChangeWindowProperty("focused",g),this.onDidChangeWindowProperty("active",r)})}$onDidChangeWindowFocus(w){this.onDidChangeWindowProperty("focused",w)}$onDidChangeWindowActive(w){this.onDidChangeWindowProperty("active",w)}onDidChangeWindowProperty(w,g){g!==this._state[w]&&(this._state={...this._state,[w]:g},this._onDidChangeWindowState.fire(this._state))}openUri(w,g){let r;if(typeof w=="string"){r=w;try{w=T.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,R.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this._proxy.$openUri(w,r,g)}async asExternalUri(w,g){if((0,R.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const r=await this._proxy.$asExternalUri(w,g);return T.URI.from(r)}};e.ExtHostWindow=_,e.ExtHostWindow=_=L=Ke([He(0,h.IExtHostRpcService)],_),e.IExtHostWindow=(0,m.createDecorator)("IExtHostWindow")}),define(Pe[242],Te([1,0,233,27,16]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let N=class extends D.AbstractExtHostConsoleForwarder{constructor(m,h){super(m,h)}_nativeConsoleLogMessage(m,h,y){h.apply(console,y)}};e.ExtHostConsoleForwarder=N,e.ExtHostConsoleForwarder=N=Ke([He(0,T.IExtHostRpcService),He(1,O.IExtHostInitDataService)],N)}),define(Pe[243],Te([1,0,11,22,24,14,5,6,144,230,50]),function(me,e,D,O,T,N,R,m,h,y,L){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0,e.stringifyJsonWithBufferRefs=o,e.parseJsonAndRestoreBufferRefs=s;function l(S,P){try{return JSON.stringify(S,P)}catch{return"null"}}const w="$$ref$$",g={[w]:-1};class r{constructor(P,k){this.jsonString=P,this.referencedBuffers=k}}function o(S,P=null,k=!1){const H=[];return{jsonString:(k?l:JSON.stringify)(S,(V,A)=>{if(typeof A>"u")return g;if(typeof A=="object"){if(A instanceof O.VSBuffer){const U=H.push(A)-1;return{[w]:U}}if(P)return P(V,A)}return A}),referencedBuffers:H}}function s(S,P,k){return JSON.parse(S,(H,$)=>{if($){const V=$[w];if(typeof V=="number")return P[V];if(k&&$.$mid===1)return k.transformIncoming($)}return $})}function n(S,P){return JSON.stringify(S,P)}function i(S){return S?(P,k)=>k&&k.$mid===1?S.transformOutgoing(k):k:null}var a;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var d;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(d||(e.ResponsiveState=d={}));const t=()=>{},E=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class p extends m.Disposable{static{_=E}static{this.UNRESPONSIVE_TIME=3*1e3}constructor(P,k=null,H=null){super(),this[_]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=P,this._logger=k,this._uriTransformer=H,this._uriReplacer=i(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let $=0,V=L.ProxyIdentifier.count;$<V;$++)this._locals[$]=null,this._proxies[$]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new D.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage($=>this._receiveOneMessage($))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(P=>{const k=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P],k.resolveErr(N.canceled())}),super.dispose()}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(P){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+p.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(P){this._unresponsiveTime=Date.now()+p.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(P){this._responsiveState!==P&&(this._responsiveState=P,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(P){return this._uriTransformer?(0,h.transformIncomingURIs)(P,this._uriTransformer):P}getProxy(P){const{nid:k,sid:H}=P;return this._proxies[k]||(this._proxies[k]=this._createProxy(k,H)),this._proxies[k]}_createProxy(P,k){const H={get:($,V)=>(typeof V=="string"&&!$[V]&&V.charCodeAt(0)===36&&($[V]=(...A)=>this._remoteCall(P,V,A)),V===c?k:$[V])};return new Proxy(Object.create(null),H)}set(P,k){return this._locals[P.nid]=k,k}assertRegistered(P){for(let k=0,H=P.length;k<H;k++){const $=P[k];if(!this._locals[$.nid])throw new Error(`Missing proxy instance ${$.sid}`)}}_receiveOneMessage(P){if(this._isDisposed)return;const k=P.byteLength,H=v.read(P,0),$=H.readUInt8(),V=H.readUInt32();switch($){case 1:case 2:{let{rpcId:A,method:U,args:j}=C.deserializeRequestJSONArgs(H);this._uriTransformer&&(j=(0,h.transformIncomingURIs)(j,this._uriTransformer)),this._receiveRequest(k,V,A,U,j,$===2);break}case 3:case 4:{let{rpcId:A,method:U,args:j}=C.deserializeRequestMixedArgs(H);this._uriTransformer&&(j=(0,h.transformIncomingURIs)(j,this._uriTransformer)),this._receiveRequest(k,V,A,U,j,$===4);break}case 5:{this._logger?.logIncoming(k,V,0,"ack"),this._onDidReceiveAcknowledge(V);break}case 6:{this._receiveCancel(k,V);break}case 7:{this._receiveReply(k,V,void 0);break}case 9:{let A=C.deserializeReplyOKJSON(H);this._uriTransformer&&(A=(0,h.transformIncomingURIs)(A,this._uriTransformer)),this._receiveReply(k,V,A);break}case 10:{const A=C.deserializeReplyOKJSONWithBuffers(H,this._uriTransformer);this._receiveReply(k,V,A);break}case 8:{const A=C.deserializeReplyOKVSBuffer(H);this._receiveReply(k,V,A);break}case 11:{let A=C.deserializeReplyErrError(H);this._uriTransformer&&(A=(0,h.transformIncomingURIs)(A,this._uriTransformer)),this._receiveReplyErr(k,V,A);break}case 12:{this._receiveReplyErr(k,V,void 0);break}default:console.error("received unexpected message"),console.error(P)}}_receiveRequest(P,k,H,$,V,A){this._logger?.logIncoming(P,k,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(H)}.${$}(`,V);const U=String(k);let j,ie;if(A){const Ce=new T.CancellationTokenSource;V.push(Ce.token),j=this._invokeHandler(H,$,V),ie=()=>Ce.cancel()}else j=this._invokeHandler(H,$,V),ie=t;this._cancelInvokedHandlers[U]=ie;const fe=C.serializeAcknowledged(k);this._logger?.logOutgoing(fe.byteLength,k,1,"ack"),this._protocol.send(fe),j.then(Ce=>{delete this._cancelInvokedHandlers[U];const _e=C.serializeReplyOK(k,Ce,this._uriReplacer);this._logger?.logOutgoing(_e.byteLength,k,1,"reply:",Ce),this._protocol.send(_e)},Ce=>{delete this._cancelInvokedHandlers[U];const _e=C.serializeReplyErr(k,Ce);this._logger?.logOutgoing(_e.byteLength,k,1,"replyErr:",Ce),this._protocol.send(_e)})}_receiveCancel(P,k){this._logger?.logIncoming(P,k,1,"receiveCancel");const H=String(k);this._cancelInvokedHandlers[H]?.()}_receiveReply(P,k,H){this._logger?.logIncoming(P,k,0,"receiveReply:",H);const $=String(k);if(!this._pendingRPCReplies.hasOwnProperty($))return;const V=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$],V.resolveOk(H)}_receiveReplyErr(P,k,H){this._logger?.logIncoming(P,k,0,"receiveReplyErr:",H);const $=String(k);if(!this._pendingRPCReplies.hasOwnProperty($))return;const V=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$];let A;H&&(H.$isError?(A=new Error,A.name=H.name,A.message=H.message,A.stack=H.stack):A=H),V.resolveErr(A)}_invokeHandler(P,k,H){try{return Promise.resolve(this._doInvokeHandler(P,k,H))}catch($){return Promise.reject($)}}_doInvokeHandler(P,k,H){const $=this._locals[P];if(!$)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(P));const V=$[k];if(typeof V!="function")throw new Error("Unknown method "+k+" on actor "+(0,L.getStringIdentifierForProxy)(P));return V.apply($,H)}_remoteCall(P,k,H){if(this._isDisposed)return new y.CanceledLazyPromise;let $=null;if(H.length>0&&T.CancellationToken.isCancellationToken(H[H.length-1])&&($=H.pop()),$&&$.isCancellationRequested)return Promise.reject(N.canceled());const V=C.serializeRequestArguments(H,this._uriReplacer),A=++this._lastMessageId,U=String(A),j=new y.LazyPromise,ie=new m.DisposableStore;$&&ie.add($.onCancellationRequested(()=>{const Ce=C.serializeCancel(A);this._logger?.logOutgoing(Ce.byteLength,A,0,"cancel"),this._protocol.send(C.serializeCancel(A))})),this._pendingRPCReplies[U]=new b(j,ie),this._onWillSendRequest(A);const fe=C.serializeRequest(A,P,k,V,!!$);return this._logger?.logOutgoing(fe.byteLength,A,0,`request: ${(0,L.getStringIdentifierForProxy)(P)}.${k}(`,H),this._protocol.send(fe),j}}e.RPCProtocol=p;class b{constructor(P,k){this._promise=P,this._disposable=k}resolveOk(P){this._promise.resolveOk(P),this._disposable.dispose()}resolveErr(P){this._promise.resolveErr(P),this._disposable.dispose()}}class v{static alloc(P,k,H){const $=new v(O.VSBuffer.alloc(H+1+4),0);return $.writeUInt8(P),$.writeUInt32(k),$}static read(P,k){return new v(P,k)}get buffer(){return this._buff}constructor(P,k){this._buff=P,this._offset=k}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this._buff.writeUInt8(P,this._offset),this._offset+=1}readUInt8(){const P=this._buff.readUInt8(this._offset);return this._offset+=1,P}writeUInt32(P){this._buff.writeUInt32BE(P,this._offset),this._offset+=4}readUInt32(){const P=this._buff.readUInt32BE(this._offset);return this._offset+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this._buff.writeUInt8(P.byteLength,this._offset),this._offset+=1,this._buff.set(P,this._offset),this._offset+=P.byteLength}readShortString(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const H=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,H}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readLongString(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const H=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,H}writeBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readVSBuffer(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const k=this._buff.slice(this._offset,this._offset+P);return this._offset+=P,k}static sizeMixedArray(P){let k=0;k+=1;for(let H=0,$=P.length;H<$;H++){const V=P[H];switch(k+=1,V.type){case 1:k+=this.sizeLongString(V.value);break;case 2:k+=this.sizeVSBuffer(V.value);break;case 3:k+=this.sizeUInt32,k+=this.sizeLongString(V.value);for(let A=0;A<V.buffers.length;++A)k+=this.sizeVSBuffer(V.buffers[A]);break;case 4:break}}return k}writeMixedArray(P){this._buff.writeUInt8(P.length,this._offset),this._offset+=1;for(let k=0,H=P.length;k<H;k++){const $=P[k];switch($.type){case 1:this.writeUInt8(1),this.writeLongString($.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer($.value);break;case 3:this.writeUInt8(3),this.writeUInt32($.buffers.length),this.writeLongString($.value);for(let V=0;V<$.buffers.length;++V)this.writeBuffer($.buffers[V]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const k=new Array(P);for(let H=0;H<P;H++)switch(this.readUInt8()){case 1:k[H]=this.readLongString();break;case 2:k[H]=this.readVSBuffer();break;case 3:{const V=this.readUInt32(),A=this.readLongString(),U=[];for(let j=0;j<V;++j)U.push(this.readVSBuffer());k[H]=new L.SerializableObjectWithBuffers(s(A,U,null));break}case 4:k[H]=void 0;break}return k}}var u;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(u||(u={}));class C{static _useMixedArgSerialization(P){for(let k=0,H=P.length;k<H;k++)if(P[k]instanceof O.VSBuffer||P[k]instanceof L.SerializableObjectWithBuffers||typeof P[k]>"u")return!0;return!1}static serializeRequestArguments(P,k){if(this._useMixedArgSerialization(P)){const H=[];for(let $=0,V=P.length;$<V;$++){const A=P[$];if(A instanceof O.VSBuffer)H[$]={type:2,value:A};else if(typeof A>"u")H[$]={type:4};else if(A instanceof L.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:j}=o(A.value,k);H[$]={type:3,value:O.VSBuffer.fromString(U),buffers:j}}else H[$]={type:1,value:O.VSBuffer.fromString(n(A,k))}}return{type:1,args:H}}return{type:0,args:n(P,k)}}static serializeRequest(P,k,H,$,V){switch($.type){case 0:return this._requestJSONArgs(P,k,H,$.args,V);case 1:return this._requestMixedArgs(P,k,H,$.args,V)}}static _requestJSONArgs(P,k,H,$,V){const A=O.VSBuffer.fromString(H),U=O.VSBuffer.fromString($);let j=0;j+=v.sizeUInt8(),j+=v.sizeShortString(A),j+=v.sizeLongString(U);const ie=v.alloc(V?2:1,P,j);return ie.writeUInt8(k),ie.writeShortString(A),ie.writeLongString(U),ie.buffer}static deserializeRequestJSONArgs(P){const k=P.readUInt8(),H=P.readShortString(),$=P.readLongString();return{rpcId:k,method:H,args:JSON.parse($)}}static _requestMixedArgs(P,k,H,$,V){const A=O.VSBuffer.fromString(H);let U=0;U+=v.sizeUInt8(),U+=v.sizeShortString(A),U+=v.sizeMixedArray($);const j=v.alloc(V?4:3,P,U);return j.writeUInt8(k),j.writeShortString(A),j.writeMixedArray($),j.buffer}static deserializeRequestMixedArgs(P){const k=P.readUInt8(),H=P.readShortString(),$=P.readMixedArray(),V=new Array($.length);for(let A=0,U=$.length;A<U;A++){const j=$[A];typeof j=="string"?V[A]=JSON.parse(j):V[A]=j}return{rpcId:k,method:H,args:V}}static serializeAcknowledged(P){return v.alloc(5,P,0).buffer}static serializeCancel(P){return v.alloc(6,P,0).buffer}static serializeReplyOK(P,k,H){if(typeof k>"u")return this._serializeReplyOKEmpty(P);if(k instanceof O.VSBuffer)return this._serializeReplyOKVSBuffer(P,k);if(k instanceof L.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:V}=o(k.value,H,!0);return this._serializeReplyOKJSONWithBuffers(P,$,V)}else return this._serializeReplyOKJSON(P,l(k,H))}static _serializeReplyOKEmpty(P){return v.alloc(7,P,0).buffer}static _serializeReplyOKVSBuffer(P,k){let H=0;H+=v.sizeVSBuffer(k);const $=v.alloc(8,P,H);return $.writeVSBuffer(k),$.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static _serializeReplyOKJSON(P,k){const H=O.VSBuffer.fromString(k);let $=0;$+=v.sizeLongString(H);const V=v.alloc(9,P,$);return V.writeLongString(H),V.buffer}static _serializeReplyOKJSONWithBuffers(P,k,H){const $=O.VSBuffer.fromString(k);let V=0;V+=v.sizeUInt32,V+=v.sizeLongString($);for(const U of H)V+=v.sizeVSBuffer(U);const A=v.alloc(10,P,V);A.writeUInt32(H.length),A.writeLongString($);for(const U of H)A.writeBuffer(U);return A.buffer}static deserializeReplyOKJSON(P){const k=P.readLongString();return JSON.parse(k)}static deserializeReplyOKJSONWithBuffers(P,k){const H=P.readUInt32(),$=P.readLongString(),V=[];for(let A=0;A<H;++A)V.push(P.readVSBuffer());return new L.SerializableObjectWithBuffers(s($,V,k))}static serializeReplyErr(P,k){const H=k?l(N.transformErrorForSerialization(k),null):void 0;if(typeof H!="string")return this._serializeReplyErrEmpty(P);const $=O.VSBuffer.fromString(H);let V=0;V+=v.sizeLongString($);const A=v.alloc(11,P,V);return A.writeLongString($),A.buffer}static deserializeReplyErrError(P){const k=P.readLongString();return JSON.parse(k)}static _serializeReplyErrEmpty(P){return v.alloc(12,P,0).buffer}}var f;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var I;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(I||(I={}))}),define(Pe[244],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const D=function(N){const R=m=>{globalThis.removeEventListener("message",R);const h=m.data;Object.defineProperties(globalThis,{postMessage:{value(y,L){h.postMessage(y,L)}},onmessage:{get(){return h.onmessage},set(y){h.onmessage=y}}}),h.addEventListener("message",y=>{globalThis.dispatchEvent(new MessageEvent("message",{data:y.data,ports:y.ports?[...y.ports]:void 0}))}),h.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",R)}.toString();class O extends EventTarget{constructor(N,R,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const h=`((${D})('${R}'))`,y=new Blob([h],{type:"application/javascript"}),L=URL.createObjectURL(y),_=new MessageChannel,l=L,w={type:"_newWorker",id:l,port:_.port2,url:L,options:m};N(w,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{N({type:"_terminateWorker",id:l}),URL.revokeObjectURL(L),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(g){_.port1.onmessage=g}},onmessageerror:{get(){return _.port1.onmessageerror},set(g){_.port1.onmessageerror=g}}}),_.port1.addEventListener("messageerror",g=>{const r=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(r)}),_.port1.addEventListener("message",g=>{const r=new MessageEvent("message",{data:g.data});this.dispatchEvent(r)}),_.port1.start()}}e.NestedWorker=O}),define(Pe[245],Te([1,0,22,28,12,55,3]),function(me,e,D,O,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookDocumentWorkbenchService=e.INotebookDocumentService=void 0,e.parse=L,e.generate=_,e.INotebookDocumentService=(0,R.createDecorator)("notebookDocumentService");const m=["W","X","Y","Z","a","b","c","d","e","f"],h=new RegExp(`^[${m.join("")}]+`),y=7;function L(w){if(w.scheme!==T.Schemas.vscodeNotebookCell)return;const g=w.fragment.indexOf("s");if(g<0)return;const r=parseInt(w.fragment.substring(0,g).replace(h,""),y),o=(0,D.decodeBase64)(w.fragment.substring(g+1)).toString();if(!isNaN(r))return{handle:r,notebook:w.with({scheme:o,fragment:null})}}function _(w,g){const r=g.toString(y),s=`${r.length<m.length?m[r.length-1]:"z"}${r}s${(0,D.encodeBase64)(D.VSBuffer.fromString(w.scheme),!0,!0)}`;return w.with({scheme:T.Schemas.vscodeNotebookCell,fragment:s})}class l{constructor(){this._documents=new O.ResourceMap}getNotebook(g){if(g.scheme===T.Schemas.vscodeNotebookCell){const r=L(g);if(r){const o=this._documents.get(r.notebook);if(o)return o}}return this._documents.get(g)}addNotebookDocument(g){this._documents.set(g.uri,g)}removeNotebookDocument(g){this._documents.delete(g.uri)}}e.NotebookDocumentWorkbenchService=l,(0,N.registerSingleton)(e.INotebookDocumentService,l,1)}),define(Pe[83],Te([1,0,22,35,39,69,12,19,21,33,245]),function(me,e,D,O,T,N,R,m,h,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MOVE_CURSOR_1_LINE_COMMAND=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.diff=E,e.isDocumentExcludePattern=p,e.notebookDocumentFilterMatch=b,e.isTextStreamMime=C,e.compressOutputItemStreams=I,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var _;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(_||(e.CellKind=_={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",N.Mimes.latex,N.Mimes.markdown,"image/png","image/jpeg",N.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[N.Mimes.latex,N.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var l;(function(j){j[j.Running=1]="Running",j[j.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var w;(function(j){j[j.Unconfirmed=1]="Unconfirmed",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var g;(function(j){j[j.Unconfirmed=1]="Unconfirmed",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(g||(e.NotebookExecutionState=g={}));var r;(function(j){j[j.WithHardKernelDependency=0]="WithHardKernelDependency",j[j.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",j[j.Pure=2]="Pure",j[j.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(j){j.Always="always",j.Never="never",j.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var s;(function(j){j[j.ModelChange=1]="ModelChange",j[j.Move=2]="Move",j[j.ChangeCellLanguage=5]="ChangeCellLanguage",j[j.Initialize=6]="Initialize",j[j.ChangeCellMetadata=7]="ChangeCellMetadata",j[j.Output=8]="Output",j[j.OutputItem=9]="OutputItem",j[j.ChangeCellContent=10]="ChangeCellContent",j[j.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",j[j.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",j[j.ChangeCellMime=13]="ChangeCellMime",j[j.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var n;(function(j){j[j.Handle=0]="Handle",j[j.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(j){j[j.Replace=1]="Replace",j[j.Output=2]="Output",j[j.Metadata=3]="Metadata",j[j.CellLanguage=4]="CellLanguage",j[j.DocumentMetadata=5]="DocumentMetadata",j[j.Move=6]="Move",j[j.OutputItems=7]="OutputItems",j[j.PartialMetadata=8]="PartialMetadata",j[j.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var a;(function(j){j.scheme=R.Schemas.vscodeNotebookCell;function ie(ne,Ie){return(0,L.generate)(ne,Ie)}j.generate=ie;function fe(ne){return(0,L.parse)(ne)}j.parse=fe;function Ce(ne,Ie){return ne.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${Ie??""},${ne.scheme!==R.Schemas.file?ne.scheme:""}`})}j.generateCellOutputUri=Ce;function _e(ne){if(ne.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const Ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!Ie)return;const xe=Ie[1]&&Ie[1]!==""?Ie[1]:void 0,re=Ie[2];return{outputId:xe,notebook:ne.with({scheme:re||R.Schemas.file,fragment:null})}}j.parseCellOutputUri=_e;function oe(ne,Ie,xe){return j.generate(ne,Ie).with({scheme:xe})}j.generateCellPropertyUri=oe;function pe(ne,Ie){if(ne.scheme===Ie)return j.parse(ne.with({scheme:j.scheme}))}j.parseCellPropertyUri=pe})(a||(e.CellUri=a={}));const d=j=>h.isWindows?j.replace(/\//g,"\\"):j;class t{constructor(ie=[],fe=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=fe,this.order=[...new Set(ie)].map(Ce=>({pattern:Ce,matches:O.parse(d(Ce))}))}sort(ie){const fe=new Map(T.Iterable.map(ie,_e=>[_e,d(_e)]));let Ce=[];for(const{matches:_e}of this.order)for(const[oe,pe]of fe)if(_e(pe)){Ce.push(oe),fe.delete(oe);break}return fe.size&&(Ce=Ce.concat([...fe.keys()].sort((_e,oe)=>this.defaultOrder.indexOf(_e)-this.defaultOrder.indexOf(oe)))),Ce}prioritize(ie,fe){const Ce=this.findIndex(ie);if(Ce===-1){this.order.unshift({pattern:ie,matches:O.parse(d(ie))});return}const _e=new Set(fe.map(pe=>this.findIndex(pe,Ce)));_e.delete(-1);const oe=Array.from(_e).sort();this.order.splice(Ce+1,0,...oe.map(pe=>this.order[pe]));for(let pe=oe.length-1;pe>=0;pe--)this.order.splice(oe[pe],1)}toArray(){return this.order.map(ie=>ie.pattern)}findIndex(ie,fe=this.order.length){const Ce=d(ie);for(let _e=0;_e<fe;_e++)if(this.order[_e].matches(Ce))return _e;return-1}}e.MimeTypeDisplayOrder=t;function E(j,ie,fe,Ce=(_e,oe)=>_e===oe){const _e=[];function oe(Ie,xe,re){if(xe===0&&re.length===0)return;const F=_e[_e.length-1];F&&F.start+F.deleteCount===Ie?(F.deleteCount+=xe,F.toInsert.push(...re)):_e.push({start:Ie,deleteCount:xe,toInsert:re})}let pe=0,ne=0;for(;;){if(pe===j.length){oe(pe,0,ie.slice(ne));break}if(ne===ie.length){oe(pe,j.length-pe,[]);break}const Ie=j[pe],xe=ie[ne];if(Ce(Ie,xe)){pe+=1,ne+=1;continue}fe(xe)?(oe(pe,1,[]),pe+=1):(oe(pe,0,[xe]),ne+=1)}return _e}e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_LINE_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtLineBoundary","none");var c;(function(j){j.default="default",j.option="option"})(c||(e.NotebookEditorPriority=c={}));function p(j){const ie=j;return!!((typeof ie.include=="string"||O.isRelativePattern(ie.include))&&(typeof ie.exclude=="string"||O.isRelativePattern(ie.exclude)))}function b(j,ie,fe){if(Array.isArray(j.viewType)&&j.viewType.indexOf(ie)>=0||j.viewType===ie)return!0;if(j.filenamePattern){const Ce=p(j.filenamePattern)?j.filenamePattern.include:j.filenamePattern,_e=p(j.filenamePattern)?j.filenamePattern.exclude:void 0;if(O.match(Ce,(0,m.basename)(fe.fsPath).toLowerCase()))return!(_e&&O.match(_e,(0,m.basename)(fe.fsPath).toLowerCase()))}return!1}e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var v;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(v||(e.CellStatusbarAlignment=v={}));class u{static{this._prefix="notebook/"}static create(ie){return`${u._prefix}${ie}`}static parse(ie){if(ie.startsWith(u._prefix))return ie.substring(u._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=u;function C(j){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(j)}const f=new TextDecoder;function I(j){const ie=[];let fe=!1;for(const pe of j)(ie.length===0||fe)&&(ie.push(pe),fe=!0);let Ce=k(ie);const _e=D.VSBuffer.concat(ie.map(pe=>D.VSBuffer.wrap(pe))),oe=U(_e);return Ce=Ce||oe.byteLength!==_e.byteLength,{data:oe,didCompression:Ce}}e.MOVE_CURSOR_1_LINE_COMMAND="\x1B[A";const S=e.MOVE_CURSOR_1_LINE_COMMAND.split("").map(j=>j.charCodeAt(0)),P=10;function k(j){let ie=!1;return j.forEach((fe,Ce)=>{if(Ce===0||fe.length<e.MOVE_CURSOR_1_LINE_COMMAND.length)return;const _e=j[Ce-1],oe=fe.subarray(0,e.MOVE_CURSOR_1_LINE_COMMAND.length);if(oe[0]===S[0]&&oe[1]===S[1]&&oe[2]===S[2]){const pe=_e.lastIndexOf(P);if(pe===-1)return;ie=!0,j[Ce-1]=_e.subarray(0,pe),j[Ce]=fe.subarray(e.MOVE_CURSOR_1_LINE_COMMAND.length)}}),ie}function H(j){let ie=j;do j=ie,ie=j.replace(/[^\n]\x08/gm,"");while(ie.length<j.length);return j}function $(j){for(j=j.replace(/\r+\n/gm,`
`);j.search(/\r[^$]/g)>-1;){const ie=j.match(/^(.*)\r+/m)[1];let fe=j.match(/\r+(.*)$/m)[1];fe=fe+ie.slice(fe.length,ie.length),j=j.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,fe)}return j}const V=8,A=13;function U(j){return!j.buffer.includes(V)&&!j.buffer.includes(A)?j:D.VSBuffer.fromString($(H(f.decode(j.buffer))))}}),define(Pe[7],Te([1,0,18,14,54,28,69,15,17,2,34,20,43,102,83]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g){"use strict";var r,o,s,n,i,a,d,t,E,c,p,b,v,u,C,f,I;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.InlineEdit=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.LanguageModelError=e.LanguageModelChatAssistantMessage=e.LanguageModelChatUserMessage=e.LanguageModelChatSystemMessage=e.ChatLocation=e.ChatResponseTurn=e.ChatRequestTurn=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFileTreePart=e.ChatResponseMarkdownPart=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.ChatCompletionItem=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.TextMultiDiffTabInput=e.ChatEditorTabInput=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.DeclarationCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.TestCoverageCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookVariablesRequestKind=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugVisualization=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.NewSymbolName=e.NewSymbolNameTag=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.Thread=e.StackFrame=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentPasteEditKind=e.DocumentPasteTriggerKind=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.asStatusBarItemIdentifier=dt,e.setBreakpointId=G,e.validateTestCoverageCount=J;function S(z){return Object.assign(z,{apply:function(...te){if(te.length===0)return Reflect.construct(z,[]);{const ye=te.length===1?[]:te[1];return Reflect.construct(z,ye,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(z,[]);{const[ye,...je]=te;return Reflect.construct(z,je,ye.constructor)}}})}var P;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var k;(function(z){z[z.TerminalCommand=0]="TerminalCommand",z[z.Opener=1]="Opener",z[z.Command=3]="Command"})(k||(e.TerminalQuickFixType=k={}));let H=r=class{static from(...M){let te=M;return new r(function(){if(te){for(const ye of te)ye&&typeof ye.dispose=="function"&&ye.dispose();te=void 0}})}#e;constructor(M){this.#e=M}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.Disposable=H,e.Disposable=H=r=Ke([S],H);let $=o=class{static Min(...M){if(M.length===0)throw new TypeError;let te=M[0];for(let ye=1;ye<M.length;ye++){const je=M[ye];je.isBefore(te)&&(te=je)}return te}static Max(...M){if(M.length===0)throw new TypeError;let te=M[0];for(let ye=1;ye<M.length;ye++){const je=M[ye];je.isAfter(te)&&(te=je)}return te}static isPosition(M){if(!M)return!1;if(M instanceof o)return!0;const{line:te,character:ye}=M;return typeof te=="number"&&typeof ye=="number"}static of(M){if(M instanceof o)return M;if(this.isPosition(M))return new o(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(M,te){if(M<0)throw(0,O.illegalArgument)("line must be non-negative");if(te<0)throw(0,O.illegalArgument)("character must be non-negative");this._line=M,this._character=te}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,te=0){if(M===null||te===null)throw(0,O.illegalArgument)();let ye;return typeof M>"u"?ye=0:typeof M=="number"?ye=M:(ye=typeof M.lineDelta=="number"?M.lineDelta:0,te=typeof M.characterDelta=="number"?M.characterDelta:0),ye===0&&te===0?this:new o(this.line+ye,this.character+te)}with(M,te=this.character){if(M===null||te===null)throw(0,O.illegalArgument)();let ye;return typeof M>"u"?ye=this.line:typeof M=="number"?ye=M:(ye=typeof M.line=="number"?M.line:this.line,te=typeof M.character=="number"?M.character:this.character),ye===this.line&&te===this.character?this:new o(ye,te)}toJSON(){return{line:this.line,character:this.character}}};e.Position=$,e.Position=$=o=Ke([S],$);let V=s=class{static isRange(M){return M instanceof s?!0:M?$.isPosition(M.start)&&$.isPosition(M.end):!1}static of(M){if(M instanceof s)return M;if(this.isRange(M))return new s(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(M,te,ye,je){let Ze,lt;if(typeof M=="number"&&typeof te=="number"&&typeof ye=="number"&&typeof je=="number"?(Ze=new $(M,te),lt=new $(ye,je)):$.isPosition(M)&&$.isPosition(te)&&(Ze=$.of(M),lt=$.of(te)),!Ze||!lt)throw new Error("Invalid arguments");Ze.isBefore(lt)?(this._start=Ze,this._end=lt):(this._start=lt,this._end=Ze)}contains(M){return s.isRange(M)?this.contains(M.start)&&this.contains(M.end):$.isPosition(M)?!($.of(M).isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const te=$.Max(M.start,this._start),ye=$.Min(M.end,this._end);if(!te.isAfter(ye))return new s(te,ye)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const te=$.Min(M.start,this._start),ye=$.Max(M.end,this.end);return new s(te,ye)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,te=this.end){if(M===null||te===null)throw(0,O.illegalArgument)();let ye;return M?$.isPosition(M)?ye=M:(ye=M.start||this.start,te=M.end||this.end):ye=this.start,ye.isEqual(this._start)&&te.isEqual(this.end)?this:new s(ye,te)}toJSON(){return[this.start,this.end]}};e.Range=V,e.Range=V=s=Ke([S],V);let A=n=class extends V{static isSelection(M){return M instanceof n?!0:M?V.isRange(M)&&$.isPosition(M.anchor)&&$.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(M,te,ye,je){let Ze,lt;if(typeof M=="number"&&typeof te=="number"&&typeof ye=="number"&&typeof je=="number"?(Ze=new $(M,te),lt=new $(ye,je)):$.isPosition(M)&&$.isPosition(te)&&(Ze=$.of(M),lt=$.of(te)),!Ze||!lt)throw new Error("Invalid arguments");super(Ze,lt),this._anchor=Ze,this._active=lt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=A,e.Selection=A=n=Ke([S],A);const U=z=>{if(typeof z!="string"||z.length===0||!/^[0-9A-Za-z_\-]+$/.test(z))throw(0,O.illegalArgument)("connectionToken")};class j{static isResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.host=="string"&&typeof M.port=="number"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,te,ye){if(typeof M!="string"||M.length===0)throw(0,O.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,O.illegalArgument)("port");typeof ye<"u"&&U(ye),this.host=M,this.port=Math.round(te),this.connectionToken=ye}}e.ResolvedAuthority=j;class ie{static isManagedResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.makeConnection=="function"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,te){this.makeConnection=M,this.connectionToken=te,typeof te<"u"&&U(te)}}e.ManagedResolvedAuthority=ie;class fe extends Error{static NotAvailable(M,te){return new fe(M,w.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(M){return new fe(M,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(M,te=w.RemoteAuthorityResolverErrorCode.Unknown,ye){super(M),this._message=M,this._code=te,this._detail=ye,Object.setPrototypeOf(this,fe.prototype)}}e.RemoteAuthorityResolverError=fe;var Ce;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(Ce||(e.EndOfLine=Ce={}));var _e;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(_e||(e.EnvironmentVariableMutatorType=_e={}));let oe=i=class{static isTextEdit(M){return M instanceof i?!0:M?V.isRange(M)&&typeof M.newText=="string":!1}static replace(M,te){return new i(M,te)}static insert(M,te){return i.replace(new V(M,M),te)}static delete(M){return i.replace(M,"")}static setEndOfLine(M){const te=new i(new V(new $(0,0),new $(0,0)),"");return te.newEol=M,te}get range(){return this._range}set range(M){if(M&&!V.isRange(M))throw(0,O.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,O.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,O.illegalArgument)("newEol");this._newEol=M}constructor(M,te){this._range=M,this._newText=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};e.TextEdit=oe,e.TextEdit=oe=i=Ke([S],oe);let pe=a=class{static isNotebookCellEdit(M){return M instanceof a?!0:M?di.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,te){return new a(M,te)}static insertCells(M,te){return new a(new di(M,M),te)}static deleteCells(M){return new a(M,[])}static updateCellMetadata(M,te){const ye=new a(new di(M,M),[]);return ye.newCellMetadata=te,ye}static updateNotebookMetadata(M){const te=new a(new di(0,0),[]);return te.newNotebookMetadata=M,te}constructor(M,te){this.range=M,this.newCells=te}};e.NotebookEdit=pe,e.NotebookEdit=pe=a=Ke([S],pe);class ne{static isSnippetTextEdit(M){return M instanceof ne?!0:M?V.isRange(M.range)&&re.isSnippetString(M.snippet):!1}static replace(M,te){return new ne(M,te)}static insert(M,te){return ne.replace(new V(M,M),te)}constructor(M,te){this.range=M,this.snippet=te}}e.SnippetTextEdit=ne;var Ie;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Ie||(e.FileEditType=Ie={}));let xe=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,te,ye,je){this._edits.push({_type:1,from:M,to:te,options:ye,metadata:je})}createFile(M,te,ye){this._edits.push({_type:1,from:void 0,to:M,options:te,metadata:ye})}deleteFile(M,te,ye){this._edits.push({_type:1,from:M,to:void 0,options:te,metadata:ye})}replaceNotebookMetadata(M,te,ye){this._edits.push({_type:3,metadata:ye,uri:M,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(M,te,ye,je){const Ze=te.start,lt=te.end;(Ze!==lt||ye.length>0)&&this._edits.push({_type:5,uri:M,index:Ze,count:lt-Ze,cells:ye,metadata:je})}replaceNotebookCellMetadata(M,te,ye,je){this._edits.push({_type:3,metadata:je,uri:M,edit:{editType:3,index:te,metadata:ye}})}replace(M,te,ye,je){this._edits.push({_type:2,uri:M,edit:new oe(te,ye),metadata:je})}insert(M,te,ye,je){this.replace(M,new V(te,te),ye,je)}delete(M,te,ye){this.replace(M,te,"",ye)}has(M){return this._edits.some(te=>te._type===2&&te.uri.toString()===M.toString())}set(M,te){if(te)for(const ye of te){if(!ye)continue;let je,Ze;Array.isArray(ye)?(je=ye[0],Ze=ye[1]):je=ye,pe.isNotebookCellEdit(je)?je.newCellMetadata?this.replaceNotebookCellMetadata(M,je.range.start,je.newCellMetadata,Ze):je.newNotebookMetadata?this.replaceNotebookMetadata(M,je.newNotebookMetadata,Ze):this.replaceNotebookCells(M,je.range,je.newCells,Ze):ne.isSnippetTextEdit(je)?this._edits.push({_type:6,uri:M,range:je.range,edit:je.snippet,metadata:Ze}):this._edits.push({_type:2,uri:M,edit:je,metadata:Ze})}else{for(let ye=0;ye<this._edits.length;ye++){const je=this._edits[ye];switch(je._type){case 2:case 6:case 3:case 5:je.uri.toString()===M.toString()&&(this._edits[ye]=void 0);break}}(0,D.coalesceInPlace)(this._edits)}}get(M){const te=[];for(const ye of this._edits)ye._type===2&&ye.uri.toString()===M.toString()&&te.push(ye.edit);return te}entries(){const M=new N.ResourceMap;for(const te of this._edits)if(te._type===2){let ye=M.get(te.uri);ye||(ye=[te.uri,[]],M.set(te.uri,ye)),ye[1].push(te.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=xe,e.WorkspaceEdit=xe=Ke([S],xe);let re=d=class{static isSnippetString(M){return M instanceof d?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}constructor(M){this._tabstop=1,this.value=M||""}appendText(M){return this.value+=d._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,te=this._tabstop++){if(typeof M=="function"){const ye=new d;ye._tabstop=this._tabstop,M(ye),this._tabstop=ye._tabstop,M=ye.value}else M=d._escape(M);return this.value+="${",this.value+=te,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,te=this._tabstop++){const ye=M.map(je=>je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(M,te){if(typeof te=="function"){const ye=new d;ye._tabstop=this._tabstop,te(ye),this._tabstop=ye._tabstop,te=ye.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.SnippetString=re,e.SnippetString=re=d=Ke([S],re);var F;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(F||(e.DiagnosticTag=F={}));var Z;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Z||(e.DiagnosticSeverity=Z={}));let be=t=class{static isLocation(M){return M instanceof t?!0:M?V.isRange(M.range)&&y.URI.isUri(M.uri):!1}constructor(M,te){if(this.uri=M,te)if(V.isRange(te))this.range=V.of(te);else if($.isPosition(te))this.range=new V(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=be,e.Location=be=t=Ke([S],be);let Le=class{static is(M){return M?typeof M.message=="string"&&M.location&&V.isRange(M.location.range)&&y.URI.isUri(M.location.uri):!1}constructor(M,te){this.location=M,this.message=te}static isEqual(M,te){return M===te?!0:!M||!te?!1:M.message===te.message&&M.location.range.isEqual(te.location.range)&&M.location.uri.toString()===te.location.uri.toString()}};e.DiagnosticRelatedInformation=Le,e.DiagnosticRelatedInformation=Le=Ke([S],Le);let Se=class{constructor(M,te,ye=Z.Error){if(!V.isRange(M))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=M,this.message=te,this.severity=ye}toJSON(){return{severity:Z[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,te){return M===te?!0:!M||!te?!1:M.message===te.message&&M.severity===te.severity&&M.code===te.code&&M.severity===te.severity&&M.source===te.source&&M.range.isEqual(te.range)&&(0,D.equals)(M.tags,te.tags)&&(0,D.equals)(M.relatedInformation,te.relatedInformation,Le.isEqual)}};e.Diagnostic=Se,e.Diagnostic=Se=Ke([S],Se);let ve=class{constructor(M,te){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=te}};e.Hover=ve,e.Hover=ve=Ke([S],ve);var he;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(he||(e.DocumentHighlightKind=he={}));let K=class{constructor(M,te=he.Text){this.range=M,this.kind=te}toJSON(){return{range:this.range,kind:he[this.kind]}}};e.DocumentHighlight=K,e.DocumentHighlight=K=Ke([S],K);let Y=class{constructor(M,te){this.uri=M,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(M=>M.toJSON())}}};e.MultiDocumentHighlight=Y,e.MultiDocumentHighlight=Y=Ke([S],Y);var le;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(le||(e.SymbolKind=le={}));var de;(function(z){z[z.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Ne=E=class{static validate(M){if(!M.name)throw new Error("name must not be falsy")}constructor(M,te,ye,je,Ze){this.name=M,this.kind=te,this.containerName=Ze,typeof ye=="string"&&(this.containerName=ye),je instanceof be?this.location=je:ye instanceof V&&(this.location=new be(je,ye)),E.validate(this)}toJSON(){return{name:this.name,kind:le[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Ne,e.SymbolInformation=Ne=E=Ke([S],Ne);let ue=c=class{static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach(c.validate)}constructor(M,te,ye,je,Ze){this.name=M,this.detail=te,this.kind=ye,this.range=je,this.selectionRange=Ze,this.children=[],c.validate(this)}};e.DocumentSymbol=ue,e.DocumentSymbol=ue=c=Ke([S],ue);var De;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(De||(e.CodeActionTriggerKind=De={}));let Re=class{constructor(M,te){this.title=M,this.kind=te}};e.CodeAction=Re,e.CodeAction=Re=Ke([S],Re);let Ue=class{static{p=this}static{this.sep="."}constructor(M){this.value=M}append(M){return new p(this.value?this.value+p.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+p.sep)}};e.CodeActionKind=Ue,e.CodeActionKind=Ue=p=Ke([S],Ue),Ue.Empty=new Ue(""),Ue.QuickFix=Ue.Empty.append("quickfix"),Ue.Refactor=Ue.Empty.append("refactor"),Ue.RefactorExtract=Ue.Refactor.append("extract"),Ue.RefactorInline=Ue.Refactor.append("inline"),Ue.RefactorMove=Ue.Refactor.append("move"),Ue.RefactorRewrite=Ue.Refactor.append("rewrite"),Ue.Source=Ue.Empty.append("source"),Ue.SourceOrganizeImports=Ue.Source.append("organizeImports"),Ue.SourceFixAll=Ue.Source.append("fixAll"),Ue.Notebook=Ue.Empty.append("notebook");let B=class{constructor(M,te){if(this.range=M,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=B,e.SelectionRange=B=Ke([S],B);class x{constructor(M,te,ye,je,Ze,lt){this.kind=M,this.name=te,this.detail=ye,this.uri=je,this.range=Ze,this.selectionRange=lt}}e.CallHierarchyItem=x;class q{constructor(M,te){this.fromRanges=te,this.from=M}}e.CallHierarchyIncomingCall=q;class W{constructor(M,te){this.fromRanges=te,this.to=M}}e.CallHierarchyOutgoingCall=W;var ee;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(ee||(e.LanguageStatusSeverity=ee={}));let se=class{constructor(M,te){this.range=M,this.command=te}get isResolved(){return!!this.command}};e.CodeLens=se,e.CodeLens=se=Ke([S],se);let Oe=b=class{#e;static isMarkdownString(M){return M instanceof b?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}constructor(M,te=!1){this.#e=new T.MarkdownString(M,{supportThemeIcons:te})}get value(){return this.#e.value}set value(M){this.#e.value=M}get isTrusted(){return this.#e.isTrusted}set isTrusted(M){this.#e.isTrusted=M}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(M){this.#e.supportThemeIcons=M}get supportHtml(){return this.#e.supportHtml}set supportHtml(M){this.#e.supportHtml=M}get baseUri(){return this.#e.baseUri}set baseUri(M){this.#e.baseUri=M}appendText(M){return this.#e.appendText(M),this}appendMarkdown(M){return this.#e.appendMarkdown(M),this}appendCodeblock(M,te){return this.#e.appendCodeblock(te??"",M),this}};e.MarkdownString=Oe,e.MarkdownString=Oe=b=Ke([S],Oe);let ze=class{constructor(M,te){this.label=M,this.documentation=te}};e.ParameterInformation=ze,e.ParameterInformation=ze=Ke([S],ze);let Ge=class{constructor(M,te){this.label=M,this.documentation=te,this.parameters=[]}};e.SignatureInformation=Ge,e.SignatureInformation=Ge=Ke([S],Ge);let Je=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=Je,e.SignatureHelp=Je=Ke([S],Je);var et;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var ot;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(ot||(e.InlayHintKind=ot={}));let it=class{constructor(M){this.value=M}};e.InlayHintLabelPart=it,e.InlayHintLabelPart=it=Ke([S],it);let nt=class{constructor(M,te,ye){this.position=M,this.label=te,this.kind=ye}};e.InlayHint=nt,e.InlayHint=nt=Ke([S],nt);var at;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at||(e.CompletionTriggerKind=at={}));var ft;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(ft||(e.CompletionItemKind=ft={}));var Be;(function(z){z[z.Deprecated=1]="Deprecated"})(Be||(e.CompletionItemTag=Be={}));let st=class{constructor(M,te){this.label=M,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&ft[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=st,e.CompletionItem=st=Ke([S],st);let Q=class{constructor(M=[],te=!1){this.items=M,this.isIncomplete=te}};e.CompletionList=Q,e.CompletionList=Q=Ke([S],Q);let X=class{constructor(M,te,ye){this.insertText=M,this.range=te,this.command=ye}};e.InlineSuggestion=X,e.InlineSuggestion=X=Ke([S],X);let ge=class{constructor(M){this.commands=void 0,this.suppressSuggestions=void 0,this.items=M}};e.InlineSuggestionList=ge,e.InlineSuggestionList=ge=Ke([S],ge);var Ve;(function(z){z[z.Unknown=0]="Unknown",z[z.Word=1]="Word",z[z.Line=2]="Line",z[z.Suggest=3]="Suggest"})(Ve||(e.PartialAcceptTriggerKind=Ve={}));var Qe;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(Qe||(e.ViewColumn=Qe={}));var Ae;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Ae||(e.StatusBarAlignment=Ae={}));function dt(z,M){return`${_.ExtensionIdentifier.toKey(z)}.${M}`}var Pt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var zt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(zt||(e.TextDocumentSaveReason=zt={}));var Zt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Zt||(e.TextEditorRevealType=Zt={}));var Gt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Gt||(e.TextEditorSelectionChangeKind=Gt={}));var ei;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(ei||(e.TextDocumentChangeReason=ei={}));var It;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(It||(e.DecorationRangeBehavior=It={})),function(z){function M(te){switch(te){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=M}(Gt||(e.TextEditorSelectionChangeKind=Gt={}));var Xt;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(Xt||(e.SyntaxTokenType=Xt={})),function(z){function M(te){switch(te){case z.Other:return"other";case z.Comment:return"comment";case z.String:return"string";case z.RegEx:return"regex"}return"other"}z.toString=M}(Xt||(e.SyntaxTokenType=Xt={}));let Vt=class{constructor(M,te){if(te&&!y.URI.isUri(te))throw(0,O.illegalArgument)("target");if(!V.isRange(M)||M.isEmpty)throw(0,O.illegalArgument)("range");this.range=M,this.target=te}};e.DocumentLink=Vt,e.DocumentLink=Vt=Ke([S],Vt);let ci=class{constructor(M,te,ye,je){this.red=M,this.green=te,this.blue=ye,this.alpha=je}};e.Color=ci,e.Color=ci=Ke([S],ci);let Ye=class{constructor(M,te){if(te&&!(te instanceof ci))throw(0,O.illegalArgument)("color");if(!V.isRange(M)||M.isEmpty)throw(0,O.illegalArgument)("range");this.range=M,this.color=te}};e.ColorInformation=Ye,e.ColorInformation=Ye=Ke([S],Ye);let ti=class{constructor(M){if(!M||typeof M!="string")throw(0,O.illegalArgument)("label");this.label=M}};e.ColorPresentation=ti,e.ColorPresentation=ti=Ke([S],ti);var ii;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(ii||(e.ColorFormat=ii={}));var Wt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var ut;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(ut||(e.TerminalExitReason=ut={}));class Et{constructor(M,te,ye){if(this.startIndex=M,this.length=te,this.tooltip=ye,typeof M!="number"||M<0)throw(0,O.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,O.illegalArgument)("length");if(ye!==void 0&&typeof ye!="string")throw(0,O.illegalArgument)("tooltip")}}e.TerminalLink=Et;class ai{constructor(M){this.uri=M}}e.TerminalQuickFixOpener=ai;class qt{constructor(M){this.terminalCommand=M}}e.TerminalQuickFixCommand=qt;var $t;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})($t||(e.TerminalLocation=$t={}));class mt{constructor(M){if(this.options=M,typeof M!="object")throw(0,O.illegalArgument)("options")}}e.TerminalProfile=mt;var Dt;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Dt||(e.TaskRevealKind=Dt={}));var li;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(li||(e.TaskPanelKind=li={}));let Qt=class{static{v=this}static{this.Clean=new v("clean","Clean")}static{this.Build=new v("build","Build")}static{this.Rebuild=new v("rebuild","Rebuild")}static{this.Test=new v("test","Test")}static from(M){switch(M){case"clean":return v.Clean;case"build":return v.Build;case"rebuild":return v.Rebuild;case"test":return v.Test;default:return}}constructor(M,te){if(this.label=te,typeof M!="string"||typeof te!="string")throw(0,O.illegalArgument)("name");this._id=M}get id(){return this._id}};e.TaskGroup=Qt,e.TaskGroup=Qt=v=Ke([S],Qt);function We(z){let M="";for(let te=0;te<z.length;te++)M+=z[te].replace(/,/g,",,")+",";return M}let Ot=class{constructor(M,te,ye){if(typeof M!="string")throw(0,O.illegalArgument)("process");this._args=[],this._process=M,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=ye):this._options=te)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,O.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(const te of this._args)M.push(te);return We(M)}};e.ProcessExecution=Ot,e.ProcessExecution=Ot=Ke([S],Ot);let Ht=class{constructor(M,te,ye){if(this._args=[],Array.isArray(te)){if(!M)throw(0,O.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,O.illegalArgument)("command");this._command=M,this._args=te,this._options=ye}else{if(typeof M!="string")throw(0,O.illegalArgument)("commandLine");this._commandLine=M,this._options=te}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,O.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,O.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const te of this._args)M.push(typeof te=="string"?te:te.value);return We(M)}};e.ShellExecution=Ht,e.ShellExecution=Ht=Ke([S],Ht);var ni;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(ni||(e.ShellQuoting=ni={}));var pt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(pt||(e.TaskScope=pt={}));class Lt{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=Lt;let Tt=class{static{u=this}static{this.ExtensionCallbackType="customExecution"}static{this.ProcessType="process"}static{this.ShellType="shell"}static{this.EmptyType="$empty"}constructor(M,te,ye,je,Ze,lt){this.__deprecated=!1,this._definition=this.definition=M;let gt;typeof te=="string"?(this._name=this.name=te,this._source=this.source=ye,this.execution=je,gt=Ze,this.__deprecated=!0):te===pt.Global||te===pt.Workspace?(this.target=te,this._name=this.name=ye,this._source=this.source=je,this.execution=Ze,gt=lt):(this.target=te,this._name=this.name=ye,this._source=this.source=je,this.execution=Ze,gt=lt),typeof gt=="string"?(this._problemMatchers=[gt],this._hasDefinedMatchers=!0):Array.isArray(gt)?(this._problemMatchers=gt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ot?this._definition={type:u.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ht?this._definition={type:u.ShellType,id:this._execution.computeId()}:this._execution instanceof Lt?this._definition={type:u.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:u.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,O.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,O.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const te=this._definition.type;(u.EmptyType===te||u.ProcessType===te||u.ShellType===te||u.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,O.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};e.Task=Tt,e.Task=Tt=u=Ke([S],Tt);var Nt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(Nt||(e.ProgressLocation=Nt={}));var ui;(function(z){function M(te){const ye=te;return(0,h.isNumber)(ye.value)?ye.tooltip&&!(0,h.isString)(ye.tooltip)?(console.log("INVALID view badge, invalid tooltip",ye.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ye.value),!1)}z.isViewBadge=M})(ui||(e.ViewBadge=ui={}));let Mt=C=class{static isTreeItem(M,te){const ye=M;if(ye.checkboxState!==void 0){const je=(0,h.isNumber)(ye.checkboxState)?ye.checkboxState:(0,h.isObject)(ye.checkboxState)&&(0,h.isNumber)(ye.checkboxState.state)?ye.checkboxState.state:void 0,Ze=!(0,h.isNumber)(ye.checkboxState)&&(0,h.isObject)(ye.checkboxState)?ye.checkboxState.tooltip:void 0;if(je===void 0||je!==yt.Checked&&je!==yt.Unchecked||Ze!==void 0&&!(0,h.isString)(Ze))return console.log("INVALID tree item, invalid checkboxState",ye.checkboxState),!1}if(M instanceof C)return!0;if(ye.label!==void 0&&!(0,h.isString)(ye.label)&&!ye.label?.label)return console.log("INVALID tree item, invalid label",ye.label),!1;if(ye.id!==void 0&&!(0,h.isString)(ye.id))return console.log("INVALID tree item, invalid id",ye.id),!1;if(ye.iconPath!==void 0&&!(0,h.isString)(ye.iconPath)&&!y.URI.isUri(ye.iconPath)&&(!ye.iconPath||!(0,h.isString)(ye.iconPath.id))){const je=ye.iconPath;if(!je||!(0,h.isString)(je.light)&&!y.URI.isUri(je.light)&&!(0,h.isString)(je.dark)&&!y.URI.isUri(je.dark))return console.log("INVALID tree item, invalid iconPath",ye.iconPath),!1}return ye.description!==void 0&&!(0,h.isString)(ye.description)&&typeof ye.description!="boolean"?(console.log("INVALID tree item, invalid description",ye.description),!1):ye.resourceUri!==void 0&&!y.URI.isUri(ye.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ye.resourceUri),!1):ye.tooltip!==void 0&&!(0,h.isString)(ye.tooltip)&&!(ye.tooltip instanceof Oe)?(console.log("INVALID tree item, invalid tooltip",ye.tooltip),!1):ye.command!==void 0&&!ye.command.command?(console.log("INVALID tree item, invalid command",ye.command),!1):ye.collapsibleState!==void 0&&ye.collapsibleState<Ft.None&&ye.collapsibleState>Ft.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ye.collapsibleState),!1):ye.contextValue!==void 0&&!(0,h.isString)(ye.contextValue)?(console.log("INVALID tree item, invalid contextValue",ye.contextValue),!1):ye.accessibilityInformation!==void 0&&!ye.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ye.accessibilityInformation),!1):!0}constructor(M,te=Ft.None){this.collapsibleState=te,y.URI.isUri(M)?this.resourceUri=M:this.label=M}};e.TreeItem=Mt,e.TreeItem=Mt=C=Ke([S],Mt);var Ft;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(Ft||(e.TreeItemCollapsibleState=Ft={}));var yt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(yt||(e.TreeItemCheckboxState=yt={}));let Rt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(M){this.value=M}};e.DataTransferItem=Rt,e.DataTransferItem=Rt=Ke([S],Rt);class ri extends Rt{}e.InternalDataTransferItem=ri;class xt extends ri{#e;constructor(M){super(""),this.#e=M}asFile(){return this.#e}}e.InternalFileDataTransferItem=xt;class wt{constructor(M,te,ye,je){this.name=M,this.uri=te,this._itemId=ye,this._getData=je}data(){return this._getData()}}e.DataTransferFile=wt;let kt=class{#e=new Map;constructor(M){for(const[te,ye]of M??[]){const je=this.#e.get(this.#t(te));je?je.push(ye):this.#e.set(this.#t(te),[ye])}}get(M){return this.#e.get(this.#t(M))?.[0]}set(M,te){this.#e.set(this.#t(M),[te])}forEach(M,te){for(const[ye,je]of this.#e)for(const Ze of je)M.call(te,Ze,ye,this)}*[Symbol.iterator](){for(const[M,te]of this.#e)for(const ye of te)yield[M,ye]}#t(M){return M.toLowerCase()}};e.DataTransfer=kt,e.DataTransfer=kt=Ke([S],kt);let fi=class{constructor(M,te,ye){this.insertText=M,this.title=te,this.kind=ye}};e.DocumentDropEdit=fi,e.DocumentDropEdit=fi=Ke([S],fi);var Ct;(function(z){z[z.Automatic=0]="Automatic",z[z.PasteAs=1]="PasteAs"})(Ct||(e.DocumentPasteTriggerKind=Ct={}));class si{static{this.sep="."}constructor(M){this.value=M}append(...M){return new si((this.value?[this.value,...M]:M).join(si.sep))}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+si.sep)}}e.DocumentPasteEditKind=si,si.Empty=new si("");let Yt=class{constructor(M,te,ye){this.title=te,this.insertText=M,this.kind=ye}};e.DocumentPasteEdit=Yt,e.DocumentPasteEdit=Yt=Ke([S],Yt);let oi=class{constructor(M,te){this.id=M,this.color=te}static isThemeIcon(M){return typeof M.id!="string"?(console.log("INVALID ThemeIcon, invalid id",M.id),!1):!0}};e.ThemeIcon=oi,e.ThemeIcon=oi=Ke([S],oi),oi.File=new oi("file"),oi.Folder=new oi("folder");let mi=class{constructor(M){this.id=M}};e.ThemeColor=mi,e.ThemeColor=mi=Ke([S],mi);var we;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(we||(e.ConfigurationTarget=we={}));let ke=class{get base(){return this._base}set base(M){this._base=M,this._baseUri=y.URI.file(M)}get baseUri(){return this._baseUri}set baseUri(M){this._baseUri=M,this._base=M.fsPath}constructor(M,te){if(typeof M!="string"&&(!M||!y.URI.isUri(M)&&!y.URI.isUri(M.uri)))throw(0,O.illegalArgument)("base");if(typeof te!="string")throw(0,O.illegalArgument)("pattern");typeof M=="string"?this.baseUri=y.URI.file(M):y.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=ke,e.RelativePattern=ke=Ke([S],ke);const ce=new WeakMap;function G(z,M){ce.set(z,M)}let Ee=class{constructor(M,te,ye,je,Ze){this.enabled=typeof M=="boolean"?M:!0,typeof te=="string"&&(this.condition=te),typeof ye=="string"&&(this.hitCondition=ye),typeof je=="string"&&(this.logMessage=je),typeof Ze=="string"&&(this.mode=Ze)}get id(){return this._id||(this._id=ce.get(this)??(0,L.generateUuid)()),this._id}};e.Breakpoint=Ee,e.Breakpoint=Ee=Ke([S],Ee);let $e=class extends Ee{constructor(M,te,ye,je,Ze,lt){if(super(te,ye,je,Ze,lt),M===null)throw(0,O.illegalArgument)("location");this.location=M}};e.SourceBreakpoint=$e,e.SourceBreakpoint=$e=Ke([S],$e);let Xe=class extends Ee{constructor(M,te,ye,je,Ze,lt){super(te,ye,je,Ze,lt),this.functionName=M}};e.FunctionBreakpoint=Xe,e.FunctionBreakpoint=Xe=Ke([S],Xe);let qe=class extends Ee{constructor(M,te,ye,je,Ze,lt,gt,Kt){if(super(je,Ze,lt,gt,Kt),!te)throw(0,O.illegalArgument)("dataId");this.label=M,this.dataId=te,this.canPersist=ye}};e.DataBreakpoint=qe,e.DataBreakpoint=qe=Ke([S],qe);let ct=class{constructor(M,te,ye){this.command=M,this.args=te||[],this.options=ye}};e.DebugAdapterExecutable=ct,e.DebugAdapterExecutable=ct=Ke([S],ct);let _t=class{constructor(M,te){this.port=M,this.host=te}};e.DebugAdapterServer=_t,e.DebugAdapterServer=_t=Ke([S],_t);let St=class{constructor(M){this.path=M}};e.DebugAdapterNamedPipeServer=St,e.DebugAdapterNamedPipeServer=St=Ke([S],St);let Jt=class{constructor(M){this.implementation=M}};e.DebugAdapterInlineImplementation=Jt,e.DebugAdapterInlineImplementation=Jt=Ke([S],Jt);class Ut{constructor(M,te,ye){this.session=M,this.threadId=te,this.frameId=ye}}e.StackFrame=Ut;class jt{constructor(M,te){this.session=M,this.threadId=te}}e.Thread=jt;let wi=class{constructor(M,te){this.range=M,this.expression=te}};e.EvaluatableExpression=wi,e.EvaluatableExpression=wi=Ke([S],wi);var ht;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(ht||(e.InlineCompletionTriggerKind=ht={}));let Oi=class{constructor(M,te){this.range=M,this.text=te}};e.InlineValueText=Oi,e.InlineValueText=Oi=Ke([S],Oi);let gi=class{constructor(M,te,ye=!0){this.range=M,this.variableName=te,this.caseSensitiveLookup=ye}};e.InlineValueVariableLookup=gi,e.InlineValueVariableLookup=gi=Ke([S],gi);let Ei=class{constructor(M,te){this.range=M,this.expression=te}};e.InlineValueEvaluatableExpression=Ei,e.InlineValueEvaluatableExpression=Ei=Ke([S],Ei);let Ii=class{constructor(M,te){this.frameId=M,this.stoppedLocation=te}};e.InlineValueContext=Ii,e.InlineValueContext=Ii=Ke([S],Ii);var Gi;(function(z){z[z.AIGenerated=1]="AIGenerated"})(Gi||(e.NewSymbolNameTag=Gi={}));class mn{constructor(M,te){this.newSymbolName=M,this.tags=te}}e.NewSymbolName=mn;var Xi;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Xi||(e.FileChangeType=Xi={}));let Di=f=class extends Error{static FileExists(M){return new f(M,l.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(M){return new f(M,l.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(M){return new f(M,l.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(M){return new f(M,l.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(M){return new f(M,l.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(M){return new f(M,l.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}constructor(M,te=l.FileSystemProviderErrorCode.Unknown,ye){super(y.URI.isUri(M)?M.toString(!0):M),this.code=ye?.name??"Unknown",(0,l.markAsFileSystemProviderError)(this,te),Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}};e.FileSystemError=Di,e.FileSystemError=Di=f=Ke([S],Di);let Ni=class{constructor(M,te,ye){this.start=M,this.end=te,this.kind=ye}};e.FoldingRange=Ni,e.FoldingRange=Ni=Ke([S],Ni);var Mi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Mi||(e.FoldingRangeKind=Mi={}));var Qi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Qi||(e.CommentThreadCollapsibleState=Qi={}));var ki;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(ki||(e.CommentMode=ki={}));var Pi;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(Pi||(e.CommentState=Pi={}));var Yi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Yi||(e.CommentThreadState=Yi={}));var Ji;(function(z){z[z.Current=0]="Current",z[z.Outdated=1]="Outdated"})(Ji||(e.CommentThreadApplicability=Ji={}));class _i{constructor(M,te=[]){this.tokenTypes=M,this.tokenModifiers=te}}e.SemanticTokensLegend=_i;function gn(z){return typeof z>"u"||(0,h.isStringArray)(z)}class Fi{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let te=0,ye=M.tokenTypes.length;te<ye;te++)this._tokenTypeStrToInt.set(M.tokenTypes[te],te);for(let te=0,ye=M.tokenModifiers.length;te<ye;te++)this._tokenModifierStrToInt.set(M.tokenModifiers[te],te)}}push(M,te,ye,je,Ze){if(typeof M=="number"&&typeof te=="number"&&typeof ye=="number"&&typeof je=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this._pushEncoded(M,te,ye,je,Ze);if(V.isRange(M)&&typeof te=="string"&&gn(ye))return this._push(M,te,ye);throw(0,O.illegalArgument)()}_push(M,te,ye){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const je=M.start.line,Ze=M.start.character,lt=M.end.character-M.start.character,gt=this._tokenTypeStrToInt.get(te);let Kt=0;if(ye)for(const hi of ye){if(!this._tokenModifierStrToInt.has(hi))throw new Error("`tokenModifier` is not in the provided legend");const pi=this._tokenModifierStrToInt.get(hi);Kt|=1<<pi>>>0}this._pushEncoded(je,Ze,lt,gt,Kt)}_pushEncoded(M,te,ye,je,Ze){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Kt=this._data.length/5|0;let hi=0,pi=0;for(let vi=0;vi<Kt;vi++){let bi=this._data[5*vi],ji=this._data[5*vi+1];bi===0?(bi=hi,ji+=pi):bi+=hi,this._data[5*vi]=bi,this._data[5*vi+1]=ji,hi=bi,pi=ji}}let lt=M,gt=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(gt-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=gt,this._data[this._dataLen++]=ye,this._data[this._dataLen++]=je,this._data[this._dataLen++]=Ze,this._prevLine=M,this._prevChar=te}static _sortAndDeltaEncode(M){const te=[],ye=M.length/5|0;for(let gt=0;gt<ye;gt++)te[gt]=gt;te.sort((gt,Kt)=>{const hi=M[5*gt],pi=M[5*Kt];if(hi===pi){const vi=M[5*gt+1],bi=M[5*Kt+1];return vi-bi}return hi-pi});const je=new Uint32Array(M.length);let Ze=0,lt=0;for(let gt=0;gt<ye;gt++){const Kt=5*te[gt],hi=M[Kt+0],pi=M[Kt+1],vi=M[Kt+2],bi=M[Kt+3],ji=M[Kt+4],On=hi-Ze,sr=On===0?pi-lt:pi,Ki=5*gt;je[Ki+0]=On,je[Ki+1]=sr,je[Ki+2]=vi,je[Ki+3]=bi,je[Ki+4]=ji,Ze=hi,lt=pi}return je}build(M){return this._dataIsSortedAndDeltaEncoded?new xi(new Uint32Array(this._data),M):new xi(Fi._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=Fi;class xi{constructor(M,te){this.resultId=te,this.data=M}}e.SemanticTokens=xi;class Zi{constructor(M,te,ye){this.start=M,this.deleteCount=te,this.data=ye}}e.SemanticTokensEdit=Zi;class pn{constructor(M,te){this.resultId=te,this.edits=M}}e.SemanticTokensEdits=pn;var Ui;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Ui||(e.DebugConsoleMode=Ui={}));class en{constructor(M){this.name=M}}e.DebugVisualization=en;let Bi=class{static{this.Back={iconPath:new oi("arrow-left")}}constructor(){}};e.QuickInputButtons=Bi,e.QuickInputButtons=Bi=Ke([S],Bi);var zi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(zi||(e.QuickPickItemKind=zi={}));var $i;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})($i||(e.InputBoxValidationSeverity=$i={}));var tn;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(tn||(e.ExtensionKind=tn={}));class vn{static validate(M){if(typeof M.badge=="string"){let te=(0,m.nextCharLength)(M.badge,0);if(te<M.badge.length&&(te+=(0,m.nextCharLength)(M.badge,te)),M.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(M.badge&&!oi.isThemeIcon(M.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}constructor(M,te,ye){this.badge=M,this.tooltip=te,this.color=ye}}e.FileDecoration=vn;let Hi=class{constructor(M){this.kind=M}};e.ColorTheme=Hi,e.ColorTheme=Hi=Ke([S],Hi);var nn;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(nn||(e.ColorThemeKind=nn={}));class di{static isNotebookRange(M){return M instanceof di?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(M,te){if(M<0)throw(0,O.illegalArgument)("start must be positive");if(te<0)throw(0,O.illegalArgument)("end must be positive");M<=te?(this._start=M,this._end=te):(this._start=te,this._end=M)}with(M){let te=this._start,ye=this._end;return M.start!==void 0&&(te=M.start),M.end!==void 0&&(ye=M.end),te===this._start&&ye===this._end?this:new di(te,ye)}}e.NotebookRange=di;class Si{static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(te=>Si.isNotebookCellData(te))}static isNotebookCellData(M){return!0}constructor(M,te,ye,je,Ze,lt,gt){this.kind=M,this.value=te,this.languageId=ye,this.mime=je,this.outputs=Ze??[],this.metadata=lt,this.executionSummary=gt,Si.validate(this)}}e.NotebookCellData=Si;class Fe{constructor(M){this.cells=M}}e.NotebookData=Fe;class Bt{static isNotebookCellOutputItem(M){return M instanceof Bt?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const te={name:M.name,message:M.message,stack:M.stack};return Bt.json(te,"application/vnd.code.notebook.error")}static stdout(M){return Bt.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Bt.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,te="application/octet-stream"){return new Bt(M,te)}static#e=new TextEncoder;static text(M,te=R.Mimes.text){const ye=Bt.#e.encode(String(M));return new Bt(ye,te)}static json(M,te="text/x-json"){const ye=JSON.stringify(M,void 0,"	");return Bt.text(ye,te)}constructor(M,te){this.data=M,this.mime=te;const ye=(0,R.normalizeMimeType)(te,!0);if(!ye)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}}e.NotebookCellOutputItem=Bt;class yi{static isNotebookCellOutput(M){return M instanceof yi?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&Array.isArray(M.items)}static ensureUniqueMimeTypes(M,te=!1){const ye=new Set,je=new Set;for(let Ze=0;Ze<M.length;Ze++){const lt=M[Ze],gt=(0,R.normalizeMimeType)(lt.mime);if(!ye.has(gt)||(0,g.isTextStreamMime)(gt)){ye.add(gt);continue}je.add(Ze),te&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return je.size===0?M:M.filter((Ze,lt)=>!je.has(lt))}constructor(M,te,ye){this.items=yi.ensureUniqueMimeTypes(M,!0),typeof te=="string"?(this.id=te,this.metadata=ye):(this.id=(0,L.generateUuid)(),this.metadata=te??ye)}}e.NotebookCellOutput=yi;var tt;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(tt||(e.NotebookCellKind=tt={}));var vt;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(vt||(e.NotebookCellExecutionState=vt={}));var rn;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var sn;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(sn||(e.NotebookEditorRevealType=sn={}));class on{constructor(M,te){this.text=M,this.alignment=te}}e.NotebookCellStatusBarItem=on;var an;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(an||(e.NotebookControllerAffinity=an={}));var Ci;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(Ci||(e.NotebookControllerAffinity2=Ci={}));class En{constructor(M,te=[]){this.uri=M,this.provides=(0,D.asArray)(te)}}e.NotebookRendererScript=En;class bn{constructor(M){this.label=M}}e.NotebookKernelSourceAction=bn;var cn;(function(z){z[z.Named=1]="Named",z[z.Indexed=2]="Indexed"})(cn||(e.NotebookVariablesRequestKind=cn={}));let Ti=class{constructor(M,te){this.label=M,this.timestamp=te}};e.TimelineItem=Ti,e.TimelineItem=Ti=Ke([S],Ti);var ln;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(ln||(e.ExtensionMode=ln={}));var un;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(un||(e.ExtensionRuntime=un={}));var dn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(dn||(e.StandardTokenType=dn={}));class wn{constructor(M,te){this.ranges=M,this.wordPattern=te}}e.LinkedEditingRanges=wn;class _n{constructor(M){this._autoForwardAction=M}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=_n;var hn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(hn||(e.TestResultState=hn={}));var fn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(fn||(e.TestRunProfileKind=fn={}));let Vi=class{constructor(M=void 0,te=void 0,ye=void 0,je=!1){this.include=M,this.exclude=te,this.profile=ye,this.continuous=je}};e.TestRunRequest=Vi,e.TestRunRequest=Vi=Ke([S],Vi);let Wi=I=class{static diff(M,te,ye){const je=new I(M);return je.expectedOutput=te,je.actualOutput=ye,je}constructor(M){this.message=M}};e.TestMessage=Wi,e.TestMessage=Wi=I=Ke([S],Wi);let qi=class{constructor(M){this.id=M}};e.TestTag=qi,e.TestTag=qi=Ke([S],qi);class Ai{constructor(M,te){this.covered=M,this.total=te,J(this)}}e.TestCoverageCount=Ai;function J(z){if(z){if(z.covered>z.total)throw new Error(`The total number of covered items (${z.covered}) cannot be greater than the total (${z.total})`);if(z.total<0)throw new Error(`The number of covered items (${z.total}) cannot be negative`)}}class ae{static fromDetails(M,te){const ye=new Ai(0,0),je=new Ai(0,0),Ze=new Ai(0,0);for(const gt of te)if("branches"in gt){ye.total+=1,ye.covered+=gt.executed?1:0;for(const Kt of gt.branches)je.total+=1,je.covered+=Kt.executed?1:0}else Ze.total+=1,Ze.covered+=gt.executed?1:0;const lt=new ae(M,ye,je.total>0?je:void 0,Ze.total>0?Ze:void 0);return lt.detailedCoverage=te,lt}constructor(M,te,ye,je){this.uri=M,this.statementCoverage=te,this.branchCoverage=ye,this.declarationCoverage=je}}e.FileCoverage=ae;class Me{get executionCount(){return+this.executed}set executionCount(M){this.executed=M}constructor(M,te,ye=[]){this.executed=M,this.location=te,this.branches=ye}}e.StatementCoverage=Me;class rt{get executionCount(){return+this.executed}set executionCount(M){this.executed=M}constructor(M,te,ye){this.executed=M,this.location=te,this.label=ye}}e.BranchCoverage=rt;class bt{get executionCount(){return+this.executed}set executionCount(M){this.executed=M}constructor(M,te,ye){this.name=M,this.executed=te,this.location=ye}}e.DeclarationCoverage=bt;var At;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(At||(e.ExternalUriOpenerPriority=At={}));var Ri;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(Ri||(e.WorkspaceTrustState=Ri={}));var Sn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(Sn||(e.PortAutoForwardAction=Sn={}));class Nn{constructor(M,te,ye,je,Ze,lt){this.kind=M,this.name=te,this.detail=ye,this.uri=je,this.range=Ze,this.selectionRange=lt}}e.TypeHierarchyItem=Nn;class Mn{constructor(M){this.uri=M}}e.TextTabInput=Mn;class Fn{constructor(M,te){this.original=M,this.modified=te}}e.TextDiffTabInput=Fn;class xn{constructor(M,te,ye,je){this.base=M,this.input1=te,this.input2=ye,this.result=je}}e.TextMergeTabInput=xn;class Un{constructor(M,te){this.uri=M,this.viewType=te}}e.CustomEditorTabInput=Un;class Bn{constructor(M){this.viewType=M}}e.WebviewEditorTabInput=Bn;class zn{constructor(M,te){this.uri=M,this.notebookType=te}}e.NotebookEditorTabInput=zn;class $n{constructor(M,te,ye){this.original=M,this.modified=te,this.notebookType=ye}}e.NotebookDiffEditorTabInput=$n;class Hn{constructor(){}}e.TerminalEditorTabInput=Hn;class Vn{constructor(M,te){this.uri=M,this.inputBoxUri=te}}e.InteractiveWindowInput=Vn;class Wn{constructor(M){this.providerId=M}}e.ChatEditorTabInput=Wn;class qn{constructor(M){this.textDiffs=M}}e.TextMultiDiffTabInput=qn;var yn;(function(z){z[z.Down=0]="Down",z[z.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var Cn;(function(z){z[z.Action=1]="Action",z[z.Toolbar=2]="Toolbar"})(Cn||(e.ChatCopyKind=Cn={}));var In;(function(z){z[z.Short=1]="Short",z[z.Medium=2]="Medium",z[z.Full=3]="Full"})(In||(e.ChatVariableLevel=In={}));class jn{constructor(M,te){this.label=M,this.values=te}}e.ChatCompletionItem=jn;var Dn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful",z[z.Undone=2]="Undone",z[z.Accepted=3]="Accepted",z[z.Bug=4]="Bug"})(Dn||(e.InteractiveEditorResponseFeedbackKind=Dn={}));var kn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful"})(kn||(e.ChatResultFeedbackKind=kn={}));class Kn{constructor(M){this.value=typeof M=="string"?new Oe(M):M}}e.ChatResponseMarkdownPart=Kn;class Gn{constructor(M,te){this.value=M,this.baseUri=te}}e.ChatResponseFileTreePart=Gn;class Xn{constructor(M,te){this.value=M,this.title=te}}e.ChatResponseAnchorPart=Xn;class Qn{constructor(M){this.value=M}}e.ChatResponseProgressPart=Qn;class Yn{constructor(M){this.value=M}}e.ChatResponseCommandButtonPart=Yn;class Jn{constructor(M){this.value=M}}e.ChatResponseReferencePart=Jn;class Zn{constructor(M,te,ye,je){this.prompt=M,this.command=te,this.variables=ye,this.participant=je}}e.ChatRequestTurn=Zn;class er{constructor(M,te,ye,je){this.response=M,this.result=te,this.participant=ye,this.command=je}}e.ChatResponseTurn=er;var Pn;(function(z){z[z.Panel=1]="Panel",z[z.Terminal=2]="Terminal",z[z.Notebook=3]="Notebook",z[z.Editor=4]="Editor"})(Pn||(e.ChatLocation=Pn={}));class tr{constructor(M){this.content=M}}e.LanguageModelChatSystemMessage=tr;class ir{constructor(M,te){this.content=M,this.name=te}}e.LanguageModelChatUserMessage=ir;class nr{constructor(M,te){this.content=M,this.name=te}}e.LanguageModelChatAssistantMessage=nr;class Li extends Error{static NotFound(M){return new Li(M,Li.NotFound.name)}static NoPermissions(M){return new Li(M,Li.NoPermissions.name)}constructor(M,te,ye){super(M,{cause:ye}),this.name="LanguageModelError",this.code=te??""}}e.LanguageModelError=Li;var Tn;(function(z){z[z.SymbolInformation=1]="SymbolInformation",z[z.CommandInformation=2]="CommandInformation",z[z.SearchInformation=3]="SearchInformation",z[z.SettingInformation=4]="SettingInformation"})(Tn||(e.RelatedInformationType=Tn={}));var An;(function(z){z[z.Started=1]="Started",z[z.Recognizing=2]="Recognizing",z[z.Recognized=3]="Recognized",z[z.Stopped=4]="Stopped"})(An||(e.SpeechToTextStatus=An={}));var Rn;(function(z){z[z.Recognized=1]="Recognized",z[z.Stopped=2]="Stopped"})(Rn||(e.KeywordRecognitionStatus=Rn={}));class rr{constructor(M,te){this.text=M,this.range=te}}e.InlineEdit=rr;var Ln;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Ln||(e.InlineEditTriggerKind=Ln={}))}),define(Pe[246],Te([1,0,4,7]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRelatedInformation=void 0;class T{constructor(R){this._relatedInformationProviders=new Map,this._nextHandle=0,this._proxy=R.getProxy(D.MainContext.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,m,h){if(this._relatedInformationProviders.size===0)throw new Error("No related information providers registered");const y=this._relatedInformationProviders.get(R);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(m,h)??[]}getRelatedInformation(R,m,h){return this._proxy.$getAiRelatedInformation(m,h)}registerRelatedInformationProvider(R,m,h){const y=this._nextHandle;return this._nextHandle++,this._relatedInformationProviders.set(y,h),this._proxy.$registerAiRelatedInformationProvider(y,m),new O.Disposable(()=>{this._proxy.$unregisterAiRelatedInformationProvider(y),this._relatedInformationProviders.delete(y)})}}e.ExtHostRelatedInformation=T}),define(Pe[84],Te([1,0,5,4,7,20,106,3,16]),function(me,e,D,O,T,N,R,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=e.IExtHostAuthentication=void 0,e.IExtHostAuthentication=(0,m.createDecorator)("IExtHostAuthentication");let y=class{constructor(l){this._authenticationProviders=new Map,this._onDidChangeSessions=new D.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._getSessionTaskSingler=new L,this._getSessionsTaskSingler=new L,this._proxy=l.getProxy(O.MainContext.MainThreadAuthentication)}async getSession(l,w,g,r={}){const o=N.ExtensionIdentifier.toKey(l.identifier),s=[...g].sort().join(" ");return await this._getSessionTaskSingler.getOrCreate(`${o} ${w} ${s}`,async()=>{await this._proxy.$ensureProvider(w);const n=l.displayName||l.name;return this._proxy.$getSession(w,g,o,n,r)})}async getSessions(l,w,g){const r=N.ExtensionIdentifier.toKey(l.identifier),o=[...g].sort().join(" ");return await this._getSessionsTaskSingler.getOrCreate(`${r} ${o}`,async()=>{await this._proxy.$ensureProvider(w);const s=l.displayName||l.name;return this._proxy.$getSessions(w,g,r,s)})}async removeSession(l,w){const g=this._authenticationProviders.get(l);return g?g.provider.removeSession(w):this._proxy.$removeSession(l,w)}registerAuthenticationProvider(l,w,g,r){if(this._authenticationProviders.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this._authenticationProviders.set(l,{label:w,provider:g,options:r??{supportsMultipleAccounts:!1}});const o=g.onDidChangeSessions(s=>this._proxy.$sendDidChangeSessions(l,s));return this._proxy.$registerAuthenticationProvider(l,w,r?.supportsMultipleAccounts??!1),new T.Disposable(()=>{o.dispose(),this._authenticationProviders.delete(l),this._proxy.$unregisterAuthenticationProvider(l)})}$createSession(l,w,g){const r=this._authenticationProviders.get(l);if(r)return Promise.resolve(r.provider.createSession(w,g));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$removeSession(l,w){const g=this._authenticationProviders.get(l);if(g)return Promise.resolve(g.provider.removeSession(w));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$getSessions(l,w){const g=this._authenticationProviders.get(l);if(g)return Promise.resolve(g.provider.getSessions(w));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,w){return l.startsWith(R.INTERNAL_AUTH_PROVIDER_PREFIX)||this._onDidChangeSessions.fire({provider:{id:l,label:w}}),Promise.resolve()}};e.ExtHostAuthentication=y,e.ExtHostAuthentication=y=Ke([He(0,h.IExtHostRpcService)],y);class L{constructor(){this._inFlightPromises=new Map}getOrCreate(l,w){const g=this._inFlightPromises.get(l);if(g)return g;const r=w().finally(()=>this._inFlightPromises.delete(l));return this._inFlightPromises.set(l,r),r}}}),define(Pe[110],Te([1,0,2,4,7,3,16,13,18,15,19,25]),function(me,e,D,O,T,N,R,m,h,y,L,_){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let w=class{static{l=this}static{this._handlePool=0}static{this._maxEventSize=250}constructor(r,o){this._logService=o,this._provider=new Map,this._proxy=r.getProxy(O.MainContext.MainThreadDecorations)}registerFileDecorationProvider(r,o){const s=l._handlePool++;this._provider.set(s,{provider:r,extensionDescription:o}),this._proxy.$registerDecorationProvider(s,o.identifier.value);const n=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this._proxy.$onDidChange(s,null);return}const a=(0,h.asArray)(i);if(a.length<=l._maxEventSize){this._proxy.$onDidChange(s,a);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,a.length);const d=a.map(c=>({uri:c,rank:(0,y.count)(c.path,"/")})),t=(0,h.groupBy)(d,(c,p)=>c.rank-p.rank||(0,y.compare)(c.uri.path,p.uri.path)),E=[];e:for(const c of t){let p;for(const b of c){const v=(0,L.dirname)(b.uri.path);if(p!==v&&(p=v,E.push(b.uri)>=l._maxEventSize))break e}}this._proxy.$onDidChange(s,E)});return new T.Disposable(()=>{n?.dispose(),this._proxy.$unregisterDecorationProvider(s),this._provider.delete(s)})}async $provideDecorations(r,o,s){if(!this._provider.has(r))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:a}=this._provider.get(r);return await Promise.all(o.map(async d=>{try{const{uri:t,id:E}=d,c=await Promise.resolve(i.provideFileDecoration(D.URI.revive(t),s));if(!c)return;try{T.FileDecoration.validate(c),c.badge&&typeof c.badge!="string"&&(0,_.checkProposedApiEnabled)(a,"codiconDecoration"),n[E]=[c.propagate,c.tooltip,c.badge,c.color]}catch(p){this._logService.warn(`INVALID decoration from extension '${a.identifier.value}': ${p}`)}}catch(t){this._logService.error(t)}})),n}};e.ExtHostDecorations=w,e.ExtHostDecorations=w=l=Ke([He(0,R.IExtHostRpcService),He(1,m.ILogService)],w),e.IExtHostDecorations=(0,N.createDecorator)("IExtHostDecorations")}),define(Pe[247],Te([1,0,14,2,7,4,12,24,15]),function(me,e,D,O,T,N,R,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class y{static{this._handlePool=0}constructor(_,l,w){this._documentsAndEditors=l,this._logService=w,this._documentContentProviders=new Map,this._proxy=_.getProxy(N.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,l){if(Object.keys(R.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const w=y._handlePool++;this._documentContentProviders.set(w,l),this._proxy.$registerTextContentProvider(w,_);let g;if(typeof l.onDidChange=="function"){let r;g=l.onDidChange(async o=>{if(o.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this._documentsAndEditors.getDocument(o))return;r&&await r;const s=this.$provideTextDocumentContent(w,o).then(async n=>{if(!n&&typeof n!="string")return;const i=this._documentsAndEditors.getDocument(o);if(!i)return;const a=(0,h.splitLines)(n);if(!i.equalLines(a))return this._proxy.$onVirtualDocumentChange(o,n)}).catch(D.onUnexpectedError).finally(()=>{r===s&&(r=void 0)});r=s})}return new T.Disposable(()=>{this._documentContentProviders.delete(w)&&this._proxy.$unregisterTextContentProvider(w),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(_,l){const w=this._documentContentProviders.get(_);return w?Promise.resolve(w.provideTextDocumentContent(O.URI.revive(l),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=y}),define(Pe[111],Te([1,0,56,12,15,303,152,7,18]),function(me,e,D,O,T,N,R,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=void 0,e.setWordDefinitionFor=L;const y=new Map;function L(g,r){r?y.set(g,r):y.delete(g)}function _(g){return y.get(g)}class l extends N.MirrorTextModel{constructor(r,o,s,n,i,a,d){super(o,s,n,i),this._proxy=r,this._languageId=a,this._isDirty=d,this._isDisposed=!1}dispose(){(0,D.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(r){return(0,h.equals)(this._lines,r)}get document(){if(!this._document){const r=this;this._document={get uri(){return r._uri},get fileName(){return r._uri.fsPath},get isUntitled(){return r._uri.scheme===O.Schemas.untitled},get languageId(){return r._languageId},get version(){return r._versionId},get isClosed(){return r._isDisposed},get isDirty(){return r._isDirty},save(){return r._save()},getText(o){return o?r._getTextInRange(o):r.getText()},get eol(){return r._eol===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return r._lines.length},lineAt(o){return r._lineAt(o)},offsetAt(o){return r._offsetAt(o)},positionAt(o){return r._positionAt(o)},validateRange(o){return r._validateRange(o)},validatePosition(o){return r._validatePosition(o)},getWordRangeAtPosition(o,s){return r._getWordRangeAtPosition(o,s)}}}return Object.freeze(this._document)}_acceptLanguageId(r){(0,D.ok)(!this._isDisposed),this._languageId=r}_acceptIsDirty(r){(0,D.ok)(!this._isDisposed),this._isDirty=r}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(r){const o=this._validateRange(r);if(o.isEmpty)return"";if(o.isSingleLine)return this._lines[o.start.line].substring(o.start.character,o.end.character);const s=this._eol,n=o.start.line,i=o.end.line,a=[];a.push(this._lines[n].substring(o.start.character));for(let d=n+1;d<i;d++)a.push(this._lines[d]);return a.push(this._lines[i].substring(0,o.end.character)),a.join(s)}_lineAt(r){let o;if(r instanceof m.Position?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this._lines.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new w(o,this._lines[o],o===this._lines.length-1)}_offsetAt(r){return r=this._validatePosition(r),this._ensureLineStarts(),this._lineStarts.getPrefixSum(r.line-1)+r.character}_positionAt(r){r=Math.floor(r),r=Math.max(0,r),this._ensureLineStarts();const o=this._lineStarts.getIndexOf(r),s=this._lines[o.index].length;return new m.Position(o.index,Math.min(o.remainder,s))}_validateRange(r){if(!(r instanceof m.Range))throw new Error("Invalid argument");const o=this._validatePosition(r.start),s=this._validatePosition(r.end);return o===r.start&&s===r.end?r:new m.Range(o.line,o.character,s.line,s.character)}_validatePosition(r){if(!(r instanceof m.Position))throw new Error("Invalid argument");if(this._lines.length===0)return r.with(0,0);let{line:o,character:s}=r,n=!1;if(o<0)o=0,s=0,n=!0;else if(o>=this._lines.length)o=this._lines.length-1,s=this._lines[o].length,n=!0;else{const i=this._lines[o].length;s<0?(s=0,n=!0):s>i&&(s=i,n=!0)}return n?new m.Position(o,s):r}_getWordRangeAtPosition(r,o){const s=this._validatePosition(r);if(!o)o=_(this._languageId);else if((0,T.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const n=(0,R.getWordAtText)(s.character+1,(0,R.ensureValidWordDefinition)(o),this._lines[s.line],0);if(n)return new m.Range(s.line,n.startColumn-1,s.line,n.endColumn-1)}}e.ExtHostDocumentData=l;class w{constructor(r,o,s){this._line=r,this._text=o,this._isLastLine=s}get lineNumber(){return this._line}get text(){return this._text}get range(){return new m.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new m.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=w}),define(Pe[248],Te([1,0,4,7]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAiEmbeddingVector=void 0;class T{constructor(R){this._AiEmbeddingVectorProviders=new Map,this._nextHandle=0,this._proxy=R.getProxy(D.MainContext.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,m,h){if(this._AiEmbeddingVectorProviders.size===0)throw new Error("No embedding vector providers registered");const y=this._AiEmbeddingVectorProviders.get(R);if(!y)throw new Error("Embedding vector provider not found");const L=await y.provideEmbeddingVector(m,h);if(!L)throw new Error("Embedding vector provider returned undefined");return L}registerEmbeddingVectorProvider(R,m,h){const y=this._nextHandle;return this._nextHandle++,this._AiEmbeddingVectorProviders.set(y,h),this._proxy.$registerAiEmbeddingVectorProvider(m,y),new O.Disposable(()=>{this._proxy.$unregisterAiEmbeddingVectorProvider(y),this._AiEmbeddingVectorProviders.delete(y)})}}e.ExtHostAiEmbeddingVector=T}),define(Pe[64],Te([1,0,4,43,7,22,3,16,44,6,11,23,12]),function(me,e,D,O,T,N,R,m,h,y,L,_,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let g=w=class{constructor(o,s){this._fileSystemProvider=new Map,this._writeQueue=new L.ResourceQueue,this._proxy=o.getProxy(D.MainContext.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let a;const d=n._fileSystemProvider.get(i.scheme);return d?(await n._proxy.$ensureActivation(i.scheme),a=await d.impl.stat(i)):a=await n._proxy.$stat(i),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===O.FilePermission.Readonly?1:void 0}}catch(a){w._handleError(a)}},async readDirectory(i){try{const a=n._fileSystemProvider.get(i.scheme);return a?(await n._proxy.$ensureActivation(i.scheme),(await a.impl.readDirectory(i)).slice()):await n._proxy.$readdir(i)}catch(a){return w._handleError(a)}},async createDirectory(i){try{const a=n._fileSystemProvider.get(i.scheme);return a&&!a.isReadonly?(await n._proxy.$ensureActivation(i.scheme),await n.mkdirp(a.impl,a.extUri,i)):await n._proxy.$mkdir(i)}catch(a){return w._handleError(a)}},async readFile(i){try{const a=n._fileSystemProvider.get(i.scheme);return a?(await n._proxy.$ensureActivation(i.scheme),(await a.impl.readFile(i)).slice()):(await n._proxy.$readFile(i)).buffer}catch(a){return w._handleError(a)}},async writeFile(i,a){try{const d=n._fileSystemProvider.get(i.scheme);return d&&!d.isReadonly?(await n._proxy.$ensureActivation(i.scheme),await n.mkdirp(d.impl,d.extUri,d.extUri.dirname(i)),await n._writeQueue.queueFor(i,()=>Promise.resolve(d.impl.writeFile(i,a,{create:!0,overwrite:!0})))):await n._proxy.$writeFile(i,N.VSBuffer.wrap(a))}catch(d){return w._handleError(d)}},async delete(i,a){try{const d=n._fileSystemProvider.get(i.scheme);return d&&!d.isReadonly&&!a?.useTrash?(await n._proxy.$ensureActivation(i.scheme),await d.impl.delete(i,{recursive:!1,...a})):await n._proxy.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(d){return w._handleError(d)}},async rename(i,a,d){try{return await n._proxy.$rename(i,a,{overwrite:!1,...d})}catch(t){return w._handleError(t)}},async copy(i,a,d){try{return await n._proxy.$copy(i,a,{overwrite:!1,...d})}catch(t){return w._handleError(t)}},isWritableFileSystem(i){const a=s.getCapabilities(i);if(typeof a=="number")return!(a&2048)}})}async mkdirp(o,s,n){const i=[];for(;!s.isEqual(n,s.dirname(n));)try{if(!((await o.stat(n)).type&O.FileType.Directory))throw T.FileSystemError.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(O.toFileSystemProviderErrorCode(a)!==O.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(s.basename(n)),n=s.dirname(n)}for(let a=i.length-1;a>=0;a--){n=s.joinPath(n,i[a]);try{await o.createDirectory(n)}catch(d){if(O.toFileSystemProviderErrorCode(d)!==O.FileSystemProviderErrorCode.FileExists)throw d}}}static _handleError(o){if(o instanceof T.FileSystemError)throw o;if(o instanceof O.FileSystemProviderError)switch(o.code){case O.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(o.message);case O.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(o.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(o.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(o.message);case O.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(o.message);case O.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(o.message);default:throw new T.FileSystemError(o.message,o.name)}if(!(o instanceof Error))throw new T.FileSystemError(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw T.FileSystemError.Unavailable(o.message);switch(o.name){case O.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(o.message);case O.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(o.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(o.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(o.message);case O.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(o.message);case O.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(o.message);default:throw new T.FileSystemError(o.message,o.name)}}addFileSystemProvider(o,s,n){return this._fileSystemProvider.set(o,{impl:s,extUri:n?.isCaseSensitive?_.extUri:_.extUriIgnorePathCase,isReadonly:!!n?.isReadonly}),(0,y.toDisposable)(()=>this._fileSystemProvider.delete(o))}getFileSystemProviderExtUri(o){return this._fileSystemProvider.get(o)?.extUri??_.extUri}};e.ExtHostConsumerFileSystem=g,e.ExtHostConsumerFileSystem=g=w=Ke([He(0,m.IExtHostRpcService),He(1,h.IExtHostFileSystemInfo)],g),e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(Pe[249],Te([1,0,4,7]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class T{constructor(R){this._IssueUriRequestHandlers=new Map,this._IssueDataProviders=new Map,this._proxy=R.getProxy(D.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(R,m){if(this._IssueUriRequestHandlers.size===0)throw new Error("No issue request handlers registered");const h=this._IssueUriRequestHandlers.get(R);if(!h)throw new Error("Issue request handler not found");const y=await h.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(R,m){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const h=this._IssueDataProviders.get(R);if(!h)throw new Error("Issue data provider not found");const y=await h.provideIssueData(m);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(R,m){if(this._IssueDataProviders.size===0)throw new Error("No issue request handlers registered");const h=this._IssueDataProviders.get(R);if(!h)throw new Error("Issue data provider not found");const y=await h.provideIssueTemplate(m);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(R,m){const h=R.identifier.value;return this._IssueUriRequestHandlers.set(h,m),this._proxy.$registerIssueUriRequestHandler(h),new O.Disposable(()=>{this._proxy.$unregisterIssueUriRequestHandler(h),this._IssueUriRequestHandlers.delete(h)})}registerIssueDataProvider(R,m){const h=R.identifier.value;return this._IssueDataProviders.set(h,m),this._proxy.$registerIssueDataProvider(h),new O.Disposable(()=>{this._proxy.$unregisterIssueDataProvider(h),this._IssueDataProviders.delete(h)})}}e.ExtHostIssueReporter=T}),define(Pe[85],Te([1,0,3,27,13,64,2]),function(me,e,D,O,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,D.createDecorator)("IExtensionStoragePaths");let m=class{constructor(y,L,_){this._logService=L,this._extHostFileSystem=_,this._workspace=y.workspace??void 0,this._environment=y.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(y){return R.URI.joinPath(this._environment.workspaceStorageHome,y)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const y=this._workspace.id,L=await this._getWorkspaceStorageURI(y);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(y){if(this._value)return R.URI.joinPath(this._value,y.identifier.value)}globalValue(y){return R.URI.joinPath(this._environment.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=m,e.ExtensionStoragePaths=m=Ke([He(0,O.IExtHostInitDataService),He(1,T.ILogService),He(2,N.IExtHostConsumerFileSystem)],m)}),define(Pe[250],Te([1,0,7,16,5]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let N=class{constructor(m){this._actual=new D.ColorTheme(D.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new T.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(m){let h;switch(m){case"light":h=D.ColorThemeKind.Light;break;case"hcDark":h=D.ColorThemeKind.HighContrast;break;case"hcLight":h=D.ColorThemeKind.HighContrastLight;break;default:h=D.ColorThemeKind.Dark}this._actual=new D.ColorTheme(h),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};e.ExtHostTheming=N,e.ExtHostTheming=N=Ke([He(0,O.IExtHostRpcService)],N)}),define(Pe[86],Te([1,0,24,5,6,174,3,13,203,4,27,16,7]),function(me,e,D,O,T,N,R,m,h,y,L,_,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;class w extends h.DisposableTunnel{}var g;(function(o){function s(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?h.TunnelPrivacyId.Public:h.TunnelPrivacyId.Private),protocol:i.protocol}}o.fromApiTunnel=s;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==h.TunnelPrivacyId.ConstantPrivate&&i.privacy!==h.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}o.fromServiceTunnel=n})(g||(e.TunnelDtoConverter=g={})),e.IExtHostTunnelService=(0,R.createDecorator)("IExtHostTunnelService");let r=class extends T.Disposable{constructor(s,n,i){super(),this.logService=i,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new O.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=s.getProxy(y.MainContext.MainThreadTunnelService)}async openTunnel(s,n){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this._proxy.$openTunnel(n,s.displayName);if(i){const a=new w(i.remoteAddress,i.localAddress,()=>this._proxy.$closeTunnel(i.remoteAddress));return this._register(a),a}}async getTunnels(){return this._proxy.$getTunnels()}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(s,n){s.portRange===void 0&&s.commandPattern===void 0&&this.logService.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(i,{selector:s,provider:n}),this._proxy.$registerPortsAttributesProvider(s,i),new l.Disposable(()=>{this._portAttributesProviders.delete(i),this._proxy.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(s,n,i,a,d){const t=[];for(const c of s){const p=this._portAttributesProviders.get(c);if(!p)return[];t.push(...await Promise.all(n.map(async b=>{let v;try{v=await p.provider.providePortAttributes({port:b,pid:i,commandLine:a},d)}catch{v=await p.provider.providePortAttributes(b,i,a,d)}return{providedAttributes:v,port:b}})))}const E=t.filter(c=>!!c.providedAttributes);return E.length>0?E.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,n){if(this._forwardPortProvider)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this._forwardPortProvider=async(a,d)=>await s.provideTunnel(a,d,D.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this._proxy.$setTunnelProvider(i),Promise.resolve((0,T.toDisposable)(()=>{this._forwardPortProvider=void 0,this._proxy.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,n){if(s){s.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this._showCandidatePort=s.showCandidatePort,this._proxy.$setCandidateFilter());const i=s.tunnelFactory??(n?this.makeManagedTunnelFactory(n):void 0);if(i){this._forwardPortProvider=i;let a=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:N.localize(0,null),themeIcon:"lock"},{id:"public",label:N.localize(1,null),themeIcon:"eye"}]);const d=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this._proxy.$setTunnelProvider(d)}}else this._forwardPortProvider=void 0;return(0,T.toDisposable)(()=>{this._forwardPortProvider=void 0})}makeManagedTunnelFactory(s){}async $closeTunnel(s,n){if(this._extensionTunnels.has(s.host)){const i=this._extensionTunnels.get(s.host);i.has(s.port)&&(n&&i.get(s.port).disposeListener.dispose(),await i.get(s.port).tunnel.dispose(),i.delete(s.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(s,n){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this._forwardPortProvider(s,n);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const a=await i;if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.logService.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this._extensionTunnels.has(s.remoteAddress.host)||this._extensionTunnels.set(s.remoteAddress.host,new Map);const d=this._register(a.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(a.remoteAddress))));return this._extensionTunnels.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:a,disposeListener:d}),g.fromApiTunnel(a)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(s){const n=await Promise.all(s.map(a=>this._showCandidatePort(a.host,a.port,a.detail??""))),i=s.filter((a,d)=>n[d]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(a=>a.port).join(", ")} to ${i.map(a=>a.port).join(", ")}`),i}};e.ExtHostTunnelService=r,e.ExtHostTunnelService=r=Ke([He(0,_.IExtHostRpcService),He(1,L.IExtHostInitDataService),He(2,m.ILogService)],r)}),define(Pe[8],Te([1,0,18,22,132,251,54,28,124,53,69,26,127,23,17,2,29,87,100,105,104,212,83,49,61,223,25,7]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o,s,n,i,a,d,t,E,c,p,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.isDecorationOptionsArr=j,e.fromRangeOrRangeWithMessage=fe,e.pathOrURIToURI=Ce;var u;(function(we){function ke(G){const{selectionStartLineNumber:Ee,selectionStartColumn:$e,positionLineNumber:Xe,positionColumn:qe}=G,ct=new v.Position(Ee-1,$e-1),_t=new v.Position(Xe-1,qe-1);return new v.Selection(ct,_t)}we.to=ke;function ce(G){const{anchor:Ee,active:$e}=G;return{selectionStartLineNumber:Ee.line+1,selectionStartColumn:Ee.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}we.from=ce})(u||(e.Selection=u={}));var C;(function(we){function ke(G){if(!G)return;const{start:Ee,end:$e}=G;return{startLineNumber:Ee.line+1,startColumn:Ee.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}we.from=ke;function ce(G){if(!G)return;const{startLineNumber:Ee,startColumn:$e,endLineNumber:Xe,endColumn:qe}=G;return new v.Range(Ee-1,$e-1,Xe-1,qe-1)}we.to=ce})(C||(e.Range=C={}));var f;(function(we){function ke(G){return{uri:G.uri,range:C.from(G.range)}}we.from=ke;function ce(G){return new v.Location(r.URI.revive(G.uri),C.to(G.range))}we.to=ce})(f||(e.Location=f={}));var I;(function(we){function ke(ce){switch(ce){case 1:return v.StandardTokenType.Comment;case 0:return v.StandardTokenType.Other;case 3:return v.StandardTokenType.RegEx;case 2:return v.StandardTokenType.String}}we.to=ke})(I||(e.TokenType=I={}));var S;(function(we){function ke(G){return new v.Position(G.lineNumber-1,G.column-1)}we.to=ke;function ce(G){return{lineNumber:G.line+1,column:G.character+1}}we.from=ce})(S||(e.Position=S={}));var P;(function(we){function ke(Ee,$e,Xe){return(0,D.coalesce)((0,D.asArray)(Ee).map(qe=>ce(qe,$e,Xe)))}we.from=ke;function ce(Ee,$e,Xe){if(typeof Ee=="string")return{$serialized:!0,language:Ee,isBuiltin:Xe?.isBuiltin};if(Ee)return{$serialized:!0,language:Ee.language,scheme:G(Ee.scheme,$e),pattern:ge.from(Ee.pattern)??void 0,exclusive:Ee.exclusive,notebookType:Ee.notebookType,isBuiltin:Xe?.isBuiltin}}function G(Ee,$e){return $e&&typeof Ee=="string"?$e.transformOutgoingScheme(Ee):Ee}})(P||(e.DocumentSelector=P={}));var k;(function(we){function ke(G){switch(G){case v.DiagnosticTag.Unnecessary:return 1;case v.DiagnosticTag.Deprecated:return 2}}we.from=ke;function ce(G){switch(G){case 1:return v.DiagnosticTag.Unnecessary;case 2:return v.DiagnosticTag.Deprecated;default:return}}we.to=ce})(k||(e.DiagnosticTag=k={}));var H;(function(we){function ke(G){let Ee;return G.code&&((0,g.isString)(G.code)||(0,g.isNumber)(G.code)?Ee=String(G.code):Ee={value:String(G.code.value),target:G.code.target}),{...C.from(G.range),message:G.message,source:G.source,code:Ee,severity:V.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map($.from),tags:Array.isArray(G.tags)?(0,D.coalesce)(G.tags.map(k.from)):void 0}}we.from=ke;function ce(G){const Ee=new v.Diagnostic(C.to(G),G.message,V.to(G.severity));return Ee.source=G.source,Ee.code=(0,g.isString)(G.code)?G.code:G.code?.value,Ee.relatedInformation=G.relatedInformation&&G.relatedInformation.map($.to),Ee.tags=G.tags&&(0,D.coalesce)(G.tags.map(k.to)),Ee}we.to=ce})(H||(e.Diagnostic=H={}));var $;(function(we){function ke(G){return{...C.from(G.location.range),message:G.message,resource:G.location.uri}}we.from=ke;function ce(G){return new v.DiagnosticRelatedInformation(new v.Location(G.resource,C.to(G)),G.message)}we.to=ce})($||(e.DiagnosticRelatedInformation=$={}));var V;(function(we){function ke(G){switch(G){case v.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}we.from=ke;function ce(G){switch(G){case n.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}we.to=ce})(V||(e.DiagnosticSeverity=V={}));var A;(function(we){function ke(G){return typeof G=="number"&&G>=v.ViewColumn.One?G-1:G===v.ViewColumn.Beside?p.SIDE_GROUP:p.ACTIVE_GROUP}we.from=ke;function ce(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=ce})(A||(e.ViewColumn=A={}));function U(we){return typeof we.range<"u"}function j(we){return we.length===0?!0:!!U(we[0])}var ie;(function(we){function ke(qe){return qe.map(we.from)}we.fromMany=ke;function ce(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function G(qe){let ct;if(ce(qe)){const{language:Ut,value:jt}=qe;ct={value:"```"+Ut+`
`+jt+"\n```\n"}}else v.MarkdownString.isMarkdownString(qe)?ct={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ct={value:qe}:ct={value:""};const _t=Object.create(null);ct.uris=_t;const St=Ut=>{try{let jt=r.URI.parse(Ut,!0);jt=jt.with({query:Ee(jt.query,_t)}),_t[Ut]=jt}catch{}return""},Jt=new h.marked.Renderer;return Jt.link=St,Jt.image=Ut=>typeof Ut=="string"?St(R.parseHrefAndDimensions(Ut).href):"",(0,h.marked)(ct.value,{renderer:Jt}),ct}we.from=G;function Ee(qe,ct){if(!qe)return qe;let _t;try{_t=(0,y.parse)(qe)}catch{}if(!_t)return qe;let St=!1;return _t=(0,_.cloneAndChange)(_t,Jt=>{if(r.URI.isUri(Jt)){const Ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[Ut]=Jt,St=!0,Ut}else return}),St?JSON.stringify(_t):qe}function $e(qe){const ct=new v.MarkdownString(qe.value,qe.supportThemeIcons);return ct.isTrusted=qe.isTrusted,ct.supportHtml=qe.supportHtml,ct.baseUri=qe.baseUri?r.URI.from(qe.baseUri):void 0,ct}we.to=$e;function Xe(qe){if(qe)return typeof qe=="string"?qe:we.from(qe)}we.fromStrict=Xe})(ie||(e.MarkdownString=ie={}));function fe(we){return j(we)?we.map(ke=>({range:C.from(ke.range),hoverMessage:Array.isArray(ke.hoverMessage)?ie.fromMany(ke.hoverMessage):ke.hoverMessage?ie.from(ke.hoverMessage):void 0,renderOptions:ke.renderOptions})):we.map(ke=>({range:C.from(ke)}))}function Ce(we){return typeof we>"u"?we:typeof we=="string"?r.URI.file(we):we}var _e;(function(we){function ke(ce){return typeof ce>"u"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?Ce(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}we.from=ke})(_e||(e.ThemableDecorationAttachmentRenderOptions=_e={}));var oe;(function(we){function ke(ce){return typeof ce>"u"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?Ce(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?_e.from(ce.before):void 0,after:ce.after?_e.from(ce.after):void 0}}we.from=ke})(oe||(e.ThemableDecorationRenderOptions=oe={}));var pe;(function(we){function ke(ce){if(typeof ce>"u")return ce;switch(ce){case v.DecorationRangeBehavior.OpenOpen:return 0;case v.DecorationRangeBehavior.ClosedClosed:return 1;case v.DecorationRangeBehavior.OpenClosed:return 2;case v.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=ke})(pe||(e.DecorationRangeBehavior=pe={}));var ne;(function(we){function ke(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?pe.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?oe.from(ce.light):void 0,dark:ce.dark?oe.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?Ce(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?_e.from(ce.before):void 0,after:ce.after?_e.from(ce.after):void 0}}we.from=ke})(ne||(e.DecorationRenderOptions=ne={}));var Ie;(function(we){function ke(G){return{text:G.newText,eol:G.newEol&&ft.from(G.newEol),range:C.from(G.range)}}we.from=ke;function ce(G){const Ee=new v.TextEdit(C.to(G.range),G.text);return Ee.newEol=typeof G.eol>"u"?void 0:ft.to(G.eol),Ee}we.to=ce})(Ie||(e.TextEdit=Ie={}));var xe;(function(we){function ke(G,Ee){const $e={edits:[]};if(G instanceof v.WorkspaceEdit){const Xe=new m.ResourceSet;for(const qe of G._allEntries())qe._type===1&&r.URI.isUri(qe.to)&&qe.from===void 0&&Xe.add(qe.to);for(const qe of G._allEntries())if(qe._type===1){let ct;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ct={type:"base64",value:(0,O.encodeBase64)(O.VSBuffer.wrap(qe.options.contents))}:ct={type:"dataTransferItem",id:qe.options.contents._itemId}),$e.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ct},metadata:qe.metadata})}else qe._type===2?$e.edits.push({resource:qe.uri,textEdit:Ie.from(qe.edit),versionId:Xe.has(qe.uri)?void 0:Ee?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?$e.edits.push({resource:qe.uri,textEdit:{range:C.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Xe.has(qe.uri)?void 0:Ee?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?$e.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Ee?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&$e.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Ee?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Gt.from)}})}return $e}we.from=ke;function ce(G){const Ee=new v.WorkspaceEdit,$e=new m.ResourceMap;for(const Xe of G.edits)if(Xe.textEdit){const qe=Xe,ct=r.URI.revive(qe.resource),_t=C.to(qe.textEdit.range),St=qe.textEdit.text,Jt=qe.textEdit.insertAsSnippet;let Ut;Jt?Ut=v.SnippetTextEdit.replace(_t,new v.SnippetString(St)):Ut=v.TextEdit.replace(_t,St);const jt=$e.get(ct);jt?jt.push(Ut):$e.set(ct,[Ut])}else Ee.renameFile(r.URI.revive(Xe.oldResource),r.URI.revive(Xe.newResource),Xe.options);for(const[Xe,qe]of $e)Ee.set(Xe,qe);return Ee}we.to=ce})(xe||(e.WorkspaceEdit=xe={}));var re;(function(we){const ke=Object.create(null);ke[v.SymbolKind.File]=0,ke[v.SymbolKind.Module]=1,ke[v.SymbolKind.Namespace]=2,ke[v.SymbolKind.Package]=3,ke[v.SymbolKind.Class]=4,ke[v.SymbolKind.Method]=5,ke[v.SymbolKind.Property]=6,ke[v.SymbolKind.Field]=7,ke[v.SymbolKind.Constructor]=8,ke[v.SymbolKind.Enum]=9,ke[v.SymbolKind.Interface]=10,ke[v.SymbolKind.Function]=11,ke[v.SymbolKind.Variable]=12,ke[v.SymbolKind.Constant]=13,ke[v.SymbolKind.String]=14,ke[v.SymbolKind.Number]=15,ke[v.SymbolKind.Boolean]=16,ke[v.SymbolKind.Array]=17,ke[v.SymbolKind.Object]=18,ke[v.SymbolKind.Key]=19,ke[v.SymbolKind.Null]=20,ke[v.SymbolKind.EnumMember]=21,ke[v.SymbolKind.Struct]=22,ke[v.SymbolKind.Event]=23,ke[v.SymbolKind.Operator]=24,ke[v.SymbolKind.TypeParameter]=25;function ce(Ee){return typeof ke[Ee]=="number"?ke[Ee]:6}we.from=ce;function G(Ee){for(const $e in ke)if(ke[$e]===Ee)return Number($e);return v.SymbolKind.Property}we.to=G})(re||(e.SymbolKind=re={}));var F;(function(we){function ke(G){switch(G){case v.SymbolTag.Deprecated:return 1}}we.from=ke;function ce(G){switch(G){case 1:return v.SymbolTag.Deprecated}}we.to=ce})(F||(e.SymbolTag=F={}));var Z;(function(we){function ke(G){return{name:G.name,kind:re.from(G.kind),tags:G.tags&&G.tags.map(F.from),containerName:G.containerName,location:he.from(G.location)}}we.from=ke;function ce(G){const Ee=new v.SymbolInformation(G.name,re.to(G.kind),G.containerName,he.to(G.location));return Ee.tags=G.tags&&G.tags.map(F.to),Ee}we.to=ce})(Z||(e.WorkspaceSymbol=Z={}));var be;(function(we){function ke(G){const Ee={name:G.name||"!!MISSING: name!!",detail:G.detail,range:C.from(G.range),selectionRange:C.from(G.selectionRange),kind:re.from(G.kind),tags:G.tags?.map(F.from)??[]};return G.children&&(Ee.children=G.children.map(ke)),Ee}we.from=ke;function ce(G){const Ee=new v.DocumentSymbol(G.name,G.detail,re.to(G.kind),C.to(G.range),C.to(G.selectionRange));return(0,D.isNonEmptyArray)(G.tags)&&(Ee.tags=G.tags.map(F.to)),G.children&&(Ee.children=G.children.map(ce)),Ee}we.to=ce})(be||(e.DocumentSymbol=be={}));var Le;(function(we){function ke(G){const Ee=new v.CallHierarchyItem(re.to(G.kind),G.name,G.detail||"",r.URI.revive(G.uri),C.to(G.range),C.to(G.selectionRange));return Ee._sessionId=G._sessionId,Ee._itemId=G._itemId,Ee}we.to=ke;function ce(G,Ee,$e){if(Ee=Ee??G._sessionId,$e=$e??G._itemId,Ee===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:$e,name:G.name,detail:G.detail,kind:re.from(G.kind),uri:G.uri,range:C.from(G.range),selectionRange:C.from(G.selectionRange),tags:G.tags?.map(F.from)}}we.from=ce})(Le||(e.CallHierarchyItem=Le={}));var Se;(function(we){function ke(ce){return new v.CallHierarchyIncomingCall(Le.to(ce.from),ce.fromRanges.map(G=>C.to(G)))}we.to=ke})(Se||(e.CallHierarchyIncomingCall=Se={}));var ve;(function(we){function ke(ce){return new v.CallHierarchyOutgoingCall(Le.to(ce.to),ce.fromRanges.map(G=>C.to(G)))}we.to=ke})(ve||(e.CallHierarchyOutgoingCall=ve={}));var he;(function(we){function ke(G){return{range:G.range&&C.from(G.range),uri:G.uri}}we.from=ke;function ce(G){return new v.Location(r.URI.revive(G.uri),C.to(G.range))}we.to=ce})(he||(e.location=he={}));var K;(function(we){function ke(G){const Ee=G,$e=G;return{originSelectionRange:Ee.originSelectionRange?C.from(Ee.originSelectionRange):void 0,uri:Ee.targetUri?Ee.targetUri:$e.uri,range:C.from(Ee.targetRange?Ee.targetRange:$e.range),targetSelectionRange:Ee.targetSelectionRange?C.from(Ee.targetSelectionRange):void 0}}we.from=ke;function ce(G){return{targetUri:r.URI.revive(G.uri),targetRange:C.to(G.range),targetSelectionRange:G.targetSelectionRange?C.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?C.to(G.originSelectionRange):void 0}}we.to=ce})(K||(e.DefinitionLink=K={}));var Y;(function(we){function ke(G){return{range:C.from(G.range),contents:ie.fromMany(G.contents)}}we.from=ke;function ce(G){return new v.Hover(G.contents.map(ie.to),C.to(G.range))}we.to=ce})(Y||(e.Hover=Y={}));var le;(function(we){function ke(G){return{range:C.from(G.range),expression:G.expression}}we.from=ke;function ce(G){return new v.EvaluatableExpression(C.to(G.range),G.expression)}we.to=ce})(le||(e.EvaluatableExpression=le={}));var de;(function(we){function ke(G){if(G instanceof v.InlineValueText)return{type:"text",range:C.from(G.range),text:G.text};if(G instanceof v.InlineValueVariableLookup)return{type:"variable",range:C.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof v.InlineValueEvaluatableExpression)return{type:"expression",range:C.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}we.from=ke;function ce(G){switch(G.type){case"text":return{range:C.to(G.range),text:G.text};case"variable":return{range:C.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:C.to(G.range),expression:G.expression}}}we.to=ce})(de||(e.InlineValue=de={}));var Ne;(function(we){function ke(G){return{frameId:G.frameId,stoppedLocation:C.from(G.stoppedLocation)}}we.from=ke;function ce(G){return new v.InlineValueContext(G.frameId,C.to(G.stoppedLocation))}we.to=ce})(Ne||(e.InlineValueContext=Ne={}));var ue;(function(we){function ke(G){return{range:C.from(G.range),kind:G.kind}}we.from=ke;function ce(G){return new v.DocumentHighlight(C.to(G.range),G.kind)}we.to=ce})(ue||(e.DocumentHighlight=ue={}));var De;(function(we){function ke(G){return{uri:G.uri,highlights:G.highlights.map(ue.from)}}we.from=ke;function ce(G){return new v.MultiDocumentHighlight(r.URI.revive(G.uri),G.highlights.map(ue.to))}we.to=ce})(De||(e.MultiDocumentHighlight=De={}));var Re;(function(we){function ke(ce){switch(ce){case 1:return v.CompletionTriggerKind.TriggerCharacter;case 2:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return v.CompletionTriggerKind.Invoke}}we.to=ke})(Re||(e.CompletionTriggerKind=Re={}));var Ue;(function(we){function ke(ce){return{triggerKind:Re.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}we.to=ke})(Ue||(e.CompletionContext=Ue={}));var B;(function(we){function ke(G){switch(G){case v.CompletionItemTag.Deprecated:return 1}}we.from=ke;function ce(G){switch(G){case 1:return v.CompletionItemTag.Deprecated}}we.to=ce})(B||(e.CompletionItemTag=B={}));var x;(function(we){const ke=new Map([[v.CompletionItemKind.Method,0],[v.CompletionItemKind.Function,1],[v.CompletionItemKind.Constructor,2],[v.CompletionItemKind.Field,3],[v.CompletionItemKind.Variable,4],[v.CompletionItemKind.Class,5],[v.CompletionItemKind.Interface,7],[v.CompletionItemKind.Struct,6],[v.CompletionItemKind.Module,8],[v.CompletionItemKind.Property,9],[v.CompletionItemKind.Unit,12],[v.CompletionItemKind.Value,13],[v.CompletionItemKind.Constant,14],[v.CompletionItemKind.Enum,15],[v.CompletionItemKind.EnumMember,16],[v.CompletionItemKind.Keyword,17],[v.CompletionItemKind.Snippet,27],[v.CompletionItemKind.Text,18],[v.CompletionItemKind.Color,19],[v.CompletionItemKind.File,20],[v.CompletionItemKind.Reference,21],[v.CompletionItemKind.Folder,23],[v.CompletionItemKind.Event,10],[v.CompletionItemKind.Operator,11],[v.CompletionItemKind.TypeParameter,24],[v.CompletionItemKind.Issue,26],[v.CompletionItemKind.User,25]]);function ce($e){return ke.get($e)??9}we.from=ce;const G=new Map([[0,v.CompletionItemKind.Method],[1,v.CompletionItemKind.Function],[2,v.CompletionItemKind.Constructor],[3,v.CompletionItemKind.Field],[4,v.CompletionItemKind.Variable],[5,v.CompletionItemKind.Class],[7,v.CompletionItemKind.Interface],[6,v.CompletionItemKind.Struct],[8,v.CompletionItemKind.Module],[9,v.CompletionItemKind.Property],[12,v.CompletionItemKind.Unit],[13,v.CompletionItemKind.Value],[14,v.CompletionItemKind.Constant],[15,v.CompletionItemKind.Enum],[16,v.CompletionItemKind.EnumMember],[17,v.CompletionItemKind.Keyword],[27,v.CompletionItemKind.Snippet],[18,v.CompletionItemKind.Text],[19,v.CompletionItemKind.Color],[20,v.CompletionItemKind.File],[21,v.CompletionItemKind.Reference],[23,v.CompletionItemKind.Folder],[10,v.CompletionItemKind.Event],[11,v.CompletionItemKind.Operator],[24,v.CompletionItemKind.TypeParameter],[25,v.CompletionItemKind.User],[26,v.CompletionItemKind.Issue]]);function Ee($e){return G.get($e)??v.CompletionItemKind.Property}we.to=Ee})(x||(e.CompletionItemKind=x={}));var q;(function(we){function ke(ce,G){const Ee=new v.CompletionItem(ce.label);return Ee.insertText=ce.insertText,Ee.kind=x.to(ce.kind),Ee.tags=ce.tags?.map(B.to),Ee.detail=ce.detail,Ee.documentation=R.isMarkdownString(ce.documentation)?ie.to(ce.documentation):ce.documentation,Ee.sortText=ce.sortText,Ee.filterText=ce.filterText,Ee.preselect=ce.preselect,Ee.commitCharacters=ce.commitCharacters,o.Range.isIRange(ce.range)?Ee.range=C.to(ce.range):typeof ce.range=="object"&&(Ee.range={inserting:C.to(ce.range.insert),replacing:C.to(ce.range.replace)}),Ee.keepWhitespace=typeof ce.insertTextRules>"u"?!1:!!(ce.insertTextRules&1),typeof ce.insertTextRules<"u"&&ce.insertTextRules&4?Ee.insertText=new v.SnippetString(ce.insertText):(Ee.insertText=ce.insertText,Ee.textEdit=Ee.range instanceof v.Range?new v.TextEdit(Ee.range,Ee.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Ee.additionalTextEdits=ce.additionalTextEdits.map($e=>Ie.to($e))),Ee.command=G&&ce.command?G.fromInternal(ce.command):void 0,Ee}we.to=ke})(q||(e.CompletionItem=q={}));var W;(function(we){function ke(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:ie.fromStrict(G.documentation)}}we.from=ke;function ce(G){return{label:G.label,documentation:R.isMarkdownString(G.documentation)?ie.to(G.documentation):G.documentation}}we.to=ce})(W||(e.ParameterInformation=W={}));var ee;(function(we){function ke(G){return{label:G.label,documentation:ie.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(W.from):[],activeParameter:G.activeParameter}}we.from=ke;function ce(G){return{label:G.label,documentation:R.isMarkdownString(G.documentation)?ie.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(W.to):[],activeParameter:G.activeParameter}}we.to=ce})(ee||(e.SignatureInformation=ee={}));var se;(function(we){function ke(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(ee.from):[]}}we.from=ke;function ce(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(ee.to):[]}}we.to=ce})(se||(e.SignatureHelp=se={}));var Oe;(function(we){function ke(ce,G){const Ee=new v.InlayHint(S.to(G.position),typeof G.label=="string"?G.label:G.label.map(ze.to.bind(void 0,ce)),G.kind&&Ge.to(G.kind));return Ee.textEdits=G.textEdits&&G.textEdits.map(Ie.to),Ee.tooltip=R.isMarkdownString(G.tooltip)?ie.to(G.tooltip):G.tooltip,Ee.paddingLeft=G.paddingLeft,Ee.paddingRight=G.paddingRight,Ee}we.to=ke})(Oe||(e.InlayHint=Oe={}));var ze;(function(we){function ke(ce,G){const Ee=new v.InlayHintLabelPart(G.label);return Ee.tooltip=R.isMarkdownString(G.tooltip)?ie.to(G.tooltip):G.tooltip,s.Command.is(G.command)&&(Ee.command=ce.fromInternal(G.command)),G.location&&(Ee.location=he.to(G.location)),Ee}we.to=ke})(ze||(e.InlayHintLabelPart=ze={}));var Ge;(function(we){function ke(G){return G}we.from=ke;function ce(G){return G}we.to=ce})(Ge||(e.InlayHintKind=Ge={}));var Je;(function(we){function ke(G){return{range:C.from(G.range),url:G.target,tooltip:G.tooltip}}we.from=ke;function ce(G){let Ee;if(G.url)try{Ee=typeof G.url=="string"?r.URI.parse(G.url,!0):r.URI.revive(G.url)}catch{}return new v.DocumentLink(C.to(G.range),Ee)}we.to=ce})(Je||(e.DocumentLink=Je={}));var et;(function(we){function ke(G){const Ee=new v.ColorPresentation(G.label);return G.textEdit&&(Ee.textEdit=Ie.to(G.textEdit)),G.additionalTextEdits&&(Ee.additionalTextEdits=G.additionalTextEdits.map($e=>Ie.to($e))),Ee}we.to=ke;function ce(G){return{label:G.label,textEdit:G.textEdit?Ie.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Ee=>Ie.from(Ee)):void 0}}we.from=ce})(et||(e.ColorPresentation=et={}));var ot;(function(we){function ke(G){return new v.Color(G[0],G[1],G[2],G[3])}we.to=ke;function ce(G){return[G.red,G.green,G.blue,G.alpha]}we.from=ce})(ot||(e.Color=ot={}));var it;(function(we){function ke(G){return{range:C.from(G.range)}}we.from=ke;function ce(G){return new v.SelectionRange(C.to(G.range))}we.to=ce})(it||(e.SelectionRange=it={}));var nt;(function(we){function ke(ce){switch(ce){case 2:return v.TextDocumentSaveReason.AfterDelay;case 1:return v.TextDocumentSaveReason.Manual;case 3:case 4:return v.TextDocumentSaveReason.FocusOut}}we.to=ke})(nt||(e.TextDocumentSaveReason=nt={}));var at;(function(we){function ke(G){switch(G){case v.TextEditorLineNumbersStyle.Off:return 0;case v.TextEditorLineNumbersStyle.Relative:return 2;case v.TextEditorLineNumbersStyle.Interval:return 3;case v.TextEditorLineNumbersStyle.On:default:return 1}}we.from=ke;function ce(G){switch(G){case 0:return v.TextEditorLineNumbersStyle.Off;case 2:return v.TextEditorLineNumbersStyle.Relative;case 3:return v.TextEditorLineNumbersStyle.Interval;case 1:default:return v.TextEditorLineNumbersStyle.On}}we.to=ce})(at||(e.TextEditorLineNumbersStyle=at={}));var ft;(function(we){function ke(G){if(G===v.EndOfLine.CRLF)return 1;if(G===v.EndOfLine.LF)return 0}we.from=ke;function ce(G){if(G===1)return v.EndOfLine.CRLF;if(G===0)return v.EndOfLine.LF}we.to=ce})(ft||(e.EndOfLine=ft={}));var Be;(function(we){function ke(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case v.ProgressLocation.SourceControl:return 3;case v.ProgressLocation.Window:return 10;case v.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=ke})(Be||(e.ProgressLocation=Be={}));var st;(function(we){function ke(G){const Ee={start:G.start+1,end:G.end+1};return G.kind&&(Ee.kind=Q.from(G.kind)),Ee}we.from=ke;function ce(G){const Ee={start:G.start-1,end:G.end-1};return G.kind&&(Ee.kind=Q.to(G.kind)),Ee}we.to=ce})(st||(e.FoldingRange=st={}));var Q;(function(we){function ke(G){if(G)switch(G){case v.FoldingRangeKind.Comment:return s.FoldingRangeKind.Comment;case v.FoldingRangeKind.Imports:return s.FoldingRangeKind.Imports;case v.FoldingRangeKind.Region:return s.FoldingRangeKind.Region}}we.from=ke;function ce(G){if(G)switch(G.value){case s.FoldingRangeKind.Comment.value:return v.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports.value:return v.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region.value:return v.FoldingRangeKind.Region}}we.to=ce})(Q||(e.FoldingRangeKind=Q={}));var X;(function(we){function ke(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?C.from(ce.selection):void 0,override:typeof ce.override=="boolean"?a.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}we.from=ke})(X||(e.TextEditorOpenOptions=X={}));var ge;(function(we){function ke($e){return $e instanceof v.RelativePattern?$e.toJSON():typeof $e=="string"?$e:ce($e)||G($e)?new v.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}we.from=ke;function ce($e){const Xe=$e;return Xe?r.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function G($e){const Xe=$e;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Ee($e){return typeof $e=="string"?$e:new v.RelativePattern(r.URI.revive($e.baseUri),$e.pattern)}we.to=Ee})(ge||(e.GlobPattern=ge={}));var Ve;(function(we){function ke(ce){if(ce){if(Array.isArray(ce))return ce.map(ke);if(typeof ce=="string")return ce;{const G=ce;return{language:G.language,scheme:G.scheme,pattern:ge.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}we.from=ke})(Ve||(e.LanguageSelector=Ve={}));var Qe;(function(we){function ke(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Ee=>Array.isArray(Ee)&&Ee.every($e=>$e&&typeof $e=="object"&&"uri"in $e&&r.URI.isUri($e.uri)&&"version"in $e&&typeof $e.version=="number"&&"ranges"in $e&&Array.isArray($e.ranges)&&$e.ranges.every(Xe=>Xe instanceof v.Range)))}we.is=ke;function ce(G){return{documents:G.documents.map(Ee=>Ee.map($e=>({uri:r.URI.from($e.uri),version:$e.version,ranges:$e.ranges.map(Xe=>C.from(Xe))})))}}we.from=ce})(Qe||(e.MappedEditsContext=Qe={}));var Ae;(function(we){function ke(G){return{start:G.start,end:G.end}}we.from=ke;function ce(G){return new v.NotebookRange(G.start,G.end)}we.to=ce})(Ae||(e.NotebookRange=Ae={}));var dt;(function(we){function ke(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}we.to=ke;function ce(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}we.from=ce})(dt||(e.NotebookCellExecutionSummary=dt={}));var Pt;(function(we){function ke(ce){if(ce===t.NotebookCellExecutionState.Unconfirmed)return v.NotebookCellExecutionState.Pending;if(ce===t.NotebookCellExecutionState.Pending)return;if(ce===t.NotebookCellExecutionState.Executing)return v.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ce}`)}we.to=ke})(Pt||(e.NotebookCellExecutionState=Pt={}));var zt;(function(we){function ke(G){switch(G){case v.NotebookCellKind.Markup:return t.CellKind.Markup;case v.NotebookCellKind.Code:default:return t.CellKind.Code}}we.from=ke;function ce(G){switch(G){case t.CellKind.Markup:return v.NotebookCellKind.Markup;case t.CellKind.Code:default:return v.NotebookCellKind.Code}}we.to=ce})(zt||(e.NotebookCellKind=zt={}));var Zt;(function(we){function ke(G){const Ee={metadata:G.metadata??Object.create(null),cells:[]};for(const $e of G.cells)v.NotebookCellData.validate($e),Ee.cells.push(Gt.from($e));return Ee}we.from=ke;function ce(G){const Ee=new v.NotebookData(G.cells.map(Gt.to));return(0,g.isEmptyObject)(G.metadata)||(Ee.metadata=G.metadata),Ee}we.to=ce})(Zt||(e.NotebookData=Zt={}));var Gt;(function(we){function ke(G){return{cellKind:zt.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:dt.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(It.from):[]}}we.from=ke;function ce(G){return new v.NotebookCellData(zt.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(It.to):void 0,G.metadata,G.internalMetadata?dt.to(G.internalMetadata):void 0)}we.to=ce})(Gt||(e.NotebookCellData=Gt={}));var ei;(function(we){function ke(G){return{mime:G.mime,valueBytes:O.VSBuffer.wrap(G.data)}}we.from=ke;function ce(G){return new v.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}we.to=ce})(ei||(e.NotebookCellOutputItem=ei={}));var It;(function(we){function ke(G){return{outputId:G.id,items:G.items.map(ei.from),metadata:G.metadata}}we.from=ke;function ce(G){const Ee=G.items.map(ei.to);return new v.NotebookCellOutput(Ee,G.outputId,G.metadata)}we.to=ce})(It||(e.NotebookCellOutput=It={}));var Xt;(function(we){function ke(Ee){return G(Ee)?{include:ge.from(Ee.include)??void 0,exclude:ge.from(Ee.exclude)??void 0}:ge.from(Ee)??void 0}we.from=ke;function ce(Ee){return G(Ee)?{include:ge.to(Ee.include),exclude:ge.to(Ee.exclude)}:ge.to(Ee)}we.to=ce;function G(Ee){const $e=Ee;return $e?!(0,g.isUndefinedOrNull)($e.include)&&!(0,g.isUndefinedOrNull)($e.exclude):!1}})(Xt||(e.NotebookExclusiveDocumentPattern=Xt={}));var Vt;(function(we){function ke(ce,G,Ee){const $e=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===v.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal($e,Ee),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}we.from=ke})(Vt||(e.NotebookStatusBarItem=Vt={}));var ci;(function(we){function ke(ce,G,Ee){const $e=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{command:G.toInternal($e,Ee),label:ce.label,description:ce.description,detail:ce.detail,documentation:ce.documentation}}we.from=ke})(ci||(e.NotebookKernelSourceAction=ci={}));var Ye;(function(we){function ke(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{},cellContentMetadata:ce?.cellContentMetadata??{}}}we.from=ke})(Ye||(e.NotebookDocumentContentOptions=Ye={}));var ti;(function(we){function ke(G){return{uri:G.uri,provides:G.provides}}we.from=ke;function ce(G){return new v.NotebookRendererScript(r.URI.revive(G.uri),G.provides)}we.to=ce})(ti||(e.NotebookRendererScript=ti={}));var ii;(function(we){function ke(G){return{message:ie.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:C.from(G.location.range),uri:G.location.uri}}}we.from=ke;function ce(G){const Ee=new v.TestMessage(typeof G.message=="string"?G.message:ie.to(G.message));return Ee.actualOutput=G.actual,Ee.expectedOutput=G.expected,Ee.contextValue=G.contextValue,Ee.location=G.location?he.to(G.location):void 0,Ee}we.to=ce})(ii||(e.TestMessage=ii={}));var Wt;(function(we){we.namespace=c.namespaceTestTag,we.denamespace=c.denamespaceTestTag})(Wt||(e.TestTag=Wt={}));var ut;(function(we){function ke(G){const Ee=(0,i.getPrivateApiFor)(G).controllerId;return{extId:E.TestId.fromExtHostTestItem(G,Ee).toString(),label:G.label,uri:r.URI.revive(G.uri),busy:G.busy,tags:G.tags.map($e=>Wt.namespace(Ee,$e.id)),range:o.Range.lift(C.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&ie.fromStrict(G.error)||null}}we.from=ke;function ce(G){return{parent:void 0,error:void 0,id:E.TestId.fromString(G.extId).localId,label:G.label,uri:r.URI.revive(G.uri),tags:(G.tags||[]).map(Ee=>{const{tagId:$e}=Wt.denamespace(Ee);return new v.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:C.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}we.toPlain=ce})(ut||(e.TestItem=ut={})),function(we){function ke(G){return{id:G.id}}we.from=ke;function ce(G){return new v.TestTag(G.id)}we.to=ce}(Wt||(e.TestTag=Wt={}));var Et;(function(we){const ke=(G,Ee)=>{const $e=G.value;if(!$e)return;const Xe={...ut.toPlain($e.item),parent:Ee,taskStates:$e.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ct=>ct.type===0).map(ii.to)})),children:[]};if(G.children)for(const qe of G.children.values()){const ct=ke(qe,Xe);ct&&Xe.children.push(ct)}return Xe};function ce(G){const Ee=new l.WellDefinedPrefixTree;for(const qe of G.items)Ee.insert(E.TestId.fromString(qe.item.extId).path,qe);const $e=[Ee.nodes],Xe=[];for(;$e.length;)for(const qe of $e.pop())qe.value?Xe.push(qe):qe.children&&$e.push(qe.children.values());return{completedAt:G.completedAt,results:Xe.map(qe=>ke(qe)).filter(g.isDefined)}}we.to=ce})(Et||(e.TestResults=Et={}));var ai;(function(we){function ke($e){return{covered:$e.covered,total:$e.total}}function ce($e){return"line"in $e?S.from($e):C.from($e)}function G($e){if(typeof $e.executed=="number"&&$e.executed<0)throw new Error(`Invalid coverage count ${$e.executed}`);return"branches"in $e?{count:$e.executed,location:ce($e.location),type:1,branches:$e.branches.length?$e.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&ce(Xe.location),label:Xe.label})):void 0}:{type:0,name:$e.name,count:$e.executed,location:ce($e.location)}}we.fromDetails=G;function Ee($e,Xe){return v.validateTestCoverageCount(Xe.statementCoverage),v.validateTestCoverageCount(Xe.branchCoverage),v.validateTestCoverageCount(Xe.declarationCoverage),{id:$e,uri:Xe.uri,statement:ke(Xe.statementCoverage),branch:Xe.branchCoverage&&ke(Xe.branchCoverage),declaration:Xe.declarationCoverage&&ke(Xe.declarationCoverage)}}we.fromFile=Ee})(ai||(e.TestCoverage=ai={}));var qt;(function(we){function ke(ce){switch(ce){case 1:return v.CodeActionTriggerKind.Invoke;case 2:return v.CodeActionTriggerKind.Automatic}}we.to=ke})(qt||(e.CodeActionTriggerKind=qt={}));var $t;(function(we){function ke(G){const Ee=new v.TypeHierarchyItem(re.to(G.kind),G.name,G.detail||"",r.URI.revive(G.uri),C.to(G.range),C.to(G.selectionRange));return Ee._sessionId=G._sessionId,Ee._itemId=G._itemId,Ee}we.to=ke;function ce(G,Ee,$e){if(Ee=Ee??G._sessionId,$e=$e??G._itemId,Ee===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:$e,kind:re.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:C.from(G.range),selectionRange:C.from(G.selectionRange),tags:G.tags?.map(F.from)}}we.from=ce})($t||(e.TypeHierarchyItem=$t={}));var mt;(function(we){function ke(ce){if(ce)return{value:ce.value,tooltip:ce.tooltip}}we.from=ke})(mt||(e.ViewBadge=mt={}));var Dt;(function(we){function ke($e,Xe,qe){const ct=Xe.fileData;return ct?new v.InternalFileDataTransferItem(new v.DataTransferFile(ct.name,r.URI.revive(ct.uri),ct.id,(0,N.createSingleCallFunction)(()=>qe(ct.id)))):$e===L.Mimes.uriList&&Xe.uriListData?new v.InternalDataTransferItem(Ee(Xe.uriListData)):new v.InternalDataTransferItem(Xe.asString)}we.to=ke;async function ce($e,Xe){const qe=await Xe.asString();if($e===L.Mimes.uriList)return{asString:qe,fileData:void 0,uriListData:G(qe)};const ct=Xe.asFile();return{asString:qe,fileData:ct?{name:ct.name,uri:ct.uri,id:ct._itemId??ct.id}:void 0}}we.from=ce;function G($e){return T.UriList.split($e).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return r.URI.parse(Xe)}catch{}return Xe})}function Ee($e){return T.UriList.create($e.map(Xe=>typeof Xe=="string"?Xe:r.URI.revive(Xe)))}})(Dt||(e.DataTransferItem=Dt={}));var li;(function(we){function ke(G,Ee){const $e=G.items.map(([Xe,qe])=>[Xe,Dt.to(Xe,qe,Ee)]);return new v.DataTransfer($e)}we.toDataTransfer=ke;async function ce(G){const Ee={items:[]},$e=[];for(const[Xe,qe]of G)$e.push((async()=>{Ee.items.push([Xe,await Dt.from(Xe,qe)])})());return await Promise.all($e),Ee}we.from=ce})(li||(e.DataTransfer=li={}));var Qt;(function(we){function ke(G,Ee){return{kind:"reply",agentId:G.participant??Ee?.agentId??"",subCommand:G.command??Ee?.command,message:G.prompt,title:G.label}}we.from=ke;function ce(G){return{prompt:G.message,label:G.title,participant:G.agentId,command:G.subCommand}}we.to=ce})(Qt||(e.ChatFollowup=Qt={}));var We;(function(we){function ke(ce){return"commandId"in ce?{kind:"command",title:ce.title??"",commandId:ce.commandId??"",when:ce.when??"",args:ce.args}:{kind:"reply",message:ce.message,title:ce.title,tooltip:ce.tooltip}}we.from=ke})(We||(e.ChatInlineFollowup=We={}));var Ot;(function(we){function ke(G){switch(G.role){case 0:return new v.LanguageModelChatSystemMessage(G.content);case 1:return new v.LanguageModelChatUserMessage(G.content);case 2:return new v.LanguageModelChatAssistantMessage(G.content)}}we.to=ke;function ce(G){if(G instanceof v.LanguageModelChatSystemMessage)return{role:0,content:G.content};if(G instanceof v.LanguageModelChatUserMessage)return{role:1,content:G.content};if(G instanceof v.LanguageModelChatAssistantMessage)return{role:2,content:G.content};throw new Error("Invalid LanguageModelMessage")}we.from=ce})(Ot||(e.LanguageModelMessage=Ot={}));var Ht;(function(we){function ke(Ee){const $e={};for(const Xe of Object.keys(Ee))$e[Xe]=Ee[Xe].map(we.to);return $e}we.objectTo=ke;function ce(Ee){return{level:ni.to(Ee.level),kind:Ee.kind,value:(0,r.isUriComponents)(Ee.value)?r.URI.revive(Ee.value):Ee.value,description:Ee.description}}we.to=ce;function G(Ee){return{level:ni.from(Ee.level),kind:Ee.kind,value:Ee.value,description:Ee.description}}we.from=G})(Ht||(e.ChatVariable=Ht={}));var ni;(function(we){function ke(G){switch(G){case"short":return v.ChatVariableLevel.Short;case"medium":return v.ChatVariableLevel.Medium;case"full":default:return v.ChatVariableLevel.Full}}we.to=ke;function ce(G){switch(G){case v.ChatVariableLevel.Short:return"short";case v.ChatVariableLevel.Medium:return"medium";case v.ChatVariableLevel.Full:default:return"full"}}we.from=ce})(ni||(e.ChatVariableLevel=ni={}));var pt;(function(we){function ke(ce){switch(ce){case 1:return v.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return v.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return v.InteractiveEditorResponseFeedbackKind.Undone;case 3:return v.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return v.InteractiveEditorResponseFeedbackKind.Bug}}we.to=ke})(pt||(e.InteractiveEditorResponseFeedbackKind=pt={}));var Lt;(function(we){function ke(G){return{kind:"markdownContent",content:ie.from(G.value)}}we.to=ke;function ce(G){return new v.ChatResponseMarkdownPart(ie.to(G.content))}we.from=ce})(Lt||(e.ChatResponseMarkdownPart=Lt={}));var Tt;(function(we){function ke(G){const{value:Ee,baseUri:$e}=G;function Xe(qe,ct){return qe.map(_t=>{const St=r.URI.joinPath(ct,_t.name);return{label:_t.name,uri:St,children:_t.children&&Xe(_t.children,St)}})}return{kind:"treeData",treeData:{label:(0,w.basename)($e),uri:$e,children:Xe(Ee,$e)}}}we.to=ke;function ce(G){const Ee=(0,y.revive)(G.treeData);function $e(ct){return ct.map(_t=>({name:_t.label,children:_t.children&&$e(_t.children)}))}const Xe=Ee.uri,qe=Ee.children?$e(Ee.children):[];return new v.ChatResponseFileTreePart(qe,Xe)}we.from=ce})(Tt||(e.ChatResponseFilesPart=Tt={}));var Nt;(function(we){function ke(G){return{kind:"inlineReference",name:G.title,inlineReference:r.URI.isUri(G.value)?G.value:f.from(G.value)}}we.to=ke;function ce(G){const Ee=(0,y.revive)(G);return new v.ChatResponseAnchorPart(r.URI.isUri(Ee.inlineReference)?Ee.inlineReference:f.to(Ee.inlineReference),G.name)}we.from=ce})(Nt||(e.ChatResponseAnchorPart=Nt={}));var ui;(function(we){function ke(G){return{kind:"progressMessage",content:ie.from(G.value)}}we.to=ke;function ce(G){return new v.ChatResponseProgressPart(G.content.value)}we.from=ce})(ui||(e.ChatResponseProgressPart=ui={}));var Mt;(function(we){function ke(G,Ee,$e){return{kind:"command",command:Ee.toInternal(G.value,$e)??{command:G.value.command,title:G.value.title}}}we.to=ke;function ce(G,Ee){return new v.ChatResponseCommandButtonPart(Ee.fromInternal(G.command)??{command:G.command.id,title:G.command.title})}we.from=ce})(Mt||(e.ChatResponseCommandButtonPart=Mt={}));var Ft;(function(we){function ke(G){return"variableName"in G.value?{kind:"reference",reference:{variableName:G.value.variableName,value:r.URI.isUri(G.value.value)||!G.value.value?G.value.value:f.from(G.value.value)}}:{kind:"reference",reference:r.URI.isUri(G.value)?G.value:f.from(G.value)}}we.to=ke;function ce(G){const Ee=(0,y.revive)(G),$e=Xe=>r.URI.isUri(Xe)?Xe:f.to(Xe);return new v.ChatResponseReferencePart("variableName"in Ee.reference?{variableName:Ee.reference.variableName,value:Ee.reference.value&&$e(Ee.reference.value)}:$e(Ee.reference))}we.from=ce})(Ft||(e.ChatResponseReferencePart=Ft={}));var yt;(function(we){function ke(Ee,$e,Xe){return Ee instanceof v.ChatResponseMarkdownPart?Lt.to(Ee):Ee instanceof v.ChatResponseAnchorPart?Nt.to(Ee):Ee instanceof v.ChatResponseReferencePart?Ft.to(Ee):Ee instanceof v.ChatResponseProgressPart?ui.to(Ee):Ee instanceof v.ChatResponseFileTreePart?Tt.to(Ee):Ee instanceof v.ChatResponseCommandButtonPart?Mt.to(Ee,$e,Xe):{kind:"content",content:""}}we.to=ke;function ce(Ee,$e){switch(Ee.kind){case"reference":return Ft.from(Ee);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return G(Ee,$e)}}we.from=ce;function G(Ee,$e){switch(Ee.kind){case"markdownContent":return Lt.from(Ee);case"inlineReference":return Nt.from(Ee);case"progressMessage":return;case"treeData":return Tt.from(Ee);case"command":return Mt.from(Ee,$e)}}we.fromContent=G})(yt||(e.ChatResponsePart=yt={}));var Rt;(function(we){function ke(G,Ee){return"markdownContent"in Ee?((0,b.checkProposedApiEnabled)(G,"chatParticipantAdditions"),{content:ie.from(Ee.markdownContent),kind:"markdownContent"}):"content"in Ee?"vulnerabilities"in Ee&&Ee.vulnerabilities?((0,b.checkProposedApiEnabled)(G,"chatParticipantAdditions"),{content:Ee.content,vulnerabilities:Ee.vulnerabilities,kind:"vulnerability"}):typeof Ee.content=="string"?{content:Ee.content,kind:"content"}:((0,b.checkProposedApiEnabled)(G,"chatParticipantAdditions"),{content:ie.from(Ee.content),kind:"markdownContent"}):"documents"in Ee?{documents:Ee.documents.map($e=>({uri:$e.uri,version:$e.version,ranges:$e.ranges.map(Xe=>C.from(Xe))})),kind:"usedContext"}:"reference"in Ee?{reference:"uri"in Ee.reference?{uri:Ee.reference.uri,range:C.from(Ee.reference.range)}:Ee.reference,kind:"reference"}:"inlineReference"in Ee?{inlineReference:"uri"in Ee.inlineReference?{uri:Ee.inlineReference.uri,range:C.from(Ee.inlineReference.range)}:Ee.inlineReference,name:Ee.title,kind:"inlineReference"}:"participant"in Ee?((0,b.checkProposedApiEnabled)(G,"chatParticipantAdditions"),{agentId:Ee.participant,command:Ee.command,kind:"agentDetection"}):"message"in Ee?{content:ie.from(Ee.message),kind:"progressMessage"}:void 0}we.from=ke;function ce(G,Ee){switch(G.kind){case"markdownContent":return{content:G.content.value};case"inlineReference":return{inlineReference:(0,r.isUriComponents)(G.inlineReference)?r.URI.revive(G.inlineReference):f.to(G.inlineReference),title:G.name};case"command":return{command:Ee.fromInternal(G.command)??{command:G.command.id,title:G.command.title}};default:return}}we.toProgressContent=ce})(Rt||(e.ChatResponseProgress=Rt={}));var ri;(function(we){function ke(ce){return{prompt:ce.message,command:ce.command,variables:ce.variables.variables.map(wt.to),location:xt.to(ce.location)}}we.to=ke})(ri||(e.ChatAgentRequest=ri={}));var xt;(function(we){function ke(ce){switch(ce){case d.ChatAgentLocation.Notebook:return v.ChatLocation.Notebook;case d.ChatAgentLocation.Terminal:return v.ChatLocation.Terminal;case d.ChatAgentLocation.Panel:return v.ChatLocation.Panel;case d.ChatAgentLocation.Editor:return v.ChatLocation.Editor}}we.to=ke})(xt||(e.ChatLocation=xt={}));var wt;(function(we){function ke(ce){return{name:ce.name,range:ce.range&&[ce.range.start,ce.range.endExclusive],values:ce.values.map(Ht.to)}}we.to=ke})(wt||(e.ChatAgentResolvedVariable=wt={}));var kt;(function(we){function ke(ce){return{label:ce.label,values:ce.values.map(Ht.from),insertText:ce.insertText,detail:ce.detail,documentation:ce.documentation}}we.from=ke})(kt||(e.ChatAgentCompletionItem=kt={}));var fi;(function(we){function ke(ce){return{errorDetails:ce.errorDetails,metadata:ce.metadata}}we.to=ke})(fi||(e.ChatAgentResult=fi={}));var Ct;(function(we){function ke(ce,G,Ee){if(G.action.kind==="vote")return;const $e=fi.to(ce);return G.action.kind==="command"?{action:{kind:"command",commandButton:Rt.toProgressContent(G.action.commandButton,Ee)},result:$e}:G.action.kind==="followUp"?{action:{kind:"followUp",followup:Qt.to(G.action.followup)},result:$e}:{action:G.action,result:$e}}we.to=ke})(Ct||(e.ChatAgentUserActionEvent=Ct={}));var si;(function(we){function ke(ce,G,Ee){return"terminalCommand"in ce?{terminalCommand:ce.terminalCommand,shouldExecute:ce.shouldExecute}:"uri"in ce?{uri:ce.uri}:G.toInternal(ce,Ee)}we.from=ke})(si||(e.TerminalQuickFix=si={}));var Yt;(function(we){function ke(ce){return{kind:oi.to(ce.kind)}}we.to=ke})(Yt||(e.PartialAcceptInfo=Yt={}));var oi;(function(we){function ke(ce){switch(ce){case 0:return v.PartialAcceptTriggerKind.Word;case 1:return v.PartialAcceptTriggerKind.Line;case 2:return v.PartialAcceptTriggerKind.Suggest;default:return v.PartialAcceptTriggerKind.Unknown}}we.to=ke})(oi||(e.PartialAcceptTriggerKind=oi={}));var mi;(function(we){function ke(ce,G){return{id:G,label:ce.label,description:ce.description,canEdit:ce.canEdit,collapsibleState:ce.collapsibleState||0,contextValue:ce.contextValue}}we.from=ke})(mi||(e.DebugTreeItem=mi={}))}),define(Pe[252],Te([1,0,4,16,8]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let N=class{constructor(m,h){this._proxy=m.getProxy(D.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:y=>h.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,h,y){const L=T.WorkspaceEdit.from(m,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(L,void 0,y?.isRefactoring??!1)}};e.ExtHostBulkEdits=N,e.ExtHostBulkEdits=N=Ke([He(0,O.IExtHostRpcService)],N)}),define(Pe[253],Te([1,0,18,11,42,5,39,6,65,17,2,163,20,4,8,7,213,25]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatAgents2=void 0;class n{constructor(t,E,c,p,b,v){this._extension=t,this._request=E,this._proxy=c,this._logService=p,this._commandsConverter=b,this._sessionDisposables=v,this._stopWatch=h.StopWatch.create(!1),this._isClosed=!1}close(){this._isClosed=!0}get timings(){return{firstProgress:this._firstProgress,totalElapsed:this._stopWatch.elapsed()}}get apiObject(){if(!this._apiObject){let E=function(p){if(t._isClosed){const b=new Error("Response stream has been closed");throw Error.captureStackTrace(b,p),b}};const t=this;this._stopWatch.reset();const c=p=>{typeof this._firstProgress>"u"&&"content"in p&&(this._firstProgress=this._stopWatch.elapsed()),this._proxy.$handleProgressChunk(this._request.requestId,p)};this._apiObject={markdown(p){E(this.markdown);const b=new r.ChatResponseMarkdownPart(p),v=g.ChatResponseMarkdownPart.to(b);return c(v),this},filetree(p,b){E(this.filetree);const v=new r.ChatResponseFileTreePart(p,b),u=g.ChatResponseFilesPart.to(v);return c(u),this},anchor(p,b){E(this.anchor);const v=new r.ChatResponseAnchorPart(p,b),u=g.ChatResponseAnchorPart.to(v);return c(u),this},button(p){E(this.anchor);const b=new r.ChatResponseCommandButtonPart(p),v=g.ChatResponseCommandButtonPart.to(b,t._commandsConverter,t._sessionDisposables);return c(v),this},progress(p){E(this.progress);const b=new r.ChatResponseProgressPart(p),v=g.ChatResponseProgressPart.to(b);return c(v),this},reference(p){if(E(this.reference),"variableName"in p&&!p.value){const b=t._request.variables.variables.find(v=>v.name===p.variableName);if(b){let v;if(b.references?.length)v=b.references.map(u=>({kind:"reference",reference:{variableName:p.variableName,value:u.reference}}));else{const u=new r.ChatResponseReferencePart(p);v=[g.ChatResponseReferencePart.to(u)]}return v.forEach(u=>c(u)),this}}else{const b=new r.ChatResponseReferencePart(p),v=g.ChatResponseReferencePart.to(b);c(v)}return this},push(p){if(E(this.push),p instanceof r.ChatResponseReferencePart)this.reference(p.value);else{const b=g.ChatResponsePart.to(p,t._commandsConverter,t._sessionDisposables);c(b)}return this},report(p){if(E(this.report),"placeholder"in p&&"resolvedContent"in p)return;const b=g.ChatResponseProgress.from(t._extension,p);if(!b){t._logService.error("Unknown progress type: "+JSON.stringify(p));return}return c(b),this}}}return this._apiObject}}class i{static{this._idPool=0}constructor(t,E,c){this._logService=E,this.commands=c,this._agents=new Map,this._sessionDisposables=new m.DisposableMap,this._proxy=t.getProxy(w.MainContext.MainThreadChatAgents2)}createChatAgent(t,E,c){const p=i._idPool++,b=new a(t,E,this._proxy,p,c);return this._agents.set(p,b),this._proxy.$registerAgent(p,t.identifier,E,{},void 0),b.apiAgent}createDynamicChatAgent(t,E,c,p,b){const v=i._idPool++,u=new a(t,E,this._proxy,v,b);return this._agents.set(v,u),this._proxy.$registerAgent(v,t.identifier,E,{},{name:c,description:p}),u.apiAgent}async $invokeAgent(t,E,c,p){const b=this._agents.get(t);if(!b)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let v=this._sessionDisposables.get(E.sessionId);v||(v=new m.DisposableStore,this._sessionDisposables.set(E.sessionId,v));const u=new n(b.extension,E,this._proxy,this._logService,this.commands.converter,v);try{const C=await this.prepareHistoryTurns(E.agentId,c),f=b.invoke(g.ChatAgentRequest.to(E),{history:C},u.apiObject,p);return await(0,O.raceCancellation)(Promise.resolve(f).then(I=>{if(I?.metadata)try{JSON.stringify(I.metadata)}catch(S){const P=`result.metadata MUST be JSON.stringify-able. Got error: ${S.message}`;return this._logService.error(`[${b.extension.identifier.value}] [@${b.id}] ${P}`,b.extension),{errorDetails:{message:P},timings:u.timings}}return{errorDetails:I?.errorDetails,timings:u.timings,metadata:I?.metadata}}),p)}catch(C){return this._logService.error(C,b.extension),{errorDetails:{message:(0,_.localize)(0,null,(0,T.toErrorMessage)(C)),responseIsIncomplete:!0}}}finally{u.close()}}async prepareHistoryTurns(t,E){const c=[];for(const p of E.history){const b=g.ChatAgentResult.to(p.result),v=t===p.request.agentId?b:{...b,metadata:void 0};c.push(new r.ChatRequestTurn(p.request.message,p.request.command,p.request.variables.variables.map(g.ChatAgentResolvedVariable.to),p.request.agentId));const u=(0,D.coalesce)(p.response.map(C=>g.ChatResponsePart.fromContent(C,this.commands.converter)));c.push(new r.ChatResponseTurn(u,v,p.request.agentId,p.request.command))}return c}$releaseSession(t){this._sessionDisposables.deleteAndDispose(t)}async $provideFollowups(t,E,c,p,b){const v=this._agents.get(E);if(!v)return Promise.resolve([]);const u=await this.prepareHistoryTurns(v.id,p),C=g.ChatAgentResult.to(c);return(await v.provideFollowups(C,{history:u},b)).filter(f=>{const I=!f.participant||R.Iterable.some(this._agents.values(),S=>S.id===f.participant&&l.ExtensionIdentifier.equals(S.extension.identifier,v.extension.identifier));return I||this._logService.warn(`[@${v.id}] ChatFollowup refers to an unknown participant: ${f.participant}`),I}).map(f=>g.ChatFollowup.from(f,t))}$acceptFeedback(t,E,c,p){const b=this._agents.get(t);if(!b)return;const v=g.ChatAgentResult.to(E);let u;switch(c){case o.InteractiveSessionVoteDirection.Down:u=r.ChatResultFeedbackKind.Unhelpful;break;case o.InteractiveSessionVoteDirection.Up:u=r.ChatResultFeedbackKind.Helpful;break}b.acceptFeedback(Object.freeze(p?{result:v,kind:u,reportIssue:p}:{result:v,kind:u}))}$acceptAction(t,E,c){const p=this._agents.get(t);if(!p||c.action.kind==="vote")return;const b=g.ChatAgentUserActionEvent.to(E,c,this.commands.converter);b&&p.acceptAction(Object.freeze(b))}async $invokeCompletionProvider(t,E,c){const p=this._agents.get(t);return p?(await p.invokeCompletionProvider(E,c)).map(g.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,E){const c=this._agents.get(t);if(c)return await c.provideWelcomeMessage(E)}async $provideSampleQuestions(t,E){const c=this._agents.get(t);if(c)return(await c.provideSampleQuestions(E)).map(p=>g.ChatFollowup.from(p,void 0))}}e.ExtHostChatAgents2=i;class a{constructor(t,E,c,p,b){this.extension=t,this.id=E,this._proxy=c,this._handle=p,this._requestHandler=b,this._onDidReceiveFeedback=new N.Emitter,this._onDidPerformAction=new N.Emitter}acceptFeedback(t){this._onDidReceiveFeedback.fire(t)}acceptAction(t){this._onDidPerformAction.fire(t)}async invokeCompletionProvider(t,E){return this._agentVariableProvider?await this._agentVariableProvider.provider.provideCompletionItems(t,E)??[]:[]}async provideFollowups(t,E,c){if(!this._followupProvider)return[];const p=await this._followupProvider.provideFollowups(t,E,c);return p?p.filter(b=>!(b&&"commandId"in b)).filter(b=>!(b&&"message"in b)):[]}async provideWelcomeMessage(t){if(!this._welcomeMessageProvider)return[];const E=await this._welcomeMessageProvider.provideWelcomeMessage(t);return E?E.map(c=>typeof c=="string"?c:g.MarkdownString.from(c)):[]}async provideSampleQuestions(t){if(!this._welcomeMessageProvider||!this._welcomeMessageProvider.provideSampleQuestions)return[];const E=await this._welcomeMessageProvider.provideSampleQuestions(t);return E||[]}get apiAgent(){let t=!1,E=!1;const c=()=>{t||E||(E=!0,queueMicrotask(()=>{this._proxy.$updateAgent(this._handle,{fullName:this._fullName,icon:this._iconPath?this._iconPath instanceof L.URI?this._iconPath:"light"in this._iconPath?this._iconPath.light:void 0:void 0,iconDark:this._iconPath&&"dark"in this._iconPath?this._iconPath.dark:void 0,themeIcon:this._iconPath instanceof r.ThemeIcon?this._iconPath:void 0,hasFollowups:this._followupProvider!==void 0,isSecondary:this._isSecondary,helpTextPrefix:!this._helpTextPrefix||typeof this._helpTextPrefix=="string"?this._helpTextPrefix:g.MarkdownString.from(this._helpTextPrefix),helpTextVariablesPrefix:!this._helpTextVariablesPrefix||typeof this._helpTextVariablesPrefix=="string"?this._helpTextVariablesPrefix:g.MarkdownString.from(this._helpTextVariablesPrefix),helpTextPostfix:!this._helpTextPostfix||typeof this._helpTextPostfix=="string"?this._helpTextPostfix:g.MarkdownString.from(this._helpTextPostfix),sampleRequest:this._sampleRequest,supportIssueReporting:this._supportIssueReporting,requester:this._requester}),E=!1}))},p=this;return{get id(){return p.id},get fullName(){return(0,s.checkProposedApiEnabled)(p.extension,"defaultChatParticipant"),p._fullName??p.extension.displayName??p.extension.name},set fullName(b){(0,s.checkProposedApiEnabled)(p.extension,"defaultChatParticipant"),p._fullName=b,c()},get iconPath(){return p._iconPath},set iconPath(b){p._iconPath=b,c()},get requestHandler(){return p._requestHandler},set requestHandler(b){(0,y.assertType)(typeof b=="function","Invalid request handler"),p._requestHandler=b},get followupProvider(){return p._followupProvider},set followupProvider(b){p._followupProvider=b,c()},get isDefault(){return(0,s.checkProposedApiEnabled)(p.extension,"defaultChatParticipant"),p._isDefault},set isDefault(b){(0,s.checkProposedApiEnabled)(p.extension,"defaultChatParticipant"),p._isDefault=b,c()},get helpTextPrefix(){return(0,s.checkProposedApiEnabled)(p.extension,"defaultChatParticipant"),p._helpTextPrefix},set helpTextPrefix(b){(0,s.checkProposedApiEnabled)(p.extension,"defaultChatParticipant"),p._helpTextPrefix=b,c()},get helpTextVariablesPrefix(){return(0,s.checkProposedApiEnabled)(p.extension,"defaultChatParticipant"),p._helpTextVariablesPrefix},set helpTextVariablesPrefix(b){(0,s.checkProposedApiEnabled)(p.extension,"defaultChatParticipant"),p._helpTextVariablesPrefix=b,c()},get helpTextPostfix(){return(0,s.checkProposedApiEnabled)(p.extension,"defaultChatParticipant"),p._helpTextPostfix},set helpTextPostfix(b){(0,s.checkProposedApiEnabled)(p.extension,"defaultChatParticipant"),p._helpTextPostfix=b,c()},get isSecondary(){return(0,s.checkProposedApiEnabled)(p.extension,"defaultChatParticipant"),p._isSecondary},set isSecondary(b){(0,s.checkProposedApiEnabled)(p.extension,"defaultChatParticipant"),p._isSecondary=b,c()},get sampleRequest(){return p._sampleRequest},set sampleRequest(b){p._sampleRequest=b,c()},get supportIssueReporting(){return(0,s.checkProposedApiEnabled)(p.extension,"chatParticipantAdditions"),p._supportIssueReporting},set supportIssueReporting(b){(0,s.checkProposedApiEnabled)(p.extension,"chatParticipantAdditions"),p._supportIssueReporting=b,c()},get onDidReceiveFeedback(){return p._onDidReceiveFeedback.event},set participantVariableProvider(b){if((0,s.checkProposedApiEnabled)(p.extension,"chatParticipantAdditions"),p._agentVariableProvider=b,b){if(!b.triggerCharacters.length)throw new Error("triggerCharacters are required");p._proxy.$registerAgentCompletionsProvider(p._handle,b.triggerCharacters)}else p._proxy.$unregisterAgentCompletionsProvider(p._handle)},get participantVariableProvider(){return(0,s.checkProposedApiEnabled)(p.extension,"chatParticipantAdditions"),p._agentVariableProvider},set welcomeMessageProvider(b){(0,s.checkProposedApiEnabled)(p.extension,"defaultChatParticipant"),p._welcomeMessageProvider=b,c()},get welcomeMessageProvider(){return(0,s.checkProposedApiEnabled)(p.extension,"defaultChatParticipant"),p._welcomeMessageProvider},onDidPerformAction:(0,s.isProposedApiEnabled)(this.extension,"chatParticipantAdditions")?this._onDidPerformAction.event:void 0,set requester(b){p._requester=b,c()},get requester(){return p._requester},dispose(){t=!0,p._followupProvider=void 0,p._onDidReceiveFeedback.dispose(),p._proxy.$unregisterAgent(p._handle)}}}invoke(t,E,c,p){return this._requestHandler(t,E,c,p)}}}),define(Pe[254],Te([1,0,14,6,4,8,7,25]),function(me,e,D,O,T,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChatVariables=void 0;class h{static{this._idPool=0}constructor(_){this._resolver=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadChatVariables)}async $resolveVariable(_,l,w,g){const r=this._resolver.get(_);if(r)try{if(r.resolver.resolve2){(0,m.checkProposedApiEnabled)(r.extension,"chatParticipantAdditions");const o=new y(l,this._proxy),s=await r.resolver.resolve2(r.data.name,{prompt:w},o.apiObject,g);if(s)return s.map(N.ChatVariable.from)}else{const o=await r.resolver.resolve(r.data.name,{prompt:w},g);if(o)return o.map(N.ChatVariable.from)}}catch(o){(0,D.onUnexpectedExternalError)(o)}}registerVariableResolver(_,l,w,g){const r=h._idPool++;return this._resolver.set(r,{extension:_,data:{name:l,description:w},resolver:g}),this._proxy.$registerVariable(r,{name:l,description:w}),(0,O.toDisposable)(()=>{this._resolver.delete(r),this._proxy.$unregisterVariable(r)})}}e.ExtHostChatVariables=h;class y{constructor(_,l){this._requestId=_,this._proxy=l,this._isClosed=!1}close(){this._isClosed=!0}get apiObject(){if(!this._apiObject){let l=function(g){if(_._isClosed){const r=new Error("Response stream has been closed");throw Error.captureStackTrace(r,g),r}};const _=this,w=g=>{this._proxy.$handleProgressChunk(this._requestId,g)};this._apiObject={progress(g){l(this.progress);const r=new R.ChatResponseProgressPart(g),o=N.ChatResponseProgressPart.to(r);return w(o),this},reference(g){l(this.reference);const r=new R.ChatResponseReferencePart(g),o=N.ChatResponseReferencePart.to(r);return w(o),this},push(g){return l(this.push),g instanceof R.ChatResponseReferencePart?w(N.ChatResponseReferencePart.to(g)):g instanceof R.ChatResponseProgressPart&&w(N.ChatResponseProgressPart.to(g)),this}}}return this._apiObject}}}),define(Pe[255],Te([1,0,11,68,5,6,2,87,20,8,7,4,25]),function(me,e,D,O,T,N,R,m,h,y,L,_,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=w;function w(g,r,o){const s=g.getProxy(_.MainContext.MainThreadComments);class n{static{this.handlePool=0}constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new h.ExtensionIdentifierMap,r.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const C=this._commentControllers.get(u.handle);return C?C.value:u}else if(u&&u.$mid===7){const C=u,f=this._commentControllers.get(C.commentControlHandle);if(!f)return C;const I=f.getCommentThread(C.commentThreadHandle);return I?I.value:C}else if(u&&(u.$mid===9||u.$mid===8)){const C=this._commentControllers.get(u.thread.commentControlHandle);if(!C)return u;const f=C.getCommentThread(u.thread.commentThreadHandle);return f?u.$mid===8?f.value:{thread:f.value,text:u.text}:u}else if(u&&u.$mid===10){const C=this._commentControllers.get(u.thread.commentControlHandle);if(!C)return u;const f=C.getCommentThread(u.thread.commentThreadHandle);if(!f)return u;const I=u.commentUniqueId,S=f.getCommentByUniqueId(I);return S||u}else if(u&&u.$mid===11){const C=this._commentControllers.get(u.thread.commentControlHandle);if(!C)return u;const f=C.getCommentThread(u.thread.commentThreadHandle);if(!f)return u;const I=u.text,S=u.commentUniqueId,P=f.getCommentByUniqueId(S);return P?(typeof P.body=="string"?P.body=I:P.body=new L.MarkdownString(I),P):u}return u}})}createCommentController(u,C,f){const I=n.handlePool++,S=new a(u,I,C,f);this._commentControllers.set(S.handle,S);const P=this._commentControllersByExtension.get(u.identifier)||[];return P.push(S),this._commentControllersByExtension.set(u.identifier,P),S.value}async $createCommentThreadTemplate(u,C,f){const I=this._commentControllers.get(u);I&&I.$createCommentThreadTemplate(C,f)}async $setActiveComment(u,C){const f=this._commentControllers.get(u);f&&f.$setActiveComment(C??void 0)}async $updateCommentThreadTemplate(u,C,f){const I=this._commentControllers.get(u);I&&I.$updateCommentThreadTemplate(C,f)}$deleteCommentThread(u,C){this._commentControllers.get(u)?.$deleteCommentThread(C)}async $provideCommentingRanges(u,C,f){const I=this._commentControllers.get(u);if(!I||!I.commentingRangeProvider)return Promise.resolve(void 0);const S=await o.ensureDocumentData(R.URI.revive(C));return(0,D.asPromise)(async()=>{const P=await I.commentingRangeProvider.provideCommentingRanges(S.document,f);let k;return Array.isArray(P)?k={ranges:P,fileComments:!1}:P?k={ranges:P.ranges||[],fileComments:P.fileComments||!1}:k=P??void 0,k}).then(P=>{let k;return P&&(k={ranges:P.ranges.map(H=>y.Range.from(H)),fileComments:P.fileComments}),k})}$toggleReaction(u,C,f,I,S){const P=this._commentControllers.get(u);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,D.asPromise)(()=>{const k=P.getCommentThread(C);if(k){const H=k.getCommentByUniqueId(I.uniqueIdInThread);if(P!==void 0&&H&&P.reactionHandler)return P.reactionHandler(H,E(S))}return Promise.resolve(void 0)})}}class i{static{this._handlePool=0}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){(u===void 0!=(this._range===void 0)||!u||!this._range||!u.isEqual(this._range))&&(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get state(){return this._state}set state(u){this._state=u,typeof u=="object"?((0,l.checkProposedApiEnabled)(this.extensionDescription,"commentThreadApplicability"),this.modifications.state=u.resolved,this.modifications.applicability=u.applicability):this.modifications.state=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(u,C,f,I,S,P,k,H){this._commentControllerHandle=C,this._id=f,this._uri=I,this._range=S,this._comments=P,this.extensionDescription=k,this._isTemplate=H,this.handle=i._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new T.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new N.MutableDisposable,this._acceptInputDisposables.value=new N.DisposableStore,this._id===void 0&&(this._id=`${u}.${this.handle}`),s.$createCommentThread(C,this.handle,this._id,this._uri,y.Range.from(this._range),k.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this._localDisposables.push({dispose:()=>{s.$deleteCommentThread(C,this.handle)}});const $=this;this.value={get uri(){return $.uri},get range(){return $.range},set range(V){$.range=V},get comments(){return $.comments},set comments(V){$.comments=V},get collapsibleState(){return $.collapsibleState},set collapsibleState(V){$.collapsibleState=V},get canReply(){return $.canReply},set canReply(V){$.canReply=V},get contextValue(){return $.contextValue},set contextValue(V){$.contextValue=V},get label(){return $.label},set label(V){$.label=V},get state(){return $.state},set state(V){$.state=V},dispose:()=>{$.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new N.DisposableStore);const u=f=>Object.prototype.hasOwnProperty.call(this.modifications,f),C={};u("range")&&(C.range=y.Range.from(this._range)),u("label")&&(C.label=this.label),u("contextValue")&&(C.contextValue=this.contextValue??null),u("comments")&&(C.comments=this._comments.map(f=>d(this,f,this._commentsMap,this.extensionDescription))),u("collapsibleState")&&(C.collapseState=c(this._collapseState)),u("canReply")&&(C.canReply=this.canReply),u("state")&&(C.state=p(this._state)),u("applicability")&&(C.applicability=b(this._state)),u("isTemplate")&&(C.isTemplate=this._isTemplate),this.modifications={},s.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,C)}getCommentByUniqueId(u){for(const C of this._commentsMap){const f=C[0],I=C[1];if(u===I)return f}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose())}}Ke([(0,O.debounce)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(u){this._commentingRangeProvider=u,u?.resourceHints&&(0,l.checkProposedApiEnabled)(this._extension,"commentingRangeHint"),s.$updateCommentingRanges(this.handle,u?.resourceHints)}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,s.$updateCommentControllerFeatures(this.handle,{options:this._options})}get activeComment(){return(0,l.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeComment}get activeCommentThread(){return(0,l.checkProposedApiEnabled)(this._extension,"activeComment"),this._activeThread}constructor(u,C,f,I){this._extension=u,this._handle=C,this._id=f,this._label=I,this._threads=new Map,s.$registerCommentController(this.handle,f,I,this._extension.identifier.value);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(P){S.options=P},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(P){S.commentingRangeProvider=P},get reactionHandler(){return S.reactionHandler},set reactionHandler(P){S.reactionHandler=P},get activeCommentThread(){return S.activeCommentThread},createCommentThread(P,k,H){return S.createCommentThread(P,k,H).value},dispose:()=>{S.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(u,C,f){C===void 0&&(0,l.checkProposedApiEnabled)(this._extension,"fileComments");const I=new i(this.id,this.handle,void 0,u,C,f,this._extension,!1);return this._threads.set(I.handle,I),I}$setActiveComment(u){if(!u){this._activeComment=void 0,this._activeThread=void 0;return}const C=this._threads.get(u.commentThreadHandle);C&&(this._activeComment=u.uniqueIdInThread?C.getCommentByUniqueId(u.uniqueIdInThread):void 0,this._activeThread=C)}$createCommentThreadTemplate(u,C){const f=new i(this.id,this.handle,void 0,R.URI.revive(u),y.Range.to(C),[],this._extension,!0);return f.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this._threads.set(f.handle,f),f}$updateCommentThreadTemplate(u,C){const f=this._threads.get(u);f&&(f.range=y.Range.to(C))}$deleteCommentThread(u){this._threads.get(u)?.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._localDisposables.forEach(u=>u.dispose())}}function d(v,u,C,f){let I=C.get(u);return I||(I=++v.commentHandle,C.set(u,I)),u.state!==void 0&&(0,l.checkProposedApiEnabled)(f,"commentsDraftState"),u.reactions?.some(S=>S.reactors!==void 0)&&(0,l.checkProposedApiEnabled)(f,"commentReactor"),{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:I,body:typeof u.body=="string"?u.body:y.MarkdownString.from(u.body),userName:u.author.name,userIconPath:u.author.iconPath,label:u.label,commentReactions:u.reactions?u.reactions.map(S=>t(S)):void 0,state:u.state,timestamp:u.timestamp?.toJSON()}}function t(v){return{label:v.label,iconPath:v.iconPath?y.pathOrURIToURI(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted,reactors:v.reactors&&v.reactors.length>0&&typeof v.reactors[0]!="string"?v.reactors.map(u=>u.name):v.reactors}}function E(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?R.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1,reactors:v.reactors?.map(u=>({name:u}))}}function c(v){if(v!==void 0)switch(v){case L.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function p(v){let u;if(typeof v=="object"?u=v.resolved:u=v,u!==void 0)switch(u){case L.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}function b(v){let u;if(typeof v=="object"&&(u=v.applicability),u!==void 0)switch(u){case L.CommentThreadApplicability.Current:return m.CommentThreadApplicability.Current;case L.CommentThreadApplicability.Outdated:return m.CommentThreadApplicability.Outdated}return m.CommentThreadApplicability.Current}return new n}}),define(Pe[256],Te([1,0,24,99,6,12,23,2,8,63,74,4,7]),function(me,e,D,O,T,N,R,m,h,y,L,_,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class w{constructor(E,c){this.document=E,this._storagePath=c,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(E){return this._edits.add([E])}async undo(E,c){await this.getEdit(E).undo(),c||this.disposeBackup()}async redo(E,c){await this.getEdit(E).redo(),c||this.disposeBackup()}disposeEdits(E){for(const c of E)this._edits.delete(c)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const E=d(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,E)}updateBackup(E){this._backup?.delete(),this._backup=E}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(E){const c=this._edits.get(E,0);if(!c)throw new Error("No edit found");return c}}class g{constructor(){this._documents=new Map}get(E,c){return this._documents.get(this.key(E,c))}add(E,c,p){const b=this.key(E,c.uri);if(this._documents.has(b))throw new Error(`Document already exists for viewType:${E} resource:${c.uri}`);const v=new w(c,p);return this._documents.set(b,v),v}delete(E,c){const p=this.key(E,c.uri);this._documents.delete(p)}key(E,c){return`${E}@@@${c}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this._providers=new Map}addTextProvider(E,c,p){return this.add(0,E,c,p)}addCustomProvider(E,c,p){return this.add(1,E,c,p)}get(E){return this._providers.get(E)}add(E,c,p,b){if(this._providers.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this._providers.set(c,{type:E,extension:p,provider:b}),new l.Disposable(()=>this._providers.delete(c))}}class s{constructor(E,c,p,b,v){this._extHostDocuments=c,this._extensionStoragePaths=p,this._extHostWebview=b,this._extHostWebviewPanels=v,this._editorProviders=new o,this._documents=new g,this._proxy=E.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(E,c,p,b){const v=new T.DisposableStore;return i(p)?(v.add(this._editorProviders.addTextProvider(c,E,p)),this._proxy.$registerTextEditorProvider((0,y.toExtensionData)(E),c,b.webviewOptions||{},{supportsMove:!!p.moveCustomTextEditor},(0,y.shouldSerializeBuffersForPostMessage)(E))):(v.add(this._editorProviders.addCustomProvider(c,E,p)),n(p)&&v.add(p.onDidChangeCustomDocument(u=>{const C=this.getCustomDocumentEntry(c,u.document.uri);if(a(u)){const f=C.addEdit(u);this._proxy.$onDidEdit(u.document.uri,c,f,u.label)}else this._proxy.$onContentChange(u.document.uri,c)})),this._proxy.$registerCustomEditorProvider((0,y.toExtensionData)(E),c,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,y.shouldSerializeBuffersForPostMessage)(E))),l.Disposable.from(v,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(c)}))}async $createCustomDocument(E,c,p,b,v){const u=this._editorProviders.get(c);if(!u)throw new Error(`No provider found for '${c}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${c}'`);const C=m.URI.revive(E),f=await u.provider.openCustomDocument(C,{backupId:p,untitledDocumentData:b?.buffer},v);let I;return n(u.provider)&&this._extensionStoragePaths&&(I=this._extensionStoragePaths.workspaceValue(u.extension)??this._extensionStoragePaths.globalValue(u.extension)),this._documents.add(c,f,I),{editable:n(u.provider)}}async $disposeCustomDocument(E,c){const p=this._editorProviders.get(c);if(!p)throw new Error(`No provider found for '${c}'`);if(p.type!==1)throw new Error(`Invalid provider type for '${c}'`);const b=m.URI.revive(E),{document:v}=this.getCustomDocumentEntry(c,b);this._documents.delete(c,v),v.dispose()}async $resolveCustomEditor(E,c,p,b,v,u){const C=this._editorProviders.get(p);if(!C)throw new Error(`No provider found for '${p}'`);const f=h.ViewColumn.to(v),I=this._extHostWebview.createNewWebview(c,b.contentOptions,C.extension),S=this._extHostWebviewPanels.createNewWebviewPanel(c,p,b.title,f,b.options,I,b.active),P=m.URI.revive(E);switch(C.type){case 1:{const{document:k}=this.getCustomDocumentEntry(p,P);return C.provider.resolveCustomEditor(k,S,u)}case 0:{const k=this._extHostDocuments.getDocument(P);return C.provider.resolveCustomTextEditor(k,S,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(E,c,p){this.getCustomDocumentEntry(c,E).disposeEdits(p)}async $onMoveCustomEditor(E,c,p){const b=this._editorProviders.get(p);if(!b)throw new Error(`No provider found for '${p}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${p}'`);const v=this._extHostWebviewPanels.getWebviewPanel(E);if(!v)throw new Error("No webview found");const u=m.URI.revive(c),C=this._extHostDocuments.getDocument(u);await b.provider.moveCustomTextEditor(C,v,D.CancellationToken.None)}async $undo(E,c,p,b){return this.getCustomDocumentEntry(c,E).undo(p,b)}async $redo(E,c,p,b){return this.getCustomDocumentEntry(c,E).redo(p,b)}async $revert(E,c,p){const b=this.getCustomDocumentEntry(c,E);await this.getCustomEditorProvider(c).revertCustomDocument(b.document,p),b.disposeBackup()}async $onSave(E,c,p){const b=this.getCustomDocumentEntry(c,E);await this.getCustomEditorProvider(c).saveCustomDocument(b.document,p),b.disposeBackup()}async $onSaveAs(E,c,p,b){const v=this.getCustomDocumentEntry(c,E);return this.getCustomEditorProvider(c).saveCustomDocumentAs(v.document,m.URI.revive(p),b)}async $backup(E,c,p){const b=this.getCustomDocumentEntry(c,E),u=await this.getCustomEditorProvider(c).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},p);return b.updateBackup(u),u.id}getCustomDocumentEntry(E,c){const p=this._documents.get(E,m.URI.revive(c));if(!p)throw new Error("No custom document found");return p}getCustomEditorProvider(E){const p=this._editorProviders.get(E)?.provider;if(!p||!n(p))throw new Error("Custom document is not editable");return p}}e.ExtHostCustomEditors=s;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function a(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function d(t){const E=t.scheme===N.Schemas.file||t.scheme===N.Schemas.untitled?t.fsPath:t.toString();return(0,O.hash)(E)+""}}),define(Pe[257],Te([1,0,164,100,2,4,7,8,5,13,28,44]),function(me,e,D,O,T,N,R,m,h,y,L,_){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{#e;#t;#i;constructor(o,s,n,i,a,d,t,E){this._name=o,this._owner=s,this._maxDiagnosticsTotal=n,this._maxDiagnosticsPerFile=i,this._modelVersionIdProvider=a,this._isDisposed=!1,this._maxDiagnosticsTotal=Math.max(i,n),this.#i=new L.ResourceMap(c=>d.getComparisonKey(c)),this.#e=t,this.#t=E}dispose(){this._isDisposed||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this._owner),this.#i.clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,s){if(!o){this.clear();return}this._checkDisposed();let n=[];if(T.URI.isUri(o)){if(!s){this.delete(o);return}this.#i.set(o,s.slice()),n=[o]}else if(Array.isArray(o)){n=[];let d;o=[...o].sort(w._compareIndexedTuplesByUri);for(const t of o){const[E,c]=t;if((!d||E.toString()!==d.toString())&&(d&&this.#i.get(d).length===0&&this.#i.delete(d),d=E,n.push(E),this.#i.set(E,[])),c)this.#i.get(E)?.push(...c);else{const p=this.#i.get(E);p&&(p.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let a=0;for(const d of n){let t=[];const E=this.#i.get(d);if(E)if(E.length>this._maxDiagnosticsPerFile){t=[];const c=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let p=0;p<4;p++)for(const b of E)if(b.severity===c[p]&&t.push({...m.Diagnostic.from(b),modelVersionId:this._modelVersionIdProvider(d)})===this._maxDiagnosticsPerFile)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,D.localize)(0,null,E.length-this._maxDiagnosticsPerFile),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=E.map(c=>({...m.Diagnostic.from(c),modelVersionId:this._modelVersionIdProvider(d)}));if(i.push([d,t]),a+=t.length,a>this._maxDiagnosticsTotal)break}this.#e.$changeMany(this._owner,i)}delete(o){this._checkDisposed(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this._owner)}forEach(o,s){this._checkDisposed();for(const[n,i]of this)o.call(s,n,i,this)}*[Symbol.iterator](){this._checkDisposed();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this._checkDisposed();const s=this.#i.get(o);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(this.#i.get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,s){return o[0].toString()<s[0].toString()?-1:o[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=w;let g=class{static{l=this}static{this._idPool=0}static{this._maxDiagnosticsPerFile=1e3}static{this._maxDiagnosticsTotal=1.1*l._maxDiagnosticsPerFile}static _mapper(o){const s=new L.ResourceMap;for(const n of o)s.set(n,n);return{uris:Object.freeze(Array.from(s.values()))}}constructor(o,s,n,i){this._logService=s,this._fileSystemInfoService=n,this._extHostDocumentsAndEditors=i,this._collections=new Map,this._onDidChangeDiagnostics=new h.DebounceEmitter({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=h.Event.map(this._onDidChangeDiagnostics.event,l._mapper),this._proxy=o.getProxy(N.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(o,s){const{_collections:n,_proxy:i,_onDidChangeDiagnostics:a,_logService:d,_fileSystemInfoService:t,_extHostDocumentsAndEditors:E}=this,c=new class{$changeMany(v,u){i.$changeMany(v,u),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,v,u.length===0?"CLEARING":u)}$clear(v){i.$clear(v),d.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,v)}dispose(){i.dispose()}};let p;if(!s)s="_generated_diagnostic_collection_name_#"+l._idPool++,p=s;else if(!n.has(s))p=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do p=s+l._idPool++;while(n.has(p))}return new class extends w{constructor(){super(s,p,l._maxDiagnosticsTotal,l._maxDiagnosticsPerFile,v=>E.getDocument(v)?.version,t.extUri,c,a),n.set(p,this)}dispose(){super.dispose(),n.delete(p)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const s=new Map,n=[];for(const i of this._collections.values())i.forEach((a,d)=>{let t=s.get(a.toString());typeof t>"u"&&(t=n.length,s.set(a.toString(),t),n.push([a,[]])),n[t][1]=n[t][1].concat(...d)});return n}}_getDiagnostics(o){let s=[];for(const n of this._collections.values())n.has(o)&&(s=s.concat(n.get(o)));return s}$acceptMarkersChange(o){if(!this._mirrorCollection){const s="_generated_mirror",n=new w(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(s,n),this._mirrorCollection=n}for(const[s,n]of o)this._mirrorCollection.set(T.URI.revive(s),n.map(m.Diagnostic.to))}};e.ExtHostDiagnostics=g,e.ExtHostDiagnostics=g=l=Ke([He(1,y.ILogService),He(2,_.IExtHostFileSystemInfo)],g)}),define(Pe[258],Te([1,0,2,14,7,8,192]),function(me,e,D,O,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class m{constructor(y,L,_,l={timeout:1500,errors:3}){this._logService=y,this._documents=L,this._mainThreadBulkEdits=_,this._thresholds=l,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(y){return(L,_,l)=>{const g={dispose:this._callbacks.push([L,_,y])};return Array.isArray(l)&&l.push(g),g}}async $participateInSave(y,L){const _=D.URI.revive(y);let l=!1;const w=setTimeout(()=>l=!0,this._thresholds.timeout),g=[];try{for(const r of[...this._callbacks]){if(l)break;const o=this._documents.getDocument(_),s=await this._deliverEventAsyncAndBlameBadListeners(r,{document:o,reason:N.TextDocumentSaveReason.to(L)});g.push(s)}}finally{clearTimeout(w)}return g}_deliverEventAsyncAndBlameBadListeners([y,L,_],l){const w=this._badListeners.get(y);return typeof w=="number"&&w>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,y,L,l).then(()=>!0,g=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const r=this._badListeners.get(y);this._badListeners.set(y,r?r+1:1),typeof r=="number"&&r>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(y,L,_,l){const w=[],g=Date.now(),{document:r,reason:o}=l,{version:s}=r,n=Object.freeze({document:r,reason:o,waitUntil(i){if(Object.isFrozen(w))throw(0,O.illegalState)("waitUntil can not be called async");w.push(Promise.resolve(i))}});try{L.apply(_,[n])}catch(i){return Promise.reject(i)}return Object.freeze(w),new Promise((i,a)=>{const d=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(w).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(d),i(t)}).catch(t=>{clearTimeout(d),a(t)})}).then(i=>{const a={edits:[]};for(const d of i)if(Array.isArray(d)&&d.every(t=>t instanceof T.TextEdit))for(const{newText:t,newEol:E,range:c}of d)a.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:c&&N.Range.from(c),text:t,eol:E&&N.EndOfLine.from(E)}});if(a.edits.length!==0)return s===r.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=m}),define(Pe[259],Te([1,0,5,6,2,4,111,8,17,26,7]),function(me,e,D,O,T,N,R,m,h,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(w,g){this._onDidAddDocument=new D.Emitter,this._onDidRemoveDocument=new D.Emitter,this._onDidChangeDocument=new D.Emitter,this._onDidSaveDocument=new D.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new O.DisposableStore,this._documentLoader=new Map,this._proxy=w.getProxy(N.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const o of r)this._onDidRemoveDocument.fire(o.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const o of r)this._onDidAddDocument.fire(o.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(w){if(!w)return;const g=this._documentsAndEditors.getDocument(w);if(g)return g}getDocument(w){const g=this.getDocumentData(w);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return g.document}ensureDocumentData(w){const g=this._documentsAndEditors.getDocument(w);if(g)return Promise.resolve(g);let r=this._documentLoader.get(w.toString());return r||(r=this._proxy.$tryOpenDocument(w).then(o=>{this._documentLoader.delete(w.toString());const s=T.URI.revive(o);return(0,h.assertIsDefined)(this._documentsAndEditors.getDocument(s))},o=>(this._documentLoader.delete(w.toString()),Promise.reject(o))),this._documentLoader.set(w.toString(),r)),r}createDocumentData(w){return this._proxy.$tryCreateDocument(w).then(g=>T.URI.revive(g))}$acceptModelLanguageChanged(w,g){const r=T.URI.revive(w),o=this._documentsAndEditors.getDocument(r);if(!o)throw new Error("unknown document");this._onDidRemoveDocument.fire(o.document),o._acceptLanguageId(g),this._onDidAddDocument.fire(o.document)}$acceptModelSaved(w){const g=T.URI.revive(w),r=this._documentsAndEditors.getDocument(g);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(w,g){const r=T.URI.revive(w),o=this._documentsAndEditors.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(g),this._onDidChangeDocument.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,g,r){const o=T.URI.revive(w),s=this._documentsAndEditors.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(r),s.onEvents(g);let n;g.isUndoing?n=L.TextDocumentChangeReason.Undo:g.isRedoing&&(n=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,y.deepFreeze)({document:s.document,contentChanges:g.changes.map(i=>({range:m.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(w,g){(0,R.setWordDefinitionFor)(w,g)}}e.ExtHostDocuments=_}),define(Pe[66],Te([1,0,260,5,17,2,3,4,16,8,7]),function(me,e,D,O,T,N,R,m,h,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,R.createDecorator)("IExtHostEditorTabs");class _{constructor(o,s,n){this._activeTabIdGetter=n,this._parentGroup=s,this.acceptDtoUpdate(o)}get apiObject(){if(!this._apiObject){const o=this,s={get isActive(){return o._dto.id===o._activeTabIdGetter()},get label(){return o._dto.label},get input(){return o._input},get isDirty(){return o._dto.isDirty},get isPinned(){return o._dto.isPinned},get isPreview(){return o._dto.isPreview},get group(){return o._parentGroup.apiObject}};this._apiObject=Object.freeze(s)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(o){this._dto=o,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new L.TextTabInput(N.URI.revive(this._dto.input.uri));case 2:return new L.TextDiffTabInput(N.URI.revive(this._dto.input.original),N.URI.revive(this._dto.input.modified));case 3:return new L.TextMergeTabInput(N.URI.revive(this._dto.input.base),N.URI.revive(this._dto.input.input1),N.URI.revive(this._dto.input.input2),N.URI.revive(this._dto.input.result));case 6:return new L.CustomEditorTabInput(N.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new L.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new L.NotebookEditorTabInput(N.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new L.NotebookDiffEditorTabInput(N.URI.revive(this._dto.input.original),N.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new L.TerminalEditorTabInput;case 9:return new L.InteractiveWindowInput(N.URI.revive(this._dto.input.uri),N.URI.revive(this._dto.input.inputBoxUri));case 10:return new L.ChatEditorTabInput(this._dto.input.providerId);case 11:return new L.TextMultiDiffTabInput(this._dto.input.diffEditors.map(o=>new L.TextDiffTabInput(N.URI.revive(o.original),N.URI.revive(o.modified))));default:return}}}class l{constructor(o,s){this._tabs=[],this._activeTabId="",this._dto=o,this._activeGroupIdGetter=s;for(const n of o.tabs)n.isActive&&(this._activeTabId=n.id),this._tabs.push(new _(n,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const o=this,s={get isActive(){return o._dto.groupId===o._activeGroupIdGetter()},get viewColumn(){return y.ViewColumn.to(o._dto.viewColumn)},get activeTab(){return o._tabs.find(n=>n.tabId===o._activeTabId)?.apiObject},get tabs(){return Object.freeze(o._tabs.map(n=>n.apiObject))}};this._apiObject=Object.freeze(s)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(o){this._dto=o}acceptTabOperation(o){if(o.kind===0){const n=new _(o.tabDto,this,()=>this.activeTabId());return this._tabs.splice(o.index,0,n),o.tabDto.isActive&&(this._activeTabId=n.tabId),n}else if(o.kind===1){const n=this._tabs.splice(o.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return n.tabId===this._activeTabId&&(this._activeTabId=""),n}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this._tabs.splice(o.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this._tabs.splice(o.index,0,n),n}const s=this._tabs.find(n=>n.tabId===o.tabDto.id);if(!s)throw new Error("INVALID tab");return o.tabDto.isActive?this._activeTabId=o.tabDto.id:this._activeTabId===o.tabDto.id&&!o.tabDto.isActive&&(this._activeTabId=""),s.acceptDtoUpdate(o.tabDto),s}activeTabId(){return this._activeTabId}}let w=class{constructor(o){this._onDidChangeTabs=new O.Emitter,this._onDidChangeTabGroups=new O.Emitter,this._extHostTabGroups=[],this._proxy=o.getProxy(m.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const o=this,s={onDidChangeTabGroups:o._onDidChangeTabGroups.event,onDidChangeTabs:o._onDidChangeTabs.event,get all(){return Object.freeze(o._extHostTabGroups.map(n=>n.apiObject))},get activeTabGroup(){const n=o._activeGroupId;return(0,T.assertIsDefined)(o._extHostTabGroups.find(a=>a.groupId===n)?.apiObject)},close:async(n,i)=>{const a=Array.isArray(n)?n:[n];return a.length?g(a[0])?this._closeGroups(a,i):this._closeTabs(a,i):!0}};this._apiObject=Object.freeze(s)}return this._apiObject}$acceptEditorTabModel(o){const s=new Set(this._extHostTabGroups.map(c=>c.groupId)),n=new Set(o.map(c=>c.groupId)),i=(0,D.diffSets)(s,n),a=this._extHostTabGroups.filter(c=>i.removed.includes(c.groupId)).map(c=>c.apiObject),d=[],t=[];this._extHostTabGroups=o.map(c=>{const p=new l(c,()=>this._activeGroupId);return i.added.includes(p.groupId)?d.push(p.apiObject):t.push(p.apiObject),p});const E=(0,T.assertIsDefined)(o.find(c=>c.isActive===!0)?.groupId);E!==void 0&&this._activeGroupId!==E&&(this._activeGroupId=E),this._onDidChangeTabGroups.fire(Object.freeze({opened:d,closed:a,changed:t}))}$acceptTabGroupUpdate(o){const s=this._extHostTabGroups.find(n=>n.groupId===o.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(o),o.isActive&&(this._activeGroupId=o.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const s=this._extHostTabGroups.find(i=>i.groupId===o.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const n=s.acceptTabOperation(o);switch(o.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}_findExtHostTabFromApi(o){for(const s of this._extHostTabGroups)for(const n of s.tabs)if(n.apiObject===o)return n}_findExtHostTabGroupFromApi(o){return this._extHostTabGroups.find(s=>s.apiObject===o)}async _closeTabs(o,s){const n=[];for(const i of o){const a=this._findExtHostTabFromApi(i);if(!a)throw new Error("Tab close: Invalid tab not found!");n.push(a.tabId)}return this._proxy.$closeTab(n,s)}async _closeGroups(o,s){const n=[];for(const i of o){const a=this._findExtHostTabGroupFromApi(i);if(!a)throw new Error("Group close: Invalid group not found!");n.push(a.groupId)}return this._proxy.$closeGroup(n,s)}};e.ExtHostEditorTabs=w,e.ExtHostEditorTabs=w=Ke([He(0,h.IExtHostRpcService)],w);function g(r){return r.tabs!==void 0}}),define(Pe[261],Te([1,0,2,4,6,7,8,304,15,22,25,54]),function(me,e,D,O,T,N,R,m,h,y,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class l{constructor(){this._schemes=[]}add(r){this._stateMachine=void 0,this._schemes.push(r)}delete(r){const o=this._schemes.indexOf(r);o>=0&&(this._schemes.splice(o,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const r=this._schemes.sort(),o=[];let s,n,i=14,a=14;for(const d of r){let t=s?(0,h.commonPrefixLength)(s,d):0;for(t===0?n=1:n=a;t<d.length;t++)t+1===d.length?(i=a,a=9):a+=1,o.push([n,d.toUpperCase().charCodeAt(t),a]),o.push([n,d.toLowerCase().charCodeAt(t),a]),n=a;s=d,a=i}o.push([9,58,10]),o.push([10,47,12]),this._stateMachine=new m.StateMachine(o)}}provideDocumentLinks(r){this._initStateMachine();const o=[],s=m.LinkComputer.computeLinks({getLineContent(n){return r.lineAt(n-1).text},getLineCount(){return r.lineCount}},this._stateMachine);for(const n of s){const i=R.DocumentLink.to(n);i.target&&o.push(i)}return o}}class w{constructor(r,o){this._extHostLanguageFeatures=o,this._linkProvider=new l,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=r.getProxy(O.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(r,o,s,n={}){if(w._validateFileSystemProvider(s),this._registeredSchemes.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(r,"*",this._linkProvider));const i=this._handlePool++;this._linkProvider.add(o),this._registeredSchemes.add(o),this._fsProvider.set(i,s);let a=2;n.isCaseSensitive&&(a+=1024),n.isReadonly&&(a+=2048),typeof s.copy=="function"&&(a+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,L.checkProposedApiEnabled)(r,"fsChunks"),a+=4);let d;n.isReadonly&&(0,_.isMarkdownString)(n.isReadonly)&&n.isReadonly.value!==""&&(d={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this._proxy.$registerFileSystemProvider(i,o,a,d).catch(E=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${o}`),console.error(E)});const t=s.onDidChangeFile(E=>{const c=[];for(const p of E){const{uri:b,type:v}=p;if(b.scheme!==o)continue;let u;switch(v){case N.FileChangeType.Changed:u=0;break;case N.FileChangeType.Created:u=1;break;case N.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:b,type:u})}this._proxy.$onFileSystemChange(i,c)});return(0,T.toDisposable)(()=>{t.dispose(),this._linkProvider.delete(o),this._registeredSchemes.delete(o),this._fsProvider.delete(i),this._proxy.$unregisterProvider(i)})}static _validateFileSystemProvider(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static _asIStat(r){const{type:o,ctime:s,mtime:n,size:i,permissions:a}=r;return{type:o,ctime:s,mtime:n,size:i,permissions:a}}$stat(r,o){return Promise.resolve(this._getFsProvider(r).stat(D.URI.revive(o))).then(s=>w._asIStat(s))}$readdir(r,o){return Promise.resolve(this._getFsProvider(r).readDirectory(D.URI.revive(o)))}$readFile(r,o){return Promise.resolve(this._getFsProvider(r).readFile(D.URI.revive(o))).then(s=>y.VSBuffer.wrap(s))}$writeFile(r,o,s,n){return Promise.resolve(this._getFsProvider(r).writeFile(D.URI.revive(o),s.buffer,n))}$delete(r,o,s){return Promise.resolve(this._getFsProvider(r).delete(D.URI.revive(o),s))}$rename(r,o,s,n){return Promise.resolve(this._getFsProvider(r).rename(D.URI.revive(o),D.URI.revive(s),n))}$copy(r,o,s,n){const i=this._getFsProvider(r);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(D.URI.revive(o),D.URI.revive(s),n))}$mkdir(r,o){return Promise.resolve(this._getFsProvider(r).createDirectory(D.URI.revive(o)))}$watch(r,o,s,n){const i=this._getFsProvider(r).watch(D.URI.revive(s),n);this._watches.set(o,i)}$unwatch(r,o){const s=this._watches.get(o);s&&(s.dispose(),this._watches.delete(o))}$open(r,o,s){const n=this._getFsProvider(r);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(D.URI.revive(o),s))}$close(r,o){const s=this._getFsProvider(r);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(o))}$read(r,o,s,n){const i=this._getFsProvider(r);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const a=y.VSBuffer.alloc(n);return Promise.resolve(i.read(o,s,a.buffer,0,n)).then(d=>a.slice(0,d))}$write(r,o,s,n){const i=this._getFsProvider(r);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(o,s,n.buffer,0,n.byteLength))}_getFsProvider(r){const o=this._fsProvider.get(r);if(!o){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return o}}e.ExtHostFileSystem=w}),define(Pe[262],Te([1,0,5,35,2,4,8,7,40]),function(me,e,D,O,T,N,R,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return!!(this._config&1)}get ignoreChangeEvents(){return!!(this._config&2)}get ignoreDeleteEvents(){return!!(this._config&4)}constructor(w,g,r,o,s,n){this.session=Math.random(),this._onDidCreate=new D.Emitter,this._onDidChange=new D.Emitter,this._onDidDelete=new D.Emitter,this._config=0,n?.ignoreCreateEvents&&(this._config+=1),n?.ignoreChangeEvents&&(this._config+=2),n?.ignoreDeleteEvents&&(this._config+=4);const i=(0,O.parse)(s),a=typeof s=="string",d=n?.correlate,t=o(E=>{if(!(typeof E.session=="number"&&E.session!==this.session)&&!(d&&typeof E.session>"u")){if(!n?.ignoreCreateEvents)for(const c of E.created){const p=T.URI.revive(c);i(p.fsPath)&&(!a||g.getWorkspaceFolder(p))&&this._onDidCreate.fire(p)}if(!n?.ignoreChangeEvents)for(const c of E.changed){const p=T.URI.revive(c);i(p.fsPath)&&(!a||g.getWorkspaceFolder(p))&&this._onDidChange.fire(p)}if(!n?.ignoreDeleteEvents)for(const c of E.deleted){const p=T.URI.revive(c);i(p.fsPath)&&(!a||g.getWorkspaceFolder(p))&&this._onDidDelete.fire(p)}}});this._disposable=m.Disposable.from(this.ensureWatching(w,r,s,n,n?.correlate),this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(w,g,r,o,s){const n=m.Disposable.from();if(typeof r=="string")return n;const i=w.getProxy(N.MainContext.MainThreadFileSystemEventService);let a=!1;return(r.pattern.includes(O.GLOBSTAR)||r.pattern.includes(O.GLOB_SPLIT))&&(a=!0),i.$watch(g.identifier.value,this.session,r.baseUri,{recursive:a,excludes:o?.excludes??[]},!!s),m.Disposable.from({dispose:()=>i.$unwatch(this.session)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class L{constructor(w){this._events=w,this.session=this._events.session,this._created=new h.Lazy(()=>this._events.created.map(T.URI.revive)),this._changed=new h.Lazy(()=>this._events.changed.map(T.URI.revive)),this._deleted=new h.Lazy(()=>this._events.deleted.map(T.URI.revive))}get created(){return this._created.value}get changed(){return this._changed.value}get deleted(){return this._deleted.value}}class _{constructor(w,g,r){this._mainContext=w,this._logService=g,this._extHostDocumentsAndEditors=r,this._onFileSystemEvent=new D.Emitter,this._onDidRenameFile=new D.Emitter,this._onDidCreateFile=new D.Emitter,this._onDidDeleteFile=new D.Emitter,this._onWillRenameFile=new D.AsyncEmitter,this._onWillCreateFile=new D.AsyncEmitter,this._onWillDeleteFile=new D.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(w,g,r,o){return new y(this._mainContext,w,g,this._onFileSystemEvent.event,R.GlobPattern.from(r),o)}$onFileEvent(w){this._onFileSystemEvent.fire(new L(w))}$onDidRunFileOperation(w,g){switch(w){case 2:this._onDidRenameFile.fire(Object.freeze({files:g.map(r=>({oldUri:T.URI.revive(r.source),newUri:T.URI.revive(r.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:g.map(r=>T.URI.revive(r.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:g.map(r=>T.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(w){return this._createWillExecuteEvent(w,this._onWillRenameFile)}getOnWillCreateFileEvent(w){return this._createWillExecuteEvent(w,this._onWillCreateFile)}getOnWillDeleteFileEvent(w){return this._createWillExecuteEvent(w,this._onWillDeleteFile)}_createWillExecuteEvent(w,g){return(r,o,s)=>{const n=function(a){r.call(o,a)};return n.extension=w,g.event(n,void 0,s)}}async $onWillRunFileOperation(w,g,r,o){switch(w){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:g.map(s=>({oldUri:T.URI.revive(s.source),newUri:T.URI.revive(s.target)}))},r,o);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:g.map(s=>T.URI.revive(s.target))},r,o);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:g.map(s=>T.URI.revive(s.target))},r,o)}}async _fireWillEvent(w,g,r,o){const s=new Set,n=[];if(await w.fireAsync(g,o,async(a,d)=>{const t=Date.now(),E=await Promise.resolve(a);E instanceof m.WorkspaceEdit&&(n.push([d.extension,E]),s.add(d.extension.displayName??d.extension.identifier.value)),Date.now()-t>r&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),o.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,a]of n){const{edits:d}=R.WorkspaceEdit.from(a,{getTextDocumentVersion:t=>this._extHostDocumentsAndEditors.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(d)}return{edit:i,extensionNames:Array.from(s)}}}e.ExtHostFileSystemEventService=_}),define(Pe[263],Te([1,0,18,11,24,14,90,6,26,65,15,17,2,29,305,87,97,166,20,8,7,25,74,4]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o,s,n,i,a,d,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class c{constructor(B,x){this._documents=B,this._provider=x}async provideDocumentSymbols(B,x){const q=this._documents.getDocument(B),W=await this._provider.provideDocumentSymbols(q,x);if(!(0,D.isFalsyOrEmpty)(W))return W[0]instanceof a.DocumentSymbol?W.map(i.DocumentSymbol.from):c._asDocumentSymbolTree(W)}static _asDocumentSymbolTree(B){B=B.slice(0).sort((W,ee)=>{let se=W.location.range.start.compareTo(ee.location.range.start);return se===0&&(se=ee.location.range.end.compareTo(W.location.range.end)),se});const x=[],q=[];for(const W of B){const ee={name:W.name||"!!MISSING: name!!",kind:i.SymbolKind.from(W.kind),tags:W.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:W.containerName,range:i.Range.from(W.location.range),selectionRange:i.Range.from(W.location.range),children:[]};for(;;){if(q.length===0){q.push(ee),x.push(ee);break}const se=q[q.length-1];if(w.Range.containsRange(se.range,ee.range)&&!w.Range.equalsRange(se.range,ee.range)){se.children?.push(ee),q.push(ee);break}q.pop()}}return x}}class p{constructor(B,x,q,W,ee,se){this._documents=B,this._commands=x,this._provider=q,this._extension=W,this._extTelemetry=ee,this._logService=se,this._cache=new t.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(B,x){const q=this._documents.getDocument(B),W=await this._provider.provideCodeLenses(q,x);if(!W||x.isCancellationRequested)return;const ee=this._cache.add(W),se=new m.DisposableStore;this._disposables.set(ee,se);const Oe={cacheId:ee,lenses:[]};for(let ze=0;ze<W.length;ze++)Oe.lenses.push({cacheId:[ee,ze],range:i.Range.from(W[ze].range),command:this._commands.toInternal(W[ze].command,se)});return Oe}async resolveCodeLens(B,x){const q=B.cacheId&&this._cache.get(...B.cacheId);if(!q)return;let W;if(typeof this._provider.resolveCodeLens!="function"||q.isResolved?W=q:W=await this._provider.resolveCodeLens(q,x),W||(W=q),x.isCancellationRequested)return;const ee=B.cacheId&&this._disposables.get(B.cacheId[0]);if(ee){if(!W.command){const se=new Error("INVALID code lens resolved, lacks command: "+this._extension.identifier.value);this._extTelemetry.onExtensionError(this._extension.identifier,se),this._logService.error(se);return}return B.command=this._commands.toInternal(W.command,ee),B}}releaseCodeLenses(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}}function b(Ue){return Array.isArray(Ue)?Ue.map(i.DefinitionLink.from):Ue?[i.DefinitionLink.from(Ue)]:[]}class v{constructor(B,x){this._documents=B,this._provider=x}async provideDefinition(B,x,q){const W=this._documents.getDocument(B),ee=i.Position.to(x),se=await this._provider.provideDefinition(W,ee,q);return b(se)}}class u{constructor(B,x){this._documents=B,this._provider=x}async provideDeclaration(B,x,q){const W=this._documents.getDocument(B),ee=i.Position.to(x),se=await this._provider.provideDeclaration(W,ee,q);return b(se)}}class C{constructor(B,x){this._documents=B,this._provider=x}async provideImplementation(B,x,q){const W=this._documents.getDocument(B),ee=i.Position.to(x),se=await this._provider.provideImplementation(W,ee,q);return b(se)}}class f{constructor(B,x){this._documents=B,this._provider=x}async provideTypeDefinition(B,x,q){const W=this._documents.getDocument(B),ee=i.Position.to(x),se=await this._provider.provideTypeDefinition(W,ee,q);return b(se)}}class I{constructor(B,x){this._documents=B,this._provider=x}async provideHover(B,x,q){const W=this._documents.getDocument(B),ee=i.Position.to(x),se=await this._provider.provideHover(W,ee,q);if(!(!se||(0,D.isFalsyOrEmpty)(se.contents)))return se.range||(se.range=W.getWordRangeAtPosition(ee)),se.range||(se.range=new a.Range(ee,ee)),i.Hover.from(se)}}class S{constructor(B,x){this._documents=B,this._provider=x}async provideEvaluatableExpression(B,x,q){const W=this._documents.getDocument(B),ee=i.Position.to(x),se=await this._provider.provideEvaluatableExpression(W,ee,q);if(se)return i.EvaluatableExpression.from(se)}}class P{constructor(B,x){this._documents=B,this._provider=x}async provideInlineValues(B,x,q,W){const ee=this._documents.getDocument(B),se=await this._provider.provideInlineValues(ee,i.Range.to(x),i.InlineValueContext.to(q),W);if(Array.isArray(se))return se.map(Oe=>i.InlineValue.from(Oe))}}class k{constructor(B,x){this._documents=B,this._provider=x}async provideDocumentHighlights(B,x,q){const W=this._documents.getDocument(B),ee=i.Position.to(x),se=await this._provider.provideDocumentHighlights(W,ee,q);if(Array.isArray(se))return se.map(i.DocumentHighlight.from)}}class H{constructor(B,x){this._documents=B,this._provider=x}async provideMultiDocumentHighlights(B,x,q,W){const ee=this._documents.getDocument(B),se=q.map(Ge=>this._documents.getDocument(Ge)),Oe=i.Position.to(x),ze=await this._provider.provideMultiDocumentHighlights(ee,Oe,se,W);if(Array.isArray(ze))return ze.map(i.MultiDocumentHighlight.from)}}class ${constructor(B,x){this._documents=B,this._provider=x}async provideLinkedEditingRanges(B,x,q){const W=this._documents.getDocument(B),ee=i.Position.to(x),se=await this._provider.provideLinkedEditingRanges(W,ee,q);if(se&&Array.isArray(se.ranges))return{ranges:(0,D.coalesce)(se.ranges.map(i.Range.from)),wordPattern:se.wordPattern}}}class V{constructor(B,x){this._documents=B,this._provider=x}async provideReferences(B,x,q,W){const ee=this._documents.getDocument(B),se=i.Position.to(x),Oe=await this._provider.provideReferences(ee,se,q,W);if(Array.isArray(Oe))return Oe.map(i.location.from)}}class A{static{this._maxCodeActionsPerFile=1e3}constructor(B,x,q,W,ee,se,Oe){this._documents=B,this._commands=x,this._diagnostics=q,this._provider=W,this._logService=ee,this._extension=se,this._apiDeprecation=Oe,this._cache=new t.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(B,x,q,W){const ee=this._documents.getDocument(B),se=g.Selection.isISelection(x)?i.Selection.to(x):i.Range.to(x),Oe=[];for(const it of this._diagnostics.getDiagnostics(B))if(se.intersection(it.range)&&Oe.push(it)>A._maxCodeActionsPerFile)break;const ze={diagnostics:Oe,only:q.only?new a.CodeActionKind(q.only):void 0,triggerKind:i.CodeActionTriggerKind.to(q.trigger)},Ge=await this._provider.provideCodeActions(ee,se,ze,W);if(!(0,D.isNonEmptyArray)(Ge)||W.isCancellationRequested)return;const Je=this._cache.add(Ge),et=new m.DisposableStore;this._disposables.set(Je,et);const ot=[];for(let it=0;it<Ge.length;it++){const nt=Ge[it];if(nt)if(A._isCommand(nt))this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:nt.title,command:this._commands.toInternal(nt,et)});else{ze.only&&(nt.kind?ze.only.contains(nt.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=nt.ranges??[];ot.push({cacheId:[Je,it],title:nt.title,command:nt.command&&this._commands.toInternal(nt.command,et),diagnostics:nt.diagnostics&&nt.diagnostics.map(i.Diagnostic.from),edit:nt.edit&&i.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,d.isProposedApiEnabled)(this._extension,"codeActionAI")?nt.isAI:!1,ranges:(0,d.isProposedApiEnabled)(this._extension,"codeActionRanges")?(0,D.coalesce)(at.map(i.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:Je,actions:ot}}async resolveCodeAction(B,x){const[q,W]=B,ee=this._cache.get(q,W);if(!ee||A._isCommand(ee))return{};if(!this._provider.resolveCodeAction)return{};const se=await this._provider.resolveCodeAction(ee,x)??ee;let Oe;se.edit&&(Oe=i.WorkspaceEdit.from(se.edit,void 0));let ze;if(se.command){const Ge=this._disposables.get(q);Ge&&(ze=this._commands.toInternal(se.command,Ge))}return{edit:Oe,command:ze}}releaseCodeActions(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}static _isCommand(B){return typeof B.command=="string"&&typeof B.title=="string"}}class U{constructor(B,x,q,W,ee){this._proxy=B,this._documents=x,this._provider=q,this._handle=W,this._extension=ee,this._cache=new t.Cache("DocumentPasteEdit")}async prepareDocumentPaste(B,x,q,W){if(!this._provider.prepareDocumentPaste)return;const ee=this._documents.getDocument(B),se=x.map(Ge=>i.Range.to(Ge)),Oe=i.DataTransfer.toDataTransfer(q,()=>{throw new N.NotImplementedError});if(await this._provider.prepareDocumentPaste(ee,se,Oe,W),W.isCancellationRequested)return;const ze=Array.from(Oe).filter(([,Ge])=>!(Ge instanceof a.InternalDataTransferItem));return i.DataTransfer.from(ze)}async providePasteEdits(B,x,q,W,ee,se){if(!this._provider.provideDocumentPasteEdits)return[];const Oe=this._documents.getDocument(x),ze=q.map(ot=>i.Range.to(ot)),Ge=i.DataTransfer.toDataTransfer(W,async ot=>(await this._proxy.$resolvePasteFileData(this._handle,B,ot)).buffer),Je=await this._provider.provideDocumentPasteEdits(Oe,ze,Ge,{only:ee.only?new a.DocumentPasteEditKind(ee.only):void 0,triggerKind:ee.triggerKind},se);if(!Je||se.isCancellationRequested)return[];const et=this._cache.add(Je);return Je.map((ot,it)=>({_cacheId:[et,it],title:ot.title??(0,s.localize)(0,null,this._extension.displayName||this._extension.name),kind:ot.kind,yieldTo:ot.yieldTo?.map(nt=>nt.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?i.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolvePasteEdit(B,x){const[q,W]=B,ee=this._cache.get(q,W);if(!ee||!this._provider.resolveDocumentPasteEdit)return{};const se=await this._provider.resolveDocumentPasteEdit(ee,x)??ee;return{additionalEdit:se.additionalEdit?i.WorkspaceEdit.from(se.additionalEdit,void 0):void 0}}releasePasteEdits(B){this._cache.delete(B)}}class j{constructor(B,x){this._documents=B,this._provider=x}async provideDocumentFormattingEdits(B,x,q){const W=this._documents.getDocument(B),ee=await this._provider.provideDocumentFormattingEdits(W,x,q);if(Array.isArray(ee))return ee.map(i.TextEdit.from)}}class ie{constructor(B,x){this._documents=B,this._provider=x}async provideDocumentRangeFormattingEdits(B,x,q,W){const ee=this._documents.getDocument(B),se=i.Range.to(x),Oe=await this._provider.provideDocumentRangeFormattingEdits(ee,se,q,W);if(Array.isArray(Oe))return Oe.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,x,q,W){(0,_.assertType)(typeof this._provider.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this._documents.getDocument(B),se=x.map(i.Range.to),Oe=await this._provider.provideDocumentRangesFormattingEdits(ee,se,q,W);if(Array.isArray(Oe))return Oe.map(i.TextEdit.from)}}class fe{constructor(B,x){this._documents=B,this._provider=x,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,x,q,W,ee){const se=this._documents.getDocument(B),Oe=i.Position.to(x),ze=await this._provider.provideOnTypeFormattingEdits(se,Oe,q,W,ee);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}}class Ce{constructor(B,x){this._provider=B,this._logService=x,this._cache=new t.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(B,x){const q=await this._provider.provideWorkspaceSymbols(B,x);if(!(0,D.isNonEmptyArray)(q))return{symbols:[]};const W=this._cache.add(q),ee={cacheId:W,symbols:[]};for(let se=0;se<q.length;se++){const Oe=q[se];if(!Oe||!Oe.name){this._logService.warn("INVALID SymbolInformation",Oe);continue}ee.symbols.push({...i.WorkspaceSymbol.from(Oe),cacheId:[W,se]})}return ee}async resolveWorkspaceSymbol(B,x){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const q=this._cache.get(...B.cacheId);if(q){const W=await this._provider.resolveWorkspaceSymbol(q,x);return W&&(0,h.mixin)(B,i.WorkspaceSymbol.from(W),!0)}}releaseWorkspaceSymbols(B){this._cache.delete(B)}}class _e{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,x,q){this._documents=B,this._provider=x,this._logService=q}async provideRenameEdits(B,x,q,W){const ee=this._documents.getDocument(B),se=i.Position.to(x);try{const Oe=await this._provider.provideRenameEdits(ee,se,q,W);return Oe?i.WorkspaceEdit.from(Oe):void 0}catch(Oe){const ze=_e._asMessage(Oe);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(B,x,q){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const W=this._documents.getDocument(B),ee=i.Position.to(x);try{const se=await this._provider.prepareRename(W,ee,q);let Oe,ze;if(a.Range.isRange(se)?(Oe=se,ze=W.getText(se)):(0,_.isObject)(se)&&(Oe=se.range,ze=se.placeholder),!Oe||!ze)return;if(Oe.start.line>ee.line||Oe.end.line<ee.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Oe),text:ze}}catch(se){const Oe=_e._asMessage(se);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(se)}}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class oe{constructor(B,x,q){this._documents=B,this._provider=x,this._logService=q}async provideNewSymbolNames(B,x,q){const W=this._documents.getDocument(B),ee=i.Range.to(x);try{const se=await this._provider.provideNewSymbolNames(W,ee,q);return se?se.map(Oe=>typeof Oe=="string"?{newSymbolName:Oe}:{newSymbolName:Oe.newSymbolName,tags:Oe.tags}):void 0}catch(se){this._logService.error(oe._asMessage(se)??JSON.stringify(se,null,"	"));return}}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class pe{constructor(B,x){this.resultId=B,this.tokens=x}}class ne{constructor(B,x){this._documents=B,this._provider=x,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(B,x,q){const W=this._documents.getDocument(B),ee=x!==0?this._previousResults.get(x):null;let se=typeof ee?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(W,ee.resultId,q):await this._provider.provideDocumentSemanticTokens(W,q);return ee&&this._previousResults.delete(x),se?(se=ne._fixProvidedSemanticTokens(se),this._send(ne._convertToEdits(ee,se),se)):null}async releaseDocumentSemanticColoring(B){this._previousResults.delete(B)}static _fixProvidedSemanticTokens(B){return ne._isSemanticTokens(B)?ne._isCorrectSemanticTokens(B)?B:new a.SemanticTokens(new Uint32Array(B.data),B.resultId):ne._isSemanticTokensEdits(B)?ne._isCorrectSemanticTokensEdits(B)?B:new a.SemanticTokensEdits(B.edits.map(x=>new a.SemanticTokensEdit(x.start,x.deleteCount,x.data?new Uint32Array(x.data):x.data)),B.resultId):B}static _isSemanticTokens(B){return B&&!!B.data}static _isCorrectSemanticTokens(B){return B.data instanceof Uint32Array}static _isSemanticTokensEdits(B){return B&&Array.isArray(B.edits)}static _isCorrectSemanticTokensEdits(B){for(const x of B.edits)if(!(x.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(B,x){if(!ne._isSemanticTokens(x)||!B||!B.tokens)return x;const q=B.tokens,W=q.length,ee=x.data,se=ee.length;let Oe=0;const ze=Math.min(W,se);for(;Oe<ze&&q[Oe]===ee[Oe];)Oe++;if(Oe===W&&Oe===se)return new a.SemanticTokensEdits([],x.resultId);let Ge=0;const Je=ze-Oe;for(;Ge<Je&&q[W-Ge-1]===ee[se-Ge-1];)Ge++;return new a.SemanticTokensEdits([{start:Oe,deleteCount:W-Oe-Ge,data:ee.subarray(Oe,se-Ge)}],x.resultId)}_send(B,x){if(ne._isSemanticTokens(B)){const q=this._nextResultId++;return this._previousResults.set(q,new pe(B.resultId,B.data)),(0,o.encodeSemanticTokensDto)({id:q,type:"full",data:B.data})}if(ne._isSemanticTokensEdits(B)){const q=this._nextResultId++;return ne._isSemanticTokens(x)?this._previousResults.set(q,new pe(x.resultId,x.data)):this._previousResults.set(q,new pe(B.resultId)),(0,o.encodeSemanticTokensDto)({id:q,type:"delta",deltas:(B.edits||[]).map(W=>({start:W.start,deleteCount:W.deleteCount,data:W.data}))})}return null}}class Ie{constructor(B,x){this._documents=B,this._provider=x}async provideDocumentRangeSemanticTokens(B,x,q){const W=this._documents.getDocument(B),ee=await this._provider.provideDocumentRangeSemanticTokens(W,i.Range.to(x),q);return ee?this._send(ee):null}_send(B){return(0,o.encodeSemanticTokensDto)({id:0,type:"full",data:B.data})}}class xe{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,x,q,W,ee){this._documents=B,this._commands=x,this._provider=q,this._apiDeprecation=W,this._extension=ee,this._cache=new t.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(B,x,q,W){const ee=this._documents.getDocument(B),se=i.Position.to(x),Oe=ee.getWordRangeAtPosition(se)||new a.Range(se,se),ze=Oe.with({end:se}),Ge=new y.StopWatch,Je=await this._provider.provideCompletionItems(ee,se,W,i.CompletionContext.to(q));if(!Je||W.isCancellationRequested)return;const et=Array.isArray(Je)?new a.CompletionList(Je):Je,ot=xe.supportsResolving(this._provider)?this._cache.add(et.items):this._cache.add([]),it=new m.DisposableStore;this._disposables.set(ot,it);const nt=[],at={x:ot,b:nt,a:{replace:i.Range.from(Oe),insert:i.Range.from(ze)},c:et.isIncomplete||void 0,d:Ge.elapsed()};for(let ft=0;ft<et.items.length;ft++){const Be=et.items[ft],st=this._convertCompletionItem(Be,[ot,ft],ze,Oe);nt.push(st)}return at}async resolveCompletionItem(B,x){if(typeof this._provider.resolveCompletionItem!="function")return;const q=this._cache.get(...B);if(!q)return;const W=this._convertCompletionItem(q,B),ee=await this._provider.resolveCompletionItem(q,x);if(!ee)return;const se=this._convertCompletionItem(ee,B);return(W.h!==se.h||W.i!==se.i)&&this._apiDeprecation.report("CompletionItem.insertText",this._extension,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(W.n!==se.n||W.o!==se.o||!(0,h.equals)(W.p,se.p))&&this._apiDeprecation.report("CompletionItem.command",this._extension,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...W,d:se.d,c:se.c,l:se.l,h:se.h,i:se.i,n:se.n,o:se.o,p:se.p}}releaseCompletionItems(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_convertCompletionItem(B,x,q,W){const ee=this._disposables.get(x[0]);if(!ee)throw Error("DisposableStore is missing...");const se=this._commands.toInternal(B.command,ee),Oe={x,a:B.label,b:B.kind!==void 0?i.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(i.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:i.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(i.TextEdit.from),n:se?.$ident,o:se?.id,p:se?.$ident?void 0:se?.arguments};B.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=B.textEdit.newText):typeof B.insertText=="string"?Oe.h=B.insertText:B.insertText instanceof a.SnippetString&&(Oe.h=B.insertText.value,Oe.i|=4);let ze;return B.textEdit?ze=B.textEdit.range:B.range&&(ze=B.range),a.Range.isRange(ze)?Oe.j=i.Range.from(ze):ze&&(!q?.isEqual(ze.inserting)||!W?.isEqual(ze.replacing))&&(Oe.j={insert:i.Range.from(ze.inserting),replace:i.Range.from(ze.replacing)}),Oe}}class re{async provideInlineCompletions(B,x,q,W){}disposeCompletions(B){}handleDidShowCompletionItem(B,x,q){}handlePartialAccept(B,x,q,W){}}class F extends re{constructor(B,x,q,W){super(),this._extension=B,this._documents=x,this._provider=q,this._commands=W,this._references=new be,this._isAdditionsProposedApiEnabled=(0,d.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[r.InlineCompletionTriggerKind.Automatic]:a.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:a.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,d.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&(typeof this._provider.handleDidShowCompletionItem=="function"||typeof this._provider.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,x,q,W){const ee=this._documents.getDocument(B),se=i.Position.to(x),Oe=await this._provider.provideInlineCompletionItems(ee,se,{selectedCompletionInfo:q.selectedSuggestionInfo?{range:i.Range.to(q.selectedSuggestionInfo.range),text:q.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[q.triggerKind]},W);if(!Oe||W.isCancellationRequested)return;const ze=Array.isArray(Oe)?Oe:Oe.items,Ge=this._isAdditionsProposedApiEnabled?Array.isArray(Oe)?[]:Oe.commands||[]:[],Je=this._isAdditionsProposedApiEnabled&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let et;return{pid:this._references.createReferenceId({dispose(){et?.dispose()},items:ze}),items:ze.map((it,nt)=>{let at;it.command&&(et||(et=new m.DisposableStore),at=this._commands.toInternal(it.command,et));const ft=it.insertText;return{insertText:typeof ft=="string"?ft:{snippet:ft.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:at,idx:nt,completeBracketPairs:this._isAdditionsProposedApiEnabled?it.completeBracketPairs:!1}}),commands:Ge.map(it=>(et||(et=new m.DisposableStore),this._commands.toInternal(it,et))),suppressSuggestions:!1,enableForwardStability:Je}}disposeCompletions(B){this._references.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,x,q){const W=this._references.get(B)?.items[x];W&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(W,q)}handlePartialAccept(B,x,q,W){const ee=this._references.get(B)?.items[x];ee&&this._provider.handleDidPartiallyAcceptCompletionItem&&this._isAdditionsProposedApiEnabled&&(this._provider.handleDidPartiallyAcceptCompletionItem(ee,q),this._provider.handleDidPartiallyAcceptCompletionItem(ee,i.PartialAcceptInfo.to(W)))}}class Z{async provideInlineEdits(B,x,q){const W=this._documents.getDocument(B),ee=await this._provider.provideInlineEdit(W,{triggerKind:this.languageTriggerKindToVSCodeTriggerKind[x.triggerKind]},q);if(!ee||q.isCancellationRequested)return;let se;const Oe=this._references.createReferenceId({dispose(){se?.dispose()},item:ee});let ze;ee.accepted&&(se||(se=new m.DisposableStore),ze=this._commands.toInternal(ee.accepted,se));let Ge;return ee.rejected&&(se||(se=new m.DisposableStore),Ge=this._commands.toInternal(ee.rejected,se)),{pid:Oe,text:ee.text,range:i.Range.from(ee.range),accepted:ze,rejected:Ge}}disposeEdit(B){this._references.disposeReferenceId(B)?.dispose()}constructor(B,x,q,W){this._documents=x,this._provider=q,this._commands=W,this._references=new be,this.languageTriggerKindToVSCodeTriggerKind={[r.InlineEditTriggerKind.Automatic]:a.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:a.InlineEditTriggerKind.Invoke}}}class be{constructor(){this._references=new Map,this._idPool=1}createReferenceId(B){const x=this._idPool++;return this._references.set(x,B),x}disposeReferenceId(B){const x=this._references.get(B);return this._references.delete(B),x}get(B){return this._references.get(B)}}class Le{constructor(B,x){this._documents=B,this._provider=x,this._cache=new t.Cache("SignatureHelp")}async provideSignatureHelp(B,x,q,W){const ee=this._documents.getDocument(B),se=i.Position.to(x),Oe=this.reviveContext(q),ze=await this._provider.provideSignatureHelp(ee,se,W,Oe);if(ze){const Ge=this._cache.add([ze]);return{...i.SignatureHelp.from(ze),id:Ge}}}reviveContext(B){let x;if(B.activeSignatureHelp){const q=i.SignatureHelp.to(B.activeSignatureHelp),W=this._cache.get(B.activeSignatureHelp.id,0);W?(x=W,x.activeSignature=q.activeSignature,x.activeParameter=q.activeParameter):x=q}return{...B,activeSignatureHelp:x}}releaseSignatureHelp(B){this._cache.delete(B)}}class Se{constructor(B,x,q,W,ee){this._documents=B,this._commands=x,this._provider=q,this._logService=W,this._extension=ee,this._cache=new t.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(B,x,q){const W=this._documents.getDocument(B),ee=i.Range.to(x),se=await this._provider.provideInlayHints(W,ee,q);if(!Array.isArray(se)||se.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(x)}`);return}if(q.isCancellationRequested)return;const Oe=this._cache.add(se);this._disposables.set(Oe,new m.DisposableStore);const ze={hints:[],cacheId:Oe};for(let Ge=0;Ge<se.length;Ge++)this._isValidInlayHint(se[Ge],ee)&&ze.hints.push(this._convertInlayHint(se[Ge],[Oe,Ge]));return this._logService.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this._extension.identifier.value}' for range ${JSON.stringify(x)}`),ze}async resolveInlayHint(B,x){if(typeof this._provider.resolveInlayHint!="function")return;const q=this._cache.get(...B);if(!q)return;const W=await this._provider.resolveInlayHint(q,x);if(W&&this._isValidInlayHint(W))return this._convertInlayHint(W,B)}releaseHints(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_isValidInlayHint(B,x){return B.label.length===0||Array.isArray(B.label)&&B.label.every(q=>q.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(x&&!x.contains(B.position))}_convertInlayHint(B,x){const q=this._disposables.get(x[0]);if(!q)throw Error("DisposableStore is missing...");const W={label:"",cacheId:x,tooltip:i.MarkdownString.fromStrict(B.tooltip),position:i.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(i.TextEdit.from),kind:B.kind&&i.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")W.label=B.label;else{const ee=[];W.label=ee;for(const se of B.label){if(!se.value){console.warn("INVALID inlay hint, empty label part",this._extension.identifier.value);continue}const Oe={label:se.value,tooltip:i.MarkdownString.fromStrict(se.tooltip)};a.Location.isLocation(se.location)&&(Oe.location=i.location.from(se.location)),se.command&&(Oe.command=this._commands.toInternal(se.command,q)),ee.push(Oe)}}return W}}class ve{constructor(B,x){this._documents=B,this._provider=x,this._cache=new t.Cache("DocumentLink")}async provideLinks(B,x){const q=this._documents.getDocument(B),W=await this._provider.provideDocumentLinks(q,x);if(!(!Array.isArray(W)||W.length===0)&&!x.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:W.filter(ve._validateLink).map(i.DocumentLink.from)};{const ee=this._cache.add(W),se={links:[],cacheId:ee};for(let Oe=0;Oe<W.length;Oe++){if(!ve._validateLink(W[Oe]))continue;const ze=i.DocumentLink.from(W[Oe]);ze.cacheId=[ee,Oe],se.links.push(ze)}return se}}}static _validateLink(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,x){if(typeof this._provider.resolveDocumentLink!="function")return;const q=this._cache.get(...B);if(!q)return;const W=await this._provider.resolveDocumentLink(q,x);if(!(!W||!ve._validateLink(W)))return i.DocumentLink.from(W)}releaseLinks(B){this._cache.delete(B)}}class he{constructor(B,x){this._documents=B,this._provider=x}async provideColors(B,x){const q=this._documents.getDocument(B),W=await this._provider.provideDocumentColors(q,x);return Array.isArray(W)?W.map(se=>({color:i.Color.from(se.color),range:i.Range.from(se.range)})):[]}async provideColorPresentations(B,x,q){const W=this._documents.getDocument(B),ee=i.Range.to(x.range),se=i.Color.to(x.color),Oe=await this._provider.provideColorPresentations(se,{document:W,range:ee},q);if(Array.isArray(Oe))return Oe.map(i.ColorPresentation.from)}}class K{constructor(B,x){this._documents=B,this._provider=x}async provideFoldingRanges(B,x,q){const W=this._documents.getDocument(B),ee=await this._provider.provideFoldingRanges(W,x,q);if(Array.isArray(ee))return ee.map(i.FoldingRange.from)}}class Y{constructor(B,x,q){this._documents=B,this._provider=x,this._logService=q}async provideSelectionRanges(B,x,q){const W=this._documents.getDocument(B),ee=x.map(i.Position.to),se=await this._provider.provideSelectionRanges(W,ee,q);if(!(0,D.isNonEmptyArray)(se))return[];if(se.length!==ee.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let ze=0;ze<ee.length;ze++){const Ge=[];Oe.push(Ge);let Je=ee[ze],et=se[ze];for(;;){if(!et.range.contains(Je))throw new Error("INVALID selection range, must contain the previous range");if(Ge.push(i.SelectionRange.from(et)),!et.parent)break;Je=et.range,et=et.parent}}return Oe}}class le{constructor(B,x){this._documents=B,this._provider=x,this._idPool=new R.IdGenerator(""),this._cache=new Map}async prepareSession(B,x,q){const W=this._documents.getDocument(B),ee=i.Position.to(x),se=await this._provider.prepareCallHierarchy(W,ee,q);if(!se)return;const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(se)?se.map(ze=>this._cacheAndConvertItem(Oe,ze)):[this._cacheAndConvertItem(Oe,se)]}async provideCallsTo(B,x,q){const W=this._itemFromCache(B,x);if(!W)throw new Error("missing call hierarchy item");const ee=await this._provider.provideCallHierarchyIncomingCalls(W,q);if(ee)return ee.map(se=>({from:this._cacheAndConvertItem(B,se.from),fromRanges:se.fromRanges.map(Oe=>i.Range.from(Oe))}))}async provideCallsFrom(B,x,q){const W=this._itemFromCache(B,x);if(!W)throw new Error("missing call hierarchy item");const ee=await this._provider.provideCallHierarchyOutgoingCalls(W,q);if(ee)return ee.map(se=>({to:this._cacheAndConvertItem(B,se.to),fromRanges:se.fromRanges.map(Oe=>i.Range.from(Oe))}))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,x){const q=this._cache.get(B),W=i.CallHierarchyItem.from(x,B,q.size.toString(36));return q.set(W._itemId,x),W}_itemFromCache(B,x){return this._cache.get(B)?.get(x)}}class de{constructor(B,x){this._documents=B,this._provider=x,this._idPool=new R.IdGenerator(""),this._cache=new Map}async prepareSession(B,x,q){const W=this._documents.getDocument(B),ee=i.Position.to(x),se=await this._provider.prepareTypeHierarchy(W,ee,q);if(!se)return;const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(se)?se.map(ze=>this._cacheAndConvertItem(Oe,ze)):[this._cacheAndConvertItem(Oe,se)]}async provideSupertypes(B,x,q){const W=this._itemFromCache(B,x);if(!W)throw new Error("missing type hierarchy item");const ee=await this._provider.provideTypeHierarchySupertypes(W,q);if(ee)return ee.map(se=>this._cacheAndConvertItem(B,se))}async provideSubtypes(B,x,q){const W=this._itemFromCache(B,x);if(!W)throw new Error("missing type hierarchy item");const ee=await this._provider.provideTypeHierarchySubtypes(W,q);if(ee)return ee.map(se=>this._cacheAndConvertItem(B,se))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,x){const q=this._cache.get(B),W=i.TypeHierarchyItem.from(x,B,q.size.toString(36));return q.set(W._itemId,x),W}_itemFromCache(B,x){return this._cache.get(B)?.get(x)}}class Ne{constructor(B,x,q,W,ee){this._proxy=B,this._documents=x,this._provider=q,this._handle=W,this._extension=ee}async provideDocumentOnDropEdits(B,x,q,W,ee){const se=this._documents.getDocument(x),Oe=i.Position.to(q),ze=i.DataTransfer.toDataTransfer(W,async Je=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,B,Je)).buffer),Ge=await this._provider.provideDocumentDropEdits(se,Oe,ze,ee);if(Ge)return(0,D.asArray)(Ge).map(Je=>({title:Je.title??(0,s.localize)(1,null,this._extension.displayName||this._extension.name),kind:Je.kind?.value,yieldTo:Je.yieldTo?.map(et=>et.value),insertText:typeof Je.insertText=="string"?Je.insertText:{snippet:Je.insertText.value},additionalEdit:Je.additionalEdit?i.WorkspaceEdit.from(Je.additionalEdit,void 0):void 0}))}}class ue{constructor(B,x){this._documents=B,this._provider=x}async provideMappedEdits(B,x,q,W){const ee=l.URI.revive(B),se=this._documents.getDocument(ee),Oe=q.documents.map(Je=>Je.map(et=>({uri:l.URI.revive(et.uri),version:et.version,ranges:et.ranges.map(ot=>i.Range.to(ot))}))),ze={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},Ge=await this._provider.provideMappedEdits(se,x,ze,W);return Ge?i.WorkspaceEdit.from(Ge):null}}class De{constructor(B,x){this.adapter=B,this.extension=x}}class Re{static{this._handlePool=0}constructor(B,x,q,W,ee,se,Oe,ze){this._uriTransformer=x,this._documents=q,this._commands=W,this._diagnostics=ee,this._logService=se,this._apiDeprecation=Oe,this._extensionTelemetry=ze,this._adapter=new Map,this._proxy=B.getProxy(E.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(B,x){return i.DocumentSelector.from(B,this._uriTransformer,x)}_createDisposable(B){return new a.Disposable(()=>{this._adapter.delete(B),this._proxy.$unregister(B)})}_nextHandle(){return Re._handlePool++}async _withAdapter(B,x,q,W,ee,se=!1){const Oe=this._adapter.get(B);if(!Oe||!(Oe.adapter instanceof x))return W;const ze=Date.now();se||this._logService.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${q.toString().replace(/[\r\n]/g,"")}'`);const Ge=q(Oe.adapter,Oe.extension);return Promise.resolve(Ge).catch(Je=>{(0,N.isCancellationError)(Je)||(this._logService.error(`[${Oe.extension.identifier.value}] provider FAILED`),this._logService.error(Je),this._extensionTelemetry.onExtensionError(Oe.extension.identifier,Je))}).finally(()=>{se||this._logService.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),T.CancellationToken.isCancellationToken(ee)?(0,O.raceCancellationError)(Ge,ee):Ge}_addNewAdapter(B,x){const q=this._nextHandle();return this._adapter.set(q,new De(B,x)),q}static _extLabel(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,x,q,W){const ee=this._addNewAdapter(new c(this._documents,q),B),se=W&&W.label||Re._extLabel(B);return this._proxy.$registerDocumentSymbolProvider(ee,this._transformDocumentSelector(x,B),se),this._createDisposable(ee)}$provideDocumentSymbols(B,x,q){return this._withAdapter(B,c,W=>W.provideDocumentSymbols(l.URI.revive(x),q),void 0,q)}registerCodeLensProvider(B,x,q){const W=this._nextHandle(),ee=typeof q.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(W,new De(new p(this._documents,this._commands.converter,q,B,this._extensionTelemetry,this._logService),B)),this._proxy.$registerCodeLensSupport(W,this._transformDocumentSelector(x,B),ee);let se=this._createDisposable(W);if(ee!==void 0){const Oe=q.onDidChangeCodeLenses(ze=>this._proxy.$emitCodeLensEvent(ee));se=a.Disposable.from(se,Oe)}return se}$provideCodeLenses(B,x,q){return this._withAdapter(B,p,W=>W.provideCodeLenses(l.URI.revive(x),q),void 0,q)}$resolveCodeLens(B,x,q){return this._withAdapter(B,p,W=>W.resolveCodeLens(x,q),void 0,void 0)}$releaseCodeLenses(B,x){this._withAdapter(B,p,q=>Promise.resolve(q.releaseCodeLenses(x)),void 0,void 0)}registerDefinitionProvider(B,x,q){const W=this._addNewAdapter(new v(this._documents,q),B);return this._proxy.$registerDefinitionSupport(W,this._transformDocumentSelector(x,B)),this._createDisposable(W)}$provideDefinition(B,x,q,W){return this._withAdapter(B,v,ee=>ee.provideDefinition(l.URI.revive(x),q,W),[],W)}registerDeclarationProvider(B,x,q){const W=this._addNewAdapter(new u(this._documents,q),B);return this._proxy.$registerDeclarationSupport(W,this._transformDocumentSelector(x,B)),this._createDisposable(W)}$provideDeclaration(B,x,q,W){return this._withAdapter(B,u,ee=>ee.provideDeclaration(l.URI.revive(x),q,W),[],W)}registerImplementationProvider(B,x,q){const W=this._addNewAdapter(new C(this._documents,q),B);return this._proxy.$registerImplementationSupport(W,this._transformDocumentSelector(x,B)),this._createDisposable(W)}$provideImplementation(B,x,q,W){return this._withAdapter(B,C,ee=>ee.provideImplementation(l.URI.revive(x),q,W),[],W)}registerTypeDefinitionProvider(B,x,q){const W=this._addNewAdapter(new f(this._documents,q),B);return this._proxy.$registerTypeDefinitionSupport(W,this._transformDocumentSelector(x,B)),this._createDisposable(W)}$provideTypeDefinition(B,x,q,W){return this._withAdapter(B,f,ee=>ee.provideTypeDefinition(l.URI.revive(x),q,W),[],W)}registerHoverProvider(B,x,q,W){const ee=this._addNewAdapter(new I(this._documents,q),B);return this._proxy.$registerHoverProvider(ee,this._transformDocumentSelector(x,B)),this._createDisposable(ee)}$provideHover(B,x,q,W){return this._withAdapter(B,I,ee=>ee.provideHover(l.URI.revive(x),q,W),void 0,W)}registerEvaluatableExpressionProvider(B,x,q,W){const ee=this._addNewAdapter(new S(this._documents,q),B);return this._proxy.$registerEvaluatableExpressionProvider(ee,this._transformDocumentSelector(x,B)),this._createDisposable(ee)}$provideEvaluatableExpression(B,x,q,W){return this._withAdapter(B,S,ee=>ee.provideEvaluatableExpression(l.URI.revive(x),q,W),void 0,W)}registerInlineValuesProvider(B,x,q,W){const ee=typeof q.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new P(this._documents,q),B);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(x,B),ee);let Oe=this._createDisposable(se);if(ee!==void 0){const ze=q.onDidChangeInlineValues(Ge=>this._proxy.$emitInlineValuesEvent(ee));Oe=a.Disposable.from(Oe,ze)}return Oe}$provideInlineValues(B,x,q,W,ee){return this._withAdapter(B,P,se=>se.provideInlineValues(l.URI.revive(x),q,W,ee),void 0,ee)}registerDocumentHighlightProvider(B,x,q){const W=this._addNewAdapter(new k(this._documents,q),B);return this._proxy.$registerDocumentHighlightProvider(W,this._transformDocumentSelector(x,B)),this._createDisposable(W)}registerMultiDocumentHighlightProvider(B,x,q){const W=this._addNewAdapter(new H(this._documents,q),B);return this._proxy.$registerMultiDocumentHighlightProvider(W,this._transformDocumentSelector(x,B)),this._createDisposable(W)}$provideDocumentHighlights(B,x,q,W){return this._withAdapter(B,k,ee=>ee.provideDocumentHighlights(l.URI.revive(x),q,W),void 0,W)}$provideMultiDocumentHighlights(B,x,q,W,ee){return this._withAdapter(B,H,se=>se.provideMultiDocumentHighlights(l.URI.revive(x),q,W.map(Oe=>l.URI.revive(Oe)),ee),void 0,ee)}registerLinkedEditingRangeProvider(B,x,q){const W=this._addNewAdapter(new $(this._documents,q),B);return this._proxy.$registerLinkedEditingRangeProvider(W,this._transformDocumentSelector(x,B)),this._createDisposable(W)}$provideLinkedEditingRanges(B,x,q,W){return this._withAdapter(B,$,async ee=>{const se=await ee.provideLinkedEditingRanges(l.URI.revive(x),q,W);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Re._serializeRegExp(se.wordPattern):void 0}},void 0,W)}registerReferenceProvider(B,x,q){const W=this._addNewAdapter(new V(this._documents,q),B);return this._proxy.$registerReferenceSupport(W,this._transformDocumentSelector(x,B)),this._createDisposable(W)}$provideReferences(B,x,q,W,ee){return this._withAdapter(B,V,se=>se.provideReferences(l.URI.revive(x),q,W,ee),void 0,ee)}registerCodeActionProvider(B,x,q,W){const ee=new m.DisposableStore,se=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,q,this._logService,B,this._apiDeprecation),B);return this._proxy.$registerQuickFixSupport(se,this._transformDocumentSelector(x,B),{providedKinds:W?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:W?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this._commands.converter.toInternal(Oe.command,ee)}))},Re._extLabel(B),!!q.resolveCodeAction),ee.add(this._createDisposable(se)),ee}$provideCodeActions(B,x,q,W,ee){return this._withAdapter(B,A,se=>se.provideCodeActions(l.URI.revive(x),q,W,ee),void 0,ee)}$resolveCodeAction(B,x,q){return this._withAdapter(B,A,W=>W.resolveCodeAction(x,q),{},void 0)}$releaseCodeActions(B,x){this._withAdapter(B,A,q=>Promise.resolve(q.releaseCodeActions(x)),void 0,void 0)}registerDocumentFormattingEditProvider(B,x,q){const W=this._addNewAdapter(new j(this._documents,q),B);return this._proxy.$registerDocumentFormattingSupport(W,this._transformDocumentSelector(x,B),B.identifier,B.displayName||B.name),this._createDisposable(W)}$provideDocumentFormattingEdits(B,x,q,W){return this._withAdapter(B,j,ee=>ee.provideDocumentFormattingEdits(l.URI.revive(x),q,W),void 0,W)}registerDocumentRangeFormattingEditProvider(B,x,q){const W=typeof q.provideDocumentRangesFormattingEdits=="function",ee=this._addNewAdapter(new ie(this._documents,q),B);return this._proxy.$registerRangeFormattingSupport(ee,this._transformDocumentSelector(x,B),B.identifier,B.displayName||B.name,W),this._createDisposable(ee)}$provideDocumentRangeFormattingEdits(B,x,q,W,ee){return this._withAdapter(B,ie,se=>se.provideDocumentRangeFormattingEdits(l.URI.revive(x),q,W,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(B,x,q,W,ee){return this._withAdapter(B,ie,se=>se.provideDocumentRangesFormattingEdits(l.URI.revive(x),q,W,ee),void 0,ee)}registerOnTypeFormattingEditProvider(B,x,q,W){const ee=this._addNewAdapter(new fe(this._documents,q),B);return this._proxy.$registerOnTypeFormattingSupport(ee,this._transformDocumentSelector(x,B),W,B.identifier),this._createDisposable(ee)}$provideOnTypeFormattingEdits(B,x,q,W,ee,se){return this._withAdapter(B,fe,Oe=>Oe.provideOnTypeFormattingEdits(l.URI.revive(x),q,W,ee,se),void 0,se)}registerWorkspaceSymbolProvider(B,x){const q=this._addNewAdapter(new Ce(x,this._logService),B);return this._proxy.$registerNavigateTypeSupport(q,typeof x.resolveWorkspaceSymbol=="function"),this._createDisposable(q)}$provideWorkspaceSymbols(B,x,q){return this._withAdapter(B,Ce,W=>W.provideWorkspaceSymbols(x,q),{symbols:[]},q)}$resolveWorkspaceSymbol(B,x,q){return this._withAdapter(B,Ce,W=>W.resolveWorkspaceSymbol(x,q),void 0,void 0)}$releaseWorkspaceSymbols(B,x){this._withAdapter(B,Ce,q=>q.releaseWorkspaceSymbols(x),void 0,void 0)}registerRenameProvider(B,x,q){const W=this._addNewAdapter(new _e(this._documents,q,this._logService),B);return this._proxy.$registerRenameSupport(W,this._transformDocumentSelector(x,B),_e.supportsResolving(q)),this._createDisposable(W)}$provideRenameEdits(B,x,q,W,ee){return this._withAdapter(B,_e,se=>se.provideRenameEdits(l.URI.revive(x),q,W,ee),void 0,ee)}$resolveRenameLocation(B,x,q,W){return this._withAdapter(B,_e,ee=>ee.resolveRenameLocation(l.URI.revive(x),q,W),void 0,W)}registerNewSymbolNamesProvider(B,x,q){const W=this._addNewAdapter(new oe(this._documents,q,this._logService),B);return this._proxy.$registerNewSymbolNamesProvider(W,this._transformDocumentSelector(x,B)),this._createDisposable(W)}$provideNewSymbolNames(B,x,q,W){return this._withAdapter(B,oe,ee=>ee.provideNewSymbolNames(l.URI.revive(x),q,W),void 0,W)}registerDocumentSemanticTokensProvider(B,x,q,W){const ee=this._addNewAdapter(new ne(this._documents,q),B),se=typeof q.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ee,this._transformDocumentSelector(x,B),W,se);let Oe=this._createDisposable(ee);if(se){const ze=q.onDidChangeSemanticTokens(Ge=>this._proxy.$emitDocumentSemanticTokensEvent(se));Oe=a.Disposable.from(Oe,ze)}return Oe}$provideDocumentSemanticTokens(B,x,q,W){return this._withAdapter(B,ne,ee=>ee.provideDocumentSemanticTokens(l.URI.revive(x),q,W),null,W)}$releaseDocumentSemanticTokens(B,x){this._withAdapter(B,ne,q=>q.releaseDocumentSemanticColoring(x),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,x,q,W){const ee=this._addNewAdapter(new Ie(this._documents,q),B);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ee,this._transformDocumentSelector(x,B),W),this._createDisposable(ee)}$provideDocumentRangeSemanticTokens(B,x,q,W){return this._withAdapter(B,Ie,ee=>ee.provideDocumentRangeSemanticTokens(l.URI.revive(x),q,W),null,W)}registerCompletionItemProvider(B,x,q,W){const ee=this._addNewAdapter(new xe(this._documents,this._commands.converter,q,this._apiDeprecation,B),B);return this._proxy.$registerCompletionsProvider(ee,this._transformDocumentSelector(x,B),W,xe.supportsResolving(q),B.identifier),this._createDisposable(ee)}$provideCompletionItems(B,x,q,W,ee){return this._withAdapter(B,xe,se=>se.provideCompletionItems(l.URI.revive(x),q,W,ee),void 0,ee)}$resolveCompletionItem(B,x,q){return this._withAdapter(B,xe,W=>W.resolveCompletionItem(x,q),void 0,q)}$releaseCompletionItems(B,x){this._withAdapter(B,xe,q=>q.releaseCompletionItems(x),void 0,void 0)}registerInlineCompletionsProvider(B,x,q,W){const ee=new F(B,this._documents,q,this._commands.converter),se=this._addNewAdapter(ee,B);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(x,B),ee.supportsHandleEvents,n.ExtensionIdentifier.toKey(B.identifier.value),W?.yieldTo?.map(Oe=>n.ExtensionIdentifier.toKey(Oe))||[]),this._createDisposable(se)}$provideInlineCompletions(B,x,q,W,ee){return this._withAdapter(B,re,se=>se.provideInlineCompletions(l.URI.revive(x),q,W,ee),void 0,ee)}$handleInlineCompletionDidShow(B,x,q,W){this._withAdapter(B,re,async ee=>{ee.handleDidShowCompletionItem(x,q,W)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,x,q,W,ee){this._withAdapter(B,re,async se=>{se.handlePartialAccept(x,q,W,ee)},void 0,void 0)}$freeInlineCompletionsList(B,x){this._withAdapter(B,re,async q=>{q.disposeCompletions(x)},void 0,void 0)}registerInlineEditProvider(B,x,q){const W=new Z(B,this._documents,q,this._commands.converter),ee=this._addNewAdapter(W,B);return this._proxy.$registerInlineEditProvider(ee,this._transformDocumentSelector(x,B),B.identifier),this._createDisposable(ee)}$provideInlineEdit(B,x,q,W){return this._withAdapter(B,Z,ee=>ee.provideInlineEdits(l.URI.revive(x),q,W),void 0,W)}$freeInlineEdit(B,x){this._withAdapter(B,Z,async q=>{q.disposeEdit(x)},void 0,void 0)}registerSignatureHelpProvider(B,x,q,W){const ee=Array.isArray(W)?{triggerCharacters:W,retriggerCharacters:[]}:W,se=this._addNewAdapter(new Le(this._documents,q),B);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(x,B),ee),this._createDisposable(se)}$provideSignatureHelp(B,x,q,W,ee){return this._withAdapter(B,Le,se=>se.provideSignatureHelp(l.URI.revive(x),q,W,ee),void 0,ee)}$releaseSignatureHelp(B,x){this._withAdapter(B,Le,q=>q.releaseSignatureHelp(x),void 0,void 0)}registerInlayHintsProvider(B,x,q){const W=typeof q.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ee=this._addNewAdapter(new Se(this._documents,this._commands.converter,q,this._logService,B),B);this._proxy.$registerInlayHintsProvider(ee,this._transformDocumentSelector(x,B),typeof q.resolveInlayHint=="function",W,Re._extLabel(B));let se=this._createDisposable(ee);if(W!==void 0){const Oe=q.onDidChangeInlayHints(ze=>this._proxy.$emitInlayHintsEvent(W));se=a.Disposable.from(se,Oe)}return se}$provideInlayHints(B,x,q,W){return this._withAdapter(B,Se,ee=>ee.provideInlayHints(l.URI.revive(x),q,W),void 0,W)}$resolveInlayHint(B,x,q){return this._withAdapter(B,Se,W=>W.resolveInlayHint(x,q),void 0,q)}$releaseInlayHints(B,x){this._withAdapter(B,Se,q=>q.releaseHints(x),void 0,void 0)}registerDocumentLinkProvider(B,x,q){const W=this._addNewAdapter(new ve(this._documents,q),B);return this._proxy.$registerDocumentLinkProvider(W,this._transformDocumentSelector(x,B),typeof q.resolveDocumentLink=="function"),this._createDisposable(W)}$provideDocumentLinks(B,x,q){return this._withAdapter(B,ve,W=>W.provideLinks(l.URI.revive(x),q),void 0,q,x.scheme==="output")}$resolveDocumentLink(B,x,q){return this._withAdapter(B,ve,W=>W.resolveLink(x,q),void 0,void 0,!0)}$releaseDocumentLinks(B,x){this._withAdapter(B,ve,q=>q.releaseLinks(x),void 0,void 0,!0)}registerColorProvider(B,x,q){const W=this._addNewAdapter(new he(this._documents,q),B);return this._proxy.$registerDocumentColorProvider(W,this._transformDocumentSelector(x,B)),this._createDisposable(W)}$provideDocumentColors(B,x,q){return this._withAdapter(B,he,W=>W.provideColors(l.URI.revive(x),q),[],q)}$provideColorPresentations(B,x,q,W){return this._withAdapter(B,he,ee=>ee.provideColorPresentations(l.URI.revive(x),q,W),void 0,W)}registerFoldingRangeProvider(B,x,q){const W=this._nextHandle(),ee=typeof q.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(W,new De(new K(this._documents,q),B)),this._proxy.$registerFoldingRangeProvider(W,this._transformDocumentSelector(x,B),B.identifier,ee);let se=this._createDisposable(W);if(ee!==void 0){const Oe=q.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ee));se=a.Disposable.from(se,Oe)}return se}$provideFoldingRanges(B,x,q,W){return this._withAdapter(B,K,ee=>ee.provideFoldingRanges(l.URI.revive(x),q,W),void 0,W)}registerSelectionRangeProvider(B,x,q){const W=this._addNewAdapter(new Y(this._documents,q,this._logService),B);return this._proxy.$registerSelectionRangeProvider(W,this._transformDocumentSelector(x,B)),this._createDisposable(W)}$provideSelectionRanges(B,x,q,W){return this._withAdapter(B,Y,ee=>ee.provideSelectionRanges(l.URI.revive(x),q,W),[],W)}registerCallHierarchyProvider(B,x,q){const W=this._addNewAdapter(new le(this._documents,q),B);return this._proxy.$registerCallHierarchyProvider(W,this._transformDocumentSelector(x,B)),this._createDisposable(W)}$prepareCallHierarchy(B,x,q,W){return this._withAdapter(B,le,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(x),q,W)),void 0,W)}$provideCallHierarchyIncomingCalls(B,x,q,W){return this._withAdapter(B,le,ee=>ee.provideCallsTo(x,q,W),void 0,W)}$provideCallHierarchyOutgoingCalls(B,x,q,W){return this._withAdapter(B,le,ee=>ee.provideCallsFrom(x,q,W),void 0,W)}$releaseCallHierarchy(B,x){this._withAdapter(B,le,q=>Promise.resolve(q.releaseSession(x)),void 0,void 0)}registerTypeHierarchyProvider(B,x,q){const W=this._addNewAdapter(new de(this._documents,q),B);return this._proxy.$registerTypeHierarchyProvider(W,this._transformDocumentSelector(x,B)),this._createDisposable(W)}$prepareTypeHierarchy(B,x,q,W){return this._withAdapter(B,de,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(x),q,W)),void 0,W)}$provideTypeHierarchySupertypes(B,x,q,W){return this._withAdapter(B,de,ee=>ee.provideSupertypes(x,q,W),void 0,W)}$provideTypeHierarchySubtypes(B,x,q,W){return this._withAdapter(B,de,ee=>ee.provideSubtypes(x,q,W),void 0,W)}$releaseTypeHierarchy(B,x){this._withAdapter(B,de,q=>Promise.resolve(q.releaseSession(x)),void 0,void 0)}registerDocumentOnDropEditProvider(B,x,q,W){const ee=this._nextHandle();return this._adapter.set(ee,new De(new Ne(this._proxy,this._documents,q,ee,B),B)),this._proxy.$registerDocumentOnDropEditProvider(ee,this._transformDocumentSelector(x,B),(0,d.isProposedApiEnabled)(B,"dropMetadata")?W:void 0),this._createDisposable(ee)}$provideDocumentOnDropEdits(B,x,q,W,ee,se){return this._withAdapter(B,Ne,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(x,l.URI.revive(q),W,ee,se)),void 0,void 0)}registerMappedEditsProvider(B,x,q){const W=this._addNewAdapter(new ue(this._documents,q),B);return this._proxy.$registerMappedEditsProvider(W,this._transformDocumentSelector(x,B)),this._createDisposable(W)}$provideMappedEdits(B,x,q,W,ee){return this._withAdapter(B,ue,se=>Promise.resolve(se.provideMappedEdits(x,q,W,ee)),null,ee)}registerDocumentPasteEditProvider(B,x,q,W){const ee=this._nextHandle();return this._adapter.set(ee,new De(new U(this._proxy,this._documents,q,ee,B),B)),this._proxy.$registerPasteEditProvider(ee,this._transformDocumentSelector(x,B),{supportsCopy:!!q.prepareDocumentPaste,supportsPaste:!!q.provideDocumentPasteEdits,supportsResolve:!!q.resolveDocumentPasteEdit,providedPasteEditKinds:W.providedPasteEditKinds?.map(se=>se.value),copyMimeTypes:W.copyMimeTypes,pasteMimeTypes:W.pasteMimeTypes}),this._createDisposable(ee)}$prepareDocumentPaste(B,x,q,W,ee){return this._withAdapter(B,U,se=>se.prepareDocumentPaste(l.URI.revive(x),q,W,ee),void 0,ee)}$providePasteEdits(B,x,q,W,ee,se,Oe){return this._withAdapter(B,U,ze=>ze.providePasteEdits(x,l.URI.revive(q),W,ee,se,Oe),void 0,Oe)}$resolvePasteEdit(B,x,q){return this._withAdapter(B,U,W=>W.resolvePasteEdit(x,q),{},void 0)}$releasePasteEdits(B,x){this._withAdapter(B,U,q=>Promise.resolve(q.releasePasteEdits(x)),void 0,void 0)}static _serializeRegExp(B){return{pattern:B.source,flags:B.flags}}static _serializeIndentationRule(B){return{decreaseIndentPattern:Re._serializeRegExp(B.decreaseIndentPattern),increaseIndentPattern:Re._serializeRegExp(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?Re._serializeRegExp(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?Re._serializeRegExp(B.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(B){return{beforeText:Re._serializeRegExp(B.beforeText),afterText:B.afterText?Re._serializeRegExp(B.afterText):void 0,previousLineText:B.previousLineText?Re._serializeRegExp(B.previousLineText):void 0,action:B.action}}static _serializeOnEnterRules(B){return B.map(Re._serializeOnEnterRule)}static _serializeAutoClosingPair(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(x=>a.SyntaxTokenType.toString(x)):void 0}}static _serializeAutoClosingPairs(B){return B.map(Re._serializeAutoClosingPair)}setLanguageConfiguration(B,x,q){const{wordPattern:W}=q;if(W&&(0,L.regExpLeadsToEndlessLoop)(W))throw new Error(`Invalid language configuration: wordPattern '${W}' is not allowed to match the empty string.`);W?this._documents.setWordDefinitionFor(x,W):this._documents.setWordDefinitionFor(x,void 0),q.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),q.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const ee=this._nextHandle(),se={comments:q.comments,brackets:q.brackets,wordPattern:q.wordPattern?Re._serializeRegExp(q.wordPattern):void 0,indentationRules:q.indentationRules?Re._serializeIndentationRule(q.indentationRules):void 0,onEnterRules:q.onEnterRules?Re._serializeOnEnterRules(q.onEnterRules):void 0,__electricCharacterSupport:q.__electricCharacterSupport,__characterPairSupport:q.__characterPairSupport,autoClosingPairs:q.autoClosingPairs?Re._serializeAutoClosingPairs(q.autoClosingPairs):void 0};return this._proxy.$setLanguageConfiguration(ee,x,se),this._createDisposable(ee)}$setWordDefinitions(B){for(const x of B)this._documents.setWordDefinitionFor(x.languageId,new RegExp(x.regexSource,x.regexFlags))}}e.ExtHostLanguageFeatures=Re}),define(Pe[88],Te([1,0,6,4,8,7,101,20,11,5,167,106,14,3,16,84,13]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageModels=e.IExtHostLanguageModels=void 0,e.IExtHostLanguageModels=(0,w.createDecorator)("IExtHostLanguageModels");class n{constructor(t,E){this.option=t,this.stream=new h.AsyncIterableSource,this.stream=E??new h.AsyncIterableSource}}class i{constructor(){this._responseStreams=new Map,this._defaultStream=new h.AsyncIterableSource,this._isDone=!1,this._isStreaming=!1;const t=this;this.apiObject={stream:t._defaultStream.asyncIterable}}*_streams(){if(this._responseStreams.size>0)for(const[,t]of this._responseStreams)yield t.stream;else yield this._defaultStream}handleFragment(t){if(this._isDone)return;this._isStreaming=!0;let E=this._responseStreams.get(t.index);E||(this._responseStreams.size===0?E=new n(t.index,this._defaultStream):E=new n(t.index),this._responseStreams.set(t.index,E)),E.stream.emitOne(t.part)}get isStreaming(){return this._isStreaming}reject(t){this._isDone=!0;for(const E of this._streams())E.reject(t)}resolve(){this._isDone=!0;for(const t of this._streams())t.resolve()}}let a=class{static{s=this}static{this._idPool=1}constructor(t,E,c){this._logService=E,this._extHostAuthentication=c,this._onDidChangeModelAccess=new y.Emitter,this._onDidChangeProviders=new y.Emitter,this.onDidChangeProviders=this._onDidChangeProviders.event,this._languageModels=new Map,this._allLanguageModelData=new Map,this._modelAccessList=new m.ExtensionIdentifierMap,this._pendingRequest=new Map,this._languageAccessInformationExtensions=new Set,this._proxy=t.getProxy(O.MainContext.MainThreadLanguageModels)}dispose(){this._onDidChangeModelAccess.dispose(),this._onDidChangeProviders.dispose()}registerLanguageModel(t,E,c,p){const b=s._idPool++;this._languageModels.set(b,{extension:t.identifier,provider:c,languageModelId:E});let v;return p.auth&&(v={providerLabel:t.displayName||t.name,accountLabel:typeof p.auth=="object"?p.auth.label:void 0}),this._proxy.$registerLanguageModelProvider(b,E,{extension:t.identifier,identifier:E,model:p.name??"",auth:v}),(0,D.toDisposable)(()=>{this._languageModels.delete(b),this._proxy.$unregisterProvider(b)})}async $provideLanguageModelResponse(t,E,c,p,b,v){const u=this._languageModels.get(t);if(!u)return;const C=new R.Progress(async f=>{if(v.isCancellationRequested){this._logService.warn(`[CHAT](${u.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this._proxy.$handleProgressChunk(E,{index:f.index,part:f.part})});return u.provider.provideLanguageModelResponse2(p.map(T.LanguageModelMessage.to),b,m.ExtensionIdentifier.toKey(c),C,v)}$updateLanguageModels(t){const E=[],c=[];if(t.added)for(const p of t.added)this._allLanguageModelData.set(p.identifier,p),E.push(p.model);if(t.removed)for(const p of t.removed){this._allLanguageModelData.delete(p),c.push(p);for(const[b,v]of this._pendingRequest)v.languageModelId===p&&(v.res.reject(new l.CancellationError),this._pendingRequest.delete(b))}this._onDidChangeProviders.fire(Object.freeze({added:Object.freeze(E),removed:Object.freeze(c)})),t.added?.forEach(this._fakeAuthPopulate,this)}getLanguageModelIds(){return Array.from(this._allLanguageModelData.keys())}$updateModelAccesslist(t){const E=new Array;for(const{from:c,to:p,enabled:b}of t){const v=this._modelAccessList.get(c)??new m.ExtensionIdentifierSet;if(v.has(p)!==b){b?v.add(p):v.delete(p),this._modelAccessList.set(c,v);const C={from:c,to:p};E.push(C),this._onDidChangeModelAccess.fire(C)}}}async sendChatRequest(t,E,c,p,b){const v=t.identifier,u=await this._proxy.$prepareChatAccess(v,E,p.justification);if(!u||!this._allLanguageModelData.has(E))throw N.LanguageModelError.NotFound(`Language model '${E}' is unknown.`);if(this._isUsingAuth(v,u)&&(!await this._getAuthAccess(t,{identifier:u.extension,displayName:u.auth.providerLabel},p.justification,p.silent)||!this._modelAccessList.get(v)?.has(u.extension)))throw N.LanguageModelError.NoPermissions(`Language model '${E}' cannot be used by '${v.value}'.`);const C=Math.random()*1e6|0,f=this._proxy.$fetchResponse(v,E,C,c.map(T.LanguageModelMessage.from),p.modelOptions??{},b),I=new h.Barrier,S=new i;this._pendingRequest.set(C,{languageModelId:E,res:S});let P;if(f.catch(k=>{I.isOpen()?S.reject(k):P=k}).finally(()=>{this._pendingRequest.delete(C),S.resolve(),I.open()}),await I.wait(),P)throw new N.LanguageModelError(`Language model '${E}' errored, check cause for more details`,"Unknown",P);return S.apiObject}async $handleResponseFragment(t,E){const c=this._pendingRequest.get(t);c&&c.res.handleFragment(E)}async _getAuthAccess(t,E,c,p){const b=_.INTERNAL_AUTH_PROVIDER_PREFIX+E.identifier.value;if(await this._extHostAuthentication.getSession(t,b,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:E.identifier,enabled:!0}]),!0;if(p)return!1;try{const u=c?(0,L.localize)(0,null,E.displayName,c):(0,L.localize)(1,null,E.displayName);return await this._extHostAuthentication.getSession(t,b,[],{forceNewSession:{detail:u}}),this.$updateModelAccesslist([{from:t.identifier,to:E.identifier,enabled:!0}]),!0}catch{return!1}}_isUsingAuth(t,E){return!!E.auth&&!m.ExtensionIdentifier.equals(E.extension,t)}async _fakeAuthPopulate(t){for(const E of this._languageAccessInformationExtensions)try{await this._getAuthAccess(E,{identifier:t.extension,displayName:""},void 0,!0)}catch(c){this._logService.error("Fake Auth request failed"),this._logService.error(c)}}createLanguageModelAccessInformation(t){this._languageAccessInformationExtensions.add(t);const E=this,c=y.Event.signal(y.Event.filter(this._onDidChangeModelAccess.event,b=>m.ExtensionIdentifier.equals(b.from,t.identifier))),p=y.Event.signal(this._onDidChangeProviders.event);return{get onDidChange(){return y.Event.any(c,p)},canSendRequest(b){const v=E._allLanguageModelData.get(b);if(!v)return;if(!E._isUsingAuth(t.identifier,v))return!0;const u=E._modelAccessList.get(t.identifier);if(u)return u.has(v.extension)}}}};e.ExtHostLanguageModels=a,e.ExtHostLanguageModels=a=s=Ke([He(0,g.IExtHostRpcService),He(1,o.ILogService),He(2,r.IExtHostAuthentication)],a)}),define(Pe[264],Te([1,0,4,8,7,32,11,6,25]),function(me,e,D,O,T,N,R,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(_,l,w,g){this._documents=l,this._commands=w,this._uriTransformer=g,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=_.getProxy(D.MainContext.MainThreadLanguages)}$acceptLanguageIds(_){this._languageIds=_}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(_,l){await this._proxy.$changeLanguage(_,l);const w=this._documents.getDocumentData(_);if(!w)throw new Error(`document '${_.toString()}' NOT found`);return w.document}async tokenAtPosition(_,l){const w=_.version,g=O.Position.from(l),r=await this._proxy.$tokensAtPosition(_.uri,g),o={type:T.StandardTokenType.Other,range:_.getWordRangeAtPosition(l)??new T.Range(l.line,l.character,l.line,l.character)};if(!r)return o;const s={range:O.Range.to(r.range),type:O.TokenType.to(r.type)};return!s.range.contains(l)||w!==_.version?o:s}createLanguageStatusItem(_,l,w){const g=this._handlePool++,r=this._proxy,o=this._ids,s=`${_.identifier.value}/${l}`;if(o.has(s))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);o.add(s);const n={selector:w,id:l,name:_.displayName??_.name,severity:T.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const a=new m.DisposableStore,d=()=>{if(i?.dispose(),!o.has(s)){console.warn(`LanguageStatusItem (${l}) from ${_.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,R.disposableTimeout)(()=>{a.clear(),this._proxy.$setLanguageStatus(g,{id:s,name:n.name??_.displayName??_.name,source:_.displayName??_.name,selector:O.DocumentSelector.from(n.selector,this._uriTransformer),label:n.text,detail:n.detail??"",severity:n.severity===T.LanguageStatusSeverity.Error?N.default.Error:n.severity===T.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:n.command&&this._commands.toInternal(n.command,a),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){a.dispose(),i?.dispose(),r.$removeLanguageStatus(g),o.delete(s)},get id(){return n.id},get name(){return n.name},set name(E){n.name=E,d()},get selector(){return n.selector},set selector(E){n.selector=E,d()},get text(){return n.text},set text(E){n.text=E,d()},set text2(E){(0,h.checkProposedApiEnabled)(_,"languageStatusText"),n.text=E,d()},get text2(){return(0,h.checkProposedApiEnabled)(_,"languageStatusText"),n.text},get detail(){return n.detail},set detail(E){n.detail=E,d()},get severity(){return n.severity},set severity(E){n.severity=E,d()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(E){n.accessibilityInformation=E,d()},get command(){return n.command},set command(E){n.command=E,d()},get busy(){return n.busy},set busy(E){n.busy=E,d()}};return d(),t}}e.ExtHostLanguages=y}),define(Pe[265],Te([1,0,12,2,8,7,83]),function(me,e,D,O,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class m{constructor(_,l,w,g){this.start=_,this.deletedCount=l,this.deletedItems=w,this.items=g}asApiEvent(){return{range:new N.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(_=>_.apiCell),removedCells:this.deletedItems}}}class h{static asModelAddData(_){return{EOL:_.eol,lines:_.source,languageId:_.language,uri:_.uri,isDirty:!1,versionId:1}}constructor(_,l,w){this.notebook=_,this._extHostDocument=l,this._cellData=w,this.handle=w.handle,this.uri=O.URI.revive(w.uri),this.cellKind=w.cellKind,this._outputs=w.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=w.internalMetadata??{},this._metadata=Object.freeze(w.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const _=this,l=this._extHostDocument.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return _.notebook.getCellIndex(_)},notebook:_.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:l.document,get mime(){return _._mime},set mime(g){_._mime=g},get outputs(){return _._outputs.slice(0)},get metadata(){return _._metadata},get executionSummary(){return _._previousResult}};this._apiCell=Object.freeze(w)}return this._apiCell}setOutputs(_){this._outputs=_.map(T.NotebookCellOutput.to)}setOutputItems(_,l,w){const g=w.map(T.NotebookCellOutputItem.to),r=this._outputs.find(o=>o.id===_);if(r&&(l||(r.items.length=0),r.items.push(...g),r.items.length>1&&r.items.every(o=>R.isTextStreamMime(o.mime)))){const o=new Map,s=[];r.items.forEach(n=>{let i;o.has(n.mime)?i=o.get(n.mime):(i=[],o.set(n.mime,i),s.push(n.mime)),i.push(n.data)}),r.items.length=0,s.forEach(n=>{const i=R.compressOutputItemStreams(o.get(n));r.items.push({mime:n,data:i.data.buffer})})}}setMetadata(_){this._metadata=Object.freeze(_)}setInternalMetadata(_){this._internalMetadata=_,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(_))}setMime(_){}}e.ExtHostCell=h;class y{static{this._handlePool=0}constructor(_,l,w,g,r){this._proxy=_,this._textDocumentsAndEditors=l,this._textDocuments=w,this.uri=g,this.handle=y._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=r.viewType,this._metadata=Object.freeze(r.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,r.cells]],!0,void 0),this._versionId=r.versionId}dispose(){this._disposed=!0}get versionId(){return this._versionId}get apiNotebook(){if(!this._notebook){const _=this,l={get uri(){return _.uri},get version(){return _._versionId},get notebookType(){return _._notebookType},get isDirty(){return _._isDirty},get isUntitled(){return _.uri.scheme===D.Schemas.untitled},get isClosed(){return _._disposed},get metadata(){return _._metadata},get cellCount(){return _._cells.length},cellAt(w){return w=_._validateIndex(w),_._cells[w].apiCell},getCells(w){return(w?_._getCells(w):_._cells).map(r=>r.apiCell)},save(){return _._save()}};this._notebook=Object.freeze(l)}return this._notebook}acceptDocumentPropertiesChanged(_){_.metadata&&(this._metadata=Object.freeze({...this._metadata,..._.metadata}))}acceptDirty(_){this._isDirty=_}acceptModelChanged(_,l,w){this._versionId=_.versionId,this._isDirty=l,this.acceptDocumentPropertiesChanged({metadata:w});const g={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},r=[];for(const s of _.rawEvents)s.kind===R.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(s.changes,!1,g.contentChanges):s.kind===R.NotebookCellsChangeType.Move?this._moveCells(s.index,s.length,s.newIdx,g.contentChanges):s.kind===R.NotebookCellsChangeType.Output?(this._setCellOutputs(s.index,s.outputs),r.push({cell:this._cells[s.index].apiCell,outputs:this._cells[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(s.index,s.outputId,s.append,s.outputItems),r.push({cell:this._cells[s.index].apiCell,outputs:this._cells[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(s.index,s.language),r.push({cell:this._cells[s.index].apiCell,document:this._cells[s.index].apiCell.document})):s.kind===R.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this._cells[s.index].apiCell,document:this._cells[s.index].apiCell.document}):s.kind===R.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(s.index,s.mime):s.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(s.index,s.metadata),r.push({cell:this._cells[s.index].apiCell,metadata:this._cells[s.index].apiCell.metadata})):s.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(s.index,s.internalMetadata),r.push({cell:this._cells[s.index].apiCell,executionSummary:this._cells[s.index].apiCell.executionSummary}));const o=new Map;for(let s=0;s<r.length;s++){const n=r[s],i=o.get(n.cell);if(i===void 0){const a=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});o.set(n.cell,a-1)}else g.cellChanges[i]={...g.cellChanges[i],...n}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}_validateIndex(_){return _=_|0,_<0?0:_>=this._cells.length?this._cells.length-1:_}_validateRange(_){let l=_.start|0,w=_.end|0;return l<0&&(l=0),w>this._cells.length&&(w=this._cells.length),_.with({start:l,end:w})}_getCells(_){_=this._validateRange(_);const l=[];for(let w=_.start;w<_.end;w++)l.push(this._cells[w]);return l}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(_,l,w){if(this._disposed)return;const g=[],r=[],o=[];if(_.reverse().forEach(s=>{const i=s[2].map(t=>{const E=new h(this,this._textDocumentsAndEditors,t);return l||r.push(h.asModelAddData(t)),E}),a=new m(s[0],s[1],[],i),d=this._cells.splice(s[0],s[1],...i);for(const t of d)o.push(t.uri),a.deletedItems.push(t.apiCell);g.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),w)for(const s of g)w.push(s.asApiEvent())}_moveCells(_,l,w,g){const r=this._cells.splice(_,l);this._cells.splice(w,0,...r);const o=[new m(_,l,r.map(s=>s.apiCell),[]),new m(w,0,[],r)];for(const s of o)g.push(s.asApiEvent())}_setCellOutputs(_,l){this._cells[_].setOutputs(l)}_setCellOutputItems(_,l,w,g){this._cells[_].setOutputItems(l,w,g)}_changeCellLanguage(_,l){const w=this._cells[_];w.apiCell.document.languageId!==l&&this._textDocuments.$acceptModelLanguageChanged(w.uri,l)}_changeCellMime(_,l){const w=this._cells[_];w.apiCell.mime=l}_changeCellMetadata(_,l){this._cells[_].setMetadata(l)}_changeCellInternalMetadata(_,l){this._cells[_].setInternalMetadata(l)}getCellFromApiCell(_){return this._cells.find(l=>l.apiCell===_)}getCellFromIndex(_){return this._cells[_]}getCell(_){return this._cells.find(l=>l.handle===_)}getCellIndex(_){return this._cells.indexOf(_)}}e.ExtHostNotebookDocument=y}),define(Pe[266],Te([1,0,5,2,8,7]),function(me,e,D,O,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class R{constructor(h,y,L,_={timeout:1500,errors:3}){this._logService=h,this._notebooksAndEditors=y,this._mainThreadBulkEdits=L,this._thresholds=_,this._onWillSaveNotebookDocumentEvent=new D.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(h){return(y,L,_)=>{const l=function(g){y.call(L,g)};return l.extension=h,this._onWillSaveNotebookDocumentEvent.event(l,void 0,_)}}async $participateInSave(h,y,L){const _=O.URI.revive(h),l=this._notebooksAndEditors.getNotebookDocument(_);if(!l)throw new Error("Unable to resolve notebook document");const w=[];if(await this._onWillSaveNotebookDocumentEvent.fireAsync({notebook:l.apiNotebook,reason:T.TextDocumentSaveReason.to(y)},L,async(r,o)=>{const s=Date.now(),n=await await Promise.resolve(r);Date.now()-s>this._thresholds.timeout&&this._logService.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!L.isCancellationRequested&&n&&(n instanceof N.WorkspaceEdit?w.push(n):this._logService.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),L.isCancellationRequested)return!1;if(w.length===0)return!0;const g={edits:[]};for(const r of w){const{edits:o}=T.WorkspaceEdit.from(r);g.edits=g.edits.concat(o)}return this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(g)}}e.ExtHostNotebookDocumentSaveParticipant=R}),define(Pe[112],Te([1,0,14,8,7]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class N{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,h,y,L,_,l){this.id=m,this._proxy=h,this.notebookData=y,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=_,this._visibleRanges=L,this._viewColumn=l}get apiEditor(){if(!this._editor){const m=this;this._editor={get notebook(){return m.notebookData.apiNotebook},get selection(){return m._selections[0]},set selection(h){this.selections=[h]},get selections(){return m._selections},set selections(h){if(!Array.isArray(h)||!h.every(T.NotebookRange.isNotebookRange))throw(0,D.illegalArgument)("selections");m._selections=h,m._trySetSelections(h)},get visibleRanges(){return m._visibleRanges},revealRange(h,y){m._proxy.$tryRevealRange(m.id,O.NotebookRange.from(h),y??T.NotebookEditorRevealType.Default)},get viewColumn(){return m._viewColumn}},N.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(m){this._visible=m}_acceptVisibleRanges(m){this._visibleRanges=m}_acceptSelections(m){this._selections=m}_trySetSelections(m){this._proxy.$trySetSelections(this.id,m.map(O.NotebookRange.from))}_acceptViewColumn(m){this._viewColumn=m}}e.ExtHostNotebookEditor=N}),define(Pe[267],Te([1,0,5,13,8]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let N=class{constructor(m,h){this._logService=m,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new D.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new D.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(m,h){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,h);const y=this._notebooksAndEditors.getEditorById(m);h.visibleRanges&&y._acceptVisibleRanges(h.visibleRanges.ranges.map(T.NotebookRange.to)),h.selections&&y._acceptSelections(h.selections.selections.map(T.NotebookRange.to)),h.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),h.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const h in m)this._notebooksAndEditors.getEditorById(h)._acceptViewColumn(T.ViewColumn.to(m[h]))}};e.ExtHostNotebookEditors=N,e.ExtHostNotebookEditors=N=Ke([He(0,O.ILogService)],N)}),define(Pe[268],Te([1,0,5,4,112]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class N{constructor(m,h){this._extHostNotebook=h,this._rendererMessageEmitters=new Map,this.proxy=m.getProxy(O.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(m,h,y){const L=this._extHostNotebook.getEditorById(m);this._rendererMessageEmitters.get(h)?.fire({editor:L.apiEditor,message:y})}createRendererMessaging(m,h){if(!m.contributes?.notebookRenderer?.some(L=>L.id===h))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${h})`);return{onDidReceiveMessage:(L,_,l)=>this.getOrCreateEmitterFor(h).event(L,_,l),postMessage:(L,_)=>{T.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,_]=[_,L]);const l=_&&T.ExtHostNotebookEditor.apiEditorsToExtHost.get(_);return this.proxy.$postMessage(l?.id,h,L)}}}getOrCreateEmitterFor(m){let h=this._rendererMessageEmitters.get(m);return h||(h=new D.Emitter({onDidRemoveLastListener:()=>{h?.dispose(),this._rendererMessageEmitters.delete(m)}}),this._rendererMessageEmitters.set(m,h),h)}}e.ExtHostNotebookRenderers=N}),define(Pe[269],Te([1,0,8,101,24,68,14]),function(me,e,D,O,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class m{constructor(_){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=_}async withProgress(_,l,w){const g=this._handles++,{title:r,location:o,cancellable:s}=l,n={label:_.displayName||_.name,id:_.identifier.value};return this._proxy.$startProgress(g,{location:D.ProgressLocation.from(o),title:r,source:n,cancellable:s},_.isUnderDevelopment?void 0:_.identifier.value).catch(R.onUnexpectedExternalError),this._withProgress(g,w,!!s)}_withProgress(_,l,w){let g;w&&(g=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(_,g));const r=s=>{this._proxy.$progressEnd(s),this._mapHandleToCancellationSource.delete(s),g?.dispose()};let o;try{o=l(new y(this._proxy,_),w&&g?g.token:T.CancellationToken.None)}catch(s){throw r(_),s}return o.then(s=>r(_),s=>r(_)),o}$acceptProgressCanceled(_){const l=this._mapHandleToCancellationSource.get(_);l&&(l.cancel(),this._mapHandleToCancellationSource.delete(_))}}e.ExtHostProgress=m;function h(L,_){return L.message=_.message,typeof _.increment=="number"&&(typeof L.increment=="number"?L.increment+=_.increment:L.increment=_.increment),L}class y extends O.Progress{constructor(_,l){super(w=>this.throttledReport(w)),this._proxy=_,this._handle=l}throttledReport(_){this._proxy.$progressReport(this._handle,_)}}Ke([(0,N.throttle)(100,(L,_)=>h(L,_),()=>Object.create(null))],y.prototype,"throttledReport",null)}),define(Pe[270],Te([1,0,2,4,11,8]),function(me,e,D,O,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class R{static{this.handlePool=0}constructor(h,y){this.uriTransformer=y,this.providers=new Map,this.proxy=h.getProxy(O.MainContext.MainThreadQuickDiff)}$provideOriginalResource(h,y,L){const _=D.URI.revive(y),l=this.providers.get(h);return l?(0,T.asPromise)(()=>l.provideOriginalResource(_,L)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider(h,y,L,_){const l=R.handlePool++;return this.providers.set(l,y),this.proxy.$registerQuickDiffProvider(l,N.DocumentSelector.from(h,this.uriTransformer),L,_),{dispose:()=>{this.proxy.$unregisterQuickDiffProvider(l),this.providers.delete(l)}}}}e.ExtHostQuickDiff=R}),define(Pe[271],Te([1,0,24,5,6,4,2,7,14,18,32,41,25,8]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=g;function g(r,o,s){const n=r.getProxy(N.MainContext.MainThreadQuickOpen);class i{constructor(u,C){this._sessions=new Map,this._instances=0,this._workspace=u,this._commands=C}showQuickPick(u,C,f,I=D.CancellationToken.None){this._onDidSelectItem=void 0;const S=Promise.resolve(C),P=++this._instances,k=n.$show(P,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},I),H={},$=k.then(()=>H);return Promise.race([$,S]).then(V=>{if(V===H)return;const A=(0,l.isProposedApiEnabled)(u,"quickPickItemTooltip");return S.then(U=>{const j=[];for(let ie=0;ie<U.length;ie++){const fe=U[ie];if(typeof fe=="string")j.push({label:fe,handle:ie});else if(fe.kind===m.QuickPickItemKind.Separator)j.push({type:"separator",label:fe.label});else{fe.tooltip&&!A&&console.warn(`Extension '${u.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${u.identifier.value}`);const Ce=fe.iconPath?c(fe.iconPath):void 0;j.push({label:fe.label,iconPath:Ce?.iconPath,iconClass:Ce?.iconClass,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:A?w.MarkdownString.fromStrict(fe.tooltip):void 0,handle:ie})}}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=ie=>{f.onDidSelectItem(U[ie])}),n.$setItems(P,j),k.then(ie=>{if(typeof ie=="number")return U[ie];if(Array.isArray(ie))return ie.map(fe=>U[fe])})})}).then(void 0,V=>{if(!(0,h.isCancellationError)(V))return n.$setError(P,V),Promise.reject(V)})}$onItemSelected(u){this._onDidSelectItem?.(u)}showInput(u,C=D.CancellationToken.None){return this._validateInput=u?.validateInput,n.$input(u,typeof this._validateInput=="function",C).then(void 0,f=>{if(!(0,h.isCancellationError)(f))return Promise.reject(f)})}async $validateInput(u){if(!this._validateInput)return;const C=await this._validateInput(u);if(!C||typeof C=="string")return C;let f;switch(C.severity){case m.InputBoxValidationSeverity.Info:f=L.default.Info;break;case m.InputBoxValidationSeverity.Warning:f=L.default.Warning;break;case m.InputBoxValidationSeverity.Error:f=L.default.Error;break;default:f=C.message?L.default.Error:L.default.Ignore;break}return{content:C.message,severity:f}}async showWorkspaceFolderPick(u,C=D.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[u]);if(!f)return;const I=await this._workspace.getWorkspaceFolders2();if(I)return I.find(S=>S.uri.toString()===f.uri.toString())}createQuickPick(u){const C=new p(u,()=>this._sessions.delete(C._id));return this._sessions.set(C._id,C),C}createInputBox(u){const C=new b(u,()=>this._sessions.delete(C._id));return this._sessions.set(C._id,C),C}$onDidChangeValue(u,C){this._sessions.get(u)?._fireDidChangeValue(C)}$onDidAccept(u){this._sessions.get(u)?._fireDidAccept()}$onDidChangeActive(u,C){const f=this._sessions.get(u);f instanceof p&&f._fireDidChangeActive(C)}$onDidChangeSelection(u,C){const f=this._sessions.get(u);f instanceof p&&f._fireDidChangeSelection(C)}$onDidTriggerButton(u,C){this._sessions.get(u)?._fireDidTriggerButton(C)}$onDidTriggerItemButton(u,C,f){const I=this._sessions.get(u);I instanceof p&&I._fireDidTriggerItemButton(C,f)}$onDidHide(u){this._sessions.get(u)?._fireDidHide()}}class a{static{this._nextId=1}constructor(u,C){this._extensionId=u,this._onDidDispose=C,this._id=p._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new O.Emitter,this._onDidChangeValueEmitter=new O.Emitter,this._onDidTriggerButtonEmitter=new O.Emitter,this._onDidHideEmitter=new O.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(u){this._title=u,this.update({title:u})}get step(){return this._steps}set step(u){this._steps=u,this.update({step:u})}get totalSteps(){return this._totalSteps}set totalSteps(u){this._totalSteps=u,this.update({totalSteps:u})}get enabled(){return this._enabled}set enabled(u){this._enabled=u,this.update({enabled:u})}get busy(){return this._busy}set busy(u){this._busy=u,this.update({busy:u})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(u){this._ignoreFocusOut=u,this.update({ignoreFocusOut:u})}get value(){return this._value}set value(u){this._value=u,this.update({value:u})}get placeholder(){return this._placeholder}set placeholder(u){this._placeholder=u,this.update({placeholder:u})}get buttons(){return this._buttons}set buttons(u){this._buttons=u.slice(),this._handlesToButtons.clear(),u.forEach((C,f)=>{const I=C===m.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(I,C)}),this.update({buttons:u.map((C,f)=>({...c(C.iconPath),tooltip:C.tooltip,handle:C===m.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(u){this._value=u,this._onDidChangeValueEmitter.fire(u)}_fireDidTriggerButton(u){const C=this._handlesToButtons.get(u);C&&this._onDidTriggerButtonEmitter.fire(C)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),n.$dispose(this._id))}update(u){if(!this._disposed){for(const C of Object.keys(u)){const f=u[C];this._pendingUpdate[C]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){n.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}function d(v){if(v instanceof m.ThemeIcon)return{id:v.id};const u=E(v),C=t(v);return{dark:typeof u=="string"?R.URI.file(u):u,light:typeof C=="string"?R.URI.file(C):C}}function t(v){return typeof v=="object"&&"light"in v?v.light:v}function E(v){return typeof v=="object"&&"dark"in v?v.dark:v}function c(v){const u=d(v);let C,f;return"id"in u?f=_.ThemeIcon.asClassName(u):C=u,{iconPath:C,iconClass:f}}class p extends a{constructor(u,C){super(u.identifier,C),this.extension=u,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new O.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new O.Emitter,this._onDidTriggerItemButtonEmitter=new O.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(u){this._items=u.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),u.forEach((I,S)=>{this._handlesToItems.set(S,I),this._itemsToHandles.set(I,S)});const C=(0,l.isProposedApiEnabled)(this.extension,"quickPickItemTooltip"),f=[];for(let I=0;I<u.length;I++){const S=u[I];if(S.kind===m.QuickPickItemKind.Separator)f.push({type:"separator",label:S.label});else{S.tooltip&&!C&&console.warn(`Extension '${this.extension.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.extension.identifier.value}`);const P=S.iconPath?c(S.iconPath):void 0;f.push({handle:I,label:S.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:S.description,detail:S.detail,picked:S.picked,alwaysShow:S.alwaysShow,tooltip:C?w.MarkdownString.fromStrict(S.tooltip):void 0,buttons:S.buttons?.map((k,H)=>({...c(k.iconPath),tooltip:k.tooltip,handle:H}))})}}this.update({items:f})}get canSelectMany(){return this._canSelectMany}set canSelectMany(u){this._canSelectMany=u,this.update({canSelectMany:u})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(u){this._matchOnDescription=u,this.update({matchOnDescription:u})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(u){this._matchOnDetail=u,this.update({matchOnDetail:u})}get sortByLabel(){return this._sortByLabel}set sortByLabel(u){this._sortByLabel=u,this.update({sortByLabel:u})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(u){this._keepScrollPosition=u,this.update({keepScrollPosition:u})}get activeItems(){return this._activeItems}set activeItems(u){this._activeItems=u.filter(C=>this._itemsToHandles.has(C)),this.update({activeItems:this._activeItems.map(C=>this._itemsToHandles.get(C))})}get selectedItems(){return this._selectedItems}set selectedItems(u){this._selectedItems=u.filter(C=>this._itemsToHandles.has(C)),this.update({selectedItems:this._selectedItems.map(C=>this._itemsToHandles.get(C))})}_fireDidChangeActive(u){const C=(0,y.coalesce)(u.map(f=>this._handlesToItems.get(f)));this._activeItems=C,this._onDidChangeActiveEmitter.fire(C)}_fireDidChangeSelection(u){const C=(0,y.coalesce)(u.map(f=>this._handlesToItems.get(f)));this._selectedItems=C,this._onDidChangeSelectionEmitter.fire(C)}_fireDidTriggerItemButton(u,C){const f=this._handlesToItems.get(u);if(!f||!f.buttons||!f.buttons.length)return;const I=f.buttons[C];I&&this._onDidTriggerItemButtonEmitter.fire({button:I,item:f})}}class b extends a{constructor(u,C){super(u.identifier,C),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(u){this._password=u,this.update({password:u})}get prompt(){return this._prompt}set prompt(u){this._prompt=u,this.update({prompt:u})}get valueSelection(){return this._valueSelection}set valueSelection(u){this._valueSelection=u,this.update({valueSelection:u})}get validationMessage(){return this._validationMessage}set validationMessage(u){this._validationMessage=u,u?typeof u=="string"?this.update({validationMessage:u,severity:L.default.Error}):this.update({validationMessage:u.message,severity:u.severity??L.default.Error}):this.update({validationMessage:void 0,severity:L.default.Ignore})}}return new i(o,s)}}),define(Pe[272],Te([1,0,2,5,68,6,11,4,18,143,13,20,41,8,25,12,21]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function n(P){return P instanceof D.URI}function i(P,k){return P.scheme===r.Schemas.file&&k.scheme===r.Schemas.file&&o.isLinux?P.toString()===k.toString():P.toString().toLowerCase()===k.toString().toLowerCase()}function a(P){if(P)return typeof P.iconPath=="string"?D.URI.file(P.iconPath):D.URI.isUri(P.iconPath)||l.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function d(P){if(P.icon){if(D.URI.isUri(P.icon))return P.icon;if(l.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const k=P.icon;return{light:k.light,dark:k.dark}}}else return}function t(P,k){if(!P.iconPath&&!k.iconPath)return 0;if(P.iconPath){if(!k.iconPath)return 1}else return-1;const H=typeof P.iconPath=="string"?P.iconPath:D.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,$=typeof k.iconPath=="string"?k.iconPath:D.URI.isUri(k.iconPath)?k.iconPath.fsPath:k.iconPath.id;return(0,y.comparePaths)(H,$)}function E(P,k){let H=0;if(P.strikeThrough!==k.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==k.faded)return P.faded?1:-1;if(P.tooltip!==k.tooltip)return(P.tooltip||"").localeCompare(k.tooltip||"");if(H=t(P,k),H!==0)return H;if(P.light&&k.light)H=t(P.light,k.light);else{if(P.light)return 1;if(k.light)return-1}if(H!==0)return H;if(P.dark&&k.dark)H=t(P.dark,k.dark);else{if(P.dark)return 1;if(k.dark)return-1}return H}function c(P,k){if(P.command!==k.command)return P.command<k.command?-1:1;if(P.title!==k.title)return P.title<k.title?-1:1;if(P.tooltip!==k.tooltip){if(P.tooltip!==void 0&&k.tooltip!==void 0)return P.tooltip<k.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(k.tooltip!==void 0)return-1}if(P.arguments===k.arguments)return 0;if(P.arguments)if(k.arguments){if(P.arguments.length!==k.arguments.length)return P.arguments.length-k.arguments.length}else return 1;else return-1;for(let H=0;H<P.arguments.length;H++){const $=P.arguments[H],V=k.arguments[H];if($!==V&&!(n($)&&n(V)&&i($,V)))return $<V?-1:1}return 0}function p(P,k){let H=(0,y.comparePaths)(P.resourceUri.fsPath,k.resourceUri.fsPath,!0);if(H!==0)return H;if(P.command&&k.command)H=c(P.command,k.command);else{if(P.command)return 1;if(k.command)return-1}if(H!==0)return H;if(P.decorations&&k.decorations)H=E(P.decorations,k.decorations);else{if(P.decorations)return 1;if(k.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&k.multiFileDiffEditorModifiedUri)H=(0,y.comparePaths)(P.multiFileDiffEditorModifiedUri.fsPath,k.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(k.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&k.multiDiffEditorOriginalUri)H=(0,y.comparePaths)(P.multiDiffEditorOriginalUri.fsPath,k.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(k.multiDiffEditorOriginalUri)return-1}return H}function b(P,k){for(let H=0;H<P.length;H++)if(P[H]!==k[H])return!1;return!0}function v(P,k){return P.command===k.command&&P.title===k.title&&P.tooltip===k.tooltip&&(P.arguments&&k.arguments?b(P.arguments,k.arguments):P.arguments===k.arguments)}function u(P,k){return(0,h.equals)(P,k,v)}class C{#e;#t;get value(){return this._value}set value(k){k=k??"",this.#e.$setInputBoxValue(this._sourceControlHandle,k),this.updateValue(k)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(k){this.#e.$setInputBoxPlaceholder(this._sourceControlHandle,k),this._placeholder=k}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(k){if((0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),k&&typeof k!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=k,this.#e.$setValidationProviderIsEnabled(this._sourceControlHandle,!!k)}get enabled(){return this._enabled}set enabled(k){k=!!k,this._enabled!==k&&(this._enabled=k,this.#e.$setInputBoxEnablement(this._sourceControlHandle,k))}get visible(){return this._visible}set visible(k){k=!!k,this._visible!==k&&(this._visible=k,this.#e.$setInputBoxVisibility(this._sourceControlHandle,k))}get document(){return(0,g.checkProposedApiEnabled)(this._extension,"scmTextDocument"),this.#t.getDocument(this._documentUri)}constructor(k,H,$,V,A){this._extension=k,this._sourceControlHandle=V,this._documentUri=A,this._value="",this._onDidChange=new O.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,this.#t=H,this.#e=$}showValidationMessage(k,H){(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),this.#e.$showValidationMessage(this._sourceControlHandle,k,H)}$onInputBoxValueChange(k){this.updateValue(k)}updateValue(k){this._value=k,this._onDidChange.fire(k)}}e.ExtHostSCMInputBox=C;class f{static{this._handlePool=0}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(k){this._label=k,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,k)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(k){this._hideWhenEmpty=k,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(k){this._resourceStates=[...k],this._onDidUpdateResourceStates.fire()}constructor(k,H,$,V,A,U,j){this._proxy=k,this._commands=H,this._sourceControlHandle=$,this._id=V,this._label=A,this.multiDiffEditorEnableViewChanges=U,this._extension=j,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new O.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new O.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=f._handlePool++}getResourceState(k){return this._resourceStatesMap.get(k)}$executeResourceCommand(k,H){const $=this._resourceStatesCommandsMap.get(k);return $?(0,R.asPromise)(()=>this._commands.executeCommand($.command,...$.arguments||[],H)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const k=[...this._resourceStates].sort(p),$=(0,h.sortedDiff)(this._resourceSnapshot,k,p).map(U=>{const j=U.toInsert.map(ie=>{const fe=this._resourceHandlePool++;this._resourceStatesMap.set(fe,ie);const Ce=ie.resourceUri;let _e;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"||ie.command.command==="vscode.changes"){const he=new N.DisposableStore;_e=this._commands.converter.toInternal(ie.command,he),this._resourceStatesDisposablesMap.set(fe,he)}else this._resourceStatesCommandsMap.set(fe,ie.command);const oe=(0,g.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor"),pe=oe?ie.multiDiffEditorOriginalUri:void 0,ne=oe?ie.multiFileDiffEditorModifiedUri:void 0,Ie=a(ie.decorations),xe=ie.decorations&&a(ie.decorations.light)||Ie,re=ie.decorations&&a(ie.decorations.dark)||Ie,F=[xe,re],Z=ie.decorations&&ie.decorations.tooltip||"",be=ie.decorations&&!!ie.decorations.strikeThrough,Le=ie.decorations&&!!ie.decorations.faded,Se=ie.contextValue||"";return{rawResource:[fe,Ce,F,Z,be,Le,Se,_e,pe,ne],handle:fe}});return{start:U.start,deleteCount:U.deleteCount,toInsert:j}}),V=$.map(({start:U,deleteCount:j,toInsert:ie})=>[U,j,ie.map(fe=>fe.rawResource)]),A=$.reverse();for(const{start:U,deleteCount:j,toInsert:ie}of A){const fe=ie.map(_e=>_e.handle),Ce=this._handlesSnapshot.splice(U,j,...fe);for(const _e of Ce)this._resourceStatesMap.delete(_e),this._resourceStatesCommandsMap.delete(_e),this._resourceStatesDisposablesMap.get(_e)?.dispose(),this._resourceStatesDisposablesMap.delete(_e)}return this._resourceSnapshot=k,V}dispose(){this._disposed=!0,this._onDidDispose.fire()}}class I{static{this._handlePool=0}#e;get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(k){this._count!==k&&(this._count=k,this.#e.$updateSourceControl(this.handle,{count:k}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(k){this._quickDiffProvider=k;let H;(0,g.isProposedApiEnabled)(this._extension,"quickDiffProvider")&&(H=k?.label),this.#e.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!k,quickDiffLabel:H})}get historyProvider(){return(0,g.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider}set historyProvider(k){(0,g.checkProposedApiEnabled)(this._extension,"scmHistoryProvider"),this._historyProvider=k,this._historyProviderDisposable.value=new N.DisposableStore,this.#e.$updateSourceControl(this.handle,{hasHistoryProvider:!!k}),k&&this._historyProviderDisposable.value.add(k.onDidChangeCurrentHistoryItemGroup(()=>{this._historyProviderCurrentHistoryItemGroup=k?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.handle,this._historyProviderCurrentHistoryItemGroup)}))}get commitTemplate(){return this._commitTemplate}set commitTemplate(k){k!==this._commitTemplate&&(this._commitTemplate=k,this.#e.$updateSourceControl(this.handle,{commitTemplate:k}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(k){this._acceptInputDisposables.value=new N.DisposableStore,this._acceptInputCommand=k;const H=this._commands.converter.toInternal(k,this._acceptInputDisposables.value);this.#e.$updateSourceControl(this.handle,{acceptInputCommand:H})}get actionButton(){return(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(k){(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new N.DisposableStore,this._actionButton=k;const H=k!==void 0?{command:this._commands.converter.toInternal(k.command,this._actionButtonDisposables.value),secondaryCommands:k.secondaryCommands?.map($=>$.map(V=>this._commands.converter.toInternal(V,this._actionButtonDisposables.value))),description:k.description,enabled:k.enabled}:void 0;this.#e.$updateSourceControl(this.handle,{actionButton:H??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(k){if(this._statusBarCommands&&k&&u(this._statusBarCommands,k))return;this._statusBarDisposables.value=new N.DisposableStore,this._statusBarCommands=k;const H=(k||[]).map($=>this._commands.converter.toInternal($,this._statusBarDisposables.value));this.#e.$updateSourceControl(this.handle,{statusBarCommands:H})}get selected(){return this._selected}constructor(k,H,$,V,A,U,j){this._extension=k,this._commands=V,this._id=A,this._label=U,this._rootUri=j,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._historyProviderDisposable=new N.MutableDisposable,this._commitTemplate=void 0,this._acceptInputDisposables=new N.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new N.MutableDisposable,this._statusBarDisposables=new N.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new O.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=I._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this.#e=$;const ie=D.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${A}/scm${this.handle}/input`,query:j?`rootUri=${encodeURIComponent(j.toString())}`:void 0});this._inputBox=new C(k,H,this.#e,this.handle,ie),this.#e.$registerSourceControl(this.handle,A,U,j,ie)}createResourceGroup(k,H,$){const V=(0,g.isProposedApiEnabled)(this._extension,"scmMultiDiffEditor")&&$?.multiDiffEditorEnableViewChanges===!0,A=new f(this.#e,this._commands,this.handle,k,H,V,this._extension),U=O.Event.once(A.onDidDispose)(()=>this.createdResourceGroups.delete(A));return this.createdResourceGroups.set(A,U),this.eventuallyAddResourceGroups(),A}eventuallyAddResourceGroups(){const k=[],H=[];for(const[$,V]of this.createdResourceGroups){V.dispose();const A=$.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add($),this.eventuallyUpdateResourceStates()});O.Event.once($.onDidDispose)(()=>{this.updatedResourceGroups.delete($),A.dispose(),this._groups.delete($.handle),this.#e.$unregisterGroup(this.handle,$.handle)}),k.push([$.handle,$.id,$.label,$.features,$.multiDiffEditorEnableViewChanges]);const U=$._takeResourceStateSnapshot();U.length>0&&H.push([$.handle,U]),this._groups.set($.handle,$)}this.#e.$registerGroups(this.handle,k,H),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const k=[];this.updatedResourceGroups.forEach(H=>{const $=H._takeResourceStateSnapshot();$.length!==0&&k.push([H.handle,$])}),k.length>0&&this.#e.$spliceResourceStates(this.handle,k),this.updatedResourceGroups.clear()}getResourceGroup(k){return this._groups.get(k)}setSelectionState(k){this._selected=k,this._onDidChangeSelection.fire(k)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(k=>k.dispose()),this.#e.$unregisterSourceControl(this.handle)}}Ke([(0,T.debounce)(100)],I.prototype,"eventuallyAddResourceGroups",null),Ke([(0,T.debounce)(100)],I.prototype,"eventuallyUpdateResourceStates",null);let S=class{static{s=this}static{this._handlePool=0}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(k,H,$,V){this._commands=H,this._extHostDocuments=$,this.logService=V,this._sourceControls=new Map,this._sourceControlsByExtension=new _.ExtensionIdentifierMap,this._onDidChangeActiveProvider=new O.Emitter,this._proxy=k.getProxy(m.MainContext.MainThreadSCM),this._telemetry=k.getProxy(m.MainContext.MainThreadTelemetry),H.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const U=this._sourceControls.get(A.sourceControlHandle);if(!U)return A;const j=U.getResourceGroup(A.groupHandle);return j?j.getResourceState(A.handle):A}else if(A&&A.$mid===4){const U=this._sourceControls.get(A.sourceControlHandle);return U?U.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const U=this._sourceControls.get(A.handle);return U||A}return A}})}createSourceControl(k,H,$,V){this.logService.trace("ExtHostSCM#createSourceControl",k.identifier.value,H,$,V),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:k.identifier.value});const A=s._handlePool++,U=new I(k,this._extHostDocuments,this._proxy,this._commands,H,$,V);this._sourceControls.set(A,U);const j=this._sourceControlsByExtension.get(k.identifier)||[];return j.push(U),this._sourceControlsByExtension.set(k.identifier,j),U}getLastInputBox(k){this.logService.trace("ExtHostSCM#getLastInputBox",k.identifier.value);const H=this._sourceControlsByExtension.get(k.identifier),$=H&&H[H.length-1];return $&&$.inputBox}$provideOriginalResource(k,H,$){const V=D.URI.revive(H);this.logService.trace("ExtHostSCM#$provideOriginalResource",k,V.toString());const A=this._sourceControls.get(k);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>A.quickDiffProvider.provideOriginalResource(V,$)).then(U=>U||null)}$onInputBoxValueChange(k,H){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",k);const $=this._sourceControls.get(k);return $&&$.inputBox.$onInputBoxValueChange(H),Promise.resolve(void 0)}$executeResourceCommand(k,H,$,V){this.logService.trace("ExtHostSCM#$executeResourceCommand",k,H,$);const A=this._sourceControls.get(k);if(!A)return Promise.resolve(void 0);const U=A.getResourceGroup(H);return U?U.$executeResourceCommand($,V):Promise.resolve(void 0)}$validateInput(k,H,$){this.logService.trace("ExtHostSCM#$validateInput",k);const V=this._sourceControls.get(k);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>V.inputBox.validateInput(H,$)).then(A=>{if(!A)return Promise.resolve(void 0);const U=w.MarkdownString.fromStrict(A.message);return U?Promise.resolve([U,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(k){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",k),k!==void 0&&this._sourceControls.get(k)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=k,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(k,H,$,V){return await this._sourceControls.get(k)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(H,$,V)??void 0}async $provideHistoryItems(k,H,$,V){return(await this._sourceControls.get(k)?.historyProvider?.provideHistoryItems(H,$,V))?.map(j=>({...j,icon:d(j)}))??void 0}async $provideHistoryItemSummary(k,H,$,V){const A=this._sourceControls.get(k)?.historyProvider;if(typeof A?.provideHistoryItemSummary!="function")return;const U=await A.provideHistoryItemSummary(H,$,V);return U?{...U,icon:d(U)}:void 0}async $provideHistoryItemChanges(k,H,$,V){return await this._sourceControls.get(k)?.historyProvider?.provideHistoryItemChanges(H,$,V)??void 0}};e.ExtHostSCM=S,e.ExtHostSCM=S=s=Ke([He(3,L.ILogService)],S)}),define(Pe[273],Te([1,0,4,8,2]),function(me,e,D,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class N{static{this.handlePool=0}constructor(m,h){this.uriTransformer=h,this.providers=new Map,this.proxy=m.getProxy(D.MainContext.MainThreadShare)}async $provideShare(m,h,y){return await this.providers.get(m)?.provideShare({selection:O.Range.to(h.selection),resourceUri:T.URI.revive(h.resourceUri)},y)??void 0}registerShareProvider(m,h){const y=N.handlePool++;return this.providers.set(y,h),this.proxy.$registerShareProvider(y,O.DocumentSelector.from(m,this.uriTransformer),h.id,h.label,h.priority),{dispose:()=>{this.proxy.$unregisterShareProvider(y),this.providers.delete(y)}}}}e.ExtHostShare=N}),define(Pe[274],Te([1,0,7,4,170,6,8,17]),function(me,e,D,O,T,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class h{static{this.ID_GEN=0}static{this.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new D.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.ThemeColor("statusBarItem.warningForeground")]])}#e;#t;constructor(l,w,g,r,o,s=D.StatusBarAlignment.Left,n){if(this._disposed=!1,this._text="",this._staleCommandRegistrations=new N.DisposableStore,this.#e=l,this.#t=w,o&&r){this._entryId=(0,D.asStatusBarItemIdentifier)(r.identifier,o);const i=g.get(this._entryId);i&&(s=i.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,n=i.priority,this._visible=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this._entryId=String(h.ID_GEN++);this._extension=r,this._id=o,this._alignment=s,this._priority=this.validatePriority(n)}validatePriority(l){if((0,m.isNumber)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(l){this._text=l,this.update()}set name(l){this._name=l,this.update()}set tooltip(l){this._tooltip=l,this.update()}set color(l){this._color=l,this.update()}set backgroundColor(l){l&&!h.ALLOWED_BACKGROUND_COLORS.has(l.id)&&(l=void 0),this._backgroundColor=l,this.update()}set command(l){this._command?.fromApi!==l&&(this._latestCommandRegistration&&this._staleCommandRegistrations.add(this._latestCommandRegistration),this._latestCommandRegistration=new N.DisposableStore,typeof l=="string"?this._command={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this._latestCommandRegistration)}:l?this._command={fromApi:l,internal:this.#t.toInternal(l,this._latestCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(l){this._accessibilityInformation=l,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this.#e.$disposeEntry(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let l;this._extension?this._id?l=`${this._extension.identifier.value}.${this._id}`:l=this._extension.identifier.value:l=this._id;let w;this._name?w=this._name:w=(0,T.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=h.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const r=R.MarkdownString.fromStrict(this._tooltip);this.#e.$setEntry(this._entryId,l,this._extension?.identifier.value,w,this._text,r,this._command?.internal,g,this._backgroundColor,this._alignment===D.StatusBarAlignment.Left,this._priority,this._accessibilityInformation),this._staleCommandRegistrations.clear()},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=h;class y{constructor(l){this._messages=[],this._item=l.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,T.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(l){const w={message:l};return this._messages.unshift(w),this._update(),new D.Disposable(()=>{const g=this._messages.indexOf(w);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class L{constructor(l,w){this._existingItems=new Map,this._proxy=l.getProxy(O.MainContext.MainThreadStatusBar),this._commands=w,this._statusMessage=new y(this)}$acceptStaticEntries(l){for(const w of l)this._existingItems.set(w.entryId,w)}createStatusBarEntry(l,w,g,r){return new h(this._proxy,this._commands,this._existingItems,l,w,g,r)}setStatusBarMessage(l,w){const g=this._statusMessage.setMessage(l);let r;return typeof w=="number"?r=setTimeout(()=>g.dispose(),w):typeof w<"u"&&w.then(()=>g.dispose(),()=>g.dispose()),new D.Disposable(()=>{g.dispose(),clearTimeout(r)})}}e.ExtHostStatusBar=L}),define(Pe[113],Te([1,0,29,105,49,75,61,8,2]),function(me,e,D,O,T,N,R,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const y=(i,a,d,t)=>{let E=a;return{enumerable:!0,configurable:!1,get(){return E},set(c){if(!d(E,c)){const p=E;E=c,i.listener?.(t(c,p))}}}},L=(i,a)=>i===a,_={range:(i,a)=>i===a?!0:!i||!a?!1:i.isEqual(a),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(i,a)=>!(i.length!==a.length||i.some(d=>!a.find(t=>d.id===t.id)))},l=i=>a=>({op:4,update:i(a)}),w=(i,a)=>({range:(()=>{let d;const t=l(E=>({range:D.Range.lift(m.Range.from(E))}));return{enumerable:!0,configurable:!1,get(){return d},set(E){i.listener?.({op:6}),_.range(d,E)||(d=E,i.listener?.(t(E)))}}})(),label:y(i,a,_.label,l(d=>({label:d}))),description:y(i,void 0,_.description,l(d=>({description:d}))),sortText:y(i,void 0,_.sortText,l(d=>({sortText:d}))),canResolveChildren:y(i,!1,_.canResolveChildren,d=>({op:2,state:d})),busy:y(i,!1,_.busy,l(d=>({busy:d}))),error:y(i,void 0,_.error,l(d=>({error:m.MarkdownString.fromStrict(d)||null}))),tags:y(i,[],_.tags,(d,t)=>({op:1,new:d.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),g=i=>{const a=T.TestId.fromString(i.extId),d=new o(a.controllerId,a.localId,i.label,h.URI.revive(i.uri)||void 0);return d.range=m.Range.to(i.range||void 0),d.description=i.description||void 0,d.sortText=i.sortText||void 0,d.tags=i.tags.map(t=>m.TestTag.to({id:(0,R.denamespaceTestTag)(t).tagId})),d},r=i=>{let a;for(const d of i.tests){const t=g(d.item);(0,O.getPrivateApiFor)(t).parent=a,a=t}return a};e.toItemFromContext=r;class o{constructor(a,d,t,E){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const c=(0,O.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:E,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof s?void 0:c.parent}},children:{value:(0,N.createTestItemChildren)(c,O.getPrivateApiFor,o),enumerable:!0,writable:!1},...w(c,t)})}}e.TestItemImpl=o;class s extends o{constructor(a,d){super(a,a,d,void 0),this._isRoot=!0}}e.TestItemRootImpl=s;class n extends N.TestItemCollection{constructor(a,d,t){super({controllerId:a,getDocumentVersion:E=>E&&t.getDocument(E)?.version,getApiFor:O.getPrivateApiFor,getChildren:E=>E.children,root:new s(a,d),toITestItem:m.TestItem.from})}}e.ExtHostTestItemCollection=n}),define(Pe[31],Te([1,0,17,7,8,26,4,18,13,53,29,93,2,6,3,16,113,22,50,42,65,59,62,34]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o,s,n,i,a,d,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let c=class{#e;#t;#i;constructor(f,I,S){this._commands=new Map,this._apiCommands=new Map,this.#e=f.getProxy(R.MainContext.MainThreadCommands),this._logService=I,this.#i=S,this.#t=f.getProxy(R.MainContext.MainThreadTelemetry),this.converter=new p(this,P=>{const k=this._apiCommands.get(P);return k?.result===v.Void?k:void 0},I),this._argumentProcessors=[{processArgument(P){return(0,y.revive)(P)}},{processArgument(P){return(0,N.cloneAndChange)(P,function(k){if(L.Range.isIRange(k))return T.Range.to(k);if(_.Position.isIPosition(k))return T.Position.to(k);if(L.Range.isIRange(k.range)&&l.URI.isUri(k.uri))return T.location.to(k);if(k instanceof s.VSBuffer)return k.buffer.buffer;if(!Array.isArray(k))return k})}}]}registerArgumentProcessor(f){this._argumentProcessors.push(f)}registerApiCommand(f){const I=this.registerCommand(!1,f.id,async(...S)=>{const P=f.args.map((H,$)=>{if(!H.validate(S[$]))throw new Error(`Invalid argument '${H.name}' when running '${f.id}', received: ${typeof S[$]=="object"?JSON.stringify(S[$],null,"	"):S[$]} `);return H.convert(S[$])}),k=await this.executeCommand(f.internalId,...P);return f.result.convert(k,S,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this._apiCommands.set(f.id,f),new O.Disposable(()=>{I.dispose(),this._apiCommands.delete(f.id)})}registerCommand(f,I,S,P,k,H){if(this._logService.trace("ExtHostCommands#registerCommand",I),!I.trim().length)throw new Error("invalid id");if(this._commands.has(I))throw new Error(`command '${I}' already exists`);return this._commands.set(I,{callback:S,thisArg:P,metadata:k,extension:H}),f&&this.#e.$registerCommand(I),new O.Disposable(()=>{this._commands.delete(I)&&f&&this.#e.$unregisterCommand(I)})}executeCommand(f,...I){return this._logService.trace("ExtHostCommands#executeCommand",f),this._doExecuteCommand(f,I,!0)}async _doExecuteCommand(f,I,S){if(this._commands.has(f))return this.#e.$fireCommandActivationEvent(f),this._executeContributedCommand(f,I,!1);{let P=!1;const k=(0,N.cloneAndChange)(I,function(H){if(H instanceof O.Position)return T.Position.from(H);if(H instanceof O.Range)return T.Range.from(H);if(H instanceof O.Location)return T.location.from(H);if(O.NotebookRange.isNotebookRange(H))return T.NotebookRange.from(H);if(H instanceof ArrayBuffer)return P=!0,s.VSBuffer.wrap(new Uint8Array(H));if(H instanceof Uint8Array)return P=!0,s.VSBuffer.wrap(H);if(H instanceof s.VSBuffer)return P=!0,H;if(!Array.isArray(H))return H});try{const H=await this.#e.$executeCommand(f,P?new n.SerializableObjectWithBuffers(k):k,S);return(0,y.revive)(H)}catch(H){if(H instanceof Error&&H.message==="$executeCommand:retry")return this._doExecuteCommand(f,I,!1);throw H}}}async _executeContributedCommand(f,I,S){const P=this._commands.get(f);if(!P)throw new Error("Unknown command");const{callback:k,thisArg:H,metadata:$}=P;if($?.args)for(let A=0;A<$.args.length;A++)try{(0,D.validateConstraint)(I[A],$.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${$.args[A].name}' - ${$.args[A].description}`)}const V=a.StopWatch.create();try{return await k.apply(H,I)}catch(A){if(f===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...I);U&&(f=U.command)}if(this._logService.error(A,f,P.extension?.identifier),!S)throw A;if(P.extension?.identifier){const U=this.#i.onExtensionError(P.extension.identifier,A);this._logService.trace("forwarded error to extension?",U,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.toErrorMessage)(A)),this.id=f,this.source=P.extension?.displayName??P.extension?.name}}}finally{this._reportTelemetry(P,f,V.elapsed())}}_reportTelemetry(f,I,S){f.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new d.TelemetryTrustedValue(I),duration:S})}$executeContributedCommand(f,...I){this._logService.trace("ExtHostCommands#$executeContributedCommand",f);const S=this._commands.get(f);return S?(I=I.map(P=>this._argumentProcessors.reduce((k,H)=>H.processArgument(k,S.extension?.identifier),P)),this._executeContributedCommand(f,I,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this._logService.trace("ExtHostCommands#getCommands",f),this.#e.$getCommands().then(I=>(f&&(I=I.filter(S=>S[0]!=="_")),I))}$getContributedCommandMetadata(){const f=Object.create(null);for(const[I,S]of this._commands){const{metadata:P}=S;P&&(f[I]=P)}return Promise.resolve(f)}};e.ExtHostCommands=c,e.ExtHostCommands=c=Ke([He(0,r.IExtHostRpcService),He(1,h.ILogService),He(2,t.IExtHostTelemetry)],c),e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class p{constructor(f,I,S){this._commands=f,this._lookupApiCommand=I,this._logService=S,this.delegatingCommandId=`__vsc${(0,E.generateUuid)()}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(f,I){if(!f)return;const S={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return S;const P=this._lookupApiCommand(f.command);if(P)S.id=P.internalId,S.arguments=P.args.map((k,H)=>k.convert(f.arguments&&f.arguments[H]));else if((0,m.isNonEmptyArray)(f.arguments)){const k=`${f.command} /${++this._cachIdPool}`;this._cache.set(k,f),I.add((0,w.toDisposable)(()=>{this._cache.delete(k),this._logService.trace("CommandsConverter#DISPOSE",k)})),S.$ident=k,S.id=this.delegatingCommandId,S.arguments=[k],this._logService.trace("CommandsConverter#CREATE",f.command,k)}return S}fromInternal(f){return typeof f.$ident=="string"?this._cache.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this._cache.get(f[0])}_executeConvertedCommand(...f){const I=this.getActualCommand(...f);return this._logService.trace("CommandsConverter#EXECUTE",f[0],I?I.command:"MISSING"),I?this._commands.executeCommand(I.command,...I.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.CommandsConverter=p;class b{static{this.Uri=new b("uri","Uri of a text document",f=>l.URI.isUri(f),f=>f)}static{this.Position=new b("position","A position in a text document",f=>O.Position.isPosition(f),T.Position.from)}static{this.Range=new b("range","A range in a text document",f=>O.Range.isRange(f),T.Range.from)}static{this.Selection=new b("selection","A selection in a text document",f=>O.Selection.isSelection(f),T.Selection.from)}static{this.Number=new b("number","",f=>typeof f=="number",f=>f)}static{this.String=new b("string","",f=>typeof f=="string",f=>f)}static{this.StringArray=b.Arr(b.String)}static Arr(f){return new b(`${f.name}_array`,`Array of ${f.name}, ${f.description}`,I=>Array.isArray(I)&&I.every(S=>f.validate(S)),I=>I.map(S=>f.convert(S)))}static{this.CallHierarchyItem=new b("item","A call hierarchy item",f=>f instanceof O.CallHierarchyItem,T.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new b("item","A type hierarchy item",f=>f instanceof O.TypeHierarchyItem,T.TypeHierarchyItem.from)}static{this.TestItem=new b("testItem","A VSCodium TestItem",f=>f instanceof o.TestItemImpl,T.TestItem.from)}constructor(f,I,S,P){this.name=f,this.description=I,this.validate=S,this.convert=P}optional(){return new b(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,I){return new b(f??this.name,I??this.description,this.validate,this.convert)}}e.ApiCommandArgument=b;class v{static{this.Void=new v("no result",f=>f)}constructor(f,I){this.description=f,this.convert=I}}e.ApiCommandResult=v;class u{constructor(f,I,S,P,k){this.id=f,this.internalId=I,this.description=S,this.args=P,this.result=k}}e.ApiCommand=u}),define(Pe[275],Te([1,0,18,12,2,87,97,33,31,8,7]),function(me,e,D,O,T,N,R,m,h,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new h.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",w(y.DocumentHighlight.to))),new h.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,D.isFalsyOrEmpty)(r))return;class s extends L.SymbolInformation{static to(i){const a=new s(i.name,y.SymbolKind.to(i.kind),i.containerName||"",new L.Location(o[0],y.Range.to(i.range)));return a.detail=i.detail,a.range=a.location.range,a.selectionRange=y.Range.to(i.selectionRange),a.children=i.children?i.children.map(s.to):[],a}}return r.map(s.to)})),new h.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(y.TextEdit.to))),new h.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range,new h.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(y.TextEdit.to))),new h.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,new h.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new h.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(y.TextEdit.to))),new h.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new h.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new h.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new h.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new h.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location-instances.",w(y.location.to))),new h.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Hover-instances.",w(y.Hover.to))),new h.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>L.Position.isPosition(o)),r=>r.map(y.Position.from))],new h.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(o=>{let s;for(const n of o.reverse())s=new L.SelectionRange(y.Range.to(n),s);return s}))),new h.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[h.ApiCommandArgument.String.with("query","Search string")],new h.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(y.WorkspaceSymbol.to))),new h.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(y.CallHierarchyItem.to))),new h.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[h.ApiCommandArgument.CallHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(y.CallHierarchyIncomingCall.to))),new h.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[h.ApiCommandArgument.CallHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(y.CallHierarchyOutgoingCall.to))),new h.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:y.Range.to(r.range),placeholder:r.text}})),new h.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("newName","The new symbol name")],new h.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return y.WorkspaceEdit.to(r)}})),new h.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new h.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(y.DocumentLink.to))),new h.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new L.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new h.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,R.decodeSemanticTokensDto)(r);if(o.type==="full")return new L.SemanticTokens(o.data,void 0)})),new h.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range.optional()],new h.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new L.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new h.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,R.decodeSemanticTokensDto)(r);if(o.type==="full")return new L.SemanticTokens(o.data,void 0)})),new h.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),h.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new h.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,o,s)=>{if(!r)return new L.CompletionList([]);const n=r.suggestions.map(i=>y.CompletionItem.to(i,s));return new L.CompletionList(n,r.incomplete)})),new h.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new h.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return y.SignatureHelp.to(r)})),new h.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new h.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,o,s)=>w(n=>new L.CodeLens(y.Range.to(n.range),n.command&&s.fromInternal(n.command)))(r))),new h.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>L.Range.isRange(r),r=>L.Selection.isSelection(r)?y.Selection.from(r):y.Range.from(r)),h.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),h.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new h.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,o,s)=>w(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(n.command)}else{const i=new L.CodeAction(n.title,n.kind?new L.CodeActionKind(n.kind):void 0);return n.edit&&(i.edit=y.WorkspaceEdit.to(n.edit)),n.command&&(i.command=s.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(r))),new h.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new L.ColorInformation(y.Range.to(o.range),y.Color.to(o.color))):[])),new h.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new h.ApiCommandArgument("color","The color to show and insert",r=>r instanceof L.Color,y.Color.from),new h.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:y.Range.from(r.range)}))],new h.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(y.ColorPresentation.to):[])),new h.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to an array of Inlay objects",(r,o,s)=>r.map(y.InlayHint.to.bind(void 0,s)))),new h.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(y.FoldingRange.to)})),new h.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new h.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",w(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>y.NotebookExclusiveDocumentPattern.to(o))})))),new h.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range,new h.ApiCommandArgument("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof L.Range,r=>y.InlineValueContext.from(r))],new h.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(y.InlineValue.to))),new h.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new h.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",r=>T.URI.isUri(r)||typeof r=="string"&&(0,O.matchesSomeScheme)(r,O.Schemas.http,O.Schemas.https),r=>r),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[y.ViewColumn.from(r),void 0]:[y.ViewColumn.from(r.viewColumn),y.TextEditorOpenOptions.from(r)])).optional(),h.ApiCommandArgument.String.with("label","").optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[h.ApiCommandArgument.Uri.with("resource","Resource to open"),h.ApiCommandArgument.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VSCodium's default text editor"),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[y.ViewColumn.from(r),void 0]:[y.ViewColumn.from(r.viewColumn),y.TextEditorOpenOptions.from(r)])).optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[h.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),h.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),h.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[y.ViewColumn.from(r.viewColumn),y.TextEditorOpenOptions.from(r)]).optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[h.ApiCommandArgument.String.with("title","Human readable title for the changes editor"),new h.ApiCommandArgument("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[s,n,i]=o;if(!T.URI.isUri(s)||!T.URI.isUri(n)&&n!==void 0&&n!==null||!T.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],h.ApiCommandResult.Void),new h.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(y.TypeHierarchyItem.to))),new h.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[h.ApiCommandArgument.TypeHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(y.TypeHierarchyItem.to))),new h.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[h.ApiCommandArgument.TypeHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(y.TypeHierarchyItem.to))),new h.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[h.ApiCommandArgument.TestItem],h.ApiCommandResult.Void),new h.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[h.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],h.ApiCommandResult.Void),new h.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[h.ApiCommandArgument.String.with("name","The context key name"),new h.ApiCommandArgument("value","The context key value",()=>!0,r=>r)],h.ApiCommandResult.Void),new h.ApiCommand("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.StringArray,new h.ApiCommandArgument("MappedEditsContext","Mapped Edits Context",r=>y.MappedEditsContext.is(r),r=>y.MappedEditsContext.from(r))],new h.ApiCommandResult("A promise that resolves to a workspace edit or null",r=>r?y.WorkspaceEdit.to(r):null))];class l{static register(o){_.forEach(o.registerApiCommand,o),this._registerValidateWhenClausesCommand(o)}static _registerValidateWhenClausesCommand(o){o.registerCommand(!1,"_validateWhenClauses",m.validateWhenClauses)}}e.ExtHostApiCommands=l;function w(r){return o=>{if(Array.isArray(o))return o.map(r)}}function g(r){if(!Array.isArray(r))return;const o=[];for(const s of r)N.isLocationLink(s)?o.push(y.DefinitionLink.to(s)):o.push(y.location.to(s));return o}}),define(Pe[276],Te([1,0,11,6,2,4,31,8,7]),function(me,e,D,O,T,N,R,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class y{static{this._pool=0}constructor(w,g){this.extension=w,this.provider=g,this.handle=y._pool++}}class L{constructor(w){this.session=w,this.responses=[]}}class _{static{this._nextId=0}constructor(w,g,r,o){this._documents=r,this._logService=o,this._inputProvider=new Map,this._inputSessions=new Map,this._proxy=w.getProxy(N.MainContext.MainThreadInlineChat),g.registerApiCommand(new R.ApiCommand("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.ApiCommandArgument("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?m.Range.from(s.initialRange):void 0,initialSelection:h.Selection.isSelection(s.initialSelection)?m.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?m.Position.from(s.position):void 0}})],R.ApiCommandResult.Void))}registerProvider(w,g,r){const o=new y(w,g);return this._inputProvider.set(o.handle,o),this._proxy.$registerInteractiveEditorProvider(o.handle,r?.label??w.displayName??w.name,w.identifier,typeof g.handleInteractiveEditorResponseFeedback=="function",typeof g.provideFollowups=="function",r?.supportReportIssue??!1),(0,O.toDisposable)(()=>{this._proxy.$unregisterInteractiveEditorProvider(o.handle),this._inputProvider.delete(o.handle)})}async $prepareSession(w,g,r,o){const s=this._inputProvider.get(w);if(!s){this._logService.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this._documents.getDocument(T.URI.revive(g)),i=m.Selection.to(r),a=await s.provider.prepareInteractiveEditorSession({document:n,selection:i},o);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const d=_._nextId++;return this._inputSessions.set(d,new L(a)),{id:d,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:m.Range.from(a.wholeRange),message:a.message}}async $provideResponse(w,g,r,o){const s=this._inputProvider.get(w);if(!s)return;const n=this._inputSessions.get(g.id);if(!n)return;const i={prompt:r.prompt,selection:m.Selection.to(r.selection),wholeRange:m.Range.to(r.wholeRange),attempt:r.attempt,live:r.live,previewDocument:this._documents.getDocument(T.URI.revive(r.previewDocument)),withIntentDetection:r.withIntentDetection};let a=!1;const d={report:async C=>{if(!r.live&&C.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||o.isCancellationRequested||await this._proxy.$handleProgressChunk(r.requestId,{message:C.message,edits:C.edits?.map(m.TextEdit.from),editsShouldBeInstant:C.editsShouldBeInstant,slashCommand:C.slashCommand?.command,markdownFragment:h.MarkdownString.isMarkdownString(C.content)?C.content.value:C.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(n.session,i,d,o));let E;try{E=await(0,D.raceCancellation)(t,o)}finally{a=!0}if(!E)return;const c=n.responses.push(E)-1,p={wholeRange:m.Range.from(E.wholeRange),placeholder:E.placeholder};if(!_._isEditResponse(E))return{...p,id:c,type:"editorEdit",message:m.MarkdownString.from(E.contents),edits:[]};const{edits:b,contents:v}=E,u=v!==void 0?m.MarkdownString.from(v):void 0;return b instanceof h.WorkspaceEdit?{...p,id:c,type:"bulkEdit",edits:m.WorkspaceEdit.from(b),message:u}:{...p,id:c,type:"editorEdit",edits:b.map(m.TextEdit.from),message:u}}async $provideFollowups(w,g,r,o){const s=this._inputProvider.get(w),n=this._inputSessions.get(g),i=n?.responses[r];if(s&&i&&s.provider.provideFollowups){const a=Promise.resolve(s.provider.provideFollowups(n.session,i,o));return(await(0,D.raceCancellation)(a,o))?.map(m.ChatInlineFollowup.from)}}$handleFeedback(w,g,r,o){const s=this._inputProvider.get(w),n=this._inputSessions.get(g),i=n?.responses[r];if(s&&i){const a=m.InteractiveEditorResponseFeedbackKind.to(o);s.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,a)}}$releaseSession(w,g){}static _isEditResponse(w){return typeof w=="object"&&typeof w.edits=="object"}}e.ExtHostInteractiveEditor=_}),define(Pe[277],Te([1,0,2,31]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class T{constructor(R,m,h,y,L){this._extHostNotebooks=m,this._textDocumentsAndEditors=h,this._commands=y;const _=new O.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.ApiCommandArgument("showOptions","Show Options",l=>!0,l=>l),new O.ApiCommandArgument("resource","Interactive resource Uri",l=>!0,l=>l),new O.ApiCommandArgument("controllerId","Notebook controller Id",l=>!0,l=>l),new O.ApiCommandArgument("title","Interactive editor title",l=>!0,l=>l)],new O.ApiCommandResult("Notebook and input URI",l=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const w=this._extHostNotebooks.getEditorById(l.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:D.URI.revive(l.notebookUri),inputUri:D.URI.revive(l.inputUri),notebookEditor:w.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:D.URI.revive(l.notebookUri),inputUri:D.URI.revive(l.inputUri)}}));this._commands.registerApiCommand(_)}$willAddInteractiveDocument(R,m,h,y){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:h,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,m){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=T}),define(Pe[278],Te([1,0,18,11,24,5,6,28,2,20,13,4,31,8,7,76,217,25,50,218]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o,s,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0,e.createKernelId=b;let a=class{constructor(u,C,f,I,S){this._initData=C,this._extHostNotebook=f,this._commands=I,this._logService=S,this._activeExecutions=new m.ResourceMap,this._activeNotebookExecutions=new m.ResourceMap,this._kernelDetectionTask=new Map,this._kernelDetectionTaskHandlePool=0,this._kernelSourceActionProviders=new Map,this._kernelSourceActionProviderHandlePool=0,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new N.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this.id=0,this.variableStore={},this._proxy=u.getProxy(_.MainContext.MainThreadNotebookKernels);const P=new l.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.ApiCommandArgument("options","Select kernel options",H=>!0,H=>{if(H&&"notebookEditor"in H&&"id"in H){const $=this._extHostNotebook.getIdByEditor(H.notebookEditor);return{id:H.id,extension:H.extension,notebookEditorId:$}}else if(H&&"notebookEditor"in H){const $=this._extHostNotebook.getIdByEditor(H.notebookEditor);if($===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${H.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:$}}return H})],l.ApiCommandResult.Void),k=new l.ApiCommand("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.ApiCommandArgument.Uri],new l.ApiCommandResult("A promise that resolves to an array of variables",(H,$)=>H.map(V=>({variable:{name:V.name,value:V.value,expression:V.expression,type:V.type,language:V.language},hasNamedChildren:V.hasNamedChildren,indexedChildrenCount:V.indexedChildrenCount}))));this._commands.registerApiCommand(P),this._commands.registerApiCommand(k)}createNotebookController(u,C,f,I,S,P){for(const Ie of this._kernelData.values())if(Ie.controller.id===C&&y.ExtensionIdentifier.equals(u.identifier,Ie.extensionId))throw new Error(`notebook controller with id '${C}' ALREADY exist`);const k=this._handlePool++,H=this;this._logService.trace(`NotebookController[${k}], CREATED by ${u.identifier.value}, ${C}`);const $=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${u.identifier}'`);let V=!1;const A=new N.Emitter,U=new N.Emitter,j={id:b(u.identifier,C),notebookType:f,extensionId:u.identifier,extensionLocation:u.extensionLocation,label:I||u.identifier.value,preloads:P?P.map(w.NotebookRendererScript.from):[]};let ie=S??$,fe,Ce;this._proxy.$addKernel(k,j).catch(Ie=>{console.log(Ie),V=!0});let _e=0;const oe=()=>{if(V)return;const Ie=++_e;Promise.resolve().then(()=>{Ie===_e&&this._proxy.$updateKernel(k,j)})},pe=new m.ResourceMap,ne={get id(){return C},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return j.label},set label(Ie){j.label=Ie??u.displayName??u.name,oe()},get detail(){return j.detail??""},set detail(Ie){j.detail=Ie,oe()},get description(){return j.description??""},set description(Ie){j.description=Ie,oe()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(Ie){j.supportedLanguages=Ie,oe()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(Ie){j.supportsExecutionOrder=Ie,oe()},get rendererScripts(){return j.preloads?j.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(Ie){ie=Ie??$},get interruptHandler(){return fe},set interruptHandler(Ie){fe=Ie,j.supportsInterrupt=!!Ie,oe()},set variableProvider(Ie){(0,s.checkProposedApiEnabled)(u,"notebookVariableProvider"),Ce=Ie,j.hasVariableProvider=!!Ie,Ie?.onDidChangeVariables(xe=>H._proxy.$variablesUpdated(xe.uri)),oe()},get variableProvider(){return Ce},createNotebookCellExecution(Ie){if(V)throw new Error("notebook controller is DISPOSED");if(!pe.has(Ie.notebook.uri))throw H._logService.trace(`NotebookController[${k}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(xe=>xe.toString())),new Error(`notebook controller is NOT associated to notebook: ${Ie.notebook.uri.toString()}`);return H._createNotebookCellExecution(Ie,b(u.identifier,this.id))},createNotebookExecution(Ie){if((0,s.checkProposedApiEnabled)(u,"notebookExecution"),V)throw new Error("notebook controller is DISPOSED");if(!pe.has(Ie.uri))throw H._logService.trace(`NotebookController[${k}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(xe=>xe.toString())),new Error(`notebook controller is NOT associated to notebook: ${Ie.uri.toString()}`);return H._createNotebookExecution(Ie,b(u.identifier,this.id))},dispose:()=>{V||(this._logService.trace(`NotebookController[${k}], DISPOSED`),V=!0,this._kernelData.delete(k),A.dispose(),U.dispose(),this._proxy.$removeKernel(k))},updateNotebookAffinity(Ie,xe){xe===g.NotebookControllerAffinity2.Hidden&&(0,s.checkProposedApiEnabled)(u,"notebookControllerAffinityHidden"),H._proxy.$updateNotebookPriority(k,Ie.uri,xe)},onDidReceiveMessage:U.event,postMessage(Ie,xe){return(0,s.checkProposedApiEnabled)(u,"notebookMessaging"),H._proxy.$postMessage(k,xe&&H._extHostNotebook.getIdByEditor(xe),Ie)},asWebviewUri(Ie){return(0,s.checkProposedApiEnabled)(u,"notebookMessaging"),(0,r.asWebviewUri)(Ie,H._initData.remote)}};return this._kernelData.set(k,{extensionId:u.identifier,controller:ne,onDidReceiveMessage:U,onDidChangeSelection:A,associatedNotebooks:pe}),ne}getIdByController(u){for(const[C,f]of this._kernelData)if(f.controller===u)return b(f.extensionId,u.id);return null}createNotebookControllerDetectionTask(u,C){const f=this._kernelDetectionTaskHandlePool++,I=this;this._logService.trace(`NotebookControllerDetectionTask[${f}], CREATED by ${u.identifier.value}`),this._proxy.$addKernelDetectionTask(f,C);const S={dispose:()=>{this._kernelDetectionTask.delete(f),I._proxy.$removeKernelDetectionTask(f)}};return this._kernelDetectionTask.set(f,S),S}registerKernelSourceActionProvider(u,C,f){const I=this._kernelSourceActionProviderHandlePool++,S=typeof f.onDidChangeNotebookKernelSourceActions=="function"?I:void 0,P=this;this._kernelSourceActionProviders.set(I,f),this._logService.trace(`NotebookKernelSourceActionProvider[${I}], CREATED by ${u.identifier.value}`),this._proxy.$addKernelSourceActionProvider(I,I,C);let k;return S!==void 0&&(k=f.onDidChangeNotebookKernelSourceActions(H=>this._proxy.$emitNotebookKernelSourceActionsChangeEvent(S))),{dispose:()=>{this._kernelSourceActionProviders.delete(I),P._proxy.$removeKernelSourceActionProvider(I,I),k?.dispose()}}}async $provideKernelSourceActions(u,C){const f=this._kernelSourceActionProviders.get(u);if(f){const I=new R.DisposableStore;return(await f.provideNotebookKernelSourceActions(C)??[]).map(P=>w.NotebookKernelSourceAction.from(P,this._commands.converter,I))}return[]}$acceptNotebookAssociation(u,C,f){const I=this._kernelData.get(u);if(I){const S=this._extHostNotebook.getNotebookDocument(h.URI.revive(C));f?I.associatedNotebooks.set(S.uri,!0):I.associatedNotebooks.delete(S.uri),this._logService.trace(`NotebookController[${u}] ASSOCIATE notebook`,S.uri.toString(),f),I.onDidChangeSelection.fire({selected:f,notebook:S.apiNotebook})}}async $executeCells(u,C,f){const I=this._kernelData.get(u);if(!I)return;const S=this._extHostNotebook.getNotebookDocument(h.URI.revive(C)),P=[];for(const k of f){const H=S.getCell(k);H&&P.push(H.apiCell)}try{this._logService.trace(`NotebookController[${u}] EXECUTE cells`,S.uri.toString(),P.length),await I.controller.executeHandler.call(I.controller,P,S.apiNotebook,I.controller)}catch(k){this._logService.error(`NotebookController[${u}] execute cells FAILED`,k),console.error(k)}}async $cancelCells(u,C,f){const I=this._kernelData.get(u);if(!I)return;const S=this._extHostNotebook.getNotebookDocument(h.URI.revive(C));if(I.controller.interruptHandler)await I.controller.interruptHandler.call(I.controller,S.apiNotebook);else for(const P of f){const k=S.getCell(P);k&&this._activeExecutions.get(k.uri)?.cancel()}if(I.controller.interruptHandler){const P=this._activeNotebookExecutions.get(S.uri);f.length&&Array.isArray(P)&&P.length&&P.forEach(k=>k.dispose())}}async $provideVariables(u,C,f,I,S,P,k){const H=this._kernelData.get(u);if(!H)return;const $=this._extHostNotebook.getNotebookDocument(h.URI.revive(f)),V=H.controller.variableProvider;if(!V)return;let A;if(I!==void 0){if(A=this.variableStore[I],!A)return}else this.variableStore={};const U=S==="named"?g.NotebookVariablesRequestKind.Named:g.NotebookVariablesRequestKind.Indexed,j=V.provideVariables($.apiNotebook,A,U,P,k);let ie=0;for await(const fe of j){if(k.isCancellationRequested)return;const Ce={id:this.id++,name:fe.variable.name,value:fe.variable.value,type:fe.variable.type,interfaces:fe.variable.interfaces,language:fe.variable.language,expression:fe.variable.expression,hasNamedChildren:fe.hasNamedChildren,indexedChildrenCount:fe.indexedChildrenCount,extensionId:H.extensionId.value};if(this.variableStore[Ce.id]=fe.variable,this._proxy.$receiveVariable(C,Ce),ie++>=i.variablePageSize)return}}$acceptKernelMessageFromRenderer(u,C,f){const I=this._kernelData.get(u);if(!I)return;const S=this._extHostNotebook.getEditorById(C);I.onDidReceiveMessage.fire(Object.freeze({editor:S.apiEditor,message:f}))}$cellExecutionChanged(u,C,f){const S=this._extHostNotebook.getNotebookDocument(h.URI.revive(u)).getCell(C);if(S){const P=f?w.NotebookCellExecutionState.to(f):g.NotebookCellExecutionState.Idle;P!==void 0&&this._onDidChangeCellExecutionState.fire({cell:S.apiCell,state:P})}}_createNotebookCellExecution(u,C){if(u.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const I=this._extHostNotebook.getNotebookDocument(u.notebook.uri).getCellFromApiCell(u);if(!I)throw new Error("invalid cell");if(this._activeExecutions.has(I.uri))throw new Error(`duplicate execution for ${I.uri}`);const S=new t(C,I,this._proxy);this._activeExecutions.set(I.uri,S);const P=S.onDidChangeState(()=>{S.state===d.Resolved&&(S.dispose(),P.dispose(),this._activeExecutions.delete(I.uri))});return S.asApiObject()}_createNotebookExecution(u,C){const f=this._extHostNotebook.getNotebookDocument(u.uri),I=u.getCells().find(k=>{const H=f.getCellFromApiCell(k);return H&&this._activeExecutions.has(H.uri)});if(I)throw new Error(`duplicate cell execution for ${I.document.uri}`);if(this._activeNotebookExecutions.has(f.uri))throw new Error(`duplicate notebook execution for ${f.uri}`);const S=new c(C,f,this._proxy),P=S.onDidChangeState(()=>{S.state===E.Resolved&&(S.dispose(),P.dispose(),this._activeNotebookExecutions.delete(f.uri))});return this._activeNotebookExecutions.set(f.uri,[S,P]),S.asApiObject()}};e.ExtHostNotebookKernels=a,e.ExtHostNotebookKernels=a=Ke([He(4,L.ILogService)],a);var d;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(d||(d={}));class t extends R.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(u,C,f){super(),this._cell=C,this._proxy=f,this._handle=t.HANDLE++,this._onDidChangeState=new N.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=d.Init,this._tokenSource=this._register(new T.CancellationTokenSource),this._collector=new p(10,I=>this.update(I)),this._executionOrder=C.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,u,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(u){await this._collector.addItem(u)}async update(u){const C=Array.isArray(u)?u:[u];return this._proxy.$updateExecution(this._handle,new n.SerializableObjectWithBuffers(C))}verifyStateForOutput(){if(this._state===d.Init)throw new Error("Must call start before modifying cell output");if(this._state===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(u){let C=this._cell;if(u&&(C=this._cell.notebook.getCellFromApiCell(u)),!C)throw new Error("INVALID cell");return C.handle}validateAndConvertOutputs(u){return u.map(C=>{const f=g.NotebookCellOutput.ensureUniqueMimeTypes(C.items,!0);return f===C.items?w.NotebookCellOutput.from(C):w.NotebookCellOutput.from({items:f,id:C.id,metadata:C.metadata})})}async updateOutputs(u,C,f){const I=this.cellIndexToHandle(C),S=this.validateAndConvertOutputs((0,D.asArray)(u));return this.updateSoon({editType:o.CellExecutionUpdateType.Output,cellHandle:I,append:f,outputs:S})}async updateOutputItems(u,C,f){return u=g.NotebookCellOutput.ensureUniqueMimeTypes((0,D.asArray)(u),!0),this.updateSoon({editType:o.CellExecutionUpdateType.OutputItems,items:u.map(w.NotebookCellOutputItem.from),outputId:C.id,append:f})}asApiObject(){const u=this;return Object.freeze({get token(){return u._tokenSource.token},get cell(){return u._cell.apiCell},get executionOrder(){return u._executionOrder},set executionOrder(f){u._executionOrder=f,u.update([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:u._executionOrder}])},start(f){if(u._state===d.Resolved||u._state===d.Started)throw new Error("Cannot call start again");u._state=d.Started,u._onDidChangeState.fire(),u.update({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:f})},end(f,I,S){if(u._state===d.Resolved)throw new Error("Cannot call resolve twice");u._state=d.Resolved,u._onDidChangeState.fire(),u._collector.flush();const P=S?{message:S.message,stack:S.stack,location:S?.location?{startLineNumber:S.location.start.line,startColumn:S.location.start.character,endLineNumber:S.location.end.line,endColumn:S.location.end.character}:void 0,uri:S.uri}:void 0;u._proxy.$completeExecution(u._handle,new n.SerializableObjectWithBuffers({runEndTime:I,lastRunSuccess:f,error:P}))},clearOutput(f){return u.verifyStateForOutput(),u.updateOutputs([],f,!1)},appendOutput(f,I){return u.verifyStateForOutput(),u.updateOutputs(f,I,!0)},replaceOutput(f,I){return u.verifyStateForOutput(),u.updateOutputs(f,I,!1)},appendOutputItems(f,I){return u.verifyStateForOutput(),u.updateOutputItems(f,I,!0)},replaceOutputItems(f,I){return u.verifyStateForOutput(),u.updateOutputItems(f,I,!1)}})}}var E;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(E||(E={}));class c extends R.Disposable{static{this.HANDLE=0}get state(){return this._state}constructor(u,C,f){super(),this._notebook=C,this._proxy=f,this._handle=c.HANDLE++,this._onDidChangeState=new N.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=E.Init,this._tokenSource=this._register(new T.CancellationTokenSource),this._proxy.$createNotebookExecution(this._handle,u,this._notebook.uri)}cancel(){this._tokenSource.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this._state===E.Resolved||this._state===E.Started)throw new Error("Cannot call start again");this._state=E.Started,this._onDidChangeState.fire(),this._proxy.$beginNotebookExecution(this._handle)},end:()=>{if(this._state===E.Resolved)throw new Error("Cannot call resolve twice");this._state=E.Resolved,this._onDidChangeState.fire(),this._proxy.$completeNotebookExecution(this._handle)}})}}class p{constructor(u,C){this.delay=u,this.callback=C,this.batch=[],this.startedTimer=Date.now()}addItem(u){return this.batch.push(u),this.currentDeferred||(this.currentDeferred=new O.DeferredPromise,this.startedTimer=Date.now(),(0,O.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const u=this.currentDeferred;this.currentDeferred=void 0;const C=this.batch;return this.batch=[],this.callback(C).finally(()=>u.complete())}}function b(v,u){return`${v.value}/${u}`}}),define(Pe[51],Te([1,0,5,4,3,2,16,6,7,172,14,200,24,34,201,41,11,8,31]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class i extends m.Disposable{constructor(f,I,S,P){super(),this._proxy=f,this._id=I,this._creationOptions=S,this._name=P,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._onWillDispose=this._register(new D.Emitter),this.onWillDispose=this._onWillDispose.event,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(H=>this._pidPromiseComplete=H);const k=this;this.value={get name(){return k._name||""},get processId(){return k._pidPromise},get creationOptions(){return k._creationOptions},get exitStatus(){return k._exitStatus},get state(){return k._state},get selection(){return k._selection},get shellIntegration(){return k.shellIntegration},sendText(H,$=!0){k._checkDisposed(),k._proxy.$sendText(k._id,H,$)},show(H){k._checkDisposed(),k._proxy.$show(k._id,H)},hide(){k._checkDisposed(),k._proxy.$hide(k._id)},dispose(){k._disposed||(k._disposed=!0,k._proxy.$dispose(k._id))},get dimensions(){if(!(k._cols===void 0||k._rows===void 0))return{columns:k._cols,rows:k._rows}}}}dispose(){this._onWillDispose.fire(),super.dispose()}async create(f,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??I?.cwd??void 0,env:f.env??void 0,icon:b(f.iconPath)??void 0,color:r.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:I?.forceShellIntegration??void 0,isFeatureTerminal:I?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:I?.useShellEnvironment??void 0,location:I?.location||this._serializeParentTerminal(f.location,I?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,I,S,P,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:P,color:r.ThemeColor.isThemeColor(k)?k.id:void 0,location:I?.location||this._serializeParentTerminal(f,S),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(f,I){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&I?{parentTerminal:I}:"viewColumn"in f?{viewColumn:s.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(f){this._name=f}setExitStatus(f,I){this._exitStatus=Object.freeze({code:f,reason:I})}setDimensions(f,I){return f===this._cols&&I===this._rows||f===0||I===0?!1:(this._cols=f,this._rows=I,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}setSelection(f){this._selection=f}_setProcessId(f){this._pidPromiseComplete?(this._pidPromiseComplete(f),this._pidPromiseComplete=void 0):this._pidPromise.then(I=>{I!==f&&(this._pidPromise=Promise.resolve(f))})}}e.ExtHostTerminal=i;class a{get onProcessReady(){return this._onProcessReady.event}constructor(f){this._pty=f,this.id=0,this.shouldPersist=!1,this._onProcessData=new D.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new D.Emitter,this._onDidChangeProperty=new D.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new D.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,I){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${I}`)}async start(){}shutdown(){this._pty.close()}input(f){this._pty.handleInput?.(f)}resize(f,I){this._pty.setDimensions?.({columns:f,rows:I})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this._pty.onDidWrite(I=>this._onProcessData.fire(I)),this._pty.onDidClose?.((I=void 0)=>{this._onProcessExit.fire(I===void 0?void 0:I)}),this._pty.onDidOverrideDimensions?.(I=>{I&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:I.columns,rows:I.rows}})}),this._pty.onDidChangeName?.(I=>{this._onDidChangeProperty.fire({type:"title",value:I})}),this._pty.open(f||void 0),f&&this._pty.setDimensions?.(f),this._onProcessReady.fire({pid:-1,cwd:"",windowsPty:void 0})}}let d=1,t=class extends m.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(f=>f.value)}constructor(f,I,S){super(),this._extHostCommands=I,this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._lastQuickFixCommands=this._register(new m.MutableDisposable),this._linkProviders=new Set,this._profileProviders=new Map,this._quickFixProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new D.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new D.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new D.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new D.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new D.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new D.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._onDidWriteTerminalData=new D.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this._onDidWriteTerminalData.event,this._onDidExecuteCommand=new D.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this._onDidExecuteCommand.event,this._proxy=S.getProxy(O.MainContext.MainThreadTerminalService),this._bufferer=new g.TerminalDataBufferer(this._proxy.$sendProcessData),this._proxy.$registerProcessSupport(f),this._extHostCommands.registerArgumentProcessor({processArgument:P=>{const k=H=>{const $=H;return this.getTerminalById($.instanceId)?.value};switch(P?.$mid){case 15:return k(P);default:{if(Array.isArray(P))for(let H=0;H<P.length&&P[H].$mid===15;H++)P[H]=k(P[H]);return P}}}}),this._register({dispose:()=>{for(const[P,k]of this._terminalProcesses)k.shutdown(!0)}})}getDefaultShell(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(f,I){const S=new i(this._proxy,(0,w.generateUuid)(),f,f.name),P=new a(f.pty);return S.createExtensionTerminal(f.location,I,this._serializeParentTerminal(f,I).resolvedExtHostIdentifier,b(f.iconPath),v(f.color)).then(k=>{const H=this._setupExtHostProcessListeners(k,P);this._terminalProcessDisposables[k]=H}),this._terminals.push(S),S.value}_serializeParentTerminal(f,I){if(I=I||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const S=f.location.parentTerminal;if(S){const P=this._terminals.find(k=>k.value===S);P&&(I.resolvedExtHostIdentifier=P._id)}}else f.location&&typeof f.location!="object"?I.location=f.location:I.location&&typeof I.location=="object"&&"splitActiveTerminal"in I.location&&(I.location={splitActiveTerminal:!0});return I}attachPtyToTerminal(f,I){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const P=new a(I),k=this._setupExtHostProcessListeners(f,P);this._terminalProcessDisposables[f]=k}async $acceptActiveTerminalChanged(f){const I=this._activeTerminal;if(f===null){this._activeTerminal=void 0,I!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const S=this.getTerminalById(f);S&&(this._activeTerminal=S,I!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(f,I){const S=this.getTerminalById(f);S&&this._onDidWriteTerminalData.fire({terminal:S.value,data:I})}async $acceptTerminalDimensions(f,I,S){const P=this.getTerminalById(f);P&&P.setDimensions(I,S)&&this._onDidChangeTerminalDimensions.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(f,I){const S=this.getTerminalById(f);S&&this._onDidExecuteCommand.fire({terminal:S.value,...I})}async $acceptTerminalMaximumDimensions(f,I,S){this._terminalProcesses.get(f)?.resize(I,S)}async $acceptTerminalTitleChange(f,I){const S=this.getTerminalById(f);S&&(S.name=I)}async $acceptTerminalClosed(f,I,S){const P=this._getTerminalObjectIndexById(this._terminals,f);if(P!==null){const k=this._terminals.splice(P,1)[0];k.setExitStatus(I,S),this._onDidCloseTerminal.fire(k.value)}}$acceptTerminalOpened(f,I,S,P){if(I){const $=this._getTerminalObjectIndexById(this._terminals,I);if($!==null){this._terminals[$]._id=f,this._onDidOpenTerminal.fire(this.terminals[$]),this._terminals[$].isOpen=!0;return}}const k={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:N.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},H=new i(this._proxy,f,k,S);this._terminals.push(H),this._onDidOpenTerminal.fire(H.value),H.isOpen=!0}async $acceptTerminalProcessId(f,I){this.getTerminalById(f)?._setProcessId(I)}async $startExtensionTerminal(f,I){const S=this.getTerminalById(f);if(!S)return{message:(0,y.localize)(0,null,f)};S.isOpen||await new Promise(k=>{const H=this.onDidOpenTerminal(async $=>{$===S.value&&(H.dispose(),k())})});const P=this._terminalProcesses.get(f);P?P.startSendingEvents(I):this._extensionTerminalAwaitingStart[f]={initialDimensions:I}}_setupExtHostProcessListeners(f,I){const S=new m.DisposableStore;S.add(I.onProcessReady(k=>this._proxy.$sendProcessReady(f,k.pid,k.cwd,k.windowsPty))),S.add(I.onDidChangeProperty(k=>this._proxy.$sendProcessProperty(f,k))),this._bufferer.startBuffering(f,I.onProcessData),S.add(I.onProcessExit(k=>this._onProcessExit(f,k))),this._terminalProcesses.set(f,I);const P=this._extensionTerminalAwaitingStart[f];return P&&I instanceof a&&(I.startSendingEvents(P.initialDimensions),delete this._extensionTerminalAwaitingStart[f]),S}$acceptProcessAckDataEvent(f,I){this._terminalProcesses.get(f)?.acknowledgeDataEvent(I)}$acceptProcessInput(f,I){this._terminalProcesses.get(f)?.input(I)}$acceptTerminalInteraction(f){const I=this.getTerminalById(f);I?.setInteractedWith()&&this._onDidChangeTerminalState.fire(I.value)}$acceptTerminalSelection(f,I){this.getTerminalById(f)?.setSelection(I)}$acceptProcessResize(f,I,S){try{this._terminalProcesses.get(f)?.resize(I,S)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(f,I){this._terminalProcesses.get(f)?.shutdown(I)}$acceptProcessRequestInitialCwd(f){this._terminalProcesses.get(f)?.getInitialCwd().then(I=>this._proxy.$sendProcessProperty(f,{type:"initialCwd",value:I}))}$acceptProcessRequestCwd(f){this._terminalProcesses.get(f)?.getCwd().then(I=>this._proxy.$sendProcessProperty(f,{type:"cwd",value:I}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this._linkProviders.add(f),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new h.Disposable(()=>{this._linkProviders.delete(f),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(f,I,S){if(this._profileProviders.has(I))throw new Error(`Terminal profile provider "${I}" already registered`);return this._profileProviders.set(I,S),this._proxy.$registerProfileProvider(I,f.identifier.value),new h.Disposable(()=>{this._profileProviders.delete(I),this._proxy.$unregisterProfileProvider(I)})}registerTerminalQuickFixProvider(f,I,S){if(this._quickFixProviders.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this._quickFixProviders.set(f,S),this._proxy.$registerQuickFixProvider(f,I),new h.Disposable(()=>{this._quickFixProviders.delete(f),this._proxy.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,I){const S=new l.CancellationTokenSource().token;if(S.isCancellationRequested)return;const P=this._quickFixProviders.get(f);if(!P)return;const k=await P.provideTerminalQuickFixes(I,S);if(k===null||Array.isArray(k)&&k.length===0)return;const H=new m.DisposableStore;if(this._lastQuickFixCommands.value=H,!Array.isArray(k))return k?s.TerminalQuickFix.from(k,this._extHostCommands.converter,H):void 0;const $=[];for(const V of k){const A=s.TerminalQuickFix.from(V,this._extHostCommands.converter,H);A&&$.push(A)}return $}async $createContributedProfileTerminal(f,I){const S=new l.CancellationTokenSource().token;let P=await this._profileProviders.get(f)?.provideTerminalProfile(S);if(!S.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,I);return}this.createTerminalFromOptions(P.options,I)}}async $provideLinks(f,I){const S=this.getTerminalById(f);if(!S)return[];this._terminalLinkCache.delete(f),this._terminalLinkCancellationSource.get(f)?.dispose(!0);const k=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(f,k);const H=[],$={terminal:S.value,line:I},V=[];for(const j of this._linkProviders)V.push(o.Promises.withAsyncBody(async ie=>{k.token.onCancellationRequested(()=>ie({provider:j,links:[]}));const fe=await j.provideTerminalLinks($,k.token)||[];k.token.isCancellationRequested||ie({provider:j,links:fe})}));const A=await Promise.all(V);if(k.token.isCancellationRequested)return[];const U=new Map;for(const j of A)j&&j.links.length>0&&H.push(...j.links.map(ie=>{const fe={id:d++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return U.set(fe.id,{provider:j.provider,link:ie}),fe}));return this._terminalLinkCache.set(f,U),H}$activateLink(f,I){const S=this._terminalLinkCache.get(f)?.get(I);S&&S.provider.handleTerminalLink(S.link)}_onProcessExit(f,I){this._bufferer.stopBuffering(f),this._terminalProcesses.delete(f),delete this._extensionTerminalAwaitingStart[f];const S=this._terminalProcessDisposables[f];S&&(S.dispose(),delete this._terminalProcessDisposables[f]),this._proxy.$sendProcessExit(f,I)}getTerminalById(f){return this._getTerminalObjectById(this._terminals,f)}getTerminalIdByApiObject(f){const I=this._terminals.findIndex(S=>S.value===f);return I>=0?I:null}_getTerminalObjectById(f,I){const S=this._getTerminalObjectIndexById(f,I);return S!==null?f[S]:null}_getTerminalObjectIndexById(f,I){const S=f.findIndex(P=>P._id===I);return S>=0?S:null}getEnvironmentVariableCollection(f){let I=this._environmentVariableCollections.get(f.identifier.value);return I||(I=new E,this._setEnvironmentVariableCollection(f.identifier.value,I)),I.getScopedEnvironmentVariableCollection(void 0)}_syncEnvironmentVariableCollection(f,I){const S=(0,_.serializeEnvironmentVariableCollection)(I.map),P=(0,_.serializeEnvironmentDescriptionMap)(I.descriptionMap);this._proxy.$setEnvironmentVariableCollection(f,I.persistent,S.length===0?void 0:S,P)}$initEnvironmentVariableCollections(f){f.forEach(I=>{const S=I[0],P=new E(I[1]);this._setEnvironmentVariableCollection(S,P)})}$acceptDefaultProfile(f,I){const S=this._defaultProfile;this._defaultProfile=f,this._defaultAutomationProfile=I,S?.path!==f.path&&this._onDidChangeShell.fire(f.path)}_setEnvironmentVariableCollection(f,I){this._environmentVariableCollections.set(f,I),I.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(f,I)})}};e.BaseExtHostTerminalService=t,e.BaseExtHostTerminalService=t=Ke([He(1,n.IExtHostCommands),He(2,R.IExtHostRpcService)],t);class E{get persistent(){return this._persistent}set persistent(f){this._persistent=f,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(f){this.map=new Map,this.scopedCollections=new Map,this.descriptionMap=new Map,this._persistent=!0,this._onDidChangeCollection=new D.Emitter,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const I=this.getScopeKey(f);let S=this.scopedCollections.get(I);return S||(S=new c(this,f),this.scopedCollections.set(I,S),S.onDidChangeCollection(()=>this._onDidChangeCollection.fire())),S}replace(f,I,S,P){this._setIfDiffers(f,{value:I,type:h.EnvironmentVariableMutatorType.Replace,options:S??{applyAtProcessCreation:!0},scope:P})}append(f,I,S,P){this._setIfDiffers(f,{value:I,type:h.EnvironmentVariableMutatorType.Append,options:S??{applyAtProcessCreation:!0},scope:P})}prepend(f,I,S,P){this._setIfDiffers(f,{value:I,type:h.EnvironmentVariableMutatorType.Prepend,options:S??{applyAtProcessCreation:!0},scope:P})}_setIfDiffers(f,I){if(I.options&&I.options.applyAtProcessCreation===!1&&!I.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const S=this.getKey(f,I.scope),P=this.map.get(S),k=I.options?{applyAtProcessCreation:I.options.applyAtProcessCreation??!1,applyAtShellIntegration:I.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==I.value||P.type!==I.type||P.options?.applyAtProcessCreation!==k.applyAtProcessCreation||P.options?.applyAtShellIntegration!==k.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==I.scope?.workspaceFolder?.index){const H=this.getKey(f,I.scope),$={variable:f,...I,options:k};this.map.set(H,$),this._onDidChangeCollection.fire()}}get(f,I){const S=this.getKey(f,I),P=this.map.get(S);return P?u(P):void 0}getKey(f,I){const S=this.getScopeKey(I);return S.length?`${f}:::${S}`:f}getScopeKey(f){return this.getWorkspaceKey(f?.workspaceFolder)??""}getWorkspaceKey(f){return f?f.uri.toString():void 0}getVariableMap(f){const I=new Map;for(const[S,P]of this.map)this.getScopeKey(P.scope)===this.getScopeKey(f)&&I.set(P.variable,u(P));return I}delete(f,I){const S=this.getKey(f,I);this.map.delete(S),this._onDidChangeCollection.fire()}clear(f){if(f?.workspaceFolder){for(const[I,S]of this.map)S.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(I);this.clearDescription(f)}else this.map.clear(),this.descriptionMap.clear();this._onDidChangeCollection.fire()}setDescription(f,I){const S=this.getScopeKey(I),P=this.descriptionMap.get(S);if(!P||P.description!==f){let k;typeof f=="string"?k=f:k=f?.value.split(`

`)[0];const H={description:k,scope:I};this.descriptionMap.set(S,H),this._onDidChangeCollection.fire()}}getDescription(f){const I=this.getScopeKey(f);return this.descriptionMap.get(I)?.description}clearDescription(f){const I=this.getScopeKey(f);this.descriptionMap.delete(I)}}class c{get persistent(){return this.collection.persistent}set persistent(f){this.collection.persistent=f}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(f,I){this.collection=f,this.scope=I,this._onDidChangeCollection=new D.Emitter}getScoped(f){return this.collection.getScopedEnvironmentVariableCollection(f)}replace(f,I,S){this.collection.replace(f,I,S,this.scope)}append(f,I,S){this.collection.append(f,I,S,this.scope)}prepend(f,I,S){this.collection.prepend(f,I,S,this.scope)}get(f){return this.collection.get(f,this.scope)}forEach(f,I){this.collection.getVariableMap(this.scope).forEach((S,P)=>f.call(I,P,S,this),this.scope)}[Symbol.iterator](){return this.collection.getVariableMap(this.scope).entries()}delete(f){this.collection.delete(f,this.scope),this._onDidChangeCollection.fire(void 0)}clear(){this.collection.clear(this.scope)}set description(f){this.collection.setDescription(f,this.scope)}get description(){return this.collection.getDescription(this.scope)}}let p=class extends t{constructor(f,I){super(!1,f,I)}createTerminal(f,I,S){throw new L.NotSupportedError}createTerminalFromOptions(f,I){throw new L.NotSupportedError}};e.WorkerExtHostTerminalService=p,e.WorkerExtHostTerminalService=p=Ke([He(0,n.IExtHostCommands),He(1,R.IExtHostRpcService)],p);function b(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function v(C){return r.ThemeColor.isThemeColor(C)?C:void 0}function u(C){const f={...C};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Pe[114],Te([1,0,6,3,4,16,51,5,2,11]),function(me,e,D,O,T,N,R,m,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalShellIntegration=e.IExtHostTerminalShellIntegration=void 0,e.IExtHostTerminalShellIntegration=(0,O.createDecorator)("IExtHostTerminalShellIntegration");let L=class extends D.Disposable{constructor(r,o){super(),this._extHostTerminalService=o,this._activeShellIntegrations=new Map,this._onDidChangeTerminalShellIntegration=new m.Emitter,this.onDidChangeTerminalShellIntegration=this._onDidChangeTerminalShellIntegration.event,this._onDidStartTerminalShellExecution=new m.Emitter,this.onDidStartTerminalShellExecution=this._onDidStartTerminalShellExecution.event,this._onDidEndTerminalShellExecution=new m.Emitter,this.onDidEndTerminalShellExecution=this._onDidEndTerminalShellExecution.event,this._proxy=r.getProxy(T.MainContext.MainThreadTerminalShellIntegration),this._register((0,D.toDisposable)(()=>{for(const[s,n]of this._activeShellIntegrations)n.dispose();this._activeShellIntegrations.clear()}))}$shellIntegrationChange(r){const o=this._extHostTerminalService.getTerminalById(r);if(!o)return;const s=o.value;let n=this._activeShellIntegrations.get(r);n||(n=new _(o.value,this._onDidStartTerminalShellExecution),this._activeShellIntegrations.set(r,n),n.store.add(o.onWillDispose(()=>this._activeShellIntegrations.get(r)?.dispose())),n.store.add(n.onDidRequestShellExecution(i=>this._proxy.$executeCommand(r,i))),n.store.add(n.onDidRequestEndExecution(i=>this._onDidEndTerminalShellExecution.fire(i.value))),n.store.add(n.onDidRequestChangeShellIntegration(i=>this._onDidChangeTerminalShellIntegration.fire(i))),o.shellIntegration=n.value),this._onDidChangeTerminalShellIntegration.fire({terminal:s,shellIntegration:n.value})}$shellExecutionStart(r,o,s){this._activeShellIntegrations.has(r)||this.$shellIntegrationChange(r),this._activeShellIntegrations.get(r)?.startShellExecution(o,s)}$shellExecutionEnd(r,o,s){this._activeShellIntegrations.get(r)?.endShellExecution(o,s)}$shellExecutionData(r,o){this._activeShellIntegrations.get(r)?.emitData(o)}$cwdChange(r,o){this._activeShellIntegrations.get(r)?.setCwd(o)}$closeTerminal(r){this._activeShellIntegrations.get(r)?.dispose(),this._activeShellIntegrations.delete(r)}};e.ExtHostTerminalShellIntegration=L,e.ExtHostTerminalShellIntegration=L=Ke([He(0,N.IExtHostRpcService),He(1,R.IExtHostTerminalService)],L);class _ extends D.Disposable{get currentExecution(){return this._currentExecution}constructor(r,o){super(),this._terminal=r,this._onDidStartTerminalShellExecution=o,this._ignoreNextExecution=!1,this.store=this._register(new D.DisposableStore),this._onDidRequestChangeShellIntegration=this._register(new m.Emitter),this.onDidRequestChangeShellIntegration=this._onDidRequestChangeShellIntegration.event,this._onDidRequestShellExecution=this._register(new m.Emitter),this.onDidRequestShellExecution=this._onDidRequestShellExecution.event,this._onDidRequestEndExecution=this._register(new m.Emitter),this.onDidRequestEndExecution=this._onDidRequestEndExecution.event;const s=this;this.value={get cwd(){return s._cwd},executeCommand(n){s._onDidRequestShellExecution.fire(n);const i=s.startShellExecution(n,s._cwd).value;return s._ignoreNextExecution=!0,i}}}startShellExecution(r,o){return this._ignoreNextExecution&&this._currentExecution?this._ignoreNextExecution=!1:(this._currentExecution&&(this._currentExecution.endExecution(void 0,void 0),this._onDidRequestEndExecution.fire(this._currentExecution)),this._currentExecution=new l(this._terminal,r,o),this._onDidStartTerminalShellExecution.fire(this._currentExecution.value)),this._currentExecution}emitData(r){this.currentExecution?.emitData(r)}endShellExecution(r,o){this._currentExecution&&(this._currentExecution.endExecution(r,o),this._onDidRequestEndExecution.fire(this._currentExecution),this._currentExecution=void 0)}setCwd(r){let o=!1;h.URI.isUri(this._cwd)?this._cwd.toString()!==r.toString()&&(o=!0):this._cwd!==r&&(o=!0),o&&(this._cwd=r,this._onDidRequestChangeShellIntegration.fire({terminal:this._terminal,shellIntegration:this.value}))}}class l{constructor(r,o,s){this.terminal=r,this._commandLine=o,this.cwd=s,this._exitCode=new Promise(i=>{this._exitCodeResolve=i});const n=this;this.value={get terminal(){return r},get commandLine(){return n._commandLine},get cwd(){return s},get exitCode(){return n._exitCode},createDataStream(){return n._createDataStream()}}}_createDataStream(){if(!this._dataStream){if(this._exitCodeResolve===void 0)return y.AsyncIterableObject.EMPTY;this._dataStream=new w}return this._dataStream.createIterable()}emitData(r){this._dataStream?.emitData(r)}endExecution(r,o){r&&(this._commandLine=r),this._dataStream?.endExecution(),this._dataStream=void 0,this._exitCodeResolve?.(o),this._exitCodeResolve=void 0}}class w extends D.Disposable{constructor(){super(...arguments),this._emitters=[]}createIterable(){const r=this._barrier=new y.Barrier;return new y.AsyncIterableObject(async s=>{this._emitters.push(s),await r.wait()})}emitData(r){for(const o of this._emitters)o.emitOne(r)}endExecution(){this._barrier?.open(),this._barrier=void 0}}}),define(Pe[279],Te([1,0,11,22,24,5,251,99,6,17,34,13,4,16,113,8,7,49,75,61]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o,s,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let a=class extends h.Disposable{constructor(k,H,$,V){super(),this.editors=V,this.resultsChangedEmitter=this._register(new N.Emitter),this.controllers=new Map,this.defaultProfilesChangedEmitter=this._register(new N.Emitter),this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=k.getProxy(l.MainContext.MainThreadTesting),this.observer=new C(this.proxy),this.runTracker=new c(this.proxy,H),$.registerArgumentProcessor({processArgument:A=>{switch(A?.$mid){case 16:{const U=A,j=U.tests[U.tests.length-1].item.extId;return this.controllers.get(s.TestId.root(j))?.collection.tree.get(j)?.actual??(0,g.toItemFromContext)(A)}case 18:{const{test:U,message:j}=A,ie=U.item.extId;return{test:this.controllers.get(s.TestId.root(ie))?.collection.tree.get(ie)?.actual??(0,g.toItemFromContext)({$mid:16,tests:[U]}),message:r.TestMessage.to(j)}}default:return A}}}),$.registerCommand(!1,"testing.getExplorerSelection",async()=>{const A=await $.executeCommand("_testing.getExplorerSelection"),U=j=>{const ie=this.controllers.get(s.TestId.root(j));if(ie)return s.TestId.isRoot(j)?ie.controller:ie.collection.tree.get(j)?.actual};return{include:A?.include.map(U).filter(y.isDefined)||[],exclude:A?.exclude.map(U).filter(y.isDefined)||[]}})}createTestController(k,H,$,V){if(this.controllers.has(H))throw new Error(`Attempt to insert a duplicate controller with ID "${H}"`);const A=new h.DisposableStore,U=A.add(new g.ExtHostTestItemCollection(H,$,this.editors));U.root.label=$;const j=new Map,ie=new Set,fe=this.proxy,Ce={items:U.root.children,get label(){return $},set label(oe){$=oe,U.root.label=oe,fe.$updateController(H,{label:$})},get refreshHandler(){return V},set refreshHandler(oe){V=oe,fe.$updateController(H,{canRefresh:!!oe})},get id(){return H},createRunProfile:(oe,pe,ne,Ie,xe,re)=>{let F=(0,m.hash)(oe);for(;j.has(F);)F++;return new I(this.proxy,j,ie,this.defaultProfilesChangedEmitter.event,H,F,oe,pe,ne,Ie,xe,re)},createTestItem(oe,pe,ne){return new g.TestItemImpl(H,oe,pe,ne)},createTestRun:(oe,pe,ne=!0)=>this.runTracker.createTestRun(H,U,oe,pe,ne),invalidateTestResults:oe=>{if(oe===void 0)this.proxy.$markTestRetired(void 0);else{const pe=oe instanceof Array?oe:[oe];this.proxy.$markTestRetired(pe.map(ne=>s.TestId.fromExtHostTestItem(ne,H).toString()))}},set resolveHandler(oe){U.resolveHandler=oe},get resolveHandler(){return U.resolveHandler},dispose:()=>{A.dispose()}};fe.$registerTestController(H,$,!!V),A.add((0,h.toDisposable)(()=>fe.$unregisterTestController(H)));const _e={controller:Ce,collection:U,profiles:j,extension:k,activeProfiles:ie};return this.controllers.set(H,_e),A.add((0,h.toDisposable)(()=>this.controllers.delete(H))),A.add(U.onDidGenerateDiff(oe=>fe.$publishDiff(H,oe.map(i.TestsDiffOp.serialize)))),Ce}createTestObserver(){return this.observer.checkout()}async runTests(k,H=T.CancellationToken.None){const $=p(k);if(!$)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const V=this.controllers.get($.controllerId);if(!V)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:k.include?.map(A=>s.TestId.fromExtHostTestItem(A,V.collection.root.id).toString())??[V.collection.root.id],profileGroup:S[$.kind],profileId:$.profileId,controllerId:$.controllerId}],exclude:k.exclude?.map(A=>A.id)},H)}$syncTests(){for(const{collection:k}of this.controllers.values())k.flushDiff();return Promise.resolve()}async $getCoverageDetails(k,H){return(await this.runTracker.getCoverageDetails(k,H))?.map(r.TestCoverage.fromDetails)}async $disposeRun(k){this.runTracker.disposeTestRun(k)}$configureRunProfile(k,H){this.controllers.get(k)?.profiles.get(H)?.configureHandler?.()}$setDefaultRunProfiles(k){const H=new Map;for(const[$,V]of Object.entries(k)){const A=this.controllers.get($);if(!A)continue;const U=new Map,j=V.filter(fe=>!A.activeProfiles.has(fe)),ie=[...A.activeProfiles].filter(fe=>!V.includes(fe));for(const fe of j)U.set(fe,!0),A.activeProfiles.add(fe);for(const fe of ie)U.set(fe,!1),A.activeProfiles.delete(fe);U.size&&H.set($,U)}this.defaultProfilesChangedEmitter.fire(H)}async $refreshTests(k,H){await this.controllers.get(k)?.controller.refreshHandler?.(H)}$publishTestResults(k){this.results=Object.freeze(k.map(r.TestResults.to).concat(this.results).sort((H,$)=>$.completedAt-H.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(k,H){const $=this.controllers.get(s.TestId.fromString(k).controllerId)?.collection;$&&(await $.expand(k,H<0?1/0:H),$.flushDiff())}$acceptDiff(k){this.observer.applyDiff(k.map(H=>i.TestsDiffOp.deserialize({asCanonicalUri:$=>$},H)))}async $runControllerTests(k,H){return Promise.all(k.map($=>this.runControllerTestRequest($,!1,H)))}async $startContinuousRun(k,H){const $=new T.CancellationTokenSource(H),V=await Promise.all(k.map(A=>this.runControllerTestRequest(A,!0,$.token)));return!H.isCancellationRequested&&!V.some(A=>A.error)&&await new Promise(A=>H.onCancellationRequested(A)),$.dispose(!0),V}async runControllerTestRequest(k,H,$){const V=this.controllers.get(k.controllerId);if(!V)return{};const{collection:A,profiles:U}=V,j=U.get(k.profileId);if(!j)return{};const ie=k.testIds.map(oe=>A.tree.get(oe)).filter(y.isDefined),fe=k.excludeExtIds.map(oe=>V.collection.tree.get(oe)).filter(y.isDefined).filter(oe=>ie.some(pe=>pe.fullId.compare(oe.fullId)===2));if(!ie.length)return{};const Ce=new o.TestRunRequest(ie.some(oe=>oe.actual instanceof g.TestItemRootImpl)?void 0:ie.map(oe=>oe.actual),fe.map(oe=>oe.actual),j,H),_e=(0,i.isStartControllerTests)(k)&&this.runTracker.prepareForMainThreadTestRun(Ce,b.fromInternal(k,V.collection),j,$);try{return await j.runHandler(Ce,$),{}}catch(oe){return{error:String(oe)}}finally{_e&&_e.hasRunningTasks&&!$.isCancellationRequested&&await N.Event.toPromise(_e.onEnd)}}$cancelExtensionTestRun(k){k===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(k)}};e.ExtHostTesting=a,e.ExtHostTesting=a=Ke([He(0,w.IExtHostRpcService),He(1,_.ILogService)],a);const d=1e4;var t;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(t||(t={}));class E extends h.Disposable{get hasRunningTasks(){return this.running>0}get id(){return this.dto.id}constructor(k,H,$,V,A){super(),this.dto=k,this.proxy=H,this.logService=$,this.profile=V,this.state=0,this.running=0,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new N.Emitter),this.publishedCoverage=new Map,this.onEnd=this.endEmitter.event,this.cts=this._register(new T.CancellationTokenSource(A));const U=this._register(new D.RunOnceScheduler(()=>this.forciblyEndTasks(),d));this._register(this.cts.token.onCancellationRequested(()=>U.schedule()));const j=new N.Emitter;this.onDidDispose=j.event,this._register((0,h.toDisposable)(()=>{j.fire(),j.dispose()}))}cancel(){this.state===0?(this.cts.cancel(),this.state=1):this.state===1&&this.forciblyEndTasks()}getCoverageDetails(k,H){const[,$,V]=s.TestId.fromString(k).path,A=this.publishedCoverage.get(V);if(!A)return[];if(A.backCompatResolve)return A.backCompatResolve(H);const U=this.tasks.get($);if(!U)throw new Error("unreachable: run task was not found");return this.profile?.loadDetailedCoverage?.(U.run,A.coverage,H)??[]}createRun(k){const H=this.dto.id,$=this.dto.controllerId,V=(0,L.generateUuid)(),A=_e=>(oe,...pe)=>{if(ie){this.logService.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}this.dto.isIncluded(oe)&&(this.ensureTestIsKnown(oe),_e(oe,...pe))},U=(_e,oe)=>{const pe=oe instanceof Array?oe.map(r.TestMessage.from):[r.TestMessage.from(oe)];if(_e.uri&&_e.range){const ne={range:r.Range.from(_e.range),uri:_e.uri};for(const Ie of pe)Ie.location=Ie.location||ne}this.proxy.$appendTestMessagesInRun(H,V,s.TestId.fromExtHostTestItem(_e,$).toString(),pe)},j=(_e,oe)=>{const pe=_e.uri.toString(),ne=new s.TestId([H,V,pe]).toString();this.publishedCoverage.set(pe,{coverage:_e,backCompatResolve:oe}),this.proxy.$appendCoverage(H,V,r.TestCoverage.fromFile(ne,_e))};let ie=!1,fe;const Ce={isPersisted:this.dto.isPersisted,token:this.cts.token,name:k,onDidDispose:this.onDidDispose,get coverageProvider(){return fe},set coverageProvider(_e){fe=_e,_e&&Promise.resolve(_e.provideFileCoverage(T.CancellationToken.None)).then(oe=>{oe?.forEach(pe=>j(pe,_e.resolveFileCoverage&&(async ne=>(await _e.resolveFileCoverage(pe,ne)||pe).detailedCoverage)))})},addCoverage:j,enqueued:A(_e=>{this.proxy.$updateTestStateInRun(H,V,s.TestId.fromExtHostTestItem(_e,$).toString(),1)}),skipped:A(_e=>{this.proxy.$updateTestStateInRun(H,V,s.TestId.fromExtHostTestItem(_e,$).toString(),5)}),started:A(_e=>{this.proxy.$updateTestStateInRun(H,V,s.TestId.fromExtHostTestItem(_e,$).toString(),2)}),errored:A((_e,oe,pe)=>{U(_e,oe),this.proxy.$updateTestStateInRun(H,V,s.TestId.fromExtHostTestItem(_e,$).toString(),6,pe)}),failed:A((_e,oe,pe)=>{U(_e,oe),this.proxy.$updateTestStateInRun(H,V,s.TestId.fromExtHostTestItem(_e,$).toString(),4,pe)}),passed:A((_e,oe)=>{this.proxy.$updateTestStateInRun(H,V,s.TestId.fromExtHostTestItem(_e,this.dto.controllerId).toString(),3,oe)}),appendOutput:(_e,oe,pe)=>{ie||(pe&&(this.dto.isIncluded(pe)?this.ensureTestIsKnown(pe):pe=void 0),this.proxy.$appendOutputToRun(H,V,O.VSBuffer.fromString(_e),oe&&r.location.from(oe),pe&&s.TestId.fromExtHostTestItem(pe,$).toString()))},end:()=>{ie||(ie=!0,this.proxy.$finishedTestRunTask(H,V),--this.running||this.markEnded())}};return this.running++,this.tasks.set(V,{run:Ce}),this.proxy.$startedTestRunTask(H,{id:V,name:k,running:!0}),Ce}forciblyEndTasks(){for(const{run:k}of this.tasks.values())k.end()}markEnded(){this.state!==2&&(this.state=2,this.endEmitter.fire())}ensureTestIsKnown(k){if(!(k instanceof g.TestItemImpl))throw new n.InvalidTestItemError(k.id);if(this.sharedTestIds.has(s.TestId.fromExtHostTestItem(k,this.dto.controllerId).toString()))return;const H=[],$=this.dto.colllection.root;for(;;){const V=r.TestItem.from(k);if(H.unshift(V),this.sharedTestIds.has(V.extId)||(this.sharedTestIds.add(V.extId),k===$))break;k=k.parent||$}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,H)}dispose(){this.markEnded(),super.dispose()}}class c{get trackers(){return this.tracked.values()}constructor(k,H){this.proxy=k,this.logService=H,this.tracked=new Map,this.trackedById=new Map}getCoverageDetails(k,H){const $=s.TestId.root(k);return this.trackedById.get($)?.getCoverageDetails(k,H)||[]}disposeTestRun(k){this.trackedById.get(k)?.dispose(),this.trackedById.delete(k);for(const[H,{id:$}]of this.tracked)$===k&&this.tracked.delete(H)}prepareForMainThreadTestRun(k,H,$,V){return this.getTracker(k,H,$,V)}cancelRunById(k){this.trackedById.get(k)?.cancel()}cancelAllRuns(){for(const k of this.tracked.values())k.cancel()}createTestRun(k,H,$,V,A){const U=this.tracked.get($);if(U)return U.createRun(V);const j=b.fromPublic(k,H,$,A),ie=p($);this.proxy.$startedExtensionTestRun({controllerId:k,continuous:!!$.continuous,profile:ie&&{group:S[ie.kind],id:ie.profileId},exclude:$.exclude?.map(Ce=>s.TestId.fromExtHostTestItem(Ce,H.root.id).toString())??[],id:j.id,include:$.include?.map(Ce=>s.TestId.fromExtHostTestItem(Ce,H.root.id).toString())??[H.root.id],persist:A});const fe=this.getTracker($,j,$.profile);return N.Event.once(fe.onEnd)(()=>{this.proxy.$finishedExtensionTestRun(j.id)}),fe.createRun(V)}getTracker(k,H,$,V){const A=new E(H,this.proxy,this.logService,$,V);return this.tracked.set(k,A),this.trackedById.set(A.id,A),A}}e.TestRunCoordinator=c;const p=P=>{if(P.profile){if(!(P.profile instanceof I))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class b{static fromPublic(k,H,$,V){return new b(k,(0,L.generateUuid)(),$.include?.map(A=>s.TestId.fromExtHostTestItem(A,k).toString())??[k],$.exclude?.map(A=>s.TestId.fromExtHostTestItem(A,k).toString())??[],V,H)}static fromInternal(k,H){return new b(k.controllerId,k.runId,k.testIds,k.excludeExtIds,!0,H)}constructor(k,H,$,V,A,U){this.controllerId=k,this.id=H,this.isPersisted=A,this.colllection=U,this.includePrefix=$.map(j=>j+"\0"),this.excludePrefix=V.map(j=>j+"\0")}isIncluded(k){const H=s.TestId.fromExtHostTestItem(k,this.controllerId).toString()+"\0";for(const $ of this.excludePrefix)if(H===$||H.startsWith($))return!1;for(const $ of this.includePrefix)if(H===$||H.startsWith($))return!0;return!1}}e.TestRunDto=b;class v{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(k){this.emitter=k,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(k){this.added.add(k)}update(k){Object.assign(k.revived,r.TestItem.toPlain(k.item)),this.added.has(k)||this.updated.add(k)}remove(k){if(this.added.has(k)){this.added.delete(k);return}this.updated.delete(k);const H=s.TestId.parentId(k.item.extId);if(H&&this.alreadyRemoved.has(H.toString())){this.alreadyRemoved.add(k.item.extId);return}this.removed.add(k)}getChangeEvent(){const{added:k,updated:H,removed:$}=this;return{get added(){return[...k].map(V=>V.revived)},get updated(){return[...H].map(V=>V.revived)},get removed(){return[...$].map(V=>V.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class u extends i.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new N.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return this.roots}getMirroredTestDataById(k){return this.items.get(k)}getMirroredTestDataByReference(k){return this.items.get(k.id)}createItem(k,H){return{...k,revived:r.TestItem.toPlain(k.item),depth:H?H.depth+1:0,children:new Set}}createChangeCollector(){return new v(this.changeEmitter)}}class C{constructor(k){this.proxy=k}checkout(){this.current||(this.current=this.createObserverData());const k=this.current;return k.observers++,{onDidChangeTest:k.tests.onDidChangeTests,get tests(){return[...k.tests.rootTests].map(H=>H.revived)},dispose:(0,R.createSingleCallFunction)(()=>{--k.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(k){return this.current?.tests.getMirroredTestDataByReference(k)}applyDiff(k){this.current?.tests.apply(k)}createObserverData(){const k=new u({asCanonicalUri:H=>H});return this.proxy.$subscribeToDiffs(),{observers:0,tests:k}}}const f=(P,k,H,$)=>{H?Object.assign(H,$):k.$updateTestRunConfig(P.controllerId,P.profileId,$)};class I{#e;#t;#i;#n;#s;get label(){return this._label}set label(k){k!==this._label&&(this._label=k,f(this,this.#e,this.#n,{label:k}))}get supportsContinuousRun(){return this._supportsContinuousRun}set supportsContinuousRun(k){k!==this._supportsContinuousRun&&(this._supportsContinuousRun=k,f(this,this.#e,this.#n,{supportsContinuousRun:k}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(k){k!==this.isDefault&&(k?this.#t.add(this.profileId):this.#t.delete(this.profileId),f(this,this.#e,this.#n,{isDefault:k}))}get tag(){return this._tag}set tag(k){k?.id!==this._tag?.id&&(this._tag=k,f(this,this.#e,this.#n,{tag:k?r.TestTag.namespace(this.controllerId,k.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(k){k!==this._configureHandler&&(this._configureHandler=k,f(this,this.#e,this.#n,{hasConfigurationHandler:!!k}))}get onDidChangeDefault(){return N.Event.chain(this.#i,k=>k.map(H=>H.get(this.controllerId)?.get(this.profileId)).filter(y.isDefined))}constructor(k,H,$,V,A,U,j,ie,fe,Ce=!1,_e=void 0,oe=!1){this.controllerId=A,this.profileId=U,this._label=j,this.kind=ie,this.runHandler=fe,this._tag=_e,this._supportsContinuousRun=oe,this.#e=k,this.#s=H,this.#t=$,this.#i=V,H.set(U,this);const pe=S[ie];if(typeof pe!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);Ce&&$.add(U),this.#n={profileId:U,controllerId:A,tag:_e?r.TestTag.namespace(this.controllerId,_e.id):null,label:j,group:pe,isDefault:Ce,hasConfigurationHandler:!1,supportsContinuousRun:oe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.TestRunProfileImpl=I;const S={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Pe[115],Te([1,0,56,14,90,8,7]),function(me,e,D,O,T,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class m{static{this._Keys=new T.IdGenerator("TextEditorDecorationType")}constructor(l,w,g){const r=m._Keys.nextId();l.$registerTextEditorDecorationType(w.identifier,r,N.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:r,dispose(){l.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=m;class h{constructor(l,w){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=w.undoStopBefore,this._undoStopAfter=w.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,w){this._throwIfFinalized();let g=null;if(l instanceof R.Position)g=new R.Range(l,l);else if(l instanceof R.Range)g=l;else throw new Error("Unrecognized location");this._pushEdit(g,w,!1)}insert(l,w){this._throwIfFinalized(),this._pushEdit(new R.Range(l,l),w,!0)}delete(l){this._throwIfFinalized();let w=null;if(l instanceof R.Range)w=l;else throw new Error("Unrecognized location");this._pushEdit(w,null,!0)}_pushEdit(l,w,g){const r=this._document.validateRange(l);this._collectedEdits.push({range:r,text:w,forceMoveMarkers:g})}setEndOfLine(l){if(this._throwIfFinalized(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,O.illegalArgument)("endOfLine");this._setEndOfLine=l}}class y{constructor(l,w,g,r){this._proxy=l,this._id=w,this._accept(g),this._logService=r;const o=this;this.value={get tabSize(){return o._tabSize},set tabSize(s){o._setTabSize(s)},get indentSize(){return o._indentSize},set indentSize(s){o._setIndentSize(s)},get insertSpaces(){return o._insertSpaces},set insertSpaces(s){o._setInsertSpaces(s)},get cursorStyle(){return o._cursorStyle},set cursorStyle(s){o._setCursorStyle(s)},get lineNumbers(){return o._lineNumbers},set lineNumbers(s){o._setLineNumbers(s)}}}_accept(l){this._tabSize=l.tabSize,this._indentSize=l.indentSize,this._originalIndentSize=l.originalIndentSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=N.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const w=Math.floor(l);return w>0?w:null}if(typeof l=="string"){const w=parseInt(l,10);return isNaN(w)?null:w>0?w:null}return null}_setTabSize(l){const w=this._validateTabSize(l);if(w!==null){if(typeof w=="number"){if(this._tabSize===w)return;this._tabSize=w}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:w}))}}_validateIndentSize(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const w=Math.floor(l);return w>0?w:null}if(typeof l=="string"){const w=parseInt(l,10);return isNaN(w)?null:w>0?w:null}return null}_setIndentSize(l){const w=this._validateIndentSize(l);if(w!==null){if(typeof w=="number"){if(this._originalIndentSize===w)return;this._indentSize=w,this._originalIndentSize=w}this._warnOnError("setIndentSize",this._proxy.$trySetOptions(this._id,{indentSize:w}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:!!l}_setInsertSpaces(l){const w=this._validateInsertSpaces(l);if(typeof w=="boolean"){if(this._insertSpaces===w)return;this._insertSpaces=w}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:w}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:N.TextEditorLineNumbersStyle.from(l)})))}assign(l){const w={};let g=!1;if(typeof l.tabSize<"u"){const r=this._validateTabSize(l.tabSize);r==="auto"?(g=!0,w.tabSize=r):typeof r=="number"&&this._tabSize!==r&&(this._tabSize=r,g=!0,w.tabSize=r)}if(typeof l.indentSize<"u"){const r=this._validateIndentSize(l.indentSize);r==="tabSize"?(g=!0,w.indentSize=r):typeof r=="number"&&this._originalIndentSize!==r&&(this._indentSize=r,this._originalIndentSize=r,g=!0,w.indentSize=r)}if(typeof l.insertSpaces<"u"){const r=this._validateInsertSpaces(l.insertSpaces);r==="auto"?(g=!0,w.insertSpaces=r):this._insertSpaces!==r&&(this._insertSpaces=r,g=!0,w.insertSpaces=r)}typeof l.cursorStyle<"u"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,g=!0,w.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,g=!0,w.lineNumbers=N.TextEditorLineNumbersStyle.from(l.lineNumbers)),g&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,w))}_warnOnError(l,w){w.catch(g=>{this._logService.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this._logService.warn(g)})}}e.ExtHostTextEditorOptions=y;class L{constructor(l,w,g,r,o,s,n,i){this.id=l,this._proxy=w,this._logService=g,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=o,this._options=new y(this._proxy,this.id,s,g),this._visibleRanges=n,this._viewColumn=i;const a=this;this.value=Object.freeze({get document(){return r.value},set document(d){throw new O.ReadonlyError("document")},get selection(){return a._selections&&a._selections[0]},set selection(d){if(!(d instanceof R.Selection))throw(0,O.illegalArgument)("selection");a._selections=[d],a._trySetSelection()},get selections(){return a._selections},set selections(d){if(!Array.isArray(d)||d.some(t=>!(t instanceof R.Selection)))throw(0,O.illegalArgument)("selections");a._selections=d,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(d){throw new O.ReadonlyError("visibleRanges")},get options(){return a._options.value},set options(d){a._disposed||a._options.assign(d)},get viewColumn(){return a._viewColumn},set viewColumn(d){throw new O.ReadonlyError("viewColumn")},edit(d,t={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const E=new h(r.value,t);return d(E),a._applyEdit(E)},insertSnippet(d,t,E={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=a._selections.map(p=>N.Range.from(p));else if(t instanceof R.Position){const{lineNumber:p,column:b}=N.Position.from(t);c=[{startLineNumber:p,startColumn:b,endLineNumber:p,endColumn:b}]}else if(t instanceof R.Range)c=[N.Range.from(t)];else{c=[];for(const p of t)if(p instanceof R.Range)c.push(N.Range.from(p));else{const{lineNumber:b,column:v}=N.Position.from(p);c.push({startLineNumber:b,startColumn:v,endLineNumber:b,endColumn:v})}}return w.$tryInsertSnippet(l,r.value.version,d.value,c,E)},setDecorations(d,t){const E=t.length===0;E&&!a._hasDecorationsForKey.has(d.key)||(E?a._hasDecorationsForKey.delete(d.key):a._hasDecorationsForKey.add(d.key),a._runOnProxy(()=>{if(N.isDecorationOptionsArr(t))return w.$trySetDecorations(l,d.key,N.fromRangeOrRangeWithMessage(t));{const c=new Array(4*t.length);for(let p=0,b=t.length;p<b;p++){const v=t[p];c[4*p]=v.start.line+1,c[4*p+1]=v.start.character+1,c[4*p+2]=v.end.line+1,c[4*p+3]=v.end.character+1}return w.$trySetDecorationsFast(l,d.key,c)}}))},revealRange(d,t){a._runOnProxy(()=>w.$tryRevealRange(l,N.Range.from(d),t||R.TextEditorRevealType.Default))},show(d){w.$tryShowEditor(l,N.ViewColumn.from(d))},hide(){w.$tryHideEditor(l)}})}dispose(){(0,D.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,D.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,D.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,D.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,D.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(N.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const w=l.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const g=w.edits.map(o=>o.range);g.sort((o,s)=>o.end.line===s.end.line?o.end.character===s.end.character?o.start.line===s.start.line?o.start.character-s.start.character:o.start.line-s.start.line:o.end.character-s.end.character:o.end.line-s.end.line);for(let o=0,s=g.length-1;o<s;o++){const n=g[o].end;if(g[o+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=w.edits.map(o=>({range:N.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,w.documentVersionId,r,{setEndOfLine:typeof w.setEndOfLine=="number"?N.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this._logService.warn(w),null))}}e.ExtHostTextEditor=L}),define(Pe[67],Te([1,0,56,5,6,2,3,4,111,16,115,8,13,28,12,39,40]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class s{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let n=class{constructor(a,d){this._extHostRpc=a,this._logService=d,this._activeEditorId=null,this._editors=new Map,this._documents=new w.ResourceMap,this._onDidAddDocuments=new O.Emitter,this._onDidRemoveDocuments=new O.Emitter,this._onDidChangeVisibleTextEditors=new O.Emitter,this._onDidChangeActiveTextEditor=new O.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const d=[],t=[],E=[];if(a.removedDocuments)for(const c of a.removedDocuments){const p=N.URI.revive(c),b=this._documents.get(p);b?.unref()&&(this._documents.delete(p),d.push(b.value))}if(a.addedDocuments)for(const c of a.addedDocuments){const p=N.URI.revive(c.uri);let b=this._documents.get(p);if(b&&p.scheme!==g.Schemas.vscodeNotebookCell&&p.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${p} already exists!'`);b||(b=new s(new h.ExtHostDocumentData(this._extHostRpc.getProxy(m.MainContext.MainThreadDocuments),p,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty)),this._documents.set(p,b),t.push(b.value)),b.ref()}if(a.removedEditors)for(const c of a.removedEditors){const p=this._editors.get(c);this._editors.delete(c),p&&E.push(p)}if(a.addedEditors)for(const c of a.addedEditors){const p=N.URI.revive(c.documentUri);D.ok(this._documents.has(p),`document '${p}' does not exist`),D.ok(!this._editors.has(c.id),`editor '${c.id}' already exists!`);const b=this._documents.get(p).value,v=new L.ExtHostTextEditor(c.id,this._extHostRpc.getProxy(m.MainContext.MainThreadTextEditors),this._logService,new o.Lazy(()=>b.document),c.selections.map(_.Selection.to),c.options,c.visibleRanges.map(u=>_.Range.to(u)),typeof c.editorPosition=="number"?_.ViewColumn.to(c.editorPosition):void 0);this._editors.set(c.id,v)}a.newActiveEditor!==void 0&&(D.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,T.dispose)(d),(0,T.dispose)(E),a.removedDocuments&&this._onDidRemoveDocuments.fire(d),a.addedDocuments&&this._onDidAddDocuments.fire(t),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(c=>c.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){return this._documents.get(a)?.value}allDocuments(){return r.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!this._activeEditorId)return;const d=this._editors.get(this._activeEditorId);return a?d:d?.value}allEditors(){return[...this._editors.values()]}};e.ExtHostDocumentsAndEditors=n,e.ExtHostDocumentsAndEditors=n=Ke([He(0,y.IExtHostRpcService),He(1,l.ILogService)],n),e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(Pe[280],Te([1,0,18,5,4,115,8,7]),function(me,e,D,O,T,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class h{constructor(L,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new O.Emitter,this._onDidChangeTextEditorOptions=new O.Emitter,this._onDidChangeTextEditorVisibleRanges=new O.Emitter,this._onDidChangeTextEditorViewColumn=new O.Emitter,this._onDidChangeActiveTextEditor=new O.Emitter,this._onDidChangeVisibleTextEditors=new O.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(T.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const _=this._extHostDocumentsAndEditors.allEditors();return L?_:_.map(l=>l.value)}async showTextDocument(L,_,l){let w;typeof _=="number"?w={position:R.ViewColumn.from(_),preserveFocus:l}:typeof _=="object"?w={position:R.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?R.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:w={preserveFocus:!1};const g=await this._proxy.$tryShowTextDocument(L.uri,w),r=g&&this._extHostDocumentsAndEditors.getEditor(g);if(r)return r.value;throw g?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,_){return new N.TextEditorDecorationType(this._proxy,L,_).value}$acceptEditorPropertiesChanged(L,_){const l=this._extHostDocumentsAndEditors.getEditor(L);if(!l)throw new Error("unknown text editor");if(_.options&&l._acceptOptions(_.options),_.selections){const w=_.selections.selections.map(R.Selection.to);l._acceptSelections(w)}if(_.visibleRanges){const w=D.coalesce(_.visibleRanges.map(R.Range.to));l._acceptVisibleRanges(w)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{..._.options,lineNumbers:R.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const w=m.TextEditorSelectionChangeKind.fromValue(_.selections.source),g=_.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:g,kind:w})}if(_.visibleRanges){const w=D.coalesce(_.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:w})}}$acceptEditorPositionData(L){for(const _ in L){const l=this._extHostDocumentsAndEditors.getEditor(_);if(!l)throw new Error("Unknown text editor");const w=R.ViewColumn.to(L[_]);l.value.viewColumn!==w&&(l._acceptViewColumn(w),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:w}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=h}),define(Pe[281],Te([1,0,2,3,4,6,7,8,20,17]),function(me,e,D,O,T,N,R,m,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,O.createDecorator)("IExtHostTimeline");class L{constructor(w,g){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=w.getProxy(T.MainContext.MainThreadTimeline),g.registerArgumentProcessor({processArgument:(r,o)=>{if(r&&r.$mid===12)if(this._providers.get(r.source)&&h.ExtensionIdentifier.equals(o,this._providers.get(r.source)?.extension)){const s=r.uri===void 0?void 0:D.URI.revive(r.uri);return this._itemsBySourceAndUriMap.get(r.source)?.get(_(s))?.get(r.handle)}else return;return r}})}async $getTimeline(w,g,r,o){return this._providers.get(w)?.provider.provideTimeline(D.URI.revive(g),r,o)}registerTimelineProvider(w,g,r,o){const s=new N.DisposableStore,n=this.convertTimelineItem(g.id,o,s).bind(this);let i;g.onDidChange&&(i=g.onDidChange(d=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...d,id:g.id}),this));const a=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...g,scheme:w,onDidChange:void 0,async provideTimeline(d,t,E){t?.resetCache&&(s.clear(),a.get(g.id)?.clear());const c=await g.provideTimeline(d,t,E);if(c==null)return;const p=n(d,t);return{...c,source:g.id,items:c.items.map(p)}},dispose(){for(const d of a.values())d.get(g.id)?.clear();i?.dispose(),s.dispose()}},r)}convertTimelineItem(w,g,r){return(o,s)=>{let n;if(s?.cacheResults){let i=this._itemsBySourceAndUriMap.get(w);i===void 0&&(i=new Map,this._itemsBySourceAndUriMap.set(w,i));const a=_(o);n=i.get(a),n===void 0&&(n=new Map,i.set(a,n))}return i=>{const{iconPath:a,...d}=i,t=`${w}|${i.id??i.timestamp}`;n?.set(t,i);let E,c,p;i.iconPath&&(a instanceof R.ThemeIcon?p={id:a.id,color:a.color}:D.URI.isUri(a)?(E=a,c=a):{light:E,dark:c}=a);let b;return R.MarkdownString.isMarkdownString(d.tooltip)?b=m.MarkdownString.from(d.tooltip):(0,y.isString)(d.tooltip)?b=d.tooltip:R.MarkdownString.isMarkdownString(d.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=m.MarkdownString.from(d.detail)):(0,y.isString)(d.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=d.detail),{...d,id:d.id??void 0,handle:t,source:w,command:i.command?g.toInternal(i.command,r):void 0,icon:E,iconDark:c,themeIcon:p,tooltip:b,accessibilityInformation:i.accessibilityInformation}}}}registerTimelineProviderCore(w,g){if(this._providers.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this._proxy.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this._providers.set(w.id,{provider:w,extension:g}),(0,N.toDisposable)(()=>{for(const o of this._itemsBySourceAndUriMap.values())o.get(w.id)?.clear();this._providers.delete(w.id),this._proxy.$unregisterTimelineProvider(w.id),w.dispose()})}}e.ExtHostTimeline=L;function _(l){return l?.toString()}}),define(Pe[282],Te([1,0,173,23,2,5,6,211,11,7,17,18,8,54,24,137,25]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function s(a,d){if((0,L.isString)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let t;return Array.isArray(a.highlights)&&(t=a.highlights.filter(E=>E.length===2&&typeof E[0]=="number"&&typeof E[1]=="number"),t=t.length?t:void 0),{label:a.label,highlights:t}}}class n extends R.Disposable{constructor(d,t,E){super(),this._proxy=d,this.commands=t,this.logService=E,this.treeViews=new Map,this.treeDragAndDropService=new r.TreeViewsDnDService;function c(p){return p&&p.$treeViewId&&(p.$treeItemHandle||p.$selectedTreeItems||p.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:p=>c(p)?this.convertArgument(p):Array.isArray(p)&&p.length>0?p.map(b=>c(b)?this.convertArgument(b):b):p})}registerTreeDataProvider(d,t,E){const c=this.createTreeView(d,{treeDataProvider:t},E);return{dispose:()=>c.dispose()}}createTreeView(d,t,E){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],p=t.dragAndDropController?.dragMimeTypes??[],b=!!t.dragAndDropController?.handleDrag,v=!!t.dragAndDropController?.handleDrop,u=this.createExtHostTreeView(d,t,E),C={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:p,hasHandleDrag:b,hasHandleDrop:v,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},f=this._proxy.$registerTreeViewDataProvider(d,C),I={get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get activeItem(){return(0,o.checkProposedApiEnabled)(E,"treeViewActiveItem"),u.focusedElement},get onDidChangeActiveItem(){return(0,o.checkProposedApiEnabled)(E,"treeViewActiveItem"),u.onDidChangeActiveItem},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get onDidChangeCheckboxState(){return u.onDidChangeCheckboxState},get message(){return u.message},set message(S){(0,w.isMarkdownString)(S)&&(0,o.checkProposedApiEnabled)(E,"treeViewMarkdownMessage"),u.message=S},get title(){return u.title},set title(S){u.title=S},get description(){return u.description},set description(S){u.description=S},get badge(){return u.badge},set badge(S){S!==void 0&&y.ViewBadge.isViewBadge(S)?u.badge={value:Math.floor(Math.abs(S.value)),tooltip:S.tooltip}:S===void 0&&(u.badge=void 0)},reveal:(S,P)=>u.reveal(S,P),dispose:async()=>{await f,this.treeViews.delete(d),u.dispose()}};return this._register(I),I}$getChildren(d,t){const E=this.treeViews.get(d);return E?E.getChildren(t):Promise.reject(new m.NoTreeViewError(d))}async $handleDrop(d,t,E,c,p,b,v,u){const C=this.treeViews.get(d);if(!C)return Promise.reject(new m.NoTreeViewError(d));const f=l.DataTransfer.toDataTransfer(E,async I=>(await this._proxy.$resolveDropFileData(d,t,I)).buffer);return v===d&&u&&await this.addAdditionalTransferItems(f,C,u,p,b),C.onDrop(f,c,p)}async addAdditionalTransferItems(d,t,E,c,p){const b=this.treeDragAndDropService.removeDragOperationTransfer(p);if(b)(await b)?.forEach((v,u)=>{v&&d.set(u,v)});else if(p&&t.handleDrag){const v=t.handleDrag(E,d,c);this.treeDragAndDropService.addDragOperationTransfer(p,v),await v}return d}async $handleDrag(d,t,E,c){const p=this.treeViews.get(d);if(!p)return Promise.reject(new m.NoTreeViewError(d));const b=await this.addAdditionalTransferItems(new y.DataTransfer,p,t,c,E);if(!(!b||c.isCancellationRequested))return l.DataTransfer.from(b)}async $hasResolve(d){const t=this.treeViews.get(d);if(!t)throw new m.NoTreeViewError(d);return t.hasResolve}$resolve(d,t,E){const c=this.treeViews.get(d);if(!c)throw new m.NoTreeViewError(d);return c.resolveTreeItem(t,E)}$setExpanded(d,t,E){const c=this.treeViews.get(d);if(!c)throw new m.NoTreeViewError(d);c.setExpanded(t,E)}$setSelectionAndFocus(d,t,E){const c=this.treeViews.get(d);if(!c)throw new m.NoTreeViewError(d);c.setSelectionAndFocus(t,E)}$setVisible(d,t){const E=this.treeViews.get(d);if(!E){if(!t)return;throw new m.NoTreeViewError(d)}E.setVisible(t)}$changeCheckboxState(d,t){const E=this.treeViews.get(d);if(!E)throw new m.NoTreeViewError(d);E.setCheckboxState(t)}createExtHostTreeView(d,t,E){const c=this._register(new i(d,t,this._proxy,this.commands.converter,this.logService,E));return this.treeViews.set(d,c),c}convertArgument(d){const t=this.treeViews.get(d.$treeViewId);return t&&"$treeItemHandle"in d?t.getExtensionElement(d.$treeItemHandle):t&&"$focusedTreeItem"in d&&d.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=n;class i extends R.Disposable{static{this.LABEL_HANDLE_PREFIX="0"}static{this.ID_HANDLE_PREFIX="1"}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(d=>this.getExtensionElement(d)).filter(d=>!(0,L.isUndefinedOrNull)(d))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(d,t,E,c,p,b){if(super(),this.viewId=d,this.proxy=E,this.commands=c,this.logService=p,this.extension=b,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new N.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new N.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new N.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeActiveItem=this._register(new N.Emitter),this.onDidChangeActiveItem=this._onDidChangeActiveItem.event,this._onDidChangeVisibility=this._register(new N.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new N.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new N.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new g.CancellationTokenSource,b.contributes&&b.contributes.views)for(const f in b.contributes.views)for(const I of b.contributes.views[f])I.id===d&&(this._title=I.name);this.dataProvider=t.treeDataProvider,this.dndController=t.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(f=>this._onDidChangeData.fire({message:!1,element:f})));let v,u;const C=N.Event.debounce(this._onDidChangeData.event,(f,I)=>(f||(f={message:!1,elements:[]}),I.element!==!1&&(v||(v=new Promise(S=>u=S),this.refreshPromise=this.refreshPromise.then(()=>v)),Array.isArray(I.element)?f.elements.push(...I.element):f.elements.push(I.element)),I.message&&(f.message=!0),f),200,!0);this._register(C(({message:f,elements:I})=>{I.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const S=u;return v=null,this.refresh(I).then(()=>S())})),f&&this.proxy.$setMessage(this.viewId,l.MarkdownString.fromStrict(this._message)??"")}))}async getChildren(d){const t=d?this.getExtensionElement(d):void 0;if(d&&!t)return this.logService.error(`No tree item with id '${d}' found.`),Promise.resolve([]);let E=this.getChildrenNodes(d);return E||(E=await this.fetchChildrenNodes(t)),E?E.map(c=>c.item):void 0}getExtensionElement(d){return this.elements.get(d)}reveal(d,t){t=t||{select:!0,focus:!1};const E=(0,L.isUndefinedOrNull)(t.select)?!0:t.select,c=(0,L.isUndefinedOrNull)(t.focus)?!1:t.focus,p=(0,L.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.refreshPromise.then(()=>this.resolveUnknownParentChain(d)).then(b=>this.resolveTreeNode(d,b[b.length-1]).then(v=>this.proxy.$reveal(this.viewId,{item:v.item,parentChain:b.map(u=>u.item)},{select:E,focus:c,expand:p})),b=>this.logService.error(b)):this.proxy.$reveal(this.viewId,void 0,{select:E,focus:c,expand:p})}get message(){return this._message}set message(d){this._message=d,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(d){this._title=d,this.proxy.$setTitle(this.viewId,d,this._description)}get description(){return this._description}set description(d){this._description=d,this.proxy.$setTitle(this.viewId,this._title,d)}get badge(){return this._badge}set badge(d){this._badge?.value===d?.value&&this._badge?.tooltip===d?.tooltip||(this._badge=l.ViewBadge.from(d),this.proxy.$setBadge(this.viewId,d))}setExpanded(d,t){const E=this.getExtensionElement(d);E&&(t?this._onDidExpandElement.fire(Object.freeze({element:E})):this._onDidCollapseElement.fire(Object.freeze({element:E})))}setSelectionAndFocus(d,t){const E=!(0,_.equals)(this._selectedHandles,d);this._selectedHandles=d;const c=this._focusedHandle!==t;this._focusedHandle=t,E&&this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})),c&&this._onDidChangeActiveItem.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(d){d!==this._visible&&(this._visible=d,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(d){const t=(await Promise.all(d.map(async E=>{const c=this.getExtensionElement(E.treeItemHandle);return c?{extensionItem:c,treeItem:await this.dataProvider.getTreeItem(c),newState:E.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(E=>E!==void 0);t.forEach(E=>{E.treeItem.checkboxState=E.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:t.map(E=>[E.extensionItem,E.newState])})}async handleDrag(d,t,E){const c=[];for(const p of d){const b=this.getExtensionElement(p);b&&c.push(b)}if(!(!this.dndController?.handleDrag||c.length===0))return await this.dndController.handleDrag(c,t,E),t}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(d,t,E){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.dndController?.handleDrop))return(0,h.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(c,d,E):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(d,t){if(!this.dataProvider.resolveTreeItem)return;const E=this.elements.get(d);if(E){const c=this.nodes.get(E);if(c){const p=await this.dataProvider.resolveTreeItem(c.extensionItem,E,t)??c.extensionItem;return this.validateTreeItem(p),c.item.tooltip=this.getTooltip(p.tooltip),c.item.command=this.getCommand(c.disposableStore,p.command),c.item}}}resolveUnknownParentChain(d){return this.resolveParent(d).then(t=>t?this.resolveUnknownParentChain(t).then(E=>this.resolveTreeNode(t,E[E.length-1]).then(c=>(E.push(c),E))):Promise.resolve([]))}resolveParent(d){const t=this.nodes.get(d);return t?Promise.resolve(t.parent?this.elements.get(t.parent.item.handle):void 0):(0,h.asPromise)(()=>this.dataProvider.getParent(d))}resolveTreeNode(d,t){const E=this.nodes.get(d);return E?Promise.resolve(E):(0,h.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(c=>this.createHandle(d,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const p=this.getExtensionElement(c);if(p){const b=this.nodes.get(p);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.extension.identifier.value}`)}))}getChildrenNodes(d){if(d){let t;if(typeof d=="string"){const E=this.getExtensionElement(d);t=E?this.nodes.get(E):void 0}else t=d;return t&&t.children||void 0}return this.roots}async fetchChildrenNodes(d){this.clearChildren(d);const t=new g.CancellationTokenSource(this._refreshCancellationSource.token);try{const E=d?this.nodes.get(d):void 0,c=await this.dataProvider.getChildren(d);if(t.token.isCancellationRequested)return;const p=(0,_.coalesce)(c||[]),b=await Promise.all((0,_.coalesce)(p).map(u=>this.dataProvider.getTreeItem(u)));if(t.token.isCancellationRequested)return;const v=b.map((u,C)=>u?this.createAndRegisterTreeNode(p[C],u,E):null);return(0,_.coalesce)(v)}finally{t.dispose()}}refresh(d){if(d.some(E=>!E))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new g.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const E=this.getHandlesToRefresh(d);if(E.length)return this.refreshHandles(E)}return Promise.resolve(void 0)}getHandlesToRefresh(d){const t=new Set,E=d.map(p=>this.nodes.get(p));for(const p of E)if(p&&!t.has(p.item.handle)){let b=p;for(;b&&b.parent&&E.findIndex(v=>b&&b.parent&&v&&v.item.handle===b.parent.item.handle)===-1;){const v=this.elements.get(b.parent.item.handle);b=v?this.nodes.get(v):void 0}b&&!b.parent&&t.add(p.item.handle)}const c=[];return t.forEach(p=>{const b=this.elements.get(p);if(b){const v=this.nodes.get(b);v&&(!v.parent||!t.has(v.parent.item.handle))&&c.push(p)}}),c}refreshHandles(d){const t={};return Promise.all(d.map(E=>this.refreshNode(E).then(c=>{c&&(t[E]=c.item)}))).then(()=>Object.keys(t).length?this.proxy.$refresh(this.viewId,t):void 0)}refreshNode(d){const t=this.getExtensionElement(d);if(t){const E=this.nodes.get(t);if(E)return this.clearChildren(t),(0,h.asPromise)(()=>this.dataProvider.getTreeItem(t)).then(c=>{if(c){const p=this.createTreeNode(t,c,E.parent);return this.updateNodeCache(t,p,E,E.parent),E.dispose(),p}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(d,t,E){const c=this.createTreeNode(d,t,E);if(t.id&&this.elements.has(c.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.addNodeToCache(d,c),this.addNodeToParentCache(c,E),c}getTooltip(d){return y.MarkdownString.isMarkdownString(d)?l.MarkdownString.from(d):d}getCommand(d,t){return t?{...this.commands.toInternal(t,d),originalId:t.command}:void 0}getCheckbox(d){if(d.checkboxState===void 0)return;let t,E,c;return typeof d.checkboxState=="number"?t=d.checkboxState:(t=d.checkboxState.state,E=d.checkboxState.tooltip,c=d.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:E,accessibilityInformation:c}}validateTreeItem(d){if(!y.TreeItem.isTreeItem(d,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(d,t,E){this.validateTreeItem(t);const c=this._register(new R.DisposableStore),p=this.createHandle(d,t,E),b=this.getLightIconPath(t);return{item:{handle:p,parentHandle:E?E.item.handle:void 0,label:s(t.label,this.extension),description:t.description,resourceUri:t.resourceUri,tooltip:this.getTooltip(t.tooltip),command:this.getCommand(c,t.command),contextValue:t.contextValue,icon:b,iconDark:this.getDarkIconPath(t)||b,themeIcon:this.getThemeIcon(t),collapsibleState:(0,L.isUndefinedOrNull)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.getCheckbox(t)},extensionItem:t,parent:E,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(d){return d.iconPath instanceof y.ThemeIcon?d.iconPath:void 0}createHandle(d,{id:t,label:E,resourceUri:c},p,b){if(t)return`${i.ID_HANDLE_PREFIX}/${t}`;const v=s(E,this.extension),u=p?p.item.handle:i.LABEL_HANDLE_PREFIX;let C=v?v.label:c?(0,O.basename)(c):"";C=C.indexOf("/")!==-1?C.replace("/","//"):C;const f=this.nodes.has(d)?this.nodes.get(d).item.handle:void 0,I=this.getChildrenNodes(p)||[];let S,P=0;do{if(S=`${u}/${P}:${C}`,b||!this.elements.has(S)||f===S)break;P++}while(P<=I.length);return S}getLightIconPath(d){if(d.iconPath&&!(d.iconPath instanceof y.ThemeIcon))return typeof d.iconPath=="string"||T.URI.isUri(d.iconPath)?this.getIconPath(d.iconPath):this.getIconPath(d.iconPath.light)}getDarkIconPath(d){if(d.iconPath&&!(d.iconPath instanceof y.ThemeIcon)&&d.iconPath.dark)return this.getIconPath(d.iconPath.dark)}getIconPath(d){return T.URI.isUri(d)?d:T.URI.file(d)}addNodeToCache(d,t){this.elements.set(t.item.handle,d),this.nodes.set(d,t)}updateNodeCache(d,t,E,c){this.elements.delete(t.item.handle),this.nodes.delete(d),t.item.handle!==E.item.handle&&this.elements.delete(E.item.handle),this.addNodeToCache(d,t);const p=this.getChildrenNodes(c)||[],b=p.filter(v=>v.item.handle===E.item.handle)[0];b&&p.splice(p.indexOf(b),1,t)}addNodeToParentCache(d,t){t?(t.children||(t.children=[]),t.children.push(d)):(this.roots||(this.roots=[]),this.roots.push(d))}clearChildren(d){if(d){const t=this.nodes.get(d);if(t){if(t.children)for(const E of t.children){const c=this.elements.get(E.item.handle);c&&this.clear(c)}t.children=void 0}}else this.clearAll()}clear(d){const t=this.nodes.get(d);if(t){if(t.children)for(const E of t.children){const c=this.elements.get(E.item.handle);c&&this.clear(c)}this.nodes.delete(d),this.elements.delete(t.item.handle),t.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(d=>d.dispose()),this.nodes.clear()}dispose(){super.dispose(),this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}}),define(Pe[283],Te([1,0,5,6,2,34,8,63,4,7]),function(me,e,D,O,T,N,R,m,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class L extends O.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#h;#d;constructor(g,r,o,s){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#h=this._register(new D.Emitter),this.onDidDispose=this.#h.event,this.#d=this._register(new D.Emitter),this.onDidChangeViewState=this.#d.event,this.#e=g,this.#t=r,this.#n=o,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#l=s.active}dispose(){this.#u||(this.#u=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),this.#n}get viewType(){return this.assertNotDisposed(),this.#i}get title(){return this.assertNotDisposed(),this.#r}set title(g){this.assertNotDisposed(),this.#r!==g&&(this.#r=g,this.#t.$setTitle(this.#e,g))}get iconPath(){return this.assertNotDisposed(),this.#a}set iconPath(g){this.assertNotDisposed(),this.#a!==g&&(this.#a=g,this.#t.$setIconPath(this.#e,T.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return this.#s}get viewColumn(){if(this.assertNotDisposed(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.assertNotDisposed(),this.#l}get visible(){return this.assertNotDisposed(),this.#c}_updateViewState(g){this.#u||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(this.#l=g.active,this.#c=g.visible,this.#o=g.viewColumn,this.#d.fire({webviewPanel:this}))}reveal(g,r){this.assertNotDisposed(),this.#t.$reveal(this.#e,{viewColumn:typeof g>"u"?void 0:R.ViewColumn.from(g),preserveFocus:!!r})}assertNotDisposed(){if(this.#u)throw new Error("Webview is disposed")}}class _ extends O.Disposable{static newHandle(){return(0,N.generateUuid)()}constructor(g,r,o){super(),this.webviews=r,this.workspace=o,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=g.getProxy(h.MainContext.MainThreadWebviewPanels)}dispose(){super.dispose(),this._webviewPanels.forEach(g=>g.dispose()),this._webviewPanels.clear()}createWebviewPanel(g,r,o,s,n={}){const i=typeof s=="object"?s.viewColumn:s,a={viewColumn:R.ViewColumn.from(i),preserveFocus:typeof s=="object"&&!!s.preserveFocus},d=(0,m.shouldSerializeBuffersForPostMessage)(g),t=_.newHandle();this._proxy.$createWebviewPanel((0,m.toExtensionData)(g),t,r,{title:o,panelOptions:l(n),webviewOptions:(0,m.serializeWebviewOptions)(g,this.workspace,n),serializeBuffersForPostMessage:d},a);const E=this.webviews.createNewWebview(t,n,g);return this.createNewWebviewPanel(t,r,o,i,n,E,!0)}$onDidChangeWebviewPanelViewStates(g){const r=Object.keys(g);r.sort((o,s)=>{const n=g[o],i=g[s];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const o of r){const s=this.getWebviewPanel(o);if(!s)continue;const n=g[o];s._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this._webviewPanels.delete(g),this.webviews.deleteWebview(g)}registerWebviewPanelSerializer(g,r,o){if(this._serializers.has(r))throw new Error(`Serializer for '${r}' already registered`);return this._serializers.set(r,{serializer:o,extension:g}),this._proxy.$registerSerializer(r,{serializeBuffersForPostMessage:(0,m.shouldSerializeBuffersForPostMessage)(g)}),new y.Disposable(()=>{this._serializers.delete(r),this._proxy.$unregisterSerializer(r)})}async $deserializeWebviewPanel(g,r,o,s){const n=this._serializers.get(r);if(!n)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:a}=n,d=this.webviews.createNewWebview(g,o.webviewOptions,a),t=this.createNewWebviewPanel(g,r,o.title,s,o.panelOptions,d,o.active);await i.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(g,r,o,s,n,i,a){const d=new L(g,this._proxy,i,{viewType:r,title:o,viewColumn:s,panelOptions:n,active:a});return this._webviewPanels.set(g,d),d}getWebviewPanel(g){return this._webviewPanels.get(g)}}e.ExtHostWebviewPanels=_;function l(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}}),define(Pe[284],Te([1,0,5,6,63,8,4,7]),function(me,e,D,O,T,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class h extends O.Disposable{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(_,l,w,g,r,o){super(),this.#s=!1,this.#l=this._register(new D.Emitter),this.onDidChangeVisibility=this.#l.event,this.#u=this._register(new D.Emitter),this.onDidDispose=this.#u.event,this.#i=w,this.#a=g,this.#e=_,this.#t=l,this.#n=r,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.assertNotDisposed(),this.#a}set title(_){this.assertNotDisposed(),this.#a!==_&&(this.#a=_,this.#t.$setWebviewViewTitle(this.#e,_))}get description(){return this.assertNotDisposed(),this.#o}set description(_){this.assertNotDisposed(),this.#o!==_&&(this.#o=_,this.#t.$setWebviewViewDescription(this.#e,_))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(_){_===this.#r||this.#s||(this.#r=_,this.#l.fire())}get badge(){return this.assertNotDisposed(),this.#c}set badge(_){this.assertNotDisposed(),!(_?.value===this.#c?.value&&_?.tooltip===this.#c?.tooltip)&&(this.#c=N.ViewBadge.from(_),this.#t.$setWebviewViewBadge(this.#e,_))}show(_){this.assertNotDisposed(),this.#t.$show(this.#e,!!_)}assertNotDisposed(){if(this.#s)throw new Error("Webview is disposed")}}class y{constructor(_,l){this._extHostWebview=l,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=_.getProxy(R.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(_,l,w,g){if(this._viewProviders.has(l))throw new Error(`View provider for '${l}' already registered`);return this._viewProviders.set(l,{provider:w,extension:_}),this._proxy.$registerWebviewViewProvider((0,T.toExtensionData)(_),l,{retainContextWhenHidden:g?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(_)}),new m.Disposable(()=>{this._viewProviders.delete(l),this._proxy.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(_,l,w,g,r){const o=this._viewProviders.get(l);if(!o)throw new Error(`No view provider found for '${l}'`);const{provider:s,extension:n}=o,i=this._extHostWebview.createNewWebview(_,{},n),a=new h(_,this._proxy,l,w,i,!0);this._webviewViews.set(_,a),await s.resolveWebviewView(a,{state:g},r)}async $onDidChangeWebviewViewVisibility(_,l){this.getWebviewView(_)._setVisible(l)}async $disposeWebviewView(_){const l=this.getWebviewView(_);this._webviewViews.delete(_),l.dispose(),this._extHostWebview.deleteWebview(_)}getWebviewView(_){const l=this._webviewViews.get(_);if(!l)throw new Error("No webview found");return l}}e.ExtHostWebviewViews=y}),define(Pe[285],Te([1,0,5,30,33,3]),function(me,e,D,O,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=e.CONTEXT_ACTIVE_OUTPUT_LEVEL=e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=e.CONTEXT_ACTIVE_FILE_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new T.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_FILE_OUTPUT=new T.RawContextKey("activeLogOutput",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_SETTABLE=new T.RawContextKey("activeLogOutput.levelSettable",!1),e.CONTEXT_ACTIVE_OUTPUT_LEVEL=new T.RawContextKey("activeLogOutput.level",""),e.CONTEXT_ACTIVE_OUTPUT_LEVEL_IS_DEFAULT=new T.RawContextKey("activeLogOutput.levelIsDefault",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new T.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,N.createDecorator)("outputService");var R;(function(h){h[h.Append=1]="Append",h[h.Replace=2]="Replace",h[h.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.channels=new Map,this._onDidRegisterChannel=new D.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new D.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(y){this.channels.has(y.id)||(this.channels.set(y.id,y),this._onDidRegisterChannel.fire(y.id))}getChannels(){const y=[];return this.channels.forEach(L=>y.push(L)),y}getChannel(y){return this.channels.get(y)}removeChannel(y){this.channels.delete(y),this._onDidRemoveChannel.fire(y)}}O.Registry.add(e.Extensions.OutputChannels,new m),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new T.RawContextKey("activeOutputChannel","")}),define(Pe[116],Te([1,0,4,3,16,20,13,285,64,27,44,141,22,17,43,5,6]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class s extends R.AbstractMessageLogger{get disposed(){return this._disposed}constructor(d,t,E,c,p){super(),this.id=d,this.name=t,this.logger=E,this.proxy=c,this.extension=p,this.offset=0,this._disposed=!1,this.visible=!1,this.setLevel(E.getLevel()),this._register(E.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(d){this.append(d+`
`)}append(d){this.info(d)}clear(){const d=this.offset;this.logger.flush(),this.proxy.$update(this.id,m.OutputChannelUpdateMode.Clear,d)}replace(d){const t=this.offset;this.info(d),this.proxy.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.logger.flush()}show(d,t){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof d=="boolean"?d:t))}hide(){this.proxy.$close(this.id)}log(d,t){this.offset+=l.VSBuffer.fromString(t).byteLength,(0,R.log)(this.logger,d,t),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class n extends s{appendLine(d){this.append(d)}}let i=class{constructor(d,t,E,c,p,b){this.initData=t,this.extHostFileSystem=E,this.extHostFileSystemInfo=c,this.loggerService=p,this.logService=b,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=d.getProxy(D.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(t.logsLocation,`output_logging_${(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.visibleChannelId=d;for(const[t,E]of this.channels)E.visible=t===this.visibleChannelId}createOutputChannel(d,t,E){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,p=(0,w.isString)(t)?t:void 0;if((0,w.isString)(p)&&!p.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const v=this.initData.environment.extensionLogLevel?.find(([C])=>N.ExtensionIdentifier.equals(E.identifier,C))?.[1];v&&(b=(0,R.parseLogLevel)(v));const u=c?this.doCreateLogOutputChannel(d,b,E):this.doCreateOutputChannel(d,p,E);return u.then(C=>{this.channels.set(C.id,C),C.visible=C.id===this.visibleChannelId}),c?this.createExtHostLogOutputChannel(d,b??this.logService.getLevel(),u):this.createExtHostOutputChannel(d,u)}async doCreateOutputChannel(d,t,E){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const c=await this.outputDirectoryPromise,p=this.extHostFileSystemInfo.extUri.joinPath(c,`${this.namePool++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.loggerService.createLogger(p,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),v=await this.proxy.$register(d,p,t,E.identifier.value);return new s(v,d,b,this.proxy,E)}async doCreateLogOutputChannel(d,t,E){const c=await this.createExtensionLogDirectory(E),p=d.replace(/[\\/:\*\?"<>\|]/g,""),b=this.extHostFileSystemInfo.extUri.joinPath(c,`${p}.log`),v=`${E.identifier.value}.${p}`,u=this.loggerService.createLogger(b,{id:v,name:d,logLevel:t,extensionId:E.identifier.value});return new n(v,d,u,this.proxy,E)}createExtensionLogDirectory(d){let t=this.extensionLogDirectoryPromise.get(d.identifier.value);if(!t){const E=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,d.identifier.value);this.extensionLogDirectoryPromise.set(d.identifier.value,t=(async()=>{try{await this.extHostFileSystem.value.createDirectory(E)}catch(c){if((0,g.toFileSystemProviderErrorCode)(c)!==g.FileSystemProviderErrorCode.FileExists)throw c}return E})())}return t}createExtHostOutputChannel(d,t){let E=!1;const c=()=>{if(E)throw new Error("Channel has been closed")};return{get name(){return d},append(p){c(),t.then(b=>b.append(p))},appendLine(p){c(),t.then(b=>b.appendLine(p))},clear(){c(),t.then(p=>p.clear())},replace(p){c(),t.then(b=>b.replace(p))},show(p,b){c(),t.then(v=>v.show(p,b))},hide(){c(),t.then(p=>p.hide())},dispose(){E=!0,t.then(p=>p.dispose())}}}createExtHostLogOutputChannel(d,t,E){const c=new o.DisposableStore,p=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},b=c.add(new r.Emitter);function v(u){t=u,b.fire(u)}return E.then(u=>{c.add(u),u.logLevel!==t&&v(u.logLevel),c.add(u.onDidChangeLogLevel(C=>v(C)))}),{...this.createExtHostOutputChannel(d,E),get logLevel(){return t},onDidChangeLogLevel:b.event,trace(u,...C){p(),E.then(f=>f.trace(u,...C))},debug(u,...C){p(),E.then(f=>f.debug(u,...C))},info(u,...C){p(),E.then(f=>f.info(u,...C))},warn(u,...C){p(),E.then(f=>f.warn(u,...C))},error(u,...C){p(),E.then(f=>f.error(u,...C))},dispose(){c.dispose()}}}};e.ExtHostOutputService=i,e.ExtHostOutputService=i=Ke([He(0,T.IExtHostRpcService),He(1,y.IExtHostInitDataService),He(2,h.IExtHostConsumerFileSystem),He(3,L.IExtHostFileSystemInfo),He(4,R.ILoggerService),He(5,R.ILogService)],i),e.IExtHostOutputService=(0,O.createDecorator)("IExtHostOutputService")}),define(Pe[117],Te([1,0,3,11]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,D.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(T){let N=1/0;for(let m=0;m<this.maxSampleCount;m++){const h=await T.getRoundTripTime();if(h===void 0)return;N=Math.min(N,h/2),await(0,O.timeout)(this.sampleDelay)}this.average.push(N),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(N):R=this.initial.reduce((m,h)=>m+h,0)/this.initial.length,this.lastMeasurement={initial:R,current:N,average:this.average.reduce((m,h)=>m+h,0)/this.average.length,high:typeof R>"u"?!1:N>this.highLatencyMaxThreshold||N>this.highLatencyMinThreshold&&N>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Pe[286],Te([1,0,176,57,30,48,47,6,5,117,21,26,11]),function(me,e,D,O,T,N,R,m,h,y,L,_,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DynamicWorkbenchSecurityConfiguration=e.ConfigurationMigrationWorkbenchContribution=e.Extensions=e.problemsConfigurationNodeBase=e.securityConfigurationNodeBase=e.workbenchConfigurationNodeBase=e.applicationConfigurationNodeBase=void 0,e.applicationConfigurationNodeBase=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.workbenchConfigurationNodeBase=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.securityConfigurationNodeBase=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.problemsConfigurationNodeBase=Object.freeze({id:"problems",title:(0,D.localize)(3,null),type:"object",order:101}),e.Extensions={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this._onDidRegisterConfigurationMigrations=new h.Emitter,this.onDidRegisterConfigurationMigration=this._onDidRegisterConfigurationMigrations.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const g=new w;T.Registry.add(e.Extensions.ConfigurationMigration,g);let r=class extends m.Disposable{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.configurationService=n,this.workspaceService=i,this._register(this.workspaceService.onDidChangeWorkspaceFolders(async a=>{for(const d of a.added)await this.migrateConfigurationsForFolder(d,g.migrations)})),this.migrateConfigurations(g.migrations),this._register(g.onDidRegisterConfigurationMigration(a=>this.migrateConfigurations(a)))}async migrateConfigurations(n){await this.migrateConfigurationsForFolder(void 0,n);for(const i of this.workspaceService.getWorkspace().folders)await this.migrateConfigurationsForFolder(i,n)}async migrateConfigurationsForFolder(n,i){await Promise.all([i.map(a=>this.migrateConfigurationsForFolderAndOverride(a,n?.uri))])}async migrateConfigurationsForFolderAndOverride(n,i){const a=this.configurationService.inspect(n.key,{resource:i}),d=this.workspaceService.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,E]of d){const c=a[t];if(!c)continue;const p=[];if(c.value!==void 0){const b=await this.runMigration(n,t,c.value,i,void 0);for(const v of b??[])p.push([v,[]])}for(const{identifiers:b,value:v}of c.overrides??[])if(v!==void 0){const u=await this.runMigration(n,t,v,i,b);for(const C of u??[])p.push([C,b])}p.length&&await Promise.allSettled(p.map(async([[b,v],u])=>this.configurationService.updateValue(b,v.value,{resource:i,overrideIdentifiers:u},E)))}}async runMigration(n,i,a,d,t){const E=p=>{const v=this.configurationService.inspect(p,{resource:d})[i];if(v)return t?v.overrides?.find(({identifiers:u})=>(0,_.equals)(u,t))?.value:v.value},c=await n.migrateFn(a,E);return Array.isArray(c)?c:[[n.key,c]]}};e.ConfigurationMigrationWorkbenchContribution=r,e.ConfigurationMigrationWorkbenchContribution=r=Ke([He(0,R.IConfigurationService),He(1,N.IWorkspaceContextService)],r);let o=class extends m.Disposable{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.remoteAgentService=n,this._ready=new l.DeferredPromise,this.ready=this._ready.p,this.create()}async create(){try{await this.doCreate()}finally{this._ready.complete()}}async doCreate(){if(!L.isWindows&&(await this.remoteAgentService.getEnvironment())?.os!==1)return;T.Registry.as(O.Extensions.Configuration).registerConfiguration({...e.securityConfigurationNodeBase,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(4,null)},default:[],markdownDescription:(0,D.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(6,null),scope:2}}})}};e.DynamicWorkbenchSecurityConfiguration=o,e.DynamicWorkbenchSecurityConfiguration=o=Ke([He(0,y.IRemoteAgentService)],o)}),define(Pe[287],Te([1,0,35,12,19,23,184,286,57,3,30]),function(me,e,D,O,T,N,R,m,h,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.editorsAssociationsSettingId=e.IEditorResolverService=void 0,e.priorityToRank=r,e.globMatchesResource=o,e.IEditorResolverService=(0,y.createDecorator)("editorResolverService"),e.editorsAssociationsSettingId="workbench.editorAssociations";const _=L.Registry.as(h.Extensions.Configuration),l={...m.workbenchConfigurationNodeBase,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};_.registerConfiguration(l);var w;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(w||(e.RegisteredEditorPriority=w={}));var g;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(g||(e.ResolvedStatus=g={}));function r(s){switch(s){case w.exclusive:return 5;case w.default:return 4;case w.builtin:return 3;case w.option:default:return 1}}function o(s,n){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(n.scheme))return!1;const d=typeof s=="string"&&s.indexOf(T.posix.sep)>=0?`${n.scheme}:${n.path}`:(0,N.basename)(n);return D.match(typeof s=="string"?s.toLowerCase():s,d.toLowerCase())}}),define(Pe[288],Te([1,0,46,12,19,21,23,2,3,205,48,224,117]),function(me,e,D,O,T,N,R,m,h,y,L,_,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,h.createDecorator)("pathService");let g=w=class{constructor(o,s,n,i){this.localUserHome=o,this.remoteAgentService=s,this.environmentService=n,this.contextService=i,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||N.OS)(),this.resolveUserHome=(async()=>{const a=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=a?.userHome??o})()}hasValidBasename(o,s,n){return typeof s=="string"||typeof s>"u"?this.resolveOS.then(i=>this.doHasValidBasename(o,i,s)):this.doHasValidBasename(o,s,n)}doHasValidBasename(o,s,n){return o.scheme===O.Schemas.file||o.scheme===O.Schemas.vscodeRemote?(0,D.isValidBasename)(n??(0,R.basename)(o),s===1):!0}get defaultUriScheme(){return w.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return O.Schemas.vscodeRemote;const n=(0,y.getVirtualWorkspaceScheme)(s.getWorkspace());if(n)return n;const i=s.getWorkspace().folders[0];if(i)return i.uri.scheme;const a=s.getWorkspace().configuration;return a?a.scheme:O.Schemas.file}userHome(o){return o?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(o=>o===1?T.win32:T.posix)}async fileURI(o){let s="";if(await this.resolveOS===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const i=o.indexOf("/",2);i===-1?(s=o.substring(2),o="/"):(s=o.substring(2,i),o=o.substring(i)||"/")}return m.URI.from({scheme:O.Schemas.file,authority:s,path:o,query:"",fragment:""})}};e.AbstractPathService=g,e.AbstractPathService=g=w=Ke([He(1,l.IRemoteAgentService),He(2,_.IWorkbenchEnvironmentService),He(3,L.IWorkspaceContextService)],g)}),define(Pe[118],Te([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class D{constructor(R,m){this.line=R,this.character=m}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,m){return new D(0,0)}with(R){return new D(0,0)}}e.Position=D;class O{constructor(R,m,h,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(R,m),this.end=new D(h,y)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new O(0,0,0,0)}with(R){return new O(0,0,0,0)}}e.Range=O;var T;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(T||(e.TextSearchCompleteMessageType=T={}))}),define(Pe[45],Te([1,0,18,35,26,46,15,3,19,14,118,11]),function(me,e,D,O,T,N,R,m,h,y,L,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.SerializableFileMatch=e.SearchError=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.SEARCH_RESULT_LANGUAGE_ID=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,e.resultIsMatch=s,e.isFileMatch=n,e.isProgressMessage=i,e.getExcludes=u,e.pathIncludedInQuery=C,e.deserializeSearchError=S,e.serializeSearchError=P,e.isSerializedSearchComplete=k,e.isSerializedSearchSuccess=H,e.isSerializedFileMatch=$,e.isFilePatternMatch=V,e.resolvePatternsForProvider=U,e.hasSiblingPromiseFn=fe,e.hasSiblingFn=Ce,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_RESULT_LANGUAGE_ID="search-result",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const l="\u27EA ",w=" characters skipped \u27EB",g=(l.length+w.length+5)*2;e.ISearchService=(0,m.createDecorator)("searchService");var r;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text",oe[oe.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text",oe[oe.aiText=3]="aiText"})(o||(e.QueryType=o={}));function s(oe){return!!oe.preview}function n(oe){return!!oe.resource}function i(oe){return!!oe.message}var a;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class d{constructor(pe){this.resource=pe,this.results=[]}}e.FileMatch=d;class t{constructor(pe,ne,Ie,xe){this.ranges=ne,this.webviewIndex=xe;const re=Array.isArray(ne)?ne:[ne];if(Ie&&Ie.matchLines===1&&E(re)){pe=(0,R.getNLines)(pe,Ie.matchLines);let F="",Z=0,be=0;const Le=Math.floor(Ie.charsPerLine/5),Se=[];for(const ve of re){const he=Math.max(ve.startColumn-Le,0),K=ve.startColumn+Ie.charsPerLine;if(he>be+Le+g){const Y=l+(he-be)+w;F+=Y+pe.slice(he,K),Z+=he-(be+Y.length)}else F+=pe.slice(be,K);Se.push(new p(0,ve.startColumn-Z,ve.endColumn-Z)),be=K}this.preview={text:F,matches:Array.isArray(this.ranges)?Se:Se[0]}}else{const F=Array.isArray(ne)?ne[0].startLineNumber:ne.startLineNumber;this.preview={text:pe,matches:(0,D.mapArrayOrNot)(ne,Z=>new c(Z.startLineNumber-F,Z.startColumn,Z.endLineNumber-F,Z.endColumn))}}}}e.TextSearchMatch=t;function E(oe){const pe=oe[0].startLineNumber;for(const ne of oe)if(ne.startLineNumber!==pe||ne.endLineNumber!==pe)return!1;return!0}class c{constructor(pe,ne,Ie,xe){this.startLineNumber=pe,this.startColumn=ne,this.endLineNumber=Ie,this.endColumn=xe}}e.SearchRange=c;class p extends c{constructor(pe,ne,Ie){super(pe,ne,pe,Ie)}}e.OneLineRange=p;var b;(function(oe){oe.List="list",oe.Tree="tree"})(b||(e.ViewMode=b={}));var v;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(v||(e.SearchSortOrder=v={}));function u(oe,pe=!0){const ne=oe&&oe.files&&oe.files.exclude,Ie=pe&&oe&&oe.search&&oe.search.exclude;if(!ne&&!Ie)return;if(!ne||!Ie)return ne||Ie;let xe=Object.create(null);return xe=T.mixin(xe,T.deepClone(ne)),xe=T.mixin(xe,T.deepClone(Ie),!0),xe}function C(oe,pe){return oe.excludePattern&&O.match(oe.excludePattern,pe)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&O.match(oe.includePattern,pe)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(ne=>{const Ie=ne.folder.fsPath;if(N.isEqualOrParent(pe,Ie)){const xe=h.relative(Ie,pe);return!ne.includePattern||!!O.match(ne.includePattern,xe)}else return!1}):!1:!0}var f;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(f||(e.SearchErrorCode=f={}));class I extends Error{constructor(pe,ne){super(pe),this.code=ne}}e.SearchError=I;function S(oe){const pe=oe.message;if((0,y.isCancellationError)(oe))return new I(pe,f.canceled);try{const ne=JSON.parse(pe);return new I(ne.message,ne.code)}catch{return new I(pe,f.other)}}function P(oe){const pe={message:oe.message,code:oe.code};return new Error(JSON.stringify(pe))}function k(oe){return oe.type==="error"?!0:oe.type==="success"}function H(oe){return oe.type==="success"}function $(oe){return!!oe.path}function V(oe,pe,ne=!0){const Ie=oe.searchPath?oe.searchPath:oe.relativePath;return ne?(0,R.fuzzyContains)(Ie,pe):O.match(pe,Ie)}class A{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=A;function U(oe,pe){const ne={...oe||{},...pe||{}};return Object.keys(ne).filter(Ie=>{const xe=ne[Ie];return typeof xe=="boolean"&&xe})}class j{constructor(pe,ne){this._parsedIncludeExpression=null,this._excludeExpression={...pe.excludePattern||{},...ne.excludePattern||{}},this._parsedExcludeExpression=O.parse(this._excludeExpression);let Ie=pe.includePattern;ne.includePattern&&(Ie?Ie={...Ie,...ne.includePattern}:Ie=ne.includePattern),Ie&&(this._parsedIncludeExpression=O.parse(Ie))}matchesExcludesSync(pe,ne,Ie){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(pe,ne,Ie))}includedInQuerySync(pe,ne,Ie){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(pe,ne,Ie)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(pe,ne,Ie))}includedInQuery(pe,ne,Ie){const xe=this._parsedExcludeExpression(pe,ne,Ie),re=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(pe,ne,Ie):!0;return(0,_.isThenable)(xe)?xe.then(F=>F?!1:re()):re()}hasSiblingExcludeClauses(){return ie(this._excludeExpression)}}e.QueryGlobTester=j;function ie(oe){for(const pe in oe)if(typeof oe[pe]!="boolean")return!0;return!1}function fe(oe){if(!oe)return;let pe;return ne=>(pe||(pe=(oe()||Promise.resolve([])).then(Ie=>Ie?_e(Ie):{})),pe.then(Ie=>!!Ie[ne]))}function Ce(oe){if(!oe)return;let pe;return ne=>{if(!pe){const Ie=oe();pe=Ie?_e(Ie):{}}return!!pe[ne]}}function _e(oe){const pe={};for(const ne of oe)pe[ne]=!0;return pe}}),define(Pe[36],Te([1,0,18,11,24,5,6,52,12,126,23,15,2,175,3,13,194,48,44,27,16,8,7,60,45,4,53]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o,s,n,i,a,d,t,E,c,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function v(H,$,V){return new L.ExtUri(A=>I(A,V)).isEqual(H,$)}function u(H,$,V){return v(H.uri,$.uri,V)?0:(0,_.compare)(H.uri.toString(),$.uri.toString())}function C(H,$,V){return H.index!==$.index?H.index<$.index?-1:1:v(H.uri,$.uri,V)?(0,_.compare)(H.name,$.name):(0,_.compare)(H.uri.toString(),$.uri.toString())}function f(H,$,V,A){const U=H.slice(0).sort((ie,fe)=>V(ie,fe,A)),j=$.slice(0).sort((ie,fe)=>V(ie,fe,A));return(0,D.delta)(U,j,(ie,fe)=>V(ie,fe,A))}function I(H,$){const V=$.getCapabilities(H.scheme);return!(V&&V&1024)}class S extends s.Workspace{static toExtHostWorkspace($,V,A,U){if(!$)return{workspace:null,added:[],removed:[]};const{id:j,name:ie,folders:fe,configuration:Ce,transient:_e,isUntitled:oe}=$,pe=[],ne=V;V?fe.forEach((F,Z)=>{const be=l.URI.revive(F.uri),Le=S._findFolder(A||V,be,U);Le?(Le.name=F.name,Le.index=F.index,pe.push(Le)):pe.push({uri:be,name:F.name,index:Z})}):pe.push(...fe.map(({uri:F,name:Z,index:be})=>({uri:l.URI.revive(F),name:Z,index:be}))),pe.sort((F,Z)=>F.index<Z.index?-1:1);const Ie=new S(j,ie,pe,!!_e,Ce?l.URI.revive(Ce):null,!!oe,F=>I(F,U)),{added:xe,removed:re}=f(ne?ne.workspaceFolders:[],Ie.workspaceFolders,u,U);return{workspace:Ie,added:xe,removed:re}}static _findFolder($,V,A){for(let U=0;U<$.folders.length;U++){const j=$.workspaceFolders[U];if(v(j.uri,V,A))return j}}constructor($,V,A,U,j,ie,fe){super($,A.map(Ce=>new s.WorkspaceFolder(Ce)),U,j,fe),this._name=V,this._isUntitled=ie,this._workspaceFolders=[],this._structure=m.TernarySearchTree.forUris(fe),A.forEach(Ce=>{this._workspaceFolders.push(Ce),this._structure.set(Ce.uri,Ce)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder($,V){return V&&this._structure.get($)&&($=(0,L.dirname)($)),this._structure.findSubstr($)}resolveWorkspaceFolder($){return this._structure.get($)}}let P=class{constructor($,V,A,U,j){this._onDidChangeWorkspace=new N.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new N.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._onWillCreateEditSessionIdentityEvent=new N.AsyncEmitter,this._canonicalUriProviders=new Map,this._logService=U,this._extHostFileSystemInfo=A,this._uriTransformerService=j,this._requestIdProvider=new y.Counter,this._barrier=new O.Barrier,this._proxy=$.getProxy(p.MainContext.MainThreadWorkspace),this._messageService=$.getProxy(p.MainContext.MainThreadMessageService);const ie=V.workspace;this._confirmedWorkspace=ie?new S(ie.id,ie.name,[],!!ie.transient,ie.configuration?l.URI.revive(ie.configuration):null,!!ie.isUntitled,fe=>I(fe,A)):void 0}$initializeWorkspace($,V){this._trusted=V,this.$acceptWorkspaceData($),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:h.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders($,V,A,...U){const j=[];if(Array.isArray(U)&&U.forEach(oe=>{l.URI.isUri(oe.uri)&&!j.some(pe=>v(pe.uri,oe.uri,this._extHostFileSystemInfo))&&j.push({uri:oe.uri,name:oe.name||(0,L.basenameOrAuthority)(oe.uri)})}),this._unconfirmedWorkspace||[V,A].some(oe=>typeof oe!="number"||oe<0)||A===0&&j.length===0)return!1;const ie=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(V+A>ie.length)return!1;const fe=ie.slice(0);fe.splice(V,A,...j.map(oe=>({uri:oe.uri,name:oe.name||(0,L.basenameOrAuthority)(oe.uri),index:void 0})));for(let oe=0;oe<fe.length;oe++){const pe=fe[oe];if(fe.some((ne,Ie)=>Ie!==oe&&v(pe.uri,ne.uri,this._extHostFileSystemInfo)))return!1}fe.forEach((oe,pe)=>oe.index=pe);const{added:Ce,removed:_e}=f(ie,fe,C,this._extHostFileSystemInfo);if(Ce.length===0&&_e.length===0)return!1;if(this._proxy){const oe=$.displayName||$.name;this._proxy.$updateWorkspaceFolders(oe,V,A,j).then(void 0,pe=>{this._unconfirmedWorkspace=void 0;const ne={source:{identifier:$.identifier,label:$.displayName||$.name}};this._messageService.$showMessage(o.Severity.Error,(0,w.localize)(0,null,oe,pe.toString()),ne,[])})}return this.trySetWorkspaceFolders(fe),!0}getWorkspaceFolder($,V){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,V)}async getWorkspaceFolder2($,V){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,V)}async resolveWorkspaceFolder($){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder($)}getPath(){if(!this._actualWorkspace)return;const{folders:$}=this._actualWorkspace;if($.length!==0)return $[0].uri.fsPath}getRelativePath($,V){let A,U="";if(typeof $=="string"?(A=l.URI.file($),U=$):typeof $<"u"&&(A=$,U=$.fsPath),!A)return U;const j=this.getWorkspaceFolder(A,!0);if(!j)return U;typeof V>"u"&&this._actualWorkspace&&(V=this._actualWorkspace.folders.length>1);let ie=(0,L.relativePath)(j.uri,A);return V&&j.name&&(ie=`${j.name}/${ie}`),ie}trySetWorkspaceFolders($){this._actualWorkspace&&(this._unconfirmedWorkspace=S.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:$,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData($){const{workspace:V,added:A,removed:U}=S.toExtHostWorkspace($,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=V||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:A,removed:U}))}findFiles($,V,A,U,j=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let ie="",fe=!0;return V===null?fe=!1:V!==void 0&&(typeof V=="string"?ie=V:ie=V.pattern),this._findFilesImpl($,void 0,{exclude:ie,maxResults:A,useDefaultExcludes:fe,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},j)}findFiles2($,V={},A,U=T.CancellationToken.None){return this._logService.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${A.value}, entryPoint: findFiles2`),this._findFilesImpl(void 0,$,V,U)}async _findFilesImpl($,V,A,U=T.CancellationToken.None){if(U&&U.isCancellationRequested)return Promise.resolve([]);const j=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,ie={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof A.useDefaultSearchExcludes=="boolean"?!A.useDefaultSearchExcludes:!1,maxResults:A.maxResults,excludePattern:j,shouldGlobSearch:typeof A.fuzzy=="boolean"?!A.fuzzy:!0,_reason:"startFileSearch"};let fe;if($){const{includePattern:Ce,folder:_e}=k(d.GlobPattern.from($));fe=_e,ie.includePattern=Ce}else{const{includePattern:Ce,folder:_e}=k(d.GlobPattern.from(V));fe=_e,ie.filePattern=Ce}return this._proxy.$startFileSearch(fe??null,ie,U).then(Ce=>Array.isArray(Ce)?Ce.map(_e=>l.URI.revive(_e)):[])}async findTextInFiles($,V,A,U,j=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const ie=this._requestIdProvider.getNext(),fe=typeof V.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:V.previewOptions,{includePattern:Ce,folder:_e}=k(d.GlobPattern.from(V.include)),oe=typeof V.exclude=="string"?V.exclude:V.exclude?V.exclude.pattern:void 0,pe={ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles=="boolean"?!V.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof V.useGlobalIgnoreFiles=="boolean"?!V.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof V.useParentIgnoreFiles=="boolean"?!V.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof V.useDefaultExcludes=="boolean"?!V.useDefaultExcludes:!0,fileEncoding:V.encoding,maxResults:V.maxResults,previewOptions:fe,afterContext:V.afterContext,beforeContext:V.beforeContext,includePattern:Ce,excludePattern:oe},ne=!1;if(this._activeSearchCallbacks[ie]=Ie=>{if(ne)return;const xe=l.URI.revive(Ie.resource);Ie.results.forEach(re=>{const F=(0,b.revive)(re);(0,c.resultIsMatch)(F)?A({uri:xe,preview:{text:F.preview.text,matches:(0,D.mapArrayOrNot)(F.preview.matches,Z=>new t.Range(Z.startLineNumber,Z.startColumn,Z.endLineNumber,Z.endColumn))},ranges:(0,D.mapArrayOrNot)(F.ranges,Z=>new t.Range(Z.startLineNumber,Z.startColumn,Z.endLineNumber,Z.endColumn))}):A({uri:xe,text:F.text,lineNumber:F.lineNumber})})},j.isCancellationRequested)return{};try{const Ie=await this._proxy.$startTextSearch($,_e??null,pe,ie,j);return delete this._activeSearchCallbacks[ie],Ie||{}}catch(Ie){throw delete this._activeSearchCallbacks[ie],Ie}}$handleTextSearchResult($,V){this._activeSearchCallbacks[V]?.($)}async save($){const V=await this._proxy.$save($,{saveAs:!1});return l.URI.revive(V)}async saveAs($){const V=await this._proxy.$save($,{saveAs:!0});return l.URI.revive(V)}saveAll($){return this._proxy.$saveAll($)}resolveProxy($){return this._proxy.$resolveProxy($)}loadCertificates(){return this._proxy.$loadCertificates()}get trusted(){return this._trusted}requestWorkspaceTrust($){return this._proxy.$requestWorkspaceTrust($)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider($,V){if(this._editSessionIdentityProviders.has($))throw new Error(`A provider has already been registered for scheme ${$}`);this._editSessionIdentityProviders.set($,V);const A=this._uriTransformerService.transformOutgoingScheme($),U=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(U,A),(0,R.toDisposable)(()=>{this._editSessionIdentityProviders.delete($),this._proxy.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier($,V){this._logService.info("Getting edit session identifier for workspaceFolder",$);const A=await this.resolveWorkspaceFolder(l.URI.revive($));if(!A){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",A);const U=this._editSessionIdentityProviders.get(A.uri.scheme);if(this._logService.info(`Provider for scheme ${A.uri.scheme} is defined: `,!!U),!U)return;const j=await U.provideEditSessionIdentity(A,V);if(this._logService.info("Provider returned edit session identifier: ",j),!!j)return j}async $provideEditSessionIdentityMatch($,V,A,U){this._logService.info("Getting edit session identifier for workspaceFolder",$);const j=await this.resolveWorkspaceFolder(l.URI.revive($));if(!j){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const ie=this._editSessionIdentityProviders.get(j.uri.scheme);if(this._logService.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!ie),!ie)return;const fe=await ie.provideEditSessionIdentityMatch?.(V,A,U);if(this._logService.info("Provider returned edit session identifier match result: ",fe),!!fe)return fe}getOnWillCreateEditSessionIdentityEvent($){return(V,A,U)=>{const j=function(fe){V.call(A,fe)};return j.extension=$,this._onWillCreateEditSessionIdentityEvent.event(j,void 0,U)}}async $onWillCreateEditSessionIdentity($,V,A){const U=await this.resolveWorkspaceFolder(l.URI.revive($));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this._onWillCreateEditSessionIdentityEvent.fireAsync({workspaceFolder:U},V,async(j,ie)=>{const fe=Date.now();await Promise.resolve(j),Date.now()-fe>A&&this._logService.warn("SLOW edit session create-participant",ie.extension.identifier)}),V.isCancellationRequested}registerCanonicalUriProvider($,V){if(this._canonicalUriProviders.has($))throw new Error(`A provider has already been registered for scheme ${$}`);this._canonicalUriProviders.set($,V);const A=this._uriTransformerService.transformOutgoingScheme($),U=this._providerHandlePool++;return this._proxy.$registerCanonicalUriProvider(U,A),(0,R.toDisposable)(()=>{this._canonicalUriProviders.delete($),this._proxy.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri($,V,A){const U=this._canonicalUriProviders.get($.scheme);if(!U)return;const j=await U.provideCanonicalUri?.(l.URI.revive($),V,A);if(j)return j}async $provideCanonicalUri($,V,A){return this.provideCanonicalUri(l.URI.revive($),{targetScheme:V},A)}};e.ExtHostWorkspace=P,e.ExtHostWorkspace=P=Ke([He(0,a.IExtHostRpcService),He(1,i.IExtHostInitDataService),He(2,n.IExtHostFileSystemInfo),He(3,r.ILogService),He(4,E.IURITransformerService)],P),e.IExtHostWorkspace=(0,g.createDecorator)("IExtHostWorkspace");function k(H){let $,V;return H&&(typeof H=="string"?$=H:($=H.pattern,V=l.URI.revive(H.baseUri))),{includePattern:$,folder:V}}}),define(Pe[37],Te([1,0,26,5,36,4,7,196,57,17,11,3,16,13,2]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function r(E,c){if(c){const p=c.split(".");let b=E;for(let v=0;b&&v<p.length;v++)b=b[p[v]];return b}}function o(E){return E instanceof g.URI}function s(E){return E&&E.uri instanceof g.URI&&E.languageId&&typeof E.languageId=="string"}function n(E){return E&&!E.uri&&E.languageId&&typeof E.languageId=="string"}function i(E){return E&&E.uri instanceof g.URI&&(!E.name||typeof E.name=="string")&&(!E.index||typeof E.index=="number")}function a(E){if(o(E))return{resource:E};if(s(E))return{resource:E.uri,overrideIdentifier:E.languageId};if(n(E))return{overrideIdentifier:E.languageId};if(i(E))return{resource:E.uri};if(E===null)return{resource:null}}let d=class{constructor(c,p,b){this._proxy=c.getProxy(N.MainContext.MainThreadConfiguration),this._extHostWorkspace=p,this._logService=b,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(c=>this._actual)}$initializeConfiguration(c){this._actual=new t(this._proxy,this._extHostWorkspace,c,this._logService),this._barrier.open()}$acceptConfigurationChanged(c,p){this.getConfigProvider().then(b=>b.$acceptConfigurationChanged(c,p))}};e.ExtHostConfiguration=d,e.ExtHostConfiguration=d=Ke([He(0,l.IExtHostRpcService),He(1,T.IExtHostWorkspace),He(2,w.ILogService)],d);class t{constructor(c,p,b,v){this._onDidChangeConfiguration=new O.Emitter,this._proxy=c,this._logService=v,this._extHostWorkspace=p,this._configuration=m.Configuration.parse(b),this._configurationScopes=this._toMap(b.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(c,p){const b={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=m.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(p,b))}getConfiguration(c,p,b){const v=a(p)||{},u=this._toReadonlyValue(c?r(this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace),c):this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace));c&&this._validateConfigurationAccess(c,v,b?.identifier);function C(I){if(I==null)return null;if(typeof I=="boolean")return I?2:5;switch(I){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(I){return typeof r(u,I)<"u"},get:(I,S)=>{this._validateConfigurationAccess(c?`${c}.${I}`:I,v,b?.identifier);let P=r(u,I);if(typeof P>"u")P=S;else{let k;const H=($,V)=>{if((0,y.isObject)($)){let A;const U=()=>{k=k||(0,D.deepClone)(u),A=A||r(k,V)};return new Proxy($,{get:(j,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return U(),()=>A;if(k)return A=A||r(k,V),A[ie];const fe=j[ie];return typeof ie=="string"?H(fe,`${V}.${ie}`):fe},set:(j,ie,fe)=>(U(),A&&(A[ie]=fe),!0),deleteProperty:(j,ie)=>(U(),A&&delete A[ie],!0),defineProperty:(j,ie,fe)=>(U(),A&&Object.defineProperty(A,ie,fe),!0)})}return Array.isArray($)?(0,D.deepClone)($):$};P=H(P,I)}return P},update:(I,S,P,k)=>{I=c?`${c}.${I}`:I;const H=C(P);return S!==void 0?this._proxy.$updateConfigurationOption(H,I,S,v,k):this._proxy.$removeConfigurationOption(H,I,v,k)},inspect:I=>{I=c?`${c}.${I}`:I;const S=this._configuration.inspect(I,v,this._extHostWorkspace.workspace);if(S)return{key:I,defaultValue:(0,D.deepClone)(S.policy?.value??S.default?.value),globalValue:(0,D.deepClone)(S.user?.value??S.application?.value),workspaceValue:(0,D.deepClone)(S.workspace?.value),workspaceFolderValue:(0,D.deepClone)(S.workspaceFolder?.value),defaultLanguageValue:(0,D.deepClone)(S.default?.override),globalLanguageValue:(0,D.deepClone)(S.user?.override??S.application?.override),workspaceLanguageValue:(0,D.deepClone)(S.workspace?.override),workspaceFolderLanguageValue:(0,D.deepClone)(S.workspaceFolder?.override),languageIds:(0,D.deepClone)(S.overrideIdentifiers)}}};return typeof u=="object"&&(0,D.mixin)(f,u,!1),Object.freeze(f)}_toReadonlyValue(c){const p=b=>(0,y.isObject)(b)?new Proxy(b,{get:(v,u)=>p(v[u]),set:(v,u,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(u)}' of object`)},deleteProperty:(v,u)=>{throw new Error(`TypeError: Cannot delete read only property '${String(u)}' of object`)},defineProperty:(v,u)=>{throw new Error(`TypeError: Cannot define property '${String(u)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):b;return p(c)}_validateConfigurationAccess(c,p,b){const v=h.OVERRIDE_PROPERTY_REGEX.test(c)?4:this._configurationScopes.get(c),u=b?`[${b.value}] `:"";if(v===4){typeof p?.resource>"u"&&this._logService.warn(`${u}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){p?.resource&&this._logService.warn(`${u}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(c,p){const b=new m.ConfigurationChangeEvent(c,p,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(v,u)=>b.affectsConfiguration(v,a(u))})}_toMap(c){return c.reduce((p,b)=>(p.set(b[0],b[1]),p),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")}),define(Pe[119],Te([1,0,2,11,5,4,7,36,67,37,24,51,16,27,3,12,21,13,78,229,14]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var d;(function(H){function $(A){if(A!=null)return A}H.from=$;function V(A){if(A!=null)return A}H.to=V})(d||(d={}));var t;(function(H){function $(A){if(A!=null)return A}H.from=$;function V(A){if(A!=null)return A}H.to=V})(t||(t={}));var E;(function(H){function $(A){if(A!=null)return A}H.from=$;function V(A){if(A!=null)return A}H.to=V})(E||(E={}));var c;(function(H){function $(U){if(U){const j=U;return j&&!!j.process}else return!1}H.is=$;function V(U){if(U==null)return;const j={process:U.process,args:U.args};return U.options&&(j.options=E.from(U.options)),j}H.from=V;function A(U){if(U!=null)return new R.ProcessExecution(U.process,U.args,U.options)}H.to=A})(c||(c={}));var p;(function(H){function $(A){if(A!=null)return A}H.from=$;function V(A){if(A!=null)return A}H.to=V})(p||(p={}));var b;(function(H){function $(U){if(U){const j=U;return j&&(!!j.commandLine||!!j.command)}else return!1}H.is=$;function V(U){if(U==null)return;const j={};return U.commandLine!==void 0?j.commandLine=U.commandLine:(j.command=U.command,j.args=U.args),U.options&&(j.options=p.from(U.options)),j}H.from=V;function A(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new R.ShellExecution(U.commandLine,U.options):new R.ShellExecution(U.command,U.args?U.args:[],U.options)}H.to=A})(b||(b={}));var v;(function(H){function $(U){if(U){const j=U;return j&&j.customExecution==="customExecution"}else return!1}H.is=$;function V(U){return{customExecution:"customExecution"}}H.from=V;function A(U,j){return j.get(U)}H.to=A})(v||(e.CustomExecutionDTO=v={}));var u;(function(H){function $(V,A){let U;return V.scope!==void 0&&typeof V.scope!="number"?U=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===R.TaskScope.Workspace&&A&&A.workspaceFile?U=A.workspaceFile:U=i.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:U}}H.from=$})(u||(e.TaskHandleDTO=u={}));var C;(function(H){function $(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}H.from=$})(C||(C={}));var f;(function(H){function $(U,j){if(U==null)return[];const ie=[];for(const fe of U){const Ce=V(fe,j);Ce&&ie.push(Ce)}return ie}H.fromMany=$;function V(U,j){if(U==null)return;let ie;U.execution instanceof R.ProcessExecution?ie=c.from(U.execution):U.execution instanceof R.ShellExecution?ie=b.from(U.execution):U.execution&&U.execution instanceof R.CustomExecution&&(ie=v.from(U.execution));const fe=d.from(U.definition);let Ce;return U.scope?typeof U.scope=="number"?Ce=U.scope:Ce=U.scope.uri:Ce=R.TaskScope.Workspace,!fe||!Ce?void 0:{_id:U._id,definition:fe,name:U.name,source:{extensionId:j.identifier.value,label:U.source,scope:Ce},execution:ie,isBackground:U.isBackground,group:C.from(U.group),presentationOptions:t.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}H.from=V;async function A(U,j,ie){if(U==null)return;let fe;c.is(U.execution)?fe=c.to(U.execution):b.is(U.execution)?fe=b.to(U.execution):v.is(U.execution)&&(fe=v.to(U._id,ie));const Ce=d.to(U.definition);let _e;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?_e=U.source.scope:_e=await j.resolveWorkspaceFolder(D.URI.revive(U.source.scope)):_e=R.TaskScope.Workspace),!Ce||!_e)return;const oe=new R.Task(Ce,_e,U.name,U.source.label,fe,U.problemMatchers);return U.isBackground!==void 0&&(oe.isBackground=U.isBackground),U.group!==void 0&&(oe.group=R.TaskGroup.from(U.group._id),oe.group&&U.group.isDefault&&(oe.group=new R.TaskGroup(oe.group.id,oe.group.label),U.group.isDefault===!0&&(oe.group.isDefault=U.group.isDefault))),U.presentationOptions&&(oe.presentationOptions=t.to(U.presentationOptions)),U._id&&(oe._id=U._id),U.detail&&(oe.detail=U.detail),oe}H.to=A})(f||(e.TaskDTO=f={}));var I;(function(H){function $(A){return A}H.from=$;function V(A){if(A)return Object.assign(Object.create(null),A)}H.to=V})(I||(I={}));class S{#e;constructor($,V,A){this._id=V,this._task=A,this.#e=$}get task(){return this._task}terminate(){this.#e.terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}let P=class{constructor($,V,A,U,j,ie,fe,Ce){this._onDidExecuteTask=new T.Emitter,this._onDidTerminateTask=new T.Emitter,this._onDidTaskProcessStarted=new T.Emitter,this._onDidTaskProcessEnded=new T.Emitter,this._proxy=$.getProxy(N.MainContext.MainThreadTask),this._workspaceProvider=A,this._editorService=U,this._configurationService=j,this._terminalService=ie,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=fe,this._deprecationService=Ce,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider($,V,A){if(!A)return new R.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:V,provider:A,extension:$}),this._proxy.$registerTaskProvider(U,V),new R.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem($,V){this._proxy.$registerTaskSystem($,V)}fetchTasks($){return this._proxy.$fetchTasks(I.from($)).then(async V=>{const A=[];for(const U of V){const j=await f.to(U,this._workspaceProvider,this._providedCustomExecutions2);j&&A.push(j)}return A})}get taskExecutions(){const $=[];return this._taskExecutions.forEach(V=>$.push(V)),$}terminateTask($){if(!($ instanceof S))throw new Error("No valid task execution provided");return this._proxy.$terminateTask($._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask($,V,A){const U=this._providedCustomExecutions2.get($.id);U&&(this._activeCustomExecutions2.set($.id,U),this._terminalService.attachPtyToTerminal(V,await U.callback(A))),this._lastStartedTask=$.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution($)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask($){if(!this._taskExecutionPromises.has($.id))return;const V=await this.getTaskExecution($);this._taskExecutionPromises.delete($.id),this._taskExecutions.delete($.id),this.customExecutionComplete($),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess($){const V=await this.getTaskExecution($.id);this._onDidTaskProcessStarted.fire({execution:V,processId:$.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess($){const V=await this.getTaskExecution($.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:$.exitCode})}$provideTasks($,V){const A=this._handlers.get($);if(!A)return Promise.reject(new Error("no handler found"));const U=[],j=(0,O.asPromise)(()=>A.provider.provideTasks(L.CancellationToken.None)).then(ie=>this.provideTasksInternal(V,U,A,ie));return new Promise(ie=>{j.then(fe=>{Promise.all(U).then(()=>{ie(fe)})})})}async $resolveTask($,V){const A=this._handlers.get($);if(!A)return Promise.reject(new Error("no handler found"));if(V.definition.type!==A.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${A.type}].`);const U=await f.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const j=await A.provider.resolveTask(U,L.CancellationToken.None);if(!j)return;this.checkDeprecation(j,A);const ie=f.from(j,A.extension);if(!ie)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(ie.execution)&&await this.addCustomExecution(ie,j,!0),await this.resolveTaskInternal(ie)}nextHandle(){return this._handleCounter++}async addCustomExecution($,V,A){const U=await this._proxy.$createTaskId($);!A&&!this._providedCustomExecutions2.has(U)&&(this._notProvidedCustomExecutions.add(U),this._activeCustomExecutions2.set(U,V.execution)),this._providedCustomExecutions2.set(U,V.execution)}async getTaskExecution($,V){if(typeof $=="string"){const j=this._taskExecutionPromises.get($);if(!j)throw new a.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const A=this._taskExecutionPromises.get($.id);if(A)return A;let U;return V?U=Promise.resolve(new S(this,$.id,V)):U=f.to($.task,this._workspaceProvider,this._providedCustomExecutions2).then(j=>{if(!j)throw new a.ErrorNoTelemetry("Unexpected: Task does not exist.");return new S(this,$.id,j)}),this._taskExecutionPromises.set($.id,U),U.then(j=>(this._taskExecutions.set($.id,j),j))}checkDeprecation($,V){$._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete($){this._activeCustomExecutions2.get($.id)&&this._activeCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.has($.id)&&this._lastStartedTask!==$.id&&(this._providedCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.delete($.id));const A=this._notProvidedCustomExecutions.values();let U=A.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=A.next()}};e.ExtHostTaskBase=P,e.ExtHostTaskBase=P=Ke([He(0,l.IExtHostRpcService),He(1,w.IExtHostInitDataService),He(2,m.IExtHostWorkspace),He(3,h.IExtHostDocumentsAndEditors),He(4,y.IExtHostConfiguration),He(5,_.IExtHostTerminalService),He(6,s.ILogService),He(7,n.IExtHostApiDeprecationService)],P);let k=class extends P{constructor($,V,A,U,j,ie,fe,Ce){super($,V,A,U,j,ie,fe,Ce),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask($,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const A=f.from(V,$);if(A===void 0)throw new Error("Task is not valid");if(v.is(A.execution))await this.addCustomExecution(A,V,!1);else throw new a.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(A),V);return this._proxy.$executeTask(A).catch(j=>{throw new Error(j)}),U}provideTasksInternal($,V,A,U){const j=[];if(U)for(const ie of U){if(this.checkDeprecation(ie,A),!ie.definition||!$[ie.definition.type]){const Ce=ie.source?ie.source:"No task source";this._logService.warn(`The task [${Ce}, ${ie.name}] uses an undefined task type. The task will be ignored in the future.`)}const fe=f.from(ie,A.extension);fe&&v.is(fe.execution)?(j.push(fe),V.push(this.addCustomExecution(fe,ie,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:j,extension:A.extension}}async resolveTaskInternal($){if(v.is($.execution))return $;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables($,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,V,A){}};e.WorkerExtHostTask=k,e.WorkerExtHostTask=k=Ke([He(0,l.IExtHostRpcService),He(1,w.IExtHostInitDataService),He(2,m.IExtHostWorkspace),He(3,h.IExtHostDocumentsAndEditors),He(4,y.IExtHostConfiguration),He(5,_.IExtHostTerminalService),He(6,s.ILogService),He(7,n.IExtHostApiDeprecationService)],k),e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(Pe[289],Te([1,0,45,29]),function(me,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rawCellPrefix=void 0,e.isINotebookFileMatchNoModel=T,e.genericCellMatchesToTextSearchMatches=N;function T(R){return"cellResults"in R}e.rawCellPrefix="rawCell#";function N(R,m){let h=-1;const y=[];let L=[];return R.forEach(l=>{l.range.startLineNumber!==h&&L.length>0&&(y.push([...L]),L=[]),L.push(l),h=l.range.endLineNumber}),L.length>0&&y.push([...L]),y.map(l=>{const w=[],g=l[0].range.startLineNumber,r=l[l.length-1].range.endLineNumber;for(let o=g;o<=r;o++)w.push(m.getLineContent(o));return new D.TextSearchMatch(w.join(`
`)+`
`,l.map(o=>new O.Range(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Pe[290],Te([1,0,169,22,5,6,28,15,17,2,43,74,4,31,8,7,50,265,112,26,12,219,289,287]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o,s,n,i,a,d,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class c{static{this._notebookStatusBarItemProviderHandlePool=0}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(b=>b.apiEditor)}constructor(b,v,u,C,f,I){this._textDocumentsAndEditors=u,this._textDocuments=C,this._extHostFileSystem=f,this._extHostSearch=I,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new _.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=b.getProxy(l.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=b.getProxy(l.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=b.getProxy(l.MainContext.MainThreadNotebookEditors),this._commandsConverter=v.converter,v.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const P=S.notebookEditor?.notebookUri,k=S.cell.handle,$=this._documents.get(P)?.getCell(k);if($)return $.apiCell}if(S&&S.$mid===14){const P=S.uri,k=this._documents.get(P);if(k)return k.apiNotebook}return S}}),c._registerApiCommands(v)}getEditorById(b){const v=this._editors.get(b);if(!v)throw new Error(`unknown text editor: ${b}. known editors: ${[...this._editors.keys()]} `);return v}getIdByEditor(b){for(const[v,u]of this._editors)if(u.apiEditor===b)return v}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(b,v){const u=this._documents.get(b);if(!u&&!v)throw new Error(`NO notebook document for '${b}'`);return u}static _convertNotebookRegistrationData(b,v){if(!v)return;const u=v.filenamePattern.map(C=>g.NotebookExclusiveDocumentPattern.from(C)).filter(C=>C!==void 0);if(v.filenamePattern&&!u){console.warn(`Notebook content provider view options file name pattern is invalid ${v.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:v.displayName,filenamePattern:u,exclusive:v.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,v,u){const C=c._notebookStatusBarItemProviderHandlePool++,f=typeof u.onDidChangeCellStatusBarItems=="function"?c._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(C,u),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(C,f,v);let I;return f!==void 0&&(I=u.onDidChangeCellStatusBarItems(S=>this._notebookProxy.$emitCellStatusBarEvent(f))),new r.Disposable(()=>{this._notebookStatusBarItemProviders.delete(C),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(C,f),I?.dispose()})}async createNotebookDocument(b){const v=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:b.viewType,content:b.content&&g.NotebookData.from(b.content)});return y.URI.revive(v)}async openNotebookDocument(b){const v=this._documents.get(b);if(v)return v.apiNotebook;const u=await this._notebookDocumentsProxy.$tryOpenNotebook(b),C=this._documents.get(y.URI.revive(u));return(0,h.assertIsDefined)(C?.apiNotebook)}async showNotebookDocument(b,v){y.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let u;typeof v=="object"?u={position:g.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(g.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0}:u={preserveFocus:!1};const C=await this._notebookEditorsProxy.$tryShowNotebookDocument(b.uri,b.notebookType,u),f=C&&this._editors.get(C)?.apiEditor;if(f)return f;throw C?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,v,u,C){const f=this._notebookStatusBarItemProviders.get(b),I=y.URI.revive(v),S=this._documents.get(I);if(!S||!f)return;const P=S.getCellFromIndex(u);if(!P)return;const k=await f.provideCellStatusBarItems(P.apiCell,C);if(!k)return;const H=new N.DisposableStore,$=this._statusBarCache.add([H]),A=(Array.isArray(k)?k:[k]).map(U=>g.NotebookStatusBarItem.from(U,this._commandsConverter,H));return{cacheId:$,items:A}}$releaseNotebookCellStatusBarItems(b){this._statusBarCache.delete(b)}registerNotebookSerializer(b,v,u,C,f){if((0,m.isFalsyOrWhitespace)(v))throw new Error("viewType cannot be empty or just whitespace");const I=this._handlePool++;return this._notebookSerializer.set(I,{viewType:v,serializer:u,options:C}),this._notebookProxy.$registerNotebookSerializer(I,{id:b.identifier,location:b.extensionLocation},v,g.NotebookDocumentContentOptions.from(C),c._convertNotebookRegistrationData(b,f)),(0,N.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(I)})}async $dataToNotebook(b,v,u){const C=this._notebookSerializer.get(b);if(!C)throw new Error("NO serializer found");const f=await C.serializer.deserializeNotebook(v.buffer,u);return new o.SerializableObjectWithBuffers(g.NotebookData.from(f))}async $notebookToData(b,v,u){const C=this._notebookSerializer.get(b);if(!C)throw new Error("NO serializer found");const f=await C.serializer.serializeNotebook(g.NotebookData.to(v.value),u);return O.VSBuffer.wrap(f)}async $saveNotebook(b,v,u,C,f){const I=y.URI.revive(v),S=this._notebookSerializer.get(b);if(!S)throw new Error("NO serializer found");const P=this._documents.get(I);if(!P)throw new Error("Document NOT found");if(P.versionId!==u)throw new Error("Document version mismatch");if(!this._extHostFileSystem.value.isWritableFileSystem(I.scheme))throw new L.FileOperationError((0,D.localize)(0,null,this._resourceForError(I)),6);await this._validateWriteFile(I,C);const k={metadata:(0,i.filter)(P.apiNotebook.metadata,U=>!(S.options?.transientDocumentMetadata??{})[U]),cells:[]};for(const U of P.apiNotebook.getCells()){const j=new r.NotebookCellData(U.kind,U.document.getText(),U.document.languageId,U.mime,S.options?.transientOutputs?[]:[...U.outputs],U.metadata,U.executionSummary);j.metadata=(0,i.filter)(U.metadata,ie=>!(S.options?.transientCellMetadata??{})[ie]),k.cells.push(j)}const H=await S.serializer.serializeNotebook(k,f);await this._extHostFileSystem.value.writeFile(I,H);const $=this._extHostFileSystem.getFileSystemProviderExtUri(I.scheme),V=await this._extHostFileSystem.value.stat(I);return{name:$.basename(I),isFile:(V.type&L.FileType.File)!==0,isDirectory:(V.type&L.FileType.Directory)!==0,isSymbolicLink:(V.type&L.FileType.SymbolicLink)!==0,mtime:V.mtime,ctime:V.ctime,size:V.size,readonly:!!((V.permissions??0)&L.FilePermission.Readonly)||!this._extHostFileSystem.value.isWritableFileSystem(I.scheme),locked:!!((V.permissions??0)&L.FilePermission.Locked),etag:L.etag({mtime:V.mtime,size:V.size}),children:void 0}}async $searchInNotebooks(b,v,u,C,f){const I=this._notebookSerializer.get(b)?.serializer;if(!I)return{limitHit:!1,results:[]};const S=new R.ResourceSet;await(async(V,A,U)=>{await Promise.all(V.map(async j=>await Promise.all(j.filenamePatterns.map(ie=>{const fe={_reason:U._reason,folderQueries:U.folderQueries,includePattern:U.includePattern,excludePattern:U.excludePattern,maxResults:U.maxResults,type:1,filePattern:ie};return this._extHostSearch.doInternalFileSearchWithCustomCallback(fe,A,Ce=>{Ce.forEach(_e=>{S.has(_e)||C.some(pe=>j.isFromSettings&&!pe.isFromSettings?!1:pe.filenamePatterns.some(ne=>(0,E.globMatchesResource)(ne,_e)))||S.add(_e)})}).catch(Ce=>{if(Ce.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Ce})}))))})(u,f,v);const k=new R.ResourceMap;let H=!1;const $=Array.from(S).map(async V=>{const A=[];try{if(f.isCancellationRequested)return;if(v.maxResults&&[...k.values()].reduce((fe,Ce)=>fe+Ce.cellResults.length,0)>v.maxResults){H=!0;return}const U=[],j=this._documents.get(V);if(j)j.apiNotebook.getCells().forEach(Ce=>U.push({input:Ce.document.getText(),outputs:Ce.outputs.flatMap(_e=>_e.items.map(oe=>oe.data.toString()))}));else{const fe=await this._extHostFileSystem.value.readFile(V),Ce=O.VSBuffer.fromString(fe.toString()),_e=await I.deserializeNotebook(Ce.buffer,f);if(f.isCancellationRequested)return;g.NotebookData.from(_e).cells.forEach(pe=>U.push({input:pe.source,outputs:pe.outputs.flatMap(ne=>ne.items.map(Ie=>Ie.valueBytes.toString()))}))}if(f.isCancellationRequested)return;U.forEach((fe,Ce)=>{const _e=v.contentPattern.pattern,oe=new d.CellSearchModel(fe.input,void 0,fe.outputs),pe=oe.findInInputs(_e),ne=oe.findInOutputs(_e),Ie=ne.flatMap(xe=>(0,t.genericCellMatchesToTextSearchMatches)(xe.matches,xe.textBuffer)).map((xe,re)=>(xe.webviewIndex=re,xe));if(pe.length>0||ne.length>0){const xe={index:Ce,contentResults:(0,t.genericCellMatchesToTextSearchMatches)(pe,oe.inputTextBuffer),webviewResults:Ie};A.push(xe)}});const ie={resource:V,cellResults:A};k.set(V,ie);return}catch{return}});return await Promise.all($),{limitHit:H,results:[...k.values()]}}async _validateWriteFile(b,v){const u=await this._extHostFileSystem.value.stat(b);if(typeof v?.mtime=="number"&&typeof v.etag=="string"&&v.etag!==L.ETAG_DISABLED&&typeof u.mtime=="number"&&typeof u.size=="number"&&v.mtime<u.mtime&&v.etag!==L.etag({mtime:v.mtime,size:u.size}))throw new L.FileOperationError((0,D.localize)(1,null),3,v)}_resourceForError(b){return b.scheme===a.Schemas.file?b.fsPath:b.toString()}_createExtHostEditor(b,v,u){if(this._editors.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const C=new n.ExtHostNotebookEditor(v,this._notebookEditorsProxy,b,u.visibleRanges.map(g.NotebookRange.to),u.selections.map(g.NotebookRange.to),typeof u.viewColumn=="number"?g.ViewColumn.to(u.viewColumn):void 0);this._editors.set(v,C)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const u of b.value.removedDocuments){const C=y.URI.revive(u),f=this._documents.get(C);f&&(f.dispose(),this._documents.delete(C),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(I=>I.document.uri)}),this._onDidCloseNotebookDocument.fire(f.apiNotebook));for(const I of this._editors.values())I.notebookData.uri.toString()===C.toString()&&this._editors.delete(I.id)}if(b.value.addedDocuments){const u=[];for(const C of b.value.addedDocuments){const f=y.URI.revive(C.uri);if(this._documents.has(f))throw new Error(`adding EXISTING notebook ${f} `);const I=new s.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,f,C);u.push(...C.cells.map(S=>s.ExtHostCell.asModelAddData(S))),this._documents.get(f)?.dispose(),this._documents.set(f,I),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:u}),this._onDidOpenNotebookDocument.fire(I.apiNotebook)}}if(b.value.addedEditors)for(const u of b.value.addedEditors){if(this._editors.has(u.id))return;const C=y.URI.revive(u.documentUri),f=this._documents.get(C);f&&this._createExtHostEditor(f,u.id,u)}const v=[];if(b.value.removedEditors)for(const u of b.value.removedEditors){const C=this._editors.get(u);C&&(this._editors.delete(u),this._activeNotebookEditor?.id===C.id&&(this._activeNotebookEditor=void 0),v.push(C))}if(b.value.visibleEditors){this._visibleNotebookEditors=b.value.visibleEditors.map(C=>this._editors.get(C)).filter(C=>!!C);const u=new Set;this._visibleNotebookEditors.forEach(C=>u.add(C.id));for(const C of this._editors.values()){const f=u.has(C.id);C._acceptVisibility(f)}this._visibleNotebookEditors=[...this._editors.values()].map(C=>C).filter(C=>C.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this._activeNotebookEditor=void 0:b.value.newActiveEditor&&(this._editors.get(b.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${b.value.newActiveEditor}`),this._activeNotebookEditor=this._editors.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(b){const v=w.ApiCommandArgument.String.with("notebookType","A notebook type"),u=new w.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[v,new w.ApiCommandArgument("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>O.VSBuffer.wrap(f))],new w.ApiCommandResult("Notebook Data",f=>g.NotebookData.to(f.value))),C=new w.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[v,new w.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new o.SerializableObjectWithBuffers(g.NotebookData.from(f)))],new w.ApiCommandResult("Bytes",f=>f.buffer));b.registerApiCommand(u),b.registerApiCommand(C)}}e.ExtHostNotebookController=c}),define(Pe[291],Te([1,0,19,24,42,35,23,65,45]),function(me,e,D,O,T,N,R,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class y{constructor(l,w,g){this.config=l,this.provider=w,this.sessionToken=g,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&N.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&N.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const w=this.config.folderQueries||[];return new Promise((g,r)=>{const o=s=>{this.resultCount++,l(s)};if(this.isCanceled)return g({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(s=>{const n=s.toString(),i=D.basename(n);this.globalExcludePattern&&this.globalExcludePattern(n,i)||this.matchFile(o,{base:s,basename:i})}),Promise.all(w.map(s=>this.searchInFolder(s,o))).then(s=>{g({limitHit:this.isLimitHit,stats:s[0]||void 0})},s=>{r(new Error((0,T.toErrorMessage)(s)))})})}async searchInFolder(l,w){const g=new O.CancellationTokenSource,r=this.getSearchOptionsForFolder(l),o=this.initDirectoryTree(),s=new h.QueryGlobTester(this.config,l),n=!s.hasSiblingExcludeClauses();let i;try{this.activeCancellationTokens.add(g),i=m.StopWatch.create();const a=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},r,g.token),d=i.elapsed(),t=m.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(a&&a.forEach(E=>{const c=D.posix.relative(l.folder.path,E.path);if(n){const p=D.basename(E.path);this.matchFile(w,{base:l.folder,relativePath:c,basename:p});return}this.addDirectoryEntries(o,l.folder,c,w)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(o,s,w),{providerTime:d,postProcessTime:t.elapsed()})}finally{g.dispose(),this.activeCancellationTokens.delete(g)}}getSearchOptionsForFolder(l){const w=(0,h.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),g=(0,h.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:g,includes:w,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},w,g,r){if(g===this.filePattern){const s=D.basename(this.filePattern);this.matchFile(r,{base:w,relativePath:this.filePattern,basename:s})}function o(s){const n=D.basename(s),i=D.dirname(s);let a=l[i];a||(a=l[i]=[],o(i)),a.push({base:w,relativePath:s,basename:n})}o(g)}matchDirectoryTree({rootEntries:l,pathToEntries:w},g,r){const o=this,s=this.filePattern;function n(i){const a=(0,h.hasSiblingFn)(()=>i.map(d=>d.basename));for(let d=0,t=i.length;d<t;d++){const E=i[d],{relativePath:c,basename:p}=E;if(g.matchesExcludesSync(c,p,s!==p?a:void 0))continue;const b=w[c];if(b)n(b);else{if(c===s)continue;o.matchFile(r,E)}if(o.isLimitHit)break}}n(l)}matchFile(l,w){(!this.includePattern||w.relativePath&&this.includePattern(w.relativePath,w.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(w))}}class L{constructor(){this.sessions=new Map}static{this.BATCH_SIZE=512}fileSearch(l,w,g,r){const o=this.getSessionTokenSource(l.cacheKey),s=new y(l,w,o&&o.token);let n=0;const i=a=>{n+=a.length,g(a.map(d=>this.rawMatchToSearchItem(d)))};return this.doSearch(s,L.BATCH_SIZE,i,r).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:a.stats}}))}clearCache(l){this.getSessionTokenSource(l)?.cancel()}getSessionTokenSource(l){if(l)return this.sessions.has(l)||this.sessions.set(l,new O.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:R.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,w,g,r){const o=r.onCancellationRequested(()=>{l.cancel()}),s=i=>{i&&(n.push(i),w>0&&n.length>=w&&(g(n),n=[]))};let n=[];return l.search(s).then(i=>(n.length&&g(n),o.dispose(),i),i=>(n.length&&g(n),o.dispose(),Promise.reject(i)))}}e.FileSearchManager=L}),define(Pe[292],Te([1,0,18,260,35,96,28,12,19,23,15,17,2,95,186,47,13,48,107,288,45]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryBuilder=void 0,e.resolveResourcesForSearchIncludes=C;let d=class{constructor(I,S,P,k,H){this.configurationService=I,this.workspaceContextService=S,this.editorGroupsService=P,this.logService=k,this.pathService=H}text(I,S,P={}){I=this.getContentPattern(I,P);const k=this.configurationService.getValue(),H=S&&S.some(V=>!this.configurationService.getValue({resource:V}).search.useRipgrep);return{...this.commonQuery(S?.map(s.toWorkspaceFolder),P),type:2,contentPattern:I,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:k.search.usePCRE2||H||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}getContentPattern(I,S){const P=this.configurationService.getValue();I.isRegExp&&(I.pattern=I.pattern.replace(/\r?\n/g,"\\n"));const k={...I,wordSeparators:P.editor.wordSeparators};return this.isCaseSensitive(I,S)&&(k.isCaseSensitive=!0),this.isMultiline(I)&&(k.isMultiline=!0),S.notebookSearchConfig?.includeMarkupInput&&(k.notebookInfo||(k.notebookInfo={}),k.notebookInfo.isInNotebookMarkdownInput=S.notebookSearchConfig.includeMarkupInput),S.notebookSearchConfig?.includeMarkupPreview&&(k.notebookInfo||(k.notebookInfo={}),k.notebookInfo.isInNotebookMarkdownPreview=S.notebookSearchConfig.includeMarkupPreview),S.notebookSearchConfig?.includeCodeInput&&(k.notebookInfo||(k.notebookInfo={}),k.notebookInfo.isInNotebookCellInput=S.notebookSearchConfig.includeCodeInput),S.notebookSearchConfig?.includeOutput&&(k.notebookInfo||(k.notebookInfo={}),k.notebookInfo.isInNotebookCellOutput=S.notebookSearchConfig.includeOutput),k}file(I,S={}){return{...this.commonQuery(I,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey,shouldGlobMatchFilePattern:S.shouldGlobSearch}}handleIncludeExclude(I,S){return I?(I=Array.isArray(I)?I.map(b):b(I),S?this.parseSearchPaths(I):{pattern:E(...Array.isArray(I)?I:[I])}):{}}commonQuery(I=[],S={}){const P=this.handleIncludeExclude(S.includePattern,S.expandPatterns),k=this.handleIncludeExclude(S.excludePattern,S.expandPatterns),H=I.length>1,$=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,S,k)):I.map(U=>this.getFolderQueryForRoot(U,S,k,H))).filter(U=>!!U),V={_reason:S._reason,folderQueries:$,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:k.pattern,includePattern:P.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const U=D.coalesce(D.flatten(this.editorGroupsService.groups.map(fe=>fe.editors.map(Ce=>Ce.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const j=U.filter(fe=>(0,a.pathIncludedInQuery)(V,fe.fsPath)),ie=this.commonQueryFromFileList(j);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...V,...ie}}const A=S.extraFileResources&&S.extraFileResources.filter(U=>(0,a.pathIncludedInQuery)(V,U.fsPath));return V.extraFileResources=A&&A.length?A:void 0,V}commonQueryFromFileList(I){const S=[],P=new R.ResourceMap,k={};let H=!1;return I.forEach($=>{if($.scheme===m.Schemas.walkThrough)return;if((0,y.isAbsolutePath)($)){const A=this.workspaceContextService.getWorkspaceFolder($)?.uri??$.with({path:h.dirname($.fsPath)});let U=P.get(A);U||(H=!0,U={folder:A,includePattern:{}},S.push(U),P.set(A,U));const j=h.relative(A.fsPath,$.fsPath);(0,_.assertIsDefined)(U.includePattern)[j.replace(/\\/g,"/")]=!0}else $.fsPath&&(H=!0,k[$.fsPath]=!0)}),{folderQueries:S,includePattern:k,usingSearchPaths:!0,excludePattern:H?void 0:{"**/*":!0}}}isCaseSensitive(I,S){if(S.isSmartCase){if(I.isRegExp){if(L.containsUppercaseCharacter(I.pattern,!0))return!0}else if(L.containsUppercaseCharacter(I.pattern))return!0}return!!I.isCaseSensitive}isMultiline(I){return I.isMultiline||I.isRegExp&&(0,w.isMultilineRegexSource)(I.pattern)||I.pattern.indexOf(`
`)>=0?!0:!!I.isMultiline}parseSearchPaths(I){const S=ie=>h.isAbsolute(ie)||/^\.\.?([\/\\]|$)/.test(ie),k=(Array.isArray(I)?I:c(I)).map(ie=>{const fe=this.pathService.resolvedUserHome;return fe?(0,N.untildify)(ie,fe.scheme===m.Schemas.file?fe.fsPath:fe.path):ie}),H=O.groupBy(k,ie=>S(ie)?"searchPaths":"exprSegments"),$=(H.exprSegments||[]).map(ie=>L.rtrim(ie,"/")).map(ie=>L.rtrim(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),p(ie))),V={},A=this.expandSearchPathPatterns(H.searchPaths||[]);A&&A.length&&(V.searchPaths=A);const U=D.flatten($),j=E(...U);return j&&(V.pattern=j),V}getExcludesForFolder(I,S){return S.disregardExcludeSettings?void 0:(0,a.getExcludes)(I,!S.disregardSearchExcludeSettings)}expandSearchPathPatterns(I){if(!I||!I.length)return[];const S=I.flatMap(k=>{let{pathPortion:H,globPortion:$}=t(k);return $&&($=v($)),this.expandOneSearchPath(H).flatMap(A=>this.resolveOneSearchPathPattern(A,$))}),P=new Map;return S.forEach(k=>{const H=k.searchPath.toString(),$=P.get(H);$?k.pattern&&($.pattern=$.pattern||{},$.pattern[k.pattern]=!0):P.set(H,{searchPath:k.searchPath,pattern:k.pattern?E(k.pattern):void 0})}),Array.from(P.values())}expandOneSearchPath(I){if(h.isAbsolute(I)){const S=this.workspaceContextService.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==m.Schemas.file?[{searchPath:S[0].uri.with({path:I})}]:[{searchPath:l.URI.file(h.normalize(I))}]}if(this.workspaceContextService.getWorkbenchState()===2){const S=this.workspaceContextService.getWorkspace().folders[0].uri;if(I=b(I),I.startsWith("../")||I===".."){const k=h.posix.resolve(S.path,I);return[{searchPath:S.with({path:k})}]}const P=v(I);return[{searchPath:S,pattern:P}]}else{if(I==="./"||I===".\\")return[];{const S=I.replace(/^\.[\/\\]/,""),k=this.workspaceContextService.getWorkspace().folders.map(H=>{const $=S.match(new RegExp(`^${L.escapeRegExpCharacters(H.name)}(?:/(.*)|$)`));return $?{match:$,folder:H}:null}).filter(_.isDefined);if(k.length)return k.map(H=>{const $=H.match[1];return{searchPath:H.folder.uri,pattern:$&&v($)}});{const H=I.match(/\.[\/\\](.+)[\/\\]?/),$=H?H[1]:I,V=g.localize(0,null,$);throw new Error(V)}}}}resolveOneSearchPathPattern(I,S){const P=I.pattern&&S?`${I.pattern}/${S}`:I.pattern||S,k=[{searchPath:I.searchPath,pattern:P}];return P&&!P.endsWith("**")&&k.push({searchPath:I.searchPath,pattern:P+"/**"}),k}getFolderQueryForSearchPath(I,S,P){const k=this.getFolderQueryForRoot((0,s.toWorkspaceFolder)(I.searchPath),S,P,!1);return k?{...k,includePattern:I.pattern}:null}getFolderQueryForRoot(I,S,P,k){let H;const $=l.URI.isUri(I)?I:I.uri;if(P.searchPaths){const ie=P.searchPaths.filter(fe=>(0,y.isEqual)(fe.searchPath,$))[0];if(ie&&!ie.pattern)return null;ie&&(H=ie.pattern)}const V=this.configurationService.getValue({resource:$}),U={...this.getExcludesForFolder(V,S)||{},...H||{}},j=l.URI.isUri(I)?(0,y.basename)(I):I.name;return{folder:$,folderName:k?j:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:V.files&&V.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!V.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!V.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!V.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!V.search.followSymlinks}}};e.QueryBuilder=d,e.QueryBuilder=d=Ke([He(0,r.IConfigurationService),He(1,s.IWorkspaceContextService),He(2,n.IEditorGroupsService),He(3,o.ILogService),He(4,i.IPathService)],d);function t(f){const I=f.match(/[\*\{\}\(\)\[\]\?]/);if(I){const S=I.index,P=f.substr(0,S).match(/[/|\\][^/\\]*$/);if(P){let k=f.substr(0,P.index);return k.match(/[/\\]/)||(k+="/"),{pathPortion:k,globPortion:f.substr((P.index||0)+1)}}}return{pathPortion:f}}function E(...f){return f.length?f.reduce((I,S)=>(I[S]=!0,I),Object.create(null)):void 0}function c(f){return T.splitGlobAware(f,",").map(I=>I.trim()).filter(I=>!!I.length)}function p(f){return[`**/${f}/**`,`**/${f}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function b(f){return f.replace(/\\/g,"/")}function v(f){return b(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(f){return f.replace(/([?*[\]])/g,"[$1]")}function C(f,I){f=D.distinct(f,k=>k.toString());const S=[],P=I.getWorkspace();return f&&f.forEach(k=>{let H;if(I.getWorkbenchState()===2)H=(0,y.relativePath)(P.folders[0].uri,k),H&&H!=="."&&(H="./"+H);else{const $=I.getWorkspaceFolder(k);if($){const V=$.name;if(P.folders.filter(U=>U.name===V).length===1){const U=(0,y.relativePath)($.uri,k);U===""?H=`./${$.name}`:H=`./${$.name}/${U}`}else H=k.fsPath}}H&&S.push(u(H))}),S}}),define(Pe[293],Te([1,0,23,2,24,14,3,292,45,48,11]),function(me,e,D,O,T,N,R,m,h,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkActivateWorkspaceContainsExtension=l,e.checkGlobFileExists=r;const _=7e3;function l(o,s){const n=s.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],a=[];for(const b of n)if(/^workspaceContains:/.test(b)){const v=b.substr(18);v.indexOf("*")>=0||v.indexOf("?")>=0||o.forceUsingSearch?a.push(v):i.push(v)}if(i.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:d,resolve:t}=(0,L.promiseWithResolvers)(),E=b=>t({activationEvent:b}),c=Promise.all(i.map(b=>w(o,b,E))).then(()=>{}),p=g(o,s.identifier,a,E);return Promise.all([c,p]).then(()=>{t(void 0)}),d}async function w(o,s,n){for(const i of o.folders)if(await o.exists(D.joinPath(O.URI.revive(i),s))){n(`workspaceContains:${s}`);return}}async function g(o,s,n,i){if(n.length===0)return Promise.resolve(void 0);const a=new T.CancellationTokenSource,d=o.checkExists(o.folders,n,a.token),t=setTimeout(async()=>{a.cancel(),o.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},_);let E=!1;try{E=await d}catch(c){N.isCancellationError(c)||N.onUnexpectedError(c)}a.dispose(),clearTimeout(t),E&&i(`workspaceContains:${n.join(",")}`)}function r(o,s,n,i){const a=o.get(R.IInstantiationService),d=o.get(h.ISearchService),E=a.createInstance(m.QueryBuilder).file(s.map(c=>(0,y.toWorkspaceFolder)(O.URI.revive(c))),{_reason:"checkExists",includePattern:n,exists:!0});return d.fileSearch(E,i).then(c=>!!c.limitHit,c=>N.isCancellationError(c)?!1:Promise.reject(c))}}),define(Pe[38],Te([1,0,165,19,89,23,11,6,52,2,13,4,37,225,82,36,25,108,14,20,22,207,7,102,3,27,85,16,71,86,51,88,5,293,81,209,12,79,65,21,80]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o,s,n,i,a,d,t,E,c,p,b,v,u,C,f,I,S,P,k,H,$,V,A,U,j){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,c.createDecorator)("IHostUtils");let fe=ie=class extends m.Disposable{constructor(F,Z,be,Le,Se,ve,he,K,Y,le,de,Ne,ue){super(),this._extHostManagedSockets=Ne,this._extHostLanguageModels=ue,this._onDidChangeRemoteConnectionData=this._register(new S.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._realPathCache=new Map,this._isTerminating=!1,this._hostUtils=Z,this._extHostContext=be,this._initData=he,this._extHostWorkspace=Le,this._extHostConfiguration=Se,this._logService=ve,this._extHostTunnelService=Y,this._extHostTerminalService=le,this._extHostLocalizationService=de,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._activationEventsReader=new xe(this._initData.extensions.activationEvents),this._globalRegistry=new s.ExtensionDescriptionRegistry(this._activationEventsReader,this._initData.extensions.allExtensions);const De=new i.ExtensionIdentifierSet(this._initData.extensions.myExtensions);this._myRegistry=new s.ExtensionDescriptionRegistry(this._activationEventsReader,ne(this._globalRegistry,De)),U.isCI&&(this._logService.info(`Creating extension host with the following global extensions: ${oe(this._globalRegistry)}`),this._logService.info(`Creating extension host with the following local extensions: ${oe(this._myRegistry)}`)),this._storage=new g.ExtHostStorage(this._extHostContext,this._logService),this._secretState=new k.ExtHostSecretState(this._extHostContext),this._storagePath=K,this._instaService=F.createChild(new u.ServiceCollection([g.IExtHostStorage,this._storage],[k.IExtHostSecretState,this._secretState])),this._activator=this._register(new w.ExtensionsActivator(this._myRegistry,this._globalRegistry,{onExtensionActivationError:(Re,Ue,B)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Re,n.transformErrorForSerialization(Ue),B)},actualActivateExtension:async(Re,Ue)=>{if(s.ExtensionDescriptionRegistry.isHostExtension(Re,this._myRegistry,this._globalRegistry))return await this._mainThreadExtensionsProxy.$activateExtension(Re,Ue),new w.HostExtension;const B=this._myRegistry.getExtensionDescription(Re);return this._activateExtension(B,Ue)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),T.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(F){n.onUnexpectedError(F)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let F=[];try{F=this._myRegistry.getAllExtensionDescriptions().map(Se=>Se.identifier).filter(Se=>this.isActivated(Se)).map(Se=>this._deactivate(Se))}catch{}await Promise.all(F)}terminate(F,Z=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${F}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),n.setUnexpectedErrorHandler(Le=>{this._logService.error(Le)}),this._extHostContext.dispose();const be=this._deactivateAll();Promise.race([(0,R.timeout)(5e3),be]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${Z}`):this._logService.info(`Extension host exiting with code ${Z}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(Z)})}isActivated(F){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(F):!1}async getExtension(F){const Z=await this._mainThreadExtensionsProxy.$getExtension(F);return Z&&{...Z,identifier:new i.ExtensionIdentifier(Z.identifier.value),extensionLocation:y.URI.revive(Z.extensionLocation)}}_activateByEvent(F,Z){return this._activator.activateByEvent(F,Z)}_activateById(F,Z){return this._activator.activateById(F,Z)}activateByIdWithErrors(F,Z){return this._activateById(F,Z).then(()=>{const be=this._activator.getActivatedExtension(F);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(F=>this._myRegistry)}getExtensionExports(F){if(this._readyToRunExtensions.isOpen())return this._activator.getActivatedExtension(F).exports;try{return this._activator.getActivatedExtension(F).exports}catch{return null}}async _realPathExtensionUri(F){if(F.scheme===$.Schemas.file&&this._hostUtils.fsRealpath){const Z=F.fsPath;this._realPathCache.has(Z)||this._realPathCache.set(Z,this._hostUtils.fsRealpath(Z));const be=await this._realPathCache.get(Z);return y.URI.file(be)}return F}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(F=>new Ie(F))),this._extensionPathIndex}async _createExtensionPathIndex(F){const Z=h.TernarySearchTree.forUris(be=>N.extUriBiasedIgnorePathCase.ignorePathCasing(be));return await Promise.all(F.map(async be=>{if(this._getEntryPoint(be)){const Le=await this._realPathExtensionUri(be.extensionLocation);Z.set(Le,be)}})),Z}_deactivate(F){let Z=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(F))return Z;const be=this._activator.getActivatedExtension(F);if(!be)return Z;try{typeof be.module.deactivate=="function"&&(Z=Promise.resolve(be.module.deactivate()).then(void 0,Le=>(this._logService.error(Le),Promise.resolve(void 0))))}catch(Le){this._logService.error(`An error occurred when deactivating the extension '${F.value}':`),this._logService.error(Le)}try{(0,m.dispose)(be.subscriptions)}catch(Le){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${F.value}':`),this._logService.error(Le)}return Z}async _activateExtension(F,Z){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier),this._doActivateExtension(F,Z).then(be=>{const Le=be.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(F.identifier,Le.codeLoadingTime,Le.activateCallTime,Le.activateResolvedTime,Z),this._logExtensionActivationTimes(F,Z,"success",Le),be},be=>{throw this._logExtensionActivationTimes(F,Z,"failure"),be})}_logExtensionActivationTimes(F,Z,be,Le){const Se=_e(F,Z);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Se,...Le||{},outcome:be})}_doActivateExtension(F,Z){const be=_e(F,Z);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",be);const Le=this._getEntryPoint(F);if(!Le)return Promise.resolve(new w.EmptyExtension(w.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${F.identifier.value}, startup: ${Z.startup}, activationEvent: '${Z.activationEvent}'${F.identifier.value!==Z.extensionId.value?`, root cause: ${Z.extensionId.value}`:""}`),this._logService.flush();const Se=new w.ExtensionActivationTimesBuilder(Z.startup);return Promise.all([this._loadCommonJSModule(F,(0,N.joinPath)(F.extensionLocation,Le),Se),this._loadExtensionContext(F)]).then(ve=>(T.mark(`code/extHost/willActivateExtension/${F.identifier.value}`),ie._callActivate(this._logService,F.identifier,ve[0],ve[1],Se))).then(ve=>(T.mark(`code/extHost/didActivateExtension/${F.identifier.value}`),ve))}_loadExtensionContext(F){const Z=this._extHostLanguageModels.createLanguageModelAccessInformation(F),be=new d.ExtensionGlobalMemento(F,this._storage),Le=new d.ExtensionMemento(F.identifier.value,!1,this._storage),Se=new H.ExtensionSecrets(F,this._secretState),ve=F.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,he=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${F.identifier.value}`),Promise.all([be.whenReady,Le.whenReady,this._storagePath.whenReady]).then(()=>{const K=this;let Y,le;const de=(0,o.isProposedApiEnabled)(F,"ipc")?this._initData.messagePorts?.get(i.ExtensionIdentifier.toKey(F.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Le,secrets:Se,subscriptions:[],get languageModelAccessInformation(){return Z},get extensionUri(){return F.extensionLocation},get extensionPath(){return F.extensionLocation.fsPath},asAbsolutePath(Ne){return O.join(F.extensionLocation.fsPath,Ne)},get storagePath(){return K._storagePath.workspaceValue(F)?.fsPath},get globalStoragePath(){return K._storagePath.globalValue(F).fsPath},get logPath(){return O.join(K._initData.logsLocation.fsPath,F.identifier.value)},get logUri(){return y.URI.joinPath(K._initData.logsLocation,F.identifier.value)},get storageUri(){return K._storagePath.workspaceValue(F)},get globalStorageUri(){return K._storagePath.globalValue(F)},get extensionMode(){return ve},get extension(){return Y===void 0&&(Y=new pe(K,F.identifier,F,he,!1)),Y},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(F,"extensionRuntime"),K.extensionRuntime},get environmentVariableCollection(){return K._extHostTerminalService.getEnvironmentVariableCollection(F)},get messagePassingProtocol(){if(!le){if(!de)return;const Ne=S.Event.buffer(S.Event.fromDOMEventEmitter(de,"message",ue=>ue.data));de.start(),le={onDidReceiveMessage:Ne,postMessage:de.postMessage.bind(de)}}return le}})})}static _callActivate(F,Z,be,Le,Se){return be=be||{activate:void 0,deactivate:void 0},this._callActivateOptional(F,Z,be,Le,Se).then(ve=>new w.ActivatedExtension(!1,null,Se.build(),be,ve,Le.subscriptions))}static _callActivateOptional(F,Z,be,Le,Se){if(typeof be.activate=="function")try{Se.activateCallStart(),F.trace(`ExtensionService#_callActivateOptional ${Z.value}`);const ve=typeof global=="object"?global:self,he=be.activate.apply(ve,[Le]);return Se.activateCallStop(),Se.activateResolveStart(),Promise.resolve(he).then(K=>(Se.activateResolveStop(),K))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(be)}_activateOneStartupFinished(F,Z){this._activateById(F.identifier,{startup:!1,extensionId:F.identifier,activationEvent:Z}).then(void 0,be=>{this._logService.error(be)})}_activateAllStartupFinishedDeferred(F,Z=0){const Le=Date.now();(0,U.setTimeout0)(()=>{for(let Se=Z;Se<F.length;Se+=1){const ve=F[Se];for(const he of ve.activationEvents??[])if(he==="onStartupFinished")if(Date.now()-Le>50){this._activateAllStartupFinishedDeferred(F,Se);break}else this._activateOneStartupFinished(ve,he)}})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(T.getMarks()),this._extHostConfiguration.getConfigProvider().then(F=>{const Z=F.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this._myRegistry.getAllExtensionDescriptions();if(Z)this._activateAllStartupFinishedDeferred(be);else for(const Le of be)if(Le.activationEvents)for(const Se of Le.activationEvents)Se==="onStartupFinished"&&this._activateOneStartupFinished(Le,Se)})}_handleEagerExtensions(){const F=this._activateByEvent("*",!0).then(void 0,ve=>{this._logService.error(ve)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ve=>this._handleWorkspaceContainsEagerExtensions(ve.added)));const Z=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],be=this._handleWorkspaceContainsEagerExtensions(Z),Le=this._handleRemoteResolverEagerExtensions(),Se=Promise.all([Le,F,be]).then(()=>{});return Promise.race([Se,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Se}_handleWorkspaceContainsEagerExtensions(F){return F.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(Z=>this._handleWorkspaceContainsEagerExtension(F,Z))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(F,Z){if(this.isActivated(Z.identifier))return;const be=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Le={logService:this._logService,folders:F.map(ve=>ve.uri),forceUsingSearch:be||!this._hostUtils.fsExists,exists:ve=>this._hostUtils.fsExists(ve.fsPath),checkExists:(ve,he,K)=>this._mainThreadWorkspaceProxy.$checkExists(ve,he,K)},Se=await(0,P.checkActivateWorkspaceContainsExtension)(Le,Z);if(Se)return this._activateById(Z.identifier,{startup:!0,extensionId:Z.identifier,activationEvent:Se.activationEvent}).then(void 0,ve=>this._logService.error(ve))}async _handleRemoteResolverEagerExtensions(){if(this._initData.remote.authority)return this._activateByEvent(`onResolveRemoteAuthority:${this._initData.remote.authority}`,!1)}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(F){throw console.error(F),F}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:F,extensionTestsLocationURI:Z}=this._initData.environment;if(!F||!Z)throw new Error(D.localize(0,null));const be=await this._loadCommonJSModule(null,Z,new w.ExtensionActivationTimesBuilder(!1));if(!be||typeof be.run!="function")throw new Error(D.localize(1,null,Z.toString()));return new Promise((Le,Se)=>{const ve=(Y,le)=>{Y?(U.isCI&&this._logService.error("Test runner called back with error",Y),Se(Y)):(U.isCI&&(le?this._logService.info(`Test runner called back with ${le} failures.`):this._logService.info("Test runner called back with successful outcome.")),Le(typeof le=="number"&&le>0?1:0))},he=(0,N.originalFSPath)(Z),K=be.run(he,ve);K&&K.then&&K.then(()=>{U.isCI&&this._logService.info("Test runner finished successfully."),Le(0)}).catch(Y=>{U.isCI&&this._logService.error("Test runner finished with error",Y),Se(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>Promise.race([this._activator.waitForActivatingExtensions(),(0,R.timeout)(1e3)])).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(F,Z){return this._resolvers[F]=Z,(0,m.toDisposable)(()=>{delete this._resolvers[F]})}async getRemoteExecServer(F){const{resolver:Z}=await this._activateAndGetResolver(F);return Z?.resolveExecServer?.(F,{resolveAttempt:0})}async _activateAndGetResolver(F){const Z=F.indexOf("+");if(Z===-1)throw new t.RemoteAuthorityResolverError("Not an authority that can be resolved!",E.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=F.substr(0,Z);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this._resolvers[be]}}async $resolveAuthority(F,Z){const be=A.StopWatch.create(!1),Le=()=>`[resolveAuthority(${(0,E.getRemoteAuthorityPrefix)(F)},${Z})][${be.elapsed()}ms] `,Se=x=>this._logService.info(`${Le()}${x}`),ve=x=>this._logService.warn(`${Le()}${x}`),he=(x,q=void 0)=>this._logService.error(`${Le()}${x}`,q),K=x=>{if(x instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:x._code,message:x._message,detail:x._detail}};throw x},Y=async x=>{Se(`activating resolver for ${x}...`);const{resolver:q,authorityPrefix:W}=await this._activateAndGetResolver(x);if(!q)throw he(`no resolver for ${W}`),new t.RemoteAuthorityResolverError(`No remote extension installed to resolve ${W}.`,E.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:W,remoteAuthority:x}},le=F.split(/@|%40/g).reverse();Se(`activating remote resolvers ${le.join(" -> ")}`);let de;try{de=await Promise.all(le.map(Y)).catch(async x=>{if(!(x instanceof t.RemoteAuthorityResolverError)||x._code!==E.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw x;return ve(`resolving nested authorities failed: ${x.message}`),[await Y(F)]})}catch(x){return K(x)}const Ne=new R.IntervalTimer;Ne.cancelAndSet(()=>Se("waiting..."),1e3);let ue,De;for(const[x,{authorityPrefix:q,resolver:W,remoteAuthority:ee}]of de.entries())try{if(x===de.length-1)Se("invoking final resolve()..."),T.mark(`code/extHost/willResolveAuthority/${q}`),ue=await W.resolve(ee,{resolveAttempt:Z,execServer:De}),T.mark(`code/extHost/didResolveAuthorityOK/${q}`),Se("setting tunnel factory..."),this._register(await this._extHostTunnelService.setTunnelFactory(W,t.ManagedResolvedAuthority.isManagedResolvedAuthority(ue)?ue:void 0));else{if(Se(`invoking resolveExecServer() for ${ee}`),T.mark(`code/extHost/willResolveExecServer/${q}`),De=await W.resolveExecServer?.(ee,{resolveAttempt:Z,execServer:De}),!De)throw new t.RemoteAuthorityResolverError(`Exec server was not available for ${ee}`,E.RemoteAuthorityResolverErrorCode.NoResolverFound);T.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(se){return T.mark(`code/extHost/didResolveAuthorityError/${q}`),he("returned an error",se),Ne.dispose(),K(se)}Ne.dispose();const Re={environmentTunnels:ue.environmentTunnels,features:ue.tunnelFeatures?{elevation:ue.tunnelFeatures.elevation,privacyOptions:ue.tunnelFeatures.privacyOptions,protocol:ue.tunnelFeatures.protocol===void 0?!0:ue.tunnelFeatures.protocol}:void 0},Ue={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted,authenticationSession:ue.authenticationSessionForInitializingExtensions?{id:ue.authenticationSessionForInitializingExtensions.id,providerId:ue.authenticationSessionForInitializingExtensions.providerId}:void 0};Se(`returned ${t.ManagedResolvedAuthority.isManagedResolvedAuthority(ue)?"managed authority":`${ue.host}:${ue.port}`}`);let B;if(t.ManagedResolvedAuthority.isManagedResolvedAuthority(ue)){const x=Z;this._extHostManagedSockets.setFactory(x,ue.makeConnection),B={authority:F,connectTo:new E.ManagedRemoteConnection(x),connectionToken:ue.connectionToken}}else B={authority:F,connectTo:new E.WebSocketRemoteConnection(ue.host,ue.port),connectionToken:ue.connectionToken};return{type:"ok",value:{authority:B,options:Ue,tunnelInformation:Re}}}async $getCanonicalURI(F,Z){this._logService.info(`$getCanonicalURI invoked for authority (${(0,E.getRemoteAuthorityPrefix)(F)})`);const{resolver:be}=await this._activateAndGetResolver(F);if(!be)return null;const Le=y.URI.revive(Z);if(typeof be.getCanonicalURI>"u")return Le;const Se=await(0,R.asPromise)(()=>be.getCanonicalURI(Le));return Se||Le}async $startExtensionHost(F){F.toAdd.forEach(ve=>ve.extensionLocation=y.URI.revive(ve.extensionLocation));const{globalRegistry:Z,myExtensions:be}=Ce(this._activationEventsReader,this._globalRegistry,this._myRegistry,F),Le=await this._createExtensionPathIndex(be);return(await this.getExtensionPathIndex()).setSearchTree(Le),this._globalRegistry.set(Z.getAllExtensionDescriptions()),this._myRegistry.set(be),U.isCI&&(this._logService.info(`$startExtensionHost: global extensions: ${oe(this._globalRegistry)}`),this._logService.info(`$startExtensionHost: local extensions: ${oe(this._myRegistry)}`)),this._startExtensionHost()}$activateByEvent(F,Z){return Z===1?this._almostReadyToRunExtensions.wait().then(be=>this._activateByEvent(F,!1)):this._readyToRunExtensions.wait().then(be=>this._activateByEvent(F,!1))}async $activate(F,Z){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(F)?(await this._activateById(F,Z),!0):!1}async $deltaExtensions(F){F.toAdd.forEach(ve=>ve.extensionLocation=y.URI.revive(ve.extensionLocation));const{globalRegistry:Z,myExtensions:be}=Ce(this._activationEventsReader,this._globalRegistry,this._myRegistry,F),Le=await this._createExtensionPathIndex(be);return(await this.getExtensionPathIndex()).setSearchTree(Le),this._globalRegistry.set(Z.getAllExtensionDescriptions()),this._myRegistry.set(be),U.isCI&&(this._logService.info(`$deltaExtensions: global extensions: ${oe(this._globalRegistry)}`),this._logService.info(`$deltaExtensions: local extensions: ${oe(this._myRegistry)}`)),Promise.resolve(void 0)}async $test_latency(F){return F}async $test_up(F){return F.byteLength}async $test_down(F){const Z=a.VSBuffer.alloc(F),be=Math.random()%256;for(let Le=0;Le<F;Le++)Z.writeUInt8(be,Le);return Z}async $updateRemoteConnectionData(F){this._remoteConnectionData=F,this._onDidChangeRemoteConnectionData.fire()}};e.AbstractExtHostExtensionService=fe,e.AbstractExtHostExtensionService=fe=ie=Ke([He(0,c.IInstantiationService),He(1,e.IHostUtils),He(2,v.IExtHostRpcService),He(3,r.IExtHostWorkspace),He(4,l.IExtHostConfiguration),He(5,L.ILogService),He(6,p.IExtHostInitDataService),He(7,b.IExtensionStoragePaths),He(8,C.IExtHostTunnelService),He(9,f.IExtHostTerminalService),He(10,V.IExtHostLocalizationService),He(11,j.IExtHostManagedSockets),He(12,I.IExtHostLanguageModels)],fe);function Ce(re,F,Z,be){re.addActivationEvents(be.addActivationEvents);const Le=new s.ExtensionDescriptionRegistry(re,F.getAllExtensionDescriptions());Le.deltaExtensions(be.toAdd,be.toRemove);const Se=new i.ExtensionIdentifierSet(Z.getAllExtensionDescriptions().map(he=>he.identifier));for(const he of be.myToRemove)Se.delete(he);for(const he of be.myToAdd)Se.add(he);const ve=ne(Le,Se);return{globalRegistry:Le,myExtensions:ve}}function _e(re,F){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:F.activationEvent,reasonId:F.extensionId.value}}function oe(re){return re.getAllExtensionDescriptions().map(F=>F.identifier.value).join(",")}e.IExtHostExtensionService=(0,c.createDecorator)("IExtHostExtensionService");class pe{#e;#t;#i;constructor(F,Z,be,Le,Se){this.#e=F,this.#t=Z,this.#i=be.identifier,this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=O.normalize((0,N.originalFSPath)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=Le,this.isFromDifferentExtensionHost=Se}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.Extension=pe;function ne(re,F){return re.getAllExtensionDescriptions().filter(Z=>F.has(Z.identifier))}class Ie{constructor(F){this._searchTree=F}setSearchTree(F){this._searchTree=F}findSubstr(F){return this._searchTree.findSubstr(F)}forEach(F){return this._searchTree.forEach(F)}}e.ExtensionPaths=Ie;class xe{constructor(F){this._map=new i.ExtensionIdentifierMap,this.addActivationEvents(F)}readActivationEvents(F){return this._map.get(F.identifier)??[]}addActivationEvents(F){for(const Z of Object.keys(F))this._map.set(Z,F[Z])}}}),define(Pe[294],Te([1,0,89,2,4,37,25,20,16,27,3,38,13,15]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(a,d,t,E,c,p,b){this._apiFactory=a,this._extensionRegistry=d,this._instaService=t,this._extHostConfiguration=E,this._extHostExtensionService=c,this._initData=p,this._logService=b,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),D.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new s(this._apiFactory,d,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(o)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(n,d,this._initData.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const d of a.nodeModuleName)this._factories.set(d,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(d=>a.alternativeModuleName(d))}};e.RequireInterceptor=r,e.RequireInterceptor=r=Ke([He(2,L.IInstantiationService),He(3,N.IExtHostConfiguration),He(4,_.IExtHostExtensionService),He(5,y.IExtHostInitDataService),He(6,l.ILogService)],r);let o=class{static{g=this}static{this.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&g.aliased.size){const d=(0,w.escapeRegExpCharacters)(this.forceForwardSlashes(a.environment.appRoot.fsPath)),t="[a-z0-9_.-]",E=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${d}/${c}\\/)(${E})(.*)$`,"i")}}alternativeModuleName(a){if(!this.re)return;const d=this.re.exec(this.forceForwardSlashes(a));if(!d)return;const[,t,E,c]=d,p=g.aliased.get(E);if(p!==void 0)return console.warn(`${E} as been renamed to ${p}, please update your imports`),t+p+c}forceForwardSlashes(a){return a.replace(/\\/g,"/")}};o=g=Ke([He(0,y.IExtHostInitDataService)],o);class s{constructor(a,d,t,E,c){this._apiFactory=a,this._extensionPaths=d,this._extensionRegistry=t,this._configProvider=E,this._logService=c,this.nodeModuleName="vscode",this._extApiImpl=new m.ExtensionIdentifierMap}load(a,d){const t=this._extensionPaths.findSubstr(d);if(t){let E=this._extApiImpl.get(t.identifier);return E||(E=this._apiFactory(t,this._extensionRegistry,this._configProvider),this._extApiImpl.set(t.identifier,E)),E}if(!this._defaultApiImpl){let E="";this._extensionPaths.forEach((c,p)=>E+=`	${p} -> ${c.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d}. These are the extension path mappings: 
${E}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let n=class{constructor(a,d,t){this._extensionPaths=a,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=t.getProxy(T.MainContext.MainThreadTelemetry);const E=t.getProxy(T.MainContext.MainThreadWindow);this._impl=(c,p)=>{const b=O.URI.parse(c);return p?this.callOriginal(c,p):b.scheme==="http"||b.scheme==="https"?E.$openUri(b,c,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this._appUriScheme?E.$openUri(b,c,{}):this.callOriginal(c,p)}}load(a,d,t){const E=this._extensionPaths.findSubstr(d);return E&&(this._extensionId=E.identifier.value,this.sendShimmingTelemetry()),this._original=t(a),this._impl}callOriginal(a,d){return this.sendNoForwardTelemetry(),this._original(a,d)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};n=Ke([He(2,h.IExtHostRpcService)],n)}),define(Pe[120],Te([1,0,40,6,19,73,3,67,66,38,7,36,222,37]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,R.createDecorator)("IExtHostVariableResolverProvider");class g extends l.AbstractVariableResolverService{constructor(s,n,i,a,d,t,E){function c(){if(i){const p=i.activeEditor();if(p)return p.document.uri;const b=a.tabGroups.all.find(v=>v.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof L.TextDiffTabInput||b.input instanceof L.NotebookDiffEditorTabInput)return b.input.modified;if(b.input instanceof L.TextTabInput||b.input instanceof L.NotebookEditorTabInput||b.input instanceof L.CustomEditorTabInput)return b.input.uri}}}super({getFolderUri:p=>{const b=t.folders.filter(v=>v.name===p);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(p,b)=>d.getConfiguration(void 0,p).get(b),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const p=c();if(p)return T.normalize(p.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const p=c();if(p){const b=n.getWorkspaceFolder(p);if(b)return T.normalize(b.uri.fsPath)}}},getSelectedText:()=>{if(i){const p=i.activeEditor();if(p&&!p.selection.isEmpty)return p.document.getText(p.selection)}},getLineNumber:()=>{if(i){const p=i.activeEditor();if(p)return String(p.selection.end.line+1)}},getExtension:p=>s.getExtension(p)},void 0,E?Promise.resolve(E):void 0,Promise.resolve(N.env))}}let r=class extends O.Disposable{constructor(s,n,i,a,d){super(),this.extensionService=s,this.workspaceService=n,this.editorService=i,this.configurationService=a,this.editorTabs=d,this._resolver=new D.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),c={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async p=>{c.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new g(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,c,this.homeDir())})}getResolver(){return this._resolver.value}homeDir(){}};e.ExtHostVariableResolverProviderService=r,e.ExtHostVariableResolverProviderService=r=Ke([He(0,y.IExtHostExtensionService),He(1,_.IExtHostWorkspace),He(2,m.IExtHostDocumentsAndEditors),He(3,w.IExtHostConfiguration),He(4,h.IExtHostEditorTabs)],r)}),define(Pe[121],Te([1,0,11,5,2,20,3,4,66,38,16,7,36,214,216,37,120,6,41,31,8]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,R.createDecorator)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession?.api}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(u,C,f,I,S,P,k){this._workspaceService=C,this._extensionService=f,this._configurationService=I,this._editorTabs=S,this._variableResolver=P,this._commands=k,this._debugSessions=new Map,this._debugVisualizationTreeItemIdsCounter=0,this._debugVisualizationProviders=new Map,this._debugVisualizationTrees=new Map,this._debugVisualizationTreeItemIds=new WeakMap,this._debugVisualizationElements=new Map,this._visualizers=new Map,this._visualizerIdCounter=0,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new O.Emitter,this._onDidTerminateDebugSession=new O.Emitter,this._onDidChangeActiveDebugSession=new O.Emitter,this._onDidReceiveDebugSessionCustomEvent=new O.Emitter,this._debugServiceProxy=u.getProxy(m.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new O.Emitter,this._onDidChangeActiveStackItem=new O.Emitter,this._activeDebugConsole=new E(this._debugServiceProxy),this._breakpoints=new Map,this._extensionService.getExtensionRegistry().then(H=>{H.onDidChange($=>{this.registerAllDebugTypes(H)}),this.registerAllDebugTypes(H)})}async $getVisualizerTreeItem(u,C){const f=this.hydrateVisualizationContext(C);if(!f)return;const I=await this._debugVisualizationTrees.get(u)?.getTreeItem?.(f);return I?this.convertVisualizerTreeItem(u,I):void 0}registerDebugVisualizationTree(u,C,f){const I=N.ExtensionIdentifier.toKey(u.identifier),S=this.extensionVisKey(I,C);if(this._debugVisualizationProviders.has(S))throw new Error(`A debug visualization provider with id '${C}' is already registered`);return this._debugVisualizationTrees.set(S,f),this._debugServiceProxy.$registerDebugVisualizerTree(S,!!f.editItem),(0,s.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizerTree(S),this._debugVisualizationTrees.delete(C)})}async $getVisualizerTreeItemChildren(u,C){const f=this._debugVisualizationElements.get(C)?.item;return f?(await this._debugVisualizationTrees.get(u)?.getChildren?.(f))?.map(S=>this.convertVisualizerTreeItem(u,S))||[]:[]}async $editVisualizerTreeItem(u,C){const f=this._debugVisualizationElements.get(u);if(!f)return;const I=await this._debugVisualizationTrees.get(f.provider)?.editItem?.(f.item,C);return this.convertVisualizerTreeItem(f.provider,I||f.item)}$disposeVisualizedTree(u){const C=this._debugVisualizationElements.get(u);if(!C)return;const f=[C.children];for(const I of f)if(I)for(const S of I)f.push(this._debugVisualizationElements.get(S)?.children),this._debugVisualizationElements.delete(S)}convertVisualizerTreeItem(u,C){let f=this._debugVisualizationTreeItemIds.get(C);return f||(f=this._debugVisualizationTreeItemIdsCounter++,this._debugVisualizationTreeItemIds.set(C,f),this._debugVisualizationElements.set(f,{provider:u,item:C})),a.DebugTreeItem.from(C,f)}asDebugSourceUri(u,C){const f=u;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let I=`debug:${encodeURIComponent(f.path||"")}`,S="?";return C&&(I+=`${S}session=${encodeURIComponent(C.id)}`,S="&"),I+=`${S}ref=${f.sourceReference}`,T.URI.parse(I)}else{if(f.path)return T.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(u){const C=[];for(const f of u.getAllExtensionDescriptions())if(f.contributes){const I=f.contributes.debuggers;if(I&&I.length>0)for(const S of I)(0,g.isDebuggerMainContribution)(S)&&C.push(S.type)}this._debugServiceProxy.$registerDebugTypes(C)}get activeStackItem(){return this._activeStackItem}get onDidChangeActiveStackItem(){return this._onDidChangeActiveStackItem.event}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){const u=[];return this._breakpoints.forEach(C=>u.push(C)),u}async $resolveDebugVisualizer(u,C){const f=this._visualizers.get(u);if(!f)throw new Error(`No debug visualizer found with id '${u}'`);let{v:I,provider:S,extensionId:P}=f;if(I.visualization||(I=await S.resolveDebugVisualization?.(I,C)||I,f.v=I),!I.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${S}'`);return this.serializeVisualization(P,I.visualization)}async $executeDebugVisualizerCommand(u){const C=this._visualizers.get(u);if(!C)throw new Error(`No debug visualizer found with id '${u}'`);const f=C.v.visualization;f&&"command"in f&&this._commands.executeCommand(f.command,...f.arguments||[])}hydrateVisualizationContext(u){const C=this._debugSessions.get(u.sessionId);return C&&{session:C.api,variable:u.variable,containerId:u.containerId,frameId:u.frameId,threadId:u.threadId}}async $provideDebugVisualizers(u,C,f,I){const S=this.hydrateVisualizationContext(f),P=this.extensionVisKey(u,C),k=this._debugVisualizationProviders.get(P);if(!S||!k)return[];const H=await k.provideDebugVisualization(S,I);return H?H.map($=>{const V=++this._visualizerIdCounter;this._visualizers.set(V,{v:$,provider:k,extensionId:u});const A=$.iconPath?this.getIconPathOrClass($.iconPath):void 0;return{id:V,name:$.name,iconClass:A?.iconClass,iconPath:A?.iconPath,visualization:this.serializeVisualization(u,$.visualization)}}):[]}$disposeDebugVisualizers(u){for(const C of u)this._visualizers.delete(C)}registerDebugVisualizationProvider(u,C,f){if(!u.contributes?.debugVisualizers?.some(P=>P.id===C))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${C})`);const I=N.ExtensionIdentifier.toKey(u.identifier),S=this.extensionVisKey(I,C);if(this._debugVisualizationProviders.has(S))throw new Error(`A debug visualization provider with id '${C}' is already registered`);return this._debugVisualizationProviders.set(S,f),this._debugServiceProxy.$registerDebugVisualizer(I,C),(0,s.toDisposable)(()=>{this._debugServiceProxy.$unregisterDebugVisualizer(I,C),this._debugVisualizationProviders.delete(C)})}addBreakpoints(u){const C=u.filter(S=>{const P=S.id;return this._breakpoints.has(P)?!1:(this._breakpoints.set(P,S),!0)});this.fireBreakpointChanges(C,[],[]);const f=[],I=new Map;for(const S of C)if(S instanceof _.SourceBreakpoint){let P=I.get(S.location.uri.toString());P||(P={type:"sourceMulti",uri:S.location.uri,lines:[]},I.set(S.location.uri.toString(),P),f.push(P)),P.lines.push({id:S.id,enabled:S.enabled,condition:S.condition,hitCondition:S.hitCondition,logMessage:S.logMessage,line:S.location.range.start.line,character:S.location.range.start.character,mode:S.mode})}else S instanceof _.FunctionBreakpoint&&f.push({type:"function",id:S.id,enabled:S.enabled,hitCondition:S.hitCondition,logMessage:S.logMessage,condition:S.condition,functionName:S.functionName,mode:S.mode});return this._debugServiceProxy.$registerBreakpoints(f)}removeBreakpoints(u){const C=u.filter(P=>this._breakpoints.delete(P.id));this.fireBreakpointChanges([],C,[]);const f=C.filter(P=>P instanceof _.SourceBreakpoint).map(P=>P.id),I=C.filter(P=>P instanceof _.FunctionBreakpoint).map(P=>P.id),S=C.filter(P=>P instanceof _.DataBreakpoint).map(P=>P.id);return this._debugServiceProxy.$unregisterBreakpoints(f,I,S)}startDebugging(u,C,f){return this._debugServiceProxy.$startDebugging(u?u.uri:void 0,C,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===_.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,suppressSaveBeforeStart:f.suppressSaveBeforeStart,suppressDebugStatusbar:f.suppressDebugStatusbar??f.debugUI?.simple,suppressDebugToolbar:f.suppressDebugToolbar??f.debugUI?.simple,suppressDebugView:f.suppressDebugView??f.debugUI?.simple})}stopDebugging(u){return this._debugServiceProxy.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,C,f){if(!C)return new _.Disposable(()=>{});const I=this._configProviderHandleCounter++;return this._configProviders.push({type:u,handle:I,provider:C}),this._debugServiceProxy.$registerDebugConfigurationProvider(u,f,!!C.provideDebugConfigurations,!!C.resolveDebugConfiguration,!!C.resolveDebugConfigurationWithSubstitutedVariables,I),new _.Disposable(()=>{this._configProviders=this._configProviders.filter(S=>S.provider!==C),this._debugServiceProxy.$unregisterDebugConfigurationProvider(I)})}registerDebugAdapterDescriptorFactory(u,C,f){if(!f)return new _.Disposable(()=>{});if(!this.definesDebugType(u,C))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${C}' debugger.`);if(this.getAdapterDescriptorFactoryByType(C))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const I=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:C,handle:I,factory:f}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(C,I),new _.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(S=>S.factory!==f),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(I)})}registerDebugAdapterTrackerFactory(u,C){if(!C)return new _.Disposable(()=>{});const f=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:u,handle:f,factory:C}),new _.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(I=>I.factory!==C)})}async $runInTerminal(u,C){return Promise.resolve(void 0)}async $substituteVariables(u,C){let f;const I=await this.getFolder(u);return I&&(f={uri:I.uri,name:I.name,index:I.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(f,C)}createDebugAdapter(u,C){if(u.type==="implementation")return new p(u.implementation)}createSignService(){}async $startDASession(u,C){const f=this,I=await this.getSession(C);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(I.type),I).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${I.type}' (extension might have failed to activate)`);const P=this.convertToDto(S),k=this.createDebugAdapter(P,I);if(!k)throw new Error(`Couldn't create a debug adapter for type '${I.type}'.`);const H=k;return this._debugAdapters.set(u,H),this.getDebugAdapterTrackers(I).then($=>($&&this._debugAdaptersTrackers.set(u,$),H.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const A=V,U={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const j=await this._signService.sign(A.arguments.value);U.body={signature:j},H.sendResponse(U)}else throw new Error("no signer")}catch(j){U.success=!1,U.message=j.message,H.sendResponse(U)}}else $&&$.onDidSendMessage&&$.onDidSendMessage(V),V=(0,g.convertToVSCPaths)(V,!0),f._debugServiceProxy.$acceptDAMessage(u,V)}),H.onError(V=>{$&&$.onError&&$.onError(V),this._debugServiceProxy.$acceptDAError(u,V.name,V.message,V.stack)}),H.onExit(V=>{$&&$.onExit&&$.onExit(V??void 0,void 0),this._debugServiceProxy.$acceptDAExit(u,V??void 0,void 0)}),$&&$.onWillStartSession&&$.onWillStartSession(),H.startSession()))})}$sendDAMessage(u,C){C=(0,g.convertToDAPaths)(C,!1);const f=this._debugAdaptersTrackers.get(u);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(C),this._debugAdapters.get(u)?.sendMessage(C)}$stopDASession(u){const C=this._debugAdaptersTrackers.get(u);this._debugAdaptersTrackers.delete(u),C&&C.onWillStopSession&&C.onWillStopSession();const f=this._debugAdapters.get(u);return this._debugAdapters.delete(u),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const C=[],f=[],I=[];if(u.added)for(const S of u.added){const P=S.id;if(P&&!this._breakpoints.has(P)){let k;if(S.type==="function")k=new _.FunctionBreakpoint(S.functionName,S.enabled,S.condition,S.hitCondition,S.logMessage,S.mode);else if(S.type==="data")k=new _.DataBreakpoint(S.label,S.dataId,S.canPersist,S.enabled,S.hitCondition,S.condition,S.logMessage,S.mode);else{const H=T.URI.revive(S.uri);k=new _.SourceBreakpoint(new _.Location(H,new _.Position(S.line,S.character)),S.enabled,S.condition,S.hitCondition,S.logMessage,S.mode)}(0,_.setBreakpointId)(k,P),this._breakpoints.set(P,k),C.push(k)}}if(u.removed)for(const S of u.removed){const P=this._breakpoints.get(S);P&&(this._breakpoints.delete(S),f.push(P))}if(u.changed){for(const S of u.changed)if(S.id){const P=this._breakpoints.get(S.id);if(P){if(P instanceof _.FunctionBreakpoint&&S.type==="function"){const k=P;k.enabled=S.enabled,k.condition=S.condition,k.hitCondition=S.hitCondition,k.logMessage=S.logMessage,k.functionName=S.functionName}else if(P instanceof _.SourceBreakpoint&&S.type==="source"){const k=P;k.enabled=S.enabled,k.condition=S.condition,k.hitCondition=S.hitCondition,k.logMessage=S.logMessage,k.location=new _.Location(T.URI.revive(S.uri),new _.Position(S.line,S.character))}I.push(P)}}}this.fireBreakpointChanges(C,f,I)}async $acceptStackFrameFocus(u){let C;if(u){const f=await this.getSession(u.sessionId);u.kind==="thread"?C=new _.Thread(f.api,u.threadId):C=new _.StackFrame(f.api,u.threadId,u.frameId)}this._activeStackItem=C,this._onDidChangeActiveStackItem.fire(this._activeStackItem)}$provideDebugConfigurations(u,C,f){return(0,D.asPromise)(async()=>{const I=this.getConfigProviderByHandle(u);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const S=await this.getFolder(C);return I.provideDebugConfigurations(S,f)}).then(I=>{if(!I)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return I})}$resolveDebugConfiguration(u,C,f,I){return(0,D.asPromise)(async()=>{const S=this.getConfigProviderByHandle(u);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.getFolder(C);return S.resolveDebugConfiguration(P,f,I)})}$resolveDebugConfigurationWithSubstitutedVariables(u,C,f,I){return(0,D.asPromise)(async()=>{const S=this.getConfigProviderByHandle(u);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.getFolder(C);return S.resolveDebugConfigurationWithSubstitutedVariables(P,f,I)})}async $provideDebugAdapter(u,C){const f=this.getAdapterDescriptorFactoryByHandle(u);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const I=await this.getSession(C);return this.getAdapterDescriptor(f,I).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${I.type}'`);return this.convertToDto(S)})}async $acceptDebugSessionStarted(u){const C=await this.getSession(u);this._onDidStartDebugSession.fire(C.api)}async $acceptDebugSessionTerminated(u){const C=await this.getSession(u);C&&(this._onDidTerminateDebugSession.fire(C.api),this._debugSessions.delete(C.id))}async $acceptDebugSessionActiveChanged(u){this._activeDebugSession=u?await this.getSession(u):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession?.api)}async $acceptDebugSessionNameChanged(u,C){(await this.getSession(u))?._acceptNameChanged(C)}async $acceptDebugSessionCustomEvent(u,C){const I={session:(await this.getSession(u)).api,event:C.event,body:C.body};this._onDidReceiveDebugSessionCustomEvent.fire(I)}convertToDto(u){if(u instanceof _.DebugAdapterExecutable)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof _.DebugAdapterServer)return{type:"server",port:u.port,host:u.host};if(u instanceof _.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:u.path};if(u instanceof _.DebugAdapterInlineImplementation)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(u){const C=this._adapterFactories.filter(f=>f.type===u);if(C.length>0)return C[0].factory}getAdapterDescriptorFactoryByHandle(u){const C=this._adapterFactories.filter(f=>f.handle===u);if(C.length>0)return C[0].factory}getConfigProviderByHandle(u){const C=this._configProviders.filter(f=>f.handle===u);if(C.length>0)return C[0].provider}definesDebugType(u,C){if(u.contributes){const f=u.contributes.debuggers;if(f&&f.length>0){for(const I of f)if(I.label&&I.type&&I.type===C)return!0}}return!1}getDebugAdapterTrackers(u){const f=u.configuration.type,I=this._trackerFactories.filter(S=>S.type===f||S.type==="*").map(S=>(0,D.asPromise)(()=>S.factory.createDebugAdapterTracker(u.api)).then(P=>P,P=>null));return Promise.race([Promise.all(I).then(S=>{const P=S.filter(k=>!!k);if(P.length>0)return new c(P)}),new Promise(S=>setTimeout(()=>S(void 0),1e3))]).catch(S=>{})}async getAdapterDescriptor(u,C){const f=C.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new _.DebugAdapterServer(f));if(u){const S=await this._extensionService.getExtensionRegistry();return(0,D.asPromise)(()=>u.createDebugAdapterDescriptor(C.api,this.daExecutableFromPackage(C,S))).then(P=>{if(P)return P})}const I=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(C,I))}daExecutableFromPackage(u,C){}fireBreakpointChanges(u,C,f){(u.length>0||C.length>0||f.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:u,removed:C,changed:f}))}async getSession(u){if(u)if(typeof u=="string"){const C=this._debugSessions.get(u);if(C)return C}else{let C=this._debugSessions.get(u.id);if(!C){const f=await this.getFolder(u.folderUri),I=u.parent?this._debugSessions.get(u.parent):void 0;C=new t(this._debugServiceProxy,u.id,u.type,u.name,f,u.configuration,I?.api),this._debugSessions.set(C.id,C),this._debugServiceProxy.$sessionCached(C.id)}return C}throw new Error("cannot find session")}getFolder(u){if(u){const C=T.URI.revive(u);return this._workspaceService.resolveWorkspaceFolder(C)}return Promise.resolve(void 0)}extensionVisKey(u,C){return`${u}\0${C}`}serializeVisualization(u,C){if(C){if("title"in C&&"command"in C)return{type:0};if("treeId"in C)return{type:1,id:`${u}\0${C.treeId}`};throw new Error("Unsupported debug visualization type")}}getIconPathOrClass(u){const C=this.getIconUris(u);let f,I;return"id"in C?I=n.ThemeIcon.asClassName(C):f=C,{iconPath:f,iconClass:I}}getIconUris(u){if(u instanceof _.ThemeIcon)return{id:u.id};const C=typeof u=="object"&&"dark"in u?u.dark:u,f=typeof u=="object"&&"light"in u?u.light:u;return{dark:typeof C=="string"?T.URI.file(C):C,light:typeof f=="string"?T.URI.file(f):f}}};e.ExtHostDebugServiceBase=d,e.ExtHostDebugServiceBase=d=Ke([He(0,L.IExtHostRpcService),He(1,l.IExtHostWorkspace),He(2,y.IExtHostExtensionService),He(3,r.IExtHostConfiguration),He(4,h.IExtHostEditorTabs),He(5,o.IExtHostVariableResolverProvider),He(6,i.IExtHostCommands)],d);class t{constructor(u,C,f,I,S,P,k){this._debugServiceProxy=u,this._id=C,this._type=f,this._name=I,this._workspaceFolder=S,this._configuration=P,this._parentSession=k}get api(){const u=this;return this.apiSession??=Object.freeze({id:u._id,type:u._type,get name(){return u._name},set name(C){u._name=C,u._debugServiceProxy.$setDebugSessionName(u._id,C)},parentSession:u._parentSession,workspaceFolder:u._workspaceFolder,configuration:u._configuration,customRequest(C,f){return u._debugServiceProxy.$customDebugAdapterRequest(u._id,C,f)},getDebugProtocolBreakpoint(C){return u._debugServiceProxy.$getDebugProtocolBreakpoint(u._id,C.id)}})}get id(){return this._id}get type(){return this._type}_acceptNameChanged(u){this._name=u}get configuration(){return this._configuration}}e.ExtHostDebugSession=t;class E{constructor(u){this.value=Object.freeze({append(C){u.$appendDebugConsole(C)},appendLine(C){this.append(C+`
`)}})}}e.ExtHostDebugConsole=E;class c{constructor(u){this.trackers=u}onWillStartSession(){this.trackers.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.trackers.forEach(C=>C.onWillReceiveMessage?C.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.trackers.forEach(C=>C.onDidSendMessage?C.onDidSendMessage(u):void 0)}onWillStopSession(){this.trackers.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.trackers.forEach(C=>C.onError?C.onError(u):void 0)}onExit(u,C){this.trackers.forEach(f=>f.onExit?f.onExit(u,C):void 0)}}class p extends w.AbstractDebugAdapter{constructor(u){super(),this.implementation=u,u.onDidSendMessage(C=>{this.acceptMessage(C)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.implementation.handleMessage(u)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let b=class extends d{constructor(u,C,f,I,S,P,k){super(u,C,f,I,S,P,k)}};e.WorkerExtHostDebugService=b,e.WorkerExtHostDebugService=b=Ke([He(0,L.IExtHostRpcService),He(1,l.IExtHostWorkspace),He(2,y.IExtHostExtensionService),He(3,r.IExtHostConfiguration),He(4,h.IExtHostEditorTabs),He(5,o.IExtHostVariableResolverProvider),He(6,i.IExtHostCommands)],b)}),define(Pe[295],Te([1,0,14,89,2,4,243,13,55,71,27,191,16,60,38,62]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=e.ErrorHandler=void 0;class o{static async installEarlyHandler(i){Error.stackTraceLimit=100;const a=i.get(m.ILogService),t=i.get(l.IExtHostRpcService).getProxy(N.MainContext.MainThreadErrors);D.setUnexpectedErrorHandler(E=>{a.error(E);const c=D.transformErrorForSerialization(E);t.$onUnexpectedError(c)})}static async installFullHandler(i){const a=i.get(m.ILogService),d=i.get(l.IExtHostRpcService),t=i.get(g.IExtHostExtensionService),E=i.get(r.IExtHostTelemetry),c=d.getProxy(N.MainContext.MainThreadExtensionService),p=d.getProxy(N.MainContext.MainThreadErrors),b=await t.getExtensionPathIndex(),v=new WeakMap;function u(I,S){if(v.has(I))return v.get(I).stack;let P="",k,H;for(const V of S)P+=`
	at ${V.toString()}`,H=V.getFileName(),!k&&H&&(k=b.findSubstr(T.URI.file(H)));const $=`${I.name||"Error"}: ${I.message||""}${P}`;return v.set(I,{extensionIdentifier:k?.identifier,stack:$}),$}const C=Symbol("prepareStackTrace wrapped");let f=u;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return f},set(I){if(I===u||!I||I[C]){f=I||u;return}f=function(S,P){return u(S,P),I.call(Error,S,P)},Object.assign(f,{[C]:!0})}}),D.setUnexpectedErrorHandler(I=>{a.error(I);const S=D.transformErrorForSerialization(I),P=v.get(I);if(!P?.extensionIdentifier){p.$onUnexpectedError(S);return}c.$onExtensionRuntimeError(P.extensionIdentifier,S);const k=E.onExtensionError(P.extensionIdentifier,I);a.trace("forwarded error to extension?",k,P)})}}e.ErrorHandler=o;class s{constructor(i,a,d,t,E){this._hostUtils=d,this._rpcProtocol=new R.RPCProtocol(i,null,t),a=s._transform(a,this._rpcProtocol);const c=new y.ServiceCollection(...(0,h.getSingletonServiceDescriptors)());c.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...a,messagePorts:E}),c.set(l.IExtHostRpcService,new l.ExtHostRpcService(this._rpcProtocol)),c.set(w.IURITransformerService,new w.URITransformerService(t)),c.set(g.IHostUtils,d);const p=new _.InstantiationService(c,!0);p.invokeFunction(o.installEarlyHandler),this._logService=p.invokeFunction(b=>b.get(m.ILogService)),O.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",a),this._extensionService=p.invokeFunction(b=>b.get(g.IExtHostExtensionService)),this._extensionService.initialize(),p.invokeFunction(o.installFullHandler)}async asBrowserUri(i){const a=this._rpcProtocol.getProxy(N.MainContext.MainThreadExtensionService);return T.URI.revive(await a.$asBrowserUri(i))}terminate(i){this._extensionService.terminate(i)}static _transform(i,a){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=T.URI.revive(a.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=T.URI.revive(a.transformIncomingURIs(i.environment.appRoot));const d=i.environment.extensionDevelopmentLocationURI;return d&&(i.environment.extensionDevelopmentLocationURI=d.map(t=>T.URI.revive(a.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=T.URI.revive(a.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=T.URI.revive(a.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=T.URI.revive(a.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=T.URI.revive(a.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=T.URI.revive(a.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=T.URI.revive(a.transformIncomingURIs(i.logsLocation)),i.workspace=a.transformIncomingURIs(i.workspace),i}}e.ExtensionHostMain=s}),define(Pe[296],Te([1,0,18,11,24,42,12,19,23,2,45]),function(me,e,D,O,T,N,R,m,h,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.TextSearchResultsCollector=e.TextSearchManager=void 0,e.extensionResultIsMatch=r;class _{constructor(n,i,a){this.queryProviderPair=n,this.fileUtils=i,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}get query(){return this.queryProviderPair.query}search(n,i){const a=this.query.folderQueries||[],d=new T.CancellationTokenSource(i);return new Promise((t,E)=>{this.collector=new w(n);let c=!1;const p=(b,v)=>{if(!c&&!this.isLimitHit){const u=this.resultSize(b);r(b)&&typeof this.query.maxResults=="number"&&this.resultCount+u>this.query.maxResults&&(this.isLimitHit=!0,c=!0,d.cancel(),b=this.trimResultToSize(b,this.query.maxResults-this.resultCount));const C=this.resultSize(b);this.resultCount+=C,(C>0||!r(b))&&this.collector.add(b,v)}};Promise.all(a.map((b,v)=>this.searchInFolder(b,u=>p(u,v),d.token))).then(b=>{d.dispose(),this.collector.flush();const v=b.some(u=>!!u&&!!u.limitHit);t({limitHit:this.isLimitHit||v,messages:(0,D.flatten)(b.map(u=>u?.message?Array.isArray(u.message)?u.message:[u.message]:[])),stats:{type:this.processType}})},b=>{d.dispose();const v=(0,N.toErrorMessage)(b);E(new Error(v))})})}resultSize(n){return r(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}trimResultToSize(n,i){const a=Array.isArray(n.ranges)?n.ranges:[n.ranges],d=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:a.slice(0,i),preview:{matches:d.slice(0,i),text:n.preview.text},uri:n.uri}}async searchInFolder(n,i,a){const d=new L.QueryGlobTester(this.query,n),t=[],E={report:b=>{if(!this.validateProviderResult(b))return;const v=n.folder.scheme===R.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(h.dirname(b.uri))):void 0,u=h.relativePath(n.folder,b.uri);if(u){const C=d.includedInQuery(u,m.basename(u),v);(0,O.isThenable)(C)?t.push(C.then(f=>{f&&i(b)})):C&&i(b)}}},c=this.getSearchOptionsForFolder(n);let p;return this.queryProviderPair.query.type===3?p=await this.queryProviderPair.provider.provideAITextSearchResults(this.queryProviderPair.query.contentPattern,c,E,a):p=await this.queryProviderPair.provider.provideTextSearchResults(l(this.queryProviderPair.query.contentPattern),c,E,a),t.length&&await Promise.all(t),p}validateProviderResult(n){if(r(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(n){const i=(0,L.resolvePatternsForProvider)(this.query.includePattern,n.includePattern),a=(0,L.resolvePatternsForProvider)(this.query.excludePattern,n.excludePattern),d={folder:y.URI.from(n.folder),excludes:a,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.fileUtils.toCanonicalName(n.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return"usePCRE2"in this.query&&(d.usePCRE2=this.query.usePCRE2),d}}e.TextSearchManager=_;function l(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class w{constructor(n){this._onResult=n,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new o(512,i=>this.sendItems(i))}add(n,i){this._currentFileMatch&&(this._currentFolderIdx!==i||!h.isEqual(this._currentUri,n.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=i,this._currentFileMatch={resource:n.uri,results:[]}),this._currentFileMatch.results.push(g(n))}pushToCollector(){const n=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,n)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(n){this._onResult(n)}}e.TextSearchResultsCollector=w;function g(s){return r(s)?{preview:{matches:(0,D.mapArrayOrNot)(s.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:s.preview.text},ranges:(0,D.mapArrayOrNot)(s.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function r(s){return!!s.preview}class o{static{this.TIMEOUT=4e3}static{this.START_BATCH_AFTER_COUNT=50}constructor(n,i){this.maxBatchSize=n,this.cb=i,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(n,i){n&&this.addItemToBatch(n,i)}addItems(n,i){n&&this.addItemsToBatch(n,i)}addItemToBatch(n,i){this.batch.push(n),this.batchSize+=i,this.onUpdate()}addItemsToBatch(n,i){this.batch=this.batch.concat(n),this.batchSize+=i,this.onUpdate()}onUpdate(){this.totalNumberCompleted<o.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},o.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=o}),define(Pe[122],Te([1,0,6,4,3,291,16,60,13,2,296]),function(me,e,D,O,T,N,R,m,h,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSearch=e.IExtHostSearch=void 0,e.reviveQuery=l,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let _=class{constructor(r,o,s){this.extHostRpc=r,this._uriTransformer=o,this._logService=s,this._proxy=this.extHostRpc.getProxy(O.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._aiTextSearchProvider=new Map,this._aiTextSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new N.FileSearchManager}_transformScheme(r){return this._uriTransformer.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this._textSearchUsedSchemes.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this._textSearchUsedSchemes.add(r);const s=this._handlePool++;return this._textSearchProvider.set(s,o),this._proxy.$registerTextSearchProvider(s,this._transformScheme(r)),(0,D.toDisposable)(()=>{this._textSearchUsedSchemes.delete(r),this._textSearchProvider.delete(s),this._proxy.$unregisterProvider(s)})}registerAITextSearchProvider(r,o){if(this._aiTextSearchUsedSchemes.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this._aiTextSearchUsedSchemes.add(r);const s=this._handlePool++;return this._aiTextSearchProvider.set(s,o),this._proxy.$registerAITextSearchProvider(s,this._transformScheme(r)),(0,D.toDisposable)(()=>{this._aiTextSearchUsedSchemes.delete(r),this._aiTextSearchProvider.delete(s),this._proxy.$unregisterProvider(s)})}registerFileSearchProvider(r,o){if(this._fileSearchUsedSchemes.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this._fileSearchUsedSchemes.add(r);const s=this._handlePool++;return this._fileSearchProvider.set(s,o),this._proxy.$registerFileSearchProvider(s,this._transformScheme(r)),(0,D.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(r),this._fileSearchProvider.delete(s),this._proxy.$unregisterProvider(s)})}$provideFileSearchResults(r,o,s,n){const i=l(s),a=this._fileSearchProvider.get(r);if(a)return this._fileSearchManager.fileSearch(i,a,d=>{this._proxy.$handleFileMatch(r,o,d.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,s){return{messages:[]}}$clearCache(r){return this._fileSearchManager.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,s,n){const i=this._textSearchProvider.get(r);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const a=l(s);return this.createTextSearchManager(a,i).search(t=>this._proxy.$handleTextMatch(r,o,t),n)}$provideAITextSearchResults(r,o,s,n){const i=this._aiTextSearchProvider.get(r);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const a=l(s);return this.createAITextSearchManager(a,i).search(t=>this._proxy.$handleTextMatch(r,o,t),n)}$enableExtensionHostSearch(){}createTextSearchManager(r,o){return new L.TextSearchManager({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}createAITextSearchManager(r,o){return new L.TextSearchManager({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"aiTextSearchProvider")}};e.ExtHostSearch=_,e.ExtHostSearch=_=Ke([He(0,R.IExtHostRpcService),He(1,m.IURITransformerService),He(2,h.ILogService)],_);function l(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(w),extraFileResources:g.extraFileResources&&g.extraFileResources.map(r=>y.URI.revive(r))}}function w(g){return{...g,folder:y.URI.revive(g.folder)}}}),define(Pe[297],Te([1,0,24,14,5,6,12,32,2,151,147,135,94,20,43,13,58,59,204,4,246,275,78,84,252,231,253,88,254,232,220,31,255,37,256,121,110,257,234,247,258,259,67,66,248,38,261,64,262,44,27,276,277,249,235,263,264,79,80,237,290,266,208,267,278,268,116,238,269,270,271,16,272,122,81,273,239,274,82,85,119,62,51,279,280,250,281,282,86,8,7,240,60,241,63,283,284,109,36,215,77,25,118,114]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o,s,n,i,a,d,t,E,c,p,b,v,u,C,f,I,S,P,k,H,$,V,A,U,j,ie,fe,Ce,_e,oe,pe,ne,Ie,xe,re,F,Z,be,Le,Se,ve,he,K,Y,le,de,Ne,ue,De,Re,Ue,B,x,q,W,ee,se,Oe,ze,Ge,Je,et,ot,it,nt,at,ft,Be,st,Q,X,ge,Ve,Qe,Ae,dt,Pt,zt,Zt,Gt,ei,It,Xt,Vt,ci,Ye,ti,ii){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=Wt;function Wt(ut){const Et=ut.get(re.IExtHostInitDataService),ai=ut.get(xe.IExtHostFileSystemInfo),qt=ut.get(ne.IExtHostConsumerFileSystem),$t=ut.get(oe.IExtHostExtensionService),mt=ut.get(Xt.IExtHostWorkspace),Dt=ut.get(at.IExtHostTelemetry),li=ut.get(P.IExtHostConfiguration),Qt=ut.get(Pt.IURITransformerService),We=ut.get(ee.IExtHostRpcService),Ot=ut.get(ot.IExtHostStorage),Ht=ut.get(it.IExtensionStoragePaths),ni=ut.get(r.ILoggerService),pt=ut.get(r.ILogService),Lt=ut.get(Ve.IExtHostTunnelService),Tt=ut.get(t.IExtHostApiDeprecationService),Nt=ut.get(It.IExtHostWindow),ui=ut.get(ze.IExtHostSecretState),Mt=ut.get(Ce.IExtHostEditorTabs),Ft=ut.get(K.IExtHostManagedSockets),yt=ut.get(E.IExtHostAuthentication),Rt=ut.get(v.IExtHostLanguageModels);We.set(i.ExtHostContext.ExtHostFileSystemInfo,ai),We.set(i.ExtHostContext.ExtHostLogLevelServiceShape,ni),We.set(i.ExtHostContext.ExtHostWorkspace,mt),We.set(i.ExtHostContext.ExtHostConfiguration,li),We.set(i.ExtHostContext.ExtHostExtensionService,$t),We.set(i.ExtHostContext.ExtHostStorage,Ot),We.set(i.ExtHostContext.ExtHostTunnelService,Lt),We.set(i.ExtHostContext.ExtHostWindow,Nt),We.set(i.ExtHostContext.ExtHostSecretState,ui),We.set(i.ExtHostContext.ExtHostTelemetry,Dt),We.set(i.ExtHostContext.ExtHostEditorTabs,Mt),We.set(i.ExtHostContext.ExtHostManagedSockets,Ft),We.set(i.ExtHostContext.ExtHostAuthentication,yt),We.set(i.ExtHostContext.ExtHostChatProvider,Rt);const ri=We.set(i.ExtHostContext.ExtHostDecorations,ut.get($.IExtHostDecorations)),xt=We.set(i.ExtHostContext.ExtHostDocumentsAndEditors,ut.get(fe.IExtHostDocumentsAndEditors)),wt=We.set(i.ExtHostContext.ExtHostCommands,ut.get(I.IExtHostCommands)),kt=We.set(i.ExtHostContext.ExtHostTerminalService,ut.get(ft.IExtHostTerminalService)),fi=We.set(i.ExtHostContext.ExtHostTerminalShellIntegration,ut.get(ii.IExtHostTerminalShellIntegration)),Ct=We.set(i.ExtHostContext.ExtHostDebugService,ut.get(H.IExtHostDebugService)),si=We.set(i.ExtHostContext.ExtHostSearch,ut.get(Oe.IExtHostSearch)),Yt=We.set(i.ExtHostContext.ExtHostTask,ut.get(nt.IExtHostTask)),oi=We.set(i.ExtHostContext.ExtHostOutputService,ut.get(Ue.IExtHostOutputService)),mi=We.set(i.ExtHostContext.ExtHostLocalization,ut.get(he.IExtHostLocalizationService)),we=We.set(i.ExtHostContext.ExtHostUrls,new zt.ExtHostUrls(We)),ke=We.set(i.ExtHostContext.ExtHostDocuments,new ie.ExtHostDocuments(We,xt)),ce=We.set(i.ExtHostContext.ExtHostDocumentContentProviders,new U.ExtHostDocumentContentProvider(We,xt,pt)),G=We.set(i.ExtHostContext.ExtHostDocumentSaveParticipant,new j.ExtHostDocumentSaveParticipant(pt,ke,We.getProxy(i.MainContext.MainThreadBulkEdits))),Ee=We.set(i.ExtHostContext.ExtHostNotebook,new le.ExtHostNotebookController(We,wt,xt,ke,qt,si)),$e=We.set(i.ExtHostContext.ExtHostNotebookDocuments,new Ne.ExtHostNotebookDocuments(Ee)),Xe=We.set(i.ExtHostContext.ExtHostNotebookEditors,new ue.ExtHostNotebookEditors(pt,Ee)),qe=We.set(i.ExtHostContext.ExtHostNotebookKernels,new De.ExtHostNotebookKernels(We,Et,Ee,wt,pt)),ct=We.set(i.ExtHostContext.ExtHostNotebookRenderers,new Re.ExtHostNotebookRenderers(We,Ee)),_t=We.set(i.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new de.ExtHostNotebookDocumentSaveParticipant(pt,Ee,We.getProxy(i.MainContext.MainThreadBulkEdits))),St=We.set(i.ExtHostContext.ExtHostEditors,new st.ExtHostEditors(We,xt)),Jt=We.set(i.ExtHostContext.ExtHostTreeViews,new ge.ExtHostTreeViews(We.getProxy(i.MainContext.MainThreadTreeViews),wt,pt)),Ut=We.set(i.ExtHostContext.ExtHostEditorInsets,new f.ExtHostEditorInsets(We.getProxy(i.MainContext.MainThreadEditorInsets),St,Et.remote)),jt=We.set(i.ExtHostContext.ExtHostDiagnostics,new V.ExtHostDiagnostics(We,pt,ai,xt)),wi=We.set(i.ExtHostContext.ExtHostLanguages,new ve.ExtHostLanguages(We,ke,wt.converter,Qt)),ht=We.set(i.ExtHostContext.ExtHostLanguageFeatures,new Se.ExtHostLanguageFeatures(We,Qt,ke,wt,jt,pt,Tt,Dt)),Oi=We.set(i.ExtHostContext.ExtHostFileSystem,new pe.ExtHostFileSystem(We,ht)),gi=We.set(i.ExtHostContext.ExtHostFileSystemEventService,new Ie.ExtHostFileSystemEventService(We,pt,xt)),Ei=We.set(i.ExtHostContext.ExtHostQuickOpen,(0,W.createExtHostQuickOpen)(We,mt,wt)),Ii=We.set(i.ExtHostContext.ExtHostSCM,new se.ExtHostSCM(We,wt,ke,pt)),Gi=We.set(i.ExtHostContext.ExtHostQuickDiff,new q.ExtHostQuickDiff(We,Qt)),mn=We.set(i.ExtHostContext.ExtHostShare,new Ge.ExtHostShare(We,Qt)),Xi=We.set(i.ExtHostContext.ExtHostComments,(0,S.createExtHostComments)(We,wt,ke)),Di=We.set(i.ExtHostContext.ExtHostProgress,new x.ExtHostProgress(We.getProxy(i.MainContext.MainThreadProgress))),Ni=We.set(i.ExtHostContext.ExtHostLabelService,new Le.ExtHostLabelService(We)),Mi=We.set(i.ExtHostContext.ExtHostTheming,new Q.ExtHostTheming(We)),Qi=We.set(i.ExtHostContext.ExtHostTimeline,new X.ExtHostTimeline(We,wt)),ki=We.set(i.ExtHostContext.ExtHostWebviews,new Zt.ExtHostWebviews(We,Et.remote,mt,pt,Tt)),Pi=We.set(i.ExtHostContext.ExtHostWebviewPanels,new Gt.ExtHostWebviewPanels(We,ki,mt)),Yi=We.set(i.ExtHostContext.ExtHostCustomEditors,new k.ExtHostCustomEditors(We,ke,Ht,ki,Pi)),Ji=We.set(i.ExtHostContext.ExtHostWebviewViews,new ei.ExtHostWebviewViews(We,ki)),_i=We.set(i.ExtHostContext.ExtHostTesting,new Be.ExtHostTesting(We,pt,wt,xt)),gn=We.set(i.ExtHostContext.ExtHostUriOpeners,new dt.ExtHostUriOpeners(We)),Fi=We.set(i.ExtHostContext.ExtHostProfileContentHandlers,new B.ExtHostProfileContentHandlers(We));We.set(i.ExtHostContext.ExtHostInteractive,new Z.ExtHostInteractive(We,Ee,xt,wt,pt));const xi=We.set(i.ExtHostContext.ExtHostInlineChat,new F.ExtHostInteractiveEditor(We,wt,ke,pt)),Zi=We.set(i.ExtHostContext.ExtHostChatAgents2,new b.ExtHostChatAgents2(We,pt,wt)),pn=We.set(i.ExtHostContext.ExtHostChatVariables,new u.ExtHostChatVariables(We)),Ui=We.set(i.ExtHostContext.ExtHostChat,new p.ExtHostChat(We)),en=We.set(i.ExtHostContext.ExtHostAiRelatedInformation,new a.ExtHostRelatedInformation(We)),Bi=We.set(i.ExtHostContext.ExtHostAiEmbeddingVector,new _e.ExtHostAiEmbeddingVector(We)),zi=We.set(i.ExtHostContext.ExtHostIssueReporter,new be.ExtHostIssueReporter(We)),$i=We.set(i.ExtHostContext.ExtHostStatusBar,new et.ExtHostStatusBar(We,wt.converter)),tn=We.set(i.ExtHostContext.ExtHostSpeech,new Je.ExtHostSpeech(We)),vn=Object.values(i.ExtHostContext);We.assertRegistered(vn);const Hi=new c.ExtHostBulkEdits(We,xt),nn=new C.ExtHostClipboard(We),di=new Y.ExtHostMessageService(We,pt),Si=new A.ExtHostDialogs(We);return d.ExtHostApiCommands.register(wt),function(Fe,Bt,yi){function tt(J){return(ae,Me,rt)=>{const bt=J(At=>{try{ae.call(Me,At)}catch(Ri){O.onUnexpectedExternalError(new Error(`[ExtensionListenerError] Extension '${Fe.identifier.value}' FAILED to handle event: ${Ri.toString()}`,{cause:Ri})),Dt.onExtensionError(Fe.identifier,Ri)}});return rt?.push(bt),bt}}const vt=function(){let J=!Fe.isUnderDevelopment;function ae(){J||(pt.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function Me(rt){if(Array.isArray(rt))rt.forEach(Me);else if(typeof rt=="string")ae();else{const bt=rt;typeof bt.scheme>"u"&&ae(),typeof bt.exclusive=="boolean"&&(0,Ye.checkProposedApiEnabled)(Fe,"documentFiltersExclusive")}return rt}}(),rn={getSession(J,ae,Me){return typeof Me?.forceNewSession=="object"&&Me.forceNewSession.learnMore&&(0,Ye.checkProposedApiEnabled)(Fe,"authLearnMore"),yt.getSession(Fe,J,ae,Me)},getSessions(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"authGetSessions"),yt.getSessions(Fe,J,ae)},async hasSession(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"authSession"),!!await yt.getSession(Fe,J,ae,{silent:!0})},get onDidChangeSessions(){return tt(yt.onDidChangeSessions)},registerAuthenticationProvider(J,ae,Me,rt){return yt.registerAuthenticationProvider(J,ae,Me,rt)}},sn={registerCommand(J,ae,Me){return wt.registerCommand(!0,J,ae,Me,void 0,Fe)},registerTextEditorCommand(J,ae,Me){return wt.registerCommand(!0,J,(...rt)=>{const bt=St.getActiveTextEditor();if(!bt){pt.warn("Cannot execute "+J+" because there is no active text editor.");return}return bt.edit(At=>{ae.apply(Me,[bt,At,...rt])}).then(At=>{At||pt.warn("Edits from command "+J+" were not applied.")},At=>{pt.warn("An error occurred while running command "+J,At)})},void 0,void 0,Fe)},registerDiffInformationCommand:(J,ae,Me)=>((0,Ye.checkProposedApiEnabled)(Fe,"diffCommand"),wt.registerCommand(!0,J,async(...rt)=>{const bt=xt.activeEditor(!0);if(!bt){pt.warn("Cannot execute "+J+" because there is no active text editor.");return}const At=await St.getDiffInformation(bt.id);ae.apply(Me,[At,...rt])},void 0,void 0,Fe)),executeCommand(J,...ae){return wt.executeCommand(J,...ae)},getCommands(J=!1){return wt.getCommands(J)}},on={get machineId(){return Et.telemetryInfo.machineId},get sessionId(){return Et.telemetryInfo.sessionId},get language(){return Et.environment.appLanguage},get appName(){return Et.environment.appName},get appRoot(){return Et.environment.appRoot?.fsPath??""},get appHost(){return Et.environment.appHost},get uriScheme(){return Et.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return kt.getDefaultShell(!1)},get onDidChangeShell(){return tt(kt.onDidChangeShell)},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return tt(Dt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.checkProposedApiEnabled)(Fe,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.checkProposedApiEnabled)(Fe,"telemetry"),tt(Dt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,at.isNewAppInstall)(Et.telemetryInfo.firstSessionDate)},createTelemetryLogger(J,ae){return at.ExtHostTelemetryLogger.validateSender(J),Dt.instantiateLogger(Fe,J,ae)},openExternal(J,ae){return Nt.openUri(J,{allowTunneling:!!Et.remote.authority,allowContributedOpeners:ae?.allowContributedOpeners})},async asExternalUri(J){if(J.scheme===Et.environment.appUriScheme)return we.createAppUri(J);try{return await Nt.asExternalUri(J,{allowTunneling:!!Et.remote.authority})}catch(ae){if((0,R.matchesScheme)(J,R.Schemas.http)||(0,R.matchesScheme)(J,R.Schemas.https))return J;throw ae}},get remoteName(){return(0,o.getRemoteName)(Et.remote.authority)},get remoteAuthority(){return(0,Ye.checkProposedApiEnabled)(Fe,"resolvers"),Et.remote.authority},get uiKind(){return Et.uiKind},get logLevel(){return pt.getLevel()},get onDidChangeLogLevel(){return tt(pt.onDidChangeLogLevel)},registerIssueUriRequestHandler(J){return(0,Ye.checkProposedApiEnabled)(Fe,"handleIssueUri"),zi.registerIssueUriRequestHandler(Fe,J)},registerIssueDataProvider(J){return(0,Ye.checkProposedApiEnabled)(Fe,"handleIssueUri"),zi.registerIssueDataProvider(Fe,J)},get appQuality(){return(0,Ye.checkProposedApiEnabled)(Fe,"resolvers"),Et.quality},get appCommit(){return(0,Ye.checkProposedApiEnabled)(Fe,"resolvers"),Et.commit}};Et.environment.extensionTestsLocationURI||Object.freeze(on);const an={createTestController(J,ae,Me){return _i.createTestController(Fe,J,ae,Me)},createTestObserver(){return(0,Ye.checkProposedApiEnabled)(Fe,"testObserver"),_i.createTestObserver()},runTests(J){return(0,Ye.checkProposedApiEnabled)(Fe,"testObserver"),_i.runTests(J)},get onDidChangeTestResults(){return(0,Ye.checkProposedApiEnabled)(Fe,"testObserver"),tt(_i.onResultsChanged)},get testResults(){return(0,Ye.checkProposedApiEnabled)(Fe,"testObserver"),_i.results}},Ci=Et.remote.isRemote?Ae.ExtensionKind.Workspace:Ae.ExtensionKind.UI,En={getExtension(J,ae){(0,Ye.isProposedApiEnabled)(Fe,"extensionsAny")||(ae=!1);const Me=Bt.mine.getExtensionDescription(J);if(Me)return new oe.Extension($t,Fe.identifier,Me,Ci,!1);if(ae){const rt=Bt.all.getExtensionDescription(J);if(rt)return new oe.Extension($t,Fe.identifier,rt,Ci,!0)}},get all(){const J=[];for(const ae of Bt.mine.getAllExtensionDescriptions())J.push(new oe.Extension($t,Fe.identifier,ae,Ci,!1));return J},get allAcrossExtensionHosts(){(0,Ye.checkProposedApiEnabled)(Fe,"extensionsAny");const J=new w.ExtensionIdentifierSet(Bt.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),ae=[];for(const Me of Bt.all.getAllExtensionDescriptions()){const rt=!J.has(Me.identifier);ae.push(new oe.Extension($t,Fe.identifier,Me,Ci,rt))}return ae},get onDidChange(){return(0,Ye.isProposedApiEnabled)(Fe,"extensionsAny")?tt(T.Event.any(Bt.mine.onDidChange,Bt.all.onDidChange)):tt(Bt.mine.onDidChange)}},bn={createDiagnosticCollection(J){return jt.createDiagnosticCollection(Fe.identifier,J)},get onDidChangeDiagnostics(){return tt(jt.onDidChangeDiagnostics)},getDiagnostics:J=>jt.getDiagnostics(J),getLanguages(){return wi.getLanguages()},setTextDocumentLanguage(J,ae){return wi.changeLanguage(J.uri,ae)},match(J,ae){const Me=Qe.LanguageSelector.from(J);let rt;return(0,L.targetsNotebooks)(Me)&&(rt=Ee.notebookDocuments.find(bt=>bt.apiNotebook.getCells().find(At=>At.document===ae))?.apiNotebook),(0,L.score)(Me,ae.uri,ae.languageId,!0,rt?.uri,rt?.notebookType)},registerCodeActionsProvider(J,ae,Me){return ht.registerCodeActionProvider(Fe,vt(J),ae,Me)},registerDocumentPasteEditProvider(J,ae,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"documentPaste"),ht.registerDocumentPasteEditProvider(Fe,vt(J),ae,Me)},registerCodeLensProvider(J,ae){return ht.registerCodeLensProvider(Fe,vt(J),ae)},registerDefinitionProvider(J,ae){return ht.registerDefinitionProvider(Fe,vt(J),ae)},registerDeclarationProvider(J,ae){return ht.registerDeclarationProvider(Fe,vt(J),ae)},registerImplementationProvider(J,ae){return ht.registerImplementationProvider(Fe,vt(J),ae)},registerTypeDefinitionProvider(J,ae){return ht.registerTypeDefinitionProvider(Fe,vt(J),ae)},registerHoverProvider(J,ae){return ht.registerHoverProvider(Fe,vt(J),ae,Fe.identifier)},registerEvaluatableExpressionProvider(J,ae){return ht.registerEvaluatableExpressionProvider(Fe,vt(J),ae,Fe.identifier)},registerInlineValuesProvider(J,ae){return ht.registerInlineValuesProvider(Fe,vt(J),ae,Fe.identifier)},registerDocumentHighlightProvider(J,ae){return ht.registerDocumentHighlightProvider(Fe,vt(J),ae)},registerMultiDocumentHighlightProvider(J,ae){return ht.registerMultiDocumentHighlightProvider(Fe,vt(J),ae)},registerLinkedEditingRangeProvider(J,ae){return ht.registerLinkedEditingRangeProvider(Fe,vt(J),ae)},registerReferenceProvider(J,ae){return ht.registerReferenceProvider(Fe,vt(J),ae)},registerRenameProvider(J,ae){return ht.registerRenameProvider(Fe,vt(J),ae)},registerNewSymbolNamesProvider(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"newSymbolNamesProvider"),ht.registerNewSymbolNamesProvider(Fe,vt(J),ae)},registerDocumentSymbolProvider(J,ae,Me){return ht.registerDocumentSymbolProvider(Fe,vt(J),ae,Me)},registerWorkspaceSymbolProvider(J){return ht.registerWorkspaceSymbolProvider(Fe,J)},registerDocumentFormattingEditProvider(J,ae){return ht.registerDocumentFormattingEditProvider(Fe,vt(J),ae)},registerDocumentRangeFormattingEditProvider(J,ae){return ht.registerDocumentRangeFormattingEditProvider(Fe,vt(J),ae)},registerOnTypeFormattingEditProvider(J,ae,Me,...rt){return ht.registerOnTypeFormattingEditProvider(Fe,vt(J),ae,[Me].concat(rt))},registerDocumentSemanticTokensProvider(J,ae,Me){return ht.registerDocumentSemanticTokensProvider(Fe,vt(J),ae,Me)},registerDocumentRangeSemanticTokensProvider(J,ae,Me){return ht.registerDocumentRangeSemanticTokensProvider(Fe,vt(J),ae,Me)},registerSignatureHelpProvider(J,ae,Me,...rt){return typeof Me=="object"?ht.registerSignatureHelpProvider(Fe,vt(J),ae,Me):ht.registerSignatureHelpProvider(Fe,vt(J),ae,typeof Me>"u"?[]:[Me,...rt])},registerCompletionItemProvider(J,ae,...Me){return ht.registerCompletionItemProvider(Fe,vt(J),ae,Me)},registerInlineCompletionItemProvider(J,ae,Me){return ae.handleDidShowCompletionItem&&(0,Ye.checkProposedApiEnabled)(Fe,"inlineCompletionsAdditions"),ae.handleDidPartiallyAcceptCompletionItem&&(0,Ye.checkProposedApiEnabled)(Fe,"inlineCompletionsAdditions"),Me&&(0,Ye.checkProposedApiEnabled)(Fe,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Fe,vt(J),ae,Me)},registerInlineEditProvider(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"inlineEdit"),ht.registerInlineEditProvider(Fe,vt(J),ae)},registerDocumentLinkProvider(J,ae){return ht.registerDocumentLinkProvider(Fe,vt(J),ae)},registerColorProvider(J,ae){return ht.registerColorProvider(Fe,vt(J),ae)},registerFoldingRangeProvider(J,ae){return ht.registerFoldingRangeProvider(Fe,vt(J),ae)},registerSelectionRangeProvider(J,ae){return ht.registerSelectionRangeProvider(Fe,J,ae)},registerCallHierarchyProvider(J,ae){return ht.registerCallHierarchyProvider(Fe,J,ae)},registerTypeHierarchyProvider(J,ae){return ht.registerTypeHierarchyProvider(Fe,J,ae)},setLanguageConfiguration:(J,ae)=>ht.setLanguageConfiguration(Fe,J,ae),getTokenInformationAtPosition(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"tokenInformation"),wi.tokenAtPosition(J,ae)},registerInlayHintsProvider(J,ae){return ht.registerInlayHintsProvider(Fe,J,ae)},createLanguageStatusItem(J,ae){return wi.createLanguageStatusItem(Fe,J,ae)},registerDocumentDropEditProvider(J,ae,Me){return ht.registerDocumentOnDropEditProvider(Fe,J,ae,(0,Ye.isProposedApiEnabled)(Fe,"dropMetadata")?Me:void 0)}},cn={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return kt.activeTerminal},get terminals(){return kt.terminals},async showTextDocument(J,ae,Me){h.URI.isUri(J)&&J.scheme===R.Schemas.vscodeRemote&&!J.authority&&Tt.report("workspace.showTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await(h.URI.isUri(J)?Promise.resolve(Ti.openTextDocument(J)):Promise.resolve(J));return St.showTextDocument(rt,ae,Me)},createTextEditorDecorationType(J){return St.createTextEditorDecorationType(Fe,J)},onDidChangeActiveTextEditor(J,ae,Me){return tt(St.onDidChangeActiveTextEditor)(J,ae,Me)},onDidChangeVisibleTextEditors(J,ae,Me){return tt(St.onDidChangeVisibleTextEditors)(J,ae,Me)},onDidChangeTextEditorSelection(J,ae,Me){return tt(St.onDidChangeTextEditorSelection)(J,ae,Me)},onDidChangeTextEditorOptions(J,ae,Me){return tt(St.onDidChangeTextEditorOptions)(J,ae,Me)},onDidChangeTextEditorVisibleRanges(J,ae,Me){return tt(St.onDidChangeTextEditorVisibleRanges)(J,ae,Me)},onDidChangeTextEditorViewColumn(J,ae,Me){return tt(St.onDidChangeTextEditorViewColumn)(J,ae,Me)},onDidCloseTerminal(J,ae,Me){return tt(kt.onDidCloseTerminal)(J,ae,Me)},onDidOpenTerminal(J,ae,Me){return tt(kt.onDidOpenTerminal)(J,ae,Me)},onDidChangeActiveTerminal(J,ae,Me){return tt(kt.onDidChangeActiveTerminal)(J,ae,Me)},onDidChangeTerminalDimensions(J,ae,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"terminalDimensions"),tt(kt.onDidChangeTerminalDimensions)(J,ae,Me)},onDidChangeTerminalState(J,ae,Me){return tt(kt.onDidChangeTerminalState)(J,ae,Me)},onDidWriteTerminalData(J,ae,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"terminalDataWriteEvent"),tt(kt.onDidWriteTerminalData)(J,ae,Me)},onDidExecuteTerminalCommand(J,ae,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"terminalExecuteCommandEvent"),tt(kt.onDidExecuteTerminalCommand)(J,ae,Me)},onDidChangeTerminalShellIntegration(J,ae,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"terminalShellIntegration"),tt(fi.onDidChangeTerminalShellIntegration)(J,ae,Me)},onDidStartTerminalShellExecution(J,ae,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"terminalShellIntegration"),tt(fi.onDidStartTerminalShellExecution)(J,ae,Me)},onDidEndTerminalShellExecution(J,ae,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"terminalShellIntegration"),tt(fi.onDidEndTerminalShellExecution)(J,ae,Me)},get state(){return Nt.getState(Fe)},onDidChangeWindowState(J,ae,Me){return tt(Nt.onDidChangeWindowState)(J,ae,Me)},showInformationMessage(J,...ae){return di.showMessage(Fe,m.default.Info,J,ae[0],ae.slice(1))},showWarningMessage(J,...ae){return di.showMessage(Fe,m.default.Warning,J,ae[0],ae.slice(1))},showErrorMessage(J,...ae){return di.showMessage(Fe,m.default.Error,J,ae[0],ae.slice(1))},showQuickPick(J,ae,Me){return Ei.showQuickPick(Fe,J,ae,Me)},showWorkspaceFolderPick(J){return Ei.showWorkspaceFolderPick(J)},showInputBox(J,ae){return Ei.showInput(J,ae)},showOpenDialog(J){return Si.showOpenDialog(Fe,J)},showSaveDialog(J){return Si.showSaveDialog(J)},createStatusBarItem(J,ae,Me){let rt,bt,At;return typeof J=="string"?(rt=J,bt=ae,At=Me):(bt=J,At=ae),$i.createStatusBarEntry(Fe,rt,bt,At)},setStatusBarMessage(J,ae){return $i.setStatusBarMessage(J,ae)},withScmProgress(J){return Tt.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),Di.withProgress(Fe,{location:Ae.ProgressLocation.SourceControl},(ae,Me)=>J({report(rt){}}))},withProgress(J,ae){return Di.withProgress(Fe,J,ae)},createOutputChannel(J,ae){return oi.createOutputChannel(J,ae,Fe)},createWebviewPanel(J,ae,Me,rt){return Pi.createWebviewPanel(Fe,J,ae,Me,rt)},createWebviewTextEditorInset(J,ae,Me,rt){return(0,Ye.checkProposedApiEnabled)(Fe,"editorInsets"),Ut.createWebviewEditorInset(J,ae,Me,rt,Fe)},createTerminal(J,ae,Me){return typeof J=="object"?"pty"in J?kt.createExtensionTerminal(J):kt.createTerminalFromOptions(J):kt.createTerminal(J,ae,Me)},registerTerminalLinkProvider(J){return kt.registerLinkProvider(J)},registerTerminalProfileProvider(J,ae){return kt.registerProfileProvider(Fe,J,ae)},registerTerminalQuickFixProvider(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"terminalQuickFixProvider"),kt.registerTerminalQuickFixProvider(J,Fe.identifier.value,ae)},registerTreeDataProvider(J,ae){return Jt.registerTreeDataProvider(J,ae,Fe)},createTreeView(J,ae){return Jt.createTreeView(J,ae,Fe)},registerWebviewPanelSerializer:(J,ae)=>Pi.registerWebviewPanelSerializer(Fe,J,ae),registerCustomEditorProvider:(J,ae,Me={})=>Yi.registerCustomEditorProvider(Fe,J,ae,Me),registerFileDecorationProvider(J){return ri.registerFileDecorationProvider(J,Fe)},registerUriHandler(J){return we.registerUriHandler(Fe,J)},createQuickPick(){return Ei.createQuickPick(Fe)},createInputBox(){return Ei.createInputBox(Fe)},get activeColorTheme(){return Mi.activeColorTheme},onDidChangeActiveColorTheme(J,ae,Me){return tt(Mi.onDidChangeActiveColorTheme)(J,ae,Me)},registerWebviewViewProvider(J,ae,Me){return Ji.registerWebviewViewProvider(Fe,J,ae,Me?.webviewOptions)},get activeNotebookEditor(){return Ee.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,ae,Me){return tt(Ee.onDidChangeActiveNotebookEditor)(J,ae,Me)},get visibleNotebookEditors(){return Ee.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return tt(Ee.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(J,ae,Me){return tt(Xe.onDidChangeNotebookEditorSelection)(J,ae,Me)},onDidChangeNotebookEditorVisibleRanges(J,ae,Me){return tt(Xe.onDidChangeNotebookEditorVisibleRanges)(J,ae,Me)},showNotebookDocument(J,ae){return Ee.showNotebookDocument(J,ae)},registerExternalUriOpener(J,ae,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"externalUriOpener"),gn.registerExternalUriOpener(Fe.identifier,J,ae,Me)},registerProfileContentHandler(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"profileContentHandlers"),Fi.registerProfileContentHandler(Fe,J,ae)},registerQuickDiffProvider(J,ae,Me,rt){return(0,Ye.checkProposedApiEnabled)(Fe,"quickDiffProvider"),Gi.registerQuickDiffProvider(vt(J),ae,Me,rt)},get tabGroups(){return Mt.tabGroups},registerShareProvider(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"shareProvider"),mn.registerShareProvider(vt(J),ae)}},Ti={get rootPath(){return Tt.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(J){throw new O.ReadonlyError("rootPath")},getWorkspaceFolder(J){return mt.getWorkspaceFolder(J)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(J){throw new O.ReadonlyError("name")},get workspaceFile(){return mt.workspaceFile},set workspaceFile(J){throw new O.ReadonlyError("workspaceFile")},updateWorkspaceFolders:(J,ae,...Me)=>mt.updateWorkspaceFolders(Fe,J,ae||0,...Me),onDidChangeWorkspaceFolders:function(J,ae,Me){return tt(mt.onDidChangeWorkspace)(J,ae,Me)},asRelativePath:(J,ae)=>mt.getRelativePath(J,ae),findFiles:(J,ae,Me,rt)=>mt.findFiles(J,ae,Me,Fe.identifier,rt),findFiles2:(J,ae,Me)=>((0,Ye.checkProposedApiEnabled)(Fe,"findFiles2"),mt.findFiles2(J,ae,Fe.identifier,Me)),findTextInFiles:(J,ae,Me,rt)=>{(0,Ye.checkProposedApiEnabled)(Fe,"findTextInFiles");let bt,At;return typeof ae=="object"?(bt=ae,At=Me):(bt={},At=ae,rt=Me),mt.findTextInFiles(J,bt||{},At,Fe.identifier,rt)},save:J=>mt.save(J),saveAs:J=>mt.saveAs(J),saveAll:J=>mt.saveAll(J),applyEdit(J,ae){return Hi.applyWorkspaceEdit(J,Fe,ae)},createFileSystemWatcher:(J,ae,Me,rt)=>{let bt;return typeof ae=="boolean"?bt={ignoreCreateEvents:!!ae,ignoreChangeEvents:!!Me,ignoreDeleteEvents:!!rt,correlate:!1}:ae&&((0,Ye.checkProposedApiEnabled)(Fe,"createFileSystemWatcher"),bt={...ae,correlate:!0}),gi.createFileSystemWatcher(mt,Fe,J,bt)},get textDocuments(){return ke.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw new O.ReadonlyError("textDocuments")},openTextDocument(J){let ae;const Me=J;if(typeof J=="string")ae=Promise.resolve(h.URI.file(J));else if(h.URI.isUri(J))ae=Promise.resolve(J);else if(!Me||typeof Me=="object")ae=ke.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ae.then(rt=>(rt.scheme===R.Schemas.vscodeRemote&&!rt.authority&&Tt.report("workspace.openTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority."),ke.ensureDocumentData(rt).then(bt=>bt.document)))},onDidOpenTextDocument:(J,ae,Me)=>tt(ke.onDidAddDocument)(J,ae,Me),onDidCloseTextDocument:(J,ae,Me)=>tt(ke.onDidRemoveDocument)(J,ae,Me),onDidChangeTextDocument:(J,ae,Me)=>tt(ke.onDidChangeDocument)(J,ae,Me),onDidSaveTextDocument:(J,ae,Me)=>tt(ke.onDidSaveDocument)(J,ae,Me),onWillSaveTextDocument:(J,ae,Me)=>tt(G.getOnWillSaveTextDocumentEvent(Fe))(J,ae,Me),get notebookDocuments(){return Ee.notebookDocuments.map(J=>J.apiNotebook)},async openNotebookDocument(J,ae){let Me;if(h.URI.isUri(J))Me=J,await Ee.openNotebookDocument(J);else if(typeof J=="string")Me=h.URI.revive(await Ee.createNotebookDocument({viewType:J,content:ae}));else throw new Error("Invalid arguments");return Ee.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(J,ae,Me){return tt($e.onDidSaveNotebookDocument)(J,ae,Me)},onDidChangeNotebookDocument(J,ae,Me){return tt($e.onDidChangeNotebookDocument)(J,ae,Me)},onWillSaveNotebookDocument(J,ae,Me){return tt(_t.getOnWillSaveNotebookDocumentEvent(Fe))(J,ae,Me)},get onDidOpenNotebookDocument(){return tt(Ee.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return tt(Ee.onDidCloseNotebookDocument)},registerNotebookSerializer(J,ae,Me,rt){return Ee.registerNotebookSerializer(Fe,J,ae,Me,(0,Ye.isProposedApiEnabled)(Fe,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(J,ae,Me)=>tt(yi.onDidChangeConfiguration)(J,ae,Me),getConfiguration(J,ae){return ae=arguments.length===1?void 0:ae,yi.getConfiguration(J,ae,Fe)},registerTextDocumentContentProvider(J,ae){return ce.registerTextDocumentContentProvider(J,ae)},registerTaskProvider:(J,ae)=>(Tt.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),Yt.registerTaskProvider(Fe,J,ae)),registerFileSystemProvider(J,ae,Me){return(0,N.combinedDisposable)(Oi.registerFileSystemProvider(Fe,J,ae,Me),qt.addFileSystemProvider(J,ae,Me))},get fs(){return qt.value},registerFileSearchProvider:(J,ae)=>((0,Ye.checkProposedApiEnabled)(Fe,"fileSearchProvider"),si.registerFileSearchProvider(J,ae)),registerTextSearchProvider:(J,ae)=>((0,Ye.checkProposedApiEnabled)(Fe,"textSearchProvider"),si.registerTextSearchProvider(J,ae)),registerAITextSearchProvider:(J,ae)=>((0,Ye.checkProposedApiEnabled)(Fe,"aiTextSearchProvider"),(0,Ye.checkProposedApiEnabled)(Fe,"textSearchProvider"),si.registerAITextSearchProvider(J,ae)),registerRemoteAuthorityResolver:(J,ae)=>((0,Ye.checkProposedApiEnabled)(Fe,"resolvers"),$t.registerRemoteAuthorityResolver(J,ae)),registerResourceLabelFormatter:J=>((0,Ye.checkProposedApiEnabled)(Fe,"resolvers"),Ni.$registerResourceLabelFormatter(J)),getRemoteExecServer:J=>((0,Ye.checkProposedApiEnabled)(Fe,"resolvers"),$t.getRemoteExecServer(J)),onDidCreateFiles:(J,ae,Me)=>tt(gi.onDidCreateFile)(J,ae,Me),onDidDeleteFiles:(J,ae,Me)=>tt(gi.onDidDeleteFile)(J,ae,Me),onDidRenameFiles:(J,ae,Me)=>tt(gi.onDidRenameFile)(J,ae,Me),onWillCreateFiles:(J,ae,Me)=>tt(gi.getOnWillCreateFileEvent(Fe))(J,ae,Me),onWillDeleteFiles:(J,ae,Me)=>tt(gi.getOnWillDeleteFileEvent(Fe))(J,ae,Me),onWillRenameFiles:(J,ae,Me)=>tt(gi.getOnWillRenameFileEvent(Fe))(J,ae,Me),openTunnel:J=>((0,Ye.checkProposedApiEnabled)(Fe,"tunnels"),Lt.openTunnel(Fe,J).then(ae=>{if(!ae)throw new Error("cannot open tunnel");return ae})),get tunnels(){return(0,Ye.checkProposedApiEnabled)(Fe,"tunnels"),Lt.getTunnels()},onDidChangeTunnels:(J,ae,Me)=>((0,Ye.checkProposedApiEnabled)(Fe,"tunnels"),tt(Lt.onDidChangeTunnels)(J,ae,Me)),registerPortAttributesProvider:(J,ae)=>((0,Ye.checkProposedApiEnabled)(Fe,"portsAttributes"),Lt.registerPortsAttributesProvider(J,ae)),registerTunnelProvider:(J,ae)=>((0,Ye.checkProposedApiEnabled)(Fe,"tunnelFactory"),Lt.registerTunnelProvider(J,ae)),registerTimelineProvider:(J,ae)=>((0,Ye.checkProposedApiEnabled)(Fe,"timeline"),Qi.registerTimelineProvider(J,ae,Fe.identifier,wt.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:J=>((0,Ye.checkProposedApiEnabled)(Fe,"workspaceTrust"),mt.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,ae,Me)=>tt(mt.onDidGrantWorkspaceTrust)(J,ae,Me),registerEditSessionIdentityProvider:(J,ae)=>((0,Ye.checkProposedApiEnabled)(Fe,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(J,ae)),onWillCreateEditSessionIdentity:(J,ae,Me)=>((0,Ye.checkProposedApiEnabled)(Fe,"editSessionIdentityProvider"),tt(mt.getOnWillCreateEditSessionIdentityEvent(Fe))(J,ae,Me)),registerCanonicalUriProvider:(J,ae)=>((0,Ye.checkProposedApiEnabled)(Fe,"canonicalUriProvider"),mt.registerCanonicalUriProvider(J,ae)),getCanonicalUri:(J,ae,Me)=>((0,Ye.checkProposedApiEnabled)(Fe,"canonicalUriProvider"),mt.provideCanonicalUri(J,ae,Me))},ln={get inputBox(){return Tt.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),Ii.getLastInputBox(Fe)},createSourceControl(J,ae,Me){return Ii.createSourceControl(Fe,J,ae,Me)}},un={createCommentController(J,ae){return Xi.createCommentController(Fe,J,ae)}},dn={get activeDebugSession(){return Ct.activeDebugSession},get activeDebugConsole(){return Ct.activeDebugConsole},get breakpoints(){return Ct.breakpoints},get activeStackItem(){if((0,Ye.isProposedApiEnabled)(Fe,"debugFocus"))return Ct.activeStackItem},registerDebugVisualizationProvider(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"debugVisualization"),Ct.registerDebugVisualizationProvider(Fe,J,ae)},registerDebugVisualizationTreeProvider(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"debugVisualization"),Ct.registerDebugVisualizationTree(Fe,J,ae)},onDidStartDebugSession(J,ae,Me){return tt(Ct.onDidStartDebugSession)(J,ae,Me)},onDidTerminateDebugSession(J,ae,Me){return tt(Ct.onDidTerminateDebugSession)(J,ae,Me)},onDidChangeActiveDebugSession(J,ae,Me){return tt(Ct.onDidChangeActiveDebugSession)(J,ae,Me)},onDidReceiveDebugSessionCustomEvent(J,ae,Me){return tt(Ct.onDidReceiveDebugSessionCustomEvent)(J,ae,Me)},onDidChangeBreakpoints(J,ae,Me){return tt(Ct.onDidChangeBreakpoints)(J,ae,Me)},onDidChangeActiveStackItem(J,ae,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"debugFocus"),tt(Ct.onDidChangeActiveStackItem)(J,ae,Me)},registerDebugConfigurationProvider(J,ae,Me){return Ct.registerDebugConfigurationProvider(J,ae,Me||Vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,ae){return Ct.registerDebugAdapterDescriptorFactory(Fe,J,ae)},registerDebugAdapterTrackerFactory(J,ae){return Ct.registerDebugAdapterTrackerFactory(J,ae)},startDebugging(J,ae,Me){return!Me||typeof Me=="object"&&"configuration"in Me?Ct.startDebugging(J,ae,{parentSession:Me}):Ct.startDebugging(J,ae,Me||{})},stopDebugging(J){return Ct.stopDebugging(J)},addBreakpoints(J){return Ct.addBreakpoints(J)},removeBreakpoints(J){return Ct.removeBreakpoints(J)},asDebugSourceUri(J,ae){return Ct.asDebugSourceUri(J,ae)}},wn={registerTaskProvider:(J,ae)=>Yt.registerTaskProvider(Fe,J,ae),fetchTasks:J=>Yt.fetchTasks(J),executeTask:J=>Yt.executeTask(Fe,J),get taskExecutions(){return Yt.taskExecutions},onDidStartTask:(J,ae,Me)=>tt(Yt.onDidStartTask)(J,ae,Me),onDidEndTask:(J,ae,Me)=>tt(Yt.onDidEndTask)(J,ae,Me),onDidStartTaskProcess:(J,ae,Me)=>tt(Yt.onDidStartTaskProcess)(J,ae,Me),onDidEndTaskProcess:(J,ae,Me)=>tt(Yt.onDidEndTaskProcess)(J,ae,Me)},_n={createNotebookController(J,ae,Me,rt,bt){return qe.createNotebookController(Fe,J,ae,Me,rt,(0,Ye.isProposedApiEnabled)(Fe,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(J,ae)=>Ee.registerNotebookCellStatusBarItemProvider(Fe,J,ae),createRendererMessaging(J){return ct.createRendererMessaging(Fe,J)},createNotebookControllerDetectionTask(J){return(0,Ye.checkProposedApiEnabled)(Fe,"notebookKernelSource"),qe.createNotebookControllerDetectionTask(Fe,J)},registerKernelSourceActionProvider(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"notebookKernelSource"),qe.registerKernelSourceActionProvider(Fe,J,ae)},onDidChangeNotebookCellExecutionState(J,ae,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"notebookCellExecutionState"),tt(qe.onDidChangeNotebookCellExecutionState)(J,ae,Me)}},hn={t(...J){if(typeof J[0]=="string"){const ae=J.shift(),Me=!J||typeof J[0]!="object"?J:J[0];return mi.getMessage(Fe.identifier.value,{message:ae,args:Me})}return mi.getMessage(Fe.identifier.value,J[0])},get bundle(){return mi.getBundle(Fe.identifier.value)},get uri(){return mi.getBundleUri(Fe.identifier.value)}},fn={_version:1,registerInteractiveEditorSessionProvider(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"interactive"),xi.registerProvider(Fe,J,ae)},registerInteractiveSessionProvider(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"interactive"),Ui.registerChatProvider(Fe,J,ae)},transferChatSession(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"interactive"),Ui.transferChatSession(J,ae)}},Vi={getRelatedInformation(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"aiRelatedInformation"),en.getRelatedInformation(Fe,J,ae)},registerRelatedInformationProvider(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"aiRelatedInformation"),en.registerRelatedInformationProvider(Fe,J,ae)},registerEmbeddingVectorProvider(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"aiRelatedInformation"),Bi.registerEmbeddingVectorProvider(Fe,J,ae)}},Wi={registerChatResponseProvider(J,ae,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"chatProvider"),Rt.registerLanguageModel(Fe,J,ae,Me)},registerChatVariableResolver(J,ae,Me){return(0,Ye.checkProposedApiEnabled)(Fe,"chatVariableResolver"),pn.registerVariableResolver(Fe,J,ae,Me)},registerMappedEditsProvider(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"mappedEditsProvider"),ht.registerMappedEditsProvider(Fe,J,ae)},createChatParticipant(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"chatParticipant"),Zi.createChatAgent(Fe,J,ae)},createDynamicChatParticipant(J,ae,Me,rt){return(0,Ye.checkProposedApiEnabled)(Fe,"chatParticipantAdditions"),Zi.createDynamicChatAgent(Fe,J,ae,Me,rt)}},qi={get languageModels(){return(0,Ye.checkProposedApiEnabled)(Fe,"languageModels"),Rt.getLanguageModelIds()},onDidChangeLanguageModels:(J,ae,Me)=>((0,Ye.checkProposedApiEnabled)(Fe,"languageModels"),Rt.onDidChangeProviders(J,ae,Me)),sendChatRequest(J,ae,Me,rt){return(0,Ye.checkProposedApiEnabled)(Fe,"languageModels"),Rt.sendChatRequest(Fe,J,ae,Me,rt)}},Ai={registerSpeechProvider(J,ae){return(0,Ye.checkProposedApiEnabled)(Fe,"speech"),tn.registerProvider(Fe.identifier,J,ae)}};return{version:Et.version,ai:Vi,authentication:rn,commands:sn,comments:un,chat:Wi,debug:dn,env:on,extensions:En,interactive:fn,l10n:hn,languages:bn,lm:qi,notebooks:_n,scm:ln,speech:Ai,tasks:wn,tests:an,window:cn,workspace:Ti,Breakpoint:Ae.Breakpoint,TerminalOutputAnchor:Ae.TerminalOutputAnchor,ChatResultFeedbackKind:Ae.ChatResultFeedbackKind,ChatVariableLevel:Ae.ChatVariableLevel,ChatCompletionItem:Ae.ChatCompletionItem,CallHierarchyIncomingCall:Ae.CallHierarchyIncomingCall,CallHierarchyItem:Ae.CallHierarchyItem,CallHierarchyOutgoingCall:Ae.CallHierarchyOutgoingCall,CancellationError:O.CancellationError,CancellationTokenSource:D.CancellationTokenSource,CandidatePortSource:i.CandidatePortSource,CodeAction:Ae.CodeAction,CodeActionKind:Ae.CodeActionKind,CodeActionTriggerKind:Ae.CodeActionTriggerKind,CodeLens:Ae.CodeLens,Color:Ae.Color,ColorInformation:Ae.ColorInformation,ColorPresentation:Ae.ColorPresentation,ColorThemeKind:Ae.ColorThemeKind,CommentMode:Ae.CommentMode,CommentState:Ae.CommentState,CommentThreadCollapsibleState:Ae.CommentThreadCollapsibleState,CommentThreadState:Ae.CommentThreadState,CommentThreadApplicability:Ae.CommentThreadApplicability,CompletionItem:Ae.CompletionItem,CompletionItemKind:Ae.CompletionItemKind,CompletionItemTag:Ae.CompletionItemTag,CompletionList:Ae.CompletionList,CompletionTriggerKind:Ae.CompletionTriggerKind,ConfigurationTarget:Ae.ConfigurationTarget,CustomExecution:Ae.CustomExecution,DebugAdapterExecutable:Ae.DebugAdapterExecutable,DebugAdapterInlineImplementation:Ae.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:Ae.DebugAdapterNamedPipeServer,DebugAdapterServer:Ae.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ae.DebugConsoleMode,DebugVisualization:Ae.DebugVisualization,DecorationRangeBehavior:Ae.DecorationRangeBehavior,Diagnostic:Ae.Diagnostic,DiagnosticRelatedInformation:Ae.DiagnosticRelatedInformation,DiagnosticSeverity:Ae.DiagnosticSeverity,DiagnosticTag:Ae.DiagnosticTag,Disposable:Ae.Disposable,DocumentHighlight:Ae.DocumentHighlight,DocumentHighlightKind:Ae.DocumentHighlightKind,MultiDocumentHighlight:Ae.MultiDocumentHighlight,DocumentLink:Ae.DocumentLink,DocumentSymbol:Ae.DocumentSymbol,EndOfLine:Ae.EndOfLine,EnvironmentVariableMutatorType:Ae.EnvironmentVariableMutatorType,EvaluatableExpression:Ae.EvaluatableExpression,InlineValueText:Ae.InlineValueText,InlineValueVariableLookup:Ae.InlineValueVariableLookup,InlineValueEvaluatableExpression:Ae.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:Ae.InlineCompletionTriggerKind,EventEmitter:T.Emitter,ExtensionKind:Ae.ExtensionKind,ExtensionMode:Ae.ExtensionMode,ExternalUriOpenerPriority:Ae.ExternalUriOpenerPriority,FileChangeType:Ae.FileChangeType,FileDecoration:Ae.FileDecoration,FileDecoration2:Ae.FileDecoration,FileSystemError:Ae.FileSystemError,FileType:g.FileType,FilePermission:g.FilePermission,FoldingRange:Ae.FoldingRange,FoldingRangeKind:Ae.FoldingRangeKind,FunctionBreakpoint:Ae.FunctionBreakpoint,InlineCompletionItem:Ae.InlineSuggestion,InlineCompletionList:Ae.InlineSuggestionList,Hover:Ae.Hover,IndentAction:_.IndentAction,Location:Ae.Location,MarkdownString:Ae.MarkdownString,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Ae.ParameterInformation,PortAutoForwardAction:Ae.PortAutoForwardAction,Position:Ae.Position,ProcessExecution:Ae.ProcessExecution,ProgressLocation:Ae.ProgressLocation,QuickInputButtons:Ae.QuickInputButtons,Range:Ae.Range,RelativePattern:Ae.RelativePattern,Selection:Ae.Selection,SelectionRange:Ae.SelectionRange,SemanticTokens:Ae.SemanticTokens,SemanticTokensBuilder:Ae.SemanticTokensBuilder,SemanticTokensEdit:Ae.SemanticTokensEdit,SemanticTokensEdits:Ae.SemanticTokensEdits,SemanticTokensLegend:Ae.SemanticTokensLegend,ShellExecution:Ae.ShellExecution,ShellQuoting:Ae.ShellQuoting,SignatureHelp:Ae.SignatureHelp,SignatureHelpTriggerKind:Ae.SignatureHelpTriggerKind,SignatureInformation:Ae.SignatureInformation,SnippetString:Ae.SnippetString,SourceBreakpoint:Ae.SourceBreakpoint,StandardTokenType:Ae.StandardTokenType,StatusBarAlignment:Ae.StatusBarAlignment,SymbolInformation:Ae.SymbolInformation,SymbolKind:Ae.SymbolKind,SymbolTag:Ae.SymbolTag,Task:Ae.Task,TaskGroup:Ae.TaskGroup,TaskPanelKind:Ae.TaskPanelKind,TaskRevealKind:Ae.TaskRevealKind,TaskScope:Ae.TaskScope,TerminalLink:Ae.TerminalLink,TerminalQuickFixTerminalCommand:Ae.TerminalQuickFixCommand,TerminalQuickFixOpener:Ae.TerminalQuickFixOpener,TerminalLocation:Ae.TerminalLocation,TerminalProfile:Ae.TerminalProfile,TerminalExitReason:Ae.TerminalExitReason,TextDocumentSaveReason:Ae.TextDocumentSaveReason,TextEdit:Ae.TextEdit,SnippetTextEdit:Ae.SnippetTextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ae.TextEditorLineNumbersStyle,TextEditorRevealType:Ae.TextEditorRevealType,TextEditorSelectionChangeKind:Ae.TextEditorSelectionChangeKind,SyntaxTokenType:Ae.SyntaxTokenType,TextDocumentChangeReason:Ae.TextDocumentChangeReason,ThemeColor:Ae.ThemeColor,ThemeIcon:Ae.ThemeIcon,TreeItem:Ae.TreeItem,TreeItemCheckboxState:Ae.TreeItemCheckboxState,TreeItemCollapsibleState:Ae.TreeItemCollapsibleState,TypeHierarchyItem:Ae.TypeHierarchyItem,UIKind:ci.UIKind,Uri:h.URI,ViewColumn:Ae.ViewColumn,WorkspaceEdit:Ae.WorkspaceEdit,DocumentPasteTriggerKind:Ae.DocumentPasteTriggerKind,DocumentDropEdit:Ae.DocumentDropEdit,DocumentPasteEditKind:Ae.DocumentPasteEditKind,DocumentPasteEdit:Ae.DocumentPasteEdit,InlayHint:Ae.InlayHint,InlayHintLabelPart:Ae.InlayHintLabelPart,InlayHintKind:Ae.InlayHintKind,RemoteAuthorityResolverError:Ae.RemoteAuthorityResolverError,ResolvedAuthority:Ae.ResolvedAuthority,ManagedResolvedAuthority:Ae.ManagedResolvedAuthority,SourceControlInputBoxValidationType:Ae.SourceControlInputBoxValidationType,ExtensionRuntime:Ae.ExtensionRuntime,TimelineItem:Ae.TimelineItem,NotebookRange:Ae.NotebookRange,NotebookCellKind:Ae.NotebookCellKind,NotebookCellExecutionState:Ae.NotebookCellExecutionState,NotebookCellData:Ae.NotebookCellData,NotebookData:Ae.NotebookData,NotebookRendererScript:Ae.NotebookRendererScript,NotebookCellStatusBarAlignment:Ae.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ae.NotebookEditorRevealType,NotebookCellOutput:Ae.NotebookCellOutput,NotebookCellOutputItem:Ae.NotebookCellOutputItem,NotebookCellStatusBarItem:Ae.NotebookCellStatusBarItem,NotebookControllerAffinity:Ae.NotebookControllerAffinity,NotebookControllerAffinity2:Ae.NotebookControllerAffinity2,NotebookEdit:Ae.NotebookEdit,NotebookKernelSourceAction:Ae.NotebookKernelSourceAction,NotebookVariablesRequestKind:Ae.NotebookVariablesRequestKind,PortAttributes:Ae.PortAttributes,LinkedEditingRanges:Ae.LinkedEditingRanges,TestResultState:Ae.TestResultState,TestRunRequest:Ae.TestRunRequest,TestMessage:Ae.TestMessage,TestTag:Ae.TestTag,TestRunProfileKind:Ae.TestRunProfileKind,TextSearchCompleteMessageType:ti.TextSearchCompleteMessageType,DataTransfer:Ae.DataTransfer,DataTransferItem:Ae.DataTransferItem,TestCoverageCount:Ae.TestCoverageCount,FileCoverage:Ae.FileCoverage,StatementCoverage:Ae.StatementCoverage,BranchCoverage:Ae.BranchCoverage,DeclarationCoverage:Ae.DeclarationCoverage,FunctionCoverage:Ae.DeclarationCoverage,WorkspaceTrustState:Ae.WorkspaceTrustState,LanguageStatusSeverity:Ae.LanguageStatusSeverity,QuickPickItemKind:Ae.QuickPickItemKind,InputBoxValidationSeverity:Ae.InputBoxValidationSeverity,TabInputText:Ae.TextTabInput,TabInputTextDiff:Ae.TextDiffTabInput,TabInputTextMerge:Ae.TextMergeTabInput,TabInputCustom:Ae.CustomEditorTabInput,TabInputNotebook:Ae.NotebookEditorTabInput,TabInputNotebookDiff:Ae.NotebookDiffEditorTabInput,TabInputWebview:Ae.WebviewEditorTabInput,TabInputTerminal:Ae.TerminalEditorTabInput,TabInputInteractiveWindow:Ae.InteractiveWindowInput,TabInputChat:Ae.ChatEditorTabInput,TabInputTextMultiDiff:Ae.TextMultiDiffTabInput,TelemetryTrustedValue:s.TelemetryTrustedValue,LogLevel:r.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ae.InteractiveSessionVoteDirection,ChatCopyKind:Ae.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Ae.InteractiveEditorResponseFeedbackKind,StackFrame:Ae.StackFrame,Thread:Ae.Thread,RelatedInformationType:Ae.RelatedInformationType,SpeechToTextStatus:Ae.SpeechToTextStatus,PartialAcceptTriggerKind:Ae.PartialAcceptTriggerKind,KeywordRecognitionStatus:Ae.KeywordRecognitionStatus,ChatResponseMarkdownPart:Ae.ChatResponseMarkdownPart,ChatResponseFileTreePart:Ae.ChatResponseFileTreePart,ChatResponseAnchorPart:Ae.ChatResponseAnchorPart,ChatResponseProgressPart:Ae.ChatResponseProgressPart,ChatResponseReferencePart:Ae.ChatResponseReferencePart,ChatResponseCommandButtonPart:Ae.ChatResponseCommandButtonPart,ChatRequestTurn:Ae.ChatRequestTurn,ChatResponseTurn:Ae.ChatResponseTurn,ChatLocation:Ae.ChatLocation,LanguageModelChatSystemMessage:Ae.LanguageModelChatSystemMessage,LanguageModelChatUserMessage:Ae.LanguageModelChatUserMessage,LanguageModelChatAssistantMessage:Ae.LanguageModelChatAssistantMessage,LanguageModelSystemMessage:Ae.LanguageModelChatSystemMessage,LanguageModelUserMessage:Ae.LanguageModelChatUserMessage,LanguageModelAssistantMessage:Ae.LanguageModelChatAssistantMessage,LanguageModelError:Ae.LanguageModelError,NewSymbolName:Ae.NewSymbolName,NewSymbolNameTag:Ae.NewSymbolNameTag,InlineEdit:Ae.InlineEdit,InlineEditTriggerKind:Ae.InlineEditTriggerKind}}}}),define(Pe[298],Te([1,0,55,116,36,110,37,31,67,51,119,121,122,82,86,78,109,64,44,81,62,66,236,13,120,79,80,84,88,114]),function(me,e,D,O,T,N,R,m,h,y,L,_,l,w,g,r,o,s,n,i,a,d,t,E,c,p,b,v,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.registerSingleton)(p.IExtHostLocalizationService,p.ExtHostLocalizationService,1),(0,D.registerSingleton)(E.ILoggerService,t.ExtHostLoggerService,1),(0,D.registerSingleton)(r.IExtHostApiDeprecationService,r.ExtHostApiDeprecationService,1),(0,D.registerSingleton)(m.IExtHostCommands,m.ExtHostCommands,0),(0,D.registerSingleton)(v.IExtHostAuthentication,v.ExtHostAuthentication,0),(0,D.registerSingleton)(u.IExtHostLanguageModels,u.ExtHostLanguageModels,0),(0,D.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration,0),(0,D.registerSingleton)(s.IExtHostConsumerFileSystem,s.ExtHostConsumerFileSystem,0),(0,D.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService,0),(0,D.registerSingleton)(N.IExtHostDecorations,N.ExtHostDecorations,0),(0,D.registerSingleton)(h.IExtHostDocumentsAndEditors,h.ExtHostDocumentsAndEditors,0),(0,D.registerSingleton)(b.IExtHostManagedSockets,b.ExtHostManagedSockets,0),(0,D.registerSingleton)(n.IExtHostFileSystemInfo,n.ExtHostFileSystemInfo,0),(0,D.registerSingleton)(O.IExtHostOutputService,O.ExtHostOutputService,1),(0,D.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch,0),(0,D.registerSingleton)(w.IExtHostStorage,w.ExtHostStorage,0),(0,D.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,D.registerSingleton)(y.IExtHostTerminalService,y.WorkerExtHostTerminalService,0),(0,D.registerSingleton)(C.IExtHostTerminalShellIntegration,C.ExtHostTerminalShellIntegration,0),(0,D.registerSingleton)(g.IExtHostTunnelService,g.ExtHostTunnelService,0),(0,D.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,0),(0,D.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace,0),(0,D.registerSingleton)(i.IExtHostSecretState,i.ExtHostSecretState,0),(0,D.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry,0),(0,D.registerSingleton)(d.IExtHostEditorTabs,d.ExtHostEditorTabs,0),(0,D.registerSingleton)(c.IExtHostVariableResolverProvider,c.ExtHostVariableResolverProviderService,0)}),define(Pe[299],Te([1,0,297,38,2,294,7,11,242]),function(me,e,D,O,T,N,R,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class y extends N.RequireInterceptor{_installInterceptor(){}getModule(w,g){for(const r of this._alternatives){const o=r(w);if(o){w=o;break}}if(this._factories.has(w))return this._factories.get(w).load(w,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class L extends O.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(h.ExtHostConsoleForwarder);const w=this._instaService.invokeFunction(D.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(y,w,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(w){return w.browser}async _loadCommonJSModule(w,g,r){g=g.with({path:_(g.path,".js")});const o=w?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const s=T.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(g)),n=await fetch(s.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),n.status!==200)throw new Error(n.statusText);const i=await n.text(),a=`${g.toString(!0)}#vscode-extension`,d=`${i}
//# sourceURL=${a}`;let t;try{t=new Function("module","exports","require",d)}catch(b){throw console.error(o?`Loading code for extension ${o} failed: ${b.message}`:`Loading code failed: ${b.message}`),console.error(`${g.toString(!0)}${typeof b.line=="number"?` line ${b.line}`:""}${typeof b.column=="number"?` column ${b.column}`:""}`),console.error(b),b}w&&await this._extHostLocalizationService.initializeLocalizedMessages(w);const E={},c={exports:E},p=b=>{const v=this._fakeModules.getModule(b,g);if(v===void 0)throw new Error(`Cannot load module '${b}'`);return v};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(c,E,p),c.exports!==E?c.exports:E}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(w){}async _waitForDebuggerAttachment(w=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+w;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,m.timeout)(10)}}e.ExtHostExtensionService=L;function _(l,w){return l.endsWith(w)?l:l+w}}),define(Pe[300],Te([1,0,70,55,13,38,206,85,299]),function(me,e,D,O,T,N,R,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,O.registerSingleton)(T.ILogService,new D.SyncDescriptor(R.ExtHostLogService,[!0],!0)),(0,O.registerSingleton)(N.IExtHostExtensionService,h.ExtHostExtensionService,0),(0,O.registerSingleton)(m.IExtensionStoragePaths,m.ExtensionStoragePaths,0)}),define(Pe[306],Te([1,0,22,5,77,295,244,19,89,12,2,298,300]),function(me,e,D,O,T,N,R,m,h,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=d;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function w(t){return/^(file|vscode-remote):/i.test(t)}const g=fetch.bind(self);function r(t){self.fetch=async function(E,c){return E instanceof Request||w(String(E))&&(E=(await t(L.URI.parse(String(E)))).toString(!0)),g(E,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open(E,c,p,b,v){(async()=>(w(c.toString())&&(c=(await t(L.URI.parse(c.toString()))).toString(!0)),super.open(E,c,p??!0,b,v)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(E,c){if(/^file:/i.test(E.toString()))E=y.FileAccess.uriToBrowserUri(L.URI.parse(E.toString())).toString(!0);else if(/^vscode-remote:/i.test(E.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const b=`(${function(f){function I(k){return typeof k=="string"||k instanceof URL?String(k).replace(/^file:\/\//i,"vscode-file://vscode-app"):k}const S=fetch.bind(self);self.fetch=function(k,H){return k instanceof Request?S(k,H):S(I(k),H)},self.XMLHttpRequest=class extends XMLHttpRequest{open(k,H,$,V,A){return super.open(k,I(H),$??!0,V,A)}};const P=importScripts.bind(self);self.importScripts=(...k)=>{P(...k.map(I))},P(f)}.toString()}('${E}'))`;c=c||{},c.name=`${name} -> ${c.name||m.basename(E.toString())}`;const v=new Blob([b],{type:"application/javascript"}),u=URL.createObjectURL(v);return new t(u,c)}}else self.Worker=class extends R.NestedWorker{constructor(t,E){super(l,t,{name:m.basename(t.toString()),...E})}};const o=new class{constructor(){this.pid=void 0}exit(t){_()}};class s{constructor(){const E=new MessageChannel,c=new O.Emitter;let p=!1;l(E.port2,[E.port2]),E.port1.onmessage=b=>{const{data:v}=b;if(!(v instanceof ArrayBuffer)){console.warn("UNKNOWN data received",v);return}const u=D.VSBuffer.wrap(new Uint8Array(v,0,v.byteLength));if((0,T.isMessageOfType)(u,2)){p=!0,i("received terminate message from renderer");return}c.fire(u)},this.protocol={onMessage:c.event,send:b=>{if(!p){const v=b.buffer.buffer.slice(b.buffer.byteOffset,b.buffer.byteOffset+b.buffer.byteLength);E.port1.postMessage(v,[v])}}}}}function n(t){return new Promise(E=>{const c=t.onMessage(p=>{c.dispose();const b=JSON.parse(p.toString());t.send((0,T.createMessageOfType)(0)),E({protocol:t,initData:b})});t.send((0,T.createMessageOfType)(1))})}let i=t=>_();function a(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function d(){h.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(E){a(E)&&n(t.protocol).then(c=>{h.mark("code/extHost/didWaitForInitData");const p=new N.ExtensionHostMain(c.protocol,c.initData,o,null,E.data);r(b=>p.asBrowserUri(b)),i=b=>p.terminate(b)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0d01a72525276e5e3771fe5851b9c83de0de1e2b/core/vs/workbench/api/worker/extensionHostWorker.js.map
